//*****************************************************************************
//*
//*
//*		AZ_Lib.h
//*
//*
//*****************************************************************************
//	Die Bibliothek aller AZ Funktionen
//	Ist AZ_LIB_CODE		definiert so ist die Bibliothek auch
//						debug-bar
//	Mit AZ_LIB_NODUMMYS	knnen die Dummys fr strlen,memcpy...
//						entfernt werden.
//	Mit AZ_LIB_ADDAFX	kann der Bibliothek Afx-Funktionen
//						zugefgt werden
//	Mit AZ_LIB_PRINT	kann beim Kompilieren eine Information
//						ber die benutze Bibliothek augegeben
//						werden
//	Unter dem Menpunkt
//				Extras/Optionen/Verzeichnisse/Include-Dateien
//				solter der Pfad dieser Header-Datei eingetragen sein
//	Unter dem Menpunkt
//				Extras/Optionen/Verzeichnisse/Bibliothek-Dateien
//	 			solter der Pfad des AL_Lib-Projektes eingetragen sein

#ifndef		__AZ_LIB_H__
#define 	__AZ_LIB_H__

#if _MSC_VER >= 1000
#pragma once
#endif



#if	!defined(_MFC_VER) && defined(AZ_LIB_ADDAFX)
#define	_MFC_VER	0
#define	_MFC_VER_CLEAR
#endif



#if defined(UNICODE) || defined(_UNICODE)


//*****************************************************************************
//*
//*		Allgemein Unicode Single Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifndef	_MT

	#ifdef	_DLL
	#error	AZ-Lib falsche Konfiguration  (_DLL ist nicht erlaubt)
	#endif

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DU.lib     UNICODE,DEBUG,CODE,single Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DCU.lib    UNICODE,DEBUG,no CODE,single Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_RU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_RU.lib     UNICODE,RELEASE,no CODE,single Thread,no MFC" )
	#endif
	#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Muli Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifndef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_MDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_MDU.lib    UNICODE,DEBUG,CODE,multi Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_MDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_MDCU.lib   UNICODE,DEBUG,no CODE,multi Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_MRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_MRU.lib    UNICODE,RELEASE,no CODE,multi Thread,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Muli Thread ohne Afx mit Dll
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifdef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DMDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DDCU.lib   UNICODE,DEBUG,CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DMDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DMDCU.lib  UNICODE,DEBUG,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_DMRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DMRU.lib   UNICODE,RELEASE,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Multi Thread mit Afx in statischer Bibeliothek
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifndef _AFXDLL

#ifdef	_DLL
#ifndef	_MT
	#error	AZ-Lib untersttzt nicht  _DLL ohne _MT , Multithread einschalten
#endif
#endif

#ifdef	_DLL
#ifdef	_MT

	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SDRU.lib   UNICODE,RELEASE,no CODE,multi Thread DLL,static MFC" )
	#endif

	#error Building MFC application with /MD[d] (CRT dll version) requires MFC shared dll version. Please #define _AFXDLL or do not use /MD[d]

#endif
#endif


#ifndef	_DLL
#ifdef	_MT

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SMDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SMDU.lib   UNICODE,DEBUG,CODE,multi Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SMDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SMDCU.lib  UNICODE,DEBUG,no CODE,multi Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_SMRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SMRU.lib   UNICODE,RELEASE,no CODE,multi Thread,static MFC" )
	#endif
	#endif

#endif
#endif


#ifndef	_DLL
#ifndef	_MT
	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SDU.lib    UNICODE,DEBUG,CODE,single Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SDCU.lib   UNICODE,DEBUG,no CODE,single Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_SRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SRU.lib    UNICODE,RELEASE,no CODE,single Thread,static MFC" )
	#endif
	#endif
#endif
#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Multi Thread mit Afx in DLL
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifdef  _AFXDLL

#if	(defined(_DLL)) && (defined(_MT))

	#if (defined(_DEBUG) && defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DDU.lib    UNICODE,DEBUG,CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DDCU.lib   UNICODE,DEBUG,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_DRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DRU.lib    UNICODE,RELEASE,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif
#else
	#error	AZ-Lib falsche Konfiguration  (_DLL ohne _MT ist nicht erlaubt)
#endif


#endif
#endif


#else	// UNICODE

//*****************************************************************************
//*
//*		Allgemein Single Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifndef	_MT

	#ifdef	_DLL
	#error	AZ-Lib falsche Konfiguration  (_DLL ist nicht erlaubt)
	#endif

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_D.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_D.lib     DEBUG,CODE,single Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DC.lib    DEBUG,no CODE,single Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_R.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_R.lib     RELEASE,no CODE,single Thread,no MFC" )
	#endif
	#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Muli Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifndef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_MD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_MD.lib    DEBUG,CODE,multi Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_MDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_MDC.lib   DEBUG,no CODE,multi Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_MR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_MR.lib    RELEASE,no CODE,multi Thread,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Muli Thread ohne Afx mit Dll
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifdef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DMD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DDC.lib   DEBUG,CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DMDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DMDC.lib  DEBUG,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_DMR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DMR.lib   RELEASE,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Multi Thread mit Afx in statischer Bibeliothek
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifndef _AFXDLL

#ifdef	_DLL
#ifndef	_MT
	#error	AZ-Lib untersttzt nicht  _DLL ohne _MT , Multithread einschalten
#endif
#endif

#ifdef	_DLL
#ifdef	_MT

	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SDR.lib   RELEASE,no CODE,multi Thread DLL,static MFC" )
	#endif

	#error Building MFC application with /MD[d] (CRT dll version) requires MFC shared dll version. Please #define _AFXDLL or do not use /MD[d]

#endif
#endif


#ifndef	_DLL
#ifdef	_MT

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SMD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SMD.lib   DEBUG,CODE,multi Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SMDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SMDC.lib  DEBUG,no CODE,multi Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_SMR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SMR.lib   RELEASE,no CODE,multi Thread,static MFC" )
	#endif
	#endif

#endif
#endif


#ifndef	_DLL
#ifndef	_MT
	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SD.lib    DEBUG,CODE,single Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_SDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SDC.lib   DEBUG,no CODE,single Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_SR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_SR.lib    RELEASE,no CODE,single Thread,static MFC" )
	#endif
	#endif
#endif
#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Multi Thread mit Afx in DLL
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifdef  _AFXDLL

#if	(defined(_DLL)) && (defined(_MT))

	#if (defined(_DEBUG) && defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DD.lib    DEBUG,CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Lib_DDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DDC.lib   DEBUG,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Lib_DR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Lib_DR.lib    RELEASE,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif
#else
	#error	AZ-Lib falsche Konfiguration  (_DLL ohne _MT ist nicht erlaubt)
#endif


#endif
#endif



#endif	// UNICODE


//******************************************************************************
//*
//*		printf,sprintf,fprintf auf ProcPrintf.cpp umleiten
//*
//******************************************************************************

#ifdef	AZ_NO_PRINTF
#ifndef	PP_NO_COMMON
#define	PP_NO_COMMON
#endif
#endif

//*****************************************************************************
//*
//*		Include Dateien
//*
//*****************************************************************************

#ifndef	 _MFC_VER

#include <windows.h>

#endif

#include "RegText.h"
#include "RegKeys.h"
#include "TxtKeys.h"
#include "MapFile.h"
#include "ShortCuts.h"
#include "StartProg.h"
#include "RegConfig.h"
#include "DataField.h"
#include "AZ_Macros.h"
#include "TextBuffer.h"
#include "FileBuffer.h"
#include "FileFinder.h"
#include "ProcPrintf.h"
#include "StringChain.h"
#include "MemFunctions.h"
#include "BitFunctions.h"
#include "WinExtension.h"
#include "FileFunctions.h"
#include "RandFunctions.h"
#include "StringFunctions.h"


#ifndef	AZ_LIB_NODUMMYS
#ifdef _DEBUG
#include "Dummys.h"
#else
#if defined(_MSC_VER) && (_MSC_VER>1000)
#pragma warning( disable :4164)
#pragma intrinsic( strcmp)
#pragma intrinsic( strcpy)
#pragma intrinsic( strlen)
#pragma intrinsic(_strset)
#pragma intrinsic( memset)
#pragma intrinsic( memcmp)
#pragma intrinsic( memcpy)
#pragma intrinsic( labs	 )
#pragma intrinsic(_inp	 )
#pragma intrinsic(_inpw	 )
#pragma intrinsic(_rotl	 )
#pragma intrinsic(_rotr	 )
#pragma intrinsic(_lrotl )
#endif
#endif
#endif



#ifdef	_MFC_VER_CLEAR
#undef	_MFC_VER_CLEAR
#undef	_MFC_VER
#endif

#if    _MFC_VER >= 0x0700
#ifndef Enable3dControls
#define	Enable3dControls()
#endif
#ifndef Enable3dControlsStatic
#define	Enable3dControlsStatic()
#endif
#endif

#endif
