//*****************************************************************************
//*
//*
//*		AZ_Macros
//*
//*
//*****************************************************************************
//
//	RANGE(a,b,c)							// Beschrnkt a auf b bis c
//	MIN(a,b)								// Ergibt den kleineren Wert
//	MAX(a,b)								// Ergibt den greren  Wert
//
//	DELETE_MEM(mem)							// Gibt Speicher frei uns setzt Zeiger auf 0
//	NEW_MEM   (mem,ges)						// Reserviert neuen Speicher
//	CLEAR_MEM (mem)							// Setzt Bytes des Speichers auf 0
//
//	MEM_GROW  (mem,anz,ges,add)				// Speicherbereich von ges auf ges+add vergrern
//	MEM_CUT   (mem,anz,ges,pos,sub)			// sub Teile bei pos aus mem entfernen
//	MEM_INSERT(mem,anz,ges,pos,add)			// add Teile bei pos in  mem einfgen
//	MEM_COPY  (mem,mem1,anz,ges,pos,add)	// add Teile bei pos in  mem einfgen
  										
#ifndef		__AZ_MACROS_H__
#define 	__AZ_MACROS_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	<memory.h>

#define 	MEM_ADD		256				

#define 	RANGE(a,b,c) {if((a)>(c))(a)=(c));if((a)<(b))(a)=(b));}
#define 	MIN(a,b)	 (((a)<(b))? (a):(b))
#define 	MAX(a,b)	 (((a)>(b))? (a):(b))

#define 	DELETE_MEM(mem)			{if(mem){delete mem;mem=0;}}
#define 	NEW_MEM(mem,ges)													\
			{																	\
			if(mem)delete mem;													\
			*((int*)&mem)=(int)(new char[ges*sizeof(mem[0])]);					\
			}
#define 	CLEAR_MEM(mem)			memset(mem,0,sizeof(mem))


#define 	MEM_GROW(mem,anz,ges,add)											\
			{																	\
			ges+=add;															\
			if(!mem)															\
				*((int*)&mem)=(int)(new char[ges*sizeof(mem[0])]);				\
			else{																\
				char *neu_mem_xx;												\
				neu_mem_xx=new char[(ges+add)*sizeof(mem[0])];					\
				memcpy(neu_mem_xx,mem,    anz*sizeof(mem[0]));					\
				delete   mem;													\
				*((int*)&mem)=(int)neu_mem_xx;									\
				}																\
			}																	
#define 	MEM_CUT(mem,anz,ges,pos,sub)										\
			{																	\
			if(sub>0&&mem)														\
			if(pos<anz )														\
			{																	\
			int sub_mem_xx;														\
			sub_mem_xx=(pos+sub>len)? anz-pos:sub;								\
			memmove(mem+ pos			,										\
					mem+(pos+sub_mem_xx),										\
					(anz-pos-sub_mem_xx)*sizeof(mem[0]));						\
					 anz-=   sub_mem_xx;										\
			}}																	
#define 	MEM_INSERT(mem,anz,ges,pos,add)										\
			{																	\
			if(add>0)															\
			{																	\
			if((ges<anz+add)||!mem)MEM_GROW(mem,anz,ges,MEM_ADD)				\
			if (pos<anz)														\
			{																	\
			memmove(mem+(pos+add),												\
					mem+ pos     ,												\
					(anz-pos    )*sizeof(mem[0]));								\
					 anz+=add;													\
			}}}
#define 	MEM_COPY(mem,mem1,anz,ges,pos,add)									\
			{																	\
			if(add>0)															\
			{																	\
			if((ges<anz+add)||!mem)MEM_GROW(mem,anz,ges,MEM_ADD)				\
			if (pos<anz)														\
			{																	\
			memmove(mem+(pos+add),												\
					mem+ pos     ,												\
					(anz-pos    )*sizeof(mem[0]));								\
					 anz+=add;													\
			}		 															\
			memcpy (mem+pos,mem1,add*sizeof(mem[0]));							\
			}}



#endif