//*****************************************************************************
//*
//*
//*		ArchiveFile.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf Arcgiv-Dateien wie ZIP,TAR,GZ,TGZ....:
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int		Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen

#include	<stdio.h>
#include	<stddef.h>
#include	<string.h>
#include	"FileFinder.h"
#include	"ArchiveFile.h"
#include	"FileFunctions.h"
#include	"StringFunctions.h"
#include	"Codecs/IoCallbacks.h"

#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	atoiz	   _wtoi
#define 	itoaz	   _itow
#define 	strzlen		(int)wcslen
#define 	strtoulz    wcstoul
#define 	strzcpy		wcscpy
#define 	strzncpy	wcsncpy
#define 	strzncat	wcsncat
#define 	strzicmp	wcsicmp
#define 	strzcspn	wcscspn
#define 	szprintf	swprintf
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	atoiz	    atoi
#define 	itoaz		itoa
#define 	strzlen		(int)strlen
#define 	strtoulz    strtoul
#define 	strzcpy		strcpy
#define 	strzncpy	strncpy
#define 	strzncat	strncat
#define 	strzicmp	stricmp
#define 	strzcspn	strcspn
#define 	szprintf	sprintf
#endif


#ifndef 	SPEZIAL_STR
#define		SPEZIAL_STR	Z("zip;zoo;arc;lzh;arj;gz;cab;bz2;tgz;rar;rpm;gzip;7z;k")
#endif 	

#define 	ENTRIES(a)	(sizeof(a)/sizeof((a)[0]))
#ifndef	   _WIN64
#ifndef		DWORD_PTR
#define		DWORD_PTR	DWORD
#endif
#endif



#define PROG(iMode,pEntry)							\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	if(Progress(iMode,pEntry))throw CAF_ERROR_BREAK;\
	}
#define PROGR(iMode,pEntry,iRet)					\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	if(Progress(iMode,pEntry))return iRet;			\
	}
#define PROGN(iMode,pEntry)							\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	Progress(iMode,pEntry);							\
	}


//*****************************************************************************
//*
//*		Globale Variabeln
//*
//*****************************************************************************

bool   CArchiveFile::m_bProgInit=0;					// Progress Init
zchar *CArchiveFile::m_pTempPath=0;					// Pfad fr temporre Dateien
zchar *CArchiveFile::m_cProgTxt1[CAF_PROG_MAX];		// Progress Namen
zchar *CArchiveFile::m_cProgTxt2[CAF_PROG_MAX]; 	// Progress Namen
int    CArchiveFile::m_iProgLen1[CAF_PROG_MAX]; 	// Progress Lnge
int    CArchiveFile::m_iProgLen2[CAF_PROG_MAX]; 	// Progress Lnge

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CArchiveFile::CArchiveFile()
{

	m_hResHg		= NULL;					   		// Global Handle der benutzen Resource
	m_hResSrc		= NULL;							// Handle der benutzen Resource
	m_pMemPtr		= NULL;							// Zeiger auf Hauptspeicher
	m_pSubPtr		= NULL;							// Unterdatei, Zeiger auf Resourcen Speicher
	m_pMemFree		= NULL;							// Free-Zeiger auf dynamischne Haupspeicher
	m_pSubFree		= NULL;							// Unterdatei, Free-Zeiger auf dynamischne Unterspeicher
	m_pPassword		= NULL;					   		// Zeiger auf das Passwort
	m_pUserData		= NULL;					   		// User-Daten fr Archiv
	m_pBasePath		= NULL;					   		// Pfad fr auf die geffnete Unterdatei
	m_pFileName		= NULL;					   		// Ist der Name der Archiv-Datei ohne Pfad
	m_pErrorText	= NULL;					   		// Speicher fr Fehlertext	
	m_pErrorFile	= Z("???");				   		// Dateiname fr F... Fehler
	m_iErrorCode	= CAF_ERROR_OK;			   		// Aktueller Fehler-Code (siehe CAF_ERROR_???)
	m_pInsertFile	= NULL;							// Dateiname die gerade mit Add(...) eingefgt wird
	m_iCompressMode	= CAF_BEST;				   		// Komprimirungsmodus (CAF_BEST,CAF_STORE)
	m_iOpenMode		= CAF_CLOSED;			   		// Modus beim ffnen (0=CAF_CLOSED 1=CAF_READ 1=CAF_WRITE 3=CAF_CREATE)
	m_hSubFile		= INVALID_HANDLE_VALUE;			// Unterdatei, Ist das Datei-Handle 
	m_hFile			= INVALID_HANDLE_VALUE;			// Ist das Datei-Handle der Hauptdatei
	m_cFilePath[0]	= 0;				   			// Ist der akuelle Dateiname vom Archiv	
	m_iLevel		= 9;							// Komprimirungslevel (0=keine 8=maximal,9=standard)
	m_pProgress		= 0;							// Benutzte Progress-Funktion (NULL=auu)		
	m_iErrorCode	= 0;							// Aktueller Fehler-Code (siehe CAF_ERROR_???)		
	m_iModeFlags	= 0;							// Komprimirung und Diverses CAF_FLAG_????
	m_pProgParam	= 0;							// Zeiger fr Progress-Funktion	
	m_iProgMode		= 0;							// Progress Modus  (jedes Bit ist ein Schalter)
	m_iFileSize		= 0;							// Gre der Hauptdatei oder des Resourcen-Speichers		
	m_iProgOn		= 0;							// Progress Ein/Aus (jedes Bit ist ein Schalter)
	m_iMemLen		= 0;							// Lnge des  Hauptspeichers
	m_iMemPos		= 0;							// Ausleseposition aus Resourcen Speichers
	m_iMemEnd		= 0;							// Hchste Schreibposition im Speicher
	m_iSortMode		= 0;							// Ist die Liste sortiert (0=nein, CAF_FLAG_SORT???)
	m_cSubActive	= 0;							// Ist eine Unterdatei aktiv
	m_cHasStore		= 0;							// Kann das Archiv die Datei auch unkomprimiert speichern
	m_cHasAddFile	= 0;							// Knnen Dateien direkt eingefgt werden
	m_cHasCompress	= 1;							// Gibt es komprimier Funktionen
	m_cThrowRd		= 1;							// Exeptions beim Lesen werfen
	m_cThrowWr		= 1;							// Exeptions beim Schreiben werfen


}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CArchiveFile::~CArchiveFile()
{

	ReleaseData();
	if(m_pErrorText){delete m_pErrorText;m_pErrorText=0;}
	if(m_pPassword ){delete m_pPassword ;m_pPassword =0;}
	if(m_pMemFree  ){delete m_pMemFree  ;m_pMemFree  =0;}
	if(m_pSubFree  ){delete m_pSubFree  ;m_pSubFree  =0;}

	m_pFileName = NULL;
	m_pBasePath	= NULL;

}

//*****************************************************************************
//*
//*		OpenRes
//*
//*****************************************************************************
//	ffnet eine Resource aus der EXE-Datei als Archiv.
//	pName   : Name der Resource
//	pType   : Ist der Resource-Ordner wenn pType==0 ist wird "DATA" benutzt
//	iFlags	: Diverse Flags fr die Klasse:
//				CAF_FLAG_NOFIND		0x0010	Nicht prfen ob die Datei im Archiv existiert 
//				CAF_FLAG_NOCHECK	0x0020  Die Dateien nicht Prfen beim ffnen. 
//				CAF_FLAG_NOEXIST	0x0040  Vorhandene Dateien nicht berschreiben.  
//				CAF_FLAG_NOREADONLY	0x0080  Schreibgeschtze Dateien nicht berschreiben.  
//				CAF_FLAG_FULLPATH	0x0880  Ganze Namen mit Laufwerken speichern.  
//				CAF_FLAG_FULLNAME	0x0800  Ganze Namen Speichern ohne Laufwerk.  
//				CAF_FLAG_SORT		0x0400  Liste nach Namen sortieren.  
//				CAF_FLAG_SORTLEN	0x0500  Liste nach Lngen sortieren.  
//				CAF_FLAG_SUBDIR		0x1000  Unterverzeichnisse durchsuchen beim Anhngen.  
//				CAF_FLAG_NEW		0x2000  Nur neuere Dateien ersetzen.  
//				CAF_FLAG_BEST		0x4000  Beste Komprimierung beim Anhngen von Dateien.  
//				CAF_FLAG_STORE		0x8000  Keine Komprimierung beim Anhngen von Dateien.  
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//				CAF_ERROR_OK		Alles ok
//				CAF_ERROR_NONE		Wenn Datei nicht gefunden werden konnte
//				CAF_ERROR_OPEN		Wenn Datei nicht geffnet werden konnte
//				CAF_ERROR_CREATE	Wenn Datei nicht erzeugt  werden konnte
//				CAF_ERROR_READ		Bei Lese-Fehlern
//				CAF_ERROR_FORM		Bei Fehlern im UUE-Datei
//				CAF_ERROR_MULTI		Wenn Zib ber mehere Disketten geht
//				CAF_ERROR_LOGIC		Bei internen unbekannten Fehlern
int CArchiveFile::OpenRes(const zchar *pName,const zchar *pType,int iFlags)
{
const zchar	   *pTypeEx;
int				iLen;


	ReleaseData();

	if(m_pMemFree){delete m_pMemFree;m_pMemFree=0;}		// Speicher vom letzte Aufruf freigeben
	if(m_pSubFree){delete m_pSubFree;m_pSubFree=0;}

	if(!pType)pType=Z("DATA");

	pTypeEx = pType;

	if((DWORD_PTR)pType>0xFFFF)							// Namen in Typumwandeln
		{
		if(!strzicmp(pType,Z("CURSOR")))pType=RT_CURSOR;
		if(!strzicmp(pType,Z("BITMAP")))pType=RT_BITMAP;
		if(!strzicmp(pType,Z("ICON"  )))pType=RT_ICON;
		if(!strzicmp(pType,Z("HTML"  )))pType=RT_HTML;
		}


		m_hResSrc = FindResource(NULL,pName,pType);
	if(!m_hResSrc)										// Wurde die Resource gefunden
		{
		m_iErrorCode = CAF_ERROR_NONE;
		return         CAF_ERROR_NONE;
		}

		m_hResHg = (void*)LoadResource(NULL,(HRSRC)m_hResSrc);
	if(!m_hResHg)
		{
		DeleteObject(m_hResSrc);
		m_iErrorCode = CAF_ERROR_NONE;
		return         CAF_ERROR_NONE;
		}
														
	m_iMemLen = SizeofResource(NULL,(HRSRC)m_hResSrc);	// Speicher auf Resource holen	
	m_pMemPtr = (char*)LockResource(m_hResHg);
	m_iMemPos =  0;
	m_iMemEnd = -1;	


	if((DWORD_PTR)pTypeEx>0xFFFF)						
			iLen = szprintf(m_cFilePath,Z("res:\\\\%s-")          ,pTypeEx);
	else	iLen = szprintf(m_cFilePath,Z("res:\\\\%u-"),(unsigned)pTypeEx);

	if((DWORD_PTR)pName>0xFFFF)						
			szprintf(m_cFilePath+iLen,Z("%s")          ,pName);
	else	szprintf(m_cFilePath+iLen,Z("%u"),(unsigned)pName);


	iFlags   &= 0xFFF0;


return Open(m_cFilePath,0x12340008|CAF_READ|iFlags);
}

//*****************************************************************************
//*
//*		OpenMem
//*
//*****************************************************************************
//	ffnet ein Archiv aus einem Speicher
//	pData	: Zeiger auf den Speicher, mit CAF_ALLOC wird dynamischer Speicher 
//			  benutzt dessen Gre bis iSize waschen kann.
//	iSize	: Ist die Gre des Speichers in Byte, bei CAF_ALLOC ist dieser Wert 
//			  die maximale Speichergre.
//	iEnd	: Ist die aktuelle Gre des benutzen Speichers, bei CAF_ALLOC ist 
//			  dieser Wert die minimale Speichergre, anderfalls:
//				<0 = Lesen der ganze Speicher wird benutzt
//				 0 = Neuerstellen mit Null-Gre (oder mit CAF_ALLOC)
//				>0 = Zum Schreiben ffnen
//	iFlags	: Diverse Flags fr die Klasse:
//				CAF_FLAG_NOFIND		0x0010	Nicht prfen ob die Datei im Archiv existiert 
//				CAF_FLAG_NOCHECK	0x0020  Die Dateien nicht Prfen beim ffnen. 
//				CAF_FLAG_NOEXIST	0x0040  Vorhandene Dateien nicht berschreiben.  
//				CAF_FLAG_NOREADONLY	0x0080  Schreibgeschtze Dateien nicht berschreiben.  
//				CAF_FLAG_FULLPATH	0x0880  Ganze Namen mit Laufwerken speichern.  
//				CAF_FLAG_FULLNAME	0x0800  Ganze Namen Speichern ohne Laufwerk.  
//				CAF_FLAG_SORT		0x0400  Liste nach Namen sortieren.  
//				CAF_FLAG_SORTLEN	0x0500  Liste nach Lngen sortieren.  
//				CAF_FLAG_SUBDIR		0x1000  Unterverzeichnisse durchsuchen beim Anhngen.  
//				CAF_FLAG_NEW		0x2000  Nur neuere Dateien ersetzen.  
//				CAF_FLAG_BEST		0x4000  Beste Komprimierung beim Anhngen von Dateien.  
//				CAF_FLAG_STORE		0x8000  Keine Komprimierung beim Anhngen von Dateien.  
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//				CAF_ERROR_OK		Alles ok
//				CAF_ERROR_NONE		Wenn Datei nicht gefunden werden konnte
//				CAF_ERROR_OPEN		Wenn Datei nicht geffnet werden konnte
//				CAF_ERROR_CREATE	Wenn Datei nicht erzeugt  werden konnte
//				CAF_ERROR_READ		Bei Lese-Fehlern
//				CAF_ERROR_FORM		Bei Fehlern im UUE-Datei
//				CAF_ERROR_MULTI		Wenn Zib ber mehere Disketten geht
//				CAF_ERROR_LOGIC		Bei internen unbekannten Fehlern
int CArchiveFile::OpenMem(const void *pData,int iSize,int iEnd,int iFlags)
{
unsigned	uLoVal;
unsigned	uHiVal;
int			iMode;
int			iLen;

	
	ReleaseData();

	if(!pData || iSize<=0)								// Prfe die Speichergre	
		{
		m_iErrorCode = CAF_ERROR_NONE;
		return         CAF_ERROR_NONE;
		}

	if(iEnd>iSize)
		{
		m_iMemEnd = iSize;
		}

	if(pData==CAF_ALLOC)								// Dynamischen Speicher anlegen
		{
		if(m_pMemFree){delete m_pMemFree;m_pMemFree=0;}
		if(m_pSubFree){delete m_pSubFree;m_pSubFree=0;}
		
		if(iEnd<0x40000)iEnd=0x40000;

			pData = new char[iEnd+16];
		if(!pData)return CAF_ERROR_MEM;

		m_pMemFree	= (char*)pData;
		m_iMemMax	= iSize;
		iSize		= iEnd;
		iEnd		= 0;
		}

		
	m_pMemPtr	= (char*)pData;
	m_iMemLen	= iSize; 
	m_iMemEnd	= iEnd;
	m_iMemPos	= 0;
	m_hResSrc	= 0;
	m_hResHg	= 0;


	if(iEnd<0)											// Modus ermitteln
		{
		iMode	= CAF_READ;
		}
	else if(iEnd==0)
		{
		iMode	= CAF_CREATE;
		}
	else{
		iMode	= CAF_WRITE;
		}

	uLoVal	= (unsigned)m_pMemPtr;
	uHiVal	= (unsigned)((aint64)m_pMemPtr>>32);	

	if(uHiVal && sizeof(void*)!=4)
			iLen=szprintf(m_cFilePath,Z("mem:\\\\%X%08X-%u"),uHiVal,uLoVal,m_iMemLen);
	else	iLen=szprintf(m_cFilePath,Z("mem:\\\\%08X-%u"  ),       uLoVal,m_iMemLen);

	if(iEnd>=0)szprintf(m_cFilePath+iLen,Z("\\%i"),iEnd);

	iFlags   &= 0xFFF0;



return Open(m_cFilePath,0x12340008|iMode|iFlags);
}


//*****************************************************************************
//*
//*		Open
//*
//*****************************************************************************
//	ffnet eine TAR-Datei und liest alle bereits gespeicherten Dateien ein.
//	pFileName	: Ist der Dateiname des TGZ-Archivs ("res:\\" fr Resourcen)
//	iMode		: Ist der ffnungsmodus bzw. Diverse Flags
//					CAF_READ			1		Bz2-Datei nur Lesen
//					CAF_WRITE			2		Bz2-Datei auch schreiben bzw. neuerstellen wenn nicht vorhanden.
//					CAF_CREATE			3		Bz2-Datei neu erstellen Altes lschen
//					CAF_FLAG_NOFIND		0x0010	Nicht prfen ob die Datei im Archiv existiert 
//					CAF_FLAG_NOCHECK	0x0020  Die Dateien nicht Prfen beim ffnen. 
//					CAF_FLAG_NOEXIST	0x0040  Vorhandene Dateien nicht berschreiben.  
//					CAF_FLAG_NOREADONLY	0x0080  Schreibgeschtze Dateien nicht berschreiben.  
//					CAF_FLAG_FULLPATH	0x0880  Ganze Namen mit Laufwerken speichern.  
//					CAF_FLAG_FULLNAME	0x0800  Ganze Namen Speichern ohne Laufwerk.  
//					CAF_FLAG_SORT		0x0400		= Nach Namen  sortieren
//					CAF_FLAG_SORTLEN 	0x0500		= Nach Lngen sortieren
//					CAF_FLAG_SORTPOS 	0x0600		= Nach Offset sortieren (intern)
//					CAF_FLAG_SORTEX	 	0x0700		= Nach Namen mit Zahlen Bercksichtigung
//					CAF_FLAG_SUBDIR		0x1000  Unterverzeichnisse durchsuchen beim Anhngen.  
//					CAF_FLAG_NEW		0x2000  Nur neuere Dateien ersetzen.  
//					CAF_FLAG_BEST		0x4000  Beste Komprimierung beim Anhngen von Dateien.  
//					CAF_FLAG_STORE		0x8000  Keine Komprimierung beim Anhngen von Dateien.  
//	iLevel		: Komprimierungs Levl (0-9) 9=maximal  (unbenutzt)
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//					CAF_ERROR_OK		Alles ok
//					CAF_ERROR_NONE		Wenn die Datei nicht gefunden werden konnte
//					CAF_ERROR_OPEN		Wenn die Datei nicht geffnet werden konnte
//					CAF_ERROR_CREATE	Wenn die Datei nicht erzeugt  werden konnte
//					CAF_ERROR_READ		Bei Lese-Fehlern
//					CAF_ERROR_FORM		Bei Fehlern im TAR-Datei
//					CAF_ERROR_MULTI		Wenn Zib ber mehere Disketten geht
//					CAF_ERROR_LOGIC		Bei internen unbekannten Fehlern
int CArchiveFile::Open(const zchar *pFileName,int iMode,int iLevel)
{
zchar	   *pNamePtr;
int			iFlags;
aint64		iSize;
int			iRet;
int			iLen;


	m_pTempSuffix	= NULL;
	m_iErrorCode	= CAF_ERROR_OK;
	m_iSortMode		= 0;


	iFlags = iMode;
	iMode &= 0x0F;


	if(iMode>CAF_CREATE || iMode<=CAF_CLOSED)				// Prfe den Modus
		{
		if(!m_pMemPtr || (iFlags>>16)!=0x1234)
			{
			ReleaseData();
			PROG(CAF_PROG_OPEN,-1);
			m_iErrorCode = CAF_ERROR_NOTSUPP;
			return         CAF_ERROR_NOTSUPP;
			}

		iMode &= 0x007;										// Speicher direkt bergeben
	
		if(iMode!=CAF_READ)
			{
			if(m_cHasCompress==0)							// Wird nur Lesen untersttzt
				{
				PROG(CAF_PROG_OPEN,-1);
				m_iErrorCode = CAF_ERROR_NOTSUPP;
				return         CAF_ERROR_NOTSUPP;
				}

			if(m_iMemEnd<16)								// Bei zu kleinen Dateien auf Create wechseln
				{
				iMode	  = CAF_CREATE;
				m_iMemEnd = 0;
				m_iMemPos = 0;
				}
			}
															
		
		goto Load;
		}


	if(m_pMemFree){delete m_pMemFree;m_pMemFree=0;}			// Speicher vom letzte Aufruf freigeben
	if(m_pSubFree){delete m_pSubFree;m_pSubFree=0;}

	ReleaseData();


	if(m_cHasCompress==0 && iMode!=CAF_READ)				// Wird nur Lesen untersttzt
		{
		PROG(CAF_PROG_OPEN,-1);
		m_iErrorCode = CAF_ERROR_NOTSUPP;
		return         CAF_ERROR_NOTSUPP;
		}


//******************** Resourenpfad *******************************************


	if(pFileName[0]=='R'  || pFileName[0]=='r')				// Ist es "res://<type>/<name>"
	if(pFileName[1]=='E'  || pFileName[1]=='e')
	if(pFileName[2]=='S'  || pFileName[2]=='s')
	if(pFileName[3]==':')
	if(pFileName[4]=='\\' || pFileName[4]=='/')
	if(pFileName[5]=='\\' || pFileName[5]=='/')
		{
		zchar		  cType[64];
		zchar		  cName[64];
		const zchar	 *pType=0;
		const zchar	 *pName=0;
		int			  iNum;

		pFileName += 6;

		iNum = (int)strzcspn(pFileName,Z("\\/-"));			

		if(pFileName[iNum] && iNum<sizeof(cType)-1)			// Typnamen auswerten 
			{
			memcpy(cType,pFileName,iNum*sizeof(zchar));

			cType[iNum] = 0;
			iNum		= atoiz(cType);

			if(iNum)pType = MAKEINTRESOURCE(iNum);
			else	pType = cType;	

			pFileName    += iNum+1;
			}


		iNum = strzlen(pFileName);
		
		if(iNum<sizeof(cName)-1)							// Namen auswerten
			{
			memcpy(cName,pFileName,iNum*sizeof(zchar));

			cName[iNum] = 0;
			iNum		= atoiz(cName);

			if(iNum)pName = MAKEINTRESOURCE(iNum);
			else	pName = cName;	
			}


		return OpenRes(pName,pType,iFlags);
		}


//******************** Speicherpfad *******************************************


	if((pFileName[0]=='M'  || pFileName[0]=='m') &&			// Speicher ffnen
	   (pFileName[1]=='E'  || pFileName[1]=='e') &&
	   (pFileName[2]=='M'  || pFileName[2]=='m') &&
	   (pFileName[3]==':')					     &&
	   (pFileName[4]=='\\' || pFileName[4]=='/') &&
	   (pFileName[5]=='\\' || pFileName[5]=='/'))
		{
		zchar		  cName[32];
		aint64		  iValue;
		void		 *pData;
		int			  iNum;
		int			  iEnd;


		pFileName += 6;

		iNum = (int)strzcspn(pFileName,Z("\\/-"));			// Ist der Pfad der Typname ?

		if(iNum<=16 || sizeof(void*)==4)
			{
			pData = (void*)strtoulz(pFileName,NULL,16);
			}
		else{												// Mehr als 32-Bit
			memcpy(cName,pFileName,16*sizeof(zchar));
			cName[16] = 0;
			iValue    = strtoulz(cName,NULL,16);
			iValue  <<= (iNum-16)*4;
			iValue   |=	strtoulz(pFileName+16,NULL,16);
			pData	  = (void*)iValue;
			}

			pFileName += iNum;
		if(*pFileName)pFileName++;

		iNum       = atoiz(pFileName);						// Speicherlnge holen
		pFileName += (int)strzcspn(pFileName,Z("\\/-"));
		if(*pFileName)pFileName++;
		iEnd	   = (*pFileName)? atoiz(pFileName):-1;		// Endlnge holen			

		
		return OpenMem(pData,iNum,iEnd,iFlags);
		}												



//******************** Datei ffnen *******************************************	


	m_iMemLen = 0;

	GetFullPathName(pFileName,ENTRIES(m_cFilePath),m_cFilePath,(zchar**)&pNamePtr);

	

	switch(iMode)
		{													// Lesen
	case CAF_READ:
	
		m_hFile	= CreateFile(m_cFilePath,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		break;


	case CAF_WRITE:											// Schreiben
	
		   m_hFile = CreateFile(m_cFilePath,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(m_hFile!=INVALID_HANDLE_VALUE)
			{
			   iSize = GetFileSize(m_hFile);
			if(iSize<0)
				{
				CloseHandle(m_hFile);
				m_hFile = INVALID_HANDLE_VALUE;
				break;
				}

			SetFilePointer(m_hFile,0,0,FILE_BEGIN);
			SetEndOfFile  (m_hFile);
			iMode = CAF_CREATE;
			break;
			}

		iMode = CAF_CREATE;

									
	case CAF_CREATE:										// Neuerstellen
		
		m_hFile = CreateFile(m_cFilePath,GENERIC_READ|GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
		break;
		}



	if(m_hFile==INVALID_HANDLE_VALUE)						// Fehler beim ffnen
		{
		PROG(CAF_PROG_OPEN,-1);

		switch(iMode)
			{
		case CAF_CREATE:m_iErrorCode = CAF_ERROR_CREATE;	break;
		default:		m_iErrorCode = CAF_ERROR_OPEN;		break;
			}

		return m_iErrorCode;
		}



//******************** Ab hier macht die Ableitung weiter *********************

	
Load:

	m_iFileSize = MainSize();								// Dateigre einlesen
	

	   iLen	= strzlen(m_cFilePath);
	if(iLen<=0)
		{
		m_pFileName = NULL;
		}
	else{
		for(;iLen>0;iLen--)
			{
			if(m_cFilePath[iLen-1]=='\\')break;
			if(m_cFilePath[iLen-1]=='/' )break;
			if(m_cFilePath[iLen-1]==':' )break;
			}
		
		m_pFileName = m_cFilePath+iLen;
		}


	m_iOpenMode	 = iMode;
	
	Flags(iFlags&~0x0F);
													
	try	{
		iRet = ArchOpen(iLevel);							// Den Rest laden in der Klassenableitung
		m_iErrorCode = iRet;
		}
	catch(int iError)
		{
		m_iErrorCode = iError;
		iRet		 = iError;
		PROGN(CAF_PROG_ERROR,-1);
		Break();
		}

	if(iRet!=CAF_ERROR_OK)									// Gab es einem Fehler beim ffnen
		{
		ReleaseData();
		}



return iRet;
}


//*****************************************************************************
//*
//*		ReleaseData
//*
//*****************************************************************************
//	Schliet alle Daten. Diese Funktion muss in Close aufgerufen werden
void CArchiveFile::ReleaseData()								
{
			
	m_pBasePath		= NULL;
	m_pFileName		= NULL;
	m_cFilePath[0]	= 0;


	if(m_pMemPtr)									// Resource schliesen ?
		{
		if(m_hResHg)
			{
			UnlockResource(m_hResHg);
			m_hResHg = NULL;
			}

		if(m_hResSrc)
			{
			DeleteObject(m_hResSrc);
			m_hResSrc = NULL;
			}

		if(m_iMemEnd>=0)
			{
			m_iMemLen = m_iMemEnd;
			}

		m_pMemPtr = 0;
		m_iMemEnd = 0;
		m_iMemPos = 0;
		}

	
	if(m_hFile!=INVALID_HANDLE_VALUE)				// Die Datei schlieen
		{
		CloseHandle(m_hFile);
		m_hFile		= INVALID_HANDLE_VALUE;
		m_iFileSize	= 0;
		m_iMemLen	= 0;
		}


	if(m_pSubPtr)									// Sub-Resource schliesen ?
		{
		if(m_hResHg)
			{
			UnlockResource(m_hResHg);
			m_hResHg = NULL;
			}

		if(m_hResSrc)
			{
			DeleteObject(m_hResSrc);
			m_hResSrc = NULL;
			}

		if(m_pMemFree && m_pSubFree)				// Dynamischen Speicher verschieben	
			{
			delete m_pMemFree;

			m_pMemFree = m_pSubFree;
			m_iMemMax  = m_iSubMax;
			m_pSubFree = 0;
			m_iSubMax  = 0;	
			}

		if(m_iSubEnd>=0)
			{
			m_iMemLen = m_iSubEnd;
			}
		else{
			m_iMemLen = m_iSubLen;
			}

		m_pSubPtr = 0;
		m_iSubLen = 0;
		m_iSubPos = 0;
		m_iSubEnd = 0;
		}


	if(m_hSubFile!=INVALID_HANDLE_VALUE)			// Die Unterdatei schlieen
		{
		CloseHandle(m_hSubFile);
		m_hSubFile	= INVALID_HANDLE_VALUE;
		m_iSubSize	= 0;
		m_iMemLen	= 0;
		}

	
	m_iOpenMode		= CAF_CLOSED;
	m_cSubActive	= 0;

}

//*****************************************************************************
//*
//*		Level
//*
//*****************************************************************************
//	Setzt den Komrimierungs-Level (9=Standard)
//  Wird Level nicht angegeben wird nur der aktuelle Wert zurckgegeben
//	Ist  Level == 0 wird die Methode auf CAF_STORE gesetzet
int CArchiveFile::Level(int iLevel)
{

	if(iLevel!=-2)
		{
		if(iLevel==0){m_iCompressMode=CAF_STORE;}
		if(iLevel <0)iLevel=0;
		if(iLevel >9)iLevel=9;

		m_iLevel = iLevel;
		}


return m_iLevel;
}

//*****************************************************************************
//*
//*		Flags
//*
//*****************************************************************************
//	Setzt die Flags
//  Wird Flags nicht angegeben wird nur der aktuelle Wert zurckgegeben
//   CAF_FLAG_STORE 		0x8000		Keine Komprimierung
//   CAF_FLAG_BEST 			0x4000		Beste Komprimierung
//   CAF_FLAG_NEW  			0x2000		Nur neuere Dateien ersetzen
//   CAF_FLAG_SUBDIR		0x1000		Unterverzeichnisse durchsuchen
//	 CAF_FLAG_FULLPATH		0x0880		Ganze Namen mit Laufwerken
//   CAF_FLAG_FULLNAME		0x0800		Ganze Namen Speichern ohne LW
//   CAF_FLAG_SORT			0x0400		Liste nach Namen  sortieren
//   CAF_FLAG_SORTLEN	    0x0500		Liste nach Lngen sortieren
int CArchiveFile::Flags(int iFlags)
{

	if(iFlags!=-2)
		{
		if( iFlags&CAF_FLAG_BEST ){m_iCompressMode=CAF_BEST; iFlags&=~CAF_FLAG_STORE;}
		if( iFlags&CAF_FLAG_STORE){m_iCompressMode=CAF_STORE;}
		if((iFlags^m_iModeFlags)&0x0700)Sort(iFlags);
		m_iModeFlags = iFlags;
		}


return m_iModeFlags;
}

//*****************************************************************************
//*
//*		Mode
//*
//*****************************************************************************
//	Setze Methode frs Komrimieren
//  Wird iMode nicht angegeben wird nur der aktuelle Wert zurckgegeben
//		CAF_BEST	-1			Beste Methode
//		CAF_STORE	 0			Nur eins zu ein speichern
//		CAF_DEFLATE  8			Komrimieren
int CArchiveFile::Mode(int iMode)
{

	if(iMode!=-2)
		{
		if(iMode!=CAF_BEST && iMode!=CAF_STORE)
			{
			iMode=CAF_DEFLATE;
			}

		m_iCompressMode=iMode;
		}

return m_iCompressMode;
}


//*****************************************************************************
//*
//*		ErrorText
//*
//*****************************************************************************
zchar *CArchiveFile::ErrorText()
{
int		 iAdd=0;
zchar	*pText;
zchar	*pName;



	if(m_iErrorCode==CAF_ERROR_OK)
		{
		return Z("\nEs ist kein Fehler aufgetreten.");
		}

	if(m_iErrorCode==CAF_ERROR_BREAK)
		{
		return Z("\nBenutzer Abbruch.");
		}

	if(!m_pErrorText)
		{
		m_pErrorText=new zchar[MAX_PATH+256];
		}

	switch(m_iErrorCode)
		{
	case CAF_ERROR_COMP:	pText=Z("\nFehler beim Komprimieren :");						break;
	case CAF_ERROR_VERSION:	pText=Z("\nDiese Version wird nicht untersttzt :");			break;
	case CAF_ERROR_NOTSUPP:	pText=Z("\nDie Funktion wird nicht untersttzt :");				break;
	case CAF_ERROR_MISS:	pText=Z("\nFalscher Index oder Modus !");						break;
	case CAF_ERROR_LOGIC:	pText=Z("\nSchwerer interner Fehler !");						break;
	case CAF_ERROR_WRITE:	pText=Z("\nFehler beim Schreiben in Datei !");					break;
	case CAF_ERROR_READ:	pText=Z("\nFehler beim Lesen der Datei !");						break;
	case CAF_ERROR_CREATE:	pText=Z("\nFehler beim Erzeugen der Datei !");					break;
	case CAF_ERROR_OPEN:    pText=Z("\nFehler beim ffnen der Datei !");					break;
	case CAF_ERROR_MULTI:	pText=Z("\nFehler sie geht ber mehrere Disketten !");			break;
	case CAF_ERROR_FORM:	pText=Z("\nhat ein ungltiges Format ");						break;
	case CAF_ERROR_EOF:     pText=Z("\nvorzeitiges Dateiende erreicht !");     				break;
	case CAF_ERROR_NONE:    pText=Z("\nDatei wurde nicht gefunden !");	    				break;
	case CAF_ERROR_NOTOPEN:	pText=Z("\nDar Archiv ist nicht geffnet !");					break;
	case CAF_ERROR_MODE:	pText=Z("\nIn diesem Modus ist die Funktion nicht mglich !");	break;
	case CAF_ERROR_PATH:	pText=Z("\nFalsche Pfadname-Angabe !");							break;
	case CAF_ERROR_CRC:     pText=Z("\nCRC32 Fehler bei Datei :");					iAdd=1;	break;
	case CAF_ERROR_DECOMP:  pText=Z("\nFehler beim Entkomprimieren von :");			iAdd=1;	break;
	case CAF_ERROR_FREAD:	pText=Z("\nFehler beim Lesen der Datei: ");				iAdd=1;	break;
	case CAF_ERROR_FWRITE:	pText=Z("\nFehler beim Schreiben in Datei: ");			iAdd=1;	break;
	case CAF_ERROR_FCREATE:	pText=Z("\nFehler beim Erzeugen der Datei: ");			iAdd=1;	break;
	case CAF_ERROR_FOPEN:   pText=Z("\nFehler beim ffnen der Datei: ");			iAdd=1;	break;
	case CAF_ERROR_IGNORE:  pText=Z("\nDie Datei wurde bersprungen: ");			iAdd=1;	break;
	case CAF_ERROR_PASSWD:	pText=Z("\nFalsches Passwort : ");						iAdd=1;	break;
	case CAF_ERROR_EXIST:	pText=Z("\nDie Datei ist bereits vorhanden: ");			iAdd=1;	break;
	case CAF_ERROR_OLDER:	pText=Z("\nDie Datei ist lter als die vorhandene: ");	iAdd=1;	break;
	case CAF_ERROR_DISKFULL:pText=Z("\nEs ist kein Platz mehr vorhanden fr: ");	iAdd=1;	break;
	default:				pText=Z("\nUnbekannter Fehler");						iAdd=1;	break;
		}


	if(!m_pErrorFile)iAdd=0;

			pName = (m_cFilePath[0])? m_cFilePath:Z("\n< keine Datei geffnet >");
			strzcpy (m_pErrorText,Z("\nBei Datei : "));
			strzncat(m_pErrorText,pName       ,MAX_PATH+256);
			strzncat(m_pErrorText,pText       ,MAX_PATH+256);
	if(iAdd)strzncat(m_pErrorText,m_pErrorFile,MAX_PATH+256);


return m_pErrorText;
}

//*****************************************************************************
//*
//*		Progress
//*
//*****************************************************************************
//	Stellt die Protokoll Funktion ein
//	Submit ist der void zeiger der bergeben wird.
int	CArchiveFile::Progress(void *pParam,int (__cdecl*pProc)(void *pParam,int iMode,int iSub,CArchiveFile *pTar,zchar *pText))
{
int	i;

	m_pProgParam = pParam;
	m_iProgMode  = 0;
	m_iProgOn    = 0xFFFFFFFF;
	m_pProgress  = pProc;

	if(!m_bProgInit)
		{
		m_cProgTxt1[ CAF_PROG_OPEN	   ]=Z("\nDatei ");
		m_cProgTxt1[ CAF_PROG_SORT 	   ]=Z("\nDatei ");
		m_cProgTxt1[ CAF_PROG_FIND	   ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_ZDEL     ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_DEL      ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_CLOSE    ]=Z("\nDatei ");
		m_cProgTxt1[ CAF_PROG_CREATE   ]=Z("\nDatei ");
		m_cProgTxt1[ CAF_PROG_ZADD     ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_WRITE    ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_COMPRESS ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_READ     ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_TEST	   ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_FLUSH	   ]=Z("\nDatei ");
		m_cProgTxt1[ CAF_PROG_ERROR	   ]=Z("");
		m_cProgTxt1[ CAF_PROG_EXTRACT  ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_QUERY    ]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_DOEXTRACT]=Z("\nDatei: ");
		m_cProgTxt1[ CAF_PROG_PASSWD   ]=Z("\nDatei: ");

		m_cProgTxt2[ CAF_PROG_OPEN 	   ]=Z(" ffnen.");
		m_cProgTxt2[ CAF_PROG_SORT 	   ]=Z(" sortieren.");
		m_cProgTxt2[ CAF_PROG_FIND	   ]=Z(" gefunden.");
		m_cProgTxt2[ CAF_PROG_ZDEL     ]=Z(" entfernen.");
		m_cProgTxt2[ CAF_PROG_DEL  	   ]=Z(" lschen.");
		m_cProgTxt2[ CAF_PROG_CLOSE    ]=Z(" schlieen.");
		m_cProgTxt2[ CAF_PROG_CREATE   ]=Z(" erzeugen.");
		m_cProgTxt2[ CAF_PROG_ZADD     ]=Z(" anhngen.");
		m_cProgTxt2[ CAF_PROG_WRITE    ]=Z(" komprimieren.");
		m_cProgTxt2[ CAF_PROG_COMPRESS ]=Z(" wurde komprimiert.");
		m_cProgTxt2[ CAF_PROG_READ	   ]=Z(" lesen.");
		m_cProgTxt2[ CAF_PROG_TEST	   ]=Z(" prfen.");
		m_cProgTxt2[ CAF_PROG_FLUSH	   ]=Z(" rckschreiben.");
		m_cProgTxt2[ CAF_PROG_ERROR	   ]=Z("");
		m_cProgTxt2[ CAF_PROG_EXTRACT  ]=Z(" wurde entkomprimiert.");
		m_cProgTxt2[ CAF_PROG_QUERY    ]=Z(" berspringen ?");
		m_cProgTxt2[ CAF_PROG_DOEXTRACT]=Z(" wird entkomprimiert.");
		m_cProgTxt2[ CAF_PROG_PASSWD   ]=Z(" Passwort eingeben.");

		for(i=0;i<CAF_PROG_MAX;i++)
			{
			m_iProgLen1[i] = strzlen(m_cProgTxt1[i]);
			m_iProgLen2[i] = strzlen(m_cProgTxt2[i])+1;
			}

		m_bProgInit=1;
		}

return 	m_pProgress!=0;
}

//*****************************************************************************
//*
//*		Progress
//*
//*****************************************************************************
//	Progress Funktion aus fhern
//	Art ist die Art der Nachricht  SubNr ist die Nummer in der Zliste
//	Ergibt 1 wenn mann abbrechen soll
int	CArchiveFile::Progress(int iMsg,int iSubNum)
{
zchar	 cBuffer[MAX_PATH*2+256];
zchar	*pName;



	if(m_iProgMode&(1<<iMsg))
		{
		return m_pProgress(m_pProgParam,iMsg,iSubNum,this,0);
		}

	if(iMsg==CAF_PROG_ERROR)
		{
		return m_pProgress(m_pProgParam,iMsg,iSubNum,this,ErrorText());
		}


	if(iSubNum>=0)									// Archivname oder Datei aus Archiv
		{
		pName = Name(iSubNum);
		}
	else{
		pName = m_cFilePath;
		}


	m_iProgPos = m_iProgLen1[iMsg];
	m_iProgAdd = m_iProgLen2[iMsg];
	m_iProgLen = (pName)? strzlen(pName):0;


	memcpy(cBuffer                      ,m_cProgTxt1[iMsg],m_iProgPos*sizeof(zchar));
	memcpy(cBuffer+m_iProgPos+m_iProgLen,m_cProgTxt2[iMsg],m_iProgAdd*sizeof(zchar));
	memcpy(cBuffer+m_iProgPos			,pName            ,m_iProgLen*sizeof(zchar));



return m_pProgress(m_pProgParam,iMsg,iSubNum,this,cBuffer);
}

//*****************************************************************************
//*
//*		ProgressMode
//*
//*****************************************************************************
//	Ist das Bit fr eine Nachricht gesetzt wird die Text bertragung abgeschalten
//	Ist iMode==0 werden die Bits direkt gesetzt.
//	Ist iMode==1 werden einzelne Bits gesetzt.
//	Ist iMode==2 werden einzelne Bits gelscht.
//	Ergibt den alten Wert
int	CArchiveFile::ProgressMode(int iBits,int iMode)
{
int		iOld=m_iProgMode;

	if(iMode==0)m_iProgMode =     iBits;
	if(iMode==1)m_iProgMode|=  1<<iBits;
	if(iMode==2)m_iProgMode&=~(1<<iBits);

return iOld;
}


//*****************************************************************************
//*
//*		ProgressAdd
//*
//*****************************************************************************
//	Ist das Ein-Bit fr eine Nachricht grlscht wird die
//	Nachricht nicht bertragen
//	Ist iMode !=0 Werten alle Bits direkt gesetzt
//	Ergibt den alten Wert
int	CArchiveFile::ProgressAdd(int iBits,int iMode)
{
int		iOld=m_iProgOn;

	m_iProgOn|=(iMode)? iBits:1<<iBits;

return iOld;
}

//*****************************************************************************
//*
//*		ProgressDel
//*
//*****************************************************************************
//	Ist das Ein-Bit fr eine Nachricht grlscht wird die
//	Nachricht nicht bertragen
//	Ist iMode !=0 Werten alle Bits direkt gesetzt
//	Ergibt den alten Wert
int	CArchiveFile::ProgressDel(int iBits,int iMode)
{
int		iOld=m_iProgOn;

	m_iProgOn&=~((iMode)? iBits:1<<iBits);

return iOld;
}

//*****************************************************************************
//*
//*		Error
//*
//*****************************************************************************
//	Ergibt den aktuellen Fehlercode
int CArchiveFile::Error()
{
	return m_iErrorCode;
}

//*****************************************************************************
//*
//*		Change
//*
//*****************************************************************************
//	Schreiberlaubnis aktivieren
int CArchiveFile::Change(int iMode)
{

	m_iErrorCode = CAF_ERROR_NOTSUPP;

return CAF_ERROR_NOTSUPP;
}

//*****************************************************************************
//*
//*		SetTempPath
//*
//*****************************************************************************
//	Temporren Pfad einstellen.
void CArchiveFile::SetTempPath(const zchar *pPath)
{

	m_pTempPath = (zchar*)pPath;

}

//*****************************************************************************
//*
//*		IsDel
//*
//*****************************************************************************
//	Ergibt 1 wenn die Datei gelscht wurde.
int CArchiveFile::IsDel(int iNum)
{
	return 0;
}


//*****************************************************************************
//*
//*		IsReadOnly
//*
//*****************************************************************************
//	Ergibt 1 wenn die Datei schreibgeschtzt ist.
int CArchiveFile::IsReadOnly(int iNum)
{
	return 0;
}


//*****************************************************************************
//*
//*		SetFail
//*
//*****************************************************************************
// Defekt-Flag setzen
int CArchiveFile::SetFail(int iNum,int iFail)
{
return 0;
}

//*****************************************************************************
//*
//*		Attribute
//*
//*****************************************************************************
//	UNIX-Dateiattribute auslesen
//	iNum		: Ist die Nummer der Datei
//	Ergibt die Attribute bzw. -1 bei einem Fehler
//					0x00000001	= Execute Andere
//					0x00000002	= Write   Andere
//					0x00000004	= Read    Andere
//					0x00000080	= Execute Gruppe
//					0x00000100	= Write   Gruppe
//					0x00000200	= Read    Gruppe
//					0x00000400	= Execute Besitzer
//					0x00000800	= Write   Besitzer
//					0x00001000	= Read    Besitzer
//					0x00004000	= Verzeichnis
//					0x80000000	= Die Attribute sind nachgebiltet
int CArchiveFile::Attribute(int iNum)
{
int		iAttr;



	if((unsigned)iNum>=(unsigned)Count())
		{
		return -1;
		}

	iAttr = IsReadOnly(iNum)? 0x80000000|0444:0x80000000|0644;

	if(IsDir(iNum))iAttr|=0x00004000;



return iAttr;
}

//*****************************************************************************
//*
//*		SetStats
//*
//*****************************************************************************
//	Den Zustand einer Arichiv Datei verndern.
//	iNum	: Ist der Name der Datei samt Pfad die geprft werden soll.
//	iSet	: Welche Bits sollen gesetzt werden
//				CAF_STAT_NONE	0x0000	Die Datei wurde noch nicht entpackt
//				CAF_STAT_EXIST	0x0001	Wenn die Datei beim Entpacken schon vorhanden war
//				CAF_STAT_DECOMP	0x0002	Wenn die Datei vollstndig neu entpackt wurde (immer ohne CAF_STAT_FILEOK)
//	Ergibt den alten Wert oder -1 bei einem Fehler.
int CArchiveFile::SetStats(int iNum,int iSet)
{
return -1;
}

//*****************************************************************************
//*
//*		SetPassword
//*
//*****************************************************************************
//	Setzt das Password
//	pName		: Zeiger auf das Password (NULL = lschen)
//	Ergibt 1 wenn das Password ok ist
int CArchiveFile::SetPassword(const zchar *pName)
{
char   *pBuffer;
int		iLen;


	if(!pName)
		{
		if(!m_pPassword)return 1;
		delete m_pPassword;
		m_pPassword = 0;
		return 1;
		}

	iLen	= strzlen(pName);
	pBuffer	= new char[iLen+1];

	if(!pBuffer)return 0;

	#ifdef		UNICODE

	pBuffer[iLen]=0;

	while(iLen>0)
		{
		iLen--;
		pBuffer[iLen] = (pName[iLen]>255)? 255:pName[iLen];
		}

	#else

	memcpy(pBuffer,pName,iLen+1);

	#endif

	if(m_pPassword)delete m_pPassword;

	m_pPassword = pBuffer;


return 1;
}

//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Hole Dateiname mit Lnge
//	iNum		: Ist die Indexnummer des Namens
//	iLen		: Hier wird die Lnge des Namens gespeichert
//	Ergibt einen Zeiger auf den Namen oder NULL beieinem Fehler.
zchar *CArchiveFile::Name(int iNum,int &iLen)
{
zchar	   *pName;


		pName = Name(iNum);
	if(!pName)iLen=0;
	else	  iLen=strzlen(pName);


return pName;
}

//*****************************************************************************
//*
//*		GetFileSize
//*
//*****************************************************************************
//	Die Dateigre von einem HANDLE abfragen.
//	hFile		: Ist das Windows-Handle der Datei.
//	Ergibt die Dateigre oder -1 bei einem Fehler. 
aint64 CArchiveFile::GetFileSize(void *hFile)
{
DWORD	dwSize;
DWORD	dwHigh;
aint64	iSize;

	
	dwSize  = ::GetFileSize(hFile,&dwHigh);

	if(dwSize!=0xFFFFFFFF || GetLastError()!=NO_ERROR)
		{
		iSize	= dwHigh;
		iSize <<= 32;
		iSize  |= dwSize;	

		return iSize;
		}


return -1;
}


//*****************************************************************************
//*
//*		NoneWrite
//*
//*****************************************************************************
//	Schreibt keine Daten diese Funktion ist nur zum Testen
//	pParam		: Zeiger auf die Instanz der Klasse
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
//	Bei einem Fehler kommt es zur Exeption CAF_ERROR_WRITE (siehe m_cThrowWr)
int	__cdecl CArchiveFile::NoneWrite(void *pParam,const void *pMem,int iSize)
{
return iSize;
}


//*****************************************************************************
//*
//*		NullWrite
//*
//*****************************************************************************
//	Schreibt Daten in eine Datei wenn es keine Schreibterlaubnis gibt.
//	pParam		: Zeiger auf die Instanz der Klasse
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
//	Bei einem Fehler kommt es zur Exeption CAF_ERROR_WRITE (siehe m_cThrowWr)
int	__cdecl CArchiveFile::NullWrite(void *pParam,const void *pMem,int iSize)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;


	if(iSize<=0)return 0;

	if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;


return -1;
}


//*****************************************************************************
//*
//*		BaseWrite
//*
//*****************************************************************************
//	Schreibt Daten in die Unterdatei, in einen Speicher oder in die Datei .
//	pParam		: Zeiger auf die Instanz der Klasse
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
//	Bei einem Fehler kommt es zur Exeption CAF_ERROR_WRITE (siehe m_cThrowWr)
int	__cdecl CArchiveFile::BaseWrite(void *pParam,const void *pMem,int iSize)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
char		   *pNewMem;
DWORD			dwBytes;
int				iRest;



	if(iSize<=0)return 0;

															
	if(!pThis->m_cSubActive)								// Ist eine Sub-Datei vorhanden
		{
		if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;
		return -1;
		}


	if(pThis->m_hSubFile==INVALID_HANDLE_VALUE)				// In Speicher schreiben
		{
		if(pThis->m_iSubEnd<0)								// Keine Schreiberlaubnis
			{
			dwBytes = 0;
			}
		else{
			   iRest = pThis->m_iSubLen-pThis->m_iSubPos;
			if(iRest<iSize)									// Sind zuwenige Bytes im Puffer
				{
				if(iRest<0)iRest=0;

				dwBytes = iRest;
				
				if(pThis->m_pSubFree)						// Gibt es dynamischen Speicher
					{
					   pNewMem = Realloc(pThis->m_pSubFree,pThis->m_iSubLen,pThis->m_iSubMax,iSize);
					if(pNewMem)
						{
						pThis->m_pSubPtr = pNewMem;			// Dynamischer Speicher wurde angelegt
						dwBytes			 = iSize;
						}
					}
				}
			else{
				dwBytes = iSize;
				}

															// Daten in Speicher kopieren
			memcpy(pThis->m_pSubPtr+pThis->m_iSubPos,pMem,dwBytes);	
			

			pThis->m_iSubPos += dwBytes;


			if(pThis->m_iSubEnd<pThis->m_iSubPos)
				{
				pThis->m_iSubEnd = pThis->m_iSubPos;
				}
			}
		}
	else{
		if(!WriteFile(pThis->m_hSubFile,pMem,iSize,&dwBytes,NULL))
			{
			dwBytes = 0;
			}
		}	



	if(dwBytes!=(unsigned)iSize)							// Konnte nicht alles geschrieben werden
		{
		if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;
		return -1;
		}




return dwBytes;
}


//*****************************************************************************
//*
//*		MainWrite
//*
//*****************************************************************************
//	Schreibt Daten in eine Datei.
//	pParam		: Zeiger auf die Instanz der Klasse
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
//	Bei einem Fehler kommt es zur Exeption CAF_ERROR_WRITE (siehe m_cThrowWr)
int	__cdecl CArchiveFile::MainWrite(void *pParam,const void *pMem,int iSize)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
char		   *pNewMem;
DWORD			dwBytes;
int				iRest;


	if(iSize<=0)return 0;


	if(pThis->m_hFile==INVALID_HANDLE_VALUE)				// In Speicher schreiben
		{	
		   iRest = pThis->m_iMemLen-pThis->m_iMemPos;
		if(iRest<iSize)										// Sind zuwenige Bytes im Puffer
			{
			if(iRest<0)iRest=0;

			if(pThis->m_pMemFree)							// Gibt es dynamischen Speicher
				{
					pNewMem = Realloc(pThis->m_pMemFree,pThis->m_iMemLen,pThis->m_iMemMax,iSize);
				if(!pNewMem)
					{
					if(!pThis->m_pTempSuffix)return -1;		// Umschalten auf temporre Datei

					try	{
						pThis->m_hFile = CreateTempFile(pThis->m_pBasePath,MAX_PATH,pThis->m_pTempSuffix);
						}
					catch(int iError)
						{
						if(pThis->m_cThrowWr)throw iError;
						return iError;
						}
															
					if(!WriteFile(pThis->m_hFile,pThis->m_pMemPtr,pThis->m_iMemEnd,&dwBytes,NULL) || dwBytes!=(unsigned)pThis->m_iMemEnd)
						{
						DeleteFile(pThis->m_pBasePath);
						if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;
						return -1;
						}
					
					pThis->m_iFileSize = dwBytes;			// Dynamischen Speicher freigeben
					delete pThis->m_pMemFree;

					pThis->m_pMemFree	= NULL;
					pThis->m_pMemPtr	= NULL;
					pThis->m_iMemLen	= 0;
					pThis->m_iMemPos	= 0;
					pThis->m_iMemEnd	= 0;

					goto File;
					}
				else{
					pThis->m_pMemPtr = pNewMem;
					goto IsOk;
					}
				}
			
			memcpy(pThis->m_pMemPtr+pThis->m_iMemPos,pMem,iRest);
			
			pThis->m_iMemPos	  = pThis->m_iMemLen;
			
			if(pThis->m_iMemEnd<pThis->m_iMemPos)
				{
				pThis->m_iMemEnd = pThis->m_iMemPos;
				}

			if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;

			return -1;
			}

IsOk:
															// Daten in Speicher kopieren	
		memcpy(pThis->m_pMemPtr+pThis->m_iMemPos,pMem,iSize);	
		
		pThis->m_iMemPos	 += iSize;

		if(pThis->m_iMemEnd<pThis->m_iMemPos)
			{
			pThis->m_iMemEnd = pThis->m_iMemPos;
			}



	return iSize;
	}

File:

	if(!WriteFile(pThis->m_hFile,pMem,iSize,&dwBytes,0))	// In die Datei schreiben
		{
		if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;
		return -1;
		}

	if(dwBytes!=(unsigned)iSize)							// Konnte nicht alles geschrieben werden
		{
		if(pThis->m_cThrowWr)throw CAF_ERROR_WRITE;
		return -1;
		}


return dwBytes;
}


//*****************************************************************************
//*
//*		FileWrite
//*
//*****************************************************************************
//	Schreibt Daten in eine Datei.
//	pParam		: Ist das Handle der Datei
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
int	__cdecl CArchiveFile::FileWrite(void *pParam,const void *pMem,int iSize)
{
DWORD	dwBytes;


	if(iSize<=0)return 0;


	if(!WriteFile(pParam,pMem,iSize,&dwBytes,0))			// In die Datei schreiben
		{
		return -1;
		}


return dwBytes;
}


//*****************************************************************************
//*
//*		DataWrite
//*
//*****************************************************************************
//	Schreibt Daten in einen Speicherbereich.
//	pParam		: Ist das Handle der Datei
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
int	__cdecl CArchiveFile::DataWrite(void *pParam,const void *pMem,int iSize)
{
MemInfo	   *pInfo=(MemInfo*)pParam;
int			iRest;


	if(iSize<=0)return 0;

	iRest = pInfo->iLen-pInfo->iPos;

	if(iRest<    0)iRest=0;
	if(iSize>iRest)iSize=iRest;

	memcpy(pInfo->pMem+pInfo->iPos,pMem,iSize);

	pInfo->iPos += iSize;


return iSize;
}


//*****************************************************************************
//*
//*		BaseRead
//*
//*****************************************************************************
//	Liet Daten aus der Unterdatei, aus einen Speicher oder aus einer Datei .
//	pParam		: Zeiger auf die Instanz der Klasse
//	pMem		: Zeiger auf den Lesepuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geschriebenen Bytes.
//	Bei einem Fehler kommt es zur Exeption CAF_ERROR_WRITE (siehe m_cThrowWr)
int	__cdecl CArchiveFile::BaseRead(void *pParam,void *pMem,int iSize)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
DWORD			dwBytes;
int				iRest;



	if(iSize<=0)return 0;
															// Ist eine Sub-Datei vorhanden

	if(!pThis->m_cSubActive)
		{
		if(pThis->m_cThrowRd)throw CAF_ERROR_WRITE;
		return -1;
		}


	if(pThis->m_hSubFile==INVALID_HANDLE_VALUE)
		{
		if(pThis->m_iSubEnd<0)								// Nur lesen
				iRest = pThis->m_iSubLen-pThis->m_iSubPos;
		else	iRest = pThis->m_iSubEnd-pThis->m_iSubPos;

		if(iRest<iSize)										// Sind genug Bytes im Puffer
				dwBytes = iRest;
		else	dwBytes = iSize;

															// Daten aus dem Speicher lesen
		memcpy(pMem,pThis->m_pSubPtr+pThis->m_iSubPos,dwBytes);	
			
		pThis->m_iSubPos += dwBytes;
		}
	else{
		if(!ReadFile(pThis->m_hSubFile,pMem,iSize,&dwBytes,NULL))
			{
			dwBytes = 0;
			}
		}	



	if(dwBytes!=(unsigned)iSize)							// Konnte nicht alles geschrieben werden
		{
		if(pThis->m_cThrowRd)throw CAF_ERROR_WRITE;
		}



return dwBytes;
}

//*****************************************************************************
//*
//*		MainRead
//*
//*****************************************************************************
//	Liest aus Daten aus der Datei.
//	pParam		: Zeiger auf die Instanz der Klasse
//	pMem		: Zeiger auf den Lesepuffer
//	iSize		: Anzahl der Bytes die gelesen werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geladenen Bytes.
//	Bei einem Fehler kommt es zur Exeption CAF_ERROR_READ (siehe m_cThrowRd)
int __cdecl CArchiveFile::MainRead(void *pParam,void *pMem,int iSize)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
DWORD			dwBytes;
int				iRest;


	if(iSize<=0)return 0;



	if(pThis->m_hFile==INVALID_HANDLE_VALUE)				// Lesen aus dem Speicher
		{
		if(pThis->m_iMemEnd<0)								// Nur lesen
				iRest = pThis->m_iMemLen-pThis->m_iMemPos;
		else	iRest = pThis->m_iMemEnd-pThis->m_iMemPos;

		if(iSize>iRest)										// Sind zuwenige Bytes im Puffer
			{
			if(iRest<0)iRest=0;
			
			memcpy(pMem,pThis->m_pMemPtr+pThis->m_iMemPos,iRest);
			
			pThis->m_iMemPos	  = pThis->m_iMemLen;
			
			if(pThis->m_cThrowRd)throw CAF_ERROR_READ;


			return iRest;
			}
															// Daten aus Speicher lesen
		memcpy(pMem,pThis->m_pMemPtr+pThis->m_iMemPos,iSize);	
		
		pThis->m_iMemPos	 += iSize;

		return iSize;
		}



	if(!ReadFile(pThis->m_hFile,pMem,iSize,&dwBytes,0))		// Aus Datei laden
		{
		if(pThis->m_cThrowRd)throw CAF_ERROR_READ;
		}

	if(pThis->m_cThrowRd && dwBytes!=(unsigned)iSize)		// Konnte nicht alles gelesen werden
		{
		throw CAF_ERROR_READ;
		}



return dwBytes;
}

//*****************************************************************************
//*
//*		ProcRead
//*
//*****************************************************************************
//	Lesefunktion fr groe Bereiche.
int __cdecl CArchiveFile::ProcRead(void *pParam,void *pMem,int iLen)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
int				iByte;


	if(iLen<=0)return 0;

	if(pThis->m_iReadPos+iLen>pThis->m_iReadMax)
		{
		iLen = (int)(pThis->m_iReadMax-pThis->m_iReadPos);
		}

	   iByte = pThis->m_pReadProc(pThis,pMem,iLen);
	if(iByte<=0)
		{
		return iByte;
		}

	pThis->m_iReadPos += iByte;


return iByte;
}


//*****************************************************************************
//*
//*		FileRead
//*
//*****************************************************************************
//	Liest aus Daten aus der Datei.
//	pParam		: Handle der datei
//	pMem		: Zeiger auf den Lesepuffer
//	iSize		: Anzahl der Bytes die gelesen werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die geladenen Bytes.
int __cdecl CArchiveFile::FileRead(void *pParam,void *pMem,int iSize)
{
DWORD	dwBytes;


	if(iSize<=0)return 0;


	if(!ReadFile(pParam,pMem,iSize,&dwBytes,0))				// Daten aus Datei laden
		{
		return 0;
		}


return dwBytes;
}


//*****************************************************************************
//*
//*		DataRead
//*
//*****************************************************************************
//	Liet Daten aus einen Speicherbereich.
//	pParam		: Ist das Handle der Datei
//	pMem		: Zeiger auf den Schreibpuffer
//	iSize		: Anzahl der Bytes die schrieben werden sollen
//	Ergibt -1 bei einem Fehler ansonsten die gelesenen Bytes.
int	__cdecl CArchiveFile::DataRead(void *pParam,void *pMem,int iSize)
{
MemInfo	   *pInfo=(MemInfo*)pParam;
int			iRest;


	if(iSize<=0)return 0;

	iRest = pInfo->iLen-pInfo->iPos;

	if(iRest<    0)iRest=0;
	if(iSize>iRest)iSize=iRest;

	memcpy(pMem,pInfo->pMem+pInfo->iPos,iSize);

	pInfo->iPos += iSize;


return iSize;
}


//*****************************************************************************
//*
//*		BaseSeek
//*
//*****************************************************************************
//	Setzt File-Pointer in der Unterdatei oder dem Unterspeicherbereich.
//	pParam		: Zeiger auf die Instanz der Klasse
//	iPos		: Neue Position fr den File-Pointer 
//	iMode		: Modus fr das verschiben:
//					SEEK_POS	0	Realtiv zum Dateianfang
//					SEEK_CUR	1	Realtiv zum jetzigen Position
//					SEEK_END	2	Realtiv zum Dateiende
//	Ergibt die aktuelle Leseposition der Datei oder -1 bei einem Fehler.
aint64 CArchiveFile::BaseSeek(void *pParam,aint64 iPos,int iMode)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
LONG			lHight;
DWORD			dwPos;


	if(!pThis->m_cSubActive)return -1;


	if(pThis->m_hSubFile==INVALID_HANDLE_VALUE)	
		{
		switch(iMode)
			{
		case SEEK_END:	pThis->m_iSubPos = pThis->m_iSubLen+(int)iPos;	break;
		case SEEK_CUR:	pThis->m_iSubPos+=					(int)iPos;	break;
		default:		pThis->m_iSubPos =					(int)iPos;	break;
			}

		if(pThis->m_iSubPos<0)pThis->m_iSubPos=0;


		return pThis->m_iSubPos;
		}


	switch(iMode)
			{												// Lesen aus Datei
	case SEEK_END:	iMode=FILE_END;			break;	
	case SEEK_CUR:	iMode=FILE_CURRENT;		break;
	default:		iMode=FILE_BEGIN;		break;
			}

	lHight = (LONG)(iPos>>32);
	dwPos  = SetFilePointer(pThis->m_hSubFile,(DWORD)iPos,&lHight,iMode);


	if(dwPos!=0xFFFFFFFF || GetLastError()==NO_ERROR)
		{
		iPos	= lHight;
		iPos  <<= 32;
		iPos   |= dwPos;	

		return iPos;
		}


return -1;
}


//*****************************************************************************
//*
//*		MainSeek
//*
//*****************************************************************************
//	Setzt File-Pointer in der Datei oder dem Speicherbereich.
//	pParam		: Zeiger auf die Instanz der Klasse
//	iPos		: Neue Position fr den File-Pointer 
//	iMode		: Modus fr das verschiben:
//					SEEK_POS	0	Realtiv zum Dateianfang
//					SEEK_CUR	1	Realtiv zum jetzigen Position
//					SEEK_END	2	Realtiv zum Dateiende
//	Ergibt die aktuelle Leseposition der Datei oder -1 bei einem Fehler.
aint64 CArchiveFile::MainSeek(void *pParam,aint64 iPos,int iMode)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
LONG			lHight;
DWORD			dwPos;




	if(pThis->m_hFile==INVALID_HANDLE_VALUE)				// Speicher benutzen
		{
		switch(iMode)
			{
		case SEEK_END:	pThis->m_iMemPos = pThis->m_iMemLen+(int)iPos;	break;
		case SEEK_CUR:	pThis->m_iMemPos+=					(int)iPos;	break;
		default:		pThis->m_iMemPos =					(int)iPos;	break;
			}

		if(pThis->m_iMemPos<0)pThis->m_iMemPos=0;

		return pThis->m_iMemPos;
		}


	switch(iMode)											// Datei benutzen
			{												
	case SEEK_END:	iMode=FILE_END;			break;	
	case SEEK_CUR:	iMode=FILE_CURRENT;		break;
	default:		iMode=FILE_BEGIN;		break;
			}

	lHight = (LONG)(iPos>>32);
	dwPos  = SetFilePointer(pThis->m_hFile,(DWORD)iPos,&lHight,iMode);


	if(dwPos!=0xFFFFFFFF || GetLastError()==NO_ERROR)
		{
		iPos	= lHight;
		iPos  <<= 32;
		iPos   |= dwPos;	

		return iPos;
		}


return -1;
}


//*****************************************************************************
//*
//*		BaseTell
//*
//*****************************************************************************
//	Ergibt die aktuelle Leseposition der Unterdatei oder -1 bei einem Fehler.
aint64 CArchiveFile::BaseTell(void *pParam)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
LONG			lHight;
DWORD			dwPos;
aint64			iPos;



	if(!pThis->m_cSubActive)return -1;


	if(pThis->m_hSubFile==INVALID_HANDLE_VALUE)	
		{
		return pThis->m_iSubPos;
		}

	lHight	= 0;
	dwPos	= SetFilePointer(pThis->m_hSubFile,0,&lHight,FILE_CURRENT);

	if(dwPos!=0xFFFFFFFF || GetLastError()==NO_ERROR)	
		{
		iPos	= lHight;
		iPos  <<= 32;
		iPos   |= dwPos;	

		return iPos;
		}



return -1;
}

//*****************************************************************************
//*
//*		MainTell
//*
//*****************************************************************************
//	Ergibt die aktuelle Leseposition der Hauptdatei oder -1 bei einem Fehler.
aint64 CArchiveFile::MainTell(void *pParam)
{
CArchiveFile   *pThis=(CArchiveFile*)pParam;
LONG			lHight=0;
DWORD			dwPos;
aint64			iPos;


	if(pThis->m_hFile==INVALID_HANDLE_VALUE)				// Speicher benutzen
		{
		return pThis->m_iMemPos;
		}

	dwPos = SetFilePointer(pThis->m_hFile,0,&lHight,FILE_CURRENT);

	if(dwPos!=0xFFFFFFFF || GetLastError()==NO_ERROR)	
		{
		iPos	= lHight;
		iPos  <<= 32;
		iPos   |= dwPos;	

		return iPos;
		}


return -1;
}

//*****************************************************************************
//*
//*		BaseSize
//*
//*****************************************************************************
//	Dateigre der Unterdatei auslesen.
aint64 CArchiveFile::BaseSize()
{
	
	if(!m_cSubActive)return 0;

	if(m_hSubFile==INVALID_HANDLE_VALUE)
		{
		if(m_iSubEnd>=0)return m_iSubEnd;
		return m_iSubLen;
		}


return GetFileSize(m_hSubFile);
}

//*****************************************************************************
//*
//*		MainSize
//*
//*****************************************************************************
//	Dateigre der Hauptdatei auslesen.
aint64 CArchiveFile::MainSize()
{

	if(m_hFile==INVALID_HANDLE_VALUE)
		{
		if(m_iMemEnd>=0)return m_iMemEnd;
		
		return m_iMemLen;
		}
	       

return GetFileSize(m_hFile);
}

//*****************************************************************************
//*
//*		InitSubFile
//*
//*****************************************************************************
//	Die aktuelle Datei als Unterdatei benutzen.
void CArchiveFile::InitSubFile()
{

	if(m_cSubActive)throw CAF_ERROR_LOGIC;

	m_cSubActive	= 1;
	m_pSubFree		= m_pMemFree;			
	m_pSubPtr		= m_pMemPtr;			
	m_iSubLen		= m_iMemLen;			
	m_iSubPos		= m_iMemPos;			
	m_iSubEnd		= m_iMemEnd;			
	m_iSubMax		= m_iMemMax;			
	m_hSubSrc		= m_hResSrc;			
	m_hSubHg		= m_hResHg;				
	m_iSubMode		= m_iOpenMode;
	m_iSubSize		= m_iFileSize;			
	m_hSubFile		= m_hFile;				
											
	m_pMemFree		= 0;
	m_pMemPtr		= 0;			
	m_iMemLen		= 0;			
	m_iMemPos		= 0;			
	m_iMemEnd		= 0;			
	m_hResSrc		= 0;			
	m_hResHg		= 0;			
	m_iFileSize		= 0;			
	m_hFile			= INVALID_HANDLE_VALUE;			
	m_iOpenMode		= CAF_CLOSED;
									
}																														


//*****************************************************************************
//*
//*		CreateTempFile
//*
//*****************************************************************************
//	Erzeugt eine temorre TAR-Datei
//	pBuffer		: Zeiger auf buffer fr Dateinamen
//	iSize		: Gre des Puffers in Zeichen
//	pSuffix		: Ist das Datei-Suffix (z.B. "zip")
//	Ergibt das Handle auf die Datei
void *CArchiveFile::CreateTempFile(zchar *pBuffer,int iSize,const zchar *pSuffix)
{
zchar	cPath[MAX_PATH];
HANDLE	hTemp;


	if(m_pTempPath)											// Gibt es einen globalen Pfad
		{
		GetTempFileName(m_pTempPath,Z("AF_"),0,pBuffer);
		}
	else{													// Temporren Pfad benutzen
		GetTempPath(iSize-32,cPath);
		GetTempFileName(cPath,Z("AF_"),0,pBuffer);
		}

	#ifdef _DEBUG
	
	if(pSuffix)
		{
		int		iLen;
		DeleteFile(pBuffer);
		iLen = strzlen(pBuffer);
		strlcpy(pBuffer+iLen,pSuffix,iSize-iLen,16);
		}
	
	#endif 	

	   hTemp=CreateFile(pBuffer,GENERIC_READ|GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if(hTemp==INVALID_HANDLE_VALUE)
		{
		throw CAF_ERROR_FCREATE;
		}


return hTemp;
}

//*****************************************************************************
//*
//*		EndOfFile
//*
//*****************************************************************************
//	Leseposition als Dateiende festlegen
//	iUseSub		: Die Sub-Datei benutzen
void CArchiveFile::EndOfFile(int iUseSub)
{
char		   *pNewMem;
DWORD			dwBytes;
int				iOld;


	if(iUseSub)
		{
		if(!m_cSubActive)return;

		if(m_hSubFile!=INVALID_HANDLE_VALUE)
			{
			SetEndOfFile(m_hSubFile);
			return;
			}

		if(m_iSubEnd==NULL)									// Kann der Speicher wachsen
			{
			return;
			}

		iOld = m_iSubPos;

		   m_iSubEnd =m_iSubPos;
		if(m_iSubEnd<=m_iSubLen)
			{
			return;
			}

		if(m_pSubFree==NULL)
			{												// Kein dynamischen Speicher
			m_iSubEnd = m_iSubLen;
			if(m_cThrowWr)throw CAF_ERROR_WRITE;
			return; 
			}									

		   pNewMem = Realloc(m_pSubFree,m_iSubLen,m_iSubMax,m_iSubEnd-m_iSubLen);
		if(pNewMem)
			{
			m_pSubPtr = pNewMem;
			return;
			}

		if(!m_pTempSuffix)									// Umschalten auf temporre Datei
			{
			m_iSubEnd = m_iSubLen;
			if(m_cThrowWr)throw CAF_ERROR_WRITE;
			return;
			}

		try	{
			m_hSubFile = CreateTempFile(m_pBasePath,MAX_PATH,m_pTempSuffix);
			}
		catch(int iError)
			{
			m_iSubEnd = m_iSubLen;
			if(m_cThrowWr)throw iError;
			return;
			}

		if(iOld>m_iSubEnd)iOld=m_iSubEnd;
															// Den Speicher in die Datei geben											
		if(!WriteFile(m_hSubFile,m_pSubPtr,iOld,&dwBytes,NULL) || dwBytes!=(unsigned)iOld)
			{
			m_iSubEnd = m_iSubLen;
			DeleteFile(m_pBasePath);
			if(m_cThrowWr)throw CAF_ERROR_WRITE;
			return;
			}
		
		SetFilePointer(m_hSubFile,m_iSubEnd,NULL,FILE_BEGIN);
		SetEndOfFile  (m_hSubFile);
		
		m_iSubSize  = dwBytes;								// Dynamischen Speicher freigeben
		delete m_pSubFree;

		m_pSubFree	= NULL;
		m_pSubPtr	= NULL;
		m_iSubLen	= 0;
		m_iSubPos	= 0;
		m_iSubEnd	= 0;
		}
	else{
		if(m_hFile!=INVALID_HANDLE_VALUE)
			{
			SetEndOfFile(m_hFile);
			return;
			}

		if(m_iMemEnd==NULL)									// Kann der Speicher wachsen
			{
			return;
			}

		iOld = m_iMemPos;

		   m_iMemEnd =m_iMemPos;
		if(m_iMemEnd<=m_iMemLen)
			{
			return;
			}

		if(m_pMemFree==NULL)
			{												// Kein dynamischen Speicher
			m_iMemEnd = m_iMemLen;
			if(m_cThrowWr)throw CAF_ERROR_WRITE;
			return; 
			}									

		   pNewMem = Realloc(m_pMemFree,m_iMemLen,m_iMemMax,m_iMemEnd-m_iMemLen);
		if(pNewMem)
			{
			m_pMemPtr = pNewMem;
			return;
			}

		if(!m_pTempSuffix)									// Umschalten auf temporre Datei
			{
			m_iMemEnd = m_iMemLen;
			if(m_cThrowWr)throw CAF_ERROR_WRITE;
			return;
			}

		try	{
			m_hFile = CreateTempFile(m_pBasePath,MAX_PATH,m_pTempSuffix);
			}
		catch(int iError)
			{
			m_iMemEnd = m_iMemLen;
			if(m_cThrowWr)throw iError;
			return;
			}

		if(iOld>m_iMemEnd)iOld=m_iMemEnd;
															// Den Speicher in die Datei geben											
		if(!WriteFile(m_hFile,m_pMemPtr,iOld,&dwBytes,NULL) || dwBytes!=(unsigned)iOld)
			{
			m_iMemEnd = m_iMemLen;
			DeleteFile(m_pBasePath);
			if(m_cThrowWr)throw CAF_ERROR_WRITE;
			return;
			}
		
		SetFilePointer(m_hFile,m_iMemEnd,NULL,FILE_BEGIN);
		SetEndOfFile  (m_hFile);
		
		m_iFileSize = dwBytes;								// Dynamischen Speicher freigeben
		delete m_pMemFree;

		m_pMemFree	= NULL;
		m_pMemPtr	= NULL;
		m_iMemLen	= 0;
		m_iMemPos	= 0;
		m_iMemEnd	= 0;
		}


}

//*****************************************************************************
//*
//*		ZeroFile
//*
//*****************************************************************************
//	Eine Datei auf die Gre 0 setzen
//	iUseSub		: Die Sub-Datei benutzen
void CArchiveFile::ZeroFile(int iUseSub)
{

	if(iUseSub)											// Sub-Datei benutzen	
		{
		if(!m_cSubActive)return;

		if(m_hSubFile==INVALID_HANDLE_VALUE)
			{
			if(m_iSubEnd<0)return;

			m_iSubPos = 0;
			m_iSubEnd = 0;
			}
		else{
			SetFilePointer(m_hSubFile,0,NULL,FILE_BEGIN);
			SetEndOfFile  (m_hSubFile);
			}

		m_iSubSize = 0;
		}
	else{												// Normale Datei benutzen
		if(m_hFile==INVALID_HANDLE_VALUE)
			{
			if(m_iMemEnd<0)return;

			m_iMemPos = 0;
			m_iMemEnd = 0;
			}
		else{
			SetFilePointer(m_hFile,0,NULL,FILE_BEGIN);
			SetEndOfFile  (m_hFile);
			}

		m_iFileSize = 0;
		}

}

//*****************************************************************************
//*
//*		Flush
//*
//*****************************************************************************
//	Alle Dateien im Archiv speichern
//	Ergibt CAF_ERROR_OK wenn erfolgreich, oder eine Fehlernummer ungleich 0.
int	CArchiveFile::Flush()
{
return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		DoChange
//*
//*****************************************************************************
//	Schreiberlaubnis aktivieren oder deaktivieren.
//	iMode		: Ist der neue Modus (CAF_WRITE oder CAF_READ)
//	iFlush		: Beim Modus CAF_READ immer Flush() ausfhren
//	Ergibt CAF_ERROR_OK wenn erfolgreich, oder eine Fehlernummer ungleich 0.
int CArchiveFile::DoChange(int iMode,int iFlush)
{
const zchar *pPath;


	pPath = (m_cSubActive)? m_pBasePath:m_cFilePath;


//******************** Ab jetzt ist schreiben *********************************


	if(iMode==CAF_WRITE)								
		{
		if(!m_cHasCompress)								// Nur Lesen erlaubt
			{
			m_iErrorCode = CAF_ERROR_NOTSUPP;
			return         CAF_ERROR_NOTSUPP;
			}

		switch(m_iOpenMode)								// Prfe den neuen Modus
			{
		default:
		case CAF_CLOSED:	m_iErrorCode = CAF_ERROR_NOTOPEN;
							return         CAF_ERROR_NOTOPEN;
		case CAF_CREATE:
		case CAF_WRITE:		m_iErrorCode = CAF_ERROR_MODE;
							return         CAF_ERROR_MODE;

		case CAF_READ:		break;
			}


		if(m_pMemPtr)									// Ist ein Speicherbereich geffnet
			{
			if(m_iMemEnd<0)								// Nur Lesen
				{
				m_iErrorCode = CAF_ERROR_FOPEN;
				return         CAF_ERROR_FOPEN;
				}

			m_iMemPos	 = 0;							// Neuen Modus setzen	
			m_iOpenMode	 = CAF_WRITE;
			m_iErrorCode = CAF_ERROR_OK;
			return         CAF_ERROR_OK;
			}


		CloseHandle(m_hFile);

														// Die Datei mit Lese- und Schreibrechren neu ffnen
		   m_hFile=CreateFile(pPath,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(m_hFile==INVALID_HANDLE_VALUE)
			{
			m_iErrorCode = CAF_ERROR_OPEN;
			}
		else{
			m_iErrorCode = CAF_ERROR_OK;
			m_iOpenMode	 = CAF_WRITE;					// Neuen Dateimodus setzen	
			}

		return m_iErrorCode;
		}
	   

//******************** Wieder auf Read-Only ***********************************


	if(iMode==CAF_READ)
		{
		switch(m_iOpenMode)								// Prfe den neuen Modus
			{
		default:
		case CAF_CLOSED:	m_iErrorCode = CAF_ERROR_NOTOPEN;
							return         CAF_ERROR_NOTOPEN;
		case CAF_READ:
							m_iErrorCode = CAF_ERROR_MODE;
							return         CAF_ERROR_MODE;
		case CAF_CREATE:
		case CAF_WRITE:		break;
			}


		if(iFlush)										// Alle Dateien in Archiv speichern
			{
			   m_iErrorCode = Flush();					
			if(m_iErrorCode!=CAF_ERROR_OK)
				{
				return m_iErrorCode;
				}
			}

		if(m_pMemPtr)									// Ist ein Speicherbereich geffnet
			{
			m_iMemPos	 = 0;
			m_iOpenMode	 = CAF_READ;
			m_iErrorCode = CAF_ERROR_OK;
			return         CAF_ERROR_OK;
			}


		CloseHandle(m_hFile);
														// Die Datei nur mit Leserechren neu ffnen
		   m_hFile=CreateFile(pPath,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(m_hFile==INVALID_HANDLE_VALUE)
			{
			m_iErrorCode = CAF_ERROR_OPEN;
			return    	   CAF_ERROR_OPEN;
			}
		
		m_iOpenMode	 = CAF_READ;						// Neuen Modus setzen		
		m_iErrorCode = CAF_ERROR_OK;
		return         CAF_ERROR_OK;
		}


//******************** Falscher Modus *****************************************


	m_iErrorCode = CAF_ERROR_MODE;



return CAF_ERROR_MODE;
}

//*****************************************************************************
//*
//*		DoChangeSub
//*
//*****************************************************************************
//	Schreiberlaubnis aktivieren oder deaktivieren bei der Unterdatei.
//	iMode		: Ist der neue Modus (CAF_WRITE oder CAF_READ)
//	iFlush		: Beim Modus CAF_READ immer Flush() ausfhren
//	Ergibt CAF_ERROR_OK wenn erfolgreich, oder eine Fehlernummer ungleich 0.
int CArchiveFile::DoChangeSub(int iMode,int iFlush)
{
	
	
	if(!m_cSubActive)
		{
		m_iErrorCode = CAF_ERROR_LOGIC;
		return         CAF_ERROR_LOGIC;
		}


//******************** Ab jetzt ist schreiben *********************************


	if(iMode==CAF_WRITE)								
		{
		if(!m_cHasCompress)								// Nur Lesen erlaubt
			{
			m_iErrorCode = CAF_ERROR_NOTSUPP;
			return         CAF_ERROR_NOTSUPP;
			}

		switch(m_iSubMode)								// Prfe den neuen Modus
			{
		default:
		case CAF_CLOSED:	m_iErrorCode = CAF_ERROR_NOTOPEN;
							return         CAF_ERROR_NOTOPEN;
		case CAF_CREATE:
		case CAF_WRITE:		m_iErrorCode = CAF_ERROR_MODE;
							return         CAF_ERROR_MODE;

		case CAF_READ:		break;
			}


		if(m_pSubPtr)									// Ist ein Speicherbereich geffnet
			{
			if(m_iSubEnd<0)								// Nur Lesen
				{
				m_iErrorCode = CAF_ERROR_FOPEN;
				return         CAF_ERROR_FOPEN;
				}

			m_iSubPos	 = 0;
			m_iSubMode	 = CAF_WRITE;					// Neuen Modus setzen	
			m_iErrorCode = CAF_ERROR_OK;
			return         CAF_ERROR_OK;
			}


		CloseHandle(m_hSubFile);
		
														// Die Datei mit Lese- und Schreibrechren neu ffnen
		   m_hSubFile=CreateFile(m_cFilePath,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(m_hSubFile==INVALID_HANDLE_VALUE)
			{
			m_iErrorCode = CAF_ERROR_OPEN;
			}
		else{
			m_iErrorCode = CAF_ERROR_OK;
			m_iSubMode	 = CAF_WRITE;					// Neuen Modus setzen	
			}


		return m_iErrorCode;
		}


//******************** Wieder auf Read-Only ***********************************


	if(iMode==CAF_READ)
		{
		switch(m_iSubMode)								// Prfe den neuen Modus
			{
		default:
		case CAF_CLOSED:	m_iErrorCode = CAF_ERROR_NOTOPEN;
							return         CAF_ERROR_NOTOPEN;
		case CAF_READ:
							m_iErrorCode = CAF_ERROR_MODE;
							return         CAF_ERROR_MODE;
		case CAF_CREATE:
		case CAF_WRITE:		break;
			}


		if(iFlush)										// Alle Dateien in Archiv speichern
			{
			   m_iErrorCode = Flush();					
			if(m_iErrorCode!=CAF_ERROR_OK)
				{
				return m_iErrorCode;
				}
			}

		if(m_pSubPtr)									// Ist ein Speicherbereich geffnet
			{
			m_iSubPos	 = 0;
			m_iSubMode	 = CAF_READ;
			m_iErrorCode = CAF_ERROR_OK;
			return         CAF_ERROR_OK;
			}


		CloseHandle(m_hSubFile);
														// Die Datei nur mit Leserechren neu ffnen
		   m_hSubFile=CreateFile(m_cFilePath,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(m_hSubFile==INVALID_HANDLE_VALUE)
			{
			m_iErrorCode = CAF_ERROR_OPEN;
			return    	   CAF_ERROR_OPEN;
			}
		
		m_iSubMode 	 = CAF_READ;						// Neuen Modus setzen	
		m_iErrorCode = CAF_ERROR_OK;
		return		   CAF_ERROR_OK;
		}



//******************** Falscher Modus *****************************************


	m_iErrorCode = CAF_ERROR_MODE;



return CAF_ERROR_MODE;
}

//*****************************************************************************
//*
//*		SetOutput
//*
//*****************************************************************************
//	Ausgabe IO fr eine Compressor setzen
//	pIo		: Zeiger auf den Compressor
//	iSub	: Die Unterdatei benutzen (CAF_MAIN=0 CAF_BASE=1)
//	uCrc	: Ist der Start-CRC-Wert (0x12345678=keine Berechnung)
void CArchiveFile::SetOutput(CIoCallbacks *pIo,int iSub,unsigned uCrc)
{

	if(iSub)
		{
		if(!m_cSubActive)throw CAF_ERROR_LOGIC;

		if(m_hSubFile!=INVALID_HANDLE_VALUE)			// Schreibe in Datei
			{
			pIo->SetOut(m_hSubFile,-1,uCrc);
			}
		else if(m_pSubFree)								// Schreibe in dynamischen Speicher 
			{
			pIo->SetOut(this,BaseWrite,uCrc);
			}
		else{											// Schreibe in Speicher 
			pIo->SetOut(m_iSubLen-m_iSubPos,m_pSubPtr+m_iSubPos,uCrc,&m_iSubPos);

			if(m_iSubEnd>=0)
				{
				pIo->SetOutEnd(&m_iSubEnd);
				}
			}
		}
	else{
		if(m_hFile!=INVALID_HANDLE_VALUE)				// Schreibe in Datei
			{
			pIo->SetOut(m_hFile,-1,uCrc);
			}
		else if(m_pMemFree)								// Schreibe in dynamischen Speicher 
			{
			pIo->SetOut(this,MainWrite,uCrc);
			}
		else{											// Schreibe in fixen Speicher 
			pIo->SetOut(m_iMemLen-m_iMemPos,m_pMemPtr+m_iMemPos,uCrc,&m_iMemPos);

			if(m_iMemEnd>=0)
				{
				pIo->SetOutEnd(&m_iMemEnd);
				}
			}
		}

}

//*****************************************************************************
//*
//*		SetInput
//*
//*****************************************************************************
//	Eingabe IO fr eine Compressor setzen
//	pIo		: Zeiger auf den Compressor
//	iSub	: Die Unterdatei benutzen (CAF_MAIN=0 CAF_BASE=1)
//	iLen	: Ist die Lnge in Byte (-1=automatisch)
//	uCrc	: Ist der Start-CRC-Wert (0x12345678=keine Berechnung)
void CArchiveFile::SetInput(CIoCallbacks *pIo,int iSub,aint64 iLen,unsigned uCrc)
{
int		iMax;


	if(iSub)
		{
		if(!m_cSubActive)throw CAF_ERROR_LOGIC;

		if(m_hSubFile==INVALID_HANDLE_VALUE)			// Lese aus Speicher
			{
			if(iLen<0)
				{
				iLen  =(m_iSubEnd>=0)? m_iSubEnd:m_iSubLen;
				iLen -= m_iSubPos;
				}
			else{
				iMax  =(m_iSubEnd>=0)? m_iSubEnd:m_iSubLen;
				iMax -= m_iSubPos;
				
				if(iLen>iMax)iLen=iMax;
				}

			pIo->SetIn((int)iLen,m_pSubPtr+m_iSubPos,uCrc,&m_iSubPos);
			}
		else if(iLen>0x7FFFFFF0)						// Groe Blcke ab 2GB
			{
			m_iReadPos	= 0;
			m_iReadMax	= iLen;
			m_pReadProc	= BaseRead;

			pIo->SetIn(this,ProcRead,uCrc);
			}
		else{
			pIo->SetIn(m_hSubFile,(int)iLen,uCrc);		// Lese aus Datei
			}
		}
	else{
		if(m_hFile==INVALID_HANDLE_VALUE)				// Lese aus Speicher
			{
			if(iLen<0)
				{
				iLen  =(m_iMemEnd>=0)? m_iMemEnd:m_iMemLen;
				iLen -= m_iMemPos;
				}
			else{
				iMax  =(m_iMemEnd>=0)? m_iMemEnd:m_iMemLen;
				iMax -= m_iMemPos;
				
				if(iLen>iMax)iLen=iMax;
				}

			pIo->SetIn((int)iLen,m_pMemPtr+m_iMemPos,uCrc,&m_iMemPos);
			}
		else if(iLen>0x7FFFFFF0)						// Groe Blcke ab 2GB
			{
			m_iReadPos	= 0;
			m_iReadMax	= iLen;
			m_pReadProc	= MainRead;

			pIo->SetIn(this,ProcRead,uCrc);
			}
		else{												
			pIo->SetIn(m_hFile,(int)iLen,uCrc);			// Lese aus Datei
			}
		}

}

//*****************************************************************************
//*
//*		GetMemSize
//*
//*****************************************************************************
//	Gre des Speichers abfragen. Bei dynamischen Speicher wird auch der Zeiger
//	auf den Zeiger Speicher geholt. Das geht nur wenn das Archiv geschlossen ist.
//	pMem	: Hier wird der dynamischen Speicher gespeichert (*(void**)pMem=...)
//	iGrap	: Soll der dynamischen Speicher losgelst werden. Dann wird er von 
//			  der Klasse nicht freigegeben.
//	Ergibt die Gre des Speichers. 
int CArchiveFile::GetMemSize(void *pMem,int iGrap)
{

	if(pMem)*(void**)pMem=0; 
	
	if(m_iOpenMode==CAF_CLOSED)
		{
		if(!pMem && m_pMemFree)							// Zeiger auf dynamischen Speicher holen
			{
			*(void**)pMem=m_pMemFree; 		

			if(iGrap)									// Den Speicherzeiger loslsen
				{
				m_pMemFree	= NULL;
				m_pMemPtr	= NULL;
				m_iMemLen	= 0;
				m_iMemEnd	= 0;
				m_iMemPos	= 0;
				}
			}

		return m_iMemLen;
		}

	
	if(m_cSubActive)
		{
		if(m_hSubFile!=INVALID_HANDLE_VALUE)
			{
			return 0;
			}

		if(m_iSubEnd>=0)
				return m_iSubEnd;
		else	return m_iSubLen;
		}
	else if(m_hFile==INVALID_HANDLE_VALUE)
		{
		if(m_iMemEnd>=0)
				return m_iMemEnd;
		else	return m_iMemLen;
		}
	

return 0;
}

//*****************************************************************************
//*
//*		AllLen
//*
//*****************************************************************************
// Die Gre aller Dateien im Archiv abfragen.
aint64 CArchiveFile::AllLen()
{
int		iCount;
aint64	iSize;


	iSize  = 0;
	iCount = Count();

	while(iCount>0)
		{
		iCount--;
		iSize += Len(iCount);
		}


return iSize;
}


//*****************************************************************************
//*
//*		ArchiveType
//*
//*****************************************************************************
//	Prft ob ein Dateiname ein Archiv ist.
//	pName		: Ist der Dateiname
//	Ergibt 0 wenn kein Archiv bzw. grer 0 wenn es ein Archiv ist.
int CArchiveFile::ArchiveType(const zchar *pName)
{
return CmpFileType(pName,SPEZIAL_STR);
}


//*****************************************************************************
//*
//*		CharToPath
//*
//*****************************************************************************
//	Konvertiert '\' zu '/' in einem Dateinamen.
//	pName	: Zeiger auf den Dateinamen
void CArchiveFile::CharToPath(zchar *pName)
{
register zchar 	*pPtr=pName;


	for(;*pPtr;pPtr++)
		{
		if(*pPtr== 0  )break;
		if(*pPtr!='\\')continue;
		   *pPtr ='/';
		}

}


//*****************************************************************************
//*
//*		Realloc
//*
//*****************************************************************************
//	Einen Speicherbereich vergrern.
//	pMem		: Hier wird der aktuelle Zeiger gespeichert
//	iSize		: Hier liegt die aktuelle Gre in Byte
//	iMax		: Das ist die maximale Gre in Byte
//	iAdd		: Um wievile Bytes muss der Speicherbereich minimal wachsen
//	Ergibt einen Zeiger auf den neuen Speicherbereich, oder 0 bei einem Fehler.
char *CArchiveFile::Realloc(charptr &pMem,int &iSize,int iMax,int iAdd)
{
char   *pPtr;
char   *pOld;
int		iNew;
int		iMin;



	   iMin = iSize+iAdd;
	if(iMin>iMax)												// Gehtsich dass noch aus
		{
		return NULL;
		}

	iNew	= iSize;
	iNew   += iNew/2+0x10000;

	if(iNew<iMin)
		{
		iNew = iMin+4096;
		}

	if(iNew>iMax)
		{
		   iNew = iMax;
		if(iNew<=iSize)											// Haben wir die maximale Gre schon erreicht
			{
			return NULL;
			}
		}

		pPtr = new char[iNew+16];
	if(!pPtr)													// Zuwenig Speicher
		{
		return 0;
		}

	pOld	= pMem;

	memcpy(pPtr,pOld,iSize);

	pMem	= pPtr;
	iSize	= iNew;

	delete pOld;



return pPtr;
}

//*****************************************************************************
//*
//*		SetMemSub
//*
//*****************************************************************************
//	Erstellt einen dynamischen Speicher mit weiterer Dateiumleitung
//	iMin		: Ist die minimale Speichergre
//	iMax		: Ist die maximale Speichergre
//	pName		: Speicher fr den Namen der temporren Datei
//	pSuffix		: Suffix fr die Dateiumleitung
void CArchiveFile::SetMemSub(int iMin,int iMax,zchar *pName,const zchar *pSuffix)
{

	if(m_cSubActive==0)throw CAF_ERROR_LOGIC;
	if(m_pMemPtr   !=0)throw CAF_ERROR_LOGIC;


	if(iMin<0x20000)iMin=0x20000;
	
	if(iMin>iMax)
		{
		m_hFile		= CreateTempFile(pName,MAX_PATH,pSuffix);
		m_pBasePath = pName;
		m_iFileSize = 0;
		return;
		}

	
	m_pMemFree		= new char[iMin+16];
	
	if(!m_pMemFree)throw CAF_ERROR_MEM;	

	pName[0]		= 0;
	m_pBasePath		= pName;
	m_pTempSuffix	= pSuffix;
	m_pMemPtr		= m_pMemFree;
	m_iMemLen		= iMin;
	m_iMemMax		= iMax;
	m_iMemEnd		= 0;
	m_iMemPos		= 0;
	m_iFileSize		= 0;
	pName[0]		= 0;


}

//*****************************************************************************
//*
//*		ExtractAll
//*
//*****************************************************************************
//	Extrahiert alle Dateien eines Archives in ein Verszeichniss.
//	pPath	: Ist der Pfad des Verszeichnisses. Ist der Pfad mit  einem 
//			  '\' abgeschlossen so wird die Datei im pPathName gespeichert
//			  Ist der Pfad ohne einem '\' abgeschlossen eine neue Datei mit 
//			  dem Namen pPathName erzeugt.
//	pErrNum	: Hier werden die Anzahl an Fehler gespeichert welche einzelne 
//				  die Dateien betreffen.
//	Ergibt 0 wenn ok oder eine Fehlernummer:
//					CAF_ERROR_OK		= Wenn alles korrekt war
//					CAF_ERROR_PATH		= Pfad ungltig ist.
//					CAF_ERROR_FCREATE	= Wenn Datei nicht erzeugt werden konnte
//					CAF_ERROR_CRC		= Crc32 Fehler
//					CAF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//					CAF_ERROR_MISS		= Datei wurde aus Archiv gelscht
//					... siehe Fehler Codes
int	CArchiveFile::ExtractAll(const zchar *pPath,int *pErrNum)
{
zchar	cTemp[MAX_PATH];
int		iError;
int		iCount;
int		iStat;
int		iPos;
int		iRet;
int		iNum;


	SetDoneMode(2);												// Modus fr Done setzen

	if(pErrNum)*pErrNum=0;

	if(m_iOpenMode==CAF_CLOSED)									// Ist das Archiv geffnet
		{
		m_iErrorCode = CAF_ERROR_MISS;
		PROGN(CAF_PROG_ERROR,-1);
		return CAF_ERROR_MISS;
		}

	if(pPath)													// Verhindern das der Pfad ohne '//' endet 
		{
		   iNum	= strzlen(pPath);
		if(iNum>0 && pPath[iNum-1]!='\\' &&  pPath[iNum-1]!='/')
			{
			memcpy(cTemp,pPath,iNum*sizeof(zchar));
			cTemp[iNum  ] = '/';
			cTemp[iNum+1] = 0;
			pPath = cTemp;
			}
		}
	else if(!*pPath)
		{
		pPath = Z("./");
		}
	
	iNum	= 0;
	iCount	= Count();
	iError	= CAF_ERROR_OK;
													
	for(iPos=0;iPos<iCount;iPos++)								// Aklle Dateien des Archives durchlaufen
		{												
		iStat = Stats(iPos);
		
		if( (iStat&CAF_STAT_DELETE))continue;					// Wurde die Datei aus dem Archiv gelscht
		if(!(iStat&CAF_STAT_SAVED ))continue;					// Ist die Datei noch nicht im Archiv gespeichert
		
		   iRet= Extract(iPos,pPath);
		if(iRet==CAF_ERROR_BREAK )break;
		if(iRet==CAF_ERROR_IGNORE)continue;
		if(iRet==CAF_ERROR_MISS  )continue;
		if(iRet==CAF_ERROR_OK    )continue;
		
		iError = iRet;
		iNum  += 1; 
		}

	SetDoneMode(0);												// Modus fr Done zurcksetzen

	m_iErrorCode = iError;
	
	if(pErrNum)*pErrNum=iNum;


return iError;
}


//*****************************************************************************
//*
//*		Extract
//*
//*****************************************************************************
//	Extrahiert eine Datei aus dem Archiv mit einer Nummer.
//	iNum	: Ist die Nummer der Datei im Archiv
//	pPath	: Ist der Pfad in dem die Datei extrahiert wird wenn der Pfad mit
//			  einem '\' Zeihen abgeschlossen ist, oder es ist der Dateiname mit 
//			  dem die Archiv-Datei extrahiert wird ohen einem '\' Zeichen.
//			  Ist das Flag CAF_FLAG_NEW gesetzt so wird eine vorhanden Datei 
//		      nur berschrieben wenn sie lter ist.
//			  Ist das Flag CAF_FLAG_NOEXIST	gesetzt so werden vorhandene 
//			  Dateien niemals berschrieben.
//			  Ist das Flag CAF_FLAG_NOREADONLY gesetzt so wird eine vorhanden 
//			  Datei nur berschrieben wenn sie nicht schreibgeschtzt ist.
//			  ber IsOk() kann abgefragt werden ob die Aktion erfolgreich war.
//	Ergibt 0 wenn ok, oder eine Fehlernummer ungleich 0:
//				CAF_ERROR_OK		= Wenn alles korrekt war
//				CAF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//				CAF_ERROR_PATH		= Pfad ungltig ist.
//				CAF_ERROR_FCREATE	= Wenn Datei nicht erzeugt werden konnte
//				CAF_ERROR_CRC		= Crc32 Fehler
//				CAF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//				CAF_ERROR_IGNORE	= Die Datei wurde bersprungen
//				... siehe Fehler Codes
int	CArchiveFile::Extract(int iNum,const zchar *pPath)
{
zchar			cName[MAX_PATH+256];
zchar		   *pName;
HANDLE			hFile;
FileData		sInfo;
FfUtc			uTime;
int				iStat;
int				iMode;
int				iLen;
int				iOff;
int				iRet;



	if(!pPath || !*pPath)									// Aktuelles verzeichnis verwenden
		{
		pPath = Z(".\\");
		}


	iMode		 = SetDoneMode(1);
	m_iErrorCode = CAF_ERROR_OK;
	m_pErrorFile = NULL;	

	try	{
		PROG (CAF_PROG_READ ,iNum);
		PROGR(CAF_PROG_QUERY,iNum,CAF_ERROR_IGNORE);

		if((unsigned)iNum>=(unsigned)Count())				// Prfe die Dateinummer
			{
			m_iErrorCode = CAF_ERROR_MISS;
			PROGN(CAF_PROG_ERROR,iNum);
			goto Exit;
			}

		     iStat = Stats(iNum);
		if(!(iStat&CAF_STAT_SAVED))							// Ist die Datei noch nicht im Archiv gespeichert
			{
			m_iErrorCode = CAF_ERROR_MISS;
			PROGN(CAF_PROG_ERROR,iNum);
			goto Exit;
			}

		iLen = strzlen(pPath);
															// Dateinamen fr Ziel erzeugen
		if(iLen && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))											
			{
			   iOff=GetFullPathName(pPath,MAX_PATH,cName,0);
			if(iOff>=MAX_PATH || iLen>=256)
				{
				m_iErrorCode = CAF_ERROR_PATH;
				PROGN(CAF_PROG_ERROR,iNum);
				goto Exit;
				}
			
			pName = Name(iNum,iLen);						// Name der Archiv-Datei holen

			if(pName[0] && pName[1]==':'){pName+=2;iLen-=2;}
			if(pName[0]=='\\'           ){pName+=1;iLen-=1;}
			if(pName[0]=='/'            ){pName+=1;iLen-=1;}

			memcpy(cName+iOff,pName,(iLen+1)*sizeof(zchar));
			pPath = cName;
			}


		if(m_iModeFlags&(CAF_FLAG_NEW|CAF_FLAG_NOEXIST|CAF_FLAG_NOREADONLY))
			{
			FfFindStruct	sData;


			if(FfFileInfo(pPath,&sData)<0)					// Ist Pfad vorhanden ?
				{
				goto Doit;
				}

			if(m_iModeFlags&CAF_FLAG_NOREADONLY)			// Keine schreibgeschtzten berschreiben
			if(!(sData.dwAttr&SYS_WRITE))
				{
				SetStats(iNum,CAF_STAT_EXIST);
				m_iErrorCode =CAF_ERROR_OK;
				goto Exit;
				}

			if(m_iModeFlags&CAF_FLAG_NOEXIST)				// Keine existierenten berschreiben
				{
				SetStats(iNum,CAF_STAT_EXIST);
				m_iErrorCode =CAF_ERROR_OK;
				goto Exit;
				}

			if(sData.dwAttr&SYS_DIR)						// Ist Datei ein Verzeichnis
				{
				if(iStat&CAF_STAT_DIR)						
					{
					SetStats(iNum,CAF_STAT_EXIST);
					m_iErrorCode =CAF_ERROR_OK;
					goto Exit;
					}

				m_iErrorCode = CAF_ERROR_FCREATE;
				PROGN(CAF_PROG_ERROR,iNum);
				goto Exit;
				}

			if(m_iModeFlags&CAF_FLAG_NEW)					// Nur ltere Dateien berschreiben
				{
				   uTime = (FfUtc)Time(iNum);
				if(uTime<=sData.dwTimeWrite)				// Ist die lokale Datei lter ?
					{
					SetStats(iNum,CAF_STAT_EXIST);
					m_iErrorCode =CAF_ERROR_OK;
					goto Exit;
					}
				}
			}



//******************* Datei erzeugen ******************************************
Doit:

		if(iStat&CAF_STAT_DIR)								// Verzeichnis erzeugen
			{
				iRet=CreatePath(pPath);
			if(!iRet)
				{
				m_iErrorCode = CAF_ERROR_FCREATE;
				PROGN(CAF_PROG_ERROR,iNum);
				goto Exit;
				}

			SetStats(iNum,(iRet==2)? CAF_STAT_EXIST:CAF_STAT_DECOMP);
			m_iErrorCode = CAF_ERROR_OK;
			goto Exit;
			}


		   hFile = CreateFile(pPath,GENERIC_READ|GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
		if(hFile==INVALID_HANDLE_VALUE)						// Zuerst den Pfad erzeugen
			{
			   iRet = GetLastError();
			if(iRet==ERROR_ACCESS_DENIED)					// Ist die Datei schreibgeschtzt
				{
				if(!SetFileAttributes(pPath,FILE_ATTRIBUTE_NORMAL))
					{
					m_iErrorCode = CAF_ERROR_FCREATE;
					PROGN(CAF_PROG_ERROR,iNum);
					goto Exit;
					}

				   hFile=CreateFile(pPath,GENERIC_READ|GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
				if(hFile==INVALID_HANDLE_VALUE)
					{
					m_iErrorCode = CAF_ERROR_FCREATE;
					PROGN(CAF_PROG_ERROR,iNum);
					goto Exit;
					}
				}
			else if(iRet==ERROR_PATH_NOT_FOUND)				// Existiert der Dateipfad nicht
				{
				if(!CreatePath(pPath,CP_PATH_LEN))
					{
					m_iErrorCode = CAF_ERROR_FCREATE;
					PROGN(CAF_PROG_ERROR,iNum);
					goto Exit;
					}
				
				   hFile = CreateFile(pPath,GENERIC_READ|GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
				if(hFile==INVALID_HANDLE_VALUE)
					{
					m_iErrorCode = CAF_ERROR_FCREATE;
					PROGN(CAF_PROG_ERROR,iNum);
					goto Exit;
					}
				}
			else{
					m_iErrorCode = CAF_ERROR_FCREATE;
					PROGN(CAF_PROG_ERROR,iNum);
					goto Exit;
				}
			}


		iRet = ExtractProc(iNum,hFile,FileWrite,&sInfo);	// Die Datei entkomprimieren

		if(iRet==CAF_ERROR_OK)								// War alles ok
			{
			LPFILETIME	pTimeM=NULL;
			LPFILETIME	pTimeA=NULL;
			LPFILETIME	pTimeC=NULL;
			FILETIME	sTimeM;
			FILETIME	sTimeA;
			FILETIME	sTimeC;

			SetStats(iNum,CAF_STAT_DECOMP);

			if(!(sInfo.dwAttr&SYS_WRITE))

			if(sInfo.dwTimeWrite !=0 && sInfo.dwTimeWrite !=0xFFFFFFFF){UtcTimeToFileTime(sInfo.dwTimeWrite ,&sTimeM);pTimeM=&sTimeM;}
			if(sInfo.dwTimeCreate!=0 && sInfo.dwTimeCreate!=0xFFFFFFFF){UtcTimeToFileTime(sInfo.dwTimeCreate,&sTimeC);pTimeC=&sTimeC;}
			if(sInfo.dwTimeAccess!=0 && sInfo.dwTimeAccess!=0xFFFFFFFF){UtcTimeToFileTime(sInfo.dwTimeAccess,&sTimeA);pTimeA=&sTimeA;}
			
			SetFileTime(hFile,pTimeC,pTimeA,pTimeM);
			}

		CloseFile(hFile);
		}
	catch(int iError)										// Fehler abfangen
		{
		CloseFile(hFile);
		m_iErrorCode = iError;
		PROGN(CAF_PROG_ERROR,iNum);
		}

Exit:

	if(iMode==0)											// Modus fr Verlaufsanzeige zurcksetzen	
		{
		SetDoneMode(0);
		}



return m_iErrorCode;
}

//*****************************************************************************
//*
//*		ExtractMem
//*
//*****************************************************************************
//	Extrahiert eine Datei aus dem Archiv in einen Speicherbereich.
//	iNum	: Ist die Indexnummer der Datei die geprft werden soll
//	pMem	: Ist der Zeiger auf den Speicherbereich
//	iLen	: Ist die Gre des Speicherbereiches in Byte
//	pInfo	: Hier werden Zeiten und Attribute der Datei gespeichert.
//			  Bei NULL werden diese Werte ignoriert.
//	Ergibt 0 wenn ok, oder eine Fehlernummer ungleich 0:
//			  	CTF_ERROR_OK		= Wenn alles korrekt war
//			 	CTF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//			 	CTF_ERROR_PATH		= pPathName ungltig ist.
//			 	CTF_ERROR_FCREATE	= Wenn pFileName nicht erzeugt werden konnte
//			 	CTF_ERROR_CRC		= Crc32 Fehler
//			 	CTF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//			 	CTF_ERROR_IGNORE	= Die Datei wurde bersprungen
//				... siehe Fehler Codes
int	CArchiveFile::ExtractMem(int iNum,void *pMem,int iLen,FileData *pInfo)
{
MemInfo		sData;


	sData.pMem	= (char*)pMem; 
	sData.iLen	= iLen;
	sData.iPos	= 0;


return ExtractProc(iNum,&sData,DataWrite,pInfo);
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt dem Archiv mehrere Dateien hinzu. Dabei knnen Filter mit '*' und
//	'?' benutzt werden. Mit den Flags die bei Open(...) bergeben wurde, wird
//	die die Form des Namens im Archiv ebeinflusst (siehe Flags()):
//					CAF_FLAG_FULLPATH	0x0880	= Ganze Namen mit  Laufwerken
//	       			CAF_FLAG_FULLNAME	0x0800	= Ganze Namen ohne Laufwerken
//	pPath	 : Ist der Pfad in dem nach Dateien gesucht wird. Es kann ein Filter
//			   mit '*' und '?' angehnt werden. Mit ';' knnen mehrere Formate 
//			   gewhlt werden. z.B.  pPath="C:\Bilder\*.gif;*.jpg;*.bmp"
//	pPlus	 : Ist der Plusfilter. Eingefgte Dateien mssen zu diesem 
//			   Filter passen. Wenn der Filter NULL ist wird er ignoriert.
//	pMinus	 : Ist der Minusfilter. Eingefgte Dateien drfen nucht zu diesem 
//			   Filter  passen. Wenn der Filter NULL ist wird er ignoriert.
//	pAddPath : Ist der Pfad der vor den Namen im Archiv eingefgt wird.
//	Ergibt die Anzahl der angehngten Dateien bzw. -1 bei einem Fehler.
int CArchiveFile::Add(const zchar *pPath,const zchar *pPlus,const zchar *pMinus,const zchar *pAddPath)
{
zchar			cBuffer[512];
CFileFinder		sFind;
unsigned		uTime;
HANDLE			hFile;
FfFindStruct	sInfo;
FfFindStruct   *pInfo;
zchar		   *pName;
InpProc			pProc;
int				iAddLen;
int				iCount;
int				iFlags;
int				iMode;
int				iNum;
int				iLen;
int				iPos;
int				iCnt;
int				iOld;
int				iRet;



	if(m_iOpenMode<CAF_WRITE)								// Keine Schreiberlaubnis auf Archiv
		{
		m_iErrorCode=CAF_ERROR_WRITE;
		PROGR(CAF_PROG_ERROR,-1,-1);
		return -1;
		}



	if(pAddPath)											// Lnge des vorzusetzenden Pfades
		{
		if(pAddPath[0]=='\\')pAddPath++;
		if(pAddPath[0]=='/' )pAddPath++;

		   iAddLen = strzlen(pAddPath);
		if(iAddLen>0)
			{
			if(pAddPath[iAddLen-1]!='\\')
			if(pAddPath[iAddLen-1]!='/' )
				{
				iAddLen++;
				}
			}
		}
	else{
		iAddLen = 0;
		}


	iCount			= 0;
	iOld			= m_iModeFlags;
	m_iModeFlags   &=~CAF_FLAG_SORT;						// Sort-Flag lschen	
	m_iModeFlags   |= CAF_FLAG_NOFIND;
	
	
	if(m_cHasAddFile)
			pProc = CAF_ADD_FILE;
	else	pProc = (InpProc)FileRead;
	

	if(m_iModeFlags&CAF_FLAG_SUBDIR)
			iFlags= CFF_FIND_SUBDIR;
	else	iFlags= 0;


	sFind.Set(pPath,iFlags,pPlus,pMinus);					// Dateisuche starten	
	iMode	= (m_iModeFlags&CAF_FLAG_FULLNAME)? 1:2;



	for(;;)
		{
			pName = sFind.Next();							// Prfe ob eigene Datei
		if(!pName)break;

		if(!strzicmp(m_pFileName,pName))
		if(!CmpFileName(m_cFilePath,sFind.NameFull()))
			{
			continue;										// Das eigene Archiv nicht einfgen
			}

		pName  = sFind.Name(-1,iMode,&iLen);		
		pPath  = sFind.Name(-1,1);
		iCnt   = strzlen(pPath);


		if(!(m_iModeFlags&0x0080))							// Keine Laufwerksbuschstaben speichern
			{
			iPos = strcwlen(pName,0x00700000);
			if(pName[iPos]==':')pName+=iPos+1;
			}

		if(iAddLen)											// Einen Pfad vorsetzen
			{
			if(iLen+iAddLen>=sizeof(cBuffer)/sizeof(zchar))
				{
				continue;
				}

			if(pName[0]==':')
				{
				memcpy(cBuffer+1,pAddPath  ,iAddLen*sizeof(zchar));
				memcpy(cBuffer+iAddLen,pName+1,iLen*sizeof(zchar));
				cBuffer[iAddLen]='/';
				cBuffer[0]=':';
				}
			else{
				memcpy(cBuffer,pAddPath     , iAddLen*sizeof(zchar));
				memcpy(cBuffer+iAddLen,pName,(iLen+1)*sizeof(zchar));
				cBuffer[iAddLen-1]='/';
				}

			iNum  = Find(cBuffer);							// Ist die Datei schon vorhanden ?
			pName = cBuffer;
			}
		else{
			iNum  = Find(pName);
			}

		if(iNum>=0)											// Ist die Datei schon vorhanden
			{
			if(m_iModeFlags&CAF_FLAG_NOEXIST)				// Keine Dateien berschreiben
				{
				continue;									
				}

			if(m_iModeFlags&CAF_FLAG_NEW)					// Nur neuere Dateien
				{
				   uTime = (unsigned)Time(iNum);
				if(uTime!=0xFFFFFFFF && uTime<(unsigned)sFind.Time())
					{
					continue;
					}
				}

			Del(iNum);										// Lsche Datei aus Archiv
			}

		
		m_pInsertFile = pName;
		pInfo		  = sFind.Info();
		iNum		  = Count();


		if(m_pProgress && (m_iProgOn&(1<<CAF_PROG_QUERY)))	// Rckfrage ob die Datei eingefgt werdnen soll
			{
			if(Progress(CAF_PROG_QUERY,iNum))
				{
				continue;
				}
			}

		if(m_cHasAddFile)									// Kann die Datei via Flash() gespeichert werden
			{
			memcpy(&sInfo,pInfo,offsetof(FfFindStruct,cName));	
			strlcpy(sInfo.cName, pPath, ENTRIES(sInfo.cName));
			hFile = INVALID_HANDLE_VALUE;
			}
		else{
			   hFile = CreateFile(pPath,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
			if(hFile==INVALID_HANDLE_VALUE)							
				{
				m_iErrorCode = CAF_ERROR_FOPEN;				// Die Datei konnte nicht geffnet werden
				PROGN(CAF_PROG_ERROR,iNum);
				continue;
				}

			sInfo.cName[0] = 0;
			}												

															// Die Datei mittels Callback einfgen
		iRet = AddProc(pName,hFile,pProc,(FileData*)&sInfo);

															// Nochmals unkomprimiert versuchen
		if(iRet==CAF_ERROR_COMP && m_cHasStore && hFile!=INVALID_HANDLE_VALUE)					
			{
			sInfo.dwAttr |= SYS_VOLUME;
			SetFilePointer(hFile,0,NULL,FILE_BEGIN);
			iRet = AddProc(pName,hFile,FileRead,(FileData*)&sInfo);
			}

		if(hFile!=INVALID_HANDLE_VALUE)						// Die Datei schlieen
			{
			CloseHandle(hFile);
			}

		if(iRet==CAF_ERROR_OK)
			{
			iCount++;
			}
		}


	m_pInsertFile	= NULL;	
	m_iModeFlags    = iOld;									// Sort-Flag wieder setzen
	
	
	if((m_iModeFlags&CAF_FLAG_SORT) && iCount)
		{
		Sort();
		}




return iCount;
}

//*****************************************************************************
//*
//*		AddMem
//*
//*****************************************************************************
//	Fgt dem Archiv eine einzelne Datei hinzu, die Dateidaten stehen dabei 
//	in  einem Speicherbereich. ber die Flags() kann mann die Speicherungsart 
//	fr den Dateinamen im Archiv festlegen:
//					CAF_FLAG_FULLPATH	0x0880	 Ganze Namen mit  Laufwerken
//	       			CAF_FLAG_FULLNAME	0x0800	 Ganze Namen ohne Laufwerken
//	pName		: Ist der Dateiname fr die neue Datei
//	pMem		: Ist ein Zeiger auf den Speicherbereich
//	iLen		: Ist die Lnge der Speicherbereichs in Byte
//	pInfo		: Enthlt Zeiten und Attribute der Datei.
//				  Bei NULL werden diese Werte ignoriert.
//	Ergibt CAF_ERROR_OK wenn alles ok war oder einen Fehlercode.
int	CArchiveFile::AddMem(const zchar *pFileName,const void *pMem,int iLen,FileData *pInfo)
{
FfFindStruct	sInfo;
MemInfo			sData;
int				iRet;


	sData.pMem	= (char*)pMem; 
	sData.iLen	= iLen;
	sData.iPos	= 0;

	if(pInfo && pInfo->cName[0]=='*')						// Namesnbergabe unterdrcken
		{
		pInfo->cName[0] = 0;
		}

	iRet = AddProc(pFileName,&sData,DataRead,pInfo);

	if(iRet==CAF_ERROR_COMP && m_cHasStore)					// Nochmals unkomprimiert versuchen
		{
		if(pInfo)
			{
			memcpy(&sInfo,pInfo,offsetof(FfFindStruct,cName));	
			strlcpy(sInfo.cName,pInfo->cName,ENTRIES(sInfo.cName));
			sInfo.dwAttr |= SYS_VOLUME;	
			}
		else{
			sInfo.dwAttr		= SYS_READ|SYS_WRITE|SYS_VOLUME;	
			sInfo.dwSize		= iLen;	
			sInfo.dwTimeAccess	= 0;
			sInfo.dwTimeCreate	= 0;
			sInfo.dwTimeWrite	= 0;
			sInfo.cName[0]		= 0;
			}
		
		sData.iPos = 0;

		iRet = AddProc(pFileName,&sData,DataRead,(FileData*)&sInfo);
		}


return iRet; 
}


//*****************************************************************************
//*
//*		AddFile
//*
//*****************************************************************************
//	Fgt dem Archiv eine einzelne Dateien hinzu.
//	pPathName	: Ist der Dateipfad der Datei.
//	pFileName	: Ist der Pfad der Datei im Archiv
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//					CAF_ERROR_OK		= Wenn alles korrekt war
//					CAF_ERROR_MODE		= Keine Schreiberlaubnis vorhanden ist
//					CAF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//					CAF_ERROR_FOPEN		= Beim Einfgen von Verzeichnissen
//					CAF_ERROR_EXIST		= Die Datei im Archiv bereits existiert
//					CAF_ERROR_OLDER		= Wenn die Datei lter ist als die im Archiv
//					CAF_ERROR_BREAK		= Bei einem User-Abbruch mittels Callback
int	CArchiveFile::AddFile(const zchar *pPathName,const zchar *pFileName)
{
FfFindStruct	sInfo;
unsigned		uTime;
unsigned		uStat;
InpProc			pProc;
HANDLE			hFile;
int				iNum;
int				iRet;
int				iOld;


	if(m_iOpenMode<CAF_WRITE)								// Keine Schreiberlaubnis
		{
		m_iErrorCode=CAF_ERROR_MODE;
		PROGR(CAF_PROG_ERROR,-1,-1);
		return CAF_ERROR_MODE;
		}

	if(!pFileName || !*pFileName)							// Prf den Dateinamen
		{
		m_iErrorCode=CAF_ERROR_NAME;
		PROGR(CAF_PROG_ERROR,-1,-1);
		return CAF_ERROR_NAME;
		}

	if(FfFindFirst(pPathName,&sInfo)<0)						// Existiert die Datei
		{
		m_iErrorCode=CAF_ERROR_MISS;
		PROGR(CAF_PROG_ERROR,-1,-1);
		return CAF_ERROR_MISS;
		}

	if(sInfo.dwAttr&SYS_DIR)								// Keine Verzeichnisse einfgen
		{
		m_iErrorCode=CAF_ERROR_FOPEN;
		PROGR(CAF_PROG_ERROR,-1,-1);
		return CAF_ERROR_FOPEN;
		}


	iNum = Find(pFileName);


	if(iNum>=0)												// Ist die Datei schon im Archiv
		{
		m_pErrorFile = Name(iNum);

		if(m_iModeFlags&CAF_FLAG_NOEXIST)
			{
			m_iErrorCode=CAF_ERROR_EXIST;
			return CAF_ERROR_EXIST;
			}

		if(m_iModeFlags&CAF_FLAG_NEW)						// Nur neuere Dateien
			{
			   uTime = Time(iNum);
			if(uTime==0xFFFFFFFF)uTime=0;

			if(uTime>=sInfo.dwTimeWrite)
				{
				m_iErrorCode=CAF_ERROR_OLDER;
				return CAF_ERROR_OLDER;
				}
			}

		   uStat =	Stats(iNum);
		if(uStat&CAF_STAT_WRITE)
			{
			m_iErrorCode=CAF_ERROR_EXIST;
			return CAF_ERROR_EXIST;
			}

		Del(iNum);
		}


	m_pInsertFile = (zchar*)pFileName;
	iNum		  = Count();

	if(m_pProgress && (m_iProgOn&(1<<CAF_PROG_QUERY)))		// Rckfrage ob die Datei eingefgt werdnen soll
		{
		if(Progress(CAF_PROG_QUERY,iNum))
			{
			m_iErrorCode=CAF_ERROR_BREAK;
			return CAF_ERROR_BREAK;
			}
		}

	iOld		  = m_iModeFlags;
	m_iModeFlags |= CAF_FLAG_NOFIND;

	
	if(m_cHasAddFile)										// Datein direkt einfgen falls die Datei bei Flash() gespeichert werden kann
		{
		strlcpy(sInfo.cName,pPathName,ENTRIES(sInfo.cName));
		hFile		   = INVALID_HANDLE_VALUE;	
		pProc		   = CAF_ADD_FILE;
		}
	else{
		   hFile = CreateFile(pPathName,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
		if(hFile==INVALID_HANDLE_VALUE)							
			{
			m_iErrorCode = CAF_ERROR_FOPEN;					// Die Datei konnte nicht geffnet werden
			PROGN(CAF_PROG_ERROR,iNum);
			return CAF_ERROR_FOPEN;
			}

		SetFilePointer(hFile,0,NULL,FILE_BEGIN);

		sInfo.cName[0] = 0;
		pProc		   = (InpProc)FileRead;
		}	

															// Die Datei mittels Callback einfgen
	iRet = AddProc(pFileName,hFile,pProc,(FileData*)&sInfo);

															// Nochmals unkomprimiert versuchen
	if(iRet==CAF_ERROR_COMP && m_cHasStore && hFile!=INVALID_HANDLE_VALUE)					
		{
		sInfo.dwAttr |= SYS_VOLUME;
		SetFilePointer(hFile,0,NULL,FILE_BEGIN);
		iRet = AddProc(pFileName,hFile,FileRead,(FileData*)&sInfo);
		}

	if(hFile!=INVALID_HANDLE_VALUE)							// Die Datei schlieen
		{
		CloseHandle(hFile);
		}

	m_iModeFlags = iOld;
	


return iRet;
}

//*****************************************************************************
//*
//*		AddFile
//*
//*****************************************************************************
//	Eine Datei ohne Pfad einfgen.
int	CArchiveFile::AddFile(const zchar *pPathName)
{
int		iLen;


	iLen = strzlen(pPathName);

	for(;iLen>0;iLen--)
		{
		if(pPathName[iLen-1]=='\\')break;
		if(pPathName[iLen-1]=='/' )break;
		if(pPathName[iLen-1]==':' )break;
		}


return AddFile(pPathName,pPathName+iLen);
}

//*****************************************************************************
//*
//*		AddPath
//*
//*****************************************************************************
//	Dummy fr Klassen ohne Schreibunterstzung.
//	Fgt dem Archiv einen Pfad hinzu. Der Pfad muss dabei nicht real 
//	existieren. ber die Flags kann mann die Speicherungsart festlegen.
//			CAF_FLAG_FULLPATH	0x0880	 Ganze Namen mit  Laufwerken
//	       	CAF_FLAG_FULLNAME	0x0800	 Ganze Namen ohne Laufwerken
//	pFileName	: ist der Dateiname fr den Pfad
//	Ergibt CAF_ERROR_OK wenn alles ok war bzw. einen Fehlercode
int CArchiveFile::AddPath(const zchar *pName)
{

	m_iErrorCode = CAF_ERROR_NOTSUPP;

return m_iErrorCode;
}

//*****************************************************************************
//*
//*		AddProc
//*
//*****************************************************************************
//	Dummy fr Klassen ohne Schreibunterstzung.
//	Fgt dem Archiv eine Datei hinzu, die Daten wird ber ein Callback 
//	geladen. ber die Flags() kann mann die Speicherungsart der Namens 
//	im Archiv festlegen:
//					CAF_FLAG_FULLPATH	0x0880	 Ganze Namen mit  Laufwerken
//	       			CAF_FLAG_FULLNAME	0x0800	 Ganze Namen ohne Laufwerken
//	pFileName	: Ist der Dateiname fr die Datei
//	pParam		: Ist der Zeiger der an die Funktion bergeben wird.
//	pProc		: Ist der Zeiger auf die Callback-Funktion.
//					Mit  0 signalisiert der Callback das Dateiende 
//					Mit -1 signalisiert der Callback einen Fehler
//	pInfo		: Enthlt Zeiten, Attribute und Gre der Datei.
//				  Bei NULL werden diese Werte ignoriert.
//				  Mit "*...<Path>..." kann eine Datei direkt bergeben werden
//	Ergibt CAF_ERROR_OK wenn alles ok war oder einen Fehlercode.
int CArchiveFile::AddProc(const zchar *pName,void *pParam,InpProc pProc,FileData *pInfo)
{

	m_iErrorCode = CAF_ERROR_NOTSUPP;

return m_iErrorCode;
}

//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Dummy fr Klassen ohne Schreibunterstzung.
//	Datei aus dem Archive lschen
//	Ergibt:		CEX_ERROR_MISS   Wenn Datei nicht gefunden wurde
//				CEX_ERROR_OK     Wenn Datei gelscht wurde
//				CEX_ERROR_WRITE  Wenn Datei keine Schreib erlaubnis hat
int CArchiveFile::Del(int iNum)
{

	m_iErrorCode = CAF_ERROR_NOTSUPP;

return m_iErrorCode;
}

//*****************************************************************************
//*
//*		Test
//*
//*****************************************************************************
//	Teste eine Komprimierte Datei.
//	iNum	: Ist die Indexnummer der Datei die geprft werden soll
//	Ergibt 0 wenn ok, oder eine Fehlernummer ungleich 0:
//			  	CTF_ERROR_OK		= Wenn alles korrekt war
//			 	CTF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//			 	CTF_ERROR_PATH		= pPathName ungltig ist.
//			 	CTF_ERROR_FCREATE	= Wenn pFileName nicht erzeugt werden konnte
//			 	CTF_ERROR_CRC		= Crc32 Fehler
//			 	CTF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//			 	CTF_ERROR_IGNORE	= Die Datei wurde bersprungen
//				... siehe Fehler Codes
int	CArchiveFile::Test(int iNum)
{


return ExtractProc(iNum,this,NoneWrite);
}


