//*****************************************************************************
//*
//*
//*		ArchiveFile.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf Archiv-Dateien wie *.tar, *.zip ...:
//	Diese Klasse isr rein virtuell
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int64	Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen


#ifndef 	__ARCHIVEFILE_H__
#define 	__ARCHIVEFILE_H__


#if _MSC_VER >= 1000
#pragma once
#pragma warning( disable :4996 )
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#ifndef		WINVER 
	#define		WINVER 	0x0501 
	#endif 	
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#include	<AfxWin.h>
	#endif
#else
	#ifdef		WIN32
	#include	<windows.h>
	#endif
	#ifdef		LINUX
	#include	<unistd.h>
	#include	"stdfunk.h"
	#endif
#endif


#include	<time.h>
#include	<stdio.h>
#include	<stdlib.h>

#ifndef 	 _MSC_VER
#define 	 _cdecl
#define 	__cdecl
#endif
#ifdef		zchar
#undef 		zchar
#endif
#ifndef		_cdl
#define 	_cdl		__cdecl	
#endif 	
#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif
#ifndef 	aint64
#define 	aint64		__int64
#endif 	
#ifndef 	auint64
#define 	auint64		unsigned __int64
#endif 	

class		CIoCallbacks;

//*****************************************************************************
//*
//*		Konstanten
//*
//*****************************************************************************

#define	CAF_CLOSED			0					// Archiv ist nicht geffnet
#define	CAF_READ			1					// Archiv nur Lesen
#define	CAF_WRITE			2					// Archiv auch schreiben
#define	CAF_CREATE			3					// Archiv neu erstellen und alles lschen
#define CAF_ALLOC			((void  *)1)		// Dynamischen Speicher benutzen
#define CAF_ADD_FILE		((InpProc)1)		// Datein via AddProc() einfgen
												
#define	CAF_TIME_W			0					// Zeit der letzten nderung
#define	CAF_TIME_C			1					// Zeit der Dateierstellung
#define	CAF_TIME_A			2					// Zeit des letzten Zugriffs
												
#define	CAF_PROG_OPEN 		0					// ffnet TarFile
#define	CAF_PROG_FIND 		1					// Datei gefunden
#define	CAF_PROG_ZDEL  		2					// Datei lschen aus ZListe
#define	CAF_PROG_DEL  		3					// Datei lschen aus TarFile
#define	CAF_PROG_CLOSE 		4					// Schliet TarFile
#define	CAF_PROG_CREATE 	5					// Erzeugt neues TarFile
#define	CAF_PROG_ZADD  		6					// Datei einfgen in ZListe
#define	CAF_PROG_WRITE 		7					// Datei einfgen in TarFile
#define	CAF_PROG_READ		8					// Liet  Unterdatei
#define	CAF_PROG_FLUSH		9					// Speichert alle Dateien
#define	CAF_PROG_ERROR		10					// Fehlerausgabe
#define	CAF_PROG_EXTRACT	11					// Datei wurde endkomprimiert 
#define	CAF_PROG_TEST		12					// Testet  Unterdatei
#define	CAF_PROG_SORT 		13					// Sortiere TarFile
#define	CAF_PROG_COMPRESS	14					// Nach Komriemieren
#define	CAF_PROG_QUERY		15					// Datei berspringen
#define CAF_PROG_DOEXTRACT	16					// Datei wird entkomprimiert
#define	CAF_PROG_PASSWD		17					// Nach dem Passwort fragen
#define CAF_PROG_MAX		18					// Maximal Zahl an Nachrichten
												
#define CAF_STAT_NONE		0x0000				// Die Datei wurde noch nicht entpackt
#define CAF_STAT_EXIST		0x0001				// Wenn die Datei beim Entpacken schon vorhanden war
#define CAF_STAT_DECOMP		0x0002				// Wenn die Datei vollstndig neu entpackt wurde (immer ohne CAF_STAT_FILEOK)
#define CAF_STAT_DELETE		0x0004				// Die Datei wurde aus dem Verzeichnis gelscht
#define CAF_STAT_WRITE		0x0008				// Die Datei muss ins Archiv geschrieben werden
#define CAF_STAT_DIR		0x0010				// Die Datei ist ein Verzeichniss
#define CAF_STAT_READONLY	0x0020				// Die Datei ist schreibgeschtzt
#define CAF_STAT_SAVED		0x0040				// Die Datei wurde dem Archiv hinzugefgt
												
#define	CAF_FLAG_STORE 		0x8000				// Keine Komprimierung
#define	CAF_FLAG_BEST 		0x4000				// Beste Komprimierung
#define	CAF_FLAG_NEW  		0x2000				// Nur neuere Dateien ersetzen
#define	CAF_FLAG_SUBDIR		0x1000				// Unterverzeichnisse durchsuchen
#define	CAF_FLAG_FULLNAME	0x0800				// Ganze Namen Speichern
#define	CAF_FLAG_FULLPATH	0x0880				// Ganze Namen mit Laufwerken
#define	CAF_FLAG_SORT		0x0400				// Liste sortieren
#define	CAF_FLAG_SORTLEN	0x0500				// Liste sortieren nach pFileName
#define	CAF_FLAG_SORTPOS	0x0600				// Liste sortieren nach Offsets (intern)
#define	CAF_FLAG_SORTEX  	0x0700				// Liste sortieren nach Namen mit Zahlen Bercksichtigung
#define	CAF_FLAG_NOREADONLY	0x0080				// Schreibgeschtzte Dateien nicht berschreiben (nur beim Extrahieren)
#define	CAF_FLAG_NOEXIST	0x0040				// Dateien die schon bestehen nicht berschreiben
#define	CAF_FLAG_NOCHECK	0x0020				// Die Dateien nicht Prfen beim ffnen
#define	CAF_FLAG_NOFIND		0x0010				// Nicht prfen ob die Datei im Archiv existiert 
												
#define CAF_BEST		   -1					// Beste Methode
#define CAF_STORE			0					// Nur eins zu ein speichern
#define CAF_DEFLATE			8					// Komrimieren
#define CAF_MAIN			0					// Hauptdatei benutzen
#define CAF_BASE			1					// Unterdatei benutzen
												
#define CAF_ERROR_MISS     -1					// used by procname(), zipbare()
#define CAF_ERROR_OK        0       			// success
#define CAF_ERROR_EOF       2       			// unexpected end of zip file
#define CAF_ERROR_FORM      3       			// archive file structure error
#define CAF_ERROR_MEM       4       			// out of memory
#define CAF_ERROR_LOGIC     5       			// internal logic error
#define CAF_ERROR_BIG       6       			// entry too large to split
#define CAF_ERROR_NOTE      7       			// invalid comment format
#define CAF_ERROR_TEST      8       			// tar test (-T) failed or out of memory
#define CAF_ERROR_ABORT     9       			// user interrupt or termination
#define CAF_ERROR_TEMP      10      			// error using a temp file
#define CAF_ERROR_READ      11      			// read or seek error
#define CAF_ERROR_NONE      12      			// nothing to do
#define CAF_ERROR_NAME      13      			// missing or empty archive file
#define CAF_ERROR_WRITE     14      			// error writing to a file
#define CAF_ERROR_CREATE    15      			// couldn't open to write
#define CAF_ERROR_PARMS     16      			// bad command line
#define CAF_ERROR_OPEN      18      			// could not open a specified file to read
#define CAF_ERROR_MULTI     19      			// TarFile geht ber mehrere Disketten
#define CAF_ERROR_PATH      20     				// Falsche pPathName-Angabe
#define CAF_ERROR_CRC       21     				// Crc32 Fehler beim Etkomprimieren
#define CAF_ERROR_DECOMP    22     				// Fehler beim Etkomprimieren
#define CAF_ERROR_BREAK     23     				// Benutzer Abbruch
#define CAF_ERROR_FOPEN		24					// Fehler beim ffnen   einer SubDatei
#define CAF_ERROR_FCREATE 	25					// Fehler beim Erzeugen einer SubDatei
#define CAF_ERROR_FWRITE 	26      			// Fehler beim Schreiben in eine SubDatei
#define CAF_ERROR_FREAD  	27      			// Fehler beim Lesen     in eine SubDatei
#define CAF_ERROR_IGNORE 	28					// Die Datei wurde bersprungen
#define CAF_ERROR_NOTSUPP 	29					// Die Funktion wird nicht untersttzt
#define CAF_ERROR_VERSION 	30					// Die Version wird nicht untersttzt
#define CAF_ERROR_COMP		31					// Fehler beim Komprimieren
#define CAF_ERROR_PASSWD	32					// Falsches Password
#define CAF_ERROR_NOTOPEN	33					// Das Archiv ist nicht geffnet
#define CAF_ERROR_MODE		34					// In diesem Modus ist diese Funktion nicht mglich.
#define CAF_ERROR_EXIST		35					// Die Datei ist bereits im Archiv vorhanden
#define CAF_ERROR_OLDER		36					// Die Datei ist lter als die im Archiv vorhandene
#define CAF_ERROR_DISKFULL	37					// Im Archif ist nicht genug Platz



//*****************************************************************************
//*
//*		Klasse CArchiveFile
//*
//*****************************************************************************
class CArchiveFile
{
public:

		typedef		unsigned char uchar;

		typedef		int(_cdecl*OutFunc)(void *pParam,const uchar *pMem,int iLen);;
		typedef		int(_cdecl*OutProc)(void *pParam,const char  *pMem,int iLen);;
		typedef		int(_cdecl*OutCall)(void *pParam,const void  *pMem,int iLen);;
		typedef		int(_cdecl*InpFunc)(void *pParam,      uchar *pMem,int iLen);
		typedef		int(_cdecl*InpProc)(void *pParam,      char  *pMem,int iLen);
		typedef		int(_cdecl*InpCall)(void *pParam,      void  *pMem,int iLen);
		typedef		char	*charptr;
		typedef		unsigned uint;
		
		typedef struct
			{
			char   *pMem;						// Zeiger auf den Speicherbereich
			int		iLen;						// Gre des Speicherbereiches in Byte
			int		iPos;						// Aktueller Offset im Speicherbereich
			}MemInfo;

		typedef	struct
			{
			uint	dwAttr;						// Datei Attribute
			uint	dwSize;						// Dateigre
			uint 	dwTimeCreate;				// Erstellzeit     (UTC) 
			uint 	dwTimeAccess;				// Letzter Zugriff (UTC)
			uint 	dwTimeWrite;				// Gendert Zeit   (UTC)
			zchar	cName[2];					// Dummy fr Dateiname
			}FileData;

		int			m_iProgPos;					// Ist die Position des Dateinamens im Progress-Text
		int			m_iProgLen;					// Ist die Lnge des Dateinamens im Progress-Text
		int			m_iProgAdd;					// Ist die Lnge des Progress-Textes nach dem Dateinamen

protected:

		char	   *m_pMemFree;					// Free-Zeiger auf dynamischne Haupspeicher
		char	   *m_pMemPtr;					// Zeiger auf Hauptspeicher
		int			m_iMemLen;					// Lnge des  Hauptspeichers
		int			m_iMemPos;					// Ausleseposition aus Speichers
		int			m_iMemEnd;					// Hchste Schreibposition im Speicher
		int			m_iMemMax;					// Maximal allokierte Gre fr dynamischen Speicher
		void	   *m_hResSrc;					// Handle der benutzen Resource
		void	   *m_hResHg;					// Global Handle der benutzen Resource
		void	   *m_hFile;					// Ist das Datei-Handle der Hauptdatei
		aint64		m_iFileSize;				// Gre der Hauptdatei oder des Resourcen-Speichers

		char	   *m_pSubFree;					// Unterdatei, Free-Zeiger auf dynamischne Unterspeicher
		char	   *m_pSubPtr;					// Unterdatei, Zeiger auf Unterspeicher
		int			m_iSubLen;					// Unterdatei, Lnge des  Resourcen Speichers
		int			m_iSubPos;					// Unterdatei, Ausleseposition aus Resourcen Speichers
		int			m_iSubEnd;					// Unterdatei, Hchste Schreibposition im Speicher
		int			m_iSubMax;					// Unterdatei, Maximal allokierte Gre fr dynamischen Speicher
		int			m_iSubMode;					// Unterdatei, Oben-Modus (CAF_READ, CAF_WRITE, CAF_CREATE)
		void	   *m_hSubSrc;					// Unterdatei, Resource Handle
		void	   *m_hSubHg;					// Unterdatei, Global Handle
		void	   *m_hSubFile;					// Unterdatei, Ist das Datei-Handle
		aint64		m_iSubSize;					// Unterdatei, Gre der Datei oder des Resourcen-Speichers

		aint64		m_iReadPos;					// Aktuelle Leseposition (fr Bcke ab 2GB)
		aint64		m_iReadMax;					// Maximale Leseposition (fr Bcke ab 2GB)
		InpCall		m_pReadProc;				// Lesefunction fr groe Blcke ab 2GB

		int			m_iOpenMode;				// Modus beim ffnen (0=CAF_CLOSED 1=CAF_READ 1=CAF_WRITE 3=CAF_CREATE)
		int			m_iModeFlags;				// Komprimirung und Diverses CAF_FLAG_????
		int			m_iCompressMode;			// Komprimirungsmodus (CAF_BEST,CAF_STORE)
		int			m_iLevel;					// Komprimirungslevel (0=keine 8=maximal,9=standard)
		int			m_iSortMode;				// Ist die Liste sortiert (0=nein, CAF_FLAG_SORT???)

		char		m_cHasStore;				// Kann das Archiv die Datei auch unkomprimiert speichern
		char		m_cHasAddFile;				// Knnen Dateien direkt eingefgt werden
		char	  	m_cHasCompress;				// Gibt es komprimier Funktionen
		char	  	m_cSubActive;				// Ist eine Unterdatei aktiv
		char		m_cThrowRd;					// Exeptions beim Lesen werfen
		char		m_cThrowWr;					// Exeptions beim Schreiben werfen
				
		void	   *m_pUserData;				// User-Daten fr Archiv
		void	   *m_pProgParam;				// Zeiger fr Progress-Funktion
		int 	  	m_iProgMode;				// Progress Modus	(jedes Bit ist ein Schalter)
	   	int			m_iProgOn;					// Progress Ein/Aus (jedes Bit ist ein Schalter)
static 	bool	  	m_bProgInit;				// Progress Init
static 	zchar	   *m_cProgTxt1[CAF_PROG_MAX];	// Progress Namen
static 	zchar	   *m_cProgTxt2[CAF_PROG_MAX];	// Progress Namen
static 	int 	  	m_iProgLen1[CAF_PROG_MAX];	// Progress Lnge
static 	int 	  	m_iProgLen2[CAF_PROG_MAX];	// Progress Lnge
static 	zchar	   *m_pTempPath;				// Pfad fr temporre Dateien
const	zchar	   *m_pTempSuffix;				// Suffix fr die dynamische Umschaltung
	 	zchar	   *m_pBasePath;				// Pfad fr auf die geffnete Unterdatei

		zchar		m_cFilePath[256];			// Ist der akuelle Dateiname vom Archiv
		zchar	   *m_pFileName;				// Ist der Name der Archiv-Datei ohne Pfad
		zchar	   *m_pErrorText;				// Speicher fr Fehlertext
		zchar	   *m_pErrorFile;				// Dateiname fr F... Fehler
		zchar	   *m_pInsertFile;				// Dateiname die gerade mit Add(...) eingefgt wird
		int			m_iErrorCode;				// Aktueller Fehler-Code (siehe CAF_ERROR_???)
		char	   *m_pPassword;				// Zeiger auf das Passwort

	int (__cdecl   *m_pProgress)(void *pParam,int iMode,int iSub,CArchiveFile *pTar,zchar *pText);

public:

			CArchiveFile();
   virtual ~CArchiveFile();

			int		Open       (const zchar  *pFileName,int  iMode=CAF_READ,int iLevel=9);
			int 	OpenRes    (const zchar  *pName,const zchar *pType= 0,int iFlags=0);	// Resource ffnen
			int 	OpenRes    (unsigned      pName,const zchar *pType= 0,int iFlags=0);	// Resource ffnen
			int 	OpenMem    (const void   *pData,int iSize,int iEnd=-1,int iFlags=0);	// Speicher ffnen
	virtual	int 	SetPassword(const zchar  *pName);			// Passwort setzen

	virtual	int     AddPath    (const zchar  *pFileName);
	virtual	int		AddProc    (const zchar  *pFileName,void *pParam,InpProc pProc,FileData *pInfo=0);
			int		AddProc    (const zchar  *pFileName,void *pParam,InpCall pProc,FileData *pInfo=0);
			int		AddProc    (const zchar  *pFileName,void *pParam,InpFunc pProc,FileData *pInfo=0);
			int		AddMem     (const zchar  *pFileName,const void  *pMem,int iLen,FileData *pInfo=0);
			int		Add        (const zchar  *pPathName,const zchar *pPlus=0,const zchar *pMinus=0,const zchar *pAddPath=0);
			int		AddFile    (const zchar  *pPathName,const zchar *pFileName);
			int		AddFile    (const zchar  *pPathName);

   	virtual	int		Test       (int   iNum);
			int		Extract    (int   iNum,const zchar *pPathName=0  );
			int		ExtractMem (int   iNum,void *pMem  ,int     iLen ,FileData *pInfo=0);
	        int		ExtractProc(int   iNum,void *pParam,InpCall pProc,FileData *pInfo=0);
	        int		ExtractProc(int   iNum,void *pParam,OutCall pProc,FileData *pInfo=0);
	        int		ExtractProc(int   iNum,void *pParam,OutFunc pProc,FileData *pInfo=0);
	virtual	int		ExtractProc(int   iNum,void *pParam,OutProc pProc,FileData *pInfo=0)=0;
			int		ExtractAll (const zchar *pPathName ,int    *pErrNum=0);
	virtual	int		Change	   (int   iMode=CAF_WRITE);			// Schreiberlaubnis de/aktivieren

			int		GetMode    ();								// Aktuellen Modus ermitteln (CAF_CLOSED,CAF_READ,CAF_WRITE,CAF_CREATE)
			int		GetMemSize (void *pMem=0,int iGrap=0);		// Gre des Speichers abfragen
			aint64	AllLen	   ();								// Gre aller Dateien abfragen
	virtual	int		Flush      ();								// Alle Dateien in ZIP-Datei speichern
	virtual	int		Close      ()=0;							// Datei schliesen
	virtual	int	    Count      ()=0;							// Anzahl der Dateien
	virtual	void	Break      ()=0;							// Bearbeitung abbrechen
	virtual	int		Stats      (int    iNum            )=0;		// Zustansbits setzen
	virtual	zchar  *Name       (int    iNum,int &iLen  );		// Hole Dateiname mit Lnge
	virtual	zchar  *Name       (int    iNum            )=0;		// Hole Dateiname
	virtual	int		Sort       (int    iMode=0         )=0;		// Sortierte Kette
	virtual	int     SetFail    (int    iNum,int iFail=1);		// Defekt-Flag setzen
	virtual	int     IsReadOnly (int    iNum            );		// Ist die Datei schreibgeschtzt
	virtual	int     IsFail     (int    iNum            )=0;		// Ist die Datei defekt
	virtual	int     IsDel      (int    iNum            );		// Wurde die Datei gelscht
	virtual	int     IsDir      (int    iNum            )=0;		// Prfe ob Verzeichnis
	virtual	int     IsOk       (int    iNum            )=0;		// Richtig endkomprimiert
	virtual	aint64	Len        (int    iNum,int iMode=0)=0;		// Hole Dateilnge
	virtual	int		Del        (int    iNum            );		// Datei lschen
	virtual	int		Find       (const zchar  *pFileName)=0;		// Datei suchen
	virtual	time_t	Time       (int    iNum            )=0;		// Datei Zeit abfragen
	virtual	time_t	Time       (int    iNum,int iMode  )=0;		// Datei Zeit abfragen
	virtual	aint64	Done       (aint64*pMax=0          )=0;		// Verlaufsabfrage
	virtual int		Attribute  (int    iNum            );		// Dateiattribute auslesen 
	virtual	void   *GetUserPtr (int    iNum            )=0;		// Datenwert auslesen
	virtual	void    SetUserPtr (int    iNum,void *pData)=0;		// Datenwert einstellen
			void    SetUserData(int    iNum,int   iData);		// Datenwert einstellen
			int     GetUserData(int    iNum);					// Datenwert auslesen
			void    SetUserData(int   iData);					// Datenwert einstellen
			int     GetUserData(		   );					// Datenwert auslesen
			void   *GetUserPtr (		   );					// Datenwert auslesen
			void    SetUserPtr (void *pData);					// Datenwert einstellen

			int		Del        (const zchar *pFileName);		// Die Date aus dem Archiv lschen
			int		Test       (const zchar *pFileName);		// Die Date berprfen
			int		Stats      (const zchar *pFileName);		// Zustansbits abfragen
			int		Extract    (const zchar *pFileName,const zchar *pPathName=0);
			int		ExtractMem (const zchar *pFileName,void *pMem  ,int     iLen ,FileData *pInfo=0);
			int		ExtractProc(const zchar *pFileName,void *pParam,OutFunc pProc,FileData *pInfo=0);
			int		ExtractProc(const zchar *pFileName,void *pParam,OutProc pProc,FileData *pInfo=0);
			int		ExtractProc(const zchar *pFileName,void *pParam,OutCall pProc,FileData *pInfo=0);
			int		ExtractProc(const zchar *pFileName,void *pParam,InpCall pProc,FileData *pInfo=0);
			time_t	Time	   (const zchar *pFileName,int iMode);
			time_t	Time	   (const zchar *pFileName);

			int     Error      ();								// Fehler-Code holen
			zchar  *ErrorText  ();								// Fehler Text holen
			int		Level      (int iLevel=-2);					// Setze Komprimierungslevel
			int		Flags      (int iFlags=-2);					// Setze iFlags
			int		Mode       (int iMode =-2);					// Setze Komprimierungsmodus

			int		Progress    (void *pParam=0,int (__cdecl*pProc)(void *pParam,int iMode,int iSub,CArchiveFile *pArch,zchar *pText)=0);
			int		ProgressMode(int iType= 0,int iMode=0);
			int		ProgressAdd (int iType=31,int iMode=0);
			int		ProgressDel (int iType= 0,int iMode=0);
			int 	HasCommpress(){return m_cHasCompress;}
	static	void	SetTempPath (const zchar *pPath);			// Temporren Pfad einstellen

protected:

			void	InitSubFile ();								// Eine Unterdatei aktivieren
			void 	ReleaseData	();								// Resourcen freigeben
	virtual	int 	SetDoneMode	(int iMode)=0;					// Modus fr Done setzen
			void 	SetMemSub   (int iMin,int iMax,zchar *pName ,const zchar *pSuffix );				// Dynamische Umschaltung aktivieren
			void	SetOutput   (CIoCallbacks*pIo,int s=CAF_MAIN,				unsigned uCrc=0x12345678);	// IO fr eine Compressor setzen
			void	SetInput    (CIoCallbacks*pIp,int s=CAF_MAIN,aint64 iLen=-1,unsigned uCrc=0x12345678);	// IO fr eine Compressor setzen
			void	EndOfFile	(int iUseSub=0);				// Leseposition als Dateiende festlegen
			void	ZeroFile	(int iUseSub=0);				// Eine Datei auf die Gre 0 setzem
	virtual	int		SetStats    (int iNum,int iSet);			// Die Zustand einer Archivdatei setzen
	virtual	int		ArchOpen    (int iLevel)=0;					// Erweitertes ffnen der ZIP-Datei
			int		DoChange    (int iMode,int iFlush=1);		// Zugriffsrechte ndern
			int		DoChangeSub (int iMode,int iFlush=1);		// Zugriffsrechte ndern	(Unterdatei)
			int		Progress    (int iMode ,int iSubNr);		// Eine Verlaufsfunktion aufrufen
			int		BaseWrite   (const void *p,int iSz);		// In die Datei schreiben   (Unterdatei)
			int		MainWrite   (const void *p,int iSz);		// In die Datei schreiben
			int		BaseRead    (void  *pMem,int iSize);		// Aus der Unterdatei lesen (Unterdatei)    
			int		MainRead    (void  *pMem,int iSize);		// Aus der Datei lesen
			aint64	BaseSeek    (aint64 iPos,int iMd=SEEK_SET);	// Leseposition verschieben (Unterdatei)
			aint64	MainSeek    (aint64 iPos,int iMd=SEEK_SET);	// Leseposition verschieben
			aint64	BaseTell    ();								// Leseposition auslesen	(Unterdatei)
			aint64	MainTell    ();								// Leseposition auslesen
			aint64	BaseSize    ();								// Unterdateigre auslesen	(Unterdatei)
			aint64	MainSize    ();								// Dateigre      auslesen
	
	
	static	aint64	GetFileSize (void *hFile);					// Die Dateigre abfragen
	static	int		CloseFile   (void *hFile);					// Eine Datei schlieen
	static	void	CharToPath  (      zchar *pName);			// Konvertiert '\' zu '/' in einem Dateinamen.
	static	int 	ArchiveType (const zchar *pName);			// Prft ob ein Dateiname ein Archiv ist
	static 	char   *Realloc		(charptr &p,int &i,int m,int a);// Einen Speicherbereich vergrern
	static	void   *CreateTempFile(zchar *pBuffer,int iSize,const zchar *pSuffix);

static	int __cdecl NoneWrite(void *pPtr,const void *p,int iSz);// Schreiben ist nicht erlaubt
static	int __cdecl DataWrite(void *pPtr,const void *p,int iSz);// In einen Speicher schreiben
static	int __cdecl FileWrite(void *pPtr,const void *p,int iSz);// In eine Dateischreiben
static	int __cdecl NullWrite(void *pPtr,const void *p,int iSz);// Schreiben ist nicht erlaubt
static	int __cdecl BaseWrite(void *pPtr,const void *p,int iSz);// In die Unterdatei schreiben
static	int __cdecl MainWrite(void *pPtr,const void *p,int iSz);// In die Datei schreiben
static	int __cdecl DataRead (void *pPtr,void  *pMem,int iSize);// Aus einem Speicher lesen
static	int __cdecl FileRead (void *pPtr,void  *pMem,int iSize);// Aus einer Datei lesen
static	int __cdecl BaseRead (void *pPtr,void  *pMem,int iSize);// Aus der Unterdatei lesen
static	int __cdecl MainRead (void *pPtr,void  *pMem,int iSize);// Aus der Datei lesen
static  int __cdecl ProcRead (void *pPtr,void  *pMem,int iSize);// Aus der Datei lesen (ab 2GB)
static	aint64 _cdl	BaseSeek (void *pPtr,aint64 iPos,int iMode);// Leseposition verschieben (Unterdatei)
static	aint64 _cdl	MainSeek (void *pPtr,aint64 iPos,int iMode);// Leseposition verschieben
static	aint64 _cdl	BaseTell (void *pPtr);						// Leseposition auslesen
static	aint64 _cdl	MainTell (void *pPtr);						// Leseposition auslesen

							

};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	int   CArchiveFile::OpenRes    (unsigned uName,const zchar *pType,int iFlags){return OpenRes((zchar*)uName,pType,iFlags);}
inline	int	  CArchiveFile::AddProc    (const zchar *pFileName,void *pParam,InpCall pProc,FileData *pInfo){return AddProc    (pFileName,pParam,(InpProc)pProc,pInfo);}
inline	int	  CArchiveFile::AddProc    (const zchar *pFileName,void *pParam,InpFunc pProc,FileData *pInfo){return AddProc    (pFileName,pParam,(InpProc)pProc,pInfo);}
inline	int	  CArchiveFile::ExtractProc(const zchar *pFileName,void *pParam,OutCall pProc,FileData *pInfo){return ExtractProc(pFileName,pParam,(OutProc)pProc,pInfo);}
inline	int	  CArchiveFile::ExtractProc(const zchar *pFileName,void *pParam,OutFunc pProc,FileData *pInfo){return ExtractProc(pFileName,pParam,(OutProc)pProc,pInfo);}
inline	int	  CArchiveFile::ExtractProc(const zchar *pFileName,void *pParam,InpCall pProc,FileData *pInfo){return ExtractProc(pFileName,pParam,(OutProc)pProc,pInfo);}
inline	int	  CArchiveFile::ExtractProc(int iNum              ,void *pParam,OutCall pProc,FileData *pInfo){return ExtractProc(iNum     ,pParam,(OutProc)pProc,pInfo);}
inline	int	  CArchiveFile::ExtractProc(int iNum              ,void *pParam,OutFunc pProc,FileData *pInfo){return ExtractProc(iNum     ,pParam,(OutProc)pProc,pInfo);}
inline	int	  CArchiveFile::ExtractProc(int iNum              ,void *pParam,InpCall pProc,FileData *pInfo){return ExtractProc(iNum     ,pParam,(OutProc)pProc,pInfo);}
inline	void  CArchiveFile::SetUserData(int iNum,int iData   ){SetUserPtr(iNum,(void*)iData);}
inline	int   CArchiveFile::GetUserData(int iNum             ){return (int)GetUserPtr(iNum );}
inline	void  CArchiveFile::SetUserData(         int iData   ){SetUserPtr(     (void*)iData);}
inline	int   CArchiveFile::GetUserData(		             ){return (int)GetUserPtr(     );}
inline	void  CArchiveFile::SetUserPtr (       void *pData   ){            m_pUserData=pData;}
inline	void *CArchiveFile::GetUserPtr (                     ){return      m_pUserData      ;}
inline	int	  CArchiveFile::GetMode    (                     ){return (m_cSubActive)? m_iSubMode:m_iOpenMode;}
inline	int	  CArchiveFile::BaseWrite  (const void *p,int iSz){return BaseWrite(this,p   ,iSz  );}
inline	int	  CArchiveFile::BaseRead   (void  *pMem,int iSize){return BaseRead (this,pMem,iSize);}
inline aint64 CArchiveFile::BaseSeek   (aint64 iPos,int iMode){return BaseSeek (this,iPos,iMode);}
inline aint64 CArchiveFile::BaseTell   (                     ){return BaseTell (this           );}
inline	int	  CArchiveFile::MainWrite  (const void *p,int iSz){return MainWrite(this,p,iSz     );}
inline	int	  CArchiveFile::MainRead   (void  *pMem,int iSize){return MainRead (this,pMem,iSize);}
inline aint64 CArchiveFile::MainSeek   (aint64 iPos,int iMode){return MainSeek (this,iPos,iMode);}
inline aint64 CArchiveFile::MainTell   (                     ){return MainTell (this           );}
inline  int	  CArchiveFile::CloseFile  (void *hFile          ){return CloseHandle(hFile        );}
inline  int	  CArchiveFile::ExtractProc(const zchar *pFileName,void *a,OutProc p,FileData *i){return ExtractProc(Find(pFileName),a,p,i    );}
inline  int	  CArchiveFile::ExtractMem (const zchar *pFileName,void *pMem,int  l,FileData *i){return ExtractMem (Find(pFileName),pMem,l,i );}
inline  int	  CArchiveFile::Extract    (const zchar *pFileName,const zchar *pPathName       ){return Extract    (Find(pFileName),pPathName);}
inline  int	  CArchiveFile::Stats      (const zchar *pFileName                              ){return Stats      (Find(pFileName)          );}
inline time_t CArchiveFile::Time       (const zchar *pFileName                              ){return Time       (Find(pFileName)          );}
inline time_t CArchiveFile::Time       (const zchar *pFileName,int iMode                    ){return Time       (Find(pFileName),iMode    );}
inline  int	  CArchiveFile::Test       (const zchar *pFileName                              ){return Test       (Find(pFileName)          );}
inline  int	  CArchiveFile::Del        (const zchar *pFileName                              ){return Del        (Find(pFileName)          );}




#undef	_cdl

#endif



