//*****************************************************************************
//*
//*
//*		BzibLib.h
//*
//*
//*****************************************************************************
//	
//	This file is part of bzip2/libbzip2, a program and library for
//	lossless, block-sorting data compression.
//	
//	bzip2/libbzip2 version 1.0.4 of 20 December 2006
//	Copyright (C) 1996-2006 Julian Seward <jseward@bzip.org>
//	
//	Please read the WARNING, DISCLAIMER and PATENTS sections in the 
//	README file.
//	
//	This program is released under the terms of the license contained
//	in the file LICENSE.
//	   


#ifndef	  __BZLIB_H__					
#define	  __BZLIB_H__					


#define		BZ_RUN						0
#define		BZ_FLUSH					1
#define		BZ_FINISH					2

#define		BZ_OK						0
#define		BZ_RUN_OK					1
#define		BZ_FLUSH_OK 				2
#define		BZ_FINISH_OK				3
#define		BZ_STREAM_END				4
#define		BZ_SEQUENCE_ERROR			(-1)
#define		BZ_PARAM_ERROR				(-2)
#define		BZ_MEM_ERROR				(-3)
#define		BZ_DATA_ERROR				(-4)
#define		BZ_DATA_ERROR_MAGIC 		(-5)
#define		BZ_IO_ERROR 				(-6)
#define		BZ_UNEXPECTED_EOF			(-7)
#define		BZ_OUTBUFF_FULL 			(-8)
#define		BZ_CONFIG_ERROR 			(-9)

typedef	struct 
	{
	char        *next_in;
	unsigned int avail_in;
	unsigned int total_in_lo32;
	unsigned int total_in_hi32;

	char        *next_out;
	unsigned int avail_out;
	unsigned int total_out_lo32;
	unsigned int total_out_hi32;

	void		*state;
	void        *opaque;
	void	  *(*bzalloc)(void *,int,int);
	void       (*bzfree )(void *,void *);
	}bz_stream;


#define		BZ_EXTERN					extern
#define		BZ_API(func)				func


BZ_EXTERN int			BZ_API(Bz2_BzCompressInit  )(bz_stream *pStream,int iBlockSize100k,int iVerbosity,int iWorkFactor);
BZ_EXTERN int			BZ_API(Bz2_BzCompress      )(bz_stream *pStream,int iAction);
BZ_EXTERN int			BZ_API(Bz2_BzCompressEnd   )(bz_stream *pStream);
BZ_EXTERN int			BZ_API(Bz2_BzDecompressInit)(bz_stream *pStream,int iVerbosity,int iSmall);
BZ_EXTERN int			BZ_API(Bz2_BzDecompress    )(bz_stream *pStream);
BZ_EXTERN int			BZ_API(Bz2_BzDecompressEnd )(bz_stream *pStream);
BZ_EXTERN const char  * BZ_API(Bz2_BzlibVersion    )(void);




#endif
