//*****************************************************************************
//*
//*
//*		ExeFile.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
//
//	Klasse fr den Zugriff auf Exe Files:
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int uLen)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int64	Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen
//
#include	<stdio.h>
#include	<stddef.h>
#include	<string.h>
#include	<malloc.h>
#include	<sys/stat.h>
#include	"ExeFile.h"

#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif


#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	atoiz	   _wtoi
#define 	itoaz	   _itow
#define 	strzlen		wcslen
#define 	strzcat		wcscat
#define 	strzcmp		wcscmp
#define 	strzcpy		wcscpy
#define 	strzncpy	wcsncpy
#define 	strzncat	wcsncat
#define 	strzupr		wcsupr
#define 	strzicmp	wcsicmp
#define 	strzcspn	wcscspn
#define 	strznicmp	wcsnicmp
#define 	szprintf	swprintf
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	atoiz	    atoi
#define 	itoaz		itoa
#define 	strzlen		strlen
#define 	strzcat		strcat
#define 	strzcmp		strcmp
#define 	strzcpy		strcpy
#define 	strzncpy	strncpy
#define 	strzncat	strncat
#define 	strzupr		strupr
#define 	strzicmp	stricmp
#define 	strzcspn	strcspn
#define 	strznicmp	strnicmp
#define 	szprintf	sprintf
#endif

#define		EXE_NEW_ADD	256

#ifndef 	RT_MANIFEST
#define		RT_MANIFEST	24
#endif

#ifndef 	RT_DLGINIT
#define		RT_DLGINIT	240
#endif

#ifndef 	RT_TOOLBAR
#define		RT_TOOLBAR	241
#endif


#define		PTR_ADD(ptr,add)	(((const char*)(ptr))+(DWORD)(add))

typedef struct
	{
    DWORD   Characteristics;
    DWORD   TimeDateStamp;
    WORD    MajorVersion;
    WORD    MinorVersion;
    WORD    NumberOfNamedEntries;
    WORD    NumberOfIdEntries;
	}RerourceDir;


#define PROG(iMode,iNum)							\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	if(Progress(iMode,iNum))throw CAF_ERROR_BREAK;	\
	}
#define PROGR(iMode,iNum,iRet)						\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	if(Progress(iMode,iNum))return iRet;			\
	}
#define PROGN(iMode,iNum)							\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	Progress(iMode,iNum);							\
	}




//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CExeFile::CExeFile()
{
	m_pFiles		=  0;
	m_iFilesMax		=  0;
	m_iFilesNum		=  0;
	m_pErrorText	=  0;
	m_iDoneNow		=  0;
	m_iDoneMax		=  0;
	m_iDoneMode		=  0;
	m_cHasCompress	=  0;

	m_sDataList.Len(1);
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CExeFile::~CExeFile()
{
	if(m_iOpenMode!=CAF_CLOSED)Close();

	Clear();
}

//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
//	Lscht alle Datenfelder und setzt alle Variabeln zurck
void CExeFile::Clear()
{
int		iPos;


	for(iPos=m_iFilesNum-1;iPos>=0;iPos--)
		{
		ExeDel(iPos);
		}
	
	m_sDataList.Del();
	m_iFilesNum = 0;

}


//*****************************************************************************
//*
//*		CmpEx
//*
//*****************************************************************************
int __cdecl CExeFile::CmpEx(const void *pPos1,const void *pPos2)
{
ExeItem	*pPtr1,*pPtr2;

	pPtr1 = *(ExeItem**)pPos1;
	pPtr2 = *(ExeItem**)pPos2;

return strvicmp(pPtr1->pName,pPtr2->pName);
}

//*****************************************************************************
//*
//*		CmpName
//*
//*****************************************************************************
int __cdecl CExeFile::CmpName(const void *pPos1,const void *pPos2)
{
ExeItem	*pPtr1,*pPtr2;

	pPtr1 = *(ExeItem**)pPos1;
	pPtr2 = *(ExeItem**)pPos2;

return strzicmp(pPtr1->pName,pPtr2->pName);
}

//*****************************************************************************
//*
//*		CmpLen
//*
//*****************************************************************************
int __cdecl CExeFile::CmpLen(const void *pPos1,const void *pPos2)
{
ExeItem	*pPtr1,*pPtr2;


	pPtr1 = *(ExeItem**)pPos1;
	pPtr2 = *(ExeItem**)pPos2;

	if(pPtr1->iLen==pPtr2->iLen)return 0;

return (pPtr1->iLen<pPtr2->iLen)? -1:0;
}

//*****************************************************************************
//*
//*		CmpPos
//*
//*****************************************************************************
int __cdecl CExeFile::CmpPos(const void *pPos1,const void *pPos2)
{
ExeItem	*pPtr1,*pPtr2;
int		 iOff1,iOff2;


	pPtr1 = *(ExeItem**)pPos1;
	pPtr2 = *(ExeItem**)pPos2;

	for(iOff1=0;;iOff1++)
		{
		while(pPtr1->pList[iOff1*2]<0);
		}

	for(iOff2=0;;iOff2++)
		{
		while(pPtr2->pList[iOff2*2]<0);
		}


return pPtr1->pList[iOff1*2]-pPtr2->pList[iOff2*2];
}

//*****************************************************************************
//*
//*		Len
//*
//*****************************************************************************
//	Ergibt die Lnge der Datei mit der Indexnummer iNum
//	Ist iMode==0 wird die originale    Lnge zurckgegeben
//	Ist iMode!=0 wird die komprimierte Lnge zurckgegeben
aint64 CExeFile::Len(int iNum,int iMode)
{
ExeItem	*pEntry;

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;
	pEntry=m_pFiles[iNum];

return pEntry->iLen;
}

//*****************************************************************************
//*
//*		SetFail
//*
//*****************************************************************************
//	Setzt das Defekt-Flag und ergibt den alten Wert.
int CExeFile::SetFail(int iNum,int iFail)
{
int		iOld;

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return -1;

	iOld = m_pFiles[iNum]->cError;
	m_pFiles[iNum]->cError = iFail;

return iOld;
}

//*****************************************************************************
//*
//*		IsFail
//*
//*****************************************************************************
//	Ergibt die 1 wenn die Datei mit iNum beschdigt ist sonst 0
int CExeFile::IsFail(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return -1;

return m_pFiles[iNum]->cError;
}

//*****************************************************************************
//*
//*		IsDir
//*
//*****************************************************************************
// Ergibt die 1 wenn die Datei mit iNum ein Verzeichnis ist sonst 0
int CExeFile::IsDir(int iNum)
{

return 0;
}

//*****************************************************************************
//*
//*		IsOk
//*
//*****************************************************************************
// Ergibt:	2	Wenn die Datei vollstntig Entzipt wurde
//          1	Wenn die Datei schon vorhanden war
//			0   Bei Fehlern
int CExeFile::IsOk(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

return m_pFiles[iNum]->cDecomp;
}

//*****************************************************************************
//*
//*		Stats
//*
//*****************************************************************************
//	Die Zustandbits abfragen
//	iNum		: Ist der Name der Datei samt Pfad die geprft werden soll.
//	iSet		: Welche Bits sollen gesetzt werden
//	iDel		: Welche Bits sollen gelscht werden
//	Ergibt einen Wert mit veschiedenen Bits:
//					CAF_STAT_EXIST		0x0001	Wenn die Datei beim Entpacken schon vorhanden war
//					CAF_STAT_DECOMP		0x0002	Wenn die Datei vollstndig neu entpackt wurde (immer ohne CAF_STAT_FILEOK)
//					CAF_STAT_DELETE		0x0004	Die Datei wurde aus dem Verzeichnis gelscht
//					CAF_STAT_WRITE		0x0008	Die Datei muss ins Archiv geschrieben werden
//					CAF_STAT_DIR		0x0010	Die Datei ist ein Verzeichniss
//					CAF_STAT_READONLY	0x0020	Die Datei ist schreibgeschtzt
//					CAF_STAT_SAVED		0x0040	Die Datei ist im Archiv gespeichert
int CExeFile::Stats(int iNum)
{
ExeItem	   *pEntry;
int			iBits;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)				// Prfe den Index
		{
		return 0;
		}

			pEntry=m_pFiles[iNum];
	iBits = pEntry->cDecomp&3;
	iBits|= CAF_STAT_SAVED;
	

return iBits;	
}


//*****************************************************************************
//*
//*		Time
//*
//*****************************************************************************
// Ergibt die Zeit der letzten nderung einer Datei
// bzw.	CAF_ERROR_MISS wenn iNum/Datei nicht gefunden wurde.
time_t CExeFile::Time(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return CAF_ERROR_MISS;

return m_pFiles[iNum]->iTime;
}

time_t CExeFile::Time(int iNum,int iMode)
{
	if((unsigned)iNum>=(unsigned)m_iFilesNum)
		{
		return CAF_ERROR_MISS;
		}


return m_pFiles[iNum]->iTime;
}


//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Holt den Dateinamen einer Archivdatei.
//	iNum		: Ist die Indexnummer der Datei (-1=Archiv-Datei)
//	Ergibt eine Zeiger auf den Dateinamen der Datei bzw. NULL bei einem Fehler.
zchar *CExeFile::Name(int iNum)
{

	if((unsigned)iNum<(unsigned)m_iFilesNum)			// Prfe den Dateiindex
		{
		return m_pFiles[iNum]->pName;
		}

	if(iNum==-1)										// Name der Archiv-Datei
		{
		return m_cFilePath;
		}

return NULL;
}


//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Holt den Dateinamen einer Archivdatei samt Lnge.
//	iNum		: Ist die Indexnummer der Datei (-1=Archiv-Datei)
//	iLen		: Hier wird die Lnge des Namens gespeichert
//	Ergibt eine Zeiger auf den Dateinamen der Datei bzw. NULL bei einem Fehler.
zchar *CExeFile::Name(int iNum,int &iLen)
{


	if((unsigned)iNum<(unsigned)m_iFilesNum)			// Prfe den Dateiindex	
		{
		iLen = m_pFiles[iNum]->uNameLen;
		return m_pFiles[iNum]->pName;
		}

	if(iNum==-1)										// Name der Archiv-Datei
		{
		iLen = strzlen(m_cFilePath);					
		return m_cFilePath;
		}

	iLen = 0;


return NULL;
}

//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
//	Sortiert die Liste in m_pFiles
//  iMode:	CAF_FLAG_SORT			0x0400	Nach Namen  sortieren
//			CAF_FLAG_SORTLEN	    0x0500	Nach Lngen sortieren
//			CAF_FLAG_SORTPOS	    0x0600	Nach Offset sortieren (intern)
//			CAF_FLAG_SORTEX			0x0700	Nach Namen mit Zahlen Bercksichtigung
int	CExeFile::Sort(int iMode)
{

		iMode&=0x0700;
	if(!iMode)iMode=m_iModeFlags&0x0700;
	iMode |= 0x0400;

	PROGR(CAF_PROG_SORT,-1,0);


	if(!m_pFiles)return 0;

	if(iMode==m_iSortMode)								// Ist die Liste bereits sortiert
		{
		return m_iFilesNum;
		}

	if(m_iFilesNum)
		{
		switch(iMode)
			{
		case    CAF_FLAG_SORTEX:	qsort(m_pFiles,m_iFilesNum,sizeof(ExeItem*),CmpEx  );break;
		case    CAF_FLAG_SORTLEN:	qsort(m_pFiles,m_iFilesNum,sizeof(ExeItem*),CmpLen );break;
		case    CAF_FLAG_SORTPOS:	qsort(m_pFiles,m_iFilesNum,sizeof(ExeItem*),CmpPos );break;
		default:					qsort(m_pFiles,m_iFilesNum,sizeof(ExeItem*),CmpName);break;
			}
		}

	m_iModeFlags&=~0x0300;
	m_iModeFlags|= 0x0300&iMode;
	m_iSortMode  = iMode;


return m_iFilesNum;
}

//*****************************************************************************
//*
//*		OpenArch
//*
//*****************************************************************************
//	ffnet eine BZIP2-Datei und liest alle bereits gespeicherten Dateien ein.
//	Zuvor wurde eine Datei bzw. ein Speicherbereich in CArchiveFile::Open geffnet.
//	iLevel	: Komprimierungs Levl (0-9) 9=maximal  (unbenutzt)
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//					CAF_ERROR_OK		Alles ok
//					CAF_ERROR_NONE		Wenn die Datei nicht gefunden werden konnte
//					CAF_ERROR_OPEN		Wenn die Datei nicht geffnet werden konnte
//					CAF_ERROR_CREATE	Wenn die Datei nicht erzeugt  werden konnte
//					CAF_ERROR_READ		Bei Lese-Fehlern
//					CAF_ERROR_FORM		Bei Fehlern im TAR-Datei
//					CAF_ERROR_MULTI		Wenn Zib ber mehere Disketten geht
//					CAF_ERROR_LOGIC		Bei internen unbekannten Fehlern
int CExeFile::ArchOpen(int iLevel)
{
ExeItem				   *pEntry=0;
BYTE					aMem[2048];
int						iFound;
int						iPos;




	Clear();

	m_iDoneNow		= 0;
	m_iDoneMax		= 0;
	m_iDoneMode		= 0;
	m_iErrorCode	= CAF_ERROR_OK;
	m_uExeSize		= (unsigned)m_iFileSize;
	
	if(m_hFile!=INVALID_HANDLE_VALUE)
		{
		m_uFileTime	= FileTime(m_cFilePath);
		}
	else{
		m_uFileTime = (unsigned)time(0);
		}
		


//*****************************************************************************


try	{
	if(m_uExeSize<1024)
		{
		throw CAF_ERROR_FORM;
		}


	iFound	= 0;

	if(MainRead(aMem,1024)!=1024)
		{
		throw CAF_ERROR_FORM;
		}
														// Suche PE-Format
	if(aMem[0]=='P' && aMem[1]=='E' && aMem[2]==0 && aMem[3]==0)
		{
		iPos   = 0;
		iFound = 1;
		}
	else if(aMem[0]=='M' && aMem[1]=='Z')				// DOS-Header gefunden
		{
		iPos   = *(int*)(aMem+60);

		if(iPos<64 || iPos>4096)
			{
			throw CAF_ERROR_FORM;
			}

		MainSeek(iPos);

		if(MainRead(aMem,1024)!=1024)
			{
			throw CAF_ERROR_FORM;
			}

		if(aMem[0]=='P' && aMem[1]=='E' && aMem[2]==0 && aMem[3]==0)
			{
			iFound = 1;
			}
		}


	if(!iFound)											// Kein Format gefunden
		{
		throw CAF_ERROR_FORM;
		}

	switch(iFound)
		{
	case 1:	ScanPe(aMem,iPos);
		}
	}
catch(int iError)										// Bekannter Fehler
	{
	m_iErrorCode=iError;
	PROGN(CAF_PROG_ERROR,-1);
	Break();
	return iError;
	}

	if(m_iModeFlags&CAF_FLAG_SORT)Sort();				// Sortieren ?

	m_iErrorCode = CAF_ERROR_OK;
	m_iDoneNow	 = m_iDoneMax;



return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht nach einer Datei in der Dateiliste
//	pName	: Ist der  Dateiname nach dem gesucht wird
//	Ergibt die Indexnummer der Datei, bzw. -1 wenn die Datei nicht gefunden wurde.
int CExeFile::Find(const zchar *pName)
{
ExeItem	*pEntry;
unsigned uLen;
int		 iPos;


	if(*pName=='/' )pName++;
	if(*pName=='\\')pName++;


	uLen = (int)strzlen(pName);

	for(iPos=0;iPos<m_iFilesNum;iPos++)						// Eintrag in Kette
		{
		   pEntry=m_pFiles[iPos];
		if(pEntry->uNameLen!=uLen)continue;

		if(!CmpFileNameN(pName,pEntry->pName))
			{
			return iPos;
			}
		}


return -1;
}

//*****************************************************************************
//*
//*		ExeDel
//*
//*****************************************************************************
//	Listeneintrag lschen
void CExeFile::ExeDel(int iNum)
{
ExeItem	*pEntry;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;

	pEntry = m_pFiles[iNum];

	if(!pEntry)return;

	m_iFilesNum--;
	m_pFiles[iNum]=0;

	if(iNum<m_iFilesNum)
		{
		memmove(m_pFiles+iNum,m_pFiles+iNum+1,(m_iFilesNum-iNum)*sizeof(m_pFiles[0]));
		}

	if(pEntry->pName)delete pEntry->pName;
	if(pEntry->pList!=pEntry->aList)delete pEntry->pList;

	delete pEntry;

	if(m_iFilesNum<=0)
		{
		delete  m_pFiles;
		m_iFilesNum	 = 0;
		m_iFilesMax	 = 0;
		}

}

//*****************************************************************************
//*
//*		ExeNew
//*
//*****************************************************************************
//	Listeneintrag erzeugen
int	CExeFile::ExeNew()
{
ExeItem	**pNew;



	if(!m_pFiles || !m_iFilesMax)							// Neue Kette
		{
		m_pFiles = new ExeItem*[EXE_NEW_ADD];
		memset(m_pFiles,0,sizeof(ExeItem*[EXE_NEW_ADD]));
		m_iFilesMax=EXE_NEW_ADD;
		}

	if(m_iFilesNum >= m_iFilesMax)							// Kette vergrern
		{
		pNew = new ExeItem*[m_iFilesMax+EXE_NEW_ADD];
		memset(pNew+m_iFilesMax,0,sizeof(ExeItem*[EXE_NEW_ADD]));
		memcpy(pNew,m_pFiles     ,sizeof(ExeItem*)*m_iFilesMax);
		delete m_pFiles;

		m_pFiles	= pNew;
		m_iFilesMax+= EXE_NEW_ADD;
		}


		   m_pFiles[m_iFilesNum] = new    ExeItem;
	memset(m_pFiles[m_iFilesNum],0,sizeof(ExeItem));
		   m_iFilesNum++;



return m_iFilesNum-1;
}

//*****************************************************************************
//*
//*		Break
//*
//*****************************************************************************
//	Bearbeitung abbrechen ohne Daten zu speichern
void CExeFile::Break()
{

	ReleaseData();
	m_iOpenMode=CAF_CLOSED;
	Clear();

}

//*****************************************************************************
//*
//*		Close
//*
//*****************************************************************************
//	Schliet das EXE-Datei und speichert alle Daten.
//	Ergibt;	CAF_ERROR_LOGIC		Bei einem Internen Fehler
//			CAF_ERROR_OK		Wenn alles stimmte
//			CAF_ERROR_WRITE		Problemen beim Schreiben
//			... siehe Error Codes
int CExeFile::Close()
{


	m_iErrorCode = CAF_ERROR_OK;

	if(m_iOpenMode==CAF_CLOSED)
		{
		m_iOpenMode  = CAF_CLOSED;
		m_iErrorCode = CAF_ERROR_MISS;
		PROGN(CAF_PROG_ERROR,-1);
		return CAF_ERROR_MISS;
		}

	ReleaseData();
	m_iOpenMode = CAF_CLOSED;


return CAF_ERROR_OK;
}


//*****************************************************************************
//*
//*		ExtractProc
//*
//*****************************************************************************
//	Extrahiert eine Datei aus dem Archiv ber eine Ausgabefunktion
//	iNum	: Ist die Indexnummer der Datei die geprft werden soll
//	pParam	: Ist ein Parameter der an die Ausgabefunktionbergeben wird
//	pProc	: Ist der Zeiger auf die Ausgabefunktion
//	pInfo	: Hier werden Zeiten und Attribute der Datei gespeichert.
//			  Bei NULL werden diese Werte ignoriert.
//	Ergibt 0 wenn ok, oder eine Fehlernummer ungleich 0:
//				CAF_ERROR_OK		= Wenn alles korrekt war
//				CAF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//				CAF_ERROR_PATH		= Pfad ungltig ist.
//				CAF_ERROR_FCREATE	= Wenn Datei nicht erzeugt werden konnte
//				CAF_ERROR_CRC		= Crc32 Fehler
//				CAF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//				CAF_ERROR_IGNORE	= Die Datei wurde bersprungen
//				... siehe Fehler Codes
int	CExeFile::ExtractProc(int iNum,void *pParam,OutProc pProc,FileData *pInfo)
{
char		aBuffer[2048];
ExeItem	   *pEntry;
int			iSize;
int			iIdx;
int			iOff;


	if(m_iDoneMode<=1)										// Verlaufsanzeige starten
		{
		m_iDoneMode	= 1;
		m_iDoneNow	= 0;
		m_iDoneMax	= 0;
		}

	m_iErrorCode = CAF_ERROR_OK;

	try	{

		if( m_iOpenMode==CAF_CLOSED             )throw CAF_ERROR_MISS;
		if((unsigned)iNum>=(unsigned)m_iFilesNum)throw CAF_ERROR_MISS;

			pEntry=m_pFiles[iNum];
		if(!pEntry)throw CAF_ERROR_MISS;

		if(m_iDoneMode==1)									// Verlaufsanzeige einstellen
			{
			m_iDoneNow   = 0;
			m_iDoneMax   = pEntry->iLen;
			}


		m_pErrorFile = pEntry->pName;

		if(pEntry->cError)throw CAF_ERROR_READ;


		for(iIdx=0;pEntry->pList[iIdx*2];iIdx++)			// Die Datei speichern
			{
			if(pEntry->pList[iIdx*2]<0)
				{
				iSize = pEntry->pList[iIdx*2+1];

				if(pProc(pParam,(char*)m_sDataList[-pEntry->pList[iIdx*2]-1],iSize)!=iSize)
					{
					throw CAF_ERROR_FWRITE;
					}

				m_iDoneNow += iSize;
				continue;
				}

			MainSeek(pEntry->pList[iIdx*2],SEEK_SET);

			for(iOff=0;iOff<pEntry->pList[iIdx*2+1];iOff+=iSize)
				{
				   iSize = pEntry->pList[iIdx*2+1]-iOff;
				if(iSize>2048)iSize=2048;

				if(MainRead(aBuffer,iSize)!=iSize)
					{
					throw CAF_ERROR_READ;
					}

				if(pProc(pParam,aBuffer,iSize)!=iSize)
					{
					throw CAF_ERROR_FWRITE;
					}

				m_iDoneNow += iSize;
				}
			}
		
		if(pProc(pParam,NULL,0)!=0)							// Ende anzeigen
			{
			throw CAF_ERROR_FWRITE;
			}

		if(pInfo)
			{
			pInfo->dwAttr		= SYS_READ;
			pInfo->dwSize		= pEntry->iLen;
			pInfo->dwTimeWrite	= m_uFileTime;
			pInfo->dwTimeAccess	= 0;
			pInfo->dwTimeCreate	= 0;
			pInfo->cName[0]		= 0;
			}
		}

	catch(int iError)
		{
		m_iErrorCode=iError;
		PROGN(CAF_PROG_ERROR,iNum);
		}

	if(m_iDoneMode<=1)										// Die Verlaufsanzeige zurcksetzen
		{
		m_iDoneMode = 0;
		m_iDoneNow  = m_iDoneMax;
		}



return m_iErrorCode;
}


//*****************************************************************************
//*
//*		TimeConvert
//*
//*****************************************************************************
//	pTime[0] = Year;			Jahr (+1900)
//	pTime[1] = Month;			Monat (1=Jan)
//	pTime[2] = Day;				Day (1-31)
//	pTime[3] = Hour;			Stunde
//	pTime[4] = Minute;			Minute
//	pTime[5] = Secound;			Sekunde
//	pTime[6] = Timezone;		Zeitzone in 15min Schritten
time_t CExeFile::TimeConvert(unsigned char *pTime)
{
struct tm	sTime;
time_t		iTime;


	sTime.tm_year	= pTime[0];
	sTime.tm_mon	= pTime[1]-1;
	sTime.tm_mday	= pTime[2];
	sTime.tm_hour	= pTime[3];
	sTime.tm_min	= pTime[4];
	sTime.tm_sec	= pTime[5];
	sTime.tm_isdst	= 0;

	iTime  = mktime(&sTime);
	iTime += ((char)pTime[6])*15*60;

	if(iTime<0)iTime=0;


return iTime;
}

//*****************************************************************************
//*
//*		TimeConvertE
//*
//*****************************************************************************
//	pTime[0] = Year;			Jahr (+1900)
//	pTime[1] = Month;			Monat (1=Jan)
//	pTime[2] = Day;				Day (1-31)
//	pTime[3] = Hour;			Stunde
//	pTime[4] = Minute;			Minute
//	pTime[5] = Secound;			Sekunde
//	pTime[6] = Timezone;		Zeitzone in 15min Schritten
time_t CExeFile::TimeConvertE(unsigned char *pTime)
{
time_t		iTime;
struct tm	sTime;
int			iOff;


	sTime.tm_year	= (*(WORD*)(pTime+2))-1900;
	sTime.tm_mon	= pTime[3]-1;
	sTime.tm_mday	= pTime[4];
	sTime.tm_hour	= pTime[5];
	sTime.tm_min	= pTime[6];
	sTime.tm_sec	= pTime[7];
	sTime.tm_isdst	= 0;

	iTime  = mktime(&sTime);

	if(iTime<0)return 0;

	iOff   = *(WORD*)(pTime);
	iOff  &= 0x0FFF;

	if(iOff&0x0800)iOff|=~0x0FFF;

	if(iOff>=-1440 && iOff<=1440)
		{
		iTime += iOff*60;
		if(iTime<0)return 0;
		}



return iTime;
}

//*****************************************************************************
//*
//*		Count
//*
//*****************************************************************************
//	Ergibt die Anzahl der Eintrge in der Dateiliste
int CExeFile::Count()
{
	return m_iFilesNum;
}



//*****************************************************************************
//*
//*		SetDoneMode
//*
//*****************************************************************************
//	Den Modus fr die Verlaufsanzeige setzen.
//	iMode	: Ist der neue Modus
//			    0 = Zurck zu Normal (Ende)
//				1 = Begin von Extract (einzelene Datei)
//				2 = Begin von ExtractAll
//	Ergibt den vorherigen Modus.
int CExeFile::SetDoneMode(int iMode)
{
int		iRet;

	
	iRet = m_iDoneMode;
	
	switch(iMode)
		{
	case 0:													// Zurck zu Normal (Ende)

		if(m_iDoneMode==1 || m_iDoneMode==2)
		if(m_iErrorCode==CAF_ERROR_OK)
			{
			m_iDoneNow  = m_iDoneMax;
			}

		m_iDoneMode	 = 0;
		break;

	case 1:													// Begin von Extract (einzelene Datei)

		if(iRet==2)return iRet;
		m_iDoneNow		= 0;
		m_iDoneMax		= 0;
		m_iDoneMode		= 0;
		break;

	case 2:													// Begin von ExtractAll

		m_iDoneNow		= 0;
		m_iDoneMax		= 0;
		m_iDoneMode		= 1;
		break;
		}


return iRet;
}




//*****************************************************************************
//*
//*		Done
//*
//*****************************************************************************
//	Fragt den aktuellen Verlauf bei Open,Extract,Close,Flush ab
//	pMax	: Wenn ungleich 0 wird hier das Maximum gespeichert
//	Ergibt den aktuellen Verlauf
aint64	CExeFile::Done(aint64 *pMax)
{
aint64	iRet;


	iRet = m_iDoneNow;

	if(iRet>m_iDoneMax)iRet=m_iDoneMax;
	if(pMax)*pMax=m_iDoneMax;


return iRet;
}



//*****************************************************************************
//*
//*		GetUserPtr
//*
//*****************************************************************************
//	User-Pointer abfragen
void *CExeFile::GetUserPtr(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

return m_pFiles[iNum]->pUserPtr;
}

//*****************************************************************************
//*
//*		SetUserPtr
//*
//*****************************************************************************
//	User-Pointer einstellen
void CExeFile::SetUserPtr(int iNum,void *pData)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;

	m_pFiles[iNum]->pUserPtr = pData;

}

//*****************************************************************************
//*
//*		RvaToOffset
//*
//*****************************************************************************
unsigned CExeFile::RvaToOffset(unsigned uRva,unsigned uCount,SectionHeader *pSections)
{
unsigned	uNum;
unsigned	uPos;
unsigned	uAdr;
unsigned	uOff;


	for(uPos=0;;uPos++)									// Suche den Abschnitt
		{
		if(uPos>=uCount)break;

		uNum = (pSections[uPos].Misc.VirtualSize+0x1FF)&~0x1FF;
		uOff =  pSections[uPos].PointerToRawData;
		uAdr =  pSections[uPos].VirtualAddress;

		if(uRva>=uAdr && uRva<uAdr+uNum)
			{
			return uRva+uOff-uAdr;
			}
		}


return 0;
}

//*****************************************************************************
//*
//*		CheckImage
//*
//*****************************************************************************
//	Prft ob eine Recource ein Bild ist
//	pEntry		: Ist der Dateieintrag
//	pName		: Puffer zum aktuellen Namen der Recource
//	uSize		: Ist die Lnge des Namens in Zeichen
//	pData		: Pufferspeicher zur freien Verfgung
//	Ergibt 1 wenn es ein Bild ist
int CExeFile::CheckImage(ExeItem *pEntry,zchar *pName,unsigned &uSize,unsigned char *pData)
{
char	cBuffer[64];
zchar  *pSuffix;
int		iType;



	MainSeek(pEntry->pList[0]);

	if(MainRead(cBuffer,64)!=64)return 0;

	cBuffer[63] =  0;
	iType		= -1;

	if(!strncmp(cBuffer,"II"     ,2))iType=4;				// Format ermitteln
	if(!strncmp(cBuffer,"MM"     ,2))iType=4;
	if(!strncmp(cBuffer,"GIF87a" ,6))iType=2;
	if(!strncmp(cBuffer,"GIF89a" ,6))iType=2;
	if(!strncmp(cBuffer,"\x89PNG",4))iType=3;
	if(!strncmp(cBuffer,"BM"     ,2))iType=0;
	if( strstr (cBuffer,"JFIF"     ))iType=1;
	if( cBuffer[0]=='\xFF' && cBuffer[1]=='\xD8')iType=1;
	if( cBuffer[0]=='\xFF' && cBuffer[1]=='\xDB')iType=1;

	switch(iType)
		{
	case 0:	pSuffix="bmp";	break;
	case 1:	pSuffix="jpg";	break;
	case 2:	pSuffix="gif";	break;
	case 3:	pSuffix="png";	break;
	case 4:	pSuffix="tiff";	break;
	default:return 0;
		}

	if(uSize<4 || pName[uSize-4]!='.')return 0;


	strzcpy(pName+uSize-3,pSuffix);

	if(iType==4)uSize++;


return 1;
}


//*****************************************************************************
//*
//*		AddBitmap
//*
//*****************************************************************************
int CExeFile::AddBitmap(unsigned uOffset,unsigned uSize,unsigned char *pMem)
{
BitmapInfo	sInfo;
int			iBytes;


	MainSeek(uOffset);

	if(MainRead(&sInfo,sizeof(sInfo))!=sizeof(sInfo))return 0;

	iBytes	= sInfo.biSizeImage;

	if(!iBytes)
		{
		iBytes	= sInfo.biWidth*sInfo.biBitCount;
		iBytes += 31;
		iBytes /= 32;
		iBytes *= 4;
		iBytes *= sInfo.biHeight;
		}

	pMem[0]			= 'B';
	pMem[1]			= 'M';
	*(int*)(pMem+2)	= uSize+14;
	*(int*)(pMem+6)	= 0;
	*(int*)(pMem+10)= uSize+14-iBytes;



return -1-m_sDataList.Add(pMem,-1,14);
}

//*****************************************************************************
//*
//*		AddString
//*
//*****************************************************************************
int CExeFile::AddString(unsigned uOffset,unsigned uSize,unsigned char *pMem,ExeItem *pEntry)
{
char	   *pFree;
char	   *pText;
wchar_t	   *pWide;
unsigned	uChar;
unsigned 	uOff;
unsigned 	uLen;
unsigned 	uAdd;
int			iPos;
int			iRet;
int			iNum;
int			iId;



	pFree = 0;

	if(uSize>512)										// Speicher allokieren
		{
		pFree	= new char[uSize*3+32];
		pText	= pFree+uSize;
		pWide	= (wchar_t*)pFree;
		}
	else{
		pWide	= (wchar_t*)(pMem);
		pText	= (char   *)(pMem+512);
		}

	MainSeek(uOffset);

	if(MainRead(pWide,uSize)^uSize)return 0;				// Lade Recource

	memcpy(pText,"\xEF\xBB\xBF",4);

	iId		= (pEntry->uId-1)*16;
	uSize  /= 2;
	iPos	= 3;
	uOff	= 0;

	for(iNum=0;iNum<16;iNum++)							// Texte erstellen
		{
		if(uOff>=uSize)break;

		uLen  = pWide[uOff];
		uOff += 1;

		if(uLen==0)continue;							// Leerer Eintrag
		if(uOff+uLen>uSize)break;

		iPos += sprintf(pText+iPos,"%u=\"",iId+iNum);

		while(uLen>0)									// String umwandeln
			{
			uAdd  = utf16tochar(pWide+uOff,uChar);
			uOff += uAdd;
			uLen -= uAdd;

			if(uOff>uSize)break;

			if(uChar<' ' || uChar=='"' || uChar=='\\')
					iPos += ctostr(uChar,pText+iPos,1);
			else	iPos += chartoutf8(pText+iPos,uChar);
			}

		iPos += sprintf(pText+iPos,"\"\n");
		}


	pEntry->pList[2]	= 0;							// Ende in Liste
	pEntry->pList[1]	= iPos;
	pEntry->iLen		= iPos;

	iRet = -1-m_sDataList.Add(pText,-1,iPos);

	if(pFree)delete pFree;



return iRet;
}

//*****************************************************************************
//*
//*		AddIcon
//*
//*****************************************************************************
int CExeFile::AddIcon(unsigned uOffset,unsigned uSize,unsigned char *pMem,ExeItem *pEntry)
{
IconEntry      *pList;
ItemDir	       *pDir;
unsigned		uPos;
unsigned		uLen;



	if(uSize<sizeof(ItemDir))return 0;

	pDir	= 	(ItemDir  *)(pMem);
	pList	=	(IconEntry*)(pMem+6);

	MainSeek(uOffset);

	if(MainRead(pDir,sizeof(ItemDir))!=sizeof(ItemDir))return 0;

	if(pDir->idCount>32)return 0;
	if(pDir->idCount< 1)return 0;
	if(pDir->idType!= 1)return 0;

	for(uPos=0;uPos<pDir->idCount;uPos++)
		{
		if(MainRead(pList+uPos,14)!=14)return 0;
		pList[uPos].dwImageOffset &= 0xFFFF;
		}

	if(pDir->idCount>1)
		{
		pEntry->pList	= new int[pDir->idCount*2+3];
		}

	uLen				= 6+pDir->idCount*16;
	pEntry->pList[2]	= 0;
	pEntry->pList[1]	= uLen;
	pEntry->iLen		= uLen;



return -1-m_sDataList.Add(pMem,-1,uLen);
}

//*****************************************************************************
//*
//*		AddCursor
//*
//*****************************************************************************
int CExeFile::AddCursor(unsigned uOffset,unsigned uSize,unsigned char *pMem,ExeItem *pEntry)
{
unsigned char 	aData[16];
IconEntry      *pList;
ItemDir	       *pDir;
CursorEntry		sCur;
unsigned		uPos;
unsigned		uLen;
unsigned		uCol;



	if(uSize<sizeof(ItemDir))return 0;

	pDir	= 	(ItemDir       *)(pMem);
	pList	=	(IconEntry     *)(pMem+6);

	MainSeek(uOffset);

	if(MainRead(pDir,sizeof(ItemDir))!=sizeof(ItemDir))return 0;

	if(pDir->idCount>32)return 0;
	if(pDir->idCount< 1)return 0;
	if(pDir->idType!= 2)return 0;

	for(uPos=0;uPos<pDir->idCount;uPos++)
		{
		if(MainRead(aData,14)!=14)return 0;

		uCol = *(unsigned short*)(aData+6);
		uCol = (uCol<=1)? 0:1<<uCol;

		sCur.bWidth			= aData[0];
		sCur.bHeight		= aData[2];
		sCur.bColorCount	= uCol;
		sCur.bReserved		= 0;
		sCur.wHotSpotX		= 0;
		sCur.wHotSpotY		= 0;
		sCur.dwBytesInRes	= (*(unsigned int  *)(aData+ 8))-4;
		sCur.dwImageOffset	= (*(unsigned short*)(aData+12));

		memcpy(pList+uPos,&sCur,16);
		}

	if(pDir->idCount>1)
		{
		pEntry->pList	= new int[pDir->idCount*2+3];
		}

	uLen				= 6+pDir->idCount*16;
	pEntry->pList[2]	= 0;
	pEntry->pList[1]	= uLen;
	pEntry->iLen		= uLen;



return -1-m_sDataList.Add(pMem,-1,uLen);
}

//*****************************************************************************
//*
//*		ScanPe
//*
//*****************************************************************************
void CExeFile::ScanPe(unsigned char *pMem,int iOffset)
{
SectionHeader  *pSections;
SectionHeader	aSect[32];
zchar			cFull[128];
zchar			cText[128];
unsigned short	aSpot[ 2];
int				aSize[32];
RerourceDir	   *aDirs[32];
RerourceDir	   *pDirR;
CursorEntry	   *pCursor;
ExeItem		   *pEntry;
ExeItem		   *pItem;
IconEntry	   *pList;
ItemDir		   *pDir;
unsigned short *pName;
char		   *pRsrc;
zchar		   *pSuffix;
zchar		   *pPtr;
DWORD		   *pData;
DWORD		   *pRes;
DWORD			uTypEx;
DWORD			uType;
unsigned		uCount;
unsigned		uOffset;
unsigned		uIcons;
unsigned		uLang;
unsigned		uAddr;
unsigned		uChar;
unsigned		uPos;
unsigned		uNum;
unsigned		uLen;
unsigned		uFind;
unsigned 		uSize;
unsigned		uCpu;
unsigned		uVal;
unsigned		uAdd;
int				iIdx;
int				iLevel;


	uCpu		= *(unsigned short*)(pMem+4);
	uNum		= *(unsigned short*)(pMem+20);
	uAdd		= (uCpu==0x8664)? 16:0;

	uOffset		= *(unsigned*)(pMem+uAdd+136);
	uCount		= *(unsigned*)(pMem+uAdd+116);
	uSize		= *(unsigned*)(pMem+uAdd+140);

	if(uNum>1024-16*sizeof(SectionHeader) || uCount>32 || uCount==0)
		{
		return;
		}

	memcpy(aSect,pMem+uNum+24,sizeof(SectionHeader)*uCount);
	pSections	=  aSect;

	if(uCount>16)uCount=16;

	    uOffset = RvaToOffset(uOffset,uCount,pSections);
	if(!uOffset || uOffset>=m_uExeSize || uOffset+uSize>m_uExeSize || uSize>0x70000000 || uSize<=0)
		{
		return;
		}

		pRsrc	= new char[uSize];
	if(!pRsrc)throw CAF_ERROR_MEM;

	MainSeek(uOffset);

	if(MainRead(pRsrc,uSize)!=(int)uSize)
		{
		delete pRsrc;
		throw CAF_ERROR_FORM;
		}



	aDirs[0] = (RerourceDir*)pRsrc;
	aSize[0] = 0;
	iLevel	 = 0;
	uIcons	 = 0;

	while(iLevel>=0)									// Alle Ebenen in den Recourcen absuchen
		{
		pDirR	= aDirs[iLevel];
		pData	= (DWORD*)PTR_ADD(pDirR,16);
		uNum	= pDirR->NumberOfIdEntries+pDirR->NumberOfNamedEntries;

		for(uPos=aSize[iLevel];uPos<uNum;uPos++)
			{
						 uAddr = pData[uPos*2+1];
			if(iLevel==2)uLang = pData[uPos*2];
			if(iLevel==1)uType = pData[uPos*2];
			if(iLevel==0)uTypEx= pData[uPos*2];

			if(uAddr&0x80000000)						// Gibt es eine weitere Ebene
				{
				if(iLevel>=31)continue;

				aSize[iLevel] = uPos+1;
				iLevel       += 1;
				uAddr        &= 0x7FFFFFFF;
				aDirs[iLevel] = (RerourceDir*)PTR_ADD(pRsrc,uAddr);
				aSize[iLevel] = 0;
				iLevel       += 1;

				break;
				}

			if(uTypEx&0x80000000)						// Resurce hat einen Typnamen
				{
				pName = (unsigned short*)PTR_ADD(pRsrc,uTypEx&0x7FFFFFFF);

				for(uChar=0;uChar<(unsigned)(*pName&0x1F);uChar++)
					{
					#ifndef UNICODE
					if(pName[uChar+1]>0xFF){cText[uChar]=(zchar)0xFF;continue;}
					#endif
					cText[uChar] = (zchar)pName[uChar+1];
					}

				cText[uChar]=0;
				pSuffix = Z(".bin");
				}
			else do										// Resurce hat eine Typ-ID
				{
				pSuffix = Z(".bin");
				if(uTypEx==(DWORD)RT_ACCELERATOR  ){strzcpy(cText,Z("RT_ACCELERATOR" ));					break;}
				if(uTypEx==(DWORD)RT_ANICURSOR	  ){strzcpy(cText,Z("RT_ANICURSOR"	 ));					break;}
				if(uTypEx==(DWORD)RT_ANIICON	  ){strzcpy(cText,Z("RT_ANIICON"	 ));					break;}
				if(uTypEx==(DWORD)RT_BITMAP		  ){strzcpy(cText,Z("RT_BITMAP"		 ));pSuffix=Z(".bmp");	break;}
				if(uTypEx==(DWORD)RT_CURSOR		  ){strzcpy(cText,Z("RT_CURSOR"	  	 ));					break;}
				if(uTypEx==(DWORD)RT_DIALOG		  ){strzcpy(cText,Z("RT_DIALOG"	  	 ));					break;}
				if(uTypEx==(DWORD)RT_FONT		  ){strzcpy(cText,Z("RT_FONT"		 ));					break;}
				if(uTypEx==(DWORD)RT_FONTDIR	  ){strzcpy(cText,Z("RT_FONTDIR"	 ));					break;}
				if(uTypEx==(DWORD)RT_TOOLBAR	  ){strzcpy(cText,Z("RT_TOOLBAR"	 ));					break;}
				if(uTypEx==(DWORD)RT_DLGINIT	  ){strzcpy(cText,Z("RT_DLGINIT"	 ));					break;}
				if(uTypEx==(DWORD)RT_GROUP_CURSOR ){strzcpy(cText,Z("RT_GROUP_CURSOR"));pSuffix=Z(".cur");	break;}
				if(uTypEx==(DWORD)RT_GROUP_ICON	  ){strzcpy(cText,Z("RT_GROUP_ICON"  ));pSuffix=Z(".ico");	break;}
				if(uTypEx==(DWORD)RT_HTML 	      ){strzcpy(cText,Z("RT_HTML"		 ));pSuffix=Z(".htm");	break;}
				if(uTypEx==(DWORD)RT_ICON		  ){strzcpy(cText,Z("RT_ICON"		 ));					break;}
				if(uTypEx==(DWORD)RT_MENU		  ){strzcpy(cText,Z("RT_MENU"		 ));					break;}
				if(uTypEx==(DWORD)RT_MESSAGETABLE ){strzcpy(cText,Z("RT_MESSAGETABLE"));					break;}
				if(uTypEx==(DWORD)RT_RCDATA		  ){strzcpy(cText,Z("RT_RCDATA"		 ));					break;}
				if(uTypEx==(DWORD)RT_STRING		  ){strzcpy(cText,Z("RT_STRING"		 ));pSuffix=Z(".txt");	break;}
				if(uTypEx==(DWORD)RT_VERSION 	  ){strzcpy(cText,Z("RT_VERSION"	 ));					break;}
				if(uTypEx==(DWORD)RT_MANIFEST     ){strzcpy(cText,Z("RT_MANIFEST"	 ));pSuffix=Z(".txt");	break;}
				szprintf(cText,Z("RT_%i"),uTypEx);
				}while(0);


			if(iLevel>0)								// Gibte es eine ID bzw. Unternamen
				{
				strzcat(cText,Z("_"));

				if(uType&0x80000000)					// Ein Name ist vorhanden
					{
					pName = (unsigned short*)PTR_ADD(pRsrc,uType&0x7FFFFFFF);
					pPtr  = cText+strzlen(cText);

					for(uChar=0;uChar<(unsigned)(*pName&0x1F);uChar++)
						{
						#ifndef UNICODE
						if(pName[uChar+2]>0xFF){cText[uChar]=(zchar)0xFF;continue;}
						#endif
						pPtr[uChar] = (zchar)pName[uChar+1];
						}

					pPtr[uChar]=0;

					while(uChar>0)						// Ist ein Dateisuffix vorhanden
						{
						uChar--;
						if(pPtr[uChar]!='.')continue;

						if(uTypEx&0x80000000 || !strzicmp(pSuffix,pPtr+uChar))
							{
							pSuffix = Z("");
							}
						}
					}
				else{									// Eine ID ist vorhanden
					uVal = (uTypEx==(DWORD)RT_STRING)? (uType-1)*16:uType;
					szprintf(cText+strzlen(cText),Z("%i"),uVal);
					}

				strzcat(cText,pSuffix);
				}

			pRes = (DWORD*)PTR_ADD(pRsrc,uAddr);

			if(iLevel>=2)
				{
				uLen = szprintf(cFull,Z("%u/%s"),uLang,cText);
				}
			else{
				uLen = szprintf(cFull,Z("%s"),cText);
				}

			iIdx				= ExeNew();
			pEntry				= m_pFiles[iIdx];

			pEntry->pList		= pEntry->aList;
			pEntry->pName		= new zchar[uLen+1];
			pEntry->uNameLen	= uLen;
			pEntry->uType		= (WORD)uTypEx;
			pEntry->uLang		= uLang;
			pEntry->uId			= (WORD)((uType&0x80000000)? 0xFFFF:uType);

			if(uTypEx==(DWORD)RT_BITMAP)
				{
				uOffset			= RvaToOffset(pRes[0],uCount,pSections);
				pEntry->pList[0]= AddBitmap(uOffset,pRes[1],pMem);
				pEntry->pList[1]= 14;
				pEntry->pList[2]= uOffset;
				pEntry->pList[3]= pRes[1];
				pEntry->pList[4]= 0;
				pEntry->iLen	= pRes[1]+10;
				}
			else if(uTypEx==(DWORD)RT_GROUP_ICON)
				{
				uOffset			= RvaToOffset(pRes[0],uCount,pSections);
				pEntry->pList[0]= AddIcon(uOffset,pRes[1],pMem,pEntry);
				uIcons++;
				}
			else if(uTypEx==(DWORD)RT_GROUP_CURSOR)
				{
				uOffset			= RvaToOffset(pRes[0],uCount,pSections);
				pEntry->pList[0]= AddCursor(uOffset,pRes[1],pMem,pEntry);
				uIcons++;
				}
			else if(uTypEx==(DWORD)RT_STRING)
				{
				uOffset			= RvaToOffset(pRes[0],uCount,pSections);
				pEntry->pList[0]= AddString(uOffset,pRes[1],pMem,pEntry);
				}
			else{
				pEntry->pList[0]= RvaToOffset(pRes[0],uCount,pSections);
				pEntry->pList[1]= pRes[1];
				pEntry->pList[2]= 0;
				pEntry->iLen	= pRes[1];

				if(cText[0]=='I' && !strznicmp(cText,"IMAGE_",6))
					{
					CheckImage(pEntry,cFull,uLen,pMem);
					}
				}


			memcpy(pEntry->pName,cFull,(uLen+1)*sizeof(zchar));

			PROG(CAF_PROG_FIND,iIdx);
			}

		iLevel--;
		}


	if(uIcons)											// Icons zusammenbauen
		{
		for(uPos=m_iFilesNum;uPos>0;)
			{
			uPos--;
			pEntry = m_pFiles[uPos];

			if(pEntry->uType==(DWORD)RT_GROUP_ICON)
				{
				uFind = (DWORD)RT_ICON;
				}
			else if(pEntry->uType==(DWORD)RT_GROUP_CURSOR)
				{
				uFind = (DWORD)RT_CURSOR;
				}
			else{
				continue;
				}

				iIdx = pEntry->pList[0];
			if(!iIdx)continue;

			pDir   = (ItemDir  *)m_sDataList[-iIdx-1];
			pList  = (IconEntry*)(((char*)pDir)+6);
			uIcons = pDir->idCount;
			pEntry->pList[2+uIcons*2] = 0;

			for(uNum=0;uNum<uIcons;uNum++,pList++)
				{
				for(iIdx=0;iIdx<m_iFilesNum;iIdx++)		// Suche ID
					{
					if(iIdx>=m_iFilesNum)
						{
						pEntry->pList[2+uNum*2] = 0;
						uNum = uIcons;
						break;
						}

					pItem =	m_pFiles[iIdx];

					if(pItem->uType!=uFind               )continue;
					if(pItem->uId  !=pList->dwImageOffset)continue;

					pList->dwImageOffset	= pEntry->iLen;

					if(uFind==(DWORD)RT_CURSOR)
						{
						MainSeek(pItem->pList[0]);
						MainRead(aSpot,4);

						pCursor				= (CursorEntry*)pList;
						pCursor->wHotSpotX	= aSpot[0];
						pCursor->wHotSpotY	= aSpot[1];

						pEntry->pList[2+uNum*2] = pItem->pList[0]+4;
						pEntry->pList[3+uNum*2] = pItem->pList[1]-4;
						pEntry->iLen		   += pItem->pList[1]-4;

						break;
						}

					pEntry->pList[2+uNum*2] = pItem->pList[0];
					pEntry->pList[3+uNum*2] = pItem->pList[1];
					pEntry->iLen		   += pItem->pList[1];

					break;
					}
				}
			}
		}


	delete pRsrc;

}

