//*****************************************************************************
//*
//*
//*		Sha256.h
//*
//*
//*****************************************************************************
#ifndef		__SHA256_H__
#define		__SHA256_H__


#ifdef		_MSC_VER
#define 	Sha64uint			unsigned __int64
#define 	Sha32uint			unsigned
#else
#define 	Sha64uint			unsigned long long
#define 	Sha32uint			unsigned
#endif

#define		SHA256_DIGEST_SIZE	32


#ifdef		__cplusplus
extern "C" {
#endif



typedef struct
	{
	unsigned char 	aBuffer[64];
	unsigned 		aState [8];
	Sha64uint		uCount;
	}Sha256Data;


void Sha256Init(Sha256Data *pData);
void Sha256    (Sha256Data *pData,const void *pMem, int iSize);
void Sha256Exit(Sha256Data *pData,void *pDigest);

#ifdef		__cplusplus
}
#endif

#endif
