//*****************************************************************************
//*
//*
//*		LzmFile.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf LZM-Dateien:
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *Type=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *Type=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractMem(int iNum,char *pMem,int)		// Datei in Speicher extrahieren
// 		int		ExtractAll(         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(   int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *Datei,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *Datei)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int		Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *Datei);					// Datei suchen
// 		time_t	Time (char  *Datei);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen


#ifndef 	__LZMFILE_H__
#define 	__LZMFILE_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if	    _MSC_VER > 1299
	#ifndef		WINVER 
	#define		WINVER 	0x0501 
	#endif 	
	#endif 	
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#endif
#else
	#ifdef		WIN32
	#include	<windows.h>
	#endif
	#ifdef		LINUX
	#include	<unistd.h>
	#include	"stdfunk.h"
	#endif
#endif

#ifndef 	 _MSC_VER
#define 	 _cdecl
#define 	__cdecl
#endif

#include	"TarFile.h"
#include	"Codecs/LzmaClass.h"

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif



//*****************************************************************************
//*
//*		Klasse CLzmFile
//*
//*****************************************************************************
class CLzmFile : public CTarFile
{
protected:

	zchar		m_cTarName[MAX_PATH];			// Name der temporren TAR-Datei
	aint64		m_iDoneLen;						// Gre eines Abschnittes (fr Open/Flush)
	aint64		m_iDoneSave;					// Wieviele Byte mssen ins TAR-Achive geschrieben werden
	int			m_iDoneMode;					// Verlaufmodus 0=normal 1=Mit Offset 2=Open mit Huffman 3=Close mit Huffman
	unsigned	m_uTarSize;						// Gre der TAR-Daten zum entkomprimieren

	CLzmaClass	m_sLzma;						// Komprimier Klasse


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
public:

						CLzmFile();
	virtual			   ~CLzmFile();

	virtual	int			Change     (int   iMode=CAF_WRITE);	// Schreiberlaubnis de/aktivieren
	virtual	int			Close      ();						// Datei schlieen
	virtual	aint64		Done	   (aint64 *pMax=0);		// Verlaufsabfrage

protected:

	virtual	int			ArchOpen   (int iLevel=9);
	virtual	int			CloseFlush ();

};

#endif



