//*****************************************************************************
//*
//*
//*		Delta.c
//*
//*
//*****************************************************************************
/* Delta.c -- Delta converter
2009-05-26 : Igor Pavlov : Public domain */

#include	"Delta.h"

//*****************************************************************************
//*
//*		Delta_Init
//*
//*****************************************************************************
void Delta_Init(Byte *state)
{
unsigned	i;


	for(i=0;i<DELTA_STATE_SIZE;i++)
		{
		state[i] = 0;
		}
}

//*****************************************************************************
//*
//*		MyMemCpy
//*
//*****************************************************************************
static __inline void MyMemCpy(Byte *dest,const Byte *src,unsigned size)
{
unsigned	i;


	for(i=0;i<size;i++)
		{
		dest[i] = src[i];
		}

}

//*****************************************************************************
//*
//*		Delta_Encode
//*
//*****************************************************************************
void Delta_Encode(Byte *state,unsigned delta,Byte *data,SizeT size)
{
Byte		buf[DELTA_STATE_SIZE];
Byte		b;
unsigned	j;
SizeT		i;


	j = 0;

	MyMemCpy(buf,state,delta);
	
	for(i=0;i<size;)
		{
		for(j=0;j<delta&&i<size;i++,j++)
			{
			b       =  data[i];
			data[i] = (Byte)(b - buf[j]);
			buf [j] =  b;
			}
		}

	if(j==delta)
		{
		j = 0;
		}

	MyMemCpy(state        ,buf+j,delta-j);
	MyMemCpy(state+delta-j,buf  ,j      );

}

//*****************************************************************************
//*
//*		Delta_Decode
//*
//*****************************************************************************
void Delta_Decode(Byte *state,unsigned delta,Byte *data,SizeT size)
{
Byte		buf[DELTA_STATE_SIZE];
unsigned	j = 0;
SizeT		i;


	MyMemCpy(buf, state, delta);

	for(i=0;i<size;)
		{
		for(j=0;j<delta&&i<size;i++,j++)
			{
			buf[j] = data[i] = (Byte)(buf[j] + data[i]);
			}
		}

	if(j==delta)
		{
		j = 0;
		}

	MyMemCpy(state        ,buf+j,delta-j);
	MyMemCpy(state+delta-j,buf  ,j      );
}
