//*****************************************************************************
//*
//*
//*		MsiFile.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf Compound-Dateien:
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int64	Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen

#include	<stdio.h>
#include	<stddef.h>
#include	<string.h>
#include	<sys/stat.h>
#include	"MsiFile.h"

#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	atoiz	   _wtoi
#define 	itoaz	   _itow
#define 	strzlen		wcslen
#define 	strzcpy		wcscpy
#define 	strzncpy	wcsncpy
#define 	strzncat	wcsncat
#define 	strzicmp	wcsicmp
#define 	strzcspn	wcscspn
#define 	szprintf	swprintf
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	atoiz	    atoi
#define 	itoaz		itoa
#define 	strzlen		strlen
#define 	strzcpy		strcpy
#define 	strzncpy	strncpy
#define 	strzncat	strncat
#define 	strzicmp	stricmp
#define 	strzcspn	strcspn
#define 	szprintf	sprintf
#endif


#define 	MSI_NEW_ADD	128




#define PROG(iMode,pEntry)							\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	if(Progress(iMode,pEntry))throw CAF_ERROR_BREAK;\
	}
#define PROGR(iMode,pEntry,iRet)					\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	if(Progress(iMode,pEntry))return iRet;			\
	}
#define PROGN(iMode,pEntry)							\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))		\
	{												\
	Progress(iMode,pEntry);							\
	}


typedef struct
	{
	unsigned char 	aAbSig[8];					// [000H,08] {0xd0, 0xcf, 0x11, 0xe0, 0xa1, 0xb1, 0x1a, 0xe1}
												// was       {0x0e, 0x11, 0xfc, 0x0d, 0xd0, 0xcf, 0x11, 0xe0}
	unsigned char 	aClid[16];					// [008H,16] class id (set with WriteClassStg, retrieved with GetClassFile/ReadClassStg)
	unsigned short 	uMinorVersion;				// [018H,02] minor version of the format: 33 is written by reference implementation
	unsigned short 	uDllVersion;				// [01AH,02] major version of the dll/format: 3 is written by reference implementation
	unsigned short 	uByteOrder;					// [01CH,02] 0xFFFE: indicates Intel byte-ordering
	unsigned short 	uSectorShift;				// [01EH,02] size of sectors in power-of-two (typically 9, indicating 512-byte sectors)
	unsigned short 	uMiniSectorShift;			// [020H,02] size of mini-sectors in power-of-two (typically 6, indicating 64-byte mini-sectors)
	unsigned short 	usReserved;					// [022H,02] reserved, must be zero
	unsigned 		ulReserved1;				// [024H,04] reserved, must be zero
	unsigned 		ulReserved2;				// [028H,04] reserved, must be zero
	unsigned		uSectFat;					// [02CH,04] number of SECTs in the FAT chain
	unsigned		uSectDirStart;				// [030H,04] first SECT in the Directory chain
	unsigned		uSignature;					// [034H,04] signature used for transactionin: must be zero. The reference implementation does not support transactioning
	unsigned		uMiniSectorCutoff;			// [038H,04] maximum size for mini-streams: typically 4096 bytes Windows Compound Binary File Format Specification Page 3 of 9
	unsigned		uSectMiniFatStart;			// [03CH,04] first SECT in the mini-FAT chain
	unsigned		uSectMiniFat;				// [040H,04] number of SECTs in the mini-FAT chain
	unsigned		uSectDifStart;				// [044H,04] first SECT in the DIF chain
	unsigned		uSectDif;					// [048H,04] number of SECTs in the DIF chain
	unsigned		aSectFatList[109];			// [04CH,436] the SECTs of the first 109 FAT sectors
	}StorageHeader;


typedef struct
	{
	wchar_t			cName[32];					// [000H,64] 64 bytes. The Element name in Unicode, padded with zeros to fill this byte array
	unsigned short	uNameSize;					// [040H,02] Length of the Element name in characters, not bytes
	unsigned char	ucMse;						// [042H,01] Type of object: value taken from the STGTY enumeration
	unsigned char	ucFlags;					// [043H,01] Value taken from DECOLOR enumeration.
	unsigned		uSidLeftSib;				// [044H,04] SID of the left-sibling of this entry in the directory tree
	unsigned		uSidRightSib;				// [048H,04] SID of the right-sibling of this entry in the directory tree
	unsigned		uSidChild;					// [04CH,04] SID of the child acting as the root of all the children of this
	unsigned char	aClsId[16];					// [050H,16] CLSID of this storage (if _mse=STGTY_STORAGE)
	unsigned		uUserFlags;					// [060H,04] User flags of this storage (if _mse=STGTY_STORAGE)
	unsigned		aTime[4];					// [064H,16] Create/Modify time-stamps (if _mse=STGTY_STORAGE)
	unsigned		uSectStart;					// [074H,04] starting SECT of the stream (if _mse=STGTY_STREAM)
	unsigned		uSize;						// [078H,04] size of stream in bytes (if _mse=STGTY_STREAM)
	unsigned short	uSptPropType;				// [07CH,02] Reserved for future use. Must be zero.
	}DirectoryEntry;



static char				aMsiChars[]		 = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz._" ;
static const int		uMsiNumBits		 = 6;
static const unsigned	uMsiNameMax		 = 64;
static const unsigned	uMsiStartChar	 = 0x3800;
static const unsigned 	uMsiNumChars	 = 1<<uMsiNumBits;
static const unsigned	uMsiCharMask	 = uMsiNumChars-1;
static const unsigned	uMsiUnicodeRange = uMsiNumChars*(uMsiNumChars+1);





//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CMsiFile::CMsiFile()
{
	m_pFiles		= 0;
	m_iFilesMax		= 0;
	m_iFilesNum		= 0;

	m_iDoneMode		= 0;
	m_iDoneNow		= 0;
	m_iDoneMax		= 0;

	m_uFatCount		= 0;
	m_uMinCount		= 0;
	m_pFatList		= 0;
	m_pMinList		= 0;

	m_cHasCompress	= 0;
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CMsiFile::~CMsiFile()
{

	if(m_uComState!=CAF_CLOSED)Close();

	Clear();

}

//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
//	Lscht alle Datenfelder und setzt alle Variabeln zurck
void CMsiFile::Clear()
{
int		iPos;

	for(iPos=m_iFilesNum-1;iPos>=0;iPos--)
		{
		MsiDel(iPos);
		}

	m_uFatCount = 0;
	m_uMinCount = 0;

	if(m_pFatList){delete m_pFatList;m_pFatList=0;}
	if(m_pMinList){delete m_pMinList;m_pMinList=0;}


}


//*****************************************************************************
//*
//*		CmpEx
//*
//*****************************************************************************
int __cdecl CMsiFile::CmpEx(const void *pPos1,const void *pPos2)
{
MsiItem	*pPtr1,*pPtr2;

	pPtr1 = *(MsiItem**)pPos1;
	pPtr2 = *(MsiItem**)pPos2;

return strvicmp(pPtr1->pName,pPtr2->pName);
}

//*****************************************************************************
//*
//*		CmpName
//*
//*****************************************************************************
int __cdecl CMsiFile::CmpName(const void *pPos1,const void *pPos2)
{
MsiItem	*pPtr1,*pPtr2;

	pPtr1 = *(MsiItem**)pPos1;
	pPtr2 = *(MsiItem**)pPos2;

return strzicmp(pPtr1->pName,pPtr2->pName);
}

//*****************************************************************************
//*
//*		CmpLen
//*
//*****************************************************************************
int __cdecl CMsiFile::CmpLen(const void *pPos1,const void *pPos2)
{
MsiItem	*pPtr1,*pPtr2;


	pPtr1 = *(MsiItem**)pPos1;
	pPtr2 = *(MsiItem**)pPos2;

	if(pPtr1->uSize==pPtr2->uSize)return 0;

return (pPtr1->uSize<pPtr2->uSize)? -1:0;
}

//*****************************************************************************
//*
//*		CmpPos
//*
//*****************************************************************************
int __cdecl CMsiFile::CmpPos(const void *pPos1,const void *pPos2)
{
MsiItem	*pPtr1,*pPtr2;

	pPtr1 = *(MsiItem**)pPos1;
	pPtr2 = *(MsiItem**)pPos2;

return pPtr1->uStart-pPtr2->uStart;
}

//*****************************************************************************
//*
//*		Len
//*
//*****************************************************************************
//	Ergibt die Lnge der Datei mit der Indexnummer iNum
//	Ist iMode==0 wird die originale    Lnge zurckgegeben
//	Ist iMode!=0 wird die komprimierte Lnge zurckgegeben
aint64 CMsiFile::Len(int iNum,int iMode)
{
MsiItem	*pEntry;

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;
	pEntry=m_pFiles[iNum];

return pEntry->uSize;
}

//*****************************************************************************
//*
//*		SetFail
//*
//*****************************************************************************
//	Setzt das Defekt-Flag und ergibt den alten Wert.
int CMsiFile::SetFail(int iNum,int iFail)
{
int		iOld;

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return -1;

	iOld = m_pFiles[iNum]->cError;
	m_pFiles[iNum]->cError = iFail;

return iOld;
}

//*****************************************************************************
//*
//*		IsFail
//*
//*****************************************************************************
//	Ergibt die 1 wenn die Datei mit iNum beschdigt ist sonst 0
int CMsiFile::IsFail(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return -1;

return m_pFiles[iNum]->cError;
}

//*****************************************************************************
//*
//*		IsDir
//*
//*****************************************************************************
// Ergibt die 1 wenn die Datei mit iNum ein Verzeichnis ist sonst 0
int CMsiFile::IsDir(int iNum)
{

return 0;
}

//*****************************************************************************
//*
//*		IsOk
//*
//*****************************************************************************
// Ergibt:	2	Wenn die Datei vollstntig Entzipt wurde
//          1	Wenn die Datei schon vorhanden war
//			0   Bei Fehlern
int CMsiFile::IsOk(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

return m_pFiles[iNum]->cDecomp;
}

//*****************************************************************************
//*
//*		Stats
//*
//*****************************************************************************
//	Die Zustandbits abfragen
//	iNum		: Ist der Name der Datei samt Pfad die geprft werden soll.
//	iSet		: Welche Bits sollen gesetzt werden
//	iDel		: Welche Bits sollen gelscht werden
//	Ergibt einen Wert mit veschiedenen Bits:
//					CAF_STAT_EXIST		0x0001	Wenn die Datei beim Entpacken schon vorhanden war
//					CAF_STAT_DECOMP		0x0002	Wenn die Datei vollstndig neu entpackt wurde (immer ohne CAF_STAT_FILEOK)
//					CAF_STAT_DELETE		0x0004	Die Datei wurde aus dem Verzeichnis gelscht
//					CAF_STAT_WRITE		0x0008	Die Datei muss ins Archiv geschrieben werden
//					CAF_STAT_DIR		0x0010	Die Datei ist ein Verzeichniss
//					CAF_STAT_READONLY	0x0020	Die Datei ist schreibgeschtzt
//					CAF_STAT_SAVED		0x0040	Die Datei ist im Archiv gespeichert
int CMsiFile::Stats(int iNum)
{
MsiItem	   *pEntry;
int			iBits;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)				// Prfe den Index
		{
		return 0;
		}

			pEntry=m_pFiles[iNum];
	iBits = pEntry->cDecomp&3;
	iBits|= CAF_STAT_SAVED;

	if(pEntry->cDir)iBits|= CAF_STAT_DIR;
	

return iBits;	
}


//*****************************************************************************
//*
//*		Time
//*
//*****************************************************************************
// Ergibt die Zeit der letzten nderung einer Datei
// bzw.	CAF_ERROR_MISS wenn iNum/Datei nicht gefunden wurde.
time_t CMsiFile::Time(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return CAF_ERROR_MISS;

return m_pFiles[iNum]->iTime;
}

time_t CMsiFile::Time(int iNum,int iMode)
{
	if((unsigned)iNum>=(unsigned)m_iFilesNum)
		{
		return CAF_ERROR_MISS;
		}


return m_pFiles[iNum]->iTime;
}


//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Holt den Dateinamen einer Archivdatei.
//	iNum		: Ist die Indexnummer der Datei (-1=Archiv-Datei)
//	Ergibt eine Zeiger auf den Dateinamen der Datei bzw. NULL bei einem Fehler.
zchar *CMsiFile::Name(int iNum)
{

	if((unsigned)iNum<(unsigned)m_iFilesNum)			// Prfe den Dateiindex
		{
		return m_pFiles[iNum]->pName;
		}

	if(iNum==-1)										// Name der Archiv-Datei
		{
		return m_cFilePath;
		}

return NULL;
}


//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Holt den Dateinamen einer Archivdatei samt Lnge.
//	iNum		: Ist die Indexnummer der Datei (-1=Archiv-Datei)
//	iLen		: Hier wird die Lnge des Namens gespeichert
//	Ergibt eine Zeiger auf den Dateinamen der Datei bzw. NULL bei einem Fehler.
zchar *CMsiFile::Name(int iNum,int &iLen)
{


	if((unsigned)iNum<(unsigned)m_iFilesNum)			// Prfe den Dateiindex	
		{
		iLen = m_pFiles[iNum]->uNameLen;
		return m_pFiles[iNum]->pName;
		}

	if(iNum==-1)										// Name der Archiv-Datei
		{
		iLen = strzlen(m_cFilePath);					
		return m_cFilePath;
		}

	iLen = 0;


return NULL;
}

//*****************************************************************************
//*
//*		GetUserPtr
//*
//*****************************************************************************
//	User-Pointer abfragen
void *CMsiFile::GetUserPtr(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

return m_pFiles[iNum]->pUserPtr;
}

//*****************************************************************************
//*
//*		SetUserPtr
//*
//*****************************************************************************
//	User-Pointer einstellen
void CMsiFile::SetUserPtr(int iNum,void *pData)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;

	m_pFiles[iNum]->pUserPtr = pData;

}

//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
//	Sortiert die Liste in m_pFiles
//  iMode:	CAF_FLAG_SORT			0x0400	Nach Namen  sortieren
//			CAF_FLAG_SORTLEN	    0x0500	Nach Lngen sortieren
//			CAF_FLAG_SORTPOS	    0x0600	Nach Offset sortieren (intern)
//			CAF_FLAG_SORTEX			0x0700	Nach Namen mit Zahlen Bercksichtigung
int	CMsiFile::Sort(int iMode)
{

		iMode&=0x0700;
	if(!iMode)iMode=m_iModeFlags&0x0700;
	iMode |= 0x0400;

	PROGR(CAF_PROG_SORT,-1,0);


	if(!m_pFiles)return 0;

	if(iMode==m_iSortMode)								// Ist die Liste bereits sortiert
		{
		return m_iFilesNum;
		}

	if(m_iFilesNum)
		{
		switch(iMode)
			{
		case    CAF_FLAG_SORTEX:	qsort(m_pFiles,m_iFilesNum,sizeof(MsiItem*),CmpEx  );break;
		case    CAF_FLAG_SORTLEN:	qsort(m_pFiles,m_iFilesNum,sizeof(MsiItem*),CmpLen );break;
		case    CAF_FLAG_SORTPOS:	qsort(m_pFiles,m_iFilesNum,sizeof(MsiItem*),CmpPos );break;
		default:					qsort(m_pFiles,m_iFilesNum,sizeof(MsiItem*),CmpName);break;
			}
		}

	m_iModeFlags&=~0x0300;
	m_iModeFlags|= 0x0300&iMode;
	m_iSortMode  = iMode;


return m_iFilesNum;
}


//*****************************************************************************
//*
//*		CompoundNameToFileName
//*
//*****************************************************************************
int CMsiFile::CompoundNameToFileName(const wchar_t *pStr,wchar_t *pOut)
{
wchar_t		uChar;
int			iOut;
int			i;



	iOut = 0;

	for(i=0;pStr[i];i++)
		{
		uChar = pStr[i];


		if(uChar<0x20)
			{
			pOut[iOut] = '[';
			iOut++;

			_itow(uChar,pOut+iOut,10);

			while(pOut[iOut])iOut++;

			pOut[iOut] = ']';
			iOut++;
			}
		else{
			pOut[iOut] = uChar;
			iOut++;
			}
		}

return iOut;
}


//*****************************************************************************
//*
//*		CompoundMsiNameToFileName
//*
//*****************************************************************************
int CMsiFile::CompoundMsiNameToFileName(const wchar_t *pStr,wchar_t *pOut)
{
unsigned	uChar1;
unsigned	uChar0;
wchar_t		uChar;
int			iOut;
int			i;


	iOut = 0;

	for(i=0;pStr[i];i++)
		{
		uChar =	 pStr[i];


		if(uChar<uMsiStartChar || uChar>uMsiStartChar+uMsiUnicodeRange)
			{
			pOut[iOut] = 0;
			return 0;
			}

		uChar  -= uMsiStartChar;
		uChar0  = uChar  & uMsiCharMask;
		uChar1  = uChar >> uMsiNumBits;

		if(uChar1<=uMsiNumChars)
			{
			pOut[iOut] = (wchar_t)aMsiChars[uChar0];
			iOut++;

			if(uChar1 == uMsiNumChars)
				{
				break;
				}

			pOut[iOut] = (wchar_t)aMsiChars[uChar1];
			iOut++;
			}
		else{
			pOut[iOut] = '!';
			iOut++;
			}
		}


	pOut[iOut] = 0;


return iOut;
}


//*****************************************************************************
//*
//*		ConvertName
//*
//*****************************************************************************
int CMsiFile::ConvertName(const wchar_t *pStr,wchar_t *pOut)
{
int		iLen;


	   iLen = CompoundMsiNameToFileName(pStr,pOut);
	if(iLen>0)
		{
		return iLen;
		}

	iLen = CompoundNameToFileName(pStr,pOut);


return iLen;
}

//*****************************************************************************
//*
//*		StreamRead
//*
//*****************************************************************************
//	Bytes aus einem Stream einlesen
//	pParam		: Zeiger auf die Streamdaten
//	pMem		: Zeiger auf den Zielspeicher
//	iSize		: Anzahl der zu lesenden Bytes
//	Ergibt die gelesenen Bytes, Fehler werden mit throw bergeben.
int CMsiFile::StreamRead(void *pParam,void *pMem,int iSize)
{
ComStream  *pStream=(ComStream*)pParam;
CMsiFile   *pThis  =(CMsiFile *)pStream->pThis;
char	   *pOutput=(char     *)pMem;
unsigned	uMax;
unsigned	uNum;
unsigned	uOff;


	if(iSize<=0)return 0;

	uMax = pStream->uStreamSize-pStream->uOffset;

	if((unsigned)iSize>=uMax)
		{
		iSize = uMax;
		}

	while(iSize>0)										// Daten sektorweise lesen
		{
		if(pStream->uSector>=pStream->uSectorCount)
			{
			break;
			}

		uOff  = pStream->uOffset &(pStream->uSectorSize-1);
		uNum  = pStream->uSectorSize-uOff;

		if(uNum>(unsigned)iSize)uNum=iSize;

		pThis->MainSeek(512+pStream->uSectorSize*pStream->uSector+uOff);
		pThis->MainRead(pOutput,uNum);

		iSize			 -= uNum;
		pOutput			 += uNum;
		pStream->uOffset += uNum;


		if(uOff+uNum>=pStream->uSectorSize)				// Schon auf neuem Sektor
			{
			if(pStream->uSector>=pStream->uSectorCount)
				{
				break;
				}

			pStream->uSector = pStream->pFatEntries[pStream->uSector];
			}
		}



return	(int)(pOutput-(char*)pMem);
}


//*****************************************************************************
//*
//*		ArchOpen
//*
//*****************************************************************************
//	ffnet eine MSI-Datei und liest alle bereits gespeicherten Dateien ein.
//	Zuvor wurde eine Datei bzw. ein Speicherbereich in CArchiveFile::Open geffnet.
//	iLevel	: Komprimierungs Levl (0-9) 9=maximal  (unbenutzt)
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//					CAF_ERROR_OK		Alles ok
//					CAF_ERROR_NONE		Wenn die Datei nicht gefunden werden konnte
//					CAF_ERROR_OPEN		Wenn die Datei nicht geffnet werden konnte
//					CAF_ERROR_CREATE	Wenn die Datei nicht erzeugt  werden konnte
//					CAF_ERROR_READ		Bei Lese-Fehlern
//					CAF_ERROR_FORM		Bei Fehlern im TAR-Datei
//					CAF_ERROR_MULTI		Wenn Zib ber mehere Disketten geht
//					CAF_ERROR_LOGIC		Bei internen unbekannten Fehlern
int CMsiFile::ArchOpen(int iLevel)
{
DirectoryEntry	sDir;
ComStream		sDirStream;
wchar_t			cName  [512 ];
char			cHeader[512 ];
char			cBuffer[4096];
StorageHeader  *pHeader;
MsiItem		   *pEntry;
unsigned	   *pList;
unsigned		uNext;
unsigned		uPath;
unsigned		uOff;
unsigned		uPos;
unsigned		uRet;
unsigned		uMax;
unsigned		uDir;
unsigned		uLen;
int				iIdx;
int				iNum;




	Clear();

	m_iDoneNow		= 0;
	m_iDoneMax		= m_iFileSize;
	m_iDoneMode		= 0;
	m_iErrorCode	= CAF_ERROR_OK;

	SetDoneMode(-1);										// Done-Modus in Cab-Datei



//******************** Header laden *******************************************
	try	{
		MainRead(cHeader,512);

		m_iDoneNow += 512;

		if(memcmp(cHeader,"\xD0\xCF\x11\xE0\xA1\xB1\x1A\xE1",8))
		if(memcmp(cHeader,"\x0E\x11\xFC\x0D\xD0\xCF\x11\xE0",8))
			{
			throw CAF_ERROR_FORM;
			}



		pHeader = (StorageHeader*)cHeader;

		if(pHeader->uByteOrder!=0xFFFE)						// Big-Endian wird nicht untersttzt
			{
			throw CAF_ERROR_VERSION;
			}

		m_uSecSize	= 1<<pHeader->uSectorShift;
		m_uMinSize	= 1<<pHeader->uMiniSectorShift;

		if(m_uSecSize>sizeof(cBuffer) || m_uMinSize>sizeof(cBuffer))
			{
			throw CAF_ERROR_VERSION;
			}


//******************** FAT laden **********************************************


		uRet	= 0;
		uMax	= 109;
		pList	= pHeader->aSectFatList;

		m_pFatList	= new unsigned[pHeader->uSectFat*m_uSecSize/4];

		if(!m_pFatList)
			{
			throw CAF_ERROR_MEM;
			}


		if(uMax>pHeader->uSectFat)
			{
			uMax = pHeader->uSectFat;
			}

		for(uOff=0,uPos=0;uPos<uMax;uPos++,uOff++)			// FAT aus den ersten 109 Eintrgen
			{
			MainSeek(512+pList[uPos]*m_uSecSize);
			MainRead(cBuffer,m_uSecSize);
			memcpy(m_pFatList+uOff*m_uSecSize/4,cBuffer,m_uSecSize);
			m_iDoneNow += m_uSecSize;
			}


		uNext = pHeader->uSectDifStart;
		uMax  = m_uSecSize/4-1;

		while(uOff<pHeader->uSectFat)						// FAT aus weiteren Eintrgen
			{
			MainSeek(512+uNext*m_uSecSize);
			MainRead(cBuffer,m_uSecSize);
			pList  = (unsigned*)cBuffer;

			m_iDoneNow += m_uSecSize;

			if(uOff+uMax>pHeader->uSectFat)
				{
				uMax = pHeader->uSectFat-uOff;
				}

			for(uPos=0;uPos<uMax;uPos++,uOff++)
				{
				MainSeek(512+pList[uPos]*m_uSecSize);
				MainRead(m_pFatList+uOff*m_uSecSize/4,m_uSecSize);

				m_iDoneNow += m_uSecSize;
				}

			uNext = pList[uPos];
			}


		m_uFatCount = pHeader->uSectFat*m_uSecSize/4;


//******************** Kleine FAT laden ***************************************


		m_pMinList	= new unsigned[pHeader->uSectMiniFat*m_uSecSize/4];

		if(!m_pMinList)
			{
			throw CAF_ERROR_MEM;
			}

		uNext	= pHeader->uSectMiniFatStart;

		for(uPos=0;uPos<pHeader->uSectMiniFat;uPos++)		// FAT aus weiteren Eintrgen
			{
			MainSeek(512+uNext*m_uSecSize);
			MainRead(cBuffer,m_uSecSize);

			memcpy(m_pMinList+uPos*m_uSecSize/4,cBuffer,m_uSecSize);

			m_iDoneNow += m_uSecSize;

			uNext = m_pFatList[uNext];
			}


		m_uMinCount  = pHeader->uSectMiniFat*m_uSecSize/4;


//****************** Verzeichnis laden ****************************************


		uPath = 0;
		uNext = pHeader->uSectDirStart;

		for(uDir=0;;uDir++)									// Berechne die Gre des Verzeichnisses
			{
			if(uNext&0x80000000)break;
			uNext = m_pFatList[uNext];
			}


		sDirStream.pThis		= this;						// Zeiger auf die Klasse
		sDirStream.pFatEntries	= m_pFatList;				// Zeiger auf die FAT-Tabelle
		sDirStream.uStartSector	= pHeader->uSectDirStart;	// Erster Sektor des Streams
		sDirStream.uSectorCount	= m_uFatCount;				// Anzahl der Eintrge in der FAT
		sDirStream.uSectorSize	= m_uSecSize;				// Gre eines Sektors
		sDirStream.uStreamSize	= m_uSecSize*uDir;			// Gre eines Streams in Byte
		sDirStream.uSector		= pHeader->uSectDirStart;	// Aktueller Sektor
		sDirStream.uOffset		= 0;						// Aktueller Offset im Stream

		uDir *= m_uSecSize;
		uDir /= sizeof(sDir);


		for(iIdx=-1;;)
			{
			for(;uDir>0;uDir--)								// Das Verzeichnis einlesen
				{
				if(StreamRead(&sDirStream,&sDir,sizeof(sDir))!=sizeof(sDir))
					{
					throw CAF_ERROR_FORM;
					}

				m_iDoneNow += sizeof(sDir);

					uLen = ConvertName(sDir.cName,cName+uPath);
				if(!uLen)continue;

				iNum			 = MsiNew();
				pEntry			 = m_pFiles[iNum];
				pEntry->pName	 = new zchar[uPath+uLen+1];
				pEntry->uNameLen = uLen;
				pEntry->iTime	 = sDir.aTime[0];
				pEntry->cDir	 = sDir.ucMse==1;
				pEntry->uSize	 = sDir.uSize;
				pEntry->uStart	 = sDir.uSectStart;

				strawcpy(pEntry->pName,cName,uPath+uLen+1);
				}

			for(iIdx++;iIdx<m_iFilesNum;iIdx++)
				{
					pEntry = m_pFiles[iIdx];
				if(!pEntry->cDir)continue;
				
				sDirStream.pThis		= this;				// Zeiger auf die Klasse
				sDirStream.pFatEntries	= m_pFatList;		// Zeiger auf die FAT-Tabelle
				sDirStream.uStartSector	= pEntry->uStart;	// Erster Sektor des Streams
				sDirStream.uSectorCount	= m_uFatCount;		// Anzahl der Eintrge in der FAT
				sDirStream.uSectorSize	= m_uSecSize;		// Gre eines Sektors
				sDirStream.uStreamSize	= pEntry->uSize;	// Gre eines Streams in Byte
				sDirStream.uSector		= pEntry->uStart;	// Aktueller Sektor
				sDirStream.uOffset		= 0;				// Aktueller Offset im Stream

				uDir  = pEntry->uSize/sizeof(sDir);
				uPath = pEntry->uNameLen+1;

				strawcpy(cName,pEntry->pName,pEntry->uNameLen+1);
				cName[pEntry->uNameLen] = '/';
				}

			if(iIdx>=m_iFilesNum)
				{
				break;
				}
			}
		}
	catch(int iError)										// Bekannter Fehler
		{
		Close();
		ReleaseData();
		m_iErrorCode = iError;
		PROGN(CAF_PROG_ERROR,-1);
		return iError;
		}


	m_iDoneNow   = m_iDoneMax;
	m_iErrorCode = CAF_ERROR_OK;




return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		Close
//*
//*****************************************************************************
//	Schliet das Compound-Datei und Speichert alle Daten
//	Ergibt;	CAF_ERROR_LOGIC		Bei einem Internen Fehler
//			CAF_ERROR_OK		Wenn alles stimmte
//			CAF_ERROR_WRITE		Problemen beim Schreiben
//			... siehe Error Codes
int CMsiFile::Close()
{


	Clear();

	ReleaseData();


return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		Break
//*
//*****************************************************************************
//	Bearbeitung abbrechen ohne Daten zu speichern
void CMsiFile::Break()
{

	ReleaseData();
	m_iOpenMode=CAF_CLOSED;
	Clear();

}


//*****************************************************************************
//*
//*		Count
//*
//*****************************************************************************
//	Ergibt die Anzahl der Eintrge in der Dateiliste
int CMsiFile::Count()
{
	return m_iFilesNum;
}


//*****************************************************************************
//*
//*		SetDoneMode
//*
//*****************************************************************************
//	Den Modus fr die Verlaufsanzeige setzen.
//	iMode	: Ist der neue Modus
//			    0 = Zurck zu Normal (Ende)
//				1 = Begin von Extract (einzelene Datei)
//				2 = Begin von ExtractAll
//	Ergibt den vorherigen Modus.
int CMsiFile::SetDoneMode(int iMode)
{
int		iRet;

	
	iRet = m_iDoneMode;
	
	switch(iMode)
		{
	case 0:													// Zurck zu Normal (Ende)

		if(m_iDoneMode==1 || m_iDoneMode==2)
		if(m_iErrorCode==CAF_ERROR_OK)
			{
			m_iDoneNow  = m_iDoneMax;
			}

		m_iDoneMode	 = 0;
		break;

	case 1:													// Begin von Extract (einzelene Datei)

		if(iRet==2)return iRet;
		m_iDoneNow		= 0;
		m_iDoneMax		= 0;
		m_iDoneMode		= 0;
		break;

	case 2:													// Begin von ExtractAll

		m_iDoneNow		= 0;
		m_iDoneMax		= 0;
		m_iDoneMode		= 1;
		break;
		}


return iRet;
}





//*****************************************************************************
//*
//*		Done
//*
//*****************************************************************************
//	Fragt den aktuellen Verlauf bei Open,Extract,Close,Flush ab
//	pMax	: Wenn ungleich 0 wird hier das Maximum gespeichert
//	Ergibt den aktuellen Verlauf
aint64	CMsiFile::Done(aint64 *pMax)
{
aint64	iRet;


	iRet = m_iDoneNow;

	if(iRet>m_iDoneMax)iRet=m_iDoneMax;
	if(pMax)*pMax=m_iDoneMax;


return iRet;
}

//*****************************************************************************
//*
//*		Change
//*
//*****************************************************************************
// Schreiberlaubnis aktivieren
int CMsiFile::Change(int iMode)
{

	m_iErrorCode = CAF_ERROR_NOTSUPP;

return CAF_ERROR_NOTSUPP;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht nach einer Datei in der Dateiliste
//	pName	: Ist der  Dateiname nach dem gesucht wird
//	Ergibt die Indexnummer der Datei, bzw. -1 wenn die Datei nicht gefunden wurde.
int CMsiFile::Find(const zchar *pName)
{
MsiItem	*pEntry;
unsigned uLen;
int		 iPos;


	if(*pName=='/' )pName++;
	if(*pName=='\\')pName++;


	uLen = (int)strzlen(pName);

	for(iPos=0;iPos<m_iFilesNum;iPos++)						// Eintrag in Kette
		{
		   pEntry=m_pFiles[iPos];
		if(pEntry->uNameLen!=uLen)continue;

		if(!CmpFileNameN(pName,pEntry->pName))
			{
			return iPos;
			}
		}


return -1;
}

//*****************************************************************************
//*
//*		MsiDel
//*
//*****************************************************************************
//	Listeneintrag lschen
void CMsiFile::MsiDel(int iNum)
{
MsiItem	*pEntry;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;

	pEntry = m_pFiles[iNum];

	if(!pEntry)return;

	m_iFilesNum--;
	m_pFiles[iNum]=0;

	if(iNum<m_iFilesNum)
		{
		memmove(m_pFiles+iNum,m_pFiles+iNum+1,(m_iFilesNum-iNum)*sizeof(m_pFiles[0]));
		}

	if(pEntry->pName)delete pEntry->pName;

	delete pEntry;

	if(m_iFilesNum<=0)
		{
		delete  m_pFiles;
		m_iFilesNum	 = 0;
		m_iFilesMax	 = 0;
		}

}

//*****************************************************************************
//*
//*		MsiNew
//*
//*****************************************************************************
//	Listeneintrag erzeugen
int	CMsiFile::MsiNew()
{
MsiItem	**pNew;



	if(!m_pFiles || !m_iFilesMax)							// Neue Kette
		{
		m_pFiles = new MsiItem*[MSI_NEW_ADD];
		memset(m_pFiles,0,sizeof(MsiItem*[MSI_NEW_ADD]));
		m_iFilesMax=MSI_NEW_ADD;
		}

	if(m_iFilesNum >= m_iFilesMax)							// Kette vergrern
		{
		pNew = new MsiItem*[m_iFilesMax+MSI_NEW_ADD];
		memset(pNew+m_iFilesMax,0,sizeof(MsiItem*[MSI_NEW_ADD]));
		memcpy(pNew,m_pFiles     ,sizeof(MsiItem*)*m_iFilesMax);
		delete m_pFiles;

		m_pFiles	= pNew;
		m_iFilesMax+= MSI_NEW_ADD;
		}


		   m_pFiles[m_iFilesNum] = new    MsiItem;
	memset(m_pFiles[m_iFilesNum],0,sizeof(MsiItem));
		   m_iFilesNum++;



return m_iFilesNum-1;
}


//*****************************************************************************
//*
//*		ExtractProc
//*
//*****************************************************************************
//	Extrahiert eine Datei aus dem Archiv ber eine Ausgabefunktion
//	iNum	: Ist die Indexnummer der Datei die geprft werden soll
//	pParam	: Ist ein Parameter der an die Ausgabefunktionbergeben wird
//	pProc	: Ist der Zeiger auf die Ausgabefunktion
//	pInfo	: Hier werden Zeiten und Attribute der Datei gespeichert.
//			  Bei NULL werden diese Werte ignoriert.
//	Ergibt 0 wenn ok, oder eine Fehlernummer ungleich 0:
//				CAF_ERROR_OK		= Wenn alles korrekt war
//				CAF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//				CAF_ERROR_PATH		= Pfad ungltig ist.
//				CAF_ERROR_FCREATE	= Wenn Datei nicht erzeugt werden konnte
//				CAF_ERROR_CRC		= Crc32 Fehler
//				CAF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//				CAF_ERROR_IGNORE	= Die Datei wurde bersprungen
//				... siehe Fehler Codes
int	CMsiFile::ExtractProc(int iNum,void *pParam,OutProc pProc,FileData *pInfo)
{
char		aBuffer[2048];
ComStream	sMsiStream;
MsiItem	   *pEntry;
int			iLen;




	if(m_iDoneMode<=1)										// Verlaufsanzeige starten
		{
		m_iDoneMode	= 1;
		m_iDoneNow	= 0;
		m_iDoneMax	= 0;
		}

	m_iErrorCode = CAF_ERROR_OK;

	try	{

		if( m_iOpenMode==CAF_CLOSED             )throw CAF_ERROR_MISS;
		if((unsigned)iNum>=(unsigned)m_iFilesNum)throw CAF_ERROR_MISS;

			pEntry=m_pFiles[iNum];
		if(!pEntry)throw CAF_ERROR_MISS;

		if(m_iDoneMode==1)									// Verlaufsanzeige einstellen
			{
			m_iDoneNow   = 0;
			m_iDoneMax   = pEntry->uSize;
			}


		m_pErrorFile = pEntry->pName;

		if(pEntry->cError)throw CAF_ERROR_READ;


		sMsiStream.pThis		= this;						// Zeiger auf die Klasse
		sMsiStream.pFatEntries	= m_pFatList;				// Zeiger auf die FAT-Tabelle
		sMsiStream.uStartSector	= pEntry->uStart;			// Erster Sektor des Streams
		sMsiStream.uSectorCount	= m_uFatCount;				// Anzahl der Eintrge in der FAT
		sMsiStream.uSectorSize	= m_uSecSize;				// Gre eines Sektors
		sMsiStream.uStreamSize	= pEntry->uSize;			// Gre eines Streams in Byte
		sMsiStream.uSector		= pEntry->uStart;			// Aktueller Sektor
		sMsiStream.uOffset		= 0;						// Aktueller Offset im Stream

		for(;;)												// Daten kopieren
			{
				iLen=StreamRead(&sMsiStream,aBuffer,sizeof(aBuffer));
			if(!iLen)break;
			
			if(pProc(pParam,aBuffer,iLen)!=iLen)
				{
				throw CAF_ERROR_FWRITE;
				}

			m_iDoneNow += iLen;
			}
		
		if(pProc(pParam,NULL,0)!=0)							// Ende anzeigen
			{
			throw CAF_ERROR_FWRITE;
			}

		if(pInfo)
			{
			pInfo->dwAttr		=(pEntry->cDir)? SYS_DIR:SYS_READ|SYS_WRITE;
			pInfo->dwSize		= pEntry->uSize;
			pInfo->dwTimeWrite	= pEntry->iTime;
			pInfo->dwTimeAccess	= 0;
			pInfo->dwTimeCreate	= 0;
			pInfo->cName[0]		= 0;
			}
		}

	catch(int iError)
		{
		m_iErrorCode=iError;
		PROGN(CAF_PROG_ERROR,iNum);
		}

	if(m_iDoneMode<=1)										// Die Verlaufsanzeige zurcksetzen
		{
		m_iDoneMode = 0;
		m_iDoneNow  = m_iDoneMax;
		}



return m_iErrorCode;
}

