//*****************************************************************************
//*
//*
//*		MsiFile.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf Microsoft-Compound-Dateien: (*.xls,*.msi)
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int64	Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen


#ifndef 	__MSIFILE_H__
#define 	__MSIFILE_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if	    _MSC_VER > 1299
	#ifndef		WINVER 
	#define		WINVER 	0x0501 
	#endif 	
	#endif 	
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#endif
#else
	#ifdef		WIN32
	#include	<windows.h>
	#endif
	#ifdef		LINUX
	#include	<unistd.h>
	#include	"stdfunk.h"
	#endif
#endif

#ifndef 	 _MSC_VER
#define 	 _cdecl
#define 	__cdecl
#endif

#include	<time.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	"CabFile.h"

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif



//*****************************************************************************
//*
//*		Klasse CMsiFile
//*
//*****************************************************************************
class CMsiFile : public CArchiveFile
{
protected:


	typedef struct  
		{ 
		void		   *pThis;					// Zeiger auf die Klasse
		unsigned	   *pFatEntries;			// Zeiger auf die FAT-Tabelle
		unsigned		uStartSector;			// Erster Sektor des Streams
		unsigned		uSectorCount;			// Anzahl der Eintrge in der FAT		
		unsigned		uSectorSize;			// Gre eines Sektors
		unsigned		uStreamSize;			// Gre eines Streams in Byte 
		unsigned		uOffset;				// Aktueller Offset im Stream
		unsigned		uSector;				// Aktueller Sektor
		}ComStream;

	typedef struct MsiItem 
		{ 
		void		   *pUserPtr;				// User-Pointer
		zchar		   *pName;       			// Dateiname in Datei
		unsigned	 	uNameLen;				// Dateinamen-Lnge
		time_t			iTime;					// Zeit der letzten nderung
		char			cDir;					// Ist es ein Verzeichniss
		char			cError;					// Fehler-Flag
		char			cDecomp;				// Wurde die Datei entpackt
		unsigned		uStart;					// Startsektor
		unsigned		uSize;					// Ist die Dateigre
		}MsiItem;


	unsigned	m_uComState;					// Status des ComFiles
	unsigned	m_uSecSize;						// Gre eines normalen Sektors in Byte
	unsigned	m_uMinSize;						// Gre eines kleine Sektors in Byte
	unsigned	m_uFatCount;					// Anzahl der Eintge in der FAT-Liste
	unsigned	m_uMinCount;					// Anzahl der Eintge in der MIN-FAT-Liste
	unsigned   *m_pFatList;						// Zeiger auf die FAT-Liste
	unsigned   *m_pMinList;						// Zeiger auf die MIN-FAT-Liste

	MsiItem   **m_pFiles;						// Alfabethische Liste
	int			m_iFilesNum;					// Anzahl der Listeneintrge	
	int			m_iFilesMax;					// Gesamt Listengre in Eintrgen

	int			m_iDoneMode;					// Verlaufs Modus
	aint64		m_iDoneMax;						// Maximaler Verlauf
	aint64		m_iDoneNow;						// Aktueller Verlauf 


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
public:

					CMsiFile();
	virtual        ~CMsiFile();

	virtual	int		ExtractProc	(int iNum,void *pParam,OutProc pProc,FileData *pInfo=0);
	virtual	int		Change		(int iMode);			// Schreiberlaubnis aktivieren
	virtual	int		Close		();						// Datei schliesen
	virtual	int		Count		();						// Anzahl der Dateien
	virtual	void	Break  	    ();						// Bearbeitung abbrechen
	virtual	aint64	Done		(aint64 *pMax);			// Verlaufsabfrage
	virtual	aint64	Len    		(int iNum,int iMode=0);	// Hole Dateilnge
	virtual	int		Find		(const zchar *pName);	// Suche einen Eintrag
	virtual	int		Sort		(int iMode);			// Eintrge sortieren
	virtual	zchar  *Name		(int iNum);				// Einen Dateinamen holen 
	virtual	zchar  *Name		(int iNum,int &iLen);	// Einen Dateinamen holen samt Lnge
	virtual	time_t	Time		(int iNum);				// Eine Dateizeit abfragen
	virtual	time_t	Time		(int iNum,int iMode);	// Eine Dateizeit abfragen
	virtual	int		Stats		(int iNum);				// Zustandsbits abfragen
	virtual	int		SetFail		(int iNum,int iFail);	// Fehlerbit setzen
	virtual	int     IsFail 		(int iNum);				// Ist die Datei defekt
	virtual	int     IsDir  		(int iNum);				// Prfe ob Verzeichnis
	virtual	int     IsOk   		(int iNum);				// Richtig endkomprimiert
	virtual	void   *GetUserPtr  (int iNum            );	// Datenwert auslesen
	virtual	void    SetUserPtr  (int iNum,void *pData);	// Datenwert einstellen

protected:

	virtual	int		SetDoneMode	(int iMode);			// Verlaufsmodus einstellen
	virtual	int		ArchOpen	(int iLevel=9);			// Die Archiv-Datei ffnen	
	void			Clear		();						// Speicher lschen
	int				MsiNew		();						// Neuen Listeneintrag erstellen
	void			MsiDel		(int iNum);				// Listeneintrag lschen

static int			StreamRead	(void *pParam,void *pMem,int iSize);	// Stream lesen
static int			CompoundNameToFileName    (const wchar_t *pStr,wchar_t *pOut);
static int 			CompoundMsiNameToFileName (const wchar_t *pStr,wchar_t *pOut);
static int			ConvertName               (const wchar_t *pStr,wchar_t *pOut);

static int __cdecl 	CmpName 	(const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
static int __cdecl 	CmpLen  	(const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
static int __cdecl 	CmpPos  	(const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
static int __cdecl 	CmpEx   	(const void *pPtr1,const void *pPtr2);// Vergleichsfunktion

};

#endif



