//*****************************************************************************
//*
//*
//*		rar_api.cpp
//*
//*
//*****************************************************************************
#include	"rar_api.h"

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		ADD_UNICODE
#ifndef		UNICODE
#define 	UNICODE			1
#endif
#endif

#ifdef		UNICODE
#define 	UNICODE_USED	1
#define 	zchar			wchar_t
#else
#define 	UNICODE_USED	0
#define 	zchar			char
#endif



#ifdef		UNICODE
#define 	ADD_UNICODE
#endif

#include	"rar_main.h"


struct RarData
	{
	CommandData		sCommand;
	CmdExtract		sExtract;
	RarArchive		sArchive;
	BYTE	 		uOpenMode;
	BYTE			uDummy;
	WORD			uArcNumber;
	int				iHeaderSize;
	int64			iPosAfterOpen;
	WCHAR			cTempName[MAX_PATH];
	RarData() : sArchive(&sCommand) , sExtract(&sCommand) {};
	};





#define 	RarErrorToDll(iErrCode)	iErrCode



//*****************************************************************************
//*
//*		RarOpenArchive
//*
//*****************************************************************************
void * _cdecl RarOpenArchive(RarOpenArchiveData *pArchiveData)
{
RarData    *pData=NULL;
Array<byte> sCmtData;
RAR_EXIT	iErrCode;
int			iSize;
LPCWSTR		pName;



	try	{
		ErrHandler.Clean();

		#if UNICODE_USED

		pName = pArchiveData->pArcName;

		#else

		WCHAR cTemp[MAX_PATH];

		if(!CharToWide(pArchiveData->pArcName,cTemp,MAX_PATH))
			{
			pArchiveData->uOpenResult = ERAR_EOPEN;
			return NULL;
			}
		
		pName = cTemp;

		#endif 	

		pArchiveData->uOpenResult		= 0;
		pData							= new RarData;
		pData->uOpenMode				= pArchiveData->uOpenMode;
		pData->sCommand.KeepBroken		= pArchiveData->uOpenFlags&ROADOF_KEEPBROKEN;
		pData->sCommand.DllError		= 0;
		pData->uDummy					= 0;
		pData->uArcNumber				= 0;
		pData->cTempName[0]				= 0;
		pData->sCommand.FileArgs.AddString(L"*");


		if(pArchiveData->uOpenFromMem)							// Speicher in Datei ablegen
			{
			WCHAR	cPath[MAX_PATH];
			DWORD	dwBytes;
			HANDLE	hFile;
			BOOL	bOk;


			if(!GetTempPathW(MAX_PATH-32,cPath))
				{
				pArchiveData->uOpenResult=ERAR_EOPEN;
				goto Exit;
				}
			
			if(!GetTempFileNameW(cPath,L"Rar_",0,pData->cTempName))
				{
				pArchiveData->uOpenResult=ERAR_EOPEN;
				goto Exit;
				}

			   hFile = CreateFileW(pData->cTempName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_FLAG_SEQUENTIAL_SCAN,NULL); 
			if(hFile==INVALID_HANDLE_VALUE)
				{
				pArchiveData->uOpenResult=ERAR_EOPEN;
				goto Exit;
				}

			bOk = WriteFile(hFile,pArchiveData->pMemoryPtr,pArchiveData->iMemorySize,&dwBytes,NULL);
			CloseHandle(hFile);

			if(!bOk || dwBytes^pArchiveData->iMemorySize)
				{
				pArchiveData->uOpenResult=ERAR_EOPEN;
				goto Exit;
				}
			
			pName = pData->cTempName;
			}
		
		pData->sCommand.AddArcName(pName);
		pData->sCommand.Overwrite 		= OVERWRITE_ALL;
		pData->sCommand.VersionControl	= 1;

		if(!pData->sArchive.Open(pName))
			{ 
			pArchiveData->uOpenResult=ERAR_EOPEN;
			goto Exit;
			}

		if(!pData->sArchive.IsArchive(false))
			{
			if(pData->sCommand.DllError!=0)
				{
				pArchiveData->uOpenResult = pData->sCommand.DllError;
				}
			else{
				iErrCode = ErrHandler.GetErrorCode();

				if(iErrCode!=RARX_SUCCESS && iErrCode!=RARX_WARNING)
					{
					pArchiveData->uOpenResult = RarErrorToDll(iErrCode);
					}
				else{
					pArchiveData->uOpenResult = ERAR_BAD_ARCHIVE;
					}
				}

			goto Exit;
			}

		pArchiveData->uFlags = 0;

		if(pData->sArchive.Volume	   )pArchiveData->uFlags|=0x01;
		if(pData->sArchive.MainComment )pArchiveData->uFlags|=0x02;
		if(pData->sArchive.Locked	   )pArchiveData->uFlags|=0x04;
		if(pData->sArchive.Solid       )pArchiveData->uFlags|=0x08;
		if(pData->sArchive.NewNumbering)pArchiveData->uFlags|=0x10;
		if(pData->sArchive.Signed      )pArchiveData->uFlags|=0x20;
		if(pData->sArchive.Protected   )pArchiveData->uFlags|=0x40;
		if(pData->sArchive.Encrypted   )pArchiveData->uFlags|=0x80;
		if(pData->sArchive.FirstVolume )pArchiveData->uFlags|=0x0100;

		if(pArchiveData->pComment && pArchiveData->iCommenSize>0)
			{
			Array<wchar>	sComment;

			if(pData->sArchive.GetComment(&sComment))
				{
				iSize = (int)wcslen(&sComment[0]);
				}
			else{
				iSize = 0;
				}

			if(iSize>=pArchiveData->iCommenSize)
				{
				iSize = pArchiveData->iCommenSize-1;
				}

			#if UNICODE_USED
			wcsncpy(pArchiveData->pComment,&sComment[0],iSize);
			#else
			WideToChar(&sComment[0],pArchiveData->pComment,iSize);
			#endif 	

			pArchiveData->pComment[iSize] = 0;
			}

		pData->sExtract.ExtractArchiveInit(pData->sArchive);
		pData->iPosAfterOpen = pData->sArchive.Tell();		// REM AZ Erweiterung

		return((void*)pData);
		}
	catch(RAR_EXIT iErrCode)
		{
		if(pData!=NULL && pData->sCommand.DllError)
			{
			pArchiveData->uOpenResult = pData->sCommand.DllError;
			}
		else{
			pArchiveData->uOpenResult=RarErrorToDll(iErrCode);
			}
		}
	catch(std::bad_alloc&) 									// Catch 'new' exception.
		{
		pArchiveData->uOpenResult = ERAR_NO_MEMORY;
		}

Exit:

	if(pData->cTempName[0])DeleteFile(pData->cTempName);
	if(pData)delete pData;


return	NULL;
}


//*****************************************************************************
//*
//*		RarCloseArchive
//*
//*****************************************************************************
int _cdecl RarCloseArchive(void* hArcData)
{
RarData	   *pData=(RarData *)hArcData;
bool		bSuccess;
int			iRet;


	if(!pData)return ERAR_ECLOSE;

	try	{	
		iRet	 = ERAR_SUCCESS;
		bSuccess = pData->sArchive.Close();
		}
	catch(RAR_EXIT iErrCode)
		{
		if(pData->sCommand.DllError)
				iRet = pData->sCommand.DllError;
		else	iRet = RarErrorToDll(iErrCode);
		}


	if(pData->cTempName[0])
		{
		DeleteFile(pData->cTempName);
		}

	delete	pData;


return	iRet;
}

//*****************************************************************************
//*
//*		RarDosToUnixTime
//*
//*****************************************************************************
// Unix time_t int Dos uDosTime umwandeln
static time_t RarDosToUnixTime(unsigned uDosTime)
{
struct  tm sTime;


	sTime.tm_year  = ((uDosTime>>25)     )+80;
	sTime.tm_mon   = ((uDosTime>>21)&0x0F)-1;
	sTime.tm_mday  = ((uDosTime>>16)&0x1F);
	sTime.tm_hour  = ((uDosTime>>11)&0x1F);
	sTime.tm_min   = ((uDosTime>> 5)&0x3F);
	sTime.tm_sec   = ((uDosTime<< 1)&0x3F);
	sTime.tm_isdst = 0;
	sTime.tm_wday  = 0;
	sTime.tm_yday  = 0;


return mktime(&sTime);
}


//*****************************************************************************
//*
//*		RarReadHeader
//*
//*****************************************************************************
int _cdecl RarReadHeader(void* hArcData,RarHeaderData *pHeader)
{
RarHeaderDataEx		sTemp;
int					iCode;

	
	memset(&sTemp,0,sizeof(sTemp));

	iCode = RarReadHeaderEx(hArcData,&sTemp);

	#if UNICODE_USED
	wcsncpy(pHeader->cFileName,sTemp.cFileName,ASIZE(pHeader->cFileName));
	#else
	WideToChar(sTemp.cFileName,pHeader->cFileName,ASIZE(pHeader->cFileName));
	#endif 	

	pHeader->uNameLen		= sTemp.uNameLen;
	pHeader->uFlags			= sTemp.uFlags;
	pHeader->uLenComp 		= sTemp.uLenComp;
	pHeader->uLenFull		= sTemp.uLenFull;
	pHeader->uFileCRC		= sTemp.uFileCRC;
	pHeader->uUnpVer		= sTemp.uUnpVer;
	pHeader->uMethod		= sTemp.uMethod;
	pHeader->uFileAttr 		= sTemp.uFileAttr;
	pHeader->iFileHdrPos	= sTemp.iFileHdrPos;
	pHeader->iTime			= sTemp.iTime;
	pHeader->cHashType		= sTemp.uHashType;
	pHeader->cDirectory		=(sTemp.uFlags&RHDF_DIRECTORY)? 1:0;
	pHeader->uOffset		= 0;			// Ist der Offset im temporren Speicher
	pHeader->cError			= 0;			// Ist Block fehlerhaft
	pHeader->cDecompOk		= 0;			// Ist Block richtig entkomprimiert
	pHeader->uOffset		= 0;


return iCode;
}



//*****************************************************************************
//*
//*		RarReadHeaderEx
//*
//*****************************************************************************
int _cdecl RarReadHeaderEx(void* hArcData,struct RarHeaderDataEx *pHeader)
{
RarData	   *pData=(RarData*)hArcData;
FileHeader *pFileHdr;
int			iCode;


	try	{
		   pData->iHeaderSize = (int)pData->sArchive.SearchBlock(HEAD_FILE);
		if(pData->iHeaderSize<=0)
			{
			if(pData->sArchive.Volume && pData->sArchive.GetHeaderType()==HEAD_ENDARC)
			if(pData->sArchive.EndArcHead.NextVolume)
			if(RarMergeArchive(pData->sArchive,NULL,false,'L'))
				{
				pData->uArcNumber++;
				pData->sArchive.Seek(pData->sArchive.CurBlockPos,SEEK_SET);
				return RarReadHeaderEx(hArcData,pHeader);
				}
			else{
				return ERAR_EOPEN;
				}

			if(pData->sArchive.BrokenHeader)
				{
				return ERAR_BAD_DATA;
				}

			if(pData->sArchive.FailedHeaderDecryption)
				{
				return ERAR_BAD_PASSWORD;
				}

			return ERAR_END_ARCHIVE;
			}

		pFileHdr = &pData->sArchive.FileHead;

		if(pData->uOpenMode==RAR_OM_LIST && pFileHdr->SplitBefore)
			{
				iCode = RarProcessEntry(hArcData,RAR_SKIP,NULL,NULL);
			if(!iCode)
				{
				return RarReadHeaderEx(hArcData,pHeader);
				}
			
			return iCode;
			}

		wcsncpy(pHeader->cFileName,pFileHdr->FileName,ASIZE(pHeader->cFileName));
		pHeader->uNameLen		= (int)wcslen(pHeader->cFileName);

								 pHeader->uFlags = 0;
		if(pFileHdr->SplitBefore)pHeader->uFlags|=RHDF_SPLITBEFORE;
		if(pFileHdr->SplitAfter )pHeader->uFlags|=RHDF_SPLITAFTER;
		if(pFileHdr->Encrypted  )pHeader->uFlags|=RHDF_ENCRYPTED;
		if(pFileHdr->Solid      )pHeader->uFlags|=RHDF_SOLID;
		if(pFileHdr->Dir        )pHeader->uFlags|=RHDF_DIRECTORY;


		pHeader->uLenComp 		= pFileHdr->PackSize;
		pHeader->uLenFull		= pFileHdr->UnpSize;
		pHeader->uHostOS		=(pFileHdr->HSType==HSYS_WINDOWS)? HOST_WIN32:HOST_UNIX;
		pHeader->uUnpVer		= pData->sArchive.FileHead.UnpVer;
		pHeader->uFileCRC		= pFileHdr->FileHash.CRC32;
		pHeader->uFileTime 		= pFileHdr->mtime.GetDos();
		pHeader->iTime			= pFileHdr->mtime.GetUnix();
		pHeader->iTimeModify	= pFileHdr->mtime.GetWin();
		pHeader->iTimeCreate	= pFileHdr->ctime.GetWin();
		pHeader->iTimeAccess	= pFileHdr->atime.GetWin();
		pHeader->uMethod		= pFileHdr->Method+0x30;
		pHeader->uFileAttr 		= pFileHdr->FileAttr;
		pHeader->uDictSize 		= (unsigned)(pFileHdr->WinSize/1024);
		pHeader->iFileHdrPos	= pData->sArchive.CurBlockPos;
		pHeader->iFileHdrPos   |= ((rar_u64)pData->uArcNumber)<<56;

		
		switch(pFileHdr->FileHash.Type)
			{
		case HASH_RAR14:
		case HASH_CRC32:

			pHeader->uHashType	= RAR_HASH_CRC32;
			break;

		case HASH_BLAKE2:

			pHeader->uHashType	= RAR_HASH_BLAKE2;
			memcpy(pHeader->cHash,pFileHdr->FileHash.Digest,BLAKE2_DIGEST_SIZE);
			break;

		default:

			pHeader->uHashType	= RAR_HASH_NONE;
			break;
			}

		pHeader->uRedirType		= pFileHdr->RedirType;

		if(pFileHdr->RedirType!=FSREDIR_NONE && pHeader->pRedirName && pHeader->uRedirNameSize>0 && pHeader->uRedirNameSize<100000)
			{
			wcsncpyz(pHeader->pRedirName,pFileHdr->RedirName,pHeader->uRedirNameSize);
			}

		pHeader->uDirTarget		= pFileHdr->DirTarget;
		}
	catch(RAR_EXIT iErrCode)
		{
		return (pData->sCommand.DllError)? pData->sCommand.DllError:RarErrorToDll(iErrCode);
		}



return ERAR_SUCCESS;
}


//*****************************************************************************
//*
//*		RarIsSolidArchive
//*
//*****************************************************************************
//	Prft ob das Archiv ein solides ist das immer ganz entkomprimiert werden muss
int _cdecl RarIsSolidArchive(void* hArcData)
{
RarData	   *pData=(RarData *)hArcData;


	if(!pData)return 0;

	try	{
		if(pData->sArchive.Solid)return 1;
		}
	catch(RAR_EXIT)
		{
		}


return 0;
}

//*****************************************************************************
//*
//*		RarSeekToFile
//*
//*****************************************************************************
//	Erweiterung um zu einer Datei zu springen
int _cdecl RarSeekToFile(void* hArcData,RarHeaderData *pHeaderData)
{
RarData	   *pData=(RarData *)hArcData;
unsigned	uNumber;
unsigned	uIndex;


	if(!pData)return RARX_USERERROR;


	try	{
		if(!pHeaderData)
			{
			if(pData->sArchive.Solid)return RARX_FATAL;

			pData->sExtract.ExtractArchiveInit(pData->sArchive);
			pData->sExtract.ResetToFirst();
			pData->sArchive.Seek(pData->iPosAfterOpen,SEEK_SET);
			}
		else{
			if(pData->sArchive.Solid)return RARX_FATAL;

			   uNumber = (BYTE)(pHeaderData->iFileHdrPos>>56);
			if(uNumber!=pData->uArcNumber)			// Zu anderer Datei wechesn	
				{
				if(uNumber<pData->uArcNumber)
					{
					if(!pData->sArchive.Open(pData->sArchive.FirstVolumeName))
						{
						return ERAR_EOPEN;
						}

					pData->sExtract.ExtractArchiveInit(pData->sArchive);
					pData->uArcNumber = 0;
					}
				else{
					uIndex = pData->uArcNumber;
					}

				for(uIndex=0;uIndex<uNumber;uIndex++)
					{
					if(!RarMergeArchive(pData->sArchive,NULL,false,'L'))
						{
						return ERAR_EOPEN;
						}
					}
				
				pData->uArcNumber = uNumber;
				}

			pData->sArchive.Seek(pHeaderData->iFileHdrPos&0x00FFFFFFFFFFFFFF,SEEK_SET);
			}
		}
	catch(int iErrCode)
		{
		return RarErrorToDll(iErrCode);
		}



return ERAR_SUCCESS;
}

//*****************************************************************************
//*
//*		RarProcessEntry
//*
//*****************************************************************************
int _cdecl RarProcessEntry(void* hArcData,int iOperation,const zchar *pDestPath,const zchar *pDestName)
{
RarData	   *pData=(RarData*)hArcData;
bool		bRepeat;


	try	{
		switch(iOperation)
			{
		case RAR_EXTRACTMEM:

			pData->sExtract.UnpackToMemory((void*)pDestPath,(int)pDestName);
			pData->sCommand.ProcessDataProc  = NULL;
			pData->sCommand.ProcessDataParam = NULL;
			pData->sCommand.Test			 = true;
			iOperation						 = RAR_EXTRACT;
			pDestPath						 = NULL;
			pDestName						 = NULL;
			break;

		case RAR_EXTRACTMEMEX:

			pData->sExtract.UnpackToMemory((void*)pDestPath,(int)pDestName);
			pData->sCommand.Test			 = true;
			iOperation						 = RAR_EXTRACT;
			pDestPath						 = NULL;
			pDestName						 = NULL;
			break;

		case RAR_EXTRACTPROC:

			pData->sExtract.UnpackToMemory(0,0);
			pData->sCommand.ProcessDataProc  = (PROCESSDATAPROC)pDestPath;
			pData->sCommand.ProcessDataParam = (void*)pDestName;
			pData->sCommand.Test			 = true;
			iOperation						 = RAR_EXTRACT;
			pDestPath						 = NULL;
			pDestName						 = NULL;
			break;

		case RAR_TEST_EX:

			pData->sExtract.UnpackToMemory(0,0);
			pData->sCommand.Test			 = true;
			iOperation						 = RAR_EXTRACT;
			pDestPath						 = NULL;
			pDestName						 = NULL;
			break;

		case RAR_TEST:

			pData->sExtract.UnpackToMemory(0,0);
			pData->sCommand.ProcessDataProc  = NULL;
			pData->sCommand.ProcessDataParam = NULL;
			pData->sCommand.Test			 = true;
			iOperation						 = RAR_EXTRACT;
			pDestPath						 = NULL;
			pDestName						 = NULL;
			break;

		case RAR_EXTRACTEX:

			pData->sExtract.UnpackToMemory(0,0);
			pData->sCommand.Test			 = false;
			iOperation						 = RAR_EXTRACT;
			break;

		case RAR_EXTRACT:

			pData->sExtract.UnpackToMemory(0,0);
			pData->sCommand.ProcessDataProc  = NULL;
			pData->sCommand.ProcessDataParam = NULL;
			pData->sCommand.Test			 = false;
			break;

		default:

			pData->sCommand.ProcessDataProc  = NULL;
			pData->sCommand.ProcessDataParam = NULL;
			pData->sCommand.Test			 = false;
			break;
			}



			pData->sCommand.DllError=0;
		if((pData->uOpenMode==RAR_OM_LIST && !pData->sArchive.Solid) || iOperation==RAR_SKIP) // REM AZ gendert
			{
			if(pData->sArchive.Volume)
			if(pData->sArchive.GetHeaderType()==HEAD_FILE)
			if(pData->sArchive.FileHead.Flags&LHD_SPLIT_AFTER)
				{
				if(RarMergeArchive(pData->sArchive,NULL,false,'L'))
					{
					pData->uArcNumber++;
					pData->sExtract.SignatureFound=false;
					pData->sArchive.Seek(pData->sArchive.CurBlockPos,SEEK_SET);
					return ERAR_SUCCESS;
					}
				else{
					return ERAR_EOPEN;
					}
				}

			pData->sArchive.SeekToNext();
			}
		else{
			pData->sCommand.DllOpMode = iOperation;

			if(pDestName!=NULL)
				{
				#if UNICODE_USED
				wcsncpy(pData->sCommand.DllDestName,pDestName,NM-1);
				#else
				CharToWide(pDestName,pData->sCommand.DllDestName,NM-1);
				#endif
				}
			else{
				pData->sCommand.DllDestName[0] = 0;
				}

			if(pDestPath!=NULL)
				{
				#if UNICODE_USED
				wcsncpy(pData->sCommand.ExtrPath   ,pDestPath,NM-2);
				AddEndSlash(pData->sCommand.ExtrPath         ,NM-2);
				#else
				CharToWide(pDestPath,pData->sCommand.ExtrPath,NM-2);
				AddEndSlash(pData->sCommand.ExtrPath         ,NM-2);
				#endif
				}
			else{
				pData->sCommand.ExtrPath[0] = 0;
				}

			bRepeat = false;
			wcscpy(pData->sCommand.Command,(iOperation==RAR_EXTRACT)? L"X":L"T");
			pData->sExtract.ExtractCurrentFile(pData->sArchive,pData->iHeaderSize,bRepeat);

			while(pData->sArchive.ReadHeader()!=0 && pData->sArchive.GetHeaderType()==HEAD3_SERVICE)
				{
				pData->sExtract.ExtractCurrentFile(pData->sArchive,pData->iHeaderSize,bRepeat);
				pData->sArchive.SeekToNext();
				}

			pData->sArchive.Seek(pData->sArchive.CurBlockPos,SEEK_SET);
			}
		}
	catch(int iErrCode)
		{
		return RarErrorToDll(iErrCode);
		}


return	pData->sCommand.DllError;
}


//*****************************************************************************
//*
//*		RarSetChangeVolProc
//*
//*****************************************************************************
void _cdecl RarSetChangeVolProc(void* hArcData,CHANGEVOLPROC pChangeVolProc)
{
RarData	   *pData=(RarData *)hArcData;


	if(!pData)return;

	pData->sCommand.ChangeVolProc = pChangeVolProc;

}


//*****************************************************************************
//*
//*		RarSetCallback
//*
//*****************************************************************************
void _cdecl RarSetCallback(void* hArcData,UNRARCALLBACK pCallback,RAR_LPARAM lUserData)
{
RarData	   *pData=(RarData *)hArcData;


	if(!pData)return;

	pData->sCommand.Callback = pCallback;
	pData->sCommand.UserData = lUserData;

}


//*****************************************************************************
//*
//*		RarSetProcessDataProc
//*
//*****************************************************************************
void _cdecl RarSetProcessDataProc(void* hArcData,PROCESSDATAPROC pProc,void *pParam)
{
RarData	   *pData=(RarData *)hArcData;


	if(!pData)return;

	pData->sCommand.ProcessDataProc  = pProc;
	pData->sCommand.ProcessDataParam = pParam;

}



//*****************************************************************************
//*
//*		RarSetPassword
//*
//*****************************************************************************
void _cdecl RarSetPassword(void* hArcData,zchar *pPassword)
{
#ifndef	NOCRYPT

RarData	   *pData=(RarData*)hArcData;


	if(!pData)return;


	#if UNICODE_USED

	pData->sCommand.Password.Set(pPassword);

	#else

	WCHAR	cPass[MAX_PATH];

	CharToWide(pPassword,cPass,MAX_PATH);
	pData->sCommand.Password.Set(cPass);

	#endif

#endif
}

//*****************************************************************************
//*
//*		RarSetPasswordEx
//*
//*****************************************************************************
void _cdecl RarSetPasswordEx(void* hArcData,char *pPassword)
{
#ifndef	NOCRYPT

RarData	   *pData=(RarData*)hArcData;


	if(!pData)return;

	WCHAR	cPass[MAX_PATH];

	CharToWide(pPassword,cPass,MAX_PATH);
	pData->sCommand.Password.Set(cPass);
	

#endif
}


//*****************************************************************************
//*
//*		RarGetDllVersion
//*
//*****************************************************************************
int _cdecl RarGetDllVersion()
{
return	RAR_DLL_VERSION;
}

