//*****************************************************************************
//*
//*
//*		rar_api.h
//*
//*
//*****************************************************************************
//
//	Ein Beispiel:
//
//		RarHeaderData		aList[64];	
//		RarHeaderData		sHeader;
//		RarOpenArchiveData	sData;
//		void			   *hRar;
//		int					iSolid;
//		int					iFiles;
//		int					iErr;
//		int					iPos;
//		
//		
//		
//		memset(&sData,0,sizeof(sData));
//		sData.pArcName	= "D:\\Test.rar";	
//		sData.uOpenMode	= RAR_OM_EXTRACT;
//		
//			hRar = RarOpenArchive(&sData);
//		if(!hRar)return 0;
//		
//		iSolid = RarIsSolidArchive(hRar);
//		
//		RarSetCallback(hRar,RarCallback,0x12345678);
//		
//		
//		for(iFiles=0;;iFiles++)								// Alle Dateien aus der Liste holen
//			{
//			   iErr = RarReadHeader(hRar,&sHeader);
//			if(iErr==ERAR_END_ARCHIVE)break;
//			if(iErr!=ERAR_SUCCESS)break;
//		
//			printf("%i\t%s\n",iFiles,sHeader.cFileName);
//		
//			   iErr = RarProcessEntry(hRar,RAR_SKIP,NULL,NULL);
//			if(iErr!=ERAR_SUCCESS)break;
//		
//			aList[iFiles] = sHeader;
//			}
//		
//		
//		if(iSolid)											// Beim SOLID-Modus muss die Datei neu geffnet werden
//			{
//			RarCloseArchive(hRar);
//		
//			   hRar=RarOpenArchive(&sData);
//			if(hRar==NULL)return 0;
//		
//			for(iFiles=0;;iFiles++)							// Alle Dateien aus der Liste holen
//				{
//				   iErr = RarReadHeader(hRar,&sHeader);
//				if(iErr==ERAR_END_ARCHIVE)break;
//				if(iErr!=ERAR_SUCCESS)break;
//		
//				printf("%i\t%s\n",iFiles,sHeader.cFileName);
//		
//				   iErr = RarProcessProc(hRar,WriteTempMem,(void*)0x22446688);
//				if(iErr!=ERAR_SUCCESS)break;
//				}
//			}
//		else{
//			iPos		= 4;
//		
//			   iErr = RarSeekToFile(hRar,aList+iPos);
//			if(iErr)return 0;
//		
//			   iErr = RarReadHeader(hRar,&sHeader);
//			if(iErr)return 0;
//		
//			RarSetProcessDataProc(hRar,CountWrite,(void*)0x11335577);
//		
//			   iErr = RarProcessFileEx(hRar,"D:\\Test.pdf");
//			if(iErr)return 0;
//		
//		
//		
//			iPos		= 3;
//		
//			   iErr = RarSeekToFile(hRar,aList+iPos);
//			if(iErr)return 0;
//		
//			   iErr = RarReadHeader(hRar,&sHeader);
//			if(iErr)return 0;
//		
//			RarSetProcessDataProc(hRar,CountWrite,(void*)0x66665577);
//		
//			   iErr = iErr = RarProcessMemoryEx(hRar,aMem,sizeof(aMem));
//			if(iErr)return 0;
//		
//		
//			iPos		= 2;
//		
//			   iErr = RarSeekToFile(hRar,aList+iPos);
//			if(iErr)return 0;
//		
//			   iErr = RarReadHeader(hRar,&sHeader);
//			if(iErr)return 0;
//		
//			RarSetProcessDataProc(hRar,CountWrite,(void*)0x44445555);
//		
//			   iErr = RarProcessProc(hRar,CountProc,(void*)0x33339999);
//			if(iErr)return 0;
//		
//			
//		
//			}
//		
//		RarCloseArchive(hRar);
//		

#ifndef		__RAR_API_H__
#define		__RAR_API_H__

#include	<time.h>
												// REM AZ die Fehlernummern wurde auf die von Zip-Dateien gemappt
#define		ERAR_SUCCESS			0			// CAF_ERROR_OK
#define		ERAR_END_ARCHIVE		99			// ---
#define		ERAR_NO_MEMORY			4			// CAF_ERROR_MEM
#define		ERAR_BAD_DATA			3			// CAF_ERROR_FORM
#define		ERAR_BAD_ARCHIVE		3			// CAF_ERROR_FORM
#define		ERAR_UNKNOWN_FORMAT 	3			// CAF_ERROR_FORM
#define		ERAR_EOPEN				18			// CAF_ERROR_OPEN
#define		ERAR_ECREATE			15			// CAF_ERROR_CREATE
#define		ERAR_ECLOSE 			5			// CAF_ERROR_LOGIC
#define		ERAR_EREAD				11			// CAF_ERROR_READ
#define		ERAR_EWRITE 			14			// CAF_ERROR_WRITE
#define		ERAR_SMALL_BUF			4			// CAF_ERROR_MEM
#define		ERAR_UNKNOWN			5			// CAF_ERROR_LOGIC
#define		ERAR_MISSING_PASSWORD	32			// CAF_ERROR_PASSWD
#define 	ERAR_EREFERENCE			98			// ---
#define 	ERAR_BAD_PASSWORD		32			// CAF_ERROR_PASSWD

#define		RAR_OM_LIST 			0
#define		RAR_OM_EXTRACT			1

#define		RAR_SKIP				0			// Datei nicht entkomprimieren (berspringen)
#define		RAR_TEST				1			// Datei testen				  (ohne Callback)
#define		RAR_EXTRACT 			2			// Datei extrahieren in Datei (ohne Callback)
#define		RAR_EXTRACTEX			3			// Datei extrahieren in Datei (mit  Callback)
#define		RAR_EXTRACTMEM			4			// Datei extrahieren in Speicher (ohne Callback)
#define		RAR_EXTRACTMEMEX		5			// Datei extrahieren in Speicher (mit  Callback)
#define		RAR_EXTRACTPROC			6			// Datei extrahieren mit Callback
#define		RAR_TEST_EX				7			// Datei testen	(mit Callback)

#define		RAR_VOL_ASK 			0
#define		RAR_VOL_NOTIFY			1
#define		RAR_DLL_VERSION 		4

#define		RAR_HASH_NONE			0
#define		RAR_HASH_CRC32			1
#define		RAR_HASH_BLAKE2 		2

#define		RHDF_SPLITBEFORE		0x01
#define		RHDF_SPLITAFTER 		0x02
#define		RHDF_ENCRYPTED			0x04
#define		RHDF_SOLID				0x10
#define		RHDF_DIRECTORY			0x20

#define		ROADF_VOLUME			0x0001
#define		ROADF_COMMENT			0x0002
#define		ROADF_LOCK				0x0004
#define		ROADF_SOLID 			0x0008
#define		ROADF_NEWNUMBERING		0x0010
#define		ROADF_SIGNED			0x0020
#define		ROADF_RECOVERY			0x0040
#define		ROADF_ENCHEADERS		0x0080
#define		ROADF_FIRSTVOLUME		0x0100

#define		ROADOF_KEEPBROKEN		0x0001


#ifdef		_UNIX
#define		_cdecl
#define		_cdecl
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)					L##a
#define 	zchar					wchar_t
#else
#define 	Z(a)					a
#define 	zchar					char
#endif

#ifdef		_WIN64
typedef		__int64					RAR_LPARAM;
#else 	
typedef		long					RAR_LPARAM;
#endif 	

#ifdef	   _MSC_VER
#define 	rar_i64					__int64
#define 	rar_u64					unsigned __int64
#else 	
#define 	rar_i64					long long 
#define 	rar_u64					unsigned long long 
#endif 	

typedef int (_cdecl *UNRARCALLBACK  )(unsigned uMsg ,RAR_LPARAM lUserData,RAR_LPARAM lP1,RAR_LPARAM lP2);
typedef int (_cdecl *PROCESSDATAPROC)(void *pParam  ,char *pAddr,unsigned uSize);
typedef int (_cdecl *CHANGEVOLPROC  )(char *pArcName,int   iMode);



struct RarHeaderData
	{
	void		   *pUserPtr;					// User-Pointer
	zchar			cFileName[260];				// Dateiname
	unsigned int	uNameLen;					// Dateinamen-Lnge
	rar_u64			uLenComp;					// Dateilnge komrimiert
	rar_u64			uLenFull;					// Dateilnge unkomrimiert
	time_t			iTime;						// Zeit der letzten nderung
	char 			cError;						// Ist Block fehlerhaft
	char 			cDirectory;					// Ist die Datei ein Verzeichnis
	char 			cDecompOk;					// Ist Block richtig entkomprimiert (0=nein 1=war vorhanden 2=ja)
	char 			cHashType;					// Wecher Hahs-Typ ist vorhanden (siehe RAR_HASH_???)
	unsigned int	uFlags;						// Diverse Flags (siehe RHDF_???)
	unsigned int	uFileCRC;
	unsigned int	uUnpVer;
	unsigned int	uMethod;
	unsigned int	uFileAttr;
	rar_u64	 		uOffset;					// Ist der Offset im temporren Speicher
	rar_i64			iFileHdrPos;
	};

struct RarHeaderDataEx
	{
	void		   *pUserPtr;					// User-Pointer
	wchar_t			cFileName[256];
	unsigned		uNameLen;					// Dateinamen-Lnge
	unsigned int	uFlags;
	rar_u64			uLenComp;
	rar_u64			uLenFull;
	unsigned int	uHostOS;
	unsigned int	uFileCRC;
	unsigned int	uFileTime;
	unsigned int	uUnpVer;
	unsigned int	uMethod;
	unsigned int	uFileAttr;
	unsigned int	uDictSize;
	unsigned int	uHashType;
	char			cHash[32];
	unsigned int	uRedirType;
	wchar_t		   *pRedirName;
	unsigned int	uRedirNameSize;
	unsigned int	uDirTarget;
	time_t			iTime;
	rar_u64			iTimeModify;
	rar_u64			iTimeCreate;
	rar_u64			iTimeAccess;
	rar_i64			iFileHdrPos;
	};


typedef struct
	{
	const zchar	   *pArcName;
	void		   *pMemoryPtr;
	zchar		   *pComment;
	int				iCommenSize;
	int				iMemorySize;
	unsigned int	uOpenFromMem;
	unsigned int	uOpenMode;
	unsigned int	uOpenResult;
	unsigned int	uOpenFlags;
	unsigned int	uFlags;
	}RarOpenArchiveData;


enum UNRARCALLBACK_MESSAGES
	{
	UCM_CHANGEVOLUME,
	UCM_PROCESSDATA,
	UCM_NEEDPASSWORD,
	UCM_CHANGEVOLUMEW,
	UCM_NEEDPASSWORDW,
	};



//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

#ifdef	__cplusplus
extern "C" {
#endif

void* 	_cdecl RarOpenArchive       (RarOpenArchiveData *pArchiveData);
int	   	_cdecl RarCloseArchive      (void* hArcData);
int	   	_cdecl RarIsSolidArchive    (void* hArcData);
int	   	_cdecl RarSeekToFile        (void* hArcData,RarHeaderData   *pHeaderData);
int	   	_cdecl RarReadHeader        (void* hArcData,RarHeaderData   *pHeaderData);
int		_cdecl RarReadHeaderEx		(void* hArcData,RarHeaderDataEx *pHeaderData);
void   	_cdecl RarSetPassword       (void* hArcData,zchar           *pPassword  );
void   	_cdecl RarSetPasswordEx     (void* hArcData, char           *pPassword  );
void   	_cdecl RarSetCallback       (void* hArcData,UNRARCALLBACK    pCallback,RAR_LPARAM lUserData);
void   	_cdecl RarSetChangeVolProc  (void* hArcData,CHANGEVOLPROC    pChangeVolProc  );
void   	_cdecl RarSetProcessDataProc(void* hArcData,PROCESSDATAPROC  pProc,void  *pParam);
int	   	_cdecl RarProcessEntry      (void* hArcData,int iOperation  ,const zchar *pDestPath,const zchar *pDestName);
int		_cdecl RarGetDllVersion     ();

//*****************************************************************************
//*
//*		Inline Funktionrn
//*
//*****************************************************************************
static __inline int RarProcessFile(void* hArcData,const zchar *pDestName)
	{
	return RarProcessEntry(hArcData,RAR_EXTRACT,NULL,pDestName);
	}

static __inline int RarProcessFileEx(void* hArcData,const zchar *pDestName)
	{
	return RarProcessEntry(hArcData,RAR_EXTRACTEX,NULL,pDestName);
	}

static __inline int RarProcessMemory(void* hArcData,void *pMemory,int iSize)
	{
	return RarProcessEntry(hArcData,RAR_EXTRACTMEM,(zchar*)pMemory,(zchar*)iSize);
	}

static __inline int RarProcessMemoryEx(void* hArcData,void *pMemory,int iSize)
	{
	return RarProcessEntry(hArcData,RAR_EXTRACTMEMEX,(zchar*)pMemory,(zchar*)iSize);
	}

static __inline int RarProcessProc(void* hArcData,PROCESSDATAPROC pProc,void *pParam)
	{
	return RarProcessEntry(hArcData,RAR_EXTRACTPROC,(zchar*)pProc,(zchar*)pParam);
	}

static __inline int RarProcessTest(void* hArcData)
	{
	return RarProcessEntry(hArcData,RAR_TEST,0,0);
	}

static __inline int RarProcessTestEx(void* hArcData)
	{
	return RarProcessEntry(hArcData,RAR_TEST_EX,0,0);
	}

#ifdef	__cplusplus
}
#endif


#endif
