//*****************************************************************************
//*
//*
//*		rar_extract.h
//*
//*
//*****************************************************************************
#ifndef		_RAR_EXTRACT_				
#define		_RAR_EXTRACT_				

enum EXTRACT_ARC_CODE 
	{
	EXTRACT_ARC_NEXT,
	EXTRACT_ARC_REPEAT,
	};

class CmdExtract
{
private:

	EXTRACT_ARC_CODE ExtractArchive();
	bool	ExtractFileCopy(RarFile    &New,wchar *ArcName,wchar *NameNew,wchar *NameExisting,size_t NameExistingSize);
	void	ExtrPrepareName(RarArchive &Arc,const wchar *ArcFileName,wchar *DestName,size_t DestSize);
	
	#ifdef		RARDLL					
	bool	ExtrDllGetPassword();
	#else
	bool	ExtrGetPassword(RarArchive &Arc,const wchar *ArcFileName);
	#endif
	
	#if defined(_WIN_ALL) && !defined(SFX_MODULE)
	void	ConvertDosPassword(RarArchive &Arc,SecPassword &DestPwd);
	#endif
	
	void 	ExtrCreateDir	(RarArchive &Arc,const wchar *ArcFileName);
	bool 	ExtrCreateFile	(RarArchive &Arc,RarFile &CurFile);
	bool	CheckUnpVer		(RarArchive &Arc,const wchar *ArcFileName);

	RarTime			StartTime;									// time when extraction started
	CommandData	   *Cmd;
	ComprDataIO		DataIO;
	Unpack		   *Unp;
	unsigned long	TotalFileCount;

	unsigned long	FileCount;
	unsigned long	MatchedArgs;
	bool			FirstFile;
	bool			AllMatchesExact;
	bool			ReconstructDone;

	// If any non-zero solid file was successfully unpacked before current.
	// If true and if current encrypted file is broken, obviously
	// the password is correct and we can report broken CRC without
	// any wrong password hints.

	bool			AnySolidDataUnpackedWell;
	wchar			ArcName[NM];
	bool			GlobalPassword;
	bool			PrevProcessed; 										// If previous file was successfully extracted or tested.
	wchar			DestFileName[NM];
	bool			PasswordCancelled;
	
	#if defined(_WIN_ALL) && !defined(SFX_MODULE) && !defined(SILENT)
	bool			Fat32;
	bool			NotFat32;
	#endif

public:

	CmdExtract(CommandData *Cmd);
   ~CmdExtract();

	void		DoExtract();
	void		ExtractArchiveInit(RarArchive &Arc);
	bool		ExtractCurrentFile(RarArchive &Arc,size_t HeaderSize,bool &Repeat);
	static void UnstoreFile(ComprDataIO &DataIO,int64 DestUnpSize);
	
	// REM AZ Ereiterung
	int			IsFirstFile (){return FirstFile;}
	void		ResetToFirst(){TotalFileCount=0;}
	void		UnpackFromMemory  (void *Memory,int Size);
	void		UnpackToMemory    (void *Memory,int Size);

	bool		SignatureFound;
};

#endif
