//*****************************************************************************
//*
//*
//*		os2ea.cpp
//*
//*
//*****************************************************************************
#include	<os2.h>



//*****************************************************************************
//*
//*		ExtractOS2EA
//*
//*****************************************************************************
void ExtractOS2EA(RarArchive &Arc,char *FileName)
{
	if(_osmode != OS2_MODE)
		{
		mprintf(St(MSkipEA));
		return;
		}

	if(Arc.HeaderCRC!=Arc.EAHead.HeadCRC)
		{
		RarLog(Arc.FileName,St(MEABroken),FileName);
		ErrHandler.SetErrorCode(CRC_ERROR);
		return;
		}

	if(Arc.EAHead.Method<0x31 || Arc.EAHead.Method>0x35 || Arc.EAHead.UnpVer>PACK_VER)
		{
		RarLog(Arc.FileName,St(MEAUnknHeader),FileName);
		ErrHandler.SetErrorCode(WARNING);
		return;
		}

	struct StructEAOP2
		{
		cha		   *r *GEAPtr;
		cha		   *r *FEAPtr;
		unsigned lon g Error;
		}EAOP2; 

	ComprDataIO DataIO;
	RarUnpack RarUnpack(&DataIO);
	RarUnpack.Init();

	Array<unsigned char> UnpData(Arc.EAHead.UnpSize);
	DataIO.SetUnpackToMemory(&UnpData[0],Arc.EAHead.UnpSize);
	DataIO.SetPackedSizeToRead(Arc.EAHead.DataSize);
	DataIO.EnableShowProgress(false);
	DataIO.SetFiles(&Arc,NULL);
	RarUnpack.SetDestSize(Arc.EAHead.UnpSize);
	RarUnpack.DoUnpack(Arc.EAHead.UnpVer,false);

	if(Arc.EAHead.EACRC!=~DataIO.UnpFileCRC)
		{
		RarLog(Arc.FileName,St(MEABroken),FileName);
		ErrHandler.SetErrorCode(CRC_ERROR);
		return;
		}

	EAOP2.FEAPtr	= (char *)&UnpData[0];
	EAOP2.GEAPtr	=  NULL;
	if(DosSetPathInfo((unsigned char *)FileName,2,&EAOP2,sizeof(EAOP2),0x10)!=0)
		{
		RarLog(Arc.FileName,St(MCannotSetEA),FileName);
		ErrHandler.SetErrorCode(WARNING);
		}

	RarFile::SetCloseFileTimeByName(FileName,&Arc.NewLhd.mtime,&Arc.NewLhd.atime);
	mprintf(St(MShowEA));
}


//*****************************************************************************
//*
//*		ExtractOS2EANew
//*
//*****************************************************************************
void ExtractOS2EANew(RarArchive &Arc,char *FileName)
{
	if(_osmode != OS2_MODE)
		{
		mprintf(St(MSkipEA));
		return;
		}

	Array<byte> SubData;
	if(!Arc.ReadSubData(&SubData,NULL))
		{
		return;
		}

	struct StructEAOP2
		{
		cha		   *r *GEAPtr;
		cha		   *r *FEAPtr;
		unsigned lon g Error;
		}EAOP2; 

	EAOP2.FEAPtr	= (char *)&SubData[0];
	EAOP2.GEAPtr	=  NULL;
	if(DosSetPathInfo((unsigned char *)FileName,2,&EAOP2,sizeof(EAOP2),0x10)!=0)
		{
		RarLog(Arc.FileName,St(MCannotSetEA),FileName);
		ErrHandler.SetErrorCode(WARNING);
		}

	RarFile::SetCloseFileTimeByName(FileName,&Arc.NewLhd.mtime,&Arc.NewLhd.atime);
	mprintf(St(MShowEA));
}

