//*****************************************************************************
//*
//*
//*		rar_rartypes.h
//*
//*
//*****************************************************************************
#ifndef		_RAR_TYPES_ 				
#define		_RAR_TYPES_ 				


#include	<wchar.h>


#ifdef		_MSC_VER					
typedef unsigned __int64	uint64; 							// 64 bits exactly.
typedef __int64				int64;								// Signed 64 bits exactly.
#else
typedef unsigned long long	uint64; 							// 64 bits exactly.
typedef long long			int64;								// Signed 64 bits exactly.
#endif


typedef unsigned char	byte;									// Unsigned 8 bits.
typedef unsigned short	ushort; 								// Preferably 16 bits, but can be more.
typedef unsigned int	uint;									// 32 bits or more.
typedef unsigned int	uint32; 								// 32 bits exactly.
typedef int				int32;									// Signed 32 bits exactly.
typedef wchar_t			wchar;									// Unicode character

// Get lowest 16 bits.
#define		GET_SHORT16(x)				(sizeof(ushort)==2 ? (ushort)(x):((x)&0xffff))

// Make 64 bit integer from two 32 bit.
#define		INT32TO64(high,low) 		((((uint64)(high))<<32)+((uint64)low))

// Maximum int64 value.
#define		MAX_INT64					int64(INT32TO64(0x7fffffff,0xffffffff))

// Special int64 value, large enough to never be found in real life.
// We use it in situations, when we need to indicate that parameter
// is not defined and probably should be calculated inside of function.
// Lower part is intentionally 0x7fffffff, not 0xffffffff, to make it
// compatible with 32 bit int64.
#define		INT64NDF					INT32TO64(0x7fffffff,0x7fffffff)

// Maximum uint64 value.
#define		MAX_UINT64					INT32TO64(0xffffffff,0xffffffff)
#define		UINT64NDF					MAX_UINT64


#if defined(_MSC_VER) && _MSC_VER<=1299

static inline int strnlen(const char *pString,int iMax)
	{
	int		iPos;

	for(iPos=0;iPos<iMax;iPos++)
		{
		if(!pString[iPos])break;
		}

	return iPos;
	}

#define		swprintf					_snwprintf
#define		vswprintf					_vsnwprintf

#ifndef		_O_U16TEXT					
#define		_O_U16TEXT					0x00020000
#endif

#ifndef		CRYPT_SILENT				
#define		CRYPT_SILENT				0x00000040
#endif

#ifdef		SE_CREATE_SYMBOLIC_LINK_NAME	
#define		SE_CREATE_SYMBOLIC_LINK_NAME	TEXT("SeCreateSymbolicLinkPrivilege")
#endif

#ifndef		_WIN64						
#ifndef		DWORD_PTR					
#define		DWORD_PTR					DWORD
#endif
#endif

#endif

#endif
