//*****************************************************************************
//*
//*
//*		UueFile.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf UUE-Dateien:
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int64	Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen

#include	<stdio.h>
#include	<stddef.h>
#include	<string.h>
#include	<sys/stat.h>

#include	"UueFile.h"
#include	"FileFunctions.h"


#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	atoiz	   _wtoi
#define 	itoaz	   _itow
#define 	strzlen		(int)wcslen
#define 	strzcpy		wcscpy
#define 	strzncpy	wcsncpy
#define 	strzncat	wcsncat
#define 	strzicmp	wcsicmp
#define 	strzcspn	wcscspn
#define 	szprintf	swprintf
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	atoiz	    atoi
#define 	itoaz		itoa
#define 	strzlen		(int)strlen
#define 	strzcpy		strcpy
#define 	strzncpy	strncpy
#define 	strzncat	strncat
#define 	strzicmp	stricmp
#define 	strzcspn	strcspn
#define 	szprintf	sprintf
#endif

#define 	ENTRIES(a)	 (sizeof(a)/sizeof((a)[0]))



#define PROG(iMode,pEntry)								\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))			\
	{													\
	if(Progress(iMode,pEntry))throw CAF_ERROR_BREAK;	\
	}
#define PROGR(iMode,pEntry,iRet)						\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))			\
	{													\
	if(Progress(iMode,pEntry))return iRet;				\
	}
#define PROGN(iMode,pEntry)								\
	if(m_pProgress && (m_iProgOn&(1<<iMode)))			\
	{													\
	Progress(iMode,pEntry);								\
	}


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CUueFile::CUueFile()
{

	m_pFiles		= 0;
	m_iFilesMax		= 0;
	m_iFilesNum		= 0;
	m_iFileCount	= 0;
	m_iChangeFlag	= 0;
	m_iDoneMode		= 0;
	m_iDoneNow		= 0;
	m_iDoneMax		= 0;
	m_iChanged		= 0;
	m_iCreated		= 0;
	m_iOpenMode		= 0;
	m_cHasAddFile	= 1;

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CUueFile::~CUueFile()
{

	if(m_iOpenMode!=CAF_CLOSED)
		{
		Close();
		}

	Clear();

}

//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
//	Lscht alle Datenfelder und setzt alle Variabeln zurck
void CUueFile::Clear()
{
int	iPos;


	for(iPos=m_iFilesNum-1;iPos>=0;iPos--)
		{
		UueDel(iPos);
		}


	m_sFind.Set(0);


}

//*****************************************************************************
//*
//*		CmpEx
//*
//*****************************************************************************
int __cdecl CUueFile::CmpEx(const void *pPos1,const void *pPos2)
{
UueItem	*pPtr1,*pPtr2;


	pPtr1=*(UueItem**)pPos1;
	pPtr2=*(UueItem**)pPos2;

	if(pPtr1->cDelete)return (pPtr2->cDelete)? 0:1;
	if(pPtr2->cDelete)return -1;


return strvicmp(pPtr1->pName,pPtr2->pName);
}

//*****************************************************************************
//*
//*		CmpName
//*
//*****************************************************************************
int __cdecl CUueFile::CmpName(const void *pPos1,const void *pPos2)
{
UueItem	*pPtr1,*pPtr2;


	pPtr1=*(UueItem**)pPos1;
	pPtr2=*(UueItem**)pPos2;

	if(pPtr1->cDelete)return (pPtr2->cDelete)? 0:1;
	if(pPtr2->cDelete)return -1;


return strzicmp(pPtr1->pName,pPtr2->pName);
}

//*****************************************************************************
//*
//*		CmpLen
//*
//*****************************************************************************
int __cdecl CUueFile::CmpLen(const void *pPos1,const void * pPos2)
{
UueItem	*pPtr1,*pPtr2;


	pPtr1=*(UueItem**)pPos1;
	pPtr2=*(UueItem**)pPos2;

	if(pPtr1->cDelete)return (pPtr2->cDelete)? 0:1;
	if(pPtr2->cDelete)return -1;


return pPtr1->iLen-pPtr2->iLen;
}

//*****************************************************************************
//*
//*		CmpPos
//*
//*****************************************************************************
int __cdecl CUueFile::CmpPos(const void *pPos1,const void *pPos2)
{
UueItem	*pPtr1,*pPtr2;


	pPtr1=*(UueItem**)pPos1;
	pPtr2=*(UueItem**)pPos2;

	if(pPtr1->cWrite)return (pPtr2->cWrite)? 0:1;
	if(pPtr2->cWrite)return -1;


return pPtr1->iOff-pPtr2->iOff;
}

//*****************************************************************************
//*
//*		Len
//*
//*****************************************************************************
//	Ergibt die Lnge der Datei
//	iNum	: Ist die Nmmer der Datei in der Liste
//	iMode	: Welche Lnge soll zurck gegeben werden
//				0 = wird die originale    Lnge zurckgegeben
//				1 = wird die komprimierte Lnge zurckgegeben
//	Ergibt die Lnge
aint64 CUueFile::Len(int iNum,int iMode)
{
UueItem	*pEntry;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

	pEntry = m_pFiles[iNum];


return (iMode)? pEntry->iLenDec:pEntry->iLen;
}

//*****************************************************************************
//*
//*		SetFail
//*
//*****************************************************************************
//	Setzt das Defekt-Flag und ergibt den alten Wert.
int CUueFile::SetFail(int iNum,int iFail)
{
int		iOld;

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return -1;

	iOld = m_pFiles[iNum]->cError;
	m_pFiles[iNum]->cError = iFail;

return iOld;
}

//*****************************************************************************
//*
//*		IsFail
//*
//*****************************************************************************
//	Ergibt die 1 wenn die Datei mit iNum beschdigt ist sonst 0
int CUueFile::IsFail(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return -1;

return m_pFiles[iNum]->cError;
}

//*****************************************************************************
//*
//*		IsDir
//*
//*****************************************************************************
// Ergibt die 1 wenn die Datei mit iNum ein Verzeichnis ist sonst 0
int CUueFile::IsDir(int iNum)
{


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;


return (m_pFiles[iNum]->sMode&040000)? 1:0;
}

//*****************************************************************************
//*
//*		IsReadOnly
//*
//*****************************************************************************
//	Ergibt die 1 wenn die Datei schreibgeschtzt ist.
int CUueFile::IsReadOnly(int iNum)
{


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;


return (m_pFiles[iNum]->sMode&0200)? 0:1;
}

//*****************************************************************************
//*
//*		IsOk
//*
//*****************************************************************************
//	Ergibt:	2	Wenn die Datei vollstndig entpackt wurde
//          1	Wenn die Datei schon vorhanden war
//			0   Bei Fehlern
int CUueFile::IsOk(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;


return m_pFiles[iNum]->cDecomp;
}


//*****************************************************************************
//*
//*		IsDel
//*
//*****************************************************************************
//	Ergibt 1 wenn die Datei gelscht wurde.
int CUueFile::IsDel(int iNum)
{
	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

return m_pFiles[iNum]->cDelete;
}


//*****************************************************************************
//*
//*		Time
//*
//*****************************************************************************
//	Die nderungzeit einer einzelnen Datei abfragen.
//	iNum		: Ist die Nummer der Datei
//	iMode		: Bestimmt welche Zeit abgefragt werden soll
//					CAF_TIME_W	0	= Zeit der letzten nderung
//					CAF_TIME_C	1	= Zeit der Dateierstellung 
//					CAF_TIME_A	2	= Zeit des letzten Zugriffs 
//	Ergibt die Zeit der letzten nderung einer Datei bzw. CAF_ERROR_MISS (-1)
//	wenn die Datei nicht existiert.
time_t CUueFile::Time(int iNum)
{
	if((unsigned)iNum>=(unsigned)m_iFilesNum)
		{
		return CAF_ERROR_MISS;
		}

	return m_pFiles[iNum]->iTime;
}

time_t CUueFile::Time(int iNum,int iMode)
{
	
	if((unsigned)iNum>=(unsigned)m_iFilesNum)
		{
		return CAF_ERROR_MISS;
		}

	switch(iMode)
			{
	case CAF_TIME_W:									// Zeit der letzten nderung
	case CAF_TIME_C:									// Zeit der Dateierstellung
	case CAF_TIME_A: return m_pFiles[iNum]->iTime;		// Zeit des letzten Zugriffs
			}

	return CAF_ERROR_MISS;
}


//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Hole einen Zeiger auf den Dateinamen.
//	iNum		: Ist die Indexnummer des Namens (-1=Archiv-Datei)
//	iLen		: Hier wird die Lnge des Namens gespeichert
//	Ergibt einen Zeiger auf den Namen oder NULL bei einem Fehler.
zchar *CUueFile::Name(int iNum)
{

	if((unsigned)iNum<(unsigned)m_iFilesNum)			// Prfe den Dateiindex			
		{
		return m_pFiles[iNum]->pName;
		}

	if(iNum==-1)										// Name der Archiv-Datei
		{
		return m_cFilePath;
		}

	if(iNum==m_iFilesNum)								// Datei die gerade eingefgt wird
		{
		return m_pInsertFile;
		}


return NULL;
}

//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Hole Dateiname samt Lnge.
//	iNum		: Ist die Indexnummer des Namens (-1=ZIP-File)
//	iLen		: Hier wird die Lnge des Namens gespeichert
//	Ergibt einen Zeiger auf den Namen oder NULL bei einem Fehler.
zchar *CUueFile::Name(int iNum,int &iLen)
{


	if((unsigned)iNum<(unsigned)m_iFilesNum)			// Prfe den Dateiindex
		{
		iLen = m_pFiles[iNum]->iNameLen;
		return m_pFiles[iNum]->pName;
		}

	if(iNum==-1)										// Name der Archiv-Datei
		{
		iLen = strzlen(m_cFilePath);
		return m_cFilePath;
		}

	if(iNum==m_iFilesNum)								// Datei die gerade eingefgt wird
		{
		iLen = (m_pInsertFile)? strzlen(m_pInsertFile):0;
		return  m_pInsertFile;
		}

	iLen = 0;


return NULL;
}


//*****************************************************************************
//*
//*		Stats
//*
//*****************************************************************************
//	Die Zustandbits abfragen
//	iNum		: Ist der Name der Datei samt Pfad die geprft werden soll.
//	iSet		: Welche Bits sollen gesetzt werden
//	iDel		: Welche Bits sollen gelscht werden
//	Ergibt einen Wert mit veschiedenen Bits:
//					CAF_STAT_EXIST		0x0001	Wenn die Datei beim Entpacken schon vorhanden war
//					CAF_STAT_DECOMP		0x0002	Wenn die Datei vollstndig neu entpackt wurde (immer ohne CAF_STAT_FILEOK)
//					CAF_STAT_DELETE		0x0004	Die Datei wurde aus dem Verzeichnis gelscht
//					CAF_STAT_WRITE		0x0008	Die Datei muss ins Archiv geschrieben werden
//					CAF_STAT_DIR		0x0010	Die Datei ist ein Verzeichniss
//					CAF_STAT_READONLY	0x0020	Die Datei ist schreibgeschtzt
//					CAF_STAT_SAVED		0x0040	Die Datei ist im Archiv gespeichert
int CUueFile::Stats(int iNum)
{
UueItem	   *pEntry;
int			iBits;

	if((unsigned)iNum>=(unsigned)m_iFilesNum)				// Prfe den Index
		{
		return 0;
		}

			pEntry=m_pFiles[iNum];
	iBits = pEntry->cDecomp&3;

	if(  pEntry->cDecomp     )iBits|=CAF_STAT_DECOMP;
	if(  pEntry->cDelete     )iBits|=CAF_STAT_DELETE;
	if(  pEntry->cWrite      )iBits|=CAF_STAT_WRITE;
	if(  pEntry->cSaved      )iBits|=CAF_STAT_SAVED;
	if(  pEntry->sMode&040000)iBits|=CAF_STAT_DIR;
	if(!(pEntry->sMode&0200 ))iBits|=CAF_STAT_READONLY;
	

return iBits;	
}

//*****************************************************************************
//*
//*		SetStats
//*
//*****************************************************************************
//	Den Zustand einer Arichive Datei verndern.
//	iNum		: Ist der Name der Datei samt Pfad die geprft werden soll.
//	iSet		: Welche Bits sollen gesetzt werden
//					CAF_STAT_NONE		0x0000	Die Datei wurde noch nicht entpackt
//					CAF_STAT_EXIST		0x0001	Wenn die Datei beim Entpacken schon vorhanden war
//					CAF_STAT_DECOMP		0x0002	Wenn die Datei vollstndig neu entpackt wurde (immer ohne CAF_STAT_FILEOK)
//	Ergibt den alten Wert oder -1 bei einem Fehler.
int CUueFile::SetStats(int iNum,int iSet)
{
UueItem	   *pEntry;
int			iOld;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)				// Prfe den Index
		{
		return -1;
		}

	pEntry			= m_pFiles[iNum];
	iOld			= pEntry->cDecomp;
	pEntry->cDecomp = iSet;
	

return iOld;	
}

//*****************************************************************************
//*
//*		SetDoneMode
//*
//*****************************************************************************
//	Modus fr die Verlaufsanzeige setzen.
//	iMode		: Ist der neue Modus
//				    0 = Zurck zu Normal (Ende)
//					1 = Begin von Extract (einzelene Datei)
//					2 = Begin von ExtractAll
//	Ergibt den vorherigen Modus.
int CUueFile::SetDoneMode(int iMode)
{
int		iRet;

	
	iRet = m_iDoneMode;
	
	switch(iMode)
		{
	case 0:												// Zurck zu Normal (Ende)

		if(m_iDoneMode==1 || m_iDoneMode==2)
		if(m_iErrorCode==CAF_ERROR_OK)
			{
			m_iDoneNow  = m_iDoneMax;
			}

		m_iDoneMode	 = 0;
		break;

	case 1:												// Begin von Extract (einzelene Datei)

		if(iRet==2)return iRet;
		m_iDoneNow		= 0;
		m_iDoneMax		= 0;
		m_iDoneMode		= 0;
		break;

	case 2:												// Begin von ExtractAll

		m_iDoneNow		= 0;
		m_iDoneMax		= 0;
		m_iDoneMode		= 1;
		break;
		}


return iRet;
}

//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
//	Sortiert die Liste der Dateien im Archiv.
//  iMode	: Ist der Sortiermodus	(0=Standardmodus)
//				CAF_FLAG_SORT	 0x0400		= Nach Namen  sortieren
//				CAF_FLAG_SORTLEN 0x0500		= Nach Lngen sortieren
//				CAF_FLAG_SORTPOS 0x0600		= Nach Offset sortieren (intern)
//				CAF_FLAG_SORTEX	 0x0700		= Nach Namen mit Zahlen Bercksichtigung
//	Ergibt die Anzahl der Dateien im Archiv.
int	CUueFile::Sort(int iMode)
{

		iMode&=0x0700;
	if(!iMode)											// Standardmodus benutzen
		{
		iMode = m_iModeFlags&0x0700;
		}

	iMode |= 0x0400;

	PROGR(CAF_PROG_SORT,-1,0);


	if(!m_pFiles)return 0;

	if(iMode==m_iSortMode)									// Ist die Liste bereits sortiert
		{
		return m_iFileCount;
		}

	if(m_iFilesNum)
		{
	switch(iMode)
			{
	case    CAF_FLAG_SORTEX:	qsort(m_pFiles, m_iFilesNum, sizeof(UueItem*),CmpEx  );break;
	case    CAF_FLAG_SORTLEN:	qsort(m_pFiles, m_iFilesNum, sizeof(UueItem*),CmpLen );break;
	case    CAF_FLAG_SORTPOS:	qsort(m_pFiles, m_iFilesNum, sizeof(UueItem*),CmpPos );break;
	default:					qsort(m_pFiles, m_iFilesNum, sizeof(UueItem*),CmpName);break;
			}
		}

	m_iModeFlags &= ~0x0300;
	m_iModeFlags |=  0x0300&iMode;
	m_iSortMode   =  iMode;


return m_iFileCount;
}

//*****************************************************************************
//*
//*		ArchOpen
//*
//*****************************************************************************
//	ffnet eine BZIP2-Datei und liest alle bereits gespeicherten Dateien ein.
//	Zuvor wurde eine Datei bzw. ein Speicherbereich in CArchiveFile::Open geffnet.
//	iLevel	: Komprimierungs Levl (0-9) 9=maximal  (unbenutzt)
//	Ergibt 0 wenn alles ok war, bzw. einen anderen Fehlercode:
//					CAF_ERROR_OK		Alles ok
//					CAF_ERROR_NONE		Wenn die Datei nicht gefunden werden konnte
//					CAF_ERROR_OPEN		Wenn die Datei nicht geffnet werden konnte
//					CAF_ERROR_CREATE	Wenn die Datei nicht erzeugt  werden konnte
//					CAF_ERROR_READ		Bei Lese-Fehlern
//					CAF_ERROR_FORM		Bei Fehlern im UUE-Archiv
//					CAF_ERROR_MULTI		Wenn Zib ber mehere Disketten geht
//					CAF_ERROR_LOGIC		Bei internen unbekannten Fehlern
int CUueFile::ArchOpen(int iLevel)
{
char		cBuffer[4096+512+4];
char		cName  [1024];
UueItem    *pEntry;
unsigned	uValue;
int			iLength;
int			iBytes;
int			iStart;
int			iModeF;
int			iData;
int			iSize;
int			iDone;
int			iAdd;
int			iNum;
int			iPos;
int			iOff;
int			iVal;
int 		iMax;
aint64		iLen;





	Clear();

	iNum			= 0;
	m_iFileEnd		= 0;
	m_iDoneNow		= 0;
	m_iDoneMax		= 0;
	m_iDoneMode		= 0;
	m_iChanged		= 0;
	m_iChangeFlag	= 0;
	m_iErrorCode	= CAF_ERROR_OK;



	if(m_iFileSize<=0)									// Leere Datei
		{
		if(m_iOpenMode!=CAF_CREATE)
			{
			return CAF_ERROR_FORM;
			}

		m_iChanged	= 1;
		m_iOpenMode = CAF_WRITE;

		return  CAF_ERROR_OK;
		}



	if(m_iFileSize==0)									// Leere Datei
		{
		m_iChanged	= 1;
		return  CAF_ERROR_OK;
		}

	if(m_iFileSize>=0x80000000)							// Ist die Datei zu gro
		{
		return CAF_ERROR_FORM;
		}


//******************** Dateiliste laden ***************************************


	cName[0]			= 0;
	m_iDoneNow			= 0;
	m_iDoneMax			= (int)m_iFileSize;
	iBytes				= 0;
	iDone				= 0;
	iStart				= 0;
	cBuffer[4096+512]	= 0;


try	{
	for(iPos=0;iPos<m_iFileSize;iPos+=iAdd,iDone+=iAdd,m_iDoneNow+=iAdd)
		{
		if(iDone+512>=iBytes)							// Buffer fllen
			{
			iLen	= iBytes-iDone;
			memcpy(cBuffer,cBuffer+iDone,(int)iLen);
			iBytes	= (int)iLen;
			iDone   = 0;

			   iLen	= m_iFileSize-iPos-iBytes;
			if(iLen>4096)iLen=4096;

			if(iLen<=0)
				{
				if(iBytes==0)break;
				}
			else{
				MainRead(cBuffer+iBytes,(int)iLen);
				iBytes += (int)iLen;
				}
			}

		for(iAdd=iDone;iAdd<iBytes;iAdd++)				// Zeilenlnge bestimmen
			{
			if(cBuffer[iAdd]=='\n')break;
			if(cBuffer[iAdd]=='\r')break;
			}


		iVal  = iAdd-iDone;

		if(cBuffer[iAdd]=='\r')iAdd++;
		if(cBuffer[iAdd]=='\n')iAdd++;

		iAdd -= iDone;

		if(!iVal)continue;

		if(cName[0]==0)									// Namen suchen
			{
			if(cBuffer[iDone]!='b'   || iAdd<=8)continue;
			if(memcmp(cBuffer+iDone,"begin ",6))continue;

			if(iVal>=sizeof(cName))iVal=sizeof(cName)-1;
			memcpy(cName,cBuffer+iDone,(int)iVal);
			iData		= iPos+iAdd;
			iLength     = 0;
			cName[iVal] = 0;

			continue;
			}


		uValue = cBuffer[iDone]-' ';

		if(uValue>=64)
			{
			if(uValue>64)throw CAF_ERROR_FORM;
			uValue = 0;
			}


		if(iVal<(int)(1+uValue+(uValue+2)/3))			// Zuwenig Daten in der Zeile
			{
			throw CAF_ERROR_FORM;
			}

		iLength += uValue;

		if(uValue)continue;								// Ende der Datei erreicht ?

		if(memcmp(cBuffer+iDone+iAdd,"end",3))
			{
			throw CAF_ERROR_FORM;
			}

		iAdd += iDone;
		iAdd += 3;

		for(;iAdd<iBytes;iAdd++)						// Linefeed berspringen
			{
			if(cBuffer[iAdd]=='\n')break;
			if(cBuffer[iAdd]=='\r')break;
			}

		iVal  = iAdd-iDone;

		if(cBuffer[iAdd]=='\r')iAdd++;
		if(cBuffer[iAdd]=='\n')iAdd++;

		iAdd -= iDone;

		iOff   = 6;
		iModeF = OctToInt(cName+iOff);
		while(cName[iOff]>='0' && cName[iOff]<='9')iOff++;
		while(cName[iOff]==' ')iOff++;


		if((iModeF&040000) && iLength>0)				// Verzeichnisse mssen leer sein
			{
			throw CAF_ERROR_FORM;
			}


		iNum	      = UueNew();						// Neuer Block
		pEntry	      = m_pFiles[iNum];
		m_iDoneNow    = iPos;

		memset(pEntry,0,sizeof(UueItem));

		iSize	      = (int)strlen(cName+iOff);
		pEntry->pName = new zchar[iSize+1];


		if(cName[iOff]=='.' && cName[iOff+1]=='/')
			{
			iOff+=2;
			}


		for(iMax=0;cName[iOff];iMax++)					// Von UTF8 auf ANSI
			{
			unsigned	uUnicode;
			iOff += utf8tochar(cName+iOff,uUnicode);
			#ifndef UNICODE
			if(uUnicode>255)uUnicode=255;
			#endif
			pEntry->pName[iMax] = (zchar)uUnicode;
			}

		pEntry->pName[iMax] = 0;
		pEntry->iNameLen    = iMax;


		if(pEntry->iNameLen>0 && pEntry->pName[pEntry->iNameLen-1]=='/')
			{
			pEntry->iNameLen--;
			pEntry->pName[pEntry->iNameLen]=0;
			}

		pEntry->cSaved	= 1;							// Ist die Datei in UUE vorhanden
		pEntry->iTime	= 0;							// Ist die nderungszeit
		pEntry->iOff	= iStart;						// Ist der Offset im UUE-Archiv
		pEntry->iEnd	= iPos+iAdd;					// Ist das Ende der Daten (samt Header)
		pEntry->iLen	= iLength;						// Ist die Gre der Datei entkomprmiert
		pEntry->iLenDec	= iPos -iData;					// Ist die Gre der Datei komprmiert im Archiv
		pEntry->iLenHdr	= iData-iStart;					// Ist die Gre des Headers im UUE-Archiv
		pEntry->sMode	= iModeF;						// Ist die Zugriffsart (z.B. 0666)
		iStart			= pEntry->iEnd;
		cName[0]		= 0;

		PROG(CAF_PROG_FIND,iNum);
		}

//*****************************************************************************
	}
catch(int iError)										// Bekannter Fehler
	{
	m_iErrorCode = iError;
	PROGN(CAF_PROG_ERROR,-1);
	CUueFile::Break();
	return iError;
	}

	if(m_iModeFlags&CAF_FLAG_SORT)						// Sortieren ?
		{
		Sort();
		}

	m_iErrorCode = CAF_ERROR_OK;
	m_iFileEnd	 = iPos;




return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht nach einer Datei in der Dateiliste
//	pName	: Ist der  Dateiname nach dem gesucht wird
//	Ergibt die Indexnummer der Datei, bzw. -1 wenn die Datei nicht gefunden wurde.
int CUueFile::Find(const zchar *pName)
{
UueItem	   *pEntry;
int			iLen;
int			iPos;


	if(*pName=='/' )pName++;
	if(*pName=='\\')pName++;


	iLen = strzlen(pName);

	for(iPos=0;iPos<m_iFilesNum;iPos++)								// Eintrag in Kette suchen
		{
		   pEntry = m_pFiles[iPos];
		if(pEntry->cDelete       )continue;
		if(pEntry->iNameLen!=iLen)continue;

		if(!CmpFileNameN(pName,pEntry->pName))
			{
			return iPos;
			}
		}


return -1;
}


//*****************************************************************************
//*
//*		AddPath
//*
//*****************************************************************************
//	Fgt dem UUE-Archiv einen Pfad hinzu. Der Pfad muss dabei nicht real existieren
//	ber die Flags() kann mann die Speicherungs Art festlegen
//	Falgs:	CAF_FLAG_FULLPATH	0x0880	 Ganze Namen mit  Laufwerken
//	       	CAF_FLAG_FULLNAME	0x0800	 Ganze Namen ohne Laufwerken
//	pFileName	: ist der Dateiname fr den pPathName
//	Ergibt CAF_ERROR_OK wenn alles ok war bzw. einen Fehlercode
int CUueFile::AddPath(const zchar *pFileName)
{
UueItem		   *pEntry;
time_t			iTime;
zchar		   *pName;
int				iOff;
int				iPos;
int				iNum;
int				iLen;


	m_iErrorCode=CAF_ERROR_OK;

	try	{
		if(m_iOpenMode!=CAF_WRITE)throw CAF_ERROR_WRITE;

		pName=(zchar*)pFileName;

		if(!(m_iModeFlags&0x0080))							// Keine Laufwerksbuschstaben speichern
			{
			iPos=strcwlen(pName,0x00700000);
			if(pName[iPos]==':')pName+=iPos+1;
			}

		if(*pName=='\\')pName++;
		if(*pName=='/' )pName++;


		if(m_iModeFlags&CAF_FLAG_NOFIND)				// Nicht prfen ob die Datei im Archiv ist
			{
			iNum = -1;
			}
		else{
			   iNum=Find(pName);
			if(iNum>=0 && (m_iModeFlags&CAF_FLAG_NOEXIST))
				{
				return CAF_ERROR_OK;
				}

			if(iNum>=0)
				{
				UueSetDel(iNum);
				}
			}


		iTime	= time(0);									// Neue Liste erzeugen
		iOff	= (int)MainSeek(m_iFileEnd,SEEK_SET);

		iLen				=  strzlen(pName);				// Eintrag erzeugen kopieren
		iNum				=  UueNew();
		pEntry				=  m_pFiles[iNum];
		pEntry->cDelete		=  1;
		pEntry->cWrite		=  1;
		pEntry->cSaved		=  0;
		pEntry->iNameLen    =  iLen;
		pEntry->iLen		=  0;
		pEntry->iOff		=  iOff;
		pEntry->iEnd		=  iOff;
		pEntry->iTime		=  iTime;
		pEntry->sMode		=  040666;
		pEntry->pName		=  new zchar[iLen+1];

		memcpy(pEntry->pName,pName,(iLen+1)*sizeof(zchar));
		CharToPath(pEntry->pName);


		PROGN(CAF_PROG_WRITE,iNum);

		m_iSortMode = 0;
		m_iChanged	= 1;
		Write(iNum);
		m_iFileEnd  = (int)MainTell();


		if(m_iModeFlags&CAF_FLAG_SORT)						// Sortieren ?
			{
			Sort();			
			}
		}
	catch(int iError)
		{
		m_iErrorCode = iError;
		PROGN(CAF_PROG_ERROR,-1);
		return iError;
		}


return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		AddProc
//*
//*****************************************************************************
//	Fgt dem UUE-Archiv eine Datei hinzu, die Daten wird ber ein Callback 
//	geladen. ber die Flags() kann mann die Speicherungsart der Namens 
//	im Archiv festlegen:
//					CAF_FLAG_FULLPATH	0x0880	 Ganze Namen mit  Laufwerken
//	       			CAF_FLAG_FULLNAME	0x0800	 Ganze Namen ohne Laufwerken
//	pFileName	: Ist der Dateiname fr die Datei
//	pParam		: Ist der Zeiger der an die Funktion bergeben wird.
//	pProc		: Ist der Zeiger auf die Callback-Funktion.
//					Mit  0 signalisiert der Callback das Dateiende 
//					Mit -1 signalisiert der Callback einen Fehler
//	pInfo		: Enthlt Zeiten, Attribute und Gre der Datei.
//				  Bei NULL werden diese Werte ignoriert.
//				  Mit "*...<Path>..." kann eine Datei direkt bergeben werden
//	Ergibt CAF_ERROR_OK wenn alles ok war oder einen Fehlercode.
int CUueFile::AddProc(const zchar *pFileName,void *pParam,InpProc pProc,FileData *pInfo)
{
BYTE			aLines [640];
BYTE			aBuffer[512];
char			cName  [512];
unsigned char  *pInput;
UueItem		   *pEntry;
zchar		   *pName;
unsigned		uChar;
short 			sAttr;
time_t			iTime;
int				iSize;
int				iDone;
int				iByte;
int				iOff;
int				iNum;
int				iPos;
int				iLen;
int				iEnd;
int				iAdd;
int				iIdx;



	if(pInfo && (pInfo->dwAttr&SYS_DIR))					// Ein Verzeichniss einfgen
		{
		return AddPath(pFileName);
		}

	m_iErrorCode = CAF_ERROR_OK;

	try	{
		if(m_iOpenMode!=CAF_WRITE)throw CAF_ERROR_WRITE;

		pName=(zchar*)pFileName;

		if(!(m_iModeFlags&0x0080))							// Keine Laufwerksbuschstaben speichern
			{
			iPos=strcwlen(pName,0x00700000);
			if(pName[iPos]==':')pName+=iPos+1;
			}

		if(*pName=='\\')pName++;
		if(*pName=='/' )pName++;


		if(m_iModeFlags&CAF_FLAG_NOFIND)					// Nicht prfen ob die Datei im Archiv ist
			{
			iNum = -1;
			}
		else{
			   iNum=Find(pName);
			if(iNum>=0 && (m_iModeFlags&CAF_FLAG_NOEXIST))
				{
				return CAF_ERROR_OK;
				}
			
			if(iNum>=0)
				{
				UueSetDel(iNum);
				}
			}


		if(pInfo)											// Gibt es Infos zur neuen Datei
			{
			if(pInfo->dwAttr&SYS_WRITE)
					sAttr = 0664;
			else	sAttr = 0444;

			if(pInfo->dwTimeWrite!=0 && pInfo->dwTimeWrite!=0xFFFFFFFF)
					iTime = pInfo->dwTimeWrite;
			else	iTime = time(0);		

			iSize	= (pInfo->dwAttr&SYS_HIGHMASK)>>SYS_HIGHSHIFT;
			iSize <<= 32;
			iSize  += pInfo->dwSize;

			if(pProc==CAF_ADD_FILE)							// Die Datei erst mit Flash() speichern
					iAdd = strzlen(pInfo->cName)+1;			
			else	iAdd = 0;
			}
		else{
			iTime	= time(0);								// Aktuelle Zeit benutzen
			sAttr	= 0664;
			iSize	= 0;
			iAdd	= 0;
			}



		iLen				=  strzlen(pName);				// Eintrag erzeugen kopieren
		iNum				=  UueNew();
		pEntry				=  m_pFiles[iNum];
		pEntry->iNameLen    =  iLen;
		pEntry->iLen		=  iSize;
		pEntry->iOff		=  m_iFileEnd;
		pEntry->iEnd		=  m_iFileEnd;
		pEntry->iTime		=  iTime;
		pEntry->sMode		=  sAttr;
		pEntry->pName		=  new zchar[iLen+1+iAdd];

		memcpy(pEntry->pName,pName,(iLen+1)*sizeof(zchar));
		CharToPath(pEntry->pName);

		if(iAdd)											// Die Datei erst mit Flash() speichern
			{
			pEntry->cWrite  =  1;
			pEntry->pPath	=  pEntry->pName+iLen+1;
			memcpy(pEntry->pPath,pInfo->cName,iAdd*sizeof(zchar));

			return CAF_ERROR_OK;
			}


		PROGN(CAF_PROG_WRITE,iNum);

		pEntry->cSaved		=  1;

		iOff	= (int)MainSeek(m_iFileEnd,SEEK_SET);
		iPos	= sprintf(cName,"\r\nbegin %03o ",pEntry->sMode);


		for(iIdx=0;iIdx<pEntry->iNameLen;iIdx++)			// Von ANSI auf UTF8
			{
			#ifdef UNICODE
			uChar = pEntry->pName[iIdx];
			#else
			uChar = ((unsigned char*)(pEntry->pName))[iIdx];
			#endif

			iPos += chartoutf8(cName+iPos,uChar);
			}

		cName[iPos] = '\r';	iPos++;
		cName[iPos] = '\n';	iPos++;

		pEntry->iLen		= 0;
		pEntry->iLenDec		= 0;
		pEntry->iLenHdr		= iPos;
		pEntry->iOff		= (int)MainTell();
		pEntry->iEnd		= pEntry->iOff;


		MainWrite(cName,iPos);


		if(!(pEntry->sMode&040000))							// Kopiere die Datei
			{
			iByte = 0;
			iDone = 0;
			iPos  = 0;
			iEnd  = 0;
			iLen  = 0;

			while(!iEnd || iDone<iByte)
				{
				while(iDone+45>iByte && !iEnd)				// Eingabe Puffer fllen
					{
					if(iByte>sizeof(aBuffer)-64)
						{
						iSize = iByte-iDone;
						memmove(aBuffer,aBuffer+iDone,iSize);
						iByte = iSize;
						iDone = 0;
						}

					   iSize = pProc(pParam,(char*)aBuffer+iByte,sizeof(aBuffer)-2-iByte);
					if(iSize <0)throw CAF_ERROR_READ;
					if(iSize==0)iEnd=1;

					iByte += iSize;
					}

				if(iByte==0)break;

				pInput = aBuffer+iDone;

				   iSize = iByte-iDone;
				if(iSize>45)iSize=45;

				if(iSize<45)
					{
					pInput[iSize  ] = 0;
					pInput[iSize+1] = 0;
					}

				aLines[iPos] = ' '+iSize;					// Datenlnge pro Zeile
				iPos++;

				for(iIdx=0;iIdx<iSize;iIdx+=3,iPos+=4)		// Einzelne Zeile erzeugen
					{
					aLines[iPos  ] = ( pInput[iIdx  ]      >>2)                    +' ';
					aLines[iPos+1] = ((pInput[iIdx  ]&0x03)<<4)+(pInput[iIdx+1]>>4)+' ';
					aLines[iPos+2] = ((pInput[iIdx+1]&0x0F)<<2)+(pInput[iIdx+2]>>6)+' ';
					aLines[iPos+3] = ( pInput[iIdx+2]&0x3F    )                    +' ';

					if(aLines[iPos  ]==' ')aLines[iPos  ]=96;
					if(aLines[iPos+1]==' ')aLines[iPos+1]=96;
					if(aLines[iPos+2]==' ')aLines[iPos+2]=96;
					if(aLines[iPos+3]==' ')aLines[iPos+3]=96;
					}

				aLines[iPos] = '\r'; iPos++;
				aLines[iPos] = '\n'; iPos++;


				if(iPos>512)								// Block weg speichern
					{
					MainWrite(aLines,iPos);
					iPos = 0;
					}

				iDone += iSize;
				iLen  += iSize;
				}

			if(iPos>0)MainWrite(aLines,iPos);
			}


		pEntry->iLen	 = iLen;
		pEntry->iLenDec  = (int)MainTell();
		pEntry->iLenDec -= pEntry->iOff;
		pEntry->iLenDec -= pEntry->iLenHdr;


		MainWrite("\x60\r\nend\r\n",8);


		m_iSortMode     = 0;
		m_iChanged		= 1;
		pEntry->iEnd	= (int)MainTell();
		m_iFileEnd		= pEntry->iEnd;
		m_iFileSize	= m_iFileEnd;

		if(m_iModeFlags&CAF_FLAG_SORT)						// Sortieren ?
			{
			Sort();
			}
		}
	catch(int iError)
		{
		m_iErrorCode = iError;
		PROGN(CAF_PROG_ERROR,-1);
		return iError;
		}


return CAF_ERROR_OK;
}


//*****************************************************************************
//*
//*		Write
//*
//*****************************************************************************
//	Speichert die Datei in To auf der aktuellen ZFile Position
//	Schreibt LOC-Block und pFileName Daten.
//	ber throw werden die Fehler-Codes zurck gegeben
int CUueFile::Write(int iNum)
{
BYTE			aLines [512+128];
BYTE			aBuffer[512+2];
zchar			cName  [512];
unsigned char  *pInput;
UueItem		   *pEntry;
HANDLE			hFile;
DWORD			dwAttr;
DWORD			dwBytes;
UINT			uChar;
int				iSize;
int				iMode;
int				iDone;
int				iByte;
int 			iLen;
int				iPos;
int				iOff;
int				iVal;
aint64			iAll;





	pEntry = m_pFiles[iNum];
	PROG(CAF_PROG_WRITE,iNum);



//******************** Daten speichern ****************************************


	m_pErrorFile = pEntry->pName;

	if(pEntry->sMode&040000)								// Ist es ein Verzeichnis
		{
		pEntry->iLen = 0;
		iLen		 = 0;
		iMode		 = 0040755;
		hFile		 = INVALID_HANDLE_VALUE;
		}
	else{
		iPos = strlcpy(cName,pEntry->pPath,ENTRIES(cName));

		   hFile =CreateFile(cName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(hFile==INVALID_HANDLE_VALUE)throw CAF_ERROR_FOPEN;

		   iAll = GetFileSize(hFile);
		if(iAll<0 || iAll>0x40000000)						// Ist die Datei zu gro
			{
			CloseFile(hFile);
			throw CAF_ERROR_WRITE;
			}

		iLen = (int)iAll;

		   dwAttr=GetFileAttributes(cName);
		if(dwAttr&FILE_ATTRIBUTE_READONLY)
				iMode = 0100444;
		else	iMode = 0100664;

		pEntry->iLen = iLen;
		}


	try	{
		iPos = sprintf((char*)cName,"\r\nbegin %03o ",iMode);


		for(iVal=0;iVal<pEntry->iNameLen;iVal++)			// Von ANSI auf UTF8
			{
			#ifdef UNICODE
			uChar = pEntry->pName[iVal];
			#else
			uChar = ((unsigned char*)(pEntry->pName))[iVal];
			#endif

			iPos += chartoutf8(((char*)cName)+iPos,uChar);
			}

		if(pEntry->sMode&040000)							// Slash anhngen bei Verzeichniss
			{
			cName[iPos] = '/';
			iPos++;
			}

		cName[iPos] = '\r';	iPos++;
		cName[iPos] = '\n';	iPos++;


		pEntry->iLenDec		= 0;
		pEntry->iLenHdr		= iPos;
		pEntry->iOff		= (int)MainTell();
		pEntry->iEnd		= pEntry->iOff;


		MainWrite(cName,iPos);


		if(!(pEntry->sMode&040000))							// Kopiere die Datei
			{
			iDone = 0;
			iByte = 0;
			iPos  = 0;
			iOff  = 0;

			for(;;)
				{
				if(iDone+45>iByte)
					{
					iSize = iByte-iDone;
					memmove(aBuffer,aBuffer+iDone,iSize);
					iByte = iSize;
					iDone = 0;

					   iSize = iLen-iOff;
					if(iSize>(int)(sizeof(aBuffer)-2-iByte))
						{
						iSize = sizeof(aBuffer)-2-iByte;
						}
					else if(iSize==0 && iByte==0)
						{
						break;
						}

					if(!ReadFile(hFile,aBuffer+iByte,iSize,&dwBytes,NULL) || dwBytes!=(unsigned)iSize)
						{
						CloseFile(hFile);
						throw CAF_ERROR_FREAD;
						}

					iByte += iSize;
					iOff  += iSize;
					}


				pInput = aBuffer+iDone;

				   iSize = iByte-iDone;
				if(iSize>45)iSize=45;

				if(iSize<45)
					{
					pInput[iSize  ] = 0;
					pInput[iSize+1] = 0;
					}

				aLines[iPos] = ' '+iSize;					// Datenlnge pro Zeile
				iPos++;

				for(iVal=0;iVal<iSize;iVal+=3,iPos+=4)		// Einzelne Zeile erzeugen
					{
					aLines[iPos  ] = ( pInput[iVal  ]      >>2)                    +' ';
					aLines[iPos+1] = ((pInput[iVal  ]&0x03)<<4)+(pInput[iVal+1]>>4)+' ';
					aLines[iPos+2] = ((pInput[iVal+1]&0x0F)<<2)+(pInput[iVal+2]>>6)+' ';
					aLines[iPos+3] = ( pInput[iVal+2]&0x3F    )                    +' ';

					if(aLines[iPos  ]==' ')aLines[iPos  ]=96;
					if(aLines[iPos+1]==' ')aLines[iPos+1]=96;
					if(aLines[iPos+2]==' ')aLines[iPos+2]=96;
					if(aLines[iPos+3]==' ')aLines[iPos+3]=96;
					}

				aLines[iPos] = '\r'; iPos++;
				aLines[iPos] = '\n'; iPos++;


				if(iPos>512)								// Block weg speichern
					{
					MainWrite(aLines,iPos);
					iPos = 0;
					}

				m_iDoneNow	+= iSize;
				iDone		+= iSize;
				}

			if(iPos>0)										// Block weg speichern
				{
				MainWrite(aLines,iPos);
				iPos = 0;
				}


			CloseFile(hFile);
			}


		pEntry->iLenDec  = (int)MainTell();
		pEntry->iLenDec -= pEntry->iOff;
		pEntry->iLenDec -= pEntry->iLenHdr;

		MainWrite("\x60\r\nend\r\n",8);

		pEntry->iEnd	 = (int)MainTell();
		pEntry->cSaved	 = 1;
		pEntry->cWrite	 = 0;
		pEntry->cDelete	 = 0;

		PROG(CAF_PROG_COMPRESS,iNum);
		}
	catch(int iError)									// Bekannter Fehler
		{
		CloseFile(hFile);
		throw iError;
		}



return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		UueDel
//*
//*****************************************************************************
//	Listeneintrag lschen
void CUueFile::UueDel(int iNum)
{
UueItem	*pEntry;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;

	pEntry=m_pFiles[iNum];

	if(!pEntry)return;

	m_iFilesNum--;
	m_pFiles[iNum]=0;

	if(iNum<m_iFilesNum)
		{
		memmove(m_pFiles+iNum,m_pFiles+iNum+1,(m_iFilesNum-iNum)*sizeof(m_pFiles[0]));
		}

	if(!pEntry->cDelete)m_iFileCount--;
	if( pEntry->pName  )delete pEntry->pName;
 					    delete pEntry;

	if(m_iFilesNum<=0)
		{
		delete  m_pFiles;
		m_iFilesNum		= 0;
		m_iFilesMax		= 0;
		m_iFileCount	= 0;
		}
}

//*****************************************************************************
//*
//*		UueSetDel
//*
//*****************************************************************************
//	Listeneintrag lschen
void CUueFile::UueSetDel(int iNum)
{
UueItem	*pEntry;


	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;			// Nummer im Bereich

		pEntry=m_pFiles[iNum];
	if(!pEntry->cDelete)
		{
		m_iChanged		= 1;
		m_iFileCount   -= 1;
		pEntry->cDelete	= 1;
		}

	if(pEntry->cWrite)								// Gleichen Block lschen
		{
		UueDel(iNum);
		return;
		}

	if(iNum>=m_iFileCount)return;
	if(m_iModeFlags&CAF_FLAG_SORT)					// Sortierte Liste
		{
		Sort();
		return;
		}

	m_pFiles[iNum]         = m_pFiles[m_iFileCount];
	m_pFiles[m_iFileCount] = pEntry;

}

//*****************************************************************************
//*
//*		UueNew
//*
//*****************************************************************************
//	Listeneintrag erzeugen
#define	ZNEW_ADD	256
int	CUueFile::UueNew()
{
UueItem	**pNew;



	if(!m_pFiles || !m_iFilesMax)					// Neue Kette
		{
		m_pFiles           = new UueItem*[ZNEW_ADD];
		memset(m_pFiles,0,sizeof(UueItem*[ZNEW_ADD]));
		m_iFilesMax=ZNEW_ADD;
		}

	if(m_iFilesNum >= m_iFilesMax)					// Kette vergrern
		{
		pNew = new UueItem*[m_iFilesMax+ZNEW_ADD];
		memset(pNew+m_iFilesMax,0,sizeof(UueItem*[ZNEW_ADD]));
		memcpy(pNew,m_pFiles     ,sizeof(UueItem*)*m_iFilesMax);
		delete m_pFiles;
		m_pFiles     = pNew;
		m_iFilesMax += ZNEW_ADD;
		}


		   m_pFiles[m_iFilesNum]=new UueItem;
	memset(m_pFiles[m_iFilesNum],0,sizeof(UueItem));
		   m_iFilesNum++;
		   m_iFileCount++;


return m_iFilesNum-1;
}

//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Lscht eine Datei aus dem Archiv.
//	iNum	: Ist die Indexnummer der zu lschenden Datei.
//	Ergibt:		CAF_ERROR_MISS   Wenn Datei nicht gefunden wurde
//				CAF_ERROR_OK     Wenn Datei gelscht wurde
//				CAF_ERROR_WRITE  Wenn Datei keine Schreib erlaubnis hat
int CUueFile::Del(int iNum)
{
UueItem	*pEntry;


	PROGR(CAF_PROG_ZDEL,iNum,CAF_ERROR_MISS);

	if(m_iOpenMode!=CAF_WRITE)							// Keine Schreiberlaubnis
		{
		m_iErrorCode=CAF_ERROR_WRITE;
		PROGN(CAF_PROG_ERROR,iNum);
		return m_iErrorCode;
		}

	if(iNum<0 || iNum>=m_iFileCount)				// Falscher Index
		{
		m_iErrorCode=CAF_ERROR_MISS;
		PROGN(CAF_PROG_ERROR,iNum);
		return m_iErrorCode;
		}

	m_iSortMode = 0;
	pEntry=m_pFiles[iNum];
	UueSetDel(iNum);

	m_iErrorCode = CAF_ERROR_OK;


return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		Break
//*
//*****************************************************************************
//	Bearbeitung abbrechen ohne Daten zu speichern
void CUueFile::Break()
{
	ReleaseData();
	m_iOpenMode=CAF_CLOSED;
	Clear();
}

//*****************************************************************************
//*
//*		Close
//*
//*****************************************************************************
//	Schliet das UUE-Archiv und speichert alle Daten.
//	Ergibt:	CAF_ERROR_LOGIC		Bei einem Internen Fehler
//			CAF_ERROR_OK		Wenn alles stimmte
//			CAF_ERROR_WRITE		Problemen beim Schreiben
//			... siehe Error Codes
int CUueFile::Close()
{
int		iRet;



	m_iErrorCode = CAF_ERROR_OK;


	if(m_iOpenMode==CAF_CLOSED)
		{
		m_iCreated   = 0;
		m_iOpenMode  = CAF_CLOSED;
		m_iErrorCode = CAF_ERROR_MISS;

		PROGN(CAF_PROG_ERROR,-1);

		return CAF_ERROR_MISS;
		}

	if(m_iOpenMode==CAF_READ)
		{
		ReleaseData();
		m_iCreated   = 0;
		m_iOpenMode  = CAF_CLOSED;

		return CAF_ERROR_OK;
		}

	if(m_iOpenMode!=CAF_WRITE)
		{
		ReleaseData();
		m_iCreated	 = 0;
		m_iOpenMode  = CAF_CLOSED;
		m_iErrorCode = CAF_ERROR_LOGIC;

		PROGN(CAF_PROG_ERROR,-1);

		return CAF_ERROR_LOGIC;
		}


//***************** Alte Dateien lschen neue speichern ***********************


	   iRet=Flush();
	if(iRet!=CAF_ERROR_OK)
	if(iRet!=CAF_ERROR_BREAK)
		{
		CUueFile::Break();

		m_iErrorCode = iRet;
		m_iCreated	 = 0;
		return iRet;
		}


//******************** END-Block speichern ************************************


	if(m_iChanged)
		{
		try	{
			MainSeek(m_iFileEnd);
			EndOfFile();
			m_iChangeFlag = 1;
			m_iChanged    = 0;
			}
		catch(int iError)
			{
			m_iErrorCode=iError;
			return iError;
			}
		}

	CUueFile::Break();

	m_iCreated = 0;


return CAF_ERROR_OK;
}

//*****************************************************************************
//*
//*		Flush
//*
//*****************************************************************************
//	Speichert alle Dateien im UUE-Archiv
//	Ergibt:	CAF_ERROR_LOGIC		Bei einem Internen Fehler
//			CAF_ERROR_OK		Wenn alles stimmte
//			CAF_ERROR_WRITE		Bei schreibe Problemen
//			... siehe Error Codes
int CUueFile::Flush()
{
char	*pMem;
UueItem	*pEntry;
HANDLE   hMapObj;
int		 iStart;
int		 iCount;
int		 iPosR;
int		 iPosW;
int		 iSize;
int		 iFull;
int		 iNum;
int		 iMin;
int		 iLen;
int		 iOff;
int		 iPos;



	m_iDoneMode	 = 0;
	m_iDoneNow	 = 0;
	m_iDoneMax	 = 0;

	if(m_iOpenMode!=CAF_WRITE)
		{
		m_iErrorCode = CAF_ERROR_MISS;

		return CAF_ERROR_MISS;
		}

	iPosW = 0;
			 

	if(m_iFilesNum>m_iFileCount)						// Wurden Dateien gelscht
		{
		iFull	= 0;
		iNum	= 0;
		iMin	= 0x7FFFFFFF;

		for(iPos=0;iPos<m_iFilesNum;iPos++)				
			{
			   pEntry=m_pFiles[iPos];
			if(pEntry->cDelete)
				{
				if(iMin>(aint64)pEntry->iOff)iMin=pEntry->iOff;
				m_iDoneMax += 1024;
				iNum       += 1;
				continue;
				}

			if(pEntry->cWrite)							// Datei wird neu eingefgt
				{
				m_iDoneMax += pEntry->iLen;
				}
			else{
				iFull += pEntry->iEnd;
				iFull += pEntry->iOff;
				iFull += 64;
				}
			}

		if(iFull>iMin && iNum)							// Ab erster gelschten Datei wird verschoben
			{
			m_iDoneMax += iFull-iMin;
			}
		}
	else{
		for(iPos=0;iPos<m_iFilesNum;iPos++)				// Es werden nur Dateien eingefgt
			{
			   pEntry=m_pFiles[iPos];
			if(pEntry->cDelete)continue;

			if(pEntry->cWrite)
				{
				m_iDoneMax += pEntry->iLen;
				}
			}
		}



//***************** Alte Dateien lschen **************************************


	iLen = (int)MainSize();

	try	{											// Mit MEM-File ndern
		PROG(CAF_PROG_FLUSH,-1);

		if(iLen<0x10000000 || m_hFile==INVALID_HANDLE_VALUE)							
			{
			if(m_iFilesNum>m_iFileCount)
				{
				Sort(CAF_FLAG_SORTPOS);				// Nach Offsets sortieren


				if(m_hFile==INVALID_HANDLE_VALUE)
					{
					hMapObj	= 0;
					pMem	= m_pMemPtr;
					}
				else{
						hMapObj=CreateFileMapping(m_hFile,0,PAGE_READWRITE,0,(int)iLen,0);
					if(!hMapObj)throw CAF_ERROR_WRITE;
						pMem=(char*)MapViewOfFile(hMapObj,FILE_MAP_WRITE,0,0,(int)iLen);
					}

				if(!pMem)
					{
					CloseHandle(hMapObj);
					throw CAF_ERROR_WRITE;
					}

				for(iPos=0;iPos<m_iFilesNum;iPos++)	// Dateien lschen
					{
					   pEntry=m_pFiles[iPos];
					if(pEntry->cWrite )continue;
					if(pEntry->cDelete)continue;

					PROG(CAF_PROG_WRITE,iPos);

					iPosR   = pEntry->iOff;
					iCount  = pEntry->iEnd-iPosR;


					if(iPosR!=iPosW)
						{
						if(iPosW+iCount>iLen)
							{
							UnmapViewOfFile(pMem);	// Mapping aufheben
							CloseHandle(hMapObj);	// Objekt schlieen
							throw CAF_ERROR_LOGIC;
							}

						for(iOff=0;iOff<iCount;iOff+=iSize)
							{
							   iSize = iCount-iOff;
							if(iSize>4096)iSize=4096;

							memmove(pMem+iPosW+iOff,pMem+iPosR+iOff,(int)iSize);

							m_iDoneNow += iSize;
							}

						pEntry->iOff = iPosW;
						pEntry->iEnd = iPosW+iCount;
						}

					m_iDoneNow  += iCount;
					iPosW       += iCount;
					}

				if(hMapObj)
					{
					UnmapViewOfFile(pMem);			// Mapping aufheben
					CloseHandle(hMapObj);			// Objekt schlieen
					}

				m_iChanged    = 1;
				m_iFileEnd    = iPosW;
				m_iFileSize	  = iPosW;

				MainSeek (m_iFileSize);
				EndOfFile();
				}
			}
		else{										// Mit Umkopieren
			unsigned char	ucBuffer[0x1000];

			if(m_iFilesNum>m_iFileCount)
				{
				Sort(CAF_FLAG_SORTPOS);				// Nach Offsets sortieren


				for(iPos=0;iPos<m_iFilesNum;iPos++)	// Dateien lschen
					{
					   pEntry=m_pFiles[iPos];
					if(pEntry->cWrite )continue;
					if(pEntry->cDelete)continue;

					PROG(CAF_PROG_WRITE,iPos);

					iPosR   = pEntry->iOff;
					iCount  = pEntry->iEnd-iPosR;


					if(iPosR!=iPosW)
						{
						if(iPosW+iCount>iLen)
							{
							throw CAF_ERROR_LOGIC;
							}

						for(iOff=0;iOff<iCount;iOff+=iSize)
							{
							   iSize = iCount-iOff;
							if(iSize>sizeof(ucBuffer))
								{
								iSize=sizeof(ucBuffer);
								}

							MainSeek (iPosR+iOff,SEEK_SET);
							MainRead (ucBuffer,(int)iSize);
							MainSeek (iPosW+iOff,SEEK_SET);
							MainWrite(ucBuffer,(int)iSize);

							m_iDoneNow += iSize;
							}

						pEntry->iOff = iPosW;
						pEntry->iEnd = iPosW+iCount;
						}

					m_iDoneNow  += iCount;
					iPosW       += iCount;
					}

				m_iChanged    = 1;
				m_iFileEnd    = iPosW;
				m_iFileSize	  = iPosW;

				MainSeek (m_iFileSize);
				EndOfFile();
				}
			}
		}
	catch(int iError)								// Bekannter Fehler
		{
		m_iErrorCode = iError;
		PROGN(CAF_PROG_ERROR,-1);
		return iError;
		}


//***************** Neue Dateien speichern ************************************


	try	{
		iPosW = (int)MainSeek(m_iFileEnd);

		for(iPos=0;iPos<m_iFilesNum;iPos++)			// Dateien speichern
			{
			pEntry = m_pFiles[iPos];
			iStart = m_iDoneNow;

			if(pEntry->cWrite && !pEntry->cDelete)
				{
				m_iChanged = 1;

				try	{
					Write(iPos);					// Komprimiere Datei
					}
				catch(int iError)
					{
					m_iErrorCode = iError;

					if(iError==CAF_ERROR_BREAK)break;
					if(iError!=CAF_ERROR_FREAD)
					if(iError!=CAF_ERROR_FOPEN)throw iError;

					PROGN(CAF_PROG_ERROR,iPos);
					pEntry->cDelete=1;
					m_iFileCount--;
					}

				m_iFileSize = MainTell();
				m_iFileEnd	  = (int)m_iFileSize;
				m_iDoneNow    = iStart+pEntry->iLen;
				}
			}
		}
	catch(int iError)								// Bekannter Fehler
		{
		m_iErrorCode = iError;
		PROGN(CAF_PROG_ERROR,-1);
		CUueFile::Break();
		return iError;
		}


//***************** Glscht markierte Blcke entfernen ************************


	for(iPos=m_iFilesNum-1;iPos>=0;iPos--)
		{
		   pEntry=m_pFiles[iPos];
		if(pEntry->cDelete)UueDel(iPos);
		}

	if(m_iModeFlags&CAF_FLAG_SORT)Sort();			// Liste sortieren
	m_iDoneNow = m_iDoneMax;


return m_iErrorCode=CAF_ERROR_OK;
}



//*****************************************************************************
//*
//*		ExtractProc
//*
//*****************************************************************************
//	Extrahiert eine Datei aus dem Archiv ber eine Ausgabefunktion
//	iNum	: Ist die Indexnummer der Datei die geprft werden soll
//	pParam	: Ist ein Parameter der an die Ausgabefunktionbergeben wird
//	pProc	: Ist der Zeiger auf die Ausgabefunktion
//	pInfo	: Hier werden Zeiten und Attribute der Datei gespeichert.
//			  Bei NULL werden diese Werte ignoriert.
//	Ergibt 0 wenn ok, oder eine Fehlernummer ungleich 0:
//				CAF_ERROR_OK		= Wenn alles korrekt war
//				CAF_ERROR_MISS		= Wenn die Datei nicht gefunden wurde
//				CAF_ERROR_PATH		= Pfad ungltig ist.
//				CAF_ERROR_FCREATE	= Wenn Datei nicht erzeugt werden konnte
//				CAF_ERROR_CRC		= Crc32 Fehler
//				CAF_ERROR_DECOMP	= Fehler beim Entkomprimieren
//				CAF_ERROR_IGNORE	= Die Datei wurde bersprungen
//			... siehe Fehler Codes
int	CUueFile::ExtractProc(int iNum,void *pParam,OutProc pProc,FileData *pInfo)
{
char		cBuffer[1024];
char		cLines [1024];
char	   *pInput;
UueItem	   *pEntry;
unsigned	uValue;
int			iSize;
int			iByte;
int			iDone;
int			iOut;
int			iBit;
int			iMax;
int			iPos;
int			iAdd;
int			iCnt;
int			iVal;
int			i;


	if(m_iDoneMode<=1)										// Verlaufsanzeige starten
		{
		m_iDoneMode	= 1;
		m_iDoneNow	= 0;
		m_iDoneMax	= 0;
		}

	m_iErrorCode	= CAF_ERROR_OK;
	m_pErrorFile	= NULL;
	pEntry			= NULL;



	try	{
		if(pProc==(OutProc)NoneWrite)						// Kommt der Aufruf von Test(...)
				iVal=CAF_PROG_TEST;
		else	iVal=CAF_PROG_READ;

		PROG(iVal,iNum);

		if((unsigned)iNum>=(unsigned)m_iFilesNum)
			{
			m_iErrorCode = CAF_ERROR_MISS;
			PROGN(CAF_PROG_ERROR,iNum);
			goto Exit;
			}

			pEntry = m_pFiles[iNum];
		if(!pEntry || !pEntry->cSaved)						// Ist die Datei nicht im Arschiv
			{
			m_iErrorCode = CAF_ERROR_MISS;
			PROGN(CAF_PROG_ERROR,iNum);
			goto Exit;
			}

		m_pErrorFile = pEntry->pName;
		m_iDoneMax	 = pEntry->iLen;

		MainSeek(pEntry->iOff+pEntry->iLenHdr);

		iMax	= pEntry->iLenDec;
		iByte	= 0;
		iDone	= 0;
		iOut	= 0;
		iBit	= 0;

		if(m_pMemPtr)										// Daten laden
			{
			pInput	= m_pMemPtr+m_iMemPos;
			iByte	= iMax;
			}

		for(iPos=0;;iPos+=iAdd,iDone+=iAdd)					// Dekodieren
			{
			if(m_pMemPtr)									// Daten laden
				{
				if(iDone>=iMax)break;
				}
			else{
				if(iDone+128>iByte)
					{
					iSize = iByte-iDone;
					memcpy(cLines,cLines+iDone,iSize);
					iByte = iSize;
					iDone = 0;
					iSize = 1024-iByte;

					if(iSize>iMax-iPos-iByte)
						{
						iSize=iMax-iPos-iByte;
						}

					if(iSize<=0)
						{
						if(iByte==0)break;
						}
					else{
						MainRead(cLines+iByte,iSize);
						iByte += iSize;
						}

					pInput = cLines;
					}
				}


			for(iAdd=iDone;iAdd<iByte;iAdd++)				// Zeilenlnge bestimmen
				{
				if(pInput[iAdd]=='\n')break;
				if(pInput[iAdd]=='\r')break;
				}

			iCnt   = iAdd-iDone;

			if(pInput[iAdd]=='\r')iAdd++;
			if(pInput[iAdd]=='\n')iAdd++;

			iAdd  -= iDone;

			if(iCnt==0)continue;

			   uValue = pInput[iDone]-' ';
			if(uValue>=64)
				{
				throw CAF_ERROR_FORM;
				}

			iSize   = 1+uValue+(uValue+2)/3;

			if(iCnt<iSize)									// Zuwenig Daten in der Zeile
				{
				throw CAF_ERROR_FORM;
				}


			for(i=1;i<iSize;i++)							// Zeile dekodieren
				{
				   uValue = pInput[iDone+i]-' ';
				if(uValue>=64)
					{
					if(uValue>64)throw CAF_ERROR_FORM;
					uValue=0;
					}

				switch(iBit)
					{
				case 0:	cBuffer[iOut]  =  uValue<<2;		iBit=1;	break;
				case 1:	cBuffer[iOut] |=  uValue>>4;		iOut++;
						cBuffer[iOut]  =  uValue<<4;		iBit=2;	break;
				case 2:	cBuffer[iOut] |=  uValue>>2;		iOut++;
						cBuffer[iOut]  =  uValue<<6;		iBit=3;	break;
				case 3:	cBuffer[iOut] |=  uValue;	iOut++;	iBit=0;	break;
					}
				}

			if(iOut>sizeof(cBuffer)-128)
				{
				if(pProc(pParam,cBuffer,iOut)!=iOut)
					{
					throw CAF_ERROR_READ;
					}

				m_iDoneNow += iOut;
				iOut		= 0;
				}
			}


		if(iOut>0)
			{
			if(pProc(pParam,cBuffer,iOut)!=iOut)
				{
				throw CAF_ERROR_READ;
				}

			m_iDoneNow += iOut;
			}
		
		if(pProc(pParam,NULL,0)!=0)							// Ende anzeigen
			{
			m_iErrorCode = CAF_ERROR_FWRITE;
			PROGN(CAF_PROG_ERROR,iNum);
			goto Exit;
			}
		
		if(pInfo)											// Dateidaten speichern
			{
			pInfo->dwAttr		=(pEntry->sMode&0200)?    SYS_WRITE|SYS_READ:SYS_READ;
			pInfo->dwAttr	   |=(pEntry->iLen>>(32-SYS_HIGHSHIFT))&SYS_HIGHMASK;
			pInfo->dwSize		=(unsigned)pEntry->iLen;
			pInfo->dwTimeWrite	= pEntry->iTime;
			pInfo->dwTimeCreate	= 0;
			pInfo->dwTimeAccess	= 0;
			pInfo->cName[0]		= 0;
			}
		
		PROG(CAF_PROG_EXTRACT,iNum);
		}
	catch(int iError)
		{
		m_iErrorCode=iError;
		PROGN(CAF_PROG_ERROR,iNum);
		}


Exit:

	if(m_iDoneMode<=1)										// Die Verlaufsanzeige zurcksetzen
		{
		m_iDoneMode = 0;
		m_iDoneNow  = m_iDoneMax;
		}


return m_iErrorCode;
}


//*****************************************************************************
//*
//*		OctToInt
//*
//*****************************************************************************
//	Wantelt eine Oktal-Sting in eine Zahl um
int CUueFile::OctToInt(const char *pText)
{
unsigned 	uChar;
int			iPos;
int			iVal;


	iVal = 0;

	for(iPos=0;iPos<12;iPos++)
		{
		if(pText[iPos]!=' ')break;
		}

	for(;iPos<12;iPos++)
		{
		uChar  = pText[iPos];
		uChar -= '0';

		if(uChar>7)break;

		iVal<<=3;
		iVal += uChar;
		}

return iVal;
}


//*****************************************************************************
//*
//*		Count
//*
//*****************************************************************************
//	Ergibt die Anzahl der Eintrge in der Dateiliste
int CUueFile::Count()
{
	return m_iFileCount;
}

//*****************************************************************************
//*
//*		Done
//*
//*****************************************************************************
//	Fragt den aktuellen Verlauf bei Open,Extract,Close,Flush ab
//	pMax	: Wenn ungleich 0 wird hier das Maximum gespeichert
//	Ergibt den aktuellen Verlauf
aint64	CUueFile::Done(aint64 *pMax)
{
int	iRet;


	iRet = m_iDoneNow;

	if(iRet>m_iDoneMax)iRet=m_iDoneMax;
	if(pMax)*pMax=m_iDoneMax;


return iRet; 
}

//*****************************************************************************
//*
//*		Change
//*
//*****************************************************************************
//	Schreiberlaubnis de/aktivieren
int CUueFile::Change(int iMode)
{

														// Prfe den Modus
	if(iMode<CAF_READ || iMode>CAF_WRITE || m_iOpenMode<=CAF_CLOSED)				
		{
		return CAF_ERROR_MODE;
		}
	
	if(m_iOpenMode==iMode)								// Gleicher Modus
		{
		return CAF_ERROR_OK;
		}

	if(m_iChanged==1 && iMode==CAF_READ)				// Gibt es nderungen
		{
		Flush();
		}
	
	m_iDoneMode	 = 0;
	m_iDoneNow	 = 0;
	m_iDoneMax	 = 0;


return DoChange(iMode);
}

//*****************************************************************************
//*
//*		GetUserPtr
//*
//*****************************************************************************
//	User-Pointer abfragen
void *CUueFile::GetUserPtr(int iNum)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return 0;

return m_pFiles[iNum]->pUserPtr;
}

//*****************************************************************************
//*
//*		SetUserPtr
//*
//*****************************************************************************
//	User-Pointer einstellen
void CUueFile::SetUserPtr(int iNum,void *pData)
{

	if((unsigned)iNum>=(unsigned)m_iFilesNum)return;

	m_pFiles[iNum]->pUserPtr = pData;

}



