//*****************************************************************************
//*
//*
//*		UueFile.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//
//	Klasse fr den Zugriff auf UUE-Dateien:
//
// 		int		Del   (char*)							// Datei lschen
// 		int		Del   (int)								// Datei lschen
// 		int		Open  (char*,int=0,int=0)				// Datei ffnen
//		int 	OpenRes(const char *,char *pType=0)		// Resource ffnen
//		int		OpenRes(unsigned    ,char *pType=0)		// Resource ffnen
//
// 		int		Close ();								// Datei schliesen
// 		int		Progress(void *,int (*Funkt)(...))		// Protokoll Funktion
// 		int		ProgressMode(int =0 ,int =0)			// Protokoll Funktion Modus
// 		int		ProgressAdd (int =31,int =0)			// Protokoll Nachrichten Ein
// 		int		ProgressDel (int =0 ,int =0)			// Protokoll Nachrichten Aus
//
//		char   *ErrorText()								// Ergibt Fehler-Text
//		int     Error()									// Ergibt Fehler-Code
// 		int		Add   (char*,char*=0,char*=0;char*)		// Dateien anhngen
//		int		AddMem(char*,char* ,int Len)			// Speicher Datei
//		int		ExtractProc(int iNum,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractProc(char *  ,void *, ...)		// Datei in Funktion extrahieren
//		int		ExtractMem (int iNum,char *pMem,int)	// Datei in Speicher extrahieren
//		int		ExtractMem (char *  ,char *pMem,int)	// Datei in Speicher extrahieren
// 		int		ExtractAll (         char *pPathName=0)	// Alle Dateien extrahieren
//		int		Extract(    int iNum,char *pPathName=0)	// Datei extrahieren
//		int		Extract(char *pName ,char *pPathName=0)	// Datei extrahieren
// 		int		Test   (char *pName)					// Datei prfen
//  	int		Test   (int   iNum   )					// Datei prfen
//
// 		void	Break();								// Bearbeitung abbrechen
// 		void	Sort (int iMode=0);						// Sortierte Kette
// 		char   *Name (int iNum);						// Hole Dateiname
// 		int64	Len  (int iNum,int iMode=0);			// Hole Dateilnge
// 		int		Level(int iLevel=-2);					// Setze Komprimierungslevel
// 		int		Flags(int iFlags=-2);					// Setze iFlags
// 		int		Mode (int iMode =-2);					// Setze Komprimierungsmodus
// 		int		Find (char  *pName);					// Datei suchen
// 		time_t	Time (char  *pName);					// Datei Zeit holen
// 		time_t	Time (int    iNum);						// Datei Zeit holen


#ifndef 	__UUEFILE_H__
#define 	__UUEFILE_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if	    _MSC_VER > 1299
	#ifndef		WINVER 
	#define		WINVER 	0x0501 
	#endif 	
	#endif 	
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#endif
#else
	#ifdef		WIN32
	#include	<windows.h>
	#endif
	#ifdef		LINUX
	#include	<unistd.h>
	#include	"stdfunk.h"
	#endif
#endif

#ifndef 	 _MSC_VER
#define 	 _cdecl
#define 	__cdecl
#endif

#include	<time.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	"ArchiveFile.h"
#include	"FileFinder.h"
#include	"FileFunctions.h"

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif


//*****************************************************************************
//*
//*		Klasse CUueFile
//*
//*****************************************************************************
class CUueFile : public CArchiveFile
{
protected:

	typedef struct
		{
		void   *pUserPtr;						// User-Pointer
		zchar  *pName;							// Dateinames des Eintrages
		zchar  *pPath;							// Dateipfad der einzufgenden Datei
		short	sMode;							// Sind die Mosdusbits (z.B. 0666)
		short	iNameLen;						// Ist die Lnge des Namens in Zeichen
		char	cWrite;							// Soll der Eintrag geschrieben werden
		char 	cSaved;							// Ist Block in Datei
		char	cError;							// Ist die Datei defekt
		char	cDelete;						// Soll der Eintrag gelscht werden
		char	cDecomp;						// 0=Fehler  1=war vor handen  2=entpackt
		int		iLen;							// Ist die Gre der Datei
		int		iLenHdr;						// Ist die Gre des Headers in der UUE-Datei
		int		iLenDec;						// Ist die Gre der Datei komprmiert im Archiv
		int		iOff;							// Ist der Offset in der UUE-Datei
		int		iEnd;							// Ist das Ende der Daten (samt Header)	
		time_t	iTime;							// Ist die nderungszeit
		}UueItem;

	CFileFinder	m_sFind;						// Dateien suchen

	UueItem   **m_pFiles;						// Alfabethische Liste
	int			m_iFilesNum;					// Anzahl der Listeneintrge
	int			m_iFilesMax;					// Gesamt Listengre in Eintrgen
	int			m_iFileCount;					// Listen Eintrge ohne gelschte
	int			m_iCreated;						// Wurde die Datei neu erstellt
	int			m_iFileEnd;						// Position des letzten Headers
	int			m_iChanged;						// Wurde die UUE-Datei verndert
	int			m_iChangeFlag;					// Wurde die UUE-Datei verndert (bleibt nach close)
	int 		m_iDoneNow;						// Aktueller Verlauf
	int 		m_iDoneMax;						// Maximaler Verlauf
	int			m_iDoneMode;					// Verlaufmodus 0=normal 1=ExtracktAll

//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
public:

					CUueFile();
	virtual        ~CUueFile();

	virtual	int     AddPath(const zchar  *pFileName);		// Ein Verzeichniss einfgen
	virtual	int		AddProc(const zchar  *pFileName,void *pParam,InpProc pProc,FileData *pInfo=0);
	virtual	int		ExtractProc(int iNum           ,void *pParam,OutProc pProc,FileData *pInfo=0);
	virtual	int		Change     (int iMode=CAF_WRITE);		// Schreiberlaubnis aktivieren

	virtual	int		Flush	   ();							// Datei speichern
	virtual	int		Close  	   ();							// Datei schliesen
	virtual	int	    Count  	   ();							// Anzahl der Dateien
	virtual	void	Break  	   ();							// Bearbeitung abbrechen
	virtual	zchar  *Name   	   (int    iNum);				// Hole Dateiname
	virtual	zchar  *Name   	   (int    iNum,int &iLen);		// Hole Dateiname mit Lnge
	virtual	int		Stats  	   (int    iNum);				// Die Zustandbits abfragen
	virtual	int     SetFail	   (int	   iNum,int iFail=1);	// Defekt-Flag setzen
	virtual	int     IsReadOnly (int    iNum);				// Ist die Datei schreibgeschtzt
	virtual	int     IsFail 	   (int    iNum);				// Ist die Datei defekt
	virtual	int     IsDel  	   (int	   iNum);				// Wurde die Datei gelscht
	virtual	int     IsDir  	   (int    iNum);				// Prfe ob Verzeichnis
	virtual	int     IsOk   	   (int    iNum);				// Richtig endkomprimiert
	virtual	aint64	Len    	   (int    iNum,int iMode=0);	// Hole Dateilnge
	virtual	int		Del    	   (int    iNum);				// Datei lschen
	virtual	time_t	Time   	   (int    iNum);				// Dateizeit abfragen
	virtual	time_t	Time   	   (int    iNum,int iMode);		// Dateizeit abfragen
	virtual	int		Sort   	   (int    iMode=0);			// Sortierte Kette
	virtual	void   *GetUserPtr (int    iNum            );	// Datenwert auslesen
	virtual	void    SetUserPtr (int    iNum,void *pData);	// Datenwert einstellen
	virtual	int		Find   	   (const zchar  *pFileName);	// Datei suchen
	virtual	aint64	Done   	   (aint64 *pMax);				// Verlaufsabfrage

protected:

	virtual	int		SetStats   (int iNum,int iSet);			// Die Zustand einer Archivdatei setzen
	virtual	int		ArchOpen   (int iLevel);				// ffnet die TAR-Datei
	virtual	int     SetDoneMode(int iMode);					// Modus fr Done setzen
	int				Write	   (int iNum);					// Einen Eintrag speichern
	void			Clear	   ();							// Speicher lschen
	int				UueNew     ();							// Listen Eintrag erzeugen
	void			UueDel     (int iNum);					// Listen Eintrag lschen
	void			UueSetDel  (int iNum);					// Listen Eintrag lschen

static int			OctToInt   (const char *pText);
static int __cdecl 	CmpName    (const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
static int __cdecl 	CmpLen     (const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
static int __cdecl 	CmpPos     (const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
static int __cdecl 	CmpEx      (const void *pPtr1,const void *pPtr2);// Vergleichsfunktion
};

#endif



