//*****************************************************************************
//*
//*
//*		Aes7zip.h
//*
//*
//*****************************************************************************
//
//	UIN32	aes_ptr[0..3]	= init vector
//			aes_ptr[4...]	= aes data	
//
//	16-byte (4 * 32-bit words) blocks: 1 (IV) + 1 (keyMode) + 15 (AES-256 roundKeys) */
#ifndef __AES7ZIP_H__
#define __AES7ZIP_H__


#ifdef	__cplusplus
extern "C" {
#endif 	

#define	AES_BLOCK_SIZE		16
#define AES_NUM_IVMRK_WORDS ((1 + 1 + 15) * 4)


typedef	unsigned int	UINT_AES;	
typedef	unsigned char	UCHAR_AES;
typedef	UINT_AES		AesContext[AES_NUM_IVMRK_WORDS];


void	AesGenTables  (void);
void	AesCbc_Init   (UINT_AES *aes_ptr,const UCHAR_AES *initvec);
void	AesCbc_Encode (UINT_AES *aes_ptr,      UCHAR_AES *data,unsigned numBlocks);
void	AesCbc_Decode (UINT_AES *aes_ptr,      UCHAR_AES *data,unsigned numBlocks);
void	AesCtr_Code   (UINT_AES *aes_ptr,      UCHAR_AES *data,unsigned numBlocks);
void	Aes_SetKey_Enc(UINT_AES *aes_ptr,const UCHAR_AES *key ,unsigned keySize);
void	Aes_SetKey_Dec(UINT_AES *aes_ptr,const UCHAR_AES *key ,unsigned keySize);


#ifdef	__cplusplus
}
#endif 	


#endif 	