//*****************************************************************************
//*
//*
//*		Bcj7zip.c
//*
//*
//*****************************************************************************
//
//	Bcj7zip.c -- Converter for x86 code (BCJ)
//
#include	"Bcj7zip.h"


#define		Test86MSByte(b) 			((((b) + 1) & 0xFE) == 0)

//*****************************************************************************
//*
//*		BcjConvert
//*
//*****************************************************************************
unsigned BcjConvert(unsigned char *pData,unsigned uSize,unsigned uBufferPos,unsigned *pState,int iEncoding)
{
unsigned char		   *pNext;
const unsigned char	   *pLimit;
unsigned				uShift;
unsigned				uData;
unsigned				uMask;
unsigned				uPos;
unsigned				uVal;
unsigned				uCur;



	if(uSize < 5)
		{
		return 0;
		}

	uMask		= *pState&7;
	uPos		= 0;
	uSize      -= 4;
	uBufferPos += 5;

	for(;;)
		{
		pNext  = pData+uPos;
		pLimit = pData+uSize;


		for(;pNext<pLimit;pNext++)
			{
			if((*pNext&0xFE) == 0xE8)
				{
				break;
				}
			}

		uData = (unsigned)(pNext-pData-uPos);
		uPos  = (unsigned)(pNext-pData);

		if(pNext>=pLimit)
			{
			*pState = (uData > 2)? 0:uMask>>uData;
			return uPos;
			}

		if(uData > 2)
			{
			uMask = 0;
			}
		else{
			uMask >>= uData;

			if(uMask!=0 && (uMask>4 || uMask==3 || Test86MSByte(pNext[(uMask>>1)+1])))
				{
				uMask = (uMask >> 1) | 4;
				uPos++;
				continue;
				}
			}


		if(Test86MSByte(pNext[4]))
			{
			uVal	= *(unsigned*)(pNext+1);
			uCur	= uBufferPos+uPos;
			uPos   += 5;

			if(iEncoding)
					uVal += uCur;
			else	uVal -= uCur;

			if(uMask!=0)
				{
				uShift = (uMask&6)<<2;

				if(Test86MSByte((unsigned char)(uVal>>uShift)))
					{
					uVal ^= (0x0100<<uShift)-1;
					
					if(iEncoding)
							uVal += uCur;
					else	uVal -= uCur;
					}

				uMask = 0;
				}

			pNext[1] = (unsigned char)(uVal    );
			pNext[2] = (unsigned char)(uVal>> 8);
			pNext[3] = (unsigned char)(uVal>>16);
			pNext[4] = (unsigned char)(0 - ((uVal>>24)&1));
			}
		else{
			uMask	 = (uMask>>1)|4;
			uPos	+= 1;
			}
		}
}
