//*****************************************************************************
//*
//*		
//*		CompareData.h
//*		
//*
//*****************************************************************************
#ifndef 	__COMPAREDATA_H__
#define 	__COMPAREDATA_H__


#include	"StringChain.h"
#include	"DataField.h"

#define 	CCD_NEW		0
#define 	CCD_AND		1
#define 	CCD_OR		2
#define 	CCD_SINGLE	3

class CCompareData
{
public:	


	CCompareData();
   ~CCompareData();

	int	 InsertFile(const char *pFileName);
	int	 InsertData(int iPos,int iLen=0,unsigned uFile=0);
	int	 DelFile(int iNr);
	int	 DelData(int iNr);
	void SetData(void *pData,int iLen);
	void SetData(const char *pDump);
	int	 Save(const char *pFileName);
	int  Load(const char *pFileName,int iMode=CCD_NEW);

	void Clear();

	void SetRegion(int iStart,int iEnd,int iAdd=0);
	int  GetRegionStart();
	int  GetRegionEnd();
	int  GetRegionAdd();
	int  GetDataLength();
	char*GetData();

	char*GetFile(int iNr);
	int  GetFileCount();
	int  GetFileNr(int iNr);
	int  GetLength(int iNr);
	int  GetPosition(int iNr);
	int  GetPositionCount();

protected:

	CStringChain	m_sFiles;
	CDataField		m_sPositions;
	char		   *m_sData;
	int				m_iDataLength;
	int				m_iRegionStart;
	int				m_iRegionEnd;
	int				m_iRegionAdd;
};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

inline	void CCompareData::SetRegion(int iStart,int iEnd,int iAdd){m_iRegionStart=iStart;m_iRegionEnd=iEnd;m_iRegionAdd=iAdd;}
inline	int  CCompareData::GetRegionStart(){return m_iRegionStart;}
inline	int  CCompareData::GetRegionEnd(){return m_iRegionEnd;}
inline	int  CCompareData::GetRegionAdd(){return m_iRegionAdd;}
inline	int  CCompareData::GetDataLength(){return m_iDataLength;}
inline	char*CCompareData::GetData(){return m_sData;}

inline	char*CCompareData::GetFile(int iNr){return m_sFiles[iNr];}
inline	int  CCompareData::GetFileCount()  {return m_sFiles.Count();}
inline	int  CCompareData::GetFileNr  (int iNr){return ((int*)m_sPositions[iNr])[0];}
inline	int  CCompareData::GetLength  (int iNr){return ((int*)m_sPositions[iNr])[2];}
inline	int  CCompareData::GetPosition(int iNr){return ((int*)m_sPositions[iNr])[1];}
inline	int  CCompareData::GetPositionCount(){return m_sPositions.Count();}

#endif 	