//*****************************************************************************
//*
//*
//*		AfxDialog.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#include	<afxwin.h>			// MFC-Kern- und -Standardkomponenten
#include	<afxext.h>			// MFC-Erweiterungen
#include	<afxdisp.h>			// MFC Automatisierungsklassen
#include	<afxdtctl.h>		// MFC-Untersttzung fr allgemeine Steuerelemente von Internet Explorer 4
#include	"AfxDialog.h"
#include	"TreeListCtrl.h"
#include	"WinExtension.h"

#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	TEXT_OFF			(sizeof(DPARAM)/sizeof(TCHAR))

#ifndef 	IDR_MAINFRAME
#define 	IDR_MAINFRAME		128
#endif

#if			UNICODE
#define 	Z(a)				L##a
#define 	atoi_z				_wtoi
#define 	itoa_z				_itow
#define 	ultoa_z				_ultow
#define 	strupr_z			wcsupr
#define 	strtoul_z			wcstoul
#define 	stricmp_z			wcsicmp
#define 	strcmp_z			wcsicmp
#define 	strlen_z			wcslen
#define 	strspn_z			wcsspn
#define 	strcat_z			wcscat
#else
#define 	Z(a)				a
#define 	atoi_z				atoi
#define 	itoa_z				itoa
#define 	ultoa_z				ultoa
#define 	strupr_z			strupr
#define 	strtoul_z			strtoul
#define 	stricmp_z			stricmp
#define 	strcmp_z			strcmp
#define 	strlen_z			strlen
#define 	strspn_z			strspn
#define 	strcat_z			strcat
#endif

#define 	IDC_LIST			1007
#define 	IDC_EDIT1			1008
#define 	IDC_TEXT			1034
#define 	IDC_FRAME			1046
#define		IDC_SELTEXT     	1131
#define		IDC_SELCOMBO		1132
#define		IDC_SELCOMBOEDIT	1133
#define		IDC_SELLIST0		1133
#define		IDC_SELLIST1		1134
#define		IDC_SELLIST2		1135
#define		IDC_SELLIST3		1136
#define 	IDC_RIGHTCLICK		1137
#define 	IDC_SEL_ALL			1138
#define 	IDC_SEL_NONE		1139
#define 	IDC_DO_COPY			1140

#define 	IDD_TEXT_DLG		195
#define 	IDD_LIST_DLG		196
#define 	IDD_VALUE_DLG		197
#define 	IDD_COMBO_DLG		198


BEGIN_MESSAGE_MAP(CTextDlg, CDialog)
	//{{AFX_MSG_MAP(CTextDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CValueDlg, CDialog)
	//{{AFX_MSG_MAP(CValueDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CComboDlg, CDialog)
	//{{AFX_MSG_MAP(CComboDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CListDlg, CDialog)
	//{{AFX_MSG_MAP(CListDlg)
	ON_WM_CHAR()
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_WM_DRAWITEM()
	ON_WM_MOUSEWHEEL()
	ON_LBN_DBLCLK(IDC_SELLIST0, OnDblclkList)
	ON_LBN_DBLCLK(IDC_SELLIST1, OnDblclkList)
	ON_LBN_DBLCLK(IDC_SELLIST2, OnDblclkList)
	ON_LBN_DBLCLK(IDC_SELLIST3, OnDblclkList)
	ON_COMMAND(IDC_RIGHTCLICK,  OnRightClick)
	ON_COMMAND(IDC_SEL_NONE,	OnSelNone)
	ON_COMMAND(IDC_SEL_ALL,		OnSelAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BEGIN_MESSAGE_MAP(CColumnDlg, CDialog)
	//{{AFX_MSG_MAP(CColumnDlg)
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_COMMAND(ID_EDIT_CLEAR,			  OnDelete)
	ON_COMMAND(IDC_DO_COPY,				  OnDoCopy)
	ON_COMMAND(IDC_SEL_ALL,				  OnSelAll)
	ON_COMMAND(IDC_SEL_NONE,			  OnSelNone)
	ON_MESSAGE(WM_EXITSIZEMOVE,			  OnExitSize)
	ON_NOTIFY(NM_RCLICK,IDC_LIST,		  OnRightClick)
	ON_NOTIFY(NM_DBLCLK,IDC_LIST,		  OnDoubleClick)
	ON_NOTIFY(TVN_COLUMNCLICK   ,IDC_LIST,OnColumnClick)
	ON_NOTIFY(TVN_ENDLABELEDIT  ,IDC_LIST,OnEndLabelEdit)
	ON_NOTIFY(TVN_STARTEDIT		,IDC_LIST,OnStartLabeEdit)
	ON_NOTIFY(TVN_KEYDOWN       ,IDC_LIST,OnKeyDownNotify)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


static WORD m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0004,0x0000,0x0000,0x00E8,0x003A,0x0000,0x0000,0x0044,0x0061,0x0074,0x0065,0x0069,
	0x006E,0x0061,0x006D,0x0065,0x006E,0x0020,0x0065,0x0069,0x006E,0x0067,0x0065,0x0062,0x0065,0x006E,0x0000,0x0008,
	0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0080,0x5081,
	0x0000,0x0000,0x0005,0x000F,0x00DC,0x000D,0x03F0,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,
	0x0078,0x0023,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,
	0x00AF,0x0023,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,
	0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0005,0x0005,0x00DC,0x0008,0x040A,0xFFFF,0x0082,0x0000,0x0000,
	};

static WORD m_wDlgDataEx[]=															// Mit Password bei 0x00A0
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0004,0x0000,0x0000,0x00E8,0x003A,0x0000,0x0000,0x0044,0x0061,0x0074,0x0065,0x0069,
	0x006E,0x0061,0x006D,0x0065,0x006E,0x0020,0x0065,0x0069,0x006E,0x0067,0x0065,0x0062,0x0065,0x006E,0x0000,0x0008,
	0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x00A0,0x5081,
	0x0000,0x0000,0x0005,0x000F,0x00DC,0x000D,0x03F0,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,
	0x0078,0x0023,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,
	0x00AF,0x0023,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,
	0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0005,0x0005,0x00DC,0x0008,0x040A,0xFFFF,0x0082,0x0000,0x0000,
	};

WORD CComboDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0005,0x0000,0x0000,0x00E3,0x004C,0x0000,0x0000,0x0041,0x0075,0x0073,0x0077,0x0061,
	0x0068,0x006C,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,
	0x0066,0x0000,0x0001,0x5001,0x0000,0x0000,0x0037,0x0032,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,
	0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x0073,0x0032,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,
	0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0043,0x4021,0x0000,0x0000,0x000F,0x0019,0x00C3,0x0091,
	0x046C,0xFFFF,0x0085,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x000F,0x000F,0x00C3,0x0008,0x046B,0xFFFF,
	0x0082,0x0000,0x0000,0x0000,0x0042,0x4021,0x0000,0x0000,0x000F,0x0019,0x00C3,0x0091,0x046D,0xFFFF,0x0085,0x0000,
	0x0000,
	};

WORD CListDlg::m_wDlgData[]=
	{
	0x0040,0x80CC,0x0000,0x0000,0x0007,0x0000,0x0000,0x00E3,0x00AB,0x0000,0x0000,0x0041,0x0075,0x0073,0x0077,0x0061,
	0x0068,0x006C,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,
	0x0066,0x0000,0x0001,0x5001,0x0000,0x0000,0x003C,0x0096,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,
	0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x007D,0x0096,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,
	0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0101,0x40A1,0x0000,0x0000,0x0005,0x0014,0x00D7,0x007D,
	0x046D,0xFFFF,0x0083,0x0000,0x0000,0x0000,0x0109,0x40A1,0x0000,0x0000,0x0005,0x0014,0x00D7,0x007D,0x046E,0xFFFF,
	0x0083,0x0000,0x0000,0x0000,0x0111,0x40A1,0x0000,0x0000,0x0005,0x0014,0x00D7,0x007D,0x046F,0xFFFF,0x0083,0x0000,
	0x0000,0x0000,0x0111,0x40A1,0x0000,0x0000,0x0005,0x0014,0x00D7,0x007D,0x0470,0xFFFF,0x0083,0x0000,0x0000,0x0000,
	0x0000,0x5002,0x0000,0x0000,0x0005,0x0007,0x00D7,0x0008,0x046B,0xFFFF,0x0082,0x0000,0x0000,
	};

WORD CColumnDlg::m_wDlgData[]=
	{
	0x0040,0x80CC,0x0000,0x0000,0x0004,0x0000,0x0000,0x00E1,0x00B8,0x0000,0x0000,0x0041,0x0075,0x0073,0x0077,0x0061,
	0x0068,0x006C,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,
	0x0066,0x0000,0x0001,0x5001,0x0000,0x0000,0x0037,0x00A5,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,
	0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x0078,0x00A5,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,
	0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0007,0x4000,0x0000,0x0000,0x0000,0x000F,0x00E1,0x0091,
	0x0416,0xFFFF,0x0082,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0005,0x0003,0x00D7,0x0008,0x046B,0xFFFF,
	0x0082,0x0000,0x0000,
	};


INT		CColumnDlg::m_iOldPosX	= 0;
INT		CColumnDlg::m_iOldPosY	= 0;
BOOL	CColumnDlg::m_bOldPos	= 0;
BOOL	CColumnDlg::m_bSortDir	= 0;
BYTE	CColumnDlg::m_bSortCol	= 0;

HPEN	CListDlg::m_hPen1		= 0;
HPEN	CListDlg::m_hPen2		= 0;
INT		CListDlg::m_iOldPosX	= 0;
INT		CListDlg::m_iOldPosY	= 0;
BOOL	CListDlg::m_bOldPos		= 0;

int __stdcall SetClipboardText(LPCTSTR pText,int iSize=-1);

//*****************************************************************************
//*
//*
//*		Dialogfeld CTextDlg
//*
//*
//*****************************************************************************
CTextDlg::CTextDlg(CWnd *pParent,BOOL bPassword) : CDialog((UINT)0,pParent)
{
	//{{AFX_DATA_INIT(CTextDlg)
	m_sText = _T("");
	//}}AFX_DATA_INIT

	m_bValueFocus = 0;
	m_bPassword   = 0;
	m_iSizeX	  = 0;

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)((bPassword)?m_wDlgDataEx:m_wDlgData));
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CTextDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTextDlg)
	DDX_Text(pDX, IDC_EDIT1, m_sText);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CTextDlg::OnInitDialog()
{
CWnd	   *pWnd;
CFont	   *pFont;
CRect		sRect;
HWND		hWnd;
UINT		uBits;
UINT		uMode;


	SetWindowLong(m_hWnd,GWL_USERDATA,IDD_TEXT_DLG);

	if(m_bPassword)										// Passwortmodus aktivieren
		{
		pWnd  = GetDlgItem(IDC_EDIT1);
		uBits = GetWindowLongA (pWnd->m_hWnd,GWL_STYLE);
		uMode = GetWindowLongA (pWnd->m_hWnd,GWL_EXSTYLE);
		pFont = pWnd->GetFont();
				pWnd->GetWindowRect (&sRect);
				ScreenToClient(&sRect);
				pWnd->DestroyWindow();
		hWnd  = CreateWindowEx(uMode,_T("EDIT"),_T(""),uBits|ES_PASSWORD,sRect.left,sRect.top,sRect.Width(),sRect.Height(),this->m_hWnd,0,0,0);
				SetWindowLongA(hWnd,GWL_ID,IDC_EDIT1);
		pWnd  = GetDlgItem(IDC_EDIT1);
				pWnd->SetFont(pFont);
		}

	if(m_bValueFocus)									// Focus auf das Edit-Fenster
		{
		PostMessage(WM_NEXTDLGCTL,(WPARAM)(GetDlgItem(IDC_EDIT1)->m_hWnd),1);
		}


	if(m_iSizeX)										// Dialoggre ndern
		{
		GetWindowRect(&sRect);

		if((m_iSizeX>>16)==0x1234)
			{
			m_iSizeX  &= 0xFFFF;
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 354;
			m_iSizeX  -= sRect.Width();
			}
		else{
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 354;
			}

		sRect.right  += m_iSizeX;

		MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDC_EDIT1);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect.right+=m_iSizeX;
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDC_TEXT);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect.right+=m_iSizeX;
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDOK);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect+=CPoint(m_iSizeX,0);
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDCANCEL);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect+=CPoint(m_iSizeX,0);
		pWnd->MoveWindow(&sRect,FALSE);
		}


	CDialog::OnInitDialog();

	if(!m_sTitle.IsEmpty())SetWindowText(m_sTitle);
	if(!m_sTitle1.IsEmpty())SetDlgItemText(IDC_TEXT,m_sTitle1);


return TRUE;
}


//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Einstellen der Dialog-berschrift
//	pTitle		: Zeiger auf die neue berschrift
void CTextDlg::SetTitle(LPCTSTR pTitle)
{
	m_sTitle = pTitle;
}

//*****************************************************************************
//*
//*		SetTextTitle
//*
//*****************************************************************************
//	Einstellen der Textberschrift
//	pTitle		: Zeiger auf die neue Textberschrift
void CTextDlg::SetTextTitle(LPCTSTR pText)
{
	m_sTitle1 = pText;
}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Einstellen des Textes
//	pText	: Neuer Text fr den Dialog
void CTextDlg::SetText(LPCTSTR pText)
{
	m_sText = pText;
}


//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
//	Ergibt einen Zeiger auf den Text
LPCTSTR CTextDlg::GetText()
{
	return m_sText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CTextDlg::GetText(LPTSTR pText,int iMax)
{
int iLen;


	if(iMax<=0)return 0;
	iLen=m_sText.GetLength();
	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,(LPCTSTR)m_sText,iLen*sizeof(TCHAR));
	pText[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*
//*		Dialogfeld CValueDlg
//*
//*
//*****************************************************************************
CValueDlg::CValueDlg(CWnd *pParent)	: CDialog((UINT)0,pParent)
{

	//{{AFX_DATA_INIT(CValueDlg)
	m_sText = _T("0");
	//}}AFX_DATA_INIT

	m_iSizeX	  = 0;
	m_iValue      = 0;
	m_bValueFocus = 0;

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CValueDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CValueDlg)
	DDX_Text(pDX, IDC_EDIT1, m_sText);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CValueDlg::OnInitDialog()
{
CWnd	   *pWnd;
CRect		sRect;


	SetWindowLong(m_hWnd,GWL_USERDATA,IDD_VALUE_DLG);


	if(m_bValueFocus)PostMessage(WM_NEXTDLGCTL,(WPARAM)(GetDlgItem(IDC_EDIT1)->m_hWnd),1);


	if(m_iSizeX)										// Dialoggre ndern
		{
		GetWindowRect(&sRect);

		if((m_iSizeX>>16)==0x1234)
			{
			m_iSizeX  &= 0xFFFF;
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 354;
			m_iSizeX  -= sRect.Width();
			}
		else{
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 354;
			}

		sRect.right  += m_iSizeX;

		MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDC_EDIT1);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect.right+=m_iSizeX;
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDOK);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect+=CPoint(m_iSizeX,0);
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDCANCEL);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect+=CPoint(m_iSizeX,0);
		pWnd->MoveWindow(&sRect,FALSE);
		}



	CDialog::OnInitDialog();

	if(m_sTitle !="")SetWindowText(m_sTitle);
	if(m_sTitle1!="")SetDlgItemText(IDC_TEXT,m_sTitle1);

	return TRUE;
}


//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Einstellen der Dialog-berschrift
//	pTitle		: Zeiger auf die neue berschrift
void CValueDlg::SetTitle(LPCTSTR pTitle)
{
	m_sTitle=pTitle;
}

//*****************************************************************************
//*
//*		SetTextTitle
//*
//*****************************************************************************
//	Einstellen der Textberschrift
void CValueDlg::SetTextTitle(LPCTSTR pText)
{
	m_sTitle1=pText;
}

//*****************************************************************************
//*
//*		SetValue
//*
//*****************************************************************************
//	Einstellen des Zahlewertes
//	iValue		: Neuer Zahlewerte der eingestellt werden soll
//	iMode		: 0 Dez-Zahl "123.." mit Minuszeichen
//				  1 Hex-Zahl "0x1FF.."
//				  2 Bin-Zahl "0b101.."
//				  3 Okt-Zahl "0o777.."
//				  4 Hex-Zahl "1FFh.."
//				  5 Bin-Zahl "101b.."
//				  6 Okt-Zahl "777o.."
//      		  7 Dez-Zahl "123.." ohne Minuszeichen
void CValueDlg::SetValue(int iValue,int iMode)
{
TCHAR	cBuffer[40];


	m_iValue = iValue;

	switch(iMode)
		{
	case 0:		                              itoa_z (iValue,cBuffer,  10);                    break;
	case 1:		cBuffer[0]='0';cBuffer[1]='x';itoa_z (iValue,cBuffer+2,16);strupr_z(cBuffer+2);break;
	case 2:		cBuffer[0]='0';cBuffer[1]='b';itoa_z (iValue,cBuffer+2, 2);                    break;
	case 3:		cBuffer[0]='0';cBuffer[1]='o';itoa_z (iValue,cBuffer+2, 8);                    break;
	case 4:		itoa_z (iValue,cBuffer,16);   strupr_z(cBuffer);	strcat_z(cBuffer,Z("h"));  break;
	case 5:		itoa_z (iValue,cBuffer, 2);             			strcat_z(cBuffer,Z("b"));  break;
	case 6:		itoa_z (iValue,cBuffer, 8);             			strcat_z(cBuffer,Z("o"));  break;
	default:	ultoa_z(iValue,cBuffer,10);
		}


	m_sText = cBuffer;

}


//*****************************************************************************
//*
//*		GetValue
//*
//*****************************************************************************
//	Abfragen der eingegeben Zahl
//	Ergibt den eingegebenen Zahlenwert
int CValueDlg::GetValue()
{
	return m_iValue;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CValueDlg::OnOK()
{
LPCTSTR  pPtr;
LPTSTR	 pEnd;
int		 iHex;
int		 iOct;
int		 iBin;
int		 iNeg;



	UpdateData();
	m_iValue=0;

	iNeg  = 0;
	pPtr  = m_sText;
	pPtr += strspn_z(pPtr,Z(" \t"));

	     if(pPtr[0]=='-'){iNeg=1;pPtr++;}
	else if(pPtr[0]=='+'){       pPtr++;}

	if(pPtr[0]=='0' && (pPtr[1]=='x' || pPtr[1]=='X'))
		{
		m_iValue=strtoul_z(pPtr+2,&pEnd,16);
		}
	else if(pPtr[0]=='0' && (pPtr[1]=='o' || pPtr[1]=='O'))
		{
		m_iValue=strtoul_z(pPtr+2,&pEnd,8);
		}
	else if(pPtr[0]=='0' && (pPtr[1]=='b' || pPtr[1]=='B'))
		{
		m_iValue=strtoul_z(pPtr+2,&pEnd,2);
		}
	else{
		iHex = (int)strspn_z(pPtr,Z("0123456789abcdefABCDEF"));
		iOct = (int)strspn_z(pPtr,Z("01234567"));
		iBin = (int)strspn_z(pPtr,Z("01"));

			 if(iHex>0 && (pPtr[iHex]&~32)=='H')m_iValue=strtoul_z(pPtr,0,16);
		else if(iOct>0 && (pPtr[iOct]&~32)=='O')m_iValue=strtoul_z(pPtr,0, 8);
		else if(iBin>0 && (pPtr[iBin]&~32)=='B')m_iValue=strtoul_z(pPtr,0, 2);
		else                                    m_iValue=strtoul_z(pPtr,0,10);
		}

	if(iNeg)
		{
		m_iValue=-m_iValue;
		}

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*
//*		Dialogfeld CComboDlg
//*
//*
//*****************************************************************************
CComboDlg::CComboDlg(CWnd *pParent)	: CDialog((UINT)0,pParent)
{

	//{{AFX_DATA_INIT(CComboDlg)
	m_sText = _T("");
	//}}AFX_DATA_INIT


	m_uData	      = 0;
	m_iMode		  = 0;								// 1=editerbar
	m_bCancel	  = 1;								// 1=Cancel anzeigen
	m_iSelect	  = 0;
	m_pStrText 	  = 0;
	m_iStrMax     = 0;
	m_iStrCount	  = 0;
	m_bValueFocus = 0;
	m_iSizeX	  = 0;								// Grennderung

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CComboDlg::~CComboDlg()
{

	ResetContent();

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CComboDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CComboDlg)
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CComboDlg::OnInitDialog()
{
CComboBox	*pCombo;
CWnd		*pWnd;
CRect		 sRect;
int			 i,j;


	SetWindowLong(m_hWnd,GWL_USERDATA,IDD_COMBO_DLG);

	pCombo = (CComboBox*)GetDlgItem((m_iMode)? IDC_SELCOMBOEDIT:IDC_SELCOMBO);

	if(m_bValueFocus)PostMessage(WM_NEXTDLGCTL,(WPARAM)(pCombo->m_hWnd),1);

	for(i=0;i<m_iStrCount;i++)
		{
		pCombo->InsertString(i,m_pStrText[i]+TEXT_OFF);
		}

	if(m_iSelect>=       m_iStrCount )m_iSelect=-1;
	if(m_iSelect< 0 &&  !m_iMode     )m_iSelect= 0;
	if(m_iSelect>=0)pCombo->SetCurSel(m_iSelect);
	else 		    pCombo->SetWindowText(m_sText);

	pCombo->ShowWindow(SW_SHOW);

	if(m_iSizeX)										// Dialoggre ndern
		{
		GetWindowRect(&sRect);

		if((m_iSizeX>>16)==0x1234)
			{
			m_iSizeX  &= 0xFFFF;
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 347;
			m_iSizeX  -= sRect.Width();
			}
		else{
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 347;
			}

		sRect.right  += m_iSizeX;

		MoveWindow(&sRect,FALSE);

		pCombo->GetClientRect(&sRect);
		pCombo->MapWindowPoints(this,&sRect);sRect.right+=m_iSizeX;
		pCombo->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDC_SELTEXT);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect.right+=m_iSizeX;
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDOK);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect+=CPoint(m_iSizeX/2,0);
		pWnd->MoveWindow(&sRect,FALSE);

		pWnd =GetDlgItem(IDCANCEL);
		pWnd->GetClientRect(&sRect);
		pWnd->MapWindowPoints(this,&sRect);sRect+=CPoint(m_iSizeX/2,0);
		pWnd->MoveWindow(&sRect,FALSE);
		}


	if(!m_bCancel)
		{
		GetDlgItem(IDCANCEL)->ShowWindow(SW_HIDE);
		pWnd=GetDlgItem(IDOK);
		pWnd->GetWindowRect(&sRect);
		j =(sRect.Width()/5)*3;
		sRect+=CPoint(j,0);
		ScreenToClient(&sRect);
		pWnd->MoveWindow(&sRect);
		}

	CDialog::OnInitDialog();

	if(!m_sTitle .IsEmpty())SetWindowText(m_sTitle);
	if(!m_sTitle1.IsEmpty())SetDlgItemText(IDC_SELTEXT,m_sTitle1);

	pCombo->SetFocus();
	PostMessage(WM_NEXTDLGCTL,(WPARAM)pCombo->m_hWnd,1);



return TRUE;
}


//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Einstellen der Dialog-berschrift
//	pTitle		: Zeiger auf die neue berschrift
void CComboDlg::SetTitle(LPCTSTR pTitle)
{
	m_sTitle=pTitle;
}

//*****************************************************************************
//*
//*		SetTextTitle
//*
//*****************************************************************************
//	Einstellen der Textberschrift
//	pTitle		: Zeiger auf die neue Textberschrift
void CComboDlg::SetTextTitle(LPCTSTR pText)
{
	m_sTitle1=pText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
//	Ergibt einen Zeiger auf den Text
LPCTSTR CComboDlg::GetText()
{
	return m_sText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CComboDlg::GetText(LPTSTR pText,int iMax)
{
int iLen;


	if(iMax<=0)return 0;
	iLen=m_sText.GetLength();
	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,(LPCTSTR)m_sText,iLen*sizeof(TCHAR));
	pText[iLen]=0;


return iLen;
}


//*****************************************************************************
//*
//*		GetData
//*
//*****************************************************************************
//	Abfragen der eingegeben Textdaten
DPARAM CComboDlg::GetData(int iIndex)
{

	if(iIndex<0 || iIndex>=m_iStrCount)return 0;


return *(DPARAM*)(m_pStrText[iIndex]);
}

//*****************************************************************************
//*
//*		SetData
//*
//*****************************************************************************
//	Einstellen der eingegeben Textdaten
//	Egibt den alten Wert
DPARAM CComboDlg::SetData(int iIndex,DPARAM uData)
{
DPARAM	uOld;


	if(iIndex<0 || iIndex>=m_iStrCount)
		{
		return 0;
		}

	uOld = *(DPARAM*)m_pStrText[iIndex];
	       *(DPARAM*)m_pStrText[iIndex] = uData;


return uOld;
}

//*****************************************************************************
//*
//*		SetSelect
//*
//*****************************************************************************
//	Auswahl via Text einstellen
//	pText	: Ist der Text der ausgewhlt werden soll
//	iMode	: 1=Grosklein Buchstaben nicht unterscheiden
//	Ergibt die Ausgewhlte Nummer oder -1 wenn der Text nicht gefunden wurde
int	CComboDlg::SetSelect(LPCTSTR pText,int iMode)
{
int		i;

	if(iMode)
		{
		for(i=0;i<m_iStrCount;i++)
			{
			if(stricmp_z(m_pStrText[i]+TEXT_OFF,pText))continue;
			m_iSelect=i;
			return i;
			}
		}
	else{
		for(i=0;i<m_iStrCount;i++)
			{
			if(strcmp_z(m_pStrText[i]+TEXT_OFF,pText))continue;
			m_iSelect=i;
			return i;
			}
		}

return -1;
}

//*****************************************************************************
//*
//*		InsertString
//*
//*****************************************************************************
//	Fgt eine String ein
//	iIndex		: Ist die Einfgeposition (-1=am Ende)
//	uData		: Datenwert fr den Eintrag
//	pText		: Ist det Text der eingefgt werden soll
//	bSelect		: Den Eintrag auswhlen
//	Erbibt die Einfgeposition
int CComboDlg::InsertString(int iIndex,DPARAM uData,LPCTSTR pText,BOOL bSelect)
{
int iLen;


	if(m_pStrText==0)							// Neue Tabelle
		{
		m_iStrCount = 0;
		m_iStrMax   = 16;
		m_pStrText  = new LPTSTR[m_iStrMax];
		memset(m_pStrText,0,sizeof(LPTSTR)*m_iStrMax);
		}

	if(m_iStrCount>=m_iStrMax)					// Tabelle erweitern
		{
		LPTSTR *pTemp;
		int     iMax;

		iMax   = (m_iStrMax*3)/2;
		pTemp  = new LPTSTR[iMax];
		memset(pTemp+m_iStrCount,0,sizeof(LPTSTR)*(iMax-m_iStrMax));
		memcpy(pTemp,m_pStrText   ,sizeof(LPTSTR)*      m_iStrMax );

		delete m_pStrText;
		m_iStrMax  = iMax;
		m_pStrText = pTemp;
		}



	if(iIndex<0 || iIndex>m_iStrCount)
		{
		if(iIndex==IDX_TEXT_SORT)			// Text sortieren
			{
			for(iIndex=0;iIndex<m_iStrCount;iIndex++)
				{
				if(_tcsicmp(pText,m_pStrText[iIndex]+TEXT_OFF)<0)break;
				}
			}
		else if(iIndex==IDX_VALUE_SORT)		// Werte sotieren
			{
			for(iIndex=0;iIndex<m_iStrCount;iIndex++)
				{
				if(uData<*(DPARAM*)m_pStrText[iIndex])break;
				}
			}
		else{								// Am Ende anhngen
			iIndex = m_iStrCount;
			}
		}


	memmove(m_pStrText+iIndex+1,m_pStrText+iIndex,sizeof(LPTSTR)*(m_iStrCount-iIndex));
	iLen = (int)strlen_z(pText)+1;
	m_pStrText[iIndex]=new TCHAR[iLen+TEXT_OFF];
	*(DPARAM*)m_pStrText[iIndex]=uData;
	memcpy(m_pStrText[iIndex]+TEXT_OFF,pText,iLen*sizeof(TCHAR));
	m_iStrCount++;
	if(bSelect)m_iSelect=iIndex;


return iIndex;
}

//*****************************************************************************
//*
//*		ResetContent
//*
//*****************************************************************************
//	Lscht alle Strings
void CComboDlg::ResetContent( )
{
int i;


	if(!m_iStrMax)return;

	for(i=0;i<m_iStrCount;i++)
		{
		delete m_pStrText[i];
		}

	delete m_pStrText;

	m_iStrCount = 0;
	m_pStrText  = 0;
	m_iStrMax   = 0;

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CComboDlg::OnOK()
{
CComboBox	*pCombo;


	pCombo = (CComboBox*)GetDlgItem((m_iMode)? IDC_SELCOMBOEDIT:IDC_SELCOMBO);

	m_iSelect=pCombo->GetCurSel();

	if(m_iSelect>=0)
		{
		pCombo->GetLBText(m_iSelect,m_sText);
		m_uData = *(DPARAM*)m_pStrText[m_iSelect];
		}
	else{
		pCombo->GetWindowText(m_sText);
		m_uData = 0;
		}


	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CComboDlg::OnCancel()
{

	if(!m_bCancel)
		{
		OnOK();
		return;
		}

	m_sText   = _T("");
	m_iSelect = -1;

	CDialog::OnCancel();

}

//*****************************************************************************
//*
//*
//*		Dialogfeld CListDlg
//*
//*
//*****************************************************************************
CListDlg::CListDlg(CWnd *pParent):CDialog((UINT)0,pParent)
{
	//{{AFX_DATA_INIT(CListDlg)
	m_sText = _T("");
	//}}AFX_DATA_INIT

	m_iMode		  = 0;					// 1=editerbar
	m_bCancel	  = 1;					// 1=Cancel anzeigen
	m_iSelect	  =-1;
	m_pStrText    = 0;
	m_iStrMax     = 0;
	m_iStrCount   = 0;
	m_uData		  = 0;
	m_iSizeX	  = 0;					// Grennderung
	m_iSizeY      = 0;
	m_iListId     = 0;
	m_bOldSize	  = 0;
	m_bValueFocus = 0;

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CListDlg::~CListDlg()
{

	ResetContent();

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CListDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListDlg)
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CListDlg::OnInitDialog()
{
CListBox	*pList;
CWnd		*pWnd;
CRect	     sRect;
int			 iSizeX;
int			 iSizeY;
int			 iSel=-1;
int			 iFlag;
int			 i;



	switch(m_iMode)
		{
	default:m_iListId = IDC_SELLIST0; 	break;
	case 1:	m_iListId = IDC_SELLIST1; 	break;
	case 2:	m_iListId = IDC_SELLIST2; 	break;
	case 3:	m_iListId = IDC_SELLIST3; 	break;
		}


	GetClientRect(sRect);

	iSizeX = sRect.Width();
	iSizeY = sRect.Height();

	pWnd =GetDlgItem(m_iListId);
	pWnd->GetClientRect(&sRect);
	pWnd->MapWindowPoints(this,&sRect);

	m_iFrameListX	= sRect.left;
	m_iFrameListY	= sRect.top;
	m_iFrameListZ	= iSizeY-sRect.bottom;

	pWnd =GetDlgItem(IDCANCEL);
	pWnd->GetClientRect(&sRect);
	pWnd->MapWindowPoints(this,&sRect);

	m_iSizeMinX		= (m_bCancel)? sRect.right:sRect.left;
	m_iSizeBtX		= sRect.Width();
	m_iFrameBtX		= sRect.left;
	m_iFrameBtY		= iSizeY-sRect.top;
	m_iFrameBtZ		= iSizeY-sRect.bottom;

	pWnd =GetDlgItem(IDOK);
	pWnd->GetClientRect(&sRect);
	pWnd->MapWindowPoints(this,&sRect);

	m_iFrameBtX	   -= sRect.right;
	m_iSizeMinX	   -= sRect.left-40;
	m_iSizeMinY		= iSizeY-sRect.top+100;


	pList = (CListBox*)GetDlgItem(m_iListId);


	SetWindowLong(m_hWnd,GWL_USERDATA,IDD_LIST_DLG);

	if(!m_hPen1)m_hPen1=CreatePen(PS_SOLID,2,RGB(0,128,0));
	if(!m_hPen2)m_hPen2=CreatePen(PS_SOLID,1,RGB(0,255,0));

	if(m_bValueFocus)
		{
		PostMessage(WM_NEXTDLGCTL,(WPARAM)(pList->m_hWnd),1);
		}

	if(m_sTitle1.IsEmpty())									// Text ber Listbox
		{
		m_iSizeMinY   -= 20;
		m_iFrameListY -= 20;
		}

	GetWindowRect(&sRect);
	iFlag = 0;
															// Alte Fensterposition herstellen
	if(m_bOldPos)
		{
		if(m_iOldPosX>=-20 && m_iOldPosX<GetSystemMetrics(SM_CXSCREEN)-50)
		if(m_iOldPosY>=-20 && m_iOldPosY<GetSystemMetrics(SM_CYSCREEN)-50)
			{
			i = sRect.Width();
			sRect.left	 = m_iOldPosX;
			sRect.right	 = m_iOldPosX+i;

			i = sRect.Height();
			sRect.top	 = m_iOldPosY;
			sRect.bottom = m_iOldPosY+i;
			}

		iFlag = 1;
		}


	if(m_bOldSize)											// Alte Fenstergre herstellen
		{
		sRect.right	 = m_iOldSizeX+sRect.left;
		sRect.bottom = m_iOldSizeY+sRect.top;
		iFlag        = 1;
		}


	if((m_iSizeX || m_iSizeY) && !m_bOldSize)				// Dialoggre ndern
		{
		if((m_iSizeX>>16)==0x1234)
			{
			m_iSizeX  &= 0xFFFF;
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 347;
			m_iSizeX  -= sRect.Width();
			}
		else{
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 347;
			}

		if((m_iSizeY>>16)==0x1234)
			{
			m_iSizeY  &= 0xFFFF;
			m_iSizeY  *= sRect.Height();
			m_iSizeY  /= 301;
			m_iSizeY  -= sRect.Height();
			}
		else{
			m_iSizeY  *= sRect.Height();
			m_iSizeY  /= 301;
			}

		if(m_iSizeX+sRect.Width ()<m_iSizeMinX)m_iSizeX=m_iSizeMinX-sRect.Width ();
		if(m_iSizeY+sRect.Height()<m_iSizeMinY)m_iSizeY=m_iSizeMinY-sRect.Height();

		sRect.bottom += m_iSizeY;
		sRect.right  += m_iSizeX;

		iFlag = 1;
		}

	if(iFlag)												// Den Dialog verschieben
		{
		MoveWindow(&sRect,FALSE);
		GetClientRect(&sRect);
		iSizeX = sRect.Width ();
		iSizeY = sRect.Height();
		}


	if(!m_bCancel)											// Abbrechentaste ausblenden
		{
		m_iFrameBtX = 0;

		pWnd =GetDlgItem(IDCANCEL);
		pWnd->ShowWindow(SW_HIDE);
		}


	OnSize(0,iSizeX,iSizeY);

	pList->SetRedraw(TRUE);

	for(i=0;i<m_iStrCount;i++)								// Texte in die Listbox einfgen
		{
		pList->InsertString(i,m_pStrText[i]+1+TEXT_OFF);

		if(m_iMode&1)										// Mehrfachauswahl
			{
			pList->SetSel(i,m_pStrText[i][TEXT_OFF]);
			continue;
			}

		if(m_pStrText[i][TEXT_OFF])
			{
			m_pStrText[i][TEXT_OFF]=0;
			iSel=i;
			}
		}

	if(m_iSelect<=-2)										// Nichts whlen
		{
		m_iSelect = -1;
		}
	else if(!(m_iMode&1))									// Einzelauswahl
		{
		if(m_iSelect<  0)m_iSelect=iSel;
		if(m_iSelect>=   m_iStrCount)m_iSelect= 0;
		if(m_iSelect==-1)m_iSelect= 0;
		if(m_iSelect>=0  && m_pStrText)
			{
			pList->SetCurSel(m_iSelect);
			m_pStrText[m_iSelect][TEXT_OFF]=1;
			}
		}

	pList->SetRedraw(TRUE);
	pList->ShowWindow(SW_SHOW);


	if(m_iMode>=1)											// Click auf Checkbox abfangen
		{
		WNDPROC		pProc;

		pProc = (WNDPROC)GetWindowLongPtr(pList->m_hWnd,GWL_WNDPROC);
		                 SetWindowLongPtr(pList->m_hWnd,GWL_USERDATA,(DPARAM)pProc);
						 SetWindowLongPtr(pList->m_hWnd,GWL_WNDPROC ,(DPARAM)ListBoxProc);
		}



	CDialog::OnInitDialog();

	if(!m_sTitle .IsEmpty())SetWindowText(m_sTitle);
	if(!m_sTitle1.IsEmpty())SetDlgItemText(IDC_SELTEXT,m_sTitle1);
	else			        GetDlgItem(IDC_SELTEXT)->ShowWindow(SW_HIDE);


return TRUE;
}

//*****************************************************************************
//*
//*		OnMouseWheel
//*
//*****************************************************************************
BOOL CListDlg::OnMouseWheel(UINT nFlags,short sDelta,CPoint sPoint)
{
static BOOL		bLock=0;
CListBox	   *pList;


	if(bLock)return FALSE;

	bLock = TRUE;

	pList = (CListBox*)GetDlgItem(m_iListId);
	pList->SendMessage(WM_MOUSEWHEEL,MAKELONG(nFlags,sDelta),MAKELONG(sPoint.x,sPoint.y));

	bLock = FALSE;


return TRUE;
}

//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Einstellen der Dialog-berschrift
//	pTitle		: Zeiger auf die neue berschrift
void CListDlg::SetTitle(LPCTSTR pTitle)
{
	m_sTitle=pTitle;
}

//*****************************************************************************
//*
//*		SetTextTitle
//*
//*****************************************************************************
//	Einstellen der Textberschrift
//	pTitle		: Zeiger auf die neue Textberschrift
void CListDlg::SetTextTitle(LPCTSTR pText)
{
	m_sTitle1=pText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
LPCTSTR CListDlg::GetText()
{
	return m_sText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CListDlg::GetText(LPTSTR pText,int iMax)
{
int iLen;


	if(iMax<=0)return 0;
	iLen=m_sText.GetLength();
	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,(LPCTSTR)m_sText,iLen*sizeof(TCHAR));
	pText[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen eines Listentextes
//	iIndex		: Ist der Index in der Liste
//	Ergibt einen Zeiger auf den Listentext
LPCTSTR CListDlg::GetText(int iIndex)
{


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;


return m_pStrText[iIndex]+1+TEXT_OFF;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen eines Listentextes
//	iIndex		: Ist der Index in der Liste
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CListDlg::GetText(int iIndex,LPTSTR *pText,int iMax)
{
int iLen;


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;

	if(iMax<=0)return 0;

	iLen = (int)strlen_z(m_pStrText[iIndex]+1+TEXT_OFF);

	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,m_pStrText[iIndex]+1+TEXT_OFF,iLen*sizeof(TCHAR));
	pText[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*		GetData
//*
//*****************************************************************************
//	Abfragen der eingegeben Textdaten
//	iIndex		: Ist der Index in der Liste
//	Ergibt die Zahl die zu einem Listeneintrag gehrt
DPARAM CListDlg::GetData(int iIndex)
{


	if(iIndex<0 || iIndex>=m_iStrCount)
		{
		return 0;
		}


return *(DPARAM*)(m_pStrText[iIndex]);
}

//*****************************************************************************
//*
//*		SetData
//*
//*****************************************************************************
//	Einstellen der eingegeben Textdaten
//	Egibt den alten Wert
DPARAM CListDlg::SetData(int iIndex,DPARAM uData)
{
DPARAM	uOld;


	if(iIndex<0 || iIndex>=m_iStrCount)
		{
		return 0;
		}

	uOld = *(DPARAM*)m_pStrText[iIndex];
	       *(DPARAM*)m_pStrText[iIndex] = uData;


return uOld;
}

//*****************************************************************************
//*
//*		SetSelect
//*
//*****************************************************************************
//	Auswahl via pText einstellen
//	pText	: Ist der pText der ausgewhlt werden soll
//	iMode	: 1=Grosklein nicht unterscheiden
//	Ergibt die Ausgewhlte Nummer oder -1 wenn der pText nicht gefunden wurde
int	CListDlg::SetSelect(LPCTSTR pText,int iMode)
{
int		i;

	if(iMode)
		{
		for(i=0;i<m_iStrCount;i++)
			{
			if(stricmp_z(m_pStrText[i],pText))continue;
			m_iSelect=i;
			return i;
			}
		}
	else{
		for(i=0;i<m_iStrCount;i++)
			{
			if(strcmp_z(m_pStrText[i],pText))continue;
			m_iSelect=i;
			return i;
			}
		}

return -1;
}

//*****************************************************************************
//*
//*		InsertString
//*
//*****************************************************************************
//	Fgt eine String ein
//	iIndex	: Ist die Position in der Liste (-1 = am Ende einfgen)
//	dwData	: Datenwert zu String
//	pText	: Zeiger auf pText
//	iSelect		: Soll der pText gewhlt werden
int CListDlg::InsertString(int iIndex,DPARAM uData,LPCTSTR pText,BOOL iSelect)
{
int iLen;


	if(m_pStrText==0)						// Neue Tabelle
		{
		m_iStrMax	= 16;
		m_iStrCount = 0;
		m_pStrText  = new LPTSTR[m_iStrMax];
		memset(m_pStrText,0,sizeof(LPTSTR)*m_iStrMax);
		}

	if(m_iStrCount>=m_iStrMax)				// Tabelle erweitern
		{
		LPTSTR *pTemp;
		int     iMax;

		iMax   = (m_iStrMax*3)/2;
		pTemp  = new LPTSTR[iMax];

		memset(pTemp+m_iStrCount,0,sizeof(LPTSTR)*(iMax-m_iStrMax));
		memcpy(pTemp,m_pStrText   ,sizeof(LPTSTR)*(     m_iStrMax));

		delete m_pStrText;
		m_iStrMax  = iMax;
		m_pStrText = pTemp;
		}


	if(iIndex<0 || iIndex>m_iStrCount)
		{
		if(iIndex==IDX_TEXT_SORT)			// Text sortieren
			{
			for(iIndex=0;iIndex<m_iStrCount;iIndex++)
				{
				if(_tcsicmp(pText,m_pStrText[iIndex]+1+TEXT_OFF)<0)break;
				}
			}
		else if(iIndex==IDX_VALUE_SORT)		// Werte sotieren
			{
			for(iIndex=0;iIndex<m_iStrCount;iIndex++)
				{
				if(uData<*(DPARAM*)m_pStrText[iIndex])break;
				}
			}
		else{								// Am Ende anhngen
			iIndex = m_iStrCount;
			}
		}


	memmove(m_pStrText+iIndex+1,m_pStrText+iIndex,sizeof(LPTSTR)*(m_iStrCount-iIndex));
	iLen=(int)strlen_z(pText)+1;
	m_pStrText[iIndex]=new TCHAR[iLen+1+TEXT_OFF];
	memcpy(m_pStrText[iIndex]+1+TEXT_OFF,pText,iLen*sizeof(TCHAR));
	*(DPARAM*)m_pStrText[iIndex]=uData;
	m_pStrText[iIndex][TEXT_OFF]=(iSelect)? 1:0;
	m_iStrCount++;


return iIndex;
}


//*****************************************************************************
//*
//*		SelectString
//*
//*****************************************************************************
//	Whlt einen Text aus der Liste
//	iIndex		: Ist der Index in der Liste
//	iSelect		: Soll der Eintag gewhlt (TRUE) oder abgewhlt werden (FALSE)
void CListDlg::SelectString(int iIndex,BOOL iSelect)
{

	ASSERT(iIndex>=0 && iIndex<m_iStrCount);

	if(iIndex<0 || iIndex>=m_iStrCount)return;
	m_pStrText[iIndex][TEXT_OFF]=(iSelect)? 1:0;

}


//*****************************************************************************
//*
//*		GetSelect
//*
//*****************************************************************************
//	Abfragen ob ein Eintrag ausgewhlt ist
//	iIndex		: Ist der Index in des Eintrages in der Liste
//	Ergibt 1 wenn der Eintag gewhlt wurde
int	CListDlg::GetSelect(int iIndex)
{

	ASSERT(iIndex>=0 && iIndex<m_iStrCount);

	if(iIndex<0 || iIndex>=m_iStrCount)return 0;


return m_pStrText[iIndex][TEXT_OFF];
}

//*****************************************************************************
//*
//*		ResetContent
//*
//*****************************************************************************
//	Lscht alle Eintrge aus der Liste
void CListDlg::ResetContent( )
{
int i;

	if(!m_iStrMax)return;

	for(i=0;i<m_iStrCount;i++)
		{
		delete m_pStrText[i];
		}

	delete m_pStrText;

	m_iStrCount	= 0;
	m_pStrText	= 0;
	m_iStrMax	= 0;

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CListDlg::OnOK()
{
CListBox	*pList;
CRect		 sRect;
int			 i;


	GetWindowRect(&sRect);
	m_iOldSizeX	= sRect.Width();
	m_iOldSizeY	= sRect.Height();
	m_iOldPosX	= sRect.left;
	m_iOldPosY	= sRect.top;
	m_bOldPos	= TRUE;
	m_bOldSize	= TRUE;

	pList = (CListBox*)GetDlgItem(m_iListId);

	if(m_iMode!=2)
		{
		m_iSelect=pList->GetCurSel();
		}

	if(m_iSelect>=0 && m_iSelect<m_iStrCount)
		{
		m_sText =           m_pStrText[m_iSelect]+1+TEXT_OFF;
		m_uData = *(DPARAM*)m_pStrText[m_iSelect];
		}
	else{
		m_sText = "";
		m_uData = 0;
		}

	if(m_iMode<=1)
		{
		for(i=0;i<m_iStrCount;i++)
			{
			m_pStrText[i][TEXT_OFF]=pList->GetSel(i);
			}
		}

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CListDlg::OnCancel()
{
CRect	 sRect;


	if(!m_bCancel)
		{
		return;
		}

	GetWindowRect(&sRect);
	m_iOldSizeX	= sRect.Width();
	m_iOldSizeY	= sRect.Height();
	m_iOldPosX	= sRect.left;
	m_iOldPosY	= sRect.top;
	m_bOldPos	= TRUE;
	m_bOldSize	= TRUE;


	m_sText   = _T("");
	m_iSelect = -1;

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnDrawItem
//*
//*****************************************************************************
void CListDlg::OnDrawItem(int iId, LPDRAWITEMSTRUCT pDraw)
{
int			iNum;
int			iState;
HBRUSH		hBrush;
CRect		sRect;
HWND		hWnd;
LPTSTR      pText;
CDC		   *pDc;


	iNum	= pDraw->itemID;
	hWnd	= pDraw->hwndItem;
	sRect	= pDraw->rcItem;
	iState	= pDraw->itemState;
	pDc		= CDC::FromHandle(pDraw->hDC);
	pText	= m_pStrText[iNum];


	if(iState&ODS_SELECTED)						// Hintergrundfarbe
		{
		pDc->SetTextColor(GetSysColor(COLOR_HIGHLIGHTTEXT));
		hBrush=GetSysColorBrush(COLOR_HIGHLIGHT);
		}
	else{
		pDc->SetTextColor(GetSysColor(COLOR_WINDOWTEXT));
		hBrush=GetSysColorBrush(COLOR_WINDOW);
		}


	pDc->SelectStockObject(NULL_PEN);			// Hintergrund zeichnen
	pDc->SelectObject(hBrush);
	pDc->SetBkMode(TRANSPARENT);
	pDc->Rectangle(sRect);

	pDc->SelectStockObject(BLACK_PEN);
	pDc->SelectStockObject(WHITE_BRUSH);
	pDc->Rectangle(sRect.left+3,sRect.top+2,sRect.left+3+11,sRect.top+2+11);

	if(pText[TEXT_OFF])							// Hkchen zeichnen
		{
		pDc->SelectObject(m_hPen1);
		pDc->MoveTo(sRect.left+4-2 ,sRect.top+3+3);
		pDc->LineTo(sRect.left+4+2 ,sRect.top+3+7);
		pDc->LineTo(sRect.left+4+12,sRect.top+3+0);

		pDc->SelectObject(m_hPen2);
		pDc->MoveTo(sRect.left+4-1 ,sRect.top+3+2);
		pDc->LineTo(sRect.left+4+2 ,sRect.top+3+5);
		pDc->LineTo(sRect.left+4+12,sRect.top+3+0);
		}

	sRect.left+=30;
	pDc->DrawText(pText+1+TEXT_OFF,-1,sRect,DT_LEFT);

}

//*****************************************************************************
//*
//*		OnSelNone
//*
//*****************************************************************************
void CListDlg::OnSelNone()
{
CListBox	*pList;
int			 iNew;
int			 i;

	switch(m_iMode)
		{
	case 1:	pList = (CListBox*)GetDlgItem(IDC_SELLIST1);	break;
	case 3:	pList = (CListBox*)GetDlgItem(IDC_SELLIST3);	break;
	default:	return;
		}

	i	 = pList->GetCount();
	iNew = 0;

	for(i--;i>=0;i--)
		{
		pList->SetSel(i,FALSE);

		if(m_iMode==3)
			{
			if(m_pStrText[i][TEXT_OFF])
				{
				m_pStrText[i][TEXT_OFF]=0;
				iNew=1;
				}
			}
		}

	if(iNew)pList->RedrawWindow();

}


//*****************************************************************************
//*
//*		OnSelAll
//*
//*****************************************************************************
void CListDlg::OnSelAll()
{
CListBox	*pList;
int			 iNew;
int			 i;

	switch(m_iMode)
		{
	case 1:	pList = (CListBox*)GetDlgItem(IDC_SELLIST1);	break;
	case 3:	pList = (CListBox*)GetDlgItem(IDC_SELLIST3);	break;
	default:	return;
		}

	i	 = pList->GetCount();
	iNew = 0;

	for(i--;i>=0;i--)
		{
		pList->SetSel(i,TRUE);

		if(m_iMode==3)
			{
			if(!m_pStrText[i][TEXT_OFF])
				{
				m_pStrText[i][TEXT_OFF]=1;
				iNew=1;
				}
			}
		}

	if(iNew)pList->RedrawWindow();


}

//*****************************************************************************
//*
//*		OnRightClick
//*
//*****************************************************************************
void CListDlg::OnRightClick()
{
CPoint	sPoint;
CMenu	sMenu;


	if(!(m_iMode&1))return;


	GetCursorPos(&sPoint);

	sMenu.CreatePopupMenu();
	sMenu.AppendMenu(MF_STRING,IDC_SEL_ALL ,LoadDefaultStrings(NULL,IDS_TEXT_SELALL ));
	sMenu.AppendMenu(MF_STRING,IDC_SEL_NONE,LoadDefaultStrings(NULL,IDS_TEXT_SELNONE));
	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnDblclkList
//*
//*****************************************************************************
void CListDlg::OnDblclkList()
{
CListBox	*pList;
CRect		 sRect;
int			 iSize;
int			 iNum;
int			 iTop;


	pList = (CListBox*)GetDlgItem(m_iListId);

	   iNum=pList->GetCurSel();
	if(iNum<0 || iNum>=m_iStrCount)return;

	switch(m_iMode)
		{
	case 0:	OnOK();		break;
	case 1:				break;
	case 2:	if(m_pStrText[iNum][TEXT_OFF]==0)
				{
				if(m_iSelect>=0)
				m_pStrText[m_iSelect][TEXT_OFF] = 0;
				m_pStrText[iNum     ][TEXT_OFF] = 1;

				iTop  =	pList->GetTopIndex();
				iSize = pList->GetItemHeight(0);
						pList->GetClientRect(sRect);
						sRect.top    += (m_iSelect-iTop)*iSize;
						sRect.bottom  =  sRect.top+iSize;
						pList->InvalidateRect(sRect);
						sRect.top    += (iNum-m_iSelect)*iSize;
						sRect.bottom  =  sRect.top+iSize;
						pList->InvalidateRect(sRect);

				m_iSelect = iNum;
				}

			break;

	case 3:	m_pStrText[iNum][TEXT_OFF]=!m_pStrText[iNum][TEXT_OFF];
			pList->RedrawWindow();
			break;
		}
}


//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
//	Sortiert die Listbox-Eintrge
//	pCompare	: Ist die Verleichsfunktion
//					ValueCompare
//					NameCompare
void CListDlg::Sort(int (__cdecl *pCompare)(const void*,const void*))
{
	qsort(m_pStrText,m_iStrCount,sizeof(m_pStrText),pCompare);
}

//*****************************************************************************
//*
//*		NameCompare
//*
//*****************************************************************************
//	Nach Namen sortieren
int __cdecl CListDlg::NameCompare(const void *pElem1, const void *pElem2)
{
LPTSTR	pName1,pName2;


	pName1 = *(LPTSTR*)pElem1;
	pName2 = *(LPTSTR*)pElem2;


return stricmp_z(pName1+1+TEXT_OFF,pName2+1+TEXT_OFF);
}


//*****************************************************************************
//*
//*		ValueCompare
//*
//*****************************************************************************
//	Nach Datenwerten sortieren
int __cdecl CListDlg::ValueCompare(const void *pElem1,const void *pElem2)
{
DPARAM	lVal1,lVal2;


	lVal1 = **(DPARAM**)pElem1;
	lVal2 = **(DPARAM**)pElem2;

	if(lVal1<lVal2)return -1;
	if(lVal1>lVal2)return  1;


return 0;
}


//*****************************************************************************
//*
//*		ListboxProc
//*
//*****************************************************************************
LRESULT CALLBACK CListDlg::ListBoxProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC		pProc;
LRESULT		lRet;
LRESULT		lSel;
UINT		uId;


	pProc = (WNDPROC)GetWindowLongPtr(hWnd,GWL_USERDATA);

	if(uMsg==WM_LBUTTONDOWN)
		{
		uId = GetWindowLong(hWnd,GWL_ID);

		if(GET_X_LPARAM(lParam)<20 || (uId!=IDC_SELLIST2 && uId!=IDC_SELLIST3))
			{
			lRet = CallWindowProc(pProc,hWnd,WM_LBUTTONDOWN  ,wParam,lParam);
				   CallWindowProc(pProc,hWnd,WM_LBUTTONDBLCLK,wParam,lParam);

			return lRet;
			}
		}
	else if(uMsg==WM_RBUTTONDOWN)
		{
		::SendMessage(::GetParent(hWnd),WM_COMMAND,IDC_RIGHTCLICK,0);
		}
	else if(uMsg==WM_LBUTTONDBLCLK)
		{
		uId = GetWindowLong(hWnd,GWL_ID);

		if(GET_X_LPARAM(lParam)<20 || (uId!=IDC_SELLIST2 && uId!=IDC_SELLIST3))
			{
			return 0;
			}
		}
	else if(uMsg==WM_CHAR)
		{
		if(wParam==' ')
			{
			lSel = CallWindowProc(pProc,hWnd,LB_GETCURSEL,0,0);

			if(lSel>=0)
				{
				uId  = GetWindowLong(hWnd,GWL_ID);

				switch(uId)
					{
				case IDC_SELLIST0:

						CallWindowProc(pProc,hWnd,LB_SETSEL,1,lSel);
						break;

				case IDC_SELLIST1:

						lRet = CallWindowProc(pProc,hWnd,LB_GETSEL, lSel,0   );
							   CallWindowProc(pProc,hWnd,LB_SETSEL,!lRet,lSel);

						break;

				default:

						::SendMessage(::GetParent(hWnd),WM_COMMAND,MAKELONG(uId,LBN_DBLCLK),(DPARAM)hWnd);
						break;
					}
				}
			}
		else if(wParam>' ')
			{
			::SendMessage(::GetParent(hWnd),WM_CHAR,wParam,lParam);
			}

		return 	0;
		}

return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}



//*****************************************************************************
//*
//*		OnChar
//*
//*****************************************************************************
void CListDlg::OnChar(UINT nChar,UINT nRepCnt,UINT nFlags)
{
CListBox   *pList;
LPCTSTR		pName;
unsigned	uDelta;
unsigned	uTick;
unsigned	uItem;
unsigned	uVal;
unsigned	uPos;
int			iNum;
int			iMax;
int			i;



	pList	= (CListBox*)GetDlgItem(m_iListId);
	iNum	= pList->GetCurSel();
	iMax	= m_iStrCount;


	if((nChar>='a' && nChar<='z') ||					// In Grosbuchstaben umwandeln
	   (nChar>=224 && nChar<=254))
		{
		nChar-='a'-'A';
		}


	for(;;) 											// Suche Anfangsbuchstaben
		{
		uTick  = GetTickCount();
		uDelta = (m_uKeyPos>0)? 750:500;

		if(m_uKeyPos>=3           )uDelta=1000;
		if(uTick-m_uKeyLast>uDelta)m_uKeyPos=0;
		if(m_uKeyPos>=16          )m_uKeyPos=0;
		if(m_uKeyPos==1 && m_cKeyData[0]==(TCHAR)nChar)
			{
			m_uKeyPos=0;
			}

		m_cKeyData[m_uKeyPos] = (TCHAR)nChar;
		m_uKeyLast            = uTick;
		m_uKeyPos            += 1;


		if(m_uKeyPos>1)
			{
			iNum--;
			if(iNum<0)iNum=iMax-1;
			}

		if(iMax<=0)break;

		for(i=iNum+1;i!=iNum;i++)					// Suche bereinstimmung
			{
			if(i>=iMax){i=-1;continue;}

			uItem = i;
			pName = m_pStrText[i]+1+TEXT_OFF;


			for(uPos=0;uPos<m_uKeyPos;uPos++)		// Vergleiche die Texte
				{
				#if UNICODE
				uVal = pName[uPos];
				#else
				uVal = ((unsigned char*)pName)[uPos];
				#endif

				if((uVal>='a' && uVal<='z') ||		// In Grosbuchstaben umwandeln
				   (uVal>=224 && uVal<=254))
					{
					uVal-='a'-'A';
					}

				if(m_cKeyData[uPos]!=(TCHAR)uVal)
					{
					break;
					}
				}

			if(uPos<m_uKeyPos)continue;

			pList->SetCurSel(uItem);

			return;
			}

		if(i!=iNum     )break;
		if(m_uKeyPos<=1)break;

		iNum++;
		if(iNum>=iMax)iNum=iMax-1;

		m_uKeyPos=0;
		}
}

//*****************************************************************************
//*
//*		OnSizing
//*
//*****************************************************************************
void CListDlg::OnSizing(UINT nSide,LPRECT pRect)
{


	if(pRect->right-pRect->left<m_iSizeMinX)
		{
		if(nSide==WMSZ_BOTTOMLEFT ||
		   nSide==WMSZ_TOPLEFT 	  ||
		   nSide==WMSZ_LEFT)
			{
			pRect->left = pRect->right-m_iSizeMinX;
			}
		else{
			pRect->right = pRect->left+m_iSizeMinX;
			}
		}

	if(pRect->bottom-pRect->top<m_iSizeMinY)
		{
		if(nSide==WMSZ_TOPRIGHT ||
		   nSide==WMSZ_TOPLEFT  ||
		   nSide==WMSZ_TOP)
			{
			pRect->top = pRect->bottom-m_iSizeMinY;
			}
		else{
			pRect->bottom = pRect->top+m_iSizeMinY;
			}
		}

}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CListDlg::OnSize(UINT nType,int iSizeX,int iSizeY)
{
CRect	sRect;
CWnd   *pWnd;


	if(iSizeX<=0 || iSizeY<=0 || m_iListId==0)return;

	sRect.left		= m_iFrameListX;
	sRect.right		= iSizeX-m_iFrameListX;
	sRect.top		= m_iFrameListY;
	sRect.bottom	= iSizeY-m_iFrameListZ;

	   pWnd = GetDlgItem(m_iListId);
	if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

	sRect.top		= iSizeY-m_iFrameBtY;
	sRect.bottom	= iSizeY-m_iFrameBtZ;

	if(!m_bCancel)
		{
		sRect.left		= (iSizeX-m_iSizeBtX)/2;
		sRect.right		= sRect.left+m_iSizeBtX;

		   pWnd = GetDlgItem(IDOK);
		if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

		return;
		}

	sRect.left		= (iSizeX-m_iSizeBtX*2-m_iFrameBtX)/2;
	sRect.right		= sRect.left+m_iSizeBtX;

	   pWnd=GetDlgItem(IDOK);
	if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

	sRect.left	   += m_iFrameBtX+m_iSizeBtX;
	sRect.right	   += m_iFrameBtX+m_iSizeBtX;

	   pWnd=GetDlgItem(IDCANCEL);
	if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

}

//*****************************************************************************
//*
//*
//*		Dialogfeld CColumnDlg
//*
//*
//*****************************************************************************
CColumnDlg::CColumnDlg(CWnd *pParent):CDialog((UINT)0,pParent)
{
	//{{AFX_DATA_INIT(CColumnDlg)
	m_sText = _T("");
	//}}AFX_DATA_INIT

	m_iMode		  = 0;					// 1=editerbar
	m_bCancel	  = 1;					// 1=Cancel anzeigen
	m_bSized	  = 0;
	m_iSelect	  =-1;
	m_iNewCode	  =-1;
	m_pStrText    = 0;
	m_iStrMax     = 0;
	m_iStrCount   = 0;
	m_uData		  = 0;
	m_iSizeX	  = 0;					// Grennderung
	m_iSizeY      = 0;
	m_bOldSize	  = 0;
	m_bValueFocus = 0;
	m_pColData	  = 0;
	m_iColumns	  = 0;
	m_iColumnsMax = 0;
	m_pColText	  = 0;
	m_iColText	  = 0;
	m_iColTextMax = 0;
	m_pList		  = 0;
	m_hCopyItem	  = 0;

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CColumnDlg::~CColumnDlg()
{

	ResetContent();

	while(m_iColumns>0)
		{
		m_iColumns--;
		delete m_pColData[m_iColumns].pName;
		}

	if(m_pColData)
		{
		delete m_pColData;
		m_pColData = NULL;
		m_iColumnsMax = 0;
		}

	if(m_pList)
		{
		delete m_pList;
		m_pList = NULL;
		}

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CColumnDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColumnDlg)
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CColumnDlg::OnInitDialog()
{
CWnd		*pWnd;
CRect	     sRect;
HTREEITEM	 hItem;
int			 iSizeX;
int			 iSizeY;
int			 iSel=-1;
int			 iMode;
int			 iFlag;
int			 iLast;
int			 i;


	m_bSized	= FALSE;
	iMode		= (m_iMode&0x03);
	iFlag		= (m_iMode&0x02)? TVS_CHECKBOXES:0;
	m_pList		= new CTreeListCtrl;

	for(i=0;i<m_iColumns;i++)								// Kann eine Spalte editiert werden
		{
		if(!m_pColData[i].bEdit)continue;
		iFlag   |= TVS_EDITLABELS;
		m_iMode	|= 0x80;
		break;
		}

	if(!m_iColumns && (m_iMode&0x30))						// Editiren wenn keine Spalte definiert wurde
		{
		iFlag   |= TVS_EDITLABELS;
		m_iMode	|= 0x80;
		}


	m_pList->CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_DISABLEDRAGDROP|TVS_FULLROWSELECT|iFlag,IDC_FRAME,this,IDC_LIST);

	                 iFlag =TVS_EX_SINGLECHECKBOX|TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES|TVS_EX_SINGLECHECKBOX;
	if(  iMode == 1 )iFlag^=TVS_EX_MULTISELECT;
	if(m_iMode&0x04 )iFlag^=TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES;
	if(m_iMode&0x80 )iFlag|=TVS_EX_SUBSELECT;
	if(m_iColumns==0)iFlag|=TVS_EX_HIDEHEADERS;

	m_pList->SetExtendedStyle(TVS_EX_FULLROWMARK|TVS_EX_HOMEENDSELECT|iFlag);

	for(i=0;i<m_iColumns;i++)
		{
		m_pList->InsertColumn(i,m_pColData[i].pName,m_pColData[i].bAlign,m_pColData[i].sSize);

		if(m_pColData[i].bEdit)
			{
			m_pList->SetColumnAutoEdit(i,TVAE_EDIT|TVAE_FULLWIDTH|TVAE_DBLCLICK);
			}
		}



	GetClientRect(sRect);

	iSizeX = sRect.Width();
	iSizeY = sRect.Height();

	m_pList->GetClientRect(&sRect);
	m_pList->MapWindowPoints(this,&sRect);

	m_iFrameListX	= sRect.left;
	m_iFrameListY	= sRect.top;
	m_iFrameListZ	= iSizeY-sRect.bottom;

	pWnd =GetDlgItem(IDCANCEL);
	pWnd->GetClientRect(&sRect);
	pWnd->MapWindowPoints(this,&sRect);

	m_iSizeMinX		= (m_bCancel)? sRect.right:sRect.left;
	m_iSizeBtX		= sRect.Width();
	m_iFrameBtX		= sRect.left;
	m_iFrameBtY		= iSizeY-sRect.top;
	m_iFrameBtZ		= iSizeY-sRect.bottom;

	pWnd =GetDlgItem(IDOK);
	pWnd->GetClientRect(&sRect);
	pWnd->MapWindowPoints(this,&sRect);

	m_iFrameBtX	   -= sRect.right;
	m_iSizeMinX	   -= sRect.left-40;
	m_iSizeMinY		= iSizeY-sRect.top+100;


	if(m_bValueFocus)
		{
		PostMessage(WM_NEXTDLGCTL,(WPARAM)(m_pList->m_hWnd),1);
		}

	if(m_sTitle1.IsEmpty())									// Text ber Listbox
		{
		m_iSizeMinY   -= 20;
		m_iFrameListY -= 20;
		}

	GetWindowRect(&sRect);
	iFlag = 0;
															// Alte Fensterposition herstellen
	if(m_bOldPos)
		{
		if(m_iOldPosX>=-20 && m_iOldPosX<GetSystemMetrics(SM_CXSCREEN)-50)
		if(m_iOldPosY>=-20 && m_iOldPosY<GetSystemMetrics(SM_CYSCREEN)-50)
			{
			i = sRect.Width();
			sRect.left	 = m_iOldPosX;
			sRect.right	 = m_iOldPosX+i;

			i = sRect.Height();
			sRect.top	 = m_iOldPosY;
			sRect.bottom = m_iOldPosY+i;
			}

		iFlag = 1;
		}


	if(m_bOldSize)											// Alte Fenstergre herstellen
		{
		sRect.right	 = m_iOldSizeX+sRect.left;
		sRect.bottom = m_iOldSizeY+sRect.top;
		iFlag        = 1;
		}


	if((m_iSizeX || m_iSizeY) && !m_bOldSize)				// Dialoggre ndern
		{
		if((m_iSizeX>>16)==0x1234)
			{
			m_iSizeX  &= 0xFFFF;
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 347;
			m_iSizeX  -= sRect.Width();
			}
		else{
			m_iSizeX  *= sRect.Width();
			m_iSizeX  /= 347;
			}

		if((m_iSizeY>>16)==0x1234)
			{
			m_iSizeY  &= 0xFFFF;
			m_iSizeY  *= sRect.Height();
			m_iSizeY  /= 301;
			m_iSizeY  -= sRect.Height();
			}
		else{
			m_iSizeY  *= sRect.Height();
			m_iSizeY  /= 301;
			}

		if(m_iSizeX+sRect.Width ()<m_iSizeMinX)m_iSizeX=m_iSizeMinX-sRect.Width ();
		if(m_iSizeY+sRect.Height()<m_iSizeMinY)m_iSizeY=m_iSizeMinY-sRect.Height();

		sRect.bottom += m_iSizeY;
		sRect.right  += m_iSizeX;

		iFlag = 1;
		}

	if(iFlag)												// Den Dialog verschieben
		{
		MoveWindow(&sRect,FALSE);
		GetClientRect(&sRect);
		iSizeX = sRect.Width ();
		iSizeY = sRect.Height();
		}


	if(!m_bCancel)											// Abbrechentaste ausblenden
		{
		m_iFrameBtX = 0;

		pWnd =GetDlgItem(IDCANCEL);
		pWnd->ShowWindow(SW_HIDE);
		}


	OnSize(0,iSizeX,iSizeY);

	m_pList->SetRedraw(FALSE);

	for(i=0;i<m_iStrCount;i++)								// Texte in die Listbox einfgen
		{
		hItem = m_pList->InsertItem(m_pStrText[i]+1+TEXT_OFF,TVI_ROOT,TVI_LAST,i);

		if(m_iMode&1)										// Mehrfachauswahl
			{
			if(m_iMode&2)
				{
				m_pList->SetCheck(hItem,m_pStrText[i][TEXT_OFF]);
				}
			else if(m_pStrText[i][TEXT_OFF])
				{
				m_pList->SelectItem(hItem);
				}

			continue;
			}
		}



	for(i=0,hItem=0,iLast=-1;i<m_iColText;i++)				// Spaltentexte einfgen
		{
		if(iLast!=m_pColText[i].sSize)
			{
			iLast = (WORD)m_pColText[i].sSize;
			hItem = m_pList->FindItem(TVI_ROOT,TVIF_PARAM|TVIF_CHILDS,0,NULL,iLast);
			}

		m_pList->SetItemText(hItem,m_pColText[i].pName,m_pColText[i].bAlign);
		}

	if(m_iSelect<=-2)										// Nichts whlen
		{
		m_iSelect = -1;
		}
	else if(!(m_iMode&1))									// Einzelauswahl
		{
		if(m_iSelect<  0)m_iSelect=iSel;
		if(m_iSelect>=   m_iStrCount)m_iSelect= 0;
		if(m_iSelect==-1)m_iSelect= 0;
		if(m_iSelect>=0  && m_pStrText)
			{
			hItem = m_pList->FindItem(TVI_ROOT,TVIF_PARAM|TVIF_CHILDS,0,NULL,m_iSelect);

			if(m_iMode&2)
					m_pList->SetCheck  (hItem,TRUE);
			else	m_pList->SelectItem(hItem);
			}
		}

	if(m_iMode&0x10)										// Ist das Einfgen erlaubt
		{
		m_pList->InsertItem(_T(""),TVI_ROOT,TVI_LAST,m_iStrCount);
		}


	m_pList->SetRedraw(TRUE);


	CDialog::OnInitDialog();

	if(!m_sTitle .IsEmpty())SetWindowText(m_sTitle);
	if(!m_sTitle1.IsEmpty())SetDlgItemText(IDC_SELTEXT,m_sTitle1);
	else			        GetDlgItem(IDC_SELTEXT)->ShowWindow(SW_HIDE);


return TRUE;
}

//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Einstellen der Dialog-berschrift
//	pTitle		: Zeiger auf die neue berschrift
void CColumnDlg::SetTitle(LPCTSTR pTitle)
{
	m_sTitle=pTitle;
}

//*****************************************************************************
//*
//*		SetTextTitle
//*
//*****************************************************************************
//	Einstellen der Textberschrift
//	pTitle		: Zeiger auf die neue Textberschrift
void CColumnDlg::SetTextTitle(LPCTSTR pText)
{
	m_sTitle1=pText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
LPCTSTR CColumnDlg::GetText()
{
	return m_sText;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen des eingegeben Textes
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CColumnDlg::GetText(LPTSTR pText,int iMax)
{
int iLen;


	if(iMax<=0)return 0;
	iLen=m_sText.GetLength();
	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,(LPCTSTR)m_sText,iLen*sizeof(TCHAR));
	pText[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen eines Listentextes
//	iIndex		: Ist der Index in der Liste
//	Ergibt einen Zeiger auf den Listentext
LPCTSTR CColumnDlg::GetText(int iIndex)
{


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;


return m_pStrText[iIndex]+1+TEXT_OFF;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen eines Listentextes
//	iIndex		: Ist der Index in der Liste
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CColumnDlg::GetText(int iIndex,LPTSTR pText,int iMax)
{
int iLen;


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;

	if(iMax<=0)return 0;

	iLen = (int)strlen_z(m_pStrText[iIndex]+1+TEXT_OFF);

	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,m_pStrText[iIndex]+1+TEXT_OFF,iLen*sizeof(TCHAR));
	pText[iLen]=0;


return iLen;
}


//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen eines Listentextes
//	iIndex		: Ist der Index in der Liste
//	iCol		: Ist die Nummer der Spalte
//	Ergibt einen Zeiger auf den Listentext
LPCTSTR CColumnDlg::GetText(int iIndex,int iCol)
{
int		iPos;


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;
	if(iCol <=0)return GetText(iIndex);
	if(iCol >=m_iColumns)return 0;

	for(iPos=0;iPos<m_iColText;iPos++)				// Spaltentexte suchen
		{
		if((WORD)m_pColText[iPos].sSize !=iIndex)continue;
		if(      m_pColText[iPos].bAlign!=iCol  )continue;

		return m_pColText[iPos].pName;
		}


return Z("");
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Abfragen eines Listentextes
//	iIndex		: Ist der Index in der Liste
//	iCol		: Ist die Nummer der Spalte
//	pText		: Zeiger auf den Textpuffer
//	iMax		: Ist die Gre des Textpuffers
//	Ergibt die Lnge des gespeicherten Textes
int CColumnDlg::GetText(int iIndex,int iCol,LPTSTR pText,int iMax)
{
LPTSTR	pName;
int		iLen;
int		iPos;


	if(iMax<=0)return 0;

	if(iIndex<0 || iIndex>=m_iStrCount){*pText=0;return 0;}
	if(iCol <=0)return GetText(iIndex,pText,iMax);
	if(iCol >=m_iColumns)return 0;

	if(iMax<=0)return 0;


	for(iPos=0;iPos<m_iColText;iPos++)				// Spaltentexte suchen
		{
		if((WORD)m_pColText[iPos].sSize !=iIndex)continue;
		if(      m_pColText[iPos].bAlign!=iCol  )continue;

		pName  = m_pColText[iPos].pName;

		   iLen = (int)strlen_z(pName);
		if(iLen>=iMax)iLen=iMax-1;

		memcpy(pText,pName,iLen*sizeof(TCHAR));
		pText[iLen]=0;

		return iLen;
		}

	pText[0] = 0;


return 0;
}

//*****************************************************************************
//*
//*		GetData
//*
//*****************************************************************************
//	Abfragen der eingegeben Textdaten
//	iIndex		: Ist der Index in der Liste
//	Ergibt die Zahl die zu einem Listeneintrag gehrt
DPARAM CColumnDlg::GetData(int iIndex)
{


	if(iIndex<0 || iIndex>=m_iStrCount)
		{
		return 0;
		}


return *(DPARAM*)(m_pStrText[iIndex]);
}

//*****************************************************************************
//*
//*		SetData
//*
//*****************************************************************************
//	Einstellen der eingegeben Textdaten
//	Egibt den alten Wert
DPARAM CColumnDlg::SetData(int iIndex,DPARAM uData)
{
DPARAM	uOld;


	if(iIndex<0 || iIndex>=m_iStrCount)
		{
		return 0;
		}

	uOld = *(DPARAM*)m_pStrText[iIndex];
	       *(DPARAM*)m_pStrText[iIndex] = uData;


return uOld;
}

//*****************************************************************************
//*
//*		SetSelect
//*
//*****************************************************************************
//	Auswahl via pText einstellen
//	pText	: Ist der pText der ausgewhlt werden soll
//	iMode	: 1=Grosklein nicht unterscheiden
//	Ergibt die Ausgewhlte Nummer oder -1 wenn der pText nicht gefunden wurde
int	CColumnDlg::SetSelect(LPCTSTR pText,int iMode)
{
int		i;

	if(iMode)
		{
		for(i=0;i<m_iStrCount;i++)
			{
			if(stricmp_z(m_pStrText[i],pText))continue;
			m_iSelect=i;
			return i;
			}
		}
	else{
		for(i=0;i<m_iStrCount;i++)
			{
			if(strcmp_z(m_pStrText[i],pText))continue;
			m_iSelect=i;
			return i;
			}
		}

return -1;
}

//*****************************************************************************
//*
//*		InsertString
//*
//*****************************************************************************
//	Fgt eine String ein
//	iIndex	: Ist die Position in der Liste (-1 = am Ende einfgen)
//	dwData	: Datenwert zu String
//	pText	: Zeiger auf pText
//	iSelect		: Soll der pText gewhlt werden
int CColumnDlg::InsertString(int iIndex,DPARAM uData,LPCTSTR pText,BOOL iSelect)
{
int iLen;


	if(m_pStrText==0)						// Neue Tabelle
		{
		m_iStrMax	= 16;
		m_iStrCount = 0;
		m_pStrText  = new LPTSTR[m_iStrMax];
		memset(m_pStrText,0,sizeof(LPTSTR)*m_iStrMax);
		}

	if(m_iStrCount>=m_iStrMax)				// Tabelle erweitern
		{
		LPTSTR *pTemp;
		int     iMax;

		iMax   = (m_iStrMax*3)/2;
		pTemp  = new LPTSTR[iMax];

		memset(pTemp+m_iStrCount,0,sizeof(LPTSTR)*(iMax-m_iStrMax));
		memcpy(pTemp,m_pStrText   ,sizeof(LPTSTR)*(     m_iStrMax));

		delete m_pStrText;
		m_iStrMax  = iMax;
		m_pStrText = pTemp;
		}


	if(iIndex<0 || iIndex>m_iStrCount)
		{
		if(iIndex==IDX_TEXT_SORT)			// Text sortieren
			{
			for(iIndex=0;iIndex<m_iStrCount;iIndex++)
				{
				if(_tcsicmp(pText,m_pStrText[iIndex]+1+TEXT_OFF)<0)break;
				}
			}
		else if(iIndex==IDX_VALUE_SORT)		// Werte sotieren
			{
			for(iIndex=0;iIndex<m_iStrCount;iIndex++)
				{
				if(uData<*(DPARAM*)m_pStrText[iIndex])break;
				}
			}
		else{								// Am Ende anhngen
			iIndex = m_iStrCount;
			}
		}


	memmove(m_pStrText+iIndex+1,m_pStrText+iIndex,sizeof(LPTSTR)*(m_iStrCount-iIndex));
	iLen=(int)strlen_z(pText)+1;
	m_pStrText[iIndex]=new TCHAR[iLen+1+TEXT_OFF];
	memcpy(m_pStrText[iIndex]+1+TEXT_OFF,pText,iLen*sizeof(TCHAR));
	*(DPARAM*)m_pStrText[iIndex]=uData;
	m_pStrText[iIndex][TEXT_OFF]=(iSelect)? 1:0;
	m_iStrCount++;


return iIndex;
}


//*****************************************************************************
//*
//*		SelectString
//*
//*****************************************************************************
//	Whlt einen Text aus der Liste
//	iIndex		: Ist der Index in der Liste
//	iSelect		: Soll der Eintag gewhlt (TRUE) oder abgewhlt werden (FALSE)
void CColumnDlg::SelectString(int iIndex,BOOL iSelect)
{

	ASSERT(iIndex>=0 && iIndex<m_iStrCount);

	if(iIndex<0 || iIndex>=m_iStrCount)return;
	m_pStrText[iIndex][TEXT_OFF]=(iSelect)? 1:0;

}


//*****************************************************************************
//*
//*		GetSelect
//*
//*****************************************************************************
//	Abfragen ob ein Eintrag ausgewhlt ist
//	iIndex		: Ist der Index in des Eintrages in der Liste
//	Ergibt 1 wenn der Eintag gewhlt wurde
int	CColumnDlg::GetSelect(int iIndex)
{

	ASSERT(iIndex>=0 && iIndex<m_iStrCount);

	if(iIndex<0 || iIndex>=m_iStrCount)return 0;


return m_pStrText[iIndex][TEXT_OFF];
}

//*****************************************************************************
//*
//*		ResetContent
//*
//*****************************************************************************
//	Lscht alle Eintrge aus der Liste
void CColumnDlg::ResetContent( )
{
int i;



	while(m_iColText>0)
		{
		m_iColText--;
		delete m_pColText[m_iColText].pName;
		}

	if(m_pColText)
		{
		delete m_pColText;
		m_pColText = NULL;
		m_iColTextMax = 0;
		}


	if(!m_iStrMax)return;

	for(i=0;i<m_iStrCount;i++)
		{
		delete m_pStrText[i];
		}

	delete m_pStrText;

	m_iStrCount	= 0;
	m_pStrText	= 0;
	m_iStrMax	= 0;

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CColumnDlg::OnOK()
{
CRect		 sRect;
HTREEITEM	 hItem;
int			 iVal;
int			 i;


	GetWindowRect(&sRect);
	m_iOldSizeX	= sRect.Width();
	m_iOldSizeY	= sRect.Height();
	m_iOldPosX	= sRect.left;
	m_iOldPosY	= sRect.top;
	m_bOldPos	= TRUE;
	m_bOldSize	= TRUE;
	m_iSelect	= -1;

	hItem = m_pList->EnumItems(TVI_ROOT);

	while(hItem)
		{
		i = m_pList->GetItemData(hItem);

		if(m_iMode&2)
				iVal = m_pList->GetCheck(hItem);
		else	iVal = m_pList->GetItemState(hItem,TVIS_SELECTED)&TVIS_SELECTED;

		if(i<m_iStrCount)
			{
			m_pStrText[i][TEXT_OFF] = iVal;
			if(iVal)m_iSelect=i;
			}

		hItem = m_pList->EnumItems(hItem);
		}


	if(m_iSelect>=0 && m_iSelect<m_iStrCount)
		{
		m_sText =           m_pStrText[m_iSelect]+1+TEXT_OFF;
		m_uData = *(DPARAM*)m_pStrText[m_iSelect];
		}
	else{
		m_sText = "";
		m_uData = 0;
		}



	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CColumnDlg::OnCancel()
{
CRect	 sRect;


	if(!m_bCancel)
		{
		return;
		}

	GetWindowRect(&sRect);
	m_iOldSizeX	= sRect.Width();
	m_iOldSizeY	= sRect.Height();
	m_iOldPosX	= sRect.left;
	m_iOldPosY	= sRect.top;
	m_bOldPos	= TRUE;
	m_bOldSize	= TRUE;


	m_sText   = _T("");
	m_iSelect = -1;

	CDialog::OnCancel();
}


//*****************************************************************************
//*
//*		OnSelNone
//*
//*****************************************************************************
void CColumnDlg::OnSelNone()
{
HTREEITEM	hItem;



	if(!(m_iMode&1))return;

	hItem = TVI_ROOT;

	for(;;)
		{
			hItem = m_pList->EnumItems(hItem);
		if(!hItem)break;

		if(m_iMode&2)
				m_pList->SetCheck(hItem,FALSE);
		else	m_pList->SetItemState(hItem,TVIS_SELECTED,0);
		}


}


//*****************************************************************************
//*
//*		OnSelAll
//*
//*****************************************************************************
void CColumnDlg::OnSelAll()
{
HTREEITEM	hItem;



	if(!(m_iMode&1))return;

	hItem = TVI_ROOT;

	for(;;)
		{
			hItem = m_pList->EnumItems(hItem);
		if(!hItem)break;

		if(m_iMode&2)
				m_pList->SetCheck(hItem,1);
		else	m_pList->SetItemState(hItem,TVIS_SELECTED,TVIS_SELECTED);
		}



}

//*****************************************************************************
//*
//*		OnDoCopy
//*
//*****************************************************************************
void CColumnDlg::OnDoCopy()
{
LPCTSTR		pText;


	if(!m_hCopyItem)return;

		pText = m_pList->GetItemText((HTREEITEM)m_hCopyItem,m_iCopyCol);
	if(!pText)return;


	SetClipboardText(pText);

}

//*****************************************************************************
//*
//*		OnRightClick
//*
//*****************************************************************************
void CColumnDlg::OnRightClick(NMHDR *pNmHdr,LRESULT *pResult)
{
UINT	uFlags;
CPoint	sPoint;
CPoint	sLocal;
CMenu	sMenu;



	GetCursorPos(&sPoint);

	sLocal = sPoint;

	m_pList->ScreenToClient(&sLocal);

	m_hCopyItem	= m_pList->HitTest(sLocal,&uFlags);;
	m_iCopyCol	= uFlags>>24;


	sMenu.CreatePopupMenu();
	sMenu.AppendMenu(MF_STRING,IDC_DO_COPY,LoadDefaultStrings(NULL,IDS_TEXT_COPYFIELD));

	if(m_iMode&0x20)
		{
		sMenu.AppendMenu(MF_STRING,ID_EDIT_CLEAR,LoadDefaultStrings(NULL,IDS_TEXT_CLEARLINE));
		}

	if(m_iMode&0x02)
		{
		sMenu.AppendMenu(MF_SEPARATOR);
		sMenu.AppendMenu(MF_STRING,IDC_SEL_ALL ,LoadDefaultStrings(NULL,IDS_TEXT_SELALL ));
		sMenu.AppendMenu(MF_STRING,IDC_SEL_NONE,LoadDefaultStrings(NULL,IDS_TEXT_SELNONE));
		}


	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();



}

//*****************************************************************************
//*
//*		SortProc0
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Namen
int CALLBACK CColumnDlg::SortProc(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iVal;
int				iRet;



	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR|TVIF_PARAM|TVIF_SUBITEM;
	sItem.hItem		 = hItem1;
	sItem.cChildren	 = m_bSortCol;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;
	iVal  = sItem.lParam;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR|TVIF_PARAM|TVIF_SUBITEM;
	sItem.hItem		 = hItem2;
	sItem.cChildren	 = m_bSortCol;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;

	iRet = stricmp_z(pPtr1,pPtr2);
	if(!iRet)iRet=iVal-sItem.lParam;


return (m_bSortDir)? -iRet:iRet;
}

//*****************************************************************************
//*
//*		OnColumnClick
//*
//*****************************************************************************
void CColumnDlg::OnColumnClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER	   *pHeader = (NMHEADER*)pNmHdr;
TVSORTEX		sSort;


	if(m_iMode&8)return;

	if(pHeader->iItem==m_bSortCol)
		{
		m_bSortDir  = !m_bSortDir;
		}
	else{
		m_bSortCol  = pHeader->iItem;
		m_bSortDir  = 0;
		}

	sSort.lpfnCompare	= SortProc;
	sSort.hParent		= TVI_ROOT;
    sSort.lParam		= (LPARAM)this;

	m_pList->SortChildrenEX(&sSort,1);


}


//*****************************************************************************
//*
//*		OnDblclkList
//*
//*****************************************************************************
void CColumnDlg::OnDoubleClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW	*pTree = (NMTREEVIEW*)pNmHdr;
int			 iNum;


	   iNum=pTree->itemNew.lParam;
	if(iNum<0 || iNum>=m_iStrCount)return;

	switch(m_iMode)
		{
	case 0:	OnOK();
			break;

	case 2:	m_pList->SetCheck(pTree->itemNew.hItem,TRUE);
			OnOK();
			break;
		}
}


//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
//	Sortiert die Listbox-Eintrge
//	pCompare	: Ist die Verleichsfunktion
//					ValueCompare
//					NameCompare
void CColumnDlg::Sort(int (__cdecl *pCompare)(const void*,const void*))
{
	qsort(m_pStrText,m_iStrCount,sizeof(m_pStrText),pCompare);
}

//*****************************************************************************
//*
//*		NameCompare
//*
//*****************************************************************************
//	Nach Namen sortieren
int __cdecl CColumnDlg::NameCompare(const void *pElem1, const void *pElem2)
{
LPTSTR	pName1,pName2;


	pName1 = *(LPTSTR*)pElem1;
	pName2 = *(LPTSTR*)pElem2;


return stricmp_z(pName1+1+TEXT_OFF,pName2+1+TEXT_OFF);
}


//*****************************************************************************
//*
//*		ValueCompare
//*
//*****************************************************************************
//	Nach Datenwerten sortieren
int __cdecl CColumnDlg::ValueCompare(const void *pElem1,const void *pElem2)
{
DPARAM	lVal1,lVal2;


	lVal1 = **(DPARAM**)pElem1;
	lVal2 = **(DPARAM**)pElem2;

	if(lVal1<lVal2)return -1;
	if(lVal1>lVal2)return  1;


return 0;
}



//*****************************************************************************
//*
//*		OnExitSize
//*
//*****************************************************************************
LRESULT CColumnDlg::OnExitSize(WPARAM wParam,LPARAM lParam)				
{																			

	if(m_bSized)														
		{																	
		m_bSized = 0;													
		RedrawWindow();														
		}																	

return 0;	
}



//*****************************************************************************
//*
//*		OnSizing
//*
//*****************************************************************************
void CColumnDlg::OnSizing(UINT nSide,LPRECT pRect)
{


	if(pRect->right-pRect->left<m_iSizeMinX)
		{
		if(nSide==WMSZ_BOTTOMLEFT ||
		   nSide==WMSZ_TOPLEFT 	  ||
		   nSide==WMSZ_LEFT)
			{
			pRect->left = pRect->right-m_iSizeMinX;
			}
		else{
			pRect->right = pRect->left+m_iSizeMinX;
			}
		}

	if(pRect->bottom-pRect->top<m_iSizeMinY)
		{
		if(nSide==WMSZ_TOPRIGHT ||
		   nSide==WMSZ_TOPLEFT  ||
		   nSide==WMSZ_TOP)
			{
			pRect->top = pRect->bottom-m_iSizeMinY;
			}
		else{
			pRect->bottom = pRect->top+m_iSizeMinY;
			}
		}

	m_bSized = TRUE;

}					  

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CColumnDlg::OnSize(UINT nType,int iSizeX,int iSizeY)
{
CRect	sRect;
CWnd   *pWnd;


	if(iSizeX<=0 || iSizeY<=0 || m_pList==0)return;

	sRect.left		= m_iFrameListX;
	sRect.right		= iSizeX-m_iFrameListX;
	sRect.top		= m_iFrameListY;
	sRect.bottom	= iSizeY-m_iFrameListZ;

	m_pList->MoveWindow(&sRect,TRUE);

	sRect.top		= iSizeY-m_iFrameBtY;
	sRect.bottom	= iSizeY-m_iFrameBtZ;

	if(!m_bCancel)
		{
		sRect.left		= (iSizeX-m_iSizeBtX)/2;
		sRect.right		= sRect.left+m_iSizeBtX;

		   pWnd = GetDlgItem(IDOK);
		if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

		return;
		}


	sRect.left		= (iSizeX-m_iSizeBtX*2-m_iFrameBtX)/2;
	sRect.right		= sRect.left+m_iSizeBtX;

	   pWnd=GetDlgItem(IDOK);
	if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

	sRect.left	   += m_iFrameBtX+m_iSizeBtX;
	sRect.right	   += m_iFrameBtX+m_iSizeBtX;

	   pWnd=GetDlgItem(IDCANCEL);
	if(pWnd)pWnd->MoveWindow(&sRect,TRUE);

}

//*****************************************************************************
//*
//*		AddColumn
//*
//*****************************************************************************
//	Einen neue Spalte einfgen
//	pText		: Ist die berschrift fr die Spalte
//	iWidth		: Ist die Breite der Spalte (negative Werte fr eine variable Breite)
//	bAlign		: Ist die Ausrichtung (0=link 1=rechts 2=zentriert)
//	bEdit		: Drfen Texte in der Spalte editiert werden
//	Ergibt die Position der Spalte, oder -1 bei einem Fehler
int CColumnDlg::AddColumn(LPCTSTR pText,int iWidth,BYTE bAlign,BOOL bEdit)
{
ColData	   *pNew;
int			iLen;


	ASSERT(m_iStrCount==0);

	if(m_iStrCount>0)return -1;							// Nur wenn alles leer ist Spalten einfgen

	if(m_iColumns>=m_iColumnsMax)
		{
		m_iColumnsMax += 8;
		pNew = new ColData[m_iColumnsMax];
		memcpy(pNew,m_pColData,sizeof(ColData)*m_iColumns);
		delete m_pColData;
		m_pColData = pNew;
		}


	iLen = strlen_z(pText)+1;

	m_pColData[m_iColumns].bEdit	= bEdit;
	m_pColData[m_iColumns].bAlign	= bAlign;
	m_pColData[m_iColumns].sSize	= iWidth;
	m_pColData[m_iColumns].pName	= new TCHAR[iLen];
	memcpy(m_pColData[m_iColumns].pName,pText,iLen*sizeof(TCHAR));

	m_iColumns++;


return m_iColumns-1;
}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Stellt einen Spaltentext der ersten Spalte ein.
//	iIndex		: Ist die Zeilennummer
//	pText		: Ist der Text
//	Ergibt TRUE wenn der Text eingefgt wurde
int CColumnDlg::SetText(int iIndex,LPCTSTR pText)
{
LPTSTR	pName;
LPTSTR	pLast;
int		iLen;


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;	// Prfe die Koodinaten

	iLen	= (int)strlen_z(pText)+1;
	pName	= new TCHAR[iLen+1+TEXT_OFF];
	pLast	= m_pStrText[iIndex];

	memcpy(pName+1+TEXT_OFF,pText,iLen*sizeof(TCHAR));
	*(DPARAM*)pName    = *(DPARAM*)pLast;
	m_pStrText[iIndex] = pName;
	delete pLast;



return TRUE;
}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Stellt einen Spaltentext ein
//	iIndex		: Ist die Zeilennummer
//	pText		: Ist der Text
//	iCol		: Ist die Spalte (1..N)
//	Ergibt TRUE wenn der Text eingefgt wurde
int CColumnDlg::SetText(int iIndex,LPCTSTR pText,int iCol)
{
LPTSTR	    pName;
ColData	   *pNew;
int			iLen;
int			iPos;


	if(iIndex<0 || iIndex>=m_iStrCount)return 0;	// Prfe die Koodinaten
	if(iCol <=0)return SetText(iIndex,pText);
	if(iCol >=m_iColumns)return 0;

	iLen	= (int)strlen_z(pText)+1;
	pName	= new TCHAR[iLen];
	memcpy(pName,pText,iLen*sizeof(TCHAR));

	for(iPos=0;iPos<m_iColText;iPos++)				// Spaltentexte suchen
		{
		if((WORD)m_pColText[iPos].sSize !=iIndex)continue;
		if(      m_pColText[iPos].bAlign!=iCol  )continue;

		delete m_pColText[iPos].pName;
		m_pColText[iPos].pName= pName;

		return 1;
		}


	if(m_iColText>=m_iColTextMax)					// Array mit Texten vergrern
		{
		m_iColTextMax += 32+m_iColTextMax/2;
		pNew = new ColData[m_iColTextMax];
		memcpy(pNew,m_pColText,sizeof(ColData)*m_iColText);
		delete m_pColText;
		m_pColText = pNew;
		}


	iLen = strlen_z(pText)+1;

	m_pColText[m_iColText].bAlign	= iCol;
	m_pColText[m_iColText].pName	= pName;
	m_pColText[m_iColText].sSize	= iIndex;


	m_iColText++;


return TRUE;
}

//*****************************************************************************
//*
//*		OnStartLabeEdit
//*
//*****************************************************************************
void CColumnDlg::OnStartLabeEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pNmTreeView = (NMTVDISPINFO*)pNmHdr;


	if(m_iColumns || !(m_iMode&0x80))return;

	*pResult = TVIR_EDITFULL;

}

//*****************************************************************************
//*
//*		OnEndLabelEdit
//*
//*****************************************************************************
void CColumnDlg::OnEndLabelEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pNmTreeView = (NMTVDISPINFO*)pNmHdr;
HTREEITEM		hItem;
LPCTSTR			pText;
int				iCol;
int				iRow;
int				iPos;


	if(!(pNmTreeView->item.mask&TVIF_TEXTCHANGED))
        {
        return;
        }

	iCol	= pNmTreeView->item.cChildren;
	iRow	= pNmTreeView->item.lParam;
	pText	= pNmTreeView->item.pszText;
	hItem	= pNmTreeView->item.hItem;

	if(iRow>=m_iStrCount)							// Einen neuen Text einfgen
		{
		if((m_iMode&0x10)==0 || !*pText)return;
		if((m_iMode&0x03)==1)m_pList->SetItemState(hItem,0,0,TVIS_SELECTED);
		iRow  = InsertString(m_iStrCount,m_iNewCode,(iCol)? Z(""):pText);
		hItem = m_pList->InsertItem(_T(""),TVI_ROOT,TVI_LAST,m_iStrCount);
		m_pList->SelectChilds(TVI_ROOT,TVIS_DESELECT);
		m_pList->SelectItem(hItem,iCol);
		if(!iCol)return;
		}


	SetText(iRow,pText,iCol);

	if(!*pText && (m_iMode&0x60)==0x60)				// Leere Zeile automatisch lschen
		{
		for(iPos=0;;iPos++)
			{
			if(iPos!=iCol)
				{
					pText=GetText(iRow,iPos);
				if(*pText)break;
				}

			if(iPos<=m_iColumns)
				{
				m_pList->SetFocusItem(hItem);
				OnDelete();
				break;
				}
			}
		}

}

//*****************************************************************************
//*
//*		OnKeyDownNotify
//*
//*****************************************************************************
void CColumnDlg::OnKeyDownNotify(NMHDR *pNmHdr,LRESULT *pResult)
{
TV_KEYDOWN_EX *pNotify = (TV_KEYDOWN_EX*)pNmHdr;


    if(pNotify->wVKey==VK_DELETE)
        {
        OnDelete();
        *pResult=1;
        }

}


//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CColumnDlg::OnDelete()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
int			iRow;
int			iPos;
int			iSet;


	if(!(m_iMode&0x20))return;

	hItem	= m_pList->GetFocusItem();
	hNext	= m_pList->GetNextSiblingItem(hItem);
	iRow	= m_pList->GetItemData(hItem);

	if(!hItem || iRow>=m_iStrCount || iRow<0)
		{
		return;
		}

	m_iStrCount--;									// Erste Spalte lschen
	delete m_pStrText[iRow];
	memmove(m_pStrText+iRow,m_pStrText+iRow+1,sizeof(LPTSTR)*(m_iStrCount-iRow));





	for(iPos=0;iPos<m_iColText;iPos++)				// Spaltentexte suchen
		{
		if((WORD)m_pColText[iPos].sSize>iRow)		// Zeile korrigieren
			{
			m_pColText[iPos].sSize--;
			continue;
			}

		if((WORD)m_pColText[iPos].sSize<iRow)
			{
			continue;
			}

		delete m_pColText[iPos].pName;

		m_iColText--;
		iSet  = iPos;
		break;
		}


	for(iPos++;iSet<m_iColText;iPos++)				// Spaltentexte umkopieren
		{
		if((WORD)m_pColText[iPos].sSize==iRow)
			{
			delete m_pColText[iPos].pName;
			m_iColText--;
			continue;
			}

		m_pColText[iSet] = m_pColText[iPos];

		if((WORD)m_pColText[iSet].sSize>iRow)		// Zeile korrigieren
			{
			m_pColText[iSet].sSize--;
			}

		iSet++;
		}


	if(!hNext)m_pList->GetPrevSiblingItem(hItem);
	m_pList->DeleteItem(hItem);
	m_pList->SelectItem(hNext);

	hItem = m_pList->EnumItems(TVI_ROOT);

	while(hItem)									// Referenzen in Zeilen korrigieren
		{
		iPos  = m_pList->GetItemData(hItem);
		if(iPos>iRow)m_pList->SetItemData(hItem,iPos-1);
		hItem = m_pList->EnumItems(hItem);
		}


}

