//*****************************************************************************
//*
//*
//*		AfxMacros.h
//*
//*
//*****************************************************************************
#ifndef		__AFXMACROS_H__
#define 	__AFXMACROS_H__

#if 		_MSC_VER >= 1000
#pragma 	once
#endif

#include	<afx.h>
#include	<afxadv.h>
#include	<afxpriv.h>
#include	<stddef.h>

#ifndef	   _WIN64
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr	SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr	GetWindowLong
#endif
#ifndef		SetClassLongPtr
#define		SetClassLongPtr		SetClassLong
#endif
#ifndef		GetClassLongPtr
#define		GetClassLongPtr		GetClassLong
#endif
#else
#ifdef		GWL_WNDPROC
#undef		GWL_WNDPROC
#endif
#define		GWL_WNDPROC			GWLP_WNDPROC
#ifdef		GWL_HINSTANCE
#undef		GWL_HINSTANCE
#endif
#define		GWL_HINSTANCE		GWLP_HINSTANCE
#ifdef		GWL_HWDPARENT
#undef		GWL_HWDPARENT
#endif
#define		GWL_HWDPARENT		GWLP_HWDPARENT
#ifdef		GWL_USERDATA
#undef		GWL_USERDATA
#endif
#define		GWL_USERDATA		GWLP_USERDATA
#ifdef		DWL_DLGPROC
#undef		DWL_DLGPROC
#endif
#define		DWL_DLGPROC			DWLP_DLGPROC
#endif

#ifndef		GET_X_LPARAM
#define		GET_X_LPARAM(lp)	((int)(short)LOWORD(lp))
#endif
#ifndef		GET_Y_LPARAM
#define		GET_Y_LPARAM(lp)	((int)(short)HIWORD(lp))
#endif

#ifndef	   _WIN64
#ifndef		DWORD_PTR
#define		DWORD_PTR			DWORD
#endif
#ifndef		ULONG_PTR
#define		ULONG_PTR			ULONG
#endif
#ifndef		LONG_PTR
#define		LONG_PTR			LONG
#endif
#ifndef		UINT_PTR
#define		UINT_PTR			UINT
#endif
#ifndef		INT_PTR
#define		INT_PTR				INT
#endif
#endif

#ifdef _DEBUG

#define ASSERT_PARAM1(expr,format,param1)				do { if (!(expr) && (1 == _CrtDbgReport(_CRT_ASSERT, __FILE__, __LINE__, NULL, format,param1              ))) _CrtDbgBreak(); } while (0)
#define ASSERT_PARAM2(expr,format,param1,param2)        do { if (!(expr) && (1 == _CrtDbgReport(_CRT_ASSERT, __FILE__, __LINE__, NULL, format,param1,param2       ))) _CrtDbgBreak(); } while (0)
#define ASSERT_PARAM3(expr,format,param1,param2,param3) do { if (!(expr) && (1 == _CrtDbgReport(_CRT_ASSERT, __FILE__, __LINE__, NULL, format,param1,param2,param3))) _CrtDbgBreak(); } while (0)

#else

#define ASSERT_PARAM1(expr,format,param1)
#define ASSERT_PARAM2(expr,format,param1,param2)
#define ASSERT_PARAM3(expr,format,param1,param2)

#endif

//*****************************************************************************
//*
//*		Monitor Funktionen
//*
//*****************************************************************************
//	GetDisplayRect(LPRECT pInRect,LPRECT pOutRect)		Monitor-Koordinaten auslesen
//						pInRect		= Koordinaten eines Fensters
//						pOutRect 	= Hier werden die Koordinaten des Monitors gespeichert
#if !defined WINVER || WINVER<0x0500
#define 	HMONITOR__	void*

typedef struct
	{
    DWORD   cbSize;
    RECT    rcMonitor;
    RECT    rcWork;
    DWORD   dwFlags;
	}MONITORINFO__;

extern "C" WINUSERAPI BOOL       WINAPI GetMonitorInfoA(HMONITOR__ hMonitor,MONITORINFO__ *pInfo);
extern "C" WINUSERAPI HMONITOR__ WINAPI MonitorFromRect(LPCRECT    pRect   ,DWORD          dwFlags);
#else
#define 	HMONITOR__		HMONITOR
#define 	MONITORINFO__	MONITORINFO
#endif

#define GetDisplayRect(pInRect,pOutRect)										\
		{																		\
		HMONITOR__		hMonitor;												\
		MONITORINFO__	sInfo;													\
																				\
		   hMonitor	= MonitorFromRect(pInRect,0);								\
		if(hMonitor	&& GetMonitorInfoA(hMonitor,&sInfo))						\
			{																	\
			*(pOutRect) = sInfo.rcMonitor;										\
			}																	\
		else{																	\
			(pOutRect)->top		= 0;											\
			(pOutRect)->left	= 0;											\
			(pOutRect)->right	= GetSystemMetrics(SM_CXSCREEN);				\
			(pOutRect)->bottom	= GetSystemMetrics(SM_CYSCREEN);				\
			}																	\
		}

//*****************************************************************************
//*
//*		Drop Funktionalitt fr ein Fenster
//*
//*****************************************************************************
//	Ermglicht Drops auf einem Fenster
//	#include	<AfxOle.h>				in	C___Wnd.h
//	#include	<AfxCmn.h>				in	C___Wnd.h
//	DECLARE_DROP_FUNC_MAIN(CWndClass)	in	C___Wnd.h vor der Klasse
//	DECLARE_DROP_FUNC     (CWndClass)	in	C___Wnd.h
//	DECLARE_DROP_FUNC[N]  (CWndClass)	in	C___Wnd.h fr N Subfenster
//	DROP_FUNC             (CWndClass)	in	C___Wnd.cpp
//	DROP_FUNC_ENTER		  (CWndClass)	in	C___Wnd.cpp fr OnDragEnter
//	DROP_FUNC_LEAVE		  (CWndClass)	in	C___Wnd.cpp fr OnDragLeave
//	DROP_FUNC_SCROLL	  (CWndClass)	in	C___Wnd.cpp fr OnDragScroll
//	DROP_FUNC_RENDER	  (CWndClass)	in	C___Wnd.cpp fr OnRenderData
//	DROP_FUNC_SIMPLE      (CWndClass)	in	C___Wnd.cpp	(statt DROP_FUNC ohne OnDragEnter+OnDragScroll+OnDragLeave)
//	DROP_FUNC_SIMPLE_EX   (CWndClass)	in	C___Wnd.cpp	(statt DROP_FUNC ohne OnDragEnter+OnDragScroll+OnDragLeave+OnRenderData)
//	DROP_FUNC_REGISTER()				in  C___Wnd.cpp bei OnCreate fr  Haupfenster this
//	DROP_FUNC_REGISTER[N](pWnd)			in  C___Wnd.cpp bei OnCreate frs Subfenster pWnd
//	DROP_FUNC_UNREGISTER()				in  C___Wnd.cpp bei OnDestroy oder im Destuktor
//	DROP_FUNC_UNREGISTER[N]()			in  C___Wnd.cpp bei OnDestroy oder im Destuktor
//
//	Folgende Funktionen in C___Wnd.cpp definieren (falls DROP_FUNC_SIMPLE
//
//		BOOL       CWndClass::OnRenderData(LPFORMATETC,LPSTGMEDIUM)
//		BOOL       CWndClass::OnDrop      (COleDataObject*,DROPEFFECT,CPoint)
//		DROPEFFECT CWndClass::OnDragEnter (COleDataObject*,DWORD     ,CPoint)
//		DROPEFFECT CWndClass::OnDragOver  (COleDataObject*,DWORD     ,CPoint)
//		DROPEFFECT CWndClass::OnDragScroll(                DWORD     ,CPoint)
//		void       CWndClass::OnDragLeave ()
//
//	Variablen
//
//		static CWndClass   *m_pDropTraget	Fenster ber dem der Drag schwebt (0=keiner)
//		CWnd			   *m_pDropWnd		Subfenster ber dem der Drag schwebt
//		unsigned			m_uDropMode		Aktueller Drop-Effekt (DROPEFFECT_????)
//		unsigned			m_uDropLock		Sperrt das Droppen aus ein Fenster
//
#define DECLARE_DROP_FUNC_MAIN(CWndClass)										\
	class CWndClass;															\
	class CDropTarget##CWndClass : public COleDropTarget						\
	{																			\
	virtual BOOL       OnDrop      (CWnd*,COleDataObject*,DROPEFFECT,CPoint);	\
	virtual DROPEFFECT OnDragEnter (CWnd*,COleDataObject*,DWORD     ,CPoint);	\
	virtual DROPEFFECT OnDragOver  (CWnd*,COleDataObject*,DWORD     ,CPoint);	\
	virtual DROPEFFECT OnDragScroll(CWnd*,                DWORD     ,CPoint);	\
	virtual void	   OnDragLeave (CWnd*);										\
	public:																		\
	CWndClass	  	  *m_pDropWnd;												\
	inline  HWND	   GetHwnd(){return m_hWnd;}								\
	inline  BOOL	   Register(CWnd *pView,CWnd *pWnd)							\
							{													\
							m_pDropWnd	= (CWndClass*)pView;					\
							return COleDropTarget::Register(pWnd);				\
							}													\
	inline  BOOL	   Register(CWnd *pView)									\
							{													\
							m_pDropWnd	= (CWndClass*)pView;					\
							return COleDropTarget::Register(pView);				\
							}													\
	};																			\
																				\
	class CDropData##CWndClass : public COleDataSource							\
	{																			\
	public:																		\
																				\
		CWndClass   *m_pDropWnd;												\
		CDropData##CWndClass(CWndClass *pWnd){m_pDropWnd=pWnd;}					\
		virtual BOOL OnRenderData(LPFORMATETC,LPSTGMEDIUM);						\
	};																			\


#define DECLARE_DROP_FUNC(CWndClass)											\
	static CWndClass       *m_pDropTraget;										\
	CDropTarget##CWndClass	m_sDropTarget1;										\
	CWnd				   *m_pDropWnd;											\
	unsigned				m_uDropMode;										\
	unsigned				m_uDropLock;										\
	BOOL		OnRenderData(LPFORMATETC,LPSTGMEDIUM);							\
	BOOL		OnDrop      (COleDataObject*,DROPEFFECT,CPoint);				\
	DROPEFFECT	OnDragEnter (COleDataObject*,DWORD     ,CPoint);				\
	DROPEFFECT	OnDragOver  (COleDataObject*,DWORD     ,CPoint);				\
	DROPEFFECT	OnDragScroll(                DWORD     ,CPoint);				\
	void		OnDragLeave ();													\
	inline void DropLock    (){m_uDropLock++;}									\
	inline void DropUnlock  (){if(m_uDropLock)m_uDropLock--;}					\
																				\
	friend	class	CDropTarget##CWndClass;										\
	friend	class	CDropData##CWndClass;										\

#define DROP_FUNC_ACTION()														\
	m_pDropWnd->m_pDropWnd        = pWnd;										\
	if(m_pDropWnd->m_uDropLock)													\
		{																		\
		m_pDropWnd->m_uDropMode   = DROPEFFECT_NONE;							\
		m_pDropWnd->m_pDropTraget = NULL;										\
		return DROPEFFECT_NONE;													\
		}																		\
	m_pDropWnd->m_pDropTraget	  = m_pDropWnd;


#define DROP_FUNC_EXIT()														\
	m_pDropWnd->m_pDropWnd        = pWnd;										\
	m_pDropWnd->m_pDropTraget	  = NULL;										\
	if(m_pDropWnd->m_uDropLock)return;


#define DROP_FUNC(CWndClass)													\
	CWndClass *CWndClass::m_pDropTraget;										\
	BOOL	   CDropData##CWndClass  ::OnRenderData(LPFORMATETC pFormatEtc,LPSTGMEDIUM pStgMedium){return m_pDropWnd->OnRenderData(pFormatEtc,pStgMedium);}																											\
	BOOL       CDropTarget##CWndClass::OnDrop      (CWnd *pWnd,COleDataObject *pDataObject,DROPEFFECT dEff ,CPoint sPoint){DROP_FUNC_ACTION();	m_pDropWnd->m_uDropMode=m_pDropWnd->OnDrop      (pDataObject,dEff      ,sPoint); return m_pDropWnd->m_uDropMode;}	\
	DROPEFFECT CDropTarget##CWndClass::OnDragEnter (CWnd *pWnd,COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint){DROP_FUNC_ACTION();	m_pDropWnd->m_uDropMode=m_pDropWnd->OnDragEnter (pDataObject,dwKeyState,sPoint); return m_pDropWnd->m_uDropMode;}	\
	DROPEFFECT CDropTarget##CWndClass::OnDragOver  (CWnd *pWnd,COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint){DROP_FUNC_ACTION();	m_pDropWnd->m_uDropMode=m_pDropWnd->OnDragOver  (pDataObject,dwKeyState,sPoint); return m_pDropWnd->m_uDropMode;}	\
	DROPEFFECT CDropTarget##CWndClass::OnDragScroll(CWnd *pWnd,                            DWORD dwKeyState,CPoint sPoint){DROP_FUNC_ACTION();	m_pDropWnd->m_uDropMode=m_pDropWnd->OnDragScroll(dwKeyState            ,sPoint); return m_pDropWnd->m_uDropMode;}	\
	void	   CDropTarget##CWndClass::OnDragLeave (CWnd *pWnd                                                           ){DROP_FUNC_EXIT  ();	                        m_pDropWnd->OnDragLeave ();}											 					\

#define DECLARE_DROP_FUNC1(CWndClass)											\
	DECLARE_DROP_FUNC(CWndClass)												\

#define DECLARE_DROP_FUNC2(CWndClass)											\
	CDropTarget##CWndClass	m_sDropTarget2;										\
	DECLARE_DROP_FUNC(CWndClass)												\

#define DECLARE_DROP_FUNC3(CWndClass)											\
	CDropTarget##CWndClass	m_sDropTarget2;										\
	CDropTarget##CWndClass	m_sDropTarget3;										\
	DECLARE_DROP_FUNC(CWndClass)												\

#define DECLARE_DROP_FUNC4(CWndClass)											\
	CDropTarget##CWndClass	m_sDropTarget2;										\
	CDropTarget##CWndClass	m_sDropTarget3;										\
	CDropTarget##CWndClass	m_sDropTarget4;										\
	DECLARE_DROP_FUNC(CWndClass)												\


#define DROP_FUNC_LEAVE(CWndClass)												\
	void       CWndClass::OnDragLeave(){m_uDropMode	= DROPEFFECT_NONE;}

#define DROP_FUNC_ENTER(CWndClass)												\
	DROPEFFECT CWndClass::OnDragEnter(COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint){return OnDragOver(pDataObject,dwKeyState,sPoint);}

#define DROP_FUNC_RENDER(CWndClass)												\
	BOOL CWndClass::OnRenderData(LPFORMATETC,LPSTGMEDIUM){return TRUE;}

#define DROP_FUNC_SIMPLE_EX(CWndClass)											\
	DROP_FUNC_RENDER(CWndClass)													\
	DROP_FUNC_SIMPLE(CWndClass)

#define DROP_FUNC_SCROLL(CWndClass)												\
	DROPEFFECT CWndClass::OnDragScroll(DWORD dwKeyState,CPoint sPoint){return m_uDropMode;}

#define DROP_FUNC_SIMPLE(CWndClass)												\
	DROP_FUNC_SCROLL(CWndClass)													\
	DROP_FUNC_ENTER(CWndClass)													\
	DROP_FUNC_LEAVE(CWndClass)													\
	DROP_FUNC(CWndClass)


#ifdef	_DEBUG
#define DROP_FUNC_CHECK()														\
			_AFX_THREAD_STATE *pState = AfxGetThreadState();					\
			ASSERT(pState->m_bNeedTerm);	// Wurde AfxOleInit() aufgerufen ?
#else
#define DROP_FUNC_CHECK()
#endif



#define DROP_FUNC_REGISTER()		{DROP_FUNC_CHECK();	m_uDropLock=0;m_uDropMode=DROPEFFECT_NONE; m_sDropTarget1.Register(this);		}
#define DROP_FUNC_REGISTER1(pWnd)	{DROP_FUNC_CHECK();	m_uDropLock=0;m_uDropMode=DROPEFFECT_NONE; m_sDropTarget1.Register(this,pWnd);	}
#define DROP_FUNC_REGISTER2(pWnd)	{DROP_FUNC_CHECK();	m_uDropLock=0;m_uDropMode=DROPEFFECT_NONE; m_sDropTarget2.Register(this,pWnd);	}
#define DROP_FUNC_REGISTER3(pWnd)	{DROP_FUNC_CHECK();	m_uDropLock=0;m_uDropMode=DROPEFFECT_NONE; m_sDropTarget3.Register(this,pWnd);	}
#define DROP_FUNC_REGISTER4(pWnd)	{DROP_FUNC_CHECK();	m_uDropLock=0;m_uDropMode=DROPEFFECT_NONE; m_sDropTarget4.Register(this,pWnd);	}

#define DROP_FUNC_UNREGISTER()		if(m_sDropTarget1.GetHwnd())m_sDropTarget1.Revoke();
#define DROP_FUNC_UNREGISTER1()		if(m_sDropTarget1.GetHwnd())m_sDropTarget1.Revoke();
#define DROP_FUNC_UNREGISTER2()		if(m_sDropTarget2.GetHwnd())m_sDropTarget2.Revoke();
#define DROP_FUNC_UNREGISTER3()		if(m_sDropTarget3.GetHwnd())m_sDropTarget3.Revoke();
#define DROP_FUNC_UNREGISTER4()		if(m_sDropTarget4.GetHwnd())m_sDropTarget4.Revoke();




//*****************************************************************************
//*
//*		Aktuelles Fenster Holen
//*
//*****************************************************************************
//	Holt das Fenster welches zum Dokument gehrt
//	Nur fr Single Fenster geeignet
//	Nur in C___Doc Funktionen brauchbar

#define GET_VIEW(View,Klasse)													\
		 {																		\
		 POSITION hViewPos=GetFirstViewPosition();								\
		 View=(Klasse*)GetNextView(hViewPos);									\
		 }

//*****************************************************************************
//*
//*		OnLoadLast
//*
//*****************************************************************************
//	Makro zum Laden der letzten Datei.
//	DECLARE_LOAD_LAST()					in	C___Doc.h
//	LOAD_LAST(CKlasse,CApp)				in	C___Doc.cpp
//	ON_COMMAND(ID_LOADLAST,OnLoadLast)	in	C___Doc.cpp
//	DECLARE_LOAD_LAST1()				in	C___App.h	im public Teil
//	LOAD_LAST1(CApp)					in	C___App.cpp
#define 	DECLARE_LOAD_LAST()	virtual	void OnLoadLast();
#define 	LOAD_LAST(CKlasse,CApp)												\
	void	CKlasse::OnLoadLast( )												\
	{																			\
	CString			 sTitle;													\
	CString			 *pName;													\
	CApp			 *pApp;														\
	CWnd			 *pWnd;														\
	int				  i;														\
																				\
	pApp  = (CApp*)AfxGetApp    ( );											\
	pWnd  = (CWnd*)AfxGetMainWnd( );	 										\
	pName =  pApp->GetRecentFile(0);											\
	if(!pName)return;															\
																				\
	   sTitle=GetPathName();													\
	i= sTitle.CompareNoCase(*pName); 											\
	if(i){pWnd->SendMessage(WM_COMMAND,ID_FILE_MRU_FILE1,0);return;}			\
	pName =pApp->GetRecentFile(1);												\
	if(!pName)return;															\
	pWnd->SendMessage(WM_COMMAND,ID_FILE_MRU_FILE2,0);							\
	}

#define 	DECLARE_LOAD_LAST1()	public:CString *GetRecentFile(int iNum=0);
#define 	LOAD_LAST1(CApp)													\
CString *CApp::GetRecentFile(int iNum)											\
	{																			\
	if(iNum<0)iNum=0;															\
	if(     m_pRecentFileList->GetSize()      <=iNum)return 0;					\
	if(   (*m_pRecentFileList)[iNum].GetLength()<= 0)return 0;					\
	return &m_pRecentFileList->m_arrNames[iNum];								\
	}


//*****************************************************************************
//*
//*		App-Message Funktionen  ( GetDocument() und GetView()
//*
//*****************************************************************************
//	WAPP_FUNC(CApp)		einfgen in C____App.cpp
//	DECLARE_WAPP_FUNC()	einfgen in C____App.h   im public Teil
//	CSingleDocTemplate* pDocTemplate	in InitInstance lschen

#define DECLARE_WAPP_FUNC()														\
				protected:														\
				CSingleDocTemplate *pDocTemplate;								\
				public:															\
				CDocument *GetDocument();										\
				CView     *GetView();

#define WAPP_FUNC(CAppClass)													\
			CDocument *CAppClass::GetDocument()									\
				{																\
				POSITION	hPos;												\
				CDocument  *pDoc;												\
				if(!pDocTemplate)return 0;										\
					hPos=pDocTemplate->GetFirstDocPosition();					\
				if(!hPos)return 0;												\
				return pDoc=pDocTemplate->GetNextDoc(hPos);						\
				}																\
			CView *CAppClass::GetView()											\
				{																\
				POSITION	hPos;												\
				CDocument  *pDoc;												\
				if(!pDocTemplate)return 0;										\
					hPos=pDocTemplate->GetFirstDocPosition();					\
				if(!hPos)return 0;												\
					pDoc=pDocTemplate->GetNextDoc(hPos);						\
				if(!pDoc)return 0;												\
					hPos=pDoc->GetFirstViewPosition();							\
				if(!hPos)return 0;												\
				return pDoc->GetNextView(hPos);									\
				}

//*****************************************************************************
//*
//*		MAKE_LONGFILENAME
//*
//*****************************************************************************
//	Prft in einer  CString Struktur den Dateinamen
//	und macht ihn zu einem LongFileName
//	Einsetzen in C___App.cpp nach ParseCommandLine(cmdInfo);
#define 	MAKE_LONGFILENAME(sName)											\
	{																			\
	int				iLen,iCnt,iPos;												\
	TCHAR			cBuffer[MAX_PATH+256],cPath[MAX_PATH+256];					\
	TCHAR		   *pName,*pPtr1,*pPtr2;										\
	WIN32_FIND_DATA sData; 														\
	HANDLE			sFind;														\
																				\
																				\
	iLen  = GetFullPathName(sName,sizeof(cBuffer)/sizeof(TCHAR),cBuffer,&pName);\
	iCnt  = _tcscspn(cBuffer	 ,_T("\\/"));									\
	iCnt += _tcsspn (cBuffer+iCnt,_T("\\/"));									\
	memcpy(cPath,cBuffer,iCnt*sizeof(TCHAR));									\
	pPtr1 = cBuffer+iCnt;														\
	pPtr2 = cPath  +iCnt;														\
																				\
	while(*pPtr1)																\
		{																		\
		iCnt=_tcscspn(pPtr1,_T("\\/"));											\
		memcpy(pPtr2, pPtr1,iCnt*sizeof(TCHAR));								\
		       pPtr2[ iCnt]=0;													\
																				\
		iPos=_tcscspn(pPtr2,_T("*?"));											\
		if(pPtr2[iPos])															\
			{																	\
		   _tcscpy(pPtr2,pPtr1);												\
			sName=cPath;														\
			break;																\
			}																	\
																				\
		   sFind=FindFirstFile(cPath,&sData);									\
 		if(sFind==INVALID_HANDLE_VALUE)		 									\
			{																	\
		   _tcscpy(pPtr2,pPtr1);												\
			sName=cPath;														\
			break;																\
			}																	\
																				\
		FindClose(sFind);														\
	   _tcscpy(pPtr2,sData.cFileName);											\
		pPtr2+=_tcslen(pPtr2);													\
		pPtr1+=iCnt;															\
		if(*pPtr1)																\
			{																	\
			pPtr1++;															\
			pPtr2[0]='\\';														\
			pPtr2++;															\
			continue;															\
			}																	\
		sName=cPath;															\
		break;																	\
		}																		\
	}


//*****************************************************************************
//*
//*		StatusBar - Funktionen
//*
//*****************************************************************************
//
//	STATUSBAR_PROC(CMainFrame)			Einfgen in MainFrame.cpp
//	STATUSBAR_PROC_EX(CMainFrame,Bar)	Einfgen in MainFrame.cpp wenn m_wndStatusBar nicht vorhanden ist
//	ON_STATUSBAR()						Einfgen in MainFrame.cpp
//	DECLARE_STATUSBAR_PROC()			Einfgen in MainFrame.h  im protected Teil
//	DECLARE_STATUSBAR_PROC_EX(Bar)		Einfgen in MainFrame.h  im protected Teil wenn m_wndStatusBar nicht vorhanden ist
//	static UINT indicators[]=
//		{
// 		ID_SEPARATOR,				// Statusleistenanzeige
// 		ID_INDICATOR_NUM,
//		};
//
//	Die Statusbar ist so aufgebaut:
//
//		STATUSBAR_POS aus indicators[] | n*lokale | n*gobale | Rest aus indicators[]
//
//	Lokale Fenster in die Statusbar einfgen:
//		UINT ids[n]={...}
//		UINT brt[n]={...}
//		STATUSBAR_INIT   (ids,brt,n);		Wenn brt[n] kleiner 0 dann Buchstaben verwenden
//		STATUSBAR_INIT_EX(ids,brt,n,ret);
//		STATUSBAR_SET   (0,"xxx",false);
//		STATUSBAR_SET_EX(1,"xxx",RGB(255,0,0),RGB(0,255,0),true);
//		STATUSBAR_COLOR (0,     ,RGB(255,0,0),RGB(0,255,0),true);
//
//	Lokale Fenster aus der  Statusbar entfernen:
//		STATUSBAR_INIT(0,0,0);
//
//	Globale Fenster in die Statusbar einfgen:
//		UINT ids[n]={...}
//		UINT brt[n]={...}
//		STATUSBAR_ADD(ids,brt,n,x);
//		STATUSBAR_SET   ((x>>16)  ,"xxx",false);
//		STATUSBAR_SET_EX((x>>16)-1,"xxx",RGB(255,0,0),RGB(0,255,0),true);
//		STATUSBAR_COLOR ((x>>16)-1,     ,RGB(255,0,0),RGB(0,255,0),true);
//
//	Globale Fenster aus der  Statusbar entfernen:
//		STATUSBAR_DEL(x);
//
//	StatusbarInit(UINT *pId=0,UINT *pSize=0,int iCnt=-1);
//			Stellt fr die CView eine iCnt an Fenstern ein. (lokal)
//			pId   : Ist ein Zeiger auf ein Feld mit den ID-Eintrgen
//			pSize : Ist ein Zeiger auf ein Feld mit Breiten
//			iCnt  : Ist die Anzahl der Eintrge im Feld
//			(bei -1 automatische Anzahl ermitteln, bis pId[iCnt]==0)
//			Zum Entfernen der StatusbarInit(0,0,0); aufrufen
//			Zum Anzeigen StatusbarSet(iNum,"xxx",-1,-1,true) aufrufen
//			iNum ist die Indexnummer (von 0 bis n-1)
//			Alternative : STATUSBAR_INIT(a,b,c)
//			Achtung !   : Das Fenster AfxGetMainWnd() muss gltig sein.
//
//	StatusbarAdd(UINT *pId=0,UINT *pSize=0,int iCnt=-1);
//			Hngt iCnt von Fenstern an die Statusbar an. (global)
//			Ergibt die Registrierungs ID in die Anzeigenummer
//			pId	  : Ist ein Zeiger auf ein Feld mit den ID-Eintrgen
//					   Bit 0-15  iNum= Bit 16-31 (iNum=XXX>>16)
//			pSize : Ist ein Zeiger auf ein Feld mit Breiten
//			iCnt  : Ist die Anzahl der Eintrge im Feld
//			Anzeigen  : STATUSBAR_SET(Nummer,"xxx",true)
//			Entfernen : StatusbarDel(pId); aufrufen
//			Alernative:	STATUSBAR_ADD(a,b,c)
//			Achtung ! :	Das Fenster AfxGetMainWnd() muss gltig sein.
//
//	StatusbarDel(int iId);
//			Lscht die iId-Fenster in der StatusBar (global)
//			Ergibt die Anzahl der gelschen pId's
//			Alernative:	STATUSBAR_DEL(a)
//			Achtung ! :	Das Fenster AfxGetMainWnd() muss gltig sein.
//
//	StatusbarSet(int iNum,char *pText,int iBkColor,int iTextColor,BOOL bUpdate);
//			Statusbar-Text fr iNum setzen.
//			Wenn die Farbe iBkColor und iTextColor -1 sind werden
//			keine speziellen Farben verwendet
//			Wenn iNum<0 werden die globalen Felder gesetzt
//			Alernative:	STATUSBAR_SET(a,b,c)
//			Achtung ! :	Das Fenster AfxGetMainWnd() muss gltig sein.
//
//	StatusbarColor(int iNum,int iBkColor,int iTextColor,BOOL bUpdate);
//			Statusbar-Farbe fr iNum setzen.
//			Wenn die Farbe iBkColor und iTextColor -1 sind werden
//			keine speziellen Farben verwendet
//			Wenn iNum<0 werden die globalen Felder gesetzt
//			Achtung ! :	Das Fenster AfxGetMainWnd() muss gltig sein.
//
#ifndef		STATUSBAR_ITEMS
#define 	STATUSBAR_ITEMS	indicators
#endif
#ifndef		STATUSBAR_POS
#define 	STATUSBAR_POS	1
#endif
#ifndef		STB_DRAWITEM
#define 	STB_DRAWITEM	(WM_USER+0x123)
#endif
#ifndef		STB_MESSAGE
#define 	STB_MESSAGE		(WM_USER+0x124)
#endif
#ifdef	   _DEBUG
#define 	STB_CHECK		1
#else
#define 	STB_CHECK		0
#endif
#define 	STB_INIT		0
#define 	STB_SET			1
#define 	STB_DEL			2
#define 	STB_ADD			3
#define 	STB_COLOR		4
#define 	ON_STATUSBAR()		ON_MESSAGE(STB_MESSAGE,OnStatusbarMsg)			\
								{STB_DRAWITEM,0,0,0,AfxSig_lwl,(AFX_PMSG)(AFX_PMSGW)(LRESULT (AFX_MSG_CALL CWnd::*)(WPARAM, LPARAM))&OnStatusBarDraw},


#define 	STATUSBAR_INIT(pItemsX,pSizeX,iCnt)									\
				{																\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					struct														\
						{														\
						int *pItems;											\
						int *pSize;												\
						int	 iCount;											\
						}sMsg;													\
					sMsg.pItems = (int*)pItemsX;								\
					sMsg.pSize  = (int*)pSizeX;									\
					sMsg.iCount = iCnt;											\
					pWnd->SendMessage(STB_MESSAGE,STB_INIT,(LPARAM)&sMsg);		\
					}															\
				}

#define 	STATUSBAR_INIT_EX(pItemsX,pSizeX,iCnt,iRet)							\
				{																\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					struct														\
						{														\
						UINT *pItems;											\
						UINT *pSize;											\
						int	  iCount;											\
						}sMsg;													\
					sMsg.pItems=pItemsX;sMsg.pSize=pSizeX;sMsg.iCount=iCnt;		\
					iRet=pWnd->SendMessage(STB_MESSAGE,STB_INIT,(LPARAM)&sMsg);	\
					}															\
				else{															\
					iRet = 0;													\
					}															\
				}

#define 	STATUSBAR_ADD(pItemsX,pSizeX,iCnt,iRet)								\
				{																\
				iRet=0;															\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					struct														\
						{														\
						UINT *pItems;											\
						UINT *pSize;											\
						int	  iCount;											\
						}sMsg;													\
					sMsg.pItems=pItemsX;sMsg.pSize=pSizeX;sMsg.iCount=iCnt;		\
					iRet=pWnd->SendMessage(STB_MESSAGE,STB_ADD,(LPARAM)&sMsg);	\
					}															\
				}

#define 	STATUSBAR_DEL(iId)													\
				{																\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					pWnd->SendMessage(STB_MESSAGE,STB_DEL,iId);					\
					}															\
				}

#define 	STATUSBAR_SET(iId,pTxt,bUpdat)										\
				{																\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					struct														\
						{														\
						int		   *pItems;										\
						LPCTSTR		pText;										\
						BOOL        bUpdate;									\
						int			iParam1;									\
						int			iParam2;									\
						}sMsg;													\
					sMsg.pItems  = (int*)(iId);									\
					sMsg.pText   = pTxt;										\
					sMsg.bUpdate = bUpdat;										\
					sMsg.iParam1 = -1;											\
					sMsg.iParam2 = -1;											\
					pWnd->SendMessage(STB_MESSAGE,STB_SET,(LPARAM)&sMsg);		\
					}															\
				}

#define 	STATUSBAR_SET_EX(iId,pTxt,iColBk,iColText,bUpdat)					\
				{																\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					struct														\
						{														\
						int		   *pItems;										\
						LPCTSTR		pText;										\
						BOOL        bUpdate;									\
						int			iParam1;									\
						int			iParam2;									\
						}sMsg;													\
					sMsg.pItems  = (int*)(iId);									\
					sMsg.pText   = pTxt;										\
					sMsg.bUpdate = bUpdat;										\
					sMsg.iParam1 = iColBk;										\
					sMsg.iParam2 = iColText;									\
					pWnd->SendMessage(STB_MESSAGE,STB_SET,(LPARAM)&sMsg);		\
					}															\
				}

#define 	STATUSBAR_COLOR(iId,iColBk,iColText,bUpdat)							\
				{																\
				CWnd  *pWnd=AfxGetMainWnd();									\
				if(pWnd && IsWindow(pWnd->m_hWnd))								\
					{															\
					struct														\
						{														\
						int		   *pItems;										\
						LPCTSTR		pText;										\
						BOOL        bUpdate;									\
						int			iParam1;									\
						int			iParam2;									\
						}sMsg;													\
					sMsg.pItems  = (int*)(iId);									\
					sMsg.pText   = 0;											\
					sMsg.bUpdate = bUpdat;										\
					sMsg.iParam1 = iColBk;										\
					sMsg.iParam2 = iColText;									\
					pWnd->SendMessage(STB_MESSAGE,STB_COLOR,(LPARAM)&sMsg);		\
					}															\
				}



#define 	DECLARE_STATUSBAR_PROC()	DECLARE_STATUSBAR_PROC_EX(m_wndStatusBar)
#define 	DECLARE_STATUSBAR_PROC_EX(m_wndStatusBar)							\
	typedef struct																\
		{																		\
		int    *pItems;															\
		int	   *pSize;															\
		int		iCount;															\
		int		iParam1;														\
		int		iParam2;														\
		}StatusbarMsg;															\
	typedef struct																\
		{																		\
		int		iBkColor;														\
		int		iTextColor;														\
		int		iLength;														\
		TCHAR	cText[1];														\
		}StatusbarInfo;															\
	public:																		\
		int StatusbarSet  (int   iNum,LPCTSTR pText,int iBkColor=-1,int iTextColor=-1,BOOL bUpdate=true);	\
		int StatusbarColor(int   iNum,              int iBkColor   ,int iTextColor=-1,BOOL bUpdate=true);	\
		int StatusbarDel  (int   iItem                               );			\
		int StatusbarAdd  (int  *pItem  ,int *pMetrics=0,int iCount=0);			\
		int StatusbarInit (int  *pItem=0,int *pMetrics=0,int iCount=0);			\
	protected:																	\
		afx_msg void    OnStatusBarDraw(CStatusBar*pBar,LPDRAWITEMSTRUCT pDraw);\
		afx_msg LRESULT OnStatusbarMsg(WPARAM,LPARAM);							\
		static  LRESULT CALLBACK StatusbarProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);	\
		static  VOID	StatusbarWidth(int *pMetrics,int iCount);				\
		static  WNDPROC pOldStatusbarProc;										\
		static	int		m_iStatusbarWidth;										\
		static  int		m_iStatusbarInit;										\
		int				m_iStatusbarCnt;										\
		int				m_iStatusbarAdd;										\
		int				m_iStatusbarNum;										\
		int				m_aStatusbarItems[32];	 								\
	public:																		\

#define 	STATUSBAR_PROC(CMainFrame)	STATUSBAR_PROC_EX(CMainFrame,m_wndStatusBar)
#define 	STATUSBAR_PROC_EX(CMainFrame,m_wndStatusBar)						\
	WNDPROC CMainFrame::pOldStatusbarProc=0;									\
	int		CMainFrame::m_iStatusbarWidth=0;									\
	int		CMainFrame::m_iStatusbarInit=0;										\
																				\
	VOID CMainFrame::StatusbarWidth(int *pMetrics,int iCount)					\
		{																		\
		LOGFONT	sLog;															\
		int		iPos;															\
																				\
		if(m_iStatusbarWidth==0)												\
			{																	\
			m_iStatusbarWidth = -7;												\
			if(SystemParametersInfo(SPI_GETICONTITLELOGFONT,sizeof(sLog),&sLog,0))							\
			   {																\
					if(sLog.lfWidth    )m_iStatusbarWidth= sLog.lfWidth;		\
			   else if(sLog.lfHeight   )m_iStatusbarWidth=(sLog.lfHeight*2)/3;	\
			   if(m_iStatusbarWidth>  0)m_iStatusbarWidth=-m_iStatusbarWidth;	\
			   if(m_iStatusbarWidth<-25)m_iStatusbarWidth=-25;					\
			   }																\
			}																	\
																				\
		for(iPos=0;iPos<iCount;iPos++)											\
			{																	\
			if(pMetrics[iPos]>=0)continue;										\
			pMetrics[iPos] *= m_iStatusbarWidth;								\
			}																	\
		}																		\
																				\
	LRESULT CALLBACK CMainFrame::StatusbarProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)				\
		{																		\
		StatusbarInfo  *pInfo;													\
		unsigned		uCount;													\
		unsigned		uType;													\
		unsigned		uPos;													\
																				\
		if(uMsg==WM_DESTROY)													\
			{																	\
			uCount = CallWindowProc(pOldStatusbarProc,hWnd,SB_GETPARTS,0,0);	\
			for(uPos=0;uPos<uCount;uPos++)										\
				{																\
				uType = (unsigned      )(CallWindowProc(pOldStatusbarProc,hWnd,SB_GETTEXTLENGTH,uPos,0));	\
				if(HIWORD(uType)==(SBT_OWNERDRAW|SBT_POPOUT))									\
					{															\
					pInfo = (StatusbarInfo*)(CallWindowProc(pOldStatusbarProc,hWnd,SB_GETTEXT  ,uPos,0));	\
					if(HIWORD(uType)&SBT_OWNERDRAW)delete pInfo;				\
					}															\
				}																\
			}																	\
																				\
		return CallWindowProc(pOldStatusbarProc,hWnd,uMsg,wParam,lParam);		\
		}																		\
																				\
	int CMainFrame::StatusbarSet(int iNum,LPCTSTR pText,int iBkColor,int iTextColor,BOOL bUpdate)			\
		{																		\
		StatusbarInfo  *pInfo;													\
		StatusbarInfo  *pData;													\
		DWORD			uType;													\
		DWORD			uLen;													\
		if(m_iStatusbarInit!=0x12345678)return 0;								\
		if(IsWindow(m_wndStatusBar.m_hWnd)==0)return 0;							\
		if(iNum<0)iNum+=m_wndStatusBar.GetCount()-sizeof(STATUSBAR_ITEMS)/		\
				sizeof(UINT)+STATUSBAR_POS;										\
		else	iNum       +=STATUSBAR_POS;										\
		if(iNum<0 || iNum>=m_wndStatusBar.GetCount())return 0;					\
		uType = (DWORD)         (m_wndStatusBar.GetStatusBarCtrl().SendMessage(SB_GETTEXTLENGTH,iNum,0));	\
		pInfo = (StatusbarInfo*)(m_wndStatusBar.GetStatusBarCtrl().SendMessage(SB_GETTEXT      ,iNum,0));	\
																				\
		if(SendMessage(WM_MENUICON_EXIST)!=0x12345678)							\
			{																	\
			static BOOL bDone=0;												\
			if(STB_CHECK && !bDone && (iBkColor>=0 || iTextColor))				\
				{																\
				bDone = TRUE;													\
				MessageBox("DECLARE_MENUICON_PROC() must be defined in MainFrm.h for colors in the statusbar !","Error",MB_OK|MB_ICONERROR);\
				}																\
			iBkColor	= -1;													\
			iTextColor	= -1;													\
			}																	\
																				\
		if(iBkColor>=0 || iTextColor>=0)										\
			{																	\
			if(!pOldStatusbarProc)												\
				{																\
				pOldStatusbarProc = (WNDPROC)GetWindowLongPtr(m_wndStatusBar.m_hWnd,GWL_WNDPROC);	\
				SetWindowLongPtr(m_wndStatusBar.m_hWnd,GWL_WNDPROC,(LPARAM)StatusbarProc);			\
				}																\
			uLen	= _tcslen(pText);											\
			pData	= (StatusbarInfo*)new char[sizeof(StatusbarInfo)+sizeof(TCHAR)*uLen];	\
			pData->iBkColor		= iBkColor;										\
			pData->iTextColor	= iTextColor;									\
			pData->iLength		= uLen;											\
			memcpy(pData->cText,pText,sizeof(TCHAR)*(uLen+1));					\
			m_wndStatusBar.GetStatusBarCtrl().SetText((LPCTSTR)pData,iNum,SBT_OWNERDRAW|SBT_POPOUT);	\
			}																	\
		else{																	\
			m_wndStatusBar.SetPaneText(iNum,pText,bUpdate);						\
			}																	\
																				\
		if(HIWORD(uType)&SBT_OWNERDRAW)delete pInfo;							\
		return 1;																\
		}																		\
																				\
	int CMainFrame::StatusbarColor(int iNum,int iBkColor,int iTextColor,BOOL bUpdate)		\
		{																		\
		StatusbarInfo  *pInfo;													\
		StatusbarInfo  *pData;													\
		LPCTSTR			pText;													\
		TCHAR			aText[256];												\
		DWORD			uType;													\
		DWORD			uLen;													\
		if(m_iStatusbarInit!=0x12345678)return 0;								\
		if(IsWindow(m_wndStatusBar.m_hWnd)==0)return 0;							\
		if(iNum<0)iNum+=m_wndStatusBar.GetCount()-sizeof(STATUSBAR_ITEMS)/		\
				sizeof(UINT)+STATUSBAR_POS;										\
		else	iNum       +=STATUSBAR_POS;										\
		if(iNum<0 || iNum>=m_wndStatusBar.GetCount())return 0;					\
		uType = (DWORD)         (m_wndStatusBar.GetStatusBarCtrl().SendMessage(SB_GETTEXTLENGTH,iNum,0));	\
		pInfo = (StatusbarInfo*)(m_wndStatusBar.GetStatusBarCtrl().SendMessage(SB_GETTEXT      ,iNum,0));	\
																				\
		if(SendMessage(WM_MENUICON_EXIST)!=0x12345678)							\
			{																	\
			static BOOL bDone=0;												\
			if(STB_CHECK && !bDone && (iBkColor>=0 || iTextColor))				\
				{																\
				bDone = TRUE;													\
				MessageBox("DECLARE_MENUICON_PROC() must be defined in MainFrm.h for colors in the statusbar !","Error",MB_OK|MB_ICONERROR);\
				}																\
			return 0;															\
			}																	\
																				\
		if(HIWORD(uType)&SBT_OWNERDRAW)											\
			{																	\
			pText = pInfo->cText;												\
			uLen  = pInfo->iLength;												\
			if(iBkColor  ==pInfo->iBkColor)										\
			if(iTextColor==pInfo->iTextColor)return 1;							\
			}																	\
		else{																	\
			if(iBkColor<0 && iTextColor<0)return 1;								\
			pText = aText;														\
			uLen  = LOWORD(uType);												\
			if(uLen<256)m_wndStatusBar.GetStatusBarCtrl().SendMessage(SB_GETTEXT,iNum,(LPARAM)aText);	\
			else	{aText[0]=0;uLen=0;}										\
			}																	\
																				\
		if(iBkColor>=0 || iTextColor>=0)										\
			{																	\
			if(!pOldStatusbarProc)												\
				{																\
				pOldStatusbarProc = (WNDPROC)GetWindowLongPtr(m_wndStatusBar.m_hWnd,GWL_WNDPROC);	\
				SetWindowLongPtr(m_wndStatusBar.m_hWnd,GWL_WNDPROC,(LPARAM)StatusbarProc);			\
				}																\
			uLen	= _tcslen(pText);											\
			pData	= (StatusbarInfo*)new char[sizeof(StatusbarInfo)+sizeof(TCHAR)*uLen];	\
			pData->iBkColor		= iBkColor;										\
			pData->iTextColor	= iTextColor;									\
			pData->iLength		= uLen;											\
			memcpy(pData->cText,pText,sizeof(TCHAR)*(uLen+1));					\
			m_wndStatusBar.GetStatusBarCtrl().SetText((LPCTSTR)pData,iNum,SBT_OWNERDRAW|SBT_POPOUT);	\
			}																	\
		else{																	\
			m_wndStatusBar.SetPaneText(iNum,pText,bUpdate);						\
			}																	\
																				\
		if(HIWORD(uType)&SBT_OWNERDRAW)delete pInfo;							\
		return 1;																\
		}																		\
																				\
	int CMainFrame::StatusbarAdd(int *pItem,int *pMetrics,int iCnt)				\
		{																		\
		int		i,j,iLen,iMax;													\
		int		aSize[32];														\
		UINT	aMode[32];														\
		UINT	aList[32];														\
																				\
		if(m_iStatusbarInit!=0x12345678)return 0;								\
		   iMax=sizeof(STATUSBAR_ITEMS)/sizeof(UINT);							\
		   iLen=m_wndStatusBar.m_nCount;										\
		if(iLen<=iMax)															\
			{																	\
			m_iStatusbarNum = 2;												\
			m_iStatusbarCnt = 0;												\
			m_iStatusbarAdd = STATUSBAR_POS;									\
			memset(m_aStatusbarItems,0,sizeof(m_aStatusbarItems));				\
			}																	\
		if (!pItem)iCnt=0;														\
		if (iCnt<=-1)															\
		for(iCnt=0;iCnt<8;iCnt++)if(!pItem[iCnt])break;							\
		if (iCnt+iLen-m_iStatusbarCnt>24)										\
			iCnt=24-(iLen-m_iStatusbarCnt-iMax);								\
		if (iCnt<=0)return -1;													\
		StatusbarWidth(pMetrics,iCnt);											\
		for(i=0;i<m_iStatusbarAdd;i++)											\
			m_wndStatusBar.GetPaneInfo(i,aList[i],aMode[i],aSize[i]);			\
		memmove(m_aStatusbarItems+i+iCnt,m_aStatusbarItems+i,(iLen-i)*sizeof(int));	\
		for(j=0;j<iCnt;i++,j++)													\
			{																	\
			m_aStatusbarItems[i]=m_iStatusbarNum;								\
			aList[i]=pItem[j];													\
			aSize[i]=(pMetrics)? pMetrics[j]:50;								\
			aMode[i]=SBPS_NORMAL;												\
			}																	\
		for(j=m_iStatusbarAdd;j<iLen;i++,j++)									\
			m_wndStatusBar.GetPaneInfo(j,aList[i],aMode[i],aSize[i]);			\
		m_wndStatusBar.SetIndicators(aList,i);									\
		for(j=0;j<i;j++)														\
			m_wndStatusBar.SetPaneInfo(j,aList[j],aMode[j],aSize[j]);			\
		i=m_iStatusbarNum;														\
		m_iStatusbarNum++;														\
		if(m_iStatusbarNum>0xFFFF)m_iStatusbarNum=2;							\
		return i|((m_iStatusbarAdd-iLen-iCnt+iMax-STATUSBAR_POS)<<16);			\
		}																		\
																				\
	int CMainFrame::StatusbarInit(int *pItem,int *pMetrics,int iCnt)			\
		{																		\
		int		i,j,z,iLen,iMax;												\
		int		aSize[32];														\
		UINT	aMode[32];														\
		UINT	aList[32];														\
		CString sText[32];														\
																				\
		if(!IsWindow(m_wndStatusBar.m_hWnd))return 0;							\
		   m_iStatusbarInit=0x12345678;											\
		   iMax=sizeof(STATUSBAR_ITEMS)/sizeof(UINT);							\
		   iLen=m_wndStatusBar.m_nCount;										\
		if(iLen<=iMax)															\
			{																	\
			m_iStatusbarNum=2;													\
			m_iStatusbarCnt=0;													\
			m_iStatusbarAdd=STATUSBAR_POS;										\
			memset(m_aStatusbarItems,0,sizeof(m_aStatusbarItems));				\
			}																	\
		if (!pItem)iCnt=0;														\
		if (iCnt>  8)iCnt=8;													\
		if (iCnt<=-1)															\
		for(iCnt=0;iCnt<8;iCnt++)if(!pItem[iCnt])break;							\
		if (iCnt>  0)StatusbarWidth(pMetrics,iCnt);								\
		for(i=0;i<STATUSBAR_POS;i++)											\
			m_wndStatusBar.GetPaneInfo(i,aList[i],aMode[i],aSize[i]);			\
		memmove(m_aStatusbarItems+m_iStatusbarAdd,								\
				m_aStatusbarItems+m_iStatusbarAdd+iCnt,							\
				(iLen-m_iStatusbarAdd)*sizeof(int));							\
		for(j=0;j<iCnt;i++,j++)													\
			{																	\
			m_aStatusbarItems[i]=1;												\
			aList[i]=pItem[j];													\
			aSize[i]=(pMetrics)? pMetrics[j]:50;								\
			aMode[i]=SBPS_NORMAL;												\
			}																	\
		z = m_iStatusbarAdd;													\
		    m_iStatusbarAdd = i;												\
		    m_iStatusbarCnt = iCnt;												\
		for(j=z;j<iLen;i++,j++)													\
			{																	\
			m_wndStatusBar.GetPaneInfo(j,aList[i],aMode[i],aSize[i]);			\
			m_wndStatusBar.GetPaneText(j,sText[i]);								\
			}																	\
		m_wndStatusBar.SetIndicators(aList,i);									\
		for(j=0;j<i;j++)														\
			{																	\
			m_wndStatusBar.SetPaneInfo(j,aList[j],aMode[j],aSize[j]);			\
			m_wndStatusBar.SetPaneText(j,sText[j]);								\
			}																	\
		return iCnt;															\
		}																		\
																				\
	int CMainFrame::StatusbarDel(int iItem)										\
		{																		\
		int		i,j,iLen,iMax;													\
		int		aSize[32];														\
		UINT	aMode[32];														\
		UINT	aList[32];														\
																				\
		if(m_iStatusbarInit!=0x12345678)return 0;								\
		   iItem&=0xFFFF;														\
		   iMax=sizeof(STATUSBAR_ITEMS)/sizeof(UINT);							\
		   iLen=m_wndStatusBar.m_nCount;										\
		if(iLen<=iMax)															\
			{																	\
			m_iStatusbarNum =2;													\
			m_iStatusbarCnt=0;													\
			m_iStatusbarAdd=STATUSBAR_POS;										\
			memset(m_aStatusbarItems,0,sizeof(m_aStatusbarItems));				\
			}																	\
		if(!::IsWindow(m_wndStatusBar.m_hWnd))return 0;							\
		for(i=0;i<m_iStatusbarAdd;i++)											\
			m_wndStatusBar.GetPaneInfo(i,aList[i],aMode[i],aSize[i]);			\
		for(j=i;j<iLen;j++)														\
			{																	\
			if(iItem==m_aStatusbarItems[j])continue;							\
			m_wndStatusBar.GetPaneInfo(j,aList[i],aMode[i],aSize[i]);			\
			i++;																\
			}																	\
		m_wndStatusBar.SetIndicators(aList,i);									\
		for(j=0;j<i;j++)														\
			{																	\
			m_wndStatusBar.SetPaneInfo(j,aList[j],aMode[j],aSize[j]);			\
			}																	\
		return j;																\
		}																		\
																				\
	LRESULT CMainFrame::OnStatusbarMsg(WPARAM pProc,LPARAM lParam)				\
		{																		\
		StatusbarMsg *pMsg=(StatusbarMsg*)lParam;								\
		switch(pProc)															\
				{																\
		case STB_INIT:  return StatusbarInit (pMsg->pItems,pMsg->pSize,pMsg->iCount);		\
		case STB_ADD:   return StatusbarAdd  (pMsg->pItems,pMsg->pSize,pMsg->iCount);		\
		case STB_DEL:   return StatusbarDel  (pProc);							\
		case STB_SET:   return StatusbarSet  ((int)pMsg->pItems,(TCHAR*)pMsg->pSize,pMsg->iParam1,pMsg->iParam2,pMsg->iCount);\
		case STB_COLOR: return StatusbarColor((int)pMsg->pItems,                    pMsg->iParam1,pMsg->iParam2,pMsg->iCount);\
				}																\
		return 1;																\
		}																		\
																				\
	void CMainFrame::OnStatusBarDraw(CStatusBar *pBar,LPDRAWITEMSTRUCT pDraw)	\
		{																		\
		StatusbarInfo  *pInfo;													\
		int				iPosX;													\
		int				iPosY;													\
		HDC				hDc;													\
																				\
		pInfo   = (StatusbarInfo*)(m_wndStatusBar.SendMessage(SB_GETTEXT,pDraw->itemID,NULL));		\
		hDc		=  pDraw->hDC;													\
		iPosX	= (pDraw->rcItem.right +pDraw->rcItem.left)/2;					\
		iPosY	= (pDraw->rcItem.bottom-1);										\
																				\
		SetBkColor  (hDc,(pInfo->iBkColor  <0)? GetSysColor(COLOR_MENU      ):pInfo->iBkColor  );	\
		SetTextColor(hDc,(pInfo->iTextColor<0)? GetSysColor(COLOR_WINDOWTEXT):pInfo->iTextColor);	\
		SetTextAlign(hDc,TA_CENTER|TA_BOTTOM);									\
		ExtTextOut(hDc,iPosX,iPosY,ETO_OPAQUE|ETO_CLIPPED,&pDraw->rcItem,pInfo->cText,pInfo->iLength,NULL);\
		}
																				\

//*****************************************************************************
//*
//*		Positions - Funktionen
//*
//*****************************************************************************
//
//	ON_WM_DESTROY()						Einfgen in MainFrame.cpp
//	DECLARE_LAST_PLACE()				Einfgen in MainFrame.h  im protected Teil
//	LAST_PLACE(CMainFrame)				Einfgen in MainFrame.cpp am Anfang in den globalen Teil
//	LAST_PLACE_GET()					Einfgen in MainFrame.cpp am Anfang von CMainFrame::OnDestroy()
//	LAST_PLACE_SET(&sData)				Einfgen in MainFrame.cpp am Anfang von CMainFrame::PreCreateWindow(CREATESTRUCT &sData)
#define 	DECLARE_LAST_PLACE()												\
	BOOL			SetLastPlace(LPCREATESTRUCT pCreate);						\
	void			GetLastPlace();

#define 	LAST_PLACE_GET()		GetLastPlace();
#define 	LAST_PLACE_SET(pPtr)	SetLastPlace(pPtr);
#define 	LAST_PLACE(CMainFrame)												\
	void CMainFrame::GetLastPlace()												\
	{																			\
	int			iLastSizeX;														\
	int			iLastSizeY;														\
	int			iLastPosX;														\
	int			iLastPosY;														\
	int			iIsZoomed;														\
	int			iMonitor;														\
	CRect		sRect;															\
	CRegKeys	sKey;															\
																				\
	GetWindowRect(&sRect);														\
																				\
	iLastPosX		= sRect.left;												\
	iLastPosY		= sRect.top;												\
	iLastSizeX		= sRect.Width();											\
	iLastSizeY		= sRect.Height();											\
	iIsZoomed		= IsZoomed();												\
	iMonitor		= MonitorOfWindow(this);									\
																				\
	sKey.Open();																\
	sKey.Up("Settings");														\
	sKey.Set(iIsZoomed ,"IsZoomed");											\
																				\
	if(!iIsZoomed)																\
		{																		\
		sKey.Set(iLastPosX ,"LastPosX");										\
		sKey.Set(iLastPosY ,"LastPosY");										\
		sKey.Set(iLastSizeX,"LastSizeX");										\
		sKey.Set(iLastSizeY,"LastSizeY");										\
		}																		\
																				\
	if(MonitorCount()>1)														\
		{																		\
		sKey.Set(iMonitor,"LastMonitor");										\
		}																		\
	}																			\
																				\
	BOOL CMainFrame::SetLastPlace(LPCREATESTRUCT pCreate)						\
	{		   																	\
	CWinApp	   *pApplication;													\
	static int	iLastDone=0;													\
	int			iLastSizeX;														\
	int			iLastSizeY;														\
	int			iLastPosX;														\
	int			iLastPosY;														\
	int			iIsZoomed;														\
	int			iMonitor;														\
	CRegKeys	sKey;															\
																				\
																				\
	MonitorInit();																\
																				\
	   pApplication = AfxGetApp();												\
	if(pApplication->m_nCmdShow!=SW_NORMAL)										\
		{																		\
		return TRUE;															\
		}																		\
																				\
	if(iLastDone || !pCreate->lpszName)											\
		{																		\
		return FALSE;															\
		}																		\
																				\
	iIsZoomed		= FALSE;													\
	iMonitor		= 0;														\
	iLastDone		= 1;														\
	iLastPosX		= 0;														\
	iLastPosY		= 0;														\
	iLastSizeX		= 0;														\
	iLastSizeY		= 0;														\
																				\
	sKey.Open();																\
	sKey.Up("Settings");														\
																				\
	if(!sKey.Get(iIsZoomed ,"IsZoomed"))										\
		{																		\
		return FALSE;															\
		}																		\
																				\
	sKey.Get(iLastPosX ,"LastPosX");											\
	sKey.Get(iLastPosY ,"LastPosY");											\
	sKey.Get(iLastSizeX,"LastSizeX");											\
	sKey.Get(iLastSizeY,"LastSizeY");											\
	sKey.Get(iMonitor  ,"LastMonitor");											\
																				\
	if(iIsZoomed)																\
		{																		\
		pApplication->m_nCmdShow = SW_MAXIMIZE;									\
		}																		\
																				\
	if(MonitorFrameCheck(iMonitor,iLastPosX,iLastPosY,iLastSizeX,iLastSizeY))	\
		{																		\
		pCreate->x		= iLastPosX;											\
		pCreate->y		= iLastPosY;											\
		pCreate->cx		= iLastSizeX;											\
		pCreate->cy		= iLastSizeY;											\
		}																		\
																				\
	if(MonitorOfRect(pCreate)!=iMonitor)										\
		{																		\
		MonitorMove(pCreate,iMonitor,1);										\
		}																		\
																				\
	return TRUE;																\
	}																			\


//*****************************************************************************
//*
//*		MenIcon - Funktionen
//*
//*****************************************************************************
//
//	MENUICON_PROC(CMainFrame)			Einfgen in MainFrame.cpp
//	MENUICON_PROC_EX(CMainFrame,Bar)	Einfgen in MainFrame.cpp wenn m_wndStatusBar nicht vorhanden ist
//	ON_MENUICON()						Einfgen in MainFrame.cpp
//	ON_MENUICON_MODE()					Einfgen in MainFrame.cpp (falls ID_MENUICON_MODE vorhanden ist)
//	ON_STATUSBARDRAW()					Einfgen in MainFrame.cpp (fr Owner-Draw Statusbar)
//	DECLARE_MENUICON_PROC()				Einfgen in MainFrame.h  im protected Teil
//	DECLARE_MENUICON_PROC_EX(Bar)		Einfgen in MainFrame.h  im protected Teil wenn m_wndStatusBar nicht vorhanden ist
//	MenuIconsInit(IDR_MAINFRAME);		Einfgen in MainFrame.cpp am Ende von CMainFrame::OnCreate
//
//	MenuIconsInit(WORD wIdToolbar)
//		Ld die Icons fr die Mens aus einer Toolbar.
//		wIdToolbar	: ID der Toolbar
//		Ergibt 1 wenn die Icons geladen wurde.
//
//	MenuIconsFind(WORD wItem,CMenu **pSub=0,int *pIndex=0)
//		Sucht das MENUDATA Feld zu einer Men-ID.
//		wItem		: ID des Meneintrages
//		pSub		: Hier wird das Submen gespeichert in dem das Mengefunden wude.
//		Ergibt einen Zeiger auf das Feld oder 0 wenn die ID nicht gefunden wurde.
//
//	MenuIconsGet(WORD wItem)
//		Holt das eingestellte Icon fr einen Meneintrag.
//		wItem		: ID des Meneintrages
//		Ergibt die Icon-Nummer bzw. -1 wenn kein Icon eingestellt ist.
//
//	MenuIconsSet(WORD wItem,int iIcon)
//		Stellt das Icon fr einen Meneintrag ein.
//		wItem		: ID des Meneintrages
//		iIcon		: Ist die Iconnummer (-1=kein Icon)
//		Ergibt TRUE wenn das Icon eingestellt wurde.
//
//	MenuIconsSetText(WORD wItem,LPCTSTR pText)
//		ndert den Text eines Meneintrages
//		wItem		: ID des Meneintrages
//		pText		: Ist der neue Text fr den Eintrag.
//					  Wenn er mit '\t' beginnt wird nur der
//					  Tastenanhang gendert.
//		Ergibt 0 wenn der Eintrag nicht gefunden wurde, 1 wenn alles gleich
//		bleibt und 2 wenn der Text gendert wurde.
//
//	MenuIconDelete(UINT uItem)
//		Lscht ein Men aus der Menleiste des Hauptfensters.  (globale Funktion)
//		uItem		: ID des Mens
//		Ergibt TRUE wenn das Icon gelscht wurde.
//
//	MenuIconInsert(UINT uItem,CMenu *pNew,LPCTSTR pText,int iPos-2)
//		Fgt ein Men in die Menleiste des Hauptfensters ein. (globale Funktion)
//		uItem		: ID des Mens
//		pNew		: Zeiger auf Submen mit den einzufgenden Eintrgen.
//		pText		: Name fr das Men
//		iPos		: Ist die Einfgeposition (<0 ist von rechts gezhlt)
//		Ergibt TRUE wenn das Icon gelscht wurde.
//
//	MenuIconsAdd(WORD wItem,HICON    hIcon)
//	MenuIconsAdd(WORD wItem,UINT	 uResId,COLORREF uMask)
//	MenuIconsAdd(WORD wItem,LPCTSTR  pResId,COLORREF uMask)
//	MenuIconsAdd(WORD wItem,CBitmap *pImage,COLORREF uMask)
//		Fgt ein Icon fr die Mens ein.
//		wItem		: ID des Meneintrages (0xFFFF fr keine Zuweisung)
//		hIcon		: Icon das eingefgt werden soll.
//		uResId		: ID des Bildes in den Resourcen
//		pResId		: Resourcenname des Bildes
//		pImage		: Bild das eingefgt werden soll
//		uMask		: Transparente Farbe des Bildes
//		Ergibt die Position des eingefgten Bildes.
//
//	Message-Funktion fr  Owner-Draw fr die Statusbar:
//		void CMainFrame::OnStatusBarDraw(CStatusBar *pBar,LPDRAWITEMSTRUCT pDraw)
//			{
//			...
//			}
//
#ifndef   	WM_MENUICON_SETTEXT
#define 	WM_MENUICON_SETTEXT	0x5E95
#endif
#ifndef   	WM_MENUICON_DETACH
#define 	WM_MENUICON_DETACH	0x5E96
#endif
#ifndef   	WM_MENUICON_EXIST
#define 	WM_MENUICON_EXIST	0x5E97
#endif
#ifndef   	CMF_MAXICONS
#define 	CMF_MAXICONS		512
#endif
#ifndef   	CMF_ICONSPACE
#define 	CMF_ICONSPACE		4
#endif
#ifndef   	CMF_MENUTEXT
#define 	CMF_MENUTEXT		64
#endif
#ifndef		CMF_DRAWITEM
#define 	CMF_DRAWITEM		(WM_USER+0x193)
#endif

int			MenuIconsSetText(WORD wItem,LPCTSTR pText);

#define 	ON_MENUICON()		ON_WM_DRAWITEM() 	ON_WM_MEASUREITEM()		ON_WM_INITMENUPOPUP()	ON_MESSAGE(WM_MENUICON_DETACH,OnMenuIconDetach) ON_MESSAGE(WM_MENUICON_DETACH,OnMenuIconSetText) ON_MESSAGE(WM_MENUICON_EXIST,OnMenuIconExist)
#define 	ON_MENUICON_MODE()	ON_COMMAND(ID_MENUICON_MODE,OnMenuIconMode)	ON_UPDATE_COMMAND_UI(ID_MENUICON_MODE,OnMenuIconModeUI)
#define		ON_STATUSBARDRAW()	{CMF_DRAWITEM,0,0,0,AfxSig_lwl,(AFX_PMSG)(AFX_PMSGW)(LRESULT (AFX_MSG_CALL CWnd::*)(WPARAM, LPARAM))&OnDrawStatusBar},
#define 	DECLARE_MENUICON_PROC()	DECLARE_MENUICON_PROC_EX(m_wndStatusBar)
#define 	DECLARE_MENUICON_PROC_EX(m_wndStatusBar)							\
	afx_msg LRESULT OnMenuIconExist	 (WPARAM wParam,LPARAM lParam);				\
	afx_msg LRESULT	OnMenuIconDetach (WPARAM wParam,LPARAM lParam);				\
	afx_msg LRESULT OnMenuIconSetText(WPARAM wParam,LPARAM lParam);				\
	afx_msg void	OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT pDraw);				\
	afx_msg void 	OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT pItemStruct);	\
	afx_msg void 	OnInitMenuPopup(CMenu *pMenu,UINT nIndex,BOOL bSysMenu);	\
	afx_msg void 	OnMenuIconModeUI(CCmdUI *pCmdUI);							\
	afx_msg void 	OnMenuIconMode();											\
																				\
	TCHAR		m_aItemText[CMF_MENUTEXT*(ID_FILE_MRU_LAST-ID_FILE_MRU_FIRST+1)];	\
	WORD		m_aIconIds [CMF_MAXICONS];										\
	int			m_iIconCount;													\
	static BOOL	m_bMenuMode;													\
																				\
	typedef struct 															   	\
		{																	   	\
		TCHAR	cText[CMF_MENUTEXT];										   	\
		int		iTabPos;													   	\
		WORD	wIconNumber;												   	\
		WORD	wHeight;													   	\
		WORD	wWidth;														   	\
		WORD	wTab;														   	\
		}MENUDATA;															   	\
																			   	\
	typedef struct															   	\
		{																	   	\
		WORD	wVersion;													   	\
		WORD	wWidth;														   	\
		WORD	wHeight;													   	\
		WORD	wItemCount;													   	\
		WORD	aItems[1];													   	\
		}TOOLBAR;															   	\
																			   	\
	int			m_iIconWidth;												   	\
	int			m_iIconHeight;												   	\
	CFont	    m_sMenuFont;												   	\
	CImageList  m_cMenuImages;												   	\
	CImageList  m_cGrayImages;												   	\
	HPEN		m_hMenuPen1;												   	\
	HPEN		m_hMenuPen2;												   	\
	HPEN		m_hMenuPen3;												   	\
	HPEN		m_hMenuPen4;												   	\
																				\
	public:																		\
																				\
	MENUDATA   *MenuIconsFind   (WORD   wItem,CMenu **pSub=0,int *pIndex=0);	\
	int 		MenuIconsGet    (WORD   wItem               );					\
	int 		MenuIconsSet    (WORD   wItem,int      iIcon);					\
	int			MenuIconsAdd    (WORD   wItem,HICON    hIcon);					\
	int			MenuIconsAdd    (WORD   wItem,CBitmap *pImage,COLORREF uMask=RGB(192,192,192));	\
	int			MenuIconsSetText(WORD   wItem,LPCTSTR  pText);					\
	int			MenuIconsInit   (WORD  *pIdToolbars,int iCount=1);				\
	int			MenuIconsAttach (CMenu *pMenu,int iIndex,LPCTSTR pText,UINT uItem,CDC *pDc=0);	\
	BOOL		MenuIconsDetach (CMenu *pMenu,int iIndex);						\
																				\
	protected:																	\
																				\
	void		MenuIconsUpdateSize(CMenu *pMenu,int iMaxTab);					\
	int  		MenuIconsCalc(LPCTSTR pText,int &iWidth,int &iSize,int &iTab,CDC *pDc=0); \
																				\
	inline int	MenuIconsInit(WORD wIdToolbar)									\
		{																		\
		return  MenuIconsInit(&wIdToolbar,1);									\
		}																		\
																				\
	inline int	MenuIconsInit(WORD wIdToolbar1,WORD wIdToolbar2,WORD wIdToolbar3=0,WORD wIdToolbar4=0)	\
		{																		\
		WORD	aIds[4];														\
																				\
		aIds[0] = wIdToolbar1;													\
		aIds[1] = wIdToolbar2;													\
		aIds[2] = wIdToolbar3;													\
		aIds[3] = wIdToolbar4;													\
																				\
		return  MenuIconsInit(aIds,4);											\
		}																		\
																				\
	inline int	MenuIconsAdd(WORD wItem,LPCTSTR pResId,COLORREF uMask=RGB(192,192,192))	\
		{																		\
		CBitmap sImage; 														\
		sImage .LoadBitmap(pResId);												\
		return  MenuIconsAdd(wItem,&sImage,uMask);								\
		}																		\
																				\
	inline  int	MenuIconsAdd(WORD wItem,UINT uResId,COLORREF uMask=RGB(192,192,192))	\
		{																		\
		CBitmap sImage; 														\
		sImage .LoadBitmap(uResId);												\
		return  MenuIconsAdd(wItem,&sImage,uMask);								\
		}

#define 	MENUICON_PROC(CMainFrame)	MENUICON_PROC_EX(CMainFrame,m_wndStatusBar)
#define 	MENUICON_PROC_EX(CMainFrame,m_wndStatusBar)						   	\
																				\
	BOOL	CMainFrame::m_bMenuMode=1;											\
																				\
	int	CMainFrame::MenuIconsInit(WORD *pIdToolbars,int iCount)					\
	{																		   	\
	CBitmap				sImage;													\
	CWindowDC			sTestDc(NULL);										   	\
	CRect				sRect(0,0,0,0);										   	\
	CFont			   *pOldFont;											   	\
	CMenu			   *pSubMenu;											   	\
	CMenu			   *pFrameMenu;											   	\
	INT					iMenuIndex;											   	\
	INT					iSubIndex;											   	\
	NONCLIENTMETRICS	sInfo;												   	\
	LPVOID				pPixels;												\
	LPBITMAPINFO		pBitmap;												\
	MENUITEMINFO		sMenuInfo;											   	\
	HMENU				aSubMenu [64];											\
	TCHAR				cMenuText[CMF_MENUTEXT];							   	\
	HRSRC				hTbRes;												   	\
	HGLOBAL 			hTbGlobal;											   	\
	TOOLBAR			   *pTbData;											   	\
	WORD				wIdToolbar;												\
	int					iTextWidth;											   	\
	int					iSubCount;												\
	int					iEntries;												\
	int					iIgnore;												\
	int					iMaxTab;											   	\
	int					iItems;													\
	int					iNum;													\
	int					i;													   	\
																			   	\
																				\
		for(i=0,m_iIconCount=0;i<iCount;i++)									\
			{																	\
				wIdToolbar = pIdToolbars[i];									\
			if(!wIdToolbar)break;												\
																			   	\
				hTbRes=FindResource(NULL,MAKEINTRESOURCE(wIdToolbar),RT_TOOLBAR);  	\
			if(!hTbRes)break;												   	\
																			   	\
																			   	\
			hTbGlobal  = LoadResource(NULL,hTbRes);								\
			pTbData	   = (TOOLBAR*)LockResource(hTbGlobal);						\
																			   	\
			ASSERT(pTbData);												   	\
			ASSERT(pTbData->wVersion==1);										\
																			   	\
																				\
			if(i==0)															\
				{																\
				m_iIconWidth  = pTbData->wWidth;								\
				m_iIconHeight = pTbData->wHeight;								\
				m_cGrayImages.Create(m_iIconWidth,m_iIconHeight,ILC_COLORDDB|ILC_MASK,pTbData->wItemCount,8);	\
				m_cMenuImages.Create(m_iIconWidth,m_iIconHeight,ILC_COLORDDB|ILC_MASK,pTbData->wItemCount,8);	\
				}																\
																				\
			sImage.LoadBitmap(wIdToolbar);										\
			ASSERT(pTbData->wWidth ==m_iIconWidth );							\
			ASSERT(pTbData->wHeight==m_iIconHeight);							\
			m_cMenuImages.Add(&sImage,RGB(192,192,192));   						\
			sImage.DeleteObject();												\
																				\
			sImage.LoadBitmap(wIdToolbar);										\
			pBitmap=GetDibOfResource(NULL,NULL,MAKEINTRESOURCE(wIdToolbar),RT_BITMAP,DIB_CREATE_BITMAP,&pPixels);	\
			DibConvertGrayScale(pBitmap,pPixels,RGB(223,223,223),RGB(192,192,192));\
			ASSERT(pTbData->wWidth ==m_iIconWidth );							\
			ASSERT(pTbData->wHeight==m_iIconHeight);							\
			m_cGrayImages.Add(CBitmap::FromHandle(DibGetBitmap(pBitmap)),RGB(192,192,192));	\
			DibFreeHandle(pBitmap);												\
																				\
			for(iNum=0;iNum<pTbData->wItemCount;iNum++)							\
				{																\
				if(pTbData->aItems[iNum]==0)continue;							\
				if(m_iIconCount>=CMF_MAXICONS)break;							\
				m_aIconIds[m_iIconCount] = pTbData->aItems[iNum];				\
				m_iIconCount++;													\
				}																\
																				\
			UnlockResource(hTbGlobal);										   	\
			DeleteObject  (hTbRes);											   	\
			sImage.DeleteObject();												\
			}																	\
																				\
		if(!m_iIconCount)return 0;												\
																				\
																			   	\
		m_hMenuPen1  = CreatePen(PS_SOLID,2,RGB(  0,128,  0));				   	\
		m_hMenuPen2  = CreatePen(PS_SOLID,1,RGB(  0,255,  0));				   	\
		m_hMenuPen3  = CreatePen(PS_SOLID,2,RGB(128,128,128));				   	\
		m_hMenuPen4  = CreatePen(PS_SOLID,1,RGB(222,222,222));				   	\
		sInfo.cbSize = offsetof(NONCLIENTMETRICS,lfMessageFont);				\
		sInfo.cbSize+= sizeof(LOGFONT);											\
																				\
		SystemParametersInfo(SPI_GETNONCLIENTMETRICS,sizeof(sInfo), &sInfo, 0);	\
		m_sMenuFont.CreateFontIndirect(&sInfo.lfMenuFont);					   	\
		 																	   	\
		iIgnore	     = 0;														\
		iSubCount    = 0;													   	\
		pFrameMenu   = GetMenu() ;											   	\
		pOldFont     = sTestDc.SelectObject(&m_sMenuFont);					   	\
		iEntries	 = pFrameMenu->GetMenuItemCount();							\
																				\
																				\
		for(iMenuIndex=0;iMenuIndex<iEntries;iMenuIndex++)						\
			{																   	\
			if(iIgnore)															\
				{																\
				iIgnore  = 0;													\
				}																\
			else{																\
				pSubMenu = pFrameMenu->GetSubMenu(iMenuIndex);					\
				iMaxTab	 = 0;													\
				if(!pSubMenu)continue;											\
				}																\
																				\
			iItems = pSubMenu->GetMenuItemCount();								\
																			   	\
			for(iSubIndex=0;iSubIndex<iItems;iSubIndex++)						\
				{															   	\
				sMenuInfo.cbSize		= sizeof(sMenuInfo);				   	\
				sMenuInfo.fMask			= MIIM_DATA|MIIM_TYPE|MIIM_ID|MIIM_SUBMENU;	\
				sMenuInfo.dwTypeData	= cMenuText;						   	\
				sMenuInfo.cch			= CMF_MENUTEXT;							\
				GetMenuItemInfo(*pSubMenu,iSubIndex,TRUE,&sMenuInfo);		   	\
																				\
				if(sMenuInfo.hSubMenu)											\
					{															\
					if(iSubCount<sizeof(aSubMenu)/sizeof(aSubMenu[0]))			\
						{														\
						aSubMenu[iSubCount] = sMenuInfo.hSubMenu;				\
						iSubCount++;											\
						}														\
																				\
					continue;													\
					}															\
																			   	\
				if(sMenuInfo.fType!=MFT_STRING)								   	\
					{															\
					sMenuInfo.dwItemData	 = 0;								\
					sMenuInfo.fMask 		 = MIIM_TYPE;			   			\
					sMenuInfo.fType			|= MFT_OWNERDRAW;					\
					SetMenuItemInfo(*pSubMenu,iSubIndex,TRUE,&sMenuInfo);		\
					continue;												   	\
					}															\
																			   	\
				if(sMenuInfo.wID>=ID_FILE_MRU_FIRST)						   	\
				if(sMenuInfo.wID<=ID_FILE_MRU_LAST )							\
					{															\
					continue;												   	\
					}															\
																				\
				iTextWidth = MenuIconsAttach(pSubMenu,iSubIndex,cMenuText,sMenuInfo.wID,&sTestDc);	\
				if(iMaxTab<iTextWidth)iMaxTab=iTextWidth;					   	\
				}															   	\
																			   	\
			iMaxTab+=16;													   	\
																				\
			MenuIconsUpdateSize(pSubMenu,iMaxTab);							 	\
																				\
			while(iSubCount>0)													\
				{																\
				iSubCount--;													\
				pSubMenu = CMenu::FromHandle(aSubMenu[iSubCount]);			   	\
				if(pSubMenu){iMenuIndex--;iIgnore=1;break;}						\
				}																\
			}																   	\
																			   	\
																				\
																				\
		sTestDc.SelectObject(pOldFont);										   	\
																			   	\
																			   	\
																			   	\
	return 1;																   	\
	}																		   	\
																			   	\
	void CMainFrame::OnDrawItem(int nIDCtl,LPDRAWITEMSTRUCT pDraw)				\
	{																			\
	COLORREF		uBkColor;													\
	COLORREF		uBkColorSel;												\
	COLORREF		uBkColorSex;												\
	COLORREF		uTextColorS;												\
	COLORREF		uTextColorG;												\
	COLORREF		uTextColorC;												\
	COLORREF		uTextColor;													\
	CBrush			sBackBrush;												   	\
	LPCTSTR		    pText;														\
	LPCTSTR		    pTabText;													\
	MENUDATA       *pMenuData;												   	\
	CDC			   *pDC;													   	\
	CRect			sRect;														\
	CRect			sFill;														\
	LRESULT			uData;														\
	POINT		    sPoint;													   	\
	UINT			wState;													   	\
	UINT	 		wAction;												   	\
	int 	 		nWidth;													   	\
	int 	 		nHeight;												   	\
	int				iTextLen;													\
	int				iMode;														\
																				\
		if(m_bMenuMode)															\
			{																	\
			uBkColor	 = GetSysColor(COLOR_WINDOW);							\
			uBkColorSel	 = GetSysColor(COLOR_HIGHLIGHT);						\
			uBkColorSel  = ((uBkColorSel&0xFEFEFE)>>1)+((uBkColor&0xFEFEFE)>>1);\
			uBkColorSex  = ((uBkColorSel&0xFEFEFE)>>1)+((GetSysColor(COLOR_HIGHLIGHT)&0xFEFEFE)>>1);	\
			uTextColor   = GetSysColor(COLOR_GRAYTEXT);							\
			uTextColorG  = ((uBkColor  &0xFCFCFC)>>2)+((uTextColor&0xFCFCFC)>>2)*3;	\
			uTextColorS  = ((uTextColor&0xFCFCFC)>>2)+((uBkColor  &0xFCFCFC)>>2)*3;	\
			uTextColorC  = GetSysColor(COLOR_CAPTIONTEXT);						\
			uTextColor   = GetSysColor(COLOR_MENUTEXT);							\
			}																	\
		else{																	\
			uBkColor	 = GetSysColor(COLOR_MENU);								\
			uBkColorSel	 = GetSysColor(COLOR_HIGHLIGHT);						\
			uBkColorSex	 = GetSysColor(COLOR_HIGHLIGHT);						\
			uTextColorS	 = GetSysColor(COLOR_WINDOW);							\
			uTextColorG  = GetSysColor(COLOR_GRAYTEXT);							\
			uTextColorC	 = GetSysColor(COLOR_CAPTIONTEXT);						\
			uTextColor   = GetSysColor(COLOR_MENUTEXT);							\
			}																	\
																			   	\
		if(nIDCtl==AFX_IDW_STATUS_BAR)										   	\
			{																	\
			wState = (DWORD)(m_wndStatusBar.GetStatusBarCtrl().SendMessage(SB_GETTEXTLENGTH,pDraw->itemID,0));	\
			if(HIWORD(wState)&SBT_POPOUT)										\
					SendMessage(STB_DRAWITEM,(WPARAM)&m_wndStatusBar,(LPARAM)pDraw);	\
			else	SendMessage(CMF_DRAWITEM,(WPARAM)&m_wndStatusBar,(LPARAM)pDraw);	\
			return;																\
			}																	\
																				\
		uData	  = pDraw->itemData;											\
		if(uData&1)uData--;														\
		pMenuData = (MENUDATA*)uData;									   		\
		pDC		  = CDC::FromHandle(pDraw->hDC);								\
		wState    = pDraw->itemState;							   				\
		wAction   = pDraw->itemAction;							   				\
		nWidth    = pDraw->rcItem.right -pDraw->rcItem.left;					\
		nHeight   = pDraw->rcItem.bottom-pDraw->rcItem.top;						\
																			   	\
																				\
		sRect	  = pDraw->rcItem;							   					\
		sRect.right = sRect.left+m_iIconWidth+CMF_ICONSPACE;					\
																				\
		switch(pDraw->itemAction)												\
			{																   	\
		case ODA_SELECT:													   	\
																				\
		case ODA_DRAWENTIRE:												   	\
																				\
        																	   	\
			if((wState&ODS_SELECTED) && !(wState&ODS_DISABLED))				   	\
					pDC->SetBkColor(uBkColorSex);								\
			else	pDC->SetBkColor(GetSysColor(COLOR_MENU));					\
																				\
			pDC->ExtTextOut(0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);					\
																			   	\
			sFill.top	 = sRect.top; 											\
			sFill.left   = sRect.right;											\
			sFill.right  = pDraw->rcItem.right;									\
			sFill.bottom = sRect.bottom;										\
																				\
			if((wState&ODS_SELECTED) && !(wState&ODS_DISABLED))				   	\
					pDC->SetBkColor(uBkColorSel);								\
			else	pDC->SetBkColor(uBkColor);									\
																				\
			pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);					\
																				\
			 																	\
			sPoint.x = sRect.left+1;											\
			sPoint.y = sRect.top+2;						   						\
																			   	\
																			   	\
			if(!(pDraw->itemData&1) || pMenuData->wIconNumber==0xFFFF)		   	\
				{															   	\
				if(wState&ODS_CHECKED)										   	\
					{															\
					DrawGlyphEx(pDC->m_hDC,sPoint.x,sPoint.y+2,m_iIconWidth,m_iIconHeight,(wState&ODS_DISABLED)? DG_MENU|MC_CHECKMARKDISABLED:DG_MENU|MC_CHECKMARKNORMAL);\
					}														   	\
				}															   	\
			else{															   	\
				if(wState&ODS_CHECKED)										   	\
					{														   	\
					pDC->SetBkColor(GetSysColor(COLOR_3DFACE));					\
					DrawRectanglePtr(pDC->m_hDC,&sRect);						\
					DrawFlatButtonEx(pDC->m_hDC,sPoint.x-1,sPoint.y-1,m_iIconWidth+2,m_iIconHeight+2,PFB_PRESSED|PFB_FILLED|PFB_HOT);	\
					}														   	\
																			   	\
				if(wState&ODS_DISABLED)										   	\
						m_cGrayImages.Draw(pDC,pMenuData->wIconNumber,sPoint,ILD_TRANSPARENT);\
				else	m_cMenuImages.Draw(pDC,pMenuData->wIconNumber,sPoint,ILD_TRANSPARENT);\
				}															   	\
        																	   	\
			iMode		= 0;													\
			sRect.left  = sRect.right;											\
			sRect.right = pDraw->rcItem.right;									\
			pDC->SetBkMode(TRANSPARENT);									   	\
																				\
			if(uBkColor!=GetSysColor(COLOR_MENU) || uBkColorSel!=GetSysColor(COLOR_HIGHLIGHT))	\
				{																\
				sRect.left += 3;												\
				iMode		= 1;												\
				}																\
																				\
			if(pDraw->itemData&1)												\
				{																\
				pText		= pMenuData->cText;									\
				pTabText	= pMenuData->cText+pMenuData->iTabPos+1;			\
				iTextLen	= pMenuData->iTabPos;								\
				}																\
			else{																\
				if(pDraw->itemData)												\
					{															\
					pText	= m_aItemText+CMF_MENUTEXT*((pDraw->itemData>>2)&0x3F);	\
					}															\
				else{															\
					pText	= _T("");											\
					}															\
																				\
				pTabText	= _T("");											\
				iTextLen	= -1;												\
				}																\
																				\
			if(pDraw->itemData==0)												\
				{																\
				if(iMode)														\
					{															\
					pDC->SetBkColor(GetSysColor(COLOR_GRAYTEXT));				\
					sFill.SetRect(pDraw->rcItem.left+2,pDraw->rcItem.top+3,sRect.left-5,pDraw->rcItem.top+4);	\
					pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);			\
					sFill.top++;												\
					sFill.bottom++;												\
					pDC->SetBkColor(GetSysColor(COLOR_CAPTIONTEXT));			\
					pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);			\
																				\
					pDC->SetBkColor(uTextColorG);								\
					sFill.SetRect(sRect.left-2,pDraw->rcItem.top+3,pDraw->rcItem.right-2,pDraw->rcItem.top+4);	\
					pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);			\
					sFill.top++;												\
					sFill.bottom++;												\
					pDC->SetBkColor(uTextColorS);								\
					pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);			\
					}															\
				else{															\
					pDC->SetBkColor(uTextColorG);								\
					sFill.SetRect(pDraw->rcItem.left+2,pDraw->rcItem.top+3,pDraw->rcItem.right-2,pDraw->rcItem.top+4);	\
					pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);			\
					sFill.top++;												\
					sFill.bottom++;												\
					pDC->SetBkColor(uTextColorC);								\
					pDC->ExtTextOut(0,0,ETO_OPAQUE,&sFill,NULL,0,NULL);			\
					}															\
				}																\
			else if(wState&ODS_DISABLED)									   	\
				{																\
				pDC->SetTextColor(uTextColorS);									\
				sRect.top  +=3;													\
				sRect.left +=1;													\
				pDC->DrawText(pText,iTextLen,&sRect,DT_VCENTER|DT_SINGLELINE);	\
																				\
																				\
				pDC->SetTextColor(uTextColorG);									\
				sRect.top  -=1;													\
				sRect.left -=1;													\
				pDC->DrawText(pText,iTextLen,&sRect,DT_VCENTER|DT_SINGLELINE);	\
																			   	\
				if(iTextLen!=-1)												\
					{															\
					sRect.left +=pMenuData->wTab-m_iIconWidth+CMF_ICONSPACE;	\
																				\
					pDC->SetTextColor(uTextColorS);								\
					sRect.top  +=3;												\
					sRect.left +=1;												\
					pDC->DrawText(pTabText,&sRect,DT_VCENTER|DT_SINGLELINE);	\
																				\
					pDC->SetTextColor(uTextColorG);								\
					sRect.top  -=1;												\
					sRect.left -=1;												\
					pDC->DrawText(pTabText,&sRect,DT_VCENTER|DT_SINGLELINE);	\
					}															\
				}																\
			else{																\
				if(wState&ODS_SELECTED)pDC->SetTextColor(uTextColorC);			\
				else				   pDC->SetTextColor(uTextColor );			\
        																	   	\
				sRect.top+=2;													\
				pDC->DrawText(pText,iTextLen,&sRect,DT_VCENTER|DT_SINGLELINE);	\
																			   	\
				if(iTextLen!=-1)												\
					{															\
					sRect.left+=pMenuData->wTab-m_iIconWidth+CMF_ICONSPACE;		\
					pDC->DrawText(pTabText,&sRect,DT_VCENTER|DT_SINGLELINE);	\
					}															\
				}																\
			}																   	\
	}																			\
																				\
	void CMainFrame::OnInitMenuPopup(CMenu *pMenu,UINT nIndex,BOOL bSysMenu)	\
	{																			\
	MENUDATA    *pMenuData;												   		\
	MENUITEMINFO sMenuInfo;														\
	TCHAR	     cMenuText[CMF_MENUTEXT];										\
	int			 iIndex=0;														\
	int			 iChange;														\
	int			 iMaxTab;														\
	int			 iWidth;														\
	int			 iId;															\
																				\
																				\
		CFrameWnd::OnInitMenuPopup(pMenu,nIndex,bSysMenu);						\
																				\
		if(bSysMenu)return;														\
																				\
																				\
		iIndex  = pMenu->GetMenuItemCount();									\
		iMaxTab	= 0;															\
		iChange = 0;															\
																				\
		while(iIndex>0)															\
			{																	\
			iIndex--;															\
																				\
			sMenuInfo.cbSize		= sizeof(sMenuInfo);						\
			sMenuInfo.fMask			= MIIM_DATA|MIIM_TYPE|MIIM_ID;				\
			sMenuInfo.dwTypeData	= cMenuText;								\
			sMenuInfo.cch			= CMF_MENUTEXT;								\
    																			\
			GetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);						\
																				\
			if(sMenuInfo.fType&MFT_OWNERDRAW)									\
				{																\
				if(sMenuInfo.dwItemData&1)										\
					{															\
					sMenuInfo.dwItemData--;										\
					pMenuData = (MENUDATA*)sMenuInfo.dwItemData;	   			\
					if(iMaxTab<pMenuData->wTab)iMaxTab=pMenuData->wTab;			\
					}															\
																				\
				continue;														\
				}																\
																				\
			ASSERT(!(sMenuInfo.dwItemData&1));									\
																				\
    		iId = sMenuInfo.wID;												\
																				\
			if(iId>=ID_FILE_MRU_FIRST && iId<=ID_FILE_MRU_LAST)					\
				{																\
				CWindowDC			sTestDc(NULL);								\
				CFont			   *pOldFont;									\
				CRect				sRect;										\
																				\
				pOldFont   = sTestDc.SelectObject(&m_sMenuFont);				\
				cMenuText[63] = 0;												\
				sTestDc.DrawText(cMenuText,-1,&sRect,DT_CALCRECT|DT_LEFT|DT_VCENTER|DT_SINGLELINE);\
				sTestDc.SelectObject(pOldFont);									\
																				\
				sMenuInfo.fType      |= MFT_OWNERDRAW;							\
				sMenuInfo.fMask		  = MIIM_TYPE|MIIM_DATA;					\
				sMenuInfo.dwItemData  = (sRect.Width()+m_iIconWidth+5)<<16;		\
				sMenuInfo.dwItemData |= max(m_iIconHeight,GetSystemMetrics(SM_CYMENU))<<8;	\
																				\
				sMenuInfo.dwItemData |= (iId-ID_FILE_MRU_FIRST)<<2;				\
				_tcscpy(m_aItemText+CMF_MENUTEXT*(iId-ID_FILE_MRU_FIRST),cMenuText);		\
				SetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);					\
				}																\
			else if(sMenuInfo.fType!=MFT_STRING)							   	\
				{																\
				sMenuInfo.dwItemData = 0;										\
				sMenuInfo.fMask 	 = MIIM_TYPE;			   					\
				sMenuInfo.fType		|= MFT_OWNERDRAW;							\
				SetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);					\
				}																\
			else{																\
				iWidth = MenuIconsAttach(pMenu,iIndex,cMenuText,sMenuInfo.wID);	\
				if(iMaxTab<iWidth)iMaxTab=iWidth;								\
				iChange++;														\
				}																\
			}																	\
																				\
		if(iChange)MenuIconsUpdateSize(pMenu,iMaxTab);						   	\
	}																			\
																				\
	void CMainFrame::OnMeasureItem(int nIDCtl,LPMEASUREITEMSTRUCT pMeasureItemStruct)	\
	{																		   	\
	MENUDATA   *pMenuData;													   	\
	LRESULT		uData;															\
																			   	\
																			   	\
		if(pMeasureItemStruct->CtlType==ODT_MENU)								\
			{																   	\
			if(pMeasureItemStruct->itemData&1)									\
				{																\
				uData     = pMeasureItemStruct->itemData-1;						\
				pMenuData = (MENUDATA*)uData;									\
																			   	\
				pMeasureItemStruct->itemWidth  = pMenuData->wWidth;			   	\
				pMeasureItemStruct->itemHeight = pMenuData->wHeight;		   	\
																				\
				if(m_bMenuMode)pMeasureItemStruct->itemWidth+=2;				\
																				\
				return; 														\
				}																\
																				\
			if(pMeasureItemStruct->itemData==0)									\
				{																\
				pMeasureItemStruct->itemWidth  = 20;			   				\
				pMeasureItemStruct->itemHeight = 8;							   	\
																				\
				return; 														\
				}																\
																				\
			pMeasureItemStruct->itemWidth  = (pMeasureItemStruct->itemData>>16);		\
			pMeasureItemStruct->itemHeight = (pMeasureItemStruct->itemData>> 8)&0xFF;   \
																				\
			if(m_bMenuMode)pMeasureItemStruct->itemWidth+=2;					\
																				\
			return; 															\
			}																   	\
																				\
																				\
		CFrameWnd::OnMeasureItem(nIDCtl,pMeasureItemStruct);					\
	}																			\
																				\
	void CMainFrame::OnMenuIconMode()											\
	{																			\
		m_bMenuMode = !m_bMenuMode;												\
	}																			\
																				\
	void CMainFrame::OnMenuIconModeUI(CCmdUI *pCmdUI)							\
	{																			\
		pCmdUI->SetCheck(m_bMenuMode);											\
	}																			\
																				\
	LRESULT CMainFrame::OnMenuIconSetText(WPARAM wParam,LPARAM lParam)			\
	{																			\
		return MenuIconsSetText((WORD)wParam,(LPCTSTR)lParam);					\
	}																			\
																				\
	LRESULT CMainFrame::OnMenuIconDetach(WPARAM wParam,LPARAM lParam)			\
	{																			\
		return MenuIconsDetach((CMenu*)lParam,(int)wParam);						\
	}																			\
																				\
	LRESULT CMainFrame::OnMenuIconExist(WPARAM wParam,LPARAM lParam)			\
	{																			\
		return 0x12345678;														\
	}																			\
																				\
	int CMainFrame::MenuIconsAttach(CMenu *pMenu,int iIndex,LPCTSTR pText,UINT uItem,CDC *pDc)	\
	{																			\
	MENUITEMINFO	sMenuInfo;											   		\
	MENUDATA 	   *pMenuData;												   	\
	CWindowDC	   *pWinDc; 													\
	CFont	 	   *pFont;														\
	CRect			sRect;													   	\
	int				iWidth;														\
	int				iSize;														\
	int				iIcon;														\
	int				iTab;														\
																				\
																				\
		if(!pDc)																\
			{																	\
			pWinDc	= new CWindowDC(NULL);										\
			pFont	= pWinDc->SelectObject(&m_sMenuFont);					   	\
			pDc		= pWinDc;													\
			}																	\
		else{																	\
			pWinDc	= 0;														\
			}																	\
																				\
		if(MenuIconsCalc(pText,iWidth,iSize,iTab,pDc))							\
			{																	\
			iIcon = -1;															\
			}																	\
		else{																	\
			for(iIcon=m_iIconCount-1;iIcon>=0;iIcon--)					   		\
				{														   		\
				if(m_aIconIds[iIcon]==uItem)break;								\
				}														   		\
			}																	\
																				\
		pMenuData				= (MENUDATA*)HeapAlloc(GetProcessHeap(),HEAP_GENERATE_EXCEPTIONS,sizeof(MENUDATA));	\
 		pMenuData->iTabPos		= iTab;								   			\
		pMenuData->wIconNumber	= (WORD)iIcon;							   		\
		pMenuData->wHeight		= max(m_iIconHeight,GetSystemMetrics(SM_CYMENU));\
		pMenuData->wWidth		= iWidth+iSize;						   			\
		pMenuData->wTab			= iWidth;							   			\
		pMenuData->cText[0]		= 0;											\
							   													\
		_tcsncpy(pMenuData->cText,pText,CMF_MENUTEXT-1);						\
		pMenuData->cText[CMF_MENUTEXT-1]=0;										\
				   																\
		sMenuInfo.cbSize		= sizeof(sMenuInfo);				   			\
		sMenuInfo.fType			= MFT_OWNERDRAW;					   			\
		sMenuInfo.fMask	 		= MIIM_DATA|MIIM_TYPE;				  			\
		sMenuInfo.dwItemData    = (LPARAM)pMenuData;					   		\
		sMenuInfo.dwItemData   |= 1;											\
		sMenuInfo.dwTypeData	= _T("");										\
		sMenuInfo.cch			= 0;											\
    																			\
		SetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);				   			\
																				\
		if(pWinDc)																\
			{																	\
			pWinDc->SelectObject(pFont);					   					\
			delete pWinDc;														\
			}																	\
																				\
	return iWidth;																\
	}																			\
																				\
	BOOL CMainFrame::MenuIconsDetach(CMenu *pMenu,int iIndex)					\
	{																			\
	MENUITEMINFO	sMenuInfo;											   		\
	TCHAR			cMenuText[CMF_MENUTEXT];									\
																				\
		sMenuInfo.cbSize		= sizeof(sMenuInfo);				   			\
		sMenuInfo.fType			= MFT_STRING;						   			\
		sMenuInfo.fMask	 		= MIIM_DATA|MIIM_TYPE;				  			\
		sMenuInfo.dwTypeData	= cMenuText;									\
		sMenuInfo.cch			= CMF_MENUTEXT;									\
																				\
		GetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);							\
																				\
		if(sMenuInfo.fType&MFT_OWNERDRAW)										\
		if(sMenuInfo.dwItemData&1)												\
			{																	\
			sMenuInfo.dwItemData--;												\
			HeapFree(GetProcessHeap(),0,(void*)sMenuInfo.dwItemData);			\
			}																	\
																				\
		sMenuInfo.dwItemData    = 0;								   			\
		sMenuInfo.dwTypeData	= _T("");										\
		sMenuInfo.cch			= 1;											\
    																			\
		return SetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);					\
																				\
	}																			\
																				\
	int CMainFrame::MenuIconsCalc(LPCTSTR pText,int &iWidth,int &iSize,int &iTab,CDC *pDc)	\
	{																			\
	CWindowDC	   *pWinDc; 													\
	CFont	 	   *pFont;														\
	CRect			sRect;													   	\
	int				iRet;														\
																				\
		if(!pDc)																\
			{																	\
			pWinDc	= new CWindowDC(NULL);										\
			pFont	= pWinDc->SelectObject(&m_sMenuFont);					   	\
			pDc		= pWinDc;													\
			}																	\
		else{																	\
			pWinDc	= 0;														\
			}																	\
																				\
		for(iTab=0;pText[iTab] && pText[iTab]!='\t';iTab++);					\
		pDc->DrawText(pText,iTab,&sRect,DT_CALCRECT|DT_LEFT|DT_VCENTER|DT_SINGLELINE);		\
		iRet	= (iTab>0 && pText[iTab-1]==_T('\xA0'))? 1:0;					\
		iWidth  = sRect.Width();									   			\
		iWidth += m_iIconWidth;										   			\
		iWidth += CMF_ICONSPACE;									   			\
																				\
		if(pText[iTab])												 			\
			{														   			\
			pDc->DrawText(pText+iTab+1,&sRect,DT_CALCRECT|DT_LEFT|DT_VCENTER|DT_SINGLELINE);	\
			iSize = sRect.Width()+2;									   		\
			if(iSize<24)iSize=24;									   			\
			}														   			\
		else{														   			\
			iSize	=  0;											   			\
			iTab    = -1;											   			\
			}														   			\
																				\
		if(pWinDc)																\
			{																	\
			pWinDc->SelectObject(pFont);					   					\
			delete pWinDc;														\
			}																	\
																				\
	return iRet;																\
	}																			\
																				\
	void CMainFrame::MenuIconsUpdateSize(CMenu *pMenu,int iMaxTab)				\
	{																			\
	TCHAR			cMenuText[CMF_MENUTEXT];									\
	MENUITEMINFO	sMenuInfo;													\
	MENUDATA       *pMenuData;												   	\
	int				iIndex;														\
																				\
		iIndex = pMenu->GetMenuItemCount();										\
																				\
		for(iIndex--;iIndex>=0;iIndex--)										\
			{															   		\
			sMenuInfo.cbSize		= sizeof(sMenuInfo);				   		\
			sMenuInfo.fMask			= MIIM_DATA|MIIM_TYPE;		   				\
			sMenuInfo.dwTypeData	= cMenuText;						   		\
			sMenuInfo.cch			= CMF_MENUTEXT;								\
			GetMenuItemInfo(*pMenu,iIndex,TRUE,&sMenuInfo);		   				\
																				\
			if((sMenuInfo.fType&MFT_OWNERDRAW)==0)continue;				   		\
			if((sMenuInfo.dwItemData&1))										\
				{																\
				sMenuInfo.dwItemData--;										 	\
				pMenuData				= (MENUDATA*)sMenuInfo.dwItemData;	   	\
				pMenuData->wWidth	   -= pMenuData->wTab;					   	\
				pMenuData->wWidth	   += iMaxTab;							   	\
				pMenuData->wTab			= iMaxTab;							   	\
				}															   	\
			}																	\
	}																			\
																				\
	CMainFrame::MENUDATA *CMainFrame::MenuIconsFind(WORD wItem,CMenu **pSub,int *pIndex)	\
	{																		   	\
	CMenu			   *pSubMenu;											   	\
	CMenu			   *pFrameMenu;											   	\
	INT					iMenuIndex;											   	\
	INT					iSubIndex;											   	\
	MENUITEMINFO		sMenusInfo;											   	\
	HMENU				aSubMenu[64];											\
	int					iSubCount;												\
	int					iIgnore=0;												\
	int					iEntries;												\
																			   	\
																				\
		pFrameMenu = GetMenu();												   	\
		iEntries   = pFrameMenu->GetMenuItemCount();							\
																				\
		for(iMenuIndex=0;iMenuIndex<iEntries;iMenuIndex++)						\
			{																   	\
			if(iIgnore)iIgnore=0;												\
			else{																\
				pSubMenu = pFrameMenu->GetSubMenu(iMenuIndex);					\
				}																\
																			   	\
			for(iSubIndex=pSubMenu->GetMenuItemCount()-1;iSubIndex>=0;iSubIndex--)	\
				{															   	\
				sMenusInfo.cbSize = sizeof(sMenusInfo);				   			\
				sMenusInfo.fMask  = MIIM_DATA|MIIM_TYPE|MIIM_ID|MIIM_SUBMENU;	\
				GetMenuItemInfo(*pSubMenu,iSubIndex,TRUE,&sMenusInfo);		   	\
																				\
				if(sMenusInfo.hSubMenu)											\
					{															\
					if(iSubCount<sizeof(aSubMenu)/sizeof(aSubMenu[0]))			\
						{														\
						aSubMenu[iSubCount] = sMenusInfo.hSubMenu;				\
						iSubCount++;											\
						}														\
																				\
					continue;													\
					}															\
																			   	\
				if(sMenusInfo.wID>=ID_FILE_MRU_FILE1)						   	\
				if(sMenusInfo.wID<=ID_FILE_MRU_FILE16)continue;				   	\
				if(sMenusInfo.wID==wItem)										\
				if(sMenusInfo.fType&MFT_OWNERDRAW)								\
				if(sMenusInfo.dwItemData&1)										\
					{															\
					sMenusInfo.dwItemData--;									\
					if(pSub  )*pSub  =pSubMenu;									\
					if(pIndex)*pIndex=iSubIndex;								\
					return (MENUDATA*)(sMenusInfo.dwItemData);					\
					}															\
				}															   	\
																			   	\
			while(iSubCount>0)													\
				{																\
				iSubCount--;													\
				pSubMenu = CMenu::FromHandle(aSubMenu[iSubCount]);			   	\
				if(pSubMenu){iMenuIndex--;iIgnore=1;break;}						\
				}																\
			}																   	\
																			   	\
		if(pSub  )*pSub  =0;													\
		if(pIndex)*pIndex=0;													\
																			   	\
	return 0;																   	\
	}																		   	\
																				\
	int	MenuIconsSetText(WORD wItem,LPCTSTR pText)								\
	{																			\
	CWnd *pWnd;																	\
																				\
			pWnd = AfxGetMainWnd();												\
		if(!pWnd)return 0;														\
		return pWnd->SendMessage(wItem,(LPARAM)pText);							\
	}																			\
																				\
	int CMainFrame::MenuIconsSetText(WORD wItem,LPCTSTR pText)					\
	{																			\
	TCHAR			cText[CMF_MENUTEXT];										\
	int				iSubIndex;													\
	MENUITEMINFO	sInfo;														\
	CMenu		   *pMenu;														\
	MENUDATA	   *pData;														\
	int				iMaxTab;													\
	int				iWidth;														\
	int				iSize;														\
	int				iTab;														\
	int				iOff;														\
																				\
																				\
			pData = MenuIconsFind(wItem,&pMenu,&iSubIndex);						\
		if(!pData)return 0;														\
																				\
																				\
		if(*pText=='\t')														\
				iOff = pData->iTabPos;											\
		else	iOff = 0;														\
																				\
		if(!_tcscmp(pData->cText+iOff,pText))									\
			{																	\
			return 1;															\
			}																	\
																				\
		_tcsncpy(pData->cText+iOff,pText,CMF_MENUTEXT-1-iOff);					\
																				\
		MenuIconsCalc(pData->cText,iWidth,iSize,iTab);							\
																				\
 		pData->iTabPos		= iTab;								   				\
		pData->wWidth		= iWidth+iSize;						   				\
		pData->wTab			= iWidth;							   				\
		iMaxTab				= 0;												\
																				\
		sInfo.cbSize		= sizeof(sInfo);				   					\
		sInfo.fMask 		= MIIM_TYPE|MIIM_DATA;			   					\
		sInfo.fType		    = MFT_STRING;										\
		sInfo.dwTypeData	= pData->cText;										\
		sInfo.dwItemData	= 0;												\
		sInfo.cch			= _tcslen(pData->cText);							\
		SetMenuItemInfo(*pMenu,iSubIndex,TRUE,&sInfo);							\
																				\
		sInfo.cbSize		= sizeof(sInfo);				   					\
		sInfo.fMask	 		= MIIM_DATA|MIIM_TYPE;				  				\
		sInfo.fType			= MFT_OWNERDRAW;					   				\
		sInfo.dwItemData    = (LPARAM)pData;					   				\
		sInfo.dwItemData   |= 1;												\
		sInfo.dwTypeData	= _T("");											\
		sInfo.cch			= 0;												\
		SetMenuItemInfo(*pMenu,iSubIndex,TRUE,&sInfo);							\
																				\
		for(iSubIndex=pMenu->GetMenuItemCount()-1;iSubIndex>=0;iSubIndex--)		\
			{															   		\
			sInfo.fMask			= MIIM_DATA|MIIM_TYPE;							\
			sInfo.dwTypeData	= cText;							   			\
			sInfo.cch			= CMF_MENUTEXT;									\
			GetMenuItemInfo(*pMenu,iSubIndex,TRUE,&sInfo);				   		\
																				\
			if(!(sInfo.fType&MFT_OWNERDRAW))continue;							\
			if(!(sInfo.dwItemData&1))continue;									\
																				\
			sInfo.dwItemData--;													\
			pData = (MENUDATA*)sInfo.dwItemData;	   							\
			if(iMaxTab<pData->wTab)iMaxTab=pData->wTab;							\
			}																	\
																				\
		iMaxTab += 16;													   		\
																				\
		MenuIconsUpdateSize(pMenu,iMaxTab);								 		\
																				\
																				\
	return 2;																	\
	}																			\
																				\
																			   	\
	int CMainFrame::MenuIconsGet(WORD wItem)									\
	{																			\
	MENUDATA   *pData;															\
																				\
			pData = MenuIconsFind(wItem);										\
		if(!pData)return -1;													\
																				\
	return (pData->wIconNumber==0xFFFF)? -1:pData->wIconNumber;					\
	}																			\
																			   	\
																				\
	int CMainFrame::MenuIconsSet(WORD wItem,int iIcon)							\
	{																			\
	MENUDATA   *pData;															\
																				\
			pData = MenuIconsFind(wItem);										\
		if(!pData)return FALSE;													\
		ASSERT(m_cMenuImages.GetImageCount()>iIcon && iIcon>=-1);				\
		pData->wIconNumber = (WORD)iIcon;										\
																				\
	return TRUE;																\
	}																			\
																			   	\
																				\
	int	CMainFrame::MenuIconsAdd(WORD wItem,HICON hIcon)						\
	{																			\
	LPBITMAPINFO 	pBitmap;													\
	LPVOID			pPixels;													\
	int				iOff;														\
	int				iPos;														\
																				\
		pBitmap=GetDibOfIcon(NULL,hIcon,&pPixels,RGB(192,192,192));				\
		DibConvertGrayScale(pBitmap,pPixels,RGB(223,223,223),RGB(192,192,192));	\
		iOff = m_cGrayImages.Add(CBitmap::FromHandle(DibGetBitmap(pBitmap)),RGB(192,192,192));	\
		iPos = m_cMenuImages.Add(hIcon);										\
		ASSERT(iPos>=0 && iOff==iPos);											\
		if(wItem!=0xFFFF)MenuIconsSet(wItem,iPos);								\
																				\
	return iPos;																\
	}																			\
																				\
																			   	\
	int	CMainFrame::MenuIconsAdd(WORD wItem,CBitmap *pImage,COLORREF uMask)		\
	{																			\
	LPBITMAPINFO 	pBitmap;													\
	LPVOID			pPixels;													\
	int				iOff;														\
	int				iPos;														\
																				\
		pBitmap=GetDibOfBitmap(NULL,*pImage,&pPixels);							\
		DibConvertGrayScale(pBitmap,pPixels,RGB(223,223,223),uMask);			\
		iOff = m_cGrayImages.Add(CBitmap::FromHandle(DibGetBitmap(pBitmap)),uMask);	\
		iPos = m_cMenuImages.Add(pImage,uMask);									\
		ASSERT(iPos>=0 && iOff==iPos);											\
		if(wItem!=0xFFFF)MenuIconsSet(wItem,iPos);								\
		DibFreeHandle(pBitmap);													\
																				\
	return iPos;																\
	}																			\
																				\
	int MenuIconDelete(UINT uItem)												\
	{																			\
	MENUITEMINFO	sInfo;											   			\
	TCHAR			cText;														\
	CMenu		   *pMenu;														\
	CMenu		   *pSub;														\
	CWnd		   *pWnd;														\
	int				iNum;														\
	int				iSub;														\
																				\
																				\
		pWnd=AfxGetMainWnd();													\
	if(!pWnd)return 0;															\
		pMenu=pWnd->GetMenu();													\
	if(!pMenu)return 0;															\
																				\
	iNum = pMenu->GetMenuItemCount();											\
																				\
	for(iNum--;iNum>=0;iNum--)													\
		{																		\
		sInfo.cbSize		= sizeof(sInfo);									\
		sInfo.fMask			= MIIM_ID|MIIM_DATA|MIIM_TYPE;						\
		sInfo.wID			= uItem;											\
		sInfo.dwTypeData	= &cText;						   					\
		sInfo.cch			= 1;												\
																				\
		GetMenuItemInfo(*pMenu,iNum,TRUE,&sInfo);								\
																				\
		if(sInfo.wID!=uItem)continue;											\
																				\
			pSub = pMenu->GetSubMenu(iNum);										\
		if(!pSub)continue;														\
																				\
		iSub = pSub->GetMenuItemCount();										\
																				\
		for(iSub--;iSub>=0;iSub--)												\
			{																	\
			pWnd->SendMessage(WM_MENUICON_DETACH,iSub,(LPARAM)pSub);			\
			}																	\
																				\
		pMenu->RemoveMenu(iNum,MF_BYPOSITION);									\
																				\
		if(sInfo.dwItemData==0xFF55AA88)										\
			{																	\
			DestroyMenu(*pSub);													\
			}																	\
																				\
		pWnd->DrawMenuBar();													\
																				\
		return 1;																\
		}																		\
																				\
	return 0;																	\
	}																			\
																				\
	int MenuIconInsert(UINT uItem,CMenu *pNew,LPCTSTR pText,int iPos)			\
	{																			\
	TCHAR			cText[CMF_MENUTEXT];										\
	MENUITEMINFO	sInfo;														\
	HMENU			hSub;														\
	CMenu		   *pMenu;														\
	CWnd		   *pWnd;														\
	int				iNum;														\
	int				iSub;														\
	int				iCnt;														\
																				\
																				\
	if(!pNew)return 0;															\
																				\
	MenuIconDelete(uItem);														\
																				\
																				\
		pWnd=AfxGetMainWnd();													\
	if(!pWnd)return 0;															\
		pMenu=pWnd->GetMenu();													\
	if(!pMenu)return 0;															\
																				\
	iNum = pMenu->GetMenuItemCount();											\
																				\
	if(iPos<0)																	\
		{																		\
		iPos = iNum-iPos;														\
		}																		\
																				\
	if(iPos>=iNum)iPos=iNum-1;													\
	if(iPos<    0)iPos=0;														\
																				\
	iCnt = pNew->GetMenuItemCount();											\
	hSub = CreatePopupMenu();													\
																				\
	if(!hSub)return 0;															\
																				\
	for(iSub=0;iSub<iCnt;iSub++)												\
		{																		\
		sInfo.cbSize		= sizeof(sInfo);									\
		sInfo.fMask			= MIIM_DATA|MIIM_STATE|MIIM_TYPE|MIIM_ID|MIIM_SUBMENU;	\
		sInfo.cch			= CMF_MENUTEXT;										\
		sInfo.dwTypeData	= cText;						   					\
																				\
		GetMenuItemInfo(*pNew,iSub,TRUE,&sInfo);								\
																				\
		ASSERT(!(sInfo.fType&MFT_OWNERDRAW));									\
		ASSERT(!(sInfo.hSubMenu));												\
																				\
		InsertMenuItem(hSub,iSub,TRUE,&sInfo);									\
		}																		\
																				\
	if(pMenu->InsertMenu(iPos,MF_POPUP|MF_BYPOSITION,(UINT)hSub,pText))			\
		{																		\
		sInfo.cbSize		= sizeof(sInfo);									\
		sInfo.fMask			= MIIM_ID|MIIM_DATA;								\
		sInfo.dwItemData	= 0xFF55AA88;										\
		sInfo.wID			= uItem;											\
																				\
		SetMenuItemInfo(*pMenu,iPos,TRUE,&sInfo);								\
																				\
		pWnd->DrawMenuBar();													\
		return 1;																\
		}																		\
																				\
	DestroyMenu(hSub);															\
																				\
	return 0;																	\
	}																			\


	int MenuIconInsert(UINT uItem,CMenu *pNew,LPCTSTR pText,int iPos=-2);
	int MenuIconDelete(UINT uItem);


//*****************************************************************************
//*
//*		Enumerierung aller Main-Fenster
//*
//*****************************************************************************
//
//	ENUMWND_PROC(CMainFrame)		Einfgen in MainFrame.cpp
//	ENUMWND_REGISTER("ProgammName")	Einfgen in MainFrame.cpp in den Konstruktor
//	ON_ENUMWND()					Einfgen in MainFrame.cpp bei BEGIN_MESSAGE_MAP(...)
//	DECLARE_ENUMWND_PROC()			Einfgen in MainFrame.h
//
//	HWND EnumMainWnd(HWND hLast=0)
//		Such nach allen Hauptfenstern dieses Types
//		Ergibt das Fenster-Handle des nchsten Fensters
//		Mit EnumMainWnd(ENUM_STOP) kann das Enummerieren abgebrochen werden
//

#define ON_ENUMWND()	ON_REGISTERED_MESSAGE(m_uEnumMsg,OnEnum)

#define ENUMWND_REGISTER(pName)													\
	m_hEnumSem	= NULL;															\
	m_hEnumNext	= NULL;															\
	m_hEnumLast	= NULL;															\
	m_uEnumMsg  = RegisterWindowMessage(_T(pName));

#define ENUMWND_PROC(CMainFrame)												\
	UINT	CMainFrame::m_uEnumMsg;												\
																				\
	LRESULT CMainFrame::OnEnum(WPARAM wParam,LPARAM lParam)						\
	{																			\
	if(wParam==0x12345678)return 0x12345678;									\
	return 0;																	\
	}																			\
																				\
	BOOL CALLBACK CMainFrame::EnumProc(HWND hWnd,LPARAM lParam)					\
	{																			\
	CMainFrame *pThis=(CMainFrame*)lParam;										\
	DWORD_PTR	uResult;														\
																				\
	if(pThis->m_hEnumLast==NULL)												\
		{																		\
		return FALSE;															\
		}																		\
																				\
	if(!SendMessageTimeout(hWnd,pThis->m_uEnumMsg,0x12345678,0,SMTO_NORMAL,50,&uResult))\
		{																		\
		return TRUE;															\
		}																		\
																				\
	if(uResult!=0x12345678)														\
		{																		\
		return TRUE;															\
		}																		\
																				\
	WaitForSingleObject(pThis->m_hEnumNext,INFINITE);							\
	pThis->m_hEnumWnd = hWnd;													\
	ReleaseSemaphore(pThis->m_hEnumSem,1,NULL);									\
																				\
	return TRUE;																\
	}																			\
																				\
	DWORD WINAPI CMainFrame::EnumThread(LPVOID pParam)							\
	{																			\
	CMainFrame *pThis=(CMainFrame*)pParam;										\
																				\
	EnumWindows(EnumProc,(LPARAM)pThis);										\
																				\
	WaitForSingleObject(pThis->m_hEnumNext,INFINITE);							\
	pThis->m_hEnumWnd = 0;														\
	ReleaseSemaphore (pThis->m_hEnumSem ,1  ,NULL);								\
																				\
	return 0;																	\
	}																			\
																				\
	HWND CMainFrame::EnumMainWnd(HWND hLastWnd)									\
	{																			\
	DWORD		uThreadId;														\
	HANDLE		hThread;														\
																				\
	if(m_hEnumLast!=hLastWnd)													\
		{																		\
		if(m_hEnumSem)															\
			{																	\
			m_hEnumLast = 0;													\
																				\
			for(;;)																\
				{																\
				ReleaseSemaphore   (m_hEnumNext,1 ,NULL);						\
				WaitForSingleObject(m_hEnumSem,INFINITE);						\
				if(!m_hEnumWnd)break;											\
				}																\
																				\
			CloseHandle(m_hEnumNext);											\
			CloseHandle(m_hEnumSem );											\
																				\
			m_hEnumSem = NULL;													\
			}																	\
																				\
		if(hLastWnd)return NULL;												\
		}																		\
																				\
	if(!hLastWnd)																\
		{																		\
		m_hEnumLast	= HWND_BOTTOM;												\
		m_hEnumNext	= CreateSemaphore(NULL,0,0xFFFF,NULL);						\
		m_hEnumSem	= CreateSemaphore(NULL,0,0xFFFF,NULL);						\
		hThread		= CreateThread(NULL,0x1000,EnumThread,this,0,&uThreadId);	\
		CloseHandle(hThread);													\
		}																		\
																				\
	ReleaseSemaphore   (m_hEnumNext,1 ,NULL);									\
	WaitForSingleObject(m_hEnumSem,INFINITE);									\
																				\
	m_hEnumLast = m_hEnumWnd;													\
																				\
	if(!m_hEnumLast)															\
		{																		\
		CloseHandle(m_hEnumNext);												\
		CloseHandle(m_hEnumSem );												\
		m_hEnumSem = NULL;														\
		}																		\
																				\
	return m_hEnumWnd;															\
	}


#ifndef	ENUM_STOP
#define ENUM_STOP	HWND_BOTTOM
#endif
#define DECLARE_ENUMWND_PROC()													\
	afx_msg LRESULT OnEnum(WPARAM wParam,LPARAM lParam);						\
	static	BOOL  	CALLBACK EnumProc  (HWND hHwnd,LPARAM lParam);				\
	static	DWORD 	WINAPI   EnumThread(LPVOID pParam);							\
	HWND			m_hEnumLast;												\
	HWND volatile	m_hEnumWnd;													\
	HANDLE			m_hEnumNext;												\
	HANDLE			m_hEnumSem;													\
	static UINT		m_uEnumMsg;													\
	public:																		\
	HWND			EnumMainWnd(HWND hLastWnd=NULL);							\
	protected:

//*****************************************************************************
//*
//*		Holt den Zeiger auf ein Control in der Toolbar
//*
//*****************************************************************************
//
//	GETCONTROL_PROC(CMainFrame)		Einfgen in MainFrame.cpp
//	ON_GETCONTROL()					Einfgen in MainFrame.cpp bei BEGIN_MESSAGE_MAP(...)
//	DECLARE_GETCONTROL()			Einfgen in MainFrame.h
//
//	CWnd *GetControl(UINT uCtrlId,UINT uBarId)
//		Holt enen Zeiger auf ein Toolbar-Controll
//		uCtrlId	= Ist die ID des Controlls
//		uBarId	= Ist die ID der Toolbar
//		Ergibt einen Zeiger auf das Fenster oder 0
//
#define WM_GETCONTROL			0x3FE6
#define ON_GETCONTROL()			ON_MESSAGE(WM_GETCONTROL,OnGetControl)
#define DECLARE_GETCONTROL()	LRESULT afx_msg OnGetControl(WPARAM,LPARAM);
#define GETCONTROL_PROC(CMainFrame)												\
	LRESULT afx_msg CMainFrame::OnGetControl(WPARAM wParam,LPARAM lParam)		\
	{																			\
	CToolBarNew *pBar;															\
	CWnd		*pWnd;															\
																				\
		pBar = (CToolBarNew*)GetControlBar((UINT)lParam);						\
	if(!pBar)return 0;															\
																				\
	if(wParam<64)																\
			pWnd = pBar->GetControl((UINT)wParam);								\
	else	pWnd = pBar->GetControlId(LOWORD(wParam),HIWORD(wParam));			\
																				\
	return (LRESULT)pWnd;														\
	}

inline CWnd *GetControl(UINT uCtrlId,UINT uBarId=AFX_IDW_TOOLBAR)
	{
	CWnd *pWnd=AfxGetMainWnd();
	ASSERT(pWnd!=0);
	if(!pWnd)return NULL;
	return (CWnd*)pWnd->SendMessage(WM_GETCONTROL,uCtrlId,uBarId);
	}


//*****************************************************************************
//*
//*		Dialog auf alte Position Funktionen
//*
//*****************************************************************************
//
//	GET_DLG_OLDPOS()				Einfgen in OnOk() und OnCancel()
//	SET_DLG_OLDPOS()				Einfgen in OnInitDialog()
//	LOAD_DLG_OLDPOS(sKey,pName)		Einfgen in OnInitDialog() ohne SET_DLG_OLDPOS() (optional)
//	SAVE_DLG_OLDPOS(sKey,pName)		Einfgen in OnOk() und OnCancel() ohne GET_DLG_OLDPOS() (optional)
//	DECLARE_DLG_OLDPOS()			Einfgen in die Header-Datei der Klasse
//	DLG_OLDPOS(Dlg)					Einfgen in den globalen Bereich der CPP-Datei
//
//	oder
//
//	GET_DLG_OLDSIZE()				Einfgen in OnOk() und OnCancel()
//	SET_DLG_OLDSIZE()				Einfgen in OnInitDialog()
//	LOAD_DLG_OLDSIZE(sKey,pName)	Einfgen in OnInitDialog() ohne SET_DLG_OLDSIZE() (optional)
//	SAVE_DLG_OLDSIZE(sKey,pName)	Einfgen in OnOk() und OnCancel() ohne GET_DLG_OLDSIZE() (optional)
//	DECLARE_DLG_OLDSIZE()			Einfgen in die Header-Datei der Klasse
//	DLG_OLDSIZE(Dlg)				Einfgen in den globalen Bereich der CPP-Datei
//

#define	GET_DLG_OLDPOS()																\
	{																					\
	m_iOldScreenOn = 1;																	\
	GetWindowRect(&m_sOldPos);															\
	}

#define	GET_DLG_OLDSIZE()																\
	{																					\
	if(!IsZoomed())																		\
		{																				\
		m_iOldScreenOn = 1;																\
		GetWindowRect(&m_sOldPos);														\
		}																				\
	}

#define	LOAD_DLG_OLDPOS(sKey,pName)														\
	{																					\
	if(!m_iOldScreenOn && sKey.Get(&m_sOldPos,sizeof(RECT),pName,REG_BINARY))			\
		{																				\
		m_iOldScreenOn = 1;																\
		}																				\
	SET_DLG_OLDPOS();																	\
	}

#define	LOAD_DLG_OLDSIZE(sKey,pName)													\
	{																					\
	if(!m_iOldScreenOn && sKey.Get(&m_sOldPos,sizeof(RECT),pName,REG_BINARY))			\
		{																				\
		m_iOldScreenOn = 1;																\
		}																				\
	SET_DLG_OLDSIZE();																	\
	}

#define	SAVE_DLG_OLDPOS(sKey,pName)														\
	{																					\
	GET_DLG_OLDPOS();																	\
	sKey.Set(&m_sOldPos,sizeof(RECT),pName,REG_BINARY);									\
	}

#define	SAVE_DLG_OLDSIZE(sKey,pName)													\
	{																					\
	GET_DLG_OLDSIZE();																	\
	sKey.Set(&m_sOldPos,sizeof(RECT),pName,REG_BINARY);									\
	}

#define	SET_DLG_OLDPOS()																\
	{																					\
	if(m_iOldScreenOn)																	\
		{																				\
		CRect	sDispRect;																\
		GetDisplayRect(m_sOldPos,&sDispRect);											\
		if(m_sOldPos.left>sDispRect.left-100 && m_sOldPos.left<sDispRect.right -100)	\
		if(m_sOldPos.top >sDispRect.top -10  && m_sOldPos.top <sDispRect.bottom-100)	\
			{																			\
			SetWindowPos(0,m_sOldPos.left,m_sOldPos.top ,0,0,SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_NOZORDER);	\
			}																			\
		}																				\
	}

#define	SET_DLG_OLDSIZE()																\
	{																					\
	if(m_iOldScreenOn)																	\
		{																				\
		CRect	sDispRect;																\
		GetDisplayRect(m_sOldPos,&sDispRect);											\
		if(m_sOldPos.left>sDispRect.left-100 && m_sOldPos.left<sDispRect.right -100)	\
		if(m_sOldPos.top >sDispRect.top -10  && m_sOldPos.top <sDispRect.bottom-100)	\
		if(m_sOldPos.Width()>16 && m_sOldPos.Height()>16)								\
			{																			\
			SetWindowPos(0,m_sOldPos.left,m_sOldPos.top,m_sOldPos.Width(),m_sOldPos.Height(),SWP_NOOWNERZORDER|SWP_NOZORDER);	\
			}																			\
		}																				\
	}

#define	DECLARE_DLG_OLDPOS()															\
	static CRect	m_sOldPos;															\
	static int		m_iOldScreenOn;

#define	DECLARE_DLG_OLDSIZE()															\
	static CRect	m_sOldPos;															\
	static int		m_iOldScreenOn;

#define	DLG_OLDPOS(CDlg)																\
	CRect	CDlg::m_sOldPos;															\
	int		CDlg::m_iOldScreenOn;

#define	DLG_OLDSIZE(CDlg)																\
	CRect	CDlg::m_sOldPos;															\
	int		CDlg::m_iOldScreenOn;


//*****************************************************************************
//*
//*		Dialog mit Gren-nderungs-Funktion
//*
//*****************************************************************************
//
//	ON_WM_SIZE()					Einfgen in die Message-Map
//	ON_WM_SIZING()					Einfgen in die Message-Map
//	ON_WM_EXITSIZEMOVE()			Einfgen in die Message-Map um dass Fenster neu zu zeichnen am Ende
//	DECLARE_DLG_SIZING()			Einfgen in die Header-Datei der Klasse
//	DLG_SIZING_REINIT()				Einfgen in nach dem Items verndert wurden
// 	DLG_SIZING(Dlg)					Einfgen in die Source-Datei der Klasse nach DLG_SIZING_ITEMS
// 	DLG_SIZING_EX(Dlg,SubX,SubY)	Einfgen in die Source-Datei der Klasse nach DLG_SIZING_ITEMS (Dialog verkleinerbar)
//	DLG_SIZING_SIZE(Dlg)			Einfgen in die Source-Datei der Klasse wenn OnSize nicht existiert
//	DLG_SIZING_CALL()				Einfgen in die in OnSize wenn DLG_SIZING_SIZE nicht benutzt wird
//	DLG_SIZING_INIT()				Einfgen in die in OnInitDialog wenn danach die Gre gendert wird
//	DLG_SIZING_ITEMS(Dlg,X,Y)		Einfgen in den globalen Bereich der CPP-Datei (vor DLG_SIZING bzw. DLG_SIZING_EX)
//		{							X,Y sind die maximalen Abschnitte je Richtung
//		IDC_EDIT1,	0, 0,  -4, 0,	Liste mit den ID's der Fenster
//		IDC_TEXT,	0, 0,  -4, 0,		(Move X/Y Size	X/Y)
//		IDC_EDIT2,	0, 0,	3, 0,	Bei kleiner 0 wird auch der Rest addiert.
//		};
//
#ifndef		ON_WM_EXITSIZEMOVE																 
#define 	ON_WM_EXITSIZEMOVE()	ON_MESSAGE_VOID(WM_EXITSIZEMOVE,OnExitSizeMove)
#endif
#define 	DLG_SIZING(CDlg)		DLG_SIZING_EX(CDlg,0,0)
#define 	DLG_SIZING_EX(CDlg,iSubX,iSubY)										\
void CDlg::CalcSizing(int iSizeX,int iSizeY)									\
	{																			\
	static CRect	aItems[sizeof(m_aSizingItems)/sizeof(m_aSizingItems[0])];	\
	CPoint			sPoint;														\
	CRect			sRect;														\
	CWnd		   *pWnd;														\
	int				iDifX;														\
	int				iDifY;														\
	int				iAddX;														\
	int				iAddY;														\
	int				iPos;														\
																				\
	if(iSizeX<=0 || iSizeY<=0)													\
		{																		\
		m_iSizingInit = 0;														\
		return;																	\
		}																		\
																				\
	if(!m_iSizingInit)															\
		{																		\
		if(iSizeX!=0x12345678)return;											\
																				\
		sPoint.x	= 0;														\
		sPoint.y	= 0;														\
																				\
		ClientToScreen(&sPoint);												\
																				\
		GetWindowRect(&sRect);													\
																				\
		if(iSizeY!=0x12345678)													\
			{																	\
			m_sSizingMain	  = sRect.Size();									\
			m_sSizingMain.cx -= iSubX;											\
			m_sSizingMain.cy -= iSubY;											\
			}																	\
																				\
		GetClientRect(&sRect);													\
		m_sSizingClient	= sRect.Size();											\
																				\
		for(iPos=0;iPos<sizeof(m_aSizingItems)/sizeof(m_aSizingItems[0]);iPos++)\
			{																	\
			pWnd = GetDlgItem(m_aSizingItems[iPos].uId);						\
																				\
			ASSERT_PARAM2(pWnd,"The %ith item in DLG_SIZING_ITEMS not exists (id=%i)",iPos+1,m_aSizingItems[iPos].uId);	\
			if(!pWnd)return;													\
																				\
			pWnd->GetWindowRect(aItems+iPos);									\
																				\
			aItems[iPos].left	-= sPoint.x;									\
			aItems[iPos].right  -= sPoint.x;									\
			aItems[iPos].top	-= sPoint.y;									\
			aItems[iPos].bottom -= sPoint.y;									\
			}																	\
																				\
		m_iSizingInit = 1;														\
																				\
		return;																	\
		}																		\
																				\
	iDifX	= iSizeX-m_sSizingClient.cx;										\
	iDifY	= iSizeY-m_sSizingClient.cy;										\
	iAddX	= iDifX%m_iSizingStepsX;											\
	iAddY	= iDifX%m_iSizingStepsY;											\
	iDifX  /= m_iSizingStepsX;													\
	iDifY  /= m_iSizingStepsY;													\
																				\
	for(iPos=0;iPos<sizeof(m_aSizingItems)/sizeof(m_aSizingItems[0]);iPos++)	\
		{																		\
		pWnd = GetDlgItem(m_aSizingItems[iPos].uId);							\
																				\
		if(!pWnd)continue;														\
																				\
		sRect = aItems[iPos];													\
																				\
		if(m_aSizingItems[iPos].iMoveX>0)										\
			{																	\
			sRect.left	 += iDifX*m_aSizingItems[iPos].iMoveX;					\
			sRect.right	 += iDifX*m_aSizingItems[iPos].iMoveX;					\
			}																	\
																				\
		if(m_aSizingItems[iPos].iMoveX<0)										\
			{																	\
			sRect.left	 -= iDifX*m_aSizingItems[iPos].iMoveX;					\
			sRect.right	 -= iDifX*m_aSizingItems[iPos].iMoveX;					\
			sRect.left   += iAddX;												\
			sRect.right  += iAddX;												\
			}																	\
																				\
		if(m_aSizingItems[iPos].iMoveY>0)										\
			{																	\
			sRect.top	 += iDifY*m_aSizingItems[iPos].iMoveY;					\
			sRect.bottom += iDifY*m_aSizingItems[iPos].iMoveY;					\
			}																	\
																				\
		if(m_aSizingItems[iPos].iMoveY<0)										\
			{																	\
			sRect.top	 -= iDifY*m_aSizingItems[iPos].iMoveY;					\
			sRect.bottom -= iDifY*m_aSizingItems[iPos].iMoveY;					\
			sRect.top    += iAddY;												\
			sRect.bottom += iAddY;												\
			}																	\
																				\
		if(m_aSizingItems[iPos].iSizeX>0)										\
			{																	\
			sRect.right	 += iDifX*m_aSizingItems[iPos].iSizeX;					\
			}																	\
																				\
		if(m_aSizingItems[iPos].iSizeX<0)										\
			{																	\
			sRect.right	 -= iDifX*m_aSizingItems[iPos].iSizeX;					\
			sRect.right  += iAddX;												\
			}																	\
																				\
		if(m_aSizingItems[iPos].iSizeY>0)										\
			{																	\
			sRect.bottom += iDifY*m_aSizingItems[iPos].iSizeY;					\
			}																	\
																				\
		if(m_aSizingItems[iPos].iSizeY<0)										\
			{																	\
			sRect.bottom -= iDifY*m_aSizingItems[iPos].iSizeY;					\
			sRect.bottom += iAddY;												\
			}																	\
																				\
		pWnd->MoveWindow(&sRect,TRUE);											\
		}																		\
																				\
	m_iSizingFlag = 1;															\
	}																			\
																				\
void CDlg::OnSizing(UINT nSide,LPRECT pRect)									\
	{																			\
	CRect	sRect;																\
																				\
	DLG_SIZING_INIT();															\
																				\
	if(pRect->right-pRect->left<m_sSizingMain.cx)								\
		{																		\
		switch(nSide)															\
			{																	\
		case WMSZ_BOTTOM:														\
		case WMSZ_BOTTOMLEFT:													\
		case WMSZ_LEFT:															\
		case WMSZ_TOPLEFT:		pRect->left = pRect->right-m_sSizingMain.cx;	\
								break;											\
																				\
		case WMSZ_BOTTOMRIGHT:													\
		case WMSZ_RIGHT:														\
		case WMSZ_TOP:															\
		case WMSZ_TOPRIGHT:		pRect->right = pRect->left+m_sSizingMain.cx;	\
								break;											\
			}																	\
		}																		\
																				\
	if(pRect->bottom-pRect->top<m_sSizingMain.cy)								\
		{																		\
		switch(nSide)															\
			{																	\
		case WMSZ_BOTTOM:														\
		case WMSZ_BOTTOMLEFT:													\
		case WMSZ_BOTTOMRIGHT:													\
		case WMSZ_LEFT:			pRect->bottom = pRect->top+m_sSizingMain.cy;	\
								break;											\
																				\
																				\
																				\
		case WMSZ_RIGHT:														\
		case WMSZ_TOP:															\
		case WMSZ_TOPLEFT:														\
		case WMSZ_TOPRIGHT:		pRect->top = pRect->bottom-m_sSizingMain.cy;	\
								break;											\
			}																	\
		}																		\
	}																			\
																				\
void CDlg::OnExitSizeMove()														\
	{																			\
	if(m_iSizingFlag)															\
		{																		\
		m_iSizingFlag = 0;														\
		RedrawWindow();															\
		}																		\
	}

#define DLG_SIZING_SIZE(CDlg)													\
	void CDlg::OnSize(UINT nType,int iSizeX,int iSizeY)							\
	{																			\
	DLG_SIZING_CALL()															\
	}

#define DLG_SIZING_INIT()														\
	{																			\
	if(!m_iSizingInit)															\
		{																		\
		CalcSizing(0x12345678,1);												\
		}																		\
	}

#define DLG_SIZING_REINIT()														\
	{																			\
	m_iSizingInit = 0;															\
	CalcSizing(0x12345678,0x12345678);											\
	}


#define DLG_SIZING_CALL()														\
	{																			\
	if(m_iSizingInit)															\
		{																		\
		CalcSizing(iSizeX,iSizeY);												\
		}																		\
	}

#define DLG_SIZING_ITEMS(CDlg,X,Y)												\
	int					CDlg::m_iSizingInit=0;									\
	int					CDlg::m_iSizingFlag=0;									\
	const int			CDlg::m_iSizingStepsX=X;								\
	const int			CDlg::m_iSizingStepsY=Y;								\
	CSize				CDlg::m_sSizingClient;									\
	CSize				CDlg::m_sSizingMain;									\
	CDlg::SizingItem	CDlg::m_aSizingItems[]=

#define DECLARE_DLG_SIZING()													\
																				\
	typedef	struct																\
		{																		\
		WORD		uId;														\
		char 		iMoveX;														\
		char		iMoveY;														\
		char		iSizeX;														\
		char		iSizeY;														\
		}SizingItem;															\
																				\
	afx_msg void OnExitSizeMove();												\
	afx_msg void OnSizing(UINT nSide,LPRECT pRect);								\
	afx_msg void OnSize  (UINT nType,int iSizeX,int iSizeY);					\
	void   CalcSizing(int iSizeX,int iSizeY);									\
	static SizingItem	m_aSizingItems[];										\
	static const  int	m_iSizingStepsX;										\
	static const  int	m_iSizingStepsY;										\
	static int			m_iSizingInit;											\
	static int			m_iSizingFlag;											\
	static CSize		m_sSizingClient;										\
	static CSize		m_sSizingMain;

//*****************************************************************************
//*
//*		PROCESS_RUNNING
//*
//*****************************************************************************
//	Prft ob ein anderer Prozess des selben Typs bereits luft.
//	z.B.	PROCESS_RUNNING("AppName");		Global definieren
//			if(ProcessRunning())...			Ist der Prfaufruf
#define PROCESS_RUNNING(Name)													\
	static int		iProcessState=0;											\
	static HANDLE	hProcessSem  =0;											\
	BOOL ProcessRunning()														\
	{																			\
	char				sDesc[SECURITY_DESCRIPTOR_MIN_LENGTH];					\
	SECURITY_ATTRIBUTES sAttr;													\
																				\
	if(iProcessState)return iProcessState&1;									\
	   hProcessSem=OpenSemaphoreA(SEMAPHORE_ALL_ACCESS,FALSE,"Global\\"Name);	\
	if(hProcessSem)																\
		{																		\
		iProcessState = 3;														\
		return TRUE;															\
		}																		\
																				\
	sAttr.nLength				= sizeof(sAttr);								\
	sAttr.bInheritHandle		= FALSE;										\
	sAttr.lpSecurityDescriptor	= &sDesc;										\
	InitializeSecurityDescriptor(sAttr.lpSecurityDescriptor,SECURITY_DESCRIPTOR_REVISION);\
	SetSecurityDescriptorDacl   (sAttr.lpSecurityDescriptor,TRUE,NULL,FALSE);	\
																				\
	hProcessSem		= CreateSemaphoreA(&sAttr,0,1,"Global\\"Name);				\
	iProcessState	= 2;														\
																				\
	return FALSE;																\
	}


//*****************************************************************************
//*
//*		AfxRegisterWndClassEx
//*
//*****************************************************************************
inline LPCTSTR AfxRegisterWndClassEx(LPCTSTR pClassName,UINT nClassStyle,HCURSOR hCursor=0,HBRUSH hBrush=0,HICON hIcon=0,UINT uExtra=0)
{
WNDCLASS	sClass;
HINSTANCE	hInst;



	hInst = AfxGetInstanceHandle();


	if(::GetClassInfo(hInst,pClassName,&sClass))			// Existiert die Klasse bereits
		{
		ASSERT(sClass.style == nClassStyle);
		return pClassName;
		}


	sClass.style			= nClassStyle;					// Eine neue Klasse registreiern
	sClass.lpfnWndProc		= DefWindowProc;
	sClass.cbClsExtra		= 0;
	sClass.cbWndExtra		= uExtra;
	sClass.hInstance		= hInst;
	sClass.hIcon			= hIcon;
	sClass.hCursor			= hCursor;
	sClass.hbrBackground	= hBrush;
	sClass.lpszMenuName		= NULL;
	sClass.lpszClassName	= pClassName;


	if (!AfxRegisterClass(&sClass))
		{
		AfxThrowResourceException();
		}



return pClassName;
}

//*****************************************************************************
//*
//*		GetWindowLong Funktionen
//*
//*****************************************************************************

inline	LONG    GetWndId   (HWND  hWnd){return ::GetWindowLong   (         hWnd,GWL_ID      );}
inline	LONG    GetWndId   (CWnd *pWnd){return ::GetWindowLong   ( pWnd->m_hWnd,GWL_ID      );}
inline	LONG    GetWndId   (CWnd &sWnd){return ::GetWindowLong   ( sWnd .m_hWnd,GWL_ID      );}

inline	LONG    GetStyle   (HWND  hWnd){return ::GetWindowLong   (         hWnd,GWL_STYLE   );}
inline	LONG    GetStyle   (CWnd *pWnd){return ::GetWindowLong   ( pWnd->m_hWnd,GWL_STYLE   );}
inline	LONG    GetStyle   (CWnd &sWnd){return ::GetWindowLong   ( sWnd .m_hWnd,GWL_STYLE   );}

inline	LPARAM  GetWndData (HWND  hWnd){return ::GetWindowLongPtr(         hWnd,GWL_USERDATA);}
inline	LPARAM  GetWndData (CWnd *pWnd){return ::GetWindowLongPtr( pWnd->m_hWnd,GWL_USERDATA);}
inline	LPARAM  GetWndData (CWnd &sWnd){return ::GetWindowLongPtr( sWnd .m_hWnd,GWL_USERDATA);}

inline	WNDPROC GetWndProc (HWND  hWnd){return (WNDPROC)::GetWindowLongPtr(         hWnd,GWL_WNDPROC );}
inline	WNDPROC GetWndProc (CWnd *pWnd){return (WNDPROC)::GetWindowLongPtr( pWnd->m_hWnd,GWL_WNDPROC );}
inline	WNDPROC GetWndProc (CWnd &sWnd){return (WNDPROC)::GetWindowLongPtr( sWnd .m_hWnd,GWL_WNDPROC );}

inline	WNDPROC GetThisProc(HWND  hWnd){return (WNDPROC)::GetWindowLongPtr(         hWnd,GWL_USERDATA );}
inline	WNDPROC GetThisProc(CWnd *pWnd){return (WNDPROC)::GetWindowLongPtr( pWnd->m_hWnd,GWL_USERDATA );}
inline	WNDPROC GetThisProc(CWnd &sWnd){return (WNDPROC)::GetWindowLongPtr( sWnd .m_hWnd,GWL_USERDATA );}

inline	LONG    SetWndId   (HWND  hWnd,LONG    lId   ){return ::SetWindowLong(         hWnd,GWL_ID,lId    );}
inline	LONG    SetWndId   (CWnd *pWnd,LONG    lId   ){return ::SetWindowLong( pWnd->m_hWnd,GWL_ID,lId    );}
inline	LONG    SetWndId   (CWnd &sWnd,LONG    lId   ){return ::SetWindowLong( sWnd .m_hWnd,GWL_ID,lId    );}

inline	LONG    SetStyle   (HWND  hWnd,LONG    lStyle){return ::SetWindowLong(         hWnd,GWL_STYLE,lStyle   );}
inline	LONG    SetStyle   (CWnd *pWnd,LONG    lStyle){return ::SetWindowLong( pWnd->m_hWnd,GWL_STYLE,lStyle   );}
inline	LONG    SetStyle   (CWnd &sWnd,LONG    lStyle){return ::SetWindowLong( sWnd .m_hWnd,GWL_STYLE,lStyle   );}

inline	LONG    SetStyleEx (HWND  hWnd,LONG    lStyle){return ::SetWindowLong(         hWnd,GWL_EXSTYLE,lStyle   );}
inline	LONG    SetStyleEx (CWnd *pWnd,LONG    lStyle){return ::SetWindowLong( pWnd->m_hWnd,GWL_EXSTYLE,lStyle   );}
inline	LONG    SetStyleEx (CWnd &sWnd,LONG    lStyle){return ::SetWindowLong( sWnd .m_hWnd,GWL_EXSTYLE,lStyle   );}

inline	LPARAM  SetWndData (HWND  hWnd,LPARAM  lData ){return ::SetWindowLongPtr(         hWnd,GWL_USERDATA,(LPARAM)lData);}
inline	LPARAM  SetWndData (CWnd *pWnd,LPARAM  lData ){return ::SetWindowLongPtr( pWnd->m_hWnd,GWL_USERDATA,(LPARAM)lData);}
inline	LPARAM  SetWndData (CWnd &sWnd,LPARAM  lData ){return ::SetWindowLongPtr( sWnd .m_hWnd,GWL_USERDATA,(LPARAM)lData);}
inline	LPARAM  SetWndData (HWND  hWnd,void   *pData ){return ::SetWindowLongPtr(         hWnd,GWL_USERDATA,(LPARAM)pData);}
inline	LPARAM  SetWndData (CWnd *pWnd,void   *pData ){return ::SetWindowLongPtr( pWnd->m_hWnd,GWL_USERDATA,(LPARAM)pData);}
inline	LPARAM  SetWndData (CWnd &sWnd,void   *pData ){return ::SetWindowLongPtr( sWnd .m_hWnd,GWL_USERDATA,(LPARAM)pData);}

inline	WNDPROC SetWndProc (HWND  hWnd,WNDPROC pProc ){return (WNDPROC)::SetWindowLongPtr(         hWnd,GWL_WNDPROC,(LPARAM)pProc );}
inline	WNDPROC SetWndProc (CWnd *pWnd,WNDPROC pProc ){return (WNDPROC)::SetWindowLongPtr( pWnd->m_hWnd,GWL_WNDPROC,(LPARAM)pProc );}
inline	WNDPROC SetWndProc (CWnd &sWnd,WNDPROC pProc ){return (WNDPROC)::SetWindowLongPtr( sWnd .m_hWnd,GWL_WNDPROC,(LPARAM)pProc );}

inline	WNDPROC SetThisProc(HWND  hWnd,WNDPROC pProc ){SetWndData(hWnd,GetWndProc(hWnd));return SetWndProc(hWnd,pProc);}
inline	WNDPROC SetThisProc(CWnd *pWnd,WNDPROC pProc ){SetWndData(pWnd,GetWndProc(pWnd));return SetWndProc(pWnd,pProc);}
inline	WNDPROC SetThisProc(CWnd &sWnd,WNDPROC pProc ){SetWndData(sWnd,GetWndProc(sWnd));return SetWndProc(sWnd,pProc);}



inline	HCURSOR SetCursor(const TCHAR *lId){return ::SetCursor(::LoadCursor(0,lId));}


//*****************************************************************************
//*
//*		Dialog Funktioen
//*
//*****************************************************************************
#define StaticBitmapSet(lId,Bm)	((CStatic*)GetDlgItem(lId))->SetBitmap((HBITMAP)LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(Bm),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS))
#define StaticBitmapReset(lId)	DeleteObject(((CStatic*)GetDlgItem(lId))->GetBitmap())
#define ShowDlgItem(lId,bOn)	GetDlgItem(lId)->ShowWindow((bOn)? SW_SHOW:SW_HIDE)
#define EnableDlgItem(lId,bOn)	GetDlgItem(lId)->EnableWindow(bOn)
#define GetDlgItemRect(lId,pRe)	GetDlgItem(lId)->GetClientRect(pRe)
#define GetDlgProgressCtrl(lId)	((CProgressCtrl*)GetDlgItem(lId))
#define GetDlgSliderCtrl(lId)	((CSliderCtrl*)GetDlgItem(lId))
#define GetDlgComboBox(lId)		((CComboBox*)GetDlgItem(lId))
#define GetDlgListCtrl(lId)		((CListCtrl*)GetDlgItem(lId))
#define GetDlgTreeCtrl(lId)		((CTreeCtrl*)GetDlgItem(lId))
#define GetDlgTabCtrl(lId)		((CTabCtrl*)GetDlgItem(lId))
#define GetDlgListBox(lId)		((CListBox*)GetDlgItem(lId))
#define GetDlgButton(lId)		((CButton*)GetDlgItem(lId))
#define GetDlgStatic(lId)		((CStatic*)GetDlgItem(lId))
#define GetDlgEdit(lId)			((CEdit*)GetDlgItem(lId))
#define SetDlgDefID(lId)		{SetDefID(lId);PostMessage(WM_NEXTDLGCTL,(WPARAM)(GetDlgItem(lId)->m_hWnd),1);}
#define SetDlgFocus(lId)		{PostMessage(WM_NEXTDLGCTL,(WPARAM)(GetDlgItem(lId)->m_hWnd),1);}


#if    _MFC_VER >= 0x0700
#ifndef Enable3dControls
#define	Enable3dControls()
#endif
#ifndef Enable3dControlsStatic
#define	Enable3dControlsStatic()
#endif
#endif

#endif
