//*****************************************************************************
//*
//*
//*		AlternateList.cpp
//*
//*
//*****************************************************************************
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#include	<Afx.h>
#include	<AfxCmn.h>
#include	"AlternateList.h"


BEGIN_MESSAGE_MAP(CAlternateList, CListCtrl)
	//{{AFX_MSG_MAP(CAlternateList)
	ON_WM_DRAWITEM()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CAlternateList::CAlternateList()
{

	m_iGroupViewSize = -1;
	m_iIsAttached	 =  0;
	m_pImages		 =  0;

}


//*****************************************************************************
//*
//*		Assign
//*
//*****************************************************************************
//	Dockt das Fenster an ein bestehendes an
//	hWnd		: Ist das Fenster zum
BOOL CAlternateList::Attach(HWND hWnd)
{
unsigned	uStyle;


	ASSERT(IsWindow(hWnd));

	if(!CWnd::Attach(hWnd))return FALSE;

	uStyle  =  GetWindowLong(hWnd,GWL_STYLE);
	uStyle &= ~LVS_TYPEMASK;
	uStyle |=  LVS_REPORT|LVS_OWNERDRAWFIXED;

	SetWindowLong(hWnd,GWL_STYLE,uStyle);

	m_iIsAttached = TRUE;


return TRUE;
}


//*****************************************************************************
//*
//*		Detach
//*
//*****************************************************************************
HWND CAlternateList::Detach()
{
HWND	hWnd;


	ASSERT(m_iIsAttached);

	hWnd = CWnd::Detach();

	m_iIsAttached = FALSE;


return hWnd;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CAlternateList::OnDestroy()
{

	if(m_iIsAttached)
		{
		Detach();
		}

	CListCtrl::OnDestroy();

}

//*****************************************************************************
//*
//*		DrawItem
//*
//*****************************************************************************
void CAlternateList::DrawItem(LPDRAWITEMSTRUCT pDraw)
{
TCHAR		cText[256];
int			aOff [256];
CDC		   *pDc;
HWND		hWnd;
CRect		sRect;
CRect		sDown;
CRect		sLast;
LVITEM		sItem;
SIZE		sFrame;
COLORREF	uColor1;
COLORREF	uColor2;
COLORREF	uColor3;
int			iCount;
int			iState;
int			iItem;
int			iSize;
int			iPos;
int			iLen;
int			iEnd;
int			iAdd;
int			iOff;
int			i;




	iItem	= pDraw->itemID;
	hWnd	= pDraw->hwndItem;
	sRect	= pDraw->rcItem;
	iState	= pDraw->itemState;
	i		= sRect.right-sRect.left;						// nderung der Spaltenbreiten

	if(i!=m_iGroupViewSize)
		{
		m_iGroupViewSize = i;
		m_iColumnCount   = 0;
		m_pImages	     = GetImageList(LVSIL_SMALL);

		for(iPos=0;iPos<10;iPos++)
			{
			LVCOLUMN	sColumn;

			sColumn.mask  = LVCF_WIDTH|LVCF_FMT;
			if(!GetColumn(iPos,&sColumn))break;
			m_aGroupSize[iPos] = sColumn.cx;
			m_aGroupMode[iPos] = TA_LEFT;

			if(sColumn.fmt&LVCFMT_RIGHT )m_aGroupMode[iPos] = TA_RIGHT;
			if(sColumn.fmt&LVCFMT_CENTER)m_aGroupMode[iPos] = TA_CENTER;
			}

		m_iColumnCount = iPos;

		if(iPos>0)
			{
			m_aGroupSize[iPos-1]--;
			}
		}


	pDc		= CDC::FromHandle(pDraw->hDC);
	uColor1 = GetSysColor(COLOR_WINDOW);
	uColor3 = GetSysColor(COLOR_3DFACE);

	if(iItem&1)
		{													// Hintergrund Farbe
		uColor2  = GetSysColor(COLOR_INFOBK);

		if(!((uColor1^uColor2)&0xFCFCFC))
			{
			uColor2 = uColor2^0x101000;
			}

		uColor1 = uColor2;
		}

	if(iState&ODS_SELECTED)
		{
		uColor2 = GetSysColor(COLOR_MENU);
		uColor1 = ((uColor1>>2)&0x3F3F3F)*3;
		uColor1+= ((uColor2>>2)&0x3F3F3F);
		}

	if(iState&ODS_FOCUS)
		{
		uColor2 = GetSysColor(COLOR_HIGHLIGHT);
		uColor1 = ((uColor1>>2)&0x3F3F3F)*3;
		uColor1+= ((uColor2>>2)&0x3F3F3F);
		}



	pDc->SelectStockObject(NULL_PEN);
	pDc->SetBkMode (TRANSPARENT);
	pDc->SetTextColor(GetSysColor(COLOR_WINDOWTEXT));
	pDc->SetBkColor(uColor1);

	sDown		= sRect;
	sDown.top	= sDown.bottom-1;

	iEnd  = sRect.right;
			sRect.right = sRect.left;
			sRect.bottom-=1;

	sLast = sRect;
	sLast.bottom+=1;


	for(iPos=0;iPos<m_iColumnCount;iPos++)					// Spalten zeichnen
		{
		   sRect.left  =sRect.right;
		   sRect.right+=m_aGroupSize[iPos];
		if(sRect.right<0)continue;


		sItem.mask		 = LVIF_TEXT|LVIF_IMAGE;
		sItem.iItem		 = iItem;
		sItem.iSubItem	 = iPos;
		sItem.pszText	 = cText;
		sItem.cchTextMax = sizeof(cText)/sizeof(cText[0]);

		iOff = (!iPos && m_pImages)? 16:0;

		GetItem(&sItem);

		iLen	= (int)_tcslen(cText);
		iCount	= iLen;
		iAdd	= sRect.Height()/2-7;
		if(iAdd<0)iAdd=0;

		GetTextExtentExPoint(pDc->m_hDC,cText,iLen,m_aGroupSize[iPos]-4-iOff,&iCount,aOff,&sFrame);

		if(iCount<iLen)										// Passen alle Buchstaben in die Spalte
			{
			iSize	= m_aGroupSize[iPos]-3*4-2-iOff;
			if(iSize<0)iSize=0;
			GetTextExtentExPoint(pDc->m_hDC,cText,iLen,iSize,&iCount,aOff,&sFrame);
			if(iCount<0)iCount=0;

			iLen    = iCount+3;
			memcpy(cText+iCount,_T("..."),4);
			pDc->SetTextAlign(TA_LEFT);
			pDc->ExtTextOut(sRect.left+2+iOff,sRect.top+iAdd,ETO_OPAQUE|ETO_CLIPPED,&sRect,cText,iLen,NULL);
			}
		else{
			switch(m_aGroupMode[iPos])
				{
			default:		pDc->SetTextAlign(TA_LEFT);
							pDc->ExtTextOut(sRect.left+2+iOff,sRect.top+iAdd,ETO_OPAQUE|ETO_CLIPPED,&sRect,cText,iLen,NULL);
							break;
			case TA_RIGHT:	pDc->SetTextAlign(TA_RIGHT);
							pDc->ExtTextOut(sRect.left-3+iOff+m_aGroupSize[iPos],sRect.top+iAdd,ETO_OPAQUE|ETO_CLIPPED,&sRect,cText,iLen,NULL);
							break;
			case TA_CENTER:	pDc->SetTextAlign(TA_CENTER);
							pDc->ExtTextOut(sRect.left+iOff+m_aGroupSize[iPos]/2,sRect.top+iAdd,ETO_OPAQUE|ETO_CLIPPED,&sRect,cText,iLen,NULL);
							break;
				}
			}

		if(iPos==0 && m_pImages)
			{
			m_pImages->Draw(pDc,sItem.iImage,CPoint(sRect.left+1,sRect.top),ILD_TRANSPARENT);
			}


		sLast.left  = sRect.left-1;
		sLast.right = sRect.left;
		pDc->SetBkColor(uColor3);
		pDc->ExtTextOut(0,0,ETO_OPAQUE|ETO_CLIPPED,&sLast,_T(""),0,NULL);
		pDc->SetBkColor(uColor1);
		}

	sLast.left  = iEnd;
	sLast.right = iEnd-1;
	pDc->SetBkColor(uColor3);
	pDc->ExtTextOut(0,0,ETO_OPAQUE|ETO_CLIPPED,&sLast,_T(""),0,NULL);
	pDc->SetBkColor(uColor3);
	pDc->ExtTextOut(0,0,ETO_OPAQUE|ETO_CLIPPED,&sDown,_T(""),0,NULL);

}


