//*****************************************************************************
//*
//*
//*		AnsiMessage.h
//*
//*
//*****************************************************************************
#ifndef		__ANSIMESSAGE_H__
#define 	__ANSIMESSAGE_H__

#if _MSC_VER >= 1000
#pragma once
#endif

//*****************************************************************************
//*
//*		Ansi-Message Funktionen
//*
//*****************************************************************************
//	ANSI_PROC(CApp)		einfgen in CMainFrame.cpp
//	ON_ANSI_MESSAGE()	einfgen in CMainFrame.cpp in die MessageMap
//	DECLARE_ANSI_PROC()	einfgen in CMainFrame.h   im public Teil

#define ON_ANSI_MESSAGE()																\
				ON_MESSAGE(WM_ANSIINFO,OnAnsiInfo)

#define DECLARE_ANSI_PROC()																\
				afx_msg LRESULT OnAnsiInfo(WPARAM wParam, LPARAM lParam);


#define ANSI_PROC(CMainFrame)															\
				LRESULT CMainFrame::OnAnsiInfo(WPARAM wParam, LPARAM lParam)			\
				{																		\
				CView	*pView=GetActiveView();											\
				if(!pView)return 0;														\
				return pView->SendMessage(WM_ANSIINFO,wParam,lParam);					\
				}


//*****************************************************************************
//*
//*		Nachrichten Funktionen
//*
//*****************************************************************************

#define 	WM_ANSIINFO			0x27F3					// Nachricht fr Info Funktion
#define 	ANSI_SETCURSOR		0x0000					// Cursor-Position setzen
#define 	ANSI_GETCURSOR		0x0001					// Cursor-Position lesen
#define 	ANSI_SETSCROLL		0x0002					// Scroll-Position setzen
#define 	ANSI_GETSCROLL		0x0003					// Scroll-Position lesen
#define 	ANSI_SETMARK		0x0004					// Marken-Position setzen
#define 	ANSI_GETMARK		0x0005					// Marken-Position lesen

#define		WND_SETCURSOR(Wnd,Point)	(CPoint)(Wnd)->SendMessage(WM_ANSIINFO,ANSI_SETCURSOR,MAKELONG(Point.x,Point.y))
#define		WND_GETCURSOR(Wnd)			(CPoint)(Wnd)->SendMessage(WM_ANSIINFO,ANSI_GETCURSOR,0)
#define		WND_SETSCROLL(Wnd,Point)	(CPoint)(Wnd)->SendMessage(WM_ANSIINFO,ANSI_SETSCROLL,MAKELONG(Point.x,Point.y))
#define		WND_GETSCROLL(Wnd)			(CPoint)(Wnd)->SendMessage(WM_ANSIINFO,ANSI_GETSCROLL,0)
#define		WND_SETMARK(Wnd,Point)		(CPoint)(Wnd)->SendMessage(WM_ANSIINFO,ANSI_SETMARK  ,MAKELONG(Point.x,Point.y))
#define		WND_GETMARK(Wnd)			(CPoint)(Wnd)->SendMessage(WM_ANSIINFO,ANSI_GETMARK  ,0)

#endif
