//*****************************************************************************
//*
//*
//*		AppMessage.h
//*
//*
//*****************************************************************************
#ifndef		__APPMESSAGE_H__
#define 	__APPMESSAGE_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#include	<string.h>

//*****************************************************************************
//*
//*		Nachrichten fr die Steuerung von Applikationen
//*
//*****************************************************************************

#define 	WM_APPINFO			0x27F5				// Nachricht fr Info Funktion
#define 	APP_EXIT			0x0000				// Programm beenden
#define 	APP_LOADFILE		0x0001				// Dateiladen
#define 	APP_GETDOCNAME		0x0002				// Hole Dateinamen
#define 	APP_CMPDOCNAME		0x0003				// Hole Dateinamen
#define 	APP_GETRECDOCNAME	0x0004				// Hole empangenen Dateinamen
#define 	APP_FINDTEXT		0x0005				// NAch einem Text suchen
#define 	APP_USEUNICODE		0x8000				// Texte werden im UNICODE Format bertragen

#define		APPWND_EXIT(pWnd)				(pWnd)->SendMessage(WM_APPINFO,APP_EXIT,0)
#define		APPWND_GETDOCNAME(pWnd)			(pWnd)->SendMessage(WM_APPINFO,APP_GETDOCNAME,(LPARAM)::GetActiveWindow())
#define		APPWND_CMPDOCNAME(pWnd,pFile)	(pWnd)->SendMessage(WM_COPYDATA,(WPARAM)::GetActiveWindow(),(LPARAM)MakeCopyData((WM_APPINFO<<16)|APP_CMPDOCNAME,(void*)((LPCTSTR)pFile),(_tcslen(pFile)+1)*sizeof(TCHAR)))
#define		APPWND_LOADFILE(pWnd,pFile)		(pWnd)->SendMessage(WM_COPYDATA,(WPARAM)::GetActiveWindow(),(LPARAM)MakeCopyData((WM_APPINFO<<16)|APP_LOADFILE  ,(void*)((LPCTSTR)pFile),(_tcslen(pFile)+1)*sizeof(TCHAR)))
#define		APPWND_FINDTEXT(pWnd,pText)		(pWnd)->SendMessage(WM_COPYDATA,(WPARAM)::GetActiveWindow(),(LPARAM)MakeCopyData((WM_APPINFO<<16)|APP_FINDTEXT  ,(void*)((LPCTSTR)pText),(_tcslen(pText)+1)*sizeof(TCHAR)))



//*****************************************************************************
//*
//*		App-Message Funktionen fr den Empfnger und Empfnger
//*
//*****************************************************************************
//	APP_PROC(CMainFrame)	einfgen in CMainFrame.cpp
//	ON_APP_MESSAGE()		einfgen in CMainFrame.cpp in die MessageMap
//	DECLARE_APP_PROC()		einfgen in CMainFrame.h   im public Teil


inline	LPCTSTR GET_RECDOCNAME()
			{
			LPCTSTR	pPtr;
			pPtr=(LPCTSTR)AfxGetMainWnd()->SendMessage(WM_APPINFO,APP_GETRECDOCNAME);
			if(IsBadReadPtr(pPtr,1))return 0;
			return pPtr;
			}

#define ON_APP_MESSAGE()																	\
			ON_MESSAGE(WM_APPINFO,OnAppInfo)												\
			ON_WM_COPYDATA()

#define DECLARE_APP_PROC()																	\
			public:																			\
			afx_msg BOOL    OnCopyData(CWnd *pWnd,COPYDATASTRUCT *pCopyDataStruct );		\
			afx_msg LRESULT OnAppInfo(WPARAM wParam,LPARAM lParam);							\
			LPCTSTR			GetRecDocName();												\
			protected:																		\
			CString			sRecDocName;													\
			public:

#define APP_PROC(CMainFrame)																\
			BOOL CMainFrame::OnCopyData(CWnd *pWnd,COPYDATASTRUCT *pCopyData)				\
				{																			\
				TCHAR	cPath[MAX_PATH];													\
																							\
				ConvertStringToT(pCopyData,cPath,sizeof(cPath));							\
				if(pCopyData->dwData==((WM_APPINFO<<16)|APP_GETDOCNAME))					\
					{																		\
					sRecDocName=(TCHAR*)pCopyData->lpData;									\
					return TRUE; 															\
					}																		\
				if(pCopyData->dwData==((WM_APPINFO<<16)|APP_CMPDOCNAME))					\
					{																		\
					CDocument	   *pDoc=0;													\
					CView          *pView=GetActiveView();									\
					CString			sName;													\
					if( pView)pDoc=pView->GetDocument();									\
					if(!pDoc )sName="";														\
					else	  sName=pDoc->GetPathName();									\
					return (CmpFileName(sName,(TCHAR*)pCopyData->lpData))? 0:1; 			\
					}																		\
				if(pCopyData->dwData!=((WM_APPINFO<<16)|APP_LOADFILE))return FALSE;			\
				CWinApp	*pApp=AfxGetApp();													\
				if(!pApp->OpenDocumentFile((TCHAR*)pCopyData->lpData))return FALSE;			\
				return TRUE;																\
				}																			\
			LPCTSTR	CMainFrame::GetRecDocName()												\
				{																			\
				return (LPCTSTR)sRecDocName;												\
				}																			\
			LRESULT CMainFrame::OnAppInfo(WPARAM wParam,LPARAM lParam)						\
				{																			\
				switch(wParam)																\
						{																	\
				case APP_EXIT:																\
						return PostMessage(WM_COMMAND,ID_APP_EXIT);							\
				case APP_GETDOCNAME:{														\
						COPYDATASTRUCT	sData;												\
						CDocument	   *pDoc=0;												\
						CView          *pView=GetActiveView();								\
						CString			sName;												\
						if( pView)pDoc=pView->GetDocument();								\
						if(!pDoc )sName=_T("");												\
						else	  sName=pDoc->GetPathName();								\
						sData.cbData=(_tcslen(sName)+1)*sizeof(TCHAR);						\
						sData.dwData=(WM_APPINFO<<16)|APP_GETDOCNAME;						\
						sData.lpData=(void*)((LPCTSTR)sName);								\
						return ::SendMessage((HWND)lParam,WM_COPYDATA,(WPARAM)::GetActiveWindow(),(LPARAM)&sData);\
						}																	\
				case APP_GETRECDOCNAME:	return (UINT)((LPCTSTR)sRecDocName);				\
						}																	\
				return 0;																	\
				}



//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	COPYDATASTRUCT *MakeCopyData(int iId,void *pMem,int iLen)
{
static  COPYDATASTRUCT	sCopyData;

	#ifdef UNICODE
	iId |= APP_USEUNICODE;
	#endif

	sCopyData.dwData = iId;
	sCopyData.cbData = iLen;
	sCopyData.lpData = pMem;


return &sCopyData;
};

inline void ConvertStringToT(COPYDATASTRUCT *pCopyData,void *pBuffer,int iSize)
{
	#ifdef UNICODE
	if(!(pCopyData->dwData&APP_USEUNICODE))
		{
		pCopyData->dwData |= APP_USEUNICODE;
		MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,(char*)pCopyData->lpData,pCopyData->cbData,(TCHAR*)pBuffer,iSize/2-1);
		pCopyData->cbData *= 2;
		pCopyData->lpData  = pBuffer;
		}
	else{
		pCopyData->dwData &= ~APP_USEUNICODE;
		}
	#else
	if(pCopyData->dwData&APP_USEUNICODE)
		{
		pCopyData->dwData &= ~APP_USEUNICODE;
		WideCharToMultiByte(CP_ACP,0,(wchar_t*)pCopyData->lpData,pCopyData->cbData/2,(TCHAR*)pBuffer,iSize-1,NULL,NULL);
		pCopyData->cbData /= 2;
		pCopyData->lpData  = pBuffer;
		}
	#endif
}

#endif
