//*****************************************************************************
//*
//*
//*		BitmapWnd.cpp
//*
//*
//*****************************************************************************
//
//	CBitmapWnd ist ein Fenster mit einem hinterlegten Bitmap.
//	Es ist mglich direct in den Bildspeicher ber eine BitmapImage
//	Klasse direkt auf den Bildspeicher zu zu greifen.
//	Copyright Anton Zechner (C) 2010
//
#include	"BitmapWnd.h"

#ifdef	    _MSC_VER
#pragma		 warning( disable :4996 )
#endif

#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 BMI_SIZE		  (sizeof(BITMAPINFOHEADER)+256*sizeof(RGBQUAD))
#define 	 ID_DOSIZEING	  0x6986
#ifndef		 SetClassLongPtr
#define		 SetClassLongPtr  SetClassLong
#endif
#ifndef		 GetClassLongPtr
#define		 GetClassLongPtr  GetClassLong
#endif


BEGIN_MESSAGE_MAP(CBitmapWnd,CWnd)
	//{{AFX_MSG_MAP(CBitmapWnd)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_DESTROY()
	ON_WM_SETCURSOR()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MBUTTONDBLCLK()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_DOSIZEING,OnDoSizing)
END_MESSAGE_MAP()


TCHAR	CBitmapWnd::m_cClassName[40];				// Klassenname

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CBitmapWnd::CBitmapWnd()
{
LPCTSTR		pName;


	m_sMemDC.CreateCompatibleDC(NULL);

	m_pMainWnd		= GetDesktopWindow();
	m_pMainDc		= m_pMainWnd->GetDC();
	m_iBits			= GetDeviceCaps(m_pMainDc->m_hDC,BITSPIXEL);
	m_pImage		= new BitmapImage;
	m_uBkColor		= RGB(255,255,255);
	m_iMaxSizeX		= 16000;
	m_iMaxSizeY		= 16000;
	m_iMinSizeX		= 0;
	m_iMinSizeY		= 0;
	m_iShowScrollY	= 0;
	m_iShowScrollX	= 0;
	m_bHasScrollX	= 0;
	m_bHasScrollY	= 0;
	m_bZeroScroll	= 0;
	m_bDoCenter		= 0;
	m_iScrollX		= 0;
	m_iScrollY		= 0;
	m_hBitmap		= 0;
	m_hCursor		= 0;
	m_iWndSizeX		= 0;
	m_iWndSizeY		= 0;
	m_iLockCnt		= 0;
	m_pDrawParam	= 0;
	m_pDrawCB		= 0;
	m_pMouseParam	= 0;
	m_pMouseCB		= 0;


	if(!m_cClassName[0])									// Neue Klasse erzeugen
		{
		pName = AfxRegisterWndClass(CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW,LoadCursor(NULL,IDC_ARROW),(HBRUSH)GetStockObject(NULL_BRUSH));
		_tcscpy(m_cClassName,pName);
		}

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CBitmapWnd::~CBitmapWnd()
{

	if(m_hBitmap)DeleteObject(m_hBitmap);

	if(m_pMainWnd->m_hWnd && IsWindow(m_pMainWnd->m_hWnd))
		{
		m_pMainWnd->ReleaseDC(m_pMainDc);
		}

	m_sMemDC.DeleteDC();

	delete m_pImage;

}

//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
BOOL CBitmapWnd::CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID)
{
UINT	uBar;
BOOL	bOk;



	m_bDoCenter		= (dwStyle&CBW_CENTER    )? TRUE:FALSE;
	m_bFixedSize	= (dwStyle&CBW_FIXED_SIZE)? TRUE:FALSE;

	bOk = CWnd::CreateEx(dwExStyle,m_cClassName,_T(""),dwStyle,sRect,pParentWnd,nID);

	if(bOk && m_iMinSizeX>0 && m_iMinSizeY>0)
	if((int)m_pImage->Width()<m_iMinSizeX || (int)m_pImage->Height()<m_iMinSizeY)
		{
		CreateImage(m_iMinSizeX,m_iMinSizeY);
		}

	m_hCursor		= LoadCursor(NULL,IDC_ARROW);
	m_bHasScrollX	= (dwStyle&CBW_SCROLL_X   )? TRUE:FALSE;
	m_bHasScrollY	= (dwStyle&CBW_SCROLL_Y   )? TRUE:FALSE;
	m_iShowScrollX	= (dwStyle&CBW_SHOW_SCR_X )? TRUE:FALSE;
	m_iShowScrollY	= (dwStyle&CBW_SHOW_SCR_Y )? TRUE:FALSE;
	m_bZeroScroll	= (dwStyle&CBW_ZERO_SCROLL)? TRUE:FALSE;

	if(m_bHasScrollX || m_bHasScrollY)
	if(m_iWndSizeX>0 && m_iWndSizeX>0 && bOk)
		{
		if(m_bHasScrollX && m_bHasScrollY)
			{
			uBar = SB_BOTH;
			}
		else if(m_bHasScrollY)
			{
			uBar = SB_VERT;
			}
		else{
			uBar = SB_HORZ;
			}

		ShowScrollBar(uBar,TRUE);
		UpdateScroll(m_iScrollX,m_iScrollY);
		UpdateScrollInfo();
		}



return bOk;
}

//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
//	Erzeugt das Fenster ber einem Dialog-Item.
BOOL CBitmapWnd::CreateEx(DWORD dwExStyle,DWORD dwStyle,unsigned uId,CDialog *pDlg,UINT nID)
{
CPoint	sPoint(0,0);
CRect	sRect;
CWnd   *pWnd;
BOOL	bOk;


	pWnd=pDlg->GetDlgItem(uId);
	ASSERT(pWnd!=0);


	pWnd->GetWindowRect (&sRect);
	pDlg->ClientToScreen(&sPoint);

	sRect.left	  -= sPoint.x;
	sRect.right   -= sPoint.x;
	sRect.top	  -= sPoint.y;
	sRect.bottom  -= sPoint.y;

	
	m_hCursor		= LoadCursor(NULL,IDC_ARROW);
	m_bDoCenter	    = (dwStyle&CBW_CENTER     )? TRUE:FALSE;
	m_bFixedSize    = (dwStyle&CBW_FIXED_SIZE )? TRUE:FALSE;
	m_iShowScrollX	= (dwStyle&CBW_SHOW_SCR_X )? TRUE:FALSE;
	m_iShowScrollY	= (dwStyle&CBW_SHOW_SCR_Y )? TRUE:FALSE;
	m_bZeroScroll	= (dwStyle&CBW_ZERO_SCROLL)? TRUE:FALSE;


	bOk = CWnd::CreateEx(dwExStyle,m_cClassName,_T(""),dwStyle,sRect,pDlg,nID);


	if(bOk)SetWindowPos(pWnd,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOREDRAW);
	if(bOk && m_iMinSizeX>0 && m_iMinSizeY>0)
	if((int)m_pImage->Width()<m_iMinSizeX || (int)m_pImage->Height()<m_iMinSizeY)
		{
		CreateImage(m_iMinSizeX,m_iMinSizeY);
		}

	m_bHasScrollX	= (dwStyle&CBW_SCROLL_X)? TRUE:FALSE;
	m_bHasScrollY	= (dwStyle&CBW_SCROLL_Y)? TRUE:FALSE;

	if(m_bHasScrollX || m_bHasScrollY)
	if(m_iWndSizeX>0 && m_iWndSizeX>0 && bOk)
		{
		if(m_bHasScrollX)ShowScrollBar(SB_HORZ,TRUE);
		if(m_bHasScrollY)ShowScrollBar(SB_VERT,TRUE);
		UpdateScroll(m_iScrollX,m_iScrollY);
		UpdateScrollInfo();
		}


return TRUE;

}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CBitmapWnd::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int			iPicSizeX;
int			iPicSizeY;


	m_sLockSem.Lock();

	iPicSizeX = iSizeX;
	iPicSizeY = iSizeY;

	if(m_bFixedSize)									// Das Bild hat immer die gleiche Gre
		{
		iPicSizeX = m_iMinSizeX;
		iPicSizeY = m_iMinSizeY;
		}
	else{
		if(iPicSizeX>m_iMaxSizeX)iPicSizeX=m_iMaxSizeX;
		if(iPicSizeY>m_iMaxSizeY)iPicSizeY=m_iMaxSizeY;
		if(iPicSizeX<m_iMinSizeX)iPicSizeX=m_iMinSizeX;
		if(iPicSizeY<m_iMinSizeY)iPicSizeY=m_iMinSizeY;
		}

	if(iPicSizeX>0 && iPicSizeY>0 && !m_iLockCnt)		// Hat sich die Gre verndert
	if(iPicSizeX!=(int)m_pImage->Width() || iPicSizeY!=(int)m_pImage->Height())
		{
		CreateImage(iPicSizeX,iPicSizeY);
		}

	m_sLockSem.Unlock();


	if(m_pImage  && iSizeX>0 && iSizeY>0)				// Scrollbars anpassen
	if(m_iWndSizeX!=iSizeX || m_iWndSizeY!=iSizeY)
		{
		m_iWndSizeX	= iSizeX;
		m_iWndSizeY	= iSizeY;

		UpdateScrollInfo();
		UpdateScroll(m_iScrollX,m_iScrollY);
		}

	CWnd::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CBitmapWnd::OnDestroy()
{


	m_iWndSizeX = 0;
	m_iWndSizeY = 0;


	CWnd::OnDestroy();

}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CBitmapWnd::OnPaint()
{
PAINTSTRUCT		sPaint;
RECT			sRect;
CRect			sArea;
HRGN			hRegion;
int				iStartX;
int				iStartY;
int				iSizeX;
int				iSizeY;
int				iPosX;
int				iPosY;
int				iImgX;
int				iImgY;
CDC			   *pDc;


	pDc = BeginPaint(&sPaint);

	GetClientRect(&sArea);

	if(sArea!=sPaint.rcPaint)
		{
		hRegion = CreateRectRgn(sPaint.rcPaint.left,sPaint.rcPaint.top,sPaint.rcPaint.right,sPaint.rcPaint.bottom);
		pDc->SelectObject(CRgn::FromHandle(hRegion));
		}
	else{
		hRegion = NULL;
		}



	if(m_pImage->IsOk())									// Ist das Bild OK
		{
		iImgX = m_pImage->Width();
		iImgY = m_pImage->Height();

		if(iImgX>m_iMaxSizeX)iImgX=m_iMaxSizeX;
		if(iImgY>m_iMaxSizeY)iImgY=m_iMaxSizeY;

		if(m_iScrollX<0)
			{
			iPosX	= -m_iScrollX;
			iSizeX	=  iImgX;
			iStartX	=  0;
			}
		else{
			iPosX	=  0;
			iSizeX	=  iImgX-m_iScrollX;
			iStartX	=  m_iScrollX;
			}

		if(m_iScrollY<0)
			{
			iPosY	= -m_iScrollY;
			iSizeY	=  iImgY;
			iStartY	=  0;
			}
		else{
			iPosY	=  0;
			iSizeY	=  iImgY-m_iScrollY;
			iStartY	=  m_iScrollY;
			}

		pDc->BitBlt(sArea.left+iPosX,
					sArea.top +iPosY,
					iSizeX,iSizeY,&m_sMemDC,
					iStartX,iStartY,SRCCOPY);


		if(iPosY)											// Ist oben etwas frei
			{
			sRect.left	 = sArea.left;
			sRect.right	 = sArea.right;
			sRect.top	 = sArea.top;
			sRect.bottom = sArea.top+iPosY;

			pDc->SetBkColor(m_uBkColor);
			pDc->ExtTextOut(0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
			}

		if(iPosX)											// Ist links etwas frei
			{
			sRect.left	 = sArea.left;
			sRect.right	 = sArea.left+iPosX;
			sRect.top	 = sArea.top +iPosY;
			sRect.bottom = sArea.top +iPosY+iImgY;

			pDc->SetBkColor(m_uBkColor);
			pDc->ExtTextOut(0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
			}

		if(iImgY<m_iWndSizeY)								// Ist unten etwas frei
			{
			sRect.left	 = sArea.left;
			sRect.right	 = sArea.right;
			sRect.top	 = sArea.top+iImgY+iPosY;
			sRect.bottom = sArea.bottom;

			pDc->SetBkColor(m_uBkColor);
			pDc->ExtTextOut(0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
			}

		if(iImgX<m_iWndSizeX)								// Ist rechts etwas frei
			{
			sRect.left	 = sArea.left  +iPosX+iImgX;
			sRect.right	 = sArea.right;
			sRect.top	 = sArea.top +iPosY;
			sRect.bottom = sArea.top +iPosY+iImgY;

			pDc->SetBkColor(m_uBkColor);
			pDc->ExtTextOut(0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
			}
		}
	else{
		pDc->SetBkColor(RGB(0,0,0));
		pDc->ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
		}


	if(m_pDrawCB)
		{
		pDc->OffsetWindowOrg(m_iScrollX,m_iScrollY);
		m_pDrawCB(m_pDrawParam,pDc,&sPaint);
		}


	if(hRegion)
		{
		DeleteObject(hRegion);
		}

	EndPaint(&sPaint);

}

//*****************************************************************************
//*
//*		CreateImage
//*
//*****************************************************************************
void CBitmapWnd::CreateImage(int iSizeX,int iSizeY)
{
char			sInfo[BMI_SIZE];
unsigned		uPixel;
BITMAPINFO	   *pInfo;
LPVOID			pData;
HBITMAP			hBmp;
HBITMAP			hOld;
BitmapImage	   *pImg;
int				iPos;



	iPos								= 1<<m_iBits;
	pInfo								= (BITMAPINFO*)sInfo;
	pInfo->bmiHeader.biSize				= sizeof(BITMAPINFOHEADER);
	pInfo->bmiHeader.biWidth		  	= iSizeX;
	pInfo->bmiHeader.biHeight	  		= iSizeY;
	pInfo->bmiHeader.biPlanes	  		= 1;
	pInfo->bmiHeader.biBitCount	  		= m_iBits;
	pInfo->bmiHeader.biCompression 		= BI_RGB;
	pInfo->bmiHeader.biSizeImage		= 0;
	pInfo->bmiHeader.biXPelsPerMeter	= 0;
	pInfo->bmiHeader.biYPelsPerMeter	= 0;
   	pInfo->bmiHeader.biClrUsed			= (m_iBits>8)? 0:iPos;
   	pInfo->bmiHeader.biClrImportant		= (m_iBits>8)? 0:iPos;

	hBmp = CreateDIBSection(m_pMainDc->m_hDC,pInfo,DIB_RGB_COLORS,&pData,0,0);

	ASSERT(hBmp!=0);


	if(m_iBits>8)											// Hintergrund Farbe
		{
		uPixel = pImg->SwapRGB(m_uBkColor);
		}
	else if(m_iBits==8)
		{
		uPixel = 15;
		}
	else{
		uPixel = (1<<m_iBits)-1;
		}

	pImg = new BitmapImage;									// Neues Bild erzeugen
	pImg->SetSize(m_iBits,iSizeX,iSizeY,uPixel,pData);

	if(m_iBits<=8)
		{
		PALETTEENTRY	aColors[256];

		GetSystemPaletteEntries(m_pMainDc->m_hDC,0,iPos,aColors);

		while(iPos>0)
			{
			iPos--;
			pImg->SetColor(iPos,aColors[iPos].peRed,aColors[iPos].peGreen,aColors[iPos].peBlue);
			}
		}

	if(m_pImage->IsOk())									// Altes Bild ins Neue kopieren
		{
		pImg->Put(*m_pImage,0,0);
		}

	SelectObject(m_sMemDC.m_hDC,hBmp);						// Neues Bild bernehmen
	
	hOld	  = m_hBitmap;
	m_hBitmap = hBmp;
	
	if(hOld)DeleteObject(hOld);
	

	if(m_pImage)delete m_pImage;
	m_pImage = pImg;

}

//*****************************************************************************
//*
//*		OnDoSizing
//*
//*****************************************************************************
void CBitmapWnd::OnDoSizing()
{

	OnSize(0,m_iWndSizeX,m_iWndSizeY);

}

//*****************************************************************************
//*
//*		On???
//*
//*****************************************************************************
void CBitmapWnd::OnLButtonDblClk(UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_LBUTTONDBLCLK,nFlags,sPoint);}}
void CBitmapWnd::OnMButtonDblClk(UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_MBUTTONDBLCLK,nFlags,sPoint);}}
void CBitmapWnd::OnRButtonDblClk(UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_RBUTTONDBLCLK,nFlags,sPoint);}}
void CBitmapWnd::OnLButtonDown  (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_LBUTTONDOWN  ,nFlags,sPoint);}}
void CBitmapWnd::OnMButtonDown  (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_MBUTTONDOWN  ,nFlags,sPoint);}}
void CBitmapWnd::OnRButtonDown  (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_RBUTTONDOWN  ,nFlags,sPoint);}}
void CBitmapWnd::OnLButtonUp    (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_LBUTTONUP    ,nFlags,sPoint);}}
void CBitmapWnd::OnMButtonUp    (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_MBUTTONUP    ,nFlags,sPoint);}}
void CBitmapWnd::OnRButtonUp    (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_RBUTTONUP    ,nFlags,sPoint);}}
void CBitmapWnd::OnMouseMove    (UINT nFlags,CPoint sPoint){if(m_pMouseCB){sPoint.x+=m_iScrollX;sPoint.y+=m_iScrollY;m_pMouseCB(m_pMouseParam,WM_MOUSEMOVE    ,nFlags,sPoint);}}
BOOL CBitmapWnd::OnMouseWheel   (UINT nFlags,short zDelta,CPoint sPoint)
{
	if(m_pMouseCB)
		{
		ScreenToClient(&sPoint);
		m_pMouseCB(m_pMouseParam,WM_MOUSEWHEEL,nFlags|(zDelta<<16),sPoint);
		}

return FALSE;
}

//*****************************************************************************
//*
//*		OnSetCursor
//*
//*****************************************************************************
BOOL CBitmapWnd::OnSetCursor(CWnd *pWnd,UINT nHitTest,UINT uMsg)
{
HWND	hWnd;


	hWnd = (pWnd)? pWnd->m_hWnd:NULL;

	if(hWnd==m_hWnd)							
		{
		::SetCursor(m_hCursor);
		return TRUE;
		}
	

return FALSE;
}


//*****************************************************************************
//*
//*		SetCursor
//*
//*****************************************************************************
//	Einen anderen Cursor fr's Fenster bestimmen. Das Cursor-Handle wird
//	dabei im Fenster permanent abgespeichert.
//	hCursor		: Ist das Handle des neuen Cursors (NULL=nur abfragen)
//	Ergibt das alte Cursor Handle
HCURSOR CBitmapWnd::SetCursor(HCURSOR hCursor)
{
HCURSOR		hOld;


	ASSERT(IsWindow(m_hWnd));

	if(m_hCursor==hCursor || !hCursor)
		{
		return m_hCursor;
		}

	hOld	  = m_hCursor;
	m_hCursor = hCursor;

	::SetCursor(hCursor);


return hOld;
}


//*****************************************************************************
//*
//*		Lock
//*
//*****************************************************************************
//	Sperrt das verndern des Bildes
int CBitmapWnd::Lock()
{

	m_sLockSem.Lock();
	m_iLockCnt++;
	m_sLockSem.Unlock();


return m_iLockCnt;
}

//*****************************************************************************
//*
//*		Unlock
//*
//*****************************************************************************
//	Entsperrt das verndern des Bildes
//	Ergibt 0 wenn entsperrt
int CBitmapWnd::Unlock()
{
BOOL	bDoSizing=FALSE;


	m_sLockSem.Lock();

	if(m_iLockCnt>0)
		{
		m_iLockCnt--;
		if(!m_iLockCnt)bDoSizing=TRUE;
		}

	m_sLockSem.Unlock();


	if(bDoSizing)PostMessage(WM_COMMAND,ID_DOSIZEING);


return m_iLockCnt;
}

//*****************************************************************************
//*
//*		SetDrawCallback
//*
//*****************************************************************************
void CBitmapWnd::SetDrawCallback(DrawCB pProc,void *pParam)
{
	m_pDrawCB	  = pProc;
	m_pDrawParam  = pParam;
}

//*****************************************************************************
//*
//*		SetMouseCallback
//*
//*****************************************************************************
void CBitmapWnd::SetMouseCallback(MouseCB pProc,void *pParam)
{
	m_pMouseCB	  = pProc;
	m_pMouseParam = pParam;

	ModifyStyle(0,SS_NOTIFY);
}

//*****************************************************************************
//*
//*		UpdateScroll
//*
//*****************************************************************************
//	Stellt eine neue Scroll-Position ein
//	iPosX/iPosY		: Ist die neue Position
//	Ergibt TRUE wenn die Scroll-Position verndert wurde.
BOOL CBitmapWnd::UpdateScroll(int iPosX,int iPosY)
{
BOOL	bChanged;
int		iDeltaX;
int		iDeltaY;
int		iSizeX;
int		iSizeY;


	bChanged = FALSE;

	if(!m_pImage)
		{
		if(m_iScrollX)
			{
			if(m_bHasScrollX)CWnd::SetScrollPos(SB_HORZ,0,TRUE);
			m_iScrollX=0;
			bChanged=TRUE;
			}

		if(m_iScrollY)
			{
			if(m_bHasScrollY)CWnd::SetScrollPos(SB_VERT,0,TRUE);
			m_iScrollY=0;
			bChanged=TRUE;
			}

		return bChanged;
		}

	iSizeX	= m_pImage->Width ();
	iSizeY	= m_pImage->Height();

	if(iSizeX>m_iMaxSizeX)iSizeX=m_iMaxSizeX;
	if(iSizeY>m_iMaxSizeY)iSizeY=m_iMaxSizeY;

	iDeltaX	= iSizeX-m_iWndSizeX;
	iDeltaY	= iSizeY-m_iWndSizeY;

	if(m_bDoCenter)									// Bild zentrieren
		{
		if(iDeltaX<0)
			{
			iDeltaX/=2;
			iPosX	=iDeltaX;
			}
		else{
			if(iPosX<0)iPosX=0;
			}

		if(iDeltaY<0)
			{
			iDeltaY/=2;
			iPosY	=iDeltaY;
			}
		else{
			if(iPosY<0)iPosY=0;
			}
		}
	else{											// Bild links oben
		if(iDeltaX<0)
			{
			if(m_bZeroScroll)iPosX=0;
			if(iPosX<iDeltaX)iPosX=iDeltaX;
			iDeltaX = 0;
			}
		else if(iPosX<0)
			{
			iPosX = 0;
			}

		if(iDeltaY<0)
			{
			if(m_bZeroScroll)iPosY=0;
			if(iPosY<iDeltaY)iPosY=iDeltaY;
			iDeltaY = 0;
			}
		else if(iPosY<0)
			{
			iPosY = 0;
			}
		}

	if(iPosX>iDeltaX)iPosX=iDeltaX;
	if(iPosY>iDeltaY)iPosY=iDeltaY;

	if(m_iScrollX!=iPosX)
		{
		if(m_bHasScrollX)CWnd::SetScrollPos(SB_HORZ,iPosX,TRUE);
		m_iScrollX = iPosX;
		bChanged   = TRUE;
		}

	if(m_iScrollY!=iPosY)
		{
		if(m_bHasScrollY)CWnd::SetScrollPos(SB_VERT,iPosY,TRUE);
		m_iScrollY = iPosY;
		bChanged   = TRUE;
		}


return bChanged;
}

//*****************************************************************************
//*
//*		UpdateScrollInfo
//*
//*****************************************************************************
void CBitmapWnd::UpdateScrollInfo()
{
SCROLLINFO  sTemp;
SCROLLINFO  sInfo;
int			iSize;


	if(m_bHasScrollX)									// X-Scrollbar anpassen
		{
		   iSize = m_pImage->Width();
		if(iSize>m_iMaxSizeX)iSize=m_iMaxSizeX;

		sInfo.cbSize		= sizeof(SCROLLINFO);
		sInfo.fMask			= SIF_ALL;
		sInfo.nMin  		= 0;
		sInfo.nMax  		= iSize;
		sInfo.nPage 		= m_iWndSizeX;
		sInfo.nPos			= m_iScrollX;
		sInfo.nTrackPos		= 0;

		if(m_bDoCenter && (int)sInfo.nPage>sInfo.nMax)	// Bild zentrieren
			{
			sInfo.nMin		= (sInfo.nMax-(int)sInfo.nPage)/2;
			sInfo.nMax		=  sInfo.nMin;
			sInfo.nPos		=  sInfo.nMin;
			}

		if((int)sInfo.nPage>sInfo.nMax-sInfo.nMin)
			{
			sInfo.nPage		= sInfo.nMax-sInfo.nMin;
			}

		if(m_iScrollX>(int)(sInfo.nMax-sInfo.nPage))
			{
			m_iScrollX		= sInfo.nMax-sInfo.nPage;
			sInfo.nPos		= sInfo.nMax-sInfo.nPage;
			}

		if(m_iScrollX>sInfo.nMax)
			{
			m_iScrollX		= sInfo.nMax;
			sInfo.nPos		= sInfo.nMax;
			}

		if(m_iScrollX<sInfo.nMin)
			{
			m_iScrollX		= sInfo.nMin;
			sInfo.nPos		= sInfo.nMin;
			}

		if(m_iShowScrollX)
			{
			if(m_iShowScrollX==1)						// WIN-BUG: Die Scrollbar muss an sein fr SIF_DISABLENOSCROLL
				{
				sTemp.cbSize	= sizeof(SCROLLINFO);
				sTemp.fMask		= SIF_RANGE|SIF_PAGE;
				sTemp.nMin		= 0;
				sTemp.nMax  	= 100;
				sTemp.nPage 	= 10;

				SetScrollInfo(SB_HORZ,&sTemp,TRUE);

				m_iShowScrollY	= 2;
				}

			sInfo.fMask    |= SIF_DISABLENOSCROLL;
			}

		if(sInfo.nPage==(unsigned)sInfo.nMax)
			{
			sInfo.nPage++;
			}

		SetScrollInfo(SB_HORZ,&sInfo,TRUE);
		}

	if(m_bHasScrollY)									// Y-Scrollbar anpassen
		{
		   iSize = m_pImage->Height();
		if(iSize>m_iMaxSizeY)iSize=m_iMaxSizeY;

		sInfo.cbSize		= sizeof(SCROLLINFO);
		sInfo.fMask			= SIF_ALL;
		sInfo.nMin  		= 0;
		sInfo.nMax  		= iSize;
		sInfo.nPage 		= m_iWndSizeY;
		sInfo.nPos			= m_iScrollY;
		sInfo.nTrackPos		= 0;

		if(m_bDoCenter && (int)sInfo.nPage>sInfo.nMax)	// Bild zentrieren
			{
			sInfo.nMin		= (sInfo.nMax-(int)sInfo.nPage)/2;
			sInfo.nMax		=  sInfo.nMin;
			sInfo.nPos		=  sInfo.nMin;
			}

		if((int)sInfo.nPage>sInfo.nMax-sInfo.nMin)
			{
			sInfo.nPage		= sInfo.nMax-sInfo.nMin;
			}

		if(m_iScrollY>(int)(sInfo.nMax-sInfo.nPage))
			{
			m_iScrollY		= sInfo.nMax-sInfo.nPage;
			sInfo.nPos		= sInfo.nMax-sInfo.nPage;
			}

		if(m_iScrollY>sInfo.nMax)
			{
			m_iScrollY		= sInfo.nMax;
			sInfo.nPos		= sInfo.nMax;
			}

		if(m_iScrollY<sInfo.nMin)
			{
			m_iScrollY		= sInfo.nMin;
			sInfo.nPos		= sInfo.nMin;
			}

		if(m_iShowScrollY)
			{
			if(m_iShowScrollY==1)						// WIN-BUG: Die Scrollbar muss an sein fr SIF_DISABLENOSCROLL
				{
				sTemp.cbSize	= sizeof(SCROLLINFO);
				sTemp.fMask		= SIF_RANGE|SIF_PAGE;
				sTemp.nMin		= 0;
				sTemp.nMax  	= 100;
				sTemp.nPage 	= 10;

				SetScrollInfo(SB_VERT,&sTemp,TRUE);

				m_iShowScrollY	= 2;
				}

			sInfo.fMask    |= SIF_DISABLENOSCROLL;
			}

		if(sInfo.nPage==(unsigned)sInfo.nMax)
			{
			sInfo.nPage++;
			}

		SetScrollInfo(SB_VERT,&sInfo,TRUE);
		}


}

//*****************************************************************************
//*
//*		SetScrollPos
//*
//*****************************************************************************
//	Stellt eine neue Scroll-Position ein
//	iPosX/iPosY		: Bildkoordinate der linken oberen Windowsfensterecke
//	bRedraw			: Das Fenster neu zeichnen
//	Ergibt TRUE wenn die Scroll-Position verndert wurde.
BOOL CBitmapWnd::SetScrollPos(int iPosX,int iPosY,BOOL bRedraw)
{

	if(!UpdateScroll(iPosX,iPosY))
		{
		return FALSE;
		}

	if(bRedraw)
		{
		RedrawWindow();
		}


return TRUE;
}

//*****************************************************************************
//*
//*		OnHScroll
//*
//*****************************************************************************
void CBitmapWnd::OnHScroll(UINT uCode,UINT uPos,CScrollBar*pScrollBar)
{
int		iPosX;


	if(!m_bHasScrollX)return;

	iPosX = m_iScrollX;

	switch(uCode)
		{
	case SB_LINERIGHT:		iPosX += 32;			break;
	case SB_LINELEFT:		iPosX -= 32;			break;
	case SB_PAGERIGHT:		iPosX += m_iWndSizeX;	break;
	case SB_PAGELEFT:		iPosX -= m_iWndSizeX;	break;
	case SB_THUMBPOSITION:	iPosX  = uPos;			break;
	case SB_THUMBTRACK:		iPosX  = uPos;			break;
		}

	if(UpdateScroll(iPosX,m_iScrollY))
		{
		RedrawWindow();
		}

}

//*****************************************************************************
//*
//*		OnVScroll
//*
//*****************************************************************************
void CBitmapWnd::OnVScroll(UINT uCode,UINT uPos,CScrollBar *pScrollBar)
{
int		iPosY;


	if(!m_bHasScrollY)return;

	iPosY = m_iScrollY;

	switch(uCode)
		{
	case SB_LINERIGHT:		iPosY += 32;			break;
	case SB_LINELEFT:		iPosY -= 32;			break;
	case SB_PAGERIGHT:		iPosY += m_iWndSizeY;	break;
	case SB_PAGELEFT:		iPosY -= m_iWndSizeY;	break;
	case SB_THUMBPOSITION:	iPosY  = uPos;			break;
	case SB_THUMBTRACK:		iPosY  = uPos;			break;
		}

	if(UpdateScroll(m_iScrollX,iPosY))
		{
		RedrawWindow();
		}

}

//*****************************************************************************
//*
//*		SetBkColor
//*
//*****************************************************************************
//	Einstellen der Hintergrundfarbe
void CBitmapWnd::SetBkColor(COLORREF uBkColor)
{

	if(uBkColor==m_uBkColor)return;

	m_uBkColor = uBkColor;

	if(!IsWindow(m_hWnd))return;


	if(m_iScrollX<0 || m_iScrollY<0 || m_iWndSizeX>(int)m_pImage->Width() || m_iWndSizeY>(int)m_pImage->Height())
		{
		RedrawWindow();
		}

}


//*****************************************************************************
//*
//*		InvalidateFrame
//*
//*****************************************************************************
//	Veranlast das Neuzeichen eines Bildbereiches ohne Bercksichtigung der Scroll-Position
//	iPosX/Y		: Eine Ecke des Bildbreichs relativ zum Bild
//	iSizeX/Y	: Ist die Breite des Bildbreichs (auch negative Werte sind erlaubt)
//	bErase		: Soll der Hintergrund gelscht werden
void CBitmapWnd::InvalidateFrame(int iPosX,int iPosY,int iSizeX,int iSizeY,BOOL bErase)
{
RECT sRect;

	if(iSizeX<0)
		{
		sRect.left		= iPosX+iSizeX;
		sRect.right		= iPosX;
		}
	else{
		sRect.left		= iPosX;
		sRect.right		= iPosX+iSizeX;
		}

	if(iSizeY<0)
		{
		sRect.top		= iPosY+iSizeY;
		sRect.bottom	= iPosY;
		}
	else{
		sRect.top		= iPosY;
		sRect.bottom	= iPosY+iSizeY;
		}

	CWnd::InvalidateRect(&sRect,bErase);
}

//*****************************************************************************
//*
//*		InvalidateRect
//*
//*****************************************************************************
//	Veranlast das Neuzeichen eines Bildbereiches unter Bercksichtigung der Scroll-Position
//	pRect		: Zeiger auf den Bildbereich relativ zum Bild
//	bErase		: Soll der Hintergrund gelscht werden
void CBitmapWnd::InvalidateRect(LPCRECT pRect,BOOL bErase)
{
RECT	sRect;

	sRect.left		= m_iScrollX+pRect->left;
	sRect.right		= m_iScrollX+pRect->right;
	sRect.top		= m_iScrollY+pRect->top;
	sRect.bottom	= m_iScrollY+pRect->bottom;

	CWnd::InvalidateRect(&sRect,bErase);
}

//*****************************************************************************
//*
//*		InvalidateRect
//*
//*****************************************************************************
//	Veranlast das Neuzeichen eines Bildbereiches unter Bercksichtigung der Scroll-Position
//	iPosX/Y		: Eine Ecke des Bildbreichs relativ zum Bild
//	iSizeX/Y	: Ist die Breite des Bildbreichs (auch negative Werte sind erlaubt)
//	bErase		: Soll der Hintergrund gelscht werden
void CBitmapWnd::InvalidateRect(int iPosX,int iPosY,int iSizeX,int iSizeY,BOOL bErase)
{
RECT	sRect;


	iPosX -= m_iScrollX;
	iPosY -= m_iScrollY;

	if(iSizeX<0)
		{
		sRect.left		= iPosX+iSizeX;
		sRect.right		= iPosX;
		}
	else{
		sRect.left		= iPosX;
		sRect.right		= iPosX+iSizeX;
		}

	if(iSizeY<0)
		{
		sRect.top		= iPosY+iSizeY;
		sRect.bottom	= iPosY;
		}
	else{
		sRect.top		= iPosY;
		sRect.bottom	= iPosY+iSizeY;
		}

	CWnd::InvalidateRect(&sRect,bErase);
}


//*****************************************************************************
//*
//*		ChangeSize
//*
//*****************************************************************************
//	ndert die Gre des Bildes
BOOL CBitmapWnd::ChangeSize(int iSizeX,int iSizeY)
{
BOOL	bRet;


	if(iSizeX<=0 || iSizeY<=0)
		{
		return FALSE;
		}

	if(iSizeX>16000 || iSizeY>16000)
		{
		return FALSE;
		}

	if(m_bFixedSize)										// Gibt es eine fixe Gre
		{
		m_iMinSizeX = iSizeX;
		m_iMinSizeY = iSizeY;
		}
	else{													// Minimale Gre prfen
		if(iSizeX>m_iMaxSizeX)iSizeX=m_iMaxSizeX;
		if(iSizeY>m_iMaxSizeY)iSizeY=m_iMaxSizeY;
		if(iSizeX<m_iMinSizeX)iSizeX=m_iMinSizeX;
		if(iSizeY<m_iMinSizeY)iSizeY=m_iMinSizeY;
		}


	if(m_pImage && iSizeX==(int)m_pImage->Width() && iSizeY==(int)m_pImage->Height())
		{
		return TRUE;
		}


	bRet = FALSE;

	m_sLockSem.Lock();

	if(iSizeX>0 && iSizeY>0 && !m_iLockCnt)					// Hat sich die Gre verndert
	if(iSizeX!=(int)m_pImage->Width() || iSizeY!=(int)m_pImage->Height())
		{
		CreateImage(iSizeX,iSizeY);
		bRet = TRUE;
		}

	m_sLockSem.Unlock();

	if(bRet && m_iWndSizeX>0 && m_iWndSizeY>0)
		{
		UpdateScrollInfo();
		}


return bRet;
}


//*****************************************************************************
//*
//*		EnsureVisible
//*
//*****************************************************************************
//	Prft ob ein Bildbereich sichtbar ist
//	iPosX/Y		: Ist die linke obere Ecke des Bereiches
//	iSizeX		: Ist die Breite des Bereiches, (wenn <0 keine Prfung)
//	iSizeY		: Ist die Hhe   des Bereiches, (wenn <0 keine Prfung)
//	Ergibt TRUE wenn gescrollt wurde
BOOL CBitmapWnd::EnsureVisible(int iPosX,int iPosY,int iSizeX,int iSizeY)
{
BOOL	bChanged;
int		iScrollX;
int		iScrollY;



	bChanged	= FALSE;
	iScrollX	= m_iScrollX;
	iScrollY	= m_iScrollY;

	if(iSizeX>=0 && m_iWndSizeX>0)
		{
		if(iPosX+iSizeX>=iScrollX+m_iWndSizeX)
			{
			iScrollX = m_iWndSizeX-iSizeX-1;
			bChanged = TRUE;
			}

		if(iPosX<iScrollX)
			{
			iScrollX = iPosX;
			bChanged = TRUE;
			}
		}

	if(iSizeY>=0 && m_iWndSizeY>0)
		{
		if(iPosY+iSizeY>=iScrollY+m_iWndSizeY)
			{
			iScrollY = m_iWndSizeY-iSizeY-1;
			bChanged = TRUE;
			}

		if(iPosY<iScrollY)
			{
			iScrollY = iPosY;
			bChanged = TRUE;
			}
		}


	if(!bChanged)return FALSE;


return UpdateScroll(iScrollX,iScrollY);
}

