//*****************************************************************************
//*
//*
//*		BrowserCtrl.cpp
//*
//*
//*****************************************************************************
//
// 	char   *GetPath()							Ergibt den aktuellen Pfad
// 	BOOL	SetPath(char *)						Ergibt den aktuellen Pfad
//	int	  	GetFocusItem()						Aktuelles Item vom ListView holen
//	BOOL  	SetFocusItem(int Item)				Aktuelles Item vom ListView setzen
// 	int   	Set (char*="C:\\",char*=0,int=0)	Neuen Pfad einstellen
//	int   	Filter (char *,char *,int =1)		Neuen Dateifilter einstellen
// 	void  	OnSelectAll()						Alles auswhlen
// 	int   	GetSelect(CStringChain *,int=0)		Ergibt die ausgewhlen Dateien
// 	int	  	SetStyle(int,int iMask=0xFFFF)		ndert das Aussehen
// 	int	  	Delete()							Lscht ausgewhlten Dateien
// 	int	  	NewDirectory(char *pName=0)			Erzeugt ein neues Verzeichnis
// 	int	  	DoDrop(char *pPath,int iMode)		Dorp-Funktion ausfhren
// 	int   	HitTest(CPoint,void *)				Ergibt Eintragnr. unter Cursor
// 	int   	Sort(int iMode=0,int iDir=0)		Sortiere ListView
//	void	Reload()							Aktuallisiert das Verzeichnis
//
// 	HTREEITEM Read(char *pPath,int iMode=0,HTREEITEM hRoot=0);
//
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif						 

#include	<AfxWin.h>
#include	<AfxOle.h>
#include	<AfxCmn.h>
#include	"AfxUtility.h"
#include	"BrowserCtrl.h"
#include	"WinExtension.h"


#ifndef		ID_PATHUP
#define		ID_PATHUP			0x8801
#endif
#ifndef		ID_NEWDIR
#define		ID_NEWDIR			0x8802
#endif
#ifndef		ID_DELETE
#define		ID_DELETE			0x8803
#endif
#ifndef		ID_SELECTALL
#define		ID_SELECTALL		0x8804
#endif

#define		IDC_TREEVIEW		0x00004480			// ID fr Treeview
#define		IDC_LISTVIEW		0x00004481			// ID fr ListView

#define 	DRAG_SCROLL_TIME	1200				// Scrollzeit bei Drag
#define 	SEPERATOR_WIDTH		7					// Breites des Separators

#ifndef	   _WIN64
	#ifndef	SetWindowLongPtr
	#define	SetWindowLongPtr	SetWindowLong
	#endif
	#ifndef	GetWindowLongPtr
	#define	GetWindowLongPtr	GetWindowLong
	#endif
#else
	#ifdef	GCLP_HCURSOR
	#undef	GCLP_HCURSOR
	#endif
	#define	GCLP_HCURSOR			GCLP_HCURSOR
#endif



#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DROP_FUNC       (CBrowserCtrl);
DROP_FUNC_ENTER (CBrowserCtrl);
DROP_FUNC_RENDER(CBrowserCtrl);

//*****************************************************************************
//*
//*		Nachrichten Verarbeitung
//*
//*****************************************************************************
#if _MFC_VER >= 0x0700
	typedef  LRESULT (AFX_MSG_CALL CWnd::*AfxMsgProc)(WPARAM, LPARAM);
	#define 	AFX_MSG_PROC	(AfxMsgProc)
#else
	#define 	AFX_MSG_PROC
#endif


BEGIN_MESSAGE_MAP(CBrowserCtrl,CWnd)
	//{{AFX_MSG_MAP(CBrowserCtrl)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_PATHUP						,OnPathUp)
	ON_COMMAND(ID_SELECTALL						,OnSelectAll)
	ON_COMMAND(ID_NEWDIR						,OnNewDir)
	ON_COMMAND(ID_DELETE						,OnDelete)
	//}}AFX_MSG_MAP

	ON_NOTIFY(NM_SETFOCUS		, IDC_TREEVIEW , OnTreeSetFocus)
	ON_NOTIFY(NM_RCLICK			, IDC_TREEVIEW , OnTreeRButton)
	ON_NOTIFY(TVN_KEYDOWN		, IDC_TREEVIEW , OnTreeKeyDown)
	ON_NOTIFY(TVN_ENDLABELEDIT	, IDC_TREEVIEW , OnTreeEndEdit)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_TREEVIEW , OnTreeBeginEdit)
	ON_NOTIFY(CFT_FOLDERSELECT	, IDC_TREEVIEW , OnTreeFolderSel)
	ON_NOTIFY(CFT_DRAGACTION	, IDC_TREEVIEW , OnTreeDragAction)

	ON_NOTIFY(NM_SETFOCUS		, IDC_LISTVIEW , OnListSetFocus)
	ON_NOTIFY(NM_RETURN			, IDC_LISTVIEW , OnListKeyDown)
	ON_NOTIFY(NM_RCLICK			, IDC_LISTVIEW , OnListRButton)
	ON_NOTIFY(NM_DBLCLK			, IDC_LISTVIEW , OnListDblClick)
	ON_NOTIFY(LVN_KEYDOWN		, IDC_LISTVIEW , OnListKeyDown)
	ON_NOTIFY(LVN_ENDLABELEDIT	, IDC_LISTVIEW , OnListEndEdit)
	ON_NOTIFY(LVN_BEGINLABELEDIT, IDC_LISTVIEW , OnListBeginEdit)
	ON_NOTIFY(CFL_DRAGACTION	, IDC_LISTVIEW , OnListDragAction)
	ON_NOTIFY(CFL_STATUSBARSET	, IDC_LISTVIEW , OnListStatusbar)

	ON_MESSAGE(WM_CUT,   AFX_MSG_PROC OnCut)
	ON_MESSAGE(WM_COPY,  AFX_MSG_PROC OnCopy)
	ON_MESSAGE(WM_CLEAR, AFX_MSG_PROC OnClear)
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CBrowserCtrl::CBrowserCtrl()
{
int		iSize;


	   iSize = GetSystemMetrics(SM_CXSMICON);
	if(iSize<32)iSize=32;

	m_iStyle			= 0;
	m_iDoRename			= 0;
	m_pMinusFilter		= 0;
	m_pPlusFilter		= 0;
	m_iStopThread		= 0;							// Einfge-Thread abbrechen
	m_iDragMode			= 0;							// 2= ListDrag 1=TreeDrag
	m_hDragItem			= 0;							// Item fr TreeDrag
	m_iDropScroll		= 0;							// Letzter Scroll-Modus
	m_iLastFocus		= 0;							// Wer hatte zuletzt den Fokus (0=nimand 1=List 2=Tree)
	m_iWindowX			= 0;							// Aktuelle Fenstergre
	m_iWindowY			= 0;							//		*
	m_iSeparator		= (270*iSize)/32;				// Teilung der Fenster


	m_cListView.Sort(CFL_SORT_NAME|CFL_SORT_VALUE);

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CBrowserCtrl::~CBrowserCtrl()
{

	if(m_pMinusFilter)delete m_pMinusFilter;
	if(m_pPlusFilter )delete m_pPlusFilter;

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
//	Aufruf bevor Fenster sichtbar wird.
BOOL CBrowserCtrl::PreCreateWindow(CREATESTRUCT &sData)
{
return CWnd::PreCreateWindow(sData);
}

//*****************************************************************************
//*
//*		CreateEx  Fenstererzeugung
//*
//*****************************************************************************
//	Erzeugen eines File-Browser-Control-Fensters.
//	dwStyleEx	: Ist der erweiterte Fensterstiel (siehe WS_EX_???)
//	dwStyle		: Bestimmt das Verhalten des Fensters
//					CBC_NOLISTVIEW		ListView nicht anzeigen
//					CBC_NOTREEVIEW		TreeView nicht anzeigen
//					CBC_RENAME			Dateien knnen umbenannt werden
//					CBC_DELETE			Dateilschen erlaubt
//					CBC_TABEXIT			Bei TAB Focus an Elternfenster geben
//					CBC_DRAG			Drag Operationen freigeben
//					CBC_DROP			Drop Operationen freigeben
//					CBC_DRAGDROP		Drop&Drop Operationen freigeben
//					CBC_SHOWPATHUP		Das ".." Verzeichnis anzeigen
//	sRect		: Koordinaten bei denen das Fenster erzeugt wird.
//	nID			: Ist die ID der Fensters.
//	pPlus		: Plusfilter der Dateien die im ListView angezeigt werden
//				  sollen. z.B.:	"*.gif;*.jpg;*.bmp"
//				  Bei NULL wird kein Filter eingestellt.
//	pMinus		: Minusfilter der Dateien die im ListView angezeigt werden
//				  sollen. z.B.:	"_Temp_*.gif;_Temp_*.jpg"
//				  Bei NULL wird kein Filter eingestellt.
//	pParentWnd	: Ist das Elternfenster fr das Control.
BOOL CBrowserCtrl::CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID,LPCTSTR pPlus,LPCTSTR pMinus)
{
HIMAGELIST		hImageList;
RECT			sChildRect;
DWORD			dwThreadId;
HANDLE			hThread;
DWORD			uMode;
SHFILEINFO		sSfi;
int				iOk;



	sChildRect.top		=  0;
	sChildRect.bottom	=  0;
	sChildRect.left		= 10;
	sChildRect.right	= 10;
	m_iStyle			= dwStyle;

	if(pPlus || pMinus)
		{
		Filter(pPlus,pMinus,0);
		}

	dwStyle &= 0xFFFF0000;
	iOk = CWnd::CreateEx(dwExStyle,NULL,_T("BrowserCtrl"),dwStyle|WS_CHILD,sRect,pParentWnd,nID,0);
	SetClassLongPtr(m_hWnd,GCLP_HCURSOR      ,(LPARAM)LoadCursor  (0,IDC_SIZEWE));
	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));
	hImageList = (HIMAGELIST)SHGetFileInfo(_T(""),0,&sSfi,sizeof(sSfi),SHGFI_PIDL|SHGFI_SMALLICON|SHGFI_SYSICONINDEX);


//******************** Tree-View ************************************************


	uMode = WS_CHILD|WS_VISIBLE;

	if(m_iStyle&CBC_NOTREEVIEW)uMode&=~WS_VISIBLE;
	if(m_iStyle&CBC_NONETDIRS )uMode|=CFT_NONETDIRS;
	if(m_iStyle&CBC_TABEXIT   )uMode|=CFT_TABEXIT;
	if(m_iStyle&CBC_DRAG      )uMode|=CFT_ALLOWDRAG;
	if(m_iStyle&CBC_RENAME    )uMode|=TVS_EDITLABELS;

	m_cTreeView.Create(uMode,sChildRect,this,IDC_TREEVIEW);
	m_cTreeView.SetImageList(hImageList,TVSIL_NORMAL);


//******************** List-View ************************************************


	uMode = WS_CHILD|WS_VISIBLE|CFL_SORT|CFL_SORTADD|CFL_ADDDIR|CFL_SIZE|CFL_TYPE|CFL_TIME;

	if(m_iStyle&CBC_NOLISTVIEW)uMode&=~WS_VISIBLE;
	if(m_iStyle&CBC_ONLYFILES )uMode&=~CFL_ADDDIR;
	if(m_iStyle&CBC_TABEXIT   )uMode|=CFL_TABEXIT;
	if(m_iStyle&CBC_DRAG      )uMode|=CFL_ALLOWDRAG;
	if(m_iStyle&CBC_STATUSBAR )uMode|=CFL_STATUSBAR;
	if(m_iStyle&CBC_SETCOLUMN )uMode|=CFL_SETCOLUMN;

	m_cListView.Create(uMode,sChildRect,this,IDC_LISTVIEW);
	m_cListView.SetImageList(hImageList,LVSIL_NORMAL);


//*****************************************************************************


	DROP_FUNC_REGISTER1(&m_cListView);
	DROP_FUNC_REGISTER2(&m_cTreeView);

	Filter(pPlus,pMinus,0);

	if(sRect.right >sRect.left)
	if(sRect.bottom>sRect.top )
		{
		OnSize(0,sRect.right-sRect.left,sRect.bottom-sRect.top);
		}

	hThread = CreateThread(NULL,0xF000,InsertThread,this,0,&dwThreadId);
	CloseHandle(hThread);


return iOk;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
//	Das Fenster wied geschlossen
void CBrowserCtrl::OnDestroy()
{

	m_iStopThread = 1;


	while(m_iStopThread<2)
		{
		m_hTreadAction.Unlock();
		m_cListView.Break();
		Sleep(100);
		}


	CWnd::OnDestroy();

}

//*****************************************************************************
//*
//*		OnClose
//*
//*****************************************************************************
void CBrowserCtrl::OnClose()
{

	m_iStopThread = 1;
	m_hTreadAction.Unlock();
	m_cListView.Break();

	CWnd::OnClose();

}


//*****************************************************************************
//*
//*		OnPaint    Fenster neuzeichnen
//*
//*****************************************************************************
// Neu zeichnen des Fensters
void CBrowserCtrl::OnPaint( )
{
CPaintDC	 pDC(this);


	if((m_iStyle&(CBC_NOLISTVIEW|CBC_NOTREEVIEW))==(CBC_NOLISTVIEW|CBC_NOTREEVIEW))
		{
		pDC.SelectStockObject(NULL_PEN);
		pDC.SelectObject(GetSysColorBrush(COLOR_WINDOW));
		pDC.Rectangle(0,0,10000,10000);
		}
	else{
		DrawSeparator(pDC,m_iSeparator);
		}

}

//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG

void CBrowserCtrl::AssertValid() const
{
	CWnd::AssertValid();
}

void CBrowserCtrl::Dump(CDumpContext& dc) const
{
	CWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
//	Grenanderung des Fensters
void CBrowserCtrl::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int		iDiff;
int		iLast;
int		iView;
int		iStep;




	if(iSizeX<=0 || iSizeY<=0)
		{
		return;
		}

														// Den Separator anpassen
	if(iSizeX!=m_iWindowX && m_iWindowX && !(m_iStyle&CBC_FIXEDSEPARATOR))
		{
		   iLast = m_iWindowX;
		if(iLast< 500)iLast= 500;
		if(iLast>1500)iLast=1500;

		   iView = iSizeX;
		if(iView< 500)iView= 500;
		if(iView>1500)iView=1500;

		   iDiff = iView-iLast;
		if(iDiff>0 && m_iSeparator<500)
			{
			iStep		  = iDiff/3;
			m_iSeparator += iStep;
			iDiff        -=	iStep*3;
			iStep		  = iView%3;
			
			if(iStep+iDiff>=3)m_iSeparator++;
			
			if(m_iSeparator>500)
				{
				m_iSeparator = 500;
				}
			}
		else if(iDiff<0 && m_iSeparator>200)
			{
			iStep		  = iDiff/3;
			m_iSeparator += iStep;
			iDiff        -=	iStep*3;
			iStep		  = (iView-iDiff)%3;
			
			if(iStep+iDiff>=3)m_iSeparator++;

			if(m_iSeparator<200)
				{
				m_iSeparator = 200;
				}
			}
		}


	if(IsWindow(m_cListView.m_hWnd) && !(m_iStyle&CBC_NOLISTVIEW))
		{
		if(m_iStyle&CBC_NOTREEVIEW)
			 m_cListView.MoveWindow( 0                           ,0,iSizeX                             ,iSizeY);
		else m_cListView.MoveWindow( m_iSeparator+SEPERATOR_WIDTH,0,iSizeX-m_iSeparator-SEPERATOR_WIDTH,iSizeY);
		}

	if(IsWindow(m_cTreeView.m_hWnd) && !(m_iStyle&CBC_NOTREEVIEW))
		{
		if(m_iStyle&CBC_NOLISTVIEW)
			 m_cTreeView.MoveWindow( 0, 0 ,iSizeX	   ,iSizeY);
		else m_cTreeView.MoveWindow( 0, 0 ,m_iSeparator,iSizeY);
		}


	m_iWindowX	= iSizeX;			
	m_iWindowY	= iSizeY;			


}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Holt den Zeiger auf den aktuellen Pfad
//	iReal		: Wenn dieser Wert auf 1 ist, wird bei Netzpfaden immer der
//				  der reale Pfad zurck gegeben.
//	Ergibt einen Zeiger auf den Pfad.
LPCTSTR CBrowserCtrl::GetPath(int iReal)
{
LPCTSTR		pPath;


	if(iReal && m_cTreeView.GetPathMode()==0)
		{
		return _T("");
		}

	pPath = m_cTreeView.GetPath();


return pPath;
}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Speichert den Pfad von einem ListView Eintrag in einem Puffer.
//	Am Pfadende wird ein `\' angehngt wenn es sich um ein Verzeichnis handelt.
//	iEntry		: Handels des Eintrag aus den ListView.
//	pBuffer		: Ist der Zeiger auf den Textpuffer.
//	iSize		: Ist die Gre des Textpuffers in Zeichen.
//	Ergibt die Lnge des gespeicherten Pfades bzw. 0 bei einem Fehler.
int CBrowserCtrl::GetPath(int iEntry,TCHAR *pBuffer,int iSize)
{
CFileFinder	   *pFind;
TCHAR		   *pName;
int				iLen;


	if(iSize<=0)return 0;

	iSize--;

	pFind	= m_cListView.GetFiles();
	pName	= pFind->Name(iEntry,1,&iLen);

	if(iLen>iSize)
		{
		pBuffer[0]=0;
		return 0;
		}

	memcpy(pBuffer,pName,iLen*sizeof(TCHAR));
	pBuffer[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*		SetPath
//*
//*****************************************************************************
//	Setzt einen neuen Pfad frs ListView.
//	pPath		: Ist der Zeiger auf den Pfadnamen der eingestellt werden soll.
//	pPlus		: Plusfilter der Dateien die im ListView angezeigt werden
//				  sollen. z.B.:	"*.gif;*.jpg;*.bmp"
//				  Bei NULL wird der aktuelle Filter beibehalten.
//	pMinus		: Minusfilter der Dateien die im ListView angezeigt werden
//				  sollen. z.B.:	"_Temp_*.gif;_Temp_*.jpg"
//				  Bei NULL wird der aktuelle Filter beibehalten.
//	Ergibt TRUE wenn der Pfad eingestellt werden konnte.
BOOL CBrowserCtrl::SetPath(LPCTSTR pPath,LPCTSTR pPlus,LPCTSTR pMinus)
{

	Filter(pPlus,pMinus,0);

return m_cTreeView.SetPath(pPath);
}

//*****************************************************************************
//*
//*		Filter
//*
//*****************************************************************************
//	Setzt einen neuen Anzeigefilter fr das ListView.
//	pPlus		: Plusfilter der Dateien die im ListView angezeigt werden
//				  sollen. z.B.:	"*.gif;*.jpg;*.bmp"
//				  Bei NULL wird der aktuelle Filter beibehalten.
//	pMinus		: Minusfilter der Dateien die im ListView angezeigt werden
//				  sollen. z.B.:	"_Temp_*.gif;_Temp_*.jpg"
//				  Bei NULL wird der aktuelle Filter beibehalten.
//	iMode		: Ist dieser Wert ungleich 0 so wird das ListView aktualisiert.
//	Ergibt 1 wenn ListView aktualisiert wurde, ansonsten 0.
int CBrowserCtrl::Filter(LPCTSTR pPlus,LPCTSTR pMinus,int iMode)
{
int		iChanged=0;



	if(!pPlus)
		{
		if(m_pPlusFilter)
			{
			delete m_pPlusFilter;
			m_pPlusFilter=0;
			iChanged = 1;
			}
		}
	else{
		if(!m_pPlusFilter || _tcsicmp(pPlus,m_pPlusFilter))
			{
			iChanged = 1;
			if(m_pPlusFilter)delete m_pPlusFilter;
			   m_pPlusFilter=new TCHAR[_tcslen(pPlus)+1];
			_tcscpy(m_pPlusFilter,pPlus);
			}
		}

	if(!pMinus)
		{
		if(m_pPlusFilter)
			{
			delete m_pMinusFilter;
			m_pMinusFilter=0;
			iChanged = 1;
			}
		}
	else{
		if(!m_pMinusFilter || _tcsicmp(pMinus,m_pMinusFilter))
			{
			iChanged = 1;
			if(m_pMinusFilter)delete m_pMinusFilter;
			   m_pMinusFilter=new TCHAR[_tcslen(pMinus)+1];
			_tcscpy(m_pMinusFilter,pMinus);
			}
		}

	if(iMode && iChanged && IsWindow(m_cListView.m_hWnd))
		{
		// REM AZ neu Laden
		return 1;
		}


return 0;
}



//*****************************************************************************
//*
//*		InsertThread
//*
//*****************************************************************************
DWORD WINAPI CBrowserCtrl::InsertThread(LPVOID pParam){return ((CBrowserCtrl*)pParam)->InsertThread();}
DWORD        CBrowserCtrl::InsertThread()
{
TCHAR			cBuffer[MAX_PATH+2];
CFileFinder	   *pFinder;
UINT			uFlags;
HTREEITEM		hItem;
int				iMode;
int				iLen;


	for(;;)
		{
		m_hTreadAction.Lock();
		if(m_iStopThread)break;

		while(m_hTreadAction.Lock(0));

		   iLen = m_cTreeView.GetPath(cBuffer,MAX_PATH,&hItem);
		if(iLen && cBuffer[iLen-1]!='\\')
			{
			cBuffer[iLen] = '\\';	iLen++;
			cBuffer[iLen] = 0;
			}

		iMode  = m_cTreeView.GetPathMode();
		uFlags = CFL_ADDDIR;

		if(iMode==0)
			{
			iLen	= m_cTreeView.GetPath(hItem,cBuffer,MAX_PATH,1);
			uFlags |= CFL_NETSEACH;
			}

		if(m_iStyle&CBC_SHOWPATHUP)						// ".." einblenden
			{
			uFlags |= CFL_ADDUP;
			}

		if(m_iStyle&CBC_ONLYFILES)						// Nur Dateien anzeigen
			{
			uFlags &=~CFL_ADDDIR;
			iMode   = 3;
			}

		m_cListView.DeleteAllItems();
		m_cListView.Add(cBuffer,uFlags,m_pPlusFilter,m_pMinusFilter);

		   pFinder = m_cListView.GetFiles();
		if(pFinder->DoneFlag())continue;

		if(iMode==1)
			{
			m_cTreeView.SynchPath(hItem,pFinder);
			}
		}


	m_iStopThread = 2;



return 0;
}

//*****************************************************************************
//*
//*		HitTest
//*
//*****************************************************************************
//	Stellt fest auf welchem Eintrag im ListView oder TreeView der Cursor steht.
//	sPoint		: Sind die Cursor-Koordinaten relativ zur linken oberen
//				  Fensterecke.
//	pEntry		: Hier wird der Eintrag gespeichert.
//				  Ist ein Eintrag im ListView so wird sein Index in
//				  *(int*)Element gespeichert.
//				  Ist ein Eintrag im TreeView so wird sein Zeiger in
//				  *(HTREEITEM*)Element gespeichert.
//	pRow		: Hier wird die Spalte gespeichert vpm ListView.
//	Ergibt	0 wenn kein Eintrag gefunden wurde.
//			1 wenn ein  Eintrag aus dem TreeView gefunden wurde.
//			2 wenn ein  Eintrag aus dem Listfeld gefunden wurde.
int CBrowserCtrl::HitTest(CPoint sPoint,void *pEntry,int *pRow)
{
int			iIndex;
UINT		uFlags;
HTREEITEM	hItem;
CRect		sRect;
CPoint		sPos;


//*************** Ist Cusor im TreeView ? ***************************************

	m_cTreeView.GetWindowRect(&sRect);

	if(sRect.PtInRect(sPoint))
		{
		sPos.x = sPoint.x-sRect.left;
		sPos.y = sPoint.y-sRect.top;
		hItem  = m_cTreeView.HitTest(sPos,&uFlags);

		*(HTREEITEM*)pEntry = hItem;
		if(pRow)*pRow=0;

		return (hItem)? 1:0;
		}

//*************** Ist Cusor im Listfeld ? ***************************************

	m_cListView.GetWindowRect(&sRect);

	if(sRect.PtInRect(sPoint))
		{
		sPos.x = sPoint.x-sRect.left;
		sPos.y = sPoint.y-sRect.top;
		iIndex = m_cListView.HitTest(sPos,&uFlags);

		*(DWORD_PTR*)pEntry = iIndex;
		if(pRow)*pRow = uFlags>>24;

		return (iIndex!=-1)? 2:0;
		}


	*(DWORD_PTR*)pEntry=0;
	if(pRow)*pRow=0;


return 0;
}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CBrowserCtrl::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
CRect	sRect;
CPoint	sPos;
int		i;


	GetRectView(sRect);

	sPos		 = sPoint;
	sPos.x		-= m_iSeparator;

		i = Resize(this,TRUE,sRect,m_iSeparator,sPos,SEPERATOR_WIDTH,SEPERATOR_WIDTH-2);
	if(!i)return;

	GetClientRect(&sRect);
	sRect.right -= SEPERATOR_WIDTH;

	   m_iSeparator+=i;
	if(m_iSeparator>sRect.right)m_iSeparator=sRect.right;
	if(m_iSeparator<          0)m_iSeparator=0;

	OnSize(0,sRect.right+SEPERATOR_WIDTH,sRect.bottom);
	RedrawWindow();

}

//*****************************************************************************
//*
//*		Rename
//*
//*****************************************************************************
//	Benennt eine Datei um. (nicht nur im Fenster, aus im Verzeichnis)
//	Verschoben knnen damit keine Dateine werden.
//	pOldName	: Zeiger auf den alten Namen.
//	pNewName	: Zeiger auf den neuen Namen.
//				  Sollte dieser Zeiger auch eine Pfad enthalten,
//				  so wird nur der Namenteil davon benutzt.
//	Ergibt 1 wenn erfolgreich bzw. 0 bei einem Feher.
int CBrowserCtrl::Rename(LPCTSTR pOldName,LPCTSTR pNewName)
{
TCHAR	cBuffer[MAX_PATH+16];
TCHAR	cNew   [MAX_PATH+16];
int		i,j,k;


	if(!pOldName || !pNewName)return 0;

	i = (int)_tcslen(pOldName);
	j = (int)_tcslen(pNewName);

	if(!i || !j)return 0;

	k = j;

	while(k>0)												// Vom Dateinamen den Pfad abspalten
		{
		if(pNewName[k-1]==':' )break;
		if(pNewName[k-1]=='\\')break;
		k--;
		}

	pNewName += k;
	j        -= k;

	if(i && pOldName[i-1]=='\\')							// '\' am Ende entfernen
		{
		if(i>=MAX_PATH)return 0;
		memcpy(cBuffer,pOldName,i*sizeof(TCHAR));
		i--;cBuffer[i]=0;
		pOldName=cBuffer;
		}

	if(i>=MAX_PATH)return 0;

	while(i>0)
		{
		i--;
		if(pOldName[i]==':' )break;
		if(pOldName[i]=='\\')
			{
			i++;
			break;
			}
		}

	if(i+j>=MAX_PATH)return 0;

	   memcpy (cNew,pOldName,i*sizeof(TCHAR));cNew[i]=0;
	  _tcsncat(cNew,pNewName ,MAX_PATH);
	i=(int)_tcscspn(cNew    ,_T("*?"));if(cNew    [i])return 0;
	i=(int)_tcscspn(pOldName,_T("*?"));if(pOldName[i])return 0;


return MoveFile(pOldName,cNew);
}


//*****************************************************************************
//*
//*		OnPathUp
//*
//*****************************************************************************
//	Der aktuelle Pfad wird um eine Ebene nach oben verschoben.
//	z.B.:  von "C:\Temp\Abc\"  nach "C:\Temp\"
void CBrowserCtrl::OnPathUp()
{
TCHAR	cBuffer[MAX_PATH];
int		iLen;


	iLen = m_cTreeView.GetPath(cBuffer,MAX_PATH);

	if(iLen && (cBuffer[iLen-1]=='\\'))iLen--;
	if(cBuffer[iLen]==':')return;

	while(iLen)
		{
		iLen--;
		if(cBuffer[iLen]=='\\')break;
		if(cBuffer[iLen]==':' )return;
		}

	cBuffer[iLen+1]=0;

	m_cTreeView.SetPath(cBuffer);

}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CBrowserCtrl::OnSetFocus(CWnd *pOldWnd)
{
HWND	hOldWnd;
int		iShift;


	hOldWnd = (pOldWnd)? pOldWnd->m_hWnd:NULL;


	if(m_iStyle&CFL_TABEXIT)						// Zu anderem Fenster springen
		{
		iShift = GetAsyncKeyState(VK_SHIFT)&0x8000;

		if(iShift)
			{
			if(hOldWnd==m_cTreeView.m_hWnd)
				{
				GetParent()->SetFocus();
				return;
				}

			if(hOldWnd==m_cListView.m_hWnd)
				{
				if(m_iStyle&CBC_NOTREEVIEW)
						GetParent()->SetFocus();
				else	m_cTreeView. SetFocus();
				return;
				}

			if(!(m_iStyle&CBC_NOLISTVIEW))
				{
				m_cListView.SetFocus();
				return;
				}

			if(!(m_iStyle&CBC_NOTREEVIEW))
				{
				m_cTreeView.SetFocus();
				return;
				}
			}
		else{
			if(hOldWnd==m_cListView.m_hWnd)
				{
				GetParent()->SetFocus();
				return;
				}

			if(hOldWnd==m_cTreeView.m_hWnd)
				{
				if(m_iStyle&CBC_NOLISTVIEW)
						GetParent()->SetFocus();
				else	m_cListView. SetFocus();
				return;
				}

			if(!(m_iStyle&CBC_NOTREEVIEW))
				{
				m_cTreeView.SetFocus();
				return;
				}

			if(!(m_iStyle&CBC_NOLISTVIEW))
				{
				m_cListView.SetFocus();
				return;
				}
			}
		}
	else{
		if(m_iLastFocus==1 && !(m_iStyle&CBC_NOLISTVIEW)){SetFocus(0);return;}
		if(m_iLastFocus==2 && !(m_iStyle&CBC_NOTREEVIEW)){SetFocus(1);return;}
		if(                   !(m_iStyle&CBC_NOLISTVIEW)){SetFocus(0);return;}
		if(                   !(m_iStyle&CBC_NOTREEVIEW)){SetFocus(1);return;}
		}

}

//*****************************************************************************
//*
//*		Delete
//*
//*****************************************************************************
//	Lscht die ausgewhlten Dateien im Fenster.
//	Ergibt	0 : Wenn nichts verndert wurde.
//			1 :	Wenn nur Dateien gelscht wurden.
//			2 : Wenn auch Verzeichnisse gelscht wurden.
int  CBrowserCtrl::Delete()
{
int	i;


	   i = GetSelect(&m_cDragFiles);						// Ausgewhlte Dateien holen
	if(i<=0)return 0;

	   i=DoDrop(0,4);
	if(i)Set(0);											// Verzeichnisse erneuern


return i;
}

//*****************************************************************************
//*
//*		GetSelect
//*
//*****************************************************************************
//	Kopriert die Namen der ausgewhlten Dateien in eine CStringChain Klasse.
//	pFiles		: Zeiger auf die Klasse
//	iMode:		: Dieser Wert bestimmt von wo die Dateinamen geholt werden:
//					0 = Aus dem aktuelles Fenster
//					1 = Aus dem TreeView
//					2 = Aus dem ListView
//	Ergibt die Anzahl der kopierten Dateinamen.
int CBrowserCtrl::GetSelect(CStringChain *pFiles,int iMode)
{
TCHAR		cBuffer[MAX_PATH+16];
HTREEITEM	hItem;
CWnd	   *pWnd;
int			iPos;
int			iLen;
int			iNum;



	pFiles->Del();											// Die Klasse lschen
	pWnd = 0;

	if(!iMode)
		{
			pWnd=GetFocus();
		if(!pWnd)return 0;
		}
															// Im Treeview ?
	if(iMode==1 || (iMode==0 && pWnd->m_hWnd==m_cTreeView.m_hWnd))
		{
		         hItem=m_cTreeView.GetFirstSelected();
		if(hItem)hItem=m_cTreeView.GetFocusItem();

		iLen = GetPath(hItem,cBuffer,MAX_PATH);

		if(iLen>3 && cBuffer[iLen-1]=='\\')iLen--;
		pFiles->Add(iLen,cBuffer);
		return 1;
		}


	iPos = -1;
	iNum =  0;
															// Im ListView ?
	if(iMode==2 || (iMode==0 && pWnd->m_hWnd==m_cListView.m_hWnd))
	do	{
		iPos	= m_cListView.GetFirstSelected();if(iPos==-1)break;
		iLen	= GetPath(iPos,cBuffer,MAX_PATH);
		if((iLen>3) && cBuffer[iLen-1]=='\\')iLen--;
		pFiles->Add(iLen,cBuffer);
		iNum++;
		}while(1);



return iNum;
}


//*****************************************************************************
//*
//*		OnListDblClick
//*
//*****************************************************************************
//	Doppelklick auf eine Datei.
void CBrowserCtrl::OnListDblClick(NMHDR *pNmHdr,LRESULT *pResult)
{
CFileFinder	   *pFind;
NM_LISTVIEW	   *pView;
int				iItem;



	pView	= (NM_LISTVIEW*)pNmHdr;
	iItem	= pView->iItem;
	pFind	= m_cListView.GetFiles();

	if(!pFind->IsDir(iItem))return;

	m_cTreeView.SetPath(0,pFind->Name(iItem));


}


//*****************************************************************************
//*
//*		OnListKeyDown
//*
//*****************************************************************************
//	Im ListView wurde eine Taste gedrckt
void CBrowserCtrl::OnListKeyDown(NMHDR *pNmHdr,LRESULT *pResult)
{
CFileFinder	   *pFind;
LV_KEYDOWN_EX  *pKey;
int				i;



	pKey = (LV_KEYDOWN_EX*)pNmHdr;

	if(pKey->wVKey==VK_RETURN)							// Wurde Return-Taste gedrckt
		{
		   i=m_cListView.GetNextItem(-1,LVNI_FOCUSED);
		if(i==-1)return;

			pFind = m_cListView.GetFiles();
		if(!pFind->IsDir(i))return;

		m_cTreeView.SetPath(0,pFind->Name(i));
		return;
		}

	if(pKey->wVKey==VK_F5)								// F5 --> neuladen
		{
		if(!(GetAsyncKeyState(VK_CONTROL)&0x8000))
		if(!(GetAsyncKeyState(VK_SHIFT  )&0x8000))
			{
			Reload();
			}
		}

	if(pKey->wVKey=='A')								// Cltl+A --> alles auswhlen
		{
		if(GetAsyncKeyState(VK_CONTROL)&0x8000)
			{
			OnSelectAll();
			}
		}

	if(pKey->wVKey==VK_TAB)								// TAB --> Fokus zum nchsten Fenster
		{
		*pResult=1;

		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
			{
			SetFocus(1);
			return;
			}

		if(m_iStyle&CBC_TABEXIT)
				 GetParent()->SetFocus();
		else	 SetFocus(1);

		return;
		}

	if(pKey->wVKey==VK_INSERT)							// Ctrl+Ins --> Dateien kopieren
		{
		if( (GetAsyncKeyState(VK_CONTROL)&0x8000))
		if(!(GetAsyncKeyState(VK_SHIFT  )&0x8000))
			{
			OnCopy();
			}

		return;
		}

	if(m_iStyle&CBC_DELETE && pKey->wVKey==VK_DELETE)	// Dateien lschen oder ausschneiden
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
				OnCut();
		else	Delete();
		}

}


//*****************************************************************************
//*
//*		OnListBeginEdit
//*
//*****************************************************************************
//	Beginnen eine Datei umzubennen
void CBrowserCtrl::OnListBeginEdit(NMHDR *pNmHdr,LRESULT *pResult)
{

	if(pNmHdr->code==LVN_BEGINLABELEDIT)
		{
		m_iDoRename|=2;
		}

}

//*****************************************************************************
//*
//*		OnListEndEdit
//*
//*****************************************************************************
void CBrowserCtrl::OnListEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cBuffer[MAX_PATH+16];
CFileFinder	   *pFind;
LV_DISPINFO	   *pDisp;
int				iNum;
int				iLen;



	if(!(m_iStyle&CBC_RENAME))return;

	pDisp = (LV_DISPINFO*)pNmHdr;
	m_iDoRename&=~2;

	if(!pDisp->item.pszText)return;

	iNum = pDisp->item.iItem;
	iLen = GetPath(iNum,cBuffer,MAX_PATH+2);

	if(Rename(cBuffer,pDisp->item.pszText))
		{
		pFind = m_cListView.GetFiles();
		pFind->Rename(iNum,pDisp->item.pszText);

		m_cListView.SetItemText(iNum,0,pDisp->item.pszText);
		m_cListView.RedrawItem (iNum);
		}


}


//*****************************************************************************
//*
//*		OnTreeKeyDown
//*
//*****************************************************************************
void CBrowserCtrl::OnTreeKeyDown(NMHDR *pNmHdr,LRESULT *pResult)
{
TV_KEYDOWN	 *pKey;



	pKey = (TV_KEYDOWN*)pNmHdr;

	if(pKey->wVKey==VK_TAB)								// TAB --> Fookus zum nchsten Fenster
		{
		*pResult=1;

		if(!(GetAsyncKeyState(VK_SHIFT)&0x8000))
			{
			SetFocus(0);
			return;
			}

		if(m_iStyle&CBC_TABEXIT)
			{
			GetParent()->SetFocus();
			}
		else{
			SetFocus(0);
			}

		return;
		}

	if(pKey->wVKey==VK_INSERT)							// Cltr+Ins --> Dateien kopieren
		{
		if( (GetAsyncKeyState(VK_CONTROL)&0x8000))
		if(!(GetAsyncKeyState(VK_SHIFT  )&0x8000))
			{
			OnCopy();
			}
		}

	if(m_iStyle&CBC_DELETE && pKey->wVKey==VK_DELETE)	// Dateien lschen oder ausschneiden
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
				OnCut();
		else	Delete();
		}

}

//*****************************************************************************
//*
//*		OnTreeLabelEdit
//*
//*****************************************************************************
void CBrowserCtrl::OnTreeBeginEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TV_DISPINFO	 *pDisp=(TV_DISPINFO*)pNmHdr;


	if(!(m_iStyle&CBC_RENAME))
		{
		return;
		}

	if(!m_cTreeView.IsRealPath(pDisp->item.hItem))
		{
		*pResult = 1;
		}
	else{
		m_iDoRename |= 1;
		}


}

//*****************************************************************************
//*
//*		OnTreeEndEdit
//*
//*****************************************************************************
void CBrowserCtrl::OnTreeEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cBuffer[MAX_PATH];
TV_DISPINFO	   *pDisp;
LPCTSTR			pPath;
HTREEITEM		hNext;
HTREEITEM		hItem;
int				iLen;



	pDisp = (TV_DISPINFO*)pNmHdr;

	m_iDoRename	&= ~1;

	if(!pDisp->item.pszText)return;

	iLen	= GetPath(pDisp->item.hItem,cBuffer,MAX_PATH);
	hItem	= pDisp->item.hItem;

	if(Rename(cBuffer,pDisp->item.pszText))
		{
				 m_cTreeView.SetItemText  (hItem,pDisp->item.pszText);
		   hNext=m_cTreeView.GetParentItem(hItem);
		if(hNext)m_cTreeView.SortFolders  (hNext);
		}

	pPath = m_cTreeView.GetPath();

	if(!_tcsicmp(pPath,cBuffer))
		{
		SetPath(cBuffer);
		}

}

//*****************************************************************************
//*
//*		OnTreeSetFocus
//*
//*****************************************************************************
void CBrowserCtrl::OnTreeSetFocus(NMHDR *pNmHdr,LRESULT *pResult)
{
CBC_SETFOCUS	sFocus;


	m_iLastFocus = 2;

	sFocus.sNmHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
	sFocus.sNmHdr.hwndFrom	= m_hWnd;
	sFocus.sNmHdr.code		= NM_SETFOCUS;
	sFocus.iItem			= m_iLastFocus;

	GetParent()->SendMessage(WM_NOTIFY,sFocus.sNmHdr.idFrom,(LPARAM)&sFocus.sNmHdr);

}

//*****************************************************************************
//*
//*		OnListSetFocus
//*
//*****************************************************************************
void CBrowserCtrl::OnListSetFocus(NMHDR *pNmHdr,LRESULT *pResult)
{
CBC_SETFOCUS	sFocus;


	m_iLastFocus = 1;

	sFocus.sNmHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
	sFocus.sNmHdr.hwndFrom	= m_hWnd;
	sFocus.sNmHdr.code		= NM_SETFOCUS;
	sFocus.iItem			= m_iLastFocus;

	GetParent()->SendMessage(WM_NOTIFY,sFocus.sNmHdr.idFrom,(LPARAM)&sFocus.sNmHdr);

}

//*****************************************************************************
//*
//*		OnTreeFolderSel
//*
//*****************************************************************************
//	Ein anderes Verzeichnis wurde ausgewhlt
void CBrowserCtrl::OnTreeFolderSel(NMHDR *pNmHdr,LRESULT *pResult)
{
CFT_FOLDER *pNotify=(CFT_FOLDER*)pNmHdr;


	m_cListView.Break();
	m_hTreadAction.Unlock();

	pNmHdr->idFrom		= GetWindowLong(m_hWnd,GWL_ID);
	pNmHdr->hwndFrom	= m_hWnd;

	GetParent()->SendMessage(WM_NOTIFY,pNmHdr->idFrom,(LPARAM)pNmHdr);

	if(pNotify->iMode==1 && !(m_iStyle&CBC_ONLYFILES))
		{
		*pResult = 1;
		}

}

//*****************************************************************************
//*
//*		Reload
//*
//*****************************************************************************
void CBrowserCtrl::Reload()
{

	m_cListView.Break();
	m_hTreadAction.Unlock();

}

//*****************************************************************************
//*
//*		OnTreeRButton
//*
//*****************************************************************************
void CBrowserCtrl::OnTreeRButton(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cPath[MAX_PATH];
NM_TREEVIEW	   *pTree=(NM_TREEVIEW*)pNmHdr;
HTREEITEM		hItem;
CBC_RCLICK		sHdr;


	*pResult = 0;
	hItem	 = m_cTreeView.GetFocusItem();

	if(!GetPath(hItem,cPath,sizeof(cPath)))return;

	sHdr.sNmHdr.code		= CBC_LISTRCLICK;
	sHdr.sNmHdr.hwndFrom	= m_hWnd;
	sHdr.sNmHdr.idFrom		= GetWindowLong(m_hWnd,GWL_ID);
	sHdr.iItem				= -1;
	sHdr.pPath				= cPath;

	GetParent()->SendMessage(WM_NOTIFY,sHdr.sNmHdr.idFrom,(LPARAM)&sHdr);

}


//*****************************************************************************
//*
//*		OnListRButton
//*
//*****************************************************************************
void CBrowserCtrl::OnListRButton(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cPath[MAX_PATH];
CFileFinder    *pFind;
CBC_RCLICK		sHdr;
int				iNum;


	*pResult = 0;
	pFind	 = m_cListView.GetFiles();

	   iNum=GetFocusItem();
	if(iNum<0)return;

	strlcpy(cPath,pFind->Name(iNum,1),sizeof(cPath));

	sHdr.sNmHdr.code		= CBC_LISTRCLICK;
	sHdr.sNmHdr.hwndFrom	= m_hWnd;
	sHdr.sNmHdr.idFrom		= GetWindowLong(m_hWnd,GWL_ID);
	sHdr.iItem				= iNum;
	sHdr.pPath				= cPath;

	GetParent()->SendMessage(WM_NOTIFY,sHdr.sNmHdr.idFrom,(LPARAM)&sHdr);

}

//*****************************************************************************
//*
//*		DoDrop
//*
//*****************************************************************************
//	Ruft die Drop-Funktion auf. Die Dateiliste ist in m_cDragFiles zu finden.
//	pPath	: Ist der benutzte Pfad.
//	iMode	: Bestimmt den Drop-Effekt
//				0 = DROPEFFECT_NONE
//				1 = DROPEFFECT_MOVE
//				2 = DROPEFFECT_COPY
//				3 = DROPEFFECT_LINK
//				4 = DELETE
//	Ergibt	0 : Wenn nichts verndert wurde
//			1 :	Wenn nur Dateien kopiert wurden
//			2 : Wenn auch Verzeichnisse verndert wurden
int CBrowserCtrl::DoDrop(LPCTSTR pPath,int iMode)
{
TCHAR		cBuffer[MAX_PATH+16];
CBC_NMHDR	sHdr;
int			iLen;
int			iRet;



	if(iMode==-1)return 0;


	iLen = (int)_tcslen(pPath);
	if(iLen>MAX_PATH+2)iLen=MAX_PATH+2;

	memcpy(cBuffer,pPath,iLen*sizeof(TCHAR));					// Pfad ermitteln

	for(;iLen>0;iLen--)
		{
		if(cBuffer[iLen]=='\\')break;
		}

	if(iLen && cBuffer[iLen-1]==':')
		{
		cBuffer[iLen] = '\\';
		iLen++;
		}

	cBuffer[iLen]=0;


	sHdr.sNmHdr.idFrom		= GetWindowLong(m_hWnd,GWL_ID);
	sHdr.sNmHdr.code		= CBC_DODROP;
	sHdr.sNmHdr.hwndFrom	= m_hWnd;
	sHdr.iMode				= iMode;
	sHdr.pPath				= cBuffer;
	sHdr.iCount				= m_cDragFiles.Count();
	sHdr.pFiles				= &m_cDragFiles;
	sHdr.iSize64			= 0;

	iRet = (int)GetParent()->SendMessage(WM_NOTIFY,sHdr.sNmHdr.idFrom,(LPARAM)&sHdr);

	if(iRet && (!_tcsicmp(cBuffer,m_cTreeView.GetPath()) || iRet==2))
		{
		Reload();
		}


return iRet;
}


//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
//	Whlt alle Dateien im ListView aus.
//	Ergibt die Anzahl der gewhlten Dateien.
void CBrowserCtrl::SelectAll()
{

	m_cListView.SelectAllItems();
	SetFocus(0);

}

//*****************************************************************************
//*
//*		OnNewDir
//*
//*****************************************************************************
//	Erzeugt ein neues Verzeichnis
void CBrowserCtrl::OnNewDir()
{
	NewDirectory();
}

//*****************************************************************************
//*
//*		NewDirectory
//*
//*****************************************************************************
//	Erzeugt ein neues Verzeichnis.
//	pName	: Ist der Name fr das neue Verzeichnis.
//			  Ist der Zeiger 0 so wird ein Stantartname verwendet.
//	Ergibt	0 : Wenn Verzeichnis erzeugt wurde.
//		   -1 :	Wenn Verzeichnis nicht erzeugt wurde.
int CBrowserCtrl::NewDirectory(LPCTSTR pName)
{
TCHAR			cBuffer[MAX_PATH+64];
HTREEITEM		hItem;
CFileFinder	   *pFind;
SysFindStruct	sFind;
SysFind			hFind;
int				iLen;
int				iPos;
int				iNum;
int				i;


	if(m_iStyle&CBC_ONLYFILES)								// Nur Dateien anzeigen
		{
		return -1;
		}

	if(!m_cTreeView.GetPathMode())							// Ist es ein virtuelle Netzwerkszeweig
		{
		return -1;
		}

	iLen = m_cTreeView.GetPath(cBuffer,MAX_PATH,&hItem);
	if(iLen && cBuffer[iLen-1]!='\\')
		{
		cBuffer[iLen] = '\\';
		iLen++;
		}

	if(!pName)
		{
		iNum  	= 0;
		          _tcscpy(cBuffer+iLen,_T("Neues Verzeichnis"));
		iPos	= (int)_tcslen(cBuffer);
		hFind	= SysFindFirst(cBuffer,&sFind);				// Einen freien Namen suchen

		while(hFind)
			{
			iNum++;
			SysFindClose(hFind);
			cBuffer[iPos]='(';
			_itot(iNum,cBuffer+iPos+1,10);
			_tcscat(cBuffer+iPos,_T(")"));
			hFind=SysFindFirst(cBuffer,&sFind);
			}
		}
	else{
		i=(int)_tcslen(pName);
		if(i+iLen>MAX_PATH)return -1;
		memcpy(cBuffer+iLen,pName,i+1);
		}


	i = CreateDirectory(cBuffer,NULL);						// Verzeichnis erzeugen

	if(i==0)
		{
		MessageBox(_T("Kann Verzeichnis nicht erzeugen !."),0,MB_ICONERROR|MB_OK);
		return -1;
		}

	pFind = m_cListView.GetFiles();
	pFind->Insert(cBuffer,-1,SYS_DIR);
	m_cTreeView.SynchPath(hItem,pFind);

	if(!pName)												// Dateinamen bearbeiten
		{
		iPos  = pFind->Find(cBuffer+iLen);

		if(iPos>=0)
			{
			SetFocus(0);
			m_cListView.EditLabel(iPos);
			}
		}


return 0;
}

//*****************************************************************************
//*
//*		SetStyle
//*
//*****************************************************************************
//	ndert das Aussehen und Verhalten der Fenster.
//	iStyle		: Ist der neue Style fr die Fenster.
//					CBC_NOLISTVIEW		0x0001	ListView nicht anzeigen
//					CBC_NOTREEVIEW		0x0002	TreeView nicht anzeigen
//					CBC_DRAGDROP		0x0010	Drag und Drop aktivieren
//					CBC_NODROP			0x0020	Kein Drop auf sich selbst

//					CBC_NOLISTVIEW		0x0001	ListView nicht anzeigen
//					CBC_NOTREEVIEW		0x0002	TreeView nicht anzeigen
//					CBC_RENAME			0x0004	Dateien knnen umbenannt werden
//					CBC_DELETE			0x0008	Datei Lschen erlaubt
//					CBC_TABEXIT			0x0080	Bei TAB Focus an Elternfenster geben
//					CBC_DRAG			0x0010	Drag Operationen freigeben
//					CBC_DROP			0x0020	Drop Operationen freigeben
//					CBC_DRAGDROP		0x0030	Drop&Drop Operationen freigeben
//					CBC_STATUSBAR		0x0040	Statusbar Nachrichten abschicken
//					CBC_NONETDIRS		0x0100	Keine Netzlaufwerke anzeigen
//					CBC_SHOWPATHUP		0x0200	Das ".." Verzeichnis anzeigen
//					CBC_ONLYFILES		0x0400	Nur Dateien im Listenfenster anzeigen
//					CBC_SETCOLUMN		0x0800	Die Spalten mit rechten Mausklick einblenden

//	iMask		: Bestimmt welche Style-Bits verndert werden.
//	Ergibt die die vorherigen Style-Attribute.
int CBrowserCtrl::SetStyle(int iStyle,int iMaske)
{
RECT	sRect;
int		iOld;
int		iSet;


		  	 iStyle&= iMaske;
	iOld = m_iStyle        &0xFFFF;
		   m_iStyle&=~iMaske;
		   m_iStyle|=iStyle&0xFFFF;

	if((iOld^m_iStyle)&(CBC_NOTREEVIEW|CBC_NOLISTVIEW))
		{
		m_cTreeView.ShowWindow((m_iStyle&CBC_NOTREEVIEW)? SW_HIDE:SW_SHOW );
		m_cListView.ShowWindow((m_iStyle&CBC_NOLISTVIEW)? SW_HIDE:SW_SHOW );
		GetClientRect(&sRect);
		OnSize(0,sRect.right-sRect.left,sRect.bottom-sRect.bottom);
		Set(0);
		}


	if((iOld^m_iStyle)&(CBC_ONLYFILES|CBC_SHOWPATHUP|CBC_STATUSBAR|CBC_SETCOLUMN|CBC_TABEXIT|CBC_DRAG))
		{
		iSet = CFL_ADDDIR;

		if(m_iStyle&CBC_SHOWPATHUP)iSet|= CFL_ADDUP;
		if(m_iStyle&CBC_ONLYFILES )iSet&=~CFL_ADDDIR;
		if(m_iStyle&CBC_SETCOLUMN )iSet|= CFL_SETCOLUMN;
		if(m_iStyle&CBC_STATUSBAR )iSet|= CFL_STATUSBAR;
		if(m_iStyle&CBC_TABEXIT   )iSet|= CFL_TABEXIT;
		if(m_iStyle&CBC_DRAG      )iSet|= CFL_ALLOWDRAG;

		m_cListView.SetStyle(iSet,CFL_ADDUP|CFL_ADDDIR|CFL_STATUSBAR|CFL_TABEXIT|CFL_ALLOWDRAG);

		if((iOld^m_iStyle)&CBC_SHOWPATHUP)
			{
			Reload();
			}
		}



return iOld;
}


//*****************************************************************************
//*
//*		OnListDragAction
//*
//*****************************************************************************
//	Eine Drag-Aktion wurde in TreeView gestartet oder beendet
void CBrowserCtrl::OnListDragAction(NMHDR *pNmHdr,LRESULT *pResult)
{
CFL_DRAGSTATUS *pNotify=(CFL_DRAGSTATUS*)pNmHdr;


	if(!(m_iStyle&CBC_DRAG))
		{
		*pResult = 1;
		return;
		}


}

//*****************************************************************************
//*
//*		OnTreeDragAction
//*
//*****************************************************************************
//	Eine Drag-Aktion wurde in TreeView gestartet oder beendet
void CBrowserCtrl::OnTreeDragAction(NMHDR *pNmHdr,LRESULT *pResult)
{
CFT_FOLDER *pNotify=(CFT_FOLDER*)pNmHdr;


	if(!(m_iStyle&CBC_DRAG))
		{
		*pResult = 1;
		return;
		}


}

//*****************************************************************************
//*
//*		OnDragScroll
//*
//*****************************************************************************
DROPEFFECT CBrowserCtrl::OnDragScroll(DWORD dwKeyState,CPoint sPoint)
{
HTREEITEM		hItem;
CRect			sRect;
UINT			uFlags;
int				iStep;



	do	{
		if(!(m_iStyle&CBC_DROP))
			{
			return DROPEFFECT_NONE;
			}


		if(m_uDropTime>GetTickCount())
			{
			break;
			}


		GetClientRect(&sRect);

		m_uDropTime		= GetTickCount()+DRAG_SCROLL_TIME;
		m_sDropPoint	= sPoint;
		m_iDropScroll	= 0;

		if(sPoint.y>sRect.bottom-8)
			{
			iStep = sPoint.y-sRect.bottom+8;
			}
		else if(sPoint.y<20)
			{
			iStep = 20-sPoint.y;
			}
		else{
			iStep = 0;
			}

		if(m_pDropWnd->m_hWnd==m_cListView.m_hWnd)			// Im List-View
			{
			if(iStep)										// List-View scrollen
				{
				OnDragLeave();
				if(iStep>8)iStep=8;
				m_uDropTime=GetTickCount()+((DRAG_SCROLL_TIME*8)/(20+3*iStep));
				m_cListView.Scroll((sPoint.y<20)? -1:1);
				m_iDropScroll = 2;
				}
			}
		else{
			if(iStep)										// Tree-View scrollen
				{
				if(iStep>8)iStep=8;

				      m_uDropTime=GetTickCount()+((DRAG_SCROLL_TIME*8)/(20+3*iStep));
				hItem=m_cTreeView.GetFirstVisibleItem();
				hItem=m_cTreeView.GetNextItem(hItem,(sPoint.y<5)? TVGN_PREVIOUSVISIBLE:TVGN_NEXTVISIBLE);
				if(hItem)m_cTreeView.SelectSetFirstVisible(hItem);
				m_iDropScroll = 1;
				break;
				}

			   hItem=m_cTreeView.HitTest(sPoint,&uFlags);
			if(hItem==0)break;
			if(!(m_cTreeView.GetItemState(hItem,TVIS_EXPANDED)&TVIS_EXPANDED))
				{
				m_cTreeView.Expand(hItem,TVE_EXPAND);
				m_uDropTime=GetTickCount()+DRAG_SCROLL_TIME;
				break;
				}
			}
		}while(0);



	if((dwKeyState&(MK_CONTROL|MK_SHIFT)) == (MK_CONTROL|MK_SHIFT))
							  return DROPEFFECT_LINK;
	if( dwKeyState&MK_CONTROL)return DROPEFFECT_COPY;
	if( dwKeyState&MK_SHIFT  )return DROPEFFECT_MOVE;



return DROPEFFECT_MOVE;
}


//*****************************************************************************
//*
//*		OnDragLeave
//*
//*****************************************************************************
void CBrowserCtrl::OnDragLeave()
{


	if(m_hDropTargetT)										// DropTarget lschen
		{
		m_cTreeView.SelectDropTarget(0);
		m_hDropTargetT = 0;
		}

	if(m_iDropTargetL!=-1)									// DropTarget lschen
		{
		m_cListView.SelectDropTarget(-1);
		m_iDropTargetL = -1;
		}


}


//*****************************************************************************
//*
//*		OnDragOver
//*
//*****************************************************************************
DROPEFFECT CBrowserCtrl::OnDragOver(COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint)
{
TCHAR			cBuffer[MAX_PATH];
CFileFinder	   *pFind;
STGMEDIUM		sData;
HTREEITEM		hItem;
UINT			uFlags;
int				iIndex;
int				iDifX;
int				iDifY;




	if(!(m_iStyle&CBC_DROP))
		{
		return DROPEFFECT_NONE;
		}

	if(!pDataObject->GetData(CF_HDROP,&sData))
		{
		return DROPEFFECT_NONE;
		}


	if(m_pDropWnd->m_hWnd==m_cListView.m_hWnd)				// Im List-View
		{
		iIndex = m_cListView.HitTest(sPoint,&uFlags);
		m_cListView.SelectDropTarget(iIndex);
		m_iDropTargetL = iIndex;

		pFind = m_cListView.GetFiles();

		if(pFind->IsDir(iIndex))
				GetPath(     iIndex,cBuffer,sizeof(cBuffer));
		else	m_cTreeView.GetPath(cBuffer,sizeof(cBuffer));

		iDifX =	sPoint.x-m_sDropPoint.x;
		iDifY =	sPoint.y-m_sDropPoint.y;

		if(m_iDropMode!=2 || (m_iDropScroll==2 && (iDifX>2 || iDifX<-2 || iDifY>16 || iDifX<-16)))
			{
			m_uDropTime  = GetTickCount()+DRAG_SCROLL_TIME;
			m_sDropPoint = sPoint;
			m_iDropMode  = 2;
			}
		}
	else{													// Im Tree-View
		   hItem = m_cTreeView.HitTest(sPoint,&uFlags);
		if(hItem==0)return DROPEFFECT_NONE;
		if(m_iDragMode==1 && m_hDragItem==hItem)return DROPEFFECT_NONE;

		m_cTreeView.SelectDropTarget(hItem);
		m_hDropTargetT = hItem;
		GetPath(hItem,cBuffer,sizeof(cBuffer));

		iDifX =	sPoint.x-m_sDropPoint.x;
		iDifY =	sPoint.y-m_sDropPoint.y;

		if(m_iDropMode!=1 || (m_iDropScroll==1 && (iDifX>2 || iDifX<-2 || iDifY>16 || iDifX<-16)))
			{
			m_uDropTime  = GetTickCount()+DRAG_SCROLL_TIME;
			m_sDropPoint = sPoint;
			m_iDropMode  = 1;
			}
		}


	if((dwKeyState&(MK_CONTROL|MK_SHIFT)) == (MK_CONTROL|MK_SHIFT))
							  return DROPEFFECT_LINK;
	if( dwKeyState&MK_CONTROL)return DROPEFFECT_COPY;
	if( dwKeyState&MK_SHIFT  )return DROPEFFECT_MOVE;



return DROPEFFECT_MOVE;
}

//*****************************************************************************
//*
//*		OnDrop
//*
//*****************************************************************************
BOOL CBrowserCtrl::OnDrop(COleDataObject *pDataObject,DROPEFFECT iDropEffect,CPoint sPoint)
{
TCHAR			cBuffer[MAX_PATH];
CFileFinder	   *pFind;
STGMEDIUM		sData;
HTREEITEM		hItem;
CPoint			sPos;
UINT			uFlags;
int				iCount;
int				iIndex;
int				iMode;
int				i;




	if(!(m_iStyle&CBC_DROP))
		{
		return FALSE;
		}

	if(!pDataObject->GetData(CF_HDROP,&sData))
		{
		return FALSE;
		}


	if(m_pDropWnd->m_hWnd==m_cListView.m_hWnd)
		{
		iIndex = m_cListView.HitTest(sPoint,&uFlags);
		pFind  = m_cListView.GetFiles();

		if(pFind->IsDir(iIndex))
				GetPath(     iIndex,cBuffer,sizeof(cBuffer));
		else	m_cTreeView.GetPath(cBuffer,sizeof(cBuffer));
		}
	else{
		   hItem=m_cTreeView.HitTest(sPoint,&uFlags);
		if(hItem==0)return FALSE;
		if(m_iDragMode==1 && m_hDragItem==hItem)return FALSE;

		GetPath(hItem,cBuffer,sizeof(cBuffer));
		}

	if(!cBuffer[0])return FALSE;

	m_cDragFiles.Del();							// Drag-Dateien einlesen
	iCount=DragQueryFile((HDROP)sData.hGlobal,-1,cBuffer,sizeof(cBuffer));

	for(i=0;i<iCount;i++)
		{
		DragQueryFile((HDROP)sData.hGlobal,i,cBuffer,sizeof(cBuffer));
		m_cDragFiles.Add(cBuffer);
		}


	OnDragLeave();

	m_iDropScroll = 0;

	if(!iCount)return TRUE;

								   iMode=0;
	if(iDropEffect&DROPEFFECT_LINK)iMode=3;
	if(iDropEffect&DROPEFFECT_MOVE)iMode=1;
	if(iDropEffect&DROPEFFECT_COPY)iMode=2;

	DoDrop(cBuffer,iMode);



return TRUE;
}

//*****************************************************************************
//*
//*		OnListStatusbar
//*
//*****************************************************************************
void CBrowserCtrl::OnListStatusbar(NMHDR *pNmHdr,LRESULT *pResult)
{

	if(!(m_iStyle&CBC_STATUSBAR))
		{
		return;
		}

	pNmHdr->idFrom		= GetWindowLong(m_hWnd,GWL_ID);
	pNmHdr->hwndFrom	= m_hWnd;

	GetParent()->SendMessage(WM_NOTIFY,pNmHdr->idFrom,(LPARAM)pNmHdr);

}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
//	Kopiert die Dateien in die Zwischenablage.
//	Ergibt TRUE wenn die Dateien kopiert werden konnten, ansonsten FALSE.
BOOL CBrowserCtrl::Copy()
{
CFileFinder	   *pFind;
CWnd		   *pFocus;
TCHAR		   *pMem;
TCHAR			cBuffer[MAX_PATH];
HGLOBAL			sData;
HTREEITEM		hItem;
LPCTSTR			pName;
LPCTSTR			pPath;
int				iPos;
int				iLen;
int				iNum;
BOOL			iOk;


	iPos	= -1;
	iLen	= 24;
	pFocus	= GetFocus();

	if(pFocus && pFocus->m_hWnd==m_cTreeView.m_hWnd)
		{
			hItem=m_cTreeView.GetSelectedItem();
		if(!hItem)return FALSE;

		   iLen=GetPath(hItem,cBuffer,sizeof(cBuffer));
		if(iLen>0 && (cBuffer[iLen-1]=='/' || cBuffer[iLen-1]=='\\'))iLen--;
		if(iLen>0 &&  cBuffer[iLen-1]==':') { cBuffer[iLen  ] ='\\'; iLen++; }

		sData	= GlobalAlloc(GMEM_ZEROINIT|GMEM_MOVEABLE|GMEM_DDESHARE,(iLen+22)*sizeof(TCHAR));
		pMem	= (TCHAR*)GlobalLock(sData);
		pMem[0]	= 20;
		#ifdef UNICODE
		pMem[8] = 1;
		#endif
		pMem   += 20/sizeof(TCHAR);

		memcpy(pMem,cBuffer,iLen*sizeof(TCHAR));
		}
	else{
		pFind	= m_cListView.GetFiles();

		for(;;) 									// Speichergre berechnen
			{
			   iPos=m_cListView.GetNextItem(iPos,LVIS_SELECTED);
			if(iPos<0)break;

			iLen += pFind->NameFullLen(iPos)+1;
			}


		sData	= GlobalAlloc(GMEM_ZEROINIT|GMEM_MOVEABLE|GMEM_DDESHARE,(iLen+4)*sizeof(TCHAR));
		pMem	= (TCHAR*)GlobalLock(sData);
		pMem[0]	= 20;
		#ifdef UNICODE
		pMem[8] = 1;
		#endif
		pMem   += 20/sizeof(TCHAR);
		iPos	= -1;

		for(;;) 									// Dateinamen anhngen
			{
			   iPos=m_cListView.GetNextItem(iPos,LVIS_SELECTED);
			if(iPos<0)break;

			pPath	= pFind->Path(iPos,0,&iLen);
			pName	= pFind->Name(iPos,0,&iNum);

			memcpy(pMem,pPath,iLen*sizeof(TCHAR)); pMem+=iLen;
			memcpy(pMem,pName,iNum*sizeof(TCHAR)); pMem+=iNum;
			pMem[0] = 0;
			pMem   += 1;
			}
		}


	iOk	= FALSE;

	GlobalUnlock(sData);

	if(OpenClipboard())
		{
		EmptyClipboard();
 		if(SetClipboardData(CF_HDROP,sData))iOk=TRUE;
		CloseClipboard();
		}

	if(!iOk)GlobalFree(sData);



return iOk;
}



//*****************************************************************************
//*
//*		OnClear
//*
//*****************************************************************************
//	Lscht alle ausgewhlten Dateien.
//	Ergibt TRUE wenn die Dateien gelscht werden konnten, ansonsten FALSE.
BOOL CBrowserCtrl::Clear()
{

	if(!(m_iStyle&CBC_DELETE))return FALSE;

	Delete();


return TRUE;
}


//*****************************************************************************
//*
//*		OnCut
//*
//*****************************************************************************
//	Schneidet alle ausgewhlten Dateien aus.
//	Ergibt TRUE wenn die Dateien ausgeschnitten werden konnten, ansonsten FALSE.
BOOL CBrowserCtrl::Cut()
{

	if(!(m_iStyle&CBC_DELETE))return FALSE;

	OnCopy();
	Delete();

return TRUE;
}


//*****************************************************************************
//*
//*		AddNetPath
//*
//*****************************************************************************
//	Fgt einen Netzpfad in das TreeView ein.
//	pPath		: Zeiger auf den Namen des Netzpfades.
//				  Er muss mit "\\..." beginnen.
//	Ergibt das Handle des Eintrages bei dem der Pfad eingefgt wurde.
HTREEITEM CBrowserCtrl::AddNetPath(LPCTSTR pPath)
{
HTREEITEM		hNext;


// REM AZ umbauen auf SetPath(....)

	if(pPath[0]!='\\')return 0;
	if(pPath[1]!='\\')return 0;

	hNext=0;

return hNext;
}

//*****************************************************************************
//*
//*		SetFocus
//*
//*****************************************************************************
//	Den Focus im Fenster setzen.
//	iNum		: Bestimmt das Fenster das den Fokus erhlt.
//					0 = Focus auf das ListView gegeben
//					1 = Focus auf das TreeView gegeben
//	Ergibt das Fenster das zuvor den Fokus hatte.
CWnd *CBrowserCtrl::SetFocus(int iNum)
{
CWnd   *pWnd;
int		i;


	if(m_iStyle&CBC_NOTREEVIEW    )iNum=0;
	if(m_iStyle&CBC_NOLISTVIEW && !iNum)return SetFocus();

	if(iNum)return m_cTreeView.SetFocus();


	pWnd = m_cListView.SetFocus();
	i	 = m_cListView.GetFocusItem();
	if(i<0)m_cListView.SetFocusItem(0);


return pWnd;
}



//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
void CBrowserCtrl::OnSelectAll()
{
	SelectAll();
}


//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CBrowserCtrl::OnDelete()
{
	Delete();
}


//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CBrowserCtrl::OnCopy()
{
	Copy();
}



//*****************************************************************************
//*
//*		OnClear
//*
//*****************************************************************************
void CBrowserCtrl::OnClear()
{
	Clear();
}


//*****************************************************************************
//*
//*		Cut
//*
//*****************************************************************************
void CBrowserCtrl::OnCut()
{
	Cut();
}


//*****************************************************************************
//*
//*		SetFullRowSelect
//*
//*****************************************************************************
void CBrowserCtrl::SetFullRowSelect(BOOL bOn)
{
	m_cListView.SetExtendedStyle((bOn)? LVS_EX_FULLROWSELECT:0,LVS_EX_FULLROWSELECT);
	m_cTreeView.SetExtendedStyle((bOn)? TVS_EX_FULLROWITEMS|TVS_EX_FULLROWMARK:0,TVS_EX_FULLROWITEMS|TVS_EX_FULLROWMARK);
}

//*****************************************************************************
//*
//*		SetAlternated
//*
//*****************************************************************************
void CBrowserCtrl::SetAlternated(BOOL bOn)
{
	m_cListView.SetExtendedStyle((bOn)? LVS_EX_ALTERNATECOLOR:0,LVS_EX_ALTERNATECOLOR);
	m_cTreeView.SetExtendedStyle((bOn)? TVS_EX_ALTERNATECOLOR:0,TVS_EX_ALTERNATECOLOR);
}

//*****************************************************************************
//*
//*		SetGridLines
//*
//*****************************************************************************
void CBrowserCtrl::SetGridLines(BOOL bOn)
{
	m_cListView.SetExtendedStyle((bOn)? LVS_EX_GRIDLINES:0,LVS_EX_GRIDLINES);
	m_cTreeView.SetExtendedStyle((bOn)? TVS_EX_ITEMLINES:0,TVS_EX_ITEMLINES);
}

//******************************************************************************
//*
//*		SetOrderMode
//*
//******************************************************************************
void CBrowserCtrl::SetOrderMode(BOOL bOn)
{

	m_cListView.SetExtendedStyle((bOn)? LVS_EX_HEADERDRAGDROP:0,LVS_EX_HEADERDRAGDROP);

}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Liest den Pfad eines Elements aus dem Baum- oder Listenfensters aus.
//	iType		: Ist die Art des Elementes (z.B. von HitTest)
//					1 wenn ein  Eintrag aus dem TreeView gefunden wurde.
//					2 wenn ein  Eintrag aus dem Listfeld gefunden wurde.
//	pEntry		: Hier wird Eintrag bergeben
//				  Ist ein Eintrag im ListView so wird sein Index bergeben
//				  Ist ein Eintrag im TreeView so wird HTREEITEM bergeben
//	pBuffer		: Hier wird der Pfad gespeichert
//	iFull		: Den ganzen Pfad auslesen, oder nur den Namen.
//	Ergibt die Lnge der gepseicherten Pfades in Zeichen bzw. 0 bei einem Fehler.
int CBrowserCtrl::GetPath(int iType,void *pElement,TCHAR *pBuffer,int iLen,int iFull)
{

	switch(iType)
		{
	case 1:
			if(iFull>0)return GetPath((HTREEITEM)pElement,pBuffer,iLen);
			return m_cTreeView.GetItemText((HTREEITEM)pElement,pBuffer,iLen);

	case 2:
			if(iFull>0)return GetPath((int)pElement,pBuffer,iLen);
			if(iLen>0 && m_cListView.GetItemText((int)pElement,-iFull,pBuffer,iLen))
				{
				return _tcslen(pBuffer);
				}
		}


	if(iLen>0)*pBuffer=0;


return 0;
}

//*****************************************************************************
//*
//*		SetSeparatorSize
//*
//*****************************************************************************
//	Stellt den Teiler ein
int CBrowserCtrl::SetSeparatorSize(int iSize)
{
int			iOld;


	if(m_iSeparator==iSize || iSize<0 || iSize>4096)
		{
		return m_iSeparator;
		}

	iOld = m_iSeparator;
	m_iSeparator = iSize;

	
	OnSize(0,m_iWindowX,m_iWindowY);
	


return iOld;
}
