//*****************************************************************************
//*
//*
//*		BrowserCtrl.h
//*
//*
//*****************************************************************************
//
// 	char   *GetPath()							Ergibt den aktuellen Pfad
// 	BOOL	SetPath(char *)						Ergibt den aktuellen Pfad
//	int	  	GetFocusItem()						Aktuelles Item vom Listview holen
//	BOOL  	SetFocusItem(int Item)				Aktuelles Item vom Listview setzen
// 	int   	Set (char*="C:\\",char*=0,int=0)	Neuen Pfad einstellen
//	int   	Filter (char *,char *,int =1)		Neuen Dateifilter einstellen
// 	void  	OnSelectAll()						Alles auswhlen
// 	int   	GetSelect(CStringChain *,int=0)		Ergibt die ausgewhlen Dateien
// 	int	  	SetStyle(int,int iMask=0xFFFF)		ndert das Aussehen
// 	int	  	Delete()							Lscht ausgewhlten Dateien
// 	int	  	NewDirectory(char *pName=0)			Erzeugt ein neues Verzeichnis
// 	int	  	DoDrop(char *pPath,int iMode)		Dorp-Funktion ausfhren
// 	int   	HitTest(CPoint,void *)				Ergibt Eintragnr. unter Cursor
// 	void   	Sort(int iMode=0,int iDir=0)		Sortiere ListView
//	void	Reload()							Aktuallisiert das Verzeichnis
//
//
#ifndef	  __BROWSERCTRL_H__
#define	  __BROWSERCTRL_H__

#if		   _MSC_VER >= 1000
#pragma		once
#endif

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#include	<string.h>
#include	<AfxMt.h>
#include	<AfxOle.h>
#include	<AfxCmn.h>
#include	"AfxMacros.h"
#include	"FileListCtrl.h"
#include	"FolderTreeCtrl.h"
#include	"StringFunctions.h"



//*****************************************************************************
//*
//*		Styles fr das Fenster
//*
//*****************************************************************************
				   
// Konstanten fr Create
#define	CBC_NOLISTVIEW		0x0001				// ListView nicht anzeigen
#define	CBC_NOTREEVIEW		0x0002				// TreeView nicht anzeigen
#define	CBC_RENAME			0x0004				// Dateien knnen umbenannt werden
#define	CBC_DELETE			0x0008				// Datei Lschen erlaubt
#define	CBC_TABEXIT			0x0080				// Bei TAB Focus an Elternfenster geben
#define CBC_DRAG			0x0010				// Drag Operationen freigeben
#define	CBC_DROP			0x0020				// Drop Operationen freigeben
#define	CBC_DRAGDROP		0x0030				// Drop&Drop Operationen freigeben
#define	CBC_STATUSBAR		0x0040				// Statusbar Nachrichten abschicken
#define	CBC_NONETDIRS		0x0100				// Keine Netzlaufwerke anzeigen
#define	CBC_SHOWPATHUP		0x0200				// Das ".." Verzeichnis anzeigen
#define	CBC_ONLYFILES		0x0400				// Nur Dateien im Listenfenster anzeigen
#define	CBC_SETCOLUMN		0x0800				// Die Spalten mit rechten Mausklick einblenden
#define	CBC_FIXEDSEPARATOR	0x1000				// Der Separator wird nicht angepasst

// Konstanten fr Notify Nachrichten
#define CBC_DODROP			0x1200				// Drop auf Fenster
#define CBC_LISTRCLICK		0x1201				// Click mit der rechten Maustaste im Listview
#define CBC_VIEWRCLICK		0x1202				// Click mit der rechten Maustaste im Treeview
#define	CBC_FOLDERSELECT	CFT_FOLDERSELECT	// Pfad wurde verndert
#define	CBC_STATUSBARSET	CFL_STATUSBARSET	// StatusBar setzen

// Konstanten fr Sort
#define	CBC_SORT_NAME 		CFL_SORT_NAME		// Nach Dateinamen     sortieren
#define	CBC_SORT_PATH		CFL_SORT_PATH		// Nach Dateipfad      sortieren
#define	CBC_SORT_SIZE		CFL_SORT_SIZE		// Nach Dateigre     sortieren
#define	CBC_SORT_TYPE		CFL_SORT_TYPE		// Nach Dateitype      sortieren
#define	CBC_SORT_TIME		CFL_SORT_TIME		// Nach Dateizeit      sortieren
#define	CBC_SORT_SUFFIX		CFL_SORT_SUFFIX		// Nach Dateisuffix    sortieren
#define	CBC_SORT_CREATE		CFL_SORT_CREATE		// Nach Erstllungszeit sortieren
#define	CBC_SORT_ACCCESS	CFL_SORT_ACCCESS	// Nach Zugiffszeit    sortieren
#define	CBC_SORT_NODIR		CFL_SORT_NODIR		// Verzeichnisse nicht an den Anfang
#define	CBC_SORT_VALUE		CFL_SORT_VALUE		// Bercksichtigt Zahlen in den Texten

#define IDW_BROWSERCTRL		0xABD0				// Standard Id fr Fenster
		 
typedef struct									// fr CBC_VIEWRCLICK und CBC_LISTRCLICK
	{
	NMHDR	sNmHdr;								// Notify Daten
	int		iItem;								// Item auf das geklickt wurde (-1 im Treefeld)
	LPCTSTR	pPath;								// Zeiger auf den Itempfad
	}CBC_RCLICK,*LPCBC_RCLICK;

typedef struct									// fr NM_SETFOCUS
	{
	NMHDR	sNmHdr;								// Notify Daten
	int		iItem;								// Fenster das den Fokus erhalten hat (1=List 2=Tree)
	}CBC_SETFOCUS,*LPCBC_SETFOCUS;

typedef struct									// fr CBC_DODROP und CBC_PATHCHANGE
	{
	NMHDR	sNmHdr;								// Notify Daten
	int		iMode;								// 0=None 1=Move 2=Copy 3=Link
	union	{
	struct	{
	int		iSize;								// Byte Gre
	int		iSizeHigh;							// Byte Gre obere 4 Byte
			};
	__int64	iSize64;							// Byte Gre 64-Bit-Format
			};
	int		iCount;								// Dateianzahl
	LPCTSTR	pPath;								// Drop Pfad
	CStringChain	*pFiles;					// Dateien
	}CBC_NMHDR,*LPCBC_NMHDR;

typedef CFL_STATUS		CBC_STATUS;
typedef CFT_FOLDER		CBC_FOLDER;
typedef LPCFL_STATUS	LPCBC_STATUS;





DECLARE_DROP_FUNC_MAIN(CBrowserCtrl);

//*****************************************************************************
//*
//*		KLASSE	CBrowserCtrl
//*
//*****************************************************************************
class CBrowserCtrl : public CWnd
{

public:

	CBrowserCtrl();
   ~CBrowserCtrl();

	//{{AFX_VIRTUAL(CBrowserCtrl)
public:
	BOOL			Create  (                DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID=IDW_BROWSERCTRL,LPCTSTR pPlus=0,LPCTSTR pMinus=0);
	BOOL			CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID=IDW_BROWSERCTRL,LPCTSTR pPlus=0,LPCTSTR pMinus=0);
	BOOL			PreCreateWindow(CREATESTRUCT &sCreate);
	//}}AFX_VIRTUAL

public:

	int				NewDirectory	(LPCTSTR		pName=0);
	int				SetStyle		(int			iStyle,int iMask=0xFFFF);
	int 			GetSelect		(CStringChain  *pFiles,int iMode=0);
	int 			HitTest			(CPoint			sPoint,void *pElement,int *pRow=0);
	int				Filter			(LPCTSTR		pPlus=0,LPCTSTR pMinus=0,int iMode=1);
	int 			GetPath		    (int iType,void*pElement,TCHAR *pBuffer,int iLen,int iFull=0);
	BOOL			SetPath			(LPCTSTR		pPath,LPCTSTR pPlus=0,LPCTSTR pMinus=0);
	LPCTSTR 		GetPath			(int			iReal=1);
	int  			GetSortMode		(int           *pDir=0);
	CFolderTreeCtrl*TreeWnd         ();
	CFileListCtrl  *ListWnd         ();
	CWnd		   *SetFocus		(int iNum=0);				// 0=List 1=Tree
	BOOL			SetFocusItem	(int iNum);
	int				GetFocusItem	();
	int				GetSeparatorSize();
	int				SetSeparatorSize(int iSize);
	void 			Sort			(int iMode=0,int iDir=0);
	BOOL			Set				(LPCTSTR pPath=_T("C:\\"),LPCTSTR pSubPath=0,int iMode=0);
	void  			Reload			();
	BOOL			Cut				();
	BOOL			Copy			();
	BOOL			Clear			();
	int				Delete			();
	void   			SelectAll		();
	void 			SetOrderMode    (BOOL bOn);
	void 			SetGridLines	(BOOL bOn);
	void 			SetAlternated 	(BOOL bOn);
	void 			SetFullRowSelect(BOOL bOn);

	virtual	int		DoDrop			(LPCTSTR pPath,int iMode);
	HTREEITEM		AddNetPath		(LPCTSTR pPath);

	void			OnCut			();
	void			OnCopy			();
	void			OnClear			();
	void 			OnSelectAll		();


protected:


#ifdef _DEBUG
   virtual void		AssertValid() const;
   virtual void		Dump(CDumpContext &dc) const;
#endif

	int 			GetPath		  (HTREEITEM hEntry  ,TCHAR  *pBuffer,int iLen);
	int 			GetPath		  (int       iEntry  ,TCHAR  *pBuffer,int iLen);
	int				Rename		  (LPCTSTR   pOldName,LPCTSTR pNewName);

	static	DWORD WINAPI InsertThread(LPVOID pView);
			DWORD 		 InsertThread();

	//{{AFX_MSG(CBrowserCtrl)
	afx_msg void OnClose();
	afx_msg void OnPaint();
	afx_msg void OnDelete();
	afx_msg void OnDestroy();
	afx_msg void OnSize (UINT nType,int iSizeX, int iSizeY);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags,CPoint sPoint);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	//}}AFX_MSG

	afx_msg void OnTreeFolderSel  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeDragAction (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeKeyDown	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeBeginEdit  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeEndEdit	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeRButton	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeSetFocus	  (NMHDR *pNmHdr, LRESULT *pResult);

	afx_msg void OnListRButton	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListKeyDown    (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListEndEdit	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListDblClick   (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListBeginEdit  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListDragAction (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListSetFocus	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListStatusbar  (NMHDR *pNmHdr, LRESULT *pResult);

public:

	afx_msg void OnNewDir   ();
	afx_msg void OnPathUp   ();


	DECLARE_MESSAGE_MAP()
	DECLARE_DROP_FUNC2(CBrowserCtrl);


//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

protected:


	CFolderTreeCtrl	m_cTreeView;				// Fenster mit Verzeichnisbaum
	CFileListCtrl	m_cListView;				// Fenster mit Dateiliste
	CStringChain 	m_cDragFiles;				// Dateienname fr Drag
	volatile int 	m_iStopThread;				// Einfge-Thread abbrechen
	TCHAR		   *m_pPlusFilter;				// Dateifilter
	TCHAR		   *m_pMinusFilter;				//		*
	int			 	m_iStyle;					// Fenster-Styles
	int			 	m_iSeparator;				// Teilung der Fenster
	int				m_iLastFocus;				// Wer hatte zuletzt den Fokus (0=nimand 1=List 2=Tree)
	int			 	m_iDoRename;				// Wird gerade eine Datei umbenannt
	int			 	m_iDropView;				// Hit_Test Fensternummer
	int			 	m_iDropTargetL;				// DropTarget List-Item
	int				m_iWindowX;					// Aktuelle Fenstergre
	int				m_iWindowY;					//		*
	HTREEITEM	 	m_hDropTargetT;				// DropTarget Tree-Item
	CSemaphoreNull	m_hTreadAction;				// Den Einfge-Threa Triggern

	int			 	m_iDragMode;				// 2= ListDrag 1=TreeDrag
	HTREEITEM	 	m_hDragItem;				// Item fr TreeDrag
	DWORD		 	m_uDropTime;				// Scroll-Zeit
	int			 	m_iDropMode;				// Letzter Modus
	int			 	m_iDropScroll;				// Letzter Scroll-Modus
	CPoint		 	m_sDropPoint;				// Letzter Punkt


};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	BOOL			CBrowserCtrl::Create(DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID,LPCTSTR pPlus,LPCTSTR pMinus){return CBrowserCtrl::CreateEx(0,dwStyle,sRect,pParentWnd,nID,pPlus,pMinus);}
inline	BOOL			CBrowserCtrl::Set             (LPCTSTR pPath,LPCTSTR  pSubPath,int iMode){return m_cTreeView.SetPath(pPath,pSubPath,iMode);}
inline	int 			CBrowserCtrl::GetPath	      (HTREEITEM hEntry,TCHAR *pPuffer,int iSize){return m_cTreeView.GetPath(hEntry,pPuffer,iSize);}
inline	int				CBrowserCtrl::GetFocusItem    (                  ){return  m_cListView.GetFocusItem();}
inline	BOOL			CBrowserCtrl::SetFocusItem    (int iItem         ){return  m_cListView.SetFocusItem(iItem);}
inline	void 			CBrowserCtrl::Sort            (int iMode,int iDir){		   m_cListView.Sort(iMode,iDir);}
inline	int				CBrowserCtrl::GetSortMode     (int *pDir         ){return  m_cListView.GetSortMode(pDir);}
inline	CFolderTreeCtrl*CBrowserCtrl::TreeWnd         (                  ){return &m_cTreeView;}
inline	CFileListCtrl  *CBrowserCtrl::ListWnd         (                  ){return &m_cListView;}
inline	int				CBrowserCtrl::GetSeparatorSize(                  ){return  m_iSeparator;}


//{{AFX_INSERT_LOCATION}}




#endif
