//*****************************************************************************
//*
//*
//*		ChildBar.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
//	Ist das ein Toolbar-Fenster das Gren vernderbar ist, und in dem 
//	verscheidenste Kinder-Fenster angedockte werden knnen. ber Laschen 
//	knnen dann diese Fenster ausgewhlt werdnen.
//
//	CFrameWnd.h:
//
//		class CFrameWnd
//			{
//			...
//			CChildBar	m_wndChildBar;
//			...
//			}
//	
//	CFrameWnd.cpp:
//
//		int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
//			{
//			...
//									    
//			if(!m_wndChildBar.Create(this,CBRS_BOTTOM|CBRS_GRIPPER|CBRS_CLOSEBUTTON))
//				{							// --"-- wo darf das Fenster angedock werden
//				return -1;					// Fehler beim Erzeugen
//				}
//
//											// Ein Kindfenster einfgen
//			m_MyChildWnd.Create(... , &m_wndChildBar , ... )
//			m_wndChildBar.AttachWnd(&m_wndData);
//
//											// Optinen einstellen
//			m_wndChildBar.SetBarStyle(m_wndChildBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC|CBRS_ALIGN_BOTTOM);
//	
//											// Das Andocken freigeben
//			m_wndChildBar.EnableDocking(CBRS_ALIGN_ANY);
//
//											// Das Fenster ans Hauptfenster andocken  
//			DockControlBar(&m_wndChildBar ,AFX_IDW_DOCKBAR_BOTTOM);
//
//			...
//			}
//
//		void CMainFrame::OnDataviewOn()		// Fenster ein/ausblenden
//			{
//			ShowControlBar(&m_wndChildBar,!m_wndChildBar .IsVisible(),0);
//			}
//
//		void CMainFrame::OnDataviewOnMenu(CCmdUI *pCmdUI)
//			{
//			pCmdUI->SetCheck(m_wndChildBar.IsVisible());
//			}
//
//		void CMainFrame::OnUpdateDataMenu(CCmdUI *pCmdUI)
//			{
//			pCmdUI->Enable(m_wndChildBar.IsVisible());
//			}
//
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#include	"Afx.h"
#include	"AfxMacros.h"
#include	"AfxUtility.h"
#include	"ChildBar.h"



#ifdef     _DEBUG
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif


#define 	FRAME_X_ADD			10				// Breite des X-Rahmens bei Lasche
#define 	FRAME_Y_ADD			10				// Breite des X-Rahmens bei Lasche
#define 	FRAME_X				5				// Breite des X-Rahmens
#define 	FRAME_Z				0				// Breite des X-Rahmens
#define 	FRAME_Y				5				// Breite des Y-Rahmens

//*****************************************************************************
//*
//*		Nachrichten
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CChildBar, CSizeBar)
	//{{AFX_MSG_MAP(CChildBar)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

IMPLEMENT_DYNAMIC(CChildBar, CSizeBar)


//*****************************************************************************
//*
//*		Konstructor
//*
//*****************************************************************************
CChildBar::CChildBar()
{
	pChildWnd	= NULL;							// Zeiger auf angedocktes Fenster
	sChildRect.SetRectEmpty();					// Gre und Position Child Fenster
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CChildBar::~CChildBar()
{

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugen einer ChildBar
BOOL CChildBar::Create(              CWnd* pParentWnd,DWORD dwStyle,UINT nID){return Create(_T(""),pParentWnd,dwStyle,nID);}
BOOL CChildBar::Create(LPCTSTR pName,CWnd* pParentWnd,DWORD dwStyle,UINT nID)
{
CRect	sRect;



	ASSERT_VALID(pParentWnd);

	if(!CSizeBar::Create(pName,pParentWnd,nID,dwStyle))
		{
		return FALSE;
		}


	SetBarStyleEx(GetBarStyleEx()|SCBS_SHOWEDGES|SCBS_EDGETOP|SCBS_EDGEBOTTOM);



return TRUE;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CChildBar::OnDestroy()
{

	CSizeBar::OnDestroy();
}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CChildBar::OnSize(UINT nType, int iXsize, int iYsize)
{

	CSizeBar::OnSize(nType,iXsize,iYsize);



	if(iXsize>0  && iYsize>0)
	if(pChildWnd && IsWindow(pChildWnd->m_hWnd))		// Child einstellen
		{
		GetClientRect(&sChildRect);
		pChildWnd->MoveWindow(sChildRect);
		pChildWnd->ShowWindow(SW_SHOW);
		}

}


//*****************************************************************************
//*
//*		AttachWnd
//*
//*****************************************************************************
//	Hngt ein neues Fenster in die Bar ein
//	pNewWnd		: Zeiger auf das neue Fenster
//	Ergibt einen Zeiger auf das alte Fenster
CWnd *CChildBar::AttachWnd(CWnd *pNewWnd)
{
CWnd	*pOldWnd;


	if(pNewWnd==pChildWnd)return pNewWnd;

	if(pChildWnd && ::IsWindow(pChildWnd->m_hWnd))		// Altesfenster aus blenden
		{
		pChildWnd->ShowWindow(SW_HIDE);
		pChildWnd->MoveWindow(0,0,0,0);
		}

	pOldWnd		= pChildWnd;
	pChildWnd	= pNewWnd;

	if(pChildWnd && ::IsWindow(pChildWnd->m_hWnd))		// Das neue Fenster einhngen
		{
		pChildWnd->SetParent(this);
		pChildWnd->MoveWindow(sChildRect);
		pChildWnd->ShowWindow(SW_SHOW);
		}


	if(IsWindow(m_hWnd))RedrawWindow();




return pOldWnd;
}

//*****************************************************************************
//*
//*		DetachWnd
//*
//*****************************************************************************
//	Entfernt das Fenster aus den Client-Bereich ein
//	Ergibt das alte Fenster
CWnd *CChildBar::DetachWnd()
{
CWnd	*pOldWnd;


	if(!sChildRect)return 0;
	if( pChildWnd && ::IsWindow(pChildWnd->m_hWnd))
		{
		pChildWnd->ShowWindow(SW_HIDE);
		pChildWnd->MoveWindow(0,0,0,0);
		}

	pOldWnd		= pChildWnd;
	pChildWnd	= NULL;


	if(IsWindow(m_hWnd))RedrawWindow();



return pOldWnd;
}

