//*****************************************************************************
//*
//*
//*		ColorComboWnd.h
//*
//*
//*****************************************************************************
//
//	Ist einen Win-API-ComboBox-Fenster das Farben und dicke Schrift zu lst.
//
//	Fenster Styles:
//	
//		CBS_SIMPLE          	0x0000	Auswahlliste ist immer sichtbar
//		CBS_DROPDOWN        	0x0002	ComboBox mit Eingabefeld
//		CBS_DROPDOWNLIST    	0x0003	ComboBox ohne Eingabefeld
//		CBS_OWNERDRAWFIXED		0x0010	--- nicht untersttzt ---
//		CBS_OWNERDRAWVARIABLE   0x0020	--- nicht untersttzt ---
//		CBS_AUTOHSCROLL        	0x0040	--- nicht untersttzt ---
//		CBS_OEMCONVERT         	0x0080	--- nicht untersttzt ---
//		CBS_SORT		      	0x0100	Die Eintrge in der Listbox werden sortiert
//		CBS_HASSTRINGS      	0x0200	--- nicht untersttzt ---
//		CBS_WANTRETURN			0x0200	Die Tasten RET/TAB/ESC nia Notify melden
//		CBS_NOINTEGRALHEIGHT   	0x0400	Die Listbox kann partielle Elemente anzeigen
//		CBS_DISABLENOSCROLL    	0x0800	Keien Y-Scrollbar in der Listbox
//		CBS_UPPERCASE       	0x1000	--- nicht untersttzt ---
//		CBS_LOWERCASE          	0x2000	--- nicht untersttzt ---
//		CBS_ALLOWDROP			0x4000	Dateien knnen auf das Control fallengelassen werden
//		CBS_NOGRAYDISABLE		0x8000	Fenster nicht grau machen wenn es gesperrt ist
//		CBS_ONLYLISTPAINT     WS_GROUP	Nur die Listbox farbig zeichnen
//	
//	Beispiel:
//
//		ColorComboProc(hWnd,WM_ATTACH,0,0);					// Eingngen
//		SendMessage   (hWnd,CB_SETIMAGELIST    ,0,(LPARAM)GetIconList());
//		SendMessage   (hWnd,CB_SETIMAGE        ,-1,GetIconNr("Test.cpp",SHGFI_USEFILEATTRIBUTES));
//		SendMessage   (hWnd,CB_SETCOLOR        ,MAKELONG(16,-1),(LPARAM)"\x42\x42\x42\x42\0\3\3\3\3\3\0\x20\x20\x20\x20\x20");
//		SendMessage   (hWnd,CB_SETDROPPEDHEIGHT,-15,0);
//		SendMessage   (hWnd,CB_SETTABSTOP      ,60,0);
//
//		ColorEditProc(hWnd,WM_DETACH,0,0);					// Aushngen
//	
#ifndef 	__COLORCOMBOWND_H__
#define 	__COLORCOMBOWND_H__

#define		CB_SETCOLOR			0x00F0			// Farben fr Buchstaben einstellen
#define		CB_SETCOLORMODE		0x00F1			// Optionen fr Farben einstellen (fr fr ExtTextColor())
#define		CB_SETCOLORITEM		0x00F2			// Farbe in der Farbtabelle einstellen
#define		CB_SETIMAGELIST		0x00F3			// Die Icon-Liste einstellen
#define		CB_SETIMAGE			0x00F4			// Das Icon einstellen
#define		CB_SETCALLBACK		0x00F5			// Callback fr Farben
#define		CB_GETTEXTPTR		0x00F6			// Einen Pointer direkt auf den Text holen
#define		CB_GETIMAGE			0x00F7			// Die Icon-Nummer holen
#define		CB_GETCOLORPTR		0x00F8			// Einen Pointer direkt auf die Farben holen
#define		CB_SYNCHWINDOW		0x00F9			// Die Daten mit dem unterliegenden Fenster synchronisieren
#define		CB_SETDROPPEDHEIGHT	0x00FA			// Einstellen der Dropdown-Hhe
#define		CB_SETEDITSTYLE		0x00FB			// Einstellen des Syles des Edit-Fensters
#define		CB_SETTABSTOP		0x00FC			// Einstellen des Tab-Stops in Pixel

#ifndef 	CB_SETMINVISIBLE
#define		CB_SETMINVISIBLE	0x1701			// Einstellen der minimal sichtbaren Eintrge in der Listbox	
#endif 	
#ifndef 	CB_GETMINVISIBLE
#define		CB_GETMINVISIBLE	0x1702			// Holen der minimal sichtbaren Eintrge in der Listbox
#endif 	

#define 	CBS_ONLYLISTPAINT	WS_GROUP		// Nur die Listbox farbig zeichnen
#define		CBS_WANTRETURN		0x0200			// Die Tasten RET/TAB/ESC nia Notify melden
#define		CBS_ALLOWDROP		0x4000			// Dateien knnen auf das Control fallengelassen werden
#define		CBS_NOGRAYDISABLE	0x8000			// Fenster nicht grau machen wenn es gesperrt ist


LRESULT      CALLBACK  ColorComboProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
typedef int (CALLBACK *ColorComboCb )(LPVOID pParam,LPCTSTR pText,int iSize,LPBYTE pColor,LPINT pIcon,LPARAM lUserId,INT iItem);



#endif 	