//*****************************************************************************
//*
//*
//*		ColorDialog.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#include	<afxwin.h>			// MFC-Kern- und -Standardkomponenten
#include	<afxext.h>			// MFC-Erweiterungen
#include	<afxdisp.h>			// MFC Automatisierungsklassen
#include	<afxdtctl.h>		// MFC-Untersttzung fr allgemeine Steuerelemente von Internet Explorer 4
#include	"ColorDialog.h"

#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	TEXT_OFF			(sizeof(DPARAM)/sizeof(TCHAR))

#ifndef		_WIN64
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr	SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr	GetWindowLong
#endif
#ifndef		SetClassLongPtr
#define		SetClassLongPtr		SetClassLong
#endif
#ifndef		GetClassLongPtr
#define		GetClassLongPtr		GetClassLong
#endif
#else
#ifdef		GWL_WNDPROC
#undef		GWL_WNDPROC
#endif
#define		GWL_WNDPROC			GWLP_WNDPROC
#ifdef		GWL_HINSTANCE
#undef		GWL_HINSTANCE
#endif
#define		GWL_HINSTANCE		GWLP_HINSTANCE
#ifdef		GWL_HWDPARENT
#undef		GWL_HWDPARENT
#endif
#define		GWL_HWDPARENT		GWLP_HWDPARENT
#ifdef		GWL_USERDATA
#undef		GWL_USERDATA
#endif
#define		GWL_USERDATA		GWLP_USERDATA
#endif
#ifndef 	IDR_MAINFRAME
#define 	IDR_MAINFRAME		128
#endif

#if			UNICODE
#define 	Z(a)				L##a
#define 	atoi_z				_wtoi
#define 	itoa_z				_itow
#define 	ultoa_z				_ultow
#define 	strupr_z			wcsupr
#define 	strtoul_z			wcstoul
#define 	stricmp_z			wcsicmp
#define 	strcmp_z			wcsicmp
#define 	strlen_z			wcslen
#define 	strspn_z			wcsspn
#define 	strcat_z			wcscat
#else
#define 	Z(a)				a
#define 	atoi_z				atoi
#define 	itoa_z				itoa
#define 	ultoa_z				ultoa
#define 	strupr_z			strupr
#define 	strtoul_z			strtoul
#define 	stricmp_z			stricmp
#define 	strcmp_z			strcmp
#define 	strlen_z			strlen
#define 	strspn_z			strspn
#define 	strcat_z			strcat
#endif

#define 	IDC_EDIT1			1008
#define 	IDC_TEXT			1034
#define		IDC_SELTEXT     	1131
#define		IDC_SELCOMBO		1132
#define		IDC_SELCOMBOEDIT	1133
#define		IDC_SELLIST0		1133
#define		IDC_SELLIST1		1134
#define		IDC_SELLIST2		1135
#define		IDC_SELLIST3		1136
#define 	IDC_RIGHTCLICK		1137
#define 	IDC_SEL_ALL			1138
#define 	IDC_SEL_NONE		1139


WORD CColorDlg::m_wDlgData[]=
	{
	0x0040,0x82CC,0x0000,0x0000,0x0000,0x0000,0x0000,0x019E,0x00C1,0x0000,0x0000,0x0049,0x006E,0x0066,0x006F,0x0072,
	0x006D,0x0061,0x0074,0x0069,0x006F,0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,
	0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,
	};

BEGIN_MESSAGE_MAP(CColorDlg, CDialog)
	//{{AFX_MSG_MAP(CColorDlg)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CRect	CColorDlg::m_sLastRect(0,0,0,0);
HICON	CColorDlg::m_hIcon	   = 0;
UINT	CColorDlg::m_aColors[] =
	{
	RGB(  0,  0,  0),				// 04
	RGB(  0,  0,128),				// 05
	RGB(  0,128,  0),				// 06
	RGB(  0,128,128),				// 07
	RGB(128,  0,  0),				// 08
	RGB(128,  0,128),				// 09
	RGB(128,128,  0),				// 10
	RGB(128,128,128),				// 11
	RGB(192,192,192),				// 12
	RGB(  0,  0,255),				// 13
	RGB(  0,255,  0),				// 14
	RGB(  0,255,255),				// 15
	RGB(255,  0,  0),				// 16
	RGB(255,  0,255),				// 17
	RGB(255,255,  0),				// 18
	RGB(255,128,128),				// 19
	};





//*****************************************************************************
//*
//*		Dialogfeld CColorDlg
//*
//*****************************************************************************
CColorDlg::CColorDlg(CWnd *pParent) : CDialog((UINT)0,pParent)
{
CRect	sRect;
int		iPos;


	//{{AFX_DATA_INIT(CColorDlg)
	//}}AFX_DATA_INIT

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);

	m_iSizeX	= 0;
	m_iSizeY	= 0;


	sRect.SetRectEmpty();
	m_cTextWnd.Create(WS_VSCROLL|WS_CHILD|LBS_NOTIFY|LBS_NOINTEGRALHEIGHT,sRect,CWnd::GetDesktopWindow());

	for(iPos=0;iPos<sizeof(m_aColors)/sizeof(m_aColors[0]);iPos++)
		{
		m_cTextWnd.SetColor(iPos+4,m_aColors[iPos]);
		}

	m_cTextWnd.SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_FIXED_FONT)));
	m_cTextWnd.SetMarkType(2);
	m_cTextWnd.SetMarkMode(0);
	m_cTextWnd.SetCursorMode(1);

}

//*****************************************************************************
//*
//*		Dialogfeld CColorDlg
//*
//*****************************************************************************
CColorDlg::~CColorDlg()
{

	m_cTextWnd.DestroyWindow();

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CColorDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorDlg)
	//}}AFX_DATA_MAP
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
// Behandlungsroutinen fr Nachrichten CColorDlg
BOOL CColorDlg::OnInitDialog()
{
CRect	sRect;



	if(m_hIcon==NULL)
		{
		m_hIcon=LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_MAINFRAME));
		}

	if(m_hIcon!=NULL)
		{
		SetIcon(m_hIcon,0);
		SetIcon(m_hIcon,1);
		}

	if(m_sLastRect.Width())								// Zur letzten Position
		{
		MoveWindow(m_sLastRect,FALSE);
		}

	CDialog::OnInitDialog();

	if(!m_sTitle.IsEmpty())SetWindowText(m_sTitle);

	if(m_iSizeX || m_iSizeY)							// Dialoggre ndern
		{
		GetWindowRect(&sRect);

		if(m_iSizeX)sRect.right  = sRect.left+m_iSizeX;
		if(m_iSizeY)sRect.bottom = sRect.top +m_iSizeY;

		MoveWindow(&sRect,FALSE);
		}

	GetClientRect(&sRect);

	m_cTextWnd.SetParent(this);
	m_cTextWnd.ShowWindow(SW_SHOW);
	m_cTextWnd.MoveWindow(sRect,FALSE);



return TRUE;
}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CColorDlg::OnSize(UINT nType,int iSizeX,int iSizeY)
{

	if(IsWindow(m_cTextWnd.m_hWnd))
	if(iSizeX && iSizeY)
		{
		CRect	sRect(0,0,iSizeX,iSizeY);
		m_cTextWnd.MoveWindow(&sRect,FALSE);
		m_cTextWnd.RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ERASE|RDW_ALLCHILDREN|RDW_UPDATENOW|RDW_FRAME);
		}

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CColorDlg::OnOK()
{

	GetWindowRect(&m_sLastRect);
	m_cTextWnd.ShowWindow(SW_HIDE);
	m_cTextWnd.SetParent(CWnd::GetDesktopWindow());

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CColorDlg::OnCancel()
{

	GetWindowRect(&m_sLastRect);
	m_cTextWnd.ShowWindow(SW_HIDE);
	m_cTextWnd.SetParent(CWnd::GetDesktopWindow());

	CDialog::OnCancel();
}

