//*****************************************************************************
//*
//*
//*		ColorDialog.h : Header-Datei
//*
//*
//*****************************************************************************
#ifndef COLORDIALOG_H__56788923_43AF_11D3_9273_C0544BC10000__INCLUDED_
#define COLORDIALOG_H__56788923_43AF_11D3_9273_C0544BC10000__INCLUDED_

#ifdef	   _MSC_VER
#pragma 	once
#pragma 	warning( disable :4996 )
#endif

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif


#ifdef		DWORD_PTR
#define 	DPARAM			DWORD_PTR
#else
#define 	DPARAM			DWORD
#endif

#include	"StringChain.h"
#include	"ColorListBox.h"



//*****************************************************************************
//*
//*		Dialogfeld CColorDlg
//*
//*****************************************************************************
class CColorDlg : public CDialog
{
public:

	CColorDlg(CWnd *pParent=NULL);						// Standardkonstruktor
   ~CColorDlg();

	//{{AFX_DATA(CColorDlg)
	//}}AFX_DATA

	void 	SelectFont(int iFont);
	void	SetSizeX(int iSize);						// Gre einstellen
	void	SetSizeY(int iSize);						// Gre einstellen
	void	SetSize (int iSizeX,int iSizeY);			// Gre einstellen

	int		AddString     (           LPCTSTR pText,            const VOID *pColor     ,int iLen=-1,int iState=0);
	int		AddString     (           LPCTSTR pText,                  BYTE  bColor=0x00,int iLen=-1,int iState=0);
	int		InsertString  (int nIndex,LPCTSTR pText,            const VOID *pColor     ,int iLen=-1,int iState=0);
	int		InsertString  (int nIndex,LPCTSTR pText,                  BYTE  bColor=0x00,int iLen=-1,int iState=0);
	BOOL	SetText       (int nIndex,LPCTSTR pText,int iLen   ,const VOID *pColor);
	BOOL 	SetText       (int nIndex,LPCTSTR pText,            const VOID *pColor);
	BOOL 	SetText       (int nIndex,LPCTSTR pText,int iLen=-1,      BYTE  bColor=0xFF);
	int		SetTextColor  (int nIndex,                          const VOID *pColor,int iLen);
	int 	SetTextColor  (int nIndex,                          const VOID *pColor);
	int 	SetTextColor  (int nIndex,                                BYTE  bColor);
	int		DeleteString  (int nIndex);
	int		GetTextLen    (int nIndex) const;
	int		GetText       (int nIndex,LPTSTR pBuffer);
	int		GetText       (int nIndex,LPTSTR pBuffer,int iSize);
	void	GetText       (int nIndex,CString &sString);
	LPCTSTR GetText       (int nIndex,int &iSize);
	LPCTSTR GetText       (int nIndex);
	LPARAM	SetItemData   (int nIndex,LPARAM iValue);
	LPARAM  SetItemDataPtr(int nIndex,LPVOID pPtr);
	LPARAM  GetItemData   (int nIndex) const;
	LPVOID  GetItemDataPtr(int nIndex) const;
	int		SetTabStops   (int iTabs,INT *pTabStops);
	void	SetTabSize    (int iTab);
	int		GetTabSize    ();
	int		GetLineCount  ();
	void	ResetContent  ();
	BOOL	SetFont       (CFont *pFont);
	BOOL	SetFont       (HFONT  hFont);
	BOOL	SetFont		  (int    iFont);



	//{{AFX_VIRTUAL(CColorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CColorDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK( );
	virtual void OnCancel( );
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	//}}AFX_MSG

	int				m_iSizeX;
	int				m_iSizeY;								// Grennderung
	CString			m_sTitle;
	CColorListBox	m_cTextWnd;
	static CRect	m_sLastRect;
	static WORD		m_wDlgData[];
	static UINT		m_aColors[];
	static HICON	m_hIcon;

	DECLARE_MESSAGE_MAP()

};

inline	void	CColorDlg::SetSizeX    (int iSize){m_iSizeX=iSize;}
inline	void	CColorDlg::SetSizeY    (int iSize){m_iSizeY=iSize;}
inline	void	CColorDlg::SetSize     (int iSizeX,int iSizeY){m_iSizeX=iSizeX;m_iSizeY=iSizeY;}

inline	int		CColorDlg::AddString   (           LPCTSTR pText,         const VOID *pColor,int iLen,int iState){ return m_cTextWnd.AddString   (       pText,pColor,iLen,iState);}
inline	int		CColorDlg::AddString   (           LPCTSTR pText,               BYTE  bColor,int iLen,int iState){ return m_cTextWnd.AddString   (       pText,bColor,iLen,iState);}
inline	int		CColorDlg::InsertString(int nIndex,LPCTSTR pText,         const VOID *pColor,int iLen,int iState){ return m_cTextWnd.InsertString(nIndex,pText,pColor,iLen,iState);}
inline	int		CColorDlg::InsertString(int nIndex,LPCTSTR pText,               BYTE  bColor,int iLen,int iState){ return m_cTextWnd.InsertString(nIndex,pText,bColor,iLen,iState);}
inline	BOOL	CColorDlg::SetText     (int nIndex,LPCTSTR pText,int iLen,const VOID *pColor)					 { return m_cTextWnd.SetText     (nIndex,pText,iLen,pColor);}
inline	BOOL 	CColorDlg::SetText     (int nIndex,LPCTSTR pText,         const VOID *pColor)					 { return m_cTextWnd.SetText     (nIndex,pText,     pColor);}
inline	BOOL 	CColorDlg::SetText     (int nIndex,LPCTSTR pText,int iLen,      BYTE  bColor)					 { return m_cTextWnd.SetText     (nIndex,pText,iLen,bColor);}
inline	int		CColorDlg::SetTextColor(int nIndex,                       const VOID *pColor,int iLen)			 { return m_cTextWnd.SetTextColor(nIndex,pColor,iLen);}
inline	int 	CColorDlg::SetTextColor(int nIndex,                       const VOID *pColor)					 { return m_cTextWnd.SetTextColor(nIndex,pColor     );}
inline	int 	CColorDlg::SetTextColor(int nIndex,                             BYTE  bColor)					 { return m_cTextWnd.SetTextColor(nIndex,bColor     );}
inline	int		CColorDlg::DeleteString(int nIndex)																 { return m_cTextWnd.DeleteString(nIndex);}
inline	int		CColorDlg::GetTextLen  (int nIndex) const														 { return m_cTextWnd.GetTextLen  (nIndex);}
inline	int		CColorDlg::GetText     (int nIndex,LPTSTR pBuffer)												 { return m_cTextWnd.GetText     (nIndex,pBuffer      );}
inline	int		CColorDlg::GetText     (int nIndex,LPTSTR pBuffer,int iSize)									 { return m_cTextWnd.GetText     (nIndex,pBuffer,iSize);}
inline	void	CColorDlg::GetText     (int nIndex,CString &sString)											 {        m_cTextWnd.GetText     (nIndex,sString      );}
inline	LPCTSTR CColorDlg::GetText     (int nIndex,int &iSize)													 { return m_cTextWnd.GetText     (nIndex,iSize        );}
inline	LPCTSTR CColorDlg::GetText     (int nIndex)																 { return m_cTextWnd.GetText     (nIndex              );}
inline	LPARAM	CColorDlg::SetItemData   (int nIndex,LPARAM iValue)												 { return m_cTextWnd.SetItemData (nIndex,iValue       );}
inline	LPARAM  CColorDlg::SetItemDataPtr(int nIndex,LPVOID pPtr)												 { return m_cTextWnd.SetItemDataPtr(nIndex,pPtr);}
inline	LPARAM  CColorDlg::GetItemData   (int nIndex) const														 { return m_cTextWnd.GetItemData   (nIndex     );}
inline	LPVOID  CColorDlg::GetItemDataPtr(int nIndex) const														 { return m_cTextWnd.GetItemDataPtr(nIndex     );}
inline	int		CColorDlg::SetTabStops (int iTabs,INT *pTabStops)												 { return m_cTextWnd.SetTabStops (iTabs,pTabStops);}
inline	void	CColorDlg::SetTabSize  (int iTab)																 {        m_cTextWnd.SetTabSize  (iTab);}
inline	int		CColorDlg::GetTabSize  ()																		 { return m_cTextWnd.GetTabSize  ();}
inline	int		CColorDlg::GetLineCount()																		 { return m_cTextWnd.GetLineCount();}
inline	void	CColorDlg::ResetContent() 																		 {        m_cTextWnd.ResetContent();}
inline	BOOL	CColorDlg::SetFont     (CFont *pFont)															 { return m_cTextWnd.SetFont(pFont);}
inline	BOOL	CColorDlg::SetFont     (HFONT  hFont)															 { return m_cTextWnd.SetFont(hFont);}
inline	BOOL	CColorDlg::SetFont	   (int    iFont)															 { return m_cTextWnd.SetFont(iFont);}


//{{AFX_INSERT_LOCATION}}

#endif



