//*****************************************************************************
//*
//*
//*		ColorEditWnd.h
//*
//*
//*****************************************************************************
//
//	Ist einen Win-API-Edit-Fenster das Farben und dicke Schrift zu lst.
//
//	Fenster Styles:
//	
//		ES_LEFT             0x0000	Text links ausrichten	
//		ES_CENTER           0x0001	Text mittig ausrichten	
//		ES_RIGHT            0x0002	Text rects ausrichten	
//		ES_MULTILINE        0x0004	--- nicht untersttzt ---
//		ES_UPPERCASE        0x0008	--- nicht untersttzt ---
//		ES_LOWERCASE        0x0010	--- nicht untersttzt ---
//		ES_PASSWORD         0x0020	--- nicht untersttzt ---
//		ES_AUTOVSCROLL      0x0040	--- nicht untersttzt ---
//		ES_AUTOHSCROLL      0x0080	--- nicht untersttzt ---
//		ES_NOHIDESEL        0x0100	Textauswahl auch ohne Fokus anzeigen
//		ES_OEMCONVERT       0x0400	--- nicht untersttzt ---
//		ES_READONLY         0x0800	Es ist keine Texteingabe mglich
//		ES_WANTRETURN       0x1000	Die Tasten RET/TAB/ESC nia Notify melden
//		ES_NUMBER           0x2000	Nur die Eingabe von Ziffern ist mglich
//		ES_ALLOWDROP		0x4000	Dateien knnen auf das Control fallengelassen werden
//		ES_NOGRAYDISABLE	0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	
//	Beispiel: 
//
//		ColorEditProc(hWnd,WM_ATTACH,0,0);					// Eingngen
//		SendMessage  (hWnd,EM_SETIMAGELIST,0,(LPARAM)GetIconList());
//		SendMessage  (hWnd,EM_SETIMAGE    ,GetIconNr("Test.cpp",SHGFI_USEFILEATTRIBUTES));
//		SendMessage  (hWnd,EM_SETCOLOR    ,16,(LPARAM)"\x42\x42\x42\x42\0\3\3\3\3\3\0\x20\x20\x20\x20\x20");
//				     
//		ColorEditProc(hWnd,WM_DETACH,0,0);					// Aushngen
//
#ifndef 	__COLOREDITWND_H__
#define 	__COLOREDITWND_H__

#ifndef 	EM_SETCOLOR
#define		EM_SETCOLOR			0x00E0			// Farben fr Buchstaben einstellen
#endif 	
#ifndef 	EM_SETCOLORMODE
#define		EM_SETCOLORMODE		0x00E1			// Optionen fr Farben einstellen (fr fr ExtTextColor())
#endif 	
#ifndef 	EM_SETCOLORITEM
#define		EM_SETCOLORITEM		0x00E2			// Farbe in der Farbtabelle einstellen
#endif 	
#ifndef 	EM_SETIMAGELIST
#define		EM_SETIMAGELIST		0x00E3			// Die Icon-Liste einstellen
#endif 	
#ifndef 	EM_SETIMAGE
#define		EM_SETIMAGE			0x00E4			// Das Icon einstellen
#endif 	
#ifndef 	EM_SETCALLBACK
#define		EM_SETCALLBACK		0x00E5			// Callback fr Farben
#endif 	
#ifndef 	EM_GETTEXTPTR
#define		EM_GETTEXTPTR		0x00E6			// Einen Pointer direkt auf den Text holen
#endif 	
#ifndef 	EM_GETIMAGE
#define		EM_GETIMAGE			0x00E7			// Die Icon-Nummer holen
#endif 	
#ifndef 	EM_GETCOLORPTR
#define		EM_GETCOLORPTR		0x00E8			// Einen Pointer direkt auf die Farben holen
#endif 	
#ifndef 	EM_SYNCHWINDOW
#define		EM_SYNCHWINDOW		0x00E9			// Die Daten mit dem unterliegenden Fenster synchronisieren
#endif 	
#ifndef 	EM_DROPFILES
#define 	EM_DROPFILES		0x00EA			// Den Namen eine Datei einfgen via Drop
#endif 	

#define 	ES_ALLOWDROP		0x4000			// Dateien knnen auf das Control fallengelassen werden
#define 	ES_NOGRAYDISABLE	0x8000			// Fenster nicht grau machen wenn es gesperrt ist

#ifndef 	EN_SELCHANGE
#define		EN_SELCHANGE		0x0702			// Notify-Nachricht wenn sich die Auswahl verndert hat
#endif 	
#ifndef 	EN_DROPFILES
#define		EN_DROPFILES		0x0703			// Notify-Nachricht wenn Dateien aufs Fenster gedropped wurden
#endif 	
#ifndef 	EM_REDO
#define		EM_REDO				(WM_USER+84)	// Die letzte Aktion wieder herstellen
#endif 	


LRESULT      CALLBACK  ColorEditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
typedef int (CALLBACK *ColorEditCb )(LPVOID pParam,LPCTSTR pText,int iSize,LPBYTE pColor,LPINT pIcon,LPARAM lUserId,INT iItem);



#endif 	