//*****************************************************************************
//*
//*
//*		ColorListBoxWnd.h
//*
//*
//*****************************************************************************
#ifndef 	__COLORLISTBOXWND_H__
#define 	__COLORLISTBOXWND_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	<commctrl.h>


typedef struct
	{
    POINT	sPoint;
    UINT	uFlags;
    int		iItem;
	}CLB_HITTESTINFO;

typedef struct
	{
    UINT	uMask;											// Bestimmt welche Werte gltig sind (siehe CLBF_???)
	int		iItem;											// Ist die Zeilennummer
    UINT	uState;											// Werte fr die Statusbits (siehe CLBS_???)
    UINT	uStateMask;										// Maske fr die Statusbits
	LPBYTE	pColor;											// Zeiger auf die Farben (Bit0..4=Farbe Bit5=Untersteichen Bit6=Fett Bit7=Fixed)
    LPTSTR	pText;											// Zeiger auf den Textpuffer
    int		iTextMax;										// Gre des Textpuffers
    LPARAM	lParam;											// Parameter fr den Eintarg
	}CLB_ITEM;

typedef struct
	{
	UINT	uFlags;											// Bestimmt die Art der Suche (siehe CLB_FIND_???)
	UINT	uState;											// Gesuchte Werte der Statusbits (siehe CLBS_???)
	UINT	uStateMask;										// Welche Statusbits sollen verglichen werden
	LPARAM	lParam;											// Ist der gesuchte Parameter
	LPCTSTR	pText;											// Ist der gesuchte Text
	}CLB_FIND;

typedef struct
	{
	LPBYTE	pColor;											// Zeiger auf die Farben
    LPTSTR	pText;											// Zeiger auf den Text
	INT		iSize;											// Lnge des Textes
	INT		iIdent;											// Einrckung in Pixel
	}CLB_ENTRY;

typedef struct
	{
	NMHDR	sNmHdr;											// Notify Daten
	int		iItem;											// Nummer des Eintrages
	int		iState;											// Ist der datsu des Eintrages
	LPARAM	lParam;											// Datenwert des Eintrages
	}CLB_STATUS;

typedef struct
	{
	NMHDR	sNmHdr;											// Notify Daten
	int		iMode;											// 1=Item 2=Text
	int		iItem;											// Nummer des Eintrages
	int		iRow;											// Spalte des Eintrags
	}CLB_DRAG;

typedef void (CALLBACK *PFCLBLINECB )(HWND hWnd,LPARAM lItem,CLB_ENTRY *pEntry,LPVOID pParam);
typedef int  (CALLBACK *PFCLBCOMPARE)(LPARAM lParam1,LPARAM lParam2,LPARAM lSortParam);


#define 	CLB_ADD_COLOR			6
#define 	CLB_MAX_COLOR			26
#define 	CLB_MAX_TABS			32
#define 	CLB_COLOR_EVENWND		(CLB_MAX_COLOR*2+CLB_ADD_COLOR+0)
#define		CLB_COLOR_ODDWND		(CLB_MAX_COLOR*2+CLB_ADD_COLOR+1)
#define 	CLB_COLOR_EVENSEL		(CLB_MAX_COLOR*2+CLB_ADD_COLOR+2)
#define		CLB_COLOR_ODDSEL		(CLB_MAX_COLOR*2+CLB_ADD_COLOR+3)
#define 	CLB_COLOR_EVENFOCUS		(CLB_MAX_COLOR*2+CLB_ADD_COLOR+4)
#define		CLB_COLOR_ODDFOCUS		(CLB_MAX_COLOR*2+CLB_ADD_COLOR+5)
#define		CLB_COLOR_FRAME_EVEN	(CLB_MAX_COLOR+0)
#define		CLB_COLOR_FRAME_ODD		(CLB_MAX_COLOR+1)
#define 	CLB_FIXED_FONT			((HFONT)0)
#define 	CLB_VAR_FONT			((HFONT)1)
#define 	CLB_COLOR_MASK			0x1F
#define 	CLB_UNTERLINE			0x20

#ifdef		UNICODE
#define		CLB_UINICODE			1
#else						
#define		CLB_UINICODE			0
#endif

#define 	CLBIL_STATE				0x00000000			// Imageliste fr Checkboxen
#define 	CLBIL_ICONS				0x00000001			// Imageliste fr Icons
#define 	CLBIL_NOTDEL			0x40000000			// Die Image Liste  nicht lschen
#define 	CLB_DEFCOLOR			0x55000000			// Standartfarbe
#define 	CLB_NOUPDATE			0x80000000			// Kein neuzeichnen bei CLB_SETITEMIDENT
#define 	CLBF_TEXTPTR			0x80000000			// Nur einen Zeiger auf den Text zurckgeben
#define 	CLBF_COLORPTR			0x40000000			// Nur einen Zeiger auf den Text zurckgeben
#define 	CLBF_FAST				0x20000000			// Schnell Einfgemodus
#define 	CLBF_ENDSCROLL			0x10000000			// Beim Einfgen am sichtbaren Ende weiter scrollen
#define 	CLBF_SHOWSCROLL			0x08000000			// Beim Einfgen muss der Eintrag sichtbar bleiben
#define 	CLBS_SELECTED			0x00000001			// Status fr Auswahlbit
#define 	CLBS_OVERLAY			0x0000000F			// Overlaybits fr Icons
#define 	CLBS_NOBOX				0x00000010			// Status fr keine Box zeichnen
#define 	CLBS_ICON_MASK			0x0000FFE0			// Bits fr Icon-Nummer
#define 	CLBS_ICON_SET(a)		((a)<<5)			// Icon-Nummer in Status
#define 	CLBS_ICON_GET(a)		((a)>>5)			// Icon-Nummer aus Status


// Konstanten fr SetItem und GetItem (CLB_ITEM::uMask)
#define 	CLBF_PARAM				0x00000001			// Der Wert lParam in CLB_ITEM ist gltig
#define 	CLBF_STATE				0x00000002			// Der Wert uState in CLB_ITEM ist gltig
#define 	CLBF_TEXT				0x00000004			// Der Wert pText  in CLB_ITEM ist gltig
#define 	CLBF_COLOR				0x00000008			// Der Wert pColor in CLB_ITEM ist gltig
#define 	CLBF_IDENT				0x00000010			// Der Wert HI(uState) in CLB_ITEM ist der Ident


// Konstanten fr HitTest (flags)
#define		CLBT_NOWHERE            0x00000001			// Keine Treffer
#define		CLBT_ONITEMCHECK        0x00000002			// Auf Checkbox
#define		CLBT_ONITEMLABEL        0x00000004			// Auf Text
#define 	CLBT_ABOVE              0x00000008			// ber den Zeilen
#define 	CLBT_BELOW              0x00000010			// Unter den Zeilen
#define 	CLBT_TORIGHT            0x00000020			// Rechts vom Text
#define 	CLBT_TOLEFT             0x00000040			// Links vom Text
#define		CLBT_SELECTED	        0x00000080			// Auf ausgewhlten Text
#define		CLBT_ONITEMICON	        0x00000100			// Auf Icon
#define 	CLBT_ONITEMRIGHT		0x00080000			// Koordinate ist rechts vom Text eines Eintrages


// Konstanten fr FindItem
#define 	CLB_FIND_PARAM			0x00000001			// Beim Suchen auch lParam vergleichen
#define 	CLB_FIND_STATE			0x00000002			// Beim Suchen auch den Zustand vergleichen
#define 	CLB_FIND_TEXT			0x00000004			// Beim Suchen auch den Text vergleichen
#define 	CLB_FIND_CASE			0x00000008			// Beim Suchen zwischen Gro/Kleinbuchstaben nicht unterscheiden


// Konstanten fr uStyle
#define		CLBS_FIXEDSCROLL		0x00008000			// Kein Scrollen erlaubt
#define		CLBS_NOSCROLL			0x00003000			// Keine Scrollleisten anzeigen
#define		CLBS_NOSCROLLY			0x00002000			// Keine Y-Scrollleiste anzeigen
#define		CLBS_NOSCROLLX			0x00001000			// Keine X-Scrollleiste anzeigen
#define		CLBS_NOKEYBOARD			0x00000400			// Keine Tastatureingaben erlauben
#define 	CLBS_MULTIPLESEL 		0x00000008			// Mehrfachauswahl erlauben

// Konstanten fr uStyleEx
#define 	CLB_EX_MARKOFF			0x00000000			// Keine       Markierungen
#define 	CLB_EX_MARKSINGLE		0x00000001			// Einzeilige  Markierungen
#define 	CLB_EX_MARKMULTI		0x00000002			// Mehrzeilige Markierungen
#define 	CLB_EX_MARKFULL			0x00000003			// Ganzzeilige Markierungen
#define 	CLB_EX_MARKMASK			0x00000003			// Maske fr Markierungsart
#define 	CLB_EX_STEPMISC			0x00000010			// Bei Wortsprngen auch diversen Zeichen anhalten
#define 	CLB_EX_STEPFIRST		0x00000020			// Bei Wortsprngen nur am Beginn eines Wortes/Bereichs anhalten
#define 	CLB_EX_STEPUPPER		0x00000040			// Bei Wortsprngen auch Gro/Kleinbergngen anhalten
#define 	CLB_EX_STEPUNTER		0x00000080			// Bei Wortsprngen das '-' nicht als Buchstaben betrachten
#define 	CLB_EX_STEPALL			0x000000F0			// Bei Wortsprungoptionen
#define 	CLB_EX_MULITFONT		0x00001000			// Mehrere Fonts zulassen
#define 	CLB_EX_AUTOSCROLL		0x00002000			// Beim Einfgen am sichtbaren Ende weiter scrollen
#define 	CLB_EX_CLEARALL			0x00004000			// In Context-Men "Alles lschen" einfgen
#define 	CLB_EX_COLORCONTINUE	0x00008000			// Die letzte Farbe am Zeilenende weiter fhren
#define 	CLB_EX_ALTERNATECOLOR	0x00010000			// Die Farbe abwechselnd darstellen
#define 	CLB_EX_CURSOR			0x00020000			// Cursor ein bzw. ausblenden
#define 	CLB_EX_TABEXIT			0x00040000			// Bei TAB den Fokus ans Elternfenster geben
#define 	CLB_EX_GRIDLINES		0x00080000			// Soll ein Rahmen um die Eintrge gezeichnet werden
#define 	CLB_EX_SELDBLCLICK		0x00100000			// Auswahl mit Doppelclick
#define 	CLB_EX_SELSPACE			0x00200000			// Auswahl mit SPACE-Taste
#define 	CLB_EX_SELRETURN		0x00400000			// Auswahl mit der RETURN Taste
#define 	CLB_EX_SELWORDDBL		0x00800000			// Auswahl eines Wortes mit Doppelclick
#define 	CLB_EX_NOCHARSELCET		0x01000000			// Keine Auswahl ber eine Texteingabe
#define 	CLB_EX_NOCONTEXTMENU	0x02000000			// Kein Context-Men mit der rechten Maustaste
#define 	CLB_EX_NOCHANGENOTIFY	0x04000000			// Keine Notify-Nachrichten beim ndern von Flags
#define 	CLB_EX_SELMARK			0x08000000			// Ausgewhlte Zeile markieren
#define 	CLB_EX_CHECKBOXES		0x10000000			// Checkboxen einblenden
#define 	CLB_EX_NOTHEMES			0x20000000			// Keine XP Themen benutzen
#define 	CLB_EX_SHAREIMAGELISTS	0x40000000			// Die Imageliste fr die Checkboxen nicht lschen
#define 	CLB_EX_DRAGITEMS		0x80000000			// Einzelnen Eintrge knnen per Drag geholt werden


// Konstanten fr Optionen (CLB_GETSETOPTION)
#define 	CLBO_LINECALLBACK		0x00000001			// Callbackfunktion fr Daten
#define 	CLBO_FONTHEIGHT			0x00000002			// Hhe des Fonts in Pixel
#define 	CLBO_FONTWIDTH			0x00000003			// Breite des Fonts in Pixel
#define 	CLBO_TABSTEPS			0x00000004			// Eingestellte Tabulatorbreite
#define 	CLBO_WINDOWPROC			0x00000005			// Fensterfunktion abfragen
#define 	CLBO_STATEFRAME			0x00000006			// Extra Hhe fr State-Bilder
#define 	CLBO_ICONEFRAME			0x00000007			// Extra Hhe fr Icons
#define 	CLBO_LINECBPARAM		0x00000008			// Parameter fr Callbackfunktion
#define 	CLBO_ICONCOLOR			0x00000009			// Hintergund fr Icons
#define 	CLBO_STATECOLOR			0x0000000A			// Hintergund fr Overlay-Icons
#define 	CLBO_BASEIDENT			0x0000000B			// Standart-Text-Einrckung 
#define 	CLBO_WRITEOPTION		0x80000000			// Die Option auch schreiben


// Konstanten fr Optionen (CLB_GETNEXTITEM)
#define 	CLPI_FIRSTVISIBLE 		0x00000000			// Ersten sichtbaren Eintrag
#define 	CLPI_NEXTVISIBLE 		0x00000001			// Nchsten sichtbaren Eintrag
#define 	CLPI_PREVIOUSVISIBLE 	0x00000002			// Vorheriger sichtbarer Eintrag
#define 	CLPI_LASTVISIBLE 		0x00000003			// Letzter sichtbarer Eintrag
#define 	CLPI_CARET 				0x00000004			// Eintrag der gewhlt ist


// Konstanten fr Notify-Nachrichten
#define     CLB_SELCHANED			0x00001302			// Notify Nachricht fr genderte Checkbox
#define     CLB_BEGINDRAG			0x00001303			// Notify Nachricht fr Datg-Text



// Konstanten fr neue Nachrichten
#define 	CLB_FIRST				(0x3800)			// Begin der Nachrichten
#define 	CLB_ISITEMVISIBLE		(CLB_FIRST+ 0)
#define 	CLB_GETMARK				(CLB_FIRST+ 1)
#define 	CLB_GETMARK_EX			(CLB_FIRST+ 2)
#define 	CLB_GETVISIBLECOUNT		(CLB_FIRST+ 3)
#define 	CLB_MARKALL				(CLB_FIRST+ 4)
#define 	CLB_GETSETOPTION		(CLB_FIRST+ 5)
#define 	CLB_INSERTITEM			(CLB_FIRST+ 6+CLB_UINICODE)
#define 	CLB_GETCOLOR			(CLB_FIRST+ 8)
#define 	CLB_SETCOLOR			(CLB_FIRST+ 9)
#define 	CLB_ENSUREVISIBLE		(CLB_FIRST+10)
#define 	CLB_SETIMAGELIST		(CLB_FIRST+11)
#define 	CLB_GETIMAGELIST		(CLB_FIRST+12)
#define 	CLB_GETITEMSTATE		(CLB_FIRST+13)
#define 	CLB_SETITEMSTATE		(CLB_FIRST+14)
#define 	CLB_GETSELECTEDCOUNT	(CLB_FIRST+15)
#define 	CLB_GETSTRINGWIDTH		(CLB_FIRST+16)
#define 	CLB_GETNEXTITEM			(CLB_FIRST+17)
#define 	CLB_GETITEM				(CLB_FIRST+18+CLB_UINICODE)
#define 	CLB_SETITEM				(CLB_FIRST+20+CLB_UINICODE)
#define 	CLB_DELETEITEM			(CLB_FIRST+22)
#define 	CLB_DELETEALLITEMS		(CLB_FIRST+23)
#define 	CLB_FINDITEM			(CLB_FIRST+24+CLB_UINICODE)
#define 	CLB_GETEXTENDEDSTYLE	(CLB_FIRST+26)
#define 	CLB_SETEXTENDEDSTYLE	(CLB_FIRST+27)
#define 	CLB_HITTEST				(CLB_FIRST+28)
#define 	CLB_SORTITEMS			(CLB_FIRST+29)
#define 	CLB_GETCOUNTPERPAGE		(CLB_FIRST+30)
#define 	CLB_REDRAWITEMS			(CLB_FIRST+31)
#define 	CLB_SCROLL				(CLB_FIRST+32)
#define 	CLB_GETISEARCHSTRING	(CLB_FIRST+33+CLB_UINICODE)
#define 	CLB_GETUNICODEFORMAT	(CLB_FIRST+35)
#define 	CLB_ITEMFROMPOINT		(CLB_FIRST+36)
#define 	CLB_SELECTSTRINGEXACT	(CLB_FIRST+37+CLB_UINICODE)
#define 	CLB_SELECTALL			(CLB_FIRST+39)
#define 	CLB_SETSELMARK			(CLB_FIRST+41)
#define 	CLB_SETCURSOR			(CLB_FIRST+42)
#define 	CLB_GETCURSOR			(CLB_FIRST+43)
#define 	CLB_GETITEMIDENT		(CLB_FIRST+44)
#define 	CLB_SETITEMIDENT		(CLB_FIRST+45)
#define 	CLB_CALCSIZE			(CLB_FIRST+46)
											   
											   
#define		ColorListBox_GetStyle(h)						((DWORD     )::GetWindowLong(h,GWL_STYLE))
#define		ColorListBox_SetStyle(h,d)	  					((DWORD     )::SetWindowLong(h,GWL_STYLE,d))
#define 	ColorListBox_SetStyleEx(h,d,m)					((DWORD     )::SetWindowLong(h,GWL_STYLE,((d)&(m))|(::GetWindowLong(h,GWL_STYLE)&~(m))))
#define 	ColorListBox_SetFont(h,f,r)						((INT       )::SendMessage(h,WM_SETFONT,(WPARAM)(f),MAKELONG(r,0)))
#define 	ColorListBox_Copy(h)							((INT       )::SendMessage(h,WM_COPY,0,0))

#define		ColorListBox_GetCount(h)						((BOOL      )::SendMessage(h,LB_GETCOUNT,0,0))
#define		ColorListBox_GetItemRect(h,i,p,f)			    ((INT       )::SendMessage(h,LB_GETITEMRECT,(WPARAM)((i)|((f)<<24)),(LPARAM)(RECT*)(p)))
#define 	ColorListBox_DeleteAllItems(h)					((BOOL      )::SendMessage(h,LB_RESETCONTENT,0,0))
#define		ColorListBox_DeleteItems(h,i,n)					((BOOL      )::SendMessage(h,LB_DELETESTRING,i,0xBD000000|(n)))
#define		ColorListBox_DeleteItem(h,i)					((BOOL      )::SendMessage(h,LB_DELETESTRING,i,0xBD000000))
#define 	ColorListBox_InsertString(h,l,p)				((INT       )::SendMessage(h,LB_INSERTSTRING,l         ,(LPARAM)p))
#define 	ColorListBox_AddString(h,p)						((INT       )::SendMessage(h,LB_INSERTSTRING,0x7FFFFFFF,(LPARAM)p))
#define 	ColorListBox_SetTabStops(h,n,p)					((BOOL      )::SendMessage(h,LB_SETTABSTOPS,n,(LPARAM)(p)))
#define 	ColorListBox_GetTopIndex(h)						((INT       )::SendMessage(h,LB_GETTOPINDEX,0,0))
#define 	ColorListBox_SetTopIndex(h,n)					((INT       )::SendMessage(h,LB_SETTOPINDEX,n,0))
#define 	ColorListBox_SetSel(h,n,s,f)					((BOOL      )::SendMessage(h,LB_SETSEL,MAKELONG(s,f),n))
#define 	ColorListBox_GetTextLen(h,n)					((INT		)::SendMessage(h,LB_GETTEXTLEN,n,0))
#define 	ColorListBox_GetItemData(h,n)					((INT		)::SendMessage(h,LB_GETITEMDATA,n,0))
#define 	ColorListBox_SetItemData(h,n,d)					((INT		)::SendMessage(h,LB_SETITEMDATA,n,d))
#define 	ColorListBox_GetItemIdent(h,n)					((INT		)::SendMessage(h,CLB_GETITEMIDENT,n,0))
#define 	ColorListBox_SetItemIdent(h,n,i)				((BOOL		)::SendMessage(h,CLB_SETITEMIDENT,n,i))
#define 	ColorListBox_CaclSize(h,p,i)					((BOOL		)::SendMessage(h,CLB_CALCSIZE,p,(LPARAM)(i)))

#define 	ColorListBox_HitTest(h,p)						((INT       )::SendMessage(h,CLB_HITTEST,0,(LPARAM)(CLB_HITTESTINFO*)(p)))
#define 	ColorListBox_GetCountPerPage(h)					((INT       )::SendMessage(h,CLB_GETCOUNTPERPAGE ,0,0))
#define		ColorListBox_GetExtendedStyle(h)				((DWORD     )::SendMessage(h,CLB_GETEXTENDEDSTYLE,0,0))
#define		ColorListBox_SetExtendedStyle(h,d)	  			((DWORD     )::SendMessage(h,CLB_SETEXTENDEDSTYLE,0,d))
#define 	ColorListBox_SetExtendedStyleEx(h,d,m)			((DWORD     )::SendMessage(h,CLB_SETEXTENDEDSTYLE,m,d))
#define 	ColorListBox_IsItemVisible(h,i,s)				((INT       )::SendMessage(h,CLB_ISITEMVISIBLE,s,(LPARAM)(INT)(i)))
#define		ColorListBox_GetItem(h,p)						((BOOL      )::SendMessage(h,CLB_GETITEM,0,(LPARAM)(CLB_ITEM*)(p)))
#define		ColorListBox_GetImageList(h,i)					((HIMAGELIST)::SendMessage(h,CLB_GETIMAGELIST,i,0))
#define		ColorListBox_GetVisibleCount(h)					((UINT      )::SendMessage(h,CLB_GETVISIBLECOUNT,0,0))
#define		ColorListBox_FindItem(h,p,f)					((INT       )::SendMessage(h,CLB_FINDITEM ,(WPARAM)p,(LPARAM)f))
#define		ColorListBox_SetImageList(h,l,i)				((HIMAGELIST)::SendMessage(h,CLB_SETIMAGELIST,i,(LPARAM)(UINT)(HIMAGELIST)(l)))
#define 	ColorListBox_SetOption(h,i,o)					((LPARAM    )::SendMessage(h,CLB_GETSETOPTION,(i)|CLBO_WRITEOPTION,(LPARAM)(o)))
#define 	ColorListBox_GetOption(h,i)						((LPARAM    )::SendMessage(h,CLB_GETSETOPTION,i,0))
#define 	ColorListBox_Scroll(h,x,y)						((INT       )::SendMessage(h,CLB_SCROLL,x,y))
#define 	ColorListBox_GetItemState(h,i)					((INT       )::SendMessage(h,CLB_GETITEMSTATE,i,0))
#define 	ColorListBox_SetItemState(h,i,s,m)				((INT       )::SendMessage(h,CLB_SETITEMSTATE,i,MAKELONG(s,m)))
#define 	ColorListBox_GetSelectedCount(h)				((INT       )::SendMessage(h,CLB_GETSELECTEDCOUNT,0,0))
#define 	ColorListBox_GetStringWidth(h,i)				((INT       )::SendMessage(h,CLB_GETSTRINGWIDTH,i,0))
#define 	ColorListBox_GetNextItem(h,i,t)				 	((INT       )::SendMessage(h,CLB_GETNEXTITEM,i,t))
#define		ColorListBox_SortItem(h,f,p)					((INT       )::SendMessage(h,CLB_SORTITEMS,f,(LPARAM)(PFCLBCOMPARE*)(p)))
#define		ColorListBox_GetMark(h,p,q)						((INT       )::SendMessage(h,CLB_GETMARK,(WPARAM)(p),(LPARAM)(q)))
#define		ColorListBox_GetMarkEx(h,p)						((INT       )::SendMessage(h,CLB_GETMARK_EX,0,(LPARAM)(p)))
#define		ColorListBox_ItemFromPoint(h,x,y,p)				((INT       )::SendMessage(h,CLB_ITEMFROMPOINT,MAKELONG(x,y),(LPARAM)(p)))
#define		ColorListBox_MarkAll(h)							((INT       )::SendMessage(h,CLB_MARKALL,0,0))
#define 	ColorListBox_SetColor(h,n,c)					((COLORREF  )::SendMessage(h,CLB_SETCOLOR,n,(LPARAM)(c)))
#define 	ColorListBox_GetColor(h,n,c)					((COLORREF  )::SendMessage(h,CLB_GETCOLOR,n,0))
#define 	ColorListBox_EnsureVisible(h,n,p)				((INT       )::SendMessage(h,CLB_ENSUREVISIBLE,n,p))
#define 	ColorListBox_InsertItem(h,p,f)					((INT       )::SendMessage(h,CLB_INSERTITEM,f,(LPARAM)p))
#define 	ColorListBox_SetItem(h,p,f)						((INT       )::SendMessage(h,CLB_SETITEM,f,(LPARAM)p))
#define 	ColorListBox_SelectAll(h,s)						((INT       )::SendMessage(h,CLB_SELECTALL,s,0))
#define		ColorListBox_SetCursor(h,l,p)					((BOOL      )::SendMessage(h,CLB_SETCURSOR,p,l))
#define		ColorListBox_GetCursor(h,l,p)					((BOOL      )::SendMessage(h,CLB_GETCURSOR,p,l))
#define		ColorListBox_SetSelMark(h,l,p)					((BOOL      )::SendMessage(h,CLB_SETSELMARK,p,l))

#define		ColorListBox_GetStyle(h)						((DWORD     )::GetWindowLong(h,GWL_STYLE))
#define		ColorListBox_SetStyle(h,d)	  					((DWORD     )::SetWindowLong(h,GWL_STYLE,d))
#define 	ColorListBox_SetStyleEx(h,d,m)					((DWORD     )::SetWindowLong(h,GWL_STYLE,((d)&(m))|(::GetWindowLong(h,GWL_STYLE)&~(m))))


#define 	ColorListBox_GetNextSelected(h,i)			    ColorListBox_GetNextItem(h, i,     LVNI_SELECTED)
#define 	ColorListBox_GetFirstVisible(h)				    ColorListBox_GetNextItem(h, NULL,  LVNI_FIRSTVISIBLE)
#define		ColorListBox_GetLastVisible(h)					ColorListBox_GetNextItem(h, NULL,  LVNI_LASTVISIBLE)



int			ColorListBoxRegister(HINSTANCE hInstance=0);



#endif
