//*****************************************************************************
//*
//*
//*		ComboEx.cpp
//*
//*
//*****************************************************************************
//
//	Ist eine MFC-Klasse die ComboBox-Fenster das Farben und dicker Schrift zu lst.
//
//	Fenster Styles:
//	
//		CBS_SIMPLE          	0x0000	Auswahlliste ist immer sichtbar
//		CBS_DROPDOWN        	0x0002	ComboBox mit Eingabefeld
//		CBS_DROPDOWNLIST    	0x0003	ComboBox ohne Eingabefeld
//		CBS_OWNERDRAWFIXED		0x0010	--- nicht untersttzt ---
//		CBS_OWNERDRAWVARIABLE   0x0020	--- nicht untersttzt ---
//		CBS_AUTOHSCROLL        	0x0040	--- nicht untersttzt ---
//		CBS_OEMCONVERT         	0x0080	--- nicht untersttzt ---
//		CBS_SORT		      	0x0100	Die Eintrge in der Listbox werden sortiert
//		CBS_HASSTRINGS      	0x0200	--- nicht untersttzt ---
//		CBS_WANTRETURN			0x0200	Die Tasten RET/TAB/ESC nia Notify melden
//		CBS_NOINTEGRALHEIGHT   	0x0400	Die Listbox kann partielle Elemente anzeigen
//		CBS_DISABLENOSCROLL    	0x0800	Keien Y-Scrollbar in der Listbox
//		CBS_UPPERCASE       	0x1000	--- nicht untersttzt ---
//		CBS_LOWERCASE          	0x2000	--- nicht untersttzt ---
//		CBS_ALLOWDROP			0x4000	Dateien knnen auf das Control fallengelassen werden
//		CBS_NOGRAYDISABLE		0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	
#include	<AfxPriv.h>
#include	"ComboEx.h"
#include	"WinExtension.h"


//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
//	Erstellt ein neues CComboEx-Fenster. 
BOOL CComboEx::CreateEx(DWORD dwStyleEx,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID)
{
WNDPROC		   *pSuperProc;
WNDPROC			pOldProc;


														
	ASSERT(m_hWnd ==NULL);
	ASSERT(pParent!=NULL);
	ASSERT((dwStyle&WS_POPUP) == 0);

	if(!CWnd::CreateEx(dwStyleEx,_T("COMBOBOX"),_T(""),dwStyle,sRect,pParent,nID,NULL))
		{
		return FALSE;
		}

	pSuperProc	= GetSuperWndProcAddr();				// Die neue Funktion zwischen MFC und WinApi hngen
	pOldProc	= *pSuperProc;
   *pSuperProc	= ColorComboProc;

			
	ColorComboProc(m_hWnd,WM_ATTACH,0,(LPARAM)pOldProc);// Das Farbfenster initiallisieren 
	
	
	
return TRUE;
}

//*****************************************************************************
//*
//*		SubclassWindow
//*
//*****************************************************************************
//	Ein ComboEx-Fenster an ein bestehendes Edit-Fenster andocken.
//	hWnd		: Ist das Fenster-Handle des bestehendes Edit-Fensters
//	Ergibt TRUE wenn erfolgreich bzw. FALSE bei einem Fehler.
BOOL CComboEx::SubclassWindow(HWND hWnd)
{
WNDPROC		   *pSuperProc;
WNDPROC			pOldProc;
BOOL			bOk;


	ASSERT(IsWindow(hWnd));

	#ifdef _DEBUG

	char 	cClass[32];
	DWORD	dwStyleEx;
	DWORD	dwStyle;

	GetClassNameA(hWnd,cClass,sizeof(cClass));
	ASSERT(!strcmp(cClass,"ComboBox"));

	dwStyle		= GetWindowLong(hWnd,GWL_STYLE  );
	dwStyleEx	= GetWindowLong(hWnd,GWL_EXSTYLE);
	

	ASSERT((dwStyle&CBS_ALLOWDROP        )==0 || (dwStyleEx&WS_EX_ACCEPTFILES));
	ASSERT((dwStyle&CBS_DROPDOWNLIST     )!=0);
	ASSERT((dwStyle&CBS_OWNERDRAWFIXED   )==0);
	ASSERT((dwStyle&CBS_OWNERDRAWVARIABLE)==0);

	#endif

		bOk=CComboBox::SubclassWindow(hWnd);
	if(!bOk)return FALSE;

	pSuperProc	= GetSuperWndProcAddr();				// Die neue Funktion zwischen MFC und WinApi hngen
	pOldProc	= *pSuperProc;
   *pSuperProc	= ColorComboProc;

	ColorComboProc(m_hWnd,WM_ATTACH,0,(LPARAM)pOldProc);// Das Farbfenster aktuallieren



return TRUE;
}

//*****************************************************************************
//*
//*		UnsubclassWindow
//*
//*****************************************************************************
//	Ein ComboEx-Fenster vom bestehendes Fenster abdocken.
HWND CComboEx::UnsubclassWindow()
{
WNDPROC		   *pSuperProc;



	ASSERT(IsWindow(m_hWnd));

	pSuperProc = GetSuperWndProcAddr();					

	ASSERT(*pSuperProc==ColorComboProc);

	ColorComboProc(m_hWnd,CB_SYNCHWINDOW,0,0);				
														// Die vorherige MFC Funktion wieder einhngen
   *pSuperProc = (WNDPROC)ColorComboProc(m_hWnd,WM_DETACH,0,1);



return CComboBox::UnsubclassWindow();
}



//*****************************************************************************
//*
//*		SetStyle
//*
//*****************************************************************************
//	Den Style der ComboBox einstellen
//	uStyle		: Ist der neue Style.
//					CBS_SIMPLE          	0x0000	Auswahlliste ist immer sichtbar
//					CBS_DROPDOWN        	0x0002	ComboBox mit Eingabefeld
//					CBS_DROPDOWNLIST    	0x0003	ComboBox ohne Eingabefeld
//					CBS_OWNERDRAWFIXED		0x0010	--- nicht untersttzt ---
//					CBS_OWNERDRAWVARIABLE   0x0020	--- nicht untersttzt ---
//					CBS_AUTOHSCROLL        	0x0040	--- nicht untersttzt ---
//					CBS_OEMCONVERT         	0x0080	--- nicht untersttzt ---
//					CBS_SORT		      	0x0100	Die Eintrge in der Listbox werden sortiert
//					CBS_HASSTRINGS      	0x0200	--- nicht untersttzt ---
//					CBS_WANTRETURN			0x0200	Die Tasten RET/TAB/ESC nia Notify melden
//					CBS_NOINTEGRALHEIGHT   	0x0400	Die Listbox kann partielle Elemente anzeigen
//					CBS_DISABLENOSCROLL    	0x0800	Keien Y-Scrollbar in der Listbox
//					CBS_UPPERCASE       	0x1000	--- nicht untersttzt ---
//					CBS_LOWERCASE          	0x2000	--- nicht untersttzt ---
//					CBS_ALLOWDROP			0x4000	Dateien knnen auf das Control fallengelassen werden
//					CBS_NOGRAYDISABLE		0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	uMask		: Welche Bits sollen gesetzt werden.
//	Ergubt den alten Style.
DWORD CComboEx::SetStyle(DWORD uStyle,DWORD uMask) 
{
DWORD	uBits;
DWORD	uOld;


	ASSERT(::IsWindow(m_hWnd)); 

	uOld	=  GetWindowLong(m_hWnd,GWL_STYLE);
	uBits	= ~uMask&uOld;
	uBits  |=  uMask&uStyle;
	
	SetWindowLong(m_hWnd,GWL_STYLE,uBits);


return uOld;
}


