//*****************************************************************************
//*
//*
//*		ComboEx.h
//*
//*
//*****************************************************************************
//
//	Ist eine MFC-Klasse die ComboBox-Fenster das Farben und dicker Schrift zu lst.
//
//	Fenster Styles:
//	
//		CBS_SIMPLE          	0x0000	Auswahlliste ist immer sichtbar
//		CBS_DROPDOWN        	0x0002	ComboBox mit Eingabefeld
//		CBS_DROPDOWNLIST    	0x0003	ComboBox ohne Eingabefeld
//		CBS_OWNERDRAWFIXED		0x0010	--- nicht untersttzt ---
//		CBS_OWNERDRAWVARIABLE   0x0020	--- nicht untersttzt ---
//		CBS_AUTOHSCROLL        	0x0040	--- nicht untersttzt ---
//		CBS_OEMCONVERT         	0x0080	--- nicht untersttzt ---
//		CBS_SORT		      	0x0100	Die Eintrge in der Listbox werden sortiert
//		CBS_HASSTRINGS      	0x0200	--- nicht untersttzt ---
//		CBS_WANTRETURN			0x0200	Die Tasten RET/TAB/ESC nia Notify melden
//		CBS_NOINTEGRALHEIGHT   	0x0400	Die Listbox kann partielle Elemente anzeigen
//		CBS_DISABLENOSCROLL    	0x0800	Keien Y-Scrollbar in der Listbox
//		CBS_UPPERCASE       	0x1000	--- nicht untersttzt ---
//		CBS_LOWERCASE          	0x2000	--- nicht untersttzt ---
//		CBS_ALLOWDROP			0x4000	Dateien knnen auf das Control fallengelassen werden
//		CBS_NOGRAYDISABLE		0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	
#ifndef 	__COMBOEX_H__
#define 	__COMBOEX_H__

#include	<AfxWin.h>
#include	<AfxCmn.h>

#include	"ColorComboWnd.h"



//*****************************************************************************
//*
//*		Klasse CComboBox
//*
//*****************************************************************************
class CComboEx : public CComboBox
{
public:
	
	BOOL	CreateEx		(DWORD dwStyleEx,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID);
	BOOL	Create			(DWORD                 dwStyle,const RECT &sRect,CWnd *pParent,UINT nID){return CreateEx(0,dwStyle,sRect,pParent,nID);}

	BOOL	SetColor		(const LPBYTE pColor,int iSize=0xFFFF,int i=-1)	{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETCOLOR,MAKELONG(iSize,i),(LPARAM)pColor);}
	BOOL	SetColorMode	(DWORD uMode)									{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETCOLORMODE,uMode,0);}
	BOOL	SetColorItem	(const LPCOLORREF pItem,int iCount,int iStart=0){ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETCOLORITEM,MAKELONG(iCount,iStart),(LPARAM)pItem);}
	BOOL	SetColorItem	(COLORREF uColor,int iIndex)					{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETCOLORITEM,MAKELONG(iIndex,1),(LPARAM)&uColor);}
	BOOL	SetImageList	(HIMAGELIST  hImageList)						{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETIMAGELIST,0,(LPARAM)hImageList);}
	BOOL	SetImageList	(CImageList *pImageList)						{                            return (BOOL   )  SetImageList(pImageList); }
	BOOL	SetImage		(int iImage,int iItem=-1)						{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETIMAGE,iItem,iImage);}
	BOOL	SetImageHeight	(int iHeight)									{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETDROPPEDHEIGHT,iHeight,0);}
	BOOL	SetCallback		(ColorComboCb pProc,LPVOID pParam=0)			{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,CB_SETCALLBACK,(WPARAM)pParam,(LPARAM)pProc);}
	DWORD	SetEditStyle	(DWORD uStyle ,DWORD uMask=0xFFFF)				{ASSERT(::IsWindow(m_hWnd)); return (DWORD  )::SendMessage(m_hWnd,CB_SETEDITSTYLE,uStyle,uMask);}
	DWORD	SetTabStop		(WORD uTabStop)									{ASSERT(::IsWindow(m_hWnd)); return (DWORD  )::SendMessage(m_hWnd,CB_SETTABSTOP,uTabStop,0);}
	LPCTSTR	GetText			()												{ASSERT(::IsWindow(m_hWnd)); return (LPCTSTR)::SendMessage(m_hWnd,CB_GETTEXTPTR ,0,0);}
	INT		GetImage		(int iItem)										{ASSERT(::IsWindow(m_hWnd)); return (INT    )::SendMessage(m_hWnd,CB_GETIMAGE   ,iItem,0);}
	LPBYTE	GetColors		(int iItem)										{ASSERT(::IsWindow(m_hWnd)); return (LPBYTE )::SendMessage(m_hWnd,CB_GETCOLORPTR,iItem,0);}
	DWORD	GetStyle		()												{ASSERT(::IsWindow(m_hWnd)); return (DWORD  )::GetWindowLong(m_hWnd,GWL_STYLE);}		
	VOID	SynchWindow		()												{ASSERT(::IsWindow(m_hWnd));                 ::SendMessage(m_hWnd,CB_SYNCHWINDOW,0,0);}
	BOOL	SubclassWindow  (DWORD dwStyle,HWND hWnd)						{ASSERT(::IsWindow(  hWnd));                 ::SetWindowLong(hWnd,GWL_STYLE,dwStyle); return SubclassWindow(hWnd);}
	BOOL	SubclassWindow  (              HWND hWnd);
	DWORD	SetStyle		(DWORD uStyle ,DWORD uMask=0xFFFF);
	HWND	UnsubclassWindow();

};


#endif 	