/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*   Klasse CCopyDlg                                                         */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
//	void Break()							Aktuellen Vorgang abbrechen
//	INT_PTR	 DoModal(char *Pfad,				Vorgang Starten
//				 CStringChain *Dateien,
//				 char *Von,
//				 int Flags=CF_COPY);
//
//	Flags:	CF_COPY		: Dateien kopieren
//			CF_MOVE		: Dateien verschieben
//			CF_REMOVE	: Dateien lschen

#ifndef	COPY_FUNKTIONEN__H
#define	COPY_FUNKTIONEN__H

#define	CF_COPY				0x00000000	// Dateien kopieren
#define	CF_MOVE				0x00000001	// Dateien verschieben
#define	CF_REMOVE			0x00000002	// Dateien lschen

#define	CF_IMMER			0x00000100	// Dateien immer kopieren
#define	CF_VIMMER			0x00000200	// Verzeichnisse immer kopieren
#define	CF_NIE				0x00000400	// Dateien nie kopieren
#define	CF_VNIE				0x00000800	// Verzeichnisse immer kopieren
#define	CF_ABBRUCH			0x00001000	// Vorgang abbrechen
#define	CF_KEINE_VERZ		0x00002000	// Keine Fehler wenn Verzeichnis
#define	CF_TEST				0x00004000	// Datei nur Prfen
#define	CF_FRAGE   			0x00008000	// Sicherheits Abfrage am Anfang
#define	CF_VERZ 			0x00040000	// Ein Verzeichnis wurde kopiert
#define	CF_DATEI   			0x00080000	// Eine Datei wurde kopiert


#define	MB_YESNOIMMER		0x00000007	// Zusatz Modus fr MessageBox
#define	MB_SUBDIR			0x80000000	// Datei ist ein Verzeichnis
#define	MB_ATTRIB  			0x40000000	// Icon mit Attributen erzeugen
#define	MB_SPEZIAL			0x00000008	// Zusatz Modus fr MessageBox
#define	MB_UEBERSCHREIBEN	0x00000018	// Frage ob Datei berschreiben
#define	MB_COPYFEHLER		0x00000028	// Fehler beim kopieren
#define	MB_DATEIISTVERS		0x00000038	// Fehler Datei ist ein Verzeichnis
#define	MB_SELBSTCOPY		0x00000048	// Fehler Datei kann nicht in sich selbts kopiert werden
#define	MB_ZULANG			0x00000058	// Dateiname ist zu lang
#define	MB_VERZUEBERSCHR	0x00000068	// Kann Verzeichnis nicht berschreiben
#define	MB_VERZERZEUGEN		0x00000078	// Kann Verzeichnis erzeugen
#define	MB_NICHTGEFUNDEN	0x00000088	// Datei wurde nicht gefunden
#define	MB_NICHTVERSCH		0x00000098	// Datei kann nicht verschoben werden
#define	MB_NICHTLOESCHEN	0x000000A8	// Datei kann nicht gelscht werden
#define	MB_KEINSPEICHER		0x000000B8	// Zuwenig freier Speicherplatz
#define	MB_WIRKLICHDEL		0x000000C8	// Frage ob Datei lschen

#include	<afx.h>
#include	<afxwin.h>				// MFC-Kern- und -Standardkomponenten
#include	<afxext.h>				// MFC-Erweiterungen
#include	<afxcmn.h>
#include	<afxcview.h>
#include	"Resource.h"

#include	<io.h>
#include	<fcntl.h>
#include	<errno.h>
#include	<direct.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys/stat.h>
#include	"..\StringChain.h"
#include	"..\StringFunctions.h"



struct	copy_data
	{
	char		 *pfad;			// Ziel  Pfad
	char		 *von;			// Quell Pfad
	CStringChain *dateien;		// Dateinamen
	};


class	CCopyDlg : public CDialog
{
/*****************************************************************************/
/*                                                                           */
/*   Veriabeln                                                               */
/*                                                                           */
/*****************************************************************************/
public:

	copy_data		data;				// Start Daten

	//{{AFX_DATA(CCopyDlg)
	enum { IDD = IDD_COPY };			// Dialog ID-Nummer
	//}}AFX_DATA(CCopyDlg)


protected:

	struct	dlg_struct
		{
		int			 art;
		char		*datei1;
		char		*datei2;
		_finddata_t *find1;
		_finddata_t *find2;
		};

	static	int	DLG_ID[];

	int				flags;				// Flags fr CCopyDlg-Klasse
	int				ebene;				// Zugriffs Ebene
	int				init;				// Initialisierung
	HANDLE			copy_thread;		// Thread frs Kopieren
	unsigned long	copy_thread_id;		// Thread ID

/*****************************************************************************/
/*                                                                           */
/*   Funktionen                                                              */
/*                                                                           */
/*****************************************************************************/
public:

		CCopyDlg(CWnd *pParent = NULL);	// Konstruktor
	   ~CCopyDlg();						// Destruktor

	CProgressCtrl	*progress;

   	INT_PTR		DoModal	(char *Pfad,CStringChain *Dateien,char *Von,int Flags=CF_COPY);
	inline void	Break(){OnAbbrechen();}

protected:

	void 	Copy		(copy_data	*Data);
	void 	Move		(copy_data	*Data);
	void	Remove		(copy_data	*Data);

	void	DoDataExchange( CDataExchange *pDX   );
	int		Copy_Datei	(char *Pfad,char *Datei  );
	int		Check_Datei	(char *Pfad,char *Datei=0);
	int		Frage		(char *Text,int Art);
	int		Frage		(int Art,char *Datei1=0,char *Datei2=0,_finddata_t *Find1=0,_finddata_t *Find2=0);
	void	OnAbbrechen	();

	static	BOOL CALLBACK DlgProc(HWND Dlg, UINT msg, WPARAM wParam, LPARAM lParam );
	static	DWORD WINAPI CCopyDlg::StartRemvThread(LPVOID copy_class);
	static	DWORD WINAPI CCopyDlg::StartCopyThread(LPVOID copy_class);
	static	DWORD WINAPI CCopyDlg::StartMoveThread(LPVOID copy_class);


	DECLARE_MESSAGE_MAP()

};

#endif	//COPY_FUNKTIONEN__H
