//*****************************************************************************
//*
//*
//*		DataWnd.cpp: Implementierung der Klasse CDataWnd.
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"DataWnd.h"
#include	"RegKeys.h"
#include 	"AfxDialog.h"
#include	"AfxMacros.h"
#include	"AfxUtility.h"
#include	"WinExtension.h"
#include	"FileFunctions.h"
#include	"StringFunctions.h"



#ifdef     _DEBUG
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define new DEBUG_NEW

//*****************************************************************************
//*
//*		Konstanten
//*
//*****************************************************************************

#define 	ID_LIST				0x3701						// ID fr List-Fenster
#define 	ID_LABEL			0x3702						// ID fr Label Fenster

#ifndef 	ID_CDW_LOADMODUL
#define 	ID_CDW_LOADMODUL	0x3703						// Load Modul
#endif
#ifndef 	ID_CDW_LOADLIST
#define 	ID_CDW_LOADLIST		0x3704						// Load Modul Liste
#endif
#ifndef		ID_CDW_DELETEMODUL
#define 	ID_CDW_DELETEMODUL	0x3705						// Lsche Module
#endif
#ifndef		ID_CDW_ADDTOLIST
#define 	ID_CDW_ADDTOLIST	0x3706						// Modul in Liste einfgen
#endif
#ifndef		ID_CDW_ADRESS_ON
#define 	ID_CDW_ADRESS_ON   	0x3707						// Adress-Anzeige ein/aus
#endif
#ifndef		ID_CDW_LENGTH_ON
#define 	ID_CDW_LENGTH_ON	0x3708						// Lngen-Anzeige ein/aus
#endif
#ifndef		ID_CDW_OFFSET_ON
#define 	ID_CDW_OFFSET_ON	0x3709						// Offset-Anzeige ein/aus
#endif
#ifndef		ID_CDW_FIXFONT_ON
#define 	ID_CDW_FIXFONT_ON	0x370A						// Fixen Font einschalten
#endif
#ifndef		ID_CDW_LINES_ON
#define 	ID_CDW_LINES_ON		0x370B						// Linien ein/aus
#endif
#ifndef		ID_CDW_PROPERTYS
#define 	ID_CDW_PROPERTYS	0x370C						// Eigenschaften Dialog aufrufen
#endif
#ifndef		ID_CDW_UPDATE
#define 	ID_CDW_UPDATE		0x370D						// Neu ReadData
#endif
#ifndef		ID_CDW_DELFROMLIST
#define 	ID_CDW_DELFROMLIST	0x370E						// Modul aus der Modulliste lschen
#endif
#ifndef		ID_CDW_COPY
#define 	ID_CDW_COPY			0x370F						// Feld kopieren
#endif
#ifndef		ID_CDW_ALTLINE_ON
#define 	ID_CDW_ALTLINE_ON	0x3710						// Abwechselnde Farbe ein/aus
#endif

#define 	BOX_WIDTH			13							// Breite/Hhe der Aufklappbereiches
#define 	BOX_X				11							// Breite der Aufklappbox
#define 	BOX_Y				11							// Hhe   der Aufklappbox

CPen		CDataWnd::m_sPen;								// Graue Linie
CPen		CDataWnd::m_sPen1;								// Graue Linie punktiert
int			CDataWnd::m_iWndCount  =0;						// Anzahl der Fenster
int			CDataWnd::m_iScrollX   =0;						// Breite iFrom Scrollleisten
int			CDataWnd::m_iScrollY   =0;						// Hhe iFrom Scrollleisten
BOOL		CDataWnd::m_bInitDone  =0;						// Gab es eine Initialisierung
HFONT		CDataWnd::m_hTextVar   =0;						// Variabler Font
HFONT		CDataWnd::m_hTextFix   =0;						// Fixer Font
LPTSTR		CDataWnd::m_pClassName =0;						// Klassen Name
BYTE		CDataWnd::m_uHeighVar  =16;						// Variabler Font
BYTE		CDataWnd::m_uHeighFix  =16;						// Hhe vom fixen Font
const int	CDataWnd::m_aAreaSizes[5]={250,-50,70,70,99};	// Abschnitts Breiten



//*****************************************************************************
//*
//*		Nachrichten
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CDataWnd, CWnd)
	//{{AFX_MSG_MAP(CWnd)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_NOTIFY(NM_RETURN		  ,ID_LIST	,OnListview)
	ON_NOTIFY(NM_RCLICK		  ,ID_LIST	,OnListview)
	ON_NOTIFY(NM_DBLCLK		  ,ID_LIST	,OnListview)
	ON_NOTIFY(LVN_KEYDOWN	  ,ID_LIST	,OnListview)
	ON_NOTIFY(LVN_SPECIALCLICK,ID_LIST	,OnClick)
	ON_NOTIFY(CLW_SELCHANDED  ,ID_LABEL	,OnLabel)
	ON_COMMAND(ID_CDW_LOADMODUL			,OnLoadModul)
	ON_COMMAND(ID_CDW_LOADLIST			,OnLoadListe)
	ON_COMMAND(ID_CDW_ADDTOLIST			,OnAddToList)
	ON_COMMAND(ID_CDW_DELETEMODUL		,OnDelModul)
	ON_COMMAND(ID_CDW_DELFROMLIST		,OnDelFromList)
	ON_COMMAND(ID_CDW_PROPERTYS			,OnPropertyDlg)
	ON_COMMAND(ID_CDW_ALTLINE_ON		,OnAlternate)
	ON_COMMAND(ID_CDW_FIXFONT_ON		,OnFixFont)
	ON_COMMAND(ID_CDW_ADRESS_ON   		,OnAdress)
	ON_COMMAND(ID_CDW_LENGTH_ON			,OnLength)
	ON_COMMAND(ID_CDW_OFFSET_ON			,OnOffset)
	ON_COMMAND(ID_CDW_LINES_ON			,OnLines)
	ON_COMMAND(ID_CDW_UPDATE			,OnReadData)
	ON_COMMAND(ID_CDW_COPY				,OnCopyMouse)
	ON_MESSAGE(WM_COPY					,OnCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDataWnd::CDataWnd()
{
LOGBRUSH	sLog;
LPCTSTR		pName;
int			iSize;



	if(!m_iWndCount)										// Initialiesierung
		{
		m_iScrollX = GetSystemMetrics(SM_CXVSCROLL);
		m_iScrollY = GetSystemMetrics(SM_CYHSCROLL);

		if(m_iScrollY<16)m_iScrollY=16;

		pName = AfxRegisterWndClassEx(_T("DataWnd"),0);

			    m_pClassName=new TCHAR[_tcslen(pName)+1];
		_tcscpy(m_pClassName,pName);

		if(!m_hTextVar)										// Font fr Fenster holen
			{
			m_hTextVar	= GetDefaultFont(0);
			m_hTextFix	= GetDefaultFont(1);
			
			GetTextWidth("A",m_hTextVar,1,&iSize);
			m_uHeighVar = iSize+1;
			GetTextWidth("A",m_hTextFix,1,&iSize);
			m_uHeighFix = iSize;
			}
		}

	m_iWndCount++;

	memset(m_aMemPtr  , 0,sizeof(m_aMemPtr  ));				// Speicher Variabeln
	memset(m_aMemMax  , 0,sizeof(m_aMemMax  ));
	memset(m_aMemOff  , 0,sizeof(m_aMemOff  ));
	memset(m_aMemLen  , 0,sizeof(m_aMemLen  ));
	memset(m_aMemAddr , 0,sizeof(m_aMemAddr ));
	memset(m_aBlockNum,-1,sizeof(m_aBlockNum));				// Aktuelle Block-Nummer
	memset(m_aModulNum,-1,sizeof(m_aModulNum));				// Aktuelle Modul-Nummer

	m_bLinesOn	 	= 1;									// Linien im Datenfenster
	m_bOffsetOn  	= 1;									// Offset-Anzeige
	m_bFixFontOn 	= 1;									// Fixen Font verwenden
	m_bAltLineOn	= 1;									// Abwechselnde Farben
	m_bAddressOn 	= 0;									// Adressanzeige
	m_bLengthOn  	= 0;									// Lngenanzeige
	m_iSaveCfg   	= 0;
	m_iScanSel   	= 0;
	m_iInit			= 0;
	m_sContextPt.x	= 0;
	m_sContextPt.y	= 0;
	m_iMaxLines		= 8192;

	if(!m_bInitDone)										// Gab es eine Initialisierung
		{
		m_bInitDone = TRUE;
		m_sPen.CreatePen(PS_SOLID,1,GetSysColor(COLOR_3DLIGHT));

		sLog.lbColor = GetSysColor(COLOR_3DLIGHT);
		sLog.lbStyle = PS_SOLID;
		sLog.lbHatch = 0;

	    if(!m_sPen1.CreatePen(PS_COSMETIC|PS_ALTERNATE,1,&sLog,0,NULL))
			{
			m_sPen1.CreatePen(PS_DOT,1,GetSysColor(COLOR_3DLIGHT));
			}
		}

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDataWnd::~CDataWnd()
{

	if(m_iSaveCfg)SaveConfig();

	m_iWndCount--;

	if(m_iWndCount<=0)										// Letztes Fenster geschlossen
		{
		if(m_pClassName){delete m_pClassName;m_pClassName=0;}
		}

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugen einer DataWnd
//	iScanner  :	Anzahl der Scanner
//	dwStyle	  :	CDW_LABELS		Laschen anzeigen
//				CDW_MODULLIST	ModulListe Loadn
//				CDW_NOMODULDLG	Keine Laden der Module ber einen Dlg
//				CDW_NOPROPERTYS Keine Eigenschafts Men
// 				CDW_ADDRES_ON	Adress Anzeige
// 				CDW_OFFSET_ON	Offset Anzeige
//				CDW_LENGTH_ON	Lngen Anzeige
//				CDW_FIXEDFONT	Fixe Schriftzeichen Breite
//				CDW_LISTBORDER	Rahmen um List Fenster
//				CDW_LISTLINES 	Linien im List Fenster
BOOL CDataWnd::Create(int iScanner,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID)
{
int		aSizes[5];
int		iHeight;
CRect	sRectL;
CRect	sRectI;
HFONT	hFont;
int		iFlag;
int		iBit;
int		i;


	ASSERT_VALID(pParentWnd);
	ASSERT(CDW_MAX<=SCAN_MAX);


	if(iScanner>CDW_MAX)iScanner=CDW_MAX;
	if(iScanner<1      )iScanner=1;

	m_iCount	 = iScanner;

	m_bAddressOn = (dwStyle&CDW_ADDRES_ON )? 1:0;
	m_bOffsetOn	 = (dwStyle&CDW_OFFSET_ON )? 1:0;
	m_bLengthOn	 = (dwStyle&CDW_LENGTH_ON )? 1:0;
	m_bFixFontOn = (dwStyle&CDW_FIXEDFONT )? 1:0;
	m_bLinesOn	 = (dwStyle&CDW_LISTLINES )? 1:0;
	m_bAltLineOn = (dwStyle&CDW_ALTERNATE )? 1:0;
	m_iSaveCfg 	 = (dwStyle&CDW_LOADCONFIG)? 1:0;


	if(!CWnd::Create(m_pClassName,_T("DataWindow"),dwStyle,sRect,pParentWnd,nID))
		{
		return FALSE;
		}

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));


//******************** ListViews **********************************************


	sRectI = sRect;

	if(dwStyle&CDW_LABELS)
		{
		   sRectI.bottom-=m_iScrollY;
		if(sRectI.bottom<sRectI.top)sRectI.bottom=sRectI.top;
		   sRectL=sRect;
		   sRectL.top=sRectI.bottom;
		}

	iBit = LVS_REPORT|LVS_OWNERDRAWFIXED|LVS_SINGLESEL|WS_VSCROLL;
	if(dwStyle&CDW_LISTBORDER)iBit|=WS_BORDER;

							 iFlag =LVS_EX_FULLROWSELECT;
	if(dwStyle&CDW_ALTERNATE)iFlag|=LVS_EX_ALTERNATECOLOR;
	if(dwStyle&CDW_LISTLINES)iFlag|=LVS_EX_GRIDLINES;

	hFont	= (dwStyle&CDW_FIXEDFONT)? m_hTextFix:m_hTextVar;

	GetTextWidth("A",hFont,1,&iHeight);
	if(iHeight<9)iHeight=9;

	for(i=0;i<5;i++)
		{
		aSizes[i] = (m_aAreaSizes[i]*iHeight)/12;
		}

	for(i=0;i<CDW_MAX;i++)
		{
		m_aListWnd[i].Create(iBit,sRectI,this,ID_LIST);
		m_aListWnd[i].InsertColumn(0,_T("Typ"	 ),LVCFMT_LEFT,aSizes[0]);
		m_aListWnd[i].InsertColumn(1,_T("Inhalt" ),LVCFMT_LEFT,aSizes[1]);
		m_aListWnd[i].InsertColumn(2,_T("Offset" ),LVCFMT_LEFT,aSizes[2]);
		m_aListWnd[i].InsertColumn(3,_T("Gre"  ),LVCFMT_LEFT,aSizes[3]);
		m_aListWnd[i].InsertColumn(4,_T("Adresse"),LVCFMT_LEFT,aSizes[4]);
		m_aListWnd[i].SetFont(CFont::FromHandle(hFont));
		m_aListWnd[i].SetLineCallback(LineCallback);
		m_aListWnd[i].SetLineCbParam(this);
		m_aListWnd[i].SetExtendedStyle(iFlag);
		if(!m_bOffsetOn )m_aListWnd[i].FixColumnSize(2,1,0,1);
		if(!m_bLengthOn )m_aListWnd[i].FixColumnSize(3,1,0,1);
		if(!m_bAddressOn)m_aListWnd[i].FixColumnSize(4,1,0,1);
		}

	m_aListWnd[m_iScanSel].ShowWindow(SW_SHOW);


//******************** Diverse ************************************************


	if(dwStyle&CDW_LABELS)
		{
		m_cLabelCtrl.Create(iScanner,0,_T("Daten"),sRect,this,CLW_FRAMETOP|CLW_CHILDSCROLL|CLW_CHILDSCROLLOFF|CLW_WHITELINE,ID_LABEL);
		m_cLabelCtrl.SetWindow(iScanner,m_aListWnd,ListProc);
		m_cLabelCtrl.ShowWindow(SW_SHOW);
		}

	m_iFlags = dwStyle&0xFFFF;
	m_iInit  = 1;

	if(dwStyle&CDW_MODULLIST )LoadList();
	if(dwStyle&CDW_LOADCONFIG)LoadConfig();


	OnSize(0,m_iSizeX,m_iSizeY);


return TRUE;
}

//*****************************************************************************
//*
//*		OnLabel
//*
//*****************************************************************************
//	Wird aufgerufen wenn eine ander Lasche im Label-Fenster ausgewhlt wurde
void CDataWnd::OnLabel(NMHDR *pNmHdr, LRESULT *pResult)
{
LabelNotify		*pNotify=(LabelNotify*)pNmHdr;


	SetSel(pNotify->select);

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CDataWnd::OnDestroy( )
{
	m_iInit = 0;
}

//*****************************************************************************
//*
//*		DeleteModul
//*
//*****************************************************************************
//	Alle Module und Fenster lschen
void CDataWnd::DeleteModul()
{
int		i;

	m_sScanner.Delete();

	if(m_iInit)
		{
		for(i=0;i<CDW_MAX;i++)
			{
			m_aListWnd[i].DeleteAllItems();
			}
		}

}

//*****************************************************************************
//*
//*		On...			Module Load ber einen Dialog
//*
//*****************************************************************************
void CDataWnd::OnLoadListe(){LoadList( );}
void CDataWnd::OnLoadModul(){LoadDlg (0);}
void CDataWnd::OnAddToList(){LoadDlg (1);}
void CDataWnd::OnReadData (){ReadData( );}
void CDataWnd::OnOffset   (){SetStyle(!m_bOffsetOn, m_bLengthOn, m_bAddressOn, m_bFixFontOn, m_bLinesOn, m_bAltLineOn,1);}
void CDataWnd::OnLength   (){SetStyle( m_bOffsetOn,!m_bLengthOn, m_bAddressOn, m_bFixFontOn, m_bLinesOn, m_bAltLineOn,1);}
void CDataWnd::OnAdress   (){SetStyle( m_bOffsetOn, m_bLengthOn,!m_bAddressOn, m_bFixFontOn, m_bLinesOn, m_bAltLineOn,1);}
void CDataWnd::OnFixFont  (){SetStyle( m_bOffsetOn, m_bLengthOn, m_bAddressOn,!m_bFixFontOn, m_bLinesOn, m_bAltLineOn,1);}
void CDataWnd::OnLines    (){SetStyle( m_bOffsetOn, m_bLengthOn, m_bAddressOn, m_bFixFontOn,!m_bLinesOn, m_bAltLineOn,1);}
void CDataWnd::OnAlternate(){SetStyle( m_bOffsetOn, m_bLengthOn, m_bAddressOn, m_bFixFontOn, m_bLinesOn,!m_bAltLineOn,1);}
void CDataWnd::OnDelModul (){DeleteModul();}

//*****************************************************************************
//*
//*		OnCopyMouse();
//*
//*****************************************************************************
//	Ein einzelnes Feld kopieren via Mauseingabe
void CDataWnd::OnCopyMouse()
{
	Copy(1);
}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
LRESULT CDataWnd::OnCopy(WPARAM wParam,LPARAM lParam)
{
	Copy(0);

return 0;
}

//*****************************************************************************
//*
//*		Copy
//*
//*****************************************************************************
//	Kopiert ein Feld
//	iMode		: 0=Aktuelles Fels  1=via Maus
//	Ergibt 1 wenn etwas kopiert wurde.
int CDataWnd::Copy(int iMode)
{
char			cBuffer[32];
CFastListCtrl  *pListCtrl;
TCHAR		   *pText1;
TCHAR		   *pText2;
ScanData	   *pScan;
CString			sText;
int				iBits;
int				iLen1;
int				iLen2;
int				iNum;
int				iOff;
int				iCol;


	pListCtrl = &m_aListWnd[m_iScanSel];


	if(iMode==1)									// Mit Mausklick
		{
		   iNum=pListCtrl->HitTest(m_sContextPt);
		if(iNum<0)return 0;

		iOff = pListCtrl->GetColumnWidth(0);

		for(iCol=0;iCol<4;)
			{
			if(m_sContextPt.x<iOff)break;

			iCol += 1;
			iOff += pListCtrl->GetColumnWidth(iCol);
			}

		iBits = 1<<iCol;
		}
	else{											// Aktuelles Feld
		   iNum=pListCtrl->GetFocusItem();
		if(iNum<0)return 0;

		iNum  = pListCtrl->GetItemData(iNum)&0x3FFF;
		iBits = 3;

		if(m_bOffsetOn )iBits|=1<<2;
		if(m_bLengthOn )iBits|=1<<3;
		if(m_bAddressOn)iBits|=1<<4;
		}


	iNum = pListCtrl->GetItemData(iNum)&0x3FFF;


		pScan=m_sScanner.Data(m_iScanSel,iNum,&pText1,&pText2,&iLen1,&iLen2);
	if(!pScan)return 0;

	if((iBits&0x01) && pText1)
		{
		sText += pText1;
		}

	if((iBits&0x02) && pText2)
		{
		if(!sText.IsEmpty())sText+=_T("\t");
		sText += pText2;
		}

	if(iBits&0x04)
		{
		if(!sText.IsEmpty())sText+=_T("\t");
		itostr(iLen1,cBuffer,1);
		sText += cBuffer;
		}

	if(iBits&0x08)
		{
		if(!sText.IsEmpty())sText+=_T("\t");
		itostr(iLen2,cBuffer,0x00201);
		sText += cBuffer;
		}

	if(iBits&0x10)
		{
		if(!sText.IsEmpty())sText+=_T("\t");
		qtostr(m_aMemAddr[m_iScanSel]+(LONGLONG)iLen1,cBuffer,0x00201);
		sText += cBuffer;
		}


return SetClipboardText(sText);
}

//*****************************************************************************
//*
//*		OnDelFromList
//*
//*****************************************************************************
//	Datei aus der Modulliste lschen
void CDataWnd::OnDelFromList()
{
TCHAR		cBuffer[MAX_PATH];
CListDlg	sDlg;
CRegKeys	sKey;
int			i;


	if(!sKey.Open())return;
	if(!sKey.Up(_T("DataWindow")))return;

	for(;;)
		{
		cBuffer[0]=0;
 		if(!sKey.Get(cBuffer,sizeof(cBuffer)/sizeof(TCHAR)))break;
		if(_tcsncmp(sKey.Name(),_T("List"),4))continue;
		sDlg.AddString(cBuffer);
		}

	if(!sDlg.GetCount())
		{
		MessageBox(_T("Es sind keine Module geladen !"),_T("Warnung"));
		return;
		}

	   sDlg.SetTitle(_T("Module lschen"));
	   sDlg.SetMode(3);
	   sDlg.Sort();
	   sDlg.AddSizeX(+40);
	   sDlg.AddSizeY(-40);
	if(sDlg.DoModal()!=IDOK)return;

	for(i=0;i<sDlg.GetCount();i++)
		{
		if(!sDlg.GetSelect(i))continue;
		DelFromList(sDlg.GetText(i));
		}

}


//*****************************************************************************
//*
//*		OnLastView
//*
//*****************************************************************************
//	Zurck auf letztes Fenster
void CDataWnd::OnLastView()
{

	if(m_iScanSel ==0)return;
	if(CDW_MAX<=1)return;

	SetSel(m_iScanSel-1);

}

//*****************************************************************************
//*
//*		OnNextView
//*
//*****************************************************************************
//	Vor auf nchstes Fenster
void CDataWnd::OnNextView()
{

	if(m_iScanSel+1>=CDW_MAX)return;

	SetSel(m_iScanSel+1);
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
//	Die Fenstergre wurde verndert
void CDataWnd::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int			iBorder;
int			iWidth;




	m_iSizeX = iSizeX;
	m_iSizeY = iSizeY;

	if(iSizeX<=0 || iSizeY<=0)return;

	if(m_iFlags&CDW_LABELS)										// Mit Label Fenster
		{
		iWidth  =  iSizeY-m_iScrollY-1;
		iBorder = (m_iFlags&CDW_LISTBORDER)? 1:0;

		if(iWidth<0)iWidth=0;

		if(m_iInit)
			{
			m_cLabelCtrl.SetChildRect(0,0     ,iSizeX,       iWidth);
			m_cLabelCtrl.MoveWindow  (0,iWidth,iSizeX,iSizeY-iWidth);
			m_cLabelCtrl.UpdateChildPos();
			}
		}
	else{
		if(m_iInit)												// Nur List Fenster
			{
			m_aListWnd[m_iScanSel].MoveWindow(0,0,iSizeX,iSizeY);
			}
		}


	m_iInit = 1;

}

//*****************************************************************************
//*
//*		ListProc
//*
//*****************************************************************************
LRESULT	CALLBACK CDataWnd::ListProc(WNDPROC pProc,HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,CWnd *pWnd)
{

	if(uMsg==WM_GETDLGCODE)
		{
		return DLGC_WANTALLKEYS;
		}

return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		OnClick
//*
//*****************************************************************************
void CDataWnd::OnClick(NMHDR *pNmHdr, LRESULT *pResult)
{
CFastListCtrl  *pListCtrl;
NM_LISTVIEW	   *pList;


	pListCtrl = &m_aListWnd[m_iScanSel];
	pList     = (NM_LISTVIEW*)pNmHdr;

	if(pList->uChanged<=7)return;								// Existiert eine Klappbox


	Expand(pList->iItem);

}

//*****************************************************************************
//*
//*		OnListview
//*
//*****************************************************************************
void CDataWnd::OnListview(NMHDR *pNmHdr, LRESULT *pResult)
{
CFastListCtrl  *pListCtrl;
NM_LISTVIEW	   *pList;
LV_KEYDOWN	   *pKeys;



	pListCtrl = &m_aListWnd[m_iScanSel];
	pList     = (NM_LISTVIEW*)pNmHdr;


//***************** Mausklick rechts ******************************************


	if(pNmHdr->code==NM_RCLICK)
		{
		CPoint	sPoint;
		CMenu	sMenu;
		CRect	sRect;

		GetWindowRect(&sRect);

		m_sContextPt.x	= pList->ptAction.x;
		m_sContextPt.y	= pList->ptAction.y;
		sPoint.x		= pList->ptAction.x+sRect.left;
		sPoint.y		= pList->ptAction.y+sRect.top;

		sMenu.CreatePopupMenu();

		sMenu.AppendMenu(MF_STRING,ID_CDW_COPY			,_T("Feld kopieren"			));
		sMenu.AppendMenu(MF_SEPARATOR												 );

	    if(!(m_iFlags&CDW_NOMODULDLG))
		{
		sMenu.AppendMenu(MF_STRING,ID_CDW_LOADMODUL		,_T("&Modul laden"			));
		sMenu.AppendMenu(MF_STRING,ID_CDW_LOADLIST		,_T("Modulliste &laden"		));
		sMenu.AppendMenu(MF_STRING,ID_CDW_DELETEMODUL	,_T("Module l&schen"		));
		sMenu.AppendMenu(MF_STRING,ID_CDW_ADDTOLIST		,_T("&Datei in Modulliste"	));
		sMenu.AppendMenu(MF_STRING,ID_CDW_DELFROMLIST	,_T("Datei a&us Modulliste"	));
		sMenu.AppendMenu(MF_SEPARATOR												 );
		}
		sMenu.AppendMenu(MF_STRING,ID_CDW_ADRESS_ON   	,_T("&Adressen anzeigen"	));
		sMenu.AppendMenu(MF_STRING,ID_CDW_LENGTH_ON		,_T("Ln&gen anzeigen"		));
		sMenu.AppendMenu(MF_STRING,ID_CDW_OFFSET_ON		,_T("&Offsets anzeigen"		));
		sMenu.AppendMenu(MF_STRING,ID_CDW_ALTLINE_ON	,_T("Abwechselnde Farben"   ));
		sMenu.AppendMenu(MF_STRING,ID_CDW_FIXFONT_ON	,_T("Fixe Schrift"			));
		sMenu.AppendMenu(MF_STRING,ID_CDW_LINES_ON		,_T("&Linien"				));
		sMenu.AppendMenu(MF_SEPARATOR												 );
		sMenu.AppendMenu(MF_STRING,ID_CDW_UPDATE		,_T("&Aktualisieren"		));
	    if(!(m_iFlags&CDW_NOPROPERTYS))
		sMenu.AppendMenu(MF_STRING,ID_CDW_PROPERTYS		,_T("&Eigenschaften"		));

		if(m_bAltLineOn)sMenu.CheckMenuItem(ID_CDW_ALTLINE_ON,MF_CHECKED);
		if(m_bFixFontOn)sMenu.CheckMenuItem(ID_CDW_FIXFONT_ON,MF_CHECKED);
		if(m_bAddressOn)sMenu.CheckMenuItem(ID_CDW_ADRESS_ON ,MF_CHECKED);
		if(m_bLengthOn )sMenu.CheckMenuItem(ID_CDW_LENGTH_ON ,MF_CHECKED);
		if(m_bOffsetOn )sMenu.CheckMenuItem(ID_CDW_OFFSET_ON ,MF_CHECKED);
		if(m_bLinesOn  )sMenu.CheckMenuItem(ID_CDW_LINES_ON  ,MF_CHECKED);

		sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
		sMenu.DestroyMenu();

		return;
		}


//***************** Doppelklick ***********************************************


	if(pNmHdr->code==NM_DBLCLK)
		{
		int			 iId;
		int			 iLen;
		int			 iNum;
		ScanData    *pScan;
		CFrameWnd	*pWnd;

		*pResult=1;

		if(pList->iItem<0)return;								// Ist Item im Bereich
		if(pList->iItem>=pListCtrl->GetItemCount())return;

		iNum = pListCtrl->GetItemData(pList->iItem)&0x3FFF;

			pScan=m_sScanner.Data(iNum);
		if(!pScan)return;

		iId  = GetWndId(this);
		iLen = pScan->iMemLen;
		pWnd = (CFrameWnd*)AfxGetMainWnd();

		if(iLen>0xFFFF)iLen=0;

		pWnd->GetActiveView()->PostMessage(WM_DATAWNDTAB|(iId&0x03FF),pScan->iMemOffG,iId|(iLen<<16));
		pWnd->                 PostMessage(WM_DATAWNDTAB|(iId&0x03FF),pScan->iMemOffG,iId|(iLen<<16));

		return;
		}


//***************** Tastendruck ***********************************************


	if(pNmHdr->code==NM_RETURN)
		{
		Expand(pListCtrl->GetFocusItem());
		return;
		}


	if(pNmHdr->code==LVN_KEYDOWN)
		{
		   pKeys=(LV_KEYDOWN*)pNmHdr;
		if(pKeys->wVKey==VK_RETURN)
			{
			Expand(pListCtrl->GetFocusItem());
			return;
			}

		if(pKeys->wVKey==VK_SPACE)
			{
			Expand(pListCtrl->GetFocusItem());
			return;
			}

		if(pKeys->wVKey==VK_INSERT)
			{
			if(GetAsyncKeyState(VK_CONTROL)&0x8000)Copy();
			return;
			}

		if(pKeys->wVKey=='C')
			{
			if(GetAsyncKeyState(VK_CONTROL)&0x8000)Copy();
			return;
			}

		if(pKeys->wVKey==VK_TAB)
			{
			int			 iId;
			int			 iNum;
			int			 iLen;
			ScanData    *pScan;
			CFrameWnd	*pWnd;

			iNum = pListCtrl->GetFocusItem();
			iNum = pListCtrl->GetItemData(iNum)&0x3FFF;

				pScan = m_sScanner.Data(iNum);
			if(!pScan)return;

			iId  = GetWndId(this);
			iLen = pScan->iMemLen;
			pWnd = (CFrameWnd*)AfxGetMainWnd();

			if(iLen>0xFFFF)iLen=0;

			pWnd->GetActiveView()->PostMessage(WM_DATAWNDTAB|(iId&0x03FF),pScan->iMemOffG,iId|(iLen<<16));
			pWnd->                 PostMessage(WM_DATAWNDTAB|(iId&0x03FF),pScan->iMemOffG,iId|(iLen<<16));

			return;
			}

		return;
		}

}

//*****************************************************************************
//*
//*		LineCallback
//*
//*****************************************************************************
//	Callback fr den Text der einzelnen Zeilen und Spalten
int CALLBACK CDataWnd::LineCallback(LPVOID pParam,LPARAM lItem,UINT uStart,UINT uEnd,FL_ENTRY *pEntries)
{
CDataWnd	*pThis=(CDataWnd*)pParam;
ScanData	*pScan;
LPTSTR		 pText1;
LPTSTR		 pText2;
int			 iLevel;
int			 iBits;
int		 	 iLen1;
int		 	 iLen2;
int			 iNum;
int		 	 iBox;
int			 iOff;
int			 iSel;
LONGLONG	 iAdr;




	iSel    =  pThis->m_iScanSel;
	iAdr    =  pThis->m_aMemAddr[iSel];
	iNum	=  lItem;

	iBox	= 0x0000C000&iNum;
	iBits	= 0xFFFF0000&iNum;
	iNum   &= 0x00003FFF;

		pScan=pThis->m_sScanner.Data(iSel,iNum,&pText1,&pText2,&iLen1,&iLen2);
	if(!pScan)return 0;

	if(uStart==0 && uStart<uEnd)
		{
		iOff = 0;

		   iLevel=pScan->iLevel;
		if(iLevel>8)iLevel=8;

		for(iBits>>=iLevel-1;iLevel>0;iLevel--,iBits<<=1)
			{
			switch(iBits&0x01010000)
				{
			case 0x00000000:									// Leerstelle

					pEntries->pText[iOff] = 0;
					iOff++;
					break;

			case 0x00010000:									// | Linie zeichnen

					pEntries->pText[iOff] = 1;
					iOff++;
					break;

			case 0x01000000:									// L Linien zeichnen

					pEntries->pText[iOff] = 2;
					iOff++;
					break;

			case 0x01010000:									// T Linien zeichnen

					pEntries->pText[iOff] = 3;
					iOff++;
					break;
				}
			}

		switch(iBox&0x0000F000)									// End-Abschlu
			{
		case 0x0000:											// Leerstelle
					pEntries->pText[iOff] = 0;
					iOff++;
					break;

		case 0x4000:											// - Linie
					pEntries->pText[iOff] = 4;
					iOff++;
					break;
		default:												// Box zeichnen

					if(pScan->iLevel)
						{
						if(iBox&0x4000)							// Plus Box	?
								pEntries->pText[iOff] = 20;
						else	pEntries->pText[iOff] = 14;
						}
					else{
						if(iBox&0x4000)							// Plus Box ?
								pEntries->pText[iOff] = 23;
						else	pEntries->pText[iOff] = 13;
						}

					iOff++;
					break;
			}

		iOff += strlcpy(pEntries->pText+iOff,pText1,256-iOff,iLen1);
		pEntries->iSize = iOff;
		pEntries++;
		uStart++;
		}

	if(uStart==1 && uStart<uEnd)								// Offset zeichnen
		{
		pEntries->pText	= pText2;
		pEntries->iSize = iLen2;
		pEntries++;
		uStart++;
		}

	if(uStart==2 && uStart<uEnd)								// Offset zeichnen
		{
		pEntries->iSize = itostr(pScan->iMemOff-pThis->m_aMemOff[iSel],pEntries->pText,1);
		pEntries++;
		uStart++;
		}

	if(uStart==3 && uStart<uEnd)								// Lnge zeichnen
		{
		pEntries->iSize = itostr(pScan->iMemLen,pEntries->pText,1);
		pEntries++;
		uStart++;
		}

	if(uStart==4 && uStart<uEnd)								// Addresse zeichnen
		{
		pEntries->iSize = qtostr((LONGLONG)pScan->iMemOffG+iAdr,pEntries->pText,1);
		pEntries++;
		uStart++;
		}


return 1;
}

//*****************************************************************************
//*
//*		Expand
//*
//*****************************************************************************
//	Auf/Zu Klappen einer Zeile
//	iItem		: Ist Nummer  der Zeile
//	iMode		: Was mit dem Eintrag machen
// 					0 = Wechseln
//					1 : Expand
//					2 : Zuklappen
void CDataWnd::Expand(int iItem,int iMode)
{
CFastListCtrl  *pListCtrl;
ScanData       *pScnN;
ScanData       *pScan;
int				iChange;
int			 	iLevel;
int			 	iNumN;
int			 	iNumC;
int			 	iBits;
int		     	iBox;
int			 	iMax;
int			 	iNum;


	if(iItem<0)return;

	pListCtrl	= &m_aListWnd[m_iScanSel];
	iMax		= pListCtrl->GetItemCount();
	iBox		= pListCtrl->GetItemData(iItem);

	if(!(iBox&0x00008000))return;								// Keine Box

	iNum = iBox&0x00003FFF;

		pScan=m_sScanner.Data(iNum);
	if(!pScan)return;

	iLevel	= pScan->iLevel;
	iChange	= 0;

	if(iMode)
		{
		if(iMode==1 && !(iBox&0x4000))return;
		if(iMode==2 &&  (iBox&0x4000))return;
		}

	pListCtrl->SetItemData(iItem,iBox^0x4000);


	if(!(iBox&0x4000))											// Bereich schlieen
		{
		iItem++;
		for(;;) 												// Ebene lschen
			{
			if(iItem>=iMax)goto Exit;
			iNum=pListCtrl->GetItemData(iItem)&0x3FFF;
				pScan = m_sScanner.Data(iNum);
			if(!pScan || pScan->iLevel<=iLevel)goto Exit;		// Ende der Ebene ?
			pListCtrl->DeleteItem(iItem);
			iChange=1;
			iMax--;
			}
		}

	if(iLevel>=8)												// Maximale Tiefe erreicht ?
		{
		goto Exit;
		}

	iBits = (iBox&0x007F0000)<<1;

	iItem ++;													// Bereich ffnen
	iLevel++;

	iNumN = iNum+1;
	pScnN = m_sScanner.Data(iNum+1);

	iNum++;

	while(iNum++)												// Nchste Ebene einlesen
		{
		pScan   = pScnN;
		pScnN   = m_sScanner.Data(iNum);
		iBox	= iBits|0x01014000;								// T-Linie
		iNumC	= iNumN;
		iNumN	= iNum;

		while(pScnN && pScnN->iLevel>iLevel)					// Ebene berspringen
			{
			iNum++;
			iNumN = iNum;
			pScnN = m_sScanner.Data(iNum);
			iBox  = iBits|0x0101C000;							// Plus Box + T-Linie
			}

		if(!pScan || pScan->iLevel<iLevel)break;				// Ende der Ebene
		if(!pScnN || pScnN->iLevel<iLevel)iBox^=0x00010000;		// L Linie

		pListCtrl->InsertItem(iItem,iBox|iNumC);
		iChange = 1;
		iItem++;
		}

Exit:

	if(iChange)RedrawWindow();


}


//*****************************************************************************
//*
//*		MaxLines
//*
//*****************************************************************************
//	Einstellen der maximalen Zahl an Linien im DadenFenster (0-16000)
//	Ergibt den alten Wert
int CDataWnd::MaxLines(int iLines)
{


	if(iLines<0    )iLines=0;
	if(iLines>16000)iLines=16000;

	int alt=m_iMaxLines;
			m_iMaxLines=iLines;


return alt;
}

//*****************************************************************************
//*
//*		SetStyle
//*
//*****************************************************************************
//	Stellt die Anzeig in den Fenstern ein
//	-1 = Wert bei behalten
//	Ergibt 1 bei einer Vernderung
BOOL CDataWnd::SetStyle(DWORD dwFlags,BOOL bRedraw)
{

	return SetStyle(dwFlags&CDW_OFFSET_ON,
					dwFlags&CDW_LENGTH_ON,
					dwFlags&CDW_ADDRES_ON,
					dwFlags&CDW_FIXEDFONT,
					dwFlags&CDW_LISTLINES,bRedraw);



}

//*****************************************************************************
//*
//*		SetStyle
//*
//*****************************************************************************
//	Stellt die Anzeig in den Fenstern ein
//	iOff		: Offsets  anzeigen (-1 = keine nderung)
//	iLen		: Lngen   anzeigen (-1 = keine nderung)
//	iAdr		: Adressen anzeigen (-1 = keine nderung)
//	iFix		: Fixe Schrift      (-1 = keine nderung)
//	iLin		: Linien   anzeigen (-1 = keine nderung)
//	iAlt		: Linien   anzeigen (-1 = keine nderung)
//	bRedraw		: Fenster neu zeichnen
//	Ergibt 1 bei einer Vernderung
BOOL CDataWnd::SetStyle(int iOff,int iLen,int iAdr,int iFix,int iLin,int iAlt,BOOL bRedraw)
{
BOOL		bNewSize;
BOOL		bDrawNew;
HFONT		hFont;
int			iFlag;
int			i;


	bDrawNew = 0;
	bNewSize = 0;

	if(iOff==-1)iOff=m_bOffsetOn;
	if(iLen==-1)iLen=m_bLengthOn;
	if(iAdr==-1)iAdr=m_bAddressOn;
	if(iFix==-1)iFix=m_bFixFontOn;
	if(iAlt==-1)iAlt=m_bAltLineOn;
	if(iLin==-1)iLin=m_bLinesOn;

	iOff = (iOff)? 1:0;
	iLen = (iLen)? 1:0;
	iAdr = (iAdr)? 1:0;
	iFix = (iFix)? 1:0;
	iLin = (iLin)? 1:0;

	if(m_bOffsetOn!=iOff)
		{
		for(i=0;i<CDW_MAX;i++)m_aListWnd[i].FixColumnSize(2,!iOff,(iOff)? LVCF_LASTSIZE:0,(m_iInit)? 0:1);
		bDrawNew=1;
		bNewSize=1;
		}

	if(m_bLengthOn!=iLen)
		{
		for(i=0;i<CDW_MAX;i++)m_aListWnd[i].FixColumnSize(3,!iLen,(iLen)? LVCF_LASTSIZE:0,(m_iInit)? 0:1);
		bDrawNew=1;
		bNewSize=1;
		}

	if(m_bAddressOn!=iAdr)
		{
		for(i=0;i<CDW_MAX;i++)m_aListWnd[i].FixColumnSize(4,!iAdr,(iAdr)? LVCF_LASTSIZE:0,(m_iInit)? 0:1);
		bDrawNew=1;
		bNewSize=1;
		}

	if(m_bFixFontOn!=iFix)
		{
		hFont = (iFix)? m_hTextFix:m_hTextVar;
		for(i=0;i<CDW_MAX;i++)m_aListWnd[i].SetFont(CFont::FromHandle(hFont));
		}

	if(m_bLinesOn!=iLin || m_bAltLineOn!=iAlt)
		{
				iFlag =LVS_EX_FULLROWSELECT;
		if(iAlt)iFlag|=LVS_EX_ALTERNATECOLOR;
		if(iLin)iFlag|=LVS_EX_GRIDLINES;

		for(i=0;i<CDW_MAX;i++)
			{
			m_aListWnd[i].SetExtendedStyle(iFlag);
			}
		}

	m_bOffsetOn	 = iOff;
	m_bLengthOn	 = iLen;
	m_bAddressOn = iAdr;
	m_bFixFontOn = iFix;
	m_bAltLineOn = iAlt;
	m_bLinesOn	 = iLin;

	if(m_iInit && bRedraw)
		{
		if(bNewSize)OnSize(0,m_iSizeX,m_iSizeY);
		if(bDrawNew)m_aListWnd[m_iScanSel].RedrawItems(0,16000);
		}



return bDrawNew||bNewSize;
}

//*****************************************************************************
//*
//*		PropertyDlg
//*
//*****************************************************************************
//	Anzeige Typ fr das aktuelle Fenster mit Dialog einstellen
//	Ergibt 1 wen nderungen vorhanden sind
void CDataWnd::OnPropertyDlg(){PropertyDlg();}
int  CDataWnd::PropertyDlg()
{
CDataBarDlg	sDlg;
int		bDrawNew=0;


	sDlg.m_pScanner		= &m_sScanner;							// Initialisierung
	sDlg.m_aMemOff		=  m_aMemOff[m_iScanSel];
	sDlg.m_aMemLen		=  m_aMemLen[m_iScanSel];
	sDlg.m_bOffsetOn	=  m_bOffsetOn;
	sDlg.m_bAddressOn	=  m_bAddressOn;
	sDlg.m_bLengthOn	=  m_bLengthOn;
	sDlg.m_bFixFontOn	=  m_bFixFontOn;
	sDlg.m_bLinesOn		=  m_bLinesOn;
	sDlg.m_iMaxLines	=  m_iMaxLines;
	sDlg.m_aBlockNum	=  m_aBlockNum[m_iScanSel];
	sDlg.m_aModulNum	=  m_aModulNum[m_iScanSel];

	if(sDlg.DoModal()!=IDOK)return 0;


	if(SetStyle(sDlg.m_bOffsetOn ,sDlg.m_bLengthOn,
				sDlg.m_bAddressOn,sDlg.m_bFixFontOn,
				sDlg.m_bAltLineOn,sDlg.m_bLinesOn,0))bDrawNew=2;

	if((m_aMemOff  [m_iScanSel] != sDlg.m_aMemOff  )||			// Neu ReadData ?
	   (m_aMemLen  [m_iScanSel] != sDlg.m_aMemLen  )||
	   (m_iMaxLines		        != sDlg.m_iMaxLines)||
	   (m_aBlockNum[m_iScanSel] != sDlg.m_aBlockNum)||
	   (m_aModulNum[m_iScanSel] != sDlg.m_aModulNum))
		{
		m_aMemOff  [m_iScanSel]	= sDlg.m_aMemOff;
		m_aMemLen  [m_iScanSel]	= sDlg.m_aMemLen;
		m_iMaxLines				= sDlg.m_iMaxLines;
		m_aBlockNum[m_iScanSel]	= sDlg.m_aBlockNum;
		m_aModulNum[m_iScanSel]	= sDlg.m_aModulNum;

		if(m_iFlags&CDW_BLOCKNAMES)
			{
			SetText(m_iScanSel,m_sScanner.BlockName(m_aBlockNum[m_iScanSel]));
			}

		if(m_aMemOff[m_iScanSel]+  m_aMemLen[m_iScanSel]>m_aMemMax[m_iScanSel])
		   m_aMemLen[m_iScanSel]=  m_aMemMax[m_iScanSel]-m_aMemOff[m_iScanSel];
		if(m_aMemLen[m_iScanSel]<0)m_aMemLen[m_iScanSel]=0;

		ReadData(false);
		}

	if(bDrawNew&1)m_aListWnd[m_iScanSel].RedrawItems(0,16000);	// Fenster neuzeichnen
	if(bDrawNew&2){OnSize(0,m_iSizeX,m_iSizeY);RedrawWindow();}

	return bDrawNew;
}

//*****************************************************************************
//*
//*		SetSel
//*
//*****************************************************************************
//	Schaltet um auf ein anderse Fenster (0 bis CDW_MAX)
//	Ergibt die Nummer des alten Fensters
int CDataWnd::SetSel(int iNum)
{

	if(iNum>=m_iCount)iNum=m_iCount-1;
	if(iNum< 0       )iNum=0;
	if(iNum==m_iScanSel)return m_iScanSel;


	if(m_iFlags&CDW_LABELS)m_cLabelCtrl.SetSel(iNum);

	m_iScanSel=iNum;
	m_sScanner.SetScanner(m_iScanSel);

	OnSize(0,m_iSizeX,m_iSizeY);

	if(m_iInit)
		{
		m_aListWnd[m_iScanSel].RedrawWindow();
		}


return m_iScanSel;
}

//*****************************************************************************
//*
//*		SetCount
//*
//*****************************************************************************
//	Anzahl der Scanner einstellen
//	Ergibt die alte Anzahl
int CDataWnd::SetCount(int  iScanner)
{
TCHAR	cBuffer[16];
int		i,iOld;


	if(iScanner > CDW_MAX)iScanner=CDW_MAX;
	if(iScanner < 1      )iScanner=1;
	if(iScanner==m_iCount)return iScanner;

	iOld=m_iCount;
		 m_iCount=iScanner;

	_tcscpy(cBuffer,_T("Daten "));

	if(m_iScanSel>=iScanner)SetSel(0);

	for(i=iScanner;i<m_iCount;i++)						// berzhlige lschen
		{
		m_sScanner.DeleteScan(i);
		m_aMemAddr[i]=0;
		m_aMemOff [i]=0;
		m_aMemLen [i]=0;
		m_aMemMax [i]=0;
		m_aMemPtr [i]=0;
		}

	for(;i<m_iCount;i++)								// Neue Texte
		{
		_itot(i+1,cBuffer+6,10);
		SetText(i,cBuffer);
		}

	if(m_iFlags&CDW_LABELS)
		{
		m_cLabelCtrl.SetCount(m_iCount);
		}


return iOld;
}

//*****************************************************************************
//*
//*		LoadList
//*
//*****************************************************************************
//	Lade Module aus einer Modul Liste
//  Es wird vom folgendem Pfad geladen
//					"HKEY_CURRENT_USER" + "Software"  +
//					AfxGetApp()->m_pszRegistryKey     +
//					AfxGetApp()->m_pszAppName         + pRegKey
//	Ergibt Anzahl der geladenen Module
int CDataWnd::LoadList(LPCTSTR pRegKey)
{
TCHAR		cBuffer[MAX_PATH];
CRegKeys	sKey;
int			iCnt;


	iCnt=0;

	if(!sKey.Open     ())return 0;
	if(!sKey.Up(pRegKey))return 0;

	for(int i=0;;i++)
		{
		cBuffer[0]=0;

 		if(!sKey.Get(cBuffer,sizeof(cBuffer)/sizeof(TCHAR)))break;
		if(_tcsncmp(sKey.Name(),_T("List"),4))continue;
		if(LoadModul(cBuffer))iCnt++;
		}


return iCnt;
}

//*****************************************************************************
//*
//*		AddToList
//*
//*****************************************************************************
//	Module zur ModulListe hinzufgen
//	Ergibt 0 bei einem Fehler, 1 wenn bereits vorhanden, 2 wenn neu
int CDataWnd::AddToList(LPCTSTR pFile,LPCTSTR pRegKey)
{
CRegKeys	sKey;
TCHAR		cBuffer[MAX_PATH];
TCHAR		cFile  [MAX_PATH];
TCHAR		cName  [16]=_T("List   ");
int			iFree=-1;
int			iNum;


		sKey.Open();
	if(!sKey.Create(pRegKey))return 0;							// Pfade aus Registry

	GetFullPathName(pFile,sizeof(cFile)/sizeof(TCHAR),cFile,0);

	for(iNum=1;iNum<256;iNum++)
		{
		_itot(iNum,cName+4,10);
		cBuffer[0]=0;
																// Eintrag vorhanden
		if(!sKey.Get(cBuffer,sizeof(cBuffer)/sizeof(TCHAR),cName))
			{
			if(iFree==-1)iFree=iNum;
			continue;
			}

		if(!_tcsicmp(cFile,cBuffer))return 1;
		}
																// Neue Nummer
	if(iFree!=-1)
		{
		_itot(iFree,cName+4,10);
		if(sKey.Set(cFile,cName))return 2;
		}


return 0;
}

//*****************************************************************************
//*
//*		DelFromList
//*
//*****************************************************************************
//	Modul aus der Liste lschen
//	Ergibt 0 bei einem Fehler, 1 wenn gelscht, 2 wenn nicht vorhanden
int CDataWnd::DelFromList(LPCTSTR pFile,LPCTSTR pRegKey)
{
CRegKeys	sKey;
TCHAR		cBuffer[MAX_PATH];
TCHAR		cFile  [MAX_PATH];
TCHAR		cName  [16]=_T("List   ");
int			iNum;


		sKey.Open();
	if(!sKey.Up(pRegKey))return 0;								// Pfade aus Registry

	GetFullPathName(pFile,sizeof(cFile)/sizeof(TCHAR),cFile,0);

	for(iNum=1;iNum<256;iNum++)
		{
		_itot(iNum,cName+4,10);

		cBuffer[0]=0;

		if(!sKey.Get(cBuffer,sizeof(cBuffer)/sizeof(TCHAR),cName))continue;
		if(!_tcsicmp(cFile,cBuffer))
			{
			sKey.Del(cName);
			return 1;
			}
		}

return 2;
}

//*****************************************************************************
//*
//*		LoadDlg
//*
//*****************************************************************************
//	Ein Modul ber einen Dialog laden
//	Ist iMode != 0 so wird es in die ModulListe eingefrht
void CDataWnd::LoadDlg(int iMode,LPCTSTR pRegKey)
{
CRegKeys	sKey;
TCHAR		cBuffer[MAX_PATH];
BOOL		iOk=1;



	sKey.Open();												// Start Pfad aus Registry
	cBuffer[0]=0;

	if(!sKey.Get(cBuffer,sizeof(cBuffer)/sizeof(TCHAR),_T("ModulPath")))
		{
		GetCurrentDirectory(sizeof(cBuffer)/sizeof(TCHAR),cBuffer);
		};

	AddBackSlash(cBuffer);
	strlcat(cBuffer,_T("*.dfm"),sizeof(cBuffer)/sizeof(TCHAR));



//*****************************************************************************
POSITION	iPos;
CString		sName;
TCHAR		cMemory[8192];
CFileDialog	sDlg(TRUE,_T("*.dfm"),cBuffer,OFN_ALLOWMULTISELECT,_T("Daten Fenster Module (*.dfm)|*.dfm|Alle Dateien (*.*)|*.*|"));


	strlcpy(cMemory,sDlg.m_ofn.lpstrFile,sizeof(cMemory)/sizeof(TCHAR));
	sDlg.m_ofn.lpstrFile = cMemory;
	sDlg.m_ofn.nMaxFile  = sizeof(cMemory)/sizeof(TCHAR);

	if(sDlg.DoModal()!=IDOK)return;

	iPos=sDlg.GetStartPosition();						// Module laden

	while(iPos)
		{
		   sName=sDlg.GetNextPathName(iPos);
		if(sName.GetLength()<0)continue;
		if(iMode)AddToList(sName,pRegKey);
		LoadModul(sName);
		}

	if(iOk)											// Pfad registrieren
		{
		strlcpy(cBuffer,sName,sizeof(cBuffer)/sizeof(TCHAR));
		GetFileName(cBuffer)[0]=0;
		sKey.Set(cBuffer,_T("ModulPath"));
		}

}

//*****************************************************************************
//*
//*		LoadModul
//*
//*****************************************************************************
//	Ein Modul laden
BOOL CDataWnd::LoadModul(LPCTSTR pFile,LPCTSTR pName)
{
CDataBarErrorDlg	sDlg;
CTextBuffer			sInput;
int					iErrMode;
int					i;



	iErrMode = MB_ICONERROR|MB_YESNO;


	sInput.OpenMem();											// Load Fehler Aufzeichnung
	m_sScanner.ErrorOut(&sInput);

	if(m_sScanner.LoadModul(pFile,pName))						// Modul laden
		{
		if(m_sScanner.Errors())
			{
			TCHAR	cBuffer[MAX_PATH+100];

			_stprintf(cBuffer,_T("Modul %s ist fehlerhaft\nFehler anzeigen ?"),pFile);
			i=MessageBox(cBuffer,0,iErrMode);
			if(i==IDYES)
		 		{
				sDlg.m_sTitle.Format(_T("Modulfehler in %s"),GetFileName(pFile));
				sDlg.m_pText = (LPTSTR)sInput.Buffer();
				sDlg.DoModal();
				}
			}

		for(i=0;i<CDW_MAX;i++)									// Nummern initialisieren
			{
			if(m_aModulNum[i]==-1)m_aModulNum[i]=0;
			if(m_aBlockNum[i]==-1)
				{
				m_aBlockNum[i]=0;
				if(m_iFlags&CDW_BLOCKNAMES)SetText(i,m_sScanner.BlockName(m_aBlockNum[i]));
				}
			}

		delete sInput.Buffer();
		return TRUE;
		}
	else{
		TCHAR	cBuffer[MAX_PATH+100];

		_stprintf(cBuffer,_T("Modul %s konnte nicht geladen werden !\nFehler anzeigen ?"),pFile);

		   i=MessageBox(cBuffer,0,iErrMode);
		if(i==IDYES)
			{
			sDlg.m_sTitle.Format(_T("Modulfehler in %s"),GetFileName(pFile));
			sDlg.m_pText = (LPTSTR)sInput.Buffer();
			sDlg.DoModal();
			}
		}


	delete	sInput.Buffer();


return	FALSE;
}

//*****************************************************************************
//*
//*		SetMem
//*
//*****************************************************************************
//	Speicher fr das Fenster iNum einstellen
//	Ist iNum<0 wird das aktuelle genommen
//	pMem		: Zeiger fr den Speicher
//	iMax		: Gre des Speichers
//	iOff		: Begin des auszulesenden Bereiches im Speichers
//	iLen		: Gre des auszulesenden Bereiches im Speichers
//	iAdr		: Adresse des ersten Bytes in Men (nur fe Anzeige)
void CDataWnd::SetMem(char *pMem,int iMax,int iOff,int iLen,LONGLONG iAdr,int iNum)
{
BOOL	bNew=FALSE;


	if(iNum>=CDW_MAX)return;
	if(iNum<0)iNum =m_iScanSel;
	if(iMax<0)iMax=0;
	if(iOff<0)iOff=0;
	if(iOff+iLen>=iMax)iLen=iMax-iOff;
	if(iLen<0)iLen=0;


	if(m_aMemPtr [iNum]!=pMem){bNew=true;m_aMemPtr [iNum]=pMem;}
	if(m_aMemMax [iNum]!=iMax){bNew=true;m_aMemMax [iNum]=iMax;}
	if(m_aMemOff [iNum]!=iOff){bNew=true;m_aMemOff [iNum]=iOff;}
	if(m_aMemLen [iNum]!=iLen){bNew=true;m_aMemLen [iNum]=iLen;}
	if(m_aMemAddr[iNum]!=iAdr){bNew=true;m_aMemAddr[iNum]=iAdr;}

	if(bNew)ReadData(true,iNum);
}


//*****************************************************************************
//*
//*		ReadData
//*
//*****************************************************************************
//	Ein Daten des Fensters iNum neu in die Zeilen einlesen
//	Ist iNum < 0 so wird das aktuelle Fenster benutzt
//	Der Speicher muss zuvor mit  MemSet(...) eingestellt werden
//	Ist bRedraw!=0 wird das Fenster neu gezeichnet
void CDataWnd::ReadData(BOOL bRedraw,int iNum)
{
ScanData   *pScnN;
ScanData   *pScan;
int			iPos;
int			iBox;
int			iCnt;
int			i;




	if(iNum>=CDW_MAX)return;
	if(iNum<0)iNum=m_iScanSel;

	if(!m_aMemPtr[iNum] || m_aMemLen[iNum]<0)					// Kein Speicher
		{
		m_sScanner.DeleteScan();
		if(m_iInit && bRedraw)m_aListWnd[m_iScanSel].RedrawItems(0,16000);
		return;
		}

	if(IsBadReadPtr(m_aMemPtr[iNum],m_aMemMax[iNum]))			// Speicher prfen
		{
		m_aMemPtr [iNum]=0;
		m_aMemMax [iNum]=0;
		m_aMemAddr[iNum]=0;
		m_aMemLen [iNum]=0;
		m_aMemOff [iNum]=0;
		m_sScanner.DeleteScan();

		if(m_iInit && bRedraw)
			{
			m_aListWnd[m_iScanSel].RedrawItems(0,16000);
			}

		return;
		}

	if(m_aBlockNum[iNum]<0)										// Falsche Blocknummer
		{
		m_aBlockNum[iNum]=0;

		if(m_iFlags&CDW_BLOCKNAMES)
			{
			SetText(iNum,m_sScanner.BlockName(0));
			}
		}

		 m_sScanner.DeleteScan();
		 m_sScanner.Scan(m_aMemPtr[iNum],m_aMemMax[iNum],m_aBlockNum[iNum],m_iMaxLines,m_aMemOff[iNum]);
	iCnt=m_sScanner.Count();

	m_aListWnd[iNum].DeleteAllItems( );

	pScnN=m_sScanner.Data(0);

	for(i=0,iPos=0;i<iCnt;i++)									// Scan Linien einlesen
		{
		pScan    = pScnN;
		pScnN    = m_sScanner.Data(i+1);
		iBox     =(pScnN && pScnN->iLevel)? 0xC000:0x0000;

		if(pScan->iLevel)continue;

		if(m_iInit)
			{
			m_aListWnd[iNum].InsertItem(iPos,iBox|i);
			}

		iPos++;
		}


	if(m_iInit && bRedraw && iNum==m_iScanSel)
		{
		m_aListWnd[m_iScanSel].RedrawItems(0,16000);
		}
}


//*****************************************************************************
//*
//*		SaveConfig
//*
//*****************************************************************************
//	Speichere Konfiguration
//  Es wird vom folgendem Pfad geladen
//					"HKEY_CURRENT_USER" + "Software"  +
//					AfxGetApp()->m_pszRegistryKey     +
//					AfxGetApp()->m_pszAppName         + pRegKey
//	Ergibt 1 wenn gefunden
int CDataWnd::SaveConfig(LPCTSTR pRegKey)
{
TCHAR		cBlock[16]=_T("Blockname   ");
TCHAR		cNameM[16]=_T("Modulname   ");
TCHAR	   *pBlock;
TCHAR	   *pModul;
CRegKeys	sKey;
int			iFlag;
int			i;



	if(!sKey.Open     ())return 0;
	if(!sKey.Up(pRegKey))return 0;


	for(i=0;i<m_iCount;i++)
		{
		_itot(i+1,cBlock+9,10);
		_itot(i+1,cNameM+9,10);

		pBlock=m_sScanner.BlockName(m_aBlockNum[i]);
		pModul=m_sScanner.ModulName(m_aModulNum[i]);

		if(!pBlock)pBlock=_T("");
		if(!pModul)pModul=_T("");

		sKey.Set(pModul,cNameM);
		sKey.Set(pBlock,cBlock);
		}

	iFlag=0;

	if(m_bOffsetOn )iFlag|=CDW_OFFSET_ON;
	if(m_bLengthOn )iFlag|=CDW_LENGTH_ON;
	if(m_bAddressOn)iFlag|=CDW_ADDRES_ON;
	if(m_bFixFontOn)iFlag|=CDW_FIXEDFONT;
	if(m_bLinesOn  )iFlag|=CDW_LISTLINES;

	sKey.Set(iFlag,_T("Style"));



return 1;
}

//*****************************************************************************
//*
//*		LoadConfig
//*
//*****************************************************************************
//	Lade Konfiguration
//  Es wird vom folgendem Pfad geladen
//					"HKEY_CURRENT_USER" + "Software"  +
//					AfxGetApp()->m_pszRegistryKey     +
//					AfxGetApp()->m_pszAppName         + pRegKey
//	Ergibt 1 wenn gefunden
int CDataWnd::LoadConfig(LPCTSTR pRegKey)
{
CRegKeys	sKey;
TCHAR		pBlock[64],pModul[64];
TCHAR		cBlock[16]=_T("Blockname   ");
TCHAR		cNameM[16]=_T("Modulname   ");
int			i,iFlag,iNumB,iNumM,iExit=0;


	if(!sKey.Open(0,CRK_READ))return 0;
	if(!sKey.Up(pRegKey     ))return 0;


	for(i=0;i<m_iCount;i++)
		{
		_itot(i+1,cBlock+9,10);
		_itot(i+1,cNameM+9,10);

		if(!sKey.Get(pModul,sizeof(pModul)/sizeof(TCHAR),cNameM))continue;
		if(!sKey.Get(pBlock,sizeof(pBlock)/sizeof(TCHAR),cBlock))continue;

		iNumM = m_sScanner.ModulNumber(pModul      );
		iNumB = m_sScanner.BlockNumber(pBlock,iNumM);

		if(iNumB>=0)											// Ist Blocknummer iOk ?
			{
			m_aBlockNum[i] = iNumB;
			m_aModulNum[i] = iNumM;

			if(m_iFlags&CDW_BLOCKNAMES)
				{
				SetText(i,m_sScanner.BlockName(m_aBlockNum[i]));
				}
			}
		}


	if(sKey.Get(iFlag,_T("Style")))
		{
		SetStyle(iFlag);
		iExit|=1;
		}



return iExit;
}


//*****************************************************************************
//*
//*
//*		Dialoge
//*
//*
//*****************************************************************************

#define		IDC_COMBO1	1042
#define 	IDC_COMBO2	1049
#define		IDC_CHECK1	1043
#define		IDC_CHECK2	1044
#define		IDC_CHECK3	1045
#define		IDC_CHECK4	1046
#define		IDC_CHECK5	1097
#define		IDC_EDIT1 	1055
#define		IDC_EDIT2 	1075
#define		IDC_EDIT3 	1077


WORD CDataBarErrorDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0002,0x0000,0x0000,0x00FC,0x00AA,0x0000,0x0000,0x004D,0x006F,0x0064,0x0075,0x006C,
	0x0020,0x0046,0x0065,0x0068,0x006C,0x0065,0x0072,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,
	0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,0x0069,0x0096,0x0032,0x000E,
	0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x08C4,0x50B1,0x0000,0x0000,0x0005,0x0005,0x00F0,0x008C,
	0x041F,0xFFFF,0x0081,0x0000,0x0000,
	};

WORD CDataBarDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0011,0x0000,0x0000,0x00F2,0x009C,0x0000,0x0000,0x0044,0x0061,0x0074,0x0065,0x006E,
	0x0020,0x0046,0x0065,0x006E,0x0073,0x0074,0x0065,0x0072,0x0020,0x004F,0x0070,0x0074,0x0069,0x006F,0x006E,0x0065,
	0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,
	0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,0x00B4,0x000A,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,
	0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x00B4,0x001E,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,
	0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0080,0x5081,0x0000,0x0000,0x000F,0x000A,0x003C,0x000C,
	0x041F,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0080,0x5081,0x0000,0x0000,0x000F,0x0019,0x003C,0x000C,0x0433,0xFFFF,
	0x0081,0x0000,0x0000,0x0000,0x0080,0x5081,0x0000,0x0000,0x000F,0x0028,0x003C,0x000C,0x0435,0xFFFF,0x0081,0x0000,
	0x0000,0x0000,0x0103,0x5021,0x0000,0x0000,0x000F,0x0046,0x0064,0x0050,0x0412,0xFFFF,0x0085,0x0000,0x0000,0x0000,
	0x0103,0x5021,0x0000,0x0000,0x007D,0x0046,0x0069,0x0050,0x0419,0xFFFF,0x0085,0x0000,0x0000,0x0000,0x0003,0x5001,
	0x0000,0x0000,0x0014,0x005F,0x003E,0x000A,0x0413,0xFFFF,0x0080,0x004F,0x0066,0x0066,0x0073,0x0065,0x0074,0x0020,
	0x0041,0x006E,0x007A,0x0065,0x0069,0x0067,0x0065,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0014,0x0069,
	0x0043,0x000A,0x0414,0xFFFF,0x0080,0x004C,0x00E4,0x006E,0x0067,0x0065,0x006E,0x0020,0x0041,0x006E,0x007A,0x0065,
	0x0069,0x0067,0x0065,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0014,0x0073,0x0041,0x000A,0x0415,0xFFFF,
	0x0080,0x0041,0x0064,0x0072,0x0065,0x0073,0x0073,0x0020,0x0041,0x006E,0x007A,0x0065,0x0069,0x0067,0x0065,0x0000,
	0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0050,0x000C,0x0014,0x0008,0xFFFF,0xFFFF,0x0082,0x004F,0x0066,0x0066,
	0x0073,0x0065,0x0074,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0050,0x001B,0x0019,0x0008,0xFFFF,0xFFFF,
	0x0082,0x004C,0x00E4,0x006E,0x0067,0x0065,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x000F,0x003E,0x0018,0x0008,
	0xFFFF,0xFFFF,0x0082,0x004D,0x006F,0x0064,0x0075,0x006C,0x0065,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,
	0x007D,0x003C,0x0017,0x0008,0xFFFF,0xFFFF,0x0082,0x0042,0x006C,0x00F6,0x0063,0x006B,0x0065,0x0000,0x0000,0x0000,
	0x0000,0x5002,0x0000,0x0000,0x0050,0x002B,0x0034,0x0008,0xFFFF,0xFFFF,0x0082,0x004D,0x0061,0x0078,0x0069,0x006D,
	0x0061,0x006C,0x0065,0x0020,0x005A,0x0065,0x0069,0x006C,0x0065,0x006E,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,
	0x0014,0x007D,0x005F,0x000A,0x0416,0xFFFF,0x0080,0x0046,0x0069,0x0078,0x0065,0x0020,0x0053,0x0063,0x0068,0x0072,
	0x0069,0x0066,0x0074,0x007A,0x0065,0x0069,0x0063,0x0068,0x0065,0x006E,0x0062,0x0072,0x0065,0x0069,0x0074,0x0065,
	0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0014,0x0087,0x0056,0x000A,0x0449,0xFFFF,0x0080,0x004C,0x0069,0x006E,
	0x0069,0x0065,0x006E,0x0020,0x0069,0x006D,0x0020,0x0044,0x0061,0x0074,0x0065,0x006E,0x0066,0x0065,0x006E,0x0073,
	0x0074,0x0065,0x0072,0x0000,0x0000,
	};

//*****************************************************************************
//*
//*		Nachrichten
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CDataBarDlg, CDialog)
	//{{AFX_MSG_MAP(CDataBarDlg)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDataBarDlg::CDataBarDlg(CWnd *pParent)	: CDialog((UINT)0,pParent)
{

	//{{AFX_DATA_INIT(CDataBarDlg)
	m_bOffsetOn  = FALSE;
	m_bLengthOn  = FALSE;
	m_bAddressOn = FALSE;
	m_bFixFontOn = FALSE;
	m_bLinesOn   = FALSE;
	m_iMaxLines  = 0;
	m_aMemLen    = 0;
	//}}AFX_DATA_INIT

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CDataBarDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CDataBarDlg)
	DDX_Check(pDX, IDC_CHECK1, m_bOffsetOn);
	DDX_Check(pDX, IDC_CHECK2, m_bLengthOn);
	DDX_Check(pDX, IDC_CHECK3, m_bAddressOn);
	DDX_Check(pDX, IDC_CHECK4, m_bFixFontOn);
	DDX_Check(pDX, IDC_CHECK5, m_bLinesOn);
	DDX_Text (pDX, IDC_EDIT3 , m_iMaxLines);
	DDX_Text (pDX, IDC_EDIT2 , m_aMemLen);
	//}}AFX_DATA_MAP


	if(pDX->m_bSaveAndValidate)
		{
		TCHAR	cBuffer[16];

		m_pEdit->GetWindowText(cBuffer,sizeof(cBuffer)/sizeof(TCHAR));
		m_aMemOff = strtoi(cBuffer);
		}
}

//*****************************************************************************
//*
//*		OnSelchangeCombo2
//*
//*****************************************************************************
void CDataBarDlg::OnSelchangeCombo2()
{
int iNum;


	iNum        = m_pCombo2->GetCurSel();
	m_aBlockNum = m_pCombo2->GetItemData(iNum);


}

//*****************************************************************************
//*
//*		OnSelchangeCombo1
//*
//*****************************************************************************
void CDataBarDlg::OnSelchangeCombo1()
{
int iNum;


	iNum        = m_pCombo1->GetCurSel();
	m_aModulNum = m_pCombo1->GetItemData(iNum);

	LoadBlocks(m_aModulNum);

}


//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
INT_PTR CDataBarDlg::DoModal()
{
	return CDialog::DoModal();
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CDataBarDlg::OnInitDialog()
{
int		 i,iFrom,iTo,iCnt;
TCHAR	*pText,cBuffer[64];


	CDialog::OnInitDialog();


	m_pEdit   =(CEdit    *)GetDlgItem(IDC_EDIT1);				// Initialisierung
	m_pCombo1 =(CComboBox*)GetDlgItem(IDC_COMBO1);
	m_pCombo2 =(CComboBox*)GetDlgItem(IDC_COMBO2);
	m_pCombo1->ResetContent();
	m_pCombo2->ResetContent();
	m_pCombo1->LimitText(60);
	m_pCombo2->LimitText(60);
	m_pEdit  ->LimitText(15);


	iCnt=m_pScanner->ModulCount();								// Module einlesen
	if(m_aModulNum<0)m_aModulNum=0;

	for(i=0;i<iCnt;i++)
		{
		pText = m_pScanner->ModulName(i);
		iFrom = 0;
		iTo   = i-1;

		while(iFrom<=iTo)
			{
			m_pCombo1->GetLBText((iFrom+iTo)>>1,cBuffer);

			if(_tcsicmp(pText,cBuffer)<=0)
				 iFrom = ((iFrom+iTo)>>1)+1;
			else iTo   = ((iFrom+iTo)>>1)-1;
			}
		m_pCombo1->InsertString(iFrom,pText);
		m_pCombo1->SetItemData (iFrom,i);

		if(m_aModulNum==i)
			{
			m_pCombo1->SetCurSel(iFrom);
			}
		}


	LoadBlocks(m_aModulNum);									// Blcke einlesen

	itostr(m_aMemOff,cBuffer,1);								// Speicher Offset
	m_pEdit->SetWindowText(cBuffer);



return TRUE;
}


//*****************************************************************************
//*
//*		LoadBlocks
//*
//*****************************************************************************
void CDataBarDlg::LoadBlocks(int Modul)
{
int		 i,iNum,iFrom,iTo,iCnt,iPos;
TCHAR	*pText,cBuffer[64];




	m_pCombo2->ResetContent();									// Alle Blcke lschen
	if(Modul<0)return;

	iPos = m_pScanner->ModulStart(Modul);
	iCnt = m_pScanner->ModulEnd  (Modul)-iPos;

	for(i=0;i<iCnt;i++)											// Block namen laden
		{
		pText = m_pScanner->BlockName(iPos+i);
		iFrom = 0;
		iTo   = i-1;

		while(iFrom<=iTo)
			{
			m_pCombo2->GetLBText((iFrom+iTo)>>1,cBuffer);

			if(_tcsicmp(pText,cBuffer)<=0)
				 iFrom = ((iFrom+iTo)>>1)+1;
			else iTo   = ((iFrom+iTo)>>1)-1;
			}

		m_pCombo2->InsertString(iFrom,pText);
		m_pCombo2->SetItemData (iFrom,iPos+i);

		if(m_aBlockNum==iPos+i)
			{
			m_pCombo2->SetCurSel(iFrom);
			}
		}

	iNum		= m_pCombo1->GetCurSel();						// Modul Nummer
	m_aModulNum = m_pCombo1->GetItemData(iNum);
	iNum        = m_pCombo2->GetCurSel();						// Blocknummer
	m_aBlockNum	= m_pCombo2->GetItemData(iNum);

	if(m_aBlockNum<iPos || m_aBlockNum>=iPos+iCnt)
		{
		m_pCombo2->SetCurSel(0);
		}

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CDataBarDlg::OnOK()
{
int iNum;


	iNum        = m_pCombo1->GetCurSel();						// Modul Nummer
	m_aModulNum = m_pCombo1->GetItemData(iNum);
	iNum        = m_pCombo2->GetCurSel();						// Blocknummer
	m_aBlockNum = m_pCombo2->GetItemData(iNum);



CDialog::OnOK();
}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDataBarErrorDlg::CDataBarErrorDlg(CWnd *pParent) : CDialog((UINT)0, pParent)
{
	//{{AFX_DATA_INIT(CDataBarDlg)
	//}}AFX_DATA_INIT

	m_pText=_T("");

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);

}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CDataBarErrorDlg::OnInitDialog()
{

	if(m_sTitle!=_T(""))SetWindowText(m_sTitle);
	GetDlgItem(IDC_EDIT1)->SetWindowText(m_pText);


return CDialog::OnInitDialog();
}


