//*****************************************************************************
//*
//*
//*		EditEx.cpp
//*
//*
//*****************************************************************************
//
//	Ist eine MFC-Klasse die Edit-Fenster das Farben und dicker Schrift zu lst.
//
//	Fenster Styles:
//	
//		ES_LEFT             0x0000	Text links ausrichten	
//		ES_CENTER           0x0001	Text mittig ausrichten	
//		ES_RIGHT            0x0002	Text rects ausrichten	
//		ES_MULTILINE        0x0004	--- nicht untersttzt ---
//		ES_UPPERCASE        0x0008	--- nicht untersttzt ---
//		ES_LOWERCASE        0x0010	--- nicht untersttzt ---
//		ES_PASSWORD         0x0020	--- nicht untersttzt ---
//		ES_AUTOVSCROLL      0x0040	--- nicht untersttzt ---
//		ES_AUTOHSCROLL      0x0080	--- nicht untersttzt ---
//		ES_NOHIDESEL        0x0100	Textauswahl auch ohne Fokus anzeigen
//		ES_OEMCONVERT       0x0400	--- nicht untersttzt ---
//		ES_READONLY         0x0800	Es ist keine Texteingabe mglich
//		ES_WANTRETURN       0x1000	Die Tasten RET/TAB/ESC nia Notify melden
//		ES_NUMBER           0x2000	Nur die Eingabe von Ziffern ist mglich
//		ES_ALLOWDROP		0x4000	Dateien knnen auf das Control fallengelassen werden
//		ES_NOGRAYDISABLE	0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	
#include	<AfxPriv.h>
#include	"EditEx.h"
#include	"WinExtension.h"


//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
//	Erstellt ein neues CEditEx-Fenster. 
BOOL CEditEx::CreateEx(DWORD dwStyleEx,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID)
{
WNDPROC		   *pSuperProc;
WNDPROC			pOldProc;


														
	ASSERT(m_hWnd ==NULL);
	ASSERT(pParent!=NULL);
	ASSERT((dwStyle&WS_POPUP) == 0);

	if(!CWnd::CreateEx(dwStyleEx,_T("EDIT"),_T(""),dwStyle,sRect,pParent,nID,NULL))
		{
		return FALSE;
		}

	pSuperProc	= GetSuperWndProcAddr();				// Die neue Funktion zwischen MFC und WinApi hngen
	pOldProc	= *pSuperProc;
   *pSuperProc	= ColorEditProc;

			
	ColorEditProc(m_hWnd,WM_ATTACH,0,(LPARAM)pOldProc);	// Das Farbfenster initiallisieren 
	
	
	
return TRUE;
}

//*****************************************************************************
//*
//*		SubclassWindow
//*
//*****************************************************************************
//	Ein EditEx-Fenster an ein bestehendes Edit-Fenster andocken.
//	hWnd		: Ist das Fenster-Handle des bestehendes Edit-Fensters
//	Ergibt TRUE wenn erfolgreich bzw. FALSE bei einem Fehler.
BOOL CEditEx::SubclassWindow(HWND hWnd)
{
WNDPROC		   *pSuperProc;
WNDPROC			pOldProc;
BOOL			bOk;


	ASSERT(IsWindow(hWnd));

	#ifdef _DEBUG

	char 	cClass[32];
	DWORD	dwStyleEx;
	DWORD	dwStyle;

	GetClassNameA(hWnd,cClass,sizeof(cClass));
	ASSERT(!strcmp(cClass,"Edit"));

	dwStyle		= GetWindowLong(hWnd,GWL_STYLE  );
	dwStyleEx	= GetWindowLong(hWnd,GWL_EXSTYLE);
	
	ASSERT((dwStyle&ES_MULTILINE)==0);
	ASSERT((dwStyle&ES_ALLOWDROP)==0 || (dwStyleEx&WS_EX_ACCEPTFILES));

	#endif

		bOk=CEdit::SubclassWindow(hWnd);
	if(!bOk)return FALSE;

	pSuperProc	= GetSuperWndProcAddr();				// Die neue Funktion zwischen MFC und WinApi hngen
	pOldProc	= *pSuperProc;
   *pSuperProc	= ColorEditProc;

	ColorEditProc(m_hWnd,WM_ATTACH,0,(LPARAM)pOldProc);	// Das Farbfenster aktuallieren



return TRUE;
}

//*****************************************************************************
//*
//*		UnsubclassWindow
//*
//*****************************************************************************
//	Ein EditEx-Fenster vom bestehendes Fenster abdocken.
HWND CEditEx::UnsubclassWindow()
{
WNDPROC		   *pSuperProc;



	ASSERT(IsWindow(m_hWnd));

	pSuperProc = GetSuperWndProcAddr();					

	ASSERT(*pSuperProc==ColorEditProc);

	ColorEditProc(m_hWnd,EM_SYNCHWINDOW,0,0);				
														// Die vorherige MFC Funktion wieder einhngen
   *pSuperProc = (WNDPROC)ColorEditProc(m_hWnd,WM_DETACH,0,1);



return CEdit::UnsubclassWindow();
}

//*****************************************************************************
//*
//*		SetStyle
//*
//*****************************************************************************
//	Den Style der ComboBox einstellen
//	uStyle		: Ist der neue Style.
//					ES_LEFT             0x0000	Text links ausrichten	
//					ES_CENTER           0x0001	Text mittig ausrichten	
//					ES_RIGHT            0x0002	Text rects ausrichten	
//					ES_MULTILINE        0x0004	--- nicht untersttzt ---
//					ES_UPPERCASE        0x0008	--- nicht untersttzt ---
//					ES_LOWERCASE        0x0010	--- nicht untersttzt ---
//					ES_PASSWORD         0x0020	--- nicht untersttzt ---
//					ES_AUTOVSCROLL      0x0040	--- nicht untersttzt ---
//					ES_AUTOHSCROLL      0x0080	--- nicht untersttzt ---
//					ES_NOHIDESEL        0x0100	Textauswahl auch ohne Fokus anzeigen
//					ES_OEMCONVERT       0x0400	--- nicht untersttzt ---
//					ES_READONLY         0x0800	Es ist keine Texteingabe mglich
//					ES_WANTRETURN       0x1000	Die Tasten RET/TAB/ESC nia Notify melden
//					ES_NUMBER           0x2000	Nur die Eingabe von Ziffern ist mglich
//					ES_ALLOWDROP		0x4000	Dateien knnen auf das Control fallengelassen werden
//					ES_NOGRAYDISABLE	0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	uMask		: Welche Bits sollen gesetzt werden.
//	Ergubt den alten Style.
DWORD CEditEx::SetStyle(DWORD uStyle,DWORD uMask)
{
DWORD	uBits;
DWORD	uOld;


	ASSERT(::IsWindow(m_hWnd)); 

	uOld	=  GetWindowLong(m_hWnd,GWL_STYLE);
	uBits	= ~uMask&uOld;
	uBits  |=  uMask&uStyle;
	
	SetWindowLong(m_hWnd,GWL_STYLE,uBits);


return uOld;
}


