//*****************************************************************************
//*
//*
//*		EditEx.h
//*
//*
//*****************************************************************************
//
//	Ist eine MFC-Klasse die Edit-Fenster das Farben und dicker Schrift zu lst.
//
//	Fenster Styles:
//	
//		ES_LEFT             0x0000	Text links ausrichten	
//		ES_CENTER           0x0001	Text mittig ausrichten	
//		ES_RIGHT            0x0002	Text rects ausrichten	
//		ES_MULTILINE        0x0004	--- nicht untersttzt ---
//		ES_UPPERCASE        0x0008	--- nicht untersttzt ---
//		ES_LOWERCASE        0x0010	--- nicht untersttzt ---
//		ES_PASSWORD         0x0020	--- nicht untersttzt ---
//		ES_AUTOVSCROLL      0x0040	--- nicht untersttzt ---
//		ES_AUTOHSCROLL      0x0080	--- nicht untersttzt ---
//		ES_NOHIDESEL        0x0100	Textauswahl auch ohne Fokus anzeigen
//		ES_OEMCONVERT       0x0400	--- nicht untersttzt ---
//		ES_READONLY         0x0800	Es ist keine Texteingabe mglich
//		ES_WANTRETURN       0x1000	Die Tasten RET/TAB/ESC nia Notify melden
//		ES_NUMBER           0x2000	Nur die Eingabe von Ziffern ist mglich
//		ES_ALLOWDROP		0x4000	Dateien knnen auf das Control fallengelassen werden
//		ES_NOGRAYDISABLE	0x8000	Fenster nicht grau machen wenn es gesperrt ist
//	
#ifndef 	__EDITEX_H__
#define 	__EDITEX_H__

#include	<AfxWin.h>
#include	<AfxCmn.h>

#include	"ColorEditWnd.h"



//*****************************************************************************
//*
//*		Klasse CEditEx
//*
//*****************************************************************************
class CEditEx : public CEdit
{
public:
	
	BOOL	CreateEx		(DWORD dwStyleEx,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID);
	BOOL	Create			(DWORD                 dwStyle,const RECT &sRect,CWnd *pParent,UINT nID){return CreateEx(0,dwStyle,sRect,pParent,nID);}

	BOOL	ScrollHorz		(int iPos,BOOL bMode=FALSE)						{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SCROLL,(bMode)? 0x12340001:0x12340000,iPos);}
	BOOL	SetColor		(const LPBYTE pColor,int iSize=0xFFFF)			{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETCOLOR,iSize,(LPARAM)pColor);}
	BOOL	SetColorMode	(DWORD uMode)									{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETCOLORMODE,uMode,0);}
	BOOL	SetColorItem	(const LPCOLORREF pItem,int iCount,int iStart=0){ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETCOLORITEM,MAKELONG(iCount,iStart),(LPARAM)pItem);}
	BOOL	SetColorItem	(COLORREF uColor,int iIndex)					{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETCOLORITEM,MAKELONG(iIndex,1),(LPARAM)&uColor);}
	BOOL	SetImageList	(HIMAGELIST  hImageList)						{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETIMAGELIST,0,(LPARAM)hImageList);}
	BOOL	SetImageList	(CImageList *pImageList)						{                            return (BOOL   )  SetImageList(pImageList); }
	BOOL	SetImage		(int iImage)									{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETIMAGE,iImage,0);}
	BOOL	SetCallback		(ColorEditCb pProc,LPVOID pParam=0)				{ASSERT(::IsWindow(m_hWnd)); return (BOOL   )::SendMessage(m_hWnd,EM_SETCALLBACK,(WPARAM)pParam,(LPARAM)pProc);}
	LPCTSTR	GetText			()												{ASSERT(::IsWindow(m_hWnd)); return (LPCTSTR)::SendMessage(m_hWnd,EM_GETTEXTPTR,0,0);}
	INT		GetImage		()												{ASSERT(::IsWindow(m_hWnd)); return (INT    )::SendMessage(m_hWnd,EM_GETIMAGE,0,0);}
	LPBYTE	GetColors		()												{ASSERT(::IsWindow(m_hWnd)); return (LPBYTE )::SendMessage(m_hWnd,EM_GETCOLORPTR,0,0);}
	DWORD	GetStyle		()												{ASSERT(::IsWindow(m_hWnd)); return (DWORD  )::GetWindowLong(m_hWnd,GWL_STYLE);}		
	VOID	SynchWindow		()												{ASSERT(::IsWindow(m_hWnd));                 ::SendMessage(m_hWnd,EM_SYNCHWINDOW,0,0);}
	BOOL	SubclassWindow  (DWORD dwStyle,HWND  hWnd)						{ASSERT(::IsWindow(  hWnd));                 ::SetWindowLong(hWnd,GWL_STYLE,dwStyle);return SubclassWindow(hWnd);}
	BOOL	SubclassWindow  (              HWND  hWnd);
	DWORD	SetStyle		(DWORD uStyle ,DWORD uMask=0xFFFF);
	HWND	UnsubclassWindow();

};


#endif 	