//*****************************************************************************
//*
//*
//*		FastListCtrl.h
//*
//*
//*****************************************************************************
#ifndef 	__FASTLISTCTRL_H__
#define 	__FASTLISTCTRL_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	<AfxCmn.h>
#include	"FastListWnd.h"

class CHeaderCtrl;

#define 	ID_FASTLISTCTRL_DEF		0x971A

#ifndef	   _WIN64
#ifndef		DWORD_PTR
#define		DWORD_PTR				DWORD
#endif
#endif		


//*****************************************************************************
//*
//*		CFastListCtrl
//*
//*****************************************************************************
class CFastListCtrl : public CListCtrl
{

	DECLARE_DYNAMIC(CFastListCtrl)

public:

	CFastListCtrl(){};

	BOOL		 Create					(                DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nId=ID_FASTLISTCTRL_DEF);
	BOOL		 CreateEx				(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nId=ID_FASTLISTCTRL_DEF);
	BOOL		 Create  				(                DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId=ID_FASTLISTCTRL_DEF);
	BOOL		 CreateEx				(DWORD dwExStyle,DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId=ID_FASTLISTCTRL_DEF);
	int  		 InsertColumn  		 	(int nCol, LPCTSTR pColumnText, int nFormat=LVCFMT_LEFT,int nWidth=-1,int nMin=0x8000);
	int  		 InsertColumn  		 	(int nCol, const LV_COLUMN* pColumn );
	BOOL		 SetColumn     		 	(int nCol, const LV_COLUMN* pColumn );
	BOOL		 GetColumn     		 	(int nCol, LV_COLUMN* pColumn ) const;
	int			 GetColumnWidth		 	(int nCol) const;
	BOOL		 SetColumnWidth		 	(int nCol, int iWidth);
	BOOL		 SetColumnImage			(int nCol, int iImage  ,int iPlace=0);
	BOOL		 SetColumnBitmap		(int nCol, HBITMAP hBmp,int iPlace=0);
	BOOL		 SetColumnText		 	(int nCol, LPCTSTR pText);
	BOOL 		 SetColumnMark	 		(int nCol, BOOL bOn=TRUE);
	static int	 GetLineNumber			(FL_ENTRY *pEntry);
	BOOL 		 FixColumnSize	 		(int nCol, BOOL bOn=TRUE,int iWidth=-1,int iRecalc=-1);
	BOOL 		 DeleteColumn		 	(int nCol);
	BOOL 		 DeleteItems		 	(int iItem,unsigned uCount);
	INT 		 SetTopIndex			(int iItem);
	INT 		 GetSelectionCount		() const;
	INT 		 GetColumnCount			() const;
	CEdit	    *GetEditControl  		() const;
	CHeaderCtrl *GetHeaderCtrl		 	() const;
	CComboBox   *GetComboControl		() const;
	VOID		 GetEditControl			(HWND &hWnd) const;
	VOID		 GetHeaderCtrl		 	(HWND &hWnd) const;
	VOID		 GetComboControl		(HWND &hWnd) const;
	CEdit		*EditLabel			 	(INT iItem,int nCol=0,int iFull=0            ,int iSel=0);
	CComboBox	*EditLabelCb		 	(INT iItem,int nCol=0,int iFull=0,int iList=0,int iSel=0);
	CImageList  *CreateDragImage	 	(INT iItem,int nCol=0);
	CImageList  *SetImageList			(CImageList *pImageList,int nImageListType);
	HIMAGELIST	 SetImageList			(HIMAGELIST  hImageList,int nImageListType);
	BOOL		 SetItemData			(INT iItem,DWORD_PTR dwData);
	DWORD_PTR	 GetItemData			(INT iItem) const;
	DWORD		 GetStyle			 	() const;
	DWORD		 SetStyle			 	(DWORD dwStyle);
	DWORD		 SetStyle			 	(DWORD dwStyle,DWORD dwMask);
	DWORD		 GetExtendedStyle	 	() const;
	DWORD		 SetExtendedStyle	 	(DWORD dwStyle);
	DWORD		 SetExtendedStyle	 	(DWORD dwStyle,DWORD dwMask);
	DWORD		 SetEditClickMode		(DWORD dwMode);
	DWORD		 GetEditClickMode		() const;
	DWORD		 SetColorOffStates		(DWORD dwMode);
	DWORD		 GetColorOffStates		() const;
	DWORD		 SetStartOffset			(DWORD dwOffset);
	DWORD		 GetStartOffset			() const;
	HFONT		 SetCharFont2			(HFONT hFont);
	HFONT		 GetCharFont2   		() const;
	HFONT		 SetCharFont3   		(HFONT hFont);
	HFONT		 GetCharFont3   		() const;
	LPCOLORREF	 SetCharColors			(LPCOLORREF pColors);
	LPCOLORREF	 GetCharColors			() const;
	COLORREF	 GetColor			 	(int iIndex) const;
	COLORREF	 SetColor			 	(int iIndex ,COLORREF uColor);
	COLORREF	 GetItemBkColor		 	(INT iItem,int nCol=0) const;
	COLORREF	 GetItemTextColor	 	(INT iItem,int nCol=0) const;
	INT 		 IsItemVisible			(INT iItem,int nCol=0xFFFFFFFF);
	BOOL		 EnsureVisible		 	(INT iItem,int nCol);
	BOOL		 EnsureVisible		 	(INT iItem);
	BOOL		 SelectDropTarget	 	(INT iItem);
	BOOL		 SelectItem			 	(INT iItem,int nCol=0);
	BOOL		 StartEdit			 	(INT iItem,int nCol=0);
	BOOL		 DisableItemAutoEdit	(INT iItem,int nCol,BOOL bDisable=TRUE);
	BOOL		 GetItemRect		 	(INT iItem,int nCol,RECT *pRect,int iCode);
	BOOL		 GetItemRect		 	(INT iItem,		    RECT *pRect,int iCode);
	BOOL		 GetItemText		 	(INT iItem,int nCol,LPTSTR pBuffer,int iMax);
	LPCTSTR		 GetItemText		 	(INT iItem,                        int nCol=0);
	int 		 GetItemImageEx		 	(INT iItem                        ,int nCol=0);
	BOOL		 GetItemImageEx	     	(INT iItem,int *pImage            ,int nCol=0);
	BOOL		 SetColumnOrderArray	(int iCount,const int *pArray);
	BOOL		 GetColumnOrderArray	(int iCount,int       *pArray);
	BOOL		 SetItemCheckBox		(INT iItem,int iState,int nCol=0,UINT uMask=0x0F);
	INT			 GetItemCheckBox		(INT iItem		     ,int nCol=0,UINT uMask=0x0F);
	UINT 		 GetItemState        	(INT iItem,UINT nStateMask        ,int nCol=0);
	BOOL		 SetItemState        	(INT iItem,         UINT nState,UINT nStateMask);
	BOOL		 SetItemState        	(INT iItem,int nCol,UINT nState,UINT nStateMask);
	INT			 SetItemStates        	(INT iItem,INT iEnd,UINT nState,UINT nStateMask);
	BOOL		 SetItem			 	(INT iItem,int nCol,UINT nMask, LPCTSTR pText,int nImage,UINT nState=0,UINT nStateMask=0,LPARAM lParam=0);
	BOOL		 SetItem			 	(LVITEM   *pItem);
	BOOL		 SetFocusItem		 	(INT iItem,INT iCol=-1,BOOL bVisible=FALSE,BOOL bSelect=FALSE);
	BOOL		 SetFocusColumn		 	(          INT iCol   ,BOOL bVisible=FALSE,BOOL bSelect=FALSE);
	INT			 GetFocusItem		 	();
	INT			 GetFirstSelected	 	();
	INT			 GetNextSelected	 	(INT iItem);
	INT			 FindItem				(INT iItem,LVFIND *pFind);
	INT			 FindItem				(INT iItem,int     iFlags,int nCol,LPCTSTR pText,LPARAM lParam=0,UINT uState=0,UINT uStateMask=0);
	INT			 FindItem				(INT iItem,LPCTSTR pText ,int nCol=0,int iCase=0);
	INT			 FindItem				(INT iItem,LPARAM  lParam);
	INT			 InsertMulti			(INT iCount,LPARAM  lParam=0,UINT uFlags=0);
	INT			 InsertMulti			(LPARAM *pParam,INT iCount  ,UINT uFlags=0);
	INT			 InsertItem				(const LVITEM *pItem);
	INT			 InsertItem				(INT  iItem, LPARAM  lParam,UINT uFlags=0);
	INT			 InsertItem				(UINT uMask, INT nItem, LPCTSTR pText,UINT uState,UINT uStateMask,INT iImage,LPARAM lParam);
	INT			 RedrawItemsEx		 	(INT  iItem, INT nCol=0,UINT uSizeX=1,UINT uSizeY=1);
	INT			 RedrawItems			(INT  iFirst,INT iLast);
	INT 		 GetFocusColumn		 	();
	INT 		 GetSelectionColumn	 	();
	INT 		 GetDropHilightColumn	();
	INT			 GetCountPerPage		() const;
	INT			 GetMinColumn			() const;
	INT			 SetMinColumn			(int iMin);
	UINT		 GetDrawCbSize 			() const;
	UINT		 SetDrawCbSize			(UINT uSize);
	LPVOID		 GetLineCbParam  		() const;
	LPVOID		 SetLineCbParam			(LPVOID pParam);
	LPVOID		 GetDrawCbParam  		() const;
	LPVOID		 SetDrawCbParam		(LPVOID pParam);
	PFNFLLINECB	 GetLineCallback		() const;
	PFNFLLINECB	 SetLineCallback		(PFNFLLINECB pProc);
	PFNFLDRAWCB	 GetDrawCallback		() const;
	PFNFLDRAWCB	 SetDrawCallback		(PFNFLDRAWCB pProc);
	LPVOID		 GetCloseCbParam  		() const;
	LPVOID		 SetCloseCbParam		(LPVOID pParam);
	PFNFLCLOSE	 GetCloseCallback		() const;
	PFNFLCLOSE	 SetCloseCallback		(PFNFLCLOSE pProc);
	INT			 SetSetDataField		(LV_DATAFIELD *pInfos);
	LPARAM		 GetOption				(int iOption) const;
	LPARAM		 SetOption				(int iOption,LPARAM  iValue);
	INT			 SetColumnAutoEdit		(int nCol,int iMode=LVAE_EDIT);
	INT			 SetColumnAutoEdit		(int nCol,int iMode,            LPTSTR  *pList,int iMax=0);
	INT			 SetColumnAutoEdit		(int nCol,int iMode,            LPCTSTR *pList,int iMax=0);
	INT			 SetColumnAutoEdit		(int nCol,int iMode,            LPCTSTR  pText,int iMax=0);
	INT			 SetColumnAutoEdit		(int nCol,int iMode,TCHAR cChar,LPCTSTR  pText,int iMax=0);
	INT			 SetColumnAutoIcon		(int nCol,int iIcon);
	static void	 SetColorIndex			(FL_ENTRY *pEntry,LPBYTE pColors);

};


//*****************************************************************************
//*
//*		Inline Funktions
//*
//*****************************************************************************

inline	BOOL		 CFastListCtrl::Create(DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId)		{ return CreateEx(0,dwStyle,uItem,pDlg,nId);}
inline	BOOL		 CFastListCtrl::DeleteItems	(int iItem,unsigned uCount)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_DeleteItems(m_hWnd,iItem,uCount);}
inline	BOOL		 CFastListCtrl::GetColumn   (int nCol,       LV_COLUMN *pColumn) const		{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetColumn(m_hWnd,nCol,pColumn);}
inline	BOOL		 CFastListCtrl::SetColumn   (int nCol, const LV_COLUMN *pColumn)			{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumn(m_hWnd,nCol,pColumn);}
inline	INT 		 CFastListCtrl::InsertColumn(int nCol, const LV_COLUMN *pColumn)			{ ASSERT(::IsWindow(m_hWnd)); return FastList_InsertColumn(m_hWnd,nCol,pColumn); }
inline	BOOL		 CFastListCtrl::DeleteColumn(int nCol)										{ ASSERT(::IsWindow(m_hWnd)); return FastList_DeleteColumn(m_hWnd,nCol); }
inline	INT 		 CFastListCtrl::GetColumnCount() const										{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetColumnCount(m_hWnd); }
inline	INT 		 CFastListCtrl::GetSelectionCount() const									{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetOption(m_hWnd,LVOP_SELECTIONCOUNT); }
inline	INT			 CFastListCtrl::GetColumnWidth(int nCol) const								{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetColumnWidth(m_hWnd,nCol); }
inline	BOOL		 CFastListCtrl::SetColumnWidth(int nCol, int iWidth)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnWidth(m_hWnd,nCol,iWidth); }
inline	BOOL		 CFastListCtrl::SetColumnOrderArray	(int iCount,const int *pArray)			{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnOrderArray(m_hWnd,iCount,pArray);}
inline	BOOL		 CFastListCtrl::GetColumnOrderArray	(int iCount,int       *pArray)			{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetColumnOrderArray(m_hWnd,iCount,pArray);}
inline	INT			 CFastListCtrl::FindItem(INT iItem,LVFIND *pFind)							{ ASSERT(::IsWindow(m_hWnd)); return FastList_FindItem(m_hWnd,iItem,pFind); }
inline	BOOL		 CFastListCtrl::SetItemData(INT iItem,DWORD_PTR dwData) 					{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetItemData(m_hWnd,iItem,dwData); }
inline	DWORD_PTR	 CFastListCtrl::GetItemData(INT iItem) const								{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetItemData(m_hWnd,iItem); }
inline	INT			 CFastListCtrl::GetCountPerPage() const										{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetCountPerPage(m_hWnd); }
inline	int 		 CFastListCtrl::SetTopIndex(int iItem)										{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetTopIndex(m_hWnd,iItem);}
inline	DWORD		 CFastListCtrl::GetStyle() const											{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetStyle(m_hWnd); }
inline	DWORD		 CFastListCtrl::SetStyle(DWORD dwStyle)										{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetStyle(m_hWnd,dwStyle); }
inline	DWORD		 CFastListCtrl::SetStyle(DWORD dwStyle,DWORD dwMask)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetStyleEx(m_hWnd,dwStyle,dwMask); }
inline	DWORD		 CFastListCtrl::GetExtendedStyle() const									{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetExtendedStyle(m_hWnd); }
inline	DWORD		 CFastListCtrl::SetExtendedStyle(DWORD dwStyle)								{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetExtendedStyle(m_hWnd,dwStyle); }
inline	DWORD		 CFastListCtrl::SetExtendedStyle(DWORD dwStyle,DWORD dwMask)				{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetExtendedStyleEx(m_hWnd,dwStyle,dwMask); }
inline	COLORREF	 CFastListCtrl::GetColor(int iIndex) const									{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetColor(m_hWnd,iIndex); }
inline	COLORREF	 CFastListCtrl::SetColor(int iIndex,COLORREF uColor)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColor(m_hWnd,iIndex,uColor); }
inline	COLORREF	 CFastListCtrl::GetItemBkColor  (INT iItem,int nCol) const					{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetItemBkColor(m_hWnd,iItem,nCol); }
inline	COLORREF	 CFastListCtrl::GetItemTextColor(INT iItem,int nCol) const					{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetItemTextColor(m_hWnd,iItem,nCol); }
inline	INT 		 CFastListCtrl::IsItemVisible   (INT iItem,int nCol)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_IsItemVisible(m_hWnd,iItem,nCol); }
inline	BOOL		 CFastListCtrl::EnsureVisible   (INT iItem,int nCol)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_EnsureVisibleEx(m_hWnd,iItem,nCol); }
inline	BOOL		 CFastListCtrl::SelectDropTarget(INT iItem)									{ ASSERT(::IsWindow(m_hWnd)); return FastList_SelectDropTarget(m_hWnd,iItem);}
inline	BOOL		 CFastListCtrl::SelectItem  (INT iItem,int nCol)							{ ASSERT(::IsWindow(m_hWnd)); return FastList_SelectSubItem(m_hWnd,iItem,nCol); }
inline	BOOL		 CFastListCtrl::StartEdit	(INT iItem,int nCol)							{ ASSERT(::IsWindow(m_hWnd)); return FastList_StartEdit(m_hWnd,iItem,nCol); }
inline	BOOL		 CFastListCtrl::GetItemRect (INT iItem,int nCol,RECT *pRect,int iCode)		{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetItemRect(m_hWnd,iItem,nCol,pRect,iCode); }
inline	INT			 CFastListCtrl::GetNextSelected(INT iItem) 									{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetNextSelected(m_hWnd,iItem); }
inline	INT			 CFastListCtrl::GetFirstSelected()											{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetNextSelected(m_hWnd,-1); }
inline	INT			 CFastListCtrl::GetFocusItem()												{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetFocus(m_hWnd); }
inline	INT 		 CFastListCtrl::GetFocusColumn() 											{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetFocusColumn(m_hWnd); }
inline	INT 		 CFastListCtrl::GetSelectionColumn() 										{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetSelectionColumn(m_hWnd); }
inline	INT 		 CFastListCtrl::GetDropHilightColumn() 										{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetDropHilightColumn(m_hWnd); }
inline	CEdit		*CFastListCtrl::EditLabel  (INT iItem,int nCol,int iFull          ,int iSel){ ASSERT(::IsWindow(m_hWnd)); return (CEdit      *)CEdit      ::FromHandle(FastList_EditLabel(m_hWnd,iItem,(nCol&0xFFFF)|((iFull)? LVIR_EDITFULL:0)|(iSel))); }
inline	CComboBox	*CFastListCtrl::EditLabelCb(INT iItem,int nCol,int iFull,int iList,int iSel){ ASSERT(::IsWindow(m_hWnd)); return (CComboBox  *)CEdit      ::FromHandle(FastList_EditLabel(m_hWnd,iItem,(nCol&0xFFFF)|((iFull)? LVIR_EDITFULL:0)|(iSel)|((iList)? LVIR_EDITCOMBOLIST:LVIR_EDITCOMBOBOX))); }
inline	CComboBox   *CFastListCtrl::GetComboControl() const										{ ASSERT(::IsWindow(m_hWnd)); return (CComboBox  *)CWnd       ::FromHandle((HWND)::SendMessage(m_hWnd,LVM_GETEDITCONTROL,0,0));}
inline	CEdit	    *CFastListCtrl::GetEditControl() const										{ ASSERT(::IsWindow(m_hWnd)); return (CEdit      *)CWnd       ::FromHandle((HWND)::SendMessage(m_hWnd,LVM_GETEDITCONTROL,0,0));}
inline	CHeaderCtrl *CFastListCtrl::GetHeaderCtrl() const										{ ASSERT(::IsWindow(m_hWnd)); return (CHeaderCtrl*)CHeaderCtrl::FromHandle(FastList_GetHeader(m_hWnd)); }
inline	INT			 CFastListCtrl::InsertItem(const LVITEM *pItem)								{ ASSERT(::IsWindow(m_hWnd)); return (INT)::SendMessage(m_hWnd,LVM_INSERTITEM,0,(LPARAM)pItem);}
inline	INT			 CFastListCtrl::FindItem(INT iItem,LPCTSTR pText,int nCol,int iCase)		{ return FindItem(iItem,(iCase)? LVIF_TEXT|LVIF_CASE:LVIF_TEXT,nCol,pText);}
inline	INT			 CFastListCtrl::FindItem(INT iItem,LPARAM  lParam)							{ return FindItem(iItem,         LVIF_PARAM,0,0,lParam);}
inline	BOOL		 CFastListCtrl::SetItemState(INT iItem,UINT nState,UINT nMask)				{ return SetItemState(iItem,0,nState,nMask);}
inline	BOOL		 CFastListCtrl::EnsureVisible(INT iItem)									{ return EnsureVisible(iItem,0xFFFFFFFF); }
inline	BOOL		 CFastListCtrl::GetItemRect(INT iItem,RECT *pRect,int iCode)				{ return GetItemRect(iItem,pRect,iCode); }
inline	BOOL		 CFastListCtrl::SetItem(LVITEM* pItem)										{ return CListCtrl::SetItem(pItem); }
inline	INT			 CFastListCtrl::SetItemStates(INT iItem,INT iEnd,UINT uState,UINT uMask)	{ ASSERT(::IsWindow(m_hWnd));LV_SETSTATES sData;sData.iStart=iItem;sData.iEnd=iEnd;sData.uState=uState;sData.uMask=uMask;return FastList_SetItemStates(m_hWnd,&sData);}
inline	CImageList  *CFastListCtrl::SetImageList(CImageList* pImageList,int nImageListType)		{ return CListCtrl::SetImageList(pImageList,nImageListType);}
inline	HIMAGELIST	 CFastListCtrl::SetImageList(HIMAGELIST  hImageList,int nImageListType)		{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetImageList(m_hWnd,hImageList,nImageListType);}
inline	PFNFLLINECB	 CFastListCtrl::GetLineCallback() const										{ ASSERT(::IsWindow(m_hWnd)); return (PFNFLLINECB)FastList_GetOption(m_hWnd,LVOP_LINECALLBACK        );}
inline	LPVOID   	 CFastListCtrl::GetLineCbParam () const										{ ASSERT(::IsWindow(m_hWnd)); return (LPVOID     )FastList_GetOption(m_hWnd,LVOP_LINEPARAM           );}
inline	PFNFLLINECB	 CFastListCtrl::SetLineCallback(PFNFLLINECB pProc)							{ ASSERT(::IsWindow(m_hWnd)); return (PFNFLLINECB)FastList_SetOption(m_hWnd,LVOP_LINECALLBACK ,pProc );}
inline	LPVOID		 CFastListCtrl::SetLineCbParam (LPVOID pParam)								{ ASSERT(::IsWindow(m_hWnd)); return (LPVOID     )FastList_SetOption(m_hWnd,LVOP_LINEPARAM    ,pParam);}
inline	PFNFLDRAWCB	 CFastListCtrl::GetDrawCallback() const										{ ASSERT(::IsWindow(m_hWnd)); return (PFNFLDRAWCB)FastList_GetOption(m_hWnd,LVOP_DRAWCALLBACK        );}
inline	LPVOID   	 CFastListCtrl::GetDrawCbParam () const										{ ASSERT(::IsWindow(m_hWnd)); return (LPVOID     )FastList_GetOption(m_hWnd,LVOP_DRAWPARAM           );}
inline	UINT     	 CFastListCtrl::GetDrawCbSize  () const										{ ASSERT(::IsWindow(m_hWnd)); return (UINT       )FastList_GetOption(m_hWnd,LVOP_DRAWSIZE            );}
inline	PFNFLDRAWCB	 CFastListCtrl::SetDrawCallback(PFNFLDRAWCB pProc)							{ ASSERT(::IsWindow(m_hWnd)); return (PFNFLDRAWCB)FastList_SetOption(m_hWnd,LVOP_DRAWCALLBACK ,pProc );}
inline	LPVOID		 CFastListCtrl::SetDrawCbParam (LPVOID pParam)								{ ASSERT(::IsWindow(m_hWnd)); return (LPVOID     )FastList_SetOption(m_hWnd,LVOP_DRAWPARAM    ,pParam);}
inline	PFNFLCLOSE	 CFastListCtrl::GetCloseCallback() const									{ ASSERT(::IsWindow(m_hWnd)); return (PFNFLCLOSE )FastList_GetOption(m_hWnd,LVOP_CLOSECALLBACK       );}
inline	LPVOID   	 CFastListCtrl::GetCloseCbParam () const									{ ASSERT(::IsWindow(m_hWnd)); return (LPVOID     )FastList_GetOption(m_hWnd,LVOP_CLOSEPARAM          );}
inline	PFNFLCLOSE	 CFastListCtrl::SetCloseCallback(PFNFLCLOSE pProc)							{ ASSERT(::IsWindow(m_hWnd)); return (PFNFLCLOSE )FastList_SetOption(m_hWnd,LVOP_CLOSECALLBACK,pProc );}
inline	LPVOID		 CFastListCtrl::SetCloseCbParam (LPVOID pParam)								{ ASSERT(::IsWindow(m_hWnd)); return (LPVOID     )FastList_SetOption(m_hWnd,LVOP_CLOSEPARAM   ,pParam);}
inline	UINT     	 CFastListCtrl::SetDrawCbSize   (UINT uSize) 								{ ASSERT(::IsWindow(m_hWnd)); return (UINT       )FastList_SetOption(m_hWnd,LVOP_DRAWSIZE     ,uSize );}
inline	INT			 CFastListCtrl::GetMinColumn() const										{ ASSERT(::IsWindow(m_hWnd)); return (INT        )FastList_GetOption(m_hWnd,LVOP_MINCOLUMN           );}
inline	INT			 CFastListCtrl::SetMinColumn(int iMin)										{ ASSERT(::IsWindow(m_hWnd)); return (INT        )FastList_SetOption(m_hWnd,LVOP_MINCOLUMN    ,iMin  );}
inline	INT			 CFastListCtrl::SetSetDataField(LV_DATAFIELD *pInfos)						{ ASSERT(::IsWindow(m_hWnd)); return (INT        )FastList_SetDataField(m_hWnd,pInfos); }
inline  INT			 CFastListCtrl::RedrawItemsEx(INT iItem ,INT nCol,UINT uSizeX,UINT uSizeY)	{ ASSERT(::IsWindow(m_hWnd)); return FastList_RedrawItemsEx(m_hWnd,iItem,nCol,uSizeX,uSizeY);}
inline  INT			 CFastListCtrl::RedrawItems(INT iFirst,INT iLast)							{ ASSERT(::IsWindow(m_hWnd)); return ListView_RedrawItems(m_hWnd,iFirst,iLast);}
inline  INT			 CFastListCtrl::InsertMulti(INT iCount,LPARAM lParam,UINT uFlags)			{ ASSERT(::IsWindow(m_hWnd)); return FastList_InsertMulti(m_hWnd,iCount|uFlags,lParam);}
inline  INT			 CFastListCtrl::InsertMulti(LPARAM *pParam,INT iCount,UINT uFlags)			{ ASSERT(::IsWindow(m_hWnd)); return FastList_InsertMultiPtr(m_hWnd,iCount|uFlags,(LPARAM)pParam);}
inline	INT			 CFastListCtrl::SetColumnAutoEdit(int n,int m							  )	{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnAutoEdit(m_hWnd,n, m                                          ,NULL ); }
inline	INT			 CFastListCtrl::SetColumnAutoEdit(int n,int m,        LPTSTR  *pList,int x)	{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnAutoEdit(m_hWnd,n,(m|LVAE_COUNT(x)             )| LVAE_PTRLIST,pList); }
inline	INT			 CFastListCtrl::SetColumnAutoEdit(int n,int m,        LPCTSTR *pList,int x)	{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnAutoEdit(m_hWnd,n,(m|LVAE_COUNT(x)             )| LVAE_PTRLIST,pList); }
inline	INT			 CFastListCtrl::SetColumnAutoEdit(int n,int m,        LPCTSTR  pText,int x)	{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnAutoEdit(m_hWnd,n,(m|LVAE_COUNT(x)             )&~LVAE_PTRLIST,pText); }
inline	INT			 CFastListCtrl::SetColumnAutoEdit(int n,int m,TCHAR c,LPCTSTR  pText,int x)	{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetColumnAutoEdit(m_hWnd,n,(m|LVAE_COUNT(x)|LVAE_CHAR(c))&~LVAE_PTRLIST,pText); }
inline	LPARAM		 CFastListCtrl::GetOption(int iOption) const								{ ASSERT(::IsWindow(m_hWnd)); return FastList_GetOption(m_hWnd,iOption); }
inline	LPARAM		 CFastListCtrl::SetOption(int iOption,LPARAM iValue)						{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetOption(m_hWnd,iOption,iValue); }
inline	BOOL		 CFastListCtrl::DisableItemAutoEdit(INT iItem,int nCol,BOOL bDisable)		{ return SetItemState(iItem,nCol,(bDisable)? LVIS_DISABLEBIT:0,LVIS_DISABLEBIT);}
inline	BOOL		 CFastListCtrl::SetFocusItem   (INT iItem,INT iCol,BOOL bVis,BOOL bSel)		{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetFocuItem(m_hWnd,iItem,iCol,bVis,bSel);}
inline	BOOL		 CFastListCtrl::SetFocusColumn (          INT iCol,BOOL bVis,BOOL bSel)		{ ASSERT(::IsWindow(m_hWnd)); return FastList_SetFocuItem(m_hWnd,   -1,iCol,bVis,bSel);}
inline	BOOL		 CFastListCtrl::SetItemCheckBox(INT iItem,int iBits,int nCol,UINT uMask)    { return SetItemState(iItem,nCol,iBits<<12,LVIS_STATEIMAGEMASK&(uMask<<12));}
inline	BOOL		 CFastListCtrl::GetItemCheckBox(INT iItem,          int nCol,UINT uMask)    { return(GetItemState(iItem,LVIS_STATEIMAGEMASK,nCol)>>12)&uMask;  }
inline	VOID		 CFastListCtrl::GetHeaderCtrl  (HWND &hWnd) const							{ ASSERT(::IsWindow(m_hWnd)); hWnd=(HWND)::SendMessage(m_hWnd,LVM_GETHEADER     ,0,0);}
inline	VOID		 CFastListCtrl::GetEditControl (HWND &hWnd) const							{ ASSERT(::IsWindow(m_hWnd)); hWnd=(HWND)::SendMessage(m_hWnd,LVM_GETEDITCONTROL,0,0);}
inline	VOID		 CFastListCtrl::GetComboControl(HWND &hWnd) const							{ ASSERT(::IsWindow(m_hWnd)); hWnd=(HWND)::SendMessage(m_hWnd,LVM_GETEDITCONTROL,0,0);}
inline	UINT		 CFastListCtrl::GetItemState   (INT iItem,UINT uMask,int nCol)				{ ASSERT(::IsWindow(m_hWnd)); LV_ITEM sItem;sItem.mask=LVIF_STATE;sItem.stateMask=uMask;sItem.iItem=iItem;sItem.iSubItem=nCol;if(!GetItem(&sItem))return 0;return sItem.state;}
inline	BOOL		 CFastListCtrl::SetItemState   (INT iItem,int nCol,UINT nState,UINT uMask)	{ ASSERT(::IsWindow(m_hWnd)); LV_ITEM sItem;sItem.mask=LVIF_STATE;sItem.stateMask=uMask;sItem.iItem=iItem;sItem.iSubItem=nCol;sItem.state=nState;return SetItem(&sItem);}
inline	LPCTSTR		 CFastListCtrl::GetItemText    (INT iItem,int nCol)							{ ASSERT(::IsWindow(m_hWnd)); LV_ITEM sItem;sItem.mask=LVIF_TEXT|LVIF_TEXTPTR;sItem.iItem=iItem;sItem.iSubItem=nCol;if(!GetItem(&sItem))return 0;return sItem.pszText;}
inline	BOOL		 CFastListCtrl::GetItemText    (INT iItem,int nCol,LPTSTR pBuffer,int iMax) { ASSERT(::IsWindow(m_hWnd)); LV_ITEM sItem;if(iMax<=0)return FALSE;pBuffer[0]=0;sItem.mask=LVIF_TEXT;sItem.iItem=iItem;sItem.pszText=pBuffer;sItem.cchTextMax=iMax;sItem.iSubItem=nCol;return GetItem(&sItem);}
inline	int			 CFastListCtrl::GetItemImageEx (INT iItem,int nCol)							{ ASSERT(::IsWindow(m_hWnd)); LV_ITEM sItem;sItem.mask=LVIF_IMAGE;sItem.iItem=iItem;sItem.iSubItem=nCol;if(!GetItem(&sItem))return -1;return sItem.iImage;}
inline	BOOL		 CFastListCtrl::GetItemImageEx (INT iItem,int *pImage,int nCol)				{ ASSERT(::IsWindow(m_hWnd)); LV_ITEM sItem;sItem.mask=LVIF_IMAGE;sItem.iItem=iItem;sItem.iSubItem=nCol;if(!GetItem(&sItem))return FALSE;pImage[0]=sItem.iImage;return TRUE;}
inline	DWORD		 CFastListCtrl::SetEditClickMode(DWORD dwMode)								{ return (DWORD)     SetOption(LVOP_EDITCLICKMODE,dwMode);}
inline	DWORD		 CFastListCtrl::GetEditClickMode() const									{ return (DWORD)     GetOption(LVOP_EDITCLICKMODE);}
inline	DWORD		 CFastListCtrl::SetColorOffStates(DWORD dwMode)								{ return (DWORD)     SetOption(LVOP_COLOROFFSTATES,dwMode);}
inline	DWORD		 CFastListCtrl::GetColorOffStates() const									{ return (DWORD)     GetOption(LVOP_COLOROFFSTATES);}
inline	DWORD		 CFastListCtrl::SetStartOffset (DWORD dwOffset)								{ return (DWORD)     SetOption(LVOP_STARTOFFSET,dwOffset);}
inline	DWORD		 CFastListCtrl::GetStartOffset () const										{ return (DWORD)     GetOption(LVOP_STARTOFFSET);}
inline	HFONT		 CFastListCtrl::SetCharFont2   (HFONT hFont)								{ return (HFONT)     SetOption(LVOP_CHARFONT2,(LPARAM)hFont);}
inline	HFONT		 CFastListCtrl::GetCharFont2   () const										{ return (HFONT)     GetOption(LVOP_CHARFONT2);}
inline	HFONT		 CFastListCtrl::SetCharFont3   (HFONT hFont)								{ return (HFONT)     SetOption(LVOP_CHARFONT3,(LPARAM)hFont);}
inline	HFONT		 CFastListCtrl::GetCharFont3   () const										{ return (HFONT)     GetOption(LVOP_CHARFONT3);}
inline	LPCOLORREF	 CFastListCtrl::SetCharColors  (LPCOLORREF pColors)							{ return (LPCOLORREF)SetOption(LVOP_CHARCOLORS,(LPARAM)pColors);}
inline	LPCOLORREF	 CFastListCtrl::GetCharColors  () const										{ return (LPCOLORREF)GetOption(LVOP_CHARCOLORS);}
inline	int			 CFastListCtrl::GetLineNumber  (FL_ENTRY *pEntry)							{ return FastList_GetLineNumber(pEntry);}
inline	void		 CFastListCtrl::SetColorIndex  (FL_ENTRY *pEntry,LPBYTE pColors)			{ FastList_SetColorIndex(pEntry,pColors);}


#endif

