//*****************************************************************************
//*
//*
//*		FastListWnd.h
//*
//*
//*****************************************************************************
#ifndef 	__FASTLISTWND_H__
#define 	__FASTLISTWND_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	<commctrl.h>

#ifndef		FL_MAX_COLUMNS
#define 	FL_MAX_COLUMNS		32 
#endif


typedef int (CALLBACK *PFNFLLOCKCB)(LPVOID pParam,LPARAM lParam,INT iCount,UINT uAction);
typedef int (CALLBACK *PFNFLDRAWCB)(LPVOID pParam,LPARAM lParam,UINT uItem,UINT uState,HDC hDc,LPRECT pRect);

typedef struct
	{
	UINT			uFlags;
	UINT			uColumn;
	UINT			uState;
	UINT			uStateMask;
	LPARAM			lParam;
	LPCTSTR			pText;
	}LVFIND;

typedef struct
	{
    LPTSTR			pText;
	INT				iSize;
	INT				iImage;
	UINT			uState;
	COLORREF		uBkColor;
	COLORREF		uTextColor;
	}FL_ENTRY;

typedef struct
	{
    NMHDR			hdr;
    WORD			wVKey;
	WORD			wScan;
    UINT			flags;
	}LV_KEYDOWN_EX;

typedef struct
	{
    NMHDR			hdr;
    DWORD			dwFlags;
    LPTSTR			pszText;
    int				cchTextMax;
    int				iItem;
    int				iSubItem;
    LPARAM			lParam;
	unsigned		uTime;
	POINT			ptAction;
	}NMLVGETINFOTIEX;

typedef struct
	{
    NMHDR			hdr;
    LVITEM			item;
	UINT			uAction;
	UINT			uHeight;
	UINT			uMaxEntries;
	LPCTSTR			pTextEntries;
	LPCTSTR		   *pTextList;
	POINT			ptAction;
	}LV_STARTEDIT;

typedef struct
	{
    NMHDR			hdr;
	int				iSizeX;
	int				iSizeY;
	int				iOffset;
	}LV_STARTSIZE;

typedef struct
	{
    NMHDR			hdr;
    UINT			uColumn;
	UINT			uIndex;
	UINT			uPosX;
	INT				iSize;
	}LV_COLSIZE;

typedef struct
	{
    NMHDR			hdr;
	WORD			wBar;
	WORD			wMode;
	int				iScrollX;
	int				iScrollY;
	}LV_SCROLLED;

typedef struct
	{
    NMHDR			hdr;
	POINT			sPoint;
    UINT			uFlags;
    UINT			uColumn;
	}LV_HDRCLICK;

typedef struct
	{
    NMHDR			hdr;
	POINT			sPoint;
    UINT			uCount;
	int				iSelected;
	}LV_RESELECT;

typedef struct
	{
    LPVOID	       *pField;
    LPINT			pCount;
	LPVOID			pParam;
	PFNFLLOCKCB		pLockCb;
	INT				iOffset;
	INT				iSortMem;
	}LV_DATAFIELD;

typedef struct
	{
    int 			iStart;
	int				iEnd;
	UINT			uState;
	UINT			uMask;
	}LV_SETSTATES;

typedef int (CALLBACK *PFNFLLINECB)(LPVOID pParam,LPARAM iItem,UINT uStart,UINT uEnd,FL_ENTRY *pEntries);
typedef int (CALLBACK *PFNFLCLOSE )(LPVOID pParam,HWND	 hWnd);

#define 	LV_FIND					LVFIND				// Find Struktur
#define 	LV_NOIMAGE				(-2)				// Kein Icon anzeigen
#define 	LV_NOCOLOR				0xFFFFFFFF			// Standartfarbe benutzen
#define 	LV_CHARCOLOR			0xFFFFFFFE			// Farben pro Buchstaben definiert
#define 	LVN_COLUMNDBLCLICK		HDN_ITEMDBLCLICK	// Doppelklick auf Header-Zeile
#define 	LVLE_DONOTIFY			0xF5A5A500			// LVN_STARTEDIT auslsen
#define 	LVIF_LOCKING			0x80000000			// Sperren beim Lock/Unlock Callback
#define 	LVIF_TEXTPTR			0x80000000			// Nur einen Zeiger auf den Text holen
#define 	LVIF_TOOLTIPTIME		0x40000000			// Zeit zum einblenden vom Tooltip
#define		LVIF_TEXTCHANGED		0x20000000			// Bei der Eingabe wurde der Text verndert
#define		LVIF_RETURNEXIT			0x10000000			// Die Eingabe wurde mit RETURN beendet
#define 	LVIF_CASE				0x08000000			// Beim Suchen zwischen Gro/Kleinbuchstaben nicht unterscheiden
#define 	LVIF_FAST				0x04000000			// Schnell Einfgemodus
#define 	LVIF_ENDSCROLL			0x02000000			// Beim Einfgen am Ende des Fensters scollen
#define 	LVIF_SHOWSCROLL			0x01000000			// Beim Einfgen muss der Eintrag sichtbar bleiben
#define 	LVIS_UNTERLINE			0x00000040			// Schriftart unterstrichen
#define 	LVIS_BOLD				0x00000080			// Schriftart fett
#define		LVSIL_NOTDEL            0x40000000			// Image-Liste nicht lschen
#define 	LVSIL_CHECK				0x00000003			// Icon-Liste fr Checkboxen
#define 	LVSIL_SUBIMAGES			0x00000004			// Icon-Liste fr Spalten
#define 	LVSIL_HEADER			0x00000005			// Icon-Liste fr Header
#ifndef 	SB_SETPOSITION
#define 	SB_SETPOSITION			9					// Eine Scrollposition direkt setzen (ber lParam)
#endif
#ifndef 	SB_KEYDOWN
#define 	SB_KEYDOWN				10					// Eine Scrollposition ber die Tastatur ndern
#endif
#ifndef 	SB_MOUSEWHEEL
#define 	SB_MOUSEWHEEL			11					// Eine Scrollposition ber das Mausrad ndern
#endif
#ifndef 	SB_THUMBTRACKEX
#define 	SB_THUMBTRACKEX			12					// Eine 28-Bit Scroll-Position setzen
#endif
#ifndef		VK_DBLCLK
#define 	VK_DBLCLK				0x10000				// Edit mit Doppelklick
#endif
#ifndef		VK_ICONCLK
#define 	VK_ICONCLK				0x10001				// Edit mit Klick auf Icon
#endif
#ifndef		VK_EDITCLK
#define 	VK_EDITCLK				0x10002				// Edit mit Klick auf augewhltes Element
#endif
#ifndef		VK_PASTE
#define 	VK_PASTE				0x10004				// Edit mit WM_PASTE
#endif
#ifdef		UNICODE
#define		LV_UINICODE				1
#else
#define		LV_UINICODE				0
#endif

// Konstanten fr Farben bei Einzelfarben
#define 	LVC_MASK				0x1F				// Farbmaske bei Einzelfarben
#define 	LVC_UNTERLINE			0x20				// Flag fr Unterstreichen bei Einzelfarben
#define 	LVC_BOLD				0x40				// Flag fr Fett bei Einzelfarben
#define 	LVC_MODE_BKCOLOR_0		0x00000000			// Kein Bit  fr Hintergund
#define 	LVC_MODE_BKCOLOR_1		0x10000000			// Ein  Bit  fr Hintergund
#define 	LVC_MODE_BKCOLOR_2		0x20000000			// Zwei Bits fr Hintergund
#define 	LVC_MODE_BKCOLOR_3		0x30000000			// Drei Bits fr Hintergund
#define 	LVC_MODE_NODEFAULT		0x80000000			// Keine Default-Text-Farbe



// Konstanten fr Farben (LVM_SETBKCOLOR)
#define 	LVC_BK					0					// Hintergrundfarbe
#define 	LVC_ODD					1					// Abwechselnte Farbe        (siehe LVS_EX_ALTERNATECOLOR)
#define 	LVC_EVEN				2					// Abwechselnte Farbe gerade (siehe LVS_EX_ALTERNATECOLOR)
#define 	LVC_FRAME				3					// Farbe fr Trennlinien (siehe LVS_EX_GRIDLINES)
#define 	LVC_TEXT				4					// Textfarbe
#define 	LVC_TRACK				5					// Farbe fr getrakte Texte
#define 	LVC_MARK				6					// Markierte Zeile
#define 	LVC_MARKODD				6					// Markierte Zeile (ungerade)
#define 	LVC_MARKEVEN			7					// Markierte Zeile (gerade)
#define 	LVC_COLBK				8					// Hintergrundfarbe wenn Spalte markiert
#define 	LVC_COLODD				9					// Abwechselnte Farbe wenn Spalte markiert
#define 	LVC_COLEVEN				10					// Abwechselnte Farbe gerade wenn Spalte markiert
#define 	LVC_GRAYED				11					// Hindergrundfarbe wenn gesperrt
#define 	LVC_NOFOCUS				12					// Farbe der Einfgemarke wenn keine Focus und abwechselnd

// Konstanten fr GetNextItem/SelectItem
#define 	LVNI_DROPHILITESUB		0x00000100			// Ausgewhlte Spalte holen
#define 	LVNI_CARETSUB			0x00000101			// Drophighilite Spalte holen
#define 	LVNI_FOCUS				0x00000102			// Eintrag der den Fokus hat
#define 	LVNI_FOCUSSUB			0x00000103			// Spalte  die den Fokus hat
#define 	LVNI_NEXTSELCHILD		0x00000104			// Nchster ausgewhlter Kindeintrag
#define 	LVNI_NEXTVISIBLE		0x00000105			// Nchster sichtbarer Eintrag
#define 	LVNI_PREVIOUSVISIBLE	0x00000106			// Vorheriger sichtbarer Eintrag
#define 	LVNI_LASTVISIBLE		0x00000107			// Letzter sichtbarer Eintrag
#define 	LVNI_CARET				0x00000108			// Den Eintrag fr die Marke whlen
#define 	LVNI_DROPHILITE			0x00000109			// Den Eintrag fr das Droptarget whlen
#define 	LVNI_FIRSTVISIBLE		0x0000010A			// Den ersten sichtbaren Eintrag whlen


// Konstanten fr InsertColumn(mask)
#define 	LVCF_VWIDTH				LVCF_SUBITEM		// Variable Breite festlegen
#define 	LVCF_MIN				LVCF_ORDER			// Minimale Breite festlegen
#define 	LVCF_MARK				0x80000000			// Soll die Spalte markiert werden
#define 	LVCF_FIXED				0x40000000			// Soll die auf eine Fixebreite fixiert werden
#define 	LVCF_RECALC				0x20000000			// Variablespalten wieder auf die volle Lnge zoomen
#define 	LVCF_LASTSIZE			0x44332211			// Breite vor dem Fixieren wieder herstellen

// Konstanten fr InsertColumn (format mask)
#define 	LVCFMT_MARK				0x10000000			// Maske fr Spaltenmarkierung
#define 	LVCFMT_FIXED			0x20000000			// Maske fr Spaltenfixierung
#define 	LVCFMT_RECALC			0x40000000			// Modus fr Spalten-Zoom


// Konstanten fr ColumnAutoEdit
#define 	LVAE_NONE				(0<<LVAE_MODEPOS)	// Kein atomatisches Editieren
#define 	LVAE_EDIT				(1<<LVAE_MODEPOS)	// Atomatisches Editieren mit Edit-Fenster
#define 	LVAE_COMBO				(2<<LVAE_MODEPOS)	// Atomatisches Editieren mit ComboBox
#define 	LVAE_CBLIST				(3<<LVAE_MODEPOS)	// Atomatisches Editieren mit ComboListBox
#define 	LVAE_STEP				(4<<LVAE_MODEPOS)	// Einzelnes Weiterschalten mit Enter
#define 	LVAE_STEPED				(5<<LVAE_MODEPOS)	// Einzelnes Weiterschalten mit Enter
#define 	LVAE_CHECK				(6<<LVAE_MODEPOS)	// Atomatisches Editieren mit CheckBox
#define 	LVAE_CHECKED			(7<<LVAE_MODEPOS)	// Atomatisches Editieren mit CheckBox mit Edit
#define 	LVAE_NEXTLINE			0x00000001			// Nach Enter in die nchste Zeile
#define 	LVAE_DBLCLICK			0x00000002			// Editieren mit Doppelklick
#define 	LVAE_FULLWIDTH			0x00000004			// Combobox ber die volle Breite einblenden
#define 	LVAE_PTRLIST			0x00000008			// Die Datenliste wird als Zeigerliste bergeben
#define 	LVAE_ONLYRETURN			0x00000010			// Das Editeren kann nur mit Return begonnen werden
#define 	LVAE_STATEENABLE		0x00000020			// Das Editeren kann mit dem 0x8000 State-Bit gesperrt werden
#define 	LVAE_ICONCLICK			0x00000040			// Editieren mit einem Einfachlick auf das Icon
#define 	LVAE_DROPDOWN			0x00000080			// Die DropDownListe der ComboBox aufklappen
#define 	LVAE_COL(c)				(((c)&0x3F)<<11)	// Ist die Spalte frs automatische Editieren
#define 	LVAE_CHAR(c)			(((c)&0xFF)<<17)	// Ist das Trennzeichen fr die Datenliste
#define 	LVAE_COUNT(c)			(((c)&0x7F)<<25)	// Bestimmt die Anzahl der Eintrge in der Datenliste (0=auto)
#define 	LVAE_MODEMASK			(7<<LVAE_MODEPOS)	// Maske fr die Modusbits
#define 	LVAE_MODEPOS			0x00000008			// Maske fr die Modusbits
#define 	LVIS_DISABLEBIT			0x00008000			// Ist das State-Bit fr's sperren der Auto-Edit-Option


// Konstanten fr HitTest (flags)
#define 	LVHT_SPECIALCHAR(u)		(((UINT)(u)>> 8)&31)// Umwandeln von Spaltemasken zu Speialzeichen
#define 	LVHT_SPECIAL(u)		    (((UINT)(u)>>13)&15)// Umwandeln von Spaltemasken zu Speialposition
#define 	LVHT_SUBTOCOL(u)		(((UINT)(u)>>24))	// Umwandeln von Spaltemasken zu Spaltenummern
#define 	LVHT_ONRIGHTSPACE		0x00800000			// Auf rechtem Rand nach den Extrgen
#define 	LVHT_ONSUBLABEL			0x00400000			// Koordinate ist auf dem Text eines Extraeintrages
#define 	LVHT_ONSUBICON			0x00200000			// Koordinate ist auf einem Extraeintrag
#define 	LVHT_ONSUBRIGHT			0x00100000			// Koordinate ist auf einem Extraeintrag rechts vom Text
#define 	LVHT_ONSUBBASE			0x00080000			// Koordinate ist auf dem Text eines Extraeintrages ooder dem Leerbegin
#define 	LVHT_ONITEMBASE			0x00040000			// Koordinate ist auf dem Text eines Eintrages ooder dem Leerbegin
#define 	LVHT_ONITEMRIGHT		0x00020000			// Koordinate ist rechts vom Text eines Eintrages
#define 	LVHT_ONSPECIAL			0x00010000			// Koordinate ist auf einem Speialzeichen
#define 	LVHT_ONLEFTAREA			0x00008000			// Koordinate ist auf dem linken Draw-Bereich
#define 	LVHT_ONSUBITEM			(LVHT_ONSUBICON|LVHT_ONSUBLABEL)


// Konstanten fr GetItemRect (LVM_GETITEMRECT)
#define 	LVIR_COLTOSUB(u)		((u)<<24)			// Spalte angeben
#define 	LVIR_GETCOLUMN			0x00000080			// Nur Spalte abfragen
#define 	LVIR_INVISIBLEALSO		0x00000100			// Auch unsichtbare EIntrge abfragen


// Konstanten fr EditLabel (LVM_EDITLABEL)
#define 	LVIR_EDITCOMBOCHAR(n)	(((n)&0xFF)<<8)		// Trennzeichen der Combobox-Eintrge (nur fr Notify-Nachricht)
#define 	LVIR_EDITCOMBODEL		0x00000080			// Lscht den Puffer fr die Eintrge (nur fr Notify-Nachricht)
#define 	LVIR_EDITCOMBODOWN		0x10000000			// Die Combobox aufklappen (nur fr Notify-Nachricht)
#define 	LVIR_EDITCOMBOBOX		0x20000000			// Statt dem Edit-Fenster eine ComboBox einblenden
#define 	LVIR_EDITCOMBOLIST		0x40000000			// Statt dem Edit-Fenster eine ComboBox nur mit Listenauswahl einblenden
#define 	LVIR_EDITFULL			0x80000000			// Das Edit-Fenster ber die volle Breite einblenden
#define 	LVIR_EDITTEXT			0x00000001			// Das Edit-Fenster ber den Text einblenden (nur fr Notify-Nachricht)
#define 	LVIR_EDITCOL(u)			((u)&0xFF)			// Spalte angeben
#define 	LVIR_SELALL				0x00000000			// Alles whlen
#define 	LVIR_SELAREA(a,b)		((0x0C0000|(a&0x1FF)|((b&0x1FF)<<9))<<8)	// Textbereich whlen
#define 	LVIR_SETCURSOR(a)		((0x080000|(a&0x3FFFF))<<8)					// Cursor auf Textstelle
#define 	LVIR_SETAT(a)			((0x040000|(a&0x3FFFF))<<8)					// Cursor auf Pixel-Offset


// Konstanten fr uStyleEx
#define		LVS_EX_HEADERCHGNOTIFY  0x00000100			// Nachrichten versenden wenn eine Spaltenbreite verndert wurde
#define		LVS_EX_ALWAYSSCROLLY	0x00000200			// Y-Scrollbar immer einblenden
#define 	LVS_EX_SCROLLNOTIFY		0x00002000			// Beim Scrollen Notify-Nachrichten versenden
#define 	LVS_EX_STEPOUT			0x00004000			// Mit Cursor Edid und Checkboxen verlassen
#define 	LVS_EX_NORIGHTSELECT	0x00008000			// Mit der rechten Maustaste keine Eintrge auswhlen
#define 	LVS_EX_NOCURSORSET		0x00020000			// Bei VK_EDITCLK immer den gesammten Text whlen
#define 	LVS_EX_EDITCLICK		0x00040000			// Mit einem Klick das gewhlte Item berabreiten
#define 	LVS_EX_TABEXIT			0x00080000			// Bei TAB den Fokus ans Elternfenster geben
#define 	LVS_EX_BITCHECKBOX		0x00100000			// Bei Checkboxen nur das unterste Bit ndern
#define 	LVS_EX_ALTERNATECOLOR	0x00200000			// Die Farbe abwechselnd darstellen
#define 	LVS_EX_SUBSELECT		0x00400000			// Sub-Eintrge seperat auswhlen
#define 	LVS_EX_NOCHARSELCET		0x00800000			// Keine Auswahl ber eine Texteingabe
#define 	LVS_EX_NOCOLUMNRESIZE	0x01000000			// Der User darf die Spaltenbreite nicht ndern
#define 	LVS_EX_GRAYEDDISABLE	0x02000000			// Das Control grau zeichnen wenn es gesperrt ist
#define 	LVS_EX_AUTOHSCROLL 		0x04000000			// Horizontale Scrollbar ausblenden
#define 	LVS_EX_FIXEDCOLSIZE		0x08000000			// Gesamtbreite aller Spalten gleich belassen
#define 	LVS_EX_NODELNOTIFY		0x10000000			// Keine Notify-Nachrichten beim Lschen
#define 	LVS_EX_NOCHANGENOTIFY	0x20000000			// Keine Notify-Nachrichten beim ndern von Flags
#define 	LVS_EX_DISABLEDRAGDROP	0x40000000			// Drag and Drop sperren
#define 	LVS_EX_NOTOOLTIPS		0x80000000			// Keine Tooltips anzeigen
#define 	LVS_NONEVENHEIGHT		0x00000400			// Immer eine gerade Zeilenhhe


// Konstanten fr Optionen (LVM_GETSETOPTION)
#define 	LVOP_LINEPARAM			0x00000001			// Parameter fr die Line-Callback-Funktion
#define 	LVOP_LINECALLBACK		0x00000002			// Line-Callback-Funktion fr Daten
#define 	LVOP_CLOSEPARAM			0x00000003			// Parameter fr die Close-Callback-Funktion
#define 	LVOP_CLOSECALLBACK		0x00000004			// Close-Callback-Funktion fr Daten
#define 	LVOP_MINCOLUMN			0x00000005			// Linkeste Spalte fr Tasterureingaben
#define 	LVOP_SELECTIONCOUNT		0x00000006			// Anzahl der ausgewhlten Eintrge abfragen
#define 	LVOP_EDITCLICKMODE		0x00000007			// Editklickoptionen (Bit0=nur auf Text, Bit1=direkt ohne Auswahl)
#define 	LVOP_CHARCOLORS			0x00000008			// Farbliste fr einzelne Buchstaben
#define 	LVOP_CHARFONT2			0x00000009			// Font Nummer 2 fr Einzelfarben
#define 	LVOP_CHARFONT3			0x0000000A			// Font Nummer 3 fr Einzelfarben
#define 	LVOP_COLOROFFSTATES		0x0000000B			// Bei welchen LVIS_??? States die Einzelfarben deaktivieren
#define 	LVOP_STARTOFFSET		0x0000000C			// Leerbereich zwischen Header und erster Zeile
#define 	LVOP_WINDOWPROC			0x0000000D			// Fensterfunktion abfragen
#define 	LVOP_DRAWSIZE			0x0000000E			// Breite des linken Draw-Bereichs
#define 	LVOP_DRAWPARAM			0x0000000F			// Parameter fr die Draw-Callback-Funktion
#define 	LVOP_DRAWCALLBACK		0x00000010			// Draw-Callback-Funktion fr linken Bereich
#define 	LVOP_WRITEOPTION		0x80000000			// Die Option auch schreiben


// Konstanten fr Notify-Nachrichten
#define		LVN_ITEMTOOLTIP			(LVN_FIRST-32)		// Notify Nachricht fr Tooltip-Fenster
#define     LVN_CBSTATECHANGED      (LVN_FIRST-33)		// Notify Nachricht fr genderte Checkbox
#define 	LVN_STEPSTATECHANGED	(LVN_FIRST-34)		// Notify Nachricht fr genderte Step-Aktion
#define 	LVN_STARTEDIT			(LVN_FIRST-35)		// Notify fr's Starten des Editvorgangs
#define 	LVN_SCROLLED			(LVN_FIRST-36)		// Notify fr einen Scroll-Vorgang
#define 	LVN_COLUMNCHANGED		(TVN_FIRST-37)		// Notify Nachricht wenn eine Spalte verndert wurde
#define 	LVN_COLUMNRCLICK		(TVN_FIRST-38)		// Notify Nachricht bei recten Mausklick auf Header
#define 	LVN_RESELECT			(TVN_FIRST-39)		// Notify Nachricht wenn die gesamte Auswahl sich verndert hat
#define     LVN_SPECIALCLICK		(LVN_FIRST-40)		// Notify Nachricht wenn auf ein Spezaialzeichen gedrckt wird
#define     LVN_STARTCHANGED		(LVN_FIRST-41)		// Notify Nachricht wenn die Gre des Statbereichs verndert wurde

// Konstanten fr neue Nachrichten
#define 	LVM_SELECTSUBITEM		(LVM_FIRST+180-0)
#define 	LVM_GETITEMHEIGHT		(LVM_FIRST+180-2)
#define 	LVM_SETITEMHEIGHT		(LVM_FIRST+180-3)
#define 	LVM_GETVISIBLECOUNT		(LVM_FIRST+180-4)
#define 	LVM_GETITEMBKCOLOR		(LVM_FIRST+180-5)
#define 	LVM_GETITEMTEXTCOLOR	(LVM_FIRST+180-6)
#define 	LVM_ENDEDITLABELNOW		(LVM_FIRST+180-7)
#define 	LVM_GETCOLUMNCOUNT		(LVM_FIRST+180-8)
#define 	LVM_SELECTITEM			(LVM_FIRST+180-9)
#define 	LVM_DELETEITEMS			(LVM_FIRST+180-10)
#define 	LVM_GETSETOPTION		(LVM_FIRST+180-11)
#define 	LVM_REDRAWITEMS_EX		(LVM_FIRST+180-12)
#define 	LVM_SETTOPINDEX			(LVM_FIRST+180-13)
#define 	LVM_INSERTMULTI			(LVM_FIRST+180-14-LV_UINICODE)
#define 	LVM_INSERTMULTIPTR		(LVM_FIRST+180-16-LV_UINICODE)
#define 	LVM_COLUMNAUTOEDIT		(LVM_FIRST+180-18-LV_UINICODE)
#define 	LVM_SETDATAFIELD		(LVM_FIRST+180-20)
#define 	LVM_STARTUPDATE			(LVM_FIRST+180-21)
#define 	LVM_SETITEMSTATES		(LVM_FIRST+180-22)
#define 	LVM_SETFOCUSITEM		(LVM_FIRST+180-23)
#define 	LVM_GETITEMDATA			(LVM_FIRST+180-24)
#define 	LVM_SETITEMDATA			(LVM_FIRST+180-25)
#ifndef		LVM_ISITEMVISIBLE
#define 	LVM_ISITEMVISIBLE		(LVM_FIRST+182)
#endif

#define 	FastList_DeleteAllItems(h)					((BOOL      )::SendMessage(h,LVM_DELETEITEMS,0,0x7FFFFFFF))
#define		FastList_DeleteItems(h,i,n)					((BOOL      )::SendMessage(h,LVM_DELETEITEMS,i,n))
#define		FastList_DeleteItem(h,i)					((BOOL      )::SendMessage(h,LVM_DELETEITEM ,i,0))
#define		FastList_GetHeader(h)						((HWND      )::SendMessage(h,LVM_GETHEADER,0,0))
#define		FastList_DeleteColumn(h,i)     				((BOOL      )::SendMessage(h,LVM_DELETECOLUMN,(WPARAM)(int)(i),0))
#define		FastList_InsertColumn(h,i,p)				((INT       )::SendMessage(h,LVM_INSERTCOLUMN,(WPARAM)(int)(i),(LPARAM)(const LV_COLUMN*)(p)))
#define 	FastList_GetColumnCount(h)					((INT       )::SendMessage(h,LVM_GETCOLUMNCOUNT,0,0))
#define 	FastList_HitTest(h,p)						((INT       )::SendMessage(h,LVM_HITTEST,0,(LPARAM)(LPLV_HITTESTINFO)(p)))
#define		FastList_GetItemBkColor(h,i,s)				((COLORREF  )::SendMessage(h,LVM_GETITEMBKCOLOR,(WPARAM)(i),s))
#define		FastList_GetItemTextColor(h,i,s)			((COLORREF  )::SendMessage(h,LVM_GETITEMTEXTCOLOR,(WPARAM)(i),s))
#define 	FastList_GetCountPerPage(h)					((INT       )::SendMessage(h,LVM_GETCOUNTPERPAGE ,0,0))
#define		FastList_GetExtendedStyle(h)				((DWORD     )::SendMessage(h,LVM_GETEXTENDEDLISTVIEWSTYLE,0,0))
#define		FastList_SetExtendedStyle(h,d)	  			((DWORD     )::SendMessage(h,LVM_SETEXTENDEDLISTVIEWSTYLE,0,d))
#define 	FastList_SetExtendedStyleEx(h,d,m)			((DWORD     )::SendMessage(h,LVM_SETEXTENDEDLISTVIEWSTYLE,m,d))
#define		FastList_GetColor(h,i)						((COLORREF  )::SendMessage(h,LVM_GETBKCOLOR,(WPARAM)(i),0))
#define		FastList_SetColor(h,i,c) 					((COLORREF  )::SendMessage(h,LVM_SETBKCOLOR,(WPARAM)(i),c))
#define 	FastList_IsItemVisible(h,i,s)				((INT       )::SendMessage(h,LVM_ISITEMVISIBLE,s,(LPARAM)(INT)(i)))
#define 	FastList_EnsureVisible(h,i,p)				((BOOL      )::SendMessage(h,LVM_ENSUREVISIBLE,(LPARAM)(INT)(i),(p)? 1:0))
#define 	FastList_EnsureVisibleEx(h,i,s)				((BOOL      )::SendMessage(h,LVM_ENSUREVISIBLE,(LPARAM)(INT)(i),(s)|0x80000000))
#define 	FastList_SelectSubItem(h,i,s)				((BOOL      )::SendMessage(h,LVM_SELECTSUBITEM,(WPARAM)(s),(LPARAM)(INT)(i)))
#define 	FastList_GetItemData(h,i)					((DWORD_PTR )::SendMessage(h,LVM_GETITEMDATA,0,(LPARAM)(INT)(i)))
#define 	FastList_SetItemData(h,i,d)					((BOOL      )::SendMessage(h,LVM_SETITEMDATA,d,(LPARAM)(INT)(i)))
#define 	FastList_Select(h,i,c)						((BOOL      )::SendMessage(h,LVM_SELECTITEM,(WPARAM)(c),(LPARAM)(INT)(i)))
#define		FastList_EditLabel(h,i,s)				    ((HWND      )::SendMessage(h,LVM_EDITLABEL,(LPARAM)(INT)(i),(LPARAM)(INT)(s)))
#define		FastList_StartEdit(h,i,s)				    ((BOOL      )::SendMessage(h,LVM_EDITLABEL,(LPARAM)(INT)(i),LVIR_EDITCOL(s)|LVLE_DONOTIFY))
#define		FastList_EndEditLabelNow(h,c)				((BOOL      )::SendMessage(h,LVM_ENDEDITLABELNOW,c,0))
#define		FastList_GetItem(h,p)						((BOOL      )::SendMessage(h,LVM_GETITEM,0,(LPARAM)(LV_ITEM*)(p)))
#define		FastList_GetCount(h)						((BOOL      )::SendMessage(h,LVM_GETITEMCOUNT,0,0))
#define		FastList_GetEditControl(h)					((HWND      )::SendMessage(h,LVM_GETEDITCONTROL,0,0))
#define		FastList_GetImageList(h,i)					((HIMAGELIST)::SendMessage(h,LVM_GETIMAGELIST,i,0))
#define		FastList_GetVisibleCount(h)					((UINT      )::SendMessage(h,LVM_GETVISIBLECOUNT,0,0))
#define		FastList_InsertItem(h,p)					((INT       )::SendMessage(h,LVM_INSERTITEM,0,(LPARAM)(LPLV_INSERTSTRUCT)(p)))
#define		FastList_FindItem(h,p,f)					((INT       )::SendMessage(h,LVM_FINDITEM ,(WPARAM)p,(LPARAM)f))
#define		FastList_CreateDragImage(h,i)				((HIMAGELIST)::SendMessage(h,LVM_CREATEDRAGIMAGE, 0, (LPARAM)(INT)(i)))
#define		FastList_CreateDragImageEx(h,i,s)			((HIMAGELIST)::SendMessage(h,LVM_CREATEDRAGIMAGE, s, (LPARAM)(INT)(i)))
#define		FastList_SetImageList(h,l,i)				((HIMAGELIST)::SendMessage(h,LVM_SETIMAGELIST,i,(LPARAM)(UINT)(HIMAGELIST)(l)))
#define		FastList_SetColumn(h,i,p)					((BOOL      )::SendMessage(h,LVM_SETCOLUMN,i,(LPARAM)(const LV_COLUMN*)(p)))
#define		FastList_GetColumn(h,i,p)					((BOOL      )::SendMessage(h,LVM_GETCOLUMN,i,(LPARAM)(LV_COLUMN*)(p)))
#define		FastList_SetColumnWidth(h,i,w)				((BOOL      )::SendMessage(h,LVM_SETCOLUMNWIDTH,i,w))
#define		FastList_GetColumnWidth(h,i)				((INT       )::SendMessage(h,LVM_GETCOLUMNWIDTH,i,0))
#define 	FastList_SetColumnOrderArray(h,n,p)			((BOOL      )::SendMessage(h,LVM_SETCOLUMNORDERARRAY,n,(LPARAM)(p)))
#define 	FastList_GetColumnOrderArray(h,n,p)			((BOOL      )::SendMessage(h,LVM_GETCOLUMNORDERARRAY,n,(LPARAM)(p)))
#define		FastList_GetStyle(h)						((DWORD     )::GetWindowLong(h,GWL_STYLE))
#define		FastList_SetStyle(h,d)	  					((DWORD     )::SetWindowLong(h,GWL_STYLE,d))
#define 	FastList_SetStyleEx(h,d,m)					((DWORD     )::SetWindowLong(h,GWL_STYLE,((d)&(m))|(::GetWindowLong(h,GWL_STYLE)&~(m))))
#define		FastList_GetItemRect(h,i,s,p,c)			    (*(INT*)p =((c)|(LVIR_COLTOSUB(s))),(BOOL)::SendMessage(h,LVM_GETITEMRECT,(WPARAM)(i),(LPARAM)(RECT*)(p)))
#define 	FastList_SetOption(h,i,o)					((LPARAM    )::SendMessage(h,LVM_GETSETOPTION,(i)|LVOP_WRITEOPTION,(LPARAM)(o)))
#define 	FastList_GetOption(h,i)						((LPARAM    )::SendMessage(h,LVM_GETSETOPTION,i,0))
#define 	FastList_RedrawItemsEx(h,i,s,x,y)			((INT       )::SendMessage(h,LVM_REDRAWITEMS_EX,((i)&0x00FFFFFF)|((s)<<24),((y)&0x00FFFFFF)|((x)<<24)))
#define 	FastList_InsertMulti(h,n,p)					((INT       )::SendMessage(h,LVM_INSERTMULTI,n,p))
#define 	FastList_InsertMultiPtr(h,n,p)				((INT       )::SendMessage(h,LVM_INSERTMULTIPTR,n,(LPARAM)p))
#define 	FastList_SetColumnAutoEdit(h,i,f,p)			((BOOL      )::SendMessage(h,LVM_COLUMNAUTOEDIT,(WPARAM)((f)&~LVAE_COL(-1))|LVAE_COL(i),(LPARAM)(p)))
#define 	FastList_SetTopIndex(h,i)					((INT       )::SendMessage(h,LVM_SETTOPINDEX,i,0))
#define 	FastList_SetDataField(h,p)					((INT       )::SendMessage(h,LVM_SETDATAFIELD ,0,(LPARAM)(p)))
#define 	FastList_SetItemStates(h,p)					((INT       )::SendMessage(h,LVM_SETITEMSTATES,0,(LPARAM)(p)))
#define 	FastList_SetFocuItem(h,i,s,v,l)				((INT       )::SendMessage(h,LVM_SETFOCUSITEM,(l)? ((v)? 0xC0000000|(WORD)s:0x40000000|(WORD)s):((v)? 0x80000000|(WORD)s:(WORD)s),i))

#define 	FastList_GetLineNumber(p)					(*(LPINT)(((p)->pText)-((sizeof(INT)+sizeof(LPBYTE))/sizeof(TCHAR))))

#define		FastList_SelectItem(h,i)					FastList_Select(h,i,LVNI_CARET)
#define 	FastList_SelectDropTarget(h,i)				FastList_Select(h,i,LVNI_DROPHILITE)
#define 	FastList_SelectSetFirstVisible(h,i)			FastList_Select(h,i,LVNI_FIRSTVISIBLE)

#define		FastList_SortItem(h,f,p)					ListView_SortItem(h,f,p)
#define 	FastList_GetNextSelected(h,i)			    ListView_GetNextItem(h, i,     LVNI_SELECTED)
#define 	FastList_GetFirstVisible(h)				    ListView_GetNextItem(h, NULL,  LVNI_FIRSTVISIBLE)
#define		FastList_GetLastVisible(h)					ListView_GetNextItem(h, NULL,  LVNI_LASTVISIBLE)
#define		FastList_GetFocus(h)						ListView_GetNextItem(h, NULL,  LVNI_FOCUS)
#define		FastList_GetFocusColumn(h)					((int)ListView_GetNextItem(h, NULL,  LVNI_FOCUSSUB))
#define		FastList_GetSelectionColumn(h)				((int)ListView_GetNextItem(h, NULL,  LVNI_CARETSUB))
#define		FastList_GetDropHilightColumn(h)			((int)ListView_GetNextItem(h, NULL,  LVNI_DROPHILITESUB))
#define		FastList_SetColorIndex(e,p)					{*(LPBYTE*)((e)->pText-sizeof(LPBYTE)/sizeof(TCHAR))=p;(e)->uTextColor=LV_CHARCOLOR;}

int			FastListRegister(HINSTANCE hInstance=0);



#endif
