//*****************************************************************************
//*
//*
//*		Allgemeine	Message Funktionen fr CHexView und CHexWnd
//*
//*
//*****************************************************************************
#ifndef		HEX_MESSAGE__H_INCLUDE
#define 	HEX_MESSAGE__H_INCLUDE

#if _MSC_VER >= 1000
#pragma once
#endif

//*****************************************************************************
//*
//*		Ansi-Message Funktionen
//*
//*****************************************************************************
//	HEX_PROC(CApp)		einfgen in CMainFrame.cpp 
//	ON_HEX_MESSAGE()	einfgen in CMainFrame.cpp in die MessageMap
//	DECLARE_HEX_PROC()	einfgen in CMainFrame.h   im public Teil

#define ON_HEX_MESSAGE()																\
				ON_MESSAGE(WM_HEXINFO,OnHexInfo)										

#define DECLARE_HEX_PROC()																\
				afx_msg LRESULT OnHexInfo(WPARAM wParam, LPARAM lParam);

#define HEX_PROC(CMainFrame)															\
				LRESULT CMainFrame::OnHexInfo(WPARAM wParam, LPARAM lParam)				\
				{																		\
				CView	*view=GetActiveView();											\
				if(!view)return 0;														\
				return view->SendMessage(WM_HEXINFO,wParam,lParam);									\
				}


//*****************************************************************************
//*
//*		Nachrichten Funktionen
//*
//*****************************************************************************


#define 	WM_HEXINFO			0x27F4	// Nachricht fr Info Funktion
#define 	HEX_SETCURSOR		0x0000	// Cursor-Offset  setzen
#define 	HEX_GETCURSOR		0x0001	// Cursor-Offset  lesen
#define 	HEX_SETSCROLL		0x0002	// Scroll-Offset  setzen
#define 	HEX_GETSCROLL		0x0003	// Scroll-Offset  lesen
#define 	HEX_SETMARKE		0x0004	// Marken-Offset  setzen
#define 	HEX_GETMARKE		0x0005	// Marken-Offset  lesen
#define 	HEX_SETADDRES		0x0006	// Basis -Adresse setzen
#define 	HEX_GETADDRES		0x0007	// Basis -Adresse lesen
#define 	HEX_GETMEMLEN		0x0008	// Speicherlnge  lesen

#define		HEXWND_SETCURSOR(Wnd,Addr)		(Wnd)->SendMessage(WM_HEXINFO,HEX_SETCURSOR,Addr)
#define		HEXWND_GETCURSOR(Wnd)			(Wnd)->SendMessage(WM_HEXINFO,HEX_GETCURSOR,0)
#define		HEXWND_SETSCROLL(Wnd,Addr)		(Wnd)->SendMessage(WM_HEXINFO,HEX_SETSCROLL,Addr)
#define		HEXWND_GETSCROLL(Wnd)			(Wnd)->SendMessage(WM_HEXINFO,HEX_GETSCROLL,0)
#define		HEXWND_SETADDRES(Wnd,Addr)		(Wnd)->SendMessage(WM_HEXINFO,HEX_SETADDRES,Addr)
#define		HEXWND_GETADDRES(Wnd)			(Wnd)->SendMessage(WM_HEXINFO,HEX_GETADDRES,0)
#define		HEXWND_SETMARKE(Wnd,Addr)		(Wnd)->SendMessage(WM_HEXINFO,HEX_SETMARKE ,Addr)
#define		HEXWND_GETMARKE(Wnd)			(Wnd)->SendMessage(WM_HEXINFO,HEX_GETMARKE ,0)
#define		HEXWND_GETMEMLEN(Wnd)			(Wnd)->SendMessage(WM_HEXINFO,HEX_GETMEMLEN,0)

#endif
