//*****************************************************************************
//*
//*
//*		HtmlBar.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2008
//
#include	"HtmlBar.h"
#include	"AfxMacros.h"
#include	"AfxUtility.h"
#include	"StringFunctions.h"


#ifdef     _DEBUG
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

#define 	ID_HTMLCTRL			0x4527			// Nachrichtenliste akualisieren
#define 	ID_DELAYTICKER		0x4528			// ID Fr Delay-Events
#define 	FRAME_X_ADD			10				// Breite des X-Rahmens bei Lasche
#define 	FRAME_Y_ADD			10				// Breite des X-Rahmens bei Lasche
#define 	FRAME_X				5				// Breite des X-Rahmens
#define 	FRAME_Z				0				// Breite des X-Rahmens
#define 	FRAME_Y				5				// Breite des Y-Rahmens
#define 	DELAY_MS			250				// Zeit fr Delay Ticker


//*****************************************************************************
//*
//*		Nachrichten
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CHtmlBar, CSizeBar)
	//{{AFX_MSG_MAP(CHtmlBar)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
//	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()

IMPLEMENT_DYNAMIC(CHtmlBar, CSizeBar)


//*****************************************************************************
//*
//*		Konstructor
//*
//*****************************************************************************
CHtmlBar::CHtmlBar()
{

	m_sChildRect.SetRectEmpty();				// Gre und Position Child Fenster

	m_bDelayOn	= 0;
	m_uDelay	= 0;

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CHtmlBar::~CHtmlBar()
{

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugen einer HtmlBar
BOOL CHtmlBar::Create(             CWnd *pParentWnd,DWORD dwStyle,UINT nID){return Create("",pParentWnd,dwStyle,nID);}
BOOL CHtmlBar::Create(LPCSTR pName,CWnd *pParentWnd,DWORD dwStyle,UINT nID)
{
CRect	sRect;



	ASSERT_VALID(pParentWnd);

	if(!CSizeBar::Create(pName,pParentWnd,CSize(320,320),nID,dwStyle))
		{
		return FALSE;
		}


	SetBarStyleEx(GetBarStyleEx()|SCBS_SHOWEDGES|SCBS_EDGETOP|SCBS_EDGEBOTTOM);

	if(!m_cHtmlClrl.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE,sRect,this,ID_HTMLCTRL))
		{
		return FALSE;
		}




return TRUE;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CHtmlBar::OnDestroy()
{
	CSizeBar::OnDestroy();
}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CHtmlBar::OnSize(UINT nType,int iXsize,int iYsize)
{

	CSizeBar::OnSize(nType,iXsize,iYsize);



	if(iXsize>0  && iYsize>0)
	if(IsWindow(m_cHtmlClrl.m_hWnd))						// Liste einstellen
		{
		GetClientRect(&m_sChildRect);
		m_cHtmlClrl.MoveWindow(m_sChildRect);
		m_cHtmlClrl.ShowWindow(SW_SHOW);
		}

}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CHtmlBar::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_DELAYTICKER)
		{
		if(m_uDelay>=DELAY_MS)
			{
			m_bDelayOn=FALSE;
			KillTimer(ID_DELAYTICKER);
			m_cHtmlClrl.Navigate2(m_cDelayUrl);
			return;
			}

		m_uDelay -= DELAY_MS;
		return;
		}

	CSizeBar::OnTimer(nIdEvent);

}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CHtmlBar::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
CMenu		sMenu;


	sMenu.CreatePopupMenu();
	//sMenu.AppendMenu(MF_STRING,ID_MSGBAR_COPY ,_T("&Kopieren"));
	//sMenu.EnableMenuItem(ID_MSGBAR_COPY,MF_DISABLED|MF_GRAYED);

	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		Refresh
//*
//*****************************************************************************
void CHtmlBar::Refresh()
{
	m_cHtmlClrl.Refresh();
}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
void CHtmlBar::Stop()
{
	m_cHtmlClrl.Stop();
}

//*****************************************************************************
//*
//*		GoBack
//*
//*****************************************************************************
void CHtmlBar::GoBack()
{
	m_cHtmlClrl.GoBack();
}

//*****************************************************************************
//*
//*		GoForward
//*
//*****************************************************************************
void CHtmlBar::GoForward()
{
	m_cHtmlClrl.Refresh();
}

//*****************************************************************************
//*
//*		Navigate
//*
//*****************************************************************************
void CHtmlBar::Navigate(LPCTSTR pUrl,unsigned uDelay)
{

	if(uDelay==0)
		{
		m_cHtmlClrl.Navigate2(pUrl);
		return;
		}


	m_uDelay = uDelay;
	strlcpy(m_cDelayUrl,pUrl,sizeof(m_cDelayUrl));


	if(m_bDelayOn)
		{
		m_bDelayOn = TRUE;
		SetTimer(ID_DELAYTICKER,DELAY_MS,NULL);
		}


}


