//*****************************************************************************
//*
//*
//*		HtmlDlg.h
//*
//*
//*****************************************************************************
#ifndef		AFX_HTMLDLG_H__1434E496_22A5_4AC0_8832_99123A819D3B__INCLUDED_
#define		AFX_HTMLDLG_H__1434E496_22A5_4AC0_8832_99123A819D3B__INCLUDED_	

#if		   _MSC_VER > 1000
#pragma		once						
#endif

#include	"HtmlCtrl.h"
#include	"AfxMacros.h"

#define 	CHT_HAS_OK		0x01				// OK-Button vorhanden
#define 	CHT_HAS_CANCEL	0x02				// Abbruch-Button vorhanden
#define 	CHT_ENABLE_OK	0x04				// OK-Button erst freigeben wenn gewhlt


//*****************************************************************************
//*
//*		Dialogfeld CHtmlDlg
//*
//*****************************************************************************
class CHtmlDlg : public CDialog
{
public:

	CHtmlDlg(CWnd *pParent=NULL);	  

	//{{AFX_DATA(CHtmlDlg)
	BOOL	m_bSelected;
	//}}AFX_DATA

	void	SetUrl     (LPCTSTR pText);			// URL fr die HTML-Seite laden
	void	SetText    (LPCTSTR pText);			// Text fr Check-Box setzen
	void	SetTitle   (LPCTSTR pText);			// Titel fr Dialog setzen
	DWORD	SetMode    (DWORD dwFlags);			// Anzeigemodus anpassen
	DWORD	GetMode    ();						// Anzeigemodus abfragen
	BOOL	IsSelected ();
	BOOL	SetSelected(BOOL bSet);



	//{{AFX_VIRTUAL(CHtmlDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	
	//}}AFX_VIRTUAL

protected:

	CString			m_sUrl;
	CString			m_sText;
	CString			m_sTitle;
	CHtmlCtrl		m_cHtml;
	DWORD			m_dwFlags;
	static HICON	m_hMainIcon;	
	static WORD		m_wDlgData[];

	//{{AFX_MSG(CHtmlDlg)
	afx_msg void OnTimer(UINT_PTR nIdEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnLoadUrl();
	virtual void OnCancel();
	afx_msg void OnCheck();
	afx_msg void OnOk2();
	virtual void OnOK();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_DLG_OLDSIZE()
	DECLARE_DLG_SIZING()

};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	BOOL	CHtmlDlg::SetSelected(BOOL bSet){BOOL bOld=m_bSelected;m_bSelected=bSet;return bOld;}  
inline	BOOL	CHtmlDlg::IsSelected(){return m_bSelected;}  
inline	DWORD	CHtmlDlg::GetMode   (){return m_dwFlags;}
inline	DWORD	CHtmlDlg::SetMode   (DWORD dwFlags){DWORD dwOld=m_dwFlags;m_dwFlags=dwFlags;return dwOld;}
inline	void	CHtmlDlg::SetTitle  (LPCTSTR pText){m_sTitle=pText;}
inline	void	CHtmlDlg::SetText   (LPCTSTR pText){m_sText =pText;}
inline	void	CHtmlDlg::SetUrl    (LPCTSTR pText){m_sUrl  =pText;}


//{{AFX_INSERT_LOCATION}}

#endif
