//*****************************************************************************
//*
//*
//*		InfoWindow.h
//*
//*
//*****************************************************************************
//	
//	InfoWindow ist ein Grafikfenster mit dem man schnell und einfach 
//	grafische Informationen anzeigen kann:
//
//	Funktion:
//
//		BitmapImage	  *pImage;
//	
//		pImage = InfoWindowCreate(320,200,"MeinText");		//	Fenster erstellen
//
//		for(;;)
//			{
//			pImage->Box(10,10,30,30,RGB(0,255,0));
//			pImage->Print(10,40,"Hallo");	
//			...
//			InfoWindowUpdate(pImage);
//			}
//			
//		InfoWindowDelete(pImage);							//	Fenster entfernen
//	
#ifndef 	__INFOWINDOW_H__
#define 	__INFOWINDOW_H__


#include		"Image/BitmapImage.h"

extern	unsigned char aFontCourier8[];
extern	unsigned char aFontCourier10[];
extern	unsigned char aFontCourier12[];
extern	unsigned char aFontCourier14[];
extern	unsigned char aFontArial6[];
extern	unsigned char aFontArial8[];
extern	unsigned char aFontArial10[];
extern	unsigned char aFontArial12[];
extern	unsigned char aFontArial14[];
extern	unsigned char aFontMicro6[];
extern	unsigned char aFontMicroVar6[];


BitmapImage	   *InfoWindowCreate(int iSizeX,int iSizeY,const char *pText="Info",int iBits=32);
int				InfoWindowDelete(BitmapImage *pWindow);
void 			InfoWindowUpdate(BitmapImage *pWindow);



#endif 	