//*****************************************************************************
//*
//*
//*		PathCtrl.cpp
//*
//*
//*****************************************************************************
#include	<wchar.h>
#include	<string.h>
#include	<AfxOle.h>
#include	"FileFunctions.h"
#include	"StringFunctions.h"
#include	"WinExtension.h"
#include	"PathCtrl.h"

#ifdef	    _MSC_VER
#pragma		 warning( disable :4996 )
#endif

#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	 WM_THREADMSG			0x3417
#define 	 ID_PATHCOPY			0x3418
#define 	 ID_NAMECOPY			0x3419
#define 	 ID_TICKER				0x341A
#define 	 ID_EDITPOS				0x341B
#define 	 ID_ICONPOS				0x0100
#define 	 ID_TEXTPOS				0x0101
#define 	 ID_DROPDOWN			0x0102
#define 	 ID_THREADINIT			0x0001
#define 	 ID_THREADEXIT			0x0002
#define 	 ID_THREADDONE			0x0003
#define 	 CPC_LIST_HEIGHT		450
#define 	 CPC_LIST_WIDTH			280
#define 	 CPC_LIST_MIN			90
#define 	 CPC_TEXT_FRAME			8
#define 	 CPC_ICON_FRAME			4
#define		 CF_TEXT_EX				((sizeof(TCHAR)>1)? CF_UNICODETEXT:CF_TEXT)
#define 	 DT_COMMON				(DT_CENTER|DT_VCENTER|DT_NOCLIP|DT_SINGLELINE|DT_NOPREFIX)

BEGIN_MESSAGE_MAP(CPathCtrl,CComboBox)
	//{{AFX_MSG_MAP(CBitmapWnd)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_DESTROY()
	ON_WM_DROPFILES()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_STYLECHANGING()
	ON_EN_CHANGE(1001,OnEditChange)
	ON_MESSAGE(WM_SETTEXT		,OnSetText)
	ON_MESSAGE(WM_GETTEXT		,OnGetText)
	ON_MESSAGE(WM_GETTEXTLENGTH	,OnGetTextLen)
	ON_MESSAGE(WM_THREADMSG   	,OnThreadMsg)
	ON_MESSAGE(WM_MOUSELEAVE  	,OnMouseLeave)
	ON_MESSAGE(CB_SETCURSEL   	,OnSetCurSel)
	ON_MESSAGE(CB_SELECTSTRING	,OnSelString)
	ON_COMMAND(ID_PATHCOPY	  	,OnCopyPath)
	ON_COMMAND(ID_NAMECOPY	  	,OnCopyName)
	ON_CONTROL_REFLECT(CBN_CLOSEUP,OnCloseUp)
	ON_NOTIFY(LVN_GETDISPINFO 	,0,OnGetListItem)
	ON_NOTIFY(NM_CLICK        	,0,OnListItemClick)
	//}}AFX
END_MESSAGE_MAP()


typedef	HRESULT (WINAPI *SetWindowThemeT )(HWND,LPCWSTR,LPCWSTR);
typedef	LPVOID  (WINAPI *OpenThemeDataT  )(HWND hwnd,LPCWSTR pszClassList);
typedef	HRESULT (WINAPI *CloseThemeDataT )(LPVOID);
typedef	HRESULT (WINAPI *DrawThemeBackgT )(LPVOID,HDC,int,int,const RECT*,const RECT*);
typedef	HRESULT (WINAPI *GetThemeBackgRcT)(LPVOID,HDC,int,int,LPCRECT,LPRECT);
typedef	HRESULT (WINAPI *GetThemeMetricT )(LPVOID,HDC,int,int,int,int*);
typedef	HRESULT (WINAPI *GetThemePartSzT )(LPVOID,HDC,int,int,LPCRECT,int,LPSIZE);
typedef	HRESULT (WINAPI *DrawThemeEdgeT  )(LPVOID,HDC,int,int,LPCRECT,UINT,UINT,LPRECT);


static SetWindowThemeT	pSetWindowTheme	= NULL;
static OpenThemeDataT	pOpenThemeData	= NULL;
static CloseThemeDataT	pCloseThemeData	= NULL;
static DrawThemeBackgT	pDrawThemeBackg	= NULL;
static DrawThemeEdgeT 	pDrawThemeEdge  = NULL;
static GetThemeBackgRcT	pGetThemeBackgRc= NULL;
static GetThemePartSzT	pGetThemePartSz = NULL;

HFONT		CPathCtrl::m_hFontText		= 0;				// Font fr den Text
HFONT		CPathCtrl::m_hFontChar		= 0;				// Font fr den Spezialzeichen
HIMAGELIST	CPathCtrl::m_hImageList		= 0;				// Handle fr Icon-Liste
INT			CPathCtrl::m_iPathImage		= 0;				// Standart Icon fr Pfade
INT			CPathCtrl::m_iImagesSizeX	= 0;				// Gre der Icons
INT			CPathCtrl::m_iImagesSizeY	= 0;				//		*
INT			CPathCtrl::m_iItemHeight	= 0;				// Ist die Hhe eines Listeneintrages
INT			CPathCtrl::m_iItemStart		= 0;				// Ist die Icon-Breite in der Liste
INT			CPathCtrl::m_iFontHeight	= 0;				// Ist die Schriftgre
INT			CPathCtrl::m_iRawHeight		= 0;				// Ist die Zeilengre
HMODULE		CPathCtrl::m_hUxThemeDll	= NULL;				// Handle von UxTheme.dll
UINT		CPathCtrl::m_uKeyPos		= 0;				// Aktuelle Position im Textspeicher
DWORD		CPathCtrl::m_uKeyLast		= 0;				// Tick der letzten Tasteneingabe
TCHAR		CPathCtrl::m_cKeyData[16];						// Textspeicher

CCriticalSection	CPathCtrl::m_sLock;




//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CPathCtrl::CPathCtrl()
{

	m_cPath[0]			= 0;								// Aktueller Pfad
	m_aPathOffset[0]	= 0;								// Offset der Unterpfade
	m_iFolders			= 0;								// Anzahl der Folder
	m_iFolderIcon		=-1;								// Icon des Folders
	m_iListMax			=16;								// Maximale Lnge der Liste
	m_iListLast			= 0;								// Welche Liste war gewhlt
	m_iListCol			= 0;								// Spalte der aktiven Liste
	m_iListSel			=-1;								// Welche Liste ist gewhlt
	m_iListBits			=-1;								// Welche Liste ist aktiv
	m_iSegSel			=-1;								// Ausgewhlter Abschnitt
	m_iKeySel			=-1;								// Ausgewhlter Abschnitt via Tastatur
	m_hEdit				= 0;								// Handle vom Edit-Fenster
	m_hWnd				= 0;								// Handle vom Fenster
	m_iBasePos			= 0;								// Position des ersten Unterpfade
	m_iBaseEnd			= 0;								// Letztes sichtbares Segment
	m_iBaseOffset		= 0;								// Index des ersten Unterpfade
	m_uLastDrives		= 0;								// Zuletzt eingefgte Laufwerke
	m_pThreadData		= 0;								// Zeiger auf die Dateisuchklasse
	m_iHistoryPos		= 0;								// Position in der Historie
	m_iHistoryMax		= 50;								// Maximale Anzahl an Historieeintrgen

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CPathCtrl::~CPathCtrl()
{
	m_sLock.Lock();

	if(m_pThreadData && m_pThreadData->uInitOk<2)			// Den Thread beenden
		{
		m_pThreadData->uCommand = 0xFFFFFFFF;
		m_pThreadData->uInitOk	= 2;
		m_pThreadData->sFind.Break();
		m_pThreadData->sSem.Unlock();
		}

	m_sLock.Unlock();

}

//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
BOOL CPathCtrl::CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID)
{
BOOL	bOk;


	GlobalInit();
	LocalInit(dwStyle);

		bOk = CWnd::CreateEx(dwExStyle|WS_EX_ACCEPTFILES,_T("COMBOBOX"),_T(""),(dwStyle&~0x000F)|CBS_DROPDOWN|CBS_OWNERDRAWFIXED|CBS_HASSTRINGS|CBS_AUTOHSCROLL,sRect,pParentWnd,nID);
	if(!bOk)return FALSE;


return PostInit();
}

//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
//	Erzeugt das Fenster ber einem Dialog-Item.
BOOL CPathCtrl::CreateEx(DWORD dwExStyle,DWORD dwStyle,unsigned uId,CDialog *pDlg,UINT nID)
{
CPoint	sPoint(0,0);
CRect	sRect;
CWnd   *pWnd;


	m_cEditPath[0] = 0;
	pWnd=pDlg->GetDlgItem(uId);
	ASSERT(pWnd!=0);


	pWnd->GetWindowRect (&sRect);
	pDlg->ClientToScreen(&sPoint);

	sRect.left	  -= sPoint.x;
	sRect.right   -= sPoint.x;
	sRect.top	  -= sPoint.y;
	sRect.bottom  -= sPoint.y;

	if(!CreateEx(dwExStyle,dwStyle,sRect,pDlg,nID))
		{
		return FALSE;
		}

	SetWindowPos(pWnd,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOREDRAW);


return TRUE;
}

//*****************************************************************************
//*
//*		PostInit
//*
//*****************************************************************************
BOOL CPathCtrl::PostInit()
{
CRect	sRect1;
CRect	sRect2;
HANDLE	hThread;
DWORD	uThread;
DWORD	uPos;


	m_bEditCheck = 0;	

	#if _MSC_VER <= 1299
	m_cDirList.CreateEx      (0,WC_LISTVIEW,NULL,WS_BORDER|WS_POPUP|LVS_REPORT|LVS_NOCOLUMNHEADER|LVS_SINGLESEL|LVS_SHAREIMAGELISTS|LVS_OWNERDATA,0,0,0,0,m_hWnd,NULL,NULL);
	#else
	m_cDirList.CreateEx      (0,WS_BORDER|WS_POPUP|LVS_REPORT|LVS_NOCOLUMNHEADER|LVS_SINGLESEL|LVS_SHAREIMAGELISTS|LVS_OWNERDATA,CRect(0,0,0,0),CWnd::FromHandle(m_hWnd),0);
	#endif 

	m_cDirList.SetBkColor    (GetSysColor(COLOR_MENU));
	m_cDirList.SetTextBkColor(GetSysColor(COLOR_MENU));
	m_cDirList.SetImageList  (CImageList::FromHandle(m_hImageList),LVSIL_SMALL);
	m_cDirList.InsertColumn  (0,_T("AAA"),LVCFMT_LEFT,250,-1);
	m_cDirList.SetExtendedStyle(LVS_EX_TRACKSELECT|LVS_EX_FULLROWSELECT);
	m_cDirList.SetHoverTime  (30);


	if(m_iItemHeight==0)									// Abmessungen der Listeneintrge
		{
		m_cDirList.InsertItem(0,_T(""),m_iPathImage);
		m_cDirList.InsertItem(1,_T(""),m_iPathImage);
		m_cDirList.GetItemRect(0,&sRect1,LVIR_LABEL);
		m_cDirList.GetItemRect(1,&sRect2,LVIR_LABEL);

		m_iItemStart  = sRect2.left;
		m_iItemHeight = sRect2.top-sRect1.top;

		if(m_iItemHeight<m_iImagesSizeY+2)
			{
			m_iItemHeight = m_iImagesSizeY+2;
			}

		if(m_iItemStart<m_iImagesSizeX+2)
			{
			m_iItemStart = m_iImagesSizeX+2;
			}

		m_iItemStart += 8;
		}


	if(pOpenThemeData)										// Thema initialisieren
			m_hTheme = pOpenThemeData(m_hWnd,L"Header");
	else	m_hTheme = NULL;

	if(!m_hEdit)
		{
		m_hEdit   =      ::GetWindow (m_hWnd ,GW_CHILD);
		if(m_bBreadCrumb)::ShowWindow(m_hEdit,SW_HIDE );
		}

	           SendMessage(WM_SETFONT,(WPARAM)m_hFontText,0);
	m_cDirList.SendMessage(WM_SETFONT,(WPARAM)m_hFontText,0);

	SetWindowLongPtr(m_hEdit          ,GWL_USERDATA,(LPARAM)this);
	SetWindowLongPtr(m_cDirList.m_hWnd,GWL_USERDATA,(LPARAM)this);
	m_pOldEdit	  = (WNDPROC)SetWindowLongPtr(m_hEdit          ,GWL_WNDPROC,(LPARAM)EditProc);
	m_pOldList	  = (WNDPROC)SetWindowLongPtr(m_cDirList.m_hWnd,GWL_WNDPROC,(LPARAM)ListProc);
	EditPos();

	for(uPos=0;uPos<CPC_MAX_FOLDERS;uPos++)					// Verzeichnis-Slots initialisieren
		{
		m_aPathDirs  [uPos].DataLength(sizeof(DirData));
		m_aPathDirs  [uPos].SetUserData(-1);
		m_aPathWidth [uPos] = CPC_LIST_WIDTH;
		m_aPathHeight[uPos] = CPC_LIST_HEIGHT;
		}

															// Thread fr Dateisuche starten
		hThread = CreateThread(NULL,0x10000,SearchThread,m_hWnd,0,&uThread);
	if(!hThread)
		{
		m_cDirList.DestroyWindow();
		DestroyWindow();
		return FALSE;
		}

	CloseHandle(hThread);
	DragAcceptFiles(m_bAllowDrop);


return TRUE;
}

//*****************************************************************************
//*
//*		LocalInit
//*
//*****************************************************************************
void CPathCtrl::LocalInit(DWORD dwStyle)
{

	m_bTabExit    = (dwStyle&CPC_TABEXIT	  )? 1:0;		// Fokus zum Eltern-Fenster bei TAB
	m_bAllowDrag  =	(dwStyle&CPC_ALLOWDRAG	  )? 1:0;		// Dateien per Drag weiter geben
	m_bAllowDrop  = (dwStyle&CPC_ALLOWDROP	  )? 1:0;		// Hinzufgen von Pfaden per Drag & Drop
	m_bMustExist  = (dwStyle&CPC_PATHMUSTEXIST)? 1:0;		// Muss der Pfad existieren
	m_bAddWihtRet = (dwStyle&CPC_ADDWITHENTER )? 1:0;		// Pfade mit Enter in die Liste einfgen
	m_bHasHistory = (dwStyle&CPC_HASHISTORY	  )? 1:0;		// Hat das Fenster eine Historie
	m_bNoNetPaths = (dwStyle&CPC_NONETDIRS    )? 1:0;		// Keine Netzwerkspfade
   	m_bBreadCrumb = (dwStyle&CPC_NOBREADCRUMB )? 0:1;		// Brotkrmel-Navigation
	m_iButtonSize = GetSystemMetrics(SM_CXHSCROLL);			// Tastenbreite
	m_iButtonMode = HIS_NORMAL;								// Zustand der Taste
	m_bTickerOn	  = false;									// Ist der Ticker ein
	m_pOldEdit	  = NULL;									// Alte Edit-Fenster Funktion
	m_pOldList	  = NULL;									// Alte List-Fenster Funktion
	m_bEditOn	  = !m_bBreadCrumb;							// Ist der Pfad sichtbar
	m_bListOn	  = 0;										// Ist die Verzeichnisliste ein
	m_iTurn		  = 0;										// Aktueller Umlauf

}

//*****************************************************************************
//*
//*		GlobalInit
//*
//*****************************************************************************
void CPathCtrl::GlobalInit()
{
IMAGEINFO		sInfo;
LOGFONT			sLog;



	if(!m_hFontText)										// Die Fonts erzeugen
		{
		SystemParametersInfo(SPI_GETICONTITLELOGFONT,sizeof(sLog),&sLog,0);
		m_hFontText   = CreateFontIndirect(&sLog);
		m_iFontHeight = (sLog.lfHeight<0)? -sLog.lfHeight:sLog.lfHeight;
		_tcscpy(sLog.lfFaceName,_T("Marlett"));
		m_hFontChar   = CreateFontIndirect(&sLog);
		}

	if(!m_hImageList)										// Image-Liste initialisieren
		{
		m_hImageList   = CIconChache::GetImageList();
		m_iPathImage   = CIconChache::GetPathIcon(SHGFI_SMALLICON);

		ImageList_GetImageInfo(m_hImageList,0,&sInfo);

		m_iImagesSizeX = sInfo.rcImage.right -sInfo.rcImage.left;
		m_iImagesSizeY = sInfo.rcImage.bottom-sInfo.rcImage.top;
		}

	if(!m_hUxThemeDll)										// Mit Thema zeichnen	
		{
		   m_hUxThemeDll = LoadLibrary(_T("UxTheme.dll"));
		if(m_hUxThemeDll)
			{
			pSetWindowTheme  = (SetWindowThemeT )GetProcAddress(m_hUxThemeDll,"SetWindowTheme"     );
			pOpenThemeData   = (OpenThemeDataT  )GetProcAddress(m_hUxThemeDll,"OpenThemeData"	   );
			pCloseThemeData  = (CloseThemeDataT )GetProcAddress(m_hUxThemeDll,"CloseThemeData"	   );
			pDrawThemeBackg  = (DrawThemeBackgT )GetProcAddress(m_hUxThemeDll,"DrawThemeBackground");
			pGetThemePartSz  = (GetThemePartSzT )GetProcAddress(m_hUxThemeDll,"GetThemePartSize"   );
			pDrawThemeEdge	 = (DrawThemeEdgeT  )GetProcAddress(m_hUxThemeDll,"DrawThemeEdge"	   );
			pGetThemeBackgRc = (GetThemeBackgRcT)GetProcAddress(m_hUxThemeDll,"GetThemeBackgroundContentRect");
			}
		}


	if(m_iFontHeight>m_iImagesSizeY)
		{
		m_iRawHeight = m_iFontHeight+2;
		}
	else{
		m_iRawHeight = m_iImagesSizeY+2;
		}


}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CPathCtrl::OnDestroy()
{

	m_sLock.Lock();

	if(m_pThreadData && m_pThreadData->uInitOk<3)			// Den Thread beenden
		{
		m_pThreadData->uCommand = 0xFFFFFFFF;
		m_pThreadData->uInitOk	= 2;
		m_pThreadData->sFind.Break();
		m_pThreadData->sSem.Unlock();
		}

	m_sLock.Unlock();

	CComboBox::OnDestroy();

}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CPathCtrl::OnPaint()
{
PAINTSTRUCT		sPaint;
CRect			sRect;
CRect			sBase;
CRect			sDraw;
LPCTSTR			pText;
int				iPosX;
int				iPosY;
int				iStep;
int				iDiff;
int				iAddY;
int				iNext;
int				iMark;
int				iSel;
int				iEnd;
HDC				hDc;


	if(m_iWndSizeX<=0 || m_iWndSizeY<=0)					// Ist das Fenster sichtbar
		{
		return;
		}

	hDc = ::BeginPaint(m_hWnd,&sPaint);

	sRect.left		= 0;
	sRect.right		= m_iWndSizeX;
	sRect.top		= 0;
	sRect.bottom	= m_iWndSizeY;
	iEnd			= m_iFolders*2;

	if(iEnd>0)												// Letztes Segment nicht zeichnen
	if(m_aPathDirs[m_iFolders-1].Count()==0)
	if(m_aPathDirs[m_iFolders-1].GetUserData()==m_iTurn)
		{
		iEnd--;
		}


	if(m_bListOn && m_iKeySel<0)							// Ist die Liste herunter geklappt
		{
		if(m_iSegSel<0 || m_iSegSel>m_iBaseEnd)
			{
			   m_iKeySel = m_iListLast;
			if(m_iKeySel>m_iFolders*2)
				{
				m_iKeySel = m_iFolders*2;
				}
			}
		else{
			m_iKeySel = (m_iSegSel+1)&~1;
			}
		}


	if(m_iKeySel>0)											// Doppelsegment ber Tastatur gewhlt
		{
		iMark	= 0x1819;
		iSel	= m_iKeySel-1;
		}
	else if(m_iKeySel==0)									// Linkes Einzelsegment ber Tastatur gewhlt
		{
		iMark	= 0x0018;
		iSel	= 0;
		}
	else if(m_iSegSel<0)									// Kein Segment unter Mauszeiger
		{
		iSel	= -1;
		iMark	= 0x0000;
		}
	else if(m_iSegSel&1)									// Graues Segment ist rechts
		{
		iMark	= 0x1018;
		iSel	= m_iSegSel;
		}
	else{													// Graues Segment ist links
		iMark	= 0x1812;
		iSel	= m_iSegSel-1;
		}

	if(iMark && iSel<m_iBasePos)							// Markierte Segmente vor Anzeigebeginn
		{
		iSel   += 1;
		iMark >>= 8;

		if(iSel<m_iBasePos)
			{
			iMark =  0;
			iSel  = -1;
			}
		else if(!(iMark&8))
			{
			iMark = 0x16;
			}
		}

	if(iMark>0xFF && iSel==m_iBaseEnd-1)					// Letztes Segment entfernen
		{
		iMark = (iMark&8)? 0x18:0x16;
		}

	if(m_bListOn)											// Ist die Liste herunter geklappt
		{
		iMark |= (iMark<=0xFF)? 0x20:0x2020;
		}

	if(m_hTheme)											// Mit Thema zeichnen
		{
		pDrawThemeEdge(m_hTheme,hDc,HP_HEADERITEM,HIS_NORMAL,&sRect,BDR_SUNKENOUTER,BF_RECT|BF_ADJUST,&sBase);

		sDraw.top	= sBase.top;
		sDraw.bottom= sBase.bottom+2;
		sDraw.right	= sBase.right;
		sDraw.left	= sBase.left+m_iButtonSize+CPC_ICON_FRAME;

		iPosX		= sBase.left+CPC_ICON_FRAME/2;			// Icon ausgeben
		iPosY		= sBase.top+(sBase.Height()-m_iImagesSizeY)/2;


		SelectObject(hDc,GetSysColorBrush(COLOR_WINDOW));
		SelectObject(hDc,GetStockObject(NULL_PEN));
		SelectObject(hDc,m_hFontChar);
		SetBkMode   (hDc,TRANSPARENT);

		Rectangle   (hDc,sBase.left          ,sBase.top           ,sDraw.left+2,iPosY+1               );
		Rectangle   (hDc,sBase.left          ,iPosY+m_iImagesSizeY,sDraw.left+2,sRect.bottom          );
		Rectangle   (hDc,sBase.left          ,iPosY               ,iPosX+1     ,iPosY+m_iImagesSizeY+1);
		Rectangle   (hDc,iPosX+m_iImagesSizeY,iPosY               ,sDraw.left+2,iPosY+m_iImagesSizeY+1);

//		ImageList_SetBkColor(m_hImageList,GetSysColor(COLOR_WINDOW));
//		ImageList_Draw(m_hImageList,m_iFolderIcon,hDc,iPosX,iPosY,ILD_NORMAL);
		ImageList_DrawEx(m_hImageList,m_iFolderIcon,hDc,iPosX,iPosY,m_iImagesSizeX,m_iImagesSizeY,GetSysColor(COLOR_WINDOW),CLR_NONE,ILD_NORMAL);


		if(!m_bEditOn)
		for(iStep=m_iBasePos;iStep<m_iBaseEnd;iStep++)		// Pfadsegmente zeichnen
			{
			iDiff  = m_aPathStart[iStep+1];
			iDiff -= m_aPathStart[iStep  ];
			pText  = _T("\x34");
			iNext  = sDraw.left+iDiff;
			iAddY  = 2;

			if(iStep<iSel || iMark==0)
				{
				sDraw.right = iNext;
				Rectangle(hDc,sDraw.left,sDraw.top,sBase.right+1,sDraw.bottom-1);
				}
			else{
				if(iMark&0x04)
					{
					sDraw.right = sDraw.left+4;
					pDrawThemeBackg(m_hTheme,hDc,HP_HEADERITEMLEFT,HIS_NORMAL,&sDraw,NULL);
					}

				if(iMark&0x20)
					{
					if(iSel&1)iAddY=0;
					pText=_T("\x36");
					}

				sDraw.right   = iNext+(iMark&1);
				pDrawThemeBackg(m_hTheme,hDc,(iMark&2)? HP_HEADERITEMLEFT:HP_HEADERITEM,(iMark&8)? HIS_HOT:HIS_NORMAL,&sDraw,NULL);
				sDraw.right   = iNext;
				iMark		>>= 8;
				}

			if(iStep&1)
				{
				sDraw.top -= iAddY;
				SelectObject(hDc,m_hFontText);
				DrawText    (hDc,m_cPath+m_aPathOffset[iStep/2],m_aPathSize[iStep/2],&sDraw,DT_COMMON);
				sDraw.top += iAddY;
				}
			else{
				SelectObject(hDc,m_hFontChar);
				DrawText    (hDc,pText,1,&sDraw,DT_COMMON);
				}

			sDraw.left = sDraw.right;
			}


		sDraw.right = sBase.right-m_iButtonSize;

		if(sDraw.left<=sDraw.right)							// Leerbereich zwischen Pfad und DropDown
			{
			Rectangle(hDc,sDraw.left,sDraw.top,sBase.right+1,sDraw.bottom-1);
			}

		sDraw.left	= sDraw.right;							// Drop-Down-Taste zeichnen
		sDraw.right	= sBase.right;

		if(sDraw.left<sBase.left)sDraw.left=sBase.left;

		pDrawThemeBackg(m_hTheme,hDc,(m_iButtonMode==HIS_NORMAL)? HP_HEADERITEMLEFT:HP_HEADERITEM,m_iButtonMode,&sDraw,NULL);
		if(m_iButtonMode==HIS_PRESSED)sDraw.top += 2;
		SelectObject(hDc,m_hFontChar);
		DrawText(hDc,_T("\x36"),1,&sDraw,DT_COMMON);
		}
	else{													// Ohne Thema zeichnen
		SelectObject(hDc,GetStockObject(BLACK_PEN));		// Rahmen um das Fenster
		SelectObject(hDc,GetStockObject(NULL_BRUSH));
		Rectangle   (hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);

		sDraw.top	 = sRect.top;
		sDraw.right	 = sRect.right;
		sDraw.bottom = sRect.bottom;
		sDraw.left	 = m_iButtonSize+CPC_ICON_FRAME+1;

		iPosX		 = sRect.left+CPC_ICON_FRAME/2+1;		// Icon ausgeben
		iPosY		 = sRect.top+(sRect.Height()-m_iImagesSizeY)/2;

		SetBkMode   (hDc,TRANSPARENT);
		SelectObject(hDc,GetStockObject(NULL_PEN));
		SelectObject(hDc,GetSysColorBrush(COLOR_WINDOW));
		Rectangle   (hDc,sRect.left+1        ,sRect.top+1         ,sDraw.left+2,iPosY+1               );
		Rectangle   (hDc,sRect.left+1        ,iPosY+m_iImagesSizeY,sDraw.left+2,sRect.bottom          );
		Rectangle   (hDc,sRect.left+1        ,iPosY               ,iPosX+1     ,iPosY+m_iImagesSizeY+1);
		Rectangle   (hDc,iPosX+m_iImagesSizeY,iPosY               ,sDraw.left+2,iPosY+m_iImagesSizeY+1);

//		ImageList_SetBkColor(m_hImageList,GetSysColor(COLOR_WINDOW));
//		ImageList_Draw(m_hImageList,m_iFolderIcon,hDc,iPosX,iPosY,ILD_NORMAL);
		ImageList_DrawEx(m_hImageList,m_iFolderIcon,hDc,iPosX,iPosY,m_iImagesSizeX,m_iImagesSizeY,GetSysColor(COLOR_WINDOW),CLR_NONE,ILD_NORMAL);

		if(!m_bEditOn)
		for(iStep=m_iBasePos;iStep<m_iBaseEnd;iStep++)		// Pfadsegmente zeichnen
			{
			iDiff  = m_aPathStart[iStep+1];
			iDiff -= m_aPathStart[iStep  ];
			pText  = _T("\x34");
			iAddY  = 0;

			sDraw.right = sDraw.left+iDiff;

			if(iStep<iSel || !iMark)
				{
				SelectObject(hDc,GetStockObject(NULL_PEN));
				SelectObject(hDc,GetSysColorBrush(COLOR_WINDOW));
				Rectangle   (hDc,sDraw.left,sDraw.top+1,sDraw.right+1,sDraw.bottom);
				}
			else{
				if(iMark&0x20)
					{
					if(iSel&1)iAddY=-2;
					pText=_T("\x36");
					}

				SelectObject(hDc,GetSysColorBrush((iMark&8)? COLOR_HIGHLIGHT:COLOR_WINDOW));
				SelectObject(hDc,GetStockObject(BLACK_PEN));
				Rectangle   (hDc,sDraw.left,sDraw.top,sDraw.right+((iMark&0xFF00)? (iStep&1):0),sDraw.bottom);
				iMark >>= 8;
				}

			if(iStep&1)
				{
				sDraw.top -= iAddY;
				SelectObject(hDc,m_hFontText);
				DrawText    (hDc,m_cPath+m_aPathOffset[iStep/2],m_aPathSize[iStep/2],&sDraw,DT_COMMON);
				sDraw.top += iAddY;
				}
			else{
				SelectObject(hDc,m_hFontChar);
				DrawText    (hDc,pText,1,&sDraw,DT_COMMON);
				}

			sDraw.left = sDraw.right;
			}

		sDraw.right = sRect.right-m_iButtonSize-1;

		if(sDraw.left<=sDraw.right)							// Leerbereich zwischen Pfad und DropDown
			{
			SelectObject(hDc,GetStockObject(NULL_PEN));
			SelectObject(hDc,GetSysColorBrush(COLOR_WINDOW));
			Rectangle   (hDc,sDraw.left,sDraw.top+1,sDraw.right+1,sDraw.bottom);
			}

		sDraw.left	= sDraw.right;							// Drop-Down-Taste zeichnen
		sDraw.right	= sRect.right;

		SelectObject(hDc,m_hFontChar);						// Drop-Down-Taste zeichnen
		SelectObject(hDc,GetStockObject(BLACK_PEN));
		SelectObject(hDc,GetSysColorBrush((m_iButtonMode!=HIS_NORMAL)? COLOR_SCROLLBAR:COLOR_BTNHILIGHT));
		Rectangle   (hDc,sDraw.left,sDraw.top,sDraw.right,sDraw.bottom);

		if(m_iButtonMode==HIS_PRESSED)sDraw.top+=2;
		DrawText    (hDc,_T("\x36"),1,&sDraw,DT_COMMON);
		}



	::EndPaint(m_hWnd,&sPaint);


}

//*****************************************************************************
//*
//*		DrawItem
//*
//*****************************************************************************
//	Ein ELement aus der Drop-Down-Liste zeichnen
void CPathCtrl::DrawItem(LPDRAWITEMSTRUCT pDrawItem)
{
TCHAR		cPath[MAX_PATH];
COLORREF	uColor1;
COLORREF	uColor2;
CRect		sRect;
DWORD		uAttr;
TCHAR		cSign;
int			iIcon;
int			iItem;
int			iSize;


	ASSERT(pDrawItem->CtlType==ODT_COMBOBOX);

	iItem = pDrawItem->itemID;
	iSize = GetLBText(iItem,cPath);
	iSize = DelBackSlash(cPath,iSize);
	cSign = cPath[0]&~0x20;

	if(iSize>=2 && cPath[1]==':' && cSign>='A' && cSign<='Z')
		{
		if(iSize==2)										// Ist es ein Laufwerk
			{
			   iIcon = CIconChache::GetDriveIcon(cSign);
			if(iIcon<0)iIcon=m_iPathImage;
			}
		else if(cSign==(TCHAR)CIconChache::GetBaseDrive())
			{
			iIcon = GetSmallIcon(cPath,uAttr);				// Auf C: immer holen
			}
		else{
			iIcon=m_iPathImage;								// Andere Pfade
			}
		}
	else{													// Netzlaufwerk und andere
		iIcon = GetSmallIcon(cPath,uAttr);
		}

	sRect   = pDrawItem->rcItem;
	uColor1 = GetSysColor(COLOR_WINDOW);

	
	if(pDrawItem->itemState&ODS_SELECTED)					// Farbe fr Auswahl
		{
		uColor2 = GetSysColor(COLOR_HIGHLIGHT);
		uColor1 = ((uColor1>>2)&0x3F3F3F)*3;
		uColor1+= ((uColor2>>2)&0x3F3F3F);
		}


	SetBkColor(pDrawItem->hDC,uColor1);
	ExtTextOut(pDrawItem->hDC,sRect.left+m_iImagesSizeX+4,sRect.top+1,ETO_OPAQUE,&sRect,cPath,iSize,NULL);

	ImageList_Draw(m_hImageList,iIcon,pDrawItem->hDC,pDrawItem->rcItem.left+2,pDrawItem->rcItem.top+1,ILD_TRANSPARENT);



}

//*****************************************************************************
//*
//*		MeasureItem
//*
//*****************************************************************************
//	Hhe eines Elementes der Drop-Down-Liste
void CPathCtrl::MeasureItem(LPMEASUREITEMSTRUCT pMeasureItem)
{

	pMeasureItem->itemHeight = m_iRawHeight;

}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CPathCtrl::OnSize(UINT nType,int iSizeX,int iSizeY)
{
CRect	sRect;
CRect	sEdit;
int		iSize;


	CComboBox::OnSize(nType,iSizeX,iSizeY);

	if(!m_hEdit)
		{
		m_hEdit    = ::GetWindow(m_hWnd,GW_CHILD);

		if(m_bBreadCrumb)
			{
			::ShowWindow(m_hEdit,SW_HIDE);
			m_bEditOn = FALSE;
			}
		}

	if(iSizeX<=0 || iSizeY<=0)
		{
		m_iWndSizeX = 0;
		m_iWndSizeY = 0;
		return;
		}

	m_iWndSizeX = iSizeX;
	m_iWndSizeY = iSizeY;

	::GetWindowRect(m_hWnd ,&sRect);
	::GetWindowRect(m_hEdit,&sEdit);

	iSize			= GetSystemMetrics(SM_CXHSCROLL);
	m_iButtonSize	= sRect.right-sEdit.right-2;
	if(m_iButtonSize<iSize)m_iButtonSize=iSize;

	m_iButtonEnd	= sRect.right-sRect.left;
	m_iButtonStart  = m_iButtonEnd-m_iButtonSize;

	EditPos ();
	CalcBase();

}

//*****************************************************************************
//*
//*		EditPos
//*
//*****************************************************************************
//	Prft die Position des Editfensters in der ComboBox
void CPathCtrl::EditPos()
{
CRect		sRect;
CRect		sEdit;

	::GetWindowRect(m_hWnd ,&sRect);
	::GetWindowRect(m_hEdit,&sEdit);

	if(sEdit.left<sRect.left+m_iImagesSizeX+4)
		{
		sEdit.left = sRect.left+m_iImagesSizeX+2;
		ScreenToClient(&sEdit);
		::MoveWindow(m_hEdit,sEdit.left,sEdit.top,sEdit.Width(),sEdit.Height(),TRUE);
		
		if(!m_bEditCheck)
			{
			SetTimer(ID_EDITPOS,250,NULL);
			}

		m_bEditCheck = 3;
		}

		m_bEditCheck--;
	if(!m_bEditCheck)
		{
		KillTimer(ID_EDITPOS);
		}

}

//*****************************************************************************
//*
//*		OnEditFocus
//*
//*****************************************************************************
//	Das Edit-Fenster hat den Fokus erhalten
void CPathCtrl::OnEditFocus()
{

	m_bTextChanged = 0;
	EditPos();
	DefWindowProc(WM_COMMAND,MAKELONG(1001,EN_SETFOCUS),(LPARAM)m_hEdit);

}

//*****************************************************************************
//*
//*		OnEditNoFocus
//*
//*****************************************************************************
//	Das Edit-Fenster hat den Fokus verloren
void CPathCtrl::OnEditNoFocus()
{

	if(m_bBreadCrumb)
		{
		m_cEditPath[0] = 0;
		if(m_bTextChanged)SendMessage(WM_GETTEXT,MAX_PATH,(LPARAM)m_cEditPath);
		DefWindowProc(WM_SETTEXT,0,(LPARAM)m_cPath);
		::ShowWindow(m_hEdit,SW_HIDE);
		m_bEditOn = FALSE;
		}

	DefWindowProc(WM_COMMAND,MAKELONG(1001,EN_SETFOCUS),(LPARAM)m_hEdit);

}

//*****************************************************************************
//*
//*		OnEditChange
//*
//*****************************************************************************
//	Der Text im Edit-Fenster hat sich verndert
void CPathCtrl::OnEditChange()
{
	m_bTextChanged = TRUE;
}

//*****************************************************************************
//*
//*		OnCloseUp
//*
//*****************************************************************************
//	Die Drop-Down-Liste wurde geschlossen
void CPathCtrl::OnCloseUp()
{
TCHAR		cPath[MAX_PATH];
int			iItem;


	   iItem = GetCurSel();
	if(iItem>=0)
		{
		GetLBText(iItem,cPath);
		SetPath(cPath);
		SetFocus();
		DefWindowProc(WM_SETTEXT,0,(LPARAM)"");
		DefWindowProc(WM_SETTEXT,0,(LPARAM)m_cPath);
		}
	else{
		::GetWindowText(m_hEdit,cPath,MAX_PATH);

		if(!_tcsicmp(cPath,m_cPath))
			{
			OnEditNoFocus();
			}
		}
}

//*****************************************************************************
//*
//*		OnTakeEdit
//*
//*****************************************************************************
//	Return wurde im Edit-Fenster gedrckt um den Pfad zu bernehmen
void CPathCtrl::OnTakeEdit()
{
TCHAR		cPath[MAX_PATH];
int			iSize;
int			iPos;
int			iRet;


	iSize = ::GetWindowText(m_hEdit,cPath,MAX_PATH);

	if(iSize>=0)
		{
		if(SetPath(cPath) && m_bAddWihtRet)
			{
			   iRet=GetLBText(0,cPath);
			if(iRet<=0 || _tcscmp(m_cPath,cPath))		// Neuen Pfad an die erste Stelle
				{
				InsertString(0,m_cPath);
				}

			for(iPos=1;iPos<m_iListMax;iPos++)			// Doppelte Namen entfernen
				{
				   iRet = GetLBText(iPos,cPath);
				if(iRet<0)break;

				if(_tcscmp(m_cPath,cPath))continue;

				DeleteString(iPos);
				iPos--;
				}

			for(;;)										// Ist die Liste zu lang
				{
				iRet = GetLBTextLen(iPos);
				if(iRet<0)break;
				DeleteString(iPos);
				}
			}
		}

	if(m_bBreadCrumb)
		{
		::ShowWindow(m_hEdit,SW_HIDE);
		m_bEditOn = FALSE;
		SetFocus();
		}

}

//*****************************************************************************
//*
//*		OnExitEdit
//*
//*****************************************************************************
//	ESC wurde im Edit-Fenster gedrckt um den Pfad zu bernehmen
void CPathCtrl::OnExitEdit()
{


	if(m_bBreadCrumb)
		{
		::SetWindowText(m_hEdit,m_cPath);
		::ShowWindow   (m_hEdit,SW_HIDE);
		m_bTextChanged = FALSE;
		m_bEditOn	   = FALSE;
		SetFocus();
		}
	else{
		m_bTextChanged = FALSE;
		::SetWindowText(m_hEdit,m_cPath);
		::SendMessage  (m_hEdit,EM_SETSEL,0,_tcslen(m_cPath));
		}

}

//*****************************************************************************
//*
//*		OnMouseCheck
//*
//*****************************************************************************
void CPathCtrl::OnMouseCheck()
{
CPoint		sPoint;
int			iFlags;

	GetCursorPos  (&sPoint);
	ScreenToClient(&sPoint);
	iFlags	 = (GetAsyncKeyState(VK_LBUTTON)&0x8000)? MK_LBUTTON:0;

	OnMouseMove(iFlags,sPoint);

}

//*****************************************************************************
//*
//*		OnMouseLeave
//*
//*****************************************************************************
LRESULT CPathCtrl::OnMouseLeave(WPARAM wParam,LPARAM lParam)
{

	OnMouseCheck();

return DefWindowProc(WM_MOUSELEAVE,wParam,lParam);
}

//*****************************************************************************
//*
//*		OnLButtonDblClk
//*
//*****************************************************************************
void CPathCtrl::OnLButtonDblClk(UINT nFlags,CPoint sPoint)
{

	OnMouseMove(nFlags,sPoint);

	DefWindowProc(WM_MOUSELEAVE,nFlags,MAKELONG(sPoint.x,sPoint.y));

}

//*****************************************************************************
//*
//*		EditSel
//*
//*****************************************************************************
void CPathCtrl::EditSel()
{

	::SetWindowText(m_hEdit,m_cPath);
	::SendMessage  (m_hEdit,EM_SETSEL,0,_tcslen(m_cPath));
	::ShowWindow   (m_hEdit,SW_SHOW);
	::SetFocus     (m_hEdit);

	if(m_bListOn!=FALSE)
		{
		m_bListOn = 0;
		m_cDirList.ShowWindow(SW_HIDE);
		}

	if(m_bEditOn==FALSE)
		{
		OnEditFocus();
		m_bEditOn = TRUE;
		RedrawWindow();
		}

}

//*****************************************************************************
//*
//*		OnRButtonDown
//*
//*****************************************************************************
void CPathCtrl::OnRButtonDown(UINT nFlags,CPoint sPoint)
{
CMenu	sMenu;
UINT	uFlag;


	OnMouseMove(nFlags,sPoint);

	if(m_iSegSel==ID_DROPDOWN)return;

	m_iMenuSegment = m_iSegSel;

	sMenu.CreatePopupMenu();
	uFlag = (m_cPath[0])? 0:MF_GRAYED;
	sMenu.AppendMenu(MF_STRING|uFlag,ID_PATHCOPY,_T("&Pfad kopieren"));
	uFlag = (m_iSegSel&1 && m_iMenuSegment>0)? 0:MF_GRAYED;
	sMenu.AppendMenu(MF_STRING|uFlag,ID_NAMECOPY,_T("&Abschnitt kopieren"));

	ClientToScreen(&sPoint);

	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CPathCtrl::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
unsigned	uDiff;
unsigned	uBits;
int			iOld;


	OnMouseMove(nFlags,sPoint);
	m_sClickPoint	= sPoint;
	m_bIconClick	= 0;

	if(m_iSegSel==ID_ICONPOS)							// Klick auf Icon
		{
		m_bIconClick = 1;
		}
	else if(m_iSegSel==ID_TEXTPOS)						// Klick auf Text oder Icon
		{
		EditSel();
		}
	else if(m_iSegSel>=0 && m_iSegSel<256 && !m_bEditOn)// Klick auf Aufklapptaste
		{
		if(nFlags&MK_CONTROL)
			{
			iOld	  =  m_iKeySel;
			m_iKeySel = (m_iSegSel+1)&~1;
			if(iOld!=m_iKeySel)
				{
				SetFocus();
				RedrawWindow();
				}
			}
		else if(m_iSegSel&1)
			{
			SelectSegment((m_iSegSel+1)/2);
			}
		else if(m_bListOn)
			{
			m_bListOn = 0;
			m_cDirList.ShowWindow(SW_HIDE);
			RedrawWindow();
			}
		else{
			if(m_aPathDirs[0].Count())
				{
				   uBits = GetLogicalDrives();
				if(uBits!=m_uLastDrives)
					{
					m_sLock.Lock();
					UpdateDrives(uBits);				// Neue Laufwerke einfgen
					m_sLock.Unlock();
					}
				}

			uDiff  = GetTickCount();
			uDiff -= m_uLockClick;

			if(uDiff>50)
				{
				m_iKeySel   = m_iSegSel;
				ShowList(m_iKeySel/2);
				RedrawWindow();
				}
			}
		}
	else if(m_iKeySel>=0 && m_iKeySel<m_iFolders*2)		// Klick auf Aufklapptaste
		{
		ShowList(m_iKeySel/2);
		RedrawWindow();
		}
	else{
		DefWindowProc(WM_MOUSELEAVE,nFlags,MAKELONG(sPoint.x,sPoint.y));
		}

	if(m_iSegSel==ID_DROPDOWN)							// Wurde die Liste aufgeklappt
		{
		if(GetDroppedState())
			{
			if(GetCurSel()==-1)::SetWindowText(m_hEdit,m_cPath);
			::ShowWindow(m_hEdit,SW_SHOW);
			m_bEditOn = TRUE;
			EditPos();

			if(m_bListOn)
				{
				m_bListOn = 0;
				m_cDirList.ShowWindow(SW_HIDE);
				}
			}
		}


}

//*****************************************************************************
//*
//*		OnLButtonUp
//*
//*****************************************************************************
void CPathCtrl::OnLButtonUp(UINT nFlags,CPoint sPoint)
{


	OnMouseMove(nFlags,sPoint);


	if(m_iSegSel==ID_ICONPOS && m_bIconClick)			// Klick auf Icon
		{
		EditSel();
		}

	m_bIconClick = 0;

	DefWindowProc(WM_MOUSELEAVE,nFlags,MAKELONG(sPoint.x,sPoint.y));

}


//*****************************************************************************
//*
//*		OnMouseMove
//*
//*****************************************************************************
void CPathCtrl::OnMouseMove(UINT nFlags,CPoint sPoint)
{
TRACKMOUSEEVENT sEvent;
int				iDiffX;
int				iDiffY;
int				iMode;
int				iPosX;
int				iSel;



	if(sPoint.y<0 || sPoint.y>=m_iWndSizeY)				// Auerhalb des Y-Bereiches
		{
		iSel = -1;

		if(GetDroppedState())
			{
			iMode = HIS_PRESSED;

			if(!m_bTickerOn)
				{
				m_bTickerOn = true;
				SetTimer(ID_TICKER,100,NULL);
				}
			}
		else{
			iMode	= HIS_NORMAL;
			}
		}												// Nicht auf Drop-Down-Taste
	else if(sPoint.x<m_iButtonStart || sPoint.x>m_iButtonEnd)
		{
		if(GetDroppedState())
			{
			iMode = HIS_PRESSED;

			if(!m_bTickerOn)
				{
				m_bTickerOn = true;
				SetTimer(ID_TICKER,100,NULL);
				}
			}
		else{
			iMode	= HIS_NORMAL;
			}

		if(sPoint.x<m_iImagesSizeX+CPC_ICON_FRAME)		// Ist die Maus auf einem Icon
			{
			iSel = ID_ICONPOS;
			}
		else{
			iPosX = sPoint.x+m_iBaseOffset;

			for(iSel=m_iBaseEnd-1;;iSel--)				// Ist die Maus auf einem Abschnitt
				{
				if(iSel<m_iBasePos)
					{
					iSel = (sPoint.x>0 && sPoint.x<m_iWndSizeX)? ID_TEXTPOS:-1;
					break;
					}

				if(iPosX>=m_aPathStart[iSel] && iPosX<m_aPathStart[iSel+1])
					{
					break;
					}
				}
			}
		}
	else if(nFlags&MK_LBUTTON)							// Drop-Down gedrckt
		{
		iSel		= ID_DROPDOWN;
		iMode		= HIS_PRESSED;
		}
	else{												// ber Drop-Down Taste
		iSel		= ID_DROPDOWN;
		iMode		= HIS_HOT;
		}


	if(m_iButtonMode!=iMode || iSel!=m_iSegSel)
		{
		if((iMode!=HIS_NORMAL && m_iButtonMode==HIS_NORMAL) || (iSel>=0 && m_iSegSel<0))
			{
			sEvent.cbSize		= sizeof(TRACKMOUSEEVENT);
			sEvent.dwFlags		= TME_LEAVE;
			sEvent.hwndTrack	= m_hWnd;

			_TrackMouseEvent(&sEvent);
			}

		if(iSel>=0 && iSel<0x100)						// Maus ber Brotkrmmen
			{
			if(m_bListOn)
				{
				m_iKeySel = (iSel+1)&~1;
				ShowList(m_iKeySel/2);
				}
			else{
				m_iKeySel = -1;
				}
			}

		m_iButtonMode = iMode;
		m_iSegSel	  = iSel;

		RedrawWindow();
		}

	CComboBox::OnMouseMove(nFlags,sPoint);

	if(m_iListBits==-2 && m_bListOn)					// Ist das Verzeichniss noch nicht geladen
		{
		SetCursor(LoadCursor(NULL,IDC_WAIT));
		}

														// Drag starten
	if(m_iSegSel==ID_ICONPOS && m_bIconClick && m_bAllowDrag)
		{
		iDiffX	= m_sClickPoint.x-sPoint.x;	if(iDiffX<0)iDiffX=-iDiffX;
		iDiffY	= m_sClickPoint.y-sPoint.y;	if(iDiffY<0)iDiffY=-iDiffY;

		if(iDiffX>3 || iDiffY>3)
		if(BeginDrag())
			{
			m_bIconClick = 0;
			}
		}



}

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CPathCtrl::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
CWnd   *pParent;
int		iFlags;
int		iOld;


	if(m_iFolders<=0)return;

	iOld = m_iKeySel;

	if(nChar==VK_LEFT && !m_bEditOn)
		{
		if(m_iKeySel<0 && m_iSegSel>=0 && m_iSegSel<0x100)
			{
			m_iKeySel = (m_iSegSel+1)&~1;
			}

		if(m_iKeySel<0 || m_iKeySel>m_iFolders*2)
			{
			m_iKeySel = m_iFolders*2;
			}
		else{
			m_iKeySel -=  2;
			m_iKeySel &= ~1;

			if(m_iKeySel<0)
				{
				m_iKeySel = m_iFolders*2;
				}
			}
		}

	if(nChar==VK_RIGHT && !m_bEditOn)
		{
		if(m_iKeySel<0 && m_iSegSel>=0 && m_iSegSel<0x100)
			{
			m_iKeySel = (m_iSegSel+1)&~1;
			}

		if(m_iKeySel<0 || m_iKeySel>m_iFolders*2)
			{
			m_iKeySel = 0;
			}
		else{
			m_iKeySel +=  2;
			m_iKeySel &= ~1;

			if(m_iKeySel>m_iFolders*2)
				{
				m_iKeySel = 0;
				}
			}
		}

	if(nChar==VK_RETURN)
		{
		if(!m_bEditOn)
			{
			iFlags  = GetAsyncKeyState(VK_SHIFT  )&0x8000;
			iFlags |= GetAsyncKeyState(VK_CONTROL)&0x8000;

			if(iFlags)
				{
				EditSel();
				return;
				}

			if(m_iKeySel>0)
					SelectSegment((m_iKeySel+1)/2);
			else	EditSel();

			return;
			}
		}

	if(nChar==VK_TAB && m_bTabExit)
		{
		   pParent = GetParent();
		if(pParent)pParent->SetFocus();
		}

	if(nChar==VK_DOWN && !m_bEditOn && !m_bListOn)
		{
		ShowList(m_iKeySel/2);
		RedrawWindow();
		return;
		}

	if(iOld!=m_iKeySel)
		{
		if(m_iKeySel>=0)
			{
			m_iListLast = m_iKeySel;
			}

		RedrawWindow();
		}
}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CPathCtrl::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_TICKER)
		{
		if(!GetDroppedState())
			{
			OnMouseCheck();

			if(m_iButtonMode!=HIS_PRESSED)
				{
				KillTimer(ID_TICKER);
				m_bTickerOn = false;
				}
			}

		return;
		}

	if(nIdEvent==ID_EDITPOS)
		{
		EditPos();
		}

	CComboBox::OnTimer(nIdEvent);

}

//*****************************************************************************
//*
//*		OnDropFiles
//*
//*****************************************************************************
void CPathCtrl::OnDropFiles(HDROP hDropInfo)
{
TCHAR		cFile[MAX_PATH];
DWORD		dwAttr;
int			iLen;


	iLen = DragQueryFile(hDropInfo,0,cFile,MAX_PATH);
	DragFinish(hDropInfo);

	   dwAttr = GetFileAttributes(cFile);
	if(dwAttr==0xFFFFFFFF)return;

	if(!(dwAttr&FILE_ATTRIBUTE_DIRECTORY))
		{
		for(;;iLen--)
			{
			if(iLen<=0)return;
			if(cFile[iLen]=='\\')break;
			if(cFile[iLen]=='/' )break;
			if(cFile[iLen]==':' ){iLen++;break;}
			}

		cFile[iLen] = 0;
		}


	SetPath(cFile,CPC_FULLPATH|_tcslen(cFile));


}

//*****************************************************************************
//*
//*		SearchThread
//*
//*****************************************************************************
DWORD WINAPI CPathCtrl::SearchThread(LPVOID pParam)
{
TCHAR			cPath[MAX_PATH];
CStringChain   *pChain;
LPCTSTR			pName;
CSize			sSize;
DirData			sInfo;
ThreadData		sData;
unsigned		uDone;
unsigned		uUser;
unsigned		uSize;
unsigned		uFlag;
unsigned		uVal;
unsigned		uPos;
unsigned		uMin;
unsigned		uSub;
unsigned		uLen;
HWND			hWnd;
HDC				hDc;



	hWnd			= (HWND)pParam;
	sData.pThis		= NULL;									// Zeiger auf eigene Instanz
	sData.uInitOk	= 0;									// Ist die Instanz ok (0=none 1=init 2=exit)
	sData.uCommand	= 0;									// Command fr die Suche
	sData.uDoneCmd	= 0;									// Fertige Suche
	sData.uCurrent	= 0;									// Aktuelle Suche


	for(;;)
		{
		sData.sSem.Lock(1000);

		if(sData.uInitOk==0)								// Ist das Fenster schon angedockt
			{
			::PostMessage(hWnd,WM_THREADMSG,ID_THREADINIT,(LPARAM)&sData);
			continue;
			}

		if(sData.uCommand==0xFFFFFFFF)break;
		if(sData.uCommand==0x00000000)continue;

		m_sLock.Lock();

		if(sData.uInitOk!=1)								// Ist das Fenster noch gltig
			{
			m_sLock.Unlock();
			break;
			}

		uDone	=  sData.uCommand;
		uSub	= (uDone>>24)-1;
		pChain	=  sData.pThis->m_aPathDirs+uSub;
		sData.uCommand = 0x00000000;
															// Ist der Auftrag noch gltig
		if(((uDone^sData.pThis->m_iTurn)&0x00FFFFFF) || uSub>(UINT)sData.pThis->m_iFolders)
			{
			m_sLock.Unlock();
			continue;
			}

		   uUser = pChain->GetUserData();
		if(uUser==uDone)									// Ist die Liste schon aktuell
			{
			if(uSub==0)
				{
				   uVal = GetLogicalDrives();
				if(uVal!=sData.pThis->m_uLastDrives)
					{
					sData.pThis->UpdateDrives(uVal);		// Es gibt andere Laufwerke
					}
				}

			m_sLock.Unlock();

			sData.uDoneCmd = uDone;
			::PostMessage(hWnd,WM_THREADMSG,ID_THREADDONE,uDone);

			continue;
			}

		uLen	= sData.pThis->m_aPathOffset[uSub];
		sData.uCurrent	= uDone;
		ASSERT(uLen<MAX_PATH-3);
		memcpy(cPath,sData.pThis->m_cPath,uLen*sizeof(TCHAR));

		uFlag = CFF_FIND_DIR|CFF_FIND_ALL;
		if(sData.pThis->m_bNoNetPaths==0)uFlag|=CFF_FIND_NET;

		m_sLock.Unlock();

		if(uLen && uSub)									// Verzeichniss durchsuchen
			{
			if(cPath[uLen-1]!='\\')
				{
				cPath[uLen] = '\\';
				uLen++;
				}

			cPath[uLen  ] = '*';
			cPath[uLen+1] = 0;
			}
		else{												// Laufwerke suchen
			cPath[0] = ':';
			cPath[1] = 0;
			}

		sData.sFind.Read(cPath,uFlag);
		sData.sFind.Sort(CFF_SORT_NAME|CFF_SORT_VALUE);

		m_sLock.Lock();

		if(sData.uInitOk!=1)								// Ist das Fenster noch gltig
			{
			m_sLock.Unlock();
			break;
			}


		pChain->Del();
		uMin = CPC_LIST_MIN;
		hDc  = ::GetDC(sData.pThis->m_cDirList.m_hWnd);
		SelectObject(hDc,m_hFontText);


		for(uPos=0;;uPos++)									// Verzeichnisse in die Liste koieren
			{
				pName = sData.sFind.Name(uPos,0,(int*)&uLen);
			if(!pName)break;

			GetTextExtentPoint(hDc,pName,uLen,&sSize);

			if(sSize.cx>CPC_LIST_WIDTH)sSize.cx=CPC_LIST_WIDTH;
			if(sSize.cx>(INT)uMin)uMin=sSize.cx;

			sInfo.iIcon		=  sData.sFind.GetSmallIcon(uPos);
			sInfo.uType		= (sData.sFind.IsNet(uPos))? 1:0;
			sInfo.uTextSize	= (WORD)sSize.cx;

			pChain->Add(uLen,pName,CSC_END,&sInfo);
			}

		if(pChain->Count()==0 && !sData.pThis->m_bMustExist)// Bei leeren Listen das Pfadsegment einfgen
		if(uSub<(UINT)sData.pThis->m_iFolders)
			{
			pName  = sData.pThis->m_cPath;
			pName += sData.pThis->m_aPathOffset[uSub];
			uLen   = sData.pThis->m_aPathSize  [uSub];

			GetTextExtentPoint(hDc,pName,uLen,&sSize);

			if(sSize.cx>CPC_LIST_WIDTH)sSize.cx=CPC_LIST_WIDTH;
			if(sSize.cx>(INT)uMin)uMin=sSize.cx;

			sInfo.iIcon		= m_iPathImage;
			sInfo.uType		= 2;
			sInfo.uTextSize	= (WORD)sSize.cx;

			pChain->Add(uLen,pName,CSC_END,&sInfo);

			uPos++;
			}


		if(uPos*m_iItemHeight>CPC_LIST_HEIGHT)				// Hhe der Liste berechnen
			{
			uVal   = GetSystemMetrics(SM_CXVSCROLL);
			uMin  += m_iItemStart+uVal;
			uSize  = CPC_LIST_HEIGHT-CPC_LIST_HEIGHT%m_iItemHeight;
			uSize += 3;
			}
		else{
			uMin  += m_iItemStart;
			uSize  = uPos*m_iItemHeight;
			uSize += 3;
			uVal   = 0;
			}

		sData.pThis->m_aPathHeight[uSub] = uSize;
		sData.pThis->m_aPathWidth [uSub] = uMin;
		sData.pThis->m_aPathScroll[uSub] = uVal;


		pChain->SetUserData(uDone);
		::ReleaseDC(sData.pThis->m_cDirList.m_hWnd,hDc);

		sData.uDoneCmd = uDone;
		sData.uCurrent = 0;

		m_sLock.Unlock();

		::PostMessage(hWnd,WM_THREADMSG,ID_THREADDONE,uDone);
		}

	m_sLock.Lock();
	sData.uInitOk = 3;
	m_sLock.Unlock();

	::PostMessage(hWnd,WM_THREADMSG,ID_THREADEXIT,(LPARAM)&sData);





return 0;
}

//*****************************************************************************
//*
//*		OnGetTextLen
//*
//*****************************************************************************
LRESULT CPathCtrl::OnGetTextLen(WPARAM wParam,LPARAM lParam)
{
LRESULT		lRet;


	if(m_bEditOn)
		{
		lRet = DefWindowProc(WM_GETTEXT,wParam,lParam);
		}
	else{
		lRet = _tcslen(m_cPath);
		}


return lRet;
}

//*****************************************************************************
//*
//*		OnGetText
//*
//*****************************************************************************
LRESULT CPathCtrl::OnGetText(WPARAM wParam,LPARAM lParam)
{
LPTSTR		pText;
LRESULT		lRet;


	if(m_bEditOn)
		{
		lRet = DefWindowProc(WM_GETTEXT,wParam,lParam);
		}
	else{
		if((LRESULT)wParam<=0)return 0;

		lRet = _tcslen(m_cPath);

		if(lRet>=(int)wParam)lRet=wParam-1;

		pText = (LPTSTR)lParam;

		memcpy(pText,m_cPath,lRet*sizeof(TCHAR));
		pText[lRet] = 0;
		}


return lRet;
}

//*****************************************************************************
//*
//*		OnSetText
//*
//*****************************************************************************
LRESULT CPathCtrl::OnSetText(WPARAM wParam,LPARAM lParam)
{
LRESULT lRet;


	lRet = DefWindowProc(WM_SETTEXT,wParam,lParam);

	if(!m_bEditOn)SetPath((LPCTSTR)lParam);


return TRUE;
}

//*****************************************************************************
//*
//*		OnSetCurSel
//*
//*****************************************************************************
LRESULT CPathCtrl::OnSelString(WPARAM wParam,LPARAM lParam)
{
LRESULT lRet;


	lRet = DefWindowProc(CB_SELECTSTRING,wParam,lParam);

	if(lRet>=0 && lParam)
		{
		SetPath((LPCTSTR)lParam);
		}


return lRet;
}

//*****************************************************************************
//*
//*		OnSetCurSel
//*
//*****************************************************************************
LRESULT CPathCtrl::OnSetCurSel(WPARAM wParam,LPARAM lParam)
{
LRESULT lRet;


	lRet = DefWindowProc(CB_SETCURSEL,wParam,lParam);

	OnCloseUp();


return lRet;
}

//*****************************************************************************
//*
//*		OnThreadMsg
//*
//*****************************************************************************
LRESULT CPathCtrl::OnThreadMsg(WPARAM wParam,LPARAM lParam)
{
unsigned 	uBits;
int			iSeg;

	switch(wParam)
		{
	case ID_THREADINIT:										// Der Thread wurde gestartet

						m_sLock.Lock();

						m_pThreadData			= (ThreadData*)lParam;
						m_pThreadData->pThis	= this;
						m_pThreadData->uInitOk	= 1;
						StartSearch(m_iFolders);

						m_sLock.Unlock();
						break;

	case ID_THREADEXIT:										// Der Thread wurde beendet
						m_pThreadData = NULL;
						break;

	case ID_THREADDONE:										// Eine Suche ist fertig

						uBits  = (UINT)lParam;
						iSeg   = (uBits>>24)-1;
						uBits ^= m_iTurn;
						uBits &= 0x00FFFFFF;

						m_sLock.Lock();
															// Wieder hinten beginnen
						if(iSeg==0 && uBits==0 && m_iFolders>0)
							{
							uBits |= (m_aPathDirs[iSeg].GetUserData()^m_iTurn)&0x00FFFFFF;
							}

						if(uBits==0 && iSeg>0)
							{
							if(iSeg==m_iFolders)CalcBase();	// Letzes Segment ausblenden
							if(iSeg>=1)StartSearch(iSeg-1);
							}
						else if(m_iFolders)
							{
							//StartSearch(m_iFolders);
							}

						if(m_bListOn && iSeg==m_iListCol)	// Neue Liste anzeigen
							{
							ShowList(iSeg);
							}

						m_sLock.Unlock();

						break;
		}


return 0;
}

//*****************************************************************************
//*
//*		OnGetListItem
//*
//*****************************************************************************
void CPathCtrl::OnGetListItem(NMHDR *pNotify,LRESULT *pResult)
{
NMLVDISPINFO   *pList=(NMLVDISPINFO*)pNotify;
CStringChain   *pChain;
DirData		   *pData;
LPTSTR			pText;
int				iItem;
int				iLen;


	if((UINT)m_iListCol>CPC_MAX_FOLDERS)
		{
		pList->item.iImage	= -1;
		pList->item.pszText = _T("");
		return;
		}

	iItem	= pList->item.iItem;
	pChain	= m_aPathDirs+m_iListCol;
	pText	= pChain->Get(iItem,iLen);
	pData	= (DirData*)pChain->Data(iItem);

	if(!pText)
		{
		pList->item.iImage	= -1;
		pList->item.pszText = _T("");
		return;
		}

	pList->item.iImage		= pData->iIcon;
	pList->item.pszText		= pText;
	pList->item.cchTextMax	= iLen;


}

//*****************************************************************************
//*
//*		OnListItemClick
//*
//*****************************************************************************
void CPathCtrl::OnListItemClick(NMHDR *pNotify,LRESULT *pResult)
{
NMITEMACTIVATE *pList=(NMITEMACTIVATE*)pNotify;


	SelectFolder(m_iListCol,pList->iItem);

}

//*****************************************************************************
//*
//*		OnCharInput
//*
//*****************************************************************************
//	Ein Zeichen wurde im Listen Fenster eingegeben
void CPathCtrl::OnCharInput(int iChar)
{
DWORD		uDelta;
DWORD		uTick;
LPCTSTR		pName;
LVITEM		sItem;
UINT		uPos;
UINT		uVal;
INT			iNum;
INT			iMax;
INT			iIdx;



	if(iChar<' ')return;

	if(iChar>='a' && iChar<='z')iChar-=0x20;
	if(iChar>=224 && iChar<=254)iChar-=0x20;

	for(;;) 											// Suche Anfangsbuchstaben
		{
		iNum   = m_cDirList.GetNextItem(-1,LVNI_SELECTED);
		iMax   = m_aPathDirs[m_iListCol].Count();
		uTick  = GetTickCount();
		uDelta = (m_uKeyPos>0)? 750:500;

		if(m_uKeyPos>=3           )uDelta=1000;
		if(uTick-m_uKeyLast>uDelta)m_uKeyPos=0;
		if(m_uKeyPos>=16          )m_uKeyPos=0;
		if(m_uKeyPos==1 && m_cKeyData[0]==(TCHAR)iChar)
			{
			m_uKeyPos=0;
			}

		m_cKeyData[m_uKeyPos] = (TCHAR)iChar;
		m_uKeyLast            = uTick;
		m_uKeyPos            += 1;

		if(m_uKeyPos>1)
			{
			iNum--;
			if(iNum<0)iNum=iMax-1;
			}

		if(iNum< 0)iNum=0;
		if(iMax<=0)break;
		if(iNum>=iMax)iNum=iMax-1;

		for(iIdx=iNum+1;iIdx!=iNum;iIdx++)				// Suche bereinstimmung
			{
			if(iIdx>=iMax){iIdx=-1;continue;}

				pName  = m_aPathDirs[m_iListCol].Get(iIdx);
			if(!pName)pName=_T("");

			for(uPos=0;uPos<m_uKeyPos;uPos++)			// Vergleiche die Texte
				{
				#if UNICODE
				uVal = pName[uPos];
				#else
				uVal = ((unsigned char*)pName)[uPos];
				#endif

				if((uVal>='a' && uVal<='z') ||			// In Grosbuchstaben umwandeln
				   (uVal>=224 && uVal<=254))
					{
					uVal-='a'-'A';
					}

				if(m_cKeyData[uPos]!=(TCHAR)uVal)
					{
					break;
					}
				}

			if(uPos<m_uKeyPos)continue;

			sItem.iItem		= iIdx;
			sItem.mask		= LVIF_STATE;
			sItem.stateMask = LVIS_SELECTED|LVIS_FOCUSED;
			sItem.state		= LVIS_SELECTED|LVIS_FOCUSED;

			m_cDirList.SendMessage(LVM_SETITEMSTATE,iIdx,(LPARAM)&sItem);
			m_cDirList.EnsureVisible(iIdx,FALSE);

			return;
			}

		if(iIdx!=iNum  )break;
		if(m_uKeyPos<=1)break;

		iNum++;
		if(iNum>=iMax)iNum=iMax-1;

		m_uKeyPos=0;
		}


}

//*****************************************************************************
//*
//*		OnListKeyDown
//*
//*****************************************************************************
//	Eine Taste wurde im Listen Fenster gedrckt
void CPathCtrl::OnListKeyDown(int iKey)
{
INT		iItem;
INT		iLast;



	if(iKey==VK_RETURN)
		{
		iItem = m_cDirList.GetNextItem(-1,LVNI_SELECTED);
		if(SelectFolder(m_iListCol,iItem))
			{
			m_iKeySel = m_iListCol*2+2;
			}

		return;
		}

	if(iKey==VK_ESCAPE)
		{
		iLast = m_iKeySel;
		SelectFolder(-1,-1);
		m_iKeySel = iLast;
		return;
		}

	if(iKey==VK_LEFT)
		{
		m_iKeySel -= 2;

		if(m_iKeySel<0)
			{
			m_iKeySel = m_iFolders*2;
			}

		ShowList(m_iKeySel/2);
		RedrawWindow();
		return;
		}

	if(iKey==VK_RIGHT)
		{
		if(m_iKeySel<0)
			{
			m_iKeySel = m_iFolders*2;
			}
		else{
			m_iKeySel += 2;
			}

		if(m_iKeySel>m_iFolders*2)
			{
			m_iKeySel = 0;
			}
		else if(m_iKeySel<0)
			{
			m_iKeySel = m_iFolders*2;
			}

		ShowList(m_iKeySel/2);
		RedrawWindow();
		return;
		}


}

//*****************************************************************************
//*
//*		OnStyleChanging
//*
//*****************************************************************************
void CPathCtrl::OnStyleChanging(int nStyleType,LPSTYLESTRUCT pStyle)
{

	if(nStyleType==GWL_STYLE && m_pOldEdit)
		{
		m_bTabExit   =(pStyle->styleNew&CPC_TABEXIT      )? 1:0;
		m_bAllowDrag =(pStyle->styleNew&CPC_ALLOWDRAG	 )? 1:0;
		m_bAllowDrop =(pStyle->styleNew&CPC_ALLOWDROP	 )? 1:0;
		m_bMustExist =(pStyle->styleNew&CPC_PATHMUSTEXIST)? 1:0;
		m_bAddWihtRet=(pStyle->styleNew&CPC_ADDWITHENTER )? 1:0;
		m_bHasHistory=(pStyle->styleNew&CPC_HASHISTORY	 )? 1:0;
		m_bNoNetPaths=(pStyle->styleNew&CPC_NONETDIRS    )? 1:0;
		SetBreadCrumb((pStyle->styleNew&CPC_NOBREADCRUMB )? 0:1);

		DragAcceptFiles(m_bAllowDrop);

		pStyle->styleNew	&= ~0x000F;
		pStyle->styleNew	|= CBS_DROPDOWN|CBS_OWNERDRAWFIXED|CBS_HASSTRINGS|CBS_AUTOHSCROLL;
		}

}

//*****************************************************************************
//*
//*		OnCopyPath
//*
//*****************************************************************************
//	Kopiert den ganzen Pfad
void CPathCtrl::OnCopyPath()
{
HGLOBAL		hGlobal;
int			iSize;
TCHAR	   *pNew;


	   iSize = (int)_tcslen(m_cPath);
	if(iSize<=0)return;

	hGlobal	= GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,(iSize+1)*sizeof(TCHAR));
	pNew	= (TCHAR*)GlobalLock(hGlobal);

	if(m_cPath[0]=='\\' && m_cPath[1]=='\\')
			iSize = CFileFinder::NetPathConvert(m_cPath,pNew,MAX_PATH);
	else	memcpy(pNew,m_cPath,iSize*sizeof(TCHAR));

	pNew[iSize]=0;

	GlobalUnlock(hGlobal);

	if(OpenClipboard())
		{
		EmptyClipboard();
		if(!SetClipboardData(CF_TEXT_EX,hGlobal))GlobalFree(hGlobal);
		CloseClipboard();
		}
	else{
		GlobalFree(hGlobal);
		}

}

//*****************************************************************************
//*
//*		OnCopyName
//*
//*****************************************************************************
//	Kopiert eine Ordner aus dem Pfad
void CPathCtrl::OnCopyName()
{
HGLOBAL		hGlobal;
LPCTSTR		pPath;
int			iSize;
int			iPos;
TCHAR	   *pNew;


	   iPos = m_iMenuSegment/2;
	if(iPos>=m_iFolders)return;

	pPath = m_cPath+m_aPathOffset[iPos];
	iSize = m_aPathOffset[iPos+1]-m_aPathOffset[iPos];

	if(iSize>0 && pPath[iSize-1]=='\\')
		{
		iSize--;
		}

	while(*pPath=='\\' && iSize>0)
		{
		pPath++;
		iSize--;
		}

	if(iSize<=0)return;

	hGlobal	= GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,(iSize+1)*sizeof(TCHAR));
	pNew	= (TCHAR*)GlobalLock(hGlobal);

	memcpy(pNew,pPath,iSize*sizeof(TCHAR));
	pNew[iSize]=0;

	GlobalUnlock(hGlobal);

	if(OpenClipboard())
		{
		EmptyClipboard();
		if(!SetClipboardData(CF_TEXT_EX,hGlobal))GlobalFree(hGlobal);
		CloseClipboard();
		}
	else{
		GlobalFree(hGlobal);
		}

}

//*****************************************************************************
//*
//*		SetBreadCrumb
//*
//*****************************************************************************
//	Brotkrmel-Navigation ein/ausschalten.
//	bOn		: Ein oder Aus
//	Ergibt den vorherigen Wert.
BOOL CPathCtrl::SetBreadCrumb(BOOL bOn)
{
bool	bOld;
bool	bNew;


	ASSERT(IsWindow(m_hWnd));

	bOld	= m_bBreadCrumb;
	bNew	= (bOn)? 1:0;

	if(m_bBreadCrumb!=bNew)
		{
		m_bBreadCrumb = bNew;

		if(m_bEditOn && bNew && m_hWnd!=::GetFocus())
			{
			m_bEditOn = FALSE;
			::SetWindowText(m_hEdit,m_cPath);
			::ShowWindow   (m_hEdit,SW_HIDE);
			RedrawWindow();
			}

		if(!m_bEditOn && !bNew)
			{
			EditSel();
			RedrawWindow();
			}
		}


return bOld;
}

//*****************************************************************************
//*
//*		SetAllowDrop
//*
//*****************************************************************************
BOOL CPathCtrl::SetAllowDrop(BOOL bOn)
{
bool	bOld;
bool	bNew;


	ASSERT(IsWindow(m_hWnd));

	bOld	= m_bAllowDrop;
	bNew	= (bOn)? 1:0;

	if(m_bAllowDrop!=bNew)
		{
		m_bAllowDrop = bNew;
		DragAcceptFiles(bNew);
		}


return bOld;
}

//*****************************************************************************
//*
//*		EditProc
//*
//*****************************************************************************
//	Tasten an Eltern Fenster weiterleiten
LRESULT WINAPI CPathCtrl::EditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
CWnd		   *pParent;
CPathCtrl	   *pThis;




	pThis = (CPathCtrl*)GetWindowLongPtr(hWnd,GWL_USERDATA);

	if(uMsg==WM_KEYDOWN)
		{
		if(!pThis->m_bEditOn)								// Taste ans Elternfenster
			{
			pThis->PostMessage(WM_KEYDOWN,wParam,lParam);
			return 0;
			}

		if(wParam==VK_RETURN)								// Mit ENTER den Pfad bernhmen
			{
			pThis->OnTakeEdit();
			pThis->OnMouseCheck();
			}

		if(wParam==VK_ESCAPE)								// Mit ECS das Fenster verlassen
			{
			pThis->OnExitEdit();
			pThis->OnMouseCheck();
			}

		if(wParam==VK_TAB)
			{
			if(pThis->m_bTabExit)							// Fokus zum Eltern-Fenster bei TAB
				{
				   pParent = pThis->GetParent();
				if(pParent)
					{
					pParent->SetFocus();
					pThis->OnMouseCheck();
					}

				return 0;
				}
			}
		}
	else if(uMsg==WM_SETFOCUS)
		{
		pThis->OnEditFocus();
		}
	else if(uMsg==WM_KILLFOCUS)
		{
		pThis->OnEditNoFocus();
		}




return CallWindowProc(pThis->m_pOldEdit,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		ListProc
//*
//*****************************************************************************
//	Tasten an Eltern Fenster weiterleiten
LRESULT WINAPI CPathCtrl::ListProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
CPathCtrl	   *pThis;



	pThis = (CPathCtrl*)GetWindowLongPtr(hWnd,GWL_USERDATA);

	if(uMsg>=WM_KEYFIRST && uMsg<=WM_KEYLAST)
		{
		if(uMsg==WM_KEYDOWN)
			{
			if(wParam!=VK_DOWN && wParam!=VK_UP && wParam!=VK_END && wParam!=VK_HOME && wParam!=VK_NEXT && wParam!=VK_PRIOR)
				{
				pThis->OnListKeyDown((WORD)wParam);
				pThis->OnMouseCheck();
				return 0;
				}
			}

		if(uMsg==WM_KEYUP)
			{
			if(wParam!=VK_DOWN && wParam!=VK_UP && wParam!=VK_END && wParam!=VK_HOME && wParam!=VK_NEXT && wParam!=VK_PRIOR)
				{
				return 0;
				}
			}

		if(uMsg==WM_CHAR)
			{
			pThis->OnCharInput((WORD)wParam);
			return 0;
			}
		}
	else if(uMsg==WM_KILLFOCUS)
		{
		if(pThis->m_iSegSel>=0 && pThis->m_iSegSel<0x100 && !(pThis->m_iSegSel&1))
			{
			pThis->m_uLockClick = GetTickCount();
			}

		pThis->SelectFolder(-1,-1);
		pThis->OnMouseCheck();
		}


return CallWindowProc(pThis->m_pOldList,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		CalcBase
//*
//*****************************************************************************
//	Berechnet das erste sichtbare Segement
void CPathCtrl::CalcBase()
{
int		iSizeX;
int		iBits;
int		iDiff;
int		iOld;
int		iEnd;


	iOld		= m_iBasePos;
	iEnd		= m_iBaseEnd;
	iBits		= m_iTurn|((m_iFolders+1)<<24);
	iSizeX		= m_iWndSizeX-m_iButtonSize-m_iImagesSizeX-4-20;
	m_iBasePos	= m_iFolders*2+1;
	m_iBaseEnd	= m_iFolders*2+1;


	if(m_iBaseEnd>2 && (m_iBaseEnd&1))						// Letztes Segement nicht zeichnen
	if(m_aPathDirs[m_iFolders].Count()==0)
	if(m_aPathDirs[m_iFolders].GetUserData()==iBits)
		{
		m_iBaseEnd--;
		}

	for(m_iBasePos=m_iBaseEnd;m_iBasePos>0;m_iBasePos--)
		{
		iDiff	= m_aPathStart[m_iBasePos  ];
		iDiff  -= m_aPathStart[m_iBasePos-1];

		if(iDiff>iSizeX)break;

		iSizeX -= iDiff;
		}

	m_iBaseOffset  = m_aPathStart[m_iBasePos];
	m_iBaseOffset -= m_iImagesSizeX+CPC_ICON_FRAME;

	if(iOld!=m_iBasePos || iEnd!=m_iBaseEnd)				// Hat sich etwas verndert
		{
		RedrawWindow();
		}


}

//*****************************************************************************
//*
//*		SelectSegment
//*
//*****************************************************************************
//	Auswahl eines Segmentes des Pfades
//	iNumber		: Ist die Segmentnummer (1...m_iFolders)
//	Ergibt 1 wenn das Segment gewhlt wurde.
int CPathCtrl::SelectSegment(int iNumber)
{
CPC_FOLDER	sNotify;
int			iOff;
int			iLen;
int			iNum;

	if(iNumber<=0 || iNumber>=m_iFolders)return 0;
	if(iNumber==m_iFolders)return 1;

	m_iFolders	= iNumber;
	m_iBaseEnd	= iNumber*2+1;
	m_cPath[m_aPathOffset[iNumber]] = 0;

	if(m_iSegSel>iNumber*2)m_iSegSel=-1;
	if(m_iKeySel>iNumber*2)m_iKeySel=-1;

	if(iNumber>0 && m_aPathDirs[iNumber-1].Count())			// Icon aus der Liste holen
		{
		iOff  = m_aPathOffset[iNumber-1];
		iLen  = m_aPathSize	 [iNumber-1];
		iNum  = m_aPathDirs  [iNumber-1].Find(iLen,m_cPath+iOff,0,-1,0x01);

		if(iNum>=0)
			{
			m_iFolderIcon = m_aPathDirs[iNumber-1].DataGet(iNum);
			}
		}


	DefWindowProc(WM_SETTEXT,0,(LPARAM)m_cPath);
	::SetWindowText(m_hEdit,m_cPath);

	RedrawWindow();


	sNotify.sNmHdr.code		= CPC_FOLDERSELECT;
	sNotify.sNmHdr.hwndFrom	= m_hWnd;
	sNotify.sNmHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
	sNotify.hDummy			= NULL;
	sNotify.pPath			= m_cPath;
	sNotify.iMode			= 1;
														// Eltern-Fenster benachrichtigen
	GetParent()->SendMessage(WM_NOTIFY,sNotify.sNmHdr.idFrom,(LPARAM)&sNotify);


return 1;
}



//*****************************************************************************
//*
//*		BeginDrag
//*
//*****************************************************************************
BOOL CPathCtrl::BeginDrag()
{
HGLOBAL			hGlobal;
CPC_FOLDER		sNotify;
COleDataSource	sDrag;
STGMEDIUM		sData;
LPTSTR			pMem;
int				iLen;


	if(!m_bAllowDrag || !m_cPath[0])						// Drag erlaubt ?
		{
		return FALSE;
		}


	m_sLock.Lock();

	sNotify.sNmHdr.code		= CPC_DRAGACTION;
	sNotify.sNmHdr.hwndFrom	= m_hWnd;
	sNotify.sNmHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
	sNotify.iMode			= m_iPathType;
	sNotify.hDummy			= NULL;
	sNotify.pPath			= m_cPath;
															// Eltern-Fenster benachrichtigen
	if(GetParent()->SendMessage(WM_NOTIFY,sNotify.sNmHdr.idFrom,(LPARAM)&sNotify))
		{
		m_sLock.Unlock();
		return FALSE;
		}

	m_sLock.Unlock();

	hGlobal	 = GlobalAlloc(GMEM_ZEROINIT,MAX_PATH*sizeof(TCHAR)+24);
	pMem	 = (LPTSTR)GlobalLock(hGlobal);
	pMem[0]	 = 20;
	#ifdef UNICODE
	pMem[8]  = 1;
	#endif
	pMem	+= 20/sizeof(TCHAR);
															// Realen Netzwerkspfad auflsen
	if(m_cPath[0]=='\\' && m_cPath[1]=='\\' && m_iPathType>0)
		{
		iLen = CFileFinder::NetPathConvert(m_cPath,pMem,MAX_PATH);
		}
	else{
		iLen = _tcslen(m_cPath);
		memcpy(pMem,m_cPath,(iLen+1)*sizeof(TCHAR));
		}

	iLen += 24;


	GlobalUnlock(hGlobal);

	sData.pUnkForRelease	= 0;
	sData.hGlobal			= hGlobal;
	sData.tymed				= TYMED_HGLOBAL;

	if(m_bAllowDrop)DragAcceptFiles(FALSE);

	sDrag.CacheGlobalData(CF_HDROP,sData.hGlobal);
	sDrag.DoDragDrop();
	sDrag.Empty();

	if(m_bAllowDrop)DragAcceptFiles(TRUE);

	m_sLock.Lock();
															// Eltern-Fenster benachrichtigen
	GetParent()->SendMessage(WM_NOTIFY,sNotify.sNmHdr.idFrom,(LPARAM)&sNotify);

	m_sLock.Unlock();


return TRUE;
}

//*****************************************************************************
//*
//*		GetRawHeight
//*
//*****************************************************************************
//	Ergibt die Hhe eines Eintrages in der Listbox
int CPathCtrl::GetRawHeight()
{

	if(!m_iRawHeight)GlobalInit();

return m_iRawHeight;
}

//*****************************************************************************
//*
//*		GetSmallIcon
//*
//*****************************************************************************
//	Holt die Nummer des kleine Icons fr einen Pfad
INT	WINAPI CPathCtrl::GetSmallIcon(LPCTSTR pPath,DWORD &uAttr)
{
SHFILEINFO	sInfo;
int			iRet;


	if(pPath[0] && pPath[1]==':' && pPath[2]==0)		// Ist es ein Laufwerk 
		{
		iRet   = CIconChache::GetDriveIcon(pPath[0]);
		uAttr  = FILE_ATTRIBUTE_DIRECTORY;

		if(iRet>=0)return iRet;
		
		return m_iPathImage;
		}

	
	   uAttr = GetFileAttributes(pPath);
	if(uAttr==0xFFFFFFFF)return m_iPathImage;

	iRet  = SHGetFileInfo(pPath,uAttr,&sInfo,sizeof(sInfo),SHGFI_SYSICONINDEX|SHGFI_SMALLICON);


return (iRet==0)? m_iPathImage:sInfo.iIcon;
}

//*****************************************************************************
//*
//*		StartSearch
//*
//*****************************************************************************
//	Started eine Suchanfrage in einem Pfadsegment.
int CPathCtrl::StartSearch(int iSegment)
{
unsigned	uBits;


	if(iSegment<0         )return 0;
	if(iSegment>m_iFolders)return 0;
	if(m_pThreadData==NULL)return 0;

	uBits  = m_iTurn&0x00FFFFFF;
	uBits |= (iSegment+1)<<24;

	if(m_pThreadData->uCurrent==uBits)						// Ist die Suche bereits aktiv
		{
		return 1;
		}

	m_pThreadData->uCommand = uBits;
	m_pThreadData->sFind.Break();
	m_pThreadData->sSem.Unlock();


return 1;
}


//*****************************************************************************
//*
//*		UpdateDrives
//*
//*****************************************************************************
void CPathCtrl::UpdateDrives(unsigned uDrives)
{
TCHAR			cPath[4]=_T("A:");
CStringChain   *pChain;
LPCTSTR			pName;
CSize			sSize;
DirData			sInfo;
DWORD			uSize;
int				iNum;
int				iPos;
int				iBit;
HDC				hDc;


	m_uLastDrives	= uDrives;
	pChain			= m_aPathDirs;
	sInfo.uBits		= 0;
	sInfo.uType		= 0;

 	hDc  = ::GetDC(m_cDirList.m_hWnd);
	SelectObject(hDc,m_hFontText);


	for(iPos=0,iBit=1;iPos<26;iPos++,iBit<<=1)			// Laufwerke abschreiten
		{
		cPath[0] = 'A'+iPos;
		iNum	 = pChain->Find(cPath);

		if(iBit&uDrives)								// Neues Laufwerk
			{
			if(iNum>=0)continue;

			   sInfo.iIcon = CIconChache::GetDriveIcon(cPath[0]);
			if(sInfo.iIcon<0)sInfo.iIcon=m_iPathImage;

			GetTextExtentPoint(hDc,cPath,3,&sSize);

			sInfo.uTextSize	= (WORD)sSize.cx;

			for(iNum=0;iNum<pChain->Count();iNum++)
				{
				   pName = pChain->Get(iNum);
				if(pName[0]>=cPath[0])break;
				if(pName[1]!=':')break;
				}

			pChain->Add(3,cPath,iNum,&sInfo);
			}
		else if(iNum>=0)								// Laufwerk entfernen
			{
			pChain->Del(iNum);
			}
		}

	iPos  = pChain->Count();
	uSize = m_aPathHeight[0];

	if(iPos*m_iItemHeight>CPC_LIST_HEIGHT)				// Hhe der Liste
		{
		if(uSize<CPC_LIST_HEIGHT)m_aPathWidth[0]+=GetSystemMetrics(SM_CXVSCROLL);
		uSize  = CPC_LIST_HEIGHT-CPC_LIST_HEIGHT%m_iItemHeight;
		uSize += 3;
		}
	else{
		if(uSize>=CPC_LIST_HEIGHT)m_aPathWidth[0]-=GetSystemMetrics(SM_CXVSCROLL);
		uSize  = iPos*m_iItemHeight;
		uSize += 3;
		}

	m_aPathHeight[0] = (WORD)uSize;


	::ReleaseDC(m_cDirList.m_hWnd,hDc);

}

//*****************************************************************************
//*
//*		HistoryJump
//*
//*****************************************************************************
BOOL CPathCtrl::HistoryJump(BOOL bUp)
{
LPCTSTR		pName;
int			iPos;
int			iLen;


	iPos	= (bUp)? m_iHistoryPos+1:m_iHistoryPos-1;
	pName	= m_sHistory.Get(iPos,iLen);

	if(!pName)return FALSE;


return SetPath(pName,iLen);
}

//*****************************************************************************
//*
//*		ShowList
//*
//*****************************************************************************
//	Blendet das Listenfenster fr ein Pfadsegment ein
//	iSegment	: Ist das Pfadsegment
//	Ergibt 1 wenn das Listenfenster eingeblendet wurde, bzw. 0 bei einem Fehler.
int CPathCtrl::ShowList(int iSegment)
{
CPoint	sPoint;
CRect	sRect;
CSize	sSize;
INT		iBits;
INT		iDiff;


	if(iSegment<0 || iSegment>m_iFolders)					// Prfe Pfadsegment-Nummer
		{
		return 0;
		}

	   iBits =(iSegment+1)<<24;
	   iBits|=m_iTurn&0x00FFFFFF;
	if(iBits==m_iListBits && m_bListOn)						// Ist die Liste bereits sichtbar
		{
		return 1;
		}

	m_uKeyPos	= 0;
	m_bListOn   = 1;
	m_iListLast	= m_iSegSel;
	m_iListCol	= iSegment;
	m_iListBits	= iBits;

	if(iBits!=m_aPathDirs[iSegment].GetUserData())
		{
		SetFocus();
		m_iListBits = -2;
		m_cDirList.ShowWindow(SW_HIDE);
		SetCursor(LoadCursor(NULL,IDC_WAIT));
		return 0;
		}

	if(m_aPathDirs[iSegment].Count()==0)
		{
		return 0;
		}

	sSize.cx	= m_aPathWidth [iSegment    ];
	sSize.cy	= m_aPathHeight[iSegment    ];
	sPoint.x	= m_aPathStart [iSegment*2+1];
	sPoint.x   -= m_aPathStart [m_iBasePos  ];
	sPoint.y	= m_iWndSizeY;

	ClientToScreen(&sPoint);
	GetDesktopWindow()->GetWindowRect(&sRect);
															// berlab das Fenster mit dem Rand
	if(sPoint.y+sSize.cy>sRect.bottom)
		{
		   iDiff = sPoint.y-sRect.bottom;
		if(iDiff<CPC_LIST_HEIGHT/4)
			{
			sPoint.y  = sRect.bottom-sSize.cy-64;
			}
		else{
			sSize.cy  = sPoint.y-sRect.bottom-64;
			sSize.cy -= sSize.cy%m_iRawHeight;
			sSize.cy += 3;
			}
		}

	if(sPoint.x+sSize.cx>sRect.right )sPoint.x=sRect.right -sSize.cx;
	if(sPoint.x         <sRect.left  )sPoint.x=sRect.left;

	m_cDirList.SetItemCountEx(m_aPathDirs[iSegment].Count());
	m_cDirList.SetColumnWidth(0,sSize.cx-m_aPathScroll[iSegment]-1);
	m_cDirList.SetWindowPos(NULL,sPoint.x,sPoint.y,sSize.cx,sSize.cy,SWP_NOZORDER|SWP_SHOWWINDOW);
	m_cDirList.RedrawWindow();
	m_cDirList.SetFocus();


return 1;
}


//*****************************************************************************
//*
//*		SelectFolder
//*
//*****************************************************************************
//	Einen Pfad aus den Listen auswhlen
//	iSegment	: Ist das Pfadsegment
//	iItem		: Ist der Index in der Liste
//	Ergibt 1 wenn ein neuer Pfad gewhlt wurde, bzw. 0 wenn nicht.
int CPathCtrl::SelectFolder(int iSegment,int iItem)
{
TCHAR			cPath[MAX_PATH];
DirData	       *pData;
LPTSTR			pText;
int				iSize;
int				iPos;
int				iLen;
int				iRet;


	iRet		= 0;
	m_bListOn	= 0;
	m_cDirList.ShowWindow(SW_HIDE);


	if(iSegment>=0 && iSegment<=m_iFolders)					// Prfe Pfadsegment-Nummer
		{
		m_sLock.Lock();

		pText = m_aPathDirs  [iSegment].Get(iItem,iLen);
		iSize = m_aPathOffset[iSegment];
		if(iSegment==0)iSize=0;

		if(pText && iLen && iSize+iLen<MAX_PATH-4)
			{
			pData = (DirData*)m_aPathDirs[iSegment].Data(iItem);
			memcpy(cPath,m_cPath,iSize*sizeof(TCHAR));
			m_iIconNext = pData->iIcon;

			if(iSegment && iSize>1 && !strwchar(cPath[iSize-1],0x00300000))
				{
				cPath[iSize] = '\\';
				iSize++;
				}

			memcpy(cPath+iSize,pText,(iLen+1)*sizeof(TCHAR));
			m_sLock.Unlock();
			if(pData->uType==1)iSize|=CPC_PATHNOK;

			iPos   = strwlen(cPath,0x00300000,3);
			iSize |= (iPos>=2 || pData->uType)? CPC_NETPATH|CPC_ICONOK:CPC_FULLPATH|CPC_ICONOK;
			iRet   = SetPath(cPath,iSize+iLen);
			}
		else{
			m_sLock.Unlock();
			}
		}

	if(m_iKeySel>=0)										// Auswahl aufheben
		{
		m_iKeySel = -1;
		RedrawWindow();
		}

	SetFocus();


return iRet;
}

//*****************************************************************************
//*
//*		SetPath
//*
//*****************************************************************************
//	Einstellen des aktuellen Pfades
//	pPath		: Zeiger auf den neuen Pfad
//	iSize		: Lnge des neuen Pfades (-1=mit strlen ermitteln)
//	Ergibt 1 wenn der Pfad gesetzt wurde, bzw. 0 bei einem Fehler.
int	CPathCtrl::SetPath(LPCTSTR pPath,int iSize)
{
TCHAR		cTemp[MAX_PATH];
TCHAR		cPath[MAX_PATH];
CPC_FOLDER	sNotify;
CSize		sSize;
LPCTSTR		pName;
DWORD		uAttr;
DWORD		uUser;
DWORD		uBits;
INT			iReal;
INT			iSame;
INT			iMode;
INT			iIcon;
INT			iPos;
INT			iLen;
INT			iNum;
HDC			hDc;




	if(iSize<0)												// Gre mit strlen ermitteln
		{
		iSize = _tcslen(pPath);
		iMode = 0;
		iIcon =-1;

		if(iSize>=MAX_PATH-8)
			{
			return 0;
			}
		}
	else{
		if((iSize&0xFFFF0000)==CPC_NETPATH)					// Ist es ein voller Netzwerkspfad "\\...."
			{
			iIcon  = (iSize&CPC_ICONOK )? m_iIconNext:-1;
			iReal  = (iSize&CPC_PATHNOK);
			iSize &= 0x3FFF;
			iMode  = 2;
			}
		else if((iSize&0xFFFF0000)==CPC_FULLPATH)			// Ist es ein voller Laufwerkspfad "C:\..."
			{
			iIcon  = (iSize&CPC_ICONOK)? m_iIconNext:-1;
			iReal  = (iSize&CPC_PATHNOK);
			iSize &= 0x3FFF;
			iMode  = 1;
			}
		else{
			if(iSize>=MAX_PATH-8)							// Ist der Pfad zu lang
				{
				return 0;
				}

			if(pPath[iSize])								// Pfad nicht mit 0 abgeschlossen
				{
				memcpy(cTemp,pPath,iSize*sizeof(TCHAR));
				cTemp[iSize] = 0;
				pPath = cTemp;
				}

			iMode = 0;
			iIcon =-1;
			}
		}


	switch(iMode)
		{													// Auf ganzen Pfad ergnzen
	case 0:	   iSize = GetFullPathName(pPath,MAX_PATH,cPath,NULL);
			if(iSize<=0)return 0;
			break;

	case 1:	memcpy(cPath,pPath,iSize*sizeof(TCHAR));		// Es ist bereits ein voller Pfad
			cPath[iSize] = 0;
			break;

	case 2:	iPos = strwlen(pPath,0x00300000,2);				// Netztpfad vielleicht ohne "\\..."

			if(iPos==2 && iSize>=2)
				{
				memcpy(cPath,pPath,iSize*sizeof(TCHAR));
				}
			else{
				memcpy(cPath+2,pPath,iSize*sizeof(TCHAR));
				cPath[0] = '\\';
				cPath[1] = '\\';
				iSize   += 2;
				}

			cPath[iSize] = 0;
			break;
		}

	if(iSize>0 && strwchar(pPath[iSize-1],0x00300000))		// Backslash entfrennen
		{
		iSize--;
		}

	m_bTextChanged = 0;
	cPath[iSize]   = 0;
	PathConvert(cPath);

	if(!_tcsicmp(cPath,m_cPath))							// Keine nderung
		{
		return 1;
		}

	m_sLock.Lock();

	if(cPath[0]=='\\')										// Ist es eine Netzlaufwerk
		{
		iPos = (cPath[1]=='\\')? 2:1;

		if(iPos==2 && m_bNoNetPaths)return 0;
		}
	else{
		iPos = 0;
		}

	if(iIcon==-1)											// Das Icon einlesen
		{
		SetCursor(LoadCursor(NULL,IDC_WAIT));

		if(iPos==2)											// Netzwerkspfad "\\..."
			{
			iLen		= CFileFinder::NetPathConvert(cPath,cTemp,MAX_PATH);
			iIcon		= GetSmallIcon(cTemp,uAttr);
			m_iPathType = (uAttr!=0xFFFFFFFF)? 1:0;
			}
		else{												// Laufwerkspfad "C:\...."
			m_iPathType = (cPath[1]==':' && cPath[2]==0)? 2:1;
			iIcon		= GetSmallIcon(cPath,uAttr);
			if(uAttr==0xFFFFFFFF)m_iPathType=3;
			}

		SetCursor(LoadCursor(NULL,IDC_ARROW));
		}
	else{
		if(iReal)m_iPathType=0;
		else if(cPath[1]==':' && cPath[2]==0)
				m_iPathType = 2;
		else	m_iPathType = 1;
		}

	if(uAttr==0xFFFFFFFF && m_bMustExist)					// Exitiert der Pfad
		{
		return 0;
		}

	if(uAttr==0xFFFFFFFF && iPos==2 && m_aPathDirs[0].Count())
		{
		iLen = strcwlen(cPath+iPos,0x00300000);

		if(cPath[iLen]==0 || cPath[iLen+2]==0)				// Icon aus Laufwerksliste
			{
			   iNum = m_aPathDirs[0].Find(iLen,cPath+iPos,0,-1,0x01);
			if(iNum>=0)
				{
				iIcon = m_aPathDirs[0].DataGet(iNum);
				}
			}
		}

	m_iFolders		= 0;
	m_aPathStart[0] = 0;
	m_aPathStart[1] = m_iButtonSize;
	m_iFolderIcon	= iIcon;

	iSame	= 1;
	hDc		= ::GetDC(m_hWnd);
	SelectObject(hDc,m_hFontText);



	if(m_aPathDirs[0].Count())								// Laufwerke schon eingelesen
		{
		   uBits = GetLogicalDrives();
		if(uBits!=m_uLastDrives)
			{
			UpdateDrives(uBits);
			}

		uBits  =  m_iTurn&0x00FFFFFF;
		uBits |=  1<<24;
		m_aPathDirs[0].SetUserData(uBits+1);
		}


	for(;;)													// Pfad abschreiten
		{
		iPos += strwlen (cPath+iPos,0x00300000);
		iLen  = strcwlen(cPath+iPos,0x00300000);

		if(iLen==0 || m_iFolders>=CPC_MAX_FOLDERS)break;

		GetTextExtentPoint(hDc,cPath+iPos,iLen,&sSize);		// Textbreite in Pixel

		m_aPathOffset[m_iFolders] = iPos;
		m_aPathSize	 [m_iFolders] = iLen;

		m_iFolders++;
															// Ist es noch das gleiche Verzeichnis
		if(iSame==0 || _tcsnicmp(cPath+iPos,m_cPath+iPos,iLen) || !strwchar(m_cPath[iPos+iLen],0x80300000))
			{
			iSame  = 0;
			}
		else{
			uBits  =  m_iTurn&0x00FFFFFF;
			uBits |= (m_iFolders+1)<<24;

			   uUser = m_aPathDirs[m_iFolders].GetUserData();
			if(uUser==uBits && m_aPathDirs[iPos].Count())
				{
				m_aPathDirs[m_iFolders].SetUserData(uBits+1);
				}
			}

		m_aPathStart[m_iFolders*2  ] = (WORD)(m_aPathStart[m_iFolders*2-1]+sSize.cx+CPC_TEXT_FRAME);
		m_aPathStart[m_iFolders*2+1] = (WORD)(m_aPathStart[m_iFolders*2  ]+m_iButtonSize);

		iPos += iLen;
		}

	memcpy(m_cPath,cPath,(iSize+1)*sizeof(TCHAR));


	::ReleaseDC(m_hWnd,hDc);

	m_iTurn++;
	m_aPathSize	 [m_iFolders] = 0;
	m_aPathOffset[m_iFolders] = iPos;

	StartSearch(m_iFolders);

	m_sLock.Unlock();

	DefWindowProc(WM_SETTEXT,0,(LPARAM)m_cPath);
	::SetWindowText(m_hEdit,m_cPath);

	CalcBase();
	RedrawWindow();


	if(m_bHasHistory)										// Pfade der Historie
		{
			pName = m_sHistory[m_iHistoryPos];
		if(!pName || _tcsicmp(pName,m_cPath))
			{
			m_iHistoryPos = m_sHistory.Add(m_cPath,m_iHistoryPos+1);
			m_sHistory.Del(m_iHistoryPos+1,-1);
			iNum = m_sHistory.Count()-m_iHistoryMax;

			if(iNum>0)
				{
				m_sHistory.Del(0,iNum);
				m_iHistoryPos -= iNum;
				}
			}
		}


	sNotify.sNmHdr.code		= CPC_FOLDERSELECT;
	sNotify.sNmHdr.hwndFrom	= m_hWnd;
	sNotify.sNmHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
	sNotify.hDummy			= NULL;
	sNotify.pPath			= m_cPath;
	sNotify.iMode			= 1;
															// Eltern-Fenster benachrichtigen
	GetParent()->SendMessage(WM_NOTIFY,sNotify.sNmHdr.idFrom,(LPARAM)&sNotify);



return 1;
}

//*****************************************************************************
//*
//*		SubclassWindow
//*
//*****************************************************************************
BOOL CPathCtrl::SubclassWindow(DWORD dwStyle,HWND hWnd)
{
CRect	sRect;
BOOL	bOk;


	GlobalInit();

	ASSERT(IsWindow(hWnd));

	#ifdef _DEBUG

	char 	cClass[32];
	DWORD	dwValue;

	GetClassNameA(hWnd,cClass,sizeof(cClass));
	ASSERT(!strcmp(cClass,"ComboBox"));

	dwValue  = GetWindowLong(hWnd,GWL_STYLE);
	dwValue &= 0x0F|CBS_OWNERDRAWFIXED|CBS_HASSTRINGS|CBS_AUTOHSCROLL;
	ASSERT(dwValue==(CBS_DROPDOWN|CBS_OWNERDRAWFIXED|CBS_HASSTRINGS|CBS_AUTOHSCROLL));

	#endif

	LocalInit(dwStyle);

		bOk=CComboBox::SubclassWindow(hWnd);
	if(!bOk || !PostInit())return FALSE;

	GetClientRect(&sRect);

			   PostMessage(WM_SIZE,0,MAKELONG(sRect.Width(),sRect.Height()));
	           PostMessage(WM_SETFONT,(WPARAM)m_hFontText,0);
	m_cDirList.PostMessage(WM_SETFONT,(WPARAM)m_hFontText,0);


return TRUE;
}

//*****************************************************************************
//*
//*		UnsubclassWindow
//*
//*****************************************************************************
HWND CPathCtrl::UnsubclassWindow()
{

	m_sLock.Lock();

	if(m_pThreadData && m_pThreadData->uInitOk<3)		// Den Thread beenden
		{
		m_pThreadData->uCommand = 0xFFFFFFFF;
		m_pThreadData->uInitOk	= 2;
		m_pThreadData->sFind.Break();
		m_pThreadData->sSem.Unlock();
		}

	m_sLock.Unlock();

	if(IsWindow(m_cDirList.m_hWnd))
		{
		m_cDirList.DestroyWindow();
		}


return CComboBox::UnsubclassWindow();
}

//*****************************************************************************
//*
//*		StopEdit
//*
//*****************************************************************************
//	Bricht das aktuelle Editiren ab.
//	bCancel		: Soll die Eingabe bernommen werden
//	Ergibt TRUE wenn das Fenster im Edit-Modus war.
BOOL CPathCtrl::StopEdit(BOOL bCancel)
{
TCHAR	cEdit[MAX_PATH];
TCHAR	cPath[MAX_PATH];
int		iEnd;
int		iLen;


	if(m_bBreadCrumb==0)								// Ist der Focus im Edit-Fenster
		{
		return FALSE;
		}

	if(bCancel)
		{
		if(m_bEditOn)OnExitEdit();
		goto Exit;
		}

	if(!m_bEditOn && m_bTextChanged && m_cEditPath[0])	// Hat das Fenster den Fokus bereits verloren
		{
		m_bTextChanged = 0;
		iLen  = _tcslen(m_cEditPath);
		memcpy(cEdit,m_cEditPath,(iLen+1)*sizeof(TCHAR));
		}
	else{												// Das Fenster hat noch den Fokus
		   iLen = (int)::SendMessage(m_hEdit,WM_GETTEXT,MAX_PATH,(LPARAM)cEdit);
		if(iLen<=0)goto Exit;
		}

       iLen = GetFullPathName(cEdit,MAX_PATH,cPath,NULL);
	if(iLen<=0)goto Exit;

	iEnd = _tcslen(m_cPath);

	if(iEnd>0)
		{
		if(cPath  [iLen-1]=='\\' || cPath  [iLen-1]=='/')iLen--;
		if(m_cPath[iEnd-1]=='\\' || m_cPath[iEnd-1]=='/')iEnd--;

		if(iLen==iEnd && !CmpFileNameG(m_cPath,cPath,iLen,iEnd))
			{
			goto Exit;
			}											// Der neue Pfad ist gleich
		}

	SetPath(cPath);

Exit:

	SetFocus();


return TRUE;
}
