//*****************************************************************************
//*
//*
//*		Implementierung der Klasse CPathDlg
//*
//*
//*****************************************************************************
//
//  int		 GetPath(char *pBuffer,int iMax,int iAddBackSlash)
//	char    *GetPath(int iAddBackSlash)				Pfad lesen
//	char    *SetPath(char    *pPath)				Pfad setzen
//	char    *SetCurrentPath()						Aktuellen Pfad setzen
//	char    *PathUp()								Pfad um eins nach oben setzen
//	char    *PathNext(CString*pPath)				Unterverzeichnis anhngen
//	void     SetTitle(char *pText=0)				Titeltext eingeben
//  INT_PTR	 DoModal(char *pRegName=0,int iMode=3)	Dialog aus fhren (IDOK/IDCANCEL)
//
#ifndef		__PFADDLG_H__
#define		__PFADDLG_H__


#define 	CPD_MUSTEXIST		0x01				// Pfad muss existieren
#define 	CPD_CREATEPATH		0x02				// Pfad neu erzeugen
#define 	CPD_NONETWORK		0x04				// Netzpfade sind nicht erlaubt
#define 	CPD_NOTREECTRL		0x08				// Kein Baumfenster anzeigen
#define 	CPD_NOBREADCRUMB 	0x10				// Keine Brotkrumennavigation

#include	<afx.h>
#include	<afxmt.h>
#include	"StringChain.h"
#include	"FileFinder.h"
#include	"AfxMacros.h"


//*****************************************************************************
//*
//*		Dialog CPathDlg
//*
//*****************************************************************************
class CPathDlg : public CDialog
{
public:

	DECLARE_DLG_OLDSIZE()

	CPathDlg(CWnd *pParent=NULL,LPCTSTR pRegName=0);
   ~CPathDlg();

	int		GetFlags      (                        );
	void  	SetFlags      (int	          iFlags   );
	int	  	GetPath       (TCHAR         *pBuffer ,int iMax,int iAddBackSlash=0);
	int	  	GetPath       (CString       &sBuffer          ,int iAddBackSlash=0);
	INT_PTR	DoModal       (LPCTSTR		  pRegName,int iMode=CPD_MUSTEXIST|CPD_CREATEPATH);
	TCHAR  *GetPath       (                        int iAddBackSlash=0);
	TCHAR  *SetPath       (LPCTSTR		  pPath    );
	void  	AddPathLast   (LPCTSTR		  pPath    );
	void  	SetPathLast   (LPCTSTR		  pChain   );
	void  	SetPathLast   (CStringChain *pChain    );
	void  	SetTitle      (LPCTSTR		  pText=0  );
	void  	SetRegKey     (LPCTSTR		  pKey     );
	void  	SetExtension  (LPCTSTR		  pName    );
	void  	SetTemplate   (int			  iTemplate);
	TCHAR  *PathNext      (LPCTSTR		  pPath    );
	TCHAR  *PathUp        (                        );
	TCHAR  *SetCurrentPath(                        );

protected:

	BOOL				m_bNoNetwork;				// Keine Netzwerkpfade
	BOOL				m_bMustExist;				// Pfad muss existieren
	BOOL				m_bCreatePath;				// Pfad neu erzeugen
	BOOL				m_bNoTreeCtrl;				// Kein Baumfenster anzeigen
	BOOL				m_bNoBreadCrumb;			// Keine Brotkrumennavigation

	CString				m_sPath;					// Pfad ohne Backslash
	CString				m_sPathSlash;				// Pfad mit  Backslash

	bool volatile		m_bThreadRunning;			// Luft der Einlese-Thread bereit
	bool volatile		m_bThreadReady;				// Ist der Einlese-Thread bereit
	bool volatile		m_bStartRead;				// Das einlesen der Verzeichnisse Starten
	bool volatile		m_bCloseDlg;				// Wurde der Dialog geschlossen
	bool				m_bDlgActive;				// Ist der Dialog offen
	bool				m_bUpdateLb;				// Die Listbox aktualisieren
	bool				m_bSetList;					// Liste setzen
	int					m_iIconNet;					// Icon fr Netzumgebung
	int					m_iIconDir;					// Icon fr Verzeichnis
	int					m_iIconOpen;				// Icon fr offenes Verzeichnis
	int					m_iIconNetLw;				// Icon fr Extra Netzlaufwerk
	int					m_iStartMode;				// Modus fr Laufwerke (-1=unbekannt 0=nicht 1=File 2=Pfad 3=Laufwerk 4=realer Netzpfad 5=Share)

	HIMAGELIST			m_sImageList;				// Icon Liste
	CListBox		   *m_pListBox;					// Verzeichnis Fenster
	CComboBox		   *m_pDriveBox;				// Laufwerks   Fenster
	CComboBox		   *m_pPathBox;					// Pfadanzeige
	CStringChain	   *m_pLastPaths;				// Zuletzt gewhlte Pfade
	CSemaphore			m_sReadSem;					// Semaphore der das Einlesen startet
	CString				m_sTitle;					// Titel Text
	CString				m_sNetName;					// Netzpfad beim Start
	CString				m_sPathExtension;			// Text fr Pfaderweiterung
	CString				m_sSelectedPath;			// In Verzeichnis Fenster gewhlter Pfad
	CString				m_sRealNetPath;				// Realer Pfad fr Netzlaufwerke
	CStringChain	   *m_pDirectories;				// Verzeichnisse
	int					m_iDirPos;					// Verzeichnis Knick
	int					m_iInOnSelectList;			// Die Funktion OnSelectList wurde aufgerufen
	TCHAR			   *m_pExtraNetDrive;			// Extra Netzlaufwerk
	TCHAR			   *m_pRegName;					// Registry Name

	CStringChain	   *m_pOldPaths;				// Alte Pfade
	CStringChain	   *m_pDrives;					// Laufwerke
	int					m_iDriveType;				// Laufwerkestyp (0=Disk 1=Netz)
	int					m_iDriveSel;				// Laufwerk das gerade gewhlt ist

	int					m_iTextOff;					// Y-Offet fr Text in der Liste
	int					m_iKeyPos;					// Aktuelle Position fr Tasteneingabe
	unsigned			m_uKeyLast;					// Wann gab es die letzte Eingabe
	TCHAR				m_cKeyData[8];				// Speicher fr gedrckte Tatsen
	TCHAR				m_cReadPath[256];			// Pfad fr's einlesen des Verzeichnissses

	WNDPROC				m_pListProc;				// Alte Fensterfunktion fr Listbox
	CWnd			   *m_pTreeCtrl;				// Zeiger auf BaumfFenster
	CWnd			   *m_pPathCtrl;				// Zeiger auf Brodkrummenfenster
	BOOL				m_bTreeMode;				// Ist das BaumfFenster aktiv
	BOOL				m_bBreadMode;				// Ist die Brotkrumennavigation aktiv
	UINT				m_uTreeTicker;				// Update Ticks fr Baumfenster
	CRITICAL_SECTION 	m_sSynch;					// Synchronisierungs Objekt

	//{{AFX_VIRTUAL(CPathDlg)
public:
	virtual INT_PTR DoModal();
protected:
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange *pDX);
	//}}AFX_VIRTUAL

protected:

	void  WaitForExit ();
	void  ReadList    ();
	int   GetDrive    ();
	int	  ExistPath   (LPCTSTR pPath);
	void  LoadRegistry(LPCTSTR pRegName,int iMode=CPD_MUSTEXIST|CPD_CREATEPATH);

	//{{AFX_MSG(CPathDlg)
	afx_msg LRESULT OnDrop     (WPARAM wParam,LPARAM lParam);
	afx_msg void OnTimer       (UINT_PTR uIdEvent);
	afx_msg void OnSelChanged  (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnPathChanged (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnItemDblClick(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnMeasureItem (int nId,LPMEASUREITEMSTRUCT pMeasureItem);
	afx_msg void OnDrawItem    (int nIDCtl, LPDRAWITEMSTRUCT pDrawItemStruct);
	afx_msg void OnKeyDown     (UINT nChar, UINT nRepCnt,UINT nFlags);
	afx_msg void OnSysCommand  (UINT nID, LPARAM lParam);
	afx_msg void OnSelchangeDrive();
	afx_msg void OnSelchangeLast ();
	afx_msg void OnSetTreePath   ();
	afx_msg void OnSelectList    ();
	afx_msg void OnDriveDone     ();
	afx_msg void OnBreadMode	 ();
	afx_msg void OnTreeMode	     ();
	afx_msg void OnReadDone		 ();
	afx_msg void OnDestroy       ();
	afx_msg void OnPathUp	     ();
	virtual void OnCancel        ();
	virtual void OnOK            ();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_DLG_SIZING()

		   UINT		InitThread();
	static UINT		InitThread(LPVOID pParam);
  	static LRESULT  CALLBACK ListProc (HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static LRESULT  CALLBACK ComboProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static WORD		m_wDlgData[];
};

//{{AFX_INSERT_LOCATION}}

#endif
