//*****************************************************************************
//*
//*
//*		ProgressDlg.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#include	<afx.h>
#include	<afxwin.h>
#include	<afxext.h>
#include	<afxdisp.h>
#include	<shlwapi.h>
#include	<afxdtctl.h>
#include	"AfxUtility.h"
#include	"ProgressDlg.h"
#include	"FileFunctions.h"
#include	"StringFunctions.h"


#ifdef		   _DEBUG
#define new		DEBUG_NEW
#undef			THIS_FILE
static char		THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CProgressDlg, CDialog)
	//{{AFX_MSG_MAP(CProgressDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CProgressDlg)



#ifndef		_WIN64
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr	SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr	GetWindowLong
#endif
#endif

#ifndef 	IDR_MAINFRAME
#define 	IDR_MAINFRAME		128
#endif

#ifndef		PBM_SETMARQUEE
#define		PBM_SETMARQUEE      (WM_USER+10)
#endif

#ifndef 	PBS_MARQUEE
#define		PBS_MARQUEE			0x08
#endif

#define 	TBL_NOPROGRESS		0x0000					// Progress-Bar abschalten
#define 	TBL_TICKER			0x0001					// Progress-Bar in den Ticker-Modus umschalten
#define 	TBL_NORMAL			0x0002					// Normale Farbe fr Progress-Bar
#define 	TBL_ERROR			0x0004					// Rote    Farbe fr Progress-Bar
#define 	TBL_PAUSED			0x0008					// Gelbe   Farbe fr Progress-Bar

#define 	IDC_TEXT			1034
#define 	IDC_ICONWND			1099
#define 	IDC_PROGRESS1		1019

#define 	ID_UPDATEDLG		0x1991
#define 	ID_MESSAGEDLG		0x1992
#define 	ID_ENDDLG			0x1993
#define 	ID_TIMEPROC			0x1994
#define 	ID_STEPPROC			0x1995
#define 	ID_QUERYPROC		0x1996
#define 	ID_DIALOG			0x1997
#define 	ID_DELAYSHOW		0x1998
#define 	ID_UPDATETEXT		0x1999

BYTE CProgressDlg::m_aFontSize[256];					// Buchstabennreiten fr den Dialog
BOOL CProgressDlg::m_bFontDone  = 0;					// Wurden doe Buchstabennreiten geholt
int  CProgressDlg::m_iTaskBarOn = 0;					// Taskbar-Modus (-1 geht nicht,0=unbekannt 1=geht)
int  CProgressDlg::m_iInitWidth = 410;					// Initialierungsbreite des Textfensters

WORD CProgressDlg::m_aDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0004,0x0000,0x0000,0x0147,0x0047,0x0000,0x0000,0x0044,0x0069,0x0061,0x006C,0x006F,
	0x0067,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,
	0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x0087,0x002D,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,
	0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x5080,0x0000,0x0000,0x0023,0x001E,0x0118,0x0009,
	0x03FB,0x006D,0x0073,0x0063,0x0074,0x006C,0x0073,0x005F,0x0070,0x0072,0x006F,0x0067,0x0072,0x0065,0x0073,0x0073,
	0x0033,0x0032,0x0000,0x0050,0x0072,0x006F,0x0067,0x0072,0x0065,0x0073,0x0073,0x0031,0x0000,0x0000,0x0080,0x5002,
	0x0000,0x0000,0x0028,0x000F,0x0113,0x0008,0x040A,0xFFFF,0x0082,0x0000,0x0000,0x0000,0x0003,0x5000,0x0000,0x0000,
	0x0005,0x000F,0x0014,0x0014,0x044B,0xFFFF,0x0082,0xFFFF,0x0080,0x0000,
	};


const IID	IID_ITaskbarList3_	= {0xEA1AFB91,0x9E28,0x4B86,0x90,0xE9,0x9E,0x9F,0x8A,0x5E,0xEF,0xAF};

#if _MSC_VER <= 1299

typedef enum THUMBBUTTONMASK
	{
	THB_BITMAP   		= 0x00000001,
	THB_ICON     		= 0x00000002,
	THB_TOOLTIP  		= 0x00000004,
	THB_FLAGS    		= 0x00000008
	}THUMBBUTTONMASK;

typedef enum THUMBBUTTONFLAGS
	{
	THBF_ENABLED        = 0x00000000,
	THBF_DISABLED       = 0x00000001,
	THBF_DISMISSONCLICK = 0x00000002,
	THBF_NOBACKGROUND   = 0x00000004,
	THBF_HIDDEN         = 0x00000008,
	THBF_NONINTERACTIVE = 0x00000010
	}THUMBBUTTONFLAGS;

typedef struct THUMBBUTTON
	{
	THUMBBUTTONMASK  	dwMask;
	UINT             	iId;
	UINT             	iBitmap;
	HICON            	hIcon;
	WCHAR				szTip[260];
	THUMBBUTTONFLAGS	dwFlags;
	}THUMBBUTTON,*LPTHUMBBUTTON;

#endif 

typedef struct ITaskbarList3Vtbl
    {
    BEGIN_INTERFACE

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface		)(VOID __RPC_FAR *pThis,REFIID pRiid,void __RPC_FAR *__RPC_FAR *pObject);
	ULONG   ( STDMETHODCALLTYPE __RPC_FAR *AddRef				)(VOID __RPC_FAR *pThis);
	ULONG   ( STDMETHODCALLTYPE __RPC_FAR *Release				)(VOID __RPC_FAR *pThis);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *HrInit				)(VOID __RPC_FAR *pThis);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *AddTab				)(VOID __RPC_FAR *pThis,HWND hWnd);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DeleteTab			)(VOID __RPC_FAR *pThis,HWND hWnd);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ActivateTab			)(VOID __RPC_FAR *pThis,HWND hWnd);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetActiveAlt			)(VOID __RPC_FAR *pThis,HWND hWnd);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *MarkFullscreenWindow	)(VOID __RPC_FAR *pThis,HWND hWnd,BOOL      bFullScreen);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetProgressValue		)(VOID __RPC_FAR *pThis,HWND hWnd,ULONGLONG uCompleted,ULONGLONG uTotal);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetProgressState		)(VOID __RPC_FAR *pThis,HWND hWnd,DWORD     dwTbpFlags);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *RegisterTab			)(VOID __RPC_FAR *pThis,HWND hwndTab,HWND   hWndMdi);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *UnregisterTab		)(VOID __RPC_FAR *pThis,HWND hwndTab);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetTabOrder			)(VOID __RPC_FAR *pThis,HWND hwndTab,HWND hWndInsertBefore);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetTabActive			)(VOID __RPC_FAR *pThis,HWND hwndTab,HWND hWndMdi,DWORD dwReserved);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ThumbBarAddButtons	)(VOID __RPC_FAR *pThis,HWND hWnd,UINT uButtons,LPTHUMBBUTTON pButton);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ThumbBarUpdateButtons)(VOID __RPC_FAR *pThis,HWND hWnd,UINT uButtons,LPTHUMBBUTTON pButton);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ThumbBarSetImageList	)(VOID __RPC_FAR *pThis,HWND hWnd,HIMAGELIST hImageList);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOverlayIcon		)(VOID __RPC_FAR *pThis,HWND hWnd,HICON   hIcon,LPCWSTR pDescription);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetThumbnailTooltip	)(VOID __RPC_FAR *pThis,HWND hWnd,LPCWSTR pTip);
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetThumbnailClip		)(VOID __RPC_FAR *pThis,HWND hWnd,LPRECT  pClip);

    END_INTERFACE
    }ITaskbarList3Vtbl;

typedef struct
	{
	ITaskbarList3Vtbl	*pVtbl;
	}ITaskbarList_;


typedef DWORD (_stdcall *GetVersionType)(DLLVERSIONINFO*);

#define 	TBL(a)	((ITaskbarList_*)(a))

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CProgressDlg::CProgressDlg(CWnd *pParent):CDialog((UINT)0,pParent)
{


	//{{AFX_DATA_INIT(CProgressDlg)
	//}}AFX_DATA_INIT

	m_uDelayShow	= 0;
	m_iRun			= 0;
	m_pThreadProc	= 0;
	m_iRangeSub		= 0;
	m_iRangeShift	= 0;
	m_pThread		= 0;
	m_pProcParam1	= 0;
	m_pProcParam2	= 0;
	m_pProcParam3	= 0;
	m_pProcParam4	= 0;
	m_iProcExit		=-1;
	m_iPriority		= THREAD_PRIORITY_NORMAL;
	m_iTextWidth	= m_iInitWidth;
	m_iRange		= 100;
	m_iRangeEnd		= 100;
	m_iProgressMode	= 0;
	m_iPreXpVersion	= 0;
	m_iCancel		= 0;
	m_iExit			= 0;
	m_iPos			= 0;
	m_iNoCancel		= 0;
	m_iPosUnshift	= 0;
	m_iProcTime		= 0;
	m_pQueryPos		= 0;
	m_pQueryMax		= 0;
	m_iQueryTime	= 0;
	m_iQueryMode	= 0;
	m_pQueryProc	= 0;
	m_pBreakProc	= 0;
	m_pParamBreak	= 0;
	m_pParamTime	= 0;
	m_pTimeProc		= 0;
	m_iIcon			= 0;
	m_hIcon			= 0;
	m_hTextFont		= 0;
	m_bIsClosed		= 0;
	m_bTextTimer	= 0;
	m_iTextHeight	= 9;
	m_uLinesNow		= 0;
	m_uLineCount	= 1;
	m_pTaskbar		= 0;
	m_iTaskbarSub	= 0;
	m_iTaskbarPos	= 0;
	m_iTaskbarLock	= 0;

	memset(m_cTextBuffer,0,sizeof(m_cTextBuffer));

	m_sMboxSem.Lock();

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_aDlgData);
}

//*****************************************************************************
//*
//*		Denstruktor
//*
//*****************************************************************************
CProgressDlg::~CProgressDlg()
{

	m_sMboxSem.Unlock();
	while(m_iRun)Sleep(50);

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CProgressDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressDlg)
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
INT_PTR	CProgressDlg::DoModal()
{

	m_bIsClosed = 0;


return CDialog::DoModal();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CProgressDlg::OnCancel()
{

	if(m_pBreakProc && !m_iCancel)
		{
		m_pBreakProc(m_pParamBreak);
		}

	m_iExit   = 1;
	m_iCancel = 1;


	GetDlgItem(IDCANCEL)->EnableWindow(FALSE);

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CProgressDlg::OnInitDialog()
{
HFONT			hFont;
CStatic		   *pWnd;
unsigned		uPos;


	m_aLastSet[0]	= GetTickCount()-1000;
	m_iTaskbarLock	= 0;
	m_iTaskbarLast	= 0;
	m_bTextTimer	= 0;
	m_uLinesNow		= 1;
	m_bIsClosed		= 0;
	m_pWndProc		= 0;


	for(uPos=1;uPos<CPD_MAX_LINE;uPos++)
		{
		m_aLastSet[uPos] = m_aLastSet[0];
		}

	SET_DLG_OLDPOS()


	m_pTextWnd		= GetDlgItem(IDC_TEXT);
	m_pTextWnd->GetClientRect(&m_sTextRect);
	m_hTextFont		= (HFONT)m_pTextWnd->GetFont()->m_hObject;
	m_iTextHeight	= m_sTextRect.Height()+2;
	m_iTextWidth	= m_sTextRect.Width();
	m_iInitWidth	= m_iTextWidth;

	if(m_bFontDone!=TRUE)							// Wurden die Buchstabennreiten geholt
		{
		   hFont = (HFONT)m_pTextWnd->SendMessage(WM_GETFONT,0,0);
		if(hFont)									
			{
			GetCharWidths(m_aFontSize,hFont);
			m_bFontDone = TRUE;
			}
		}

	UpdateLines(m_uLineCount);						// Zustzliche Zeilen einblenden


	CDialog::OnInitDialog();

	if(m_iIcon)										// Ein anderes Icon laden
		{
		m_hIcon=LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(m_iIcon));
		ASSERT(m_hIcon!=0);
		}

	if(m_hIcon)										// Ein anderes Icon laden
		{
		pWnd=(CStatic*)GetDlgItem(IDC_ICONWND);
		pWnd->SetIcon(m_hIcon);
		}

	if(m_iNoCancel)
		{
		GetDlgItem(IDCANCEL)->ShowWindow(SW_HIDE);
		}

	if(m_sTitle!="")SetWindowText(m_sTitle);

	m_iPos			= 0;
	m_iExit			= 0;
	m_iCancel		= 0;
	m_iPosUnshift	= 0;

	m_pProgress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);
	m_pProgress->SetRange(0,(short)(m_iRange>>m_iRangeShift));
	m_pProgress->SetPos(0);

	if(m_iProgressMode)								// Spezialanzeige fr den Step-Modus
		{
		ProgresMode(m_iProgressMode);
		}

	SetDlgItemText(IDC_TEXT,m_cTextBuffer);

	if(m_iProcTime )SetTimer(ID_TIMEPROC ,m_iProcTime ,NULL);
	if(m_iQueryTime)SetTimer(ID_QUERYPROC,m_iQueryTime,NULL);


	m_pThread = AfxBeginThread(ThreadProc,this,m_iPriority,0x20000);


	if(m_uDelayShow)
		{
		GET_DLG_OLDPOS();
		EnableWindow(FALSE);
		SetCursor(IDC_WAIT);
		SetTimer(ID_DELAYSHOW,m_uDelayShow,NULL);
		SetWindowPos(0,0x7000,0x7000,0,0,SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_NOZORDER);
		}


return TRUE;

}

//*****************************************************************************
//*
//*		ProgresMode
//*
//*****************************************************************************
//	Progress-Modus einstellen
//	iNewMode	: Stellt den Modus der ProgressBar ein:
//						0  = Normale Zeile von 0 bis n
//					    1  = Step-Bar die nur Schritte anzeigt.
//					  >10  = Step-Bar die nur Schritte anzeigt mit automatischen
//							 Verschieben alle N Millisekunden.
//	iOldMode	: Alter Modus der aufgehoben werden soll (-1=keiner)
void CProgressDlg::ProgresMode(int iNewMode,int iOldMode)
{
static int		iDone=0;
static int		iMode=0;


	if(!iDone)										// OS-Version setzen
		{
		GetVersionType	pGetVersion;
		DLLVERSIONINFO	sInfo;
		HMODULE			hDll;

		hDll		= GetModuleHandleW(L"ComCtl32.dll");
		pGetVersion	= (GetVersionType)GetProcAddress(hDll,"DllGetVersion");

		if(pGetVersion)
			{
			sInfo.cbSize = sizeof(sInfo);
			pGetVersion(&sInfo);
			iMode = (sInfo.dwMajorVersion>=6)? 1:0;
			}

		iDone = 1;
		}


	if(iOldMode>=0)									// Alten Modus zurck setzen
		{
		if(iOldMode>10)
			{
			KillTimer(ID_STEPPROC);
			}

		if(iOldMode!=0 && iNewMode==0)
			{
			if(iMode==0)
				{
				if(m_pWndProc)SetWindowLongPtr(m_pProgress->m_hWnd,GWL_WNDPROC ,(LPARAM)m_pWndProc);
				m_iPreXpVersion = 0;
				}
			else{
				SetStyle(m_pProgress,~PBS_MARQUEE&::GetStyle(m_pProgress));
				::SendMessage(m_pProgress->m_hWnd,PBM_SETMARQUEE,FALSE,0);
				}
			}
		}


	if(iNewMode)									// Step-Modus einschalten
		{
		m_iRangeShift	= 0;
		m_pProgress->SetRange(0,100);
		m_iStepPos		= 0;

		if(iMode==0)								// Vor XP selber zeichnen
			{
			if(!m_pWndProc)m_pWndProc=(WNDPROC)GetWindowLongPtr(m_pProgress->m_hWnd,GWL_WNDPROC);
			SetWindowLongPtr(m_pProgress->m_hWnd,GWL_USERDATA,(LPARAM)this);
			SetWindowLongPtr(m_pProgress->m_hWnd,GWL_WNDPROC ,(LPARAM)WndProc);
			m_iPreXpVersion = 1;
			if(m_iProgressMode>10)SetTimer(ID_STEPPROC,m_iProgressMode,NULL);
			}
		else{										// Ab XP
			SetStyle(m_pProgress,PBS_MARQUEE|::GetStyle(m_pProgress));

			if(m_iProgressMode>10)
			if(!::SendMessage(m_pProgress->m_hWnd,PBM_SETMARQUEE,TRUE,m_iProgressMode))
				{
				// Ein Mainfest mit XP-Style muss hinzugefgt werden
				ASSERT(0);
				}
			}
		}
}

//*****************************************************************************
//*
//*		SetRange
//*
//*****************************************************************************
//	Den ProgressBar Bereich einstellen
//	Bereiche die die WORD-Grenze berschreiten werden korrigiert
void CProgressDlg::SetRange(__int64 iLower,__int64 iRange)
{
	if(m_iProgressMode)return;

	m_iRangeSub = iLower;
	SetRange(iRange-iLower);
}

void CProgressDlg::SetRange(__int64 iRange)
{
__int64 iVal;


	if(m_iProgressMode)return;
	if(iRange<1)iRange=1;

	m_iRangeEnd   = iRange;

	if(iRange>512)iRange+=iRange/256;

	if(m_iRange==iRange)return;

	m_iRange      = iRange;
	m_iRangeShift = 0;

	for(iVal=iRange;iVal>(__int64)1024;iVal>>=1)
		{
		m_iRangeShift++;
		}


	if(!IsWindow(		      m_hWnd))return;
	if(!IsWindow(m_pProgress->m_hWnd))return;

	PostMessage(WM_COMMAND,ID_UPDATEDLG,4);

}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Einstellen des Textes ber der Progressbar
//	uLine	: Ist die Nummer der Zeile die gendert werden soll
//	pText	: Zeiger auf den Text
//	pPath	: Ist der Pfad der bei eingefgt 'iPos' eingefgt werden soll
//	iBase	: Anzahl der Verzeichnisse die am Anfang stehen
//	iPos	: Wenn grer 0 ist es das Zeichen bei dem der Pfad eingefgt wird,
//			  wenn kleiner 0 dann ist des die Position im Text.
void CProgressDlg::SetText(UINT uLine,LPCTSTR pText,LPCTSTR pPath,int iBase,int iPos)
{
unsigned	uDelta;
unsigned	uStart;
unsigned	uTick;
int			iNext;


	if(uLine>=CPD_MAX_LINE)return;
	if(uLine && uLine+1<m_uLinesNow)SetLines(uLine+1);

	if(!pText)pText=_T("");
	if(!pPath)pPath=_T("");


	if(iPos>0)									// Markierung mit Zeichen
		{
		iPos	= strchar(pText,iPos);
		iNext	= iPos;
		if(pText[iPos])iNext++;
		}
	else{										// Direkte Position
		iPos	= strnlen(pText,-iPos);
		iNext	= iPos;
		}

	if(!m_bFontDone)							// Wurden die Buchstabennreiten geholt
		{
		GetCharWidths(m_aFontSize);
		m_bFontDone = 2;
		}

	uStart	= uLine*CPD_MAX_SIZE;
	iPos	= strlcpy(m_cTextBuffer+uStart,pText               ,CPD_MAX_SIZE,iPos);
	iPos   += CommpressFileName(pPath,m_cTextBuffer+uStart+iPos,CPD_MAX_SIZE-iPos,m_iTextWidth-5,m_aFontSize,iBase,pText,pText+iNext,1024,iPos);
	iPos   += strlcpy(m_cTextBuffer+uStart+iPos,pText+iNext    ,CPD_MAX_SIZE-iPos);

	if(!IsWindow(m_hWnd))return;

	uTick	= GetTickCount();
	uDelta	= uTick-m_aLastSet[uLine];

	if(uDelta<80)								// Text verzgert bertragen
		{
		m_aTextFlag[uLine] = 1;
		if(m_bTextTimer)return;
		PostMessage(WM_COMMAND,ID_UPDATEDLG,5+uLine*256);
		m_bTextTimer = 1;
		return;
		}


	PostMessage(WM_COMMAND,ID_UPDATEDLG,1+uLine*256);

}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Einstellen des Textes ber der Progressbar
//	uLine	: Ist die Nummer der Zeile die gendert werden soll
//	pText	: Zeiger auf den Text
void CProgressDlg::SetText(UINT uLine,LPCTSTR pText)
{
unsigned	uDelta;
unsigned	uTick;


	if(uLine>=CPD_MAX_LINE)return;
	if(uLine && uLine+1>m_uLinesNow)SetLines(uLine+1);

	if(!pText)pText=_T("");
	if(!_tcscmp(m_cTextBuffer+uLine*CPD_MAX_SIZE,pText))
		{
		return;
		}

	strlcpy(m_cTextBuffer+uLine*CPD_MAX_SIZE,pText,CPD_MAX_SIZE);

	if(!IsWindow(m_hWnd))return;


	uTick	= GetTickCount();
	uDelta	= uTick-m_aLastSet[uLine];

	if(uDelta<80)								// Text verzgert bertragen
		{
		m_aTextFlag[uLine] = 1;
		if(m_bTextTimer)return;
		PostMessage(WM_COMMAND,ID_UPDATEDLG,5+uLine*256);
		m_bTextTimer = 1;
		return;
		}


	PostMessage(WM_COMMAND,ID_UPDATEDLG,1+uLine*256);

}

//*****************************************************************************
//*
//*		SetPos
//*
//*****************************************************************************
//	Die ProgressBar Position einstellen
//	Positionen die die WORD-Grenze berschreiten werden gekrzt
void CProgressDlg::SetPos(__int64 iPos)
{
int		iPosNew;


	iPos		 -= m_iRangeSub;

	if(iPos>=m_iRangeEnd)
		{
		iPos = m_iRange;
		}

	m_iPosUnshift = iPos;
	iPosNew		  = (int)(m_iPosUnshift>>m_iRangeShift);

	if(iPosNew==m_iPos)return;

	m_iPos		  = iPosNew;

	if(!IsWindow(m_hWnd))return;

	PostMessage(WM_COMMAND,ID_UPDATEDLG,2);

}

//*****************************************************************************
//*
//*		SetPos
//*
//*****************************************************************************
//	Die ProgressBar Position um 1 erhhen
void CProgressDlg::SetPos()
{
int		iPosNew;


	m_iPosUnshift  += 1;
	iPosNew			= (int)(m_iPosUnshift>>m_iRangeShift);

	if(iPosNew==m_iPos)return;

	m_iPos			= iPosNew;

	if(!IsWindow(m_hWnd))return;

	PostMessage(WM_COMMAND,ID_UPDATEDLG,2);


}

//*****************************************************************************
//*
//*		StepIt
//*
//*****************************************************************************
//	Die ProgressBar um einen Schritt weiter verschieben
void CProgressDlg::StepIt()
{
	if(!IsWindow(m_hWnd))return;
	PostMessage(WM_COMMAND,ID_UPDATEDLG,3);
}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
//	Ruft CANCEL auf fr den Dialog
void CProgressDlg::Stop()
{
	m_iExit = 1;
	if(!IsWindow(m_hWnd))return;
	PostMessage(WM_COMMAND,IDCANCEL);
}

//*****************************************************************************
//*
//*		OnCommand
//*
//*****************************************************************************
BOOL CProgressDlg::OnCommand(WPARAM wParam,LPARAM lParam)
{
int			iOffset;
int			iRange;
unsigned	uLine;
unsigned	uBits;


	if(wParam==ID_UPDATEDLG)
		{
		if(m_bIsClosed)return TRUE;

		switch((BYTE)lParam)							// SetText
			{
		case 1:	uLine = (lParam>>8)%CPD_MAX_LINE;
				m_aLastSet[uLine] = GetTickCount();
				SetDlgItemText(IDC_TEXT+uLine,m_cTextBuffer+uLine*CPD_MAX_SIZE);
				break;

		case 2: if(m_iProgressMode)						// SetPos
					{
					if(m_iPreXpVersion)
						{
						if(m_iStepPos==m_iPos)return TRUE;
						m_iStepPos = m_iPos;
						m_pProgress->RedrawWindow();
						}

					return TRUE;
					}

				if(!m_pTaskbar && m_iTaskBarOn<=1)
					{
					TaskbarInit();
					}

				if(m_pTaskbar)
					{
					iRange	= (int)(m_iRange>>m_iRangeShift);
					iOffset	= m_iPos;

					if(iOffset>iRange)iOffset=iRange;

					if(m_iTaskbarSub>1)					// Vervielfacher fr Taskbar
						{
						if(m_iTaskbarLock && iOffset>iRange/32 && iOffset*8<iRange*7)
							{
							m_iTaskbarLock = 0;
							}

						if(m_iTaskbarLock==0)
							{
							if(iRange<=0)iRange=1;
							iOffset	*= 1024;
							iOffset /= iRange;
							iOffset += 1024*m_iTaskbarPos;
							iRange	 = 1024*m_iTaskbarSub;

							if(iOffset<m_iTaskbarLast)	// Sperren bei Rcksprung
								{
								if((iOffset&0x03FF)<=64)
									{
									m_iTaskbarLock = 1;
									}

								m_pProgress->SetPos(m_iPos);
								break;
								}
							else{
								m_iTaskbarLast = iOffset;
								}
							}
						}

					if(m_iTaskbarLock==0 || m_iTaskbarSub<=1)
						{
						TBL(m_pTaskbar)->pVtbl->SetProgressValue(m_pTaskbar,m_hMainWnd,iOffset,iRange);
						m_iTaskbarLast = iOffset;
						}
					}

				m_pProgress->SetPos(m_iPos);
				break;

		case 3: if(m_iProgressMode)						// Steper Modus
					{
					if(m_iPreXpVersion)
						{
						m_iStepPos++;
						m_pProgress->RedrawWindow();
						}


					}
				m_pProgress->StepIt();
				return TRUE;

		case 4: if(m_iProgressMode)return TRUE;			// Set Range
				m_pProgress->SetRange(0,(short)(m_iRange>>m_iRangeShift));
				m_pProgress->SetPos  (  (int  )(m_iPos  >>m_iRangeShift));
				break;

		case 5:	uLine = (lParam>>8)%CPD_MAX_LINE;		// Text verzgert bertragen
				m_aTextFlag[uLine] = 1;
				SetTimer(ID_UPDATETEXT,50,NULL);
				break;

		case 6:	if(m_iQueryMode)						// Prozetur die den Verlauf aktualisieren
						SetTimer (ID_QUERYPROC,m_iQueryTime,NULL);
				else	KillTimer(ID_QUERYPROC);
				break;

		case 7:	if(m_iProcTime)							// Prozetur die alle N Millisekunden
						SetTimer (ID_TIMEPROC,m_iProcTime,NULL);
				else	KillTimer(ID_TIMEPROC);
				break;

		case 8:	UpdateLines((int)lParam>>8);			// Einstellen der darstellbaren Textzeilen
				break;

		case 9:	uBits = (unsigned)lParam;				// SetProgressModeEx
				ProgresMode((uBits>>8)&0x0FFF,(uBits>>20)&0x0FFF);
				break;
			}

		return TRUE;
		}

	if(wParam==ID_MESSAGEDLG)
		{
		m_uMboxRet=CDialog::MessageBox(m_pMboxText,m_pMboxTitle,m_uMboxType);
		m_sMboxSem.Unlock();
		return TRUE;
		}

	if(wParam==ID_DIALOG)
		{
		m_uMboxRet=(UINT)m_pDialog->DoModal();
		m_sMboxSem.Unlock();
		return TRUE;
		}

	if(wParam==ID_ENDDLG)
		{
		GET_DLG_OLDPOS();
		m_bIsClosed = TRUE;
		if(m_pTaskbar)TaskbarExit();
		EndDialog((m_iExit)? IDCANCEL:IDOK);
		return TRUE;
		}


return CDialog::OnCommand(wParam, lParam);
}


//*****************************************************************************
//*
//*		ThreadProc
//*
//*****************************************************************************
UINT CProgressDlg::ThreadProc(void *pParam)
{
CProgressDlg	*pDlg;


	   pDlg=(CProgressDlg*)pParam;
	   pDlg->m_iProcExit = -1;
	   pDlg->m_iRun		 =  1;
	if(pDlg->m_pThreadProc)
	   pDlg->m_iProcExit = pDlg->m_pThreadProc(pDlg);
	   pDlg->m_iRun		 =  0;
	   pDlg->m_pThread	 =  0;

	if(IsWindow(pDlg->m_hWnd))
		{
		pDlg->PostMessage(WM_COMMAND,ID_ENDDLG);
		}



return 0;
}


//*****************************************************************************
//*
//*		SetProc
//*
//*****************************************************************************
//	Einstellen der Thread-Funktion. Wenn diese Funktion beendet wird
//	schliet sich der Dialog
//	pProc		: Zeiger auf Funktion
//	pParam1-4	: bergabe Parameter fr Dialog
void CProgressDlg::SetProc(int (_cdecl *pProc)(CProgressDlg*),const void *pParam1,const void *pParam2,const void *pParam3,const void *pParam4,const void *pParam5)
{

	m_pProcParam5 = (void*)pParam5;
	m_pProcParam4 = (void*)pParam4;
	m_pProcParam3 = (void*)pParam3;
	m_pProcParam2 = (void*)pParam2;
	m_pProcParam1 = (void*)pParam1;

	m_pThreadProc = pProc;
}

//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Einstellen der Dialogfenster Titels
void CProgressDlg::SetTitle(LPCTSTR pTitle)
{
	if(!pTitle)pTitle=_T("");
	m_sTitle = pTitle;
}

//*****************************************************************************
//*
//*		MessageBox
//*
//*****************************************************************************
//	Eine MessageBox anzeigen
int CProgressDlg::MessageBox(LPCTSTR pText,LPCTSTR pTitel,UINT uType)
{

	if(m_pTaskbar)
		{
		TBL(m_pTaskbar)->pVtbl->SetProgressState(m_pTaskbar,m_hMainWnd,((uType&0xF0)==MB_ICONERROR)? TBL_ERROR:TBL_PAUSED);
		}

	m_pMboxText  = pText;
	m_pMboxTitle = pTitel;
	m_uMboxType  = uType;

	PostMessage(WM_COMMAND,ID_MESSAGEDLG);
	m_sMboxSem.Lock();

	if(m_pTaskbar)
		{
		TBL(m_pTaskbar)->pVtbl->SetProgressState(m_pTaskbar,m_hMainWnd,TBL_NORMAL);
		}


return m_uMboxRet;
}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
//	Aufruf der periodischen Zeitfunktion
void CProgressDlg::OnTimer(UINT_PTR uEvent)
{
__int64		iCount;
__int64		iPos;
int			iNum;



	if(uEvent==ID_QUERYPROC)
		{
		iPos    = 0;
		iCount	= 0;

		switch(m_iQueryMode)								// Art der Query-Funktion
			{
		case 1:	if(!m_pQueryProc)return;
				iPos   = (int)m_pQueryProc(&iCount);
				break;

		case 2:	if(!m_pQueryProc)return;
				iPos   = m_pQueryProc(&iCount);
				break;

		case 3:	if(m_pQueryPos)iPos   = *(int*)m_pQueryPos;
				if(m_pQueryMax)iCount = *(int*)m_pQueryMax;
				break;

		case 4:	if(m_pQueryPos)iPos   = *(__int64*)m_pQueryPos;
				if(m_pQueryMax)iCount = *(__int64*)m_pQueryMax;
				break;

		default:return;
			}

		if(iCount)SetRange(iCount);
		SetPos(iPos);

		return;
		}

	if(uEvent==ID_TIMEPROC)
		{
		if(m_pTimeProc)m_pTimeProc(m_pParamTime);
		return;
		}

	if(uEvent==ID_STEPPROC)
		{
		if(m_iPreXpVersion)
			{
			m_iStepPos++;
			m_pProgress->RedrawWindow();
			}
		return;
		}

	if(uEvent==ID_DELAYSHOW)
		{
		KillTimer(ID_DELAYSHOW);
		SetCursor(IDC_ARROW);
		EnableWindow(TRUE);
		SET_DLG_OLDPOS();
		PostMessage(WM_COMMAND,ID_UPDATEDLG,1);
		return;
		}

	if(uEvent==ID_UPDATETEXT)
		{
		for(iNum=0;iNum<CPD_MAX_LINE;iNum++)
			{
			if(!m_aTextFlag[iNum])continue;
			m_aTextFlag[iNum] = 0;
			PostMessage(WM_COMMAND,ID_UPDATEDLG,1+iNum*256);
			}

		return;
		}

	CDialog::OnTimer(uEvent);
}


//*****************************************************************************
//*
//*		SetTime
//*
//*****************************************************************************
//	Setzt eine Prozetur die alle Time Millisekunden aufgerufen wird
//	Ist Time==0 dann erfolgt keine Aufruf
void CProgressDlg::SetTime(ProgresProcVV pProc,unsigned uTime,void *pParam)
{

	m_iProcTime  = uTime;
	m_pTimeProc  = pProc;
	m_pParamTime = pParam;

	if(!IsWindow(m_hWnd))return;
	PostMessage(WM_COMMAND,ID_UPDATEDLG,7);

}

//*****************************************************************************
//*
//*		SetBreak
//*
//*****************************************************************************
//	Setzt eine Prozetur die aufgerufen wirdn wenn CANCEL gedrckt wird
void CProgressDlg::SetBreak(ProgresProcVV pProc,void *pParam)
{
	m_pParamBreak = pParam;
	m_pBreakProc  = pProc;
}

//*****************************************************************************
//*
//*		SetQuery
//*
//*****************************************************************************
//	Setzt eine Prozetur bzw. Pointer die den Verlauf aktualisieren
//	iMode		; 0=aus 1=INT Callback 2=INT64 Callback 3=INT Zeiger 4=INT64 Zeiger
//	uTime		: Ist die Update-Zeit in Millisekunden.
//	pPtr1/2		: Zeiger auf Funktionen und INT-Zeiger
//	Ist Time==0 dann erfolgt keine Aufruf
void CProgressDlg::SetQuery(int iMode,unsigned uTime,void *pPtr1,void *pPtr2)
{

	m_iQueryMode = iMode;
	m_iQueryTime = uTime;
	m_pQueryPos  = pPtr1;
	m_pQueryMax  = pPtr2;
	m_pQueryProc = (ProgresProcPX)pPtr1;

	if(!IsWindow(m_hWnd))return;
	PostMessage(WM_COMMAND,ID_UPDATEDLG,6);
}

//*****************************************************************************
//*
//*		SetPriority
//*
//*****************************************************************************
//	Stellt die Prioritt der Prozedur ein
//		 0 = normal
//		>0 = hher
//		<0 = niedriger
void CProgressDlg::SetPriority(int iPriority)
{
	m_iPriority=iPriority;
}


//*****************************************************************************
//*
//*		WndProc
//*
//*****************************************************************************
//	Fensterprozetur fr ProgessBar fr den Step-Modus
LRESULT __stdcall CProgressDlg::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
CProgressDlg   *pDlg;
PAINTSTRUCT		sPs;
WNDPROC			pPrevFunc;
RECT			sRect;
HDC				hDc;
int				iSize;
int				iPos;
int 			iOff;
int				iNum;
int				iEnd;

	#define 	PB_FRAME	1
	#define 	PB_DIFF		2
	#define 	PB_SIZE		8
	#define 	PB_NUM		5

	pDlg       = (CProgressDlg*)GetWindowLongPtr(hWnd,GWL_USERDATA);
	pPrevFunc  = pDlg->m_pWndProc;

	switch(uMsg)
		{
	case WM_PAINT:

		::GetUpdateRect(hWnd,&sRect,0);

		hDc  = ::BeginPaint(hWnd,&sPs);
		iPos = pDlg->m_iStepPos;


		::GetClientRect(hWnd,&sRect);
		sRect.bottom++;
		sRect.right++;

		iSize = sRect.bottom-sRect.top;
		iOff  = sRect.left;

		SelectObject(hDc,GetStockObject(NULL_PEN));
		SelectObject(hDc,GetSysColorBrush(COLOR_3DFACE));

		sRect.bottom  = sRect.top+PB_FRAME+1;
		Rectangle(hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);
		sRect.bottom  = sRect.top+iSize;
		sRect.top     = sRect.bottom-PB_FRAME-1;
		Rectangle(hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);
		sRect.top     = sRect.bottom-iSize;
		sRect.bottom -= PB_FRAME;
		sRect.top    += PB_FRAME;

		iSize  = sRect.right-sRect.left;
		iNum   = (iSize+PB_SIZE+PB_FRAME-1)/(PB_SIZE+PB_DIFF);
		iPos  %= iNum+PB_NUM-1;
		if(iPos<0)iPos+=iNum+PB_NUM;
		iPos  -= PB_NUM-1;
		iEnd   = iPos+PB_NUM;

		if(iPos>0)
			{
			sRect.right = sRect.left+PB_FRAME+1;
			sRect.right+= iPos*(PB_SIZE+PB_DIFF);
			}
		else{
			sRect.right = sRect.left+PB_FRAME+1;
			iPos=0;
			}

		Rectangle(hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);


		for(;iPos<iEnd;iPos++)
			{
			sRect.left  = sRect.right-1;
			sRect.right	= sRect.left+PB_SIZE+1;

			SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT));
			Rectangle   (hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);

			sRect.left  = sRect.right-1;
			sRect.right	= sRect.left+PB_DIFF+1;

			SelectObject(hDc,GetSysColorBrush(COLOR_3DFACE));
			Rectangle   (hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);
			}

		sRect.left  = sRect.right-1;
		sRect.right	= iOff+iSize+10;

		Rectangle(hDc,sRect.left,sRect.top,sRect.right,sRect.bottom);
		::EndPaint(hWnd,&sPs);

		return 0;
		}



return CallWindowProc(pPrevFunc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		Dialog
//*
//*****************************************************************************
//	ffnet einen modalen Dialog
int	CProgressDlg::Dialog(CDialog *pDlg)
{

	if(m_pTaskbar)
		{
		TBL(m_pTaskbar)->pVtbl->SetProgressState(m_pTaskbar,m_hMainWnd,TBL_PAUSED);
		}

	m_pDialog = pDlg;
	PostMessage(WM_COMMAND,ID_DIALOG);
	m_sMboxSem.Lock();

	if(m_pTaskbar)
		{
		TBL(m_pTaskbar)->pVtbl->SetProgressState(m_pTaskbar,m_hMainWnd,TBL_NOPROGRESS);
		}


return m_uMboxRet;
}

//*****************************************************************************
//*
//*		UpdateLines
//*
//*****************************************************************************
//	Erzeugt im Fenster die zustzlichen Zeilen
void CProgressDlg::UpdateLines(UINT uLines)
{
CWnd	   *pWnd;
CRect		sRect;
UINT		uAdd;
HWND		hWnd;


	if(uLines>CPD_MAX_LINE)uLines=CPD_MAX_LINE;
	if(m_uLinesNow>=uLines)return;

	uAdd = (uLines-m_uLinesNow)*m_iTextHeight;

	GetWindowRect(&sRect);
	SetWindowPos(NULL,0,0,sRect.Width(),sRect.Height()+uAdd,SWP_NOOWNERZORDER|SWP_NOMOVE|SWP_NOZORDER);

	pWnd =GetDlgItem(IDCANCEL);
	::MoveWindow(pWnd,0,uAdd,TRUE);

	pWnd =GetDlgItem(IDC_PROGRESS1);
	::MoveWindow(pWnd,0,uAdd,TRUE);


	while(m_uLinesNow<uLines)
		{
		hWnd = CreateWindow(_T("STATIC"),m_cTextBuffer+CPD_MAX_SIZE*m_uLinesNow,
							WS_CHILD|WS_VISIBLE|SS_LEFT|SS_NOPREFIX,
							0,2048,m_iTextWidth,m_iTextHeight,m_hWnd,
							(HMENU)(IDC_TEXT+m_uLinesNow),NULL,NULL);

		::SendMessage(hWnd,WM_SETFONT,(WPARAM)m_hTextFont,0);
		::MoveWindow(this,IDC_TEXT+m_uLinesNow,IDC_TEXT);
		::MoveWindow(CWnd::FromHandle(hWnd),0,m_iTextHeight*m_uLinesNow,TRUE);

		m_uLinesNow++;
		}

}

//*****************************************************************************
//*
//*		SetLines
//*
//*****************************************************************************
//	Einstellen der darstellbaren Textzeilen im Dialog.
//	uLines		: Ist die neue Zeilenanzahl.
void CProgressDlg::SetLines(unsigned uLines)
{

	if(uLines>CPD_MAX_LINE)uLines=CPD_MAX_LINE;
	if(uLines==m_uLinesNow)return;

	if(!IsWindow(m_hWnd))
		{
		m_uLineCount = uLines;
		return;
		}

	PostMessage(WM_COMMAND,ID_UPDATEDLG,8+uLines*256);

}

//*****************************************************************************
//*
//*		TaskbarInit
//*
//*****************************************************************************
//	Versucht auch die Progess-Bar der Task-Leiste zu benutzen
void CProgressDlg::TaskbarInit()
{
HWND		hNext;
HRESULT		uRet;


	if(m_iProgressMode)return;
	if(m_iTaskBarOn>=2)return;
	if(m_pTaskbar     )return;


	uRet = CoInitialize(NULL);

	if(!SUCCEEDED(uRet))
		{
		CoUninitialize();
		return;
		}

	uRet = CoCreateInstance(CLSID_TaskbarList,NULL,CLSCTX_INPROC_SERVER,IID_ITaskbarList3_,&m_pTaskbar);

	if(SUCCEEDED(uRet))
		{
		m_iTaskBarOn = 1;
		m_hMainWnd   = m_hWnd;

		for(;;)
			{
				hNext = ::GetParent(m_hMainWnd);
			if(!hNext)break;

			m_hMainWnd = hNext;
			}

		TBL(m_pTaskbar)->pVtbl->SetProgressState(m_pTaskbar,m_hMainWnd,TBL_NORMAL);
		}
	else{
		m_iTaskBarOn = 2;
		CoUninitialize();
		}

}

//*****************************************************************************
//*
//*		TaskbarExit
//*
//*****************************************************************************
//	Die Progess-Bar der Task-Leiste schlieen
void CProgressDlg::TaskbarExit()
{

	if(m_pTaskbar)
		{
		TBL(m_pTaskbar)->pVtbl->SetProgressState(m_pTaskbar,m_hMainWnd,TBL_NOPROGRESS);
		TBL(m_pTaskbar)->pVtbl->Release(m_pTaskbar);
		CoUninitialize();
		m_pTaskbar = 0;
		}

}

//*****************************************************************************
//*
//*		SetProgressModeEx
//*
//*****************************************************************************
//	Wird der Progress-Modus zur Laufzeit gendert
//	iMode		: Stellt den Modus der ProgressBar ein:
//						0  = Normale Zeile von 0 bis n
//					    1  = Step-Bar die nur Schritte anzeigt.
//					  >10  = Step-Bar die nur Schritte anzeigt mit automatischen
//							 Verschieben alle N Millisekunden.
void CProgressDlg::SetProgressModeEx(int iMode)
{
	if(iMode==m_iProgressMode)return;
	PostMessage(WM_COMMAND,ID_UPDATEDLG,9|((iMode&0x0FFF)<<8)|((m_iProgressMode&0x0FFF)<<20));
}
