//*****************************************************************************
//*
//*
//*		ProgressDlg.h
//*
//*
//*****************************************************************************
#ifndef		__AFX_PROGRESS_H__
#define		__AFX_PROGRESS_H__

#include	<afx.h>
#include	<afxcmn.h>
#include	"AfxMacros.h"
#include	"SemaphoreEx.h"

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#define 	CPD_MAX_SIZE	512
#define 	CPD_MAX_LINE	4

#ifdef	_MSC_VER
#pragma warning( disable :4996 )
#endif

class CProgressDlg;

typedef void    (_cdecl *ProgresProcVD )(CProgressDlg *);
typedef void    (_cdecl *ProgresProcVV)(void *);
typedef void    (_cdecl *ProgresProcVN)();
typedef int     (_cdecl *ProgresProcI )(CProgressDlg *);
typedef int     (_cdecl *ProgresProcIN)();
typedef int     (_cdecl *ProgresProcP )(int*);
typedef __int64 (_cdecl *ProgresProcPX)(__int64*);

				   
//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class CProgressDlg : public CDialog
{
public:

	 CProgressDlg(CWnd *pParent = NULL);				// Standardkonstruktor
	~CProgressDlg();

	void SetTitle(LPCTSTR pTitle=0);					// Den Titel des Dialoges einstellen
	void SetProc (ProgresProcIN pProc);
	void SetProc (ProgresProcI  pProc,const void *pParam1  ,const void *pParam2  ,const void  *pParam3  ,const void  *pParam4  ,const void  *pParam5  );
	void SetProc (ProgresProcI  pProc,const void *pParam1  ,const void *pParam2  ,const void  *pParam3  ,const void  *pParam4  ,int		  iParam5=0);
	void SetProc (ProgresProcI  pProc,const void *pParam1  ,const void *pParam2  ,const void  *pParam3  ,int          iParam4=0,int          iParam5=0);
	void SetProc (ProgresProcI  pProc,const void *pParam1  ,const void *pParam2  ,int          iParam3=0,int          iParam4=0,int          iParam5=0);
	void SetProc (ProgresProcI  pProc,const void *pParam1  ,int         iParam2=0,int          iParam3=0,int          iParam4=0,int          iParam5=0);
	void SetProc (ProgresProcI  pProc,int         iParam1=0,int         iParam2=0,int          iParam3=0,int          iParam4=0,int          iParam5=0);
	void SetQuery(ProgresProcP  pProc                ,unsigned uTime=300);
	void SetQuery(ProgresProcPX	pProc                ,unsigned uTime=300);
	void SetQuery(__int64      *pPos,__int64  *pMax=0,unsigned uTime=300);
	void SetQuery(  int        *pPos,  int    *pMax=0,unsigned uTime=300);
	void SetQuery(unsigned     *pPos,unsigned *pMax=0,unsigned uTime=300);
	void SetTime (ProgresProcVD pProc,unsigned uTime=300);
	void SetTime (ProgresProcVN pProc,unsigned uTime=300);
	void SetTime (ProgresProcVV pProc,unsigned uTime,void *pParam);
	void SetBreak(ProgresProcVV pProc,               void *pParam);
	void SetBreak(ProgresProcVD pProc);
	void SetBreak(ProgresProcVN pProc);
	void SetBreak();
	void SetQuery();
	void SetTime ();

	void SetDelay(UINT      uDelay);					// Den Dialog verzgert einblenden
	void SetPriority(int    iPriority);					// Thread Prioritt einstellen
	void SetTaskbar(int iPos,int iRange=0);				// Multiplikator fr Taskbar setzen
	void Stop    ();									// CANCEL aufrufen
	void SetIcon (int       iIcon);						// Ein anderes Icon einstellen
	void SetIcon (HICON     hIcon);						// Ein anderes Icon einstellen
	void GetRange(unsigned &uLower,unsigned &uRange);	// Den Progress-Bereich einstellen (min-max)
	void GetRange(unsigned &uRange);					// Den Progress-Bereich einstellen ( 0 -max)
	void GetRange(  int    &iLower,  int    &iRange);	// Den Progress-Bereich einstellen (min-max)
	void GetRange(  int    &iRange);					// Den Progress-Bereich einstellen ( 0 -max)
	void GetRange(__int64  &iLower,__int64  &iRange);	// Den Progress-Bereich einstellen (min-max)
	void GetRange(__int64  &iRange);					// Den Progress-Bereich einstellen ( 0 -max)
	void SetRange(__int64   iLower,__int64   iRange);	// Den Progress-Bereich einstellen (min-max)
	void SetRange(__int64   iRange);					// Den Progress-Bereich einstellen ( 0 -max)
	void GetPos  (unsigned &uPos);						// Die aktuelle Progress-Position abfragen
	void GetPos  (  int    &iPos);						// Die aktuelle Progress-Position abfragen
	void GetPos  (__int64  &iPos);						// Die aktuelle Progress-Position abfragen
	void SetPos  (__int64   iPos);						// Die aktuelle Progress-Position einstellen
	void SetPos  ();									// Die aktuelle Progress-Position um 1 erhhen
 __int64 GetPos  ();									// Die aktuelle Progress-Position abfragen
	void StepIt  ();									// Die aktuelle Progress-Position weiterschieben
	void SetProgressMode(int iMode);					// Einstellen des Anzeigemodus der Progressbar
	void SetLines(unsigned   uLines);					// Einstellen der Textzeilen
	void SetText (            LPCTSTR pText);			// Den Text ber der ProgressBar einstellen
	void SetText (UINT	uLine,LPCTSTR pText);			// Den Text ber der ProgressBar einstellen
	void SetText (            LPCTSTR pText,LPCTSTR pPath,int iBase=2,int iPos='@');
	void SetText (UINT	uLine,LPCTSTR pText,LPCTSTR pPath,int iBase=2,int iPos='@');
	int  MessageBox(LPCTSTR  pText,LPCTSTR pTitel=NULL,UINT uType=MB_OK);
	int	 Dialog    (CDialog *pDlg);
	int *GetWidth();


	//{{AFX_DATA(CProgressDlg)
	//}}AFX_DATA

public:

	void  *GetVoid1(){return         m_pProcParam1;}		// Parameter abfragen
	void  *GetVoid2(){return         m_pProcParam2;}		//		*
	void  *GetVoid3(){return         m_pProcParam3;}		//		*
	void  *GetVoid4(){return         m_pProcParam4;}		//		*
	void  *GetVoid5(){return         m_pProcParam5;}		//		*
	TCHAR *GetChar1(){return (TCHAR*)m_pProcParam1;}		//		*
	TCHAR *GetChar2(){return (TCHAR*)m_pProcParam2;}		//		*
	TCHAR *GetChar3(){return (TCHAR*)m_pProcParam3;}		//		*
	TCHAR *GetChar4(){return (TCHAR*)m_pProcParam4;}		//		*
	TCHAR *GetChar5(){return (TCHAR*)m_pProcParam5;}		//		*
	int	   GetInt1 (){return (int   )m_pProcParam1;}		//		*
	int	   GetInt2 (){return (int   )m_pProcParam2;}		//		*
	int	   GetInt3 (){return (int   )m_pProcParam3;}		//		*
	int	   GetInt4 (){return (int   )m_pProcParam4;}		//		*
	int	   GetInt5 (){return (int   )m_pProcParam5;}		//		*
	int    IsStoped(){return m_iExit;}						// Abfragen ob es einen Abbruch gab
	int	   GetExitCode(){return m_iProcExit;}				// Rckgabewert der Funktion abfragen
	void   HideCancel(int iMode=TRUE);


protected:

	//{{AFX_VIRTUAL(CProgressDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);    // DDX/DDV-Untersttzung
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	public:
	virtual INT_PTR	DoModal();
	//}}AFX_VIRTUAL


protected:

	void					 TaskbarInit();
	void					 TaskbarExit();
	void					 ProgresMode(int iMode,int iOldMode=-1);
	void					 UpdateLines(UINT uLines);
	void					 SetProgressModeEx(int iMode);
	void					 SetQuery(int iMode,unsigned uTime,void *pPtr1,void *pPtr2);
	static LRESULT __stdcall WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static UINT    _cdecl    ThreadProc(void *pParam);

	static WORD      m_aDlgData[];
	static BYTE		 m_aFontSize[256];					// Buchstabennreiten fr den Dialog
	static BOOL		 m_bFontDone;						// Wurden doe Buchstabennreiten geholt
	static int		 m_iTaskBarOn;						// Taskbar-Modus (0=unbekannt 1=geht 2=geht nicht)
	static int		 m_iInitWidth;						// Initialierungsbreite des Textfensters
	TCHAR			 m_cTextBuffer[CPD_MAX_LINE*CPD_MAX_SIZE+32];
	BOOL			 m_aTextFlag  [CPD_MAX_LINE];
	UINT			 m_aLastSet   [CPD_MAX_LINE];
	WNDPROC			 m_pWndProc;
	CSemaphoreEx	 m_sMboxSem;
	CProgressCtrl	*m_pProgress;
	CWinThread      *m_pThread;
	CDialog			*m_pDialog;
	CWnd			*m_pTextWnd;
	CRect			 m_sTextRect;
	CString			 m_sTitle;
	int				 m_iRun;
	int				 m_iIcon;
	HICON			 m_hIcon;
	HFONT			 m_hTextFont;
	LPCTSTR			 m_pMboxText;
	LPCTSTR			 m_pMboxTitle;
	UINT			 m_uMboxType;
	UINT			 m_uMboxRet;
	BOOL			 m_bIsClosed;
	BOOL			 m_bTextTimer;
	LPVOID			 m_pQueryPos;
	LPVOID			 m_pQueryMax;
	UINT   			 m_uDelayShow;
	UINT   			 m_uLineCount;
	UINT   			 m_uLinesNow;
	int	   			 m_iPriority;
	int				 m_iNoCancel;
	int    			 m_iExit;
	int	   			 m_iPos;
  __int64  			 m_iPosUnshift;
  __int64  			 m_iRange;
	int	   			 m_iCancel;
	int	   			 m_iTextWidth;
	int				 m_iTextHeight;
	int	   			 m_iProcTime;
	int	   			 m_iQueryTime;
	int	   			 m_iQueryMode;						// 1=int 2=int64 3=ptr_int 4=ptr_int64
	int	   			 m_iProgressMode;
	int				 m_iPreXpVersion;
	int    			 m_iStepPos;
  __int64  			 m_iRangeSub;
  __int64  			 m_iRangeEnd;
	int	   			 m_iRangeShift;
	int    			 m_iProcExit;
	void  			*m_pProcParam1;
	void  			*m_pProcParam2;
	void  			*m_pProcParam3;
	void  			*m_pProcParam4;
	void  			*m_pProcParam5;
	void  			*m_pParamBreak;
	void  			*m_pParamTime;
	void  			*m_pTaskbar;
	int				 m_iTaskbarSub;
	int				 m_iTaskbarPos;
	int				 m_iTaskbarLock;
	int				 m_iTaskbarLast;
	HWND			 m_hMainWnd;

  __int64   (_cdecl *m_pQueryProc )(__int64*);
	int     (_cdecl *m_pThreadProc)(CProgressDlg*);
	void    (_cdecl *m_pTimeProc  )(void*);
	void    (_cdecl *m_pBreakProc )(void*);



	//{{AFX_MSG(CProgressDlg)
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT_PTR);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_DLG_OLDPOS()
};



//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline void	   CProgressDlg::SetProc(ProgresProcIN pProc                                                                                            ){SetProc((ProgresProcIN)pProc);}
inline void    CProgressDlg::SetProc(ProgresProcI  pProc,const void *pParam1,const void *pParam2,const void *pParam3,const void *pParam4,int iParam5){SetProc(pProc,(void*)pParam1,(void*)pParam2,(void*)pParam3,(void*)pParam4,(void*)iParam5);}
inline void    CProgressDlg::SetProc(ProgresProcI  pProc,const void *pParam1,const void *pParam2,const void *pParam3,int         iParam4,int iParam5){SetProc(pProc,(void*)pParam1,(void*)pParam2,(void*)pParam3,(void*)iParam4,(void*)iParam5);}
inline void    CProgressDlg::SetProc(ProgresProcI  pProc,const void *pParam1,const void *pParam2,int         iParam3,int         iParam4,int iParam5){SetProc(pProc,(void*)pParam1,(void*)pParam2,(void*)iParam3,(void*)iParam4,(void*)iParam5);}
inline void    CProgressDlg::SetProc(ProgresProcI  pProc,const void *pParam1,int         iParam2,int         iParam3,int         iParam4,int iParam5){SetProc(pProc,(void*)pParam1,(void*)iParam2,(void*)iParam3,(void*)iParam4,(void*)iParam5);}
inline void    CProgressDlg::SetProc(ProgresProcI  pProc,int         iParam1,int         iParam2,int         iParam3,int         iParam4,int iParam5){SetProc(pProc,(void*)iParam1,(void*)iParam2,(void*)iParam3,(void*)iParam4,(void*)iParam5);}
inline void	   CProgressDlg::SetTaskbar(int iPos,int iRange){m_iTaskbarPos=iPos;if(iRange>0)m_iTaskbarSub=iRange;if(m_iTaskbarSub)m_iTaskbarLock=1;}
inline void    CProgressDlg::SetIcon(int           iIcon){m_iIcon=    iIcon&0xFFFF ;}
inline void    CProgressDlg::SetIcon(HICON         hIcon){m_iIcon=0;m_hIcon= hIcon ;}
inline void    CProgressDlg::SetProgressMode(int   iMode){if(m_iRun)SetProgressModeEx(iMode); m_iProgressMode=iMode;}
inline void	   CProgressDlg::SetDelay(UINT      uDelay){m_uDelayShow     = uDelay;}
inline void    CProgressDlg::GetRange(unsigned &uLower,unsigned &uRange){uLower = (int)m_iRangeSub;uRange = (int)m_iRange;}
inline void    CProgressDlg::GetRange(  int    &iLower,  int    &iRange){iLower = (int)m_iRangeSub;iRange = (int)m_iRange;}
inline void    CProgressDlg::GetRange(unsigned &uRange                 ){                 	       uRange = (int)m_iRange;}
inline void    CProgressDlg::GetRange(  int    &iRange                 ){                 	       iRange = (int)m_iRange;}
inline void    CProgressDlg::GetRange(__int64  &iLower,__int64  &iRange){iLower =      m_iRangeSub;iRange =      m_iRange;}
inline void    CProgressDlg::GetRange(__int64  &iRange                 ){                    	   iRange =      m_iRange;}
inline void    CProgressDlg::GetPos  (unsigned &uPos                   ){                   	   uPos   = (int)m_iPosUnshift;}
inline void    CProgressDlg::GetPos  (  int    &iPos                   ){                   	   iPos   = (int)m_iPosUnshift;}
inline void    CProgressDlg::GetPos  (__int64  &iPos                   ){                   	   iPos   =      m_iPosUnshift;}
inline int    *CProgressDlg::GetWidth(){return &m_iTextWidth;}
inline __int64 CProgressDlg::GetPos  (){return  m_iPosUnshift;}
inline void    CProgressDlg::HideCancel(int iMode){m_iNoCancel=iMode;}
inline void    CProgressDlg::SetText (LPCTSTR pText){SetText((UINT)0,pText);}
inline void    CProgressDlg::SetText (LPCTSTR pText,LPCTSTR pPath,int iBase,int iPos){SetText((int)0,pText,pPath,iBase,iPos);}
inline void    CProgressDlg::SetTime (ProgresProcVN pProc,unsigned uTime){SetTime ((ProgresProcVV)pProc,uTime,NULL);}
inline void    CProgressDlg::SetTime (ProgresProcVD pProc,unsigned uTime){SetTime ((ProgresProcVV)pProc,uTime,this);}
inline void    CProgressDlg::SetTime (                                  ){SetTime ((ProgresProcVV)NULL ,0    ,NULL);}
inline void    CProgressDlg::SetBreak(ProgresProcVN pProc               ){SetBreak((ProgresProcVV)pProc      ,NULL);}
inline void    CProgressDlg::SetBreak(ProgresProcVD pProc               ){SetBreak((ProgresProcVV)pProc      ,this);}
inline void    CProgressDlg::SetBreak(                                  ){SetBreak((ProgresProcVV)NULL       ,NULL);}
inline void    CProgressDlg::SetQuery(                                                ){SetQuery(0,0,NULL,NULL);}
inline void    CProgressDlg::SetQuery(ProgresProcP  pProc              ,unsigned uTime){SetQuery(1,uTime,(void*)pProc,NULL);}
inline void    CProgressDlg::SetQuery(ProgresProcPX	pProc              ,unsigned uTime){SetQuery(2,uTime,(void*)pProc,NULL);}
inline void    CProgressDlg::SetQuery(__int64      *pPos,__int64  *pMax,unsigned uTime){SetQuery(3,uTime,(void*)pPos,(void*)pMax);}
inline void    CProgressDlg::SetQuery(  int        *pPos,  int    *pMax,unsigned uTime){SetQuery(4,uTime,(void*)pPos,(void*)pMax);}
inline void    CProgressDlg::SetQuery(unsigned     *pPos,unsigned *pMax,unsigned uTime){SetQuery(5,uTime,(void*)pPos,(void*)pMax);}

//{{AFX_INSERT_LOCATION}}


#endif
