//*****************************************************************************
//*
//*
//*		SizeBar.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
//	
//	Mit dieser Klasse kann man ControlBars erzeugen deren Gre 
//	vernderbar sind, und die neben einander dockbar sind.
//	
//	Mit einem #define auf CBaseControlBarClass kann man die Basisklasse CControlBar ndern
//	Mit einem #define auf CBaseDockFrameClass  kann man die Basisklasse CMiniDockFrameWnd ndern
//	
//
//	SCB_REPLACE_MINIFRAME	Soll die Klasse CMiniDockFrameWnd ausgetaucht 
//							werden damit nicht angedockte Fenster Gren 
//							verndert werden knnen wie normale Fenster
//
//	CBRS_SIZE_DYNAMIC		Muss immer gesetzt sein
//
//
//	Weitere Informationen in SizeBar.h
//
#if		    _MSC_VER > 1299
#ifndef		 WINVER
#define		 WINVER 	0x0501
#endif
#endif

#include	<AfxWin.h>
#include	<AfxExt.h>
#include	"SizeBar.h"
#include	"WinExtension.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CSizeBarBase, CBaseControlBarClass)
	//{{AFX_MSG_MAP(CSizeBarBase)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_NCPAINT()
	ON_WM_NCHITTEST()
	ON_WM_MOUSEMOVE()
	ON_WM_NCCALCSIZE()
	ON_WM_SETTINGCHANGE()
	ON_WM_CAPTURECHANGED()
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_WM_NCLBUTTONDOWN()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SETTEXT, OnSetText)
END_MESSAGE_MAP()


IMPLEMENT_DYNAMIC(CSizeBarBase,CBaseControlBarClass);


BEGIN_MESSAGE_MAP(CSizeBar, CBaseSizeBarClass)
	//{{AFX_MSG_MAP(CSizeBar)
	ON_WM_NCLBUTTONUP()
	ON_WM_NCHITTEST()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SETTEXT, OnSetText)
END_MESSAGE_MAP()


IMPLEMENT_DYNAMIC(CSizeBar, CBaseSizeBarClass);

#ifdef  SCB_REPLACE_MINIFRAME

BEGIN_MESSAGE_MAP(CSizeDockFrameWnd, CBaseDockFrameClass)
	//{{AFX_MSG_MAP(CSizeDockFrameWnd)
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

IMPLEMENT_DYNCREATE(CSizeDockFrameWnd, CBaseDockFrameClass);

#endif

#define 	CBRS_CLOSEBOTTON	CBRS_HIDE_INPLACE

#ifndef		_WIN64
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr	SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr	GetWindowLong
#endif
#ifndef		SetClassLongPtr
#define		SetClassLongPtr		SetClassLong
#endif
#ifndef		GetClassLongPtr
#define		GetClassLongPtr		GetClassLong
#endif
#else
#ifdef		GCLP_HBRBACKGROUND
#undef		GCLP_HBRBACKGROUND
#endif	
#define		GCLP_HBRBACKGROUND	GCLP_HBRBACKGROUND
#endif


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CSizeBarBase::CSizeBarBase()
{

	m_szNow				= CSize(0,  0);
	m_szHorz			= CSize(200,200);
	m_szVert			= CSize(200,200);
	m_szFloat			= CSize(200,200);
	m_szMinHorz 		= CSize(33, 32);
	m_szMinVert 		= CSize(33, 32);
	m_szMinFloat		= CSize(37, 32);
	m_bThisTracking		= FALSE;
	m_bDoTracking		= FALSE;
	m_bTracking 		= FALSE;
	m_bKeepSize 		= FALSE;
	m_bParentSizing 	= FALSE;
	m_bDragShowContent	= FALSE;
	m_bShowLast			= FALSE;
	m_bShowFlag			= FALSE;
	m_nDockBarID		= 0;
	m_dwStyleLock		= 0;
	m_dwBarStyle		= 0;
	m_iGripper			= 0;
	m_cxEdge			= 8;

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CSizeBarBase::~CSizeBarBase()
{
}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//  old creation method, still here for compatibility reasons
BOOL CSizeBarBase::Create(LPCTSTR pWindowName, CWnd* pParentWnd,CSize sizeDefault,UINT nID, DWORD dwStyle)
{

	m_szHorz  = sizeDefault;
	m_szVert  = sizeDefault;
	m_szFloat = sizeDefault;

return Create(pWindowName, pParentWnd, nID, dwStyle);
}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//  Erzeugt eine neue Bar
//	pWindowName	: Ist der Name des FDensters in der Floating-Darstellung
//	pParentWnd	: Zeiger auf das eltern Fenster
//	dwStyle		: CBRS_TOP			Oben   andocken
//				  CBRS_BOTTOM		Unten  andocken
//				  CBRS_RIGHT    	Rechts andocken
//				  CBRS_BOTTOM   	Links  andocken
//				  CBRS_FLOATING		Nicht andocken
//				  CBRS_CLOSEBUTTON	Eine Taste zun schliesen einfgen
//				  CBRS_GRIPPER      Eine Lasche zum verschieben einfgen
//	Ergibt TRUE wenn die Bar erzeugt wurde
BOOL CSizeBarBase::Create(LPCTSTR pWindowName,CWnd *pParentWnd,UINT nID,DWORD dwStyle)
{
CString		sClass;


	ASSERT_VALID(pParentWnd);
	ASSERT(!((dwStyle & CBRS_SIZE_FIXED) &&(dwStyle & CBRS_SIZE_DYNAMIC)));

	m_nBarID		=   nID;	
	m_iFixedHorz	=   dwStyle & CBRS_FIXEDHORZ;
	m_iFixedVert	=   dwStyle & CBRS_FIXEDVERT;
	m_iClose		=   dwStyle & CBRS_CLOSEBUTTON;					// add a close button
	m_iGripper 		=   dwStyle &(CBRS_GRIPPER|CBRS_CLOSEBUTTON);	// add a gripper to the bar
	m_dwStyle  		=   dwStyle & CBRS_ALL; 						// save the control bar styles
	sClass     		= ::AfxRegisterWndClass(CS_DBLCLKS,::LoadCursor(NULL, IDC_ARROW),::GetSysColorBrush(COLOR_BTNFACE), 0);
	dwStyle		   |=   WS_CLIPCHILDREN; 							// prevents flashing
	dwStyle		   &= ~((CBRS_ALL|CBRS_FIXEDHORZ|CBRS_FIXEDVERT)^CBRS_HIDE_INPLACE);	// keep only the generic window styles

	if(!m_iGripper)m_iClose=0;

	if(!CWnd::Create(sClass,pWindowName,dwStyle,CRect(0,0,0,0),pParentWnd,nID))
		{
		return FALSE;
		}

return TRUE;
}


#if defined(SCB_REPLACE_MINIFRAME) && !defined(SCB_MINIFRAME_CAPTION)


//*****************************************************************************
//*
//*		EnableDocking
//*
//*****************************************************************************
void CSizeBarBase::EnableDocking(DWORD dwDockStyle)
{
	// must be CBRS_ALIGN_XXX or CBRS_FLOAT_MULTI only
	ASSERT((dwDockStyle & ~(CBRS_ALIGN_ANY|CBRS_FLOAT_MULTI)) == 0);
	// cannot have the CBRS_FLOAT_MULTI style
	ASSERT((dwDockStyle & CBRS_FLOAT_MULTI) == 0);
	// the bar must have CBRS_SIZE_DYNAMIC style
	ASSERT((m_dwStyle & CBRS_SIZE_DYNAMIC) != 0);

	m_dwDockStyle = dwDockStyle;

	if(m_pDockContext == NULL)
		{
		m_pDockContext = new CSCBDockContext(this);
		}

	if(m_hWndOwner == NULL)									// permanently wire the bar's owner to its current parent
		{
		m_hWndOwner = ::GetParent(m_hWnd);
		}
}
#endif

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
//  CSizeBarBase message handlers
int CSizeBarBase::OnCreate(LPCREATESTRUCT lpCreateStruct)
{

	if(CBaseControlBarClass::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	// query SPI_GETDRAGFULLWINDOWS system parameter
	// OnSettingChange() will update m_bDragShowContent

	m_bDragShowContent = FALSE;
	::SystemParametersInfo(SPI_GETDRAGFULLWINDOWS, 0,&m_bDragShowContent, 0);

	// uncomment this line if you want raised borders
	// m_dwBarStyle |= SCBS_SHOWEDGES;

	m_dwBarStyle &= ~m_dwStyleLock;


return 0;
}


//*****************************************************************************
//*
//*		OnSetText
//*
//*****************************************************************************
LRESULT CSizeBarBase::OnSetText(WPARAM wParam, LPARAM lParam)
{
	UNUSED_ALWAYS(wParam);

	LRESULT lResult = CWnd::Default();

	if(IsFloating() && GetParentFrame()->IsKindOf(RUNTIME_CLASS(CMiniDockFrameWnd)))
		{
		m_pDockBar->SetWindowText((LPCTSTR) lParam);		// update dockbar
		GetParentFrame()->DelayRecalcLayout();				// refresh miniframe
		}

return lResult;
}

//*****************************************************************************
//*
//*		IsSideTracking
//*
//*****************************************************************************
const BOOL CSizeBarBase::IsSideTracking() const
{
	// don't call this when not tracking
	ASSERT(m_bTracking && !IsFloating());

	if(m_uEdge==HTLEFT || m_uEdge == HTRIGHT)
		{
		return IsHorzDocked();
		}


return IsVertDocked();
}

//*****************************************************************************
//*
//*		CalcFixedLayout
//*
//*****************************************************************************
CSize CSizeBarBase::CalcFixedLayout(BOOL bStretch, BOOL bHorz)
{
int						iLengthTotal;
CSizeDockBar		   *pDockBar;
AFX_SIZEPARENTPARAMS	sLayout;
CRect					sRect;
int						i;



	if(bStretch)						// the bar is stretched (is not the child of a dockbar)
		{
		if(bHorz)
				return CSize(32767, m_szHorz.cy);
		else	return CSize(m_szVert.cx, 32767);
		}


										// dirty cast - we need access to protected CDockBar members
	pDockBar = (CSizeDockBar*)m_pDockBar;

	// force imediate RecalcDelayShow() for all sizing bars on the row
	// with delayShow/delayHide flags set to avoid IsVisible() problems

	CSizeArray aSizeBars;

	GetRowSizingBars(aSizeBars);


	if(pDockBar->m_bLayoutQuery)
		{
		sLayout.hDWP = NULL;
		}
	else{
		sLayout.hDWP = ::BeginDeferWindowPos((int)aSizeBars.GetSize());
		}


	for(i=0;i<aSizeBars.GetSize();i++)
		{
		if(aSizeBars[i]->m_nStateFlags & (delayHide|delayShow))
			{
			aSizeBars[i]->RecalcDelayShow(&sLayout);
			}
		}

	if(sLayout.hDWP != NULL)
		{
		::EndDeferWindowPos(sLayout.hDWP);
		}

	// get available length

	   sRect = pDockBar->m_rectLayout;
	if(sRect.IsRectEmpty())
		{
		m_pDockSite->GetClientRect(&sRect);
		}

	if(bHorz)
			iLengthTotal = sRect.Width ()+2;
	else	iLengthTotal = sRect.Height()-2;


	if(IsVisible() && !IsFloating() && m_bParentSizing && aSizeBars[0]==this)
		{
		if(NegotiateSpace(iLengthTotal,bHorz))
			{
			AlignControlBars();
			}
		}

	m_bParentSizing = FALSE;

	if(bHorz)
		{
		return CSize(max(m_szMinHorz.cx,m_szHorz.cx),max(m_szMinHorz.cy,m_szHorz.cy));
		}


return CSize(max(m_szMinVert.cx,m_szVert.cx),max(m_szMinVert.cy,m_szVert.cy));
}

//*****************************************************************************
//*
//*		CalcDynamicLayout
//*
//*****************************************************************************
CSize CSizeBarBase::CalcDynamicLayout(int nLength, DWORD dwMode)
{
CPoint	sCursor;
CRect	sFrame;
CRect	sBar;


	if(dwMode&(LM_HORZDOCK|LM_VERTDOCK))					// docked ?
		{
		if(nLength == -1)
			{
			m_bParentSizing = TRUE;
			}

		return CBaseControlBarClass::CalcDynamicLayout(nLength, dwMode);
		}

	if(dwMode&LM_MRUWIDTH)return m_szFloat;
	if(dwMode&LM_COMMIT  )return m_szFloat;					// already committed

	#ifndef		SCB_REPLACE_MINIFRAME

	int uHitTest;

	uHitTest = m_pDockContext->m_nHitTest;					// check for dialgonal resizing hit test

	if(IsFloating() &&
	  (uHitTest==HTTOPLEFT  || uHitTest==HTBOTTOMLEFT ||
	   uHitTest==HTTOPRIGHT || uHitTest==HTBOTTOMRIGHT))
		{
		::GetCursorPos(&sCursor);

		GetParentFrame()->GetWindowRect(&sFrame);
		GetWindowRect(&sBar);

		if(uHitTest == HTTOPLEFT || uHitTest == HTBOTTOMLEFT)
			{
			m_szFloat.cx = sFrame.left + sBar.Width() - sCursor.x;
			m_pDockContext->m_rectFrameDragHorz.left =
			min(sCursor.x, sFrame.left + sBar.Width() - m_szMinFloat.cx);
			}

		if(uHitTest == HTTOPLEFT || uHitTest == HTTOPRIGHT)
			{
			m_szFloat.cy = sFrame.top + sBar.Height() - sCursor.y;
			m_pDockContext->m_rectFrameDragHorz.top =
			min(sCursor.y, sFrame.top + sBar.Height() - m_szMinFloat.cy);
			}

		if(uHitTest == HTTOPRIGHT || uHitTest == HTBOTTOMRIGHT)
			{
			m_szFloat.cx = sBar.Width() + sCursor.x - sFrame.right;
			}

		if(uHitTest == HTBOTTOMLEFT || uHitTest == HTBOTTOMRIGHT)
			{
			m_szFloat.cy = sBar.Height() + sCursor.y - sFrame.bottom;
			}
		}
	else{
		if(dwMode & LM_LENGTHY)
				m_szFloat.cy = nLength;
		else	m_szFloat.cx = nLength;
		}
	#else

	if(dwMode & LM_LENGTHY)
			m_szFloat.cy = nLength;
	else	m_szFloat.cx = nLength;

	#endif


	m_szFloat.cx = max(m_szFloat.cx, m_szMinFloat.cx);
	m_szFloat.cy = max(m_szFloat.cy, m_szMinFloat.cy);


return m_szFloat;
}

//*****************************************************************************
//*
//*		OnWindowPosChanging
//*
//*****************************************************************************
void CSizeBarBase::OnWindowPosChanging(WINDOWPOS FAR* pWindowPos)
{

	pWindowPos->flags |= SWP_FRAMECHANGED;					// force non-client recalc if moved or resized

	CBaseControlBarClass::OnWindowPosChanging(pWindowPos);


	m_nDockBarID = GetParent()->GetDlgCtrlID();				// find on which side are we docked

	if(!IsFloating())
		{
		if(pWindowPos->flags & SWP_SHOWWINDOW)
			{
			m_bKeepSize = TRUE;
			}
		}

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
//  Mouse Handling
void CSizeBarBase::OnLButtonDown(UINT nFlags, CPoint sPoint)
{

	if(m_pDockBar!=NULL)									// start the drag
		{
		ASSERT(m_pDockContext!=NULL);
		ClientToScreen(&sPoint);
		m_pDockContext->StartDrag(sPoint);
		}
	else{
		CWnd::OnLButtonDown(nFlags,sPoint);
		}
}

//*****************************************************************************
//*
//*		OnLButtonDblClk
//*
//*****************************************************************************
void CSizeBarBase::OnLButtonDblClk(UINT nFlags, CPoint sPoint)
{

	if(m_pDockBar != NULL)									// toggle docking
		{
		ASSERT(m_pDockContext != NULL);
		m_pDockContext->ToggleDocking();
		}
	else{
		CWnd::OnLButtonDblClk(nFlags, sPoint);
		}
}

//*****************************************************************************
//*
//*		OnNcLButtonDown
//*
//*****************************************************************************
void CSizeBarBase::OnNcLButtonDown(UINT uHitTest,CPoint sPoint)
{

	UNUSED_ALWAYS(sPoint);

	if(m_bTracking || IsFloating())return;

	if(m_dwStyleLock)
		{
		if(uHitTest==HTLEFT   && (m_dwStyleLock&SCBS_EDGELEFT  ))return;
		if(uHitTest==HTRIGHT  && (m_dwStyleLock&SCBS_EDGERIGHT ))return;
		if(uHitTest==HTTOP    && (m_dwStyleLock&SCBS_EDGELEFT  ))return;
		if(uHitTest==HTBOTTOM && (m_dwStyleLock&SCBS_EDGEBOTTOM))return;
		}

	if(uHitTest>=HTSIZEFIRST && uHitTest<=HTSIZELAST)
		{
		StartTracking(uHitTest,sPoint); 					// sizing edge hit
		}
}

//*****************************************************************************
//*
//*		OnLButtonUp
//*
//*****************************************************************************
void CSizeBarBase::OnLButtonUp(UINT nFlags, CPoint sPoint)
{
	if(m_bTracking)
		{
		StopTracking();
		}

	CBaseControlBarClass::OnLButtonUp(nFlags, sPoint);
}

//*****************************************************************************
//*
//*		OnRButtonDown
//*
//*****************************************************************************
void CSizeBarBase::OnRButtonDown(UINT nFlags, CPoint sPoint)
{
	if(m_bTracking)
		{
		StopTracking();
		}

	CBaseControlBarClass::OnRButtonDown(nFlags, sPoint);
}

//*****************************************************************************
//*
//*		OnMouseMove
//*
//*****************************************************************************
void CSizeBarBase::OnMouseMove(UINT nFlags, CPoint sPoint)
{
	if(m_bTracking)
		{
		CPoint ptScreen = sPoint;
		ClientToScreen(&ptScreen);

		OnTrackUpdateSize(ptScreen);
		}

	CBaseControlBarClass::OnMouseMove(nFlags, sPoint);
}

//*****************************************************************************
//*
//*		OnCaptureChanged
//*
//*****************************************************************************
void CSizeBarBase::OnCaptureChanged(CWnd *pWnd)
{

	if(m_bTracking && (pWnd != this))
		{
		StopTracking();
		}

	CBaseControlBarClass::OnCaptureChanged(pWnd);

}

//*****************************************************************************
//*
//*		OnNcCalcSize
//*
//*****************************************************************************
void CSizeBarBase::OnNcCalcSize(BOOL bCalcValidRects,NCCALCSIZE_PARAMS FAR* pNcSize)
{
CFrameWnd  *pFrame;
DWORD		dwStyle;
BOOL		bHorz;
int			iThis;


	UNUSED_ALWAYS(bCalcValidRects);

	#ifndef		SCB_REPLACE_MINIFRAME

	if(IsFloating())										// Enable diagonal resizing for floating miniframe
		{
		pFrame = GetParentFrame();

		if(pFrame && pFrame->IsKindOf(RUNTIME_CLASS(CMiniFrameWnd)))
			{
			   dwStyle = ::GetWindowLong(pFrame->m_hWnd,GWL_STYLE);
			if(dwStyle&MFS_4THICKFRAME)
				{
				pFrame->ModifyStyle(MFS_4THICKFRAME, 0);	// clear
				GetParent()->ModifyStyle(0, WS_CLIPCHILDREN);
				}
			}
		}

	#endif


	m_dwBarStyle &= ~SCBS_EDGEALL;							// compute the the client area


	if(!IsFloating() && m_pDockBar)							// add resizing edges between bars on the same row
		{
		CSizeArray aSizeBars;

		GetRowSizingBars(aSizeBars, iThis);

		bHorz = IsHorzDocked();

		/*if(iThis>0)										// REM AZ nur eine Vergrerungsleiste auf einer Seite
			{
			m_dwBarStyle |= (bHorz)? SCBS_EDGELEFT:SCBS_EDGETOP;
			}
		*/

		if(iThis<aSizeBars.GetUpperBound())
			{
			m_dwBarStyle |= (bHorz)? SCBS_EDGERIGHT:SCBS_EDGEBOTTOM;
			}

		m_dwBarStyle &= ~m_dwStyleLock;
		}

	NcCalcClient(&pNcSize->rgrc[0], m_nDockBarID);

}

//*****************************************************************************
//*
//*		NcCalcClient
//*
//*****************************************************************************
void CSizeBarBase::NcCalcClient(LPRECT pRc, UINT nDockBarID)
{
CRect	sRect(pRc);



	sRect.DeflateRect(3,5,3,3);

	if(nDockBarID != AFX_IDW_DOCKBAR_FLOAT)
		{
		//sRect.DeflateRect(2, 0, 2, 2);
		sRect.DeflateRect(0, -2, 0, 0);						// REM AZ Rahmen kleiner machen
		}

	switch(nDockBarID)
		{
	case AFX_IDW_DOCKBAR_TOP:

		m_dwBarStyle |= SCBS_EDGEBOTTOM;
		break;

	case AFX_IDW_DOCKBAR_BOTTOM:

		m_dwBarStyle |= SCBS_EDGETOP;
		break;

	case AFX_IDW_DOCKBAR_LEFT:

		m_dwBarStyle |= SCBS_EDGERIGHT;
		break;

	case AFX_IDW_DOCKBAR_RIGHT:

		m_dwBarStyle |= SCBS_EDGELEFT;
		break;
		}

	m_dwBarStyle &= ~m_dwStyleLock;


	if(m_dwBarStyle & SCBS_SHOWEDGES)						// make room for edges only if they will be painted
		{
		sRect.DeflateRect(
				   (m_dwBarStyle & SCBS_EDGELEFT  )? m_cxEdge : 0,
				   (m_dwBarStyle & SCBS_EDGETOP   )? m_cxEdge : 0,
				   (m_dwBarStyle & SCBS_EDGERIGHT )? m_cxEdge : 0,
				   (m_dwBarStyle & SCBS_EDGEBOTTOM)? m_cxEdge : 0);
		}

	*pRc = sRect;
}

//*****************************************************************************
//*
//*		OnNcPaint
//*
//*****************************************************************************
void CSizeBarBase::OnNcPaint()
{
int			i;
CDC			sMdc;
CWindowDC	sDc(this);										// get window DC that is clipped to the non-client area
CRect		sClient;
CRect		sDraw;
CRect		sEdge;
CRect		sBar;
CBitmap		sBm;
CBitmap    *pOldBm;




	GetClientRect (sClient);
	ClientToScreen(sClient);
	GetWindowRect (sBar);

	sClient.OffsetRect(-sBar.TopLeft());
	sBar   .OffsetRect(-sBar.TopLeft());
	sMdc   .CreateCompatibleDC(&sDc);
	sBm    .CreateCompatibleBitmap(&sDc,sBar.Width(),sBar.Height());

	pOldBm = sMdc.SelectObject(&sBm);
	sDraw  = sBar;											// draw borders in non-client area
	DrawBorders(&sMdc, sDraw);

															// erase the NC background
	sMdc.FillRect(sDraw, CBrush::FromHandle((HBRUSH) GetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND)));

	if(m_dwBarStyle & SCBS_SHOWEDGES)
		{													// paint the sizing edges
		for(i=0;i<4;i++)
			{
			if(!GetEdgeRect(sBar,GetEdgeHTCode(i),sEdge))continue;
			DrawSizeRect(&sMdc,&sEdge,i&1);
			}
		}

	if(m_iGripper)
		{
		NcPaintGripper(&sMdc,sClient);
		}


	sDc.IntersectClipRect(sBar);							// client area is not our bussiness
	sDc.ExcludeClipRect(sClient);
	sDc.BitBlt(0,0,sBar.Width(),sBar.Height(),&sMdc,0,0,SRCCOPY);

	ReleaseDC(&sDc);

	sMdc.SelectObject(pOldBm);
	sBm .DeleteObject();
	sMdc.DeleteDC();
}

//*****************************************************************************
//*
//*		NcPaintGripper
//*
//*****************************************************************************
void CSizeBarBase::NcPaintGripper(CDC* pDc, CRect sClient)
{
	UNUSED_ALWAYS(pDc);
	UNUSED_ALWAYS(sClient);
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CSizeBarBase::OnPaint()
{
	CPaintDC sDc(this);										// overridden to skip border painting based on clientrect
}

//*****************************************************************************
//*
//*		OnNcHitTest
//*
//*****************************************************************************
LRESULT CSizeBarBase::OnNcHitTest(CPoint sPoint)
{
CRect	sEdge;
CRect	sBar;
int		i;


	GetWindowRect(sBar);

	if(!IsFloating())
		{
		for(i=0;i<4;i++)
			{
			if(!GetEdgeRect(sBar,GetEdgeHTCode(i),sEdge))continue;
			if(!sEdge.PtInRect(sPoint))continue;
			return GetEdgeHTCode(i);
			}
		}


return HTCLIENT;
}

//*****************************************************************************
//*
//*		OnSettingChange
//*
//*****************************************************************************
void CSizeBarBase::OnSettingChange(UINT uFlags, LPCTSTR lpszSection)
{
	CBaseControlBarClass::OnSettingChange(uFlags, lpszSection);

	m_bDragShowContent = FALSE;
	::SystemParametersInfo(SPI_GETDRAGFULLWINDOWS,0,&m_bDragShowContent,0);
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CSizeBarBase::OnSize(UINT nType,int iSizeX,int iSizeY)
{
CWnd	*pWnd;

	UNUSED_ALWAYS(nType);

	if((m_dwBarStyle & SCBS_SIZECHILD) != 0)				// automatic child resizing - only one child is allowed
		{
		   pWnd = GetWindow(GW_CHILD);
		if(pWnd)
			{
			pWnd->MoveWindow(0,0,iSizeX,iSizeY);
			ASSERT(pWnd->GetWindow(GW_HWNDNEXT) == NULL);
			}
		}

	m_szNow.cx	= iSizeX;
	m_szNow.cy	= iSizeY;

}

//*****************************************************************************
//*
//*		DelayShow
//*
//*****************************************************************************
void CSizeBarBase::DelayShow(BOOL bShow)
{

	if(!bShow)
		{
		m_bShowFlag = FALSE;
		}
	else if(!m_bShowLast)
		{
		m_bShowFlag = TRUE;
		}

	m_bShowLast = bShow;

	CBaseControlBarClass::DelayShow(bShow);

}


//*****************************************************************************
//*
//*		OnClose
//*
//*****************************************************************************
void CSizeBarBase::OnClose()
{
	// do nothing: protection against accidentally destruction by the
	// child control (i.e. if user hits Esc in a child editctrl)
}

//*****************************************************************************
//*
//*		StartTracking
//*
//*****************************************************************************
//  CSizeBarBase implementation helpers
void CSizeBarBase::StartTracking(UINT uHitTest,CPoint sPoint)
{
int				i;
int				iThis;
int				iMinWidth;
int				iMaxWidth;
int				iExcessWidth;
CRect			sBar;
CRect			sRect;
CRect			sEdge;
CRect			sTemp;
BOOL			bHorz;
BOOL			bHorzTracking;
BOOL			bTopOrLeft;
CSizeArray		aSizeBars;
CSizeBarBase   *pBar;




	SetCapture();

	if(!m_bDragShowContent)									// make sure no updates are pending
		{
		RedrawWindow(NULL, NULL, RDW_ALLCHILDREN | RDW_UPDATENOW);
		}

	m_bTracking		=  TRUE;
	m_uEdge			=  uHitTest;
	bHorz			=  IsHorzDocked();
	bHorzTracking	= (m_uEdge==HTLEFT) || (m_uEdge==HTRIGHT);
	m_nTrackPosOld	= (bHorzTracking)? sPoint.x:sPoint.y;


	GetWindowRect(sBar);
	GetEdgeRect  (sBar,m_uEdge,sEdge);


	m_nTrackEdgeOfs = m_nTrackPosOld - ((bHorzTracking)? sEdge.CenterPoint().x:sEdge.CenterPoint().y);

	GetRowSizingBars(aSizeBars,iThis);						// get other bars from this position

	m_nTrackPosMin  = m_nTrackPosMax = m_nTrackPosOld;

	if(!IsSideTracking())
		{
															// calc minwidth as the max minwidth of the sizing bars on row
		iMinWidth	= (bHorz)? m_szMinHorz.cy:m_szMinVert.cx;

		for(i=0;i<aSizeBars.GetSize();i++)
			{
			iMinWidth = max(iMinWidth,(bHorz)? aSizeBars[i]->m_szMinHorz.cy:aSizeBars[i]->m_szMinVert.cx);
			}

		iExcessWidth = ((bHorz)? m_szHorz.cy:m_szVert.cx) - iMinWidth;

															// the control bar cannot grow with more than the width of
															// remaining client area of the mainframe

		m_pDockSite->RepositionBars(0,0xFFFF,AFX_IDW_PANE_FIRST,reposQuery,&sTemp,NULL,TRUE);
		iMaxWidth		= (bHorz)? sTemp.Height()-2 : sTemp.Width()-2;
		bTopOrLeft		= (m_uEdge==HTTOP) || (m_uEdge==HTLEFT);
		m_nTrackPosMin -= bTopOrLeft ? iMaxWidth : iExcessWidth;
		m_nTrackPosMax += bTopOrLeft ? iExcessWidth : iMaxWidth;

		if(bTopOrLeft && m_nTrackPosOld<=m_nTrackPosMin)	// is a segment of the bar hidden							
			{
			pBar = aSizeBars[0];
			GetParent()->GetWindowRect(&sRect);
			sRect.IntersectRect( &sBar,&sRect);

			if(bHorz)
					m_nTrackPosOld -= sBar.Height()-sRect.Height();
			else	m_nTrackPosOld -= sBar.Width ()-sRect.Width ();
			}
		}
	else{
															// side tracking:
															// max size is the actual size plus the amount the other
															// sizing bars can be decreased until they reach their minsize
		if(m_uEdge==HTBOTTOM || m_uEdge==HTRIGHT)
			{
			iThis++;
			}

		for(i=0;i<aSizeBars.GetSize();i++)
			{
			pBar				  = aSizeBars[i];
			pBar->m_bDoTracking   = TRUE;
			pBar->m_bThisTracking = (iThis==i)? TRUE:FALSE;

			iExcessWidth = (bHorz)?	pBar->m_szHorz.cx-pBar->m_szMinHorz.cx:
									pBar->m_szVert.cy-pBar->m_szMinVert.cy;

			if(i<iThis)
					m_nTrackPosMin -= iExcessWidth;
			else	m_nTrackPosMax += iExcessWidth;
			}
		}

	OnTrackInvertTracker(); 								// draw tracker

}

//*****************************************************************************
//*
//*		StopTracking
//*
//*****************************************************************************
void CSizeBarBase::StopTracking()
{

	OnTrackInvertTracker(); 								// erase tracker

	m_bTracking = FALSE;
	ReleaseCapture();

	m_pDockSite->DelayRecalcLayout();

	if(m_bDoTracking)
		{
		CSizeBarBase   *pBar;
		CSizeArray		aSizeBars;
		int				i,iThis;

		GetRowSizingBars(aSizeBars,iThis);					// get other bars from this position

		for(i=0;i<aSizeBars.GetSize();i++)
			{
			pBar					= aSizeBars[i];
			pBar->m_bDoTracking		= FALSE;
			pBar->m_bThisTracking	= FALSE;
			}
		}

}

//*****************************************************************************
//*
//*		OnTrackUpdateSize
//*
//*****************************************************************************
void CSizeBarBase::OnTrackUpdateSize(CPoint &sPoint)
{
int				i;
int				iThis;
int				iFirst;
int				iLimit;
int				iDelta;
int				iDeltaT;
int				iTrackPos;
int				iGrowingBar;
BOOL			bHorzTrack;
BOOL			bBefore;
BOOL			bHorz;
CSize			sSize;
CSizeBarBase   *pBar;




	ASSERT(!IsFloating());

	bHorzTrack	= (m_uEdge==HTLEFT || m_uEdge==HTRIGHT);
	iTrackPos	= (bHorzTrack)? sPoint.x : sPoint.y;
	iTrackPos	= max(m_nTrackPosMin, min(m_nTrackPosMax, iTrackPos));
	iDelta		= iTrackPos - m_nTrackPosOld;

	if(iDelta==0)return;									// no pos change


	OnTrackInvertTracker(); 								// erase tracker

	m_nTrackPosOld = iTrackPos;

	bHorz = IsHorzDocked();
	sSize = (bHorz)? m_szHorz:m_szVert;

	switch(m_uEdge)
		{
	case HTLEFT:	sSize -= CSize(iDelta, 0); break;
	case HTTOP:		sSize -= CSize(0, iDelta); break;
	case HTRIGHT:	sSize += CSize(iDelta, 0); break;
	case HTBOTTOM:	sSize += CSize(0, iDelta); break;
		}

	CSizeArray aSizeBars;

	GetRowSizingBars(aSizeBars,iThis);

	if(!IsSideTracking())
	for(i=0;i<aSizeBars.GetSize();i++)
		{
		pBar = aSizeBars[i];								// make same width (or height)

		if(bHorz)pBar->m_szHorz.cy = sSize.cy;
		else	 pBar->m_szVert.cx = sSize.cx;
		}
	else{
		iGrowingBar = iThis;
		bBefore		= (m_uEdge==HTTOP || m_uEdge==HTLEFT);

		if( bBefore && iDelta>0)iGrowingBar--;
		if(!bBefore && iDelta<0)iGrowingBar++;
		if( iGrowingBar!=iThis )bBefore=!bBefore;



		iDelta = abs(iDelta);								// nGrowing is growing
		pBar   = aSizeBars[iGrowingBar];

		if(bHorz)pBar->m_szHorz.cx += iDelta;
		else	 pBar->m_szVert.cy += iDelta;

															// the others are shrinking
		iFirst = (bBefore)? iGrowingBar-1 : iGrowingBar+1;
		iLimit = (bBefore)? -1 : (int)aSizeBars.GetSize();

		for(i=iFirst;iDelta!=0 && i!=iLimit;i+=((bBefore)? -1:1))
			{
			pBar	= aSizeBars[i];
			iDeltaT = min(iDelta,((bHorz)? pBar->m_szHorz   .cx : pBar->m_szVert   .cy) -
								 ((bHorz)? pBar->m_szMinHorz.cx : pBar->m_szMinVert.cy));

			if(bHorz)pBar->m_szHorz.cx -= iDeltaT;
			else	 pBar->m_szVert.cy -= iDeltaT;

			iDelta -= iDeltaT;
			}
		}

	OnTrackInvertTracker(); 								// redraw tracker at new pos

	if(m_bDragShowContent)
		{
		m_pDockSite->DelayRecalcLayout();
		}

}

//*****************************************************************************
//*
//*		OnTrackInvertTracker
//*
//*****************************************************************************
void CSizeBarBase::OnTrackInvertTracker()
{
CBrush *pBrushOld;
CBrush *pBrush;
CDC    *pDc;
int		iOfs;
BOOL	bHorz;
CRect	sRect;
CRect	sBar;
CRect	sDock;
CRect	sFrame;
BOOL	bHorzTracking;



	ASSERT(m_bTracking);

	if(m_bDragShowContent)return;							// don't show tracker if DragFullWindows is on

	bHorz = IsHorzDocked();

	GetWindowRect(sBar);
	m_pDockBar ->GetWindowRect(sDock);
	m_pDockSite->GetWindowRect(sFrame);

	VERIFY(GetEdgeRect(sBar, m_uEdge, sRect));



	if(!IsSideTracking())
		{
		if(bHorz)sRect = CRect(sDock.left+1,sRect.top  ,sDock.right-1,sRect.bottom  );
		else	 sRect = CRect(sRect.left  ,sDock.top+1,sRect.right  ,sDock.bottom-1);
		}

	bHorzTracking	= (m_uEdge == HTLEFT || m_uEdge == HTRIGHT);
	iOfs			= m_nTrackPosOld - m_nTrackEdgeOfs;
	iOfs		   -= (bHorzTracking)? sRect.CenterPoint().x : sRect.CenterPoint().y;

	if(m_cxEdge>5)
		{
		if(bHorzTracking)
				sRect.right -=2;
		else	sRect.bottom-=2;
		}

	sRect.OffsetRect((bHorzTracking)? iOfs:0,(bHorzTracking)? 0:iOfs);
	sRect.OffsetRect(-sFrame.TopLeft());

	pDc			= m_pDockSite->GetDCEx(NULL,DCX_WINDOW|DCX_CACHE|DCX_LOCKWINDOWUPDATE);
	pBrush		= CDC::GetHalftoneBrush();
	pBrushOld	= pDc->SelectObject(pBrush);

	pDc->PatBlt(sRect.left, sRect.top, sRect.Width(), sRect.Height(), PATINVERT);
	pDc->SelectObject(pBrushOld);
	m_pDockSite->ReleaseDC(pDc);

}

//*****************************************************************************
//*
//*		GetEdgeRect
//*
//*****************************************************************************
BOOL CSizeBarBase::GetEdgeRect(CRect sWnd, UINT uHitTest,CRect& sEdge)
{
BOOL	bHorz;


	sEdge = sWnd;


	if(m_dwBarStyle&SCBS_SHOWEDGES)
		{
		sEdge.DeflateRect(1,1);
		}

	bHorz = IsHorzDocked();

	switch(uHitTest)
		{
	case HTLEFT:

		if(!(m_dwBarStyle & SCBS_EDGELEFT))return FALSE;
		sEdge.right = sEdge.left + m_cxEdge;
		//if(bHorz)sEdge.DeflateRect(0,m_cxEdge);
		if(m_dwBarStyle & SCBS_EDGETOP   )sEdge.top   +=m_cxEdge-2;
		if(m_dwBarStyle & SCBS_EDGEBOTTOM)sEdge.bottom-=m_cxEdge-2;

		break;

	case HTTOP:

		if(!(m_dwBarStyle & SCBS_EDGETOP))return FALSE;
		sEdge.bottom = sEdge.top + m_cxEdge;
		//if(!bHorz)sEdge.DeflateRect(m_cxEdge,0);
		break;

	case HTRIGHT:

		if(!(m_dwBarStyle & SCBS_EDGERIGHT))return FALSE;
		sEdge.left = sEdge.right - m_cxEdge;
		//if(bHorz)sEdge.DeflateRect(0,m_cxEdge);

		if(m_dwBarStyle & SCBS_EDGETOP   )sEdge.top   +=m_cxEdge-2;
		if(m_dwBarStyle & SCBS_EDGEBOTTOM)sEdge.bottom-=m_cxEdge-1;

		break;

	case HTBOTTOM:

		if(!(m_dwBarStyle & SCBS_EDGEBOTTOM))return FALSE;
		sEdge.top = sEdge.bottom - m_cxEdge;
		//if(!bHorz)sEdge.DeflateRect(m_cxEdge,0);
		break;

	default:

		ASSERT(FALSE);										// invalid hit test code
		}

return TRUE;
}

//*****************************************************************************
//*
//*		GetEdgeHTCode
//*
//*****************************************************************************
UINT CSizeBarBase::GetEdgeHTCode(int nEdge)
{

	if(nEdge == 0) return HTLEFT;
	if(nEdge == 1) return HTTOP;
	if(nEdge == 2) return HTRIGHT;
	if(nEdge == 3) return HTBOTTOM;
	ASSERT(FALSE);											// invalid edge code

return HTNOWHERE;
}

//*****************************************************************************
//*
//*		GetRowInfo
//*
//*****************************************************************************
void CSizeBarBase::GetRowInfo(int &iFirst, int &iLast, int &iThis)
{
int		i;
int		iBars;


	ASSERT_VALID(m_pDockBar);								// verify bounds

	iThis = m_pDockBar->FindBar(this);

	ASSERT(iThis!=-1);

	iBars = (int)m_pDockBar->m_arrBars.GetSize();

															// find the first and the last bar in row
	for(iFirst=-1,i=iThis-1;i>=0 && iFirst==-1;i--)
		{
		if(m_pDockBar->m_arrBars[i] == NULL)
			{
			iFirst = i + 1;
			}
		}

	for(iLast=-1,i=iThis+1;i<iBars && iLast==-1;i++)
		{
		if(m_pDockBar->m_arrBars[i] == NULL)
			{
			iLast = i - 1;
			}
		}

	ASSERT((iLast != -1) && (iFirst != -1));
}

//*****************************************************************************
//*
//*		GetRowSizingBars
//*
//*****************************************************************************
void CSizeBarBase::GetRowSizingBars(CSizeArray &aSizeBars)
{
int		iThis;


	GetRowSizingBars(aSizeBars, iThis);

}

//*****************************************************************************
//*
//*		GetRowSizingBars
//*
//*****************************************************************************
void CSizeBarBase::GetRowSizingBars(CSizeArray &aSizeBars, int &iThis)
{
int				i;
int				iLastT;
int				iThisT;
int				iFirstT;
CSizeBarBase   *pBar;



	aSizeBars.RemoveAll();


	GetRowInfo(iFirstT,iLastT,iThisT);

	iThis = -1;

	for(i=iFirstT;i<=iLastT;i++)
		{
		pBar = (CSizeBarBase*)m_pDockBar->m_arrBars[i];

		if( HIWORD(pBar) == 0)continue; 					// placeholder
		if(!pBar->IsVisible())continue;
		if( pBar->IsKindOf(RUNTIME_CLASS(CSizeBarBase)))
			{
			if(pBar==this)
				{
				iThis = (int)aSizeBars.GetSize();
				}

			aSizeBars.Add(pBar);
			}
		}
}

//*****************************************************************************
//*
//*		NegotiateSpace
//*
//*****************************************************************************
BOOL CSizeBarBase::NegotiateSpace(int iLengthTotal, BOOL bHorz)
{
CSizeBarBase   *pBar;
CSizeBarBase   *pSub;
CRect			sRect;
BOOL			bFlag;
BOOL			bIsSizingBar;
int				iLengthActual;
int				iLengthAvail;
int				iLengthMin;
int				iLengthBar;
int				iWidthMax;
int				iDeltaOld;
int				iNumBars;
int				iLenMin;
int				iMinPos;
int				iDelta2;
int				iDelta;
int				iFirst;
int				iLast;
int				iThis;
int				iLen;
int				i;



	GetRowInfo(iFirst, iLast, iThis);

	iLengthAvail	= iLengthTotal;
	iLengthActual	= 0;
	iLengthMin		= 2;
	iWidthMax		= 0;

	for(i=iFirst;i<=iLast;i++)
		{
		pBar = (CSizeBarBase*)m_pDockBar->m_arrBars[i];

		if( HIWORD(pBar) == 0)continue; 						// placeholder
		if(!pBar->IsVisible())continue;

		bIsSizingBar   = pBar->IsKindOf(RUNTIME_CLASS(CSizeBarBase));

						 										// minimum length of the bar
		if(bIsSizingBar)
			{
			iLengthBar = (bHorz)? pBar->m_szMinHorz.cx-2:pBar->m_szMinVert.cy-2;
			}
		else{
			pBar->GetWindowRect(&sRect);
			iLengthBar = (bHorz)? sRect.Width()-2 : sRect.Height()-2;
			}

		   iLengthMin +=iLengthBar;
		if(iLengthMin > iLengthTotal)
			{
			if(i<iThis)										// split the row after fixed bar
				{
				m_pDockBar->m_arrBars.InsertAt(i + 1,(CControlBar*)NULL);
				return FALSE;
				}

			if(i==iThis)									// only this sizebar remains on the row, adjust it to minsize
				{
				if(bHorz)m_szHorz.cx = m_szMinHorz.cx;
				else	 m_szVert.cy = m_szMinVert.cy;

				return TRUE;								// the dockbar will split the row for us
				}

															// we have enough bars - go negotiate with them
			m_pDockBar->m_arrBars.InsertAt(i,(CControlBar*)NULL);
			iLast	= i-1;

			break;
			}

		if(bIsSizingBar)
			{
			iLengthActual +=               (bHorz)? pBar->m_szHorz.cx-2 : pBar->m_szVert.cy-2;
			iWidthMax      = max(iWidthMax,(bHorz)? pBar->m_szHorz.cy   : pBar->m_szVert.cx );
			}
		else{
			iLengthAvail -= iLengthBar;
			}
		}

	CSizeArray aSizeBars;

	GetRowSizingBars(aSizeBars);

	iNumBars	= (int)aSizeBars.GetSize();
	iDelta		= iLengthAvail-iLengthActual;


	if(iNumBars==1)											// return faster when there is only one sizing bar per row (this one)
		{
		ASSERT(aSizeBars[0] == this);

		if(iDelta==0)return TRUE;

		m_bKeepSize = FALSE;

		if(bHorz)m_szHorz.cx += iDelta;
		else	 m_szVert.cy += iDelta;

		return TRUE;
		}


	for(i=0;i<iNumBars;i++)									// make all the bars the same width
		{
		pBar = aSizeBars[i];

		if(bHorz)
				pBar->m_szHorz.cy = iWidthMax;
		else	pBar->m_szVert.cx = iWidthMax;
		}

	
	iMinPos = iNumBars-1;

	while(iDelta!=0)										// distribute the difference between the bars,
		{													// but don't shrink them below their minsizes
		iDeltaOld = iDelta;

		for(i=0;i<iNumBars;i++)
			{
			pBar	= aSizeBars[i];
			iLenMin = (bHorz)? pBar->m_szMinHorz.cx : pBar->m_szMinVert.cy;
			iLen	= (bHorz)? pBar->m_szHorz   .cx : pBar->m_szVert   .cy;


			if(pBar->m_bShowFlag)							// add a fixed bar at the end
				{
				pBar->m_bShowFlag=0; 

				if(i+1==iNumBars && i==iMinPos && i>0)
					{
					pSub = aSizeBars[i-1];

					if(bHorz!=0 && pSub->m_iFixedHorz && pSub->m_szHorz.cx!=pSub->m_szMinHorz.cx)
						{
						iDelta += pSub->m_szHorz.cx-pSub->m_szMinHorz.cx;
						pSub->m_szHorz.cx = pSub->m_szMinHorz.cx;
						iDeltaOld = iDelta;
						}
				   
					if(bHorz==0 && pSub->m_iFixedVert && pSub->m_szVert.cy!=pSub->m_szMinVert.cy)
						{
						iDelta += pSub->m_szVert.cy-pSub->m_szMinVert.cy;
						pSub->m_szVert.cy = pSub->m_szMinVert.cy;
						iDeltaOld = iDelta;
						}
					}
				}

			 												// already at min length
			    											// or wants to keep its size
			if((iLen==iLenMin && iDelta<0) || pBar->m_bKeepSize)
				{
				continue;
				}

			if(iDelta!=0)									// sign of iDelta
					iDelta2 = (iDelta<0)? -1:1;
			else	iDelta2 =  0;

			if(bHorz!=0 && (!pBar->m_iFixedHorz || i>=iMinPos))
				{
				pBar->m_szHorz.cx += iDelta2;
				iDelta            -= iDelta2;
				}
			
			if(bHorz==0 && (!pBar->m_iFixedVert || i>=iMinPos))
				{
				pBar->m_szVert.cy += iDelta2;
				iDelta            -= iDelta2;
				}

			if(iDelta==0)break;
			}


		if(iDeltaOld==iDelta || iDelta==0)					// clear m_bKeepSize flags
			{
			bFlag = FALSE;
			
			for(i=0;i<iNumBars;i++)
				{
				pBar = aSizeBars[i];
				if(!pBar->m_bKeepSize)continue;
				pBar->m_bKeepSize = FALSE;
				bFlag			  = TRUE;
				}

			if(!bFlag)
				{
				iMinPos--;
				if(iMinPos<0)break;
				}
			}
		}


return TRUE;
}

//*****************************************************************************
//*
//*		AlignControlBars
//*
//*****************************************************************************
void CSizeBarBase::AlignControlBars()
{
CSizeBarBase   *pBar;
CRect			sRect;
CRect			sDock;
BOOL			bHorz;
BOOL			bNeedRecalc;
int				iValue;
int				iAlign;
int				iFirst;
int				iThis;
int				iLast;
int				i;



	GetRowInfo(iFirst,iLast,iThis);

	bNeedRecalc = FALSE;
	bHorz		= IsHorzDocked();
	iAlign		=(bHorz)? -2:0;


	m_pDockBar->GetWindowRect(&sDock);

	for(i=iFirst;i<=iLast;i++)
		{
		pBar = (CSizeBarBase*)m_pDockBar->m_arrBars[i];

		if( HIWORD(pBar) == 0)continue; 					// placeholder
		if(!pBar->IsVisible())continue;

		pBar->GetWindowRect(&sRect);
		sRect.OffsetRect(-sDock.TopLeft());

		if(pBar->IsKindOf(RUNTIME_CLASS(CSizeBarBase)))
			{
			sRect = CRect(sRect.TopLeft(),(bHorz)? pBar->m_szHorz:pBar->m_szVert);
			}

		   iValue = (bHorz)? sRect.left : sRect.top;
		if(iValue!=iAlign)
			{
			if(!bHorz)
				{
				sRect.OffsetRect(0, iAlign - sRect.top - 2);
				}
			else if(m_nDockBarID == AFX_IDW_DOCKBAR_TOP)
				{
				sRect.OffsetRect(iAlign - sRect.left, -2);
				}
			else{
				sRect.OffsetRect(iAlign - sRect.left, 0);
				}

			pBar->MoveWindow(sRect);
			bNeedRecalc = TRUE;
			}

		iAlign += ((bHorz)? sRect.Width():sRect.Height()) - 2;
		}

	if(bNeedRecalc)
		{
		m_pDockSite->DelayRecalcLayout();
		}
}

//*****************************************************************************
//*
//*		OnUpdateCmdUI
//*
//*****************************************************************************
void CSizeBarBase::OnUpdateCmdUI(CFrameWnd* pTarget,BOOL bDisableIfNoHndler)
{
	UNUSED_ALWAYS(bDisableIfNoHndler);
	UNUSED_ALWAYS(pTarget);
}

//*****************************************************************************
//*
//*		LoadBarState
//*
//*****************************************************************************
void CSizeBarBase::LoadBarState(LPCTSTR pProfileName)
{
CWinApp	   *pApp ;
INT			iFloating;
TCHAR		cSection[32];



	ASSERT_VALID(this);
	ASSERT(GetSafeHwnd());									// must be called after Create()


	#if defined(SCB_REPLACE_MINIFRAME) && !defined(SCB_MINIFRAME_CAPTION)

	CControlBarInfo    *pInfo
	CDockState			sState;								// compensate the caption miscalculation in CFrameWnd::SetDockState()
	UINT				nID;
	int					i,j;


	sState.LoadState(pProfileName);
	nID = GetDlgCtrlID();

	for(i=0;i<sState.m_arrBarInfo.GetSize();i++)
		{
		pInfo = (CControlBarInfo*)sState.m_arrBarInfo[i];
		ASSERT(pInfo != NULL);

		if(!pInfo->m_bFloating)continue;

		for(j=0;j<pInfo->m_arrBarID.GetSize();j++)			// this is a floating dockbar - check the ID array
			{
			if((DWORD)pInfo->m_arrBarID[j]==nID)
				{
				pInfo->m_pointPos.x ++;						// found this bar - offset origin and save settings
				pInfo->m_pointPos.y += ::GetSystemMetrics(SM_CYSMCAPTION) + 1;
				pInfo->SaveState(pProfileName, i);
				}
			}
		}

	#endif

	pApp = AfxGetApp();

	wsprintf(cSection, _T("%s-SCBar-%d"), pProfileName,GetDlgCtrlID());

	iFloating = pApp->GetProfileInt(cSection, _T("Floating"),FALSE);							
	m_szHorz .cx = max(m_szMinHorz .cx, (int) pApp->GetProfileInt(cSection, _T("sizeHorzCX" ), m_szHorz .cx));
	m_szHorz .cy = max(m_szMinHorz .cy, (int) pApp->GetProfileInt(cSection, _T("sizeHorzCY" ), m_szHorz .cy));
	m_szVert .cx = max(m_szMinVert .cx, (int) pApp->GetProfileInt(cSection, _T("sizeVertCX" ), m_szVert .cx));
	m_szVert .cy = max(m_szMinVert .cy, (int) pApp->GetProfileInt(cSection, _T("sizeVertCY" ), m_szVert .cy));
	m_szFloat.cx = max(m_szMinFloat.cx, (int) pApp->GetProfileInt(cSection, _T("sizeFloatCX"), m_szFloat.cx));
	m_szFloat.cy = max(m_szMinFloat.cy, (int) pApp->GetProfileInt(cSection, _T("sizeFloatCY"), m_szFloat.cy));

	if(iFloating)
		{
		SendMessage(WM_LBUTTONDBLCLK,0,0);
		}

}

//*****************************************************************************
//*
//*		SaveBarState
//*
//*****************************************************************************
void CSizeBarBase::SaveBarState(LPCTSTR pProfileName)
{
CWinApp	   *pApp;
TCHAR		cSection[32];
															// place your SaveState or GlobalSaveState call in
															// CMainFrame's OnClose() or DestroyWindow(), not in OnDestroy()
	ASSERT_VALID(this);

	pApp = AfxGetApp();

	wsprintf(cSection, _T("%s-SCBar-%d"),pProfileName,m_nBarID);

	pApp->WriteProfileInt(cSection, _T("Floating"   ), IsFloating());
	pApp->WriteProfileInt(cSection, _T("sizeHorzCX" ), m_szHorz .cx);
	pApp->WriteProfileInt(cSection, _T("sizeHorzCY" ), m_szHorz .cy);
	pApp->WriteProfileInt(cSection, _T("sizeVertCX" ), m_szVert .cx);
	pApp->WriteProfileInt(cSection, _T("sizeVertCY" ), m_szVert .cy);
	pApp->WriteProfileInt(cSection, _T("sizeFloatCX"), m_szFloat.cx);
	pApp->WriteProfileInt(cSection, _T("sizeFloatCY"), m_szFloat.cy);
}

//*****************************************************************************
//*
//*		GlobalLoadState
//*
//*****************************************************************************
void CSizeBarBase::GlobalLoadState(CFrameWnd* pFrame,LPCTSTR pProfileName)
{
CSizeBarBase   *pBar;
POSITION		pPos;


	pPos = pFrame->m_listControlBars.GetHeadPosition();


	while(pPos)
		{
		pBar = (CSizeBarBase*) pFrame->m_listControlBars.GetNext(pPos);

		ASSERT(pBar != NULL);

		if(pBar->IsKindOf(RUNTIME_CLASS(CSizeBarBase)))
			{
			pBar->LoadBarState(pProfileName);
			}
		}


}

//*****************************************************************************
//*
//*		GlobalSaveState
//*
//*****************************************************************************
void CSizeBarBase::GlobalSaveState(CFrameWnd* pFrame,LPCTSTR pProfileName)
{
CSizeBarBase   *pBar;
POSITION		pPos;



	pPos = pFrame->m_listControlBars.GetHeadPosition();

	while(pPos != NULL)
		{
		pBar = (CSizeBarBase*) pFrame->m_listControlBars.GetNext(pPos);

		ASSERT(pBar != NULL);

		if(pBar->IsKindOf(RUNTIME_CLASS(CSizeBarBase)))
			{
			pBar->SaveBarState(pProfileName);
			}
		}
}

#ifdef		SCB_REPLACE_MINIFRAME
#ifndef		SCB_MINIFRAME_CAPTION


//*****************************************************************************
//*
//*		AdjustRectangle
//*
//*****************************************************************************
//  CSCBDockContext Drag Operations
static void AdjustRectangle(CRect& sRect, CPoint sPoint)
{
int		iXoffset;
int		iYoffset;


	iXoffset = (sPoint.x<sRect.left)? (sPoint.x-sRect.left) : (sPoint.x>sRect.right )? (sPoint.x-sRect.right ) : 0;
	iYoffset = (sPoint.y<sRect.top )? (sPoint.y-sRect.top ) : (sPoint.y>sRect.bottom)? (sPoint.y-sRect.bottom) : 0;


	sRect.OffsetRect(iXoffset, iYoffset);
}

//*****************************************************************************
//*
//*		StartDrag
//*
//*****************************************************************************
void CSCBDockContext::StartDrag(CPoint sPoint)
{
CRect	sRect;
CSize	sHorz;
CSize	sVert;
CSize	sFloat;


	ASSERT_VALID(m_pBar);
	m_bDragging = TRUE;

	InitLoop();

	ASSERT((m_pBar->m_dwStyle & CBRS_SIZE_DYNAMIC) != 0);

	m_pBar->GetWindowRect(sRect);							// get true bar size (including borders)

	m_ptLast = sPoint;
	sHorz	 = m_pBar->CalcDynamicLayout(0, LM_HORZ | LM_HORZDOCK);
	sVert	 = m_pBar->CalcDynamicLayout(0, LM_VERTDOCK);
	sFloat   = m_pBar->CalcDynamicLayout(0, LM_HORZ | LM_MRUWIDTH);

	m_rectDragHorz		= CRect(sRect.TopLeft(), sHorz);
	m_rectDragVert		= CRect(sRect.TopLeft(), sVert);
	m_rectFrameDragHorz = CRect(sRect.TopLeft(), sFloat);	// calculate frame dragging rectangle

	#ifdef		_MAC
	CMiniFrameWnd::CalcBorders(&m_rectFrameDragHorz,WS_THICKFRAME, WS_EX_FORCESIZEBOX);
	#else
	CMiniFrameWnd::CalcBorders(&m_rectFrameDragHorz,WS_THICKFRAME);
	#endif

	m_rectFrameDragHorz.DeflateRect(2, 2);
	m_rectFrameDragVert = m_rectFrameDragHorz;


	AdjustRectangle(m_rectDragHorz     ,sPoint);			// adjust rectangles so that sPoint is inside
	AdjustRectangle(m_rectDragVert	   ,sPoint);
	AdjustRectangle(m_rectFrameDragHorz,sPoint);
	AdjustRectangle(m_rectFrameDragVert,sPoint);


	m_dwOverDockStyle = CanDock();							// initialize tracking state and enter tracking loop

	Move(sPoint);											// call it here to handle special keys
	Track();

}
#endif


//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CSizeDockFrameWnd::Create(CWnd *pParent, DWORD dwBarStyle)
{
CString sHide;
CMenu  *pSysMenu;
DWORD	dwExStyle;
DWORD	dwStyle;

															// set m_bInRecalcLayout to avoid flashing during creation
	m_bInRecalcLayout = TRUE;								// RecalcLayout will be called once something is docked

	dwStyle		= WS_POPUP|WS_CAPTION|WS_SYSMENU|MFS_MOVEFRAME|
				  MFS_4THICKFRAME|MFS_SYNCACTIVE|MFS_BLOCKSYSMENU|
				  FWS_SNAPTOBARS;

	if(dwBarStyle & CBRS_SIZE_DYNAMIC)
		{
		dwStyle &= ~MFS_MOVEFRAME;
		}

	#ifdef		_MAC
	if(dwBarStyle & CBRS_SIZE_DYNAMIC)
		{
		dwExStyle |= WS_EX_FORCESIZEBOX;
		}
	else{
		dwStyle    &= ~(MFS_MOVEFRAME|MFS_4THICKFRAME);
		}
	#endif

	if(!CMiniFrameWnd::CreateEx(dwExStyle,NULL, &afxChNil, dwStyle, rectDefault, pParent))
		{
		m_bInRecalcLayout = FALSE;
		return FALSE;
		}

	dwStyle  = (dwBarStyle&(CBRS_ALIGN_LEFT|CBRS_ALIGN_RIGHT))?  CBRS_ALIGN_LEFT:CBRS_ALIGN_TOP;
	dwStyle |=  dwBarStyle & CBRS_FLOAT_MULTI;
	pSysMenu = GetSystemMenu(FALSE);


	if(sHide.LoadString(AFX_IDS_HIDE))
		{
		pSysMenu->DeleteMenu(SC_CLOSE, MF_BYCOMMAND);
		pSysMenu->AppendMenu(MF_STRING|MF_ENABLED,SC_CLOSE,sHide);
		}

															// must initially create with parent frame as parent
	if(!m_wndDockBar.Create(pParent, WS_CHILD | WS_VISIBLE | dwStyle,AFX_IDW_DOCKBAR_FLOAT))
		{
		m_bInRecalcLayout = FALSE;
		return FALSE;
		}


	m_wndDockBar.SetParent(this);							// set parent to CSizeDockFrameWnd
	m_bInRecalcLayout = FALSE;


return TRUE;
}

//*****************************************************************************
//*
//*		OnNcLButtonDown
//*
//*****************************************************************************
void CSizeDockFrameWnd::OnNcLButtonDown(UINT uHitTest,CPoint sPoint)
{
	if(uHitTest==HTCAPTION || uHitTest==HTCLOSE)
		{
		CBaseDockFrameClass::OnNcLButtonDown(uHitTest, sPoint);
		return;
		}

	if(GetSizingControlBar() != NULL)
		{
		CMiniFrameWnd::OnNcLButtonDown(uHitTest,sPoint);
		}
	else{
		CBaseDockFrameClass::OnNcLButtonDown(uHitTest,sPoint);
		}
}

//*****************************************************************************
//*
//*		GetSizingControlBar
//*
//*****************************************************************************
CSizeBarBase* CSizeDockFrameWnd::GetSizingControlBar()
{
CWnd   *pWnd;


		pWnd = GetWindow(GW_CHILD); 						// get the dockbar
	if(!pWnd)
		{
		return NULL;
		}

	    pWnd = pWnd->GetWindow(GW_CHILD);					// get the controlbar
	if(!pWnd)
		{
		return NULL;
		}

	if(!pWnd->IsKindOf(RUNTIME_CLASS(CSizeBarBase)))
		{
		return NULL;
		}


return (CSizeBarBase*)pWnd;
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CSizeDockFrameWnd::OnSize(UINT nType,int iSizeX,int iSizeY)
{
CSizeBarBase  *pBar = GetSizingControlBar();



	if(pBar && !(GetStyle()&MFS_4THICKFRAME) && pBar->IsVisible())
		{
		pBar->m_szFloat = CSize(iSizeX+4,iSizeY+4);
		}

	CBaseDockFrameClass::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnGetMinMaxInfo
//*
//*****************************************************************************
void CSizeDockFrameWnd::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI)
{
CSizeBarBase    *pBar;


	CBaseDockFrameClass::OnGetMinMaxInfo(lpMMI);

	   pBar = GetSizingControlBar();
	if(pBar != NULL)
		{
		CRect sRect(CPoint(0, 0), pBar->m_szMinFloat - CSize(4, 4));


		#ifndef		SCB_MINIFRAME_CAPTION
		CMiniFrameWnd::CalcBorders(&sRect,WS_THICKFRAME);
		#else
		CMiniFrameWnd::CalcBorders(&sRect,WS_THICKFRAME|WS_CAPTION);
		#endif

		lpMMI->ptMinTrackSize.x = sRect.Width ();
		lpMMI->ptMinTrackSize.y = sRect.Height();
		}
}

//*****************************************************************************
//*
//*		OnWindowPosChanging
//*
//*****************************************************************************
void CSizeDockFrameWnd::OnWindowPosChanging(WINDOWPOS FAR* pWindowPos)
{
CSizeBarBase   *pBar;



	if(GetStyle()&MFS_4THICKFRAME)
		{
		   pBar = GetSizingControlBar();
		if(pBar)
			{
			pWindowPos->flags |= SWP_NOSIZE;				// don't size this time
															// prevents flicker
			pBar->m_pDockBar->ModifyStyle(0, WS_CLIPCHILDREN);

			ModifyStyle(MFS_4THICKFRAME, 0);				// enable diagonal resizing

			#ifndef		SCB_MINIFRAME_CAPTION
			ModifyStyle(WS_SYSMENU|WS_CAPTION, 0);			// remove caption
			#endif

			DelayRecalcLayout();
			pBar->PostMessage(WM_NCPAINT);
			}
		}


	CMiniFrameWnd::OnWindowPosChanging(pWindowPos);
}


#endif




//*****************************************************************************
//*
//*		CSizeBar
//*
//*****************************************************************************
CSizeBar::CSizeBar()
{
	m_cyGripper = 12;

}

//*****************************************************************************
//*
//*		CSizeBar
//*
//*****************************************************************************
CSizeBar::~CSizeBar()
{
}


//*****************************************************************************
//*
//*		OnNcLButtonUp
//*
//*****************************************************************************
void CSizeBar::OnNcLButtonUp(UINT nHitTest, CPoint sPoint)
{

	if(nHitTest==HTCLOSE)
		{
		m_pDockSite->ShowControlBar(this, FALSE, FALSE);	// hide
		}

	CBaseSizeBarClass::OnNcLButtonUp(nHitTest, sPoint);
}

//*****************************************************************************
//*
//*		NcCalcClient
//*
//*****************************************************************************
void CSizeBar::NcCalcClient(LPRECT pRect, UINT nDockBarID)
{
BOOL	bHorz;
CRect	sRect;
CRect	sClient;
CPoint	sButton;


	sRect = *pRect;



	
	CBaseSizeBarClass::NcCalcClient(pRect, nDockBarID);		// subtract edges

	if(!HasGripper())return;



	sClient = *pRect;										// the client rect as calculated by the base class
	bHorz   = (nDockBarID == AFX_IDW_DOCKBAR_TOP) ||(nDockBarID == AFX_IDW_DOCKBAR_BOTTOM);

	if(bHorz)
		{
		sClient.DeflateRect(m_cyGripper,0,0,0);
		}
	else{
		sClient.DeflateRect(0,m_cyGripper,0,0);
		}

	if(m_iClose)
		{
		if(bHorz)											// set position for the "x" (hide bar) button
				sButton = CPoint(sClient.left -12,sClient.top+1);
		else	sButton = CPoint(sClient.right-11,sClient.top-12);

		m_bHide.Move(sButton-sRect.TopLeft());
		}


	*pRect = sClient;

}

//*****************************************************************************
//*
//*		NcPaintGripper
//*
//*****************************************************************************
void CSizeBar::NcPaintGripper(CDC *pDC, CRect sRect)
{
BOOL	bHorz;
CRect	sButton;
CRect	sGripper;



	if(!HasGripper())return;

															// paints a simple "two raised lines" sGripper
															// override this if you want a more sophisticated gripper
	sGripper = sRect;
	bHorz	 = IsHorzDocked();

	if(m_iClose)
			sButton=m_bHide.GetRect();
	else	sButton.SetRect(sRect.right,0,2,2);

	sGripper.DeflateRect(1, 1);

	if(bHorz)												// Gripper at left
		{
		sGripper.left   -= m_cyGripper    - 1;
		sGripper.right	 = sGripper.left  + 3;
		sGripper.top 	 = sButton.bottom + 3;
		if(!m_iClose)sGripper.top+=5;
		}
	else{													// Gripper at top
		sGripper.top    -= m_cyGripper    - 1;
		sGripper.bottom	 = sGripper.top   + 3;
		sGripper.right	 = sButton.left   - 1;
		}

	pDC->Draw3dRect(sGripper,::GetSysColor(COLOR_BTNHIGHLIGHT),::GetSysColor(COLOR_BTNSHADOW));
	sGripper.OffsetRect((bHorz)? 3:0,(bHorz)? 0:3);
	pDC->Draw3dRect(sGripper,::GetSysColor(COLOR_BTNHIGHLIGHT),::GetSysColor(COLOR_BTNSHADOW));

	if(m_iClose)
		{
		m_bHide.Paint(pDC);
		}
}

//*****************************************************************************
//*
//*		OnNcHitTest
//*
//*****************************************************************************
LRESULT CSizeBar::OnNcHitTest(CPoint sPoint)
{
CRect	sClient;
CRect	sRect;
LRESULT	lRet;



	GetWindowRect(sRect);

	lRet = CBaseSizeBarClass::OnNcHitTest(sPoint);

	if(lRet!=HTCLIENT)return lRet;

	if(m_iClose)
		{
		sClient = m_bHide.GetRect();
		sClient.OffsetRect(sRect.TopLeft());
		if(sClient.PtInRect(sPoint))return HTCLOSE;
		}


return HTCLIENT;
}

//*****************************************************************************
//*
//*		OnUpdateCmdUI
//*
//*****************************************************************************
//  CSizeBar implementation helpers
void CSizeBar::OnUpdateCmdUI(CFrameWnd* pTarget,BOOL bDisableIfNoHndler)
{
BOOL	bHit;
BOOL	bNeedPaint;
BOOL 	bWasRaised;
BOOL 	bWasPushed;
BOOL	bLButtonDown;
CPoint	sPoint;


	UNUSED_ALWAYS(bDisableIfNoHndler);
	UNUSED_ALWAYS(pTarget);

	if(!m_iClose)return;
	if(!HasGripper())return;

	GetCursorPos(&sPoint);


	bHit			 = (OnNcHitTest(sPoint) == HTCLOSE);
	bLButtonDown	 = (::GetKeyState(VK_LBUTTON) < 0);

	bNeedPaint		 = FALSE;
	bWasPushed		 = m_bHide.bPushed;
	bWasRaised		 = m_bHide.bRaised;
	m_bHide.bPushed  = bHit &&  bLButtonDown;
	m_bHide.bRaised  = bHit && !bLButtonDown;
	bNeedPaint      |= (m_bHide.bPushed^bWasPushed) || (m_bHide.bRaised^bWasRaised);

	if(bNeedPaint)
		{
		SendMessage(WM_NCPAINT);
		}

}

//*****************************************************************************
//*
//*		CSizeBarButton
//*
//*****************************************************************************
//  CSizeBarButton
CSizeBarButton::CSizeBarButton()
{

	bRaised = FALSE;
	bPushed = FALSE;

}

//*****************************************************************************
//*
//*		Paint
//*
//*****************************************************************************
void CSizeBarButton::Paint(CDC *pDC)
{
CRect		sClient;
CFont		sFont;
CFont	   *pOldFont;
COLORREF	uTextColor;
int			iBkMode;
int			iPixels;
int			iSize;


	sClient = GetRect();

	if(bPushed)
		{
		pDC->Draw3dRect(sClient, ::GetSysColor(COLOR_BTNSHADOW),::GetSysColor(COLOR_BTNHIGHLIGHT));
		}
	else{
		if(bRaised)pDC->Draw3dRect(sClient,::GetSysColor(COLOR_BTNHIGHLIGHT),::GetSysColor(COLOR_BTNSHADOW));
		}

	uTextColor	= pDC->GetTextColor();
				  pDC->SetTextColor(::GetSysColor(COLOR_BTNTEXT));
	iBkMode		= pDC->SetBkMode(TRANSPARENT);

	iPixels		= pDC->GetDeviceCaps(LOGPIXELSX);
	iSize		= MulDiv(60,96,iPixels);					// 6 points at 96 iPixels
				  sFont.CreatePointFont(iSize,_T("Marlett"));
	pOldFont	= pDC->SelectObject(&sFont);

	pDC->TextOut     (pOrg.x+2,pOrg.y+2,_T("r"),1);
	pDC->SelectObject(pOldFont);
	pDC->SetBkMode   (iBkMode);
	pDC->SetTextColor(uTextColor);

}

//*****************************************************************************
//*
//*		HasGripper
//*
//*****************************************************************************
BOOL CSizeBar::HasGripper() const
{
	#if defined(SCB_MINIFRAME_CAPTION) || !defined(SCB_REPLACE_MINIFRAME)

	if(IsFloating())										// if the miniframe has a caption, don't display the sGripper
		{
		return FALSE;
		}

	#endif

return (m_iGripper)? TRUE:FALSE;
}


//*****************************************************************************
//*
//*		DrawSizeRect
//*
//*****************************************************************************
void CSizeBarBase::DrawSizeRect(CDC *pDc,CRect *pRect,BOOL bHorz)
{
int			iEnd;
int			iPos;
int			iSize;
int			iStart;
HGDIOBJ		hOldPen;
HGDIOBJ		hOldBrush;


	hOldPen   = pDc->SelectStockObject(NULL_PEN);
	hOldBrush = pDc->SelectObject(GetSysColorBrush(COLOR_3DLIGHT));

	if(bHorz)
		{
		iPos	= pRect->left-1;
		iEnd	= pRect->right+2;
		iSize	= pRect->Height()-4;
		iStart	= pRect->top;

		pDc->Rectangle(iPos,iStart        ,iEnd,iStart+2      );
		pDc->SelectStockObject(WHITE_BRUSH);
		pDc->Rectangle(iPos,iStart+1      ,iEnd,iStart+3      );
		pDc->SelectObject(GetSysColorBrush(COLOR_3DFACE));
		pDc->Rectangle(iPos,iStart+2      ,iEnd,iStart+iSize+3);
 		pDc->SelectObject(GetSysColorBrush(COLOR_3DSHADOW));
		pDc->Rectangle(iPos,iStart+iSize  ,iEnd,iStart+iSize+2);
		pDc->SelectStockObject(BLACK_BRUSH);
		pDc->Rectangle(iPos,iStart+iSize+1,iEnd,iStart+iSize+3);
		}
	else{
		iPos	= pRect->top-1;
		iEnd	= pRect->bottom+2;
		iSize	= pRect->Width()-4;
		iStart	= pRect->left;

		pDc->Rectangle(iStart       ,iPos,iStart+2       ,iEnd);
		pDc->SelectStockObject(WHITE_BRUSH);
		pDc->Rectangle(iStart+1     ,iPos,iStart+3       ,iEnd);
		pDc->SelectObject(GetSysColorBrush(COLOR_3DFACE));
		pDc->Rectangle(iStart+2     ,iPos,iStart+iSize+3 ,iEnd);
 		pDc->SelectObject(GetSysColorBrush(COLOR_3DSHADOW));
		pDc->Rectangle(iStart+iSize  ,iPos,iStart+iSize+2,iEnd);
		pDc->SelectStockObject(BLACK_BRUSH);
		pDc->Rectangle(iStart+iSize+1,iPos,iStart+iSize+3,iEnd);
		}


	pDc->SelectObject(hOldBrush);
	pDc->SelectObject(hOldPen);

}
