//*****************************************************************************
//*
//*
//*		SizeBar.h
//*
//*
//*****************************************************************************
//	
//	Mit dieser Klasse kann man ControlBars erzeugen deren Gre 
//	vernderbar sind, und die neben einander dockbar sind.
//	
//	Mit einem #define auf CBaseControlBarClass kann man die Basisklasse CControlBar ndern
//	Mit einem #define auf CBaseDockFrameClass  kann man die Basisklasse CMiniDockFrameWnd ndern
//	
//
//	SCB_REPLACE_MINIFRAME	Soll die Klasse CMiniDockFrameWnd ausgetaucht 
//							werden damit nicht angedockte Fenster Gren 
//							verndert werden knnen wie normale Fenster
//
//	CBRS_SIZE_DYNAMIC		Muss immer gesetzt sein
//
//
//*****************************************************************************
//
//	Ableiten einer eigenen Klasse:
//
//
// 		BEGIN_MESSAGE_MAP(CMyBar, baseCMyBar)
// 			//{{AFX_MSG_MAP(CMyBar)
// 			ON_WM_CREATE()
// 			//}}AFX_MSG_MAP
// 		END_MESSAGE_MAP()
// 
// 		CMyBar::CMyBar()
// 		{
// 		}
// 
// 		CMyBar::~CMyBar()
// 		{
// 		}
// 
// 		int CMyBar::OnCreate(LPCREATESTRUCT lpCreateStruct)
// 		{
// 			if(baseCMyBar::OnCreate(lpCreateStruct) == -1)
// 				{
// 				return -1;
// 				}
// 
// 			SetBarStyleEx(GetBarStyleEx() | SCBS_SHOWEDGES | SCBS_SIZECHILD);
// 
// 			if(!m_wndChild.Create(WS_CHILD|WS_VISIBLE|ES_MULTILINE|ES_WANTRETURN|ES_AUTOVSCROLL,CRect(0,0,0,0),this,123))
//				{
// 				return -1;
//				}
// 
// 			m_wndChild.ModifyStyleEx(0,WS_EX_CLIENTEDGE);
// 
// 			if(!m_font.CreateStockObject(DEFAULT_GUI_FONT))
// 			if(!m_font.CreatePointFont(80, "MS Sans Serif"))
// 				{
// 				return -1;
// 				}
// 
// 			m_wndChild.SetFont(&m_font);
// 
// 		return 0;
// 		}
// 
// 
//*****************************************************************************
//
//	So wird CSizeBar in MainFrm.cpp verwendet:
//
//
//		int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
// 		{
// 	
// 			...
//			
//			if(!m_wndMyBar.Create("Name des Fensters",this,123))	<--- Achtung keine geleichen ID's verwenden	
//				{
//				TRACE0("Failed to create mybar\n");
//				return -1;											
//				}
//			
//			...
//			
//			EnableDocking(CBRS_ALIGN_ANY);
//			
//			...
//			
//			m_wndMyBar.EnableDocking(CBRS_ALIGN_ANY);				<--- Bestimmen wo die Bar andocken kann
//			
//			DockControlBar(&m_wndMyBar,AFX_IDW_DOCKBAR_LEFT);		<--- Bar andocken und standard Seite angeben
//			
//			...
//			
//			m_wndMyBar.LoadBarState("BarState");					<--- Laden des letzten Layouts
//					   LoadBarState("BarState");
//
//		}
//	
//		BOOL CMainFrame::DestroyWindow()
//		{
//		
//			m_wndMyBar.SaveBarState("BarState");					<--- Speichern des aktuellen Layouts
//					   SaveBarState("BarState");
//		
//		return CFrameWnd::DestroyWindow();
//		}
//		
//		
//*****************************************************************************
//	
//	Weitere Infos unter http://www.codeproject.com/docking/sizecbar.asp
//		
		

#ifndef		__SIZECBAR_H__
#define		__SIZECBAR_H__				

#include	<AfxPriv.h> 
#include	<AfxTempl.h>

#if _MSC_VER >= 1000
#pragma once
#endif

//#define		SCB_REPLACE_MINIFRAME		

#if defined(SCB_MINIFRAME_CAPTION) && !defined(SCB_REPLACE_MINIFRAME)
#error     "SCB_MINIFRAME_CAPTION requires SCB_REPLACE_MINIFRAME"
#endif

// Konstanten fr CSizeBarBase 
#define		SCBS_EDGELEFT				0x00000001
#define		SCBS_EDGERIGHT				0x00000002
#define		SCBS_EDGETOP				0x00000004
#define		SCBS_EDGEBOTTOM 			0x00000008
#define		SCBS_EDGEALL				0x0000000F
#define		SCBS_SHOWEDGES				0x00000010
#define		SCBS_SIZECHILD				0x00000020

#define 	CBRS_CLOSEBUTTON			CBRS_HIDE_INPLACE	// Eine Close-Teste einfgen
#define		CBRS_FIXEDHORZ				0x00080000
#define		CBRS_FIXEDVERT				0x00040000

#ifndef		CBaseDockFrameClass	
#define		CBaseDockFrameClass			CMiniDockFrameWnd
#endif

#ifndef		CBaseControlBarClass		
#define		CBaseControlBarClass		CControlBar
#endif

#ifndef		CBaseSizeBarClass		
#define		CBaseSizeBarClass			CSizeBarBase
#endif

class	CSizeBarBase;
typedef CTypedPtrArray <CPtrArray,CSizeBarBase*> CSizeArray;


//*****************************************************************************
//*
//*		Klasse CSizeDockBar
//*
//*****************************************************************************
//	CSizeDockBar dummy class for access to protected members

class CSizeDockBar : public CDockBar
{
	friend class CSizeBarBase;
};



//*****************************************************************************
//*
//*		CSizeBarBase
//*
//*****************************************************************************
class CSizeBarBase : public CBaseControlBarClass
{
	DECLARE_DYNAMIC(CSizeBarBase);

protected:

	DWORD	m_dwStyleLock;
	DWORD	m_dwBarStyle;

public:
	CSizeBarBase();

	virtual BOOL Create(LPCTSTR pWindowName,CWnd* pParentWnd,CSize sizeDefault,UINT nID,DWORD dwStyle = WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_SIZE_DYNAMIC);
	virtual BOOL Create(LPCTSTR pWindowName,CWnd* pParentWnd,                  UINT nID,DWORD dwStyle = WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_SIZE_DYNAMIC);
	        BOOL Create(                    CWnd* pParentWnd,CSize sizeDefault,UINT nID,DWORD dwStyle = WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_SIZE_DYNAMIC);
	        BOOL Create(                    CWnd* pParentWnd,                  UINT nID,DWORD dwStyle = WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_SIZE_DYNAMIC);


public:
	const   BOOL IsFloating    () const;
	const   BOOL IsHorzDocked  () const;
	const   BOOL IsVertDocked  () const;
	const   BOOL IsSideTracking() const;
	const   BOOL GetBarStyleEx () const {return m_dwBarStyle;}
	const   BOOL GetLockStyle  () const {return m_dwStyleLock;}

	
public:

	#if defined(SCB_REPLACE_MINIFRAME) && !defined(SCB_MINIFRAME_CAPTION)
	void EnableDocking(DWORD dwDockStyle);
	#endif

	virtual void LoadBarState   (LPCTSTR    pProfileName);
	virtual void SaveBarState   (LPCTSTR    pProfileName);
	static  void GlobalLoadState(CFrameWnd *pFrame, LPCTSTR pProfileName);
	static  void GlobalSaveState(CFrameWnd *pFrame, LPCTSTR pProfileName);
	virtual void OnUpdateCmdUI  (CFrameWnd *pTarget,BOOL    bDisableIfNoHndler);
			void SetBarStyleEx  (DWORD      dwNewStyle){m_dwBarStyle  = (dwNewStyle & ~SCBS_EDGEALL);}
			void SetLockStyle   (DWORD      dwNewStyle){m_dwStyleLock =  dwNewStyle;}

public:

	//{{AFX_VIRTUAL(CSizeBarBase)
public:
	virtual CSize CalcFixedLayout(BOOL bStretch, BOOL bHorz);
	virtual CSize CalcDynamicLayout(int nLength, DWORD dwMode);
	//}}AFX_VIRTUAL
	
public:

	virtual ~CSizeBarBase();

protected:

	UINT			GetEdgeHTCode(int nEdge);
	BOOL			GetEdgeRect(CRect rcWnd, UINT nHitTest, CRect& rcEdge);
	void			DrawSizeRect(CDC *pDc,CRect *pRect,BOOL bHorz);						
	virtual void 	StartTracking(UINT nHitTest, CPoint sPoint);
	virtual void 	StopTracking();
	virtual void 	OnTrackUpdateSize(CPoint& point);
	virtual void 	OnTrackInvertTracker();
	virtual void 	NcPaintGripper(CDC *pDC, CRect rcClient);
	virtual void 	NcCalcClient(LPRECT pRc, UINT nDockBarID);
	virtual void	DelayShow(BOOL bShow);
	virtual void	AlignControlBars();
			void 	GetRowInfo(int& nFirst, int& nLast, int& nThis);
			void 	GetRowSizingBars(CSizeArray& arrSCBars);
			void 	GetRowSizingBars(CSizeArray& arrSCBars, int& nThis);
			BOOL 	NegotiateSpace(int nLengthTotal, BOOL bHorz);

protected:


	UINT	m_uEdge;
	CSize	m_szNow;
	CSize	m_szHorz;
	CSize	m_szVert;
	CSize	m_szFloat;
	CSize	m_szMinHorz;
	CSize	m_szMinVert;
	CSize	m_szMinFloat;
	int		m_nTrackPosMin;
	int		m_nTrackPosMax;
	int		m_nTrackPosOld;
	int		m_nTrackEdgeOfs;
	BOOL	m_bThisTracking;
	BOOL	m_bShowLast;
	BOOL	m_bShowFlag;
	BOOL	m_bDoTracking;
	BOOL	m_bTracking;
	BOOL	m_bKeepSize;
	BOOL	m_bParentSizing;
	BOOL	m_bDragShowContent;
	UINT	m_nDockBarID;
	UINT	m_nBarID;
	int		m_iFixedHorz;
	int		m_iFixedVert;
	int		m_iGripper;
	int		m_iClose;
	int		m_cxEdge;

protected:

	//{{AFX_MSG(CSizeBarBase)
	afx_msg LRESULT OnNcHitTest(CPoint sPoint);
	afx_msg int  OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg void OnNcPaint();
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS FAR* pNcsp);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	afx_msg void OnSettingChange(UINT uFlags, LPCTSTR lpszSection);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint sPoint);
	afx_msg void OnMouseMove(UINT nFlags, CPoint sPoint);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint sPoint);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint sPoint);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint sPoint);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint sPoint);
	afx_msg void OnWindowPosChanging(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnPaint();
	afx_msg void OnClose();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg LRESULT OnSetText(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()

	#ifdef		SCB_REPLACE_MINIFRAME	
	friend class CMiniDockFrameWnd;
	#endif
};

#ifdef		SCB_REPLACE_MINIFRAME		
#ifndef		SCB_MINIFRAME_CAPTION		



//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class CSCBDockContext : public CDockContext
{
public:

	CSCBDockContext(CControlBar* pBar) : CDockContext(pBar) {}

	virtual void StartDrag(CPoint pPoint);
};
#endif



//*****************************************************************************
//*
//*		Klasse CMiniDockFrameWnd
//*
//*****************************************************************************
class CSizeDockFrameWnd : public CBaseDockFrameClass
{
	DECLARE_DYNCREATE(CMiniDockFrameWnd)


	//{{AFX_VIRTUAL(CMiniDockFrameWnd)
public:
	virtual BOOL Create(CWnd *pParent, DWORD dwBarStyle);
	//}}AFX_VIRTUAL

public:

	CSizeBarBase* GetSizingControlBar();

	//{{AFX_MSG(CMiniDockFrameWnd)
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint sPoint);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnWindowPosChanging(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
#endif





//*****************************************************************************
//*
//*		Klasse CSizeBarButton
//*
//*****************************************************************************
class CSizeBarButton
{
public:

	CSizeBarButton();

	void			Move(CPoint pTo) {pOrg = pTo; };
	CRect			GetRect() { return CRect(pOrg, CSize(11,11)); };
	void			Paint(CDC *pDC);

	BOOL			bPushed;
	BOOL			bRaised;

protected:

	CPoint			pOrg;
};




//*****************************************************************************
//*
//*		Klsaae CSizeBar
//*
//*****************************************************************************
class CSizeBar : public CBaseSizeBarClass
{
	DECLARE_DYNAMIC(CSizeBar);

public:
			 CSizeBar();
	virtual ~CSizeBar();
	virtual  BOOL HasGripper() const;
	virtual  void OnUpdateCmdUI(CFrameWnd* pTarget,BOOL bDisableIfNoHndler);

public:
	//{{AFX_VIRTUAL(CSizeBar)
	//}}AFX_VIRTUAL

protected:

	virtual void NcPaintGripper(CDC *pDC, CRect rcClient);
	virtual void NcCalcClient(LPRECT pRc, UINT nDockBarID);

	int				m_cyGripper;
	CSizeBarButton	m_bHide;

protected:

	//{{AFX_MSG(CSizeBar)
	afx_msg LRESULT OnNcHitTest(CPoint sPoint);
	afx_msg void    OnNcLButtonUp(UINT nHitTest,CPoint sPoint);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	const BOOL CSizeBarBase::IsFloating  () const{return !IsHorzDocked() && !IsVertDocked();}
inline	const BOOL CSizeBarBase::IsHorzDocked() const{return (m_nDockBarID==AFX_IDW_DOCKBAR_TOP  || m_nDockBarID==AFX_IDW_DOCKBAR_BOTTOM);}
inline	const BOOL CSizeBarBase::IsVertDocked() const{return (m_nDockBarID==AFX_IDW_DOCKBAR_LEFT || m_nDockBarID==AFX_IDW_DOCKBAR_RIGHT );}
inline	      BOOL CSizeBarBase::Create(CWnd* pParentWnd,CSize sizeDefault,UINT nID,DWORD dwStyle){return Create(_T(""),pParentWnd,sizeDefault,nID,dwStyle);}
inline	      BOOL CSizeBarBase::Create(CWnd* pParentWnd,                  UINT nID,DWORD dwStyle){return Create(_T(""),pParentWnd,            nID,dwStyle);}


#endif

