//*****************************************************************************
//*
//*
//*		ToolBarExWnd.h
//*
//*
//*****************************************************************************
#ifndef 	__TOOLBAREXWND_H__
#define 	__TOOLBAREXWND_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	<commctrl.h>

#ifndef	   _WIN64
#ifndef		DWORD_PTR
#define		DWORD_PTR				DWORD
#endif
#endif		


#define 	TBSTYLE_PACKED			0x00000020			// Vertikal stapeln ist erlaut
#define		TB_IMAGENONE			(-1)				// Bild nicht benutzt
#define 	TB_SENDCB			   ((HWND)0xFFFFFFFF)	// Send-Callback benutzen    (fr TB_SETPARENT)
#define 	TB_EXTENDED				0x12340000			// Erweiterte Parameter fr  (fr TB_ADDBITMAP)
#define 	TB_ENDINDEX				0x000053FF			// Tasten am Ende einfgen   (fr TB_ADDBUTTON??)
#define 	TB_ISHBITMAP			0x0000FFFF			// HBITMAP wurde bergeben   (fr TB_CALCPICCOUNT)
#define 	TB_FROMLIST				0x0000FFFF			// Separator erstes Zeichen  (fr TB_ADDSTRING)
#define 	TB_SINGLETEXT			0x0000FFFE			// Es ist ein einzelner Text (fr TB_ADDSTRING)
#define 	TB_ONLYSTATE			0x000073C3			// Nur den State setzen      (fr TB_SETSTYLESTATE)
#define 	TB_VARSIZE				0x00000FFE			// Das Bitmap hat eine vraiable Gre
#define 	TB_NOCOLOR				0xFFFFFFFF			// Standartfarbe
#define 	TB_NOFRAME				0xFFFFFFFE			// Keinen Rahmen um TAG's zeichnen
#define 	TB_ID_FIRST				0x000074B0			// Erste ID fr ein Control
#define 	TB_ID_LAST				(TB_ID_FIRST+TB_MAX_CONTROLS-1)
#define 	TB_SPECIAL(i)			(((i)>>24)==0x12)	// Ist es ein Spezialindex
#define 	TB_MAX_CONTROLS			64

#define 	TB_ADDINDEX(i)			(0x00005000|(WORD)(i))// Tasten Index fr TB_ADDBUTTON??
#define 	TB_USE_ID(i)			(0x12480000|(WORD)(i))// Index aus Command-ID holen
#define 	TB_USE_INDEX(i)			(0x12340000|(WORD)(i))// Index aus LOWORD holen
#define 	TB_USE_TAG(i)			(0x12220000|(WORD)(i))// Index aus TagID holen
#define 	TB_USE_NID(i,n)			(0x12800000|(WORD)(i)|(((n)&0x7F)<<16))
#define 	TB_USE_FLAG(f,n)		(0x12800000|(WORD)((f&0xF000)|0x0E7E)|(((n)&0x7F)<<16))

#ifndef 	TBIF_BYINDEX
#define		TBIF_BYINDEX            0x80000000			// Daten via Index holen
#endif
#define		TBIF_RECT				0x40000000			// In den Infos ist das absolute Rechteck gltig
#define		TBIF_RECTSIZE			0x20000000			// In den Infos ist das Rechteck als Gre gltig
#define		TBIF_FLAGS              0x10000000			// In den Infos sind die Flags gltig
#define		TBIF_STRINGID           0x08000000			// In den Infos ist die String-ID gltig (pszText)

// Konstanten fr Farben (TB_SETCOLOR)
#define 	TBC_BK					0					// Hintergrundfarbe
#define 	TBC_GROUP				1					// Farbe fr Gruppentext
#define 	TBC_TEXT				2					// Textfarbe
#define 	TBC_HOT					3					// Hintergrundfarbe wenn gewhlt
#define 	TBC_HOTEX				4					// Hintergrundfarbe wenn gewhlt (verlaufend)
#define 	TBC_MARK				5					// Farbe fr Marke
#define 	TBC_TAGBK				6					// Hintergund fr TAG's
#define 	TBC_TAGTEXT				7					// Text fr TAG's
#define 	TBC_TAGFRAME			8					// Rand fr TAG's

// Konstanten fr Flags aus TBTAGITEM
#define 	TBTF_LEFT				0x00000000			// TAG links  ausurichten
#define 	TBTF_CENTER				0x00000001			// TAG mittig ausurichten
#define 	TBTF_RIGHT				0x00000002			// TAG rechts ausurichten
#define 	TBTF_TOP				0x00000000			// TAG oben   ausurichten
#define 	TBTF_VCENTER			0x00000004			// TAG mittig ausurichten
#define 	TBTF_BOTTOM				0x00000008			// TAG unten  ausurichten
#define 	TBTF_DELEXIST			0x00000020			// TAG ein existierntes TAG lschen
#define 	TBTF_USEID				0x00000040			// TAG hat statt Index eine ID
#define 	TBTF_RECALC				0x00000080			// TAG Position neu berechnen

// Konstanten fr Optionen (TB_GETSETOPTION)
#define 	TBOP_AUTOEXPANDOFF		0x00000001			// Icon Offset fr TVS_EX_AUTOEXPANDICON
#define 	TBOP_WRITEOPTION		0x80000000			// Die Option auch schreiben
#define 	TBOP_CANGECOLOOR1		0x00000000			// Erste Farbe fr Farb-Icons
#define 	TBOP_CANGECOLOOR2		0x00000001			// Zweite Farbe fr Farb-Icons

// Konstanten fr Dual-Farben
#define 	TBC_C16_TO_RGB(c)		((((c)&0x00001F)<<3)|(((c)&0x0007E0)<<5)|(((c)&0x00F800)<<8))
#define 	TBC_RGB_TO_C16(c)		((((c)&0x0000F8)>>3)|(((c)&0x00FC00)>>5)|(((c)&0xF80000)>>8))

// Konstanten fr wFlags in TBBUTTONEX
#define		BTFL_TEXT_RIGHT			0x00000001			// Den Text immer links anzeigen
#define		BTFL_TEXT_BOTTOM		0x00000002			// Den Text immer unten anzeigen
#define		BTFL_TEXT_INNER			0x00000004			// Den Text in der Taste anzeigen
#define		BTFL_FORCE_FLAT			0x00000008			// Die Taste immer flach zeichnen
#define		BTFL_FORCE_LIFTED		0x00000010			// Die Taste immer erhoben zeichnen
#define		BTFL_NOT_SUNKEN			0x00000020			// Die Taste wird nie gedrckt gezeichnet
#define		BTFL_NOT_GRAYED			0x00000040			// Die Taste wird nie ausgegraut gezeichnet
#define		BTFL_NOT_HOT			0x00000080			// Die Taste wird nie ausgegraut gezeichnet
#define		BTFL_NOT_PACKING		0x00000100			// Die Taste nicht vertikal stabeln
#define		BTFL_GROUP_TEXT			0x00000200			// Der Separator hat einen Gruppentext
#define		BTFL_TEXT_SIZE			0x00000200			// Die Taste hat einen minimale Textbreite
#define		BTFL_RIGHT_CLICK		0x00000400			// Die Taste kann mit der Rechts gedrckt werden
#define		BTFL_COLOR_DUAL			0x00000800			// Zwei Farben im Image knnen getauscht werden
#define		BTFL_COLOR_CHANGE		0x00001000			// Eine Farbe im Image kann getauscht werden
#define		BTFL_CONTROL			0x00002000			// Die Taste ist ein extrenes Control
#define		BTFL_RADIO				0x00004000			// Es wird eine CheckBox gezeichnet
#define		BTFL_CHECKBOX			0x00008000			// Es wird eine CheckBox gezeichnet

// Konstanten fr fsStyle in TBBUTTONEX
#ifndef		BTNS_CHECK
#define 	BTNS_CHECK				TBSTYLE_CHECK
#endif
#ifndef		BTNS_BUTTON
#define 	BTNS_BUTTON				TBSTYLE_BUTTON
#endif
#ifndef		BTNS_AUTOSIZE
#define 	BTNS_AUTOSIZE			TBSTYLE_AUTOSIZE
#endif
#ifndef		BTNS_CHECKGROUP
#define 	BTNS_CHECKGROUP			TBSTYLE_CHECKGROUP
#endif
#ifndef		BTNS_NOPREFIX
#define 	BTNS_NOPREFIX			TBSTYLE_NOPREFIX
#endif
#ifndef		BTNS_DROPDOWN
#define 	BTNS_DROPDOWN			TBSTYLE_DROPDOWN
#endif
#ifndef		BTNS_GROUP
#define 	BTNS_GROUP				TBSTYLE_GROUP
#endif
#ifndef		BTNS_SEP
#define 	BTNS_SEP				TBSTYLE_SEP
#endif
#ifndef 	BTNS_SHOWTEXT
#define		BTNS_SHOWTEXT			0x40
#endif
#ifndef 	BTNS_GROUPSTART
#define		BTNS_GROUPSTART			0x80
#endif

// Konstanten fr neue Nachrichten
#define 	TB_SETCOLOR				(WM_USER+160-11)
#define 	TB_GETSETOPTION			(WM_USER+160-12)
#define 	TB_ADDBUTTONSEX			(WM_USER+160-13)
#define 	TB_INSERTBUTTONEX		(WM_USER+160-14)
#define 	TB_CALCFRAME			(WM_USER+160-15)
#define 	TB_GETFRAME				(WM_USER+160-16)
#define 	TB_SETSCALING			(WM_USER+160-17)
#define 	TB_SETPARAM				(WM_USER+160-18)
#define 	TB_GETPARAM				(WM_USER+160-19)
#define 	TB_SETFLAGS				(WM_USER+160-20)
#define 	TB_GETFLAGS				(WM_USER+160-21)
#define 	TB_INDEXTOCOMMAND		(WM_USER+160-22)
#define 	TB_GETBITMAPSIZE		(WM_USER+160-23)
#define 	TB_GETSENDWND			(WM_USER+160-24)
#define 	TB_DELETEBUTTONS		(WM_USER+160-25)
#define 	TB_DELBITMAPS			(WM_USER+160-26)
#define 	TB_GETIDLIST			(WM_USER+160-27)
#define 	TB_GETBITMAPINFO		(WM_USER+160-28)
#define 	TB_CALCPICCOUNT			(WM_USER+160-29)
#define 	TB_CHANGEFLAGS			(WM_USER+160-30)
#define 	TB_CHANGESTATE			(WM_USER+160-31)
#define 	TB_CHANGESTYLE			(WM_USER+160-32)
#define 	TB_COUNTITEMS			(WM_USER+160-33)
#define 	TB_GETSTRINGCOUNT		(WM_USER+160-34)
#define 	TB_FINDSTRINGA			(WM_USER+160-35)
#define 	TB_FINDSTRINGW			(WM_USER+160-36)
#define 	TB_DELSTRINGS			(WM_USER+160-37)
#define 	TB_GETSTRINGID			(WM_USER+160-38)
#define 	TB_SETSTRINGID			(WM_USER+160-39)
#define 	TB_GETBITMAPID			(WM_USER+160-40)
#define 	TB_SETBITMAPID			(WM_USER+160-41)
#define 	TB_GETCOMMANDID			(WM_USER+160-42)
#define 	TB_SETCOMMANDID			(WM_USER+160-43)
#define 	TB_GETSTYLESTATE		(WM_USER+160-44)
#define 	TB_SETSTYLESTATE		(WM_USER+160-45)
#define 	TB_SETBUTTONSTRINGA		(WM_USER+160-46)
#define 	TB_SETBUTTONSTRINGW		(WM_USER+160-47)
#define 	TB_FINDCONTROL			(WM_USER+160-48)
#define 	TB_SETTEXTSIZE			(WM_USER+160-49)
#define 	TB_RECACLLAYOUT			(WM_USER+160-50)
#define 	TB_INSERTTAGA			(WM_USER+160-51)
#define 	TB_INSERTTAGW			(WM_USER+160-52)
#define 	TB_DELETETAG			(WM_USER+160-53)
#define 	TB_TIMER				(WM_USER+160-54)

#ifndef 	TB_SETLISTGAP
#define		TB_SETLISTGAP           (WM_USER+96)
#endif
#ifndef 	TB_GETSTRINGW
#define		TB_GETSTRINGW			(WM_USER+91)
#endif
#ifndef 	TB_GETSTRINGA
#define		TB_GETSTRINGA           (WM_USER+92)
#endif
#ifndef 	TB_GETSTRING
#ifdef		UNICODE
#define		TB_GETSTRING			TB_GETSTRINGW
#else
#define		TB_GETSTRING            TB_GETSTRINGA
#endif
#endif
#ifdef		UNICODE
#define		TB_INSERTTAG			TB_INSERTTAGW
#define 	TB_FINDSTRING			TB_FINDSTRINGW
#define 	TB_SETBUTTONSTRING		TB_SETBUTTONSTRINGW
#else
#define		TB_INSERTTAG			TB_INSERTTAGA
#define 	TB_FINDSTRING			TB_FINDSTRINGA
#define 	TB_SETBUTTONSTRING		TB_SETBUTTONSTRINGA
#endif


#define		ToolBarEx_GetStyle(h)						((DWORD   )::GetWindowLong(h,GWL_STYLE))
#define		ToolBarEx_SetStyle(h,d)	  					((DWORD   )::SetWindowLong(h,GWL_STYLE,d))
#define 	ToolBarEx_SetStyleEx(h,d,m)					((DWORD   )::SetWindowLong(h,GWL_STYLE,((d)&(m))|(::GetWindowLong(h,GWL_STYLE)&~(m))))
#define 	ToolBarEx_SetOption(h,i,o)					((INT     )::SendMessage(h,TB_GETSETOPTION,(i)|TBOP_WRITEOPTION,(LPARAM)(o)))
#define 	ToolBarEx_GetOption(h,i)					((INT     )::SendMessage(h,TB_GETSETOPTION,i,0))
#define		ToolBarEx_GetFlags(h,i)						((INT     )::SendMessage(h,TB_GETFLAGS,i,0))
#define		ToolBarEx_SetFlags(h,i,f,m)	 				((INT     )::SendMessage(h,TB_SETFLAGS,i,MAKELONG(f,m)))
#define		ToolBarEx_GetParam(h,i)						((LRESULT )::SendMessage(h,TB_GETPARAM,i,0))
#define		ToolBarEx_SetParam(h,i,p)	 				((LRESULT )::SendMessage(h,TB_SETPARAM,i,(LPARAM)(p)))
#define		ToolBarEx_GetBitmapId(h,i)					((INT     )::SendMessage(h,TB_GETBITMAPID,i,0))
#define		ToolBarEx_SetBitmapId(h,i,v)		 		((INT     )::SendMessage(h,TB_SETBITMAPID,i,v))
#define		ToolBarEx_GetStringId(h,i)					((INT     )::SendMessage(h,TB_GETSTRINGID,i,0))
#define		ToolBarEx_SetStringId(h,i,v)	 			((INT     )::SendMessage(h,TB_SETSTRINGID,i,v))
#define		ToolBarEx_GetCommandId(h,i)					((INT     )::SendMessage(h,TB_GETCOMMANDID,i,0))
#define		ToolBarEx_SetCommandId(h,i,v)	 			((INT     )::SendMessage(h,TB_SETCOMMANDID,i,v))
#define		ToolBarEx_GetStyleState(h,i)				((INT     )::SendMessage(h,TB_GETSTYLESTATE,i,0))
#define		ToolBarEx_SetStyleState(h,i,s,m,t,n)		((INT     )::SendMessage(h,TB_SETSTYLESTATE,i,MAKELONG(MAKEWORD(s,m),MAKEWORD(t,n))))
#define		ToolBarEx_SetStyleStateEx(h,i,v)			((INT     )::SendMessage(h,TB_SETSTYLESTATE,i,((v)&0x00FF00FF)|0xFF00FF00))
#define		ToolBarEx_SetStyleStateMask(h,i,v,m)		((INT     )::SendMessage(h,TB_SETSTYLESTATE,i,((v)&0x00FF00FF)|(((m)&0x00FF00FF)<<8)))
#define		ToolBarEx_GetStateByte(h,i)					((INT     )::SendMessage(h,TB_GETSTYLESTATE,i,0))
#define		ToolBarEx_SetStateByte(h,i,t,n)				((INT     )::SendMessage(h,TB_SETSTYLESTATE,i,MAKELONG(MAKEWORD(t,n),TB_ONLYSTATE)))
#define		ToolBarEx_GetStyleByte(h,i)					((INT     )::SendMessage(h,TB_GETSTYLESTATE,i,0))
#define		ToolBarEx_SetStyleByte(h,i,s,m)				((INT     )::SendMessage(h,TB_SETSTYLESTATE,i,MAKEWORD(s,m)))
#define		ToolBarEx_SetColor(h,i,c)					((COLORREF)::SendMessage(h,TB_SETCOLOR,i,c))
#define		ToolBarEx_ButtonCount(h)					((INT     )::SendMessage(h,TB_BUTTONCOUNT,0,0))
#define		ToolBarEx_ChangeFlags(h,f,m,i,u)			((INT     )::SendMessage(h,TB_CHANGEFLAGS,MAKELONG(i,u),MAKELONG(f,m)))
#define		ToolBarEx_ChangeStyle(h,f,m,i,u)			((INT     )::SendMessage(h,TB_CHANGESTYLE,MAKELONG(i,u),MAKELONG(f,m)))
#define		ToolBarEx_ChangeState(h,f,m,i,u)			((INT     )::SendMessage(h,TB_CHANGESTATE,MAKELONG(i,u),MAKELONG(f,m)))
#define		ToolBarEx_AddButtonsEx(h,i,n,p)				((BOOL    )::SendMessage(h,TB_ADDBUTTONSEX,MAKELONG(n,TB_ADDINDEX(i)),(LPARAM)(p)))
#define		ToolBarEx_AddButtons(h,i,n,p)				((BOOL    )::SendMessage(h,TB_ADDBUTTONS  ,MAKELONG(n,TB_ADDINDEX(i)),(LPARAM)(p)))
#define		ToolBarEx_CalcFrame(h,w,f)					((INT     )::SendMessage(h,TB_CALCFRAME,w,f))
#define		ToolBarEx_GetScaling(h)						((INT     )::SendMessage(h,TB_SETSCALING,0xFFFFFFFF,0xFFFFFFFF))
#define		ToolBarEx_SetScaling(h,s)					((INT     )::SendMessage(h,TB_SETSCALING,0xFFFFFFFF,s))
#define		ToolBarEx_GetBitmapScaling(h,n)				((INT     )::SendMessage(h,TB_SETSCALING,n,0xFFFFFFFF))
#define		ToolBarEx_SetBitmapScaling(h,n,s)			((INT     )::SendMessage(h,TB_SETSCALING,n,s))
#define 	ToolBarEx_DeleteButton(h,i)					((BOOL    )::SendMessage(h,TB_DELETEBUTTON,i,0))
#define		ToolBarEx_DelButtons(h,f,u)					((INT     )::SendMessage(h,TB_DELETEBUTTONS,f,u))
#define		ToolBarEx_DelBitmaps(h)						((INT     )::SendMessage(h,TB_DELBITMAPS,0,0))
#define		ToolBarEx_GetIdList(h,n,p)					((INT     )::SendMessage(h,TB_GETIDLIST,n,(LPARAM)(p)))
#define		ToolBarEx_AddBitmap(h,i,p)					((INT     )::SendMessage(h,TB_ADDBITMAP,i,(LPARAM)(p)))
#define		ToolBarEx_CountItems(h,i,u,f,m)				((INT     )::SendMessage(h,TB_COUNTITEMS,MAKELONG(i,u),MAKELONG(f,m)))
#define		ToolBarEx_CommandToIndex(h,i)				((INT     )::SendMessage(h,TB_COMMANDTOINDEX,i,0))
#define 	ToolBarEx_IndexToCommand(h,i)				((INT     )::SendMessage(h,TB_INDEXTOCOMMAND,i,0))
#define		ToolBarEx_CalcPicCount(h,q,p)				((INT     )::SendMessage(h,TB_CALCPICCOUNT,(WPARAM)(q),(LPARAM)(p)))
#define		ToolBarEx_GetBitmapInfo(h,i,n,p)			((INT     )::SendMessage(h,TB_GETBITMAPINFO,MAKELONG(i,n),(LPARAM)(p)))
#define		ToolBarEx_ReplaceBitmap(h,s,p)				((INT     )::SendMessage(h,TB_REPLACEBITMAP,s,(LPARAM)(p)))
#define 	ToolBarEx_SetListGap(h,x,y)					((INT     )::SendMessage(h,TB_SETLISTGAP,x,y))
#define 	ToolBarEx_SetInsertMark(h,p)				((INT     )::SendMessage(h,TB_SETINSERTMARK,0,(LPARAM)(p)))
#define 	ToolBarEx_GetStringCount(h)					((INT     )::SendMessage(h,TB_GETSTRINGCOUNT,0,0))
#define 	ToolBarEx_GetFrame(h)						((INT     )::SendMessage(h,TB_GETFRAME,0,0))
#define 	ToolBarEx_SetParent(h,i,w)					((INT     )::SendMessage(h,TB_SETPARENT,(WPARAM)(w),TB_EXTENDED|(i)))
#define 	ToolBarEx_IsButtonPressed(h,i)				((INT     )::SendMessage(h,TB_ISBUTTONPRESSED,i,0))
#define 	ToolBarEx_IsButtonIndeterminate(h,i)		((INT     )::SendMessage(h,TB_ISBUTTONINDETERMINATE,i,0))
#define 	ToolBarEx_IsButtonHighlighted(h,i)			((INT     )::SendMessage(h,TB_ISBUTTONHIGHLIGHTED,i,0))
#define 	ToolBarEx_IsButtonEnabled(h,i)				((INT     )::SendMessage(h,TB_ISBUTTONENABLED,i,0))
#define 	ToolBarEx_IsButtonChecked(h,i)				((INT     )::SendMessage(h,TB_ISBUTTONCHECKED,i,0))
#define 	ToolBarEx_IsButtonHidden(h,i)				((INT     )::SendMessage(h,TB_ISBUTTONHIDDEN,i,0))
#define 	ToolBarEx_IndeterminateButton(h,i,v)		((INT     )::SendMessage(h,TB_INDETERMINATE,i,MAKELONG(v,0)))
#define 	ToolBarEx_EnableButton(h,i,v)				((INT     )::SendMessage(h,TB_ENABLEBUTTON,i,MAKELONG(v,0)))
#define 	ToolBarEx_PressButton(h,i,v)				((INT     )::SendMessage(h,TB_PRESSBUTTON,i,MAKELONG(v,0)))
#define 	ToolBarEx_CheckButton(h,i,v)				((INT     )::SendMessage(h,TB_CHECKBUTTON,i,MAKELONG(v,0)))
#define 	ToolBarEx_MarkButton(h,i,v)					((INT     )::SendMessage(h,TB_MARKBUTTON,i,MAKELONG(v,0)))
#define 	ToolBarEx_MarkHide(h,i,v)					((INT     )::SendMessage(h,TB_HIDEBUTTON,i,MAKELONG(v,0)))
#define 	ToolBarEx_GetString(h,i,l,v)				((INT     )::SendMessage(h,TB_GETSTRING,MAKELONG(l,i),(LPARAM)(b)))
#define 	ToolBarEx_GetState(h,i)						((INT     )::SendMessage(h,TB_GETSTATE,i,0))
#define 	ToolBarEx_GetItemRect(h,i,p)				((INT     )::SendMessage(h,TB_GETITEMRECT,i,(LPARAM)(p)))
#define 	ToolBarEx_GetRect(h,i,p)					((INT     )::SendMessage(h,TB_GETRECT,i,(LPARAM)(p)))
#define 	ToolBarEx_GetButtonText(h,i,p)				((INT     )::SendMessage(h,TB_GETBUTTONTEXT,i,(LPARAM)(p)))
#define 	ToolBarEx_GetButtonInfo(h,i,p)				((INT     )::SendMessage(h,TB_GETBUTTONINFO,i,(LPARAM)(p)))
#define 	ToolBarEx_GetBimap(h,i)						((INT     )::SendMessage(h,TB_GETBITMAP,i,0))
#define 	ToolBarEx_ChangeBimap(h,i,p)				((BOOL    )::SendMessage(h,TB_CHANGEBITMAP,i,(LPARAM)(p)))
#define 	ToolBarEx_AddString(h,m,i)					((INT     )::SendMessage(h,TB_ADDSTRING,(WPARAM)(m),MAKELONG(0,i)))
#define 	ToolBarEx_AddStringList(h,p,t)				((INT     )::SendMessage(h,TB_ADDSTRING,t,(LPARAM)(p)))
#define 	ToolBarEx_SetIndent(h,v)					((INT     )::SendMessage(h,TB_SETINDENT,v,0))
#define 	ToolBarEx_InsertButton(h,i,p)				((BOOL    )::SendMessage(h,TB_INSERTBUTTON,i,(LPARAM)(p)))
#define 	ToolBarEx_InsertButtonEx(h,i,p)				((BOOL    )::SendMessage(h,TB_INSERTBUTTON,i,(LPARAM)(p)))
#define 	ToolBarEx_ButtonStructSize(h,i,p)			((INT     )::SendMessage(h,TB_BUTTONSTRUCTSIZE,n0))
#define 	ToolBarEx_HitTest(h,p)						((INT     )::SendMessage(h,TB_HITTEST,0,(LPARAM)(p)))
#define 	ToolBarEx_SetButtomWidth(h,x,y)				((INT     )::SendMessage(h,TB_SETBUTTONWIDTH,0,MAKELONG(x,y)))
#define 	ToolBarEx_SetButtomSize(h,x,y)				((INT     )::SendMessage(h,TB_SETBUTTONSIZE,0,MAKELONG(x,y)))
#define 	ToolBarEx_GetButtomSize(h)					((INT     )::SendMessage(h,TB_GETBUTTONSIZE,0,0))
#define 	ToolBarEx_SetPadding(h,x,y)					((INT     )::SendMessage(h,TB_SETPADDING,0,MAKELONG(x,y)))
#define 	ToolBarEx_GetPadding(h,x,y)					((INT     )::SendMessage(h,TB_GETPADDING,0,0))
#define 	ToolBarEx_SetBitmapSize(h,x,y)				((INT     )::SendMessage(h,TB_SETBITMAPSIZE,0,MAKELONG(x,y)))
#define 	ToolBarEx_GetBitmapSize(h,x,y)				((INT     )::SendMessage(h,TB_GETBITMAPSIZE,0,0))
#define 	ToolBarEx_SetTooltips(h,w)					((HWND    )::SendMessage(h,TB_SETTOOLTIPS,(WPARAM)(w),0))
#define 	ToolBarEx_GetTooltips(h,w)					((HWND    )::SendMessage(h,TB_GETTOOLTIPS,0,0))
#define		ToolBarEx_DelStrings(h,i,n)					((INT     )::SendMessage(h,TB_DELSTRINGS,i,n))
#define		ToolBarEx_FindStrings(h,i,n,p)				((INT     )::SendMessage(h,TB_FINDSTRING,MAKELONG(i,n),(LPARAM)(p)))
#define		ToolBarEx_SetButtonString(h,i,p)			((INT     )::SendMessage(h,TB_SETBUTTONSTRING,i,(LPARAM)(p)))
#define		ToolBarEx_FindControl(h,w)					((INT     )::SendMessage(h,TB_FINDCONTROL,0,(LPARAM)(w)))
#define		ToolBarEx_SetTextSize(h,i,v)				((INT     )::SendMessage(h,TB_SETTEXTSIZE,i,v))
#define		ToolBarEx_ReCaclLayout(h,v,r)				((INT     )::SendMessage(h,TB_RECACLLAYOUT,v,r))
#define		ToolBarEx_InsertTag(h,i,t)					((INT     )::SendMessage(h,TB_INSERTTAG,(WPARAM)(i),(LPARAM)(t)))
#define		ToolBarEx_DeleteTag(h,i)					((INT     )::SendMessage(h,TB_DELETETAG,i,0))



typedef struct
	{
	INT			iBitmap;								// Index des Bildes (-1==keines)
	INT       	idCommand;								// ID fr WM_COMMAND
	BYTE      	fsState;								// Tasten-Status (siehe TBSTATE_???)
	BYTE      	fsStyle;								// Tasten-Style  (siehe BTNS_???)
	WORD		wFlags;									// Diverse Flags (siehe BTFL_???)
	#ifdef     _WIN64
	BYTE		bReserved[4];							// Unbenutzte Dummy-Bytes
	#endif
	DWORD_PTR	dwData;									// User-Daten fr die Taste
	INT_PTR		iString;								// Index des Textes
	}TBBUTTONEX,*LPTBBUTTONEX;

typedef struct
	{
	UINT		cbSize;									// Gre der Struktur in Byte
	DWORD     	dwMask;									// Welche Eintrge sind gltig (TBIF_IMAGE,TBIF_LPARAM...)
	int       	idCommand;								// ID der Taste
	int       	iImage;									// Unbenutzt immer auf TB_IMAGENONE
	BYTE      	fsState;								// Flags der Taste  (TBSTATE_CHECKED,TBSTATE_ENABLED,TBSTATE_PRESSED...)
	BYTE      	fsStyle;								// Styles der Taste	(BTNS_???)
	WORD      	cx;										// Breite der Taste in Pixel
	DWORD_PTR 	lParam;									// User-Parameter
	LPTSTR    	pszText;								// Zeiger auf den Text der Taste
	int       	cchText;								// Puffergre des Textes
	RECT		sRect;									// Ist das aktuelle Rechteck der Taste
	WORD		wFlags;									// Diverse Flags (siehe BTFL_???)
	WORD		wMask;									// Maske fr die Flags
	}TBBUTTONINFOEX,*LPTBBUTTONINFOEX;

typedef struct
	{
	HINSTANCE	hInstance;								// Instance-Handle der Resource (0=HBITMAP)
	DWORD_PTR	uBitmapId;								// Ist die ID des Bitmaps oder HBITMAP
	WORD		wCount;									// Anzahl der Bilder
	WORD		wScale;									// Skalierungsfaktor (256=1:1)
	WORD		wSizeX;									// Breite eines Einzelbildes (0=Varsize)
	WORD		wSizeY;									// Hhe des Bildes
	}TBBITMAPINFO,*LPTBBITMAPINFO;

typedef struct
	{
    HINSTANCE	hInst;									// Instance-Handle der Resource (0=HBITMAP)
    DWORD_PTR	nID;									// Ist die ID des Bitmaps oder HBITMAP
	WORD		wFlags;									// Diverse Flags (Bit0=AutoType Bit1=Count aus Breite Bit2=HBITMAP lschen Bit3=Count holen Bit4=Breite holen Bit5=Hhe nach wScale)
	WORD		wCount;									// Anzahl der Bilder in der Bitmap-Resource (Rckgabewert)
	WORD		wWidth;									// Hhe der Icons
	WORD		wScale;									// Skalierungsfaktor (256=1:1)
	}TBADDBITMAPEX,*LPTBADDBITMAPEX;

typedef struct
	{
	UINT		uIndex;									// Index oder ID der Taste fr das TAG
	SHORT		sDeltaX;								// Offset zum Icon
	SHORT		sDeltaY;								//			*
	BYTE		ucFlags;								// Diverse Flags (TBTF_???)
	BYTE		ucItemId;								// ID fr's Lschen und einfgen
	}TBTAGITEM,*LPTBTAGITEM;

int ToolbarExRegister(HINSTANCE hInstance=0);


#endif
