//*****************************************************************************
//*
//*
//*		ToolBarNew.h
//*
//*
//*****************************************************************************
#ifndef 	__TOOLBARNEW_H__
#define 	__TOOLBARNEW_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	<Afx.h>
#include	<AfxCmn.h>
#include	<AfxExt.h>
#include	"ToolBarExWnd.h"
#include	"../WinExtension.h"


#define 	ID_TOOLBAREXCTRL_DEF		0x9719				// Standart ID fr's Fenster
#define 	ID_TOOLMENU_ID				0xD000				// Standart ID fr's Context-Men
#define 	AFX_TB_NAMES				0x4001				// Standart String-Resource fr Context-Men

#define 	ID_TOOLMENU_SMALL			(ID_TOOLMENU_ID+0)	// Standart ID's fr's Context-Men
#define 	ID_TOOLMENU_MIDLDE			(ID_TOOLMENU_ID+1)	//		*
#define 	ID_TOOLMENU_BIG				(ID_TOOLMENU_ID+2)	//		*
#define 	ID_TOOLMENU_FLAT			(ID_TOOLMENU_ID+3)	//		*
#define 	ID_TOOLMENU_HIDE			(ID_TOOLMENU_ID+4)	//		*

#define 	CBES_MENU_SMALL				0x00010000			// Contextmen fr kleine Gre vorhanden
#define 	CBES_MENU_MIDDLE			0x00020000			// Contextmen fr mittlere Gre vorhanden
#define 	CBES_MENU_BIG				0x00040000			// Contextmen fr groe Gre vorhanden
#define 	CBES_MENU_FLAT				0x00080000			// Contextmen fr flache Toolbar vorhanden
#define 	CBES_MENU_HIDE				0x00100000			// Contextmen fr Toolbar ausblenden

#ifndef 	CNB_MAX_RSRC
#define 	CNB_MAX_RSRC				8					// Maximale Anzahl an Resourcen
#endif 	
#define 	CNB_CURRENTLIST				0x4567				// ID-Liste aus Toolbar holen
#define 	CNB_MENU_SIZE				5					// Anzahl der Eintrge im Contextmen
				   
typedef struct
	{
	HINSTANCE	hInstance;									// Instance des Bildes (0=HBITMAP)
	DWORD_PTR	uBitmapId;									// ResourceId oder Handle auf Bitmap	
	WORD		wFlags;										// Diverse Flags (Bit0=AutoType Bit1=Count aus Breite Bit2=HBITMAP lschen Bit3=Count holen)
	WORD		wScale;										// Die Skalierung fr das Bitmap
	WORD		wVersion;									// Version der Toolbar (sollte 1 sein)
	WORD		wWidth;										// Breite der Icons
	WORD		wHeight;									// Hhe   der Icons
	WORD		wItemCount;									// Anzahl der Icons
	WORD		aItems[1];									// Feld mit Icons
	}CToolBarDataEx;


//*****************************************************************************
//*
//*		CToolBarNew
//*
//*****************************************************************************
class CToolBarNew : public CToolBar
{

	DECLARE_DYNAMIC(CToolBarNew)

public:

	CToolBarNew();

	BOOL			Create		  (CWnd *pParentWnd,                               DWORD dwStyle=WS_CHILD|WS_VISIBLE|CBRS_TOP                                    ,UINT nID=AFX_IDW_TOOLBAR);
	BOOL			CreateEx	  (CWnd *pParentWnd,DWORD dwCtrlStyle=TBSTYLE_FLAT,DWORD dwStyle=WS_CHILD|WS_VISIBLE|CBRS_ALIGN_TOP,CRect sBorders=CRect(0,0,0,0),UINT nID=AFX_IDW_TOOLBAR);
					
	void			UpdateLayout  ();

	DWORD			GetStyle	  () const;
	DWORD			SetStyle	  (DWORD dwStyle);
	DWORD			SetStyle	  (DWORD dwStyle,DWORD dwMask,BOOL bRedraw=TRUE);
	BOOL			SetFlatMode	  (BOOL bFlat,BOOL bRedraw=TRUE);
	CSize			CalcSize	  (BOOL bSetSize=TRUE,int iMinX=0);
								  
	BOOL			LoadBitmap	  (LPCTSTR  pResourceName,int iWidth=0);
	BOOL			LoadBitmap 	  (UINT     nIdResource  ,int iWidth=0);
	BOOL			LoadToolBar	  (UINT     nIdResource  );
	BOOL			LoadToolBar	  (LPCTSTR  pResourceName);
	BOOL			LoadToolBar	  (LPCTSTR *pResources   ,BOOL bCopyItems,UINT *pItemList=0,int iCount=0,LPBYTE pTypes=0,UINT uScale=0);
	BOOL			LoadToolBar	  (LPCTSTR  pResourceName,BOOL bCopyItems);
					
	void			SetColors	  (int iCount,const LPWORD pIds,COLORREF *pColors,COLORREF uXchgColor=0xFFFFFFFF);
	void			SetColors	  (int iCount,int          iId ,COLORREF *pColors,COLORREF uXchgColor=0xFFFFFFFF);
	void			SetColor	  (unsigned uItem              ,COLORREF  uColor1,COLORREF uColor2   =0xFFFFFFFF);
	void			SetColorXchg  (COLORREF  uColor1,COLORREF uColor2=0xFFFFFFFF);

	BOOL			SetButtons	  (const UINT *pIdArray,int iCount);
	BOOL			SetGroup	  (int iIndex,int iCount);	
	BOOL			SetMenuText   (UINT uIndex,LPCTSTR pText);
	int				SetMenuId	  (UINT uIndex,WORD wId);
	UINT 			SetIconSize   (UINT uSize);
	UINT 			GetIconSize   () const;
					
	UINT			ChangeFlags   (UINT  uFlags,UINT uMask,UINT uItem,UINT uUntil=0);
	UINT			ChangeStyle   (UINT  uFlags,UINT uMask,UINT uItem,UINT uUntil=0);
	UINT			ChangeState   (UINT  uFlags,UINT uMask,UINT uItem,UINT uUntil=0);
								  
	UINT			GetFlags      (UINT  uItem) const;
	UINT			SetFlags      (UINT  uItem,UINT  uFlags,UINT uMask=0xFFFF);
	BOOL			SetBitmap	  (HBITMAP   hBitmap,int iWidth=0,BOOL bDelete=FALSE,UINT *pItemList=0,int iCount=0,UINT uScale=0);
	BOOL			SetBitmap	  (DWORD_PTR uBitmap,int iWidth=0,HMODULE  hModule=0,UINT *pItemList=0,int iCount=0,UINT uScale=0);

	BOOL			TagInsert	  (LPCTSTR pText,UINT uIndex,int iPosX=1,int iPosY=1,BYTE bFlags=TBTF_RIGHT|TBTF_TOP,BYTE bId=0);
	BOOL			TagInsert	  (LPTBTAGITEM pItem,LPCTSTR pText);
	BOOL			TagDelete	  (UINT uIndex);


	int 			SetTextSize	  (int iIndex,int iSize);
	int 			GetButtonStyle(int iIndex) const;
	int 			SetButtonStyle(int iIndex, UINT uStyle,UINT uMask=0x00FF00FF);	
	BOOL			SetButtonText (int iIndex,LPCTSTR pText);
	void			SetButtonInfo (int iIndex,UINT  uCommand,UINT  uStyle=0xFFFFFFFF,int iImage=-2);
	void			SetButtonInfo (int iIndex,UINT  uCommand,UINT  uStyle,           int iImage ,UINT uFlags,UINT uMask=0xFFFF);
	void			GetButtonInfo (int iIndex,UINT &uCommand,UINT &uStyle           ,int &iImage,UINT uFlags) const;
	void			GetButtonInfo (int iIndex,UINT &uCommand,UINT &uStyle           ,int &iImage) const;
					
	CWnd		   *GetControl	  (unsigned uNumber) const;
	CWnd		   *GetControlId  (unsigned uId  ,unsigned uPos=0) const;
	int 			AddControl    (CWnd    *pWnd ,unsigned uItem,int iNumber=-1,BOOL bSetFont=TRUE);
	int				ButtonCount   () const;
								  
	int				GetScaling    () const;
	int				SetScaling    (int iScale,BOOL bRedraw=TRUE);
	int				GetBitmapScaling(int iBitmap) const;
	int				SetBitmapScaling(int iBitmap,int iScale,BOOL bRedraw=TRUE);

	virtual CSize 	CalcFixedLayout(BOOL bStretch, BOOL bHorz);
	virtual CSize 	CalcDynamicLayout(int nLength, DWORD nMode);
	virtual void	OnUpdateCmdUI(CFrameWnd *pTarget,BOOL bDisableIfNoHndler);
	

protected:
	
	//{{AFX_MSG(CToolBarNew)
	afx_msg void OnContextMenu(CWnd *pWnd,CPoint sPoint);
	afx_msg void OnTimer(UINT_PTR nIdEvent);
	//}}AFX_MSG


	DECLARE_MESSAGE_MAP()

	virtual BOOL	OnWndMsg(UINT uMsg,WPARAM wParam,LPARAM lParam,LRESULT *pResult);

	static const	LPCTSTR	m_aDefaultMenuNames[CNB_MENU_SIZE];
	static BOOL		m_bInitDone;					// CToolBar wurte initialisiert
	
	LPCTSTR			m_aMenuTxt[CNB_MENU_SIZE];		// Texte fr das Toolbar-Men
	WORD			m_aMenuIds[CNB_MENU_SIZE];		// ID's  fr das Toolbar-Men
	UINT			m_uExtraStyle;					// Erweiterte Styles 
	UINT			m_uIconSize;					// Gre der Icons fr Men (0=klein 1=mittel 2=gro)
	int				m_iMinSize;						// Minimale Breite vom ungedocken Fenster 
	int				m_iWidth;						// Breite eines Standart-Icons

};


//*****************************************************************************
//*
//*		Inline Funktions
//*
//*****************************************************************************
inline	DWORD		CToolBarNew::GetStyle   () const										{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_GetStyle(m_hWnd); }
inline	UINT		CToolBarNew::GetFlags   (UINT     uItem) const						  	{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_GetFlags(m_hWnd,uItem);}
inline	UINT		CToolBarNew::SetFlags   (UINT     uItem,UINT uFlags,UINT uMask)		  	{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_SetFlags(m_hWnd,uItem,uFlags,uMask);}
inline	BOOL		CToolBarNew::TagDelete	(UINT uIndex)									{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_DeleteTag(m_hWnd,uIndex); }
inline	BOOL		CToolBarNew::TagInsert	(LPTBTAGITEM pItem,LPCTSTR pText)				{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_InsertTag(m_hWnd,pItem,pText); }
inline	BOOL		CToolBarNew::LoadBitmap (UINT     nIdResource,int iWidth)			  	{ASSERT(::IsWindow(m_hWnd)); return LoadBitmap((LPCTSTR)nIdResource);}
inline	BOOL 		CToolBarNew::LoadToolBar(UINT     nIdResource  )						{ASSERT(::IsWindow(m_hWnd)); return LoadToolBar(MAKEINTRESOURCE(nIdResource));}
inline	BOOL 		CToolBarNew::LoadToolBar(LPCTSTR  pResourceName)						{ASSERT(::IsWindow(m_hWnd)); return LoadToolBar(pResourceName,0);}
inline	BOOL 		CToolBarNew::LoadToolBar(LPCTSTR  pResourceName,BOOL bCopyItems)		{ASSERT(::IsWindow(m_hWnd)); LPCTSTR aNames[2];aNames[0]=pResourceName;aNames[1]=0;return LoadToolBar(aNames,bCopyItems,0,0,0);}
inline  BOOL		CToolBarNew::SetButtonText(int iIndex,LPCTSTR pText)					{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_SetButtonString(m_hWnd,iIndex,pText);}
inline  int			CToolBarNew::ButtonCount() const										{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_ButtonCount(m_hWnd);}
inline  int			CToolBarNew::GetScaling () const										{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_GetScaling(m_hWnd);}
inline  UINT		CToolBarNew::ChangeFlags(UINT uFlags,UINT uMask,UINT uItem,UINT uUntil)	{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_ChangeFlags(m_hWnd,uFlags,uMask,uItem,uUntil);}
inline  UINT		CToolBarNew::ChangeStyle(UINT uFlags,UINT uMask,UINT uItem,UINT uUntil)	{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_ChangeStyle(m_hWnd,uFlags,uMask,uItem,uUntil);}
inline  UINT		CToolBarNew::ChangeState(UINT uFlags,UINT uMask,UINT uItem,UINT uUntil)	{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_ChangeState(m_hWnd,uFlags,uMask,uItem,uUntil);}
inline  int			CToolBarNew::GetBitmapScaling(int iBitmap) const						{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_GetBitmapScaling(m_hWnd,iBitmap);}
inline  int 		CToolBarNew::SetButtonStyle(int iIndex,UINT uStyle,UINT uMask)			{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_SetStyleStateMask(m_hWnd,iIndex,uStyle^TBBS_DISABLED,uMask)^TBBS_DISABLED;}
inline  int 		CToolBarNew::GetButtonStyle(int iIndex) const							{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_GetStyleState(m_hWnd,iIndex)^TBBS_DISABLED;}
inline  int 		CToolBarNew::SetTextSize(int iIndex,int iSize)							{ASSERT(::IsWindow(m_hWnd)); return ToolBarEx_SetTextSize(m_hWnd,iIndex,iSize);}
inline  int			CToolBarNew::SetMenuId	(UINT uIndex,WORD wId)							{ASSERT_VALID(this); if(uIndex>=CNB_MENU_SIZE)return -1;WORD wOld=m_aMenuIds[uIndex];m_aMenuIds[uIndex]=wId;return wOld;} 
inline  BOOL		CToolBarNew::SetMenuText(UINT uIndex,LPCTSTR pText)						{ASSERT_VALID(this); if(uIndex>=CNB_MENU_SIZE)return FALSE;m_aMenuTxt[uIndex]=pText;return TRUE;} 
inline  BOOL		CToolBarNew::SetFlatMode(BOOL bFlat,BOOL bRedraw)						{ASSERT_VALID(this); DWORD dwOld=SetStyle((bFlat)? TBSTYLE_FLAT:0,TBSTYLE_FLAT,bRedraw); return (dwOld&TBSTYLE_FLAT)? TRUE:FALSE;}
inline  UINT 		CToolBarNew::SetIconSize(UINT uSize)									{ASSERT_VALID(this); UINT uOld=m_uIconSize;m_uIconSize=uSize;return uOld;}
inline  UINT 		CToolBarNew::GetIconSize() const										{ASSERT_VALID(this); return m_uIconSize;}

#endif

