//*****************************************************************************
//*
//*
//*		VersionDlg.cpp
//*
//*
//*****************************************************************************
#include	"VersionDlg.h"
#include	"RegKeys.h"

#ifdef	    _MSC_VER
#pragma		 warning( disable :4996 )
#endif

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef 	 IDC_VERSION
#define 	 IDC_VERSION	1299
#endif 	

//*****************************************************************************
//*
//*		Dialogfeld CVersionDlg
//*
//*****************************************************************************
CVersionDlg::CVersionDlg(LPCTSTR pTemplateName,LPCTSTR pRegPath,LPCTSTR pRegName,CWnd *pParentWnd) : CDialog(pTemplateName,pParentWnd)
{
	m_pRegPath = pRegPath;
	m_pRegName = pRegName;
}

CVersionDlg::CVersionDlg(UINT nIdTemplate,LPCTSTR pRegPath,LPCTSTR pRegName,CWnd *pParentWnd) : CDialog(nIdTemplate,pParentWnd)
{
	m_pRegPath = pRegPath;
	m_pRegName = pRegName;
}

CVersionDlg::CVersionDlg(LPCTSTR pTemplateName,UINT	uStringId,LPCTSTR pRegName,CWnd *pParentWnd) : CDialog(pTemplateName,pParentWnd)
{
	if(!uStringId)
		{
		m_pRegPath = 0;
		}
	else if(m_sCfgPath.LoadString(uStringId))
		{
		m_pRegPath = m_sCfgPath;
		}
	else{
		m_pRegPath = 0;
		}

	m_pRegName = pRegName;
}

CVersionDlg::CVersionDlg(UINT nIdTemplate,UINT uStringId,LPCTSTR pRegName,CWnd *pParentWnd) : CDialog(nIdTemplate,pParentWnd)
{
	if(!uStringId)
		{
		m_pRegPath = 0;
		}
	else if(m_sCfgPath.LoadString(uStringId))
		{
		m_pRegPath = m_sCfgPath;
		}
	else{
		m_pRegPath = 0;
		}

	m_pRegName = pRegName;
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CVersionDlg::OnInitDialog()
{
TCHAR		aText[256];
TCHAR		aInfo[128];
LPCTSTR		pPtr;
CRegKeys	sKey;
CRect		sRect;
CWnd	   *pWnd;
FILE	   *pFile;	
int			iLen;
	

	if(!m_pRegName)m_pRegName=_T("Version");

	

	
	
	if(m_pRegPath==0)										// Keine Informationen anzeigen
		{
		aInfo[0] = 0;
		}
	else if(m_pRegPath[0]=='.' && (m_pRegPath[1]=='\\' || m_pRegPath[1]=='/'))
		{													// Version aus Datei holen
		iLen = GetModuleFileName(NULL,aText,sizeof(aText));
		while(iLen>0 && aText[iLen-1]!='\\')iLen--;
		_tcsncpy(aText+iLen,m_pRegPath+2,sizeof(aText)-iLen-1);
		aText[sizeof(aText)-1]=0;

			pFile = _tfopen(aText,_T("rb"));
		if(!pFile)
			{
			aInfo[0] = 0;
			}
		else{
			_fgetts(aInfo,sizeof(aInfo),pFile);
			fclose(pFile);
			aInfo[sizeof(aInfo)-1] = 0;
			iLen = (int)_tcslen(aInfo);
			while(iLen>0 && aInfo[iLen-1]<' ' && aInfo[iLen-1]>0)iLen--;
			aInfo[iLen] = 0;
			}
		}
	else{													// Version aus Registry	holen
		aInfo[0] = 0;

		sKey.Open(HKEY_LOCAL_MACHINE,m_pRegPath,CRK_READ);
		sKey.Get(aInfo,sizeof(aInfo)/sizeof(TCHAR),m_pRegName);

		if(aInfo[0]==0)
			{
			sKey.Open(HKEY_CURRENT_USER,m_pRegPath,CRK_READ);
			sKey.Get(aInfo,sizeof(aInfo)/sizeof(TCHAR),m_pRegName);
			}
		}

	if(aInfo[0])											// Wurde eine Information gefunden	
		{
		   pWnd = GetDlgItem(IDC_VERSION);
		if(pWnd)
			{
			pWnd->SetWindowText(aInfo);
			pWnd = NULL;
			}
		else{		
			pWnd = GetNextWindow(GW_CHILD);
			}
		
		while(pWnd)
			{
			pWnd->GetWindowText(aText,(sizeof(aText)-sizeof(aInfo))/sizeof(TCHAR)-4);			
			pPtr = _tcsstr(aText,_T("Version "));

			if(pPtr)										// Versionsinfo gefunden ?
				{
				pPtr += 8;

				while(*pPtr==' ')pPtr++;

				if(*pPtr>='0' && *pPtr<='9')
					{
					_tcscat(aText,_T(" / "));
					_tcscat(aText,aInfo);

					pWnd->GetClientRect(&sRect);
					pWnd->SetWindowPos (NULL,0,0,sRect.Width()*2,sRect.Height(),SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION);
					pWnd->SetWindowText(aText);

					break;
					}
				}
			
			pWnd = pWnd->GetNextWindow();
			}
		}


return CDialog::OnInitDialog();
}
