//*****************************************************************************
//*
//*
//*		AnsiBase.h
//*
//*
//*****************************************************************************
//
//	Makros:
//
//		USE_RC					: Dialoge aus den Resourcen laden
//		USE_VIRTUAL_LINES		: Gibt es vituelle Lineen (Bereiche zuklappen)
//		TO_ANSISPLIT			: Das Fenster kann geteilt werden
//		TO_ANSIWND				: Die CWnd statt CView Version erstellen
//		ANSI_FLAGS				: Sind die Flags mit dehnen die Klasse erstellt wird
//		ANSI_ICONS				: ID von der Bitmap mit Icons vom Kontextmen
//
//
//	Abzuleitende Funktionen
//
//	Mu:	(*)	PrintLine(...)			Zum Zeichen der einzelen Zeilen
//
//	Kann:	(*)	PrintMargin (...)		Zum Zeichnen des Randes
//			(*)	PositionOk(...)			Zum berprfen der Cursor-Position
//			(*)	LineLength(...)			Zum Abfragen der Zeilen-Lngen
//			(*)	OnPreparePrinting(...)	Zum Auswhlen der Druckerauswahl
//			(*) Update(...)				Zum Aktualisieren der Fenster
//
//	Die Dateien AnsiDlg.cpp und AnsiDlg.h sind fr die Farbeinstellung zustndig
//
//	ID_VIEW_COLOR muss in das Hauptmen eingefgt werden fr die Farbauswahl
//	ID_VIEW_FONT  muss in das Hauptmen eingefgt werden fr die Schriftauswahl
//
//	ber die m_iWindowMode Variabel knnen verschiedene Verhaltensweisen des
//	Fensters eingestellt werden:
//		ANSI_NO_SCROLL	: Kein    Scrollen des Fensters
//		ANSI_NO_SCROLL_Y: Kein  X-Scrollen des Fensters
//		ANSI_NO_SCROLL_Y: Kein  Y-Scrollen des Fensters
//		ANSI_NO_SCRBAR	: Keine   Scroll-Leisten
//		ANSI_NO_SCRBAR_X: Keine X-Scroll-Leiste
//		ANSI_NO_SCRBAR_Y: Keine Y-Scroll-Leiste
//		ANSI_FIX		: Bei genauem Fensterma    die Scrollbars entfernen
//		ANSI_FIX_X		: Bei genauer Fensterbreite die Scrollbar  entfernen
//		ANSI_FIX_Y		: Bei genauer Fensterhhe   die Scrollbar  entfernen
//		ANSI_SPLIT		: Das Fenster kann in X und Y Richtung geteilt werden
//		ANSI_SPLIT_X	: Das Fenster kann in X Richtung geteilt werden
//		ANSI_SPLIT_Y	: Das Fenster kann in Y Richtung geteilt werden
//
//	Funktionen:
//
//		void   PrintText    (HDC,RECT,char *pText,char *pColors,int iLength,int iFlags)
// 		void   FontSet      (int iHeight=FONT_STD ,char *pName="Courier")
// 		int    FontView     ()
// 		int    ColorConfig  (char *pPath=0,int iMode=0)
// 		int	   ColorSave    (char *pPath=0)
// 		int    ColorAdd     (COLORREF uText,COLORREF uBachground,char *pName,int iIndex=0)
// 		int	   ColorChose   (HDC hDc,unsigned uColor,int iFlags)
// 		int    ColorView    ()
// 		void   ColorDisable ()
// 		int	   SetMargin    (int iWidth=0)
// 		int	   OnPageSetup  ()
// 		void   Update       (int iMode=0)
// 	    void   UpdateGroup  (int iMode=0)
// 		void   RedrawGroup  ()
//		void   StartMenu    (CPoint sPos,CMenu *pMenu=0)
//		int	   SplitWindow  (int iMode=ANSI_SPLIT_Y,int iPos=ANSI_SPLIT_POS(128))
//		int    SplitPosition(int iMode=ANSI_SPLIT_Y)
//
//		int	   GetMode		()
//		int	   SetMode		(int Mode,int iMask)
//      CPoint GetCursor    ()
//      void   GetCursor    (int &iPosX,int &iPosY)
//      CPoint SetCursor    (CPoint sPos,int iMode=0)
//      CPoint SetCursor    (int iPosX,int iPosY,int iMode=0)
//      CPoint GetScroll    ()
//      CPoint SetScroll    (CPoint sPos)
//      CPoint SetScroll    (int iPosX,int iPosY)
//      CPoint SetScroll    (int iPosX,int iPosY,int iRedraw)
//      CSize  GetScreen    ()
//
//	Zeichen Funktionen:
//
//		void   DrawView(int iMode=0)	Mit Zeichnen beginnen
// 		void   DrawViewAll		  ()	Alles neuzeichen
// 		void   DrawViewCursor     ()	Den Cursor neuzeichen
// 		void   DrawViewCursorLine ()	Die Cursor-Zeile neuzeichen
// 		void   DrawViewCursorNext ()	Ab der Cursor Zeile neuzeichen
// 		void   DrawViewFromCursor ()	Vom Cursor bis zum Zeilen Ende
// 		void   DrawViewLine(int iNum)	Eine bestimmte Zeile zeichnen
// 		void   DrawViewFrom(int iNum)	Ab einer bestimmten Zeile zeichnen
//		void   DrawViewArea(int iNum,N)	Einen Bereich neu zeichnen
//
//	Virtuelle Funktionen:
//
//		Sie bergeben Zeichen Koordinaten
//		Wird 1 zurckgegeben so werden die Signale nicht weiter bearbeitet
//
//		void   OnSize   	  ( int iSizeX,int iSizeY,int iDeltaX,int iDeltaY )
//		int    OnChar   	  ( UINT nChar, UINT nFlags )
//		int    OnKeyUp  	  ( UINT nChar, UINT nFlags )
//		int    OnKeyDown	  ( UINT nChar, UINT nFlags )
//		int    OnLButtonDblClk( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnRButtonDblClk( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnLButtonDown  ( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnRButtonDown  ( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnLButtonUp    ( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnRButtonUp    ( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnMouseMove    ( UINT nFlags, CPoint sPoint,int iPosX,int iPosY)
//		int    OnMarginClick  ( UINT nFlags, CPoint sPoint,int iPosY)
//
//	Notify-Nachrichten:
//
//		Wird die Scrollposition verndert wird an das Elternfenster
//		eine ANSI_SCROLL Notify-Nachricht an das Elternfenster gesentet
//		mit den Scroll-Koordinaten.
//
//		Bei Erhalt des Focus und beim Verlieren dieses wird eine
//		Notify-Nachricht gesentet.
//
//

#include    "Controls/AnsiMessage.h"

#define 	ANSI_SCROLL			0x27F4			// Nachricht bei nderungen
#define 	ANSI_SETFOCUS		0x27F5			// Nachricht bei Erhalt des Focus
#define 	ANSI_KILLFOCUS		0x27F6			// Nachricht bei Verlust des Focus

#ifdef		TO_ANSIWND
	#define		CAnsiView	CAnsiWnd
	#define 	CView		CWnd
#else
	#ifdef		CAnsiView
	#undef 		CAnsiView
	#endif
	#ifdef		CView
	#undef 		CView
	#endif
#endif

/*****************************************************************************/
#ifndef 	ANSI_DEFINE
#define 	ANSI_DEFINE


//	Konstanten fr m_iWindowMode
#define		ANSI_NO_SCROLL		0x0003			// Kein   Scrollen des Fensters
#define		ANSI_NO_SCROLL_X	0x0001			// Kein X-Scrollen des Fensters
#define		ANSI_NO_SCROLL_Y	0x0002			// Kein Y-Scrollen des Fensters
#define		ANSI_NO_SCRBAR		0x000C			// Keine   Scroll-Leisten
#define		ANSI_NO_SCRBAR_X	0x0004			// Keine X-Scroll-Leiste
#define		ANSI_NO_SCRBAR_Y	0x0008			// Keine Y-Scroll-Leiste
#define		ANSI_FIX			0x0030			// Bei genauem Fensterma    die Scrollbars entfernen
#define		ANSI_FIX_X			0x0010			// Bei genaue  Fensterbreite die Scrollbars entfernen
#define		ANSI_FIX_Y			0x0020			// Bei genaue  Fensterhhe   die Scrollbars entfernen
#define		ANSI_DROP			0x0040			// Bei Datei ffnen bei Drop
#define		ANSI_SHOW_SCRBAR	0x0300			// Scroll-Leisten immer anzeigen
#define		ANSI_SHOW_SCRBAR_X	0x0100			// X-Scroll-Leiste immer anzeigen
#define		ANSI_SHOW_SCRBAR_Y	0x0200			// Y-Scroll-Leiste immer anzeigen
#define 	ANSI_SPLIT			0x0C00			// Das Fenster kann in X und Y Richtung geteilt werden
#define 	ANSI_SPLIT_X		0x0400			// Das Fenster kann in X Richtung geteilt werden
#define 	ANSI_SPLIT_Y		0x0800			// Das Fenster kann in Y Richtung geteilt werden
#define 	ANSI_SPLIT_XY		0x0C00			// Das Fenster kann in X und Y Richtung geteilt werden


//	Konstanten fr OnMarginClick
#define 	MK_UP				0x8000			// Maus Taste losgelassen
#define 	MK_DOWN				0x4000			// Maus Taste gedrckt
#define 	MK_DBLCLK			0x2000			// Maus Taste Doppelclick
#define 	MK_MOVE 			0x1000			// Maus Bewegung
#define 	MK_LEFT				0x0800			// Von linker  Maus Taste
#define 	MK_RIGHT			0x0400			// Von rechter Maus Taste

//	Konstanten fr die Klasse
#define		ANSI_WITDH_MAX		80				// Standard Breite fr Fenster
#define		ANSI_LINES_MAX 		0				// Standard Zeilenanzahl
#define 	ANSI_FONT_MIN		6				// Minimale Zeichenhhe
#define 	ANSI_FONT_MAX		48				// Maximale Zeichenhhe
#define 	ANSI_FONT_STD		15				// Standard Zeichenhhe
#define		ANSI_FONT_TEXT		"Standard"		// Name fr Stantartfarbe
#define 	ANSI_WND_ID			0x0123			// Standard ID fr AnsiWnd
#define 	ANSI_SRCOLL_ID		0x0390			// Standard ID fr ScrollBars
#define 	ANSI_NO_SUBCALL		0x0400			// Kein Unteraufruf bei On?Button???

// Konstanten fr Fenster neuzeichnen
#define		NZ_ALL				0x80000000		// Alles neuzeichnen
#define		NZ_CURSOR			0x40000000		// Cursor neuzeichnen
#define		NZ_LINE				0x20000000		// Zeile mit Cursor neu zeichnen
#define		NZ_LINE_NEXT		0x10000000		// Zeilen nach Cursor neu zeichnen
#define		NZ_LINE_CURSOR		0x08000000		// Text nach Cursor neu zeichnen
#define		NZ_LINE_AREA		0x04000000		// Einen Zeilebereich (0x1F/0x1FFFF) zeichnen
#define		NZ_LINE_FROM		0x02000000		// Zeilen ab Nummer &0x3FFFFF zeichnen
#define		NZ_LINE_NR			0x01000000		// Zeile mit Nummer &0x3FFFFF zeichnen
#define		NZ_LINE_WW			0x0001FFFF		// Und-Verknpfung fr Area-Nummer
#define		NZ_LINE_XX			0x003FFFFF		// Und-Verknpfung fr Nummer
#define		NZ_LINE_COUNT		0x0000001F		// Und-Verknpfung fr Area-Anzahl
#define 	NZ_LINE_SHIFT		0x00000011		// Bitverschiebung fr Area-Bereich
#define		NZ_LINE_YY			0x87000000		// Maske fr Zeilen Modi
#define		NZ_LOCK 			0x00400000		// Zeichnen unterdrcken

// Tastatur Status
#define		KEY_SHIFT 			0x00000001		// Shift-Taste gedrckt
#define		KEY_CLTR   			0x00000002		// Cltr -Taste gedrckt

// Konstanten fr Schriften
#define 	ANSI_BOLD			0x00000001		// Fette Schrift
#define 	ANSI_ITALIC			0x00000002		// Schrgschrift
#define 	ANSI_UNDERLINE		0x00000004		// Unterstrichen
#define 	ANSI_FIXED			0x00000008		// Buchstaben haben gleiche Breite
#define 	ANSI_TRUETYPE		0x00000010		// Nur True-Type-Fonts
#define		ANSI_ONLYNEW		0x80000000		// Nur neue Farben einfgen

#define 	ANSI_SPLIT_POS(v)	(0x1230000|(v))	// Aufteilung in Prozenz fr SplitWindow(...)


typedef struct
	{
	NMHDR	sHdr;								// Notify Daten
	int		iParam1;
	int		iParam2;
	}ANSI_NMHDR,*LPANSI_NMHDR;

typedef struct
	{
	int		iWidth;								// Schriftdatan
	int		iHeight;
	int		iFlags;
	TCHAR	cFontName[32];
	}ANSI_FONT;

typedef struct
	{
	int		iCharWidth;							// Schriftabmessungen
	int		iCharHeight;
	int		iIsVector;
	}ANSI_FONT_METRICS;


#endif


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class CAnsiView : public CView
{
#ifndef TO_ANSIWND
DECLARE_DYNCREATE(CAnsiView)
#endif

protected:

struct	AnsiGroupData
	{
	int				iCount;							// Anzahl der Gruppenmitglieder
	int				iId;							// Idendifikations Nummer
	HFONT			hFont;							// Handel fr Schriftart
	HFONT			hFontEx[8];						// Zustzliche Schriftarten
	int				iColorCount;					// Anzahl der Farben in 'farben'
	ANSI_FONT		sAnsiFont;						// Daten zur aktuellen Schriftart
	AnsiColor	   *pColorList;						// Farbenkette
	BYTE	 	   *pColorTable;					// Farbtabelle fr die Schnellsuche
	LPTSTR     		pConfig;						// Name des Config-Pfades
	LPCTSTR    		pName;							// Zeiger auf Namen der Gruppe
	int				iFontSizeX;						// Gre der Schrift
	int				iFontSizeY;						//			*
	};

	AnsiGroupData  *m_pGroup;						// Zeiger auf Guppendaten
	HCURSOR			m_hCursorNow;					// Ist der aktuelle Cursor
	HCURSOR			m_hCursorBase;					// Ist der Haupt-Cursor vom Fenster

#ifndef TO_ANSIWND
static AnsiPageData	m_sPrinterData;					// Seiteneinstellungen frs Drucken
#endif

	int				m_iFontSizeX;					// Breite der aktuellen Schrift
	int				m_iFontSizeY;					//			*
	int				m_iScreenX;						// Fenstergre in Buchstaben
	int				m_iScreenY;						//			*
	int				m_iScreenFullX;					// Fenstergre in Pixel mit Scroll-Bars
	int				m_iScreenFullY;					//			*
	int				m_iScreenSizeX;					// Fenstergre in Pixel
	int				m_iScreenSizeY;					//			*
	int				m_iScrollX;						// Scrollposition
	int				m_iScrollY;						//			*
	int				m_iCursorX;						// Cursorposition
	int				m_iCursorY;						//			*
	int				m_iCursorMode;					// Einfgen,berschreiben,Ein,Aus
	int				m_iContextX;					// Position des letzten Kontextmenaufrufs
	int				m_iContextY;					//			*
	int				m_iLastScrollX;					// Scroll-Position beim letzten rechten Mausklick
	int				m_iLastScrollY;					//			*
	int				m_iLastClickX;					// Position des letzten rechten Mausklicks
	int				m_iLastClickY;					//			*
	int				m_iLineCount;					// Anzahl der Zeilen im Fenster
	int				m_iLineWidthMax;				// Maximale Breite in Zeichen
	int				m_iRedrawFlags;					// Flags zu Neuzeichnen
	int				m_iKeyState;					// Shift/Cltr Tasten Zustand
	int				m_iColorNow;					// Aktuelle Farbe
	int				m_iFontNow;						// Aktuelle Schrift
	int				m_iPrintNow;					// Aktuelle Druckfarbe
	int				m_iMarginWidth;					// Breite des Randes
	int				m_iWindowMode;					// Art des Fensters
	int				m_iClickPosX;					// Pixel vom altuellen Click
	int				m_iClickPosY;					//			*
	char 			m_cColorDisable;				// Sperrt die Farbverwaltung
	char 			m_cClickMode;					// Modus der rechten Maustaste (0=aus 1=an 2=Rahmen 3=move)
	char 			m_cFocusOn;						// Hat das Fenster den Fokus
	TCHAR		   *m_pConfigPath;					// Konigurationspfad

private:

	int				m_iCursorModeOld;				// Alte Cursoreinfgen
	int				m_iCursorOldX;					// Alte Cursorposition
	int				m_iCursorOldY;					//			*
	int				m_iScreenOldX;					// Alte Schirmkoordinaten
	int				m_iScreenOldY;					//			*
	int				m_iScrollOldX;					// Alte Scrollposition
	int				m_iScrollOldY;					//			*
	int				m_iScrollAddX;					// Scroll fr Schirmende
	int				m_iScrollAddY;					//			*
	int				m_iOriginPtX;					// Versatz fr ersten Buchstaben
	int				m_iOriginPtY;					//			*
	int				m_iWindowModeOld;				// Alte Art des Fensters
	int			   *m_pPageBegin;					// Anfnge der Seiten
	int			   *m_pLineSizes;					// Breite der einzelnen Zeilen
	int				m_iLineWidthMaxOld;				// Alte Maximale Breite
	int				m_iLineCountOld; 				// Alte Anzahl der Zeilen
	int				m_iCaretX;						// Cursor-Marken-Position relativ zum sichtbaren Bereich
	int				m_iCaretY;						//			*
	char 			m_cCaretFocus;					//			*
	char 			m_cCaret;						// Cursor-Marke sichtbar
	char			m_cCapture;						// Ist der Maus-Capture aktiv
	char 			m_cMouseOn;						// MausMove ein/aus (0=aus 1=Down im View 2=Down am Rand)
	BYTE 			m_bMouseNum;					// Zhler frs Verschieben mit der rechten Taste 
	BYTE 			m_bMouseTimer;					// Maus Timer ein (1=linke Taste 2=rechte Taste)
	int				m_iMouseX;						// Maus-Koordinaten
	int				m_iMouseY;						//			*
	unsigned		m_uMouseTicks;					// Mausticks
	int				m_iMoveOldX;					// Letzte Moveposition (in Zeichen)
	int				m_iMoveOldY;					//			*
	int				m_iOnSizeCnt;					// OnSize-Rekursions Nummer

static HCURSOR		m_hCursorBeam;					// Globales Handle fr den Beam-Mauszeiger
static HCURSOR		m_hCursorHand;					// Globales Handle fr den Hand-Mauszeiger
static COLORREF		m_uScrollColor;					// Farbe fr recht untere Ecke bei ScrollBars
static int			m_iGroupId;						// Gruppen ID Nummer
static int		  	m_iClassCount;					// Anzahl der Klassen
static TCHAR	   *m_pClassName;					// Zeiger auf Namen der Klasse
static CAnsiView   *m_pClassLast;					// Zeiger auf letzte Klasse
	   CAnsiView   *m_pClassPrev;					// Zeiger auf vorherige Klasse
	   CAnsiView   *m_pClassNext;					// Zeiger auf nchste Klasse


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
	#ifndef TO_ANSIWND
public:
		    void AllowDrop(BOOL bEnable=TRUE);
protected:
	virtual	BOOL PreCreateWindow(CREATESTRUCT& cs);
	#else
public:		BOOL Create  (                DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT uId=ANSI_WND_ID);
			BOOL CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT uId=ANSI_WND_ID);
	#endif
		    CAnsiView(LPCTSTR pGroupName=_T("Null"),int iWidth=ANSI_WITDH_MAX,int iLinesMax=ANSI_LINES_MAX);
		   ~CAnsiView();

public:
			int  NextField	    (int iMode=0);
			int  SplitWindow	(int iMode=ANSI_SPLIT_Y,int iPos=ANSI_SPLIT_POS(128));
			int  SplitPosition	(int iMode=ANSI_SPLIT_Y|1);
			int  SetActiveField	(int iArea,BOOL bRedraw=TRUE);
			int  GetMode		();
			int  SetMode		(int Mode,int iMask);
			int  ConfigPath	    (LPTSTR  pBuffer,int iSize,LPCTSTR pPath=0);
 			void ConfigSetPath	(LPCTSTR pPath);
			void DrawView		(int iMode=0);
			void FontSet		(int iHeight=ANSI_FONT_STD,LPCTSTR pName=_T("Courier"));
	static	int	 FontInfo		(LPCTSTR pGroupName,int &iWidth,int &iHeight);
			int  FontView		();
			int  ColorConfig	(LPCTSTR pPfad=0,int iMode=0);
			int	 ColorSave  	(LPCTSTR pPfad=0);
			int  ColorAdd   	(         COLORREF  uTextColor,COLORREF  uBkColor,LPCTSTR pName,int iIndex=0,int iFont=0);
			int  ColorInfo		(int iNum,COLORREF &uTextColor,COLORREF &uBkColor,int  &iFont);
	virtual int  ColorView  	();
	virtual int	 SetMargin  	(int iWidth=0);
	virtual void Update     	(int iMode=0);
	        void UpdateGroup	(int iMode=0);
			void RedrawGroup	();
	#ifndef TO_ANSIWND
			void OnPageSetup	();
	#endif

		int		 PointToPos     (CPoint sPos,int &iPosX,int &iPosY,int iMode=0);
		void     GetCursor      (int &iPosX,int &iPosY);
		CPoint	 GetCursor  	();
    	CPoint   SetCursor  	(CPoint sPos ,int iMode=0);
    	CPoint   SetCursor  	(int    iPosX,int iPosY,int iMode=0);
    	CPoint   GetScroll  	();
    	CPoint   SetScroll  	(CPoint sPos );
		CPoint   SetScroll  	(CPoint sPos ,int iRedraw);
    	CPoint   SetScroll  	(int    iPosX,int iPosY);
		CPoint   SetScroll      (int    iPosX,int iPosY,int iRedraw);
		CPoint	 GetContext     ();
    	CSize    GetScreen  	();

protected:

	#ifdef  USE_VIRTUAL_LINES
	virtual	int	 TranslateLine  (unsigned uLine,int iDelta);
			int  FindVirtualLine(int	  iLine);
	#endif

	virtual int  PrintLine  	(HDC hDc,RECT *pRect,int   iLine,int   iStart,int iSize,int iFlags=0);
	        void PrintText  	(HDC hDc,RECT *pRect,char *pText,char *pColor,int iSize,int iFlags=0);
			int	 ColorChose 	(HDC hDc,unsigned uColor,int iFlags=0);
	static HFONT FontCreate 	(ANSI_FONT *pFontData);
	inline void  FontDelete     (HFONT hFont){DeleteObject(hFont);}	// Einen Font lschen
		   void	 FontMetrics	(HFONT hFont,ANSI_FONT_METRICS *pMetrics,HDC hDefDc=0);
	    HCURSOR  SetBeam		(HCURSOR hCursor=0);
		HCURSOR	 SetBeamEx		(LPCTSTR uCursor);

	virtual void PrintMargin  	(HDC hDc,RECT *pRect,int iLine);
	virtual void StartMenu    	(CPoint sPos,CMenu *pMenu=0);
	virtual int  PositionOk   	(int iPosX,int iPosY,int iMode=0);
	virtual int  LineLength   	(int iLine);
			void PositionCheck	(int iMode=0);
			int	 SetCursorMode	(int iMode=5);
			void SendNotify   	(int iType,int iParam1=0,int iParam2=0);
			void DoScroll		(int iMode=3);
			void NoScroll		();
			void StartMove		();

	virtual void OnScrollChange	();
	virtual void OnSize			(int iSizeX,int iSizeY,int iDeltaX,int iDeltaY );
	virtual int  OnScroll 		(UINT nChar);
	virtual int  OnChar   		(UINT nChar , UINT   nFlags );
	virtual int  OnKeyUp  		(UINT nChar , UINT   nFlags );
	virtual int  OnKeyDown		(UINT nChar , UINT   nFlags );
	virtual int  OnLButtonDblClk(UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnRButtonDblClk(UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnLButtonDown  (UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnRButtonDown  (UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnLButtonUp    (UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnRButtonUp    (UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnMouseMove    (UINT nFlags, CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnMarginClick  (UINT nFlags, CPoint sPoint,int iPosY);
	virtual BOOL OnSplitChanged	(UINT nFlags, int    iSlplitX, int iSlplitY);
	virtual BOOL OnMouseWheel	(UINT nFlags, short  iDelta);
	virtual void OnDraw         (CDC *pDC);

	#ifndef TO_ANSIWND
	virtual BOOL OnPreparePrinting(          CPrintInfo *pInfo);
	virtual void OnPrint		  (CDC *pDC, CPrintInfo *pInfo);
	virtual void OnBeginPrinting  (CDC *pDC, CPrintInfo *pInfo);
	virtual void OnEndPrinting    (CDC *pDC, CPrintInfo *pInfo);
	afx_msg void OnDropFiles	  (HDROP hDropInfo);
	#else
	afx_msg void OnPaint		  ();
	#endif

	int			IsFieldActive     ();				// Ist das gezeichnete Feld das aktuelle		
	int			CurrerntDrawField ();				// Welches Feld wird gerade gezeichnet



	//{{AFX_VIRTUAL(CAnsiView)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CAnsiView)
	afx_msg void OnFontView      ();
	afx_msg void OnColorView     ();
	afx_msg UINT OnGetDlgCode    ();
	afx_msg void OnSysColorChange();
	afx_msg void OnTimer         ( UINT_PTR );
	afx_msg void OnHScroll       ( UINT,UINT, CScrollBar*);
	afx_msg void OnVScroll       ( UINT,UINT, CScrollBar*);
	afx_msg void OnSetFocus      ( CWnd *pWnd );
	afx_msg void OnKillFocus     ( CWnd *pWnd );
	afx_msg void OnSize			 ( UINT nType , int iPosX, int iPosY);
	afx_msg void OnLButtonUp     ( UINT nFlags, CPoint sPoint );
	afx_msg void OnLButtonDown   ( UINT nFlags, CPoint sPoint );
	afx_msg void OnLButtonDblClk ( UINT nFlags, CPoint sPoint );
	afx_msg void OnRButtonUp     ( UINT nFlags, CPoint sPoint );
	afx_msg void OnRButtonDown   ( UINT nFlags, CPoint sPoint );
	afx_msg void OnRButtonDblClk ( UINT nFlags, CPoint sPoint );
	afx_msg void OnMButtonDown   ( UINT nFlags, CPoint sPoint );
	afx_msg void OnMouseMove     ( UINT nFlags, CPoint sPoint );
	afx_msg BOOL OnMouseWheel	 ( UINT nFlags, short iDelta, CPoint sPoint);
	afx_msg void OnChar          ( UINT nChar , UINT nRepCnt, UINT nFlags );
	afx_msg void OnKeyUp         ( UINT nChar , UINT nRepCnt, UINT nFlags );
	afx_msg void OnKeyDown       ( UINT nChar , UINT nRepCnt, UINT nFlags );
	afx_msg int  OnCreate        ( LPCREATESTRUCT pCreateStruct);
	afx_msg BOOL OnSetCursor     ( CWnd *pWnd,UINT nHitTest,UINT uMsg);
	afx_msg LRESULT OnAnsiInfo   ( WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnButtonDownX( WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG


	inline	void	GetClientRect(LPRECT pRect) const {pRect->top=0;pRect->left=0;pRect->right=m_iScreenSizeX;pRect->bottom=m_iScreenSizeY;}
	LONG			TabbedTextOutEx(HDC hDc,LPRECT pRect,const LPBYTE pString,const LPWORD pColors,INT iCount,INT iFlags,INT iTabs=0);

private:

	#ifdef	TO_ANSISPLIT

	int				m_iFieldDraw;					// Welches Feld wird gerade gezeichnet
	int				m_iSplitActiv;					// Aktives Fenster (Bit0=X Bit1=Y)
	char			m_cSplitBeam;					// Welcher Mauszeiger ist aktiv (0=Beam 1=Y 2=Y 3=XY)
	char 			m_cSplitBack;					// Altes Feld bei Verschieben mit rechter Maustaste
	char			m_aSplitOn     [2];				// Ist das Fenster geteillt	 (0=X 1=Y)
	int				m_aSplitPos    [2];				// Position des Teiles (real, 0=X 1=Y)
	int				m_aSplitNow    [2];				// Position des Teiles (set , 0=X 1=Y)
	int				m_aSplitSizeX  [2];				// Gre eines Fensters
	int				m_aSplitSizeY  [2];				//			*
	int				m_aScrollAddX  [2];				// Scroll fr Schirmende
	int				m_aScrollAddY  [2];				//			*
	int				m_aScrollX     [2];				// Scroll-Positionen der Abschnitte
	int				m_aScrollY     [2];				//			*
	int				m_aScreenX     [2];				// Fenstergre in Buchstaben der Abschnitte
	int				m_aScreenY     [2];				//			*
	CScrollBar		m_aScrollBars  [4];				// ScrollBars fr das Fenster
	char			m_aScrollBarsOn[4];				// Sind die ScrollBars sichtbar
	int				m_iScrollOldXB;					// Alte Scrollposition fr inaktive Bars
	int				m_iScrollOldYB;					//			*
	int				m_iScreenOldXB;					// Alte Schirmkoordinaten fr inaktive Bars
	int				m_iScreenOldYB;					//			*
	int				m_iScreenMaxY;					// Maximale Anzahl an vollen Zeile in der oberen Hlfte
	int				m_iMouseField;					// Feld der rechten Maustaste
	static HCURSOR	m_hCursorSizeNs;				// Globales Handle fr den SizeNs-Mauszeiger
	static HCURSOR	m_hCursorSizeWe;				// Globales Handle fr den SizeWe-Mauszeiger
	static HCURSOR	m_hCursorSizeAll;				// Globales Handle fr den SizeAll-Mauszeiger

	int				GetFieldOfPoint(CPoint sPoint,CPoint *pBase=0);

	#define 		ANSI_BAR(i)		i="\0\1\2\3\0\1\2\3\2\1\0\3\0\1\2\3\0\3\2\1\0\1\2\3\2\3\0\1\0\1\2\3"[i|(m_iSplitActiv<<3)];
	#define 		ANSI_SPL(i)		i
	
	#define 		SB_HORZ_X		(SB_HORZ|2)		// Inverse X-ScrollBars whlen
	#define 		SB_VERT_X		(SB_VERT|2)		// Inverse Y-ScrollBars whlen
	#define 		SB_DIRECT		4				// ScrollBars direkt whlen

	#else

	CScrollBar		m_aScrollBars  [2];				// ScrollBars fr das Fenster
	char			m_aScrollBarsOn[2];				// Sind die ScrollBars sichtbar

	#define 		ANSI_BAR(i)	
	#define 		ANSI_SPL(i)

	#endif 	

	virtual CScrollBar* GetScrollBarCtrl(int iBar)                           {ANSI_BAR(iBar);return m_aScrollBars+iBar;}
	inline	int	 GetScrollPos (int iBar) const					             {ANSI_BAR(iBar);return m_aScrollBars[iBar].GetScrollPos();}
	inline	int	 SetScrollPos (int iBar,int iPos,BOOL bRedraw=TRUE)          {ANSI_BAR(iBar);return m_aScrollBars[iBar].SetScrollPos(iPos,bRedraw);}
	inline	int	 GetScrollInfo(int iBar,LPSCROLLINFO pInfo,INT nMask=SIF_ALL){ANSI_BAR(iBar);return m_aScrollBars[iBar].GetScrollInfo(pInfo,nMask);}
		   	int	 SetScrollInfo(int iBar,LPSCROLLINFO pInfo,INT iFlags=1);


public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
#endif

protected:

	DECLARE_MESSAGE_MAP()

//*****************************************************************************
//*
//*		Inline Zeichen Funktionen
//*
//*****************************************************************************
inline void  DrawViewAll()		 { m_iRedrawFlags =NZ_ALL	     ;}
inline void  DrawViewCursor()	 { m_iRedrawFlags|=NZ_CURSOR     ;}
inline void  DrawViewCursorLine(){ m_iRedrawFlags|=NZ_LINE       ;}
inline void  DrawViewCursorNext(){ m_iRedrawFlags|=NZ_LINE_NEXT  ;}
inline void  DrawViewFromCursor(){ m_iRedrawFlags|=NZ_LINE_CURSOR;}
inline void  DrawViewLine(int iLine)
		{
		if(m_iRedrawFlags&NZ_LINE_YY)
			{	m_iRedrawFlags	=  NZ_ALL;		}
		else{	m_iRedrawFlags &= ~NZ_LINE_XX;
				m_iRedrawFlags |=  NZ_LINE_XX&iLine;
				m_iRedrawFlags |=  NZ_LINE_NR; }
		}
inline void  DrawViewFrom(int iLine)
		{
		if(m_iRedrawFlags&NZ_LINE_FROM)
			{
			if((m_iRedrawFlags&NZ_LINE_XX)<=iLine)return;
			m_iRedrawFlags &= ~NZ_LINE_XX;
			m_iRedrawFlags |=  NZ_LINE_XX&iLine; return;
			}
		if(m_iRedrawFlags&NZ_LINE_YY)
			{	m_iRedrawFlags	=  NZ_ALL;		}
		else{	m_iRedrawFlags &= ~NZ_LINE_XX;
				m_iRedrawFlags |=  NZ_LINE_XX&iLine;
				m_iRedrawFlags |=  NZ_LINE_FROM;	}
		}
inline void  DrawViewArea(int iLine,int iEnd)
		{
		int		iCount;

		   iCount = iEnd-iLine;
		if(iCount<0){iCount=-iCount;iLine=iEnd;}

		if(m_iRedrawFlags&NZ_LINE_YY)
			{	m_iRedrawFlags	=  NZ_ALL;		}
		else if(iCount>NZ_LINE_COUNT || (UINT)iLine >NZ_LINE_WW)
			{	m_iRedrawFlags |= (NZ_LINE_XX&iLine)|NZ_LINE_FROM;}
		else{	m_iRedrawFlags &= ~NZ_LINE_XX;
				m_iRedrawFlags |=  NZ_LINE_AREA;
				m_iRedrawFlags |=  iLine|(iCount<<NZ_LINE_SHIFT); }
		}

public:

inline CSize	GetFontSize (){return CSize(m_iFontSizeX,m_iFontSizeY);}	// Ergibt die Gre einer Schrift-Zeichens in Pixel
inline int		ColorCount  (){return m_pGroup->iColorCount;}				// Ergibt die Anzahl der Farben
inline void		ColorDisable(){m_cColorDisable=1;}							// Sperrt die Farbverwaltung

};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline int		CAnsiView::GetMode  (){return m_iWindowMode;}
inline CPoint	CAnsiView::GetCursor(){return CPoint(m_iCursorX,m_iCursorY);}
inline void     CAnsiView::GetCursor(int &iPosX,int &iPosY){iPosX=m_iCursorX;iPosY=m_iCursorY;}
inline int		CAnsiView::SplitPosition(int iMode){ANSI_SPL(if(iMode&(ANSI_SPLIT_Y|1))return m_aSplitNow[1];else return m_aSplitNow[0]);return 0;}

#ifdef	TO_ANSISPLIT
inline int		CAnsiView::IsFieldActive    (){return m_iFieldDraw==m_iSplitActiv;}
inline int		CAnsiView::CurrerntDrawField(){return m_iFieldDraw;}
#else
inline int		CAnsiView::IsFieldActive    (){return 1;}
inline int		CAnsiView::CurrerntDrawField(){return 0;}
#endif 	



//*****************************************************************************
//{{AFX_INSERT_LOCATION
//}}AFX_INSERT_LOCATION


#ifdef		CAnsiView
#undef 		CAnsiView
#endif
#ifdef		CView
#undef 		CView
#endif