//*****************************************************************************
//*
//*
//*		AnsiDlg.h
//*
//*
//*****************************************************************************
#ifndef	AFX_ANSIDLG_H__88888888_D7DA_11D1_9273_444553540044__INCLUDED_
#define AFX_ANSIDLG_H__88888888_D7DA_11D1_9273_444553540044__INCLUDED_

#include <afxwin.h>

#if _MSC_VER >= 1000
#pragma once
#endif


typedef struct
	{
	COLORREF	uColorBk;			// Hintergrundfarbe
	COLORREF	uColorText;			// Textfarbe
	int			iIndex;				// Index-Nummer der Farbe
	int			iFontMode;			// Schriftart (Bit0=Fett Bit1=Kursiv Bit2=Unterstreichen)
	TCHAR      *pName;				// Zeiger auf Namen
	}AnsiColor;


unsigned char  *ColorList  (AnsiColor  *pColorList);
void			ColorDelete(AnsiColor **pColorList);
int 			ColorSerach(AnsiColor  *pColorList,LPCTSTR  pName,int iIndex=0);
int 			ColorInsert(AnsiColor **pColorList,COLORREF uTextColor,COLORREF uBkColor,LPCTSTR pName,int iIndex=0,int iFontMode=0);
int 			ColorChange(AnsiColor **pColorList,COLORREF uTextColor,COLORREF uBkColor,LPCTSTR pName,int iIndex=0,int iFontMode=0);

//*****************************************************************************
//*
//*		AnsiPageData  
//*
//*****************************************************************************
//	Struktur fr die Seitenansicht beim Drucken

typedef struct									// Seiteneinstellungen frs Drucken
	{
	unsigned		uLines;						// Anzahl der Zeilen je Seite
	unsigned		uMarginTop;					// Oberer  Rand in mm
	unsigned		uMarginBottom;				// Unterer Rand in mm
	unsigned		uMarginLeft;				// Linker  Rand in mm
	unsigned		uMarginRight;				// Rechter Rand in mm
	unsigned		uFlags;						// Flags fr Druckoptionen
	LPTSTR			pHeaderData;				// Art der Kopfzeile
	LPTSTR			pFooterData;				// Art der Fusszeile
	AnsiColor	   *pColorList;					// Farbenkette
	int				iColorCount;				// Anzahl der Farben in 'farben'
	HFONT			hFontPrint;					// Normale Druckschrift
	HFONT			hFontLine;					// Kopf/Fusszeilen Schrift
	HFONT			aFontEx[8];					// Zusttzliche Druckschriften
	int				iStartX,iStartY;			// Start Koordinaten in Druckseite
	int				iHeaderY,iFooterY;  		// Positionen der Fu/Kopfzeilen
	int				iFontSizeX;					// Schriftbreite der Druckschrift
	int				iFontSizeY;					// Schrifthhe   der Druckschrift
	int				iCharCount;					// Anzahl der Buchstaben je Zeile
	int				iPages;						// Seiten Anzahl
	int				iMarkStartX;				// Marke fr Druck-Auswahl
	int				iMarkStopX;					//			*
	int				iMarkStartY;				//			*
	int				iMarkStopY;					//			*
	}AnsiPageData;							

#endif


//*****************************************************************************
//*
//*		Dialog CAnsiColorDlg
//*
//*****************************************************************************
class CAnsiColorDlg : public CDialog
{

public:


	CAnsiColorDlg(CWnd *pParent=NULL);
   	INT_PTR DoModal(AnsiColor *pColorList=0,HFONT hFont=0,int iSelect=0,const LPVOID pIndexList=NULL);



protected:


	AnsiColor  *m_pColorList;					// Zeiger auf Farben
	AnsiColor  *m_pTempList;					// Zeiger auf Farben
	LPBYTE		m_pIndexList;					// Welche Farben gehren zum aktuellen Format
	COLORREF	m_uColorBk;						// Hintergrundfarbe
	COLORREF	m_uColorText;					// Textfarbe
	COLORREF	m_uColorUserBk;					// Hintergrundfarbe benuzerdefiniert
	COLORREF	m_uColorUserText;				// Textfarbe benuzerdefiniert
	HFONT	    m_hFont;						// Schriftart fr Textfeld
	int			m_iColorCount;					// Anzahl der Farben
	int			m_iColorNumber;					// Nummer der Farbe
	int			m_iItemSize;					// Ist die Gre einer Farbkachel
	int			m_iBkColor;						// HGFarbe - Radiobuttons
	int			m_iTextColor;					// VGFarbe - Radiobuttons
	BOOL		m_bUnterLine;					// Schriftart Unterstrichen
	BOOL		m_bItalic;						// Schriftart Schrg
	BOOL		m_bBold;						// Schriftart Fett



	void AssignColors();
	void SetFontMode ();
    void DrawItems   ();

	//{{AFX_VIRTUAL(CAnsiColorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);
	//}}AFX_VIRTUAL


	//{{AFX_MSG(CAnsiColorDlg)
	afx_msg void OnBold();
	afx_msg void OnPaint();
	afx_msg void OnFormat();
	afx_msg void OnItalic();
	afx_msg void OnUserBk();
	afx_msg void OnUserText();
	afx_msg void OnUnterLine();
	afx_msg void OnSelChange();
	afx_msg void OnSelColor1();
	afx_msg void OnSelColor2();
	afx_msg void OnDrawItem(int nIdCtl, LPDRAWITEMSTRUCT pDrawItem);
	virtual BOOL OnInitDialog();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	static WORD		m_wDlgData[];

};

//*****************************************************************************
//*
//*		Dialog CAnsiPrintDlg
//*
//*****************************************************************************
class CAnsiPrintDlg : public CDialog
{
public:

	CAnsiPrintDlg(CWnd *pParent=NULL);
   	INT_PTR DoModal(AnsiPageData *pPageData);

protected:

	AnsiPageData   *m_pPageDataPtr;				// Zeiger auf Seiteneinstellungen fr Fenster
	CString			m_sHeaderData;				// Kopfzeile
	CString			m_sFooterData;				// Fusszeile
	CString			m_sMarginTop;				// Rand oben   in mm
	CString			m_sMarginLeft;				// Rand links  in mm
	CString			m_sMarginRight;				// Rand rechts in mm
	CString			m_sMarginBottom;			// Rand unten  in mm
	CString			m_sLines;					// Zeilen pro Seite
	BOOL			m_bPrintBlack;				// Schwarz/Weis Drucken
	BOOL			m_bPrintGray;				// Graustufen   Drucken
	BOOL			m_bPrintColors;				// Farben       Drucken
	BOOL			m_bWrapLines;				// Automatischer Zeilenumbruch
	BOOL			m_bSameFont;				// Gleiche Schriftart
	BOOL			m_bDrawMargin;				// Rahmen Zeichnen
	BOOL			m_bFillMatrgin;				// Rahmen ausmalen
	int				m_iSelect;					// Nummer der Auswahl der Combobox
												
	void			OnMenu(unsigned uNum);		// Submen aufgerufen einfgen
	void			StartMenu(RECT &sRect);

	//{{AFX_VIRTUAL(CAnsiPrintDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	//}}AFX_VIRTUAL


	//{{AFX_MSG(CAnsiPrintDlg)
	afx_msg void OnSelect1();
	afx_msg void OnSelect2();
	afx_msg void OnOk();
	afx_msg void OnMenu0();
	afx_msg void OnMenu1();
	afx_msg void OnMenu2();
	afx_msg void OnMenu3();
	afx_msg void OnMenu4();
	afx_msg void OnMenu5();
	afx_msg void OnMenu6();
	afx_msg void OnMenu7();
	afx_msg void OnMenu8();
	afx_msg void OnMenu9();
    afx_msg void OnMenuA();
	afx_msg void OnDestroy();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	static WORD		m_wDlgData[];
	static WORD		m_wDlgIcon[];

};


