//*****************************************************************************
//*
//*
//*		Basis-Datei fr CHexView / CHexWnd
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#include 	<winreg.h>
#include 	<memory.h>
#include 	<stdlib.h>
#include 	<string.h>
#include 	"RegKeys.h"

#ifdef		TO_HEXWND

	#define	CAnsiView	CAnsiWnd
	#define	CHexView	CHexWnd
	#define CView		CWnd

#else

	#ifdef	CAnsiView
	#undef 	CAnsiView
	#endif
	#ifdef	CHexView
	#undef 	CHexView
	#endif
	#ifdef	CView
	#undef 	CView
	#endif

#endif


#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define		m_iMarkStart		(m_iAreaStart[0])		// Anfang der Marke
#define		m_iMarkEnd			(m_iAreaEnd  [0])		// Ende der Marke
#define		m_iMarkOn			(m_uAreaUsed [0])		// Marke eingeschalten



#ifndef		ID_HEX_CONFIG
#define 	ID_HEX_CONFIG		0x8900
#endif
#ifndef		ID_CHECKSUM
#define 	ID_CHECKSUM			0x8901
#endif
#ifndef		ID_EDIT_UNDO
#define		ID_EDIT_UNDO		0x8902
#endif
#ifndef		ID_EDIT_UNDOBACK
#define		ID_EDIT_UNDOBACK	0x8903
#endif
#ifndef		ID_EDIT_FIND_NEXT
#define 	ID_EDIT_FIND_NEXT	0x8904
#endif
#ifndef		ID_EDIT_FIND_NEXT2
#define 	ID_EDIT_FIND_NEXT2	0x8905
#endif
#ifndef		ID_MOVETO
#define 	ID_MOVETO			0x8906
#endif
#ifndef		ID_INPUTVALUE
#define 	ID_INPUTVALUE		0x8907
#endif
#ifndef		ID_HEX_CONVERT
#define 	ID_HEX_CONVERT		0x8908
#endif
#ifndef		ID_HEX_FLOAT
#define 	ID_HEX_FLOAT		0x8909
#endif
#ifndef 	ID_CPP_COPY
#define 	ID_CPP_COPY			0x890A
#endif
#ifndef 	ID_STR_COPY
#define 	ID_STR_COPY			0x890B
#endif
#ifndef 	ID_EDIT_PASTE_EX
#define 	ID_EDIT_PASTE_EX	0x890C
#endif
#ifndef		ID_HEX_CRCCALC
#define 	ID_HEX_CRCCALC		0x890D
#endif


#ifdef	HEX_MULTI_ADDR
	#define ACONVERT(uAdr)		uAdr=(AdrU)AddrToLinear((AdrU)uAdr)
	#define LCONVERT(uAdr)		uAdr=(AdrU)LinearToAddr((AdrU)uAdr)
#else
	#define ACONVERT(uAdr)
	#define LCONVERT(uAdr)
#endif

//*****************************************************************************
//*
//*		Nachrichten Verarbeitung
//*
//*****************************************************************************
#ifndef		TO_HEXWND
IMPLEMENT_DYNCREATE(CHexView,CAnsiView)
#endif

BEGIN_MESSAGE_MAP  (CHexView,CAnsiView)
	//{{AFX_MSG_MAP(CHexView)
	ON_COMMAND(ID_HEX_CONFIG  			  ,OnConfigView)
	ON_COMMAND(ID_EDIT_UNDO				  ,OnUndo)
	ON_COMMAND(ID_EDIT_UNDOBACK			  ,OnUndoBack)
	ON_COMMAND(ID_EDIT_FIND   			  ,OnFindView)
	ON_COMMAND(ID_EDIT_FIND_NEXT		  ,OnFindNext)
	ON_COMMAND(ID_EDIT_FIND_NEXT2		  ,OnFindMark)
	ON_COMMAND(ID_EDIT_COPY				  ,OnCopy)
	ON_COMMAND(ID_EDIT_PASTE			  ,OnPaste)
	ON_COMMAND(ID_EDIT_PASTE_EX			  ,OnPasteEx)
	ON_COMMAND(ID_MOVETO				  ,OnMoveTo)
	ON_COMMAND(ID_CPP_COPY				  ,OnCppCopy)
	ON_COMMAND(ID_STR_COPY				  ,OnStrCopy)
	ON_COMMAND(ID_CHECKSUM				  ,OnChecksum)
	ON_COMMAND(ID_INPUTVALUE			  ,OnValueInput)
	ON_COMMAND(ID_HEX_CRCCALC			  ,OnCrcCalc)
	ON_COMMAND(ID_HEX_CONVERT			  ,OnHexConvert)
	ON_COMMAND(ID_HEX_FLOAT				  ,OnFloatView)
	ON_UPDATE_COMMAND_UI(ID_CPP_COPY      ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_STR_COPY      ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO	  ,OnMenuUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDOBACK ,OnMenuUndoBack)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY     ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE	  ,OnMenuClipboard)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_EX ,OnMenuClipboard)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND_NEXT,OnMenuFind)
	ON_MESSAGE(WM_HEXINFO				  ,OnHexInfo)
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


static inline int atostr(CHexView::AdrI iVal,TCHAR *pStr,int iMode=0)
{
int		iRet;

	if(sizeof(CHexView::AdrI)==sizeof(int))
			iRet=itostr((int)iVal,pStr,iMode);
	else	iRet=qtostr(     iVal,pStr,iMode);

return iRet;
}

static inline int otostr(CHexView::OffI iVal,TCHAR *pStr,int iMode=0)
{
int		iRet;

	if(sizeof(CHexView::OffI)==sizeof(int))
			iRet=itostr((int)iVal,pStr,iMode);
	else	iRet=qtostr(     iVal,pStr,iMode);

return iRet;
}



//*****************************************************************************
//*
//*		Statische Variabeln
//*
//*****************************************************************************

int		CHexView::m_iWindowCount=0;						// Anzahl der Fenster insgesamt
int		CHexView::m_iFindFlags	=HEX_FIND_IN_ALL;		// Suchen-Flags
LPTSTR	CHexView::m_pFindText	=0;						// Suchen  Strings
LPTSTR	CHexView::m_pGroupText	=0;						// Strings fr Gruppensuche
LPTSTR	CHexView::m_pResultText =0;						// Strings Suche


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CHexView::CHexView(int iMode):CAnsiView(_T("Hex"))
{
int i;

	#ifdef	HEX_MULTI_ADDR
	m_iMultiMax			= 0;							// Gre der Umwandlungstabellen
	m_iMultiCount		= 0;							// Anzahl der Multi-Frames
	m_pMultiOffToAdr	= 0;							// Umwandlungstabelle Linera->Address
	m_pMultiAdrToOff	= 0;							// Umwandlungstabelle Linera->Address
	#endif

	#if HEX_ALLOW_GROW
	m_pOldMem			= 0;							// Vorheriger Speicher spter freigben
	m_iMemExtra			= 0;							// Lnge des Extra-Bytes am Ende des Speichers
	m_bAllowGrow		= 0;							// Ist der Modus an Wachsen
	m_bCanGrow			= 0;							// Kann der Speicher wachsen
	#endif


	m_iWindowCount	   += 1;
	m_iWindowMode	   |= ANSI_FIX;
	m_iFlags			= iMode&(~HEX_CHANGED);
	m_iFlagsOld			= -1;

	m_iFlags		   |=HEX_AUTO_SIZE;
	m_iFlags		   |=HEX_SNAP_IN;
	m_iFlags		   |=HEX_GRID_SIZE;
	m_iFlags		   |=HEX_CONFIG;
	m_iFlags		   |=HEX_MEM_FREE;

	if(m_pGroup->iColorCount<=1)						// Farben erstellen
		{
		ColorAdd(RGB(255,  0,  0),0xFFFFFFFF      ,_T("Adressen"	   ),2);
		ColorAdd(RGB(0  ,  0,255),0xFFFFFFFF      ,_T("HEX-Bereich"	   ),3);
		ColorAdd(RGB(255,255,255),RGB(  0,  0,255),_T("Markierung"	   ),4);
		ColorAdd(RGB(255,255,255),RGB(100,100,200),_T("Bereich"		   ),5);
		ColorAdd(RGB(0,  0  ,255),RGB(230,230,255),_T("Bit-Marke"	   ),6);
		ColorAdd(RGB(0,  0  ,  0),RGB(230,230,255),_T("Bit-Marke-Text" ),7);
		}

	for(i=0;i<=HEX_SLOT_COUNT;i++)						// Marke und Bereiche initialisieren
		{
		m_uAreaUsed	[i] 	= 0;
		m_iAreaStart[i] 	= 0;
		m_iAreaEnd  [i] 	= 0;
		m_uAreaColor[i] 	= (i)? 4:3;
		}

	m_pBitFlags				= 0;						// BitFeld mit Marken
	m_iBitCount				= 0;						// Anzahl der Bitmarken in Byte

	m_pMem					= new uchar[1];				// Speicher
	m_iMemAddress 			= 0;						// Start-Offset des Speichers
	m_iMemSize   			= 0;						// Lnge des Speichers
	m_iMemBegin				= 0;						// Startverschub in der ersten Zeile

	m_pMoveItems			= 0;						// Liste mit allen Sprungzielen
	m_iCursorMode			= 0;						// Wo ist der Cursor (0=HEX 1=STR 2=ADR)
	m_iStausbarLen			= 4;						// Statusbar Initialisierung
	m_iStausbarMode			= 0x1002;

	m_iMouseX				=-1;
	m_iMouseY				=-1;

	m_iHasTabLoop			= 0;						// Werden Tab-Sprnge aus dem Fenster gemeldet
	m_iOnSizeCnt			= 0;						// Ist die Funktion OnSize aktiv
	m_iPosLastX				= 0;						// Letzte X-Position im Str oder Hex Bereich
	m_iLineWidth			= 1;						// Bytebreite einer Zeile
	m_iLineWidthTemp		= 1;						// Bytebreite einer Zeile (eingestellt)
	m_iLineAdrRaster		= 4;						// Addressen Raster
	m_iLineAdrRasterTemp	= 4;						// Addressen Raster
	m_iLineRasterSteps		= 4;						// Anzeige-Breiten-Raster
	m_iLineRasterStepsTemp	= 4;						// Anzeige-Breiten-Raster (eingestellt)
	m_iLenOfAdr				= 6;						// Breite des Adr-Bereiches
	m_iLineFormat			= 0;						// Ausgabeformat 0=byte 1=word 2=dword 3=qword
	m_iLineInvert			= 0;						// Maske fr's invertieren von Bytes
	m_iLineSpaceN			= 4;						// Zusatz-Space nach n Byte
	m_iLineSpaceNTemp		= 4;						// Zusatz-Space nach n Byte (eingestellt)
	m_iSelRaster			= 0;						// Die Auswahl auf das Ausgabeformat rastern

	m_iCursorX				= m_iPosOfHex;				// Cursor Position
	m_iCursorNipple			= 0;						// Cursor in oberen oder unteren 4-Bit (0=0..3 1=4..7)

	m_iUndoPos				= 0;						// Aktuelle Undo-Position
	m_iUndoMax				= 0;						// Maximale Undo-Position
	m_iUndoMin				= 0;						// Minimale Undo-Position

	memset(m_aUndo,0,sizeof(m_aUndo));					// Undo-Speicher rcksetzen


	SetMargin(2);
	SetWidth(16,4,1,6,0,0);


	if(m_iFlags&HEX_CONFIG)								// Konfiguration aus Registry holen
		{
		ConfigLoad();
		}


}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CHexView::~CHexView()
{

	#if HEX_ALLOW_GROW
	if(m_pOldMem)delete m_pOldMem;						// Vorheriger Speicher spter freigben
	#endif

	UndoClear();

	m_iWindowCount--;

	if(m_pMoveItems)delete m_pMoveItems;

	if((m_iFlags&HEX_MEM_FREE)&& m_pMem)delete m_pMem;
	if( m_iFlags&HEX_CONFIG)ConfigSave();				// Konfiguration in Registry schreiben


	if(m_iWindowCount<=0)
		{
		if(m_pFindText  )delete m_pFindText;			// Suchen  Strings
		if(m_pGroupText )delete m_pGroupText;			// Strings fr Gruppensuche
		if(m_pResultText)delete m_pResultText;			// Strings Suche
		}

	#ifdef	HEX_MULTI_ADDR
	if(m_pMultiOffToAdr){delete m_pMultiOffToAdr; m_pMultiOffToAdr = 0;}
	if(m_pMultiAdrToOff){delete m_pMultiAdrToOff; m_pMultiAdrToOff = 0;}
	#endif

}

//*****************************************************************************
//*
//*		PositionOk
//*
//*****************************************************************************
//	Mit dieser Funktion kann der Cursor verschoben werden.
//	iPosX/iPosY	: Sind die neuen absoluten bzw. rlativen Koordinaten vom Cursor
//	Art 		: Bestimmt wie der Cursor gesetzt werden soll
//					Bit 0 = 0 : Absolute Koortdnaten
//      			Bit 0 = 1 : Relative Koortdnaten
//      			Bit 1 = 1 : Ziehen mit Shift oder Maus
//      			Bit 2 = 1 : CLTR ist gedrckt
//      			Bit 3 = 1 : Eingabe ber Maus
//      			Bit 4 = 1 : Maus Taste zum ersten mal gedrckt
//      			Bit 5 = 1 : Keine 2 Zeichen Bewegung oder Markierungssprung
//      			Bit 6 = 1 : Keine-Notify Nachrichten senden
//					Bit 7 = 1 : Links/Rechts/Auf/Ab Taste wurde gedrckt
// Ergibt 1 wenn Koortdnaten verndert wurden.
int CHexView::PositionOk(int iPosX,int iPosY,int iMode)
{
OffI	iMarkOldStart;
OffI	iMarkOldEnd;
int		iMarkOldOn;
int		iCursorNewX;
int		iCursorNewY;
OffI	iOff;
int		x,y,z;



	if(iMode&1)
		{													// Relative Position
		iCursorNewX = m_iCursorX+iPosX;
		iCursorNewY = m_iCursorY+iPosY;

		if(m_iMarkOn && m_iCursorMode==0 && !(iMode&0x20))
			{
			if(iPosX== 1)iCursorNewX++;
			if(iPosX==-1)iCursorNewX--;
			}

		if(!(iMode&0x2A) && m_iMarkOn)						// Marke lschen und zum Anfang oder Ende
			{
			if((iPosX==-1 || iPosY==-1) && m_iMarkStart<m_iCursorOffset)
				{
				GetPosition(iCursorNewX,iCursorNewY,m_iMarkStart);
				}
			if((iPosX== 1 || iPosY== 1) && m_iMarkStart >m_iCursorOffset)
				{
				GetPosition(iCursorNewX,iCursorNewY,m_iMarkStart);
				}

			}
		}
	else{
		iCursorNewX = iPosX;								// Absolute Position
		iCursorNewY = iPosY;
		}


//******************* Maus-Eingabe *********************************************


	if(iMode&8)
		{
		if(iMode&16)										// Mauszeiger Markenbeginn
			{
			m_iMouseX = iCursorNewX;
			m_iMouseY = iCursorNewY;
			}

		if(iMode&2)
			{												// Mauszeiger Marke aus ?
			if(m_iMouseX==iPosX)
			if(m_iMouseY==iPosY)
				{
				iMode &= ~2;
				}
			}

		if(iCursorNewX<0)
			{
			iCursorNewX   = 0;
			}

		if(iCursorNewX<m_iLenOfAdr-HEX_SPACE1)				// In welchem Bereich
			{
			m_iCursorMode = 2;
			}
		else if(iCursorNewX>=m_iPosOfStr)
			{
			m_iCursorMode = 1;
			}
		else{
			m_iCursorMode = 0;
			}

		}


//****************** Prfe neue Cursor Position ********************************


	switch(m_iCursorMode)
		{
	case 0:													// Cursor war im Hex-Bereich

		if((iMode&1) && iPosX<-1 && iCursorNewX< m_iPosOfHex)iCursorNewX=m_iPosOfHex;
		if((iMode&1) && iPosX> 1 && iCursorNewX>=m_iPosOfStr)iCursorNewX=HexPosition(m_iLineWidth-1)+1;

		z = BinPosition(iCursorNewX);
		x = HexPosition(z);
		y = (iCursorNewX>x)? 1:0;

		if(iMode&8)
			{
			if(iCursorNewX>x+2 && z+1<m_iLineWidth){z++;y=0;}
			}
		else{
			if(iPosX>0 && iCursorNewX> x+1){z+=1+2*m_iLineInvert;y=0;              }
			if(iPosX<0 && iCursorNewX< x  ){z=m_iLineWidth-1    ;y=1;iCursorNewY--;}
			if(iPosX>0 && z>=m_iLineWidth ){z=m_iLineInvert     ;y=0;iCursorNewY++;}
			}

		if(m_iMarkOn && !(iMode&0x20))y=0;

		iCursorNewX     = HexPosition(z)+y;
		m_iCursorNipple = 1-y;

		break;

	case 1:													// Cursor war im STR-Bereich

		if(!(iMode&8))
			{
			if(iPosX<-1 && iCursorNewX< m_iPosOfStr){iCursorNewX=m_iPosOfStr;				 }
			if(iPosX> 1 && iCursorNewX>=m_iPosOfEnd){iCursorNewX=m_iPosOfEnd-1;				 }
			if(iCursorNewX>=m_iPosOfEnd            ){iCursorNewX=m_iPosOfStr  ;iCursorNewY++;}
			if(iCursorNewX< m_iPosOfStr            ){iCursorNewX=m_iPosOfEnd-1;iCursorNewY--;}
			}

		if(iCursorNewX>=m_iPosOfEnd)iCursorNewX=m_iPosOfEnd-1;
		if(iCursorNewX< m_iPosOfStr)iCursorNewX=m_iPosOfStr;

		m_iCursorNipple=0;

		break;

	case 2:													// Cursor war im ADR-Bereich

		if(iCursorNewX<       0)iCursorNewX=0;
		if(iCursorNewX>=m_iLenOfAdr-HEX_SPACE1)
			{
			iCursorNewX=m_iPosOfHex;
			m_iCursorMode=0;
			}

		m_iCursorNipple = m_iLenOfAdr-iCursorNewX-1-HEX_SPACE1;

		break;
		}


//*****************************************************************************


	if(m_iCursorMode==2)									// Startadresse
		{
		m_iCursorOffset  = (OffI)iCursorNewY;
		m_iCursorOffset *= m_iLineWidth;
		}
	else{
		m_iCursorOffset  = (OffI)GetAddress(iCursorNewX,iCursorNewY);
		m_iCursorOffset -= (OffI)m_iMemAddress;
		}

	if(m_iCursorOffset>=m_iMemSize)							// Adressen-Prfung
		{
		#if HEX_ALLOW_GROW									// Der Speicher soll wachsen

		if(m_bCanGrow && m_bAllowGrow && !(iMode&2))
			{
			iOff			= m_iMemSize;
			m_iCursorOffset	= m_iMemSize;
			m_iCursorNipple = 1;

			if(m_iCursorMode!=2)
				{
 				iCursorNewX = HexPosition((int)(iOff%(OffI)m_iLineWidth));
				}

			if(m_iScrollY>=m_iLineCount && m_iLineCount>0)	// Ist die Zeile noch sichtbar
				{
				y		     = m_iScrollY-m_iLineCount+1;
				m_iScrollY  -= y;
				iCursorNewY -= y;
				}
															// Ist der Curso noch im Bereich
			if(iCursorNewY>=m_iLineCount && m_iLineCount && BinPosition(iCursorNewX))
				{
				iCursorNewY = m_iLineCount-1;
				}
			}
		else

		#endif
			{
			iOff  = m_iMemBegin%m_iLineWidth-1;
			iOff += m_iMemSize;

			if(m_iCursorMode!=2)
				{
 				iCursorNewX = HexPosition((int)(iOff%(OffI)m_iLineWidth));
				if(m_iCursorMode==0)iCursorNewX++;
				}

			iCursorNewY     = (int)(iOff/(OffI)m_iLineWidth);
			m_iCursorOffset	= m_iMemSize-1;
			m_iCursorNipple = 1;
			}
		}

	if(m_iCursorOffset<0)
		{
		if(m_iCursorMode!=2)
			{
			iCursorNewX = HexPosition(m_iMemBegin%m_iLineWidth);
			}

		iCursorNewY     = 0;
		m_iCursorOffset = 0;
		m_iCursorNipple = (m_iCursorMode)? 0:1;
		}


//******************** Marken Steuerung	***************************************


	iMarkOldOn	  = m_iMarkOn;
	iMarkOldEnd	  = m_iMarkEnd;
	iMarkOldStart = m_iMarkStart;

	if(iMode&2)
		{
		if(!m_iMarkOn)										// Neue Make erzeugen ?
			{
			m_iMarkOn        = 1;
			m_iStausbarMode |= 0x1000;
			m_iMarkStart     = (OffI)GetAddress(m_iCursorX,m_iCursorY);
			m_iMarkStart    -= (OffI)m_iMemAddress;
			}

		m_iMarkEnd  = (OffI)GetAddress(iCursorNewX,iCursorNewY);
		m_iMarkEnd -= (OffI)m_iMemAddress;

		if(m_iCursorY==iCursorNewY)
			{
			m_iRedrawFlags |= NZ_LINE;
			}
		else{
			if(!(m_iRedrawFlags&NZ_LINE_YY) &&
			   ((m_iCursorY-iCursorNewY==-1)||				// Einzeilige Verschiebung ?
			    (m_iCursorY-iCursorNewY== 1)))
				 {
				 m_iRedrawFlags|=NZ_LINE;
				 m_iRedrawFlags|=NZ_LINE_NR|m_iCursorY;
				 }
			else m_iRedrawFlags =NZ_ALL;
			}
		}
	else if(!(iMode&0x20))
		{
		if(m_iMarkOn)
			{
			m_iMarkStart += m_iMemBegin%m_iLineWidth;
			m_iMarkStart /= m_iLineWidth;
			m_iMarkEnd   += m_iMemBegin%m_iLineWidth;
			m_iMarkEnd   /= m_iLineWidth;

			if(!(m_iRedrawFlags&NZ_LINE_YY) &&				// Einzeilige Marke ?
				(m_iMarkStart==m_iMarkEnd))
				{
				m_iRedrawFlags |= NZ_LINE;
				m_iRedrawFlags |= NZ_LINE_NR|m_iMarkStart;
				}
			else{
				m_iRedrawFlags = NZ_ALL;
				}
			}

		m_iMarkOn		= 0;
		m_iMarkEnd		= 0;
		m_iMarkStart	= 0;
		m_iStausbarMode|= 0x1000;
		}

	if(!(iMode&0x40))
	if(iMarkOldOn   != m_iMarkOn   ||
	   iMarkOldEnd  != m_iMarkEnd  ||
	   iMarkOldStart!= m_iMarkStart)
		{
		if(!m_iMarkOn)
			{
			SendNotify(HEX_SELCHANGE,0,0,0);
			}
		else{
			if(m_iMarkStart<m_iMarkEnd)
					SendNotify(HEX_SELCHANGE,m_iMarkStart,m_iMarkEnd  ,m_iMarkOn);
			else	SendNotify(HEX_SELCHANGE,m_iMarkEnd  ,m_iMarkStart,m_iMarkOn);
			}
		}

	if(m_iLineFormat && m_iMarkOn && m_iSelRaster)			// Die Auswahl auf das Ausgabeformat rastern
		{
		if(m_iMarkStart<m_iMarkEnd)
			{
			m_iMarkStart &= ~((1<<m_iLineFormat)-1);
			m_iMarkEnd   |=  ((1<<m_iLineFormat)-1);
			}
		else{
			m_iMarkStart |=  ((1<<m_iLineFormat)-1);
			m_iMarkEnd   &= ~((1<<m_iLineFormat)-1);
			}
		}

	m_iCursorX = iCursorNewX;								// Position speichern
	m_iCursorY = iCursorNewY;

	StatusbarSet();


return TRUE;
}

//*****************************************************************************
//*
//*		SendNotify
//*
//*****************************************************************************
void CHexView::SendNotify(int iType,MaxI iParam1,MaxI iParam2,int iParam3)
{
HEX_NMHDR	sNotify;
CWnd	   *pWnd;


	   pWnd=GetParent();
	if(pWnd)
		{
		sNotify.sHdr.code		= iType;
		sNotify.sHdr.hwndFrom	= m_hWnd;
		sNotify.sHdr.idFrom		= GetWindowLong(m_hWnd,GWL_ID);
		sNotify.iParam1			= iParam1;
		sNotify.iParam2			= iParam2;
		sNotify.iParam3			= iParam3;

		GetParent()->SendMessage(WM_NOTIFY,sNotify.sHdr.idFrom,(LPARAM)&sNotify);
		}

}

//*****************************************************************************
//*
//*		SendNotify
//*
//*****************************************************************************
void CHexView::SendNotify(int iType,int iParam)
{
HEX_NMHDR	sNotify;
CWnd	   *pWnd;


	   pWnd=GetParent();
	if(pWnd)
		{
		sNotify.sHdr.code		= iType;
		sNotify.sHdr.hwndFrom	= m_hWnd;
		sNotify.sHdr.idFrom		= GetWindowLong(m_hWnd,GWL_ID);
		sNotify.iParam1			= iParam;
		sNotify.iParam2			= 0;
		sNotify.iParam3			= 0;

		GetParent()->SendMessage(WM_NOTIFY,sNotify.sHdr.idFrom,(LPARAM)&sNotify);
		}

}

//*****************************************************************************
//*
//*		HexPosition
//*
//*****************************************************************************
//	Errechnet aus dem Byte-Offset in einer Zeile die X-Koordinate in der Ziele.
//	uOff	: Ist der Byte-Offset in der Zeile
//	Ergibt den Byte-Offset in der Zeile.
int CHexView::HexPosition(uint uOff)
{
int 	iPos;


	uOff %= m_iLineWidth;

	switch(m_iCursorMode)
		{
	case 0:	uOff ^= m_iLineInvert;							// Im HEX-Bereich
	  		iPos  = uOff<<1;

			if(m_iLineAddSpace)iPos+=uOff>>m_iLineFormat;
			if(m_iLineSpaceN  )iPos+=uOff/ m_iLineSpaceN;

			return iPos+m_iPosOfHex;

	case 1:	return m_iPosOfStr+uOff;						// Im STR-Bereich
			}



return  uOff;												// Im ADR-Bereich
}

//*****************************************************************************
//*
//*		BinPosition
//*
//*****************************************************************************
//	Errechnet aus einer X-Koordinate den Byte-Offset in der Zeile
//	iPosX		: X-Koordinate in der Zeile.
//	Ergibt den Byte-Offset von der X-Koordinate.
int	CHexView::BinPosition(int iPosX)
{
int  iVal;


	switch(m_iCursorMode)
			{

	case 0:	   iPosX-=m_iPosOfHex;							// Im HEX-Bereich
			if(iPosX<0)return 0;

			iVal = 2<<m_iLineFormat;

			if(m_iLineAddSpace)iVal +=1;
			if(m_iLineSpaceN  )iPosX-=(iPosX+1)/(iVal*(m_iLineSpaceN>>m_iLineFormat)+1);
			if(m_iLineAddSpace)iPosX-=(iPosX+1)/ iVal;

			   iPosX/=2;
			if(iPosX>=m_iLineWidth)return m_iLineWidth-1;

			return iPosX^m_iLineInvert;


	case 1:	   iPosX-=m_iPosOfStr;							// Im STR-Bereich
			if(iPosX<0)return 0;
			if(iPosX>=m_iLineWidth)return m_iLineWidth-1;

			return iPosX;
			}


return iPosX;												// Im ADR-Bereich
}

//*****************************************************************************
//*
//*		OnMoveTo
//*
//*****************************************************************************
//	Der Cursor wird mit einem Dialog auf eine neue Adresse gesetzt
void CHexView::OnMoveTo()
{
	MoveTo(-1);
}

//*****************************************************************************
//*
//*		MoveTo
//*
//*****************************************************************************
//	Der Cursor wird mit einem Dialog auf eine neue Adresse gesetzt.
//	iAddr	: Ist die neue Adresse fr den Cursor. (absolute  Adresse).
//			  Bei -1 wird die aktuelle Adresse in den Dialog bernommen.
//	Ergibt die Zieladresse bzw. -1 bei einem Abbbruch.
CHexView::AdrI CHexView::MoveTo(AdrI iAddr)
{
CHexItemDlg		sDlg(this);


	sDlg.m_pTitle	= _T("Cursor setzen" );
	sDlg.m_pText	= _T("Neue Adresse :");
	sDlg.m_iValue	= m_iCursorOffset;
	sDlg.m_iValue  += m_iMemAddress;
	sDlg.m_pItems	=&m_pMoveItems;
	sDlg.m_iMode	= 1;


	LCONVERT(sDlg.m_iValue);


	if(iAddr==-1 && m_iMarkOn)								// Adresse aus der Auswahl holen
		{
		sDlg.m_iValue = 0;

		GetSelection(&sDlg.m_iValue,sizeof(sDlg.m_iValue));

		if((unsigned)sDlg.m_iValue<(unsigned)m_iMemAddress)
			{
			sDlg.m_iValue += m_iMemAddress;
			}
		}

	if(iAddr!=-1)sDlg.m_iValue=iAddr;
	if(sDlg.DoModal()!=IDOK)return -1;

	SetCursor((AdrI)sDlg.m_iValue,1);

	LCONVERT(sDlg.m_iValue);



return (AdrI)sDlg.m_iValue;
}

//*****************************************************************************
//*
//*		OnPreparePrinting
//*
//*****************************************************************************
// Wird aufgerufen vor dem Drucken hie wird die Seiten anzahl berechent
#ifndef 	TO_HEXWND
BOOL CHexView::OnPreparePrinting(CPrintInfo *pInfo)
{
int iPosY,iEndY;


	if(m_iMarkOn)
		{
		m_iMarkStart -= m_iMemAddress;
		m_iMarkEnd   -= m_iMemAddress;
		iPosY         = m_iMarkStart;
		iEndY         = m_iMarkEnd;

		if(iPosY>=m_iMemSize)iPosY=m_iMemSize-1;
		if(iEndY>=m_iMemSize)iEndY=m_iMemSize-1;
		if(iPosY<0          )iPosY=0;
		if(iEndY<0          )iEndY=0;

		iPosY += m_iMemBegin%m_iLineWidth;
		iEndY += m_iMemBegin%m_iLineWidth;
		iPosY /= m_iLineWidth;
		iEndY /= m_iLineWidth;

		pInfo->m_pPD->m_pd.Flags &= ~PD_NOSELECTION;
		pInfo->m_pPD->m_pd.Flags |=  PD_SELECTION;

		m_sPrinterData.iMarkStartX = 0;
		m_sPrinterData.iMarkStartY = iPosY;
		m_sPrinterData.iMarkStopX  = 10000;
		m_sPrinterData.iMarkStopY  = iEndY;
		}


return CAnsiView::OnPreparePrinting(pInfo);
}
#endif

//*****************************************************************************
//*
//*		Update
//*
//*****************************************************************************
//	Fenster auf den neuersten Stand bringen.
//	iMode	: Wenn Bit 2 (0x04) gesetzt ist wird das Fenster neugezeichnet,
void CHexView::Update(int iMode)
{

	if(iMode&4)												// Neu zeichnen
		{
		DrawView(1);
		}

}

//*****************************************************************************
//*
//*		FindSelection
//*
//*****************************************************************************
//	Sucht ab der Cursor-Adresse nach der dem gerade marierten Abschinitt.
//	Der Abschinitt wird in einen Suchtext umgewandelt und in *m_pResultText abgelegt.
//	Ergibt 1 wenn Text gefunden sontst 0
void CHexView::OnFindMark(){FindSelection();}
int	 CHexView::FindSelection()
{
TCHAR		cBuffer[256];
TCHAR		cText[32];
OffI		iStart;
OffI		iLen;
int			iNum;
int			iSet;
int			i;




	if(!m_iMarkOn)return FindView();

	m_iFindFlags |= HEX_FIND_SELLECTED;

	if(m_iMarkEnd>m_iMarkStart)
		{
		iSet   = 1;
		iLen   = m_iMarkEnd-m_iMarkStart+1;
		iStart = m_iMarkStart;
		}
	else{
		iSet   = 0;
		iLen   = m_iMarkStart-m_iMarkEnd+1;
		iStart = m_iMarkEnd;
		}

	if(iLen>64)iLen=64;

	for(i=0;i<iLen;i++)										// Ist die Auswahl ein ASCII-Text
		{
		if(m_pMem[iStart+i]<' ')break;
		if(m_pMem[iStart+i]>127)break;
		}

	if(i<iLen)
		{													// Kein ASCII-Text
		cBuffer[0]=':';
		htostr(m_pMem+iStart,cBuffer+1,(int)iLen,HEX_SPACE|HEX_NULL);
		}
	else{													// Auswahl ist ASCII-Text
		cBuffer[     0]='\"';
		cBuffer[iLen+1]='\"';
		cBuffer[iLen+2]=0;
		memcpy(cBuffer+1,m_pMem+iStart,(int)iLen);
		}


	   iNum =   ChainFind  (&m_pFindText,cBuffer);			// Suchtext erstellen
	if(iNum!=-1)ChainDelete(&m_pFindText,iNum);
			    ChainInsert(&m_pFindText,cBuffer,0);

	_tcscpy(cBuffer,_T("T:0x        :        "));
	if(i>iLen)cBuffer[0]='U';


	htostr(m_pMem+iStart,cBuffer+13,(int)iLen,HEX_SPACE|HEX_NULL);
	htostr(&iLen        ,cBuffer+4 ,2        ,HEX_INVERT);

	if(m_iFindFlags&HEX_FIND_NO_CASE)						// Gro/Keinunterscheidung
		{
		cBuffer[ 9]='/';
		cBuffer[10]='G';
		}

	itostr((int)iLen,cText);

	ChainClear (&m_pResultText);
	ChainInsert(&m_pResultText,cText,0);
	ChainInsert(&m_pResultText,cBuffer,1);

	if(iSet)SetCursor(iStart);


return FindNext();
}

//*****************************************************************************
//*
//*		FindNext
//*
//*****************************************************************************
//	Sucht ab der Cursor-Adresse nach Suchtext aus *m_pResultText.
//	Ergibt 1 wenn Text gefunden sontst 0
void CHexView::OnFindNext(){FindNext();}
int	 CHexView::FindNext()
{
OffI	iStart;
OffI	iEnd;
OffI	iLen;
OffI	iRet;


	if(!m_pResultText)return FindView();					// Ohne Suchtext ber Dialog suchen

	iStart	= m_iCursorOffset+1;
	iEnd	= m_iCursorOffset;
	iLen	= m_iMemSize;
	iRet	= FindText(m_pResultText,iStart,iLen,1);		// Suche starten

	if(iRet==-1 && iStart>0)								// Ende des speichers erreicht ?
		{
		   iRet=MessageBox(_T("Ende erreicht. Am Anfang weiter suchen ?"),0,MB_OKCANCEL|MB_ICONQUESTION);
		if(iRet==IDCANCEL)return 0;

		iStart = 0;
		iLen   = iEnd+1;
		iRet   = FindText(m_pResultText,iStart,iLen,1);		// Suchen im unteren Teil (Vor Cursor)
		}

	if(iRet==-1)
		{
		MessageBox(_T("Bereich wurde nicht gefunden !"),0,MB_OK|MB_ICONINFORMATION);
		}


return (iRet!=-1)? 1:0;
}

//*****************************************************************************
//*
//*		FindView
//*
//*****************************************************************************
//	Sucht ab der Cursorposition
//	Ergibt 1 wenn Text gefunden sontst 0
void CHexView::OnFindView(){FindView();}
int	 CHexView::FindView()
{
CHexFindDlg		sDlg(this);
TCHAR			cBuffer[256];
TCHAR		   *pText=0;
OffI			iStart;
OffI			iLen;
OffI			iEnd;
OffI			iVal;
int				iBegin;
int				iOver;
int				iMark;
int				iAll;
int				iRet;
int				iUp;
int				i;


	if(!m_iMarkOn)											// Keine Markierung
		{
		m_iFindFlags &= ~HEX_FIND_SELLECTED;
		}
	else{
		m_iFindFlags |= HEX_FIND_SELLECTED;					// Markierung ist vorhanden

		if(m_iMarkEnd>m_iMarkStart)
			{
			iLen   = m_iMarkEnd-m_iMarkStart+1;
			iStart = m_iMarkStart;
			}
		else{
			iLen   = m_iMarkStart-m_iMarkEnd+1;
			iStart = m_iMarkEnd;
			}

		if(iLen>64)iLen=64;

		for(i=0;i<iLen;i++)									// Ist die Marke ein ASCII-Text
			{
			if(m_pMem[iStart+i]<' ' || m_pMem[iStart+i]>127)break;
			}

		if(i<iLen)
			{
			htostr(m_pMem+iStart,cBuffer+1,(int)iLen,HEX_SPACE|HEX_NULL);
			cBuffer[0] = ':';
			}
		else{
			cBuffer[     0] = '\"';
			cBuffer[iLen+1] = '\"';
			cBuffer[iLen+2] = 0;

			for(i=0;i<iLen;i++)
				{
				cBuffer[i+1] = m_pMem[iStart+i];
				}
			}

		pText=cBuffer;
		}



	for(;;)
		{
		iRet = sDlg.DoModal(&m_iFindFlags,&m_pFindText,&m_pGroupText,&m_pResultText,pText);

		if(iRet==IDCANCEL)return 0;

		iUp    = (m_iFindFlags&HEX_FIND_UPWARDS);
		iMark  = (m_iFindFlags&HEX_FIND_IN_SEL );
		iAll   = (m_iFindFlags&HEX_FIND_IN_ALL );
		iBegin = (m_iFindFlags&HEX_FIND_BEGIN  );

		if(iUp)												// Aufwrts suchen
			{
			iStart =  m_iCursorOffset-1;
			iEnd   =  m_iCursorOffset;
			iLen   = -m_iMemSize;
			iOver  =  iAll;
			}
		else{												// Abwrts suchen
			iStart = m_iCursorOffset+1;
			iEnd   = m_iCursorOffset;
			iLen   = m_iMemSize;
			iOver  = iAll;
			}

		if(iBegin)											// Vom Anfang Suchen
			{
			iStart =  0;
			iEnd   =  m_iMemSize;
			iLen   =  m_iMemSize;
			iOver  =  0;
			}

		if(iMark && m_iMarkOn)								// Im Bereich suchen
			{
			iStart = (iUp)? m_iMarkEnd+1:m_iMarkStart;
			iEnd   = (iUp)? m_iMarkStart:m_iMarkEnd+1;
			iLen   =  iEnd-iStart;
			iOver  =  0;
			}

		iVal = FindText(m_pResultText,iStart,iLen,1);		// Suchen

		if(iVal==-1 && iOver)								// berlauf ?
			{
			iStart = (iUp)?  m_iMemSize:0;
			iLen   = (iUp)? -m_iMemSize+iEnd:iEnd;
			iVal   = FindText(m_pResultText,iStart,iLen,1);	// Suchen 2. Teil
			}

		if(iVal==-1)
			{
			MessageBox(_T("Bereich wurde nicht gefunden !"));
			Select(-2);
			}

		if(!(iRet&0x8000))break;
		}



return (iVal!=-1)? 1:0;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht in einem Bereich nach Daten.
//	pBytes		: Zeiger auf die Daten nach denen gesucht wird
//	iLen		: Ist die Lnge der Suchdaten.
//	iStart		: Ist der Anfangs-Offset des Suchbereichs
//	iCount		: Ist die Lnge des Suchbereichs.
//				  Ist die Lnge kleiner 0 so wird rckwrts gesucht.
//	iMode		: Dieser Wert bestimmt die Art der Suche
//					0	Eins zu eins Suche
//					1	Gros/Kleinbuchstaben ignorieren
//					2	Masken-Suche, die Bit-Maske kommt nach Bytes (Bytes+Len)
//  Ergibt die Offset-Adresse im Speicher bzw. -1 wenn nichts gefunden wurde.
CHexView::OffI CHexView::Find(char *pBytes,int iLen,OffI iStart,OffI iCount,int iMode)
{
uchar            aTemp[3];
char			*pMask;
char			 cChar;
char			 cByte;
OffI			 iSize;
OffI			 iPos;
int				 iDir;



	if(iLen<=0)return iStart;
	if(m_pMem==0)return -1;

	iSize	= m_iMemSize;
	iSize  -= iLen-1;

//********************* Bereichsprfung ****************************************

	if(iCount>0)
		{
		iDir=1;
		if(iStart       >=iSize)return -1;
		if(iStart+iCount>=iSize){iCount =iSize -iStart;}
		if(iStart       < 0    ){iCount+=iStart;iStart=0;}
		if(iStart+iCount<=0    )return -1;
		if(       iCount<=0    )return -1;
		}
	else{
		iDir=-1;
		iCount=-iCount;
		if(iStart       < 0    )return -1;
		if(iStart-iCount< 0    ) iCount =iStart+1;
		if(iStart       >=iSize){iCount-=iStart-iSize;iStart=iSize-1;}
		if(iStart-iCount>=iSize)return -1;
		if(       iCount<=0    )return -1;
		}

//******************** Suchen *********************************************

	if(iMode==0)
		{
		if(iLen>4)
			{
			int iVal=*(int*)pBytes;

			iLen   -= 4;
			pBytes += 4;

			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if(*(int*)(m_pMem+iPos)    !=    iVal)continue;
				if(memcmp (m_pMem+iPos+4,pBytes,iLen))continue;
 				return iPos;
				}
			}
		else if(iLen==4)
			{
			int iVal=*(int*)pBytes;

			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if(*(int*)(m_pMem+iPos)!=iVal)continue;
 				return iPos;
				}
			}
		else if(iLen==2)
			{
			short sVal=*(short*)pBytes;

			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if(*(short*)(m_pMem+iPos)!=sVal)continue;
 				return iPos;
				}
			}
		else if(iLen==1)
			{
			uchar uVal=*pBytes;

			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if(m_pMem[iPos]!=uVal)continue;
 				return iPos;
				}
			}
		else{
			memcpy(aTemp,pBytes,3);

			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if(aTemp[0]!=m_pMem[iPos  ])continue;
				if(aTemp[1]!=m_pMem[iPos+1])continue;
				if(aTemp[2]!=m_pMem[iPos+2])continue;
				return iPos;
				}
			}
		}

//******************** Suchen (igoriere Gros/Kleinbuchstaben) *****************

	if(iMode==1)
		{
		iLen--;
		cByte = pBytes[0];

		if( cByte>='A' && cByte<='Z' )cByte+=32;

		for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
			{
			   cChar=m_pMem[iPos];
			if(cChar!=cByte)
				{
				if(cChar>='A' && cChar<='Z')cChar+=32;
				if(cChar!=cByte)continue;
				}

			if(memicmp(m_pMem+iPos+1,pBytes+1,iLen))continue;

			return iPos;
			}
		}

//******************** Masken-Suche *******************************************

	if(iMode==2)
		{
		pMask=pBytes+iLen;

		if(iLen>=4)
			{
			int iVal =*(int*)pBytes;
			int iMask=*(int*)pMask;

			iLen   -=4;
			pMask  +=4;
			pBytes +=4;

			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if((*(int*)(m_pMem+iPos) ^ iVal)&iMask      )continue;
				if( memmcmp(m_pMem+iPos+4,pBytes,pMask,iLen))continue;
 				return iPos;
				}
			}
		else{
			for(iPos=iStart;iCount>0;iPos+=iDir,iCount--)
				{
				if(memmcmp(m_pMem+iPos,pBytes,pMask,iLen))continue;
 				return iPos;
				}
			}
		}


return -1;
}

//*****************************************************************************
//*
//*		FindText
//*
//*****************************************************************************
//	Sucht in einem Bereich nach Daten die mittels eines Suchtextes bergeben werden.
//	Text 		: Zeiger auf den Suchtext mit dem folgendem Format:
//
//					[Bereichs-Lnge]                        /00
//          		[Art-Byte]:[Lnge]   [/G][/B] :Hex-Dump /00
//					[Art-Byte]:[Lnge]   [/G][/B] :Hex-Dump /00 ...
//          		/00
//          		/G       :  fr Gro/Kleinschreibung ignorieren
//          		/B       :  fr Modorola Format
//          		Art-Byte :  'D'-Dezimal  'H'-Hexadez. 'B'=Binr 'T'=Text 'U'=Hex-Dump 'M'=Masken-Dump
//
//					Bei Masken-Dumps muss Lnge halbiert werden
//  				Ist Laenge kleiner 0 so wird nach unten gesucht.
//  				Markieren gibt an ob der Bereich markiert werden
//  				soll wenn er gefunden wird.
//
//	iStart		: Ist der Anfangs-Offset des Suchbereichs
//	iSize		: Ist die Lnge des Suchbereichs.
//				  Ist die Lnge kleiner 0 so wird rckwrts gesucht.
//	iSelect		: Soll der gefundene Bereich ausgewhlt werden.
//  Ergibt die Offsetadresse in pMem bzw. -1 wenn nichts gefunden wurde
CHexView::OffI CHexView::FindText(LPTSTR pText,OffI iStart,OffI iSize,int iSelect)
{
char   *pBytes;
TCHAR	cType;
int		aMode[HEX_GROUP_MAX];
int		aSize[HEX_GROUP_MAX];
OffI	aAddr[HEX_GROUP_MAX];
OffI	iBegin;
OffI	iStop;
OffI	iArea;
OffI	iEnd;
OffI	iEndO;
OffI	iEndU;
int		iLast;
int		iLines;
OffI	iPosO=0;
OffI	iPosU=0;
int		iPos;
int		iCnt;
OffI	j;
int 	i;




	if(!pText)return -1;


	iStop = iStart+iSize;
	iArea = strtoi(pText,0xC000);							// Bereichslnge holen
	iCnt  = ChainCount(&pText)-1;

	if(iCnt<1			 )return -1;
	if(iCnt>HEX_GROUP_MAX)iCnt=HEX_GROUP_MAX;

	pBytes = new char[256*iCnt];

	for(i=0;i<iCnt;i++)
		{
		aMode[i] =  0;
		pText   += _tcslen (pText)+1;
		pText   +=  strwlen(pText,0xA0);					// Leerzeichen berspringen
		cType    =  pText[0];
		pText   +=  strchar(pText,':');if(pText[0]==':')pText++;
		aSize[i] =  strtoi (pText,0xC000);					// Speicherlnge holen
		iLast    =  strchar(pText,':');
		iPos     =  strchar(pText,'G');if(iPos<iLast && 'G'== pText[iPos])aMode[i]|=1;
		pText   +=  iLast;StrToBin(pText,pBytes+i*256,256);

		if(cType=='M')										// Masken-Dump
			{
			aMode[i]   = 2;
			aSize[i] >>= 1;
			}
		}


//******************** Suchen *************************************************


	::SetCursor(IDC_WAIT);

	do	{
		   aAddr[0]=Find(pBytes,aSize[0],iStart,iSize,aMode[0]);
		if(aAddr[0]==-1)break;
		if(iCnt    <= 1)break;

		if(m_iFindFlags&HEX_FIND_IN_ORDER)					// Suche mit richtiger Reihenfolge
			{
			iEnd = aAddr[0]+iArea;

			if(iEnd>iStop)iEnd=iStop;

			for(i=1;i<iCnt;i++)
				{
				iBegin = aAddr[i-1] +aSize[i-1];
				j      = iEnd-iBegin-aSize[i]+1;

				if(j<0)break;
				   j=Find(pBytes+i*256,aSize[i],iBegin,j,aMode[i]);
				if(j==-1)break;

				aAddr[i]=j;
				}
			}
		else{												// Suche ohne richtiger Reihenfolge
			iBegin = aAddr[0];
			iEndO  = aAddr[0]+iArea;
			iEndU  = aAddr[0]-iArea;

			if(iEndO>iStop )iEndO=iStop;
			if(iEndU>iStart)iEndU=iStart;

			for(i=1;i<iCnt;i++)								// Suche ohne richtiger Reihenfolge
				{
				iPosO = -1;
				iPosU = -1;

				   j = iEndO-iBegin-aSize[i];
				if(j>0)iPosO=Find(pBytes+i*256,aSize[i],iBegin+aSize[0],j,aMode[i]);

				if(iPosO==-1)
					{
					   j= iBegin-iEndU-1;
					if(j<0)iPosU=Find(pBytes+i*256,aSize[i],iBegin-1,j,aMode[i]);
					}

				if(iPosO==-1)
					{
					if(iPosU==-1)break;
					aAddr[i]=iPosU;
					}
				else{
					if(iPosU==-1)aAddr[i]=iPosO;
					else aAddr[i]=(iBegin-iPosU < iPosO-iBegin)? iPosU:iPosO;
					}
				}
			}


		//******************** Nchste Suche **********************************


		if(i>=iCnt)break;									// Alles gefunden ?

		j  =  aAddr[0]-iStart;
		j += (iSize<0)? -1:1;

		if(iSize*iSize<j*j)
			{
			aAddr[0] = -1;
			break;
			}

		iStart += j;
		iSize  -= j;

		}while(1);


	::SetCursor(IDC_ARROW);


//******************* Ergebnis markieren **************************************


	if(iSelect)
		{
		Select(-2);

		if(aAddr[0]!=-1)
			{
			for(i=0;i<iCnt;i++)Select(i,aAddr[i],aSize[i]);

			SetCursor(aAddr[0]);
			SetSelection(aAddr[0]+aSize[0]);


			iLines = (int)(((m_iMemBegin+aAddr[0])%(OffI)m_iLineWidth+(OffI)aSize[0]-1)/(OffI)m_iLineWidth);

			if(iLines>0 && iLines<m_iScreenY/2)				// Prfen ob Makierung sichtbar
				{
				j = m_iScreenY;

				if(j>3 && m_iScreenSizeY%m_iFontSizeY)j--;

				if(m_iCursorY-m_iScrollY+iLines>=j)			// Muss Fenster gescrollt werden ?
					{
					j  = m_iCursorY+iLines-j+1;
					j *= m_iLineWidth;
					j += m_iMemBegin;

					SetScroll(j,0);
					}
				}
			}
		}


	delete pBytes;


return aAddr[0];
}


//*****************************************************************************
//*
//*		Menu????
//*
//*****************************************************************************
//	Funktionen zum ein/ausschalten von Men Funktionen
void CHexView::OnMenuSelection(CCmdUI *pCmdUI){pCmdUI->Enable(m_iMarkOn       );}
void CHexView::OnMenuFind     (CCmdUI *pCmdUI){pCmdUI->Enable(m_pResultText!=0);}
void CHexView::OnMenuClipboard(CCmdUI *pCmdUI){pCmdUI->Enable(m_iMemSize>0 && !(m_iFlags&HEX_NOT_CHANGE) && IsClipboardFormatAvailable(CF_TEXT));}
void CHexView::OnMenuUndo     (CCmdUI *pCmdUI){pCmdUI->Enable(m_iUndoMin!=m_iUndoPos);	}
void CHexView::OnMenuUndoBack (CCmdUI *pCmdUI){pCmdUI->Enable(m_iUndoMax!=m_iUndoPos);	}


//*****************************************************************************
//*
//*		StatusbarSet
//*
//*****************************************************************************
//	Aktualisiert die Statuszeile
int CHexView::StatusbarSet()
{
TCHAR		 cBuffer[64];
TCHAR		 cStr[256];
TCHAR		 cHex[64];
AdrI		 iAdr;
OffI		 iOff;
OffI		 iPos;
OffI 		 iNum;
int			 iLen;
int			 i;
int			 j;



	if(!m_cFocusOn      )return 0;
	if(!m_iStatusbarInit)return 0;


//******************** Adress-Anzeige *****************************************


	if(m_iStausbarOff!=m_iCursorOffset || (m_iStausbarMode&0x1000))
		{
		iAdr = (AdrI)m_iCursorOffset+m_iMemAddress;

		LCONVERT(iAdr);

		_tcscpy(cStr,_T(" Adr: "));atostr(iAdr,cBuffer,1);
		_tcscat(cStr,cBuffer     );
		_tcscat(cStr,_T(" / "   ));

		if(m_iMarkOn)
			{
			iOff = m_iMarkEnd-m_iMarkStart;

			if(iOff<0){iOff=-iOff+1;_tcscat(cStr,_T("M: -"));}
			else      {iOff= iOff+1;_tcscat(cStr,_T("M: +"));}

			otostr(iOff,cBuffer,(m_iStausbarMode&0x2000)? 1:0);
			}
		else{
			atostr(iAdr,cBuffer);
			}

		_tcscat(cStr,cBuffer);
		STATUSBAR_SET(0,cStr,true);
		m_iStausbarOff=m_iCursorOffset;
		}


//******************** Wert-Anzeige *******************************************


	if(m_iMarkOn)										// Ist Bereich markiert ?
		{
		iNum = (int)m_iMarkEnd-m_iMarkStart;

		if(iNum>0){iOff=m_iMarkStart;iLen= (int)iNum+1;}
		else	  {iOff=m_iMarkEnd  ;iLen=-(int)iNum+1;}
		if(iLen>4){iLen=4;}
		if(iLen<1){iLen=1;}
		}
	else{												// Keine Marke
		iLen = "\x1\x2\x4\x4"[m_iStausbarMode&3];
		iOff = m_iCursorOffset;
		}

	for(;;)
		{
		if(iOff<0){i=0;break;}
		if(iOff<m_iMemSize-(OffI)m_iStausbarLen)
			{
			if(m_iStausbarMode&0x4000)					// Big Endian Format
				{
				for(i=0,j=0,iPos=iOff;j<iLen;j++,iPos++)
					{
					i<<= 8;
					i |= m_pMem[iPos];
					}
				}
			else{
				i = *(int*)(m_pMem+iOff);
				}

			break;
			}

		for(i=0,j=0,iPos=iOff;iPos<m_iMemSize;iPos++,j+=8)
			{
			i+=(long)m_pMem[iPos]<<j;
			}

		if(m_iStausbarMode&0x4000)						// Big Endian Format
			{
			for(i=0,j=0,iPos=iOff;iPos<m_iMemSize && j<iLen;iPos++,j++)
				{
				i<<=8;
				i |=m_pMem[iPos];
				}
			}
		else{
			for(i=0,j=0,iPos=iOff;iPos<m_iMemSize;iPos++,j+=8)
				i+=(long)m_pMem[iPos]<<j;
			}

		break;
		}

	iLen  = 0xFFFFFFFF>>(32-(iLen<<3));
	i    &= iLen;

	if(~m_iStausbarMode&0x8000 && (i&(~iLen>>1)))i|=~iLen;
	if( m_iStausbarValue!=i || (m_iStausbarMode&0x1000))
		{
		itostr(i,cHex,0x8010);

		if(m_iStausbarMode&0x8000)
			  itostr(i,cBuffer,15);
		else  itostr(i,cBuffer, 0);


		_tcscpy(cStr,_T(" Wert: 0x"));
		_tcscat(cStr,cHex           );
		_tcscat(cStr,_T(" / "      ));
		_tcscat(cStr,cBuffer        );

		STATUSBAR_SET(1,cStr,true);

		m_iStausbarValue=i;
		}

	m_iStausbarMode &= ~0x1000;
	m_iStausbarCnt   =  0;


return 1;
}

//*****************************************************************************
//*
//*		StatusbarInit
//*
//*****************************************************************************
// Erzeugt eine neue Statuszeile
int CHexView::StatusbarInit()
{
UINT		 aWidth[] =	{-20,-23};
UINT		 aInd  [] =	{0,0};


	STATUSBAR_INIT(aInd,aWidth,2);

	m_iStausbarMode |= 0x1000;
	m_iStausbarCnt   = 0;
	m_iStatusbarInit = 1;

	StatusbarSet();


return 1;
}

//*****************************************************************************
//*
//*		StatusbarExit
//*
//*****************************************************************************
//	Erzeugt eine neue Statuszeile
int CHexView::StatusbarExit()
{

	STATUSBAR_INIT(0,0,0);


	m_iStatusbarInit  = 0;
	m_iStausbarMode  |= 0x1000;
	m_iStausbarCnt    = 0;


return 1;
}

//*****************************************************************************
//*
//*		LineLength
//*
//*****************************************************************************
//	Ergibt die Lnge einer Zeile in Zeichen. (ADR,HEX und STR)
int CHexView::LineLength(int iLine)
{

return m_iPosOfEnd;
}

//*****************************************************************************
//*
//*		SetAddress
//*
//*****************************************************************************
//  Setzt die Basis-Anzeige-Adresse des Speichers. Das ist die angezeigte
//	Adresse des ersten Bytes (bei Offset 0) des Speichers.
//	iAddress		: Ist die neue Adresse.
//  Ergibt die zuvor eingestellte Adresse.
CHexView::AdrI CHexView::SetAddress(AdrI iAddress)
{
AdrI	iAddrCursor;
AdrI	iAddrScroll;
AdrI	iAddrMark;
AdrI	iAddrBase;
AdrI	iDelta;
int		iMode;
int		iOld;


	if(m_iMemAddress==iAddress)return iAddress;


	iAddrCursor = (AdrI)GetCursor(1);
	iAddrScroll = (AdrI)GetScroll(1);
	iAddrMark   = (AdrI)GetSelection(1);
	iAddrBase	= m_iMemAddress;

	iOld		=  m_iFlags;								// Gleichen Speicher bergeben (ohne Freigabe)
	iMode		= (m_iFlags&HEX_NOT_CHANGE)? 0:1;
	m_iFlags   &= ~HEX_MEM_FREE;

	SetMem(m_pMem,m_iMemSize,iAddress,iMode);

	m_iFlags	= iOld;
	iDelta		= iAddress-iAddrBase;

	SetCursor   (iAddrCursor+iDelta,1);						// Scroll/Cursor Daten wieder herstellen
	SetScroll   (iAddrScroll+iDelta,1);
	SetSelection(iAddrMark  +iDelta,1);


return iAddrBase;
}

//*****************************************************************************
//*
//*		SetScroll
//*
//*****************************************************************************
//  Setzt die Adresse der linken oberen Ecke
//	Adresse		: Ist die Adresse zu der gescrollt werden soll
//	iMode		: Bestimmt die Art der Adresse
//					Ist iMode==0    ist Adresse ein  Speicher-Offset
//					Ist iMode!=0	ist Adresse eine Speicheradresse
//  Ergibt die alte Adresse.
CHexView::MaxI CHexView::SetScroll(MaxI iAddress,int iMode)
{
OffI	iOffset;
OffI	iVal;
MaxI	iOld;
int		x,y;


	if(iMode)
		{
		ACONVERT(iAddress);
		}
	else{
		iAddress += (AdrI)m_iMemAddress;
		}

	if(iAddress>=m_iMemAddress+(AdrI)m_iMemSize  )iAddress=m_iMemAddress+(AdrI)m_iMemSize  -1;
	if(iAddress<=m_iMemAddress-(AdrI)m_iLineWidth)iAddress=m_iMemAddress-(AdrI)m_iLineWidth+1;

	if(m_iMemSize==0)iAddress=0;


	if(m_iFlags&HEX_SNAP_IN)								// Einrasten Funktion
		{
		iAddress -= m_iLineWidth*m_iScrollY;
		iAddress -= iAddress%(AdrI)m_iLineAdrRaster;

		if(iAddress<0)
			{
			iAddress -= m_iLineAdrRaster;
			}

		iAddress += m_iLineWidth*m_iScrollY;
		}


	iOld  = m_iLineWidth*m_iScrollY;
	iOld -= m_iMemBegin %m_iLineWidth;
	iOld += m_iMemAddress;

	if(iOld==iAddress)return iOld;							// Keine nderung der Scroll-Position

	iOffset	= (OffI)(iAddress-m_iMemAddress);
	x		= m_iLineWidth;
	x	   -= (int)(iOffset%(OffI)m_iLineWidth);
	x	   %= m_iLineWidth;
	y		= (int)((iOffset+(OffI)x)/(OffI)m_iLineWidth);


	if(m_iFlags&HEX_SNAP_IN)
		{
		x %= m_iLineAdrRaster;
		}

	if(x!=m_iMemBegin)										// Neuer Anfangs-Verschub
		{
		m_iMemBegin     = x;
		m_iRedrawFlags  = NZ_ALL;
		}

	iVal  = m_iMemSize;
	iVal += m_iMemBegin%m_iLineWidth;
	iVal += m_iLineWidth-1;
	iVal /= m_iLineWidth;
	x     = (int)iVal;

	if(x!=m_iLineCount)
		{
		m_iLineCount    = x;
		m_iRedrawFlags |= NZ_LINE_NEXT;
		}


	if(y!=m_iScrollY)										// Neue Scroll-Position
		{
		   m_iScrollY =y;
		if(m_iScrollY>=m_iLineCount)m_iScrollY=m_iLineCount-1;
		if(m_iScrollY<0)m_iScrollY=0;

		m_iRedrawFlags = NZ_ALL;
		}

	PositionOk(m_iCursorX,m_iCursorY,0x60);
	PositionCheck(2);
	DrawView(1);



return iOld;
}


//*****************************************************************************
//*
//*		GetPosition
//*
//*****************************************************************************
//	Berechenet aus der Adresse die X/Y Koordinaten (Zeile/Spalte)
//	iPosX/iPosY		: Hier werden die Koordinaten gespeichert.
//	iOffset			: Ist der Offset im Speicher, nicht die Anzeigeadresse.
void CHexView::GetPosition(int &iPosX,int &iPosY,OffI iOffset)
{

	iOffset    += m_iMemBegin        %m_iLineWidth;
	iPosY		= (int)(iOffset/(OffI)m_iLineWidth);
	iOffset    %= m_iLineWidth;
	iPosX		= HexPosition((int)iOffset);

}

//*****************************************************************************
//*
//*		GetAddress
//*
//*****************************************************************************
//	Berechenet die Adresse des Bytes auf einer Koordinate (nicht den Offset)
//	iPosX/iPosY		: Sind die Werte fr die Koordinate
//	Ergibt die Adresse (absolute Adresse)
CHexView::AdrI CHexView::GetAddress(int iPosX,int iPosY)
{
AdrI	iAddr;
int		iVal;


	iAddr  = iPosY;
	iAddr *= m_iLineWidth;
	iAddr -= m_iMemBegin%m_iLineWidth;
	iAddr += m_iMemAddress;


	if(iPosX>=m_iPosOfHex && iPosX<m_iPosOfStr)				// Im HEX-Bereich
		{
		iPosX -= m_iPosOfHex;
		iVal   = 2<<m_iLineFormat;

		if(m_iLineAddSpace)iVal +=1;
		if(m_iLineSpaceN  )iPosX-=(iPosX+1)/(iVal*(m_iLineSpaceN>>m_iLineFormat)+1);
		if(m_iLineAddSpace)iPosX-=(iPosX+1)/ iVal;

		iPosX /= 2;
		iPosX ^= m_iLineInvert;

		if(iPosX>=m_iLineWidth)
				iAddr += m_iLineWidth-1;
		else    iAddr += iPosX;
		}

	if(iPosX>=m_iPosOfStr && iPosX<m_iPosOfEnd)				// Im STR-Bereich
		{
		iAddr += iPosX-m_iPosOfStr;
		}


return iAddr;
}

//*****************************************************************************
//*
//*		SetWidth
//*
//*****************************************************************************
//	Stellt die neue Breite fr das Fenster ein. Ist iSpaceN,iSpace,iWidth iFormat
//	oder iAddrLen <= -1 so werden die alten Werte verwendet.
//	iWidth		: Ist die Anzahl an Bytes die pro Zeile dargestell werden soll.
//	iSpaceN		: Ist die Byte Zahl bei der ein Extraabstand kommt.
//	iSpace		: Bestimmt ob zwischen den Werrten eine extra Leerzeichen kommt.
//	iAddrLen	: Ist die Lnge fr die Addrese in (Zeichen)
//	iFormat		: Ist das Ausgabeformat. (0=BYTE 1=WORT 2=DWORD,3=QWORD)
//	iInvert		: Sollen die angezeigten Werte in der Byte-Reihenfolge
//				  invertiert dargestellt werden.
//	Ergibt die alte Breite
int CHexView::SetWidth(int iWidth,int iSpaceN,int iSpace,int iAddrLen,int iFormat,int iInvert)
{
int		iSpaceNTemp;
int		iWidthTemp;
int		i,j,k,iOld;



	if(iSpace  <=-1)iSpace   = m_iLineAddSpace;				// Alte Werte bernehmen
	if(iSpaceN <=-1)iSpaceN  = m_iLineSpaceNTemp;
	if(iWidth  <=-1)iWidth   = m_iLineWidthTemp;
	if(iFormat <=-1)iFormat  = m_iLineFormat;
	if(iInvert <=-1)iInvert  = m_iLineInvert;
	if(iAddrLen<=-1)iAddrLen = m_iLenOfAdr-HEX_SPACE1;
	if(iAddrLen>  8)iAddrLen = 8;
				    iAddrLen+= HEX_SPACE1;

	if(m_iLineRasterSteps<0)
		{
		m_iLineRasterSteps     = 1;
		m_iLineRasterStepsTemp = 1;
		}

	if(m_iLineAdrRaster<0)
		{
		m_iLineAdrRaster       = 1;
		m_iLineAdrRasterTemp   = 1;
		}

	if(m_iFlags&HEX_GRID_SIZE)								// Rasterbreite Funktion
		{
		iWidth -= iWidth%m_iLineRasterSteps;
		}



	iFormat    &= 3;
	iSpaceNTemp = iSpaceN;
	iWidthTemp	= iWidth;


	if(iInvert)iInvert=(1<<iFormat)-1;

	if(iFormat)												// Extra Leerzeichen auf's Format einrasten
		{
		iWidth  >>=  iFormat;
		iWidth  <<=  iFormat;
		iSpaceN  +=  ((1<<iFormat)-1);
		iSpaceN  &= ~((1<<iFormat)-1);

		if(iWidth<=0)iWidth=1<<iFormat;
		}
	else{
		iInvert = 0;
		}

	if(iWidth<= 0)iWidth=1;									// Variabeldimensionen prfen
	if(iWidth>256)iWidth=256;


	if(iSpace   == m_iLineAddSpace)							// Keine nderungen ?
	if(iSpaceN  == m_iLineSpaceN  )
	if(iWidth   == m_iLineWidth   )
	if(iAddrLen == m_iLenOfAdr    )
	if(iFormat  == m_iLineFormat  )
	if(iInvert  == m_iLineInvert  )
	if(!((m_iFlagsOld^m_iFlags)&(HEX_NO_ADR|HEX_NO_HEX|HEX_NO_STR|HEX_INIT|HEX_AUTO_SIZE|HEX_SNAP_IN|HEX_SNAP_IN)))
		{
		return iWidth;
		}

	m_iFlags     &= ~HEX_INIT;
	m_iFlagsOld   =  m_iFlags;

	k = BinPosition(m_iCursorX);							// k=Byte-Nummer vom Cursor
	i = HexPosition(k);										// i=Spalten-Nummer von Byte[k]
	j = (m_iCursorX>i)? 1:0;

	if(iSpaceN<=0)iSpaceN=0x1000;

	iOld = m_iLineWidth;



	m_iLineSpaceNTemp		= iSpaceNTemp;					// Space anhngen (eingestellt)
	m_iLineWidthTemp		= iWidthTemp;					// Bytebreite einer Zeile (eingestellt)
	m_iLineAddSpace			= iSpace;						// Space anhngen
	m_iLineSpaceN 			= iSpaceN;						// Bytezahl fr extra iSpace
	m_iLineWidth 			= iWidth;						// Bytebreite einer Zeile
	m_iLineFormat 			= iFormat;						// Ausgabeformat der Zeilen
	m_iLineInvert 			= iInvert;						// Ausgabeformat der Zeilen
	m_iLenOfAdr				= iAddrLen;						// Adddres-Bereichbreite
	m_iLenOfHex				= m_iLineWidth*2+HEX_SPACE2;	// Lnge des Hex-Bereiches

	if(iFormat)
		{
		m_iLineAdrRaster   +=  ((1<<iFormat)-1);
		m_iLineAdrRaster   &= ~((1<<iFormat)-1);
		m_iLineRasterSteps +=  ((1<<iFormat)-1);
		m_iLineRasterSteps &= ~((1<<iFormat)-1);
		}

	if(m_iLineAddSpace)
		{
		m_iLenOfHex        +=  m_iLineWidth/(1<<iFormat);
		m_iLenOfHex        -= (m_iLineAddSpace!=0     )? 1:0;
		}

	if(m_iLineSpaceN)
		{
		m_iLenOfHex        +=  m_iLineWidth/m_iLineSpaceN;
		m_iLenOfHex        -= (m_iLineWidth%m_iLineSpaceN)? 0:1;
		}


	if(m_iFlags&HEX_NO_ADR)m_iLenOfAdr=0;
	if(m_iFlags&HEX_NO_HEX)m_iLenOfHex=0;


	m_iLenOfStr		= (m_iFlags&HEX_NO_STR)? 0:m_iLineWidth;
	m_iPosOfHex		=  m_iLenOfAdr;							// Position fr Hex Zeichen
	m_iPosOfStr		=  m_iPosOfHex+m_iLenOfHex;				// Postion  fr ASCII-Zeichen
	m_iPosOfEnd		=  m_iPosOfStr+m_iLenOfStr;

	m_iLineWidthMax =  m_iPosOfEnd;
	m_iLineCount    = (int)((m_iMemSize+(OffI)(m_iMemBegin%m_iLineWidth)+(OffI)m_iLineWidth-1)/(OffI)m_iLineWidth);


	if((m_iFlags&HEX_NO_HEX)&&(m_iCursorMode==0))m_iCursorMode=1;
	if((m_iFlags&HEX_NO_STR)&&(m_iCursorMode==1))m_iCursorMode=2;


	m_iRedrawFlags	= NZ_ALL;								// Neu Zeichnen
	k = BinPosition(m_iCursorX);

	PositionOk(HexPosition(k)+j,m_iCursorY,0x40);

	if(m_hWnd)
		{
		PositionCheck(2);
		DrawView(1);
		}


return iOld;
}

//*****************************************************************************
//*
//*     OnSize
//*
//*****************************************************************************
//	Grennderung des Fensters
//	iSizeX /iSizeY		: Neue Gre in Zeichen
//	iDeltaX/iDeltaY		: Grenderung in Zeichen
void CHexView::OnSize(int iSizeX,int iSizeY,int iDeltaX,int iDeltaY)
{
OffI	iScroll;
int		iLine;
OffI	iMark;
OffI	iAdr;
int		iNum;
int		x,y,z;



	if(!(m_iFlags&HEX_AUTO_SIZE))return; 					// Breite anpassen ?
	if(m_iOnSizeCnt>2)return;

	m_iOnSizeCnt++;

	iScroll = (OffI)GetScroll();
	iAdr 	= (OffI)GetCursor();
	iMark	= (OffI)GetSelection();
	iLine	= m_iCursorY-m_iScrollY;
	y		= 0;
	z		= 0;

	if(!(m_iFlags&HEX_NO_HEX))z+=2;
	if(!(m_iFlags&HEX_NO_STR))z+=1;							// Breite fr STR-Bereich
	if(z<=0)z=1;

	x		= m_iScreenX-m_iLenOfAdr-1;

	if(!(m_iFlags&HEX_NO_HEX))								// Breite fr HEX-Bereich
		{
		if(!(m_iFlags&HEX_NO_STR))x-=HEX_SPACE2;

		iNum = 1<<m_iLineFormat;

		if(m_iLineSpaceN)
			{
			if(m_iLineAddSpace)
				{
				y  = x*m_iLineSpaceN*iNum+(m_iLineSpaceN*iNum);
				y /= z*m_iLineSpaceN*iNum+ m_iLineSpaceN+iNum;
				}
			else{
				y  = x*m_iLineSpaceN+m_iLineSpaceN;
				y /= z*m_iLineSpaceN+1;
				}
			}
		else{
			if(m_iLineAddSpace)
				{
				y = (x*iNum+iNum)/(z*iNum+1);
				}
			else{
				y =  x/z;
				}
			}
		}
	else{
		y = x/z;
		}


	if(iDeltaX)SetWidth(y,-1,-1,-1);						// Neue Breite
	if(iLine>m_iLineCount)iLine=m_iLineCount;

	SetScroll(iScroll);
	SetCursor(iAdr);
	SetSelection(iMark);

	m_iOnSizeCnt--;
}


//*****************************************************************************
//*
//*     GetModify
//*
//*****************************************************************************
//	Liest das Modify-Flag aus.
BOOL CHexView::GetModify()
{
return   (m_iFlags&HEX_CHANGED)? 1:0;
}

//*****************************************************************************
//*
//*     SetModify
//*
//*****************************************************************************
//	Setzt oder lscht das Modify Flag
//	Ergibt den alten Zustand
BOOL CHexView::SetModify(BOOL bFlag)
{
int iOld;



	iOld   =(m_iFlags&=~HEX_CHANGED)? 1:0;
		     m_iFlags&=~HEX_CHANGED;
	if(bFlag)m_iFlags|= HEX_CHANGED;



return iOld;
}


//*****************************************************************************
//*
//*		OnKillFocus
//*
//*****************************************************************************
void CHexView::OnKillFocus(CWnd *pNewWnd)
{

	StatusbarExit();
	CAnsiView::OnKillFocus(pNewWnd);
	SendNotify(HEX_KILLFOCUS);

}


//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CHexView::OnSetFocus(CWnd *pOldWnd)
{

	CAnsiView::OnSetFocus(pOldWnd);
	StatusbarInit();
	SendNotify(HEX_SETFOCUS);

}

//*****************************************************************************
//*
//*		SetCursorArea
//*
//*****************************************************************************
//	Stellt ein in welchem Bereich der Cursor sich befinden soll
//	iArea	: 0=HEX-Bereich 1=STR-Bereich 2=Adresse
//	Ergibt den zuletzt eingestellten Bereich
int CHexView::SetCursorArea(int iArea)
{
int		iOld;
int		i,j;


	if(iArea< 0 || iArea>2              )return m_iCursorMode;
	if(iArea==m_iCursorMode             )return m_iCursorMode;
	if(iArea==0 && (m_iFlags&HEX_NO_HEX))return m_iCursorMode;
	if(iArea==1 && (m_iFlags&HEX_NO_HEX))return m_iCursorMode;

	iOld = m_iCursorMode;


	if(m_iCursorMode!=2)
		{
	   	j = BinPosition(m_iCursorX);
		m_iPosLastX = j;
		}
	else{
		j = m_iPosLastX%m_iLineWidth;
		}

	m_iCursorMode=iArea;

	if(m_iCursorMode==2)i=0;
	else i=HexPosition(j);

	PositionOk(i,m_iCursorY);
	PositionCheck();
	DrawView(1);



return iOld;
}

//*****************************************************************************
//*
//*		OnChar
//*
//*****************************************************************************
// Ergibt 1 wenn das Zeichen verarbeitet wurde
int CHexView::OnChar(UINT nChar,UINT nFlags)
{
UndoBlock  *pUndo;
BYTE		bGrow;
BYTE		bByte;
OffI		iOff;
int			i,j;



	if(nChar=='\t')											// Modus wechseln ADR->HEX->STR
		{
		if(m_iCursorMode!=2)
			{
	   		j = BinPosition(m_iCursorX);
			m_iPosLastX = j;
			}
		else{
			j = m_iPosLastX%m_iLineWidth;
			}

		i = (m_iKeyState&KEY_SHIFT)? 2:1;

		if(m_iHasTabLoop)
			{
			     if(m_iCursorMode==2 && i==2                         )SendNotify(HEX_TABLOOP,1);
			else if(m_iCursorMode==1 && i==1                         )SendNotify(HEX_TABLOOP,0);
			else if(m_iCursorMode==0 && i==1 && (m_iFlags&HEX_NO_STR))SendNotify(HEX_TABLOOP,0);
			}

		m_iCursorMode += i;
		m_iCursorMode %= 3;

		if((m_iFlags&HEX_NO_HEX) && m_iCursorMode==0)
			{
			m_iCursorMode += i;
			}

		m_iCursorMode %= 3;

		if((m_iFlags&HEX_NO_STR) && m_iCursorMode==1)
			{
			m_iCursorMode += i;
			}

		m_iCursorMode %= 3;

		if(m_iCursorMode==2)i=0;
		else i=HexPosition(j);

		PositionOk(i,m_iCursorY);
		PositionCheck();
		DrawView(1);

		return 1;
		}


//*****************************************************************************


	if(nChar<' ')
		{
		if(nChar!=VK_BACK)
			{
			MessageBeep(MB_ICONASTERISK);
			return 0;
			}

		#if HEX_ALLOW_GROW


		if(m_iCursorMode!=2 && m_bCanGrow && m_bAllowGrow)	// Der Speicher soll schrumpfen
			{
			LPBYTE	pData;
			BYTE	bMode;
			int		iPosX;
			int		iPosY;

			iOff  = (OffI)GetAddress(m_iCursorX,m_iCursorY);

			if(m_iMarkOn)									// Make lschen
				{
				if(iOff<m_iMarkStart)
					{
					i	 = (int)(m_iMarkStart-iOff)+1;
					}
				else{
					i	 = (int)(iOff-m_iMarkStart)+1;
					iOff = m_iMarkStart;
					}

				bMode = 0;
				pData = new unsigned char[i];

				memcpy(pData,m_pMem+iOff,i);
				}
			else{											// Ein Byte lschen
				i = 1;

				if(m_iCursorMode==1 || m_iCursorNipple)
					{
					iOff--;
					}

				if(m_iCursorMode==0)
						bMode = (m_iCursorNipple)? 2:3;
				else	bMode = 0;

				j	  = m_pMem[iOff];
				pData = NULL;
				}

			 if(!ShrinkMem(iOff,i))							// Die Bytes lschen
				{
				MessageBeep(MB_ICONASTERISK);
				if(pData)delete pData;
				return 0;
				}

			pUndo			= UndoGet(iOff,i);
			pUndo->pData	= pData;
			pUndo->ucMode	= bMode;
			pUndo->ucGrow	= 0x01;
			pUndo->ucByte	= j;
			pUndo->uSize	= i;


			GetPosition(iPosX,iPosY,iOff);

			PositionOk(iPosX,iPosY,0);
			PositionCheck();
			DrawView(1);
			UndoAdd();

			return 1;
			}

		#endif

		CAnsiView::OnKeyDown(VK_LEFT,1,0);
		return 0;
		}


//*************************** HEX-Modus ***************************************


	switch(m_iCursorMode)
		{
	case 0:

		if(m_iFlags&HEX_NOT_CHANGE)return 1;
		if(m_iFlags&HEX_NO_HEX    )return 1;

			 if(nChar>='0' && nChar<='9')nChar-='0';
		else if(nChar>='a' && nChar<='f')nChar-='a'-10;
		else if(nChar>='A' && nChar<='F')nChar-='A'-10;
		else{
			MessageBeep(MB_ICONASTERISK);
			return 0;
			}


		iOff  = (OffI)GetAddress(m_iCursorX,m_iCursorY);
		iOff -= (OffI)m_iMemAddress;
		bGrow = 0x00;

		#if HEX_ALLOW_GROW
										// Der Speicher soll wachsen
		if(m_iCursorNipple && m_bCanGrow && m_bAllowGrow)
			{
			if(!GrowMem(iOff))
				{
				MessageBeep(MB_ICONASTERISK);
				return 0;
				}

			bGrow = 0x02;
			}
		else

		#endif

		if((MaxI)iOff>=(MaxI)m_iMemSize || iOff<0)
			{
			MessageBeep(MB_ICONASTERISK);
			return 0;
			}

		bByte			= m_pMem [iOff];
		pUndo			= UndoGet(iOff);
		pUndo->ucByte	= bByte;
		pUndo->ucMode	=(m_iCursorNipple)? 2:3;

		#if HEX_ALLOW_GROW
		pUndo->ucGrow	= bGrow;
		#endif


		if(m_iCursorNipple)				// Obere 4 Bit
			{
			m_pMem[iOff] &= 0x0F;
			m_pMem[iOff] |= nChar<<4;
			}
		else{							// Untere 4 Bit
			m_pMem[iOff] &= 0xF0;
			m_pMem[iOff] |= nChar;
			}

		if(bByte!=m_pMem[iOff])
			{
			m_iFlags|=HEX_CHANGED;
			}

		j = BinPosition(m_iCursorX);

		if(j+1<m_iLineWidth)			// In der gleichen Zeile
			{
			m_iRedrawFlags |= NZ_LINE;
			}
		else{
			if(!(m_iRedrawFlags&NZ_LINE_YY))
        		{
				m_iRedrawFlags|=NZ_LINE;
				m_iRedrawFlags|=NZ_LINE_NR|m_iCursorY;
				}
			else{
				m_iRedrawFlags =NZ_ALL;
				}
			}

		PositionOk(1,0,(m_iMarkOn)? 0x01:0x21);
		PositionCheck();
		DrawView(1);
		UndoAdd();

		return 1;


//*************************** STR-Modus ***************************************

	case 1:

		if(m_iFlags&HEX_NOT_CHANGE)return 1;
		if(m_iFlags&HEX_NO_STR    )return 1;

		iOff  = (OffI)(GetAddress(m_iCursorX,m_iCursorY)-m_iMemAddress);

		#if HEX_ALLOW_GROW

		if(m_bCanGrow && m_bAllowGrow)	// Der Speicher soll wachsen
			{
			if(!GrowMem(iOff))
				{
				MessageBeep(MB_ICONASTERISK);
				return 0;
				}

			bGrow = 0x02;
			}
		else

		#endif

		if(iOff>=m_iMemSize || iOff<0)
			{
			MessageBeep(MB_ICONASTERISK);
			return 0;
			}

		if(nChar!=m_pMem[iOff])
			{
			m_iFlags |= HEX_CHANGED;
			}

		pUndo			= UndoGet(iOff);
		pUndo->ucByte	= m_pMem [iOff];

		#if HEX_ALLOW_GROW
		pUndo->ucGrow	= bGrow;
		#endif

		m_pMem[iOff]	= nChar;

		j = BinPosition(m_iCursorX);

		if(j+1<m_iLineWidth)			// In der gleichen Zeile
			{
			m_iRedrawFlags |= NZ_LINE;
			}
		else{
			if(!(m_iRedrawFlags&NZ_LINE_YY))
        		{
				m_iRedrawFlags |= NZ_LINE;
				m_iRedrawFlags |= NZ_LINE_NR|m_iCursorY;
				}
			else{
				m_iRedrawFlags  = NZ_ALL;
				}
			}

		PositionOk(1,0,1);
		PositionCheck();
		DrawView(1);
		UndoAdd();

		return 1;


//*************************** ADR-Modus ***************************************

	case 2:

		MessageBeep(MB_ICONASTERISK);
		return 0;
		}


return 0;
}

//*****************************************************************************
//*
//*		PrintMargin   Rand auf den Schirm zeichnen;
//*
//*****************************************************************************
//	Zeichnet den linken Rand einer Zeile.
//	hDdc		: Handle vom Gertekontext.
//	pRect		: Pixelkoordinaten des Bereiches.
//	iLine		: Zeilennummer des linken Randes.
void CHexView::PrintMargin(HDC hDc,RECT *pRect,int iLine)
{

	SelectObject(hDc,GetStockObject(NULL_PEN));
	SelectObject(hDc,GetStockObject(WHITE_BRUSH));
	Rectangle(hDc,pRect->left,pRect->top,pRect->right+1,pRect->bottom+1);

}

//*****************************************************************************
//*
//*		PrintLine
//*
//*****************************************************************************
//	Eine Zeile auf den Schirm zeichnen.
//	hDc		: Gertekontext in dem gezeichnet wird.
//	pRect	: Pixelkoordinaten des Bereiches in dem gezeichnet wird.
//	iLine	: Zeilennummer des Textes der augegeben werden soll.
//	iStart	: Startzeichen in der Zeile (X-Scroll-Offset).
//	iCount	: Anzahl der auszugebenden Zeichen (Bildschirmbreite)
//	iFlags  : Diverse Bits fr die Zeile
//				Bit0	  = Ist fr die die Ausgabe auf einem Drucker bei einem Aufruf aus OnPrint()
//				Bit1	  = Ist es nicht das aktive Feld bei TO_ANSISPLIT
//				Bit8..9   = Ist die Feldnummer bei TO_ANSISPLIT
//				Bit12..31 = Ist der X-Ursprung fr Tabulatoren
//			  iFlags muss an ColorChose weiter gegeben werden !
//	Ergibt die letzte Koordinate in Zeichen der ausgegeben Zeile.
int CHexView::PrintLine(HDC hDc,RECT *pRect,int iLine,int iCount,int iSize,int iFlags)
{
uchar	aBuffer[1024+512];
uchar	aColors[1024+512];
uchar	aDummy [256];
OffI	iStart;
OffI	iFrom;
OffI	iOff;
OffI	iTo;
AdrI	iAdr;
int		iMask;
int		iPosX;
int		iPosY;
int		iPos;
int		iCol;
int		iAdd;
int		iCnt;
int		i;
int		j;
int		k;
int		w;




	if(iLine>=m_iLineCount)return 0;
	if(iSize<=0           )return 0;


	iStart  = iLine;
	iStart *= m_iLineWidth;
	iStart -= m_iMemBegin%m_iLineWidth;


//***************************** ADR-Bereich ***********************************


	if(!(m_iFlags&HEX_NO_ADR))
		{
		iAdr = (AdrI)iStart+m_iMemAddress;
		LCONVERT(iAdr);
		i = m_iLenOfAdr-HEX_SPACE1;
		htostr(&iAdr,(char*)aBuffer,(i+1)>>1,HEX_INVERT);
		if(i&1)memmove(aBuffer,aBuffer+1,i);
		memset(aBuffer-HEX_SPACE1+m_iPosOfHex,' ',HEX_SPACE1);
		}

	memset(aBuffer-HEX_SPACE2+m_iPosOfStr,' ',HEX_SPACE2);


//***************************** Hex/Str-Bereich *******************************


	if(iStart>=0 && iStart+m_iLineWidth<m_iMemSize)			// Ganze Line ausgeben
		{
		if(!(m_iFlags&HEX_NO_STR))memcpy(aBuffer+m_iPosOfStr,m_pMem+iStart,m_iLineWidth);
		if(!(m_iFlags&HEX_NO_HEX))
			{
			i  = m_iLineFormat<<25;
			i |= m_iLineSpaceN&0xFF;

			if(m_iLineAddSpace)i|=HEX_SPACE;
			if(m_iLineInvert  )i|=HEX_INVERT;

			htostr(m_pMem+iStart,(char*)aBuffer+m_iPosOfHex,m_iLineWidth,i);
			}

		iPos = 0;
		}
	else{
		memset(aBuffer+m_iPosOfHex,' ',(m_iLineWidth<<2)+m_iLineWidth+HEX_SPACE2);
		memset(aDummy,0,m_iLineWidth);

		k	= m_iLineWidth;
		j	= 0;

		if(iStart+(OffI)k>m_iMemSize)						// Ist die Line lnger als der Speicher
			{
			k  = (int)(m_iMemSize-iStart);
			}

		if(iStart<0)										// Beginnt die Line vor dem Speicher
			{
			k += (int)iStart;
			j -= (int)iStart;
			}

		if(k>0)memcpy(aDummy+j,m_pMem+iStart+j,k);


		iPos  =  m_iPosOfHex;
		iOff  =  iStart;
		k	  =  1<<m_iLineFormat;
		iMask = (1<<m_iLineFormat)-1;

		for(i=0,w=0;i<m_iLineWidth;i++,iOff++)				// Einzelne Bytes ausgeben
			{
			if(w==0 && iOff>=0 && iOff<m_iMemSize)
				{
				if(iOff+(OffI)k>m_iMemSize)
					{
					if(!(m_iFlags&HEX_NO_HEX))htostr(aDummy+i,(char*)aBuffer+iPos+((m_iLineInvert)? (k-m_iMemSize+iOff)*2:0),(int)(m_iMemSize-iOff),(m_iLineInvert)? HEX_INVERT:0);
					if(!(m_iFlags&HEX_NO_STR))memcpy(aBuffer+m_iPosOfStr+i,aDummy+i,(int)(m_iMemSize-iOff));
					}
				else{
					if(!(m_iFlags&HEX_NO_HEX))htostr(aDummy+i,(char*)aBuffer+iPos,k,(m_iLineInvert)? HEX_INVERT:0);
					if(!(m_iFlags&HEX_NO_STR))memcpy(aBuffer+m_iPosOfStr+i,aDummy+i,k);
					}
				}

			if(!((i+1)%m_iLineSpaceN))iPos++;
			if(m_iLineAddSpace && (i&iMask)==iMask)iPos++;

			iPos += 2;
			w    += 1;

			if(w>=k)w=0;
			}
		}


//*********************** Farben einstellen ***********************************


	memset(aColors            ,1,m_iLenOfAdr);
	memset(aColors+m_iLenOfAdr,2,m_iLenOfHex);
	memset(aColors+m_iPosOfStr,0,m_iLenOfStr);


	if(!(iFlags&1))
		{
		if(m_pBitFlags && iStart<m_iBitCount)				// Bit-Feld mit Marken vorhanden
			{
			iPos  = m_iPosOfHex;
			iMask = (1<<m_iLineFormat)-1;

			for(i=0;i<m_iLineWidth;i++)						// Bytes durchlaufen
				{
				if(iStart+i>=m_iBitCount)break;
				if(bit_read(m_pBitFlags,((int)iStart+i)^m_iLineInvert))
					{
					if(!(m_iFlags&HEX_NO_STR)) aColors[m_iPosOfStr+i]=6;
					if(!(m_iFlags&HEX_NO_HEX)){aColors[iPos         ]=5;
											   aColors[iPos+1       ]=5;}
					}

				if(!((i+1)%m_iLineSpaceN))iPos++;
				if(m_iLineAddSpace && (i&iMask)==iMask)iPos++;
				iPos+=2;
				}
			}


		for(j=HEX_SLOT_COUNT;j>=0;j--)						// Alle Bereiche durchlaufen
			{
			if(m_uAreaUsed [j]==0)continue;					// Bereich ungltig
			if(m_iAreaStart[j]<m_iAreaEnd[j])				// Start oder Ende zuerst ?
				{
				iFrom = m_iAreaStart[j];
				iTo   = m_iAreaEnd  [j];
				}
			else{
				iTo   = m_iAreaStart[j];
				iFrom = m_iAreaEnd  [j];
				}

			if(iStart>iTo || iStart+m_iLineWidth<=iFrom)
				{
				continue;
				}

			iPos   = m_iPosOfHex;
			iMask  = (1<<m_iLineFormat)-1;
			iCol   = m_uAreaColor[j];

			for(i=0;i<m_iLineWidth;i++)						// Bytes durchlaufen
				{
				if(iStart+i>=iFrom && iStart+i<=iTo)
					{
					iAdd=(m_iLineInvert-(i&m_iLineInvert)*2)*2;

					if(!(m_iFlags&HEX_NO_STR))aColors[m_iPosOfStr+i]=iCol;
					if(!(m_iFlags&HEX_NO_HEX))
						{
						aColors[iPos+iAdd  ] = iCol;
						aColors[iPos+iAdd+1] = iCol;
						}
					}

				if(!((i+1)%m_iLineSpaceN))iPos++;
				if(m_iLineAddSpace && (i&iMask)==iMask)iPos++;
				iPos+=2;
				}
			}
		}


//*********************** Zeichnen ********************************************


	for(i=m_iPosOfStr;i<m_iPosOfEnd;i++)
		{
		k = aBuffer[i];

		if(k<0x20){aBuffer[i]='.';continue;}
		if(k<0x7F){               continue;}
		if(k>0x9F){               continue;}

		aBuffer[i]='.';
		}

	iPosX = pRect->left;
	iPosY = pRect->top;
	iCnt  = 0;


	while(iSize>0)
		{
		if(iCount>=m_iPosOfEnd)break;

		iCol = aColors[iCount];

		for(i=1;iCount+i<m_iPosOfEnd;i++)
			{
			if(iCol!=aColors[iCount+i])break;
			}

		if(i>iSize)i=iSize;

		ColorChose(hDc,iCol,iFlags);

		k	 	 = TabbedTextOutA(hDc,iPosX,iPosY,(char*)aBuffer+iCount,i,0,0,0);
		iPosX   += k&0xFFFF;
		iSize   -= i;
		iCount  += i;
		iCnt    += i;
		}


	ColorChose(hDc,0,iFlags);


return iCnt;
}


//*****************************************************************************
//*
//*		EnsureVisible
//*
//*****************************************************************************
//	Prft ob ein Bereich sichtbar ist, und scrollt hin wenn ntig.
//	iStart		: Ist der Anfangs-Offset fr den zu prfenden Bereich.
//	iSize		: Ist der die Lnge fr den zu prfenden Bereich.
//	Ergibt 1 wenn gescrollt wurde
int	CHexView::EnsureVisible(OffI iStart,OffI iLen)
{
int		iFrom;
int		iDiff;
int		iAdd;
int		iEnd;


	if(m_iScreenY<=0)
		{
		return 0;
		}

	if(iStart<0)
		{
		iLen  += iStart;
		iStart = 0;
		}

	if(iLen<0)
		{
		iLen = 0;
		}

	if(iStart+iLen>m_iMemSize)
		{
		if(iStart>=m_iMemSize)return 0;
		iLen = m_iMemSize-iStart;
		}

	if(iLen>0)iLen--;


	iFrom	= (iStart     +m_iMemBegin%m_iLineWidth)/m_iLineWidth;
	iEnd	= (iStart+iLen+m_iMemBegin%m_iLineWidth)/m_iLineWidth;

	if(iFrom>=m_iScrollY && iEnd<m_iScrollY+m_iScreenY)		// Ist die Marke im Bereich
		{
		return 0;
		}

	   iDiff = iEnd-iFrom;
	if(iDiff<=m_iScreenY)									// Passt die Marke ber den ganzen Schirm
		{
		   iAdd = (m_iScreenY-iDiff)/2;
		if(iAdd>3)iAdd=3;
		if(iAdd<0)iAdd=0;

		iStart -= m_iLineWidth*iAdd;

		SetScroll(iStart);

		return 1;
		}

	if(iEnd<=m_iScrollY)									// Bereich vor Scroll-Position
		{
		SetScroll(iStart);
		return 1;
		}

	if(iFrom>=m_iScrollY+m_iScreenY)						// Bereich hinter Scroll-Position
		{
		SetScroll(iStart);
		return 1;
		}


return 0;
}

//*****************************************************************************
//*
//*		EnsureVisible
//*
//*****************************************************************************
//	Prft ob eine Markierung sichtbar ist, und scrollt hin wenn ntig.
//	iMode		: Ist die Nummer des Bereiches (-1...HEX_SLOT_COUNT-1,-1=User-Markierung).
//	Ergibt 1 wenn gescrollt wurde
int	CHexView::EnsureVisible(int iMode)
{
OffI	iStart;
OffI	iLen;


	iMode++;

	if(iMode>HEX_SLOT_COUNT)return 0;
	if(iMode<             0)return 0;

	if(iMode==0 && !m_uAreaUsed[iMode])
		{
		iStart = m_iCursorOffset;
		iLen   = 1;
		}
	else if(!m_uAreaUsed[iMode])
		{
		return 0;
		}
	else{
		iStart = m_iAreaStart[iMode];
		iLen   = m_iAreaEnd  [iMode]-iStart;
		}


return EnsureVisible(iStart,iLen);
}


//*****************************************************************************
//*
//*		Select
//*
//*****************************************************************************
//	Markiere einen Bereich im Fenster.
//	iMode		: Ist die Nummer des Bereiches (0...HEX_SLOT_COUNT-1).
//					Wenn iMode -1 ist dann die nchste freie Markierungen gesucht.
//					Wenn iMode -2 ist dann werden alle Markierungen gelscht.
//	iStart		: Ist der Anfangs-Offset fr den zu markierenten Bereich.
//	iSize		: Ist der die Lnge fr den zu markierenten Bereich.
//				  Wenn die Lnge <= 0 ist dann wird die Markierungen gelscht.
//	Ergibt die Bereichsnummer fr den Bereich bzw. HEX_SLOT_COUNT wenn
//	kein freier Bereich vorhanden ist .
int	CHexView::Select(int iMode,OffI iStart,OffI iSize)
{
OffI	iEnd;
int		i;



	if(iMode==-2)											// Alle Markierungen lschen
		{
		for(i=0;i<HEX_SLOT_COUNT;i++)
			{
			if(!m_uAreaUsed[i+1])continue;
			Select(i,0,0);
			}

		return -2;
		}

	if(iMode==-1)
		{													// Suche freien Bereich
		for(iMode=0;iMode<=HEX_SLOT_COUNT;iMode++)
			{
			if(!m_uAreaUsed[iMode+1])break;
			}
		}


	if(iMode>HEX_SLOT_COUNT)return HEX_SLOT_COUNT;
	if(iMode<             0)return HEX_SLOT_COUNT;


	iMode++;


	if(iSize<=0)											// Marke lschen
		{
		if(!m_uAreaUsed[iMode])return iMode-1;

		iStart = (m_iAreaStart[iMode]+m_iMemBegin%m_iLineWidth)/m_iLineWidth;
		iEnd   = (m_iAreaEnd  [iMode]+m_iMemBegin%m_iLineWidth)/m_iLineWidth;

		if(!(m_iRedrawFlags &NZ_LINE_YY) &&(iStart==iEnd))
			 m_iRedrawFlags|=NZ_LINE_NR|iStart;
		else m_iRedrawFlags =NZ_ALL;

		m_uAreaUsed[iMode]=0;
		DrawView(1);

		return iMode-1;
		}


	iEnd=iStart+iSize-1;

	if( m_uAreaUsed [iMode])
	if( m_iAreaStart[iMode]==iStart)						// Gleiche Bereiche
	if((m_iAreaEnd  [iMode]==iEnd ))return iMode;


	if( m_uAreaUsed [iMode])Select(iMode-1,0,0);
		m_iAreaStart[iMode] = iStart;						// Anfang eines Bereiches
		m_iAreaEnd  [iMode] = iEnd;         				// Ende   eines Bereiches
		m_uAreaColor[iMode] = (iMode)? 4:3;					// Farbe  eines Bereiches
		m_uAreaUsed [iMode] = 1;							// Bereich einschalten


//*****************************************************************************


	iStart += (m_iMemBegin%m_iLineWidth);
	iEnd   += (m_iMemBegin%m_iLineWidth);
	iStart /=  m_iLineWidth;
	iEnd   /=  m_iLineWidth;

	if(!(m_iRedrawFlags&NZ_LINE_YY) && iStart==iEnd)		// Einzeilige Marke ?
 		{
		m_iRedrawFlags |= NZ_LINE;
		m_iRedrawFlags |= NZ_LINE_NR|iStart;
		}
	else{
		m_iRedrawFlags  = NZ_ALL;
		}

	DrawView(1);


return iMode-1;
}

//*****************************************************************************
//*
//*		GetFlags
//*
//*****************************************************************************
//	Liest die aktuellen Flags ein.
//	Ergibt folgende Bit-Werte:
//				HEX_NOT_CHANGE	: Text in darf nicht gendert werden
//				HEX_AUTO_SIZE   : Breite automatisch bestimmen
//				HEX_SNAP_IN     : Startadresse einrasten
//				HEX_GRID_SIZE	: Breite nur in Schritten einstellbar
//				HEX_NO_HEX      : Keinen HEX-Bereich anzeigen
//				HEX_NO_STR      : Keinen STR-Bereich anzeigen
//				HEX_NO_ADR      : Keinen ADR-Bereich anzeigenprotected:
//				HEX_CHANGED     : Wurde der Speicher gendert
#define 	HEX_MASK_FLAGS	(HEX_NOT_CHANGE|HEX_AUTO_SIZE|HEX_SNAP_IN|HEX_GRID_SIZE|HEX_NO_HEX|HEX_NO_STR|HEX_NO_ADR|HEX_CHANGED)

DWORD  CHexView::GetFlags()
{
return m_iFlags&HEX_MASK_FLAGS;
}

//*****************************************************************************
//*
//*		SetFlags
//*
//*****************************************************************************
//	Stellt Flags ein und ergibt den alten Zustand:
//				HEX_NOT_CHANGE	: Text in darf nicht gendert werden
//				HEX_AUTO_SIZE   : Breite automatisch bestimmen
//				HEX_SNAP_IN     : Startadresse einrasten
//				HEX_GRID_SIZE	: Breite nur in Schritten einstellbar
//				HEX_NO_HEX      : Keinen HEX-Bereich anzeigen
//				HEX_NO_STR      : Keinen STR-Bereich anzeigen
//				HEX_NO_ADR      : Keinen ADR-Bereich anzeigenprotected:
//				HEX_CHANGED     : Wurde der Speicher gendert
//	uFlags	: Sind die neuen Flags die eingestellt werden sollen.
//	uMask	: Diese Maske bestimmt welche Flags gendert werden.
DWORD CHexView::SetFlags(DWORD uFlags,DWORD uMask)
{
int		iOld;


	iOld    = m_iFlags;
	uMask  &= HEX_MASK_FLAGS;
	uFlags &= uMask;


	if((m_iFlags^uFlags)&uMask)
		{
		if((uFlags&HEX_NOT_CHANGE) && !(m_iFlags&HEX_NOT_CHANGE))
			{
			if(IsBadWritePtr(m_pMem,(UINT_PTR)m_iMemSize))
				{
				MessageBeep(MB_ICONEXCLAMATION);
				uFlags  &= ~HEX_NOT_CHANGE;
				}
			}

		m_iFlags &= ~uMask;
		m_iFlags |=  uFlags|HEX_CONFIG;

		RedrawGroup();
		}


return iOld&HEX_MASK_FLAGS;
}

//*****************************************************************************
//*
//*		SetCursor
//*
//*****************************************************************************
//	Setzt den Cursor auf die angegebene Adresse
//	iAddress	: Ist die neue Adresse fr den Cursor (absolut/relativ)
//	iMode		: Bestimmt die Art der Adresse
//					Ist iMode==0		ist Adresse ein  Speicher-Offset
//					Ist iMode!=0		ist Adresse eine Speicheradresse
//										Offset = Adresse-=m_iMemAddress;
//  Ergibt 1 wenn Adresse die ok war und der Cursor gesetzt wurde, ansondsten 0.
int CHexView::SetCursor(MaxI iAddress,int iMode)
{
OffI	iOffset;
int		iRedraw;
int 	iPosX;
int 	iPosY;
int		iRet=1;



	if(iMode)
		{
		ACONVERT(iAddress);
		iOffset = (OffI)(iAddress-m_iMemAddress);
		}
	else{
		iOffset = (OffI)(iAddress);
		}

	if(iOffset>=m_iMemSize){iOffset=m_iMemSize-1;iRet=0;}
	if(iOffset<0          ){iOffset=0;           iRet=0;}

	iOffset += m_iMemBegin%m_iLineWidth;

	iPosY = (int)(iOffset/(MaxI)m_iLineWidth);
	iPosX = (int)(iOffset%(MaxI)m_iLineWidth);
	iPosX = HexPosition(iPosX);

	iRedraw = m_iRedrawFlags;

	if(m_iCursorMode==2)m_iCursorMode=0;

	PositionOk(iPosX,iPosY,0x40);
	PositionCheck(2);

	if(!iRedraw && m_iRedrawFlags)DrawView(1);


return iRet;
}

//*****************************************************************************
//*
//*		SetCursor
//*
//*****************************************************************************
//	Setzt den Cursor auf die angegebene Adresse	und markiert einen Bereich.
//	iAddress	: Ist die neue Adresse fr den Cursor (absolut/relativ)
//	iMode		: Bestimmt die Art der Adresse
//					Ist iMode==0		ist Adresse ein  Speicher-Offset
//					Ist iMode!=0		ist Adresse eine Speicheradresse
//									Offset = Adresse-=m_iMemAddress;
//	iShift		: Ist dieser Wert ungleich 0, so wird der Bereich zwischen
//				  aktueller Cursor-Position und neuer markiert.
//  Ergibt 1 wenn iAddress die ok war und der Cursor gesetzt wurde, ansondsten 0.
int CHexView::SetCursor(MaxI iAddress,int iMode,int iShift)
{
OffI	iOffset;
int		iRedraw;
int		iRet=1;
int		x,y;


	if(iMode)
		{
		ACONVERT(iAddress);
		iOffset = (OffI)(iAddress-m_iMemAddress);
		}
	else{
		iOffset = (OffI)(iAddress);
		}

	if(iOffset>=m_iMemSize){iOffset=m_iMemSize-1;iRet=0;}
	if(iOffset<0          ){iOffset=0;           iRet=0;}

	iOffset += m_iMemBegin%m_iLineWidth;

	y = (int)(iOffset/(MaxI)m_iLineWidth);
	x = (int)(iOffset%(MaxI)m_iLineWidth);
	x = HexPosition(x);

	iRedraw = m_iRedrawFlags;

	if(m_iCursorMode==2)m_iCursorMode=0;

	PositionOk(x,y,(iShift)? 0x42:0x40);
	PositionCheck(2);


	if(!iRedraw && m_iRedrawFlags)DrawView(1);


return iRet;
}

//*****************************************************************************
//*
//*		SetSelection
//*
//*****************************************************************************
//	Setzt die Marke auf die angegebene Adresse
//	Adresse		: Ist die neue Adresse fr die Marke (absolut/relativ)
//	iMode		: Bestimmt die Art der Adresse
//					Ist iMode==0		ist Adresse ein  Speicher-Offset
//					Ist iMode!=0		ist Adresse eine Speicheradresse
//									Offset = Adresse-=m_iMemAddress;
//  Ergibt 1 wenn Adresse die ok war und die Marke gesetzt wurde, ansondsten 0.
int CHexView::SetSelection(MaxI iAddress,int iMode)
{
OffI	iOffset;
int		iRedraw;
int		iRet=1;
int		iPosX;
int		iPosY;



	if(iMode)
		{
		ACONVERT(iAddress);
		iOffset = (OffI)(iAddress-m_iMemAddress);
		}
	else{
		iOffset = (OffI)(iAddress);
		}


	if(iOffset>(MaxI)m_iMemSize){iOffset =m_iMemSize-1;iRet=0;}
	if(iOffset<0               ){iOffset =0;           iRet=0;}


	if(m_iCursorOffset<iOffset)
		{
		m_iMarkStart =  m_iCursorOffset;
		m_iMarkEnd   =  iOffset-1;
		m_iMarkOn    =  1;
		}
	else{
		m_iMarkOn    = (m_iCursorOffset==iOffset)? 0:1;
		m_iMarkStart =  iOffset+1;
		m_iMarkEnd   =  m_iCursorOffset;
		}


	iOffset += m_iMemBegin%m_iLineWidth;

	iPosY = (int)(iOffset/(MaxI)m_iLineWidth);
	iPosX = (int)(iOffset%(MaxI)m_iLineWidth);

	iRedraw = m_iRedrawFlags;

	if(iPosY==m_iCursorY)
			DrawViewCursorLine();
	else	DrawViewFrom((iPosY<m_iCursorY)? iPosY:m_iCursorY);

	if(!iRedraw && m_iRedrawFlags)DrawView(1);


return iRet;
}

//*****************************************************************************
//*
//*		SetSelection
//*
//*****************************************************************************
//	Setzt die Marke auf die angegebene Adresse
//	Adresse		: Ist die neue Adresse fr die Marke (absolut/relativ)
//	iMode		: Bestimmt die Art der Adresse
//					Ist iMode==0		ist Adresse ein  Speicher-Offset
//					Ist iMode!=0		ist Adresse eine Speicheradresse
//									Offset = Adresse-=m_iMemAddress;
//  Ergibt 1 wenn Adresse die ok war und die Marke gesetzt wurde, ansondsten 0.
int CHexView::SetSelection(MaxI iAddress,int iLen,int iMode)
{
OffI	iOffset;
OffI	iOffEnd;
OffI	iOffPos;
int		iRedraw;
int		iPageY;
int		iRet=1;
int		iPosX;
int		iPosY;
int		iEndX;
int		iEndY;
int		iDifY;
int		iValY;



	if(iMode)
		{
		ACONVERT(iAddress);
		iOffset = (OffI)(iAddress-m_iMemAddress);
		iMode   = 0;
		}
	else{
		iOffset = (OffI)(iAddress);
		}

	if(iLen<0)
		{
		iLen = 0;
		iRet = 0;
		}


	if(iOffset>=(MaxI)m_iMemSize)
		{
		iOffset = m_iMemSize-1;
		iRet    = 0;
		iLen    = 0;
		}

	if(iOffset<0)
		{
		if(iLen>-iOffset)
				iLen += (int)iOffset;
		else	iLen  = 0;

		iOffset = 0;
		iRet    = 0;
		}


	if(iLen<=0)
		{
		if(!SetCursor(iAddress,iMode))
			{
			iRet = 0;
			}

		return iRet;
		}

	if(iOffset+iLen>(MaxI)m_iMemSize)
		{
		iLen = (int)(m_iMemSize-iOffset);
		iRet = 0;
		}

	iOffPos  = iOffset+m_iMemBegin%m_iLineWidth;
	iOffEnd  = iOffPos+iLen;

	iPosY	 = (int)(iOffPos/(MaxI)m_iLineWidth);
	iPosX	 = (int)(iOffPos%(MaxI)m_iLineWidth);
	iEndY	 = (int)(iOffEnd/(MaxI)m_iLineWidth);
	iEndX	 = (int)(iOffEnd%(MaxI)m_iLineWidth);
	iPosX	 = HexPosition(iPosX);
	iEndX	 = HexPosition(iEndX);


	iPageY		 = (m_iScreenY<10)? m_iScreenY:m_iScreenY-4;
	iRedraw      =  m_iRedrawFlags;


	if(iPosY>=m_iScrollY && iPosY<m_iScrollY+iPageY)		// Start im sichtbaren Bereich
		{
		if(iPosX!=m_iCursorX || iPosY!=m_iCursorY)
			{
			PositionOk(iPosX,iPosY,0x40);
			PositionCheck(6);
			}

		if(m_iMarkOn)
			{
			if(iPosY==iEndY || m_iMarkStart<iOffPos || m_iMarkEnd<iOffPos)
				{
				m_iRedrawFlags = NZ_ALL;
				}
			}

		m_iMarkEnd   =  iOffEnd-1;
		m_iMarkStart =  iOffPos;
		m_iMarkOn	 =  1;

		if(iPosY==iEndY)
			{
			DrawViewCursorLine();
			}
		else{
			DrawViewFrom(iPosY);
			}
		}
	else{													// Es muss gescrollt werden
		if(m_iScreenY>4)
			{
			iDifY = iEndY-iPosY;

			if(iDifY+4<=m_iScreenY)
					iValY = iPosY-iDifY/2;
			else	iValY = iPosY-1;

			if(iValY<0)iValY=0;

			CAnsiView::SetScroll(0,iValY,0);
			}

		PositionOk(iPosX,iPosY,0x40);
		PositionCheck(6);

		m_iMarkEnd   =  iOffEnd-1;
		m_iMarkStart =  iOffPos;
		m_iMarkOn	 =  1;

		m_iRedrawFlags = NZ_ALL;
		}


	if(!iRedraw && m_iRedrawFlags)DrawView(1);



return iRet;
}

//*****************************************************************************
//*
//*     DeleteSelection
//*
//*****************************************************************************
//	Entfernt die Marke vom Bildschirm.
//  Ergibt 1 wenn die Marke vorher ein war.
int	CHexView::DeleteSelection()
{

	if(!m_iMarkOn)return 0;

	SetCursor(m_iCursorOffset);


return 1;
}

//*****************************************************************************
//*
//*		SelectionCopy
//*
//*****************************************************************************
//	Kopiert die Marke in die Zwischenablage als Hex-Dump (:11 22 33 44...)
//	Ergibt Anzahl der kopierten Bytes.
void CHexView::OnCopy(){SelectionCopy();}
int  CHexView::SelectionCopy()
{
TCHAR      *pTxt=0;
OffI		iStart;
OffI		iStop;
OffI		iSize;
int 		iCnt;
int			iLen;
int			i;



	if(!m_iMarkOn)return 0;									// Nichts markiert

	iStart  = m_iMarkStart;
	iStop   = m_iMarkEnd;

	if(iStart>=m_iMemSize)iStart=m_iMemSize-1;
	if(iStop >=m_iMemSize)iStop =m_iMemSize-1;
	if(iStart<0)iStart=0;
	if(iStop <0)iStop =0;


	if(iStop<iStart)
		{
		iSize  =  iStart-iStop+1;
		iStart =  iStop;
		}
	else{
		iSize  =  iStop-iStart+1;
		}

	if(iSize<=0)
		{
		return 0;
		}

	if(iSize>0x00400000)
		{
		iSize=0x00400000;
		}

	iCnt = (int)iSize;
	iLen = -1;

	if(m_iCursorMode==1)									// Text erstellen
		{
		for(i=0;i<iCnt;i++)
			{
			if(m_pMem[iStart+i]<' ')break;
			}

		if(i==iCnt)
			{
			pTxt = new TCHAR[iCnt+1];

			for(i=0;i<iCnt;i++)
				{
				pTxt[i] = m_pMem[iStart+(OffI)i];
				}

			pTxt[iCnt] = 0;
			iLen = iCnt;
			}
		}

	if(iLen==-1)											// HEX-Dump erstellen
		{
		pTxt = new TCHAR[iCnt*3+4];
		iLen = BinToStr(m_pMem+iStart,iCnt,pTxt,5);
		}


//********************* In Zwischenablage kopieren ****************************


	if(iCnt)
		{
		SetClipboardText(pTxt,iLen);
		}

	delete pTxt;



return iCnt;
}

//*****************************************************************************
//*
//*		SelectionInsert
//*
//*****************************************************************************
//	Fgt die Zwischenablage in den Speicher ein.
//	iMode	: Bestimmt das Format des Textes in der Zwischenablage
//				0 = HEX-Dump --> ":11 22 33 44..."
//				1 = HEX-Dump --> "112233..." oder ":11,22,33" oder "11 22 33" oder
//								 "11:22:33"	 oder
//	Ergibt 1 wenn Marke eingefgt wurde
void CHexView::OnPaste  (){SelectionInsert(0);}
void CHexView::OnPasteEx(){SelectionInsert(1);}
int  CHexView::SelectionInsert(int iMode)
{
UndoBlock  *pUndo;
TCHAR	   *pPtr;
BYTE	   *pBin;
BYTE		bGrow;
OffI		iStart;
int			iLine;
int			iLen;
int			iEnd;
int			iOff;
int			iCnt;




	if(m_iFlags&HEX_NOT_CHANGE) 							// Darf Fenster gendert werden ?
		{
		MessageBeep(MB_ICONASTERISK);
		return 0;
		}

		pPtr = GetClipboardText();							// Daten aus Zwischenablage holen
	if(!pPtr)return 0;


	if(iMode)												// Format "[:]112233.." oder "[:]11,22,33" oder "[:]11 22 33"
		{
		iCnt = _tcslen(pPtr);
		pBin = new BYTE[iCnt/2+1];
		iOff = strwlen(pPtr,0xE0);

		if(pPtr[iOff]=='0' && (pPtr[iOff+1]=='x' || pPtr[iOff+1]=='X'))
			{
			for(;iOff<iCnt;iOff++)
				{
				if(pPtr[iOff  ]!='0')continue;
				if(pPtr[iOff+1]!='x')
				if(pPtr[iOff+1]!='X')continue;

				pPtr[iOff  ]=' ';
				pPtr[iOff+1]=' ';
				}
			}

		for(iOff=0;iOff<iCnt;iOff++)
			{
			if(pPtr[iOff]==',' )pPtr[iOff]=' ';
			if(pPtr[iOff]==':' )pPtr[iOff]=' ';
			if(pPtr[iOff]=='' )pPtr[iOff]=' ';
			if(pPtr[iOff]=='\n')pPtr[iOff]=' ';
			if(pPtr[iOff]=='\r')pPtr[iOff]=' ';
			}

		iLen = dumptomem(pBin,iCnt/2+1,pPtr);

		delete pPtr;
		pPtr = (TCHAR*)pBin;
		}
	else{													// Format ":11 22 33"
		iLen = StrToBin(pPtr,pPtr,_tcslen(pPtr),0);
		}



	iStart = (OffI)GetCursor(0);							// Cursor-Offset


	if(m_iMarkOn)											// In Marke einfgen
		{
		iStart=(OffI)GetSelection(0,&iCnt);
		if(iLen>iCnt)iLen=iCnt;
		}


	iLine = (int)((iStart+(OffI)m_iMemBegin             )/(OffI)m_iLineWidth);
	iEnd  = (int)((iStart+(OffI)m_iMemBegin+(OffI)iLen-1)/(OffI)m_iLineWidth);

	#if HEX_ALLOW_GROW

	if(m_bCanGrow && m_bAllowGrow && iStart<=m_iMemSize)	// Den Speicher vergern
		{
		if(!GrowMem(iStart,iLen))
			{
			MessageBeep(MB_ICONASTERISK);
			delete pPtr;
			return 0;
			}

		bGrow = 0x02;
		iEnd  = -1;
		}
	else

	#endif
		{
		bGrow = 0x00;

		if(iStart>=m_iMemSize)								// Auserhalb vom Speicher
			{
			delete pPtr;
			return 0;
			}

		if(iStart+(OffI)iLen>=m_iMemSize)					// Einfgebereich zu lang
			{
			iLen = (int)(m_iMemSize-iStart);
			}
		}

	pUndo		  = UndoGet(iStart,iLen);
	pUndo->pData  = (unsigned char*)pPtr;
	pUndo->ucGrow = bGrow;
	m_iFlags     |= HEX_CHANGED;


	memxchg(m_pMem+iStart,pPtr,iLen);


	if(iEnd!=iLine)
			DrawViewFrom(iLine);
	else{	DrawViewCursorNext();							// Neu zeichnen
			DrawViewCursorLine();	}
			DrawView(1);


	UndoAdd();



return 1;
}

//*****************************************************************************
//*
//*		OnUndo/OnUndoBack
//*
//*****************************************************************************
void CHexView::OnUndo    (){Undo(-1);}
void CHexView::OnUndoBack(){Undo( 1);}

//*****************************************************************************
//*
//*		ConfigLoad
//*
//*****************************************************************************
//	Ld Konfiguration und Farben,Suchpptionen aus der Registry mit dem
//	Pfad mit dem  "<RegistryKey>/<AppName>/<Pfad>"
//	pPath	: Ist der Pfad der angehngt wird
//	Ergibt 1 wenn alles gespeichert wurde
int CHexView::ConfigLoad(LPCTSTR pPath)
{
CRegKeys		sKey;
DWORD			iLen;
unsigned char	cBuffer[2048];
LPCTSTR			pPath1,pPath2;
TCHAR		    cName[1024]=_T("Software");
int				i;



	pPath1 = AfxGetApp()->m_pszRegistryKey;
	pPath2 = AfxGetApp()->m_pszAppName;


	if(pPath1)												// Pfad erstellen
		{
		strlcat(cName,_T("\\"),sizeof(cName));
		strlcat(cName,pPath1  ,sizeof(cName));
		}

	if(pPath2)
		{
		strlcat(cName,_T("\\"),sizeof(cName));
		strlcat(cName,pPath2  ,sizeof(cName));
		}

	if(pPath)
		{
		strlcat(cName,_T("\\"),sizeof(cName));
		strlcat(cName,pPath   ,sizeof(cName));
		}


//****************** Konfiguration laden ***************************************


	if(sKey.Open(HKEY_CURRENT_USER,cName,CRK_READ))
		{
		if(!m_pFindText)
			{
			if(sKey.Get(cBuffer,sizeof(cBuffer),_T("HexFind"),REG_MULTI_SZ))
				{
				iLen        = sKey.Len();
				m_pFindText = new TCHAR[iLen+2];

				memcpy(m_pFindText,cBuffer,iLen);

				m_pFindText[iLen  ] = 0;
				m_pFindText[iLen+1] = 0;
				}
			}

		if(!m_pGroupText)
			{
			if(sKey.Get(cBuffer,sizeof(cBuffer),_T("HexGroup"),REG_MULTI_SZ))
				{
				iLen         = sKey.Len();
				m_pGroupText = new TCHAR[iLen+2];

				memcpy(m_pGroupText,cBuffer,iLen);

				m_pGroupText[iLen  ] = 0;
				m_pGroupText[iLen+1] = 0;
				}
			}

		sKey.Get(m_iLineAddSpace		,_T("InsertSpace"    ));
		sKey.Get(m_iLineSpaceNTemp		,_T("ExtraSpace"     ));
		sKey.Get(m_iLineWidthTemp		,_T("LineWidth"      ));
		sKey.Get(m_iLineAdrRasterTemp	,_T("Raster"         ));
		sKey.Get(m_iLineRasterStepsTemp	,_T("WidthRaster"    ));
		sKey.Get(m_iLineInvert			,_T("InvertBytes"    ));
		sKey.Get(m_iLineFormat			,_T("OutputFormat"   ));
		sKey.Get(m_iSelRaster			,_T("SelectionRaster"));
		sKey.Get(m_iStausbarMode		,_T("StatusbarMode"  ));
		sKey.Get(m_iFindFlags			,_T("HexFindFlags"   ));

		if(sKey.Get(m_iLenOfAdr,_T("AddressLength")))
			{
			m_iLenOfAdr+=HEX_SPACE1;
			}

		if(sKey.Get(i,_T("HexFlags")))
			{
			i        &=  (HEX_AUTO_SIZE|HEX_SNAP_IN|HEX_GRID_SIZE);
			m_iFlags &= ~(HEX_AUTO_SIZE|HEX_SNAP_IN|HEX_GRID_SIZE);
			m_iFlags |= i|HEX_INIT;
			}


		m_iLineWidth		= m_iLineWidthTemp;
		m_iLineSpaceN		= m_iLineSpaceNTemp;
		m_iLineAdrRaster	= m_iLineAdrRasterTemp;
		m_iLineRasterSteps	= m_iLineRasterStepsTemp;

		if(m_iLineWidth<=0)m_iLineWidth=16;


		SetWidth();
		}


//******************* Farben laden ********************************************


	ColorConfig(cName,1);								// Standard Einstellung
	ColorConfig(cName,0);								// Benutzer Einstellung


return 1;
}

//*****************************************************************************
//*
//*		ConfigSave
//*
//*****************************************************************************
// Speichert Konfiguration und Farben,Such-Optionen in die Registry
// Ist pPath=0 wird der pPath aus m_pGroup->config gennommen
// Ergibt 1 wenn alles gespeichert wurde
int CHexView::ConfigSave(LPCTSTR pPath)
{
CRegKeys	sKey;
LPCTSTR		pPath1=0,pPath2=0;
TCHAR		cName[1024]=_T("Software");
int			i;



	pPath1 = AfxGetApp()->m_pszRegistryKey;
	pPath2 = AfxGetApp()->m_pszAppName;


	if(pPath1)											// Pfad erstellen
		{
		strlcat(cName,_T("\\"),sizeof(cName));
		strlcat(cName,pPath1  ,sizeof(cName));
		}

	if(pPath2)
		{
		strlcat(cName,_T("\\"),sizeof(cName));
		strlcat(cName,pPath2  ,sizeof(cName));
		}

	if(pPath)
		{
		strlcat(cName,_T("\\"),sizeof(cName));
		strlcat(cName,pPath   ,sizeof(cName));
		}


	if(!sKey.Open(HKEY_CURRENT_USER,cName))
		{
		return 0;
		}


//******************* Config laden *********************************************


	if(m_pFindText )sKey.SetMulti(m_pFindText ,_T("HexFind" ));
	if(m_pGroupText)sKey.SetMulti(m_pGroupText,_T("HexGroup"));

	i = m_iLenOfAdr-HEX_SPACE1;

	sKey.Set(i			 			,_T("AddressLength"  ));
	sKey.Set(m_iLineAddSpace		,_T("InsertSpace"    ));
	sKey.Set(m_iLineSpaceNTemp		,_T("ExtraSpace"     ));
	sKey.Set(m_iLineWidthTemp		,_T("LineWidth"      ));
	sKey.Set(m_iLineAdrRasterTemp	,_T("Raster"         ));
	sKey.Set(m_iFlags				,_T("HexFlags"       ));
	sKey.Set(m_iStausbarMode		,_T("StatusbarMode"  ));
	sKey.Set(m_iLineRasterStepsTemp	,_T("WidthRaster"    ));
	sKey.Set(m_iFindFlags			,_T("HexFindFlags"   ));
	sKey.Set(m_iLineInvert			,_T("InvertBytes"    ));
	sKey.Set(m_iLineFormat			,_T("OutputFormat"   ));
	sKey.Set(m_iSelRaster			,_T("SelectionRaster"));



return 1;
}

//*****************************************************************************
//*
//*		SetMem
//*
//*****************************************************************************
//	Weist dem Fenster einen neuen Speicherbereich zu.
//	pMemPtr		: Zeiger auf den neuen Speicherbereich.
//	iMemLen		: Ist die Lnge des Speicherbereiches.
//	iAddress	: Die Anzeigeaddresse des ersten Bytes (kein Offset!!)
//	iMode		: Bestimt wie der Speicherbereich eingefgt wird
//					Bit0  == 1  Speicher darf verndert werden
//					      == 0  Speicher darf nicht verndert werden
//					Bit1  == 1  Speicher wird vom Fenster freigegeben
//					      == 0  Speicher wird nicht vom Fenster freigegeben
//					Bit2  == 1  Cursor und Scroll-Position nicht setzen
//					Bit3  == 1  Nicht neuzeichen
//					Bit4  == 1  Keine neue Breite einstellen
//					Bit5  == 1  Set Speicher wachsen (nur mit Bit0+Bit1 und HEX_ALLOW_GROW)
//					Bit6  == 1  Set Speicher-Modus auf Wachsen
//					Bit7  == 1  Set Speicher-Modus auf nicht Wachsen
//					Bit8  == 1  Alten Speicher nicht freigeben
//	Ergibt die Lnge der letzten Speicherbereiches.
CHexView::OffI CHexView::SetMem(void *pMemPtr,OffI iMemLen,AdrI iAddress,int iMode)
{
uchar  *pMem=(uchar*)pMemPtr;
uchar  *pOld;
OffI	iLen;



	#ifdef	HEX_MULTI_ADDR
	m_iMultiCount	= 0;
	#endif


	if(IsBadReadPtr(pMemPtr,(UINT_PTR)iMemLen))				// Prfe Speicher
		{
		pMemPtr		= "\x0\x0\x0\x0";
		iMemLen		= 0;
		}

	if((iMode&0x01) && IsBadWritePtr(pMemPtr,(UINT_PTR)iMemLen))
		{
		pMemPtr		= "\x0\x0\x0\x0";
		iMemLen		= 0;
		}

	iLen			= m_iMemSize;
	pOld			= m_pMem;
	m_iMemSize		= 0;
	m_pMem			= pMem;
	m_iMemSize		= iMemLen;
	m_iMemAddress	= iAddress;


	if(pOld && (m_iFlags&HEX_MEM_FREE) && !(iMode&0x100))	// Altenspeicher lschen
		{
		delete pOld;
		}
					 m_iFlags&=~HEX_MEM_FREE;
	if(  iMode&0x02 )m_iFlags|= HEX_MEM_FREE;
					 m_iFlags&=~HEX_NOT_CHANGE;
	if(!(iMode&0x01))m_iFlags|= HEX_NOT_CHANGE;

	Select(-2);
	m_iFlags |= HEX_INIT;


	if((iMode&0x10) && m_iLineWidth)
		{
		m_iLineCount = (int)((m_iMemSize+(OffI)(m_iMemBegin%m_iLineWidth)+(OffI)m_iLineWidth-1)/(OffI)m_iLineWidth);
		}
	else{
		SetWidth(-1);
		}

	if(!(iMode&0x04))
		{
		SetScroll(iAddress,1);								// Scrolle auf Anfangsadresse
		SetCursor(iAddress,1);								// Cursor  auf Anfangsadresse
		}

	if(!(iMode&0x08))
		{
		m_iRedrawFlags=NZ_ALL;
		DrawView(1);
		}


	#if HEX_ALLOW_GROW

	m_iMemExtra			= 0;								// Lnge des Extra-Bytes am Ende des Speichers

	if((iMode&0x23)==0x23 && iMemLen<=HEX_MAX_GROW)			// Kann der Speicher wachsen
		{
		m_bCanGrow		= 1;
		}
	else{
		m_bCanGrow		= 0;
		}

	if(iMode&0x40)m_bAllowGrow=1;
	if(iMode&0x80)m_bAllowGrow=0;

	SetCursorMode((m_bAllowGrow && m_bCanGrow)? 0x03:0x02);

	#endif


	UndoClear();



return iLen;
}

//*****************************************************************************
//*
//*		GetMem
//*
//*****************************************************************************
//	Holl den Zeiger auf den aktuellen Speicher.
//	pLength		: Wenn dieser Wert != 0 ist wird dort die Lnge gespeichert.
//	pAddress	: Wenn dieser Wert != 0 ist wird dort die iStart-Adresse gespeichert.
//	Ergibt einen Zeiger auf den aktuellen Speicher..
unsigned char *CHexView::GetMem(OffI *pLength,AdrI *pAddress)
{


	if(pLength )*pLength =m_iMemSize;
	if(pAddress)*pAddress=m_iMemAddress;


return m_pMem;
}

//*****************************************************************************
//*
//*		ConfigView
//*
//*****************************************************************************
//	Ruft das Dialog-Fenster fr die Konfiguration auf.
void CHexView::OnConfigView(){ConfigView();}
int  CHexView::ConfigView()
{
int				i;
CHexConfigDlg	sDlg(this);



	sDlg.m_iWidth		=  m_iLineWidthTemp;				// Fixe Breite
	sDlg.m_iSpaceN		=  m_iLineSpaceNTemp;				// Alle n-Zeichen ein Extra Leerzeichen
	sDlg.m_iSpace		=  m_iLineAddSpace!=0;				// Leerzeichen ein
	sDlg.m_iRaster		=  m_iLineAdrRasterTemp;			// Adressraster
	sDlg.m_iRasterW		=  m_iLineRasterStepsTemp;			// Breitenraster
	sDlg.m_iValue		=  m_iStausbarMode;					// Wert-Anzeige
	sDlg.m_iAddressLen	=  m_iLenOfAdr-HEX_SPACE1;			// Adressziffern Zahl
	sDlg.m_iFormat		=  m_iLineFormat;					// Ausgabeformat (0=byte 1=Word 2=Dword 3=Qword)
	sDlg.m_iInvertBytes	=  m_iLineInvert!=0;				// Byte-Reihenfolge invertieren
	sDlg.m_iSelRaster	=  m_iSelRaster;					// Die Auswahl auf das Ausgabeformat rastern								// Die Auswahl auf das Format rastern
	sDlg.m_iSpaceNOn	= (m_iLineSpaceN<=256);				// Extra Leerzeichen ein
	sDlg.m_iRasterOn	= (m_iFlags&HEX_SNAP_IN  )!=0;		// Adressraster einschalten
	sDlg.m_iRasterWOn	= (m_iFlags&HEX_GRID_SIZE)!=0;		// Breitenraster einschalten
	sDlg.m_iWidthOn		= (m_iFlags&HEX_AUTO_SIZE)==0;		// Fixe Breite einschalten

	   i=sDlg.DoModal();
	if(i!=IDOK)return i;

	SetWidth (sDlg.m_iWidth  ,sDlg.m_iSpaceN,sDlg.m_iSpace,sDlg.m_iAddressLen,sDlg.m_iFormat,sDlg.m_iInvertBytes);
	SetConfig(sDlg.m_iRasterW,sDlg.m_iRaster,sDlg.m_iValue,sDlg.m_iSelRaster);
	SendNotify(HEX_CONFIGCHANGE);


return i;
}

//*****************************************************************************
//*
//*		GetConfig
//*
//*****************************************************************************
//	Konfiguration abfragen
//	iMode		: Whlt die Art der Konfiguration aus
int CHexView::GetConfig(int iMode)
{


	switch(iMode)
		{
	case  0: return m_iLineWidthTemp;						// Bytebreite einer Zeile
	case  1: return m_iLineSpaceNTemp;						// Bytezahl fr extra Space
	case  2: return m_iLineAddSpace;						// Space anhngen
	case  3: return m_iLineAdrRasterTemp;					// Adresse einrasten
	case  4: return m_iLineRasterStepsTemp;					// Raster Schritte fr Breite
	case  5: return m_iFlags;								// Flage fr Konfiguration
	case  6: return m_iStausbarMode;						// Statusbar Wert-Anzeige
	case  7: return m_iLenOfAdr-HEX_SPACE1;					// Anzahl der Adressziffern
	case  8: return m_iLineFormat;							// Ausgabeformat 0=byte 1=word 2=dword 3=qword
	case  9: return m_iLineInvert;							// Maske fr's invertieren von Bytes
	case 10: return m_iSelRaster;							// Die Auswahl auf das Ausgabeformat rastern
		}


return 0;
}

//*****************************************************************************
//*
//*		SetConfig
//*
//*****************************************************************************
//  Konfiguration setzen
//  iRasterWidth	: Wenn  > 0 setzt den Raster fr die Breite
//               	  Wenn == 0 dann kein Raster
// 				 	  Wenn  < 0 dann fixe Breite
//  iAddressRaster 	: Wenn setzt den Rast fr die Breite
//               	  Wenn == 0 dann kein Raster
// 				 	  Wenn  < 0 dann alten Wert nehmen
//  iValueMode  	: Wenn == 0 Byte-Werte
//               	  Wenn == 1 Word-Werte
//               	  Wenn == 2 DWord-Werte
//               	  Wenn Bit 0x4000 gesetzt dann BigEndian Format
//               	  Wenn Bit 0x8000 gesetzt dann nur positiver Zahlen
// 				 	  Wenn  < 0 dann alten Wert nehmen
//  iSelcetRaster	: Wenn  > 0 dann kein Einrasten aufs Ausgabeformat
// 					  Wenn == 0 dann kein Einrasten der Auswahl
// 					  Wenn  < 0 dann alten Wert nehmen
//  Ergibt die neue Breite
int CHexView::SetConfig(int iRasterWidth,int iAddressRaster,int iValueMode,int iSelcetRaster)
{
int		i,iFlag;


	iFlag = m_iFlags;

	if(iRasterWidth==0)										// Kein Breitenraster
		{
		m_iLineRasterSteps     = 1;
		m_iLineRasterStepsTemp = 1;
		m_iFlags &=~ HEX_GRID_SIZE;
		m_iFlags |=  HEX_AUTO_SIZE;
		}

	if(iRasterWidth >0)										// Breiten Raster einstellen
		{
		m_iLineRasterSteps     = iRasterWidth;
		m_iLineRasterStepsTemp = iRasterWidth;
		if(m_iLineWidth%iRasterWidth)m_iFlags|=HEX_INIT;
		m_iFlags |= HEX_GRID_SIZE|HEX_AUTO_SIZE;
		}

	if(iRasterWidth <0)										// Fixe Breite einstellen
		{
		if(iRasterWidth<-256)iRasterWidth=-256;
		if(m_iLineWidth!=-iRasterWidth)m_iFlags|=HEX_INIT;
		m_iLineWidth=-iRasterWidth;
		m_iFlags &= ~(HEX_GRID_SIZE|HEX_AUTO_SIZE);
		m_iLineAdrRaster		= iAddressRaster;
		m_iLineAdrRasterTemp	= m_iLineAdrRaster;
		}

	if(iAddressRaster>0)									// Adressraster einstellen
		{
		m_iFlags |=  HEX_SNAP_IN;
		}
	else{
		m_iFlags &= ~HEX_SNAP_IN;
		iAddressRaster = 1;
		}


	if(iAddressRaster!=m_iLineAdrRaster)
		{
		m_iFlags             |= HEX_INIT;
		m_iLineAdrRaster      = iAddressRaster;
		m_iLineAdrRasterTemp  = iAddressRaster;
		}



	if(m_iStausbarMode>=0)
		{
		i = m_iStausbarMode;
		m_iStausbarMode = iValueMode;

		if(i!=m_iStausbarMode)
			{
			m_iStausbarMode|=0x1000;
			StatusbarSet();
			}
		}


	m_iLineWidthTemp		= m_iLineWidth;





	if(((m_iFlags^iFlag)&(HEX_AUTO_SIZE|HEX_GRID_SIZE))&&(m_iFlags& HEX_AUTO_SIZE))
		{
		OnSize(m_iScreenX,m_iScreenY,1,0);
		}
	else{
		SetWidth(-1);
		}


	if(iSelcetRaster>=0)
		{
		m_iSelRaster=iSelcetRaster;
		}




return m_iLineWidthTemp;
}

//*****************************************************************************
//*
//*		OnChecksum
//*
//*****************************************************************************
// Check-Summe berrechnen
void CHexView::OnChecksum()
{
CHexChecksumDlg	sDlg(this);
int				i;


	if(m_iMarkOn)											// Ist Bereich markiert ?
		{
		i = (int)(m_iMarkEnd-m_iMarkStart);

		if(i>=0)sDlg.DoModal(m_pMem+m_iMarkStart, i+1);
		else	sDlg.DoModal(m_pMem+m_iMarkEnd  ,-i+1);
		}
	else{
		i = (m_iMemSize<0x00100000)? (int)m_iMemSize:0x00100000;

		sDlg.DoModal(m_pMem,i);
		}


}

//*****************************************************************************
//*
//*		OnCrcCalc
//*
//*****************************************************************************
// CRC berrechnen
void CHexView::OnCrcCalc()
{
CHexCrcCalcDlg	sDlg(this);
int				i;


	if(m_iMarkOn)											// Ist Bereich markiert ?
		{
		i = (int)(m_iMarkEnd-m_iMarkStart);

		if(i>=0)sDlg.DoModal(m_pMem+m_iMarkStart, i+1);
		else	sDlg.DoModal(m_pMem+m_iMarkEnd  ,-i+1);
		}
	else{
		i = (m_iMemSize<0x00100000)? (int)m_iMemSize:0x00100000;

		sDlg.DoModal(m_pMem,i);
		}


}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Ergibt den Beginn der Marke.
//	Ist pLength!=0  so wird dort die Lnge der Marke gespeichert
//	Ist iMode==0	   so wird der Speicher-Offset zurckgegeben
//	Ist iMode!=0	   so wird die Adresse zurckgegeben
CHexView::MaxI CHexView::GetSelection(int iMode,int *pLength)
{
OffI	iStart;
OffI	iEnd;
OffI	iLen;
MaxI	iVal;


	if(m_iMarkOn)											// Ist Bereich markiert ?
		{
		iStart = m_iMarkStart;
		iEnd   = m_iMarkEnd;

		if(iStart>iEnd)
			{
			iLen	= iEnd;
			iEnd	= iStart;
			iStart	= iLen;
			}

		iLen = iEnd-iStart;

		if(pLength)
			{
			if(iLen>=0x00400000)
					*pLength = 0x00400000;
			else	*pLength = (int)iLen+1;
			}

		iVal = (MaxI)iStart;

		if(iMode)
			{
			iVal += m_iMemAddress;
			LCONVERT(iVal);
			}

		return iVal;
		}

	iVal = (MaxI)m_iCursorOffset;							// Nichts ist Markiert

	if(iMode)
		{
		iVal += m_iMemAddress;
		LCONVERT(iVal);
		}

	if(pLength)*pLength=0;


return iVal;
}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Ergibt 1 wenn ein Bereich markiert ist.
//	Ist pStart !=0  so wird dort der iStart der Marke gespeichert
//	Ist pLength!=0  so wird dort die Lnge der Marke gespeichert
//	Ist iMode  ==0	so wird der Speicher-Offset zurckgegeben
//	Ist iMode  !=0	so wird die Adresse zurckgegeben
//	iMax ist die maximale Anzahl an Bytes fr die Auswahl
//	Ergibt 1 wenn ein Bereich markiert ist sonst 0
int CHexView::GetSelection(MaxI *pStart,int *pLength,int iMode,int iMax)
{
OffI	iStart;
OffI	iEnd;
OffI	iLen;
MaxI	iVal;



	if(m_iMarkOn)											// Ist Bereich markiert ?
		{
		iStart = m_iMarkStart;
		iEnd   = m_iMarkEnd;

		if(iStart>iEnd)
			{
			iLen	= iEnd;
			iEnd	= iStart;
			iStart	= iLen;
			}

		iLen = iEnd-iStart;

		if(pLength)
			{
			if(iLen>=iMax)
					*pLength = iMax;
			else	*pLength = (int)iLen+1;
			}

		iVal = (MaxI)iStart;

		if(iMode)
			{
			iVal += m_iMemAddress;
			LCONVERT(iVal);
			}

		if(pStart)*pStart=iVal;

		return 1;
		}

	iVal = (MaxI)m_iCursorOffset;							// Nichts ist Markiert

	if(iMode)
		{
		iVal += m_iMemAddress;
		LCONVERT(iVal);
		}

	if(pStart )*pStart =iVal;
	if(pLength)*pLength=0;


return 0;
}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Es wird der markierte Bereich nach in eine Speicher kopiert.
//	pMem		: Zeiger auf den Pufferspeicher
//	iMax		: Ist die maximale Gre des Speichers
//	pLength		: Wenn der Zeiger ungleich 0 ist, wird dort die Lnge der
//				  Marke gespeichert.
//	Ergibt die Anzahl der kopierten Bytes.
int CHexView::GetSelection(void *pMem,int iMax,int *pLength)
{
OffI	iStart;
OffI	iTemp;
OffI	iEnd;
OffI	iLen;


	if(iMax     <=0)return 0;
	if(m_iMarkOn==0)return 0;								// Ist Bereich markiert ?

	iStart = m_iMarkStart;
	iEnd   = m_iMarkEnd;

	if(iStart>iEnd)
		{
		iTemp	= iEnd;
		iEnd	= iStart;
		iStart	= iTemp;
		}

	   iLen=iEnd-iStart+1;
	if(iLen>iMax)iLen=iMax;

	if(pLength)
		{
		*pLength = (int)iLen;
		}

	memcpy(pMem,m_pMem+iStart,(int)iLen);


return (int)iLen;
}



//*****************************************************************************
//*
//*		GetCursorMem
//*
//*****************************************************************************
//	Es wird der Bereich auf den der Cursor steht nach pMem kopiert
//	Wenn ein Bereich markiert ist wird die unter Markenposition verwendet
//	pMem	: Zeiger auf den Zielpuffer.
//	iCnt	: Ist die Anzahl der zu kopierenden Bytes
//	Ergibt die Anzahl der kopierten Bytes
int CHexView::GetCursorMem(void *pMem,int iCnt)
{
OffI	iOff;


	if(iCnt<=0)return 0;

	iOff = m_iCursorOffset;

	if(m_iMarkOn && iOff>m_iMarkStart)iOff=m_iMarkStart;
	if(iOff+(OffI)iCnt  >m_iMemSize  )iCnt=(int)(m_iMemSize-iOff);

	memcpy(pMem,m_pMem+iOff,iCnt);


return iCnt;
}

//*****************************************************************************
//*
//*		GetSelectedMem
//*
//*****************************************************************************
//	Es wird der Bereich der Marke nach pMem kopiert
//	pMem	: Zeiger auf den Zielpuffer.
//	iCnt	: Ist die maximale Anzahl der zu kopierenden Bytes.
//	Ergibt die Anzahl der kopierten Bytes
int CHexView::GetSelectedMem(void *pMem,int iCnt)
{
OffI	iOff;
int		iLen;


	if(!m_iMarkOn)return 0;

	iOff = (OffI)GetSelection(0,&iLen);

	if(iLen>iCnt)iLen=iCnt;

	memcpy(pMem,m_pMem+iOff,iLen);


return iLen;
}

//*****************************************************************************
//*
//*		StartMenu
//*
//*****************************************************************************
//	Startet ein Men bei
//	sPos	: Ist die Position fr das Men
//	pMenu	: Zeiger auf das Men. Bei 0 wird ein neues Men erzeugt
void CHexView::StartMenu(CPoint sPoint,CMenu *pMenu)
{
CMenu	sMenu;
CRect	sRect;
UINT	uBits;


	if(!pMenu)												// Neues Men
		{
		pMenu=&sMenu;
		sMenu.CreatePopupMenu();
		}
	
	uBits = (m_iMarkOn)? 0:MF_GRAYED;

	pMenu->AppendMenu(MF_STRING,ID_CHECKSUM  	  , _T("&Checksumme"   ));
	pMenu->AppendMenu(MF_STRING,ID_MOVETO  		  , _T("&Zu Adresse"   ));
	pMenu->AppendMenu(MF_STRING|uBits,ID_EDIT_COPY, _T("&Kopieren"     ));
	pMenu->AppendMenu(MF_STRING,ID_EDIT_FIND	  , _T("&Suchen"       ));
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_STRING,ID_HEX_CONFIG	  , _T("&Einstellungen"));


	#ifdef HEX_ICONS

	AddMenuBitmap(pMenu,ID_EDIT_FIND	,HEX_ICONS,0);
	AddMenuBitmap(pMenu,ID_EDIT_COPY	,HEX_ICONS,1);

	#endif 	


	if(!m_iMarkOn)
		{
		pMenu->EnableMenuItem(ID_EDIT_CUT ,MF_GRAYED);
		}

	CAnsiView::StartMenu(sPoint,pMenu);

	if(pMenu==&sMenu)sMenu.DestroyMenu();

}


//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
int CHexView::OnKeyDown(UINT nChar,UINT nFlags)
{


	if(m_iKeyState&KEY_CLTR)
		{
		if(nChar=='F')										// Einfgemodus ein/aus
			{
			FindView();
			return 1;
			}

		if(nChar==VK_INSERT)								// Einfgemodus ein/aus
			{
			SelectionCopy();
			return 1;
			}

		if(nChar=='C')										// Kopieren
			{
			SelectionCopy();
			return 1;
			}

		if(nChar=='V')										// Einfgen
			{
			OnPaste();
			return 1;
			}

		if(nChar=='Y')										// Einfgen
			{
			OnHexConvert();
			return 1;
			}
		}


	#if HEX_ALLOW_GROW

	if(nChar==VK_DELETE)									// Lschen mit DEL
		{
		if(!m_iMarkOn && (m_iCursorMode==1 || m_iCursorNipple))
			{
			CAnsiView::OnKeyDown(VK_RIGHT,1,0);
			}

		OnChar(VK_BACK,1);
		}
															// Cursor Umschalten
	if(nChar==VK_INSERT && !(m_iKeyState&(KEY_CLTR|KEY_SHIFT)))
		{
		m_bAllowGrow = !m_bAllowGrow;

		SetCursorMode((m_bAllowGrow && m_bCanGrow)? 0x03:0x02);

		if(!m_bAllowGrow && m_iCursorOffset>=m_iMemSize)
			{
			PositionOk(0,0,1);
			}
		}

	#endif


return 0;
}

//*****************************************************************************
//*
//*		OnHexConvert
//*
//*****************************************************************************
//	Dialog aufrufen fr Zahlen-Umwandlung
void CHexView::OnHexConvert()
{
CHexConvertDlg	sDlg(this);


	if(m_iMarkOn)											// Markierten Bereich holen
		{
		sDlg.m_iValue=0;
		GetSelection(&sDlg.m_iValue,sizeof(sDlg.m_iValue));
		}

	sDlg.DoModal();

}


//*****************************************************************************
//*
//*		OnFloatView
//*
//*****************************************************************************
//	Double Float Hex Converter
void CHexView::OnFloatView()
{
CHexFloatDlg	sDlg(this);


	sDlg.m_iMode=2;


	if(m_iMarkOn)											// Markierten Bereich holen
		{
		sDlg.m_iSize=GetSelection(&sDlg.m_bHexData,sizeof(sDlg.m_bHexData));
		}
	else{
		sDlg.m_iSize=GetCursorMem(&sDlg.m_bHexData,sizeof(sDlg.m_bHexData));
		}

	sDlg.DoModal();

}

//*****************************************************************************
//*
//*		OnValueInput
//*
//*****************************************************************************
void CHexView::OnValueInput()
{
CHexValueDlg	sDlg(this);
char		   *pPtr;
char		    cChar;
OffI			iStart;
int				iLen;
int				i;


	if(m_iMarkOn)											// Markierten Bereich holen
		{
		sDlg.m_sValue.i64	=  0;
		iStart				=  (OffI)GetSelection();
		GetSelection(sDlg.m_sValue.data,sizeof(sDlg.m_sValue.data),&sDlg.m_iLength);
		}
	else{
		iStart				=  m_iCursorOffset;
		sDlg.m_iLength		=  4;
		sDlg.m_sValue.i		=  *(int*)(m_pMem+iStart);
		}

	if(sDlg.DoModal()!=IDOK)return;
	if(iStart >= m_iMemSize)return;

	if(m_iFlags&HEX_NOT_CHANGE)
		{
		MessageBox(_T("Die Daten sind schreibgeschtzt !"));
		return;
		}

	iLen = sDlg.m_iLength;

	if(sDlg.m_iBigEndian)									// Byte-Reihenfolge umdrehen
		{
		pPtr = sDlg.m_sValue.text;

		for(i=0;i<iLen>>1;i++)
			{
			cChar	= pPtr[i];
			pPtr[i]	= pPtr[iLen-1-i];
			pPtr[iLen-1-i]=cChar;
			}
		}


	if(iStart+(OffI)iLen>=m_iMemSize)
		{
		iLen = (int)(m_iMemSize-iStart);
		}

	UndoSave(iStart,iLen);

	memcpy(m_pMem+iStart,&sDlg.m_sValue.data,iLen);
	m_iFlags|=HEX_CHANGED;

	DrawViewCursorNext();									// Neu zeichnen
	DrawViewCursorLine();
	DrawView(1);

}

//*****************************************************************************
//*
//*		OnCppCopy
//*
//*****************************************************************************
void CHexView::OnCppCopy()
{
CHexValueDlg	sDlg(this);
CRegKeys		sKey;
TCHAR          *pTxt;
OffI			iStart;
int				iMode;
OffI			iVal;
int				iCnt;
int				iLen;
int				iPos;
int				iNum;


	if(!m_iMarkOn)return;									// Nichts markiert


	sDlg.m_pTitle		= _T("Kopiere im C++ Format");
	sDlg.m_pEditText    = _T("Spaltenbreite");
	sDlg.m_iFormatOn	= 1;
	sDlg.m_iLength      = 1;
	sDlg.m_iType		= 0;
	sDlg.m_sValue.i		= 16;

	sKey.Open();
	sKey.Up (_T("CppCopyDlg"));
	sKey.Get(sDlg.m_iType   ,_T("BigEndian"));
	sKey.Get(sDlg.m_iLength ,_T("ValueSize"));
	sKey.Get(sDlg.m_sValue.i,_T("LineSize" ));
	sKey.Get(sDlg.m_iFormat ,_T("Format"   ));

	iStart = m_iMarkStart;
	iVal   = m_iMarkEnd;
	iVal  -= m_iMarkStart;

	if(iVal<0)
		{
		iVal 	= -iVal+1;
		iStart	=  m_iMarkEnd;
		}
	else{
		iVal++;
		}

	if(iVal<0x8000)
			iCnt = (int)iVal;
	else	iCnt = 0x8000;


	sDlg.m_pPreview		= CppMakeText;						// Callback  fr Vorschau
	sDlg.m_pPreParam	= m_pMem+iStart;
	sDlg.m_iPreLength	= iCnt;


	if(sDlg.DoModal()!=IDOK)return;

	sKey.Set(sDlg.m_iType   ,_T("BigEndian"));
	sKey.Set(sDlg.m_iLength ,_T("ValueSize"));
	sKey.Set(sDlg.m_sValue.i,_T("LineSize" ));
	sKey.Set(sDlg.m_iFormat ,_T("Format"   ));

	iLen	=  sDlg.m_iLength;
	iNum	=  iCnt*8+(iCnt/iLen+1)*4+16;
	pTxt	=  new TCHAR[iNum];
	iMode	= (sDlg.m_iBigEndian)? 0x80:0x00;
	iMode  |=  sDlg.m_iFormat;								// Den Text erstellen
	iPos	= CppMakeText(m_pMem+iStart,iCnt,sDlg.m_iLength,iMode,sDlg.m_sValue.uc,pTxt,iNum);

	pTxt[iPos] = 0;

	SetClipboardText(pTxt,iPos);							// In Zwischenablage kopieren

	delete pTxt;

}

//*****************************************************************************
//*
//*		CppMakeText
//*
//*****************************************************************************
//	Erzeugt eine C++ Text aus einen Speicherbereich
//	pMem		: Zeiger auf den Speicher
//	iMemLen		: Gre des Speichers
//	iByte		: Wertgre in Byte (1=BYTE 2=WORD 4=DWORD 8=QWORD)
//	iFormat		: Format fr die Ausgabe (0=C/C++ 1=ASM 2=BASE64 3=Dump Bit7=BigEndian)
//	iWidth		: Ist die Spaltenbreite
//	pBuffer		: Zeiger auf den Textpuffer
//	iSize		: Gre des Textpuffers
//	Ergibt die Lnge des erzeugten Textes.
int _cdecl CHexView::CppMakeText(void *pMem,int iMemLen,int iByte,int iFormat,int iWidth,char *pText,int iSize)
{
unsigned char  *pPtr=(unsigned char*)pMem;
char			cSign;
int				iMode;
int				iAdd;
int				iPos;
int				iOff;
int				iNum;



	if(iSize<4)												// Prfe die Puffer gre
		{
		if(iSize>0)pText[0]=0;
		return 0;
		}

	if(iWidth<=0)iWidth=16;

	iSize -= 4;
	iMode  = (iFormat&0x80)? 0:HEX_INVERT;


	switch(iFormat&3)
		{
	case 3:													// HEX-Dump

		iAdd = (iByte>4)? 0:iByte;

		for(iOff=0,iPos=0;iOff<iMemLen;iOff+=iByte)			// Dump Text erzeugen
			{
			iByte = iWidth;

			if(iOff+iByte>iMemLen)iByte=iMemLen-iOff;
			if(iPos+iByte*2>=iSize)break;

			iPos += memtodump(pText+iPos,pPtr+iOff,iByte,HEX_NULL|iAdd);

			pText[iPos] = '\n';	iPos++;
			}

		break;

	case 2:													// Texttypen

		switch(iByte)
			{
		case 1:												// Base 64
				if((iMemLen*4)/3+iMemLen/48+8>iSize)
					{
					iMemLen = (iSize-8)*192/261;
					}

				iPos = memtobase64(pPtr,iMemLen,pText);
				break;

		case 2:	pText[0] = '\"'; 							// HEX-Text "\x00\x11..."
				iPos     = 1;

				for(iOff=0,iNum=1;iOff<iMemLen;iNum++,iOff++)
					{
					if(iPos+5>=iSize)break;

					pText[iPos] = '\\'; iPos++;
					pText[iPos] = 'x' ; iPos++;
					iPos      += htostr(pPtr+iOff,pText+iPos,1,0);

					if(iNum<iWidth)continue;

					pText[iPos] = '\"'; iPos++;
					pText[iPos] = '\n'; iPos++;
					iNum       = 0;

					if(iOff+1>=iMemLen)break;

					pText[iPos] = '\"'; iPos++;
					}

				if(iNum!=1)
					{
					pText[iPos] = '\"'; iPos++;
					pText[iPos] = '\n'; iPos++;
					}

				break;

		case 4:												// MIN-Text "Abc\n\r\x33...123..."
				for(iOff=0,iPos=0;iOff<iMemLen;iOff+=iNum)
					{
					if(iPos+4>iSize)break;

					   iNum = iMemLen-iOff;
					if(iNum>iWidth)iNum=iWidth;

					pText[iPos] = '"' ; iPos++;
					iPos += memtostr(pText+iPos,iSize-iPos-2,pPtr+iOff,iNum,STR_NOQUOTE|STR_CCPSPLIT);
					pText[iPos] = '"' ; iPos++;
					pText[iPos] = '\n'; iPos++;
					}

				break;

		default:											// Chars 'A','B','\x11'...

				for(iOff=0,iNum=1,iPos=0;iOff<iMemLen;iNum++,iOff++)
					{
					if(iPos+7>=iSize)break;

					iPos += ctostr(pPtr[iOff],pText+iPos,0);
					pText[iPos] = ','; iPos++;

					if(iNum<iWidth)continue;
					pText[iPos] = '\n'; iPos++;
					iNum        = 0;
					}

				if(iNum!=1)
					{
					pText[iPos] = '\n'; iPos++;
					}

				break;
			}

		break;

	case 1:

		cSign = "BBWDDQQQQ"[iByte];
															// ASM Text erzeugen
		for(iOff=0,iNum=1,iPos=0;iOff<iMemLen;iNum++,iOff+=iByte)
			{
			if(iPos+8+iByte*2>=iSize)break;

			if(iNum==1)
				{
				pText[iPos] = 'D'  ;iPos++;
				pText[iPos] = cSign;iPos++;
				pText[iPos] = '\t' ;iPos++;
				}

			pText[iPos] = '0';iPos++;
			iPos       += htostr(pPtr+iOff,pText+iPos,iByte,iMode);
			pText[iPos] = 'h';iPos++;
			pText[iPos] = ',';iPos++;

			if(iNum<iWidth)continue;
			iPos--;
			pText[iPos] = '\n';iPos++;
			iNum=0;
			}

		if(iNum!=1)
			{
			pText[iPos] = '\n';iPos++;
			}


		break;

	default:
															// C++ Text erzeugen
		for(iOff=0,iNum=0,iPos=0,iNum++;iOff<iMemLen;iNum++,iOff+=iByte)
			{
			if(iPos+8+iByte*2>=iSize)break;

			pText[iPos] = '0'; iPos++;
			pText[iPos] = 'x'; iPos++;
			iPos      += htostr(pPtr+iOff,pText+iPos,iByte,iMode);
			pText[iPos] = ','; iPos++;

			if(iNum<iWidth)continue;
			pText[iPos] = '\n'; iPos++;
			iNum = 0;
			}

		if(iNum!=1)
			{
			pText[iPos] = '\n'; iPos++;
			}


		break;
		}



	pText[iPos] = 0;


return iPos;
}

//*****************************************************************************
//*
//*		OnStrCopy
//*
//*****************************************************************************
void CHexView::OnStrCopy()
{
BYTE           *pPtr;
TCHAR          *pTxt;
OffI			iStart;
OffI			iVal;
int				iCnt;
int				iPos;
int				iLen;
int				i;



	if(!m_iMarkOn)return;									// Nichts markiert


	iStart = m_iMarkStart;
	iVal   = m_iMarkEnd;
	iVal  -= m_iMarkStart;

	if(iVal<0)
		{
		iVal 	= -iVal+1;
		iStart	=  m_iMarkEnd;
		}
	else{
		iVal++;
		}

	if(iVal<0x8000)											// Nur bis zu 32768 Zeichen kopieren
			iCnt = (int)iVal;
	else	iCnt = 0x8000;

	pPtr	= m_pMem+iStart;

	for(iPos=0,i=0;iPos<iCnt;iPos++)						// Spezialzeichen zhlen
		{
		if(pPtr[iPos]<' ')i++;
		}

	pTxt	= new TCHAR[iCnt+i*5+16];
	iLen	= memtostr(pTxt,iCnt+i*4+16,pPtr,iCnt,STR_NOQUOTE|STR_CCPSPLIT);

	SetClipboardText(pTxt,iLen);							// In Zwischenablage kopieren

	delete pTxt;

}

//*****************************************************************************
//*
//*		GetScroll
//*
//*****************************************************************************
//	Ergibt die Adresse bzw. den Offset der linken oberen Fensterecke
//	Ist iMode==0		wird der Speicher-Offset zurckgegeben
//	Ist iMode!=0		wird die Adresse zurckgegeben
CHexView::MaxI CHexView::GetScroll(int iMode)
{
MaxI	iVal;


	iVal  = m_iLineWidth;
	iVal *= m_iScrollY;
	iVal -= m_iMemBegin%m_iLineWidth;

	if(iMode)
		{
		iVal += m_iMemAddress;
		LCONVERT(iVal);
		}


return iVal;
}

//*****************************************************************************
//*
//*		GetCursorAddr
//*
//*****************************************************************************
//	Ergibt die alktuelle Cursor-Adresse bzw. den Offset des Cursors
//	Ist ein Bereich markiert so wird nicht die Startadresse der Marke zurck
//	gegeben. Das kann auch die hhere Adresse sein
//	Ist iMode==0		wird der Speicher-Offset zurckgegeben
//	Ist iMode!=0		wird die Adresse zurckgegeben
CHexView::MaxI CHexView::GetCursorAddr(int iMode)
{
MaxI		iVal;


	iVal = m_iCursorOffset;

	if(iMode)
		{
		iVal += m_iMemAddress;
		LCONVERT(iVal);
		}


return iVal;
}

//*****************************************************************************
//*
//*		GetCursor
//*
//*****************************************************************************
//	Ergibt die alktuelle Cursor-Adresse bzw. den Offset des Cursors
//	Ist ein Bereich markiert so wird die Startadresse der Marke zurck
//	gegeben. Das kann auch die hhere Adresse sein
//	Ist iMode==0		wird der Speicher-Offset zurckgegeben
//	Ist iMode!=0		wird die Adresse zurckgegeben
CHexView::MaxI CHexView::GetCursor(int iMode)
{
MaxI		iVal;


	iVal = (m_iMarkOn)? m_iMarkStart:m_iCursorOffset;

	if(iMode)
		{
		iVal += m_iMemAddress;
		LCONVERT(iVal);
		}


return iVal;
}

//*****************************************************************************
//*
//*		OnHexInfo
//*
//*****************************************************************************
LRESULT CHexView::OnHexInfo(WPARAM wParam,LPARAM lParam)
{

	switch(wParam)
		{
	case HEX_GETMEMLEN:	return (LRESULT)m_iMemSize;			// Speicherlnge  holen
	case HEX_GETMARKE:	return (LRESULT)GetSelection();		// Marken-Offset  lesen
	case HEX_GETCURSOR:	return (LRESULT)GetCursor();		// Cursor-Offset  lesen
	case HEX_GETSCROLL:	return (LRESULT)GetScroll();		// Scroll-Offset  lesen
	case HEX_GETADDRES:	return (LRESULT)GetAddress();		// Basis -Adresse lesen

	case HEX_SETMARKE:	SetSelection(lParam);	return 1;	// Marken-Offset  lesen
	case HEX_SETCURSOR:	SetCursor(lParam);		return 1;	// Cursor-Offset  lesen
	case HEX_SETSCROLL:	SetScroll(lParam);		return 1;	// Scroll-Offset  lesen
	case HEX_SETADDRES:	SetAddress(lParam);		return 1;	// Basis -Adresse lesen
		}


return 0;
}


//*****************************************************************************
//*
//*		SetBitSelection
//*
//*****************************************************************************
//	Einstellen der Bit-Marken
//	pMark	: Zeiger auf Bit-Feld
//	iSize	: Lnge des Bitfeldes in Byte (-1 fr die Speicherlnge)
//	Ergibt die Gre des Bit-Feldes
int	CHexView::SetBitSelection(void *pMark,int iSize)
{


	m_pBitFlags = pMark;

	if(iSize>=0)
		{
		m_iBitCount = iSize;
		}
	else if(m_iMemSize<0x04000000)
		{
		m_iBitCount = (int)m_iMemSize;
		}
	else{
		m_iBitCount = 0x04000000;
		}


return m_iBitCount;
}

//*****************************************************************************
//*
//*		GetBitSelection
//*
//*****************************************************************************
//	Abfragen der Bit-Marken
//	pSize	: Lnge des Bitfelde in Bit (-1 fr die Speicherlnge)
//	Ergibt die Gre des Bit-Feldes
void *CHexView::GetBitSelection(int *pSize)
{

	if(pSize)*pSize=m_iBitCount;

return m_pBitFlags;
}


//*****************************************************************************
//*
//*		AddFrame
//*
//*****************************************************************************
//	Einen Frame fr eine Multi-Adresse einfgen
//	uAddr	: Anzeigeadresse
//	uSize	: Lnge des Segmentes
//	uOff	: Ist das Offset im Speicher
//	Ergibt TRUE wenn der Frame eingefgt wurde.
#ifdef	HEX_MULTI_ADDR
BOOL CHexView::AddFrame(AdrU uAddr,OffU uSize,OffU uOff)
{
AdrU	uAdrE;
OffU	uOffE;
int		iPos;
int		iRem;



	if(uOff+uSize>(uint)m_iMemSize)return FALSE;
	if(uOff+uSize<uOff            )return FALSE;
	if(uSize<=0                   )return FALSE;

	if(m_iMultiMax+16>m_iMultiCount)						// Umwandlungstabellen erweitern
		{
		AdrU  *pTemp1,*pOld1;
		AdrU  *pTemp2,*pOld2;

		pTemp1 = new AdrU[m_iMultiMax+128];
		pTemp2 = new AdrU[m_iMultiMax+128];
		pOld1  = m_pMultiOffToAdr;
		pOld2  = m_pMultiAdrToOff;

		memcpy(pTemp1,m_pMultiOffToAdr,sizeof(AdrU)*m_iMultiCount);
		memcpy(pTemp2,m_pMultiAdrToOff,sizeof(AdrU)*m_iMultiCount);

		m_pMultiOffToAdr = pTemp1;
		m_pMultiAdrToOff = pTemp2;

		if(pOld1)delete pOld1;
		if(pOld2)delete pOld2;

		m_iMultiMax += 128;
		}


	uAdrE  = uAddr;
	uAdrE += (AdrU)uSize;

	for(iPos=0;iPos<m_iMultiCount;iPos+=4)					// Suche freie Lcken
		{
		if(m_pMultiAdrToOff[iPos  ]<uAddr)continue;
		if(m_pMultiAdrToOff[iPos+1]>uAddr)return FALSE;
		if(m_pMultiAdrToOff[iPos  ]<uAdrE)return FALSE;
		break;
		}

	iRem   = iPos;
	uOffE  = uOff;
	uOffE += (OffU)uSize;

	for(iPos=0;iPos<m_iMultiCount;iPos+=4)
		{
		if(m_pMultiOffToAdr[iPos  ]<uOff )continue;
		if(m_pMultiOffToAdr[iPos+1]>uOff )return FALSE;
		if(m_pMultiOffToAdr[iPos  ]<uOffE)return FALSE;
		break;
		}


	memmove(m_pMultiOffToAdr+iPos+4,m_pMultiOffToAdr+iPos,sizeof(AdrU)*(m_iMultiCount-iPos));

	m_pMultiOffToAdr[iPos  ] = (AdrU)uOff;
	m_pMultiOffToAdr[iPos+1] = (AdrU)uAddr;
	m_pMultiOffToAdr[iPos+2] = (AdrU)uOffE;
	m_pMultiOffToAdr[iPos+3] = (AdrU)uAdrE;

	iPos=iRem;

	memmove(m_pMultiAdrToOff+iPos+4,m_pMultiAdrToOff+iPos,sizeof(AdrU)*(m_iMultiCount-iPos));

	m_pMultiAdrToOff[iPos  ] = (AdrU)uAddr;
	m_pMultiAdrToOff[iPos+1] = (AdrU)uOff;
	m_pMultiAdrToOff[iPos+2] = (AdrU)uAdrE;
	m_pMultiAdrToOff[iPos+3] = (AdrU)uOffE;

	m_iMultiCount+=4;


return TRUE;
}
#endif

//*****************************************************************************
//*
//*		IsMemInFrame
//*
//*****************************************************************************
//	Schaut ob eine Adresse in einem Framebereich ist
#ifdef	HEX_MULTI_ADDR
unsigned CHexView::IsMemInFrame(AdrU uAddr)
{
AdrI	iFirst;
AdrI	iLast;
AdrI	iHalf;



	iFirst = 0;
	iLast  = m_iMultiCount;

	while(iFirst+4<iLast)
		{
		iHalf=((iFirst+iLast)>>1)&~3;

		if(uAddr<m_pMultiAdrToOff[iHalf])
				iLast  = iHalf;
		else	iFirst = iHalf;
		}

	if(iFirst<m_iMultiCount)
	if(uAddr>=m_pMultiAdrToOff[iFirst  ])
	if(uAddr< m_pMultiAdrToOff[iFirst+2])
		{
		return 1;
		}


return 0;
}
#endif

//*****************************************************************************
//*
//*		AddrToLinear
//*
//*****************************************************************************
//	Wandelt eine Frame-Adresse in eine lieare um
#ifdef	HEX_MULTI_ADDR
CHexView::AdrU CHexView::AddrToLinear(AdrU uAddr)
{
int 	iFirst;
int 	iLast;
int 	iHalf;



	iFirst = 0;
	iLast  = m_iMultiCount;

	while(iFirst+4<iLast)
		{
		iHalf = ((iFirst+iLast)>>1)&~3;

		if(uAddr<m_pMultiAdrToOff[iHalf])
				iLast  = iHalf;
		else	iFirst = iHalf;
		}

	if(iFirst <  m_iMultiCount)
	if(uAddr  >= m_pMultiAdrToOff[iFirst  ])
	if(uAddr  <= m_pMultiAdrToOff[iFirst+2])
		{
		uAddr += m_iMemAddress;
		uAddr += m_pMultiAdrToOff[iFirst+1];
		uAddr -= m_pMultiAdrToOff[iFirst  ];

		return uAddr;
		}


return uAddr;
}
#endif

//*****************************************************************************
//*
//*		LinearToAddr
//*
//*****************************************************************************
//	Wandelt eine Linear-Adresse in eine Frame-Adresse um
#ifdef	HEX_MULTI_ADDR
CHexView::AdrU CHexView::LinearToAddr(AdrU uAddrL)
{
int 		iFirst;
int 		iLast;
int 		iHalf;
AdrU		uAddr;


	iFirst = 0;
	iLast  = m_iMultiCount;
	uAddr  = uAddrL-m_iMemAddress;


	while(iFirst+4<iLast)
		{
		iHalf = ((iFirst+iLast)>>1)&~3;

		if(uAddr<m_pMultiOffToAdr[iHalf])
				iLast  = iHalf;
		else	iFirst = iHalf;
		}

	if(iFirst <  m_iMultiCount)
	if(uAddr  >= m_pMultiOffToAdr[iFirst  ])
	if(uAddr  <= m_pMultiOffToAdr[iFirst+2])
		{
		uAddr += m_pMultiOffToAdr[iFirst+1];
		uAddr -= m_pMultiOffToAdr[iFirst  ];

		return uAddr;
		}


return uAddrL;
}
#endif


//*****************************************************************************
//*
//*		LineOfAddress
//*
//*****************************************************************************
//	Berechnet die Fenserzeile in der ein Offset liegt.
//	iOffset		: Ist der Offset im Speicher (nicht die Adresse)
//	Ergibt die Zeile im Fenster
int CHexView::LineOfAddress(OffI iOffset)
{
int		iLine;


	if(iOffset>=m_iMemSize)iOffset=m_iMemSize-1;
	if(iOffset<0          )iOffset=0;

	iOffset +=       m_iMemBegin % m_iLineWidth;
	iLine	 = (int)(iOffset/(OffI)m_iLineWidth);


return iLine;
}

//*****************************************************************************
//*
//*     UndoClear
//*
//*****************************************************************************
// 	Lscht den gesammten Undo-Speicher.
void CHexView::UndoClear()
{
int iPos;


	for(iPos=0;iPos<HEX_UNDO_MAX;iPos++)				// Undo Speicher lschen
		{
		if(   !m_aUndo[iPos].pData)continue;
		delete m_aUndo[iPos].pData;
			   m_aUndo[iPos].pData=0;
		}

	m_iUndoPos = 0;
	m_iUndoMin = 0;
	m_iUndoMax = 0;

}

//*****************************************************************************
//*
//*     UndoGet
//*
//*****************************************************************************
// 	Holt einen Zeiger auf ein neues Undo-Element
//	uOffset		: Ist der Offset im Speicher (nicht die Adresse)
//	uSize		: Ist die Lnge des Undo-Bereiches in Byte. (0=Nipple)
//	Ergibt einen Zeiger auf das Undo-Element
CHexView::UndoBlock *CHexView::UndoGet(OffU uOffset,unsigned uSize)
{
UndoBlock	*pUndo;


	pUndo			= m_aUndo;
	pUndo		   += m_iUndoPos;
	pUndo->uOffset	= uOffset;
	pUndo->ucChange	= (m_iFlags&HEX_CHANGED)? 1:0;
	pUndo->uSize	= uSize;
	pUndo->ucMode	= 0;
	#if HEX_ALLOW_GROW
	pUndo->ucGrow	= 0;
	#endif


	if(pUndo->pData)
		{
		delete pUndo->pData;
		pUndo->pData = 0;
		}


return pUndo;
}


//*****************************************************************************
//*
//*     UndoAdd
//*
//*****************************************************************************
// 	Erhht den Undo-Zeiger um eins
void CHexView::UndoAdd()
{
int		iPos;


	if(m_iFlags&HEX_NOT_CHANGE)return; 					// Darf Fenster gendert werden ?

	if(m_iUndoPos==m_iUndoMax)							// Am Ende der Kette ?
		{
		m_iUndoPos = (m_iUndoPos+1)%HEX_UNDO_MAX;
		m_iUndoMax =  m_iUndoPos;

		if(m_iUndoMax!=m_iUndoMin)return; 				// berlauf ?

		   m_aUndo[m_iUndoMin].ucChange=1;
		if(m_aUndo[m_iUndoMin].pData)
			{
			delete m_aUndo[m_iUndoMin].pData;
				   m_aUndo[m_iUndoMin].pData=0;
			}

		m_iUndoMin = (m_iUndoMin+1)%HEX_UNDO_MAX;

		return;
		}



	iPos = m_iUndoPos;

	for(;;)												// Bis max alles lschen
		{
		iPos = (iPos+1)%HEX_UNDO_MAX;

		if(iPos==m_iUndoMax)break;

		if(m_aUndo[iPos].pData)
			{
			delete m_aUndo[iPos].pData;
				   m_aUndo[iPos].pData=0;
			}

		}

	m_iUndoPos = (m_iUndoPos+1)%HEX_UNDO_MAX;			// Neue Position
	m_iUndoMax =  m_iUndoPos;


}

//*****************************************************************************
//*
//*     UndoSave
//*
//*****************************************************************************
// 	Speichert einen Bereich im im Undo-Speicher
//	iAddress	: Ist die Adresse ab der gesepeichert wird. (absolut/relativ)
//	iSize		: Ist die Gre des Bereiches in Byte.
//	iMode		: Bestimmt die Art der Adresse
//					Ist iMode==0		ist Adresse ein  Speicher-Offset
//					Ist iMode!=0		ist Adresse eine Speicheradresse
//					Offset = Adresse-=m_iMemAddress;
//	Ergibt die Anzahl der gespeicheren Bytes.
int CHexView::UndoSave(MaxI iAddress,int iSize,int iMode)
{
OffI		iOffset;
UndoBlock  *pUndo;



	if(m_iFlags&HEX_NOT_CHANGE)return 0; 				// Darf Fenster gendert werden ?

	if(iMode)
		{
		ACONVERT(iAddress);
		iOffset	= (OffI)((MaxI)iAddress-(MaxI)m_iMemAddress);
		}
	else{
		iOffset	= (OffI)iAddress;
		}


	if(iOffset>=(MaxI)m_iMemSize)
		{												// Offset auserhalb des Speichers
		return 0;
		}

	if(iOffset<0)
		{
		iSize  += (int)iOffset;
		iOffset = 0;
		}

	if(iSize<=0)return 0;

	pUndo	= UndoGet(iOffset,iSize);

	if(iSize==1)										// Einzelnes Byte
		{
		pUndo->ucByte = m_pMem[iOffset];
		}
	else{												// Mehrere Bytes
		pUndo->pData  = new unsigned char[iSize];
		pUndo->uSize  = iSize;

		if(!pUndo->pData)return 0;

		memcpy(pUndo->pData,m_pMem+iOffset,iSize);
		}


	UndoAdd();


return iSize;
}

//*****************************************************************************
//*
//*     Undo
//*
//*****************************************************************************
//	Rckgngig machen von nderungen.
//	iCount		: Ist die Anzahl der nderungen die rckgngig gemacht werden
//				  sollen. Wenn kleiner 0 dann rckgngig, wenn grer 0 dann
//				  dann wiederherstellen.
//	Ergibt die Anzahl der rckgenommen nderung.
int CHexView::Undo(int iCount)
{
UndoBlock  *pUndo;
BYTE		uByte;
BYTE		uMode;
OffI		iOffset;
int			iRedraw;
int			iLine;
int			iFrom;
int			iPos;
int			iEnd;
int			iNum;
int			iAdd;



	if(!iCount || (m_iFlags&HEX_NOT_CHANGE))return 0;



	if(iCount<0)
		{
		if(m_iUndoPos==m_iUndoMin)return 0;

		iCount	= -iCount;
		iAdd	= -1;
		iEnd	= (m_iUndoMin-1)%HEX_UNDO_MAX;
		iPos	= (m_iUndoPos-1)%HEX_UNDO_MAX;
		}
	else{
		if(m_iUndoPos==m_iUndoMax)return 0;

		iAdd	=  1;
		iEnd	= (m_iUndoMax-1)%HEX_UNDO_MAX;
		iPos	=  m_iUndoPos;
		}


	iRedraw  = m_iRedrawFlags;


	for(iNum=0;iCount>0;iCount--)
		{
		pUndo	= m_aUndo+iPos;
		iOffset = pUndo->uOffset;
		iFrom	= LineOfAddress(iOffset);

		if(pUndo->pData)								// Einen Speicherbereich tauschen
			{
			iLine = LineOfAddress(iOffset+pUndo->uSize-1);

			#if HEX_ALLOW_GROW

			if(pUndo->ucGrow==0x01)
				{
				GrowMem(iOffset,pUndo->uSize);
				iLine = -1;
				}

			#endif

			memxchg(m_pMem+iOffset,pUndo->pData,pUndo->uSize);

			#if HEX_ALLOW_GROW

			if(pUndo->ucGrow==0x02)
				{
				ShrinkMem(iOffset,pUndo->uSize);
				iLine = -1;
				}

			pUndo->ucGrow  ^= 0x03;

			#endif

			uMode			= pUndo->ucMode;
			pUndo->ucMode  ^= 1;
			}
		else{											// Einzelnes Byte ndern
			iLine = iFrom;
			uByte = m_pMem[iOffset];
			uMode= pUndo->ucMode;

			#if HEX_ALLOW_GROW

			if(pUndo->ucGrow==0x01)
				{
				GrowMem(iOffset);
				iLine = -1;
				}

			#endif

			m_pMem[iOffset]	= pUndo->ucByte;

			#if HEX_ALLOW_GROW

			if(pUndo->ucGrow==0x02)
				{
				ShrinkMem(iOffset);
				iLine = -1;
				}

			pUndo->ucGrow  ^= 0x03;

			#endif

			pUndo->ucByte	= uByte;
			pUndo->ucMode  ^= 0x01;
			}


		if(iFrom==iLine)								// Wurde nur eine Zeile verndert
				DrawViewLine(iFrom);
		else	DrawViewFrom(iFrom);

		iPos  = (iPos+iAdd)%HEX_UNDO_MAX;
		iNum +=  1;

		if(iPos==iEnd)break;
		}



	if(iAdd<0)
		{
		m_iUndoPos = (iPos+1)%HEX_UNDO_MAX;

		if(!pUndo->ucChange && m_iUndoPos==m_iUndoMin)
			{
			m_iFlags &= ~HEX_CHANGED;
			}
		}
	else{
		m_iUndoPos  = iPos;
		m_iFlags      |= HEX_CHANGED;
		}



	SetCursor(iOffset);

	if((uMode&0x02) && iAdd>0)							// Andere Bearbeitungsposition beim Wiederherstellen
		{
		uMode ^= 1;
		uMode += 1;
		}

	if(uMode>=3 && m_iCursorMode==0)					// Cursor auf die Bearbeitungsposition
		{
		PositionOk(uMode-2,0,0x01);
		}

	if(!iRedraw && m_iRedrawFlags)
		{
		DrawView(1);
		}



return iNum;
}

//*****************************************************************************
//*
//*		GrowMem
//*
//*****************************************************************************
//	Ein oder mehrere Bytes in den Speicher einfgen.
//	iOff		: Offset wo die Bytes eingefgt werden soll
//	Erbibt 1 wenn das Byte eingefgt wurde, bzw. 0 bei einem Fehler.
#if HEX_ALLOW_GROW
int CHexView::GrowMem(OffI iOff,int iByte)
{
uchar	   *pData;
int			iSize;
int			iRest;
int			iLine;


	if(iOff<0 || iOff>m_iMemSize || iByte<=0 || iOff+(OffI)iByte>HEX_MAX_GROW)
		{
		return 0;
		}

	iRest = (int)(m_iMemSize-iOff);

	if(m_iMemExtra<iByte)								// Muss neue Speicher allokiert werden
		{
		iSize	= (int)(m_iMemSize+iByte+0x1000);
		pData	= new uchar[iSize+4];

		if(!pData)return 0;

		memcpy(pData                ,m_pMem      ,(int)iOff);
		memcpy(pData+(int)iOff+iByte,m_pMem+(int)iOff,iRest);
		memset(pData+(int)iOff      ,0               ,iByte);

		m_pOldMem	= m_pMem;
		m_pMem		= pData;
		m_iMemExtra = 0x1000;
		}
	else{												// Speicher nur verschieben
		m_iMemExtra -= iByte;

		memmove(m_pMem+(int)iOff+iByte,m_pMem+(int)iOff,iRest);
		memset (m_pMem+(int)iOff      ,0               ,iByte);
		}


	m_iMemSize += iByte;

	if(m_iLineWidth)
		{
		m_iLineCount = (int)((m_iMemSize+(OffI)(m_iMemBegin%m_iLineWidth)+(OffI)m_iLineWidth-1)/(OffI)m_iLineWidth);
		}


	m_iFlags    |= HEX_CHANGED;
	iLine		 = LineOfAddress(iOff);
	DrawViewFrom(iLine);


return 1;
}

#endif

//*****************************************************************************
//*
//*		ShrinkMem
//*
//*****************************************************************************
//	Ein oder mehrere aus dem Speicher entfernen
//	iOff		: Offset wo die Bytes entfernt werden sollen
//	Erbibt 1 wenn das Byte eingefgt wurde, bzw. 0 bei einem Fehler.
#if HEX_ALLOW_GROW
int CHexView::ShrinkMem(OffI iOff,int iByte)
{
int			iRest;
int			iLine;


	if(iOff<0 || iOff>=m_iMemSize || iByte<=0)			// Prfe das Offset
		{
		return 0;
		}

	 if(iByte+iOff>m_iMemSize)							// Die Byte-Anzahl
		{
		iByte = (int)(m_iMemSize-iOff);
		}

	iRest		 = (int)(m_iMemSize-iOff)-iByte;

	m_iMemExtra += iByte;
	m_iMemSize  -= iByte;

	memmove(m_pMem+(int)iOff,m_pMem+(int)iOff+iByte,iRest);


	if(m_iLineWidth)
		{
		m_iLineCount = (int)((m_iMemSize+(OffI)(m_iMemBegin%m_iLineWidth)+(OffI)m_iLineWidth-1)/(OffI)m_iLineWidth);
		}

	m_iFlags    |= HEX_CHANGED;
	iLine		 = LineOfAddress(iOff);
	DrawViewFrom(iLine);


return 1;
}

#endif

//*****************************************************************************
//*
//*		GetGrowingType
//*
//*****************************************************************************
//	Einfgemodus abfragen
//	Ergibt 1 wenn erlaubt 0 wenn nicht und -1 wenn nicht mglich
int CHexView::GetGrowingType()
{

	#if HEX_ALLOW_GROW

	if(!(m_iFlags&HEX_NOT_CHANGE) && (m_iFlags&HEX_MEM_FREE) && m_iMemSize<=HEX_MAX_GROW)
		{
		return (m_bCanGrow)? 1:0;
		}

	#endif


return -1;
}

//*****************************************************************************
//*
//*		SetGrowingMode
//*
//*****************************************************************************
//	Einfgemodus setzen
//	iAllow		: Wie soll der Einfgemodus verndert werden
//					-1 = nicht ndern
//					 0 = ausschalten
//					 1 = einschalten
//	iOn			: Wie soll der generlle Einfgemodus gesetzt werden
//					-1 = nicht ndern
//					 0 = ausschalten
//					 1 = einschalten
//	Ergibt 1 wenn das Einfgen erlaubt ist.
int CHexView::SetGrowingMode(int iAllow,int iOn)
{
#if HEX_ALLOW_GROW

int		iOld;
int		iRet;


	iOld = (m_bCanGrow && m_bAllowGrow)? 1:0;

	if(iOn>0 && !(m_iFlags&HEX_NOT_CHANGE) && (m_iFlags&HEX_MEM_FREE) && m_iMemSize<=HEX_MAX_GROW)
		{
		m_bCanGrow = 1;
		}
	else if(iOn>=0)
		{
		m_bCanGrow = 0;
		}

	if(iAllow>=0)
		{
		m_bAllowGrow = 1;
		}
	else if(iAllow==0)
		{
		m_bAllowGrow = 0;
		}

	iRet = (m_bCanGrow && m_bAllowGrow)? 1:0;

	if(iOld!=iRet)
		{
		SetCursorMode((iRet)? 0x03:0x02);
		}


return iRet;

#endif


return 0;
}
