//*****************************************************************************
//*
//*
//*		Klasse  CHexView = Text CHexView Fenster
//*
//*
//*****************************************************************************
#include	<stdlib.h>
#include    "Controls/HexMessage.h"

#ifdef		TO_HEXWND
	#define		CAnsiView	CAnsiWnd
	#define		CHexView	CHexWnd
	#define 	CView		CWnd
#else
	#ifdef		CAnsiView
	#undef 		CAnsiView
	#endif
	#ifdef		CHexView
	#undef 		CHexView
	#endif
	#ifdef		CView
	#undef 		CView
	#endif
#endif

//*****************************************************************************


#ifdef     _WIN64
#ifdef		HEX_ADDR_64
#undef 		HEX_ADDR_64
#endif
#define 	HEX_ADDR_64			1							// Adressen sind 64-Bit breit
#else
#ifndef		HEX_ADDR_64
#define 	HEX_ADDR_64			0							// Adressen sind 32-Bit breit
#endif
#endif

#ifdef     _WIN64
#ifdef		HEX_OFFSET_64
#undef 		HEX_OFFSET_64
#endif
#define 	HEX_OFFSET_64		1							// Offsets sind 64-Bit breit
#else
#ifndef		HEX_OFFSET_64
#define 	HEX_OFFSET_64		0							// Offsets sind 32-Bit breit
#endif
#endif

#ifndef		HEX_SPACE1
#define		HEX_SPACE1			2							// Space zwischen Adress und Hex
#endif

#ifndef		HEX_SPACE2
#define		HEX_SPACE2			2							// Space zwischen Hex und String
#endif

#ifndef		HEX_SLOT_COUNT
#define		HEX_SLOT_COUNT		8							// Anzahl der Bereiche fr's Suchen
#endif

#ifndef		HEX_UNDO_MAX
#define 	HEX_UNDO_MAX		256							// Gre des Undo-Speichers
#endif

#ifndef		HEX_ALLOW_GROW
#define 	HEX_ALLOW_GROW		0							// Kann der Speicher mit einer Eingabe wachsen
#endif

#ifndef		HEX_MAX_GROW
#define 	HEX_MAX_GROW		0x20000						// Maximale Gre bis zu der der Speicher wachsen kann
#endif



// Art Flags fr Konstruktor

#define		HEX_NOT_CHANGE	 	0x0001						// Text in darf nicht gendern
#define		HEX_AUTO_SIZE      	0x0002						// Breite automatisch bestimmen
#define		HEX_SNAP_IN        	0x0004						// Start Adresse einrasten
#define		HEX_GRID_SIZE    	0x0008 						// Breiten in Schritten
#define		HEX_NO_HEX         	0x0010 						// Keinen Hex-Bereich anzeigen
#define		HEX_NO_STR         	0x0020 						// Keinen Str-Bereich anzeigen
#define		HEX_NO_ADR			0x0040 						// Keinen Adr-Bereich anzeigen
#define		HEX_CONFIG			0x0080 						// Konfiguration aus Registry holen
#define		HEX_MEM_FREE        0x0100 						// Speicher beim Beenden freigeben
#define		HEX_CHANGED			0x8000 						// Wurde Speicher gendert
#define		HEX_INIT            0x4000 						// Fenster neu initialisieren

// Konstanden fr Notify Nachrichten

#define 	HEX_SELCHANGE		0x2BF5						// Nachricht bei Markierungsnderungen
#define 	HEX_CONFIGCHANGE	0x2BF6						// Nachricht bei Konfigurationsnderungen
#define 	HEX_KILLFOCUS		0x2BF7						// Nachricht bei Verlust des Focus
#define 	HEX_SETFOCUS		0x2BF8						// Nachricht bei Erhalt des Focus
#define 	HEX_TABLOOP			0x2BF9						// Nachricht bei TAB-Sprngen aus dem Fenster

#if			HEX_ALLOW_GROW==0
#define 	m_bAllowGrow		0
#define 	m_bCanGrow			0
#endif



//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class CHexView : public CAnsiView
{
#ifndef		TO_HEXWND
DECLARE_DYNCREATE(CHexView)
#endif

public:

#if     (HEX_ADDR_64!=0) && (HEX_OFFSET_64!=0)

typedef	LONGLONG		MaxI;
typedef	LONGLONG		OffI;
typedef	LONGLONG		AdrI;
typedef	ULONGLONG		MaxU;
typedef	ULONGLONG		OffU;
typedef	ULONGLONG		AdrU;

#elif   (HEX_ADDR_64!=0) && (HEX_OFFSET_64==0)

typedef	LONGLONG		MaxI;
typedef	int				OffI;
typedef	LONGLONG		AdrI;
typedef	ULONGLONG		MaxU;
typedef	UINT			OffU;
typedef	ULONGLONG		AdrU;

#elif   (HEX_ADDR_64==0) && (HEX_OFFSET_64!=0)

typedef	LONGLONG		MaxI;
typedef	LONGLONG		OffI;
typedef	int				AdrI;
typedef	ULONGLONG		MaxU;
typedef	ULONGLONG		OffU;
typedef	UINT			AdrU;

#else //(HEX_ADDR_64==0) && (HEX_OFFSET_64==0)

typedef	int				MaxI;
typedef	int				OffI;
typedef	int				AdrI;
typedef	UINT			MaxU;
typedef	UINT			OffU;
typedef	UINT			AdrU;

#endif

typedef	unsigned int	uint;
typedef	unsigned char	uchar;


protected:

		uchar		   *m_pMem;								// Zeiger auf angezeigten Speicher
		OffI			m_iMemSize;							// Lnge des Speichers in Byte
		AdrI			m_iMemAddress;						// Adresse des ersten Bytes fr m_pMem[0]
		int				m_iMemBegin;						// Startverschub in der ersten Zeile

#if HEX_ALLOW_GROW
		uchar		   *m_pOldMem;							// Vorheriger Speicher spter freigben
		int 			m_iMemExtra;						// Lnge des Extra-Bytes am Ende des Speichers
		bool 			m_bAllowGrow;						// Ist der Modus an Wachsen an
		bool 			m_bCanGrow;							// Kann der Speicher wachsen
#endif

		LPTSTR			m_pMoveItems;						// Liste mit allen Sprungzielen
		void	  	   *m_pBitFlags;						// Bitfeld mit Marken (fr Markierung)
		int				m_iBitCount;						// Anzahl der Bitmarken in Byte

		int				m_iLineWidth;						// Bytebreite einer Zeile
		int				m_iLineWidthTemp;					// Bytebreite einer Zeile (eingestellt)
		int				m_iLineSpaceN;						// Bytezahl fr extra Space
		int				m_iLineSpaceNTemp;					// Bytezahl fr extra Space (eingestellt)
		int				m_iLineAddSpace;					// Space anhngen
		int				m_iLineFormat;						// Ausgabeformat 0=byte 1=word 2=dword 3=qword
		int				m_iLineInvert;						// Maske fr's invertieren von Bytes
		int				m_iLineAdrRaster;					// Adresse einrasten
		int				m_iLineAdrRasterTemp;				// Adresse einrasten (eingestellt)
		int				m_iLineRasterSteps;					// Raster Schritte fr Breite
		int				m_iLineRasterStepsTemp;				// Raster Schritte fr Breite (eingestellt)
		int				m_iPosOfStr;						// Postion  fr ASCII-Zeichen
		int				m_iPosOfHex;						// Position fr Hex Zeichen
		int				m_iPosOfEnd;						// Position fr Ende der Zeile
		int				m_iLenOfAdr;						// Lnge des Adr-Bereiches
		int				m_iLenOfHex;						// Lnge des Hex-Bereiches
		int				m_iLenOfStr;						// Lnge des Str-Bereiches
		int				m_iPosLastX;						// Letzte X-Position im Str oder Hex Bereich
		int				m_iHasTabLoop;						// Werden Tab-Sprnge aus dem Fenster gemeldet
		int				m_iSelRaster;						// Die Auswahl auf das Ausgabeformat rastern

		int				m_iCursorMode;						// Wo ist der Cursor (0=HEX 1=STR 2=ADR)
		int				m_iCursorNipple;					// Cursor in oberen oder unteren 4-Bit (0=0..3 1=4..7)
		OffI			m_iCursorOffset;					// Byte auf den der Cursor steht (Offest in m_pMem)
		OffI			m_iAreaStart[HEX_SLOT_COUNT+1];		// Anfang eines Bereiches
		OffI			m_iAreaEnd  [HEX_SLOT_COUNT+1];		// Ende   eines Bereiches
		uchar			m_uAreaUsed [HEX_SLOT_COUNT+1];		// Ist Bereich aktiv
		uchar			m_uAreaColor[HEX_SLOT_COUNT+1];		// Farbe  eines Bereiches

static	LPTSTR   		m_pFindText;						// String Kette fr suchen
static	LPTSTR   		m_pGroupText;						// String Kette fr Gruppensuche
static	LPTSTR   		m_pResultText;						// String Kette fr Suche

#ifdef	HEX_MULTI_ADDR
		int				m_iMultiMax;						// Gre der Umwandlungstabellen
		int				m_iMultiCount;						// Anzahl der Multi-Frames
		AdrU   		   *m_pMultiOffToAdr;					// Umwandlungstabelle Linerar->Address
		AdrU   		   *m_pMultiAdrToOff;					// Umwandlungstabelle Address->Linerar
#endif

private:

static	int				m_iWindowCount;						// Anzahl der Fenster insgesamt
static	int				m_iFindFlags;						// Flags fr das Suchen
      	int				m_iFlags;							// Flags fr Fenster
        int				m_iFlagsOld;						// Alter Zustand der Flags
		OffI			m_iStausbarOff;						// Zustand der Statusbar
		int     		m_iStausbarMode;					// Art der Adresse
		int				m_iStausbarValue;					// Zustand der Statusbar
		int     		m_iStausbarLen;						// Byte-Lnge des Wertes
		int				m_iStatusbarInit;					// Statusbar eingeschalten
		int				m_iStausbarCnt;						// Statusbar-Zhler
		int				m_iMouseX;							// Maus Zeiger Position
		int				m_iMouseY;							//			*
		int				m_iOnSizeCnt;						// Ist die Funktion OnSize aktiv

typedef struct
		{
		uchar		   *pData;								// Speicher fr das Einfgen
		OffU			uOffset;							// Offset im Speicher
		unsigned		uSize;								// Gre des Speichers
		unsigned char	ucByte;								// Wert fr einzel Zeichen
		unsigned char	ucMode;								// Wo war der Cursor (0=Str 2=HexLow 3=HexHigh)
		unsigned char	ucChange;							// War der Speicher gendert
		unsigned char	ucGrow;								// Shrink=1 Grow=2
		}UndoBlock;

		int				m_iUndoPos;							// Aktuelle Undo-Position
		int				m_iUndoMax;							// Maximale Undo-Position
		int				m_iUndoMin;							// Minimale Undo-Position
		UndoBlock		m_aUndo[HEX_UNDO_MAX];				// Undo-Speicher


DECLARE_MESSAGE_MAP()
friend class CHexDoubleWnd;

//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

public:

	CHexView(int iMode=0);
   ~CHexView();

		int	   ConfigView     ();
		int    ConfigLoad	  (LPCTSTR	pPath=0);
		int    ConfigSave     (LPCTSTR	pPath=0);
		int    GetConfig 	  (int		iMode);
		int    SetConfig 	  (int		iRasterWidth=-1,int iAddressRaster=-1,int iValueShowMode=-1,int iSelcetRaster=-1);
		OffI   Find			  (char    *pBytes,int iLen,OffI iStart=0,OffI iSize=0x40000000,int iMode=0);
		OffI   FindText		  (LPTSTR   pText          ,OffI iStart=0,OffI iSize=0x40000000,int iMark=0);
		int	   FindNext		  ();
		int	   FindSelection  ();
		int	   IsSelected     ();									// Ergibt ob eitwas markiert ist
		OffI   SetMem         (void    *pMem   ,OffI iSize,AdrI iAddress=0,int iMode=0);
		uchar *GetMem         (OffI    *pSize=0,AdrI *pAddress=0);
		uchar *GetMemPointer  ();
		MaxI   GetSelection	  (int		iMode=0               ,int *pLen=0);
		int	   GetSelection	  (void    *pStart,  int iMax     ,int *pLen=0);
		int	   GetSelection	  (MaxI    *pStart,                int *pLen=0,int iMode=0,int iMax=0x00400000);
		int	   Select		  (int      iMode=-1,OffI iStart=0,OffI iLen=0);
		int	   EnsureVisible  (OffI     iStart,OffI iLen);
		int	   EnsureVisible  (int	    iMode);
		AdrI   MoveTo		  (AdrI     iAddr=-1);
		int	   Undo			  (int      iCount);
		int	   UndoSave		  (MaxI     iAddress,int iSize,int iMode=0);
		int	   GetCursorMem	  (void    *pMem ,int iSize);			// Speicher bei Cursor kopieren
		int	   GetSelectedMem (void    *pMem ,int iSize);			// Speicher der Marke  kopieren
		int	   SetCursor	  (MaxI     iAddr,int iMode=0);			// Setze Cursor auf Anzeigeadresse
		int    SetCursor      (MaxI     iAddr,int iMode,int iShift);// Setze Cursor auf Anzeigeadresse mit Shift
		MaxI   SetScroll	  (MaxI     iAddr,int iMode=0);			// Setze Addresse der linken oberen Ecke
		int	   SetSelection	  (MaxI     iAddr,int iMode=0);			// Setze Marke  auf Anzeigeadresse
		int	   SetSelection	  (MaxI     iAddr,int iLen,int iMode);	// Setze Marke  auf Anzeigeadresse (ganzer Bereich)
		AdrI   SetAddress	  (AdrI     iAddr);						// Setze Basis-Anzeiger-Addrese
		MaxI   GetScroll	  (int      iMode=0);					// Hole Addresse/Offset der linken oberen Ecke
		MaxI   GetCursor	  (int      iMode=0);					// Hole Cursor Addrese/Offset
		MaxI   GetCursorAddr  (int      iMode=0);					// Hole Cursor Addrese/Offset (ohne Markenausgeich)
		int	   SetCursorArea  (int      iArea);						// Stellt ein in welchem Bereich der Cursor sich befinden soll
		int	   GetCursorArea  ();									// Hole in welchem Bereich sich der Cursor befindet
		int	   GetViewSize	  ();									// Hole die Anzahl der angezeigen Bytes auf einer Seite
		AdrI   GetAddress	  ();									// Hole Basis Anzeige-Offset
		OffI   GetLength	  ();									// Hole Speicherlnge
		bool   GetGrowingOn   ();									// Ist die Speichervergerung aktiv
		bool   GetGrowingMode ();									// Kann der Speicher vergert werden
		int	   SetGrowingMode (int iAllow,int iOn=-1);				// Einfgemodus setzen
		int	   GetGrowingType ();									// Einfgemodus abfragen
		int	   DeleteSelection();									// Marke lschen
		int	   SetBitSelection(void    *pMark,int iSize=-1);		// Bit Marken setzen
		void  *GetBitSelection(int     *pSize=0); 					// Bit Marken abfragen


static  int _cdecl CppMakeText(void    *pMem,int iMemLen,int iByte,int iFormat,int iWidth,TCHAR *pBuffer,int iSize);
		int	   SetWidth		  (int		iWidth=-1,int iSpaceN=-1,int iAddSpace=-1,int iAdrLen=-1,int iFormat=-1,int iInvert=-1);
virtual void   Update		  (int		iMode=0);
		BOOL   SetModify	  (BOOL		bModify=1);
		BOOL   GetModify	  ();
		DWORD  GetFlags		  ();
		DWORD  SetFlags		  (DWORD	uFlags,DWORD uMask=0xFFFF);

		int	   FindView		  ();
		int	   SelectionCopy  ();
		int	   SelectionInsert(int      iMode=0);
		int	   SetTabLoop	  (int		iMode=1);

		void   OnUndo         ();
		void   OnUndoBack     ();
		void   OnCopy		  ();
		void   OnPaste		  ();
		void   OnPasteEx	  ();
		void   OnMoveTo		  ();
		void   OnCppCopy	  ();
		void   OnStrCopy	  ();
		void   OnFloatView	  ();
		void   OnCrcCalc	  ();
		void   OnChecksum	  ();
		void   OnHexConvert	  ();
		void   OnValueInput	  ();

#ifdef	HEX_MULTI_ADDR
		BOOL   AddFrame		  (AdrU		uAddr,OffU uSize,OffU uOffset);
		AdrU   AddrToLinear	  (AdrU 	uAddr);
		AdrU   LinearToAddr	  (AdrU 	uAddr);
		uint   IsMemInFrame	  (AdrU 	uAddr);
#endif

protected:

	#if HEX_ALLOW_GROW
	int			GrowMem		  (OffI		iOff,int iByte=1);
	int			ShrinkMem	  (OffI		iOff,int iByte=1);
	#endif

	void		StartMenu	  (CPoint   sPoint,CMenu *pMenu);
	int 	 	HexPosition	  (uint 	uOffset);
	int			BinPosition	  (int		iPosX);
	AdrI		GetAddress 	  (int	    iPosX,int  iPosY);
	void 		GetPosition	  (int 	   &iPosX,int &iPosY  ,OffI iOffset);
	void		SendNotify 	  (int 	    iType,MaxI iParam1,MaxI iParam2,int iParam3=0);
	void		SendNotify 	  (int 	    iType,int  iParam=0);
	int			LineOfAddress (OffI	    iOffset);
	int			StatusbarSet  ();



	//{{AFX_VIRTUAL(CHexView)
	virtual void PrintMargin(HDC  hDc,RECT *pRect,int iLine);
	virtual int  PrintLine  (HDC  hDc,RECT *pRect,int iLine,int iStart,int iSize,int iFlags=0);
	virtual int  PositionOk (int  iPosX,int iPosY,int iMode=0);
	virtual int  LineLength (int  Zeile);
	virtual void OnSize     (int  iSizeX,int iSizeY,int iDeltaX,int iDeltaY);
	virtual int  OnChar     (UINT nChar,UINT nFlags);
	virtual int  OnKeyDown  (UINT nChar,UINT nFlags);
	//}}AFX_VIRTUAL



	//{{AFX_MSG(CHexView)
	afx_msg	void	OnFindView       ();
	afx_msg	void	OnFindNext       ();
	afx_msg	void	OnFindMark       ();
	afx_msg	void	OnConfigView     ();
	afx_msg	void	OnMenuFind       (CCmdUI *pCmdUI);
	afx_msg	void	OnMenuUndo 		 (CCmdUI *pCmdUI);
	afx_msg	void	OnMenuUndoBack	 (CCmdUI *pCmdUI);
	afx_msg	void	OnMenuSelection  (CCmdUI *pCmdUI);
	afx_msg	void	OnMenuClipboard  (CCmdUI *pCmdUI);
	afx_msg void	OnKillFocus      (CWnd   *pNewWnd);
	afx_msg void	OnSetFocus       (CWnd   *pOldWnd);
	afx_msg	BOOL	OnPreparePrinting(CPrintInfo *pInfo);
	afx_msg LRESULT OnHexInfo(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG

private:

	int			StatusbarInit();
	int			StatusbarExit();
	void		UndoClear    ();
	void		UndoAdd		 ();
	UndoBlock  *UndoGet(OffU uOffset,unsigned uSize=0);

};


#ifndef 	__HEX_NMHDR__
#define 	__HEX_NMHDR__

typedef struct
	{
	NMHDR			sHdr;									// Notify Daten
	CHexView::MaxI	iParam1;
	CHexView::MaxI	iParam2;
	int				iParam3;
	}HEX_NMHDR,*LPHEX_NMHDR;

#endif


//*****************************************************************************
//*
//*		Inline Funktioen
//*
//*****************************************************************************
inline	unsigned char  *CHexView::GetMemPointer (){return  m_pMem			      ;}
inline	CHexView::AdrI	CHexView::GetAddress    (){return  m_iMemAddress          ;}
inline	CHexView::OffI	CHexView::GetLength     (){return  m_iMemSize             ;}
inline	bool			CHexView::GetGrowingMode(){return  m_bCanGrow             ;}
inline	bool			CHexView::GetGrowingOn  (){return  m_bAllowGrow           ;}
inline	int				CHexView::GetCursorArea (){return  m_iCursorMode          ;}
inline	int				CHexView::GetViewSize   (){return  m_iScreenY*m_iLineWidth;}
inline	int				CHexView::IsSelected    (){return  m_uAreaUsed[0]         ;}
inline	int				CHexView::SetTabLoop    (int iMode){int iOld=m_iHasTabLoop;m_iHasTabLoop=iMode;return iOld;}

//*****************************************************************************

#if			HEX_ALLOW_GROW==0
#undef 		m_bAllowGrow
#undef 		m_bCanGrow
#endif
#ifdef		CAnsiView
#undef 		CAnsiView
#endif
#ifdef		CHexView
#undef 		CHexView
#endif
#ifdef		CView
#undef 		CView
#endif


