//*****************************************************************************
//*
//*
//*		HexDlg.h
//*
//*
//*****************************************************************************
#ifndef	AFX_HEXDLG_H__85678844_F5DA_2351_9231_174553540044__INCLUDED_
#define AFX_HEXDLG_H__85678844_F5DA_2351_9231_174553540044__INCLUDED_


#if				_MSC_VER >= 1000
#pragma once
#endif


#define		HEX_FIND_UPWARDS	 0x0001				// Bei Suche nach oben suchen
#define		HEX_FIND_IN_SEL		 0x0002 			// Bei Suche nach oben suchen
#define		HEX_FIND_IN_ALL		 0x0004				// Die Ganze Datei durchsuchen
#define		HEX_FIND_NO_CASE	 0x0008 			// Gro-Kleinschreibung ignorieren
#define		HEX_FIND_GROUP       0x0010 			// Suche nach einer Gruppe
#define		HEX_FIND_IN_ORDER	 0x0020 			// Bei Gruppen-Suche Reihenfolge beachten
#define		HEX_FIND_BEGIN		 0x0040 			// Vom Anfang an suchen
#define 	HEX_FIND_UNICODE	 0x0080 			// Text als Unicode suchen
#define 	HEX_FIND_BIGENDIAN	 0x0100				// Zahlen ins Modorola Format umwandeln
#define		HEX_FIND_SELLECTED   0x8000 			// Ein Bereich ist Makiert
#define		HEX_FIND_NODIR		 0x4000 			// Richtungsauwahl sperren
#define		HEX_FIND_NOGROUP	 0x2000 			// Gruppenauswahl sperren
#define		HEX_FIND_NORETRY	 0x1000 			// Keine Weitersuchentaste

#define		HEX_FIND_MAX		 16					// Maximale Zahl der Suchen  Eintrge
#define		HEX_GROUP_MAX		 16					// Maximale Zahl der Gruppen Eintrge

//*****************************************************************************
//*
//*		Globale Funktionen
//*
//*****************************************************************************

TCHAR	   *ChainStr     (TCHAR **pChain,int iNum);
int			ChainDelete  (TCHAR **pChain,int iNum);
int			ChainFind	 (TCHAR **pChain,LPCTSTR pStr);
int			ChainInsert  (TCHAR **pChain,LPCTSTR pStr,int iNum);
int			ChainLength  (TCHAR **pChain);
int			ChainCount   (TCHAR **pChain);
void		ChainClear   (TCHAR **pChain);

int			StrMode      (LPCTSTR pStr);
int			StrToBin     (LPCTSTR pStr,void *pMem,int    iLen);
int			StrToBin     (LPCTSTR pStr,void *pMem,int    iLen,int iAllowMask);
int			BinToStr     (LPCVOID pMem,int   iLen,LPTSTR pStr,int iMode=4);

//*****************************************************************************
//*
//*		Klasse CHexFindDlg
//*
//*****************************************************************************
class CHexFindDlg : public CDialog
{
public:


	static int	m_iVarOld;							// Variabel alt
	int			m_iVarMode;							// Variabel art
	int			m_iInputMode;						// Eingabe  art
	int			m_iUpwarts;							// Aufwrts/abwrts suchen
	int			m_iCaseCmp;							// Gros/Kleinschreibung ignorieren
	int			m_iAll;								// Den ganzen Text durchsuchen
	int			m_iUnicode;							// Unicode Text suchen
	int			m_iBigEndian;						// Zahlen ins Modoroa Format umwandeln
	int			m_iSeachInMark;						// Den markierten Bereich durchsuchen
	int			m_iMarkOn;							// Ist Marke eingeschaltet
	int			m_iBegin;							// Von Anfang an suchen
	int			m_iGroupAnalyse;					// Den Text im Suchenfeld analysieren
	int			m_iGroup;							// Gruppensuche ein
	int			m_iGroupOld; 						// Gruppen Suche alter Wert
	int			m_iGroupLen;		    			// Gruppen Suche ein
	int			m_iGroupRow;						// Gruppen Suche ein
	int			m_aGroupOff;						// Gruppen Suche sperren
	int			m_iUntilOff;						// Weitersuchen-Taste ausschalten
	int			m_iTextLen;							// Lnge des Texte im Suchen Feld
	int			m_iExit;							// Exit-Flags
	int			m_iNoDir;							// Richtungsauswahl sperren
	TCHAR	   *m_pText;							// Anfangs Text
	TCHAR     **m_pFindText;						// Suche Texte
	TCHAR     **m_pGroupText;						// Gruppen-Suche Texte
	TCHAR     **m_pResultText;						// Ergebnis-Kette

	//{{AFX_DATA(CTextFindDlg)
	//}}AFX_DATA(CTextFindDlg)

			CHexFindDlg(CWnd *pParent = NULL);
   	INT_PTR	DoModal    (int  *pFlags,TCHAR **pFindText,TCHAR **pGroupText,TCHAR **pResultText,TCHAR *pText=0);

protected:

	void	AddFindText();
	void	StringMode(TCHAR *pStr,int iMax);
	void	EndDialog (int    iRet);


	//{{AFX_VIRTUAL(CHexFindDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	virtual BOOL OnInitDialog();
	afx_msg void OnFind();
	afx_msg void OnNext();
	afx_msg void OnInputUpdate();
	afx_msg void OnInputCheck();
	afx_msg void OnInputConvert();
	afx_msg void OnGroupInsert();
	afx_msg void OnGroupDelete();
	afx_msg void OnGroupClearAll();
	afx_msg void InsertEntryInGroup();
	afx_msg void OnGroupUp();
	afx_msg void OnGroupDown();
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CHexFindDlg)
	virtual	void OnCancel();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	static int 		m_iScreenX,m_iScreenY,m_iScreenOn;		// Alte Dialogposition
	static WORD		m_wDlgData[];

};

//*****************************************************************************
//*
//*		Klasse CHexConfigDlg
//*
//*****************************************************************************
class CHexConfigDlg : public CDialog
{
public:

	int			m_iSpace;									// Leerzeichen einfgen
	int			m_iSpaceN;									// Alle n-Zeichen ein Extra Leerzeichen
	int			m_iSpaceNOn;								// Extra Leerzeichen ein
	int			m_iWidth;									// Fixe Breite
	int			m_iWidthOn;									// Fixe Breite einschalten
	int			m_iRaster;									// Adressraster
	int			m_iRasterOn;								// Adressraster einschalten
	int			m_iRasterW;									// Breitenraster
	int			m_iRasterWOn;								// Breitenraster einschalten
	int			m_iValue;									// Wert-Anzeige
	int			m_iValuePos;								// Wert-Anzeige positiv
	int			m_iAddressLen;								// Adressziffern Zahl
	int			m_iBigEndian;								// Anzeige im Modorola Format
	int			m_iHexDisdance;								// Distanzanzeige Hexadezimal
	int			m_iInvertBytes;								// Byte-Reihenfolge invertieren
	int			m_iSelRaster;								// Die Auswahl m_iUpwarts das Format rastern
	int			m_iFormat;									// Ausgabeformat (0=Byte 1=Wort 2=Dword 3=Qword)

	CHexConfigDlg(CWnd *pParent = NULL);
   	INT_PTR		DoModal();

protected:

	//{{AFX_VIRTUAL(CHexConfigDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	afx_msg void OnInputUpdate();
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CHexConfigDlg)
	//}}AFX_MSG


	DECLARE_MESSAGE_MAP()


	static WORD		m_wDlgData[];

};

//*****************************************************************************
//*
//*		Klasse CHexChecksumDlg
//*
//*****************************************************************************
class CHexChecksumDlg : public CDialog
{
public:

	unsigned int	m_uSumBa;								// Byte  Summe ADD
	unsigned int	m_uSumWa;								// Word  Summe
	unsigned int	m_uSumDa;								// DWord Summe

	unsigned int	m_uSumBs;								// Byte  Summe SUB
	unsigned int	m_uSumWs;								// Word  Summe
	unsigned int	m_uSumDs;								// DWord Summe

	unsigned int	m_uSumBx;								// Byte  Summe XOR
	unsigned int	m_uSumWx;								// Word  Summe
	unsigned int	m_uSumDx;								// DWord Summe

	unsigned int	m_uSumWaBe;								// Word  Summe ADD big endian
	unsigned int	m_uSumDaBe;								// DWord Summe

	unsigned int	m_uSumWsBe;								// Word  Summe SUB big endian
	unsigned int	m_uSumDsBe;								// DWord Summe

	unsigned int	m_uSumWxBe;								// Word  Summe XOR big endian
	unsigned int	m_uSumDxBe;								// DWord Summe


	//{{AFX_DATA(CHexChecksumDlg)
	BOOL	m_iBigEndian;
	//}}AFX_DATA(CHexChecksumDlg)

	BOOL	m_iHasBigEndinan;

			CHexChecksumDlg(CWnd  *pParent = NULL);
   	INT_PTR	DoModal(unsigned char *pMem,unsigned int iLen);


protected:

	//{{AFX_VIRTUAL(CHexChecksumDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CHexChecksumDlg)
	afx_msg HBRUSH OnCtlColor( CDC *pDC, CWnd *pWnd,UINT nCtlColor);
	afx_msg void   OnChangeEndian();
	virtual BOOL   OnInitDialog();
	virtual void   OnCancel();
	virtual void   OnOK();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	static int 		m_iScreenX,m_iScreenY,m_iScreenOn;		// Alte Dialogposition
	static WORD		m_wDlgData[];


};

//*****************************************************************************
//*
//*		Klasse CHexItemDlg
//*
//*****************************************************************************
class CHexItemDlg : public CDialog
{
public:

	//{{AFX_DATA(CHexItemDlg)
	//}}AFX_DATA(CHexItemDlg)

  __int64			m_iValue;								// Wert
	int				m_iMode;								// Anzeigemodus (0=dez 1=hex 2=dez64 3=hex64)
	LPCTSTR			m_pText;								// Eingabetext
	LPCTSTR			m_pTitle;								// Titeltext
	LPTSTR		   *m_pItems;								// Liste mit Eintrgen

	CHexItemDlg(CWnd *pParent = NULL);
	virtual INT_PTR  DoModal();

protected:

	//{{AFX_VIRTUAL(CHexItemDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	virtual BOOL OnInitDialog( );
	virtual void OnOK();
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CHexItemDlg)
	//}}AFX_MSG

	static WORD		m_wDlgData[];

};

//*****************************************************************************
//*
//*		Klasse CHexValueDlg
//*
//*****************************************************************************
class CHexValueDlg : public CDialog
{
public:

	//{{AFX_DATA(CHexValueDlg)
	CString			m_sText;
	int				m_iMode;								// 0=Byte 1=Word 2=DWord 3=QWord
	BOOL			m_iBigEndian;
	//}}AFX_DATA_INIT

	LPCTSTR			m_pTitle;								// Titeltext
	LPCTSTR			m_pEditText;							// Eingabe Titel

	typedef int (_cdecl *PreviewCb)(void *pParam,int iMemLen,int iByte,int iFormat,int iWidth,TCHAR *pBuffer,int iSize); 
	
	PreviewCb		m_pPreview;								// Callback  fr Vorschau
	void		   *m_pPreParam;							// Parameter fr Vorschau
	int				m_iPreLength;							// Lnge     fr Vorschau

	union													// Eingegebener Zahlenwert
		{
	__int64				i64;									
	  int				i;
	  short 			s;
	  char  			c;
	  char				text[8];
	unsigned  __int64	ui64;
	unsigned   int		ui;
	unsigned   short 	us;
	unsigned   char  	uc;
	unsigned   char		data[8];
		}m_sValue;

	int     		m_iType;								// 1=Hex 0=Dec
	int				m_iLength;								// Lnge der Zahl in Byte (1=BYTE 2=WORD 4=DWORD 8=QWORD)
	int				m_iFormat;								// 0=C/C++ 1=ASM 2=BASE64 3=Dump
	int				m_iFormatOn;							// Die ASM-Format Optinon einschalten

	CHexValueDlg(CWnd *pParent = NULL);
	virtual INT_PTR  DoModal();

protected:

	//{{AFX_VIRTUAL(CHexValueDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CHexValueDlg)
	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	afx_msg void OnTimer(UINT_PTR nIdEvent);
	virtual BOOL OnInitDialog( );
	afx_msg void OnClicked();
	virtual void OnCancel();
	afx_msg void OnUpdate();
	virtual void OnOK();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	void			UpdateText(int iFormat);
	UINT			m_uTicker;								// Update-Ticker

	static int 		m_iScreenX,m_iScreenY,m_iScreenOn;		// Alte Dialogposition
	static WORD		m_wDlgData [];
	static WORD		m_wDlgData1[];
	static WORD		m_wDlgData2[];

};


//*****************************************************************************
//*
//*		Klasse CHexConvertDlg
//*
//*****************************************************************************
class CHexConvertDlg : public CDialog
{
public:

	CHexConvertDlg(CWnd *pParent = NULL);
	
	BOOL			m_bCancel;
	BOOL			m_bUse64;
	LPCTSTR			m_pTitle;
	int				m_iValue;
	__int64			m_qValue;


	//{{AFX_DATA(CHexConvertDlg)
	CString	m_sValText;
	//}}AFX_DATA

	virtual INT_PTR DoModal ();
	inline  int		GetValue(){return  m_iValue;}
	inline  void	SetValue(int iVal){m_iValue=iVal;}

protected:

	//{{AFX_VIRTUAL(CHexConvertDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	//}}AFX_VIRTUAL

protected:

	int				m_iClacOk;
	int				m_iSelect;

	//{{AFX_MSG(CHexConvertDlg)
	afx_msg HBRUSH	OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	afx_msg void   	OnTimer(UINT_PTR nIDEvent);
	afx_msg void   	OnChange();
	virtual BOOL   	OnInitDialog();
	virtual void   	OnCancel();
	virtual void   	OnOK();
	//}}AFX_MSG


	DECLARE_MESSAGE_MAP()

	static int _cdecl TokenCallback(void *pParam,const char *pText,  int   *pValue);
	static int _cdecl TokenCallback(void *pParam,const char *pText,__int64 *pValue);

	static int 		m_iScreenX,m_iScreenY,m_iScreenOn;		// Alte Dialogposition


	static WORD		m_wDlgData[];
	LPTSTR			m_pLastEntries;
};

//*****************************************************************************
//*
//*		Klasse CHexFloatDlg
//*
//*****************************************************************************
class CHexFloatDlg : public CDialog
{
public:

	CHexFloatDlg(CWnd *pParent = NULL);

	//{{AFX_DATA(CHexFloatDlg)
	//}}AFX_DATA

	__int64			m_iMantisseD;							// double Mantisse
	int		 		m_iMantisseF;							// float  Mantisse
	int 			m_iExponentD;							// double Exponent
	int		 		m_iExponentF;							// float  Exponent
	double			m_dValue;								// double Wert
	float			m_fValue;								// float  Wert
	BYTE			m_bHexData[8];							// BYTE Daten
	BYTE			m_bValueOk[4];							// Fehler Bits
	int				m_iMode;								// 0=double 1=float 2=hex Eingabe 3=D-Mantisse 4=F-Mantisse 5=D-Exponent 6=F-Exponent
	int				m_iSize;								// Gltige m_bHexData Bytes (4 oder 8)


	//{{AFX_VIRTUAL(CHexFloatDlg)
	virtual INT_PTR  DoModal();
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);		// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	int				m_iDisable;
	CEdit		   *m_pEditHex;
	CEdit		   *m_pEditFloat;
	CEdit		   *m_pEditDouble;
	CEdit		   *m_pEditFloatM;
	CEdit		   *m_pEditDoubleM;
	CEdit		   *m_pEditFloatE;
	CEdit		   *m_pEditDoubleE;

	void SetText(int iNum);

	//{{AFX_MSG(CHexFloatDlg)
	afx_msg HBRUSH OnCtlColor(CDC *pDC,CWnd* pWnd,UINT nCtlColor);
	afx_msg void OnExitDoubleM();
	afx_msg void OnExitFloatM();
	afx_msg void OnExitDoubleE();
	afx_msg void OnExitFloatE();
	afx_msg void OnFocusDoubleM();
	afx_msg void OnFocusFloatM();
	afx_msg void OnFocusDoubleE();
	afx_msg void OnFocusFloatE();
	afx_msg void OnChangeDouble();
	afx_msg void OnChangeFloat();
	afx_msg void OnChangeDoubleM();
	afx_msg void OnChangeFloatM();
	afx_msg void OnChangeDoubleE();
	afx_msg void OnChangeFloatE();
	afx_msg void OnChangeHex();
	afx_msg void OnSwapB();
	afx_msg void OnSwapW();
	afx_msg void OnSwapQ();
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	static int 		m_iScreenX,m_iScreenY,m_iScreenOn;		// Alte Dialogposition
	static WORD		m_wDlgData[];

};

//*****************************************************************************
//*
//*		CHexCrcCalcDlg
//*
//*****************************************************************************
class CHexCrcCalcDlg : public CDialog
{
public:

	typedef	unsigned __int64	CrcType;
	typedef	const BYTE		   *MemPtr; 
	typedef struct
		{
		LPCTSTR		pName;
		unsigned 	uSize;
		CrcType		uPolynom;
		}CrcDefine;

	CHexCrcCalcDlg(CWnd* pParent = NULL);						// Standardkonstruktor
	INT_PTR DoModal(MemPtr pMem,int iLen);
	

	//{{AFX_DATA(CHexCrcCalcDlg)
	BOOL			m_bInvert;
	int				m_iSourceSel;
	int				m_iTypeSelect;
	CString 		m_sPolynomSize;
	CString 		m_sPolynomValueN;
	CString 		m_sPolynomValueI;
	CString 		m_sStartValue;
	CString 		m_sFormular;
	//}}AFX_DATA	
					
	BOOL			m_bPolynomValid;							// Die Werte beim Start bernehmen
	CrcType 		m_uPolynomValueI;							// Polynombits (1+x+x+x...)
	CrcType 		m_uPolynomValueN;							// Polynombits (...x+x+x+1)
	CrcType 		m_uPolynomMask;								// Polynombits
	CrcType 		m_uStartValue;								// Startwert fr die Berechnung
	UINT			m_uPolynomSize;								// Gre des Polynoms in Bit
	INT				m_uMemSize;									// Gre des Spichers fr die Berechnung
	MemPtr  		m_pMemory;									// Spichers fr die Berechnung
	CrcType 		m_uResultA;									// CRC-Ergebnis 
	CrcType 		m_uResultA0;								// CRC-Ergebnis fr  0 
	CrcType 		m_uResultA1;								// CRC-Ergebnis fr ~0
	CrcType 		m_uResultB;									// CRC-Ergebnis 
	CrcType 		m_uResultB0;								// CRC-Ergebnis fr  0 
	CrcType 		m_uResultB1;								// CRC-Ergebnis fr ~0
	CrcType 		m_uResultC;									// CRC-Ergebnis 
	CrcType 		m_uResultC0;								// CRC-Ergebnis fr  0 
	CrcType 		m_uResultC1;								// CRC-Ergebnis fr ~0
	CrcType 		m_aTableA[256];								// CRC Berechnungstabellen
	CrcType 		m_aTableB[256];								//		*
	CrcType 		m_aTableC[256];								//		*

	CrcType CrcCalcA(CrcType uCrc,const void *pMem,int iLen,CrcType *pTable);
	CrcType CrcCalcB(CrcType uCrc,const void *pMem,int iLen,CrcType *pTable);
	CrcType CrcCalcC(CrcType uCrc,const void *pMem,int iLen,CrcType *pTable);
	void	CrcGenerateTableA(CrcType uPolynm,CrcType *pTable);
	void	CrcGenerateTableB(CrcType uPolynm,CrcType *pTable);
	void	CrcGenerateTableC(CrcType uPolynm,CrcType *pTable,unsigned uSize);


	//{{AFX_VIRTUAL(CHexCrcCalcDlg)
protected:
	virtual void 	DoDataExchange(CDataExchange* pDX);			// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	void	Update(int iMode);	

	//{{AFX_MSG(CHexCrcCalcDlg)
	afx_msg HBRUSH 	OnCtlColor(CDC *pDC,CWnd* pWnd,UINT nCtlColor);
	virtual BOOL 	OnInitDialog();
	virtual void 	OnCancel();
	virtual void 	OnOK();
	afx_msg void 	OnInvert();
	afx_msg void 	OnKillFocus();
	afx_msg void 	OnChangeEdit();
	afx_msg void 	OnChangeType();
	afx_msg void 	OnChangeSize();
	afx_msg void 	OnChangePolyA();
	afx_msg void 	OnChangePolyB();
	afx_msg void 	OnChangeStart();
	afx_msg void 	OnSourceChange();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	static int 			m_iScreenX,m_iScreenY,m_iScreenOn;		// Alte Dialogposition
	static WORD			m_wDlgData[];
	static CrcDefine	m_sDefines[];

	BOOL			m_bSourceOn;
	BOOL			m_bLastPolyOk;
	BOOL			m_bLastStartOk;
	BOOL			m_bFormularErr;
	CString 		m_sLastPolynomValue;
	CString 		m_sLastStartValue;
	CrcType 		m_uLastPolynom;
	UINT			m_uLastSize;

};

//{{AFX_INSERT_LOCATION}}
#endif
