//*****************************************************************************
//*
//*
//*		TextBase.h
//*
//*
//*****************************************************************************
/*
	Makros:

		USE_RC						: Dialoge aus den Resourcen laden
		USE_UTF8					: Texte werden intern als UTF8 gespeichert
		USE_DICIONARY				: Wrterbuch fr Rechtschreibfehler
		USE_WORD_HIGHLIGHT			: Gesuchte Wrter hervorheben
		USE_MARK_HIGHLIGHT			: Ausgewhlte Wrter hervorheben
		USE_VIRTUAL_LINES			: Textbereiche knnen eingeklappt werden
		USE_TEXT_DRAGDROP			: Drag&Drop fr Texte (auf 1 setzen)
		TO_TEXTWND					: Die CWnd statt CView Version erstellen
		TEXT_ICONS					: ID von der Bitmap mit Icons vom Kontextmen

	
	Berschreibung der Registry Formate:


[HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Editor\Text]

	"_XXX"="YYY"					// Ld Unterschlssel "\YYY" fr *.XXX Dateien

[HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Editor\Text\YYY]

	"FileType"						// Nemder fr den Dateityp
	"Color"     =dword:0			// Nur eine fixe Farbe fr den ganzen Text
	"ColorArray"=hex:01,...			// Alle Zeilen haben die gleichen Farben in jeder Spalte.
									// Die Farbnummern der Spalten sind hier gespeichert

	"UpperLower"="S"			// Gro/Kleinschreibung einschalten ('' zu ''...)
	"Letters"   ="S"			// Zeichen die Buchstaben sind (Gruppe 0x02)
	"Separators"=";,"				// Zustzliche Trennzeichen    (Gruppe 0x04)
	"Numbers"   ="0123456789"		// fr Ziffern (Gruppe 0x01)
	"Group1"    =""					// fr (Gruppe 0x08)
	"Group2"    =""					// fr (Gruppe 0x10)
	"Group3"    =""					// fr (Gruppe 0x20)
	"Group4"    =""					// fr (Gruppe 0x40)
	"Group5"    =""					// fr (Gruppe 0x80)
	"BracketOn" =dword:0			// Klammersuche einschalten,
									//		Bits  0- 7 = Farbindex
									//		Bits  8-15 = Farbindex fr Klammerbereich
									//		0x80000000  fr '()'
									//		0x40000000  fr '[]'
									//		0x20000000  fr '{}'
									//		0x10000000  fr '<>'
	"BracketOff"=dword:0			//		Bits  0- 7 = 1. Farbindex der keine Klammern enthlt
									//		Bits  8-15 = 2. Farbindex der keine Klammern enthlt
									//		Bits 16-23 = 3. Farbindex der keine Klammern enthlt
									//		Bits 24-31 = 4. Farbindex der keine Klammern enthlt

	"Group?On"    =""				// Zeichen bei dehnen eine Gruppe eingeschaltet ('\r' fr Zeilenende)
	"Group?Off"   =""				// Zeichen bei dehnen eine Gruppe ausgeschaltet	('\r' fr Zeilenende)
	"Group?Color" =dword:1			// Farbe wenn eine Gruppe eingeschalten ist
	"Groups"      =dword:8			// Eingeschalten Gruppen die bei Zeilenende weiter gehen
	"GroupContinue"		    		// Eingeschalten Gruppen die bei speziellen Zeichen am Zeilenende weitergehen
	"GroupChar"			    		// Zeichen fr Zeilenende

	"DicColors"=hex:03,84,			// Fr einzelne Farbbereiche fr 2das Wrterbuch
									// ein/ausschalten (Bit7==1 : ausschalten )
									// z.B.   03 = Fr Farbe 3 einschalten
									//		  84 = Fr Farbe 4 ausschalten
									//		  FF = Alle ausschalten
									//		  7F = Alle einschalten

	"DicOnOff"=dword:01				// 1=Wrterbuch immer einschalten
									// 2=Wrterbuch immer ausschalten

[HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Editor\Text\YYY\Words\ZZZ]

									// ZZZ ist ein beliebiger Schlssel

	"Mode"=hex:04,04,01,00...		// Byte1 = Gruppe zu der das Zeichen vor dem Wort (eine)
									//         gehren muss, bei 0 keine Prfung
									// Byte2 = Gruppe zu der das Zeichen nach dem Wort
									//         gehren muss, bei 0 keine Prfung
									// Byte3 = Das Wort geht weiter sollange die
									//         Zeichen zur Gruppe gehren
									// Byte4 = Gruppe zu der das Zeichen vor dem Wort
	    							//         nicht gehren darf bei 0 keine Prfung
									// Byte5 = Gruppe einschalten
	    							// Byte6 = Gruppe ausschalten
									// Byte7 = Gruppen die eingeschalten sein mssen (alle)
									//         gehren muss, bei 0 keine Prfung
	"Color"=dword:3					// Indexnummer fr Farbe
									//		   wenn die Bit 11-15 gesetzt sind
									//         so wird durch das Wort auch die
									//         Gruppen 1-5 aktiviert
	"XXX"="Wort"					// Liste mit Wrten "XXX"= beliebiger Name

[HKEY_LOCAL_MACHINE\SOFTWARE\AZ_Editor\CTextView\YYY\Fixed\ZZZ]

									// ZZZ ist ein beliebiger Schlssel

	"Letters" ="()"					// Zeichen mit fixen Farben
	"Color"   =dword:3				// Indexnummer fr Farbe


[HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Editor\Text\YYY\Until\ZZZ]

									// ZZZ ist ein beliebiger Schlssel

	"Mode1"=hex:00,00,00... 		// Art fr das 1.Wort
									// Byte1 = Gruppe zu der das Zeichen vorm Anfangsw.
									//         gehren muss, bei 0 keine Prfung
									// Byte2 = Gruppe zu der das Zeichen nach dem Anf.
									//         gehren muss, bei 0 keine Prfung
									// Byte3 = Bei Zeilenende aufhren     ==0
									//         Bei Zeilenende weitermachen ==1
									//		   Bei Zeichen weitermachen	    >1
									// Byte4 = Gruppe zu der das Zeichen vor dem Wort
	    							//         nicht gehren darf bei 0 keine Prfung
									// Byte5 = Gruppe einschalten
	    							// Byte6 = Gruppe ausschalten
									// Byte7 = Gruppen die eingeschalten sein mssen (alle)
									//         gehren muss, bei 0 keine Prfung

	"Mode2"=hex:00,00,00... 		// Art fr das 2.Wort
									// Byte1 = Gruppe zu der das Zeichen vorm Anfangsw.
									//         gehren muss, bei 0 keine Prfung
									// Byte2 = Gruppe zu der das Zeichen nach dem Anf.
									//         gehren muss, bei 0 keine Prfung
									// Byte3 = Gruppe fr jump Zeichen dabei wird das
									//         nchste Zeichen nicht berprft
									// Byte4 = Gruppe zu der das Zeichen vor dem Wort
	    							//         nicht gehren darf bei 0 keine Prfung
									// Byte5 = Gruppe einschalten
	    							// Byte6 = Gruppe ausschalten
									// Byte7 = Gruppen die eingeschalten sein mssen (alle)
									//         gehren muss, bei 0 keine Prfung
	"Color"=dword:3					// Indexnummer fr Farbe
	"Data1"="BEGIN"					// Anfangswort
	"Data2"="END"					// Endwort

[HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Editor\Text\YYY\Accel]

	"Name"="A:Text"					// Der Taste 'A'+Ctrl
									// einen Text zuortnen
	"Name"="C:Text"					// Der Taste 'C'+Ctrl
									// einen Text zuortnen

[HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Editor\Text\Colors\INDEX_NR]

									// INDEX_NR ist die Nummer der Farbe

	"HG"=dword:00FFFFFF				// Hintergrund Farbe
	"VG"=dword:00FF0000				// Vordergrund Farbe
	"Name"="Name"					// Namen der   Farbe
	"Schriftart"=dword:0133			// Schriftart fr Font
									// -1 oder kein Eintrag = Standartschrift verwenden
									// Bit 0  = Fett
									// Bit 1  = Kursif
									// Bit 2  = Unterstrichen
									// Bit 4  = Fett		  (fr's Drucken)
									// Bit 5  = Kursif        (fr's Drucken)
									// Bit 6  = Unterstrichen (fr's Drucken)
									// Bit 8  = Eine eigene Art fr's Drucken ist vorhanden (Bit 4-7)

//**************** Berschreibung der Formate fr Farben ************************

m_aCharType							// Art fr die einzelnen Buchstaben

		Bit 0 :						// Ziffern (0..9)
		Bit 1 :						// Buchstaben
		Bit 2 :						// Trenzeichen (' ','\t','\n')
		Bit 3-7:					// Gruppe 1 bis 5 zur freien Belegung

m_pWordList

		Byte[0] :					// Fr 1.Zeichen vor Wort muss zur Gruppe gehren
									// 0 = nicht prfen
									// sonst muss es das eines der gewhlten sein
		Byte[1] :					// Fr 1.Zeichen nach Wort
									// 0 = nicht prfen
									// sonst muss es das eines der gewhlten sein
		Byte[2] :					// *Bei Worten werden alle folgenden Zeichen die diese
									//  Art haben in der gleichen Farbe gezeichnet
									// *Bei einem Bis-Wort (siehe Byte[5]) ist es die
									//  Nummer des 2. Wortes
									// *Beim 2.Wort eines Bis-Wortes ist es die Art eines
									//  Jump-Zeichen bei denen das nchste Zeichen von der
									//  berprfung aus geschlossen wird.
       	Byte[3] :					// Fr 1.Zeichen vor Wort darf nicht zur Gruppe gehren
									// 0 = nicht prfen
									// sonst muss es das eines der gewhlten sein
		Byte[4] :					// Maskenbits fr Grruppen die eingeschalten werden
		Byte[5] :					// Maskenbits fr Grruppen die ausgeschalten werden
		Byte[6] :					// Nummer der Farbe
		Byte[7] :					// Art des Wortes
									// 1 = Wrter
									// 2 = Fixbuchstaben
									// 3 = Bis Wrter
									// 4 = Bis Wrter ohne Zeilende-Abbruch
		Byte[8] :					// Anzahl der Buchstaben im Wort (x)
		Byte[9...]:					// Wort , Bei Gro/Kleinschreibung mssen alle
									// Buchstaben gro sein !
		Byte[9 +x]:					// Null

******************************************************************************/

#include    "TextMessage.h"
#include	<AfxMt.h>
#include	<AfxOle.h>
#include	<AfxCmn.h>
#include	<AfxMacros.h>


#ifdef 		USE_DICIONARY
#include	"DicLib.h"
#endif

#ifdef		TO_TEXTWND
	#define	CTextView	CTextWnd
	#define	CAnsiView	CAnsiWnd
	#define CView		CWnd
#else
	#ifdef	CTextView
	#undef 	CTextView
	#endif
	#ifdef	CAnsiView
	#undef 	CAnsiView
	#endif
	#ifdef	CView
	#undef 	CView
	#endif
#endif

//*****************************************************************************

#ifndef		USE_TEXT_DRAGDROP
#define 	USE_TEXT_DRAGDROP		1						// Ist Drag&Drop frei gegeben
#endif

#ifndef		TEXT_DEFINE
#define		TEXT_DEFINE

#define		TEXT_FIND_MAX			16						// Maximale Auswahl frs Suchen
#define		TEXT_LINES_ADD			512						// Zeilen zum Anhngen
#define		TEXT_CHARS_MAX			2048					// Maximale Zeilenbreite
#define		TEXT_MAX_LINES			50000					// Standartwert fr maximale Zeilenanzahl
#define 	TEXT_EXPAND			   -12345					// Einen Bereich wieder aufklappen

#define		LINE_HEADER				offsetof(TextLine,aText)// Position der Textdaten in den Zeilendaten
#define		TEXT_UNDO_MAX			128						// Maximale Undo-Zahl
															// iFlags fr Rechschreibprfung
#define 	FLAG_DICON			 	0x00008000				// Rechschreibprfung einschalten

// Flags fr den Konstruktor

#define		FLAG_DONT_CHANGE	 	0x00000001				// Text in darf nicht gendert werden
#define		FLAG_DONT_HIGHLIGHT		0x00000002				// Kein Highlight von Worten
#define 	FLAG_DONT_MARKWORDS		0x00000004				// Kein Markieren von ausgewhlten Wrtern

// Konstanten fr Text_Funktionen

#define		TEXT_LINE           	0x00000001				// Zeilenweise einfgen
#define		TEXT_CURSOR_LEFT   		0x00000002				// Cursor an den Anfang setzen
#define		TEXT_CURSOR_RIGHT   	0x00000004				// Cursor ans Ende setzen
#define		TEXT_REDRAW   			0x00000008				// Fenster nachher neuzeichen
#define		TEXT_WORD       		0x00000010				// Wortweise kopieren
#define		TEXT_CURSOR     		0x00000020				// iPosX/iPosY durch Cursor ersetzen
#define		TEXT_SELECTION		   	0x00000040				// iEndX/iEndY durch Marke ersetzen
#define		TEXT_UNDO       		0x00000080				// Undo-Koordinaten speichern
#define 	TEXT_UNDOADD			0x00000100				// UnduAdd() aufrufen
#define 	TEXT_UNDOTWOTURNS		0x00000200				// Zweimal rckgngig
#define 	TEXT_IS_UTF8			0x00000400				// Der Text ist im UTF8-Format
#define 	TEXT_IS_UTF16			0x00000800				// Der Text ist im UTF16-Format
#define 	TEXT_NOCASE				0x00001000				// Keine Gro-Klein-Unterscheidung
#define 	TEXT_HAS_LENGTH			0x00002000				// Die oberen 8-Bit sind die Lnge

// Konstanten fr SetHookProc

#define 	HOOK_CHANGE_LINE	 	0x00000001				// Wenn Zeilen verndert werden
#define 	HOOK_INSERT_LINE	 	0x00000002				// Wenn Zeilen einfgen wurden
#define 	HOOK_DELETE_LINE	 	0x00000003				// Wenn Zeilen gelscht werden
#define 	HOOK_MOVE_CURSOR	 	0x00000004				// Wenn der Cursorbewegt wurde
#define 	HOOK_RAND_TEXT		 	0x00000005				// Ausgeben des Randtexte
#define 	HOOK_STATUSBAR_TEXT	 	0x00000006				// Ausgeben des Statusbartextes
#define 	HOOK_CHANGE_TEXT	 	0x00000007				// Bevor ein Text verndert wird
#define 	HOOK_CONTEXT_MENU		0x00000008				// Bevor das Kontextmen eingeblendet wird

// Konstanten fr Notify Nachrichten

#define 	TXT_KILLFOCUS			0x00002CF7				// Nachricht bei Verlust des Focus
#define 	TXT_SETFOCUS			0x00002CF8				// Nachricht bei Erhalt des Focus
#define 	TXT_TABLOOP				0x00002CF9				// Nachricht bei TAB-Sprngen aus dem Fenster

#endif

#ifdef		USE_VIRTUAL_LINES
#if			TEXT_MAX_LINES<65535
#define 	UJUMP					WORD					// Virtuelle Zeilen haben 2-Byte-Sprnge
#else
#define 	UJUMP					DWORD					// Virtuelle Zeilen haben 4-Byte-Sprnge
#endif
#endif


#ifndef 	__TXT_NMHDR__
#define 	__TXT_NMHDR__

typedef struct
	{
	NMHDR	sHdr;											// Notify Daten
	int		iParam1;
	int		iParam2;
	int		iParam3;
	}TXT_NMHDR,*LPTXT_NMHDR;

#endif


#if			USE_TEXT_DRAGDROP
#ifdef		TO_TEXTWND
			DECLARE_DROP_FUNC_MAIN(CTextWnd)
#else
			DECLARE_DROP_FUNC_MAIN(CTextView)
#endif
#endif


//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************
class CTextView : public CAnsiView
{
#ifndef	TO_TEXTWND
DECLARE_DYNCREATE(CTextView)
#endif

public:

typedef	unsigned int	uint;								// Standardtypen
typedef	unsigned char	uchar;

typedef struct
		{
		DWORD 			dwData;								// 4 Byte-Speicher
		#ifdef USE_VIRTUAL_LINES
		UJUMP			uPrev;								// Abstand zur vorherigen sichtbaren Zeile (falls Teile zugeklappt sind)
		UJUMP			uNext;								// Abstand zur nchsten   sichtbaren Zeile (falls Teile zugeklappt sind)
		#endif
		WORD			uSize;								// Lnge des Textes in der Zeile in Byte (nicht aufgerundet)
		WORD			uStart;								// Startposition der Worte in Spalten (/t==m_iTabWidth)
		WORD			uEnd;								// Ende des Textes		   in Spalten (/t==m_iTabWidth)
		BYTE			bGroup;								// Welche Gruppen sind aktiv am Zeilenende
		BYTE			bColor;								// Farbe welche aktiv ist am Zeilenende
		BYTE		   *pColors;							// Speicher fr Farben (Lnge immer auf 16 aufrunden)
		unsigned char	aText[TEXT_CHARS_MAX];				// Textspeicher
		}TextLine,*TextLinePtr;

typedef struct
		{
		char 			cMode;								// Art des Undos UNDO_DEL
		char			cChanged;							// Alter Textzustand
		CPoint 			sPoint;								// Position der Undo-Operation
		CPoint 			sDelPt;								// Position fr das Lschen
		unsigned 		uNewChar;							// Neues Zeichen
		unsigned 		uOldChar;							// Altes Zeichen
		uchar		   *pData;								// Speicher fr das Einfgen
		}UndoBlock;

		int				m_iUndoPos;							// Aktuelle Undo-Position
		int				m_iUndoMax;							// Maximale Undo-Position
		int				m_iUndoMin;							// Minimale Undo-Position
		UndoBlock		m_aUndo[TEXT_UNDO_MAX];				// Undo-Speicher

protected:


DECLARE_MESSAGE_MAP()

#ifdef	USE_DICIONARY
static	HDIC			m_hDicGlobal;						// Wrterbuch
static	HDIC			m_hDicLocal;						// Pershnlichse Wrterbuch
static	char			m_cDicNameG[64];					// Name des geladenen globalen Wrterbuches
static	char			m_cDicNameL[64];					// Name des geladenen pers.    Wrterbuches
static	int				m_iDicFlags;						// iFlags fr die Rechtschreibprfung
		int				m_iDicContextX1;					// Position der letzten Kontextmenauswahl
		int				m_iDicContextX2;					//			*
#endif

private:

static	char			m_aAccelTab1[];						// Krzelumwandlung
static	char			m_aAccelTab2[];						// Krzelumwandlung
static	int				m_iTabWidth;						// Breite der Tab's
static	int				m_iWindowCount;						// Anzahl der Fenster insgesamt

		uchar		   *m_pNullLine;						// Temporre Zeile fr interen Gebrauch
		uchar		   *m_pColumColors;						// Gleiche Farben in jeder Zeile
		TextLinePtr    *m_pLineList;						// Zeigerfeld auf Zeilen Adressen
		int				m_iLineListSize;					// Anzahl der Zeilen in **m_pLineList
		int     		m_iColorMode;						// Farbmodus -1=Variabel 0>=Startfarbe
		int				m_iMaxChars;						// Maximale Byteanzahl in Zeile
		int				m_iMarkX;							// Markierungsposition
		int				m_iMarkY;							//			*
		int				m_iMarkOn;							// Ist etwas markiert (0nein 1=einzeilig 2=mehrzeilig)
		int				m_iWordPosX;						// Wort-Position fr rechten Mausklick
		int				m_iWordPosY;						//			*
		int     		m_iCursorLastX;						// Letzte  X-Position des Cursors
		int				m_iStatusbarCode;					// Zustand der Statusbar
		int				m_iUntilColors;						// Position der bis Farben
		int				m_iTextMargin;						// Ist die Breite des linken Feldbereiches (wenn er eingeblendet ist)
		unsigned		m_uLastDblClick;					// Wann gab es den letzten Doppelklick
		int				m_iLastDblClickX;					// Koordinaten des letzten Doppelklicks
		int				m_iLastDblClickY;					//			*
		CPoint			m_sLastClickPt;						// Koordinaten des letzten Klicks
		int				m_iLastClickX;						//			*
		int				m_iLastClickY;						//			*
		int				m_iLastClick;						// Gab es einen Klick fr Drag
		char 			m_cHasTabLoop;						// Werden Tab-Sprnge aus dem Fenster gemeldet
		char 			m_cUndoLocked;						// Zeichen kommt von undo
		char 			m_cStatusbarInit;					// Statusbar eingeschalten

		char 			m_cAreaMode;						// Ist 1 wenn cursor>marke
		int				m_iAreaStartX;						// ndern Bereich
		int				m_iAreaStopX;						//		*
		int				m_iAreaStartY;						//		*
		int				m_iAreaStopY;						//		*

		uchar   		m_uGroupChar;						// Zeichen fr Zeilenenden bei denen Gruppen weitergehen
		uchar			m_uCaseMode;						// Gro/Kleinschreibung ignorieren
		int				m_iGroupLines;						// Gruppen die bei Zeilenenden mit Zeichen weitergehen
		uchar   		m_aCaseTable[256];					// Gro/Kleinumwandlung
		uchar   		m_aGroupOn  [256];					// Gruppe ein ausschalten
		uchar   		m_aGroupOff [256];					// Gruppe ein ausschalten
		uchar   		m_aCharType [256];					// Art der Buchstaben
		uchar   		m_aFixColors[256];					// Zeichen mit Fixfarben
		#ifdef 	USE_DICIONARY
		uchar   		m_aDicColors[128];					// Fr welche Farben ist das Wrterbuch an
		#endif
		WORD    		m_aWordStart[256];					// Erste Nummer fr Wort des Zeichens
		WORD    	 	m_aWordNum  [256];					// Anzahl der Worte fr Buchstaben
		uchar		  **m_pWordList;						// Speicher fr Wrter mit Farben
		int				m_iWordCount;						// Anzahl der gespeicherten Worte
		int				m_iGroupUntil;						// Gruppen die weiter gehen
		int				m_iGroupColorsOn;					// Gibt es Gruppen Farben
		int				m_aGroupColors[5];					// Gruppen Farben
		char    		m_cConfigName[16];					// Namen der aktuellen Konfiguration
		char			m_cColorList [32];					// Welche Farben werden benutzt

		uchar		   *m_pChangeText;						// ndern Text
		uchar		   *m_pFindText;						// Suchen Text
		char		   *m_pFindSelection;					// Suchen Auswahl
		uchar		   *m_pCopyMem[10];						// Kopierspeicher
		int  		    m_aCopyLen[10];						// Kopierspeicher Lngen

		int				m_iKeyStepMask;						// Maske fr die Wortsprnge mit Cltr+Right/Left

		char		   *m_aAccelNamen['Z'-'0'+13];			// Accel Namen
		CTextChangeDlg *m_sChngeDlg;						// ndern Dialog
		CTextFindDlg   *m_sFindDlg;							// Suchen Dialog
		#ifdef USE_UTF8
		int				m_iCmpDiff;							// Ausugleichslnge fr zweiten bei CMP-Funktionen
		#endif

		char		   *m_pBracketMode;						// Art fr Klammern "([{<\x00)]}>"
		int				m_iBracketColor;					// Farbe fr Klammer
		int				m_iBracketColorEx;					// Farbe fr Klammerbereich
		int				m_iBracketX;						// Klammerposition
		int				m_iBracketY;						//			*
		int				m_iBracketArea;						// Den ganzen Klammerbereich markieren
		uint			m_uBracketOff;						// Farben fr Klammern die ausgelassen werden
		char 			m_cBracketOn;						// Ist Klammer sichtbar

		char 			m_cIgnorChar;						// Das nchste CHAR Zeichen ignorieren
		char 			m_cNotChange;						// Darf Text gendert werden
		char 			m_cChanged;							// Wurde Text gendert
		uchar			m_ucHasDrop;						// Ist ein Einggen mittels Drop erlaubt
		uchar			m_ucHasDrag;						// Ist ein Whlen des Texte muittels Drag erlaubt
		uchar			m_ucDoDrag;							// Wird gerade ein Drag ausgefhrt

		#ifdef USE_MARK_HIGHLIGHT
		uchar			m_ucWordMarkTicker;					// Das Markieren verzgert auslsen
		uchar			m_ucWordMarkAnd;					// Und-Maske des hervorgehoben Wortes (~0x00 oder ~0x20)
		uchar			m_ucWordMarkChar;					// Erstes Zeichen des hervorgehoben Wortes
		uchar			m_ucWordMarkSize;					// Lnge des hervorgehoben Wortes
		uchar			m_ucWordMarkMode;					// Nur ganze Wrter markieren (0=nein 1=ja 255=gesperrt)
		uchar			m_ucWordMarkWord[64];				// Ganzes Wort das hervorgehoben werden soll
		#endif

		#ifdef USE_WORD_HIGHLIGHT
		uchar			m_ucHighlightAnd;					// Und-Maske des hervorgehoben Wortes (~0x00 oder ~0x20)
		uchar			m_ucHighlightChar;					// Erstes Zeichen des hervorgehoben Wortes
		uchar			m_ucHighlightSize;					// Lnge des hervorgehoben Wortes
		uchar			m_ucHighlightMode;					// Nur ganze Wrter markieren (0=nein 1=ja 255=gesperrt)
		uchar			m_ucHighlightWord[64];				// Ganzes Wort das hervorgehoben werden soll
		#endif


protected:

static	TextLine		m_sNullLine;						// Zeile ohne Eintrag
static	int				m_iFlags;							// Flags frs Textfenster
		int				m_iLinesMax;						// Maximale Zeilenanzahl
		int				m_iVirtualLines;					// Virtuelle Zeilenanzeige ein

		void  (__cdecl *m_pHookChangeLine   )(CTextView*,void*,int);
		void           *m_pHookChangeLineParam;
		void  (__cdecl *m_pHookInsertLine   )(CTextView*,void*,int);
		void           *m_pHookInsertLineParam;
		void  (__cdecl *m_pHookDeleteLine   )(CTextView*,void*,int);
		void           *m_pHookDeleteLineParam;
		int   (__cdecl *m_pHookMarginText   )(CTextView*,void*,int,char*,int,HICON*);
		void           *m_pHookMarginTextParam;
		int   (__cdecl *m_pHookMoveCursor   )(CTextView*,void*,int,int);
		void           *m_pHookMoveCursorParam;
		int   (__cdecl *m_pHookStatusbarText)(CTextView*,void*,int,int,int,char *);
		void           *m_pHookStatusbarTextParam;
		int   (__cdecl *m_pHookChangeText   )(CTextView*,void*,int,int,int);
		void           *m_pHookChangeTextParam;
		int   (__cdecl *m_pHookContextMenu  )(CTextView*,void*,CMenu*,int,int,const char *);
		void           *m_pHookContextMenuParam;



//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

public:

	CTextView(int iCharsMax=TEXT_CHARS_MAX,int iLinesMax=TEXT_MAX_LINES,int iMode=0,char *pGroup="Text");
   ~CTextView();

			int		ConfigAccel		(const char   *pPath=0);
			int	 	ConfigText    	(const char   *pPath=0);
			int	 	ConfigText    	(int           iColor );
			int	 	ConfigText    	(unsigned char*pColors,int iLen,int iDefault=0);
			int	 	ConfigLoad	   	(const char   *pPath=0);
			int	 	ConfigSave	   	(const char   *pPath=0);
			int	 	ConfigView	   	();
			char*	GetConfigName 	();
	virtual	int  	ColorView     	();
			int	 	FindView	   	(const char    *pText=0,int iMode=0);
			int	 	Find          	(const char    *pText=0,int iMode=0);
			int  	FindWord      	();
			int	 	FindNext      	();
			int	 	ReplaceView   	(const  char   *pText=0,const char *pChange=0,int iMode=0);
			int	 	Replace       	(const  char   *pText=0,const char *pChange=0,int iMode=0);
			int  	TextInsert     	(const wchar_t *pText                    ,int iMode=0);
			int  	TextInsert     	(const uchar   *pText                    ,int iMode=0);
			int  	TextInsert     	(const  char   *pText                    ,int iMode=0);
			int  	TextInsert    	(const wchar_t *pText,int iPosX,int iPosY,int iMode=0);
			int  	TextInsert    	(const uchar   *pText,int iPosX,int iPosY,int iMode=0);
			int  	TextInsert    	(const  char   *pText,int iPosX,int iPosY,int iMode=0);
			int  	TextInsert    	(const wchar_t *pText,int iPosX,int iPosY,int iMode,int iSize);
			int  	TextInsert    	(const uchar   *pText,int iPosX,int iPosY,int iMode,int iSize);
			int  	TextInsert    	(const  char   *pText,int iPosX,int iPosY,int iMode,int iSize);
			int  	TextExchange  	(const wchar_t *pText,          int iPosY,int iMode=0);
			int  	TextExchange  	(const uchar   *pText,          int iPosY,int iMode=0);
			int  	TextExchange  	(const  char   *pText,          int iPosY,int iMode=0);
			int  	TextExchange  	(const wchar_t *pText,          int iPosY,int iSize                  ,int iMode);
			int  	TextExchange  	(const uchar   *pText,          int iPosY,int iSize                  ,int iMode);
			int  	TextExchange  	(const  char   *pText,          int iPosY,int iSize                  ,int iMode);
			int  	TextClear     	(                   int iPosX,int iPosY,int iEndX,int iEndY          ,int iMode=0);
			int  	TextCopy      	(  wchar_t **pText, int iPosX,int iPosY,int iEndX,int iEndY          ,int iMode=0);
			int  	TextCopy      	(  uchar   **pText, int iPosX,int iPosY,int iEndX,int iEndY          ,int iMode=0);
			int  	TextCopy      	(   char   **pText, int iPosX,int iPosY,int iEndX,int iEndY          ,int iMode=0);
			int  	TextCopy      	(  wchar_t  *pText, int iMax, int iPosX,int iPosY,int iEndX,int iEndY,int iMode=0);
			int  	TextCopy      	(  uchar    *pText, int iMax, int iPosX,int iPosY,int iEndX,int iEndY,int iMode=0);
			int  	TextCopy      	(   char    *pText, int iMax, int iPosX,int iPosY,int iEndX,int iEndY,int iMode=0);
			int  	TextCopy      	(  wchar_t  *pText, int iMax                                         ,int iMode=TEXT_CURSOR|TEXT_SELECTION);
			int  	TextCopy      	(  uchar    *pText, int iMax                                         ,int iMode=TEXT_CURSOR|TEXT_SELECTION);
			int  	TextCopy      	(	char    *pText, int iMax                                         ,int iMode=TEXT_CURSOR|TEXT_SELECTION);
			int  	TextCopy      	(  wchar_t **pText                                                   ,int iMode=TEXT_CURSOR|TEXT_SELECTION);
			int  	TextCopy      	(  uchar   **pText                                                   ,int iMode=TEXT_CURSOR|TEXT_SELECTION);
			int  	TextCopy      	(   char   **pText                                                   ,int iMode=TEXT_CURSOR|TEXT_SELECTION);
			int	 	TextData      	(int  iLine,int iMode=0,int iData=0);
			int	 	TextNew	   		();
			int  	WordCopy      	(wchar_t **pText         ,int iMode=0);
			int  	WordCopy      	(  uchar **pText         ,int iMode=0);
			int  	WordCopy      	(   char **pText         ,int iMode=0);
			int  	WordCopy      	(wchar_t  *pText,int iMax,int iMode=0);
			int  	WordCopy      	(  uchar  *pText,int iMax,int iMode=0);
			int  	WordCopy      	(   char  *pText,int iMax,int iMode=0);
				 	
			int  	ColorCopy     	(wchar_t **pText,uchar **pColors,int iPosY,int iEndX1=0,int iEndX2=-1,int iMode=1);
			int  	ColorCopy     	(wchar_t **pText, char **pColors,int iPosY,int iEndX1=0,int iEndX2=-1,int iMode=1);
			int  	ColorCopy     	(  uchar **pText,uchar **pColors,int iPosY,int iEndX1=0,int iEndX2=-1,int iMode=1);
			int  	ColorCopy     	(  uchar **pText, char **pColors,int iPosY,int iEndX1=0,int iEndX2=-1,int iMode=1);
			int  	ColorCopy     	(   char **pText,uchar **pColors,int iPosY,int iEndX1=0,int iEndX2=-1,int iMode=1);
			int  	ColorCopy     	(   char **pText, char **pColors,int iPosY,int iEndX1=0,int iEndX2=-1,int iMode=1);
				 	
			int  	ConvertCursorToPos(int iLine,int iPos);
			int  	ConvertPosToCursor(int iLine,int iCursor);
			int  	SetTextMargin 	(int iWidth);
			int	 	GetTextMargin 	();
			int  	GetLineCount  	();
			int  	GetTabSize    	();
			char*	GetLineText   	(            unsigned uLine,int *pLen=0);
static char* _cdecl	GetLineText		(void *pThis,unsigned uLine,int *pLen=0);
			int	 	GetColorPos   	(int iPosX,int iPosY);
			int  	SetTabSize    	(int iWidth);
			int	 	SetRange	   	();
			int	 	SetRange	   	(int     iPosX,int     iPosY,int  iEndX,int  iEndY);
			void 	GetRange	   	(int    &iPosX,int    &iPosY,int &iEndX,int &iEndY);
			void 	GetRange	   	(CPoint &sPos ,CPoint &sEnd);
		    int  	CheckRange    	(int     iPosX,int     iPosY);
			int  	CheckRange    	(CPoint  sPos);
			BOOL 	GetCanModify  	();				// Abfragen   ob der Text gendert werden darf
			BOOL 	SetCanModify  	(BOOL bNew=1);	// Einstellen ob der Text gendert werden darf
			BOOL 	GetModify     	();				// Abfragen   ob der Text gendert wurde
			BOOL 	SetModify     	(BOOL bNew=1);	// Einstellen ob der Text gendert wurde
			BOOL 	IsSelectedX   	();				// Ist eine  einzeilige Marke vorhanden
			BOOL 	IsSelectedY   	();				// Ist eine mehrzeilige Marke vorhanden
			int  	IsSelected    	();				// Ist etwas Markiert (0=nichts 1=einzeilig 2=zweizeilig)
			int  	IsSelected    	(int iPosX,int iPosY			);	// Ist ein Zeichen markiert (0=nichts 1=einzeilig 2=zweizeilig)
			int  	IsWord			(int iPosX,int iPosY,int iCopy=0);	// Ist auf der Position ein Wort
			int  	InsertEx      	(int iNr);
			int	 	PrintColor    	(int iLine);
			int	 	BeginDrag	    ();

			#ifdef	USE_WORD_HIGHLIGHT
			int	 	WordHighlight	(const uchar *pText,int iMode=0);
			int	 	WordHighlight	(const  char *pWord,int iMode=0);
			#endif
			#ifdef 	USE_MARK_HIGHLIGHT
			int	 	MarkHighlight	(const uchar *pText,int iMode=0);
			int	 	MarkHighlight	(const  char *pWord,int iMode=0);
			#endif

			#ifdef	USE_VIRTUAL_LINES
			int	 	ExpandCheck		(uint uLine);
			int	 	Expand			(uint uLine,int iCount=TEXT_EXPAND);
			#else
	inline	int	 	ExpandCheck		(uint uLine){return 0;}
	inline	int	 	Expand			(uint uLine,int iCount=TEXT_EXPAND){return 0;}
			#endif

			int	 	SetTabLoop    	(int iMode=1);
			int  	SetColor	   	(int iLine,uchar *pColors,int iLen,int iDefault=-1,int iAdd=1);
			int  	GetFlags      	();
			int  	SetFlags      	(int iFlags,int And=~FLAG_CONFIG_SAFE);
			int  	GetSelectionMode();
			int  	GetSelectionPos	(int &iPosX,int &iPosY,int &iEndX,int &iEndY);
			int  	GetSelectionPos	(int &iPosX,int &iPosY);
		 CPoint  	GetSelection  	();
		 CPoint  	SetSelection  	(CPoint sMark);
		 CPoint  	SetSelection  	(int iPosX,int iPosY);
	virtual void 	Update        	(int iMode=0);
				 	
	void		 	OnCut         	();				// Bearbeiten Befehle
	void		 	OnCopy        	();
	void		 	OnClear       	();
	void		 	OnPaste       	();
	void		 	OnUndo        	();
	void		 	OnUndoBack    	();
	void		 	OnSelectAll   	();
				 	
	int			 	Undo			(int iCount);
	int			 	UndoSave    	(int iLine1=0,int iLine2=1000000);
	int			 	UndoLoad    	(int iLine1=0,int iLine2=1000000);
	
	int			 	SelectionArea	(int &iStart,int &iStop);			 	
	int			 	SelectionTab	(int iMode  );
	int	 		 	SelectionClear 	(int iUndo2=0);
	int	 		 	SelectionCopy  	(int iNum=-1);
	int	 		 	SelectionInsert	(int iNum=-1);
	int	 		 	SelectionCut   	(int iNum=-1);
	int 		 	SelectWord     	(int iPosX,int iPosY);
	int 		 	SelectWord		();
				 	
	void 	       *SetHookProc		(int iMode,void *pProc,void *pParam);
	void 	       *DelHookProc 	(int iMode){return SetHookProc(iMode,0,0);}

#ifdef 		USE_DICIONARY
	int				ConfigDic   	(const char *pPath=0,int iFlags=0,int Mask=0,int iMode=0);
	char    	   *GetDicName  	(int iMode=0);
	HDIC			GetDicionary	(int iMode=0);
	int				SetDicFlags 	(int iFlags,int iMask=0xFFFFFFFF);
	int				GetDicFlags 	();
	int 			SelectDicWord  ();
#endif

protected:

	#ifdef  USE_VIRTUAL_LINES
	virtual	int	 TranslateLine  (unsigned uLine,int iDelta);
	#endif
	#ifdef  USE_WORD_HIGHLIGHT
	int			HighlightInLine(int iLine);
	#endif
	#ifdef 	USE_MARK_HIGHLIGHT
	int			MarkedWordInLine(int iLine);
	#endif
	#if defined(USE_MARK_HIGHLIGHT) || defined(USE_WORD_HIGHLIGHT)
	static int	GetMarkingText(const uchar *pText,uchar *pBuffer,int iSize,int iMode);
	#endif


	static  int  __cdecl WordCmp(const void  *pEntry1, const void *pEntry2);
	inline  int  CharType	   	(const uchar *pChar);
	inline  int  CharType	   	(unsigned uChar );
	inline  int  FindColor     	(unsigned uIndex);
	void		 FindUpdate		(uchar   *pText );
	virtual void OnCutRange    	(int      iId);
	virtual void OnCopyRange   	(int      iId);
	virtual void OnPasteRange  	(int      iId);
	virtual void OnScrollChange	();
	virtual int  OnChar        	(UINT     nChar ,UINT   nFlags);
	virtual int  OnKeyDown     	(UINT     nChar ,UINT   nFlags);
	virtual int  OnMouseMove    (UINT     nFlags,CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnLButtonUp    (UINT     nFlags,CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnLButtonDown  (UINT     nFlags,CPoint sPoint,int iPosX,int iPosY);
	virtual int  OnLButtonDblClk(UINT     nFlags,CPoint sPoint,int iPosX,int iPosY);
	virtual void StartMenu	   	(CPoint   sPos  ,CMenu *pMenu=0);
	virtual void PrintMargin   	(HDC      hDc   ,RECT  *pRect,int iLine);
			void SendNotify    	(int      iType,int iParam1=0,int iParam2=0,int iParam3=0);
	virtual TextLine *GetLine  	(unsigned uLine);

	//{{AFX_VIRTUAL(CTextView)
	virtual int  PrintLine		(HDC hDc,RECT *pRect,int iLine,int iStart,int iSize,int iFlags=0);
	virtual int  PositionOk		(int iPosX,int iPosY,int iMode);
	virtual int  LineLength		(int iLine);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CTextView)
	afx_msg	int		OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg	void	OnMenuUndo 		(CCmdUI *pCmdUI);
	afx_msg	void	OnMenuUndoBack	(CCmdUI *pCmdUI);
	afx_msg	void	OnMenuSelection	(CCmdUI *pCmdUI);
	afx_msg	void	OnMenuFind	    (CCmdUI *pCmdUI);
	afx_msg	void	OnMenuClipboard	(CCmdUI *pCmdUI);
	afx_msg	void	OnConfigView    ();
	afx_msg	void	OnCopyWord      ();
	afx_msg	void 	OnDicOnOff      ();
	afx_msg	void	OnFindView		();
	afx_msg	void	OnFindNext		();
	afx_msg	void	OnFindWord		();
	afx_msg	void	OnSelectWord    ();
	afx_msg	void	OnRepalceView	();
	afx_msg	void    OnSetFocus      (CWnd *pOldWnd);
	afx_msg	void    OnKillFocus     (CWnd *pNewWnd);
	afx_msg	LRESULT OnTextInfo      (WPARAM wParam,LPARAM lParam);
	#ifndef			TO_TEXTWND
	afx_msg	BOOL	OnPreparePrinting(CPrintInfo* pInfo);
	#endif
	#ifdef 			USE_DICIONARY
	afx_msg	void	OnMenuDicOn		(CCmdUI *pCmdUI);
	#endif
	#ifdef 			USE_MARK_HIGHLIGHT
	afx_msg	void	OnTimer			(UINT_PTR uIdEvent);
	afx_msg	void	OnMenuMarkOn	(CCmdUI *pCmdUI);
	afx_msg	void	OnMarkOnOff		();
	#endif
	//}}AFX_MSG


private:

	void		 UndoAdd		();
	void		 UndoClear      ();
	void		 CheckBlock		();
	void		 LineBeginEnd	(TextLine *pMem);
	TextLine    *LineCreate		(                   const unsigned char *pText,unsigned int iLen);
	int			 LineInsert		(unsigned int iLine,const unsigned char *pText,unsigned int iLen);
	int			 LineChange		(unsigned int iLine,const unsigned char *pText,unsigned int iLen);
	int			 LineDelete		(unsigned int iLine);
	int			 CharInput		(unsigned     uChar,int iUndoOk=1);
	int			 CharAbc		(int          iPos,unsigned char *pText,int      iLen,int iDir=0,int *pEnd=0);
	int			 SignAbc		(int          iPos,unsigned char *pText,int      iLen,int iDir=0);
	int			 TextPosition	(int          iPos,unsigned char *pText,unsigned uLen);
	int			 ViewPosition	(int          iPos,unsigned char *pText,unsigned uLen);
	int	    	 WordInsert		(uchar       *pMode   ,char *pText,int iLen);
	int			 CmpN			(unsigned	  uChar1  ,const void  *pBuffer2                ,int iUpper);
	int			 Cmp			(const void  *pBuffer1,const void  *pBuffer2,unsigned uCount,int iUpper);
	int			 CmpF			(const void  *pBuffer1,const void  *pBuffer2,unsigned uCount,int iUpper);
	int			 CmpC		    (const uchar *pBuffer1,const uchar *pBuffer2,unsigned uCount,int iUpper);
	int			 CmpX			(const uchar *pFind   ,int  iFindLen,const uchar *pText,int iLen,int iUpper);
	int			 TypeLen		(const uchar *pStr    ,int  iMode,int iLen);
	#ifdef 		 USE_DICIONARY
	int			 PrintDicionary	(int iLine);
	#endif

	int			 StatusbarInit	();
	int			 StatusbarExit  ();
	int			 StatusbarSet   ();

	#if			USE_TEXT_DRAGDROP
	#ifdef		TO_TEXTWND
				DECLARE_DROP_FUNC(CTextWnd)
	#else
				DECLARE_DROP_FUNC(CTextView)
	#endif
	#endif

// REM AZ
//virtual int  OnMarginClick  (UINT nFlags, CPoint sPoint,int iPosY);
};


//*****************************************************************************
//*
//*		inline Funktionen
//*
//*****************************************************************************
#ifdef 	USE_DICIONARY
inline	int  CTextView::GetDicFlags 	(         ){return          m_iDicFlags;}
inline	HDIC CTextView::GetDicionary	(int iMode){return (iMode)? m_hDicLocal:m_hDicGlobal;}
inline	char*CTextView::GetDicName  	(int iMode){return (iMode)? m_cDicNameL:m_cDicNameG;}
#endif
#ifdef USE_WORD_HIGHLIGHT
inline	int	 CTextView::WordHighlight   (const  char *pWord,int iMode){return WordHighlight((const uchar *)pWord,iMode);}
#endif
#ifdef USE_MARK_HIGHLIGHT
inline	int	 CTextView::MarkHighlight   (const  char *pWord,int iMode){return MarkHighlight((const uchar *)pWord,iMode);}
#endif
inline	int	 CTextView::SetTabLoop  	(int iMode){char cOld=m_cHasTabLoop;m_cHasTabLoop=iMode;return cOld;}
inline	int  CTextView::InsertEx    	(int iNum ){return SelectionInsert(iNum);}
inline	int  CTextView::GetSelectionPos (int &iPosX,int &iPosY){if(m_iMarkOn==1){if(m_iCursorX<m_iMarkX){iPosX=m_iCursorX;}else{iPosX=m_iMarkX;}iPosY=m_iCursorY;return 1;}if(m_iMarkOn==2){if(m_iCursorY<m_iMarkY){iPosX=m_iCursorX;iPosY=m_iCursorY;}else{iPosX=m_iMarkX;iPosY=m_iMarkY;}return 2;}iPosX=0;iPosY=0;return 0;}
inline	int  CTextView::GetSelectionPos (int &iPosX,int &iPosY,int &iEndX,int &iEndY){if(m_iMarkOn==1){if(m_iCursorX<m_iMarkX){iPosX=m_iCursorX;iEndX=m_iMarkX;}else{iPosX=m_iMarkX;}iPosY=m_iCursorY;iEndY=m_iMarkY;return 1;}if(m_iMarkOn==2){if(m_iCursorY<m_iMarkY){iPosX=m_iCursorX;iPosY=m_iCursorY;iEndX=m_iMarkX;iEndY=m_iMarkY;}else{iPosX=m_iMarkX;iPosY=m_iMarkY;iEndX=m_iCursorX;iEndY=m_iCursorY;}return 2;}iPosX=0;iPosY=0;iEndX=0;iEndY=0;return 0;}
inline	void CTextView::GetRange		(int &iPosX,int &iPosY,int &iEndX,int &iEndY){iPosX=m_iAreaStartX;iPosY=m_iAreaStartY;iEndX=m_iAreaStopX;iEndY=m_iAreaStopY;}
inline	void CTextView::GetRange		(CPoint &sFrom,CPoint &sTo){sFrom.x=m_iAreaStartX;sFrom.y=m_iAreaStartY;sTo.x=m_iAreaStopX;sTo.y=m_iAreaStopY;}
inline	int  CTextView::TextCopy		(	   wchar_t  *pText,int iMax                    ,int iMode){return TextCopy((uchar*)pText,iMax*2,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextCopy		(		char    *pText,int iMax                    ,int iMode){return TextCopy((uchar*)pText,iMax  ,iMode              );}
inline	int  CTextView::TextCopy		(	   wchar_t  *pText,int iMax,int iPosX,int iPosY,int iEndX,int iEndY,int iMode){return TextCopy((unsigned char  *)pText,iMax,iPosX,iPosY,iEndX,iEndY,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextCopy		(	    char    *pText,int iMax,int iPosX,int iPosY,int iEndX,int iEndY,int iMode){return TextCopy((unsigned char  *)pText,iMax,iPosX,iPosY,iEndX,iEndY,iMode              );}
inline	int  CTextView::TextCopy		(	   wchar_t **pText         ,int iPosX,int iPosY,int iEndX,int iEndY,int iMode){return TextCopy((unsigned char **)pText,iPosX,iPosY,iEndX,iEndY,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextCopy		(	    char   **pText         ,int iPosX,int iPosY,int iEndX,int iEndY,int iMode){return TextCopy((unsigned char **)pText,iPosX,iPosY,iEndX,iEndY,iMode              );}
inline	int  CTextView::TextInsert		(const wchar_t  *pText         ,int iPosX,int iPosY,int iMode){return TextInsert((unsigned char*)pText,iPosX,iPosY,iMode|TEXT_IS_UTF16,wcslen(       pText)*2);}
inline	int  CTextView::TextInsert		(const uchar    *pText         ,int iPosX,int iPosY,int iMode){return TextInsert((unsigned char*)pText,iPosX,iPosY,iMode              ,strlen((char*)pText)  );}
inline	int  CTextView::TextInsert		(const  char    *pText         ,int iPosX,int iPosY,int iMode){return TextInsert((unsigned char*)pText,iPosX,iPosY,iMode              ,strlen((char*)pText)  );}
inline	int  CTextView::TextInsert		(const wchar_t  *pText         ,int iPosX,int iPosY,int iMode,int iSize){return TextInsert((unsigned char *)pText,iPosX,iPosY,iMode|TEXT_IS_UTF16,iSize*2);}
inline	int  CTextView::TextInsert		(const  char    *pText         ,int iPosX,int iPosY,int iMode,int iSize){return TextInsert((unsigned char *)pText,iPosX,iPosY,iMode              ,iSize  );}
inline	int  CTextView::TextInsert		(const wchar_t  *pText                    ,int iMode){return TextInsert((unsigned char*)pText                              ,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextInsert		(const  char    *pText                    ,int iMode){return TextInsert((unsigned char*)pText                              ,iMode              );}
inline	int  CTextView::TextExchange	(const wchar_t  *pText,          int iPosY,int iMode){return TextExchange ((unsigned char*)pText,iPosY,wcslen(pText)*2     ,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextExchange	(const uchar    *pText,          int iPosY,int iMode){return TextExchange ((unsigned char*)pText,iPosY,strlen((char*)pText),iMode);}
inline	int  CTextView::TextExchange	(const  char    *pText,          int iPosY,int iMode){return TextExchange ((unsigned char*)pText,iPosY,strlen((char*)pText),iMode);}
inline	int  CTextView::TextExchange	(const wchar_t  *pText,          int iPosY,int iSize,int iMode){return TextExchange ((unsigned char*)pText,iPosY,iSize*2   ,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextExchange	(const  char    *pText,          int iPosY,int iSize,int iMode){return TextExchange ((unsigned char*)pText,iPosY,iSize     ,iMode);}
inline	int  CTextView::TextCopy		(      wchar_t **pText          ,int iMode){return TextCopy((uchar**)pText,0,0,0,0,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::TextCopy		(        uchar **pText          ,int iMode){return TextCopy((uchar**)pText,0,0,0,0,iMode);}
inline	int  CTextView::TextCopy 		(         char **pText          ,int iMode){return TextCopy((uchar**)pText,0,0,0,0,iMode);}
inline	int  CTextView::WordCopy 		(      wchar_t **pText          ,int iMode){return TextCopy((uchar**)pText,0,0,0,0,TEXT_CURSOR|TEXT_WORD|TEXT_IS_UTF16|iMode);}
inline	int  CTextView::WordCopy 		(        uchar **pText          ,int iMode){return TextCopy((uchar**)pText,0,0,0,0,TEXT_CURSOR|TEXT_WORD|              iMode);}
inline	int  CTextView::WordCopy 		(         char **pText          ,int iMode){return TextCopy((uchar**)pText,0,0,0,0,TEXT_CURSOR|TEXT_WORD|              iMode);}
inline	int  CTextView::WordCopy 		(      wchar_t  *pText,int iMax ,int iMode){return TextCopy((uchar *)pText,iMax*2 ,TEXT_CURSOR|TEXT_WORD|TEXT_IS_UTF16|iMode);}
inline	int  CTextView::WordCopy 		(        uchar  *pText,int iMax ,int iMode){return TextCopy((uchar *)pText,iMax   ,TEXT_CURSOR|TEXT_WORD|              iMode);}
inline	int  CTextView::WordCopy 		(         char  *pText,int iMax ,int iMode){return TextCopy((uchar *)pText,iMax   ,TEXT_CURSOR|TEXT_WORD|              iMode);}
inline	int  CTextView::ColorCopy		(      wchar_t **pText,uchar **pColors,int iPosY,int iEndX1,int iEndX2,int iMode){return ColorCopy((uchar**)pText,(uchar**)pColors,iPosY,iEndX1,iEndX2,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::ColorCopy		(      wchar_t **pText, char **pColors,int iPosY,int iEndX1,int iEndX2,int iMode){return ColorCopy((uchar**)pText,(uchar**)pColors,iPosY,iEndX1,iEndX2,iMode|TEXT_IS_UTF16);}
inline	int  CTextView::ColorCopy		(        uchar **pText, char **pColors,int iPosY,int iEndX1,int iEndX2,int iMode){return ColorCopy((uchar**)pText,(uchar**)pColors,iPosY,iEndX1,iEndX2,iMode);}
inline	int  CTextView::ColorCopy		(         char **pText,uchar **pColors,int iPosY,int iEndX1,int iEndX2,int iMode){return ColorCopy((uchar**)pText,(uchar**)pColors,iPosY,iEndX1,iEndX2,iMode);}
inline	int  CTextView::ColorCopy		(         char **pText, char **pColors,int iPosY,int iEndX1,int iEndX2,int iMode){return ColorCopy((uchar**)pText,(uchar**)pColors,iPosY,iEndX1,iEndX2,iMode);}
inline	int  CTextView::IsSelected		(){return m_iMarkOn;     }
inline	int  CTextView::GetLineCount	(){return m_iLineCount;  }
inline	int  CTextView::GetTabSize  	(){return m_iTabWidth;   }
inline	int  CTextView::GetFlags    	(){return m_iFlags;      }
inline	BOOL CTextView::IsSelectedX 	(){return m_iMarkOn==1;  }
inline	BOOL CTextView::IsSelectedY 	(){return m_iMarkOn==2;  }
inline	BOOL CTextView::GetModify   	(){return m_cChanged;    }
inline	BOOL CTextView::GetCanModify	(){return!m_cNotChange;  }
inline	int  CTextView::GetSelectionMode(){return m_iMarkOn;	 } // Ergibt: 0=nichts markiert 1=einzeilige Marke 2=mehrzeiliger Marke
inline	char*CTextView::GetConfigName   (){return m_cConfigName; }
inline	int	 CTextView::GetTextMargin	(){return m_iTextMargin; }
inline	int  CTextView::ConvertCursorToPos(int iLine,int iPos){TextLine *pLine;pLine=GetLine(iLine);return TextPosition(iPos,pLine->aText,pLine->uSize);}
inline	int  CTextView::ConvertPosToCursor(int iLine,int iPos){TextLine *pLine;pLine=GetLine(iLine);return ViewPosition(iPos,pLine->aText,pLine->uSize);}

//*****************************************************************************
//{{AFX_INSERT_LOCATION
//}}AFX_INSERT_LOCATION


#ifdef		CTextView
#undef 		CTextView
#endif
#ifdef		CAnsiView
#undef 		CAnsiView
#endif
#ifdef		CView
#undef 		CView
#endif
