//*****************************************************************************
//*
//*
//*		TextDlg.h
//*
//*
//*****************************************************************************
#ifndef	AFX_TEXTDLG_H__56771288_VXDA_1341_9273_144553540000__INCLUDED_
#define AFX_TEXTDLG_H__56771288_VXDA_1341_9273_144553540000__INCLUDED_

#include	"TextMessage.h"

class CTextChangeDlg;

//*****************************************************************************
//*
//*		Dialog CTextQuestionDlg
//*
//*****************************************************************************
class CTextQuestionDlg : public CDialog
{
public:

	CTextQuestionDlg(CWnd *pParent=NULL);
	void		Move	  ();
   	INT_PTR		DoModal   ();

protected:

	friend		CTextChangeDlg;

	CWnd       *m_pTextWnd;								// View - Klasse


	//{{AFX_VIRTUAL(CTextQuestionDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnYes();
	afx_msg void OnNo();
	afx_msg void OnCancel();
	//}}AFX_VIRTUAL(CTextQuestionDlg)

	DECLARE_MESSAGE_MAP()

	static int 		m_iScreenSizeX;						// Alte Dialog Position
	static int 		m_iScreenSizeY;
	static int 		m_iScreenOn;
	static WORD		m_wDlgData[];

};


//*****************************************************************************
//*
//*		Dialog CTextFindDlg
//*
//*****************************************************************************
class CTextFindDlg : public CDialog
{
public:

	CTextFindDlg(CWnd *pParent=NULL);

	INT_PTR DoModal(CWnd *pEdit,LPTSTR pText,int iTextSize,int iFlags,LPCTSTR pSelction);


protected:

	int					m_bSpecialExpression;			// Regulren Ausdruck suchen
	int					m_bWordHighLight;				// Die Wrter markieren
	int					m_bHasHighLight;				// Knnen Wrter makiert werden
	int					m_bFullDocument;				// Den ganzen Text durchsuchen
	int					m_bSeachUpwards;				// Aufwrts/abwrts suchen
	int					m_bIgnoreCase;					// Gros/Kleinschreibung ignorieren
	int					m_bWordHlInit;					// Initalwert fr Wrter markieren
	int					m_bFullWords;					// Ganze Wrter suchen
	int					m_bSeachDown;					//		*

	TCHAR				m_cSeachText[260];				// Suchetext
	LPCTSTR				m_pSelection;					// Auswahltexte
	CWnd			   *m_pTextWnd;						// View - Klasse


	//{{AFX_VIRTUAL(CTextFindDlg)
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange *pDX);
	afx_msg void OnMenu(UINT Art);
	afx_msg void OnChanged();
	afx_msg void OnDestroy();
	afx_msg void OnSelect();
	afx_msg void OnCancel();
	afx_msg void OnFind();
	afx_msg void OnNext();
	//}}AFX_VIRTUAL(CTextFindDlg)

	DECLARE_MESSAGE_MAP()

	static int 			m_iScreenSizeX;					// Alte Dialog Position
	static int 			m_iScreenSizeY;
	static int 			m_iScreenOn;
	static WORD			m_wDlgData[];
	static WORD			m_wDlgIcon[];
};

//*****************************************************************************
//*
//*		Dialog CTextConfigDlg
//*
//*****************************************************************************
class CTextConfigDlg : public CDialog
{
public:

	CTextConfigDlg(CWnd *pParent=NULL);

   	INT_PTR		DoModal(CWnd *pEdit,int iFlags,int iTabWithd);

protected:

	BOOL				m_bMarkFullLines;				// Linienweise markieren
	BOOL				m_bBracketArea;					// Klammern bereichsweise markieren
	BOOL				m_bVirtual;						// Virtueller Bildschirm
	BOOL				m_bInsertBefore;				// Vor marke einfgen
	BOOL				m_iTabWidth;					// Tabulator-Beite
	BOOL				m_bFindBrackets;				// Nach Klammern suchen
	BOOL				m_bShowLineNumbers;				// Zeilennummern anzeigen
	BOOL				m_bMarkUntilEnd;				// Marke bis zum Zeilenende
	BOOL				m_bJumpMisc;					// Auch diversen Zeichen anhalten.
	BOOL				m_bJumpFirst;					// Nur am Beginn eines Wortes/Bereichs anhalten.
	BOOL				m_bJumpUpper;					// Auch Gro/Kleinbergngen anhalten.
	BOOL				m_bJumpUnter;					// Das '_' nicht als Buchstaben betrachten.
	INT					m_iMarkMode;					// Modus fr's Markieren von Worten 
	INT					m_iInitFlags;					// Grundzustand der Flags
	CWnd			   *m_pTextWnd;						// View - Klasse


	//{{AFX_VIRTUAL(CTextConfigDlg)
	virtual void DoDataExchange(CDataExchange *pDX);
	virtual BOOL OnInitDialog();
	afx_msg void OnOk();
	//}}AFX_VIRTUAL(CTextConfigDlg)

	DECLARE_MESSAGE_MAP()

	static WORD			m_wDlgData[];
};

//*****************************************************************************
//*
//*		Dialog CTextChangeDlg
//*
//*****************************************************************************
class CTextChangeDlg : public CDialog
{
public:


	CTextChangeDlg(CWnd *pParent=NULL);

	INT_PTR DoModal(CWnd *pEdit,LPTSTR pText,int iTextSize,LPTSTR pChange,int iChangeSize,int iFlags,LPCTSTR pSelction);


protected:

	int					m_bSpecialExpression;			// Regulren Ausdruck suchen
	int					m_bWordHighLight;				// Die Wrte markieren
	int					m_bHasHighLight;				// Knnen Wrter makiert werden
	int					m_bIgnoreCase;					// Gros/Kleinschreibung ignorieren
	int					m_bFullWords;					// Ganze Wrter suchen
	int					m_bSeachDown;					//		*
	int					m_bSeachUpwards;				// Aufwrts/abwrts suchen
	int					m_bFullDocument;				// Den ganzen Text durchsuchen
	int					m_bFullModeOn;					// Was ndern anzeigen
	int					m_bFullMode;					// Was ndern (Gesamter Text/Auswahl)

	LPCTSTR				m_pSelection;					// Auswahltexte
	TCHAR				m_cNewText  [260];				// nderntext
	TCHAR				m_cSeachText[260];				// Suchettext
	CTextQuestionDlg	m_sQuestionDlg;					// Ja/Nein/Abbruch-Dialog
	CWnd			   *m_pTextWnd;						// View - Klasse

	//{{AFX_VIRTUAL(CTextChangeDlg)
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange *pDX);
	afx_msg void OnMenu(UINT Art);
	afx_msg void OnChanged();
	afx_msg void OnDestroy();
	afx_msg void OnSelect();
	afx_msg void OnChange();
	afx_msg void OnCancel();
	afx_msg void OnAll();
	//}}AFX_VIRTUAL(CTextChangeDlg)

	DECLARE_MESSAGE_MAP()

	static int 			m_iScreenSizeX;					// Alte Dialog Position
	static int 			m_iScreenSizeY;
	static int 			m_iScreenOn;
	static WORD			m_wDlgData[];
	static WORD			m_wDlgIcon[];

};


//*****************************************************************************
//{{AFX_INSERT_LOCATION}}

#endif
