//*****************************************************************************
//*
//*
//*		CoordFunctions.h
//*
//*
//*****************************************************************************
//	
//	Verschidene Funktionen zur Bearbeitung von gobalen Koordinaten
//
#ifndef 	__COORDFUNCTIONS_H__
#define 	__COORDFUNCTIONS_H__

#if defined(_WIN32)
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
					
	#include <afx.h>

#else

	#ifdef	 _WIN32
	#include <windows.h>
	#endif

#endif
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifdef	UNICODE
#define 	CoordToText	CoordToTextW
#else 	
#define 	CoordToText	CoordToTextA
#endif 	


typedef struct
	{
	double		dGlobalTime;							// Ist die OLE-Zeit (Tage seit 30.Dec.1899)
	double		dCoordX;								// Lngengrad
	double		dCoordY;								// Breitengrad
	double		dCoordZ;								// Seehhe in Meter
	double		dDistance;								// Gesammterweg in Meter
	double		dTime;									// Gesamtfahrzeit in Sekunden (mit Pausen)
	double		dPause;									// Gesamtpausenzeit in Sekunden
	double		dVelocity;								// Geswindigkeit in m/s
	double		dHeighUp;								// Gemachte Hhenmeter
	double		dHeighDown;								// Abgebaute Hhenmeter
	double		dUserData1;								// User-Daten 1
	double		dUserData2;								// User-Daten 2
	double		dUserData3;								// User-Daten 3
	double		dUserData4;								// User-Daten 4
	}RouteData;


void			CoordDelta		  (double  dPosX,double dPosY,double dDeltaX,double dDeltaY,double &dCoordX,double &dCoordY);
void			CoordDeltaEx	  (double  dPosX,double dPosY,double dDeltaX,double dDeltaY,double &dCoordX,double &dCoordY);
double			DistanceOfPoints  (double  dLongitude1,double dLatitude1,double dLongitude2,double dLatitude2);
double			DistanceOfPointsEx(double  dLongitude1,double dLatitude1,double dLongitude2,double dLatitude2);
double			CoordToMercator   (double  dLatitude);
double			MercatorToCoord   (double  dPosY);
void			CoordToPixel      (double  dPosX,double  dPosY,double &dPixelX,double &dPixelY,const double *pRefValues);
void inline		CoordToPixel      (double  dPosX,double  dPosY,int    &iPixelX,int    &iPixelY,const double *pRefValues){double dPixelX;double dPixelY; CoordToPixel(dPosX,dPosY,dPixelX,dPixelY,pRefValues); iPixelX  =(int)dPixelX;iPixelY  =(int)dPixelY;}
void inline		CoordToPixel      (double  dPosX,double  dPosY,                LPPOINT pPoint ,const double *pRefValues){double dPixelX;double dPixelY; CoordToPixel(dPosX,dPosY,dPixelX,dPixelY,pRefValues); pPoint->x=(int)dPixelX;pPoint->y=(int)dPixelY;}
void 			PixelToCoord      (double &dPosX,double &dPosY,double  dPixelX,double  dPixelY,const double *pRefValues);
void inline		PixelToCoord      (double &dPosX,double &dPosY,        const   LPPOINT pPoint ,const double *pRefValues){PixelToCoord(dPosX,dPosY,pPoint->x,pPoint->y,pRefValues);}
int				EncodeMercatorRef (      char *pComment,double  dCoordX,double dCoordY,int iZoom);
int				EncodeMercatorRef (      char *pComment,double  dCoordX,double dCoordY,int iZoom,int iPosX,int iPosY);
int				DecodeMercatorRef (const char *pComment,double *pRefValues);
int				EncodeMercatorRef (      char *pComment,double  dCoordX,double dCoordY,double dResX,double dResY);
int				EncodeMercatorRef (      char *pComment,double  dCoordX,double dCoordY,double dResX,double dResY,int iPosX,int iPosY);
int inline		EncodeMercatorRef (      char *pComment,const double *pRefValues){return EncodeMercatorRef(pComment,pRefValues[2],pRefValues[3],pRefValues[0],pRefValues[1]);}
int				EncodeMercatorRef (      char *pComment,const double *pRefValues,int iPosX,int iPosY);
int				ReadTrackFile     (const char    *pFilename,      RouteData **pRoutePtr,char    *pBuffer=0);
int				ReadTrackFile     (const wchar_t *pFilename,      RouteData **pRoutePtr,wchar_t *pBuffer=0);
int				SaveKml			  (const char    *pFilename,const RouteData  *pRoute,int iCount,const char    *pName=0);
int				SaveKml			  (const wchar_t *pFilename,const RouteData  *pRoute,int iCount,const wchar_t *pName=0);
int				SaveGpx			  (const char    *pFilename,const RouteData  *pRoute,int iCount,const char    *pName=0);
int				SaveGpx			  (const wchar_t *pFilename,const RouteData  *pRoute,int iCount,const wchar_t *pName=0);
int				SaveCsv			  (const char    *pFilename,const RouteData  *pRoute,int iCount,const char    *pName=0);
int				SaveCsv			  (const wchar_t *pFilename,const RouteData  *pRoute,int iCount,const wchar_t *pName=0);
double			CalcDistance	  (RouteData  *pRoute,int iCount,int iFlags=0);
int 			ScaleRoute  	  (const RouteData  *pRoute,int iCount,RouteData **pRoutePtr,double dStep,unsigned uMode=0);
double			TextToCoord		  (const  char   *pText,int *pLen=0);
double			TextToCoord		  (const wchar_t *pText,int *pLen=0);
const char	   *CoordToTextA	  (double dValue,unsigned uFormat, char   *pBuffer=0,int *pLen=0);
const wchar_t  *CoordToTextW	  (double dValue,unsigned uFormat,wchar_t *pBuffer=0,int *pLen=0);

#endif 	