//*****************************************************************************
//*
//*
//*		DataField.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechen (C) 2003
//
//	Die Klasse CDataPointer erzeugt eine Feld-Liste von Eintrgen (Zeiger-Liste mit varaibeln Elementgren)
//	Die Klasse CDataList    erzeugt eine Feld-Liste von Eintrgen (Zeiger-Liste)
//	Die Klasse CDataList    erzeugt eine Feld-Liste von Eintrgen (Zeiger-Liste)
//
//	Funktionen:
//
// 	int   Find (int   iValue, ... )						: Sucht eine Zahl
// 	int   Find (void *pMem  , ... )						: Sucht einen Bereich
// 	int   Len  (unsigned uSize=0,int Add=-1)			: Lnge einstellen
// 	void *Get  (unsigned uPos)							: Zeiger auf Element
// 	void *Get  (unsigned uPos,void *pTarget)			: Element kopieren
// 	int	  Del  ()										: Alle   Elemente lschen
// 	int	  Del  (unsigned uPos)							: Ein    Element  lschen
// 	int	  Del  (unsigned uFrom ,unsigned uTo);	 		: Einige Elemente lschen
// 	int	  Set  (void*  pData,unsigned uPos,int iNum=1)	: Elemente berschreiben
// 	int	  Set  (void** pData,unsigned uPos,int iNum=1)	: Elemente berschreiben
// 	int	  Add  (void*  pData,unsigned uPos,int iNum=1)	: Elemente einfgen
// 	int	  Add  (void** pData,unsigned uPos,int iNum=1)	: Elemente einfgen
// 	void  Sort (int (_cdecl*iCmp)(...),int,int,int)		: Das Feld sortieren
//	void  Sort (int (_cdecl*pCmp)(...),void*,int,...)	: Das Feld sortieren
// 	void  Sort (unsigned,int iLen=-1,int,int,int)		: Das Feld sortieren
// 	int   Count()										: Anzahl der Elemente abfragen
//
#ifdef		GLOBAL_CONFIG
#define 	DATAFIELD_CPP
#include	<GlobalConfig.h>
#undef		DATAFIELD_CPP
#endif


#include	<string.h>
#include	"DataField.h"

#ifdef		 AZ_LIB_ADDAFX
#if		    _MSC_VER > 1299
#ifndef		 WINVER
#define		 WINVER 	0x0501
#endif
#endif
#include	<Afx.h>
#endif

#ifdef		_MSC_VER
#pragma 	warning( disable :4302 )
#pragma 	warning( disable :4311 )
#pragma 	warning( disable :4312 )
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef		i64
#undef 		i64
#endif

#ifdef		u64
#undef 		u64
#endif

#ifndef	   _MSC_VER
#define		i64	 			long long
#define		u64	 			unsigned long long
#else
#define		i64	 			__int64
#define		u64	 			unsigned __int64
#endif


typedef		void*			lpvoid;
typedef		char*			lpchar;


#define 	OFFSET_MEM(i,o)		(((char*)(m_pField[i]))+(o))
#define 	OFFSET_PTR(i,o)		(((char*) m_pField)+(i)*m_uFieldSize+(o))


#define		XCHANGE_MEM(a,b)											\
			{							/* Tausche Felder */			\
			int    *pPos1,*pPos2;										\
			int		i,j;												\
																		\
			pPos1=(int*)(((char*)m_pField)+(a)*m_uFieldSize);			\
			pPos2=(int*)(((char*)m_pField)+(b)*m_uFieldSize);			\
			for(i=0;i<iNum;i++)											\
				{														\
				j=pPos1[i];												\
				  pPos1[i]=pPos2[i];									\
				  pPos2[i]=j;											\
				}														\
																		\
			if(iMask)					/* Die letzten Byte kopieren */	\
				{														\
				j=pPos1[i];												\
				  pPos1[i]&=  iMask;									\
				  pPos1[i]|= ~iMask & pPos2[i];							\
				  pPos2[i]&=  iMask;									\
				  pPos2[i]|= ~iMask & j;								\
				}														\
			}

int DataFieldCmpInt(void *pParam,const void *pData1,const void *pData2)
	{
	int	iVal1=*(int*)pData1;
	int	iVal2=*(int*)pData2;

	if(iVal1<iVal2)return -1;
	if(iVal1>iVal2)return  1;

	return 0;
	}

int DataFieldCmpUInt(void *pParam,const void *pData1,const void *pData2)
	{
	unsigned uVal1=*(unsigned*)pData1;
	unsigned uVal2=*(unsigned*)pData2;

	if(uVal1<uVal2)return -1;
	if(uVal1>uVal2)return  1;

	return 0;
	}

int DataFieldCmpShort(void *pParam,const void *pData1,const void *pData2)
	{
	int		iVal1=*(short*)pData1;
	int		iVal2=*(short*)pData2;
	return  iVal1-iVal2;
	}

int DataFieldCmpUShort(void *pParam,const void *pData1,const void *pData2)
	{
	unsigned uVal1=*(unsigned short*)pData1;
	unsigned uVal2=*(unsigned short*)pData2;
	return   uVal1-uVal2;
	}


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
//	uFree	: Sollen die Eintrge beim Lschen mit delete freigegeben werden.
//	uAdd	: Ist die Zahl der Eintrge um die das Feld  bei Betarf vergert
//			  wird. Bei Null erfolgt eine dynamische Vergrerung.
CDataPointer::CDataPointer(unsigned uFree,unsigned  iAdd)
{
	m_uFieldAdd   = iAdd;
	m_uFieldFree  = uFree;
	m_uFieldCount = 0;
	m_uFieldMax	  = 0;
	m_pField	  = 0;
	m_pOldPtr     = 0;
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDataPointer::~CDataPointer()
{
int i,iNum;

	iNum=m_uFieldCount;
		 m_uFieldCount=0;

	if(m_uFieldFree)
		{
		for(i=0;i<iNum;i++)delete m_pField[i];
		}

	if(m_pOldPtr)
		{
		delete m_pOldPtr;
		m_pOldPtr = 0;
		}

	if(m_pField)
		{
		delete m_pField;
		m_pField = 0;
		}

}

//*****************************************************************************
//*
//*		Len
//*
//*****************************************************************************
//	Stellt ein ob die Eintrge freigegeben werden sollen beim Lschen.
//	Das funktioniert nur wenn das Feld leer ist.
//	uFree	: Sollen die Eintrge beim Lschen mit delete freigegeben werden.
//	uAdd	: Ist die Zahl der Eintrge um die das Feld bei Betarf vergert
//			  wird. Bei Null erfolgt eine dynamische Vergrerung (+50%).
//			  Wenn kleiner 0 wird die Vergrerung nicht verndert.
//	Ergibt 1 wenn alles ok war bzw. 0 bei einem Fehler
int CDataPointer::Len(unsigned uFree,int iAdd)
{

	if(iAdd>=0)
		{
		m_uFieldAdd=iAdd;
		}

	if(uFree)
		{
		if(m_uFieldCount)return 0;
		m_uFieldFree = uFree;
		}


return 1;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein.
//	pData	: Ist der Zeiger auf das Array mit den einzufgenten Elementen.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iCopy	: Wenn diesert Wert 0 ist wird nur der Zeiger in die Liste eingetragen
//			  Wenn nicht wird ein neuer Zeiger mit new erzeugt und die Daten kopiert.
//	Ergibt die Einfgeposition.
int	CDataPointer::Add(const void *pData,unsigned uPos,int iCopy)
{
char     *pPtr=(char*)pData;
void	**pFieldNew;
int       iMaxNew;



	if(iCopy>0 && m_uFieldFree)							// Das Element allokieren
		{
		pPtr = new char[iCopy];
		memcpy(pPtr,pData,iCopy);
		}


	if(uPos>m_uFieldCount)uPos=m_uFieldCount;			// Position ok
	if(1   +m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+1)/m_uFieldAdd)+1;
			 		    iMaxNew*=  m_uFieldAdd;		}
		else{		    iMaxNew =((m_uFieldMax+1)*3)/2;	// Gre + 50%
			         if(iMaxNew<16)iMaxNew=16;	}


		pFieldNew = new lpvoid[iMaxNew];

		memcpy(pFieldNew       ,m_pField     ,               uPos *sizeof(void*));
		memcpy(pFieldNew+uPos+1,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));
		       pFieldNew[uPos] =pPtr;

		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr      = m_pField;						// In Feld speichern
		m_pField	   = pFieldNew;
		m_uFieldMax    = iMaxNew;
		m_uFieldCount += 1;

		return uPos;
		}

														// Element einfgen
	memmove(m_pField+uPos+1,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));
	m_pField[uPos]=pPtr;
	m_uFieldCount++;



return uPos;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein.
//	pData	: Ist der Zeiger auf das Zeigerfeld mit den einzufgenten Elementen.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die eingefgt werden sollen.
//	Ergibt die Einfgeposition.
int	CDataPointer::Add(void **pData,unsigned uPos,int iNum)
{
void	**pFieldNew;
int       iMaxNew;


	if(uPos>m_uFieldCount)uPos=m_uFieldCount;			// Position ok
	if(iNum<=0    )return uPos;							// Nichts einfgen ?
	if(iNum+m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+iNum)/m_uFieldAdd)+1;
					    iMaxNew*=  m_uFieldAdd;		}
		else{		    iMaxNew =((m_uFieldMax+iNum)*3)/2;// Gre + 50%
				     if(iMaxNew<16)iMaxNew=16;	}

		pFieldNew = new lpvoid[iMaxNew];

		memcpy(pFieldNew          ,m_pField     ,               uPos *sizeof(void*));
		memcpy(pFieldNew+uPos+iNum,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));
		memcpy(pFieldNew+uPos  	  ,pData	    ,			 	iNum *sizeof(void*));

		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr	   = m_pField;						// In Feld speichern
		m_pField	   = pFieldNew;
		m_uFieldMax    = iMaxNew;
		m_uFieldCount += iNum;

		return uPos;
		}

	memmove(m_pField+uPos+iNum,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));
	memcpy (m_pField+uPos  	  ,pData	    ,               iNum *sizeof(void*));


	m_uFieldCount += iNum;



return uPos;
}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
//	berschreibt ein oder meherer Elemente im Feld.
//	berzhlige Elementer werden am Ende des Feldes angehngt.
//	pData	: Ist der Zeiger auf das Array mit den neuen Elementen.
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iCopy	: Wenn diesert Wert 0 ist wird nur der Zeiger in die Liste eingetragen
//			  Wenn nicht wird ein neuer Zeiger mit new erzeugt und die Daten kopiert.
//	Ergibt die Position ab der Elemente gendert wurden
int	CDataPointer::Set(const void *pData,unsigned uPos,int iCopy)
{
char    *pPtr;





	if(uPos>=m_uFieldCount)return Add(pData,uPos,0);	// Am Ende einfgen

	if(iCopy>0 && m_uFieldFree)							// Das Element allokieren
		{
		pPtr = new char[iCopy];
		memcpy(pPtr,pData,iCopy);
		}
	else{
		pPtr=(char*)pData;
		}

	m_pField[uPos] = pPtr;




return uPos;
}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
//	berschreibt ein oder meherer Elemente im Feld.
//	berzhlige Elementer werden am Ende des Feldes angehngt.
//	pData	: Ist der Zeiger auf das Zeigerfeld mit den neuen Elementen.
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die Eingefgt werden sollen.
//	Ergibt die Position ab der Elemente gendert wurden
int	CDataPointer::Set(void** pData,unsigned uPos,int iNum)
{
unsigned i;



	if(uPos>=m_uFieldCount)return Add(pData,uPos,iNum);	// Am Ende einfgen
	if(iNum<=0            )return uPos;					// Nichts einfgen ?


	for(i=uPos;i<m_uFieldCount;iNum--,i++)
		{
		m_pField[i] = (char*)*pData;
		pData++;
		}

	if(iNum>0)Add(pData,i,iNum);						// Die restlichen Elemente einfgen



return uPos;
}


//*****************************************************************************
//*
//*		Peek
//*
//*****************************************************************************
//	Lscht eine einzelnen Eintrag aus der Liste ohne den Eintrag zu deallokieren.
//	Dieser Eintrag muss mit Free() spter deallokiert werden.
//	uPos	: Ist die Position des Eintrages.
//	Ergibt eine Zeiger auf den Eintrag, oder NULL bei einem Fehler.
void *CDataPointer::Peek(unsigned uPos)
{
void	   *pEntry;


	if(uPos>=m_uFieldCount)return 0;					// Position prfen

	pEntry			= m_pField[uPos];
	m_pField[uPos]	= 0;
	
	Del(uPos,uPos+1);


return pEntry;
}

//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Lscht alle Eintrge in einem Bereich
//	uFrom	: Ist der Beginn des Bereiches. (erste Element das gelscht wird)
//	uTo		: Ist das Ende des Bereiches. (erste Element das nicht gelscht wird)
//	Ergibt die Anzahl der gelschten Elemente.
int	CDataPointer::Del(unsigned uFrom,unsigned uTo)
{
void 	  **pFieldNew;
void	   *pEntry;
int			iCount;
int			iNum;
unsigned	uPos;



	if(uFrom >=m_uFieldCount)return 0;
	if(uTo   <=uFrom        )return 0;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;


	iCount		   = m_uFieldCount;
	iNum		   = uTo-uFrom;
	m_uFieldCount -= iNum;

	if(m_uFieldFree)									// Eintrge freigeben
		{
		for(uPos=uFrom;uPos<uTo;uPos++)
			{
			pEntry = m_pField[uPos];
			if(pEntry)
				{
				delete pEntry;
				m_pField[uPos] = 0;
				}
			}
		}

	memmove(m_pField+uFrom,m_pField+uTo,(iCount-uTo)*sizeof(void*));

	if(m_uFieldCount<=0)								// Ganzes Feld lschen
		{
		if(m_pOldPtr)
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr	= m_pField;
		m_uFieldMax	= 0;
		m_pField	= 0;
		}
	else if(m_uFieldAdd>0)								// Feld verkleinern
		{
		if(m_uFieldCount+m_uFieldAdd*4<=m_uFieldMax)
			{
			m_uFieldMax = m_uFieldCount+m_uFieldAdd;
			pFieldNew   = new lpvoid[m_uFieldMax];

			memcpy(pFieldNew,m_pField,m_uFieldCount*sizeof(lpvoid));

			if(m_pOldPtr)
				{
				delete m_pOldPtr;
				m_pOldPtr = 0;
				}

			m_pOldPtr	= m_pField;
			m_pField	= pFieldNew;
			}
		}
	else{
		if(m_uFieldCount*4<=m_uFieldMax)
			{
  			m_uFieldMax = (m_uFieldCount*3)/2;
			pFieldNew   = new lpvoid[m_uFieldMax];

			memcpy(pFieldNew,m_pField,m_uFieldCount*sizeof(lpvoid));

			if(m_pOldPtr)
				{
				delete m_pOldPtr;
				m_pOldPtr = 0;
				}

			m_pOldPtr	= m_pField;
			m_pField	= pFieldNew;
			}
		}


return iNum;
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Kopiert den Inhalt eines Eintrages in einen Puffer
//	uPos		: Ist die Position des Eintrages
//	pTarget		: Ist der Zeiger auf den Puffer in den der Eintrag gespeichert wird.
//	Ergibt einen Zeiger auf das Element bzw. 0 bei einem Fehler.
void *CDataPointer::Get(unsigned uPos,void *pTarget,unsigned uSize) const
{


	if(uPos>=m_uFieldCount || !pTarget)return 0;

	memcpy(pTarget,m_pField[uPos],uSize);


return m_pField[uPos];
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Holt einen Wert aus einen Eintrag
//	uPos		: Ist die Position des Eintrages
//	uOffset		: Ist der Offset im Eintrag von dem der Wert geholt werden soll
//	Ergibt den Wert.
int CDataPointer::Get(unsigned uPos,unsigned uOffset) const
{
char	*pEntry;


	if(uPos>=m_uFieldCount)return 0;

	pEntry = (char*)m_pField[uPos];


return *(int*)(pEntry+uOffset);
}

//*****************************************************************************
//*
//*		GetQ
//*
//*****************************************************************************
//	Holt einen 64-Bit-Wert aus einen Eintrag
//	uPos		: Ist die Position des Eintrages
//	uOffset		: Ist der Offset im Eintrag von dem der Wert geholt werden soll
//	Ergibt den Wert.
i64 CDataPointer::GetQ(unsigned uPos,unsigned uOffset) const
{
char	*pEntry;


	if(uPos>=m_uFieldCount)return 0;

	pEntry = (char*)m_pField[uPos];


return *(i64*)(pEntry+uOffset);
}

//*****************************************************************************
//*
//*		Grow
//*
//*****************************************************************************
//	Allokiert die maximale Gre des Feldes. 
//	Wenn das Feld grer ist erfolgt keine Anderung.
//	iSize	: Ist die neue maximal Gre fr das Feld
//	Ergibt die aktuelle maximal Gre vom Feld.
int CDataPointer::Grow(int iSize)
{
void	**pFieldNew;



	if(iSize<=(int)m_uFieldMax)							// Ist Feld bereits gro genug
		{
		return m_uFieldMax;
		}
		
	pFieldNew = new lpvoid[iSize];

	if(m_uFieldCount)
		{
		memcpy(pFieldNew,m_pField,m_uFieldCount*sizeof(void*));
		}

	if(m_pOldPtr)										// Vorheriges Feld freigeben
		{
		delete m_pOldPtr;
		m_pOldPtr = 0;
		}

	m_pOldPtr      = m_pField;							// In Feld speichern
	m_pField	   = pFieldNew;
	m_uFieldMax    = iSize;


return m_uFieldMax;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Bereich im Feld.
//	pMem		: Gesuchter Bereich
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: Offset im Element
//	iLen		: Lnge des Bereiches ( <=0 fr bis zum Ende)
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataPointer::Find(const void *pMem,unsigned uFrom,unsigned uTo,int iLen,unsigned uOffset) const
{

	if(!pMem                )return -1;
	if(uFrom > m_uFieldCount)return -1;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		if(!memcmp((char*)m_pField[uFrom]+uOffset,pMem,iLen))return uFrom;
		}


return -1;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Bereich im Feld via Callback-Funktion.
//	pParam	: Erster Parameter der an die Vergleichsfunktion bergeben wird.
//	uFrom   : Ist die Startposition
//	uTo  	: Ist das Ende der Suche bei -1 die String Anzahl
//	pCmp	: Ist die Vergleichsfunktion. Mit ihr werden die Datenbereiche der
//			  Eintrge mit dem Parameter verglichen:
//				>0 Der Parameter ist grer  als der Eintrag
//				=0 Der Parameter ist gleich  mit dem Eintrag
//				<0 Der Parameter ist kleiner als der Eintrag
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataPointer::Find(const void *pParam,unsigned uFrom,unsigned uTo,int (__cdecl*pCmp)(const void*,const void*)) const
{


	if(uFrom > m_uFieldCount)return -1;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		if(!pCmp(pParam,m_pField[uFrom]))return uFrom;
		}



return -1;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht eine Zahl im Feld.
//	iValue		: Ist die gesuchter Zahl
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: uOffset im Element
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataPointer::Find(int iValue,unsigned uFrom,unsigned uTo,unsigned uOffset) const
{
int		 *pPtr;


	if(uFrom > m_uFieldCount)return -1;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		pPtr=(int*)(((char*)m_pField[uFrom])+uOffset);
		if(iValue==*pPtr)return uFrom;
		}


return -1;
}

//*****************************************************************************
//*
//*		FindQ
//*
//*****************************************************************************
//	Sucht eine 64-Bi-Zahl im Feld.
//	iValue		: Ist die gesuchter Zahl
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: uOffset im Element
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataPointer::FindQ(i64 iValue,unsigned uFrom,unsigned uTo,unsigned uOffset) const
{
i64		 *pPtr;


	if(uFrom > m_uFieldCount)return -1;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		pPtr=(i64*)(((char*)m_pField[uFrom])+uOffset);
		if(iValue==*pPtr)return uFrom;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFastQ
//*
//****************************************************************************
//  Sucht eine Zahl mit der Schnell-Sucht-Methode.
//	Die Liste muss sortiert sein.
//	iValue		: Ist die iValue nach der gesucht wird
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo die iValue gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataPointer::FindFastQ(i64 iValue,unsigned uStart,unsigned uEnd,unsigned uOffset,int iMode)const
{
int		 iHalf;
int		 iCmp;
i64		 iVal;


	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	uEnd--;

	if(iMode&1) for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(i64*)((char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=((u64)iValue<(u64)iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02) {uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}
	else for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(i64*)((char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=(iValue<iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;continue;}
					  uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//  Sucht eine Zahl mit der Schnell-Sucht-Methode.
//	Die Liste muss sortiert sein.
//	iValue		: Ist die iValue nach der gesucht wird
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo die iValue gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataPointer::FindFast(int iValue,unsigned uStart,unsigned uEnd,unsigned uOffset,int iMode)const
{
int		 iHalf,iCmp,iVal;


	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	uEnd--;

	if(iMode&1) for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(int*)( (char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=((unsigned)iValue<(unsigned)iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02) {uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}
	else for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(int*)( (char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=(iValue<iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;continue;}
					  uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}


return -1;
}


//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//  Sucht einen Speicherabschnitt mit der Schnell-Sucht-Methode
//	Die Liste muss sortiert sein
//	pMem		: Ist ein Zeiger auf den Speicherabschnitt
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	iLen		: Ist die Lnge des zu suchenden Speicherabschnitt
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo der Speicher gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataPointer::FindFast(void *pMem,unsigned uStart,unsigned uEnd,int iLen,unsigned uOffset,int iMode)const
{
int		 iHalf,iCmp;



	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	uEnd--;

	for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		iCmp=memcmp(pMem,(char*)m_pField[uStart+iHalf]+uOffset,iLen);

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//	Sucht einen Bereich mit der Schnell-Such-Methode und einer speziellen Funktion
//	Die Liste muss sortiert sein
//	pParam	: Erster Parameter der an die Vergleichsfunktion bergeben wird.
//	uStart  : Ist die Startposition
//	uEnd	: Ist das Ende der Suche bei -1 die String Anzahl
//	iMode	: Bit0 != 0 unsigned Vergleich
//			  Bit1 != 0 Erste  Position finden
//			  Bit2 != 0 Position hinter letzter suchen
//			  Bit3 != 0 Einfgeposition suchen
//	pCmp	: Ist die Vergleichsfunktion. Mit ihr werden die Datenbereiche der
//			  Eintrge mit dem Parameter verglichen:
//				>0 Der Parameter ist grer  als der Eintrag
//				=0 Der Parameter ist gleich  mit dem Eintrag
//				<0 Der Parameter ist kleiner als der Eintrag
//	Ergibt die Position wo der Text gefunden wurde bzw. -1 wenn nicht gefunden.
int	CDataPointer::FindFast(const void *pParam,unsigned uStart,unsigned uEnd,int iMode,int (__cdecl*pCmp)(const void*,const void*))const
{
int		 iHalf,iCmp;




	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	uEnd--;

	for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		iCmp=pCmp(pParam,m_pField[uStart+iHalf]);

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	uOffset		: Ist der Offset ab dem beim Sortieren verglichen wird.
//	iLen		: Ist die Byteanzahl die verglichen wird. (-1 fr bis zum iEnd)
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum iEnd sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataPointer::Sort(unsigned uOffset,int iLen,int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?

//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pPos;
char   *pPtr;

	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd+1;

		pPos        = m_pField[m];
		m_pField[m] = m_pField[u];
		m_pField[u] = pPos;

		pPtr  = (char*)m_pField[iStart];
		pPtr += uOffset;

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=memcmp(((char*)m_pField[u])+uOffset,pPtr,iLen);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=memcmp(((char*)m_pField[o])+uOffset,pPtr,iLen);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			pPos        = m_pField[u];
			m_pField[u] = m_pField[o];
			m_pField[o] = pPos;
			}

		pPos             = m_pField[iStart];
		m_pField[iStart] = m_pField[o];
		m_pField[o]      = pPos;

		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u<iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u<iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	pCmp		: Ist die Sortierfunktion vpm Typ int XXX(CDataField*,int p1,int p2)
//				  Ergibt	=0 ergibt wenn p1==p2
//							>0 ergibt wenn p1> p2
//							<0 ergibt wenn p1< p2
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataPointer::Sort(int (__cdecl *pCmp)(CDataPointer*,int,int),int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pPos;


	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;

		pPos        = m_pField[m];
		m_pField[m] = m_pField[u];
		m_pField[u] = pPos;

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=pCmp(this, u, iStart);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=pCmp(this, o, iStart);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			pPos        = m_pField[u];
			m_pField[u] = m_pField[o];
			m_pField[o] = pPos;
			}

		pPos             = m_pField[iStart];
		m_pField[iStart] = m_pField[o];
		m_pField[o     ] = pPos;

		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u < iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u < iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}
																// Eine Ebene absteigen
	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	pCmp		: Ist die Sortierfunktion vpm Typ int XXX(void *pParam,void *pPtr1,void *pPtr1)
//				  Ergibt	=0 ergibt wenn pPtr1==pPtr2
//							>0 ergibt wenn pPtr1> pPtr2
//							<0 ergibt wenn pPtr1< pPtr2
//	pParam		: Ist der User-Parameter fr die Sortierfunktion
//	iOffset		: Ist der Offset im Feld ab dem verglichen wird
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataPointer::Sort(int (__cdecl *pCmp)(void*,const void*,const void*),void *pParam,int iOffset,int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pMem;
void   *pPos;


	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;

		pPos        = m_pField[m];
		m_pField[m] = m_pField[u];
		m_pField[u] = pPos;
		pMem		= OFFSET_MEM(iStart,iOffset);

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=pCmp(pParam,OFFSET_MEM(u,iOffset),pMem);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=pCmp(pParam,OFFSET_MEM(o,iOffset),pMem);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			pPos        = m_pField[u];
			m_pField[u] = m_pField[o];
			m_pField[o] = pPos;
			}

		pPos             = m_pField[iStart];
		m_pField[iStart] = m_pField[o];
		m_pField[o     ] = pPos;

		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u < iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u < iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}
																// Eine Ebene absteigen
	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
//	uSize	: Ist die Gre eines Eintrages in Byte
//	uAdd	: Ist die Zahl der Eintrge um die das Feld  bei Betarf vergert
//			  wird. Bei Null erfolgt eine dynamische Vergrerung.
CDataField::CDataField(unsigned uSize,unsigned uAdd)
{

	m_uFieldAdd		= uAdd;
	m_uFieldSize	= uSize;
	m_uFieldCount	= 0;
	m_uFieldMax		= 0;
	m_pField		= 0;
	m_pOldPtr       = 0;

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDataField::~CDataField()
{

	m_uFieldCount = 0;

	if(m_pOldPtr)
		{
		delete m_pOldPtr;
		m_pOldPtr = 0;
		}

	if(m_pField)
		{
		delete m_pField;
		m_pField = 0;
		}

}


//*****************************************************************************
//*
//*		Len
//*
//*****************************************************************************
//	Stellt eine neue Feldgre ein. Das funktioniert nur wenn das Feld leer ist.
//	uSize	: Ist die neue Feldgre eines Eintrages in Byte
//			  Ist die Gre 0 so wird die Feldgre nicht verndert.
//	uAdd	: Ist die Zahl der Eintrge um die das Feld bei Betarf vergert
//			  wird. Bei Null erfolgt eine dynamische Vergrerung (+50%).
//			  Wenn kleiner 0 wird die Vergrerung nicht verndert.
//	Ergibt 1 wenn alles ok war bzw. 0 bei einem Fehler
int CDataField::Len(unsigned uSize,int iAdd)
{

	if(iAdd>=0)m_uFieldAdd=iAdd;
	if(uSize)
		{
		if(m_uFieldCount)return 0;
		m_uFieldSize=uSize;
		}

return 1;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein.
//	pData	: Ist der Zeiger auf das Array mit den einzufgenten Elementen.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die eingefgt werden sollen.
//	Ergibt die Einfgeposition.
int	CDataField::Add(const void *pData,unsigned uPos,int iNum)
{
char     *pFieldNew;
char     *pFieldOld;
int       iMaxNew;
int       iPosA;
int       iPosP;
int       iPosN;



	if(uPos>m_uFieldCount)uPos=m_uFieldCount;			// Position ok
	if(iNum<=0    )return uPos;							// Nichts einfgen ?
	if(iNum+m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+iNum)/m_uFieldAdd)+1;
				iMaxNew*=  m_uFieldAdd;		}
		else{	iMaxNew =((m_uFieldMax+iNum)*3)/2;		// Gre + 50%
			 if(iMaxNew<16)iMaxNew=16;	}

		iPosP = m_uFieldSize* uPos;
		iPosN = m_uFieldSize*(uPos+iNum);
		iPosA = m_uFieldSize* m_uFieldCount;

		if(m_pOldPtr)									// Vorherige Liste lschen
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		pFieldNew = new char[iMaxNew*m_uFieldSize];
		pFieldOld = (char*)m_pField;					// In Feld speichern

		memcpy(pFieldNew      ,pFieldOld      ,iPosP      );
		memcpy(pFieldNew+iPosN,pFieldOld+iPosP,iPosA-iPosP);
		memcpy(pFieldNew+iPosP,pData          ,iNum*m_uFieldSize);

		if(m_pOldPtr)									// Vorheriges Feld lschen
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr		= m_pField;
		m_pField        = pFieldNew;
		m_uFieldMax		= iMaxNew;
		m_uFieldCount  += iNum;

		return uPos;
		}

	iPosP = m_uFieldSize* uPos;
	iPosN = m_uFieldSize*(uPos+iNum);
	iPosA = m_uFieldSize* m_uFieldCount;

	memmove(((char*)m_pField)+iPosN,((char*)m_pField)+iPosP,iPosA-iPosP);
	memmove(((char*)m_pField)+iPosP,((char*)pData),iNum*m_uFieldSize);

	m_uFieldCount += iNum;



return uPos;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein.
//	pData	: Ist der Zeiger auf das Zeigerfeld mit den einzufgenten Elementen.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die eingefgt werden sollen.
//	Ergibt die Einfgeposition.
int	CDataField::Add(void **pData,unsigned uPos,int iNum)
{
char     *pFieldNew;
char     *pFieldOld;
int       iMaxNew;
int       iPosN;
int       iPosA;
int       iPosP;
int       iPos;



	if(uPos>m_uFieldCount)uPos=m_uFieldCount;			// Position ok
	if(iNum<=0  )return uPos;							// Nichts einfgen ?
	if(iNum+m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+iNum)/m_uFieldAdd)+1;
				iMaxNew*=  m_uFieldAdd;		}
		else{	iMaxNew =((m_uFieldMax+iNum)*3)/2;		// Gre + 50%
			 if(iMaxNew<16)iMaxNew=16;	}

		iPosP = m_uFieldSize* uPos;
		iPosN = m_uFieldSize*(uPos+iNum);
		iPosA = m_uFieldSize* m_uFieldCount;

		pFieldNew = new char[iMaxNew*m_uFieldSize];
		pFieldOld = (char*)m_pField;					// In Feld speichern

		memcpy(pFieldNew      ,pFieldOld      ,iPosP      );
		memcpy(pFieldNew+iPosN,pFieldOld+iPosP,iPosA-iPosP);

		for(iPos=0;iPos<iNum;iPos++)					// Elemente kopieren
			{
			memcpy(pFieldNew+iPosP,pData[iPos],m_uFieldSize);
			iPosP+=m_uFieldSize;
			}

		if(m_pOldPtr)									// Vorheriges Feld lschen
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr		= m_pField;
		m_pField		= pFieldNew;
		m_uFieldMax		= iMaxNew;
		m_uFieldCount  += iNum;

		return uPos;
		}

	iPosP = m_uFieldSize* uPos;
	iPosN = m_uFieldSize*(uPos+iNum);
	iPosA = m_uFieldSize* m_uFieldCount;

	memmove(((char*)m_pField)+iPosN,((char*)m_pField)+iPosP,iPosA-iPosP);

	for(iPos=0;iPos<iNum;iPos++)						// Elemente kopieren
		{
		memcpy(((char*)m_pField)+iPosP,pData[iPos],m_uFieldSize);
		iPosP += m_uFieldSize;
		}

	m_uFieldCount+=iNum;



return uPos;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein ohne Daten zu kopieren.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die eingefgt werden sollen.
//	pPos	: Hier wird die Einfgeposition gespeichert wenn nicht 0.
//	Ergibt einen Zeiger auf die eingefgten Felder.
void *CDataField::Add(unsigned uPos,int iNum,int *pPos)
{
char     *pFieldNew;
char     *pFieldOld;
int       iMaxNew;
int       iPosA;
int       iPosP;
int       iPosN;



	if(uPos>m_uFieldCount)uPos=m_uFieldCount;			// Position ok
	if(iNum<=0  )return 0;								// Nichts einfgen ?
	if(iNum+m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+iNum)/m_uFieldAdd)+1;
				iMaxNew*=  m_uFieldAdd;		}
		else{	iMaxNew =((m_uFieldMax+iNum)*3)/2;		// Gre + 50%
			 if(iMaxNew<16)iMaxNew=16;	}

		iPosP = m_uFieldSize* uPos;
		iPosN = m_uFieldSize*(uPos+iNum);
		iPosA = m_uFieldSize* m_uFieldCount;

		pFieldNew = new char[iMaxNew*m_uFieldSize];
		pFieldOld = (char*)m_pField;					// In Feld speichern

		memcpy(pFieldNew      ,pFieldOld      ,iPosP      );
		memcpy(pFieldNew+iPosN,pFieldOld+iPosP,iPosA-iPosP);

		if(m_pOldPtr)									// Vorheriges Feld lschen
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr	= m_pField;
		m_pField	= pFieldNew;
		m_uFieldMax = iMaxNew;
		}
	else{
		iPosP = m_uFieldSize* uPos;
		iPosN = m_uFieldSize*(uPos+iNum);
		iPosA = m_uFieldSize* m_uFieldCount;

		memmove(((char*)m_pField)+iPosN,((char*)m_pField)+iPosP,iPosA-iPosP);
		}

	m_uFieldCount+=iNum;

	if(pPos)*pPos=uPos;



return ((char*)m_pField)+iPosP;
}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
//	berschreibt ein oder meherer Elemente im Feld.
//	berzhlige Elementer werden am Ende des Feldes angehngt.
//	pData	: Ist der Zeiger auf das Array mit den neuen Elementen.
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die Eingefgt werden sollen.
//	Ergibt die Position ab der Elemente gendert wurden
int	CDataField::Set(const void *pData,unsigned uPos,int iNum)
{
char    *pPtr;
int      i;


	if(uPos>=m_uFieldCount)return Add(pData,uPos,iNum);	// Am Ende einfgen
	if(iNum<=0            )return uPos;					// Nichts einfgen ?

	pPtr=(char*)pData;

	   i=m_uFieldCount-uPos;
	if(i>iNum)i=iNum;
	if(i)memcpy(((char*)m_pField)+uPos*m_uFieldSize,pPtr,m_uFieldSize*i);

	if(iNum>i)Add(pPtr+i*m_uFieldSize,uPos+i,iNum-i);	// Die restlichen Elemente einfgen


return uPos;
}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
//	berschreibt ein oder meherer Elemente im Feld.
//	berzhlige Elementer werden am Ende des Feldes angehngt.
//	pData	: Ist der Zeiger auf das Zeigerfeld mit den neuen Elementen.
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die Eingefgt werden sollen.
//	Ergibt die Position ab der Elemente gendert wurden
int	CDataField::Set(void **pData,unsigned uPos,int iNum)
{
int i,iPosP;



	if(uPos>=m_uFieldCount)return Add(pData,uPos,iNum);	// Am Ende einfgen
	if(iNum<=0			  )return uPos;					// Nichts einfgen ?

	iPosP = uPos*m_uFieldSize;

	for(i=0;i<iNum;i++)									// Elemente kopieren
		{
		if(uPos+i<m_uFieldCount)break;
		memcpy(((char*)m_pField)+iPosP,pData[i],m_uFieldSize);
		iPosP+=m_uFieldSize;
		}

	if(iNum>i)Add(pData+i,uPos+i,iNum-i);				// Die restlichen Elemente einfgen


return uPos;
}


//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Lscht alle Eintrge in einem Bereich
//	uFrom	: Ist der Beginn des Bereiches. (erste Element das gelscht wird)
//	uTo		: Ist das Ende des Bereiches. (erste Element das nicht gelscht wird)
//	Ergibt die Anzahl der gelschten Elemente.
int	CDataField::Del(unsigned uFrom,unsigned uTo)
{
void   *pFieldNew;
int		iCount;
int		iSize;
int		iNum;



	if(uFrom>=m_uFieldCount)return 0;
	if(uTo  <=uFrom        )return 0;
	if(uTo  > m_uFieldCount)uTo=m_uFieldCount;

	iNum   = m_uFieldCount-uTo;
	iCount = uTo-uFrom;

	uFrom *= m_uFieldSize;
	uTo   *= m_uFieldSize;
	iNum  *= m_uFieldSize;

	m_uFieldCount  -= iCount;
	memmove(((char*)m_pField)+uFrom,((char*)m_pField)+uTo,iNum);

	if(m_uFieldCount<=0)							// Feld ganz lschen
		{
		if(m_pOldPtr)
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr	= m_pField;
		m_uFieldMax = 0;
		m_pField	= 0;

		return iCount;
		}

	if(m_uFieldAdd>0)								// Feld verkleinern
		{
		if(m_uFieldCount+m_uFieldAdd*2<=m_uFieldMax)
			{
  			m_uFieldMax = m_uFieldCount+m_uFieldAdd;
			iSize		= m_uFieldCount*m_uFieldSize;
			iNum		= m_uFieldMax  *m_uFieldSize;
			pFieldNew   = (void*)new char[iNum];

			memcpy(pFieldNew,m_pField,iSize);

			if(m_pOldPtr)
				{
				delete m_pOldPtr;
				m_pOldPtr = 0;
				}

			m_pOldPtr	= m_pField;
			m_pField	= pFieldNew;
			}
		}
	else{
		if(m_uFieldCount*2<=m_uFieldMax)
			{
  			m_uFieldMax =(m_uFieldCount*3)/2;
			iSize		= m_uFieldCount*m_uFieldSize;
			iNum		= m_uFieldMax  *m_uFieldSize;
			pFieldNew   = (void*)new char[iNum];

			memcpy(pFieldNew,m_pField,iSize);

			if(m_pOldPtr)
				{
				delete m_pOldPtr;
				m_pOldPtr = 0;
				}

			m_pOldPtr	= m_pField;
			m_pField	= pFieldNew;
			}
		}



return iCount;
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Kopiert den Inhalt eines Eintrages in einen Puffer
//	uPos		: Ist die Position des Eintrages
//	pTarget		: Ist der Zeiger auf den Puffer in den der Eintrag gespeichert wird.
//	Ergibt einen Zeiger auf das Element bzw. 0 bei einem Fehler.
void *CDataField::Get(unsigned uPos,void *pTarget) const
{


	if(uPos>=m_uFieldCount || !pTarget)return 0;

	memmove(pTarget,((char*)m_pField)+uPos*m_uFieldSize,m_uFieldSize);


return (void*)(((char*)m_pField)+uPos*m_uFieldSize);
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Holt einen Wert aus einen Eintrag
//	uPos		: Ist die Position des Eintrages
//	uOffset		: Ist der Offset im Eintrag von dem der Wert geholt werden soll
//	Ergibt den Wert.
int CDataField::Get(unsigned uPos,unsigned uOffset) const
{
char	*pEntry;


	if(uPos>=m_uFieldCount || uOffset+4>m_uFieldSize)return 0;

	pEntry = ((char*)m_pField)+uPos*m_uFieldSize;


return *(int*)(pEntry+uOffset);
}

//*****************************************************************************
//*
//*		GetQ
//*
//*****************************************************************************
//	Holt einen 64-Bit-Wert aus einen Eintrag
//	uPos		: Ist die Position des Eintrages
//	uOffset		: Ist der Offset im Eintrag von dem der Wert geholt werden soll
//	Ergibt den Wert.
i64 CDataField::GetQ(unsigned uPos,unsigned uOffset) const
{
char	*pEntry;


	if(uPos>=m_uFieldCount || uOffset+8>m_uFieldSize)return 0;

	pEntry = ((char*)m_pField)+uPos*m_uFieldSize;


return *(i64*)(pEntry+uOffset);
}

//*****************************************************************************
//*
//*		Grow
//*
//*****************************************************************************
//	Allokiert die maximale Gre des Feldes. 
//	Wenn das Feld grer ist erfolgt keine Anderung.
//	iSize	: Ist die neue maximal Gre fr das Feld
//	Ergibt die aktuelle maximal Gre vom Feld.
int CDataField::Grow(int iSize)
{
char     *pFieldNew;
char     *pFieldOld;



	if(iSize<=(int)m_uFieldMax)							// Ist das Feld gro genug
		{
		return m_uFieldMax;	
		}
		
		pFieldNew = new char[iSize*m_uFieldSize];
	if(!pFieldNew)
		{
		return 0;	
		}
	
	pFieldOld = (char*)m_pField;						
	
	if(m_uFieldCount)									// In Feld kopieren
		{												
		memcpy(pFieldNew,pFieldOld,m_uFieldCount*m_uFieldSize);
		}

	if(m_pOldPtr)										// Vorheriges Feld lschen
		{
		delete m_pOldPtr;
		m_pOldPtr = 0;
		}

	m_pOldPtr	= m_pField;
	m_pField	= pFieldNew;
	m_uFieldMax = iSize;


return m_uFieldMax;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Bereich im Feld
//	pMem		: Zeiger auf den gesuchten Bereich
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: Offset im Element
//	iLen		: Lnge des Bereiches (<=0 steht fr fr bis zum Ende)
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataField::Find(const void *pMem,unsigned uFrom,unsigned uTo,int iLen,unsigned uOffset) const
{

	if(pMem==0                  )return -1;
	if(uFrom  > m_uFieldCount   )return -1;
	if(uOffset>=m_uFieldSize    )return -1;
	if(iLen<=0                  )iLen=m_uFieldSize-uOffset;
	if(iLen+uOffset>m_uFieldSize)return -1;
	if(uTo>m_uFieldCount        )uTo=m_uFieldCount;


	uFrom = uFrom*m_uFieldSize+uOffset;
	uTo   = uTo  *m_uFieldSize+uOffset;

	for(;uFrom<uTo;uFrom+=m_uFieldSize)
		{
		if(!memcmp(((char*)m_pField)+uFrom,pMem,iLen))return uFrom/m_uFieldSize;
		}


return -1;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Bereich im Feld via Callback-Funktion.
//	pParam	: Erster Parameter der an die Vergleichsfunktion bergeben wird.
//	uFrom   : Ist die Startposition
//	uTo  	: Ist das Ende der Suche bei -1 die String Anzahl
//	pCmp	: Ist die Vergleichsfunktion. Mit ihr werden die Datenbereiche der
//			  Eintrge mit dem Parameter verglichen:
//				>0 Der Parameter ist grer  als der Eintrag
//				=0 Der Parameter ist gleich  mit dem Eintrag
//				<0 Der Parameter ist kleiner als der Eintrag
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataField::Find(const void *pParam,unsigned uFrom,unsigned uTo,int (__cdecl*pCmp)(const void*,const void*)) const
{

	if(uFrom > m_uFieldCount)return -1;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;

	uFrom *= m_uFieldSize;
	uTo   *= m_uFieldSize;

	for(;uFrom<uTo;uFrom+=m_uFieldSize)
		{
		if(!pCmp(pParam,((char*)m_pField)+uFrom))return uFrom/m_uFieldSize;
		}


return -1;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht eine Zahl im Feld
//	iValue		: Gesuchter Bereich
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: Offset der Zahl im Element
//	Ergibt die gefundene Position bzw -1 bei nicht Finden
int CDataField::Find(int iValue,unsigned uFrom,unsigned uTo,unsigned uOffset) const
{
int		 *pPtr;


	if(uFrom              >m_uFieldCount)return -1;
	if(uOffset+sizeof(int)>m_uFieldSize )return -1;
	if(uTo                >m_uFieldCount)uTo=m_uFieldCount;


	uFrom = uFrom*m_uFieldSize+uOffset;
	uTo   = uTo  *m_uFieldSize+uOffset;


	for(;uFrom<uTo;uFrom++)
		{
		pPtr=(int*)(((char*)m_pField)+uFrom);
		if(iValue==*pPtr)return uFrom/m_uFieldSize;
		}



return -1;
}


//*****************************************************************************
//*
//*		FindQ
//*
//*****************************************************************************
//	Sucht eine Zahl im Feld
//	iValue		: Gesuchter Bereich
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: Offset der Zahl im Element
//	Ergibt die gefundene Position bzw -1 bei nicht Finden
int CDataField::FindQ(i64 iValue,unsigned uFrom,unsigned uTo,unsigned uOffset) const
{
i64		 *pPtr;


	if(uFrom              >m_uFieldCount)return -1;
	if(uOffset+sizeof(int)>m_uFieldSize )return -1;
	if(uTo                >m_uFieldCount)uTo=m_uFieldCount;


	uFrom = uFrom*m_uFieldSize+uOffset;
	uTo   = uTo  *m_uFieldSize+uOffset;


	for(;uFrom<uTo;uFrom++)
		{
		pPtr=(i64*)(((char*)m_pField)+uFrom);
		if(iValue==*pPtr)return uFrom/m_uFieldSize;
		}



return -1;
}

//****************************************************************************
//*
//*		FindFastQ
//*
//****************************************************************************
//  Sucht eine Zahl mit der Schnell-Sucht-Methode
//	Die Liste muss dafr sortiert sein
//	iValue		: Ist die iValue nach der gesucht wird
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo die iValue gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataField::FindFastQ(i64 iValue,unsigned uStart,unsigned uEnd,unsigned uOffset,int iMode)const
{
int		iHalf;
int		iCmp;
i64		iVal;
char   *iPos;


	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	if(uOffset+sizeof(int)>m_uFieldSize)					// Ist der Datenbereich gro genug
		{
		return -1;
		}


	iPos=(char*)m_pField+uOffset;
	uEnd--;

	if(iMode&1) for(;;)
		{
		iHalf = (uEnd-uStart+1)>>1;

		   iVal=*(i64*)(iPos+(uStart+iHalf)*m_uFieldSize);
		if(iVal==iValue)iCmp=0;
		else		    iCmp=((u64)iValue<(u64)iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}
	else for(;;)
		{
		iHalf = (uEnd-uStart+1)>>1;

		   iVal=*(i64*)(iPos+(uStart+iHalf)*m_uFieldSize);
		if(iVal==iValue)iCmp=0;
		else		    iCmp=(iValue<iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}
		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;}

		iMode|=0x08;
		}


return -1;
}


//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//  Sucht eine Zahl mit der Schnell-Sucht-Methode
//	Die Liste muss dafr sortiert sein
//	iValue		: Ist die iValue nach der gesucht wird
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo die iValue gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataField::FindFast(int iValue,unsigned uStart,unsigned uEnd,unsigned uOffset,int iMode)const
{
int		 iHalf,iCmp,iVal;
char    *iPos;


	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	if(uOffset+sizeof(int)>m_uFieldSize)					// Ist der Datenbereich gro genug
		{
		return -1;
		}


	iPos=(char*)m_pField+uOffset;
	uEnd--;

	if(iMode&1) for(;;)
		{
		iHalf = (uEnd-uStart+1)>>1;

		   iVal=*(int*)(iPos+(uStart+iHalf)*m_uFieldSize);
		if(iVal==iValue)iCmp=0;
		else		  iCmp=((unsigned)iValue<(unsigned)iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}
	else for(;;)
		{
		iHalf = (uEnd-uStart+1)>>1;

		   iVal=*(int*)(iPos+(uStart+iHalf)*m_uFieldSize);
		if(iVal==iValue)iCmp=0;
		else		    iCmp=(iValue<iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}
		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;}

		iMode|=0x08;
		}


return -1;
}


//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//  Sucht einen Speicherabschnitt mit der Schnell-Sucht-Methode
//	Die Liste muss dafr sortiert sein
//	pMem		: Ist ein Zeiger auf den Speicherabschnitt
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	iLen		: Ist die Lnge des zu suchenden Speicherabschnitt (-1=bis zum Ende)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo der Speicher gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataField::FindFast(void *pMem,unsigned uStart,unsigned uEnd,int iLen,unsigned uOffset,int iMode)const
{
int		 iHalf,iCmp;
char    *pPos;



	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd        > m_uFieldCount)uEnd=m_uFieldCount;		// Ist Ende hinter der Anzahl
	if(uEnd	       <=uStart       )return -1;				// Ende vor Start ?
	if(uOffset     >=m_uFieldSize )return -1;				// Ist der Datenbereich gro genug
	if(iLen        <=0            )iLen=m_uFieldSize-uOffset;
	if(iLen+uOffset>m_uFieldSize  )return -1;


	pPos = (char*)m_pField+uOffset;
	uEnd--;

	for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		iCmp=memcmp(pMem,pPos+(uStart+iHalf)*m_uFieldSize,iLen);

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//	Sucht einen Bereich mit der Schnell-Such-Methode und einer speziellen Funktion
//	Die Liste muss sortiert sein
//	pParam	: Erster Parameter der an die Vergleichsfunktion bergeben wird.
//	uStart  : Ist die Startposition
//	uEnd	: Ist das Ende der Suche bei -1 die String Anzahl
//	iMode	: Bit0 != 0 unsigned Vergleich
//			  Bit1 != 0 Erste  Position finden
//			  Bit2 != 0 Position hinter letzter suchen
//			  Bit3 != 0 Einfgeposition suchen
//	pCmp	: Ist die Vergleichsfunktion. Mit ihr werden die Datenbereiche der
//			  Eintrge mit dem Parameter verglichen:
//				>0 Der Parameter ist grer  als der Eintrag
//				=0 Der Parameter ist gleich  mit dem Eintrag
//				<0 Der Parameter ist kleiner als der Eintrag
//	Ergibt die Position wo der Text gefunden wurde bzw. -1 wenn nicht gefunden.
int	CDataField::FindFast(const void *pParam,unsigned uStart,unsigned uEnd,int iMode,int (__cdecl*pCmp)(const void*,const void*))const
{
int		 iHalf,iCmp;
char    *pPos;



	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	pPos = (char*)m_pField;
	uEnd--;

	for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		iCmp=pCmp(pParam,pPos+(uStart+iHalf)*m_uFieldSize);

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	uOffset		: Ist der Offset ab dem beim Sortieren verglichen wird.
//	iLen		: Ist die Byteanzahl die verglichen wird. (-1 fr bis zum Ende)
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataField::Sort(unsigned uOffset,int iLen,int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;									// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;					//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//	*
	if(iEnd    <=iStart )return;							// End vor Start ?

	if(uOffset    >=m_uFieldSize)return;					// Ist der Offset zu gro
	if(iLen <0)iLen=m_uFieldSize-uOffset;
	if(uOffset+iLen>m_uFieldSize)iLen=m_uFieldSize-uOffset;


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c,iNum,iMask;
int		aMenU[30],aMenO[30];
int		iLevel;
char   *pPtr;


	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;

	iNum  = m_uFieldSize>>2;
	iMask =(m_uFieldSize&3)? iMask=0xFFFFFFFF<<((m_uFieldSize&3)*8):0;

	for(;;)
		{
		m = (iStart + iEnd)>>1;								// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;

		XCHANGE_MEM(m,u);

		pPtr  = ((char*)m_pField)+iStart*m_uFieldSize;
		pPtr += uOffset;

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=memcmp((((char*)m_pField)+u*m_uFieldSize)+uOffset,pPtr,iLen);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=memcmp((((char*)m_pField)+o*m_uFieldSize)+uOffset,pPtr,iLen);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			XCHANGE_MEM(o,u);
			}

		XCHANGE_MEM(iStart,o);


		if(o-1-iStart >= iEnd-u )
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u<iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u<iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	pCmp		: Ist die Sortierfunktion vpm Typ int XXX(CDataField*,int p1,int p2)
//				  Ergibt	=0 ergibt wenn p1==p2
//							>0 ergibt wenn p1> p2
//							<0 ergibt wenn p1< p2
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataField::Sort(int (__cdecl *pCmp)(CDataField*,int,int),int iStart,int iEnd,int iDir)
{


	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c,iNum,iMask;
int		aMenU[30],aMenO[30];
int		iLevel;


	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;

	iNum = m_uFieldSize>>2;
	iMask=(m_uFieldSize&3)? iMask=0xFFFFFFFF<<((m_uFieldSize&3)*8):0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;


		XCHANGE_MEM(m,u);

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=pCmp(this, u, iStart);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=pCmp(this, o, iStart);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			XCHANGE_MEM(o,u);
			}

		XCHANGE_MEM(iStart,o);


		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u<iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u<iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}


}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	pCmp		: Ist die Sortierfunktion vpm Typ int XXX(void *pParam,void *pPtr1,void *pPtr1)
//				  Ergibt	=0 ergibt wenn pPtr1==pPtr2
//							>0 ergibt wenn pPtr1> pPtr2
//							<0 ergibt wenn pPtr1< pPtr2
//	pParam		: Ist der User-Parameter fr die Sortierfunktion
//	iOffset		: Ist der Offset im Feld ab dem verglichen wird
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataField::Sort(int (__cdecl *pCmp)(void*,const void*,const void*),void *pParam,int iOffset,int iStart,int iEnd,int iDir)
{


	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c,iNum,iMask;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pMem;

	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;

	iNum = m_uFieldSize>>2;
	iMask=(m_uFieldSize&3)? iMask=0xFFFFFFFF<<((m_uFieldSize&3)*8):0;
	pMem = OFFSET_PTR(iStart,iOffset);


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;


		XCHANGE_MEM(m,u);

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=pCmp(pParam,OFFSET_PTR(u,iOffset),pMem);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=pCmp(pParam,OFFSET_PTR(o,iOffset),pMem);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			XCHANGE_MEM(o,u);
			}

		XCHANGE_MEM(iStart,o);


		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u<iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u<iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}


}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
//	uSize	: Ist die Gre eines Eintrages in Byte
//	uAdd	: Ist die Zahl der Eintrge um die das Feld  bei Betarf vergert
//			  wird. Bei Null erfolgt eine dynamische Vergrerung.
CDataList::CDataList(unsigned uSize,unsigned iAdd)
{
	m_uFieldAdd   = iAdd;
	m_uFieldSize  = uSize;
	m_uFieldCount = 0;
	m_uFieldMax	  = 0;
	m_pField	  = 0;
	m_pOldPtr     = 0;
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDataList::~CDataList()
{
int i,iNum;


	iNum = m_uFieldCount;
		   m_uFieldCount = 0;

	for(i=0;i<iNum;i++)delete m_pField[i];

	if(m_pOldPtr)
		{
		delete m_pOldPtr;
		m_pOldPtr = 0;
		}

	if(m_pField)
		{
		delete m_pField;
		m_pField = 0;
		}

}

//*****************************************************************************
//*
//*		Len
//*
//*****************************************************************************
//	Stellt eine neue Feldgre ein. Das funktioniert nur wenn das Feld leer ist.
//	uSize	: Ist die neue Feldgre eines Eintrages in Byte
//			  Ist die Gre 0 so wird die Feldgre nicht verndert.
//	uAdd	: Ist die Zahl der Eintrge um die das Feld bei Betarf vergert
//			  wird. Bei Null erfolgt eine dynamische Vergrerung (+50%).
//			  Wenn kleiner 0 wird die Vergrerung nicht verndert.
//	Ergibt 1 wenn alles ok war bzw. 0 bei einem Fehler
int CDataList::Len(unsigned uSize,int iAdd)
{

	if(iAdd>=0)
		{
		m_uFieldAdd=iAdd;
		}

	if(uSize)
		{
		if(m_uFieldCount)return 0;
		m_uFieldSize=uSize;
		}


return 1;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein.
//	Die Datenfelder werden dabei umkopiert.
//	pData	: Ist der Zeiger auf das Array mit den einzufgenten Elementen.
//			  Von hier werden die Daten in die neuen Eintrge kopiert.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die eingefgt werden sollen.
//	Ergibt die Einfgeposition.
int	CDataList::Add(const void *pData,unsigned uPos,int iNum)
{
char     *pPtr=(char*)pData;
void	**pFieldNew,*pNew;
int       iMaxNew,i;


	if(uPos>m_uFieldCount)uPos=m_uFieldCount;			// Position ok
	if(iNum<=0    )return uPos;							// Nichts einfgen ?
	if(iNum+m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+iNum)/m_uFieldAdd)+1;
			 		    iMaxNew*=  m_uFieldAdd;		}
		else{		    iMaxNew =((m_uFieldMax+iNum)*3)/2;// Gre + 50%
			         if(iMaxNew<16)iMaxNew=16;	}


		pFieldNew = new lpvoid[iMaxNew];

		memcpy(pFieldNew           ,m_pField    ,               uPos *sizeof(void*));
		memcpy(pFieldNew+uPos+iNum,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

		for(i=0;i<iNum;i++)								// Elemente einfgen
			{
			pNew  = new char[m_uFieldSize];
			memcpy(pNew,pPtr,m_uFieldSize);
			pFieldNew[uPos+i]=pNew;
			pPtr += m_uFieldSize;
			}

		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr		= m_pField;						// In Feld speichern
		m_pField		= pFieldNew;
		m_uFieldMax		= iMaxNew;
		m_uFieldCount  += iNum;

		return uPos;
		}

	memmove(m_pField+uPos+iNum,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

	for(i=0;i<iNum;i++)									// Elemente einfgen
		{
		pNew  = new char[m_uFieldSize];
		memcpy(pNew,pPtr,m_uFieldSize);
		m_pField[uPos+i]=pNew;
		pPtr += m_uFieldSize;
		}

	m_uFieldCount += iNum;


return uPos;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein oder meherer Elemente ins Feld ein. 
//	Die Datenfelder werden dabei umkopiert.
//	pData	: Ist der Zeiger auf das Zeigerfeld mit den einzufgenten Elementen.
//			  Von hier werden die Daten in die neuen Eintrge kopiert.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die eingefgt werden sollen.
//	Ergibt die Einfgeposition.
int	CDataList::Add(void **pData,unsigned uPos,int iNum)
{
void	**pFieldNew,*pNew;
int       iMaxNew,i;


	if(uPos>m_uFieldCount)								// Position ok
		{
		uPos = m_uFieldCount;
		}


	if(iNum<=0)											// Nichts einfgen ?
		{
		return uPos;							
		}


	if(iNum+m_uFieldCount>m_uFieldMax)					// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+iNum)/m_uFieldAdd)+1;
					    iMaxNew*=  m_uFieldAdd;		}
		else{		    iMaxNew =((m_uFieldMax+iNum)*3)/2;	// Gre + 50%
				     if(iMaxNew<16)iMaxNew=16;	}

		pFieldNew = new lpvoid[iMaxNew];

		memcpy(pFieldNew          ,m_pField     ,               uPos *sizeof(void*));
		memcpy(pFieldNew+uPos+iNum,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

		for(i=0;i<iNum;i++)								// Elemente einfgen
			{
			pNew      = new char[m_uFieldSize];
			memcpy(pNew,pData[i],m_uFieldSize);
			pFieldNew[uPos+i]=pNew;
			}

		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr		= m_pField;						// In Feld speichern
		m_pField		= pFieldNew;
		m_uFieldMax		= iMaxNew;
		m_uFieldCount  += iNum;

		return uPos;
		}

	memmove(m_pField+uPos+iNum,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

	for(i=0;i<iNum;i++)									// Elemente einfgen
		{
		pNew      = new char[m_uFieldSize];
		memcpy(pNew,pData[i],m_uFieldSize);
		m_pField[uPos+i]=pNew;
		}

	m_uFieldCount+=iNum;



return uPos;
}

//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Fgt ein Element ins Feld ein, ohne Daten zu kopieren.
//	Das neue Datenfeld wird automatisch allokiert ohne Initialisierung.
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	pPos	: Hier wird die Einfgeposition gespeichert wenn nicht 0.
//	Ergibt einen Zeiger auf das eingefgten Feld.
void *CDataList::Add(unsigned uPos,int *pPos)
{
void	**pFieldNew,*pNew;
int       iMaxNew;


	if(uPos>m_uFieldCount)								// Position ok
		{
		uPos = m_uFieldCount;
		}


	if(m_uFieldCount>=m_uFieldMax)						// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+1)/m_uFieldAdd)+1;
			 		    iMaxNew*=  m_uFieldAdd;		}
		else{		    iMaxNew = (m_uFieldMax*3)/2;	// Gre + 50%
			         if(iMaxNew<16)iMaxNew=16;	}


		pFieldNew = new lpvoid[iMaxNew];

		memcpy(pFieldNew       ,m_pField     ,               uPos *sizeof(void*));
		memcpy(pFieldNew+uPos+1,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

		pNew = new char[m_uFieldSize];
		pFieldNew[uPos] = pNew;

		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr		= m_pField;						// In Feld speichern
		m_pField		= pFieldNew;
		m_uFieldMax		= iMaxNew;
		m_uFieldCount  += 1;

		if(pPos)*pPos=uPos;

		return pNew;
		}


	memmove(m_pField+uPos+1,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

	pNew = new char[m_uFieldSize];
	m_pField[uPos] = pNew;
	m_uFieldCount++;

	if(pPos)*pPos=uPos;



return pNew;
}

//*****************************************************************************
//*
//*		AddEx
//*
//*****************************************************************************
//	Fgt ein einzelnes Element ins Feld ein, und setzt den Zeiger direkt.
//	Das neue Element muss zuvor mit Alloc() erstellt worden sein.
//	pEntry	: Ist der Zeiger auf das Element das eingefgt werden soll.
//			  Der Eintrag muss mit Alloc erstellt worden sein.	
//	uPos	: Ist die Einfgeposition
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	Ergibt die Einfgeposition.
int CDataList::AddEx(const void *pEntry,unsigned uPos)
{
void	**pFieldNew;
int       iMaxNew;


	if(uPos>m_uFieldCount)								// Position ok
		{
		uPos = m_uFieldCount;
		}
	
	
	if(m_uFieldCount>=m_uFieldMax)						// Ist Feld zu klein
		{
		if(m_uFieldAdd){iMaxNew =((m_uFieldMax+1)/m_uFieldAdd)+1;
			 		    iMaxNew*=  m_uFieldAdd;		}
		else{		    iMaxNew = (m_uFieldMax*3)/2;	// Gre + 50%
			         if(iMaxNew<16)iMaxNew=16;	}


		pFieldNew = new lpvoid[iMaxNew];

		memcpy(pFieldNew       ,m_pField     ,               uPos *sizeof(void*));
		memcpy(pFieldNew+uPos+1,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

		pFieldNew[uPos] = (void*)pEntry;

		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr		= m_pField;						// In Feld speichern
		m_pField		= pFieldNew;
		m_uFieldMax		= iMaxNew;
		m_uFieldCount  += 1;

		return uPos;
		}


	memmove(m_pField+uPos+1,m_pField+uPos,(m_uFieldCount-uPos)*sizeof(void*));

	m_pField[uPos] = (void*)pEntry;
	m_uFieldCount++;




return uPos;
}


//*****************************************************************************
//*
//*		SetEx
//*
//*****************************************************************************
//	berschreibt einen Elementzeiger im Feld.
//	pEnty	: Ist der Zeiger auf den neuen Eintrag.
//			  Der Eintrag muss mit Alloc erstellt worden sein.	
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende eingefgt.
//	Ergibt den vorherigen Zeiger vom Eintrag, oder NULL beim Einfgen.
void *CDataList::SetEx(const void *pEntry,unsigned uPos)
{
void	*pOldEntry;


	if(uPos>m_uFieldCount)								// Position ok
		{
		AddEx(pEntry,m_uFieldCount);
		return 0;
		}

	pOldEntry		= m_pField[uPos];					// Neuen Eintrag setzen
	m_pField[uPos]	= (void*)pEntry;


return pOldEntry;
}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
//	berschreibt ein oder meherer Elemente im Feld.
//	berzhlige Elementer werden am Ende des Feldes angehngt.
//	pData	: Ist der Zeiger auf das Array mit den neuen Elementen.
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die Eingefgt werden sollen.
//	Ergibt die Position ab der Elemente gendert wurden.
int	CDataList::Set(const void *pData,unsigned uPos,int iNum)
{
char    *pPtr;
unsigned i;



	if(uPos>=m_uFieldCount)return Add(pData,uPos,iNum);	// Am Ende einfgen
	if(iNum<=0            )return uPos;					// Nichts einfgen ?

	pPtr = (char*)pData;

	for(i=uPos;i<m_uFieldCount;iNum--,i++)
		{
		memcpy(m_pField[i],pPtr,m_uFieldSize);
		pPtr += m_uFieldSize;
		}

	if(iNum>0)Add(pPtr,i,iNum);							// Die restlichen Elemente einfgen



return uPos;
}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
//	berschreibt ein oder meherer Elemente im Feld.
//	berzhlige Elementer werden am Ende des Feldes angehngt.
//	pData	: Ist der Zeiger auf das Zeigerfeld mit den neuen Elementen.
//	uPos	: Ist die Position ab der die Elementen berschreiben werden
//			  Wenn die Position zu hoch ist wird das Feldende benutzt.
//	iNum	: Ist die Anzahl der Elemente die Eingefgt werden sollen.
//	Ergibt die Position ab der Elemente gendert wurden
int	CDataList::Set(void **pData,unsigned uPos,int iNum)
{
unsigned i;



	if(uPos>=m_uFieldCount)return Add(pData,uPos,iNum);	// Am Ende einfgen
	if(iNum<=0            )return uPos;					// Nichts einfgen ?


	for(i=uPos;i<m_uFieldCount;iNum--,i++)
		{
		memcpy(m_pField[i],*pData,m_uFieldSize);
		pData++;
		}

	if(iNum>0)Add(pData,i,iNum);						// Die restlichen Elemente einfgen



return uPos;
}


//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Lscht alle Eintrge in einem Bereich
//	uFrom	: Ist der Beginn des Bereiches. (erste Element das gelscht wird)
//	uTo		: Ist das Ende des Bereiches. (erste Element das nicht gelscht wird)
//	Ergibt die Anzahl der gelschten Elemente.
int	CDataList::Del(unsigned uFrom,unsigned uTo)
{
void 	  **pFieldNew;
void	   *pEntry;
int			iCount;
int			iNum;
unsigned	uPos;



	if(uFrom >=m_uFieldCount)return 0;					// Position prfen
	if(uTo   <=uFrom        )return 0;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;


	iCount		   = m_uFieldCount;
	iNum		   = uTo-uFrom;
	m_uFieldCount -= iNum;


	for(uPos=uFrom;uPos<uTo;uPos++)						// Eintrge lschen
		{
		pEntry = m_pField[uPos];
		if(pEntry)
			{
			delete pEntry;
			m_pField[uPos] = 0;
			}
		}

	memmove(m_pField+uFrom,m_pField+uTo,(iCount-uTo)*sizeof(void*));

	if(m_uFieldCount<=0)								// Ganzes Feld lschen
		{
		if(m_pOldPtr)									// Vorheriges Feld freigeben
			{
			delete m_pOldPtr;
			m_pOldPtr = 0;
			}

		m_pOldPtr	= m_pField;
		m_uFieldMax = 0;
		m_pField	= 0;
		}
	else if(m_uFieldAdd>0)								// Feld verkleinern
		{
		if(m_uFieldCount+m_uFieldAdd*4<=m_uFieldMax)
			{
			m_uFieldMax = m_uFieldCount+m_uFieldAdd;
			pFieldNew   = new lpvoid[m_uFieldMax];

			memcpy(pFieldNew,m_pField,m_uFieldCount*sizeof(lpvoid));

			if(m_pOldPtr)								// Vorheriges Feld freigeben
				{
				delete m_pOldPtr;
				m_pOldPtr = 0;
				}

			m_pOldPtr	= m_pField;						// In Feld speichern
			m_pField	= pFieldNew;
			}
		}
	else{
		if(m_uFieldCount*4<=m_uFieldMax)
			{
  			m_uFieldMax = (m_uFieldCount*3)/2;
			pFieldNew   = new lpvoid[m_uFieldMax];

			memcpy(pFieldNew,m_pField,m_uFieldCount*sizeof(lpvoid));

			if(m_pOldPtr)								// Vorheriges Feld freigeben
				{
				delete m_pOldPtr;
				m_pOldPtr = 0;
				}

			m_pOldPtr	= m_pField;						// In Feld speichern
			m_pField	= pFieldNew;
			}
		}


return iNum;
}

//*****************************************************************************
//*
//*		Peek
//*
//*****************************************************************************
//	Lscht eine einzelnen Eintrag aus der Liste ohne den Eintrag zu deallokieren.
//	Dieser Eintrag muss mit Free() spter deallokiert werden.
//	uPos	: Ist die Position des Eintrages.
//	Ergibt eine Zeiger auf den Eintrag, oder NULL bei einem Fehler.
void *CDataList::Peek(unsigned uPos)
{
void	   *pEntry;


	if(uPos>=m_uFieldCount)return 0;					// Position prfen

	pEntry			= m_pField[uPos];
	m_pField[uPos]	= 0;
	
	Del(uPos,uPos+1);


return pEntry;
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Kopiert den Inhalt eines Eintrages in einen Puffer
//	uPos		: Ist die Position des Eintrages
//	pTarget		: Ist der Zeiger auf den Puffer in den der Eintrag gespeichert wird.
//	Ergibt einen Zeiger auf das Element bzw. 0 bei einem Fehler.
void *CDataList::Get(unsigned uPos,void *pTarget) const
{


	if(uPos>=m_uFieldCount || !pTarget)return 0;

	memcpy(pTarget,m_pField[uPos],m_uFieldSize);


return m_pField[uPos];
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Holt einen Wert aus einen Eintrag
//	uPos		: Ist die Position des Eintrages
//	uOffset		: Ist der Offset im Eintrag von dem der Wert geholt werden soll
//	Ergibt den Wert.
int CDataList::Get(unsigned uPos,unsigned uOffset) const
{
char	*pEntry;


	if(uPos>=m_uFieldCount || uOffset+4>m_uFieldSize)return 0;

	pEntry = (char*)m_pField[uPos];


return *(int*)(pEntry+uOffset);
}

//*****************************************************************************
//*
//*		GetQ
//*
//*****************************************************************************
//	Holt einen 64-Bit-Wert aus einen Eintrag
//	uPos		: Ist die Position des Eintrages
//	uOffset		: Ist der Offset im Eintrag von dem der Wert geholt werden soll
//	Ergibt den Wert.
i64 CDataList::GetQ(unsigned uPos,unsigned uOffset) const
{
char	*pEntry;


	if(uPos>=m_uFieldCount || uOffset+8>m_uFieldSize)return 0;

	pEntry = (char*)m_pField[uPos];


return *(i64*)(pEntry+uOffset);
}

//*****************************************************************************
//*
//*		Grow
//*
//*****************************************************************************
//	Allokiert die maximale Gre des Feldes. 
//	Wenn das Feld grer ist erfolgt keine Anderung.
//	iSize	: Ist die neue maximal Gre fr das Feld
//	Ergibt die aktuelle maximal Gre vom Feld.
int CDataList::Grow(int iSize)
{
void	**pFieldNew;



	if(iSize<=(int)m_uFieldMax)							// Ist das Feld bereits gro genug
		{
		return m_uFieldMax;
		}
		
		pFieldNew = new lpvoid[iSize];
	if(!pFieldNew)
		{
		return 0;
		}
		
	if(m_uFieldCount)
		{
		memcpy(pFieldNew,m_pField,m_uFieldCount*sizeof(void*));
		}

	if(m_pOldPtr)										// Vorheriges Feld freigeben
		{
		delete m_pOldPtr;
		m_pOldPtr = 0;
		}

	m_pOldPtr		= m_pField;							// In Feld speichern
	m_pField		= pFieldNew;
	m_uFieldMax		= iSize;



return m_uFieldMax;
}


//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Bereich im Feld.
//	pMem		: Gesuchter Bereich
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: Offset im Element
//	iLen		: Lnge des Bereiches ( <=0 fr bis zum Ende)
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataList::Find(const void *pMem,unsigned uFrom,unsigned uTo,int iLen,unsigned uOffset) const
{

	if(!pMem                     )return -1;
	if(uFrom      > m_uFieldCount)return -1;
	if(uOffset    >=m_uFieldSize )return -1;
	if(iLen<=0                   )iLen=m_uFieldSize-uOffset;
	if(iLen+uOffset>m_uFieldSize )return -1;
	if(uTo         >m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		if(!memcmp((char*)m_pField[uFrom]+uOffset,pMem,iLen))return uFrom;
		}


return -1;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Bereich im Feld via Callback-Funktion.
//	pParam	: Erster Parameter der an die Vergleichsfunktion bergeben wird.
//	uFrom   : Ist die Startposition
//	uTo  	: Ist das Ende der Suche bei -1 die String Anzahl
//	pCmp	: Ist die Vergleichsfunktion. Mit ihr werden die Datenbereiche der
//			  Eintrge mit dem Parameter verglichen:
//				>0 Der Parameter ist grer  als der Eintrag
//				=0 Der Parameter ist gleich  mit dem Eintrag
//				<0 Der Parameter ist kleiner als der Eintrag
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataList::Find(const void *pParam,unsigned uFrom,unsigned uTo,int (__cdecl*pCmp)(const void*,const void*)) const
{

	if(uFrom > m_uFieldCount)return -1;
	if(uTo   > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		if(!pCmp(pParam,m_pField[uFrom]))return uFrom;
		}


return -1;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht eine Zahl im Feld.
//	iValue		: Ist die gesuchter Zahl
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: uOffset im Element
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataList::Find(int iValue,unsigned uFrom,unsigned uTo,unsigned uOffset) const
{
int		 *pPtr;


	if(uFrom              > m_uFieldCount)return -1;
	if(uOffset            >=m_uFieldSize )return -1;
	if(uOffset+sizeof(int)> m_uFieldSize )return -1;
	if(uTo                > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		pPtr=(int*)(((char*)m_pField[uFrom])+uOffset);
		if(iValue==*pPtr)return uFrom;
		}


return -1;
}

//*****************************************************************************
//*
//*		FindQ
//*
//*****************************************************************************
//	Sucht eine Zahl im Feld.
//	iValue		: Ist die gesuchter Zahl
//	uFrom		: Beginn der Suche
//	uTo			: Ende   der Suche
//	uOffset		: uOffset im Element
//	Ergibt die gefundene Position bzw. -1 wenn nichts gefunden wurde.
int CDataList::FindQ(i64 iValue,unsigned uFrom,unsigned uTo,unsigned uOffset) const
{
i64		 *pPtr;


	if(uFrom              > m_uFieldCount)return -1;
	if(uOffset            >=m_uFieldSize )return -1;
	if(uOffset+sizeof(int)> m_uFieldSize )return -1;
	if(uTo                > m_uFieldCount)uTo=m_uFieldCount;

	for(;uFrom<uTo;uFrom++)
		{
		pPtr=(i64*)(((char*)m_pField[uFrom])+uOffset);
		if(iValue==*pPtr)return uFrom;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFastQ
//*
//****************************************************************************
//  Sucht eine Zahl mit der Schnell-Sucht-Methode.
//	Die Liste muss sortiert sein.
//	iValue		: Ist die iValue nach der gesucht wird
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo die iValue gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataList::FindFastQ(i64 iValue,unsigned uStart,unsigned uEnd,unsigned uOffset,int iMode)const
{
int		iHalf;
int		iCmp;
i64		iVal;


	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	if(uOffset+sizeof(int)>m_uFieldSize)					// Ist das Datenfeld gro genug
		{
		return -1;
		}

	uEnd--;

	if(iMode&1) for(;;)
		{
		iHalf = (uEnd-uStart+1)>>1;

		   iVal=*(i64*)((char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=((u64)iValue<(u64)iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02) {uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}
	else for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(i64*)((char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=(iValue<iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;continue;}
					  uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//  Sucht eine Zahl mit der Schnell-Sucht-Methode.
//	Die Liste muss sortiert sein.
//	iValue		: Ist die iValue nach der gesucht wird
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo die iValue gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataList::FindFast(int iValue,unsigned uStart,unsigned uEnd,unsigned uOffset,int iMode)const
{
int		 iHalf,iCmp,iVal;


	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	if(uOffset+sizeof(int)>m_uFieldSize)					// Ist das Datenfeld gro genug
		{
		return -1;
		}

	uEnd--;

	if(iMode&1) for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(int*)( (char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=((unsigned)iValue<(unsigned)iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02) {uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}
	else for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		   iVal=*(int*)( (char*)m_pField[uStart+iHalf]+uOffset );
		if(iVal==iValue)iCmp=0;
		else		    iCmp=(iValue<iVal)? -1:1;

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;continue;}
					  uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//  Sucht einen Speicherabschnitt mit der Schnell-Sucht-Methode
//	Die Liste muss sortiert sein
//	pMem		: Ist ein Zeiger auf den Speicherabschnitt
//	uStart		: Ist die uStart Position
//  uEnd		: Ist das uEnd der Suche (bei -1 die Anzahl der Eintrge)
//	iLen		: Ist die Lnge des zu suchenden Speicherabschnitt (-1=bis zum Ende)
//	uOffset		: Ist der uOffset im Feld
//	iMode		: Bit0 != 0 unsigned Vergleich
//				  Bit1 != 0 Erste  Position finden
//  			  Bit2 != 0 Position hinter letzter suchen
//  			  Bit3 != 0 Einfgeposition suchen
//  Ergibt die Position wo der Speicher gefunden wurde bzw. -1 wenn nichts gefunden wurde.
int	CDataList::FindFast(void *pMem,unsigned uStart,unsigned uEnd,int iLen,unsigned uOffset,int iMode)const
{
int		 iHalf,iCmp;




	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd        > m_uFieldCount)uEnd=m_uFieldCount;		// Ist Ende hinter der Anzahl
	if(uEnd	       <=uStart       )return -1;				// Ende vor Start ?
	if(uOffset     >=m_uFieldSize )return -1;				// Ist das Datenfeld gro genug
	if(iLen        <=0            )iLen=m_uFieldSize-uOffset;
	if(iLen+uOffset> m_uFieldSize )return -1;

	uEnd--;

	for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		iCmp=memcmp(pMem,(char*)m_pField[uStart+iHalf]+uOffset,iLen);

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		FindFast
//*
//****************************************************************************
//	Sucht einen Bereich mit der Schnell-Such-Methode und einer speziellen Funktion
//	Die Liste muss sortiert sein
//	pParam	: Erster Parameter der an die Vergleichsfunktion bergeben wird.
//	uStart  : Ist die Startposition
//	uEnd	: Ist das Ende der Suche bei -1 die String Anzahl
//	iMode	: Bit0 != 0 unsigned Vergleich
//			  Bit1 != 0 Erste  Position finden
//			  Bit2 != 0 Position hinter letzter suchen
//			  Bit3 != 0 Einfgeposition suchen
//	pCmp	: Ist die Vergleichsfunktion. Mit ihr werden die Datenbereiche der
//			  Eintrge mit dem Parameter verglichen:
//				>0 Der Parameter ist grer  als der Eintrag
//				=0 Der Parameter ist gleich  mit dem Eintrag
//				<0 Der Parameter ist kleiner als der Eintrag
//	Ergibt die Position wo der Text gefunden wurde bzw. -1 wenn nicht gefunden.
int	CDataList::FindFast(const void *pParam,unsigned uStart,unsigned uEnd,int iMode,int (__cdecl*pCmp)(const void*,const void*))const
{
int		 iHalf,iCmp;




	if(uStart>=m_uFieldCount)								// Auerhalb des Bereichs ?
		{
		if(iMode&0x08)return m_uFieldCount;
		return -1;
		}

	if(uEnd  > m_uFieldCount)uEnd=m_uFieldCount;			// Ist Ende hinter der Anzahl
	if(uEnd	 <=uStart       )return -1;						// Ende vor Start ?

	uEnd--;

	for(;;)
		{
		iHalf=(uEnd-uStart+1)>>1;

		iCmp=pCmp(pParam,m_pField[uStart+iHalf]);

		if(iHalf && iCmp)									// Weiter suchen
			{
			if(iCmp<0){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd  =uStart;continue;}
					   uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd  ;continue;
			}

		if(!iHalf)											// Ende erreicht
			{
			if(iCmp==0   )return (iMode&0x04)? uStart+1:uStart;
			if(iMode&0x08)return (iCmp >=  0)? uStart+1:uStart;
						  return -1;
			}

		if(!(iMode&0x06)) return uStart+iHalf;				// Gefunden
		if(  iMode&0x02 ){uEnd  =uStart+iHalf-1;if(uStart>uEnd)uEnd =uStart;}
		else		     {uStart=uStart+iHalf+1;if(uStart>uEnd)uStart=uEnd ;}

		iMode|=0x08;
		}


return -1;
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	uOffset		: Ist der Offset ab dem beim Sortieren verglichen wird.
//	iLen		: Ist die Byteanzahl die verglichen wird. (-1 fr bis zum iEnd)
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum iEnd sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataList::Sort(unsigned uOffset,int iLen,int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?

	if(uOffset    >=m_uFieldSize)return;						// Ist Offset zu gro
	if(iLen<0 )iLen=m_uFieldSize-uOffset;
	if(uOffset+iLen>m_uFieldSize)iLen=m_uFieldSize-uOffset;


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pPos;
char   *pPtr;

	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd+1;

		pPos        = m_pField[m];
		m_pField[m] = m_pField[u];
		m_pField[u] = pPos;

		pPtr  = (char*)m_pField[iStart];
		pPtr += uOffset;

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=memcmp(((char*)m_pField[u])+uOffset,pPtr,iLen);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=memcmp(((char*)m_pField[o])+uOffset,pPtr,iLen);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			pPos        = m_pField[u];
			m_pField[u] = m_pField[o];
			m_pField[o] = pPos;
			}

		pPos             = m_pField[iStart];
		m_pField[iStart] = m_pField[o];
		m_pField[o]      = pPos;

		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u<iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u<iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	pCmp		: Ist die Sortierfunktion vpm Typ int XXX(CDataField*,int p1,int p2)
//				  Ergibt	=0 ergibt wenn p1==p2
//							>0 ergibt wenn p1> p2
//							<0 ergibt wenn p1< p2
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataList::Sort(int (__cdecl *pCmp)(CDataList*,int,int),int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pPos;


	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;

		pPos        = m_pField[m];
		m_pField[m] = m_pField[u];
		m_pField[u] = pPos;

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=pCmp(this, u, iStart);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=pCmp(this, o, iStart);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			pPos        = m_pField[u];
			m_pField[u] = m_pField[o];
			m_pField[o] = pPos;
			}

		pPos             = m_pField[iStart];
		m_pField[iStart] = m_pField[o];
		m_pField[o     ] = pPos;

		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u < iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u < iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}

//****************************************************************************
//*
//*		Sort
//*
//****************************************************************************
//  Sortiert eine Liste.
//	pCmp		: Ist die Sortierfunktion vpm Typ int XXX(void *pParam,void *pPtr1,void *pPtr1)
//				  Ergibt	=0 ergibt wenn pPtr1==pPtr2
//							>0 ergibt wenn pPtr1> pPtr2
//							<0 ergibt wenn pPtr1< pPtr2
//	pParam		: Ist der User-Parameter fr die Sortierfunktion
//	iOffset		: Ist der Offset im Feld ab dem verglichen wird
//	iStart		: Ist das Element ab dem sortiert wird.
//	iEnd		: Ist das Element bis vor dem sortiert wird.
//				  Bei -1 wird bis zum Ende sortiert.
//	iDir		: Ist die Sortierrichtung.
void CDataList::Sort(int (__cdecl *pCmp)(void*,const void*,const void*),void *pParam,int iOffset,int iStart,int iEnd,int iDir)
{

	if(iStart<0)iStart=0;										// Auerhalb des Bereichs ?
	if(iStart>=(int)m_uFieldCount)return;						//		*
	if((unsigned)iEnd>(unsigned)m_uFieldCount)iEnd=m_uFieldCount;//		*
	if(iEnd <=iStart )return;									// Ende vor Start ?


//************************* Qsort-Alogarytmus *********************************
int		u,o,m,c;
int		aMenU[30],aMenO[30];
int		iLevel;
void   *pMem;
void   *pPos;


	iEnd--;

	if(iStart>=iEnd)return;

	iLevel = 0;


	for(;;)
		{
		m = (iStart + iEnd)>>1;									// Mitte berechnen
		u =  iStart;
		o =  iEnd + 1;

		pPos        = m_pField[m];
		m_pField[m] = m_pField[u];
		m_pField[u] = pPos;

		pMem = OFFSET_MEM(iStart,iOffset);

		for(;;)
			{
			do  {
				u++;
				if(u>iEnd)break;
				c=pCmp(pParam,OFFSET_MEM(u,iOffset),pMem);
				if(iDir)c=-c;
				}while(c<=0);

			do  {
				o--;
				if(o<=iStart)break;
				c=pCmp(pParam,OFFSET_MEM(o,iOffset),pMem);
				if(iDir)c=-c;
				}while(c>=0);

			if(o<u)break;

			pPos        = m_pField[u];
			m_pField[u] = m_pField[o];
			m_pField[o] = pPos;
			}

		pPos             = m_pField[iStart];
		m_pField[iStart] = m_pField[o];
		m_pField[o     ] = pPos;

		if(o-1-iStart >= iEnd-u)
			{
			if(iStart+1 < o)
				{
				aMenU[iLevel] = iStart;
				aMenO[iLevel] = o-1;
				iLevel++;
				}

			if(u < iEnd)
				{
				iStart = u;
				continue;
				}
			}
		else{
			if(u < iEnd)
				{
				aMenU[iLevel] = u;
				aMenO[iLevel] = iEnd;
				iLevel++;
				}

			if(iStart+1 < o)
				{
				iEnd = o-1;
				continue;
				}
			}

	    if(iLevel<=0)											// Noch Ebenen vorhanden
			{
			return;
			}

		iLevel--;												// Eine Ebene absteigen
		iStart = aMenU[iLevel];
		iEnd   = aMenO[iLevel];
		}
}



//*****************************************************************************
//*
//*		Konstructor
//*
//*****************************************************************************
CDataArray::CDataArray()
{

	m_pMemory	= 0;
	m_uSize		= 0;
	m_uMax		= 0;


}

//*****************************************************************************
//*
//*		Konstructor
//*
//*****************************************************************************
//	iSize	: Ist die Miniamale Array-Gre
CDataArray::CDataArray(int iSize)
{

	m_pMemory	= 0;
	m_uSize		= 0;
	m_uMax		= 0;

	if(iSize>0)
		{
		   m_pMemory = new char[iSize];
		if(m_pMemory)m_uMax=iSize;
		}

}

//*****************************************************************************
//*
//*		Denstructor
//*
//*****************************************************************************
CDataArray::~CDataArray()
{

	if(m_pMemory)
		{
		delete m_pMemory;
		m_pMemory = 0;
		m_uSize	  = 0;
		m_uMax	  = 0;
		}

}

//*****************************************************************************
//*
//*		Expand
//*
//*****************************************************************************
//	Den Array-Puffer vergrern
//	uBytes		: Ist die minimale neue Gre
//	Ergibt die neue maximale Array-Gre oder 0 bei einem Fehler
unsigned CDataArray::Expand(unsigned uBytes)
{
char	   *pNewMem;
char	   *pOldMem;


	if(uBytes<1024)uBytes=1024;

	uBytes += uBytes/2;
	pNewMem = new char[uBytes];
	pOldMem = m_pMemory;

	if(!pNewMem)return 0;


	memcpy(pNewMem,m_pMemory,m_uSize);
	m_pMemory	= pNewMem;
	m_uMax		= uBytes;

	delete pOldMem;


return uBytes;
}

//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
//	Lsch das gesammte Array und gibt den Speicher frei
void CDataArray::Clear()
{
	m_uSize = 0;
	m_uMax	= 0;

	if(m_pMemory)
		{
		delete m_pMemory;
		m_pMemory = 0;
		}

}


//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Das Array vergrern, ohne einen Speicherbereich zu kopieren
//	iSize		: Gre um wieviel das Array wachsen soll
//	Ergibt die neue Gre des Arrays
int CDataArray::Grow(int iSize)
{
unsigned 	uBytes;


	if(iSize<=0)return 0;

	   uBytes = m_uSize-iSize;
	if(uBytes>m_uMax && !Expand(uBytes))
		{
		return m_uSize;
		}

	m_uSize += iSize;


return m_uSize;
}


//*****************************************************************************
//*
//*		Add
//*
//*****************************************************************************
//	Einen neuen Teil ans Array anhngen
//	pBuffer		: Zeiger auf den Puffer der angehngt werden soll
//	iSize		: Gre des Puffers
//	Ergibt die neue Gre des Arrays
int CDataArray::Add(const void *pBuffer,int iSize)
{
unsigned 	uBytes;


	if(iSize<=0)return 0;

	   uBytes = m_uSize+iSize;
	if(uBytes>m_uMax && !Expand(uBytes))
		{
		return m_uSize;
		}

	memcpy(m_pMemory+m_uSize,pBuffer,iSize);
	m_uSize += iSize;


return m_uSize;
}


//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Speicher einen Teil des Arrays in einem Puffer
//	pBuffer		: Zeiger auf den Puffer
//	iSize		: Gre des Puffers
//	uOffset		: Offset vom Teil im Array
//	Ergibt die Anzahl der kopierten Bytes
int CDataArray::Get(void *pBuffer,int iSize,unsigned uOffset)
{
int		iRest;

	if(iSize<=0 || uOffset>=m_uSize)return 0;

	   iRest = m_uSize-uOffset;
	if(iRest<iSize)iSize=iRest;

	memcpy(pBuffer,m_pMemory+uOffset,iSize);


return iSize;
}

//*****************************************************************************
//*
//*		Replace
//*
//*****************************************************************************
//	Einen Bereich im Array mit einem Speicherbereich tauschen.
//  pBuffer		: Zeiger auf den neuen Speicherbereich.
//	iSize		: Gre des neuen Speicherbereiches.
//	iOld		: Gre des Bereiches im Array der getauscht werden soll.
//	uOffset		: Offset des Bereiches im Array.
//	Ergibt die neue Gre des Arrays.
int CDataArray::Replace(const void *pBuffer,int iSize,int iOld,unsigned uOffset)
{
char	   *pMemory;
unsigned	uBytes;
int			iRest;


	if(iSize<=0)
		{
		return m_uSize;
		}

	   uBytes = m_uSize+iSize;
	if(uBytes>m_uMax && !Expand(uBytes))
		{
		return m_uSize;
		}



	if(uOffset>m_uSize)
		{
		uOffset = m_uSize;
		iOld	= 0;
		}

	iRest	= m_uSize  -uOffset;
	pMemory	= m_pMemory+uOffset;

	if(iOld<0)
		{
		iOld = 0;
		}
	else{
		   iRest -= iOld;
		if(iRest<0)iRest=0;
		}

	memmove(pMemory+iSize,pMemory+iOld,iRest);
	memcpy (pMemory,pBuffer,iSize);

	m_uSize = uOffset+iRest+iSize;


return m_uSize;
}


//*****************************************************************************
//*
//*		Insert
//*
//*****************************************************************************
//	Ein Speicherbereich ins Array einfgen.
//	pBuffer		: Zeiger auf den Speicherbereich.
//	iSize		: Gre des Speicherbereiches in Byte.
//	uOffset		: Ist der Offset im Array an dem der Speicherbereich eingefgt werden soll.
//	Ergibt die neue Gre des Arrays.
int CDataArray::Insert(const void *pBuffer,int iSize,unsigned uOffset)
{
char	   *pMemory;
unsigned	uBytes;
int			iRest;


	if(iSize<=0)
		{
		return m_uSize;
		}

	   uBytes = m_uSize+iSize;
	if(uBytes>m_uMax && !Expand(uBytes))
		{
		return m_uSize;
		}


	if(uOffset>m_uSize)
		{
		uOffset = m_uSize;
		}

	iRest	= m_uSize  -uOffset;
	pMemory	= m_pMemory+uOffset;


	memmove(pMemory+iSize,pMemory,iRest);
	memcpy (pMemory,pBuffer,iSize);

	m_uSize = uOffset+iRest+iSize;


return m_uSize;
}

//*****************************************************************************
//*
//*		Slide
//*
//*****************************************************************************
//	Einen Bereich im Array verschieben.
//	iFrom		: Ist der Start-Offset des Bereiches im Array.
//	iSize		: Ist die Gre des des Bereiches im Array in Byte.
//	iTarget		: Ist der Offset zu dem der Bereich verschoben werden soll.
//	Ergibt den neuen Offset des Bereiches, bzw. -1 bei einem Fehler.
int CDataArray::Slide(int iFrom,int iSize,int iTarget)
{
char	cTemp[1024];
char   *pTemp;
char   *pMem1;
char   *pMem2;
int		iNum1;
int		iNum2;



	if(iTarget<0 || iFrom<0 || iSize<0)
		{
		return -1;
		}

	if(m_uSize==0)
		{
		if(iSize    )return -1;
		if(iTarget>0)return -1;
		return 0;
		}

	if(iFrom+iSize>(int)m_uSize || iTarget+iSize>(int)m_uSize)
		{
		return -1;
		}

	if(iTarget==iFrom || iSize==0)
		{
		return iTarget;
		}

	if(iTarget<iFrom)									// Welcher Bereich ist vorher
		{
		iNum1 = iFrom-iTarget;
		iNum2 = iSize;
		pMem1 = (char*)m_pMemory+iTarget;
		pMem2 = (char*)m_pMemory+iFrom;
		}
	else{
		iNum1 = iSize;
		iNum2 = iTarget-iFrom;
		pMem1 = (char*)m_pMemory+iFrom;
		pMem2 = pMem1+iSize;
		}


	if(iNum1>iNum2)										// Wercher Bereich ist grer
		{
		if(iNum2>sizeof(cTemp))
				pTemp=new char[iNum2];
		else	pTemp=cTemp;

		memcpy (pTemp      ,pMem2,iNum2);
		memmove(pMem1+iNum2,pMem1,iNum1);
		memcpy (pMem1      ,pTemp,iNum2);
		}
	else{
		if(iNum1>sizeof(cTemp))
				pTemp=new char[iNum1];
		else	pTemp=cTemp;

		memcpy (pTemp      ,pMem1,iNum1);
		memmove(pMem1      ,pMem2,iNum2);
		memcpy (pMem1+iNum2,pTemp,iNum1);
		}


	if(pTemp!=cTemp)delete pTemp;



return iTarget;
}

//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Lscht eine Bereich aus dem Array
//	iSize		: Ist die Gre des Bereichs
//	uOffset		: Ist der Offset des Bereichs
//	Ergibt die neue Gre des Arrays.
int CDataArray::Del(int iSize,unsigned uOffset)
{
int			iRest;



	if(iSize<=0 || uOffset>=m_uSize)
		{
		return m_uSize;
		}

	iRest = m_uSize-uOffset;

	if(iSize>=iRest)
		{
		m_uSize = uOffset;
		return m_uSize;
		}


	memmove(m_pMemory+uOffset,m_pMemory+uOffset+iSize,iRest-iSize);

	m_uSize -= iSize;



return m_uSize;
}

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

#ifdef _DEBUG

int   CDataList   ::Count()const {return m_uFieldCount;}
int	  CDataList   ::Del  (){return Del(0,m_uFieldCount);}
int	  CDataList   ::Del  (unsigned uPos){return Del(uPos,uPos+1);}
void**CDataList   ::Get  () const{return m_pField;}
void *CDataList   ::Get  (unsigned uPos) const{if(uPos>=m_uFieldCount)return 0;return m_pField[uPos];}
void *CDataList   ::operator[](unsigned  uPos )const{return Get(uPos);}
void  CDataList   ::operator=(CDataList &sField){Del();Len(sField.m_uFieldSize,sField.m_uFieldAdd);Set(sField.m_pField,0,sField.m_uFieldCount);}
void  CDataList   ::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
void  CDataList   ::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
void  CDataList   ::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
int   CDataList   ::GetUserData()const{return (int)m_pUserPtr;}
void *CDataList   ::GetUserPtr ()const{return      m_pUserPtr;}
void  CDataList   ::Sort(int iLen){Sort((unsigned)0,iLen);}
bool  CDataList   ::Check(unsigned uPos)const{return uPos<(unsigned)m_uFieldCount;}
void  CDataList   ::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iEnd,int iDir){Sort(pCmp,0,iOffset,iStart,iEnd,iDir);}
void  CDataList   ::Free(void *pEntry){delete pEntry;}
void *CDataList   ::Alloc(){return new char[m_uFieldSize];}

int   CDataField  ::Count()const {return m_uFieldCount;}
int	  CDataField  ::Del  (){return Del(0,m_uFieldCount);}
int	  CDataField  ::Del  (unsigned uPos){return Del(uPos,uPos+1);}
void *CDataField  ::Get  () const{return m_pField;}
void *CDataField  ::Get  (unsigned uPos) const{if(uPos>=m_uFieldCount)return 0;return ((char*)m_pField)+uPos*m_uFieldSize;}
void *CDataField  ::operator[](unsigned uPos)const{return Get(uPos);}
void  CDataField  ::operator=(CDataField &sField){Del();Len(sField.m_uFieldSize,sField.m_uFieldAdd);Set(sField.m_pField,0,sField.m_uFieldCount);}
void  CDataField  ::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
void  CDataField  ::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
void  CDataField  ::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
int   CDataField  ::GetUserData()const{return (int)m_pUserPtr;}
void *CDataField  ::GetUserPtr ()const{return      m_pUserPtr;}
void  CDataField  ::Sort(int iLen){Sort((unsigned)0,iLen);}
bool  CDataField  ::Check(unsigned uPos)const{return uPos<(unsigned)m_uFieldCount;}
void  CDataField  ::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iEnd,int iDir){Sort(pCmp,0,iOffset,iStart,iEnd,iDir);}

char *CDataArray  ::Get(unsigned uOffset,int &iSize){if(uOffset>=m_uSize){iSize=0;return 0;}iSize=m_uSize-uOffset;return m_pMemory+uOffset;}
char *CDataArray  ::Get(unsigned uOffset           ){if(uOffset>=m_uSize){        return 0;}                      return m_pMemory+uOffset;}
char *CDataArray  ::Get(int *pSize){*pSize=m_uSize;return m_pMemory;}
char *CDataArray  ::Get(          ){			   return m_pMemory;}
void  CDataArray  ::Del(){m_uSize=0;}
void  CDataArray  ::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
void  CDataArray  ::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
void  CDataArray  ::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
int   CDataArray  ::GetUserData()const{return (int)m_pUserPtr;}
void *CDataArray  ::GetUserPtr ()const{return      m_pUserPtr;}

int   CDataPointer::Count()const {return m_uFieldCount;}
int	  CDataPointer::Del  (){return Del(0,m_uFieldCount);}
int	  CDataPointer::Del  (unsigned uPos){return Del(uPos,uPos+1);}
void**CDataPointer::Get  () const{return m_pField;}
void *CDataPointer::Get  (unsigned uPos) const{if(uPos>=m_uFieldCount)return 0;return m_pField[uPos];}
void *CDataPointer::operator[](unsigned  uPos)const{return Get(uPos);}
void  CDataPointer::operator=(CDataPointer &sField){Del();Len(sField.m_uFieldFree,sField.m_uFieldAdd);Set(&sField.m_pField,0,sField.m_uFieldCount);}
void  CDataPointer::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
void  CDataPointer::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
void  CDataPointer::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
int   CDataPointer::GetUserData()const{return (int)m_pUserPtr;}
void *CDataPointer::GetUserPtr ()const{return      m_pUserPtr;}
void  CDataPointer::Sort(int iLen){Sort((unsigned)0,iLen);}
bool  CDataPointer::Check(unsigned uPos)const{return uPos<(unsigned)m_uFieldCount;}
void  CDataPointer::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iEnd,int iDir){Sort(pCmp,0,iOffset,iStart,iEnd,iDir);}

#endif


