//*****************************************************************************
//*
//*
//*		DataField.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechen (C) 2008
//
//	Die Klasse CDataPointer erzeugt eine Feld-Liste von Eintrgen (Zeiger-Liste mit varaibeln Elementgren)
//	Die Klasse CDataField   erzeugt ein  Feld       von Eintrgen (zusammen hngend)
//	Die Klasse CDataList    erzeugt eine Feld-Liste von Eintrgen (Zeiger-Liste)
//
//	Funktionen:
//
// 	int   Find (int   iValue, ... )						: Sucht eine Zahl
// 	int   Find (void *pMem  , ... )						: Sucht einen Bereich
// 	int   Len  (unsigned uSize=0,int Add=-1)			: Lnge einstellen
// 	void *Get  (unsigned uPos)							: Zeiger auf Element
// 	void *Get  (unsigned uPos,void *pTarget)			: Element kopieren
// 	int	  Del  ()										: Alle   Elemente lschen
// 	int	  Del  (unsigned uPos)							: Ein    Element  lschen
// 	int	  Del  (unsigned uFrom ,unsigned uTo);	 		: Einige Elemente lschen
// 	int	  Set  (void*  pData,unsigned uPos,int iNum=1)	: Elemente berschreiben
// 	int	  Set  (void** pData,unsigned uPos,int iNum=1)	: Elemente berschreiben
// 	int	  Add  (void*  pData,unsigned uPos,int iNum=1)	: Elemente einfgen
// 	int	  Add  (void** pData,unsigned uPos,int iNum=1)	: Elemente einfgen
// 	void  Sort (int (_cdecl*iCmp)(...),int,int,int)		: Das Feld sortieren
//	void  Sort (int (_cdecl*pCmp)(...),void*,int,...)	: Das Feld sortieren
// 	void  Sort (unsigned,int iLen=-1,int,int,int)		: Das Feld sortieren
// 	int   Count()										: Anzahl der Elemente abfragen

#ifndef	__DATAFIELD_H__
#define __DATAFIELD_H__


#if	_MSC_VER >= 1000
#pragma		warning( push )
#pragma		warning( disable :4302)
#pragma		warning( disable :4311)
#pragma		warning( disable :4312)
#pragma		once
#endif

#define 	CDF_ADD		0								// Feld-Vergerung (0=dynamisch)

#ifdef		i64
#undef 		i64
#endif

#ifdef		u64
#undef 		u64
#endif

#ifndef	   _MSC_VER
#define		i64	 		long long
#define		u64	 		unsigned long long
#ifndef		__cdecl
#define 	__cdecl
#endif
#else
#define		i64	 		__int64
#define		u64	 		unsigned __int64
#endif

int 		DataFieldCmpInt   (void *pParam,const void *pData1,const void *pData2);
int 		DataFieldCmpUInt  (void *pParam,const void *pData1,const void *pData2);
int 		DataFieldCmpShort (void *pParam,const void *pData1,const void *pData2);
int			DataFieldCmpUShort(void *pParam,const void *pData1,const void *pData2);

#define 	CDF_CMP_INT		DataFieldCmpInt
#define 	CDF_CMP_UINT	DataFieldCmpUInt
#define 	CDF_CMP_SHORT	DataFieldCmpShort
#define 	CDF_CMP_USHORT	DataFieldCmpUShort

class		CDataList;
class		CDataField;
class		CDataPointer;

extern int __cdecl memslide  (void *pBuffer1                     ,int iFrom,int iCount,int iOffset,int iMax);
extern int __cdecl memremove (void *pBuffer1                     ,int iSize,int iCount         ,int iOffset);
extern int __cdecl meminsert (void *pBuffer1,const void *pBuffer2,int iSize,int iCount         ,int iOffset);
extern int __cdecl memreplace(void *pBuffer1,const void *pBuffer2,int iSize,int iCount,int iOld,int iOffset);


//*****************************************************************************
//*
//*		Klasse	CDataPointer
//*
//*****************************************************************************
//	Ist eine Liste aus Zeigern aus Datenbereiche. Die Datenbereiche knnen 
//	unterschidlich gro sein, und knne automatisch deallokiert werden.
class CDataPointer
{
public:

	 CDataPointer(unsigned  uFree=0,unsigned  uAdd=CDF_ADD);
	~CDataPointer();

	int   FindQ    		(i64         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,unsigned uOffset=0	         )const;
	int   Find     		(int         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,unsigned uOffset=0	         )const;
	int   Find     		(const void *pMem  ,unsigned uFrom  ,unsigned uTo ,int iLen ,unsigned uOffset=0	         )const;
	int	  Find     		(const void *pParam,unsigned uFrom  ,unsigned uTo ,int (__cdecl*pCmp)(const void*,const void*))const;
	int   FindFastQ		(i64         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,unsigned uOffset=0,int iMode=0)const;
	int   FindFast 		(int         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,unsigned uOffset=0,int iMode=0)const;
	int   FindFast 		(void       *pMem  ,unsigned uFrom  ,unsigned uTo ,int iLen ,unsigned uOffset=0,int iMode=0)const;
	int	  FindFast 		(const void *pParam,unsigned uFrom  ,unsigned uTo ,int iMode,int (__cdecl*pCmp)(const void*,const void*))const;
	int   Len      		(unsigned    uFree ,int      iAdd=-1);
	void**Get      		(                                   )const;
	void *Get      		(unsigned    uPos                   )const;
	void *Get      		(unsigned    uPos ,void     *pTarget,unsigned uSize)const;
	int   Get      		(unsigned    uPos ,unsigned  uOffset)const;
	i64   GetQ     		(unsigned    uPos ,unsigned  uOffset)const;
	int	  Del      		();
	int	  Del      		(unsigned    uPos);
	int	  Del      		(unsigned    uFrom,unsigned  uTo);
	int	  Set      		(const void* pData,unsigned  uPos=0x7FFFFFFF,int iCopy=0);
	int	  Set      		(      void**pData,unsigned  uPos=0x7FFFFFFF,int iNum =1);
	int	  Add      		(const void* pData,unsigned  uPos=0x7FFFFFFF,int iCopy=0);
	int	  Add      		(      void**pData,unsigned  uPos=0x7FFFFFFF,int iNum =1);
	int   Count    		()const;
	void  Sort     		(int (__cdecl*pCmp)(void*,const void*,const void*),void *pParam,int iOffset=0,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int (__cdecl*pCmp)(void*,const void*,const void*)             ,int iOffset=0,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int (__cdecl*pCmp)(CDataPointer*,int,int)                                   ,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(unsigned uOffset=0,int iLen=-1                                              ,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort	   		(int      iLen );
	bool  Check			(unsigned uPos )const;
	void *Peek	   		(unsigned uPos );
	int	  Grow   		(int      iSize);				// Das Array vergrern

	void  SetUserData	(int      iData);
	void  SetUserPtr 	(void    *pPtr );
	void  GetUserPtr 	(void    *pPtr )const;
	int   GetUserData	(              )const;
	void *GetUserPtr 	(              )const;

	void *operator[](unsigned uPos)const;
	void  operator=(CDataPointer &sField);

protected:

	unsigned		 	m_uFieldCount;					// Anzahl der Eintrge
	unsigned		 	m_uFieldFree;					// Die Eintrge beim lschen freigeben
	unsigned		 	m_uFieldAdd;					// Eintrge um die das Feld vergrert wird
	unsigned			m_uFieldMax;					// Anzahl aller allokierten Eintrge
	void			  **m_pField;						// Zeiger auf das Zeigerfeld
	void			  **m_pOldPtr;						// Zeiger auf vorherige Zeigerfeld
	void			   *m_pUserPtr;						// Frei verwendbarer Wert fr den User

};


//*****************************************************************************
//*
//*		Klasse	CDataList
//*
//*****************************************************************************
//	Ist eine Liste aus Zeigern aus Datenbereiche mit gleicher Gre.
class CDataList
{
public:

	 CDataList(unsigned  uSize=sizeof(int),unsigned  uAdd=CDF_ADD);
	~CDataList();

	int   FindQ			(i64         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0		      )const;
	int   Find     		(int         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0		      )const;
	int   Find     		(const void *pMem  ,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,int iLen=0,unsigned uOffset=0		      )const;
	int	  Find     		(const void *pParam,unsigned uFrom  ,unsigned uTo,int (__cdecl*pCmp)(const void*,const void*))const;
	int   FindFastQ		(i64         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0,int iMode=0)const;
	int   FindFast 		(int         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0,int iMode=0)const;
	int   FindFast 		(void       *pMem  ,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,int iLen=0,unsigned uOffset=0,int iMode=0)const;
	int	  FindFast 		(const void *pParam,unsigned uFrom  ,unsigned uTo,int iMode ,int (__cdecl*pCmp)(const void*,const void*))const;
	int   Len      		(unsigned uSize=0,int iAdd=-1);
	void**Get      		(                                )const;
	void *Get      		(unsigned uPos                   )const;
	void *Get      		(unsigned uPos,void      *pTarget)const;
	int   Get      		(unsigned uPos,unsigned   uOffset)const;
	i64   GetQ     		(unsigned uPos,unsigned   uOffset)const;
	int	  Del      		();
	int	  Del      		(unsigned uPos);
	int	  Del      		(unsigned uFrom,unsigned uTo);
	void *SetEx    		(const void  *pData,unsigned uPos=0x7FFFFFFF);
	int	  Set      		(const void  *pData,unsigned uPos=0x7FFFFFFF,int  iNum=1);
	int	  Set      		(      void **pData,unsigned uPos=0x7FFFFFFF,int  iNum=1);
	int	  Add      		(const void  *pData,unsigned uPos=0x7FFFFFFF,int  iNum=1);
	int	  Add      		(      void **pData,unsigned uPos=0x7FFFFFFF,int  iNum=1);
	void *Add	   		(                   unsigned uPos=0x7FFFFFFF,int *pPos=0);
	int	  AddEx    		(const void  *pData,unsigned uPos=0x7FFFFFFF);
	int   Count    		()const;
	void  Sort     		(int (__cdecl*pCmp)(void*,const void*,const void*),void *pParam,int iOffset=0,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int (__cdecl*pCmp)(void*,const void*,const void*)             ,int iOffset=0,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int (__cdecl*pCmp)(CDataList*,int,int)                                      ,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(unsigned uOffset=0,int iLen=-1                                              ,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort	   		(int iLen);
	bool  Check    		(unsigned uPos)const;
	int	  Grow   		(int      iSize);				// Das Array vergrern
				   		
	void *Peek	   		(unsigned uPos);				// Einen Eintrag aus der Liste entferen ohne ihn zu deallokieren
    static void Free	(void *pEntry);					// Einen Eintrag deallokieren der nicht in der Liste ist
	void *Alloc			();								// Einen Eintrag auerhalb der Liste allokieren

	void  SetUserData	(int   iData);
	void  SetUserPtr 	(void *pPtr);
	void  GetUserPtr 	(void *pPtr)const;
	int   GetUserData	()const;
	void *GetUserPtr 	()const;

	void *operator[](unsigned uPos)const;
	void  operator=(CDataList &sField);

protected:

	unsigned			m_uFieldCount;					// Anzahl der Eintrge
	unsigned		 	m_uFieldSize;					// Gre eines einzelnen Eintrages in Byte
	unsigned		 	m_uFieldAdd;					// Eintrge um die das Feld vergrert wird
	unsigned			m_uFieldMax;					// Anzahl aller allokierten Eintrge
	void			  **m_pField;						// Zeiger auf das Zeigerfeld
	void			  **m_pOldPtr;						// Zeiger auf vorherige Zeigerfeld
	void			   *m_pUserPtr;						// Frei verwendbarer Wert fr den User

};

//*****************************************************************************
//*
//*		Klasse CDataField
//*
//*****************************************************************************
//	Ist ein zusammenhngendes Array aus Datenbereichen mit gleicher Gre.
class CDataField
{
public:

	 CDataField(unsigned uSize=sizeof(int),unsigned uAdd=CDF_ADD);
	~CDataField();

	int   FindQ			(i64         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0		    )const;
	int   Find     		(int         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0		    )const;
	int   Find     		(const void *pMem  ,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,int iLen=0,unsigned uOffset=0		    )const;
	int	  Find     		(const void *pParam,unsigned uFrom  ,unsigned uTo,int (__cdecl*pCmp)(const void*,const void*))const;
	int   FindFastQ		(i64         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0,int iMode=0)const;
	int   FindFast 		(int         iValue,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF           ,unsigned uOffset=0,int iMode=0)const;
	int   FindFast 		(void       *pMem  ,unsigned uFrom=0,unsigned uTo=0x7FFFFFFF,int iLen=0,unsigned uOffset=0,int iMode=0)const;
	int	  FindFast 		(const void *pParam,unsigned uFrom  ,unsigned uTo,int iMode ,int (__cdecl*pCmp)(const void*,const void*))const;
	int   Len      		(unsigned    uSize=0,int iAdd=-1);
	void *Get      		(                                   )const;
	void *Get      		(unsigned    uPos                   )const;
	void *Get      		(unsigned    uPos  ,void    *pTarget)const;
	int   Get      		(unsigned    uPos  ,unsigned uOffset)const;
	i64   GetQ     		(unsigned    uPos  ,unsigned uOffset)const;
	int	  Del      		();		     
	int	  Del      		(unsigned    uPos);
	int	  Del      		(unsigned    uFrom ,unsigned uTo);
	int	  Set      		(const void* pData ,unsigned uPos=0x7FFFFFFF,int iNum=1);
	int	  Set      		(      void**pData ,unsigned uPos=0x7FFFFFFF,int iNum=1);
	int	  Add      		(const void* pData ,unsigned uPos=0x7FFFFFFF,int iNum=1);
	int	  Add      		(      void**pData ,unsigned uPos=0x7FFFFFFF,int iNum=1);
	void *Add      		(                   unsigned uPos=0x7FFFFFFF,int iNum=1,int *pPos=0);
	int   Count    		() const;
				   		
	void  SetUserData	(int   iData);
	void  SetUserPtr 	(void *pPtr );
	void  GetUserPtr 	(void *pPtr )const;
	int   GetUserData	(           )const;
	void *GetUserPtr 	(           )const;

	void  Sort     		(int (__cdecl*pCmp)(void*,const void*,const void*),void *pParam,int iOffset=0,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int (__cdecl*pCmp)(void*,const void*,const void*)             ,int iOffset=0,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int (__cdecl*pCmp)(CDataField*,int,int)                                     ,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(unsigned uOffset=0,int iLen=-1                                              ,int iStart=0,int iEnd=-1,int iDir=0);
	void  Sort     		(int iLen);
	bool  Check    		(unsigned uPos)const;
	int	  Grow   		(int      iSize);				// Das Array vergrern

	void *operator[](unsigned uPos)const;
	void  operator=(CDataField &sField);

protected:

	unsigned		 	m_uFieldCount;					// Anzahl der Eintrge
	unsigned		 	m_uFieldSize;					// Gre eines einzelnen Eintrages in Byte
	unsigned		 	m_uFieldAdd;					// Eintrge um die das Feld vergrert wird
	unsigned			m_uFieldMax;					// Anzahl aller allokierten Eintrge
	void			   *m_pField;						// Zeiger auf das Feld
	void			   *m_pOldPtr;						// Zeiger auf vorherige Zeigerfeld
	void			   *m_pUserPtr;						// Frei verwendbarer Wert fr den User

};


//*****************************************************************************
//*
//*		Klasse CDataArray
//*
//*****************************************************************************
//	Ist ein Datenbereichen aus einzelnen Bytes.
class CDataArray
{
public:


	CDataArray(int iSize);
	CDataArray();
   ~CDataArray();

	void 	Clear		();								// Array und Speicher lschen
	void 	Del			();								// Nur ganzes Array lschen
	int 	Del			(int iSize,unsigned uOffset=0);	// Einen Teils des Arrays lschen

	int		Grow   		(int iSize);					// Das Array vergrern
	int		Add    		(const void *pBuffer,int iSize);// Einen Speicherbereich anhngen
	int		Insert 		(const void *pBuffer,int iSize,         unsigned uOffset=0);
	int		Replace		(const void *pBuffer,int iSize,int iOld,unsigned uOffset=0);
	int		Slide  		(int iForm,int iSize,int iTarget);		// Einen Bereich im Array verschieben

	int		Get			(void *pBuffer,int iSize,unsigned uOffset=0);	// Array-Segment kopieren
	char   *Get			(unsigned uOffset,int &iSize);	// Zeiger auf Array-Segment holen (mit Gre)
	char   *Get			(unsigned uOffset);				// Zeiger auf Array-Segment holen
	char   *Get			(int *pSize);					// Zeiger auf Array holen (mit Gre)
	char   *Get			();								// Zeiger auf Array holen

	void	SetUserData	(int   iData);
	void	SetUserPtr 	(void *pPtr );
	void	GetUserPtr 	(void *pPtr )const;
	int		GetUserData	(           )const;
	void   *GetUserPtr 	(           )const;

protected:

	unsigned Expand		(unsigned uBytes);				// Den gesamten Speicher vergrern

	void			   *m_pUserPtr;						// Frei verwendbarer Wert fr den User
	char			   *m_pMemory;						// Zeiger auf den Array-Puffer
	unsigned		 	m_uSize;						// Gre des Arrays in Byte
	unsigned		 	m_uMax;							// Gre des Array-Puffers

};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

#ifndef _DEBUG

inline	int   CDataList   ::Count()const {return m_uFieldCount;}
inline	int	  CDataList   ::Del  (){return Del(0,m_uFieldCount);}
inline	int	  CDataList   ::Del  (unsigned uPos){return Del(uPos,uPos+1);}
inline	void**CDataList   ::Get  () const {return m_pField;}
inline	void *CDataList   ::Get  (unsigned uPos) const {if(uPos>=m_uFieldCount)return 0;return m_pField[uPos];}
inline	void *CDataList   ::operator[](unsigned  uPos )const{return Get(uPos);}
inline	void  CDataList   ::operator=(CDataList &sField){Del();Len(sField.m_uFieldSize,sField.m_uFieldAdd);Set(sField.m_pField,0,sField.m_uFieldCount);}
inline	void  CDataList   ::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
inline	void  CDataList   ::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
inline	void  CDataList   ::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
inline	int   CDataList   ::GetUserData()const{return (int)m_pUserPtr;}
inline	void *CDataList   ::GetUserPtr ()const{return      m_pUserPtr;}
inline	void  CDataList   ::Sort(int iLen){Sort((unsigned)0,iLen);}
inline	bool  CDataList   ::Check(unsigned uPos)const{return uPos<(unsigned)m_uFieldCount;}
inline	void  CDataList   ::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iEnd,int iDir){Sort(pCmp,0,iOffset,iStart,iEnd,iDir);}
inline	void  CDataList   ::Free(void *pEntry){delete pEntry;}
inline	void *CDataList   ::Alloc(){return new char[m_uFieldSize];}

inline	int   CDataField  ::Count()const {return m_uFieldCount;}
inline	int	  CDataField  ::Del  (){return Del(0,m_uFieldCount);}
inline	int	  CDataField  ::Del  (unsigned uPos){return Del(uPos,uPos+1);}
inline	void *CDataField  ::Get  () const {return m_pField;}
inline	void *CDataField  ::Get  (unsigned uPos) const {if(uPos>=m_uFieldCount)return 0;return ((char*)m_pField)+uPos*m_uFieldSize;}
inline	void *CDataField  ::operator[](unsigned  uPos )const{return Get(uPos);}
inline	void  CDataField  ::operator=(CDataField &sField){Del();Len(sField.m_uFieldSize,sField.m_uFieldAdd);Set(sField.m_pField,0,sField.m_uFieldCount);}
inline	void  CDataField  ::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
inline	void  CDataField  ::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
inline	void  CDataField  ::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
inline	int   CDataField  ::GetUserData()const{return (int)m_pUserPtr;}
inline	void *CDataField  ::GetUserPtr ()const{return      m_pUserPtr;}
inline	void  CDataField  ::Sort(int iLen){Sort((unsigned)0,iLen);}
inline	bool  CDataField  ::Check(unsigned uPos)const{return uPos<(unsigned)m_uFieldCount;}
inline	void  CDataField  ::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iEnd,int iDir){Sort(pCmp,0,iOffset,iStart,iEnd,iDir);}

inline	char *CDataArray  ::Get(unsigned uOffset,int &iSize){if(uOffset>=m_uSize){iSize=0;return 0;}iSize=m_uSize-uOffset;return m_pMemory+uOffset;}
inline	char *CDataArray  ::Get(unsigned uOffset           ){if(uOffset>=m_uSize){        return 0;}                      return m_pMemory+uOffset;}
inline	char *CDataArray  ::Get(int *pSize){*pSize=m_uSize;return m_pMemory;}
inline	char *CDataArray  ::Get(          ){			   return m_pMemory;}
inline	void  CDataArray  ::Del(){m_uSize=0;}
inline	void  CDataArray  ::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
inline	void  CDataArray  ::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
inline	void  CDataArray  ::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
inline	int   CDataArray  ::GetUserData()const{return (int)m_pUserPtr;}
inline	void *CDataArray  ::GetUserPtr ()const{return      m_pUserPtr;}

inline	int   CDataPointer::Count()const {return m_uFieldCount;}
inline	int	  CDataPointer::Del  (){return Del(0,m_uFieldCount);}
inline	int	  CDataPointer::Del  (unsigned uPos){return Del(uPos,uPos+1);}
inline	void**CDataPointer::Get  () const {return m_pField;}
inline	void *CDataPointer::Get  (unsigned uPos) const {if(uPos>=m_uFieldCount)return 0;return m_pField[uPos];}
inline	void *CDataPointer::operator[](unsigned  uPos )const{return Get(uPos);}
inline	void  CDataPointer::operator=(CDataPointer &sField){Del();Len(sField.m_uFieldFree,sField.m_uFieldAdd);Set(&sField.m_pField,0,sField.m_uFieldCount);}
inline	void  CDataPointer::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
inline	void  CDataPointer::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
inline	void  CDataPointer::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
inline	int   CDataPointer::GetUserData()const{return (int)m_pUserPtr;}
inline	void *CDataPointer::GetUserPtr ()const{return      m_pUserPtr;}
inline	void  CDataPointer::Sort(int iLen){Sort((unsigned)0,iLen);}
inline	bool  CDataPointer::Check(unsigned uPos)const{return uPos<(unsigned)m_uFieldCount;}
inline	void  CDataPointer::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iEnd,int iDir){Sort(pCmp,0,iOffset,iStart,iEnd,iDir);}

#endif

#ifdef		i64
#undef 		i64
#endif


#if	_MSC_VER >= 1000
#pragma		warning( pop )
#endif

#endif
