//*****************************************************************************
//*
//*
//*		DataSanner.h: Schnittstelle fr die Klasse CDataScanner.
//*
//*
//*****************************************************************************
//
//	Mit dieser KLasse kann ein Speicherbereich analysiert werden und
//	als Text ausgegeben werden. Die Art der Analyse wird in Moduldateien
//	gespeichert (Siehe DataScanner.html)
//
//	Funktionen;
//
//		int		  Errors    ()
//		void	  ErrorOut  (CTextBuffer *pError)
// 		int 	  LoadModul (CTextBuffer *pInput,char *pName=0)
// 		int 	  LoadModul (const char  *pFile ,char *pName=0)
// 		int		  Count     ()
// 		int		  Count     (unsigned int uNr)
// 		int		  Scan      (unsigned int uNr,void *pMem,int iMemSize,int   iStart,int iMax=1000)
// 		int		  Scan      (                 void *pMem,int iMemSize,int   iStart,int iMax=1000)
// 		int		  Scan      (unsigned int uNr,void *pMem,int iMemSize,char *pBlock,int iMax=1000)
// 		int		  Scan      (                 void *pMem,int iMemSize,char *pBlock,int iMax=1000)
//		ScanData *Data      (unsigned int uNr,int   iPos,char **pText1=0,char **pText2=0)
//		ScanData *Data      (                 int   iPos,char **pText1=0,char **pText2=0)
//		char	 *BlockName (unsigned int uBlockNr=0)
// 		char	 *ModulName (unsigned int uModulNr=0)
// 		int		  ModulStart(unsigned int uModulNr=0)
// 		int		  ModulEnd  (unsigned int uModulNr=0)
//		void	  Delete	()
//		void	  DeleteScan(int iNr=-1);
//		int		  BlockNumber(char *pBlockName,int Modul=-1)
//		int		  ModulNumber(char *pModulName);
//		int	      BlockCount()
//		int	      ModulCount()
//		int		  SetScanner(unsigned int uNr)
//
//	ScanData:
//
// 		short	iTextNr;	: Textnummer fr m_sDumpData
// 		short	iLevel;		: Ebene
// 		int		iMemLen;	: Memory Lnge
// 		int		iMemOff;	: Memory Offset
// 		int		mem_goff;	: Memory globaler Offset
//
//	Syntax:		(Eine genaue Beschreibung ist in .\Allgemein\DataScanner.html)
//
//		BYTE											;1 Byte	Fixkomma
// 		WORD											;2 Byte Fixkomma
// 		RWORD											;3 Byte	Fixkomma
// 		DWORD											;4 Byte	Fixkomma
//		QWORD	  "Name" [Eintrge] [BIS Dump] [#Flags]	;8 Byte	Fixkomma
// 		FLOAD				(1)				 (XBDOHSUC)	;4 Byte Flieskomma
// 		DOUBLE											;8 Byte Flieskomma
//
//		STRING											;C-String mit '\0'
// 		STRING_D								 		;Dos-String mit '$'
// 		STRING_B								 		;Byte-String mit 1Len+Text
// 		STRING_P  "Name" [Lnge]   [BIS Dump] 	 		;Pascal-String mit 2Len+Text
// 		STRING_K								 		;String-Kette mit "\0\0"
//
//		BIT		  "Name" [Bitzahl] [#Flags]				;Bit Ketten (1-32)
// 							(1)   (XBDOHSUC)			;Bits auf n-tes Byte auslesen
//		REST	  "Name" [RasterBreite] [RasterVerschub] [#Flags]
//							(4)				  (0)		(XBDOHSUC)
//
//
//		IF	[!]	BIS Dump	   GOTO	  Marke				;If Mit Dump
//							   CALL
//
//
//		IF	[!]	Marke == Zahl  GOTO   Marke				;If Anweisung
// 					  !=	   CALL
// 					  >=
// 					  <=
// 					  >
// 					  >
//					  &
//		GOTO	Marke									;Sprung
//		CALL	Marke									;Unterfunktion aufrufen
//		RETURN											;Return fr Call oder Loop
//		EXIT											;Ablauf beenden
//		LOOP	[Anzahl]|[VarMarke]  [CallMarke]		;Schleifen Durchlauf
//		BLOCK	"BlockName"								;Block-Anfang
//		MODUL	"ModulName"								;Modul-Name
//		VERSCHUB[Anzahl]|[VarMarke]	 [#Flags]			;Byte verschieben/rastern
//								  (GLR)
//
// 		OFFSET	["Name"] [Zahl] [Flags]					;Aktuelles Offset+Zahl ausgeben
// 								 (NGA)
// 		LEN		["Name"] [Zahl] [Flags]					;Restliche Lnge+Zahl ausgeben
// 								 (NGA)
//
//
//		ADD												;Rechen Oberationen
//		SUB
// 		MUL			ZielMarke  QuellMarke  Zahl
//		DIV			ZielMarke  QuellMarke
//		MOD			ZielMarke              Zahl
//		AND
//		OR
//		XOR
//		MOV
//
//		AB												;Eine Ebene absteigen
//		AUF												;Eine Ebene aufsteigen
//
//		TEXT		"Text..."							;Einen Text ausgeben
//		PRINT		["Name"] DataMarke	        [Flags]	;Eine Zahl  ausgeben
//		SPRINT		["Name"] DataMarke OutMarke	[Flags]	;Eine Zahl in einer bestehenden Zeile ausgeben
//									   (XBDOHSUC)
//		;												;REM-Marke
//		:MarkenName										;Markendefinition
//
//	Flags:
//
//		B			Binr ausgeben				( 0b1010 )
// 		O			Octal ausgeben				( 0o1234 )
// 		D			Dezimal (signed) ausgeben	(  -1234 )
// 		H			HexaDezimal ausgeben		( 0x0FF0 )
// 		S			Signed Dezimal Zahl			(  -1234 )
// 		U			Unsigned Dezimal Zahl		(   1234 )
// 		C			Als Zeichen ausgeben		( 'A'    )
// 		X			Im Assembler Format ausgeben( 0FFh 0101b)
// 		K			Nut Zahlen ausgeben         ( 0FF  0101 )
//		1-9			Ausgabebreite der Zahlen
//
//		G			Globales Offset verwenden vom  Beginn weg
// 		N			Nicht ausgeben
//		R			Raster Verschub (fr Befehl VERSCHUB)
//		A			Absoluter Verschub (fr Befehl VERSCHUB)
//
//	Dump
//
//		BIS    .... [+Lnge] [*]
//
//				F1			Hex Byte
//				?			Nicht geprfftes Byte
//				~10101111	Byte binr angegeben
// 				~1??10??0   Byte binr angegeben mit nicht geprften Bits
// 				'A'			Byte Zeichen Zeichen
//				"xyz\n123"	Zeichen Folge
//				+Lnge		Die Dump-Lnge die dem Offset addiert wird
//				*			Dump Ende
//
//			z.B.:	00 A0 ? "Hallo\n" A6 ?? ~1??00011 FF   +2345
//					Es werden die angegeben Zeichen	geprft auer die
//					Bits die auf ? gesetzt sind. ( 3? oder ?3 ist nicht erlaubt )
//					Ist eine Lnge mit '+' angegeben wird die danach angegebe
//					Lnge addiert, ansonsten die Anzahl der Zeichen
//

#ifndef 	__DATASANNER_H__
#define     __DATASANNER_H__

#if 		_MSC_VER >= 1000
#pragma 	once
#endif

#include	"StringChain.h"
#include	"TextBuffer.h"
#include	"DataField.h"

#define 	SCAN_MAX	16			// Maximale Anzahl an Scannern
#define 	CALL_MAX	16			// Maximale Rekursions Tiefe fr Calls


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	zchar		wchar_t
#else
#define 	zchar		char
#endif


typedef struct
	{
	short	iTextNr;				// Textnummer fr m_sDumpData
	short	iLevel;					// Ebene
	int		iMemLen;				// Memory Lnge
	int		iMemOff;				// Memory Offset
	int		iMemOffG;				// Memory globaler Offset
	}ScanData;

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************

class CDataScanner
{
public:

	CDataScanner();
	CDataScanner(int iMax);
	virtual ~CDataScanner();

	int		  Errors    ();
	void	  ErrorOut  (int          iMode=0);
	void	  ErrorOut  (CTextBuffer *pError);
	int 	  LoadModul (CTextBuffer *pInput,const zchar *pName=0);
	int 	  LoadModul (const zchar *pFile ,const zchar *pName=0);
	int		  Count     ();
	int		  Count     (unsigned int uNr);
	int		  Scan      (unsigned int uNr,void *pMem,int iMemSize,unsigned    uBlockNr=0,int iMax=1000,int iOff=0);
	int		  Scan      (                 void *pMem,int iMemSize,unsigned    uBlockNr=0,int iMax=1000,int iOff=0);
	int		  Scan      (unsigned int uNr,void *pMem,int iMemSize,zchar      *pBlock    ,int iMax=1000,int iOff=0);
	int		  Scan      (                 void *pMem,int iMemSize,zchar      *pBlock    ,int iMax=1000,int iOff=0);
    ScanData *Data      (unsigned int uNr,int   iPos,zchar **pText1=0,zchar **pText2=0  ,int *pLen1=0,int *pLen2=0);
	ScanData *Data      (				  int   iPos,zchar **pText1=0,zchar **pText2=0  ,int *pLen1=0,int *pLen2=0);
	zchar	 *BlockName (unsigned int uBlockNr=0);
	zchar	 *ModulName (unsigned int uModulNr=0);
	int		  ModulStart(unsigned int uModulNr=0);
	int		  ModulEnd  (unsigned int uModulNr=0);
	int 	  GetParam  (unsigned int uModulNr,unsigned int uNum,int &iValue);
	int 	  GetParam  (const zchar *pModul  ,unsigned int uNum,int &iValue);
	int 	  SetParam  (unsigned int uModulNr,unsigned int uNum,int  iValue);
	int 	  SetParam  (const zchar *pModul  ,unsigned int uNum,int  iValue);
	int		  SetScanner(unsigned int uNr);
	int  	  SetFlags  (int iFlags);
	int  	  GetFlags  ();
	void	  Delete	();
	void	  DeleteScan(int iNr=-1);
	int		  BlockNumber(const zchar *pBlockName,int iModul=-1);
	int		  ModulNumber(const zchar *pModulName);
	int		  BlockCount();
	int		  ModulCount();

protected:

	#ifndef	_MSC_VER
	typedef	long long	qint
	#else
	typedef	__int64		qint;
	#endif

	void	Error		(zchar *pText,int iMode=0);	// Fehler Ausgabe
	int		DumpRead	(zchar *pMem ,int *pAdd,CStringChain *pMarks);
	int		DumpCheck	( char *pMem ,int  iNum,int iOff ,int iSize );

	int		CDataScanner::PrintValue64(qint Wert,int &iAnz,int iFlags,zchar *pBuffer,int iBufferLen,int iByteLen,int iExtNr);
	int		CDataScanner::PrintValue  (int  Wert,int &iAnz,int iFlags,zchar *pBuffer,int iBufferLen,int iByteLen,int iExtNr);

//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************
protected:

	CStringChain	m_sData;						// Daten
	CStringChain	m_sDumps;						// Bis-Dump Daten
	CStringChain	m_sFlags;						// Flag-Texte
	CStringChain	m_sBlocks;						// Block Daten
	CStringChain	m_sModuls;						// Modul Daten
	CStringChain	m_sScans  [SCAN_MAX];			// Scanner
	CStringChain	m_sStrings[SCAN_MAX];			// Temporre Text
	CTextBuffer    *m_pErrorOut;					// Fehlerausgabepuffer

	int				m_iLine;						// Aktuelle Zeilen-Nummer
	int				m_iErrorMode;					// Fehler Art (0:keine 1:prinf 2:CTextBuffer)
	int				m_iErrorCount;					// Anzahl der gefunden Fehler
	int 			m_iDefaultScan;					// Standard Auslese-Nummer
	int 			m_iGlobalFlags;					// Globale Scanner-Flags

};

#endif

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline ScanData *CDataScanner::Data    (int iPos,zchar **pText1,zchar **pText2,int *pLen1,int *pLen2){return Data(m_iDefaultScan,iPos,pText1,pText2,pLen1,pLen2);}
inline int 	     CDataScanner::GetParam(const zchar *pModul,unsigned int uNum,int &iValue){return GetParam(ModulNumber(pModul),uNum,iValue);}
inline int 	     CDataScanner::SetParam(const zchar *pModul,unsigned int uNum,int  iValue){return SetParam(ModulNumber(pModul),uNum,iValue);}
inline int       CDataScanner::Count   (){return Count(m_iDefaultScan);}
inline int       CDataScanner::Count   (unsigned int uNr){if(uNr>=SCAN_MAX)return 0;return m_sScans[uNr].Count();}
inline int       CDataScanner::Scan    (void *pMem,int iMemSize,unsigned uBlockNr,int iMax,int iOff){return Scan(m_iDefaultScan,pMem,iMemSize,uBlockNr,iMax,iOff);}
inline int       CDataScanner::Scan    (void *pMem,int iMemSize,zchar   *pBlock  ,int iMax,int iOff){return Scan(m_iDefaultScan,pMem,iMemSize,pBlock  ,iMax,iOff);}
inline int       CDataScanner::BlockCount(){return m_sBlocks.Count();}
inline int       CDataScanner::ModulCount(){return m_sModuls.Count();}
inline int       CDataScanner::SetFlags  (int iFlags){int iOld=m_iGlobalFlags;m_iGlobalFlags=iFlags;return iOld;}
inline int       CDataScanner::GetFlags  (){return m_iGlobalFlags;}
