//*****************************************************************************
//*
//*
//*		DiskIO.h
//*
//*
//*****************************************************************************
#ifndef 	__DISKIO_H__
#define 	__DISKIO_H__

#include	<winioctl.h>

#ifndef		QWORD_DEFINED
#define		QWORD_DEFINED	
typedef		unsigned __int64 QWORD;
#endif		

	BOOL  GetDriveGuid       (int   iDrive,LPSTR  pVolumeName,int iSize);
	BOOL  SetDriveGuid       (int   iDrive,LPCSTR pVolumeName);
	BOOL  DelDriveGuid       (int   iDrive);

	void *OpenDevice		 (int   iDrive,int iAccess=0,BOOL bLock=FALSE);
	BOOL  CloseDevice		 (void *hDrive,BOOL bNoMount=FALSE);
	BOOL  ReadSector		 (void *hDrive,QWORD qwStart, DWORD dwCount,      void *pBuffer);
	BOOL  WriteSector		 (void *hDrive,QWORD qwStart, DWORD dwCount,const void *pBuffer);
	INT	  GetPartitionInfo   (void *hDrive,DWORD *pNumber=0,QWORD *pStart=0,QWORD *pSize=0,GUID *pGuid=0);
	BOOL  FlushSector        (void *hDrive);

	BOOL  ReadSector		 (int   iDrive,QWORD qwStart, DWORD dwCount,      void *pBuffer);
	BOOL  WriteSector		 (int   iDrive,QWORD qwStart, DWORD dwCount,const void *pBuffer);
	INT	  GetPartitionInfo   (int   iDrive,DWORD *pNumber=0,QWORD *pStart=0,QWORD *pSize=0,GUID *pGuid=0);

	QWORD GetSectorCount	 (int   iDrive,DWORD *pSize=0);
	QWORD GetSectorCount	 (void *hDrive,DWORD *pSize=0);
	DWORD GetDriveOfVolume	 (int   iDrive,int *pPartition=0);
	DWORD GetVolumeOfDrive	 (int   iDrive);

	BOOL  FormatDisk		 (int   iDrive,MEDIA_TYPE iType=F3_1Pt44_512);
	BOOL  GetDriveData		 (int   iDrive,DISK_GEOMETRY *pDiscData);
	int	  HasAccess			 (int   iDrive,BOOL bWrite=FALSE);



#endif
