//*****************************************************************************
//*
//*
//*		FileFunctions.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//	Allgemeine File Funktioen:
//
// 		char   *GetFileType  (char*,int*=0)			Datei Typ holen
// 		char   *GetFileName  (char*,int*=0)			Datei Namen holen
// 		char   *GetFileBody  (char*,int*=0)			Datei Pfad holen
// 		char   *GetFilePath  (char*,int*=0)			Datei Pfad holen
// 		char   *GetFilePathR (char*,int*=0)			Datei Pfad holen (relativ)
// 		int		GetExeName   (char*,int=1024)		Ergibt Exe Dateinamen
// 		int		GetExePath   (char*,int=1024)		Ergibt Exe Dateipfad
//		int		FilePathLen  (char*,int)			Ergibt Lnge des Pfades bis Ebene
// 		int		FilePathLen  (char*)				Ergibt Lnge des Pfades
// 		int     FileDriveLen (char*)				Ergibt Lnge des Laufwerkes
//		int		FileNameLen  (char*)				Ergibt Lnge eines Namens
// 		int     GetFileDrive (char*)				Datei Laufwerk holen
// 		int		CreatePath   (char*,int=0)			Einen Pfad erzeugen
//		int     RemovePath   (const char *,int=0);	Pfad lschen
// 		int		ExistFile    (char*)				Prfen ob Datei vorhanden
//		int		LengthFile	 (HFILE)				Dateilnger holen
//		int		RemoveFile   (char*)		    	Lscht Datei
// 		int		AddBackSlash (char*,int=-1)			Hngt  ein '\' wenn es fehlt
// 		int		DelBackSlash (char*,int=-1)			Lscht ein '\' wenn es existiert
// 		int		HasBackSlash (char*,int=-1)			Ergibt 1 wenn ein '\' existiert
//		int		CmpFileName  (char*,char*,int=7)	Dateinamen vergleichen
//		int		CmpFileNameN (char*,char*)			Dateinamen vergleichen
//		int		CmpFileNameG (char*,char*)			Dateinamen vergleichen
//		int		CmpFileNameN (char*,char*,int,int)	Dateinamen vergleichen
//		int		CmpFileNameG (char*,char*,int,int)	Dateinamen vergleichen
//		int		SetFileName  (char*,char *,char *,int=1024)
//		int		SetFileName  (char*,	   char *,int=1024)
//		int		PathConvert  (char*,int='\')		Dateinamen '/' zu '\' tauschen
//		int		PathFullMake (char*,char*,char*,int,int)
//		int		PathOffset   (char*,char*,char*,int,int)
//		int		PathCompress (char*,char*,int)	".." und "." aus einem Dateinamen entfernen
//		int     MakeLongPath (char*,char*,int)		Einen langen  Dateinamen erzeugen
//		int     MakeShortPath(char*,char*,int)		Einen kurzen Dateinamen erzeugen
//		int		CopyFileTime (char*,char*)			Dateizeit kopieren
//		int		FindFile     (char*,WIN32_FIND_DATA*)
//		int		FindFile     (char*,WIN32_FILE_ATTRIBUTE_DATA*)

#ifndef		__FILEFUNCTIONS_H__
#define     __FILEFUNCTIONS_H__

#include	<time.h>
#include	<stdio.h>


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if		_MSC_VER > 1299
	#ifndef		WINVER
	#define		WINVER 	0x0501
	#endif
	#endif
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#endif
#else
	#include	<Windows.h>
#endif


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	zchar			wchar_t
#define		FileInfo		FileInfoW	
#define		FileInfoCb		FileInfoCbW	
#else
#define 	zchar			char
#define		FileInfo		FileInfoA	
#define		FileInfoCb		FileInfoCbA	
#endif



// Konstanden fr CopyFileProgress/CopyFolder/CountFiles
#define 	CFP_POS64		0x00000001			// Die Position ist ein 64-Bit-Wert
#define 	CFP_MAX64		0x00000002			// Der Maximalwert ist ein 64-Bit-Wert
#define 	CFP_POSADD		0x00000004			// Die Position wird zum Anfangswert addiert
#define 	CFP_FAILIFEXIST	0x00000008			// Nicht kopieren wenn die Zieldatei existiert
#define 	CFP_TEMPRENAME	0x00000010			// Zuerst in eine Temporredatei kopieren
#define 	CFP_COPYTIME	0x00000020			// Auch die Dateizeiten kopieren
#define 	CFP_COPYATTRIB	0x00000040			// Attributte mit kopieren
#define 	CFP_READONLY	0x00000080			// Auch ReadOnly Dateien berschreiben
#define 	CFP_CREATEPATH	0x00000100			// Zielpfad erzeugen falls er nicht existiert
#define 	CFP_DELETEPATH	0x00000200			// Bei Zielpfaderzeugung etweige Dateien lschen
#define 	CFP_MOVEFILE	0x00000400			// Wenn erfolgreich dann die Quelldatei lschen
#define 	CFP_FORCEMOVE	0x00000800			// Die Quelldatei auch lschen wenn sie schreibgeschtzt ist
#define 	CFP_ADDALWAYS	0x00001000			// Die Lnge auch bei Fehlern addieren
#define 	CFP_USEPATH		0x00002000			// Den Dateinamen vom Pfad entfernnen
#define 	CFP_USEPATHNEW	0x00004000			// Den Dateinamen vom Pfad entfernnen (fr Ziel)
#define 	CFP_STOPATERROR	0x00008000			// Nach jedem Fehler anhalten
#define 	CFP_RECURSIVE	0x00010000			// Auch Unterverzeichnisse beachten
#define 	CFP_DEBUGSLEEP	0x10000000			// Den Kopiervorgang verlangsammen zum Debuggen
#define 	CFP_NODONECB	0x20000000			// Keinen DONE-Callback aufrufen
#define 	CFP_ONLYINIT	0x40000000			// Nur Datenstruktur initialisieren

#define 	CFP_ACTION_FILE	0					// Eine Datei wurde gefunden
#define 	CFP_ACTION_PATH	1					// Eine Verzeichnis wurde gefunden
#define 	CFP_ACTION_COPY	2					// Eine Datei wird kopiert
#define 	CFP_ACTION_DEL	3					// Das Verzeichnis lschen
#define 	CFP_ACTION_ERR	4					// Es gab eine Fehler
#define 	CFP_ACTION_DONE	5					// Der letzte Aufruf

#define 	CFP_RET_BREAK  -1					// Den ganzen Vorgang abbrechen
#define 	CFP_RET_OK		0					// Die Datei/Pfad bernehmen 
#define 	CFP_RET_IGNORE	1					// Die Datei/Pfad auslassen

#define 	CP_FULL_LEN		0x00000000			// Bei CreatePath(...) ganzen Pfad benutzen
#define 	CP_PATH_LEN		0x0000FFFF			// Bei CreatePath(...) den Dateinamen am Ende enfrenen

#define 	CTP_USEEXE		((const void*)1)	// CTP_USEEXE	= Stat GetTempPath wird GetExePath benutzt (nur bei pName1)
#define 	CTP_UNIQUE		((const void*)2)	// CTP_UNIQUE	= Eine eindeutige 8 stellige ID anhngen
#define 	CTP_UNIADD		((const void*)3)	// CTP_UNIADD	= Eine eindeutige 8 stellige ID anhngen ohne Backslash
#define		CTP_NAMEADD		((const void*)4)	// CTP_NAMEADD	= Nur den Dateinamen des nchsten Abschnitts anhngen

#define 	CIC_NAME_MAX	8

struct		FileInfoStrA;
struct		FileInfoStrW;

typedef int (__cdecl *FileInfoCbA)(void *pParam,const char    *pPath,int iNameOffset,int iAction,FileInfoStrA *pData);
typedef int (__cdecl *FileInfoCbW)(void *pParam,const wchar_t *pPath,int iNameOffset,int iAction,FileInfoStrW *pData);


typedef struct FileInfoStrA
	{
	__int64				iSizeNow;							// Anzahl der kopierten Bytes			
	__int64				iSizeMax;							// Gesamtanzahl der zu kopierenden Bytes			
	int					iFileNow;							// Anzahl der kopierten Dateien			
	int					iFileMax;							// Gesamtanzahl der zu kopierenden Dateien			
	int					iPathNow;							// Anzahl der erstelleten Pfade			
	int					iPathMax;							// Gesamtanzahl der zu erstellenden Pfade			
	int 				iLevel;								// Ist die Pfadebene (0=Root)
	short  				sFilter;							// Anzahl der Plusfilter
	short 				sNameSize;							// Lnge des Dateinamnes (ohne Pfad)	
	__int64				iFileSize;							// Gre der Datei fr Callback
	LPWIN32_FIND_DATAA  pFileInfo;							// Datei-Infos fr fr Callback		
	const char 		   *pFilterPlus; 	   					// Ist der Plusfilter (z.B.: "*.h;*.cpp")
	const char 		   *pFilterMinus; 	   					// Ist der Plusfilter (z.B.: "*.h;*.cpp")
	void	  		   *pCurrentPos;						// Zeiger auf die Anzahl der kopierten Bytes (32/64 Bit CFP_POS64)
	void	  		   *pMaximalPos;						// Zeiger auf Gesamtanzahl der zu kopierenden Bytes (32/64 Bit CFP_MAX64)
	volatile const void*pBreakPtr;							// ber diesen Zeiger kann ein User-Abbruch ausgelst werden (mit Byte[0])
	void	   		   *pCbParam;							// User-Parameter fr Callback Funktion 
	FileInfoCbA			pCallback;							// Ist die Callback Funktion fr Datein, Pfade und Fehler.
	}FileInfoA;

typedef struct FileInfoStrW
	{
	__int64				iSizeNow;							// Anzahl der kopierten Bytes			
	__int64				iSizeMax;							// Gesamtanzahl der zu kopierenden Bytes			
	int					iFileNow;							// Anzahl der kopierten Dateien			
	int					iFileMax;							// Gesamtanzahl der zu kopierenden Dateien			
	int					iPathNow;							// Anzahl der erstelleten Pfade			
	int					iPathMax;							// Gesamtanzahl der zu erstellenden Pfade			
	int 				iLevel;								// Ist die Pfadebene (0=Root)
	short  				sFilter;							// Anzahl der Plusfilter
	short 				sNameSize;							// Lnge des Dateinamnes (ohne Pfad)	
	__int64				iFileSize;							// Gre der Datei fr Callback
	LPWIN32_FIND_DATAW  pFileInfo;							// Datei-Infos fr fr Callback		
	const wchar_t      *pFilterPlus; 	   					// Ist der Plusfilter (z.B.: "*.h;*.cpp")
	const wchar_t	   *pFilterMinus; 	   					// Ist der Plusfilter (z.B.: "*.h;*.cpp")
	void	  		   *pCurrentPos;						// Zeiger auf die Anzahl der kopierten Bytes (32/64 Bit CFP_POS64)
	void	  		   *pMaximalPos;						// Zeiger auf Gesamtanzahl der zu kopierenden Bytes (32/64 Bit CFP_MAX64)
	volatile const void*pBreakPtr;							// ber diesen Zeiger kann ein User-Abbruch ausgelst werden (mit Byte[0])
	void	   		   *pCbParam;							// User-Parameter fr Callback Funktion 
	FileInfoCbW			pCallback;							// Ist die Callback Funktion fr Datein, Pfade und Fehler.
	}FileInfoW;


//*****************************************************************************
//*
//*    Allgemeine   File-Funktioen
//*
//*****************************************************************************
// ANSI

	int  _cdecl PasteFileType    (int iLen,char *pTarget,const char *pPath,const char *pType,int iMax=1024);
	int  _cdecl PasteFileType    (int iLen,char *pTarget,                  const char *pType,int iMax=1024);
	int  _cdecl PasteFileType    (         char *pTarget,const char *pPath,const char *pType,int iMax=1024);
	int  _cdecl PasteFileType    (         char *pTarget,                  const char *pType,int iMax=1024);
	int	 _cdecl	SubFileName      (int iLen,char *pPath);		   						// letzten Eintrag lschen
	int	 _cdecl	SubFileName      (	       char *pPath);		   						// letzten Eintrag lschen
	int  _cdecl	AddFileName      (int iLen,char *pTarget,const char *pPath,const char *pName,int iMax=1024);
	int  _cdecl	AddFileName      (int iLen,char *pTarget,                  const char *pName,int iMax=1024);
	int  _cdecl	AddFileName      (         char *pTarget,const char *pPath,const char *pName,int iMax=1024);
	int  _cdecl	AddFileName      (         char *pTarget,                  const char *pName,int iMax=1024);
	int	 _cdecl SetFileType      (int iLen,char *pTarget,const char *pPath,const char *pType,int iMax=1024);
	int	 _cdecl	SetFileType      (int iLen,char *pTarget,                  const char *pType,int iMax=1024);
	int	 _cdecl SetFileType      (         char *pTarget,const char *pPath,const char *pType,int iMax=1024);
	int	 _cdecl	SetFileType      (         char *pTarget,                  const char *pType,int iMax=1024);
	int	 _cdecl SetFileName      (int iLen,char *pTarget,const char *pPath,const char *pName,int iMax=1024,int iNameSize=-1);
	int	 _cdecl	SetFileName      (int iLen,char *pTarget,                  const char *pName,int iMax=1024,int iNameSize=-1);
	int	 _cdecl SetFileName      (         char *pTarget,const char *pPath,const char *pName,int iMax=1024,int iNameSize=-1);
	int	 _cdecl	SetFileName      (         char *pTarget,                  const char *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (int iLen,char *pBuffer,const char *pPath,const char *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (int iLen,char *pBuffer,                  const char *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (         char *pBuffer,const char *pPath,const char *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (         char *pBuffer,                  const char *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFileBody      (int iLen,char *pBuffer,const char *pPath,const char *pBody,int iMax=1024,int iBodySize=-1);
	int  _cdecl SetFileBody      (int iLen,char *pBuffer,                  const char *pBody,int iMax=1024,int iBodySize=-1);
	int  _cdecl SetFileBody      (         char *pBuffer,const char *pPath,const char *pBody,int iMax=1024,int iBodySize=-1);
	int  _cdecl SetFileBody      (         char *pBuffer,                  const char *pBody,int iMax=1024,int iBodySize=-1);

	int  _cdecl	GetFileType      (char *pTarget,int iNum,const char *pPath,int iLen);	// Datei Typ holen
	int  _cdecl	GetFileType      (char *pTarget,         const char *pPath,int iLen);	// Datei Typ holen
	int  _cdecl	GetFileName      (char *pTarget,int iNum,const char *pPath,int iLen);	// Datei Namen holen
	int  _cdecl	GetFileName      (char *pTarget,         const char *pPath,int iLen);	// Datei Namen holen
	int  _cdecl	GetFileBody      (char *pTarget,int iNum,const char *pPath,int iLen);	// Datei Kern holen
	int  _cdecl	GetFileBody      (char *pTarget,         const char *pPath,int iLen);	// Datei Kern holen
	int  _cdecl	GetFilePath      (char *pTarget,         const char *pPath,int iLen);	// Datei Pfad holen
	int  _cdecl	GetFilePathR     (char *pTarget,int iNum,const char *pPath,int iLen);	// Datei Pfad holen
	int  _cdecl	GetFilePathR     (char *pTarget,         const char *pPath,int iLen);	// Datei Pfad holen
	char*_cdecl	GetFileType      (int iNum,const char *pPath,int *pLen=0);				// Datei Typ holen
	char*_cdecl	GetFileType      (         const char *pPath,int *pLen=0);				// Datei Typ holen
	char*_cdecl	GetFileName      (int iNum,const char *pPath,int *pLen=0);				// Datei Namen holen
	char*_cdecl	GetFileName      (         const char *pPath,int *pLen=0);				// Datei Namen holen
	char*_cdecl	GetFileBody      (int iLen,const char *pPath,int *pLen=0);				// Datei Kern holen
	char*_cdecl	GetFileBody      (         const char *pPath,int *pLen=0);				// Datei Kern holen
	char*_cdecl	GetFilePath      (         const char *pPath,int *pLen=0);				// Datei Pfad holen
	char*_cdecl	GetFilePathR     (int iNum,const char *pPath,int *pLen=0);				// Datei Pfad holen (relativ)
	char*_cdecl	GetFilePathR     (         const char *pPath,int *pLen=0);				// Datei Pfad holen (relativ)
	int  _cdecl	GetFileDrive     (const char *pPath);			  						// Datei Laufwerk holen
	int	 _cdecl	FilePathLen      (int iLen,const char *pPath);							// Ergibt Lnge des Pfades
	int	 _cdecl	FilePathLen      (const char *pPath,int  Ebene);						// Ergibt Lnge des Pfades bis Ebene
	int	 _cdecl	FilePathLen      (const char *pPath);		   							// Ergibt Lnge des Pfades
	int  _cdecl	FileDriveLen     (const char *pPath);		   							// Ergibt Lnge des Laufwerkes
	int  _cdecl	FileNameLen      (const char *pPath);		   							// Ergibt Lnge eines Namens
	int  _cdecl CreateTempPath   (      char *pPath,int iSize,const void *pName1,const void *pName2=0,const void *pName3=0,const void *pName4=0,int *pLen=0);
	int  _cdecl CreateTempPath   (      char *pPath,int iSize,const void *pName1,const void *pName2  ,const void *pName3,  const void *pName4,int &iLen);
	int  _cdecl CreateTempPath   (      char *pPath,int iSize,const void *pName1,const void *pName2  ,const void *pName3,int &iLen);
	int  _cdecl CreateTempPath   (      char *pPath,int iSize,const void *pName1,const void *pName2  ,int &iLen);
	int  _cdecl CreateTempPath   (      char *pPath,int iSize,const void *pName1,int &iLen);
	int	 _cdecl	CreatePath       (const char *pPath);									// Einen Pfad erzeugen
	int	 _cdecl	CreatePath       (const char *pPath,int iPathLen);						// Einen Pfad erzeugen
	int  _cdecl RemovePath       (const char *pPath,int iOnlySub=0);					// Einen Pfad lschen
	int  _cdecl RemovePath	     (const char *pPath,int iOnlySub,__int64 iDelta,const char *pFilter=0,__int64 iNow=0);
	int	 _cdecl	ExistFile        (const char *pPath);		   							// Prfen ob Datei vorhanden
	int	 _cdecl	RemoveFile       (const char *pPath);		   							// Lscht Datei
	int	 _cdecl	HasBackSlash     (const char *pPath,int iLen=-1);						// Ergibt 1 wenn ein '\' existiert
	int	 _cdecl	AddBackSlash     (      char *pPath,int iLen=-1);						// Hngt  ein '\' wenn es fehlt
	int	 _cdecl AddBackSlash     (char cSign,char *pPath,int iLen=-1);					//			*
	int	 _cdecl	DelBackSlash     (      char *pPath,int iLen=-1);						// Lscht ein '\' wenn es existiert
	int	 _cdecl	GetExeName       (      char *pPath,int iMax=1024);						// Pfad des aktuellen Programms holen
	int	 _cdecl	GetExePath       (      char *pPath,int iMax=1024);						// Verzeichnis des aktuellen Programms holen
	int  _cdecl IsFullPathName   (const char *pPath);									// Ist es ein absoluter Pfad
	int	 _cdecl	LengthFile       (const char *pPath  ,void *pLen64);		   			// Dateilnger holen
	int	 _cdecl	LengthFile       (const char *pPath  );		   							// Dateilnger holen
	int	 _cdecl	LengthFile       (FILE       *pFile  ,void *pLen64);		   			// Dateilnger holen
	int	 _cdecl	LengthFile       (FILE       *pFile  );		   							// Dateilnger holen
	int	 _cdecl	LengthFile       (HANDLE      hHandle,void *pLen64);					// Dateilnger holen
	int	 _cdecl	LengthFile       (HANDLE      hHandle);			   						// Dateilnger holen
	int	 _cdecl	LengthFile       (HFILE       hHandle,void *pLen64);					// Dateilnger holen
	int	 _cdecl	LengthFile       (HFILE       hHandle);			   						// Dateilnger holen
	int  _cdecl ChainFile        (const char *pSource,const char *pFormat=".old",int iMode=0,int iMax=0,int iPos=-1,int iDelta=1,const char *pPath=0);
	int  _cdecl ReplaceFile      (const char *pSource,const char *pTarget,int iFlags=0,const char *pBackup=0,int iForceBackup=0);
	int  _cdecl ChangeFile       (const char *pPath,int iPos,int iByte,const void *pPtr,int iSize,const char *pBackup=0,int iForceBackup=0);
	int  _cdecl CmpFileData	     (const char *pFile1,const char *pFile2);				// Dateien 	   vergleichen
	LONG _cdecl CmpFileTime      (const char *pPath1,const char *pPath2,int iMode=2);	// Dateienzeit vergleichen
	LONG _cdecl CmpFileTime      (LONGLONG    iTime1,const char *pPath2,int iMode=2);	// Dateienzeit vergleichen
	LONG _cdecl CmpFileTime      (CONST FILETIME *pTime1,const char *pPath2,int iMod=2);// Dateienzeit vergleichen
	int	 _cdecl	CmpFileType      (const char *pPath ,const char *pType,int iLen);		// Dateitypen  vergleichen
	int	 _cdecl	CmpFileType      (const char *pPath ,const char *pType );				// Dateitypen  vergleichen
	int	 _cdecl	CmpFileNameG     (const char *pPath1,const char *pPath2);				// Dateinamen  vergleichen
	int	 _cdecl	CmpFileNameN     (const char *pPath1,const char *pPath2);				// Dateinamen  vergleichen
	int	 _cdecl	CmpFileNameG     (const char *pPath1,const char *pPath2,int iLen1,int iLen2);	// Dateinamen vergleichen
	int	 _cdecl	CmpFileNameN     (const char *pPath1,const char *pPath2,int iLen1,int iLen2);	// Dateinamen vergleichen
	int	 _cdecl	CmpFileName      (const char *pPath1,const char *pPath2,int iMode=7);	// Dateinamen vergleichen
	int	 _cdecl	PathConvert      (      char *pPath ,int iMode ='\\');					// Dateinamen '/' zu '\' tauschen
	int	 _cdecl	PathConvert      (      char *pPath1,const char *pPath2,int iSize,int iMode='\\');
	int  _cdecl	PathOffset       (char *pTarget,const char *pFrom    ,const char *pTo      ,int iSize,int iLevel=1);
	int  _cdecl	PathFullMake     (char *pTarget,const char *pBasePath,const char *pFilePath,int iSize,int iLevel=1);
	int  _cdecl FindPathFile     (char *pTarget,const char *pFilename,int iMax,const char *pSufixes=0,int iType =0);
	int  _cdecl	PathCompress     (char *pTarget,const char *pPath,int iSize,int iLen,const char *pName,int iAdd);
	int  _cdecl	PathCompress     (char *pTarget,const char *pPath,int iSize,int iLen,const char *pName);
	int  _cdecl	PathCompress     (char *pTarget,const char *pPath,int iSize,int iLen);
	int  _cdecl	PathCompress     (char *pTarget,const char *pPath,int iSize);
	int  _cdecl	PathCompress     (char *pTarget                  ,int iSize);
	int  _cdecl MakeLongPath     (char *pTarget,const char *pPath,int iSize);
	int  _cdecl MakeShortPath    (char *pTarget,const char *pPath,int iSize);
	int  _cdecl CopyFileTime     (const char *pPath,const char *pTarget);
	int  _cdecl FindFile         (const char *pPath,WIN32_FIND_DATAA *pFind);
	int  _cdecl FindFile         (const char *pPath,WIN32_FILE_ATTRIBUTE_DATA *pFind);
	int  _cdecl	SaveMemory       (const char *pPath,const char    *pText);
	int  _cdecl	SaveMemory       (const char *pPath,const wchar_t *pText);
	int  _cdecl	SaveMemory       (const char *pPath,const void *pMemory,int iSize,int iAtEnd=0);
	int  _cdecl	LoadMemory       (const char *pPath,      void *pMemory,int iSize,int iFail=0);
	int  _cdecl ChangeFileTime   (const char *pPath,const FILETIME *pLastWriteTime,const FILETIME *pCreationTime= 0,const FILETIME *pLastAccessTime= 0);
	int  _cdecl ChangeFileTime   (const char *pPath,time_t          iLastWriteTime,time_t          iCreationTime=-1,time_t          iLastAccessTime=-1);
	int  _cdecl CopyFileProgress (unsigned uFlags,const char *pExistingFile,const char *pNewFileName,void *pCurrentPos,void *pMaximalPos=0,const void *pBreakPtr=0);
	int  _cdecl CopyFileProgress (const char *pExistingFile,const char *pNewFileName,int              *pCurrentPos,int              *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
	int  _cdecl CopyFileProgress (const char *pExistingFile,const char *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
	int  _cdecl CopyFileProgress (const char *pExistingFile,const char *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
	int  _cdecl CopyFileProgress (const char *pExistingFile,const char *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
unsigned _cdecl FileTime         (const char *pFilename,int iMode=0);
	BOOL _cdecl IsDots           (const char *pFilename);						// Ist es ein "." oder ".." Pfad

	int  _cdecl CountFiles		 (unsigned uFlags,const char *pPath,FileInfoA *pData); 
	int  _cdecl CountFiles		 (const char *pPath,           int   *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (const char *pPath,         __int64 *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (const char *pPath,unsigned   int   *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (const char *pPath,unsigned __int64 *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (void *pParam,FileInfoCbA pProc,const char *pPath ,const char *pFilterPlus=0,const char *pFilterMinus=0,unsigned uFlags=CFP_RECURSIVE); 

	int  _cdecl CopyFolder		 (unsigned uFlags,const char *pSourcePath,const char *pTargetPath,FileInfoA *pData); 
	int  _cdecl CopyFolder		 (const char *pSourcePath,const char *pTargetPath,           int   *pCurrentPos=0,           int   *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH); 
	int  _cdecl CopyFolder		 (const char *pSourcePath,const char *pTargetPath,         __int64 *pCurrentPos  ,         __int64 *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH|CFP_POS64|CFP_MAX64); 
	int  _cdecl CopyFolder		 (const char *pSourcePath,const char *pTargetPath,unsigned   int   *pCurrentPos  ,unsigned   int   *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH); 
	int  _cdecl CopyFolder		 (const char *pSourcePath,const char *pTargetPath,unsigned __int64 *pCurrentPos  ,unsigned __int64 *pMaximalPos=0,const char *pFilterPlus=0,const char *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH|CFP_POS64|CFP_MAX64); 
	int  _cdecl CopyFolder		 (void *pParam,FileInfoCbA pProc,const char *pSourcePath,const char *pTargetPath,const char *pFilterPlus=0,const char *pFilterMinus=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH); 


// UNICODE

	int  _cdecl PasteFileType    (int iLen,wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pType,int iMax=1024);
	int  _cdecl PasteFileType    (int iLen,wchar_t *pTarget,                     const wchar_t *pType,int iMax=1024);
	int  _cdecl PasteFileType    (         wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pType,int iMax=1024);
	int  _cdecl PasteFileType    (         wchar_t *pTarget,                     const wchar_t *pType,int iMax=1024);
	int	 _cdecl	SubFileName      (int iLen,wchar_t *pPath);		   						// letzten Eintrag lschen
	int	 _cdecl	SubFileName      (	       wchar_t *pPath);		   						// letzten Eintrag lschen
	int  _cdecl	AddFileName      (int iLen,wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pName,int iMax=1024);
	int  _cdecl	AddFileName      (int iLen,wchar_t *pTarget,                     const wchar_t *pName,int iMax=1024);
	int  _cdecl	AddFileName      (         wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pName,int iMax=1024);
	int  _cdecl	AddFileName      (         wchar_t *pTarget,                     const wchar_t *pName,int iMax=1024);
	int	 _cdecl SetFileType      (int iLen,wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pType,int iMax=1024);
	int	 _cdecl	SetFileType      (int iLen,wchar_t *pTarget,                     const wchar_t *pType,int iMax=1024);
	int	 _cdecl SetFileType      (         wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pType,int iMax=1024);
	int	 _cdecl	SetFileType      (         wchar_t *pTarget,                     const wchar_t *pType,int iMax=1024);
	int	 _cdecl SetFileName      (int iLen,wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int	 _cdecl	SetFileName      (int iLen,wchar_t *pTarget,                     const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int	 _cdecl SetFileName      (         wchar_t *pTarget,const wchar_t *pPath,const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int	 _cdecl	SetFileName      (         wchar_t *pTarget,                     const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFilePath      (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax=1024,int iNameSize=-1);
	int  _cdecl SetFileBody      (int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pBody,int iMax=1024,int iBodySize=-1);
	int  _cdecl SetFileBody      (int iLen,wchar_t *pBuffer,                     const wchar_t *pBody,int iMax=1024,int iBodySize=-1);
	int  _cdecl SetFileBody      (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pBody,int iMax=1024,int iBodySize=-1);
	int  _cdecl SetFileBody      (         wchar_t *pBuffer,                     const wchar_t *pBody,int iMax=1024,int iBodySize=-1);
	

	int  _cdecl	GetFileType      (wchar_t *pTarget,int iNum,const wchar_t *pPath,int iLen);// Datei Typ holen
	int  _cdecl	GetFileType      (wchar_t *pTarget,         const wchar_t *pPath,int iLen);// Datei Typ holen
	int  _cdecl	GetFileName      (wchar_t *pTarget,int iNum,const wchar_t *pPath,int iLen);// Datei Namen holen
	int  _cdecl	GetFileName      (wchar_t *pTarget,         const wchar_t *pPath,int iLen);// Datei Namen holen
	int  _cdecl	GetFileBody      (wchar_t *pTarget,int iNum,const wchar_t *pPath,int iLen);// Datei Kern holen
	int  _cdecl	GetFileBody      (wchar_t *pTarget,         const wchar_t *pPath,int iLen);// Datei Pfad holen
	int  _cdecl	GetFilePath      (wchar_t *pTarget,         const wchar_t *pPath,int iLen);// Datei Pfad holen
	int  _cdecl	GetFilePathR     (wchar_t *pTarget,int iNum,const wchar_t *pPath,int iLen);// Datei Pfad holen
	int  _cdecl	GetFilePathR     (wchar_t *pTarget,         const wchar_t *pPath,int iLen);// Datei Pfad holen
	wchar_t * _cdecl	GetFileType  (int iNum,const wchar_t *pPath,int *pLen=0);		// Datei Typ holen
	wchar_t * _cdecl	GetFileType  (         const wchar_t *pPath,int *pLen=0);		// Datei Typ holen
	wchar_t * _cdecl	GetFileName  (int iNum,const wchar_t *pPath,int *pLen=0);		// Datei Namen holen
	wchar_t * _cdecl	GetFileName  (         const wchar_t *pPath,int *pLen=0);		// Datei Namen holen
	wchar_t * _cdecl	GetFileBody  (int iNum,const wchar_t *pPath,int *pLen=0);		// Datei Kern holen
	wchar_t * _cdecl	GetFileBody  (         const wchar_t *pPath,int *pLen=0);		// Datei Kern holen
	wchar_t * _cdecl	GetFilePath  (         const wchar_t *pPath,int *pLen=0);		// Datei Pfad holen
	wchar_t * _cdecl	GetFilePathR (int iNum,const wchar_t *pPath,int *pLen=0);		// Datei Pfad holen (relativ)
	wchar_t * _cdecl	GetFilePathR (         const wchar_t *pPath,int *pLen=0);		// Datei Pfad holen (relativ)
	int  _cdecl	GetFileDrive     (const wchar_t *pPath);			  					// Datei Laufwerk holen
	int	 _cdecl	FilePathLen      (int iLen,const wchar_t *pPath);						// Ergibt Lnge des Pfades
	int	 _cdecl	FilePathLen      (const wchar_t *pPath,int  Ebene);						// Ergibt Lnge des Pfades bis Ebene
	int	 _cdecl	FilePathLen      (const wchar_t *pPath);		   						// Ergibt Lnge des Pfades
	int  _cdecl	FileDriveLen     (const wchar_t *pPath);		   						// Ergibt Lnge des Laufwerkes
	int  _cdecl	FileNameLen      (const wchar_t *pPath);		   						// Ergibt Lnge eines Namens
	int  _cdecl CreateTempPath   (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2=0,const void *pName3=0,const void *pName4=0,int *pLen=0);
	int  _cdecl CreateTempPath   (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2  ,const void *pName3,  const void *pName4,int &iLen);
	int  _cdecl CreateTempPath   (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2  ,const void *pName3,int &iLen);
	int  _cdecl CreateTempPath   (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2  ,int &iLen);
	int  _cdecl CreateTempPath   (      wchar_t *pPath,int iSize,const void *pName1,int &iLen);
	int	 _cdecl	CreatePath       (const wchar_t *pPath);								// Einen Pfad erzeugen
	int	 _cdecl	CreatePath       (const wchar_t *pPath,int iPathLen);					// Einen Pfad erzeugen
	int  _cdecl RemovePath       (const wchar_t *pPath,int iOnlySub=0);					// Einen Pfad lschen
	int  _cdecl RemovePath	     (const wchar_t *pPath,int iOnlySub,__int64 iDelta,const wchar_t *pFilter=0,__int64 iNow=0);
	int	 _cdecl	ExistFile        (const wchar_t *pPath);		   						// Prfen ob Datei vorhanden
	int	 _cdecl	RemoveFile       (const wchar_t *pPath);		   						// Lscht Datei
	int	 _cdecl	HasBackSlash     (const wchar_t *pPath,int iLen=-1);					// Ergibt 1 wenn ein '\' existiert
	int	 _cdecl	AddBackSlash     (      wchar_t *pPath,int iLen=-1);					// Hngt  ein '\' wenn es fehlt
	int	 _cdecl AddBackSlash     (wchar_t cSign,wchar_t *pPath,int iLen=-1);			//			*
	int	 _cdecl	DelBackSlash     (      wchar_t *pPath,int iLen=-1);					// Lscht ein '\' wenn es existiert
	int	 _cdecl	GetExeName       (      wchar_t *pPath,int iMax=1024);					// Pfad es aktuellen Programms holen
	int	 _cdecl	GetExePath       (      wchar_t *pPath,int iMax=1024);					// Verzeichnis es aktuellen Programms holen
	int  _cdecl IsFullPathName   (const wchar_t *pPath);								// Ist es ein absoluter Pfad
	int	 _cdecl	LengthFile       (const wchar_t *pPath);		   						// Dateilnger holen
	int	 _cdecl	LengthFile       (const wchar_t *pPath,void *pLen64);					// Dateilnger holen
	int  _cdecl ChainFile        (const wchar_t *pSource,const wchar_t *pFormat=L".old",int iMode=0,int iMax=0,int iPos=-1,int iDelta=1,const wchar_t *pPath=0);
	int  _cdecl ReplaceFile      (const wchar_t *pSource,const wchar_t *pTarget,int iFlags=0,const wchar_t *pBackup=0,int iForceBackup=0);
	int  _cdecl ChangeFile       (const wchar_t *pPath,int iPos,int iByte,const void *pPtr,int iSize,const wchar_t *pBackup=0,int iForceBackup=0);
	int  _cdecl CmpFileData	     (const wchar_t *pFile1,const wchar_t *pFile2);				// Dateien 	   vergleichen
	LONG _cdecl CmpFileTime      (const wchar_t *pPath1,const wchar_t *pPath2,int iMode=2); // Dateienzeit vergleichen
	LONG _cdecl CmpFileTime      (LONGLONG       iTime1,const wchar_t *pPath2,int iMode=2);	// Dateienzeit vergleichen
	LONG _cdecl CmpFileTime      (CONST FILETIME*pTime1,const wchar_t *pPath2,int iMode=2);	// Dateienzeit vergleichen
	int	 _cdecl	CmpFileType      (const wchar_t *pPath ,const wchar_t *pType ,int iLen);	// Dateitypen vergleichen
	int	 _cdecl	CmpFileType      (const wchar_t *pPath ,const wchar_t *pType );				// Dateitypen  vergleichen
	int	 _cdecl	CmpFileNameG     (const wchar_t *pPath1,const wchar_t *pPath2);				// Dateinamen  vergleichen
	int	 _cdecl	CmpFileNameN     (const wchar_t *pPath1,const wchar_t *pPath2);				// Dateinamen  vergleichen
	int	 _cdecl	CmpFileNameG     (const wchar_t *pPath1,const wchar_t *pPath2,int iLen1,int iLen2);	// Dateinamen vergleichen
	int	 _cdecl	CmpFileNameN     (const wchar_t *pPath1,const wchar_t *pPath2,int iLen1,int iLen2);	// Dateinamen vergleichen
	int	 _cdecl	CmpFileName      (const wchar_t *pPath1,const wchar_t *pPath2,int iMode=7);			// Dateinamen vergleichen
	int	 _cdecl	PathConvert      (      wchar_t *pPath ,int iMode ='\\');	 						// Dateinamen '/' zu '\' tauschen
	int	 _cdecl	PathConvert      (      wchar_t *pPath1,const wchar_t *pPath2,int iSize,int iMode='\\');
	int  _cdecl	PathOffset       (wchar_t *pTarget,const wchar_t *pFrom    ,const wchar_t *pTo      ,int iSize,int iLevel=1);
	int  _cdecl	PathFullMake     (wchar_t *pTarget,const wchar_t *pBasePath,const wchar_t *pFilePath,int iSize,int iLevel=1);
	int  _cdecl FindPathFile     (wchar_t *pTarget,const wchar_t *pFilename,int iMax,const wchar_t *pSufixes=0,int iType =0);
	int  _cdecl	PathCompress     (wchar_t *pTarget,const wchar_t *pPath,int iSize,int iLen,const wchar_t *pName,int iAdd);
	int  _cdecl	PathCompress     (wchar_t *pTarget,const wchar_t *pPath,int iSize,int iLen,const wchar_t *pName);
	int  _cdecl	PathCompress     (wchar_t *pTarget,const wchar_t *pPath,int iSize,int iLen);
	int  _cdecl	PathCompress     (wchar_t *pTarget,const wchar_t *pPath,int iSize);
	int  _cdecl	PathCompress     (wchar_t *pPath                       ,int iSize);
	int  _cdecl MakeLongPath     (wchar_t *pTarget,const wchar_t *pPath,int iSize);
	int  _cdecl MakeShortPath    (wchar_t *pTarget,const wchar_t *pPath,int iSize);
	int  _cdecl CopyFileTime     (const wchar_t *pPath,const wchar_t *pTarget);
	int  _cdecl FindFile         (const wchar_t *pPath,WIN32_FIND_DATAW *pFind);
	int  _cdecl FindFile         (const wchar_t *pPath,WIN32_FILE_ATTRIBUTE_DATA *pFind);
	int  _cdecl	SaveMemory       (const wchar_t *pPath,const char    *pText);
	int  _cdecl	SaveMemory       (const wchar_t *pPath,const wchar_t *pText);
	int  _cdecl	SaveMemory       (const wchar_t *pPath,const void *pMemory,int iSize,int iAtEnd=0);
	int  _cdecl	LoadMemory       (const wchar_t *pPath,      void *pMemory,int iSize,int iFail=0);
	int  _cdecl ChangeFileTime   (const wchar_t *pPath,const FILETIME *pLastWriteTime,const FILETIME *pCreationTime= 0,const FILETIME *pLastAccessTime= 0);
	int  _cdecl ChangeFileTime   (const wchar_t *pPath,time_t          iLastWriteTime,time_t          iCreationTime=-1,time_t          iLastAccessTime=-1);
	int  _cdecl CopyFileProgress (unsigned uFlags,const wchar_t *pExistingFile,const wchar_t *pNewFileName,void *pCurrentPos=0,void *pMaximalPos=0,const void *pBreakPtr=0);
	int  _cdecl CopyFileProgress (const wchar_t *pExistingFile,const wchar_t *pNewFileName,int              *pCurrentPos,int              *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
	int  _cdecl CopyFileProgress (const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
	int  _cdecl CopyFileProgress (const wchar_t *pExistingFile,const wchar_t *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
	int  _cdecl CopyFileProgress (const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos=0,const void volatile *pBreakPtr=0,unsigned uFlags=0);
unsigned _cdecl FileTime         (const wchar_t *pFilename,int iMode=0);
	BOOL _cdecl IsDots           (const wchar_t *pFilename);					// Ist es ein "." oder ".." Pfad

	int  _cdecl CountFiles		 (unsigned uFlags,const wchar_t *pPath,FileInfoW *pData); 
	int  _cdecl CountFiles		 (const wchar_t *pPath,           int   *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (const wchar_t *pPath,         __int64 *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (const wchar_t *pPath,unsigned   int   *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (const wchar_t *pPath,unsigned __int64 *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE); 
	int  _cdecl CountFiles		 (void *pParam,FileInfoCbA pProc,const wchar_t *pPath ,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,unsigned uFlags=CFP_RECURSIVE); 
		 				  		 
	int  _cdecl CopyFolder		 (unsigned uFlags,const wchar_t *pSourcePath,const wchar_t *pTargetPath,FileInfoW *pData); 
	int  _cdecl CopyFolder		 (const wchar_t *pSourcePath,const wchar_t *pTargetPath,           int   *pCurrentPos=0,           int   *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH); 
	int  _cdecl CopyFolder		 (const wchar_t *pSourcePath,const wchar_t *pTargetPath,         __int64 *pCurrentPos  ,         __int64 *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH|CFP_POS64|CFP_MAX64); 
	int  _cdecl CopyFolder		 (const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned   int   *pCurrentPos  ,unsigned   int   *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH); 
	int  _cdecl CopyFolder		 (const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned __int64 *pCurrentPos  ,unsigned __int64 *pMaximalPos=0,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,const void volatile *pBreakPtr=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH|CFP_POS64|CFP_MAX64); 
	int  _cdecl CopyFolder		 (void *pParam,FileInfoCbA pProc,const wchar_t *pSourcePath,const wchar_t *pTargetPath,const wchar_t *pFilterPlus=0,const wchar_t *pFilterMinus=0,unsigned uFlags=CFP_RECURSIVE|CFP_CREATEPATH); 

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

	int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2=0,const void *pName3=0,const void *pName4=0,int *pLen=0);
	int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2  ,const void *pName3,  const void *pName4,int &iLen);
	int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2  ,const void *pName3,int &iLen);
	int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2  ,int &iLen);
	int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,int &iLen);
	int	 _cdecl	PasteFileType (CString &sTarget,const zchar *pPath,const zchar *pType);
	int	 _cdecl	PasteFileType (CString &sTarget,CString &sSource  ,const zchar *pType);
	int	 _cdecl	PasteFileType (CString &sTarget,				   const zchar *pType);
	int  _cdecl	AddFileName   (CString &sTarget,const zchar *pPath,const zchar *pName);
	int  _cdecl	AddFileName   (CString &sTarget,CString &sSource  ,const zchar *pName);
	int  _cdecl	AddFileName   (CString &sTarget,				   const zchar *pName);
	int	 _cdecl	SetFileType   (CString &sTarget,const zchar *pPath,const zchar *pType);
	int	 _cdecl	SetFileType   (CString &sTarget,CString &sSource  ,const zchar *pType);
	int	 _cdecl	SetFileType   (CString &sTarget,				   const zchar *pType);
	int	 _cdecl	SetFileName   (CString &sTarget,const zchar *pPath,const zchar *pName,int iNameSize=-1);
	int	 _cdecl	SetFileName   (CString &sTarget,CString &sSource  ,const zchar *pName,int iNameSize=-1);
	int	 _cdecl	SetFileName   (CString &sTarget,				   const zchar *pName,int iNameSize=-1);
	int	 _cdecl	SetFilePath   (CString &sTarget,const zchar *pPath,const zchar *pName,int iNameSize=-1);
	int	 _cdecl	SetFilePath   (CString &sTarget,CString &sSource  ,const zchar *pName,int iNameSize=-1);
	int	 _cdecl	SetFilePath   (CString &sTarget,				   const zchar *pName,int iNameSize=-1);
	int	 _cdecl	SetFileBody   (CString &sTarget,const zchar *pPath,const zchar *pBody,int iBodySize=-1);
	int	 _cdecl	SetFileBody   (CString &sTarget,CString &sSource  ,const zchar *pBody,int iBodySize=-1);
	int	 _cdecl	SetFileBody   (CString &sTarget,				   const zchar *pBody,int iBodySize=-1);

	int	 _cdecl	GetFileBody   (CString &sTarget,const zchar *pPath);			// Datei Kern holen
	int	 _cdecl	GetFilePath   (CString &sTarget,const zchar *pPath);			// Datei Pfad holen
	int	 _cdecl	GetFilePathR  (CString &sTarget,const zchar *pPath);			// Datei Pfad holen
	int	 _cdecl	GetFileType   (CString &sTarget,const zchar *pPath);			// Datei Typ holen
	int	 _cdecl	GetFileName   (CString &sTarget,const zchar *pPath);			// Datei Namen holen
	int	 _cdecl	SubFileName   (CString &sPath);				  					// letzten Eintrag lschen
	int	 _cdecl	AddBackSlash  (CString &sPath);				  					// Hngt  ein '\' wenn es fehlt
	int	 _cdecl	AddBackSlash  (CString &sPath,zchar cSign);	  					// Hngt  ein '\' wenn es fehlt
	int	 _cdecl	DelBackSlash  (CString &sPath);				  					// Lscht ein '\' wenn es existiert
	int	 _cdecl	GetExeName    (CString &sPath);				  					// Dateinamen der Exe-Datei holen
	int	 _cdecl	GetExePath    (CString &sPath);				  					// Dateipfad  der Exe-Datei holen
	int	 _cdecl	PathConvert   (CString &sTarget,int iMode ='\\');				// Dateinamen '/' zu '\' tauschen
	int  _cdecl	PathCompress  (CString &sPath);				  					// Dateinamen zusammen krzen
	int  _cdecl	PathCompress  (CString &sTarget,const zchar *pPath);			// Dateinamen zusammen krzen
	int  _cdecl	PathCompress  (CString &sTarget,const zchar *pPath,int iLen);	// Dateinamen zusammen krzen
	int  _cdecl	PathOffset    (CString &sTarget,const zchar *pFrom    ,const zchar *pTo      ,int iLevel=1);
	int  _cdecl	PathFullMake  (CString &sTarget,const zchar *pBasePath,const zchar *pFilePath,int iLevel=1);
	int  _cdecl FindPathFile  (CString &sTarget,const zchar *pFilename,const zchar *pSufixes=0,int iType=0);
	int  _cdecl MakeLongPath  (CString &sTarget,const zchar *pPath);
	int  _cdecl MakeShortPath (CString &sTarget,const zchar *pPath);

#endif

//*****************************************************************************
//*
//*		Diverse Funktionen
//*
//*****************************************************************************

#ifdef _MSC_VER
#if    _MSC_VER < 1299
typedef time_t __time32_t;
#endif
#endif

BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,LPDWORD   pUtcTime);
BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,LONGLONG *pUtcTime);
BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,unsigned *pUtcTime);
BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,__time32_t *pUtcTime);
BOOL _cdecl UtcTimeToFileTime(LONGLONG iUtcTime,FILETIME *pFileTime);

LONG _cdecl CmpFileTime      (CONST FILETIME *pTime1,CONST FILETIME *pTime2,int iMode=2);
LONG _cdecl CmpFileTime      (CONST FILETIME *pTime1,LONGLONG        iTime2,int iMode=2);
LONG _cdecl CmpFileTime      (LONGLONG        iTime1,CONST FILETIME *pTime2,int iMode=2);
LONG _cdecl CmpFileTime      (LONGLONG        iTime1,LONGLONG        iTime2,int iMode=2);

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

#ifndef 	_DEBUG

	#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

	inline int	    _cdecl PathConvert   (CString &sPath,int iMode){return PathConvert((zchar*)((const zchar*)sPath),iMode);}
	inline int      _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int &iLen){return CreateTempPath(sTarget,pName1,pName2,pName3,pName4,&iLen);}
	inline int      _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2,const void *pName3                   ,int &iLen){return CreateTempPath(sTarget,pName1,pName2,pName3,0     ,&iLen);}
	inline int      _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2                                      ,int &iLen){return CreateTempPath(sTarget,pName1,pName2,0     ,0     ,&iLen);}
	inline int      _cdecl CreateTempPath(CString &sTarget,const void *pName1                                                         ,int &iLen){return CreateTempPath(sTarget,pName1,0     ,0     ,0     ,&iLen);}

	#endif

	inline int   	_cdecl PathCompress    (         char    *pTarget,const char    *pPath,int iSize,int iLen,const char    *pName){return PathCompress(pTarget,pPath,iSize,iLen,pName,strlen(pName));}
	inline int   	_cdecl PathCompress    (         wchar_t *pTarget,const wchar_t *pPath,int iSize,int iLen,const wchar_t *pName){return PathCompress(pTarget,pPath,iSize,iLen,pName,wcslen(pName));}
	inline int   	_cdecl PathCompress    (         char    *pPath,int iSize){return PathCompress(pPath,pPath,iSize);}
	inline int   	_cdecl PathCompress    (         wchar_t *pPath,int iSize){return PathCompress(pPath,pPath,iSize);}

	inline int   	_cdecl SubFileName     (         char    *pPath){return SubFileName((int)strlen(pPath),pPath);}
	inline int   	_cdecl SubFileName     (         wchar_t *pPath){return SubFileName((int)wcslen(pPath),pPath);}

	inline int      _cdecl AddFileName     (int iLen,char    *pBuffer,                     const char    *pName,int iMax){return AddFileName  (iLen                ,pBuffer,pBuffer,pName,iMax);}
	inline int      _cdecl AddFileName     (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax){return AddFileName  (iLen                ,pBuffer,pBuffer,pName,iMax);}
	inline int      _cdecl AddFileName     (         char    *pBuffer,                     const char    *pName,int iMax){return AddFileName  ((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax);}
	inline int      _cdecl AddFileName     (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax){return AddFileName  ((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax);}
	inline int      _cdecl AddFileName     (         char    *pBuffer,const char    *pPath,const char    *pName,int iMax){return AddFileName  ((int)strlen(pPath  ),pBuffer,pPath  ,pName,iMax);}
	inline int      _cdecl AddFileName     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax){return AddFileName  ((int)wcslen(pPath  ),pBuffer,pPath  ,pName,iMax);}

	inline int   	_cdecl PasteFileType   (int iLen,char    *pBuffer,                     const char    *pType,int iMax){return PasteFileType(iLen                ,pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl PasteFileType   (int iLen,wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return PasteFileType(iLen                ,pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl PasteFileType   (         char    *pBuffer,                     const char    *pType,int iMax){return PasteFileType((int)strlen(pBuffer),pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl PasteFileType   (         wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return PasteFileType((int)wcslen(pBuffer),pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl PasteFileType   (         char    *pBuffer,const char    *pPath,const char    *pType,int iMax){return PasteFileType((int)strlen(pPath)  ,pBuffer,pPath  ,pType,iMax);}
	inline int   	_cdecl PasteFileType   (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pType,int iMax){return PasteFileType((int)wcslen(pPath)  ,pBuffer,pPath  ,pType,iMax);}

	inline int   	_cdecl SetFileType     (int iLen,char    *pBuffer,                     const char    *pType,int iMax){return SetFileType  ((int)strlen(pBuffer),pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl SetFileType     (int iLen,wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return SetFileType  ((int)wcslen(pBuffer),pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl SetFileType     (         char    *pBuffer,                     const char    *pType,int iMax){return SetFileType  ((int)strlen(pBuffer),pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl SetFileType     (         wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return SetFileType  ((int)wcslen(pBuffer),pBuffer,pBuffer,pType,iMax);}
	inline int   	_cdecl SetFileType     (         char    *pBuffer,const char    *pPath,const char    *pType,int iMax){return SetFileType  ((int)strlen(pPath  ),pBuffer,pPath  ,pType,iMax);}
	inline int   	_cdecl SetFileType     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pType,int iMax){return SetFileType  ((int)wcslen(pPath  ),pBuffer,pPath  ,pType,iMax);}
																														  
	inline int   	_cdecl SetFileName     (int iLen,char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFileName((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFileName     (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFileName((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFileName     (         char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFileName((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFileName     (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFileName((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFileName     (         char    *pBuffer,const char    *pPath,const char    *pName,int iMax,int iNameSize){return SetFileName((int)strlen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFileName     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax,int iNameSize){return SetFileName((int)wcslen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}

	inline int   	_cdecl SetFilePath     (int iLen,char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFilePath((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFilePath     (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFilePath((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFilePath     (         char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFilePath((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFilePath     (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFilePath((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFilePath     (         char    *pBuffer,const char    *pPath,const char    *pName,int iMax,int iNameSize){return SetFilePath((int)strlen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}
	inline int   	_cdecl SetFilePath     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax,int iNameSize){return SetFilePath((int)wcslen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}

	inline int   	_cdecl SetFileBody     (int iLen,char    *pBuffer,                     const char    *pBody,int iMax,int iBodySize){return SetFileBody((int)strlen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
	inline int   	_cdecl SetFileBody     (int iLen,wchar_t *pBuffer,                     const wchar_t *pBody,int iMax,int iBodySize){return SetFileBody((int)wcslen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
	inline int   	_cdecl SetFileBody     (         char    *pBuffer,                     const char    *pBody,int iMax,int iBodySize){return SetFileBody((int)strlen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
	inline int   	_cdecl SetFileBody     (         wchar_t *pBuffer,                     const wchar_t *pBody,int iMax,int iBodySize){return SetFileBody((int)wcslen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
	inline int   	_cdecl SetFileBody     (         char    *pBuffer,const char    *pPath,const char    *pBody,int iMax,int iBodySize){return SetFileBody((int)strlen(pPath  ),pBuffer,pPath  ,pBody,iMax,iBodySize);}
	inline int   	_cdecl SetFileBody     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pBody,int iMax,int iBodySize){return SetFileBody((int)wcslen(pPath  ),pBuffer,pPath  ,pBody,iMax,iBodySize);}


	inline int   	_cdecl CmpFileType     (const char    *pPath ,const char    *pType){return CmpFileType(pPath,pType,(int)strlen(pPath));}
	inline int   	_cdecl CmpFileType     (const wchar_t *pPath ,const wchar_t *pType){return CmpFileType(pPath,pType,(int)wcslen(pPath));}

	inline int   	_cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,int              *pCurrentPos,int              *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,int              *pCurrentPos,int              *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
	inline int   	_cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}

	inline int   	_cdecl GetFileType     (char *pTarget,const char *pPath,int iLen){return GetFileType (pTarget,(int)strlen(pPath),pPath,iLen);}
	inline int   	_cdecl GetFileName     (char *pTarget,const char *pPath,int iLen){return GetFileName (pTarget,(int)strlen(pPath),pPath,iLen);}
	inline int   	_cdecl GetFileBody     (char *pTarget,const char *pPath,int iLen){return GetFileBody (pTarget,(int)strlen(pPath),pPath,iLen);}
	inline int   	_cdecl GetFilePathR    (char *pTarget,const char *pPath,int iLen){return GetFilePathR(pTarget,(int)strlen(pPath),pPath,iLen);}
	inline char* 	_cdecl GetFileType     (const char *pPath,int *pLen){return GetFileType ((int)strlen(pPath),pPath,pLen);}
	inline char* 	_cdecl GetFileName     (const char *pPath,int *pLen){return GetFileName ((int)strlen(pPath),pPath,pLen);}
	inline char* 	_cdecl GetFileBody     (const char *pPath,int *pLen){return GetFileBody ((int)strlen(pPath),pPath,pLen);}
	inline char* 	_cdecl GetFilePathR    (const char *pPath,int *pLen){return GetFilePathR((int)strlen(pPath),pPath,pLen);}

	inline int   	_cdecl GetFileType     (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFileType (pTarget,(int)wcslen(pPath),pPath,iLen);}
	inline int   	_cdecl GetFileName     (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFileName (pTarget,(int)wcslen(pPath),pPath,iLen);}
	inline int   	_cdecl GetFileBody     (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFileBody (pTarget,(int)wcslen(pPath),pPath,iLen);}
	inline int   	_cdecl GetFilePathR    (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFilePathR(pTarget,(int)wcslen(pPath),pPath,iLen);}
	inline wchar_t* _cdecl GetFileType     (const wchar_t *pPath,int *pLen){return GetFileType ((int)wcslen(pPath),pPath,pLen);}
	inline wchar_t* _cdecl GetFileName     (const wchar_t *pPath,int *pLen){return GetFileName ((int)wcslen(pPath),pPath,pLen);}
	inline wchar_t* _cdecl GetFileBody     (const wchar_t *pPath,int *pLen){return GetFileBody ((int)wcslen(pPath),pPath,pLen);}
	inline wchar_t* _cdecl GetFilePathR    (const wchar_t *pPath,int *pLen){return GetFilePathR((int)wcslen(pPath),pPath,pLen);}

	inline int		_cdecl FilePathLen     (const char    *pPath){return FilePathLen((int)strlen(pPath),pPath);}
	inline int		_cdecl FilePathLen     (const wchar_t *pPath){return FilePathLen((int)wcslen(pPath),pPath);}

	inline int      _cdecl SaveMemory      (const char    *pPath,const char    *pText){return SaveMemory(pPath,pText,(int)strlen(pText));}
	inline int      _cdecl SaveMemory      (const char    *pPath,const wchar_t *pText){return SaveMemory(pPath,pText,(int)wcslen(pText)*sizeof(wchar_t));}
	inline int      _cdecl SaveMemory      (const wchar_t *pPath,const char    *pText){return SaveMemory(pPath,pText,(int)strlen(pText));}
	inline int      _cdecl SaveMemory      (const wchar_t *pPath,const wchar_t *pText){return SaveMemory(pPath,pText,(int)wcslen(pText)*sizeof(wchar_t));}

	inline BOOL		_cdecl IsDots          (const char    *pPath){if(pPath[0]!='.')return FALSE;if(pPath[1]== 0 )return TRUE;if(pPath[1]=='.' && pPath[2]==0){return TRUE;}return FALSE;}
	inline BOOL		_cdecl IsDots          (const wchar_t *pPath){if(pPath[0]!='.')return FALSE;if(pPath[1]== 0 )return TRUE;if(pPath[1]=='.' && pPath[2]==0){return TRUE;}return FALSE;}

	inline BOOL     _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,unsigned *pUtcTime){return FileTimeToUtcTime(pFileTime,(LPDWORD)pUtcTime);}

	inline int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3                   ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1,const void *pName2                                      ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,0     ,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1                                                         ,int &iLen){return CreateTempPath(pPath,iSize,pName1,0     ,0     ,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3                   ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2                                      ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,0     ,0,&iLen);}
	inline int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1                                                         ,int &iLen){return CreateTempPath(pPath,iSize,pName1,0     ,0     ,0,&iLen);}

	inline int _cdecl CountFiles(const char *pPath,__int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CountFiles(uFlags|CFP_MAX64,pPath,&sData);
	}

	inline int _cdecl CountFiles(const char *pPath,  int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CountFiles(uFlags,pPath,&sData);
	}

	inline int _cdecl CountFiles(void *pParam,FileInfoCbA pProc,const char *pPath,const char *pFilterPlus,const char *pFilterMinus,unsigned uFlags)
	{
	FileInfoA	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

	return CountFiles(uFlags,pPath,&sData);
	}

	inline int _cdecl CountFiles(const char *pPath,unsigned __int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
	inline int _cdecl CountFiles(const char *pPath,unsigned   int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

	inline int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,__int64 *pCurrentPos,__int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CopyFolder(uFlags|CFP_MAX64,pSourcePath,pTargetPath,&sData);
	}
	inline int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,  int   *pCurrentPos,  int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
	}

	inline int _cdecl CopyFolder(void *pParam,FileInfoCbA pProc,const char *pSourcePath,const char *pTargetPath,const char *pFilterPlus,const char *pFilterMinus,unsigned uFlags)
	{
	FileInfoA	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

	return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
	}

	inline int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(__int64*)pCurrentPos,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
	inline int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,unsigned   int   *pCurrentPos,unsigned   int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(  int  *)pCurrentPos,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

	inline int _cdecl CountFiles(const wchar_t *pPath,__int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CountFiles(uFlags|CFP_MAX64,pPath,&sData);
	}
	inline int _cdecl CountFiles(const wchar_t *pPath,  int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CountFiles(uFlags,pPath,&sData);
	}

	inline int _cdecl CountFiles(void *pParam,FileInfoCbW pProc,const wchar_t *pPath,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,unsigned uFlags)
	{
	FileInfoW	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

	return CountFiles(uFlags,pPath,&sData);
	}

	inline int _cdecl CountFiles(const wchar_t *pPath,unsigned __int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
	inline int _cdecl CountFiles(const wchar_t *pPath,unsigned   int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

	inline int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned __int64 *pCurrentPos,__int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CopyFolder(uFlags|CFP_MAX64,pSourcePath,pTargetPath,&sData);
	}

	inline int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned   int   *pCurrentPos,  int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
	{
	FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

	return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
	}

	inline int _cdecl CopyFolder(void *pParam,FileInfoCbW pProc,const wchar_t *pSourcePath,const wchar_t *pTargetPath,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,unsigned uFlags)
	{
	FileInfoW	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

	return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
	}

	inline int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(__int64*)pCurrentPos,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
	inline int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned   int   *pCurrentPos,unsigned   int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(  int  *)pCurrentPos,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

#endif


#endif



