//*****************************************************************************
//*
//*
//*		exfat_log.c
//*
//*
//*****************************************************************************
/*
	log.c (02.09.09)
	exFAT file system implementation library.

	Free exFAT implementation.
	Copyright (C) 2010-2016  Andrew Nayenko

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include	"exfat.h"
#include	<stdarg.h>

int exfat_errors;


//*****************************************************************************
//*
//*		exfat_bug
//*
//*****************************************************************************
// 	This message means an internal bug in exFAT implementation.
EXFAT_STATIC void exfat_bug(const char *format,...)
{
va_list		ap;

	
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	va_end(ap);

	abort();
}


//*****************************************************************************
//*
//*		exfat_error
//*
//*****************************************************************************
// 	This message means an error in exFAT file system.
EXFAT_STATIC void exfat_error(const char *format,...)
{
va_list		ap;

	
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	va_end(ap);

}


//*****************************************************************************
//*
//*		exfat_warn
//*
//*****************************************************************************
// 	This message means that there is something unexpected in exFAT file system
// 	that can be a potential problem.
EXFAT_STATIC void exfat_warn(const char *format,...)
{
va_list		ap;

	
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	va_end(ap);

}


//*****************************************************************************
//*
//*		exfat_debug
//*
//*****************************************************************************
// 	Just debug message. Disabled by default.
EXFAT_STATIC void exfat_debug(const char *format,...)
{
va_list		ap;

	
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	va_end(ap);

}
