//*****************************************************************************
//*
//*
//*		ext4_compiler.h
//*
//*
//*****************************************************************************
#ifndef		__EXT4_EXT4_COMPILER_H__
#define		__EXT4_EXT4_COMPILER_H__



#ifndef		__cplusplus
#define		true				1
#define		false				0
#endif



#ifdef		_MSC_VER

#pragma		once

#if defined(_M_IX86) && (_MSC_VER>=1300)

#define		EXT4_MSC_INSTR
#define		EXT4_CPU_32BIT
#include	<intrin.h>

#elif defined(_M_X64) || defined(_M_AMD64)

#define		EXT4_MSC_INSTR
#define		EXT4_CPU_64BIT
#include	<intrin.h>

#elif defined(_M_IX86) && (_MSC_VER<1300)

#define		EXT4_MSC_VC60
#define		EXT4_CPU_32BIT
#pragma		warning(push)
#pragma		warning(disable:4035)

#endif



#ifdef		EXT4_MSC_INSTR

//*****************************************************************************
//*
//*		ext4_btol_w
//*
//*****************************************************************************
static __inline unsigned short ext4_btol_w(unsigned short uValue)
{
return _byteswap_ushort(uValue);
}

//*****************************************************************************
//*
//*		ext4_btol_dw
//*
//*****************************************************************************
static __inline unsigned int ext4_btol_dw(unsigned int uValue)
{
return _byteswap_ulong(uValue);
}

//*****************************************************************************
//*
//*		ext4_btol_qw
//*
//*****************************************************************************
static __inline unsigned __int64 ext4_btol_qw(unsigned __int64 uValue)
{
return _byteswap_uint64(uValue);
}

#elif defined(EXT4_MSC_VC60)

//*****************************************************************************
//*
//*		ext4_btol_w
//*
//*****************************************************************************
static __inline unsigned short ext4_btol_w(unsigned short uValue)
{
	_asm
		{
		mov		ax,uValue
		xchg	al,ah;					;// Tausche AL mit AH
		}
}

//*****************************************************************************
//*
//*		ext4_btol_dw
//*
//*****************************************************************************
static __inline unsigned int ext4_btol_dw(unsigned int uValue)
{
	_asm
		{
		mov		eax,uValue
		bswap	eax;					;// Tausche Bytes in EAX
		}
}

//*****************************************************************************
//*
//*		ext4_btol_qw
//*
//*****************************************************************************
static __inline unsigned __int64 ext4_btol_qw(unsigned __int64 uValue)
{
	_asm
		{
		mov		edx,dword ptr uValue+0
		mov		eax,dword ptr uValue+4
		bswap	edx;
		bswap	eax;
		}
}

#endif

#if defined(EXT4_MSC_INSTR) || defined(EXT4_MSC_VC60)

#define		BTOL_16(n)					ext4_btol_w (n)
#define		BTOL_32(n)					ext4_btol_dw(n)
#define		BTOL_64(n)					ext4_btol_qw(n)

#endif

#ifndef		EXT4_INLINE
#ifndef		__cplusplus
#define		EXT4_INLINE 				__inline
#else
#define		EXT4_INLINE 				inline
#endif 	
#endif 	

#define		VAL_I64(v)					((__int64)v)

typedef 	char						int8_t;
typedef 	short						int16_t;
typedef 	int							int32_t;
typedef 	__int64						int64_t;
typedef 	unsigned char				uint8_t;
typedef 	unsigned short				uint16_t;
typedef 	unsigned int				uint32_t;
typedef 	unsigned __int64			uint64_t;

#ifndef		__unused
#define		__unused
#endif

#ifndef		PRIu64
#define		PRIu64						"I64u"
#endif

#ifndef		PRId64
#define		PRId64						"I64i"
#endif

#ifndef		PRIu32
#define		PRIu32						"u"
#endif

#ifndef		PRId32
#define		PRId32						"i"
#endif

#ifndef		PRIx32
#define		PRIx32						"X"
#endif

#ifndef		PRIu16
#define		PRIu16						"hu"
#endif

#elif defined(__GNUC__)


#ifndef		EXT4_INLINE
#define		EXT4_INLINE 				inline
#endif 	

#define		VAL_I64(v)					(v##LL)

typedef		char						int8_t;
typedef		short						int16_t;
typedef 	int							int32_t;
typedef 	long long					uint64_t;
typedef 	unsigned char				uint8_t;
typedef 	unsigned short				uint16_t;
typedef 	unsigned int				uint32_t;
typedef 	unsigned long long 			uint64_t;

#ifndef		PRIu64
#define		PRIu64						"llu"
#endif

#ifndef		PRId64
#define		PRId64						"lld"
#endif

#ifndef		PRIu32
#define		PRIu32						"u"
#endif

#ifndef		PRId32
#define		PRId32						"i"
#endif

#ifndef		PRIx32
#define		PRIx32						"X"
#endif

#ifndef		PRIu16
#define		PRIu16						"hu"
#endif

#else

	#error		"unknown compiler"

#endif



#endif
