//*****************************************************************************
//*
//*
//*		ext4_mbr.h
//*
//*
//*****************************************************************************
//	Copyright (c) 2015 Grzegorz Kostka (kostka.grzegorz@gmail.com)
//	All rights reserved.
//	
//	Redistribution and use in source and binary forms, with or without
//	modification, are permitted provided that the following conditions
//	are met:
//	
//	- Redistributions of source code must retain the above copyright
//	  notice, this list of conditions and the following disclaimer.
//	- Redistributions in binary form must reproduce the above copyright
//	  notice, this list of conditions and the following disclaimer in the
//	  documentation and/or other materials provided with the distribution.
//	- The name of the author may not be used to endorse or promote products
//	  derived from this software without specific prior written permission.
//	
//	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
//	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
//	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//	IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
//	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
//	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
//	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//	* @addtogroup lwext4
//	@{
//	*
//	@file  ext4_mbr.h
//	@brief Master boot record parser

#ifndef		EXT4_MBR_H_ 				
#define		EXT4_MBR_H_ 				


#include	"ext4_config.h"
#include	"ext4_compiler.h"
#include	"ext4_blockdev.h"

#ifdef		__cplusplus 				
extern "C"	{
#endif


struct ext4_mbr_bdevs						//*@brief Master boot record block devices descriptor
	{
	struct ext4_blockdev	partitions[4];
	};

CONFIG_EXT4_STATIC int ext4_mbr_scan(struct ext4_blockdev *parent, struct ext4_mbr_bdevs *bdevs);


struct ext4_mbr_parts						//*@brief Master boot record partitions
	{
	uint64_t		size[4];
	};

CONFIG_EXT4_STATIC int ext4_mbr_write(struct ext4_blockdev *parent, struct ext4_mbr_parts *parts);


#ifdef		__cplusplus 				
}
#endif

#endif // EXT4_MBR_H_ 

//	*
//	@}
