//*****************************************************************************
//*
//*
//*		ff_diskio.h
//*
//*
//*****************************************************************************
//
//  Low level disk interface modlue include file  R0.06   (C)ChaN, 2007
//

#ifndef		__FF_DISKIO_H__ 			
#define		__FF_DISKIO_H__ 			

#include	<windows.h>
#include	"ff_integer.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef BYTE	DSTATUS;										// Status of Disk Functions 


typedef enum													// Results of Disk Functions 
	{ 
	RES_OK = 0, 												// 0: Successful 
	RES_ERROR,													// 1: R/W Error 
	RES_WRPRT,													// 2: Write Protected 
	RES_NOTRDY, 												// 3: Not Ready 
	RES_PARERR													// 4: Invalid Parameter 
	}DRESULT; 

#ifndef		FS_POINTER
#define 	FS_POINTER
#endif 	

#ifndef		FS_PARAM
#define 	FS_PARAM(p,a)			a
#endif 	


// Prototypes for disk control functions 

#define 	disk_init(p,a)			((FATDATA*)p)->disk_init_proc  (p FS_POINTER,FS_PARAM(p,a))
#define 	disk_status(p,a)		((FATDATA*)p)->disk_status_proc(p FS_POINTER,FS_PARAM(p,a))
#define 	disk_ioctl(p,a,b,c)		((FATDATA*)p)->disk_ioctl_proc (p FS_POINTER,FS_PARAM(p,a),b,c)
#define 	disk_write(p,a,b,c,d)	((FATDATA*)p)->disk_write_proc (p FS_POINTER,FS_PARAM(p,a),b,c,d)
#define 	disk_read(p,a,b,c,d)	((FATDATA*)p)->disk_read_proc  (p FS_POINTER,FS_PARAM(p,a),b,c,d)

// Disk Status Bits (DSTATUS) 

#define		STA_NOINIT					0x01					// Drive not initialized 
#define		STA_NODISK					0x02					// No medium in the drive 
#define		STA_PROTECT 				0x04					// Write protected 


// Command code for disk_ioctrl() 
#define		CTRL_SYNC					0						// Mandatory for read/write configuration 
#define		CTRL_SECTOR_COUNT			1						// Mandatory for only f_mkfs() 
#define		CTRL_SECTOR_SIZE 			2
#define		CTRL_BLOCK_SIZE				3						// Mandatory for only f_mkfs() 
#define		CTRL_POWER					4
#define		CTRL_LOCK					5
#define		CTRL_EJECT					6
#define		CTRL_SECTOR_CNT64			7						// Mandatory for only f_mkfs() 


// Definitions corresponds to multi partition 
#define		LD2PD(ptr,drv) (drv)								// Physical drive# is equal to logical drive# 
#define		LD2PT(ptr,drv) 0									// Always mounts the 1st partition 



#ifdef __cplusplus
}
#endif

#endif
