//*****************************************************************************
//*
//*
//*		AzFtpClient.h
//*
//*
//*****************************************************************************
#ifndef		__AZFTPCLIENT_H__
#define		__AZFTPCLIENT_H__

#include	<windows.h>
#include	<time.h>

#define 	AZFTP_NO_UTF8		0x0001				// Dateinamen nicht in UTF8 konvertieren
#define 	AZFTP_NO_ANIS		0x0002				// Dateinamen nicht in ANSI konvertieren
#define 	AZFTP_PASSIVE		0x0004				// Passiven Modus verwenden
#define 	AZFTP_RECONNECT		0x0008				// Wieder verbinden bei Verbindungsabbruch
#define 	AZFTP_NO_ANONYMOUS	0x0010				// Anonymous-Login sperren bei User ""
#define 	AZFTP_LINK_RESOLVE	0x0800				// Herausfinden ob LINK's Verzeichnisse sind
#define 	AZFTP_USE_MDTM		0x1000				// MDTM Kommando verwenden (nderungszeit holen)
#define 	AZFTP_USE_SIZE		0x2000				// SIZE Kommando verwenden (Dateigre abfragen)
#define 	AZFTP_USE_EPRT		0x4000				// EPRT Kommando verwenden (IP-V6 Unterstzung)
#define 	AZFTP_USE_EPSV		0x8000				// EPSV Kommando verwenden (Erweiteter Modus)

typedef	unsigned short *AzFtpHandle;
typedef int (_cdecl *AzFtpFileCallback)(void *pParam,      void *pBuffer,int iSize);
typedef int (_cdecl *AzFtpReadCallback)(void *pParam,const void *pBuffer,int iSize);
typedef int (_cdecl *AzFtpFindCallback)(void *pParam,WIN32_FIND_DATA *pFind);

	
AzFtpHandle	AzFtpConnect	(LPCTSTR     pServer,LPCTSTR pUserName,LPCTSTR pPassword=NULL,unsigned short usPort=0,int iFlags=AZFTP_PASSIVE,unsigned uTimeout=10000,int *pError=0,void **pCancelPtr=0);
void 		AzFtpSetSize	(AzFtpHandle hClient,UINT	 uSize);
int			AzFtpCwd		(AzFtpHandle hClient,LPCTSTR pDirName);
int			AzFtpPwd		(AzFtpHandle hClient,LPTSTR  pBuffer,int iSize);
int			AzFtpRmDir  	(AzFtpHandle hClient,LPCTSTR pDirName);
int			AzFtpMkDir		(AzFtpHandle hClient,LPCTSTR pDirName);
int			AzFtpRename		(AzFtpHandle hClient,LPCTSTR pExisting,LPCTSTR pNewName);
int			AzFtpRemove 	(AzFtpHandle hClient,LPCTSTR pFileName);
int			AzFtpChmod  	(AzFtpHandle hClient,LPCTSTR pRemoteFile,int iPermission);
int			AzFtpGetTime	(AzFtpHandle hClient,LPCTSTR pRemoteFile,time_t &iTime);
int			AzFtpSetTime	(AzFtpHandle hClient,LPCTSTR pRemoteFile,time_t  iTime);
int			AzFtpPutFile	(AzFtpHandle hClient,LPCTSTR pRemoteFile,LPCTSTR pLocalFile);
int			AzFtpGetFile	(AzFtpHandle hClient,LPCTSTR pRemoteFile,LPCTSTR pLocalFile);
int			AzFtpPutMem 	(AzFtpHandle hClient,LPCTSTR pRemoteFile,const void *pMem,int iSize);
int			AzFtpGetMem 	(AzFtpHandle hClient,LPCTSTR pRemoteFile,      void *pMem,int iSize);
int			AzFtpPutProc	(AzFtpHandle hClient,LPCTSTR pRemoteFile,	   void *pParam,AzFtpFileCallback pProc);
int			AzFtpGetProc	(AzFtpHandle hClient,LPCTSTR pRemoteFile,      void *pParam,AzFtpReadCallback pProc);
int			AzFtpList   	(AzFtpHandle hClient,LPCTSTR pRemotePath,      void *pParam,AzFtpFindCallback pProc);
int			AzFtpSetProgress(AzFtpHandle hClient,UINT    uPos,UINT  uMax=0xFFFFFFFF);
int			AzFtpGetProgress(AzFtpHandle hClient,UINT   *pPos,UINT *pMax);
int  		AzFtpSetTimeout (AzFtpHandle hClient,UINT    uTimeout);
int  		AzFtpGetTimeout (AzFtpHandle hClient);
int			AzFtpClose		(AzFtpHandle hClient,UINT    uTimeout=2000);
int			AzFtpAbort		(AzFtpHandle hClient);
int			AzFtpReconnect  (AzFtpHandle hClient);
int			AzFtpIsConnected(AzFtpHandle hClient);


#endif
