//*****************************************************************************
//*
//*
//*		FtpArchive.h
//*
//*
//*****************************************************************************
//
//	Emuliert ein Archive (*.zip) als FTP-Verbindung
//	
#ifndef		__FTPARCHIVE_H__
#define		__FTPARCHIVE_H__

#include	<Afx.h>
#include	<AfxMt.h>
#include	"FtpBase.h"

//*****************************************************************************
//*
//*		Klasse CFtpArchive
//*
//*****************************************************************************
class CFtpArchive : public CFtpBase
{
public:

		     CFtpArchive(CInternetSession *pSession,LPCTSTR pServer,LPCTSTR pUserName=NULL,LPCTSTR pPassword=NULL,DWORD dwContext=0,INTERNET_PORT nPort=INTERNET_INVALID_PORT_NUMBER,BOOL bPassive=FALSE);
    virtual ~CFtpArchive();

	virtual BOOL SetCurrentDirectory(LPCTSTR pDirName);
	virtual BOOL GetCurrentDirectory(LPTSTR  pDirName,LPDWORD pLen) const;

	virtual BOOL RemoveDirectory(LPCTSTR pDirName );
	virtual BOOL CreateDirectory(LPCTSTR pDirName );
	virtual BOOL Remove         (LPCTSTR pFileName);
	virtual BOOL SetAttributes  (LPCTSTR pFileName,DWORD    dwAttr);
	virtual BOOL SetModifyTime  (LPCTSTR pFileName,FILETIME sFileTime);
	virtual BOOL Rename         (LPCTSTR pExisting,LPCTSTR  pNewName);
	virtual void Close();

	virtual BOOL PutFile(LPCTSTR pLocalFile ,LPCTSTR pRemoteFile,                                                                   DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPCTSTR pLocalFile ,BOOL  bFailIfExists=TRUE,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL PutFile(LPCTSTR pRemoteFile,LPVOID  pParam,InpCall pProc,                                                          DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPVOID  pParam,OutCall pProc,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL                 ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual CInternetFile *OpenFile(LPCTSTR pFileName,DWORD dwAccess=GENERIC_READ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual BOOL QueryOption(DWORD dwOption,LPVOID pBuffer,LPDWORD pBufferLength) const;
	virtual BOOL SetOption  (DWORD dwOption,LPVOID pBuffer,DWORD   uBufferLength,DWORD dwFlags=0);

protected:
	
	virtual void DoAbort();
	virtual int	 List(LPCTSTR pRemotePath,void *pParam,FtpFindCallback pProc,LPCTSTR pFilter);
	static DWORD CALLBACK CopyCallback(LARGE_INTEGER iTotalFileSize,LARGE_INTEGER iBytesTransferred,LARGE_INTEGER iStreamSize,LARGE_INTEGER iStreamBytesTransferred,DWORD dwStreamNumber,DWORD dwCallbackReason,HANDLE hSourceFile,HANDLE hDestinationFile,LPVOID pParam);

	
	TCHAR			m_cCurrDir[CFB_MAX_PATH];
	CSemaphore		m_sSemaphor;
	BOOL volatile 	m_bCancel;
	DWORD			m_uDoneSet;
	DWORD			m_uTickSet;
	__int64			m_iDoneNow;
	__int64			m_iDoneMax;

};


#endif
