//*****************************************************************************
//*
//*
//*		FtpAxComm.h
//*
//*
//*****************************************************************************
//
//	Ist eine Verbindung ber die AX-Comm-API
//	
#ifndef		__FTPAXCOMM_H__
#define		__FTPAXCOMM_H__


#include	"FtpBase.h"

extern int	CiCommDllUnload();
extern int	CiCommDllLoad(LPCTSTR pPath=0);
extern int	CiDoConnect(void **pSession,const char *pServer,int nPort=0,const char *pUser="",const char *pPassWd="");


//*****************************************************************************
//*
//*		Klasse CFtpAxComm
//*
//*****************************************************************************
class CFtpAxComm : public CFtpBase
{
public:

		     CFtpAxComm(CInternetSession *pSession,LPCTSTR pServer,LPCTSTR pUserName=NULL,LPCTSTR pPassword=NULL,DWORD dwContext=0,INTERNET_PORT nPort=INTERNET_INVALID_PORT_NUMBER,BOOL bPassive=FALSE);
    virtual ~CFtpAxComm();

		    BOOL Init(int iReconnect,unsigned uTimeout=10000,BOOL bUtf8=TRUE);
	virtual BOOL SetCurrentDirectory(LPCTSTR pDirName);
	virtual BOOL GetCurrentDirectory(LPTSTR  pDirName,LPDWORD pLen) const;

	virtual BOOL RemoveDirectory(LPCTSTR pDirName );
	virtual BOOL CreateDirectory(LPCTSTR pDirName );
	virtual BOOL Remove         (LPCTSTR pFileName);
	virtual BOOL SetAttributes  (LPCTSTR pFileName,DWORD    dwAttr);
	virtual BOOL SetModifyTime  (LPCTSTR pFileName,FILETIME sFileTime);
	virtual BOOL Rename         (LPCTSTR pExisting,LPCTSTR  pNewName);
	virtual void Close();

	virtual BOOL PutFile(LPCTSTR pLocalFile ,LPCTSTR pRemoteFile,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPCTSTR pLocalFile ,BOOL  bFailIfExists=TRUE,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL PutFile(LPCTSTR pRemoteFile,LPVOID  pParam,InpCall pProc,                                                         DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPVOID  pParam,OutCall pProc,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL                ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual CInternetFile *OpenFile(LPCTSTR pFileName,DWORD dwAccess=GENERIC_READ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual BOOL QueryOption(DWORD dwOption,LPVOID pBuffer,LPDWORD pBufferLength) const;
	virtual BOOL SetOption  (DWORD dwOption,LPVOID pBuffer,DWORD   uBufferLength,DWORD dwFlags=0);

protected:
	
	        BOOL Reconnect(BOOL bForce=FALSE);	
		    BOOL SetStat(LPWIN32_FIND_DATA pInfo);
			void SetError(int iError);		
	virtual void DoAbort();
	virtual int	 List(LPCTSTR pRemotePath,void *pParam,FtpFindCallback pProc,LPCTSTR pFilter);
	int 		 PathFullMake(char *pBuffer,LPCTSTR pCurrDir,LPCTSTR pPath,int iSize);
	
	
	__int64		m_aProgess[2];						// [0]=Now [1]=Max
	TCHAR		m_cCurrDir[CFB_MAX_PATH];
	unsigned	m_uTimeout;
	BOOL		m_bReconnect;
	BOOL		m_bConnDone;
	BOOL		m_bUseUtf8;
};


#endif
