//*****************************************************************************
//*
//*
//*		FtpBase.h
//*
//*
//*****************************************************************************
//
//	Basisklasse fr FTP-Verbindungen
//	
#ifndef		__FTPBASE_H__		
#define		__FTPBASE_H__		


#include	<afx.h>
#include	<afxinet.h>
#include	"../StringChain.h"

#define 	INTERNET_OPTION_PROGRESS	(INTERNET_LAST_OPTION+1)	// Verlaufsanzeige 
#define 	INTERNET_OPTION_PROGRESS2	(INTERNET_LAST_OPTION+2)	// Verlaufsanzeige mit Maximalwert
#define 	INTERNET_OPTION_PROGRSET	(INTERNET_LAST_OPTION+3)	// Verlaufsanzeige setzen
#define 	INTERNET_OPTION_RETRY		(INTERNET_LAST_OPTION+4)	// Put/Get mehrfach versuchen
#define 	INTERNET_OPTION_READONLY	(INTERNET_LAST_OPTION+5)	// Hat die Verbindung schreib Erlaubnis 
#define 	INTERNET_OPTION_MODE		(INTERNET_LAST_OPTION+6)	// Verbindungsmodus abfragen
#define 	INTERNET_OPTION_UTF8		(INTERNET_LAST_OPTION+7)	// Benutze UTF8 Konvertierung
#define 	INTERNET_OPTION_LOCAL		(INTERNET_LAST_OPTION+8)	// Ist es eine lokale Verbindung
#define 	INTERNET_OPTION_CONNTYPE	(INTERNET_LAST_OPTION+9)	// Ergibt die Art der Verbindung (FTP_MODE_????)
#define 	INTERNET_OPTION_RECONNECT	(INTERNET_LAST_OPTION+10)	// Einen Reconnect auslsen
#define 	INTERNET_OPTION_URLFORMAT	(INTERNET_LAST_OPTION+11)	// Ist das Format des URL-Namens (0=normal 1=HTML)
#define 	INTERNET_OPTION_SETSTAT		(INTERNET_LAST_OPTION+12)	// Attribute und Zeiten setzen
#define 	INTERNET_OPTION_ERROPEN		(INTERNET_LAST_OPTION+13)	// Fehler beim ffnen der Quelle
#define 	INTERNET_OPTION_PUTSIZE		(INTERNET_LAST_OPTION+14)	// Gre der zu bertragenden Datei
#define 	INTERNET_OPTION_PATHMODE	(INTERNET_LAST_OPTION+15)	// Pfadmodus abfragen (0=ftp:// 1=//... 2=D:\...)
#define 	INTERNET_OPTION_ONLYDIR		(INTERNET_LAST_OPTION+16)	// Mit CFB_ONLYDIR Verzeichnisse aufgelistet werden
#define 	INTERNET_FLAG_ALL_DIRS		0x00000400					// Alle Verzeichnisse suchen
#define 	INTERNET_FLAG_NO_DIRS		0x00000200					// Keine Verzeichnisse 
#define 	INTERNET_FLAG_NO_DOTS		0x00001000					// Keine "." und ".." Verzeichnisse 
#define 	INTERNET_FLAG_ONLY_DIRS		0x00002000					// Nur Verzeichnisse finden
#define		FILE_ATTRIBUTE_EXEC			0x00000080					// Spezialflag fr ausfhrbar
#define		FILE_ATTRIBUTE_LINK			0x00000200					// Spezialflag fr Software-Links	
#define		FILE_SET_ATTRIBUTE			0x00000400					// Spezialflag fr Attributte setzen

#ifndef		QWORD_DEFINED
#define		QWORD_DEFINED	
typedef		unsigned __int64	QWORD;
#endif		

#ifndef 	CFB_MAX_PATH		
#define 	CFB_MAX_PATH		512									// Maximale Pfadlnge
#endif 	

#define 	CFB_ONLYDIR			((LPCTSTR)0x0123)					// Nur nach Verzeichnissen suchen


typedef int (_cdecl *FtpFindCallback)(void *pParam,WIN32_FIND_DATA *pFind);

class		CFtpBaseFind;

//*****************************************************************************
//*
//*		Klasse CFtpBase
//*
//*****************************************************************************
class CFtpBase : public CObject
{
public:

	typedef	int(_cdecl*OutCall)(void *pParam,const void  *pMem,int iLen);
	typedef	int(_cdecl*InpCall)(void *pParam,      void  *pMem,int iLen);
	typedef struct
		{
		LPBYTE	pMem;
		INT		iPos;
		INT		iLen;
		}MemoryData;

	CFtpBase(CInternetSession *pSession,HINTERNET hConnected,LPCTSTR pServer,DWORD dwContext);
	CFtpBase(CInternetSession *pSession,LPCTSTR   pServer   ,LPCTSTR pUserName=NULL,LPCTSTR pPassword=NULL,DWORD dwContext=0,INTERNET_PORT nPort=INTERNET_INVALID_PORT_NUMBER,BOOL bPassive=FALSE);
    virtual ~CFtpBase();


	virtual BOOL SetCurrentDirectory     (LPCTSTR  pDirName) = 0;
	virtual BOOL GetCurrentDirectory     (LPTSTR   pDirName,LPDWORD pLen) const = 0 ;
			BOOL GetCurrentDirectory     (LPTSTR   pDirName,  DWORD uLen) const;
			BOOL GetCurrentDirectory     (CString &sDirName) const;
			BOOL GetCurrentDirectoryAsURL(LPTSTR   pDirName,LPDWORD pLen) const;
			BOOL GetCurrentDirectoryAsURL(CString &sDirName) const;

			BOOL CreatePath     (LPCTSTR pDirName);
			BOOL RemovePath     (LPCTSTR pDirName);
	virtual BOOL SetModifyTime  (LPCTSTR pFileName,FILETIME sFileTime) = 0;
	virtual BOOL SetAttributes  (LPCTSTR pFileName,DWORD    dwAttr   ) = 0;
	virtual BOOL RemoveDirectory(LPCTSTR pDirName ) = 0;
	virtual BOOL CreateDirectory(LPCTSTR pDirName ) = 0;
	virtual BOOL Remove         (LPCTSTR pFileName) = 0;
	virtual BOOL Rename         (LPCTSTR pExisting,LPCTSTR pNewName  ) = 0;
	virtual void Close() = 0;
		    void Abort();

	virtual BOOL PutFile(LPCTSTR pLocalFile ,LPCTSTR pRemoteFile,                                                                  DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1) = 0;
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPCTSTR pLocalFile ,BOOL  bFailIfExists=TRUE,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1) = 0;
	virtual BOOL PutFile(LPCTSTR pRemoteFile,LPVOID  pParam  ,InpCall pProc,                                                       DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPVOID  pParam  ,OutCall pProc,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL              ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL PutFile(LPCTSTR pRemoteFile,const LPVOID pMemory,INT iSize,                                                       DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual INT  GetFile(LPCTSTR pRemoteFile,      LPVOID pMemory,INT iSize,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL              ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual CInternetFile *OpenFile(LPCTSTR pFileName,DWORD dwAccess=GENERIC_READ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual int  GetLocalPath      (LPCTSTR pFileName,LPTSTR pBuffer,int iSize);

	virtual BOOL QueryOption(DWORD dwOption,LPVOID   pBuffer,LPDWORD pBufferLength) const;
			BOOL QueryOption(DWORD dwOption,DWORD   &dwValue) const;
			BOOL QueryOption(DWORD dwOption,CString &sRefString) const;
	virtual BOOL SetOption  (DWORD dwOption,LPVOID   pBuffer,DWORD   uBufferLength,DWORD dwFlags=0);
			BOOL SetOption  (DWORD dwOption,DWORD    dwValue                      ,DWORD dwFlags=0);

			operator		  HINTERNET    () const;
			DWORD			  GetContext   () const;
			CInternetSession *GetSession   () const;
			CString			  GetServerName() const;
			LPCTSTR			  GetUserName  () const;
			LPCTSTR			  GetProtocol  () const;

protected:

		    BOOL SetStat (LPWIN32_FIND_DATA pInfo);
	virtual int	 List    (LPCTSTR pRemotePath,void *pParam,FtpFindCallback pProc,LPCTSTR pFilter) = 0;
	virtual void DoAbort() = 0;

	static  int  __cdecl MemRead (void *pParam,      void *pBuffer,int iSize);
	static  int  __cdecl MemWrite(void *pParam,const void *pBuffer,int iSize);
	
	friend	CFtpBaseFind;

	
	WORD			m_wPort;						// TCP Port fr den Server (0=default)	
	BOOL			m_bPassive;						// Ist die Verbindung passive
	DWORD			m_dwPutSize;					// Gre der zu bertragenden Datei
	DWORD			m_dwContext;					// Context nummer fr die Verbindung
	DWORD			m_dwErrOpen;					// Gab es den Letzen Fehler beim ffnen
	CString			m_sServerName;					// Ist der Name des Servers
	CString			m_sUserName;					// Ist der Usernamen fr den Login
	CString			m_sPassword;					// Ist das Passwort fr den den Server
	LPCTSTR			m_pBaseUrl;						// Ist das URL Prfix (z.B.: "ftp://")
	LPVOID			m_pSession;						// Ist ein Zeiger auf die Session
	BOOL volatile 	m_bAbortAllowed;				// Ist ein Abbruch erlaubt


};

//*****************************************************************************
//*
//*		Klasse CFtpCommonFind
//*
//*****************************************************************************
class CFtpBaseFind : public CObject
{
public:

			 CFtpBaseFind(CFtpBase *pConnection,DWORD dwContext=1);
	virtual ~CFtpBaseFind();

	virtual BOOL FindFile(LPCTSTR pName=NULL,DWORD dwFlags=INTERNET_FLAG_RELOAD);
	virtual BOOL FindFile(LPCTSTR pName,LPCTSTR pPlus,LPCTSTR pMinus=NULL,DWORD dwFlags=INTERNET_FLAG_RELOAD);
	virtual BOOL FindNextFile();
	virtual BOOL Close();

	DWORD		 GetAttributes    () const;
	DWORD		 GetLength	      () const;
	__int64 	 GetLength64	  () const;
	CString 	 GetFileName	  () const;
	CString 	 GetFilePath	  () const;
	CString 	 GetFileTitle     () const;
	CString 	 GetFileURL	      () const;
	CString 	 GetRoot		  () const;

	time_t		 GetLastWriteTime () const;
	time_t		 GetLastAccessTime() const;
	time_t		 GetCreationTime  () const;
	BOOL 		 GetLastWriteTime (FILETIME *pTimeStamp) const;
	BOOL		 GetLastAccessTime(FILETIME *pTimeStamp) const;
	BOOL 		 GetCreationTime  (FILETIME *pTimeStamp) const;
	BOOL 		 GetLastWriteTime (CTime    &sTime ) const;
	BOOL 		 GetLastAccessTime(CTime    &sTime ) const;
	BOOL 		 GetCreationTime  (CTime    &sTime ) const;
	BOOL 		 MatchesMask	  (DWORD     dwMask) const;
	BOOL 		 IsDots           () const;
	BOOL 		 IsReadOnly       () const;
	BOOL 		 IsDirectory      () const;
	BOOL 		 IsCompressed     () const;
	BOOL 		 IsSystem         () const;
	BOOL 		 IsHidden         () const;
	BOOL 		 IsTemporary      () const;
	BOOL 		 IsNormal         () const;
	BOOL 		 IsArchived       () const;


protected:

	static  int		_cdecl ListCallback(void *pParam,WIN32_FIND_DATA *pFind);
	friend  CFtpBase;

	CStringChain	m_sList;						// Alle empfangenen Dateien			
	LPCTSTR			m_pFilter;						// Dateifilter fr List
	LPCTSTR			m_pMinus;						// Minusfilter fr List
	LPCTSTR			m_pPlus;						// Plusfilter  fr List
	BOOL			m_bDone;						// Wurden alle Dateien aufgelistet
	BOOL			m_bClose;						// Es gab einen Abbruch
	BOOL			m_bNoDots;						// Keine "." und ".." Verzeichnisse finden
	BOOL			m_bNoDirs;						// Keine Verzeichnisse finden
	BOOL			m_bAllDirs;						// Alle  Verzeichnisse finden
	BOOL			m_bOnlyDirs;					// Keine Verzeichnisse finden
	CFtpBase	   *m_pConnection;					// Ist die FTP-Verbindung
	WIN32_FIND_DATA	m_sFindData;					// Daten vom der zuletzt gefunden Datei
	CString			m_sRoot;						// Root-Pfad fr List
	int				m_iReadPos;						// Ausleseposition der Liste

}; 

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

inline	BOOL				CFtpBase::QueryOption(DWORD dwOption,DWORD &dwValue) const {DWORD dwLen=sizeof(DWORD);return QueryOption(dwOption,&dwValue,&dwLen);}
inline	BOOL				CFtpBase::SetOption  (DWORD dwOption,DWORD  dwValue,DWORD dwFlags){return SetOption(dwOption,&dwValue,sizeof(dwValue),dwFlags);}
inline	DWORD				CFtpBase::GetContext   () const	{ return m_dwContext;}
inline	CInternetSession   *CFtpBase::GetSession   () const	{ return (CInternetSession*)m_pSession;}
inline	CString				CFtpBase::GetServerName() const	{ return m_sServerName; }
inline	LPCTSTR			    CFtpBase::GetUserName  () const { return m_sUserName; }
inline	LPCTSTR			    CFtpBase::GetProtocol  () const { return m_pBaseUrl; }
inline						CFtpBase::operator HINTERNET() const{ return (HINTERNET)NULL;}
inline	DWORD				CFtpBaseFind::GetAttributes() const	{ return m_sFindData.dwFileAttributes;}
inline	BOOL				CFtpBaseFind::IsReadOnly   () const	{ return MatchesMask(FILE_ATTRIBUTE_READONLY  ); }
inline	BOOL				CFtpBaseFind::IsDirectory  () const	{ return MatchesMask(FILE_ATTRIBUTE_DIRECTORY ); }
inline	BOOL				CFtpBaseFind::IsCompressed () const	{ return MatchesMask(FILE_ATTRIBUTE_COMPRESSED); }
inline	BOOL				CFtpBaseFind::IsSystem     () const	{ return MatchesMask(FILE_ATTRIBUTE_SYSTEM    ); }
inline	BOOL				CFtpBaseFind::IsHidden     () const	{ return MatchesMask(FILE_ATTRIBUTE_HIDDEN    ); }
inline	BOOL				CFtpBaseFind::IsTemporary  () const	{ return MatchesMask(FILE_ATTRIBUTE_TEMPORARY ); }
inline	BOOL				CFtpBaseFind::IsNormal     () const	{ return MatchesMask(FILE_ATTRIBUTE_NORMAL    ); }
inline	BOOL				CFtpBaseFind::IsArchived   () const	{ return MatchesMask(FILE_ATTRIBUTE_ARCHIVE   ); }



#endif
