//*****************************************************************************
//*
//*
//*		FtpConsole.h
//*
//*
//*****************************************************************************
//
//	Ist eine Security-Consolen-Verbindung ber SSL
//
#ifndef		__FTPCONSOLE_H__
#define		__FTPCONSOLE_H__


#include	"FtpBase.h"

//*****************************************************************************
//*
//*		Klasse CFtpConsole
//*
//*****************************************************************************
class CFtpConsole : public CFtpBase
{
public:

		     CFtpConsole(CInternetSession *pSession,LPCTSTR pServer,LPCTSTR pUserName=NULL,LPCTSTR pPassword=NULL,DWORD dwContext=0,INTERNET_PORT nPort=INTERNET_INVALID_PORT_NUMBER,BOOL bPassive=FALSE);
    virtual ~CFtpConsole();

		    BOOL Init(int iReconnect,unsigned uTimeout=10000,BOOL bUtf8=TRUE);
	virtual BOOL SetCurrentDirectory(LPCTSTR pDirName);
	virtual BOOL GetCurrentDirectory(LPTSTR  pDirName,LPDWORD pLen) const;

	virtual BOOL RemoveDirectory(LPCTSTR pDirName );
	virtual BOOL CreateDirectory(LPCTSTR pDirName );
	virtual BOOL Remove         (LPCTSTR pFileName);
	virtual BOOL SetAttributes  (LPCTSTR pFileName,DWORD    dwAttr);
	virtual BOOL SetModifyTime  (LPCTSTR pFileName,FILETIME sFileTime);
	virtual BOOL Rename         (LPCTSTR pExisting,LPCTSTR  pNewName);
	virtual void Close();

	virtual BOOL PutFile(LPCTSTR pLocalFile ,LPCTSTR pRemoteFile,                                                                   DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPCTSTR pLocalFile ,BOOL  bFailIfExists=TRUE,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL PutFile(LPCTSTR pRemoteFile,LPVOID  pParam,InpCall pProc,                                                          DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPVOID  pParam,OutCall pProc,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL                 ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual CInternetFile *OpenFile(LPCTSTR pFileName,DWORD dwAccess=GENERIC_READ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual BOOL QueryOption(DWORD dwOption,LPVOID pBuffer,LPDWORD pBufferLength) const;
	virtual BOOL SetOption  (DWORD dwOption,LPVOID pBuffer,DWORD   uBufferLength,DWORD dwFlags=0);

protected:

	        BOOL Reconnect(BOOL bForce=FALSE);
		    BOOL SetStat(LPWIN32_FIND_DATA pInfo);
			int  GetStat(LPCTSTR pFileName,LPWIN32_FIND_DATA pInfo);
			BOOL TruncFile(LPCTSTR pFileName,int iSize);
			void SetError(int iError);
	virtual void DoAbort();
	virtual int	 List(LPCTSTR pRemotePath,void *pParam,FtpFindCallback pProc,LPCTSTR pFilter);
	static  int  _cdecl CopyHexOut(void *pParam,void  *pMem,int iLen);
	static  int	 HextOutText(char *pBuffer,const char *pPath,int iSize);		
	int 		 GetLinkTarget(const char *pLinkPath,char *pTarget,int iSize);
	int 		 PathFullMake(char *pBuffer,LPCTSTR pCurrDir,LPCTSTR pPath,int iSize);
	int			 LineCommand(const char *pCmd,char *pBuffer,int iSize,const char *pExtra="",const char *pFrame="");
	int			 LineToAttrib(const char *pLine,LPWIN32_FIND_DATA pInfo);
	int			 MemToText(const char *pMem,char *pText,int iLen);
	int			 DecodeError(const char *pBuffer);
	int			 DecodeError(int iErr);
	int			 ClearBuffer();
	int			 SuLogin();

	TCHAR			m_cCurrDir[CFB_MAX_PATH];
	CHAR			m_cPrefix[2];
	static BYTE		m_aHexOut[]; 
	LPCSTR			m_pLsText;
	unsigned		m_uHexOutVesion;
	unsigned		m_uProgressSize;
	unsigned		m_uProgressOff;
	unsigned		m_uLsMode;
	unsigned		m_uTimeout;
	BOOL volatile	m_bUserBreak;
	BOOL			m_bReconnect;
	BOOL			m_bUseHexOut;
	BOOL			m_bConnDone;
	BOOL			m_bUseUtf8;
};


#endif
