//*****************************************************************************
//*
//*
//*		FtpDrives.h
//*
//*
//*****************************************************************************
//
//	Ist eine Verbindung zu einem FAT-Lauferk oder FAT-Image.
//	
#ifndef		__FTPDRIVES_H__
#define		__FTPDRIVES_H__


#include	"FtpBase.h"
#include	"DiskTools.h"


//*****************************************************************************
//*
//*		Klasse CFtpDrives
//*
//*****************************************************************************
class CFtpDrives : public CFtpBase
{
public:

		     CFtpDrives(CInternetSession *pSession,LPCTSTR pServer,LPCTSTR pUserName=NULL,LPCTSTR pPassword=NULL,DWORD dwContext=0,INTERNET_PORT nPort=INTERNET_INVALID_PORT_NUMBER,BOOL bPassive=FALSE);
    virtual ~CFtpDrives();

		    BOOL Init(int iReadOnly=0);
	virtual BOOL SetCurrentDirectory(LPCTSTR pDirName);
	virtual BOOL GetCurrentDirectory(LPTSTR  pDirName,LPDWORD pLen) const;

	virtual BOOL RemoveDirectory(LPCTSTR pDirName );
	virtual BOOL CreateDirectory(LPCTSTR pDirName );
	virtual BOOL Remove         (LPCTSTR pFileName);
	virtual BOOL SetAttributes  (LPCTSTR pFileName,DWORD    dwAttr);
	virtual BOOL SetModifyTime  (LPCTSTR pFileName,FILETIME sFileTime);
	virtual BOOL Rename         (LPCTSTR pExisting,LPCTSTR  pNewName);
	virtual void Close();

	virtual BOOL PutFile(LPCTSTR pLocalFile ,LPCTSTR pRemoteFile,                                                                   DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPCTSTR pLocalFile ,BOOL  bFailIfExists=TRUE,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL PutFile(LPCTSTR pRemoteFile,LPVOID  pParam,InpCall pProc,                                                          DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);
	virtual BOOL GetFile(LPCTSTR pRemoteFile,LPVOID  pParam,OutCall pProc,DWORD dwAttributes=FILE_ATTRIBUTE_NORMAL                 ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual CInternetFile *OpenFile(LPCTSTR pFileName,DWORD dwAccess=GENERIC_READ,DWORD dwFlags=FTP_TRANSFER_TYPE_BINARY,DWORD dwContext=1);

	virtual BOOL QueryOption(DWORD dwOption,LPVOID pBuffer,LPDWORD pBufferLength) const;
	virtual BOOL SetOption  (DWORD dwOption,LPVOID pBuffer,DWORD   uBufferLength,DWORD dwFlags=0);

protected:

	LPBYTE 		m_pBuffer;
	BOOL		m_bRetry;	
	BOOL		m_bBreak;	
	BOOL		m_bReadOnly;
	UINT		m_uPartition;
	LONG		m_lLocked;
	DWORD		m_uTimeout;
	QWORD		m_uProgress;
	QWORD		m_uProgrMax;

			void SetError(int iError) const;		
	virtual void DoAbort();
	virtual int	 List(LPCTSTR pRemotePath,void *pParam,FtpFindCallback pProc,LPCTSTR pFilter);
		    BOOL SetStat(LPWIN32_FIND_DATA pInfo);


};


#endif
