//*****************************************************************************
//*
//*
//*		FtpTools.h
//*
//*
//*****************************************************************************
//
//	Erzeugt diverse FTP Verbindungen
//
//			*) FTP
//			*) SFTP
//			*) SMB
//			*) SSH
//			*) ARCHIVE
//			*) AX-COMM
//
//	Spezielle Define's
//	
//			FTP_NO_DISC			Keine FAT Verbindungen
//			FTP_NO_SSH			Keine SSH Verbindungen
//			FTP_NO_SMB			Keine SMB Verbindungen
//			FTP_NO_SFTP			Keine SFTP Verbindungen
//			FTP_NO_ARCH			Keine Archiv Verbindungen
//			FTP_NO_AXCOMM		Keine AX-Comm Verbindungen
//			FTP_OLNY_ZIP		Nur das ZIP-Format wird untersttzt
//	
#ifndef 	__FTPTOOLS_H__
#define 	__FTPTOOLS_H__


#define 	FTP_MODE_NONE				0x0000		// Keine Type spezifizeirt
#define 	FTP_MODE_FTP				0x0001		// Normale FTP Verbindung
#define 	FTP_MODE_SFTP				0x0002		// Serurity SFTP Verbindung
#define 	FTP_MODE_SMB				0x0003		// Verzeichnis oder Netzlaufwerk
#define 	FTP_MODE_ARCH				0x0004		// Eine Archivedatei (z.B. *.zip)
#define 	FTP_MODE_DISK				0x0005		// Ein FAT-Image oder Laufwerk
#define 	FTP_MODE_AXCOMM				0x0006		// Verbintung zu PLC5 Ax5commSrv
#define 	FTP_MODE_SSH				0x0007		// Serurity SSH Verbindung
#define 	FTP_MODE_RECONN				0x0100		// Die Verbindung bei Abbrchen neu aufbauen
#define 	FTP_MODE_PASSIVE			0x0200		// Eine passiver Verbindung aufbauen
#define 	FTP_MODE_HEXOUT				0x0200		// HexOur benutzen bei SSH-Konsolen-Verbindungen
#define 	FTP_MODE_RETRY				0x0400		// Die Daten Verbindung versuchen erneut aufzubauen
#define 	FTP_MODE_RESOLVE			0x0800		// Soft-Links auf FTP-Verbindunen auflsen
#define 	FTP_MODE_READONLY			0x1000		// Nur lesend auf die Verbindung zugreifen

#include	"FtpBase.h"

CFtpBase   *GetFtpConnectionEx(LPCTSTR pServer,LPCTSTR pUserName=NULL,LPCTSTR pPassword=NULL,INTERNET_PORT nPort=INTERNET_INVALID_PORT_NUMBER,int iMode=0,LPCTSTR pPath=NULL,LPVOID *pCancelPtr=NULL);
unsigned	GetFtpConnType    (LPCTSTR pUrl,BOOL bOnlyProt=FALSE);
unsigned	GetFtpConnCancel  (LPVOID  pCandelPtr);
LPCTSTR		FtpAxCommPath     (LPCTSTR pPath=0);
unsigned	FtpShutdown       ();


#endif 	
