//*****************************************************************************
//*
//*
//*		HardwareBreakPoint.h
//*
//*
//*****************************************************************************
#ifndef	__HARDWAREBREAKPOINT_H__
#define	__HARDWAREBREAKPOINT_H__


#define HWBP_ALL_THREADS	((void*)0x80FF7733)	
#define HWBP_CUR_THREAD		((void*)0x80FF7744)	

enum HWBP_TYPE
	{
	HWBP_TYPE_CODE,
	HWBP_TYPE_RDWR,
	HWBP_TYPE_WRITE,
	};

enum HWBP_SIZE
	{
	HWBP_SIZE_1,
	HWBP_SIZE_2,
	HWBP_SIZE_4,
	HWBP_SIZE_8,
	};


#ifdef __cplusplus
extern "C" {
#endif

void		HardwareBreakPointInit();
void		HardwareBreakPointExit();
unsigned 	HardwareBreakPointThread();
void       *HardwareBreakpointSet(void *hThread,HWBP_TYPE eType,HWBP_SIZE eSize,void *pPtr);
int 		HardwareBreakpointDel(void *hBreakPoint);
int			HardwareBreakpointUpdate(void *hBreakPoint,void *hThread=HWBP_CUR_THREAD);

#ifdef __cplusplus
}
#endif

#endif
