//*****************************************************************************
//*
//*
//*		Klasse BitmapImage
//*
//*
//*****************************************************************************
//
//	Allgemeine Funktionen
//
//		bool SetSize(unsigned uBits,unsigned iSizeX,unsigned iSizeY,unsigned uPixel=0,void *pData=0)
// 		bool            IsOk       ()		Bild vorhanden
// 		bool            IsRGB      ()		Bild im RGB-Modus
// 		unsigned		Width      ()		Bild Breite
// 		unsigned		Height     ()		Bild Hhe
// 		unsigned		BitCount   ()		Bild Bitanzahl
// 		unsigned		ColorCount ()		Bild Farbenanzahl
// 		unsigned char  *ImageData  ()		Bild Daten
//
//	Farb Funktionen
//
//		ColorMapEntry & ColorMap(unsigned uIndex)					 Farbe holen
//		ColorMapEntry   ColorMap(unsigned uIndex)					 Farbe lesen
// 		unsigned		SwapRGB (unsigned uColor)					 RGB Farbe zu GBR Farbe
// 		void			SwapRGB4(unsigned char *pRow ,int Count)		 RGB Reihe zu GBR Reihe
// 		void			SwapRGB3(unsigned char *pRow ,int Count)		 RGB Reihe zu GBR Reihe
//		void			SetColor(unsigned uIndex,COLORRGB uColor)
// 		void			SetColor(unsigned uIndex  ,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue)
// 		void			SetColor(unsigned uIndex  ,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha)
//		COLORRGB		GetColor(unsigned uIndex)
// 		COLORRGB		GetColor(unsigned uIndex  ,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)
// 		COLORRGB		GetColor(unsigned uIndex  ,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)
// 		COLORRGB		RgbToColor(                unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue)
// 		COLORRGB		RgbToColor(                unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha)
// 		void			ColorToRgb(COLORRGB uColor,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)
// 		COLORRGB		RgbToGray (                unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue)
// 		COLORRGB		RgbToGray (COLORRGB uColor)
//		unsigned		RgbToPixel(COLORRGB uColor)
//		COLORRGB		ColorTo12 (COLORRGB uColor)
//		COLORRGB		ColorTo14 (COLORRGB uColor)
//		COLORRGB		ColorTo34 (COLORRGB uColor)
//		COLORRGB		ColorTo8  (COLORRGB uColor,unsigned uMul)
//		COLORRGB		ColorDiff (COLORRGB uColor1,COLORRGB uColor2)
//		COLORRGB		ColorDiff2(COLORRGB uColor1,COLORRGB uColor2)
//
//	Funktionen fr die Zwischenablage
//
// 		bool Paste  (void *hWnd=0,int iMode=0)			Bild aus Clipboard kopiern
// 		bool Copy   (void *hWnd=0)						Bild ins Clipboard kopiern
// 		bool Clear  ()									Bild lschen
//		bool Swap	(BitmapImage &sImage)	 			Tausche zwei Bildklassen
//
//	Bitmap-Funktionen
//
//		HBITMAP CreateBitmap(HWND hWnd)					Bitmap erzeugen
//		bool	InsertBitmap(HWND hWnd,HBITMAP Bitmap)	Bitmap kopieren
//		bool	InsertBitmap(BITMAPINFOHEADER*,void*,void*)
//		bool	InsertBitmap(BITMAPINFOHEADER*)
//		bool	InsertBitmap(LPCTSTR pResourceName,HINSTANCE hInstance)
//		bool	InsertBitmap(UINT    nIdResource  ,HINSTANCE hInstance)
//
//	Zeichen-Funktionen
//
//		int  StretchDIB( HDC ,RECT *)
//		int	 StretchDIB( HDC ,POINT*,POINT*  )
//		int	 StretchDIB( HDC ,int,int,int,int)
//		int	 SetDIB    ( HDC ,POINT* )
//		int	 SetDIB    ( HDC ,int,int)
//
//	Bild-Funktionen
//
//		bool ConvertToGray  ()
//		bool ConvertToGray  (BitmapImage&)
//		bool ConvertToGray8 (BitmapImage&)
//		bool ConvertToSingle(BitmapImage&)
//		bool ConvertTo8Bit  (BitmapImage&)
//		bool ConvertToColors(BitmapImage&,COLORREF *pColors,unsigned uMax);
//		bool ConvertToRGB   (BitmapImage&,int iBits=0)
//		bool ConvertToAlpha (BitmapImage&,int uMode=0)
// 		bool Stretch  (const BitmapImage&,RECT  *pRect      ,int iMode=0)
// 		bool Stretch  (const BitmapImage&,unsigned,unsigned,int iMode=0)
//		bool Smoth    (const BitmapImage&,unsigned,unsigned Bits=24);
//		bool Rotate	  (const BitmapImage&,int)
// 		bool Put      (const BitmapImage&,int,int,int iMode=0)
//   	bool Put      (const BitmapImage&,POINT *,int iMode=0)
// 		bool Get      (const BitmapImage&,int,int,int,int)
//   	bool Get      (const BitmapImage&,RECT*)
// 		bool Fill     (POINT*	      ,int iPixel)
// 		bool Fill     (int,int,       ,int iPixel)
// 		bool Line     (POINT *,POINT *,int iPixel)
// 		bool Line     (int,int,int,int,int iPixel)
// 		bool LineSmoth(POINT *,POINT *,int iPixel)
// 		bool LineSmoth(int,int,int,int,int iPixel)
// 		bool Box      (int,int,int,int,int iPixel)
// 		bool Frame    (int,int,int,int,int iPixel)
// 		bool Frame    (RECT*          ,int iPixel)
// 		bool Rectangle(int,int,int,int,int iPixel)
// 		bool Rectangle(RECT*          ,int iPixel)
// 		bool Triangle (int,int,int,int,int,int,int iPixel)
// 		bool Triangle (int*           ,int iPixel)
//
//	Pixel-Funktionen
//
// 		unsigned GetPixel(unsigned ,unsigned)
// 		void	 SetPixel(unsigned ,unsigned,unsigned uPixel)
// 		COLORRGB GetRGB  (unsigned ,unsigned)
// 		void	 GetRGB  (unsigned ,unsigned,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)
// 		void	 GetRGB  (unsigned ,unsigned,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)
// 		void	 SetRGB  (unsigned ,unsigned,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue)
// 		void	 SetRGB  (unsigned ,unsigned,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha)
//
// 		unsigned GetPixel(POINT *)
// 		void	 SetPixel(POINT *,unsigned uPixel)
// 		COLORRGB GetRGB  (POINT *)
// 		void	 GetRGB  (POINT *,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)
// 		void	 GetRGB  (POINT *,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)
// 		void	 SetRGB  (POINT *,unsigned,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue)
// 		void	 SetRGB  (POINT *,unsigned,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha)
//
//	Reihen-Funktionen
//
// 		unsigned char *GetRow     (unsigned)	Zeiger auf Reihe holen direct zum Bild
// 		unsigned char *GetRow4    (unsigned)	Zeiger auf Reihe holen 4 Byte Format
// 		unsigned char *GetRow3    (unsigned)	Zeiger auf Reihe holen 3 Byte Format
// 		unsigned char *GetRow4Temp(unsigned)	Zeiger auf kopierte Reihe holen 4 Byte Format
// 		unsigned char *GetRow3Temp(unsigned)	Zeiger auf kopierte Reihe holen 3 Byte Format
//		operator[unsigned]						Zeiger auf Bild-Reihe holen
//
//	Text-Funktionen
//
//		int		Print(unsigned,unsigned,const char*)
//		int		Print(POINT*           ,const char*)
//		int		Print(                  const char*)
//
//	Diverse-Funktionen
//
//     void SetProgressFunction  (IMAGEPROGRESSFUNCTION,void*);

#ifndef   __BITIMAGE_H__
#define   __BITIMAGE_H__

#if        _MSC_VER >= 1000
#pragma		once
#endif

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif


#define	BITMAPIMAGE_CFG	0x8080C88B		// Freigegebene Bit-Formate

#if defined(_WIN32)
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
										// Falls AFX verwendet wird
	#include <afx.h>					// MFC-Kern
	#include <afxwin.h>					// MFC-Kern- und -Standardkomponenten
	#include <stdlib.h>

#else

	#ifdef	 _WIN32
	#include <Windows.h>
	#include <stdlib.h>
	#endif

#endif
#endif


#ifdef	_MSC_VER						// Falls Visual C++ verwendet wird
	#define FC	__fastcall
	#pragma warning( disable :4100 )
#else
	#ifndef	FC
	#define FC
	#endif
	#ifndef	_cdecl
	#define _cdecl
	#endif
	#ifndef	__cdecl
	#define __cdecl
	#endif
#endif

#define TEXT_AUTOSPACE		0xBCDEEEEE
#define TEXT_NONE			NULL
#define TEXT_SMOTH			BitmapImage::SetTextPixelSmoth
#define TEXT_NORMAL			BitmapImage::SetTextPixelNormal
#define LINE_DOTTED			BitmapImage::SetLinePixelDotted
#define LINE_DASHED			BitmapImage::SetLinePixelDashed
#define FILL_GET			BitmapImage::GetFillPixel
#define BI_TETXSIZE			0xBCDEFFFF
#define BI_NOT_INIT			0xBCDE7AF9
#define BI_BITMAP			((void*)1)

#define ROW_PTR(y)			(pImageData1-(y)*uRowWidth)		// Reihen Zeiger
#define ROW_PTR_C(c,y)		((c)->pImageData1-(y)*(c)->uRowWidth)
#define RGB_COMPINE(a,b)	((((a)&0x00FEFEFE)>>1)+(((b)&0x00FEFEFE)>>1))
#define RGB_COMPINE_13(a,b)	((((a)&0x00FCFCFC)>>2)+(((b)&0x00FCFCFC)>>2)*3)
#define RGB_COMPINE_31(a,b)	((((b)&0x00FCFCFC)>>2)+(((a)&0x00FCFCFC)>>2)*3)

#define BGR(r,g,b)			(((unsigned)(unsigned char)(b))|(((unsigned)(unsigned char)(g))<<8)|(((unsigned)(unsigned char)(r))<<16))
#define BGRA(r,g,b,a)		(((unsigned)(unsigned char)(b))|(((unsigned)(unsigned char)(g))<<8)|(((unsigned)(unsigned char)(r))<<16)|(((unsigned)(unsigned char)(a))<<24))
#define RGBA(r,g,b,a)		(((unsigned)(unsigned char)(r))|(((unsigned)(unsigned char)(g))<<8)|(((unsigned)(unsigned char)(b))<<16)|(((unsigned)(unsigned char)(a))<<24))

class	BitmapImage;
class	BitmapImageCoder;

typedef void				(FC *PixelFunction)(BitmapImage *pImage                    ,unsigned uXpos,unsigned uYpos,unsigned uColor);
typedef void      			(FC *PixelFillSet )(BitmapImage *pImage,unsigned char *pPtr,unsigned uXpos,unsigned uYpos,unsigned uColor);
typedef unsigned  			(FC *PixelFillGet )(BitmapImage *pImage,unsigned char *pPtr,unsigned uXpos,unsigned uYpos);

typedef int					int_bm32;
typedef short 		    	int_bm16;
typedef unsigned			uint_bm32;
typedef unsigned short 		uint_bm16;


//*****************************************************************************
//*
//*		Falls Kein Windows verwendet wird
//*
//*****************************************************************************
#ifndef	_WIN32


typedef	struct tagPOINT
	{
	int_bm32 		x;
	int_bm32		y;
	}POINT;

typedef struct tagSIZE
	{
	int_bm32		cx;
	int_bm32		cy;
	}SIZE;

typedef	struct tagRECT
	{
	int_bm32		left;
	int_bm32		top;
	int_bm32		right;
	int_bm32		bottom;
	}RECT;

typedef	POINT	   *LPPOINT;
typedef	RECT	   *LPRECT;
typedef	void	   *HDC;
typedef	void	   *HWND;
typedef	void	   *HGLOBAL;
typedef	void	   *HBITMAP;

typedef struct tagBITMAPINFOHEADER
	{
   	uint_bm32  		biSize;
	int_bm32  		biWidth;
   	int_bm32  		biHeight;
   	uint_bm16		biPlanes;
   	uint_bm16		biBitCount;
   	uint_bm32  		biCompression;
   	uint_bm32  		biSizeImage;
   	int_bm32		biXPelsPerMeter;
   	int_bm32		biYPelsPerMeter;
   	uint_bm32  		biClrUsed;
   	uint_bm32  		biClrImportant;
	}BITMAPINFOHEADER;

typedef struct tagRGBQUAD
	{
    unsigned char	rgbBlue;
    unsigned char	rgbGreen;
    unsigned char	rgbRed;
    unsigned char	rgbReserved;
	}RGBQUAD;

typedef struct tagRGBTRIPLE
	{
    unsigned char	rgbtBlue;
    unsigned char	rgbtGreen;
    unsigned char	rgbtRed;
	}RGBTRIPLE;

typedef struct tagBITMAPINFO
	{
	BITMAPINFOHEADER bmiHeader;
	RGBQUAD          bmiColors[1];
	}BITMAPINFO;

#ifdef	__GNUC__

typedef struct tagBITMAPFILEHEADER
	{
    uint_bm16		bfType;
    uint_bm32  		bfSize;
    uint_bm16		bfReserved1;
    uint_bm16		bfReserved2;
    uint_bm32  		bfOffBits;
	}BITMAPFILEHEADER __attribute__(aligned(1));

#else

#pragma pack(push,1)

typedef struct tagBITMAPFILEHEADER
	{
    uint_bm16		bfType;
    uint_bm32  		bfSize;
    uint_bm16		bfReserved1;
    uint_bm16		bfReserved2;
    uint_bm32  		bfOffBits;
	}BITMAPFILEHEADER;

#pragma pack(pop)

#endif


typedef struct tagBITMAPCOREHEADER
	{
    uint_bm32  		bcSize;
    uint_bm16		bcWidth;
    uint_bm16		bcHeight;
    uint_bm16		bcPlanes;
    uint_bm16		bcBitCount;
	}BITMAPCOREHEADER;

typedef struct tagBITMAP
	{
	uint_bm32  		bmType;
	uint_bm32  		bmWidth;
	uint_bm32  		bmHeight;
	uint_bm32  		bmWidthBytes;
	uint_bm32  		bmPlanes;
	uint_bm32  		bmBitsPixel;
	void		   *bmBits;
	}BITMAP;


typedef unsigned	COLORREF;		// Blue  = Byte 2
									// Green = Byte 1
									// Red   = Byte 0


#define BI_RGB			0
#define BI_BITFIELDS	3
#define GDI_ERROR		0xFFFFFFFF


#endif


//*****************************************************************************
//*
//*		Typen
//*
//*****************************************************************************

typedef unsigned	COLORRGB;		// Blue  = Byte 0
									// Green = Byte 1
									// Red   = Byte 2

//Type  DWORD		COLORREF;		// Blue  = Byte 2
									// Green = Byte 1
									// Red   = Byte 0


typedef void (*PROGRESSFUNCTION)(BitmapImageCoder	   &sCoder,
										void		   *pData,
                                 		unsigned 		uCurrent,
                                 		unsigned 		uPassCount,
                                 		unsigned 		uProgress,
                                 		bool		   &bCancel);

typedef void (*IMAGEPROGRESSFUNCTION)(	BitmapImage    &sImage,
										void		   *pData,
										unsigned 		uCurrent,
										unsigned 		uPassCount,
										unsigned 		uProgress,
										bool           &bCancel);



//*****************************************************************************
//*
//*		Klasse BitmapImageCoder
//*
//*****************************************************************************
class BitmapImageCoder
{
public:

	BitmapImageCoder();
   ~BitmapImageCoder();

	void	 SetProgressFunction(PROGRESSFUNCTION,void*);
	char    *SetComment(const char    *pText);
	char    *SetComment(const wchar_t *pText);
	char    *GetComment();


protected:

	void	Initialize();
	void	DoCopy(const BitmapImageCoder &sSource);

	PROGRESSFUNCTION  pProgressProc;
	void             *pProgressData;
	char			 *pComment;
	int			      iCommentLen;

};

inline char *BitmapImageCoder::GetComment(){return pComment;}
inline void  BitmapImageCoder::SetProgressFunction(PROGRESSFUNCTION pProc,void *pData)
{
	pProgressProc = pProc;
	pProgressData = pData;
}




//*****************************************************************************
//*
//*		Klassen		BitmapImageDecoder / BitmapImageEncoder
//*
//*****************************************************************************

class CFileBuffer;

class BitmapImageDecoder : public BitmapImageCoder
{
public:
		     BitmapImageDecoder(){};
virtual     ~BitmapImageDecoder(){};
virtual void ReadImage (const char    *pName, BitmapImage &sImage)=0;
virtual void ReadImage (const wchar_t *pName, BitmapImage &sImage)=0;
virtual void ReadImage (CFileBuffer   *pFile, BitmapImage &sImage)=0;
};

class BitmapImageEncoder : public BitmapImageCoder
{
public:
			 BitmapImageEncoder(){};
virtual     ~BitmapImageEncoder(){};
virtual void WriteImage(const char    *pName,const BitmapImage &sImage)=0;
virtual void WriteImage(const wchar_t *pName,const BitmapImage &sImage)=0;
virtual void WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage)=0;
};



//*****************************************************************************
//*
//*
//*		Klasse BitmapImage
//*
//*
//*****************************************************************************
class BitmapImage
{


//*****************************************************************************
//*
//*		Typen fr BitmapImage
//*
//*****************************************************************************

public:

	enum{
		AlphaOffset	= 3,
		RedOffset	= 2,
		GreenOffset	= 1,
		BlueOffset	= 0,
		};


	typedef union 										// Fr 24-Bit Farben
		{
		struct
			{
		unsigned char	ucBlue;
		unsigned char	ucGreen;
		unsigned char	ucRed;
		unsigned char	ucMask;
			};

		COLORRGB		uRgb;
		}ColorMapEntry;


protected:

	struct ColorUsage									// Fr Farbkonvertierung
		{
		unsigned		uUsage;
		unsigned char	aColors[3];
		ColorUsage     *pNext  [3];
		};

	struct ColorUsageTable
		{
		ColorUsage	   *pLists[256][3];
		unsigned		uColorCount;
		} ;

	struct ColorArea
		{
		struct
			{
			unsigned char ucLow;
			unsigned char ucHigh;
			}aColorValues[3];

		unsigned		uColorCount;
		unsigned		uPixelCount;
		};

	ColorUsageTable    *pColorUsage;
	ColorArea          *pColorAreas;
	unsigned char      *pActualFont;
	unsigned	     	uAreaCount;
	unsigned char 		uFontOff;
	unsigned char 		uFontBit;
	unsigned short 		uFontMin;
	unsigned short 		uFontMax;
	char 				cTextAlignX;
	char 				cTextAlignY;
	char 				cTextAddY;
	char 				cLastError;
	int					iTextShift;
	int					iTextSpace;
	int					iTextBase;
	int					iTextJump;
	int					iTextHole;
	unsigned		 	uTextColor0;
	unsigned		 	uTextColor1;
	PixelFunction	 	pSet0;
	PixelFunction	 	pSet1;


//*****************************************************************************
//*
//*		Funktionen fr BitmapImage
//*
//*****************************************************************************

public:

	         BitmapImage ();
	virtual ~BitmapImage ();
	         BitmapImage (           const BitmapImage &sImage);
			 BitmapImage &operator= (const BitmapImage &sImage);
	unsigned char*        operator[](unsigned) const;


												// Bild Daten einstellen
	bool	SetSize			(unsigned uBits,unsigned uSizeX,unsigned uSizeY,unsigned uPixel=0,void *pData=0);


	ColorMapEntry &ColorMap	(unsigned uIndex);	// Function to retrieve entries in the color map.
	ColorMapEntry  ColorMap	(unsigned uIndex) const;

	int	 	SetDIB    		(HDC hDc,int	iPosX,int iPosY);
	int	 	SetDIB    		(HDC hDc,POINT *pTopLeft);
	int		StretchDIB		(HDC hDc,RECT  *pRect);
	int	 	StretchDIB		(HDC hDc,POINT *pTopLeft,POINT *pBottomRight);
	int	 	StretchDIB		(HDC hDc,int	iPosX,int iPosY,int iSizeX,int iSizeY);

	HBITMAP CreateBitmap	(HWND hWnd=0);
	bool	InsertBitmap	(HWND hWnd,HBITMAP hBitmap);
	bool	InsertBitmap	(BITMAPINFOHEADER *pInfo,void *pData,void *pColors);
	bool	InsertBitmap	(BITMAPINFOHEADER *pInfo);
	bool	InsertBitmap	(LPCTSTR pResourceName,HINSTANCE hInstance=0);
	bool	InsertBitmap	(UINT    nIdResource  ,HINSTANCE hInstance=0);

	bool 	Paste			(HWND hWnd=0,int iMode=0);		// Bild aus Clipboard kopiern
	bool 	Copy			(HWND hWnd=0)const;				// Bild ins Clipboard kopiern
	bool 	Clear			();								// Bild lschen
	bool    Swap			(BitmapImage &sImage);			// Tausche zwei Bildklassen

	int 	LastError		()const;
	int 	HasAlphaEx		()const;
	bool	HasAlpha		()const;
	bool	FillAlpha		(unsigned char ucAlpha=255);
	bool	PutAlphaArea	(unsigned uColor);
	bool 	PutAlphaEx		(const BitmapImage &sImage,int      iPosX,int       iPosY);
  	bool 	PutAlphaEx		(const BitmapImage &sImage,POINT   *pTopLeft);
	bool 	PutAlpha		(const BitmapImage &sImage,int      iPosX,int       iPosY);
  	bool 	PutAlpha		(const BitmapImage &sImage,POINT   *pTopLeft);
	bool 	PutMask			(const BitmapImage &sImage,int      iPosX,int       iPosY,const BitmapImage &sMask);
  	bool 	PutMask			(const BitmapImage &sImage,POINT   *pTopLeft             ,const BitmapImage &sMask);
	bool 	Stretch 		(const BitmapImage &sImage,RECT    *pRect				  ,int iMode=0);
	bool 	Stretch 		(const BitmapImage &sImage,unsigned iSizeX,unsigned iSizeY,int iMode=0);
	bool 	Stretch 		(                          RECT    *pRect				  ,int iMode=0);
	bool 	Stretch 		(                          unsigned iSizeX,unsigned iSizeY,int iMode=0);
	bool 	Put     		(const BitmapImage &sImage,int      iPosX,int       iPosY ,int iMode=0);
  	bool 	Put     		(const BitmapImage &sImage,POINT   *pTopLeft,              int iMode=0);
	bool 	Get     		(const BitmapImage &sImage,int iPosX,int iPosY,int iSizeX ,int iSizeY );
  	bool 	Get				(const BitmapImage &sImage,RECT  *pRect);
	bool 	Polygon			(POINT*pPoints,int iCount,int iPixel);
	bool 	Polygon			(POINT*pPoints,int iCount,int iPixel,PixelFillSet pSet);
	bool 	Polygon			(int  *pPoints,int iCount,int iPixel);
	bool 	Polygon			(int  *pPoints,int iCount,int iPixel,PixelFillSet pSet);
	bool 	Line     		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel,PixelFillSet  pSet ,int iFull=1);
	bool 	Line     		(POINT*pTopLeft       ,POINT *pBottomRight  ,int iPixel,PixelFunction pProc,int iFull=1);
	bool 	Line     		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel,PixelFunction pProc,int iFull=1);
	bool 	Line     		(POINT*pTopLeft       ,POINT *pBottomRight  ,int iPixel);
	bool 	Line     		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel);
	bool 	LineSmoth 		(POINT*pTopLeft       ,POINT *pBottomRight  ,int iPixel,int iFull=1);
	bool 	LineSmoth 		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel,int iFull=1);
	bool 	Circle 			(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFunction pProc,int iAngelFrom=0,int iAngelTo=0x20000,int iRoll=0,int iFull=1);
	bool 	Circle 			(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,                    int iAngelFrom=0,int iAngelTo=0x20000,int iRoll=0);
	bool 	CircleSmoth		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,                    int iAngelFrom=0,int iAngelTo=0x20000,int iRoll=0);
	bool 	Ellipsis		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFillSet pSet,int iMode=0);
	bool 	Ellipsis		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel                  ,int iMode=0);
	bool 	EllipsisSmoth	(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel                  ,int iMode=0);
	bool 	BoxAlpha  		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel);
	bool 	BoxAlpha  		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel1,int iPixel2,int iPaternSize=0);
	bool 	Box      		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel);
	bool 	Box      		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel1,int iPixel2,int iPaternSize);
	bool 	Box				(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel ,int iAlpha);
	bool 	Box      		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFillSet pSet);
	bool 	Move      		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iTargetX,int iTargetY);
	bool 	Move      		(RECT  *pRect                               ,int iTargetX,int iTargetY);
	bool 	Move      		(RECT  *pRect                               ,POINT *pTarget);
	bool 	Frame    		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel);
	bool 	Frame    		(RECT *pRect                                ,int iPixel);
	bool 	Frame    		(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFunction pProc);
	bool 	Frame    		(RECT *pRect                                ,int iPixel,PixelFunction pProc);
	bool 	Rectangle		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel);
	bool 	Rectangle		(RECT *pRect                                ,int iPixel);
	bool 	Rectangle		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel,int iAlpha);
	bool 	Rectangle		(RECT *pRect                                ,int iPixel,int iAlpha);
	bool 	Rectangle		(int   iPosX,int iPosY,int iEndX ,int iEndY ,int iPixel,PixelFillSet pSet);
	bool 	Rectangle		(RECT *pRect                                ,int iPixel,PixelFillSet pSet);
	bool 	Triangle		(int  *pPoints								,int iPixel,PixelFillSet pSet);
	bool 	Triangle		(int  *pPoints								,int iPixel);
	bool 	Triangle		(int  *pPoint1,int  *pPoint2,int  *pPoint3	,int iPixel);
	bool 	Triangle		(int  *pPoint1,int  *pPoint2,int  *pPoint3	,int iPixel,PixelFillSet pSet);
	bool 	Triangle		(int   iPosX1,int iPosY1,int iPosX2,int iPosY2,int iPosX3,int iPosY3,int iPixel);
	bool 	Triangle		(int   iPosX1,int iPosY1,int iPosX2,int iPosY2,int iPosX3,int iPosY3,int iPixel,PixelFillSet pSet);
	bool 	Roll			(const BitmapImage &sSource,int iAngel,int iMode,int &iCenterX,int &iCenterY,unsigned uColor=0);
	bool 	Roll			(const BitmapImage &sSource,int iAngel,int iMode=0,unsigned uColor=0);
	bool 	Rotate       	(const BitmapImage &sImage,int iMode,int iSwapX=0,int iSwapY=0);
	bool 	Rotate       	(                          int iMode,int iSwapX=0,int iSwapY=0);
	bool 	Smoth        	(const BitmapImage &sImage,unsigned iMode=32,unsigned uBits=24);
	bool	ConvertToColors (const BitmapImage &sImage,unsigned uMax=0,COLORREF *pColors=0);
	bool 	ConvertToRGB 	(const BitmapImage &sImage,                  unsigned uBits= 0);
	bool 	ConvertTo8Bit	(const BitmapImage &sImage);
	bool	ConvertToSingle (const BitmapImage &sImage);
	bool 	ConvertToGray8	(const BitmapImage &sImage);
	bool 	ConvertToGray	(const BitmapImage &sImage);
	bool	ConvertToAlpha  (const BitmapImage &sImage,int iMode=0,COLORRGB uColor=0);
	bool	ConvertToColors (unsigned uMax=0,COLORREF *pColors=0);
	bool 	ConvertToRGB 	(                  unsigned uBits= 0);
	bool 	ConvertTo8Bit	();
	bool	ConvertToSingle ();
	bool 	ConvertToGray8	();
	bool 	ConvertToGray	();
	bool	CompessColors   ();
	bool	ConvertToAlpha  (int iMode=0,COLORRGB uColor=0);

	bool            IsOk       () const;		// Bild vorhanden
	bool            IsRGB      () const; 		// Bild im RGB-Modus
	unsigned		Width      () const;		// Bild Breite
	unsigned		Height     () const;		// Bild Hhe
	unsigned		BitCount   () const;		// Bild Bitanzahl
	unsigned		ColorCount () const;		// Bild	Farbenanzahl
	unsigned		BytesPerRow() const;		// Bild Breite einer Zeile
	unsigned char  *ImageData  () const;		// Bild Daten
	unsigned char  *GetRow     (unsigned uPosY)const;
	unsigned char  *GetRow1    (unsigned uPosY)const;
	unsigned char  *GetRow3    (unsigned uPosY)const;
	unsigned char  *GetRow4    (unsigned uPosY)const;
	unsigned char  *GetRow1Temp(unsigned uPosY)const;
	unsigned char  *GetRow3Temp(unsigned uPosY)const;
	unsigned char  *GetRow4Temp(unsigned uPosY)const;
	unsigned		GetPixel   (unsigned uPosX,unsigned uPosY)const;
	void			SetPixel   (unsigned uPosX,unsigned uPosY,unsigned uPixel);
	unsigned char 	GetAlpha   (unsigned uPosX,unsigned uPosY);
	void			SetAlpha   (unsigned uPosX,unsigned uPosY,unsigned uAlpha);
	COLORRGB		GetRGB     (unsigned uPosX,unsigned uPosY)const;
	void			GetRGB     (unsigned uPosX,unsigned uPosY,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)const;
	void			GetRGB     (unsigned uPosX,unsigned uPosY,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)const;
	void			SetRGB     (unsigned uPosX,unsigned uPosY,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue);
	void			SetRGB     (unsigned uPosX,unsigned uPosY,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha);

	unsigned		RgbToPixel (COLORRGB uColor)const;

	unsigned		GetPixel   (unsigned char *pPtr,unsigned uPosX);
	void			SetPixel   (unsigned char *pPtr,unsigned uPosX,unsigned uPixel);
	unsigned		GetPixel   (POINT *pPoint)const;
	void	 		SetPixel   (POINT *pPoint,unsigned uPixel);
	COLORRGB 		GetRGB     (POINT *pPoint)const;
	void	 		GetRGB     (POINT *pPoint,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)const;
	void	 		GetRGB     (POINT *pPoint,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)const;
	void			SetRGB     (POINT *pPoint,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue);
	void			SetRGB     (POINT *pPoint,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha);
	void			SetAlpha   (POINT *pPoint,unsigned uAlpha);
	unsigned char 	GetAlpha   (POINT *pPoint);

	static unsigned	SwapRGB    (unsigned       uColor);
	static void  FC	SwapRGB4   (unsigned char *pRow,int Count);
	static void  FC SwapRGB3   (unsigned char *pRow,int Count);

	void			SetColor   (unsigned uIndex,COLORRGB uColor);
	void     		SetColor   (unsigned uIndex,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue);
	void     		SetColor   (unsigned uIndex,unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char  ucAlpha);
	COLORRGB 		GetColor   (unsigned uIndex,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)const;
	COLORRGB 		GetColor   (unsigned uIndex,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)const;
	COLORRGB 		GetColor   (unsigned uIndex)const;

	static COLORRGB RgbToGray  (unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue);
	static COLORRGB	RgbToColor (unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue);
	static COLORRGB	RgbToColor (unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue,unsigned char ucAlpha);
	static COLORRGB RgbToGray  (COLORRGB uColor);
	static void		ColorToRgb (COLORRGB uColor,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue);
	static void		ColorToRgb (COLORRGB uColor,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha);
	static COLORRGB ColorTo12  (COLORRGB uColor);
	static COLORRGB ColorTo14  (COLORRGB uColor);
	static COLORRGB ColorTo34  (COLORRGB uColor);
	static COLORRGB ColorTo8   (COLORRGB uColor ,unsigned uMul);
	static COLORRGB	ColorDiff  (COLORRGB uColor1,COLORRGB uColor2);
	static COLORRGB	ColorDiff2 (COLORRGB uColor1,COLORRGB uColor2);

	static void	FC	SetLinePixelDotted (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void	FC	SetLinePixelDashed (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void	FC	SetTextPixelNormal (BitmapImage *pImage,unsigned uPosX,unsigned uPosY,unsigned uColor);
	static void	FC	SetTextPixelSmoth  (BitmapImage *pImage,unsigned uPosX,unsigned uPosY,unsigned uColor);
	static void	FC	SetTextPixelSmoth32(BitmapImage *pImage,unsigned uPosX,unsigned uPosY,unsigned uColor);
	static unsigned FC	GetFillPixel   (BitmapImage *pImage,unsigned char *pRow,unsigned uPosX,unsigned uPosY);

	static void FC	DrawPixel1  (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixel2  (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixel3  (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixel4  (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixel5  (BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);

	static void FC	DrawPixelEx1(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixelEx2(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixelEx3(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixelEx4(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);
	static void FC	DrawPixelEx5(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor);

	bool			Fill		(POINT    *pPoint,               unsigned    uPixel,PixelFillSet pSet,PixelFillGet pGet=FILL_GET,unsigned uStart=0xFFFFFFFF);
	bool    		Fill   		(unsigned  uXpos ,unsigned uYpos,unsigned    uPixel,PixelFillSet pSet,PixelFillGet pGet=FILL_GET,unsigned uStart=0xFFFFFFFF);
	bool			Fill   		(POINT    *pPoint,               unsigned    uPixel);
	bool    		Fill   		(unsigned  uXpos ,unsigned uYpos,unsigned    uPixel);
	int				Print  		(POINT    *pPoint,               const char *pText );
	int				Print  		(unsigned  uXpos ,unsigned uYpos,const char *pText );
	int				Print  		(                                const char *pText );
	void			Scroll 		(int iShiftX,int iShiftY,int iFill=BI_NOT_INIT);
	void			SetAlign	(int iAlignX,int iAlignY=0);
	void			SetSpacing	(int iSpace);
	void			SetFont		(unsigned char *pFont);
	void 			SetPixelFunction(PixelFunction pProc,unsigned uColor=0,int iPixel=0);
    void			SetProgressFunction(IMAGEPROGRESSFUNCTION pProc,void *pParam);
   	bool			GetPixelsPerMeter(int &iPerMeterX,int &iPerMeterY);
   	bool			SetPixelsPerMeter(int  iPerMeterX,int  iPerMeterY);

	unsigned char  *SetInitMem	(void *pPtr);
	void  			SetUserData	(int   iData);
    void			SetUserPtr 	(void *pPtr);
    void			GetUserPtr 	(void *pPtr)const;
    int 			GetUserData	()const;
    void		   *GetUserPtr 	()const;
	HBITMAP			GetBitmap  	()const;
	BITMAPINFO     *Info       	()const;


	enum       { RowRounding = 4 } ;			// Number of bytes to round each uPosY to. On Windows this should be 4.

protected:

	void ClearData();
	void DoCopy(const BitmapImage &);


	void 			FreeColorQuant  ();
	int				LargestColorArea(ColorArea    &uArea);
	void 			CreateColor     (unsigned      uColor);
	unsigned char  *GetRow_         (unsigned      uPosY)const;
	void			TextPut			(unsigned      uXpos ,unsigned uYpos      ,unsigned char *pMem);
	void			TextDummy		(unsigned      uXpos ,unsigned uYpos      ,int iSizeX,int iSizeY,PixelFunction pSet);
	void 			SplitAreaInHalf (unsigned      uDepth,unsigned uRetryDepth,unsigned uArea,unsigned uSplitColor);
	void 			AddColor		(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue);
	unsigned		QuantizedColor  (unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue);
	ColorUsage     *FindColor		(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue);
	void 			FindColorUsage  (const BitmapImage &sImage);
	void			QuantizeSrcImage(const BitmapImage &sImage);

protected:


	static	unsigned char* FC Get1Row0  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get1Row1  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get1Row2  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get1Row4  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get1Row8  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get1RowG  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row0  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row1  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row2  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row4  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row8  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row12 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row15 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row16 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row24 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get3Row32 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row0  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row1  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row2  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row4  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row8  (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row12 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row15 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row16 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row24 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC Get4Row32 (unsigned char *pRow,BitmapImage *pImage);
	static	unsigned char* FC GetTRow   (unsigned char *pRow,BitmapImage *pImage);

	static	unsigned       FC GetPixel0 (unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel1 (unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel2 (unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel4 (unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel8 (unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel12(unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel15(unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel16(unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel24(unsigned char *pRow,unsigned uPosX);
	static	unsigned       FC GetPixel32(unsigned char *pRow,unsigned uPosX);

	static	void           FC SetPixel0 (unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel1 (unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel2 (unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel4 (unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel8 (unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel12(unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel15(unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel16(unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel24(unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	static	void           FC SetPixel32(unsigned char *pRow,unsigned uPosX,unsigned uPixel);

	static	unsigned       FC RgbToPixel0 (COLORRGB uColor);
	static	unsigned       FC RgbToPixel1 (COLORRGB uColor);
	static	unsigned       FC RgbToPixel2 (COLORRGB uColor);
	static	unsigned       FC RgbToPixel4 (COLORRGB uColor);
	static	unsigned       FC RgbToPixel8 (COLORRGB uColor);
	static	unsigned       FC RgbToPixel12(COLORRGB uColor);
	static	unsigned       FC RgbToPixel15(COLORRGB uColor);
	static	unsigned       FC RgbToPixel16(COLORRGB uColor);
	static	unsigned       FC RgbToPixel24(COLORRGB uColor);
	static	unsigned       FC RgbToPixel32(COLORRGB uColor);


//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

protected:

	BITMAPINFO     *pBitmapInfo;						// Zeiger fr Bildstatus (muss als erstes stehen)
	void		   *pUserPtr;							// Zeiger fr User-Daten
	unsigned char  *pImageRow;							// Zeiger fr Reserve Reihe
	unsigned char  *pImageMem;							// Zeiger fr Bilddaten
	unsigned char  *pImageBase;							// Zeiger fr SetSize NULL
	unsigned char  *pImageData;							// Zeiger fr Bilddaten
	unsigned char  *pImageData1;						// Zeiger fr Bilddaten-1
	unsigned		uImageWidth;						// Bildbreite in Pixel
	unsigned		uImageHeight;						// Bildhhe   in Pixel
	unsigned   		uImageSize;							// Bildgre  in Byte
	unsigned   		uImageBits;							// Bits je Pixel (1, 2, 4, 8, or 24)
	unsigned   		uRowWidth;							// Bildbreite in Byte
	unsigned   		uColumMask;							// Maske fr den Offset im Byte
	unsigned   		uShiftMask;							// Bei Bit==1 pixel_bytes addieren
	unsigned   		uBytesPerPixel;						// Anzahl der Byte fr einen Pixel
	unsigned   		uPixelMask;							//   2^bits-1
	unsigned   		uPixelBit;							// 1<<(bits-1);
	unsigned   		uColumBit;							// Wie viele Bits hat der Offset
	unsigned   		uIsRgb;								// Hat das Bild ein RGB format
	unsigned   		uColorCount;						// Number of entries in the color map.
	unsigned   		uColorMask;							// Farb-Bits die dargestellt werden
	unsigned		uDelData;							// Speicher freigeben
	unsigned		uMaskDashed;						// Maske fr strichlierte Linien
	unsigned		uMaskDotted;						// Maske fr punktierte Linien
	ColorMapEntry  *pColorMap;							// Color map for 8-bit sImage
	HBITMAP			hBitmap;							// Bitmap-Handle fr den Speicher

	unsigned char  *(FC *Get1Row_   )(unsigned char *pRow,BitmapImage *pImage);
	unsigned char  *(FC *Get3Row_   )(unsigned char *pRow,BitmapImage *pImage);
	unsigned char  *(FC *Get4Row_   )(unsigned char *pRow,BitmapImage *pImage);
	unsigned char  *(FC *Get1RowT_  )(unsigned char *pRow,BitmapImage *pImage);
	unsigned char  *(FC *Get3RowT_  )(unsigned char *pRow,BitmapImage *pImage);
	unsigned char  *(FC *Get4RowT_  )(unsigned char *pRow,BitmapImage *pImage);
	unsigned        (FC *GetPixel_  )(unsigned char *pRow,unsigned uPosX);
	void            (FC *SetPixel_  )(unsigned char *pRow,unsigned uPosX,unsigned uPixel);
	unsigned        (FC *RgbToPixel_)(COLORRGB uColor);

	IMAGEPROGRESSFUNCTION	pProgressProc;				// Callback fr Progessfunktion
	void				   *pProgressData;				// Parameter fr Progessfunktion (muss als letztes stehen)
	void				   	CallProgressFunction(unsigned uPercent,unsigned uPass,unsigned uPassCount);

};

//*****************************************************************************
//*
//*		Inline Funktionen fr BitmapImageCoder
//*
//*****************************************************************************
inline bool				BitmapImage::IsOk        () const{return pImageData && uImageWidth && uImageHeight;}
inline bool				BitmapImage::IsRGB       () const{return uImageBits>=12;}
inline int 				BitmapImage::LastError	 () const{return cLastError    ;}
inline BITMAPINFO      *BitmapImage::Info        () const{return pBitmapInfo   ;}
inline unsigned   		BitmapImage::Width       () const{return uImageWidth   ;}
inline unsigned   		BitmapImage::Height      () const{return uImageHeight  ;}
inline unsigned   		BitmapImage::BitCount    () const{return uImageBits    ;}
inline unsigned   		BitmapImage::ColorCount  () const{return uColorCount   ;}
inline unsigned			BitmapImage::BytesPerRow () const{return uRowWidth     ;}
inline unsigned char   *BitmapImage::ImageData   () const{return pImageData    ;}
inline void				BitmapImage::SetAlign    (int iAlignX,int iAlignY){cTextAlignX=iAlignX;cTextAlignY=iAlignY;if(iAlignY)SetFont(pActualFont);else cTextAddY=0;}
inline void				BitmapImage::SetUserData (int   iData ){pUserPtr=(void*)iData;}
inline void				BitmapImage::SetUserPtr  (void *pPtr  ){pUserPtr=pPtr;}
inline void				BitmapImage::GetUserPtr  (void *pPtr  )const{*(void**)pPtr=pUserPtr;}
inline int 				BitmapImage::GetUserData ()const{return (int)pUserPtr;}
inline void			   *BitmapImage::GetUserPtr  ()const{return      pUserPtr;}
inline HBITMAP			BitmapImage::GetBitmap   ()const{return      hBitmap ;}
inline bool				BitmapImage::InsertBitmap(UINT nIdResource,HINSTANCE hInstance){return InsertBitmap(MAKEINTRESOURCE(nIdResource),hInstance);}


inline unsigned char *BitmapImage::SetInitMem(void *pPtr)
	{
	void *pOld=pImageBase;
	pImageBase = (unsigned char*)pPtr;
	return (unsigned char*)pOld;
	}
inline bool BitmapImage::Polygon(POINT*pPoints,int iCount,int iPixel)
	{
	return Polygon((int*)pPoints,iCount,iPixel);
	}
inline bool BitmapImage::Polygon(POINT*pPoints,int iCount,int iPixel,PixelFillSet pSet)
	{
	return Polygon((int*)pPoints,iCount,iPixel,pSet);
	}
inline bool BitmapImage::Fill(POINT *pPoint,unsigned uPixel,PixelFillSet pSet,PixelFillGet pGet,unsigned uStart)
	{
	return Fill(pPoint->x,pPoint->y,uPixel,pSet,pGet,uStart);
	}
inline bool BitmapImage::Fill(POINT *pPoint,unsigned uPixel)
	{
	return Fill(pPoint->x,pPoint->y,uPixel);
	}
inline int BitmapImage::Print(POINT *pPoint,const char *pText)
	{
	return Print(pPoint->x,pPoint->y,pText);
	}
inline int BitmapImage::Print(const char *pText)
	{
	return Print(0,BI_TETXSIZE,pText);
	}
inline unsigned char *BitmapImage::operator[](unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;	// Koordinaten prfen
	return ROW_PTR(uPosY);
	}
inline BitmapImage::ColorMapEntry &BitmapImage::ColorMap(unsigned uIndex)
	{
	return pColorMap[uIndex&0xFF];
	}
inline BitmapImage::ColorMapEntry  BitmapImage::ColorMap(unsigned uIndex)const
	{
	return pColorMap[uIndex&0xFF];
	}
inline bool BitmapImage::Stretch(const BitmapImage &sImage,RECT  *pRect,int iMode)
	{
	return Stretch(sImage,pRect->right-pRect->left,pRect->bottom-pRect->top,iMode);
	}
inline bool BitmapImage::Put(const BitmapImage &sImage,POINT *pTopLeft,int iMode)
	{
	return Put(sImage,pTopLeft->x,pTopLeft->y,iMode);
	}
inline bool BitmapImage::PutAlphaEx(const BitmapImage &sImage,POINT *pTopLeft)
	{
	return PutAlphaEx(sImage,pTopLeft->x,pTopLeft->y);
	}
inline bool BitmapImage::PutAlpha(const BitmapImage &sImage,POINT *pTopLeft)
	{
	return PutAlpha(sImage,pTopLeft->x,pTopLeft->y);
	}
inline bool BitmapImage::PutMask(const BitmapImage &sImage,POINT *pTopLeft,const BitmapImage &sMask)
	{
	return PutMask(sImage,pTopLeft->x,pTopLeft->y,sMask);
	}
inline bool BitmapImage::Triangle(int iPosX1,int iPosY1,int iPosX2,int iPosY2,int iPosX3,int iPosY3,int iPixel)
	{
	int aPoints[6]={iPosX1,iPosY1,iPosX2,iPosY2,iPosX3,iPosY3};	return Triangle(aPoints,iPixel);
	}
inline bool BitmapImage::Triangle(int iPosX1,int iPosY1,int iPosX2,int iPosY2,int iPosX3,int iPosY3,int iPixel,PixelFillSet pSet)
	{
	int aPoints[6]={iPosX1,iPosY1,iPosX2,iPosY2,iPosX3,iPosY3};	return Triangle(aPoints,iPixel,pSet);
	}
inline bool BitmapImage::Triangle(int *pPoint1,int *pPoint2,int *pPoint3,int iPixel,PixelFillSet pSet)
	{
	int aPoints[6]={pPoint1[0],pPoint1[1],pPoint2[0],pPoint2[1],pPoint3[0],pPoint3[1]};	return Triangle(aPoints,iPixel,pSet);
	}
inline bool BitmapImage::Triangle(int *pPoint1,int *pPoint2,int *pPoint3,int iPixel)
	{
	int aPoints[6]={pPoint1[0],pPoint1[1],pPoint2[0],pPoint2[1],pPoint3[0],pPoint3[1]};	return Triangle(aPoints,iPixel);
	}
inline bool BitmapImage::Rectangle(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel)
	{
	return Box(iPosX,iPosY,iEndX-iPosX,iEndY-iPosY,iPixel);
	}
inline bool BitmapImage::Rectangle(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel,int iAlpha)
	{
	return Box(iPosX,iPosY,iEndX-iPosX,iEndY-iPosY,iPixel,iAlpha);
	}
inline bool BitmapImage::Rectangle(RECT  *pRect,int iPixel)
	{
	return Box(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,iPixel);
	}
inline bool BitmapImage::Rectangle(RECT  *pRect,int iPixel,int iAlpha)
	{
	return Box(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,iPixel,iAlpha);
	}
inline bool BitmapImage::Rectangle(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel,PixelFillSet pSet)
	{
	return Box(iPosX,iPosY,iEndX-iPosX,iEndY-iPosY,iPixel,pSet);
	}
inline bool BitmapImage::Rectangle(RECT  *pRect,int iPixel,PixelFillSet pSet)
	{
	return Box(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,iPixel,pSet);
	}
inline bool BitmapImage::Frame(RECT  *pRect,int iPixel,PixelFunction pProc)
	{
	return Frame(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,iPixel,pProc);
	}
inline bool BitmapImage::Frame(RECT  *pRect,int iPixel)
	{
	return Frame(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,iPixel);
	}
inline bool BitmapImage::Get(const BitmapImage &sImage,RECT  *pRect)
	{
	return Get(sImage,pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top);
	}
inline bool BitmapImage::Move(RECT  *pRect,int iTargetX,int iTargetY)
	{
	return Move(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,iTargetX,iTargetY);
	}
inline bool BitmapImage::Move(RECT  *pRect,POINT *pTarget)
	{
	return Move(pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,pTarget->x,pTarget->y);
	}
inline bool BitmapImage::Line(POINT *pTopLeft,POINT *pBottomRight,int iPixel)
	{
	return Line(pTopLeft->x,pTopLeft->y,pBottomRight->y,pBottomRight->y,iPixel);
	}
inline bool BitmapImage::Line(POINT *pTopLeft,POINT *pBottomRight,int iPixel,PixelFunction pProc,int iFull)
	{
	return Line(pTopLeft->x,pTopLeft->y,pBottomRight->y,pBottomRight->y,iPixel,pProc,iFull);
	}
inline bool BitmapImage::LineSmoth(POINT *pTopLeft,POINT *pBottomRight,int iPixel,int iFull)
	{
	return LineSmoth(pTopLeft->x,pTopLeft->y,pBottomRight->y,pBottomRight->y,iPixel,iFull);
	}

//*****************************************************************************
//*
//*		SetPixel/GetPixel
//*
//*****************************************************************************
inline unsigned BitmapImage::GetPixel(unsigned uPosX,unsigned uPosY) const
	{
	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return 0;	// Koordinaten prfen

	register unsigned char *pPtr;

		   pPtr = ROW_PTR(uPosY);
	return GetPixel_(pPtr,uPosX);
	}

inline void BitmapImage::SetPixel(unsigned uPosX,unsigned uPosY,unsigned uPixel)
	{
	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return;	// Koordinaten prfen

	register unsigned char *pPtr;

	pPtr = ROW_PTR(uPosY);
	SetPixel_(pPtr,uPosX,uPixel);
	}

inline unsigned BitmapImage::GetPixel(POINT *pPoint) const
	{
	if((unsigned)pPoint->x>= uImageWidth ||					// Koordinaten prfen
	   (unsigned)pPoint->y>= uImageHeight)return 0;

	register unsigned char *pPtr;

		   pPtr = ROW_PTR(pPoint->y);
	return GetPixel_(pPtr,pPoint->x);
	}

inline void BitmapImage::SetPixel(POINT *pPoint,unsigned uPixel)
	{
	if((unsigned)pPoint->x>= uImageWidth ||					// Koordinaten prfen
	   (unsigned)pPoint->y>= uImageHeight)return;

	register unsigned char *pPtr;

	pPtr = ROW_PTR(pPoint->y);
	SetPixel_(pPtr,pPoint->x,uPixel);
	}

inline unsigned BitmapImage::GetPixel(unsigned char *pPtr,unsigned uPosX)
	{
	return GetPixel_(pPtr,uPosX);
	}

inline void BitmapImage::SetPixel(unsigned char *pPtr,unsigned uPosX,unsigned uPixel)
	{
	SetPixel_(pPtr,uPosX,uPixel);
	}

inline unsigned BitmapImage::RgbToPixel(COLORRGB uColor) const
	{
	return RgbToPixel_(uColor);
	}

//*****************************************************************************
//*
//*		SetAlpha/GetAlpha
//*
//*****************************************************************************
inline unsigned char BitmapImage::GetAlpha(unsigned uPosX,unsigned uPosY)
	{
	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return 0;			// Koordinaten prfen
	if(uImageBits!=32)return 0;

	register unsigned char *pPtr;

	pPtr = ROW_PTR(uPosY);
	return pPtr[uPosX*4+3];
	}

inline void BitmapImage::SetAlpha(unsigned uPosX,unsigned uPosY,unsigned uAlpha)
	{
	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return;			// Koordinaten prfen
	if(uImageBits!=32)return;

	register unsigned char *pPtr;

	pPtr = ROW_PTR(uPosY);
	pPtr[uPosX*4+3]=uAlpha;
	}

inline unsigned char BitmapImage::GetAlpha(POINT *pPoint)
	{																// Koordinaten prfen
	if((unsigned)(pPoint->x)>=uImageWidth || (unsigned)(pPoint->y)>=uImageHeight)return 0;
	if(uImageBits!=32)return 0;

	register unsigned char *pPtr;

	pPtr = ROW_PTR(pPoint->y);
	return pPtr[pPoint->x*4+3];
	}

inline void BitmapImage::SetAlpha(POINT *pPoint,unsigned uAlpha)
	{																// Koordinaten prfen
	if((unsigned)(pPoint->x)>=uImageWidth || (unsigned)(pPoint->y)>=uImageHeight)return;
	if(uImageBits!=32)return;

	register unsigned char *pPtr;

	pPtr = ROW_PTR(pPoint->y);
	pPtr[pPoint->x*4+3]=uAlpha;
	}



//*****************************************************************************
//*
//*		GetRGB
//*
//*****************************************************************************
inline COLORRGB BitmapImage::GetRGB(unsigned uPosX,unsigned uPosY)const
	{
	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return 0;	// Koordinaten prfen

	register	unsigned char *pPtr;

	pPtr=ROW_PTR(uPosY);

	if(uIsRgb)return GetPixel_(pPtr,uPosX);
	return pColorMap[GetPixel_(pPtr,uPosX)].uRgb;
	}

inline COLORRGB	BitmapImage::RgbToColor(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			}sTemp;

	sTemp.uRgb[RedOffset  ]=ucRed;
	sTemp.uRgb[GreenOffset]=ucGreen;
	sTemp.uRgb[BlueOffset ]=ucBlue;
	sTemp.uRgb[AlphaOffset]=0;

	return sTemp.uColor;
	}

inline COLORRGB BitmapImage::RgbToColor(unsigned char  ucRed,unsigned char  ucGreen,unsigned char  ucBlue,unsigned char ucAlpha)
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			}sTemp;

	sTemp.uRgb[RedOffset  ]=ucRed;
	sTemp.uRgb[GreenOffset]=ucGreen;
	sTemp.uRgb[BlueOffset ]=ucBlue;
	sTemp.uRgb[AlphaOffset]=ucAlpha;

	return sTemp.uColor;
	}

inline void BitmapImage::ColorToRgb(COLORRGB uColor,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			}sTemp;

	sTemp.uColor = uColor;
	ucRed		 = sTemp.uRgb[RedOffset  ];
	ucGreen		 = sTemp.uRgb[GreenOffset];
	ucBlue		 = sTemp.uRgb[BlueOffset ];
	}

inline void BitmapImage::ColorToRgb(COLORRGB uColor,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			}sTemp;

	sTemp.uColor = uColor;
	ucRed		 = sTemp.uRgb[RedOffset  ];
	ucGreen 	 = sTemp.uRgb[GreenOffset];
	ucBlue  	 = sTemp.uRgb[BlueOffset ];
	ucAlpha 	 = sTemp.uRgb[AlphaOffset];
	}

inline COLORRGB BitmapImage::RgbToGray(COLORRGB uColor)
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			}sTemp;

	sTemp.uColor =  uColor;
	sTemp.uColor =  sTemp.uRgb[RedOffset]*76 + sTemp.uRgb[GreenOffset]*152 + sTemp.uRgb[BlueOffset]*29;

	sTemp.uRgb[0] = sTemp.uRgb[1];
	sTemp.uRgb[2] = sTemp.uRgb[1];

	return sTemp.uColor;
	}

inline COLORRGB BitmapImage::RgbToGray(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			}sTemp;

	sTemp.uRgb[RedOffset  ] = ucRed;
	sTemp.uRgb[GreenOffset] = ucGreen;
	sTemp.uRgb[BlueOffset ] = ucBlue;

	sTemp.uColor  = sTemp.uRgb[RedOffset]*76 + sTemp.uRgb[GreenOffset]*152 + sTemp.uRgb[BlueOffset]*29;

	sTemp.uRgb[0] = sTemp.uRgb[1];
	sTemp.uRgb[2] = sTemp.uRgb[1];
	sTemp.uRgb[3] = 0;

	return sTemp.uColor;
	}

inline void BitmapImage::GetRGB(unsigned uPosX,unsigned uPosY,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)const
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			unsigned char  *pPtr;
			}sTemp;

	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return;	// Koordinaten prfen

	sTemp.pPtr=ROW_PTR(uPosY);
	sTemp.uColor=GetPixel_(sTemp.pPtr,uPosX);
	if(!uIsRgb)sTemp.uColor=pColorMap[sTemp.uColor].uRgb;


	ucRed  =sTemp.uRgb[RedOffset  ];
	ucGreen=sTemp.uRgb[GreenOffset];
	ucBlue =sTemp.uRgb[BlueOffset ];
	}

inline void BitmapImage::GetRGB(unsigned uPosX,unsigned uPosY,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)const
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			unsigned char  *pPtr;
			}sTemp;

	if(uPosX>=uImageWidth || uPosY>=uImageHeight)return;	// Koordinaten prfen

	sTemp.pPtr=ROW_PTR(uPosY);
	sTemp.uColor=GetPixel_(sTemp.pPtr,uPosX);
	if(!uIsRgb)sTemp.uColor=pColorMap[sTemp.uColor].uRgb;


	ucRed  =sTemp.uRgb[RedOffset  ];
	ucGreen=sTemp.uRgb[GreenOffset];
	ucBlue =sTemp.uRgb[BlueOffset ];
	ucAlpha=sTemp.uRgb[AlphaOffset];
	}

inline COLORRGB BitmapImage::GetRGB(POINT *pPoint)const
	{
	if((unsigned)pPoint->x>= uImageWidth ||	// Koordinaten prfen
	   (unsigned)pPoint->y>= uImageHeight)return 0;

	register	unsigned char *pPtr;

	pPtr=ROW_PTR(pPoint->y);

	if(uIsRgb)return GetPixel_(pPtr,pPoint->x);
	return pColorMap[GetPixel_(pPtr,pPoint->x)].uRgb;
	}

inline void BitmapImage::GetRGB(POINT *pPoint,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue)const
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			unsigned char  *pPtr;
			}sTemp;

	if((unsigned)pPoint->x>= uImageWidth ||	// Koordinaten prfen
	   (unsigned)pPoint->y>= uImageHeight)return;

	sTemp.pPtr   = ROW_PTR(pPoint->y);
	sTemp.uColor = GetPixel_(sTemp.pPtr,pPoint->x);
	if(!uIsRgb)sTemp.uColor=pColorMap[sTemp.uColor].uRgb;

	ucRed   = sTemp.uRgb[RedOffset  ];
	ucGreen = sTemp.uRgb[GreenOffset];
	ucBlue  = sTemp.uRgb[BlueOffset ];
	}

inline void BitmapImage::GetRGB(POINT *pPoint,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha)const
	{
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			unsigned char  *pPtr;
			}sTemp;

	if((unsigned)pPoint->x>= uImageWidth ||	// Koordinaten prfen
	   (unsigned)pPoint->y>= uImageHeight)return;

	sTemp.pPtr   = ROW_PTR(pPoint->y);
	sTemp.uColor = GetPixel_(sTemp.pPtr,pPoint->x);
	if(!uIsRgb)sTemp.uColor=pColorMap[sTemp.uColor].uRgb;

	ucRed   = sTemp.uRgb[RedOffset  ];
	ucGreen = sTemp.uRgb[GreenOffset];
	ucBlue  = sTemp.uRgb[BlueOffset ];
	ucAlpha	= sTemp.uRgb[AlphaOffset];
	}

inline void BitmapImage::SetRGB(unsigned uPosX,unsigned uPosY,unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
	{
	unsigned	uColor;

	uColor	= BGR(ucRed,ucGreen,ucBlue);
	SetPixel(uPosX,uPosY,uColor);
	}

inline void BitmapImage::SetRGB(unsigned uPosX,unsigned uPosY,unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue,unsigned char ucAlpha)
	{
	unsigned	uColor;

	uColor	= BGRA(ucRed,ucGreen,ucBlue,ucAlpha);
	SetPixel(uPosX,uPosY,uColor);
	}

inline void BitmapImage::SetRGB(POINT *pPoint,unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
	{
	unsigned	uColor;

	uColor	= BGR(ucRed,ucGreen,ucBlue);
	SetPixel(pPoint->x,pPoint->y,uColor);
	}

inline void BitmapImage::SetRGB(POINT *pPoint,unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue,unsigned char ucAlpha)
	{
	unsigned	uColor;

	uColor	= BGRA(ucRed,ucGreen,ucBlue,ucAlpha);
	SetPixel(pPoint->x,pPoint->y,uColor);
	}

//*****************************************************************************
//*
//*		SwapRGB
//*
//*****************************************************************************
//  Tauscht eine RGB-Farbe in eine GBR-Farbe

#ifdef	   _MSC_VER
#pragma		warning( push )
#pragma		warning( disable :4035 )
#endif

inline unsigned BitmapImage::SwapRGB(unsigned uColor)
{
#if !defined(NO_ASM) && defined(_MSC_VER) && defined(_M_IX86) && (_MSC_VER<1300)

_asm	{
		mov		eax,uColor
		bswap	eax;				;// Tausche Bytes in EAX
		ror		eax,8
		}

#elif !defined(NO_ASM) && defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_X64) || defined(_M_AMD64))

	return _rotr(_byteswap_ulong(uColor),8);

#else

	return ((uColor&0x00FF0000)>>16)|(uColor&0xFF00FF00)|((uColor&0x000000FF)<<16)|(uColor&0xFF000000);

#endif
}

#ifdef	   _MSC_VER
#pragma		warning( pop )
#endif

//*****************************************************************************
//*
//*		ColorTo??
//*
//*****************************************************************************
//	Teile von Farben berechnen
inline COLORRGB BitmapImage::ColorTo12(COLORRGB uColor){return        ((uColor>>1)&0x7F7F7F7F);}
inline COLORRGB BitmapImage::ColorTo14(COLORRGB uColor){return        ((uColor>>2)&0x3F3F3F3F);}
inline COLORRGB BitmapImage::ColorTo34(COLORRGB uColor){return uColor-((uColor>>2)&0x3F3F3F3F);}
inline COLORRGB BitmapImage::ColorTo8 (COLORRGB uColor,unsigned uMul){return ((uColor>>3)&0x1F1F1F1F)*uMul;}

//*****************************************************************************
//*
//*		GetColor
//*
//*****************************************************************************
inline COLORRGB BitmapImage::GetColor(unsigned uIndex) const
{
return pColorMap[uIndex&0xFF].uRgb;
}


//*****************************************************************************
//*
//*		GetRow?
//*
//*****************************************************************************
//	Ergibt eine RGB Reihe im 3 oder 4 Byte Format
//	GetRow?Temp erzeugt temporre Reihen die verndert werden knnen.
inline unsigned char *BitmapImage::GetRow_(unsigned uPosY)const
	{
	return ROW_PTR(uPosY);
	}

inline unsigned char *BitmapImage::GetRow(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return ROW_PTR(uPosY);
	}

inline unsigned char *BitmapImage::GetRow1(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return Get1Row_(ROW_PTR(uPosY),(BitmapImage*)this);
	}

inline unsigned char *BitmapImage::GetRow3(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return Get3Row_(ROW_PTR(uPosY),(BitmapImage*)this);
	}

inline unsigned char *BitmapImage::GetRow4(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return Get4Row_(ROW_PTR(uPosY),(BitmapImage*)this);
	}

inline unsigned char *BitmapImage::GetRow1Temp(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return Get1RowT_(ROW_PTR(uPosY),(BitmapImage*)this);
	}

inline unsigned char *BitmapImage::GetRow3Temp(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return Get3RowT_(ROW_PTR(uPosY),(BitmapImage*)this);
	}

inline unsigned char *BitmapImage::GetRow4Temp(unsigned uPosY)const
	{
	if(uPosY >= uImageHeight)return pImageRow;		// Koordinaten prfen
	return Get4RowT_(ROW_PTR(uPosY),(BitmapImage*)this);
	}


//*****************************************************************************
//*
//*		StretchDIB
//*
//*****************************************************************************
//	Bild auf einen DC ausgeben
inline int BitmapImage::StretchDIB( HDC hDc,RECT  *pRect)                       {return StretchDIB(hDc,pRect->left,pRect->top ,pRect->right   ,pRect->bottom  );}
inline int BitmapImage::StretchDIB( HDC hDc,POINT *pTopLeft,POINT *pBottomRight){return StretchDIB(hDc,pTopLeft->x,pTopLeft->y,pBottomRight->x,pBottomRight->y);}
inline int BitmapImage::StretchDIB( HDC hDc,int iPosX,int iPosY,int iSizeX,int iSizeY)
	{
	if(!IsOk())return 0;

	#ifdef	_WIN32

	return StretchDIBits(	hDc,iPosX,iPosY,iSizeX,iSizeY,0,0,
							uImageWidth,
							uImageHeight,
							pImageData,
							pBitmapInfo,
							DIB_RGB_COLORS,
							SRCCOPY);
	#else

	return GDI_ERROR;

	#endif
	}


//*****************************************************************************
//*
//*		SetDIB
//*
//*****************************************************************************
// Bild zeichnen
inline int	BitmapImage::SetDIB(HDC hDc,POINT *pTopLeft){return SetDIB(hDc,pTopLeft->x,pTopLeft->y);}
inline int	BitmapImage::SetDIB(HDC hDc,int iPosX,int iPosY)
	{
	if(!IsOk())return 0;

	#ifdef	_WIN32

	return	SetDIBitsToDevice(	hDc,iPosX,iPosY,
								uImageWidth,
								uImageHeight,0,0,0,
								pBitmapInfo->bmiHeader.biHeight,
								pImageData,
								pBitmapInfo,
								DIB_RGB_COLORS);
	#else

	return 0;

	#endif
	}

//*****************************************************************************
//*
//*		Roll
//*
//*****************************************************************************
//	Ein Bild um die Mitte rotieren
inline bool	BitmapImage::Roll(const BitmapImage &sSource,int iAngel,int iMode,unsigned uColor)
	{
	int		iCenterX;
	int		iCenterY;

	iCenterX = sSource.Width ()*2;
	iCenterY = sSource.Height()*2;

	return Roll(sSource,iAngel,iMode|2,iCenterX,iCenterY,uColor);
	}

//*****************************************************************************
//*
//*		ConvertToColors
//*
//*****************************************************************************
inline bool	BitmapImage::ConvertToColors(unsigned uMax,COLORREF *pColors)
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return ConvertToColors(sImage,uMax,pColors);
}

//*****************************************************************************
//*
//*		ConvertToRGB
//*
//*****************************************************************************
inline bool BitmapImage::ConvertToRGB(unsigned uBits)
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return ConvertToRGB(sImage,uBits);
}

//*****************************************************************************
//*
//*		ConvertTo8Bit
//*
//*****************************************************************************
inline bool BitmapImage::ConvertTo8Bit()
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return ConvertTo8Bit(sImage);
}

//*****************************************************************************
//*
//*		ConvertToSingle
//*
//*****************************************************************************
inline bool BitmapImage::ConvertToSingle()
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return ConvertToSingle(sImage);
}

//*****************************************************************************
//*
//*		ConvertToGray8
//*
//*****************************************************************************
inline bool BitmapImage::ConvertToGray8()
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return ConvertToGray8(sImage);
}

//*****************************************************************************
//*
//*		ConvertToAlpha
//*
//*****************************************************************************
inline bool BitmapImage::ConvertToAlpha(int iMode,COLORRGB uColor)
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return ConvertToAlpha(sImage,iMode,uColor);
}

//*****************************************************************************
//*
//*		Stretch
//*
//*****************************************************************************
inline bool BitmapImage::Stretch(RECT *pRect,int iMode)
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return Stretch(sImage,pRect,iMode);
}

inline bool BitmapImage::Stretch(unsigned iSizeX,unsigned iSizeY,int iMode)
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return Stretch(sImage,iSizeX,iSizeY,iMode);
}

//*****************************************************************************
//*
//*		Rotate
//*
//*****************************************************************************
inline bool BitmapImage::Rotate(int iMode,int iSwapX,int iSwapY)
{

	if(!IsOk())return false;

	BitmapImage	sImage;

	sImage.Swap(*this);

return Rotate(sImage,iMode,iSwapX,iSwapY);
}


#endif


