//*****************************************************************************
//*
//*
//*		Bmp.h
//*
//*
//*****************************************************************************

#ifndef __BMP_H__
#define __BMP_H__

#include "GrException.h"

#ifdef	ERROR_DEUTSCH
	#define	EB_ERR_OF	"Fehler beim ffnen der BMP-Datei !"
	#define	EB_ERR_RF	"Fehler beim Lesen der BMP-Datei !"
	#define	EB_ERR_WF	"Fehler beim Schreiben BMP-Datei !"
	#define	EB_ERR_WS	"Die Datei ist keine BMP-Datei !"
	#define	EB_ERR_CS	"Beschdigte BMP-Datei !"
	#define	EB_ERR_US	"Das Format der BMP-Datei wird nicht untersttzt !"
	#define	EB_ERR_UE	"Fehler beim Unknown Error"
	#define	EB_ERR_DE	"Falsche Bild-Daten !"
#else
	#define	EB_ERR_OF	"Error opening BMP file"
	#define	EB_ERR_RF	"Error reading BMP file"
	#define	EB_ERR_WF	"Error writing BMP file"
	#define	EB_ERR_WS	"Not a Windows Bitmap stream"
	#define	EB_ERR_CS	"Corrupt Windows Bitmap stream"
	#define	EB_ERR_US	"Unsupported Bitmap Format"
	#define	EB_ERR_UE	"Unknown Error"
	#define	EB_ERR_DE	"Bad input data"
#endif

class EBmpFileOpenError : public EGraphicsException
{
public:
  EBmpFileOpenError () : EGraphicsException (EB_ERR_OF) {}
  EBmpFileOpenError (const EBmpFileOpenError &be) : EGraphicsException (be) {}
  EBmpFileOpenError &operator=(const EBmpFileOpenError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EBmpFileReadError : public EGraphicsException
{
public:
  EBmpFileReadError () : EGraphicsException (EB_ERR_RF) {}
  EBmpFileReadError (const EBmpFileReadError &be) : EGraphicsException (be) {}
  EBmpFileReadError &operator=(const EBmpFileReadError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
};

class EBmpFileWriteError : public EGraphicsException
{
public:
  EBmpFileWriteError () : EGraphicsException (EB_ERR_WF) {}
  EBmpFileWriteError (const EBmpFileWriteError &be) : EGraphicsException (be) {}
  EBmpFileWriteError &operator=(const EBmpFileWriteError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EBmpNotABmpFile : public EGraphicsException
{
public:
  EBmpNotABmpFile () : EGraphicsException (EB_ERR_WS) {}
  EBmpNotABmpFile (const EBmpNotABmpFile &be) : EGraphicsException (be) {}
  EBmpNotABmpFile &operator=(const EBmpNotABmpFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EBmpCorruptFile : public EGraphicsException
{
public:
  EBmpCorruptFile () : EGraphicsException (EB_ERR_CS) {}
  EBmpCorruptFile (const EBmpCorruptFile &be) : EGraphicsException (be) {}
  EBmpCorruptFile &operator=(const EBmpCorruptFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EBmpNotSupported : public EGraphicsException
{
public:
  EBmpNotSupported () : EGraphicsException (EB_ERR_US) {}
  EBmpNotSupported (const EBmpNotSupported &be) : EGraphicsException (be) {}
  EBmpNotSupported &operator=(const EBmpNotSupported &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EBmpUnknownError : public EGraphicsException
{
public:
  EBmpUnknownError () : EGraphicsException (EB_ERR_UE) {}
  EBmpUnknownError (const EBmpUnknownError &be) : EGraphicsException (be) {}
  EBmpUnknownError &operator=(const EBmpUnknownError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EBmpDataError : public EGraphicsException
{
public:
  EBmpDataError () : EGraphicsException (EB_ERR_DE) {}
  EBmpDataError (const EBmpDataError &be) : EGraphicsException (be) {}
  EBmpDataError &operator=(const EBmpDataError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

#endif
