 //*****************************************************************************
//*
//*
//*		BmpDecoder.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2008
//
#ifndef __BMPDECODER_H__
#define __BMPDECODER_H__

#if _MSC_VER >= 1000
#pragma once				 
#endif


#include	"Bmp.h"
#include	"BitmapImage.h"
#include	"GrException.h"
#include	"..\FileBuffer.h"
  

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class BmpDecoder : public BitmapImageDecoder
{
public:

					BmpDecoder();
	virtual        ~BmpDecoder();

	virtual void	ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void	ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void	ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);
	void			GetPixelPerMeter(int &iMeterX,int &iMeterY);

protected:

	void			CallProgressFunction(unsigned uPercent) ;

	int				Read24  (unsigned uWidth,unsigned uHeight,BitmapImage &sImage);
	int				Read32  (unsigned uWidth,unsigned uHeight,BitmapImage &sImage);
	int				ReadBIT8(unsigned uWidth,unsigned uHeight,BitmapImage &sImage);
	int				ReadRLE4(unsigned uWidth,unsigned uHeight,BitmapImage &sImage);
	int				ReadRLE8(unsigned uWidth,unsigned uHeight,BitmapImage &sImage);
	
	CFileBuffer	   *m_pBuffer;
	unsigned		m_uBitCount;
	int				m_iMeterX;					// Pixel per Meter
	int				m_iMeterY;					//		*


};


#endif
