//*****************************************************************************
//*
//*
//*		BmpEncoder.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#ifndef		__BMBENCODER_H__
#define		__BMPENCODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"BitmapImage.h"
#include	"Bmp.h"


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class BmpEncoder : public BitmapImageEncoder
{
public:
					BmpEncoder();
	virtual        ~BmpEncoder();
	virtual void	WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual void	WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual void	WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);
	virtual void	WriteImage(const wchar_t *pName,const BitmapImage &sImage,int iMode);
	virtual void	WriteImage(const char    *pName,const BitmapImage &sImage,int iMode);
	virtual void	WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage,int iMode);
	void			SetPixelPerMeter(int iMeterX,int iMeterY);
	int 			SetFormat(int iFormat);
	int 			SetMode(int iMode,int iMask=0xFF);

private:
	
	void			Initialize();
	void			CallProgressFunction(unsigned uPercent);

protected:

	int				m_iMeterX;					// Pixel per Meter
	int				m_iMeterY;					//		*
	int				m_iFormat;					// Save Format 24 or 32
	int				m_iModeBits;				// Bit0=Color compress

};



#endif
