//*****************************************************************************
//*
//*
//*		Eps.h
//*
//*
//*****************************************************************************
//
//	Copyright (c) 2011 AZ Software
//	All rights reserved.
//	Author:  Anton Zechner
//
#ifndef __EPS_H__
#define __EPS_H__

#include "GrException.h"


#ifdef	ERROR_DEUTSCH
	#define	ES_ERR_OF	"Fehler beim ffnen der EPS-Datei !"
	#define	ES_ERR_RF	"Fehler beim Lesen der EPS-Datei !"
	#define	ES_ERR_WF	"Fehler beim Schreiben EPS-Datei !"
	#define	ES_ERR_WS	"Die Datei ist keine EPS-Datei !"
	#define	ES_ERR_CS	"Beschdigte EPS-Datei !"
	#define	ES_ERR_US	"Das Format der EPS-Datei wird nicht untersttzt !"
	#define	ES_ERR_UE	"Fehler beim Unknown Error"
	#define	ES_ERR_DE	"Falsche Bild-Daten !"
#else
	#define	ES_ERR_OF	"Error opening EPS file"
	#define	ES_ERR_RF	"Error reading EPS file"
	#define	ES_ERR_WF	"Error writing EPS file"
	#define	ES_ERR_WS	"Not a Windows Bitmap stream"
	#define	ES_ERR_CS	"Corrupt Windows Bitmap stream"
	#define	ES_ERR_US	"Unsupported Bitmap Format"
	#define	ES_ERR_UE	"Unknown Error"
	#define	ES_ERR_DE	"Bad input data"
#endif

class EEpsFileOpenError : public EGraphicsException
{
public:
  EEpsFileOpenError () : EGraphicsException (ES_ERR_OF) {}
  EEpsFileOpenError (const EEpsFileOpenError &be) : EGraphicsException (be) {}
  EEpsFileOpenError &operator=(const EEpsFileOpenError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EEpsFileReadError : public EGraphicsException
{
public:
  EEpsFileReadError () : EGraphicsException (ES_ERR_RF) {}
  EEpsFileReadError (const EEpsFileReadError &be) : EGraphicsException (be) {}
  EEpsFileReadError &operator=(const EEpsFileReadError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
};

class EEpsFileWriteError : public EGraphicsException
{
public:
  EEpsFileWriteError () : EGraphicsException (ES_ERR_WF) {}
  EEpsFileWriteError (const EEpsFileWriteError &be) : EGraphicsException (be) {}
  EEpsFileWriteError &operator=(const EEpsFileWriteError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EEpsNotAEpsFile : public EGraphicsException
{
public:
  EEpsNotAEpsFile () : EGraphicsException (ES_ERR_WS) {}
  EEpsNotAEpsFile (const EEpsNotAEpsFile &be) : EGraphicsException (be) {}
  EEpsNotAEpsFile &operator=(const EEpsNotAEpsFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EEpsCorruptFile : public EGraphicsException
{
public:
  EEpsCorruptFile () : EGraphicsException (ES_ERR_CS) {}
  EEpsCorruptFile (const EEpsCorruptFile &be) : EGraphicsException (be) {}
  EEpsCorruptFile &operator=(const EEpsCorruptFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EEpsNotSupported : public EGraphicsException
{
public:
  EEpsNotSupported () : EGraphicsException (ES_ERR_US) {}
  EEpsNotSupported (const EEpsNotSupported &be) : EGraphicsException (be) {}
  EEpsNotSupported &operator=(const EEpsNotSupported &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EEpsUnknownError : public EGraphicsException
{
public:
  EEpsUnknownError () : EGraphicsException (ES_ERR_UE) {}
  EEpsUnknownError (const EEpsUnknownError &be) : EGraphicsException (be) {}
  EEpsUnknownError &operator=(const EEpsUnknownError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EEpsDataError : public EGraphicsException
{
public:
  EEpsDataError () : EGraphicsException (ES_ERR_DE) {}
  EEpsDataError (const EEpsDataError &be) : EGraphicsException (be) {}
  EEpsDataError &operator=(const EEpsDataError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;



#endif
