//*****************************************************************************
//*
//*		EpsDecoder.h
//*
//*
//*****************************************************************************
//
//	Copyright (c) 2011 AZ Software
//	All rights reserved.
//	Author:  Anton Zechner
//

#ifndef __EPSDECODER_H__
#define __EPSDECODER_H__

#include	"BitmapImage.h"
#include	"..\TextBuffer.h"
#include	"Eps.h"


//*****************************************************************************
//*
//*		Klasse EpsDecoder
//*
//*****************************************************************************
class EpsDecoder : public BitmapImageDecoder
{
public:

					EpsDecoder() ;
	virtual        ~EpsDecoder() ;
	virtual void	ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void	ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void	ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);
	void			GetPixelPerMeter(int &iMeterX,int &iMeterY);

private:

	void			Read();
	void			CallProgressFunction(unsigned uPercent);
	int				CheckImageMode(const char *pMem,int *pValues);
	int				CheckImageSize(const char *pMem,int *pValues);

	CFileBuffer    *m_pInput;
	BitmapImage	   *m_pImage;

	int				m_iFileEnd;				// Daten Ende in Datei
	int				m_iMeterX;				// Pixel per Meter
	int				m_iMeterY;				//		*
	int				m_iSizeX;				// Bild Auflsung	
	int				m_iSizeY;				//		*
	int				m_iPlane;				// Farbauflsungen
	int				m_iBits;				//		*		
	int				m_iInter;				// Farben im Einzelmodus
	int				m_iInvers;				// Y-Zeilen Invertieren

};

#endif
