//*****************************************************************************
//*
//*
//*		EpsEncoder.h
//*
//*
//*****************************************************************************
//
//	Copyright (c) 2011 AZ Software
//	All rights reserved.
//	Author:  Anton Zechner
//

#ifndef		__EPSENCODER_H__
#define		__EPSENCODER_H__

#include 	"Eps.h"
#include 	"BitmapImage.h"
#include 	"..\FileBuffer.h"


//*****************************************************************************
//*
//*		Klasse EpsEncoder
//*
//*****************************************************************************
class EpsEncoder : public BitmapImageEncoder
{
public:

					EpsEncoder();
	virtual        ~EpsEncoder();
	virtual void	WriteImage (const wchar_t *pName,const BitmapImage &sImage);
	virtual void	WriteImage (const char    *pName,const BitmapImage &sImage);
	virtual void 	WriteImage (CFileBuffer   *pFile,const BitmapImage &sImage);
	void		 	SetPixelPerMeter(int iMeterX,int iMeterY);

private:

	void			CallProgressFunction (unsigned int uPercent);
					
	int				m_iBaseSeek;					// Anfangs Offset in der Datei
	int				m_iSizeX;						// Bildauflsung
	int				m_iSizeY;						//		*
	int				m_iMeterX;						// Auflsung in Pixel je Meter
	int				m_iMeterY;						//		*
	int				m_iPlane;						// Sample je Pixel
	int				m_iBits;						// Bits je Pixel

};

#endif
