//*****************************************************************************
//*
//*
//*		GifDecoder.h
//*
//*
//*****************************************************************************
#ifndef __GIFDECODER_H__
#define __GIFDECODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


typedef	unsigned char UBYTE1;

#include	"BitmapImage.h"
#include	"GifException.h"
#include	"..\FileBuffer.h"

struct		GifColorTableEntry;


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class GifDecoder : public BitmapImageDecoder
{
public:

						GifDecoder();
	virtual     	   ~GifDecoder();
	virtual void		ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void		ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void		ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);
	void        		ReadNextImage(BitmapImage &sImage);
	void			  	Reset();
	int					MoreImages();
	int					TransparentColor();

private:

	void				Initialize();
	void				ReadToNextImage();
	void				ReadStreamHeader();
	void				ReadCompressedData();
	void				InitializeLocalData();
	void				OutputRow(int &iRow,unsigned char *pRowBuf);
	void				CallProgressFunction(unsigned uPercent);

	unsigned int        m_uColorCount;
	GifColorTableEntry *m_pColorTable;
	BitmapImage	       *m_pCurrentImg;
	CFileBuffer		   *m_pFile;

	bool				m_bMultipleImages;
	bool		   		m_bProgressive;
	bool		   		m_bInterlaced;
	bool				m_bMoreImages;
	unsigned	 		m_uImageWidth;
	unsigned	 		m_uImageHeight;
	unsigned	 		m_uCurrentRow;
	unsigned	 		m_uCurrentColumn;
	unsigned	 		m_uInterlaceGroup;
	unsigned	 		m_uScreenHeight;
	unsigned	 		m_uScreenWidth;
	unsigned	 		m_uImageLeft;
	unsigned	 		m_uImageTop;
	int					m_iTransparentColor;


};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline int	GifDecoder::TransparentColor(){return m_iTransparentColor;}
inline int	GifDecoder::MoreImages      (){return m_bMoreImages;}

#endif






