//*****************************************************************************
//*
//*
//*		GifEncoder.h
//*
//*
//*****************************************************************************
#ifndef __GIFENCOD_H__
#define __GIFENCOD_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"BitmapImage.h"
#include	"GifException.h"
#include	"..\FileBuffer.h"

#define		GIF_HSIZE	5003							// 80% occupancy

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class GifEncoder : public BitmapImageEncoder
{
public:

			  GifEncoder();
	virtual  ~GifEncoder();

			void WriteImage(const wchar_t *pName,const BitmapImage **pImages,int iImageCount);
			void WriteImage(const char    *pName,const BitmapImage **pImages,int iImageCount);
			void WriteImage(CFileBuffer   *pFile,const BitmapImage **pImages,int iImageCount);
	virtual void WriteImage(const wchar_t *pName,const BitmapImage  &sImage);
	virtual void WriteImage(const char    *pName,const BitmapImage  &sImage);
	virtual void WriteImage(CFileBuffer   *pFile,const BitmapImage  &sImage);

	inline	void SetTransparentColor(int iColor);
	inline	void SetBackgroundColor (int iColor);
	inline	void SetPictureDelay    (int iDelay);

private:

	void	Initialize();
	int 	CallProgressFunction(unsigned int);
	void	Compress(int iInitCode,unsigned uWidth,unsigned uHeight);

	CFileBuffer		   *m_pBuffer;
	const BitmapImage **m_pImgList;
	const BitmapImage  *m_pImage;
	unsigned			m_uBgColor;						// Nummer der Hintergrundfarbe
	unsigned			m_uImageCount;					// Ist die Anzalh der zuspeichernten Bilder
	unsigned			m_uTranparence;					// Ist die Transparente Farbe (0x100 = keine)
	unsigned			m_uDelay;						// Weiterschaltezeit fr Bilder (1/100 sek)
	unsigned			m_uPercent;						// Letzte Prozentausgabe
	unsigned			m_uTickVal;						// Prozentschrittsumme
	unsigned			m_uTick;						// Prozentschritt


//******************** Compress-Daten *****************************************

	inline	void CharOut   (int iChar);
			void OutputCode(int iCode);
			void ResetHash (int iSize);
			void ResetBlock();

	int						iBitCount; 					// number of bits/code
	int						iMaxBits; 					// user settable max # bits/code
	int						iInitBits;
	int						iClearCode;
	int						iFreeCode;
	int						iLastCode;					// should NEVER generate this code
	int						iMaxCode;					// maximum code, given iBitCount
	int						iEofCode;
	int						iCurBits;
	unsigned				uCurAccu;

	int						iClearFlag;
	int						iBufSize;
	char					aBuffer[256];

	int						aHashTab[GIF_HSIZE];
	unsigned short			aCodeTab[GIF_HSIZE];



};


//*****************************************************************************
//*
//*		Inline-Funktionen
//*
//*****************************************************************************
inline	void GifEncoder::SetTransparentColor(int iColor)
{
	m_uTranparence = iColor;
}

inline	void GifEncoder::SetBackgroundColor(int iColor)
{
	m_uBgColor	   = iColor;
}

inline	void GifEncoder::SetPictureDelay(int iDelay)
{
	m_uDelay = iDelay;
}


#endif
