#ifndef __GREXCEPT_H
#define __GREXCEPT_H
//
// Copyright (c) 1997,1998 Colosseum Builders, Inc.
// All rights reserved.
//
// Colosseum Builders, Inc. makes no warranty, expressed or implied
// with regards to this software. It is provided as is.
//
// o The user assumes all risk for using this software. The authors of this
//   software shall be liable for no damages of any kind.
//
// o If the source code is distributed then this copyright notice must
//   remain unaltered and any modification must be noted.
//
// o If this code is shipped in binary format the accompanying documentation
//   should state that "this software is based, in part, on the work of
//   Colosseum Builders, Inc."
//
// o This GIF decoder may be distributed and used without license fee
//   to the authors. It is our understanding that GIF decoding is not
//   covered by patents (which is why there are non-LZW GIF encoders).
//   However, we are not lawyers. If you wish to encorporate this software
//   then you should get your own legal advice.
//

//
//  Title:  Graphics Exception Classes
//
//  Author:  John M. Miano  miano@colosseumbuilders.com
//

#include <string.h>


#define 	ERROR_DEUTSCH

#ifdef	_MSC_VER
	#pragma once
	#pragma warning( disable :4996 )
#endif


#define 	EG_CODE_ABORT				1
#define 	EG_CODE_OUTOFRANGE			2
#define 	EG_CODE_INVALIDBITCOUNT		3
#define 	EG_CODE_TOOBIG				4
#define 	EG_CODE_WRONGCOLOR			5
#define 	EG_CODE_MEMORY				6


#ifdef	ERROR_DEUTSCH
	#define 	STR_ABORT		"Benutzer Abbruch"
	#define 	STR_SUBSTROR	"Subscript auerhalb vom Bereich"
	#define 	STR_INALBITC	"Fehlerhafter Bit-Zhler"
	#define 	STR_TOOBIG		"Das Bild ist zu gro"
	#define 	STR_WRONGCOLOR	"Falsches Farbformat"
	#define 	STR_MEMORY		"Zu wenig Speicher"
#else
	#define 	STR_ABORT		"Abort"
	#define 	STR_SUBSTROR	"Subscript out of range"
	#define 	STR_INALBITC	"Invalid bit count"
	#define 	STR_TOOBIG		"The picture is too big"
	#define 	STR_WRONGCOLOR	"Wrong color format"
	#define 	STR_MEMORY		"Out off memory"
#endif


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif


/*
#include <stdexcept>

class EGraphicsException : public std::logic_error
	{
	public:	EGraphicsException (std::string msg) : std::logic_error (msg.c_str ()) {}
	};

// Dieser Code frt bei MS VC++ .Net zu einem Fehler !!!

*/

class EGraphicsException
	{
	protected: zchar m_cText[256];
			   int   m_iCode;

	public:

	EGraphicsException (const char *pMsg,int iCode=0)
		{
		#ifdef		UNICODE

		int i;

		for(i=0;i<255 && pMsg[i];i++)
			{
			m_cText[i]=pMsg[i];
			}

		m_cText[i] = 0;

		#else

		strncpy(m_cText,pMsg,sizeof(m_cText));

		#endif

		m_iCode = iCode;
		};

	const zchar *what(){return m_cText;}
	int          code(){return m_iCode;}
	};
class EGraphicsAbort : public EGraphicsException
	{
	public:	EGraphicsAbort () : EGraphicsException(STR_ABORT,EG_CODE_ABORT) {}
	};
class ESubscriptOutOfRange : public EGraphicsException
	{
	public:	ESubscriptOutOfRange () : EGraphicsException(STR_SUBSTROR,EG_CODE_OUTOFRANGE) {}
	};
class EInvalidBitCount : public EGraphicsException
	{
	public:	EInvalidBitCount () : EGraphicsException(STR_INALBITC,EG_CODE_INVALIDBITCOUNT) {}
	};
class EGraphicsPicSize : public EGraphicsException
	{
	public:	EGraphicsPicSize () : EGraphicsException(STR_TOOBIG,EG_CODE_TOOBIG) {}
	};
class EGraphicsWrongColor : public EGraphicsException
	{
	public:	EGraphicsWrongColor () : EGraphicsException(STR_WRONGCOLOR,EG_CODE_WRONGCOLOR) {}
	};
class EGraphicsMemory : public EGraphicsException
	{
	public:	EGraphicsMemory () : EGraphicsException(STR_MEMORY,EG_CODE_MEMORY) {}
	};



#ifdef		Z
#undef 		Z
#endif



#endif
