//*****************************************************************************
//*
//*		Icon.h
//*
//*****************************************************************************
//
// Copyright (c) 2002 AZ Software
// All rights reserved.
// Author:  Anton Zechner
//
#ifndef __ICON_H__
#define __ICON_H__

#include "GrException.h"


#pragma pack(push,2)

typedef struct
	{
    unsigned char	bWidth;          // Width, in pixels, of the image
    unsigned char	bHeight;         // Height, in pixels, of the image
    unsigned char	bColorCount;     // Number of colors in image (0 if >=8bpp)
    unsigned char	bReserved;       // Reserved ( must be 0)
    unsigned short	wPlanes;         // Color Planes
    unsigned short	wBitCount;       // Bits per pixel
    unsigned int 	dwBytesInRes;    // How many bytes in this resource?
    unsigned int  	dwImageOffset;   // Where in the file is this image?
	}ICONDIRENTRY, *LPICONDIRENTRY;

typedef struct
	{
    unsigned char	bWidth;          // Width, in pixels, of the image
    unsigned char	bHeight;         // Height, in pixels, of the image
    unsigned char	bColorCount;     // Number of colors in image (0 ==> 1bpp)
    unsigned char	bReserved;       // Reserved ( must be 0)
    unsigned short 	wHotSpotX;       // Hotspot's X-Position
    unsigned short	wHotSpotY;       // Hotspot's Y-Position
    unsigned int	dwBytesInRes;    // How many bytes in this resource?
    unsigned int  	dwImageOffset;   // Where in the file is this image?
	}CURSORDIRENTRY, *LPCURSORDIRENTRY;

typedef struct
	{
    unsigned char	bWidth;          // Width, in pixels, of the image
    unsigned char	bHeight;         // Height, in pixels, of the image
    unsigned char	bColorCount;     // Number of colors in image (0 if >=8bpp)
    unsigned char	bReserved;       // Reserved ( must be 0)
    unsigned short	wPlanes;         // Color Planes
    unsigned short	wBitCount;       // Bits per pixel
    unsigned int	dwBytesInRes;    // How many bytes in this resource?
    unsigned short  nID;			 // Name Ordinal Points to component
	}GICONDIRENTRY, *LPGICONDIRENTRY;

typedef struct
	{
    unsigned short 	wWidth;          // Width, in pixels, of the image
    unsigned short	wHeight;         // Height, in pixels, of the image
    unsigned short	wPlanes;         // Color Planes
    unsigned short	wBitCount;       // Bits per pixel
    unsigned int	dwBytesInRes;    // How many bytes in this resource?
    unsigned short  nID;			 // Name Ordinal Points to component
	}GCURSORDIRENTRY, *LPGCURSORDIRENTRY;

typedef struct
	{
    unsigned short	idReserved;		 // Reserved (must be 0)
    unsigned short	idType;       	 // Resource Type (1 for icons)
    unsigned short	idCount;      	 // How many images?
	union{
    ICONDIRENTRY	idEntries[1]; 	 // An entry for each image (idCount of 'em)
	CURSORDIRENTRY	idCursors[1]; 	 // An entry for each cursor (idCount of 'em)
	     };
	}ITEMDIR, *LPITEMDIR;

typedef struct
	{
    unsigned short	idReserved;		 // Reserved (must be 0)
    unsigned short	idType;       	 // Resource Type (1 for icons 2 for cursors)
    unsigned short	idCount;      	 // How many images?
	union{
    GICONDIRENTRY	idEntries[1]; 	 // An entry for each image (idCount of 'em)
	GCURSORDIRENTRY	idCursors[1]; 	 // An entry for each cursor (idCount of 'em)
	     };
	}GITEMDIR, *LPGITEMDIR;

#pragma pack( pop )

class EIconError : public EGraphicsException
{
public:
		 EIconError (const char *msg) : EGraphicsException (msg) {} ;
};

#endif
