//*****************************************************************************
//*
//*
//*		Zum Erstellen von Bildertafeln
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//

#include	"../StringChain.h"
#include	"ImageLoader.h"



#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif


int (_cdecl *pImageTableProgres)(void *pParam,int iPos,const zchar *pText)=0;
void        *pImageTableParam=0;

//*****************************************************************************
//*
//*		CreateImageTable
//*
//*****************************************************************************
//	Erzeugt eine Bildertabelle
//	pImage		: Bildspeiche fr Bildertabelle
//	pChain		: Dateinamen fr Bilder
//	iCountX		: Bilderanzahl in X-Richtung
//	iSizeX		: Bilderbreite mit Rahmen
//	iSizeY		: Bilderhhe   mit Rahmen
//	iFrame		: Rahmen breit in Einzelbild
//	uHgColor	: Hintergrundfarbe
//	uFrameColor	: Rahmenfarbe
//	Ergibt die Anzahl an eingefgten Bildern
int CreateImageTable(BitmapImage   *pImage,
					 CStringChain  *pChain,
					 int			iCountX,
					 int			iSizeX,
					 int			iSizeY,
					 int			iFrame,
					 COLORREF		uHgColor,
					 COLORREF		uFrameColor)
{
zchar		*pName;
BitmapImage  sImg;
BitmapImage  sNew;
int			 iMaxX;
int			 iMaxY;
int			 iPosX;
int			 iPosY;
int			 iImgX;
int			 iImgY;
int			 iMode;
int			 iNum;
int			 iOk;
int			 x,y;


	pName	= Z("");
	iMode	= -1;
	iMaxX	= iCountX*iSizeX;
	iMaxY	= ((pChain->Count()+iCountX-1)/iCountX)*iSizeY;
	iImgX	= iSizeX-iFrame-iFrame;
	iImgY	= iSizeY-iFrame-iFrame;

	pImage->SetSize(24,iMaxX,iMaxY);
	pImage->Rectangle(0,0,iMaxX,iMaxY,uHgColor);


	for(iNum=0;iNum<pChain->Count();iNum++)
		{
		pName = pChain->Get(iNum);

		if(pImageTableProgres)						// Progress Funktion aufrufen
			{
				iOk=pImageTableProgres(pImageTableParam,iNum,pName);
			if(!iOk)break;
			}

		iOk		= 1;
		iPosX	= (iNum%iCountX)*iSizeX+iFrame;
		iPosY	= (iNum/iCountX)*iSizeY+iFrame;


		if(ImageLoader(pName,&sImg))iOk=0;

		if(!sImg.IsOk())iOk=0;						// Ist Bild gro genug

		if(!iOk)									// Bild durchstreichen
			{
			pImage->Frame(iPosX-1,iPosY-1,iImgX+2,iImgY+2,uFrameColor);
			pImage->Line (iPosX			 ,iPosY,
						  iPosX+iImgX-1	 ,iPosY+iImgY-1  ,uFrameColor);
			pImage->Line (iPosX+iImgX-1	 ,iPosY,
						  iPosX			 ,iPosY+iImgY-1  ,uFrameColor);
			continue;
			}

		   x =(sImg.Width()*iImgY)/sImg.Height();	// Gre berechnen
		if(x<=iImgX)
			{
			y = iImgY;
			}
		else{
			x = iImgX;
			y = (sImg.Height()*iImgX)/sImg.Width();
			}

		sNew.Stretch(sImg,x,y,1);					// Bild erzeugen
		pImage->Box(iPosX-1,iPosY-1,iImgX+2,iImgY+2,uFrameColor);
		pImage->Put(sNew,iPosX+(iImgX-x)/2 ,iPosY+(iImgY-y)/2);
		}


	if(pImageTableProgres)							// Progress Funktion aufrufen
		{
		pImageTableProgres(pImageTableParam,iNum,pName);
		}


return iNum;
}
