//*****************************************************************************
//*
//*
//*		JpegDecoder.h
//*
//*
//*****************************************************************************
//	
//	Klasse zum Lesen von *.jpeg Bildern
//
#ifndef __JPEGDECODER_H__
#define __JPEGDECODER_H__


#include "BitmapImage.h"
#include "GrException.h"
#include "JpegException.h"

struct jpeg_common_struct;
struct jpeg_decompress_struct;

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class JpegDecoder : public BitmapImageDecoder
{
public:

			 JpegDecoder();
	virtual ~JpegDecoder();

	virtual void	ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void	ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void	ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);
	virtual void	UpdateImage();

protected:

	static void  _cdecl JpegError(jpeg_common_struct *pInfo);
	void			ThrowImageError(int iError);


private:


	void			Initialize();
	void			DoCopy(const JpegDecoder &);

	char			cErrorString[256];

};





#endif

