//*****************************************************************************
//*
//*
//*		JpegEncoder.h
//*
//*
//*****************************************************************************
//
//	Klasse zum Schreiben von *.jpeg Dateien
//
//	(C) Copyright Anton Zechner 2007
//
#ifndef __JPEGENCODER_H__
#define __JPEGENCODER_H__

#include "BitmapImage.h"
#include "JpegException.h"



//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class JpegEncoder : public BitmapImageEncoder
{
public:

					JpegEncoder () ;
	virtual        ~JpegEncoder () ;

	virtual void	WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual void	WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual void	WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);


	unsigned int	GetQuality    ()const;					// Image Quality (1-100)
	void			SetQuality    (unsigned int);
	bool			GetGrayscale  ()const;					// Grayscale Mode (True=Gray Scale,False=Color)
	void			SetGrayscale  (bool);
	bool			GetProgressive()const;					// Progressive Mode (True=Progressive,False=Sequential)
	void			SetProgressive(bool);


protected:

	void			DoCopy(const JpegEncoder &);
	void			Initialize();

	int				m_iImageQuality;						// Bild Qualitt
	bool			m_bProgressiveMode;
	bool  			m_bGrayScale;
  
};


#endif

