#ifndef __JPGEXCEP_H
#define __JPGEXCEP_H
//
// Copyright (c) 1997,1998 Colosseum Builders, Inc.
// All rights reserved.
//
// Colosseum Builders, Inc. makes no warranty, expressed or implied
// with regards to this software. It is provided as is.
//
// See the README.TXT file that came with this software for information
// on redistribution or send E-mail to info@colosseumbuilders.com
//
// o The user assumes all risk for using this software. The authors of this
//   software shall be liable for no damages of any kind.
//
// o If the source code is distributed then this copyright notice must
//   remain unaltered and any modification must be noted.
//
// o If this code is shipped in binary format the accompanying documentation
//   should state that "this software is based, in part, on the work of
//   Colosseum Builders, Inc."
//

//
//  Title:  JPEG Exception Definitions
//
//  Author:  John M. Miano  miano@colosseumbuilders.com
//

#include "GrException.h"



#ifdef	ERROR_DEUTSCH
	#define 	JSTR_ABORT		"Benutzer Abbruch"
	#define 	JSTR_OPENE		"Fehler beim ffnen der Datei !"
	#define 	JSTR_OUTOR		"Wert auerhalb der Bereiches !"
	#define 	JSTR_IOUTOR		"Index auerhalb der Bereiches !"
	#define 	JSTR_WRERR		"Fehler beim Schreiben in die Datei !"
	#define 	JSTR_BADI		"Falsche Bild-Daten !"
#else
	#define 	JSTR_ABORT		"Jpeg Abort"
	#define 	JSTR_OPENE		"Open error"
	#define 	JSTR_OUTOR		"Value out of range"
	#define 	JSTR_IOUTOR		"Index out of range"
	#define 	JSTR_WRERR		"Write Error"
	#define 	JSTR_BADI		"Bad input"
#endif


// Base class for trappable JPEG errors.
class EJpegError : public EGraphicsException
	{
	public:	EJpegError (const char *msg) : EGraphicsException (msg) {}
	};

// Exception that makes reading the image impossible.
class EJpegFatal : public EGraphicsException
	{
	public:	EJpegFatal (const char *msg) : EGraphicsException (msg) {}
	};

// Exception thrown when the callback function returns a values
// indicating the caller wants to abort the decode.
class EJpegAbort : public EGraphicsException
	{
	public:	EJpegAbort  () : EGraphicsException (JSTR_ABORT) {}
	};
class EJpegOpenError : public EGraphicsException
	{
	public:	EJpegOpenError  () : EGraphicsException (JSTR_OPENE) {}
	};
class EJpegValueOutOfRange : public EJpegError
	{
	public:	EJpegValueOutOfRange () : EJpegError (JSTR_OUTOR) {}
	};
class EJpegIndexOutOfRange : public EJpegError
	{
	public:	EJpegIndexOutOfRange () : EJpegError (JSTR_IOUTOR) {}
	};
class EJpegBadOutputParameter : public EJpegError
	{
	public:	EJpegBadOutputParameter (const char *msg) : EJpegError (msg) {}
	};
class EJpegBadData : public EJpegError
	{
	public:	EJpegBadData (const char *msg = JSTR_BADI) : EJpegError (msg) {}
	};
class EJpegWriteError : public EJpegError
	{
	public:	EJpegWriteError (const char *msg = JSTR_WRERR) : EJpegError (msg) {}
	};
	
	
#endif

