//*****************************************************************************
//*
//*
//*		PngDecoder.h
//*
//*
//*****************************************************************************
//
//	Copyright (c) 2007 Anton Zechner
//
//	Das ist eine Klasse zum Laden von PNG Bildern, basierend auf libpng
// 
#ifndef __PNGDECODER_H__
#define __PNGDECODER_H__


#include	"../FileBuffer.h"
#include	"BitmapImage.h"
#include	"GrException.h"
		    


//*****************************************************************************
//*
//*		Klasse PngDecoder
//*
//*****************************************************************************
class PngDecoder : public BitmapImageDecoder
{
public:

			 PngDecoder();
	virtual ~PngDecoder();
	virtual  void ReadImage (const wchar_t *pName,BitmapImage &sImage);
	virtual  void ReadImage (const char    *pName,BitmapImage &sImage);
	virtual  void ReadImage (CFileBuffer   *pFile,BitmapImage &sImage);
			 int  HasAlpha  ();			

private:

		  	void		CallProgressFunction (unsigned int uPercent);
	static	void _cdecl ReadBuffer(void *pPtr,unsigned char *pBuffer,unsigned uLength);
	static	void _cdecl ErrorProc (void *pPtr,const char *pErrorText);

	CFileBuffer	   *pStream;	
	int				iColorType;						// Bit0=Palette Bit1=Color Bit2=Alpha


};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline int  PngDecoder::HasAlpha(){return iColorType&4;}


#endif
