//*****************************************************************************
//*
//*
//*		PngEncoder.h
//*
//*
//*****************************************************************************
//
//	Copyright (c) 2007 Anton Zechner
//
//	Das ist eine Klasse zum Speichern von PNG Bildern, basierend auf libpng
// 
#ifndef __PNGENCODER_H__
#define __PNGENCODER_H__



#include	"BitmapImage.h"
#include	"GrException.h"
#include	"../FileBuffer.h"

#define 	PNG_EN_MAX_TEXT

//*****************************************************************************
//*
//*		Klasse PngEncoder
//*
//*****************************************************************************
class PngEncoder : public BitmapImageEncoder
{
public:

			 PngEncoder();
	virtual ~PngEncoder();
	virtual  void WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual  void WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual  void WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);
	virtual  void WriteImage(const wchar_t *pName,const BitmapImage &sImage,int iMode);
	virtual  void WriteImage(const char    *pName,const BitmapImage &sImage,int iMode);
	virtual  void WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage,int iMode);

	int 	AddComment(const char *pText,const char *pKey="COMMENT");
	void	SetMode(int iMode);


protected:

	void				CallProgressFunction(unsigned uPercent);
	static void _cdecl	WriteBuffer(void *pPtr,unsigned char *pBuffer,unsigned uLength);
	static void _cdecl	ErrorProc(void *pPtr,const char *pErrorText);


	CFileBuffer	       *pStream;	
	int					iDefaultMode;
								
};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline void		PngEncoder::SetMode(int iMode){iDefaultMode=iMode;}

#endif


