//*****************************************************************************
//*
//*
//*		Pnm.h
//*
//*
//*****************************************************************************
#ifndef __PNM_H__
#define __PNM_H__

#include "GrException.h"

#ifdef	ERROR_DEUTSCH
	#define	EM_ERR_OF	"Fehler beim ffnen der PNM-Datei !"
	#define	EM_ERR_RF	"Fehler beim Lesen der PNM-Datei !"
	#define	EM_ERR_WF	"Fehler beim Schreiben PNM-Datei !"
	#define	EM_ERR_WS	"Die Datei ist keine PNM-Datei !"
	#define	EM_ERR_CS	"Beschdigte PNM-Datei !"
	#define	EM_ERR_US	"Das Format der PNM-Datei wird nicht untersttzt !"
	#define	EM_ERR_UE	"Fehler beim Unknown Error"
	#define	EM_ERR_DE	"Falsche Bild-Daten !"
#else
	#define	EM_ERR_OF	"Error opening PNM file"
	#define	EM_ERR_RF	"Error reading PNM file"
	#define	EM_ERR_WF	"Error writing PNM file"
	#define	EM_ERR_WS	"Not a Windows Bitmap stream"
	#define	EM_ERR_CS	"Corrupt Windows Bitmap stream"
	#define	EM_ERR_US	"Unsupported Bitmap Format"
	#define	EM_ERR_UE	"Unknown Error"
	#define	EM_ERR_DE	"Bad input data"
#endif

class EPnmFileOpenError : public EGraphicsException
{
public:
  EPnmFileOpenError () : EGraphicsException (EM_ERR_OF) {}
  EPnmFileOpenError (const EPnmFileOpenError &be) : EGraphicsException (be) {}
  EPnmFileOpenError &operator=(const EPnmFileOpenError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EPnmFileReadError : public EGraphicsException
{
public:
  EPnmFileReadError () : EGraphicsException (EM_ERR_RF) {}
  EPnmFileReadError (const EPnmFileReadError &be) : EGraphicsException (be) {}
  EPnmFileReadError &operator=(const EPnmFileReadError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
};

class EPnmFileWriteError : public EGraphicsException
{
public:
  EPnmFileWriteError () : EGraphicsException (EM_ERR_WF) {}
  EPnmFileWriteError (const EPnmFileWriteError &be) : EGraphicsException (be) {}
  EPnmFileWriteError &operator=(const EPnmFileWriteError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EPnmNotAPnmFile : public EGraphicsException
{
public:
  EPnmNotAPnmFile () : EGraphicsException (EM_ERR_WS) {}
  EPnmNotAPnmFile (const EPnmNotAPnmFile &be) : EGraphicsException (be) {}
  EPnmNotAPnmFile &operator=(const EPnmNotAPnmFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EPnmCorruptFile : public EGraphicsException
{
public:
  EPnmCorruptFile () : EGraphicsException (EM_ERR_CS) {}
  EPnmCorruptFile (const EPnmCorruptFile &be) : EGraphicsException (be) {}
  EPnmCorruptFile &operator=(const EPnmCorruptFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EPnmNotSupported : public EGraphicsException
{
public:
  EPnmNotSupported () : EGraphicsException (EM_ERR_US) {}
  EPnmNotSupported (const EPnmNotSupported &be) : EGraphicsException (be) {}
  EPnmNotSupported &operator=(const EPnmNotSupported &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EPnmUnknownError : public EGraphicsException
{
public:
  EPnmUnknownError () : EGraphicsException (EM_ERR_UE) {}
  EPnmUnknownError (const EPnmUnknownError &be) : EGraphicsException (be) {}
  EPnmUnknownError &operator=(const EPnmUnknownError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EPnmDataError : public EGraphicsException
{
public:
  EPnmDataError () : EGraphicsException (EM_ERR_DE) {}
  EPnmDataError (const EPnmDataError &be) : EGraphicsException (be) {}
  EPnmDataError &operator=(const EPnmDataError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

#endif
