//*****************************************************************************
//*
//*
//*		TlsDecoder.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2013
//
#ifndef __TLSDECODER_H__
#define __TLSDECODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"Tls.h"
#include	"BitmapImage.h"
#include	"GrException.h"
#include	"..\FileBuffer.h"
  

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class TlsDecoder : public BitmapImageDecoder
{
public:

						TlsDecoder() ;
	virtual     	   ~TlsDecoder() ;

	virtual void		ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void		ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void		ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);
	virtual void		ReadImage(const wchar_t *pName,BitmapImage &sImage,unsigned uPictureNr);
	virtual void		ReadImage(const char    *pName,BitmapImage &sImage,unsigned uPictureNr);
	virtual void		ReadImage(CFileBuffer   *pFile,BitmapImage &sImage,unsigned uPictureNr);
	void  				SelectPicture(unsigned uLoadNumber);
	unsigned 			GetPicureId();
	void				GetSequence(unsigned &uTime,unsigned &uNext);
	void				GetErrorAreas(unsigned *pArea);
						
protected:				
						
	void				CallProgressFunction(unsigned uPercent) ;
	
	CFileBuffer		   *m_pBuffer;
	unsigned			m_uBitCount;
	TlsFileHeader		m_sFileHeader;
	TlsAreaHeader		m_sAreas;
	TlsSequenceHeader	m_sSequence;
	unsigned			m_uLoadNumber;

};


#endif
