//*****************************************************************************
//*
//*
//*		TlsEncoder.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2013
//
#ifndef		__BMBENCODER_H__
#define		__BMPENCODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"BitmapImage.h"
#include	"Tls.h"


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class TlsEncoder : public BitmapImageEncoder
{
public:
						TlsEncoder();
	virtual     	   ~TlsEncoder();
	virtual void		WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual void		WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual void		WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);
	virtual void		WriteImage(const wchar_t *pName,const BitmapImage *pImages,unsigned uPicCount,unsigned *pAreas=0,unsigned *pTimes=0,unsigned char *pNext=0);
	virtual void		WriteImage(const char    *pName,const BitmapImage *pImages,unsigned uPicCount,unsigned *pAreas=0,unsigned *pTimes=0,unsigned char *pNext=0);
	virtual void		WriteImage(CFileBuffer   *pFile,const BitmapImage *pImages,unsigned uPicCount,unsigned *pAreas=0,unsigned *pTimes=0,unsigned char *pNext=0);

	unsigned 			SetPicureId(unsigned uPicureId);
	void				SetSequence(unsigned uTime,int iNext=-1);
	void				SetErrorAreas(unsigned *pArea);
	int 				SetFormat(int iFormat);

private:
	
	void				Initialize();
	void				CallProgressFunction(unsigned uPercent);
	virtual void		WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage,unsigned uPicPos,unsigned uPicCount);


protected:

	int					m_iFormat;					// Save Format 8 or 32
	int					m_iSequDone;				// Wurden die Bildsequenz eingestellt	
	int					m_iAreasDone;				// Wurden die Bereiche eingestellt	
	unsigned			m_uPicureId;				// Einteutige Bild-ID
	unsigned			m_uPicCnt;					// Einteutige Bild-ID
	unsigned short 		m_usCalcCrc;				// CRC fr die Berechnung
	TlsSequenceHeader	m_sSequence;				// Sequenzinfos
	TlsFileHeader		m_sFileHeader;				// Datei-Header
	TlsAreaHeader		m_sAreas;					// Fehlerbereiche

};



#endif
