//*****************************************************************************
//*
//*
//*		Xwd.h
//*
//*
//*****************************************************************************
#ifndef __XWD_H__
#define __XWD_H__

#include "GrException.h"

#ifdef	ERROR_DEUTSCH
	#define	EW_ERR_OF	"Fehler beim ffnen der XWD-Datei !"
	#define	EW_ERR_RF	"Fehler beim Lesen der XWD-Datei !"
	#define	EW_ERR_WF	"Fehler beim Schreiben XWD-Datei !"
	#define	EW_ERR_WS	"Die Datei ist keine XWD-Datei !"
	#define	EW_ERR_CS	"Beschdigte XWD-Datei !"
	#define	EW_ERR_US	"Das Format der XWD-Datei wird nicht untersttzt !"
	#define	EW_ERR_UE	"Fehler beim Unknown Error"
	#define	EW_ERR_DE	"Falsche Bild-Daten !"
#else
	#define	EW_ERR_OF	"Error opening XWD file"
	#define	EW_ERR_RF	"Error reading XWD file"
	#define	EW_ERR_WF	"Error writing XWD file"
	#define	EW_ERR_WS	"Not a Windows Bitmap stream"
	#define	EW_ERR_CS	"Corrupt Windows Bitmap stream"
	#define	EW_ERR_US	"Unsupported Bitmap Format"
	#define	EW_ERR_UE	"Unknown Error"
	#define	EW_ERR_DE	"Bad input data"
#endif

class EXwdFileOpenError : public EGraphicsException
{
public:
  EXwdFileOpenError () : EGraphicsException (EW_ERR_OF) {}
  EXwdFileOpenError (const EXwdFileOpenError &be) : EGraphicsException (be) {}
  EXwdFileOpenError &operator=(const EXwdFileOpenError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EXwdFileReadError : public EGraphicsException
{
public:
  EXwdFileReadError () : EGraphicsException (EW_ERR_RF) {}
  EXwdFileReadError (const EXwdFileReadError &be) : EGraphicsException (be) {}
  EXwdFileReadError &operator=(const EXwdFileReadError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
};

class EXwdFileWriteError : public EGraphicsException
{
public:
  EXwdFileWriteError () : EGraphicsException (EW_ERR_WF) {}
  EXwdFileWriteError (const EXwdFileWriteError &be) : EGraphicsException (be) {}
  EXwdFileWriteError &operator=(const EXwdFileWriteError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EXwdNotAXwdFile : public EGraphicsException
{
public:
  EXwdNotAXwdFile () : EGraphicsException (EW_ERR_WS) {}
  EXwdNotAXwdFile (const EXwdNotAXwdFile &be) : EGraphicsException (be) {}
  EXwdNotAXwdFile &operator=(const EXwdNotAXwdFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EXwdCorruptFile : public EGraphicsException
{
public:
  EXwdCorruptFile () : EGraphicsException (EW_ERR_CS) {}
  EXwdCorruptFile (const EXwdCorruptFile &be) : EGraphicsException (be) {}
  EXwdCorruptFile &operator=(const EXwdCorruptFile &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EXwdNotSupported : public EGraphicsException
{
public:
  EXwdNotSupported () : EGraphicsException (EW_ERR_US) {}
  EXwdNotSupported (const EXwdNotSupported &be) : EGraphicsException (be) {}
  EXwdNotSupported &operator=(const EXwdNotSupported &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EXwdUnknownError : public EGraphicsException
{
public:
  EXwdUnknownError () : EGraphicsException (EW_ERR_UE) {}
  EXwdUnknownError (const EXwdUnknownError &be) : EGraphicsException (be) {}
  EXwdUnknownError &operator=(const EXwdUnknownError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

class EXwdDataError : public EGraphicsException
{
public:
  EXwdDataError () : EGraphicsException (EW_ERR_DE) {}
  EXwdDataError (const EXwdDataError &be) : EGraphicsException (be) {}
  EXwdDataError &operator=(const EXwdDataError &ge)
  {
    this->EGraphicsException::operator=(ge) ;
    return *this ;
  }
} ;

#endif
