//*****************************************************************************
//*
//*		IsLoad
//*
//*****************************************************************************
#include <windows.h>
#include <string.h>
#include <tlhelp32.h>
#include <vdmdbg.h>
#include <tchar.h>
#include "IsLoad.h"	

#if    _MSC_VER >= 1000
#pragma warning( disable :4996 )
#endif



// NT Funktionen
typedef INT    (WINAPI *VDMENUMTASKWOWEX  )(DWORD  dwProcessId, TASKENUMPROCEX fp, LPARAM lparam);
typedef BOOL   (WINAPI *ENUMPROCESSES     )(DWORD *lpidProcess, DWORD cb, DWORD * cbNeeded);
typedef BOOL   (WINAPI *ENUMPROCESSMODULES)(HANDLE hProcess,HMODULE * lphModule,DWORD cb,LPDWORD lpcbNeeded);
typedef DWORD  (WINAPI *GETMODULEFILENAMEA)(HANDLE hProcess,HMODULE hModule,LPSTR lpstrFileName,DWORD nSize);
typedef DWORD  (WINAPI *GETMODULEFILENAMEW)(HANDLE hProcess,HMODULE hModule,LPWSTR lpstrFileName,DWORD nSize);
typedef DWORD  (WINAPI *GETMODULEBASENAMEW)(HANDLE hProcess,HMODULE hModule,LPTSTR lpstrFileName,DWORD nSize);

// Win95 functions
typedef HANDLE (WINAPI *CREATESNAPSHOT)(DWORD  dwFlags,DWORD th32ProcessID);
typedef BOOL   (WINAPI *PROCESSWALK   )(HANDLE hSnapshot,LPPROCESSENTRY32 lppe);
typedef BOOL   (WINAPI *MODULEWALK    )(HANDLE hSnapshot,LPMODULEENTRY32 lpme);


#define 	MAX_HANDLE_COUNT	128

#ifdef	UNICODE
#define	GETMODULEFILENAME	GETMODULEFILENAMEW
#else
#define	GETMODULEFILENAME	GETMODULEFILENAMEA
#endif


//*****************************************************************************
//*
//*		IsLoad
//*
//*****************************************************************************
//	Ergibt 1 wenn der aktuelle Prozess schon einmal geladen wurde
BOOL IsLoad(void)
{
OSVERSIONINFO	ovi;
TCHAR			module_name[MAX_PATH];
BOOL			use_nt,exit=0;
DWORD			process_id =0,i;




	ovi.dwOSVersionInfoSize = sizeof(ovi);
	GetVersionEx(&ovi);
	GetModuleFileName(0,module_name,MAX_PATH);
	process_id=GetCurrentProcessId();

	use_nt = ovi.dwPlatformId == VER_PLATFORM_WIN32_NT && ovi.dwMajorVersion <= 4;

	if(use_nt)
		{
		HMODULE			m_modPSAPI;
		HMODULE			m_modVDMDBG;

		m_modPSAPI  = LoadLibrary(_T("PSAPI.DLL"));
		m_modVDMDBG = LoadLibrary(_T("VDMDBG.DLL"));

		if( NULL == m_modPSAPI || NULL == m_modVDMDBG )return FALSE;

		ENUMPROCESSES       pEnumProcesses;
		GETMODULEFILENAME   pGetModuleFileName;
		VDMENUMTASKWOWEX	pVDMEnumTaskWOWEx;
		ENUMPROCESSMODULES  pEnumProcessModules;

		pVDMEnumTaskWOWEx  = (VDMENUMTASKWOWEX )GetProcAddress(m_modVDMDBG, "VDMEnumTaskWOWEx");
		pEnumProcesses     = (ENUMPROCESSES    )GetProcAddress(m_modPSAPI, "EnumProcesses");
		pEnumProcessModules= (ENUMPROCESSMODULES)GetProcAddress(m_modPSAPI, "EnumProcessModules");
#ifdef	UNICODE
		pGetModuleFileName = (GETMODULEFILENAME)GetProcAddress(m_modPSAPI, "GetModuleFileNameExW");
#else
		pGetModuleFileName = (GETMODULEFILENAME)GetProcAddress(m_modPSAPI, "GetModuleFileNameExA");
#endif

		if(	NULL == pVDMEnumTaskWOWEx	||
			NULL == pEnumProcesses		||
			NULL == pGetModuleFileName	)return FALSE;

		DWORD nProcessIDs[MAX_HANDLE_COUNT];
		DWORD nProcessNo;

		BOOL bSuccess = pEnumProcesses(nProcessIDs, sizeof(nProcessIDs), &nProcessNo);
		nProcessNo /= sizeof(nProcessIDs[0]);

		if(!bSuccess)return FALSE;

		for(i=0; i<nProcessNo; i++)
			{
			if(nProcessIDs[i]== process_id)continue;
			HANDLE process = OpenProcess(PROCESS_QUERY_INFORMATION|PROCESS_VM_READ,FALSE, nProcessIDs[i]);

			HMODULE hModules[MAX_HANDLE_COUNT];
			DWORD nModuleNo;
			TCHAR szFileName[MAX_PATH];

			pEnumProcessModules(process, hModules, sizeof(hModules), &nModuleNo);

			nModuleNo /= sizeof(hModules[0]);
			if(pGetModuleFileName(process, hModules[0], szFileName,MAX_PATH))
				{
				if(!stricmp(szFileName,module_name))
					{
					exit=TRUE;
					break;
					}
				}
			CloseHandle(process);
			}

		}
	else{

		HANDLE		snapshot;
		HINSTANCE	modKERNEL = GetModuleHandle(_T("KERNEL32.DLL"));

		CREATESNAPSHOT CreateToolhelp32Snapshot;
		PROCESSWALK pProcess32First;
		PROCESSWALK pProcess32Next;

		CreateToolhelp32Snapshot = (CREATESNAPSHOT)GetProcAddress(modKERNEL, "CreateToolhelp32Snapshot");
		pProcess32First = (PROCESSWALK)GetProcAddress(modKERNEL, "Process32First");
		pProcess32Next  = (PROCESSWALK)GetProcAddress(modKERNEL, "Process32Next");

		if (
			NULL == CreateToolhelp32Snapshot	||
			NULL == pProcess32First				||
			NULL == pProcess32Next)
			return FALSE;

		PROCESSENTRY32 proc;
		proc.dwSize = sizeof(proc);


		snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
		pProcess32First(snapshot, &proc);

		do	{
			if(proc.th32ProcessID == process_id)continue;
			if(!stricmp(proc.szExeFile,module_name))
				{
				exit=TRUE;
				break;
				}
			}while(pProcess32Next(snapshot,&proc));


		CloseHandle(snapshot);
		}

return exit;
}
