//*****************************************************************************
//*
//*
//*		FileLogger.cpp
//*
//*
//*****************************************************************************
//	
//	Das ist ein Modul um formatierte Text in LOG-Dateien zu schreiben.
//
#include	"FileLogger.h"
#include	<stdarg.h>
#include	<string.h>
#include	<stdio.h>
#include	<time.h>


#ifdef		_MSC_VER	
#if			_MSC_VER<=1299
#define 	vsnprintf			_vsnprintf	
#endif 	
#endif 	

#ifndef		FPF_ADD_DATE
#define 	FPF_ADD_DATE		0					// Das Datum anhngen
#endif 		

#ifndef		FPF_ADD_TIME
#define 	FPF_ADD_TIME		1					// Die Zeit anhngen
#endif 		

#ifndef		FPF_ADD_PID
#define 	FPF_ADD_PID			1					// Prozess-ID anhngen
#endif 		

#ifndef		FPF_MAX_SIZE
#define 	FPF_MAX_SIZE		0x18000				// Maximale Dateigre
#endif 		

#ifndef		FPF_MAX_FILES
#define 	FPF_MAX_FILES		9					// Maximale Dateianzahl
#endif 		


#ifdef		linux									// Pfad fr die LOG-Dateien
#ifndef		FPF_PATH
#define 	FPF_PATH			"/"
#endif 	
#include	<unistd.h>
#else
#ifndef		FPF_PATH
#define 	FPF_PATH			"C:"
#endif 	
#define 	getpid()			GetCurrentProcessId()	
#include	<windows.h>
#endif 		

#ifdef		__cplusplus
#define 	FPF_TYPE			extern "C"
#else
#define 	FPF_TYPE			
#endif 		


//*****************************************************************************
//*
//*		FilePrint
//*
//*****************************************************************************
//	Speichert Texte in eine Datei. Diedate wird dabei jedemal neu geffnet.
//	pFileName	: Ist der Name der Datei ohne Pfad
//	pFormat		: Ist das Ausgabeformat	siehe printf(...)
//	Ergibt die Anzahl der gespeicherten Zeichen
FPF_TYPE int FilePrint(const char *pFileName,const char *pFormat,...)
{
char		cBuffer[1024];
char		cPath[256];
FILE	   *pFile;		
va_list		pArgs;
int			iSize;
int			iOff;


	iOff  = 0;


	#if FPF_ADD_TIME || FPF_ADD_DATE
		{
		struct tm  *pData;
		time_t		iTime;

		iTime = time(0);
		pData = localtime(&iTime);

		#if FPF_ADD_DATE

		if(!pData)									// Datum anhngen
			{
			iOff += sprintf(cBuffer+iOff,"XXXX-XX-XX ");
			}
		else{
			iOff += sprintf(cBuffer+iOff,"%04i-%02i-%02i ",pData->tm_year+1900,pData->tm_mon+1,pData->tm_mday);
			}
		
		#endif 		

		#if FPF_ADD_TIME
													// Zeit anhngen
		if(!pData)
			{
			iOff += sprintf(cBuffer+iOff,"XX:XX:XX\t");
			}
		else{
			iOff += sprintf(cBuffer+iOff,"%02i:%02i:%02i\t",pData->tm_hour,pData->tm_min,pData->tm_sec);
			}
		
		#endif 		
		}
	#endif 	

	#if FPF_ADD_PID

	iOff += sprintf(cBuffer+iOff,"(#%05u)\t",getpid());

	#endif 	


	va_start(pArgs,pFormat);						// Den Text ausgeben
	iOff += vsnprintf(cBuffer+iOff,sizeof(cBuffer)-iOff-2,pFormat,pArgs);
	va_end(pArgs);

	cBuffer[iOff] = '\n';	iOff++;
	cBuffer[iOff] = 0;

	if(pFileName[0]!='/' && pFileName[0]!='\\' && !(pFileName[0] && pFileName[1]==':'))
		{
		sprintf(cPath,"%s/%s",FPF_PATH,pFileName);
		pFileName = cPath;
		}
	

		pFile = fopen(pFileName,"a+b");				// Die Datei ffnen
	if(!pFile)return -1;

	fwrite(cBuffer,iOff,1,pFile);

	iSize = ftell(pFile);

	fclose(pFile);

	
	
	#if FPF_MAX_SIZE>0

	if(iSize>=FPF_MAX_SIZE)							// Ist die Datei zu gro
		{
		const char *pSuffix="";;
		int			iLen;
		int			iPos;

		iLen = strlen(pFileName);

		for(iPos=iLen-1;;iPos--)
			{
			if(pFileName[iPos]=='.')
				{
				pSuffix = pFileName+iPos;
				iLen    = iPos;
				break;
				}

			if(pFileName[iPos]!=':' )
			if(pFileName[iPos]!='\\')
			if(pFileName[iPos]!='/' )
			if(iPos>0)
				{
				continue;
				}
			
			break;
			}
													// Lsche die letzte Datei
		sprintf(cBuffer,"%.*s.%i%s",iLen,pFileName,FPF_MAX_FILES,pSuffix);
		remove(cBuffer);

		for(iPos=FPF_MAX_FILES-1;iPos>0;iPos--)		
			{
			strcpy (cBuffer+512,cBuffer);
			sprintf(cBuffer,"%.*s.%i%s",iLen,pFileName,iPos,pSuffix);
			rename (cBuffer,cBuffer+512);
			}
		
		rename(pFileName,cBuffer);
		}

	#endif 	



return iOff;
}


