//*****************************************************************************
//*
//*
//*		ProfileLogger.h
//*
//*
//*****************************************************************************
//
//	Diese Modul kann in Echtzeit Daten in einem Programm aufzeichen.
//	Dazu wird das Remote-Interface verwendet. Datenpakete werden in einem
//	Shared-Memory gespeichert, und von einem anderen Prozess ausgelesen.
//	Dieser Prozess kann die Datenpakete via TCP weiterleiten.
//	Copyright Anton Zechner (C) 2010
//
//	Als Empfnger kann das Terminal-Programm mit der ID 18227 benutzt werden.
//
//	Beispiel:
//
//
//		ProfileLoggerInit(PLOG_ALL);
//
//		for(;;)
//			{
//			ProfileLoggerMark("MyMark");
//			iRet = Function();
//			ProfileLoggerMark("MyMark out",iRet);
//			}
//
//		ProfileLoggerExit();
//
#ifndef 	__PROFILELOGGER_H__
#define 	__PROFILELOGGER_H__


#ifdef __cplusplus
#define		PLOG_API	extern "C"
#define		D(a)		a
#else
#define		PLOG_API
#define		D(a)
#endif

#define 	PLOG_ALL		0x000000FF				// Alle Funktionen tracen
#define 	PLOG_SLEEP		0x00000001				// Sleep/SleepEx tracen
#define 	PLOG_WAIT		0x00000002				// WaitForSingleObject/WaitForMultipleObjects... tracen
#define 	PLOG_START		0x00000100				// Aufzeichnung sofort starten
#define 	PLOG_NONE		0x9D4F378D				// Parameter nicht anzeigen

PLOG_API	void	ProfileLoggerInit(int iMode,const char *pModule D(=0));
PLOG_API	void	ProfileLoggerExit();
PLOG_API	void	ProfileLoggerMark(const char *pName,int iVal1 D(=PLOG_NONE),int iVal2 D(=PLOG_NONE),int iVal3 D(=PLOG_NONE),int iVal4 D(=PLOG_NONE));


#undef		D

#endif
