//*****************************************************************************
//*
//*
//*		LongTime.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2015
//
//	Funktionen:
//
//		unsigned int64 GetLongTime()	: Ergibt den Wert des 64-Bit-System-Counters
//
#ifdef		GLOBAL_CONFIG
#define		LONGTIME_CPP
#include	<GlobalConfig.h>
#undef		LONGTIME_CPP
#endif

#include	"LongTime.h"

#ifdef		WIN32
#include	<windows.h>
#endif 	


//*****************************************************************************
//*
//*		GetLongTime
//*
//*****************************************************************************
//	Ergibt den Wert des 64-Bit-System-Counters
#if defined(NO_GLT_ASM)

	#ifdef	WIN32

		extern "C" unsigned ilt64 _cdecl GetLongTime()
			{
			LARGE_INTEGER	uVal;
			QueryPerformanceCounter(&uVal);
			return	uVal.QuadPart;
			}

	#else

		#ifndef LONGTIME_NO_ERROR	
		#error  the function GetLongTime is for this opertaing system not supported
		#endif 	

	#endif 	

#elif defined(_DEBUG)

	#if defined(__GNUC__)
	
		extern "C" unsigned ilt64 GetLongTime()
			{
			unsigned ilt64  uVal;
			__asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));
			return uVal;
			}

	#elif defined(_MSC_VER) && (defined(_M_X64) || defined(_M_AMD64) || (_MSC_VER>=1300))

		extern "C" unsigned ilt64 _cdecl GetLongTime()
			{
			return __rdtsc();
			}

	#elif defined(_MSC_VER) && defined(_M_IX86) && (_MSC_VER<1300)

		#pragma warning( disable :4035 )

		extern "C" unsigned ilt64 _cdecl GetLongTime()
			{
			_asm	rdtsc;						// Den 64 Bit CPU-Takt zhler auslesen
			}

	#else
	
		#ifndef LONGTIME_NO_ERROR	
		#error  unkown compiler or cpu 
		#endif 	

	#endif

#endif


