//*****************************************************************************
//*
//*
//*		Long Time.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2015
//
//	Funktionen:
//
//		unsigned int64 GetLongTime()	: Ergibt den Wert des 64-Bit-System-Counters
//
#ifndef __LONGTIME_H__
#define __LONGTIME_H__

#if     _MSC_VER >= 1000
#pragma	 once
#endif

#ifdef	 GLOBAL_CONFIG
#define  LONGTIME_H
#include <GlobalConfig.h>
#undef	 LONGTIME_H
#endif

#ifdef	_MSC_VER
	#pragma once
	#pragma warning( push )
	#pragma warning( disable :4035 )
	#if     defined(_M_X64) || defined(_M_AMD64) || (defined(_M_IX86) && (_MSC_VER>=1300))
	#include <intrin.h>
	#endif
#elif !defined(__GNUC__) || !(defined(__i386__) || defined(__i486__) || defined(__i586__) || (defined(__x86_64__) || defined(__amd64__))
	#ifndef	NO_GLT_ASM
	#define NO_GLT_ASM
	#endif
#endif


#ifndef _MSC_VER
	#ifndef	 _cdecl
	#define	 _cdecl
	#endif
	#ifndef	__cdecl
	#define	__cdecl
	#endif
	#ifndef	ilt64
	#define ilt64	long long
	#endif
#else
	#ifndef	ilt64
	#define ilt64	__int64
	#endif
#endif



//*****************************************************************************
//*
//*		GetLongTime
//*
//*****************************************************************************
//	Ergibt den Wert des 64-Bit-System-Counters
#if defined(_DEBUG) || defined(NO_GLT_ASM)

	#ifdef	__cplusplus
	extern "C" {
	#endif
	
	extern unsigned ilt64 _cdecl GetLongTime();

	#ifdef	__cplusplus
	}
	#endif

#else

	#if defined(__GNUC__)

		 __attribute__((always_inline)) static inline unsigned ilt64 GetLongTime()
			{
			unsigned ilt64  uVal;
			__asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));
			return uVal;
			}

	#elif defined(_MSC_VER) && (defined(_M_X64) || defined(_M_AMD64) || (defined(_M_IX86) && (_MSC_VER>=1300)))

		static __inline unsigned ilt64 GetLongTime()
			{
			return __rdtsc();
			}

	#elif defined(_MSC_VER) && defined(_M_IX86) && (_MSC_VER<1300)

		static __inline unsigned ilt64 GetLongTime()
			{
			_asm	rdtsc;				
			}

	#else
	
		#ifndef LONGTIME_NO_ERROR	
		#error  unkown compiler or cpu 
		#endif 	

	#endif

#endif



#ifdef	_MSC_VER
#pragma warning( pop )
#endif

#endif
