//*****************************************************************************
//*
//*
//*		NetFunctions.cpp
//*
//*
//*****************************************************************************
#define		_WIN32_DCOM

#include	<windows.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<time.h>

#ifndef	   _WIN64
#ifndef		DWORD_PTR
#define		DWORD_PTR		DWORD
#endif
#endif

#include	<objbase.h>
#include	<comdef.h>
#include	"NetFunctions.h"

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef		UNICODE
#define 	XCHAR			WCHAR
#else
#define 	XCHAR			BYTE
#endif

#ifndef		HAS_WBEMIDL_H
#define 	HAS_WBEMIDL_H	0
#endif

#ifdef	   _MSC_VER
#pragma		warning( disable :4996 )
#endif


//*****************************************************************************
//*
//*		Log-Funktionen
//*
//*****************************************************************************

#define 	LOG_WMI			0
#define 	LOG_FILE		"Net.log"


#if			LOG_WMI
#define 	LOG_WMI0(a)			{FILE *f; f=fopen(LOG_FILE,"a+b");if(f){fprintf(f,a      );fclose(f);}}
#define 	LOG_WMI1(a,b)		{FILE *f; f=fopen(LOG_FILE,"a+b");if(f){fprintf(f,a,b    );fclose(f);}}
#define 	LOG_WMI2(a,b,c)		{FILE *f; f=fopen(LOG_FILE,"a+b");if(f){fprintf(f,a,b,c  );fclose(f);}}
#define 	LOG_WMI3(a,b,c,d)	{FILE *f; f=fopen(LOG_FILE,"a+b");if(f){fprintf(f,a,b,c,d);fclose(f);}}
#else
#define 	LOG_WMI0(a)
#define 	LOG_WMI1(a,b)
#define 	LOG_WMI2(a,b,c)
#define 	LOG_WMI3(a,b,c,d)
#endif



//*****************************************************************************
//*
//*		WMI Definitionen
//*
//*****************************************************************************
#if	HAS_WBEMIDL_H

#include	<wbemidl.h>
#pragma		comment(lib, "wbemuuid.lib")

#else

#ifndef	__SPECSTRINGS_STRICT_LEVEL
#define __out
#define __pre
#define __post
#define __valid
#define __notvalid
#define __refparam
#define __deref_out
#define __allowed(p)
#define __out_ecount(x)
#define __elem_writableTo(count)
#define __elem_readableTo(count)
#define __deref_opt_inout_opt                       __allowed(on_parameter)
#define __maybenull									__allowed(on_typedecl)
#define __exceptthat								__allowed(on_typedecl)
#define __RPC__out                                  __out
#define __RPC__in                                   __pre __valid
#define __RPC__in_opt                               __RPC__in __pre __exceptthat __maybenull
#define __RPC__deref_out                            __deref_out
#define __RPC__deref_out_opt                        __RPC__deref_out
#define __RPC__deref_opt_inout_opt                  __deref_opt_inout_opt
#define __RPC__out_ecount(size)                     __out_ecount(size)           __post  __elem_writableTo(size)
#define __RPC__out_ecount_string(size)              __RPC__out_ecount(size)      __post  __nullterminated
#define __RPC__out_ecount_part(size,length)         __RPC__out_ecount(size)      __post  __elem_readableTo(length)
#define __RPC__out_ecount_full_string(size)         __RPC__out_ecount_full(size) __post  __nullterminated
#define __RPC__out_ecount_full(size)                __RPC__out_ecount_part(size, size)
#endif

extern "C"
{
const IID		IID_IWbemLocator_	= {0xDC12A687,0x737F,0x11CF, 0x88,0x4D,0x00,0xAA,0x00,0x4B,0x2E,0x24};
const CLSID		CLSID_WbemLocator_	= {0x4590F811,0x1D3A,0x11D0, 0x89,0x1F,0x00,0xAA,0x00,0x4B,0x2E,0x24};
}

typedef long CIMTYPE;
typedef interface IWbemLocator		   IWbemLocator;
typedef interface IWbemContext		   IWbemContext;
typedef interface IWbemServices        IWbemServices;
typedef interface IWbemCallResult      IWbemCallResult;
typedef interface IWbemObjectSink      IWbemObjectSink;
typedef interface IWbemClassObject	   IWbemClassObject;
typedef interface IWbemQualifierSet    IWbemQualifierSet;
typedef interface IEnumWbemClassObject IEnumWbemClassObject;

    MIDL_INTERFACE("dc12a681-737f-11cf-884d-00aa004b2e24")
    IWbemClassObject : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE GetQualifierSet(
            /* [out] */ IWbemQualifierSet **ppQualSet) = 0;

        virtual HRESULT STDMETHODCALLTYPE Get(
            /* [string][in] */ LPCWSTR wszName,
            /* [in] */ long lFlags,
            /* [unique][in][out] */ VARIANT *pVal,
            /* [unique][in][out] */ CIMTYPE *pType,
            /* [unique][in][out] */ long *plFlavor) = 0;

        virtual HRESULT STDMETHODCALLTYPE Put(
            /* [string][in] */ LPCWSTR wszName,
            /* [in] */ long lFlags,
            /* [in] */ VARIANT *pVal,
            /* [in] */ CIMTYPE Type) = 0;

        virtual HRESULT STDMETHODCALLTYPE Delete(
            /* [string][in] */ LPCWSTR wszName) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetNames(
            /* [string][in] */ LPCWSTR wszQualifierName,
            /* [in] */ long lFlags,
            /* [in] */ VARIANT *pQualifierVal,
            /* [out] */ SAFEARRAY * *pNames) = 0;

        virtual HRESULT STDMETHODCALLTYPE BeginEnumeration(
            /* [in] */ long lEnumFlags) = 0;

        virtual HRESULT STDMETHODCALLTYPE Next(
            /* [in] */ long lFlags,
            /* [unique][in][out] */ BSTR *strName,
            /* [unique][in][out] */ VARIANT *pVal,
            /* [unique][in][out] */ CIMTYPE *pType,
            /* [unique][in][out] */ long *plFlavor) = 0;

        virtual HRESULT STDMETHODCALLTYPE EndEnumeration( void) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetPropertyQualifierSet(
            /* [string][in] */ LPCWSTR wszProperty,
            /* [out] */ IWbemQualifierSet **ppQualSet) = 0;

        virtual HRESULT STDMETHODCALLTYPE Clone(
            /* [out] */ IWbemClassObject **ppCopy) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetObjectText(
            /* [in] */ long lFlags,
            /* [out] */ BSTR *pstrObjectText) = 0;

        virtual HRESULT STDMETHODCALLTYPE SpawnDerivedClass(
            /* [in] */ long lFlags,
            /* [out] */ IWbemClassObject **ppNewClass) = 0;

        virtual HRESULT STDMETHODCALLTYPE SpawnInstance(
            /* [in] */ long lFlags,
            /* [out] */ IWbemClassObject **ppNewInstance) = 0;

        virtual HRESULT STDMETHODCALLTYPE CompareTo(
            /* [in] */ long lFlags,
            /* [in] */ IWbemClassObject *pCompareTo) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetPropertyOrigin(
            /* [string][in] */ LPCWSTR wszName,
            /* [out] */ BSTR *pstrClassName) = 0;

        virtual HRESULT STDMETHODCALLTYPE InheritsFrom(
            /* [in] */ LPCWSTR strAncestor) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetMethod(
            /* [string][in] */ LPCWSTR wszName,
            /* [in] */ long lFlags,
            /* [out] */ IWbemClassObject **ppInSignature,
            /* [out] */ IWbemClassObject **ppOutSignature) = 0;

        virtual HRESULT STDMETHODCALLTYPE PutMethod(
            /* [string][in] */ LPCWSTR wszName,
            /* [in] */ long lFlags,
            /* [in] */ IWbemClassObject *pInSignature,
            /* [in] */ IWbemClassObject *pOutSignature) = 0;

        virtual HRESULT STDMETHODCALLTYPE DeleteMethod(
            /* [string][in] */ LPCWSTR wszName) = 0;

        virtual HRESULT STDMETHODCALLTYPE BeginMethodEnumeration(
            /* [in] */ long lEnumFlags) = 0;

        virtual HRESULT STDMETHODCALLTYPE NextMethod(
            /* [in] */ long lFlags,
            /* [unique][in][out] */ BSTR *pstrName,
            /* [unique][in][out] */ IWbemClassObject **ppInSignature,
            /* [unique][in][out] */ IWbemClassObject **ppOutSignature) = 0;

        virtual HRESULT STDMETHODCALLTYPE EndMethodEnumeration( void) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetMethodQualifierSet(
            /* [string][in] */ LPCWSTR wszMethod,
            /* [out] */ IWbemQualifierSet **ppQualSet) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetMethodOrigin(
            /* [string][in] */ LPCWSTR wszMethodName,
            /* [out] */ BSTR *pstrClassName) = 0;

    };


MIDL_INTERFACE("027947e1-d731-11ce-a357-000000000001")
IEnumWbemClassObject : public IUnknown
{
    public:
        virtual HRESULT STDMETHODCALLTYPE Reset( void) = 0;

        virtual HRESULT STDMETHODCALLTYPE Next(
            /* [in] */ long lTimeout,
            /* [in] */ ULONG uCount,
            /* [length_is][size_is][out] */ __RPC__out_ecount_part(uCount, *puReturned) IWbemClassObject **apObjects,
            /* [out] */ __RPC__out ULONG *puReturned) = 0;

        virtual HRESULT STDMETHODCALLTYPE NextAsync(
            /* [in] */ ULONG uCount,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pSink) = 0;

        virtual HRESULT STDMETHODCALLTYPE Clone(
            /* [out] */ __RPC__deref_out_opt IEnumWbemClassObject **ppEnum) = 0;

        virtual HRESULT STDMETHODCALLTYPE Skip(
            /* [in] */ long lTimeout,
            /* [in] */ ULONG nCount) = 0;

    };

    MIDL_INTERFACE("9556dc99-828c-11cf-a37e-00aa003240c7")
    IWbemServices : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE OpenNamespace(
            /* [in] */ __RPC__in const BSTR strNamespace,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemServices **ppWorkingNamespace,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE CancelAsyncCall(
            /* [in] */ __RPC__in_opt IWbemObjectSink *pSink) = 0;

        virtual HRESULT STDMETHODCALLTYPE QueryObjectSink(
            /* [in] */ long lFlags,
            /* [out] */ __RPC__deref_out_opt IWbemObjectSink **ppResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetObject(
            /* [in] */ __RPC__in const BSTR strObjectPath,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemClassObject **ppObject,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppCallResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE GetObjectAsync(
            /* [in] */ __RPC__in const BSTR strObjectPath,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE PutClass(
            /* [in] */ __RPC__in_opt IWbemClassObject *pObject,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppCallResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE PutClassAsync(
            /* [in] */ __RPC__in_opt IWbemClassObject *pObject,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE DeleteClass(
            /* [in] */ __RPC__in const BSTR strClass,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppCallResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE DeleteClassAsync(
            /* [in] */ __RPC__in const BSTR strClass,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE CreateClassEnum(
            /* [in] */ __RPC__in const BSTR strSuperclass,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [out] */ __RPC__deref_out_opt IEnumWbemClassObject **ppEnum) = 0;

        virtual HRESULT STDMETHODCALLTYPE CreateClassEnumAsync(
            /* [in] */ __RPC__in const BSTR strSuperclass,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE PutInstance(
            /* [in] */ __RPC__in_opt IWbemClassObject *pInst,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppCallResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE PutInstanceAsync(
            /* [in] */ __RPC__in_opt IWbemClassObject *pInst,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE DeleteInstance(
            /* [in] */ __RPC__in const BSTR strObjectPath,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppCallResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE DeleteInstanceAsync(
            /* [in] */ __RPC__in const BSTR strObjectPath,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE CreateInstanceEnum(
            /* [in] */ __RPC__in const BSTR strFilter,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [out] */ __RPC__deref_out_opt IEnumWbemClassObject **ppEnum) = 0;

        virtual HRESULT STDMETHODCALLTYPE CreateInstanceEnumAsync(
            /* [in] */ __RPC__in const BSTR strFilter,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE ExecQuery(
            /* [in] */ __RPC__in const BSTR strQueryLanguage,
            /* [in] */ __RPC__in const BSTR strQuery,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [out] */ __RPC__deref_out_opt IEnumWbemClassObject **ppEnum) = 0;

        virtual HRESULT STDMETHODCALLTYPE ExecQueryAsync(
            /* [in] */ __RPC__in const BSTR strQueryLanguage,
            /* [in] */ __RPC__in const BSTR strQuery,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE ExecNotificationQuery(
            /* [in] */ __RPC__in const BSTR strQueryLanguage,
            /* [in] */ __RPC__in const BSTR strQuery,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [out] */ __RPC__deref_out_opt IEnumWbemClassObject **ppEnum) = 0;

        virtual HRESULT STDMETHODCALLTYPE ExecNotificationQueryAsync(
            /* [in] */ __RPC__in const BSTR strQueryLanguage,
            /* [in] */ __RPC__in const BSTR strQuery,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

        virtual HRESULT STDMETHODCALLTYPE ExecMethod(
            /* [in] */ __RPC__in const BSTR strObjectPath,
            /* [in] */ __RPC__in const BSTR strMethodName,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemClassObject *pInParams,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemClassObject **ppOutParams,
            /* [unique][in][out] */ __RPC__deref_opt_inout_opt IWbemCallResult **ppCallResult) = 0;

        virtual HRESULT STDMETHODCALLTYPE ExecMethodAsync(
            /* [in] */ __RPC__in const BSTR strObjectPath,
            /* [in] */ __RPC__in const BSTR strMethodName,
            /* [in] */ long lFlags,
            /* [in] */ __RPC__in_opt IWbemContext *pCtx,
            /* [in] */ __RPC__in_opt IWbemClassObject *pInParams,
            /* [in] */ __RPC__in_opt IWbemObjectSink *pResponseHandler) = 0;

    };

    MIDL_INTERFACE("dc12a687-737f-11cf-884d-00aa004b2e24")
    IWbemLocator : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE ConnectServer(
            /* [in] */ const BSTR strNetworkResource,
            /* [in] */ const BSTR strUser,
            /* [in] */ const BSTR strPassword,
            /* [in] */ const BSTR strLocale,
            /* [in] */ long lSecurityFlags,
            /* [in] */ const BSTR strAuthority,
            /* [in] */ IWbemContext *pCtx,
            /* [out] */ IWbemServices **ppNamespace) = 0;

    };


typedef enum tag_WBEM_TIMEOUT_TYPE
    {
	WBEM_NO_WAIT	= 0,
	WBEM_INFINITE	= 0xffffffff
    } 	WBEM_TIMEOUT_TYPE;

typedef enum tag_WBEM_GENERIC_FLAG_TYPE
    {
	WBEM_FLAG_RETURN_IMMEDIATELY		= 0x10,
	WBEM_FLAG_RETURN_WBEM_COMPLETE		= 0,
	WBEM_FLAG_BIDIRECTIONAL				= 0,
	WBEM_FLAG_FORWARD_ONLY				= 0x20,
	WBEM_FLAG_NO_ERROR_OBJECT			= 0x40,
	WBEM_FLAG_RETURN_ERROR_OBJECT		= 0,
	WBEM_FLAG_SEND_STATUS				= 0x80,
	WBEM_FLAG_DONT_SEND_STATUS			= 0,
	WBEM_FLAG_ENSURE_LOCATABLE			= 0x100,
	WBEM_FLAG_DIRECT_READ				= 0x200,
	WBEM_FLAG_SEND_ONLY_SELECTED		= 0,
	WBEM_RETURN_WHEN_COMPLETE			= 0,
	WBEM_RETURN_IMMEDIATELY				= 0x10,
	WBEM_MASK_RESERVED_FLAGS			= 0x1f000,
	WBEM_FLAG_USE_AMENDED_QUALIFIERS	= 0x20000,
	WBEM_FLAG_STRONG_VALIDATION			= 0x100000
    } 	WBEM_GENERIC_FLAG_TYPE;

typedef enum tag_WBEMSTATUS
    {
	WBEM_NO_ERROR						= 0,
	WBEM_S_NO_ERROR						= 0,
	WBEM_S_SAME							= 0,
	WBEM_S_FALSE						= 1,
	WBEM_S_ALREADY_EXISTS				= 0x40001,
	WBEM_S_RESET_TO_DEFAULT				= 0x40002,
	WBEM_S_DIFFERENT					= 0x40003,
	WBEM_S_TIMEDOUT						= 0x40004,
	WBEM_S_NO_MORE_DATA					= 0x40005,
	WBEM_S_OPERATION_CANCELLED			= 0x40006,
	WBEM_S_PENDING						= 0x40007,
	WBEM_S_DUPLICATE_OBJECTS			= 0x40008,
	WBEM_S_ACCESS_DENIED				= 0x40009,
	WBEM_S_PARTIAL_RESULTS				= 0x40010,
	WBEM_S_SOURCE_NOT_AVAILABLE			= 0x40017,
	WBEM_E_FAILED						= 0x80041001,
	WBEM_E_NOT_FOUND					= 0x80041002,
	WBEM_E_ACCESS_DENIED				= 0x80041003,
	WBEM_E_PROVIDER_FAILURE				= 0x80041004,
	WBEM_E_TYPE_MISMATCH				= 0x80041005,
	WBEM_E_OUT_OF_MEMORY				= 0x80041006,
	WBEM_E_INVALID_CONTEXT				= 0x80041007,
	WBEM_E_INVALID_PARAMETER			= 0x80041008,
	WBEM_E_NOT_AVAILABLE				= 0x80041009,
	WBEM_E_CRITICAL_ERROR				= 0x8004100a,
	WBEM_E_INVALID_STREAM				= 0x8004100b,
	WBEM_E_NOT_SUPPORTED				= 0x8004100c,
	WBEM_E_INVALID_SUPERCLASS			= 0x8004100d,
	WBEM_E_INVALID_NAMESPACE			= 0x8004100e,
	WBEM_E_INVALID_OBJECT				= 0x8004100f,
	WBEM_E_INVALID_CLASS				= 0x80041010,
	WBEM_E_PROVIDER_NOT_FOUND			= 0x80041011,
	WBEM_E_INVALID_PROVIDER_REGISTRATION= 0x80041012,
	WBEM_E_PROVIDER_LOAD_FAILURE		= 0x80041013,
	WBEM_E_INITIALIZATION_FAILURE		= 0x80041014,
	WBEM_E_TRANSPORT_FAILURE			= 0x80041015,
	WBEM_E_INVALID_OPERATION			= 0x80041016,
	WBEM_E_INVALID_QUERY				= 0x80041017,
	WBEM_E_INVALID_QUERY_TYPE			= 0x80041018,
	WBEM_E_ALREADY_EXISTS				= 0x80041019,
	WBEM_E_OVERRIDE_NOT_ALLOWED			= 0x8004101a,
	WBEM_E_PROPAGATED_QUALIFIER			= 0x8004101b,
	WBEM_E_PROPAGATED_PROPERTY			= 0x8004101c,
	WBEM_E_UNEXPECTED					= 0x8004101d,
	WBEM_E_ILLEGAL_OPERATION			= 0x8004101e,
	WBEM_E_CANNOT_BE_KEY				= 0x8004101f,
	WBEM_E_INCOMPLETE_CLASS				= 0x80041020,
	WBEM_E_INVALID_SYNTAX				= 0x80041021,
	WBEM_E_NONDECORATED_OBJECT			= 0x80041022,
	WBEM_E_READ_ONLY					= 0x80041023,
	WBEM_E_PROVIDER_NOT_CAPABLE			= 0x80041024,
	WBEM_E_CLASS_HAS_CHILDREN			= 0x80041025,
	WBEM_E_CLASS_HAS_INSTANCES			= 0x80041026,
	WBEM_E_QUERY_NOT_IMPLEMENTED		= 0x80041027,
	WBEM_E_ILLEGAL_NULL					= 0x80041028,
	WBEM_E_INVALID_QUALIFIER_TYPE		= 0x80041029,
	WBEM_E_INVALID_PROPERTY_TYPE		= 0x8004102a,
	WBEM_E_VALUE_OUT_OF_RANGE			= 0x8004102b,
	WBEM_E_CANNOT_BE_SINGLETON			= 0x8004102c,
	WBEM_E_INVALID_CIM_TYPE				= 0x8004102d,
	WBEM_E_INVALID_METHOD				= 0x8004102e,
	WBEM_E_INVALID_METHOD_PARAMETERS	= 0x8004102f,
	WBEM_E_SYSTEM_PROPERTY				= 0x80041030,
	WBEM_E_INVALID_PROPERTY				= 0x80041031,
	WBEM_E_CALL_CANCELLED				= 0x80041032,
	WBEM_E_SHUTTING_DOWN				= 0x80041033,
	WBEM_E_PROPAGATED_METHOD			= 0x80041034,
	WBEM_E_UNSUPPORTED_PARAMETER		= 0x80041035,
	WBEM_E_MISSING_PARAMETER_ID			= 0x80041036,
	WBEM_E_INVALID_PARAMETER_ID			= 0x80041037,
	WBEM_E_NONCONSECUTIVE_PARAMETER_IDS	= 0x80041038,
	WBEM_E_PARAMETER_ID_ON_RETVAL		= 0x80041039,
	WBEM_E_INVALID_OBJECT_PATH			= 0x8004103a,
	WBEM_E_OUT_OF_DISK_SPACE			= 0x8004103b,
	WBEM_E_BUFFER_TOO_SMALL				= 0x8004103c,
	WBEM_E_UNSUPPORTED_PUT_EXTENSION	= 0x8004103d,
	WBEM_E_UNKNOWN_OBJECT_TYPE			= 0x8004103e,
	WBEM_E_UNKNOWN_PACKET_TYPE			= 0x8004103f,
	WBEM_E_MARSHAL_VERSION_MISMATCH		= 0x80041040,
	WBEM_E_MARSHAL_INVALID_SIGNATURE	= 0x80041041,
	WBEM_E_INVALID_QUALIFIER			= 0x80041042,
	WBEM_E_INVALID_DUPLICATE_PARAMETER	= 0x80041043,
	WBEM_E_TOO_MUCH_DATA				= 0x80041044,
	WBEM_E_SERVER_TOO_BUSY				= 0x80041045,
	WBEM_E_INVALID_FLAVOR				= 0x80041046,
	WBEM_E_CIRCULAR_REFERENCE			= 0x80041047,
	WBEM_E_UNSUPPORTED_CLASS_UPDATE		= 0x80041048,
	WBEM_E_CANNOT_CHANGE_KEY_INHERITANCE= 0x80041049,
	WBEM_E_CANNOT_CHANGE_INDEX_INHERITANCE	= 0x80041050,
	WBEM_E_TOO_MANY_PROPERTIES			= 0x80041051,
	WBEM_E_UPDATE_TYPE_MISMATCH			= 0x80041052,
	WBEM_E_UPDATE_OVERRIDE_NOT_ALLOWED	= 0x80041053,
	WBEM_E_UPDATE_PROPAGATED_METHOD		= 0x80041054,
	WBEM_E_METHOD_NOT_IMPLEMENTED		= 0x80041055,
	WBEM_E_METHOD_DISABLED				= 0x80041056,
	WBEM_E_REFRESHER_BUSY				= 0x80041057,
	WBEM_E_UNPARSABLE_QUERY				= 0x80041058,
	WBEM_E_NOT_EVENT_CLASS				= 0x80041059,
	WBEM_E_MISSING_GROUP_WITHIN			= 0x8004105a,
	WBEM_E_MISSING_AGGREGATION_LIST		= 0x8004105b,
	WBEM_E_PROPERTY_NOT_AN_OBJECT		= 0x8004105c,
	WBEM_E_AGGREGATING_BY_OBJECT		= 0x8004105d,
	WBEM_E_UNINTERPRETABLE_PROVIDER_QUERY	= 0x8004105f,
	WBEM_E_BACKUP_RESTORE_WINMGMT_RUNNING	= 0x80041060,
	WBEM_E_QUEUE_OVERFLOW				= 0x80041061,
	WBEM_E_PRIVILEGE_NOT_HELD			= 0x80041062,
	WBEM_E_INVALID_OPERATOR				= 0x80041063,
	WBEM_E_LOCAL_CREDENTIALS			= 0x80041064,
	WBEM_E_CANNOT_BE_ABSTRACT			= 0x80041065,
	WBEM_E_AMENDED_OBJECT				= 0x80041066,
	WBEM_E_CLIENT_TOO_SLOW				= 0x80041067,
	WBEM_E_NULL_SECURITY_DESCRIPTOR		= 0x80041068,
	WBEM_E_TIMED_OUT					= 0x80041069,
	WBEM_E_INVALID_ASSOCIATION			= 0x8004106a,
	WBEM_E_AMBIGUOUS_OPERATION			= 0x8004106b,
	WBEM_E_QUOTA_VIOLATION				= 0x8004106c,
	WBEM_E_RESERVED_001					= 0x8004106d,
	WBEM_E_RESERVED_002					= 0x8004106e,
	WBEM_E_UNSUPPORTED_LOCALE			= 0x8004106f,
	WBEM_E_HANDLE_OUT_OF_DATE			= 0x80041070,
	WBEM_E_CONNECTION_FAILED			= 0x80041071,
	WBEM_E_INVALID_HANDLE_REQUEST		= 0x80041072,
	WBEM_E_PROPERTY_NAME_TOO_WIDE		= 0x80041073,
	WBEM_E_CLASS_NAME_TOO_WIDE			= 0x80041074,
	WBEM_E_METHOD_NAME_TOO_WIDE			= 0x80041075,
	WBEM_E_QUALIFIER_NAME_TOO_WIDE		= 0x80041076,
	WBEM_E_RERUN_COMMAND				= 0x80041077,
	WBEM_E_DATABASE_VER_MISMATCH		= 0x80041078,
	WBEM_E_VETO_DELETE					= 0x80041079,
	WBEM_E_VETO_PUT						= 0x8004107a,
	WBEM_E_INVALID_LOCALE				= 0x80041080,
	WBEM_E_PROVIDER_SUSPENDED			= 0x80041081,
	WBEM_E_SYNCHRONIZATION_REQUIRED		= 0x80041082,
	WBEM_E_NO_SCHEMA					= 0x80041083,
	WBEM_E_PROVIDER_ALREADY_REGISTERED	= 0x80041084,
	WBEM_E_PROVIDER_NOT_REGISTERED		= 0x80041085,
	WBEM_E_FATAL_TRANSPORT_ERROR		= 0x80041086,
	WBEM_E_ENCRYPTED_CONNECTION_REQUIRED= 0x80041087,
	WBEM_E_PROVIDER_TIMED_OUT			= 0x80041088,
	WBEM_E_NO_KEY						= 0x80041089,
	WBEM_E_PROVIDER_DISABLED			= 0x8004108a,
	WBEMESS_E_REGISTRATION_TOO_BROAD	= 0x80042001,
	WBEMESS_E_REGISTRATION_TOO_PRECISE	= 0x80042002,
	WBEMESS_E_AUTHZ_NOT_PRIVILEGED		= 0x80042003,
	WBEMMOF_E_EXPECTED_QUALIFIER_NAME	= 0x80044001,
	WBEMMOF_E_EXPECTED_SEMI				= 0x80044002,
	WBEMMOF_E_EXPECTED_OPEN_BRACE		= 0x80044003,
	WBEMMOF_E_EXPECTED_CLOSE_BRACE		= 0x80044004,
	WBEMMOF_E_EXPECTED_CLOSE_BRACKET	= 0x80044005,
	WBEMMOF_E_EXPECTED_CLOSE_PAREN		= 0x80044006,
	WBEMMOF_E_ILLEGAL_CONSTANT_VALUE	= 0x80044007,
	WBEMMOF_E_EXPECTED_TYPE_IDENTIFIER	= 0x80044008,
	WBEMMOF_E_EXPECTED_OPEN_PAREN		= 0x80044009,
	WBEMMOF_E_UNRECOGNIZED_TOKEN		= 0x8004400a,
	WBEMMOF_E_UNRECOGNIZED_TYPE			= 0x8004400b,
	WBEMMOF_E_EXPECTED_PROPERTY_NAME	= 0x8004400c,
	WBEMMOF_E_TYPEDEF_NOT_SUPPORTED		= 0x8004400d,
	WBEMMOF_E_UNEXPECTED_ALIAS			= 0x8004400e,
	WBEMMOF_E_UNEXPECTED_ARRAY_INIT		= 0x8004400f,
	WBEMMOF_E_INVALID_AMENDMENT_SYNTAX	= 0x80044010,
	WBEMMOF_E_INVALID_DUPLICATE_AMENDMENT	= 0x80044011,
	WBEMMOF_E_INVALID_PRAGMA			= 0x80044012,
	WBEMMOF_E_INVALID_NAMESPACE_SYNTAX	= 0x80044013,
	WBEMMOF_E_EXPECTED_CLASS_NAME		= 0x80044014,
	WBEMMOF_E_TYPE_MISMATCH				= 0x80044015,
	WBEMMOF_E_EXPECTED_ALIAS_NAME		= 0x80044016,
	WBEMMOF_E_INVALID_CLASS_DECLARATION	= 0x80044017,
	WBEMMOF_E_INVALID_INSTANCE_DECLARATION	= 0x80044018,
	WBEMMOF_E_EXPECTED_DOLLAR			= 0x80044019,
	WBEMMOF_E_CIMTYPE_QUALIFIER			= 0x8004401a,
	WBEMMOF_E_DUPLICATE_PROPERTY		= 0x8004401b,
	WBEMMOF_E_INVALID_NAMESPACE_SPECIFICATION	= 0x8004401c,
	WBEMMOF_E_OUT_OF_RANGE				= 0x8004401d,
	WBEMMOF_E_INVALID_FILE				= 0x8004401e,
	WBEMMOF_E_ALIASES_IN_EMBEDDED		= 0x8004401f,
	WBEMMOF_E_NULL_ARRAY_ELEM			= 0x80044020,
	WBEMMOF_E_DUPLICATE_QUALIFIER		= 0x80044021,
	WBEMMOF_E_EXPECTED_FLAVOR_TYPE		= 0x80044022,
	WBEMMOF_E_INCOMPATIBLE_FLAVOR_TYPES	= 0x80044023,
	WBEMMOF_E_MULTIPLE_ALIASES			= 0x80044024,
	WBEMMOF_E_INCOMPATIBLE_FLAVOR_TYPES2= 0x80044025,
	WBEMMOF_E_NO_ARRAYS_RETURNED		= 0x80044026,
	WBEMMOF_E_MUST_BE_IN_OR_OUT			= 0x80044027,
	WBEMMOF_E_INVALID_FLAGS_SYNTAX		= 0x80044028,
	WBEMMOF_E_EXPECTED_BRACE_OR_BAD_TYPE= 0x80044029,
	WBEMMOF_E_UNSUPPORTED_CIMV22_QUAL_VALUE	= 0x8004402a,
	WBEMMOF_E_UNSUPPORTED_CIMV22_DATA_TYPE	= 0x8004402b,
	WBEMMOF_E_INVALID_DELETEINSTANCE_SYNTAX	= 0x8004402c,
	WBEMMOF_E_INVALID_QUALIFIER_SYNTAX	= 0x8004402d,
	WBEMMOF_E_QUALIFIER_USED_OUTSIDE_SCOPE	= 0x8004402e,
	WBEMMOF_E_ERROR_CREATING_TEMP_FILE	= 0x8004402f,
	WBEMMOF_E_ERROR_INVALID_INCLUDE_FILE= 0x80044030,
	WBEMMOF_E_INVALID_DELETECLASS_SYNTAX= 0x80044031
    } 	WBEMSTATUS;

#endif 	// HAS_WBEMIDL_H

//*****************************************************************************
//*
//*		IpHlpApi Definitionen
//*
//*****************************************************************************

#pragma		comment(lib,"IpHlpApi.lib")


#define 	MIB_IF_TYPE_ETHERNET            6
#define 	MAX_ADAPTER_ADDRESS_LENGTH		8
#define		MAX_INTERFACE_NAME_LEN			256
#define 	MAX_ADAPTER_NAME_LENGTH			256
#define 	MAX_ADAPTER_DESCRIPTION_LENGTH	128
#define 	MAX_ADAPTER_NAME				128
#define		MAXLEN_IFDESCR					256
#define		MAXLEN_PHYSADDR					8
#define		OID_GEN_LINK_STATE              0x00010207
#define		OID_GEN_LINK_SPEED              0x00010107
#define		OID_GEN_MEDIA_CONNECT_STATUS    0x00010114
#define		FILE_DEVICE_PHYSICAL_NETCARD    0x00000017
#define		FILE_ANY_ACCESS                 0
#define		METHOD_OUT_DIRECT               2

#ifndef		CTL_CODE
#define		CTL_CODE(DeviceType,Function,Method,Access)		(((DeviceType)<<16) | ((Access)<<14) | ((Function)<<2) | (Method))
#endif
#define		NDIS_CONTROL_CODE(request,method)	            CTL_CODE(FILE_DEVICE_PHYSICAL_NETCARD,request,method,FILE_ANY_ACCESS)
#define		IOCTL_NDIS_QUERY_GLOBAL_STATS					NDIS_CONTROL_CODE(0,METHOD_OUT_DIRECT)
#define		ENTRIES(a)										(sizeof(a)/sizeof((a)[0]))

#define 	SemInit()			CreateSemaphore(0,1,0x70000000,0)
#define 	SemExit(h)			CloseHandle(h)
#define		SemLock(h)			WaitForSingleObject(h,0xFFFFFFFF)
#define		SemUnlock(h)		ReleaseSemaphore(h,1,0)


static		HANDLE				hCardSem	= 0;			// Semaphor fr den Zugriff
static		unsigned 			uCardCnt  	= 0;			// Anzahl der Karten
static		NetCardInfo		   *pCardInfos  = 0;			// Zeiger auf Karteninformationen
static		int					iCardErr    = 0;			// Fehler beim Holen der Infos
static		int					iInitNet    = 0;			// Wurden die Funktionen initialisiert
static		int					iInitOle	= 0;			// Fehler beim Holen der Infos
static		int					iInitCnt	= 0;			// Anzahl der Initialisierungen

typedef struct
	{
	TCHAR				cNet[0x1000];
	TCHAR				cSub[0x1000];
	TCHAR				cName[256];
	TCHAR				cGate[64];
	int					iDhcp;
	}NetCardData;

typedef struct _MIB_IFROW
	{
	WCHAR				wszName[MAX_INTERFACE_NAME_LEN];
	DWORD				dwIndex;
	DWORD				dwType;
	DWORD				dwMtu;
	DWORD				dwSpeed;
	DWORD				dwPhysAddrLen;
	BYTE 				bPhysAddr[MAXLEN_PHYSADDR];
	DWORD				dwAdminStatus;
	DWORD				dwOperStatus;
	DWORD				dwLastChange;
	DWORD				dwInOctets;
	DWORD				dwInUcastPkts;
	DWORD				dwInNUcastPkts;
	DWORD				dwInDiscards;
	DWORD				dwInErrors;
	DWORD				dwInUnknownProtos;
	DWORD				dwOutOctets;
	DWORD				dwOutUcastPkts;
	DWORD				dwOutNUcastPkts;
	DWORD				dwOutDiscards;
	DWORD				dwOutErrors;
	DWORD				dwOutQLen;
	DWORD				dwDescrLen;
	BYTE 				bDescr[MAXLEN_IFDESCR];
	} MIB_IFROW, *PMIB_IFROW;

typedef struct _MIB_IFTABLE
	{
	DWORD				dwNumEntries;
	MIB_IFROW			table[1];
	}MIB_IFTABLE, *PMIB_IFTABLE;

typedef struct _MIB_IPADDRROW
	{
    DWORD				dwAddr;
    DWORD       		dwIndex;
    DWORD       		dwMask;
    DWORD       		dwBCastAddr;
    DWORD       		dwReasmSize;
    WORD				wContext;
    WORD				wType;
	}MIB_IPADDRROW, *PMIB_IPADDRROW;

typedef struct _MIB_IPADDRTABLE
	{
    DWORD				dwNumEntries;
    MIB_IPADDRROW		table[1];
	}MIB_IPADDRTABLE, *PMIB_IPADDRTABLE;

typedef struct _IP_ADAPTER_INDEX_MAP
	{
    ULONG				Index;
    WCHAR				Name[MAX_ADAPTER_NAME];
	}IP_ADAPTER_INDEX_MAP, *PIP_ADAPTER_INDEX_MAP;

typedef struct
	{
    char				String[4 * 4];
	}IP_ADDRESS_STRING, *PIP_ADDRESS_STRING, IP_MASK_STRING, *PIP_MASK_STRING;

typedef struct _IP_ADDR_STRING
	{
    struct _IP_ADDR_STRING* Next;
    IP_ADDRESS_STRING	IpAddress;
    IP_MASK_STRING		IpMask;
    DWORD				Context;
	} IP_ADDR_STRING, *PIP_ADDR_STRING;

typedef struct _IP_ADAPTER_INFO
	{
    struct _IP_ADAPTER_INFO *Next;
    DWORD				ComboIndex;
    char 				AdapterName[MAX_ADAPTER_NAME_LENGTH + 4];
    char 				Description[MAX_ADAPTER_DESCRIPTION_LENGTH + 4];
    UINT 				AddressLength;
    BYTE 				Address[MAX_ADAPTER_ADDRESS_LENGTH];
    DWORD 				Index;
    UINT 				Type;
    UINT 				DhcpEnabled;
    PIP_ADDR_STRING		CurrentIpAddress;
    IP_ADDR_STRING 		IpAddressList;
    IP_ADDR_STRING 		GatewayList;
    IP_ADDR_STRING 		DhcpServer;
    BOOL				HaveWins;
    IP_ADDR_STRING		PrimaryWinsServer;
    IP_ADDR_STRING		SecondaryWinsServer;
    time_t				LeaseObtained;
    time_t				LeaseExpires;
	}IP_ADAPTER_INFO,*PIP_ADAPTER_INFO;

typedef ULONG IPAddr;       // An IP address.
typedef ULONG IPMask;       // An IP subnet mask.

extern "C"
{
DWORD WINAPI	IpRenewAddress  (PIP_ADAPTER_INDEX_MAP pAdapterInfo);
DWORD WINAPI	GetAdaptersInfo (PIP_ADAPTER_INFO pAdapterInfo,PULONG pOutBufLen);
DWORD WINAPI	GetIpAddrTable  (PMIB_IPADDRTABLE pIpAddrTable,PULONG pSize,BOOL bOrder);
DWORD WINAPI	AddIPAddress    (IPAddr  uIpAddress,IPMask uIpMask,DWORD  uIfIndex,PULONG  pNetContext,PULONG  pNetInstance);
DWORD WINAPI	DeleteIPAddress (ULONG   uNetContext);
DWORD WINAPI	GetIfTable      (PMIB_IFTABLE pIfTable,PULONG pSize,BOOL bOrder);
}

static	int		WmiEnableDhcp   (LPCTSTR pMac,int     iDepth=0);
static	int		WmiSetGateway   (LPCTSTR pMac,LPCTSTR pGateway);
static	int		WmiSetNameServer(LPCTSTR pMac,LPCTSTR pAddr1,LPCTSTR pAddr2);
static	int		WmiSetIpAdresses(LPCTSTR pMac,LPCTSTR pAddr ,LPCTSTR pMask ,int iDepth=0);
static	int		NetGetConnectStatus(LPCTSTR pInterface,int iNoLock);

//*****************************************************************************
//*
//*		BtoL
//*
//*****************************************************************************
//	Big-Little-Endian tauschen
static inline unsigned int BtoL(unsigned uValue)
{
#if defined(_WIN64) || !defined(_M_IX86)

	return _byteswap_ulong(uValue);

#else

	_asm{
		mov		eax,uValue
		bswap	eax;				;// Tausche Bytes in EAX
		mov		uValue,eax
		}

	return uValue;

#endif
}

//*****************************************************************************
//*
//*		GetCardNameOfMac
//*
//*****************************************************************************
//	Holt den Namen aus dem Explorer zu einer Netzwerkskarte
static BOOL GetCardNameOfMac(LPCTSTR pOidName,TCHAR *pStr,int iBufferSize)
{
TCHAR			cRegPath[256];
DWORD			dwType;
DWORD			dwSize;
HKEY			hKey;



	if(iBufferSize<=0)return FALSE;



	_tcscpy(cRegPath,_T("SYSTEM\\CurrentControlSet\\Control\\Network\\{4D36E972-E325-11CE-BFC1-08002BE10318}\\"));
	_tcscat(cRegPath,pOidName);
	_tcscat(cRegPath,_T("\\Connection"));

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,cRegPath,0,KEY_READ,&hKey)!=ERROR_SUCCESS)
		{
		pStr[0] = 0;
		return FALSE;
		}


	dwSize = iBufferSize*sizeof(TCHAR)-2;
	dwType = REG_SZ;

	if(RegQueryValueEx(hKey,_T("Name"),0,&dwType,(LPBYTE)pStr,&dwSize)==ERROR_SUCCESS)
		{
		pStr[dwSize/sizeof(TCHAR)]=0;
		}
	else{
		pStr[0]=0;
		}


	RegCloseKey(hKey);



return FALSE;
}

//*****************************************************************************
//*
//*		ReadCardData
//*
//*****************************************************************************
//	List die Daten einer Netzwerkskarte aus der Registry
//	pName	: Ist die GUID der Netzwerkskarte.
//					z.B.: "{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"
//	pData	: Hier werden die Daten der Netzwerkskarte gespeichert.
//	Ergibt 1 wenn ok oder 0 bei einem Fehler.
static int ReadCardData(LPCTSTR	pName,NetCardData *pData)
{
TCHAR		cName[256];
DWORD		uLength;
DWORD		uOffset;
DWORD		uType;
HKEY		hKey;
int			iLen;
int			iRet;



	_tcscpy(cName,_T("System\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces\\"));
	iLen = _tcslen(cName);
	_tcsncpy(cName+iLen,pName,ENTRIES(cName)-iLen-1);

	pData->iDhcp	= 0;
	pData->cNet [0]	= 0;
	pData->cSub [0]	= 0;
	pData->cGate[0]	= 0;
	pData->cName[0]	= 0;


															// ffne Schlssel
	   iRet = RegOpenKeyEx(HKEY_LOCAL_MACHINE,cName,0,KEY_READ,&hKey);
	if(iRet!=ERROR_SUCCESS)
		{
		return 0;
		}


	uLength	= sizeof(pData->iDhcp);
	uType	= REG_DWORD;

	RegQueryValueEx(hKey,_T("EnableDHCP"),0,&uType,(unsigned char*)&pData->iDhcp,&uLength);

	pData->cSub[0] = 0;
	pData->cNet[0] = 0;
	pData->cSub[1] = 0;
	pData->cNet[1] = 0;

	uLength	= ENTRIES(pData->cNet)-2;
	uType	= REG_MULTI_SZ;

	RegQueryValueEx(hKey,_T("IPAddress" ),0,&uType,(unsigned char*)pData->cNet,&uLength);

	pData->cNet[uLength]=0;	uLength++;
	pData->cNet[uLength]=0;	uLength++;

	uLength	= ENTRIES(pData->cSub)-2;
	uType	= REG_MULTI_SZ;

	RegQueryValueEx(hKey,_T("SubnetMask"),0,&uType,(unsigned char*)pData->cSub,&uLength);

	pData->cSub[uLength]=0;	uLength++;
	pData->cSub[uLength]=0;	uLength++;

	uLength	= ENTRIES(pData->cGate)-1;
	uType	= REG_SZ;

	RegQueryValueEx(hKey,_T("DefaultGateway"),0,&uType,(unsigned char*)pData->cGate,&uLength);

	uLength	= ENTRIES(cName)-2;
	uType	= REG_MULTI_SZ;
	cName[0]= 0;
	cName[1]= 0;

	uLength	= ENTRIES(pData->cName)-2;
	uType	= REG_SZ;

	RegQueryValueEx(hKey,_T("NameServer"),0,&uType,(unsigned char*)pData->cName,&uLength);

	pData->cName[uLength]=0;	uLength++;
	pData->cName[uLength]=0;	uLength++;

	for(uOffset=0;uOffset<uLength;uOffset++)
		{
		if(pData->cName[uOffset]!=',')continue;
		pData->cName[uOffset] = 0;
		}

	RegCloseKey(hKey);



return 1;
}

//*****************************************************************************
//*
//*		GetAdapterName
//*
//*****************************************************************************
//	Sucht den Namen einer Netzwerkskarte.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//	pBuffer			: Hier wird der Name gespeichert
//						z.B.: "{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"
//	iSize			: Ist die Namenspuffergre in Zeichen.
//	iNoLock			: Semaphore nicht benutzen
//	Ergibt die Indexnummer der Ethernet Karte, bzw. eine Fehlernummer
//						-1  = Keine Netzwerkskarten gefunden
//						-2  = Keine Netzwerkskarten-Info vorhanden
//						-3  = Die Netzwerkskarte wurde nicht gefunden
static int GetAdapterName(LPCTSTR pInterface,LPTSTR pBuffer,int iSize,int iNoLock=0)
{
DWORD		uIndex;
DWORD		uNum;
int			iRet;
int			iLen;



	if(iInitNet==0)											// Wurde bereits nach Karten gesucht
		{
		NetUpdateCards();
		}


	if(*pInterface>='0' && *pInterface<='9')				// Ist der Name ein Index
		{
		uIndex = _ttoi(pInterface);
		for(iLen=0;pInterface[iLen];iLen++)
			{
			if(pInterface[iLen]<'0')break;
			if(pInterface[iLen]>'9')break;
			}

		if(pInterface[iLen])uIndex=0x12345678;
		}
	else{
		uIndex = 0x12345678;

		if(pInterface[0]=='\\' && pInterface[1]=='\\')		// "//./" berspringen
		if(pInterface[2]=='.'  && pInterface[3]=='\\')
			{
			pInterface += 4;
			}
		}


	if(uCardCnt==0)return iCardErr;

	if(!iNoLock)SemLock(hCardSem);

	for(uNum=0;uNum<uCardCnt;uNum++)						// Suche die Karte
		{
		if(pCardInfos[uNum].uIndex==uIndex)break;
		if(!_tcsicmp(pInterface,pCardInfos[uNum].cMac       ))break;
		if(!_tcsicmp(pInterface,pCardInfos[uNum].cName      ))break;
		if(!_tcsicmp(pInterface,pCardInfos[uNum].cDesciption))break;
		}


	if(uNum>=uCardCnt)										// Interface wurde nicht gefunden
		{
		if(!iNoLock)SemUnlock(hCardSem);
		return -3;
		}


	if(pBuffer && iSize>0)									// Den GUID Namen speichern
		{
		_tcsncpy(pBuffer,pCardInfos[uNum].cName,iSize);
		pBuffer[iSize-1]=0;
		}

	iRet = pCardInfos[uNum].uIndex;

	if(!iNoLock)SemUnlock(hCardSem);


return iRet;
}

//*****************************************************************************
//*
//*		SortCards
//*
//*****************************************************************************
//	Sortierfunktion fr Karten
static int _cdecl SortCards(const void *pPtr1,const void *pPtr2)
{
NetCardInfo	   *pCard1=(NetCardInfo*)pPtr1;
NetCardInfo	   *pCard2=(NetCardInfo*)pPtr2;
int				iOff1;
int				iOff2;


	for(iOff1=0;;iOff1++)
		{
		if(pCard1->cDesciption[iOff1  ]==0){iOff1=0;break;}
		if(pCard1->cDesciption[iOff1  ]!='V')
		if(pCard1->cDesciption[iOff1  ]!='v')continue;
		if(pCard1->cDesciption[iOff1+1]!='M')
		if(pCard1->cDesciption[iOff1+1]!='m')continue;

		if(!_tcsnicmp(pCard1->cDesciption+iOff1,"VMware",6))break;
		}

	for(iOff2=0;;iOff2++)
		{
		if(pCard2->cDesciption[iOff2  ]==0){iOff2=0;break;}
		if(pCard2->cDesciption[iOff2  ]!='V')
		if(pCard2->cDesciption[iOff2  ]!='v')continue;
		if(pCard2->cDesciption[iOff2+2]!='M')
		if(pCard2->cDesciption[iOff2+2]!='m')continue;

		if(!_tcsnicmp(pCard2->cDesciption+iOff2,"VMware",6))break;
		}

	if(iOff1!=iOff2)return iOff1-iOff2;

	for(iOff1=0;;iOff1++)
		{
		if(pCard1->cDesciption[iOff1  ]==0){iOff1=0;break;}
		if(pCard1->cDesciption[iOff1  ]!='L')
		if(pCard1->cDesciption[iOff1  ]!='l')continue;
		if(pCard1->cDesciption[iOff1+1]!='O')
		if(pCard1->cDesciption[iOff1+1]!='o')continue;

		if(!_tcsnicmp(pCard1->cDesciption+iOff1,"Loopback",8))break;
		}

	for(iOff2=0;;iOff2++)
		{
		if(pCard2->cDesciption[iOff2  ]==0){iOff2=0;break;}
		if(pCard2->cDesciption[iOff2  ]!='L')
		if(pCard2->cDesciption[iOff2  ]!='l')continue;
		if(pCard2->cDesciption[iOff2+2]!='O')
		if(pCard2->cDesciption[iOff2+2]!='o')continue;

		if(!_tcsnicmp(pCard2->cDesciption+iOff2,"Loopback",8))break;
		}


	if(iOff1!=iOff2)return iOff1-iOff2;



return _tcsicmp(pCard1->cDesciption,pCard2->cDesciption);
}

//*****************************************************************************
//*
//*		CheckIpAddess
//*
//*****************************************************************************
//	Prft ob eine IP-Adresse richtig ist
//	pAddr		: Ist die IP-Adresse (z.B. "192.168.0.1")
//	pIp			: Hier wird der Wert der IP-Adresse gespeichert.
//	Ergibt 1 wenn ok, ansonsten 0
static int CheckIpAddess(LPCTSTR pAddr,void *pIp=0)
{
char	cEnd;
int		iPos;
int		iVal;
int		iIp;


	if(pIp)*(int*)pIp=0;

	if(!pAddr)return 0;

	iIp = 0;

	for(iPos=0;iPos<4;iPos++)
		{
		if(*pAddr<'0' || *pAddr>'9')return 0;
		iVal = _ttoi(pAddr);
		if(iVal>255)return 0;
		while(*pAddr>='0' && *pAddr<='9')pAddr++;

		cEnd = (iPos==3)? 0:'.';

		if(*pAddr!=cEnd)return 0;

		iIp |= iVal<<(8*iPos);

		pAddr++;
		}


	if(pIp)*(int*)pIp=iIp;


return 1;
}


//*****************************************************************************
//*
//*		IpToIndex
//*
//*****************************************************************************
//	Sucht die Netzwerkskarte zu einer IP-Adresse
//	uAddr		: Ist die IP-Adresse
//	Ergibt den Index der Karte bzw. -1 bei einem Fehler
static int IpToIndex(unsigned uAddr)
{
MIB_IPADDRTABLE    *pTable;
ULONG				uSize;
DWORD				uNum;
int					iRet;



	uSize	= 0;
	pTable	= (MIB_IPADDRTABLE*)new char[8];
	iRet	= GetIpAddrTable(pTable,&uSize,0);				// IP-Tabelle holen

	if(iRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IPADDRTABLE*)new char[uSize];
		iRet	= GetIpAddrTable(pTable,&uSize,0);
		}

	if(iRet!=NO_ERROR)
		{
		delete pTable;
		return -1;
		}

	iRet = -1;

	for(uNum=pTable->dwNumEntries;uNum>0;)					// Adresse suchen
		{
		uNum--;
		if(pTable->table[uNum].dwAddr!=uAddr)continue;
		iRet = pTable->table[uNum].dwIndex;
		}

	delete pTable;



return iRet;
}

//*****************************************************************************
//*
//*		NetCheckIpAddress
//*
//*****************************************************************************
//	Prft eine IP-Adresse
//	pIpAddr		: Zeiger auf die IP-Adresse
//	uIsMask		: Ist die IP-Adresse eine SubNet-Maske
//	Ergibt die IP-Adresse oder 0xFFFFFFFF bei einem Fehler
unsigned NetCheckIpAddress(LPCTSTR  pIpAddr,unsigned uIsMask)
{
DWORD		uAddr;
DWORD		uMask;


	if(!CheckIpAddess(pIpAddr,&uAddr))
		{
		return 0xFFFFFFFF;
		}

	if(uIsMask)
		{
		uMask = BtoL(uAddr);
		while(uMask&0x80000000)uMask<<=1;
		if(uMask)return 0xFFFFFFFF;
		}


return uAddr;
}

//*****************************************************************************
//*
//*		NetGetSubNet
//*
//*****************************************************************************
//	Sucht die Subnet-Maske zu einer IP-Adresse
//	uAddr		: Ist die IP-Adresse
//	Ergibt die Subnet-Maske bzw. 0xFFFFFFFF bei einem Fehler.
unsigned NetGetSubNet(unsigned uAddr)
{
MIB_IPADDRTABLE    *pTable;
ULONG				uSize;
DWORD				uNum;
DWORD				uRet;


	if(!uAddr)return 0xFFFFFFFF;

	uSize	= 256;
	pTable	= (MIB_IPADDRTABLE*)new char[uSize];
	uRet	= GetIpAddrTable(pTable,&uSize,0);				// IP-Tabelle holen

	if(uRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IPADDRTABLE*)new char[uSize];
		uRet	= GetIpAddrTable(pTable,&uSize,0);
		}

	if(uRet!=NO_ERROR)
		{
		delete pTable;
		return 0xFFFFFFFF;
		}

	uRet = 0xFFFFFFFF;

	for(uNum=pTable->dwNumEntries;uNum>0;)					// Adresse lschen
		{
		uNum--;
		if(pTable->table[uNum].dwAddr!=uAddr)continue;
		uRet = pTable->table[uNum].dwMask;
		}

	delete pTable;



return uRet;
}

//*****************************************************************************
//*
//*		NetSetIpDefault
//*
//*****************************************************************************
//	Stellt die standart IP-Adresse aus der Registry ein.
//	pInterface		: Ist der Interface-Name
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//	Ergibt 0 wenn ok, bzw. eine Fehlernummer
//						1 = Keine Netzwerkskarten gefunden
//						2 = Keine Netzwerkskarten-Info vorhanden
//						3 = Die Netzwerkskarte wurde nicht gefunden
//						4 = Falsches Format der IP-Addresse
//						5 = Falsches Format der SubNet-Maske
//						6 = Die Adresse existiert bereits (z.B. auf anderer Schnittstelle)
//						7 = Kein Zugriff auf Registry
//						8 = Kein Kabel in der Netzwerkskarte
//						9 = Die Adresse konnte nicht gesetzt werden
int NetSetIpDefault(LPCTSTR  pInterface)
{
TCHAR				cName[128];
NetCardData			sData;
int					iOff1;
int					iOff2;
int					iLen1;
int					iLen2;
int					iRet;


	   iRet = GetAdapterName(pInterface,cName,ENTRIES(cName));
	if(iRet<0)												// Karte nicht gefunden
		{
		return -iRet;
		}


	if(!ReadCardData(cName,&sData))							// Daten aus der Registry lesen
		{
		return 7;
		}


	iOff1 = 0;
	iOff2 = 0;

	for(;;)													// Alle IP-Addressen aus der Registry setzen
		{
		iLen1 = _tcslen(sData.cNet+iOff1)+1;
		iLen2 = _tcslen(sData.cSub+iOff2)+1;

		if(iLen1<=1)break;
		if(iLen2<=1)break;


		   iRet = NetSetIpAddress(pInterface,sData.cNet+iOff1,sData.cSub+iOff2,(iOff1)? 0x00:0x01);
		if(iRet)return iRet;

		iOff1 += iLen1;
		iOff2 += iLen2;
		}



return 0;
}


//*****************************************************************************
//*
//*		NetSetIpAddress
//*
//*****************************************************************************
//	Stellt die IP-Adresse einer Ethernet Karte ein.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//	pIpAddr			: Ist die neue IP-Adresse "192.169.0.111" oder "DHCP"
//	pSubNet			: Ist die SubNet-Maske, ignoriert bei DHCP
//	uFlags			: Bestimmt die Arte des Einfgens
//						Bit0 = Andere Adressen lschen
//						Bit1 = Premanent einrichten
//	Ergibt 0 wenn ok, bzw. eine Fehlernummer
//						1 = Keine Netzwerkskarten gefunden
//						2 = Keine Netzwerkskarten-Info vorhanden
//						3 = Die Netzwerkskarte wurde nicht gefunden
//						4 = Falsches Format der IP-Addresse
//						5 = Falsches Format der SubNet-Maske
//						6 = Die Adresse existiert bereits (z.B. auf anderer Schnittstelle)
//						7 = Kein Zugriff auf Registry
//						8 = Kein Kabel in der Netzwerkskarte
//						9 = Die Adresse konnte nicht gesetzt werden
int NetSetIpAddress(LPCTSTR pInterface,LPCTSTR pIpAddr,LPCTSTR pSubNet,DWORD uFlags)
{
MIB_IPADDRTABLE		   *pTable;
IP_ADAPTER_INDEX_MAP	sMap;
NetCardData				sData;
TCHAR					cName[128];
ULONG					uInstance;
ULONG					uContext;
ULONG					uIndex;
ULONG					uSize;
DWORD					uAddr;
DWORD					uMask;
DWORD					uVal;
DWORD					uNum;
int						iDhcp;
int						iOff1;
int						iOff2;
int						iLen1;
int						iLen2;
int						iPos;
int						iRet;


	if(!_tcsicmp(pIpAddr,_T("DHCP")))							// IP-Adresse prfen
		{
		iDhcp = 1;
		uAddr = 0;
		uMask = 0;
		}
	else{
		if(!CheckIpAddess(pIpAddr,&uAddr) || uAddr==0)
			{
			return 4;
			}

		if(!CheckIpAddess(pSubNet,&uMask))
			{
			return 5;
			}

		uVal = BtoL(uMask);
		while(uVal&0x80000000)uVal<<=1;
		if(uVal)return 5;

		iDhcp = 0;
		}


	   iRet = GetAdapterName(pInterface,cName,ENTRIES(cName));
	if(iRet<0)												// Karte nicht gefunden
		{
		return -iRet;
		}

	uIndex = iRet;


//******************** Registry einstellen ************************************


	if(uFlags&2)											// Permanent setzen
		{
		if(iDhcp)											// DHCP Server verwenden
			{
			SemLock(hCardSem);

			iRet = 3;

			for(uVal=0;uVal<uCardCnt;uVal++)				// Neue Adressen setzen
				{
				if(pCardInfos[uVal].uIndex!=uIndex)continue;
				iRet = WmiEnableDhcp(pCardInfos[uVal].cMac);
				break;
				}

			SemUnlock(hCardSem);

			return iRet;
			}
		else{
			if(!ReadCardData(cName,&sData))					// Daten aus der Registry lesen
				{
				return 7;
				}

			iOff1 = 0;
			iOff2 = 0;

			if(!(uFlags&0x01))								// Doppelte Adressen suchen
				{
				for(;;)
					{
					iLen1 = _tcslen(sData.cNet+iOff1)+1;
					iLen2 = _tcslen(sData.cSub+iOff2)+1;

					if(iLen1<=1)break;
					if(iLen2<=1)break;

					if(!_tcscmp(sData.cNet+iOff1,_T("0.0.0.0")))
						{
						memmove(sData.cNet+iOff1,sData.cNet+iOff1+iLen1,ENTRIES(sData.cNet)-iOff1-iLen1);
						memmove(sData.cSub+iOff2,sData.cSub+iOff2+iLen2,ENTRIES(sData.cSub)-iOff2-iLen2);
						continue;
						}

					if(!_tcscmp(sData.cNet+iOff1,pIpAddr))
						{
						memmove(sData.cNet+iOff1,sData.cNet+iOff1+iLen1,ENTRIES(sData.cNet)-iOff1-iLen1);
						memmove(sData.cSub+iOff2,sData.cSub+iOff2+iLen2,ENTRIES(sData.cSub)-iOff2-iLen2);
						continue;
						}

					iOff1 += iLen1;
					iOff2 += iLen2;
					}
				}

			_tcscpy(sData.cNet+iOff1,pIpAddr);
			_tcscpy(sData.cSub+iOff2,pSubNet);
			iOff1 += _tcslen(sData.cNet+iOff1)+1;
			iOff2 += _tcslen(sData.cSub+iOff2)+1;


			sData.cNet[iOff1+0] = 0;
			sData.cNet[iOff1+1] = 0;
			sData.cSub[iOff2+0] = 0;
			sData.cSub[iOff2+1] = 0;

			SemLock(hCardSem);

			iRet = 3;

			for(uVal=0;uVal<uCardCnt;uVal++)				// Neue Adressen setzen
				{
				if(pCardInfos[uVal].uIndex!=uIndex)continue;
				iRet  = WmiSetIpAdresses(pCardInfos[uVal].cMac,sData.cNet,sData.cSub);
				break;
				}


			SemUnlock(hCardSem);

			return iRet;
			}
		}


//******************** Adresse setzen *****************************************


	uSize	= 0;
	pTable	= (MIB_IPADDRTABLE*)new char[8];
	iRet	= GetIpAddrTable(pTable,&uSize,0);				// IP-Tabelle holen

	if(iRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IPADDRTABLE*)new char[uSize];
		iRet	= GetIpAddrTable(pTable,&uSize,0);
		}

	if(iRet!=NO_ERROR)
		{
		delete pTable;
		return 2;
		}



	if(uFlags&0x01)											// Andere Adressen lschen
		{
		for(uNum=pTable->dwNumEntries;uNum>0;)
			{
			uNum--;
			if(pTable->table[uNum].dwIndex!=uIndex)continue;
			if(pTable->table[uNum].dwAddr==uAddr)
			if(pTable->table[uNum].dwMask==uMask)continue;
			DeleteIPAddress(pTable->table[uNum].wContext);
			}
		}

	if(iDhcp)												// Soll die Adresse ber DHCP kommen
		{
		sMap.Index	= uIndex;

		for(iPos=0;iPos<MAX_ADAPTER_NAME-1;iPos++)
			{
			if(!cName[iPos])break;
			sMap.Name[iPos] = (XCHAR)cName[iPos];
			}

		sMap.Name[iPos] = 0;

		IpRenewAddress(&sMap);
		}
	else{
		for(uNum=pTable->dwNumEntries;uNum>0;)				// Existiert die Addresse bereits
			{
			uNum--;
			if(pTable->table[uNum].dwIndex!=uIndex)continue;
			if(pTable->table[uNum].dwAddr !=uAddr )continue;

			if(pTable->table[uNum].dwMask==uMask)
				{
				delete pTable;
				return 0;
				}

			DeleteIPAddress(pTable->table[uNum].wContext);	// Adressen mit anderer Subnetmaske lschen
			}

		uContext	= 0;
		uInstance	= 0;
															// Neue Adresse einfgen
		   iRet = AddIPAddress(uAddr,uMask,uIndex,&uContext,&uInstance);
		if(iRet!=NO_ERROR)
			{
			delete pTable;

			if(iRet==ERROR_DUP_NAME)return 6;
			if(iRet==ERROR_GEN_FAILURE)
			if(NetGetConnectStatus(pInterface)==0)
				{
				if(uFlags&0x02)return 0;
				return 8;
				}

			SetLastError(iRet);

			return 9;
			}
		}


	delete pTable;



return 0;
}

//*****************************************************************************
//*
//*		NetDelIpAddress
//*
//*****************************************************************************
//	Lscht eine IP-Adresse einer Ethernet Karte.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//						"all"										IP auf allen lschen
//	pIpAddr			: Ist die neue IP-Adresse "192.169.0.111"
//	uFlags			: Bestimmt die Arte des Einfgens
//						Bit1 = Premanent lschen
//	Ergibt 0 wenn ok, bzw. eine Fehlernummer
//						1  = Keine Netzwerkskarten gefunden
//						2  = Keine Netzwerkskarten-Info vorhanden
//						3  = Die Netzwerkskarte wurde nicht gefunden
//						4  = Falsches Format der IP-Addresse
//						7  = Kein Zugriff auf Registry
//						8  = Kein Kabel in der Netzwerkskarte
//						10 = Die Adresse konnte nicht gefunden werden
//						11 = Die Adresse konnte nicht gelscht werden
int NetDelIpAddress(LPCTSTR pInterface,LPCTSTR pIpAddr,DWORD uFlags)
{
TCHAR				cName[128];
LPCTSTR				pName;
NetCardData			sData;
NetCardInfo		   *pInfo;
MIB_IPADDRTABLE    *pTable;
ULONG				uIndex;
ULONG				uSize;
DWORD				uAddr;
DWORD				uNum;
int					iOff1;
int					iOff2;
int					iLen1;
int					iLen2;
int					iFlag;
int					iAll;
int					iRet;
int					iNum;


	if(!CheckIpAddess(pIpAddr,&uAddr) || uAddr==0) 			// IP-Adresse prfen
		{
		return 4;
		}

	if(_tcscmp(pInterface,_T("all")))
		{
		   iRet = GetAdapterName(pInterface,cName,ENTRIES(cName));
		if(iRet<0)											// Karte nicht gefunden
			{
			return -iRet;
			}

		uIndex   = iRet;
		iAll     = 0;
		}
	else{
		cName[0] = 0;
		uIndex	 = 0;
		iAll     = 1;
		}


	iFlag  = 0;



//******************** Registry einstellen ************************************


	if(uFlags&2)											// Permanent lschen
		{
		if(iAll)
			{
			SemLock(hCardSem);

			iNum	= 0;
			pInfo	= NetGetCardInfo(0);
			pName	= (pInfo)? pInfo->cName:_T("*");
			}
		else{
			iNum	= iRet;
			pName	= cName;
			}

Retry:
		if(!ReadCardData(pName,&sData))
			{
			if(iAll)SemUnlock(hCardSem);
			return 7;
			}

		iOff1 = 0;
		iOff2 = 0;

		for(;;)												// Adresse suchen
			{
			iLen1 = _tcslen(sData.cNet+iOff1)+1;
			iLen2 = _tcslen(sData.cSub+iOff2)+1;

			if(iLen1<=1)break;
			if(iLen2<=1)break;

			if(!_tcscmp(sData.cNet+iOff1,pIpAddr))
				{
				memmove(sData.cNet+iOff1,sData.cNet+iOff1+iLen1,ENTRIES(sData.cNet)-iOff1-iLen1);
				memmove(sData.cSub+iOff2,sData.cSub+iOff2+iLen2,ENTRIES(sData.cSub)-iOff2-iLen2);
				iFlag = 3;
				continue;
				}

			iOff1 += iLen1;
			iOff2 += iLen2;
			}

		if(iFlag&2)
			{
			/* REM AZ ber WMI
			if(!sKey.SetMulti(cNet,_T("IPAddress")))		// Neue Adressen setzen
				{
				return 7;
				}

			if(!sKey.SetMulti(cSub,_T("SubnetMask")))
				{
				return 7;
				}
			*/
			}

		if(iAll)											// Auf allen Karten suchen
			{
			iNum++;
			pInfo	= NetGetCardInfo(iNum);

			if(pInfo)
				{
				pName  = pInfo->cName;
				iFlag &= 1;
				goto Retry;
				}

			SemUnlock(hCardSem);
			}
		}


//******************** Adresse setzen *****************************************


	uSize	= 0;
	pTable	= (MIB_IPADDRTABLE*)new char[8];
	iRet	= GetIpAddrTable(pTable,&uSize,0);				// IP-Tabelle holen

	if(iRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IPADDRTABLE*)new char[uSize];
		iRet	= GetIpAddrTable(pTable,&uSize,0);
		}

	if(iRet!=NO_ERROR)
		{
		delete pTable;
		return 2;
		}


	iFlag = 0;

	for(uNum=pTable->dwNumEntries;uNum>0;)					// Adresse lschen
		{
		uNum--;
		if(iAll==0)
		if(pTable->table[uNum].dwIndex!=uIndex)continue;
		if(pTable->table[uNum].dwAddr !=uAddr )continue;

		iRet = DeleteIPAddress(pTable->table[uNum].wContext);

		if(iRet!=NO_ERROR)
			{
			delete pTable;
			return 11;
			}

		iFlag = 1;
		}


	delete pTable;



return (iFlag)? 0:10;
}

//*****************************************************************************
//*
//*		NetSetGateway
//*
//*****************************************************************************
//	Stellt die Gateway-Adresse einer Ethernet Karte ein.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//	pIpAddr			: Ist die IP-Adresse des Gateways.
//					  Bei 0 oder "" wird die Gateway-Adresse gelscht.
//	Ergibt 0 wenn ok, bzw. eine Fehlernummer
//						1  = Keine Netzwerkskarten gefunden
//						2  = Keine Netzwerkskarten-Info vorhanden
//						3  = Die Netzwerkskarte wurde nicht gefunden
//						4  = Falsches Format der IP-Addresse
//						12 = Kann OLE-Interface nicht initialisieren.
//						13 = Kann WMI-Interface nicht initialisieren.
//						14 = Fehler bei WMI Abfrage.
int NetSetGateway(LPCTSTR  pInterface,LPCTSTR pIpAddr)
{
unsigned	uIndex;
unsigned	uVal;
int			iRet;



	   iRet = GetAdapterName(pInterface,NULL,0);
	if(iRet<0)												// Karte nicht gefunden
		{
		return -iRet;
		}

	if(pIpAddr && *pIpAddr)									// IP-Adresse prfen
		{
		if(!CheckIpAddess(pIpAddr))
			{
			return 4;
			}
		}

	uIndex = iRet;

	for(uVal=0;uVal<uCardCnt;uVal++)						// Neue Gateway-Adresse setzen
		{
		if(pCardInfos[uVal].uIndex!=uIndex)continue;
		return WmiSetGateway(pCardInfos[uVal].cMac,pIpAddr);
		}


return 3;
}

//*****************************************************************************
//*
//*		NetSetNameServer
//*
//*****************************************************************************
//	Stellt die Name-Server-Adresse einer Ethernet Karte ein.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//	pIpAddr1		: Ist die IP-Adresse des ersten Nameservers.
//					  Bei 0 oder "" werden die Server-Addressen gelscht.
//	pIpAddr2		: Ist die IP-Adresse des zweiten Nameservers.
//					  Bei 0 oder "" wird die Server-Addressen gelscht.
//	Ergibt 0 wenn ok, bzw. eine Fehlernummer
//						1  = Keine Netzwerkskarten gefunden
//						2  = Keine Netzwerkskarten-Info vorhanden
//						3  = Die Netzwerkskarte wurde nicht gefunden
//						4  = Falsches Format der IP-Addresse
//						12 = Kann OLE-Interface nicht initialisieren.
//						13 = Kann WMI-Interface nicht initialisieren.
//						14 = Fehler bei WMI Abfrage.
int NetSetNameServer(LPCTSTR  pInterface,LPCTSTR pIpAddr1,LPCTSTR pIpAddr2)
{
unsigned	uIndex;
unsigned	uVal;
int			iRet;



	   iRet = GetAdapterName(pInterface,NULL,0);
	if(iRet<0)												// Karte nicht gefunden
		{
		return -iRet;
		}

	if(pIpAddr1 && *pIpAddr1)								// IP-Adresse prfen
		{
		if(!CheckIpAddess(pIpAddr1))
			{
			return 4;
			}
		}

	if(pIpAddr2 && *pIpAddr2)								// IP-Adresse prfen
		{
		if(!CheckIpAddess(pIpAddr2))
			{
			return 4;
			}
		}

	uIndex = iRet;

	for(uVal=0;uVal<uCardCnt;uVal++)						// Neue Name-Server-Adressen setzen
		{
		if(pCardInfos[uVal].uIndex!=uIndex)continue;
		return WmiSetNameServer(pCardInfos[uVal].cMac,pIpAddr1,pIpAddr2);
		}


return 3;
}


//*****************************************************************************
//*
//*		NetGetIpAddresses
//*
//*****************************************************************************
//	Holt die IP-Adresse einer Ethernet Karte.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//	pList			: Hier werden IP Adressen und SubNet-Masken gespeichert.
//						[n*2+0] = Addr
//						[n*2+1] = Mask
//						0/0     = DHCP
//	iCount			: Ist die Anzahl der Pltze im Puffer. (immer 2*DWORD)
//	uFlags			: Bestimmt die Arte der Adressen
//						Bit0 = Aktuelle Adressen
//						Bit1 = Premanente aus Registry
//	Ergibt 0 wenn ok, bzw. eine Fehlernummer
//						-1 = Keine Netzwerkskarten gefunden
//						-2 = Keine Netzwerkskarten-Info vorhanden
//						-3 = Die Netzwerkskarte wurde nicht gefunden
//						>0 = Anzahl der gefunden Adressen
//						-7 = Kein Zugriff auf Registry
int NetGetIpAddresses(LPCTSTR  pInterface,DWORD *pList,int iCount,DWORD uFlags)
{
NetCardData			sData;
TCHAR				cName[128];
MIB_IPADDRTABLE    *pTable;
ULONG				uIndex;
ULONG				uSize;
DWORD				uAddr;
DWORD				uMask;
DWORD				uNum;
int					iOff1;
int					iOff2;
int					iLen1;
int					iLen2;
int					iRet;
int					iCnt;
int					iPos;



	   iRet = GetAdapterName(pInterface,cName,ENTRIES(cName));
	if(iRet<0)												// Karte nicht gefunden
		{
		return iRet;
		}

	if(iCount<0)iCount=0;
	uIndex   = iRet;
	iCnt	 = 0;


//******************** Registry einstellen ************************************


	if(uFlags&2)											// Permanent lschen
		{

		if(!ReadCardData(cName,&sData))
			{
			return -7;
			}


		if(sData.iDhcp)										// Ist DHCP eingestellt
			{
			if(iCnt<iCount)
				{
				pList[iCnt*2+0]=0;
				pList[iCnt*2+1]=0;
				}

			iCnt++;
			}
		else{
			iOff1 = 0;
			iOff2 = 0;

			for(;;)											// Adresse suchen
				{
				iLen1 = _tcslen(sData.cNet+iOff1)+1;
				iLen2 = _tcslen(sData.cSub+iOff2)+1;

				if(iLen1<=1)break;
				if(iLen2<=1)break;

				CheckIpAddess(sData.cNet+iOff1,&uAddr);
				CheckIpAddess(sData.cSub+iOff2,&uMask);

				for(iPos=0;iPos<iCnt;iPos++)				// Doppelte suchen
					{
					if(pList[iPos*2+0]==uAddr)
					if(pList[iPos*2+1]==uMask)break;
					}

				if(iPos>=iCnt && iCnt<iCount)				// IP einfgen
					{
					pList[iCnt*2+0] = uAddr;
					pList[iCnt*2+1] = uMask;
					iCnt++;
					}

				iOff1 += iLen1;
				iOff2 += iLen2;
				}
			}
		}


//******************** Aktuelle Adressen holen ********************************


	if(uFlags&0x01)
		{
		uSize	= 0;
		pTable	= (MIB_IPADDRTABLE*)new char[8];
		iRet	= GetIpAddrTable(pTable,&uSize,0);			// IP-Tabelle holen

		if(iRet==ERROR_INSUFFICIENT_BUFFER)
			{
			delete pTable;
			pTable	= (MIB_IPADDRTABLE*)new char[uSize];
			iRet	= GetIpAddrTable(pTable,&uSize,0);
			}

		if(iRet==NO_ERROR)
			{
			for(uNum=pTable->dwNumEntries;uNum>0;)			// Adresse lschen
				{
				uNum--;
				if(pTable->table[uNum].dwIndex!=uIndex)continue;

				uAddr = pTable->table[uNum].dwAddr;
				uMask = pTable->table[uNum].dwMask;

				if(!uAddr)continue;

				for(iPos=0;iPos<iCnt;iPos++)
					{										// Doppelte suchen
					if(pList[iPos*2+0]==uAddr)
					if(pList[iPos*2+1]==uMask)break;
					}

				if(iPos>=iCnt && iCnt<iCount)
					{										// IP einfgen
					pList[iCnt*2+0] = uAddr;
					pList[iCnt*2+1] = uMask;
					iCnt++;
					}
				}
			}

		delete pTable;
		}



return iCnt;
}

//*****************************************************************************
//*
//*		NetIpAddressToText
//*
//*****************************************************************************
unsigned NetIpAddressToText(unsigned uAddr,LPTSTR pText)
{
return _stprintf(pText,_T("%i.%i.%i.%i"),(uAddr>>8*0)&0xFF,(uAddr>>8*1)&0xFF,(uAddr>>8*2)&0xFF,(uAddr>>8*3)&0xFF);
}

//*****************************************************************************
//*
//*		NetTextToIpAddress
//*
//*****************************************************************************
//	Wandel eine IP-Adresse aus einem Text in eine binre Adresse um
//	uAddr		: Hier wird die Adresse gespeichert
//	pText		: Zeiger auf die Adresse ("127.0.0.1"  "127.0.0.1:1234" oder "192.168.0.1/24")
//	pSubNet		: Wenn ungleich 0 wird hier die Subnetmaske gespeichert,
//				  bzw. 0 wenn nicht vorhanden
//	Ergibt 1 wenn die Adresse gltig ist
unsigned NetTextToIpAddress(DWORD &uAddr,LPCTSTR pText,DWORD *pSubNet)
{
unsigned	uAll;
unsigned	uSub;
unsigned	uVal;
unsigned	uNum;


	uAll	= 0;
	uAddr	= 0;

	if(pSubNet)*pSubNet=0;

	for(uSub=0;;uSub+=8)
		{
		for(uVal=0;*pText>='0' && *pText<='9';pText++)
			{
			uVal *= 10;
			uVal += *pText-'0';
			}

		if(uVal>255)return 0;

		uAll |= uVal<<uSub;

		if(uSub == 3*8)break;
		if(*pText!='.')break;

		pText++;
		}


	if(*pText==':')											// Tcp-Port berspringen
		{
		pText++;
		
		while(*pText>='0' && *pText<='9')
			{
			pText++;
			}
		}


	if(*pText=='/')											// Mit Subnetz
		{
		if(pText[1]<'0')return 0;
		if(pText[1]>'9')return 0;

		if(pSubNet)
			{
			uNum = atoi(pText+1);
			if(uNum>0 && uNum<32)
				{
				uVal = ~(0xFFFFFFFF>>uNum);
				*pSubNet  = (uVal>>24)&0x000000FF;
				*pSubNet |= (uVal>> 8)&0x0000FF00;
				*pSubNet |= (uVal<< 8)&0x00FF0000;
				*pSubNet |= (uVal<<24)&0xFF000000;
				}
			}
		}
	else if(*pText!=0)
		{
		return 0;
		}


	uAddr = uAll;



return 1;
}

//*****************************************************************************
//*
//*		NetGetConnectStatus
//*
//*****************************************************************************
//	Holt den Verbindungsstatus einer Netzwerkskarte.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//						"192.168.0.10"								IP
//	Ergibt ob ein Netzwerkskabel in der Ethernetkarte steckt.
//						-1  = Keine Netzwerkskarten gefunden
//						-2  = Keine Netzwerkskarten-Info vorhanden
//						-3  = Die Netzwerkskarte wurde nicht gefunden
//						-4  = Die IP-Adresse wurde nicht gefunden
//						 0  = nicht verbunden
//						 1  = verbunden
//				         2  = unbestimmt
       int NetGetConnectStatus(LPCTSTR pInterface){return NetGetConnectStatus(pInterface,0);}
static int NetGetConnectStatus(LPCTSTR pInterface,int iNoLock)
{
TCHAR				cName[128]=_T("\\\\.\\");
DWORD				dwBytesRet;
DWORD				dwStatus;
DWORD				dwObj;
DWORD				uAddr;
HANDLE				hFile;
int					iRet;
BOOL				bOk;


	if(CheckIpAddess(pInterface,&uAddr) && uAddr==0)		// Wurde eine IP-Addresse angegeben
		{
		   iRet = IpToIndex(uAddr);
		if(iRet<0)return -4;

		_itot(iRet,cName+100,10);
		pInterface= cName+100;
		}


	   iRet = GetAdapterName(pInterface,cName+4,ENTRIES(cName)-4,iNoLock);
	if(iRet<0)												// Karte nicht gefunden
		{
		return iRet;
		}


	   hFile = CreateFile(cName,0,0,NULL,OPEN_EXISTING,0,0);
	if(hFile==INVALID_HANDLE_VALUE)return -1;


	dwObj	= OID_GEN_MEDIA_CONNECT_STATUS;
	bOk		= DeviceIoControl(hFile,IOCTL_NDIS_QUERY_GLOBAL_STATS,&dwObj,sizeof(dwObj),&dwStatus,sizeof(dwStatus),&dwBytesRet,NULL);

	CloseHandle(hFile);

	if(!bOk || dwStatus>1)return 2;


return (dwStatus)? 0:1;
}

//*****************************************************************************
//*
//*		NetGetLinkSpeed
//*
//*****************************************************************************
//	Holt die Verbindungsgeschwindigkeit einer Netzwerkskarte.
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//						"192.168.0.10"								IP
//	Ergibt ob ein Netzwerkskabel in der Ethernetkarte steckt.
//						-1  = Keine Netzwerkskarten gefunden
//						-2  = Keine Netzwerkskarten-Info vorhanden
//						-3  = Die Netzwerkskarte wurde nicht gefunden
//						-4  = Die IP-Adresse wurde nicht gefunden
//						 0  = nicht verbunden
//						>0  = Verbindung in MBit
int NetGetLinkSpeed(LPCTSTR pInterface)
{
MIB_IFTABLE		   *pTable;
TCHAR				cName[16];
DWORD				uIndex;
DWORD				uAddr;
DWORD				uSize;
DWORD				uNum;
int					iRet;



	if(CheckIpAddess(pInterface,&uAddr) && uAddr!=0)		// Wurde eine IP-Addresse angegeben
		{
		   iRet = IpToIndex(uAddr);
		if(iRet<0)return -4;

		_itot(iRet,cName,10);
		pInterface= cName;
		}


	   iRet = GetAdapterName(pInterface,0,0);
	if(iRet<0)												// Karte nicht gefunden
		{
		return iRet;
		}


	uSize	= 0;
	uIndex	= iRet;
	pTable	= (MIB_IFTABLE*)new char[8];
	iRet	= GetIfTable(pTable,&uSize,0);					// Interface-Tabelle holen

	if(iRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IFTABLE*)new char[uSize];
		iRet	= GetIfTable(pTable,&uSize,0);
		}

	if(iRet!=NO_ERROR)
		{
		delete pTable;
		return -1;
		}


	iRet = -3;

	for(uNum=0;uNum<pTable->dwNumEntries;uNum++)			// Suche die Karte
		{
		if(uIndex!=pTable->table[uNum].dwIndex)continue;
		iRet = pTable->table[uNum].dwSpeed/1000000;
		}

	delete pTable;



return iRet;
}


//*****************************************************************************
//*
//*		NetGetPackets
//*
//*****************************************************************************
//	Holt die Anzahl der gesenteten und empfangenen Pakete
//	pInterface		: Ist der Interfacename
//						"00-11-22-33-44-55"							Mac
//						"{CF879B1D-3C21-442E-A353-9E5FC581A2B6}"	GUID
//						"LAN-Verbindung Eth1"						Name
//						"5"											Index
//						"192.168.0.10"								IP
//	uOut			: Hier wird die Anzahl der gesendeten  Pakete gespeichert
//	uInp			: Hier wird die Anzahl der empfangenen Pakete gespeichert
//	uOutByte		: Hier wird die Anzahl der gesendeten  Bytes  gespeichert
//	uInpByte		: Hier wird die Anzahl der empfangenen Bytes  gespeichert
//	Ergibt ob ein Netzwerkskabel in der Ethernetkarte steckt.
//						-1  = Keine Netzwerkskarten gefunden
//						-2  = Keine Netzwerkskarten-Info vorhanden
//						-3  = Die Netzwerkskarte wurde nicht gefunden
//						-4  = Die IP-Adresse wurde nicht gefunden
//						 0  = Pakete wurden geholt
int NetGetPackets(LPCTSTR pInterface,DWORD &uOut,DWORD &uInp,DWORD &uOutByte,DWORD &uInpByte)
{
MIB_IFTABLE		   *pTable;
TCHAR				cName[16];
DWORD				uIndex;
DWORD				uAddr;
DWORD				uSize;
DWORD				uNum;
int					iRet;



	uOut		= 0;
	uInp		= 0;
	uOutByte	= 0;
	uInpByte	= 0;


	if(CheckIpAddess(pInterface,&uAddr) && uAddr!=0)		// Wurde eine IP-Addresse angegeben
		{
		   iRet = IpToIndex(uAddr);
		if(iRet<0)return -4;

		_itot(iRet,cName,10);
		pInterface= cName;
		}


	   iRet = GetAdapterName(pInterface,0,0);
	if(iRet<0)												// Karte nicht gefunden
		{
		return iRet;
		}


	uSize	= 0;
	uIndex	= iRet;
	pTable	= (MIB_IFTABLE*)new char[8];
	iRet	= GetIfTable(pTable,&uSize,0);					// Interface-Tabelle holen

	if(iRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IFTABLE*)new char[uSize];
		iRet	= GetIfTable(pTable,&uSize,0);
		}

	if(iRet!=NO_ERROR)
		{
		delete pTable;
		return -1;
		}


	iRet = -3;

	for(uNum=0;uNum<pTable->dwNumEntries;uNum++)			// Suche die Karte
		{
		if(uIndex!=pTable->table[uNum].dwIndex)continue;
		uOut		= pTable->table[uNum].dwOutUcastPkts+pTable->table[uNum].dwOutNUcastPkts+pTable->table[uNum].dwOutDiscards;
		uInp		= pTable->table[uNum].dwInUcastPkts +pTable->table[uNum].dwInNUcastPkts +pTable->table[uNum].dwInDiscards;
		uOutByte	= pTable->table[uNum].dwOutOctets;
		uInpByte	= pTable->table[uNum].dwInOctets;
		iRet		= 0;
		}

	delete pTable;



return iRet;
}

//*****************************************************************************
//*
//*		NetUpdateCards
//*
//*****************************************************************************
//	Aktualisiert die Karteninformationen
//	Ergibt die anzahl der gefundenen Ethernet-Karten
unsigned NetUpdateCards()
{
MIB_IPADDRTABLE    *pTable;
IP_ADAPTER_INFO	   *pNext;
IP_ADAPTER_INFO	   *pInfo;
DWORD				uIndex;
DWORD				uSize;
DWORD				uAddr;
DWORD				uCard;
UINT				uNum;
int					iRet;
int					iPos;
int					iOff;



	if(!hCardSem)hCardSem=SemInit();

	iInitNet = 1;

	SemLock(hCardSem);


	uSize	= 1024;
	pInfo	= (IP_ADAPTER_INFO*)new char[uSize];
	iRet	= GetAdaptersInfo(pInfo,&uSize);

	if(iRet==ERROR_BUFFER_OVERFLOW)							// Zu wenig Speicher
		{
		delete pInfo;
		pInfo	= (IP_ADAPTER_INFO*)new char[uSize];
		iRet	= GetAdaptersInfo(pInfo,&uSize);
		}

	if(iRet!=ERROR_SUCCESS)									// Keine Netzwerkskarten gefunden
		{
		if(iRet==ERROR_NO_DATA || iRet==ERROR_NOT_SUPPORTED)
				iCardErr = -1;
		else	iCardErr = -2;

		uCardCnt = 0;
		SemUnlock(hCardSem);
		delete pInfo;
		return -2;
		}


	pNext = pInfo;

	for(uNum=0;pNext;)										// Zhle die Netzwerkskarten
		{
		if(pNext->Type==MIB_IF_TYPE_ETHERNET)
			{
			uNum++;
			}

		pNext = pNext->Next;
		}



	if(pCardInfos)delete pCardInfos;

	pCardInfos = new NetCardInfo[uNum];
	iCardErr   = (uNum==0)? -3:0;
	uCardCnt   = uNum;
	pNext	   = pInfo;


	for(uNum=0;pNext;)										// Infos speichern
		{
		if(pNext->Type==MIB_IF_TYPE_ETHERNET)
			{
			memset(pCardInfos+uNum,0,sizeof(NetCardInfo));

			pCardInfos[uNum].uIndex = pNext->Index;
			pCardInfos[uNum].uDhcp  = pNext->DhcpEnabled;

			for(iPos=0;iPos<ENTRIES(pCardInfos[uNum].cDesciption)-1;iPos++)
				{
				if(!pNext->Description[iPos])break;
				pCardInfos[uNum].cDesciption[iPos] = (BYTE)pNext->Description[iPos];
				}

			pCardInfos[uNum].cDesciption[iPos] = 0;


			for(iPos=0;iPos<ENTRIES(pCardInfos[uNum].cName)-1;iPos++)
				{
				if(!pNext->AdapterName[iPos])break;
				pCardInfos[uNum].cName[iPos] = (BYTE)pNext->AdapterName[iPos];
				}

			pCardInfos[uNum].cName[iPos] = 0;

			for(iPos=0;iPos<ENTRIES(pCardInfos[uNum].cGateway)-1;iPos++)
				{
				if(!pNext->GatewayList.IpAddress.String[iPos])break;
				pCardInfos[uNum].cGateway[iPos] = (BYTE)pNext->GatewayList.IpAddress.String[iPos];
				}

			pCardInfos[uNum].cGateway[iPos] = 0;

			if(iPos>0)
				{
				CheckIpAddess(pCardInfos[uNum].cGateway,&pCardInfos[uNum].uGate);
				}


			if(pNext->AddressLength==6)
				{
				_stprintf(pCardInfos[uNum].cMac,_T("%02X-%02X-%02X-%02X-%02X-%02X"),
							pNext->Address[0],
							pNext->Address[1],
							pNext->Address[2],
							pNext->Address[3],
							pNext->Address[4],
							pNext->Address[5]);

				memcpy(pCardInfos[uNum].aMac,pNext->Address,6);
				}

			uNum++;
			}

		pNext = pNext->Next;
		}


	if(uCardCnt>=2)											// Sortiere die Karten
		{
		qsort(pCardInfos,uCardCnt,sizeof(NetCardInfo),SortCards);
		}


	uSize	= 0;
	pTable	= (MIB_IPADDRTABLE*)new char[8];
	iRet	= GetIpAddrTable(pTable,&uSize,0);				// IP-Tabelle holen

	if(iRet==ERROR_INSUFFICIENT_BUFFER)
		{
		delete pTable;
		pTable	= (MIB_IPADDRTABLE*)new char[uSize];
		iRet	= GetIpAddrTable(pTable,&uSize,0);
		}

	if(iRet==NO_ERROR)
		{
		NetCardData	sData;


		for(uNum=pTable->dwNumEntries;uNum>0;)				// Adresse suchen
			{
			uNum--;
			uAddr = pTable->table[uNum].dwAddr;
			if(uAddr==0)continue;

			uIndex = pTable->table[uNum].dwIndex;

			for(uCard=0;uCard<uCardCnt;uCard++)				// Karte zu IP
				{
				if(uIndex!=pCardInfos[uCard].uIndex)continue;

				   pCardInfos[uCard].uIpCount++;
				if(pCardInfos[uCard].uIpCount>1)continue;

				NetIpAddressToText(uAddr,pCardInfos[uCard].cFirstIp);

				pCardInfos[uCard].uAddr = uAddr;
				}

			iRet = pTable->table[uNum].dwIndex;
			}


		for(uCard=0;uCard<uCardCnt;uCard++)					// IP's aus der Registry holen
			{
			if(ReadCardData(pCardInfos[uCard].cName,&sData))
				{
				if(pCardInfos[uCard].cFirstIp[0]==0)
				if(CheckIpAddess(sData.cNet,&pCardInfos[uCard].uAddr) && pCardInfos[uCard].uAddr)
					{
					_tcsncpy(pCardInfos[uCard].cFirstIp,sData.cNet,ENTRIES(pCardInfos[uCard].cFirstIp)-1);
					pCardInfos[uCard].uIpCount++;
					}

				if(sData.cName[0])
					{
					_tcsncpy(pCardInfos[uCard].cNameSrv1,sData.cName,sizeof(pCardInfos[uCard].cNameSrv1)-1);
					CheckIpAddess(pCardInfos[uCard].cNameSrv1,&pCardInfos[uCard].uNameSrv1);

					iOff = _tcslen(sData.cName)+1;

					if(sData.cName[iOff+1])
						{
						_tcsncpy(pCardInfos[uCard].cNameSrv2,sData.cName+iOff+1,sizeof(pCardInfos[uCard].cNameSrv2)-1);
						CheckIpAddess(pCardInfos[uCard].cNameSrv2,&pCardInfos[uCard].uNameSrv2);
						}
					}

				}

			if(!_tcsicmp(pCardInfos[uCard].cMac,_T("02-00-4C-4F-4F-50")))
				{
				_tcscpy(pCardInfos[uCard].cFirstIp,_T("127.0.0.1"));
				CheckIpAddess(_T("127.0.0.1"),&pCardInfos[uCard].uAddr);
				}

			GetCardNameOfMac(pCardInfos[uCard].cName,pCardInfos[uCard].cInfoName,sizeof(pCardInfos[uCard].cInfoName)/sizeof(TCHAR));
			}
		}

	delete pTable;
	delete pInfo;

	SemUnlock(hCardSem);



return uCardCnt;
}


//*****************************************************************************
//*
//*		NetGetCardInfo
//*
//*****************************************************************************
//	Ethernet-Karteninfos abfragen
//	uCard		: Ist die Kartennummer
//	Ergibt einen Zeiger auf die Infos oder 0 bei einem Fehler
NetCardInfo *NetGetCardInfo(unsigned uCard)
{

	if(uCard>=uCardCnt)return NULL;


return pCardInfos+uCard;
}


//*****************************************************************************
//*
//*		NetExit
//*
//*****************************************************************************
//	Alle Speicher der Netzwerkschnittstelle wieder freigeben
void NetExit()
{

	if(iInitCnt>0)
		{
		iInitCnt--;
		if(iInitCnt)return;
		}

	if(iInitOle)
		{
		CoUninitialize();
		iInitOle = 0;
		}


	if(hCardSem)
		{
		SemLock(hCardSem);

		iInitNet = 0;
		uCardCnt = 0;

		if(pCardInfos)
			{
			delete pCardInfos;
			pCardInfos = 0;
			}

		SemUnlock(hCardSem);
		}
}


//*****************************************************************************
//*
//*		NetInit
//*
//*****************************************************************************
//	Inizialisiert die Netzwerkschnittstelle.
void NetInit()
{

	if(!hCardSem)
		{
		hCardSem=SemInit();
		}

	iInitCnt++;

}



//*****************************************************************************
//*
//*		WmiSetIpAdresses
//*
//*****************************************************************************
//	Stellt die fixen IP-Adressen ber das WMI Interface ein
//	pMac		: Ist die MAC-Addresse der Netzwerkskarte.
//					z.B. "00-11-22-33-44-55"
//	pAddr		: Ist die Liste mit den IP-Adressen
//	pMask		: Ist die Liste mit den Subnetmasken
//	iDepth		: Ist die Aufruftiefe
//	Ergibt 0 wenn die Adressen gesetzt wurden, oder eine Fehlernummer
//						 3 = Die Netzwerkskarte wurde nicht gefunden.
//						 4 = Falsches Format der IP-Addresse
//						 5 = Falsches Format der SubNet-Maske
//						 9 = Die Adresse konnte nicht gesetzt werden
//						12 = Kann OLE-Interface nicht initialisieren.
//						13 = Kann WMI-Interface nicht initialisieren.
//						14 = Fehler bei WMI Abfrage.
static int WmiSetIpAdresses(LPCTSTR pMac,LPCTSTR pAddr,LPCTSTR pMask,int iDepth)
{
IEnumWbemClassObject   *pEnumerator = NULL;
IWbemServices		   *pServices   = NULL;
IWbemLocator		   *pLocator    = NULL;
IWbemClassObject	   *pOutInst	= NULL;
IWbemClassObject       *pObject		= NULL;
IWbemClassObject	   *pParams     = NULL;
IWbemClassObject	   *pClass      = NULL;
IWbemClassObject	   *pCall       = NULL;
SAFEARRAY			   *pAddrList	= NULL;
SAFEARRAY			   *pMaskList	= NULL;
VARIANT					sArgAddr;
VARIANT					sArgMask;
BSTR					pAddrSys[64];
BSTR					pMaskSys[64];
WCHAR					cText[256];
ULONG					uReturn;
LONG					lIdx;
HRESULT					lRes;
int						iPos;
int						iLen;
int						iOff;
int						iNum;
int						iErr;



	LOG_WMI3("WmiSetIpAdresses(\"%s\",\"%s\",\"%s\")\n",pMac,pAddr,pMask);

	iErr = -1;

	if(!iInitOle)												// OLE Initialisieren
		{
		lRes =	CoInitializeEx(0, COINIT_MULTITHREADED);

		if(FAILED(lRes))
			{
			return 1;											// Program has failed.
			}
																// Set general COM security levels

		lRes =	CoInitializeSecurity(NULL,
								-1,								// COM authentication
							 	NULL,							// Authentication services
							 	NULL,							// Reserved
							 	RPC_C_AUTHN_LEVEL_DEFAULT, 		// Default authentication
							 	RPC_C_IMP_LEVEL_IMPERSONATE,	// Default Impersonation
							 	NULL,							// Authentication info
							 	EOAC_NONE, 						// Additional capabilities
							 	NULL);							// Reserved



		if(FAILED(lRes))
			{
			CoUninitialize();
			return 1;											// Program has failed.
			}

		iInitOle = 1;
		}

	iNum = 0;
	lRes = CoCreateInstance(CLSID_WbemLocator_,0,CLSCTX_INPROC_SERVER,IID_IWbemLocator_,(LPVOID*)&pLocator);

	if(FAILED(lRes))
		{
		return 13;
		}

																// Connect to WMI through the IWbemLocator::ConnectServer
	lRes = pLocator->ConnectServer(_bstr_t(L"ROOT\\CIMV2"), 	// Object path of WMI namespace
								NULL,							// User name. NULL = current user
						   		NULL,							// User password. NULL = current
						   		0,								// Locale. NULL indicates current
						   		NULL,							// Security flags.
						   		0,								// Authority (e.g. Kerberos)
						   		0,								// Context object
						   		&pServices);					// Pointer to IWbemServices proxy


	if(FAILED(lRes))
		{
		pLocator->Release();
		return 13;
		}


	lRes = CoSetProxyBlanket(pServices,							// Indicates the proxy to set
							 RPC_C_AUTHN_WINNT, 				// RPC_C_AUTHN_xxx
							 RPC_C_AUTHZ_NONE,					// RPC_C_AUTHZ_xxx
							 NULL,								// Server principal name
							 RPC_C_AUTHN_LEVEL_CALL,			// RPC_C_AUTHN_LEVEL_xxx
							 RPC_C_IMP_LEVEL_IMPERSONATE,		// RPC_C_IMP_LEVEL_xxx
							 NULL,								// Client identity
							 EOAC_NONE);						// Proxy capabilities

	if(FAILED(lRes))
		{
		pServices->Release();
		pLocator ->Release();
		return 1;
		}
																// Grab class required to work on Win32_NetworkAdapterConfiguration

	lRes = pServices->GetObject(L"Win32_NetworkAdapterConfiguration",0,NULL,&pClass,NULL);

	if(lRes!=WBEM_S_NO_ERROR)
		{
		pServices->Release();
		pLocator ->Release();
		return 13;
		}


//******************** Suche die Karte ****************************************
unsigned	uIndex;
_variant_t	sVarVal;
_bstr_t		sStr;


	wcscpy(cText,L"SELECT * FROM Win32_NetworkAdapterConfiguration WHERE MACAddress = '");
	iOff = wcslen(cText);

	for(iLen=0;iLen<20;iLen++)
		{
		if(!pMac[iLen])break;

		if(pMac[iLen]=='-')
			{
			cText[iOff+iLen] = ':';
			}
		else if(pMac[iLen]>='a' && pMac[iLen]<='z')
			{
			cText[iOff+iLen] = pMac[iLen]-32;
			}
		else{
			cText[iOff+iLen] = pMac[iLen];
			}
		}

	wcscpy(cText+iOff+iLen,L"'");

	LOG_WMI1("      ExecQuery: \"%S\"\n",cText);

																// Suche die Karte via MAC
	   lRes = pServices->ExecQuery(L"WQL",cText,WBEM_FLAG_FORWARD_ONLY|WBEM_FLAG_RETURN_IMMEDIATELY,NULL,&pEnumerator);
	if(lRes!=WBEM_S_NO_ERROR || !pEnumerator)
		{
		uReturn = 13;
		goto Exit;
		}


	   lRes = pEnumerator->Next(WBEM_INFINITE,1,&pObject,&uReturn);
	if(lRes || uReturn==0)
		{
		uReturn = 3;
		goto Exit;
		}


	   lRes = pObject->Get(L"Index",0,&sVarVal,0,0);
	if(lRes)
		{
		uReturn = 14;
		goto Exit;
		}

	sStr	= sVarVal;
	uIndex  = _wtoi(sStr);
	VariantClear(&sVarVal);



//******************** Addressen setzen ***************************************
BSTR		pResult;
int			iOff1;
int			iOff2;
int			iLen1;
int			iLen2;



	iOff1 = 0;
	iOff2 = 0;
	iErr  = 9;

	for(iNum=0;iNum<64;iNum++)									// Zhle die IP-Adressen
		{
		iLen1 = _tcslen(pAddr+iOff1)+1;
		iLen2 = _tcslen(pMask+iOff2)+1;

		if(iLen1<=1 || iLen2<=1)break;

		iOff1 += iLen1;
		iOff2 += iLen2;
		}


	if(iNum<=0)
		{
		uReturn = 15;
		goto Exit;
		}


	pAddrList = SafeArrayCreateVector(VT_BSTR,0,iNum);
	pMaskList = SafeArrayCreateVector(VT_BSTR,0,iNum);


	iOff1 = 0;
	iOff2 = 0;

	for(lIdx=0;lIdx<iNum;lIdx++)								// IP-Listen erzeugen
		{
		iLen1 = _tcslen(pAddr+iOff1)+1;
		iLen2 = _tcslen(pMask+iOff2)+1;

		for(iOff=0;iOff<=iLen1;iOff++)
			{
			cText[iOff] = (XCHAR)pAddr[iOff1+iOff];
			}

		if(cText[0]=='*' && cText[1]==0)						// Ist es ein Dummy
			{
			cText[0] = 0;
			}

		LOG_WMI1("      Add: \"%S\"\t",cText);

        pAddrSys[lIdx]  = SysAllocString(cText);


		for(iOff=0;iOff<=iLen2;iOff++)
			{
			cText[iOff] = (XCHAR)pMask[iOff2+iOff];
			}

		if(cText[0]=='*' && cText[1]==0)						// Ist es ein Dummy
			{
			cText[0] = 0;
			}

        LOG_WMI1("\"%S\"\n",cText);

		pMaskSys[lIdx]  = SysAllocString(cText);

		SafeArrayPutElement(pAddrList,&lIdx,pAddrSys[lIdx]);
		SafeArrayPutElement(pMaskList,&lIdx,pMaskSys[lIdx]);

		iOff1 += iLen1;
		iOff2 += iLen2;
		}



	   lRes = pClass->GetMethod(L"EnableStatic",0,&pCall,NULL);
	if(lRes!=WBEM_S_NO_ERROR)									// Die Methode holen
		{
		uReturn = 14;
		goto Exit;
		}

	   lRes = pCall->SpawnInstance(0,&pParams);
	if(lRes!=WBEM_S_NO_ERROR)									// Parameterliste erzeugen
		{
		uReturn = 14;
		goto Exit;
		}



	sArgAddr.vt		= VT_ARRAY|VT_BSTR;
	sArgAddr.parray	= pAddrList;

	sArgMask.vt		= VT_ARRAY|VT_BSTR;
	sArgMask.parray	= pMaskList;

	if(pParams->Put(L"IPAddress" ,0,&sArgAddr, 0)!=WBEM_S_NO_ERROR ||
	   pParams->Put(L"SubNetMask",0,&sArgMask, 0)!=WBEM_S_NO_ERROR)
		{
		uReturn = 14;
		goto Exit;
		}



	wcscpy(cText,L"Win32_NetworkAdapterConfiguration.Index=");
	iLen = wcslen(cText);
	_itow(uIndex,cText+iLen,10);

																// Die IP-Adressen setzen
	   lRes = pServices->ExecMethod(cText,L"EnableStatic",0,NULL,pParams,&pOutInst,NULL);
	if(lRes!=WBEM_S_NO_ERROR)
		{
		LOG_WMI1("      ExecMethod ERROR = 0x&08X\n",lRes);
		uReturn = 9;
		goto Exit;
		}


	   lRes = pOutInst->GetObjectText(0,&pResult);				// Rckgabewert abfragen
	if(lRes!=WBEM_S_NO_ERROR)
		{
		uReturn = 9;
		goto Exit;
		}


	iErr = -1;

	for(iOff=0;pResult[iOff];iOff++)							// Rckgabewert suchen
		{
		if(pResult[iOff]<'0')continue;
		if(pResult[iOff]>'9')continue;
		iErr = _wtoi(pResult+iOff);
		break;
		}

	LOG_WMI1("      ExecMethod = %i\n",iErr);

	switch(iErr)
		{
	case  0:	uReturn = 0;	break;
	case 70:	uReturn = 4;	break;
	case 66:	uReturn = 5;	break;
	default:	uReturn = 9;	break;
		}




//******************** Ende ***************************************************
Exit:


	if(pAddrList)SafeArrayDestroy(pAddrList);
	if(pMaskList)SafeArrayDestroy(pMaskList);

	for(iPos=0;iPos<iNum;iPos++)
		{
		SysFreeString(pAddrSys[iPos]);
        SysFreeString(pMaskSys[iPos]);
		}

	if(pEnumerator)pEnumerator->Release();
	if(pServices  )pServices  ->Release();
	if(pLocator   )pLocator   ->Release();
	if(pOutInst   )pOutInst   ->Release();
	if(pObject	  )pObject	  ->Release();
	if(pParams    )pParams    ->Release();
	if(pClass     )pClass     ->Release();
	if(pCall      )pCall      ->Release();


	if(!iDepth && iErr)											// Manchmal geht's erst beim zweiten mal
		{
		LOG_WMI0("      Second Turn\n");
		return WmiSetIpAdresses(pMac,pAddr,pMask,1);
		}



return uReturn;
}



//*****************************************************************************
//*
//*		WmiEnableDhcp
//*
//*****************************************************************************
//	Aktiviert den DHCP Server fr eine Netzwerkskarte
//	pMac		: Ist die MAC-Addresse der Netzwerkskarte.
//					z.B. "00-11-22-33-44-55"
//	iDepth		: Ist die Aufruftiefe
//	Ergibt 0 wenn die Adressen gesetzt wurden, oder eine Fehlernummer
//						 3 = Die Netzwerkskarte wurde nicht gefunden.
//						 4 = Falsches Format der IP-Addresse
//						 5 = Falsches Format der SubNet-Maske
//						 9 = Die Adresse konnte nicht gesetzt werden
//						12 = Kann OLE-Interface nicht initialisieren.
//						13 = Kann WMI-Interface nicht initialisieren.
//						14 = Fehler bei WMI Abfrage.
static int WmiEnableDhcp(LPCTSTR pMac,int iDepth)
{
IEnumWbemClassObject   *pEnumerator = NULL;
IWbemServices		   *pServices   = NULL;
IWbemLocator		   *pLocator    = NULL;
IWbemClassObject	   *pOutInst	= NULL;
IWbemClassObject       *pObject		= NULL;
IWbemClassObject	   *pClass      = NULL;
IWbemClassObject	   *pCall       = NULL;
WCHAR					cText[256];
ULONG					uReturn;
HRESULT					lRes;
int						iLen;
int						iOff;
int						iNum;


	LOG_WMI2("WmiEnableDhcp(\"%s\",%i)\n",pMac,iDepth);


	if(!iInitOle)												// OLE Initialisieren
		{
		lRes =	CoInitializeEx(0, COINIT_MULTITHREADED);

		if(FAILED(lRes))
			{
			return 1;											// Program has failed.
			}
																// Set general COM security levels

		lRes =	CoInitializeSecurity(NULL,
								-1,								// COM authentication
							 	NULL,							// Authentication services
							 	NULL,							// Reserved
							 	RPC_C_AUTHN_LEVEL_DEFAULT, 		// Default authentication
							 	RPC_C_IMP_LEVEL_IMPERSONATE,	// Default Impersonation
							 	NULL,							// Authentication info
							 	EOAC_NONE, 						// Additional capabilities
							 	NULL);							// Reserved



		if(FAILED(lRes))
			{
			CoUninitialize();
			return 1;											// Program has failed.
			}

		iInitOle = 1;
		}

	iNum = 0;
	lRes = CoCreateInstance(CLSID_WbemLocator_,0,CLSCTX_INPROC_SERVER,IID_IWbemLocator_,(LPVOID*)&pLocator);

	if(FAILED(lRes))
		{
		return 13;
		}

																// Connect to WMI through the IWbemLocator::ConnectServer
	lRes = pLocator->ConnectServer(_bstr_t(L"ROOT\\CIMV2"), 	// Object path of WMI namespace
								NULL,							// User name. NULL = current user
						   		NULL,							// User password. NULL = current
						   		0,								// Locale. NULL indicates current
						   		NULL,							// Security flags.
						   		0,								// Authority (e.g. Kerberos)
						   		0,								// Context object
						   		&pServices);					// Pointer to IWbemServices proxy


	if(FAILED(lRes))
		{
		pLocator->Release();
		return 13;
		}


	lRes = CoSetProxyBlanket(pServices,							// Indicates the proxy to set
							 RPC_C_AUTHN_WINNT, 				// RPC_C_AUTHN_xxx
							 RPC_C_AUTHZ_NONE,					// RPC_C_AUTHZ_xxx
							 NULL,								// Server principal name
							 RPC_C_AUTHN_LEVEL_CALL,			// RPC_C_AUTHN_LEVEL_xxx
							 RPC_C_IMP_LEVEL_IMPERSONATE,		// RPC_C_IMP_LEVEL_xxx
							 NULL,								// Client identity
							 EOAC_NONE);						// Proxy capabilities

	if(FAILED(lRes))
		{
		pServices->Release();
		pLocator ->Release();
		return 1;
		}
																// Grab class required to work on Win32_NetworkAdapterConfiguration

	lRes = pServices->GetObject(L"Win32_NetworkAdapterConfiguration",0,NULL,&pClass,NULL);

	if(lRes!=WBEM_S_NO_ERROR)
		{
		pServices->Release();
		pLocator ->Release();
		return 13;
		}


//******************** Suche die Karte ****************************************
unsigned	uIndex;
_variant_t	sVarVal;
_bstr_t		sStr;


	wcscpy(cText,L"SELECT * FROM Win32_NetworkAdapterConfiguration WHERE MACAddress = '");
	iOff = wcslen(cText);

	for(iLen=0;iLen<20;iLen++)
		{
		if(!pMac[iLen])break;

		if(pMac[iLen]=='-')
			{
			cText[iOff+iLen] = ':';
			}
		else if(pMac[iLen]>='a' && pMac[iLen]<='z')
			{
			cText[iOff+iLen] = pMac[iLen]-32;
			}
		else{
			cText[iOff+iLen] = pMac[iLen];
			}
		}

	wcscpy(cText+iOff+iLen,L"' AND IPEnabled = TRUE");

	LOG_WMI1("      ExecQuery: \"%S\"\n",cText);

																// Suche die Karte via MAC
	   lRes = pServices->ExecQuery(L"WQL",cText,WBEM_FLAG_FORWARD_ONLY|WBEM_FLAG_RETURN_IMMEDIATELY,NULL,&pEnumerator);
	if(lRes!=WBEM_S_NO_ERROR || !pEnumerator)
		{
		uReturn = 13;
		goto Exit;
		}


	   lRes = pEnumerator->Next(WBEM_INFINITE,1,&pObject,&uReturn);
	if(lRes || uReturn==0)
		{
		uReturn = 3;
		goto Exit;
		}


	   lRes = pObject->Get(L"Index",0,&sVarVal,0,0);
	if(lRes)
		{
		uReturn = 14;
		goto Exit;
		}

	sStr	= sVarVal;
	uIndex  = _wtoi(sStr);
	VariantClear(&sVarVal);



//******************** Addressen setzen ***************************************
BSTR		pResult;
int			iErr;




	   lRes = pClass->GetMethod(L"EnableDHCP",0,&pCall,NULL);
	if(lRes!=WBEM_S_NO_ERROR)									// Die Methode holen
		{
		uReturn = 14;
		goto Exit;
		}


	wcscpy(cText,L"Win32_NetworkAdapterConfiguration.Index=");
	iLen = wcslen(cText);
	_itow(uIndex,cText+iLen,10);

																// Die IP-Adressen setzen
	   lRes = pServices->ExecMethod(cText,L"EnableDHCP",0,NULL,NULL,&pOutInst,NULL);
	if(lRes!=WBEM_S_NO_ERROR)
		{
		uReturn = 9;
		goto Exit;
		}


	   lRes = pOutInst->GetObjectText(0,&pResult);				// Rckgabewert abfragen
	if(lRes!=WBEM_S_NO_ERROR)
		{
		uReturn = 9;
		goto Exit;
		}


	iErr = -1;

	for(iOff=0;pResult[iOff];iOff++)							// Rckgabewert suchen
		{
		if(pResult[iOff]<'0')continue;
		if(pResult[iOff]>'9')continue;
		iErr = _wtoi(pResult+iOff);
		break;
		}


	LOG_WMI1("      ExecMethod = %i\n",iErr);


	switch(iErr)
		{
	case  0:	uReturn = 0;	break;
	case 70:	uReturn = 4;	break;
	case 66:	uReturn = 5;	break;
	default:	uReturn = 9;	break;
		}




//******************** Ende ***************************************************
Exit:


	if(pEnumerator)pEnumerator->Release();
	if(pServices  )pServices  ->Release();
	if(pLocator   )pLocator   ->Release();
	if(pOutInst   )pOutInst   ->Release();
	if(pObject	  )pObject	  ->Release();
	if(pClass     )pClass     ->Release();
	if(pCall      )pCall      ->Release();


	if(!iDepth && iErr)											// Manchmal geht's erst beim zweiten mal
		{
		LOG_WMI1("      NetGetConnectStatus = %i\n",NetGetConnectStatus(pMac,1));

		if(uReturn && iErr==94 && NetGetConnectStatus(pMac,1)==0)
			{
			TCHAR		cName[128];
			DWORD		uValue;
			HKEY		hKey;
			int			iLen;
			int			iRet;
																// In Registry setzen wenn Kabel ausgesteckt

			_tcscpy(cName,_T("System\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces\\"));
			iLen = _tcslen(cName);

			if(GetAdapterName(pMac,cName+iLen,ENTRIES(cName)-iLen,1))
				{
																// ffne Schlssel
				   iRet = RegOpenKeyEx(HKEY_LOCAL_MACHINE,cName,0,KEY_ALL_ACCESS,&hKey);
				if(iRet!=ERROR_SUCCESS)
					{
					LOG_WMI1("      RegOpenKeyEx ERROR = %i\n",iRet);
					return 0;
					}


				uValue	= 1;

				RegSetValueEx(hKey,_T("EnableDHCP"),0,REG_DWORD   ,(unsigned char*)&uValue  ,  sizeof(DWORD));
				RegSetValueEx(hKey,_T("IPAddress" ),0,REG_MULTI_SZ,(unsigned char*)_T("0\0"),2*sizeof(TCHAR));
				RegSetValueEx(hKey,_T("SubnetMask"),0,REG_MULTI_SZ,(unsigned char*)_T("0\0"),2*sizeof(TCHAR));
				}
			}

		uReturn = WmiEnableDhcp(pMac,1);
		}




return uReturn;
}


//*****************************************************************************
//*
//*		WmiSetGateway
//*
//*****************************************************************************
//	Stellt die Gateway IP-Adresse ber das WMI Interface ein
//	pMac		: Ist die MAC-Addresse der Netzwerkskarte.
//					z.B. "00-11-22-33-44-55"
//	pAddr1		: Ist die IP-Adresse des Gateways
//					Bei 0 oder "" wird die Adresse gelscht
//	Ergibt 0 wenn die Adressen gesetzt wurden, oder eine Fehlernummer
//						 3 = Die Netzwerkskarte wurde nicht gefunden.
//						 4 = Falsches Format der IP-Addresse
//						 5 = Falsches Format der SubNet-Maske
//						 9 = Die Adresse konnte nicht gesetzt werden
//						12 = Kann OLE-Interface nicht initialisieren.
//						13 = Kann WMI-Interface nicht initialisieren.
//						14 = Fehler bei WMI Abfrage.
static int WmiSetGateway(LPCTSTR pMac,LPCTSTR pGateway)
{
IEnumWbemClassObject   *pEnumerator = NULL;
IWbemServices		   *pServices   = NULL;
IWbemLocator		   *pLocator    = NULL;
IWbemClassObject	   *pOutInst	= NULL;
IWbemClassObject       *pObject		= NULL;
IWbemClassObject	   *pParams     = NULL;
IWbemClassObject	   *pClass      = NULL;
IWbemClassObject	   *pCall       = NULL;
SAFEARRAY			   *pGateList	= NULL;
SAFEARRAY			   *pMetricList	= NULL;
BSTR					pGateSys    = NULL;
WORD					uMetric		= 0;
VARIANT					sArgMetric;
VARIANT					sArgAddr;
WCHAR					cText[256];
ULONG					uReturn;
LONG					lIdx;
HRESULT					lRes;
int						iLen;
int						iOff;



	LOG_WMI2("WmiSetGateway(\"%s\",\"%s\")\n",pMac,pGateway);

	if(!iInitOle)												// OLE Initialisieren
		{
		lRes =	CoInitializeEx(0, COINIT_MULTITHREADED);

		if(FAILED(lRes))
			{
			return 1;											// Program has failed.
			}
																// Set general COM security levels

		lRes =	CoInitializeSecurity(NULL,
								-1,								// COM authentication
							 	NULL,							// Authentication services
							 	NULL,							// Reserved
							 	RPC_C_AUTHN_LEVEL_DEFAULT, 		// Default authentication
							 	RPC_C_IMP_LEVEL_IMPERSONATE,	// Default Impersonation
							 	NULL,							// Authentication info
							 	EOAC_NONE, 						// Additional capabilities
							 	NULL);							// Reserved



		if(FAILED(lRes))
			{
			CoUninitialize();
			return 1;											// Program has failed.
			}

		iInitOle = 1;
		}

	lRes = CoCreateInstance(CLSID_WbemLocator_,0,CLSCTX_INPROC_SERVER,IID_IWbemLocator_,(LPVOID*)&pLocator);

	if(FAILED(lRes))
		{
		return 13;
		}

																// Connect to WMI through the IWbemLocator::ConnectServer
	lRes = pLocator->ConnectServer(_bstr_t(L"ROOT\\CIMV2"), 	// Object path of WMI namespace
								NULL,							// User name. NULL = current user
						   		NULL,							// User password. NULL = current
						   		0,								// Locale. NULL indicates current
						   		NULL,							// Security flags.
						   		0,								// Authority (e.g. Kerberos)
						   		0,								// Context object
						   		&pServices);					// Pointer to IWbemServices proxy


	if(FAILED(lRes))
		{
		pLocator->Release();
		return 13;
		}


	lRes = CoSetProxyBlanket(pServices,							// Indicates the proxy to set
							 RPC_C_AUTHN_WINNT, 				// RPC_C_AUTHN_xxx
							 RPC_C_AUTHZ_NONE,					// RPC_C_AUTHZ_xxx
							 NULL,								// Server principal name
							 RPC_C_AUTHN_LEVEL_CALL,			// RPC_C_AUTHN_LEVEL_xxx
							 RPC_C_IMP_LEVEL_IMPERSONATE,		// RPC_C_IMP_LEVEL_xxx
							 NULL,								// Client identity
							 EOAC_NONE);						// Proxy capabilities

	if(FAILED(lRes))
		{
		pServices->Release();
		pLocator ->Release();
		return 1;
		}
																// Grab class required to work on Win32_NetworkAdapterConfiguration

	lRes = pServices->GetObject(L"Win32_NetworkAdapterConfiguration",0,NULL,&pClass,NULL);

	if(lRes!=WBEM_S_NO_ERROR)
		{
		pServices->Release();
		pLocator ->Release();
		return 13;
		}


//******************** Suche die Karte ****************************************
unsigned	uIndex;
_variant_t	sVarVal;
_bstr_t		sStr;


	wcscpy(cText,L"SELECT * FROM Win32_NetworkAdapterConfiguration WHERE MACAddress = '");
	iOff = wcslen(cText);

	for(iLen=0;iLen<20;iLen++)
		{
		if(!pMac[iLen])break;

		if(pMac[iLen]=='-')
			{
			cText[iOff+iLen] = ':';
			}
		else if(pMac[iLen]>='a' && pMac[iLen]<='z')
			{
			cText[iOff+iLen] = pMac[iLen]-32;
			}
		else{
			cText[iOff+iLen] = pMac[iLen];
			}
		}

	wcscpy(cText+iOff+iLen,L"'");

	LOG_WMI1("      ExecQuery: \"%S\"\n",cText);

																// Suche die Karte via MAC
	   lRes = pServices->ExecQuery(L"WQL",cText,WBEM_FLAG_FORWARD_ONLY|WBEM_FLAG_RETURN_IMMEDIATELY,NULL,&pEnumerator);
	if(lRes!=WBEM_S_NO_ERROR || !pEnumerator)
		{
		uReturn = 13;
		goto Exit;
		}


	   lRes = pEnumerator->Next(WBEM_INFINITE,1,&pObject,&uReturn);
	if(lRes || uReturn==0)
		{
		uReturn = 3;
		goto Exit;
		}


	   lRes = pObject->Get(L"Index",0,&sVarVal,0,0);
	if(lRes)
		{
		uReturn = 14;
		goto Exit;
		}

	sStr	= sVarVal;
	uIndex  = _wtoi(sStr);
	VariantClear(&sVarVal);



//******************** Addressen setzen ***************************************
BSTR			pResult;
int				iErr;


	iErr  = 9;

	if(!pGateway)pGateway=_T("");

	pGateList   = SafeArrayCreateVector(VT_BSTR,0,(*pGateway)? 1:0);
	pMetricList = SafeArrayCreateVector(VT_BSTR,0,(*pGateway)? 1:0);

	if(*pGateway)												// Gateway Adresse vorhanden
		{
		for(iOff=0;iOff<=64;iOff++)
			{
				cText[iOff] = (XCHAR)pGateway[iOff];
			if(!cText[iOff])break;
			}

		pGateSys = SysAllocString(cText);

		lIdx = 0;
		SafeArrayPutElement(pGateList  ,&lIdx,pGateSys);
		SafeArrayPutElement(pMetricList,&lIdx,&uMetric);
		}


	   lRes = pClass->GetMethod(L"SetGateways",0,&pCall,NULL);
	if(lRes!=WBEM_S_NO_ERROR)									// Die Methode holen
		{
		uReturn = 14;
		goto Exit;
		}

	   lRes = pCall->SpawnInstance(0,&pParams);
	if(lRes!=WBEM_S_NO_ERROR)									// Parameterliste erzeugen
		{
		uReturn = 14;
		goto Exit;
		}


 	sArgAddr.vt			= VT_ARRAY|VT_BSTR;
	sArgAddr.parray		= pGateList;

	sArgMetric.vt		= VT_ARRAY|VT_UI1;
	sArgMetric.parray	= pMetricList;

	if(pParams->Put(L"DefaultIPGateway" ,0,&sArgAddr  ,0)!=WBEM_S_NO_ERROR ||
	   pParams->Put(L"GatewayCostMetric",0,&sArgMetric,0)!=WBEM_S_NO_ERROR)
		{
		uReturn = 14;
		goto Exit;
		}



	wcscpy(cText,L"Win32_NetworkAdapterConfiguration.Index=");
	iLen = wcslen(cText);
	_itow(uIndex,cText+iLen,10);

																// Die IP-Adressen setzen
	   lRes = pServices->ExecMethod(cText,L"SetGateways",0,NULL,pParams,&pOutInst,NULL);
	if(lRes!=WBEM_S_NO_ERROR)
		{
		uReturn = 9;
		goto Exit;
		}


	   lRes = pOutInst->GetObjectText(0,&pResult);				// Rckgabewert abfragen
	if(lRes!=WBEM_S_NO_ERROR)
		{
		uReturn = 9;
		goto Exit;
		}


	iErr = -1;

	for(iOff=0;pResult[iOff];iOff++)							// Rckgabewert suchen
		{
		if(pResult[iOff]<'0')continue;
		if(pResult[iOff]>'9')continue;
		iErr = _wtoi(pResult+iOff);
		break;
		}


	LOG_WMI1("      ExecMethod = %i\n",iErr);


	switch(iErr)
		{
	case  0:	uReturn = 0;	break;
	case 70:	uReturn = 4;	break;
	case 66:	uReturn = 5;	break;
	default:	uReturn = 9;	break;
		}




//******************** Ende ***************************************************
Exit:


	if(pGateList  )SafeArrayDestroy(pGateList);
	if(pMetricList)SafeArrayDestroy(pMetricList);
	if(pGateSys   )SysFreeString(pGateSys);

	if(pEnumerator)pEnumerator->Release();
	if(pServices  )pServices  ->Release();
	if(pLocator   )pLocator   ->Release();
	if(pOutInst   )pOutInst   ->Release();
	if(pObject	  )pObject	  ->Release();
	if(pParams    )pParams    ->Release();
	if(pClass     )pClass     ->Release();
	if(pCall      )pCall      ->Release();



return uReturn;
}


//*****************************************************************************
//*
//*		WmiSetNameServer
//*
//*****************************************************************************
//	Stellt die Name-Server IP-Adressen ber das WMI Interface ein
//	pMac		: Ist die MAC-Addresse der Netzwerkskarte.
//					z.B. "00-11-22-33-44-55"
//	pAddr1		: Ist die IP-Adresse des ersten Nameservers
//					Bei 0 oder "" wird die Adresse gelscht
//	pAddr2		: Ist die IP-Adresse des ersten Nameservers
//					Bei 0 oder "" wird die Adresse gelscht
//	Ergibt 0 wenn die Adressen gesetzt wurden, oder eine Fehlernummer
//						 3 = Die Netzwerkskarte wurde nicht gefunden.
//						 4 = Falsches Format der IP-Addresse
//						 5 = Falsches Format der SubNet-Maske
//						 9 = Die Adresse konnte nicht gesetzt werden
//						12 = Kann OLE-Interface nicht initialisieren.
//						13 = Kann WMI-Interface nicht initialisieren.
//						14 = Fehler bei WMI Abfrage.
static int WmiSetNameServer(LPCTSTR pMac,LPCTSTR pAddr1,LPCTSTR pAddr2)
{
IEnumWbemClassObject   *pEnumerator = NULL;
IWbemServices		   *pServices   = NULL;
IWbemLocator		   *pLocator    = NULL;
IWbemClassObject	   *pOutInst	= NULL;
IWbemClassObject       *pObject		= NULL;
IWbemClassObject	   *pParams     = NULL;
IWbemClassObject	   *pClass      = NULL;
IWbemClassObject	   *pCall       = NULL;
SAFEARRAY			   *pNameList	= NULL;
BSTR					pNameSys[2] = {0,0};
WORD					uMetric		= 0;
VARIANT					sArgAddr;
WCHAR					cText[256];
ULONG					uReturn;
LONG					lIdx;
HRESULT					lRes;
int						iLen;
int						iOff;



	LOG_WMI3("WmiSetNameServer(\"%s\",\"%s\",\"%s\")\n",pMac,pAddr1,pAddr2);


	if( pAddr2 &&  *pAddr2)										// Nur zweitet Server vorhanden
	if(!pAddr1 || !*pAddr1)
		{
		pAddr1 = pAddr2;
		pAddr2 = _T("");
		}



	if(!iInitOle)												// OLE Initialisieren
		{
		lRes =	CoInitializeEx(0, COINIT_MULTITHREADED);

		if(FAILED(lRes))
			{
			return 1;											// Program has failed.
			}
																// Set general COM security levels

		lRes =	CoInitializeSecurity(NULL,
								-1,								// COM authentication
							 	NULL,							// Authentication services
							 	NULL,							// Reserved
							 	RPC_C_AUTHN_LEVEL_DEFAULT, 		// Default authentication
							 	RPC_C_IMP_LEVEL_IMPERSONATE,	// Default Impersonation
							 	NULL,							// Authentication info
							 	EOAC_NONE, 						// Additional capabilities
							 	NULL);							// Reserved



		if(FAILED(lRes))
			{
			CoUninitialize();
			return 1;											// Program has failed.
			}

		iInitOle = 1;
		}

	lRes = CoCreateInstance(CLSID_WbemLocator_,0,CLSCTX_INPROC_SERVER,IID_IWbemLocator_,(LPVOID*)&pLocator);

	if(FAILED(lRes))
		{
		return 13;
		}

																// Connect to WMI through the IWbemLocator::ConnectServer
	lRes = pLocator->ConnectServer(_bstr_t(L"ROOT\\CIMV2"), 	// Object path of WMI namespace
								NULL,							// User name. NULL = current user
						   		NULL,							// User password. NULL = current
						   		0,								// Locale. NULL indicates current
						   		NULL,							// Security flags.
						   		0,								// Authority (e.g. Kerberos)
						   		0,								// Context object
						   		&pServices);					// Pointer to IWbemServices proxy


	if(FAILED(lRes))
		{
		pLocator->Release();
		return 13;
		}


	lRes = CoSetProxyBlanket(pServices,							// Indicates the proxy to set
							 RPC_C_AUTHN_WINNT, 				// RPC_C_AUTHN_xxx
							 RPC_C_AUTHZ_NONE,					// RPC_C_AUTHZ_xxx
							 NULL,								// Server principal name
							 RPC_C_AUTHN_LEVEL_CALL,			// RPC_C_AUTHN_LEVEL_xxx
							 RPC_C_IMP_LEVEL_IMPERSONATE,		// RPC_C_IMP_LEVEL_xxx
							 NULL,								// Client identity
							 EOAC_NONE);						// Proxy capabilities

	if(FAILED(lRes))
		{
		pServices->Release();
		pLocator ->Release();
		return 1;
		}
																// Grab class required to work on Win32_NetworkAdapterConfiguration

	lRes = pServices->GetObject(L"Win32_NetworkAdapterConfiguration",0,NULL,&pClass,NULL);

	if(lRes!=WBEM_S_NO_ERROR)
		{
		pServices->Release();
		pLocator ->Release();
		return 13;
		}


//******************** Suche die Karte ****************************************
unsigned	uIndex;
_variant_t	sVarVal;
_bstr_t		sStr;


	wcscpy(cText,L"SELECT * FROM Win32_NetworkAdapterConfiguration WHERE MACAddress = '");
	iOff = wcslen(cText);

	for(iLen=0;iLen<20;iLen++)
		{
		if(!pMac[iLen])break;

		if(pMac[iLen]=='-')
			{
			cText[iOff+iLen] = ':';
			}
		else if(pMac[iLen]>='a' && pMac[iLen]<='z')
			{
			cText[iOff+iLen] = pMac[iLen]-32;
			}
		else{
			cText[iOff+iLen] = pMac[iLen];
			}
		}

	wcscpy(cText+iOff+iLen,L"' AND IPEnabled = TRUE");

	LOG_WMI1("      ExecQuery: \"%S\"\n",cText);

																// Suche die Karte via MAC
	   lRes = pServices->ExecQuery(L"WQL",cText,WBEM_FLAG_FORWARD_ONLY|WBEM_FLAG_RETURN_IMMEDIATELY,NULL,&pEnumerator);
	if(lRes!=WBEM_S_NO_ERROR || !pEnumerator)
		{
		uReturn = 13;
		goto Exit;
		}


	   lRes = pEnumerator->Next(WBEM_INFINITE,1,&pObject,&uReturn);
	if(lRes || uReturn==0)
		{
		uReturn = 3;
		goto Exit;
		}


	   lRes = pObject->Get(L"Index",0,&sVarVal,0,0);
	if(lRes)
		{
		uReturn = 14;
		goto Exit;
		}

	sStr	= sVarVal;
	uIndex  = _wtoi(sStr);
	VariantClear(&sVarVal);



//******************** Addressen setzen ***************************************
BSTR			pResult;
int				iErr;
int				iNum;

	if(!pAddr1)pAddr1=_T("");
	if(!pAddr2)pAddr2=_T("");

	iNum = 0;
	if(*pAddr1)iNum++;
	if(*pAddr2)iNum++;


	pNameList   = SafeArrayCreateVector(VT_BSTR,0,iNum);


	if(*pAddr1)													// Adressen vorhanden
		{
		for(iOff=0;iOff<=64;iOff++)
			{
				cText[iOff] = (XCHAR)pAddr1[iOff];
			if(!cText[iOff])break;
			}

		pNameSys[0] = SysAllocString(cText);

		lIdx = 0;
		SafeArrayPutElement(pNameList,&lIdx,pNameSys[0]);
		}

	if(*pAddr2)													// Zweite Adressen vorhanden
		{
		for(iOff=0;iOff<=64;iOff++)
			{
				cText[iOff] = (XCHAR)pAddr2[iOff];
			if(!cText[iOff])break;
			}

		pNameSys[1] = SysAllocString(cText);

		lIdx = 1;
		SafeArrayPutElement(pNameList,&lIdx,pNameSys[1]);
		}


	   lRes = pClass->GetMethod(L"SetDNSServerSearchOrder",0,&pCall,NULL);
	if(lRes!=WBEM_S_NO_ERROR)									// Die Methode holen
		{
		uReturn = 14;
		goto Exit;
		}

	   lRes = pCall->SpawnInstance(0,&pParams);
	if(lRes!=WBEM_S_NO_ERROR)									// Parameterliste erzeugen
		{
		uReturn = 14;
		goto Exit;
		}


 	sArgAddr.vt			= VT_ARRAY|VT_BSTR;
	sArgAddr.parray		= pNameList;

	if(pParams->Put(L"DNSServerSearchOrder",0,&sArgAddr,0)!=WBEM_S_NO_ERROR)
		{
		uReturn = 14;
		goto Exit;
		}



	wcscpy(cText,L"Win32_NetworkAdapterConfiguration.Index=");
	iLen = wcslen(cText);
	_itow(uIndex,cText+iLen,10);

																// Die IP-Adressen setzen
	   lRes = pServices->ExecMethod(cText,L"SetDNSServerSearchOrder",0,NULL,pParams,&pOutInst,NULL);
	if(lRes!=WBEM_S_NO_ERROR)
		{
		LOG_WMI1("      ExecMethod ERROR 0x%08X\n",lRes);
		uReturn = 9;
		goto Exit;
		}


	   lRes = pOutInst->GetObjectText(0,&pResult);				// Rckgabewert abfragen
	if(lRes!=WBEM_S_NO_ERROR)
		{
		uReturn = 9;
		goto Exit;
		}


	iErr = -1;

	for(iOff=0;pResult[iOff];iOff++)							// Rckgabewert suchen
		{
		if(pResult[iOff]<'0')continue;
		if(pResult[iOff]>'9')continue;
		iErr = _wtoi(pResult+iOff);
		break;
		}

	LOG_WMI1("      ExecMethod = %i\n",iErr);

	if(iErr)													// Prfen ob die Adressen bernommen wurden
		{
		TCHAR			cName[128];
		NetCardData		sData;
		int				iNum;

		iNum = GetAdapterName(pMac,cName,ENTRIES(cName),1);

		if(iNum>=0 && ReadCardData(cName,&sData))
			{
			if(!*pAddr1 && !sData.cName[0])
				{
				LOG_WMI0("      Reg OK 0\n");
				return 0;
				}

			if(!_tcscmp(pAddr1,sData.cName))
				{
				iNum = _tcslen(sData.cName);

				if(!_tcscmp(pAddr2,sData.cName+iNum+1))
					{
					LOG_WMI0("      Reg OK *\n");
					return 0;
					}
				}
			}
		}


	switch(iErr)
		{
	case  0:	uReturn = 0;	break;
	case 70:	uReturn = 4;	break;
	case 66:	uReturn = 5;	break;
	default:	uReturn = 9;	break;
		}




//******************** Ende ***************************************************
Exit:


	if(pNameList  )SafeArrayDestroy(pNameList);
	if(pNameSys[0])SysFreeString(pNameSys[0]);
	if(pNameSys[1])SysFreeString(pNameSys[1]);

	if(pEnumerator)pEnumerator->Release();
	if(pServices  )pServices  ->Release();
	if(pLocator   )pLocator   ->Release();
	if(pOutInst   )pOutInst   ->Release();
	if(pObject	  )pObject	  ->Release();
	if(pParams    )pParams    ->Release();
	if(pClass     )pClass     ->Release();
	if(pCall      )pCall      ->Release();



return uReturn;
}

//*****************************************************************************
//*
//*		NetIsLocalNet
//*
//*****************************************************************************
//	Prft ob eine IP-Adresse eim lkalen SubNetz ist
//	pIpAddr		: Ist die IP-Adresse die Geprft werden soll
//	pInterface	: Hier wird der Interface-Name gespeichert (32 Byte fr MAC)
//	Ergibt 0 wenn die IP-Adresse zu keinem lokalen Subnetz gehrt:
//						0 = nicht im lokalen Subnetz
//						1 = im lokalen Subnetz
//						2 = lokale IP-Adresse
unsigned NetIsLocalNet(unsigned uAddr,LPTSTR pInterface)
{
NetCardInfo    *pCard;
DWORD			aList[128];
TCHAR			cName[4];
unsigned		uSub;
unsigned		uNet;
unsigned		uNum;
int				iRet;
int				iPos;
int				iOff;



	if(iInitNet==0)											// Wurde bereits nach Karten gesucht
		{
		NetUpdateCards();
		}


	if((uAddr&0x00FFFFFF)==0x0000007F)						// Loopback-Adresse
		{
		for(uNum=0;uNum<uCardCnt;uNum++)					// Alle Netzwerkskarten absuchen
			{
			pCard = pCardInfos+uNum;

			for(iOff=0;;iOff++)
				{
				if(pCard->cDesciption[iOff  ]==0){iOff=0;break;}
				if(pCard->cDesciption[iOff  ]!='L')
				if(pCard->cDesciption[iOff  ]!='l')continue;
				if(pCard->cDesciption[iOff+1]!='O')
				if(pCard->cDesciption[iOff+1]!='o')continue;

				if(!_tcsnicmp(pCard->cDesciption+iOff,"Loopback",8))
					{
					_tcscpy(pInterface,pCard->cMac);
					return 2;
					}
				}
			}

		_tcscpy(pInterface,_T("02-00-4C-4F-4F-50"));

		return 2;
		}


	for(uNum=0;uNum<uCardCnt;uNum++)						// Alle Netzwerkskarten absuchen
		{
		cName[3] =  0;
		cName[2] = (TCHAR)('0'+ pCardInfos[uNum].uIndex%10    );
		cName[1] = (TCHAR)('0'+(pCardInfos[uNum].uIndex/10)%10);
		cName[0] = (TCHAR)('0'+ pCardInfos[uNum].uIndex/100   );

		   iRet = NetGetIpAddresses(cName,aList,ENTRIES(aList)/2);
		if(iRet<=0)continue;

		for(iPos=iRet-1;iPos>=0;iPos--)
			{
			uNet = aList[iPos*2+1]&aList[iPos*2];
			uSub = aList[iPos*2+1]&uAddr;

			if(uNet==uSub)
				{
				return (aList[iPos*2]==uAddr)? 2:1;
				}
			}
		}



return 0;
}

