//*****************************************************************************
//*
//*
//*		PeFunctions
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#if  defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
#include	<afxwin.h>
#ifndef		AZ_LIB_ADDAFX
#define     AZ_LIB_ADDAFX
#endif
#else
#include	<windows.h>
#endif

#ifndef		PE_NO_FILE_PROCS
#include	"AZ_Lib.h"
#endif 	
#include	<ShlObj.h>
#include	<ImageHlp.h>
#include	"PeFunctions.h"


#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifndef		 CSIDL_SYSTEM
#define 	 CSIDL_SYSTEM			0x0025
#endif
#ifndef 	 CSIDL_SYSTEMX86
#define		 CSIDL_SYSTEMX86		0x0029
#endif


#define 	 ADD_NONE				((LPWORD)1)
#define 	 WORD_SIGN(a,b)			( WORD)(((unsigned char)(a)+((unsigned char)(b)<<8)))
#define 	 DWORD_SIGN(a,b,c,d)	(DWORD)(((unsigned char)(a)+((unsigned char)(b)<<8)+((unsigned char)(c)<<16)+((unsigned char)(d)<<24)))

//******************************************************************************
//*
//*		UnProtect
//*
//******************************************************************************
//	Removes the write protection of a memory area
//	pMem		: pointer to the memory area
//	iSize		: is the size of the memory area
//	Returns 1 if ok, or 0 if an error occurs.
static BOOL UnProtect(void *pMem,int iSize)
{
MEMORY_BASIC_INFORMATION	sInfo;
DWORD						uAttr;
DWORD						uOld;


	VirtualQuery(pMem,&sInfo,sizeof(sInfo));

	if(sInfo.Protect&(PAGE_EXECUTE|PAGE_EXECUTE_READ|PAGE_EXECUTE_READWRITE|PAGE_EXECUTE_WRITECOPY))
			uAttr = PAGE_EXECUTE_WRITECOPY;
	else	uAttr = PAGE_WRITECOPY;


return VirtualProtect(pMem,iSize,uAttr,&uOld);
}


//*****************************************************************************
//*
//*		PeWowRedirect
//*
//*****************************************************************************
//	Die Umleitung des "C:\Windows\system32" Pfades ndern
//	iMode	:  0 = Umleitung von vorherwieder herstellen
//			   1 = Umleitung aufheben
//			  -1 = Umleitung einschalten
//	Ergibt den vorherigen Modus
static void PeWowRedirect(int iMode)
{

	#ifndef _WIN64

	typedef BOOL (WINAPI *LPFN_WOW64DISABLE)(PVOID*);
	static	LPFN_WOW64DISABLE   Wow64Ena =0;
	static	LPFN_WOW64DISABLE   Wow64Dis =0;
	static	LPFN_WOW64DISABLE   Wow64Res =0;
	static	int					iOld64Ini=0;
	static	int					iOld64Cnt=0;
	static	PVOID				pOld64Dis=0;

	if(!iOld64Ini)										// Funktionen laden
		{
		HINSTANCE	hKernel;

		iOld64Ini = 1;
		hKernel   = GetModuleHandleA("kernel32");
		Wow64Dis  = (LPFN_WOW64DISABLE)GetProcAddress(hKernel,"Wow64DisableWow64FsRedirection");
		Wow64Ena  = (LPFN_WOW64DISABLE)GetProcAddress(hKernel,"Wow64EnableWow64FsRedirection");
		Wow64Res  = (LPFN_WOW64DISABLE)GetProcAddress(hKernel,"Wow64RevertWow64FsRedirection");
		}

	if(iMode>0)											// Umleitung aufheben
		{
		iOld64Cnt++;

		if(iOld64Cnt>1)return;

		if(Wow64Dis)
			{
			Wow64Dis(&pOld64Dis);
			}
		}
	else if(iMode<0)									// Umleitung einschalten
		{
		iOld64Cnt++;

		if(iOld64Cnt>1)return;

		if(Wow64Ena)
			{
			Wow64Ena(&pOld64Dis);
			}
		}
	else{												// Umleitung von vorher wieder herstellen
		if(iOld64Cnt<=0)return;
		   iOld64Cnt--;
		if(iOld64Cnt<=0)return;

		if(Wow64Res)
			{
			Wow64Res(&pOld64Dis);
			}
		}

	#endif

}

//*****************************************************************************
//*
//*		FindPeCodeMem
//*
//*****************************************************************************
//	Sucht einen freien Code-Speicher fr den Einsprungpunkt der Funktionen.
//	pBase		: Handle der Instanze, oder Basisadresse
//	pEntries	: Offset-Liste mit den Einsprungpunkten
//	iCount		: Anzahl der Einsprungpunkte in der Offset-Liste
//	iSize		: Gre des Speichers
//	Ergibt einen Zeiger auf den Speicher oder NULL wenn nichts gefunden wurde.
static char *FindPeCodeMem(void *pBase,DWORD *pEntries,int iCount,int iSize)
{
char	   *pPtr;
int			iIdx;
int			iOff;


	for(iIdx=0;iIdx<iCount;iIdx++)						// Vor einen Einsprungpunkt setzen
		{
		   iOff = pEntries[iIdx];
		if(iOff<iSize)continue;

		pPtr = (char*)PTR_ADD_32(pBase,iOff-1);

		if(pPtr[0]!='\xFF')
		if(pPtr[0]!='\x00')
		if(pPtr[0]!='\x90')
		if(pPtr[0]!='\xCC')continue;

		for(iOff=1;iOff<16;iOff++)						// Bereichsgre ermitteln
			{
			if(pPtr[-iOff]!=pPtr[0])break;
			}

		if(iOff>=iSize)									// Ist der Bereich gro genug
			{
			return pPtr-iOff+1;
			}
		}


return NULL;
}

//*****************************************************************************
//*
//*		FindPeCodeMem
//*
//*****************************************************************************
//	Sucht einen freien Code-Speicher in den Leerbereichen der Abschnitte.
//	pBase		: Handle der Instanze, oder Basisadresse
//	pEntries	: Offset-Liste mit den Einsprungpunkten
//	iCount		: Anzahl der Einsprungpunkte in der Offset-Liste
//	iSize		: Gre des Speichers
//	pAdd		: Hier wird ein Zeiger auf die Grenmakierung gespeichert.
//				  Wenn pAdd 0 ist dann muss eine neue Makierung eingefgt werden
//						>LL HH 55 5A AA			(LL:HH) ist die Gre
//	Ergibt einen Zeiger auf den Speicher oder NULL wenn nichts gefunden wurde.
static char *FindPeCodeMem(void *pBase,DWORD *pEntries,int iCount,int iSize,LPWORD &pAdd)
{
IMAGE_SECTION_HEADER *pSections;
char				 *pData;
SYSTEM_INFO			  sInfo;
static unsigned		  uPage;
static unsigned		  uStep;
unsigned			  uCount;
unsigned			  uFrom;
unsigned			  uLen;
unsigned			  uEnd;
unsigned			  uIdx;
unsigned			  uMin;
unsigned			  uMid;
unsigned			  uMax;
unsigned			  uCnt;
unsigned			  uNum;
unsigned			  uPos;


		pSections = GetSectionHeaderEx(pBase,&uCount);
	if(!pSections)									// Zeiger auf die Abschnitte
		{
		return FALSE;
		}

	if(!uPage)										// Seitengre holen
		{
		GetSystemInfo(&sInfo);
		uPage = sInfo.dwAllocationGranularity;
		uStep = sInfo.dwPageSize;
		}

	for(uIdx=0;uIdx<uCount;uIdx++)					// Suche Abschnitt mit Leerraum am Ende
		{
		if(uIdx>=uCount)
			{
			return FALSE;
			}

		if(!(pSections[uIdx].Characteristics&IMAGE_SCN_CNT_CODE))
			{
			continue;
			}

		uCnt = pSections[uIdx].SizeOfRawData;
		uNum = pSections[uIdx].Misc.VirtualSize;

		if(uCnt>uNum)uCnt=uNum;

		uMin = 512  -(uCnt&0x1FF);
		uMid = uStep-(uCnt&(uStep-1));
		uMax = uPage-(uCnt&(uPage-1));
		uEnd = pSections[uIdx].VirtualAddress+uCnt;

		for(uPos=0;uPos<uCount;uPos++)				// Abschnitt auf berlappungen prfen
			{
			if(uPos==uIdx)continue;

			uFrom = pSections[uPos].VirtualAddress;
			uLen  = pSections[uPos].SizeOfRawData;
			uNum  = pSections[uIdx].Misc.VirtualSize;

			if(uNum>uNum)uNum=uNum;

			if(uEnd     >=uFrom+uNum)continue;
			if(uEnd+uMax<=uFrom     )continue;

			if(uMax<=uMin)break;

			uMax = (uMax>uMid)? uMid:uMin;
			uPos = 0;
			uPos--;
			}

		if(uPos<uCount )continue;
		if(uMax<5+(UINT)iSize)continue;

		for(;;)										// Ist der Speicher gltig
			{
			pData = (char*)PTR_ADD_32(pBase,uEnd+uMax);
			if(!IsBadReadPtr(pData-uMax,uMax))break;
			if(uMax<0x1000){uMax=0;continue;}
			uMax -= 0x1000;
			}

		if(uMax<5+(UINT)iSize)continue;

													// Ist das Segment bereits markiert
		if(pData[-3]!='\x55' || pData[-2]!='\x5A' || pData[-1]!='\xAA')
			{
			pAdd = 0;
			return pData-5-iSize;
			}

		pAdd = (LPWORD)(pData-5);
		uNum = *pAdd+iSize;							// Benutzes Segment erweitern

		if(uNum<=uMax)
			{
			return pData-uNum-iSize;
			}
		}


return 0;
}


//*****************************************************************************
//*
//*		PeWin64Bit
//*
//*****************************************************************************
//	Prft ob ein 64-Bit-Betriebsystem vorhanden ist
//	Ergibt 0 wenn kein 64-Bit-Betriebsystem vorhanden ist ansonsten
//				0 = 32-Bit-Betriebsystem
//				1 = 64-Bit-Betriebsystem und 32-Bit-Prozess
//				2 = 64-Bit-Betriebsystem
int PeWin64Bit()
{

	#if _WIN64

	return 2;

	#else

	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS)(HANDLE, PBOOL);
	static  LPFN_ISWOW64PROCESS  IsWow64 = 0;
	static  int 				 iIs64Bit= 0;
	static  BOOL				 bInit   = 0;

	if(!bInit)
		{
		IsWow64 = (LPFN_ISWOW64PROCESS)GetProcAddress(GetModuleHandleA("kernel32"),"IsWow64Process");
		bInit	= TRUE;

		if(IsWow64)
			{
			IsWow64(GetCurrentProcess(),&iIs64Bit);
			if(iIs64Bit)iIs64Bit=1;
			}
		}


	return iIs64Bit;

	#endif

}

//*****************************************************************************
//*
//*		GetDosHeader
//*
//*****************************************************************************
//	Holt den DOS-Header zu einem Instanz-Handle
//	hInstance	: Instanz-Handle
//	Ergibt einen Zeiger auf den DOS-Header oder 0 wenn kein Header vorhanden ist.
IMAGE_DOS_HEADER *GetDosHeader(HINSTANCE hInstance)
{


	if(!hInstance)return 0;
	if(*(WORD*)hInstance!=WORD_SIGN('M','Z'))return 0;


return (IMAGE_DOS_HEADER*)hInstance;
}

//*****************************************************************************
//*
//*		GetPeHeader32
//*
//*****************************************************************************
//	Holt den PE-Header der nach einem DOS-Header folgt
//	pDosHeader	: Zeiger auf den DOS-Header
//	Ergibt einen Zeiger auf den PE-Header oder 0 wenn kein Header vorhanden ist.
IMAGE_NT_HEADERS32 *GetPeHeader32(IMAGE_DOS_HEADER *pDosHeader)
{
IMAGE_NT_HEADERS32	*pPeHeader;


	if(!pDosHeader)return 0;
	if(IsBadReadPtr(pDosHeader,sizeof(*pDosHeader)))return 0;
	if(*(DWORD*)pDosHeader==DWORD_SIGN('P','E',0,0))return (IMAGE_NT_HEADERS32*)pDosHeader;
	if(pDosHeader->e_magic !=WORD_SIGN('M','Z')    )return 0;


	pPeHeader=(IMAGE_NT_HEADERS32*)PTR_ADD_32(pDosHeader,pDosHeader->e_lfanew);
	if(!IsBadReadPtr(pPeHeader,sizeof(*pPeHeader)))
	if(pPeHeader->Signature==DWORD_SIGN('P','E',0,0))
		{
		if(pPeHeader->FileHeader.Machine==0x8664)return 0;	// 64-Bit
		return pPeHeader;
		}

	if(!pDosHeader->e_cp)return 0;

	pPeHeader=(IMAGE_NT_HEADERS32*)PTR_ADD_32(pDosHeader,pDosHeader->e_cblp+pDosHeader->e_cp*16-16+64);
	if(!IsBadReadPtr(pPeHeader,sizeof(*pPeHeader)))
	if(pPeHeader->Signature==DWORD_SIGN('P','E',0,0))
		{
		if(pPeHeader->FileHeader.Machine==0x8664)return 0;	// 64-Bit
		return pPeHeader;
		}


return 0;
}

//*****************************************************************************
//*
//*		GetPeHeader64
//*
//*****************************************************************************
//	Holt den PE-Header der nach einem DOS-Header folgt
//	pDosHeader	: Zeiger auf den DOS-Header
//	Ergibt einen Zeiger auf den PE-Header oder 0 wenn kein Header vorhanden ist.
IMAGE_NT_HEADERS64 *GetPeHeader64(IMAGE_DOS_HEADER *pDosHeader)
{
IMAGE_NT_HEADERS64	*pPeHeader;


	if(!pDosHeader)return 0;
	if(IsBadReadPtr(pDosHeader,sizeof(*pDosHeader)))return 0;
	if(*(DWORD*)pDosHeader==DWORD_SIGN('P','E',0,0))return (IMAGE_NT_HEADERS64*)pDosHeader;
	if(pDosHeader->e_magic !=WORD_SIGN('M','Z')    )return 0;


	pPeHeader=(IMAGE_NT_HEADERS64*)PTR_ADD_32(pDosHeader,pDosHeader->e_lfanew);
	if(!IsBadReadPtr(pPeHeader,sizeof(*pPeHeader)))
	if(pPeHeader->Signature==DWORD_SIGN('P','E',0,0))
		{
		if(pPeHeader->FileHeader.Machine!=0x8664)return 0;	// 64-Bit
		return pPeHeader;
		}

	if(!pDosHeader->e_cp)return 0;

	pPeHeader=(IMAGE_NT_HEADERS64*)PTR_ADD_32(pDosHeader,pDosHeader->e_cblp+pDosHeader->e_cp*16-16+64);
	if(!IsBadReadPtr(pPeHeader,sizeof(*pPeHeader)))
	if(pPeHeader->Signature==DWORD_SIGN('P','E',0,0))
		{
		if(pPeHeader->FileHeader.Machine!=0x8664)return 0;	// 64-Bit
		return pPeHeader;
		}


return 0;
}

//*****************************************************************************
//*
//*		GetPeFileHeader
//*
//*****************************************************************************
//	Holt einen Zeiger auf den File-Header nach dem PE-Header
//	pPeHeader	: Zeiger auf den PE-Header
//	Ergibt einen Zeiger auf den PE-Header oder 0 wenn keine Header vorhanden sind.
IMAGE_FILE_HEADER *GetPeFileHeader(IMAGE_DOS_HEADER *pInstance)
{
IMAGE_NT_HEADERS32     *pPeHdr;
IMAGE_DOS_HEADER	   *pDos;
char			       *pMem;
DWORD				    uOff;


		pMem = (char*)pInstance;
	if(!pMem)return 0;

	if(IsBadReadPtr(pMem,sizeof(IMAGE_DOS_HEADER)))
		{
		return 0;
		}

	if(*(DWORD*)pMem==DWORD_SIGN('P','E',0,0))		// Kein DOS-Header
		{
		uOff = 0;
		}
	else if(*(WORD*)pMem==WORD_SIGN('M','Z'))		// DOS-Header
		{
		pDos = (IMAGE_DOS_HEADER*)pMem;
		uOff = pDos->e_lfanew;
		}
	else{											// Unbekannte Datei
		return 0;
		}

	if(IsBadReadPtr(pMem,uOff+4+sizeof(IMAGE_FILE_HEADER)))
		{
		return 0;
		}

	pPeHdr = (IMAGE_NT_HEADERS32*)(pMem+uOff);


return &pPeHdr->FileHeader;
}

//*****************************************************************************
//*
//*		GetSectionHeader32
//*
//*****************************************************************************
//	Holt einen Zeiger auf die 16 Section-Header nach dem PE-Header
//	pPeHeader	: Zeiger auf den PE-Header
//	Ergibt einen Zeiger auf den PE-Section-Header oder 0 wenn keine Header vorhanden sind.
IMAGE_SECTION_HEADER *GetSectionHeader32(IMAGE_NT_HEADERS32 *pPeHeader,void *pCount)
{
IMAGE_SECTION_HEADER	*pSections;


	if(!pPeHeader || pPeHeader->FileHeader.Machine==0x8664)
		{
		if(pCount)
			{
			PTR_SET_32(pCount,0);
			}

		return 0;
		}

	pSections = (IMAGE_SECTION_HEADER*)PTR_ADD_32(pPeHeader,sizeof(IMAGE_FILE_HEADER)+sizeof(pPeHeader->Signature)+pPeHeader->FileHeader.SizeOfOptionalHeader);

	if(pCount)										// Anzahl der Sektionen speichern
		{
		PTR_SET_32(pCount,pPeHeader->FileHeader.NumberOfSections);
		}


return pSections;
}

//*****************************************************************************
//*
//*		GetSectionHeader64
//*
//*****************************************************************************
//	Holt einen Zeiger auf die 16 Section-Header nach dem PE-Header
//	pPeHeader	: Zeiger auf den PE-Header
//	Ergibt einen Zeiger auf den PE-Section-Header oder 0 wenn keine Header vorhanden sind.
IMAGE_SECTION_HEADER *GetSectionHeader64(IMAGE_NT_HEADERS64 *pPeHeader,void *pCount)
{
IMAGE_SECTION_HEADER	*pSections;


	if(!pPeHeader || pPeHeader->FileHeader.Machine!=0x8664)
		{
		if(pCount)
			{
			PTR_SET_32(pCount,0);
			}

		return 0;
		}

	pSections = (IMAGE_SECTION_HEADER*)PTR_ADD_32(pPeHeader,sizeof(IMAGE_FILE_HEADER)+sizeof(pPeHeader->Signature)+pPeHeader->FileHeader.SizeOfOptionalHeader);

	if(pCount)										// Anzahl der Sektionen speichern
		{
		PTR_SET_32(pCount,pPeHeader->FileHeader.NumberOfSections);
		}

return pSections;
}

//*****************************************************************************
//*
//*		GetSectionHeaderEx
//*
//*****************************************************************************
//	Holt einen Zeiger auf die 16 Section-Header nach dem PE-Header (32 und 64 Bit)
//	pInstance		: Zeiger auf den PE-Header oder DOS-Header
//	pCount			: Hier wir die Anzahl der der Sectionen gespeichert
//	Ergibt einen Zeiger auf den PE-Section-Header oder 0 wenn keine Header vorhanden sind.
IMAGE_SECTION_HEADER *GetSectionHeaderEx(void *pInstance,void *pCount)
{
IMAGE_SECTION_HEADER   *pSections;
IMAGE_NT_HEADERS32     *pPeHeader;
IMAGE_DOS_HEADER	   *pDos;
char			       *pMem;
DWORD				    uOff;


	if(pCount)
		{
		PTR_SET_32(pCount,0);
		}

		pMem = (char*)pInstance;
	if(!pMem)return 0;

	if(IsBadReadPtr(pMem,sizeof(IMAGE_DOS_HEADER)))
		{
		return 0;
		}

	if(*(DWORD*)pMem==DWORD_SIGN('P','E',0,0))		// Kein DOS-Header
		{
		uOff = 0;
		}
	else if(*(WORD*)pMem==WORD_SIGN('M','Z'))		// DOS-Header
		{
		pDos = (IMAGE_DOS_HEADER*)pMem;
		uOff = pDos->e_lfanew;
		}
	else{											// Unbekannte Datei
		return 0;
		}

	if(IsBadReadPtr(pMem,uOff+4+sizeof(IMAGE_FILE_HEADER)))
		{
		return 0;
		}

	pPeHeader = (IMAGE_NT_HEADERS32*)(pMem+uOff);
	pSections = (IMAGE_SECTION_HEADER*)PTR_ADD_32(pPeHeader,sizeof(IMAGE_FILE_HEADER)+sizeof(pPeHeader->Signature)+pPeHeader->FileHeader.SizeOfOptionalHeader);

	if(pCount)										// Anzahl der Sektionen speichern
		{
		PTR_SET_32(pCount,pPeHeader->FileHeader.NumberOfSections);
		}


return pSections;
}

//*****************************************************************************
//*
//*		GetEDataSize32
//*
//*****************************************************************************
//	Holt die Gre des Export-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetEDataSize32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;
};

//*****************************************************************************
//*
//*		GetEDataSize64
//*
//*****************************************************************************
//	Holt die Gre des Export-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetEDataSize64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;
};

//*****************************************************************************
//*
//*		GetEDataPtr32
//*
//*****************************************************************************
IMAGE_EXPORT_DIRECTORY *GetEDataPtr32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_EXPORT_DIRECTORY*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetEDataPtr64
//*
//*****************************************************************************
IMAGE_EXPORT_DIRECTORY *GetEDataPtr64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_EXPORT_DIRECTORY*)PTR_ADD_32(uOffset,pInstance);
};

//*****************************************************************************
//*
//*		GetIDataSize32
//*
//*****************************************************************************
//	Holt die Gre des Import-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetIDataSize32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size;
};

//*****************************************************************************
//*
//*		GetIDataSize64
//*
//*****************************************************************************
//	Holt die Gre des Import-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetIDataSize64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;



		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size;
};

//*****************************************************************************
//*
//*		GetIDataPtr32
//*
//*****************************************************************************
IMAGE_IMPORT_DESCRIPTOR	*GetIDataPtr32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_IMPORT_DESCRIPTOR*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetIDataPtr64
//*
//*****************************************************************************
IMAGE_IMPORT_DESCRIPTOR	*GetIDataPtr64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_IMPORT_DESCRIPTOR*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetRelocPtr32
//*
//*****************************************************************************
IMAGE_BASE_RELOCATION *GetRelocPtr32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_BASE_RELOCATION*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetRelocPtr64
//*
//*****************************************************************************
IMAGE_BASE_RELOCATION *GetRelocPtr64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_BASE_RELOCATION*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetRelocSize32
//*
//*****************************************************************************
//	Holt die Gre des Realoc-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetRelocSize32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].Size;
};

//*****************************************************************************
//*
//*		GetRelocSize64
//*
//*****************************************************************************
//	Holt die Gre des Realoc-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetRelocSize64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].Size;
};

//*****************************************************************************
//*
//*		GetRescPtr32
//*
//*****************************************************************************
IMAGE_RESOURCE_DIRECTORY *GetRsrcPtr32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_RESOURCE_DIRECTORY*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetRescPtr64
//*
//*****************************************************************************
IMAGE_RESOURCE_DIRECTORY *GetRsrcPtr64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;
DWORD				 uOffset;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader )return 0;
		uOffset=pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE].VirtualAddress;
	if(!uOffset)return 0;


return (IMAGE_RESOURCE_DIRECTORY*)PTR_ADD_32(pInstance,uOffset);
};

//*****************************************************************************
//*
//*		GetRsrcSize32
//*
//*****************************************************************************
//	Holt die Gre des Resoursen-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetRsrcSize32(void *pInstance)
{
IMAGE_NT_HEADERS32	*pPeHeader;


		pPeHeader=GetPeHeader32(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE].Size;
};

//*****************************************************************************
//*
//*		GetRsrcSize64
//*
//*****************************************************************************
//	Holt die Gre des Resoursen-Datenbereichs aus einem Instanz-Handle
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	Ergibt die Gre in Byte oder 0 bei einem Fehler
DWORD GetRsrcSize64(void *pInstance)
{
IMAGE_NT_HEADERS64	*pPeHeader;


		pPeHeader=GetPeHeader64(pInstance);
	if(!pPeHeader)return 0;


return pPeHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE].Size;
};


//*****************************************************************************
//*
//*		FindExportProc32
//*
//*****************************************************************************
//	Sucht nach einer Export-Funktion
//	pEData		: Zeiger auf den Export-Datenabschnitt
//	pBase		: Handle der Instanze, oder Basisadresse
//	uProc		: Ist der Offset auf die Funktion relative zur Basisadresse
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pIndex		: Ist pIndex  !=0 so wird dort der Index der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
//	bzw. "*" wenn nur ein Ordinal existiert.
const char *FindExportProc32(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uProc,WORD *pOrdinal,DWORD *pIndex)
{
DWORD	   *pEntries;
DWORD	   *pNames;
WORD	   *pList;
unsigned	uCount;
unsigned	uName;
unsigned	uPos;
unsigned	uMax;



	if(!pEData || !pBase)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pIndex  )*pIndex  =0xFFFFFFFF;
		return 0;
		}

	uCount	 =  pEData->NumberOfFunctions;
	uName	 =  pEData->NumberOfNames;
	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uMax	 = (uCount>uName)? uCount:uName;


	for(uPos=0;;uPos++)						// Suche Funktionsoffset
		{
		if(uPos>=uMax)
			{
			if(pOrdinal)*pOrdinal=0xFFFF;
			if(pIndex  )*pIndex  =0xFFFFFFFF;
			return 0;
			}

		if(pEntries[uPos]==uProc)break;
		}

	if(pIndex)*pIndex=uPos;

	if(pOrdinal)
		{
		if(uPos<uCount)						// Ist die Position ber der Feldgre
				*pOrdinal=pList[uPos]+(short)pEData->Base;
		else	*pOrdinal=0xFFFF;
		}


	if(uPos>=uName)return "*";


return (char*)pBase+pNames[uPos];
}



//*****************************************************************************
//*
//*		FindExportProc64
//*
//*****************************************************************************
//	Sucht nach einer Export-Funktion
//	pEData		: Zeiger auf den Export-Datenabschnitt
//	pBase		: Handle der Instanze, oder Basisadresse
//	uProc		: Ist der Offset auf die Funktion relative zur Basisadresse
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pIndex		: Ist pIndex  !=0 so wird dort der Index der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
//	bzw. "*" wenn nur ein Ordinal existiert.
const char *FindExportProc64(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uProc,WORD *pOrdinal,DWORD *pIndex)
{
DWORD	   *pEntries;
DWORD	   *pNames;
WORD	   *pList;
unsigned	uCount;
unsigned	uName;
unsigned	uPos;
unsigned	uMax;



	if(!pEData || !pBase)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pIndex  )*pIndex  =0xFFFFFFFF;
		return 0;
		}

	uCount	 =  pEData->NumberOfFunctions;
	uName	 =  pEData->NumberOfNames;
	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uMax	 = (uCount>uName)? uCount:uName;


	for(uPos=0;;uPos++)						// Suche Funktionsoffset
		{
		if(uPos>=uMax)
			{
			if(pOrdinal)*pOrdinal=0xFFFF;
			if(pIndex  )*pIndex  =0xFFFFFFFF;
			return 0;
			}

		if(pEntries[uPos]==uProc)break;
		}

	if(pIndex)*pIndex=uPos;

	if(pOrdinal)
		{
		if(uPos<uCount)						// Ist die Position ber der Feldgre
				*pOrdinal=pList[uPos]+(short)pEData->Base;
		else	*pOrdinal=0xFFFF;
		}


	if(uPos>=uName)return "*";


return (char*)pBase+pNames[uPos];
}

//*****************************************************************************
//*
//*		FindExportProc32
//*
//*****************************************************************************
//	Sucht nach einer Export-Funktion
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Ist der Zeiger auf die Funktion
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pIndex		: Ist pIndex  !=0 so wird dort der Index der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
//	bzw. "*" wenn nur ein Ordinal existiert.
const char *FindExportProc32(const char *pDllName,void *pProc,WORD *pOrdinal,DWORD *pIndex)
{
#ifdef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pIndex )*pIndex =0;
	return 0;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pIndex )*pIndex =0;
		return 0;
		}

	return FindExportProc32(hDll,pProc,pOrdinal,pIndex);

#endif
}

//*****************************************************************************
//*
//*		FindExportProc64
//*
//*****************************************************************************
//	Sucht nach einer Export-Funktion
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Ist der Zeiger auf die Funktion
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pIndex		: Ist pIndex  !=0 so wird dort der Index der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
//	bzw. "*" wenn nur ein Ordinal existiert.
const char *FindExportProc64(const char *pDllName,void *pProc,WORD *pOrdinal,DWORD *pIndex)
{
#ifndef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pIndex )*pIndex =0;
	return 0;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pIndex )*pIndex =0;
		return 0;
		}

	return FindExportProc64(hDll,pProc,pOrdinal,pIndex);

#endif
}

//*****************************************************************************
//*
//*		FindExportProc32
//*
//*****************************************************************************
//	Sucht nach einer Export-Funktion
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Ist der Zeiger auf die Funktion
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pIndex		: Ist pIndex  !=0 so wird dort der Index der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
//	bzw. "*" wenn nur ein Ordinal existiert.
const char *FindExportProc32(HMODULE hDll,void *pProc,WORD *pOrdinal,DWORD *pIndex)
{
#ifdef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pIndex )*pIndex =0;
	return 0;

#else

	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pIndex )*pIndex =0;
		return 0;
		}

	return FindExportProc32(GetEDataPtr32(hDll),hDll,(DWORD)PTR_SUB_32(pProc,hDll),pOrdinal,pIndex);

#endif
}

//*****************************************************************************
//*
//*		FindExportProc64
//*
//*****************************************************************************
//	Sucht nach einer Export-Funktion
//	pProc		: Ist der Zeiger auf die Funktion
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pIndex		: Ist pIndex  !=0 so wird dort der Index der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
//	bzw. "*" wenn nur ein Ordinal existiert.
const char *FindExportProc64(HMODULE hDll,void *pProc,WORD *pOrdinal,DWORD *pIndex)
{
#ifndef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pIndex )*pIndex =0;
	return 0;

#else

	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pIndex )*pIndex =0;
		return 0;
		}

	return FindExportProc64(GetEDataPtr64(hDll),hDll,(DWORD)PTR_SUB_64(pProc,hDll),pOrdinal,pIndex);

#endif
}

//*****************************************************************************
//*
//*		GetExportProc32
//*
//*****************************************************************************
//	Ergibt den Namen der Export-Funktion mit der Nummer uIndex
//	pEData		: Zeiger auf den Export-Datenabschnitt
//	pBase		: Handle der Instanze, oder Basisadresse
//	uIndex		: Ist der Index der Funktion. Ist das Bit 0x80000000 gesetzt
//				  so wird nach der Ordinal-Nummer gesucht.
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pOffset		: Ist pOffset !=0 so wird dort der Offset der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
char *GetExportProc32(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uIndex,WORD *pOrdinal,DWORD *pOffset)
{
DWORD	   *pEntries;
DWORD	   *pNames;
WORD	   *pList;
unsigned	uCount;
unsigned	uMode;
unsigned	uName;
unsigned	uOrd;
unsigned	uPos;


	if(!pEData || !pBase)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	uMode	 =  0x80000000&uIndex;
	uIndex	&=  0x7FFFFFFF;
	uCount	 =  pEData->NumberOfFunctions;
	uName	 =  pEData->NumberOfNames;

	if(!uMode && uIndex>=uCount)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);

	if(uMode)
		{
		uIndex -= pEData->Base;

		for(uPos=0;uPos<uName;uPos++)
			{
			if(pList[uPos]==uIndex)break;
			}

		if(uPos<uName)					// Wurde Ordinal gefunden
			{
			uIndex  = uPos;
			}
		}

	if(uIndex>=uCount)					// Ist die eine Funktion vorhanden
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	if(uIndex>=uName)					// Funktion ohne Namen (Orinale ab 100h...)
		{
		if(pOrdinal)*pOrdinal=(WORD)(uIndex+pEData->Base);
		if(pOffset )*pOffset =pEntries[uIndex];
		return "???";
		}


	uOrd = pList[uIndex];

	if(pOrdinal)*pOrdinal= uOrd+(short)pEData->Base;
	if(pOffset )*pOffset =(uOrd>=uCount)? 0:pEntries[uOrd];


return (char*)pBase+pNames[uIndex];
}

//*****************************************************************************
//*
//*		GetExportProc64
//*
//*****************************************************************************
//	Ergibt den Namen der Export-Funktion mit der Nummer uIndex
//	pEData		: Zeiger auf den Export-Datenabschnitt
//	pBase		: Handle der Instanze, oder Basisadresse
//	uIndex		: Ist der Index der Funktion. Ist das Bit 0x80000000 gesetzt
//				  so wird nach der Ordinal-Nummer gesucht.
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pOffset		: Ist pOffset !=0 so wird dort der Offset der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
char *GetExportProc64(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uIndex,WORD *pOrdinal,DWORD *pOffset)
{
DWORD	   *pEntries;
DWORD	   *pNames;
WORD	   *pList;
unsigned	uCount;
unsigned 	uMode;
unsigned	uName;
unsigned	uOrd;
unsigned	uPos;



	if(!pEData || !pBase)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	uMode	 =  0x80000000&uIndex;
	uIndex	&=  0x7FFFFFFF;
	uCount	 =  pEData->NumberOfFunctions;
	uName	 =  pEData->NumberOfNames;

	if(!uMode && uIndex>=uCount)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);

	if(uMode)
		{
		uIndex -= pEData->Base;

		for(uPos=0;uPos<uName;uPos++)
			{
			if(pList[uPos]==uIndex)break;
			}

		if(uPos<uName)					// Wurde Ordinal gefunden
			{
			uIndex  = uPos;
			}
		}

	if(uIndex>=uCount)					// Ist die eine Funktion vorhanden
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	if(uIndex>=uName)					// Funktion ohne Namen (Orinale ab 100h...)
		{
		if(pOrdinal)*pOrdinal=(WORD)(uIndex+pEData->Base);
		if(pOffset )*pOffset =pEntries[uIndex];
		return "???";
		}


	uOrd = pList[uIndex];

	if(pOrdinal)*pOrdinal= uOrd+(short)pEData->Base;
	if(pOffset )*pOffset =(uOrd>=uCount)? 0:pEntries[uOrd];


return (char*)pBase+pNames[uIndex];
}

//*****************************************************************************
//*
//*		GetExportProc32
//*
//*****************************************************************************
//	Ergibt den Namen der Export-Funktion mit der Nummer uIndex
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	uIndex		: Ist der Index der Funktion. Ist das Bit 0x80000000 gesetzt
//				  so wird nach der Ordinal-Nummer gesucht.
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pOffset		: Ist pOffset !=0 so wird dort der Offset der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
char *GetExportProc32(const char *pDllName,DWORD uIndex,WORD *pOrdinal,DWORD *pOffset)
{
#ifdef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pOffset )*pOffset =0;
	return 0;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	return GetExportProc32(hDll,uIndex,pOrdinal,pOffset);

#endif
}

//*****************************************************************************
//*
//*		GetExportProc64
//*
//*****************************************************************************
//	Ergibt den Namen der Export-Funktion mit der Nummer uIndex
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	uIndex		: Ist der Index der Funktion. Ist das Bit 0x80000000 gesetzt
//				  so wird nach der Ordinal-Nummer gesucht.
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pOffset		: Ist pOffset !=0 so wird dort der Offset der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
char *GetExportProc64(const char *pDllName,DWORD uIndex,WORD *pOrdinal,DWORD *pOffset)
{
#ifndef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pOffset )*pOffset =0;
	return 0;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	return GetExportProc64(hDll,uIndex,pOrdinal,pOffset);

#endif
}

//*****************************************************************************
//*
//*		GetExportProc32
//*
//*****************************************************************************
//	Ergibt den Namen der Export-Funktion mit der Nummer uIndex
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	uIndex		: Ist der Index der Funktion. Ist das Bit 0x80000000 gesetzt
//				  so wird nach der Ordinal-Nummer gesucht.
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pOffset		: Ist pOffset !=0 so wird dort der Offset der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
char *GetExportProc32(HMODULE hDll,DWORD uIndex,WORD *pOrdinal,DWORD *pOffset)
{
#ifdef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pOffset )*pOffset =0;
	return 0;

#else

	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	return GetExportProc32(GetEDataPtr32(hDll),hDll,uIndex,pOrdinal,pOffset);

#endif
}

//*****************************************************************************
//*
//*		GetExportProc64
//*
//*****************************************************************************
//	Ergibt den Namen der Export-Funktion mit der Nummer uIndex
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	uIndex		: Ist der Index der Funktion. Ist das Bit 0x80000000 gesetzt
//				  so wird nach der Ordinal-Nummer gesucht.
//	pOrdinal	: Ist pOrdinal!=0 so wird dort die Funktions-Nummer abgelegt.
//	pOffset		: Ist pOffset !=0 so wird dort der Offset der Funktion abgelegt.
//	Ergibt 0 wenn keine Funktion gefunden wurde, oder einen Zeiger auf den Namen.
char *GetExportProc64(HMODULE hDll,DWORD uIndex,WORD *pOrdinal,DWORD *pOffset)
{
#ifndef _WIN64

	if(pOrdinal)*pOrdinal=0xFFFF;
	if(pOffset )*pOffset =0;
	return 0;

#else

	if(!hDll)
		{
		if(pOrdinal)*pOrdinal=0xFFFF;
		if(pOffset )*pOffset =0;
		return 0;
		}

	return GetExportProc64(GetEDataPtr64(hDll),hDll,uIndex,pOrdinal,pOffset);

#endif
}

//*****************************************************************************
//*
//*		SetExportProc32
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetExportProc32(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	DWORD	   *pEntries;
	DWORD	   *pNames;
	WORD	   *pList;
	char       *pPtr;
	unsigned	uIndex;
	unsigned 	uCount;
	unsigned 	uName;
	unsigned 	uOrd;


	if(pOldProc)*pOldProc=0;
	if(!pEData )return FALSE;

	uCount	 = pEData->NumberOfFunctions;
	uName	 = pEData->NumberOfNames;

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uOrd	 = (DWORD )pName;

	if(!(uOrd&0xFFFF0000))
		{
		uOrd -= pEData->Base;

		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			if(pList[uIndex]==uOrd)break;
			}
		}
	else{
		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			pPtr=(char*)pBase+pNames[uIndex];
			if(!strcmp(pName,pPtr))break;
			}
		}


	   uIndex = pList[uIndex];
	if(uIndex>=uCount)return FALSE;

	//if(IsBadWritePtr(pEntries+uIndex,4))
	if(!UnProtect(pEntries+uIndex,4))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		*pOldProc = (void*)PTR_ADD_32(pBase,pEntries[uIndex]);
		}

	pEntries[uIndex] = (DWORD)pNewProc-(DWORD)pBase;


	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		SetExportProc64
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetExportProc64(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	DWORD      *pEntries;
	DWORD	   *pNames;
	WORD	   *pList;
	char       *pPtr;
	unsigned	uIndex;
	unsigned 	uCount;
	unsigned 	uName;
	ULONGLONG 	uDiff;
	ULONGLONG 	uOrd;
	DWORD	  	uOld;


	if(pOldProc)*pOldProc=0;
	if(!pEData )return FALSE;

	uCount	 = pEData->NumberOfFunctions;
	uName	 = pEData->NumberOfNames;

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uOrd	 = (ULONGLONG)pName;

	if(!(uOrd&0xFFFFFFFFFFFF0000))
		{
		uOrd -= pEData->Base;

		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			if(pList[uIndex]==uOrd)break;
			}
		}
	else{
		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			pPtr=(char*)pBase+pNames[uIndex];
			if(!strcmp(pName,pPtr))break;
			}
		}


	   uIndex = pList[uIndex];
	if(uIndex>=uCount)return FALSE;

	uDiff	= (ULONGLONG)pNewProc-(ULONGLONG)pBase;

	if(uDiff&0xFFFFFFFF00000000)
		{
		// REM AZ funktioniert nicht da der OFFSET ber 64-Bit ist (jump einrichten)
		return FALSE;
		}

	//if(IsBadWritePtr(pEntries+uIndex,4))
	if(!UnProtect(pEntries+uIndex,4))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		*pOldProc = (void*)PTR_ADD_32(pBase,pEntries[uIndex]);
		}

	pEntries[uIndex] = (DWORD)pNewProc-(DWORD)pBase;


	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		SetExportProc32
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportProc32(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)return FALSE;

	return SetExportProc32(hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportProc64
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportProc64(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)return FALSE;

	return SetExportProc64(hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportProc32
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportProc32(HMODULE hDll,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	IMAGE_EXPORT_DIRECTORY	*pEData;
	char					 cPath[256];

	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

		pEData=GetEDataPtr32(hDll);
	if(!pEData)return FALSE;

	return SetExportProc32(pEData,hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportProc64
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportProc64(HMODULE hDll,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	IMAGE_EXPORT_DIRECTORY	*pEData;
	char					 cPath[256];

	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

		pEData=GetEDataPtr64(hDll);
	if(!pEData)return FALSE;

	return SetExportProc64(pEData,hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetImportProc32
//*
//*****************************************************************************
//	ndert alle Import-Tabellen in einem Prozess
//	pDllName	: Name der DLL mit der Funktion die gendert werden soll
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert
//	iFlags		: Diverse Flags
//					PE_NO_SYSTEM = Keine System-DLL's ndern
//	Ergibt die Anzahl der genderten Funktionen
int SetImportProc32(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc,int iFlags)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return 0;

#else

	char						cPath[256];
	MEMORY_BASIC_INFORMATION	sMi;
	SYSTEM_INFO					sSi;
	BOOL						bOk;
	BOOL						bExit;
	DWORD						dwPtr;
	DWORD						dwOld;
	DWORD						dwMax;
	DWORD						uSize;
	DWORD						uMask;
	DWORD						uAddr;
	int							iNum;


	GetSystemInfo(&sSi);

	iNum	= 0;
	bExit	= FALSE;
	dwPtr	= (DWORD)sSi.lpMinimumApplicationAddress;
	dwMax	= (DWORD)sSi.lpMaximumApplicationAddress;
	uAddr	= sSi.dwPageSize;
	uMask	= ~(uAddr-1);

	for(;;)										// Suche alle Module
		{
		sMi.BaseAddress=0;
		bOk = VirtualQuery((void*)dwPtr,&sMi,sizeof(sMi));

		if(GetModuleFileName((HMODULE)dwPtr,cPath,sizeof(cPath)))
			{
			bOk = TRUE;

			if(iFlags&PE_NO_SYSTEM)
				{
				strupr(cPath);
				if(strstr(cPath,"\\SYSTEM32\\"))bOk=FALSE;
				if(strstr(cPath,"\\SYSWOW64\\"))bOk=FALSE;
				}

			if(bOk && SetImportProc32((HMODULE)dwPtr,pDllName,pProc,pNewPorc,pOldProc))
				{
				iNum++;
				}
			}

		dwOld = dwPtr;
		uSize = sMi.RegionSize&uMask;

		if(!uSize)uSize=uAddr;
			dwPtr+=uSize;
		if(!dwPtr       )break;
		if( dwPtr< dwOld)break;
		if( dwPtr>=dwMax)break;
		}


	return iNum;

#endif
}

//*****************************************************************************
//*
//*		SetImportProc64
//*
//*****************************************************************************
//	ndert alle Import-Tabellen in einem Prozess
//	pDllName	: Name der DLL mit der Funktion die gendert werden soll
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	iFlags		: Diverse Flags
//					PE_NO_SYSTEM = Keine System-DLL's ndern
//	Ergibt die Anzahl der genderten Funktionen
int SetImportProc64(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc,int iFlags)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return 0;

#else

	char						cPath[256];
	MEMORY_BASIC_INFORMATION	sMi;
	SYSTEM_INFO					sSi;
	BOOL						bOk;
	BOOL						bExit;
	ULONGLONG					dwPtr;
	ULONGLONG					dwOld;
	ULONGLONG					dwMax;
	ULONGLONG					uSize;
	ULONGLONG					uMask;
	ULONGLONG					uAddr;
	int							iNum;


	GetSystemInfo(&sSi);

	iNum	= 0;
	bExit	= FALSE;
	dwPtr	= (ULONGLONG)sSi.lpMinimumApplicationAddress;
	dwMax	= (ULONGLONG)sSi.lpMaximumApplicationAddress;
	uAddr	= sSi.dwPageSize;
	uMask	= ~(uAddr-1);

	for(;;) 									// Suche alle Module
		{
		sMi.BaseAddress=0;
		bOk = VirtualQuery((void*)dwPtr,&sMi,sizeof(sMi));

		if(GetModuleFileName((HMODULE)dwPtr,cPath,sizeof(cPath)))
			{
			bOk = TRUE;

			if(iFlags&PE_NO_SYSTEM)
				{
				strupr(cPath);
				if(strstr(cPath,"\\SYSTEM32\\"))bOk=FALSE;
				if(strstr(cPath,"\\SYSWOW64\\"))bOk=FALSE;
				}

			if(bOk && SetImportProc64((HMODULE)dwPtr,pDllName,pProc,pNewPorc,pOldProc))
				{
				iNum++;
				}
			}

		dwOld = dwPtr;
		uSize = sMi.RegionSize&uMask;

		if(!uSize)uSize=uAddr;
			dwPtr+=uSize;
		if(!dwPtr       )break;
		if( dwPtr< dwOld)break;
		if( dwPtr>=dwMax)break;
		}


	return iNum;

#endif
}

//*****************************************************************************
//*
//*		SetImportProc32
//*
//*****************************************************************************
//	ndert alle Import-Tabellen in einem Modul
//	pModule		: Name des Modules mit den Import-Tabellen
//	pDllName	: Dll-Name der Funktion die gendert werden soll
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt die Anzahl der genderten Funktionen
BOOL SetImportProc32(const char *pModule,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE		hDll;

	hDll=GetModuleHandle(pModule);

	return SetImportProc32(hDll,pDllName,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetImportProc64
//*
//*****************************************************************************
//	ndert alle Import-Tabellen in einem Modul
//	pModule		: Name des Modules mit den Import-Tabellen
//	pDllName	: Dll-Name der Funktion die gendert werden soll
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt die Anzahl der genderten Funktionen
BOOL SetImportProc64(const char *pModule,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE		hDll;

	hDll=GetModuleHandle(pModule);

	return SetImportProc64(hDll,pDllName,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetImportProc32
//*
//*****************************************************************************
//	ndert alle Import-Tabellen in einem Modul
//	hDll		: Handle des Modules mit den Import-Tabellen
//	pDllName	: Dll-Name der Funktion die gendert werden soll
//	pProc		: Name der Funktion die gendert werden soll (NULL=nur Abfrage)
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt die Anzahl der genderten Funktionen
BOOL SetImportProc32(HMODULE hDll,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	char					 cPath[256];
	IMAGE_THUNK_DATA32	    *pNameThunk;
	IMAGE_THUNK_DATA32	    *pAddrThunk;
	IMAGE_IMPORT_DESCRIPTOR	*pIData;
	IMAGE_NT_HEADERS32		*pPeHdr;
	char					*pName;
	void					*pItem;
	DWORD					 dwPos;
	int						 i,iLen;


	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

	iLen   = strlen(pDllName);

	if(iLen>4 && !memicmp(pDllName+iLen-4,".dll",4))
		{
		iLen-=4;
		}

	pPeHdr = (IMAGE_NT_HEADERS32     *)PTR_ADD_32(hDll,((IMAGE_DOS_HEADER*)hDll)->e_lfanew);
	pIData = (IMAGE_IMPORT_DESCRIPTOR*)PTR_ADD_32(hDll,pPeHdr->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);

	for(i=0;;i++)						// Suche Import Dll's
		{
		if(i>=256)break;
		if(!pIData[i].Name	      )break;
		if(!pIData[i].FirstThunk  )break;
		if( pIData[i].Name==0xFFFF)continue;

		pName = (char*)PTR_ADD_32(hDll,pIData[i].Name);
		if(memicmp(pName,pDllName,iLen))continue;
		if(pName[iLen]!=0 && pName[iLen]!='.')continue;


		pNameThunk = (IMAGE_THUNK_DATA32*)PTR_ADD_32(hDll,pIData[i].OriginalFirstThunk);
		pAddrThunk = (IMAGE_THUNK_DATA32*)PTR_ADD_32(hDll,pIData[i].FirstThunk);

		for(i=0;;i++)					// Suche Funktion
			{
			if(i>=4096)break;;
			if(!pNameThunk[i].u1.AddressOfData)break;

			   dwPos=pNameThunk[i].u1.Ordinal;
			if(dwPos&0x80000000)continue;

			pName = (char*)PTR_ADD_32(hDll,dwPos+2);

			if(!strcmp(pName,pProc))   // Setze Funktions Pointer
				{
				pItem = (void*)pAddrThunk[i].u1.Function;
				if(pOldProc)*pOldProc=pItem;
				if(pNewPorc==pItem)return 2;
				if(pNewPorc==NULL )return TRUE;

				if(!UnProtect(&pAddrThunk[i].u1.Function,4))
					{
					return FALSE;
					}

				*(DWORD *)&pAddrThunk[i].u1.Function = (DWORD)pNewPorc;

				return TRUE;
				}
			}

		break;
		}


	return FALSE;

#endif
}

//*****************************************************************************
//*
//*		SetImportProc64
//*
//*****************************************************************************
//	ndert alle Import-Tabellen in einem Modul
//	hDll		: Handle des Modules mit den Import-Tabellen
//	pDllName	: Dll-Name der Funktion die gendert werden soll
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt die Anzahl der genderten Funktionen
BOOL SetImportProc64(HMODULE hDll,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	char					 cPath[256];
	IMAGE_THUNK_DATA64	    *pNameThunk;
	IMAGE_THUNK_DATA64	    *pAddrThunk;
	IMAGE_IMPORT_DESCRIPTOR	*pIData;
	IMAGE_NT_HEADERS64		*pPeHdr;
	char					*pName;
	void					*pItem;
	ULONGLONG				 dwPos;
	ULONGLONG				 dwOld;
	int						 i,iLen;


	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

	iLen   = strlen(pDllName);

	if(iLen>4 && !memicmp(pDllName+iLen-4,".dll",4))
		{
		iLen-=4;
		}

	pPeHdr = (IMAGE_NT_HEADERS64     *)PTR_ADD_32(hDll,((IMAGE_DOS_HEADER*)hDll)->e_lfanew);
	pIData = (IMAGE_IMPORT_DESCRIPTOR*)PTR_ADD_32(hDll,pPeHdr->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);

	for(i=0;;i++)						// Suche Import Dll's
		{
		if(i>=256)break;
		if(!pIData[i].Name	      )break;
		if(!pIData[i].FirstThunk  )break;
		if( pIData[i].Name==0xFFFF)continue;

		pName = (char*)PTR_ADD_32(hDll,pIData[i].Name);
		if(memicmp(pName,pDllName,iLen))continue;
		if(pName[iLen]!=0 && pName[iLen]!='.')continue;


		pNameThunk = (IMAGE_THUNK_DATA64*)PTR_ADD_64(hDll,pIData[i].OriginalFirstThunk);
		pAddrThunk = (IMAGE_THUNK_DATA64*)PTR_ADD_64(hDll,pIData[i].FirstThunk);

		for(i=0;;i++)					// Suche Funktion
			{

			if(i>=4096)break;;
			if(!pNameThunk[i].u1.AddressOfData)break;

			   dwPos=pNameThunk[i].u1.Ordinal;
			if(dwPos&0x8000000000000000)continue;

			pName = (char*)PTR_ADD_64(hDll,dwPos+2);

			if(!strcmp(pName,pProc))   // Setze Funktions Pointer
				{
				pItem = (void*)pAddrThunk[i].u1.Function;
				if(pOldProc)*pOldProc=pItem;
				if(pNewPorc==pItem)return 2;
				if(pNewPorc==NULL )return TRUE;

				if(!UnProtect(&pAddrThunk[i].u1.Function,8))
					{
					return FALSE;
					}

				*(ULONGLONG*)&pAddrThunk[i].u1.Function = (ULONGLONG)pNewPorc;

				return TRUE;
				}
			}

		break;
		}


	return FALSE;

#endif
}

//*****************************************************************************
//*
//*		GetImportDll32
//*
//*****************************************************************************
//	Ergibt den Namnen der Import-Dll von einem bestimmten Index
//	pIData		: Zeiger auf den Import-Abschnitt.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	pNameThunk	: Zeiger in dem die Funktions-Daten-Namen gespeichert werden.
//				  Kann auch NULL sein.
//	pAddrThunk	: Zeiger in dem die Funktions-Daten-Adressen gespeichert werden.
//				  Kann auch NULL sein.
//	Ergibt den Namen der DLL bzw. 0 wenn keine gefunden wurde
const char *GetImportDll32(IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,DWORD uIndex,
						   IMAGE_THUNK_DATA32     **pNameThunk,
						   IMAGE_THUNK_DATA32     **pAddrThunk)
{
unsigned	uPos;



	if(!pIData)return 0;


	for(uPos=0;;uPos++)						// Suche Import Dll's
		{
		if(uPos>=256                 )return 0;
		if(pIData[uPos].Name	  ==0)return 0;
		if(pIData[uPos].FirstThunk==0)return 0;
		if(uPos==uIndex)break;
		}

	if(pNameThunk)
		{
		*pNameThunk = (IMAGE_THUNK_DATA32*)PTR_ADD_32(pBase,pIData[uPos].OriginalFirstThunk);
		}

	if(pAddrThunk)
		{
		*pAddrThunk = (IMAGE_THUNK_DATA32*)PTR_ADD_32(pBase,pIData[uPos].FirstThunk);
		}


return PTR_ADD_32(pBase,pIData[uPos].Name);
}

//*****************************************************************************
//*
//*		GetImportDll64
//*
//*****************************************************************************
//	Ergibt den Namnen der Import-Dll von einem bestimmten Index
//	pIData		: Zeiger auf den Import-Abschnitt.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	pNameThunk	: Zeiger in dem die Funktions-Daten-Namen gespeichert werden.
//				  Kann auch NULL sein.
//	pAddrThunk	: Zeiger in dem die Funktions-Daten-Adressen gespeichert werden.
//				  Kann auch NULL sein.
//	Ergibt den Namen der DLL bzw. 0 wenn keine gefunden wurde
const char *GetImportDll64(IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,DWORD uIndex,
		  				   IMAGE_THUNK_DATA64     **pNameThunk,
						   IMAGE_THUNK_DATA64     **pAddrThunk)
{
unsigned	uPos;



	if(!pIData)return 0;


	for(uPos=0;;uPos++)						// Suche Import Dll's
		{
		if(uPos>=256                 )return 0;
		if(pIData[uPos].Name	  ==0)return 0;
		if(pIData[uPos].FirstThunk==0)return 0;
		if(uPos==uIndex)break;
		}

	if(pNameThunk)
		{
		*pNameThunk = (IMAGE_THUNK_DATA64*)PTR_ADD_64(pBase,pIData[uPos].OriginalFirstThunk);
		}

	if(pAddrThunk)
		{
		*pAddrThunk = (IMAGE_THUNK_DATA64*)PTR_ADD_64(pBase,pIData[uPos].FirstThunk);
		}


return PTR_ADD_32(pBase,pIData[uPos].Name);
}

//*****************************************************************************
//*
//*		GetImportDll32
//*
//*****************************************************************************
//	Sucht nach einer Import-Dll mit einem bestimmten Namen
//	pIData		: Zeiger auf den Import-Abschnitt.
//	pBase		: Handle der Instanz
//	pName		: Name der Dll (z.B. "KERNEL32" oder "Kernel32.dll")
//	pNameThunk	: Zeiger in dem die Funktions-Daten-Namen gespeichert werden.
//				  Kann auch NULL sein.
//	pAddrThunk	: Zeiger in dem die Funktions-Daten-Adressen gespeichert werden.
//				  Kann auch NULL sein.
//	Ergibt den Namen der DLL bzw. 0 wenn keine gefunden wurde
const char *GetImportDll32(IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,LPCSTR pName,
						   IMAGE_THUNK_DATA32     **pNameThunk,
						   IMAGE_THUNK_DATA32     **pAddrThunk)
{
const char *pDll;
unsigned	uPos;
unsigned	uLen;



	if(!pIData)return 0;


	uLen = strlen(pName);
											// Suffix entfernen
	if(uLen>4 && !memicmp(pName+uLen-4,".dll",4))
		{
		uLen -= 4;
		}


	for(uPos=0;;uPos++)						// Suche Import Dll
		{
		if(uPos>=256                 )return 0;
		if(pIData[uPos].Name	  ==0)return 0;
		if(pIData[uPos].FirstThunk==0)return 0;

		pDll = PTR_ADD_32(pBase,pIData[uPos].Name);

		if(memicmp(pDll,pName,uLen))continue;
		if(pDll[uLen]==0)break;
		if(memicmp(pDll+uLen,".dll",4)==0)break;
		}

	if(pNameThunk)
		{
		*pNameThunk = (IMAGE_THUNK_DATA32*)PTR_ADD_32(pBase,pIData[uPos].OriginalFirstThunk);
		}

	if(pAddrThunk)
		{
		*pAddrThunk = (IMAGE_THUNK_DATA32*)PTR_ADD_32(pBase,pIData[uPos].FirstThunk);
		}


return pDll;
}

//*****************************************************************************
//*
//*		GetImportDll64
//*
//*****************************************************************************
//	Sucht nach einer Import-Dll mit einem bestimmten Namen
//	pIData		: Zeiger auf den Import-Abschnitt.
//	pBase		: Handle der Instanz
//	pName		: Name der Dll (z.B. "KERNEL64" oder "Kernel64.dll")
//	pNameThunk	: Zeiger in dem die Funktions-Daten-Namen gespeichert werden.
//				  Kann auch NULL sein.
//	pAddrThunk	: Zeiger in dem die Funktions-Daten-Adressen gespeichert werden.
//				  Kann auch NULL sein.
//	Ergibt den Namen der DLL bzw. 0 wenn keine gefunden wurde
const char *GetImportDll64(IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,LPCSTR pName,
						   IMAGE_THUNK_DATA64     **pNameThunk,
						   IMAGE_THUNK_DATA64     **pAddrThunk)
{
const char *pDll;
unsigned	uPos;
unsigned	uLen;



	if(!pIData)return 0;


	uLen = strlen(pName);
											// Suffix entfernen
	if(uLen>4 && !memicmp(pName+uLen-4,".dll",4))
		{
		uLen -= 4;
		}


	for(uPos=0;;uPos++)						// Suche Import Dll
		{
		if(uPos>=256                 )return 0;
		if(pIData[uPos].Name	  ==0)return 0;
		if(pIData[uPos].FirstThunk==0)return 0;

		pDll = PTR_ADD_64(pBase,pIData[uPos].Name);

		if(memicmp(pDll,pName,uLen))continue;
		if(pDll[uLen]==0)break;
		if(memicmp(pDll+uLen,".dll",4)==0)break;
		}

	if(pNameThunk)
		{
		*pNameThunk = (IMAGE_THUNK_DATA64*)PTR_ADD_64(pBase,pIData[uPos].OriginalFirstThunk);
		}

	if(pAddrThunk)
		{
		*pAddrThunk = (IMAGE_THUNK_DATA64*)PTR_ADD_64(pBase,pIData[uPos].FirstThunk);
		}


return pDll;
}


//*****************************************************************************
//*
//*		GetImportName32
//*
//*****************************************************************************
//	Ergibt den Namnen der Import-Funktion von einem bestimmten Index
//	pThunk		: Zeiger auf den Dll-Abschnitt mit den Namen.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	Ergibt den Namen der DLL bzw. 0 wenn keine gefunden wurde
const char *GetImportName32(IMAGE_THUNK_DATA32 *pThunk,void *pBase,DWORD uIndex)
{
DWORD		uNum;
DWORD		uPos;



	if(!pThunk)return 0;

	for(uNum=0;;uNum++)
		{
		if(uNum>=4096)return 0;
		if(!pThunk[uNum].u1.Ordinal)return 0;
		if(uNum==uIndex)break;
		}

	uPos = pThunk[uNum].u1.Ordinal;

	if(uPos&0x80000000)					// Ordinal Import
		{
		   uPos&=0xFFFF;
		if(uPos==0)uPos=0x10000;

		return (char*)uPos;
		}


return PTR_ADD_32(pBase,uPos+2);
}

//*****************************************************************************
//*
//*		GetImportIndex32
//*
//*****************************************************************************
//	Ergibt den Namnen der Import-Funktion von einem bestimmten Index
//	pThunk		: Zeiger auf den Dll-Abschnitt mit den Namen.
//	pBase		: Handle der Instanz
//	pProc		: Name der gesuchten Funktion
//	Ergibt den Index des Namen im Dll-Abschnitt oder 0xFFFFFFFF bei einem Fehler.
DWORD GetImportIndex32(IMAGE_THUNK_DATA32 *pThunk,void *pBase,LPCSTR pProc)
{
LPCSTR		pName;
DWORD		dwPos;
int			i;


	for(i=0;;i++)						// Suche Funktion
		{

		if(i>=4096)break;;
		if(!pThunk[i].u1.AddressOfData)break;

		   dwPos=pThunk[i].u1.Ordinal;
		if(dwPos&0x80000000)continue;

		pName = (char*)PTR_ADD_32(pBase,dwPos+2);

		if(!strcmp(pName,pProc))		// Funktion gefunden
			{
			return i;
			}
		}

return 0xFFFFFFFF;
}

//*****************************************************************************
//*
//*		GetImportIndex64
//*
//*****************************************************************************
//	Ergibt den Namnen der Import-Funktion von einem bestimmten Index
//	pThunk		: Zeiger auf den Dll-Abschnitt mit den Namen.
//	pBase		: Handle der Instanz
//	pProc		: Name der gesuchten Funktion
//	Ergibt den Index des Namen im Dll-Abschnitt oder 0xFFFFFFFF bei einem Fehler.
DWORD GetImportIndex64(IMAGE_THUNK_DATA64 *pThunk,void *pBase,LPCSTR pProc)
{
LPCSTR		pName;
ULONGLONG	dwPos;
int			i;


	for(i=0;;i++)						// Suche Funktion
		{

		if(i>=4096)break;;
		if(!pThunk[i].u1.AddressOfData)break;

		   dwPos=pThunk[i].u1.Ordinal;
		if(dwPos&0x8000000000000000)continue;

		pName = (char*)PTR_ADD_64(pBase,dwPos+2);

		if(!strcmp(pName,pProc))		// Funktion gefunden
			{
			return i;
			}
		}

return 0xFFFFFFFF;
}

//*****************************************************************************
//*
//*		GetImportName64
//*
//*****************************************************************************
//	Ergibt den Namnen der Import-Funktion von einem bestimmten Index
//	pThunk		: Zeiger auf den Dll-Abschnitt mit den Namen.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	Ergibt den Namen der DLL bzw. 0 wenn keine gefunden wurde
const char *GetImportName64(IMAGE_THUNK_DATA64 *pThunk,void *pBase,DWORD uIndex)
{
ULONGLONG	uPos;
DWORD		uNum;



	if(!pThunk)return 0;

	for(uNum=0;;uNum++)
		{
		if(uNum>=4096)return 0;
		if(!pThunk[uNum].u1.Ordinal)return 0;
		if(uNum==uIndex)break;
		}

	uPos = pThunk[uNum].u1.Ordinal;

	if(uPos&0x8000000000000000)			// Ordinal Import
		{
		   uPos&=0xFFFF;
		if(uPos==0)uPos=0x10000;

		return (char*)uPos;
		}


return PTR_ADD_64(pBase,uPos+2);
}

//*****************************************************************************
//*
//*		GetImportProc32
//*
//*****************************************************************************
//	Ergibt die Adresse der Import-Funktion auf uIndex
//	pThunk		: Zeiger auf den Dll-Abschnitt mid den Addressen.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	Ergibt die Adresse der Funktion bzw. 0 wenn keine gefunden wurde
void *GetImportProc32(IMAGE_THUNK_DATA32 *pThunk,void *pBase,DWORD uIndex)
{
DWORD	uNum;


	if(!pThunk)return 0;

	for(uNum=0;;uNum++)
		{
		if(uNum>=4096)return 0;
		if(pThunk[uNum].u1.Function==0)return 0;
		if(uNum==uIndex)break;
		}


return (void*)pThunk[uNum].u1.Function;
}

//*****************************************************************************
//*
//*		GetImportProc64
//*
//*****************************************************************************
//	Ergibt die Adresse der Import-Funktion auf uIndex
//	pThunk		: Zeiger auf den Dll-Abschnitt mid den Addressen.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	Ergibt die Adresse der Funktion bzw. 0 wenn keine gefunden wurde
void *GetImportProc64(IMAGE_THUNK_DATA64 *pThunk,void *pBase,DWORD uIndex)
{
DWORD	uNum;


	if(!pThunk)return 0;

	for(uNum=0;;uNum++)
		{
		if(uNum>=4096)return 0;
		if(pThunk[uNum].u1.Function==0)return 0;
		if(uNum==uIndex)break;
		}


return (void*)pThunk[uNum].u1.Function;
}

//*****************************************************************************
//*
//*		SetImportProc32
//*
//*****************************************************************************
//	Stellt die Adresse einer Import-Funktion auf einem uIndex neu ein
//	pThunk		: Zeiger auf den Dll-Abschnitt mid den Addressen.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	pAddr		: Neue Funktions-Adresse
//	Ergibt die Adresse der Funktion bzw. 0 wenn keine gefunden wurde
BOOL SetImportProc32(IMAGE_THUNK_DATA32 *pThunk,void *pBase,DWORD uIndex,void *pAddr)
{
#ifdef _WIN64

	return FALSE;

#else

	DWORD	uNum;

	if(!pThunk)return FALSE;

	for(uNum=0;;uNum++)
		{
		if(uNum>=4096)return FALSE;
		if(!pThunk[uNum].u1.AddressOfData)return FALSE;
		if(uNum==uIndex)break;
		}

	if(!UnProtect(&pThunk[uNum].u1.Function,4))
		{
		return FALSE;
		}

	*(DWORD*)&pThunk[uNum].u1.Function = (DWORD)pAddr;


	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		SetImportProc64
//*
//*****************************************************************************
//	Stellt die Adresse einer Import-Funktion auf einem uIndex neu ein
//	pThunk		: Zeiger auf den Dll-Abschnitt mid den Addressen.
//	pBase		: Handle der Instanz
//	uIndex		: Nummer der Dll die abgefragt werden soll.
//	pAddr		: Neue Funktions-Adresse
//	Ergibt die Adresse der Funktion bzw. 0 wenn keine gefunden wurde
BOOL SetImportProc64(IMAGE_THUNK_DATA64 *pThunk,void *pBase,DWORD uIndex,void *pAddr)
{
#ifndef _WIN64

	return FALSE;

#else

	DWORD	uOld;
	DWORD	uNum;

	if(!pThunk)return FALSE;

	for(uNum=0;;uNum++)
		{
		if(uNum>=4096)return FALSE;
		if(!pThunk[uNum].u1.AddressOfData)return FALSE;
		if(uNum==uIndex)break;
		}

	if(!UnProtect(&pThunk[uNum].u1.Function,8))
		{
		return FALSE;
		}

	*(ULONGLONG*)&pThunk[uNum].u1.Function = (ULONGLONG)pAddr;


	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		PeFileToMem
//*
//*****************************************************************************
//	Rechnet den Offset in der Datei in einen Offset im Speicher um
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	uOffset			: Offset im Speicher der umgerechnet werden soll.
//	Ergibt den Speicheroffset (ab RVA) oder 0xFFFFFFFF bei einem Fehler.
#ifndef PE_NO_FILE_PROCS
DWORD PeFileToMem(const void *pInstance,DWORD uOffset)
{
IMAGE_OPTIONAL_HEADER  *pOption;
IMAGE_SECTION_HEADER   *pSections;
IMAGE_FILE_HEADER	   *pImage;
IMAGE_DOS_HEADER	   *pDos;
char			       *pMem;
CMapFile		   		sMap;
DWORD				    uCount;
DWORD				    uFrom;
DWORD				    uMax;
DWORD				    uOff;
DWORD				    uSec;
DWORD				    uNum;
DWORD				    uPos;




		pMem = (char*)pInstance;
	if(!pMem)return 0xFFFFFFFF;

	if(IsBadReadPtr(pMem,sizeof(IMAGE_DOS_HEADER)))
		{
		return 0xFFFFFFFF;
		}

	if(*(DWORD*)pMem==DWORD_SIGN('P','E',0,0))		// Kein DOS-Header
		{
		uOff = 0;
		}
	else if(*(WORD*)pMem==WORD_SIGN('M','Z'))		// DOS-Header
		{
		pDos = (IMAGE_DOS_HEADER*)pMem;
		uOff = pDos->e_lfanew;
		}
	else{											// Unbekannte Datei
		return 0xFFFFFFFF;
		}

	if(IsBadReadPtr(pMem,uOff+4+sizeof(IMAGE_FILE_HEADER)+sizeof(IMAGE_OPTIONAL_HEADER)+sizeof(IMAGE_SECTION_HEADER)*16))
		{
		return 0xFFFFFFFF;
		}


	uOff	   += 4;								// Zeiger holen
	pImage		= (IMAGE_FILE_HEADER*)(pMem+uOff);
	uOff	   += sizeof(IMAGE_FILE_HEADER);
	pOption		= (IMAGE_OPTIONAL_HEADER*)(pMem+uOff);
	uOff	   += pImage->SizeOfOptionalHeader;
	pSections	= (IMAGE_SECTION_HEADER*)(pMem+uOff);
	uMax		= 0x2000000;
	uCount		= pImage->NumberOfSections;

	if(uCount>16)uCount=16;


	for(uSec=0;uSec<uCount;uSec++)					// Abschnitt suchen
		{
		uNum  = (pSections[uSec].SizeOfRawData+0x1FF)&~0x1FF;
		uFrom =  pSections[uSec].PointerToRawData;
		uPos  =  pSections[uSec].VirtualAddress;

		if(uOffset>=uFrom && uOffset<uFrom+uNum)	// Ist der Offest im Abschnitt
			{
			return uOffset+uPos-uFrom;
			}

		if(uFrom<uMax)uMax=uFrom;
		}

	if(uOffset>=uMax)return 0xFFFFFFFF;


return uOffset;
}
#endif 	

//*****************************************************************************
//*
//*		PeMemToFile
//*
//*****************************************************************************
//	Rechnet den Offset im Speicher in einen Offset in einer Datei um
//	pInstance		: Zeiger auf die Instanz bzw. dem Instanz-Handle
//	uOffset			: Offset im Speicher der umgerechnet werden soll.
//					  Der Speicher beginnt bei der RVA-Adresse.
//	Ergibt den Dateioffset oder 0xFFFFFFFF bei einem Fehler.
#ifndef PE_NO_FILE_PROCS
DWORD PeMemToFile(const void *pInstance,DWORD uOffset)
{
IMAGE_OPTIONAL_HEADER  *pOption;
IMAGE_SECTION_HEADER   *pSections;
IMAGE_FILE_HEADER	   *pImage;
IMAGE_DOS_HEADER	   *pDos;
char			       *pMem;
CMapFile		   		sMap;
DWORD				    uCount;
DWORD				    uFrom;
DWORD				    uMax;
DWORD				    uOff;
DWORD				    uSec;
DWORD				    uNum;
DWORD				    uPos;




		pMem = (char*)pInstance;
	if(!pMem)return 0xFFFFFFFF;

	if(IsBadReadPtr(pMem,sizeof(IMAGE_DOS_HEADER)))
		{
		return 0xFFFFFFFF;
		}

	if(*(DWORD*)pMem==DWORD_SIGN('P','E',0,0))		// Kein DOS-Header
		{
		uOff = 0;
		}
	else if(*(WORD*)pMem==WORD_SIGN('M','Z'))		// DOS-Header
		{
		pDos = (IMAGE_DOS_HEADER*)pMem;
		uOff = pDos->e_lfanew;
		}
	else{											// Unbekannte Datei
		return 0xFFFFFFFF;
		}

	if(IsBadReadPtr(pMem,uOff+4+sizeof(IMAGE_FILE_HEADER)+sizeof(IMAGE_OPTIONAL_HEADER)+sizeof(IMAGE_SECTION_HEADER)*16))
		{
		return 0xFFFFFFFF;
		}


	uOff	   += 4;								// Zeiger holen
	pImage		= (IMAGE_FILE_HEADER*)(pMem+uOff);
	uOff	   += sizeof(IMAGE_FILE_HEADER);
	pOption		= (IMAGE_OPTIONAL_HEADER*)(pMem+uOff);
	uOff	   += pImage->SizeOfOptionalHeader;
	pSections	= (IMAGE_SECTION_HEADER*)(pMem+uOff);
	uMax		= 0x2000000;
	uCount		= pImage->NumberOfSections;

	if(uCount>16)uCount=16;


	for(uSec=0;uSec<uCount;uSec++)					// Abschnitt suchen
		{
		uNum  = (pSections[uSec].Misc.VirtualSize+0x1FF)&~0x1FF;
		uFrom =  pSections[uSec].PointerToRawData;
		uPos  =  pSections[uSec].VirtualAddress;

		if(uOffset>=uPos && uOffset<uPos+uNum)		// Ist der Offest im Abschnitt
			{
			return uOffset+uFrom-uPos;
			}

		if(uPos<uMax)uMax=uPos;
		}

	if(uOffset>=uMax)return 0xFFFFFFFF;


return uOffset;
}
#endif 	

//*****************************************************************************
//*
//*		LoadDllFile
//*
//*****************************************************************************
//	Ld eine Dll-Datei aus allen diversen mglichen Pfaden
//	pFilename		: Ist der Dateiname der DLL
//	uBase			: Ist die Basisadresse fr die DLL
//	pSize			: Hier wird die Gre des Speicherblocks abgelegt
//	pType			: Hier wird der Dateityp gespeichert (0=kiner 1=32-Bit 2=64-Bit)
//	uForce			: Wird ein Dateityp bentigt (0=kiner 1=32-Bit 2=64-Bit)
//	Ergibt einen Zeiger auf den Speicherbereich, dieser Speicherbereich muss
//	mit delete freigegeben werden, oder NULL bei einem Fehler.
#ifndef PE_NO_FILE_PROCS
void *LoadDllFile(const char *pFilename,DWORD uBase,DWORD *pSize,DWORD *pType,DWORD uForce)
{
char	cName[MAX_PATH];
DWORD	uType;
void   *pDll;


	if(pType==0)pType=&uType;
	if(pSize)*pSize=0;

	if(ExistFile(pFilename)==1)
		{
		   pDll = LoadPeFile(pFilename,uBase,pSize,pType);
		if(pDll)
			{
			if(!uForce || *pType==uForce)
				{
				return pDll;
				}

			delete pDll;
			}
		}

	cName[0];

	if(uForce==1)									// 32-Bit-Dll
		{
		SHGetSpecialFolderPath(0,cName,CSIDL_SYSTEMX86,0);
		}

	if(uForce==2)									// 64-Bit-Dll
		{
		SHGetSpecialFolderPath(0,cName,CSIDL_SYSTEM,0);
		}

	if(cName[0]==0)
		{
		GetSystemDirectory(cName,sizeof(cName));
		}

	pFilename = GetFileName(pFilename);
	AddBackSlash(cName);
	SetFileName(cName,pFilename,sizeof(cName));

	PeWowRedirect(1);
	pDll=LoadPeFile(cName,uBase,pSize,pType,uForce);
	PeWowRedirect(0);

	if(pDll)
		{
		if(!uForce || *pType==uForce)
			{
			return pDll;
			}

		delete pDll;
		}

	#ifdef _WIN64

	GetSystemDirectory(cName,sizeof(cName));
	SetFileName(cName,"SysWoW64",sizeof(cName));
	AddBackSlash(cName);
	SetFileName(cName,pFilename,sizeof(cName));

	   pDll=LoadPeFile(cName,uBase,pSize,pType);
	if(pDll)
		{
		if(!uForce || *pType==uForce)
			{
			return pDll;
			}

		delete pDll;
		}

	#else

	if(PeWin64Bit())
		{
		PeWowRedirect(1);
		pDll=LoadPeFile(cName,uBase,pSize,pType);
		PeWowRedirect(0);

		if(pDll)return pDll;
		}

	#endif

	GetWindowsDirectory(cName,sizeof(cName));
	AddBackSlash(cName);
	SetFileName(cName,pFilename,sizeof(cName));

	   pDll = LoadPeFile(cName,uBase,pSize,pType);
	if(pDll)
		{
		if(!uForce || *pType==uForce)
			{
			return pDll;
			}

		delete pDll;
		}


return NULL;
}
#endif 	

//*****************************************************************************
//*
//*		LoadPeFile
//*
//*****************************************************************************
//	Ld eine PE-Datei aus einer Datei.
//	pFilename		: Ist der Dateiname der DLL
//	uBase			: Ist die Basisadresse fr die DLL
//	pSize			: Hier wird die Gre des Speicherblocks abgelegt
//	pType			: Hier wird der Dateityp gespeichert (0=kiner 1=32-Bit 2=64-Bit)
//	uForce			: Wird ein Dateityp bentigt (0=kiner 1=32-Bit 2=64-Bit)
//	Ergibt einen Zeiger auf den Speicherbereich, dieser Speicherbereich muss
//	mit delete freigegeben werden, oder NULL bei einem Fehler.
#ifndef PE_NO_FILE_PROCS
void *LoadPeFile(const char *pFilename,DWORD uBase,DWORD *pSize,DWORD *pType,DWORD uForce)
{
IMAGE_OPTIONAL_HEADER  *pOption;
IMAGE_SECTION_HEADER   *pSections;
IMAGE_NT_HEADERS32	   *pPeHeader;
IMAGE_FILE_HEADER	   *pImage;
IMAGE_DOS_HEADER	   *pDos;
char			       *pMem;
char			       *pPtr;
CMapFile		   		sMap;
DWORD				    uCount;
DWORD				    uFrom;
DWORD				    uSize;
DWORD				    uOff;
DWORD				    uIdx;
DWORD				    uLen;
DWORD				    uCnt;
DWORD				    uPos;
DWORD				    uOk;



	if(pSize)*pSize=0;
	if(pType)*pType=0;

		pMem=sMap.Open(pFilename,CMF_READ);			// ffne die Datei
	if(!pMem)return 0;

	   uSize = (unsigned)sMap.GetLength();
	if(uSize<sizeof(IMAGE_DOS_HEADER))
		{
		return 0;
		}

	if(*(DWORD*)pMem==DWORD_SIGN('P','E',0,0))		// Kein DOS-Header
		{
		uOff = 0;
		}
	else if(*(WORD*)pMem==WORD_SIGN('M','Z'))		// DOS-Header
		{
		pDos = (IMAGE_DOS_HEADER*)pMem;
		uOff = pDos->e_lfanew;
		}
	else{											// Unbekannte Datei
		return 0;
		}

	if(uOff+4+sizeof(IMAGE_SECTION_HEADER)*16>uSize)
		{
		return 0;
		}


	pPeHeader	= (IMAGE_NT_HEADERS32*)(pMem+uOff);
	uOff	   += 4;								// Zeiger holen
	pImage		= (IMAGE_FILE_HEADER*)(pMem+uOff);
	uOff	   += sizeof(IMAGE_FILE_HEADER);
	pOption		= (IMAGE_OPTIONAL_HEADER*)(pMem+uOff);
	uOff	   += pImage->SizeOfOptionalHeader;
	pSections	= (IMAGE_SECTION_HEADER*)(pMem+uOff);


	if(uForce)										// Header-Typ prfen
		{
		if(uForce==1 && pImage->Machine==0x014C)uForce=0;
		if(uForce==2 && pImage->Machine==0x8664)uForce=0;
		if(uForce)
			{
			return 0;
			}
		}

	if(uOff+4+sizeof(IMAGE_FILE_HEADER)>uSize)
		{
		return 0;
		}


	   uLen = pOption->SizeOfImage;
	if(uLen==0)return 0;
	if(uLen>0x10000000)return 0;
	if(uLen<uOff+sizeof(IMAGE_SECTION_HEADER)*16)return 0;

	pPtr = new char[uLen+16];						// Speicher fr Image

	   uCount = pImage->NumberOfSections;
	if(uCount>16)uCount=16;

	memset(pPtr,0,uLen+16);
	memcpy(pPtr,pMem,uOff+sizeof(IMAGE_SECTION_HEADER)*uCount);

	uOk = 1;

	for(uIdx=0;uIdx<uCount;uIdx++)					// Daten kopieren
		{
			uCnt =pSections[uIdx].SizeOfRawData;
			uPos =pSections[uIdx].VirtualAddress;
			uFrom=pSections[uIdx].PointerToRawData;
		if(	uFrom+uCnt > uSize){uOk=0;break;}
		if(	uFrom+uCnt < uFrom){uOk=0;break;}
		if(	uPos +uCnt > uLen ){uOk=0;break;}
		if(	uPos +uCnt < uPos ){uOk=0;break;}

		memcpy(pPtr+uPos,pMem+uFrom,uCnt);
		}

		uOk=1;// REM AZ
	if(!uOk)										// Gab es Fehler beim Laden
		{
		delete pPtr;
		return 0;
		}



	if(uBase && !RealocPeFile(pPtr,uBase,uLen))		// Adressen relozieren
		{
		if(pSize)*pSize=0;
		if(pType)*pType=0;
		delete pPtr;
		return 0;
		}

	if(pSize)*pSize=uLen;
	if(pType)*pType=(pImage->Machine==0x8664)? 2:1;



return pPtr;
}
#endif 	

//*****************************************************************************
//*
//*		RealocPeFile
//*
//*****************************************************************************
//	Reloziert ein PE-Image
//	pMem		: Zeiger aus das Image
//	uBase		: Neue Basisadresse
//	uSize		: Gre des Images in Byte
//	Ergibt 1 wenn das Relozieren erfolgreich war, bzw. 0 bei einem Fehler
#ifndef PE_NO_FILE_PROCS
int	RealocPeFile(void *pMem,DWORD uBase,DWORD uSize)
{
IMAGE_BASE_RELOCATION  *pReloc;
IMAGE_NT_HEADERS32	   *pPeHdr32;
IMAGE_NT_HEADERS64	   *pPeHdr64;
WORD				   *pTemp;
char			       *pData;
ULONGLONG			    uDelta;
ULONGLONG				uStart;
DWORD				    uAddr;
DWORD				    uTemp;
DWORD				    uVal;
DWORD				    uOff;
DWORD				    uIdx;
DWORD				    uCnt;



	if(!pMem)return 0;


	if(pPeHdr32=GetPeHeader32(pMem))				// 32-Bit
		{
		uStart   = pPeHdr32->OptionalHeader.ImageBase;
		pReloc	 = GetRelocPtr32(pMem);
		pPeHdr64 = 0;
		}
	else if(pPeHdr64=GetPeHeader64(pMem))			// 64-Bit
		{
		uStart   = pPeHdr64->OptionalHeader.ImageBase;
		pReloc   = GetRelocPtr64(pMem);
		}
	else{
		return 0;
		}


		uDelta=(ULONGLONG)uBase-uStart;
	if(!uDelta)pReloc=0;


	while(pReloc)									// Reloc-Tabelle
		{
		if(!pReloc->VirtualAddress)break;
		if(!pReloc->SizeOfBlock   )break;


		pTemp = (WORD*)PTR_ADD_32(pReloc,sizeof(*pReloc));
		uAddr =  pReloc->VirtualAddress;
		uCnt  = (pReloc->SizeOfBlock-sizeof(*pReloc))/sizeof(WORD);
		pData = (char*)pMem+pReloc->VirtualAddress;

		for(uIdx=0;uIdx<uCnt;uIdx++)				// Reloc-Daten setzen
			{
			uVal = pTemp[uIdx];
			uOff = uVal&0x0FFF;

			if(uOff+8>uSize)continue;

			switch(uVal>>12)						// REM AZ weitere Optionen prfen
				{
			case IMAGE_REL_BASED_ABSOLUTE:              // 0
					break;
			case IMAGE_REL_BASED_HIGH:                  // 1
					*(WORD*)(pData+uOff)+=(WORD)(uDelta>>16);
					break;
			case IMAGE_REL_BASED_LOW:                   // 2
					*(WORD*)(pData+uOff)+=(WORD)uDelta;
					break;
			case IMAGE_REL_BASED_HIGHLOW:               // 3
					*(DWORD*)(pData+uOff)+=(DWORD)uDelta;
					break;
			case IMAGE_REL_BASED_HIGHADJ:               // 4
					uIdx  += 1;
					uTemp  = *(WORD*)(pData+uOff)<16;
					uTemp += ( WORD)pTemp[uIdx];
					uTemp += (DWORD)uDelta;
					uTemp += 0x8000;
					*(WORD*)(pData+uOff)=(WORD)(uTemp>>16);
					break;
			case IMAGE_REL_BASED_DIR64:                 // 10
					*(ULONGLONG*)(pData+uOff)+=uDelta;
					break;
			/*
			case IMAGE_REL_BASED_MIPS_JMPADDR:          // 5
					break;
			case IMAGE_REL_BASED_SECTION:               // 6
					break;
			case IMAGE_REL_BASED_REL32:                 // 7
					break;
			case IMAGE_REL_BASED_IA64_IMM64:            // 9
					break;
			case IMAGE_REL_BASED_HIGH3ADJ:              // 11
					break;
			*/
			default:
					uVal=0;
				}
			}

		pReloc = (IMAGE_BASE_RELOCATION*)PTR_ADD_32(pReloc,pReloc->SizeOfBlock);
		}



	if(pPeHdr32)pPeHdr32->OptionalHeader.ImageBase=uBase;
	if(pPeHdr64)pPeHdr64->OptionalHeader.ImageBase=uBase;



return 1;
}
#endif 	

//*****************************************************************************
//*
//*		SetExportProc64
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetPeMemory(void *pTarget,void *pSource,int iSize)
{


	if(iSize<=0)return FALSE;

	//if(IsBadWritePtr(pTarget,iSize))
	if(!UnProtect(pTarget,iSize))
		{
		return FALSE;
		}

	memcpy(pTarget,pSource,iSize);


return TRUE;
}


//*****************************************************************************
//*
//*		SetExportJump32
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion, sucht dabei einen
//	Einsprungpunkt in der DLL.
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetExportJump32(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	DWORD	   *pEntries;
	DWORD	   *pNames;
	WORD	   *pList;
	char       *pJump;
	char       *pNow;
	char       *pPtr;
	unsigned	uIndex;
	unsigned 	uCount;
	unsigned 	uName;
	unsigned 	uSize;
	unsigned 	uByte;
	unsigned 	uVal;
	unsigned 	uOrd;
	LPWORD		pAdd;
	DWORD    	uOld;


	if(pOldProc)*pOldProc=0;
	if(!pEData )return FALSE;

	uCount	 = pEData->NumberOfFunctions;
	uName	 = pEData->NumberOfNames;

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uOrd	 = (DWORD )pName;

	if(!(uOrd&0xFFFF0000))								// Sucher Ordinal-Nummer
		{
		uOrd -= pEData->Base;

		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			if(pList[uIndex]==uOrd)break;
			}
		}
	else{												// Suche den Funktionsnamen
		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			pPtr=(char*)pBase+pNames[uIndex];
			if(!strcmp(pName,pPtr))break;
			}
		}

	   uIndex = pList[uIndex];
	if(uIndex>=uCount)return FALSE;


	uByte	= 5;
	pAdd	= ADD_NONE;
	pNow	= (char*)PTR_ADD_32(pBase,pEntries[uIndex]);
	pJump	= FindPeCodeMem(pBase,pEntries,uName,uByte);

	if(!pJump)											// Suche am Ende der Abschnitte
		{
			pJump = FindPeCodeMem(pBase,pEntries,uName,uByte,pAdd);
		if(!pJump)return FALSE;
		}


	if(pAdd==NULL)										// Neue Grenmarkierung mit Bereich
		{
		uSize = uByte+5;
		}
	else if(pAdd==ADD_NONE)								// Nur Bereich
		{
		uSize = uByte;
		}
	else{												// Bereich bis Grenmarkierung
		uSize = (char*)pAdd-pJump+5;
		}

	//if(IsBadWritePtr(pJump,uSize))
	if(!VirtualProtect(pJump,uSize,PAGE_EXECUTE_WRITECOPY,&uOld))
	if(!VirtualProtect(pJump,uSize,PAGE_EXECUTE_READWRITE,&uOld))
	if(!VirtualProtect(pJump,uSize,PAGE_WRITECOPY        ,&uOld))
		{
		return FALSE;
		}

	//if(IsBadWritePtr(pEntries+uIndex,4))
	if(!UnProtect(pEntries+uIndex,4))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		*pOldProc = (void*)pNow;
		}

	pEntries[uIndex] = (DWORD)pJump-(DWORD)pBase;		// Einsprungpunkt in der Tabelle ndern
	uVal	 = (char*)pNewProc-pJump-5;
	pJump[0] = '\xE9';
	PTR_SET_32(pJump+1,uVal);

	if(pAdd==NULL)										// Grenmarkierung einfgen
		{
		pAdd = (LPWORD)(pJump+uByte);
		memcpy(pAdd,"\x05\x00\x55\x5A\xAA",5);
		}

	if(pAdd!=ADD_NONE)									// Grenmarkierung vergern
		{
		pAdd[0] += uByte;
		}

	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		SetExportJump64
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion, sucht dabei einen
//	Einsprungpunkt in der DLL.
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetExportJump64(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	DWORD      *pEntries;
	DWORD	   *pNames;
	WORD	   *pList;
	char       *pJump;
	char       *pNow;
	char       *pPtr;
	char		aData[16];
	unsigned	uIndex;
	unsigned 	uCount;
	unsigned 	uName;
	unsigned 	uSize;
	unsigned 	uByte;
	ULONGLONG 	uDiff;
	ULONGLONG 	uOrd;
	DWORD	  	uOld;
	LPWORD		pAdd;
	UINT		uVal;


	if(pOldProc)*pOldProc=0;
	if(!pEData )return FALSE;

	uCount	 = pEData->NumberOfFunctions;
	uName	 = pEData->NumberOfNames;

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uOrd	 = (ULONGLONG)pName;

	if(!(uOrd&0xFFFFFFFFFFFF0000))						// Suche Ordinal-Nummer
		{
		uOrd -= pEData->Base;

		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			if(pList[uIndex]==uOrd)break;
			}
		}
	else{												// Suche Funktionsnamen
		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			pPtr=(char*)pBase+pNames[uIndex];
			if(!strcmp(pName,pPtr))break;
			}
		}


	   uIndex = pList[uIndex];
	if(uIndex>=uCount)return FALSE;

	uDiff	= (ULONGLONG)pNewProc-(ULONGLONG)pBase;

	if(uDiff&0xFFFFFFFF80000000)						// Springe weiter als 32 Bit
		{
		memcpy(aData,"\xFF\x25\x06\x00\x00\x00",6);		// JMP [RIP+6]
		memcpy(aData+6,&pNewProc,8);
		uByte = 14;
		}
	else{
		uByte = 5;
		}

	pAdd	= ADD_NONE;
	pNow	= (char*)PTR_ADD_32(pBase,pEntries[uIndex]);
	pJump	= FindPeCodeMem(pBase,pEntries,uName,uByte);

	if(!pJump)											// Suche am Ende der Abschnitte
		{
			pJump = FindPeCodeMem(pBase,pEntries,uName,uByte,pAdd);
		if(!pJump)return FALSE;
		}


	if(pAdd==NULL)										// Neue Grenmarkierung mit Bereich
		{
		uSize = uByte+5;
		}
	else if(pAdd==ADD_NONE)								// Nur Bereich
		{
		uSize = uByte;
		}
	else{												// Bereich bis Grenmarkierung
		uSize = (char*)pAdd-pJump+5;
		}

	//if(IsBadWritePtr(pJump,uSize))
	if(!VirtualProtect(pJump,uSize,PAGE_EXECUTE_WRITECOPY,&uOld))
	if(!VirtualProtect(pJump,uSize,PAGE_EXECUTE_READWRITE,&uOld))
	if(!VirtualProtect(pJump,uSize,PAGE_WRITECOPY        ,&uOld))
		{
		return FALSE;
		}

	//if(IsBadWritePtr(pEntries+uIndex,4))
	if(!UnProtect(pEntries+uIndex,4))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		*pOldProc = (void*)pNow;
		}

	if(uByte==5)										// Relativer Sprung
		{
		pEntries[uIndex] = (DWORD)pJump-(DWORD)pBase;
		uVal	 = (char*)pNewProc-pJump-5;
		pJump[0] = '\xE9';
		pJump   += uByte;
		PTR_SET_32(pJump+1,uVal);
		}
	else{
		memcpy(pJump,aData,uByte);
		pJump   += uByte;
		}

	if(pAdd==NULL)										// Grenmarkierung einfgen
		{
		pAdd = (LPWORD)(pJump+uByte);
		memcpy(pAdd,"\x05\x00\x55\x5A\xAA",5);
		}

	if(pAdd!=ADD_NONE)									// Grenmarkierung vergern
		{
		pAdd[0] += uByte;
		}

	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		SetExportJump32
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportJump32(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)return FALSE;

	return SetExportJump32(hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportJump64
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportJump64(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)return FALSE;

	return SetExportJump64(hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportJump32
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportJump32(HMODULE hDll,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	IMAGE_EXPORT_DIRECTORY	*pEData;
	char					 cPath[256];

	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

		pEData=GetEDataPtr32(hDll);
	if(!pEData)return FALSE;

	return SetExportJump32(pEData,hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportJump64
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportJump64(HMODULE hDll,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	IMAGE_EXPORT_DIRECTORY	*pEData;
	char					 cPath[256];

	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

		pEData=GetEDataPtr64(hDll);
	if(!pEData)return FALSE;

	return SetExportJump64(pEData,hDll,pProc,pNewPorc,pOldProc);

#endif
}



//*****************************************************************************
//*
//*		SetExportHook32
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion, versucht dabei einen
//	Hot-Patch-Point	der DLL zu verwenden.
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetExportHook32(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	DWORD	   *pEntries;
	DWORD	   *pNames;
	WORD	   *pList;
	char       *pHook;
	char       *pNow;
	char       *pPtr;
	unsigned	uIndex;
	unsigned 	uCount;
	unsigned 	uName;
	unsigned 	uSize;
	unsigned 	uByte;
	unsigned 	uVal;
	unsigned 	uOrd;
	LPWORD		pAdd;
	DWORD    	uOld;


	if(pOldProc)*pOldProc=0;
	if(!pEData )return FALSE;

	uCount	 = pEData->NumberOfFunctions;
	uName	 = pEData->NumberOfNames;

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uOrd	 = (DWORD )pName;

	if(!(uOrd&0xFFFF0000))
		{
		uOrd -= pEData->Base;

		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			if(pList[uIndex]==uOrd)break;
			}
		}
	else{
		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			pPtr=(char*)pBase+pNames[uIndex];
			if(!strcmp(pName,pPtr))break;
			}
		}

	   uIndex = pList[uIndex];
	if(uIndex>=uCount)return FALSE;

	pNow	= (char*)PTR_ADD_32(pBase,pEntries[uIndex]);

	if(memcmp(pNow,"\x8B\xFF\x55\x8B\xEC",5))			// Ist ein Hot-Patch-Point mglich
		{												// MOV edi,edi  PUSH ebp  MOV ebp,esp
		return FALSE;
		}

	uByte	= 8;
	pAdd	= ADD_NONE;
	pHook	= FindPeCodeMem(pBase,pEntries,uName,uByte);

	if(!pHook)											// Suche am Ende der Abschnitte
		{
			pHook = FindPeCodeMem(pBase,pEntries,uName,uByte,pAdd);
		if(!pHook)return FALSE;
		}


	if(pAdd==NULL)										// Neue Grenmarkierung mit Bereich
		{
		uSize = uByte+5;
		}
	else if(pAdd==ADD_NONE)								// Nur Bereich
		{
		uSize = uByte;
		}
	else{												// Bereich bis Grenmarkierung
		uSize = (char*)pAdd-pHook+5;
		}

	//if(IsBadWritePtr(pHook,uSize))
	if(!VirtualProtect(pHook,uSize,PAGE_EXECUTE_WRITECOPY,&uOld))
	if(!VirtualProtect(pHook,uSize,PAGE_EXECUTE_READWRITE,&uOld))
	if(!VirtualProtect(pHook,uSize,PAGE_WRITECOPY        ,&uOld))
		{
		return FALSE;
		}

	//if(IsBadWritePtr(pNow,5))
	if(!VirtualProtect(pNow,5,PAGE_EXECUTE_WRITECOPY,&uOld))
	if(!VirtualProtect(pNow,5,PAGE_EXECUTE_READWRITE,&uOld))
	if(!VirtualProtect(pNow,5,PAGE_WRITECOPY        ,&uOld))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		*pOldProc = pHook;
		}

	uVal	 = (char*)pNewProc-pNow-5;					// JMP <pNewProc> am Beginn der alten Funkton
	pNow[0]  = '\xE9';
	PTR_SET_32(pNow+1,uVal);

	uVal	 = (char*)pNow-pHook-3;						// PUSH ebp  MOV ebp,esp  JMP <pOldProc>
	PTR_SET_32(pHook,0xE9EC8B55);						// Ist der neue Einsprungpunkt auf 8 Bytes
	PTR_SET_32(pHook+4,uVal);


	if(pAdd==NULL)										// Grenmarkierung einfgen
		{
		pAdd = (LPWORD)(pHook+uByte);
		memcpy(pAdd,"\x05\x00\x55\x5A\xAA",5);
		}

	if(pAdd!=ADD_NONE)									// Grenmarkierung vergern
		{
		pAdd[0] += uByte;
		}

	return TRUE;

#endif
}

//*****************************************************************************
//*
//*		SetExportHook64
//*
//*****************************************************************************
//	ndert den Zeiger auf eine Export-Funktion, sucht dabei einen
//	Einsprungpunkt in der DLL.
//	pEData		: Zeiger auf den pEData-Abschnitt
//	pBase		: Handle der Instanze
//	pName		: Name der Export-Funktion
//				  bzw. wenn Name < 0x10000 die Ordinal-Nummer
//	pNewProc	: Ist der Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der Wert der alten Funktion gespeichert wenn != 0
//	Ergibt TRUE wenn die Funktion verndert wurde.
BOOL SetExportHook64(IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	DWORD      *pEntries;
	DWORD	   *pNames;
	WORD	   *pList;
	char       *pHook;
	char       *pNow;
	char       *pPtr;
	char		aData[16];
	unsigned	uIndex;
	unsigned 	uCount;
	unsigned 	uName;
	unsigned 	uSize;
	unsigned 	uByte;
	ULONGLONG 	uDiff;
	ULONGLONG 	uOrd;
	DWORD	  	uOld;
	LPWORD		pAdd;
	UINT		uVal;


	if(pOldProc)*pOldProc=0;
	if(!pEData )return FALSE;

	uCount	 = pEData->NumberOfFunctions;
	uName	 = pEData->NumberOfNames;

	pNames	 = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfNames);
	pEntries = (DWORD*)PTR_ADD_32(pBase,pEData->AddressOfFunctions);
	pList	 = ( WORD*)PTR_ADD_32(pBase,pEData->AddressOfNameOrdinals);
	uOrd	 = (ULONGLONG)pName;

	if(!(uOrd&0xFFFFFFFFFFFF0000))
		{
		uOrd -= pEData->Base;

		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			if(pList[uIndex]==uOrd)break;
			}
		}
	else{
		for(uIndex=0;;uIndex++)
			{
			if(uIndex>=uName)return FALSE;
			pPtr=(char*)pBase+pNames[uIndex];
			if(!strcmp(pName,pPtr))break;
			}
		}


	   uIndex = pList[uIndex];
	if(uIndex>=uCount)return FALSE;

	uDiff	= (ULONGLONG)pNewProc-(ULONGLONG)pBase;

	if(uDiff&0xFFFFFFFF80000000)						// Springe weiter als 32 Bit
		{
		memcpy(aData,"\xFF\x25\x06\x00\x00\x00",6);		// JMP [RIP+6]
		memcpy(aData+6,&pNewProc,8);
		uByte = 14;
		}
	else{
		uByte = 5;
		}

	pNow	= (char*)PTR_ADD_32(pBase,pEntries[uIndex]);

	if(memcmp(pNow,"\x8B\xFF\x55\x8B\xEC",5))			// Ist ein Hot-Patch-Point mglich
		{
		return FALSE;
		}

	uByte	= 8;
	pAdd	= ADD_NONE;
	pHook	= FindPeCodeMem(pBase,pEntries,uName,uByte);

	if(!pHook)											// Suche am Ende der Abschnitte
		{
			pHook = FindPeCodeMem(pBase,pEntries,uName,uByte,pAdd);
		if(!pHook)return FALSE;
		}


	if(pAdd==NULL)										// Neue Grenmarkierung mit Bereich
		{
		uSize = uByte+5;
		}
	else if(pAdd==ADD_NONE)								// Nur Bereich
		{
		uSize = uByte;
		}
	else{												// Bereich bis Grenmarkierung
		uSize = (char*)pAdd-pHook+5;
		}

	//if(IsBadWritePtr(pHook,uSize))
	if(!VirtualProtect(pHook,uSize,PAGE_EXECUTE_WRITECOPY,&uOld))
	if(!VirtualProtect(pHook,uSize,PAGE_EXECUTE_READWRITE,&uOld))
	if(!VirtualProtect(pHook,uSize,PAGE_WRITECOPY        ,&uOld))
		{
		return FALSE;
		}

	//if(IsBadWritePtr(pNow,5))
	if(!VirtualProtect(pNow,5,PAGE_EXECUTE_WRITECOPY,&uOld))
	if(!VirtualProtect(pNow,5,PAGE_EXECUTE_READWRITE,&uOld))
	if(!VirtualProtect(pNow,5,PAGE_WRITECOPY        ,&uOld))
		{
		return FALSE;
		}

	if(pOldProc)
		{
		*pOldProc = pHook;
		}

	uVal	 = (char*)pNewProc-pNow-5;					// JMP <pNewProc>
	pNow[0]  = '\xE9';
	PTR_SET_32(pNow+1,uVal);

	uVal	 = (char*)pHook-pNow+4;						// PUSH ebp  MOV ebp,esp  JMP <pOldProc>
	PTR_SET_32(pHook,0xE9EC8B55);
	PTR_SET_32(pHook+4,uVal);

	if(pAdd==NULL)										// Grenmarkierung einfgen
		{
		pAdd = (LPWORD)(pHook+uByte);
		memcpy(pAdd,"\x05\x00\x55\x5A\xAA",5);
		}

	if(pAdd!=ADD_NONE)									// Grenmarkierung vergern
		{
		pAdd[0] += uByte;
		}

	return TRUE;


#endif
}

//*****************************************************************************
//*
//*		SetExportHook32
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportHook32(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)return FALSE;

	return SetExportHook32(hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportHook64
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	pDllName	: Dll-Name des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportHook64(const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	HMODULE hDll;

		hDll=GetModuleHandle(pDllName);
	if(!hDll)return FALSE;

	return SetExportHook64(hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportHook32
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportHook32(HMODULE hDll,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifdef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	IMAGE_EXPORT_DIRECTORY	*pEData;
	char					 cPath[256];

	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

		pEData=GetEDataPtr32(hDll);
	if(!pEData)return FALSE;

	return SetExportHook32(pEData,hDll,pProc,pNewPorc,pOldProc);

#endif
}

//*****************************************************************************
//*
//*		SetExportHook64
//*
//*****************************************************************************
//	ndert eine Funktion in der Export-Tabelle eines Moduls
//	hDll		: Handle   des Moduls mit der Export-Tabelle
//	pProc		: Name der Funktion die gendert werden soll
//	pNewPorc	: Zeiger auf die neue Funktion
//	pOldProc	: Dort wird der wert der alten Funktion gespeichert
//	Ergibt TRUE wenn die Funktion gesetzt wurde
BOOL SetExportHook64(HMODULE hDll,const char *pProc,void *pNewPorc,void **pOldProc)
{
#ifndef _WIN64

	if(pOldProc)*pOldProc=0;
	return FALSE;

#else

	IMAGE_EXPORT_DIRECTORY	*pEData;
	char					 cPath[256];

	if(!hDll)return FALSE;
	if(!GetModuleFileName(hDll,cPath,sizeof(cPath)))return FALSE;

		pEData=GetEDataPtr64(hDll);
	if(!pEData)return FALSE;

	return SetExportHook64(pEData,hDll,pProc,pNewPorc,pOldProc);

#endif
}

