//*****************************************************************************
//*
//*
//*		PeFunctions
//*
//*
//*****************************************************************************
#ifndef 	__PEFUNKTIONE_H__
#define 	__PEFUNKTIONE_H__


#if _MSC_VER >= 1000
#pragma once
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#endif
#else
	#include	<windows.h>
#endif

#ifdef _WIN64

#define ULONG_PE				ULONGLONG
#define PTR_ADD					PTR_ADD_64

#define FindExportProc			FindExportProc64
#define GetSectionHeader		GetSectionHeader64
#define GetExportProc			GetExportProc64
#define SetExportProc			SetExportProc64
#define SetExportJump			SetExportJump64
#define SetExportHook			SetExportHook64
#define SetImportProc			SetImportProc64
#define GetImportProc			GetImportProc64
#define GetImportIndex			GetImportIndex64
#define GetImportName			GetImportName64
#define GetImportDll			GetImportDll64
#define GetPeHeader				GetPeHeader64

#define GetEDataPtr				GetEDataPtr64
#define GetEDataSize			GetEDataSize64
#define GetIDataPtr				GetIDataPtr64
#define GetIDataSize			GetIDataSize64
#define GetRelocPtr				GetRelocPtr64
#define GetRelocSize			GetRelocSize64
#define GetRsrcPtr				GetRsrcPtr64
#define GetRsrcSize				GetRsrcSize64

#else

#define ULONG_PE				DWORD
#define PTR_ADD					PTR_ADD_32

#define FindExportProc			FindExportProc32
#define GetSectionHeader		GetSectionHeader32
#define GetExportProc			GetExportProc32
#define SetExportProc			SetExportProc32
#define SetExportJump			SetExportJump32
#define SetExportHook			SetExportHook32
#define SetImportProc			SetImportProc32
#define GetImportProc			GetImportProc32
#define GetImportIndex			GetImportIndex32
#define GetImportName			GetImportName32
#define GetImportDll			GetImportDll32
#define GetPeHeader				GetPeHeader32

#define GetEDataPtr				GetEDataPtr32
#define GetEDataSize			GetEDataSize32
#define GetIDataPtr				GetIDataPtr32
#define GetIDataSize			GetIDataSize32
#define GetRelocPtr				GetRelocPtr32
#define GetRelocSize			GetRelocSize32
#define GetRsrcPtr				GetRsrcPtr32
#define GetRsrcSize				GetRsrcSize32

#endif

#ifndef	_WIN64
#ifndef	DWORD_PTR
#define DWORD_PTR				DWORD
#endif
#endif		

#define PTR_ADD_64(ptr,add)		(((const char*)(ptr))+(ULONGLONG  )(add))
#define PTR_ADD_32(ptr,add)		(((const char*)(ptr))+(DWORD      )(add))
#define PTR_SUB_64(ptr,add)		(((const char*)(ptr))-(const char*)(add))
#define PTR_SUB_32(ptr,add)		(((const char*)(ptr))-(const char*)(add))
#define PTR_SET_64(ptr,val)	    *((ULONGLONG *)(ptr))=(ULONGLONG  )(val)
#define PTR_SET_32(ptr,val)	    *((DWORD     *)(ptr))=(DWORD      )(val)

#define PE_TYPE_NONE			0
#define PE_TYPE_32				1
#define PE_TYPE_64				2
#define PE_NO_SYSTEM			1


//******************** Allgemeine Funktionen **********************************


		int						 PeWin64Bit        ();
		void					 PeWowRedirect     (int iMode);
		void				    *LoadDllFile	   (const char *pFilename,DWORD uBase=0,DWORD *pSize=0,DWORD *pType=0,DWORD uForce=0);
		void					*LoadPeFile 	   (const char *pFilename,DWORD uBase=0,DWORD *pSize=0,DWORD *pType=0,DWORD uForce=0);
		int						 RealocPeFile 	   (      void *pMem     ,DWORD uBase  ,DWORD  uSize);
		DWORD					 PeMemToFile	   (const void *pInstance,DWORD uOffset);
		DWORD					 PeFileToMem	   (const void *pInstance,DWORD uOffset);
		BOOL					 SetPeMemory	   (void *pTarget,void *pSource,int iSize);

		IMAGE_DOS_HEADER		*GetDosHeader      (HINSTANCE   hInstance);
inline	IMAGE_DOS_HEADER		*GetDosHeader      (void       *pInstance){return GetDosHeader((HINSTANCE)pInstance);}
		IMAGE_SECTION_HEADER	*GetSectionHeaderEx(void       *pInstance,void *pCount=0);
		IMAGE_FILE_HEADER		*GetPeFileHeader   (IMAGE_DOS_HEADER    *pInstance);
inline	IMAGE_FILE_HEADER		*GetPeFileHeader   (HINSTANCE		     hInstance){return GetPeFileHeader((IMAGE_DOS_HEADER*)hInstance);}
inline	IMAGE_FILE_HEADER		*GetPeFileHeader   (void                *pInstance){return GetPeFileHeader((IMAGE_DOS_HEADER*)pInstance);}
inline	IMAGE_FILE_HEADER		*GetPeFileHeader   (IMAGE_NT_HEADERS32  *pInstance){return GetPeFileHeader((IMAGE_DOS_HEADER*)pInstance);}
inline	IMAGE_FILE_HEADER		*GetPeFileHeader   (IMAGE_NT_HEADERS64  *pInstance){return GetPeFileHeader((IMAGE_DOS_HEADER*)pInstance);}


//******************** 32-Bit-Funktionen **************************************


		IMAGE_NT_HEADERS32		*GetPeHeader32     (IMAGE_DOS_HEADER    *pInstance);
inline	IMAGE_NT_HEADERS32		*GetPeHeader32     (HINSTANCE		     hInstance){return GetPeHeader32((IMAGE_DOS_HEADER*)hInstance);}
inline	IMAGE_NT_HEADERS32		*GetPeHeader32     (void                *pInstance){return GetPeHeader32((IMAGE_DOS_HEADER*)pInstance);}
		IMAGE_SECTION_HEADER	*GetSectionHeader32(IMAGE_NT_HEADERS32  *pPeHeader,void *pCount=0);
inline	IMAGE_SECTION_HEADER	*GetSectionHeader32(HINSTANCE            hInstance,void *pCount=0){return GetSectionHeader32(GetPeHeader32(hInstance),pCount);}
inline	IMAGE_SECTION_HEADER	*GetSectionHeader32(void	            *pInstance,void *pCount=0){return GetSectionHeader32(GetPeHeader32(pInstance),pCount);}

		const char              *FindExportProc32  (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uProc ,WORD *pOrdinal=0,DWORD *pIndex=0);
		const char              *FindExportProc32  (HMODULE     hDll                          ,void *pProc ,WORD *pOrdinal=0,DWORD *pIndex=0);
		const char              *FindExportProc32  (                    const char *pDllName  ,void *pProc ,WORD *pOrdinal=0,DWORD *pIndex=0);
		char					*GetExportProc32   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uIndex,WORD *pOrdinal=0,DWORD *pAddr=0);
		char					*GetExportProc32   (HMODULE     hDll                          ,DWORD uIndex,WORD *pOrdinal=0,DWORD *pAddr=0);
		char					*GetExportProc32   (                    const char *pDllName  ,DWORD uIndex,WORD *pOrdinal=0,DWORD *pAddr=0);
		BOOL					 SetExportProc32   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc=0);
		BOOL					 SetExportProc32   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportProc32   (HMODULE     hDll                        ,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportJump32   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc=0);
		BOOL					 SetExportJump32   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportJump32   (HMODULE     hDll                        ,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportHook32   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc=0);
		BOOL					 SetExportHook32   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportHook32   (HMODULE     hDll                        ,const char *pProc,void *pNewPorc,void **pOldProc=0);
		int						 SetImportProc32   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0,int iFlags=PE_NO_SYSTEM);
		BOOL					 SetImportProc32   (HMODULE     hDll   ,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetImportProc32   (const char *pModule,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL 					 SetImportProc32   (IMAGE_THUNK_DATA32      *pThunk,void *pBase,DWORD uIndex  ,void *pProc);
		DWORD					 GetImportIndex32  (IMAGE_THUNK_DATA32      *pThunk,void *pBase,LPCSTR pProc);
		void 					*GetImportProc32   (IMAGE_THUNK_DATA32      *pThunk,void *pBase,DWORD uIndex);
		const char 				*GetImportName32   (IMAGE_THUNK_DATA32      *pThunk,void *pBase,DWORD uIndex);
		const char				*GetImportDll32    (IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,DWORD uIndex,IMAGE_THUNK_DATA32 **pNameThunk=0,IMAGE_THUNK_DATA32 **pAddrThunk=0);
		const char				*GetImportDll32    (IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,LPCSTR pName,IMAGE_THUNK_DATA32 **pNameThunk=0,IMAGE_THUNK_DATA32 **pAddrThunk=0);

		IMAGE_EXPORT_DIRECTORY	*GetEDataPtr32     (void *pInstance);
		DWORD					 GetEDataSize32    (void *pInstance);
		IMAGE_IMPORT_DESCRIPTOR	*GetIDataPtr32     (void *pInstance);
		DWORD					 GetIDataSize32    (void *pInstance);
		IMAGE_BASE_RELOCATION	*GetRelocPtr32     (void *pInstance);
		DWORD					 GetRelocSize32    (void *pInstance);
		IMAGE_RESOURCE_DIRECTORY*GetRsrcPtr32      (void *pInstance);
		DWORD					 GetRsrcSize32     (void *pInstance);


//******************** 64-Bit-Funktionen **************************************


		IMAGE_NT_HEADERS64		*GetPeHeader64     (IMAGE_DOS_HEADER    *pInstance);
inline	IMAGE_NT_HEADERS64		*GetPeHeader64     (HINSTANCE		     hInstance){return GetPeHeader64((IMAGE_DOS_HEADER*)hInstance);}
inline	IMAGE_NT_HEADERS64		*GetPeHeader64     (void                *pInstance){return GetPeHeader64((IMAGE_DOS_HEADER*)pInstance);}
		IMAGE_SECTION_HEADER	*GetSectionHeader64(IMAGE_NT_HEADERS64  *pPeHeader,void *pCount=0);
inline	IMAGE_SECTION_HEADER	*GetSectionHeader64(HINSTANCE            hInstance,void *pCount=0){return GetSectionHeader64(GetPeHeader64(hInstance),pCount);}
inline	IMAGE_SECTION_HEADER	*GetSectionHeader64(void	            *pInstance,void *pCount=0){return GetSectionHeader64(GetPeHeader64(pInstance),pCount);}

		const char              *FindExportProc64  (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uProc ,WORD *pOrdinal=0,DWORD *pIndex=0);
		const char              *FindExportProc64  (HMODULE     hDll                          ,void *pProc ,WORD *pOrdinal=0,DWORD *pIndex=0);
		const char              *FindExportProc64  (                    const char *pDllName  ,void *pProc ,WORD *pOrdinal=0,DWORD *pIndex=0);
		char					*GetExportProc64   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,DWORD uIndex,WORD *pOrdinal=0,DWORD *pAddr=0);
		char					*GetExportProc64   (HMODULE     hDll                          ,DWORD uIndex,WORD *pOrdinal=0,DWORD *pAddr=0);
		char					*GetExportProc64   (                    const char *pDllName  ,DWORD uIndex,WORD *pOrdinal=0,DWORD *pAddr=0);
		BOOL					 SetExportProc64   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc=0);
		BOOL					 SetExportProc64   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportProc64   (HMODULE     hDll                        ,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportJump64   (IMAGE_EXPORT_DIRECTORY *pEData,void *pBase,const char *pName,const void *pNewProc,void **pOldProc=0);
		BOOL					 SetExportJump64   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetExportJump64   (HMODULE     hDll                        ,const char *pProc,void *pNewPorc,void **pOldProc=0);
		int						 SetImportProc64   (                    const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0,int iFlags=PE_NO_SYSTEM);
		BOOL					 SetImportProc64   (HMODULE     hDll   ,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL					 SetImportProc64   (const char *pModule,const char *pDllName,const char *pProc,void *pNewPorc,void **pOldProc=0);
		BOOL 					 SetImportProc64   (IMAGE_THUNK_DATA64      *pThunk,void *pBase,DWORD uIndex  ,void *pProc);
		DWORD					 GetImportIndex64  (IMAGE_THUNK_DATA64      *pThunk,void *pBase,LPCSTR pProc);
		void 					*GetImportProc64   (IMAGE_THUNK_DATA64      *pThunk,void *pBase,DWORD uIndex);
		const char 				*GetImportName64   (IMAGE_THUNK_DATA64      *pThunk,void *pBase,DWORD uIndex);
		const char				*GetImportDll64    (IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,DWORD uIndex,IMAGE_THUNK_DATA64 **pNameThunk=0,IMAGE_THUNK_DATA64 **pAddrThunk=0);
		const char				*GetImportDll64    (IMAGE_IMPORT_DESCRIPTOR *pIData,void *pBase,LPCSTR pName,IMAGE_THUNK_DATA64 **pNameThunk=0,IMAGE_THUNK_DATA64 **pAddrThunk=0);

		IMAGE_EXPORT_DIRECTORY	*GetEDataPtr64     (void *pInstance);
		DWORD					 GetEDataSize64    (void *pInstance);
		IMAGE_IMPORT_DESCRIPTOR	*GetIDataPtr64     (void *pInstance);
		DWORD					 GetIDataSize64    (void *pInstance);
		IMAGE_BASE_RELOCATION	*GetRelocPtr64     (void *pInstance);
		DWORD					 GetRelocSize64    (void *pInstance);
		IMAGE_RESOURCE_DIRECTORY*GetRsrcPtr64      (void *pInstance);
		DWORD					 GetRsrcSize64     (void *pInstance);



#endif
