//*****************************************************************************
//*
//*
//*		ProcPrintf.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//	In dieser Datei ist eine printf Funktion implementiert die fr die
//	Ausgabe einen Funktions-Pointer erlaubt. (Callbacks)
//	Die Funktionen sind fr ANSI und UNICODE geschrieben.
//
//	Erweiterungen gegenber den normaren Printf-Format:
//
//		%...b		: Ausgabe von binren Zahlen (mit 'b' oder 'B' fr 0B... Prfix)
//		%-.*m		: Ausgabe von HEX-Dumps ('lqh'=SpaceNByte ' '=Plus_Space '+'=Plus_':' '0'=00_am_Ende '#'='...'am_Ende)
//		%@A...		: Ausgabe von absolten Parametern   ('A'...'L')
//		%~...		: Definiton von absolten Parametern oder nicht ausgeben
//		%..s		: Textausgabe mit Sonderzeichenunterdrckung
//		%...q?		: 64-Bit Prfix fr 8-Byte breite Werte
//		%...D		: Dezimalzahl mit Tausendertrennzeichen ('#' fr Punkt als Trennung  ".* fr Fixendezimalpunkt)
//		%...U		: Dezimalzahl mit Tausendertrennzeichen ('#' fr Punkt als Trennung  ".* fr Fixendezimalpunkt)
//		%...F		: Dezimalzahl mit Tausendertrennzeichen ('#' fr Punkt als Trennung)
//			  
#ifdef		GLOBAL_CONFIG
#define 	PROCPRINTF_CPP
#include	<GlobalConfig.h>
#undef		PROCPRINTF_CPP
#endif

#define 	PP_NO_COMMON
#include	<time.h>
#include	<wchar.h>
#include	<string.h>
#include	"ProcPrintf.h"

#ifdef	_MSC_VER
#pragma warning( disable :4996 )
#endif

#ifndef		PP_HAS_FLOAT
#define 	PP_HAS_FLOAT	1					// Fliekommauntersttzung einschalten
#endif

#ifndef		PP_HAS_UNICODE
#define 	PP_HAS_UNICODE	1					// Unicode-Untersttzung einschalten
#endif

#ifndef		PP_HAS_USWITCH
#define 	PP_HAS_USWITCH	1					// Unicode-Umschaltung einschalten
#endif

#ifndef		PP_HAS_64BIT
#define 	PP_HAS_64BIT	1					// 64-Bit-Untersttzung einschalten
#endif

#ifndef		PP_HAS_LONGDBL
#define 	PP_HAS_LONGDBL	1					// LongDouble-Untersttzung einschalten
#endif

#ifndef		PP_HAS_DUMP
#define 	PP_HAS_DUMP		1					// Erweiterung um Dump-Ausgabe ("...%.?m...")
#endif

#ifndef		PP_HAS_TIME
#define 	PP_HAS_TIME		1					// Erweiterung um Zeitmodus ("...%k...")
#endif

#ifndef		PP_HAS_OCTAL
#define 	PP_HAS_OCTAL	1					// Oktal-Untersttzung einschalten
#endif

#ifndef		PP_HAS_HEXDEC
#define 	PP_HAS_HEXDEC	1					// Hexdezimal und Pointer-Untersttzung einschalten
#endif

#ifndef		PP_HAS_BINARY
#define 	PP_HAS_BINARY	1					// Erweiterung um binren Modus ("...%b...")
#endif

#ifndef		PP_HAS_STRCHG
#define 	PP_HAS_STRCHG	1					// Erweiterung um # fr Strings ('\n' --> '.')
#endif

#ifndef		PP_HAS_MAXSIGN
#define 	PP_HAS_MAXSIGN	1					// Erweiterung um berlaufmarkierung fr Strings ("...")
#endif

#ifndef		PP_HAS_DIVIDER
#define 	PP_HAS_DIVIDER	1					// Erweiterung um Tausendertrennzeichen  ("..%U..%I..%F..")
#endif

#ifndef		PP_HAS_GLOBAL
#define 	PP_HAS_GLOBAL	1					// Erweiterung um globalen Parameter ("...%@?...")
#endif

#ifndef		PP_HAS_IGNORE
#define 	PP_HAS_IGNORE	1					// Erweiterung um Parameter ignorieren ("...%~...")
#endif

#ifndef		PP_HAS_SYPRINTF
#define 	PP_HAS_SYPRINTF	1					// Die xsprintf() Funktionen aktivieren
#endif

#ifndef		PP_HAS_SXPRINTF
#define 	PP_HAS_SXPRINTF	1					// Die xsnprintf() Funktionen aktivieren
#endif

#ifndef		PP_HAS_SMPRINTF
#define 	PP_HAS_SMPRINTF	1					// Die xsmprintf() Funktionen aktivieren
#endif

#ifndef		PP_HAS_XPRINTF
#define 	PP_HAS_XPRINTF	1					// Die xprintf() Funktionen aktivieren
#endif

#ifndef		PP_HAS_FPRINTF
#define 	PP_HAS_FPRINTF	1					// Die fprintf() Funktionen aktivieren
#endif

#ifndef		PP_USE_STREAM
#define 	PP_USE_STREAM	0					// Fr WritePrintf die Stream-Funktion fwrite benutzen
#endif

#ifndef		PP_HEAP_ALLOC
#define 	PP_HEAP_ALLOC	128					// Startgre fr dynamischen Speicher
#endif

#define 	PP_NODPOINT		0x00000010			// Kein ':' in Zeitangabe
#define 	PP_ADDDATE		0x00000020			// Datum auch ausgeben
#define 	PP_HASWIDTH		0x00000040			// Wurde eine Breite angegeben
#define 	PP_FILLZERO_BIT	0x00000080			// Merke das Fill-Zero gesetzt wurde
#define 	PP_LEFTALIGN	0x00000100			// Ausgabe links ausrichten
#define 	PP_FILLZERO		0x00000200			// Ausgabe mit 0 auffllen
#define 	PP_FILLZERO_EX	0x00000280			// Ausgabe mit 0 auffllen plus Merker
#define 	PP_PREFIX		0x00000400			// Ein Prfix (0 oder 0x) ausgeben
#define 	PP_USEPRECIS	0x00000800			// Prezision ist die Stringlnge
#define 	PP_ADDSIGN	   (0x00010800|('+'<<24))//Ein Vorzeichen anhngen
#define 	PP_ADDSPACE	   (0x00001800|(' '<<24))//Ein Vorzeichen anhngen bei - und Space bei +
#define 	PP_UNTERLINE    0x00001000			// Unterline statt Space in Zeitangaben
#define 	PP_PRECISION	0x00002000			// Die Prezission wurde angegeben
#define 	PP_LOWCHAR		0x00004000			// Bei Exponenten 'e' verwenden
#define 	PP_IGNORE		0x00008000			// Einen Wert nicht ausgeben
#define 	PP_ADDSECS	    0x00010000			// Skunden in Zeitangaben ausgeben
#define 	PP_LONG64		0x00000001			// Acht Byte-Zahl
#define 	PP_LONG			0x00000002			// Vier Byte-Zahl
#define 	PP_SHORT		0x00000003			// Zwei Byte-Zahl
#define 	PP_CHAR			0x00000004			// Ein  Byte-Zahl
#ifndef		PP_PARAMS
#define 	PP_PARAMS		12					// Maximale Parameteranzahl
#endif

#ifndef		PP_PROC
#define 	PP_PROC			extern "C"
#endif

#if			PP_HAS_64BIT==0
#define		ppbin64(v,p)	ppbin((unsigned)(v),p)
#define		ppoct64(v,p)	ppoct((unsigned)(v),p)
#define		ppdec64(v,p)	ppdec((unsigned)(v),p)
#define		pphex64(v,p,c)	pphex((unsigned)(v),p,c)
#endif

#ifndef		PP_HAS_GLOBAL
#undef		PP_HAS_IGNORE
#define 	PP_HAS_IGNORE	1
#endif

#if			PP_HAS_DIVIDER
#define		TDEC			0x13
#define		TUNS			0x14
#else
#define		TDEC			0x00
#define		TUNS			0x00
#endif

#if			PP_HAS_DIVIDER && PP_HAS_FLOAT
#define		TFLT			0x15
#else
#define		TFLT			0x00
#endif

#if			PP_HAS_BINARY
#define		TBIN			0x08
#else
#define		TBIN			0x00
#endif

#if			PP_HAS_DUMP
#define		TDMP			0x12
#else
#define		TDMP			0x00
#endif

#if			PP_HAS_TIME
#define		TTIM			0x16
#else
#define		TTIM			0x00
#endif

#if			PP_HAS_GLOBAL
#define 	TGLB			0xE0
#define 	TIGN			0xC0
#else
#define 	TGLB			0x00
#endif

#if			PP_HAS_IGNORE
#define 	TIGN			0xC0
#endif

#ifndef		TIGN
#define 	TIGN			0x00
#endif


//*****************************************************************************
//*
//*		Compiler Einstellungen
//*
//*****************************************************************************

#ifdef _MSC_VER

	typedef	unsigned __int64    uppint64;
	typedef          __int64     ppint64;
	#define HIGH32_MASK		  ((uppint64)0xFFFFFFFF00000000l)

#elif defined(__GNUC__)

	typedef unsigned long long  uppint64;
	typedef          long long   ppint64;
	#define HIGH32_MASK			0xFFFFFFFF00000000ull

#elif defined(__CC_ARM)

	typedef unsigned long long  uppint64;
	typedef          long long   ppint64;
	#define HIGH32_MASK			0xFFFFFFFF00000000ull

#elif defined(__ICCARM__)

	typedef unsigned long long  uppint64;
	typedef          long long   ppint64;
	#define HIGH32_MASK			0xFFFFFFFF00000000ull

#else

	#error  unknown compiler

#endif



static const unsigned char aCharTypes[128] =
	{
	//	Bit0 = '*'
	//	Bit1 = Zahlen
	//	Bit2 = '.'
	//	Bit3 = printf Spezifikation
	//	Bit4 = printf Typen
	//	Bit5 = printf Flags  1='+' 2=' ' 3='#' 4='-' 5='0' 6='@' 7='~'
	//	Bit6 = printf Flags
	//	Bit7 = printf Flags
	0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,  // 00h
	0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,  //	10h
	0x42,0x00,0x00,0x60, 0x00,0x00,0x00,0x00, 0x00,0x00,0x01,0x22, 0x00,0x82,0x04,0x00,  //	20h
	0xA2,0x02,0x02,0x02, 0x02,0x02,0x02,0x02, 0x02,0x02,0x00,0x00, 0x00,0x00,0x00,0x00,  //	30h
	TGLB,0x10,0x10,0x10, 0x10,0x10,0x10,0x10, 0x00,0x08,0x00,0x10, 0x08,0x10,0x00,0x00,  //	40h
	0x00,0x00,0x00,0x10, 0x00,0x10,0x00,0x00, 0x10,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,  //	50h
	0x00,0x10,0x10,0x10, 0x10,0x10,0x10,0x10, 0x08,0x10,0x08,0x10, 0x08,0x10,0x10,0x10,  //	60h
	0x10,0x08,0x00,0x10, 0x08,0x10,0x00,0x08, 0x10,0x00,0x08,0x00, 0x00,0x00,TIGN,0x00,  //	70h
	};

static const unsigned char aCharModes[64] =
	{
	0x00,0x11,TBIN,0x00, TDEC,0x0F,TFLT,0x0D, 0x00,0x00,0x00,TTIM, 0x00,TDMP,0x00,0x00,  //	40h
	0x00,0x00,0x00,0x02, 0x00,TUNS,0x00,0x00, 0x0A,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,  //	50h
	0x00,0x11,TBIN,0x01, 0x05,0x0E,0x10,0x0C, 0x00,0x04,0x00,TTIM, 0x00,TDMP,0x0B,0x07,  //	60h
	0x09,0x00,0x00,0x03, 0x00,0x06,0x00,0x00, 0x0A,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,  //	70h
	};

#if PP_HAS_FLOAT

#include	<math.h>

static const double	aDecPow[16]	=
	{
	1.0,
	10.0,
	100.0,
	1000.0,
	10000.0,
	100000.0,
	1000000.0,
	10000000.0,
	100000000.0,
	1000000000.0,
	10000000000.0,
	100000000000.0,
	1000000000000.0,
	10000000000000.0,
	100000000000000.0,
	1000000000000000.0,
	};

static const double	aAddPow[16]	=
	{
	0.499999999999,
	0.0499999999999,
	0.00499999999999,
	0.000499999999999,
	0.0000499999999999,
	0.00000499999999999,
	0.000000499999999999,
	0.0000000499999999999,
	0.00000000499999999999,
	0.000000000499999999999,
	0.0000000000499999999999,
	0.00000000000499999999999,
	0.000000000000499999999999,
	0.0000000000000499999999999,
	0.00000000000000499999999999,
	0.000000000000000499999999999,
	};
#endif

typedef	struct
	{
	char	   *pBuffer;
	int			iOffset;
	int			iSize;
	}SxDataA;

typedef	struct
	{
	wchar_t    *pBuffer;
	int			iOffset;
	int			iSize;
	}SxDataW;

#if	PP_HAS_GLOBAL

typedef	union
	{
	unsigned   *pValue;
	unsigned	uValue;
	uppint64	uVal64;
	#if PP_HAS_FLOAT
	double		dValue;
	#if PP_HAS_LONGDBL
	long double	dValEx;
	#endif
	#endif
	}ParamEntry;

typedef	struct
	{
	int			iSize;
	int			iScan;
	int			iRead;
	ParamEntry	aData[PP_PARAMS];
	}ParamData;

#ifndef		va_copy
#define		va_copy(dst,src)		(dst)=(src);
#endif

#if PP_HAS_UNICODE
#define		int_iAdd				,int iAdd
#define		IADD					,iAdd
#else
const int	iAdd=1;
#define		int_iAdd
#define		IADD
#endif


//*****************************************************************************
//*
//*		ppscan
//*
//*****************************************************************************
//	Sucht alle Parameter in einem Format-String und bestimmt deren Gre
//	pFormatPtr	: Zeiger auf Format-String
//	pArgs		: Parameterliste auf aktuellen Parameter
//	pData		: Hier werden die Parameter gespeichert, und enthlt Infos.
//	iByte		: Gre des zuletzt gescannten Parameters
//	iAdd		: Gre eines Zeichen im Format-String
static void _cdecl ppscan(const void *pFormatPtr,va_list pArgs,ParamData *pData,int iByte int_iAdd)
	{
	unsigned char  *pFormat=(unsigned char*)pFormatPtr;
	char			aSizes[PP_PARAMS+2];
	unsigned char	ucType;
	unsigned char	ucSign;
	unsigned 		uFlags;
	int				iScan;
	int				iRead;
	int				iMode;
	int				iPos;
	int				iEnd;


	memset(aSizes,0,sizeof(aSizes));
	aSizes[pData->iRead-1] = iByte;
	iScan = pData->iScan+1;


	while(*pFormat)										// Format-String auswerten
		{
		ucSign   = pFormat[0];
		pFormat += iAdd;

		if(ucSign!='%')continue;						// Parameter gefunden

		if(iAdd==2 && pFormat[-1])
			{
			continue;
			}

		ucSign   = pFormat[0];
		pFormat += iAdd;

		if(ucSign=='%')continue;						// '%' ausgeben

		iMode    = 0;
		uFlags   = 0;
		iRead	 = iScan;
		ucType	 = aCharTypes[ucSign];

		while(ucType&0xE0)								// Format auswerten
			{
			if((ucType&0xE0)==TGLB)						// Parameter auf fixer Position "...%@?..."
				{
				   ucSign = pFormat[0];
				if(ucSign>='A' && ucSign<'A'+PP_PARAMS)
					{
					pFormat += iAdd;
					iRead	 = ucSign-'A'+1;
					iMode    = 1;
					}
				}

			   ucSign = *pFormat;pFormat+=iAdd;
			if(ucSign>=sizeof(aCharTypes))continue;
			ucType=aCharTypes[ucSign];
			}


		if(ucType&0x03)									// Breite auswerten
			{
			if(ucType&0x01)								// Breite vom Stack holen ('*')
				{
				aSizes[iRead] = sizeof(int);
				iRead++;

				   ucSign = *pFormat;pFormat+=iAdd;
				if(ucSign>=sizeof(aCharTypes))break;

				ucType=aCharTypes[ucSign];
				}
			else{
				while(ucType&0x02)						// Breite aus Zahl holen
					{
					   ucSign = *pFormat;pFormat+=iAdd;
					if(ucSign>=sizeof(aCharTypes))break;

					ucType=aCharTypes[ucSign];
					}
				}
			}

		if(ucType&0x05)									// Przision auswerten
			{
			   ucSign = *pFormat;pFormat+=iAdd;
			if(ucSign>=sizeof(aCharTypes))break;

			ucType=aCharTypes[ucSign];

			if(ucType&0x01)								// Przision vom Stack holen ('*')
				{
				aSizes[iRead] = sizeof(int);
				iRead++;

				   ucSign = *pFormat;pFormat+=iAdd;
				if(ucSign>=sizeof(aCharTypes))break;

				ucType=aCharTypes[ucSign];
				}
			else{
				while(ucType&0x02)						// Przision aus Zahl holen
					{
					   ucSign = *pFormat;pFormat+=iAdd;
					if(ucSign>=sizeof(aCharTypes))break;

					ucType=aCharTypes[ucSign];
					}
				}
			}

		if(ucType&0x08)									// Prfix auswerten
			{
			switch(ucSign)
				{
			case 'w':
			case 'j':
			case 'L':	uFlags |= PP_LONG;
						break;

			case 'z':	uFlags |= (sizeof(size_t)==8)? PP_LONG64:PP_LONG;
						break;

			case 't':	uFlags |= (sizeof(void*)==8)? PP_LONG64:PP_LONG;
						break;

			case 'q':	uFlags |= PP_LONG64;
						break;

			case 'h':	if(pFormat[0]=='h')
							{
							pFormat += iAdd;
							uFlags  |= PP_CHAR;
							}
						else{
							uFlags  |= PP_SHORT;
							}
						break;

			case 'l':	if(pFormat[0]=='l')
							{
							pFormat += iAdd;
							uFlags  |= PP_LONG64;
							}
						else{
							uFlags  |= (sizeof(long)==8)? PP_LONG64:PP_LONG;
							}
						break;

			case 'I':	if(pFormat[0]=='6' && pFormat[iAdd]=='4')
							{
							pFormat += iAdd*2;
							uFlags  |= PP_LONG64;
							break;
							}

						if(pFormat[0]=='3' && pFormat[iAdd]=='2')
							{
							pFormat += iAdd*2;
							uFlags  |= PP_LONG;
							break;
							}

						uFlags |= (sizeof(void*)==8)? PP_LONG64:PP_LONG;
						break;
				}

			   ucSign = *pFormat;pFormat+=iAdd;
			if(ucSign>=sizeof(aCharTypes))break;

			ucType=aCharTypes[ucSign];
			}


		if(!(ucType&0x10))								// Falsches Typzeichen
			{
			pFormat--;
			continue;
			}


		switch(aCharModes[ucSign-0x40])					// Typ auswerten
			{

		#if PP_HAS_USWITCH
		case 0:											// 'C'
		#endif
		case 1:											// 'c'
		#if PP_HAS_USWITCH
		case 2:											// 'S'
		#endif
					iByte = sizeof(int);
					break;
		case 3:											// 's':
		case 11:										// 'k'
		#if PP_HAS_DUMP
		case 18:										// 'm' 'M'
		#endif
					iByte = sizeof(char*);
					break;

		#if PP_HAS_TIME
		case 22:										// 'k' 'K'
					if((uFlags&0x07)==PP_LONG64 || (sizeof(time_t)==sizeof(ppint64) && !(uFlags&0x07)))
							iByte = sizeof(ppint64);
					else	iByte = sizeof(int);

					break;
		#endif

		case 9:											// 'p'
					if(sizeof(void*)==8 && !(uFlags&0x07))
						{
						iByte = 8;
						break;
						}
		case 4:											// 'i'
		case 5:											// 'd'
		case 6:											// 'u'
		#if PP_HAS_OCTAL
		case 7:											// 'o'
		#endif
		#if PP_HAS_BINARY
		case 8:											// 'b' 'B'
		#endif
		#if	PP_HAS_HEXDEC
		case 10:										// 'x' 'X'
		#endif
		#if PP_HAS_DIVIDER
		case 19:										// 'D'
		case 20:										// 'U'
		#if PP_HAS_FLOAT
		case 21:										// 'F'
		#endif
		#endif
					iByte = ((uFlags&0x07)==PP_LONG64)? sizeof(ppint64):sizeof(int);
					break;
		case 12:										// 'g'
		case 13:										// 'G'
		case 14:										// 'e'
		case 15:										// 'E'
		case 16:										// 'f'
		case 17:										// 'a' 'A'
					#if PP_HAS_LONGDBL
					iByte = (uFlags&(PP_LONG64|PP_LONG))? sizeof(long double):sizeof(double);
					#else
					iByte = sizeof(double);
					#endif
					break;

		default:	continue;
			}


		aSizes[iRead-1] = iByte;
		iRead++;

		if(iMode)										// Weiter bei aktuellem Parameter
			{
			iRead = iScan;
			}
		else{
			iScan = iRead;
			}
		}

	for(iEnd=PP_PARAMS-1;iEnd>0;iEnd--)					// Suche den letzten Parameter
		{
		if(aSizes[iEnd])break;
		}

	va_list pNext;

	va_copy(pNext,pArgs);

	for(iPos=pData->iSize;iPos<=iEnd;iPos++)			// Daten einlesen
		{
		if(aSizes[iPos]==sizeof(ppint64))
			{
			pData->aData[iPos].uVal64 = va_arg(pNext,ppint64);
			}
		#if PP_HAS_FLOAT && PP_HAS_LONGDBL
		else if(aSizes[iPos]==sizeof(long double) && sizeof(long double)!=sizeof(double))
			{
			pData->aData[iPos].dValEx = va_arg(pNext,long double);
			}
		#endif
		else{
			pData->aData[iPos].uValue = va_arg(pNext,unsigned);
			}
		}

	pData->iSize = iPos;

	va_end(pNext);
	}

#define 	va_get_arg(target,ttype,args,type)									\
				{																\
				if(sParams.iRead==0)											\
					{															\
					target=(ttype)va_arg(args,type);							\
					sParams.iScan++;											\
					if(sParams.iSize<PP_PARAMS)									\
						{														\
						*(ttype*)(sParams.aData+sParams.iSize)=(ttype)target;	\
						sParams.iSize++;										\
						}														\
					}															\
				else{															\
					if(sParams.iRead>sParams.iSize)								\
						{														\
						int iAdd=sizeof(*pFormat);								\
						ppscan(pFormat,pArgs,&sParams,sizeof(type) IADD);		\
						}														\
					target = *(ttype*)(sParams.aData+sParams.iRead-1);			\
					}															\
				}

#else

#define 	va_get_arg(target,ttype,args,type)	target=(ttype)va_arg(args,type);

#endif


//*****************************************************************************
//*
//*		memsetu
//*
//*****************************************************************************

#if	PP_HAS_UNICODE || PP_HAS_USWITCH

static void _cdecl memsetu(void *pBuffer,int iVal,unsigned uCount)
{
unsigned short	*pPtr=(unsigned short*)pBuffer;



	while(uCount>0)
		{
	   *pPtr = (unsigned short)iVal;
		pPtr++;
		uCount--;
		}

}

#endif

//*****************************************************************************
//*
//*		WriteSxPrintf
//*
//*****************************************************************************
//	Speichert Daten in einem Textpuffer mit Lngenbeschrnkung.
//	pParam	: Zeiger auf FILE Pointer
//	pBuffer	: Zeiger auf Puffer
//	iSize	: Lnge der Daten im Puffer in Zeichen
//	Ergibt die Anzahl der gespeicherten Zeichen.

#if PP_HAS_SXPRINTF || PP_HAS_SYPRINTF

static int _cdecl WriteSxPrintf(void *pParam,const char *pBuffer,int iSize)
{
SxDataA	   *pData=(SxDataA*)pParam;


	if(pData->iOffset+iSize>=pData->iSize)
		{
		if(pData->iOffset>=pData->iSize)
			{
			return 0;
			}

		iSize = pData->iSize-pData->iOffset;
		}

	memcpy(pData->pBuffer+pData->iOffset,pBuffer,iSize);
	pData->iOffset += iSize;


return iSize;
}

#if PP_HAS_UNICODE

static int _cdecl WriteSxPrintf(void *pParam,const wchar_t *pBuffer,int iSize)
{
SxDataW	   *pData=(SxDataW*)pParam;


	if(pData->iOffset+iSize>=pData->iSize)
		{
		if(pData->iOffset>=pData->iSize)
			{
			return 0;
			}

		iSize = pData->iSize-pData->iOffset;
		}

	memcpy(pData->pBuffer+pData->iOffset,pBuffer,iSize*sizeof(wchar_t));
	pData->iOffset += iSize;


return iSize;
}

#endif

#endif

//*****************************************************************************
//*
//*		WriteSmPrintf
//*
//*****************************************************************************
//	Speichert Daten in einem Textpuffer mit dynamischen Speicher.
//	pParam	: Zeiger auf FILE Pointer
//	pBuffer	: Zeiger auf Puffer
//	iSize	: Lnge der Daten im Puffer in Zeichen
//	Ergibt die Anzahl der gespeicherten Zeichen.

#if PP_HAS_SXPRINTF || PP_HAS_SYPRINTF

static int _cdecl WriteSmPrintf(void *pParam,const char *pBuffer,int iSize)
{
HeapStringA	   *pData=(HeapStringA*)pParam;
char		   *pText;
int				iNew;


	if(pData->iSize+iSize>pData->iMax)					// Speicher Block vergrern
		{
		iNew  = pData->iMax+pData->iMax/2+iSize+PP_HEAP_ALLOC;
		iNew &= ~15;

			pText = new char[iNew];
		if(!pText)return 0;

		memcpy(pText,pData->pText,pData->iSize);
		delete pData->pText;
		pData->pText = pText;
		pData->iMax  = iNew;
		}

	memcpy(pData->pText+pData->iSize,pBuffer,iSize);
	pData->iSize += iSize;


return iSize;
}

#if PP_HAS_UNICODE

static int _cdecl WriteSmPrintf(void *pParam,const wchar_t *pBuffer,int iSize)
{
HeapStringW	   *pData=(HeapStringW*)pParam;
wchar_t		   *pText;
int				iNew;


	if(pData->iSize+iSize>pData->iMax)					// Speicher Block vergrern
		{
		iNew  = pData->iMax+pData->iMax/2+iSize+PP_HEAP_ALLOC;
		iNew &= ~15;

			pText = new wchar_t[iNew];
		if(!pText)return 0;

		memcpy(pText,pData->pText,pData->iSize);
		delete pData->pText;
		pData->pText = pText;
		pData->iMax  = iNew;
		}


	memcpy(pData->pText+pData->iSize,pBuffer,iSize*sizeof(wchar_t));
	pData->iSize += iSize;


return iSize;
}

#endif

#endif

//*****************************************************************************
//*
//*		WritePrintf
//*
//*****************************************************************************
//	Gibt Daten in der aktuellen console aus.
//	pParam	: Zeiger auf FILE Pointer
//	pBuffer	: Zeiger auf Puffer
//	iSize	: Lnge der Daten im Puffer in Zeichen
//	Ergibt die Anzahl der gespeicherten Zeichen.

#if PP_HAS_XPRINTF

#if			defined(_WIN32)
#include	<windows.h>
#elif		defined(linux)
#include	<unistd.h>
#endif

static int _cdecl WritePrintf(void *pParam,const char *pBuffer,int iSize)
{
	#if		defined(ConOutputA)

	return	ConOutputA(pParam,pBuffer,iSize);

	#elif	PP_USE_STREAM
	
	return 	fwrite(pBuffer,1,iSize,(FILE*)pParam);

	#elif	defined(_WIN32)

	DWORD	dwBytes;
	WriteFile(pParam,pBuffer,iSize,&dwBytes,NULL);
	return	dwBytes;

	#elif	defined(linux)

	return	write((int)pParam,pBuffer,iSize);

	#else

	#error	unknown OS

	#endif
}

#if PP_HAS_UNICODE

static int _cdecl WritePrintf(void *pParam,const wchar_t *pBuffer,int iSize)
{
	#if		defined(ConOutputW)

	return	ConOutputW(pParam,pBuffer,iSize);

	#elif	PP_USE_STREAM
	
	return 	fwrite(pBuffer,1,iSize,(FILE*)pParam);

	#elif	defined(_WIN32)

	DWORD	dwBytes;
	WriteFile(pParam,pBuffer,iSize*sizeof(wchar_t),&dwBytes,NULL);
	return	dwBytes/sizeof(wchar_t);

	#elif	defined(linux)

	#error	convert to uft8
	return	write((int)pParam,pBuffer,iSize);

	#else

	#error	unknown OS

	#endif
}

#endif

#endif

//*****************************************************************************
//*
//*		WriteAnsiPf
//*
//*****************************************************************************
//	Speichert einen Puffer im ANSI Format in einer Datei
//	pParam	: Zeiger auf FILE Pointer
//	pBuffer	: Zeiger auf Puffer
//	iSize	: Lnge der Daten im Puffer in Zeichen
//	Ergibt die Anzahl der gespeicherten Zeichen

#if PP_HAS_FPRINTF

static int _cdecl WriteAnsiPf(void *pParam,const char *pBuffer,int iSize)
{
return (int)fwrite(pBuffer,1,iSize,(FILE*)pParam);
}

#if PP_HAS_UNICODE

static int _cdecl WriteAnsiPf(void *pParam,const wchar_t *pBuffer,int iSize)
{
wchar_t		uChar;
char		cBuffer[256];
int			iPos,iOff,iOut;


	iOut = 0;
	iOff = 0;

	for(iPos=0;iPos<iSize;iPos++)
		{
		   uChar = pBuffer[iPos];
		if(uChar>=256)continue;

		cBuffer[iOff] = (char)uChar;
		iOff++;

		if(iOff<sizeof(cBuffer))continue;

		iOut += (int)fwrite(cBuffer,1,iOff,(FILE*)pParam);
		iOff  = 0;
		}


	if(iOff>0)
		{
		iOut += (int)fwrite(cBuffer,1,iOff,(FILE*)pParam);
		}


return iOut;
}

#endif

#endif

//*****************************************************************************
//*
//*		WriteAnsiPf
//*
//*****************************************************************************
//	Speichert einen Puffer im UTF8 Format in einer Datei
//	pParam	: Zeiger auf FILE Pointer
//	pBuffer	: Zeiger auf Puffer
//	iSize	: Lnge der Daten im Puffer in Zeichen
//	Ergibt die Anzahl der gespeicherten Zeichen

#if PP_HAS_FPRINTF

static int _cdecl WriteUtf8Pf(void *pParam,const char *pBuffer,int iSize)
{
unsigned	uUnicode;
char		cBuffer[256];
int			iPos,iOff,iOut;


	iOut = 0;
	iOff = 0;

	for(iPos=0;iPos<iSize;iPos++)
		{
		uUnicode = (unsigned char)pBuffer[iPos];

		if(uUnicode<0x80)								// Ein Zeichen
			{
			cBuffer[iOff]=(char)uUnicode;  iOff++;
			}
		else{											// Zwei Zeichen
			cBuffer[iOff]=(char)((uUnicode>>  6)|0xC0);iOff++;
			cBuffer[iOff]=(char)((uUnicode&0x3F)|0x80);iOff++;
			}

		if(iOff<sizeof(cBuffer)-2)continue;

		iOut += (int)fwrite(cBuffer,1,iOff,(FILE*)pParam);
		iOff  = 0;
		}


	if(iOff>0)
		{
		iOut += (int)fwrite(cBuffer,1,iOff,(FILE*)pParam);
		}


return iOut;
}

#if PP_HAS_UNICODE

static int _cdecl WriteUtf8Pf(void *pParam,const wchar_t *pBuffer,int iSize)
{
unsigned		uLast;
unsigned		uUnicode;
unsigned char	ucTemp [4];
char			cBuffer[256];
int				iPos,iOff,iOut;


	iOut = 0;
	iOff = 0;

	for(iPos=0;iPos<iSize;iPos++)
		{
		uUnicode = pBuffer[iPos];

		if(uUnicode<0x80)								// Ein Zeichen
			{
			cBuffer[iOff]=(char)uUnicode;  iOff++;
			}
		else if(uUnicode<0x800)							// Zwei Zeichen
			{
			cBuffer[iOff]=(char)((uUnicode>>  6)|0xC0);iOff++;
			cBuffer[iOff]=(char)((uUnicode&0x3F)|0x80);iOff++;
			}
		else if(uUnicode<0xD800 || uUnicode>0xDFFF)		// Drei Zeichen
			{
			cBuffer[iOff]=(char)( (uUnicode>>12)      |0xE0);iOff++;
			cBuffer[iOff]=(char)(((uUnicode>> 6)&0x3F)|0x80);iOff++;
			cBuffer[iOff]=(char)( (uUnicode     &0x3F)|0x80);iOff++;
			}
		else{											// Vier Zeichen

			if(uUnicode>=0xDC00)						// Low-Surrogate ohne High-Surrogate
				{
				if(iPos!=0)continue;
				if(fseek((FILE*)pParam,-4,SEEK_CUR  ))continue;
				if(fread(ucTemp,4,1,(FILE*)pParam)!=1)continue;

				uLast  = (ucTemp[0]&0x07)<<18;
				uLast |= (ucTemp[1]&0x3F)<<12;
				uLast |= (ucTemp[2]&0x3F)<< 6;
				uLast |= (ucTemp[3]&0x3F);

				if(uLast&0x03FF)continue;
				if(fseek((FILE*)pParam,-4,SEEK_CUR  ))continue;

				uUnicode  &= 0x03FF;
				uUnicode  |= uLast;
				}
			else{										// High-Surrogate
				uUnicode  &= 0x03FF;
				uUnicode  += 0x0040;
				uUnicode <<= 10;

				if(iPos+1<iSize)						// Low-Surrogate anhngen
				if((pBuffer[iPos+1]&0xFC00)==0xDC00)
					{
					uUnicode |= pBuffer[iPos+1]&0x03FF;
					iPos++;
					}
				}

			cBuffer[iOff]=(char)(((uUnicode>>18)&0x07)|0xF0);iOff++;
			cBuffer[iOff]=(char)(((uUnicode>>12)&0x3F)|0x80);iOff++;
			cBuffer[iOff]=(char)(((uUnicode>> 6)&0x3F)|0x80);iOff++;
			cBuffer[iOff]=(char)( (uUnicode     &0x3F)|0x80);iOff++;
			}

		if(iOff<sizeof(cBuffer)-4)continue;

		iOut += (int)fwrite(cBuffer,1,iOff,(FILE*)pParam);
		iOff  = 0;
		}


	if(iOff>0)
		{
		iOut += (int)fwrite(cBuffer,1,iOff,(FILE*)pParam);
		}


return iOut;
}

#endif

#endif

//*****************************************************************************
//*
//*		WriteWidePf
//*
//*****************************************************************************
//	Speichert einen Puffer im UTF16 Format in einer Datei
//	pParam	: Zeiger auf FILE Pointer
//	pBuffer	: Zeiger auf Puffer
//	iSize	: Lnge der Daten im Puffer in Zeichen
//	Ergibt die Anzahl der gespeicherten Zeichen

#if PP_HAS_FPRINTF

static int _cdecl  WriteWidePf(void *pParam,const char *pBuffer,int iSize)
{
wchar_t		uChar;
wchar_t		cBuffer[256];
int			iPos,iOff,iOut;


	iOut = 0;
	iOff = 0;

	for(iPos=0;iPos<iSize;iPos++)
		{
		uChar		  = (unsigned char)pBuffer[iPos];
		cBuffer[iOff] = uChar;
		iOff++;

		if(iOff<sizeof(cBuffer))continue;

		iOut += (int)fwrite(cBuffer,2,iOff,(FILE*)pParam);
		iOff  = 0;
		}


	if(iOff>0)
		{
		iOut += (int)fwrite(cBuffer,2,iOff,(FILE*)pParam);
		}


return iOut;
}

#if PP_HAS_UNICODE

static int _cdecl  WriteWidePf(void *pParam,const wchar_t *pBuffer,int iSize)
{
return (int)fwrite(pBuffer,2,iSize,(FILE*)pParam);
}

#endif

#endif

//*****************************************************************************
//*
//*		CharToUnicode
//*
//*****************************************************************************
//	Konvertiert einen CHAR-Puffer in einen WCHAR-Puffer
//	pBuffer		: Ist der Zeiger auf den Puffer
//	iLen		: Ist die Lnge des Puffers
#if PP_HAS_UNICODE

static void inline CharToUnicode(wchar_t *pBuffer,int iLen)
{
unsigned char	*pInput=(unsigned char*)pBuffer;


	for(iLen--;iLen>=0;iLen--)
		{
		pBuffer[iLen] = pInput[iLen];
		}


}

#endif

//*****************************************************************************
//*
//*		pphex
//*
//*****************************************************************************
//	Eine Hexadzimalzahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if	PP_HAS_HEXDEC

static int pphex(unsigned uValue,char *pBuffer,const char *pDigits)
{
int		iPos;
int		iShift;



	for(iShift=28;iShift>=0;iShift-=4)					// Suche Beginn
		{
		if(uValue&(0x0F<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = pDigits[(uValue>>iShift)&0x0F];
		iShift -= 4;
		iPos   += 1;
		};


return iPos;
}

#if PP_HAS_UNICODE

static int pphex(unsigned uValue,wchar_t *pBuffer,const char *pDigits)
{
int		iPos;
int		iShift;



	for(iShift=28;iShift>=0;iShift-=4)					// Suche Beginn
		{
		if(uValue&(0x0F<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = pDigits[(uValue>>iShift)&0x0F];
		iShift -= 4;
		iPos   += 1;
		}


return iPos;
}

#endif
#endif

//*****************************************************************************
//*
//*		pphex64
//*
//*****************************************************************************
//	Eine 64-Bit-Hexadzimalzahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if	PP_HAS_HEXDEC
#if PP_HAS_64BIT

static int pphex64(uppint64 uValue,char *pBuffer,const char *pDigits)
{
int		iPos;
int		iShift;


	if(!(uValue&HIGH32_MASK))
		{
		return pphex((unsigned)uValue,pBuffer,pDigits);
		}


	for(iShift=60;iShift>=0;iShift-=4)					// Suche Beginn
		{
		if(uValue&((ppint64)0x0F<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = pDigits[(uValue>>iShift)&0x0F];
		iShift -= 4;
		iPos   += 1;
		};


return iPos;
}

#if PP_HAS_UNICODE

static int pphex64(uppint64 uValue,wchar_t *pBuffer,const char *pDigits)
{
int		iPos;
int		iShift;


	if(!(uValue&HIGH32_MASK))
		{
		return pphex((unsigned)uValue,pBuffer,pDigits);
		}

	for(iShift=60;iShift>=0;iShift-=4)					// Suche Beginn
		{
		if(uValue&((ppint64)0x0F<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = pDigits[(uValue>>iShift)&0x0F];
		iShift -= 4;
		iPos   += 1;
		}


return iPos;
}

#endif
#endif
#endif

//*****************************************************************************
//*
//*		ppoct
//*
//*****************************************************************************
//	Eine 64-Bit-Oktalzahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_OCTAL

static int ppoct(unsigned uValue,char *pBuffer)
{
int		iPos;
int		iShift;



	for(iShift=30;iShift>=0;iShift-=3)					// Suche Beginn
		{
		if(uValue&(0x07<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (char)('0'+((uValue>>iShift)&0x07));
		iShift -= 3;
		iPos   += 1;
		};


return iPos;
}

#if PP_HAS_UNICODE

static int ppoct(unsigned uValue,wchar_t *pBuffer)
{
int		iPos;
int		iShift;



	for(iShift=30;iShift>=0;iShift-=3)					// Suche Beginn
		{
		if(uValue&(0x07<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (wchar_t)('0'+((uValue>>iShift)&0x07));
		iShift -= 3;
		iPos   += 1;
		};


return iPos;
}

#endif
#endif

//*****************************************************************************
//*
//*		ppoct64
//*
//*****************************************************************************
//	Eine 64-Bit-Oktalzahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_OCTAL
#if PP_HAS_64BIT

static int ppoct64(uppint64 uValue,char *pBuffer)
{
int		iPos;
int		iShift;


	if(!(uValue&HIGH32_MASK))
		{
		return ppoct((unsigned)uValue,pBuffer);
		}


	for(iShift=63;iShift>=0;iShift-=3)					// Suche Beginn
		{
		if(uValue&((ppint64)0x07<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (char)('0'+((uValue>>iShift)&0x07));
		iShift -= 3;
		iPos   += 1;
		}


return iPos;
}

#if PP_HAS_UNICODE

static int ppoct64(uppint64 uValue,wchar_t *pBuffer)
{
int		iPos;
int		iShift;


	if(!(uValue&HIGH32_MASK))
		{
		return ppoct((unsigned)uValue,pBuffer);
		}


	for(iShift=63;iShift>=0;iShift-=3)					// Suche Beginn
		{
		if(uValue&((ppint64)0x07<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (wchar_t)('0'+((uValue>>iShift)&0x07));
		iShift -= 3;
		iPos   += 1;
		};


return iPos;
}

#endif
#endif
#endif

//*****************************************************************************
//*
//*		ppbin
//*
//*****************************************************************************
//	Eine Binrzahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_BINARY

static int ppbin(unsigned uValue,char *pBuffer)
{
int		iPos;
int		iShift;



	for(iShift=31;iShift>0;iShift--)					// Suche Beginn
		{
		if(uValue&(1<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (char)('0'+((uValue>>iShift)&1));
		iShift--;
		iPos++;
		}


return iPos;
}

#if PP_HAS_UNICODE

static int ppbin(unsigned uValue,wchar_t *pBuffer)
{
int		iPos;
int		iShift;



	for(iShift=31;iShift>=0;iShift--)					// Suche Beginn
		{
		if(uValue&(1<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (wchar_t)('0'+((uValue>>iShift)&1));
		iShift--;
		iPos++;
		}


return iPos;
}

#endif
#endif

//*****************************************************************************
//*
//*		ppbin64
//*
//*****************************************************************************
//	Eine 64-Bit-Binrzahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_BINARY
#if PP_HAS_64BIT

static int ppbin64(uppint64 uValue,char *pBuffer)
{
int		iPos;
int		iShift;


	if(!(uValue&HIGH32_MASK))
		{
		return ppbin((unsigned)uValue,pBuffer);
		}


	for(iShift=63;iShift>=0;iShift--)					// Suche Beginn
		{
		if(uValue&((ppint64)1<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (char)('0'+((uValue>>iShift)&1));
		iShift--;
		iPos++;
		}


return iPos;
}

#if PP_HAS_UNICODE

static int ppbin64(uppint64 uValue,wchar_t *pBuffer)
{
int		iPos;
int		iShift;


	if(!(uValue&HIGH32_MASK))
		{
		return ppbin((unsigned)uValue,pBuffer);
		}


	for(iShift=63;iShift>=0;iShift--)					// Suche Beginn
		{
		if(uValue&((ppint64)1<<iShift))break;
		}

	iPos = 0;

	while(iShift>=0)
		{
		pBuffer[iPos] = (wchar_t)('0'+((uValue>>iShift)&1));
		iShift--;
		iPos++;
		}


return iPos;
}

#endif
#endif
#endif

//*****************************************************************************
//*
//*		ppdec
//*
//*****************************************************************************
//	Eine Zahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
static int ppdec(unsigned uValue,char *pBuffer)
{
int		iPos,i;
char	cTemp[32];


	iPos = 0;

	while(uValue)
		{
		cTemp[iPos] = (char)('0'+uValue%10);
		uValue     /= 10;
		iPos++;
		}


	for(i=iPos;i>0;)
		{
		i--;
		pBuffer[i] = cTemp[iPos-i-1];
		}


return iPos;
}

#if PP_HAS_UNICODE

static int ppdec(unsigned uValue,wchar_t *pBuffer)
{
int			iPos,i;
wchar_t		cTemp[32];


	iPos = 0;

	while(uValue)
		{
		cTemp[iPos] = (wchar_t)('0'+uValue%10);
		uValue     /= 10;
		iPos++;
		}


	for(i=iPos;i>0;)
		{
		i--;
		pBuffer[i] = cTemp[iPos-i-1];
		}


return iPos;
}

#endif

//*****************************************************************************
//*
//*		ppdec64
//*
//*****************************************************************************
//	Eine 64-Bit-Zahl in einen Text umwandeln
//	uValue	: Ist die Zahl
//	pBuffer	: Zeiger auf den Textpuffer
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_64BIT

static int ppdec64(uppint64 uValue,char *pBuffer)
{
int		iPos,i;
char	cTemp[32];


	if(!(uValue&HIGH32_MASK))
		{
		return ppdec((unsigned)uValue,pBuffer);
		}

	iPos = 0;

	while(uValue)
		{
		cTemp[iPos] = (char)('0'+uValue%10L);
		uValue     /= 10L;
		iPos++;
		}


	for(i=iPos;i>0;)
		{
		i--;
		pBuffer[i] = cTemp[iPos-i-1];
		}


return iPos;
}

#if PP_HAS_UNICODE

static int ppdec64(uppint64 uValue,wchar_t *pBuffer)
{
int			iPos,i;
wchar_t		cTemp[32];



	if(!(uValue&HIGH32_MASK))
		{
		return ppdec((unsigned)uValue,pBuffer);
		}

	iPos = 0;

	while(uValue)
		{
		cTemp[iPos] = (wchar_t)('0'+uValue%10L);
		uValue     /= 10L;
		iPos++;
		}


	for(i=iPos;i>0;)
		{
		i--;
		pBuffer[i] = cTemp[iPos-i-1];
		}


return iPos;
}

#endif
#endif

#if PP_HAS_FLOAT

//*****************************************************************************
//*
//*		ppdouble_f
//*
//*****************************************************************************
//	Eine Fliekommazahl in einen Text umwandeln.
//	uValue		: Ist die Zahl
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_LEFTALIGN	0x0100		Ausgabe links ausrichten
//					PP_FILLZERO		0x0200		Ausgabe mit 0 auffllen
//					PP_PREFIX		0x0400		Ein Prfix (0 oder 0x) ausgeben
//					PP_ADDSIGN		0x0800		Ein Vorzeichen anhngen
//					PP_ADDSPACE		0x1000		Ein Vorzeichen anhngen bei - und Space bei +
//					PP_PRECISION	0x2000		Die Prezission wurde angegeben
//					PP_LOWCHAR		0x4000		Bei Exponenten 'e' verwenden
//	iPrecision	: Anzahl der Kommastellen
//	Ergibt die Anzahl der ausgegebenen Bytes
static	int ppdouble_f(double dValue,char *pBuffer,unsigned uFlags,int iPrecision)
{
double		dMul;
int			iLen;
int			iNum;
int			iVal;
union
	{
	double			dFloat;
	unsigned char	aByte [8];
	unsigned short 	aWord [4];
	unsigned short 	aDword[2];
	}sVal;



	if(!(uFlags&PP_PRECISION))								// Default-Wert fr Kommastellen
		{
		iPrecision = 6;
		}


	sVal.dFloat	= dValue;

	if(sVal.aByte[7]&0x80)									// Wert kleiner als 0
		{
		sVal.aByte[7]&=~0x80;
		pBuffer[0]    = '-';
		iLen          = 1;
		}
	else if(uFlags&PP_ADDSIGN)								// Immer ein Vorzeichen anhngen
		{
		pBuffer[0]    = uFlags>>24;
		iLen          = 1;
		}
	else{
		iLen          = 0;
		}


	if((sVal.aWord[3]&0x7FFF)>=0x7FF0)						// INF oder NAN
		{
		if(sVal.aDword[0]==0 && sVal.aWord[2]==0 && (sVal.aByte[6]&0x0F)==0)
			{
			strcpy(pBuffer+iLen,"1.#INF");
			}
		else{
			strcpy(pBuffer+iLen,"1.#NAN");
			}

		iLen++;

		if(iPrecision<=0)									// Keine Kommastellen
			{
			if(uFlags&PP_PREFIX)iLen++;
			return iLen;
			}

		if(iPrecision<4)
			{
			memset(pBuffer+iLen+2,'$',4);
			}

		return iLen+2+iPrecision;
		}



	if(iPrecision<=sizeof(aDecPow)/sizeof(aDecPow[0]))		// Die letzte Stelle runden
			sVal.dFloat += aAddPow[iPrecision];
	else	sVal.dFloat += pow(10.0,(double)-iPrecision)*aDecPow[0];



	   iNum = (int)log10(sVal.dFloat);						// Anzahl der Vorkommastellen
	if(iNum<0)iNum=0;

	if(iNum<=sizeof(aDecPow)/sizeof(aDecPow[0]))
			dMul = aDecPow[iNum];
	else	dMul = pow(10.0,(double)iNum);


	if(iPrecision+iNum>=900)								// Puffergre prfen
		{
		iPrecision = 900-iNum;
		}


	for(;;)													// Vorkommastellen berechnen
		{
		iVal          = (int)(sVal.dFloat/dMul);
		pBuffer[iLen] = '0'+iVal;
		sVal.dFloat  -= dMul*(double)iVal;

		iLen++;
		iNum--;

		if(iNum<0)break;

		if(iNum<=sizeof(aDecPow)/sizeof(aDecPow[0]))
				dMul = aDecPow[iNum];
		else	dMul = pow(10.0,(double)iNum);
		}


	if(iPrecision<=0)										// Keine Kommastellen
		{
		if(uFlags&PP_PREFIX)
			{
			pBuffer[iLen] = '.';
			iLen++;
			}

		return iLen;
		}


	pBuffer[iLen] = '.';
	iLen++;


	for(;;)													// Nachkommastellen
		{
		sVal.dFloat  *= 10.0;
		iVal		  = (int)sVal.dFloat;
		pBuffer[iLen] = '0'+iVal;


		   iPrecision--;
		if(iPrecision<0)break;

		sVal.dFloat  -= (double)iVal;
		iLen++;
		}



return iLen;
}

#if PP_HAS_UNICODE

static	int ppdouble_f(double dValue,wchar_t *pBuffer,unsigned uFlags,int iPrecision)
{
int		iLen;


	iLen = ppdouble_f(dValue,(char*)pBuffer,uFlags,iPrecision);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif

//*****************************************************************************
//*
//*		ppdouble_e
//*
//*****************************************************************************
//	Eine Fliekommazahl in einen Text umwandeln im Expontezialformat. (1.0e+123)
//	uValue		: Ist die Zahl
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_LEFTALIGN	0x0100		Ausgabe links ausrichten
//					PP_FILLZERO		0x0200		Ausgabe mit 0 auffllen
//					PP_PREFIX		0x0400		Ein Prfix (0 oder 0x) ausgeben
//					PP_ADDSIGN		0x0800		Ein Vorzeichen anhngen
//					PP_ADDSPACE		0x1000		Ein Vorzeichen anhngen bei - und Space bei +
//					PP_PRECISION	0x2000		Die Prezission wurde angegeben
//					PP_LOWCHAR		0x4000		Bei Exponenten 'e' verwenden
//	iPrecision	: Anzahl der Kommastellen
//	Ergibt die Anzahl der ausgegebenen Bytes
static	int ppdouble_e(double dValue,char *pBuffer,unsigned uFlags,int iPrecision)
{
double		dMul;
int			iLen;
int			iNum;
int			iVal;
int			iExp;
union
	{
	double			dFloat;
	unsigned char	aByte [8];
	unsigned short 	aWord [4];
	unsigned int  	aDword[2];
	}sVal;



	if(!(uFlags&PP_PRECISION))								// Default-Wert fr Kommastellen
		{
		iPrecision = 6;
		}


	sVal.dFloat	= dValue;

	if(sVal.aByte[7]&0x80)									// Wert kleiner als 0
		{
		sVal.aByte[7]&=~0x80;
		pBuffer[0]    = '-';
		iLen          = 1;
		}
	else if(uFlags&PP_ADDSIGN)								// Immer ein Vorzeichen anhngen
		{
		pBuffer[0]    = uFlags>>24;
		iLen          = 1;
		}
	else{
		iLen          = 0;
		}


	if((sVal.aWord[3]&0x7FFF)>=0x7FF0)						// INF oder NAN
		{
		if(sVal.aDword[0]==0 && sVal.aWord[2]==0 && (sVal.aByte[6]&0x0F)==0)
			{
			strcpy(pBuffer+iLen,"1.#INF");
			}
		else{
			strcpy(pBuffer+iLen,"1.#NAN");
			}

		iLen++;

		if(iPrecision<=0)									// Keine Kommastellen
			{
			if(uFlags&PP_PREFIX)iLen++;
			return iLen;
			}

		if(iPrecision<4)
			{
			memset(pBuffer+iLen+2,'$',4);
			}

		return iLen+2+iPrecision;
		}


	if(iPrecision>=900)										// Puffergre prfen
		{
		iPrecision = 900;
		}


	   iExp	= (int)log10(sVal.dFloat);						// Anzahl der Vorkommastellen
	if(iExp<0)
		{
		iExp--;
		iNum = -iExp;

		if(iNum<=sizeof(aDecPow)/sizeof(aDecPow[0]))
				dMul = aDecPow[iNum];
		else	dMul = pow(10.0,(double)iNum);

		sVal.dFloat *= dMul;
		}
	else if(iExp>0)
		{
		if(iExp<=sizeof(aDecPow)/sizeof(aDecPow[0]))
				dMul = aDecPow[iExp];
		else	dMul = pow(10.0,(double)iExp);

		sVal.dFloat /= dMul;
		}


	if(iPrecision<=sizeof(aDecPow)/sizeof(aDecPow[0]))		// Die letzte Stelle runden
			sVal.dFloat += aAddPow[iPrecision];
	else	sVal.dFloat += pow(10.0,(double)-iPrecision)*aDecPow[0];


	if(sVal.dFloat>=10.0)
		{
		sVal.dFloat /= 10.0;
		iExp++;
		}


	iVal          = (int)sVal.dFloat;						// Vorkommastelle berechnen
	pBuffer[iLen] = '0'+iVal;
	sVal.dFloat  -= (double)iVal;

	iLen++;

	if(iPrecision>0 || (uFlags&PP_PREFIX))					// Kommastelle einfgen
		{
		pBuffer[iLen] = '.';
		iLen++;
		}

	while(iPrecision>0)										// Nachkommastellen
		{
		sVal.dFloat  *= 10.0;
		iVal		  = (int)sVal.dFloat;
		pBuffer[iLen] = '0'+iVal;
		sVal.dFloat  -= (double)iVal;

		iLen++;
		iPrecision--;
		}


	pBuffer[iLen] = (uFlags&PP_LOWCHAR)? 'e':'E';			// Exponent anhngen
	iLen++;

	if(iExp<0)
		{
		pBuffer[iLen] = '-';
		iExp=-iExp;
		iLen++;
		}
	else{
		pBuffer[iLen] = '+';
		iLen++;
		}

	pBuffer[iLen] = '0'+(iExp/100);		iLen++;
	pBuffer[iLen] = '0'+(iExp/10)%10;	iLen++;
	pBuffer[iLen] = '0'+(iExp%10);		iLen++;



return iLen;
}

#if PP_HAS_UNICODE

static	int ppdouble_e(double dValue,wchar_t *pBuffer,unsigned uFlags,int iPrecision)
{
int		iLen;


	iLen = ppdouble_e(dValue,(char*)pBuffer,uFlags,iPrecision);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif

//*****************************************************************************
//*
//*		ppdouble_g
//*
//*****************************************************************************
//	Eine Fliekommazahl in einen Text umwandeln (im besten Format).
//	uValue		: Ist die Zahl
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_LEFTALIGN	0x0100		Ausgabe links ausrichten
//					PP_FILLZERO		0x0200		Ausgabe mit 0 auffllen
//					PP_PREFIX		0x0400		Ein Prfix (0 oder 0x) ausgeben
//					PP_ADDSIGN		0x0800		Ein Vorzeichen anhngen
//					PP_ADDSPACE		0x1000		Ein Vorzeichen anhngen bei - und Space bei +
//					PP_PRECISION	0x2000		Die Prezission wurde angegeben
//					PP_LOWCHAR		0x4000		Bei Exponenten 'e' verwenden
//	iPrecision	: Anzahl der Kommastellen
//	Ergibt die Anzahl der ausgegebenen Bytes
static	int ppdouble_g(double dValue,char *pBuffer,unsigned uFlags,int iPrecision)
{
double	dVal;
double	dPre;
double	dMul;
int		iExp;
int		iNum;
int		iPos;
int		iNul;




	if(!(uFlags&PP_PRECISION))								// Default-Wert fr Kommastellen
		{
		iPrecision = 6;
		uFlags    |= PP_PRECISION;
		iNul	   = 1;
		}
	else{
		iNul	   = 1;
		}


	dVal = (dValue<0.0)? -dValue:dValue;
	iExp = 1+(int)log10(dVal);


	if(iExp<-2 || iExp>iPrecision)
		{
		if(iPrecision>0)iPrecision--;

		iNum = ppdouble_e(dValue,pBuffer,uFlags,iPrecision);

		if(!iNul || iNum<=6 || (uFlags&PP_PREFIX) || (pBuffer[iNum-5]!='e' && pBuffer[iNum-5]!='E'))
			{
			return iNum;
			}

		iNum -= 5;

		for(iPos=iNum;iPos>1;iPos--)						// Nullen am Ende suchen
			{
			if(pBuffer[iPos-1]!='0')break;
			}

		if(iPos>1 && pBuffer[iPos-1]=='.')
			{
			iPos--;
			}

		if(iPos==iNum)return iNum+5;


		memmove(pBuffer+iPos,pBuffer+iNum,5);

		return iPos+5;
		}


	if(iExp<0)												// Rundung prfen
		{
		iNum = -iExp;

		if(iNum<=sizeof(aDecPow)/sizeof(aDecPow[0]))
				dMul = aDecPow[iNum];
		else	dMul = pow(10.0,(double)iNum);

		dPre = dVal*dMul;
		}
	else if(iExp>0)
		{
		if(iExp<=sizeof(aDecPow)/sizeof(aDecPow[0]))
				dMul = aDecPow[iExp];
		else	dMul = pow(10.0,(double)iExp);

		dPre = dVal/dMul;
		}
	else{
		dPre = dVal;
		}

	if(iPrecision<=sizeof(aDecPow)/sizeof(aDecPow[0]))		// Die letzte Stelle runden
			dPre += aAddPow[iPrecision];
	else	dPre += pow(10.0,(double)-iPrecision)*aDecPow[0];


	if(dPre>=1.0)iExp++;



	iPrecision -= iExp;
	if(dVal<1.0)iPrecision++;

	iNum = ppdouble_f(dValue,pBuffer,uFlags,iPrecision);


	if(!iNul || iNum<=1 || iPrecision<=0 || (uFlags&PP_PREFIX))
		{
		return iNum;
		}

	for(iPos=iNum;iPos>1;iPos--)							// Nullen am Ende suchen
		{
		if(pBuffer[iPos-1]!='0')break;
		}

	if(iPos>1 && pBuffer[iPos-1]=='.')
		{
		iPos--;
		}




return iPos;
}

#if PP_HAS_UNICODE

static	int ppdouble_g(double dValue,wchar_t *pBuffer,unsigned uFlags,int iPrecision)
{
int		iLen;


	iLen = ppdouble_g(dValue,(char*)pBuffer,uFlags,iPrecision);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif

//*****************************************************************************
//*
//*		ppdouble_a
//*
//*****************************************************************************
//	Eine Fliekommazahl in einen Text im HEX-Format umwandeln.
//	uValue		: Ist die Zahl
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_LEFTALIGN	0x0100		Ausgabe links ausrichten
//					PP_FILLZERO		0x0200		Ausgabe mit 0 auffllen
//					PP_PREFIX		0x0400		Ein Prfix (0 oder 0x) ausgeben
//					PP_ADDSIGN		0x0800		Ein Vorzeichen anhngen
//					PP_ADDSPACE		0x1000		Ein Vorzeichen anhngen bei - und Space bei +
//					PP_PRECISION	0x2000		Die Prezission wurde angegeben
//					PP_LOWCHAR		0x4000		Bei Exponenten 'e' verwenden
//	iPrecision	: Anzahl der Kommastellen
//	pDigits		: Zeiger auf die Buchstaben fr die HEX-Ausgabe
//	Ergibt die Anzahl der ausgegebenen Bytes
static	int ppdouble_a(double dValue,char *pBuffer,unsigned uFlags,int iPrecision,const char *pDigits)
{
int			iExp;
int			iLen;
int		 	iVal;
int		 	iNum;
union
	{
	double			dFloat;
	uppint64		uQard;
	unsigned char	aByte [8];
	unsigned short 	aWord [4];
	unsigned short 	aDword[2];
	}sVal;



	if(!(uFlags&PP_PRECISION))								// Default-Wert fr Kommastellen
		{
		iPrecision = 6;
		}


	sVal.dFloat	= dValue;

	if(sVal.aByte[7]&0x80)									// Wert kleiner als 0
		{
		sVal.aByte[7]&=~0x80;
		pBuffer[0]    = '-';
		iLen          = 1;
		}
	else if(uFlags&PP_ADDSIGN)								// Immer ein Vorzeichen anhngen
		{
		pBuffer[0]    = uFlags>>24;
		iLen          = 1;
		}
	else{
		iLen          = 0;
		}


	if((sVal.aWord[3]&0x7FFF)>=0x7FF0)						// INF oder NAN
		{
		if(sVal.aDword[0]==0 && sVal.aWord[2]==0 && (sVal.aByte[6]&0x0F)==0)
			{
			strcpy(pBuffer+iLen,"0x1.#INF");
			iNum = 4;
			}
		else{
			strcpy(pBuffer+iLen,"0x1.#QNAN");
			iNum = 5;
			}

		pBuffer[iLen+1] = pDigits[16];
		iLen += 4;


		if(iPrecision<iNum)									// Keine Kommastellen
			{
			if(iPrecision>0)
				{
				memset(pBuffer+iLen,'$',iPrecision);
				iLen += iPrecision;
				}
			else{
				iLen -= 1;
				}
			}
		else{
			iLen += iNum;
			}

		if(iPrecision>iNum)
			{
			memset(pBuffer+iLen,'0',iPrecision-iNum);
			iLen += iPrecision-iNum;
			}

		strcpy(pBuffer+iLen,"p+0");
		pBuffer[iLen] = pDigits[17];
		return iLen+3;
		}

	iExp	= (sVal.aWord[3]>>4)&0x07FF;

	if(iExp)												// Normalisierte Gleikomazahl
		{
		strcpy(pBuffer+iLen,"0x1.");
		pBuffer[iLen+1] = pDigits[16];
		iLen += 4;
		}
	else{													// Spezialfall
		strcpy(pBuffer+iLen,"0x0.");
		pBuffer[iLen+1] = pDigits[16];
		iLen += 4;
															// Ist der Wert 0
		if(sVal.aDword[0]==0 && sVal.aWord[2]==0 && !(sVal.aByte[6]&0x0F))
				iExp  = 0x03FF;
		else	iExp += 1;
		}

	 iExp  -=  0x03FF;



	if(iPrecision>=900)										// Puffergre prfen
		{
		iPrecision = 900;
		}
	else if(iPrecision<=0)
		{
		iLen--;
		}
	else{
		for(;iPrecision>0;iPrecision--)						// Nachkommastellen
			{
			iVal		  = sVal.aByte[6]&0x0F;
			pBuffer[iLen] = pDigits[iVal];
			sVal.uQard  <<= 4;
			iLen++;
			}
		}

	pBuffer[iLen] = pDigits[17];
	iLen++;

	if(iExp==0)
		{
		pBuffer[iLen] = '+';
		iLen += 1;
		pBuffer[iLen] = '0';
		iLen += 1;
		}
	else if(iExp<0)
		{
		pBuffer[iLen] = '-';
		iLen += 1;
		iLen += ppdec((unsigned)-iExp,pBuffer+iLen);
		}
	else{
		pBuffer[iLen] = '+';
		iLen += 1;
		iLen += ppdec(iExp,pBuffer+iLen);
		}


return iLen;
}

#if PP_HAS_UNICODE

static	int ppdouble_a(double dValue,wchar_t *pBuffer,unsigned uFlags,int iPrecision,const char *pDigits)
{
int		iLen;


	iLen = ppdouble_a(dValue,(char*)pBuffer,uFlags,iPrecision,pDigits);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif
#endif

//*****************************************************************************
//*
//*		ppdump
//*
//*****************************************************************************
//	Eine Fliekommazahl in einen Text im HEX-Format umwandeln.
//	uValue		: Ist die Zahl
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_LONG64		0x0001		Alle 8 Byte ein Extra-Space
//					PP_LONG			0x0002		Alle 4 Byte ein Extra-Space
//					PP_SHORT		0x0003		Alle 2 Byte ein Extra-Space
//					PP_HASWIDTH		0x0040		Wurde eine Breite angegeben
//					PP_LEFTALIGN	0x0100		Ausgabe links ausrichten
//					PP_FILLZERO_EX	0x0280		Ausgabe am Ende mit 00 auffllen
//					PP_PREFIX		0x0400		Am Ende "..." an wenn zuwenig Platz
//					PP_ADDSIGN		0x0800		':' zwischen den Bytes ausgeben
//					PP_ADDSPACE		0x1000		' ' zwischen den Bytes ausgeben
//					PP_ADDSPACE|...	0x1800		'-' zwischen den Bytes ausgeben
//					PP_PRECISION	0x2000		Die Prezission wurde angegeben
//	iPrecision	: Anzahl der Bytes zum ausgeben
//	iWidth		: Maximale Breite fr die Ausgabe
//	pDigits		: Zeiger auf die Buchstaben fr die HEX-Ausgabe
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_DUMP

static int ppdump(unsigned char *pPointer,char *pBuffer,unsigned uFlags,int iPrecision,int iWidth,const char *pDigits)
{
unsigned 	uValue;
char		cSpace;
int			iCount;
int			iDiff;
int			iLen;
int			iPos;
int			iMax;


	if(!pPointer)											// Zeiger prfen
		{
		memcpy(pBuffer,"(null)\0",8);
		return 6;
		}

	if(iPrecision>256)
		{
		iPrecision = 256;
		}

	if(iPrecision<=0)										// Keine Dump-Lnge vorhanden
		{
		if(iPrecision<0 || (uFlags&PP_PRECISION))
			{
			return 0;
			}

		iPrecision = 16;
		}


	iMax	= iPrecision*2;
	iLen	= 0;
	iPos	= 0;

	if(uFlags&0x1800)										// Fllzeichen erstellen
		{
		cSpace =  " :-"[(uFlags>>11)&3];
		iMax  +=  iPrecision-1;
		}
	else{
		cSpace = 0;
		}

	if(uFlags&0x0003)										// Alle N Byte eine Leerstelle
		{
		iCount =  "\x04\x08\x04\x02"[uFlags&0x0003];
		iMax  +=  (iPrecision+1)/4;
		}
	else{
		iCount = 0;
		}


	if(uFlags&PP_PREFIX)									// "..." Am Ende anhngen
		{
		if(iMax>iWidth && (uFlags&PP_PREFIX))
			{
			if(iWidth<=0)return 0;

			iMax  = iWidth-3;
			iDiff = (cSpace)? 3:2;

			if(iCount)
				{
				iMax++;
				iPrecision  = (iMax/(iDiff*iCount+1))*iCount;
				iPrecision += (iMax%(iDiff*iCount+1))/iDiff;
				}
			else{
				iPrecision  =  iMax/iDiff;
				}

			if(iPrecision<=0)goto Done;
			}												// HEX-Dump zu kurz
		else if(iMax<iWidth && (uFlags&PP_HASWIDTH)&& !(uFlags&PP_LEFTALIGN))
			{
			iWidth  =  iMax;
			uFlags &= ~PP_PREFIX;
			}
		else{
			uFlags &= ~PP_PREFIX;
			}
		}


	for(;;)													// HEX-Dump ausgeben
		{
		uValue	= pPointer[iPos];

		pBuffer[iLen] = pDigits[uValue>>4];		iLen++;
		pBuffer[iLen] = pDigits[uValue&15];		iLen++;

		iPos++;
		if(iPos>=iPrecision)break;

		if(cSpace)
			{
			pBuffer[iLen] = cSpace;
			iLen++;
			}

		if(iCount && !(iPos%iCount))						// Alle N Byte ein extra Leerzeichen
			{
			pBuffer[iLen] = ' ';
			iLen++;
			}
		}


	if(iLen<iWidth && (uFlags&PP_FILLZERO_EX))				// Ende mit 00 auffllen
		{
		for(;;)
			{
			iMax = iLen;

			if(cSpace)
				{
				pBuffer[iLen] = cSpace;
				iLen++;
				}

			if(iCount && !(iPos%iCount))					// Alle N Byte ein extra Leerzeichen
				{
				pBuffer[iLen] = ' ';
				iLen++;
				}

			pBuffer[iLen] = '0';		iLen++;
			pBuffer[iLen] = '0';		iLen++;
			iPos++;

			if(iLen>=iWidth)break;
			}

		return iMax;
		}

	if(uFlags&PP_PREFIX)									// "..." am Ende anhngen
		{
Done:	memcpy(pBuffer+iLen,"...",4);

		iLen   += 3;
		iWidth -= iLen;

		if(iWidth>0)										// Mit ' ' bis zum Ende auffllen
			{
			if(iWidth>128 && iWidth+iLen>1024)iWidth=1024-iLen;
			memset(pBuffer+iLen,' ',iWidth);
			iLen += iWidth;
			}
		}


return iLen;
}


#if PP_HAS_UNICODE

static int ppdump(unsigned char *pPointer,wchar_t *pBuffer,unsigned uFlags,int iPrecision,int iWidth,const char *pDigits)
{
int		iLen;


	iLen = ppdump(pPointer,(char*)pBuffer,uFlags,iPrecision,iWidth,pDigits);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif
#endif

//*****************************************************************************
//*
//*		pptime
//*
//*****************************************************************************
//	Eine Fliekommazahl in einen Text im HEX-Format umwandeln.
//	uValue		: Ist die Zahl
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_NODPOINT		0x00010		Kein ':' in Zeitangabe
//					PP_ADDDATE		0x00020		Datum auch ausgeben
//					PP_PREFIX		0x00400		31.11.2000 statt 2000-11-31
//					PP_UNTERLINE	0x01000		'_' statt ' ' zwischen Datum und Zeit
//					PP_PRECISION	0x02000		Die Prezission wurde angegeben
//					PP_ADDSECS		0x10000		Keine Sekunden ausgeben
//	iPrecision	: Anzahl der Bytes zum ausgeben
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_TIME

static int pptime(ppint64 iTime,char *pBuffer,unsigned uFlags,int iPrecision)
{
struct tm  *pTime;
char		cSpace;
int			iVal;
int			iLen;


	if(iPrecision>256)
		{
		iPrecision	= 256;
		}

	if(iPrecision<0 || !(uFlags&PP_PRECISION))				// Space zwischen Datum und Zeit
		{
		iPrecision	= 1;
		}


		pTime = localtime((time_t*)&iTime);
	if(!pTime)
		{
		memcpy(pBuffer,"(null)\0",8);
		return 6;
		}

	iLen	= 0;

	if(uFlags&PP_ADDDATE)									// Ein Datum ausgeben
		{
		if(uFlags&PP_PREFIX)
			{
			iLen		 += ppdec(pTime->tm_mday,pBuffer+iLen);
			pBuffer[iLen] = '.';
			iLen         += 1;
			iLen		 += ppdec(pTime->tm_mon+1,pBuffer+iLen);
			pBuffer[iLen] = '.';
			iLen         += 1;
			iLen		 += ppdec(pTime->tm_year+1900,pBuffer+iLen);
			}
		else{
			iLen		 += ppdec(pTime->tm_year+1900,pBuffer+iLen);
			pBuffer[iLen] = '-';
			iLen         += 1;
			iVal		  = pTime->tm_mon+1;
			pBuffer[iLen] = '0'+iVal/10;					// Monat ausgeben
			iLen         += 1;
			pBuffer[iLen] = '0'+iVal%10;
			iLen         += 1;
			pBuffer[iLen] = '-';
			iLen         += 1;
			pBuffer[iLen] = '0'+pTime->tm_mday/10;			// Tag ausgeben
			iLen         += 1;
			pBuffer[iLen] = '0'+pTime->tm_mday%10;
			iLen         += 1;
			}

		cSpace = (uFlags&PP_UNTERLINE)? '_':' ';

		for(iVal=iPrecision;iVal>0;iVal--)					// Leerzeichen nach Datum
			{
			pBuffer[iLen] = cSpace;
			iLen         += 1;
			}
		}

	if(iPrecision>0 || !(uFlags&PP_ADDDATE))				// Auch eine Zeit ausgeben
		{
		pBuffer[iLen] = '0'+pTime->tm_hour/10;				// Stunden ausgeben
		iLen         += 1;
		pBuffer[iLen] = '0'+pTime->tm_hour%10;
		iLen         += 1;

		if(!(uFlags&PP_NODPOINT))
			{
			pBuffer[iLen] = ':';
			iLen         += 1;
			}

		pBuffer[iLen] = '0'+pTime->tm_min/10;				// Minuten ausgeben
		iLen         += 1;
		pBuffer[iLen] = '0'+pTime->tm_min%10;
		iLen         += 1;

		if(!(uFlags&PP_ADDSECS))							// Sekunden auch anhngen
			{
			if(!(uFlags&PP_NODPOINT))
				{
				pBuffer[iLen] = ':';
				iLen         += 1;
				}

			pBuffer[iLen] = '0'+pTime->tm_sec/10;			// Sekunden ausgeben
			iLen         += 1;
			pBuffer[iLen] = '0'+pTime->tm_sec%10;
			iLen         += 1;
			}
		}

return iLen;
}


#if PP_HAS_UNICODE

static int pptime(ppint64 iTime,wchar_t *pBuffer,unsigned uFlags,int iPrecision)
{
int		iLen;


	iLen = pptime(iTime,(char*)pBuffer,uFlags,iPrecision);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif
#endif

//*****************************************************************************
//*
//*		ppdivider
//*
//*****************************************************************************
//	Eine Zahl mit Tausendertrennzeichen fllen. ("1234" --> "1.234")
//	iLen		: Ist die aktuelle Gre der Ausgabe
//	pBuffer		: Zeiger auf den Textpuffer (min. 1024 Byte)
//	uFlags		: Formatangaben
//					PP_FILLZERO		0x0200		Ausgabe am Ende mit 00 auffllen
//					PP_PREFIX		0x0400		Benutze '.' als Trennzeichen
//					PP_PRECISION	0x2000		Eine Kommastelle einfgen
//	iPrecision	: Anzahl der Kommastellen von hinten
//	iWidth		: Maximale Breite fr die Ausgabe
//	pDigits		: Zeiger auf die Buchstaben fr die HEX-Ausgabe
//	Ergibt die Anzahl der ausgegebenen Bytes
#if PP_HAS_DIVIDER

static int ppdivider(int iLen,char *pBuffer,unsigned uFlags,int iPrecision,int iWidth)
{
unsigned char	ucSign;
int				iOut;
int				iPos;
int				iGet;
int				iAdd;
int				iNum;
int				iMin;
int				iAll;


	if(iLen==0)
		{
		pBuffer[0] = '0';
		iLen       = 1;
		}
	
	if(iPrecision<=0 && iLen>0 && pBuffer[iLen-1]=='.')		// Komma am Ende entfernen
		{
		iLen--;
		}

	#ifdef _DEBUG
	pBuffer[iLen] = 0;
	#endif

	iMin = -1;

	for(iPos=0;iPos<iLen;iPos++)							// Suche Start und Ende der Zahl
		{
		   ucSign = pBuffer[iPos];
		if(ucSign=='.')
			{
			break;
			}

		if(ucSign<'0' || ucSign>'9')
			{
			iMin = iPos;
			}
		}

	iMin++;
	iAdd = 0;
	iNum = iPos-iMin;

	if(iPrecision>0 && iPrecision<128)						// Komma einfgen
		{
		if(iNum>iPrecision)
			{
			iPos       -= iPrecision;						// 12.456
			iNum       -= iPrecision;
			iAdd		= 1;
			iPrecision	= 1;
			}
		else{												// __._56
			iPos       -= iNum;
			iPrecision -= iNum-1;
			iAdd		= iPrecision+1;
			iNum		= 0;
			}
		}

	iAdd += (iNum-1)/3;

	if(iWidth>1024)
		{
		iWidth = 1024;
		}
															// Links mit '0' oder ' ' fllen
	if(iLen+iAdd<iWidth && ((uFlags^PP_LEFTALIGN)&(PP_FILLZERO|PP_LEFTALIGN)))
		{
		iAdd = iWidth-iLen;
		}

	if(iAdd<=0)return iLen;									// Keine nderungen

	iAll = iLen+iAdd;
	iOut = iAll;

	#ifdef _DEBUG
	pBuffer[iOut] = 0;
	#endif

	for(iGet=iLen;iGet>iPos;)
		{
		iOut--;
		iGet--;
		pBuffer[iOut] = pBuffer[iGet];
		}


	iAdd	= 3;

	if(iPrecision)											// Kommastelle einfgen
		{
		while(iPrecision>1)
			{
			iOut--;
			iPrecision--;
			pBuffer[iOut] = '0';
			}

		iOut--;
		pBuffer[iOut] = '.';

		if(iNum==0)											// Eine '0' vorne anhngen
			{
			iOut--;
			iAdd = 2;
			pBuffer[iOut] = '0';
			}
		}

	ucSign	= (uFlags&PP_PREFIX)? '.':' ';

	while(iNum>0)											// Vorkommastelln mit Trennzeichen ausgeben
		{
		if(iAdd==0)
			{
			iAdd=3;
			iOut--;
			pBuffer[iOut] = ucSign;
			}

		iNum--;
		iAdd--;
		iOut--;
		iGet--;
		pBuffer[iOut] = pBuffer[iGet];
		}

	if(uFlags&PP_FILLZERO)									// Mit '0' fllen
		{
		while(iOut>iMin)
			{
			if(iAdd==0)
				{
				iAdd=3;
				iOut--;

				if(iOut<=iMin)
					{
					iOut++;
					break;
					}

				pBuffer[iOut] = ucSign;
				}

			iAdd--;
			iOut--;
			pBuffer[iOut] = '0';
			}
		}

	if(iOut>0 && iOut>iGet)									// Den Rest ausgeben
		{
		while(iGet>0)
			{
			iOut--;
			iGet--;
			pBuffer[iOut] = pBuffer[iGet];
			}

		while(iOut>0)										// Anfang mit ' ' fllen
			{
			iOut--;
			pBuffer[iOut] = ' ';
			}
		}


return iAll;
}

#if PP_HAS_UNICODE

static int ppdivider(int iLen,wchar_t *pBuffer,unsigned uFlags,int iPrecision,int iWidth)
{

	iLen = ppdivider(iLen,(char*)pBuffer,uFlags,iPrecision,iWidth);
	CharToUnicode(pBuffer,iLen);

return iLen;
}

#endif
#endif

//*****************************************************************************
//*
//*		pprintfa
//*
//*****************************************************************************
//	printf Funktion mit Ausgabe ber eine Funktion (ANSI)
//	pParam	: User-Parameter der an die Funktion bergeben wird
//	pProc	: Zeiger auf Funktion
//	pFormat	: Formattext fr die Ausgabe
//	Ergibt die Anzahl der ausgegebenen Zeichen (von pProc berechnet)
PP_PROC int _cdecl pprintfa(void *pParam,pprintf_proca pProc,const char *pFormat,...)
{
va_list		pArgs;
int			iRet;

	va_start(pArgs,pFormat);
	iRet = pprintfva(pParam,pProc,pFormat,pArgs);
	va_end(pArgs);

return iRet;
}

PP_PROC int _cdecl pprintfva(void *pParam,pprintf_proca pProc,const char *pFormat,va_list pArgs)
{
#if PP_HAS_STRCHG
unsigned char	ucValue;
#endif
#if PP_HAS_USWITCH
wchar_t		   *pTextUni;
#endif
#if PP_HAS_GLOBAL
ParamData		sParams={0,0};
#endif
#if PP_HAS_HEXDEC || PP_HAS_FLOAT
const char	   *pHexChars;
#endif
int			   *pIntPtr;
const char	   *pTextPtr;
char			cBuffer[2248];
unsigned char 	ucSign;
unsigned char 	ucType;
unsigned		uFlags;
wchar_t			usValue;
unsigned 		uValue;
ppint64			iVal64;
int				iOut;
int				iPos;
int				iLen;
int				iNum;
int				iStart;
int				iValue;
int				iWidth;
int				iPrefix;
int				iPrecision;


	iOut    = 0;
	iPos    = 0;
	iStart  = 0;

	while(*pFormat)
		{
		if(iPos>=sizeof(cBuffer)/2)						// Puffer speichen
			{
			iOut+=pProc(pParam,cBuffer,iPos);
			iPos=0;
			}

		for(iLen=0;iLen<sizeof(cBuffer)/2;iLen++)
			{
			if(pFormat[iLen]== 0 )break;
			if(pFormat[iLen]=='%')break;
			}

		if(iLen)										// Text kopieren
			{
			if(iLen+iPos>sizeof(cBuffer) || iLen>128)
				{
				iOut+=pProc(pParam,cBuffer,iPos);
				iOut+=pProc(pParam,pFormat,iLen);
				iPos=0;
				}
			else{
				memcpy(cBuffer+iPos,pFormat,iLen);
				iPos += iLen;
				}

			pFormat	+= iLen;
			continue;
			}

		pFormat++;

		   ucSign = *pFormat;pFormat++;
		if(ucSign>=sizeof(aCharTypes))continue;

		if(ucSign=='%')									// '%' Zeichen ausgeben
			{
			cBuffer[iPos] = (char)ucSign;
			iPos++;
			continue;
			}

		uFlags			= 0;
		iWidth			= 0;
		iPrefix			= 0;
		iPrecision		= 0;

		#if PP_HAS_GLOBAL
		sParams.iRead	= 0;							// Nchsten Parameter benutzen
		#endif

		ucType = aCharTypes[ucSign];

		while(ucType&0xE0)								// Format auswerten -+0 #
			{
			switch(ucType>>5)
				{
			case 1:	  uFlags |= PP_ADDSIGN;		break;	// '+' Ein Vorzeichen anhngen
			case 2:	  uFlags |= PP_ADDSPACE;	break;	// ' ' Ein Vorzeichen anhngen bei - und Space bei +
			case 3:	  uFlags |= PP_PREFIX;		break;	// '#' Ein Prfix (0 oder 0x) ausgeben
			case 4:	  uFlags |= PP_LEFTALIGN;			// '-' Ausgabe links ausrichten
					  uFlags &=~PP_FILLZERO;	break;	// 			*
			case 5:
			#if PP_HAS_DUMP
					  uFlags |= PP_FILLZERO_BIT;		// Fill-Zero Merker fr HEX-Dump
			#endif
			#if PP_HAS_TIME
					  uFlags |= PP_NODPOINT;			// Kein ':' in Zeitangabe
			#endif
				   if(uFlags &  PP_LEFTALIGN)	break;	// '0' Ausgabe mit 0 auffllen
					  uFlags |= PP_FILLZERO_EX;	break;	//			*

			#if PP_HAS_IGNORE

			case 6:	  uFlags |= PP_IGNORE;		break;	// Parameter definieren oder ignoriern "...%~..."

			#endif

			#if PP_HAS_GLOBAL

			case 7:	  									// Parameter auf fixer Position "...%@?..."
					   ucSign = *pFormat;
					if(ucSign>='A' && ucSign<'A'+PP_PARAMS)
						{
						sParams.iRead = ucSign-'A'+1;
						pFormat++;
						}

					break;

			#endif

				}

			   ucSign = *pFormat;pFormat++;
			if(ucSign>=sizeof(aCharTypes))continue;

			ucType=aCharTypes[ucSign];
			}


		if(ucType&0x03)									// Breite auswerten
			{
			if(ucType&0x01)								// Breite vom Stack holen ('*')
				{
				va_get_arg(iWidth,int,pArgs,int);

				   ucSign = *pFormat;pFormat++;
				if(ucSign>=sizeof(aCharTypes))break;

				ucType=aCharTypes[ucSign];
				}
			else{
				while(ucType&0x02)						// Breite aus Zahl holen
					{
					iWidth *= 10;
					iWidth += ucSign-'0';

					   ucSign = *pFormat;pFormat++;
					if(ucSign>=sizeof(aCharTypes))break;

					ucType=aCharTypes[ucSign];
					}
				}

			#if PP_HAS_STRCHG || PP_HAS_DUMP
			uFlags |= PP_HASWIDTH;
			#endif
			}

		if(ucType&0x05)									// Przision auswerten
			{
			   ucSign = *pFormat;pFormat++;
			if(ucSign>=sizeof(aCharTypes))break;

			ucType=aCharTypes[ucSign];

			if(ucType&0x01)								// Przision vom Stack holen ('*')
				{
				va_get_arg(iPrecision,int,pArgs,int);

				   ucSign = *pFormat;pFormat++;
				if(ucSign>=sizeof(aCharTypes))break;

				ucType=aCharTypes[ucSign];
				}
			else{
				while(ucType&0x02)						// Przision aus Zahl holen
					{
					iPrecision *= 10;
					iPrecision += ucSign-'0';

					   ucSign = *pFormat;pFormat++;
					if(ucSign>=sizeof(aCharTypes))break;

					ucType=aCharTypes[ucSign];
					}
				}

			uFlags |=  PP_PRECISION;
			}

		if(ucType&0x08)									// Prfix auswerten
			{
			switch(ucSign)
				{
			case 'w':
			case 'j':
			case 'L':	uFlags |= PP_LONG;
						break;

			case 'z':	uFlags |= (sizeof(size_t)==8)? PP_LONG64:PP_LONG;
						break;

			case 't':	uFlags |= (sizeof(void*)==8)? PP_LONG64:PP_LONG;
						break;

			case 'q':	uFlags |= PP_LONG64;
						break;

			case 'h':	if(pFormat[0]=='h')
							{
							pFormat += 1;
							uFlags   |= PP_CHAR;
							}
						else{
							uFlags   |= PP_SHORT;
							}
						break;

			case 'l':	if(pFormat[0]=='l')
							{
							pFormat += 1;
							uFlags   |= PP_LONG64;
							}
						else{
							uFlags   |= (sizeof(long)==8)? PP_LONG64:PP_LONG;
							}
						break;

			case 'I':	if(pFormat[0]=='6' && pFormat[1]=='4')
							{
							pFormat += 2;
							uFlags   |= PP_LONG64;
							break;
							}
						if(pFormat[0]=='3' && pFormat[1]=='2')
							{
							pFormat += 2;
							uFlags   |= PP_LONG;
							break;
							}

						uFlags |= (sizeof(void*)==8)? PP_LONG64:PP_LONG;
						break;
				}

			   ucSign = *pFormat;pFormat++;
			if(ucSign>=sizeof(aCharTypes))break;

			ucType=aCharTypes[ucSign];
			}


		if(!(ucType&0x10))								// Falsches Typzeichen
			{
			pFormat--;
			continue;
			}


		switch(aCharModes[ucSign-0x40])					// Typ auswerten
			{

		#if PP_HAS_USWITCH

		case 0:											// 'C'
					if(!(uFlags&7))
						{
						uFlags |= PP_LONG;
						}
		#endif

		case 1:		iStart = iPos;						// 'c'

					#if PP_HAS_USWITCH

					if(!((uFlags-1)&6))					// LONG oder LONG64
						{
						va_get_arg(usValue,wchar_t,pArgs,unsigned);
						if(usValue>=256)break;
						}
					else

					#endif

						{
						va_get_arg(usValue,wchar_t,pArgs,unsigned);
						}

					if((uFlags&(PP_FILLZERO|PP_PRECISION))==(PP_FILLZERO|PP_PRECISION))
						{
						uFlags &= ~PP_PRECISION;
						}

					#if PP_HAS_STRCHG

					if(uFlags&PP_PREFIX)				// Steuerzeichenunterdrckung
						{
						if(uFlags&PP_USEPRECIS)			// '\x...'
							{
							if(usValue<' ')
								{
								uValue  = usValue;
								usValue = "0123456abtnvfrEF0123456789ABCDEF"[usValue];

								cBuffer[iPos] = '\\';
								iPos++;

								if(usValue<='F')
									{
									cBuffer[iPos] = 'x';
									iPos++;
									cBuffer[iPos] = '0';
									iPos++;
									cBuffer[iPos] = '0'+uValue/16;
									iPos++;
									}
								}
							else if(usValue=='\\')
								{
								cBuffer[iPos] = '\\';
								iPos++;
								}
							}
						else if(usValue<' ')			// Punkt ausgeben
							{
							usValue = '.';
							}
						}

					#endif

					cBuffer[iPos] = (char)usValue;
					iPos++;
					break;

		#if PP_HAS_USWITCH

		case 2:											// 'S'
					if(!(uFlags&7))
						{
						uFlags |= PP_LONG;
						}
		#endif

		case 3:		if(iPos>0)							// 's'
						{
						iOut+=pProc(pParam,cBuffer,iPos);
						iPos=0;
						}

					#if PP_HAS_USWITCH

					if(!((uFlags-1)&6))					// LONG oder LONG64
						{
						va_get_arg(pTextUni,wchar_t*,pArgs,wchar_t*);
						if(!pTextUni)pTextUni=L"(null)";

						if(uFlags&PP_PRECISION)
							{
							if(uFlags&PP_USEPRECIS)		// Prezession ist String-Lnge
								{
								iLen = iPrecision;
								}
							else for(iLen=0;iLen<iPrecision;iLen++)
								{
								if(!pTextUni[iLen])break;
								}
							}
						else{
							iLen=(int)wcslen(pTextUni);
							}

						if(iLen<iWidth && !(uFlags&PP_LEFTALIGN))
							{
							iWidth -= iLen;

							while(iWidth>0)
								{
								   iNum = sizeof(cBuffer)-iPos;
								if(iNum>iWidth)iNum=iWidth;

								memset(cBuffer+iPos,(uFlags&PP_FILLZERO)? '0':' ',iNum);
								iWidth -= iNum;
								iPos   += iNum;

								if(iPos<sizeof(cBuffer))continue;

								iOut+=pProc(pParam,cBuffer,iPos);
								iPos=0;
								}

							iWidth=0;
							}

						#if PP_HAS_STRCHG

						if(uFlags&PP_PREFIX)			// Steuerzeichen zu '.'
							{
							iValue = 0;

							if((uFlags&PP_HASWIDTH) && (uFlags&PP_LEFTALIGN) && iLen>iWidth)
								{
								if(iWidth>=3)
									{
									iValue = 3;
									iLen   = iWidth-3;
									}
								else{
									iLen   = iWidth;
									}
								}

							for(iNum=0;iNum<iLen;iNum++)
								{
								   usValue = pTextUni[iNum];
								if(usValue-' '<0)usValue='.';
								cBuffer[iPos]=(char)usValue;
								iPos++;
								if(iPos<sizeof(cBuffer))continue;
								iOut+=pProc(pParam,cBuffer,iPos);
								iPos=0;
								}


							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								cBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						#if PP_HAS_MAXSIGN
														// berlaufmarkierung "..."
						if((uFlags&(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))==(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))
							{
							if(iLen<=0 || pTextUni[iLen]==0)
								{
								iValue = 0;
								}
							else if(iLen>3)
								{
								iValue = 3;
								iLen  -= 3;
								}
							else{
								iValue = iLen;
								iLen   = 0;
								}

							for(iNum=0;iNum<iLen;iNum++)
								{
								   usValue = pTextUni[iNum];
								cBuffer[iPos]=(char)usValue;
								iPos++;
								if(iPos<sizeof(cBuffer))continue;
								iOut+=pProc(pParam,cBuffer,iPos);
								iPos=0;
								}

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								cBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						for(iNum=0;iNum<iLen;iNum++)
							{
							   usValue = pTextUni[iNum];
							if(usValue>=256)continue;
							cBuffer[iPos]=(char)usValue;
							iPos++;
							if(iPos<sizeof(cBuffer))continue;
							iOut+=pProc(pParam,cBuffer,iPos);
							iPos=0;
							}
						}
					else

					#endif

						{
						va_get_arg(pTextPtr,const char*,pArgs,char*);
						if(!pTextPtr)pTextPtr="(null)";

						if(uFlags&PP_PRECISION)
							{
							if(uFlags&PP_USEPRECIS)		// Prezession ist String-Lnge
								{
								iLen = iPrecision;
								}
							else for(iLen=0;iLen<iPrecision;iLen++)
								{
								if(!pTextPtr[iLen])break;
								}
							}
						else{
							iLen=(int)strlen(pTextPtr);
							}

						if(iLen<iWidth && !(uFlags&PP_LEFTALIGN))
							{
							iWidth -= iLen;

							while(iWidth>0)
								{
								   iNum = sizeof(cBuffer)-iPos;
								if(iNum>iWidth)iNum=iWidth;

								memset(cBuffer+iPos,(uFlags&PP_FILLZERO)? '0':' ',iNum);
								iWidth -= iNum;
								iPos   += iNum;

								iOut+=pProc(pParam,cBuffer,iPos);
								iPos=0;
								}

							iWidth=0;
							}

						#if PP_HAS_STRCHG

						if(uFlags&PP_PREFIX)			// Steuerzeichen zu '.'
							{
							iValue = 0;

							if((uFlags&PP_HASWIDTH) && (uFlags&PP_LEFTALIGN) && iLen>iWidth)
								{
								if(iWidth>=3)
									{
									iValue = 3;
									iLen   = iWidth-3;
									}
								else{
									iLen   = iWidth;
									}
								}

							for(iNum=0;iNum<iLen;iNum++)
								{
								   ucValue = pTextPtr[iNum];
								if(ucValue<' ')ucValue='.';
								cBuffer[iPos] =ucValue;
								iPos++;
								if(iPos<sizeof(cBuffer))continue;
								iOut+=pProc(pParam,cBuffer,iPos);
								iPos=0;
								}

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								cBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						#if PP_HAS_MAXSIGN
														// berlaufmarkierung "..."
						if((uFlags&(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))==(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))
							{
							if(iLen<=0 || pTextPtr[iLen]==0)
								{
								iValue = 0;
								}
							else if(iLen>3)
								{
								iValue = 3;
								iLen  -= 3;
								}
							else{
								iValue = iLen;
								iLen   = 0;
								}

							iOut+=pProc(pParam,pTextPtr,iLen);

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								cBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						iOut+=pProc(pParam,pTextPtr,iLen);
						}

					if(iLen<iWidth)						// Den Rest vom Feld mit ' ' auffllen
						{
						iWidth -= iLen;

						while(iWidth>0)
							{
							   iNum = sizeof(cBuffer)-iPos;
							if(iNum>iWidth)iNum=iWidth;

							memset(cBuffer+iPos,' ',iNum);
							iWidth -= iNum;
							iPos   += iNum;

							if(iPos<sizeof(cBuffer))continue;

							iOut+=pProc(pParam,cBuffer,iPos);
							iPos=0;
							}
						}

					continue;

		case 4:											// 'i'
		case 5:											// 'd'

		#if PP_HAS_DIVIDER
		case 19:										// 'D'
		#endif
					iStart = iPos;

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(iValue,char,pArgs,int);
									if(iValue<0)
										{
										iValue = -iValue;
										cBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										cBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec(iValue,cBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(iValue,short,pArgs,int);
									if(iValue<0)
										{
										iValue = -iValue;
										cBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										cBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec(iValue,cBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64<0)
										{
										iVal64 = -iVal64;
										cBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										cBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec64(iVal64,cBuffer+iPos);
									break;

					default:		va_get_arg(iValue,int,pArgs,int);
									if(iValue<0)
										{
										iValue = -iValue;
										cBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										cBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec(iValue,cBuffer+iPos);
									break;
						}

					#if PP_HAS_DIVIDER

					if(ucSign=='D')						// Tausendertrennzeichen
						{
						iPos = ppdivider(iPos+iLen-iStart,cBuffer+iStart,uFlags,iPrecision,iWidth)+iStart;
						break;
						}

					#endif

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(cBuffer))iPrecision=sizeof(cBuffer)-iPos;
						iPrecision-=iLen;

						memmove(cBuffer+iPos+iPrecision,cBuffer+iPos,iLen);
						memset (cBuffer+iPos,'0',iPrecision);

						iLen  +=  iPrecision;
						}

					iPos+=iLen;
					break;

		case 6:											// 'u'

		#if PP_HAS_DIVIDER
		case 20:										// 'U'
		#endif
					iStart = iPos;

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									iLen   = ppdec(uValue,cBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									iLen   = ppdec(uValue,cBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									iLen   = ppdec64(iVal64,cBuffer+iPos);
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									iLen   = ppdec(uValue,cBuffer+iPos);
									break;
						}

					#if PP_HAS_DIVIDER

					if(ucSign=='U')						// Tausendertrennzeichen
						{
						iPos = ppdivider(iPos+iLen-iStart,cBuffer+iStart,uFlags,iPrecision,iWidth)+iStart;
						break;
						}

					#endif

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(cBuffer))iPrecision=sizeof(cBuffer)-iPos;
						iPrecision-=iLen;

						memmove(cBuffer+iPos+iPrecision,cBuffer+iPos,iLen);
						memset (cBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#if PP_HAS_OCTAL

		case 7:		iStart = iPos;						// 'o'

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0';
										iPos++;
										}
									iLen = ppoct(uValue,cBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0';
										iPos++;
										}
									iLen = ppoct(uValue,cBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64 && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0';
										iPos++;
										}
									iLen   = ppoct64(iVal64,cBuffer+iPos);
									uValue = (iVal64)? 1:0;
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0';
										iPos++;
										}
									iLen = ppoct(uValue,cBuffer+iPos);
									break;
						}

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(cBuffer))iPrecision=sizeof(cBuffer)-iPos;
						iPrecision-=iLen;

						if(uValue && (uFlags&PP_PREFIX))
							{
							iPrecision--;
							}

						memmove(cBuffer+iPos+iPrecision,cBuffer+iPos,iLen);
						memset (cBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#else

		case 7:		switch(uFlags&0x03)					// 'o'
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char ,pArgs,unsigned);break;
					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);break;
					case PP_LONG64: va_get_arg(iVal64,ppint64       ,pArgs,ppint64 );break;
					default:		va_get_arg(uValue,unsigned      ,pArgs,unsigned);break;
						}

					continue;
		#endif

		#if PP_HAS_BINARY

		case 8:		iStart = iPos;						// 'b' 'B'

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin(uValue,cBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin(uValue,cBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64 && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin64(iVal64,cBuffer+iPos);
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}

									iLen   = ppbin(uValue,cBuffer+iPos);
									break;
						}

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(cBuffer))iPrecision=sizeof(cBuffer)-iPos;
						iPrecision-=iLen;

						memmove(cBuffer+iPos+iPrecision,cBuffer+iPos,iLen);
						memset (cBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;
		#endif

		#if	PP_HAS_HEXDEC

		case 9:											// 'p'
					if(sizeof(void*)==8 && !(uFlags&0x07))uFlags|=PP_LONG64;

					if(uFlags&PP_PREFIX)
						{
						if(iWidth<10)iWidth=10;
						}
					else{
						if(iWidth<8)iWidth=8;
						}

					if(uFlags&PP_PREFIX)uFlags |= PP_FILLZERO;

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision = 8;
						}

					ucSign = 'X';

		case 10:										// 'x' 'X'
					iStart    = iPos;
					pHexChars = (ucSign=='x')? "0123456789abcdefxp":"0123456789ABCDEFXP";

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)ucSign^=0x20;
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen = pphex(uValue,cBuffer+iPos,pHexChars);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)ucSign^=0x20;
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen = pphex(uValue,cBuffer+iPos,pHexChars);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64 && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)ucSign^=0x20;
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = pphex64(iVal64,cBuffer+iPos,pHexChars);
									uValue = (iVal64)? 1:0;
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)ucSign^=0x20;
										cBuffer[iPos]='0'   ;iPos++;
										cBuffer[iPos]=ucSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen = pphex(uValue,cBuffer+iPos,pHexChars);
									break;
						}

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(cBuffer))iPrecision=sizeof(cBuffer)-iPos;
						iPrecision-=iLen;

						memmove(cBuffer+iPos+iPrecision,cBuffer+iPos,iLen);
						memset (cBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#else

		case 9:											// 'p'
					if(sizeof(void*)==8 && !(uFlags&0x07))uFlags|=PP_LONG64;

		case 10:	switch(uFlags&0x03)					// 'x' 'X'
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char ,pArgs,unsigned);break;
					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);break;
					case PP_LONG64: va_get_arg(iVal64,ppint64       ,pArgs,ppint64 );break;
					default:		va_get_arg(uValue,unsigned      ,pArgs,unsigned);break;
						}

					continue;

		#endif

		case 11:										// 'k'
					va_get_arg(pIntPtr,int*,pArgs,int*);
					pIntPtr[0] = iOut+iPos;
					continue;

		#if PP_HAS_FLOAT

		case 12:	uFlags |= PP_LOWCHAR;				// 'g'
		case 13:										// 'G'
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_g(dValue,cBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~PP_PRECISION;
					}
					break;

		case 14:	uFlags |= PP_LOWCHAR;				// 'e'
		case 15:										// 'E'
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_e(dValue,cBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~PP_PRECISION;
					}
					break;

		case 16:										// 'f'

		#if PP_HAS_DIVIDER
		case 21:										// 'F'
		#endif
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_f(dValue,cBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~PP_PRECISION;

						#if PP_HAS_DIVIDER

						if(ucSign=='F')					// Tausendertrennzeichen
							{
							iPos = ppdivider(iPos-iStart,cBuffer+iStart,uFlags,0,iWidth)+iStart;
							}

						#endif
					}
					break;

		case 17:										// 'a' 'A'
					{
						double dValue;

						pHexChars = (ucSign=='a')? "0123456789abcdefxp":"0123456789ABCDEFXP";

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_a(dValue,cBuffer+iPos,uFlags,iPrecision,pHexChars);
						uFlags &= ~PP_PRECISION;
					}
					break;

		#else

		case 12:										// 'g'
		case 13:										// 'G'
		case 14:										// 'e'
		case 15:										// 'E'
		case 16:										// 'f'
		case 17:										// 'a' 'A'
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)
					}
					continue;

		#endif

		#if PP_HAS_DUMP

		case 18:										// 'm' 'M'
					{
						unsigned char *pPointer;

						pHexChars = (ucSign=='m')? "0123456789abcdefxp":"0123456789ABCDEFXP";
						va_get_arg(pPointer,unsigned char*,pArgs,unsigned char*)

						iStart = iPos;
						iPos  += ppdump(pPointer,cBuffer+iPos,uFlags,iPrecision,iWidth,pHexChars);
						uFlags &= ~(PP_PRECISION|PP_FILLZERO);
						if((uFlags&(PP_PREFIX|PP_HASWIDTH|PP_LEFTALIGN))==(PP_PREFIX|PP_HASWIDTH))iWidth=0;
					}
					break;
		#endif

		#if PP_HAS_TIME

		case 22:										// 'k' 'K'
					{
						if((uFlags&0x07)==PP_LONG64 || (sizeof(time_t)==sizeof(ppint64) && !(uFlags&0x07)))
							{	va_get_arg(iVal64,ppint64,pArgs,ppint64);}
						else{	va_get_arg(iVal64,ppint64,pArgs,int    );}

						if(ucSign=='K')uFlags|=PP_ADDDATE;

						iStart = iPos;
						iPos  += pptime(iVal64,cBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~(PP_PRECISION|PP_FILLZERO);
					}
					break;
		#endif

		default:	continue;
			}


		#if PP_HAS_IGNORE

		if(uFlags&PP_IGNORE)							// Ein Parameter wurde nur definiert "...%@?..."
			{
			iPos = iStart;
			continue;
			}

		#endif

		iLen = iPos-iStart;

		if(iLen<iWidth)									// Ausrichtung und Fllzeichen
			{
			iWidth -= iLen;

			if((uFlags&PP_FILLZERO) && !(uFlags&PP_PRECISION))
				{
				if(cBuffer[iStart]=='-' || cBuffer[iStart]=='+' || cBuffer[iStart]==' ')
					{
					iStart++;
					iLen  --;
					}

				if(iPos+iWidth>sizeof(cBuffer))
					{
					char	cTemp[256];

					iOut+=pProc(pParam,cBuffer,iStart);
					memset(cTemp,'0',sizeof(cTemp));

					while(iWidth>0)
						{
						iOut+=pProc(pParam,cBuffer+iStart,(iWidth<sizeof(cTemp))? iWidth:sizeof(cTemp));
						iWidth-=sizeof(cTemp);
						}

					iOut+=pProc(pParam,cBuffer+iStart,iLen);
					iPos =0;
					}
				else{
					memmove(cBuffer+iStart+iWidth,cBuffer+iStart,iLen);
					memset (cBuffer+iStart,'0',iWidth);
					iPos+=iWidth;
					}

				}
			else if(uFlags&PP_LEFTALIGN)
				{
				if(iPos+iWidth>sizeof(cBuffer))
					{
					char  cTemp[256];

					iOut+=pProc(pParam,cBuffer,iStart);
					memset(cTemp,' ',sizeof(cTemp));

					while(iWidth>0)
						{
						iOut+=pProc(pParam,cBuffer+iStart,(iWidth<sizeof(cTemp))? iWidth:sizeof(cTemp));
						iWidth-=sizeof(cTemp);
						}

					iPos=0;
					}
				else{
					memset(cBuffer+iPos,' ',iWidth);
					iPos+=iWidth;
					}
				}
			else{
				iStart -= iPrefix;
				iLen   += iPrefix;

				if(iPos+iWidth>sizeof(cBuffer))
					{
					char	cTemp[256];

					iOut+=pProc(pParam,cBuffer,iStart);
					memset(cTemp,' ',sizeof(cTemp));

					while(iWidth>0)
						{
						iOut+=pProc(pParam,cBuffer+iStart,(iWidth<sizeof(cTemp))? iWidth:sizeof(cTemp));
						iWidth-=sizeof(cTemp);
						}

					iOut+=pProc(pParam,cBuffer+iStart,iLen);
					iPos =0;
					}
				else{
					memmove(cBuffer+iStart+iWidth,cBuffer+iStart,iLen);
					memset (cBuffer+iStart,' ',iWidth);
					iPos+=iWidth;
					}
				}
			}
		}

	if(iPos>0)
		{
		iOut+=pProc(pParam,cBuffer,iPos);
		}



return iOut;
}

//*****************************************************************************
//*
//*		pprintfw
//*
//*****************************************************************************
//	printf Funktion mit Ausgabe ber eine Funktion (UNICODE)
//	pParam	: User-Parameter der an die Funktion bergeben wird
//	pProc	: Zeiger auf Funktion
//	pFormat	: Formattext fr die Ausgabe
//	Ergibt die Anzahl der ausgegebenen Zeichen (von pProc berechnet)
#if PP_HAS_UNICODE

PP_PROC int _cdecl pprintfw(void *pParam,pprintf_procw pProc,const wchar_t  *pFormat,...)
{
va_list		pArgs;
int			iRet;

	va_start(pArgs,pFormat);
	iRet = pprintfvw(pParam,pProc,pFormat,pArgs);
	va_end(pArgs);

return iRet;
}

PP_PROC int _cdecl pprintfvw(void *pParam,pprintf_procw pProc,const wchar_t *pFormat,va_list pArgs)
{
#if PP_HAS_STRCHG && PP_HAS_USWITCH
unsigned char	ucValue;
#endif
#if PP_HAS_USWITCH
const char     *pTextAnsi;
#endif
#if PP_HAS_GLOBAL
ParamData		sParams={0,0};
#endif
#if PP_HAS_HEXDEC || PP_HAS_FLOAT
const char	   *pHexChars;
#endif
int			   *pIntPtr;
wchar_t		   *pTextPtr;
wchar_t			aBuffer[2248];
wchar_t 		usSign;
unsigned char 	ucType;
unsigned		uFlags;
wchar_t			usValue;
unsigned 		uValue;
ppint64			iVal64;
int				iOut;
int				iPos;
int				iLen;
int				iNum;
int				iStart;
int				iValue;
int				iWidth;
int				iPrefix;
int				iPrecision;


	iOut    = 0;
	iPos    = 0;
	iStart  = 0;

	while(*pFormat)
		{
		if(iPos>=sizeof(aBuffer)/2/2)					// Puffer speichen
			{
			iOut+=pProc(pParam,aBuffer,iPos);
			iPos=0;
			}

		for(iLen=0;iLen<sizeof(aBuffer)/2/2;iLen++)
			{
			if(pFormat[iLen]== 0 )break;
			if(pFormat[iLen]=='%')break;
			}

		if(iLen)										// Text kopieren
			{
			if(iLen+iPos>sizeof(aBuffer)/2 || iLen>128)
				{
				iOut+=pProc(pParam,aBuffer,iPos);
				iOut+=pProc(pParam,pFormat,iLen);
				iPos=0;
				}
			else{
				memcpy(aBuffer+iPos,pFormat,iLen*2);
				iPos    += iLen;
				}

			pFormat	+= iLen;
			continue;
			}

		pFormat++;

		   usSign = *pFormat;pFormat++;
		if(usSign>=sizeof(aCharTypes))continue;

		if(usSign=='%')									// '%' Zeichen ausgeben
			{
			aBuffer[iPos] = usSign;
			iPos++;
			continue;
			}

		uFlags			= 0;
		iWidth			= 0;
		iPrefix			= 0;
		iPrecision		= 0;

		#if PP_HAS_GLOBAL
		sParams.iRead	= 0;							// Nchsten Parameter benutzen
		#endif

		ucType = aCharTypes[usSign];

		while(ucType&0xE0)								// Format auswerten -+0 #
			{
			switch(ucType>>5)
				{
			case 1:	  uFlags |= PP_ADDSIGN;		break;	// '+' Ein Vorzeichen anhngen
			case 2:	  uFlags |= PP_ADDSPACE;	break;	// ' ' Ein Vorzeichen anhngen bei - und Space bei +
			case 3:	  uFlags |= PP_PREFIX;		break;	// '#' Ein Prfix (0 oder 0x) ausgeben
			case 4:	  uFlags |= PP_LEFTALIGN;			// '-' Ausgabe links ausrichten
					  uFlags &=~PP_FILLZERO;	break;	// 			*
			case 5:
			#if PP_HAS_DUMP
					  uFlags |= PP_FILLZERO_BIT;		// Fill-Zero Merker fr HEX-Dump
			#endif
			#if PP_HAS_TIME
					  uFlags |= PP_NODPOINT;			// Kein ':' in Zeitangabe
			#endif
				   if(uFlags &  PP_LEFTALIGN)	break;	// '0' Ausgabe mit 0 auffllen
					  uFlags |= PP_FILLZERO_EX;	break;	//			*

			#if PP_HAS_IGNORE

			case 6:	  uFlags |= PP_IGNORE;		break;	// Parameter definieren oder ignoriern "...%~..."

			#endif

			#if PP_HAS_GLOBAL

			case 7:	  									// Parameter auf fixer Position "...%@?..."
					   usSign = *pFormat;
					if(usSign>='A' && usSign<'A'+PP_PARAMS)
						{
						sParams.iRead = usSign-'A'+1;
						pFormat++;
						}

					break;
			#endif
				}

			   usSign = *pFormat;pFormat++;
			if(usSign>=sizeof(aCharTypes))continue;

			ucType=aCharTypes[usSign];
			}


		if(ucType&0x03)									// Breite auswerten
			{
			if(ucType&0x01)								// Breite vom Stack holen ('*')
				{
				va_get_arg(iWidth,int,pArgs,int);

				   usSign = *pFormat;pFormat++;
				if(usSign>=sizeof(aCharTypes))break;

				ucType=aCharTypes[usSign];
				}
			else{
				while(ucType&0x02)						// Breite aus Zahl holen
					{
					iWidth *= 10;
					iWidth += usSign-'0';

					   usSign = *pFormat;pFormat++;
					if(usSign>=sizeof(aCharTypes))break;

					ucType=aCharTypes[usSign];
					}
				}

			#if PP_HAS_STRCHG || PP_HAS_DUMP
			uFlags |= PP_HASWIDTH;
			#endif
			}

		if(ucType&0x05)									// Przision auswerten
			{
			   usSign = *pFormat;pFormat++;
			if(usSign>=sizeof(aCharTypes))break;

			ucType=aCharTypes[usSign];

			if(ucType&0x01)								// Przision vom Stack holen ('*')
				{
				va_get_arg(iPrecision,int,pArgs,int);

				   usSign = *pFormat;pFormat++;
				if(usSign>=sizeof(aCharTypes))break;

				ucType=aCharTypes[usSign];
				}
			else{
				while(ucType&0x02)						// Przision aus Zahl holen
					{
					iPrecision *= 10;
					iPrecision += usSign-'0';

					   usSign = *pFormat;pFormat++;
					if(usSign>=sizeof(aCharTypes))break;

					ucType=aCharTypes[usSign];
					}
				}

			uFlags |=  PP_PRECISION;
			}

		if(ucType&0x08)									// Prfix auswerten
			{
			switch(usSign)
				{
			case 'w':
			case 'j':
			case 'L':	uFlags |= PP_LONG;
						break;

			case 'z':	uFlags |= (sizeof(size_t)==8)? PP_LONG64:PP_LONG;
						break;

			case 't':	uFlags |= (sizeof(void*)==8)? PP_LONG64:PP_LONG;
						break;

			case 'q':	uFlags |= PP_LONG64;
						break;

			case 'h':	if(pFormat[0]=='h')
							{
							pFormat += 1;
							uFlags  |= PP_CHAR;
							}
						else{
							uFlags  |= PP_SHORT;
							}
						break;

			case 'l':	if(pFormat[0]=='l')
							{
							pFormat += 1;
							uFlags  |= PP_LONG64;
							}
						else{
							uFlags  |= (sizeof(long)==8)? PP_LONG64:PP_LONG;
							}
						break;

			case 'I':	if(pFormat[0]=='6' && pFormat[1]=='4')
							{
							pFormat += 2;
							uFlags  |= PP_LONG64;
							break;
							}
						if(pFormat[0]=='3' && pFormat[1]=='2')
							{
							pFormat += 2;
							uFlags  |= PP_LONG;
							break;
							}

						uFlags |= (sizeof(void*)==8)? PP_LONG64:PP_LONG;
						break;
				}

			   usSign = *pFormat;pFormat++;
			if(usSign>=sizeof(aCharTypes))break;

			ucType=aCharTypes[usSign];
			}


		if(!(ucType&0x10))								// Falsches Typzeichen
			{
			pFormat--;
			continue;
			}


		switch(aCharModes[usSign-0x40])					// Typ auswerten
			{

		#if PP_HAS_USWITCH

		case 0:											// 'C'
					if(!(uFlags&7))
						{
						uFlags |= PP_SHORT;
						}
		#endif

		case 1:		iStart = iPos;						// 'c'

					#if PP_HAS_USWITCH

					if((uFlags&7)>=2)					// SHORT oder CHAR
						{
						va_get_arg(usValue,unsigned char,pArgs,unsigned);
						}
					else

					#endif

						{
						va_get_arg(usValue,wchar_t,pArgs,unsigned);
						}

					if((uFlags&(PP_FILLZERO|PP_PRECISION))==(PP_FILLZERO|PP_PRECISION))
						{
						uFlags &= ~PP_PRECISION;
						}

					#if PP_HAS_STRCHG

					if(uFlags&PP_PREFIX)				// Steuerzeichenunterdrckung
						{
						if(uFlags&PP_USEPRECIS)			// '\x...'
							{
							if(usValue<' ')
								{
								uValue  = usValue;
								usValue = "0123456abtnvfrEF0123456789ABCDEF"[usValue];

								aBuffer[iPos] = '\\';
								iPos++;

								if(usValue<='F')
									{
									aBuffer[iPos] = 'x';
									iPos++;
									aBuffer[iPos] = '0';
									iPos++;
									aBuffer[iPos] = '0'+uValue/16;
									iPos++;
									}
								}
							else if(usValue=='\\')
								{
								aBuffer[iPos] = '\\';
								iPos++;
								}
							}
						else if(usValue<' ')			// Punkt ausgeben
							{
							usValue = '.';
							}
						}

					#endif

					aBuffer[iPos] = usValue;
					iPos++;
					break;

		#if PP_HAS_USWITCH

		case 2:											// 'S'
					if(!(uFlags&7))
						{
						uFlags |= PP_SHORT;
						}
		#endif

		case 3:		if(iPos>0)							// 's':
						{
						iOut+=pProc(pParam,aBuffer,iPos);
						iPos=0;
						}

					#if PP_HAS_USWITCH

					if((uFlags&7)>2)					// SHORT oder CHAR
						{
						va_get_arg(pTextAnsi,const char*,pArgs,char*);
						if(!pTextAnsi)pTextAnsi="(null)";

						if(uFlags&PP_PRECISION)
							{
							if(uFlags&PP_USEPRECIS)		// Prezession ist String-Lnge
								{
								iLen = iPrecision;
								}
							else for(iLen=0;iLen<iPrecision;iLen++)
								{
								if(!pTextAnsi[iLen])break;
								}
							}
						else{
							iLen=(int)strlen(pTextAnsi);
							}

						if(iLen<iWidth && !(uFlags&PP_LEFTALIGN))
							{
							iWidth -= iLen;

							while(iWidth>0)
								{
								   iNum = sizeof(aBuffer)/2-iPos;
								if(iNum>iWidth)iNum=iWidth;

								memsetu(aBuffer+iPos,(uFlags&PP_FILLZERO)? '0':' ',iNum);
								iWidth -= iNum;
								iPos   += iNum;

								if(iPos<sizeof(aBuffer)/2)continue;

								iOut+=pProc(pParam,aBuffer,iPos);
								iPos=0;
								}

							iWidth=0;
							}

						#if PP_HAS_STRCHG

						if(uFlags&PP_PREFIX)			// Steuerzeichen zu '.'
							{
							iValue = 0;

							if((uFlags&PP_HASWIDTH) && (uFlags&PP_LEFTALIGN) && iLen>iWidth)
								{
								if(iWidth>=3)
									{
									iValue = 3;
									iLen   = iWidth-3;
									}
								else{
									iLen   = iWidth;
									}
								}

							for(iNum=0;iNum<iLen;iNum++)
								{
								   ucValue = pTextAnsi[iNum];
								if(ucValue<' ')ucValue='.';
								aBuffer[iPos] =ucValue;
								iPos++;
								if(iPos<sizeof(aBuffer)/2)continue;
								iOut+=pProc(pParam,aBuffer,iPos);
								iPos=0;
								}

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								aBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						#if PP_HAS_MAXSIGN
														// berlaufmarkierung "..."
						if((uFlags&(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))==(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))
							{
							if(iLen<=0 || pTextAnsi[iLen]==0)
								{
								iValue = 0;
								}
							else if(iLen>3)
								{
								iValue = 3;
								iLen  -= 3;
								}
							else{
								iValue = iLen;
								iLen   = 0;
								}

							for(iNum=0;iNum<iLen;iNum++)
								{
								   usValue = pTextAnsi[iNum];
								aBuffer[iPos]=(char)usValue;
								iPos++;
								if(iPos<sizeof(aBuffer))continue;
								iOut+=pProc(pParam,aBuffer,iPos);
								iPos=0;
								}

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								aBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						for(iNum=0;iNum<iLen;iNum++)
							{
							usValue = pTextAnsi[iNum];
							aBuffer[iPos]=usValue;
							iPos++;
							if(iPos<sizeof(aBuffer)/2)continue;
							iOut+=pProc(pParam,aBuffer,iPos);
							iPos=0;
							}
						}
					else

					#endif

						{
						va_get_arg(pTextPtr,wchar_t*,pArgs,wchar_t*);
						if(!pTextPtr)pTextPtr=L"(null)";

						if(uFlags&PP_PRECISION)
							{
							if(uFlags&PP_USEPRECIS)		// Prezession ist String-Lnge
								{
								iLen = iPrecision;
								}
							else for(iLen=0;iLen<iPrecision;iLen++)
								{
								if(!pTextPtr[iLen])break;
								}
							}
						else{
							iLen=(int)wcslen(pTextPtr);
							}

						if(iLen<iWidth && !(uFlags&PP_LEFTALIGN))
							{
							iWidth -= iLen;

							while(iWidth>0)
								{
								   iNum = sizeof(aBuffer)/2-iPos;
								if(iNum>iWidth)iNum=iWidth;

								memsetu(aBuffer+iPos,(uFlags&PP_FILLZERO)? '0':' ',iNum);
								iWidth -= iNum;
								iPos   += iNum;

								iOut+=pProc(pParam,aBuffer,iPos);
								iPos=0;
								}

							iWidth=0;
							}

						#if PP_HAS_STRCHG

						if(uFlags&PP_PREFIX)			// Steuerzeichen zu '.'
							{
							iValue = 0;

							if((uFlags&PP_HASWIDTH) && (uFlags&PP_LEFTALIGN) && iLen>iWidth)
								{
								if(iWidth>=3)
									{
									iValue = 3;
									iLen   = iWidth-3;
									}
								else{
									iLen   = iWidth;
									}
								}

							for(iNum=0;iNum<iLen;iNum++)
								{
								   usValue = pTextPtr[iNum];
								if(usValue<' ')usValue='.';
								aBuffer[iPos] =usValue;
								iPos++;
								if(iPos<sizeof(aBuffer)/2)continue;
								iOut+=pProc(pParam,aBuffer,iPos);
								iPos=0;
								}

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								aBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						#if PP_HAS_MAXSIGN
														// berlaufmarkierung "..."
						if((uFlags&(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))==(PP_FILLZERO_BIT|PP_LEFTALIGN|PP_PRECISION))
							{
							if(iLen<=0 || pTextPtr[iLen]==0)
								{
								iValue = 0;
								}
							else if(iLen>3)
								{
								iValue = 3;
								iLen  -= 3;
								}
							else{
								iValue = iLen;
								iLen   = 0;
								}

							iOut+=pProc(pParam,pTextPtr,iLen);

							for(;iValue>0;iValue--)		// "..." am Ende anhngen
								{
								aBuffer[iPos] = '.';
								iPos++;
								iLen++;
								}
							}
						else

						#endif

						iOut+=pProc(pParam,pTextPtr,iLen);
						}

					if(iLen<iWidth)						// Den Rest vom Feld mit ' ' auffllen
						{
						iWidth -= iLen;

						while(iWidth>0)
							{
							   iNum = sizeof(aBuffer)/2-iPos;
							if(iNum>iWidth)iNum=iWidth;

							memsetu(aBuffer+iPos,' ',iNum);
							iWidth -= iNum;
							iPos   += iNum;

							if(iPos<sizeof(aBuffer)/2)continue;

							iOut+=pProc(pParam,aBuffer,iPos);
							iPos=0;
							}
						}

					continue;

		case 4:											// 'i'
		case 5:											// 'd'

		#if PP_HAS_DIVIDER
		case 19:										// 'D'
		#endif
					iStart = iPos;

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(iValue,char,pArgs,int);
									if(iValue<0)
										{
										iValue = -iValue;
										aBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										aBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec(iValue,aBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(iValue,short,pArgs,int);
									if(iValue<0)
										{
										iValue = -iValue;
										aBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										aBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec(iValue,aBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64<0)
										{
										iVal64 = -iVal64;
										aBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										aBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec64(iVal64,aBuffer+iPos);
									break;

					default:		va_get_arg(iValue,int,pArgs,int);
									if(iValue<0)
										{
										iValue = -iValue;
										aBuffer[iPos]='-';
										iPos++;
										}
									else if(uFlags&PP_ADDSIGN)
										{
										aBuffer[iPos]=uFlags>>24;
										iPos++;
										}

									iLen = ppdec(iValue,aBuffer+iPos);
									break;
						}

					#if PP_HAS_DIVIDER

					if(usSign=='D')						// Tausendertrennzeichen
						{
						iPos = ppdivider(iPos+iLen-iStart,aBuffer+iStart,uFlags,iPrecision,iWidth)+iStart;
						break;
						}

					#endif

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(aBuffer)/2)iPrecision=sizeof(aBuffer)/2-iPos;
						iPrecision-=iLen;

						memmove(aBuffer+iPos+iPrecision,aBuffer+iPos,iLen*2);
						memsetu(aBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;


		case 6:											// 'u'

		#if PP_HAS_DIVIDER
		case 20:										// 'U'
		#endif
					iStart = iPos;

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									iLen   = ppdec(uValue,aBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									iLen   = ppdec(uValue,aBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									iLen   = ppdec64(iVal64,aBuffer+iPos);
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									iLen   = ppdec(uValue,aBuffer+iPos);
									break;
						}

					#if PP_HAS_DIVIDER

					if(usSign=='U')						// Tausendertrennzeichen
						{
						iPos = ppdivider(iPos+iLen-iStart,aBuffer+iStart,uFlags,iPrecision,iWidth)+iStart;
						break;
						}

					#endif

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(aBuffer)/2)iPrecision=sizeof(aBuffer)/2-iPos;
						iPrecision-=iLen;

						memmove(aBuffer+iPos+iPrecision,aBuffer+iPos,iLen*2);
						memsetu(aBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#if PP_HAS_OCTAL

		case 7:		iStart = iPos;						// 'o'

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0';
										iPos++;
										}
									iLen = ppoct(uValue,aBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0';
										iPos++;
										}
									iLen = ppoct(uValue,aBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64 && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0';
										iPos++;
										}
									iLen   = ppoct64(iVal64,aBuffer+iPos);
									uValue = (iVal64)? 1:0;
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0';
										iPos++;
										}
									iLen = ppoct(uValue,aBuffer+iPos);
									break;
						}

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(aBuffer)/2)iPrecision=sizeof(aBuffer)/2-iPos;
						iPrecision-=iLen;

						if(uValue && (uFlags&PP_PREFIX))
							{
							iPrecision--;
							}

						memmove(aBuffer+iPos+iPrecision,aBuffer+iPos,iLen*2);
						memsetu(aBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#else

		case 7:		switch(uFlags&0x03)					// 'o'
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char ,pArgs,unsigned);break;
					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);break;
					case PP_LONG64: va_get_arg(iVal64,ppint64       ,pArgs,ppint64 );break;
					default:		va_get_arg(uValue,unsigned      ,pArgs,unsigned);break;
						}

					continue;

		#endif

		#if PP_HAS_BINARY

		case 8:		iStart = iPos;						// 'b' 'B'

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin(uValue,aBuffer+iPos);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin(uValue,aBuffer+iPos);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64 && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin64(iVal64,aBuffer+iPos);
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = ppbin(uValue,aBuffer+iPos);
									break;
						}

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(aBuffer)/2)iPrecision=sizeof(aBuffer)/2-iPos;
						iPrecision-=iLen;

						memmove(aBuffer+iPos+iPrecision,aBuffer+iPos,iLen*2);
						memsetu(aBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#endif

		#if	PP_HAS_HEXDEC

		case 9:											// 'p'
					if(sizeof(void*)==8 && !(uFlags&0x07))uFlags|=PP_LONG64;

					if(uFlags&PP_PREFIX)
						{
						if(iWidth<10)iWidth=10;
						}
					else{
						if(iWidth<8)iWidth=8;
						}

					if(uFlags&PP_PREFIX)uFlags |= PP_FILLZERO;

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision = 8;
						}

					usSign = 'X';

		case 10:										// 'x' 'X'
					iStart    = iPos;
					pHexChars = (usSign=='x')? "0123456789abcdefxp":"0123456789ABCDEFXP";

					switch(uFlags&0x03)
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)usSign^=0x20;
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen = pphex(uValue,aBuffer+iPos,pHexChars);
									break;

					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)usSign^=0x20;
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen = pphex(uValue,aBuffer+iPos,pHexChars);
									break;

					case PP_LONG64: va_get_arg(iVal64,ppint64,pArgs,ppint64);
									if(iVal64 && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)usSign^=0x20;
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen   = pphex64(iVal64,aBuffer+iPos,pHexChars);
									uValue = (iVal64)? 1:0;
									break;

					default:		va_get_arg(uValue,unsigned,pArgs,unsigned);
									if(uValue && (uFlags&PP_PREFIX))
										{
										if(uFlags&PP_ADDSIGN)usSign^=0x20;
										aBuffer[iPos]='0'   ;iPos++;
										aBuffer[iPos]=usSign;iPos++;
										if(uFlags&PP_FILLZERO){iStart=iPos;iWidth-=2;iPrefix=2;}
										}
									iLen = pphex(uValue,aBuffer+iPos,pHexChars);
									break;
						}

					if(!(uFlags&PP_PRECISION))
						{
						iPrecision=1;
						}

					if(iLen<iPrecision)
						{
						if(iPos+iPrecision>sizeof(aBuffer)/2)iPrecision=sizeof(aBuffer)/2-iPos;
						iPrecision-=iLen;

						memmove(aBuffer+iPos+iPrecision,aBuffer+iPos,iLen*2);
						memsetu(aBuffer+iPos,'0',iPrecision);

						iLen += iPrecision;
						}

					iPos+=iLen;
					break;

		#else

		case 9:											// 'p'
					if(sizeof(void*)==8 && !(uFlags&0x07))uFlags|=PP_LONG64;

		case 10:	switch(uFlags&0x03)					// 'x' 'X'
						{
					case PP_CHAR:	va_get_arg(uValue,unsigned char ,pArgs,unsigned);break;
					case PP_SHORT:	va_get_arg(uValue,unsigned short,pArgs,unsigned);break;
					case PP_LONG64: va_get_arg(iVal64,ppint64       ,pArgs,ppint64 );break;
					default:		va_get_arg(uValue,unsigned      ,pArgs,unsigned);break;
						}

					continue;

		#endif

		case 11:										//  'k'
					va_get_arg(pIntPtr,int*,pArgs,int*);
					pIntPtr[0] = iOut+iPos;
					continue;

		#if PP_HAS_FLOAT

		case 12:	uFlags |= PP_LOWCHAR;				// 'g'
		case 13:										// 'G'
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_g(dValue,aBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~PP_PRECISION;
					}
					break;

		case 14:	uFlags |= PP_LOWCHAR;				// 'e'
		case 15:										// 'E'
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_e(dValue,aBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~PP_PRECISION;
					}
					break;

		case 16:										// 'f'

		#if PP_HAS_DIVIDER
		case 21:										// 'F'
		#endif
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_f(dValue,aBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~PP_PRECISION;

						#if PP_HAS_DIVIDER

						if(usSign=='F')					// Tausendertrennzeichen
							{
							iPos = ppdivider(iPos-iStart,aBuffer+iStart,uFlags,0,iWidth)+iStart;
							}

						#endif
					}
					break;

		case 17:										// 'a' 'A'
					{
						double dValue;

						pHexChars = (usSign=='a')? "0123456789abcdefxp":"0123456789ABCDEFXP";

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)

						iStart = iPos;
						iPos  += ppdouble_a(dValue,aBuffer+iPos,uFlags,iPrecision,pHexChars);
						uFlags &= ~PP_PRECISION;
					}
					break;

		#else

		case 12:										// 'g'
		case 13:										// 'G'
		case 14:										// 'e'
		case 15:										// 'E'
		case 16:										// 'f'
		case 17:										// 'a' 'A'
					{
						double dValue;

						#if PP_HAS_LONGDBL
						if(uFlags&(PP_LONG64|PP_LONG))va_get_arg(dValue,long double,pArgs,long double) else
						#endif
						va_get_arg(dValue,double,pArgs,double)
					}
					continue;

		#endif

		#if PP_HAS_DUMP

		case 18:										// 'm' 'M'
					{
						unsigned char *pPointer;

						pHexChars = (usSign=='m')? "0123456789abcdefxp":"0123456789ABCDEFXP";
						va_get_arg(pPointer,unsigned char*,pArgs,unsigned char*)

						iStart = iPos;
						iPos  += ppdump(pPointer,aBuffer+iPos,uFlags,iPrecision,iWidth,pHexChars);
						uFlags &= ~(PP_PRECISION|PP_FILLZERO);
						if((uFlags&(PP_PREFIX|PP_HASWIDTH|PP_LEFTALIGN))==(PP_PREFIX|PP_HASWIDTH))iWidth=0;
					}
					break;
		#endif

		#if PP_HAS_TIME

		case 22:										// 'k' 'K'
					{
						if((uFlags&0x07)==PP_LONG64 || (sizeof(time_t)==sizeof(ppint64) && !(uFlags&0x07)))
							{	va_get_arg(iVal64,ppint64,pArgs,ppint64);}
						else{	va_get_arg(iVal64,ppint64,pArgs,int    );}

						if(usSign=='K')uFlags|=PP_ADDDATE;

						iStart = iPos;
						iPos  += pptime(iVal64,aBuffer+iPos,uFlags,iPrecision);
						uFlags &= ~(PP_PRECISION|PP_FILLZERO);
					}
					break;
		#endif

		default:	continue;
			}


		#if PP_HAS_IGNORE

		if(uFlags&PP_IGNORE)							// Ein Parameter wurde nur definiert "...%@?..."
			{
			iPos = iStart;
			continue;
			}

		#endif

		iLen = iPos-iStart;

		if(iLen<iWidth)									// Ausrichtung und Fllzeichen
			{
			iWidth -= iLen;

			if((uFlags&PP_FILLZERO) && !(uFlags&PP_PRECISION))
				{
				if(aBuffer[iStart]=='-' || aBuffer[iStart]=='+' || aBuffer[iStart]==' ')
					{
					iStart++;
					iLen  --;
					}

				if(iPos+iWidth>sizeof(aBuffer)/2)
					{
					wchar_t	aTemp[256];

					iOut+=pProc(pParam,aBuffer,iStart);
					memsetu(aTemp,'0',sizeof(aTemp)/2);

					while(iWidth>0)
						{
						iOut+=pProc(pParam,aBuffer+iStart,(iWidth<sizeof(aTemp)/2)? iWidth:sizeof(aTemp)/2);
						iWidth-=sizeof(aTemp)/2;
						}

					iOut+=pProc(pParam,aBuffer+iStart,iLen);
					iPos =0;
					}
				else{
					memmove(aBuffer+iStart+iWidth,aBuffer+iStart,iLen*2);
					memsetu(aBuffer+iStart,'0',iWidth);
					iPos+=iWidth;
					}
				}
			else if(uFlags&PP_LEFTALIGN)
				{
				if(iPos+iWidth>sizeof(aBuffer)/2)
					{
					wchar_t  aTemp[256];

					iOut+=pProc(pParam,aBuffer,iStart);
					memsetu(aTemp,' ',sizeof(aTemp)/2);

					while(iWidth>0)
						{
						iOut+=pProc(pParam,aBuffer+iStart,(iWidth<sizeof(aTemp)/2)? iWidth:sizeof(aTemp)/2);
						iWidth-=sizeof(aTemp)/2;
						}

					iPos=0;
					}
				else{
					memsetu(aBuffer+iPos,' ',iWidth);
					iPos+=iWidth;
					}
				}
			else{
				iStart -= iPrefix;
				iLen   += iPrefix;

				if(iPos+iWidth>sizeof(aBuffer)/2)
					{
					wchar_t	aTemp[256];

					iOut+=pProc(pParam,aBuffer,iStart);
					memsetu(aTemp,' ',sizeof(aTemp)/2);

					while(iWidth>0)
						{
						iOut+=pProc(pParam,aBuffer+iStart,(iWidth<sizeof(aTemp)/2)? iWidth:sizeof(aTemp)/2);
						iWidth-=sizeof(aTemp)/2;
						}

					iOut+=pProc(pParam,aBuffer+iStart,iLen);
					iPos =0;
					}
				else{
					memmove(aBuffer+iStart+iWidth,aBuffer+iStart,iLen*2);
					memsetu(aBuffer+iStart,' ',iWidth);
					iPos+=iWidth;
					}
				}
			}
		}

	if(iPos>0)
		{
		iOut+=pProc(pParam,aBuffer,iPos);
		}



return iOut;
}

#endif

//*****************************************************************************
//*
//*		fprintf? Funktionen
//*
//*****************************************************************************

#if PP_HAS_FPRINTF

PP_PROC int _cdecl  fprintfaa(FILE *pFile,const char     *pFormat,...){va_list pArgs; int iRet;va_start(pArgs,pFormat);iRet=pprintfva(pFile,WriteAnsiPf,pFormat,pArgs);va_end(pArgs);return iRet;}
PP_PROC int _cdecl  fprintfua(FILE *pFile,const char     *pFormat,...){va_list pArgs; int iRet;va_start(pArgs,pFormat);iRet=pprintfva(pFile,WriteUtf8Pf,pFormat,pArgs);va_end(pArgs);return iRet;}
PP_PROC int _cdecl  fprintfwa(FILE *pFile,const char     *pFormat,...){va_list pArgs; int iRet;va_start(pArgs,pFormat);iRet=pprintfva(pFile,WriteWidePf,pFormat,pArgs);va_end(pArgs);return iRet;}

PP_PROC int  _cdecl fprintfava(FILE *pFile,const char    *pFormat     ,va_list pArgs){return pprintfva(pFile,WriteAnsiPf,pFormat,pArgs);}
PP_PROC int  _cdecl fprintfuva(FILE *pFile,const char    *pFormat     ,va_list pArgs){return pprintfva(pFile,WriteUtf8Pf,pFormat,pArgs);}
PP_PROC int  _cdecl fprintfwva(FILE *pFile,const char    *pFormat     ,va_list pArgs){return pprintfva(pFile,WriteAnsiPf,pFormat,pArgs);}

#if PP_HAS_UNICODE

PP_PROC int _cdecl  fprintfaw(FILE *pFile,const wchar_t  *pFormat,...){va_list pArgs; int iRet;va_start(pArgs,pFormat);iRet=pprintfvw(pFile,WriteAnsiPf,pFormat,pArgs);va_end(pArgs);return iRet;}
PP_PROC int _cdecl  fprintfuw(FILE *pFile,const wchar_t  *pFormat,...){va_list pArgs; int iRet;va_start(pArgs,pFormat);iRet=pprintfvw(pFile,WriteUtf8Pf,pFormat,pArgs);va_end(pArgs);return iRet;}
PP_PROC int _cdecl  fprintfww(FILE *pFile,const wchar_t  *pFormat,...){va_list pArgs; int iRet;va_start(pArgs,pFormat);iRet=pprintfvw(pFile,WriteWidePf,pFormat,pArgs);va_end(pArgs);return iRet;}

PP_PROC int  _cdecl fprintfavw(FILE *pFile,const wchar_t *pFormat     ,va_list pArgs){return pprintfvw(pFile,WriteAnsiPf,pFormat,pArgs);}
PP_PROC int  _cdecl fprintfuvw(FILE *pFile,const wchar_t *pFormat     ,va_list pArgs){return pprintfvw(pFile,WriteUtf8Pf,pFormat,pArgs);}
PP_PROC int  _cdecl fprintfwvw(FILE *pFile,const wchar_t *pFormat     ,va_list pArgs){return pprintfvw(pFile,WriteWidePf,pFormat,pArgs);}

#endif

#endif


//*****************************************************************************
//*
//*		xsnprintf Funktionen
//*
//*****************************************************************************
//	Erstellt einen formatierten Text mit Lngenbeschrnkung und Nullbyte.
//	pBuffer		: Zeiger auf den Textpuffer.
//	iSize		: Gre des Textpuffers in Zeichen.
//	pFormat		: Format fr die Texterstellung.
//	Ergibt die Lnge der erstellten Textes in Zeichen ohne Nullbyte.

#if PP_HAS_SXPRINTF

PP_PROC int _cdecl xsnprintfva(char *pBuffer,int iSize,const char *pFormat,va_list pArgs)
{
SxDataA		sData;
int			iRet;


	if(iSize<=0)return 0;

	sData.pBuffer	= pBuffer;
	sData.iSize		= iSize-1;
	sData.iOffset	= 0;
	iRet			= pprintfva(&sData,WriteSxPrintf,pFormat,pArgs);
	pBuffer[iRet]	= 0;


return iRet;
}

PP_PROC int _cdecl xsnprintfa(char *pBuffer,int iSize,const char *pFormat,...)
{
SxDataA		sData;
va_list		pArgs;
int			iRet;


	if(iSize<=0)return 0;

	sData.pBuffer	= pBuffer;
	sData.iSize		= iSize-1;
	sData.iOffset	= 0;

	va_start(pArgs,pFormat);
	iRet = pprintfva(&sData,WriteSxPrintf,pFormat,pArgs);
	va_end(pArgs);

	pBuffer[iRet]	= 0;


return iRet;
}

#if PP_HAS_UNICODE


PP_PROC int _cdecl xsnprintfvw(wchar_t *pBuffer,int iSize,const wchar_t *pFormat,va_list pArgs)
{
SxDataW		sData;
int			iRet;


	if(iSize<=0)return 0;

	sData.pBuffer	= pBuffer;
	sData.iSize		= iSize-1;
	sData.iOffset	= 0;
	iRet			= pprintfvw(&sData,WriteSxPrintf,pFormat,pArgs);
	pBuffer[iRet]	= 0;


return iRet;
}

PP_PROC int _cdecl xsnprintfw(wchar_t *pBuffer,int iSize,const wchar_t *pFormat,...)
{
SxDataW		sData;
va_list		pArgs;
int			iRet;


	if(iSize<=0)return 0;

	sData.pBuffer	= pBuffer;
	sData.iSize		= iSize-1;
	sData.iOffset	= 0;

	va_start(pArgs,pFormat);
	iRet = pprintfvw(&sData,WriteSxPrintf,pFormat,pArgs);
	va_end(pArgs);

	pBuffer[iRet]	= 0;


return iRet;
}

#endif

//*****************************************************************************
//*
//*		xsmprintf Funktionen
//*
//*****************************************************************************
//	Erstellt einen formatierten Text in einem dynamischen Speicher.
//	pData		: Zeiger auf den dynamischen Speicher.
//					pData->pText	= Zeiger auf den Text
//					pData->iSize	= Ist die Lnge des Texte
//					pData->iMax;	= Ist die Gre des Speichers
//				  Der Zeiger pText muss mit delete freigegeben werden.
//	pFormat		: Format fr die Texterstellung.
//	Ergibt die Lnge der erstellten Textes in Zeichen ohne Nullbyte.

#if PP_HAS_SMPRINTF

PP_PROC int _cdecl xsmprintfva(HeapStringA *pData,const char *pFormat,va_list pArgs)
{
int			iRet;


	if(!pData->pText)									// Dynamischen Speicher initialisieren
		{
		pData->iSize	= 0;

		    pData->pText = new char[PP_HEAP_ALLOC+4];
		if(!pData->pText)
			{
			pData->iMax = 0;
			return 0;
			}

		pData->iMax		= PP_HEAP_ALLOC;
		}

	iRet = pprintfva(pData,WriteSmPrintf,pFormat,pArgs);

	pData->pText[iRet]	= 0;


return iRet;
}

PP_PROC int _cdecl xsmprintfa(HeapStringA *pData,const char *pFormat,...)
{
va_list		pArgs;
int			iRet;


	if(!pData->pText)									// Dynamischen Speicher initialisieren
		{
		pData->iSize	= 0;

		    pData->pText = new char[PP_HEAP_ALLOC+4];
		if(!pData->pText)
			{
			pData->iMax = 0;
			return 0;
			}

		pData->iMax		= PP_HEAP_ALLOC;
		}

	va_start(pArgs,pFormat);
	iRet = pprintfva(pData,WriteSmPrintf,pFormat,pArgs);
	va_end(pArgs);

	pData->pText[iRet]	= 0;


return iRet;
}

#if PP_HAS_UNICODE

PP_PROC int _cdecl xsmprintfvw(HeapStringW *pData,const wchar_t *pFormat,va_list pArgs)
{
int			iRet;


	if(!pData->pText)									// Dynamischen Speicher initialisieren
		{
		pData->iSize	= 0;

		    pData->pText = new wchar_t[PP_HEAP_ALLOC+4];
		if(!pData->pText)
			{
			pData->iMax = 0;
			return 0;
			}

		pData->iMax		= PP_HEAP_ALLOC;
		}

	iRet = pprintfvw(pData,WriteSmPrintf,pFormat,pArgs);

	pData->pText[iRet]	= 0;


return iRet;
}

PP_PROC int _cdecl xsmprintfw(HeapStringW *pData,const wchar_t *pFormat,...)
{
va_list		pArgs;
int			iRet;


	if(!pData->pText)									// Dynamischen Speicher initialisieren
		{
		pData->iSize	= 0;

		    pData->pText = new wchar_t[PP_HEAP_ALLOC+4];
		if(!pData->pText)
			{
			pData->iMax = 0;
			return 0;
			}

		pData->iMax		= PP_HEAP_ALLOC;
		}

	va_start(pArgs,pFormat);
	iRet = pprintfvw(pData,WriteSmPrintf,pFormat,pArgs);
	va_end(pArgs);

	pData->pText[iRet]	= 0;


return iRet;
}

#endif
#endif


//*****************************************************************************
//*
//*		xsprintf Funktionen
//*
//*****************************************************************************
//	Erstellt einen formatierten Text mit Lngenbeschrnkung und Nullbyte.
//	pBuffer		: Zeiger auf den Textpuffer.
//	iSize		: Gre des Textpuffers in Zeichen.
//	pFormat		: Format fr die Texterstellung.
//	Ergibt die Lnge der erstellten Textes in Zeichen ohne Nullbyte.

#if PP_HAS_SYPRINTF

PP_PROC int _cdecl xsprintfva(char *pBuffer,const char *pFormat,va_list pArgs)
{
SxDataA		sData;
int			iRet;


	sData.pBuffer	= pBuffer;
	sData.iSize		= 0x10000000;
	sData.iOffset	= 0;
	iRet			= pprintfva(&sData,WriteSxPrintf,pFormat,pArgs);
	pBuffer[iRet]	= 0;


return iRet;
}

PP_PROC int _cdecl xsprintfa(char *pBuffer,const char *pFormat,...)
{
SxDataA		sData;
va_list		pArgs;
int			iRet;


	sData.pBuffer	= pBuffer;
	sData.iSize		= 0x10000000;
	sData.iOffset	= 0;

	va_start(pArgs,pFormat);
	iRet = pprintfva(&sData,WriteSxPrintf,pFormat,pArgs);
	va_end(pArgs);

	pBuffer[iRet]	= 0;


return iRet;
}

#if PP_HAS_UNICODE

PP_PROC int _cdecl xsprintfvw(wchar_t *pBuffer,const wchar_t *pFormat,va_list pArgs)
{
SxDataW		sData;
int			iRet;


	sData.pBuffer	= pBuffer;
	sData.iSize		= 0x10000000;
	sData.iOffset	= 0;
	iRet			= pprintfvw(&sData,WriteSxPrintf,pFormat,pArgs);
	pBuffer[iRet]	= 0;


return iRet;
}

PP_PROC int _cdecl xsprintfw(wchar_t *pBuffer,const wchar_t *pFormat,...)
{
SxDataW		sData;
va_list		pArgs;
int			iRet;


	sData.pBuffer	= pBuffer;
	sData.iSize		= 0x10000000;
	sData.iOffset	= 0;

	va_start(pArgs,pFormat);
	iRet = pprintfvw(&sData,WriteSxPrintf,pFormat,pArgs);
	va_end(pArgs);

	pBuffer[iRet]	= 0;


return iRet;
}

#endif
#endif

//*****************************************************************************
//*
//*		xprintf Funktionen
//*
//*****************************************************************************
//	Einen formatierten Text in der aktuellen konsole ausgeben.
//	pBuffer		: Zeiger auf den Textpuffer.
//	iSize		: Gre des Textpuffers in Zeichen.
//	pFormat		: Format fr die Texterstellung.
//	Ergibt die Lnge der erstellten Textes in Zeichen ohne Nullbyte.

#if PP_HAS_XPRINTF

static	void *pConHandle=0;

PP_PROC int _cdecl xprintfva(const char *pFormat,va_list pArgs)
{
int			iRet;

	#if			defined(ConOutputInit)
	if(!pConHandle)pConHandle=ConOutputInit();
	#elif		PP_USE_STREAM
	pConHandle  = stdout;
	#elif		defined(_WIN32)
	if(!pConHandle)pConHandle=GetStdHandle(STD_OUTPUT_HANDLE);
	#elif		defined(linux)
	pConHandle	= (void*)1;
	#else
	#error		unknown OS
	#endif

	iRet = pprintfva(pConHandle,WritePrintf,pFormat,pArgs);

return iRet;
}

PP_PROC int _cdecl xprintfa(const char *pFormat,...)
{
va_list		pArgs;
int			iRet;

	#if			defined(ConOutputInit)
	if(!pConHandle)pConHandle=ConOutputInit();
	#elif		PP_USE_STREAM
	pConHandle  = stdout;
	#elif		defined(_WIN32)
	if(!pConHandle)pConHandle=GetStdHandle(STD_OUTPUT_HANDLE);
	#elif		defined(linux)
	pConHandle	= (void*)1;
	#else
	#error		unknown OS
	#endif

	va_start(pArgs,pFormat);
	iRet = pprintfva(pConHandle,WritePrintf,pFormat,pArgs);
	va_end(pArgs);

return iRet;
}

#if PP_HAS_UNICODE

PP_PROC int _cdecl xprintfvw(const wchar_t *pFormat,va_list pArgs)
{
int			iRet;

	#if			defined(ConOutputInit)
	if(!pConHandle)pConHandle=ConOutputInit();
	#elif		PP_USE_STREAM
	pConHandle  = stdout;
	#elif		defined(_WIN32)
	if(!pConHandle)pConHandle=GetStdHandle(STD_OUTPUT_HANDLE);
	#elif		defined(linux)
	pConHandle	= (void*)1;
	#else
	#error		unknown OS
	#endif

	iRet = pprintfvw(pConHandle,WritePrintf,pFormat,pArgs);

return iRet;
}

PP_PROC int _cdecl xprintfw(const wchar_t *pFormat,...)
{
va_list		pArgs;
int			iRet;

	#if			defined(ConOutputInit)
	if(!pConHandle)pConHandle=ConOutputInit();
	#elif		PP_USE_STREAM
	pConHandle  = stdout;
	#elif		defined(_WIN32)
	if(!pConHandle)pConHandle=GetStdHandle(STD_OUTPUT_HANDLE);
	#elif		defined(linux)
	pConHandle	= (void*)1;
	#else
	#error		unknown OS
	#endif

	va_start(pArgs,pFormat);
	iRet = pprintfvw(pConHandle,WritePrintf,pFormat,pArgs);
	va_end(pArgs);

return iRet;
}

#endif

#endif

#endif
