//*****************************************************************************
//*
//*
//*		ProcPrintf.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2007
//
//	In dieser Datei ist eine printf Funktion implementiert die fr die
//	Ausgabe einen Funktions-Pointer erlaubt.
//	Die Funktionen sind fr ANSI und UNICODE geschrieben.
//
//	Funktionen:
//
//		pprintf (Param ,Proc,Format,...)			: Ausgabe ber Funktion
//		xprintf (            Format,...)			: Ausgabe in Console
//		xsnprintf(Buffer,Size,Format,...)			: Ausgabe in Puffer mit Lngenbeschrnkung
//		fprintfa(FILE*      ,Format,...)			: Ausgabe in Datei im ANSI  Format
//		fprintfu(FILE*      ,Format,...)			: Ausgabe in Datei im UTF8  Format
//		fprintfw(FILE*      ,Format,...)			: Ausgabe in Datei im UTF16 Format
//
#ifndef 	__PROCPRINTF_H__
#define 	__PROCPRINTF_H__

#ifdef		GLOBAL_CONFIG
#define 	PROCPRINTF_H
#include	<GlobalConfig.h>
#undef		PROCPRINTF_H
#endif
		   
							 
#if _MSC_VER >= 1000
#pragma once
#else
#ifndef	_cdecl
#define _cdecl
#endif
#endif

#include	<stdio.h>
#include	<stdarg.h>

#ifdef  linux
  #include	<wchar.h>
#else
  #ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include <wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
  #endif
#endif


//*****************************************************************************
//*
//*		Compiler Einstellungen
//*
//*****************************************************************************

#ifdef _MSC_VER

	#ifndef	  PP_INLINE
	#define   PP_INLINE	__inline
	#endif

	#ifndef	  PP_STATIC
	#define   PP_STATIC	static
	#endif

#elif defined(__GNUC__)

	#ifndef	 _cdecl
	#define	 _cdecl
	#endif

	#ifndef	__cdecl
	#define	__cdecl
	#endif

	#ifndef	  PP_INLINE
	#define   PP_INLINE	inline
	#endif

	#ifndef	  PP_STATIC
	#define   PP_STATIC	static
	#endif

#elif defined(__CC_ARM)

	#ifndef	 _cdecl
	#define	 _cdecl
	#endif
	#ifndef	__cdecl
	#define	__cdecl
	#endif

	#ifndef	  PP_INLINE
	#define	  PP_INLINE	__inline
	#endif

	#ifndef	  PP_STATIC
	#define	  PP_STATIC	static
	#endif

#elif defined(__ICCARM__)

	#ifndef	 _cdecl
	#define	 _cdecl
	#endif
	#ifndef	__cdecl
	#define	__cdecl
	#endif

	#ifndef	  PP_INLINE
	#define	  PP_INLINE	inline
	#endif

	#ifndef	  PP_STATIC
	#define	  PP_STATIC	static
	#endif

#else

	#error    unknown compiler

#endif

typedef struct
	{
	char	 *pText;									// Zeiger auf den Text
	int		  iSize;									// Ist die Lnge des Texte
	int		  iMax;										// Ist die Gre des Speichers
	}HeapStringA;

typedef struct
	{
	wchar_t	 *pText;									// Zeiger auf den Text
	int		  iSize;									// Ist die Lnge des Texte
	int		  iMax;										// Ist die Gre des Speichers
	}HeapStringW;



//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
#ifdef	__cplusplus
#define PP_VAR_PRM	,...
extern "C" {
#else 	
#define PP_VAR_PRM	
#endif 	


	typedef	int (_cdecl *pprintf_proca)(void *pParam,const char    *pBuffer,int iSize);
	typedef	int (_cdecl *pprintf_procw)(void *pParam,const wchar_t *pBuffer,int iSize);

	int  _cdecl pprintfa   (void *pParam,pprintf_proca pProc,const char    *pFormat PP_VAR_PRM);
	int  _cdecl pprintfw   (void *pParam,pprintf_procw pProc,const wchar_t *pFormat PP_VAR_PRM);

	int  _cdecl pprintfva  (void *pParam,pprintf_proca pProc,const char    *pFormat,va_list pArgs);
	int  _cdecl pprintfvw  (void *pParam,pprintf_procw pProc,const wchar_t *pFormat,va_list pArgs);
						  
	int  _cdecl xprintfa   (                                 const char    *pFormat PP_VAR_PRM);
	int  _cdecl xprintfw   (                                 const wchar_t *pFormat PP_VAR_PRM);
	int  _cdecl xsprintfa  (char    *pBuffer                ,const char    *pFormat PP_VAR_PRM);
	int  _cdecl xsprintfw  (wchar_t *pBuffer                ,const wchar_t *pFormat PP_VAR_PRM);
	int  _cdecl xsnprintfa (char    *pBuffer,int iSize      ,const char    *pFormat PP_VAR_PRM);
	int  _cdecl xsnprintfw (wchar_t *pBuffer,int iSize      ,const wchar_t *pFormat PP_VAR_PRM);
	int  _cdecl xsmprintfa (HeapStringA *pData              ,const char    *pFormat PP_VAR_PRM);
	int  _cdecl xsmprintfw (HeapStringW *pData              ,const wchar_t *pFormat PP_VAR_PRM);
						  							        
	int  _cdecl xprintfva  (                                 const char    *pFormat,va_list pArgs);
	int  _cdecl xprintfvw  (                                 const wchar_t *pFormat,va_list pArgs);
	int  _cdecl xsprintfva (char    *pBuffer                ,const char    *pFormat,va_list pArgs);
	int  _cdecl xsprintfvw (wchar_t *pBuffer                ,const wchar_t *pFormat,va_list pArgs);
	int  _cdecl xsnprintfva(char    *pBuffer,int iSize      ,const char    *pFormat,va_list pArgs);
	int  _cdecl xsnprintfvw(wchar_t *pBuffer,int iSize      ,const wchar_t *pFormat,va_list pArgs);
	int  _cdecl xsmprintfva(HeapStringA *pData              ,const char    *pFormat,va_list pArgs);
	int  _cdecl xsmprintfvw(HeapStringW *pData              ,const wchar_t *pFormat,va_list pArgs);
						   							        
	int  _cdecl fprintfaa  (FILE *pFile                     ,const char    *pFormat PP_VAR_PRM);
	int  _cdecl fprintfaw  (FILE *pFile                     ,const wchar_t *pFormat PP_VAR_PRM);
	int  _cdecl fprintfua  (FILE *pFile                     ,const char    *pFormat PP_VAR_PRM);
	int  _cdecl fprintfuw  (FILE *pFile                     ,const wchar_t *pFormat PP_VAR_PRM);
	int  _cdecl fprintfwa  (FILE *pFile                     ,const char    *pFormat PP_VAR_PRM);
	int  _cdecl fprintfww  (FILE *pFile                     ,const wchar_t *pFormat PP_VAR_PRM);
						   			                        
	int  _cdecl fprintfava (FILE *pFile                     ,const char    *pFormat,va_list pArgs);
	int  _cdecl fprintfavw (FILE *pFile                     ,const wchar_t *pFormat,va_list pArgs);
	int  _cdecl fprintfuva (FILE *pFile                     ,const char    *pFormat,va_list pArgs);
	int  _cdecl fprintfuvw (FILE *pFile                     ,const wchar_t *pFormat,va_list pArgs);
	int  _cdecl fprintfwva (FILE *pFile                     ,const char    *pFormat,va_list pArgs);
	int  _cdecl fprintfwvw (FILE *pFile                     ,const wchar_t *pFormat,va_list pArgs);
						   

#ifdef	__cplusplus
}
#endif 	


//*****************************************************************************
//*
//*		Definitionen
//*
//*****************************************************************************

#ifdef	UNICODE

	#define 	HeapString		HeapStringW
	#define 	pprintfv		pprintfvw
	#define 	pprintf			pprintfw
	#define 	xsmprintfv		xsmprintfvw
	#define 	xsnprintfv		xsnprintfvw
	#define 	xsmprintf		xsmprintfw
	#define 	xsnprintf		xsnprintfw
	#define 	xsprintf		xsprintfw
	#define 	xprintf			xprintfw
	#define 	fprintfa		fprintfaw
	#define 	fprintfu		fprintfuw
	#define 	fprintfw		fprintfww
	#define 	pprintf_proc 	pprintf_procaw

#else 	

	#define 	HeapString		HeapStringA
	#define 	pprintfv		pprintfva
	#define 	pprintf			pprintfa
	#define 	xsmprintfv		xsmprintfva
	#define 	xsnprintfv		xsnprintfva
	#define 	xsmprintf		xsmprintfa
	#define 	xsnprintf		xsnprintfa
	#define 	xsprintf		xsprintfa
	#define 	xprintf			xprintfa
	#define 	fprintfa		fprintfaa
	#define 	fprintfu		fprintfua
	#define 	fprintfw		fprintfwa
	#define 	pprintf_proc 	pprintf_procaa

#endif 	


#ifndef	PP_NO_COMMON

	#define 	printf			xprintfa
	#define 	wprintf			xprintfw
	#define 	sprintf			xsprintfa
	#define 	swprintf		xsprintfw
	#define 	snprintf		xsnprintfa
	#define 	snwprintf		xsnprintfw
	#define    _snprintf		xsnprintfa
	#define    _snwprintf		xsnprintfw
	#define 	fprintf			fprintfaa
	#define 	fwprintf		fprintfww

	#define 	vprintf			xprintfva
	#define 	vwprintf		xprintfvw
	#define 	vsprintf		xsprintfva
	#define 	vswprintf		xsprintfvw
	#define 	vsnprintf		xsnprintfva
	#define 	vsnwprintf		xsnprintfvw
	#define    _vsnprintf		xsnprintfva
	#define    _vsnwprintf		xsnprintfvw
	#define 	vfprintf		fprintfava
	#define 	vfwprintf		fprintfwvw

	#ifdef	 	_tprintf		
	#undef 		_tprintf	
	#endif 		
	#ifdef	 	_ftprintf		
	#undef 		_ftprintf		
	#endif 		
	#ifdef	 	_stprintf		
	#undef 		_stprintf		
	#endif 		
	#ifdef	 	_sntprintf		
	#undef 		_sntprintf		
	#endif 		
	#ifdef	 	_vtprintf		
	#undef 		_vtprintf		
	#endif 		
	#ifdef	 	_vftprintf		
	#undef 		_vftprintf		
	#endif 		
	#ifdef	 	_vstprintf		
	#undef 		_vstprintf		
	#endif 		
	#ifdef	 	_vsntprintf		
	#undef 		_vsntprintf		
	#endif 		

	#ifdef		UNICODE
	
	#define 	_tprintf		xprintfw
	#define 	_ftprintf		fprintfww
	#define 	_stprintf		xsprintfw
	#define 	_sntprintf		xsnprintfw
	#define 	_vtprintf		xprintfvw
	#define 	_vftprintf		fprintfwvw
	#define 	_vstprintf		xsprintfvw
	#define 	_vsntprintf		xsnprintfvw

	#else 	

	#define 	_tprintf		xprintfa
	#define 	_ftprintf		fprintfaa
	#define 	_stprintf		xsprintfa
	#define 	_sntprintf		xsnprintfa
	#define 	_vtprintf		xprintfva
	#define 	_vftprintf		fprintfava
	#define 	_vstprintf		xsprintfva
	#define 	_vsntprintf		xsnprintfva
	
	#endif 	

#endif 	

#endif
