//*****************************************************************************
//*
//*
//*		Konfiguration fr die Registry
//*
//*
//*****************************************************************************
//
//	Diverse Funktionen um registrierte Dateitypen in der Registry zu bearbeiten.
//
//	(C) Copyright Anton Zechner 2007
//
#ifdef	   _MFC_VER
#ifndef		AZ_LIB_ADDAFX
#define		AZ_LIB_ADDAFX
#endif
#endif

#include	"RegKeys.h"
#include	"RegConfig.h"
#include	"MemFunctions.h"
#include	"FileFunctions.h"
#include	"StringFunctions.h"
#include	<ShlObj.h>

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	strzlen		wcslen
#define 	strzcat		wcscat
#define 	strzcpy		wcscpy
#define 	strzncpy	wcsncpy
#define 	strzicmp	wcsicmp
#define 	strzlwr		wcslwr
#define 	strzupr		wcsupr
#define 	itoz	   _itow
#define 	atoz	   _wtoi
#else
#define 	Z(a)		a
#define 	strzlen		strlen
#define 	strzcat		strcat
#define 	strzcpy		strcpy
#define 	strzncpy	strncpy
#define 	strzicmp	stricmp
#define 	strzlwr		strlwr
#define 	strzupr		strupr
#define 	itoz		itoa
#define 	atoz		atoi
#endif


static		LPCTSTR     aOpenList []={Z("open" ),Z("ffne"     ),Z("ffne"  ),Z("ffnen"),Z("ffnen"),0};
static		LPCTSTR     aPrintList[]={Z("print"),Z("Drucke"    ),Z("Drucken"),0};
static		LPCTSTR     aEditList []={Z("Edit" ),Z("Bearbeiten"),0};



//*****************************************************************************
//*
//*		ConfigFileIcon
//*
//*****************************************************************************
//	Stellt das Icon fr eine Dateiart ein.
//	pType		: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	pFilename	: Ist der Dateiname des Icons
//	iIconNr		: Ist die Nummer des Icons in der Icon-Datei, Wenn iIconNr
//					kleiner 0 ist, wird die Icon-ID verwentet.
//	pTypeName	: Ist der Anzeigename fr die Dateiart. Wird keiner angegeben
//					wird "TYPE Datei" verwentet.
//	pGroupName	: Ist der Gruppenname in der Registry. Wird keiner angegeben
//					wird "TYPEfile" benutzt.
//	Ergibt true wenn die Dateiart registriert wurde.
bool ConfigFileIcon(LPCTSTR pType,
					LPCTSTR pFilename,
					int	    iIconNr,
					LPCTSTR pTypeName,
					LPCTSTR pGroupName)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16];
TCHAR 		cGroup[64];
TCHAR		cName [64];
TCHAR		cTemp [64];
TCHAR		cPath [MAX_PATH+16];
int			iGroupSet;
int			iNameSet;
int			i;


	iGroupSet = 1;
	iNameSet  = 1;

		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!pTypeName || !*pTypeName)						// Typnamen erzeugen
		{
		iNameSet=0;
		strzcpy(cName,pPtr);
		strzupr(cName);
		strzcat(cName,Z(" Datei"));
		pTypeName=cName;
		}



	strzncpy(cPath,pFilename,MAX_PATH);					// Dateiname erzeugen
	cPath[MAX_PATH]=0;
	if(ExistFile(cPath)!=1)								// Existiert Datei
		{
		for(i=0;;i++)
			{
			if(cPath[i]==0  )return false;								
			if(cPath[i]=='%')break;
			}
		}

				  cGroup[0]=',';						// Iconnummer anhngen
	itoz(iIconNr, cGroup+1,10);
	strzcat(cPath,cGroup);


	if(!pGroupName || !*pGroupName)						// Gruppenname erzeugen
		{
		iGroupSet=0;
		strzcpy(cGroup,pPtr);
		strzcat(cGroup,Z("file"));
		strzlwr(cGroup);
		pGroupName=cGroup;
		}


	if(!sKey.Create(HKEY_CLASSES_ROOT,cType))return false;
	if(!iGroupSet)
		{
		if(!sKey.Get(cTemp,sizeof(cTemp),0) || !cTemp[0])iGroupSet=1;
		else	strzncpy(cGroup,cTemp,sizeof(cGroup));
		}

	if(iGroupSet)
	if(!sKey.Set(pGroupName,0))return false;
		sKey.Close();


	if(sKey.Open(HKEY_CLASSES_ROOT,Z("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts"),CRK_CREATE))
	if(sKey.Up(cType))
	if(sKey.Up(Z("UserChoice")))
		{
		sKey.Del(Z("Progid"));
		}


	if(!sKey.Create(HKEY_CLASSES_ROOT,pGroupName))return false;
	if(!iNameSet)
		{
		if(!sKey.Get(cTemp,sizeof(cTemp),0) || !cTemp[0])iNameSet=1;
		else	strzncpy(cName,cTemp,sizeof(cName));
		}

	if(iNameSet)
	if(!sKey.Set(pTypeName,0))return false;
		sKey.Set(Z("") ,Z("AlwaysShowExt"));
		sKey.Set((void*)Z("\0\0\0\0"),4,Z("EditFlags"),REG_BINARY);
	if(!sKey.Up (Z("DefaultIcon")))return false;
	if(!sKey.Set(cPath,0))return false;
		sKey.Down();
	if(!sKey.Up(Z("ShellEx"),TRUE))return true;
		sKey.DelKey(Z("IconHandler"));
		sKey.Close();


	

return true;
}

//*****************************************************************************
//*
//*		ConfigFileType
//*
//*****************************************************************************
//	Stellt den Typnamen Icon fr eine Dateiart ein.
//	pType		: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	pTypeName	: Ist der Anzeigename fr die Dateiart der gespeichert werden soll
//	Ergibt true wenn der Typnamen registriert wurde.
bool ConfigFileType(LPCTSTR pType,LPCTSTR pTypeName)
{
TCHAR		cType[16];
TCHAR		cTemp[64];
LPCTSTR		pPtr;
CRegKeys	sKey;


	if(!pTypeName || !*pTypeName)return false;


		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);


	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))
		{
		return false;
		}

	if(!sKey.Get(cTemp,sizeof(cTemp),0))				// Hole Typ-Pfad
		{
		return false;
		}

	if(!sKey.Open(HKEY_CLASSES_ROOT,cTemp,CRK_WRITE))
		{
		return false;
		}

	if(!sKey.Set(pTypeName,0))							// Speichere den Typnamen
		{
		return false;
		}
	

return true;
}

//*****************************************************************************
//*
//*		ConfigFileTypeGet
//*
//*****************************************************************************
//	Holt den Typnamen von einer Dateiart.
//	pType		: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	pBuffer		: Ist der Puffer in dem der Typnamen gespeichert wird.
//	iSize		: Ist die Gre des Puffers in Zeichen.
//	Ergibt true wenn der Typnamen geholt wurde.
bool ConfigFileTypeGet(LPCTSTR pType,LPTSTR pBuffer ,int iSize)
{
TCHAR		cType[16];
TCHAR		cTemp[64];
LPCTSTR		pPtr;
CRegKeys	sKey;


	if(!pBuffer || iSize<=0)return false;
	
	*pBuffer = 0;

		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);


	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))
		{
		return false;
		}

	if(!sKey.Get(cTemp,sizeof(cTemp),0))				// Hole Typ-Pfad
		{
		return false;
		}

	if(!sKey.Open(HKEY_CLASSES_ROOT,cTemp,CRK_READ))
		{
		return false;
		}

	if(!sKey.Get(pBuffer,iSize,0))						// Hole den Typnamen
		{
		return false;
		}
	

return true;
}


//*****************************************************************************
//*
//*		ConfigFileCommand
//*
//*****************************************************************************
//	Speichert in der Registry fr eine Dateiart ein Icon fr das Kommando-Context-Men.
//	pType		: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	pCommand	: Ist der Registry-Name des Kommandos. Wenn er 0 ist, dann
//					wird "open" als Kommando verwendet.
//	pFilename	: Ist der Dateiname mit dem Icon.
//					bei 0 wird die aktuelle EXE-Datei benutzt
//	iIconNr		: Ist die Nummer des Icons in der Icon-Datei, Wenn iIconNr
//					kleiner 0 ist, wird die Icon-ID verwentet.
//	Ergibt true wenn das Kommando registriert wurde.
bool ConfigFileCmdIcon( LPCTSTR pType,
						LPCTSTR pCommand,
						LPCTSTR pFilename,
						int	    iIconNr)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cCmd  [64];
TCHAR		cType [16];
TCHAR		cGroup[16+8];
TCHAR		cPath [MAX_PATH*2+16];
int			iPos;
int			i;


		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

	if(pFilename)
		{
		strzncpy(cPath,pFilename,MAX_PATH);				// Dateiname erzeugen
		cPath[MAX_PATH]=0;
		if(ExistFile(cPath)!=1)							// Existiert Datei
			{
			for(i=0;;i++)
				{
				if(cPath[i]==0  )return false;								
				if(cPath[i]=='%')break;
				}
			}
		}
	else{
		GetExeName(cPath,MAX_PATH);
		}


		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))
		{
		if(!sKey.Create(HKEY_CLASSES_ROOT,cType))return false;
		}

	if(!sKey.Get(cGroup,sizeof(cGroup),0) || !*cGroup)
		{
		strzcpy(cGroup,cType+1);
		strzcat(cGroup,Z("file"));
		if(!sKey.Set(cGroup,0))return false;
		}

	sKey.Close();

	
	i = strchar(pFilename,' ');							// Gibt es Leerzeichen im Pfad
	if(pFilename[i])
		{
		i=MakeShortPath(cPath,cPath,MAX_PATH);
		}

	cPath[i]=',';
	itostr(iIconNr,cPath+i+1);


	if(!pCommand || !*pCommand)pCommand=Z("open");

	for(i=0,iPos=0;pCommand[i];i++)						// '&' entfrenen
		{
		if(iPos>=sizeof(cCmd)-1)break;
		if(pCommand[i]=='&')continue;
		cCmd[iPos]=pCommand[i];
		iPos++;
		}

	cCmd[iPos]=0;
	if(iPos==i)pCommand=0;

	for(i=1;aOpenList[i];i++)
		{
		if(strzicmp(cCmd,aOpenList[i]))continue;
		strzcpy(cCmd,Z("open"));
		pCommand=0;
		break;
		}

	for(i=1;aPrintList[i];i++)
		{
		if(strzicmp(cCmd,aPrintList[i]))continue;
		strzcpy(cCmd,Z("print"));
		pCommand=0;
		break;
		}

	for(i=1;aEditList[i];i++)
		{
		if(strzicmp(cCmd,aEditList[i]))continue;
		strzcpy(cCmd,Z("Edit"));
		pCommand=0;
		break;
		}

	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_CREATE))return false;
	if(!sKey.Up(Z("Shell")))return false;
	if(!sKey.Up(cCmd))return false;


	if(!sKey.Set(cPath,Z("Icon")))
		{
		return false;
		}


	sKey.Close();

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))
		{
		if(!sKey.Create(HKEY_CLASSES_ROOT,cType))return false;
		}



return true;
}


//*****************************************************************************
//*
//*		ConfigFileCommand
//*
//*****************************************************************************
//	Speichert in der Registry fr eine Dateiart ein Kommando.
//	pType		: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	pFilename	: Ist der Dateiname fr das Programm das aufgerufen werden soll.
//					bei NULL wird die aktuelle EXE-Datei benutzt
//	pCommand	: Ist der Registry-Name des Kommandos. Wenn er 0 ist, dann
//					wird "open" als Kommando verwendet.
//	pSwitches	: Sind die Parameter fr das Kommando. Wenn 0 angegeben ist,
//				  dann wird "%1" als Parameter benutzt.
//	Ergibt true wenn das Kommando registriert wurde.
bool ConfigFileCommand(	LPCTSTR pType,
						LPCTSTR pFilename,
						LPCTSTR pCommand,
						LPCTSTR pSwitches)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cCmd  [64];
TCHAR		cType [16];
TCHAR		cGroup[16+8];
TCHAR		cPath [MAX_PATH*2+16];
int			iEdit;
int			iPos;
int			i;


	iEdit=0;

		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

	if(pFilename)										// Dateiname erzeugen
		{
		strzncpy(cPath+1,pFilename,MAX_PATH-1);			
		cPath[MAX_PATH]=0;
		if(ExistFile(cPath+1)!=1)						// Existiert Datei
			{
			for(i=1;;i++)
				{
				if(cPath[i]==0  )return false;								
				if(cPath[i]=='%')break;
				}
			}
		}
	else{
		GetExeName(cPath+1,MAX_PATH-1);
		}

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))
		{
		if(!sKey.Create(HKEY_CLASSES_ROOT,cType))return false;
		}

	if(!sKey.Get(cGroup,sizeof(cGroup),0) || !*cGroup)
		{
		strzcpy(cGroup,cType+1);
		strzcat(cGroup,Z("file"));
		if(!sKey.Set(cGroup,0))return false;
		}

	sKey.Close();

	cPath[0]='"';strzcat(cPath,Z("\""));				// In Klammen setzen
	if(!pSwitches || !*pSwitches)pSwitches=Z("\"%1\"");	// Schalter anhngen
	strzcat(cPath,Z(" "));
	strzcat(cPath,pSwitches);


	if(!pCommand || !*pCommand)pCommand=Z("open");

	for(i=0,iPos=0;pCommand[i];i++)						// '&' entfrenen
		{
		if(iPos>=sizeof(cCmd)-1)break;
		if(pCommand[i]=='&')continue;
		cCmd[iPos]=pCommand[i];
		iPos++;
		}

	cCmd[iPos]=0;
	if(iPos==i)pCommand=0;

	for(i=1;aOpenList[i];i++)
		{
		if(strzicmp(cCmd,aOpenList[i]))continue;
		strzcpy(cCmd,Z("open"));
		pCommand=0;
		break;
		}

	for(i=1;aPrintList[i];i++)
		{
		if(strzicmp(cCmd,aPrintList[i]))continue;
		strzcpy(cCmd,Z("print"));
		pCommand=0;
		break;
		}

	for(i=1;aEditList[i];i++)
		{
		if(strzicmp(cCmd,aEditList[i]))continue;
		strzcpy(cCmd,Z("Edit"));
		pCommand=0;
		iEdit=1;
		break;
		}

	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_CREATE))return false;
	if(!sKey.Up(Z("Shell")))return false;
	if(iEdit)
		{
		sKey.DelKey(Z("Bearbeiten" ));
		sKey.DelKey(Z("&Bearbeiten"));
		}

	if(!sKey.Up(cCmd))return false;

	if(iEdit)
		{
		sKey.Set(Z("&Bearbeiten"),0);
		}
	else if(pCommand)
		{
		sKey.Set(pCommand,0);
		}



	if(!sKey.Up (Z("Command")))return false;
	if(!sKey.Set(cPath,0     ))return false;

	sKey.Down();
	sKey.DelKey(Z("ddeexec"));
	sKey.Down();
	sKey.DelKey(Z("DropTarget"));
	sKey.Close();




return true;
}


//*****************************************************************************
//*
//*		ConfigFileQuery
//*
//*****************************************************************************
//	Prft ob fr eine Dateiart ein Registry-Eintrag vorhanden ist.
//	pType	: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	Ergibt	: Bit 0 = Die Dateiart ist registriert
//            Bit 1 = Ein Name ist hinterlegt
//            Bit 2 = Ein Icon ist hinterlegt
//            Bit 3 = Die Icondatei existiert
//			  Bit 4 = Ein ffnen Kommando ist registriert
//			  Bit 5 = Ein Drucken Kommando ist registriert
//			  Bit 6 = Ein Bearbeiten Kommando ist registriert
//			  Bit 7 = Ein Edit Kommando ist registriert
int ConfigFileQuery(LPCTSTR pType)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cText [256 ];
TCHAR		cType [16  ];
TCHAR		cGroup[16+8];
int			iRet;
int			iLen;



		pPtr=GetFileType(pType);					// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return 0;
	if(strzlen(pPtr)+2>sizeof(cType))return 0;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return 0;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return 0;
		sKey.Close();
	if(!*cGroup)return 0;
	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_READ))return 1;


	iRet=0x01;

	if(sKey.Get(cText,sizeof(cText),0))				// Prfe Namen
		{
		if(cText[0])iRet|=0x02;
		}

	if(sKey.Up(Z("DefaultIcon")))					// Prfe Icons
		{
		if(sKey.Get(cText,sizeof(cText),0))
			{
			if(cText[0])iRet|=0x04;
			iLen=(int)strzlen(cText);
			if(iLen>0)iLen--;
			for(;iLen>0;iLen--)
				{
				if(cText[iLen]=='-')continue;
				if(cText[iLen]==',')break;
				if(cText[iLen]< '0'){iLen++;break;}
				if(cText[iLen]> '9'){iLen++;break;}
				}
			if(cText[iLen]==',')cText[iLen]=0;		// Existiert die Icon Datei
			if(ExistFile(cText)==1)iRet|=0x08;
			}
		sKey.Down();
		}


	if(!sKey.Up(Z("Shell"     )))return iRet;		// Prfe Kommandos
	if( sKey.Up(Z("open"      ))){iRet|=0x10;sKey.Down();}
	if( sKey.Up(Z("ffnen"    ))){iRet|=0x10;sKey.Down();}
	if( sKey.Up(Z("ffnen"    ))){iRet|=0x10;sKey.Down();}
	if( sKey.Up(Z("ffne"     ))){iRet|=0x10;sKey.Down();}
	if( sKey.Up(Z("ffne"     ))){iRet|=0x10;sKey.Down();}
	if( sKey.Up(Z("print"     ))){iRet|=0x20;sKey.Down();}
	if( sKey.Up(Z("drucke"    ))){iRet|=0x20;sKey.Down();}
	if( sKey.Up(Z("drucken"   ))){iRet|=0x20;sKey.Down();}
	if( sKey.Up(Z("Bearbeiten"))){iRet|=0x40;sKey.Down();}
	if( sKey.Up(Z("Edit"      ))){iRet|=0x80;sKey.Down();}


return iRet;
}



//*****************************************************************************
//*
//*		ConfigFileRefresh
//*
//*****************************************************************************
//	Aktualisiert die Anzeige von Icons fr eine Dateiart.
//	pType		: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	Ergibt true wenn die Anzeige aktualisiert wurde.
bool ConfigFileRefresh(LPCTSTR pType)
{
TCHAR		 cTemp[MAX_PATH];
TCHAR 		 cName[MAX_PATH+16+8];
LPCTSTR   	 pPtr;
HANDLE		 h;


		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pType)>=16)return false;

	GetTempPath(sizeof(cTemp),cTemp);
  	GetTempFileName(cTemp,Z("CFR"),1,cName);
	strzcat(cName,Z("."));
	strzcat(cName,pType );

	   h=CreateFile(cName,GENERIC_READ|GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING,0);
	if(h==INVALID_HANDLE_VALUE)return false;
	CloseHandle(h);

	SHChangeNotify(SHCNE_ASSOCCHANGED,SHCNF_PATH,cName,0);

	RemoveFile(cName);



return true;
}



//*****************************************************************************
//*
//*		ConfigFileDelete
//*
//*****************************************************************************
//	Lscht die Registrierung einer Dateiart.
//	pType			: Datei Suffix oder ein Dateiname weches(r) die Dateiart festlegt
//	bRemoveCommands	: Wenn auf true dann werden auch die Kommandos fr die
//					  Dateiart gelscht.
//	Ergibt true wenn die Registrierung gelscht wurde.
bool ConfigFileDelete(LPCTSTR pType,bool bRemoveCommands)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType[16];
TCHAR		cName[64];


		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);


	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return true;

	if(bRemoveCommands)
		{
		sKey.Get(cName,sizeof(cName),0);
		}

	if(sKey.Open(HKEY_CLASSES_ROOT,Z(""),CRK_WRITE))
		{
		if(!sKey.DelKey(cType))return false;
		}

	if(!bRemoveCommands)return true;

	if(cName[0] && sKey.Open(HKEY_CLASSES_ROOT,Z(""),CRK_WRITE))
		{
		if(sKey.DelKey(cName))return true;
		}


return false;
}


//*****************************************************************************
//*
//*		ConfigFileCmdChange
//*
//*****************************************************************************
//	ndert das aufzurufende Programm in einem Kommando.
//	pType			: Ist ein Dateiname oder das Suffix mit der Dateiart
//	pFilenameOld	: Ist der Pfad des Programms das gendert werden soll
//					  Wenn dieser Zeiger 0 ist werden alle Programme gendert
//					  Der Pfad kann auch Wildcards wie und ? enthalten.
//					  Dieser Pfad wird mit memxcmp("*"+Pfad+"*") gesucht
//					  Nur wenn der Pfad gefunden wurde wird er gegen
//					  getauscht mit pFilenameNew
//	pFilenameNew	: Ist der neue Programmpfad fr das Kommando
//	pCommand		: Ist das Kommando das gendert wird.
//					  Ist pCommand gleich 0 dann wird "open" verwendet
//					  Mit ALL_COMMAND werden alle Kommandos berprft
//	pSwitches		: Sind die neuen Parameter fr das Programm.
//					  Ist pSwitches gleich 0 so werden die alten
//					  Parameter verwendet.
//	Ergibt true wenn mindestens ein Kommando verndert wurde.
bool ConfigFileCmdChange(	LPCTSTR pType,
							LPCTSTR pFilenameOld,
							LPCTSTR pFilenameNew,
							LPCTSTR pCommand,
							LPCTSTR pSwitches)
{
LPCTSTR    *pListPtr;
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16  ];
TCHAR		cGroup[16+8];
TCHAR		cCmd  [64  ];
TCHAR		cPath [MAX_PATH*2+16];
TCHAR		cFind [MAX_PATH*2+16];
bool		bChaned;
int			iLen;
int			iPos;
int			iNew;
int			iSub;
int			i;



		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return false;
		sKey.Close();
	if(!*cGroup)return false;


	if(ExistFile(pFilenameNew)!=1)						// Existiert Datei
		{
		for(i=0;;i++)
			{
			if(pFilenameNew[i]==0  )return false;								
			if(pFilenameNew[i]=='%')break;
			}
		}

	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_WRITE))return false;
	if(!sKey.Up(Z("Shell")))return false;


	pListPtr=0;




	if(pCommand!=ALL_COMMAND)							// Gehrt das Kommando zu einer Liste
	do	{
		if(!pCommand || !*pCommand){pListPtr=aOpenList;break;}

		for(i=0,iPos=0;pCommand[i];i++)					// '&' entfernen
			{
			if(iPos>=sizeof(cCmd)-1)break;
			if(pCommand[i]=='&')continue;
			cCmd[iPos]=pCommand[i];
			iPos++;
			}

		if(iPos!=i)
			{
			cCmd[iPos]=0;
			pCommand=cCmd;
			}

		if(!strzicmp(pCommand,Z("open"      ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffne"     ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffne"     ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffnen"    ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffnen"    ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("Drucken"   ))){pListPtr=aPrintList;break;}
		if(!strzicmp(pCommand,Z("Drucke"    ))){pListPtr=aPrintList;break;}
		if(!strzicmp(pCommand,Z("print"     ))){pListPtr=aPrintList;break;}
		if(!strzicmp(pCommand,Z("Bearbeiten"))){pListPtr=aEditList;	break;}
		if(!strzicmp(pCommand,Z("Edit"      ))){pListPtr=aEditList;	break;}
		}while(0);


	if(!pFilenameOld)pFilenameOld=Z("");

	iLen=strlcpy(cFind+1,pFilenameOld,sizeof(cFind)-2);

	cFind[     0] = '*';
	cFind[iLen+1] = '*';
	cFind[iLen+2] =  0 ;

	PathConvert(cFind);
	bChaned	= false;
	iLen   += 2;
	iNew	= (int)strzlen(pFilenameNew);
	iSub	= 0;


	for(;;) 											// Alle Kommandos durchlaufen
		{
		if(pCommand==ALL_COMMAND)
			{
			if(!sKey.KeySubName(cPath,sizeof(cPath),iSub))break;
			pPtr=cPath;
			iSub++;
			}
		else if(pListPtr)
			{
			pPtr=*pListPtr;
			pListPtr++;
			if(!pPtr)break;
			}
		else{
			if(!pCommand)break;
			pPtr=pCommand;
			pCommand=0;
			}

		if(!sKey.Up(pPtr))continue;						// Das Kommando ffnen
		if(!sKey.Up (Z("Command")))
			{
			sKey.Down();
			continue;
			}

		sKey.Get(cPath,sizeof(cPath),0);

		if(memxcmp(cFind,iLen,cPath,sKey.Len(),1))		// Passt der alte Programmpfad
			{
			sKey.Down();
			sKey.Down();
			continue;
			}


		if(pSwitches)									// Neu Parameter vergeben
			{
			iPos=strlcpy(cPath+1,pFilenameNew,MAX_PATH);
			cPath[0]='"';
			cPath[iPos+1]='"';
			cPath[iPos+2]=' ';
			strzcpy(cPath+iPos+3,pSwitches);
			}
		else{
			if(cPath[0]=='"')							// Die alten Parameter weiter verwenden
				{
				for(iPos=1;cPath[iPos];iPos++)
					{
					if(cPath[iPos]=='"'){iPos++;break;}
					}
				}
			else{
				for(iPos=0;cPath[iPos];iPos++)
					{
					if(cPath[iPos]==' ' )break;
					if(cPath[iPos]=='\t')break;
					}
				}

			if(iNew+4+sKey.Len()-iPos>sizeof(cPath))
				{
				sKey.Down();
				sKey.Down();
				continue;
				}

			memmove(cPath+iNew+2,cPath+iPos,sKey.Len()-iPos+1);
			memcpy (cPath+1,pFilenameNew,iNew*sizeof(TCHAR));
			cPath[iNew+1]='"';
			cPath[     0]='"';
			}


		if(sKey.Set(cPath,0))bChaned=true;
		sKey.Down();
		sKey.DelKey(Z("ddeexec"));
		sKey.Down();
		sKey.DelKey(Z("DropTarget"));
		}

	sKey.Close();



return bChaned;
}

//*****************************************************************************
//*
//*		ConfigFileIconChange
//*
//*****************************************************************************
//	ndert das Icon in einer Datei Registrierung.
//	pType			: Ist ein Dateiname oder das Suffix mit der Dateiart
//	pFilenameOld	: Ist der Pfad des Icons das gendert werden soll
//					  Wenn dieser Zeiger 0 ist werden alle Icons gendert
//					  Der Pfad kann auch Wildcards wie und ? enthalten.
//					  Dieser Pfad wird mit memxcmp("*"+Pfad+"*") gesucht
//					  Nur wenn der Pfad gefunden wurde wird er gegen
//					  getauscht mit pFilenameNew
//	pFilenameNew	: Ist der neue Programmpfad fr das Icon
//	iIconNr			: Ist die Nummer des neuen Icons in der Datei
//	Ergibt true wenn das Icon verndert wurde.
bool ConfigFileIconChange(	LPCTSTR pType,
							LPCTSTR pFilenameOld,
							LPCTSTR pFilenameNew,
							int		iIconNr)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16];
TCHAR 		cGroup[16+8];
TCHAR		cPath [MAX_PATH*2+16];
TCHAR		cFind [MAX_PATH*2+16];
int			iLen;
int			iPos;
int			iNew;
int			iSub;


		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return false;
		sKey.Close();
	if(!*cGroup)return false;


	if(ExistFile(pFilenameNew)!=1)						// Existiert Datei
		{
		for(iPos=0;;iPos++)
			{
			if(pFilenameNew[iPos]==0  )return false;								
			if(pFilenameNew[iPos]=='%')break;
			}
		}


	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_WRITE))return false;
	if(!sKey.Up(Z("DefaultIcon")))return false;



	if(!pFilenameOld)pFilenameOld=Z("");
	iLen=strlcpy(cFind+1,pFilenameOld,sizeof(cFind)-2);
	cFind[     0]='*';
	cFind[iLen+1]='*';
	cFind[iLen+2]= 0;
	iLen+=2;
	PathConvert(cFind);
	iNew=(int)strzlen(pFilenameNew);
	iSub=0;


	sKey.Get(cPath,sizeof(cPath),0);					// IconPfad auslesen

	if(memxcmp(cFind,iLen,cPath,sKey.Len(),1))			// Passt der alte Icon-Pfad
		{
		return false;
		}


	iPos=strlcpy(cPath,pFilenameNew,MAX_PATH);
	cPath[iPos]=',';
	itoz(iIconNr,cPath+iPos+1,10);

	if(!sKey.Set(cPath,0))return false;
		sKey.Down();
	if(!sKey.Up(Z("ShellEx"),TRUE))return true;
		sKey.DelKey(Z("IconHandler"));
		sKey.Close();



return true;
}



//*****************************************************************************
//*
//*		ConfigFileDeleteIf
//*
//*****************************************************************************
//	Lscht eine Dateiart wenn Icon und Kommando Eintrge von nur einem
//	Programm stammen.
//	pType			: Ist ein Dateiname oder das Suffix mit der Dateiart
//	pFilenameCmd	: Ist der Pfad des Programms fr alle Kommandos
//					  Der Pfad kann auch Wildcards wie und ? enthalten.
//					  Dieser Pfad wird mit memxcmp("*"+Pfad+"*") gesucht
//					  Nur wenn der Pfad gefunden wurde wird die Dateiart
//					  gelscht
//	pFilenameIcon	: Ist der Pfad des Programms fr das Icon
//					  Ist der Pfad gleich 0 so wird pFilenameCmd als Pfad benutzt.
//					  Der Pfad kann auch Wildcards wie und ? enthalten.
//					  Dieser Pfad wird mit memxcmp("*"+Pfad+"*") gesucht
//					  Nur wenn der Pfad gefunden wurde wird die Dateiart
//					  gelscht
//	Ergibt true wenn die Dateiart gelscht wurde.
bool ConfigFileDeleteIf(	LPCTSTR pType,
							LPCTSTR pFilenameCmd,
							LPCTSTR pFilenameIcon)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16  ];
TCHAR		cGroup[16+8];
TCHAR		cPath [MAX_PATH*2+16];
TCHAR		cFind [MAX_PATH*2+16];
int			iLen;
int			iSub;
int			iOk;


		pPtr=GetFileType(pType);							// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return false;
		sKey.Close();
	if(!*cGroup)return false;

	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_WRITE))
		{
		if(sKey.Open(HKEY_CLASSES_ROOT,Z(""),CRK_WRITE))
			{
			if(!sKey.DelKey(cType))return false;
			}
		return true;
		}

	for(iOk=0,iSub=0;iSub<3;iSub++)
		{
		if(!sKey.KeySubName(cPath,sizeof(cPath),iSub))break;

		if(!strzicmp(cPath,Z("DefaultIcon")))iOk|=1;
		if(!strzicmp(cPath,Z("Shell"      )))iOk|=2;
		}

	if(iSub>=3 || (iSub==2 && iOk!=3) || (iSub==1 && iOk==0))
		{
		return false;
		}


	if(iOk&1)
	if(sKey.Up(Z("DefaultIcon")))
		{
		if(!pFilenameIcon)pFilenameIcon=pFilenameCmd;

		iLen=strlcpy(cFind+1,pFilenameIcon,sizeof(cFind)-2);
		cFind[     0]='*';
		cFind[iLen+1]='*';
		cFind[iLen+2]= 0;
		iLen+=2;
		PathConvert(cFind);

		sKey.Get(cPath,sizeof(cPath),0);					// IconPfad auslesen

		if(cPath[0])
		if(memxcmp(cFind,iLen,cPath,sKey.Len(),1))			// Passt der alte Icon-Pfad
			{
			return false;
			}

		sKey.Down();
		}

	if(iOk&2)
		{
		iLen=strlcpy(cFind+1,pFilenameCmd,sizeof(cFind)-2);
		cFind[     0]='*';
		cFind[iLen+1]='*';
		cFind[iLen+2]= 0;
		iLen+=2;
		PathConvert(cFind);

		if(sKey.Up(Z("Shell")))
			{
			for(iSub=0;;iSub++)
				{
				if(!sKey.KeySubName(cPath,sizeof(cPath),iSub))break;
				if(!sKey.Up(cPath))continue;
				if(!sKey.Up(Z("Command")))
					{
					sKey.Down();
					continue;
					}

				sKey.Get(cPath,sizeof(cPath),0);			// Kommando auslesen

				if(cPath[0])
				if(memxcmp(cFind,iLen,cPath,sKey.Len(),1))	// Passt der alte Icon-Pfad
					{
					return false;
					}

				sKey.Down();
				sKey.Down();
				}

			sKey.Down();
			}
		}

	if(sKey.Open(HKEY_CLASSES_ROOT,Z(""),CRK_WRITE))
		{
		if(!sKey.DelKey(cType ))return false;
		if(!sKey.DelKey(cGroup))return false;
		}


return true;
}


//*****************************************************************************
//*
//*		ConfigFileCmdDelete
//*
//*****************************************************************************
//	Lscht ein Kommando.
//	pType			: Ist ein Dateiname oder das Suffix mit der Dateiart
//	pCommand		: Ist das Kommando das gelscht wird.
//					  Ist pCommand gleich 0 dann wird "open" verwendet
//					  Mit ALL_COMMAND werden alle Kommandos berprft
//	pFilenameOld	: Ist der Pfad des Programms das lscht werden soll
//					  Wenn dieser Zeiger 0 ist werden alle Programme lscht
//					  Der Pfad kann auch Wildcards wie und ? enthalten.
//					  Dieser Pfad wird mit memxcmp("*"+Pfad+"*") gesucht
//					  Nur wenn der Pfad gefunden wurde wird er gelscht.
//	Ergibt true wenn mindestens ein Kommando gelscht wurde.
bool ConfigFileCmdDelete(	LPCTSTR pType,
							LPCTSTR pCommand,
							LPCTSTR pFilenameOld)
{
LPCTSTR    *pListPtr;
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cCmd    [64  ];
TCHAR		cType   [16  ];
TCHAR		cGroup  [16+8];
TCHAR		cCommand[64  ];
TCHAR		cPath[MAX_PATH*2+16];
TCHAR		cFind[MAX_PATH*2+16];
bool		bChaned;
bool		bDel;
int			iPos;
int			iLen;
int			iSub;
int			i;



		pPtr=GetFileType(pType);						// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return false;
		sKey.Close();
	if(!*cGroup)return false;


	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_WRITE))return false;
	if(!sKey.Up(Z("Shell")))return false;


	pListPtr=0;

	if(pCommand!=ALL_COMMAND)						// Gehrt das Kommando zu einer Liste
	do	{
		if(!pCommand || !*pCommand         ){pListPtr=aOpenList;	break;}

		for(i=0,iPos=0;pCommand[i];i++)				// '&' entfernen
			{
			if(iPos>=sizeof(cCmd)-1)break;
			if(pCommand[i]=='&')continue;
			cCmd[iPos]=pCommand[i];
			iPos++;
			}

		if(iPos!=i)
			{
			cCmd[iPos]=0;
			pCommand=cCmd;
			}

		if(!strzicmp(pCommand,Z("open"      ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffne"     ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffne"     ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffnen"    ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("ffnen"    ))){pListPtr=aOpenList;	break;}
		if(!strzicmp(pCommand,Z("Drucken"   ))){pListPtr=aPrintList;	break;}
		if(!strzicmp(pCommand,Z("Drucke"    ))){pListPtr=aPrintList;	break;}
		if(!strzicmp(pCommand,Z("print"     ))){pListPtr=aPrintList;	break;}
		if(!strzicmp(pCommand,Z("Bearbeiten"))){pListPtr=aEditList;	break;}
		if(!strzicmp(pCommand,Z("Edit"      ))){pListPtr=aEditList;	break;}
		}while(0);


	if(!pFilenameOld)pFilenameOld=Z("");
	iLen=strlcpy(cFind+1,pFilenameOld,sizeof(cFind)-2);
	cFind[     0]='*';
	cFind[iLen+1]='*';
	cFind[iLen+2]= 0;
	iLen+=2;
	PathConvert(cFind);
	bChaned=false;
	iSub=sKey.KeyCount();


	for(;;) 										// Alle Kommandos durchlaufen
		{
		if(pCommand==ALL_COMMAND)
			{
			iSub--;
			if(iSub<0)break;
			if(!sKey.KeySubName(cCommand,sizeof(cCommand),iSub))continue;
			pPtr=cCommand;
			}
		else if(pListPtr)
			{
			pPtr=*pListPtr;
			pListPtr++;
			if(!pPtr)break;
			}
		else{
			if(!pCommand)break;
			pPtr=pCommand;
			pCommand=0;
			}

		bDel=true;

		if(sKey.Up(pPtr))								// Das Kommando ffnen
			{
			if(sKey.Up(Z("Command")))
				{
				sKey.Get(cPath,sizeof(cPath),0);

	 			if(cPath[0])							// Passt der alte Programmpfad
				if(memxcmp(cFind,iLen,cPath,sKey.Len(),1))bDel=false;

				sKey.Down();
				}

			sKey.Down();
			if(bDel && sKey.DelKey(pPtr))bChaned=true;
			}

		}

	sKey.Close();





return bChaned;
}


//*****************************************************************************
//*
//*		ConfigFileCmdGet
//*
//*****************************************************************************
//	Holt den Aufruf fr ein bestimmtes Kommando.
//	pType			: Ist ein Dateiname oder das Suffix mit der Dateiart
//	pBuffer			: Zeiger auf den Speicher fr das Kommando
//	iSize			: Gre des Buffers fr das Kommando
//	pCommand		: Ist das Kommando das geholt wird.
//					  Ist pCommand gleich 0 dann wird "open" verwendet
//	Ergibt true wenn ein Kommando gefunden wurde.
bool ConfigFileCmdGet(		LPCTSTR     pType,
							LPTSTR		pBuffer,
							int			iSize,
							LPCTSTR		pCommand)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16  ];
TCHAR		cGroup[16+8];



	if(iSize>0)*pBuffer=0;


		pPtr=GetFileType(pType);					// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return 0;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return 0;
		sKey.Close();
	if(!*cGroup)return 0;
	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_READ))return false;

	if(!pCommand)pCommand=Z("open");
	if(!sKey.Up(Z("Shell"    )))return false;
	if(!sKey.Up(pCommand      ))return false;
	if(!sKey.Up(Z("Command"  )))return false;
	if(!sKey.Get(pBuffer,iSize))return false;



return true;
}

//*****************************************************************************
//*
//*		ConfigFileIconGet
//*
//*****************************************************************************
//	Holt das Icon fr ein bestimmten Typ.
//	pType			: Ist ein Dateiname oder das Suffix mit der Dateiart
//	pBuffer			: Zeiger auf den Speicher fr das Kommando
//	iSize			: Gre des Buffers fr das Kommando
//	pIconNr			: Hier wird die Iconnummer gespeichert falls ungleich Null
//	Ergibt true wenn ein Kommando gefunden wurde.
bool ConfigFileIconGet(		LPCTSTR		pType,
							LPTSTR		pBuffer,
							int			iSize,
							int		   *pIconNr)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16  ];
TCHAR		cGroup[16+8];
int			iLen;


	if(iSize>0)*pBuffer=0;
	if(pIconNr)*pIconNr=0;


		pPtr=GetFileType(pType);							// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return 0;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return 0;
		sKey.Close();
	if(!*cGroup)return 0;
	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_READ))return false;

	if(!sKey.Up(Z("DefaultIcon")))return false;				// Prfe Icons
	if(!sKey.Get(pBuffer,iSize,0))return false;

	   iLen=(int)strzlen(pBuffer);
	if(iLen<=0)return false;

	for(iLen--;iLen>0;iLen--)
		{
		if(pBuffer[iLen]=='-')continue;
		if(pBuffer[iLen]==',')break;
		if(pBuffer[iLen]< '0'){iLen++;break;}
		if(pBuffer[iLen]> '9'){iLen++;break;}
		}

	if(pBuffer[iLen]==',')pBuffer[iLen]=0;
	if(pIconNr)*pIconNr=atoz(pBuffer+iLen+1);



return true;
}

//*****************************************************************************
//*
//*		ConfigFileDeleteCmd
//*
//*****************************************************************************
//	Lscht ein Kommando.
//	pType		: Ist ein Dateiname oder das Suffix mit der Dateiart
//	Kommando	: Ist der cName des Kommandos das gelscht werden soll (0=open)
//	Ergibt true wenn das Kommando gelscht wurde.
bool ConfigFileDeleteCmd(LPCTSTR pType,LPCTSTR pCommand)
{
LPCTSTR		pPtr;
CRegKeys	sKey;
TCHAR		cType [16  ];
TCHAR		cGroup[16+8];
TCHAR		cPath[MAX_PATH*2+16];
int			iSub;
int			iOk;


		pPtr=GetFileType(pType);							// Hole Typ
	if(*pPtr==0)pPtr=pType;
	if(*pPtr==0)return false;
	if(strzlen(pPtr)+2>sizeof(cType))return false;

		    cType[0]='.';
	strzcpy(cType+1,pPtr);
	strzlwr(cType);

	if(!sKey.Open(HKEY_CLASSES_ROOT,cType,CRK_READ))return false;
	if(!sKey.Get(cGroup,sizeof(cGroup),0))return false;
		sKey.Close();
	if(!*cGroup)return false;

	if(!sKey.Open(HKEY_CLASSES_ROOT,cGroup,CRK_WRITE))
		{
		if(sKey.Open(HKEY_CLASSES_ROOT,Z(""),CRK_WRITE))
			{
			if(!sKey.DelKey(cType))return false;
			}
		return true;
		}

	for(iOk=0,iSub=0;iSub<16;iSub++)
		{
		if(!sKey.KeySubName(cPath,sizeof(cPath),iSub))break;
		if(!strzicmp(cPath,Z("Shell"))){iOk=1;break;}
		}

	if(iOk==0)return false;

	if(!sKey.Up(Z("Shell")))return false;

	if(!pCommand)pCommand=Z("open");

	if(!sKey.DelKey(pCommand))return false;


return true;
}


