//*****************************************************************************
//*
//*
//*		RegKeys.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//	Diese Klasse ermglicht den Zugriff auf die Registry:
//
//	Funktionen der Klasse CRegKeys
//
//		bool Close ();												// Schliet Schlssel
//		bool Open  (HKEY   hKeyNow=HKEY_CURRENT_USER,				// ffnet Schlssel
//					char  *pPath=0,
//					int	   iMode=CRK_CREATE);
//		bool Open  (char  *pPath=0,
//					int	   iMode=CRK_CREATE);
//		bool Create(char  *pPath);									// Erzeugt Unterschlssel
//		bool Create(HKEY   hKeyNow=HKEY_CURRENT_USER, 				// Erzeugt Schlssel
//					char  *pPath=0,int iExMode=0);
//		bool Up	   (char  *pPath=CRK_NEXT,int iOnlyIfExist=0);		// Pfad aufsteigen
//		bool Down  ();												// Pfad aufabsteigen
//		bool Next  ();												// Nchsten Unterschlssel ffnen
//		bool First ();												// Zum ersten Unterschlssel
//
//																	// Werte auslesen
//		bool Get(		  int	&iVal,char  *pName=CRK_NEXT);
//		bool Get(unsigned int	&uVal,char  *pName=CRK_NEXT);
//		bool Get(		  long	&lVal,char  *pName=CRK_NEXT);
//		bool Get(unsigned long	&uVal,char  *pName=CRK_NEXT);
//		bool Get(		  char **pVal,char  *pName=CRK_NEXT);
//		bool Get(unsigned char **pVal,char  *pName=CRK_NEXT);
//		bool Get(		  void **pVal,char  *pName=CRK_NEXT,DWORD dwType=REG_BINARY);
//		bool Get(		  char  *pVal,char  *pName=CRK_NEXT);
//		bool Get(unsigned char  *pVal,char  *pName=CRK_NEXT);
//		bool Get(		  char  *pVal,DWORD dwLen,char  *pName=CRK_NEXT);
//		bool Get(unsigned char  *pVal,DWORD dwLen,char  *pName=CRK_NEXT);
//		bool Get(		  void	*pVal,DWORD dwLen,char  *pName=CRK_NEXT,DWORD dwType=REG_BINARY);
//
//																	// Werte schreiben
//		bool Set(		  int	 iVal,char  *pName=CRK_NEXT);
//		bool Set(		  char 	*pVal,char  *pName=CRK_NEXT);
//		bool Set(unsigned char 	*pVal,char  *pName=CRK_NEXT);
//		bool Set(		  void	*pVal,DWORD dwLen,char *pName=CRK_NEXT,DWORD dwType=REG_BINARY);
//
//		bool Del    (char  *pName=CRK_NEXT);						// Wert lschen
//		bool DelKey (char  *pName=CRK_NEXT);						// Key	lschen
//
//		bool Load   (char  *pFilename);								// Zweig speichern
//		bool Save   (char  *pFilename);								// Zweig speichern
//		bool Replace(char  *pFilenameOld,char *pFilenameNew);		// Zweig austauschen
//
//		int		Path(char  *,int,int iMode=0);						// Ergibt Pfad
//		int		GetLength(const char  *pName);						// Ergibt die Lnge eines Wertes
//		DWORD	Type ();											// Ergibt Type	der Werte
//		DWORD	Len  ();											// Ergibt Lnge der Werte
//		HKEY	Key  ();											// Ergibt Aktuellen Schlssel
//		char   *Name ();											// Ergibt Name
//		int		Error();											// Ergibt letzten Fehler
//
//		int	    KeyCount  ();										// Ergibt Anzahl der SubKeys
//		int	    ValueCount();										// Ergibt Werte Anzahl
//		char   *ValueName (int iNr=-1);								// Ergibt Wert-Namen
//		char   *KeySubName(int iNr=-1);								// Ergibt SubKey-Namen
//		char   *KeyName   (int iNr=-1);								// Ergibt hKey-Namen
//
//		int	    RegPath(char  *pPath,int iLen,zchar  *pName=0);		// Ergibt Standard Pfad

#ifndef		__REGKEYS_H__
#define     __REGKEYS_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#if defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if		_MSC_VER > 1299
	#ifndef		WINVER
	#define		WINVER 	0x0501
	#endif
	#endif
	#include	<Afx.h>
	#include	<AfxWin.h>
#else
	#include	<Windows.h>
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	zcharu		short
#define 	strlenz		wcslen
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	zcharu		unsigned char
#define 	strlenz		strlen
#endif


#ifndef		__TXTKEYS_H__
#define 	ERROR_KEY		0x5815								// Fehler wenn Keys nicht offen
#define 	ERROR_LIMIT		0x5816								// Fehler wenn zuviele Keys offen
#define 	ERROR_MODE		0x5817								// Zugriffs-Modus Fehler
#define 	ERROR_DATA		0x5818								// Falscher Datenzeiger

#define 	CRK_KEYS_MAX	12									// Maximale Ebenentiefe
#define 	CRK_KEYS_END	(CRK_KEYS_MAX-1)					// Letzte Ebenen-Nummer
#define 	CRK_NEXT		((zchar*)-1) 						// Nchster Wert
#define 	CRK_ALL			((zchar*)-2) 						// Alle Werte

#define 	CRK_READ		0									// Schlssel nur lesen
#define 	CRK_WRITE		1									// Schlssel auch schreiben
#define 	CRK_CREATE		2									// Schlssel auch erzeugen
#endif

#define		CRK_USE_AUTO	0x10000000							// Unicode oder Ansi benutzen (fr GetEx)
#define		CRK_USE_ANSI	0x10000000							// Ansi benutzen    (fr GetEx)
#define		CRK_USE_WIDE	0x20000000							// Unicode benutzen (fr GetEx)

#define		CRK_WOW64_64KEY	0x00000100							// 32-Bit Programme nicht auf WOW64 Umleitung gehen
#define		CRK_WOW64_32KEY	0x00000200							// 64-Bit Programme immer auf WOW64 Umleitung gehen
#define		CRK_WOW64_AUTO	0x80000000							// Automatische WOW64 Umleitung

#ifndef		REG_QWORD
#define		REG_QWORD		11									// 64-Bit Werte
#endif		


class CStringChain;

class CRegKeys
{
//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************
protected:

	HKEY	hKeyNow;											// Registry Schlssel
	HKEY	hKeyInit;											// Anfangs	Schlssel
	zchar 	cName[257];											// Wertname
	DWORD	dwType;												// Type	 der Werte
	DWORD	dwLength;											// Lnge der Werte
	DWORD	dwNameLen;											// Lnge des Namens

	HKEY	aKey[CRK_KEYS_MAX];									// Registry Schlssel
	int		aPos[CRK_KEYS_MAX];									// Ebenen Position
	int		aSub[CRK_KEYS_MAX];									// Ebenen Position
	zchar  *aStr[CRK_KEYS_MAX];									// Ebenen Namen
	int		iLevel;												// Aktuelle Ebene
	int		iOpenMode;											// ffnungsmodus CRK_???
	int		iFlags;												// Zugriffsflags
	int		iError;												// Letzter Fehler

	static const zchar *aRootName[]; 							// Root Namen
	static const HKEY   aRootKeys[]; 							// Root Schlssel


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
public:

	CRegKeys();													// Konstruktor
   ~CRegKeys();													// Destruktor

	bool Close ();												// Schliet Schlssel
	bool Open  ();												// ffnet Schlssel
	bool Open  (HKEY         hKey,								// ffnet Schlssel
				const zchar *pPath=0,
				int			 iMode=CRK_CREATE);
	bool Open  (const zchar *pPath,								// ffnet Schlssel
				int	         iMode=CRK_CREATE);
	bool Create(const zchar *pPath);							// Erzeugt Unterschlssel
	bool Create(HKEY         hKey =HKEY_CURRENT_USER, 			// Erzeugt Schlssel
				const zchar *pPath=0,int iExMode=0);
	bool Up	   (const zchar *pPath=CRK_NEXT,int iOnlyIfExist=0);// Pfad aufsteigen
	bool Down  ();												// Pfad aufabsteigen
	bool Jump  ();												// Pfad weiterspringen
	bool Next  ();												// Nchsten Unterschlssel ffnen
	bool First ();												// Zum ersten Unterschlssel

	bool Get(float            &dVal,const zchar *pName=CRK_NEXT);
	bool Get(double           &dVal,const zchar *pName=CRK_NEXT);
	bool Get(		  int	  &iVal,const zchar *pName=CRK_NEXT);
	bool Get(unsigned int	  &iVal,const zchar *pName=CRK_NEXT);
	bool Get(		  long	  &iVal,const zchar *pName=CRK_NEXT);
	bool Get(unsigned long	  &iVal,const zchar *pName=CRK_NEXT);
	bool Get(		  zchar  **pVal,const zchar *pName=CRK_NEXT,DWORD dwType=REG_SZ);
	bool Get(         zcharu **pVal,const zchar *pName=CRK_NEXT,DWORD dwType=REG_SZ);
	bool Get(		  void   **pVal,const zchar *pName=CRK_NEXT,DWORD dwType=REG_BINARY);
	bool Get(		  zchar   *pVal,const zchar *pName=CRK_NEXT);
	bool Get(         zcharu  *pVal,const zchar *pName=CRK_NEXT);
	bool Get(		  zchar	  *pVal,DWORD dwLen,const zchar *pName=CRK_NEXT);
	bool Get(         zcharu  *pVal,DWORD dwLen,const zchar *pName=CRK_NEXT);
	bool Get(		  void	  *pVal,DWORD dwLen,const zchar *pName=CRK_NEXT,DWORD dwType=REG_BINARY);
	bool GetEx(		  void	  *pVal,DWORD dwLen,const zchar *pName=CRK_NEXT,DWORD dwType=REG_BINARY);
	bool GetEx(		  void   **pVal,const zchar *pName=CRK_NEXT,DWORD dwType=REG_BINARY);


	bool Set(double           &dVal,            const zchar *pName);
	bool Set(float            &fVal,            const zchar *pName);
	bool Set(int			   iVal,            const zchar *pName);
	bool Set(const zchar      *pVal,            const zchar *pName);
	bool Set(const zcharu     *pVal,            const zchar *pName);
	bool Set(const void       *pVal,DWORD dwLen,const zchar *pName,DWORD dwType=REG_BINARY);
	bool SetEx(const void     *pVal,DWORD dwLen,const zchar *pName,DWORD dwType=REG_BINARY);

	bool GetMulti(			zchar  *pVal,DWORD dwLen,const zchar *pName=CRK_NEXT);
	bool GetMulti(			zchar **pVal		    ,const zchar *pName=CRK_NEXT);
	bool GetMulti(CStringChain     *pChain		    ,const zchar *pName=CRK_NEXT);

	bool SetMulti(const		zchar  *pVal		    ,const zchar *pName);
	bool SetMulti(const		zchar  *pVal,DWORD dwLen,const zchar *pName);
	bool SetMulti(const CStringChain *pChain		,const zchar *pName,int iStart=0,int iStop=0x3FFFFFFF);


#if defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	bool Get(CString &sStr,const zchar *pName=CRK_NEXT);
	bool Set(CString  sStr,const zchar *pName=CRK_NEXT);
#endif

	bool Del    (const zchar *pName=CRK_NEXT); 					// Wert lschen
	bool DelKey (const zchar *pName=CRK_NEXT); 					// Key	lschen

	bool Load	(const zchar *pPath,const zchar *pFilename);	// Zweig speichern
	bool Save	(const zchar *pFilename);						// Zweig speichern
	bool Replace(const zchar *pPath,							// Zweig austauschen
				 const zchar *pFilenameOld,
				 const zchar *pFilenameNew);

	DWORD	Type ();											// Ergibt Type	der Werte
	DWORD	Len  ();											// Ergibt Lnge der Werte
	HKEY	Key  ();											// Ergibt Aktuellen Schlssel
	zchar  *Name (); 											// Ergibt Name
	zchar  *Name (int &iLen); 									// Ergibt Name mit Lnge
	int		Error();											// Ergibt letzten Fehler
	int		Path(zchar *pMem,int iLen,int iMode=0);				// Ergibt Pfad
	int		GetLength(const zchar *pName=CRK_NEXT);				// Ergint die Lnge eines Wertes

	int		KeyCount   (); 										// Ergibt Anzahl der SubKeys
	int		ValueCount ();										// Ergibt Werte Anzahl
	zchar  *ValueName  (                       int iNr=-1);		// Ergibt Wert-Namen
	zchar  *ValueName  (int    *pSize,         int iNr=-1);		// Ergibt Wert-Namen
	int		ValueName  (zchar **pName,         int iNr=-1);		// Ergibt Wert-Namen
	int		ValueName  (zchar  *pName,int iLen,int iNr=-1);		// Ergibt Wert-Namen
	zchar  *KeySubName (                       int iNr=-1);		// Ergibt SubKey-Namen
	zchar  *KeySubName (int    *pSize,         int iNr=-1);		// Ergibt SubKey-Namen
	int		KeySubName (zchar **pName,         int iNr=-1); 	// Ergibt SubKey-Namen
	int		KeySubName (zchar  *pName,int iLen,int iNr=-1);		// Ergibt SubKey-Namen
	zchar  *KeyName    (                       int iNr=-1); 	// Ergibt Pfadteilenamen
	zchar  *KeyName    (int    *pSize,         int iNr=-1); 	// Ergibt Pfadteilenamen
	int		KeyName    (zchar **pName,         int iNr=-1); 	// Ergibt Pfadteilenamen
	int		KeyName    (zchar  *pName,int iLen,int iNr=-1);		// Ergibt Pfadteilenamen
	int		KeyIndex   (					   int iNr=-1);		// Setzte den Index eines Pfadteilenames

	int		RegPath    (zchar *pPath,int iLen,const zchar *p=0);// Ergibt Standartpfad
	int		Level      ();										// Ergibt Ebene

protected:

	int		GetInitKey(HKEY &hKey,const zchar *pPath); 			// Init Key holen

};


//*****************************************************************************
//*
//*		inline Funktionen
//*
//*****************************************************************************
#ifndef		_DEBUG

inline bool   CRegKeys::Open (const zchar *pPath,int iMode){return Open(0,pPath,iMode);}
inline bool   CRegKeys::Open (){return Open(HKEY_CURRENT_USER,0,CRK_CREATE);}
inline bool   CRegKeys::Jump (){Down(); return Up(CRK_NEXT);}
inline bool   CRegKeys::Next (){        return Up(CRK_NEXT);}
inline int    CRegKeys::Level(){        return iLevel      ;}


inline bool   CRegKeys::SetMulti(const zchar *pVal,DWORD dwLen,const zchar *pName){return Set((void*)pVal,dwLen                              ,pName,REG_MULTI_SZ);}
inline bool   CRegKeys::Set(const    zchar   *pVal,const zchar *pName){return Set((const void*) pVal,(int)strlenz(        pVal)*sizeof(zchar),pName,REG_SZ      );}
inline bool   CRegKeys::Set(const    zcharu  *pVal,const zchar *pName){return Set((const void*) pVal,(int)strlenz((zchar*)pVal)*sizeof(zchar),pName,REG_SZ      );}
inline bool   CRegKeys::Set(int               iVal,const zchar *pName){return Set((const void*)&iVal,     sizeof (        iVal)              ,pName,REG_DWORD   );}
inline bool   CRegKeys::Set(float            &fVal,const zchar *pName){double dVal=fVal;return Set(dVal,pName);}

inline bool   CRegKeys::GetMulti(    zchar  **pVal,const zchar *pName            ){return Get((void**) pVal                             ,pName,REG_MULTI_SZ);}
inline bool   CRegKeys::Get(         int     &iVal,const zchar *pName            ){return Get((void* )&iVal,sizeof(iVal)                ,pName,REG_DWORD   );}
inline bool   CRegKeys::Get(unsigned int     &uVal,const zchar *pName            ){return Get((void* )&uVal,sizeof(uVal)                ,pName,REG_DWORD   );}
inline bool   CRegKeys::Get(         long    &lVal,const zchar *pName            ){return Get((void* )&lVal,sizeof(lVal)                ,pName,REG_DWORD   );}
inline bool   CRegKeys::Get(unsigned long    &uVal,const zchar *pName            ){return Get((void* )&uVal,sizeof(uVal)                ,pName,REG_DWORD   );}
inline bool   CRegKeys::Get(         zchar   *pVal,const zchar *pName            ){return Get((void* ) pVal,260*sizeof(zchar)           ,pName,REG_SZ      );}
inline bool   CRegKeys::Get(         zcharu  *pVal,const zchar *pName            ){return Get((void* ) pVal,260*sizeof(zchar)           ,pName,REG_SZ      );}
inline bool   CRegKeys::Get(         zchar  **pVal,const zchar *pName,DWORD uType){return Get((void**) pVal,                             pName,uType       );}
inline bool   CRegKeys::Get(         zcharu **pVal,const zchar *pName,DWORD uType){return Get((void**) pVal,                             pName,uType       );}
inline bool   CRegKeys::Get(         zchar   *pVal,DWORD dwLen,const zchar *pName){return Get((void* ) pVal,dwLen                       ,pName,REG_SZ      );}
inline bool   CRegKeys::Get(         zcharu  *pVal,DWORD dwLen,const zchar *pName){return Get((void* ) pVal,dwLen                       ,pName,REG_SZ      );}
inline bool   CRegKeys::GetMulti(    zchar   *pVal,DWORD dwLen,const zchar *pName){return Get((void* ) pVal,dwLen                       ,pName,REG_MULTI_SZ);}

inline DWORD  CRegKeys::Type (){return  dwType   ;}
inline DWORD  CRegKeys::Len  (){return  dwLength ;}
inline HKEY   CRegKeys::Key  (){return  hKeyNow  ;}
inline int    CRegKeys::Error(){return  iError   ;}
inline zchar *CRegKeys::Name (){return  cName    ;}
inline zchar *CRegKeys::Name (int &iLen){iLen=dwNameLen;return cName;}

#if defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

inline bool CRegKeys::Set(CString  sStr,const zchar *pName){return Set((const void*)((LPCTSTR)sStr),sStr.GetLength(),pName,REG_SZ);}

#endif
#endif


#ifdef		strlenz
#undef 		strlenz
#endif

#ifdef		zcharu
#undef 		zcharu
#endif

#ifdef		Z
#undef 		Z
#endif

#endif
