//*****************************************************************************
//*
//*
//*		RegText.h
//*
//*
//*****************************************************************************
//
//	In/Exportieren von Registry-Eintrgen in Textdateien
//
//	Funktionen:
//
//		bool Export(char *pFile,HKEY hKey,char *pPath="",int iMode=0)
// 		bool Export(char *pFile,          char *pPath   ,int iMode=0)
// 		bool Import(char *pFile)
//
#ifndef	AFX_REGTEXT_H__462B1A85_4F34_11D3_903E_F8F626B70A66__INCLUDED_
#define AFX_REGTEXT_H__462B1A85_4F34_11D3_903E_F8F626B70A66__INCLUDED_

#if		   _MSC_VER >= 1000
#pragma		once
#endif

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#ifndef	 __AFX_H__
	#include <Afx.h>
	#endif
#else
	#include <windows.h>
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif


#include	"RegKeys.h"
#include	"TextBuffer.h"
#include	"MemFunctions.h"
#include	"StringFunctions.h"


#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#else
#define 	Z(a)		a
#define 	zchar		char
#endif


#define 	CRT_NEW			0						// Neue Datei erzeugen
#define 	CRT_ADD			1						// An bestehende Datei anfgen



//*****************************************************************************
//*
//*		Klasse CRegText
//*
//*****************************************************************************
class CRegText
{
public:

	CRegText();
   ~CRegText();

	bool			Export(const zchar *pFile,HKEY hKey,const zchar *pPath=Z(""),int iMode=0);
	bool			Export(const zchar *pFile,          const zchar *pPath      ,int iMode=0);
	bool			Import(const zchar *pFile);
	bool			Import(int iLen,const char    *pMem);
	bool			Import(int iLen,const wchar_t *pMem);
	bool			Import(int iLen,const void    *pMem,int iFormat);
	
	static inline void SetVarProc(char   *(_cdecl*)(const char   *));
	static inline void SetVarProc(wchar_t*(_cdecl*)(const wchar_t*));
	 
protected:

	bool			Export   (const zchar *pFile,int iMode);// Schlssel exportieren
	bool			Close    ();							// Datei schliesen
	bool			Import   ();							// Registry-Zweig importieren
	void			WriteKey ();							// Key Eintrge speichern
	int				ReadAdd  (int iCount);					// Datei lesen
	int				GetFormat(const char *pPtr,int iLen);	// Das Dateiformat bestimmen
	zchar		   *LineCfg  (zchar *pLine,int iMax=0xFFFFF);

	static int		MemToStr(zchar *pStr,int iMax,const zchar *pMem,int iLen);
	static int		StrToMem(zchar *pMem,int iLen,const zchar *pStr);

//*****************************************************************************
//*
//*     Variabeln
//*
//*****************************************************************************
protected:

	bool			m_bEofFlag;								// Ende der Datei erreicht
	bool			m_bIsOpen;								// Ist eine Datei geffnet
	int				m_iFileLen;								// Dateilnge
	int				m_iFilePos;								// Datei Leseposition
															
	CRegKeys		m_sKey;									// Registry-Schlssel
	CTextBuffer		m_sStream;								// Dateipuffer
	zchar		   *m_pTempText;							// Puffer fr LineCfg
	int				m_iTempSize;							// Puffergre

															// Funktion fr Variabelnamen
	static char    *(_cdecl *m_pGetVarNameA)(const char   *); 	
	static wchar_t *(_cdecl *m_pGetVarNameW)(const wchar_t*); 	

};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline void CRegText::SetVarProc(char   * (_cdecl   *pProc)(const char   *)){m_pGetVarNameA=pProc;}
inline void CRegText::SetVarProc(wchar_t* (_cdecl   *pProc)(const wchar_t*)){m_pGetVarNameW=pProc;}
inline bool CRegText::Import(int iLen,const char    *pMem ){return Import(iLen,pMem,0);}
inline bool CRegText::Import(int iLen,const wchar_t *pMem ){return Import(iLen,pMem,1);}


#endif
