//*****************************************************************************
//*
//*
//*		ResourceHacker.h
//*
//*
//*****************************************************************************
#ifndef 	__RESOURCEHACKER_H__
#define 	__RESOURCEHACKER_H__


#include	"DataField.h"

typedef struct
	{
	unsigned		uPeLength;						// Lnge der PE-Datei
	unsigned		uPeOffset;						// Offset des PE-Headers
	unsigned		uPeHeader;						// Gre des PE-Headers
	unsigned		uSize;							// Gre der Resurcen in Byte
	unsigned		uIs64Bit;						// Ist es eine 64-Bit Datei
	unsigned		uOffset;						// Offset der Resurcen in pFileData
	unsigned		uDelta;							// Virtuelle Adressen auf Offsets umrechen
	unsigned		uDirPos;						// Offset zum DataDirectory
	unsigned		uRscPos;						// Offset zum ".rsrc" Abschnitt
	unsigned		uCodePage;						// Ist die normale CodePage
	unsigned		uFileAlign;						// Aligment der EXE-Datei
	unsigned char  *pFileData;						// Zeiger auf die Dateidaten
	CDataList		sResList;						// Liste mit neuen Resourcen
	CDataPointer 	sMemList;						// Mit diversen Speicherbereichen
	}ResourceData;

#define 	  RES_DEFAULT	((LPCTSTR)0x0000FFFF)
#define 	  RES_NONE		((LPCTSTR)0x0000FFFE)
#define 	  RES_FILE		((UINT   )0xFFFF0000)

ResourceData *ResourceLoad  (LPCTSTR pFilename,int *pError=0);
int			  ResourceSave  (ResourceData *pResource,LPCTSTR pFilename);
void		  ResourceFree  (ResourceData *pResource);
int 		  ResourceFind  (ResourceData *pResource,LPCTSTR *pNames,unsigned uLevels);
LPBYTE		  ResourceEntry (ResourceData *pResource,LPCTSTR *pNames,unsigned uLevels,int *pSize=0);
int 		  ResourceDelete(ResourceData *pResource,LPCTSTR *pNames,unsigned uLevels);
int 		  ResourceInsert(ResourceData *pResource,LPCTSTR *pNames,unsigned uLevels,LPCVOID pData,UINT uSize);

inline int 	  ResourceFind  (ResourceData *pResource,LPCTSTR  pName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT){LPCTSTR aList[3]={pName1,pName2,pName3}; return ResourceFind(pResource,aList,3);}
inline int 	  ResourceFind  (ResourceData *pResource,UINT     uName1,UINT    uName2            ,UINT    uName3            ){return ResourceFind(pResource,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)uName3);}
inline int 	  ResourceFind  (ResourceData *pResource,UINT     uName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT){return ResourceFind(pResource,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)pName3);}
inline int 	  ResourceFind  (ResourceData *pResource,UINT     uName1,LPCTSTR pName2            ,UINT    uName3            ){return ResourceFind(pResource,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)uName3);}
inline int 	  ResourceFind  (ResourceData *pResource,UINT     uName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT){return ResourceFind(pResource,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)pName3);}
inline int 	  ResourceFind  (ResourceData *pResource,LPCTSTR  pName1,UINT    uName2            ,UINT    uName3            ){return ResourceFind(pResource,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)uName3);}
inline int 	  ResourceFind  (ResourceData *pResource,LPCTSTR  pName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT){return ResourceFind(pResource,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)pName3);}
inline int 	  ResourceFind  (ResourceData *pResource,LPCTSTR  pName1,LPCTSTR pName2            ,UINT    uName3            ){return ResourceFind(pResource,(LPCTSTR)pName1,(LPCTSTR)pName2,(LPCTSTR)uName3);}

inline LPBYTE ResourceEntry (ResourceData *pResource,LPCTSTR  pName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT,int *pSize=0){LPCTSTR aList[3]={pName1,pName2,pName3}; return ResourceEntry(pResource,aList,3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,UINT     uName1,UINT    uName2            ,UINT    uName3            ,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)uName3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,UINT     uName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)pName3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,UINT     uName1,LPCTSTR pName2            ,UINT    uName3            ,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)uName3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,UINT     uName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)pName3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,LPCTSTR  pName1,UINT    uName2            ,UINT    uName3            ,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)uName3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,LPCTSTR  pName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)pName3,pSize);}
inline LPBYTE ResourceEntry (ResourceData *pResource,LPCTSTR  pName1,LPCTSTR pName2            ,UINT    uName3            ,int *pSize=0){return ResourceEntry(pResource,(LPCTSTR)pName1,(LPCTSTR)pName2,(LPCTSTR)uName3,pSize);}

inline int 	  ResourceDelete(ResourceData *pResource,LPCTSTR  pName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT){LPCTSTR aList[3]={pName1,pName2,pName3}; return ResourceDelete(pResource,aList,3);}
inline int 	  ResourceDelete(ResourceData *pResource,UINT     uName1,UINT    uName2            ,UINT    uName3            ){return ResourceDelete(pResource,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)uName3);}
inline int 	  ResourceDelete(ResourceData *pResource,UINT     uName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT){return ResourceDelete(pResource,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)pName3);}
inline int 	  ResourceDelete(ResourceData *pResource,UINT     uName1,LPCTSTR pName2            ,UINT    uName3            ){return ResourceDelete(pResource,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)uName3);}
inline int 	  ResourceDelete(ResourceData *pResource,UINT     uName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT){return ResourceDelete(pResource,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)pName3);}
inline int 	  ResourceDelete(ResourceData *pResource,LPCTSTR  pName1,UINT    uName2            ,UINT    uName3            ){return ResourceDelete(pResource,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)uName3);}
inline int 	  ResourceDelete(ResourceData *pResource,LPCTSTR  pName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT){return ResourceDelete(pResource,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)pName3);}
inline int 	  ResourceDelete(ResourceData *pResource,LPCTSTR  pName1,LPCTSTR pName2            ,UINT    uName3            ){return ResourceDelete(pResource,(LPCTSTR)pName1,(LPCTSTR)pName2,(LPCTSTR)uName3);}

inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,LPCTSTR  pName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT){LPCTSTR aList[3]={pName1,pName2,pName3}; return ResourceInsert(pResource,aList,3,pData,uSize);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,UINT     uName1,UINT    uName2            ,UINT    uName3            ){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)uName3);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,UINT     uName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)uName1,(LPCTSTR)uName2,(LPCTSTR)pName3);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,UINT     uName1,LPCTSTR pName2            ,UINT    uName3            ){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)uName3);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,UINT     uName1,LPCTSTR pName2=RES_DEFAULT,LPCTSTR pName3=RES_DEFAULT){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)uName1,(LPCTSTR)pName2,(LPCTSTR)pName3);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,LPCTSTR  pName1,UINT    uName2            ,UINT    uName3            ){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)uName3);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,LPCTSTR  pName1,UINT    uName2            ,LPCTSTR pName3=RES_DEFAULT){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)pName1,(LPCTSTR)uName2,(LPCTSTR)pName3);}
inline int 	  ResourceInsert(ResourceData *pResource,LPCVOID  pData,UINT uSize,LPCTSTR  pName1,LPCTSTR pName2            ,UINT    uName3            ){return ResourceInsert(pResource,pData,uSize,(LPCTSTR)pName1,(LPCTSTR)pName2,(LPCTSTR)uName3);}

#endif
