//*****************************************************************************
//*
//*
//*		Klasse	CShFind
//*
//*
//*****************************************************************************
#ifdef		UNICODE
#define    _UNICODE	1
#endif

#ifdef		 AZ_LIB_ADDAFX
#if		    _MSC_VER > 1299
#ifndef		 WINVER
#define		 WINVER 	0x0501
#endif
#endif
#include	<Afx.h>
#endif

#include	<stdio.h>
#include	<stdarg.h>
#include	<string.h>
#include	<tchar.h>
#include	<wchar.h>
#include	<string.h>
#include	<shlobj.h>
#include	<shlwapi.h>
#include	<lm.h>
#include 	<lmcons.h>
#include 	<lmshare.h>
#include	"ShFind.h"

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef	   _MSC_VER
#pragma		warning( disable :4996 )
#endif



// CSIDL_NETWORK

#define 		MAX_DEPTH		16			// Suchtiefe
#define 		LISTNEXT(x)		((LPITEMIDLIST)((LPBYTE)(x)+(x)->mkid.cb))
#define 		LISTADD(x,y)	((LPITEMIDLIST)((LPBYTE)(x)+(y)))
#define 		LISTNULL(x,y)	(*(DWORD*)((LPBYTE)(x)+(y)))=0;

LPSHELLFOLDER	CShFind::pDesktop	=0;
int				CShFind::iDesktopNr	=0;

 int _cdecl		strawcpy(wchar_t *pBuffer,const wchar_t *pText,int iLen,int iTextLen=0x1000000);

typedef struct										
	{
	NET_API_STATUS	uStatus;					// Status der letzen Anfrage
	PSHARE_INFO_502 pBuffer;					// Zeiger auf die Eintrge
	DWORD			dwCount;					// Anzahl der Eintrge im Puffer
	DWORD			dwTotal;					// Gesamtanzahl der Eintrge
	DWORD			dwResume;					// Suche fortsetzen
	DWORD			dwIndex;					// Aktueller Eintrag
	DWORD			dwPathSize;					// Lnge des Pfades
	WCHAR			wServerName[MAX_PATH];		// Aktueller Server-Pfad
	}NetInfo;


//*****************************************************************************
//*
//*		FindFirstNetwork
//*
//*****************************************************************************
//	Beginnt eine Suche nach den Shares einer Netztwerksadresse
//	pServer		: Ist der Name des Servers ("ax-pc36", "\\ax-pc-36" oder "\\ax-pc-36\..."
//	Ergibt ein Handle mit den Suchdaten oder NULL bei einem Fehler.
HANDLE FindFirstNetwork(LPCTSTR pServer)
{
NetInfo		   *pHandle;
int				iPos;



	if(!pServer)return NULL;

	if(pServer[0]=='\\' || pServer[0]=='/')
	if(pServer[1]=='\\' || pServer[1]=='/')
		{
		pServer += 2;
		}

	for(iPos=0;pServer[iPos];iPos++)
		{
		if(pServer[iPos]=='\\')break;
		if(pServer[iPos]=='/' )break;
		}
		
	if(!iPos || iPos>64)return NULL;

		pHandle	= new NetInfo;
	if(!pHandle)return NULL;

	#ifdef UNICODE
	
	memcpy(pHandle->wServerName+2,pServer,iPos*2);
	
	#else
	
		iPos=MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,pServer,iPos,pHandle->wServerName+2,64);
	if(!iPos)
		{
		delete pHandle;
		return NULL;
		}

	#endif


	pHandle->wServerName[0] = '\\';
	pHandle->wServerName[1] = '\\';
	pHandle->dwPathSize		= iPos+3;
	pHandle->pBuffer		= 0;				// Zeiger auf die Eintrge
	pHandle->dwCount		= 0;				// Anzahl der Eintrge im Puffer
	pHandle->dwTotal		= 0;				// Gesamtanzahl der Eintrge
	pHandle->dwResume		= 0;				// Suche fortsetzen
	pHandle->dwIndex		= 0;				// Aktueller Eintrag

	#if _MSC_VER >= 0x0514
	pHandle->uStatus = NetShareEnum((LMSTR )(pHandle->wServerName+2),502,(LPBYTE *)&pHandle->pBuffer,0xFFFFFFFF,&pHandle->dwCount,&pHandle->dwTotal,&pHandle->dwResume);
	#else
	pHandle->uStatus = NetShareEnum((TCHAR*)(pHandle->wServerName+2),502,(LPBYTE *)&pHandle->pBuffer,0xFFFFFFFF,&pHandle->dwCount,&pHandle->dwTotal,&pHandle->dwResume);
	#endif

	if(pHandle->uStatus!=ERROR_SUCCESS && pHandle->uStatus!=ERROR_MORE_DATA)
		{
		delete pHandle;
		return NULL;
		}


return pHandle;
}


//*****************************************************************************
//*
//*		FindNextNetwork
//*
//*****************************************************************************
//	Holt den nchsten Namen einer Suche nach Shares.
//	hHandle		: Ist das Handle der Suche
//	pShare		: Ist der Puffer fr den Namen
//	iSize		: Ist die Puffergre in Zeichen
//	Ergibt die Lnge des Share-Namens oder 0 am Ende.
INT FindNextNetwork(HANDLE hHandle,LPTSTR pShare,INT iSize)
{
NetInfo		   *pHandle=(NetInfo*)hHandle;
LPCWSTR			pText;
LPWSTR			pName;
DWORD			uAttr;
int				iLen;


	if(iSize<=0)return 0;

	*pShare = 0;

	if(!pHandle)return 0;

	pName	= pHandle->wServerName;
	pName  += pHandle->dwPathSize; 


	if(pHandle->dwIndex>=pHandle->dwCount)		// Daten in den Puffer nachladen	
		{
Retry:	if(pHandle->pBuffer)
			{
			NetApiBufferFree(pHandle->pBuffer);
			pHandle->pBuffer = NULL;
			
			if(pHandle->uStatus!=ERROR_MORE_DATA)
				{
				return 0;
				}
			}

		pName[-1] = 0;

		#if _MSC_VER >= 0x0514
		pHandle->uStatus = NetShareEnum((LMSTR )(pHandle->wServerName+2),502,(LPBYTE *)&pHandle->pBuffer,0xFFFFFFFF,&pHandle->dwCount,&pHandle->dwTotal,&pHandle->dwResume);
		#else
		pHandle->uStatus = NetShareEnum((TCHAR*)(pHandle->wServerName+2),502,(LPBYTE *)&pHandle->pBuffer,0xFFFFFFFF,&pHandle->dwCount,&pHandle->dwTotal,&pHandle->dwResume);
		#endif

		if(pHandle->uStatus!=ERROR_SUCCESS && pHandle->uStatus!=ERROR_MORE_DATA)
			{
			pHandle->dwIndex = 0;
			pHandle->dwCount = 0;
			return 0;
			}
		}
		
		
	pName[-1] = '\\';

	
	for(;;pHandle->dwIndex++)					// Suche nchstes Verzeichniss
		{
		if(pHandle->dwIndex>=pHandle->dwCount)goto Retry;

		pText = (LPCWSTR)pHandle->pBuffer[pHandle->dwIndex].shi502_netname;

		wcsncpy(pName,pText,MAX_PATH-pHandle->dwPathSize);
		iLen = wcslen(pName);

		if(iLen>1 && pName[iLen-1]=='$')
			{
			continue;
			}

		
		   uAttr = GetFileAttributesW(pHandle->wServerName);
		if(uAttr==0xFFFFFFFF)continue;
		if(uAttr&FILE_ATTRIBUTE_DIRECTORY)
			{
			pHandle->dwIndex++;
			break;
			}
		}
		
	#ifdef UNICODE
	
	iLen = strawcpy(pShare,pName,iSize);
	
	#else
	
	iLen = WideCharToMultiByte(CP_ACP,0,pText,-1,pShare,iSize,NULL,NULL);
	
	#endif


return iLen;
}

//*****************************************************************************
//*
//*		FindCloseNetwork
//*
//*****************************************************************************
//	Schliet einen Suche nach Shares.
//	hHandle		: Ist das Handle der Suche
//	Ergibt TRUE wenn ok oder FALSE bei einem Fehler
BOOL FindCloseNetwork(HANDLE hHandle)
{
NetInfo		   *pHandle=(NetInfo*)hHandle;


	if(!pHandle)return FALSE;

	if(pHandle->pBuffer)
		{
		NetApiBufferFree(pHandle->pBuffer);
		pHandle->pBuffer = NULL;
		}


	pHandle->dwCount = 0;

	delete pHandle;



return TRUE;
}


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CShFind::CShFind( )
{
	uAttrib = 0;
	pFolder = 0;
	pEnum   = 0;
	pItem   = 0;
	pList   = 0;
	pSub    = 0;

	iDesktopNr++;
}

CShFind::CShFind(int Folder)
{
	uAttrib = 0;
	pFolder = 0;
	pEnum   = 0;
	pItem   = 0;
	pList   = 0;
	pSub    = 0;

	iDesktopNr++;
	Init(Folder);
}

CShFind::CShFind(const CShFind &sShf)
{
	uAttrib = 0;
	pFolder = 0;
	pEnum   = 0;
	pItem   = 0;
	pList   = 0;
	pSub    = 0;

	iDesktopNr++;

	Init(sShf);
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CShFind::~CShFind( )
{

	iDesktopNr--;


	if(pList  )CoTaskMemFree(pList);
	if(pEnum  )pEnum  ->Release();
	if(pFolder)pFolder->Release();
	if(pDesktop && iDesktopNr<=0)
		{
		pDesktop->Release();
		pDesktop=0;
		}

	if(iDesktopNr<0)iDesktopNr=0;

}


//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
BOOL CShFind::Clear()
{


	if(pList  ){CoTaskMemFree(pList);pList  =0;}
	if(pEnum  ){pEnum  ->Release(  );pEnum  =0;}
	if(pFolder){pFolder->Release(  );pFolder=0;}

	uAttrib	= 0;
	pItem	= 0;
	pSub	= 0;

	if(!pDesktop)						// ShellFolder-Interface des Desktops ermitteln
		{
		if(SHGetDesktopFolder(&pDesktop)!=ERROR_SUCCESS)return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		Next
//*
//*****************************************************************************
//	Den nchsten Eintrag im Sympolraum suchen.
//	Ergibt TRUE wenn eine Eintrag gefunden wurde sonst FALSE.
BOOL CShFind::Next()
{
DWORD			uFetched;
HRESULT			uResult;
LPITEMIDLIST	pTemp;



	if(!pEnum || !pFolder)return FALSE;

	   pItem   = 0;
	   uResult = pEnum->Next(1,&pTemp,&uFetched);
	if(uResult!=NOERROR)return FALSE;

	SetItemList(pTemp);

	   uAttrib = 0xFFFFFFFF;
	   uResult = pFolder->GetAttributesOf(1,(const struct _ITEMIDLIST**)&pItem,&uAttrib);
	if(uResult!=NOERROR)uAttrib=0;


return TRUE;
}



//*****************************************************************************
//*
//*		Init
//*
//*****************************************************************************
//	Eine neue Wurzel von einem spezial Folder erzeugen.
//	iFolder		: Ist die nummer des Folders
//					CSIDL_COMMON_STARTUP
//					CSIDL_DESKTOP
//					...
//	Ergibt TRUE wenn eine neue Wurzel erzeugt wurde.
BOOL CShFind::Init(int iFolder)
{
HRESULT			uResult;
LPITEMIDLIST	pTemp;



	if(!Clear())return FALSE;							// Alles zurck setzen
	if(SHGetSpecialFolderLocation(NULL,iFolder,&pTemp)!=NOERROR)return FALSE;


	   uResult =pDesktop->BindToObject(pTemp,NULL,IID_IShellFolder,(LPVOID*)&pFolder);
	if(uResult!=NOERROR)return FALSE;

	iListPos = pTemp->mkid.cb;
	iListLen = iListPos+260;
	pList    = (LPITEMIDLIST)CoTaskMemAlloc(iListLen);	// Speicher allokieren

	CopyMemory(pList,pTemp,iListPos);
	CoTaskMemFree(pTemp);
	LISTNULL(pList,iListPos);

	pItem	= 0;
	uResult = pFolder->EnumObjects(NULL,SHCONTF_FOLDERS|SHCONTF_NONFOLDERS|SHCONTF_INCLUDEHIDDEN,&pEnum);



return (uResult==ERROR_SUCCESS)? TRUE:FALSE;
}




//*****************************************************************************
//*
//*		Init
//*
//*****************************************************************************
//	Eine neue Wurzel von einem anderen ShFind-Objekt erzeugen.
//	sShf		: Ist das Objekt von dem die Wurzel erzeugt wird.
//	Ergibt TRUE wenn eine neue Wurzel erzeugt wurde.
BOOL CShFind::Init(const CShFind &sShf)
{
DWORD			uAttrib;
HRESULT			uResult;


	if(!Clear())return FALSE;							// Alles zurck setzen
	if(!sShf.pFolder || !sShf.pItem)
		{
		return FALSE;
		}

	   uAttrib = SFGAO_FOLDER;
	   uResult = sShf.pFolder->GetAttributesOf(1,(const struct _ITEMIDLIST **)&(sShf.pItem),&uAttrib);
	if(uResult!=NOERROR)
		{
		return FALSE;
		}

	iListPos = sShf.iListPos+sShf.pItem->mkid.cb;
	iListLen = iListPos+260;
	pList    = (LPITEMIDLIST)CoTaskMemAlloc(iListLen);	// Speicher allokieren

	CopyMemory(pList,sShf.pList,iListPos);
	LISTNULL  (pList,iListPos);
	pItem	 = 0;


	if(!(uAttrib&SFGAO_FOLDER))
		{
		return FALSE;
		}

	   uResult =sShf.pFolder->BindToObject(sShf.pItem,NULL,IID_IShellFolder,(LPVOID*)&pFolder);
	if(uResult!=NOERROR)return FALSE;

	pSub	= &sShf;
	uResult =  pFolder->EnumObjects(NULL,SHCONTF_FOLDERS|SHCONTF_NONFOLDERS|SHCONTF_INCLUDEHIDDEN,&pEnum);



return (uResult==ERROR_SUCCESS)? TRUE:FALSE;
}



//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Speichert den Displaynamen in einem Puffer vom aktuellen Eintrag.
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens 80 Byte gro sein.
//	Ergibt TRUE wenn der Displaynamen gespeichert wurde.
BOOL CShFind::Name(LPTSTR pBuffer)
{
STRRET	sData;


	pBuffer[0]=0;


	if(!pFolder || !pItem)return FALSE;
	if( pFolder->GetDisplayNameOf(pItem,SHGDN_INFOLDER,&sData)!=NOERROR)return FALSE;


	switch(sData.uType)					// Typ des STRRET-Strings ermitteln
			{
	case STRRET_WSTR:                   // Wide-Characters

			#ifdef UNICODE
			wcsncpy(sData.pOleStr,pBuffer,256);
			#else
			WideCharToMultiByte(CP_ACP,0,sData.pOleStr,-1,pBuffer,256,0,0);
			#endif
			break;

	case STRRET_OFFSET:					// Text ist im PIDL enthalten

			#ifdef UNICODE
			MultiByteToWideChar(CP_ACP,0,((LPCSTR)pItem)+sData.uOffset,-1,pBuffer,256);
			#else
			strncpy(pBuffer,((LPCSTR)pItem)+sData.uOffset,256);
			#endif
			break;

	case STRRET_CSTR:					// Normaler C-String

			#ifdef UNICODE
			MultiByteToWideChar(CP_ACP,0,sData.cStr,-1,pBuffer,256);
			#else
			strncpy(pBuffer,sData.cStr,256);
			#endif
			break;
			}


return TRUE;
}


//*****************************************************************************
//*
//*		Path
//*
//*****************************************************************************
//	Speichert den reallen Dateipfad in einem Puffer vom aktuellen Eintrag
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens MAX_PATH Byte gro sein.
//	Ergibt TRUE wenn der Pfad der dazugehrenten Datei gespeichert wurde.
//	Existiert die Datei nicht als Pfad ergibt die Funktion FALSE.
BOOL CShFind::Path(LPTSTR pBuffer)
{


	pBuffer[0]=0;

	if(!(uAttrib&SFGAO_FILESYSTEM) || !pItem)				// Existiert der Pfad als Datei
		{
		return FALSE;
		}


return SHGetPathFromIDList(pList,pBuffer);
}

//*****************************************************************************
//*
//*		Link
//*
//*****************************************************************************
//	Speichert den Link-Pfad in einem Puffer vom aktuellen Eintrag
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens MAX_PATH Byte gro sein.
//	Ergibt TRUE wenn der Pfad der dazugehrenten Datei gespeichert wurde.
//	Existiert die Datei nicht als Pfad ergibt die Funktion FALSE.
BOOL CShFind::Link(LPTSTR pBuffer)
{
LRESULT		lResult;
IShellLink *pLink;


	pBuffer[0]=0;

	if(!(uAttrib&SFGAO_LINK) || !pItem)							// Existiert der Link als Datei
		{
		return FALSE;
		}

	pLink	= NULL;
	lResult	= pFolder->GetUIObjectOf(NULL,1,(LPCITEMIDLIST*)&pItem,IID_IShellLink,NULL,(void**)&pLink);

	if(!lResult && pLink)
		{
		lResult = pLink->GetPath(pBuffer,MAX_PATH,NULL,0);
		pLink->Release();
		}


return (lResult)? FALSE:TRUE;
}

//*****************************************************************************
//*
//*		Type
//*
//*****************************************************************************
//	Speichert den Dateitypenamen in einem Puffer vom aktuellen Eintrag.
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens 80 Byte gro sein.
//	Ergibt TRUE wenn der Dateitypenamen gespeichert wurde.
BOOL CShFind::Type(LPTSTR pBuffer)
{
LRESULT		lResult;
SHFILEINFO	sSfi;

	if(!pItem)return FALSE;

		lResult=SHGetFileInfo((LPCTSTR)pList,0,&sSfi,sizeof(sSfi),SHGFI_PIDL|SHGFI_TYPENAME);
	if(!lResult){pBuffer[0]=0;return FALSE;}

	_tcsncpy(pBuffer,sSfi.szTypeName,80);


return TRUE;
}

//*****************************************************************************
//*
//*		SetItemList
//*
//*****************************************************************************
BOOL CShFind::SetItemList(LPITEMIDLIST pItemPtr)
{
LPITEMIDLIST	pTemp;
int				iLen;


	if(!pList)return FALSE;									// Liste vorhanden ?

	   iLen=pItemPtr->mkid.cb;
	if(iLen+iListPos+4>iListLen)							// Ist Liste gro genug ?
		{
		iListLen = iListPos+iLen+4;
		pTemp	 = (LPITEMIDLIST)CoTaskMemAlloc(iListLen);	// Speicher allokieren

		CopyMemory(pTemp,pList,iListPos);
		CoTaskMemFree(pList);

		pList	 = pTemp;
		}

	pItem = LISTADD(pList,iListPos);
	CopyMemory(pItem,pItemPtr,iLen);
	CoTaskMemFree(pItemPtr);
	LISTNULL(pItem,iLen);


return TRUE;
}


//*****************************************************************************
//*
//*		GetIcon
//*
//*****************************************************************************
//	Die Systemicon-Nummer fr den aktuellen Eintrag auslesen.
//	iMode:	SHGFI_LARGEICON		Groe Icons
//			SHGFI_SMALLICON		Kleines Icon
//			SHGFI_OPENICON		Icon geffnet
//	Ergibt die Iconnummer bzw. -1 bei einem Fehler
int	CShFind::GetIcon(int iMode)
{
LRESULT		lResult;
SHFILEINFO	sSfi;


	if(!pList || !pItem)return -1;


	   lResult=SHGetFileInfo((LPCTSTR)pList,0,&sSfi,sizeof(sSfi),SHGFI_SYSICONINDEX|SHGFI_PIDL|iMode);
	if(lResult)return sSfi.iIcon;


return -1;
}


//*****************************************************************************
//*
//*		Free
//*
//*****************************************************************************
//	Den Speicher fr den aktuellen Eintrag freigeben.
//	Ergibt TRUE wenn ein Eintrag vorhanden war.
BOOL  CShItem::Free()
{


	if( pName){delete pName;pName=0;}
	if(!pList) return FALSE;

	CoTaskMemFree(pList);
	uAttrib	= 0;
	pList	= 0;


return TRUE;
}

//*****************************************************************************
//*
//*		GetIcon
//*
//*****************************************************************************
//	Die Systemicon-Nummer fr den aktuellen Eintrag auslesen.
//	iMode:	SHGFI_LARGEICON		Groe Icons
//			SHGFI_SMALLICON		Kleines Icon
//			SHGFI_OPENICON		Icon geffnet
//	Ergibt die Iconnummer bzw. -1 bei einem Fehler
int	CShItem::GetIcon(int iMode)
{
LRESULT		lResult;
SHFILEINFO	sSfi;


	if(!pList)return -1;

	   lResult=SHGetFileInfo((LPCTSTR)pList,0,&sSfi,sizeof(sSfi),SHGFI_SYSICONINDEX|SHGFI_PIDL|iMode);
	if(lResult)return sSfi.iIcon;


return -1;
}

//*****************************************************************************
//*
//*		Path
//*
//*****************************************************************************
//	Speichert den reallen Dateipfad in einem Puffer vom aktuellen Eintrag
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens MAX_PATH Byte gro sein.
//	Ergibt TRUE wenn der Pfad der dazugehrenten Datei gespeichert wurde.
//	Existiert die Datei nicht als Pfad ergibt die Funktion FALSE.
BOOL  CShItem::Path(LPTSTR pBuffer)
{
int		iOff;


	pBuffer[0]=0;

	if(!(uAttrib&SFGAO_FILESYSTEM) || !pList)				// Existiert der Pfad als Datei
		{
		return FALSE;
		}
															// Ist es ein Link
	if(pName && (uAttrib&(SFGAO_LINK|SFGAO_FILESYSTEM|SFGAO_FILESYSTEM))==(SFGAO_LINK|SFGAO_FILESYSTEM|SFGAO_FILESYSTEM))
		{
		iOff = (int)_tcslen(pName)+1;

		if(pName[iOff])
			{
			_tcsncpy(pBuffer,pName+iOff,MAX_PATH);
			return TRUE;
			}
		}


return SHGetPathFromIDList(pList,pBuffer);
}

//*****************************************************************************
//*
//*		Name
//*
//*****************************************************************************
//	Speichert den Displaynamen in einem Puffer vom aktuellen Eintrag.
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens 80 Byte gro sein.
//	Ergibt TRUE wenn der Displaynamen gespeichert wurde.
BOOL CShItem::Name(LPTSTR pBuffer)
{

	_tcsncpy(pBuffer,pName,MAX_PATH);


return TRUE;
}

//*****************************************************************************
//*
//*		Type
//*
//*****************************************************************************
//	Speichert den Dateitypenamen in einem Puffer vom aktuellen Eintrag.
//	pBuffer		: Ist der Zeiger auf den Puffer.
//				  Dieser muss mindestens 80 Byte gro sein.
//	Ergibt TRUE wenn der Dateitypenamen gespeichert wurde.
BOOL CShItem::Type(LPTSTR pBuffer)
{
LRESULT		lResult;
SHFILEINFO	sSfi;


		lResult=SHGetFileInfo((LPCTSTR)pList,0,&sSfi,sizeof(sSfi),SHGFI_PIDL|SHGFI_TYPENAME);
	if(!lResult){pBuffer[0]=0;return FALSE;}

	_tcsncpy(pBuffer,sSfi.szTypeName,80);


return TRUE;
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Holt einen Eintrag aus einem Objekt.
//	sShf	: Referenz auf das Objekt
//	Ergibt TRUE wenn eine Eintrag gefunden wurde sonst FALSE.
BOOL CShItem::Get(CShFind &sShf)
{
TCHAR	cName[MAX_PATH];
TCHAR	cPath[MAX_PATH];
LPBYTE	pPtr;
int		iLen;
int		iAdd;


	if(pList)Free();
	if(!sShf.pList)return FALSE;

	pPtr	= (LPBYTE)sShf.pList;
	iLen	=		  sShf.iListPos;
	iLen   += *(short*)(pPtr+iLen);
	iLen   += 4;


	pList	= (LPITEMIDLIST)CoTaskMemAlloc(iLen);			// Speicher allokieren
	CopyMemory(pList,pPtr,iLen);
	sShf.Name(cName);
	uAttrib = sShf.uAttrib;
															// Ist es ein Link
	if((uAttrib&(SFGAO_LINK|SFGAO_FILESYSTEM|SFGAO_FILESYSTEM))==(SFGAO_LINK|SFGAO_FILESYSTEM|SFGAO_FILESYSTEM))
		{
		sShf.Path(cPath);
		iAdd = (int)_tcslen(cPath);
		cPath[iAdd] = '\\';	iAdd++;
		cPath[iAdd] = 0;	iAdd++;
		}
	else{
		cPath[0] = 0;
		iAdd	 = 1;
		}

	iLen  = (int)_tcslen(cName)+1;							// Namen erzeugen
	pName = new TCHAR[iLen+iAdd];
	memcpy(pName     ,cName,iLen*sizeof(TCHAR));
	memcpy(pName+iLen,cPath,iAdd*sizeof(TCHAR));



return TRUE;
}

