//*****************************************************************************
//*
//*
//*		CShFind
//*
//*
//*****************************************************************************
#ifndef 	__SHFIND_H__
#define 	__SHFIND_H__

#ifndef		_WCHAR_T_DEFINED
#include	<wchar.h>
#endif

#include	<shlobj.h>
#include	<shellapi.h>

class CShItem;

#ifndef		SFGAO_STORAGE
#define 	SFGAO_STORAGE		0x00000008
#endif 	

HANDLE	FindFirstNetwork(LPCTSTR pServer);
BOOL	FindCloseNetwork(HANDLE  hHandle);
INT		FindNextNetwork (HANDLE  hHandle,LPTSTR pShare,INT iSize);

//*****************************************************************************
//*
//*		Klasse CShFind
//*
//*****************************************************************************
class CShFind
{

public:

	CShFind();
	CShFind(int Folder);
	CShFind(const CShFind &sShf);
   ~CShFind();

	BOOL 	Init();
	BOOL 	Init(int Folder);
	BOOL 	Init(const CShFind &sShf);
	BOOL 	Next();	
	BOOL 	Reset();	
	BOOL 	Name(LPTSTR pBuffer);
	BOOL	Path(LPTSTR pBuffer);
	BOOL	Link(LPTSTR pBuffer);
	BOOL	Type(LPTSTR pBuffer);
	ULONG	Attributes   ()const;
	BOOL	IsLink       ()const;
	BOOL	IsFolder     ()const;
	BOOL	IsReadOnly   ()const;
	BOOL	IsFilesystem ()const;
	BOOL	IsHasRealDirs()const;
	int		GetIcon     (int iMode=SHGFI_SMALLICON);
	int		GetSmallIcon(int iMode=0);
	int		GetLargeIcon(int iMode=0);


protected:

	BOOL	Clear();
	BOOL	SetItemList(LPITEMIDLIST pItemPtr);

	const	CShFind		   *pSub;
			ULONG			uAttrib;
			int				iListLen;
			int				iListPos;
			LPITEMIDLIST	pItem;
			LPITEMIDLIST	pList;
			LPENUMIDLIST	pEnum;             
			LPSHELLFOLDER	pFolder;
	static	LPSHELLFOLDER	pDesktop;
	static	int				iDesktopNr;

	friend class CShItem;
};



//*****************************************************************************
//*
//*		Klasse CShItem
//*
//*****************************************************************************
class CShItem
{
public:

	CShItem(){uAttrib=0;pList=0;pName=0;}
	CShItem(CShFind &sShf){uAttrib=0;pList=0;pName=0;Get(sShf);}
   ~CShItem(){Free();}

	int		GetIcon     (int iMode=SHGFI_SMALLICON);
	int		GetSmallIcon(int iMode=0);
	int		GetLargeIcon(int iMode=0);

	LPTSTR 	Name();
	BOOL 	Name(LPTSTR pBuffer);
	BOOL	Path(LPTSTR pBuffer);
	BOOL	Type(LPTSTR pBuffer);
	BOOL	Get (CShFind &sShf);
	ULONG	Attributes  ()const;
	BOOL	IsFilesystem()const;
	BOOL	IsReadOnly  ()const;
	BOOL	IsFolder    ()const;
	BOOL	IsLink      ()const;
	BOOL	Free();

protected:
	
	ULONG			uAttrib;	
	LPITEMIDLIST	pList;
	LPTSTR		    pName;	

};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	int	   CShFind::GetSmallIcon(int iMode){return GetIcon(iMode|SHGFI_SMALLICON)    ;}
inline	int	   CShFind::GetLargeIcon(int iMode){return GetIcon(iMode|SHGFI_LARGEICON)    ;}
inline	ULONG  CShFind::Attributes   ()const   {return  uAttrib;						  }
inline	BOOL   CShFind::IsLink       ()const   {return (uAttrib & SFGAO_LINK			);}
inline	BOOL   CShFind::IsFolder     ()const   {return (uAttrib & SFGAO_FOLDER			);}
inline	BOOL   CShFind::IsReadOnly   ()const   {return (uAttrib & SFGAO_READONLY		);}
inline	BOOL   CShFind::IsFilesystem ()const   {return (uAttrib & SFGAO_FILESYSTEM		);}
inline	BOOL   CShFind::IsHasRealDirs()const   {return (uAttrib & SFGAO_FILESYSANCESTOR );}
inline	BOOL   CShFind::Init()			       {return Init(CSIDL_DESKTOP);}
inline	BOOL   CShFind::Reset()			       {if(!pEnum)return FALSE;pEnum->Reset();return FALSE;}	
			   
inline	int	   CShItem::GetSmallIcon(int iMode){return GetIcon(iMode|SHGFI_SMALLICON	);}
inline	int	   CShItem::GetLargeIcon(int iMode){return GetIcon(iMode|SHGFI_LARGEICON	);}
inline	ULONG  CShItem::Attributes   ()const   {return  uAttrib;						  }
inline	BOOL   CShItem::IsLink       ()const   {return (uAttrib & SFGAO_LINK			);}
inline	BOOL   CShItem::IsFolder     ()const   {return (uAttrib & SFGAO_FOLDER			);}
inline	BOOL   CShItem::IsReadOnly   ()const   {return (uAttrib & SFGAO_READONLY		);}
inline	BOOL   CShItem::IsFilesystem ()const   {return (uAttrib & SFGAO_FILESYSTEM		);}
inline	LPTSTR CShItem::Name()                 {return pName                        	 ;}

#endif 	