//*****************************************************************************
//*
//*
//*		ShortCuts.h	
//*
//*
//*****************************************************************************
//	
//	Konfiguration fr Shortcuts
//
//	Copyright Anton Zechner (C) 2008
//
//	int	 GetFolderPath     ( int    iFolder,zchar    *pBuffer,zchar *pSubPath=0)
//	int	 GetFolderPath     ( int    iFolder,CString &pBuffer,zchar *pSubPath=0)
//	int  ShortCutCreate    ( int    iScPath,zchar *pPath,zchar *pName=0,zchar *pArgv=0,zchar *pDir=0)
//	int  ShortCutCreate    ( zchar *pScPath,zchar *pPath,zchar *pName=0,zchar *pArgv=0,zchar *pDir=0)
//	int  SetShortCutSetIcon( int    iScPath,zchar *pPath,zchar *pName=0,int iIcon=0)
//	int  SetShortCutSetIcon( zchar *pScPath,zchar *pPath,zchar *pName=0,int iIcon=0)
//	int  SetShortRemove    ( int    iScPath,			 zchar *pName=0)
//	int  SetShortRemove    ( zchar *pScPath,			 zchar *pName=0)
//	int  ShortCutQuery	   ( int    iScPath,			 zchar *pName,zchar *pBuffer,int iMax)
//	int  ShortCutQuery	   ( zchar *pScPath,			 zchar *pName,zchar *pBuffer,int iMax)
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#include	<Afx.h>
	#include	<AfxWin.h>
#endif

#include	"FileFunctions.h"
#include	"ShortCuts.h"
#include	<ObjBase.h>
#include	<ShlObj.h>

#ifdef		Z
#undef 		Z
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)				L##a
#define 	zchar				wchar_t
#define 	strzlen				wcslen
#define 	strzcpy				wcscpy
#define 	strzicmp			wcsicmp
#define 	strtochar(t,s)		wcsncpy(t,s,sizeof(s)/sizeof(s[0]))
#define 	strtowide(t,s,l)	wcsncpy(t,s,sizeof(s)/sizeof(s[0]));l=(int)wcslen(s);
#else
#define 	Z(a)				a
#define 	zchar				char
#define 	strzlen				strlen
#define 	strzcpy				strcpy
#define 	strzicmp			stricmp
#define 	strtochar(t,s)		WideCharToMultiByte(CP_ACP,0,s,-1,t,sizeof(t),0,0)
#define 	strtowide(t,s,l)	MultiByteToWideChar(CP_ACP,0,s,-1,t,sizeof(t)-5);l=(int)strlen(s);
#endif



//*****************************************************************************
//*
//*		GetFloderPath
//*
//*****************************************************************************
//	Speichert einen Systempfad in einem CString Objekt.
//	Der Puffer muss dabei eine mindest Lnge von MAX_PATH haben.
//	iFolder		: Ist die Nummer des Systempfades (siehe GFP_??? Makros) 
//	sBuffer		: Ist das CString Objekt.
//	pSubPath	: Ist pSubPath != 0 so wird der Pfad an den Pfad angehngt.
//	Ergibt die Lnge des Pfades in Zeichen bzw. 0 bei einem Fehler.
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
int	GetFolderPath(int iFolder,CString &sBuffer,const zchar *pSubPath)
{
zchar	cBuffer[MAX_PATH];
int		iLen;

	
		iLen = GetFolderPath(iFolder,cBuffer,pSubPath);
	if(!iLen)
		{
		sBuffer = Z("");
		return 0;
		}

	sBuffer = cBuffer;

return iLen;
}
#endif

//*****************************************************************************
//*
//*		GetFloderPath
//*
//*****************************************************************************
//	Speichert einen Systempfad in einem Puffer.
//	Der Puffer muss dabei eine mindest Lnge von MAX_PATH haben.
//	iFolder		: Ist die Nummer des Systempfades. (siehe GFP_??? Makros) 
//	pBuffer		: Ist der Zeiger auf den Puffer.
//	pSubPath	: Ist pSubPath != 0 so wird der Pfad an den Pfad angehngt.
//	Ergibt die Lnge des Pfades in Zeichen bzw. 0 bei einem Fehler.
int GetFolderPath(int iFolder,zchar *pBuffer,const zchar *pSubPath)
{
LPITEMIDLIST	pIdl;
unsigned		uLen;
int				iNum;
int				iRet;
int				i;


	*pBuffer=0;

	switch(iFolder)
			{
	case GFP_DESKTOP:			iNum=CSIDL_DESKTOPDIRECTORY;		break;
	case GFP_PROGRAMS:			iNum=CSIDL_PROGRAMS;				break;
	case GFP_STARTMENU:			iNum=CSIDL_STARTMENU;				break;
	case GFP_STARTUP: 			iNum=CSIDL_STARTUP;					break;
	case GFP_SENDTO:			iNum=CSIDL_SENDTO;					break;
	case GFP_COMMON_DESKTOP:	iNum=CSIDL_COMMON_DESKTOPDIRECTORY;	break;
	case GFP_COMMON_STARTMENU:	iNum=CSIDL_COMMON_STARTMENU;		break;
	case GFP_COMMON_STARTUP:	iNum=CSIDL_COMMON_STARTUP;			break;
	case GFP_COMMON_PROGRAMS:	iNum=CSIDL_COMMON_PROGRAMS;			break;
	default:					return 0;
			}
			


	if(SHGetSpecialFolderLocation(NULL,iNum,&pIdl)!=NOERROR)
		{
		return 0;
		}
	
		iRet = SHGetPathFromIDList(pIdl,pBuffer);
	if(!iRet)return 0;

	uLen = (unsigned)strzlen(pBuffer);

	if(pSubPath && *pSubPath)						// SubPfad anhngen
		{
		i=(int)strzlen(pSubPath);

		if(uLen+1<MAX_PATH && *pSubPath!='\\' && *pSubPath!='/')
			{
			pBuffer[uLen]='\\';uLen++;
			pBuffer[uLen]=0;
			}

		if(uLen+i>=MAX_PATH)
			{
			*pBuffer=0;
			return 0;
			}

		strzcpy(pBuffer+uLen,pSubPath);
		uLen+=i;
		}



return uLen;
}


//*****************************************************************************
//*
//*		ShortCutCreate
//*
//*****************************************************************************
//	Erzeugt einen neune Shortcut. 
//	Der Pfad wird dabei aus pScPath + pName + ".lnk" gebildet
//	iScPath		: Ist die Systempfadnummer der for den Pfad gestellt wird (siehe GFP_??? Makros) 
//	pScPath		: Ist der Quellpfad der vor den Pfad gesetzt wird
//	pPath		: Ist die Pfad fr den Shortcut
//	pName		: Ist der Name fr den Shortcut
//	pArgv		: Sind die Parameter des Shortcus
//	pDir		: Ist das Arbeitsverzeichnis fr die Shortcus-Ausfhrung.
//	Ergibt 1 wenn ok bzw. 0 bei einem Fehler
int ShortCutCreate(int          iScPath,const zchar *pPath,const zchar *pName,const zchar *pArgv,const zchar *pDir){zchar cScPath[MAX_PATH];if(!GetFolderPath(iScPath,cScPath))return 0;return ShortCutCreate(cScPath,pPath,pName,pArgv,pDir);}
int ShortCutCreate(const zchar *pScPath,const zchar *pPath,const zchar *pName,const zchar *pArgv,const zchar *pDir)
{
int				 i,iLen;
wchar_t			 wName[70];
wchar_t			 wStr[MAX_PATH];
zchar			 cStr[MAX_PATH];
IShellLink		*pIsl=0;
IPersistFile	*pIpf=0;
HRESULT			 iRetR;
HRESULT			 iRetC;



	if(!pScPath || !*pScPath)return 0;


	iRetC = CoInitialize(NULL);									// OLE initialisieren
	iRetR = CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&pIsl);

	if(!SUCCEEDED(iRetR))return 0;



	do	{
		iRetR=pIsl->SetPath(pPath);								// Programmpfad setzen
		if(!SUCCEEDED(iRetR))break;
		if(pArgv && *pArgv)iRetR=pIsl->SetArguments(pArgv);		// Argumente setzen
		if(!SUCCEEDED(iRetR))break;
		if(pDir && *pDir)iRetR=pIsl->SetWorkingDirectory(pDir);	// Arbeitsverzeichnis setzen
		if(!SUCCEEDED(iRetR))break;

		strtowide(wStr,pScPath,iLen);

		if(pName)
			{
			if(iLen>0 && wStr[iLen-1]!='\\' && wStr[iLen-1]!='/')
				{
				wStr[iLen]='\\';
				iLen++;
				}
			
			strtowide(wName,pName,i);
			if(iLen+i>MAX_PATH)break;
			wcscpy(wStr+iLen,wName);
			iLen+=i;
			}

		if(iLen<4 || wcsicmp(wStr+iLen-4,L".lnk"))
			{
			wcscpy(wStr+iLen,L".lnk");
			}

		strtochar  (cStr,wStr);
		SetFileName(cStr,Z(""));
		CreatePath (cStr);

																// PersistFile Interface ermitteln
		iRetR = pIsl->QueryInterface(IID_IPersistFile,(void**)&pIpf);

		if(!SUCCEEDED(iRetR))break;
			iRetR = pIpf->Save(wStr, TRUE );
		if(!SUCCEEDED(iRetR)){ iRetR = pIpf->Release(); break;}
			iRetR = pIpf->SaveCompleted(wStr );
		if(!SUCCEEDED(iRetR)){ iRetR = pIpf->Release(); break;}
			iRetR = pIpf->Release();
			iRetR = pIsl->Release();
		
		
		if(SUCCEEDED(iRetC))CoUninitialize();
		if(SUCCEEDED(iRetR))return 1;

		}while(0);

	iRetR = pIsl->Release();

	if(SUCCEEDED(iRetC))CoUninitialize();



return 0;
}

//*****************************************************************************
//*
//*		ShortCutSetIcon
//*
//*****************************************************************************
//	Setzt das Icon bei einem ShortCut
//	Der Pfad wird dabei aus pScPath + pName + ".lnk" gebildet
//	iScPath		: Ist die Systempfadnummer der for den Pfad gestellt wird (siehe GFP_??? Makros) 
//	pScPath		: Ist der Quellpfad der vor den Pfad gesetzt wird
//	pPath		: Ist die Pfad fr den Shortcut
//	pName		: Ist der Name fr den Shortcut
//	iIcon		: Ist die Nummer des Icons in der Datei 
//	Ergibt 1 wenn ok bzw. 0 bei einem Fehler
int ShortCutSetIcon(int          iScPath,const zchar *pPath,const zchar *pName,int iIcon){zchar cScPath[MAX_PATH]; if(!GetFolderPath(iScPath,cScPath))return 0; return ShortCutSetIcon(cScPath,pPath,pName,iIcon);}
int ShortCutSetIcon(const zchar *pScPath,const zchar *pPath,const zchar *pName,int iIcon)
{
int				 i,iLen;
wchar_t			 wName[70];
wchar_t			 wStr[MAX_PATH];
IShellLink		*pIsl=0;
IPersistFile	*pIpf=0;
HRESULT			 iRetR;
HRESULT			 iRetC;


	if(!pScPath || !*pScPath)return 0;

	iRetC = CoInitialize(NULL);									// OLE initialisieren
	iRetR = CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&pIsl);

	if(!SUCCEEDED(iRetR))return 0;


	  
	do	{
		strtowide(wStr,pScPath,iLen);

		if(pName)
			{
			if(iLen>0 && wStr[iLen-1]!='\\' && wStr[iLen-1]!='/')
				{
				wStr[iLen]='\\';
				iLen++;
				}
			
			strtowide(wName,pName,i);
			if(iLen+i>MAX_PATH)break;
			wcscpy(wStr+iLen,wName);
			iLen+=i;
			}

		if(iLen<4 || wcsicmp(wStr+iLen-4,L".lnk"))
			{
			wcscpy(wStr+iLen, L".lnk");
			}

																// PersistFile Interface ermitteln
		iRetR = pIsl->QueryInterface(IID_IPersistFile,(void**)&pIpf);

		if(!SUCCEEDED(iRetR))break;
		   iRetR = pIpf->Load(wStr, STGM_READWRITE );
		if(!SUCCEEDED(iRetR)){iRetR = pIpf->Release();break;}
		   iRetR = pIsl->SetIconLocation(pPath,iIcon);
		if(!SUCCEEDED(iRetR)){iRetR = pIpf->Release();break;}
		   iRetR = pIpf->Save(wStr, TRUE );
		if(!SUCCEEDED(iRetR)){iRetR = pIpf->Release();break;}
		   iRetR = pIpf->SaveCompleted(wStr );
		if(!SUCCEEDED(iRetR)){iRetR = pIpf->Release();break;}
		   iRetR = pIpf->Release();
		   iRetR = pIsl->Release();

		if(SUCCEEDED(iRetC))CoUninitialize();
		if(SUCCEEDED(iRetR))return 1;

		}while(0);

	iRetR = pIsl->Release();
	if(SUCCEEDED(iRetC))CoUninitialize();

return 0;
}



//*****************************************************************************
//*
//*		ShortCutRemove
//*
//*****************************************************************************
//	Lscht einen ShortCut
//	Der Pfad wird dabei aus pScPath + pName + ".lnk" gebildet
//	iScPath		: Ist die Systempfadnummer der for den Pfad gestellt wird (siehe GFP_??? Makros) 
//	pScPath		: Ist der Quellpfad der vor den Pfad gesetzt wird
//	pName		: Ist der Name fr den Shortcut
//	Ergibt 1 wenn ok bzw. 0 bei einem Fehler
int ShortCutRemove(int          iScPath,const zchar *pName){zchar cScPath[MAX_PATH];	if(!GetFolderPath(iScPath,cScPath))return 0; return ShortCutRemove(cScPath,pName);}
int ShortCutRemove(const zchar *pScPath,const zchar *pName)
{
int		i,iLen;
zchar	cStr[MAX_PATH];


	if(!pScPath || !*pScPath)return 0;


	strzcpy(cStr,pScPath);
	iLen = (int)strzlen(pScPath);

	if(pName)
		{
		i=(int)strzlen(pName);
		
		if(iLen>0 && cStr[iLen-1]!='\\' && cStr[iLen-1]!='/')
			{
			cStr[iLen]='/';
			iLen++;
			}
		
		if(iLen+i>MAX_PATH)return 0;
		
		strzcpy(cStr+iLen,pName);
		iLen+=i;
		}

	if(iLen<4 || strzicmp(cStr+iLen-4,Z(".lnk")))
		{
		strzcpy(cStr+iLen,Z(".lnk"));
		}

	DeleteFile(cStr);


return 0;
}

//*****************************************************************************
//*
//*		ShortCutQuery
//*
//*****************************************************************************
//	Abfragen des Dateinamens eines ShortCuts
//	Der Pfad wird dabei aus pScPath + pName + ".lnk" gebildet
//	iScPath		: Ist die Systempfadnummer der for den Pfad gestellt wird (siehe GFP_??? Makros) 
//	pScPath		: Ist der Quellpfad der vor den Pfad gesetzt wird
//	pName		: Ist der Name fr den Shortcut
//	Ergibt 1 wenn ok bzw. 0 bei einem Fehler
int ShortCutQuery(int          iScPath,const zchar *pName,zchar *pBuffer,int iMax){zchar cScPath[MAX_PATH]; if(!GetFolderPath(iScPath,cScPath))return 0; return ShortCutQuery(cScPath,pName,pBuffer,iMax);}
int ShortCutQuery(const zchar *pScPath,const zchar *pName,zchar *pBuffer,int iMax)
{
int				 i,iLen;
wchar_t			 wName[70];
wchar_t			 wStr[MAX_PATH];
IShellLink		*pIsl=0;
IPersistFile	*pIpf=0;
HRESULT			 iRetR;
HRESULT			 iRetC;
WIN32_FIND_DATA	 sFind;



	if(!pScPath || !*pScPath)return 0;

	iRetC = CoInitialize(NULL);								// OLE initialisieren
	iRetR = CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&pIsl);

	if(!SUCCEEDED(iRetR))
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}



	do	{
		strtowide(wStr,pScPath,iLen);
		
		if(pName)
			{
			if(iLen>0 && wStr[iLen-1]!='\\' && wStr[iLen-1]!='/')
				{
				wStr[iLen]='/';
				iLen++;
				}
			
			strtowide(wName,pName,i);
			if(iLen+i>MAX_PATH)break;
			wcscpy(wStr+iLen,wName);
			iLen+=i;
			}

		if(iLen<4 || wcsicmp(wStr+iLen-4,L".lnk"))
			{
			wcscpy(wStr+iLen, L".lnk");
			}



															// PersistFile Interface ermitteln
		iRetR=pIsl->QueryInterface(IID_IPersistFile,(void**)&pIpf);
		if(!SUCCEEDED(iRetR))break;

		   iRetR = pIpf->Load(wStr, STGM_READ );
		if(!SUCCEEDED(iRetR)){iRetR = pIpf->Release();break;}

		   iRetC = pIsl->GetPath(pBuffer,iMax,&sFind,0);
		if(!SUCCEEDED(iRetC)){iRetR = pIpf->Release();break;}

		   iRetR = pIpf->Release();
		   iRetR = pIsl->Release();

		if(SUCCEEDED(iRetC))CoUninitialize();
		if(SUCCEEDED(iRetR))return (int)strzlen(pBuffer);

		}while(0);

	if(iMax>0)pBuffer[0]=0;
	iRetR = pIsl->Release();
	if(SUCCEEDED(iRetC))CoUninitialize();



return 0;
}

