//*****************************************************************************
//*
//*
//*		SocketSniffer.cpp
//*
//*
//*****************************************************************************
//
//	Funktionen zur Paketaufzeichnung auf der Loopback-Schnittstelle.
//
#include	"WinSock2.h"
#include	"SocketSniffer.h"
#include	<stdio.h>
#include	<time.h>

#pragma		comment(lib,"ws2_32.lib")

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#define 	v				volatile
#define		SIO_RCVALL		_WSAIOW(IOC_VENDOR,1)
#define 	PACKER_HEADER	20
#ifndef		SSN_MAX_PACKET
#define 	SSN_MAX_PACKET	1500
#endif
#ifndef		SSN_MAX_SOCKET
#define 	SSN_MAX_SOCKET	16
#endif


struct in_addr6_
	{
    u_char					s6_addr[16];				// IPv6 address
    };

struct sockaddr_in6_
	{
    short					sin6_family;				// AF_INET6
    u_short					sin6_port;					// Transport level port number
    u_long					sin6_flowinfo;    			// IPv6 flow information
    struct in_addr6_		sin6_addr;					// IPv6 address
	};


typedef struct addrinfo_ex
	{
    int                 	ai_flags;					// AI_PASSIVE, AI_CANONNAME, AI_NUMERICHOST
    int                 	ai_family;      			// PF_xxx
    int                 	ai_socktype;    			// SOCK_xxx
    int                 	ai_protocol;    			// 0 or IPPROTO_xxx for IPv4 and IPv6
    size_t              	ai_addrlen;     			// Length of ai_addr
    char *              	ai_canonname;   			// Canonical name for nodename
    struct sockaddr *   	ai_addr;        			// Binary address
    struct addrinfo_ex* 	ai_next;        			// Next structure in linked list
	}addrinfo_ex_;

typedef struct SnifferPacket_
	{
	SnifferPacket_		    *pNext;
	unsigned char 			aData[4];
	}SnifferPacket;

static	SnifferPacket v	   *pLast;
static	SnifferPacket v	   *pFirst;
static	CRITICAL_SECTION	sSynch;
static	WSADATA				sWasData;
static	HANDLE				hEvent	= 0;
static	HANDLE				hHeap	= 0;
static	BOOL				bInit	= 0;
static	BOOL				bOpen	= 0;
static	BOOL v				bThread	= 0;
static	UINT v				uThTurn	= 0;
static	UINT v				uAllData= 0;
static	UINT				uTime	= 0;
static	UINT				uStart	= 0;
static	UINT				uPacket	= 0;
static	UINT				uCount	= 0;
static	SOCKET				aSocket[SSN_MAX_SOCKET];
static	CHAR				aPacket[PACKER_HEADER+14+SSN_MAX_PACKET];
static	BYTE				ucFliterData[20]={0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x08,0x00,0x00,0x00, 0xFE,0x00,0x00,0x00};
static	BYTE				ucFliterMask[20]={0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0xFF,0xFF,0x00,0x00, 0x06,0x00,0x00,0x00};



typedef int	 (WSAAPI *getaddrinfo_type )(const char *,const char *,const struct addrinfo_ex *,struct addrinfo_ex **);
typedef int  (WSAAPI *getnameinfo_type )(const struct sockaddr*,int,char*,DWORD,char*,DWORD,int);
typedef void (WSAAPI *freeaddrinfo_type)(struct addrinfo_ex *);

static	HMODULE				hDllApi	= 0;
static	HMODULE				hDllWs2	= 0;
static	int					iInit	= 0;
static	int					iInitI	= 0;
static	int					iStart	= 0;
static	getnameinfo_type	pInfo	= 0;
static	getaddrinfo_type	pProc   = 0;
static	freeaddrinfo_type	pFree	= 0;



//*****************************************************************************
//*
//*		freeaddrinfo_ex
//*
//*****************************************************************************
//	Dummy fr freeaddrinfo weil auf Win2000 die Funktion in der DLL fehlt
static void freeaddrinfo_ex(struct addrinfo_ex *pAddrInfo)
{
	if(!pFree)return;
	pFree(pAddrInfo);
}


//*****************************************************************************
//*
//*		getaddrinfo_ex
//*
//*****************************************************************************
//	Dummy fr getaddrinfo weil auf Win2000 die Funktion in der DLL fehlt
static int getaddrinfo_ex(const char *pNodeName,const char *pServname,const struct addrinfo_ex *pHints,struct addrinfo_ex **pResult)
{


	if(!iInit)
		{
		iInit = 1;

		if(!hDllWs2)
			{
			    hDllWs2 = LoadLibrary("ws2_32.dll");
			if(!hDllWs2)return -1;
			}

		if(!pInfo)pInfo = (getnameinfo_type )GetProcAddress(hDllWs2,"getnameinfo" );
		if(!pProc)pProc = (getaddrinfo_type )GetProcAddress(hDllWs2,"getaddrinfo" );
		if(!pFree)pFree = (freeaddrinfo_type)GetProcAddress(hDllWs2,"freeaddrinfo");
		}


	if(!pProc)return -1;


return pProc(pNodeName,pServname,pHints,pResult);
}


//*****************************************************************************
//*
//*		GetLocalIps
//*
//*****************************************************************************
//	Holt eine Liste mit den lokalen IP Adressen
//	pBuffer		: Zeiger auf einen Textpuffer
//	iSize  		: Gre des Textpuffers
//	iMode		: 0=Allses  1=Nur IPv4  2=Nur IPv6
//	Ergibt die Anzahl der gefunden Adressen bzw. -1 wenn der Puffer zu klein ist
static int GetLocalIps(char *pBuffer,int iSize,int iMode=0)
{
char			cMyName[128];
WORD			wVersion;
WSADATA			sWsaData;
addrinfo_ex	   *pDataM;
addrinfo_ex	   *pPtrM;
sockaddr_in6_  *pIp6M;
sockaddr_in    *pIpM;
unsigned char  *pPtr;
int				iRet;
int				iLen;
int				iCnt;



	if(iSize<20)										// Ist der Puffer zu klein
		{
		if(iSize>=1)pBuffer[0]=0;
		if(iSize>=2)pBuffer[1]=0;
		return -1;
		}

	iSize--;


	if(!iStart)
		{
		wVersion = MAKEWORD(2,0);
		iRet	 = WSAStartup(wVersion,&sWsaData);
		iStart	 = 1;
		}


	cMyName[0]	 = 0;
	iLen		 = 0;
	iCnt		 = 0;

	gethostname(cMyName,sizeof(cMyName));


	   iRet = getaddrinfo_ex(cMyName,0,0,&pDataM);
	if(iRet==0)
		{
		pPtrM = pDataM;

		while(pPtrM)
			{
			pIpM  = (sockaddr_in  *)(pPtrM->ai_addr);
			pIp6M = (sockaddr_in6_*)(pPtrM->ai_addr);

			if(pIpM->sin_family==AF_INET)
			if(iMode==0 || iMode==1)
				{
				if(iLen+24>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIpM->sin_addr;
				iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
				iLen += 1;
				iCnt += 1;
				}

			if(pIp6M->sin6_family==AF_INET6)
			if(iMode==0 || iMode==2)
				{
				if(iLen+44>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIp6M->sin6_addr;
				iLen += sprintf(pBuffer+iLen,"%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X",
							pPtr[ 0],pPtr[ 1],pPtr[ 2],pPtr[ 3],
							pPtr[ 4],pPtr[ 5],pPtr[ 6],pPtr[ 7],
							pPtr[ 8],pPtr[ 9],pPtr[10],pPtr[11],
							pPtr[12],pPtr[13],pPtr[14],pPtr[15]);

				iLen += 1;
				iCnt += 1;
				}

			pPtrM = pPtrM->ai_next;
			}

		freeaddrinfo_ex(pDataM);
		}



	   iRet = getaddrinfo_ex("localhost",0,0,&pDataM);
	if(iRet==0)
		{
		pPtrM = pDataM;

		while(pPtrM)
			{
			pIpM  = (sockaddr_in  *)(pPtrM->ai_addr);
			pIp6M = (sockaddr_in6_*)(pPtrM->ai_addr);

			if(pIpM->sin_family==AF_INET)
			if(iMode==0 || iMode==1)
				{
				if(iLen+24>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIpM->sin_addr;
				iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
				iLen += 1;
				iCnt += 1;
				}

			if(pIp6M->sin6_family==AF_INET6)
			if(iMode==0 || iMode==2)
				{
				if(iLen+48>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIp6M->sin6_addr;
				iLen += sprintf(pBuffer+iLen,"%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X",
							pPtr[ 0],pPtr[ 1],pPtr[ 2],pPtr[ 3],
							pPtr[ 4],pPtr[ 5],pPtr[ 6],pPtr[ 7],
							pPtr[ 8],pPtr[ 9],pPtr[10],pPtr[11],
							pPtr[12],pPtr[13],pPtr[14],pPtr[15]);
				iLen += 1;
				iCnt += 1;
				}

			pPtrM = pPtrM->ai_next;
			}

		freeaddrinfo_ex(pDataM);
		}




	if(iCnt>0)
		{
		pBuffer[iLen]=0;
		return iCnt;
		}


//******************** Alte Variante ber gethostbyname ***********************
hostent        *pHost;
char		  **pAddresses;
int				i;



	if(iMode && iMode!=1)
		{
		pBuffer[0]=0;
		pBuffer[1]=0;
		return 0;
		}


	   pHost = gethostbyname(cMyName);
	if(pHost && pHost->h_addrtype==AF_INET)
		{
		pAddresses = pHost->h_addr_list;

		for(i=0;i<16;i++)
			{
			if(!pAddresses[i])break;

			if(iLen+20>=iSize)
				{
				pBuffer[0]=0;
				pBuffer[1]=0;
				return -1;
				}

			pPtr  = (unsigned char *)pAddresses[i];
			iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
			iLen += 1;
			iCnt += 1;
			}
		}


	   pHost = gethostbyname("localhost");
	if(pHost && pHost->h_addrtype==AF_INET)
		{
		pAddresses = pHost->h_addr_list;

		for(i=0;i<16;i++)
			{
			if(!pAddresses[i])break;

			if(iLen+20>=iSize)
				{
				pBuffer[0]=0;
				pBuffer[1]=0;
				return -1;
				}

			pPtr  = (unsigned char *)pAddresses[i];
			iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
			iLen += 1;
			iCnt += 1;
			}
		}



	pBuffer[iLen]=0;



return iCnt;
}


//*****************************************************************************
//*
//*		FilterCmp
//*
//*****************************************************************************
//	Vergleicht ob ein Filter zu einem Paket passt
//	pFrame	: Zeiger auf das Paket
//	pBits	: Zeiger auf die Filterbits
//				[ 0.. 5] = Ziel-Mac-Adresse
//				[ 6..11] = Quell-Mac-Adresse
//				[12..13] = Ethernet-Typ
//				[14..15] = Daten nach Ethernet-Typ
//				[16]     = 0-127: Offset fr Filterbytes 17..19 (0=ab Offset 16)
//								  Filterbytes 0..11 sind fr MAC-Adressen
//				           255  : VLAN-ID prfen Filterbytes 18+19 --> VLAN
//						   254  : IP-Addresse filtern (ohne Richtungsprfung)
//									[ 0...3] = IP-A
//									[ 4...7] = IP-B
//									[ 8...9] = Port-A
//									[10..11] = Port-B
//									[17..19] = Daten
//								   Mask [16] = IP-Type (0x00=alle 0x11=UDP 0x06=TCP)
//						   253  : IP-Addresse filtern (mit Richtungsprfung)
//									[ 0...3] = IP-Source
//									[ 4...7] = IP-Destination
//									[ 8...9] = Port-Source
//									[10..11] = Port-Destination
//									[17..19] = Daten
//								   Mask [16] = IP-Type (0x00=alle 0x11=UDP 0x06=TCP)
//						   252  : Multi-Cast-Adressen immer durchlassen
//									[ 0...5] = MAC-Source
//									[ 5..11] = MAC-Destination
//									[12..15] = Pakettyp
//								   Mask [16] = Offset
//						   251  : IP-Addresse filtern (ohne Richtungsprfung und einzelen)
//									[ 0...3] = IP-A
//									[ 4...7] = IP-B
//									[ 8...9] = Port-A
//									[10..11] = Port-B
//									[17..19] = Daten
//								   Mask [16] = IP-Type (0x00=alle 0x11=UDP 0x06=TCP)
//						   250  : Profinet filtern
//									[ 0...5] = MAC
//									[ 6...7] = Port
//									[ 8..11] = IP
//								   Mask [16] = IP-Type (0x00=alle 0x01=RD 0x02=DCP 0x04=ARP 0x08=PING 0x10=UDP 0x20=MultiCast 0x40=Alarme)
//	pMask	: Zeiger auf die Filtermaske
//	Ergibt 0 wenn der Filter passt sonst 1 wenn der Filter nicht passt
static inline int FilterCmp(const void *pFrame,const void *pBits,const void *pMask)
{
unsigned short	usAddrW;
unsigned short	usMaskW;
unsigned		uOffset;
unsigned		uAddr1;
unsigned		uAddr2;
unsigned 		uPort1;
unsigned 		uPort2;
unsigned		uPort;
unsigned		uType;
unsigned		uMask;
unsigned		uAddr;
unsigned		uVal;
unsigned		uCnt;
unsigned		uAll;
unsigned		uAdd;
unsigned char  *pPtr;



	if(((unsigned short*)pFrame)[6]==0x0081)		// VLAN-Tag ignorieren
		{
		if((((unsigned*)pFrame)[4]^((unsigned*)pBits)[3])&((unsigned*)pMask)[3])return 1;

		uOffset = ((unsigned*)pBits)[4]&0xFF;

		if(uOffset>=0x80)
			{
			if(uOffset==0xFF)
				{									// VLAN-ID prfen
				if(((((unsigned*)pFrame)[3]>>16)^(((unsigned*)pBits)[4]>>16))&(((unsigned*)pMask)[4]>>16))return 1;
				}
			else if(uOffset==0xFC)					// Multicast immer erlauben
				{
				uOffset = ((unsigned*)pMask)[4]&0x7F;
				pPtr = ((unsigned char*)pFrame)+uOffset+20;
				if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;
				if(((char*)pFrame)[0]&0x01)return 0;
				goto CmpMac;
				}


			if(((unsigned short*)pFrame)[6]==0x0008)// IP-V4
				{
				pPtr    = ((unsigned char*)pFrame)+18;
				uAddr1  = ((unsigned*)pPtr)[3];
				uAddr2  = ((unsigned*)pPtr)[4];
				uType	=  pPtr[9];
				uAdd    = (pPtr[0]&0x0F)*4;
				}									// IP-V6
			else if(((unsigned short*)pFrame)[6]==0xDD86)
				{
				pPtr    = ((unsigned char*)pFrame)+18;
				uAddr1  = ((unsigned*)pPtr)[5];
				uAddr2  = ((unsigned*)pPtr)[9];
				uType   =  pPtr[6];
				uAdd	=  40;

				if(pPtr[8]==0xFF)
					{
					uAddr1  = 0xFFFFFFFF;
					}
				else if(uAddr1==1 && !((unsigned*)pPtr)[2])
					{
					uAddr1  = 0x7F000001;
					}
				else{
					uAddr1 |= 0xF0000000;
					}

				if(pPtr[24]==0xFF)
					{
					uAddr2  = 0xFFFFFFFF;
					}
				else if(uAddr2==1 && !((unsigned*)pPtr)[6])
					{
					uAddr2  = 0x7F000001;
					}
				else{
					uAddr2 |= 0xF0000000;
					}
				}
			else{									// Kein IP-Paket
				uType = 0;
				}


			if(uOffset==0xFE)						// IP-prfen
				{
				if(!uType)return 1;
				goto CmpIP;
				}
			else if(uOffset==0xFD)					// IP-prfen (nur eine Richtung)
				{
				if(!uType)return 1;
				goto CmpIPex;
				}
			else if(uOffset==0xFB)					// IP-prfen (ohne Richtungsprfung und einzelen)
				{
				if(!uType)return 1;
				goto CmpIPsingle;
				}
			else if(uOffset==0xFA)					// Profinet prfen
				{
				pPtr	=  (unsigned char *)pFrame;
				uMask	= ((unsigned      *)pMask)[0];
				usMaskW	= ((unsigned short*)pMask)[2];

				if(uMask || usMaskW)				// MAC-Adressen prfen
					{
					uAddr	= ((unsigned      *)pBits)[0];
					usAddrW	= ((unsigned short*)pBits)[2];

					if((((*(unsigned*)(pPtr  ))^uAddr)&uMask) || (((*(unsigned short*)(pPtr+ 4))^usAddrW)&usMaskW))
					if((((*(unsigned*)(pPtr+6))^uAddr)&uMask) || (((*(unsigned short*)(pPtr+10))^usAddrW)&usMaskW))
						{
						if(!(pPtr[0]&0x01))return 1;
						uMask = ((unsigned*)pMask)[4];
						if(!(uMask&0x20))return 1;
						}
					}


					uMask = ((unsigned*)pMask)[4]&0xFF;
				if(!uMask)uMask=0xFF;

				if(((unsigned short*)pFrame)[8]==0x9288)
					{
					    uVal = ((unsigned short*)pFrame)[9];
					if((uVal&0xFFFC)==0xFEFC)		// DCP
						{
						if(!(uMask&0x02))return 1;
						}							// PNIO
					else if(uVal>=0x0100 && uVal<0xFC00)
						{
						if(!(uMask&0x01))return 1;
						}
					else if((uVal&0xFDFF)==0xFC01)
						{							// Alarme
						if(!(uMask&0x40))return 1;
						}

					return 0;
					}
													// ARP
				if(((unsigned short*)pFrame)[8]==0x0608)
					{
					if(!(uMask&0x04))return 1;

					pPtr	= (unsigned char*)pFrame+4;
					uAddr	= ((unsigned*)pBits)[2];
					uMask	= ((unsigned*)pMask)[2];

					if(!uMask)return 0;				// Prfe ARP IP'S

					uAddr1  = *(unsigned*)(pPtr+0x1C);
					uAddr2  = *(unsigned*)(pPtr+0x26);

					if((uAddr1^uAddr)&uMask)
					if((uAddr2^uAddr)&uMask)return 1;

					return 0;
					}
													// ICMP+UDP
				if(((unsigned short*)pFrame)[8]!=0x0008)
					{
					return 1;
					}

				if(!(uMask&0x18))return 1;
				pPtr = ((unsigned char*)pFrame)+18;
				goto CmpProfinet;
				}
			else{
				return 1;
				}
			}
		else{
			pPtr = ((unsigned char*)pFrame)+uOffset+20;
			if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;
			}
		}
	else{
		if((((unsigned*)pFrame)[3]^((unsigned*)pBits)[3])&((unsigned*)pMask)[3])return 1;

		uOffset = ((unsigned*)pBits)[4]&0xFF;

		if(uOffset>=0x80)
			{
			if(uOffset==0xFF)
				{									// VLAN-ID prfen
				return 1;
				}
			else if(uOffset==0xFC)					// Multicast immer erlauben
				{
				uOffset = ((unsigned*)pMask)[4]&0x7F;
				pPtr = ((unsigned char*)pFrame)+uOffset+16;
				if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;
				if(((char*)pPtr)[0]&0x01)return 0;
				goto CmpMac;
				}


			if(((unsigned short*)pFrame)[6]==0x0008)// IP-V4
				{
				pPtr    = ((unsigned char*)pFrame)+14;
				uAddr1  = ((unsigned*)pPtr)[3];
				uAddr2  = ((unsigned*)pPtr)[4];
				uType	=  pPtr[9];
				uAdd    = (pPtr[0]&0x0F)*4;
				}									// IP-V6
			else if(((unsigned short*)pFrame)[6]==0xDD86)
				{
				pPtr    = ((unsigned char*)pFrame)+14;
				uAddr1  = ((unsigned*)pPtr)[5];
				uAddr2  = ((unsigned*)pPtr)[9];
				uType   =  pPtr[6];
				uAdd	=  40;

				if(pPtr[8]==0xFF)
					{
					uAddr1  = 0xFFFFFFFF;
					}
				else if(uAddr1==1 && !((unsigned*)pPtr)[2])
					{
					uAddr1  = 0x7F000001;
					}
				else{
					uAddr1 |= 0xF0000000;
					}

				if(pPtr[24]==0xFF)
					{
					uAddr2  = 0xFFFFFFFF;
					}
				else if(uAddr2==1 && !((unsigned*)pPtr)[6])
					{
					uAddr2  = 0x7F000001;
					}
				else{
					uAddr2 |= 0xF0000000;
					}
				}
			else{									// Kein IP-Paket
				uType = 0;
				}


			if(uOffset==0xFE)						// IP-prfen
				{
				if(!uType)return 1;
				goto CmpIP;
				}
			else if(uOffset==0xFD)					// IP-prfen (nur eine Richtung)
				{
				if(!uType)return 1;
				goto CmpIPex;
				}
			else if(uOffset==0xFB)					// IP-prfen (ohne Richtungsprfung und einzelen)
				{
				if(!uType)return 1;
				goto CmpIPsingle;
				}
			else if(uOffset==0xFA)					// Profinet prfen
				{
				pPtr	=  (unsigned char *)pFrame;
				uMask	= ((unsigned      *)pMask)[0];
				usMaskW	= ((unsigned short*)pMask)[2];

				if(uMask || usMaskW)				// MAC-Adressen prfen
					{
					uAddr	= ((unsigned      *)pBits)[0];
					usAddrW	= ((unsigned short*)pBits)[2];

					if((((*(unsigned*)(pPtr  ))^uAddr)&uMask) || (((*(unsigned short*)(pPtr+ 4))^usAddrW)&usMaskW))
					if((((*(unsigned*)(pPtr+6))^uAddr)&uMask) || (((*(unsigned short*)(pPtr+10))^usAddrW)&usMaskW))
						{
						if(!(pPtr[0]&0x01))return 1;
						uMask = ((unsigned*)pMask)[4];
						if(!(uMask&0x20))return 1;
						}
					}


					uMask = ((unsigned*)pMask)[4]&0xFF;
				if(!uMask)uMask=0xFF;

				if(((unsigned short*)pFrame)[6]==0x9288)
					{
					    uVal = ((unsigned short*)pFrame)[7];
					if((uVal&0xFFFC)==0xFEFC)		// DCP
						{
						if(!(uMask&0x02))return 1;
						}							// PNIO
					else if(uVal>=0x0100 && uVal<0xFC00)
						{
						if(!(uMask&0x01))return 1;
						}
					else if((uVal&0xFDFF)==0xFC01)
						{							// Alarme
						if(!(uMask&0x40))return 1;
						}

					return 0;
					}
													// ARP
				if(((unsigned short*)pFrame)[6]==0x0608)
					{
					if(!(uMask&0x04))return 1;

					pPtr	= (unsigned char*)pFrame;
					uAddr	= ((unsigned*)pBits)[2];
					uMask	= ((unsigned*)pMask)[2];

					if(!uMask)return 0;				// Prfe ARP IP'S

					uAddr1  = *(unsigned*)(pPtr+0x1C);
					uAddr2  = *(unsigned*)(pPtr+0x26);

					if((uAddr1^uAddr)&uMask)
					if((uAddr2^uAddr)&uMask)return 1;

					return 0;
					}
													// ICMP+UDP
				if(((unsigned short*)pFrame)[6]!=0x0008)
					{
					return 1;
					}

				pPtr = ((unsigned char*)pFrame)+14;
				goto CmpProfinet;
				}
			else{
				return 1;
				}
			}
		else{
			pPtr = ((unsigned char*)pFrame)+uOffset+16;
			if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;
			}

		if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;
		}

CmpMac:												// MAC-Adressen vergeichen

	if((((unsigned*)pFrame)[2]^((unsigned*)pBits)[2])&((unsigned*)pMask)[2])return 1;
	if((((unsigned*)pFrame)[1]^((unsigned*)pBits)[1])&((unsigned*)pMask)[1])return 1;
	if((((unsigned*)pFrame)[0]^((unsigned*)pBits)[0])&((unsigned*)pMask)[0])return 1;


return 0;


CmpIP:
													// IP prfen
	if((uAddr1^((unsigned*)pBits)[1])&((unsigned*)pMask)[1])
	if((uAddr1^((unsigned*)pBits)[0])&((unsigned*)pMask)[0])return 1;
	if((uAddr2^((unsigned*)pBits)[1])&((unsigned*)pMask)[1])
	if((uAddr2^((unsigned*)pBits)[0])&((unsigned*)pMask)[0])return 1;

	if(((unsigned char*)pMask)[16]!=uType)			// Typ prfen
	if(((unsigned char*)pMask)[16]!=0x00 )return 1;

	pPtr   += uAdd;
	uPort1  = ((unsigned*)pPtr)[0];
	uPort2  = (uPort1>>16)|(uPort1<<16);
													// Ports prfen
	if((uPort1^((unsigned*)pBits)[2])&((unsigned*)pMask)[2])
	if((uPort2^((unsigned*)pBits)[2])&((unsigned*)pMask)[2])return 1;

		 if(uType==0x11)pPtr += 8;
	else if(uType==0x06)pPtr += (pPtr[12]>>4)*4;
													// Daten prfen
	if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;

return 0;

CmpIPex:

	uAddr1  = ((unsigned*)pPtr)[3];
	uAddr2  = ((unsigned*)pPtr)[4];
													// IP prfen
	if((uAddr2^((unsigned*)pBits)[1])&((unsigned*)pMask)[1])return 1;
	if((uAddr1^((unsigned*)pBits)[0])&((unsigned*)pMask)[0])return 1;

	if(((unsigned char*)pMask)[16]!=uType)			// Typ prfen
	if(((unsigned char*)pMask)[16]!=0x00 )return 1;

	pPtr   += uAdd;
	uPort1  = ((unsigned*)pPtr)[0];
													// Ports prfen
	if((uPort1^((unsigned*)pBits)[2])&((unsigned*)pMask)[2])return 1;

		 if(uType==0x11)pPtr += 8;
	else if(uType==0x06)pPtr += (pPtr[12]>>4)*4;
													// Daten prfen
	if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;

return 0;

CmpIPsingle:

	if(((unsigned char*)pMask)[16]!=uType)			// Typ prfen
	if(((unsigned char*)pMask)[16]!=0x00 )return 1;

	uAll    = 0;
	uCnt    = 0;

       uMask=((unsigned*)pMask)[0];
	if(uMask)										// IP prfen (eine aus zwei)
		{
		uAll++;
		uAddr = ((unsigned*)pBits)[0];
		if(!((uAddr1^uAddr)&uMask))uCnt++;
		if(!((uAddr2^uAddr)&uMask))uCnt++;
		}

	   uMask=((unsigned*)pMask)[1];
	if(uMask)
		{
		uAll++;
		uAddr = ((unsigned*)pBits)[1];
		if(!((uAddr1^uAddr)&uMask))uCnt++;
		if(!((uAddr2^uAddr)&uMask))uCnt++;
		}

	if(uAll && !uCnt)return 1;

	pPtr   += uAdd;
	uPort1  = ((unsigned short*)pPtr)[0];
	uPort2  = ((unsigned short*)pPtr)[1];
	uAll    = 0;
	uCnt    = 0;

	   uMask=((unsigned short *)pMask)[4];
	if(uMask)										// Ports prfen (eines aus zwei)
		{
		uAll++;
		uPort = ((unsigned short*)pBits)[4];
		if(!((uPort1^uPort)&uMask))uCnt++;
		if(!((uPort2^uPort)&uMask))uCnt++;
		}

	   uMask=((unsigned short *)pMask)[5];
	if(uMask)
		{
		uAll++;
		uPort = ((unsigned short*)pBits)[5];
		if(!((uPort1^uPort)&uMask))uCnt++;
		if(!((uPort2^uPort)&uMask))uCnt++;
		}

	if(uAll && !uCnt)return 1;

		 if(uType==0x11)pPtr += 8;
	else if(uType==0x06)pPtr += (pPtr[12]>>4)*4;
													// Daten prfen
	if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;


return 0;

CmpProfinet:

	uType	=  pPtr[9];

	if(uType!=0x01 && uType!=0x11)return 1;

	uAddr1  = ((unsigned*)pPtr )[3];
	uAddr2  = ((unsigned*)pPtr )[4];
	uAddr	= ((unsigned*)pBits)[2];
	uMask	= ((unsigned*)pMask)[2];

	if(uMask)										// IP prfen
		{
		if((uAddr1^uAddr)&uMask)
		if((uAddr2^uAddr)&uMask)return 1;
		}

	pPtr   += (pPtr[0]&0x0F)*4;

	if(uType==0x11)
		{
			uVal= ((unsigned short*)pPtr )[4];
		if((uVal&0xF0FF)!=0x0004)return 1;
		if(memcmp(pPtr+36,"\x97\x6C\xD1\x11\x82\x71",6))
		if(memcmp(pPtr+36,"\x6C\x97\x11\xD1\x82\x71",6))
			{
			return 1;
			}

		uPort1  = ((unsigned short*)pPtr )[0];
		uPort2  = ((unsigned short*)pPtr )[1];
		uPort	= ((unsigned short*)pBits)[3];
		uMask	= ((unsigned short*)pMask)[3];

		if(uMask)									// Ports prfen (34964+Port)
			{
			if((uPort1^uPort)&uMask)
			if((uPort2^uPort)&uMask)
			if( uPort1!=34964 && uPort2!=34964)
				{
				return 1;
				}
			}
		}


	if(uType==0x11)pPtr += 8;

													// Daten prfen
	if((((unsigned*)pPtr)[0]^(((unsigned*)pBits)[4]>>8))&(((unsigned*)pMask)[4]>>8))return 1;


return 0;
}

//*****************************************************************************
//*
//*		SnifferThread
//*
//*****************************************************************************
//	Empfangs Thread fr Loopback-Pakete
static DWORD WINAPI SnifferThread(LPVOID pParam)
{
CHAR			aBuffer[PACKER_HEADER+14+SSN_MAX_PACKET];
struct timeval  sTimeVal;
fd_set          sFdRead;
SnifferPacket  *pPacket;
unsigned		uIndex;
unsigned		uLoop;
unsigned		uSock;
unsigned		uTurn;
unsigned		uTick;
unsigned		uSize;
unsigned		uItem;
int				iByte;
int				iRet;




	SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

	uTurn	= uThTurn;
	uIndex	= 0;

	while(uTurn==uThTurn)
		{
		sTimeVal.tv_sec  = 2;
		sTimeVal.tv_usec = 0;

		FD_ZERO(&sFdRead);

		uSock = aSocket[0]+1;

		for(uItem=0;uItem<uCount;uItem++)				// Liste mit Sockets erstellen
			{
			FD_SET(aSocket[uItem],&sFdRead);
			if(uSock<aSocket[uItem])uSock=aSocket[uItem]+1;
			}
		

		   iRet = select(uSock,&sFdRead,0,0,&sTimeVal);
		if(iRet<=0)										// Warte auf Empfang
			{
			if(iRet<0)Sleep(20);
			continue;
			}

		for(uLoop=0;uLoop<=uCount;uLoop++)				// Suche nchstes Socket mit Empfang
			{
			if(uIndex>=uCount)uIndex=0;
			if(FD_ISSET(aSocket[uIndex],&sFdRead))break;
			}
		
		   iByte = recvfrom(aSocket[uIndex],aBuffer+PACKER_HEADER+14,sizeof(aBuffer)-14-PACKER_HEADER,0,0,0);
		if(iByte<=0)
			{
			if(iByte<0)Sleep(20);
			continue;
			}

		if(uTurn!=uThTurn)break;

		if(uAllData>0x04000000)							// Nicht mehr als 64MB puffern
			{
			Sleep(100);
			continue;
			}


		memset(aBuffer+PACKER_HEADER  ,2,6);			// MAC-Adressen emulieren
		memset(aBuffer+PACKER_HEADER+6,4,6);
		aBuffer[PACKER_HEADER+12] = 0x08;				// Pakettype auf IP-Setzen
		aBuffer[PACKER_HEADER+13] = 0x00;

		uTick	= GetTickCount()-uStart;

		*(unsigned*)(aBuffer+ 0)	= uTick/1000+uTime;	// bpf_hdr von WinPcap emulieren
		*(unsigned*)(aBuffer+ 4)	=(uTick%1000)*1000;
		*(unsigned*)(aBuffer+ 8)	= iByte;
		*(unsigned*)(aBuffer+12)	= iByte;
		*(unsigned*)(aBuffer+16)	= PACKER_HEADER;

		if(FilterCmp(aBuffer+PACKER_HEADER,ucFliterData,ucFliterMask))
			{
			continue;
			}

		uSize = PACKER_HEADER+14+iByte;

			pPacket = (SnifferPacket*)HeapAlloc(hHeap,0,sizeof(SnifferPacket)+uSize);
		if(!pPacket)
			{
			Sleep(50);
			continue;
			}

		memcpy(pPacket->aData,aBuffer,uSize);
		pPacket->pNext = NULL;

		EnterCriticalSection(&sSynch);
														// Paket in die Kette einfgen
		if(!pFirst)
			{
			pLast			= pPacket;
			pFirst			= pPacket;
			uAllData		= iByte;
			}
		else{
			pFirst->pNext	= pPacket;
			pFirst			= pPacket;
			uAllData	   += iByte;
			}

		SetEvent(hEvent);

		LeaveCriticalSection(&sSynch);
		}


	bThread = FALSE;

return 0;
}


//*****************************************************************************
//*
//*		SnifferOpen
//*
//*****************************************************************************
//	ffnet eine SnifferVerbindung
//	pIpAddr	: Ist die IP-Adresse als Text. (z.B.: "127.0.0.1")
//	pBits	: Zeiger auf die Filterbits
//				[ 0.. 5] = Ziel-Mac-Adresse
//				[ 6..11] = Quell-Mac-Adresse
//				[12..13] = Ethernet-Typ
//				[14..15] = Daten nach Ethernet-Typ
//				[16]     = 0-127: Offset fr Filterbytes 17..19 (0=ab Offset 16)
//								  Filterbytes 0..11 sind fr MAC-Adressen
//				           255  : VLAN-ID prfen Filterbytes 18+19 --> VLAN
//						   254  : IP-Addresse filtern (ohne Richtungsprfung)
//									[ 0...3] = IP-A
//									[ 4...7] = IP-B
//									[ 8...9] = Port-A
//									[10..11] = Port-B
//									[17..19] = Daten
//								   Mask [16] = IP-Type (0x00=alle 0x11=UDP 0x06=TCP)
//						   253  : IP-Addresse filtern (mit Richtungsprfung)
//									[ 0...3] = IP-Source
//									[ 4...7] = IP-Destination
//									[ 8...9] = Port-Source
//									[10..11] = Port-Destination
//									[17..19] = Daten
//								   Mask [16] = IP-Type (0x00=alle 0x11=UDP 0x06=TCP)
//						   252  : Multi-Cast-Adressen immer durchlassen
//									[ 0...5] = MAC-Source
//									[ 5..11] = MAC-Destination
//									[12..15] = Pakettyp
//								   Mask [16] = Offset
//						   251  : IP-Addresse filtern (ohne Richtungsprfung und einzelen)
//									[ 0...3] = IP-A
//									[ 4...7] = IP-B
//									[ 8...9] = Port-A
//									[10..11] = Port-B
//									[17..19] = Daten
//								   Mask [16] = IP-Type (0x00=alle 0x11=UDP 0x06=TCP)
//						   250  : Profinet filtern
//									[ 0...5] = MAC
//									[ 6...7] = Port
//									[ 8..11] = IP
//								   Mask [16] = IP-Type (0x00=alle 0x01=RD 0x02=DCP 0x04=ARP 0x08=PING 0x10=UDP 0x20=MultiCast 0x40=Alarme)
//	pMask		: Zeiger auf die Filtermaske
//	iNoThread	: Keinen Empfangsthread starten
//	Ergibt ein Handle oder 0xFFFFFFFF bei einem Fehler.
unsigned SnifferOpen(const char *pIpAddr,const void *pFilterBits,const void *pFilterMask,int iNoThread)
{
char				cBuffer[1024];
HANDLE				hThread;
DWORD				uThread;
BYTE				aAddr[32];
struct sockaddr_in	sAddr;
unsigned			uSize;
unsigned			uTurn;
unsigned			uMax;
unsigned			uPos;
int					iBit;
int					iVal;



	if(!bInit)
		{
		if(WSAStartup(MAKEWORD(2,2),&sWasData)!=0)
			{
			return 0xFFFFFFFF;
			}

		bInit = TRUE;
		InitializeCriticalSection(&sSynch);
		hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
		}

	if(bOpen)											// Ist eine Verbindung bereits offen
		{
		return 0xFFFFFFFF;
		}

	uThTurn	= uThTurn+1;
	memset(aAddr,0,sizeof(aAddr));

														// Alle lokalen Adressen benutzen	
	if(!pIpAddr || !*pIpAddr || !strcmp(pIpAddr,"0.0.0.0") || !strcmp(pIpAddr,"0.0.0.0"))
		{
		uMax	= GetLocalIps(cBuffer,sizeof(cBuffer),1);
		pIpAddr	= cBuffer;
		}
	else{
		uMax	= 1;
		}


	uCount	= 0;


	for(uTurn=0;uTurn<uMax;uTurn++,pIpAddr+=strlen(pIpAddr)+1)
		{
		for(uPos=0;uPos<4;uPos++)
			{											// IP-Adresse dekodieren
			if(uPos)
				{
				if(*pIpAddr!='.')return 0xFFFFFFFF;
				pIpAddr++;
				}

			if(*pIpAddr<'0' || *pIpAddr>'9')
				{
				return 0xFFFFFFFF;
				}

			aAddr[uPos] = atoi(pIpAddr);

			while(*pIpAddr>='0' && *pIpAddr<='9')
				{
				pIpAddr++;
				}
			}

		if(*pIpAddr || uPos!=4)
			{
			continue;
			}

														// Ein neues Socker erstellen
		   aSocket[uCount] = socket(AF_INET,SOCK_RAW,IPPROTO_IP);
		if(aSocket[uCount] == INVALID_SOCKET)
			{
			continue;
			}

		memset(&sAddr, 0, sizeof(sAddr));
		memcpy(&sAddr.sin_addr.s_addr,aAddr,sizeof(sAddr.sin_addr.s_addr));
		sAddr.sin_family = AF_INET;
		sAddr.sin_port	 = 0;
	  
		if(bind(aSocket[uCount],(struct sockaddr*)&sAddr,sizeof(sAddr))==SOCKET_ERROR)
			{
			closesocket(aSocket[uCount]);
			aSocket[uCount] = -1;
			continue;
			}

		iBit = 1;
		iVal = 0;
																
		if(WSAIoctl(aSocket[uCount],SIO_RCVALL,&iBit,sizeof(iBit),0,0,(LPDWORD)&iVal,0,0)==SOCKET_ERROR)
			{
			closesocket(aSocket[uCount]);
			aSocket[uCount] = -1;
			continue;
			}

		
		uCount++;

		if(uCount>=SSN_MAX_SOCKET)
			{
			break;
			}
		}


	if(uCount==0)										// Konnte kein Socker geffnet werden
		{
		return 0xFFFFFFFF;
		}

	uSize = 0x400000/uCount;							// 4 MB Empfangspuffer


	for(uPos=0;uPos<uCount;uPos++)
		{
		if(setsockopt(aSocket[uPos],SOL_SOCKET,SO_RCVBUF,(char*)&uSize,sizeof(uSize))==-1)
			{
			uSize = 0x20000;

			if(setsockopt(aSocket[uPos],SOL_SOCKET,SO_RCVBUF,(char*)&uSize,sizeof(uSize))==-1)
				{
				uSize = 0xFFFF;
				setsockopt(aSocket[uPos],SOL_SOCKET,SO_RCVBUF,(char*)&uSize,sizeof(uSize));
				}
			}
		}




	memcpy(ucFliterData,pFilterBits,20);
	memcpy(ucFliterMask,pFilterMask,20);

	bOpen	= TRUE;
	uStart	= GetTickCount();
	uTime	= (unsigned)time(0);

	if(iNoThread==0)									// Einen Empfangsthread starten
		{
		if(!hHeap)
			{
			LPVOID	pData;

				hHeap = HeapCreate(0,0x04000000,0x04000000*4);
			if(!hHeap)hHeap=GetProcessHeap();

			pData = HeapAlloc(hHeap,0,0x02000000);
			HeapFree(hHeap,0,pData);
			}

		ResetEvent(hEvent);
		bThread = TRUE;
		hThread = CreateThread(NULL,0x40000+SSN_MAX_PACKET,SnifferThread,NULL,0,&uThread);
		CloseHandle(hThread);
		}
	else{												// Ohne Empfangsthread arbeiten
		bThread = FALSE;
		}


return 0x11223344;
}

//*****************************************************************************
//*
//*		SnifferClose
//*
//*****************************************************************************
//	Schliet eine Sniffer-Verbindung
//	uHandle		: Ist das Handle fr den Sniffer
//	Ergibt 0 wenn alles ok war bzw. -1 bei einem Fehler
unsigned SnifferClose(unsigned uHandle)
{
SnifferPacket   *pPacket;



	if(uHandle!=0x11223344 || !bOpen)
		{
		return -1;
		}

	while(uCount>0)										// Alle Sockets schlieen
		{
		uCount--;
		closesocket(aSocket[uCount]);
		aSocket[uCount]	= -1;
		}

	while(bThread)										// Warte bis der Thread gestoppt ist
		{
		uThTurn = uThTurn+1;
		Sleep(50);
		}


	EnterCriticalSection(&sSynch);

	for(;;)												// Alle Pakete lschen
		{
			pPacket	= (SnifferPacket*)pLast;
		if(!pPacket)break;

			pLast = pPacket->pNext;
		if(!pLast)
			{
			ResetEvent(hEvent);
			pFirst=0;
			}

		HeapFree(hHeap,0,pPacket);
		}


	LeaveCriticalSection(&sSynch);


	bOpen	= FALSE;



return 0;
}

//*****************************************************************************
//*
//*		SnifferReceiveWait
//*
//*****************************************************************************
//	Diese Funktion wartet bis Pakete im Empfangspuffer sind. Wenn ja knnen
//	diese anschlieent mit EthernetReadPacket empfangen werden.
//	uHandle		: Ist das Handle fr den Sniffer
//	uTimeout	: Ist die Zeit in Millisekunden die auf ein Paket gewartret wird
//	Ergibt		0 = Alles ok
//				1 = Timeout beim warten auf Pakete
//				4 = Das Gert ist nicht geffnet
unsigned SnifferReceiveWait(unsigned uHandle,unsigned uTimeout)
{
struct timeval  sTimeVal;
fd_set          sFdRead;
unsigned		uIndex;
unsigned		uSock;
unsigned		uStop;
unsigned		uTurn;
unsigned		uTick;
unsigned		uItem;
unsigned		uLoop;
int				iWait;
int				iByte;
int				iRet;



	if(uHandle!=0x11223344 || !bOpen)return 4;				// Handle prfen


	if(uPacket!=0)											// Ist schon ein Paket im Puffer
		{
		return 0;
		}


	if(bThread)												// Daten werden ber einen Thread empfangen
		{
		if(pLast)return 0;

		if(WaitForSingleObject(hEvent,uTimeout)!=WAIT_OBJECT_0)
			{
			return 1;
			}

		EnterCriticalSection(&sSynch);

		iRet = (pLast==0)? 1:0;

		LeaveCriticalSection(&sSynch);

		return iRet;
		}


	uIndex	= 0;
	uStop	= GetTickCount()+uTimeout;


	for(uTurn=0;;uTurn++)									// Hauptschleife
		{
		iWait = uStop-GetTickCount();

	    if(iWait<0)
			{
			if(uTurn)return 1;
			iWait = 0;
			}

		sTimeVal.tv_sec  =  iWait/1000;
		sTimeVal.tv_usec = (iWait%1000)*1000;

		FD_ZERO(&sFdRead);

		uSock = aSocket[0]+1;

		for(uItem=0;uItem<uCount;uItem++)					// Socket-Liste aufbauen
			{
			FD_SET(aSocket[uItem],&sFdRead);
			if(uSock<aSocket[uItem])uSock=aSocket[uItem]+1;
			}

		if(!select(uSock+1,&sFdRead,0,0,&sTimeVal))			// Warte auf Empfang
			{
			return 1;
			}

		for(uLoop=0;uLoop<=uCount;uLoop++)					// Suche nchstes Socket mit Empfang
			{
			if(uIndex>=uCount)uIndex=0;
			if(FD_ISSET(aSocket[uIndex],&sFdRead))break;
			}

		   iByte = recvfrom(aSocket[uIndex],aPacket+PACKER_HEADER+14,sizeof(aPacket)-14-PACKER_HEADER,0,0,0);
		if(iByte<=0)return 0;

		memset(aPacket+PACKER_HEADER  ,2,6);				// MAC-Adressen emulieren
		memset(aPacket+PACKER_HEADER+6,4,6);
		aPacket[PACKER_HEADER+12] = 0x08;					// Pakettype auf IP-Setzen
		aPacket[PACKER_HEADER+13] = 0x00;

		uTick	= GetTickCount()-uStart;

		*(unsigned*)(aPacket+ 0)	= uTick/1000+uTime;		// bpf_hdr von WinPcap emulieren
		*(unsigned*)(aPacket+ 4)	=(uTick%1000)*1000;
		*(unsigned*)(aPacket+ 8)	= iByte;
		*(unsigned*)(aPacket+12)	= iByte;
		*(unsigned*)(aPacket+16)	= PACKER_HEADER;

		if(!FilterCmp(aPacket+PACKER_HEADER,ucFliterData,ucFliterMask))
			{
			break;
			}
		}


	uPacket = iByte+14;



return 0;
}


//*****************************************************************************
//*
//*		SnifferReadPacket
//*
//*****************************************************************************
//	Liet das nchste Paket vom Sniffer ein
//	uHandle		: Handle der Schnittstelle
//	pSize		: Hier wird die Paketgre gespeichert
//	Ergibt einen Zeiger auf das Paket, bzw. 0 wenn kein Paker empfangen wurde.
//					*(int*)(pPacket-20)	= UTC-Zeit in Sekunden
//					*(int*)(pPacket-16)	= Microsekuden Zeitteil
//					*(int*)(pPacket-12)	= Paketgre in Byte
//					*(int*)(pPacket- 8)	= Paketgre in Byte
//					*(int*)(pPacket- 4)	= Headergre in Byte (20)
unsigned char *SnifferReadPacket(unsigned uHandle,unsigned *pSize)
{
SnifferPacket  *pPacket;
unsigned		uSize;
unsigned 		uByte;


	if(bThread)												// Daten werden ber einen Thread empfangen
		{
		if(uPacket!=0)										// Ist schon ein Paket im Puffer
			{
			if(pSize)*pSize=uPacket;
			return (unsigned char*)(aPacket+PACKER_HEADER);
			}

		if(pLast==0)
			{
			if(pSize)*pSize=0;
			return NULL;
			}


		EnterCriticalSection(&sSynch);

			pPacket	= (SnifferPacket*)pLast;
		if(!pPacket)
			{
			LeaveCriticalSection(&sSynch);
			if(pSize)*pSize=0;
			return 0;
			}

			pLast = pPacket->pNext;
		if(!pLast)											// Wurden alle Pakete aus dem Puffer entfernt
			{
			ResetEvent(hEvent);
			pFirst=0;
			}

		uByte = *(unsigned*)(pPacket->aData+12);

		if(uByte<uAllData)
				uAllData -= uByte;
		else	uAllData  = 0;

		LeaveCriticalSection(&sSynch);


		uSize	= PACKER_HEADER+14+uByte;
		memcpy(aPacket,pPacket->aData,uSize);
		HeapFree(hHeap,0,pPacket);

		uPacket = uByte+14;
		if(pSize)*pSize=uPacket;

		return (unsigned char*)(aPacket+PACKER_HEADER);
		}


	if(uPacket==0)											// Ist schon ein Paket im Puffer
		{
		if(SnifferReceiveWait(uHandle,0))return 0;
		}

	if(pSize)*pSize=uPacket;



return (unsigned char*)(aPacket+PACKER_HEADER);
}

//*****************************************************************************
//*
//*		SnifferFreePacket
//*
//*****************************************************************************
//	Gibt ein zuvor gelesenes Paket wiederfrei
//	uHandle		: Handle der Schnittstelle
//	pData		: Zeiger auf das Paket
//	Ergibt		0 = Alles ok
//				4 = Das Gert ist nicht geffnet
//				5 = Falscher Paketzeiger
unsigned SnifferFreePacket(unsigned uHandle,const void *pData)
{

	if(uHandle!=0x11223344 || !bOpen)return 4;

	if(uPacket==0 || pData!=(aPacket+PACKER_HEADER))
		{
		return 5;
		}

	uPacket = 0;


return 0;
}
