//*****************************************************************************
//*
//*
//*		SslFunctions.cpp
//*
//*
//*****************************************************************************
#include	<winsock2.h>
#include	<windows.h>
#include	<string.h>
#include	<stddef.h>
#include	<stdlib.h>
#include	<stdio.h>


#include	"SslFunctions.h"

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#define 	SSL_API				extern "C"
#define 	LOAD_PROC(n)		*(FARPROC*)(&n)=GetProcAddress(hSslDll,#n); if(!n)goto Exit;
#define 	LOAD_FUNC(n)		*(FARPROC*)(&n)=GetProcAddress(hLibDll,#n); if(!n)goto Exit;
#ifndef 	KEY_WOW64_64KEY
#define		KEY_WOW64_64KEY		0x00000100
#endif
#ifndef 	SSL_ERROR_NONE
#define		SSL_ERROR_NONE				0
#define 	SSL_ERROR_SSL				1
#define 	SSL_ERROR_WANT_READ			2
#define 	SSL_ERROR_WANT_WRITE		3
#define 	SSL_ERROR_WANT_X509_LOOKUP	4
#define 	SSL_ERROR_SYSCALL			5
#define 	SSL_ERROR_ZERO_RETURN		6
#define 	SSL_ERROR_WANT_CONNECT		7
#define 	SSL_ERROR_WANT_ACCEPT		8
#endif

#ifndef 	SSL_get_cipher
#define		SSL_get_cipher(s)			SSL_CIPHER_get_name(SSL_get_current_cipher(s))
#endif

#define     SSL_LOCK()					EnterCriticalSection(&sSslSection)
#define     SSL_UNLOCK()				LeaveCriticalSection(&sSslSection)




typedef	char		SSL_CIPHER;
typedef	char		SSL_METHOD;
typedef	char		SSL;
typedef	const SSL	SSL_CTX;

typedef	int					(_cdecl *SSL_library_init_Type)(void);
typedef	void				(_cdecl *SSL_load_error_strings_Type)(void);
typedef	const SSL_CTX  	   *(_cdecl *SSL_CTX_new_Type)(const SSL_METHOD *meth);
typedef	void				(_cdecl *SSL_CTX_free_Type)(SSL_CTX *);
typedef	SSL				   *(_cdecl *SSL_new_Type)(SSL_CTX *ctx);
typedef	void				(_cdecl *SSL_free_Type)(SSL *ssl);
typedef	int					(_cdecl *SSL_get_fd_Type)(const SSL *ssl);
typedef	int					(_cdecl *SSL_set_fd_Type)(const SSL *ssl,int fd);
typedef	int					(_cdecl *SSL_connect_Type)(const SSL *ssl);
typedef	int					(_cdecl *SSL_write_Type)(SSL *ssl,const void *buf, int num);
typedef	int					(_cdecl *SSL_read_Type)(SSL *ssl, void *buf, int num);
typedef	int					(_cdecl *SSL_get_error_Type)(const SSL *ssl, int ret);
typedef	const char		   *(_cdecl *SSL_CIPHER_get_name_Type)(const SSL_CIPHER *c);
typedef	const SSL_CIPHER   *(_cdecl *SSL_get_current_cipher_Type)(const SSL *s);
typedef	char        	   *(_cdecl *ERR_error_string_Type)(unsigned long e, char *buf);
typedef	long				(_cdecl *ERR_get_error_Type)(void);
typedef	const SSL_METHOD   *(_cdecl *TLSv1_2_client_method_Type)(void);

typedef struct
	{
	HANDLE					hWaitSem;						// Warten auf Thread
	HANDLE					hThread;						// Thread-Handle
	DWORD					dwThreadId;						// Thread-ID
	WORD					uServerPort;					// Port fr lokalen Server
	TcpHandle				hServer;						// Handle vom lokalen Server
	TcpHandle				hClient;						// Handle vom lokalen Client
	WORD					uPort;							// TCP-Port
	IpAddr					sAddr;							// IP-Adresse
	int volatile			iState;							// 0=Warten 1=Timeout 2=Fehler
	int volatile			iExit;							// Ist der Aufrufer raus
	TcpCancel			   *pCancel;						// Abbruch fr Verbindungsaufbau
    const SSL_METHOD	   *pMethod;						// SSL-Methode
    SSL_CTX     		   *pSslCtx;						// Zeiger auf SSL-Framework
	SSL					   *pSsl;							// Zeiger auf SSL-Daten
	}SslOpenData;

struct in_addr6_
    {
    unsigned char           s6_addr[16];					// IPv6 address
    };

struct sockaddr_in6_
    {
    short                   sin6_family;                    // AF_INET6
    unsigned short          sin6_port;                      // Transport level port number
    unsigned long           sin6_flowinfo;                  // IPv6 flow information
    struct in_addr6_        sin6_addr;                      // IPv6 address
    unsigned long           sin6_scope_id;                  // Set of interfaces for a scope.
    };


static	HMODULE						hSslDll		= NULL;		// Handle der ssleay32 Dll
static	HMODULE						hLibDll		= NULL;		// Handle der libeay32 Dll
static	int							iSslInit	= 0;		// Wurde alles initialisiert
static	IpAddr						iSslLocal;				// Lokale IP-Adresse (127.0.0.1)
static	CRITICAL_SECTION			sSslSection;			// Globaler Mutext fr SSL
static	SSL_library_init_Type		SSL_library_init;
static	SSL_load_error_strings_Type	SSL_load_error_strings;
static	SSL_new_Type				SSL_new;
static	SSL_free_Type				SSL_free;
static	SSL_CTX_new_Type			SSL_CTX_new;
static	SSL_CTX_free_Type			SSL_CTX_free;
static	SSL_get_fd_Type				SSL_get_fd;
static	SSL_set_fd_Type				SSL_set_fd;
static	SSL_connect_Type			SSL_connect;
static	SSL_write_Type				SSL_write;
static	SSL_read_Type				SSL_read;
static	SSL_get_error_Type			SSL_get_error;
static	SSL_CIPHER_get_name_Type	SSL_CIPHER_get_name;
static	SSL_get_current_cipher_Type	SSL_get_current_cipher;
static	TLSv1_2_client_method_Type	TLSv1_2_client_method;
static	ERR_error_string_Type		ERR_error_string;
static	ERR_get_error_Type			ERR_get_error;

extern "C" void TcpHandleFake(TcpHandle hHandle,IpAddr *pAddr,int iPort);

//*****************************************************************************
//*
//*		SslLoadDll
//*
//*****************************************************************************
//	Ld die SSL-Dll
//	Erigibt 0 bei einem Fehler 1 wenn ok, oder 2 wenn die DLL gelden war.
SSL_API int SslLoadDll()
{
CHAR	cDll[MAX_PATH];
DWORD	dwSize;
DWORD	dwType;
HKEY	hKey;
int		iLen;
int		iErr;


	if(hSslDll)return 2;

	   iErr = RegOpenKeyExA(HKEY_LOCAL_MACHINE,"Software\\AZ\\AZ-Tools",0,KEY_READ|KEY_WOW64_64KEY,&hKey);
	if(iErr==ERROR_SUCCESS)
		{
		cDll[0] = 0;
		dwType	= REG_SZ;
		dwSize	= sizeof(cDll)-32;
		iErr	= RegQueryValueExA(hKey,"Path",0,&dwType,(LPBYTE)cDll,&dwSize);
				  RegCloseKey(hKey);

		if(iErr==ERROR_SUCCESS && cDll[0])
			{
			iLen = strlen(cDll);
			if(iLen>0 && cDll[iLen-1]!='\\' && cDll[iLen-1]!='/')
				{
				cDll[iLen] = '\\';
				iLen++;
				}

			strcpy(cDll+iLen,"Tools\\ssleay32.dll");
			hSslDll = LoadLibraryExA(cDll,NULL,LOAD_WITH_ALTERED_SEARCH_PATH);
			}
		}


	if(!hSslDll)
		{
		hSslDll = LoadLibraryExA("D:\\Programme\\AZ-Tools\\Tools\\ssleay32.dll",NULL,LOAD_WITH_ALTERED_SEARCH_PATH);
		}

	if(!hSslDll)
		{
		hSslDll = LoadLibraryExA("C:\\Programme\\AZ-Tools\\Tools\\ssleay32.dll",NULL,LOAD_WITH_ALTERED_SEARCH_PATH);
		}

	if(!hSslDll)
		{
		hSslDll = LoadLibraryA("ssleay32.dll");
		}

	if(!hSslDll)
		{
		return 0;
		}


		hLibDll = GetModuleHandleA("libeay32.dll");
	if(!hLibDll)goto Exit;


	LOAD_PROC(SSL_library_init)							// Alternative Pfade laden
	LOAD_PROC(SSL_load_error_strings)
	LOAD_PROC(SSL_new)
	LOAD_PROC(SSL_free);
	LOAD_PROC(SSL_CTX_new)
	LOAD_PROC(SSL_CTX_free);
	LOAD_PROC(SSL_get_fd)
	LOAD_PROC(SSL_set_fd)
	LOAD_PROC(SSL_connect)
	LOAD_PROC(SSL_write)
	LOAD_PROC(SSL_read)
	LOAD_PROC(SSL_get_error)
	LOAD_PROC(SSL_CIPHER_get_name)
	LOAD_PROC(SSL_get_current_cipher)
	LOAD_PROC(TLSv1_2_client_method)
	LOAD_FUNC(ERR_error_string)
	LOAD_FUNC(ERR_get_error)


return 1;

Exit:

	FreeLibrary(hSslDll);
	hSslDll = 0;


return 0;
}

//*****************************************************************************
//*
//*		SslGetProc
//*
//*****************************************************************************
//	Holt den Zeiger auf eine OpenSsl-Funktion
//	pFuncPtr	: Zeiger auf den Funktionspointer (z.B.  &pMyProc)
//	pName		: Ist der Name der Funktion
//	uMode		: Aus welcher DLL kommt die Funktion (0=ssleay32 1=libeay32)
//	Erigibt 0 bei einem Fehler 1 wenn ok.
SSL_API int SslGetProc(void *pFuncPtr,const char *pName,unsigned uMode)
{
FARPROC		pFunc;


	if(!hSslDll || uMode>1)return 0;

	pFunc = GetProcAddress((uMode)? hLibDll:hSslDll,pName);

	if(!pFunc)return 0;

	*(FARPROC*)(pFuncPtr) = pFunc;


return 1;
}

//*****************************************************************************
//*
//*		SslRecvThread
//*
//*****************************************************************************
//	Empfangs-Thread fr SSL-Daten
static DWORD WINAPI SslRecvThread(LPVOID pParam)
{
SslOpenData			   *pData=(SslOpenData*)pParam;
char					cBuffer[0x1000];
int						iSize;
int						iRet;



	for(;;)												// Daten empfangen
		{
		if(TcpIsBroken(pData->hClient))break;

		   iSize = SSL_read(pData->pSsl,cBuffer,sizeof(cBuffer));
		if(iSize==0){Sleep(10);continue;}
		if(iSize<0)break;


		   iRet = TcpPut(pData->hClient,cBuffer,iSize);
		if(iRet>=iSize)continue;
		if(iRet<0)break;

		Sleep(20);
		iRet += TcpPut(pData->hClient,cBuffer+iRet,iSize-iRet);
		if(iRet!=iSize)break;
		}


	TcpShutdown(pData->hClient);



return 0;
}


//*****************************************************************************
//*
//*		SslSendThread
//*
//*****************************************************************************
//	Sende-Thread fr SSL-Daten
static DWORD WINAPI SslSendThread(LPVOID pParam)
{
char					cBuffer[0x1000];
SslOpenData			   *pData=(SslOpenData*)pParam;
struct sockaddr_in     *pAddr;
struct sockaddr_in6_    sAddr;
HANDLE					hThread;
DWORD					dwRecvId;
static int				iNext;
int						iLast;
int						iTurn;
int						iSock;
int						iSize;
int						iErr;
int						iRet;




	iLast = INVALID_SOCKET;
	iSock = socket(AF_INET, SOCK_STREAM, 0);

	if(iSock==INVALID_SOCKET)
		{
		SSL_LOCK();
		if(!pData->iState)pData->iState = 2;
		SSL_UNLOCK();
        goto Exit;
		}

	memset(&sAddr,0,sizeof(sAddr));

	if(IsIpV6(&pData->sAddr))							// Ist es eine IPV6 Adresse
		{
        sAddr.sin6_family      =  AF_INET6;
        sAddr.sin6_port        =  htons(pData->uPort);

		memcpy(sAddr.sin6_addr.s6_addr,pData->sAddr.aAddr,16);

        iSize = sizeof(sockaddr_in6_);
        }
    else if(iSock!=INVALID_SOCKET)                      // IPV4 on dual socket
        {
		pAddr = (struct sockaddr_in*)&sAddr;

		pAddr->sin_family      = AF_INET;
		pAddr->sin_port        = htons(pData->uPort);
		pAddr->sin_addr.s_addr = GetIpV4(&pData->sAddr);

		iSize = sizeof(sockaddr_in);
		}

	if(pData->pCancel)									// Gibt es Cancel-Daten
		{
		pData->pCancel->iSocket = iSock;
        pData->pCancel->iValue  = 0x5A71D34E;
        }
														// Zur Gegenstelle verbinden
	iErr = connect(iSock,(struct sockaddr*)&sAddr,iSize);


	SSL_LOCK();

	if(pData->pCancel && !pData->iExit)
		{
		pData->pCancel->iSocket = INVALID_SOCKET;
		pData->pCancel->iValue  = 0;
		}

	if(iErr && !pData->iState)							// Gab es einen Verbindungsfehler
		{
		pData->iState = 2;
		}

	if(pData->iState)									// Abbruch vom Aufrufer
		{
		SSL_UNLOCK();
		goto Exit;
		}

	SSL_UNLOCK();

		pData->pMethod	= TLSv1_2_client_method();
    if(!pData->pMethod)									// Passt die Methode
		{
		if(!pData->iState)pData->iState = 2;
		SSL_UNLOCK();
        goto Exit;
		}

		pData->pSslCtx	= SSL_CTX_new(pData->pMethod);
    if(!pData->pSslCtx)									// Passt das Framework
		{
		SSL_LOCK();
		if(!pData->iState)pData->iState = 2;
		SSL_UNLOCK();
        goto Exit;
		}

		pData->pSsl = SSL_new(pData->pSslCtx);
    if(!pData->pSsl)									// Passt das SSL Handle
		{
		SSL_LOCK();
		if(!pData->iState)pData->iState = 2;
		SSL_UNLOCK();
        goto Exit;
		}


    iLast = SSL_get_fd(pData->pSsl);

	SSL_set_fd(pData->pSsl,iSock);						// Socket fr Entschlsselungseite setzen

       iErr = SSL_connect(pData->pSsl);
    if(iErr<0)											// Konnte die SSL-Verbindung aufgebaut werden
		{
		SSL_LOCK();
		if(!pData->iState)pData->iState = 2;
		SSL_UNLOCK();
        goto Exit;
		}



	for(iTurn=0;;iTurn++)								// Erstelle einen lokalen Server
		{
		   iNext++;
		if(iNext<39270 || iNext>39370)
			{
			iNext=39270;
			}

		if(pData->iState!=0)goto Exit;
		   pData->hServer = TcpOpen(&iSslLocal,iNext,TCP_SERVER,0);
		if(pData->hServer)
			{
			pData->uServerPort = iNext;
			break;
			}

		if(iTurn>100)
			{
			SSL_LOCK();
			if(!pData->iState)pData->iState = 2;
			SSL_UNLOCK();
			goto Exit;
			}
		}


	ReleaseSemaphore(pData->hWaitSem,1,NULL);			// Den Aufrufer freigeben


	for(;;)												// Warte auf die Client-Verbindung
		{
		if(pData->iState!=0)goto Exit;
		   pData->hClient = TcpAcceptWait(pData->hServer,NULL,NULL,1000);
		if(pData->hClient)break;
		Sleep(20);
		}


	hThread = CreateThread(NULL,0x8000,SslRecvThread,pData,0,&dwRecvId);

	for(;;)												// Daten empfangen
		{
		if(TcpIsBroken(pData->hClient))break;

		   iSize = TcpGetNext(pData->hClient,cBuffer,sizeof(cBuffer),1000);
		if(iSize==0)continue;
		if(iSize <0)break;

		   iRet = SSL_write(pData->pSsl,cBuffer,iSize);
		if(iRet<0)break;

		if(iRet<iSize)									// Noch nicht alles versand
			{
			Sleep(20);
			iRet += SSL_write(pData->pSsl,cBuffer+iRet,iSize-iRet);
			if(iRet!=iSize)break;
			}
		}

	SSL_LOCK();
	if(!pData->iState)pData->iState = 3;
	SSL_UNLOCK();

	shutdown(iSock,2);
	TcpShutdown(pData->hClient);
	WaitForSingleObject(hThread,INFINITE);				// Warte bis der Empfnger Thread beendet ist


Exit:


	if(iLast!=INVALID_SOCKET)
		{
		shutdown(iLast,2);
		}

	if(iSock!=INVALID_SOCKET)
		{
		shutdown(iSock,2);
		}

	if(pData->hClient)
		{
		TcpClose(pData->hClient);
		}

	if(pData->pSsl)
		{
		SSL_free(pData->pSsl);
		pData->pSsl = 0;
		}

	if(pData->pSslCtx)
		{
		SSL_CTX_free(pData->pSslCtx);
		pData->pSslCtx = 0;
		}


	while(!pData->iExit)Sleep(200);						// Warte bis der Aufrufer weg ist
	ReleaseSemaphore(pData->hWaitSem,1,NULL);
	CloseHandle(pData->hThread);


	if(iLast!=INVALID_SOCKET)
		{
		closesocket(iLast);
		}

	if(iSock!=INVALID_SOCKET)
		{
		closesocket(iSock);
		}

	if(pData->hServer)
		{
		TcpClose(pData->hServer);
		}

	delete pData;



return 0;
}


//*****************************************************************************
//*
//*     SslOpenWait
//*
//*****************************************************************************/
//  Creates a TCP socket for a SLL conrction
//  pAddr       : Is the IP adress.  i.e. IpAddress(&iAddr,"127.0.0.1",0);
//                If this pointer is zero an it is a sever socket the any
//                address will be used.
//  uPort       : TCP port number
//  iTimeout    : Is the timeout for the connect procces in ms. (0=no timeout)
//  pCancel     : Handle for the cancel operation (0=no cancel operation)
//  iFlags      : Several Flags for the connection:
//                  TCP_NOBLOCKING = sets the socket in the no blocking mode
//                  TCP_KEEP_ALIVE = enable sending of keepalive packets
//                  TCP_NODELAYACK = disable nagle algorithm
//                  TCP_REUSEADDR  = allows to reuser an used tcp port
//                  TCP_CLOSEDOWN  = colse socket at TcpShutdown(...)
//                  Bit 16..31     = is the local port (0=auto, use TCP_USEPORT(a))
//  Retrns 0 at an error, or a TCP handle
SSL_API TcpHandle SslOpenWait(IpAddr *pAddr,unsigned short uPort,int iTimeout,TcpCancel *pCancel,int iFlags)
{
SslOpenData	   *pData;
TcpHandle		hClient;
unsigned		uStart;
unsigned		uWait;
unsigned		uDiff;
unsigned		uTurn;



	if(!iSslInit)										// Alles Initialisieren
		{
		iSslInit = 1;
		InitializeCriticalSection(&sSslSection);
		IpAddressA(&iSslLocal,"127.0.0.1");
		SslLoadDll();

		if(!hSslDll)return NULL;

		SSL_library_init();
		SSL_load_error_strings();
		}

	if(!hSslDll)return NULL;							// Ist die SSL geladen

	uStart				= GetTickCount();
	pData				= new SslOpenData;
	memset(pData,0,sizeof(SslOpenData));

	pData->hWaitSem		= CreateSemaphore(NULL,0,1,NULL);
	pData->pCancel		= pCancel;
	pData->uPort		= uPort;
	pData->sAddr		=*pAddr;

	if(iTimeout==0)iTimeout=INFINITE;


	pData->hThread = CreateThread(NULL,0x8000,SslSendThread,pData,0,&pData->dwThreadId);

														// Warte auf Thread
	if(WaitForSingleObject(pData->hWaitSem,iTimeout)!=WAIT_OBJECT_0)
		{
		SSL_LOCK();
		pData->iState = 1;
		pData->iExit  = 1;
		SSL_UNLOCK();
		return NULL;
		}


	SSL_LOCK();

	if(pData->iState)
		{
		pData->iExit  = 1;
		SSL_UNLOCK();
		return NULL;
		}

	SSL_UNLOCK();


	for(uTurn=0;;uTurn++)								// Warte auf die Client-Verbindung
		{
		if(iTimeout==INFINITE)
			{
			uWait = 10000;
			}
		else{
			uDiff = GetTickCount()-uStart;

			if((int)uDiff>iTimeout)
				{
				if(uTurn)break;
				uWait = 2000;
				}
			else{
				   uWait = iTimeout-uDiff;
				if(uWait< 1000)uWait=1000;
				if(uWait>10000)uWait=10000;
				}
			}


		   hClient = TcpOpenWait(&iSslLocal,pData->uServerPort,uWait,pCancel,TCP_CLIENT,iFlags);
		if(hClient)
			{
			TcpHandleFake(hClient,pAddr,uPort);
			pData->iExit = 1;
			return hClient;
			}
		}


	pData->iExit = 1;



return NULL;
}


