//*****************************************************************************
//*
//*
//*		StartProg.h	
//*
//*
//*****************************************************************************
//	
//	Klasse zum Starten von Programmen
//	
#ifndef 	__STARTPROG_H__
#define 	__STARTPROG_H__

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#include	<Afx.h>
	#include	<AfxWin.h>
#else
	#include	<Windows.h>
#endif

#include		<stdio.h>
#include		<string.h>
#include		<stdarg.h>
#include		<stdlib.h>


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER 
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif 	
#endif 	




#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	zchar		wchar_t
#define 	startlen	(int)wcslen
#else
#define 	zchar		char
#define 	startlen	(int)strlen
#endif


#define 	CSP_PARAM_MAX		32						// Maximale Anzahl an Parametern


#define 	CSP_NOWAIT			0x00000000				// Nicht warten bis Programm beendet ist
#define 	CSP_WAIT			0x80000000				// Warten bis Programm beendet ist
#define		CSP_SETSHOW			0x40000000				// Anzeige Modus setzen
#define		CSP_NOHANLES		0x20000000				// Die File-Handle nicht teilen
#define		CSP_SYSTEM			0x10000000				// Datei ber Command.com auftufen

#define 	CSP_TYPE_INPUT		0						// Handles von Input-Pipe
#define 	CSP_TYPE_OUTPUT		1						// Handles von Output-Pipe
#define 	CSP_TYPE_ERROR		2						// Handles von Error-Pipe
#define 	CSP_TYPE_SYSTEM		3						// Handles von Error-Pipe

#define 	CSP_HIDE            (CSP_SETSHOW|SW_HIDE)
#define 	CSP_SHOWNORMAL      (CSP_SETSHOW|SW_SHOWNORMAL)
#define 	CSP_NORMAL          (CSP_SETSHOW|SW_NORMAL)
#define 	CSP_SHOWMINIMIZED   (CSP_SETSHOW|SW_SHOWMINIMIZED)
#define 	CSP_SHOWMAXIMIZED   (CSP_SETSHOW|SW_SHOWMAXIMIZED)
#define 	CSP_MAXIMIZE        (CSP_SETSHOW|SW_MAXIMIZE)
#define 	CSP_SHOWNOACTIVATE  (CSP_SETSHOW|SW_SHOWNOACTIVATE)
#define 	CSP_SHOW            (CSP_SETSHOW|SW_SHOW)
#define 	CSP_MINIMIZE        (CSP_SETSHOW|SW_MINIMIZE)
#define 	CSP_SHOWMINNOACTIVE (CSP_SETSHOW|SW_SHOWMINNOACTIVE)
#define 	CSP_SHOWNA          (CSP_SETSHOW|SW_SHOWNA)
#define 	CSP_RESTORE         (CSP_SETSHOW|SW_RESTORE)
#define 	CSP_SHOWDEFAULT     (CSP_SETSHOW|SW_SHOWDEFAULT)
#define 	CSP_FORCEMINIMIZE   (CSP_SETSHOW|SW_FORCEMINIMIZE)

#define 	CSP_PIPE_NAMED		0x20000000				// Eine Pipe mit Namen erstellen
#define 	CSP_PIPE_OVERLAPPED	FILE_FLAG_OVERLAPPED	// Eine Pipe mit Overlapped-Flag



//*****************************************************************************
//*
//*		KLASSE	StartProg
//*
//*****************************************************************************
class	CStartProg
{
public:

		CStartProg();
		CStartProg(const zchar *pFilename);
	   ~CStartProg();

		zchar	   *SetFilename   (const zchar *pFilename);
		zchar	   *SetDirectory  (const zchar *pDirPath);
		zchar	   *SetDirectory  (const zchar *pDirPath,int iLen);
		int			SetParam	  (const zchar *pParam  ,int iLen);
		int			SetParam	  (const zchar *pParam           );
		int			SetParamEx	  (const zchar *pParam  ,int iLen,const zchar *pPrefix,int iLenP,const zchar *pSufix=0,int iLenS=0);
		int			SetParamEx	  (const zchar *pParam  ,         const zchar *pPrefix,int iLenP,const zchar *pSufix=0,int iLenS=0);
		int			SetParamEx	  (const zchar *pParam  ,int iLen,const zchar *pPrefix,int iLenP,const zchar *pSufix);
		int			SetParamEx	  (const zchar *pParam  ,         const zchar *pPrefix,int iLenP,const zchar *pSufix);
		int			SetParamEx	  (const zchar *pParam  ,int iLen,const zchar *pPrefix,          const zchar *pSufix=0,int iLenS=0);
		int			SetParamEx	  (const zchar *pParam  ,         const zchar *pPrefix,          const zchar *pSufix=0,int iLenS=0);
		int			SetParamEx	  (const zchar *pParam  ,int iLen,const zchar *pPrefix,          const zchar *pSufix);
		int			SetParamEx	  (const zchar *pParam  ,         const zchar *pPrefix,          const zchar *pSufix);
		int			SetParamMulti (const zchar *pParam  ,int iLen=-1);
		int	 _cdecl SetParamFormat(const zchar *pFormat ,...);
		void		SetEnvironment(const zchar *pName,const zchar *pValue);
		void		SetEnvironment(const zchar *pName,int          iValue);
		void		SetEnvironment(      zchar *pName);
		void		SetTitle      (const zchar *pTitle);
		void		SetFocus	  ();
		void		SetShow		  (int    iMode  );
		void		SetShowPos	  (POINT  sPos   );
		void		SetShowPos	  (int    iXpos ,int iYpos );
		void		SetShowSize	  (int    iXSize,int iYsize);
		void		SetShowSize	  (SIZE   sSize  );
		void		SetShowRect	  (LPRECT pRect  );
		void		SetShowColor  (int    iColors);
		void		SetWaitTime   (UINT	  uTime  );

		void		SetStdIn      (HANDLE hHandle);
		void		SetStdIn      (FILE  *pHandle);
		void		SetStdIn      (int	  iHandle);
		void		SetStdOut     (HANDLE hHandle);
		void		SetStdOut     (FILE  *pHandle);
		void		SetStdOut     (int	  iHandle);
		void		SetStdErr     (HANDLE hHandle);
		void		SetStdErr     (FILE  *pHandle);
		void		SetStdErr     (int	  iHandle);

		BOOL		SetStdInPipe  (HANDLE &hHandle,DWORD dwSize=1024,HANDLE *pDelMode=NULL,DWORD dwTimeout=1000);
		BOOL		SetStdInPipe  (int	  &iHandle,DWORD dwSize=1024,int    *pDelMode=NULL);
		BOOL		SetStdOutPipe (HANDLE &hHandle,DWORD dwSize=1024,HANDLE *pDelMode=NULL,DWORD dwTimeout=1000);
		BOOL		SetStdOutPipe (int	  &iHandle,DWORD dwSize=1024,int    *pDelMode=NULL);
		BOOL		SetStdErrPipe (HANDLE &hHandle,DWORD dwSize=1024,HANDLE *pDelMode=NULL,DWORD dwTimeout=1000);
		BOOL		SetStdErrPipe (int	  &iHandle,DWORD dwSize=1024,int    *pDelMode=NULL);

		HANDLE		GetHandle	  (UINT uType,UINT uIndex=0);
		HANDLE		GetStdIn      ();
		HANDLE		GetStdOut     ();
		HANDLE		GetStdErr     ();

		void		SetIdPointer  (LPVOID pPointer);
		void		Reset         (BOOL bClosePipes=TRUE);
		void		Break         ();

		int			ParamCount    ();
		DWORD		GetExitCode   ();
		HWND		GetMainWindow (int uMaxTime=INFINITE);
		DWORD		SendMessage   (UINT  uMsg,void  *wParam  ,void  *lParam=0,int iMaxTime=INFINITE);
		DWORD		SendMessage   (UINT  uMsg,WPARAM wParam  ,void  *lParam  ,int iMaxTime=INFINITE);
		DWORD		SendMessage   (UINT  uMsg,WPARAM wParam=0,LPARAM lParam=0,int iMaxTime=INFINITE);
		BOOL		PostMessage   (UINT  uMsg,void  *wParam  ,void  *lParam=0,int iMaxTime=INFINITE);
		BOOL		PostMessage   (UINT  uMsg,WPARAM wParam  ,void  *lParam  ,int iMaxTime=INFINITE);
		BOOL		PostMessage   (UINT  uMsg,WPARAM wParam=0,LPARAM lParam=0,int iMaxTime=INFINITE);

		BOOL		Wait          (DWORD dwTime=INFINITE);
		BOOL		WaitForInit   (DWORD dwTime=INFINITE);
		BOOL		Terminate     (int iExitCode=0);
		BOOL		IsRunning     ();

		BOOL _cdecl Start(const zchar *pFilename,int iMode=CSP_NOWAIT,const zchar *pFormat=0,...);
		BOOL _cdecl Start(			 	 	     int iMode=CSP_NOWAIT,const zchar *pFormat=0,...);

protected:

		BOOL _cdecl SetParamFormat(const zchar **pFormat,va_list pArgs);
		BOOL _cdecl Start(const zchar *pFilename,int iMode,const zchar **pFormat,va_list pArgs);
		BOOL		PipeCreate(HANDLE *hReadPipe,HANDLE *hWritePipe,DWORD dwSize,int iMode,DWORD dwTimeout);

		unsigned 	uDefWait;						// Standart Wartezeit
	   int volatile iBreak;							// Wurde das Warten angehalten
	   int volatile iRunning;						// Luft das Programm noch
		int			iParamLen;						// Bytelnge aller Parameter
		int			iParamCount;					// Anzahl der Parameter
		zchar      *pParams[CSP_PARAM_MAX];			// Zeiger auf Parameter
		zchar    	cProgFile[MAX_PATH];			// Programm-Dateiname
		zchar		cProgDir [MAX_PATH];			// Start-Verzeichnis
		DWORD	   *pProcessId;						// Hier wird die Prozess-Id gespeichert
		DWORD	 	uProgExit;						// Ergebnistwert des Programmes
		HWND		hProgWnd;						// Fenster-Handle von Programm
		zchar	   *pProgEnv;						// Zeiger auf EnvironmentStrings
		
		HANDLE		hEvent;							// Event um das Warten zu bebennden												
		HANDLE		aCloseValues[9];				// Handels der zum schliesenden Pipes [0-1]=in [2-3]=out [4-5]=err
		void (__cdecl *pCloseInp)(HANDLE&); 		// Funktion fr das schieen der IN -Pipe
		void (__cdecl *pCloseOut)(HANDLE&); 		// Funktion fr das schieen der OUT-Pipe
		void (__cdecl *pCloseErr)(HANDLE&); 		// Funktion fr das schieen der ERR-Pipe
													
		PROCESS_INFORMATION		sPi;				// Process Info
		STARTUPINFO				sSi;				// Startup Info
		
		void		 ClosePipes(int iFlags=7);		// Schliet Pipe-Handels von allen Pipes
static 	void __cdecl CloseInt(HANDLE &hHandle);		// Schliet Pipe-Handels vom Typ int
static	void __cdecl CloseWin(HANDLE &hHandle);		// Schliet Pipe-Handels vom Typ HANDLE

};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	DWORD	CStartProg::GetExitCode (){return uProgExit;}
inline	DWORD	CStartProg::SendMessage (UINT  uMsg,void  *wParam,void  *lParam,int iMaxTime){return SendMessage(uMsg,(WPARAM)wParam,(LPARAM)lParam,iMaxTime);}
inline	DWORD	CStartProg::SendMessage (UINT  uMsg,WPARAM wParam,void  *lParam,int iMaxTime){return SendMessage(uMsg,(WPARAM)wParam,(LPARAM)lParam,iMaxTime);}
inline	BOOL	CStartProg::PostMessage (UINT  uMsg,void  *wParam,void  *lParam,int iMaxTime){return PostMessage(uMsg,(WPARAM)wParam,(LPARAM)lParam,iMaxTime);}
inline	BOOL	CStartProg::PostMessage (UINT  uMsg,WPARAM wParam,void  *lParam,int iMaxTime){return PostMessage(uMsg,(WPARAM)wParam,(LPARAM)lParam,iMaxTime);}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,         const zchar *pPrefix,int iLenP,const zchar *pSuffix,int iLenS){return SetParamEx(pParam,startlen(pParam),pPrefix,iLenP            ,pSuffix,iLenS);}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,int iLen,const zchar *pPrefix,int iLenP,const zchar *pSuffix          ){return SetParamEx(pParam,iLen            ,pPrefix,iLenP            ,pSuffix,startlen(pSuffix));}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,         const zchar *pPrefix,int iLenP,const zchar *pSuffix          ){return SetParamEx(pParam,startlen(pParam),pPrefix,iLenP            ,pSuffix,startlen(pSuffix));}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,int iLen,const zchar *pPrefix,          const zchar *pSuffix,int iLenS){return SetParamEx(pParam,iLen            ,pPrefix,startlen(pPrefix),pSuffix,iLenS);}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,         const zchar *pPrefix,          const zchar *pSuffix,int iLenS){return SetParamEx(pParam,startlen(pParam),pPrefix,startlen(pPrefix),pSuffix,iLenS);}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,int iLen,const zchar *pPrefix,          const zchar *pSuffix          ){return SetParamEx(pParam,iLen            ,pPrefix,startlen(pPrefix),pSuffix,startlen(pSuffix));}
inline	int		CStartProg::SetParamEx	(const zchar *pParam,         const zchar *pPrefix,          const zchar *pSuffix          ){return SetParamEx(pParam,startlen(pParam),pPrefix,startlen(pPrefix),pSuffix,startlen(pSuffix));}
inline	int		CStartProg::SetParam	(const zchar *pParam    ){return SetParam(pParam,startlen(pParam));}
inline	void	CStartProg::SetTitle    (const zchar *pTitle    ){sSi.lpTitle=(zchar*)pTitle;}
inline	void	CStartProg::SetShowPos  (POINT sPos             ){sSi.dwFlags|=STARTF_USEPOSITION;	   sSi.dwX    =sPos.x;  sSi.dwY    =sPos.y  ;}
inline	void	CStartProg::SetShowPos  (int   iXpos ,int iYpos ){sSi.dwFlags|=STARTF_USEPOSITION;	   sSi.dwX    =iXpos;   sSi.dwY    =iYpos   ;}
inline	void	CStartProg::SetShowSize (int   iXsize,int iYsize){sSi.dwFlags|=STARTF_USESIZE;		   sSi.dwXSize=iXsize;  sSi.dwYSize=iYsize  ;}
inline	void	CStartProg::SetShowSize (SIZE  sSize			){sSi.dwFlags|=STARTF_USESIZE;		   sSi.dwXSize=sSize.cx;sSi.dwYSize=sSize.cy;}
inline	void	CStartProg::SetShowColor(int   iColors          ){sSi.dwFlags|=STARTF_USEFILLATTRIBUTE;sSi.dwFillAttribute=iColors              ;}
inline	void	CStartProg::SetStdIn    (HANDLE hHandle ){sSi.dwFlags|=STARTF_USESTDHANDLES;sSi.hStdInput =hHandle;}
inline	void	CStartProg::SetStdOut   (HANDLE hHandle ){sSi.dwFlags|=STARTF_USESTDHANDLES;sSi.hStdOutput=hHandle;}
inline	void	CStartProg::SetStdErr   (HANDLE hHandle ){sSi.dwFlags|=STARTF_USESTDHANDLES;sSi.hStdError =hHandle;}
inline	void	CStartProg::SetStdIn    (FILE  *pHandle ){SetStdIn (_fileno(pHandle));}
inline	void	CStartProg::SetStdOut   (FILE  *pHandle ){SetStdOut(_fileno(pHandle));}
inline	void	CStartProg::SetStdErr   (FILE  *pHandle ){SetStdErr(_fileno(pHandle));}
inline	void	CStartProg::SetWaitTime (UINT   uTime   ){uDefWait=uTime;}
inline	void	CStartProg::SetIdPointer(LPVOID pPointer){pProcessId=(LPDWORD)pPointer;}
inline	int		CStartProg::ParamCount  (){return iParamCount   ;}
inline	HANDLE	CStartProg::GetStdIn    (){return sSi.hStdInput ;}
inline	HANDLE	CStartProg::GetStdOut   (){return sSi.hStdOutput;}
inline	HANDLE	CStartProg::GetStdErr   (){return sSi.hStdError ;}


#undef	startlen


#endif
