//*****************************************************************************
//*
//*
//*		StartProgEx.h
//*
//*
//*****************************************************************************
//	
//	Verschidene Funktionen arbeiten mit Consolen-Programmen.
//	Die empfangenen Daten werden ber Pipes umgeleitet.
//
#ifndef 	__STARTPROGEX_H__
#define 	__STARTPROGEX_H__

#if defined(_WIN32)
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
					
	#include <afx.h>

#else

	#ifdef	 _WIN32
	#include <windows.h>
	#endif

#endif
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#include	<StartProg.h>

typedef void (_cdecl *CplLoggerType)(void *pParam,const char *pData,int iSize);

#define 	CPL_LINESIZE				1024

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	zchar		wchar_t
#else
#define 	zchar		char
#endif

//*****************************************************************************
//*
//*		Klasse CStartProgEx
//*
//*****************************************************************************
class CStartProgEx : public CStartProg
{
public:

	CStartProgEx();
   ~CStartProgEx();

	BOOL			ResetPipe();
	VOID			Reset(){CStartProg::Reset(FALSE);};
	BOOL _cdecl		Start(		 			     int iMode,const zchar  *pFormat=0,...);
	BOOL _cdecl		Start(const zchar *pFilename,int iMode,const zchar  *pFormat=0,...);
	INT 			ReadNext (const zchar *&pLine,int *pSize=0,UINT uTimeout=INFINITE);
	BOOL			SetOutput(const zchar *pFilename,BOOL bAppend=FALSE); 
	BOOL			SetError (const zchar *pFilename,BOOL bAppend=FALSE);
	VOID			SetLogger(CplLoggerType pProc,void *pParam,int iMode=3);

protected:

	INT				m_iReadMode;
	TCHAR			m_cLastErr;
	TCHAR			m_cLastOut;
	CplLoggerType	m_pLoggerErr;
	CplLoggerType	m_pLoggerOut;
	LPVOID		  	m_pLogParamErr;
	LPVOID			m_pLogParamOut;
	zchar			m_cLineErr[CPL_LINESIZE+1];
	zchar			m_cLineOut[CPL_LINESIZE+1];
	HANDLE			m_hPipeError;
	HANDLE			m_hPipeWrite;
	HANDLE			m_hPipeRead;
	HANDLE			m_hNextTrig;
	HANDLE			m_hReadTrig;
	HANDLE			m_hDoneTrig;
	HANDLE			m_hPortTrig;
	HANDLE			m_hMyThread;
	HANDLE			m_hOutFile;
	HANDLE			m_hErrFile;
	UINT			m_uByteOut;
	UINT			m_uByteErr;
	UINT volatile	m_uLineErr;
	UINT volatile	m_uLineOut;
	char volatile	m_cWaitDone;
	char volatile	m_cPortState;
	bool volatile	m_bRunning;
	bool volatile	m_bReset;
	bool volatile	m_bExit;
	bool volatile	m_bWait;
   CRITICAL_SECTION	m_sSynch;
	
	static	DWORD WINAPI ReadThread(LPVOID pParam);
	
	BOOL			StartIo();
	DWORD			ReadThread();
	VOID			NewDataRecived(unsigned uBytes);
	VOID			NewInfoRecived(unsigned uBytes);

};



#endif 	