//****************************************************************************
//*
//*
//*		StringChain.h
//*
//*
//****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//	Erzeugt eine Kette von Strings die zustzlich mit Daten erweitert
//	werden kann. Die Datenblcke mssen immer die gleiche Lnge aufweisen
//	die Strings knnen unterschiedlich lang sein.
//	Zustzlich wird die Stringlnge gespeichert.
//	Alle Strings samt Daten werden dynamisch verwaltet, und in eigenen
//	Speicherbereichen zwischen gespeichert.
//
//	Funktionen:		char *Get				: Zeiger auf Text holen
//					void *Data				: Zeiger auf Datenbereich holen
//					void *DataGet			: Daten  holen
//					void *DataSet   		: Daten  setzen
//					bool  DataLength		: Verndert  pDatalnge
//					int   Len				: Textlnge holen
//					int   Add				: Text und Daten hinzufgen (auch Ketten)
//					int   Del				: Einzelnen Text oder alles lschen
//					int   Count				: Anzahl der Texte in der Klasse
//					int   Find				: Text oder Wert in der Klasse suchen
//					int   Move				: Text in der Klasse verschieben
//					int   Chain     		: Erzeugt Textkette
//					void  Sort				: Eintrge sortieren
//					void  Upper				: Zu  Grobuchstaben umwandeln
//				 	void  Lower				: Zu Kleinbuchstaben umwandeln
//					int   Memory    		: Erzeugt Textseite mit /n/r
//					int   Id(int)   		: Schreibt ID-Nummer
//					int   Id()				: Liest    ID-Nummer
//					void *UserPtr(void*)	: Schreibt User-Zeiger
//					void *UserPtr()			: Liest    User-Zeiger
//					void  Change			: Tauscht zwei Eintrge
//					void  Set				: Text an ndern
//					int	  Plus				: Text an Text anhngen
//					void  TrimLeft 			: Leerzeichen links  entfernen
//					void  TrimRight			: Leerzeichen rechts entfernen
//
//	CONTAINER
//
//  int	CAdd(          char  *pStr  ,void *pData=0);	// Text in Container  einfgen
//	int	CAdd(int  iLen,char  *pStr  ,void *pData=0);	// Text in Container  einfgen
//	int	CAdd(		   char **pChain,void *pData=0);	// ByteKetten in Container  einfgen
//	int	CAdd(char cKey,char **pChain,void *pData=0);	// ByteKetten in Container  einfgen
//
//	int	ContainerInit (int iDepth=16,int iMode=0);		// Container initialisieren
//	int	ContainerCheck(char *pStr);						// Container prfen
//	int ContainerCut  ();								// Container krzen
//
//	STACK
//
//	int	  Push(		    char *pStr  ,void *pData=0);	// Text auf Stapel legen
//	int	  Push(int iLen,char *pStr  ,void *pData=0);	// Text auf Stapel legen
//
//	FIFO
//
//	int	  FifoIn (int iLen,char  *pStr,void *pData=0);	// Text in  Fifo legen
//	int	  FifoOut(	       char **pStr,void *pData=0);	// Text aus Fifo holen
//
//	Das Modul "MemFunctions.cpp" wird mit verwendet !
//
//
//

#ifndef __CSTRINGCHAIN_H__
#define __CSTRINGCHAIN_H__


#if _MSC_VER >= 1000
#pragma once
#pragma	warning( disable :4514 )
#pragma warning( disable :4996 )
#pragma	warning( push )
#pragma warning( disable :4302 )
#pragma warning( disable :4311 )
#pragma warning( disable :4312 )
#else
#define 	 _cdecl
#define 	__cdecl
#endif


#ifndef		 strcpy
#include	<string.h>
#endif
#include	<stdarg.h>

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if		_MSC_VER > 1299
	#ifndef		WINVER
	#define		WINVER 	0x0501
	#endif
	#endif
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#endif
#endif


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif



#ifdef		Z
#undef 		Z
#endif

#ifdef		i64
#undef 		i64
#endif

#ifdef		u64
#undef 		u64
#endif

#ifdef		u16
#undef 		u16
#endif

#ifdef		u8
#undef 		u8
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		strzlen
#undef 		strzlen
#endif


#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	strzlen		(int)wcslen
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	strzlen		(int)strlen
#endif

#ifndef	   _MSC_VER
#define		i64	 		long long
#define		u64	 		unsigned long long
#define		u16	 		unsigned short
#define		u8	 		unsigned char
#else
#define		i64	 		__int64
#define		u64	 		unsigned __int64
#define		u16	 		unsigned short
#define		u8	 		unsigned char
#endif


#define	CSC_ADD			256					// Anzahl der Elemente um
#define	CSC_SORT_CMP	CStringChain::SortCmp
#define	CSC_SORT_CASE	CStringChain::SortCmpG
#define	CSC_SORT_LEN	CStringChain::SortLen
#define	CSC_SORT_LENC	CStringChain::SortLenC
#define	CSC_SORT_LENCU	CStringChain::SortLenCG
#define	CSC_SORT_INT	CStringChain::SortInt
#define	CSC_SORT_INTC	CStringChain::SortIntC
#define	CSC_SORT_INTCU	CStringChain::SortIntCG
#define	CSC_SORT_UINT	CStringChain::SortUInt
#define	CSC_SORT_UINTC	CStringChain::SortUIntC
#define	CSC_SORT_UINTCU	CStringChain::SortUIntCG
#define	CSC_SORT_I64	CStringChain::SortI64
#define	CSC_SORT_I64C	CStringChain::SortI64C
#define	CSC_SORT_I64CU	CStringChain::SortI64CG
#define	CSC_SORT_UI64	CStringChain::SortUI64
#define	CSC_SORT_UI64C	CStringChain::SortUI64C
#define	CSC_SORT_UI64CU	CStringChain::SortUI64CG
#define	CSC_MASK_TEST	0x12345678

typedef	struct	{int iDummy;}fabc;
typedef	struct	{int iDummy;}fint;
typedef	struct	{int iDummy;}fval;
typedef	struct	{int iDummy;}fi64;
typedef	struct	{int iDummy;}fu64;

typedef	int(_cdecl*CscCmpN)(const zchar *pStr1,const zchar *pStr2);
typedef	int(_cdecl*CscCmpL)(const zchar *pStr1,const zchar *pStr2,int iLen);
typedef	int(_cdecl*CscCmpM)(const void  *pPtr1,const void  *pPtr2);
typedef	int(_cdecl*CscCmpP)(const void  *pPtr1,const void  *pPtr2,void *pParam);


#define CSC_END			-1
#define CSC_ABC    		((fabc*)0x08)
#define CSC_ABCG   		((fabc*)0x09)
#define CSC_ABCL   		((fabc*)0x18)
#define CSC_ABCGL  		((fabc*)0x19)
#define CSC_INT    		((fint*)0x08)
#define CSC_UINT   		((fint*)0x09)
#define CSC_INTE   		((fint*)0x0C)
#define CSC_UINTE  		((fint*)0x0D)
#define CSC_INT64  		((fi64*)0x08)
#define CSC_UINT64 		((fi64*)0x09)
#define CSC_INT64E 		((fi64*)0x0C)
#define CSC_UINT64E		((fi64*)0x0D)
#define CSC_UABC   		((fval*)0x08)
#define CSC_UABCG  		((fval*)0x09)
#define CSC_UABCL  		((fval*)0x18)
#define CSC_UABCGL 		((fval*)0x19)
#define CSC_UABC64  	((fu64*)0x08)
#define CSC_UABCG64 	((fu64*)0x09)
#define CSC_UABCL64		((fu64*)0x18)
#define CSC_UABCGL64 	((fu64*)0x19)

int 	DataFieldCmpInt   (void *pParam,const void *pData1,const void *pData2);
int 	DataFieldCmpUInt  (void *pParam,const void *pData1,const void *pData2);
int 	DataFieldCmpShort (void *pParam,const void *pData1,const void *pData2);
int		DataFieldCmpUShort(void *pParam,const void *pData1,const void *pData2);

#define CSC_CMP_INT		DataFieldCmpInt
#define CSC_CMP_UINT	DataFieldCmpUInt
#define CSC_CMP_SHORT	DataFieldCmpShort
#define CSC_CMP_USHORT	DataFieldCmpUShort


//****************************************************************************
//*
//*		Funktionen CStringChain
//*
//****************************************************************************
class	CStringChain
{
public:

		CStringChain(int pData_len=0);									// Konstruktor
	   ~CStringChain(void);												// Destruktor
		CStringChain &operator=(const CStringChain &pChain);			// Kopieren
		zchar        *operator[](int iPos)const;						// Array

int		Get	  		(int iPos,zchar  *pStr,int iLen)const;				// Text in fixen Puffer
int		Get	  		(int iPos,zchar **pStr)const;						// Text in Puffer
zchar  *Get	  		(int iPos,int    &iLen)const;						// Text holen mit Lnge
zchar  *Get	  		(int iPos,int    &iLen,int  &iData)const;			// Text holen mit Lnge und ersten Datenwert
zchar  *Get	  		(int iPos,int    &iLen,void *pData)const;			// Text holen mit Lnge und Zeiger auf die Daten
zchar  *Get	  		(int iPos)const;									// Text holen
zchar  *GetNone     (int iPos)const;									// Text holen ohne Indexprfung
zchar  *GetEx  		(int iPos,int    *pLen)const;						// Text holen plus Lnge
void   *Peek	  	(int iPos);											// Einen Datenzeiger auslesen
void   *Data	  	(int iPos)const;									// Datenzeiger holen
void   *DataEx	  	(int iPos)const;									// Datenzeiger holen mit Lnge
void   *DataNone    (int iPos)const;									// Datenzeiger holen ohne Indexprfung
void   *DataSet 	(int iPos,const void *pData );						// Daten  setzen
void   *DataGet 	(int iPos,      void *pData )const;					// Daten  holen
void   *DataGetPtr 	(int iPos                   )const;					// Daten  holen
void   *DataGetPtr 	(int iPos,unsigned    uIndex)const;					// Daten  holen
int		DataGet 	(int iPos,unsigned    uIndex)const;					// Daten  holen	(DWORD)
i64		DataGetQ	(int iPos,unsigned    uIndex)const;					// Daten  holen (QWORD)
u16		DataGetW	(int iPos,unsigned    uIndex)const;					// Daten  holen	(WORD)
u8		DataGetB	(int iPos,unsigned    uIndex)const;					// Daten  holen	(BYTE)
int   	DataSet 	(int iPos,int iValue);								// Daten  setzen (DWORD)
i64   	DataSetQ	(int iPos,i64 iValue);								// Daten  setzen (QWORD)
u16   	DataSetW 	(int iPos,u16 uValue);								// Daten  setzen (WORD)
u8   	DataSetB 	(int iPos,u8  uValue);								// Daten  setzen (BYTE)
int   	DataSet 	(int iPos,int iValue,unsigned uIndex);				// Daten  setzen (DWORD)
i64   	DataSetQ 	(int iPos,i64 iValue,unsigned uIndex);				// Daten  setzen (QWORD)
u16   	DataSetW 	(int iPos,u16 uValue,unsigned uIndex);				// Daten  setzen (WORD)
u8   	DataSetB 	(int iPos,u8  uValue,unsigned uIndex);				// Daten  setzen (BYTE)
void   *DataSetPtr 	(int iPos,const void *pData );						// Daten  holen
int   	DataGet		(int iPos)const;									// Daten  holen	(DWORD)
i64   	DataGetQ	(int iPos)const;									// Daten  holen	(QWORD)
u16		DataGetW	(int iPos)const;									// Daten  holen	(WORD)
u8		DataGetB	(int iPos)const;									// Daten  holen (BYTE)
int	  	DataLength	(int iLen);											// Verndert Datenlnge
int	  	DataLength	()const;											// Aktuelle Datenlnge holen
int		LenNone     (int iPos)const;									// Textlnge holen ohne Indexprfung
int	  	Len       	(int iPos)const;									// Lnge des Strings holen
bool  	Check      	(int iPos)const;									// Einen Index prfen
zchar  *Info  		(void *pEntry          )const;						// Text holen ohne Lnge
zchar  *Info  		(void *pEntry,int &iLen)const;						// Text holen plus Lnge
																		// Strings einfgen
int	  	Add (  void *pEntry,int iPos=-1);
int	  	Add (                    CStringChain *pCsk  ,int   iPos=-1,int iStart=0,int iStop=-1);
int	  	Add (                    const zchar  *pStr  ,int   iPos=-1,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,int   iPos=-1,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,fval *iPos   ,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,fval *iPos   ,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,fabc *iPos   ,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,fabc *iPos   ,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,fint *iPos   ,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,fint *iPos   ,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,fi64 *iPos   ,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,fi64 *iPos   ,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,fu64 *iPos   ,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,fu64 *iPos   ,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,CscCmpN pProc,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,CscCmpL pProc,const void *pData=0);
int	  	Add (                    const zchar  *pStr  ,CscCmpM pProc,const void *pData=0);
int	  	Add (  int iLen,         const zchar  *pStr  ,CscCmpM pProc,const void *pData=0);
int	  	Add (void *pParam,       const zchar  *pStr  ,CscCmpP pProc,const void *pData=0);
int	  	Add (void *pParam,int iL,const zchar  *pStr  ,CscCmpP pProc,const void *pData=0);
int	  	Add (                    const zchar **pChain,int   iPos=-1,const void *pData=0);
int	  	Add (zchar cKey,         const zchar **pChain,int   iPos=-1,const void *pData=0);
int	  	Add (zchar cKey,int iMax,const zchar **pChain,int   iPos=-1,const void *pData=0);
int	  	Add (                          zchar **pChain,int   iPos=-1,const void *pData=0);
int	  	Add (zchar cKey,               zchar **pChain,int   iPos=-1,const void *pData=0);
int	  	Add (zchar cKey,int iMax,      zchar **pChain,int   iPos=-1,const void *pData=0);
int	  	KAdd(                    const zchar  *pStr  ,int   iPos=-1,const void *pData=0);// Stringkette einfgen
int	  	KAdd(zchar cKey,         const zchar  *pStr  ,int   iPos=-1,const void *pData=0);
int		KAdd(zchar cKey,int iMax,const zchar  *pStr  ,int   iPos=-1,const void *pData=0);

int	_cdecl  AddFormatEx (const void *pData,int   iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  AddFormat   (const void *pData,int   iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				   int   iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				              const zchar *pFormat,...              );
int	_cdecl  AddFormatEx (const void *pData,fval *iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  AddFormat   (const void *pData,fval *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				   fval *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormatEx (const void *pData,fabc *iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  AddFormat   (const void *pData,fabc *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				   fabc *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormatEx (const void *pData,fint *iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  AddFormat   (const void *pData,fint *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				   fint *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormatEx (const void *pData,fi64 *iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  AddFormat   (const void *pData,fi64 *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				   fi64 *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormatEx (const void *pData,fu64 *iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  AddFormat   (const void *pData,fu64 *iPos,const zchar *pFormat,...              );
int	_cdecl  AddFormat   (				   fu64 *iPos,const zchar *pFormat,...              );
int	_cdecl  SetFormatEx (const void *pData,int   iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  SetFormat   (const void *pData,int   iPos,const zchar *pFormat,...              );
int	_cdecl  SetFormat   (				   int   iPos,const zchar *pFormat,...              );
int	_cdecl  PlusFormatEx(const void *pData,int   iPos,const zchar *pFormat    ,va_list pArgs);
int	_cdecl  PlusFormat  (const void *pData,int   iPos,const zchar *pFormat,...              );
int	_cdecl  PlusFormat  (				   int   iPos,const zchar *pFormat,...              );

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int   	Get	    (int iPos,CString *pStr)const;								// Strings holen
int   	Get	    (int iPos,CString &sStr)const;								// Strings holen
int	  	KAdd    (CString *pStr,zchar cKey,int iPos=-1,const void *pData=0);	// Stringkette einfgen
int	  	KAdd    (CString &sStr,zchar cKey,int iPos=-1,const void *pData=0);	// Stringkette einfgen
int	  	CAdd    (CString *pStr            ,const void *pData=0);			// Strings einfgen
int	  	CAdd    (CString &sStr            ,const void *pData=0);			// Strings einfgen
int	  	Pop     (CString *pStr            ,      void *pData=0);			// Strings vom Stapel
int	  	Pop     (CString &sStr            ,      void *pData=0);			// Strings vom Stapel
int	  	Push    (CString *pStr            ,const void *pData=0);			// Strings einfgen
int	  	Push    (CString &sStr            ,const void *pData=0);			// Strings einfgen
int	  	FifoIn  (CString *pStr            ,const void *pData=0);			// Strings in Fifo geben
int	  	FifoIn  (CString &sStr            ,const void *pData=0);			// Strings in Fifo geben
int   	FifoOut (CString *pStr            ,      void *pData=0);			// Text aus Fifo holen
int	  	FifoOut (CString &sStr            ,      void *pData=0);			// Text aus Fifo holen
int	  	Add     (CString *pStr,int iPos=-1,const void *pData=0);			// Strings einfgen
int	  	Add     (CString &sStr,int iPos=-1,const void *pData=0);			// Strings einfgen
int	  	Set     (CString *pStr,int iPos=-1,const void *pData=0);			// Text austauschen
int	  	Set     (CString &sStr,int iPos=-1,const void *pData=0);			// Text austauschen
int	  	Plus    (CString *pStr,int iPos=-1,const void *pData=0);			// Text an Text anhngen
int	  	Plus    (CString &sStr,int iPos=-1,const void *pData=0);			// Text an Text anhngen
int	  	Find    (CString *pStr,int iStart=0,int iStop=-1,int iMode=0)const;	// Nach einen Text suchen
int	  	Find    (CString &sStr,int iStart=0,int iStop=-1,int iMode=0)const;	// Nach einen Text suchen
int	  	FindFast(CString *pStr,int iStart=0,int iStop=-1,int iMode=0)const;	// Nach einen Text suchen
int	  	FindFast(CString &sStr,int iStart=0,int iStop=-1,int iMode=0)const;	// Nach einen Text suchen
int   	Chain   (CString *pStr,zchar cSign)const;			   				// Erzeugt Byte-Kette
int   	Chain   (CString &sStr,zchar cSign)const;			   				// Erzeugt Byte-Kette
int   	Chain   (int iStart,int iStop,CString *pStr,zchar cSign)const;		// Erzeugt Byte-Kette
int   	Chain   (int iStart,int iStop,CString &sStr,zchar cSign)const;		// Erzeugt Byte-Kette

#endif

int		Del	  ();															// Alle Texte lschen
int   	Del   (int iPos);													// Einzelnen Text lschen
int   	Del   (int iFrom  ,int iTo      );									// Stringbereich lschen
int	  	Move  (int iPos=-1,int iNum  =-1);									// Text in der Kette verschieben
void  	Change(int iPos1  ,int iPos2 =-1);									// Tauscht 2 Kentten Glieder
int	  	Set   (		    const zchar *pStr,int iPos=-1,const void *pData=0);	// Strings tauschen
int	  	Set   (int iLen,const zchar *pStr,int iPos=-1,const void *pData=0);	// Strings tauschen
int	  	Plus  (	 	    const zchar *pStr,int iPos=-1,const void *pData=0);	// Text an Text anhngen
int	  	Plus  (int iLen,const zchar *pStr,int iPos=-1,const void *pData=0);	// Text an Text anhngen

																			// Sucht einen Text
int	  	Find     (int iVal,int iLen,const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindQ    (i64 iVal,int iLen,const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	Find     (         int iLen,const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	Find     (                  const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	Find     (int iValue,                         int iStart=0,int iStop=-1              )const;
int	  	Find     (int iValue,int iOffset,             int iStart  ,int iStop                 )const;
int	  	FindQ    (i64 iValue,                         int iStart=0,int iStop=-1              )const;
int	  	FindQ    (i64 iValue,int iOffset,             int iStart  ,int iStop                 )const;
int	  	FindFastQ(i64 iVal,int iLen,const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindFast (int iVal,int iLen,const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindFast (         int iLen,const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindFast (                  const zchar *pStr,int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindFast (int  iValue,                        int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindFast (int  iValue,int iOffset            ,int iStart  ,int iStop   ,int   iMode  )const;
int	  	FindFastQ(i64  iValue,                        int iStart=0,int iStop=-1,int   iMode=0)const;
int	  	FindFastQ(i64  iValue,int iOffset            ,int iStart  ,int iStop   ,int   iMode  )const;
int		FindFast (void *pP,const void  *pData        ,int iStart  ,int iStop   ,int   iMode,int (__cdecl*pCmp)(const void*, const void *,void*))const;
int	  	FindFast (         const void  *pData		 ,int iStart  ,int iStop   ,int   iMode,int (__cdecl*pCmp)(const void *,const void *      ))const;
int		FindFast (         const zchar *pStr         ,int iStart  ,int iStop   ,int   iMode,int (__cdecl*pCmp)(const zchar*,const zchar*      ))const;
int		FindFast (int iLen,const zchar *pStr         ,int iStart  ,int iStop   ,int   iMode,int (__cdecl*pCmp)(const zchar*,const zchar*,int  ))const;
void  	Sort     (int iStart=0,int iStop=-1 ,int (__cdecl*Cmp)(CStringChain*,int,int)=SortCmp,int iDirection=0);
void    Sort     (int (__cdecl*pCmp)(void*,const void*,const void*),void *pParam,int iOffset=0,int iStart=0,int iStop=-1,int iDirection=0);
void    Sort     (int (__cdecl*pCmp)(void*,const void*,const void*)             ,int iOffset=0,int iStart=0,int iStop=-1,int iDirection=0);
void	Sort     (int (__cdecl*pCmp)(    const zchar*,const zchar*)                           ,int iStart=0,int iStop=-1,int iDirection=0);
void  	Upper    (int iStart=0,int iStop=-1);								// Zu Grobuchstaben  umwandeln
void  	Lower    (int iStart=0,int iStop=-1);								// Zu Kleinbuchstaben umwandeln
void  	TrimLeft (int iStart=0,int iStop=-1);								// Lehrzeichen links  entfernen
void  	TrimRight(int iStart=0,int iStop=-1);								// Lehrzeichen rechts entfernen
int	  	Chain 	 (                     zchar **pMem)const;					// Erzeugt Byte-Kette
int	  	Chain 	 (int iStart,int iStop,zchar **pMem)const;					// Erzeugt Byte-Kette
int   	Chain 	 (                     zchar **pMem,zchar cSign)const;		// Erzeugt Byte-Kette
int   	Chain 	 (int iStart,int iStop,zchar **pMem,zchar cSign)const;		// Erzeugt Byte-Kette
int	  	Memory	 (                     zchar **pMem,int iMax=-1,int iMode=1)const;	// Erzeugt Text-Seite mit \r\n
int	  	Memory	 (int iStart,int iStop,zchar **pMem,int iMax=-1,int iMode=1)const;	// Erzeugt Text-Seite mit \r\n

void  **GetFieldPointer(int **pCount=0)const;								// Zeiger auf das Datenfeld holen (&m_pField)
void  **GetListPointer()const;												// Zeiger auf das Datenfeld holen ( m_pField)
void	SetUserData(int   iData );											// Einstellen der Userdaten
void	SetUserPtr (void *pPtr  );											// Einstellen der Userdaten
void	GetUserPtr (void *pPtr  )const;										// Abfragen der Userdaten
int		GetUserData()const;													// Abfragen der Userdaten
void   *GetUserPtr ()const;													// Abfragen der Userdaten
int	  	Count 	   ()const;													// Ergibt Anzahl
static	void Free  (void *pEntry);											// Einen Eintrag freigeben
static	void*Alloc (int iLen,const zchar *pStr,int iSize,const void *pData);// Einen Eintrag erstellen
static	void*Alloc (		 const zchar *pStr,int iSize,const void *pData);// Einen Eintrag erstellen (ohne Text Lnge)
		void*Alloc (int iLen,const zchar *pStr          ,const void *pData);// Einen Eintrag erstellen (mit Gre von Klasse)
		void*Alloc (		 const zchar *pStr          ,const void *pData);// Einen Eintrag erstellen (mit Gre von Klasse,ohne Text Lnge)
		void*Alloc (int iLen,const zchar *pStr                            );// Einen Eintrag erstellen (mit Gre von Klasse)
		void*Alloc (		 const zchar *pStr                            );// Einen Eintrag erstellen (mit Gre von Klasse,ohne Text Lnge)



//****************************************************************************
//*
//*		Stapel Fifo Container Funktionen
//*
//****************************************************************************

int	  	CAdd(                    const zchar  *pStr  ,const void *pData=0);	// Text in Container einfgen
int	  	CAdd(int   iLen,         const zchar  *pStr  ,const void *pData=0);	// Text in Container einfgen
int	  	CAdd(                    const zchar **pChain,const void *pData=0);	// Textketten in Container einfgen
int	  	CAdd(zchar cKey,         const zchar **pChain,const void *pData=0);	// Textketten in Container einfgen
int	  	CAdd(zchar cKey,int iMax,const zchar **pChain,const void *pData=0);	// Textketten in Container einfgen
int	  	CAdd(                          zchar **pChain,const void *pData=0);	// Textketten in Container einfgen
int	  	CAdd(zchar cKey,               zchar **pChain,const void *pData=0);	// Textketten in Container einfgen
int	  	CAdd(zchar cKey,int iMax,      zchar **pChain,const void *pData=0);	// Textketten in Container einfgen

int	  	ContainerInit (int   iDepth=16,int iMode=0);						// Container initialisieren
int	  	ContainerCheck(const zchar *pStr);									// Container prfen
int	  	ContainerCut  ();													// Container krzen

int	  	Push   (         const zchar  *pStr,const void *pData=0);			// Text auf Stapel legen
int	  	Push   (int iLen,const zchar  *pStr,const void *pData=0);			// Text auf Stapel legen
int	  	Pop    (               zchar **pStr,	  void *pData=0);			// Text vom Stapel holen
int	  	Pop    (int iLen,      zchar  *pStr,	  void *pData=0);			// Text vom Stapel holen

int		FifoIn (         const zchar  *pStr,const void *pData=0);			// Text in  Fifo legen
int		FifoIn (int iLen,const zchar  *pStr,const void *pData=0);			// Text in  Fifo legen
int	  	FifoOut(	           zchar **pStr,	  void *pData=0);			// Text aus Fifo holen
int	  	FifoOut(int iLen,      zchar  *pStr,	  void *pData=0);			// Text aus Fifo holen

protected:


public:

static int __cdecl SortCmp   (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortCmpG  (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortLen   (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortLenC  (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortLenCG (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortInt   (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortIntC  (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortIntCG (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortUInt  (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortUIntC (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortUIntCG(CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortI64   (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortI64C  (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortI64CG (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortUI64  (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortUI64C (CStringChain *pChain,int iPos1,int iPos2);
static int __cdecl SortUI64CG(CStringChain *pChain,int iPos1,int iPos2);

//****************************************************************************
//*
//*		Variabeln CStringChain
//*
//****************************************************************************

protected:

	int		m_iCount;								// Anzahl der gepeicherten Text
	int		m_iMaxCount;							// Gre des allokierten Feldes
	int		m_iDataSize;							// Lnge des Zusatzes in Byte
	int		m_iConainerDepth;						// Tiefe fr Container
	int		m_iConainerMode;						// Art   fr Container
	void   *m_pUserPtr;								// Nummer fr User-Daten
	char  **m_pField;								// Zeigerfeld

	// Aufbau von einem Feldeintrag (*m_pField[xyz])
	//
	// <Offset> <Size>	<Funktion>
	//	 -4		Byte	Lnge des Strings ohne NULL-Byte
	//	  0		N		Databereich
	//	  N		M		Text
	//	  N+M	1		NULL-Byte

};

//****************************************************************************
//*
//*		Inline Funktionen CStringChain
//*
//****************************************************************************

#ifndef _DEBUG

inline int	 CStringChain::Add(         const zchar *pStr,fval *iPos,const void *pData){int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);int iNum=FindFast (*(int*)pData,iLen,pStr   ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,fval *iPos,const void *pData){                                                                   int iNum=FindFast (*(int*)pData,iLen,pStr   ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(         const zchar *pStr,fabc *iPos,const void *pData){int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);int iNum=FindFast (             iLen,pStr   ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,fabc *iPos,const void *pData){                                                                   int iNum=FindFast (             iLen,pStr   ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(         const zchar *pStr,fint *iPos,const void *pData){int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);int iNum=FindFast (*(int*)pData             ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,fint *iPos,const void *pData){                                                                   int iNum=FindFast (*(int*)pData             ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(         const zchar *pStr,fi64 *iPos,const void *pData){int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);int iNum=FindFastQ(*(i64*)pData             ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,fi64 *iPos,const void *pData){                                                                   int iNum=FindFastQ(*(i64*)pData             ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(         const zchar *pStr,fu64 *iPos,const void *pData){int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);int iNum=FindFastQ(*(i64*)pData,iLen,pStr   ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,fu64 *iPos,const void *pData){                                                                   int iNum=FindFastQ(*(i64*)pData,iLen,pStr   ,0,m_iCount,(int)iPos);return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(         const zchar *pStr,CscCmpN pP,const void *pData){                                                                   int iNum=FindFast (                  pStr   ,0,m_iCount,0x0C,pP  );return Add(     pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,CscCmpL pP,const void *pData){                                                                   int iNum=FindFast (             iLen,pStr   ,0,m_iCount,0x0C,pP  );return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(         const zchar *pStr,CscCmpM pP,const void *pData){                                                                   int iNum=FindFast (                  pData  ,0,m_iCount,0x0C,pP  );return Add(     pStr,iNum,pData);}
inline int	 CStringChain::Add(int iLen,const zchar *pStr,CscCmpM pP,const void *pData){                                                                   int iNum=FindFast (                  pData  ,0,m_iCount,0x0C,pP  );return Add(iLen,pStr,iNum,pData);}
inline int	 CStringChain::Add(void *pV,const zchar *pStr,CscCmpP pP,const void *pData){                                                                   int iNum=FindFast (             pV  ,pData  ,0,m_iCount,0x0C,pP  );return Add(     pStr,iNum,pData);}
inline int	 CStringChain::Add(void *pV,int iLen,const zchar *pStr,CscCmpP pP,const void *pData){                                                          int iNum=FindFast (             pV  ,pData  ,0,m_iCount,0x0C,pP  );return Add(iLen,pStr,iNum,pData);}

inline int	 CStringChain::Add(                    const zchar **pChain,int iPos,const void *pData){return KAdd(          *pChain,iPos,pData);}
inline int	 CStringChain::Add(zchar uKey,         const zchar **pChain,int iPos,const void *pData){return KAdd(uKey,     *pChain,iPos,pData);}
inline int	 CStringChain::Add(zchar uKey,int iMax,const zchar **pChain,int iPos,const void *pData){return KAdd(uKey,iMax,*pChain,iPos,pData);}
inline int	 CStringChain::Add(                          zchar **pChain,int iPos,const void *pData){return KAdd(          *pChain,iPos,pData);}
inline int	 CStringChain::Add(zchar uKey,               zchar **pChain,int iPos,const void *pData){return KAdd(uKey,     *pChain,iPos,pData);}
inline int	 CStringChain::Add(zchar uKey,int iMax,      zchar **pChain,int iPos,const void *pData){return KAdd(uKey,iMax,*pChain,iPos,pData);}

inline int	 CStringChain::DataGet   (int iPos                )const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(int  )                     )return 0;return *(int  *)(m_pField[iPos]);}
inline i64 	 CStringChain::DataGetQ  (int iPos                )const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(i64  )                     )return 0;return *(i64  *)(m_pField[iPos]);}
inline u16 	 CStringChain::DataGetW  (int iPos                )const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(u16  )                     )return 0;return *(u16  *)(m_pField[iPos]);}
inline u8 	 CStringChain::DataGetB  (int iPos                )const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(u8   )                     )return 0;return *(u8   *)(m_pField[iPos]);}
inline void *CStringChain::DataGetPtr(int iPos                )const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(void*)                     )return 0;return *(void**)(m_pField[iPos]);}
inline int 	 CStringChain::DataGet   (int iPos,unsigned uIndex)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(int  )+sizeof(int  )*uIndex)return 0;return *(int  *)(m_pField[iPos]+sizeof(int  )*uIndex);}
inline i64 	 CStringChain::DataGetQ  (int iPos,unsigned uIndex)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(i64  )+sizeof(i64  )*uIndex)return 0;return *(i64  *)(m_pField[iPos]+sizeof(i64  )*uIndex);}
inline u16 	 CStringChain::DataGetW  (int iPos,unsigned uIndex)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(u16  )+sizeof(u16  )*uIndex)return 0;return *(u16  *)(m_pField[iPos]+sizeof(u16  )*uIndex);}
inline u8 	 CStringChain::DataGetB  (int iPos,unsigned uIndex)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(u8   )+sizeof(u8   )*uIndex)return 0;return *(u8   *)(m_pField[iPos]+sizeof(u8   )*uIndex);}
inline void *CStringChain::DataGetPtr(int iPos,unsigned uIndex)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;if((unsigned)m_iDataSize<sizeof(void*)+sizeof(void*)*uIndex)return 0;return *(void**)(m_pField[iPos]+sizeof(void*)*uIndex);}
inline void *CStringChain::DataNone  (int iPos)const{                                               return          m_pField[iPos]             ;}
inline void *CStringChain::DataEx    (int iPos)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;return          m_pField[iPos]-sizeof(int) ;}
inline void *CStringChain::Data      (int iPos)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;return          m_pField[iPos]             ;}
inline int   CStringChain::LenNone   (int iPos)const{                                               return  *(int*)(m_pField[iPos]-sizeof(int));}
inline zchar*CStringChain::operator[](int iPos)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;return (zchar*)(m_pField[iPos]+m_iDataSize);}
inline zchar*CStringChain::Get       (int iPos)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;return (zchar*)(m_pField[iPos]+m_iDataSize);}
inline zchar*CStringChain::GetNone   (int iPos)const{                                               return (zchar*)(m_pField[iPos]+m_iDataSize);}
inline zchar*CStringChain::Get       (int iPos,int &iLen)const{if((unsigned)iPos>=(unsigned)m_iCount){         iLen=0;return 0;}       iLen =LenNone(iPos);return GetNone(iPos);}
inline zchar*CStringChain::GetEx     (int iPos,int *pLen)const{if((unsigned)iPos>=(unsigned)m_iCount){if(pLen)*pLen=0;return 0;}zchar *pName=GetNone(iPos);if(pLen)*pLen=LenNone(iPos);return pName;}
inline zchar*CStringChain::Get       (int iPos,int &iLen,void *pData)const{if((unsigned)iPos>=(unsigned)m_iCount){*(void**)pData=0;iLen=0;return 0;}                           *(void**)pData=m_pField[iPos];iLen=LenNone(iPos);return GetNone(iPos);}
inline zchar*CStringChain::Get       (int iPos,int &iLen,int  &iData)const{if((unsigned)iPos>=(unsigned)m_iCount){*(void**)iData=0;iLen=0;return 0;}iData=(m_iDataSize<sizeof(int))? 0:*(int*)m_pField[iPos];iLen=LenNone(iPos);return GetNone(iPos);}
inline zchar*CStringChain::Info      (void *pEntry          )const{if(!pEntry){       return 0;}                        return (zchar*)pEntry+m_iDataSize;}
inline zchar*CStringChain::Info      (void *pEntry,int &iLen)const{if(!pEntry){iLen=0;return 0;}iLen=((int*)pEntry)[-1];return (zchar*)pEntry+m_iDataSize;}

inline void  CStringChain::SetUserData(int   iData ){m_pUserPtr=(void*)iData;}
inline void  CStringChain::SetUserPtr (void *pPtr  ){m_pUserPtr=pPtr;}
inline void  CStringChain::GetUserPtr (void *pPtr  )const{*(void**)pPtr=m_pUserPtr;}
inline int   CStringChain::GetUserData()const{return (int)m_pUserPtr ;}
inline void *CStringChain::GetUserPtr ()const{return      m_pUserPtr ;}
inline int	 CStringChain::DataLength ()const{return      m_iDataSize;}
inline int	 CStringChain::Count      ()const{return      m_iCount   ;}
inline bool	 CStringChain::Check      (int iPos)const{return (unsigned)iPos<(unsigned)m_iCount;}
inline void *CStringChain::Alloc      (         const zchar *pStr,int iSize,const void *pData){return Alloc((int)strzlen(pStr),pStr,iSize,pData);};
inline void *CStringChain::Alloc      (int iLen,const zchar *pStr          ,const void *pData){return Alloc(iLen              ,pStr,m_iDataSize,pData);};
inline void *CStringChain::Alloc      (	        const zchar *pStr          ,const void *pData){return Alloc((int)strzlen(pStr),pStr,m_iDataSize,pData);};
inline void *CStringChain::Alloc      (int iLen,const zchar *pStr                            ){return Alloc(iLen              ,pStr,m_iDataSize,0);};
inline void *CStringChain::Alloc      (		    const zchar *pStr                            ){return Alloc((int)strzlen(pStr),pStr,m_iDataSize,0);};

inline int	 CStringChain::ContainerCut(){Del(m_iConainerDepth,m_iCount);return m_iCount;}
inline int	 CStringChain::Len(int iPos)const{if((unsigned)iPos>=(unsigned)m_iCount)return 0;return *(int*)(m_pField[iPos]-sizeof(int));}
inline void  CStringChain::Sort(int (__cdecl*pCmp)(void*,const void*,const void*),int iOffset,int iStart,int iStop,int iDirection){Sort(pCmp,0,iOffset,iStart,iStop,iDirection);}

inline int	 CStringChain::CAdd      (                    const zchar  *pStr  ,const void *pData){if(ContainerCheck(pStr)){Add (           pStr  ,0,pData);ContainerCut();}return m_iCount;}
inline int	 CStringChain::CAdd      (int iLen  ,         const zchar  *pStr  ,const void *pData){if(ContainerCheck(pStr)){Add (iLen,      pStr  ,0,pData);ContainerCut();}return m_iCount;}
inline int	 CStringChain::CAdd      (                    const zchar **pChain,const void *pData){                         KAdd(          *pChain,0,pData);ContainerInit(m_iConainerDepth,m_iConainerMode);return m_iCount;}
inline int	 CStringChain::CAdd      (zchar uKey,         const zchar **pChain,const void *pData){                         KAdd(uKey,     *pChain,0,pData);ContainerInit(m_iConainerDepth,m_iConainerMode);return m_iCount;}
inline int	 CStringChain::CAdd      (zchar uKey,int iMax,const zchar **pChain,const void *pData){                         KAdd(uKey,iMax,*pChain,0,pData);ContainerInit(m_iConainerDepth,m_iConainerMode);return m_iCount;}
inline int	 CStringChain::CAdd      (                          zchar **pChain,const void *pData){                         KAdd(          *pChain,0,pData);ContainerInit(m_iConainerDepth,m_iConainerMode);return m_iCount;}
inline int	 CStringChain::CAdd      (zchar uKey,               zchar **pChain,const void *pData){                         KAdd(uKey,     *pChain,0,pData);ContainerInit(m_iConainerDepth,m_iConainerMode);return m_iCount;}
inline int	 CStringChain::CAdd      (zchar uKey,int iMax,      zchar **pChain,const void *pData){                         KAdd(uKey,iMax,*pChain,0,pData);ContainerInit(m_iConainerDepth,m_iConainerMode);return m_iCount;}

inline int	 CStringChain::KAdd      (           const zchar  *pStr  ,int iPos,const void *pData){return KAdd(0,pStr,iPos,pData);}

inline int	 CStringChain::Push      (           const zchar  *pStr,const void *pData){return Add(     pStr,m_iCount,pData);}
inline int	 CStringChain::Push      (int iLen  ,const zchar  *pStr,const void *pData){return Add(iLen,pStr,m_iCount,pData);}

inline int	 CStringChain::FifoIn    (           const zchar  *pStr,const void *pData){return Add(     pStr,m_iCount,pData);}
inline int	 CStringChain::FifoIn    (int iLen  ,const zchar  *pStr,const void *pData){return Add(iLen,pStr,m_iCount,pData);}

inline int	 CStringChain::Find      (const zchar *pStr,int Start,int iStop,int Art)const{int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);return Find    (iLen,pStr,Start,iStop,Art);}
inline int	 CStringChain::FindFast  (const zchar *pStr,int Start,int iStop,int Art)const{int iLen;if(!pStr){iLen=0;pStr=Z("");}else iLen=(int)strzlen(pStr);return FindFast(iLen,pStr,Start,iStop,Art);}

inline int	 CStringChain::Memory    (zchar **pMem,int iMax,int iMode)const{return Memory(0,m_iCount,pMem,iMax,iMode);}
inline int	 CStringChain::Chain 	 (zchar **pMem                   )const{return Chain (0,m_iCount,pMem           );}
inline int	 CStringChain::Chain 	 (zchar **pMem,zchar cSign       )const{return Chain (0,m_iCount,pMem,cSign     );}
inline void**CStringChain::GetFieldPointer(int **pCount)const{if(pCount)*pCount=(int*)&m_iCount;return (void**)&m_pField;}
inline void**CStringChain::GetListPointer()const{return (void**)m_pField;}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

inline int  CStringChain::Get	  (int iPos,CString *pStr)const{if((unsigned)iPos>=(unsigned)m_iCount){*pStr="";return -1;}*pStr=m_pField[iPos]+m_iDataSize;return *(int*)(m_pField[iPos]-sizeof(int));}
inline int  CStringChain::Get	  (int iPos,CString &sStr)const{if((unsigned)iPos>=(unsigned)m_iCount){ sStr="";return -1;} sStr=m_pField[iPos]+m_iDataSize;return *(int*)(m_pField[iPos]-sizeof(int));}
inline int	CStringChain::CAdd    (CString *pStr         ,const void *pData){return CAdd  (pStr->GetLength(),(LPCTSTR)(*pStr)         ,pData);};
inline int	CStringChain::CAdd    (CString &sStr         ,const void *pData){return CAdd  (sStr .GetLength(),(LPCTSTR)( sStr)         ,pData);};
inline int	CStringChain::Push    (CString *pStr         ,const void *pData){return Add   (pStr->GetLength(),(LPCTSTR)(*pStr),m_iCount,pData);};
inline int	CStringChain::Push    (CString &sStr         ,const void *pData){return Add   (sStr .GetLength(),(LPCTSTR)( sStr),m_iCount,pData);};
inline int	CStringChain::FifoIn  (CString *pStr         ,const void *pData){return Add   (pStr->GetLength(),(LPCTSTR)(*pStr),m_iCount,pData);};
inline int	CStringChain::FifoIn  (CString &sStr         ,const void *pData){return Add   (sStr .GetLength(),(LPCTSTR)( sStr),m_iCount,pData);};
inline int	CStringChain::FifoOut (CString *pStr         ,      void *pData){if(m_iCount<=0)return -1;int iLen=LenNone(0);*pStr=GetNone(0);Del(0);return iLen;}
inline int	CStringChain::FifoOut (CString &sStr         ,      void *pData){if(m_iCount<=0)return -1;int iLen=LenNone(0); sStr=GetNone(0);Del(0);return iLen;}
inline int	CStringChain::Add     (CString *pStr,int iPos,const void *pData){return Add   (pStr->GetLength(),(LPCTSTR)(*pStr),   iPos,pData);};
inline int	CStringChain::Add     (CString &sStr,int iPos,const void *pData){return Add   (sStr .GetLength(),(LPCTSTR)( sStr),   iPos,pData);};
inline int	CStringChain::Set     (CString *pStr,int iPos,const void *pData){return Set   (pStr->GetLength(),(LPCTSTR)(*pStr),   iPos,pData);};
inline int	CStringChain::Set     (CString &sStr,int iPos,const void *pData){return Set   (sStr .GetLength(),(LPCTSTR)( sStr),   iPos,pData);};
inline int	CStringChain::Plus    (CString *pStr,int iPos,const void *pData){return Plus  (pStr->GetLength(),(LPCTSTR)(*pStr),   iPos,pData);};
inline int	CStringChain::Plus    (CString &sStr,int iPos,const void *pData){return Plus  (sStr .GetLength(),(LPCTSTR)( sStr),   iPos,pData);};
inline int	CStringChain::Pop     (CString *pStr         ,      void *pData){int iNum=m_iCount-1;if(iNum<0)return -1;int iLen=LenNone(iNum);*pStr=GetNone(iNum);Del(iNum);return iLen;}
inline int	CStringChain::Pop     (CString &sStr         ,      void *pData){int iNum=m_iCount-1;if(iNum<0)return -1;int iLen=LenNone(iNum); sStr=GetNone(iNum);Del(iNum);return iLen;}
inline int	CStringChain::KAdd    (CString *pStr,zchar cKey,int iPos,const void *pData){return KAdd(cKey,*pStr,iPos,pData);}
inline int	CStringChain::KAdd    (CString &sStr,zchar cKey,int iPos,const void *pData){return KAdd(cKey, sStr,iPos,pData);}
inline int	CStringChain::Find    (CString *pStr,int iStart,int iStop,int iMode)const{return Find    (pStr->GetLength(),(LPCTSTR)(*pStr),iStart,iStop,iMode);}
inline int	CStringChain::Find    (CString &sStr,int iStart,int iStop,int iMode)const{return Find    (sStr .GetLength(),(LPCTSTR)( sStr),iStart,iStop,iMode);}
inline int	CStringChain::FindFast(CString *pStr,int iStart,int iStop,int iMode)const{return FindFast(pStr->GetLength(),(LPCTSTR)(*pStr),iStart,iStop,iMode);}
inline int	CStringChain::FindFast(CString &sStr,int iStart,int iStop,int iMode)const{return FindFast(sStr .GetLength(),(LPCTSTR)( sStr),iStart,iStop,iMode);}

inline int  CStringChain::Chain   (                     CString *pStr,zchar cSign)const{return Chain (0     ,m_iCount,*pStr,cSign);}
inline int  CStringChain::Chain   (                     CString &sStr,zchar cSign)const{return Chain (0     ,m_iCount, sStr,cSign);}
inline int  CStringChain::Chain   (int iStart,int iStop,CString *pStr,zchar cSign)const{return Chain (iStart,iStop   ,*pStr,cSign);}

#endif
#endif


#ifdef		strzlen
#undef 		strzlen
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		i64
#undef 		i64
#endif

#ifdef		u16
#undef 		u16
#endif

#ifdef		u8
#undef 		u8
#endif

#ifdef		Z
#undef 		Z
#endif


#if        _MSC_VER >= 1000
#pragma		warning( pop )
#endif


#endif
