//*****************************************************************************
//*
//*
//*		String Funktionen	 
//*
//*
//*****************************************************************************
//		   
//	Diese Datei enhlt diverse Textfunktionen.
//	Alle Funktionen sind auch Unicode fhig.
//									   
//	Copyright Anton Zechner (C) 2003
//
//	int	  vtostr    (...)		Zahl in String umwandeln (mit Einheiten "123.45 k")
//	int	  itostr    (...)		Zahl in String umwandeln (mit 0x.. 0b..)
//	int	  qtostr    (...)		64-Bit-Zahl in String umwandeln (mit 0x.. 0b..)
//	int	  strtoi    (...)		String in Zahl umwandeln (mit 0x.. 0b..)
//	int64 strtoq    (...)		String in Zahl umwandeln (mit 0x.. 0b..) (fr 64 Bit)
//	int	  strtoh    (...)		Hex-String in Zahl umwandeln (mit "01Bh FF00 )
//	int	  strtof    (...)		String in Fliekommazahl umwandel
//	int	  strtab    (...)		Leerraum einfgen
//	int	  strflen   (...)		Lnge einer Fliekommazahl bestimmen
//	int	  strfind   (...)		Suche String in String
//	int	  strifind  (...)		Suche String in String ohne Gros/Klein Unterscheidung
//	int	  strlfind  (...)		Suche String in String mit Lngenbeschrnkung
//	int	  strlifind (...)		Suche String in String ohne Gros/Klein Unterscheidung
//	int	  strchar   (...)		Suche Pos nach Zeichen in String
//	int	  strlchar  (...)		Suche Zeichen in String
//	int	  strlspn   (...)		Suche erstes Zeichen vom Ende weg bis -1
//	int	  strcspnr  (...)		Suche erstes Zeichen vom Ende weg bis -1
//	int	  strspnr   (...)		Suche erstes ungleiches Zeichen vom Ende weg bis -1
//	int	  strcspnrn (...)		Suche erstes Zeichen vom Ende weg bis 0
//	int	  strspnrn  (...)		Suche erstes ungleiches Zeichen vom Ende weg bis 0
//	int	  strnlen   (...)		String Lnge bestimmen mit Beschrnkung
//	int	  strlcat   (...)		String anhngen mit Lngen Beschrnkung
//	int	  strlcpy   (...)		String kopieren mit Lngen Beschrnkung
//	int	  strtimeset(...)		Mache aus time_t einen Zeit-String
//	int	  strbits   (...)		Suche erstes ungleiches  Zeichen mit Bit-Feld
//	int	  strcbits  (...)		Suche erstes gleiches    Zeichen mit Bit-Feld
//	int	  strlbits  (...)		Suche erstes Pos nach gleichen Zeichen mit Bit-Feld
//	int	  strtobits (...)		Bit-Feld erzeugen
//	int   strencode (...)		Text verschlsseln
//	int   strdecode (...)		Text entschlsseln
//	int   strcut    (...)		Leerzeichen vorne und hinten entfernen
//	int   strlcut   (...)		Leerzeichen vorne und hinten entfernen mit Lngenbeschrnkung
//	int   strpre    (...)		String vor einen anderen String einfgen
//	int   strlpre   (...)		String vor einen anderen String einfgen mit Lngenbeschrnkung
//	int	  strcalc   (...)		Berechnet eine Formel aus einem Text
//	int   strlenstr (...)		Berechne die Lnge einer Stringangabe "...."
//	int   strgetstr (...)		Hole den String aus einer Stringangabe "...."
//	int	  strtomem  (...)		Mache String zu Speicher "/x12/x34" -> :12 34
//	int	  memtostr  (...)		Mache Speicher zu String :11 12 "/x11/x12"
//	int	  utf8tochar(...)		Einen Text in ein Unicode-Zeichen umwandeln
//	int	  chartoutf8(...);		Einen Unicode-Zeichen in einen Text umwandeln

#ifndef	__STRINGFUNCTIONS_H__
#define	__STRINGFUNCTIONS_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#include	<time.h>
#include	<stdio.h>

#ifdef	   _MSC_VER
#pragma		warning( disable :4996 )
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifndef	   _MSC_VER						// Assembler verwenden ?
#ifndef		NO_STR_ASM
#define		NO_STR_ASM
#endif
#endif

#ifndef	   _WIN32
#ifndef		NO_STR_ASM
#define		NO_STR_ASM
#endif
#endif

#ifdef	   _WIN64
#ifndef		NO_STR_ASM
#define		NO_STR_ASM
#endif
#endif

#ifdef		NO_ASM
#ifndef		NO_STR_ASM
#define		NO_STR_ASM
#endif
#endif

// Konstanten fr strtimeset/strtoutc

#define		STR_WEEKDAY		0x00000001		// Wochentag angeben
#define		STR_TIME		0x00000002		// Zeit angeben (HH:MM)
#define		STR_TIME_SEC	0x00000022		// Zeit mit Sekunden angeben (HH:MM:SS)
#define		STR_DATE		0x00000004		// Datum angeben
#define		STR_DATE_ABC	0x0000001C		// Datum angeben (TT.mmm.JJJJ)
#define		STR_DATE_LONG	0x00000014		// Datum angeben (TT.MM.JJJJ)
#define		STR_ABC			0x00000008		// Monat als Text angeben
#define		STR_LONG		0x00000010		// Das Jahr 4 stellig
#define		STR_SEC			0x00000020		// Sekunden angeben
#define 	STR_DATE_ISO	0x00000040		// ISO-Datum YY-MM-DD
#define 	STR_LONG_ISO	0x00000050		// Langes ISO-Datum YYYY-MM-DD
#define		STR_ALL			0x0000001F		// Alles anzeigen ohne Sekunden
#define		STR_ALL_EX		0x0000005B		// Alles anzeigen ohne Sekunden mit ISO Datum (JJ-MM-TT)
#define		STR_ALL_ISO		0x00000072		// Alles anzeigen mit  Sekunden mit ISO Datum (JJJJ-MM-TT HH:MM:SS)
#define 	STR_NOW			0x00100080		// Nicht angegebene Werte mit aktueller Zeit fllen
#define 	STR_NOW_TIME	0x00000080		// Nicht angegebene Zeiten mit aktueller Zeit fllen
#define 	STR_NOW_DATE	0x00100000		// Nicht angegebenes Datum mit aktueller Zeit fllen
#define 	STR_ZONE		0x00000080		// Die Zeitzone anhngen ( ...+10:00)
#define 	STR_GLOBAL		0x00000100		// Die Zeitangabe ist eine globale Zeit
#define 	STR_WEEKCOMMA	0x00000200		// Beistrich nach Wochentag einfgen
#define 	STR_SAVEZONE	0x00000200		// Zeitzone tm_wday speichern
#define 	STR_NOWEEKDAY	0x00000400		// Keinen Wochentag berspringen
#define 	STR_ADD_CHAR	0x00000400		// Ein Zeichen zwischen Datum und Zeit (Bit24..31)
#define 	STR_FORCEZONE	0x00000800		// Zeitzonen bevorzugen (..Z ...+1000 ..+10 ..-10:00)
#define 	STR_NO_COLON	0x00001000		// Keinen Doppelpunkt bei der Zeit einfgen
#define 	STR_NO_SPACE	0x00002000		// Keinen Space am Ende des Datums
#define 	STR_UNTERLINE	0x00004000		// Ein '_' statt ':' bei der Zeit einfgen
#define 	STR_USEUNTER	0x00008000		// '_' statt ' ' verwenden
#define 	STR_USESLASH	0x00010000		// '/' statt '-' und '.' verwenden
#define 	STR_USEHYPHEN	0x00020000		// '-' statt ':' in der Zeit verwenden
#define 	STR_NO_NULL		0x00040000		// Kein Null-Byte am Ende anhngen
#define 	STR_NO_DST		0x00080000		// Sommerzeitumschalzung nicht bercksichtigen
#define 	STR_ALLOW_MS	0x00010000		// Millisekunden in tm_yday holen
#define 	STR_ALLOW_US	0x00020000		// Mikosekunden in tm_yday holen
#define 	STR_ALLOW_NS	0x00040000		// Mikosekunden in tm_yday holen
#define 	STR_FORMAT_DMY	0x00008000		// Das Datum ist mit DD-MM-YY[YY] angegeben
#define 	STR_FORMAT_MDY	0x00009000		// Das Datum ist mit MM-DD-YY[YY] angegeben
#define 	STR_FORMAT_YMD	0x0000A000		// Das Datum ist mit YY[YY]-MM-DD angegeben
#define 	STR_FORMAT_YDM	0x0000D000		// Das Datum ist mit YY[YY]-DD-MM angegeben
#define 	STR_FORMAT_DYM	0x0000C000		// Das Datum ist mit DD-YY[YY]-MM angegeben
#define 	STR_FORMAT_MYD	0x0000E000		// Das Datum ist mit MM-YY[YY]-DD angegeben
#define 	STR_FORMAT_YM	0x0000F000		// Das Datum ist mit YY[YY]-MM    angegeben
#define 	STR_FORMAT_MY	0x0000B000		// Das Datum ist mit MM-YY[YY]    angegeben

#define 	STR_ADD_UNTER	(STR_ADD_CHAR|('_'<<24))
#define 	STR_ADD_TCHAR	(STR_ADD_CHAR|('T'<<24))
#define 	STR_ADD_SPACE	(STR_ADD_CHAR|(' '<<24))

// Konstanten fr memtostr/strtomem

#define		STR_REGMODE		0x80000000		// Spezialzeichen sind nur: \" \\ \n \r
#define		STR_HEXMODE		0x40000000		// Spezialzeichen nur als "\x??" ausgeben
#define		STR_NOQUOTE		0x20000000		// Anfhrungszeichen nicht berspringen
#define		STR_WIDE		0x10000000		// Speicher im UTF16-Format codieren
#define		STR_UTF8		0x08000000		// Speicher im UTF8-Format codieren
#define 	STR_CCPSPLIT	0x04000000		// Spezialzeichen mit nachfolgendem Hexdigit trennen
#define		STR_ANSI		0x00000000		// Speicher im Ansi-Format codieren

// Konstanten fr strfilter

#define		SFT_BEGIN		((int)0)		// Anfangsbuchstaben gro schreiben
#define		SFT_BIG			0x00000001		// Alles gros  schreiben
#define		SFT_LITTLE		0x00000002		// Alles klein schreiben
#define 	SFT_POINTLITTLE	0x00000200		// Den letzten Punktkleinmachen
#define 	SFT_SCANPATH	0x00000400		// Pfadeintrge prfen
#define 	SFT_SCANWORDS	0x00000800		// Worte einzeln prfen
#define 	SFT_LETLITTLE	0x00001000		// Kleingeschriebene Worte kleinlassen
#define 	SFT_ANSI		0x00002000		// Auch deutsche Umlaut und ANSI
#define		SFT_ONLYLITTLE	0x00004000		// Nur wenn alles klein  ist filtern
#define		SFT_ONLYBIG		0x00008000		// Nur wenn alles gro   ist filtern
#define		SFT_ONLYSAME	0x0000C000		// Nur wenn alles gleich ist filtern

// Konstanten fr vtostr

#define 	VTS_SIGNED		0x00000001		// Die Zahl ist Vorzeichenbehaftet
#define 	VTS_SHRINKCOMMA	0x00000002		// Nullen am Ende der Kommastellen entfernen
#define 	VTS_ADDSUFFIX	0x00000004		// Automatisch eine Einheitanhngen (z.B. 123 K)
#define 	VTS_ADDSPACE	0x00000008		// Ein Leerzeichen nach den Kommastellen einfgen
#define 	VTS_CONSTSIZE	0x00800000		// Die unbenutzte Vorkommastelen mit Space auffllen
#define 	VTS_BIN10		0x80000000		// Statt mit 1000 wird mit 2^10 dividiert
#define		VTS_BYTESUFFIX	((void*)1)

// Konstanten fr strgetlist

#define 	STR_GL_HEXDUMP  0x000000FF		// bei Hexdumps Adresss+Ascci berspringen
#define 	STR_GL_CHAR		0x00000000		// die Listenwerte sind 1 Byte gro
#define 	STR_GL_SHORT	0x00000100		// die Listenwerte sind 2 Byte gro
#define 	STR_GL_INT		0x00000300		// die Listenwerte sind 4 Byte gro
#define 	STR_GL_ZERO		0x00000400		// den restlichen Listenbereich mit 0x00 fllen
#define 	STR_GL_FILL		0x00000800		// den restlichen Listenbereich mit 0xFF fllen
#define 	STR_GL_BIN		0x00001000		// nur Binrzahlen sind in der Liste
#define 	STR_GL_DEC		0x00002000		// nur Dezimalzahlen sind in der Liste
#define 	STR_GL_OCT		0x00003000		// nur Oktalzahlen sind in der Liste
#define 	STR_GL_HEX		0x00004000		// nur Hexadezimalzahlen sind in der Liste
#define 	STR_GL_SEMI		0x00010000		// nur mit Semikolon trennen ';'
#define 	STR_GL_POINT	0x00020000		// nur mit Punkt trennen '.'
#define 	STR_GL_DPOINT	0x00030000		// nur mit Doppelpunkt trennen ':'
#define 	STR_GL_CUTTER	0x00040000		// nur mit Beistrich trennen ','
#define 	STR_GL_SPACE	0x00050000		// nur mit Leerbereich trennen ' ' oder '\t'
#define 	STR_GL_MINUS	0x00060000		// nur mit Leerbereich mit Minus trennen '-'
#define 	STR_GL_TAB		0x00070000		// nur mit Tabulator trennen '\t'
#define 	STR_GL_LINES	0x00100000		// es gibt mehrere Zeilen
#define 	STR_GL_LINEADD	0x00200000		// mit '\' am Zeilenende wird die Zeileverlngert
#define 	STR_GL_BRACKES	0x00400000		// der Text kann mit '"' eingegrenzt sein
#define 	STR_GL_NEG		0x00800000		// das Minuszeichen ist in der Liste erlaubt

// Konstanten fr strgetstr

#define 	STR_GET_ID			0x57000000	// ID fr Prefixbergabe
#define 	STR_GET_PREFIX(c,l)	((-1<<31)|STR_GET_ID)|((c)<<16)|(((l)>65535)? 65535: (((l)<0)? 0:(l)))

// Konstanten fr strparseurl

#define 	STR_NOROOTSIGN	0x1E700000		// '/' im Pfad nicht an den Anfang stellen
#define 	STR_NOTUTF8		0x1C700000		// Keine UTF8 Zeichen dekodieren
#define 	STR_URLHOST		0x00000001		// Ein Hostname wurde in der URL gefunden
#define 	STR_URLUSER		0x00000002		// Ein Username wurde in der URL gefunden
#define 	STR_URLPASSWD	0x00000004		// Ein Passwort wurde in der URL gefunden
#define 	STR_URLPORT		0x00000008		// Eine Portnummer wurde in der URL gefunden
#define 	STR_URLPROTOCOL	0x00000010		// Eine Protokollangabe wurde in der URL gefunden
#define 	STR_URLPATH		0x00000020		// Ein Pfad wurde in der URL gefunden
#define 	STR_URLSUFFIX	0x00000040		// Ein Suffix wurde in der URL gefunden

// Konstanten fr strlchar mit iMode

#define 	STR_MUST(c)		(0x57000000|(unsigned short)(c))	

// Konstanten fr strhtmlentity

#define 	STR_ITEMS_HTML	((HtmlEntity*)aHtmlEntity)
#define 	STR_ITEMS_XML	((HtmlEntity*)aXmlEntity )
#define 	STR_COUNT_HTML	102
#define 	STR_COUNT_XML	5


typedef struct
	{
	unsigned short 	uValue;							// Unicode-Zeichen vom Entity
	unsigned char 	uSize;							// Lnge Vom Text
	const char	   *pName;							// Zeiger auf den Text
	}HtmlEntity;


extern const HtmlEntity		aHtmlEntity[STR_COUNT_HTML];	// Entity's fr HTML
extern const HtmlEntity		aXmlEntity [STR_COUNT_XML ];	// Entity's fr XML
extern const unsigned int	aStrwlenTab   [256];
extern const unsigned char	aStrCharValTab[128];

#include	<stdlib.h>
#include	<string.h>

#ifndef		 time_t
#include	<time.h>
#endif


#ifdef	UNICODE
#define strwchar	strwcharw
#define strbchar	strbcharw
#else
#define strwchar	strwchara
#define strbchar	strbchara
#endif


#ifndef	intq
#if defined(LINUX) || defined(linux)
#define intq		long long
#else
#define intq		__int64
#endif
#endif




int    _cdecl  utf8length  (                     unsigned  uUnicode);
int    _cdecl  utf8length  (const char    *pText                   );
int    _cdecl  utf8length  (const char    *pText,int iMax          );
int    _cdecl  utf8prechar (const char    *pText,unsigned &uUnicode);
int	   _cdecl  utf8tochar  (const char    *pText,unsigned &uUnicode);
int	   _cdecl  chartoutf8  (      char    *pText,unsigned  uUnicode);

int    _cdecl  utf16length (                     unsigned  uUnicode);
int    _cdecl  utf16length (const wchar_t *pText                   );
int    _cdecl  utf16length (const wchar_t *pText,int iMax          );
int    _cdecl  utf16prechar(const wchar_t *pText,unsigned &uUnicode);
int	   _cdecl  utf16tochar (const wchar_t *pText,unsigned &uUnicode);
int	   _cdecl  chartoutf16 (      wchar_t *pText,unsigned  uUnicode);

typedef int (_cdecl *TokenCbIA)(void *pParam,const char    *pText,  int   *pValue);
typedef int (_cdecl *TokenCbQA)(void *pParam,const char    *pText,__int64 *pValue);
typedef int (_cdecl *TokenCbFA)(void *pParam,const char    *pText, double *pValue);
typedef int (_cdecl *TokenCbIW)(void *pParam,const wchar_t *pText,  int   *pValue);
typedef int (_cdecl *TokenCbQW)(void *pParam,const wchar_t *pText,__int64 *pValue);
typedef int (_cdecl *TokenCbFW)(void *pParam,const wchar_t *pText, double *pValue);



//******************** ANSI Funktionen ****************************************

int	   _cdecl  strcharval    (int iChar);
void   _cdecl  strtobits     (void *pBits,const char *pSigns,int iMode=0);
int	   _cdecl  strbbits      (const char *pString,const void *pSigns,int iMax=0x1000000);
int	   _cdecl  strdbits      (const char *pString,const void *pSigns,int iMax=0x1000000);
int	   _cdecl  strcbits      (const char *pString,const void *pSigns);
int	   _cdecl  strcbits      (const char *pString,const void *pSigns,int iMax);
int	   _cdecl  strnbits      (const char *pString,const void *pSigns);
int	   _cdecl  strnbits      (const char *pString,const void *pSigns,int iMax);
int	   _cdecl  strlbits      (const char *pString,const void *pSigns);
int	   _cdecl  strlbits      (const char *pString,const void *pSigns,int iMax);
int	   _cdecl  strbits       (const char *pString,const void *pSigns);
int	   _cdecl  strbits       (const char *pString,const void *pSigns,int iMax);
int    _cdecl  strflen       (const char *pString);
int    _cdecl  strflen       (const char *pString,int iMax);
int    _cdecl  strflen       (const char *pString,int iMax,int iMode,void *pPlace=0);
int    _cdecl  strchar       (const char *pString,int iSign);
int    _cdecl  strchar       (const char *pString,int iSign,int iMax);
int	   _cdecl  strchar       (const char *pString,int iSign,int iMax,int iJump);
int    _cdecl  strlchar      (const char *pString,int iSign);
int    _cdecl  strlchar      (const char *pString,int iSign,int iMax);
int	   _cdecl  strlchar      (const char *pString,int iSign,int iMax,int iJump);
int    _cdecl  strrchar      (const char *pString,int iSign);
int    _cdecl  strrchar      (const char *pString,int iSign,int iLen);
int    _cdecl  strchar       (int iMode,const char *pString,int iSign);
int    _cdecl  strchar       (int iMode,const char *pString,int iSign,int iMax);
int    _cdecl  strchar       (int iMode,const char *pString,int iSign,int iMax,int iJump);
int    _cdecl  strlchar      (int iMode,const char *pString,int iSign);
int    _cdecl  strlchar      (int iMode,const char *pString,int iSign,int iMax);
int    _cdecl  strlchar      (int iMode,const char *pString,int iSign,int iMax,int iJump);
int	   _cdecl  vtostr	     (unsigned __int64 uValue,char *pBuffer,unsigned uMode=0x8320,const void *pSufixPtr=0,int *pLevel=0);
int	   _cdecl  itostr        (int   iVal,char *pStr ,int  iMode= 0);
int	   _cdecl  qtostr        (intq  iVal,char *pStr ,int  iMode= 0);
int	   _cdecl  ctostr	     (int   iVal,char *pStr, int  iMode= 0);
int	   _cdecl  strtoz        (int  *pVal,const char *pStr ,int iBase=0,int  iLen=256,int Size=sizeof(int));
int	   _cdecl  strtoni       (const char *pString,int iMax,int iBase=0,int *pLen=  0);
intq   _cdecl  strtonq       (const char *pString,int iMax,int iBase=0,int *pLen=  0);
int	   _cdecl  strtoi        (const char *pString,int iBase=0, int *pLen=  0);
intq   _cdecl  strtoq        (const char *pString,int iBase=0, int *pLen=  0);
int	   _cdecl  strtoc	     (const char *pString,			    int *pLen=  0);
int	   _cdecl  strtoh	     (const char *pString,	  		    int  iLen= -1);
int	   _cdecl  strvlen       (const char *pString,int iBase=10,int	 iLen=0x1000000);
int	   _cdecl  strwlen       (const char *pString,int iMode,int iLen);
int	   _cdecl  strcwlen      (const char *pString,int iMode,int iLen);
int	   _cdecl  strwlen       (const char *pString,int iMode=0x3000000F);
int	   _cdecl  strcwlen      (const char *pString,int iMode=0x3000000F);
int	   _cdecl  strbwlen      (const char *pString,int iMode=0x3000000F,int iLen=0x1000000);
int	   _cdecl  strdwlen      (const char *pString,int iMode=0x3000000F,int iLen=0x1000000);
int	   _cdecl  strwfind      (const char *pString,int iMode,int iLen);
int	   _cdecl  strcwfind     (const char *pString,int iMode,int iLen);
int	   _cdecl  strwfind      (const char *pString,int iMode=0x3000000F);
int	   _cdecl  strcwfind     (const char *pString,int iMode=0x3000000F);
int	   _cdecl  strfind       (const char *pString,const char *pFind);
int	   _cdecl  strfind       (const char *pString,const char *pFind ,int iSize);
int	   _cdecl  strifind      (const char *pString,const char *pFind);
int	   _cdecl  strifind      (const char *pString,const char *pFind ,int iSize);
int    _cdecl  strlfind      (const char *pString,const char *pFind ,int iLen);
int    _cdecl  strlifind     (const char *pString,const char *pFind ,int iLen);
int    _cdecl  strlfind      (const char *pString,const char *pFind ,int iLen,int iSize);
int    _cdecl  strlifind     (const char *pString,const char *pFind ,int iLen,int iSize);
int	   _cdecl  strfindex     (const char *pString,const char *pFind,char cSign);
int	   _cdecl  strfindex     (const char *pString,const char *pFind,char cSign ,int iSize);
int	   _cdecl  strifindex    (const char *pString,const char *pFind,char cSign);
int	   _cdecl  strifindex    (const char *pString,const char *pFind,char cSign ,int iSize);
int    _cdecl  strlfindex    (const char *pString,const char *pFind,char cSign ,int iLen);
int    _cdecl  strlifindex   (const char *pString,const char *pFind,char cSign ,int iLen);
int    _cdecl  strlfindex    (const char *pString,const char *pFind,char cSign ,int iLen,int iSize);
int    _cdecl  strlifindex   (const char *pString,const char *pFind,char cSign ,int iLen,int iSize);
int	   _cdecl  strfindex     (const char *pString,int iMode,const char *pFind,char cSign);
int	   _cdecl  strfindex     (const char *pString,int iMode,const char *pFind,char cSign ,int iSize);
int	   _cdecl  strifindex    (const char *pString,int iMode,const char *pFind,char cSign);
int	   _cdecl  strifindex    (const char *pString,int iMode,const char *pFind,char cSign ,int iSize);
int    _cdecl  strlfindex    (const char *pString,int iMode,const char *pFind,char cSign ,int iLen);
int    _cdecl  strlifindex   (const char *pString,int iMode,const char *pFind,char cSign ,int iLen);
int    _cdecl  strlfindex    (const char *pString,int iMode,const char *pFind,char cSign ,int iLen,int iSize);
int    _cdecl  strlifindex   (const char *pString,int iMode,const char *pFind,char cSign ,int iLen,int iSize);
int	   _cdecl  strnlen       (const char *pString,                   int iLen);
int	   _cdecl  strcspnr      (const char *pString,const char *pSigns,int iLen=-1);
int	   _cdecl  strspnr       (const char *pString,const char *pSigns,int iLen=-1);
int	   _cdecl  strcspnrn     (const char *pString,const char *pSigns,int iLen=-1);
int	   _cdecl  strspnrn      (const char *pString,const char *pSigns,int iLen=-1);
int	   _cdecl  strlspn       (const char *pString,const char *pSigns);
int    _cdecl  strtoutc      (const char *pString,struct tm  *pData,int iFlags=STR_DATE|STR_TIME);
int    _cdecl  strtoutc      (const char *pString,struct tm  *pData,int iFlags,int iMax);
time_t _cdecl  strtoutc      (const char *pString,                  int iFlags=STR_DATE|STR_TIME,int *pFound=0);
time_t _cdecl  strtoutc      (const char *pString,                  int iFlags,int iMax,int *pFound=0);
int	   _cdecl  strtimeset    (      char *pString,time_t Zeit      ,int iMode =STR_DATE|STR_TIME);
int    _cdecl  strlinsert    (      char *pString,int iOff,int iNum,int iSize,const char *pSource,int iMax,int iLen);
int    _cdecl  strlinsert    (      char *pString,int iOff,int iNum,int iSize,const char *pSource,int iMax);
int    _cdecl  strlinsert    (      char *pString,int iOff         ,int iSize,const char *pSource,int iMax);
int    _cdecl  strlinsert    (      char *pString,int iOff         ,int iSize,const char *pSource,int iMax,int iLen);
int    _cdecl  strinsert     (      char *pString,int iOff,int iNum          ,const char *pSource,int iMax,int iLen);
int    _cdecl  strinsert     (      char *pString,int iOff,int iNum          ,const char *pSource,int iMax);
int    _cdecl  strinsert     (      char *pString,int iOff                   ,const char *pSource,int iMax);
int    _cdecl  strinsert     (      char *pString,int iOff                   ,const char *pSource,int iMax,int iLen);
int	   _cdecl  strtab        (      char *pString,int iFrom,int iTo,int iTab=4);
int	   _cdecl  strtablen     (                  const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtablenutf8 (                  const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtablen     (         int iLen,const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtablenutf8 (         int iLen,const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabpos     (int iEnd,         const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabposutf8 (int iEnd,         const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabpos     (int iEnd,int iLen,const char   *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabposutf8 (int iEnd,int iLen,const char   *pText,int iTab=4,int iRaw=0);
void   _cdecl  strfilter     (      char *pString,                  int iMode=SFT_BEGIN|SFT_LETLITTLE|SFT_POINTLITTLE|SFT_SCANWORDS|SFT_ONLYBIG);
void   _cdecl  strfilter     (      char *pString,const char *pText,int iMode=SFT_BEGIN|SFT_LETLITTLE|SFT_POINTLITTLE|SFT_SCANWORDS|SFT_ONLYBIG);
double _cdecl  strtof        (const char *pString);
double _cdecl  strtof        (const char *pString,int *pCount);
double _cdecl  strtof        (const char *pString,int *pCount,int iMode);
int	   _cdecl  strlcat       (      char *pString,const char *pText ,int iMax   );
int	   _cdecl  strlcat       (      char *pString,const char *pText ,int iMax,int iTextLen);
int	   _cdecl  strlcpy       (      char *pString,const char *pText ,int iMax   );
int	   _cdecl  strlcpy       (      char *pString,const char *pText ,int iMax,int iTextLen);
int    _cdecl  strencode     (      char *pString,unsigned lKey=0x97F31692,int iLen=-1,int iStart=0);
int    _cdecl  strdecode     (      char *pString,unsigned lKey=0x97F31692,int iLen=-1,int iStart=0);
int    _cdecl  strreplace    (      char *pString,const char *pText,const char *pFrom,const char *pTo,int iMax);
int    _cdecl  strreplace    (      char *pString,                  const char *pFrom,const char *pTo,int iMax);
int    _cdecl  strreplace    (      char *pString,const char *pText,      char  cFrom,      char  cTo,int iMax);
int    _cdecl  strreplace    (      char *pString,					      char  cFrom,      char  cTo,int iMax);
int    _cdecl  strreplace    (      char *pString,                        char  cFrom,      char  cTo);
int    _cdecl  strireplace   (      char *pString,const char *pText,const char *pFrom,const char *pTo,int iMax);
int    _cdecl  strireplace   (      char *pString,                  const char *pFrom,const char *pTo,int iMax);
int    _cdecl  strireplace   (      char *pString,const char *pText,      char  cFrom,      char  cTo,int iMax);
int    _cdecl  strireplace   (      char *pString,					      char  cFrom,      char  cTo,int iMax);
int    _cdecl  strireplace   (      char *pString,                        char  cFrom,      char  cTo);
int    _cdecl  strtoken      (const char *pString,__int64 *pValue,int *pOk=0         ,TokenCbQA pProc=0,void *pParam=0);
int    _cdecl  strtoken      (const char *pString,  int   *pValue,int *pOk=0         ,TokenCbIA pProc=0,void *pParam=0);
int    _cdecl  strtoken      (const char *pString,double  *pValue,int *pOk=0         ,TokenCbFA pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const char *pString,__int64 *pValue,int *pOk=0         ,TokenCbQA pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const char *pString,  int   *pValue,int *pOk=0         ,TokenCbIA pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const char *pString,double  *pValue,int *pOk=0         ,TokenCbFA pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const char *pString,__int64 *pValue,int *pOk,int iLevel,TokenCbQA pProc  ,void *pParam);
int    _cdecl  strcalc       (const char *pString,  int   *pValue,int *pOk,int iLevel,TokenCbIA pProc  ,void *pParam);
int    _cdecl  strcalc       (const char *pString,double  *pValue,int *pOk,int iLevel,TokenCbFA pProc  ,void *pParam);
int    _cdecl  strcalc       (const char *pString,TokenCbIA   pProc=0,void *pParam=0);
double _cdecl  strcalcf      (const char *pString,TokenCbFA   pProc=0,void *pParam=0);
intq   _cdecl  strcalc64     (const char *pString,TokenCbQA   pProc=0,void *pParam=0);
int    _cdecl  strpre        (      char *pString,const char *pSource);
int    _cdecl  strlpre       (      char *pString,const char *pSource,int iMax);
int    _cdecl  strcut        (      char *pString,const char *pSource);
int    _cdecl  strcut        (      char *pString                    );
int    _cdecl  strlcut       (      char *pString,const char *pSource,int iMax);
int    _cdecl  strlcut       (      char *pString,                    int iMax);
int	   _cdecl  strisip		 (const char *pString,                                          unsigned uMode=0x17);
int    _cdecl  strtoipv4     (const char *pString,      void *pIpAddr,void       *pSubNet=0,unsigned uMode=0x07);
int    _cdecl  strtoipv6     (const char *pString,      void *pIpAddr,int        *pSubNet=0,unsigned uMode=0x17);
const char *_cdecl ipv4tostrptra(                 const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int    _cdecl  ipv4tostr     (      char *pString,const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int    _cdecl  ipv4tostrex   (      char *pString,const void *pIpAddr,const void *pSubNet  ,unsigned uMode=0x04);
const char *_cdecl ipv6tostrptra(                 const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int    _cdecl  ipv6tostr     (      char *pString,const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int	   _cdecl  strfromcsv    (const char *pString,int *pLen,char *pBuffer,int iSize,int iLen=0x10000000,char cSign=';');
int	   _cdecl  strfromcsv    (const char *pString,          char *pBuffer,int iSize,int iLen=0x10000000,char cSign=';');
int    _cdecl  strtocsv      (const char *pString,          char *pBuffer,int iSize,int iLen=0x10000000,char cSign=';');
int    _cdecl  strgetlist    (const char *pString,void *pList,int iSize,int iFlags=STR_GL_INT,int *pCount=0);
int    _cdecl  strsubtext    (const char *pString,const char *pStrings         ,char cSign=0);
int    _cdecl  strsubtext    (const char *pString,const char**pStrings         ,int  iMax=0x10000000);
int    _cdecl  strlsubtext   (const char *pString,const char *pStrings,int iLen,char cSign=0);
int    _cdecl  strlsubtext   (const char *pString,const char**pStrings,int iLen,int  iMax=0x10000000);
int    _cdecl  strisubtext   (const char *pString,const char *pStrings         ,char cSign=0);
int    _cdecl  strisubtext   (const char *pString,const char**pStrings         ,int  iMax=0x10000000);
int    _cdecl  strlisubtext  (const char *pString,const char *pStrings,int iLen,char cSign=0);
int    _cdecl  strlisubtext  (const char *pString,const char**pStrings,int iLen,int  iMax=0x10000000);
int    _cdecl  strsubget     (      char *pString,const char *pList   ,int iLen,unsigned uIndex,char cSign=0);
int    _cdecl  strsubget     (      char *pString,const char**pList   ,int iLen,unsigned uIndex,int  iMax=0x1000000);
int    _cdecl  strsublen     (                    const char *pList            ,unsigned uIndex,char cSign=0   	 ,int *pPos=0);
int    _cdecl  strsublen     (                    const char**pList            ,unsigned uIndex,int  iMax=0x1000000,int *pPos=0);
int    _cdecl  strvcmp       (const char *pStr1  ,const char *pStr2);
int    _cdecl  strvicmp      (const char *pStr1  ,const char *pStr2);
int    _cdecl  strnvcmp      (const char *pStr1  ,const char *pStr2,int iMax);
int    _cdecl  strnvicmp     (const char *pStr1  ,const char *pStr2,int iMax);
int    _cdecl  strpcmp       (const char *pStr1  ,const char *pStr2,int iMax=4096);
int    _cdecl  strpicmp      (const char *pStr1  ,const char *pStr2,int iMax=4096);
int    _cdecl  strfromutf8   (      char *pText  ,const char *pUtf8,int iLen,int iTextLen);
int    _cdecl  strfromutf8   (      char *pText  ,const char *pUtf8,int iLen);
int    _cdecl  strtoutf8     (      char *pUtf8  ,const char *pText,int iLen);
int    _cdecl  strtoutf8     (      char *pUtf8  ,const char *pText,int iLen,int *pCount);
int    _cdecl  strtoutf8     (      char *pUtf8  ,const char *pText,int iLen            ,int iTextLen);
int    _cdecl  strtoutf8     (      char *pUtf8  ,const char *pText,int iLen,int *pCount,int iTextLen);
int    _cdecl  strwchara     (unsigned char  ucChar,unsigned uFormat);
int    _cdecl  strbchara     (unsigned char  ucChar,const void *pBits);
int	   _cdecl  strtomem      (void *pMem,int iLen,const char *pStr,int *pCount=0);
int	   _cdecl  memtostr      (char *pStr,int iMax,const void *pMem,int  iMemSize,int iMode=0);
int	   _cdecl  strlenstr     (                    const char *pStr,                    char cJump='\\',char cSign='"',int iMax=0x1000000);
int	   _cdecl  strlenstr     (int B,              const char *pStr,                    char cJump='\\',char cSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (      char *pBuffer,const char *pStr,          int iSize,char cJump='\\',char cSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (      char *pBuffer,const char *pStr,int *pLen,int iSize,char cJump='\\',char cSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (int B,char *pBuffer,const char *pStr,          int iSize,char cJump='\\',char cSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (int B,char *pBuffer,const char *pStr,int *pLen,int iSize,char cJump='\\',char cSign='"',int iMax=0x1000000);
int    _cdecl  strwcmp       (const char *pString,const char *pCompare);
int    _cdecl  strwicmp      (const char *pString,const char *pCompare);
int	   _cdecl  strparseurl   (const char *pUrl,char *pHost,int iHostSize,char *pUser=0,char *pPasswd=0,unsigned *pPort=0,char *pProtocol=0,char *pPath=0,int iPathSize=0,char *pSuffix=0,int iSuffixSize=0);
int    _cdecl  strawcpy      (      char *pBuffer,const wchar_t  *pText,int iLen,int iTextLen=0x1000000);
int    _cdecl  strawcpy      (      char *pBuffer,const  char    *pText,int iLen,int iTextLen=0x1000000);
int    _cdecl  strawcmp      (const wchar_t *pStr1,const  char   *pStr2,int iMax);
int	   _cdecl  strawcmp      (const  char   *pStr1,const  char   *pStr2,int iMax);
int    _cdecl  strawcmp      (const  char   *pStr1,const wchar_t *pStr2,int iMax);
int    _cdecl  strawcmp      (const wchar_t *pStr1,const wchar_t *pStr2,int iMax);
int    _cdecl  strawicmp     (const wchar_t *pStr1,const  char   *pStr2,int iMax);
int	   _cdecl  strawicmp     (const  char   *pStr1,const  char   *pStr2,int iMax);
int    _cdecl  strawicmp     (const  char   *pStr1,const wchar_t *pStr2,int iMax);
int    _cdecl  strawicmp     (const wchar_t *pStr1,const wchar_t *pStr2,int iMax);
void   _cdecl  strtimenames  (const char *pMonths,const char  *pWeekdays);
int	   _cdecl  strhtmldecode (const char *pText,int iLen,char *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmldecode (const char *pText,         char *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmlencode (const char *pText,int iLen,char *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmlencode (const char *pText,         char *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int    _cdecl  strfindattrib (const char *pText,int iMax,const char *pName,int *pLen=0,int *pEnd=0);
int    _cdecl  strfindtag    (const char *pText,         const char *pName,int *pLen=0,int *pEnd=0,int iFlags=0);
int    _cdecl  strfindtag    (const char *pText,int iMax,const char *pName,int *pLen=0,int *pEnd=0,int iFlags=0);
int    _cdecl  strtaglen     (int iMax,const char *pText,int iFlags=0);
int    _cdecl  strtaglen     (         const char *pText,int iFlags=0);
int	   _cdecl  strgetattrib  (const char *pText,int iMax,      char *pBuffer,int iSize,const char *pName);
int	   _cdecl  strhtmlentity (const char *pText,unsigned &uUnicode,const HtmlEntity *pList=STR_ITEMS_HTML,int iCount=STR_COUNT_HTML);
const char *_cdecl	strsubget(const char *pList,unsigned uIndex,char cSign=0,int *pLen=0,const char *pDefault=0);




#ifndef 	_DEBUG

inline int  _cdecl strcharval(int iChar)
		{
		if(iChar&~0x7F)return 0x7F;

		return aStrCharValTab[iChar];
		}

inline int  _cdecl strwchara(unsigned char ucChar,unsigned uFormat)
		{
		return aStrwlenTab[ucChar]&uFormat;
		}

inline int  _cdecl strbchara(unsigned char ucChar,const void *pBits)
		{
		unsigned *pField=(unsigned*)pBits;
		return    pField[ucChar/32]&(1<<(ucChar&0x1F));
		}

inline void _cdecl strfilter(char *pString,int iMode)
		{
		strfilter(pString,pString,iMode);
		}

inline int  _cdecl strcalc(const char *pText,int *pValue,int *pOk,TokenCbIA pProc,void *pParam)
		{
		return strcalc(pText,pValue,pOk,-2,pProc,pParam);
		}

inline int  _cdecl strcalc(const char *pText,__int64 *pValue,int *pOk,TokenCbQA pProc,void *pParam)
		{
		return strcalc(pText,pValue,pOk,-2,pProc,pParam);
		}

inline int  _cdecl strcalc(const char *pText,double *pValue,int *pOk,TokenCbFA pProc,void *pParam)
		{
		return strcalc(pText,pValue,pOk,-2,pProc,pParam);
		}

inline int  _cdecl strcalc(const char *pText,TokenCbIA pProc,void *pParam)
		{
		int iValue=0;
		strcalc(pText,&iValue,0,-2,pProc,pParam);
		return iValue;
		}

inline double _cdecl strcalcf(const char *pText,TokenCbFA pProc,void *pParam)
		{
		double dValue=0;
		strcalc(pText,&dValue,0,-2,pProc,pParam);
		return dValue;
		}

inline intq _cdecl strcalc64(const char *pText,TokenCbQA pProc,void *pParam)
		{
		intq iValue=0;
		strcalc(pText,&iValue,0,-2,pProc,pParam);
		return iValue;
		}

inline int  _cdecl  strlspn(const char *pString,const char *pSigns)
		{
		int i;
		i=(int)strcspn(pString,pSigns);
		if(pString[i])i++;
		return i;
		}

inline double _cdecl strtof(const char *pStr)
		{
		return atof(pStr);
		};

inline double _cdecl strtof(const char *pStr,int *pLen)
		{
		if(pLen)*pLen=strflen(pStr);
		return atof(pStr);
		}

inline int _cdecl strcut(char *pString)
		{
		return strcut (pString,pString);
		}

inline int _cdecl strlcut (char *pString,int iMax)
		{
		return strlcut(pString,pString,iMax);
		}

inline int _cdecl strawcpy(char *pBuffer,const char *pText,int iLen,int iTextLen)
		{
		return strlcpy(pBuffer,pText,iLen,iTextLen);
		}

inline int _cdecl strawcmp(const char *pStr1,const char *pStr2,int iMax)
		{
		return strncmp(pStr1,pStr2,iMax);
		}

inline int _cdecl strawcmp(const char *pStr1,const wchar_t *pStr2,int iMax)
		{
		return -strawcmp(pStr2,pStr1,iMax);
		}

inline int _cdecl strawicmp(const char *pStr1,const char *pStr2,int iMax)
		{
		return strnicmp(pStr1,pStr2,iMax);
		}

inline int _cdecl strawicmp(const char *pStr1,const wchar_t *pStr2,int iMax)
		{
		return -strawicmp(pStr2,pStr1,iMax);
		}

inline int _cdecl strhtmldecode(const char *pText,char *pBuffer,int iMax,int iFlags,int *pLen)
		{
		return strhtmldecode(pText,-1,pBuffer,iMax,iFlags,pLen);
		}

inline int _cdecl strhtmlencode(const char *pText,char *pBuffer,int iMax,int iFlags,int *pLen)
		{
		return strhtmlencode(pText,-1,pBuffer,iMax,iFlags,pLen);
		}

inline int _cdecl strfromcsv(const char *pString,char *pBuffer,int iSize,int iLen,char cSign)
		{
		return strfromcsv(pString,0,pBuffer,iSize,iLen,cSign);
		}

inline int _cdecl strreplace(char *pString,char cFrom,char cTo,int iMax)
		{
		return strreplace(pString,pString,cFrom,cTo,iMax);
		}

inline int _cdecl strireplace(char *pString,char cFrom,char cTo,int iMax)
		{
		return strireplace(pString,pString,cFrom,cTo,iMax);
		}

inline int _cdecl strinsert(char *pString,int iOff,int iNum,const char *pSource,int iMax)
		{
		return strinsert(pString,iOff,iNum,pSource,iMax,(int)strlen(pSource));
		}

inline int _cdecl  strinsert(char *pString,int iOff,const char *pSource,int iMax)
		{
		return strinsert(pString,iOff,0,pSource,iMax,(int)strlen(pSource));
		}

inline int _cdecl  strinsert(char *pString,int iOff,const char *pSource,int iMax,int iLen)
		{
		return strinsert(pString,iOff,0,pSource,iMax,iLen);
		}

inline int _cdecl strlinsert(char *pString,int iOff,int iSize,int iNum,const char *pSource,int iMax)
		{
		return strlinsert(pString,iOff,iNum,iSize,pSource,iMax,(int)strlen(pSource));
		}

inline int _cdecl strlinsert(char *pString,int iOff,int iSize,const char *pSource,int iMax)
		{
		return strlinsert(pString,iOff,0,iSize,pSource,iMax,(int)strlen(pSource));
		}

inline int _cdecl strlinsert(char *pString,int iOff,int iSize,const char *pSource,int iMax,int iLen)
		{
		return strlinsert(pString,iOff,0,iSize,pSource,iMax,iLen);
		}

inline int _cdecl strwfind(const char *pString,int iMode,int iLen)
		{
		int iRet=strwlen(pString,iMode,iLen); if(iRet>=iLen || !pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strcwfind(const char *pString,int iMode,int iLen)
		{
		int iRet=strcwlen(pString,iMode,iLen); if(iRet>=iLen || !pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strwfind(const char *pString,int iMode)
		{
		int iRet=strwlen(pString,iMode); if(!pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strcwfind(const char *pString,int iMode)
		{
		int iRet=strcwlen(pString,iMode); if(!pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strrchar(const char *pString,int iSign)
		{
		return strrchar(pString,iSign,(int)strlen(pString));
		}

inline int _cdecl strfindtag(const char *pText,const char *pName,int *pLen,int *pEnd,int iFlags)
		{
		return strfindtag(pText,0x10000000,pName,pLen,pEnd,iFlags|0x0200);
		}

inline int _cdecl strtaglen(const char *pText,int iFlags)
		{
		return strtaglen(0x10000000,pText,iFlags|0x0200);
		}

inline int _cdecl  strfindex(const char *pString,int iMode,const char *pFind,char cSign)
		{
		return strfindex(pString,iMode,pFind,cSign,(int)strlen(pFind));
		}

inline int _cdecl  strfindex(const char *pString,const char *pFind,char cSign)
		{
		return strfindex(pString,0x07,pFind,cSign,(int)strlen(pFind));
		}

inline int _cdecl strfindex(const char *pString,const char *pFind,char cSign,int iSize)
		{
		return strfindex(pString,0x07,pFind,cSign,iSize);
		}

inline int _cdecl strifindex(const char *pString,int iMode,const char *pFind,char cSign)
		{
		return strifindex(pString,iMode,pFind,cSign,(int)strlen(pFind));
		}

inline int _cdecl strifindex(const char *pString,const char *pFind,char cSign)
		{
		return strifindex(pString,0x07,pFind,cSign,(int)strlen(pFind));
		}

inline int _cdecl strifindex(const char *pString,const char *pFind,char cSign,int iSize)
		{
		return strifindex(pString,0x07,pFind,cSign,iSize);
		}

inline int _cdecl  strlfindex(const char *pString,int iMode,const char *pFind,char cSign,int iLen)
		{
		return strlfindex(pString,iMode,pFind,cSign,iLen,(int)strlen(pFind));
		}

inline int _cdecl  strlfindex(const char *pString,const char *pFind,char cSign,int iLen)
		{
		return strlfindex(pString,0x07,pFind,cSign,iLen,(int)strlen(pFind));
		}

inline int _cdecl  strlfindex(const char *pString,const char *pFind,char cSign,int iLen,int iSize)
		{
		return strlfindex(pString,0x07,pFind,cSign,iLen,iSize);
		}

inline int _cdecl  strlifindex(const char *pString,int iMode,const char *pFind,char cSign,int iLen)
		{
		return strlifindex(pString,iMode,pFind,cSign,iLen,(int)strlen(pFind));
		}

inline int _cdecl  strlifindex(const char *pString,const char *pFind,char cSign,int iLen)
		{
		return strlifindex(pString,0x07,pFind,cSign,iLen,(int)strlen(pFind));
		}

inline int _cdecl  strlifindex(const char *pString,const char *pFind,char cSign,int iLen,int iSize)
		{
		return strlifindex(pString,0x07,pFind,cSign,iLen,iSize);
		}
#endif

//******************** UNICODE Funktionen *************************************

void   _cdecl  strtobits     (void *pBits,const wchar_t *pSigns,int iMode=0);
int	   _cdecl  strbbits      (const wchar_t *pString,const void *pSigns,int iMax=0x1000000);
int	   _cdecl  strdbits      (const wchar_t *pString,const void *pSigns,int iMax=0x1000000);
int	   _cdecl  strcbits      (const wchar_t *pString,const void *pSigns);
int	   _cdecl  strcbits      (const wchar_t *pString,const void *pSigns,int iMax);
int	   _cdecl  strnbits      (const wchar_t *pString,const void *pSigns);
int	   _cdecl  strnbits      (const wchar_t *pString,const void *pSigns,int iMax);
int	   _cdecl  strlbits      (const wchar_t *pString,const void *pSigns);
int	   _cdecl  strlbits      (const wchar_t *pString,const void *pSigns,int iMax);
int	   _cdecl  strbits       (const wchar_t *pString,const void *pSigns);
int	   _cdecl  strbits       (const wchar_t *pString,const void *pSigns,int iMax);
int    _cdecl  strflen       (const wchar_t *pString);
int    _cdecl  strflen       (const wchar_t *pString,int iMax);
int    _cdecl  strflen       (const wchar_t *pString,int iMax,int iMode,void *pPlace=0);
int    _cdecl  strchar       (const wchar_t *pString,int iSign);
int    _cdecl  strchar       (const wchar_t *pString,int iSign,int iMax);
int	   _cdecl  strchar       (const wchar_t *pString,int iSign,int iMax,int iJump);
int    _cdecl  strlchar      (const wchar_t *pString,int iSign);
int    _cdecl  strlchar      (const wchar_t *pString,int iSign,int iMax);
int	   _cdecl  strlchar      (const wchar_t *pString,int iSign,int iMax,int iJump);
int    _cdecl  strrchar      (const wchar_t *pString,int iSign);
int    _cdecl  strrchar      (const wchar_t *pString,int iSign,int iLen);
int    _cdecl  strchar       (int iMode,const wchar_t *pString,int iSign);
int    _cdecl  strchar       (int iMode,const wchar_t *pString,int iSign,int iMax);
int    _cdecl  strchar       (int iMode,const wchar_t *pString,int iSign,int iMax,int iJump);
int    _cdecl  strlchar      (int iMode,const wchar_t *pString,int iSign);
int    _cdecl  strlchar      (int iMode,const wchar_t *pString,int iSign,int iMax);
int    _cdecl  strlchar      (int iMode,const wchar_t *pString,int iSign,int iMax,int iJump);
int	   _cdecl  vtostr	     (unsigned __int64 uValue,wchar_t *pBuffer,unsigned uMode=0x8320,const void *pSufixPtr=0,int *pLevel=0);
int	   _cdecl  itostr	     (int   iVal,wchar_t *pStr ,int  iMode= 0);
int	   _cdecl  qtostr	     (intq  iVal,wchar_t *pStr ,int  iMode= 0);
int	   _cdecl  ctostr	     (int   iVal,wchar_t *pStr, int  iMode= 0);
int	   _cdecl  strtoz        (int  *pVal,const wchar_t *pStr ,int iBase=0,int  iLen=256,int Size=sizeof(int));
int	   _cdecl  strtoni       (const wchar_t *pString,int iMax,int iBase=0,int *pLen=  0);
intq   _cdecl  strtonq       (const wchar_t *pString,int iMax,int iBase=0,int *pLen=  0);
int	   _cdecl  strtoi        (const wchar_t *pString,int iBase=0, int *pLen=  0);
intq   _cdecl  strtoq        (const wchar_t *pString,int iBase=0, int *pLen=  0);
int	   _cdecl  strtoc	     (const wchar_t *pString,			    int *pLen=  0);
int	   _cdecl  strtoh	     (const wchar_t *pString,	  		    int  iLen= -1);
int	   _cdecl  strvlen       (const wchar_t *pString,int iBase=10,int	 iLen=0x1000000);
int	   _cdecl  strwlen       (const wchar_t *pString,int iMode,int iLen);
int	   _cdecl  strcwlen      (const wchar_t *pString,int iMode,int iLen);
int	   _cdecl  strwlen       (const wchar_t *pString,int iMode=0x3000000F);
int	   _cdecl  strcwlen      (const wchar_t *pString,int iMode=0x3000000F);
int	   _cdecl  strbwlen      (const wchar_t *pString,int iMode=0x3000000F,int iLen=0x1000000);
int	   _cdecl  strdwlen      (const wchar_t *pString,int iMode=0x3000000F,int iLen=0x1000000);
int	   _cdecl  strwfind      (const wchar_t *pString,int iMode,int iLen);
int	   _cdecl  strcwfind     (const wchar_t *pString,int iMode,int iLen);
int	   _cdecl  strwfind      (const wchar_t *pString,int iMode=0x3000000F);
int	   _cdecl  strcwfind     (const wchar_t *pString,int iMode=0x3000000F);
int	   _cdecl  strfind       (const wchar_t *pString,const wchar_t *pFind);
int	   _cdecl  strfind       (const wchar_t *pString,const wchar_t *pFind ,int iSize);
int	   _cdecl  strifind      (const wchar_t *pString,const wchar_t *pFind);
int	   _cdecl  strifind      (const wchar_t *pString,const wchar_t *pFind ,int iSize);
int    _cdecl  strlfind      (const wchar_t *pString,const wchar_t *pFind ,int iLen);
int    _cdecl  strlifind     (const wchar_t *pString,const wchar_t *pFind ,int iLen);
int    _cdecl  strlfind      (const wchar_t *pString,const wchar_t *pFind ,int iLen,int iSize);
int    _cdecl  strlifind     (const wchar_t *pString,const wchar_t *pFind ,int iLen,int iSize);
int	   _cdecl  strfindex     (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign);
int	   _cdecl  strfindex     (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign ,int iSize);
int	   _cdecl  strifindex    (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign);
int	   _cdecl  strifindex    (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign ,int iSize);
int    _cdecl  strlfindex    (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign ,int iLen);
int    _cdecl  strlifindex   (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign ,int iLen);
int    _cdecl  strlfindex    (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign ,int iLen,int iSize);
int    _cdecl  strlifindex   (const wchar_t *pString,const wchar_t *pFind,wchar_t cSign ,int iLen,int iSize);
int	   _cdecl  strfindex     (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign);
int	   _cdecl  strfindex     (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign ,int iSize);
int	   _cdecl  strifindex    (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign);
int	   _cdecl  strifindex    (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign ,int iSize);
int    _cdecl  strlfindex    (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign ,int iLen);
int    _cdecl  strlifindex   (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign ,int iLen);
int    _cdecl  strlfindex    (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign ,int iLen,int iSize);
int    _cdecl  strlifindex   (const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign ,int iLen,int iSize);
int	   _cdecl  strnlen       (const wchar_t *pString,                             int iLen);
int	   _cdecl  strcspnr      (const wchar_t *pString,const wchar_t *pSigns,int iLen=-1);
int	   _cdecl  strspnr       (const wchar_t *pString,const wchar_t *pSigns,int iLen=-1);
int	   _cdecl  strcspnrn     (const wchar_t *pString,const wchar_t *pSigns,int iLen=-1);
int	   _cdecl  strspnrn      (const wchar_t *pString,const wchar_t *pSigns,int iLen=-1);
int	   _cdecl  strlspn       (const wchar_t *pString,const wchar_t *pSigns);
int    _cdecl  strtoutc      (const wchar_t *pString,struct tm  *pData,int iFlags=STR_DATE|STR_TIME);
int    _cdecl  strtoutc      (const wchar_t *pString,struct tm  *pData,int iFlags,int iMax);
time_t _cdecl  strtoutc      (const wchar_t *pString,                  int iFlags=STR_DATE|STR_TIME,int *pFound=0);
time_t _cdecl  strtoutc      (const wchar_t *pString,                  int iFlags,int iMax,int *pFound=0);
int	   _cdecl  strtimeset    (      wchar_t *pString,time_t Zeit      ,int iMode =STR_DATE|STR_TIME);
int    _cdecl  strlinsert    (      wchar_t *pString,int iOff,int iNum,int iSize,const wchar_t *pSource,int iMax,int iLen);
int    _cdecl  strlinsert    (      wchar_t *pString,int iOff,int iNum,int iSize,const wchar_t *pSource,int iMax);
int    _cdecl  strlinsert    (      wchar_t *pString,int iOff         ,int iSize,const wchar_t *pSource,int iMax);
int    _cdecl  strlinsert    (      wchar_t *pString,int iOff         ,int iSize,const wchar_t *pSource,int iMax,int iLen);
int    _cdecl  strinsert     (      wchar_t *pString,int iOff,int iNum          ,const wchar_t *pSource,int iMax,int iLen);
int    _cdecl  strinsert     (      wchar_t *pString,int iOff,int iNum          ,const wchar_t *pSource,int iMax);
int    _cdecl  strinsert     (      wchar_t *pString,int iOff                   ,const wchar_t *pSource,int iMax);
int    _cdecl  strinsert     (      wchar_t *pString,int iOff                   ,const wchar_t *pSource,int iMax,int iLen);
int	   _cdecl  strtab        (      wchar_t *pString,int iFrom,int iTo,int iTab=4);
int	   _cdecl  strtablen     (                  const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtablenutf16(                  const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtablen     (         int iLen,const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtablenutf16(         int iLen,const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabpos     (int iEnd,         const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabposutf16(int iEnd,         const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabpos     (int iEnd,int iLen,const wchar_t *pText,int iTab=4,int iRaw=0);
int	   _cdecl  strtabposutf16(int iEnd,int iLen,const wchar_t *pText,int iTab=4,int iRaw=0);
double _cdecl  strtof        (const wchar_t *pString);
double _cdecl  strtof        (const wchar_t *pString,int *pCount);
double _cdecl  strtof        (const wchar_t *pString,int *pCount,int iMode);
void   _cdecl  strfilter     (      wchar_t *pString,                      int iMode=SFT_BEGIN|SFT_LETLITTLE|SFT_POINTLITTLE|SFT_SCANWORDS|SFT_ONLYBIG);
void   _cdecl  strfilter     (      wchar_t *pString,const wchar_t *pText ,int iMode=SFT_BEGIN|SFT_LETLITTLE|SFT_POINTLITTLE|SFT_SCANWORDS|SFT_ONLYBIG);
int	   _cdecl  strlcat       (      wchar_t *pString,const wchar_t *pText ,int iMax   );
int	   _cdecl  strlcat       (      wchar_t *pString,const wchar_t *pText ,int iMax,int iTextLen);
int	   _cdecl  strlcpy       (      wchar_t *pString,const wchar_t *pText ,int iMax   );
int	   _cdecl  strlcpy       (      wchar_t *pString,const wchar_t *pText ,int iMax,int iTextLen);
int    _cdecl  strencode     (      wchar_t *pString,unsigned lKey=0x97F31692,int iLen=-1,int iStart=0);
int    _cdecl  strdecode     (      wchar_t *pString,unsigned lKey=0x97F31692,int iLen=-1,int iStart=0);
int    _cdecl  strreplace    (      wchar_t *pString,const wchar_t *pText,const wchar_t *pFrom,const wchar_t *pTo,int iMax);
int    _cdecl  strreplace    (      wchar_t *pString,                     const wchar_t *pFrom,const wchar_t *pTo,int iMax);
int    _cdecl  strreplace    (      wchar_t *pString,const wchar_t *pText,      wchar_t  cFrom,      wchar_t  cTo,int iMax);
int    _cdecl  strreplace    (      wchar_t *pString,						    wchar_t  cFrom,      wchar_t  cTo,int iMax);
int    _cdecl  strreplace    (      wchar_t *pString,                           wchar_t  cFrom,      wchar_t  cTo);
int    _cdecl  strireplace   (      wchar_t *pString,const wchar_t *pText,const wchar_t *pFrom,const wchar_t *pTo,int iMax);
int    _cdecl  strireplace   (      wchar_t *pString,                     const wchar_t *pFrom,const wchar_t *pTo,int iMax);
int    _cdecl  strireplace   (      wchar_t *pString,const wchar_t *pText,      wchar_t  cFrom,      wchar_t  cTo,int iMax);
int    _cdecl  strireplace   (      wchar_t *pString,					        wchar_t  cFrom,      wchar_t  cTo,int iMax);
int    _cdecl  strireplace   (      wchar_t *pString,                           wchar_t  cFrom,      wchar_t  cTo);
int    _cdecl  strtoken      (const wchar_t *pString,__int64 *pValue,int *pOk=0         ,TokenCbQW pProc=0,void *pParam=0);
int    _cdecl  strtoken      (const wchar_t *pString,  int   *pValue,int *pOk=0         ,TokenCbIW pProc=0,void *pParam=0);
int    _cdecl  strtoken      (const wchar_t *pString,double  *pValue,int *pOk=0         ,TokenCbFW pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const wchar_t *pString,__int64 *pValue,int *pOk=0         ,TokenCbQW pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const wchar_t *pString,  int   *pValue,int *pOk=0         ,TokenCbIW pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const wchar_t *pString,double  *pValue,int *pOk=0         ,TokenCbFW pProc=0,void *pParam=0);
int    _cdecl  strcalc       (const wchar_t *pString,__int64 *pValue,int *pOk,int iLevel,TokenCbQW pProc  ,void *pParam);
int    _cdecl  strcalc       (const wchar_t *pString,  int   *pValue,int *pOk,int iLevel,TokenCbIW pProc  ,void *pParam);
int    _cdecl  strcalc       (const wchar_t *pString,double  *pValue,int *pOk,int iLevel,TokenCbFW pProc  ,void *pParam);
int    _cdecl  strcalc       (const wchar_t *pString,TokenCbIW pProc=0,void *pParam=0);
double _cdecl  strcalcf      (const wchar_t *pString,TokenCbFW pProc=0,void *pParam=0);
intq   _cdecl  strcalc64     (const wchar_t *pString,TokenCbQW pProc=0,void *pParam=0);
int    _cdecl  strpre        (      wchar_t *pString,const wchar_t *pSource);
int    _cdecl  strlpre       (      wchar_t *pString,const wchar_t *pSource,int iMax);
int    _cdecl  strcut        (      wchar_t *pString,const wchar_t *pSource);
int    _cdecl  strcut        (      wchar_t *pString                              );
int    _cdecl  strlcut       (      wchar_t *pString,const wchar_t *pSource,int iMax);
int    _cdecl  strlcut       (      wchar_t *pString,                       int iMax);
int	   _cdecl  strisip		 (const wchar_t *pString,                                          unsigned uMode=0x17);
int    _cdecl  strtoipv4     (const wchar_t *pString,      void *pIpAddr,void       *pSubNet=0,unsigned uMode=0x07);
int    _cdecl  strtoipv6     (const wchar_t *pString,      void *pIpAddr,int        *pSubNet=0,unsigned uMode=0x17);
const wchar_t *_cdecl ipv4tostrptrw(                 const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int    _cdecl  ipv4tostr     (      wchar_t *pString,const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int    _cdecl  ipv4tostrex   (      wchar_t *pString,const void *pIpAddr,const void *pSubNet  ,unsigned uMode=0x04);
const wchar_t *_cdecl ipv6tostrptrw(                 const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int    _cdecl  ipv6tostr     (      wchar_t *pString,const void *pIpAddr,unsigned    uSubNet=0,unsigned uMode=0x04);
int	   _cdecl  strfromcsv    (const wchar_t *pString,int *pLen,wchar_t *pBuffer,int iSize,int iLen=0x10000000,wchar_t cSign=';');
int	   _cdecl  strfromcsv    (const wchar_t *pString,          wchar_t *pBuffer,int iSize,int iLen=0x10000000,wchar_t cSign=';');
int    _cdecl  strtocsv      (const wchar_t *pString,          wchar_t *pBuffer,int iSize,int iLen=0x10000000,wchar_t cSign=';');
int    _cdecl  strgetlist    (const wchar_t *pString,void *pList,int iSize,int iFlags=STR_GL_INT,int *pCount=0);
int    _cdecl  strsubtext    (const wchar_t *pString,const wchar_t *pStrings         ,wchar_t cSign=0);
int    _cdecl  strsubtext    (const wchar_t *pString,const wchar_t**pStrings         ,int  iMax=0x10000000);
int    _cdecl  strlsubtext   (const wchar_t *pString,const wchar_t *pStrings,int iLen,wchar_t cSign=0);
int    _cdecl  strlsubtext   (const wchar_t *pString,const wchar_t**pStrings,int iLen,int  iMax=0x10000000);
int    _cdecl  strisubtext   (const wchar_t *pString,const wchar_t *pStrings         ,wchar_t cSign=0);
int    _cdecl  strisubtext   (const wchar_t *pString,const wchar_t**pStrings         ,int  iMax=0x10000000);
int    _cdecl  strlisubtext  (const wchar_t *pString,const wchar_t *pStrings,int iLen,wchar_t cSign=0);
int    _cdecl  strlisubtext  (const wchar_t *pString,const wchar_t**pStrings,int iLen,int  iMax=0x10000000);
int    _cdecl  strsubget     (      wchar_t *pString,const wchar_t *pList   ,int iLen,unsigned uIndex,char cSign=0);
int    _cdecl  strsubget     (      wchar_t *pString,const wchar_t**pList   ,int iLen,unsigned uIndex,int  iMax=0x1000000);
int    _cdecl  strsublen     (                       const wchar_t *pList            ,unsigned uIndex,char cSign=0	   ,int *pPos=0);
int    _cdecl  strsublen     (                       const wchar_t**pList            ,unsigned uIndex,int  iMax=0x1000000,int *pPos=0);
int    _cdecl  strvcmp       (const wchar_t *pStr1  ,const wchar_t *pStr2);
int    _cdecl  strvicmp      (const wchar_t *pStr1  ,const wchar_t *pStr2);
int    _cdecl  strnvcmp      (const wchar_t *pStr1  ,const wchar_t *pStr2,int iMax);
int    _cdecl  strnvicmp     (const wchar_t *pStr1  ,const wchar_t *pStr2,int iMax);
int	   _cdecl  strpcmp       (const wchar_t *pStr1  ,const wchar_t *pStr2,int iMax=4096);
int    _cdecl  strpicmp      (const wchar_t *pStr1  ,const wchar_t *pStr2,int iMax=4096);
int    _cdecl  strfromutf8   (      wchar_t *pText  ,const char    *pUtf8,int iLen,int iTextLen);
int    _cdecl  strfromutf8   (      wchar_t *pText  ,const char    *pUtf8,int iLen);
int	   _cdecl  strtoutf8     (       char   *pUtf8  ,const wchar_t *pText,int iLen);
int    _cdecl  strtoutf8     (       char   *pUtf8  ,const wchar_t *pText,int iLen,int *pCount);
int	   _cdecl  strtoutf8     (       char   *pUtf8  ,const wchar_t *pText,int iLen            ,int iTextLen);
int    _cdecl  strtoutf8     (       char   *pUtf8  ,const wchar_t *pText,int iLen,int *pCount,int iTextLen);
int    _cdecl  strwcharw     (wchar_t  usChar,unsigned uFormat);
int    _cdecl  strbcharw     (wchar_t  usChar,const void *pBits);
int	   _cdecl  strtomem      (void    *pMem,int iLen,const wchar_t *pStr,int  *pCount=0);
int	   _cdecl  memtostr      (wchar_t *pStr,int iMax,const void *pMem,int iMemSize,int iMode=0);
int	   _cdecl  strlenstr     (                       const wchar_t *pStr,                    wchar_t uJump='\\',wchar_t uSign='"',int iMax=0x1000000);
int	   _cdecl  strlenstr     (int B,                 const wchar_t *pStr,                    wchar_t uJump='\\',wchar_t uSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (      wchar_t *pBuffer,const wchar_t *pStr,          int iSize,wchar_t uJump='\\',wchar_t uSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (      wchar_t *pBuffer,const wchar_t *pStr,int *pLen,int iSize,wchar_t uJump='\\',wchar_t uSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (int B,wchar_t *pBuffer,const wchar_t *pStr,          int iSize,wchar_t uJump='\\',wchar_t uSign='"',int iMax=0x1000000);
int    _cdecl  strgetstr     (int B,wchar_t *pBuffer,const wchar_t *pStr,int *pLen,int iSize,wchar_t uJump='\\',wchar_t uSign='"',int iMax=0x1000000);
int    _cdecl  strwcmp       (const wchar_t *pString,const wchar_t *pCompare);
int    _cdecl  strwicmp      (const wchar_t *pString,const wchar_t *pCompare);
int	   _cdecl  strparseurl   (const wchar_t *pUrl,wchar_t *pHost,int iHostSize,wchar_t *pUser=0,wchar_t *pPasswd=0,unsigned *pPort=0,wchar_t *pProtocol=0,wchar_t *pPath=0,int iPathSize=0,wchar_t *pSuffix=0,int iSuffixSize=0);
int    _cdecl  strawcpy      (      wchar_t *pBuffer,const   char   *pText,int iLen,int iTextLen=0x1000000);
int    _cdecl  strawcpy      (      wchar_t *pBuffer,const  wchar_t *pText,int iLen,int iTextLen=0x1000000);
void   _cdecl  strtimenames  (const wchar_t *pMonths,const  wchar_t *pWeekdays);
int	   _cdecl  strhtmldecode (const char    *pText,int iLen,wchar_t *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmldecode (const char    *pText         ,wchar_t *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmldecode (const wchar_t *pText,int iLen,wchar_t *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmldecode (const wchar_t *pText         ,wchar_t *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmlencode (const wchar_t *pText,int iLen,char    *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int	   _cdecl  strhtmlencode (const wchar_t *pText         ,char    *pBuffer,int iMax,int iFlags=3,int *pLen=0);
int    _cdecl  strfindattrib (const wchar_t *pText,int iMax,const wchar_t *pName,int *pLen=0,int *pEnd=0);
int    _cdecl  strfindtag    (const wchar_t *pText,         const wchar_t *pName,int *pLen=0,int *pEnd=0,int iFlags=0);
int    _cdecl  strfindtag    (const wchar_t *pText,int iMax,const wchar_t *pName,int *pLen=0,int *pEnd=0,int iFlags=0);
int    _cdecl  strtaglen     (int iMax,const wchar_t *pText,int iFlags=0);
int    _cdecl  strtaglen     (         const wchar_t *pText,int iFlags=0);
int	   _cdecl  strgetattrib  (const wchar_t *pText,int iMax,      wchar_t *pBuffer,int iSize,const wchar_t *pName);
int	   _cdecl  strhtmlentity (const wchar_t *pText,unsigned &uUnicode,const HtmlEntity *pList=STR_ITEMS_HTML,int iCount=STR_COUNT_HTML);

const wchar_t * _cdecl	strsubget(const wchar_t *pList,unsigned uIndex,wchar_t cSign=0,int *pLen=0,const wchar_t *pDefault=0);

#ifndef 	_DEBUG

inline int  _cdecl strwcharw(wchar_t usChar,unsigned uFormat)
		{
		if(usChar>=256)return 0x40000000;
		return aStrwlenTab[usChar]&uFormat;
		}

inline int  _cdecl strbcharw(wchar_t usChar,const void *pBits)
		{
		if(usChar>=256)usChar=255;
		unsigned *pField=(unsigned*)pBits;
		return    pField[usChar/32]&(1<<(usChar&0x1F));
		}

inline void _cdecl strfilter(wchar_t *pString,int iMode)
		{
		strfilter(pString,pString,iMode);
		}

inline int _cdecl strcalc(const wchar_t *pText,int *pValue,int *pOk,TokenCbIW pProc,void *pParam)
		{
		return strcalc(pText,pValue,pOk,-2,pProc,pParam);
		}

inline int _cdecl strcalc(const wchar_t *pText,__int64 *pValue,int *pOk,TokenCbQW pProc,void *pParam)
		{
		return strcalc(pText,pValue,pOk,-2,pProc,pParam);
		}

inline int _cdecl strcalc(const wchar_t *pText,double *pValue,int *pOk,TokenCbFW pProc,void *pParam)
		{
		return strcalc(pText,pValue,pOk,-2,pProc,pParam);
		}

inline int  _cdecl strcalc(const wchar_t *pText,TokenCbIW pProc,void *pParam)
		{
		int iValue=0;
		strcalc(pText,&iValue,0,-2,pProc,pParam);
		return iValue;
		}

inline double _cdecl strcalcf(const wchar_t *pText,TokenCbFW pProc,void *pParam)
		{
		double dValue=0;
		strcalc(pText,&dValue,0,-2,pProc,pParam);
		return dValue;
		}

inline intq _cdecl strcalc64(const wchar_t *pText,TokenCbQW pProc,void *pParam)
		{
		intq iValue=0;
		strcalc(pText,&iValue,0,-2,pProc,pParam);
		return iValue;
		}

inline int  _cdecl strlspn(const wchar_t *pString,const wchar_t *pSigns)
		{
		int i;
		i=(int)wcscspn(pString,pSigns);
		if(pString[i])i++;
		return i;
		}

inline double _cdecl strtof(const wchar_t *pStr)
		{
		double dVaue=0.0;

		swscanf(pStr,L"%lf",&dVaue);

		return dVaue;
		};

inline double _cdecl strtof(const wchar_t *pStr,int *pCount)
		{
		double dVaue=0.0;

		if(pCount)*pCount=strflen(pStr);
		swscanf(pStr,L"%lf",&dVaue);

		return dVaue;
		}

inline int  _cdecl  strcut(wchar_t *pString)
		{
		return strcut (pString,pString);
		}

inline int  _cdecl  strlcut(wchar_t *pString,int iMax)
		{
		return strlcut(pString,pString,iMax);
		}

inline int _cdecl strawcpy(wchar_t *pBuffer,const wchar_t *pText,int iLen,int iTextLen)
		{
		return strlcpy(pBuffer,pText,iLen,iTextLen);
		}

inline int _cdecl strawcmp(const wchar_t *pStr1,const wchar_t *pStr2,int iMax)
		{
		return wcsncmp(pStr1,pStr2,iMax);
		}

inline int _cdecl strawicmp(const wchar_t *pStr1,const wchar_t *pStr2,int iMax)
		{
		return wcsnicmp(pStr1,pStr2,iMax);
		}

inline int _cdecl strhtmldecode(const char *pText,wchar_t *pBuffer,int iMax,int iFlags,int *pLen)
		{
		return strhtmldecode(pText,-1,pBuffer,iMax,iFlags,pLen);
		}

inline int _cdecl strhtmldecode(const wchar_t *pText,wchar_t *pBuffer,int iMax,int iFlags,int *pLen)
		{
		return strhtmldecode(pText,-1,pBuffer,iMax,iFlags,pLen);
		}

inline int _cdecl strhtmlencode(const wchar_t *pText,char *pBuffer,int iMax,int iFlags,int *pLen)
		{
		return strhtmlencode(pText,-1,pBuffer,iMax,iFlags,pLen);
		}

inline int _cdecl strgetstr(char *pBuffer,char cPrefix,const char *pStr,int iSize,char cJump,char cSign,int iMax)
		{
		return strgetstr(pBuffer,pStr,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(wchar_t *pBuffer,wchar_t cPrefix,const wchar_t *pStr,int iSize,wchar_t cJump,wchar_t cSign,int iMax)
		{
		return strgetstr(pBuffer,pStr,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(char *pBuffer,char cPrefix,const char *pStr,int *pLen,int iSize,char cJump,char cSign,int iMax)
		{
		return strgetstr(pBuffer,pStr,pLen,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(wchar_t *pBuffer,wchar_t cPrefix,const wchar_t *pStr,int *pLen,int iSize,wchar_t cJump,wchar_t cSign,int iMax)
		{
		return strgetstr(pBuffer,pStr,pLen,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(int iMode,char *pBuffer,char cPrefix,const char *pStr,int iSize,char cJump,char cSign,int iMax)
		{
		return strgetstr(iMode,pBuffer,pStr,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(int iMode,wchar_t *pBuffer,wchar_t cPrefix,const wchar_t *pStr,int iSize,wchar_t cJump,wchar_t cSign,int iMax)
		{
		return strgetstr(iMode,pBuffer,pStr,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(int iMode,char *pBuffer,char cPrefix,const char *pStr,int *pLen,int iSize,char cJump,char cSign,int iMax)
		{
		return strgetstr(iMode,pBuffer,pStr,pLen,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strgetstr(int iMode,wchar_t *pBuffer,wchar_t cPrefix,const wchar_t *pStr,int *pLen,int iSize,wchar_t cJump,wchar_t cSign,int iMax)
		{
		return strgetstr(iMode,pBuffer,pStr,pLen,iSize,cJump,cSign,STR_GET_PREFIX(cPrefix,iMax));
		}

inline int _cdecl strfromcsv(const wchar_t *pString,wchar_t *pBuffer,int iSize,int iLen,wchar_t cSign)
		{
		return strfromcsv(pString,0,pBuffer,iSize,iLen,cSign);
		}

inline int _cdecl strreplace(wchar_t *pString,wchar_t cFrom,wchar_t cTo,int iMax)
		{
		return strreplace(pString,pString,cFrom,cTo,iMax);
		}

inline int _cdecl strireplace(wchar_t *pString,wchar_t cFrom,wchar_t cTo,int iMax)
		{
		return strireplace(pString,pString,cFrom,cTo,iMax);
		}

inline int _cdecl strinsert(wchar_t *pString,int iOff,int iNum,const wchar_t *pSource,int iMax)
		{
		return strinsert(pString,iOff,iNum,pSource,iMax,(int)wcslen(pSource));
		}

inline int _cdecl  strinsert(wchar_t *pString,int iOff,const wchar_t *pSource,int iMax)
		{
		return strinsert(pString,iOff,0,pSource,iMax,(int)wcslen(pSource));
		}

inline int _cdecl  strinsert(wchar_t *pString,int iOff,const wchar_t *pSource,int iMax,int iLen)
		{
		return strinsert(pString,iOff,0,pSource,iMax,iLen);
		}

inline int _cdecl strlinsert(wchar_t *pString,int iOff,int iSize,int iNum,const wchar_t *pSource,int iMax)
		{
		return strlinsert(pString,iOff,iNum,iSize,pSource,iMax,(int)wcslen(pSource));
		}

inline int _cdecl strlinsert(wchar_t *pString,int iOff,int iSize,const wchar_t *pSource,int iMax)
		{
		return strlinsert(pString,iOff,0,iSize,pSource,iMax,(int)wcslen(pSource));
		}

inline int _cdecl strlinsert(wchar_t *pString,int iOff,int iSize,const wchar_t *pSource,int iMax,int iLen)
		{
		return strlinsert(pString,iOff,0,iSize,pSource,iMax,iLen);
		}

inline int _cdecl strwfind(const wchar_t *pString,int iMode,int iLen)
		{
		int iRet=strwlen(pString,iMode,iLen); if(iRet>=iLen || !pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strcwfind(const wchar_t *pString,int iMode,int iLen)
		{
		int iRet=strcwlen(pString,iMode,iLen); if(iRet>=iLen || !pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strwfind(const wchar_t *pString,int iMode)
		{
		int iRet=strwlen(pString,iMode); if(!pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strcwfind(const wchar_t *pString,int iMode)
		{
		int iRet=strcwlen(pString,iMode); if(!pString[iRet])iRet=-1; return iRet;
		}

inline int _cdecl strrchar(const wchar_t *pString,int iSign)
		{
		return strrchar(pString,iSign,(int)wcslen(pString));
		}

inline int _cdecl strfindtag(const wchar_t *pText,const wchar_t *pName,int *pLen,int *pEnd,int iFlags)
		{
		return strfindtag(pText,0x10000000,pName,pLen,pEnd,iFlags|0x0200);
		}

inline int _cdecl strtaglen(const wchar_t *pText,int iFlags)
		{
		return strtaglen(0x10000000,pText,iFlags|0x0200);
		}

inline int _cdecl  strfindex(const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign)
		{
		return strfindex(pString,iMode,pFind,cSign,(int)wcslen(pFind));
		}

inline int _cdecl  strfindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign)
		{
		return strfindex(pString,0x07,pFind,cSign,(int)wcslen(pFind));
		}

inline int _cdecl strfindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign,int iSize)
		{
		return strfindex(pString,0x07,pFind,cSign,iSize);
		}

inline int _cdecl strifindex(const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign)
		{
		return strifindex(pString,iMode,pFind,cSign,(int)wcslen(pFind));
		}

inline int _cdecl strifindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign)
		{
		return strifindex(pString,0x07,pFind,cSign,(int)wcslen(pFind));
		}

inline int _cdecl strifindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign,int iSize)
		{
		return strifindex(pString,0x07,pFind,cSign,iSize);
		}

inline int _cdecl  strlfindex(const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign,int iLen)
		{
		return strlfindex(pString,iMode,pFind,cSign,iLen,(int)wcslen(pFind));
		}

inline int _cdecl  strlfindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign,int iLen)
		{
		return strlfindex(pString,0x07,pFind,cSign,iLen,(int)wcslen(pFind));
		}

inline int _cdecl  strlfindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign,int iLen,int iSize)
		{
		return strlfindex(pString,0x07,pFind,cSign,iLen,iSize);
		}

inline int _cdecl  strlifindex(const wchar_t *pString,int iMode,const wchar_t *pFind,wchar_t cSign,int iLen)
		{
		return strlifindex(pString,iMode,pFind,cSign,iLen,(int)wcslen(pFind));
		}

inline int _cdecl  strlifindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign,int iLen)
		{
		return strlifindex(pString,0x07,pFind,cSign,iLen,(int)wcslen(pFind));
		}

inline int _cdecl  strlifindex(const wchar_t *pString,const wchar_t *pFind,wchar_t cSign,int iLen,int iSize)
		{
		return strlifindex(pString,0x07,pFind,cSign,iLen,iSize);
		}

#endif

#ifdef	UNICODE
#define ipv4tostrptr	ipv4tostrptrw
#define ipv6tostrptr	ipv6tostrptrw
#else
#define ipv4tostrptr	ipv4tostrptra
#define ipv6tostrptr	ipv6tostrptra
#endif


#endif
