//******************************************************************************
//*
//*
//*		ComUtility.h
//*
//*
//******************************************************************************
#ifndef		__COMUTILITY_H__
#define		__COMUTILITY_H__

#ifdef		GLOBAL_CONFIG
#define 	COMUTILITY_H
#include	<GlobalConfig.h>
#undef		COMUTILITY_H
#endif

#ifdef		_MSC_VER
#pragma     once
#pragma 	warning( disable :4035 )
#pragma 	warning( disable :4996 )
#pragma 	warning( disable :4514 )
#endif

//	Constands for ComOpen(...)
#define		PARITY__NONE		0x00
#define		PARITY__ODD			0x01
#define		PARITY__EVEN		0x02
#define		PARITY__ZERO		0x03
#define		PARITY__ONE			0x04

#define		STOPBITS_ONE		0x00
#define		STOPBITS_TWO		0x01

#define		DATABITS_SEVEN		0x07
#define		DATABITS_EIGHT		0x08

#define		CTS_ON				0x01
#define		DSR_ON				0x02
#define		RTS_ON				0x04
#define		DTR_ON				0x08

#define 	RS485_OFF			0x00
#define 	RS485_ON			0x40

#define		RTS_HANDSHAKE		0x10
#define		DTR_HANDSHAKE		0x20


#ifdef		__cplusplus
extern		"C" {
#endif

#ifndef		__cplusplus
#ifndef		D
#define 	D(a)
#endif
#else
#ifndef		D
#define 	D(a)	a
#endif
#endif

	int  ComOpen(unsigned uNr,int iBaud D(=9600) ,int iParity D(=PARITY__NONE),int iStopbits D(=STOPBITS_ONE),int iDatabits D(=DATABITS_EIGHT),int iFlags D(=0));
	int  ComChangeMode	   (int iHandle,int iBaud,int iParity D(=-1),int iStopbits D(=-1),int iDatabits D(=-1),int iFlags D(=-1));
	int	 ComGetReadCount   (int iHandle);
	int	 ComGetWriteCount  (int iHandle);
	int	 ComGetState       (int iHandle);
	void ComSetState       (int iHandle,int iBits,int iMask);
	int	 ComWaitUntilResv  (int iHandle,unsigned uTimeout);
	int  ComWaitUntilSend  (int iHandle,unsigned uTimeout D(=2500));
	int  ComReadTimeout    (int iHandle,      void *pBuffer,int iSize,unsigned uTimeout);
	int  ComReadUntil      (int iHandle,      void *pBuffer,int iSize,unsigned uTimeout,unsigned char ucStop);
	int  ComRead           (int iHandle,      void *pBuffer,int iSize);
	int  ComWrite          (int iHandle,const void *pBuffer,int iSize);
	int  ComClose          (int iHandle);
	int	 ComGetByteSendTime(int iHandle);


#ifdef		__cplusplus
}
#endif

#undef		D


#endif
