//*****************************************************************************
//*
//*
//*		EventLibraryUtility.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#ifndef 	__EVENTUTILITY_H__
#define 	__EVENTUTILITY_H__

#ifdef		GLOBAL_CONFIG
#define 	EVENTUTILITIY_H
#include	<GlobalConfig.h>
#undef		EVENTUTILITIY_H
#endif

#ifdef		_MSC_VER
#pragma     once
#pragma 	warning( disable :4035 )
#pragma 	warning( disable :4996 )
#pragma 	warning( disable :4514 )
#endif

#ifdef 		linux
#ifndef		LINUX
#define 	LINUX	1
#endif
#endif


#ifdef	__cplusplus
extern "C" {
#endif

	typedef	void *Event;


	Event		EventOpen        	(int iKey);
	Event		EventOpenRS        	(int iKey);
	Event		EventCreate      	(int iKey);
	Event		EventCreateRS      	(int iKey);
	int			EventClose       	(Event hEvent);
//	void		EventWait        	(Event hEvent);
//	int 		EventWaitTimed  	(Event hEvent,unsigned uWaitTime);
//	void		EventPulse          (Event hEvent);
//	void		EventReset			(Event hEvent);
//	void		EventSet			(Event hEvent);

//******************** LINUX **************************************************
#ifdef	LINUX

	int			EventWaitTimed  	(Event hEvent,unsigned uWaitTime);
	void		EventWait       	(Event hEvent);
	void		EventPulse          (Event hEvent);
	void		EventReset			(Event hEvent);
	void		EventSet			(Event hEvent);

//******************** WINDOWS ************************************************
#elif defined(_WIN32) && !defined(RTTARGET)

	#ifndef _WINDOWS_
	extern	unsigned long	__declspec(dllimport)   __stdcall	WaitForSingleObject(void *,unsigned long);
	extern	int				__declspec(dllimport)   __stdcall	PulseEvent(void *);
	extern	int				__declspec(dllimport)   __stdcall	ResetEvent(void *);
	extern	int				__declspec(dllimport)   __stdcall	SetEvent(void *);
	#endif

	#define		EventWait(h)				WaitForSingleObject(h,0xFFFFFFFF)
	#define		EventWaitTimed(h,t)		  ((WaitForSingleObject(h,t)==0)? 1:0)
	#define		EventPulse(h)				PulseEvent(h)
	#define		EventReset(h)				ResetEvent(h)
	#define		EventSet(h)					SetEvent(h)

//******************** WINDOWS ************************************************
#elif defined(RTTARGET)


	#ifndef	  __THREAD_H__
	#ifndef   __THREAD_C__
	#ifndef	   _CLOCK_H
	extern		unsigned long	__declspec(dllexport)   _cdecl	CLKTicksToMilliSecs(         long);
	extern		long			__declspec(dllexport)   _cdecl	CLKMilliSecsToTicks(unsigned long);
	#endif
	#ifndef    _RTK32_H
	struct		rtkTCBType;
	struct		rtkSemaType;
	extern		void 			__declspec(dllexport)   _cdecl	RTKDelay      (long);
	extern		void 			__declspec(dllexport)   _cdecl	RTKSignal     (struct rtkSemaType*);
	extern		int				__declspec(dllexport)   _cdecl	RTKWaitTimed  (struct rtkSemaType*,long);
	extern		void 			__declspec(dllexport)   _cdecl	RTKWait       (struct rtkSemaType*);
	extern		void 			__declspec(dllexport)   _cdecl	RTKResetEvent (struct rtkSemaType*);
	extern		void 			__declspec(dllexport)   _cdecl	RTKPulse      (struct rtkSemaType*);
	extern		void 			__declspec(dllexport)  *_cdecl	RTKGetUserData(struct rtkTCBType*,int);
	#endif
	#endif
	#endif

	typedef void   *ThreadSemaphore;

	#define		EventWaitTimed(h,t)		    RTKWaitTimed (h,CLKMilliSecsToTicks(t))
	#define		EventWait(h)				RTKWait      (h)
	#define		EventReset(h)				RTKResetEvent(h)
	#define		EventPulse(h)				RTKPulse     (h)
	#define		EventSet(h)					RTKSignal    (h)


//*****************************************************************************
#else

#error wrong OS System

#endif



#ifdef	__cplusplus
}
#endif




#endif



