//*****************************************************************************
//*
//*
//*		LocalAddress.cpp
//*
//*
//*****************************************************************************
#include	<memory.h>
#include 	<string.h>
#include 	<stdlib.h>
#include	<stdio.h>
#include	"LocalAddress.h"



//*****************************************************************************
//*
//*
//*		WINDOWS
//*
//*
//*****************************************************************************
#if defined(_WIN32) || defined(_WIN64)

#pragma		comment(lib,"wsock32.lib")
#include	<winsock2.h>
#include	<windows.h>
#include	<malloc.h>

#ifdef		_MSC_VER
#pragma		warning( disable :4996 )
#endif

#if			defined(_DEBUG) && !defined(NO_DEBUG_NEW) && defined(_MSC_VER)
extern "C"	void*_cdecl	_malloc_dbg(size_t iSize,int iType,const char *pFile,int iLine);
extern "C"	void _cdecl	_free_dbg  (void  *pData,int iType);
#define		malloc(s)	_malloc_dbg (s,1,__FILE__,__LINE__)
#define		free(p)		_free_dbg   (p,1)
#endif

struct in_addr6_
	{
    u_char				s6_addr[16];					// IPv6 address
    };

struct sockaddr_in6_
	{
    short				sin6_family;					// AF_INET6
    u_short				sin6_port;						// Transport level port number
    u_long				sin6_flowinfo;    				// IPv6 flow information
    struct in_addr6_	sin6_addr;						// IPv6 address
	};


typedef struct addrinfo_ex
	{
    int                 ai_flags;						// AI_PASSIVE, AI_CANONNAME, AI_NUMERICHOST
    int                 ai_family;      				// PF_xxx
    int                 ai_socktype;    				// SOCK_xxx
    int                 ai_protocol;    				// 0 or IPPROTO_xxx for IPv4 and IPv6
    size_t              ai_addrlen;     				// Length of ai_addr
    char *              ai_canonname;   				// Canonical name for nodename
    struct sockaddr *   ai_addr;        				// Binary address
    struct addrinfo_ex* ai_next;        				// Next structure in linked list
	}addrinfo_ex_;



#ifndef		MAX_ADAPTER_ADDRESS_LENGTH
#define 	MAX_ADAPTER_ADDRESS_LENGTH      8
#endif
#ifndef 	MAX_DNS_SUFFIX_STRING_LENGTH
#define 	MAX_DNS_SUFFIX_STRING_LENGTH    256
#endif
#ifndef 	MAX_DHCPV6_DUID_LENGTH
#define 	MAX_DHCPV6_DUID_LENGTH          130
#endif
#ifndef 	AF_INET6
#define 	AF_INET6						23
#endif
#ifndef 	AI_NUMERICHOST
#define 	AI_NUMERICHOST					0x04
#endif
#ifndef 	NI_NUMERICHOST
#define 	NI_NUMERICHOST					0x02
#endif
#ifndef 	GAA_FLAG_INCLUDE_PREFIX
#define 	GAA_FLAG_INCLUDE_PREFIX         0x0010
#endif
#ifndef 	IF_TYPE_ETHERNET_CSMACD
#define		IF_TYPE_ETHERNET_CSMACD         6
#endif
#ifndef 	IF_TYPE_SOFTWARE_LOOPBACK
#define 	IF_TYPE_SOFTWARE_LOOPBACK       24
#endif
#ifndef 	IF_TYPE_IEEE80211
#define 	IF_TYPE_IEEE80211               71
#endif


typedef struct sockaddr FAR *LPSOCKADDR_;

typedef struct _SOCKET_ADDRESS_
	{
    LPSOCKADDR_	lpSockaddr;
    INT			iSockaddrLength ;
	}SOCKET_ADDRESS_, *PSOCKET_ADDRESS_, FAR * LPSOCKET_ADDRESS_;

typedef struct _IP_ADAPTER_PREFIX_
	{
	union
		{
		ULONGLONG  Alignment;
		struct
			{
		ULONG Length;
		DWORD Flags;
		};
	};

	struct _IP_ADAPTER_PREFIX_ *Next;
	SOCKET_ADDRESS_            Address;
	ULONG                     PrefixLength;
	} IP_ADAPTER_PREFIX_, *PIP_ADAPTER_PREFIX_;

typedef struct _IP_ADAPTER_UNICAST_ADDRESS_
	{
	union
		{
		struct
			{
		ULONG Length;
		DWORD Flags;
			};
		};
	struct _IP_ADAPTER_UNICAST_ADDRESS_ *Next;
	SOCKET_ADDRESS_                    Address;
	int				                   PrefixOrigin;
	int				                   SuffixOrigin;
	int			                       DadState;
	ULONG                              ValidLifetime;
	ULONG                              PreferredLifetime;
	ULONG                              LeaseLifetime;
	UCHAR                              OnLinkPrefixLength;
	}IP_ADAPTER_UNICAST_ADDRESS_, *PIP_ADAPTER_UNICAST_ADDRESS_;


typedef struct _IP_ADAPTER_ANYCAST_ADDRESS_
	{
	union
		{
	ULONGLONG Alignment;
		struct
			{
		ULONG Length;
		DWORD Flags;
		};
	};
	struct _IP_ADAPTER_ANYCAST_ADDRESS_  *Next;
	SOCKET_ADDRESS_                    Address;
	}IP_ADAPTER_ANYCAST_ADDRESS_, *PIP_ADAPTER_ANYCAST_ADDRESS_;

typedef struct _IP_ADAPTER_MULTICAST_ADDRESS_
	{
	union
		{
		ULONGLONG Alignment;
		struct
			{
		ULONG Length;
		DWORD Flags;
			};
		};
	struct _IP_ADAPTER_MULTICAST_ADDRESS_  *Next;
	SOCKET_ADDRESS_                       Address;
	} IP_ADAPTER_MULTICAST_ADDRESS_, *PIP_ADAPTER_MULTICAST_ADDRESS_;


typedef struct _IP_ADAPTER_DNS_SERVER_ADDRESS_
	{
	union
		{
    ULONGLONG Alignment;
    struct
		{
		ULONG Length;
		DWORD Reserved;
		};
	};

	struct _IP_ADAPTER_DNS_SERVER_ADDRESS_  *Next;
	SOCKET_ADDRESS_                       Address;
	} IP_ADAPTER_DNS_SERVER_ADDRESS_, *PIP_ADAPTER_DNS_SERVER_ADDRESS_;


typedef struct _IP_ADAPTER_GATEWAY_ADDRESS_
	{
	union
		{
		ULONGLONG Alignment;
		struct
			{
		ULONG Length;
		DWORD Reserved;
			};
		};
	struct _IP_ADAPTER_GATEWAY_ADDRESS_ *Next;
	SOCKET_ADDRESS_                     Address;
	} IP_ADAPTER_GATEWAY_ADDRESS_, *PIP_ADAPTER_GATEWAY_ADDRESS_;


typedef struct _IP_ADAPTER_GATEWAY_ADDRESS_LH_
	{
    union
		{
        ULONGLONG Alignment;
        struct
			{
            ULONG Length;
            DWORD Reserved;
			};
		};
    struct _IP_ADAPTER_GATEWAY_ADDRESS_LH_ *Next;
    SOCKET_ADDRESS_ Address;
	} IP_ADAPTER_GATEWAY_ADDRESS_LH_, *PIP_ADAPTER_GATEWAY_ADDRESS_LH_;

typedef struct _IP_ADAPTER_WINS_SERVER_ADDRESS_LH_
	{
    union
		{
        ULONGLONG Alignment;
        struct
			{
            ULONG Length;
            DWORD Reserved;
			};
		};

	struct _IP_ADAPTER_WINS_SERVER_ADDRESS_LH_ *Next;
    SOCKET_ADDRESS_ Address;
	} IP_ADAPTER_WINSSERVER_ADDRESS_LH_, *PIP_ADAPTER_WINSSERVER_ADDRESS_LH_;

typedef struct _IP_ADAPTER_DNS_SUFFIX_
	{
    struct _IP_ADAPTER_DNS_SUFFIX_ *Next;
    WCHAR String[MAX_DNS_SUFFIX_STRING_LENGTH];
	}IP_ADAPTER_DNS_SUFFIX_, *PIP_ADAPTER_DNS_SUFFIX_;

typedef struct _IP_ADAPTER_ADDRESSES_
	{
	union
		{
		ULONGLONG Alignment;
		struct
			{
			ULONG Length;
			DWORD IfIndex;
			};
		};

	struct _IP_ADAPTER_ADDRESSES_     *Next;
	PCHAR                              AdapterName;
	PIP_ADAPTER_UNICAST_ADDRESS_       FirstUnicastAddress;
	PIP_ADAPTER_ANYCAST_ADDRESS_       FirstAnycastAddress;
	PIP_ADAPTER_MULTICAST_ADDRESS_     FirstMulticastAddress;
	PIP_ADAPTER_DNS_SERVER_ADDRESS_    FirstDnsServerAddress;
	PWCHAR                             DnsSuffix;
	PWCHAR                             Description;
	PWCHAR                             FriendlyName;
	BYTE                               PhysicalAddress[MAX_ADAPTER_ADDRESS_LENGTH];
	DWORD                              PhysicalAddressLength;
	DWORD                              Flags;
	DWORD                              Mtu;
	DWORD                              IfType;
	int			                       OperStatus;
	DWORD                              Ipv6IfIndex;
	DWORD                              ZoneIndices[16];
	PIP_ADAPTER_PREFIX_                FirstPrefix;
	ULONG64                            TransmitLinkSpeed;
	ULONG64                            ReceiveLinkSpeed;
	PIP_ADAPTER_WINSSERVER_ADDRESS_LH_ FirstWinsServerAddress;
	PIP_ADAPTER_GATEWAY_ADDRESS_LH_    FirstGatewayAddress;
	ULONG                              Ipv4Metric;
	ULONG                              Ipv6Metric;
	/*IF_*/ LUID                       Luid;
	SOCKET_ADDRESS_                    Dhcpv4Server;
	UINT32				               CompartmentId;
	/*NET_IF_NETWORK_*/ GUID           NetworkGuid;
	int					               ConnectionType;
	int			                       TunnelType;
	SOCKET_ADDRESS_                    Dhcpv6Server;
	BYTE                               Dhcpv6ClientDuid[MAX_DHCPV6_DUID_LENGTH];
	ULONG                              Dhcpv6ClientDuidLength;
	ULONG                              Dhcpv6Iaid;
	PIP_ADAPTER_DNS_SUFFIX_            FirstDnsSuffix;
	}IP_ADAPTER_ADDRESSES_, *PIP_ADAPTER_ADDRESSES_;


typedef int	 (WSAAPI *getaddrinfo_type )(const char *,const char *,const struct addrinfo_ex *,struct addrinfo_ex **);
typedef int  (WSAAPI *getnameinfo_type )(const struct sockaddr*,int,char*,DWORD,char*,DWORD,int);
typedef void (WSAAPI *freeaddrinfo_type)(struct addrinfo_ex *);
typedef ULONG(WSAAPI *getadapaddr_type )(ULONG,ULONG,PVOID,PIP_ADAPTER_ADDRESSES_,PULONG);

static	HMODULE				hDllApi	= 0;
static	HMODULE				hDllWs2	= 0;
static	int					iInit	= 0;
static	int					iInitI	= 0;
static	int					iStart	= 0;
static	getnameinfo_type	pInfo	= 0;
static	getaddrinfo_type	pProc   = 0;
static	freeaddrinfo_type	pFree	= 0;
static	getadapaddr_type	pGetA	= 0;


//*****************************************************************************
//*
//*		freeaddrinfo_ex
//*
//*****************************************************************************
//	Dummy fr freeaddrinfo weil auf Win2000 die Funktion in der DLL fehlt
static void freeaddrinfo_ex(struct addrinfo_ex *pAddrInfo)
{
	if(!pFree)return;
	pFree(pAddrInfo);
}


//*****************************************************************************
//*
//*		getaddrinfo_ex
//*
//*****************************************************************************
//	Dummy fr getaddrinfo weil auf Win2000 die Funktion in der DLL fehlt
static int getaddrinfo_ex(const char *pNodeName,const char *pServname,const struct addrinfo_ex *pHints,struct addrinfo_ex **pResult)
{


	if(!iInit)
		{
		iInit = 1;

		if(!hDllWs2)
			{
			    hDllWs2 = LoadLibrary("ws2_32.dll");
			if(!hDllWs2)return -1;
			}

		if(!pInfo)pInfo = (getnameinfo_type )GetProcAddress(hDllWs2,"getnameinfo" );
		if(!pProc)pProc = (getaddrinfo_type )GetProcAddress(hDllWs2,"getaddrinfo" );
		if(!pFree)pFree = (freeaddrinfo_type)GetProcAddress(hDllWs2,"freeaddrinfo");
		}


	if(!pProc)return -1;


return pProc(pNodeName,pServname,pHints,pResult);
}


//*****************************************************************************
//*
//*		getnameinfo_ex
//*
//*****************************************************************************
//	Dummy fr getaddrinfo weil auf Win2000 die Funktion in der DLL fehlt
static int getnameinfo_ex(const struct sockaddr *pAddr,int iAddrLen,char *pBuffer,unsigned uBuffLen,char *pService,unsigned uServLen,int iFlags)
{


	if(!iInit)
		{
		iInit = 1;

		if(!hDllWs2)
			{
			    hDllWs2 = LoadLibrary("ws2_32.dll");
			if(!hDllWs2)return -1;
			}

		if(!pInfo)pInfo = (getnameinfo_type )GetProcAddress(hDllWs2,"getnameinfo" );
		if(!pProc)pProc = (getaddrinfo_type )GetProcAddress(hDllWs2,"getaddrinfo" );
		if(!pFree)pFree = (freeaddrinfo_type)GetProcAddress(hDllWs2,"freeaddrinfo");
		}


	if(!pInfo)return -1;


return pInfo(pAddr,iAddrLen,pBuffer,uBuffLen,pService,uServLen,iFlags);
}


//*****************************************************************************
//*
//*		IsLocalIp
//*
//*****************************************************************************
//	Prft ob eine Adresse zum lokalen Rechner gehrt
//	pAddress	: Zeiger auf die IP-Adresse oder den einen Hostanmen.
//	Ergibt 1 bei lokalen Adressen ansonsten 0.
LADAPI int IsLocalIp(const char *pAddress)
{
char			cMyAddr[128];
char			cMyName[128];
WORD			wVersion;
WSADATA			sWsaData;
addrinfo_ex	   *pDataM;
addrinfo_ex	   *pDataA;
addrinfo_ex	   *pPtrM;
addrinfo_ex	   *pPtrA;
sockaddr_in6_  *pIp6M;
sockaddr_in6_  *pIp6A;
sockaddr_in    *pIpM;
sockaddr_in    *pIpA;
int				iRet;
int				iPos;


	if(!iStart)
		{
		wVersion = MAKEWORD(2,0);
		iRet	 = WSAStartup(wVersion,&sWsaData);
		iStart	 = 1;
		}

	for(iPos=0;iPos<sizeof(cMyAddr)-1;iPos++)			// Portangaben am Ende entfernen
		{
		if(pAddress[iPos]== 0 )break;
		if(pAddress[iPos]==':')break;

		cMyAddr[iPos] = pAddress[iPos];
		}


	cMyAddr[iPos] = 0;
	cMyName[0]	  = 0;

	gethostname(cMyName,sizeof(cMyName));


	   iRet = getaddrinfo_ex(cMyAddr,0,0,&pDataA);
	if(iRet==0)
		{
		iRet  = getaddrinfo_ex(cMyName,0,0,&pDataM);

		if(iRet==0)
			{
			pPtrA = pDataA;

			while(pPtrA && !iRet)
				{
				pPtrM = pDataM;

				while(pPtrM)
					{
					pIpA  = (sockaddr_in  *)(pPtrA->ai_addr);
					pIpM  = (sockaddr_in  *)(pPtrM->ai_addr);
					pIp6A = (sockaddr_in6_*)(pPtrA->ai_addr);
					pIp6M = (sockaddr_in6_*)(pPtrM->ai_addr);

					if(pIpA->sin_family==AF_INET)
					if(pIpM->sin_family==AF_INET)
					if(!memcmp(&pIpA->sin_addr,&pIpM->sin_addr,4))
						{
						iRet=1;
						break;
						}

					if(pIp6A->sin6_family==AF_INET6)
					if(pIp6M->sin6_family==AF_INET6)
					if(!memcmp(&pIp6A->sin6_addr,&pIp6M->sin6_addr,16))
						{
						iRet=1;
						break;
						}

					pPtrM = pPtrM->ai_next;
					}

				pPtrA = pPtrA->ai_next;
				}

			freeaddrinfo_ex(pDataM);
			}

		if(iRet==0)
			{
			iRet  = getaddrinfo_ex("localhost",0,0,&pDataM);
			}

		if(iRet==0)
			{
			pPtrA = pDataA;

			while(pPtrA && !iRet)
				{
				pPtrM = pDataM;

				while(pPtrM)
					{
					pIpA  = (sockaddr_in  *)(pPtrA->ai_addr);
					pIpM  = (sockaddr_in  *)(pPtrM->ai_addr);
					pIp6A = (sockaddr_in6_*)(pPtrA->ai_addr);
					pIp6M = (sockaddr_in6_*)(pPtrM->ai_addr);

					if(pIpA->sin_family==AF_INET)
					if(pIpM->sin_family==AF_INET)
					if(!memcmp(&pIpA->sin_addr,&pIpM->sin_addr,4))
						{
						iRet=1;
						break;
						}

					if(pIp6A->sin6_family==AF_INET6)
					if(pIp6M->sin6_family==AF_INET6)
					if(!memcmp(&pIp6A->sin6_addr,&pIp6M->sin6_addr,16))
						{
						iRet=1;
						break;
						}

					pPtrM = pPtrM->ai_next;
					}

				pPtrA = pPtrA->ai_next;
				}

			freeaddrinfo_ex(pDataM);
			}

		freeaddrinfo_ex(pDataA);

		if(iRet)return 1;
		}


//******************** Alte Variante ber gethostbyname ***********************
hostent        *pHost;
char		  **pAddresses;
unsigned		uAddrA[16];
unsigned		uVal;
int				i,j;


		pHost=gethostbyname((char*)cMyAddr);
	if(!pHost || pHost->h_addrtype!=AF_INET)return 0;

	pAddresses = pHost->h_addr_list;

	for(i=0;i<16;i++)
		{
		if(!pAddresses[i])
			{
			uAddrA[i]=0;
			break;
			}
		uAddrA[i]= *(unsigned*)(pAddresses[i]);
		}

	   pHost = gethostbyname(cMyName);
	if(pHost && pHost->h_addrtype==AF_INET)
		{
		pAddresses = pHost->h_addr_list;

		for(i=0;i<16;i++)
			{
			if(!pAddresses[i])break;

			uVal = *(unsigned*)(pAddresses[i]);

			for(j=0;j<16;j++)
				{
				if(!uAddrA[j])break;
				if( uAddrA[j]==uVal)return 1;
				}
			}
		}


	   pHost = gethostbyname("localhost");
	if(pHost && pHost->h_addrtype==AF_INET)
		{
		pAddresses = pHost->h_addr_list;

		for(i=0;i<16;i++)
			{
			if(!pAddresses[i])break;

			uVal = *(unsigned*)(pAddresses[i]);

			for(j=0;j<16;j++)
				{
				if(!uAddrA[j])break;
				if( uAddrA[j]==uVal)return 1;
				}
			}
		}




return 0;
}

//*****************************************************************************
//*
//*		GetLocalByAdapter
//*
//*****************************************************************************
//	Holt eine Liste mit den lokalen IP Adressen
//	pBuffer		: Zeiger auf einen Textpuffer
//	iSize  		: Gre des Textpuffers
//	iMode		: 0=Alles  1=Nur IPv4  2=Nur IPv6
//				  Bit8 (0x100) = nur eine Addresse pro Typ und Interface
//				  Bit9 (0x200) = Subnetmasken als Zahl anhngen ("192.168.0.10/24")
//	Ergibt die Anzahl der gefunden Adressen bzw. -1 wenn der Puffer zu klein ist
static int GetLocalByAdapter(char *pBuffer,int iSize,int iMode)
{
char							cName[64];
int								iDoneV6;
int								iDoneV4;
PIP_ADAPTER_UNICAST_ADDRESS_	pAddr;
PIP_ADAPTER_ADDRESSES_			pItem;
PIP_ADAPTER_ADDRESSES_			pList;
DWORD							uFamily;
DWORD							uSize;
DWORD							uRet;
int								iOne;
int								iAll;
int								iCnt;
int								iSub;
int								iBit;
int								iLen;
int								iNum;
int								iOff;



	if(!iInitI)
		{
		iInitI = 1;

		if(!hDllApi)
			{
				hDllApi = LoadLibrary("Iphlpapi.dll");
			if(!hDllApi)return 0;
			}

		if(!pGetA)
			{
			pGetA = (getadapaddr_type)GetProcAddress(hDllApi,"GetAdaptersAddresses");
			}
		}


	if(!pGetA)return 0;

	iOne	= iMode&0x0100;
	iSub	= iMode&0x0200;
	iMode	= iMode&0x00FF;


	uRet = pGetA(AF_UNSPEC,GAA_FLAG_INCLUDE_PREFIX,NULL,NULL,&uSize);

	if(uRet!=ERROR_BUFFER_OVERFLOW)
		{
		return 0;
		}

		pList = (PIP_ADAPTER_ADDRESSES_)malloc(uSize);
	if(!pList)
		{
		return 0;
		}

	uRet  = pGetA(AF_UNSPEC,GAA_FLAG_INCLUDE_PREFIX,NULL,pList,&uSize);

	if(uRet!=ERROR_SUCCESS)
		{
		free(pList);
		return 0;
		}


	iCnt	= 0;
	iLen	= 0;

	for(pItem=pList;pItem;pItem=pItem->Next)			// Alle Interfaces durchlaufen
		{
		pAddr	= pItem->FirstUnicastAddress;
		iDoneV4	= 0;
		iDoneV6	= 0;


		if((pItem->IfType!=IF_TYPE_ETHERNET_CSMACD  ) &&
		   (pItem->IfType!=IF_TYPE_SOFTWARE_LOOPBACK) &&
		   (pItem->IfType!=IF_TYPE_IEEE80211))
			{
			continue;
			}


		for(;pAddr!=NULL;pAddr=pAddr->Next)				// Alle Adressen einer Karte  durchlaufen
			{
			uFamily = pAddr->Address.lpSockaddr->sa_family;

			if(uFamily==AF_INET)
				{
				if(iDoneV4 )continue;
				if(iMode==2)continue;
				iAll = 32;
				}
			else if(uFamily==AF_INET6)
				{
				if(iDoneV6 )continue;
				if(iMode==1)continue;
				iAll = 128;
				}
			else{
				continue;
				}

			if(getnameinfo_ex(pAddr->Address.lpSockaddr,pAddr->Address.iSockaddrLength,cName,sizeof(cName),NULL,0,NI_NUMERICHOST))
				{
				continue;
				}

			iNum = (int)strlen(cName)+1;
			iBit = 0;

			if(iLen+iNum+4<iSize)						// Adresse an die Liste anhngen
				{
				for(iOff=iNum;iOff>0;)
					{
					iOff--;
					if(cName[iOff]!='%')continue;
					cName[iOff] = 0;					// Entferne "..%6" Tag
					iNum = iOff+1;
					break;
					}

				memcpy(pBuffer+iLen,cName,iNum);
				iLen += iNum;

				if(iSub && pAddr->OnLinkPrefixLength>0 && pAddr->OnLinkPrefixLength<iAll)
					{
					iLen += sprintf(pBuffer+iLen-1,"/%i",pAddr->OnLinkPrefixLength);
					}

				iCnt += 1;
				}

			if(uFamily==AF_INET)						// Nur eine IP pro Karte
					iDoneV4=iOne;
			else	iDoneV6=iOne;
			}
		}

	free(pList);


return iCnt;
}


//*****************************************************************************
//*
//*		IpToBin
//*
//*****************************************************************************
//	Wandelt eine IP-Addresse in einen binren Bereich um
//	pAddress		: Ist die Adresse als Text
//	pBinData		: Hier wird der Bereich gespeichert
//	Ergibt die Lnge in Byte oder 0 bei einem Fehler
static int IpToBin(const char *pAddress,void *pBinData)
{
struct sockaddr_in *pIp;
struct addrinfo_ex *pPtr;
struct addrinfo_ex *pData;
struct addrinfo_ex  sInfo;
char				cMyAddr[128];
char				cIsIpV6;
char				cStop;
unsigned			uAddr;
int					iEnd;
int					iPos;
int					iCnt;
int					iRet;



	memset(pBinData,0,16);


	if(pAddress[0]=='[' )								// IPV6 Adresse im Format "[....]"
		{
		pAddress++;
		cStop = 0;
		}
	else{
		cStop = ':';
		}

	cIsIpV6	=  0;
	iCnt	=  0;
	iEnd	= -1;

	for(iPos=0;iPos<sizeof(cMyAddr)-1;iPos++)			// Port- und Subnetzangaben am Ende entfernen
		{
		if(pAddress[iPos]==':')cIsIpV6=1;
		if(pAddress[iPos]== 0 )break;
		if(pAddress[iPos]=='/')break;
		if(pAddress[iPos]=='%')break;
		if(pAddress[iPos]==']')break;
		if(pAddress[iPos]==cStop)
			{
			iEnd  = iPos;
			iCnt += 1;
			}

		cMyAddr[iPos] = pAddress[iPos];
		}


	if(iEnd>0 && iCnt==1)								// Nur ein einzelner ':'
		{
		iPos = iEnd;
		}

	cMyAddr[iPos] = 0;


	if(cIsIpV6)											// IPV6-Adresse
		{
		memset(&sInfo,0,sizeof(sInfo));
        sInfo.ai_flags |= AI_NUMERICHOST;
        sInfo.ai_family = AF_INET6;

           iRet = getaddrinfo_ex(cMyAddr,0,&sInfo,&pData);
        if(iRet!=0)return 0;

		pPtr = pData;

        while(pPtr)
            {
            pIp = (struct sockaddr_in*)(pPtr->ai_addr);

            if(pIp->sin_family==AF_INET6)
                {
                struct sockaddr_in6_ *pIp6=(struct sockaddr_in6_*)pIp;
                memcpy(pBinData,pIp6->sin6_addr.s6_addr,16);
                iRet = 16;
				break;
                }
            }


        freeaddrinfo_ex(pData);

        return iRet;
		}


       uAddr = inet_addr(cMyAddr);						// IPV4-Adresse
	if(uAddr==INADDR_NONE)return 0;


	*(unsigned*)pBinData = uAddr;


return 4;
}


//*****************************************************************************
//*
//*		GetLocalIp
//*
//*****************************************************************************
//	Holt eine Liste mit den lokalen IP Adressen
//	pBuffer		: Zeiger auf einen Textpuffer
//	iSize  		: Gre des Textpuffers
//	iMode		: 0=Allses  1=Nur IPv4  2=Nur IPv6
//				  Bit8 (0x100) = nur eine Addresse pro Typ und Interface
//				  Bit9 (0x200) = Subnetmasken als Zahl anhngen ("192.168.0.10/24")
//	Ergibt die Anzahl der gefunden Adressen bzw. -1 wenn der Puffer zu klein ist
LADAPI int GetLocalIp(char *pBuffer,int iSize,int iMode)
{
char			cMyName[128];
WORD			wVersion;
WSADATA			sWsaData;
addrinfo_ex	   *pDataM;
addrinfo_ex	   *pPtrM;
sockaddr_in6_  *pIp6M;
sockaddr_in    *pIpM;
unsigned char  *pPtr;
int				iRet;
int				iLen;
int				iCnt;



	if(iSize<20)										// Ist der Puffer zu klein
		{
		if(iSize>=1)pBuffer[0]=0;
		if(iSize>=2)pBuffer[1]=0;
		return -1;
		}

	iSize--;


	if(!iStart)
		{
		wVersion = MAKEWORD(2,0);
		iRet	 = WSAStartup(wVersion,&sWsaData);
		iStart	 = 1;
		}


	   iCnt = GetLocalByAdapter(pBuffer,iSize,iMode);
	if(iCnt)
		{
		return iCnt;
		}

	cMyName[0]	 = 0;
	iLen		 = 0;
	iCnt		 = 0;
	iMode		 = iMode&0x00FF;

	gethostname(cMyName,sizeof(cMyName));


	   iRet = getaddrinfo_ex(cMyName,0,0,&pDataM);
	if(iRet==0)
		{
		pPtrM = pDataM;

		while(pPtrM)
			{
			pIpM  = (sockaddr_in  *)(pPtrM->ai_addr);
			pIp6M = (sockaddr_in6_*)(pPtrM->ai_addr);

			if(pIpM->sin_family==AF_INET)
			if(iMode==0 || iMode==1)
				{
				if(iLen+24>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIpM->sin_addr;
				iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
				iLen += 1;
				iCnt += 1;
				}

			if(pIp6M->sin6_family==AF_INET6)
			if(iMode==0 || iMode==2)
				{
				if(iLen+44>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIp6M->sin6_addr;
				iLen += sprintf(pBuffer+iLen,"%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X",
							pPtr[ 0],pPtr[ 1],pPtr[ 2],pPtr[ 3],
							pPtr[ 4],pPtr[ 5],pPtr[ 6],pPtr[ 7],
							pPtr[ 8],pPtr[ 9],pPtr[10],pPtr[11],
							pPtr[12],pPtr[13],pPtr[14],pPtr[15]);

				iLen += 1;
				iCnt += 1;
				}

			pPtrM = pPtrM->ai_next;
			}

		freeaddrinfo_ex(pDataM);
		}



	   iRet = getaddrinfo_ex("localhost",0,0,&pDataM);
	if(iRet==0)
		{
		pPtrM = pDataM;

		while(pPtrM)
			{
			pIpM  = (sockaddr_in  *)(pPtrM->ai_addr);
			pIp6M = (sockaddr_in6_*)(pPtrM->ai_addr);

			if(pIpM->sin_family==AF_INET)
			if(iMode==0 || iMode==1)
				{
				if(iLen+24>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIpM->sin_addr;
				iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
				iLen += 1;
				iCnt += 1;
				}

			if(pIp6M->sin6_family==AF_INET6)
			if(iMode==0 || iMode==2)
				{
				if(iLen+48>=iSize)
					{
					freeaddrinfo_ex(pDataM);
					pBuffer[0]=0;
					pBuffer[1]=0;
					return -1;
					}

				pPtr  = (unsigned char*)&pIp6M->sin6_addr;
				iLen += sprintf(pBuffer+iLen,"%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X:%02X%02X",
							pPtr[ 0],pPtr[ 1],pPtr[ 2],pPtr[ 3],
							pPtr[ 4],pPtr[ 5],pPtr[ 6],pPtr[ 7],
							pPtr[ 8],pPtr[ 9],pPtr[10],pPtr[11],
							pPtr[12],pPtr[13],pPtr[14],pPtr[15]);
				iLen += 1;
				iCnt += 1;
				}

			pPtrM = pPtrM->ai_next;
			}

		freeaddrinfo_ex(pDataM);
		}




	if(iCnt>0)
		{
		pBuffer[iLen]=0;
		return iCnt;
		}


//******************** Alte Variante ber gethostbyname ***********************
hostent        *pHost;
char		  **pAddresses;
int				i;



	if(iMode && iMode!=1)
		{
		pBuffer[0]=0;
		pBuffer[1]=0;
		return 0;
		}


	   pHost = gethostbyname(cMyName);
	if(pHost && pHost->h_addrtype==AF_INET)
		{
		pAddresses = pHost->h_addr_list;

		for(i=0;i<16;i++)
			{
			if(!pAddresses[i])break;

			if(iLen+20>=iSize)
				{
				pBuffer[0]=0;
				pBuffer[1]=0;
				return -1;
				}

			pPtr  = (unsigned char *)pAddresses[i];
			iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
			iLen += 1;
			iCnt += 1;
			}
		}


	   pHost = gethostbyname("localhost");
	if(pHost && pHost->h_addrtype==AF_INET)
		{
		pAddresses = pHost->h_addr_list;

		for(i=0;i<16;i++)
			{
			if(!pAddresses[i])break;

			if(iLen+20>=iSize)
				{
				pBuffer[0]=0;
				pBuffer[1]=0;
				return -1;
				}

			pPtr  = (unsigned char *)pAddresses[i];
			iLen += sprintf(pBuffer+iLen,"%i.%i.%i.%i",pPtr[0],pPtr[1],pPtr[2],pPtr[3]);
			iLen += 1;
			iCnt += 1;
			}
		}



	pBuffer[iLen]=0;



return iCnt;
}



#endif

//*****************************************************************************
//*
//*
//*		LINUX
//*
//*
//*****************************************************************************
#ifdef	linux

#include	<unistd.h>
#include	<sys/socket.h>
#include 	<sys/types.h>
#include 	<netinet/in.h>
#include 	<arpa/inet.h>
#include	<ifaddrs.h>
#include	<netdb.h>

#define		MAX_INTERFACES		16


//*****************************************************************************
//*
//*		IpToBin
//*
//*****************************************************************************
//	Wandelt eine IP-Addresse in einen binren Bereich um
//	pAddress		: Ist die Adresse als Text
//	pBinData		: Hier wird der Bereich gespeichert
//	Ergibt die Lnge in Byte oder 0 bei einem Fehler
static int IpToBin(const char *pAddress,void *pBinData)
{
struct sockaddr_in *pIp;
struct addrinfo    *pPtr;
struct addrinfo    *pData;
struct addrinfo     sInfo;
char				cMyAddr[128];
char				cIsIpV6;
char				cStop;
unsigned			uAddr;
int					iEnd;
int					iPos;
int					iCnt;
int					iRet;



	memset(pBinData,0,16);


	if(pAddress[0]=='[' )								// IPV6 Adresse im Format "[....]"
		{
		pAddress++;
		cStop = 0;
		}
	else{
		cStop = ':';
		}

	cIsIpV6	=  0;
	iCnt	=  0;
	iEnd	= -1;

	for(iPos=0;iPos<sizeof(cMyAddr)-1;iPos++)			// Port- und Subnetzangaben am Ende entfernen
		{
		if(pAddress[iPos]==':')cIsIpV6=1;
		if(pAddress[iPos]== 0 )break;
		if(pAddress[iPos]=='/')break;
		if(pAddress[iPos]=='%')break;
		if(pAddress[iPos]==']')break;
		if(pAddress[iPos]==cStop)
			{
			iEnd  = iPos;
			iCnt += 1;
			}

		cMyAddr[iPos] = pAddress[iPos];
		}


	if(iEnd>0 && iCnt==1)								// Nur ein einzelner ':'
		{
		iPos = iEnd;
		}

	cMyAddr[iPos] = 0;


	if(cIsIpV6)											// IPV6-Adresse
		{
		memset(&sInfo,0,sizeof(sInfo));
        sInfo.ai_flags |= AI_NUMERICHOST;
        sInfo.ai_family = AF_INET6;

           iRet = getaddrinfo(cMyAddr,0,&sInfo,&pData);
        if(iRet!=0)return 0;

		pPtr = pData;

        while(pPtr)
            {
            pIp = (struct sockaddr_in*)(pPtr->ai_addr);

            if(pIp->sin_family==AF_INET6)
                {
                struct sockaddr_in6 *pIp6=(struct sockaddr_in6*)pIp;
                memcpy(pBinData,pIp6->sin6_addr.s6_addr,16);
                iRet = 16;
				break;
                }
            }


        freeaddrinfo(pData);

        return iRet;
		}


       uAddr = inet_addr(cMyAddr);						// IPV4-Adresse
	if(uAddr==INADDR_NONE)return 0;


	*(unsigned*)pBinData = uAddr;


return 4;
}

//*****************************************************************************
//*
//*		GetSubNetCount
//*
//*****************************************************************************
//	Zhlt die High-Bits in einer Sub-Net-Maske
//	pPtr		: Zeiger auf die Sub-Net-Maske
//	iMax		: Anzahl der Bits
//	Ergibt die Bits
static int GetSubNetCount(const void *pPtr,int iMax)
{
unsigned char  *pByte=(unsigned char*)pPtr;
unsigned char 	ucBit;
int				iPos;


	ucBit	 = 0x80;

	for(iPos=0;iPos<iMax;iPos++)
		{
		if(!(*pByte&ucBit))break;

			ucBit >>= 1;
		if(!ucBit)
			{
			ucBit  = 0x80;
			pByte += 1;
			}
		}


return iPos;
}

//*****************************************************************************
//*
//*		IsLocalIp
//*
//*****************************************************************************
//	Prft ob eine Adresse zum lokalen Rechner gehrt
//	pAddress	: Zeiger auf die IP-Adresse oder den einen Hostanmen.
//	Ergibt 1 bei lokalen Adressen ansonsten 0.
LADAPI int IsLocalIp(const char *pAddress)
{
char					cMyAddr[128];
struct ifaddrs		   *pList;
struct ifaddrs		   *pItem;
struct addrinfo			sInfo;
struct addrinfo	  	   *pData;
struct addrinfo	  	   *pPtr;
struct sockaddr_in	   *pIp4;
struct sockaddr_in6	   *pIp6;
struct sockaddr_in	   *pCmp4;
struct sockaddr_in6	   *pCmp6;
char 					cStop;
int						iFamily;
int 					iMode;
int						iRet;
int						iPos;




	if(pAddress[0]=='[' )								// IPV6 Adresse im Format "[....]"
		{
		pAddress++;
		cStop = ']';
		}
	else{
		cStop = ':';
		}

	iMode = 0;

	for(iPos=0;iPos<sizeof(cMyAddr)-1;iPos++)			// Portangaben am Ende entfernen
		{
		if(pAddress[iPos]== 0   )break;
		if(pAddress[iPos]==cStop)break;

		cMyAddr[iPos] = pAddress[iPos];

		     if(cMyAddr[iPos]=='.'                      )iMode|=0x01;
		else if(cMyAddr[iPos]==':'                      )iMode|=0x02;
		else if(cMyAddr[iPos]>='0' && cMyAddr[iPos]<='9')iMode|=0x04;
		else if(cMyAddr[iPos]>='A' && cMyAddr[iPos]<='F')iMode|=0x08;
		else if(cMyAddr[iPos]>='a' && cMyAddr[iPos]<='f')iMode|=0x08;
		else                                             iMode|=0x10;
		}

	cMyAddr[iPos] = 0;


	memset(&sInfo,0,sizeof(sInfo));
	pData = 0;

	if((iMode&0x15)==0x05)								// Ist es eine numerische Adresse
		{
		sInfo.ai_flags |= AI_NUMERICHOST;
		sInfo.ai_family = AF_INET;
		}
	else if((iMode&0x12)==2 && (iMode&0x0C))
		{
		sInfo.ai_flags |= AI_NUMERICHOST;
		sInfo.ai_family = AF_INET6;
		}


	   iRet = getaddrinfo(cMyAddr,0,&sInfo,&pData);
	if(iRet!=0)
		{
		return 0;
		}


	if(getifaddrs(&pList)==-1)
		{
		freeaddrinfo(pData);
		return 0;
		}

	iRet = 0;

	for(pPtr=pData;pPtr;pPtr=pPtr->ai_next)				// Alle Adressen durchlaufen
		{
			pIp4 = (struct sockaddr_in*)(pPtr->ai_addr);
		if(!pIp4)continue;

		if(pIp4->sin_family==AF_INET)
			{
			for(pItem=pList;pItem;pItem=pItem->ifa_next)
				{
				if(!pItem->ifa_addr)continue;
				   iFamily = pItem->ifa_addr->sa_family;
				if(iFamily!=AF_INET)continue;

				pCmp4 = (struct sockaddr_in*)(pItem->ifa_addr);

				if(!memcmp(&pCmp4->sin_addr,&pIp4->sin_addr,4))
					{
					iRet=1;
					goto Done;
					}
				}

			continue;
			}

		if(pIp4->sin_family==AF_INET6)
			{
			pIp6 = (struct sockaddr_in6*)(pPtr->ai_addr);

			for(pItem=pList;pItem;pItem=pItem->ifa_next)
				{
				if(!pItem->ifa_addr)continue;
				   iFamily = pItem->ifa_addr->sa_family;
				if(iFamily!=AF_INET6)continue;

				pCmp6 = (struct sockaddr_in6*)(pItem->ifa_addr);

				if(!memcmp(&pCmp6->sin6_addr,&pIp6->sin6_addr,16))
					{
					iRet=1;
					goto Done;
					}
				}

			continue;
			}
		}

Done:

	freeaddrinfo(pData);
	freeifaddrs(pList);


return iRet;
}


//*****************************************************************************
//*
//*		GetLocalIp
//*
//*****************************************************************************
//	Holt eine Liste mit den lokalen IP Adressen
//	pBuffer		: Zeiger auf einen Textpuffer
//	iSize  		: Gre des Textpuffers
//	iMode		: 0=Allses  1=Nur IPv4  2=Nur IPv6
//				  Bit8 (0x100) = nur eine Addresse pro Typ und Interface
//				  Bit9 (0x200) = Subnetmasken als Zahl anhngen ("192.168.0.10/24")
//	Ergibt die Anzahl der gefunden Adressen bzw. -1 wenn der Puffer zu klein ist
LADAPI int GetLocalIp(char *pBuffer,int iSize,int iMode)
{
char 				cName[64];
const char 		   *pDone4[MAX_INTERFACES];
const char 		   *pDone6[MAX_INTERFACES];
struct ifaddrs	   *pList;
struct ifaddrs	   *pItem;
int 				iFamily;
int 				iDone6;
int 				iDone4;
int 				iOff;
int 				iOne;
int 				iSub;
int 				iCnt;
int 				iLen;
int 				iNum;




	iDone6	= 0;
	iDone4	= 0;
	iCnt	= 0;
	iLen	= 0;
	iSub	= iMode&0x0200;
	iOne	= iMode&0x0100;
	iMode	= iMode&0x00FF;


	if(getifaddrs(&pList)==-1)
		{
		return 0;
		}


	for(pItem=pList;pItem;pItem=pItem->ifa_next)
		{
        if(!pItem->ifa_addr)continue;


		iFamily = pItem->ifa_addr->sa_family;

		switch(iFamily)
			{
		case AF_INET:	if(iMode==2)continue;			// IPV4 Adresee

						if(getnameinfo(pItem->ifa_addr,sizeof(struct sockaddr_in),cName,sizeof(cName),0,0,NI_NUMERICHOST))
							{
							continue;
							}

						if(!iOne)break;

						for(iNum=0;iNum<iDone4;iNum++)
							{
							if(!strcmp(pItem->ifa_name,pDone4[iNum]))
								{
								goto Next;
								}
							}

						if(iDone4<MAX_INTERFACES)
							{
							pDone4[iDone4] = pItem->ifa_name;
							iDone4++;
							}

						break;

		case AF_INET6:	if(iMode==1)continue;			// IPV6 Adresee

						if(getnameinfo(pItem->ifa_addr,sizeof(struct sockaddr_in6),cName,sizeof(cName),0,0,NI_NUMERICHOST))
							{
							continue;
							}

						if(!iOne)break;

						for(iNum=0;iNum<iDone6;iNum++)
							{
							if(!strcmp(pItem->ifa_name,pDone6[iNum]))
								{
								goto Next;
								}
							}

						if(iDone6<MAX_INTERFACES)
							{
							pDone6[iDone6] = pItem->ifa_name;
							iDone6++;
							}

						break;

		default:		continue;
			}


		iNum = strlen(cName)+1;

		if(iLen+iNum<iSize)								// Adresse an die Liste anhngen
			{
			for(iOff=iNum;iOff>0;)
				{
				iOff--;
				if(cName[iOff]!='%')continue;
				cName[iOff] = 0;						// Entferne "..%eth" Tag
				iNum = iOff+1;
				break;
				}

			memcpy(pBuffer+iLen,cName,iNum);

			iLen += iNum;
			iCnt += 1;

			if(iSub)									// Subnetz anhngen
				{
				if(iFamily==AF_INET6)
					{
					   iNum  = GetSubNetCount(&((struct sockaddr_in6*)pItem)->sin6_addr.s6_addr+6,128);
					if(iNum>=128)iNum=0;
					}
				else{
					   iNum = GetSubNetCount(&((struct sockaddr_in*)pItem)->sin_addr.s_addr+2,32);
					if(iNum>=32)iNum=0;
					}

				if(iNum)
					{
					iLen += sprintf(pBuffer+iLen-1,"/%i",iNum);
					}
				}


			}

Next:	continue;
		}



	freeifaddrs(pList);




return iCnt;
}



#endif




//*****************************************************************************
//*
//*
//*		Allgemeine Funktionen
//*
//*
//*****************************************************************************




//*****************************************************************************
//*
//*		IsLocalSubNet
//*
//*****************************************************************************
//	Prft ob eine Adresse zum lokalen SubNetz des Rechners gehrt
//	pAddress	: Zeiger auf die IP-Adresse oder den einen Hostanmen.
//	pOutput		: Hier wird die lokale IP dazu gespeichert
//	Ergibt die Bits des Subnetzes oder 0 wenn die Adresse nicht im Subnetz ist.
LADAPI int IsLocalSubNet(const char *pAddress,char *pOutput)
{
char				cBuffer[2048];
unsigned			aAddr[4];
unsigned			aList[4];
unsigned			aMask[4];
char			   *pName;
int					iSub;
int					iCmp;
int					iNum;
int					iPos;
int					iLen;



	if(pOutput)*pOutput=0;

	iLen	= IpToBin(pAddress,aAddr);
	iNum	= GetLocalIp(cBuffer,sizeof(cBuffer),(iLen!=4)? 0x0202:0x0201);


	if(!iLen)return 0;


	for(iPos=0;iNum>0;iNum--)
		{
		   iCmp	= IpToBin(cBuffer+iPos,aList);
		if(iCmp==iLen)
			{
			pName = cBuffer+iPos;

			for(;cBuffer[iPos];iPos++)
				{
				if(cBuffer[iPos]!='/')continue;

				iPos++;
				iSub = atoi(cBuffer+iPos);

				if(iSub<=0 && iSub>=iLen*4)break;

				aMask[0] = (iSub>=32*1)? 0xFFFFFFFF:0x00000000;
				aMask[1] = (iSub>=32*2)? 0xFFFFFFFF:0x00000000;
				aMask[2] = (iSub>=32*3)? 0xFFFFFFFF:0x00000000;
				aMask[3] = (iSub>=32*4)? 0xFFFFFFFF:0x00000000;

				aMask[iSub/32] = htonl(~(0xFFFFFFFF>>(iSub&0x1F)));

				for(iCmp=0;;iCmp++)
					{
					if(iCmp>=iLen/4)
						{
						if(pOutput)strcpy(pOutput,pName);
						return iSub;
						}

					if((aAddr[iCmp]^aList[iCmp])&aMask[iCmp])break;
					}

				break;
				}
			}

		while(cBuffer[iPos])iPos++;
		iPos++;
		}





return 0;
}

