//*****************************************************************************
//*
//*
//*		WatchdogUtility.h
//*
//*
//*****************************************************************************
//
//	This file contains functions for watchdog
//
#ifndef   __WATCHDOGUTILITY_H__
#define   __WATCHDOGUTILITY_H__

#ifdef		GLOBAL_CONFIG
#define 	WATCHDOGUTILITY_H
#include	<GlobalConfig.h>
#undef		WATCHDOGUTILITY_H
#endif

typedef		unsigned long*	WatchdogHandle;


#ifdef WATCHDOG_EMU

	static inline void				WatchdogExit      (){};
	static inline void				WatchdogReset     (){};
	static inline int 				WatchdogRunning   (){return 1;}
	static inline void				WatchdogInit      (unsigned uTime){};
	static inline WatchdogHandle	WatchdogRegister  (unsigned uUpdateMaxTime,const char *pName=0){return (WatchdogHandle)1;}
	static inline void				WatchdogChangeTime(WatchdogHandle hWatchdog,unsigned uUpdateMaxTime,unsigned char *pNewName=0){};
	static inline void				WatchdogUnregister(WatchdogHandle hWatchdog){};
	static inline void				WatchdogTrigger   (WatchdogHandle hWatchdog){};

#else

	void							WatchdogExit	  ();
	void							WatchdogReset	  ();
	int								WatchdogRunning	  ();
	void							WatchdogInit	  (unsigned uTime);
	WatchdogHandle					WatchdogRegister  (unsigned uUpdateMaxTime,const char *pName=0);
	void							WatchdogChangeTime(WatchdogHandle hWatchdog,unsigned uUpdateMaxTime,const char *pNewName=0);
	void							WatchdogUnregister(WatchdogHandle hWatchdog);
	static inline void 				WatchdogTrigger   (WatchdogHandle hWatchdog)
											{
											if(hWatchdog)
												{
												#ifdef WATCHDOG_NULL
												hWatchdog[0]=0;
												#else
												hWatchdog[0]++;
												#endif
												}
											}

#endif


#endif
