//*****************************************************************************
//*
//*
//*		TaskbarTools.h
//*
//*
//*****************************************************************************
//
//	Funktionen fr die Steuerung der Taskbar
//
//		BOOL	TaskbarHide(HWND hWnd)		Taste in der Taskbar verstecken
//		BOOL	TaskbarShow(HWND hWnd)		Taste in der Taskbar anzeigen
//
//	Nachrichten Verarbeitung:
//
//		ON_MESSAGE(TB_NOTIFYICON, OnProc)
//
//		LRESULT OnProc(WPARAM wParam,LPARAM lParam)		// lParam ist die ID
//			{
//			switch(lParam)
//				{
//			case WM_LBUTTONDOWN:
//			case WM_RBUTTONDOWN:
//				}
//
//			return 0;
//			}

#ifndef 	__TASKBARTOOLS_H__
#define 	__TASKBARTOOLS_H__


#define 	TB_NOTIFYICON		0x2F19			// ID fr Notify Nachricht
#define 	TB_NOPROGRESS		0x0000			// Progress-Bar abschalten
#define 	TB_TICKER			0x0001			// Progress-Bar in den Ticker-Modus umschalten
#define 	TB_NORMAL			0x0002			// Normale Farbe fr Progress-Bar 
#define 	TB_ERROR			0x0004			// Rote    Farbe fr Progress-Bar 
#define 	TB_PAUSED			0x0008			// Gelbe   Farbe fr Progress-Bar 


		BOOL		 TaskbarInit();
		void __cdecl TaskbarExit(void);

		BOOL TaskbarHide    (HWND hWnd);
		BOOL TaskbarShow    (HWND hWnd);
		BOOL TaskbarSetState(HWND hWnd,DWORD   dwFlags);
		BOOL TaskbarProgress(HWND hWnd,LONGLONG iNow,LONGLONG iMax,LONGLONG iMin=0);

		BOOL TaskbarIconSet (HWND hWnd,HICON   hIcon,LPCTSTR pText=0,LPARAM uId=0);
		BOOL TaskbarIconSet (HWND hWnd,LPCTSTR pIcon,LPCTSTR pText=0,LPARAM uId=0);
inline	BOOL TaskbarIconSet (HWND hWnd,UINT    uIcon,LPCTSTR pText=0,LPARAM uId=0){return TaskbarIconSet(hWnd,MAKEINTRESOURCE(uIcon),pText,uId);}

		BOOL TaskbarIconAdd (HWND hWnd,HICON   hIcon,LPCTSTR pText=0,LPARAM uId=0);
		BOOL TaskbarIconAdd (HWND hWnd,LPCTSTR pIcon,LPCTSTR pText=0,LPARAM uId=0);
inline	BOOL TaskbarIconAdd (HWND hWnd,UINT    uIcon,LPCTSTR pText=0,LPARAM uId=0){return TaskbarIconAdd(hWnd,MAKEINTRESOURCE(uIcon),pText,uId);}

		BOOL TaskbarIconDel (HWND hWnd,						 	     LPARAM uId=0);


#endif
