//*****************************************************************************
//*
//*
//*		TextBuffer.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//

#ifndef __TEXTBUFFER_H__
#define __TEXTBUFFER_H__


#if _MSC_VER >= 1000
#pragma once
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if		_MSC_VER > 1299
	#ifndef		WINVER 
	#define		WINVER 	0x0501 
	#endif 	
	#endif 	
	#include	<Afx.h>
	#include	<AfxWin.h>
#else
	#include	<Windows.h>
#endif

#ifdef	_MSC_VER
	#pragma warning( disable :4996 )
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER 
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif 	
#endif 	



#ifdef 		 LINUX
#define 	 _cdecl
#define 	__cdecl
#endif

#ifdef		zchar
#undef 		zchar
#endif 	

#ifdef		UNICODE												
#define 	zchar		wchar_t
#else 		
#define 	zchar		char 
#endif 	


#include	<stdio.h>
#include	<string.h>
#include	"FileBuffer.h"



//*****************************************************************************
//*
//*     Klasse CTextBuffer
//*
//*****************************************************************************
class CTextBuffer : public CFileBuffer
{

public:

	CTextBuffer(const wchar_t *pName,int iBufferLen=CFB_BUFFER_SIZE);
	CTextBuffer(const char    *pName,int iBufferLen=CFB_BUFFER_SIZE);
	CTextBuffer(                     int iBufferLen=CFB_BUFFER_SIZE);
   ~CTextBuffer();
	

	int		Text         (int iAdd =0,zchar**pMem=0,int iMin=0);	// Textvorschub
	int		TextValueLen (int iHex =0   ,int iMax=0x1000000);		// Zahlenlnge
	int		TextLineLen  (int iMode=0   ,int iMax=0x1000000);		// Zeilenlnge
	int		TextCharLen  (		         int iMax=0x1000000);		// Zeichenlnge
	int		TextWordLen  (               int iMax=0x1000000);		// Wortlnge
	int		TextWordLenEx(int   iCrypt=0,int iMax=0x1000000);		// Wortlnge
	int		TextLine     (zchar **pMem=0,int iMin=0,int *pCount=0,int iAdd=-1);
	int		TextLine     (zchar  *pMem  ,int iMax  ,int *pCount=0,int iAdd= 0);
	int		TextString   (zchar  *pMem  ,int iMax,zchar cFrom  ,zchar cTo=0,int *pCount=0);
	int		TextString   (zchar  *pMem  ,int iMax,int *pCount=0,int iCrypt=0);
	int		TextStringLen(int   iCrypt=0,int iMax=0x1000000);
	int		TextValue    (zchar  *pMem  ,int iMax,int *pCount=0,int iHex=0);
	int		TextWordEx   (zchar  *pMem  ,int iMax,int *pCount=0,int iCrypt=0);
	int		TextWord     (zchar  *pMem  ,int iMax,int *pCount=0);
	int		TextChar     (zchar  *pMem  ,int iMax,int *pCount=0);
	int		TextChar     (zchar  *pMem);							// Zeichen holen
	int		TextUpper    (int    iLen=0xFFFFF);						// Zeichen gro  schreiben
	int		TextLower    (int    iLen=0xFFFFF);						// Zeichen klein schreiben
	int		TextEmpty    (int    iMode=0);							// Leerzeichen berspringen


	static CTextBuffer *Convert(CFileBuffer *pPtr);
	static CTextBuffer *Convert(CFileBuffer &sClass);

};

#ifndef _DEBUG
inline CTextBuffer *CTextBuffer::Convert(CFileBuffer *pPtr  ){return (CTextBuffer*) pPtr  ;}
inline CTextBuffer *CTextBuffer::Convert(CFileBuffer &sClass){return (CTextBuffer*)&sClass;}
#endif 	

#endif
