//*****************************************************************************
//*
//*
//*		Allgemeine	Message Funktionen fr CTextView und CTextWnd
//*
//*
//*****************************************************************************
#ifndef		__TEXTMESSAGE__H__
#define 	__TEXTMESSAGE__H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"AnsiMessage.h"

#define		FLAG_VIRTUAL_SCREEN		0x00000001			// Cursor kann berall stehen
#define		FLAG_LINE_MARK		 	0x00000002			// Zeilenweise Markieren
#define		FLAG_INSERT_BEFOR	 	0x00000004			// Hinter Cursor einfgen
#define		FLAG_BRACKET      	 	0x00000008			// Nach Klammern suchen
#define		FLAG_FIND_CASE		 	0x00000010			// Gro/Kleinschreibung ignorieren
#define		FLAG_FIND_UPWARDS       0x00000020			// Abwrts suchen
#define		FLAG_FIND_ALL    		0x00000040			// Die gesammte Datei durchsuchen
#define		FLAG_FIND_WORD     		0x00000080			// Ganze Wrter suchen
#define		FLAG_FIND_EXPRESSION 	0x00000100			// Nach Ausdrcken mit * und ? suchen
#define		FLAG_MARK_TO_END	 	0x00000200			// Bis zum Zeilenende markieren
#define		FLAG_LINENUMBERS	 	0x00000400			// Zeilennummern anzeigen
#define		FLAG_BRACKET_MODE	 	0x00000800			// Klammern bereichsweise markieren
#define		FLAG_WORD_JMP_MISC		0x00001000			// Auch diversen Zeichen anhalten.
#define		FLAG_WORD_JMP_FIRST		0x00002000			// Nur am Beginn eines Wortes/Bereichs anhalten.
#define		FLAG_WORD_JMP_UPPER		0x00004000			// Auch Gro/Kleinbergngen anhalten.
#define		FLAG_WORD_JMP_UNTER		0x00008000			// Das '_' nicht als Buchstaben betrachten.
#define 	FLAG_CHANGE_SELECTION 	0x00010000			// Was ndern (Gesamter Text/Auswahl)
#define 	FLAG_FIND_HIGHLIGHT		0x00020000			// Suchwrter hervorheben
#define 	FLAG_HAS_HIGHLIGHT		0x00040000			// Suchwrter hervorheben mglich
#define 	FLAG_HAS_WORDMARK		0x00080000			// Selektierte Wrter knnen makiert werden
#define 	FLAG_WORDMARK_TYPE		0x00300000			// Ausgewhlte Wrter hervorheben (0=aus 1=mit Cursor 2=Select 3=extern)
#define 	FLAG_WORDMARK_LAST		0x00C00000			// Vorheriger Modus von ausgewhlte Wrter hervorheben
#define		FLAG_CONFIG_SAFE     	0x80000000			// Konfiguration gendert


#define 	ANSI_SETFLAGS		 	0x00000010			// Flags setzen
#define 	ANSI_GETFLAGS		 	0x00000011			// Flags lesen
#define 	ANSI_FIND			 	0x00000012			// Text suchen
#define 	ANSI_REPLACE		 	0x00000013			// Text ndern
#define 	ANSI_GETFONTSIZE	 	0x00000014			// Schriftgre holen
#define 	ANSI_SETTABSIZE		 	0x00000015			// Tabulator-Breite setzen
#define 	ANSI_HIGHLIGHT			0x00000016			// Suchwrter hervorheben
#define 	ANSI_WORDMARK			0x00000017			// Wrter markieren

											
#define		WND_FIND(pWnd ,pInfo)			(pWnd)->SendMessage(WM_ANSIINFO,ANSI_FIND	    ,(LPARAM)pInfo)
#define		WND_CHANGE(pWnd,pInfo)			(pWnd)->SendMessage(WM_ANSIINFO,ANSI_REPLACE    ,(LPARAM)pInfo)
#define		WND_HIGHLIGHT(pWnd,pInfo)		(pWnd)->SendMessage(WM_ANSIINFO,ANSI_HIGHLIGHT  ,(LPARAM)pInfo)
#define		WND_GETFLAGS(pWnd)				(pWnd)->SendMessage(WM_ANSIINFO,ANSI_GETFLAGS   ,0)
#define		WND_GETFONTSIZE(pWnd) (CSize)	(pWnd)->SendMessage(WM_ANSIINFO,ANSI_GETFONTSIZE,0)
#define		WND_SETTABWIDTH(pWnd,uWidth)	(pWnd)->SendMessage(WM_ANSIINFO,ANSI_SETTABSIZE ,uWidth)
#define		WND_SETFLAGS(pWnd,uFlags,uMask) AnsiSetFlags(pWnd,uFlags,uMask)

typedef	struct
		{
		int		 iMode;									// Art fr Suchen und ndern
		int		 iMask;									// Maske fr Flags
		char	*pText;									// Suchen Text
		char	*pChange;								// ndern Text
		}TextInfo;

inline AnsiSetFlags(CWnd *pWnd,unsigned uFlags,unsigned uMask)
		{
		TextInfo	sInfo;

		sInfo.iMode = uFlags;
		sInfo.iMask	= uMask;

		return pWnd->SendMessage(WM_ANSIINFO,ANSI_SETFLAGS,(LPARAM)&sInfo);
		}


#endif
