//*****************************************************************************
//*
//*
//*		Diverse Zeit Funktionen
//*
//*
//*****************************************************************************
#ifndef	__TIMECONVERT_H__
#define __TIMECONVERT_H__

#if _MSC_VER > 1000
#pragma once
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#define		USE_AFX_TIME
	#ifndef		__AFX_H__
	#include	<Afx.h>
	#include	<afxdisp.h>
	#endif
#else
	#include	<Windows.h>
#endif


#include	<time.h>
#include	<oledb.h>

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif


typedef	struct tm TMTIME;
typedef	struct
	{
	WORD	wTime;
	WORD	wDate;
	}DOSTIME;


//*****************************************************************************
//*
//*		TimeConvert
//*
//*****************************************************************************

inline	BOOL TimeConvert(const time_t       iUtcTime,time_t       &iUtcTimeX){iUtcTimeX=iUtcTime;return TRUE;}
		BOOL TimeConvert(const time_t       iUtcTime,FILETIME     &sFileTime);
		BOOL TimeConvert(const time_t       iUtcTime,double       &dOleTime );
		BOOL TimeConvert(const time_t       iUtcTime,SYSTEMTIME   &sSysTime );
		BOOL TimeConvert(const time_t       iUtcTime,DBDATE       &sDbDate  );
		BOOL TimeConvert(const time_t       iUtcTime,DBTIMESTAMP  &sDbStamp );
		BOOL TimeConvert(const time_t       iUtcTime,DOSTIME      &sDosTime );
		BOOL TimeConvert(const time_t       iUtcTime,DBTIME       &sDbTime  );
		BOOL TimeConvert(const time_t       iUtcTime,TMTIME       &sTmTime  ,int iLocal=0);

inline	BOOL TimeConvert(const FILETIME    &sFileTime,FILETIME    &sFileTimeX){sFileTimeX=sFileTime;return TRUE;}
		BOOL TimeConvert(const FILETIME    &sFileTime,time_t      &iUtcTime );
		BOOL TimeConvert(const FILETIME    &sFileTime,double      &dOleTime );
inline	BOOL TimeConvert(const FILETIME    &sFileTime,SYSTEMTIME  &sSysTime ){if(FileTimeToSystemTime(&sFileTime,&sSysTime))return TRUE;memset(&sSysTime,0,sizeof(sSysTime));return FALSE;}
		BOOL TimeConvert(const FILETIME    &sFileTime,DBDATE      &sDbDate  );
		BOOL TimeConvert(const FILETIME    &sFileTime,DBTIME      &sDbTime  );
		BOOL TimeConvert(const FILETIME    &sFileTime,DBTIMESTAMP &sDbStamp );
inline	BOOL TimeConvert(const FILETIME    &sFileTime,DOSTIME     &sDosTime ){if(FileTimeToDosDateTime(&sFileTime,&sDosTime.wDate,&sDosTime.wTime))return TRUE;sDosTime.wTime=0;sDosTime.wDate=0;return FALSE;}
		BOOL TimeConvert(const FILETIME    &sFileTime,TMTIME      &sTmTime  ,int iLocal=0);

inline	BOOL TimeConvert(const double      &dOleTime ,double      &dOleTimeX){dOleTimeX=dOleTime;return TRUE;}
		BOOL TimeConvert(const double      &dOleTime ,time_t      &iUtcTime );
		BOOL TimeConvert(const double      &dOleTime ,FILETIME    &sFileTime);
		BOOL TimeConvert(const double      &dOleTime ,SYSTEMTIME  &sSysTime );
		BOOL TimeConvert(const double      &dOleTime ,DBDATE      &sDbDate  );
		BOOL TimeConvert(const double      &dOleTime ,DBTIMESTAMP &sDbStamp );
		BOOL TimeConvert(const double      &dOleTime ,DOSTIME     &sDosTime );
		BOOL TimeConvert(const double      &dOleTime ,DBTIME      &sDbTime  );
		BOOL TimeConvert(const double      &dOleTime ,TMTIME      &sTmTime  ,int iLocal=0);

inline	BOOL TimeConvert(const DBDATE      &sDbDate  ,DBDATE      &sDbDateX ){sDbDateX=sDbDate;return TRUE;}
		BOOL TimeConvert(const DBDATE      &sDbDate  ,SYSTEMTIME  &sSysTime );
		BOOL TimeConvert(const DBDATE      &sDbDate  ,time_t      &iUtcTime );
		BOOL TimeConvert(const DBDATE      &sDbDate  ,FILETIME    &sFileTime);
		BOOL TimeConvert(const DBDATE      &sDbDate  ,double      &dOleTime );
		BOOL TimeConvert(const DBDATE      &sDbDate  ,DBTIMESTAMP &sDbStamp );
		BOOL TimeConvert(const DBDATE      &sDbDate  ,DOSTIME     &sDosTime );
inline	BOOL TimeConvert(const DBDATE      &sDbDate  ,TMTIME      &sTmTime  ){sTmTime.tm_isdst=0;sTmTime.tm_sec=0;sTmTime.tm_min=0;sTmTime.tm_hour=0;sTmTime.tm_mday=sDbDate.day;sTmTime.tm_mon=sDbDate.month-1;sTmTime.tm_year=sDbDate.year-1900;mktime(&sTmTime);}

inline	BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,DBTIMESTAMP &sDbStampX){sDbStampX=sDbStamp;return TRUE;}
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,DBTIMESTAMP &sDbStampX,int iMode);
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,SYSTEMTIME  &sSysTime );
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,time_t      &iUtcTime );
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,FILETIME    &sFileTime);
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,double      &dOleTime );
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,DBDATE      &sDbDate  );
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,DOSTIME     &sDosTime );
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,DBTIME      &sDbTime  );
		BOOL TimeConvert(const DBTIMESTAMP &sDbStamp ,TMTIME      &sTmTime  ,int iLocal=0);

inline	BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,SYSTEMTIME  &sSysTimeX){sSysTimeX=sSysTime;return TRUE;}
		BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,SYSTEMTIME  &sSysTimeX,int iMode);
		BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,time_t      &iUtcTime );
inline	BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,FILETIME    &sFileTime){if(SystemTimeToFileTime(&sSysTime,&sFileTime))return TRUE;sFileTime.dwHighDateTime=0;sFileTime.dwLowDateTime=0;return FALSE;}
		BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,double      &dOleTime );
inline	BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,DBDATE      &sDbDate  ){sDbDate.day = sSysTime.wDay;sDbDate.month = sSysTime.wMonth;sDbDate.year = sSysTime.wYear;return TRUE;}
		BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,DBTIMESTAMP &sDbStamp );
		BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,DOSTIME     &sDosTime );
		BOOL TimeConvert(const SYSTEMTIME  &sSysTime ,TMTIME      &sTmTime  ,int iLocal=0);

		BOOL TimeConvert(const TMTIME      &sTmTime  ,time_t      &iUtcTime ,int iLocal=0);
		BOOL TimeConvert(const TMTIME      &sTmTime  ,FILETIME    &sFileTime,int iLocal=0);
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,DBTIME      &sDbTime               ){sDbTime.hour = sTmTime.tm_hour;sDbTime.minute = sTmTime.tm_min;sDbTime.second = sTmTime.tm_sec      ;return TRUE;}
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,DBDATE      &sDbDate               ){sDbDate.day  = sTmTime.tm_mday;sDbDate.month  = sTmTime.tm_mon+1;sDbDate.year = sTmTime.tm_yday+1900;return TRUE;}
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,SYSTEMTIME  &sSysTime ,int iLocal=0){FILETIME sTime;if(!TimeConvert(sTmTime,sTime,iLocal)){memset(&sSysTime ,0,sizeof(sSysTime ));return FALSE;}return TimeConvert(sTime,sSysTime );}
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,double      &dOleTime ,int iLocal=0){FILETIME sTime;if(!TimeConvert(sTmTime,sTime,iLocal)){memset(&dOleTime ,0,sizeof(dOleTime ));return FALSE;}return TimeConvert(sTime,dOleTime );}
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,DBTIMESTAMP &sDbStamp ,int iLocal=0){FILETIME sTime;if(!TimeConvert(sTmTime,sTime,iLocal)){memset(&sDbStamp ,0,sizeof(sDbStamp ));return FALSE;}return TimeConvert(sTime,sDbStamp );}
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,DOSTIME     &sDosTime ,int iLocal=0){FILETIME sTime;if(!TimeConvert(sTmTime,sTime,iLocal)){memset(&sDosTime ,0,sizeof(sDosTime ));return FALSE;}return TimeConvert(sTime,sDosTime );}
inline	BOOL TimeConvert(const TMTIME      &sTmTime  ,TMTIME      &sTmTimeX ,int iLocal=0,int iToLocal=0){time_t iTime;if(!TimeConvert(sTmTime,iTime,iLocal)){memset(&sTmTimeX,0,sizeof(sTmTimeX));return FALSE;}return TimeConvert(iTime,sTmTimeX,iToLocal);}

inline	BOOL TimeConvert(const DOSTIME     &sDosTime ,DOSTIME     &sDosTimeX){sDosTimeX=sDosTime;return TRUE;}
		BOOL TimeConvert(const DOSTIME     &sDosTime ,SYSTEMTIME  &sSysTime );
		BOOL TimeConvert(const DOSTIME     &sDosTime ,time_t      &iUtcTime );
inline	BOOL TimeConvert(const DOSTIME     &sDosTime ,FILETIME    &sFileTime){if(DosDateTimeToFileTime(sDosTime.wDate,sDosTime.wTime,&sFileTime))return TRUE;sFileTime.dwHighDateTime=0;sFileTime.dwLowDateTime=0;return FALSE;}
		BOOL TimeConvert(const DOSTIME     &sDosTime ,double      &dOleTime );
		BOOL TimeConvert(const DOSTIME     &sDosTime ,DBDATE      &sDbDate  );
		BOOL TimeConvert(const DOSTIME     &sDosTime ,DBTIMESTAMP &sDbStamp );
inline	BOOL TimeConvert(const DOSTIME     &sDosTime ,TMTIME      &sTmTime  ,int iLocal=0){time_t iTime;if(!TimeConvert(sDosTime,iTime)){memset(&sTmTime,0,sizeof(sTmTime));return FALSE;}return TimeConvert(iTime,sTmTime,iLocal);}

inline	BOOL TimeConvert(const DBTIME      &sDbTime  ,DBTIME      &sDbTimeX ){sDbTimeX=sDbTime;return TRUE;}
		BOOL TimeConvert(const DBTIME      &sDbTime  ,time_t      &iUtcTime );
		BOOL TimeConvert(const DBTIME      &sDbTime  ,double      &dOleTime );
		BOOL TimeConvert(const DBTIME      &sDbTime  ,DBTIMESTAMP &sDbStamp );
inline	BOOL TimeConvert(const DBTIME      &sDbTime  ,TMTIME      &sTmTime  ,int iLocal=0){time_t iTime;if(!TimeConvert(sDbTime,iTime)){memset(&sTmTime,0,sizeof(sTmTime));return FALSE;}return TimeConvert(iTime,sTmTime,iLocal);}

//******************** Zu COleDateTime ****************************************
#ifdef USE_AFX_TIME

inline	BOOL TimeConvert(const time_t iUtcTime,COleDateTime &sOleTime)
			{
			sOleTime.m_status=COleDateTime::valid;
			return TimeConvert(iUtcTime,sOleTime.m_dt);
			}
inline	BOOL TimeConvert(const FILETIME &sFileTime,COleDateTime &sOleTime)
			{
			sOleTime.m_status=COleDateTime::valid;
			return TimeConvert(sFileTime,sOleTime.m_dt);
			}
inline	BOOL TimeConvert(const double &dOleTime,COleDateTime &sOleTime)
			{
			sOleTime.m_status=COleDateTime::valid;
			sOleTime.m_dt=dOleTime;
			return TRUE;
			}
inline	BOOL TimeConvert(const SYSTEMTIME &sSysTime,COleDateTime &sOleTime)
			{
			FILETIME sFileTime;
			if(!SystemTimeToFileTime(&sSysTime,&sFileTime))
				{
				sOleTime.SetDateTime(1900,1,1,0,0,0);
				return FALSE;
				}
			return TimeConvert(sFileTime,sOleTime);
			}
inline	BOOL TimeConvert(const DBDATE &sDbDate,COleDateTime &sOleTime)
			{
			FILETIME sFileTime;
			TimeConvert(sDbDate,sFileTime);
			return TimeConvert(sFileTime,sOleTime);
			}
inline	BOOL TimeConvert(const DBTIMESTAMP &sDbStamp,COleDateTime &sOleTime)
			{
			FILETIME sFileTime;
			TimeConvert(sDbStamp,sFileTime);
			return TimeConvert(sFileTime,sOleTime);
			}
inline	BOOL TimeConvert(const DOSTIME &sDosTime,COleDateTime &sOleTime)
			{
			FILETIME sFileTime;
			TimeConvert(sDosTime,sFileTime);
			return TimeConvert(sFileTime,sOleTime);
			}
inline	BOOL TimeConvert(const DBTIME &sDbTime,COleDateTime &sOleTime)
			{
			sOleTime.m_status=COleDateTime::valid;
			return TimeConvert(sDbTime,sOleTime.m_dt);
			}
inline	BOOL TimeConvert(const TMTIME &sTmTime,COleDateTime &sOleTime,int iLocal=0)
			{
			sOleTime.m_status=COleDateTime::valid;
			return TimeConvert(sTmTime,sOleTime.m_dt,iLocal);
			}

//******************** Zu CTime ***********************************************

inline	BOOL TimeConvert(const time_t iUtcTime,CTime &sAfxTime)
			{
			sAfxTime = iUtcTime;
			return TRUE;
			}
inline	BOOL TimeConvert(const FILETIME &sFileTime,CTime &sAfxTime)
			{
			BOOL	bOk;
			time_t	iTime;
			bOk=TimeConvert(sFileTime,iTime);
			sAfxTime = iTime;
			return bOk;
			}
inline	BOOL TimeConvert(const double &dOleTime,CTime &sAfxTime)
			{
			BOOL	bOk;
			time_t	iTime;
			bOk=TimeConvert(dOleTime,iTime);
			sAfxTime = iTime;
			return bOk;
			}
inline	BOOL TimeConvert(const SYSTEMTIME &sSysTime,CTime &sAfxTime)
			{
			FILETIME sFileTime;
			if(!SystemTimeToFileTime(&sSysTime,&sFileTime))
				{
				sAfxTime=0;
				return FALSE;
				}
			return TimeConvert(sFileTime,sAfxTime);
			}
inline	BOOL TimeConvert(const DBDATE &sDbDate,CTime &sAfxTime)
			{
			FILETIME sFileTime;
			TimeConvert(sDbDate,sFileTime);
			return TimeConvert(sFileTime,sAfxTime);
			}
inline	BOOL TimeConvert(const DBTIMESTAMP &sDbStamp,CTime &sAfxTime)
			{
			FILETIME sFileTime;
			TimeConvert(sDbStamp,sFileTime);
			return TimeConvert(sFileTime,sAfxTime);
			}
inline	BOOL TimeConvert(const DOSTIME &sDosTime,CTime &sAfxTime)
			{
			FILETIME sFileTime;
			TimeConvert(sDosTime,sFileTime);
			return TimeConvert(sFileTime,sAfxTime);
			}
inline	BOOL TimeConvert(const DBTIME &sDbTime,CTime &sAfxTime)
			{
			time_t iTime;
			TimeConvert(sDbTime,iTime);
			sAfxTime=iTime;
			return TRUE;
			}
inline	BOOL TimeConvert(const TMTIME &sTmTime,CTime &sAfxTime,int iLocal=0)
			{
			time_t iTime;
			TimeConvert(sTmTime,iTime,iLocal);
			sAfxTime=iTime;
			return TRUE;
			}

//******************** Von COleDateTime ***************************************

inline	BOOL TimeConvert(const COleDateTime &sOleTime,COleDateTime &sOleTimeX)
			{
			sOleTimeX=sOleTime;
			return TRUE;
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,time_t &iUtcTime)
			{
			return TimeConvert(sOleTime.m_dt,iUtcTime);
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,FILETIME &sFileTime)
			{
			return TimeConvert(sOleTime.m_dt,sFileTime);
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,double &dOleTime)
			{
			dOleTime=sOleTime.m_dt;
			return TRUE;
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,CTime &sAfxTime)
			{
			BOOL   bOk;
			time_t iTime;
			bOk      = TimeConvert(sOleTime.m_dt,iTime);
			sAfxTime = iTime;
			return TRUE;
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,SYSTEMTIME &sSysTime)
			{
			FILETIME sFileTime;
			TimeConvert(sOleTime.m_dt,sFileTime);
			if(FileTimeToSystemTime(&sFileTime,&sSysTime))return TRUE;
			memset(&sSysTime,0,sizeof(&sSysTime));
			return FALSE;
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,DBDATE &sDbDate)
			{
			FILETIME	sFileTime;
			TimeConvert(sOleTime,sFileTime);
			return TimeConvert(sFileTime,sDbDate);
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,DBTIMESTAMP &sDbStamp)
			{
			FILETIME	sFileTime;
			TimeConvert(sOleTime,sFileTime);
			return TimeConvert(sFileTime,sDbStamp);
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,DOSTIME &sDosTime)
			{
			FILETIME	sFileTime;
			TimeConvert(sOleTime,sFileTime);
			return TimeConvert(sFileTime,sDosTime);
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,DBTIME &sDbTime)
			{
			return TimeConvert(sOleTime.m_dt,sDbTime);
			}
inline	BOOL TimeConvert(const COleDateTime &sOleTime,TMTIME &sTmTime,int iLocal=0)
			{
			FILETIME	sFileTime;
			TimeConvert(sOleTime,sFileTime);
			return TimeConvert(sFileTime,sTmTime,iLocal);
			}

//******************** Von CTime **********************************************

inline	BOOL TimeConvert(const CTime &sAfxTime,CTime &sAfxTimeX)
			{
			sAfxTimeX = sAfxTime;
			return TRUE;
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,time_t &iUtcTime)
			{
			iUtcTime = sAfxTime.GetTime();
			return TRUE;
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,FILETIME &sFileTime)
			{
			return TimeConvert(sAfxTime.GetTime(),sFileTime);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,double &dOleTime)
			{
			return TimeConvert(sAfxTime.GetTime(),dOleTime);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,COleDateTime &sOleTime)
			{
			sOleTime.m_status=COleDateTime::valid;
			return TimeConvert(sAfxTime.GetTime(),sOleTime.m_dt);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,SYSTEMTIME &sSysTime)
			{
			FILETIME sFileTime;
			TimeConvert(sAfxTime.GetTime(),sFileTime);
			if(FileTimeToSystemTime(&sFileTime,&sSysTime))return TRUE;
			memset(&sSysTime,0,sizeof(&sSysTime));
			return FALSE;
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,DBDATE &sDbDate)
			{
			FILETIME	sFileTime;
			TimeConvert(sAfxTime,sFileTime);
			return TimeConvert(sFileTime,sDbDate);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,DBTIMESTAMP &sDbStamp)
			{
			FILETIME	sFileTime;
			TimeConvert(sAfxTime,sFileTime);
			return TimeConvert(sFileTime,sDbStamp);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,DOSTIME &sDosTime)
			{
			FILETIME	sFileTime;
			TimeConvert(sAfxTime,sFileTime);
			return TimeConvert(sFileTime,sDosTime);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,DBTIME &sDbTime)
			{
			return TimeConvert(sAfxTime.GetTime(),sDbTime);
			}
inline	BOOL TimeConvert(const CTime &sAfxTime,TMTIME &sTmTime,int iLocal=0)
			{
			return TimeConvert(sAfxTime.GetTime(),sTmTime,iLocal);
			}

#endif


//*****************************************************************************
//*
//*		TimeGet
//*
//*****************************************************************************
//	Ergibt Unixtime in Sekunden seit 1.Jan.1970

inline	time_t TimeGet(time_t         &iUtcTime ){return iUtcTime;}
inline	time_t TimeGet(SYSTEMTIME     &sSysTime ){time_t iTime;TimeConvert(sSysTime ,iTime);return iTime;}
inline	time_t TimeGet(FILETIME       &sFileTime){time_t iTime;TimeConvert(sFileTime,iTime);return iTime;}
inline	time_t TimeGet(double         &dOleTime ){time_t iTime;TimeConvert(dOleTime ,iTime);return iTime;}
inline	time_t TimeGet(DBDATE         &sDbDate  ){time_t iTime;TimeConvert(sDbDate  ,iTime);return iTime;}
inline	time_t TimeGet(DBTIMESTAMP    &sDbStamp ){time_t iTime;TimeConvert(sDbStamp ,iTime);return iTime;}
inline	time_t TimeGet(DBTIME         &sDbTime  ){time_t iTime;TimeConvert(sDbTime  ,iTime);return iTime;}
inline	time_t TimeGet(DOSTIME        &sDosTime ){time_t iTime;TimeConvert(sDosTime ,iTime);return iTime;}
inline	time_t TimeGet(TMTIME   &sTmTime,int i=0){time_t iTime;TimeConvert(sTmTime,iTime,i);return iTime;}

#ifdef USE_AFX_TIME
inline	time_t TimeGet(CTime          &sAfxTime ){return sAfxTime.GetTime();}
inline	time_t TimeGet(COleDateTime   &sOleTime ){time_t iTime;TimeConvert(sOleTime.m_dt,iTime);return iTime;}
#endif

//*****************************************************************************
//*
//*		TimeGet64
//*
//*****************************************************************************
//	Ergibt 100ns Schriit seit 1.1.1601 in Sekunden

inline	__int64 TimeGet64(FILETIME     &sFileTime){return *(__int64*)&sFileTime;}
inline	__int64 TimeGet64(time_t       &iUtcTime ){__int64 iTime;TimeConvert(iUtcTime ,*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(SYSTEMTIME   &sSysTime ){__int64 iTime;TimeConvert(sSysTime ,*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(double       &dOleTime ){__int64 iTime;TimeConvert(dOleTime ,*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(DBDATE       &sDbDate  ){__int64 iTime;TimeConvert(sDbDate  ,*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(DBTIMESTAMP  &sDbStamp ){__int64 iTime;TimeConvert(sDbStamp ,*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(DOSTIME      &sDosTime ){__int64 iTime;TimeConvert(sDosTime ,*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(TMTIME       &sTmTime  ){__int64 iTime;TimeConvert(sTmTime  ,*(FILETIME*)&iTime);return iTime;}

#ifdef USE_AFX_TIME
inline	__int64 TimeGet64(CTime        &sAfxTime ){__int64 iTime;TimeConvert(sAfxTime.GetTime(),*(FILETIME*)&iTime);return iTime;}
inline	__int64 TimeGet64(COleDateTime &sOleTime ){__int64 iTime;TimeConvert(sOleTime.m_dt     ,*(FILETIME*)&iTime);return iTime;}
#endif

//*****************************************************************************
//*
//*		TimeDelta
//*
//*****************************************************************************
//	Ergibt Zeitunterschied in Sekunden

#define 	TimeDelta(a,b)		(TimeGet  (b)-TimeGet  (a))
#define 	TimeDelta64(a,b)	(TimeGet64(b)-TimeGet64(a))


//*****************************************************************************
//*
//*		TimePrint
//*
//*****************************************************************************

// Konstanten fr iMode Parameter

#define	TP_MILLISEC		0x0001	// Millisekunden angeben
#define	TP_WDAY		 	0x0002	// Wochentag angeben
#define	TP_TIME 		0x000C	// Zeit angeben
#define	TP_TIMESHORT 	0x0004	// Zeit angeben ohne Sekunden
#define	TP_DATE 		0x0030	// Datum angeben mit Jahr 4 stellig
#define	TP_DATE2		0x0050	// Datum angeben mit Jahr 2 stellig
#define	TP_DATE_ISO 	0x0100	// Datum angeben mit [JJ]JJ-MM-TT
#define	TP_ONE_SPACE 	0x0200	// Nur ein Leerzeichen wischen Datum-Zeit
#define	TP_DATESHORT	0x0010	// Datum angeben ohne Jahr
#define	TP_ABC 			0x0080	// Monatsnamen ausschreiben
#define	TP_ALL	 		0x00BE	// Alle Flags ohne Millisekunden
#define TP_MILLISECEX	0x0200	// Millisekunden nur anzeigen wenn nicht 0
#define	TP_TOGLOBAL		0x4000	// Lokale  in globale Zeit umwandeln
#define	TP_TOLOCAL		0x8000	// Globale in locale  Zeit umwandeln

extern const int    aTpPDays [];
extern const int    aTpDays  [];
extern const int    aTpMPDays[];
extern const int    aTpMDays [];
extern const char  *aTpWday  [];
extern const char  *aTpMonth [];

		int  TimePrint(char    *pStr,const SYSTEMTIME   &sSysTime ,int iMode=TP_DATE|TP_TIME);
inline	int  TimePrint(char    *pStr,const time_t       &iUtcTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(iUtcTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(char    *pStr,const FILETIME     &sFileTime,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sFileTime    ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(char    *pStr,const double       &dOleTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(dOleTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(char    *pStr,const DBDATE       &sDbDate  ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sDbDate      ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(char    *pStr,const DBTIMESTAMP  &sDbStamp ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sDbStamp     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(char    *pStr,const DOSTIME      &sDosTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sDosTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
		int  TimePrint(char    *pStr,const TMTIME       &sTmTime  ,int iMode=TP_DATE|TP_TIME);
		int  TimePrint(char    *pStr,const DBTIME       &sDbTime  ,int iMode=        TP_TIME);

		int  TimePrint(wchar_t *pStr,const SYSTEMTIME   &sSysTime ,int iMode=TP_DATE|TP_TIME);
inline	int  TimePrint(wchar_t *pStr,const time_t       &iUtcTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(iUtcTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(wchar_t *pStr,const FILETIME     &sFileTime,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sFileTime    ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(wchar_t *pStr,const double       &dOleTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(dOleTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(wchar_t *pStr,const DBDATE       &sDbDate  ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sDbDate      ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(wchar_t *pStr,const DBTIMESTAMP  &sDbStamp ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sDbStamp     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(wchar_t *pStr,const DOSTIME      &sDosTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sDosTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
		int  TimePrint(wchar_t *pStr,const TMTIME       &sTmTime  ,int iMode=TP_DATE|TP_TIME);
		int  TimePrint(wchar_t *pStr,const DBTIME       &sDbTime  ,int iMode=        TP_TIME);

#ifdef USE_AFX_TIME
inline	int  TimePrint(char    *pStr,const CTime        &sAfxTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sAfxTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(char    *pStr,const COleDateTime &sOleTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sOleTime.m_dt,sSysTime);return TimePrint(pStr,sSysTime,iMode);}

inline	int  TimePrint(wchar_t *pStr,const CTime        &sAfxTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sAfxTime     ,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
inline	int  TimePrint(wchar_t *pStr,const COleDateTime &sOleTime ,int iMode=TP_DATE|TP_TIME){SYSTEMTIME sSysTime;TimeConvert(sOleTime.m_dt,sSysTime);return TimePrint(pStr,sSysTime,iMode);}
#endif

#endif
