//*****************************************************************************
//*
//*
//*		Implementierung der Klasse CTxtKeys
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//	bool Close ();											// Schliet Schlssel
//	bool Open  (HKEY  hKey=HKEY_CURRENT_USER,				// ffnet Schlssel
//				char *pPath=0,
//				int   iMode=CRK_CREATE);
//	bool Open  (char *pPath=0,
//				int   iMode=CRK_CREATE);
//	bool Create(char *pPath);								// Erzeugt UnterSchlssel
//	bool Create(HKEY  hKey=HKEY_CURRENT_USER,				// Erzeugt Schlssel
//				char *pPath=0);
//	bool Up	   (char *pPath=CRK_NEXT,int iOnlyIfExist=0);	// Pfad aufsteigen
//	bool Down  ();											// Pfad aufabsteigen
//	bool Next  ();											// Nchsten UnterSchlssel ffnen
//	bool First ();											// Zum ersten UnterSchlssel
//
//															// Werte auslesen
//	bool Get(         int   &iVal,char *pName=CRK_NEXT);
//	bool Get(unsigned int   &uVal,char *pName=CRK_NEXT);
//	bool Get(         long  &lVal,char *pName=CRK_NEXT);
//	bool Get(unsigned long  &uVal,char *pName=CRK_NEXT);
//	bool Get(		  char **pVal,char *pName=CRK_NEXT);
//	bool Get(unsigned char **pVal,char *pName=CRK_NEXT);
//	bool Get(         void **pVal,char *pName=CRK_NEXT,DWORD uType=REG_BINARY);
//	bool Get(		  char  *pVal,char *pName=CRK_NEXT);
//	bool Get(unsigned char  *pVal,char *pName=CRK_NEXT);
//	bool Get(		  void  *pVal,DWORD Len,char *pName=CRK_NEXT,DWORD uType=REG_NONE);
//
//															// Werte schreiben
//	bool Set(         int    iVal,char *pName=CRK_NEXT);
//	bool Set(         char  *pVal,char *pName=CRK_NEXT);
//	bool Set(unsigned char  *pVal,char *pName=CRK_NEXT);
//	bool Set(		  void  *pVal,DWORD Len,char *pName=CRK_NEXT,DWORD uType=REG_NONE);
//
//	bool Del   (char *pName=CRK_NEXT);						// Wert lschen
//	bool DelKey(char *pName=CRK_NEXT);						// hKey  lschen
//
//
//	int		Path(char *,int,int iMode=0);					// Ergibt Pfad
//	DWORD	Type ();										// Ergibt Type  der Werte
//	DWORD	Len  ();										// Ergibt Lnge der Werte
//	HKEY	Key  ();	     								// Ergibt Aktuellen Schlssel
//	int		Error();										// Ergibt letzten Fehler
//	char   *Name ();										// Ergibt Name
//
//	int	    ValueCount();									// Ergibt Werte Anzahl
//	char   *ValueName (int iNr=-1);							// Ergibt Wert-Namen
//	int	    KeyCount  ();									// Ergibt Anzahl der SubKeys
//	char   *KeySubName(int iNr=-1);							// Ergibt SubKey-Namen
//	char   *KeyName   (int iNr=-1);							// Ergibt hKey-Namen
//
//	int     RegPath(char *pPath,int iLen,char *pName=0);	// Ergibt Standard Pfad
//
//	int	    OpenText(const char *pName=0);					// Textdatei laden
//	int     SaveText(int iMode=0);							// Textdatei speichern
#include	<stdio.h>
#include	"TxtKeys.h"
#include	"StringFunctions.h"


#define	Check()													\
	if(iLevel<            0){iError=ERROR_KEY  ;return false;}	\
	if(iLevel>=CRK_KEYS_END){iError=ERROR_LIMIT;return false;}
#define	Exit(nr)	        {iError=nr         ;return false;}	\


#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#include	<wchar.h>
#define 	A(a)		WideToAnsi(a)
#define 	C(a)		AnsiToWide(a)
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	zcharu		short
#define 	strzlen		wcslen
#define 	strzcpy		wcscpy
#define 	strzncpy	wcsncpy
#define 	strzncat	wcsncat
#define 	strznicmp	wcsnicmp
#define 	strzcat		wcscat
#define 	fzopen	   _wfopen
#define 	rezmove	   _wremove
#define 	rezname	   _wrename
#else
#define 	A(a)		a
#define 	C(a)		a
#define 	Z(a)		a
#define 	zchar		char
#define 	zcharu		unsigned char
#define 	strzlen		strlen
#define 	strzcpy		strcpy
#define 	strzncpy	strncpy
#define 	strzncat	strncat
#define 	strznicmp	strnicmp
#define 	strzcat		strcat
#define 	fzopen		fopen
#define 	rezmove		remove
#define 	rezname		rename
#endif



#define 	NO_SUB_CREATE	((HKEY)0xFF123456)
#define 	BUFFER_READ		(BUFFER_LEN-1024)
#define 	BUFFER_LEN		4096

#define		BUFFER_ADD(mem,alt)									\
			{													\
			char  *pMemNew;										\
			int	   iAddNew=(alt>16)? alt:16;					\
			pMemNew=new char [alt+iAddNew+4];	 				\
			memcpy(pMemNew,mem,alt);							\
			alt+=iAddNew;										\
			if(mem)delete mem;									\
			mem = pMemNew;										\
			}


static	CTxtKeys  sExitKeys;							// Daten speichern beim Beenden
zchar	CTxtKeys::cFileNameGlobal[MAX_PATH]=Z("");


//*****************************************************************************
//*
//*		Variablen
//*
//*****************************************************************************

typedef	struct
	{
	unsigned	 uType;									// Type Nummer
	unsigned	 uSize;									// Lnge in Byte
	char		*pData;									// Datenzeiger
	} SubData,*SubDataPtr;

CStringChain CTxtKeys::sKeyNamesGlobal(sizeof(SubEntries));


const zchar *CTxtKeys::pRootName[]=
					{
					Z("HKEY_CLASSES_ROOT"),
					Z("HKEY_CURRENT_USER"),
					Z("HKEY_LOCAL_MACHINE"),
					Z("HKEY_USERS"),
					Z("HKEY_CURRENT_CONFIG"),
					Z("HKEY_DYN_DATA"),
					NULL
					};

const HKEY	CTxtKeys::hRootKeys[]=
					{
					HKEY_CLASSES_ROOT,
					HKEY_CURRENT_USER,
					HKEY_LOCAL_MACHINE,
					HKEY_USERS,
					HKEY_CURRENT_CONFIG,
					HKEY_DYN_DATA
					};


int	CTxtKeys::iIsLoadGlobal		= 0;					// Ist die Textdatei geladen
int	CTxtKeys::iIsModifiedGlobal	= 0;					// Wurden globale nderungen gemacht
int CTxtKeys::iClassCount		= 0;					// Zhler fr Klassen

//*****************************************************************************
//*
//*		Konstrukor
//*
//*****************************************************************************
CTxtKeys::CTxtKeys(const zchar *pPath)
{


	pFileName   =  cFileNameLocal;
	pIsModified = &iIsModifiedLocal;
	pIsLoad     = &iIsLoadLocal;

	pKeyNames   = new CStringChain;
	pKeyNames->DataLength(sizeof(SubEntries));

	strzncpy(cRegNameUsed,pPath,sizeof(cRegNameUsed));

	cName[257]	=  0;
	hKeyNow		=  0;
	iLocal		=  1;
	iLevel		= -1;

}

CTxtKeys::CTxtKeys()
{

	if(iClassCount==0)sExitKeys.cName[0]=0;

	strzncpy(cRegNameUsed,cRegName,sizeof(cRegNameUsed));

	pFileName   =  cFileNameGlobal;
	pKeyNames   = &sKeyNamesGlobal;
	pIsModified = &iIsModifiedGlobal;
	pIsLoad     = &iIsLoadGlobal;
	iClassCount++;

	cName[257]	=  0;
	hKeyNow		=  0;
	iLocal		=  0;
	iLevel		= -1;

	#ifdef UNICODE
	uWidePos	=  0;
	#endif

}

//*****************************************************************************
//*
//*		Destrukor
//*
//*****************************************************************************
CTxtKeys::~CTxtKeys()
{
SubEntries	*pSub;
SubData		*pData;
int			 iKey,iNum;


	if(iLevel>=0)Close();
	if(iLocal==0)iClassCount--;

	if(iLocal || iClassCount==0)
		{
		SaveText();

		iKey = pKeyNames->Count()-1;

		for(;iKey>=0;iKey--)
			{
			pSub=(SubEntries*)pKeyNames->Data(iKey);
			iNum=pSub->pEntries->Count()-1;

			for(;iNum>=0;iNum--)
				{
				pData=(SubData*)pSub->pEntries->Data(iNum);
				delete pData->pData;
				}

			delete pSub->pEntries;
			}

		pKeyNames->Del();
		pKeyNames = 0;
	   *pIsLoad	  = 0;
		}

}

//*****************************************************************************
//*
//*		Close
//*
//*****************************************************************************
// Schliet alle Schlssel
// Ergibt 'false' bei einem Fehler
bool CTxtKeys::Close()
{
int		iErr=ERROR_SUCCESS;
bool	i,bExit=true;


	while(iLevel>=0)
		{
			i=Down();
		if(!i)
			{
			iErr  = iError;
			bExit = false;
			}
		}

	hKeyInit = 0;
	hKeyNow  = 0;
	iError	 = iErr;


return bExit;
}

//*****************************************************************************
//*
//*		Open
//*
//*****************************************************************************
//  ffnet einen Schlssel
//	hKey	: Ausgangsschlssel =	HKEY_CURRENT_USER
//									HKEY_LOCAL_MACHINE
//									... weitere
//									0 == Schlssel aus Pfad holen.
//	pPfad	: Name des Schlssels bei 0 wird er von AfxGetApp()->m_pszRegistryKey...
//			  genommen.
//	iMode	: CRK_READ		0	Schlssel nur lesen
//		      CRK_WRITE		1	Schlssel auch schreiben
//		      CRK_CREATE	2	Schlssel neu erzeugen wenn nicht vorhanden.
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Open(HKEY hKey,const zchar *pPath,int iMode)
{
int		iCount,i;
zchar	cBuffer[1024];



	if(iLevel>=0)Close();

	iError    = ERROR_KEY;
	iOpenMode = iMode;
	iFlags	  =(iMode==CRK_READ)? KEY_READ:KEY_ALL_ACCESS;

	if(!*pIsLoad)OpenText();							// Textdatei laden

	if(hKey)											// Anfangsschlssel
		{
		iCount=GetInitKey(hKey,cBuffer);
		}
	else{
		iCount	   = 0;
		cBuffer[0] = 0;
		}

	if(!pPath)											// Standard pPath
		{
		RegPath(cBuffer+iCount,sizeof(cBuffer)-iCount);
		}
	else{
		if(hKey){cBuffer[iCount]='\\';iCount++;}
		strzncpy(cBuffer+iCount,pPath,sizeof(cBuffer)-iCount);
		cBuffer[sizeof(cBuffer)-1]=0;
		}


	   i=pKeyNames->FindFast(cBuffer,0,-1,1);			// ffne Schlssel
	if(i>=0)
		{
		pSubData	= (SubEntries*)pKeyNames->Data(i);
		pKeyName	= pKeyNames->Get(i);
		aSubData[0] = pSubData;
		aStr[0]		= pKeyName;
		aSub[0]  	= 0;
		aPos[0]  	= 0;

		if(iMode==CRK_CREATE && pSubData->iLevel)		// Speichern erlauben
			{
			*pIsModified |= pSubData->iTemp;
			pSubData->iTemp=0;
			}

		iLevel	 = 0;
		iError	 = ERROR_SUCCESS;
		hKeyInit = hKey;

		return true;
		}

	if(iOpenMode!=CRK_CREATE)
		{
		iError=ERROR_MODE;
		return false;
		}


return Create(hKey,pPath);
}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugt einen neuen Schlssel. Alle alten Schlssel werden geschlossen.
//	hKey	: Ausgangsschlssel = 	HKEY_CURRENT_USER
//									HKEY_LOCAL_MACHINE
//									... weitere
//									0 == Schlssel aus Pfad holen.
//	pPath	: Name des Schlssels bei 0 wird er von AfxGetApp()->m_pszRegistryKey
//		      genommen.
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Create(HKEY hKey,const zchar *pPath)
{
int			i,iCount;
zchar		cBuffer[1024];
SubEntries	sSub;



	if(iLevel>=0)Close();

	iError	  = ERROR_KEY;
	iOpenMode = CRK_CREATE;
	iFlags	  = KEY_ALL_ACCESS;

	if(!*pIsLoad)OpenText();							// Textdatei laden

	if(hKey && hKey!=NO_SUB_CREATE)						// Anfangsschlssel
		{
		iCount=GetInitKey(hKey,cBuffer);
		}
	else{
		iCount	   = 0;
		cBuffer[0] = 0;
		}

	if(!pPath)											// Standard pPath
		{
		RegPath(cBuffer+iCount,sizeof(cBuffer)-iCount);
		}
	else{
		if(hKey && hKey!=NO_SUB_CREATE){cBuffer[iCount]='\\';iCount++;}
		strzncpy(cBuffer+iCount,pPath,sizeof(cBuffer)-iCount);
		cBuffer[sizeof(cBuffer)-1]=0;
		}



	   i=pKeyNames->FindFast(cBuffer,0,-1,1);			// Ist pPath schon vorhanden ?
	if(i>=0)
		{
  		pSubData	= (SubEntries*)pKeyNames->Data(i);
		pKeyName	= pKeyNames->Get(i);
		aSubData[0] = pSubData;
		aStr[0]		= pKeyName;
		aSub[0]		= 0;
		aPos[0]		= 0;
		iLevel		= 0;

		if(hKey==NO_SUB_CREATE)return true;

		if(pSubData->iLevel)							// Speichern erlauben
			{
			pSubData->iTemp = 0;
			*pIsModified   |= pSubData->iTemp;
			}

		i=(int)strzlen(cBuffer);

		for(;i>0;i--)									// Root Eintrge erstellen
			{
			if(cBuffer[i]!='\\')continue;
			   cBuffer[i]=0;
			if(pKeyNames->FindFast(i,cBuffer,0,-1,1)>=0)continue;
			CTxtKeys iTemp;
			iTemp.Create(NO_SUB_CREATE,cBuffer);
			}

		iError=ERROR_SUCCESS;
		hKeyInit=hKey;
		return true;
		}



	sSub.pEntries=new CStringChain;						// Neuen Eintrag erzeugen
	sSub.pEntries->DataLength(sizeof(SubData));
	sSub.iTemp	= (hKey==NO_SUB_CREATE);
	sSub.iLevel	= 0;
	iCount		= (int)strzlen(cBuffer);

	for(i=0;i<iCount;i++)
		{
		if(cBuffer[i]=='\\')sSub.iLevel++;
		}

	i=pKeyNames->Add(iCount,cBuffer,CSC_ABCG,&sSub);
	if(hKey!=NO_SUB_CREATE)*pIsModified=1;


	if(i>=0)											// Wurde der Eintrag erzeugt
		{
		pSubData	= (SubEntries*)pKeyNames->Data(i);
		pKeyName	= pKeyNames->Get(i);
		aSubData[0] = pSubData;
		aStr[0]		= pKeyName;
		aSub[0]		= 0;
		aPos[0]		= 0;

		iLevel		= 0;
		hKeyInit	= hKey;
		iError		= ERROR_SUCCESS;

		if(hKey==NO_SUB_CREATE)return true;

		i=(int)strzlen(cBuffer);						// Root Eintrge erstellen

		for(;i>0;i--)
			{
			if(cBuffer[i]!='\\')continue;
			   cBuffer[i]=0;
			if(pKeyNames->FindFast(cBuffer,0,-1,1)>=0)continue;

			CTxtKeys iTemp;

			iTemp.Create(NO_SUB_CREATE,cBuffer);
			}

		return true;
		}




return false;
}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugt einen neuen Unterschlssel im aktuellen Schlssel.
//	pPath	: Name des Schlssels bei 0 wird er von AfxGetApp()->m_pszRegistryKey
//			  genommen.
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Create(const zchar *pPath)
{
SubEntries	sSub;
int 		iCount,i;
zchar		cBuffer[1024];


	Check();										// Sind Ebenen ok

	if(iOpenMode!=CRK_CREATE)Exit(ERROR_MODE);		// Zugriffs-Erlaubnis ?

	if(!pPath)
		{
		#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
		pPath=AfxGetApp()->m_pszRegistryKey;
		#else
		pPath=Z("");
		#endif
		}


	iError=ERROR_KEY;

	   iCount=(int)strzlen(pKeyName);
	if(iCount+2+strzlen(pPath)>=sizeof(cBuffer))return false;

	memcpy (cBuffer,pKeyName,iCount);cBuffer[iCount]='\\';
	strzcpy(cBuffer+iCount+1,pPath);
	iCount+=(int)strzlen(pPath)+1;

	   i=pKeyNames->FindFast(cBuffer,0,-1,1);		// Ist pPath schon vorhanden ?
	if(i>=0)
		{
		pSubData		 = aSubData[iLevel]=(SubEntries*)pKeyNames->Data(i);
		pKeyName		 = pKeyNames->Get(i);
		aSubData[iLevel] = pSubData;
		aStr    [iLevel] = pKeyName;
		aSub    [iLevel] = 0;
		aPos    [iLevel] = 0;
		pSubData->iTemp  = 0;						// Speichern erlauben
		*pIsModified	|= pSubData->iTemp;
		iError			 = ERROR_SUCCESS;

		return true;
		}



	sSub.pEntries=new CStringChain;					// Neuen Eintrag erzeugen
	sSub.pEntries->DataLength(sizeof(SubData));
	sSub.iTemp  = 0;
	sSub.iLevel = 0;

	for(i=0;i<iCount;i++)if(cBuffer[i]=='\\')sSub.iLevel++;

	i=pKeyNames->Add(iCount,cBuffer,CSC_ABCG,&sSub);
	*pIsModified=1;

	if(i>=0)										// Wurde der Eintrag erzeugt
		{
		iLevel++;

		pSubData		 = (SubEntries*)pKeyNames->Data(i);
		pKeyName		 = pKeyNames->Get(i);
		aSubData[iLevel] = pSubData;
		aStr    [iLevel] = pKeyName;
   		aSub    [iLevel] = 0;
		aPos    [iLevel] = 0;
		iError			 = ERROR_SUCCESS;

		return true;
		}


return false;
}

//*****************************************************************************
//*
//*		Down
//*
//*****************************************************************************
//	Springt eine Pathebene nach unten
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Down()
{

	if(iLevel<0){iError=ERROR_KEY  ;return false;}	// Sind Ebenen ok

	iLevel--;
	pKeyName = (iLevel<0)? 0:aStr    [iLevel];
	pSubData = (iLevel<0)? 0:aSubData[iLevel];
	iError   = ERROR_SUCCESS;


return true;
}
//*****************************************************************************
//*
//*		Up
//*
//*****************************************************************************
//	ffnet einen neuen Unterschlssel
//	pPath	: Ist der Name des Unterschlssels
// 				Ist pPath==NULL      wird der nchste Schlssel genommen
// 				Ist pPath==CRK_NEXT  wird der nchste Schlssel genommen
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Up(const zchar *pPath,int iOnlyIfExist)
{
zchar	cBuffer[1024];
int		iCount,i;


	Check();										// Sind Ebenen ok

	iError=ERROR_KEY;

	if(!pPath || pPath==CRK_NEXT)					// Nchsten Subkey
		{
			pPath=KeySubName();
		if(!pPath)return false;
		aSub[iLevel]++;
		}
													// ffne Schlssel


	   iCount=(int)strzlen(pKeyName);
	if(iCount+2+strzlen(pPath)>=sizeof(cBuffer))return false;

	memcpy (cBuffer,pKeyName,iCount);cBuffer[iCount]='\\';
	strzcpy(cBuffer+iCount+1,pPath);

	i=pKeyNames->FindFast(cBuffer,0,-1,1);

	if(i>=0)
		{
		iLevel++;
		pSubData		 = (SubEntries*)pKeyNames->Data(i);
		pKeyName		 = pKeyNames->Get(i);
		aSubData[iLevel] = pSubData;
		aStr    [iLevel] = pKeyName;
   		aSub    [iLevel] = 0;
		aPos    [iLevel] = 0;

		if(iOpenMode==CRK_CREATE)					// Speichern erlauben
			{
			*pIsModified   |= pSubData->iTemp;
			pSubData->iTemp = 0;
			}

		iError = ERROR_SUCCESS;

		return true;
		}


	if(iOpenMode!=CRK_CREATE || iOnlyIfExist)		// Neu erzeugen erlaubt
		{
		iError=ERROR_MODE;
		return false;
		}



return Create(pPath);
}

//*****************************************************************************
//*
//*		First
//*
//*****************************************************************************
//	Springt zurck zum ersten Wertnamen
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::First()
{
	Check();										// Sind Ebenen ok
	aSub[iLevel]=0;

return true;
}

//*****************************************************************************
//*
//*		GetLength
//*
//*****************************************************************************
//	Liest die Lnge eines Wertes aus
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//  Ergibt die Datenlnge des Wertes oder -1 bei einem Fehler
int CTxtKeys::GetLength(const zchar *pName)
{
SubData	   *pData;
int			iPos;


	Check();										// Sind Ebenen ok

	dwLength = 0;
	dwType   = REG_BINARY;

	if(pName!=CRK_NEXT)
		{
		if(!pName)pName=Z("@");
		strzncpy(cName,pName,256);
		pName=cName;

		   iPos=pSubData->pEntries->Find(pName);	// Suchen Wertnamen
		if(iPos<0){dwType=0;return -1;}

		aPos[iLevel]=iPos+1;
		}
	else{
		   iPos=aPos[iLevel];
		if(iPos>=pSubData->pEntries->Count()){dwType=0;return -1;}

		aPos[iLevel]++;
		}

	pData	 = (SubData*)pSubData->pEntries->Data(iPos);
	dwLength = pData->uSize;
	dwType	 = pData->uType;



return dwLength;
}

//*****************************************************************************
//*
//*		Get(void*...
//*
//*****************************************************************************
//	Liest einen Wert aus.
//	pVal		: Zeiger auf den Zielpuffer in dem der Wert gespeichert wird.
//	uLen		: Ist die Lnges des Zielpuffers in Byte.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//	uType		: Ist der Typ des Wertes der geholt werden soll.
//					REG_BINARY
//					REG_DWORD
//					...
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Get(void *pVal,DWORD uLen,const zchar *pName,DWORD uType)
{
SubData		   *pData;
zchar		   *pPtr;
int				iSize;
int				iPos;


	Check();											// Sind Ebenen ok

	dwLength = uLen;
	dwType	 = uType;
	iError	 = ERROR_KEY;

	if(pName!=CRK_NEXT)
		{
		if(!pName)pName=Z("@");
		strzncpy(cName,pName,256);

		   iPos=pSubData->pEntries->Find(pName);		// Suchen Wertnamen
		if(iPos<0)
			{
			dwLength = 0;
			dwType   = 0;
			return false;
			}

		aPos[iLevel]=iPos+1;
		}
	else{
		   iPos=aPos[iLevel];
		if(iPos>=pSubData->pEntries->Count())
			{
			dwLength = 0;
			dwType   = 0;
			return false;
			}

		aPos[iLevel]++;
		}


	pData=(SubData*)pSubData->pEntries->Data(iPos);

	if(uType!=REG_BINARY && uType!=pData->uType)		// Prfe Typ
		{
		dwLength = 0;
		dwType   = 0;
		return false;
		}

	dwLength = pData->uSize;
	dwType	 = pData->uType;

	if(uType==REG_MULTI_SZ)								// Prfe Lnge
		{
		iSize = dwLength/sizeof(zchar);
		pPtr  = (zchar*)pData->pData;

		     if(iSize==0)iSize=2;
		else if(iSize==1)iSize=(pPtr[0])? 3:2;
		else if(pPtr[iSize-2]!=0)iSize+=(pPtr[iSize-1])? 2:1;
		else if(pPtr[iSize-1]!=0)iSize+=2;

		dwLength = iSize*sizeof(zchar);
		}
	else if(uType==REG_SZ || uType==REG_EXPAND_SZ)
		{
		iSize = dwLength/sizeof(zchar);
		pPtr  = (zchar*)pData->pData;

			 if(iSize==0)iSize++;
		else if(pPtr[iSize-1]!=0)iSize++;

		dwLength = iSize*sizeof(zchar);
		}



	if(uLen<dwLength)return false;						// Ist Speicher gro genug ?

	memcpy(pVal,pData->pData,pData->uSize);

	if(uType==REG_MULTI_SZ)								// Null/Null anhngen
		{
		((zchar*)pVal)[dwLength/sizeof(zchar)-1]=0;
		((zchar*)pVal)[dwLength/sizeof(zchar)-2]=0;
		}
	else if(uType==REG_SZ || uType==REG_EXPAND_SZ)		// Null anhngen
		{
		((zchar*)pVal)[dwLength/sizeof(zchar)-1]=0;
		}


	iError=ERROR_SUCCESS;


return true;
}

//*****************************************************************************
//*
//*		Get(void**...
//*
//*****************************************************************************
//	Liest einen Wert aus und reserviert einen Speicherbereich dafr.
//	pVal		: Hier wird der Zeiger auf den Speicherbereich abgelegt
//				  oder NULL bei einem Fehler.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//	uType		: Ist der Typ des Wertes der geholt werden soll.
//					REG_BINARY
//					REG_DWORD
//					...
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Get(void **pVal,const zchar *pName,DWORD uType)
{
SubData		   *pData;
zchar		   *pNew;
int				iPos;
int				iSize;



	*pVal=0;

	Check();											// Sind Ebenen ok

	dwLength = 0;
	dwType	 = uType;
	iError	 = ERROR_KEY;

	if(pName!=CRK_NEXT)
		{
		if(!pName)pName=Z("@");
		strzncpy(cName,pName,256);

		   iPos=pSubData->pEntries->Find(pName);		// Suchen Wertnamen
		if(iPos<0)
			{
			dwLength = 0;
			dwType   = 0;
			return false;
			}

		aPos[iLevel]=iPos+1;
		}
	else{
		   iPos=aPos[iLevel];
		if(iPos>=pSubData->pEntries->Count())
			{
			dwLength = 0;
			dwType   = 0;
			return false;
			}

		aPos[iLevel]++;
		}


	pData=(SubData*)pSubData->pEntries->Data(iPos);

	if(uType!=REG_BINARY && uType!=pData->uType)		// Prfe uType
		{
		dwLength = 0;
		dwType   = 0;
		return false;
		}

	dwLength = pData->uSize;
	dwType   = pData->uType;


	if(dwType==REG_MULTI_SZ)							// Null Null anhngen
		{
		*pVal=pNew=new zchar[dwLength/sizeof(zchar)+2];
		memcpy(pNew,pData->pData,pData->uSize);

		iSize = dwLength/sizeof(zchar);

		     if(iSize==0){                          iSize =2;pNew[      0]=0;pNew[      1]=0;}
		else if(iSize==1){if(pNew[0]){              iSize =3;pNew[      1]=0;pNew[      2]=0;}else{iSize =2;pNew[      1]=0;}}
		else if(pNew[iSize-2]!=0){if(pNew[iSize-1]){iSize+=2;pNew[iSize-1]=0;pNew[iSize-2]=0;}else{iSize+=1;pNew[iSize-1]=0;}}
		else if(pNew[iSize-1]!=0){                  iSize+=2;pNew[iSize-1]=0;pNew[iSize-2]=0;}

		dwLength = iSize*sizeof(zchar);

		iError=ERROR_SUCCESS;
		return true;
		}
	else if(uType==REG_SZ || uType==REG_EXPAND_SZ)		// Null anhngen
		{
		*pVal=pNew=new zchar[dwLength/sizeof(zchar)+1];
		memcpy(pNew,pData->pData,pData->uSize);

		iSize = dwLength/sizeof(zchar);

		     if(iSize==0     ){pNew[    0]=0;iSize=1;}
		else if(pNew[iSize-1]){pNew[iSize]=0;iSize++;}

		dwLength = iSize*sizeof(zchar);

		iError=ERROR_SUCCESS;
		return true;
		}


	*pVal=new char[dwLength];
	memcpy(*pVal,pData->pData,pData->uSize);
	iError=ERROR_SUCCESS;


return true;
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Holt einen Text in ein CString-Objekt
//	sStr		: Ist das CString-Objekt
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//  Ergibt 'false' bei einem Fehler
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
bool CTxtKeys::Get(CString &sStr,const zchar *pName)
{
zchar *pPtr;
bool   bOk;

	bOk=Get(&pPtr,pName);

	if(pPtr)
		{
		sStr=pPtr;
		delete pPtr;
		}
	else{
		sStr=Z("");
		}


return bOk;
}
#endif

//*****************************************************************************
//*
//*		Set(void*...
//*
//*****************************************************************************
//	Speichert einen Wert in der Registry.
//	pVal		: Zeiger auf den Quellpuffer mit dem Wert.
//	uLen		: Ist die Lnges des Quellpuffers in Byte.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//	uType		: Ist der Typ des Wertes der geholt werden soll.
//					REG_BINARY
//					REG_DWORD
//					...
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Set(const void  *pVal,DWORD uLen,const zchar *pName,DWORD uType)
{
SubData		   *pData;
int				iPos;

	Check();										// Sind Ebenen ok


	if(iOpenMode==CRK_READ)Exit(ERROR_MODE);
	if(!pVal              )Exit(ERROR_DATA);
	if(!pSubData->iLevel  )Exit(ERROR_ACCESS_DENIED);

	if(uType==REG_SZ || uType==REG_EXPAND_SZ)
		{
		uLen=((int)strzlen((zchar*)pVal)+1)*sizeof(zchar);
		}


	iError=ERROR_KEY;

	if(pName!=CRK_NEXT)
		{
		if(!pName)pName=Z("@");
		strzncpy(cName,pName,sizeof(cName)*sizeof(cName[0]));

		iPos=pSubData->pEntries->Find(pName);		// Suchen Wertnamen
		aPos[iLevel]=iPos+1;
		}
	else{
		   iPos =aPos[iLevel];
		if(iPos>=pSubData->pEntries->Count())
			{
			dwLength = 0;
			dwType   = 0;
			return false;
			}

		aPos[iLevel]++;
		}

	if(iPos<0)										// Neuen Wert erzeugen
		{
		iPos=pSubData->pEntries->Add(pName);
		pData=(SubData*)pSubData->pEntries->Data(iPos);
		aPos[iLevel] = iPos+1;
		pData->pData = new char[uLen];
		pData->uSize = uLen;
		}
	else{											// Alten Wert lschen
		pData=(SubData*)pSubData->pEntries->Data(iPos);
		if(uType==pData->uType)
		if(uLen ==pData->uSize)
		if(!memcmp(pVal,pData->pData,uLen))
			{
			iError=ERROR_SUCCESS;
			return true;
			}

		if(pData->uSize!=uLen)						// Andere Gre ?
			{
			delete pData->pData;
			pData->pData=new char[uLen];
			pData->uSize=uLen;
			}
		}

	pData->uType=uType;
	*pIsModified=1;

	memcpy(pData->pData,pVal,pData->uSize);

	iError=ERROR_SUCCESS;



return true;
}


//*****************************************************************************
//*
//*		GetMulti
//*
//*****************************************************************************
//	Einen Multi-String auslesen.
//	pVal		: Zeiger auf den Zielpuffer in dem der Wert gespeichert wird.
//	uLen		: Ist die Lnges des Zielpuffers in Byte.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::GetMulti(zchar *pVal,DWORD uLen,const zchar *pName)
{



	if(!Get(pVal,uLen,pName,REG_MULTI_SZ))
		{
		if(uLen>0)pVal[0]=0;
		if(uLen>1)pVal[1]=0;
		return false;
		}

	if(uLen<2)
		{
		if(uLen==1)pVal[0]=0;
		iError=ERROR_MORE_DATA;
		return false;
		}

	if(pVal[dwLength-1])								// Prfe ob NULL am Ende
		{
		if(dwLength+1>uLen)
			{
			pVal[0]=0;
			pVal[1]=0;
			iError=ERROR_MORE_DATA;
			dwLength=0;
			return false;
			}

		pVal[dwLength]=0;
		dwLength++;
		}

	if(pVal[dwLength-2])								// Prfe ob 2. NULL am Ende
		{
		if(dwLength+1>uLen)
			{
			pVal[0]=0;
			pVal[1]=0;
			iError=ERROR_MORE_DATA;
			dwLength=0;
			return false;
			}

		pVal[dwLength]=0;
		dwLength++;
		}


return true;
}


//*****************************************************************************
//*
//*		GetMulti
//*
//*****************************************************************************
//	Einen Multi-String auslesen und reserviert einen Speicherbereich dafr.
//	pVal		: Hier wird der Zeiger auf den Speicherbereich abgelegt
//				  oder NULL bei einem Fehler.
//	pVal		: Zeiger auf den Zielpuffer in dem der Wert gespeichert wird.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::GetMulti(zchar **pVal,const zchar *pName)
{


	if(!Get((void**)pVal,pName,REG_MULTI_SZ))return false;


return true;
}


//*****************************************************************************
//*
//*		SetMulti
//*
//*****************************************************************************
//	Speichert einen Multi-String in der Registry.
//	pVal		: Zeiger auf den Multi-String.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::SetMulti(const zchar *pVal,const zchar *pName)
{
int iPos;


	for(iPos=0;pVal[iPos];)
		{
		iPos+=(int)strzlen(pVal+iPos)+1;
		}


return SetMulti(pVal,iPos+1,pName);
}

//*****************************************************************************
//*
//*		Del
//*
//*****************************************************************************
//	Lscht einen Schlsselwert. (nicht einen Pfad)
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
// 					Ist pName==CRK_ALL  werden alle Werte gelscht
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::Del(const zchar *pName)
{
int		iCount,iPos;
bool	bExit;


	Check();											// Sind Ebenen ok

	if(iOpenMode==CRK_READ)Exit(ERROR_MODE);

	if(pName==CRK_ALL)
		{
		bExit  = true;
		iCount = ValueCount();

		for(iCount--;iCount>=0;iCount--)
			{
			if(!Del(ValueName(iCount)))bExit=false;
			}

		return bExit;
		}

	if(pName==CRK_NEXT)pName=ValueName(aPos[iLevel]);
	if(pName==NULL    )pName=Z("@");

	iError=ERROR_KEY;

	   iPos=pSubData->pEntries->Find(pName);			// Suchen Wertnamen
	if(iPos<0)return false;

	pSubData->pEntries->Del(iPos);
	iError=ERROR_SUCCESS;


return true;
}

//*****************************************************************************
//*
//*		DelKey
//*
//*****************************************************************************
//	Lscht einen Unterschlssel. (nicht einen Wert) Dabei werden auch
//	weitere Unterschlssel rekursiv gelscht.
// 	pName		: Ist der Name des Wertes der ausgelesen werden soll.
//					Ist pName==NULL     wird der Standard Wert genommen
// 					Ist pName==CRK_NEXT wird der nchste  Wert genommen
// 					Ist pName==CRK_ALL  werden alle Unterschlssel gelscht
//  Ergibt 'false' bei einem Fehler
bool CTxtKeys::DelKey(const zchar *pName)
{
bool	bExit;
int		i,j,iCount,iDelNum=0;



	Check();											// Sind Ebenen ok

	if(pName==CRK_ALL)
		{
		bExit  = true;
		iCount = KeyCount();

		for(iCount--;iCount>=0;iCount--)
			{
			if(!DelKey(KeySubName(iCount)))bExit=false;
			}

		return bExit;
		}

	if(pName==CRK_NEXT)
		{
		pName=KeySubName(aSub[iLevel]);
		}



//******************** Lschen ************************************************
zchar		cBuffer[1024];
SubEntries *pSub;
SubData	   *pData;


	strzncpy(cBuffer,pKeyName,sizeof(cBuffer));
	iCount=(int)strzlen(pKeyName);

	for(i=pKeyNames->Count()-1;i>0;i--)					// Suche alle Unterschlssel
		{
		if(strznicmp(cBuffer,pKeyNames->Get(i),iCount))continue;

		pSub=(SubEntries*)pKeyNames->Data(i);

		for(j=pSub->pEntries->Count()-1;j>0;j--)		// Werte lschen
			{
			pData=(SubData*)pSub->pEntries->Data(j);
			delete pData->pData;
			pSub->pEntries->Del(j);
			}

		delete pSub->pEntries;							// Schlssel lschen
		pKeyNames->Del(i);
		}


	iError=(iDelNum)? ERROR_SUCCESS:ERROR_KEY;


return iError==ERROR_SUCCESS;
}

//*****************************************************************************
//*
//*		ValueCount
//*
//*****************************************************************************
//  Ergibt die Anzahl der Werte im aktuellen Key
int	 CTxtKeys::ValueCount()
{
DWORD	uCount;


	if(iLevel<0)Exit(ERROR_KEY);

	uCount = pSubData->pEntries->Count();
	iError = ERROR_SUCCESS;


return uCount;
}

//*****************************************************************************
//*
//*		KeyCount
//*
//*****************************************************************************
//  Ergibt die Anzahl der SubKeys im aktuellen Key
int	 CTxtKeys::KeyCount()
{
int			iCount,iFound,i;
zchar		cBuffer[1024];
SubEntries *pSub;



	if(iLevel<0)Exit(ERROR_KEY);


	strzncpy(cBuffer,pKeyName,sizeof(cBuffer));
	iCount = (int)strzlen(pKeyName);
	iFound = 0;

	i=pKeyNames->FindFast(pKeyName,0,-1,1)+1;

	for(;i<pKeyNames->Count();i++)						// Suche alle Unterschlssel
		{
		if(strznicmp(cBuffer,pKeyNames->Get(i),iCount))continue;

		   pSub=(SubEntries*)pKeyNames->Data(i);
		if(pSub->iLevel!=pSubData->iLevel+1)break;

		iFound++;
		}

	iError=ERROR_SUCCESS;



return iFound;
}

//*****************************************************************************
//*
//*		ValueName
//*
//*****************************************************************************
//  Ergibt den Namen eines Wertes und speichert ihn in einem Puffer
//	Der Speicherbereich fr den Puffer wird dabei extra angelegt.
//	pName	: Hier wird der Zeiger auf den Puffer abgelegt.
//	iNumber	: Ist die Nummer des Wertes. Bei -1 wird die aktuelle
//			  Position genommen.
//	Ergibt die Lnge des Namens oder 0 bei einem Fehler.
int CTxtKeys::ValueName(zchar **pName,int iNumber)
{
int		 iLen;
zchar	*pPtr;


	pPtr=ValueName(iNumber);

	if(!pPtr){*pName=0;return 0;}

	iLen	 = (int)strzlen(pPtr)+1;
	pName[0] = new zchar[iLen];
	memcpy(pName[0],pPtr,iLen);


return iLen-1;
}

//*****************************************************************************
//*
//*		ValueName
//*
//*****************************************************************************
//  Speichert den Namen eines Wertes in einem Puffer.
//	pName	: Ist der Zeiger auf den Puffer.
//	iSize	: Ist die Gre des Puffers
//	iNumber	: Ist die Nummer des Wertes. Bei -1 wird die aktuelle
//			  Position genommen.
//	Ergibt die Lnge des Namens
int CTxtKeys::ValueName(zchar *pName,int iSize,int iNumber)
{
int		 iLen;
zchar	*pPtr;


		pPtr=ValueName(iNumber);
	if(!pPtr)
		{
		pName[0]=0;
		return 0;
		}

	   iLen=(int)strzlen(pPtr)+1;
	if(iLen>iSize)
		{
		pName[0]=0;
		return 0;
		}

	memcpy(pName,pPtr,iLen);


return iLen-1;
}

//*****************************************************************************
//*
//*		ValueName
//*
//*****************************************************************************
//  Speichert den Namen eines Wertes im internen Namespuffer.
//	iNumber	: Ist die Nummer des Wertes. Bei -1 wird die aktuelle
//			  Position genommen.
//	Ergibt den Zeiger auf den Namen oder NULL bei einem Fehler
zchar *CTxtKeys::ValueName(int iNumber)
{
DWORD	iCount;
zchar  *pPtr;


	if(iLevel<0)Exit(ERROR_KEY);
	if(iNumber==-1)iNumber=aPos[iLevel];

	dwLength = 0;
	iCount   = 256;

	if(iNumber<0 || iNumber>=pSubData->pEntries->Count())
		{
		iError=ERROR_KEY;
		return 0;
		}

	iError	= ERROR_SUCCESS;
	pPtr	= pSubData->pEntries->Get(iNumber);

	strzncpy(cName,pPtr,sizeof(cName));


return cName;
}

//*****************************************************************************
//*
//*		KeySubName
//*
//*****************************************************************************
//  Liest den Namen eines Sub-Schlssels aus.
//	iNumber	: Ist die Nummer des Sub-Schlssels. Bei -1 wird die aktuelle
//			  Position genommen.
//	Ergibt einen Zeiger auf den Namen des Sub-Schlssels oder NULL bei einem Fehler.
zchar *CTxtKeys::KeySubName(int iNumber)
{
int			iCount,i;
zchar		cBuffer[1024],*pPtr;
SubEntries *pSub;



	if(iLevel<0)Exit(ERROR_KEY);
	if(iNumber==-1)iNumber=aSub[iLevel];


	strzncpy(cBuffer,pKeyName,sizeof(cBuffer));
	iCount=(int)strzlen(pKeyName);

	iError=ERROR_KEY;
	if(iNumber<0)return 0;

	i=pKeyNames->FindFast(pKeyName,0,-1,1)+1;

	for(;i<pKeyNames->Count();i++)							// Suche alle Unterschlssel
		{
		pPtr=pKeyNames->Get(i);
		if(strznicmp(cBuffer,pPtr,iCount))break;

		   pSub=(SubEntries*)pKeyNames->Data(i);
		if(pSub->iLevel!=pSubData->iLevel+1)break;

		if(iNumber==0)
			{
				pPtr+=iCount;
			if(*pPtr=='\\')pPtr++;
				iCount=strchar(pPtr,'\\');

			if(iCount>=sizeof(cName))iCount=sizeof(cName)-1;
			memcpy(cName,pPtr,iCount);cName[iCount]=0;
			iError=ERROR_SUCCESS;
			return cName;
			}

		iNumber--;
		}



return 0;
}

//*****************************************************************************
//*
//*		KeySubName
//*
//*****************************************************************************
//  Liest den Namen eines Sub-Schlssels aus, und speichert ihn in einem Puffer
//	Der Speicherbereich fr den Puffer wird dabei extra angelegt.
//	pName	: Hier wird der Zeiger auf den Puffer abgelegt.
//	iNumber	: Ist die Nummer des Sub-Schlssels. Bei -1 wird die aktuelle
//			  Position genommen.
//	Ergibt die Lnge des Namens oder 0 bei einem Fehler.
int	CTxtKeys::KeySubName(zchar **pName,int iNumber)
{
int		 iLen;
zchar	*pPtr;


		pPtr=KeySubName(iNumber);
	if(!pPtr){*pName=0;return 0;}

	iLen	 = (int)strzlen(pPtr)+1;
	pName[0] = new zchar[iLen];
	memcpy(pName[0],pPtr,iLen);


return iLen-1;
}
//*****************************************************************************
//*
//*		KeySubName
//*
//*****************************************************************************
//  Speichert den Namen eines Sub-Schlssels in einem Puffer.
//	pName	: Ist der Zeiger auf den Puffer.
//	uSize	: Ist die Gre des Puffers
//	iNumber	: Ist die Nummer des Sub-Schlssels. Bei -1 wird die aktuelle
//			  Position genommen.
//	Ergibt die Lnge des Namens oder 0 bei einem Fehler.
int	CTxtKeys::KeySubName(zchar *pName,int iSize,int iNumber)
{
int		 iLen;
zchar	*pPtr;


		pPtr=KeySubName(iNumber);
	if(!pPtr){pName[0]=0;return 0;}

	   iLen=(int)strzlen(pPtr)+1;
	if(iLen>iSize){pName[0]=0;return 0;}

	memcpy(pName,pPtr,iLen);


return iLen-1;
}

//*****************************************************************************
//*
//*		KeyName
//*
//*****************************************************************************
//  Holt den Namen eines Pfadteiles des aktuellen Pfades
//	iNumber		: Ist die Nummer des Pfadteiles
//					=0  Pfadteiles von Open(...)
//					>0 	Pfadteiles von Up  (...)
//  Ergibt einen Zeiger auf den Namen
zchar *CTxtKeys::KeyName(int iNumber)
{
zchar *pPtr;
int    i;


	if(iLevel<0)Exit(ERROR_KEY);
	if(iNumber==-1)iNumber=iLevel;

		pPtr=aStr[iNumber];
	if(!pPtr)return 0;


	if(iLevel==0)								// Pfad ohne HKEY_... zurckgeben
		{
		if(!strznicmp(pPtr,Z("HKEY_"),5))
			{
			pPtr+=strchar(pPtr,'\\');
			if(pPtr[0]=='\\')pPtr++;
			}
		return pPtr;
		}

	i=(int)strzlen(pPtr);						// Letzten Unterpfad zurckgeben
	for(;i>0;i--)if(pPtr[i]=='\\')break;
	if(pPtr[i]=='\\')i++;



return pPtr+i;
}


//*****************************************************************************
//*
//*		KeyName
//*
//*****************************************************************************
//  Speichert den Namen eines Pfadteiles des aktuellen Pfades, in einem Puffer.
//	pName	: Ist der Zeiger auf den Puffer.
//	iSize	: Ist die Gre des Puffers
//	iNumber	: Ist die Nummer des Pfadteiles
//				=0  Pfadteiles von Open(...)
//				>0 	Pfadteiles von Up  (...)
//	Ergibt die Lnge des Namens
int CTxtKeys::KeyName(zchar *pName,int iSize,int iNumber)
{
int		 iLen;
zchar	*pPtr;


		pPtr=KeyName(iNumber);
	if(!pPtr){pName[0]=0;return 0;}

	   iLen=(int)strzlen(pPtr)+1;
	if(iLen>iSize){pName[0]=0;return 0;}

	memcpy(pName,pPtr,iLen);


return iLen-1;
}

//*****************************************************************************
//*
//*		KeyName
//*
//*****************************************************************************
//  Speichert den Namen eines Pfadteiles des aktuellen Pfades, in einem Puffer.
//	Der Speicherbereich fr den Puffer wird dabei extra angelegt.
//	pName	: Hier wird der Zeiger auf den Puffer abgelegt.
//	iNumber	: Ist die Nummer des Pfadteiles
//				=0  Pfadteiles von Open(...)
//				>0 	Pfadteiles von Up  (...)
//	Ergibt die Lnge des Namensint CRegKeys::KeyName(zchar **pName,int iNumber)
int CTxtKeys::KeyName(zchar **pName,int iNumber)
{
int		 iLen;
zchar	*pPtr;


		pPtr=KeyName(iNumber);
	if(!pPtr){*pName=0;return 0;}

	iLen     = (int)strzlen(pPtr)+1;
	pName[0] = new zchar[iLen];
	memcpy(pName[0],pPtr,iLen);


return iLen-1;
}

//*****************************************************************************
//*
//*		RegPath
//*
//*****************************************************************************
//	Erzeugt den Standartpfad --> "Software\m_pszRegistryKey\m_pszAppName\Name"
//	und speichert ihn in einem Puffer
//	pPath	: Ist der Zeiger auf den Puffer
//	iLen	: Ist die Gre des Puffers
//	pName	: Ist der Unterpfad der an den Standartpfad angehngt wird.
//			  Bei NULL wird kein Unterpfad angehngt.
//	Ergibt die Lnge des erzeuten Pfades.
int CTxtKeys::RegPath(zchar *pPath,int iLen,const zchar *pName)
{
const zchar	   *pTemp1,*pTemp2;


	if(iLen<=0)return 0;

	#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	pTemp1=AfxGetApp()->m_pszRegistryKey;
	pTemp2=AfxGetApp()->m_pszAppName;
	#else
	pTemp1=Z("");
	pTemp2=Z("");
	#endif
				strzncpy(pPath,Z("Software"),iLen);			// Pfad erstellen
	if( pTemp1){strzncat(pPath,Z("\\")	    ,iLen);
				strzncat(pPath,pTemp1	    ,iLen); }
	if( pTemp2){strzncat(pPath,Z("\\") 	    ,iLen);
				strzncat(pPath,pTemp2	    ,iLen); }
	if( pName ){strzncat(pPath,Z("\\") 	    ,iLen);
				strzncat(pPath,pName 	    ,iLen); }

	pPath[iLen-1]=0;



return (int)strzlen(pPath);
}

//*****************************************************************************
//*
//*		Path
//*
//*****************************************************************************
// 	Speichert den aktuellen Schlsselpfad in einem Puffer
//	pMem		: Ist der Zeiger auf den Puffer
//	iLen		: Ist die Lnge des Puffers
//	iMode		: 0 = Gesamten Pfad mit  HKEY_... speichern
//				  1 = Gesamten Pfad ohne HKEY_... speichern
//				  2 = Pfad ab Ebene 0 speichern
//	Ergibt die Lnge des Pfades in Zeichen bzw. -1 bei einem Fehler
int	CTxtKeys::Path(zchar *pMem,int iLen,int iMode)
{
int		 i;
zchar   *pPtr;


	if(iLen  <=0)return -1;
	pMem[0]=0;
	if(iLevel< 0)return -1;

	pPtr=pKeyName;

	if(iMode>1)
		{
			pPtr+=(int)strzlen(aStr[0]);
		if(*pPtr=='\\')pPtr++;
		}

	if(iMode==1 && !strznicmp(pPtr,Z("HKEY_"),5))
		{
			pPtr+=strchar(pPtr,'\\');
		if(*pPtr=='\\')pPtr++;
		}

	   i=(int)strzlen(pPtr);
	if(i+1>iLen)i=iLen-1;

	memcpy(pMem,pPtr,i);
	pMem[i]=0;


return i;
}

//*****************************************************************************
//*
//*		GetInitKey
//*
//*****************************************************************************
//	Einen Init-Key holen der zu einem Pfad passt
//	hKey	: Hier wird der gefundene Init-Key abgelegt.
//	pPath	: Ist der Pfad nach dem gesucht wird. Vom Pfad wird nur das
//			  erste Segment (..1...\xxxxxx\yyyyyy) verglichen.
//	Ergibt die Lnge des ersten Segmentes mit Backslash, bzw. 0 bei einem Fehler.
int CTxtKeys::GetInitKey(HKEY hKey,zchar *pPath)
{
int		i;


	for(i=0;pRootName[i];i++)
		{
		if(hKey!=hRootKeys[i])continue;

		strzcpy(pPath,pRootName[i]);
		return (int)strzlen(pPath);
		}

	strzcpy(pPath,Z("HKEY_CURRENT_USER"));


return (int)strzlen(pPath);
}


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
#ifdef		_DEBUG

bool  CTxtKeys::Open(){return Open(HKEY_CURRENT_USER,0,CRK_CREATE);}
bool  CTxtKeys::Open(const zchar *pPath,int iMode){return Open(0,pPath,iMode);}
int   CTxtKeys::Ebene(){        return iLevel      ;}
bool  CTxtKeys::Next (){        return Up(CRK_NEXT);}
bool  CTxtKeys::Jump (){Down(); return Up(CRK_NEXT);}

bool  CTxtKeys::SetMulti(const zchar   *pVal,DWORD uLen,const zchar *pName){return Set(pVal,uLen,pName,REG_MULTI_SZ);}
bool  CTxtKeys::Set(           int      iVal,const zchar *pName){return Set((const void*)&iVal,sizeof(iVal),pName,REG_DWORD);}
bool  CTxtKeys::Set(const      zchar   *pVal,const zchar *pName){return Set((const void*) pVal,sizeof(pVal),pName,REG_SZ   );}
bool  CTxtKeys::Set(const      zcharu  *pVal,const zchar *pName){return Set((const void*) pVal,sizeof(pVal),pName,REG_SZ   );}

bool  CTxtKeys::Get(           int     &iVal,const zchar *pName){return Get((void*)&iVal,sizeof(iVal)  ,pName,REG_DWORD);}
bool  CTxtKeys::Get(unsigned   int     &uVal,const zchar *pName){return Get((void*)&uVal,sizeof(uVal)  ,pName,REG_DWORD);}
bool  CTxtKeys::Get(           long    &lVal,const zchar *pName){return Get((void*)&lVal,sizeof(lVal)  ,pName,REG_DWORD);}
bool  CTxtKeys::Get(unsigned   long    &uVal,const zchar *pName){return Get((void*)&uVal,sizeof(uVal)  ,pName,REG_DWORD);}
bool  CTxtKeys::Get(           zchar   *pVal,const zchar *pName){return Get((void*) pVal,256           ,pName,REG_SZ   );}
bool  CTxtKeys::Get(           zcharu  *pVal,const zchar *pName){return Get((void*) pVal,256           ,pName,REG_SZ   );}
bool  CTxtKeys::Get(           zchar  **pVal,const zchar *pName){return Get((void**)pVal,               pName,REG_SZ   );}
bool  CTxtKeys::Get(           zcharu **pVal,const zchar *pName){return Get((void**)pVal,               pName,REG_SZ   );}
bool  CTxtKeys::Get(           zchar   *pVal,DWORD uLen,const zchar *pName){return Get((void*)pVal,uLen,pName,REG_SZ   );}
bool  CTxtKeys::Get(           zcharu  *pVal,DWORD uLen,const zchar *pName){return Get((void*)pVal,uLen,pName,REG_SZ   );}

DWORD CTxtKeys::Type (){return  dwType  ;}
DWORD CTxtKeys::Len  (){return  dwLength;}
HKEY  CTxtKeys::Key  (){return  hKeyNow ;}
int   CTxtKeys::Error(){return  iError  ;}
zchar*CTxtKeys::Name (){return  cName   ;}

#if defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
bool CTxtKeys::Set(CString  sStr,const zchar *pName){return Set((const void*)((LPCTSTR)sStr),sStr.GetLength( ),pName,REG_SZ);}
#endif

#endif

//*****************************************************************************
//*
//*		HexToInt
//*
//*****************************************************************************
//	Wandelt einen Hex-Text in eine Zahl um
//	pHex		: Zeiger auf den Text
//	pLen		: Hier wird die Anzahl der verarbeiteten Zeichen gespeichert
//				  Wenn NULL wird nicht gespeichert.
//	Ergibt den Wert der umgewantelten Zahl.
int CTxtKeys::HexToInt(const char *pHex,int *pLen)
{
int		iVal=0;
char	cChar;



	if(pLen)pLen[0]=0;

	for(;;)
		{
		cChar=*pHex;

		if(cChar>='0' && cChar<='9')
			{
			iVal<<=4;
			iVal+=cChar-'0';
			pHex++;
			if(pLen)pLen[0]++;
			continue;
			}

		if(cChar>='a' && cChar<='f')
			{
			iVal<<=4;
			iVal+=cChar-'a'+10;
			pHex++;
			if(pLen)pLen[0]++;
			continue;
			}

		if(cChar>='A' && cChar<='F')
			{
			iVal<<=4;
			iVal+=cChar-'A'+10;
			pHex++;
			if(pLen)pLen[0]++;
			continue;
			}

		return iVal;
		}


return 0;
}


//*****************************************************************************
//*
//*		MemToStr
//*
//*****************************************************************************
//	Wandelt einen Speicherbereich in einen Text um. Dabei wird am
//	Anfang und am Ende wird ein Anfhrungszeichen eingefgt.
//	Zeichen wie '\n' und '\r' '\\' '\"' werden in Escape-Folgen umgewandelt.
//	pText		: Zeiger auf den Puffer in dem der Text abgelegt wird.
//	iMax		: Ist die Gre des Textpuffers in Zeichen.
//	pMem		: Zeiger auf den Speicherbereich der umgewandelt werden soll.
//	iSize		: Lnge des Speicherbereiches in Byte.
//	Ergibt die Lnge des Texstes ohne Nullzeichen.
int CTxtKeys::MemToStr(char *pText,int iMax,const char *pMem,int iSize)
{
int				iLen=0,iAll;
unsigned char	ucByte;


	iAll=iMax;
	iMax--;

	while(iLen<iSize)
		{
		if(iMax<=2)break;

		ucByte=pMem[iLen];iLen++;

		if(ucByte!='\"' && ucByte!='\r' && ucByte!='\\' && ucByte!='\n')
			{
			pText[0]=ucByte;
			pText++;
			iMax--;
			continue;
			}

		if(iMax<=2)break;

 		pText[0]='\\';
		pText++;
		iMax--;

		if(ucByte=='\\')pText[0]='\\';
		if(ucByte=='\"')pText[0]='\"';
		if(ucByte=='\r')pText[0]='r' ;
		if(ucByte=='\n')pText[0]='n' ;

		pText++;
		iMax--;
		}


	   iMax++;
	if(iMax>0)pText[0]=0;



return iAll-iMax;
}


//*****************************************************************************
//*
//*		StrToMem
//*
//*****************************************************************************
//	Wandelt einen Text in einen Speicherbereich um. Dabei werden Escapefolgen
//	im Text wie // /n /r /" werden bercksichtigt. Wenn der Text mir einem
//	Anfhrungszeichen anfngt, so werden diese automatisch entfernt.
//	pMem		: Zeiger auf den Puffer in dem der Speicherbereich abgelegt wird.
//	iMax		: Ist die Gre des Puffers in Byte
//	pText		: Zeiger auf den Text.
//	Ergibt die Lnge des umgewandelten Speicherbereiches.
int	CTxtKeys::StrToMem (char *pMem,int   iMax,const char *pText)
{
int			iLen=0,iStop=0;
char		cChar;


	if(*pText=='\"'){iStop=1;pText++;}				// Anfhrungszeichen entfernen

	while(iLen<iMax)
		{
			cChar=*pText;
		if(!cChar)break;
		if( cChar=='\"' && iStop)break;
		if( cChar=='\\')							// Escapefolgen
			{
			if(pText[1]=='\\' || pText[1]=='\"')
				{
				pText++;
				cChar=*pText;
				}
			else if(pText[1]=='r')
				{
				pText++;
				cChar='\r';
				}
			else if(pText[1]=='n')
				{
				pText++;
				cChar='\n';
				}
			}

		pMem[iLen]=cChar;
		pText++;
		iLen++;
		}


return iLen;
}

//*****************************************************************************
//*
//*		IntToHex
//*
//*****************************************************************************
//	Wandelt eine Zahl in einen Hexadezimal-Text um
//	iValue		: Ist die Zahl die umgewandelt werden soll.
//	pText		: Puffer in dem der Text abgelegt werden soll.
//	iLen		: Ist die Lnge in Zeichen die der Text haben soll
void CTxtKeys::IntToHex(int iValue ,char *pText,int iLen)
{

	iLen *= 4;
	iLen -= 4;

	for(;iLen>=0;iLen-=4)
		{
		*pText="0123456789ABCDEF"[(iValue>>iLen)&0x0F];
		 pText++;
		}

	*pText=0;

}



//*****************************************************************************
//*
//*		CreateFileName
//*
//*****************************************************************************
//	Erzeugt den Dateinamen fr die REG-Datei aus einem Spezialnamen mit #*?
void CTxtKeys::CreateFileName()
{
DWORD	 uSize;
int		 iLen,iPos=0;
zchar   *pPtr;


	if(pFileName[0])return;								// Ist der Dateinamen vorhanden


	pPtr=cRegNameUsed;


	if(pPtr[0]=='#')									// Exe-Pfad an den Anfang ?
		{
  		iPos=GetModuleFileName(GetModuleHandle(0),pFileName,MAX_PATH);
		for(;iPos>0;iPos--)
			{
			if(pFileName[iPos-1]=='\\')break;
			if(pFileName[iPos-1]=='/' )break;
			}
		pPtr++;
		}


	while(*pPtr)
		{
		iLen=strcwlen(pPtr,0x01800000);					// Suche "*?"
		if(iPos+iLen+1>=MAX_PATH)						// Zu langer Pfad ?
			{
			pFileName[0]='\\';
			iPos=1;
			break;
			}

		memcpy(pFileName+iPos,pPtr,iLen);
		pPtr+=iLen;
		iPos+=iLen;

		switch(*pPtr)									// User- oder Computernamen
				{
		case'*':uSize=MAX_PATH-iPos-1;
				GetUserName(pFileName+iPos,&uSize);
				iPos+=uSize;
				pPtr++;
				break;

		case'?':uSize=MAX_PATH-iPos-1;
				GetComputerName(pFileName+iPos,&uSize);
				iPos+=uSize;
				pPtr++;
				break;
				}
		}


	pFileName[iPos]=0;

}

//*****************************************************************************
//*
//*		OpenText
//*
//*****************************************************************************
//	Ld die Textdatei mit den Registry-Daten.
//	Ergibt 1 wenn Datei geladen wurde sonst 0
int CTxtKeys::OpenText()
{
SubEntries		 pSubData;
SubData			 sDat,*pDat;
FILE			*pFile;
zchar		    *pTxt,*pName;
char			 cBuffer[4096],cName[256],*pPtr,*pMem=0;
int				 i,iNum,iLen,iVal,iType,iMemLen,iDataLen;



	*pIsLoad=1;
	*pIsModified=0;

	CreateFileName();

		pFile=fzopen(pFileName,Z("rb"));
	if(!pFile)return 0;

	cBuffer[sizeof(cBuffer)-1]=0;


	while(fgets(cBuffer,sizeof(cBuffer)-1,pFile))		// Prfe Signatur
		{
			pPtr=cBuffer+strwlen(cBuffer,0xE0);			// berspringe " \t\n\r"
		if(!pPtr[0])continue;							// Leerzeile
		if(!strnicmp(pPtr,"REGEDIT4",8))
			{
				pPtr+=8;
				pPtr+=strwlen(pPtr,0xE0);				// berspringe " \t\n\r"
			if(!pPtr[0])break;
			}

		fclose(pFile);
		return 0;
		}


//******************** Haupschleife *******************************************


	pSubData.pEntries=0;
	pSubData.iTemp   =0;


	while(fgets(cBuffer,sizeof(cBuffer)-1,pFile))		// Zeilen laden
		{
			pPtr=cBuffer+strwlen(cBuffer,0xE0);			// berspringe " \t\n\r"
		if(!pPtr[0])continue;							// Leerzeile
		if( pPtr[0]=='[')								// Neuer Schlssel
			{
			if(pSubData.pEntries)
				{
				pSubData.pEntries->Sort();
				pSubData.pEntries=0;
				}

			pPtr++;
			iLen=strchar(pPtr,']');
			if(!pPtr[iLen] || !iLen)continue;

			pSubData.pEntries=new CStringChain;
			pSubData.pEntries->DataLength(sizeof(sDat));
			pSubData.iLevel=0;

			for(i=0;i<iLen;i++)if(pPtr[i]=='\\')pSubData.iLevel++;

			pKeyNames->Add(iLen,C(pPtr),CSC_END,&pSubData);

			continue;
			}

		if(!pSubData.pEntries)continue;					// Kein Schlssel aktiv

		pPtr+=strwlen(pPtr,0xE0);						// berspringe " \t\n\r"

		if(pPtr[0]=='\"')								// Namen laden
			{
			   pPtr++;iLen=strcwlen(pPtr,0x0140);		// Suche "\"\n\r"
			if(pPtr[iLen]!='"' || iLen>=sizeof(cName))continue;
			memcpy(cName,pPtr,iLen);cName[iLen]=0;
			pPtr+=iLen+1;
			}
		else{
			if(pPtr[0]!='@' )continue;
			cName[0]='@';
			cName[1]= 0;
			pPtr++;
			}

		pName = C(cName);

		   i=pSubData.pEntries->Find(pName);			// Doppel Namen verhindern
		if(i>=0)
			{
			pDat=(SubData*)pSubData.pEntries->Data(i);
			delete pDat->pData;
			pSubData.pEntries->Del(i);
			}

			pPtr+=strcspn(pPtr,"=\n\r");				// Suche '=' Zeichen
		if( pPtr[0]!='=')continue;
			pPtr++;pPtr+=strwlen(pPtr,0xA0);			// berspringe Leeerzeichen



		if(!strnicmp(pPtr,"dword:",6))					// Zahl einlesen
			{
			pPtr+=6;
			pPtr+=strwlen(pPtr,0xA0);					// Leerzeichen berspringen

			sDat.uSize=4;
			sDat.uType=REG_DWORD;
			sDat.pData=new char[4];

			*(int*)sDat.pData=HexToInt(pPtr);

			pSubData.pEntries->Add(pName,CSC_END,&sDat);
			continue;
			}


		if(!strnicmp(pPtr,"hex",3))						// Hex-Dump einlesen
			{
			   pPtr+=3;
			   iType =(pPtr[0]!='(')? 0:atoi(pPtr+1);
			   pPtr+=strcwlen(pPtr,0x00400040);			// Suche ":\n\r"
			if(pPtr[0]!=':')continue;

			pPtr++;
			pPtr+=strwlen(pPtr,0xA0);					// Leerzeichen berspringen
			iMemLen =0;
			iDataLen=0;

			for(;;) 									// HEX-Dump scanen
				{
				iVal=HexToInt(pPtr,&iLen);

				if(iLen==0)
					{
					   pPtr+=strwlen(pPtr,0xA0);		// Leerzeichen berspringen
					if(pPtr[0]!='\\')break;
					if(!fgets(cBuffer,sizeof(cBuffer)-1,pFile))break;
					pPtr=cBuffer+strwlen(cBuffer,0xA0);
					continue;
					}

				pPtr+=iLen;

				if(iDataLen>=iMemLen)BUFFER_ADD(pMem,iMemLen);

				pMem[iDataLen]=iVal;
					 iDataLen++;

				pPtr+=strspn(pPtr,", \t");
				}

			if(!pMem)pMem=new char[4];


			if(iType==REG_SZ || iType==REG_EXPAND_SZ || iType==REG_MULTI_SZ)
				{
				#ifndef UNICODE
				iDataLen &= ~1;

				for(i=0;i<iDataLen;i+=2)				// Texte von Unicode auf ANSI
					{
					if(pMem[i+1])
							pMem[i/2]='\xFF';
					else	pMem[i/2]=pMem[i+1];
					}

				iDataLen/=2;
				#endif

				pTxt	  = (zchar*)pMem;
				iDataLen /=	sizeof(zchar);

				if(iType==REG_MULTI_SZ)					// Doppelnullzeichen am Ende berprfen
					{
					if(iDataLen<=0)
						{
						iDataLen = 2;
						pTxt[0]  = 0;
						pTxt[1]  = 0;
						}
					else if(iDataLen==1)
						{
						pTxt[1]  = 0;
						iDataLen = 2;

						if(pTxt[0])
							{
							pTxt[2]  = 0;
							iDataLen = 3;
							}
						}
					else if(pTxt[iDataLen-1])
						{
						pTxt[iDataLen  ] = 0;
						pTxt[iDataLen+1] = 0;
						iDataLen        += 2;
						}
					else if(pTxt[iDataLen-2])
						{
						pTxt[iDataLen  ] = 0;
						iDataLen        += 1;
						}
					}
				else{									// Nullzeichen am Textende berprfen
					if(iDataLen<=0)
						{
						iDataLen = 1;
						pTxt[0]  = 0;
						}
					else{
						if(pTxt[iDataLen-1])
							{
							pTxt[iDataLen] = 0;
							iDataLen++;
							}
						}
					}
				}


			sDat.uSize = iDataLen*sizeof(zchar);;
			sDat.uType = iType;
			sDat.pData = pMem;

			pMem = 0;

			pSubData.pEntries->Add(pName,CSC_END,&sDat);
			continue;
			}


		if(pPtr[0]=='\"')								// Text einlesen
			{
			pPtr++;
			iLen=(int)strlen(pPtr);
			for(;iLen>0;iLen--)if(pPtr[iLen]=='"' )break;

			pPtr[iLen]=0;

			pMem=new char [(iLen+1)*sizeof(zchar)];
			iLen=StrToMem(pMem,iLen,pPtr);
			pMem[iLen]=0;
			iLen++;

			#ifdef UNICODE

			for(i=iLen-1;i>=0;i--)						// Ansi in Unicode umwandeln
				{
				pMem[iLen*2  ] = pMem[iLen];
				pMem[iLen*2+1] = 0;
				}

			iLen *= 2;

			#endif

			sDat.uSize=iLen;
			sDat.uType=REG_SZ;
			sDat.pData=pMem;
			pMem=0;

			pSubData.pEntries->Add(pName,CSC_END,&sDat);
			continue;
 			}
		}


	pKeyNames->Sort();
	fclose(pFile);


	for(iNum=0;iNum<pKeyNames->Count();iNum++)			// Root Eintrge ergnzen
		{
		pTxt=pKeyNames->Get(iNum);
		iLen=pKeyNames->Len(iNum);

		for(i=iLen;i>0;i--)
			{
			zchar cTemp[260];
			if(pTxt[i]!='\\')continue;
			if(pKeyNames->FindFast(i,pTxt,0,-1,1)>=0)break;

			CTxtKeys iTemp;

			memcpy(cTemp,pTxt,i);cTemp[i]=0;
			iTemp.Create(NO_SUB_CREATE,cTemp);
			iNum++;
			}
		}



return 1;
}


//*****************************************************************************
//*
//*		SaveText
//*
//*****************************************************************************
//	Speichert die Textdatei mit den Infos
//	iMode 0	: Nur speichern wenn es nderungen gab
//		 1	: Immer speichern
//	Ergibt 1 wenn Datei gespeichert wurde sonst 0
int CTxtKeys::SaveText(int iMode)
{
SubEntries	*pSub;
SubData		*pDat;
FILE		*pFile;
zchar		 cFileNew[MAX_PATH];
zchar		 cFileOld[MAX_PATH];
char		 cBuffer[512+4],*pPtr,*pBin;
int			 iCount,iPos,iLen,iKeyNum,iNum,iAdd,i;



	if(!*pIsModified && !iMode)return 2;

	CreateFileName();

	strzncpy(cFileNew,pFileName,sizeof(cFileNew));
	cFileNew[sizeof(cFileNew)-5]=0;
	strzcat (cFileNew,Z(".new"));


	   pFile=fzopen(cFileNew,Z("wb"));					// Neue Datei erzeugen
	if(pFile==0)return 0;

	   iLen=fprintf(pFile,"REGEDIT4");
	if(iLen<0)goto Exit;


	for(iKeyNum=0;iKeyNum<pKeyNames->Count();iKeyNum++)
		{
		   pSub=(SubEntries*)pKeyNames->Data(iKeyNum);
		if(pSub->iTemp && pSub->pEntries->Count()==0)	// Nur ein Temporrer Eintrag
			{
			continue;
			}

		   iLen=fprintf(pFile,"\r\n\r\n[%s]",pKeyNames->Get(iKeyNum));
		if(iLen<0)goto Exit;

		for(iNum=0;iNum<pSub->pEntries->Count();iNum++)
			{
			pDat=(SubData*)pSub->pEntries->Data(iNum);
			pPtr=A(        pSub->pEntries->Get (iNum));
			pBin=          pDat->pData;
			iAdd=0;


			if(pPtr[0]=='@' && pPtr[1]==0)				// Wert-Namen speichern
					iLen=fprintf(pFile,"\r\n@=");
			else	iLen=fprintf(pFile,"\r\n\"%s\"=",pPtr);

			if(iLen<=0)goto Exit;

			switch(pDat->uType)							// Werte speichern
				{
			case REG_DWORD:	IntToHex(*(int*)pBin,cBuffer,8);

							   iLen=fprintf(pFile,"dword:%s",cBuffer);
							if(iLen<=0)goto Exit;
							break;

			case REG_SZ:	   iLen=fprintf(pFile,"\"");
							if(iLen<=0)goto Exit;

							iCount=pDat->uSize-sizeof(zchar);

							#ifdef UNICODE

							   iCount &= ~1;
							if(iCount>sizeof(cBuffer)-4)goto SaveAsHex;

							pPtr = cBuffer+sizeof(cBuffer);

							for(i=0;i<iCount;i+=2)		// Von Wide auf Ansi
								{
								if(pBin[i+1])goto SaveAsHex;

								pPtr--;
								pPtr[0] = pBin[i];
								}

							pBin	= pPtr;
							iCount /= 2;

							#else

							if(iCount>sizeof(cBuffer)/2-2)goto SaveAsHex;

							#endif

							i=MemToStr(cBuffer,sizeof(cBuffer),pBin,iCount);
							cBuffer[i]=0;

							   iLen=fprintf(pFile,"\"%s\"",cBuffer);
							if(iLen<=0)goto Exit;
							break;


			case REG_EXPAND_SZ:
			case REG_MULTI_SZ:
			SaveAsHex:

							#ifndef UNICODE
							iAdd = 1;
							#endif

			default:		if(pDat->uType)
									iLen=fprintf(pFile,"hex(%i):",pDat->uType);
							else	iLen=fprintf(pFile,"hex:"    ,pDat->uType);
							if(iLen<=0)goto Exit;

							iPos	= (int)strlen(pPtr)+3+iLen;
							iCount	= pDat->uSize-1;

							for(i=0;i<iCount;i++)
								{
								IntToHex(pBin[i],cBuffer,2);
								iLen=fprintf(pFile,"%s,%s",cBuffer,(iAdd)? "00,":"");
								iPos+=3;

								if(iLen<=0)goto Exit;
								if(iPos<77)continue;

								   iLen=fprintf(pFile,"\\\r\n  ");
								if(iLen<=0)goto Exit;
								iPos=2;
								}

							if(i<(int)pDat->uSize)
								{
								IntToHex(pBin[i],cBuffer,2);

								   iLen=fprintf(pFile,"%s%s",cBuffer,(iAdd)? ",00":"");
								if(iLen<=0)goto Exit;
								}
				}
			}
		}


	fclose(pFile);


//******************** Files austauschen **************************************



	strzncpy(cFileOld,pFileName,sizeof(cFileOld));
			 cFileOld[sizeof(cFileOld)-5]=0;
	strzcat (cFileOld,Z(".old"));

	   rezmove(cFileOld);
	if(rezname(pFileName,cFileOld ))					// Alte Datei zu "*.old"
		{
		if(rezname(cFileNew ,pFileName))return 0;		// Vieleicht war alte nicht forhanden
		*pIsModified=0;
		return 1;
		}

	if(rezname(cFileNew ,pFileName))					// Neue Datei umbenennen zu "*.trg"
		{
		rezname(cFileOld,pFileName);					// Alte Datei zurck holen
		return 0;
		}


	*pIsModified=0;


return 1;


Exit:

	fclose (pFile);
	rezmove(cFileNew);


return 0;
}


//*****************************************************************************
//*
//*		AnsiToWide
//*
//*****************************************************************************
//	Wandelt einen ANSI-Text in einen Unicode-Text um
//	pText	: Ist der Zeiger auf den ANSI-Text
//	Ergibt eine Zeiger auf den Unicode-Text
#ifdef UNICODE
wchar_t *CTxtKeys::AnsiToWide(const char *pText)
{
int				iLen;
unsigned		uPos;
unsigned		uEnd;
unsigned char 	ucChar;



	iLen = strlen(pText);

	if(iLen>sizeof(uWideBuffer)/sizeof(uWideBuffer[0])/2)
		{
		return (wchar_t*)L"???";
		}

	uEnd = uWidePos+iLen+1;
	uPos = uWidePos;

	if(uEnd>=sizeof(uWideBuffer)/sizeof(uWideBuffer[0]))
		{
		uWidePos = iLen+1;
		uPos	 = 0;
		}
	else{
		uWidePos = uEnd;
		}


	for(;iLen>=0;iLen--)
		{
		ucChar			  = pText[iLen];
		uWideBuffer[uEnd] = ucChar;
		uEnd--;
		}


return	uWideBuffer+uPos;
}
#endif

//*****************************************************************************
//*
//*		WideToAnsi
//*
//*****************************************************************************
//	Wandelt einen Unicode-Text in einen ANSI-Text um
//	pText	: Ist der Zeiger auf den Unicode-Text
//	Ergibt eine Zeiger auf den ANSI-Text
#ifdef UNICODE
char *CTxtKeys::WideToAnsi(const wchar_t *pText)
{
char		   *pOut;
int				iLen;
int				iNum;
unsigned		uPos;
unsigned		uEnd;
unsigned short 	uChar;



	iLen = wcslen((wchar_t*)pText);

	if(iLen>sizeof(uWideBuffer)/sizeof(uWideBuffer[0]))
		{
		return "???";
		}

	uEnd = uWidePos+(iLen+2)/2;
	uPos = uWidePos;

	if(uEnd>=sizeof(uWideBuffer)/sizeof(uWideBuffer[0]))
		{
		uWidePos = iLen+1;
		uPos	 = 0;
		}
	else{
		uWidePos = uEnd;
		}

	pOut = (char*)(uWidePos+uPos);


	for(iNum=0;iNum<=iLen;iNum++)
		{
		   uChar = pText[iNum];
		if(uChar>0xFF)uChar=0xFF;
		pOut[iNum]=(char)uChar;
		}


return	pOut;
}
#endif

