//*****************************************************************************
//*
//*
//*		Implementierung der Klasse CTxtKeys
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//	bool Close ();											// Schliet Schlssel
//	bool Open  (HKEY  hKey=HKEY_CURRENT_USER,				// ffnet Schlssel
//				char *pPath=0,								
//				int   iMode=CRK_CREATE);					
//	bool Open  (char *pPath=0,								
//				int   iMode=CRK_CREATE);					
//	bool Create(char *pPath);								// Erzeugt Unterschlssel
//	bool Create(HKEY  hKey=HKEY_CURRENT_USER,				// Erzeugt Schlssel
//				char *pPath=0);								
//	bool Up	   (char *pPath=CRK_NEXT,int iOnlyIfExist=0);	// Pfad aufsteigen
//	bool Down  ();											// Pfad aufabsteigen
//	bool Next  ();											// Nchsten Unterschlssel ffnen
//	bool First ();											// Zum ersten Unterschlssel
//															
//															// Werte auslesen
//	bool Get(         int   &iVal,char *pName=CRK_NEXT);
//	bool Get(unsigned int   &uVal,char *pName=CRK_NEXT);
//	bool Get(         long  &lVal,char *pName=CRK_NEXT);
//	bool Get(unsigned long  &uVal,char *pName=CRK_NEXT);
//	bool Get(		  char **pVal,char *pName=CRK_NEXT);
//	bool Get(unsigned char **pVal,char *pName=CRK_NEXT);
//	bool Get(         void **pVal,char *pName=CRK_NEXT,DWORD uType=REG_BINARY);
//	bool Get(		  char  *pVal,char *pName=CRK_NEXT);
//	bool Get(unsigned char  *pVal,char *pName=CRK_NEXT);
//	bool Get(		  void  *pVal,DWORD Len,char *pName=CRK_NEXT,DWORD uType=REG_NONE);
//
//															// Werte schreiben
//	bool Set(         int    iVal,char *pName=CRK_NEXT);
//	bool Set(         char  *pVal,char *pName=CRK_NEXT);
//	bool Set(unsigned char  *pVal,char *pName=CRK_NEXT);
//	bool Set(		  void  *pVal,DWORD Len,char *pName=CRK_NEXT,DWORD uType=REG_NONE);
//
//	bool Del   (char *pName=CRK_NEXT);						// Wert lschen
//	bool DelKey(char *pName=CRK_NEXT);						// Key  lschen
//															
//															
//	int		Path(char *,int,int iMode=0);					// Ergibt Pfad
//	DWORD	Type ();										// Ergibt Type  der Werte
//	DWORD	Len  ();										// Ergibt Lnge der Werte
//	HKEY	Key  ();	     								// Ergibt Aktuellen Schlssel
//	int		Error();										// Ergibt letzten Fehler
//	char   *Name ();										// Ergibt Name
//															
//	int	    ValueCount();									// Ergibt Werte Anzahl
//	char   *ValueName (int iNr=-1);							// Ergibt Wert-Namen
//	int	    KeyCount  ();									// Ergibt Anzahl der SubKeys
//	char   *KeySubName(int iNr=-1);							// Ergibt SubKey-Namen
//	char   *KeyName   (int iNr=-1);							// Ergibt Key-Namen
//
//	int     RegPath(char *pPath,int iLen,char *pName=0);	// Ergibt Standard Pfad
//
//	int	    OpenText(const char *pName=0);					// Textdatei laden
//	int     SaveText(int iMode=0);							// Textdatei speichern


#ifndef		__TXTKEYS_H__
#define     __TXTKEYS_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#if		_MSC_VER > 1299
	#ifndef		WINVER 
	#define		WINVER 	0x0501 
	#endif 	
	#endif 	
	#include	<Afx.h>
	#include	<AfxWin.h>
#else
	#include	<Windows.h>
#endif

#include	"StringChain.h"

#ifdef		zchar
#undef 		zchar
#endif 	

#ifdef		UNICODE												
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	zcharu		short 
#else 		
#define 	Z(a)		a
#define 	zchar		char 
#define 	zcharu		unsigned char 
#endif 	


#ifndef 	__REGKEYS_H__
#define		ERROR_KEY		0x5815							// Fehler wenn Keys nicht offen
#define		ERROR_LIMIT		0x5816							// Fehler wenn zuviele Keys offen
#define		ERROR_MODE		0x5817							// Zugriffs-Modus Fehler
#define		ERROR_DATA		0x5818							// Falscher Datenzeiger
														
#define		CRK_KEYS_MAX	8								// Maximale Ebenentiefe
#define		CRK_KEYS_END	(CRK_KEYS_MAX-1)				// Letzte Ebenen-Nummer
#define		CRK_NEXT		((zchar*)-1)					// Nchster Wert
#define		CRK_ALL 		((zchar*)-2)					// Alle Werte
																
#define		CRK_READ		0								// Schlssel nur lesen
#define		CRK_WRITE		1								// Schlssel auch schreiben
#define		CRK_CREATE		2								// Schlssel auch erzeugen
#endif 														
													


typedef	struct
	{
	short		  iLevel;									// Anzahl der Untergruppen
	short		  iTemp;									// Soll Eintrag gespeichert werden
	CStringChain *pEntries;									// Eintrge
	}SubEntries,*SubEntriesPtr;



//*****************************************************************************
//*
//*		Klasse CTxtKeys
//*
//*****************************************************************************
class CTxtKeys
{
protected:


	HKEY		hKeyNow;						// Registry Schlssel
	HKEY		hKeyInit;						// Anfangs  Schlssel
	int			iError;							// Letzter Fehler
	zchar		cName[260];						// Wert cName
	DWORD		dwType;							// Type  der Werte
	DWORD		dwLength;						// Lnge der Werte

	SubEntries *aSubData[CRK_KEYS_MAX];			// Ebenen Position
	SubEntries *pSubData;

	int 		aPos[CRK_KEYS_MAX];				// Ebenen Position
	int 		aSub[CRK_KEYS_MAX];				// Ebenen Position
	zchar	   *aStr[CRK_KEYS_MAX];				// Ebenen Namen
	zchar	   *pKeyName;						// Schlsselname
	int			iLevel;							// Aktuelle Ebene
	int			iOpenMode;						// ffnungsmodus CRK_???
	int			iFlags;							// Zugriffsflags
	int			iLocal;							// Wurde die Datei iLocal geffnet


	int		    iIsLoadLocal;					// Ist die Textdatei geladen (lokal)
	int		   *pIsLoad;						// Ist die Textdatei geladen
	int			iIsModifiedLocal;				// Wurden nderungen gemacht (lokal)
	int		   *pIsModified;					// Wurden nderungen gemacht
	zchar	    cFileNameLocal[MAX_PATH];		// Dateiname von Daten (lokal)
	zchar	   *pFileName;						// Dateiname von Daten
	zchar		cRegNameUsed[MAX_PATH];			// Initial Dateiname
	CStringChain *pKeyNames;					// Schlsselnamen


	static int			 iClassCount;			// Zhler fr Klassen
	static int		     iIsLoadGlobal;			// Ist die Textdatei geladen
	static int		     iIsModifiedGlobal;		// Wurden nderungen gemacht (global)
	static zchar		 cFileNameGlobal[];		// Dateiname fr die Textdatei
	static CStringChain  sKeyNamesGlobal;		// Schlsselnamen
	static const zchar  *pRootName[];			// Root Namen
	static const HKEY    hRootKeys[];			// Root Schlssel

public:

	static zchar		 cRegName[];			// Dateiname fr die Textdatei "#Daten.trg"=Exe-Pfad
												// # am Anfang steht fr Exe-Pfad
												// ? steht fr den Computer-Namen
												// * steht fr den User-Namen
												// z.B


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************
public:

	CTxtKeys(const zchar *pPath);					// Konstruktor fr lokale Datei
	CTxtKeys();										// Konstruktor
   ~CTxtKeys();										// Destruktor
													
	bool Close();									// Schliet Schlssel
	bool Open ();									// ffnet Schlssel
	bool Open(  HKEY  hKey,				    		// ffnet Schlssel
				const zchar *pPath=0,				
				int   iMode=CRK_CREATE);			
	bool Open(  const zchar *pPath,					// ffnet Schlssel
				int   iMode=CRK_CREATE);			
	bool Create(const zchar *pPath);				// Erzeugt Unterschlssel
	bool Create(HKEY hKey=HKEY_CURRENT_USER,		// Erzeugt Schlssel
				const zchar *pPath=0);				
	bool Up	   (const zchar *pPath=CRK_NEXT,int iOnlyIfExist=0);	// Pfad aufsteigen
	bool Down  ();									// Pfad aufabsteigen
	bool Jump  ();									// Pfad weiterspringen
	bool Next  ();									// Nchsten Unterschlssel ffnen
	bool First ();									// Zum ersten Unterschlssel

	bool Get(           int     &iVal,           const zchar *pName=CRK_NEXT);
	bool Get(unsigned   int     &uVal,           const zchar *pName=CRK_NEXT);
	bool Get(           long    &lVal,           const zchar *pName=CRK_NEXT);
	bool Get(unsigned   long    &uVal,           const zchar *pName=CRK_NEXT);
	bool Get(		    zchar  **pVal,           const zchar *pName=CRK_NEXT);
	bool Get(           zcharu **pVal,           const zchar *pName=CRK_NEXT);
	bool Get(           void   **pVal,           const zchar *pName=CRK_NEXT,DWORD uType=REG_BINARY);
	bool Get(		    zchar   *pVal,           const zchar *pName=CRK_NEXT);
	bool Get(           zcharu  *pVal,           const zchar *pName=CRK_NEXT);
	bool Get(		    zchar   *pVal,DWORD uLen,const zchar *pName=CRK_NEXT);
	bool Get(           zcharu  *pVal,DWORD uLen,const zchar *pName=CRK_NEXT);
	bool Get(		    void    *pVal,DWORD uLen,const zchar *pName=CRK_NEXT,DWORD uType=REG_NONE);

	bool Set(           int      iVal,           const zchar *pName=CRK_NEXT);
	bool Set(const      zchar   *pVal,           const zchar *pName=CRK_NEXT);
	bool Set(const      zcharu  *pVal,           const zchar *pName=CRK_NEXT);
	bool Set(const      void    *pVal,DWORD uLen,const zchar *pName=CRK_NEXT,DWORD uType=REG_NONE);

	bool GetMulti(      zchar   *pVal,DWORD uLen,const zchar *pName=CRK_NEXT);
	bool GetMulti(      zchar  **pVal           ,const zchar *pName=CRK_NEXT);
	bool SetMulti(const zchar   *pVal           ,const zchar *pName);
	bool SetMulti(const zchar   *pVal,DWORD uLen,const zchar *pName);
														 
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	bool Get(CString &sStr,const zchar *pName=CRK_NEXT);
	bool Set(CString  sStr,const zchar *pName=CRK_NEXT);
#endif

	bool Del   (const zchar *pName=CRK_NEXT);				// Wert lschen
	bool DelKey(const zchar *pName=CRK_NEXT);				// Key  lschen
															
															
	DWORD	Type ();										// Ergibt Type  der Werte
	DWORD	Len  ();										// Ergibt Lnge der Werte
	HKEY	Key  ();	    								// Ergibt aktuellen Schlssel
	int		Error();										// Ergibt letzten Fehler
	zchar  *Name ();										// Ergibt Name
	int		Path(zchar *pMem,int iLen,int iMode=0);			// Ergibt Pfad
	int		GetLength(const zchar *pName=CRK_NEXT);			// Ergint die Lnge eines Wertes
															
	int	    ValueCount();									// Ergibt Werte Anzahl
	zchar  *ValueName (                       int iNr=-1);	// Ergibt Wert-Namen
	int	    ValueName (zchar **pName,         int iNr=-1);	// Ergibt Wert-Namen
	int	    ValueName (zchar  *pName,int iLen,int iNr=-1);	// Ergibt Wert-Namen
	int	    KeyCount  ();									// Ergibt Anzahl der SubKeys
	zchar  *KeySubName(                       int iNr=-1);	// Ergibt SubKey-Namen
	int	    KeySubName(zchar **pName         ,int iNr=-1);	// Ergibt SubKey-Namen
	int	    KeySubName(zchar  *pName,int iLen,int iNr=-1);	// Ergibt SubKey-Namen
	zchar  *KeyName   (                       int iNr=-1);	// Ergibt Pfadsegment
	int		KeyName   (zchar  *pName,int iLen,int iNr=-1);	// Ergibt Pfadsegment
	int		KeyName   (zchar **pName         ,int iNr=-1);	// Ergibt Pfadsegment
															
	int     RegPath(zchar *pPath,int iLen,const zchar *p=0);// Ergibt Standard Pfad
	int	    Ebene();										// Ergibt Ebene

	int		OpenText();
	int		SaveText(int iMode=0);

protected:

		void  CreateFileName();
		int	  GetInitKey(HKEY hKey,zchar *pPath);			// Init Key holen
static 	int   MemToStr(char       *pStr,int iMax,const char *pMem,int iLen);
static	int	  StrToMem(char       *pMem,int iMax,const char *pStr);
static 	int   HexToInt(const char *pHex,int *pLen=0);
static 	void  IntToHex(int iVal,char *pBuffer,int iLen);

#ifdef UNICODE
		wchar_t	        *AnsiToWide(const char    *pText);
		char         	*WideToAnsi(const wchar_t *pText);
		wchar_t			 uWideBuffer[520];
		unsigned		 uWidePos;
#endif 	

};


//*****************************************************************************
//*
//*		inline Funktionen
//*
//*****************************************************************************
#ifndef		_DEBUG

inline bool  CTxtKeys::Open(){return Open(HKEY_CURRENT_USER,0,CRK_CREATE);}
inline bool  CTxtKeys::Open(const zchar *pPath,int iMode){return Open(0,pPath,iMode);}
inline int	 CTxtKeys::Ebene(){        return iLevel      ;}
inline bool  CTxtKeys::Next (){        return Up(CRK_NEXT);}
inline bool  CTxtKeys::Jump (){Down(); return Up(CRK_NEXT);}
			 
inline bool  CTxtKeys::SetMulti(const zchar   *pVal,DWORD uLen,const zchar *pName){return Set(pVal,uLen,pName,REG_MULTI_SZ);}
inline bool  CTxtKeys::Set(           int      iVal,const zchar *pName){return Set((const void*)&iVal,sizeof(iVal),pName,REG_DWORD);}
inline bool  CTxtKeys::Set(const      zchar   *pVal,const zchar *pName){return Set((const void*) pVal,sizeof(pVal),pName,REG_SZ   );}
inline bool  CTxtKeys::Set(const      zcharu  *pVal,const zchar *pName){return Set((const void*) pVal,sizeof(pVal),pName,REG_SZ   );}
			 
inline bool  CTxtKeys::Get(		      int     &iVal,const zchar *pName){return Get((void*)&iVal,sizeof(iVal)  ,pName,REG_DWORD);}
inline bool  CTxtKeys::Get(unsigned   int     &uVal,const zchar *pName){return Get((void*)&uVal,sizeof(uVal)  ,pName,REG_DWORD);}
inline bool  CTxtKeys::Get(		      long    &lVal,const zchar *pName){return Get((void*)&lVal,sizeof(lVal)  ,pName,REG_DWORD);}
inline bool  CTxtKeys::Get(unsigned   long    &uVal,const zchar *pName){return Get((void*)&uVal,sizeof(uVal)  ,pName,REG_DWORD);}
inline bool  CTxtKeys::Get(		      zchar   *pVal,const zchar *pName){return Get((void*) pVal,256           ,pName,REG_SZ   );}
inline bool  CTxtKeys::Get(           zcharu  *pVal,const zchar *pName){return Get((void*) pVal,256           ,pName,REG_SZ   );}
inline bool  CTxtKeys::Get(           zchar  **pVal,const zchar *pName){return Get((void**)pVal,               pName,REG_SZ   );}
inline bool  CTxtKeys::Get(           zcharu **pVal,const zchar *pName){return Get((void**)pVal,               pName,REG_SZ   );}
inline bool  CTxtKeys::Get(           zchar   *pVal,DWORD uLen,const zchar *pName){return Get((void*)pVal,uLen,pName,REG_SZ   );}
inline bool  CTxtKeys::Get(           zcharu  *pVal,DWORD uLen,const zchar *pName){return Get((void*)pVal,uLen,pName,REG_SZ   );}

inline DWORD CTxtKeys::Type (){return  dwType  ;}
inline DWORD CTxtKeys::Len  (){return  dwLength;}
inline HKEY	 CTxtKeys::Key  (){return  hKeyNow ;}
inline int	 CTxtKeys::Error(){return  iError  ;}
inline zchar*CTxtKeys::Name (){return  cName   ;}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
inline bool CTxtKeys::Set(CString  sStr,const zchar *pName){return Set((const void*)((LPCTSTR)sStr),sStr.GetLength( ),pName,REG_SZ);}
#endif

#endif


#ifdef		zcharu		
#undef 		zcharu
#endif 	

#ifdef		Z		
#undef 		Z
#endif 	

#endif
