//*****************************************************************************
//*
//*
//*		BitFunctionsTest1.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2015
//
#ifdef		GLOBAL_CONFIG
#define		BITFUNCTIONS_CPP
#include	<GlobalConfig.h>
#undef		BITFUNCTIONS_CPP
#endif

#include	<string.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<time.h>

#ifdef		NO_BIT_ASM
#undef		NO_BIT_ASM
#endif

#include	"UnitTestLib.h"

namespace 	NBitFunctionsTest1
{
#include	"../BitFunctions.h"
#include	"../BitFunctions.cpp"
}

using namespace NBitFunctionsTest1;


#define		Error() 					{TestError(__FILE__,__LINE__  );iErrors++;}
#define		ErrorEx(t)					{TestError(__FILE__,__LINE__,t);iErrors++;}




//*****************************************************************************
//*
//*		BitFunctionsTest1
//*
//*****************************************************************************
int BitFunctionsTest1(void)
{
int			iErrors = 0;
ibt64		iRet64;
int			iTurn;
int			iRet;
int			iVal;



	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68);		if(iRet!=66)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF",68);		if(iRet!=67)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",68);		if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF",68);		if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",68);		if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\x00\xFF\xFF\xFF",68);		if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",0 );		if(iRet!= 0)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64);		if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64);		if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64);		if(iRet!=64)Error();

	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68);		if(iRet!=66-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF"+1,68);		if(iRet!=67-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,68);		if(iRet!=68-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF"+1,68);		if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,68);		if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\x00\xFF\xFF"+1,68);		if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,0 );		if(iRet!= 0)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64);		if(iRet!=58)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF"+1,64);		if(iRet!=59)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64);		if(iRet!=60)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64);		if(iRet!=64)Error();

	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,11);	if(iRet!=66)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF",68,11);	if(iRet!=67)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",68,11);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF",68,11);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",68,11);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,68);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,69);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",0 ,69);	if(iRet!= 0)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68, 0);	if(iRet!=66)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64, 0);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64,62);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64,63);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64,64);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64,65);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64,66);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",64,67);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64,62);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64,63);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64,64);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64,65);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64,66);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF",64,67);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64,62);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64,63);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64,64);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64,65);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64,66);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",64,67);	if(iRet!=64)Error();
	iRet = bit_find_0("\x00\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,11);	if(iRet!=66)Error();
	iRet = bit_find_0("\x00\xF0\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,11);	if(iRet!=11)Error();
	iRet = bit_find_0("\x00\xF7\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,11);	if(iRet!=11)Error();
	iRet = bit_find_0("\x00\xEF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,11);	if(iRet!=12)Error();
	iRet = bit_find_0("\x00\xF8\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF",68,11);	if(iRet!=66)Error();

	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,11);	if(iRet!=66-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF"+1,68,11);	if(iRet!=67-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,68,11);	if(iRet!=68-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,68,11);	if(iRet!=61)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,68,11);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,68);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,69);	if(iRet!=68)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,0 ,69);	if(iRet!= 0)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68, 0);	if(iRet!=66-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64, 0);	if(iRet!=66-8)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64,62);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64,63);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64,64);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64,65);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64,66);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,64,67);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64,62);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64,63);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64,64);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64,65);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64,66);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64,67);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64,62);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64,63);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64,64);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64,65);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64,66);	if(iRet!=64)Error();
	iRet = bit_find_0("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64,67);	if(iRet!=64)Error();
	iRet = bit_find_0("\x00\x00\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,11);	if(iRet!=66-8)Error();
	iRet = bit_find_0("\x00\x00\xF0\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,11);	if(iRet!=11)Error();
	iRet = bit_find_0("\x00\x00\xF7\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,11);	if(iRet!=11)Error();
	iRet = bit_find_0("\x00\x00\xEF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,11);	if(iRet!=12)Error();
	iRet = bit_find_0("\x00\x00\xF8\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF"+1,68,11);	if(iRet!=66)Error();


	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",68);		if(iRet!=66)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00",68);		if(iRet!=67)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",68);		if(iRet!=68)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00",68);		if(iRet!=68)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",68);		if(iRet!=68)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\xFF\x00\x00\x00",68);		if(iRet!=64)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00", 0);		if(iRet!= 0)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64);		if(iRet!=64)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64);		if(iRet!=64)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64);		if(iRet!=64)Error()

	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,68);		if(iRet!=66-8)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00"+1,68);		if(iRet!=67-8)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,68);		if(iRet!=68-8)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,68);		if(iRet!=61)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\xFF\x00\x00"+1,68);		if(iRet!=64)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,68);		if(iRet!=66-8)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1, 0);		if(iRet!=0)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64);		if(iRet!=66-8)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64);		if(iRet!=60)Error()
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64);		if(iRet!=64)Error()

	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00",68,11);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00",68,11);	if(iRet!=65)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",68,11);	if(iRet!=68)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",68,68);	if(iRet!=68)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",68,69);	if(iRet!=68)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",0 ,69);	if(iRet!= 0)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",68, 0);	if(iRet!=66)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64, 0);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64,62);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64,63);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64,64);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64,65);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64,66);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00",64,67);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64,62);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64,63);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64,64);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64,65);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64,66);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00",64,67);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64,62);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64,63);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64,64);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64,65);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64,66);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",64,67);	if(iRet!=64)Error();
	iRet = bit_find_1("\xFF\x00\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00",68,11);	if(iRet!=65)Error();
	iRet = bit_find_1("\xFF\x0F\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00",68,11);	if(iRet!=11)Error();
	iRet = bit_find_1("\xFF\x08\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00",68,11);	if(iRet!=11)Error();
	iRet = bit_find_1("\xFF\x10\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00",68,11);	if(iRet!=12)Error();

	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00"+1,68,11);	if(iRet!=56)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00"+1,68,11);	if(iRet!=57)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,68,11);	if(iRet!=68)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,68,68);	if(iRet!=68)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,68,69);	if(iRet!=68)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,0 ,69);	if(iRet!= 0)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,68, 0);	if(iRet!=58)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64, 0);	if(iRet!=58)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64,62);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64,63);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64,64);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64,65);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64,66);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,64,67);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64,62);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64,63);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64,64);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64,65);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64,66);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,64,67);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64,62);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64,63);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64,64);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64,65);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64,66);	if(iRet!=64)Error();
	iRet = bit_find_1("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64,67);	if(iRet!=64)Error();
	iRet = bit_find_1("\xFF\xFF\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00"+1,68,11);	if(iRet!=57)Error();
	iRet = bit_find_1("\xFF\xFF\x0F\x00\x00\x00\x00\x00\x02\x00\x00\x00"+1,68,11);	if(iRet!=11)Error();
	iRet = bit_find_1("\xFF\xFF\x08\x00\x00\x00\x00\x00\x02\x00\x00\x00"+1,68,11);	if(iRet!=11)Error();
	iRet = bit_find_1("\xFF\xFF\x10\x00\x00\x00\x00\x00\x02\x00\x00\x00"+1,68,11);	if(iRet!=12)Error();

	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,68);	if(iRet!=66-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,68);	if(iRet!=67-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF"+1,68);	if(iRet!=68-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF"+1,68);	if(iRet!=68)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,68);	if(iRet!=68)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\x00\xFF\xFF"+1,68);	if(iRet!=64)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,0 );	if(iRet!= 0)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,64);	if(iRet!=58)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,64);	if(iRet!=59)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF"+1,64);	if(iRet!=60)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,64);	if(iRet!=64)Error();

	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,68,11);	if(iRet!=66-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xEF\xFF\xFF\xFF"+1,68,11);	if(iRet!=67-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xF7\xFF\xFF\xFF"+1,68,11);	if(iRet!=68-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFB\xFF\xFF\xFF"+1,68,11);	if(iRet!=61)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF"+1,68,11);	if(iRet!=68)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,68,68);	if(iRet!=68)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,68,69);	if(iRet!=68)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,0 ,69);	if(iRet!= 0)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,68, 0);	if(iRet!=66-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,64, 0);	if(iRet!=66-8)Error();
	iRet = bit_find_0x("\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xDF\xFF\xFF\xFF"+1,64,62);	if(iRet!=64)Error();

	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,68);	if(iRet!=66-8)Error();
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00"+1,68);	if(iRet!=67-8)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00"+1,68);	if(iRet!=68-8)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00"+1,68);	if(iRet!=61)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x00\xFF\x00\x00"+1,68);	if(iRet!=64)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,68);	if(iRet!=66-8)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1, 0);	if(iRet!=0)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,64);	if(iRet!=66-8)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00"+1,64);	if(iRet!=60)Error()
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,64);	if(iRet!=64)Error()

	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x80\x00\x00\x00"+1,68,11);	if(iRet!=56)Error();
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x00"+1,68,11);	if(iRet!=57)Error();
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"+1,68,11);	if(iRet!=68)Error();
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,68,68);	if(iRet!=68)Error();
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,68, 0);	if(iRet!=58)Error();
	iRet = bit_find_1x("\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00"+1,64, 0);	if(iRet!=58)Error();

									  
	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 0;
		iRet = bit_set(&iVal,iTurn);
		if(iRet!=0 || iVal!=(1<<iTurn))Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 1<<iTurn;
		iRet = bit_set(&iVal,iTurn);
		if(iRet==0 || iVal!=(1<<iTurn))Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 0;
		iRet = bit_clear(&iVal,iTurn);
		if(iRet!=0 || iVal!=0)Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 1<<iTurn;
		iRet = bit_clear(&iVal,iTurn);
		if(iRet==0 || iVal!=0)Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 0;
		iRet = bit_change(&iVal,iTurn);
		if(iRet!=0 || iVal!=(1<<iTurn))Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 1<<iTurn;
		iRet = bit_change(&iVal,iTurn);
		if(iRet==0 || iVal!=0)Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 0;
		iRet = bit_read(&iVal,iTurn);
		if(iRet!=0)Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 1<<iTurn;
		iRet = bit_read(&iVal,iTurn);
		if(iRet==0)Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 0;
		iRet = bit_write(&iVal,iTurn,1);
		if(iRet!=0 || iVal!=(1<<iTurn))Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 1<<iTurn;
		iRet = bit_write(&iVal,iTurn,1);
		if(iRet==0 || iVal!=(1<<iTurn))Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 0;
		iRet = bit_write(&iVal,iTurn,0);
		if(iRet!=0 || iVal!=0)Error();
		}

	for(iTurn=0;iTurn<32;iTurn++)
		{
		iVal = 1<<iTurn;
		iRet = bit_write(&iVal,iTurn,0);
		if(iRet==0 || iVal!=0)Error();
		}


	iRet	= bit_swap(0xFFFFFFFF, 1);	if(iRet!=0x00000001)Error();
	iRet	= bit_swap(0x0000000F, 0);	if(iRet!=0x00000000)Error();
	iRet	= bit_swap(0x0000000F, 1);	if(iRet!=0x00000001)Error();
	iRet	= bit_swap(0x0000000F, 5);	if(iRet!=0x0000001E)Error();
	iRet	= bit_swap(0x0000000F,31);	if(iRet!=0x78000000)Error();
	iRet	= bit_swap(0x0000000F,32);	if(iRet!=0xF0000000)Error();

	iRet64	= bit_swap_qw(0xFFFFFFFF, 1);			if(iRet64!=0x00000001)Error();
	iRet64	= bit_swap_qw(0x0000000F, 0);			if(iRet64!=0x00000000)Error();
	iRet64	= bit_swap_qw(0x0000000F, 1);			if(iRet64!=0x00000001)Error();
	iRet64	= bit_swap_qw(0x0000000F, 5);			if(iRet64!=0x0000001E)Error();
	iRet64	= bit_swap_qw(0x0000000F,31);			if(iRet64!=0x78000000)Error();
	iRet64	= bit_swap_qw(0x0000000F,32);			if(iRet64!=0xF0000000)Error();
	iRet64	= bit_swap_qw(0x0000000F,33);			if(iRet64!=(((ibt64)0x1E000000)<< 4))Error();
	iRet64	= bit_swap_qw(0x0000000F,63);			if(iRet64!=(((ibt64)0x78000000)<<32))Error();
	iRet64	= bit_swap_qw(0x0000000F,64);			if(iRet64!=(((ibt64)0xF0000000)<<32))Error();
	iRet64	= bit_swap_qw(((ibt64)0x1248)<<24,64);	if(iRet64!=(((ibt64)0x1248)<<24))Error();


	iRet	= bit_shift(0x00000001, -1);			if(iRet!=0x00000000)Error();
	iRet	= bit_shift(0x00000001,	 0);			if(iRet!=0x00000001)Error();
	iRet	= bit_shift(0x00000001,	 1);			if(iRet!=0x00000002)Error();
	iRet	= bit_shift(0x00000001, 31);			if(iRet!=0x80000000)Error();
	iRet	= bit_shift(0x00000001, 32);			if(iRet!=0x00000000)Error();

	iRet	= bit_shift(0x80000000,	 1);			if(iRet!=0x00000000)Error();
	iRet	= bit_shift(0x80000000,	 0);			if(iRet!=0x80000000)Error();
	iRet	= bit_shift(0x80000000, -1);			if(iRet!=0x40000000)Error();
	iRet	= bit_shift(0x80000000,-31);			if(iRet!=0x00000001)Error();
	iRet	= bit_shift(0x80000000,-32);			if(iRet!=0x00000000)Error();


	iRet	= bit_shift_l(0x00000001, -1);			if(iRet!=0x00000000)Error();
	iRet	= bit_shift_l(0x00000001,  0);			if(iRet!=0x00000001)Error();
	iRet	= bit_shift_l(0x00000001,  1);			if(iRet!=0x00000002)Error();
	iRet	= bit_shift_l(0x00000001, 31);			if(iRet!=0x80000000)Error();
	iRet	= bit_shift_l(0x00000001, 32);			if(iRet!=0x00000000)Error();

	iRet	= bit_shift_r(0x80000000, -1);			if(iRet!=0x00000000)Error();
	iRet	= bit_shift_r(0x80000000,  0);			if(iRet!=0x80000000)Error();
	iRet	= bit_shift_r(0x80000000,  1);			if(iRet!=0x40000000)Error();
	iRet	= bit_shift_r(0x80000000, 31);			if(iRet!=0x00000001)Error();
	iRet	= bit_shift_r(0x80000000, 32);			if(iRet!=0x00000000)Error();

	iRet64	= btol_qw(((ibt64)0x11223344)<<8);		if(iRet64!=(((ibt64)0x44332211)<<24))Error();
	iRet	= btol_dw(0x11223344);					if(iRet!=0x44332211)Error();
	iRet	= btol_w (0x00001122);					if(iRet!=0x00002211)Error();

	iRet64	= bit_rol_qw (0x12345678,4);			if(iRet64!=(((ibt64)0x12345678)<<4))Error();
	iRet64	= bit_rol_qw (0x12345678,36);			if(iRet64!=(((ibt64)0x02345678)<<36)+(ibt64)1)Error();
	iRet	= bit_rol_dw (0x12345678,4);			if(iRet!=0x23456781)Error();
	iRet	= bit_rol_w	 (0x00001234,4);			if(iRet!=0x00002341)Error();
	iRet	= bit_rol_b	 (0x00000012,4);			if(iRet!=0x00000021)Error();

	iRet64	= bit_ror_qw (0x12345678,60);			if(iRet64!=(((ibt64)0x12345678)<<4))Error();
	iRet64	= bit_ror_qw (0x12345678,4);			if(iRet64!=(((ibt64)8)<<60)+(ibt64)0x01234567)Error();
	iRet	= bit_ror_dw (0x12345678,4);			if(iRet!=0x81234567)Error();
	iRet	= bit_ror_w	 (0x00001234,4);			if(iRet!=0x00004123)Error();
	iRet	= bit_ror_b	 (0x00000012,4);			if(iRet!=0x00000021)Error();




return iErrors;
}

