//*****************************************************************************
//*
//*
//*		CompressTest.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2015
//
#ifdef		GLOBAL_CONFIG
#define		BITFUNCTIONS_CPP
#include	<GlobalConfig.h>
#undef		BITFUNCTIONS_CPP
#endif

#include	"../AZ_Lib.h"
#include	"UnitTestLib.h"

#define 	LW_PATH		"D:\\"
#define		Error() 					{TestError(__FILE__,__LINE__  );iErrors++;}
#define		ErrorEx(t)					{TestError(__FILE__,__LINE__,t);iErrors++;}

static	const char *pInText =
	"Hallo aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Mausi aaa  xxxx WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Mausi aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo fff  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Mausi aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo fff  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  xxxx WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Bren aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo fff  cccc WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Hallo fff  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo fff  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  xxxx AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren fff  cccc AAAAAAAAAAAAAAAAA\n"
	"Hallo aaa  cccc WWWWWWWWWWWWWWWWW\n"
	"Hallo aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren aaa  xxxx WWWWWWWWWWWWWWWWW\n"
	"Bren aaa  cccc AAAAAAAAAAAAAAAAA\n"
	"Bren aaa  cccc AAAAAAAAAAAAAAAAA\n";




static	const char *pNameI;
static	const char *pNameO;
static	char		aBase [0x8000];
static	char		aBuff1[0x8000];
static	char		aBuff2[0x8000];
static	unsigned 	uCrc;
static	int			iSize;
static	int			iLenO;
static	int			iLenI;
static	int			iOffO;
static	int			iOffI;


//*****************************************************************************
//*
//*		ReadFrom
//*
//*****************************************************************************
static int ReadFrom(void *pParam,char *pBuffer,int iLen)
{
char	   *pMem=(char*)pParam; 
unsigned	uMax;

	
	if(iLen<=0)return 0;
	uMax = iLenI-iOffI;
	if((unsigned)iLen>uMax)iLen=uMax;

	memcpy(pBuffer,pMem+iOffI,iLen);
	iOffI+=iLen;

return iLen;
}

//*****************************************************************************
//*
//*		WriteMem
//*
//*****************************************************************************
static int WriteMem(void *pParam,const char *pBuffer,int iLen)
{
char	   *pMem=(char*)pParam; 
unsigned	uMax;

	
	if(iLen<=0)return 0;
	uMax = iLenO-iOffO;
	if((unsigned)iLen>uMax)iLen=uMax;

	memcpy(pMem+iOffO,pBuffer,iLen);
	iOffO+=iLen;


return iLen;
}


//*****************************************************************************
//*
//*		CompressTestX
//*
//*****************************************************************************
static int CompressTestX(CBaseCompressor *pClass,const char *pName)
{
char			cText[256];
FILE		   *pFileI;	
FILE		   *pFileO;
HANDLE			hHandleI;
HANDLE			hHandleO;
unsigned		uModeI;
unsigned		uModeO;
unsigned		uCrcO;
int				iSizeC;
int				iSizeD;
int				iSizeX;
int				iErrors;

	
	
	TestPrintf(pName);

	iErrors = 0;
	iSize	= sizeof(aBase);

	for(uModeI=0;uModeI<4;uModeI++)
	for(uModeO=0;uModeO<4;uModeO++)
		{
		RemoveFile(LW_PATH"Test.bin");
		SaveMemory(LW_PATH"Test.txt",pInText);

		iSize	= LoadMemory("D:\\Test.txt",aBase,sizeof(aBase),1);
		uCrc	= ~Crc32(0xFFFFFFFF,aBase,iSize);
		


		memset(aBuff1,0,sizeof(aBuff1));
		memset(aBuff2,0,sizeof(aBuff2));

		switch(uModeI)										// Kompriieren konfigurieren
			{
		case 0:	pClass->SetIn(iSize,aBase,0);
				pNameI = "Mem";
				break;
		case 1:	pClass->SetIn(aBase,ReadFrom,0);		iOffI=0;	iLenI=iSize;
				pNameI = "Proc";
				break;
		case 2:	pFileI=fopen(LW_PATH"Test.txt","rb");
				pClass->SetIn(pFileI,-1,0);
				pNameI = "File";
				break;
		case 3:	hHandleI=CreateFileA(LW_PATH"Test.txt",GENERIC_READ,0,0,OPEN_EXISTING,0,0);
				pClass->SetIn(hHandleI,-1,0);
				pNameI = "Handle";
				break;
			}

		switch(uModeO)
			{
		case 0:	pClass->SetOut(sizeof(aBuff2),aBuff2,0);
				pNameO = "Mem";
				break;
		case 1:	pClass->SetOut(aBuff2,WriteMem,0);	iOffO=0;	iLenO=sizeof(aBuff2);
				pNameO = "Proc";
				break;
		case 2:	pFileO=fopen(LW_PATH"Test.bin","wb");
				pClass->SetOut(pFileO,-1,0);
				pNameO = "File";
				break;
		case 3:	hHandleO=CreateFileA(LW_PATH"Test.bin",GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
				pClass->SetOut(hHandleO,-1,0);
				pNameO = "Handle";
				break;
			}



		try	{
			iSizeC	= (int)pClass->Compress();
			}
		catch(const char *pText)
			{
			sprintf(cText,"Compress Error A: %s  %s-->%s = %s",pName ,pNameI,pNameO,pText);
			ErrorEx(cText)
			iSizeC=0;
			}
		catch(...)
			{
			sprintf(cText,"Compress Error A: %s  %s-->%s = ?",pName ,pNameI,pNameO);
			ErrorEx(cText)
			iSizeC=0;
			}
		
		if(uModeI==2)fclose(pFileI);
		if(uModeO==2)fclose(pFileO);
		if(uModeI==3)CloseHandle(hHandleI);
		if(uModeO==3)CloseHandle(hHandleO);
		
		if(pClass->GetCrcInp()!=uCrc)
			{
			sprintf(cText,"CRC Error A: %s  %s-->%s",pName ,pNameI,pNameO);
			ErrorEx(cText)
			}

		uCrcO	= pClass->GetCrcOut();



		switch(uModeO)										// Daten laden
			{
		case 0:	
		case 1:	SaveMemory(LW_PATH"Test.bin",aBuff2,iSizeC);

				break;

		default:iSizeD=LoadMemory(LW_PATH"Test.bin",aBuff2,sizeof(aBuff2));

				if(iSizeD!=iSizeC)
					{
					sprintf(cText,"SIZE Error A: %s  %s-->%s",pName ,pNameI,pNameO);
					ErrorEx(cText)
					}
				break;
			}

		if(uCrcO!=~Crc32(0xFFFFFFFF,aBuff2,iSizeC))
			{
			sprintf(cText,"CRC Error B: %s  %s-->%s",pName ,pNameI,pNameO);
			ErrorEx(cText)
			}


		switch(uModeI)										// Dekompriieren konfigurieren
			{
		case 0:	pClass->SetIn(iSizeC,aBuff2,0);
				break;
		case 1:	pClass->SetIn(aBuff2,ReadFrom,0);	iOffI=0;	iLenI=iSizeC;
				break;
		case 2:	pFileI=fopen(LW_PATH"Test.bin","rb");
				pClass->SetIn(pFileI,-1,0);
				break;
		case 3:	hHandleI=CreateFileA(LW_PATH"Test.bin",GENERIC_READ,0,0,OPEN_EXISTING,0,0);
				pClass->SetIn(hHandleI,-1,0);
				break;
			}

		switch(uModeO)
			{
		case 0:	pClass->SetOut(sizeof(aBuff1),aBuff1,0);
				break;
		case 1:	pClass->SetOut(aBuff1,WriteMem,0);	iOffO=0;	iLenO=sizeof(aBuff1);
				break;
		case 2:	pFileO=fopen(LW_PATH"Test1.txt","wb");
				pClass->SetOut(pFileO,-1,0);
				break;
		case 3:	hHandleO=CreateFileA(LW_PATH"Test1.txt",GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
				pClass->SetOut(hHandleO,-1,0);
				break;
			}


		if(!stricmp(pName,"Lzx"))
			{
			((CLzxClass*)pClass)->SetParam(iSize);
			}

		try	{
			iSizeD	= (int)pClass->Decompress();
			}
		catch(const char *pText)
			{
			sprintf(cText,"Decompress Error A: %s  %s-->%s = %s",pName ,pNameI,pNameO,pText);
			ErrorEx(cText)
			iSizeD=0;
			}
		catch(...)
			{
			sprintf(cText,"Decompress Error A: %s  %s-->%s = ?",pName ,pNameI,pNameO);
			ErrorEx(cText)
			iSizeD=0;
			}

		if(uModeI==2)fclose(pFileI);
		if(uModeO==2)fclose(pFileO);
		if(uModeI==3)CloseHandle(hHandleI);
		if(uModeO==3)CloseHandle(hHandleO);


		if(uCrcO!=pClass->GetCrcInp())
			{
			sprintf(cText,"CRC Error C: %s  %s-->%s",pName ,pNameI,pNameO);
			ErrorEx(cText)
			}


		if(uCrc!=pClass->GetCrcOut())
			{
			sprintf(cText,"CRC Error D: %s  %s-->%s",pName ,pNameI,pNameO);
			ErrorEx(cText)
			}


		if(iSizeD!=iSize)
			{
			sprintf(cText,"SIZE Error B: %s  %s-->%s",pName ,pNameI,pNameO);
			ErrorEx(cText)
			}


		if(uModeO>1)										// Daten laden				
			{
			iSizeX = LoadMemory(LW_PATH"Test1.txt",aBuff1,sizeof(aBuff1));

			if(iSizeD!=iSizeX)
				{
				sprintf(cText,"SIZE Error C: %s  %s-->%s",pName ,pNameI,pNameO);
				ErrorEx(cText)
				}
			}
		
		
		if(memcmp(aBuff1,aBase,iSize))
			{
			sprintf(cText,"DATA Error A: %s  %s-->%s",pName ,pNameI,pNameO);
			ErrorEx(cText)
			}	
		}

	RemoveFile(LW_PATH"Test.bin");
	RemoveFile(LW_PATH"Test.txt");
	RemoveFile(LW_PATH"Test1.txt");


return iErrors;
}


//*****************************************************************************
//*
//*		CompressTest
//*
//*****************************************************************************
int CompressTest(void)
{
int		iErrors;



	iErrors = 0;

	{
	CHuffman	sClass;	
	iErrors += CompressTestX(&sClass,"Huffman");
	}

	{
	CBzipClass	sClass;	
	iErrors += CompressTestX(&sClass,"Bzip2");
	}

	{
	CLzmaClass	sClass;	
	iErrors += CompressTestX(&sClass,"Lzma");
	}

	{
/*	CLzma2Class	sClass;	
	sClass.SetMode(0x00);
	iErrors += CompressTestX(&sClass,"Lzma2");*/
	}

	{
	CPpmClass	sClass;	
	sClass.SetMode(0x01);
	iErrors += CompressTestX(&sClass,"Ppm");
	}

	{		   
	CLzwClass	sClass;	
	iErrors += CompressTestX(&sClass,"Lzw");
	}

	{
	CLzxClass	sClass;	
//	iErrors += CompressTestX(&sClass,"Lzx");
	}

	{
	CXzClass	sClass;	
	iErrors += CompressTestX(&sClass,"Xz");
	}



return iErrors;
}

