//*****************************************************************************
//*
//*
//*		UnitTestDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"UnitTest.h"
#include	"UnitTestDlg.h"
#include	"UnitTestLib.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CUnitTestDlg, CDialog)
	//{{AFX_MSG_MAP(CUnitTestDlg)
	ON_WM_PAINT()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CListBox	*pListBox;

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
CUnitTestDlg::CUnitTestDlg(CWnd *pParent): CDialog(CUnitTestDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CUnitTestDlg)
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CUnitTestDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CUnitTestDlg)
	DDX_Control(pDX, IDC_LIST1, m_cList);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CUnitTestDlg Nachrichten-Handler
BOOL CUnitTestDlg::OnInitDialog()
{
CMenu   *pSysMenu;


	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT((IDM_ABOUTBOX < 0xF000));

	   pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu != NULL)
		{
		CString		sAboutMenu;


		sAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX,sAboutMenu);
			}
		}

	SetIcon(m_hIcon,TRUE );
	SetIcon(m_hIcon,FALSE);


return TRUE; 
}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CUnitTestDlg::OnSysCommand(UINT nID,LPARAM lParam)
{
	if((nID & 0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog	sDlg(IDD_ABOUTBOX);


		sDlg.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//  Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
// 	den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
// 	Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CUnitTestDlg::OnPaint()
{
CRect	sRect;
int		iIconX;
int		iIconY;
int		iPosX;
int		iPosY;


	if(IsIconic())
		{
		CPaintDC sDc(this);										// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND,(WPARAM)sDc.GetSafeHdc(),0);
																
		iIconX = GetSystemMetrics(SM_CXICON);					// Symbol in Client-Rechteck zentrieren
		iIconY = GetSystemMetrics(SM_CYICON);
		
		GetClientRect(&sRect);
		
		iPosX  = (sRect.Width ()-iIconX+1)/2;
		iPosY  = (sRect.Height()-iIconY+1)/2;

		
		sDc.DrawIcon(iPosX,iPosY,m_hIcon);						// Symbol zeichnen
		}
	else{
		CDialog::OnPaint();
		}
}

//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CUnitTestDlg::OnQueryDragIcon()
{

return (HCURSOR)m_hIcon;
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CUnitTestDlg::OnCancel() 
{
	
	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CUnitTestDlg::OnOK() 
{
CString		sText;
int			iErrors;
	
	
	pListBox = &m_cList;
	m_cList.ResetContent();

	SetCursor(IDC_WAIT);

	iErrors  = TestStart();

	SetCursor(IDC_ARROW);

	if(iErrors)
		{
		sText.Format(_T("Es gab %i Fehler."),iErrors);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONERROR);
		}
	else{
		sText.Format(_T("Es gab keine Fehler."),iErrors);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONINFORMATION);
		}
	
//	CDialog::OnOK();
}


//*****************************************************************************
//*
//*		AddListBox
//*
//*****************************************************************************
int AddListBox(const char *pFile,int iLine,const char *pInfo)
{
HANDLE				hHandle;
WIN32_FIND_DATAA	sFind;
CString				sText;	
size_t				iLen;


	if(pInfo==NULL)
		{
		pInfo = "";
		}

	if(pFile)
		{
		hHandle = FindFirstFileA(pFile,&sFind);

		if(hHandle!=INVALID_HANDLE_VALUE)
			{
			FindClose(hHandle);
			pFile = sFind.cFileName;
			}
		else{	
			iLen = strlen(pFile);

			while(iLen>0)
				{
				if(pFile[iLen-1]=='\\')break;
				if(pFile[iLen-1]=='/' )break;
				if(pFile[iLen-1]==':' )break;
				iLen--;
				}
			
			pFile += iLen;
			}

		#ifdef UNICODE
		sText.Format(_T("%S(%i)  %S"),pFile,iLine,pInfo);
		#else
		sText.Format(_T("%s(%i)  %s"),pFile,iLine,pInfo);
		#endif 	
		}
	else{
		sText = pInfo;
		}
	
	
	pListBox->AddString(sText);


return 0;
}

