//*****************************************************************************
//*
//*
//*		UnitTestLib.cpp
//*
//*
//*****************************************************************************
//
//	Definitionen fr den UnitTest
//
#ifdef		GLOBAL_CONFIG
#define		UNITTEXTLIB_CPP
#include	<GlobalConfig.h>
#undef		UNITTEXTLIB_CPP
#endif

#ifdef		ADD_PRINTF
#include	<stdio.h>
#endif 	

int			BitFunctionsTest1(void);
int			BitFunctionsTest2(void);
int			CompressTest(void);


#ifdef		ADD_LIST_BOX
int			AddListBox(const char *pFile,int iLine,const char *pInfo);
#endif

//*****************************************************************************
//*
//*		TestPrintf
//*
//*****************************************************************************
extern "C" int TestPrintf(const char *pFormat)
{

	#ifdef	ADD_LIST_BOX
	AddListBox(0,0,pFormat);
	#endif 	

	#ifdef	ADD_PRINTF
	printf("%s",pFormat);
	#endif

return 0;
}

//*****************************************************************************
//*
//*		TestError
//*
//*****************************************************************************
extern "C" int TestError(const char *pFile,int iLine,const char *pInfo=0)
{
int 	iLen;

	
	for(iLen=0;pFile[iLen];iLen++);

	while(iLen>0)
		{
		if(pFile[iLen-1]=='\\')break;
		if(pFile[iLen-1]=='/' )break;
		if(pFile[iLen-1]==':' )break;
		iLen--;
		}
	
	pFile += iLen;

	#ifdef	ADD_LIST_BOX
	AddListBox(pFile,iLine,pInfo);
	#endif

	#ifdef	ADD_PRINTF
	printf("Error in '%s'(%i)  %s\n",pFile,iLine,(pInfo)? pInfo:"");
	#endif


return 0;
}


//*****************************************************************************
//*
//*		TestStart
//*
//*****************************************************************************
extern "C" int TestStart(void)
{
int		iErrors=0;

	TestPrintf("BitFunctionsTest1");	iErrors	+= BitFunctionsTest1();
	TestPrintf("BitFunctionsTest2");	iErrors	+= BitFunctionsTest2();
//	TestPrintf("CompressTest");			iErrors	+= CompressTest();


return iErrors;
}

