//*****************************************************************************
//*
//*
//*		VarTools.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//
//	Diese Datei enthlt Funktionen fr die Bearbeitung von
//	System Variabeln.	-->  $(Var)
//
//	Mit dem #define VAR_ONLY_ENV werden nur Variabel Funktionen kompiliert
//
//	Vordefinierte Variabeln:
//
//		Alle Enviroment Variabeln
//		USER_NAME
//		COMPUTER_NAME
//		WINDOWS_FOLDER
//		SYSTEM_FOLDER
//	 	TEMP_FOLDER
//		CURRENT_DIRECTORY
//		OS_MAJOR_NR						4=Win98
//		OS_MINOR_NR
//		OS_NAME							"WIN98" oder "WINNT"
//		COMMON_PRORAMS_FOLDER			Fr alle User
//		COMMON_STARTMENU_FOLDER			Fr alle User
//		COMMON_DESKTOPDIRECTORY_FOLDER	Fr alle User
//		DESKTOP_FOLDER
//		FAVORITES_FOLDER
//		FONTS_FOLDER
//		PERSONAL_FOLDER
//		PRORAMS_FOLDER
//		SENDTO_FOLDER
//		STARTMENU_FOLDER
//		DESKTOPDIRECTORY_FOLDER			Realer Dektoppfad
//
//	Extern definierte Variabeln:
//
//		CURRENT_PATH					Verzeichnis der aktuellen Datei
//		CURRENT_FILE					Name der aktuellen Datei
//		CALLBACK_BREAK					Abbruch von einem Callback (0=Weiter 1=OK 2=CANCEL)
//		CALLBACK_VAR					Variabelname fr einem Callback (normal "")
//		CALLBACK_NR						Tastennummer fr einem Callback (normal "")
//

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#ifndef	 __AFX_H__
	#include <Afx.h>
	#endif
#else
	#include <windows.h>
#endif

#include	<stdio.h>
#include	<string.h>
#include	<shlobj.h>
#include	<aclapi.h>
#include	<accctrl.h>
#include	<tlhelp32.h>
#include	"VarTools.h"
#include	"StringChain.h"
#include	"WinExtension.h"
#include	"MemFunctions.h"
#include	"FileFunctions.h"
#include	"StringFunctions.h"
#include	"System/MacAddrUtility.h"

#ifndef 	 VAR_ONLY_ENV
#include	"LicenseTools.h"
#include	"RegConfig.h"
#include	"ShortCuts.h"
#include	"StartProg.h"
#include	"RegKeys.h"
#include	"RegText.h"
#include	"Archive/ZipFile.h"
#ifdef		VAR_HAS_TGZTYPE
#include	"Archive/TgzFile.h"
#endif
#endif

void		 *VarWindow=0;
void		 *VarParam=0;
void		 *VarDParam=0;
void (_cdecl *VarMessage)(void*,int,char*)=0;
int  (_cdecl *VarDebug  )(void*,int,char*,void*,const char *)=0;




#define		PUFFER_ADD(mem,alt,neu)							\
			{												\
			char  *mem_neu;									\
			mem_neu=new char [neu];				 			\
			memcpy(mem_neu,mem,alt);						\
			alt=neu;										\
			if(mem)delete mem;								\
			mem = mem_neu;									\
			}


#ifndef		TH32CS_SNAPMODULE32
#define		TH32CS_SNAPMODULE32				0x0010
#endif
#ifndef		CSIDL_PROGRAM_FILES
#define		CSIDL_PROGRAM_FILES             0x0026  // C:\Program Files
#endif
#ifndef		CSIDL_PROGRAM_FILESX86
#define		CSIDL_PROGRAM_FILESX86          0x002A  // x86 C:\Program Files on RISC
#endif
#ifndef		CSIDL_PROGRAM_FILES_COMMON
#define		CSIDL_PROGRAM_FILES_COMMON      0x002B  // C:\Program Files\Common
#endif
#ifndef		CSIDL_PROGRAM_FILES_COMMONX86
#define		CSIDL_PROGRAM_FILES_COMMONX86   0x002C  // x86 Program Files\Common on RISC
#endif
#ifndef 	PROCESS_QUERY_LIMITED_INFORMATION
#define		PROCESS_QUERY_LIMITED_INFORMATION 0x1000
#endif 	


#define 	MAX_ENTRYS	16							// Maximale anzahl an Zeileneintrgen

#define 	VERSION_MJR	2
#define 	VERSION_SUB	5

static	char			zip_filter[256];			// Filter fr Zip-Dateien
static	CStringChain	var_name;					// Namen der Variabeln
static	CStringChain	var_text;					// Inhalt der Variabeln
static	CStringChain	table_val(sizeof(int));		// Tabellenwerte
static	CStringChain	table_pos(sizeof(int)*3);	// Tabellenpositionen
static	char		   *temp_text=0;				// Zeiger auf Datenpuffer
static	int				temp_size=0;				// Lnge des Datenpuffers
static	unsigned char	disk_id[4];					// Seriennummer der Festplatte
static	BOOL			is_64_bit=0;				// Ist ein 64-Bit Betreibsystem vorhanden
static	PVOID			old_64_dis=0;				// Umleitung von "C:\Windows\system32"
static	int				old_64_cnt=0;				// Anzahl von "C:\Windows\system32" Umleitungen
static	int				line_now;					// Aktuelle Zeilennummer
static	int				ignore=0;

#ifndef 	VAR_ONLY_ENV
extern void  VarLicenseDlg ();
extern int   VarFileDialog (const char *Var,const char *File,const char *Title,const char *Filter);
extern int   VarTableSelect(int Flags,CStringChain *Table,int Start,int Len,int Breite,int SizeX,int SizeY);
extern int   VarLicenceInfo(const char *Text,const char *Title,const char *WndText);
extern char *VarGetPath    (const char *Path,const char *Titel ,int Cancel,int Exist);
extern char *VarGetFile    (const char *Path,const char *Titel ,int Cancel);
extern char *VarGetText    (const char *Text,const char *Titel1,const char *Titel2,int Cancel);
static void  VarSetRegSz   (const char *Path,const char *Name,const char *Value);
static int   VarCopyFtp    (char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,int Art);
class CArchiveFileEx : public CArchiveFile
{
public:
	int ProgressEx(int Num,int Sub){return Progress(Num,Sub);}
	static CArchiveFileEx *GetArchive(CArchiveFile *File){return (CArchiveFileEx*)File;}
};

#endif

extern "C" WINBASEAPI BOOL WINAPI CheckTokenMembership(HANDLE TokenHandle,PSID SidToCheck,PBOOL IsMember);
extern "C" WINBASEAPI BOOL WINAPI CreateHardLinkA(LPCSTR,LPCSTR,LPSECURITY_ATTRIBUTES);

typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS)(HANDLE, PBOOL);
typedef BOOL (WINAPI *LPFN_WOW64DISABLE  )(PVOID*);


typedef struct
	{
	WORD  wLength;
	WORD  wValueLength;
	WORD  wType;
	WCHAR szKey[1];
	WORD  Padding1[1];
	VS_FIXEDFILEINFO Value;
	WORD  Padding2[1];
	WORD  Children[1];
	}VS_VERSIONINFO;


//*****************************************************************************
//*
//*		HasUserAdminPrivilege
//*
//*****************************************************************************
//	Prfen ob der aktuelle User Admin-Rechte hat
//	Ergibt 1 wenn ja
static BOOL HasUserAdminPrivilege()
{
SID_IDENTIFIER_AUTHORITY	sNtAuthority = SECURITY_NT_AUTHORITY;
UCHAR						aInfoBuffer[4096];
HANDLE						hAccessToken;
PSID						pSidAdmin;
BOOL						bSuccess;
PTOKEN_GROUPS				pGroups;
DWORD						dwSize;
UINT						uPos;


	pGroups = (PTOKEN_GROUPS)aInfoBuffer;

	if(!OpenProcessToken(GetCurrentProcess(),TOKEN_READ,&hAccessToken))
		{
		return FALSE;
		}

	bSuccess = GetTokenInformation(hAccessToken,TokenGroups,aInfoBuffer,sizeof(aInfoBuffer),&dwSize);
    CloseHandle(hAccessToken);


    if(!bSuccess)
		{
        return FALSE;
		}

    if(!AllocateAndInitializeSid(&sNtAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&pSidAdmin))
        {
		return FALSE;
		}

    bSuccess = FALSE;									// assume that we don't find the admin SID.

    for(uPos=0;uPos<pGroups->GroupCount;uPos++)
		{
        if(EqualSid(pSidAdmin,pGroups->Groups[uPos].Sid))
			{
            bSuccess = TRUE;
            break;
			}
		}

	FreeSid(pSidAdmin);


return bSuccess;
}

//*****************************************************************************
//*
//*		WowRedirect
//*
//*****************************************************************************
//	Die Umleitung des "C:\Windows\system32" Pfades ndern
//	iMode	: 0=umleiten 1=Umleitung aufheben
static void WowRedirect(int iMode)
{

	#ifndef _WIN64

	LPFN_WOW64DISABLE   Wow64Dir;

	if(iMode)
		{
		old_64_cnt++;

		if(old_64_cnt>1)return;

		Wow64Dir = (LPFN_WOW64DISABLE)GetProcAddress(GetModuleHandle("kernel32"),"Wow64DisableWow64FsRedirection");

		if(Wow64Dir)
			{
			Wow64Dir(&old_64_dis);
			}
		}
	else{
		if(old_64_cnt<=0)return;
		   old_64_cnt--;
		if(old_64_cnt<=0)return;

 		Wow64Dir = (LPFN_WOW64DISABLE)GetProcAddress(GetModuleHandle("kernel32"),"Wow64RevertWow64FsRedirection");

		if(Wow64Dir)
			{
			Wow64Dir(&old_64_dis);
			}
		}

	#endif

}

//*****************************************************************************
//*
//*		SetPrivilege
//*
//*****************************************************************************
#ifndef VAR_ONLY_ENV
static BOOL VarSetPrivilege(HANDLE hToken,LPCTSTR pPrivilege,BOOL bEnablePrivilege)
{
TOKEN_PRIVILEGES	sToken;
LUID				sLuid;


	if(!LookupPrivilegeValue(NULL,pPrivilege,&sLuid))	// lookup privilege on local system
		{
		return FALSE;
		}

	sToken.PrivilegeCount		= 1;
	sToken.Privileges[0].Luid	= sLuid;

	if(bEnablePrivilege)
		{
		sToken.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
		}
	else{
		sToken.Privileges[0].Attributes = 0;
		}

														// Enable the privilege or disable all privileges.

	if(!AdjustTokenPrivileges(hToken,FALSE,&sToken,sizeof(TOKEN_PRIVILEGES),(PTOKEN_PRIVILEGES)NULL,(PDWORD)NULL))
		{
		return FALSE;
		}

	if(GetLastError()==ERROR_NOT_ALL_ASSIGNED)
		{
		return FALSE;
		}


return TRUE;
}
#endif

//*****************************************************************************
//*
//*		TakeOwnership
//*
//*****************************************************************************
//	bernimmt den Besitz eines Objektes und setzt die Rechche fr die
//	User "Administrator" und "Jeder". Administratoren erhallten alle Rechte.
//	pObjectName	: Ist der Objektname (Datei oder Registry-Key)
//	uAccess		: Sind die Rechte fr den User "Jeder"
//					GENERIC_READ GENERIC_WRITE GENERIC_EXECUTE GENERIC_ALL
//	uType		: Ist der Typ des Objektes (siehe SE_OBJECT_TYPE)
//					1 = Datei
//					4 = Registry-Key
//	uCheck		: Prfen ob die Datei Schreibrechte hat
//	Ergibt TRUE wenn erfolgreich.
#ifndef VAR_ONLY_ENV
static BOOL VarTakeOwnership(LPTSTR pObjectName,unsigned uAccess,unsigned uType,unsigned uCheck)
{
const int					NUM_ACES	  = 2;
SID_IDENTIFIER_AUTHORITY	sSidAuthWorld =	SECURITY_WORLD_SID_AUTHORITY;
SID_IDENTIFIER_AUTHORITY	sSidAuthNt    = SECURITY_NT_AUTHORITY;
EXPLICIT_ACCESS				aAccess[NUM_ACES];
PSID						pSidEveryone;
PSID						pSidAdmin;
BOOL						bRetval;
HANDLE						hToken;
HANDLE						hFile;
PACL						pAcl;
DWORD						dwOsInfo;
DWORD						dwAttr;
DWORD						dwRes;



	dwOsInfo = GetWindowsVersionEx();

	if(dwOsInfo<=0x0005FFFF)return TRUE;					// Erst ab Vista


	if(uType==1 && uCheck)									// Schreibrechte der Datei prfen
		{
		   dwAttr = GetFileAttributes(pObjectName);
		if(dwAttr==0xFFFFFFFF)return TRUE;

		   hFile = CreateFile(pObjectName,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE|FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile!=INVALID_HANDLE_VALUE)
			{
			CloseHandle(hFile);
			return TRUE;
			}
		}


	pSidEveryone = NULL;
	pSidAdmin	 = NULL;
	bRetval		 = FALSE;
	hToken		 = NULL;
	pAcl		 = NULL;

															// Specify the DACL to use.
															// Create a SID for the Everyone group.
	if(!AllocateAndInitializeSid(&sSidAuthWorld,1,SECURITY_WORLD_RID,0,0,0,0,0,0,0,&pSidEveryone))
		{
		printf("AllocateAndInitializeSid (Everyone) error %u\n",GetLastError());
		goto Cleanup;
		}

															// Create a SID for the BUILTIN\Administrators group.
	if(!AllocateAndInitializeSid(&sSidAuthNt,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&pSidAdmin))
		{
		printf("AllocateAndInitializeSid (Admin) error %u\n",GetLastError());
		goto Cleanup;
		}

	ZeroMemory(&aAccess,NUM_ACES*sizeof(EXPLICIT_ACCESS));


	aAccess[0].grfAccessPermissions	=  uAccess;				// Set read access for Everyone.
	aAccess[0].grfAccessMode 		=  SET_ACCESS;
	aAccess[0].grfInheritance		=  NO_INHERITANCE;
	aAccess[0].Trustee.TrusteeForm	=  TRUSTEE_IS_SID;
	aAccess[0].Trustee.TrusteeType	=  TRUSTEE_IS_WELL_KNOWN_GROUP;
	aAccess[0].Trustee.ptstrName 	= (LPTSTR)pSidEveryone;


	aAccess[1].grfAccessPermissions	=  GENERIC_ALL;			// Set full control for Administrators.
	aAccess[1].grfAccessMode 		=  SET_ACCESS;
	aAccess[1].grfInheritance		=  NO_INHERITANCE;
	aAccess[1].Trustee.TrusteeForm	=  TRUSTEE_IS_SID;
	aAccess[1].Trustee.TrusteeType	=  TRUSTEE_IS_GROUP;
	aAccess[1].Trustee.ptstrName 	= (LPTSTR)pSidAdmin;

	if(SetEntriesInAcl(NUM_ACES,aAccess,NULL,&pAcl)!=ERROR_SUCCESS)
		{
		goto Cleanup;										// Failed SetEntriesInAcl
		}


	dwRes = SetNamedSecurityInfo(pObjectName,				// name of the object
								(SE_OBJECT_TYPE)uType,		// type of object
								 DACL_SECURITY_INFORMATION, // change only the object's DACL
								 NULL, NULL,				// do not change owner or group
								 pAcl,						// DACL specified
								 NULL); 					// do not change SACL

	if(dwRes==ERROR_SUCCESS)
		{
		bRetval = TRUE;										// No more processing needed.
		goto Cleanup;
		}

	if(dwRes!=ERROR_ACCESS_DENIED)
		{
		goto Cleanup;										// First SetNamedSecurityInfo call failed
		}


															// Open a handle to the access token for the calling process.
	if(!OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES,&hToken))
		{
		goto Cleanup;										// OpenProcessToken failed
		}


	if(!VarSetPrivilege(hToken,SE_TAKE_OWNERSHIP_NAME,TRUE))// Enable the SE_TAKE_OWNERSHIP_NAME privilege.
		{
		goto Cleanup;										// You must be logged on as Administrator
		}

															// Set the owner in the object's security descriptor.
	dwRes = SetNamedSecurityInfo(pObjectName,				// name of the object
								(SE_OBJECT_TYPE)uType,		// type of object
								 OWNER_SECURITY_INFORMATION,// change only the object's owner
								 pSidAdmin, 				// SID of Administrator group
								 NULL,
								 NULL,
								 NULL);

	if(dwRes!=ERROR_SUCCESS)
		{
		goto Cleanup;										// Could not set owner
		}

															// Disable the SE_TAKE_OWNERSHIP_NAME privilege.
	if(!VarSetPrivilege(hToken,SE_TAKE_OWNERSHIP_NAME,FALSE))
		{
		printf("Failed SetPrivilege call unexpectedly.\n");
		goto Cleanup;
		}

															// Try again to modify the object's DACL,now that we are the owner.
	dwRes = SetNamedSecurityInfo(pObjectName,				// name of the object
								(SE_OBJECT_TYPE)uType,		// type of object
								 DACL_SECURITY_INFORMATION, // change only the object's DACL
								 NULL,NULL,					// do not change owner or group
								 pAcl,						// DACL specified
								 NULL); 					// do not change SACL

	if(dwRes==ERROR_SUCCESS)
		{
		bRetval = TRUE;										// Successfully changed DACL
		}

Cleanup:

	if(pSidAdmin)
		{
		FreeSid(pSidAdmin);
		}

	if(pSidEveryone)
		{
		FreeSid(pSidEveryone);
		}

	if(pAcl)
		{
		LocalFree(pAcl);
		}

	if(hToken)
		{
		CloseHandle(hToken);
		}


return bRetval;
}
#endif


//*****************************************************************************
//*
//*		VersionCmp
//*
//*****************************************************************************
//	Vergeleicht zwei Versionsnummern
//	Ergibt 0 wenn beide gleich sind -1 wenn Text1 kleiner Text2 bzw +1 wenn grer
#ifndef VAR_ONLY_ENV
static int VersionCmp(const char *pText1,const char *pText2)
{
int		iVal1;
int		iVal2;
int		iLen1;
int		iLen2;
int		iPos;


	pText1 += strwlen(pText1,0xA0);
	pText2 += strwlen(pText2,0xA0);

	if(*pText1=='V' || *pText1=='v')*pText1++;
	if(*pText2=='V' || *pText2=='v')*pText1++;

	for(iPos=0;iPos<4;iPos++)
		{
		iVal1 = strtoi(pText1,0,&iLen1);
		iVal2 = strtoi(pText2,0,&iLen2);

		if(iVal1!=iVal2)return iVal1-=iVal2;

		pText1 += iLen1;
		pText2 += iLen2;

		if(*pText1=='.' || *pText1==',')*pText1++;
		if(*pText2=='.' || *pText2==',')*pText2++;
		}


return 0;
}
#endif 	

//*****************************************************************************
//*
//*		SetClipboardText
//*
//*****************************************************************************
//	Speichert einen Text in die Zwischenablage
//	pText	: Ist der Zeiger auf den Text
//	iSize	: Ist die maximale Lnge vom Text
//			  Wenn iSize kleine Null is wird die Lnge mit strlen bestimmt.
//	Ergibt die Lnge des gespeicherten Textes bzw. 0 wenn kein Text gespeichert wurde.
#ifndef VAR_ONLY_ENV
static void SetClipboardText(LPCTSTR pText)
{
HGLOBAL		hGlobal;
char 	   *pNew;
int			iSize;


	iSize   = strlen(pText)+1;
	hGlobal = GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,iSize);
	pNew    = (char*)GlobalLock(hGlobal);
	memcpy(pNew,pText,iSize);

	GlobalUnlock(hGlobal);

	if(OpenClipboard(0))
		{
		EmptyClipboard();
		if(!SetClipboardData(CF_TEXT,hGlobal))GlobalFree(hGlobal);
		CloseClipboard();
		}
	else{
		GlobalFree(hGlobal);
		}


}
#endif

//*****************************************************************************
//*
//*		GetClipboardText
//*
//*****************************************************************************
//	Holt einen Text aus der Zwischenablage.
//	pLen	: Hier wird die Lnge des Textes gespeichert.
//	Ergibt einen Zeiger auf den Text der in der Zwischenablage liegt.
//	Der Zeiger muss spter wieder mit delete gelscht werden
//	Ist kein Text in der Zwischenablage so wird 0 zurck gegeben.
#ifndef VAR_ONLY_ENV
static char *GetClipboardText()
{
HGLOBAL		hGlobal;
char 	   *pData;
char 	   *pPtr;
int			iNum;




	if(!IsClipboardFormatAvailable(CF_TEXT))		// Ist ein Text gespeichert ?
		{
		return 0;
		}

	if(!OpenClipboard(0))
		{
		return 0;
		}

		hGlobal = GetClipboardData(CF_TEXT);
	if(!hGlobal)
		{
		CloseClipboard();
		return 0;
		}

		pData=(char*)GlobalLock(hGlobal);			// Speicher erzeugen
	if(!pData)
		{
		CloseClipboard();
		return 0;
		}

	   iNum=strlen(pData);
	if(iNum>0)
		{
		pPtr=new char[iNum+1];
		memcpy(pPtr,pData,(iNum+1)*sizeof(char));
		}
	else{
		pPtr=0;
		}


	GlobalUnlock(hGlobal);
	CloseClipboard();



return pPtr;
}
#endif

//*****************************************************************************
//*
//*		ExistReg
//*
//*****************************************************************************
//	Prft ob ein Registry Pfad existiert
//	Path	: Ist der Pfad nach dem gesucht wird
//	Ergibt	0 = Kein Registry-Pfad
//			1 = Registry-Pfad
//			2 = DWORD-Eintrag
//			3 = String-Eintrag
//			4 = Multi-String
//			5 = Bimr-Eintrag
//			6 = Anderer Eintrag
#ifndef VAR_ONLY_ENV
static int ExistReg(const  char *Path)
{
CRegKeys	key;
const char *name;
char		path[256];
int			len;

	len=strlen(Path);

	if(len<=0 || Path[len-1]!='\\')
	if(key.Open(Path,CRK_READ|CRK_WOW64_64KEY))
		{
		return 1;
		}

	strlcpy(path,Path,sizeof(path));
	name=Path+SetFileName(path,"");
	DelBackSlash(path);

	if(!key.Open(path,CRK_READ|CRK_WOW64_64KEY))
		{
		return 0;
		}

	if(!name[0])name=NULL;
	if(key.GetLength(name)==-1)return 0;

	switch(key.Type())
		{
	case REG_DWORD:		return 2;
	case REG_SZ:		return 3;
	case REG_EXPAND_SZ:	return 3;
	case REG_MULTI_SZ:	return 4;
	case REG_BINARY:	return 5;
		}


return 6;
}
#endif

#ifndef VAR_ONLY_ENV
#ifdef  VAR_HAS_FTPCOPY

#include "FtpTools/FtpTools.h"

typedef struct
	{
	int			only;
	int			size;
	time_t		time;
	}FtpFileData;

__int64	size_offset		= 0;
int 	size_mode		= 0;
int 	size_max		= 0;
int 	size_now		= 0;


//*****************************************************************************
//*
//*		VarErrorToText
//*
//*****************************************************************************
static char *VarErrorToText(unsigned Error,char *Default)
{

	switch(Error)
		{
	case ERROR_INVALID_PARAMETER:				return "Fehlerhafter Parameter";
	case ERROR_CALL_NOT_IMPLEMENTED:			return "Die Funktion ist nicht implementiert";
	case ERROR_OPEN_FAILED:						return "Fehler beim ffnen der Datei";
	case ERROR_GRACEFUL_DISCONNECT:				return "Die Verbindung wurde abgebrochen";
	case ERROR_LOGON_FAILURE:					return "Es gab einen Fehler bein Login";
	case ERROR_WRONG_PASSWORD:					return "Falsches Passwort";
	case ERROR_OPERATION_ABORTED:				return "Es gab einen User-Abbruch";
	case ERROR_DISK_FULL:						return "Die  Festplatte ist voll";
	case ERROR_TIMEOUT:							return "Es gab einen Timeout";
	case ERROR_WRITE_FAULT:						return "Es gab eine Fehler beim Schreiben";
	case ERROR_BAD_NETPATH:						return "Der Hostnamen ist ungltig";
	case ERROR_HOST_UNREACHABLE:				return "Der Host ist nicht erreichbar";
	case ERROR_FILE_NOT_FOUND:					return "Eine Datei wurde nicht gefunden";
	case ERROR_CANNOT_MAKE:						return "Die lokale Datei konnte nicht erzeugt werden";
	case ERROR_PROTOCOL_UNREACHABLE:			return "Die Datenverbindung konnte nicht geffnet werden";
	case ERROR_INVALID_TIME:					return "Falsche Zeitangabe";
	case ERROR_READ_FAULT:						return "Es gab einen Fehler beim Lesen";
	case ERROR_NET_WRITE_FAULT:					return "Die Daten konnten nicht zum Host versand werden";
	case ERROR_OUTOFMEMORY:						return "Zuwenig Speicher";
	case ERROR_DEVICE_REINITIALIZATION_NEEDED:	return "Das Gert ist nicht initialisliert";
	case ERROR_INVALID_HANDLE:					return "Falsches Handle";
	case ERROR_CONTINUE:						return "Der Vorgang ist noch aktiv";
	case ERROR_ALREADY_ASSIGNED:				return "Die Verbindung ist noch aktiv";
	case ERROR_NOT_CONNECTED:					return "Es ist keine Verbindung vorhanden";
	case ERROR_CANCELLED:						return "Benutzerabbruch";
	case ERROR_TOO_MANY_SESS:					return "Es sind zuviele Instanzen offen";
	case ERROR_NETWORK_UNREACHABLE:				return "Das Netzwerk ist heruntergefahren";
	case ERROR_BUSY:							return "Das Gert ist beschftigt";
	case ERROR_RESOURCE_DISABLED:				return "Das Gert ist ist blockiert";
	case ERROR_INTERNAL_ERROR:					return "Interner Fehler";
	case ERROR_CRC:								return "CRC Fehler";
	case ERROR_SERVICE_REQUEST_TIMEOUT:			return "Timeout beim Request";
	case ERROR_HANDLE_EOF:						return "Das Ende der Datei wurde erreicht";
	case ERROR_ACCESS_DENIED:					return "Der Zugriff wurde verweigert";
	case ERROR_DEVICE_NOT_CONNECTED:			return "Dar Gert ist nicht verbunden";
	case ERROR_PATH_NOT_FOUND:					return "Der Pfad wurde nicht gefunden";
	case ERROR_REQ_NOT_ACCEP:					return "Die Anfrage wurde nicht akzeptiert";
	case ERROR_INVALID_DLL:						return "Die DLL konnte nicht geladen werden.";
	case ERROR_MOD_NOT_FOUND:					return "Eine DLL wurde nicht gedunden.";
		}

return Default;
}

//*****************************************************************************
//*
//*		VarCheckLocal
//*
//*****************************************************************************
//	Prft ob eine lokale Datei berschrieben werden darf
//	Path		: Pfad der lokalen Datei.
//	Time		: nderungszeit der Remote-Datei
//	Art			: Eingestllte Flags:
//					Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//					Bit1!=0 werden Fehlermeldungen ausgegeben
//  				Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  				Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  				Bit8!=0 werden ber zhlige Dateien am FTP Server gelscht
//	Ergibt 0 wenn die Datei nicht berschrieben werden darf oder:
//					0 = Nicht berschreiben
//					1 = Datei existiert nicht
//					2 =	Bestehende Datei berschreiben
//					3 =	Datei ist ein Verzeichnis
static int VarCheckLocal(const char *Path,const FILETIME *Time,int Art)
{
WIN32_FILE_ATTRIBUTE_DATA	data;

													// Existiert die Datei
	if(!GetFileAttributesEx(Path,GetFileExInfoStandard,&data))
		{
		return 1;
		}
													// Ist es ein Verzeichnis
	if(data.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
		{
		return 3;
		}

	if(Art&0x08)									// Nie berschreiben
		{
		return 0;
		}

	if(Art&0x20)									// Schreibgeschtzte nicht berschreiben
	if(data.dwFileAttributes&FILE_ATTRIBUTE_READONLY)
		{
		return 0;
		}

	if(Art&0x01)									// Prfe Zeit
	if(CompareFileTime(Time,&data.ftLastWriteTime)<=0)
		{
		return 0;
		}
													// Den Schreibschutz aufheben
	if(data.dwFileAttributes&FILE_ATTRIBUTE_READONLY)
		{
		SetFileAttributes(Path,FILE_ATTRIBUTE_NORMAL);
		}



return 2;
}

//*****************************************************************************
//*
//*		VarCheckLocal
//*
//*****************************************************************************
//	Prft ob eine lokale Datei berschrieben werden darf
//	Path		: Pfad der lokalen Datei.
//	Time		: nderungszeit der Remote-Datei
//	Art			: Eingestllte Flags:
//					Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//					Bit1!=0 werden Fehlermeldungen ausgegeben
//  				Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  				Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  				Bit8!=0 werden ber zhlige Dateien am FTP Server gelscht
//	Ergibt 0 wenn die Datei nicht berschrieben werden darf oder:
//					0 = Nicht berschreiben
//					1 = Datei existiert nicht
//					2 =	Bestehende Datei berschreiben
//					3 =	Datei ist ein Verzeichnis
static int VarCheckLocal(const char *Path,time_t iTime,int Art)
{
FILETIME	sFileTime;


	UtcTimeToFileTime(iTime,&sFileTime);


return VarCheckLocal(Path,&sFileTime,Art);
}

//*****************************************************************************
//*
//*		VarCopyFtp
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien auf/von einem Ftp Server
//  Ist bei Art Bit  0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit  1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit  3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit  5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
//			-3   wenn keine Verbindung aufgebaut werden konnet
//			-4   bei  einem falschen Login
int VarCopyFtp(char *Quelle,char *Ziel, char *Plus,char *Minus,int Unter,int Art)
{
char				 msg    [512];
char				 temp   [512];
char				 path   [512];
char				 server [256];
char				 username[64];
char				 passwd  [64];
CFtpBase   			*ftp_s;
CFtpBase			*ftp_t;
CFtpBaseFind		*find;
CFileFinder			 suche;
CStringChain		 dirs;
CStringChain		 list;
CString				 name;
CString				 s_url;
CString				 t_url;
char				*text,*txt,*ptr,*fpath,*fname;
char				 s_dir[MAX_PATH+1024+16];
char				 t_dir[MAX_PATH+1024+16];
int					 t_len,t_off,s_mode;
int					 s_len,s_off,t_mode;
int					 size,tick,exit,flags;
int					 x,ok,pos,ignore,attr;
int					 kopie_anz;
int 				 size_all;
int					 number;
int					 byte;
int					 diff;
int					 arch;
unsigned			 port;
FtpFileData			 data;
FILETIME			 zeit;




	VarSet("ERRORLEVEL","0");
	VarGetName("ZIP_FILTER",zip_filter,sizeof(zip_filter));
	PathConvert(zip_filter,'/');


	s_mode		= GetFtpConnType(Quelle,TRUE);
	t_mode		= GetFtpConnType(Ziel  ,TRUE);
	arch		= s_mode==FTP_MODE_ARCH;
	size_mode	= 0;
	size_offset	= 0;
	kopie_anz	= 0;
	number		= 0;
	ignore		= 0;
	text		= 0;
	tick		= 0;
	exit		= 0;
	find		= 0;
	ftp_s		= 0;
	ftp_t		= 0;

//*****************************************************************************

if(s_mode!=FTP_MODE_NONE && t_mode!=FTP_MODE_NONE)
do	{												// FTP-Verbindung ffnen
	s_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY|FTP_MODE_PASSIVE;
	t_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY|FTP_MODE_PASSIVE;

	try	{
		path	[0] = 0;
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Quelle,server,sizeof(server),username,passwd,&port,0,path,sizeof(path)|STR_NOROOTSIGN);

		if(!arch)
			{
			if(!server  [0])throw "Falsche FTP-Server-Name";
			if(!username[0])throw "Falsche User-Namen";
			}

		if(VarMessage)								// Ausgabe in Dialog ?
			{
			char 	text[768];
			int		param;
			int		x,y,z;

			x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
			y = strlcpy(text+x  ,Ziel        ,sizeof(text)-x  );
			z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

			param   = 0x80000000|x|(y<<7)|(z<<16);

			VarMessage(VarParam,param,text);
			}


		ftp_s = GetFtpConnectionEx(server,username,passwd,port,s_mode,path);

		if(arch && !server[0])
			{
			strncpy(server,path,sizeof(server));
			path[0] = 0;
			}

													// Ab lokalen Pfad
		if(path[0]=='.' && (path[1]==0 || path[1]=='/' || path[1]=='\\'))
			{
			if(!ftp_s->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(path[1]){AddBackSlash(name,'/');name+=path+2;}
			strlcpy(path,name,sizeof(path));
			}

		s_url  = ftp_s->GetProtocol();
		s_url += ftp_s->GetServerName();

		temp    [0] = 0;
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Ziel,server,sizeof(server),username,passwd,&port,0,temp,sizeof(temp)|STR_NOROOTSIGN);

		if(!server  [0])throw "Falsche FTP-Server-Name";
		if(!username[0])throw "Falsche User-Namen";


		ftp_t = GetFtpConnectionEx(server,username,passwd,port,t_mode,path);

													// Ab lokalen Pfad
		if(temp[0]=='.' && (temp[1]==0 || temp[1]=='/' || temp[1]=='\\'))
			{
			if(!ftp_t->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(temp[1]){AddBackSlash(name,'/');name+=temp+2;}
			strlcpy(temp,name,sizeof(temp));
			}

		t_url  = ftp_t->GetProtocol();
		t_url += ftp_t->GetServerName();
		}
	catch(char *error)
		{
		text = error;
		exit = -3;
		break;
		}
	catch(CInternetException *error)
		{
		text = VarErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		exit = (error->m_dwError==ERROR_INVALID_PASSWORD)? -4:-3;
		break;
		}
	catch(...)
		{
		text = "Keine Verbindung zum FTP-Server";
		exit = -3;
		break;
		}



	s_dir[0] = '/';
	t_dir[0] = '/';
	s_off    = strlcpy(s_dir+1,path,sizeof(s_dir)-1)+1;
	t_off    = strlcpy(t_dir+1,temp,sizeof(t_dir)-1)+1;
	dirs.Add("");
	tick++;

	PathConvert(t_dir,'/');
	PathConvert(s_dir,'/');

	GetTempPath(sizeof(path),path);
	GetTempFileName(path,"VAR",0,temp);


	while(dirs.Count()>0 && exit!=-2)				// Verzeichnis Schleife
		{
		ptr  = dirs[0];

		if(*ptr== '/')ptr++;
		if(*ptr=='\\')ptr++;

		s_len = AddBackSlash('/',s_dir,s_off);		// "/root/"
		t_len = AddBackSlash('/',t_dir,t_off);		// "D:/temp/"

		t_len = strlcpy(t_dir+t_len,ptr,sizeof(t_dir)-t_len)+t_len;
		s_len = strlcpy(s_dir+s_len,ptr,sizeof(s_dir)-s_len)+s_len;

		s_len = AddBackSlash('/',s_dir,s_len);		// "/root/.../"
		t_len = AddBackSlash('/',t_dir,t_len);		// "D:/temp/.../"

		dirs.Del(0);

		if(!ftp_t->SetCurrentDirectory(t_dir))
		if(!ftp_t->CreatePath         (t_dir))
			{
			text = "Kann FTP-Verzeichnis nicht erzeugen";
			exit = -1;
			break;
			}


		if(Art&0x29)								// Dateien am Ziel-FTP-Server einlesen
			{
			list.Del();
			list.DataLength(sizeof(FtpFileData));
			find = new CFtpBaseFind(ftp_t);
			ok   = find->FindFile(t_dir,Plus,Minus,INTERNET_FLAG_NO_DIRS);

			while(ok)
				{
				ok        = find->FindNextFile();
				name      = find->GetFileName();
				data.size = find->GetLength();
				data.time = find->GetLastWriteTime();
				data.only = find->IsReadOnly();
				list.Add(name,CSC_END,&data);
				}

			find->Close();
			delete find;
			find = 0;

			list.Sort(0,-1,CSC_SORT_CASE);
			}


		     find=new CFtpBaseFind(ftp_s);			// Dateien am Quell-FTP-Server einlesen
		ok = find->FindFile(s_dir,Plus,Minus,INTERNET_FLAG_NO_DOTS|INTERNET_FLAG_ALL_DIRS);


		t_len = AddBackSlash('/',t_dir,t_len);
		s_len = AddBackSlash('/',s_dir,s_len);


		while(ok && exit!=-2)						// Einzelne Datei-Kopier-Schleife
			{
			ok   = find->FindNextFile ();
			byte = find->GetLength    ();
			name = find->GetFileName  ();
			attr = find->GetAttributes()>>16;

			size = strlcpy(s_dir+s_len,name,sizeof(s_dir)-s_len);
				   strlcpy(t_dir+t_len,name,sizeof(t_dir)-t_len);



			if(s_mode==FTP_MODE_ARCH && zip_filter[0])
				{
				if(zip_filter[0]=='!')
					{
					if(!memxcmp(zip_filter+1,s_dir+1,size-1,1))
						{
						return 1;
						}
					}
				else{
					if(memxcmp(zip_filter,s_dir+1,size-1,1))
						{
						return 1;
						}
					}
				}

			if(find->IsDirectory())					// Verzeichnis gefunden
				{
				if(Unter==0)continue;
				dirs.Add(s_dir+s_off);
				continue;
				}

			if(Art&0x29)							// Datum und Attribute prfen
				{
				   pos = list.FindFast(name,0,-1,0x01);
				if(pos>=0)
					{
					data = *(FtpFileData*)list.Data(pos);
					diff = find->GetLastWriteTime()-data.time;
					list.Del(pos);

					if((Art&0x08)             )continue;	// Vorhandene Dateien nie berschreiben
					if((Art&0x20) && data.only)continue;	// Schreibgeschtzte nicht berschreiben
					if((Art&0x01) && diff>-59 )continue;	// Prfe Zeit
					}
				}


			if(VarMessage)							// Ausgabe in Dialog ?
				{
				char 	text[768];
				int		param;
				int		x,y,z;

				x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
				y = strlcpy(text+x  ,s_dir       ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

				param   = 0x80000000|x|(y<<7)|(z<<16);

				VarMessage(VarParam,param,text);
				}

			x = ftp_s->GetFile(s_dir,temp,0);		// Datei herunterladen

			if(!x)									// Gab es einen Fehler
				{
				if(Art&2)
					{
					sprintf(msg,"Fehler beim Herunterladen von:\n%s",s_dir);
					x=MessageBox((HWND)VarWindow,msg,"Fehler",MB_OKCANCEL|MB_ICONERROR);
					if(x==IDCANCEL){exit=-2;break;}
					}

 				exit=-1;
				continue;
				}

				x = ftp_t->PutFile(temp,t_dir);		// Datei hinaufladen
			if(!x)
				{
				Sleep(1000);
				ftp_t->SetOption(INTERNET_OPTION_RECONNECT,3);
				x = ftp_t->PutFile(temp,t_dir);		// Zweiter Versuch
				}


			if(!x)
				{
				if(Art&2)
					{
					sprintf(msg,"Fehler beim Hinaufladen von:\n%s",t_dir);
					x=MessageBox((HWND)VarWindow,msg,"Fehler",MB_OKCANCEL|MB_ICONERROR);
					if(x==IDCANCEL){exit=-2;break;}
					}

				exit=-1;
				continue;
				}

			kopie_anz++;

			if(!attr && !CmpFileType(name,"so"))	// Execute Flags setzen
				{
				x = LoadMemory(temp,msg,8);

				if(x>=4 && (!memcmp(msg,"\177ELF",4) || !memcmp(msg,"#!",2)))
					{
					attr = (0755<<16)|FILE_ATTRIBUTE_EXEC;
					}
				}

			if(attr)								// Attribute setzen
				{
				ftp_t->SetAttributes(t_dir,attr);
				}

			if(VarMessage)							// Gre ausgeben
				{
				VarMessage(VarParam,0x1234,(char*)byte);
				}
			}


		find->Close();
		delete find;
		find = 0;
		}

	RemoveFile(temp);

	}while(0);

//*****************************************************************************

else if(s_mode!=FTP_MODE_NONE)
do	{
	s_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY|FTP_MODE_PASSIVE;

	try	{											// FTP-Verbindung ffnen
		path	[0] = 0;
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Quelle,server,sizeof(server),username,passwd,&port,0,path,sizeof(path)|STR_NOROOTSIGN);

		if(!server  [0])throw "Falsche FTP-Server-Name";
		if(!username[0])throw "Falsche User-Namen";

		if(VarMessage)								// Ausgabe in Dialog ?
			{
			char 	text[768];
			int		param;
			int		x,y,z;

			if(!strcmp(Ziel,"*MOVE"))
				{
				x = strlcpy(text    ,"Verschiebe: '",sizeof(text) );
				y = strlcpy(text+x  ,Plus        ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);
				}
			else if(!strcmp(Ziel,"*CREATE"))
				{
				x = strlcpy(text    ,"Erstelle: '",sizeof(text)   );
				y = strlcpy(text+x  ,Quelle      ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);
				}
			else if(!strcmp(Ziel,"*DEL"))
				{
				x = strlcpy(text    ,"Lsche: '" ,sizeof(text)    );
				y = strlcpy(text+x  ,Quelle      ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);
				}
			else if(!strcmp(Ziel,"*EXIST"))
				{
				x = strlcpy(text    ,"Suche: '"  ,sizeof(text)    );
				y = strlcpy(text+x  ,Quelle      ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);
				}
			else{
				x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
				y = strlcpy(text+x  ,Ziel        ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);
				}

			param   = 0x80000000|x|(y<<7)|(z<<16);

			VarMessage(VarParam,param,text);
			}

		ftp_s = GetFtpConnectionEx(server,username,passwd,port,s_mode|FTP_MODE_RECONN|FTP_MODE_PASSIVE,path);

													// Ab lokalen Pfad
		if(path[0]=='.' && (path[1]==0 || path[1]=='/' || path[1]=='\\'))
			{
			if(!ftp_s->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(path[1]){AddBackSlash(name,'/');name+=path+2;}
			strlcpy(path,name,sizeof(path));
			}

		if(path[0]!='/' && path[1]!='\\')			// Slash an den Anfang
			{
			strpre(path,"/");
			}

		PathConvert (path,'/');
		DelBackSlash(path);

		s_url  = ftp_s->GetProtocol  ();			// Pfad als URL holen "ftp://192.168.0.1
		s_url += ftp_s->GetServerName();
		}
	catch(char *error)
		{
		text = error;
		exit = -3;
		break;
		}
	catch(CInternetException *error)
		{
		text = VarErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		exit = (error->m_dwError==ERROR_INVALID_PASSWORD)? -4:-3;
		break;
		}
	catch(...)
		{
		text = "Keine Verbindung zum FTP-Server";
		exit = -3;
		break;
		}

	dirs.Add(path);

	if(*Ziel=='*')									// Spezial Funktionen
		{
		Ziel++;

		if(!strcmp(Ziel,"MOVE"))
			{
			exit = (ftp_s->Rename(path,Plus))? 1:-1;
			ftp_s->Close();
			delete ftp_s;
			return exit;
			}

		if(!strcmp(Ziel,"CREATE"))
			{
			exit = (ftp_s->CreatePath(path))? 1:-1;
			ftp_s->Close();
			delete ftp_s;
			return exit;
			}

		if(!strcmp(Ziel,"EXIST"))
			{
			CFtpBaseFind find(ftp_s);

			GetFilePathR(temp,path,sizeof(temp));

			if(!find.FindFile(temp,GetFileName(path),"",INTERNET_FLAG_NO_DOTS))
				{
				ftp_s->Close();
				delete ftp_s;
				return -1;
				}

			find.FindNextFile();

			exit = (find.IsDirectory())? 1:0;
			ftp_s->Close();
			delete ftp_s;
			return exit;
			}

		if(!strcmp(Ziel,"DEL"))
			{
			if(ftp_s->Remove(path))
				{
				exit = 1;
				}
			else if(ftp_s->RemovePath(path))
				{
				exit = 1;
				}
			else{
				exit =-1;
				}

			ftp_s->Close();
			delete ftp_s;
			return exit;
			}
		}

	s_off	= dirs.Len(0);
	t_off   = strlcpy(t_dir,Ziel,sizeof(t_dir));	// Lokalen Basispfad erzeugen
	t_off   = DelBackSlash(t_dir,t_off);

	tick++;


	while(dirs.Count()>0 && exit!=-2)				// Verzeichnis Schleife
		{
		fpath = dirs.Get(0);
		size  = dirs.Len(0);

		s_len = strlcpy(s_dir      ,fpath      ,sizeof(s_dir),size);
		t_len = strlcpy(t_dir+t_off,fpath+s_off,sizeof(t_dir)-t_off)+t_off;

		s_len = AddBackSlash('/',s_dir,s_len);		// "/root/"
		t_len = AddBackSlash(    t_dir,t_len);		// "D:/temp/"

		list.Del( );
		dirs.Del(0);

		PathConvert(t_dir+t_off);
		CreatePath (t_dir);

		find  = new CFtpBaseFind(ftp_s);			// Dateien im FTP-Verzeichnis suchen
		ok    = find->FindFile(s_dir,Plus,Minus,INTERNET_FLAG_NO_DOTS|INTERNET_FLAG_ALL_DIRS);

		while(ok && exit!=-2)
			{
			ok   = find->FindNextFile();
			name = find->GetFileName();
			byte = find->GetLength();

			size = strlcpy(s_dir+s_len,name,sizeof(s_dir)-s_len);
			       strlcpy(t_dir+t_len,name,sizeof(t_dir)-t_len);


			if(s_mode==FTP_MODE_ARCH && zip_filter[0])
				{
				if(zip_filter[0]=='!')
					{
					if(!memxcmp(zip_filter+1,s_dir+1,size-1,1))
						{
						return 1;
						}
					}
				else{
					if(memxcmp(zip_filter,s_dir+1,size-1,1))
						{
						return 1;
						}
					}
				}


			if(find->IsDirectory())					// Verzeichnis gefunden
				{
				if(Unter)
					{
					dirs.Add(s_dir);				// Im diesem Verzeichnis weitersuchen
					}

				continue;
				}


			find->GetLastWriteTime(&zeit);

			if(!VarCheckLocal(t_dir,&zeit,Art))		// Lokale Dateien berschreiben ?
				{
				continue;
				}

			if(VarMessage)							// Ausgabe in Dialog ?
				{
				char 	text[768];
				int		param;
				int		x,y,z;

				x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
				y = strlcpy(text+x  ,s_dir       ,sizeof(text)-x  );
				z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

				param   = 0x80000000|x|(y<<7)|(z<<16);

				VarMessage(VarParam,param,text);
				}

		Retry2:

			if(!ftp_s->GetFile(s_dir,t_dir,0))		// Datei kopieren
				{
				if(Art&2)
					{
					sprintf(msg,"Fehler beim Herunterladen von:\n%s",s_dir);
					x=MessageBox((HWND)VarWindow,msg,"Fehler",MB_ABORTRETRYIGNORE|MB_ICONERROR);
					if(x==IDABORT){exit=-2;break;}
					if(x==IDRETRY){goto   Retry2;}
					}

 				exit=-1;
				}
			else{
				kopie_anz++;

				if(VarMessage)						// Gre ausgeben
					{
					VarMessage(VarParam,0x1234,(char*)byte);
					}
				}
			}


		find->Close();
		delete find;
		find = 0;
		}

	}while(0);

//*****************************************************************************

else if(t_mode!=FTP_MODE_NONE)
do	{
	t_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY|FTP_MODE_PASSIVE;

			 flags =CFF_FIND_ALL;
	if(Unter)flags|=CFF_FIND_SUBDIR;

	if(VarMessage)									// Ausgabe in Dialog ?
		{
		char 	text[768];
		int		param;
		int		x,y,z;

		x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
		y = strlcpy(text+x  ,Quelle      ,sizeof(text)-x  );
		z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

		param   = 0x80000000|x|(y<<7)|(z<<16);

		VarMessage(VarParam,param,text);
		}

	suche.Read(Quelle,flags,Plus,Minus);			// Suche Dateien im lokalen Verzeichnis
	size_all = (int)suche.GetSizeAll();

	try	{											// FTP-Verbindung ffnen
		path    [0] = 0;
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Ziel,server,sizeof(server),username,passwd,&port,0,path,sizeof(path)|STR_NOROOTSIGN);

		if(!server  [0])throw "Falsche FTP-Server-Name";
		if(!username[0])throw "Falsche User-Namen";

		if(VarMessage)								// Ausgabe in Dialog ?
			{
			char 	text[768];
			int		param;
			int		x,y,z;

			x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
			y = strlcpy(text+x  ,Quelle      ,sizeof(text)-x  );
			z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

			param   = 0x80000000|x|(y<<7)|(z<<16);

			VarMessage(VarParam,param,text);
			}

		ftp_t = GetFtpConnectionEx(server,username,passwd,port,t_mode|FTP_MODE_RECONN|FTP_MODE_PASSIVE,path);

													// Ab lokalen Pfad
		if(path[0]=='.' && (path[1]==0 || path[1]=='/' || path[1]=='\\'))
			{
			if(!ftp_t->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(path[1]){AddBackSlash(name,'/');name+=path+2;}
			strlcpy(path,name,sizeof(path));
			}

		if(path[0]!='/' && path[1]!='\\')			// Slash an den Anfang
			{
			strpre(path,"/");
			}

		PathConvert (path,'/');
		DelBackSlash(path);

		t_url  = ftp_t->GetProtocol  ();			// Pfad als URL holen "ftp_t://192.168.0.1
		t_url += ftp_t->GetServerName();
		}
	catch(char*)
		{
		text = "Falsche Ftp-Server-Name";
		exit = -3;
		break;
		}
	catch(CInternetException *error)
		{
		text = VarErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		exit = (error->m_dwError==ERROR_INVALID_PASSWORD)? -4:-3;
		break;
		}
	catch(...)
		{
		text = "Keine Verbindung zum FTP-Server";
		exit = -3;
		break;
		}


	t_off   = strlcpy(t_dir,path,sizeof(t_dir));
	t_off   = AddBackSlash('/',t_dir,t_off);
	t_len	= t_off;
	PathConvert(t_dir,'/');
	path[0] = '*';
	path[1] = 0;
	ignore	= 1;
	tick   += 1;


	if(!ftp_t->SetCurrentDirectory(t_dir))			// FTP-Verzeichnis erstellen
	if(!ftp_t->CreatePath         (t_dir))
		{
		text = "Kann FTP-Verzeichnis nicht erzeugen";
		exit = -1;
		break;
		}

	while(exit!=-2)									// Datei Schleife
		{
			ptr=suche.Next(1);						// z.B.  "D:/Temp/Data/Test.txt"
		if(!ptr)									// Wurden alle lokalen Dateien verarbeitet
			{
			break;
			}

		byte  = suche.Len();
		fname = suche.Name();						// z.B.  "Test.txt"
		fpath = suche.Path(-1,1);					// z.B.  "Temp/Data/"

		if(strcmp(path,fpath))						// Hat sich das Verzeichnis verndert
			{
			x  =  strlcpy     (path       ,fpath,sizeof(path));
			x  =  strlcpy     (t_dir+t_off,fpath,sizeof(t_dir)-t_off,x);
			x  =  DelBackSlash(t_dir+t_off, x );
				  PathConvert (t_dir+t_off,'/');

			ignore = 0;
			t_len  = AddBackSlash('/',t_dir,t_off+x);

			if(!ftp_t->SetCurrentDirectory(t_dir))	// Verzeichnis am FTP-Server erstellen
			if(!ftp_t->CreatePath         (t_dir))
				{
				text = "Kann FTP-Verzeichnis nicht ffnen";
				exit = -1;
				break;
				}

			if(Art&0x29)							// Dateien am FTP-Server einlesen
				{
				list.Del();
				list.DataLength(sizeof(FtpFileData));
				find = new CFtpBaseFind(ftp_t);
				ok   = find->FindFile(t_dir,Plus,Minus,INTERNET_FLAG_NO_DIRS);

				while(ok)
					{
					ok        = find->FindNextFile();
					name      = find->GetFileName();
					data.size = find->GetLength();
					data.time = find->GetLastWriteTime();
					data.only = find->IsReadOnly();
					list.Add(name,CSC_END,&data);
					}

				find->Close();
				delete find;
				find=0;

				list.Sort(0,-1,CSC_SORT_CASE);
				}
			}

		if(ignore)continue;							// Wird das Verzeichnis ausgelassen



		if(Art&0x29)								// Datum und Attribute prfen
			{
			   pos = list.FindFast(fname,0,-1,0x01);
			if(pos>=0)
				{
				data = *(FtpFileData*)list.Data(pos);
				list.Del(pos);

				if((Art&0x08)                           )continue;	// Vorhandene Dateien nie berschreiben
				if((Art&0x20) && data.only              )continue;	// Schreibgeschtzte nicht berschreiben
				if((Art&0x01) && suche.Time()<=data.time)continue;	// Zeit prfen
				}
			}


		strlcpy(t_dir+t_len,fname,sizeof(t_dir)-t_len);

		if(VarMessage)								// Ausgabe in Dialog ?
			{
			char 	text[768];
			int		param;
			int		x,y,z;

			sprintf(temp,"%s%s",(LPCSTR)t_url,t_dir);

			x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
			y = strlcpy(text+x  ,temp        ,sizeof(text)-x  );
			z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

			param   = 0x80000000|x|(y<<7)|(z<<16);

			VarMessage(VarParam,param,text);
			}

Retry3:
		size_max	 = suche.Len();
		size_mode    = 2;
		x = ftp_t->PutFile(ptr,t_dir);				// Datei hinaufladen
		size_offset += suche.Len();
		size_mode    = 1;


		if(!x)										// Fehler beim Hinaufladen
			{
			if(Art&2)
				{
				txt=VarErrorToText(GetLastError(),"");
				sprintf(msg,"Fehler beim Hinaufladen von:\n%s%s%s%s",t_dir,(*txt)? "\n(":"",txt,(*txt)? ")":"");
				x=MessageBox((HWND)VarWindow,msg,"Fehler",MB_ABORTRETRYIGNORE|MB_ICONERROR);
				if(x==IDABORT){exit=-2;break;}
				if(x==IDRETRY)
					{
					size_offset -= suche.Len();
					goto Retry3;
					}
				}

			exit=-1;
			continue;
			}

		kopie_anz++;


		if(VarMessage)								// Gre ausgeben
			{
			VarMessage(VarParam,0x1234,(char*)byte);
			}

		if(!CmpFileType(fname,"so"))				// Execute Flags setzen
			{
			x = LoadMemory(ptr,temp,8);

			if(x>=4 && (!memcmp(temp,"\177ELF",4) || !memcmp(temp,"#!",2)))
				{						   
				ftp_t->SetAttributes(t_dir,(0755<<16)|FILE_ATTRIBUTE_EXEC);
				}
			}
		}

	}while(0);


//*****************************************************************************

	size_mode	= 0;
	size_offset	= 0;


	if(Art&2 && text)
		{
		x=MessageBox((HWND)VarWindow,text,"Fehler",MB_OKCANCEL|MB_ICONERROR);
		if(x==IDCANCEL)exit=-2;
		else		   exit=-1;
		}

	if(ftp_t)
		{
		ftp_t->Close();
		delete ftp_t;
		}

	if(ftp_s)
		{
		ftp_s->Close();
		delete ftp_s;
		}


return exit;
}

#else

int VarCopyFtp(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,int Art)
{

	if(Ziel && !stricmp(Ziel,"*DEL"))
		{
		MessageBox((HWND)VarWindow,"DELETE_FTP wird in von diesem Installer nicht untersttzt !","Fehler",MB_OK|MB_ICONERROR);
		}
	else if(Ziel && !stricmp(Ziel,"*EXIST"))
		{
		MessageBox((HWND)VarWindow,"EXIST_FTP wird in von diesem Installer nicht untersttzt !","Fehler",MB_OK|MB_ICONERROR);
		}
	else if(Ziel && !stricmp(Ziel,"*CREATE"))
		{
		MessageBox((HWND)VarWindow,"CREATE_FTP wird in von diesem Installer nicht untersttzt !","Fehler",MB_OK|MB_ICONERROR);
		}
	else if(Ziel && !stricmp(Ziel,"*MOVE"))
		{
		MessageBox((HWND)VarWindow,"MOVE_FTP wird in von diesem Installer nicht untersttzt !","Fehler",MB_OK|MB_ICONERROR);
		}
	else{
		MessageBox((HWND)VarWindow,"COPY_FTP wird in von diesem Installer nicht untersttzt !","Fehler",MB_OK|MB_ICONERROR);
		}


return -2;
}

#endif
#endif

//*****************************************************************************
//*
//*		VarLoadText
//*
//*****************************************************************************
static int VarLoadText(const char *VarName,const char *File)
{
char   *text;
int		len;


	len = LengthFile(File);

	if(len<0 || len>0x10000)
		{
		VarSet("ERRORLEVEL","-1");
		return 0;
		}

	text = new char[len+8];

	if(!LoadMemory(File,text,len+4))
		{
		VarSet("ERRORLEVEL","-1");
		return 0;
		}


	VarSet("ERRORLEVEL","0");
	VarSet(VarName,text);


return 1;
}

//*****************************************************************************
//*
//*		VarHexGet
//*
//*****************************************************************************
static int VarHexGet(const char *File,int Pos,int Len,const char *VarName)
{
FILE	*f;
char	 text[1024],mem[256];
int		 i;


	VarSet(VarName,"");

	if(Pos<0 || Len<=0 || Len>256)
		{
		return -1;
		}

		f=fopen(File,"rb");
	if(!f)return -1;

	if(fseek(f,Pos,SEEK_SET))
		{
		fclose(f);
		return -1;
		}

	if(fread(mem,Len,1,f)!=1)
		{
		fclose(f);
		return -1;
		}

	fclose(f);

	for(i=0;i<Len;i++)
		{
		if(mem[i]<' ')break;
		}

 	memtodump(text,mem,Len,HEX_DPOINT|HEX_SPACE|HEX_NULL);

	VarSet(VarName,text);


return 0;
}

//*****************************************************************************
//*
//*		VarPrintTo
//*
//*****************************************************************************
void VarPrintTo(const char *Var,const char *Format,int Val1,int Val2,int Val3)
{
char	text[1024];

	sprintf(text,Format,Val1,Val2,Val3);
	VarSet(Var,text);

}

//*****************************************************************************
//*
//*		VarPrintTo
//*
//*****************************************************************************
void VarPrintTo(const char *Var,const char *Format,const char *Val1,const char *Val2,const char *Val3)
{
char	text[1024];

	sprintf(text,Format,Val1,Val2,Val3);
	VarSet(Var,text);

}

//*****************************************************************************
//*
//*		VarHexValue
//*
//*****************************************************************************
static int VarHexValue(const char *Dump,unsigned Pos,unsigned Num)
{
char			text[1024];
unsigned char	mem[256];
unsigned		len;
unsigned		val;
unsigned		off;


	if(Pos>sizeof(mem))return 0;

	len=strlcpy(text,Dump,sizeof(text));

	while(len>0)
		{
		len--;
		if(text[len]=='-')text[len]=' ';
		if(text[len]==':')text[len]=' ';
		}

	len=dumptomem(mem,sizeof(mem),text);
	if(Pos>=len)return 0;

	val = mem[Pos];

	for(off=1;off<Num;off++)
		{
		if(Pos+off>=len)break;
		val |= mem[Pos]<<(off*8);
		}


return val;
}

//*****************************************************************************
//*
//*		VarHexSet
//*
//*****************************************************************************
static int VarHexSet(const char *File,int Pos,const char *Dump)
{
FILE	*f;
char	 mem[256];
int		 len;


	if(*Dump==':')
		{
		len=dumptomem(mem,256,Dump);
		}
	else{
		len=strlcpy(mem,Dump,256+1);
		}


	if(len<=0)
		{
		return -1;
		}

	if(Pos<0)												// Am Ende anhngen
		{
			  f=fopen(File,"a+b");
		if(!f)f=fopen(File,"wb" );
		if(!f)return -1;
		}
	else{
			f=fopen(File,"r+b");
		if(!f)return -1;
		}


	if(Pos<0)
		{
		if(fseek(f,0,SEEK_END))
			{
			fclose(f);
			return -1;
			}
		}
	else{
		if(fseek(f,Pos,SEEK_SET))
			{
			fclose(f);
			return -1;
			}
		}

	if(fwrite(mem,len,1,f)!=1)
		{
		fclose(f);
		return -1;
		}

	fclose(f);


return 0;
}

//*****************************************************************************
//*
//*		VarSaveTable
//*
//*****************************************************************************
#ifndef 	VAR_ONLY_ENV
static int VarSaveTable(const char *File,const char *Name,CStringChain *Table,int Start,int Len,int Breite)
{
FILE	*f;
char	 text[32],*var,*val;
int		 nr,len;


	if(memcmp(File,"HKEY_",5))
		{
			f=fopen(File,"wb");
		if(!f)return 0;

 		strtimeset(text,time(0),STR_ALL|STR_SEC);
		fprintf(f,";Sicherung der Tabelle \"%s\"\r\n",Name);
		fprintf(f,";Aufruf aus \"%s\"\r\n",VarGetName("CURRENT_FILE"));
		fprintf(f,";Erstellt am %s \r\n\r\n",text);

		for(nr=0;nr<Len;nr+=Breite)
			{
				var=Table->Get(nr+Start);
			if(!var)continue;
				val=VarGetName(var);
			if(!val)val="";

			   len=strlen(var);
			if(len>24)len=24;

			fprintf(f,"SET %s%s = \"",var,"                        "+len);

			for(;*val;val++)
				{
				if(*val=='\\'){fwrite("\\\\",2,1,f);continue;}
				if(*val=='"' ){fwrite("\\\"",2,1,f);continue;}
				fwrite(val,1,1,f);
				}

			fprintf(f,"\"\r\n");
			}


		fclose(f);
		}
	else{
		for(nr=0;nr<Len;nr+=Breite)
			{
				var=Table->Get(nr+Start);
			if(!var)continue;
				val=VarGetName(var);
			if(!val)val="";

			VarSetRegSz(File,var,val);
			}
		}


return 1;
}
#endif

//*****************************************************************************
//*
//*		VarLoadReg
//*
//*****************************************************************************
//	Ld Variableeinstellungen aus der Registry
#ifndef 	VAR_ONLY_ENV
static int VarLoadReg(const char *Path)
{
CRegKeys	key;
const char *name;
char       *ptr;


	key.Open(Path,CRK_CREATE|CRK_WOW64_64KEY);

	while(key.Get(&ptr,CRK_NEXT))
		{
			name = key.Name();
		if(*name)
			{
			VarSet(name,ptr);
			}

		delete ptr;
		}



return 1;
}
#endif

//*****************************************************************************
//*
//*		ProcessFileName
//*
//*****************************************************************************
#ifndef VAR_ONLY_ENV
static DWORD WINAPI VarProcessFileName(unsigned uId,LPTSTR pFilename,int iSize)
{
typedef BOOL  (_stdcall *QueryFullProcessImageNameType)(HANDLE,DWORD,LPTSTR,LPDWORD);
typedef DWORD (_stdcall *GetModuleFileNameExType      )(HANDLE,HMODULE,LPTSTR,DWORD);
static GetModuleFileNameExType			pGetN=0;
static QueryFullProcessImageNameType	pProc=0;
static BOOL								bDone=0;
DWORD									dwByte;
HMODULE									hExe;
HMODULE									hDll;



	if(iSize<=0)return 0;

	if(!pProc && !bDone)
		{
		bDone = 1;

		   hDll = GetModuleHandle("KERNEL32");
		if(hDll)
			{											// Exist only on Vista and higher
			pProc = (QueryFullProcessImageNameType)GetProcAddress(hDll,"QueryFullProcessImageNameA");
			}

		   hDll = GetModuleHandle("Psapi.dll");
		if(hDll)
			{											// Exist only on Vista and higher
			pGetN = (GetModuleFileNameExType)GetProcAddress(hDll,"GetModuleFileNameExA");
			}
		}


		hExe = (HMODULE)OpenProcess(PROCESS_QUERY_INFORMATION,FALSE,uId);
	if(!hExe)
		{
			hExe = (HMODULE)OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION,FALSE,uId);
		if(!hExe)
			{
			return 0;
			}
		}
		
	dwByte = iSize;
	iSize  = 0;

	if(pProc && pProc(hExe,0,pFilename,&dwByte))
		{
		iSize =  dwByte;
		}
	else if(pGetN)
		{
		iSize =  pGetN(hExe,0,pFilename,dwByte);
		if(iSize<=0)pFilename[0]=0;
		}
	else{
		pFilename[0] = 0;
		}


	CloseHandle(hExe);


return iSize;
}
#endif

//*****************************************************************************
//*
//*		VarProcessRunning
//*
//*****************************************************************************
//	Prft ob ein Prozess luft
//	pName		: Ist der Pfad der EXE-Datei
//	iFull		: Soll auch der Pfad geprft werden
//					1 = Ganzen Pfad
//					2 = Pfad ohne obers Verzeichniss	
//					3 = Pfad ohne obere zwei Verzeichnisse
//	Ergibt 1 wenn der Prozess luft	
#ifndef 	VAR_ONLY_ENV
int	VarProcessRunning(const char *pName,int iFull)
{
HANDLE			hSnapshot;
HANDLE			hModules;
PROCESSENTRY32	sProcess;
MODULEENTRY32	sModule;
const char     *pSub;
int				iRet=0;
int				iNum;
int				iPos;
int				iLen;



	pSub = GetFileName(pName);
	if(!iFull)pName=pSub;



	hModules		= NULL;
	hSnapshot       = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS|TH32CS_SNAPMODULE32,0);
	sProcess.dwSize = sizeof(sProcess);



	if(!hSnapshot || hSnapshot==INVALID_HANDLE_VALUE)
		{
		return 0;
		}

	if(iFull)										// Auch den Pfad prfen
		{
		iLen = strlen(pName);
		if(iFull<0)iFull=1;
		if(iFull>3)iFull=3;

		iNum = iFull;

		for(iPos=iLen;iPos>0;iPos--)				// Segmente abziehen
			{
			if(pName[iPos-1]!='\\')
			if(pName[iPos-1]!='/' )
				{
				continue;
				}

			   iNum--;
			if(iNum==0)
				{
				iLen=iPos;
				break;
				}
			}
		}
	else{
		iLen = 0;
		}


	if(!Process32First(hSnapshot,&sProcess))
		{
		CloseHandle(hSnapshot);
		return 0;
		}

	do	{
		if(strnicmp(pSub,sProcess.szExeFile,15))	// compare process name
			{
			continue;
			}

		if(!iFull)
			{
			iRet =1;
			break;
			}
													// get full path name
		if(!VarProcessFileName(sProcess.th32ProcessID,sModule.szExePath,sizeof(sModule.szExePath)))
			{
			hModules = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE|TH32CS_SNAPMODULE32,sProcess.th32ProcessID);

			if(!hModules || hModules==INVALID_HANDLE_VALUE)
				{
				continue;
				}

			sModule.dwSize = sizeof(sModule);

			if(!Module32First(hModules,&sModule))
				{
				CloseHandle(hModules);
				continue;
				}
			}

		do	{										// compare filename
			if(strpicmp(pName,sModule.szExePath,iLen))
				{
				continue;
				}

			iRet=1;
			break;
			}while(Module32Next(hModules,&sModule));


		CloseHandle(hModules);
		hModules = NULL;
		if(iRet)break;


		}while(Process32Next(hSnapshot,&sProcess));

	CloseHandle(hSnapshot);


return iRet;
}
#endif

//*****************************************************************************
//*
//*		VarWriteAccess
//*
//*****************************************************************************
//	Prft ob ein Datei Schreibberechtigung hat.
//	pPath		: Ist der Pfad der Datei
//	iMode		: Nicht vorhandene Dateien versuchen anzulegen
//					0 = Nicht anlegen
//					1 = Versuchen anzulegen
//					2 = Eins zurckgeben wenn Datei nicht existiert
//	Ergibt 1 wenn die Datei eine Schreibberechtigung hat.
#ifndef 	VAR_ONLY_ENV
int VarWriteAccess(const char *pPath,int iMode=0)
{
HANDLE		hHandle;	


	if(iMode && ExistFile(pPath)==0)
		{
		if(iMode==2)return 1;

		   hHandle = CreateFile(pPath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hHandle==INVALID_HANDLE_VALUE)
			{
			return 0;
			}

		CloseHandle(hHandle);
		DeleteFile(pPath);

		return 1;
		}


	   hHandle = CreateFile(pPath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hHandle==INVALID_HANDLE_VALUE)return 0;
	
	CloseHandle(hHandle);

return 1;
}
#endif 	

//*****************************************************************************
//*
//*		VarLineCount
//*
//*****************************************************************************
//	Anzahl der Zeilen einer Datei ermitteln.
//	Ergibt die Zeilennummer bzw. -1 wenn nicht gefunden.
#ifndef 	VAR_ONLY_ENV
static int VarLineCount(const char *File)
{
char	 buffer[2048];
int		 line=0;
FILE	*f;


	    f=fopen(File,"r");
	if(!f)return -1;

	buffer[sizeof(buffer)-1] = 0;

	while(fgets(buffer,sizeof(buffer)-1,f))
		{
		line++;
		}

	fclose(f);

return -1;
}
#endif

//*****************************************************************************
//*
//*		VarLineFind
//*
//*****************************************************************************
//	Sucht die Zeile Line in der Datei File.
//	Ergibt die Zeilennummer bzw. -1 wenn nicht gefunden.
#ifndef 	VAR_ONLY_ENV
static int VarLineFind(const char *File,const char *Line)
{
char	 buffer[2048];
int		 line=0,len;
FILE	*f;


	    f=fopen(File,"r");
	if(!f)return -1;

	buffer[sizeof(buffer)-1] = 0;

	while(fgets(buffer,sizeof(buffer)-1,f))
		{
		   len=strnlen(buffer,sizeof(buffer));
		if(len>0 && buffer[len-1]=='\n')len--;
		if(len>0 && buffer[len-1]=='\r')len--;
		if(len>0 && buffer[len-1]=='\n')len--;

		if(!memycmp(Line,buffer,len,1))
			{
			fclose(f);
			return line;
			}

		line++;
		}

	fclose(f);

return -1;
}
#endif

//*****************************************************************************
//*
//*		VarLineGet
//*
//*****************************************************************************
//	Sucht die Zeile Line in der Datei File.
//	Ergibt die Lnge der Zeilen bzw. -1 wenn nichts gefunden wurde.
#ifndef 	VAR_ONLY_ENV
static int VarLineGet(const char *File,const char *Var,int Line)
{
FILE	*f;
int		 line=0,len;
char	 buffer[1024];


	VarSet(Var,"");

	if(Line<0)return -1;

	    f=fopen(File,"r");
	if(!f)return -1;

	while(fgets(buffer,sizeof(buffer),f))
		{
		   len=strnlen(buffer,sizeof(buffer));
		if(len>0 && buffer[len-1]=='\n')len--;
		if(len>0 && buffer[len-1]=='\r')len--;
		if(len>0 && buffer[len-1]=='\n')len--;

		if(!Line)
			{
			buffer[len]=0;
			VarSet(Var,buffer);
			fclose(f);
			return len;
			}

		Line--;
		}

	fclose(f);

return -1;
}
#endif

//*****************************************************************************
//*
//*		VarLineSet
//*
//*****************************************************************************
//	Ersetz eine Zeile mit einer anderen in einer Datei
//	File	: Name der Datei
//	Text	: Neue Zeile
//	Line	: Ist die Nummer der Zeile die ausgetauscht werden soll.
//			  Ist sie kleiner als 0 oder zu gro so wird die Zeile am
//			  Ende angehngt.
//	Add		: Ist Add ungleich Null so wird die Zeile eingefgt.
//	Ergibt 1 wenn die Zeile eingefgt wurde
#ifndef 	VAR_ONLY_ENV
static int VarLineSet(const char *File,const char *Text,int Line,int Add)
{
FILE	*f,*t;
int		 line=0,len,ok=0;
char	 buffer[1024];
char	 name[MAX_PATH];



	if(ExistFile(File)==0)					// Existiert die Datei ?
		{
		f=fopen(File,"wb");
		if(!f)return 0;
		fclose(f);
		}

	f=fopen(File,"rb");

	GetTempPath(sizeof(name),name);
	strncat(name,"lset_vsk.tmp",sizeof(name));

		t=fopen(name,"wb");
	if(!t)
		{
		if(f)fclose(f);
		return 0;
		}

	if(f)
	while(fgets(buffer,sizeof(buffer),f))	// Zeile suchen
		{
		len=strnlen(buffer,sizeof(buffer));
		if(Line!=line)fwrite(buffer,len,1,t);
		else{
			if(Add)fwrite(buffer,len,1,t);
			len=strlen(Text);
			fwrite(Text,len,1,t);
			fwrite("\r\n",2,1,t);
			ok=1;
			}
		line++;
		}

	if(!ok)									// Zeile anhngen
		{
		if(line>0)
			{
			len=strnlen(buffer,sizeof(buffer));
			if(len>0 && buffer[len-1]!='\n')
				{
				fwrite("\r\n",2,1,t);
				}
			}
		len=strlen(Text);
		fwrite(Text,len,1,t);
		fwrite("\r\n",2,1,t);
		}

	     fclose(t);
	if(f)fclose(f);

	ok=CopyFile(name,File,FALSE);
	RemoveFile(name);


return ok;
}
#endif

//*****************************************************************************
//*
//*		VarCallReg
//*
//*****************************************************************************
#ifndef 	VAR_ONLY_ENV
static void VarCallReg(const char *File)
{
CRegText	reg;

	reg.SetVarProc(VarGetName);
	reg.Import(File);

}
#endif

//*****************************************************************************
//*
//*		VarCall
//*
//*****************************************************************************
#ifndef 	VAR_ONLY_ENV
static int VarCall(char **Namen,int Anz)
{
CStartProg	prog;
int			x,mode=CSP_WAIT;
char		text[16];



	for(x=0;x<Anz;x++)
		{
		if(!stricmp(Namen[x],"NOWAIT"))
			{
			mode&=~CSP_WAIT;
			mode|= CSP_NOWAIT;
			continue;
			}
		if(!stricmp(Namen[x],"HIDE"))
			{
			mode|=CSP_SETSHOW|CSP_HIDE;
			continue;
			}
		if(!strnicmp(Namen[x],"DIR:",4))
			{
			prog.SetDirectory(Namen[x]+4);
			continue;
			}

		break;
		}

	if(x>=Anz)
		{
		VarSet("ERRORLEVEL","-1");
		return -1;
		}

	prog.SetFilename(Namen[x]);

	for(x++;x<Anz;x++)
		{
		prog.SetParam(Namen[x]);
		}

	if(!prog.Start(mode))
		{
		VarSet("ERRORLEVEL","-1");
		return -1;
		}

	itoa(prog.GetExitCode(),text,10);
	VarSet("ERRORLEVEL",text);



return 1;
}
#endif

//*****************************************************************************
//*
//*		VarSetRegSz
//*
//*****************************************************************************
//	Einen String-Registry-Eintrag einstellen
//	Path	: Registry-Pfad
//	Name	: Wertname
//	Value	: Neuer String
#ifndef 	VAR_ONLY_ENV
static void  VarSetRegSz(const char *Path,const char *Name,const char *Value)
{
CRegKeys	key;

	key.Open(Path,CRK_CREATE|CRK_WOW64_64KEY);
	key.Set(Value,Name);

}
#endif

//*****************************************************************************
//*
//*		VarSetRegDword
//*
//*****************************************************************************
//	Einen DWORD-Registry-Eintrag einstellen
//	Path	: Registry-Pfad
//	Name	: Wertname
//	Value	: Neuer Wert
#ifndef 	VAR_ONLY_ENV
static void  VarSetRegDword(const char *Path,const char *Name,int Value)
{
CRegKeys	key;

	key.Open(Path,CRK_CREATE|CRK_WOW64_64KEY);
	key.Set(Value,Name);

}
#endif


//*****************************************************************************
//*
//*		VarDelReg
//*
//*****************************************************************************
//	Einen Registry-Eintrag lschen
//	Path	: Registry-Schsselname
//	Name	: Wertname, wenn NULL dann wird der ganze Schssel gelscht
#ifndef 	VAR_ONLY_ENV
static void VarDelReg(const char *Path,const char *Name)
{
CRegKeys	key;
char		buffer[512];
int			len;


	if(Name)
		{
		if(!key.Open(Path,CRK_WRITE|CRK_WOW64_64KEY))return;
			key.Del((Name[0])? Name:0);
		}
	else{
		if(!key.Open(Path,CRK_READ|CRK_WOW64_64KEY))return;

		    len=strlen(Path);
		if( len>=sizeof(buffer))return;

		memcpy(buffer,Path,len+1);
		for(;len>0;len--)
			{
			if(buffer[len]=='\\')break;
			}

		if(len<=0)return;

		buffer[len]=0;
		Path=buffer;
		Name=buffer+len+1;

		if(!key.Open(Path,CRK_CREATE|CRK_WOW64_64KEY))return;
			key.DelKey(Name);
		}

}
#endif


//*****************************************************************************
//*
//*		VarGetReg
//*
//*****************************************************************************
//	Einen Registry-Wert abfragen
//	Path	: Registry-Schsselname
//	Name	: Wertname
//	Ergibt einen Zeiger auf einen Text, Zahlen werden auch in Texte umgewandelt
//	Wird der Wert nicht gefunden so wird NULL zurck gegeben
#ifndef 	VAR_ONLY_ENV
static char *VarGetReg(const char *Path,const char *Name)
{
CRegKeys	key;
static char	buffer[512];
int			dword;

	VarSet("ERRORLEVEL","-1");

	if(!key.Open(Path,CRK_READ|CRK_WOW64_64KEY))return 0;
	if(!key.Get(buffer,sizeof(buffer),Name,REG_NONE))return 0;

	switch(key.Type())
		{
	case REG_DWORD:

		dword=*(int*)buffer;
		itoa(dword,buffer,10);
		VarSet("ERRORLEVEL","0");
		return buffer;

	case REG_SZ:

		VarSet("ERRORLEVEL","0");
		return buffer;

	default:

		return 0;
		};

}
#endif


//*****************************************************************************
//*
//*		VarZipProgress
//*
//*****************************************************************************
#ifndef 	VAR_ONLY_ENV
static int _cdecl VarZipProgress(void *Sunbmit,int Art,int Sub,CArchiveFile *Zip,char *Text)
{
char   *name;
int		param;
int		add=0;
int		ret;

	if(Text)
		{
		add  = strspn(Text,"\n\r \t");
		Text+= add;
		}


	if(Art==CAF_PROG_QUERY)							// Soll die Datei kopiert werden
		{
		name = Zip->Name(Sub);

		if(zip_filter[0]=='!')
			{
			if(!memxcmp(zip_filter+1,name,strlen(name),1))
				{
				return 1;
				}
			}
		else{
			if(memxcmp(zip_filter,name,strlen(name),1))
				{
				return 1;
				}
			}
		}

	if(VarMessage)
		{
		param   = 0x80000000;
		param  |= Zip->m_iProgPos-add;				// Ist die Position des Dateinamens im Progress-Text
		param  |= Zip->m_iProgLen<< 7;				// Ist die Lnge des Dateinamens im Progress-Text
		param  |= Zip->m_iProgAdd<<16;				// Ist die Lnge des Progress-Textes nach dem Dateinamen

		if(Sub>=0)param|=0x00800000;

		if(Art==CAF_PROG_ERROR)
			{
			char text[1024];

			if(ignore)return 0;

			sprintf(text,(Sub>=0)? "%s\n%s":"%s",Zip->ErrorText(),Zip->Name(Sub));
			strlcat(text,"\n\nSollen weitere Fehler ignoriert werden ?",sizeof(text));
			ret = MessageBox((HWND)VarWindow,text,"Fehler",MB_YESNO|MB_DEFBUTTON2|MB_ICONERROR);

			if(ret==IDYES)ignore=1;
			return 0;
			}

		if(Art==CAF_PROG_EXTRACT || Art==CAF_PROG_WRITE)
		VarMessage(VarParam,0x1234,(char*)Zip->Len(Sub));
		VarMessage(VarParam,param,Text);
		}

return 0;
}
#endif

//*****************************************************************************
//*
//*		VarCopyZip
//*
//*****************************************************************************
//	Kopieren von Dateien mittels Pfadangabe
//	Source	: Dateipfad der ZipDatei
//	Target	: Zielpfad, er muss mit '\' abgeschlossen sein
//	Ergibt die Anzahl der kopierten Dateien
#ifndef 	VAR_ONLY_ENV
static int VarCopyZip(const char *Source,const char *Target,const char *Plus,const char *Minus,const char *AddPath)
{
CArchiveFileEx *file;
CZipFile		zip;
int				sdir;
int				tdir;
int				pos;
int				art;


	VarSet("ERRORLEVEL","0");
	VarGetName("ZIP_FILTER",zip_filter,sizeof(zip_filter));
	PathConvert(zip_filter,'/');

	sdir = CmpFileType(Source,"zip");
	tdir = CmpFileType(Target,"zip");
	file = CArchiveFileEx::GetArchive(&zip);

	#ifdef			VAR_HAS_TGZTYPE
	CTgzFile		tgz;

	if(CmpFileType(Source,"tgz;gz"))				// Auch TGZ untersttzen
		{
		file = CArchiveFileEx::GetArchive(&tgz);
		sdir = 1;
		}

	if(!sdir && CmpFileType(Target,"tgz;gz"))
		{
		file = CArchiveFileEx::GetArchive(&tgz);
		tdir = 1;
		}

	#endif


	if(!sdir && tdir)								// Zipdatei erzeugen
		{
		if(AddPath && *AddPath=='*')
			{
			AddPath++;
			art = CAF_CREATE;
			}
		else if(ExistFile(Target)==1)
			{
			art = CAF_WRITE;
			}
		else{
			art = CAF_CREATE;
			}

		if(file->Open(Target,art)!=CAF_ERROR_OK)
			{
			char text[512];

			VarSet("ERRORLEVEL","1");

			if(!ignore)
				{
				sprintf(text,"Fehler beim %s von '%s' !",(art==CAF_CREATE)? "Erstellen":"ffnen",Source);
				MessageBox((HWND)VarWindow,text,"Fehler",MB_OK|MB_ICONERROR);
				}

			return 0;
			}

		file->Flags(CAF_FLAG_SUBDIR);

		if(VarMessage)
			{
			file->Progress(0,VarZipProgress);
			file->ProgressDel(-1,1);
			file->ProgressAdd(1<<CAF_PROG_WRITE,1);
			file->ProgressAdd(1<<CAF_PROG_ERROR,1);
			}

		if(file->Add(Source,Plus,Minus,AddPath)<0)
			{
			char text[512];

			VarSet("ERRORLEVEL","1");

			if(!ignore)
				{
				sprintf(text,"Fehler beim Zippen von '%s' !\n%s",Source,file->ErrorText());
				MessageBox((HWND)VarWindow,text,"Fehler",MB_OK|MB_ICONERROR);
				}

			return 0;
			}

		return 1;
		}


//******************** ZIP-Datei extrahieren **********************************


	if(file->Open(Source)!=CAF_ERROR_OK)
		{
		char text[512];

		VarSet("ERRORLEVEL","1");

		if(!ignore)
			{
			sprintf(text,"Fehler beim ffnen von '%s' !",Source);
			MessageBox((HWND)VarWindow,text,"Fehler",MB_OK|MB_ICONERROR);
			}

		return 0;
		}

	if(VarMessage)
		{
		file->Progress(0,VarZipProgress);
		file->ProgressDel(-1,1);
		file->ProgressAdd(1<<CAF_PROG_EXTRACT,1);
		file->ProgressAdd(1<<CAF_PROG_ERROR  ,1);

		if(zip_filter[0])
			{
			file->ProgressAdd(1<<CAF_PROG_QUERY,1);
			}
		}

	if(!Plus )Plus ="";
	if(!Minus)Minus="";

	if(*Plus || *Minus)								// Extrahieren mit Filter
		{
		for(pos=0;pos<file->Count();pos++)
			{
			if(*Plus  &&  strwicmp(file->Name(pos),Plus ))continue;
			if(*Minus && !strwicmp(file->Name(pos),Minus))continue;

			file->ProgressEx(CAF_PROG_EXTRACT,pos);
			file->Extract(pos,Target);
			}
		}
	else if(file->ExtractAll(Target)!=CAF_ERROR_OK)	// Ganze ZIP-Datei extrahieren
		{
		char text[512];

		VarSet("ERRORLEVEL","1");

		if(!ignore)
			{
			sprintf(text,"Fehler beim Extrahiern aus '%s' !\n%s",Source,file->ErrorText());
			MessageBox((HWND)VarWindow,text,"Fehler",MB_OK|MB_ICONERROR);
			}

		return 0;
		}



return 1;
}
#endif

//*****************************************************************************
//*
//*		VarCopyFile
//*
//*****************************************************************************
//	Kopieren von Dateien mittels Pfadangabe
//	Source		: Dateipfad mit Wildcards
//	Target		: Zielpfad, ist er mit '\' abgeschlossen so wird die
//				  Datei nicht umbenant.
//	SubDirs		: Auch Verzeichnisse kopierten
//	OverWrite	: Vorhandene Dateien berschreiben
//	Compare		: Vorhandene Dateien nur kopieren wenn sie ungleich sind
//	Newer		: Vorhandene Dateien nur berschreiben wenn sie lter ist
//	Ergibt die Anzahl der kopierten Dateien
#ifndef 	VAR_ONLY_ENV
static int VarCopyFile(const char *Source,const char *Target,int SubDirs,int OverWrite,int Compare,int Newer)
{
char			buffer[MAX_PATH+16];
char			target[MAX_PATH+16];
char			text  [MAX_PATH+64];
int				x,y,z,len,tlen,param,anz=0;
HANDLE			h;
WIN32_FIND_DATA	find;


	VarSet("ERRORLEVEL","0");

	   h=FindFirstFile(Source,&find);
	if(h==INVALID_HANDLE_VALUE)return 0;

	len=strlen(Source);
	for(;len>0;len--)
		{
		if(Source[len-1]=='\\')break;
		if(Source[len-1]=='/' )break;
		if(Source[len-1]==':' )break;
		}

	if(len>=sizeof(buffer)-1)return 0;

	memcpy(buffer,Source,len);
	buffer[len]=0;


	tlen=strlen(Target);
	if(tlen>=sizeof(target)-1)return 0;
	GetFilePath(target,Target,sizeof(target));
	CreatePath(target);
	memcpy(target,Target,tlen+1);

	do	{
		x=strlen(find.cFileName);
		if(len+x>=sizeof(buffer)-4)continue;
		memcpy(buffer+len,find.cFileName,x+1);

		if(tlen>0 && (target[tlen-1]=='\\' || target[tlen-1]=='/'))
			{
			if(tlen+x+1>=sizeof(target))continue;
			memcpy(target+tlen,find.cFileName,x+1);
			}

		if(find.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(!SubDirs)continue;

			if(find.cFileName[0]=='.')
				{
				if(find.cFileName[1]== 0 )continue;
				if(find.cFileName[1]=='.')
				if(find.cFileName[2]== 0 )continue;
				}

			if(!CreatePath(target))
				{
				char text[512];

				VarSet("ERRORLEVEL","1");
				sprintf(text,"Fehler beim Erstellen von '%s' !",target);
				x=MessageBox((HWND)VarWindow,text,"Fehler",MB_OKCANCEL|MB_ICONERROR);
				if(x==IDCANCEL){anz=-1;break;}
				continue;
				}

			memcpy(buffer+ len+x,"\\*",3);
			memcpy(target+tlen+x,"\\" ,3);
			x=VarCopyFile(buffer,target,1,OverWrite,Compare,Newer);
			if(x<0){anz=-1;break;}
			anz+=x;
			buffer[len+x]=0;

			continue;
			}

		if(VarMessage)						// Text ausgeben
			{
			x = strlcpy(text    ,"Kopiere: '",sizeof(text)    );
			y = strlcpy(text+x  ,target      ,sizeof(text)-x  );
			z = strlcpy(text+x+y,"'"         ,sizeof(text)-x-y);

			param   = 0x80000000|x|(y<<7)|(z<<16);

			VarMessage(VarParam,param,text);
			}
											// Nicht berschreiben
		if(!OverWrite && ExistFile(target)==1)
			{
			}								// Nur wenn neuer kopieren
		else if(Newer && CmpFileTime(buffer,target,3)<=0)
			{
			}								// Dateien vergleichen
		else if(Compare && CmpFileData(buffer,target))
			{
			}								// Datei kopieren
		else if(CopyFile(buffer,target,FALSE))
			{
			anz++;
			}
		else{
			char text[512];

			VarSet("ERRORLEVEL","1");
			sprintf(text,"Fehler beim Kopieren von '%s' !",buffer);
			x=MessageBox((HWND)VarWindow,text,"Fehler",MB_OKCANCEL|MB_ICONERROR);
			if(x==IDCANCEL){anz=-1;break;}
			}

		if(VarMessage)						// Gre ausgeben
			{
			VarMessage(VarParam,0x1234,(char*)find.nFileSizeLow);
			}

		}while(FindNextFile(h,&find));


	FindClose(h);


return anz;
}
#endif

//*****************************************************************************
//*
//*		VarDeleteFile
//*
//*****************************************************************************
//	Lschen von Dateien mittels Pfadangabe
//	Path	: Dateipfad mit Wildcards
//	SubDirs	: Auch Verzeichnisse lschen
//	Find	: Aktueller Suchpfad falls das Findhandle geschlossen werden muss
//	Handle	: Ist das Findhandle
//	Ergibt die Anzahl der gelschten Dateien
#ifndef 	VAR_ONLY_ENV
static int VarDeleteFile(const char *Path,int SubDirs,char *Find,HANDLE &Handle)
{
char			buffer[MAX_PATH+16];
int				x,len,anz=0,wild=0;
WIN32_FIND_DATA	find;
DWORD			attr;
HANDLE			h;




	   h=FindFirstFile(Path,&find);
	if(h==INVALID_HANDLE_VALUE)return 0;

	len=strlen(Path);
	for(;len>0;len--)
		{
		if(Path[len-1]=='\\')break;
		if(Path[len-1]=='/' )break;
		if(Path[len-1]==':' )break;
		if(Path[len-1]=='*' )wild=1;
		if(Path[len-1]=='?' )wild=1;
		}

	if(len>=sizeof(buffer)-1)return 0;

	if(!wild && !SubDirs)
		{
		FindClose(h);

		   attr = GetFileAttributes(Path);
		if(attr==0xFFFFFFFF)return 0;

		if(attr&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(RemoveDirectory(Path))
				{
				return 1;
				}

			if(CmpFileName(Path,Find))
				{
				return 0;
				}

			FindClose(Handle);
			Handle=INVALID_HANDLE_VALUE;
			Find[0]=0;

			if(RemoveDirectory(Path))
				{
				return 1;
				}

			return 0;
			}

		if(RemoveFile(Path))
			{
			return 1;
			}

		return 0;
		}


	memcpy(buffer,Path,len);

	do	{
		x=strlen(find.cFileName);
		if(len+x>=sizeof(buffer)-4)continue;
		memcpy(buffer+len,find.cFileName,x+1);

		if(find.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(!SubDirs)continue;

			if(find.cFileName[0]=='.')
				{
				if(find.cFileName[1]== 0 )continue;
				if(find.cFileName[1]=='.')
				if(find.cFileName[2]== 0 )continue;
				}

			memcpy(buffer+len+x,"\\*",3);
			anz+=VarDeleteFile(buffer,1,Find,Handle);
			buffer[len+x]=0;
			if(RemoveDirectory(buffer))anz++;

			continue;
			}

		if(RemoveFile(buffer))anz++;

		}while(FindNextFile(h,&find));


	FindClose(h);

	if(!wild)
		{
		     if(RemoveFile     (Path))return anz+1;
		else if(RemoveDirectory(Path))return anz+1;

		   attr = GetFileAttributes(Path);
		if(attr==0xFFFFFFFF)return anz;

		if(attr&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(!CmpFileName(Path,Find))
				{
				FindClose(Handle);
				Handle=INVALID_HANDLE_VALUE;
				Find[0]=0;

				if(RemoveDirectory(Path))
					{
					anz++;
					}
				}
			}
		}


return anz;
}
#endif

//*****************************************************************************
//*
//*		VarInit
//*
//*****************************************************************************
//	Size	: Gre des Datenbereiches einer Variabel
void VarInit(int Size)
{
char		   *ptr;
struct tm      *tmstr;
char			buffer[MAX_PATH];
DWORD			size,pos,osinfo;
time_t			zeit;


	var_name.Del();						// Namen der Variabeln
	var_text.Del();						// Inhalt der Variabeln
	var_name.DataLength(Size);

	ptr=(char*)GetEnvironmentStrings();
	for(;;)
		{
		if(!ptr)break;
		if(IsBadReadPtr(ptr,1))break;

		size=strlen(ptr);
		if(ptr[0]=='=')
			{
			ptr+=size+1;
			if(!*ptr)break;
			continue;
			}

		for(pos=1;pos<size;pos++)if(ptr[pos]=='=')break;

		if(ptr[pos]=='=' && pos<sizeof(buffer))
			{
			memcpy(buffer,ptr,pos);
			buffer[pos]=0;
			VarSet(buffer,ptr+pos+1);
			}

		ptr+=size+1;
		if(!*ptr)break;
		}

	zeit  = time(0);
	tmstr = localtime(&zeit);
	VarSet("TIME",zeit);

	#if _WIN64

	VarSet("IS64BIT",1);

	#else

	LPFN_ISWOW64PROCESS IsWow64;

	IsWow64 = (LPFN_ISWOW64PROCESS)GetProcAddress(GetModuleHandle("kernel32"),"IsWow64Process");

    if(IsWow64)
		{
        IsWow64(GetCurrentProcess(),&is_64_bit);
        }

	VarSet("IS64BIT",is_64_bit);

	#endif


	if(tmstr)
		{
		VarSet    ("TIME_YEAR"        ,tmstr->tm_year+1900);
		VarPrintTo("TIME_MONTH","%02i",tmstr->tm_mon+1,0,0);
		VarPrintTo("TIME_DAY"  ,"%02i",tmstr->tm_mday ,0,0);
		VarPrintTo("TIME_HOUR" ,"%02i",tmstr->tm_hour ,0,0);
		VarPrintTo("TIME_MIN"  ,"%02i",tmstr->tm_min  ,0,0);
		VarPrintTo("TIME_SEC"  ,"%02i",tmstr->tm_sec  ,0,0);
		}

	size=sizeof(buffer);
	GetUserName(buffer,&size);
	VarSet("USER_NAME",buffer);

	size=sizeof(buffer);
	GetComputerName(buffer,&size);
	VarSet("COMPUTER_NAME",buffer);

	GetWindowsDirectory(buffer,sizeof(buffer));
	VarSet("WINDOWS_FOLDER",buffer);

	GetSystemDirectory(buffer,sizeof(buffer));
	VarSet("SYSTEM_FOLDER" ,buffer);

	GetTempPath(sizeof(buffer),buffer);
	VarSet("TEMP_FOLDER" ,buffer);

	GetCurrentDirectory(sizeof(buffer),buffer);
	VarSet("CURRENT_DIRECTORY",buffer);

	GetExePath(buffer,sizeof(buffer));
	VarSet("EXE_PATH",buffer);

	osinfo = GetWindowsVersionEx();
	if(osinfo)
		{
		itoa(osinfo>>16,buffer,10);
		VarSet("OS_MAJOR_NR",buffer);
		itoa(osinfo&0xFFFF,buffer,10);
		VarSet("OS_MINOR_NR",buffer);
		VarSet("OS_NAME","WINNT");
		}

	SHGetSpecialFolderPath(0,buffer,CSIDL_COMMON_PROGRAMS,0);
	if(!buffer[0])SHGetSpecialFolderPath(0,buffer,CSIDL_PROGRAMS,0);
	VarSet("COMMON_PRORAMS_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_COMMON_STARTMENU,0);
	if(!buffer[0])SHGetSpecialFolderPath(0,buffer,CSIDL_STARTMENU,0);
	VarSet("COMMON_STARTMENU_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_COMMON_DESKTOPDIRECTORY ,0);
	if(!buffer[0])SHGetSpecialFolderPath(0,buffer,CSIDL_DESKTOPDIRECTORY ,0);
	VarSet("COMMON_DESKTOPDIRECTORY_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_DESKTOP,0);
	VarSet("DESKTOP_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_FAVORITES,0);
	VarSet("FAVORITES_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_FONTS ,0);
	VarSet("FONTS_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_PERSONAL ,0);
	VarSet("PERSONAL_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_PROGRAMS ,0);
	VarSet("PRORAMS_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_SENDTO,0);
	VarSet("SENDTO_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_STARTMENU,0);
	VarSet("STARTMENU_FOLDER",buffer);

	SHGetSpecialFolderPath(0,buffer,CSIDL_DESKTOPDIRECTORY,0);
	VarSet("DESKTOPDIRECTORY_FOLDER",buffer);

	WowRedirect(1);
	buffer[0]=0;
	GetEnvironmentVariable("ProgramW6432",buffer,sizeof(buffer));
	if(!buffer[0])
		{
		GetEnvironmentVariable("ProgramFiles",buffer,sizeof(buffer));
		}
	if(!buffer[0])
		{
		     if(ExistFile("C:\\Programme"    )==1)strcpy(buffer,"C:\\Programme"    );
		else if(ExistFile("C:\\Program Files")==1)strcpy(buffer,"C:\\Program Files");
		else{
			SHGetSpecialFolderPath(0,buffer,CSIDL_PROGRAM_FILES,0);
			if(!buffer[0])strcpy(buffer,"C:\\Programme");
			}
		}
	VarSet("PROGRAM_FILES",buffer);

	buffer[0]=0;
	GetEnvironmentVariable("ProgramFiles(x86)",buffer,sizeof(buffer));
	if(!buffer[0])
		{
		     if(ExistFile("C:\\Program Files (x86)")==1)strcpy(buffer,"C:\\Program Files (x86)");
		else if(ExistFile("C:\\Programme"          )==1)strcpy(buffer,"C:\\Programme"          );
		else if(ExistFile("C:\\Program Files"      )==1)strcpy(buffer,"C:\\Program Files"      );
		else{
			SHGetSpecialFolderPath(0,buffer,CSIDL_PROGRAM_FILESX86,0);
			if(!buffer[0])strcpy(buffer,"C:\\Programme");
			}
		}
	VarSet("PROGRAM_FILESX86",buffer);
	WowRedirect(0);

	VarSet("CALLBACK_BREAK","");
	VarSet("CALLBACK_VAR"  ,"");
	VarSet("CALLBACK_NR"   ,"");

	SHGetSpecialFolderPath(0,buffer,CSIDL_APPDATA,0);

	VarSet("ISADMIN",HasUserAdminPrivilege());


	#ifndef VAR_ONLY_ENV

	BYTE	disk[4];
	DWORD	card;

	for(card=0;card<16;card++)
		{
		if(!MacAsText(card,buffer+32,32))break;
		sprintf(buffer,"MAC_ADDRESS_%u",card);
		VarSet(buffer,buffer+32);
		}

	VarSet("MAC_COUNT",card);

	DiskGetId(disk);
	sprintf(buffer,"%02X-%02X-%02X-%02X",disk[0],disk[1],disk[2],disk[3]);
	VarSet("DISKID",buffer);

	#endif




}

//*****************************************************************************
//*
//*		VarExit
//*
//*****************************************************************************
void VarExit()
{

	var_name.Del();						// Namen der Variabeln
	var_text.Del();						// Inhalt der Variabeln

	if(temp_text)
		{
		delete temp_text;
		temp_text=0;					// Zeiger auf Datenpuffer
		temp_size=0;					// Lnge des Datenpuffers
		}


}

//*****************************************************************************
//*
//*		VarGetName
//*
//*****************************************************************************
//	Sucht Variabel und gibt einen Zeiger auf deren Inhalt zurck
//	bzw. 0 wenn nicht gefunden
char * _cdecl VarGetName(const char *Variabel)
{
int nr;


	nr=var_name.FindFast(Variabel,0,-1,1);
	if(nr<0)return 0;


return var_text[nr];
}

//*****************************************************************************
//*
//*		VarGetName
//*
//*****************************************************************************
//	Sucht Variabel und gibt einen Zeiger auf deren Inhalt zurck und speichert
//	den Inhalt in einem Puffer
//	bzw. 0 wenn nicht gefunden
char * _cdecl VarGetName(const char *Variabel,char *Buffer,int Size)
{
int nr;


	if(Size<=0)return 0;

	nr=var_name.FindFast(Variabel,0,-1,1);
	if(nr<0)
		{
		Buffer[0]=0;
		return 0;
		}


	strlcpy(Buffer,var_text[nr],Size);


return var_text[nr];
}

//*****************************************************************************
//*
//*		VarGetValue
//*
//*****************************************************************************
//	Sucht Variabel und gibt den INT Wert zurck
int VarGetValue(const char *Variabel)
{
int		nr;

	nr=var_name.FindFast(Variabel,0,-1,1);
	if(nr<0)return 0;

return strtoi(var_text[nr]);
}

//*****************************************************************************
//*
//*		VarSet
//*
//*****************************************************************************
//	Speichert eine neue Variabel als Zahlenwert.
//	Variabel	: Name der Variabel
//	Value		: Ist der Zahlenwert
//	Data		: Zeiger auf Daten (variabel typ)
//	Anmerkung:	Die Gre des Dantenbereiches muss mit VarInit erstellt werden.
void VarSet(const char *Variabel,int Value,void *Data)
{
char text[16];

	itoa(Value,text,10);
	VarSet(Variabel,text,Data);

}

//*****************************************************************************
//*
//*		VarSet
//*
//*****************************************************************************
//	Speichert eine neue Variabel
//	Variabel	: Name der Variabel
//	Text		: Zu speichernter Text
//	Data		: Zeiger auf Daten (variabel typ)
//	Anmerkung:	Die Gre des Dantenbereiches muss mit VarInit erstellt werden.
void VarSet(const char *Variabel,const char *Text,void *Data)
{
int nr;


	nr=var_name.FindFast(Variabel,0,-1,0x01);
	if(nr<0)
		{
		nr=var_name.FindFast(Variabel,0,-1,0x09);
		   var_name.Add(Variabel,nr,Data);
		   var_text.Add(Text,nr);
		}
	else{
		var_name.Set(Variabel,nr,Data);
		var_text.Set(Text,nr);
		}

}

//*****************************************************************************
//*
//*		VarGetData
//*
//*****************************************************************************
//	Sucht Variabel und gibt einen Zeiger auf deren Datenbereich zurck
//	bzw. 0 wenn nicht gefunden.
//	Anmerkung:	Die Gre des Dantenbereiches muss mit VarInit erstellt werden.
void *VarGetData(const char *Variabel)
{
int nr;


	nr=var_name.FindFast(Variabel,0,-1,1);
	if(nr<0)return 0;


return var_name.Data(nr);
}

//*****************************************************************************
//*
//*		VarConvert
//*
//*****************************************************************************
//	Konvertiert alls $(Var) Symbole
//	Line	: String der konvertiert wird
//	Max		: Maximale Lnge des Strings
//	Ergibt einen Zeiger auf den neuen String (nicht mit delete ferigeben !)
//
//	Formate : "$(Var)"   wird zu "VarText"
//			  "$$(Var)"  wird zu "$(Var)"
//			  "$$"		 wird zu "$"
//			  "$1"		 wird zu "$1"
char *VarConvert(const char *Line,int Max)
{
int		pos,wo,len,num,cnt,level,size[8];
char	zeichen,varname[128],*var;



	for(pos=0;;pos++)						// Enthllt der Text eine Symbolangabe
		{
		if(pos>=Max)return (char*)Line;

		zeichen = Line[pos];

		if(zeichen== 0  )return (char*)Line;
		if(zeichen!='$' )continue;
		if(Line[pos+1]=='(')break;
		if(Line[pos+1]=='$')break;
		}


	if(!temp_text || pos+64<temp_size)		// Neuen Puffer erzeugen
		{
		if(temp_text)delete temp_text ;
		temp_text = new char[pos+512+1];
		temp_size = pos+512;
		}

	wo=pos;
	memcpy(temp_text,Line,pos);

	for(;pos<Max;pos++)						// Suche Symbolangabe
		{
		zeichen = Line[pos];

		if(zeichen==0)break;

		if(zeichen!='$' || Line[pos+1]!='(')// Zeichen speichern
			{
			if(zeichen=='$' && Line[pos+1]=='$')pos++;

			temp_text[wo]=zeichen;
			wo++;

			if(wo>=temp_size)				// Puffer vergrern
				{
				PUFFER_ADD(temp_text,temp_size,wo+256);
				}
			continue;
			}

		pos        += 2;
		level       = 0;
		size[level] = 0;
											// Hole Variabelnamen
		for(len=0,num=0;num<sizeof(varname)-2;len++)
			{
			   zeichen = Line[pos+len];
			if(zeichen!=')')
				{
				if(zeichen!='$' || Line[pos+len+1]!='(')
					{
					varname[num] =zeichen;
					num++;
					continue;
					}

				if(level>=8)break;

				len++;
				level++;
				size[level] = num;
				continue;
				}

			varname[num] = 0;
			num = size[level];

			   level--;
			if(level<0)break;
											// Ersatz Text holen
				var=VarGetName(varname+num);
			if(!var)
				{
				continue;
				}

			cnt = strlen(var);

 			if(num+cnt>=sizeof(varname)-2)
				{
				continue;
				}

			memcpy(varname+num,var,cnt);	// Ersatz Text einfgen
			num += cnt;
			}



		if(Line[pos+len]!=')')continue;

		pos+=len;

			var=VarGetName(varname);		// Ersatz Text holen
		if(!var)continue;

		len=strlen(var);
 		if(wo+len>=temp_size)				// Puffer vergrern
			{
			PUFFER_ADD(temp_text,temp_size,wo+len+256);
			}

		memcpy(temp_text+wo,var,len);		// Ersatz Text einfgen
		wo+=len;
		}


	temp_text[wo]=0;


return temp_text;
}

//*****************************************************************************
//*
//*		VarLine
//*
//*****************************************************************************
//	Aktuelle Zeile abfragen
int VarLine()
{
return line_now;
}

//*****************************************************************************
//*
//*		VarVersionOfExec
//*
//*****************************************************************************
//	Holt einen Versionstext aus einer EXE-Datei
//	Quelle		: Name der Textdatei
//	Type		: Ist der Ausgabetyp
//					0 = auto
//					1 = 1
//					2 = 1.1
//					3 = 1.1.1
//					4 = 1.1.1.1
//					5 = 1.12
//	Name		: Hier wird der Versionstext gespeichert
//	Size		: Gre des Textpuffers
//	Ergibt die Lnge des gefundenen Versionstexts bzw. -1 wenn nicht.
#ifndef 	VAR_ONLY_ENV

#pragma comment(lib, "version.lib")

int VarVersionOfExec(const char *Quelle,int Type,char *Name,int Size)
{
VS_VERSIONINFO		*info;
VS_FIXEDFILEINFO	*ver;
char				*mem;
char				 text[256];
char				 temp[256];
int					 len;


	if(Size>0)*Name=0;


	if(!GetFileVersionInfo((char*)Quelle,0,sizeof(text),text))
		{
		return -1;
		}

	info = (VS_VERSIONINFO*)text;

	if(wcscmp(info->szKey,L"VS_VERSION_INFO"))
		{
		return -1;
		}

	mem = (char*)(&info->szKey+wcslen(info->szKey)+1);

	if(((unsigned)mem)&3)
		{
		mem += 4-((unsigned)mem)&3;
		}

	ver = (VS_FIXEDFILEINFO*)mem;

	if(ver->dwSignature!=0xFEEF04BD)
		{
		return -1;
		}

	if(Type==0)
		{
		if(ver->dwFileVersionLS&0xFFFF)
			{
			Type = 4;
			}
		else if(ver->dwFileVersionLS)
			{
			Type = 3;
			}
		else{
			Type = 5;
			}
		}


	switch(Type)
		{
	case 4:	len=sprintf(temp,"%i.%i.%i.%i",ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF,ver->dwFileVersionLS>>16,ver->dwFileVersionLS&0xFFFF);	break;
	case 3:	len=sprintf(temp,"%i.%i.%i"   ,ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF,ver->dwFileVersionLS>>16);								break;
	case 2:	len=sprintf(temp,"%i.%i"      ,ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF);														break;
	case 1:	len=sprintf(temp,"%i"         ,ver->dwFileVersionMS>>16);																					break;
	default:len=sprintf(temp,"%i.%02i"    ,ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF);														break;
		}


return strlcpy(Name,temp,Size,len);
}
#endif

//*****************************************************************************
//*
//*		VarVersionOfText
//*
//*****************************************************************************
//	Holt einen Versionstext aus einer Textdatei
//	Quelle		: Name der Textdatei
//	Filter		: Filter fr Texte  "Pre" "Version" "Post" (fr memycmp)
//	Name		: Hier wird der Versionstext gespeichert
//	Size		: Gre des Textpuffers
//	Ergibt die Lnge des gefundenen Versionstexts bzw. -1 wenn nicht.
#ifndef 	VAR_ONLY_ENV
int VarVersionOfText(const char *Quelle,const char *Filter,char *Name,int Size)
{
FILE   *file;
char	filter1[128];
char	filter2[128];
char	filter3[128];
char	text  [1024];
int		star;
int		null;
int		len1;
int		len2;
int		len3;
int		pos;


	if(Size>0)*Name=0;

		file = fopen(Quelle,"rb");
	if(!file)return -1;

	Filter += strwlen  (Filter,0xE0);
	Filter += strgetstr(filter1,Filter,sizeof(filter1));
	Filter += strwlen  (Filter,0xE0);
	Filter += strgetstr(filter2,Filter,sizeof(filter2));
	Filter += strwlen  (Filter,0xE0);
	Filter += strgetstr(filter3,Filter,sizeof(filter3));

	if(!filter3[0])strcpy(filter3,"*");

	text[sizeof(text)-1]=0;

	if(filter1[0]=='\\' && filter1[1]=='.')				// Beginn mit Leerbereich
			null = strwlen(filter1+2,0x1F);
	else	null = 0;

	if(filter1[0]=='*')									// Beginn mit variablen Bereich
			star = strwlen(filter1+1,0x1F);
	else	star = 0;


	while(fgets(text,sizeof(text)-1,file))
		{
		if(null)
			{
			pos = strwlen(text,0xA0);

			if(memicmp(text+pos,filter1+2,null))
				{
				len1=0;
				continue;
				}
			}
		else if(star)
			{
			if(strlifind(text,filter1+1,strlen(text),star)<0)
				{
				len1=0;
				continue;
				}
			}

		len1 = memycmp(filter1,text          ,strlen(text          ),0x05);
		len2 = memycmp(filter2,text+len1     ,strlen(text+len1     ),0x05);
		len3 = memycmp(filter3,text+len1+len2,strlen(text+len1+len2),0x05);

		if(len1 && len2 && len3)break;

		len1=0;
		}

	fclose(file);

	if(!len1)return -1;


return strlcpy(Name,text+len1,Size,len2);
}
#endif

//*****************************************************************************
//*
//*		VarScanLine
//*
//*****************************************************************************
//	Scannt in einer Zeile alle Eintrge
//	Line	: Zeiger auf Zeile (achtung wird verndert)
//	Name	: Zeiger auf Namensliste
//	Type	: Zeiger auf Typliste (0=Eintrag 1=Text 2=Zahl)
//	Max		: Maximale anzahl der zu suchenen Eintrge
//	Die Eintrge in Name mssen spter mit delete freigegeben werden
//	Ergibt die Zahl der gefunden Eintrge
#ifndef 	VAR_ONLY_ENV
int VarScanLine(char *Line,char **Name,int *Type,int Max)
{
int		anz=0,add,len;
char   *ptr,buffer[1024];

	while(Max>0)
		{
			Line += strspn(Line," \t\n\r");
		if(!Line[0])break;


		if(Line[0]!='"')					// Normales Wort
			{
			len=strcspn(Line," \t\n\r");
			add=len;
			if(Line[len])add++;
			Line[len]=0;

			ptr=VarConvert(Line,len);
			len=strlen(ptr)+1;
			Line+=add;

			Name[anz]=new char[len];		// Namen speichern
			memcpy(Name[anz],ptr,len);
			strtoi(Name[anz],0,&add);
			Type[anz]=(len-1==add && len>1)? 2:0;
			anz++;

			continue;
			}

			Line++;
		if(!Line[0])break;

		for(len=0;Line[len];)				// Suche Stringende
			{
			len+=strcspn(Line+len,"\\\"");
			if(Line[len]=='"' )break;
			if(Line[len]=='\\')
				{
				if(Line[len+1]=='\\'){len+=2;continue;}
				if(Line[len+1]=='"' ){len+=2;continue;}
				}
			len++;
			}

		if(Line[len]!='"')break;

		add=len;
		if(Line[len])add++;
		Line[len]=0;

		len=strtomem(buffer,sizeof(buffer)-1,Line);
		buffer[len]=0;
		ptr=VarConvert(buffer,len);
		len=strlen(ptr)+1;
		Line+=add;

		Name[anz]=new char[len];			// Namen speichern
		memcpy(Name[anz],ptr,len);
		strtoi(Name[anz],0,&add);
		Type[anz]=(len-1==add && len>1)? 2:1;
		anz++;
		}


return anz;
}
#endif

//*****************************************************************************
//*
//*		VarScript
//*
//*****************************************************************************
//	Frt ein Skript aus
//	Filename	: Skript-Datei 	(*.vsk)
//	DummyFile	: Alternativer Skript-Dateiname (NULL=keiner)
//	Ergibt		: 0 Alles ok
//				  1 Kann Datei nicht ffnen
//				  2 Syntaxfehler
#ifndef VAR_ONLY_ENV
int VarScript(const char *Filename,const char *DummyFile)
{
unsigned		 timeend,time;
CStringChain	 goto_names(sizeof(int)*2);
int				 file_pos,file_max,file_next;
char			*file_mem,*text;
static char 	*if_cmp[]={"==","!=",">=","<","<=",">","&","!&","^","!^","^^","!^^","?","!?","??","!??","*==","*!=","*>=","*<","*<=","*>","@==","@!=","@>=","@<","@<=","@>","?==","?!=","?>=","?<","?<=","?>"};
char			 buffer[1024],line[2048],goto_name[64],temp[64],*ptr,*txt;
int				 goto_flag=0,end_flag=0,case_flag=0;
int				 exit_flag=0,else_flag=0,table_flag=0;
int				 exit_val=0,type=0,line_nr=0,cancel=0,exitst=0;
int				 v,w,x,y,z,index,column,ok,max,len,value,flags;
int				*table_len,table_brt=1,table_int[3];
int				 default_pos=-1,goto_pos=-1;
int				 default_lnr=-1,goto_lnr=-1;
int				 namen_count=0,nr;
int				 typen[MAX_ENTRYS];
char			*namen[MAX_ENTRYS];
char			*alloc[MAX_ENTRYS];
char			 fname[256];
DWORD			 finddirs=0;
HANDLE			 findhandle=INVALID_HANDLE_VALUE;
WIN32_FIND_DATA	 finddata;
CFileBuffer		 file;



	if(!file.OpenAnsi(Filename))
		{
		return 1;
		}

	   file_max = file.GetLength();
	if(file_max<=0)return 1;

	file_mem = new char[file_max+1];
	file.Read(file_mem,file_max);
	file_mem[file_max]=0;
	file.Close();

	file_next=0;
	fname[0] =0;

	if(!DummyFile || !*DummyFile)DummyFile=Filename;

	GetFilePath(buffer,DummyFile,sizeof(buffer));
	DelBackSlash(buffer);
	VarSet("CURRENT_PATH",buffer);
	VarSet("CURRENT_FILE",DummyFile);

	for(;;)
		{
		for(;namen_count>0;namen_count--)delete alloc[namen_count-1];

		if(file_next>=file_max)break;
		for(file_pos=file_next;file_next<file_max;file_next++)
			{
			if(file_mem[file_next]=='\n')
				{
				file_next++;
				break;
				}
			}

		if(file_next-file_pos>=sizeof(buffer))
			{
			file_next=file_pos+sizeof(buffer)-1;
			}

		memcpy(buffer,file_mem+file_pos,file_next-file_pos);
		buffer[file_next-file_pos]=0;
		ptr=buffer;
		strlcpy(line,buffer,sizeof(line));
		line_nr++;
		line_now=line_nr;

			namen_count=VarScanLine(ptr,namen,typen,MAX_ENTRYS);
		if(!namen_count)continue;
		ptr=namen[0];

		memcpy(alloc,namen,sizeof(alloc));


//******************** Sprungmarken *******************************************


		if(*ptr==';')continue;						// Kommentar

		if(*ptr==':')								// Sprung Marke
			{
			ptr++;
			if(!*ptr){exit_val=2;break;}
			if(namen_count!=1){exit_val=2;break;}
		   	table_int[0]=file_pos;
			table_int[1]=line_nr-1;

			x=goto_names.FindFast(ptr,0,-1,1);

			if(x>=0)
				{
				if(goto_names.DataGet(x)!=file_pos){exit_val=5;break;}
				}
			else{
				goto_names.Add(ptr,CSC_ABCG,&table_int);
				}

			if(goto_flag && !stricmp(goto_name,ptr))goto_flag=0;
			continue;
			}

		if(!stricmp(ptr,"CASE"))
			{
			if(namen_count<3){exit_val=2;break;}
			if(strcmp(namen[2],":")){exit_val=2;break;}
			if(case_flag && !stricmp(goto_name,namen[1]))case_flag=0;
			continue;
			}

		if(!stricmp(ptr,"TABLE"))
			{
			if(table_flag){exit_val=2;break;}
			if(namen_count!=3){exit_val=2;break;}

			table_flag=1;

			if(goto_flag || case_flag || else_flag)continue;

			   table_brt=strtoi(namen[2]);
			if(table_brt<1){exit_val=2;break;}

			x=table_pos.Find(namen[1],0,-1,1);
			table_int[0]=0;
			table_int[1]=table_brt;
			table_int[2]=table_val.Count();

			x=table_pos.Add(namen[1],x,table_int);
			table_len=(int*)table_pos.Data(x);
			continue;
			}

		if(!stricmp(ptr,"END"))
			{
			if(table_flag)
				{
				table_flag=0;
				continue;
				}
			if(case_flag && default_pos>=0)
				{
				file_next=default_pos;
				line_nr=default_lnr;
				case_flag=0;
				continue;
				}
			if(end_flag>0)end_flag--;
			else		  else_flag=0;
			continue;
			}

		if(!stricmp(ptr,"ELSE"))
			{
			if(table_flag){exit_val=2;break;}
			if(!end_flag)
				{
				if(else_flag)else_flag=0;
				else		 end_flag=1;
				}
			continue;
			}

		if(!stricmp(ptr,"DEFAULT:"))
			{
			default_pos=file_pos;
			default_lnr=line_nr-1;
			continue;
			}

		if(end_flag || else_flag)
			{
			if(!stricmp(ptr,"SWITCH"))end_flag++;
			if(!stricmp(ptr,"IF") || !stricmp(ptr,"IFEXIST"))
				{
				if(namen_count>=5 && stricmp(namen[4],"GOTO") && stricmp(namen[4],"EXIT"))
					{
					end_flag++;
					}
				}
			continue;
			}

		if(goto_flag || case_flag || else_flag)continue;

		if(VarDebug)						// Debug Modus
			{
			x=VarDebug(VarDParam,line_nr,line,&var_name,Filename);
			if(x)break;
			}

//******************** Funktionen *********************************************

		if(table_flag)						// Tabeleneintrge lesen
			{
			if(namen_count<1)continue;

			for(x=0;x<table_len[1];x++)
				{
				if(x>=namen_count)
					{
					y=0;
					table_val.Add("",CSC_END,&y);
					}
				else{
					y=strtoi(namen[x]);
					table_val.Add(namen[x],CSC_END,&y);
					}
				}

			table_len[0]+=table_len[1];
			continue;
			}

		if(!stricmp(ptr,"GOTO"))
			{
			if(namen_count!=2){exit_val=2;break;}
			ptr=namen[1];
			nr=goto_names.FindFast(ptr,0,-1,1);
			if(nr>=0)
				{
				file_next=goto_names.DataGet(nr);
				line_nr  =goto_names.DataGet(nr,1);
				continue;
				}

			strlcpy(goto_name,ptr,sizeof(goto_name));
			goto_flag=1;
			continue;
			}

		if(!stricmp(ptr,"SWITCH"))
			{
			if(namen_count!=2){exit_val=2;break;}
			if(case_flag){exit_val=2;break;}
			ptr=VarGetName(namen[1]);
			if(!ptr)ptr="";
			strlcpy(goto_name,ptr,sizeof(goto_name));
			default_pos=-1;
			default_lnr=-1;
			case_flag=1;
			continue;
			}

		if(!stricmp(ptr,"BREAK"))
			{
			if(namen_count!=1){exit_val=2;break;}
			end_flag=1;
			continue;
			}

		if(!stricmp(ptr,"SET"))
			{
			if(namen_count!=4){exit_val=2;break;}
			if(strcmp(namen[2],"=")){exit_val=2;break;}
			type=1;
			VarSet(namen[1],namen[3],&type);
			continue;
			}

		if(!stricmp(ptr,"STRUPPER"))
			{
			if(namen_count!=4){exit_val=2;break;}
			if(strcmp(namen[2],"=")){exit_val=2;break;}
			type=1;
			strupr(namen[3]);
			VarSet(namen[1],namen[3],&type);
			continue;
			}

		if(!stricmp(ptr,"STRLOWER"))
			{
			if(namen_count!=4){exit_val=2;break;}
			if(strcmp(namen[2],"=")){exit_val=2;break;}
			type=1;
			strlwr(namen[3]);
			VarSet(namen[1],namen[3],&type);
			continue;
			}

		if(!stricmp(ptr,"SET_CALC"))
			{
			if(namen_count!=4){exit_val=2;break;}
			if(strcmp(namen[2],"=")){exit_val=2;break;}
			type=1;
			VarSet(namen[1],strcalc(namen[3]),&type);
			continue;
			}

		if(!stricmp(ptr,"SET_EXIST"))
			{
			if(namen_count!=3){exit_val=2;break;}
			sprintf(buffer,"%i",ExistFile(namen[2]));
			type=1;
			VarSet(namen[1],buffer,&type);
			continue;
			}

		if(!stricmp(ptr,"SET_SIZE"))
			{
			if(namen_count!=3){exit_val=2;break;}
			sprintf(buffer,"%i",LengthFile(namen[2]));
			type=1;
			VarSet(namen[1],buffer,&type);
			continue;
			}

		if(!stricmp(ptr,"SET_TIME"))
			{
			if(namen_count<3 || namen_count>4){exit_val=2;break;}
			if(namen_count==4)
				{
				     if(!strcmp(namen[3],"WRITE" ))x=0;
				else if(!strcmp(namen[3],"CREATE"))x=1;
				else if(!strcmp(namen[3],"ACCESS"))x=2;
				else {exit_val=2;break;}
				}
			else{
				x = 0;
				}

			time=FileTime(namen[2],x);
			VarSet("ERRORLEVEL",(time)? "0":"-1");
			strtimeset(buffer,time,STR_ALL_ISO);
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"SET_VERSION"))
			{
			if(namen_count<3 || namen_count>4){exit_val=2;break;}
			if(namen_count==4)
					x=VarVersionOfText(namen[2],namen[3],buffer,sizeof(buffer));
			else	x=VarVersionOfExec(namen[2],0       ,buffer,sizeof(buffer));
			VarSet("ERRORLEVEL",(x>=0)? "0":"-1");
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"SET_PARAM"))
			{
			if(namen_count<3 || namen_count>4){exit_val=2;break;}
			if(namen_count==4)
				{
				if(strcmp(namen[3],"FLAG"))
					{
					exit_val=2;
					break;
					}
				}
	
			z = strlen(namen[2]);

			for(y=1;y<32;y++)				// Suche Komandozeilen Parameter	
				{
				sprintf(temp,"PARAM%i",y);

					text = VarGetName(temp);
				if(!text){y=32;break;}

				if(*text!='-' && *text!='/')
					{
					continue;
					}

				if(strnicmp(text+1,namen[2],z))
					{
					continue;
					}
				
				if(text[1+z]==':' || text[1+z]==0)
					{
					break;
					}
				}

			if(y>=32)						// Wuder der Parameter nicht gefunden
				{
				VarSet("ERRORLEVEL","0");
				VarSet(namen[1],(namen_count==4)? "0":"");
				continue;
				}

			VarSet("ERRORLEVEL","1");

			if(namen_count==4)				// Prfen ob der Parameter existiert
				{
				VarSet(namen[1],"1");
				continue;
				}

			if(text[1+z]==':')
				{
				text += 2+z;
				}
			else{
				sprintf(temp,"PARAM%i",y+1);
				text = VarGetName(temp);

				if(!text || *text=='-' || *text=='/')
					{
					text ="";
					}
				}
		  
			VarSet(namen[1],text);
			continue;
			}

		if(!stricmp(ptr,"SET_FILE"))
			{
			if(namen_count <2){exit_val=2;break;}
			if(namen_count >4){exit_val=2;break;}
			if(namen_count==4)
				{
				if(stricmp(namen[3],"CANCEL")){exit_val=2;break;}
				cancel=1;
				}
			else{
				cancel=0;
				}

				VarSet("ERRORLEVEL","0");
				ptr=VarGetName(namen[1]);
				ptr=VarGetFile(ptr,namen[2],cancel);
			if(!ptr)
				{
				VarSet("ERRORLEVEL","-1");
				break;
				}
			type=1;
			VarSet(namen[1],ptr,&type);
			continue;
			}

		if(!stricmp(ptr,"SET_PATH"))
			{
			if(namen_count <2){exit_val=2;break;}
			if(namen_count >5){exit_val=2;break;}

			cancel=0;
			exitst=0;

			if(namen_count>=4)
				{
				     if(!stricmp(namen[3],"CANCEL"))cancel=1;
				else if(!stricmp(namen[3],"EXIST" ))exitst=1;
				else {exit_val=2;break;}
				}

			if(namen_count>=5)
				{
				     if(!stricmp(namen[4],"CANCEL"))cancel=1;
				else if(!stricmp(namen[4],"EXIST" ))exitst=1;
				else {exit_val=2;break;}
				}

				VarSet("ERRORLEVEL","0");
				ptr=VarGetName(namen[1]);
				ptr=VarGetPath(ptr,namen[2],cancel,exitst);
			if(!ptr)
				{
				VarSet("ERRORLEVEL","-1");
				continue;
				}
			type=1;
			VarSet(namen[1],ptr,&type);
			continue;
			}

		if(!stricmp(ptr,"LICENSE_INFO"))
			{
			if(namen_count<1){exit_val=2;break;}
			if(namen_count>4){exit_val=2;break;}

			if(VarLicenceInfo(namen[1],namen[2],namen[3]))
					VarSet("ERRORLEVEL", "0");
			else	VarSet("ERRORLEVEL","-1");

			continue;
			}


		if(!stricmp(ptr,"SET_TEXT"))
			{
			if(namen_count <2){exit_val=2;break;}
			if(namen_count >5){exit_val=2;break;}
			if(namen_count==5)
				{
				if(stricmp(namen[4],"CANCEL")){exit_val=2;break;}
				cancel=1;
				}
			else{
				cancel=0;
				}

				VarSet("ERRORLEVEL","0");
				ptr=VarGetName(namen[1]);
				ptr=VarGetText(ptr,namen[2],namen[3],cancel);
			if(!ptr)
				{
				VarSet("ERRORLEVEL","-1");
				break;
				}
			type=1;
			VarSet(namen[1],ptr,&type);
			continue;
			}

		if(!stricmp(ptr,"LOAD_TEXT"))
			{
			if(namen_count!=3){exit_val=2;break;}
			VarLoadText(namen[1],namen[2]);
			continue;
			}

		if(!stricmp(ptr,"GET_VERSION"))
			{
			if(namen_count!=3){exit_val=2;break;}

			type=1;
			VarSet(namen[1],VERSION_MJR,&type);
			VarSet(namen[2],VERSION_SUB,&type);
			continue;
			}

		if(!stricmp(ptr,"GET_REG"))
			{
			if(namen_count <3){exit_val=2;break;}
			if(namen_count >4){exit_val=2;break;}
			ptr=VarGetReg(namen[2],(namen_count>3)? namen[3]:0);
			if(!ptr)ptr="";
			type=1;
			VarSet(namen[1],ptr,&type);
			continue;
			}

		if(!stricmp(ptr,"DEL_REG"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count> 3){exit_val=2;break;}
			if(namen_count<=2)namen[2]=0;
			VarDelReg(namen[1],namen[2]);
			continue;
			}

		if(!stricmp(ptr,"SET_REG_SZ"))
			{
			if(namen_count <3){exit_val=2;break;}
			if(namen_count >4){exit_val=2;break;}
			VarSetRegSz(namen[2],(namen_count>3)? namen[3]:0,namen[1]);
			continue;
			}

		if(!stricmp(ptr,"SET_REG_DWORD"))
			{
			if(namen_count!=4){exit_val=2;break;}
			VarSetRegDword(namen[2],namen[3],strtoi(namen[1]));
			continue;
			}

		if(!stricmp(ptr,"MESSAGE"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count> 3){exit_val=2;break;}
			if(namen_count<=2)namen[2]=0;
			MessageBox((HWND)VarWindow,namen[1],namen[2],MB_OK);
			continue;
			}

		if(!stricmp(ptr,"MESSAGE_QUERY"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			if(namen_count<=4)namen[4]=0;
													 x=MB_OK;
			if(!stricmp(namen[1],"OkCancel"		   ))x=MB_OKCANCEL;
			if(!stricmp(namen[1],"YesNo"		   ))x=MB_YESNO;
			if(!stricmp(namen[1],"YesNoCancel"	   ))x=MB_YESNOCANCEL;
			if(!stricmp(namen[1],"RetryCancel"	   ))x=MB_RETRYCANCEL;
			if(!stricmp(namen[1],"AbortRetryIgnore"))x=MB_ABORTRETRYIGNORE;

			if(x==MB_OK){exit_val=2;break;}

			if(namen_count>=6)
				{
				y=strtoi(namen[5]);
				if(y==1)x|=MB_DEFBUTTON1;
				if(y==2)x|=MB_DEFBUTTON2;
				if(y==3)x|=MB_DEFBUTTON3;
				if(y==4)x|=MB_DEFBUTTON4;
				}


			y=MessageBox((HWND)VarWindow,namen[3],namen[4],x);
			switch(y)
				{
			default:
			case IDCANCEL:	VarSet(namen[2],"CANCEL");	break;
			case IDIGNORE:	VarSet(namen[2],"IGNORE");	break;
			case IDABORT:	VarSet(namen[2],"ABORT");	break;
			case IDRETRY:	VarSet(namen[2],"RETRY");	break;
			case IDYES:		VarSet(namen[2],"YES");		break;
			case IDNO:		VarSet(namen[2],"NO");		break;
			case IDOK:		VarSet(namen[2],"OK");		break;
				}

			continue;
			}

		if(!stricmp(ptr,"SHORTCUT"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			if(namen_count<=3)namen[3]=0;
			if(namen_count<=4)namen[4]=0;
			if(namen_count<=5)namen[5]=0;

			ShortCutCreate(namen[1],namen[2],namen[3],namen[4],namen[5]);

			continue;
			}

		if(!stricmp(ptr,"SHORTCUT_ICON"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 5){exit_val=2;break;}
			if(namen_count<=3)namen[3]="";
			if(namen_count<=4)namen[4]="0";

			ShortCutSetIcon(namen[1],namen[2],namen[3],strtoi(namen[4]));

			continue;
			}

		if(!stricmp(ptr,"SHORTCUT_QUERY"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 4){exit_val=2;break;}
			if(namen_count<=3)namen[3]=0;

			ShortCutQuery(namen[2],namen[3],buffer,sizeof(buffer));
			VarSet(namen[1],buffer);

			continue;
			}

		if(!stricmp(ptr,"PRINT"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			if(namen_count<=3)namen[3]="";
			if(namen_count<=4)namen[4]="";
			if(namen_count<=5)namen[5]="";

			if(*namen[2]=='#')
				{
				VarPrintTo(namen[1],namen[2],namen[3],namen[4],namen[5]);
				}
			else{
				VarPrintTo(namen[1],namen[2],strtoi(namen[3]),strtoi(namen[4]),strtoi(namen[5]));
				}

			continue;
			}

		if(!stricmp(ptr,"REG_FILEICON"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			if(namen_count<=3)namen[3]="0";
			if(namen_count<=4)namen[4]=0;
			if(namen_count<=5)namen[5]=0;

			ConfigFileIcon(namen[1],namen[2],strtoi(namen[3]),namen[4],namen[5]);
			ConfigFileRefresh(namen[1]);

			continue;
			}

		if(!stricmp(ptr,"REG_FILECMD"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 5){exit_val=2;break;}
			if(namen_count<=3)namen[3]=0;
			if(namen_count<=4)namen[4]=0;

			ConfigFileCommand(namen[1],namen[2],namen[3],namen[4]);

			continue;
			}

		if(!stricmp(ptr,"REG_FILECMDICON"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 5){exit_val=2;break;}
			if(namen_count<=3)namen[3]=0;
			if(namen_count<=4)namen[4]="0";

			ConfigFileCmdIcon(namen[1],namen[3],namen[2],strtoi(namen[4]));

			continue;
			}

		if(!stricmp(ptr,"REG_FILEQUERY"))
			{
			if(namen_count!=3){exit_val=2;break;}

			x=ConfigFileQuery(namen[1]);
			VarSet(namen[2],x);

			continue;
			}

		if(!stricmp(ptr,"REG_FILECMDCHANGE"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			if(namen_count<=4)namen[4]=0;
			if(namen_count<=5)namen[5]=0;

			if(namen[4] && !stricmp(namen[4],"ALLCMD"))namen[4]=(char*)ALL_COMMAND;
			x=ConfigFileCmdChange(namen[1],namen[2],namen[3],namen[4],namen[5]);
			VarSet("ERRORLEVEL",x);

			continue;
			}

		if(!stricmp(ptr,"REG_FILEICONCHANGE"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count> 5){exit_val=2;break;}
			if(namen_count<=4)namen[4]=0;

			x=ConfigFileIconChange(namen[1],namen[2],namen[3],strtoi(namen[4]));
			VarSet("ERRORLEVEL",x);

			continue;
			}

		if(!stricmp(ptr,"REG_FILEDELETEIF"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 4){exit_val=2;break;}
			if(namen_count<=3)namen[3]=0;

			x=ConfigFileDeleteIf(namen[1],namen[2],namen[3]);
			VarSet("ERRORLEVEL",x);

			continue;
			}


		if(!stricmp(ptr,"REG_FILECMDDELETE"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count> 4){exit_val=2;break;}
			if(namen_count<=2)namen[2]=0;
			if(namen_count<=3)namen[3]=0;

			if(namen[2] && !stricmp(namen[2],"ALLCMD"))namen[2]=(char*)ALL_COMMAND;
			x=ConfigFileCmdDelete(namen[1],namen[2],namen[3]);
			VarSet("ERRORLEVEL",x);

			continue;
			}

		if(!stricmp(ptr,"REG_FILEDELETE"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count> 3){exit_val=2;break;}
			if(namen_count<=2)namen[2]="1";

			x=ConfigFileDelete(namen[1],strtoi(namen[2])!=0);
			VarSet("ERRORLEVEL",x);

			continue;
			}

		if(!stricmp(ptr,"FINDFIRST"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}

			finddirs=0;
			ptr=0;

			if(namen_count>=4)
				{
				if(!stricmp(namen[3],"ONLYDIR"))
					{
					finddirs=FILE_ATTRIBUTE_DIRECTORY;
					if(namen_count>=5)
						{
						if(namen_count==5          ){exit_val=2;break;}
						if(stricmp(namen[4],"GOTO")){exit_val=2;break;}
						ptr=namen[5];
						}
					}
				else{
					if(namen_count!=5          ){exit_val=2;break;}
					if(stricmp(namen[3],"GOTO")){exit_val=2;break;}
					ptr=namen[4];
					}
				}

			if(findhandle!=INVALID_HANDLE_VALUE)
				{
				FindClose(findhandle);
				}


			   findhandle=FindFirstFile(namen[1],&finddata);
			if(findhandle==INVALID_HANDLE_VALUE)
				{
				x=0;
				fname[0]=0;
				}
			else{
				x=GetFilePath(fname,namen[1],sizeof(fname))-1;
				if(x>=0 && (fname[x]=='\\' || fname[x]=='/'))fname[x]=0;
				x=1;
				}

			while(x && (!strcmp(finddata.cFileName,"." ) ||
					    !strcmp(finddata.cFileName,"..") ||
				       ((finddata.dwFileAttributes^finddirs)&FILE_ATTRIBUTE_DIRECTORY)))
				{
				x=FindNextFile(findhandle,&finddata);
				}


			VarSet(namen[2],(x)? finddata.cFileName:"");

			if(!x && ptr)
				{
				nr=goto_names.FindFast(ptr,0,-1,1);
				if(nr>=0)
					{
					file_next=goto_names.DataGet(nr);
					line_nr  =goto_names.DataGet(nr,1);
					continue;
					}
				strlcpy(goto_name,ptr,sizeof(goto_name));
				goto_flag=1;
				}

			continue;
			}

		if(!stricmp(ptr,"FINDNEXT"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count==3){exit_val=2;break;}
			if(namen_count>=5){exit_val=2;break;}
			if(namen_count==4 && stricmp(namen[2],"GOTO")){exit_val=2;break;}

			if(findhandle==INVALID_HANDLE_VALUE)
				{
				VarSet(namen[1],"");
				continue;
				}

			x=FindNextFile(findhandle,&finddata);

			while(x && (!strcmp(finddata.cFileName,"." ) ||
					    !strcmp(finddata.cFileName,"..") ||
				       ((finddata.dwFileAttributes^finddirs)&FILE_ATTRIBUTE_DIRECTORY)))
				{
				x=FindNextFile(findhandle,&finddata);
				}

			VarSet(namen[1],(x)? finddata.cFileName:"");

			if(x && namen_count==4)
				{
				ptr=namen[3];
				nr=goto_names.FindFast(ptr,0,-1,1);
				if(nr>=0)
					{
					file_next=goto_names.DataGet(nr);
					line_nr  =goto_names.DataGet(nr,1);
					continue;
					}
				strlcpy(goto_name,ptr,sizeof(goto_name));
				goto_flag=1;
				}

			continue;
			}

		if(!stricmp(ptr,"LICENSE_DIALOG"))
			{
			if(namen_count!=1){exit_val=2;break;}

			#ifndef VAR_ONLY_ENV
			VarLicenseDlg();
			#endif

			continue;
			}

		if(!stricmp(ptr,"TREE_SELECT"))
			{
			if(namen_count<=1 ){exit_val=2;break;}
			if(namen_count>=12){exit_val=2;break;}

			for(x=0,y=0,z=2,flags=0;z<namen_count;z++)
				{
				if(!stricmp (namen[z],"CANCEL"   )){flags|=0x0080;continue;}
				if(!stricmp (namen[z],"VERT"     )){flags|=0x0040;continue;}
				if(!stricmp (namen[z],"NOLINES"  )){flags|=0x0020;continue;}
				if(!stricmp (namen[z],"NOICONS"  )){flags|=0x0010;continue;}
				if(!stricmp (namen[z],"NOINFO"   )){flags|=0x0100;continue;}
				if(!stricmp (namen[z],"SELECT"   )){flags|=0x0200;continue;}
				if(!stricmp (namen[z],"ENDBUTTON")){flags|=0x0400;continue;}
				if(!stricmp (namen[z],"SINGLE"	 )){flags|=0x0800;continue;}
				if(!stricmp (namen[z],"EXPAND"	 )){flags|=0x1000;continue;}
				if(!strnicmp(namen[z],"X=",2     )){x=strtoi(namen[z]+2);continue;}
				if(!strnicmp(namen[z],"Y=",2     )){y=strtoi(namen[z]+2);continue;}
				if(*namen[z]>='0' && *namen[z]<='9')
					{
					flags|=strtoi(namen[z])&0x0F;
					continue;
					}
				exit_val=2;
				break;
				}
			if(z<namen_count)break;

			z=table_pos.Find(namen[1],0,-1,1);
			if(z<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(z);
			VarSet("ERRORLEVEL","0");

			z=VarTableSelect(flags,&table_val,table_len[2],table_len[0],table_len[1],x,y);
			if(!z)
				{
				VarSet("ERRORLEVEL","-1");
				break;
				}
			continue;
			}

		if(!stricmp(ptr,"CALL"))
			{
			VarCall(namen+1,namen_count-1);
			continue;
			}

		if(!stricmp(ptr,"CALL_REG"))
			{
			if(namen_count!=2){exit_val=2;break;}
			VarCallReg(namen[1]);
			continue;
			}

		if(!stricmp(ptr,"CALL_SCRIPT"))
			{
			if(namen_count!=2){exit_val=2;break;}
			strlcpy(buffer+512,VarGetName("CURRENT_PATH"),256);
			strlcpy(buffer+256,VarGetName("CURRENT_FILE"),256);
			VarSet("CALLBACK_VAR","");
			VarSet("CALLBACK_NR" ,"");
			if(memcmp(namen[1],"HKEY_",5))
				{
				VarScript(namen[1]);
				}
			else{
				VarLoadReg(namen[1]);
				}
			VarSet("CURRENT_PATH",buffer+512);
			VarSet("CURRENT_FILE",buffer+256);
			continue;
			}

		if(!stricmp(ptr,"CALL_REG"))
			{
			if(namen_count!=2){exit_val=2;break;}
			CRegText reg;
			reg.Import(namen[1]);
			continue;
			}

		if(!stricmp(ptr,"SAVE_TABLE"))
			{
			if(namen_count!=3){exit_val=2;break;}

			x=table_pos.Find(namen[2],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			VarSaveTable(namen[1],namen[2],&table_val,table_len[2],table_len[0],table_len[1]);
			continue;
			}

		if(!stricmp(ptr,"TABLE_SIZE"))
			{
			if(namen_count!=3){exit_val=2;break;}
			type=1;
			x=table_pos.Find(namen[2],0,-1,1);
			if(x<0)VarSet(namen[1],-1,&type);
			else{
				table_len=(int*)table_pos.Data(x);
				VarSet(namen[1],table_len[0]/table_len[1],&type);
				}

			continue;
			}

		if(!stricmp(ptr,"TABLE_GET"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count> 5){exit_val=2;break;}

			x=table_pos.Find(namen[2],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			if(namen_count==5)
					column = strtoi(namen[4]);
			else	column = 0;

			index = strtoi(namen[3]);

			   y=table_len[1];
			if(y<=0)y=1;

			if(index<0 || index>=table_len[0]/y){exit_val=4;break;}
			if(column<0 || column>=table_len[1]  ){exit_val=4;break;}

			ptr=table_val[table_len[2]+table_len[1]*index+column];
			type=1;
			VarSet(namen[1],ptr,&type);
			continue;
			}

		if(!stricmp(ptr,"TABLE_SET"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count> 5){exit_val=2;break;}

			x=table_pos.Find(namen[2],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			if(namen_count==5)
					column = strtoi(namen[4]);
			else	column = 0;

			index = strtoi(namen[3]);

			   y=table_len[1];
			if(y<=0)y=1;

			if(index<0 || index>=table_len[0]/y){exit_val=4;break;}
			if(column<0 || column>=table_len[1]  ){exit_val=4;break;}

			value=strtoi(namen[1]);
			table_val.Set(namen[1],table_len[2]+table_len[1]*index+column,&value);

			continue;
			}

		if(!stricmp(ptr,"TABLE_DEL"))
			{
			if(namen_count!=3){exit_val=2;break;}

			x=table_pos.Find(namen[1],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			index = strtoi(namen[2]);

			   y=table_len[1];
			if(y<=0)y=1;
			if(index<0 || index>=table_len[0]/y){exit_val=4;break;}

			y=table_len[2]+table_len[1]*index;
			table_val.Del(y,y+table_len[1]);
			column=table_len[1];
			table_len[0]-=column;

			for(x=0;x<table_pos.Count();x++)
				{
				table_len=(int*)table_pos.Data(x);
				if(table_len[2]>y)table_len[2]-=column;
				}

			continue;
			}

		if(!stricmp(ptr,"TABLE_ADD"))
			{
			if(namen_count<=3){exit_val=2;break;}

			x=table_pos.Find(namen[1],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			index = strtoi(namen[2]);

			   y=table_len[1];
			if(y<=0)y=1;
			if(index<0 || index>table_len[0]/y){exit_val=4;break;}

			y=table_len[2]+table_len[1]*index;
			column=table_len[1];
			table_len[0]+=column;

			for(x=3;x<column+3;x++)
				{
				if(x<namen_count)
					{
					value=strtoi(namen[x]);
					table_val.Add(namen[x],y+x-3,&value);
					}
				else{
					value=0;
					table_val.Add("",y+x-3,&value);
					}
				}

			for(x=0;x<table_pos.Count();x++)
				{
				table_len=(int*)table_pos.Data(x);
				if(table_len[2]>y)table_len[2]+=column;
				}

			continue;
			}

		if(!stricmp(ptr,"TABLE_FIND"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			if(namen_count==6)
			if(stricmp(namen[5],"NOCASE")){exit_val=2;break;}

			x=table_pos.Find(namen[2],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			x=(namen_count==6 || (namen_count==5 && !stricmp(namen[4],"NOCASE")));
			if(namen_count>=5 && stricmp(namen[4],"NOCASE"))
					column = strtoi(namen[4]);
			else	column = 0;

			   y=table_len[1];
			if(y<=0)y=1;
			max=table_len[0]/y;

			for(index=0;index<max;index++)
				{
				ptr=table_val[table_len[2]+index*table_len[1]+column];
				if( x && !stricmp(namen[3],ptr))break;
				if(!x && !strcmp (namen[3],ptr))break;
				}

			if(index>=max)index=-1;
			type=1;
			VarSet(namen[1],index,&type);

			continue;
			}

		if(!stricmp(ptr,"TABLE_SORT"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count> 4){exit_val=2;break;}
			if(namen_count==4)
			if(stricmp(namen[3],"NOCASE")){exit_val=2;break;}

			x=table_pos.Find(namen[1],0,-1,1);
			if(x<0){exit_val=3;break;}
			table_len=(int*)table_pos.Data(x);

			x=(namen_count==4 || (namen_count==3 && !stricmp(namen[2],"NOCASE")));
			if(namen_count>=3 && stricmp(namen[2],"NOCASE"))
					column = strtoi(namen[2]);
			else	column = 0;

			   y=table_len[1];
			if(y<=0)y=1;
			max=(table_len[0]/y)-1;

			for(z=0;z<max;z++)
				{
				y=table_len[2]+z*table_len[1]+column;
				ptr=table_val[y];
				txt=table_val[y+table_len[1]];
				if( x && stricmp(ptr,txt)<=0)continue;
				if(!x && strcmp (ptr,txt)<=0)continue;

				for(index=table_len[1]-1;index>=0;index--)
					{
					table_val.Change(y+index,y+index+table_len[1]);
					}

				z=-1;
				}

			continue;
			}

		if(!stricmp(ptr,"CALC"))
			{
			char  text[1024];

			if(namen_count<=3      ){exit_val=2;break;}
			if(strcmp(namen[2],"=")){exit_val=2;break;}
			
			text[0] = 0;

			for(x=3;x<namen_count;x++)
				{
				strlcat(text,namen[x],sizeof(text));
				strlcat(text," "     ,sizeof(text));
				}

			value=strcalc(text);
			type=1;
			VarSet(namen[1],value,&type);


			continue;
			}

		if(!stricmp(ptr,"DELETE"))
			{
			if(namen_count<=1){exit_val=2;break;}
			if(namen_count> 3){exit_val=2;break;}
			if(namen_count==3)
				{
				if(stricmp(namen[2],"SUBDIR")){exit_val=2;break;}
				}

			x=VarDeleteFile(namen[1],namen_count>=3,fname,findhandle);
			VarSet("ERRORLEVEL",x);
			continue;
			}

		if(!stricmp(ptr,"COPY"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 7){exit_val=2;break;}

			y = 0;
			z = 1;
			w = 0;
			v = 0;

			for(x=3;x<namen_count;x++)
				{
				if(!stricmp(namen[x],"CHECK"   )){w=1;continue;}
				if(!stricmp(namen[x],"SUBDIR"  )){y=1;continue;}
				if(!stricmp(namen[x],"NREPLACE")){z=0;continue;}
				if(!stricmp(namen[x],"NEWER"   )){v=1;continue;}
				break;
				}

			if(x<namen_count)
				{
				exit_val=2;
				break;
				}

			VarCopyFile(namen[1],namen[2],y,z,w,v);
			continue;
			}

		if(!stricmp(ptr,"COPY_ZIP"))
			{
			if(namen_count<=2){exit_val=2;break;}
			if(namen_count> 6){exit_val=2;break;}
			VarCopyZip(namen[1],namen[2],(namen_count>3)? namen[3]:0,(namen_count>4)? namen[4]:0,(namen_count>5)? namen[5]:0);
			continue;
			}

		if(!stricmp(ptr,"COPY_FTP"))
			{
			if(namen_count!=7){exit_val=2;break;}
			x=VarCopyFtp(namen[1],namen[2],namen[3],namen[4],strtoi(namen[5]),strtoi(namen[6]));
			VarSet("ERRORLEVEL",x);
			continue;
			}

		if(!stricmp(ptr,"MOVE_FTP"))
			{
			if(namen_count!=3){exit_val=2;break;}
			x=VarCopyFtp(namen[1],"*MOVE",namen[2],"",0,0);
			VarSet("ERRORLEVEL",x);
			continue;
			}

		if(!stricmp(ptr,"DELETE_FTP"))
			{
			if(namen_count!=2){exit_val=2;break;}
			x=VarCopyFtp(namen[1],"*DEL","","",0,0);
			VarSet("ERRORLEVEL",x);
			continue;
			}

		if(!stricmp(ptr,"EXIST_FTP"))
			{
			if(namen_count!=2){exit_val=2;break;}
			x=VarCopyFtp(namen[1],"*EXIST","","",0,0);
			VarSet("ERRORLEVEL",x);
			continue;
			}

		if(!stricmp(ptr,"CREATE_FTP"))
			{
			if(namen_count!=2){exit_val=2;break;}
			x=VarCopyFtp(namen[1],"*CREATE","","",0,0);
			VarSet("ERRORLEVEL",x);
			continue;
			}

		if(!stricmp(ptr,"GET_FILENAME"))
			{
			if(namen_count!=3){exit_val=2;break;}

			    ptr=namen[2];
			if(*ptr=='"')
				{
				ptr++;
				len=strchar(ptr,'"');
				ptr[len]=0;
				}

			ptr=GetFileName(namen[2]);
			VarSet(namen[1],ptr);

			continue;
			}

		if(!stricmp(ptr,"GET_FILEPATH"))
			{
			if(namen_count!=3){exit_val=2;break;}

			    ptr=namen[2];
			if(*ptr=='"')
				{
			 	ptr++;
				len=strchar(ptr,'"');
				ptr[len]=0;
				}

			GetFilePath(buffer,ptr,sizeof(buffer));
			DelBackSlash(buffer);
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"GET_FILEBODY"))
			{
			if(namen_count!=3){exit_val=2;break;}

			    ptr=namen[2];
			if(*ptr=='"')
				{
			 	ptr++;
				len=strchar(ptr,'"');
				ptr[len]=0;
				}

			GetFileBody(buffer,ptr,sizeof(buffer));
			DelBackSlash(buffer);
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"GET_PATHTYPE"))
			{
			if(namen_count!=3){exit_val=2;break;}

				ptr=namen[2];
			if(*ptr=='"')
				{
				ptr++;
				len=strchar(ptr,'"');
				ptr[len]=0;
				}

			GetFileType(buffer,namen[2],sizeof(buffer));
			VarSet(namen[1],buffer);

			continue;
			}

		if(!stricmp(ptr,"MOVE"))
			{
			if(namen_count!=3){exit_val=2;break;}
			MoveFile(namen[1],namen[2]);
			continue;
			}

		if(!stricmp(ptr,"LICENSE"))
			{
			unsigned extension[8];

			if(namen_count!=4){exit_val=2;break;}
			memset(extension,0,sizeof(0));

			#ifndef VAR_ONLY_ENV

			x=LicenseCheck(namen[2],strtoi(namen[3]),buffer,sizeof(buffer),&timeend,extension,sizeof(extension));

			if(timeend)
				{
				strtimeset(temp,timeend,STR_DATE|STR_ABC|STR_LONG);
				VarSet("LICENSE_TIME",temp);
				}
			else{
				VarSet("LICENSE_TIME","");
				}

			#else
			x=0;
			buffer[0]=0;
			#endif
			VarSet("LICENSE_TIME","");
			VarSet("LICENSE_BITS", x);
			VarSet("ERRORLEVEL"  , x);
			VarSet(namen[1],buffer);
			memtodump(buffer,extension,sizeof(extension));
			VarSet("LICENSE_EXTENSION",x);
			continue;
			}

		if(!stricmp(ptr,"LICENSE_CRC"))
			{
			if(namen_count<3 || namen_count>4){exit_val=2;break;}

			#ifndef VAR_ONLY_ENV

			y = 0;

			if(namen_count==3)
				{
				x = LicenseCrcFile(namen[2]);
				if(x==0 && ExistFile(namen[2])!=1)y=1;
				}
			else{
				x = LicenseCrc(namen[2],-1,strtoi(namen[3]));
				}

			#else
			x=0;
			y=1;
			#endif
			if(namen_count==3)VarSet("ERRORLEVEL",y);
			VarSet(namen[1],x);
			continue;
			}

		if(!stricmp(ptr,"MESSAGE_FILE"))
			{
			if(namen_count<4 || namen_count>5){exit_val=2;break;}
			#ifndef VAR_ONLY_ENV
			VarFileDialog(namen[1],namen[2],namen[3],(namen_count>=5)? namen[4]:0);
			#else
			VarSet(namen[1],"");
			#endif
			continue;
			}

		if(!stricmp(ptr,"STRENCODE"))
			{
			if(namen_count!=2){exit_val=2;break;}
			text = VarGetName(namen[1]);
			if(!text)continue;
			strencode(text,strtoi(namen[2]));
			continue;
			}

		if(!stricmp(ptr,"STRDECODE"))
			{
			if(namen_count!=2){exit_val=2;break;}
			text = VarGetName(namen[1]);
			if(!text)continue;
			strdecode(text,strtoi(namen[2]));
			continue;
			}

		if(!stricmp(ptr,"HEX_GET"))
			{
			if(namen_count!=5){exit_val=2;break;}
			x=VarHexGet(namen[1],strtoi(namen[2]),strtoi(namen[3]),namen[4]);
			VarSet("ERRORLEVL",x);
			continue;
			}

		if(!stricmp(ptr,"HEX_SET"))
			{
			if(namen_count!=4){exit_val=2;break;}
			x=VarHexSet(namen[1],strtoi(namen[2]),namen[3]);
			VarSet("ERRORLEVL",x);
			continue;
			}

		if(!stricmp(ptr,"HEX_VALUE"))
			{
			if(namen_count<3 && namen_count>5){exit_val=2;break;}
			y=(namen_count<5)? 1:strtoi(namen[4]);
			x=VarHexValue(namen[2],(namen_count==3)? 0:strtoi(namen[3]),y);
			VarSet(namen[1],x);
			continue;
			}

		if(!stricmp(ptr,"STR_VALUE"))
			{
			if(namen_count<3 && namen_count>4){exit_val=2;break;}
			x=strlen(namen[2]);
			if(namen_count==4)
					y=strtoi(namen[3]);
			else	y=0;
			VarSet(namen[1],(y>=0 && y<x)? namen[2][y]&0xFF:0);
			continue;
			}

		if(!stricmp(ptr,"USER_MESSAGE"))
			{
			if(namen_count!=3){exit_val=2;break;}
			if(!VarMessage)continue;
			VarMessage(VarParam,strtoi(namen[1]),namen[2]);
			continue;
			}

		if(!stricmp(ptr,"MAKE_SHORTPATH"))
			{
			if(namen_count!=3){exit_val=2;break;}
			MakeShortPath(buffer,namen[2],sizeof(buffer));
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"MAKE_LONGPATH"))
			{
			if(namen_count!=3){exit_val=2;break;}
			MakeLongPath(buffer,namen[2],sizeof(buffer));
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"STRWLEN"))
			{
			if(namen_count<3 || namen_count>4){exit_val=2;break;}
			if(namen_count==4)x=0x7FFFFFFF&strcalc(namen[3]);
			else			  x=0x7FFFFFFF;
			VarSet(namen[1],strwlen(namen[2],x));
			continue;
			}

		if(!stricmp(ptr,"STRBWLEN"))
			{
			if(namen_count!=4){exit_val=2;break;}
			x = strcalc(namen[3]);
			y = strlen(namen[2]);
			VarSet(namen[1],strbwlen(namen[2]+y,x,y));
			continue;
			}

		if(!stricmp(ptr,"STRLEFT"))
			{
			if(namen_count!=4){exit_val=2;break;}
			x=strcalc(namen[3]);
			strlcpy(buffer,namen[2],sizeof(buffer),x);
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"STRRIGHT"))
			{
			if(namen_count!=4){exit_val=2;break;}
			x=strcalc(namen[3]);
			y=strlen(namen[2]);
			if(x>y)x=y;
			if(x<0)x=0;
			strlcpy(buffer,namen[2]+y-x,sizeof(buffer));
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"STRMID"))
			{
			if(namen_count!=5){exit_val=2;break;}
			x=strcalc(namen[3]);
			y=strcalc(namen[4]);
			z=strlen(namen[2]);
			if(x>z)x=z;
			if(x<0)x=0;
			strlcpy(buffer,namen[2]+x,sizeof(buffer),y);
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"STRFIND"))
			{
			if(namen_count!=4){exit_val=2;break;}
			VarSet(namen[1],strfind(namen[2],namen[3]));
			continue;
			}

		if(!stricmp(ptr,"STRIFIND"))
			{
			if(namen_count!=4){exit_val=2;break;}
			VarSet(namen[1],strifind(namen[2],namen[3]));
			continue;
			}

		if(!stricmp(ptr,"STRREPLACE"))
			{
			if(namen_count!=5){exit_val=2;break;}
			strreplace(buffer,namen[2],namen[3],namen[4],sizeof(buffer));
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"STRIREPLACE"))
			{
			if(namen_count!=5){exit_val=2;break;}
			strireplace(buffer,namen[2],namen[3],namen[4],sizeof(buffer));
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"STRCUT"))
			{
			if(namen_count!=3){exit_val=2;break;}
			strlcut(buffer,namen[2],sizeof(buffer));
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"HARD_LINK"))
			{
			if(namen_count!=3){exit_val=2;break;}
			x=CreateHardLinkA(namen[1],namen[2],NULL);
			VarSet("ERRORLEVEL",(x==0)? "-1":"0");
			continue;
			}

		if(!stricmp(ptr,"LINK_COUNT"))
			{
			if(namen_count!=3){exit_val=2;break;}
			x = 0;
			findhandle=CreateFile(namen[1],0,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
			if(findhandle!=INVALID_HANDLE_VALUE)
				{
				BY_HANDLE_FILE_INFORMATION	info;
				if(GetFileInformationByHandle(findhandle,&info))x=info.nNumberOfLinks;
				CloseHandle(findhandle);
				}
			VarSet(namen[2],x);
			continue;
			}

		if(!stricmp(ptr,"LINE_COUNT"))
			{
			if(namen_count!=3){exit_val=2;break;}
			x=VarLineCount(namen[1]);
			itoa(x,buffer,10);
			VarSet(namen[2],buffer);
			continue;
			}

		if(!stricmp(ptr,"LINE_FIND"))
			{
			if(namen_count!=4){exit_val=2;break;}
			x=VarLineFind(namen[1],namen[3]);
			itoa(x,buffer,10);
			VarSet(namen[2],buffer);
			continue;
			}

		if(!stricmp(ptr,"LINE_GET"))
			{
			if(namen_count!=4){exit_val=2;break;}
			x=VarLineGet(namen[1],namen[2],strtoi(namen[3]));
			itoa(x,buffer,10);
			VarSet("ERRORLEVEL",buffer);
			continue;
			}

		if(!stricmp(ptr,"LINE_SET"))
			{
			if(namen_count<=3){exit_val=2;break;}
			if(namen_count>=6){exit_val=2;break;}
			if(namen_count>=5)
				{
				if(stricmp(namen[4],"ADD")){exit_val=2;break;}
				}
			VarLineSet(namen[1],namen[3],strtoi(namen[2]),namen_count>=5);
			continue;
			}

		if(!stricmp(ptr,"ENV_SET"))
			{
			if(namen_count!=3){exit_val=2;break;}
			SetEnvironmentVariable(namen[1],namen[2]);
			VarSet(namen[1],namen[2]);
			continue;
			}

		if(!stricmp(ptr,"CREATE_PATH"))
			{
			if(namen_count!=2){exit_val=2;break;}
			CreatePath(namen[1]);
			continue;
			}

		if(!stricmp(ptr,"PROCESS_RUNNING"))
			{
			if(namen_count>3){exit_val=2;break;}
			if(namen_count<2){exit_val=2;break;}
			x = VarProcessRunning(namen[1],(namen_count>=3)? strtoi(namen[2]):0);
			itoa(x,buffer,10);
			VarSet("ERRORLEVEL",buffer);
			continue;
			}

		if(!stricmp(ptr,"WRITE_ACCESS"))
			{
			if(namen_count>4){exit_val=2;break;}
			if(namen_count<3){exit_val=2;break;}
			x = VarWriteAccess(namen[2],(namen_count>=4)? strtoi(namen[3]):0);
			VarSet(namen[1],x);
			continue;
			}

		if(!stricmp(ptr,"LOAD_STRING"))
			{
			if(namen_count!=3){exit_val=2;break;}
			buffer[sizeof(buffer)-1]=0;
			if(LoadString(GetModuleHandle(NULL),strtoi(namen[2]),buffer,sizeof(buffer)-1)<=0)buffer[0]=0;
			VarSet(namen[1],buffer);
			continue;
			}

		if(!stricmp(ptr,"WOW_REDIRECT"))
			{
			if(namen_count!=2){exit_val=2;break;}
			WowRedirect(strtoi(namen[1]));
			continue;
			}

		if(!stricmp(ptr,"TAKEOWNERSHIP"))
			{
			if(namen_count<2){exit_val=2;break;}
			if(namen_count>7){exit_val=2;break;}

			x = 0;
			z = 0;

			for(y=2;y<namen_count;y++)
				{
				if(!strcmp("CHECK",namen[y])){z = 1;             continue;}
				if(!strcmp("EXEC" ,namen[y])){x|=GENERIC_EXECUTE;continue;}
				if(!strcmp("WRITE",namen[y])){x|=GENERIC_WRITE;  continue;}
				if(!strcmp("READ" ,namen[y])){x|=GENERIC_READ;   continue;}
				if(!strcmp("ALL"  ,namen[y])){x|=GENERIC_ALL;    continue;}
				exit_val=2;break;
				}

			if(y<namen_count)break;
			if(x==0)x=GENERIC_ALL;
			y=(strnicmp(namen[1],"HKEY_",5))? SE_FILE_OBJECT:SE_REGISTRY_KEY;
			y=VarTakeOwnership(namen[1],x,y,z);
			VarSet("ERRORLEVEL",y);
			continue;
			}

		if(!stricmp(ptr,"SET_CLIPBOARD"))
			{
			if(namen_count!=2){exit_val=2;break;}
			SetClipboardText(namen[1]);
			continue;
			}

		if(!stricmp(ptr,"GET_CLIPBOARD"))
			{
			if(namen_count!=2){exit_val=2;break;}
			txt=GetClipboardText();
			if(txt)
				{
				VarSet(namen[1],txt);
				delete txt;
				}
			else{
				VarSet(namen[1],"");
				}
			continue;
			}

		if(!stricmp(ptr,"EXIT"))
			{
			if(namen_count>=2){exit_val=2;break;}
			break;
			}

		if(!stricmp(ptr,"IF") || !stricmp(ptr,"IFEXIST"))
			{
			if(namen_count<5){exit_val=2;break;}
			if(namen_count>6){exit_val=2;break;}

			exit_flag=0;

			if(!stricmp(ptr,"IFEXIST"))
				{
				if(strnicmp(namen[1],"HKEY_",5))
						x=ExistFile(namen[1]);
				else	x=ExistReg (namen[1]);

				itoa(x,temp,10);
				namen[1]=temp;
				}

			if(!stricmp(namen[4],"GOTO"))
				{
				if(namen_count!=6){exit_val=2;break;}
				ptr=namen[5];
				nr=goto_names.FindFast(ptr,0,-1,1);
				if(nr>=0)
					{
					goto_pos=goto_names.DataGet(nr);
					goto_lnr=goto_names.DataGet(nr,1);
					goto_flag=1;
					}
				else{
					strlcpy(goto_name,ptr,sizeof(goto_name));
					goto_pos=-1;
					goto_lnr=-1;
					goto_flag=1;
					}
				}
			else if(!stricmp(namen[4],"EXIT"))
				{
				exit_flag=1;
				}
			else if(!stricmp(namen[4],"THEN"))
				{
				if(namen_count!=5){exit_val=2;break;}
				else_flag=1;
				}
			else{exit_val=2;break;}
										// Welcher Vergleich ?		
			for(x=0;x<sizeof(if_cmp)/sizeof(if_cmp[0]);x++)			
				{
				if(!strcmp(if_cmp[x],namen[2]))break;
				}

			if(x>=sizeof(if_cmp)/sizeof(if_cmp[0]))
				{
				exit_val=2;
				break;
				}

			switch(x>>1)
				{
			case 0:	if(typen[1]==2 && typen[3]==2)
							ok=strtoi (namen[1])==strtoi(namen[3]);
					else	ok=stricmp(namen[1],namen[3])==0;
					break;
			case 1: if(typen[1]==2 && typen[3]==2)
							ok=strtoi (namen[1])>=strtoi(namen[3]);
					else	ok=stricmp(namen[1],namen[3])>=0;
					break;
			case 2:	if(typen[1]==2 && typen[3]==2)
							ok=strtoi (namen[1])<=strtoi(namen[3]);
					else	ok=stricmp(namen[1],namen[3])<=0;
					break;
			case 3:	if(typen[1]==2 && typen[3]==2)
							ok=strtoi(namen[1])&strtoi(namen[3]);
					else	ok=0;
					break;
			case 4:	ok=memycmp(namen[3],namen[1])==0;
					break;
			case 5:	ok=memycmp(namen[3],namen[1],strlen(namen[1]),1)==0;
					break;
			case 6:	ok=memxcmp(namen[3],namen[1])==0;
					break;
			case 7:	ok=memxcmp(namen[3],namen[1],strlen(namen[1]),1)==0;
					break;
			case 8:	ok=VersionCmp(namen[1],namen[3])==0;
					break;
			case 9: ok=VersionCmp(namen[1],namen[3])>=0;
					break;
			case 10:ok=VersionCmp(namen[1],namen[3])<=0;
					break;
			case 11:ok=atoi(namen[1])==atoi(namen[3]);
					break;
			case 12:ok=atoi(namen[1])>=atoi(namen[3]);
					break;
			case 13:ok=atoi(namen[1])<=atoi(namen[3]);
					break;
			case 14:ok=strtoutc(namen[1],STR_DATE|STR_TIME|STR_GLOBAL)==strtoutc(namen[3],STR_DATE|STR_TIME|STR_GLOBAL);
					break;
			case 15:ok=strtoutc(namen[1],STR_DATE|STR_TIME|STR_GLOBAL)>=strtoutc(namen[3],STR_DATE|STR_TIME|STR_GLOBAL);
					break;
			case 16:ok=strtoutc(namen[1],STR_DATE|STR_TIME|STR_GLOBAL)<=strtoutc(namen[3],STR_DATE|STR_TIME|STR_GLOBAL);
					break;
				}

			if(x&1)ok=!ok;

			if(ok)						// Bedingung ist wahr
				{
				if(exit_flag)break;
				else_flag=0;
				}
			else{						// Bedingung ist falsch
				goto_flag=0;
				}

			if(goto_flag && goto_pos>=0)
				{
				file_next=goto_pos;
				line_nr=goto_lnr;
				goto_flag=0;
				}

			continue;
			}

		exit_val=2;						// Unbekanter Befehl
		break;
		}

	if(findhandle!=INVALID_HANDLE_VALUE)
		{
		FindClose(findhandle);
		}

	for(;namen_count>0;namen_count--)delete namen[namen_count-1];
	delete file_mem;

	if(goto_flag)
		{
		sprintf(buffer,"Die Sprungmarke %s wurde nicht gefunden !",goto_name);
		MessageBox((HWND)VarWindow,buffer,0,MB_OK);
		}

	if(exit_val==2)
		{
		sprintf(buffer,"Syntax Fehler in Zeile %i\n\n%s",line_nr,line);
		MessageBox((HWND)VarWindow,buffer,0,MB_OK);
		}

	if(exit_val==3)
		{
		sprintf(buffer,"Runtime Fehler in Zeile %i\n\n%s",line_nr,line);
		MessageBox((HWND)VarWindow,buffer,0,MB_OK);
		}

	if(exit_val==4)
		{
		sprintf(buffer,"Index Fehler in Zeile %i\n\n%s",line_nr,line);
		MessageBox((HWND)VarWindow,buffer,0,MB_OK);
		}

	if(exit_val==5)
		{
		sprintf(buffer,"Doppelte Sprungmarke in Zeile %i\n\n%s",line_nr,line);
		MessageBox((HWND)VarWindow,buffer,0,MB_OK);
		}

	if(VarDebug)						// Debug Modus
		{
		VarDebug(VarDParam,-1,"",&var_name,0);
		}

return exit_val;
}
#endif




