//*****************************************************************************
//*
//*
//*		VarTools.h
//*
//*
//*****************************************************************************
//
//	Format der Skript Dateien:
//
//	  ;Kommentar							REM-Zeile
//
//	  :Marke								Sprungmarke
//
//	  $(Variabel)							Steht fr den Inhalt einer Variabel
//
//	  "1234... \\ \" "						String mit folgenden Regeln
//											\\		wird zu \
//											\"		wird zu "
//											$(Var)  wird zum Variabelwert
//											$$(Var) wird zu $(Var)
//											$$  	wird zu $
//
//	  GOTO  Marke							Sringe zu Sprungmarke
//
//	  IF Text1 == Text2 GOTO Mark			Bedingter Sprung
//
//	  IF Text1 == Text2 EXIT				Bedingters Programmende
//
//	  IF Text1 != Text2 THEN				IF Konstrukt
//	  [ELSE]								Wenn Text1/Text2 Zahlen sind wird
//	  END									deren Wert verglichen. (-1,123,0xFF,...)
//	  										Bei IF sind auch >= <= > < & erlaubt
//
//	  SWITCH Variabel						SWITCH Konstrukt
//	  CASE Marke :
//	  [BREAK]
//	  [DEFAULT:]
//	  END
//
//	  EXIT									Das Skript beenden
//
//	  SET		Variabel = Wert				Eine Variabel setzten
//
//	  SET_CALC	Variabel = Formel			Eine Variabel auf den Wert der
//											Formel setzten.
//
//	  SET_EXIST Variabel Pfad				Eine Variabel setzten
//	  										 0 = Pfad nicht gefunden
//	  										 1 = Datei gefunden
//	  										 2 = Verzeichnis gefunden
//	  										 3 = Laufwerk gefunden
//
//	  SET_PATH  Var [Text] [CANCEL] [EXIST]	Eine Variabel auf einen Pfad setzen
//	  										Der in Variabel Pfad ist das vorgegebene Verzeichnis
//											Text ist die berschrift vom Fenster
//	  										Bei CANCEL ist ein Abbruch erlaubt
//	  										Bei EXIST muss der Pfad existieren
//											ERRORLEVEL enthllt -1 bei einem Abbruch
//											bzw. 0 wenn alles ok war
//
//	  SET_FILE  Variabel [Text] [CANCEL]	Eine Variabel auf eine Datei setzen
//	  										Der in Variabel Pfad ist die vorgegebene Datei
//											Text ist die berschrift vom Fenster
//	  										Bei CANCEL ist ein Abbruch erlaubt
//											ERRORLEVEL enthllt -1 bei einem Abbruch
//											bzw. 0 wenn alles ok war
//
//	  SET_TEXT  Variabel [Text Titel] [Titel] [CANCEL]
//	  										Ein Text einlesen
//											Der Inhalt von Variabel ist die Text Vorgabe
//	  										Text ist die Text Vorgabe
//	  										Titel ist die berschrift im Fenster
//	  										Bei CANCEL ist ein Abbruch erlaubt
//											ERRORLEVEL enthllt -1 bei einem Abbruch
//											bzw. 0 wenn alles ok war
//
//	  GET_VERSION  Variabel VariabelSub		Die Version des AzInstalleres auslesen
//	  										In Variabel wird die Versionsnummer gespeichert
//											In VariabelSub  wird die Unter-Versionsnummer
//	  										gespeichert
//
//	  DEL_REG	Pfad [Name]					Einen Registry Eintrag lschen
//											Ist Name angegeben so wird nur der
//											Registry-Wert gelscht und nicht der
//											Registry-Pfad
//
//	  GET_REG	Variabel Pfad [Name]		Einen Registry Wert auslesen und in
//											Variabel speichern
//											ERRORLEVEL wird auf -1 gesetzt wenn
//											der Eintrag nicht gefunden wurde.
//
//	  SET_REG_SZ    Value Pfad [Name]		Einen Registry Wert setzen
//
//	  SET_REG_DWORD Value Pfad [Name]		Einen Registry Wert setzen
//
//
//	  TABLE Name Breite						Eine Tabellenliste namens Name erzeugen.
//			"Text1" "Text2"	...				Die Eintrge sind zeilenweise orientiert.
//	  END									Breite gibt die Eintrge je Zeile an.
//
//	  MESSAGE		Text Titel				Eine Nachricht ausgeben
//											Text ist der Nachrichten Text
//											Titel ist der Fenstertitel
//
//	  MESSAGE_QUERY Typ Variabel Text Titel	DefButton
//											Eine Nachricht mit einer Frage ausgeben
//											Typ: OkCancel/YesNo/YesNoCancel/
//												 ReturyCancel/AbortRetryIgnore
//											In Variabel	wird das ergebnis gespeichert
//											Text ist der Nachrichten Text
//											Titel ist der Fenstertitel
//											DefButton ist die Standarttaste (1-4)
//											Es werden OK/CANCEL/ABORT/RETRY/
//											IGNORE/YES/NO in der Variabel gespeichert
//
//	  TREE_SELECT Table [CANCEL] [NOINFO] [NOICONS] [NOLINES] [VERT] [SELECT] [SINGLE] [Level] [X=???] [Y=???]
//											Frt eine Auswahl ber ein Tree-Fenster durch
//	  										Bei CANCEL ist ein Abbruch erlaubt
//											Bei NOINFO wird keine Information angezeigt
//											Bei NOICONS werden keine Auswahlflchen angezeigt
//			 								Bei NOLINES	gibt es keine Linien bei den Root-Eintrgen
//											Bei VERT werden die Fenster nebeneinander angezeigt
//											Bei SELECT wird der Eintrag $(SELECT) ausgewhlt
//											Bei SINGLE kann nur ein Eintrag por Ats augewhlt werden
//											Mit Level gibt man an, bis zu welcher Ebene die
//											Mit X=??? und Y=??? gibt man die Fenster Gre an.
//											Die Baumzweige aufgeklappt werden.
//											Die Table hat folgenden Aufbau:
//												1   : Variabelname der auf 1 oder Null ist
//												2   : Ebene (0 bis n)
//												3   : Text im Fenster oder Htem-Datei (mit @#)
//												4   : Hilfe Text fr Auswahl
//												5   : Callback-Skript fr Tasten (mit @#)
//												6-9 : Tastennamen
//											In der Variabel $(TreeName) kann man die berschrift speichern.
//											ERRORLEVEL enthllt -1 bei einem Abbruch
//											bzw. 0 wenn alles ok war.
//											In SELECT steht der ausgewhlte Eintrag.
//
//	  DELETE  Pfad [SUBDIR]					Lschen von Dateien
//											Pfad ist der Name der zu lschenden Datei
//											Er kann auch Wildcards wie '*' und '?' endhalten
//											Ist SUBDIR angegeben werden auch
//											Unterverzeichnisse gelscht
//
//	  CREATE_PATH  Pfad 					Einen neuen Pfad erzeugen.
//
//	  SHORTCUT Path File [Name][Args][Dir]	Einen Shortcut erzeugen
//											Path ist das Verzeichnis fr den Shortcut
//											File ist die Datei auf die der Shortcut	zeigt
//											Name ist der Anzeigename des Shortcuts
//											Args sind die Argumente fr den Aufruf (z.B. "%1" -s )
//											Dir ist das Ausfhrungsverzeichnis
//
//	  SHORTCUT_ICON  Path File [Name][Nr]	Das Icon eines Shortcuts einstellen
//											Path ist das Verzeichnis fr den Shortcut
//											File ist die Datei mit dem Icon
//											Name ist der Name des Shortcuts (Path+Name+".lnk")
//											Nr ist die Icon-Nummer in File
//
//	  SHORTCUT_QUERY Var Path [Name]		Einen Shortcut abfragen
//											In Var wird der Shortcut Pfad gespeichert
//											Path ist das Verzeichnis fr den Shortcut
//											Name ist der Anzeigename des Shortcuts
//
//	  REG_FILEICON Typ File [Nr][Name][Grp]	Einen Dateityp registreiren
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											File ist die Datei mit dem Icon
//											Nr ist die Icon-Nummer in File
//											Name ist der Anzeigename des Typs
//											Grp ist der Gruppenname in der Registry
//
//	  REG_FILECMD Typ File [Cmd][Args]		Ein Kommando fr einen Dateityp registreiren
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											File ist die Datei die ausgefght wird
//											Cmd ist der Anzeigename des Kommandos (open)
//											Args sind die Argumente fr den Aufruf (z.B. "%1" -s )
//
//	  REG_FILEQUERY Typ Var					Eine Dateityp Registierung abfragen
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											In Var wird das Ergebnis gespeichert
//											(siehe ConfigFileQuery(...) )
//
//	  REG_FILECMDCHANGE Typ Old New [Cmd][Args]		Bei einer Dateityp Registierung
//											ein oder mehrer Komandos ndern
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											Old ist der aktuelle Kommando Pfad
//											New ist der aktuelle Kommando Pfad
//											Cmd ist der Anzeigename des Kommandos (open)
//											Args sind die Argumente fr den Aufruf (z.B. "%1" -s )
//
//	  REG_FILEICONCHANGE Typ Old New [Nr]	Bei einer Dateityp Registierung das Icon ndern
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											Old ist der aktuelle Icon Pfad
//											New ist der aktuelle Icon Pfad
//											Nr ist die Icon-Nummer in New
//
//	  REG_FILEDELETEIF Typ Cmd [Icon]		Einen Dateityp aus der Registierung lschen
//											wenn die Icon und Kommando Pfade passen
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											Cmd ist der aktuelle Kommando Pfad
//											Icon ist der aktuelle Icon Pfad
//
//	  REG_FILECMDDELETE Typ [Cmd] [File]	Ein Kommando aus der Registierung lschen
//											wenn der Kommando Pfad passt
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											Cmd ist der aktuelle Kommando Pfad
//											File ist der aktuelle Kommando Pfad
//
//	  REG_FILEDELET Typ [DelCmd]			Einen Dateityp aus der Registierung lschen
//											Typ ist der Dateityp (TXT oder DEMO.TXT)
//											DelCmd auch die Kommandos lschen
//
//	  FINDFIRST  Path VarFile [VarDir]		Mit eine Dateisuche neubeginnen.
//											Path ist der Suchpfad
//											VarFile ist die Variabel fr den Dateinamen
//											VarDir  ist die Variabel ob ein Verzeichnis
//											gefunden wurde ("1" wenn ja sonst "0")
//
//	  FINDNEXT  VarFile [VarDir]			Mit eine Dateisuche fortfahren.
//											Path ist der Suchpfad
//											VarFile ist die Variabel fr den Dateinamen
//											VarDir  ist die Variabel ob ein Verzeichnis
//											gefunden wurde ("1" wenn ja sonst "0")
//
//
//	  COPY Source Target [SUBDIR]			Kopiert alle Dateien von Source nach Target
//											Ist Target mit einem '\' abgeschlossen so
//											werden die Dateien beim kopieren nicht umbenannt
//											Ist SUBDIR angegeben werden Unterverzeichnisse
//											mitkopiert.
//											ERRORLEVEL enthllt 1 bei einem Fehler
//											bzw. 0 wenn alles ok war
//
//	  COPY_ZIP Source Target				Kopiert alle Dateien aus dem ZipFile Source nach Target
//											Target muss mit einem '\' abgeschlossen sein
//											ERRORLEVEL enthllt 1 bei einem Fehler
//											bzw. 0 wenn alles ok war
//
//	  MOVE Source Target					Verschiebt eine Datei oder benennt sie um.
//
//	  CALC Variabel = Rechenausdruck		Speichert in Variabel das ergebnis vom
//											Rechenausdruck. Dieser Ausdruck kann aus einem
//											oder meheren Teilen bestehen
//
//	  CALL [NOWAIT] [HIDE] [DIR:Verz] Exe Params...
//											Startet die Datei Exe
//											HIDE   = Fenster verstecken
//											NOWAIT = Nicht auf das Ende warten
//											DIR:?  = Startverzeichnis
//											Params = Parameter
//											ERRORLEVEL enthllt den Rckgabewert des Programms
//											bzw. -1	bei einem Fehler
//
//	  CALL_SCRIPT File						Ein Skript starten
//
//	  CALL_REG File							Eine Registry-Datei importieren
//
//	  ENV_SET Variabel Value				Eine Enviorment Variabel fr
//											den jetzigen Prozess einstellen
//
//	  LINE_FIND File Var Text				Suche eine Zeile in der Datei File
//											Var dort wird die Zeile gespeichert
//											bzw. "-1" wenn nichts gefunden wurde
//											Text ist die zu suchende Zeile (memycmp)
//
//	  LINE_SET  File Line Text [ADD]		Fgt in die Datei File bei der Position
//											Line die Zeile Text ein
//											Ist ADD angegeben wir die Zeile eingefgt
//											sonst wird sie getauscht.
//
//	  TABLE_GET Variabel Table Row [Col]	Speichert den Wert einer Table bei Row/Col
//											in einer Variabel
//
//	  TABLE_SET Wert     Table Row [Col]	Setzt in einer Table bei Row/Col den Eintrag
//											auf einen neuen Wert
//
//	  TABLE_DEL Table Row					Lscht eine Zeile aus einer Tabelle.
//											Wenn die Zeile nicht existiert wird ein
//											Fehler ausgegeben.
//
//	  TABLE_ADD Table Row "Text" ...		Fgt eine Zeile in eine Tabelle ein.
//											Fehlende Texte werden mit "" auf gefllt.
//
//	  TABLE_SIZE Variabel Table				Speichert die Anzahl der Zeileneintrge
//											in einer Variabel, bzw -1 wenn die Tabelle
//											nicht existiert.
//
//	  TABLE_FIND Variabel Table "Text" [Col] [NOCASE]
//											Sucht einen Texteintrag in einer Tabelle
//											und speichert die Zeilennummer in einer Variabel.
//											Wird der Text Nicht gefunden wird -1 gespeichert.
//											Wenn keine Col Angabe vorhanden ist dann wird
//											in der ersten Spalte gesucht.
//											Ist NOCASE angegeben dann wird zwischen Gro-
//											kleinschreibung nicht unterschieden
//
//	  TABLE_SORT Table [Col] [NOCASE]		Sortiert eine Tabelle
//											Wenn keine Col Angabe vorhanden ist dann wird
//											nach der ersten Spalte sortiert.
//											Ist NOCASE angegeben dann wird zwischen Gro-
//											kleinschreibung nicht unterschieden
//
//	  SAVE_TABLE File Table					Speichert alle Variabeln die in einer Table
//											stehen in der Datei File ab. Die Variabelnnamen
//											mssen in der ersten Spalte der Tabelle stehen.
//
//	  GET_FILENAME Var File					Speichert den Dateinamen aus File in
//											der Variable Var
//
//	  GET_FILEPATH Var File					Speichert den Dateipfad aus File in
//											der Variable Var
//
//	  GET_FILETYPE Var File					Speichert den Dateitype aus File in
//											der Variable Var
//
//	  HEX_GET File Pos Len Var				Aus einer Datei einen Hex-Dump auslesen
//											File = Der Dateiname
//											Pos  = Die Position der Daten
//											Len  = Die Lnge der Daten (0-256)
//											Var  = Ist die Variabel in der der Dump
//												   gespeichert wird.
//											ERRORLEVEL enthllt den Rckgabewert
//											bzw. -1	bei einem Fehler
//
//	  HEX_SET File Pos Dump					In eine Datei einen Hex-Dump schreiben
//											File = Der Dateiname
//											Pos  = Die Position der Daten
//											Dump = Ist der Hex-Dump der gespeichert
//												   werden soll (":00 11 22"	oder "ein Text")
//											ERRORLEVEL enthllt den Rckgabewert
//											bzw. -1	bei einem Fehler
//
//	  USER_MESSAGE Type Text				Eine User-Nachricht schicken
//											Type ist die Nachrichten Art
//											0 : Text ausgeben
//											1 : Info anzeigen
//											2 : Titel anzeigen
//											3 : Bild einblenden
//											4 : Prozentanzeige
//											5 : Prozentanzeige add
//											6 : Prozentanzeige max
//											7 : Text2 ausgeben
//
//	  MAKE_LONGPATH	  Var Path				Den Pfad Path in eine langen Dateinamen
//											umwandeln und in der Variable Var speichern.
//
//	  MAKE_SHORTPATH  Var Path				Den Pfad Path in eine kurzen Dateinamen
//											umwandeln und in der Variable Var speichern.
//
//
//
//	Vordefinierte Variabeln:
//
//		Alle Enviroment Variabeln
//		USER_NAME
//		COMPUTER_NAME
//		WINDOWS_FOLDER
//		SYSTEM_FOLDER
//		TEMP_FOLDER
//		CURRENT_DIRECTORY
//		OS_MAJOR_NR						4=Win98
//		OS_MINOR_NR
//		OS_NAME							"WIN98" oder "WINNT"
//		COMMON_PRORAMS_FOLDER			Fr alle User
//		COMMON_STARTMENU_FOLDER			Fr alle User
//		COMMON_DESKTOPDIRECTORY_FOLDER	Fr alle User
//		DESKTOP_FOLDER
//		FAVORITES_FOLDER
//		FONTS_FOLDER
//		PERSONAL_FOLDER
//		PRORAMS_FOLDER
//		SENDTO_FOLDER
//		STARTMENU_FOLDER
//		DESKTOPDIRECTORY_FOLDER			Realer Dektoppfad
//
//	Extern definierte Variabeln:
//
//		CURRENT_PATH					Verzeichnis der aktuellen Datei
//		CURRENT_FILE					Name der aktuellen Datei
//		CALLBACK_BREAK					Abbruch von einem Callback (0=Weiter 1=OK 2=CANCEL)
//		CALLBACK_VAR					Variabelname fr einem Callback (normal "")
//		CALLBACK_NR						Tastennummer fr einem Callback (normal "")
//

#ifndef 	__VARTOOLS_H__
#define 	__VARTOOLS_H__


	int  		 VarLine    ();
	void		 VarExit    ();											// Variabeln lschen
	void 		 VarInit    (int iSize=0);								// Variabeln initialisieren
	char* 		 VarConvert (const char *pLine,int iMax=0x10000000);	// Konvertiert alls $(Var) Symbole
	int			 VarGetValue(const char *pVariabel);					// Ergibt Variabel Wert
	char* _cdecl VarGetName (const char *pVariabel);					// Ergibt Variabel Text
	char* _cdecl VarGetName (const char *pVariabel,char *pBuffer,int iSize);// Ergibt Variabel Text
	void* 		 VarGetData (const char *pVariabel);					// Sucht Variabel-Datenbereich
	void 		 VarSet     (const char *pVariabel,const char *pText,void *pData=0);
	void 		 VarSet     (const char *pVariabel,int iValue       ,void *pData=0);


	extern void*		 VarParam;
	extern void*		 VarDParam;
	extern void (_cdecl *VarMessage)(void*,int,char *);
	extern int  (_cdecl *VarDebug  )(void*,int,char *,void *,const char *);
	extern void *VarWindow;

	#ifndef 	VAR_ONLY_ENV
	int			VarScript(const char *pFilename,const char *DummyFile=0);
	#endif



#endif
