//*****************************************************************************
//*
//*
//*		AfxUtility.cpp
//*
//*
//*****************************************************************************
//				  
//	Copyright Anton Zechner (C) 2003
//
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#define		VC_EXTRALEAN		// Selten verwendete Teile der Windows-Header nicht einbinden

#include	<AfxWin.h>			// MFC-Kern- und -Standardkomponenten
#include	<AfxExt.h>			// MFC-Erweiterungen
#include	<AfxOle.h>
#include	<AfxCmn.h>
#include	<AfxPriv.h>
#include	"AfxUtility.h"
#include	"FileFinder.h"
#include	"FileFunctions.h"
#include	"DataField.h"
#include	"RegKeys.h"

#include	"ScrollList.h"
#include	"ScrollList.cpp"


#include	<accctrl.h>
#include	<aclapi.h>
#include	<oledb.h>
#include	<wchar.h>
#include	<fcntl.h>
#include	<time.h>
#include	<math.h>

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#define 	ENTRIES(a)			(sizeof(a)/sizeof((a)[0]))
#define		CF_TEXT_EX			((sizeof(TCHAR)>1)? CF_UNICODETEXT:CF_TEXT)
#define 	ID_COPYOFNPATH		0x4899
#define		EN_ENTER			0x1578
#define 	TEXT_MAX			1024
#define 	SP_SHIFTER			19

#ifndef		BCM_FIRST
#define 	BCM_FIRST           0x1600
#endif

#ifndef		BCM_SETIMAGELIST
#define 	BCM_SETIMAGELIST    (BCM_FIRST + 0x0002)
#endif

#ifndef		BUTTON_IMAGELIST_ALIGN_CENTER
#define 	BUTTON_IMAGELIST_ALIGN_CENTER 4
#endif

#define 	WM_SETEDITTEXT		0x39AA
#define 	WM_GETEDITTEXT		0x39AB

#ifndef 	WM_COPYGLOBALDATA
#define 	WM_COPYGLOBALDATA	0x0049
#endif

#ifndef 	MSGFLT_ADD
#define 	MSGFLT_ADD			0x0001
#endif

#ifndef 	MSGFLT_REMOVE
#define 	MSGFLT_REMOVE		0x0002
#endif

#ifndef 	LBN_SETFIRST
#define 	LBN_SETFIRST		0x000A
#endif

typedef struct
	{
	HIMAGELIST	himl;
	RECT		margin;
	UINT		uAlign;
	LPARAM		uMyId;
	LPVOID	  	pNext;
	}BUTTON_IMGLIST;


typedef struct
	{
	WNDPROC		pOldProc;								// Vorherige Fensterfunktion
	LPCOLORREF	pColTable;								// Farbtabele fr ExtTextColor()
	HIMAGELIST	hImgages;								// Handle der Image-Liste
	LPBYTE		pColors;								// Farben der Buchstaben
	HFONT		aFont[2];								// Fonts fr das Zeichnen ([1]=bold)
	LPTSTR		pText;									// Zeiger auf den Text
	UINT		uSize;									// Anzahl der Buchstaben
	UINT		uStyle;									// Style des Fensters
	UINT		uMaxSize;								// Anzahl der Buchstaben
	DWORD		uOption;								// Bits mit den Farboptionen fr ExtTextColor()
	DWORD		uSelNow;								// Startposition der Auswahl
	DWORD		uSelEnd;								// Startposition der Auswahl
	DWORD		uScroll;								// Scroll-Position (Zeichen)
	short		sStart;									// Start-Pixel vom Text
	short		sScrOff;								// Pixel-Offset von Scroll-Position
	short		sTextSize;								// Textbreite in Pixel
	short		sCaretPosX;								// Pixel-Offset von Blink-Cursor
	short		sCaretPosY;								//			*
	short		sMarks[2];								// Pixel-Offset der Markierung
	bool		bLbDown;								// Ist die linke Maustaste gedrckt
	bool		bHasFocus;								// Hat das Fenster den Fokus
	BYTE		bFontHeigh;								// Hhe der Schrift
	BYTE		bShowCarret;							// Ist der Cursor sichtbar
	BYTE		bIconX;									// Breite der Icons
	BYTE		bIconY;									// Hhe der Icons
	INT			iIcon;									// Ist die Icon-Nummer
	}ColorEditData;

static	WNDPROC				pOldEdidProc	= 0;		// Fensterfunktion von Edit
static	BUTTON_IMGLIST     *pIlFirst		= 0;		// Zeiger fr RemoveButtonImages()
static	WNDPROC				pOldEditProc	= 0;		// Alte Fensterfunktion fr "Edit"
static	WNDPROC				pOldCBoxProc	= 0;		// Alte Fensterfunktion fr "ComboBox"
static	ATOM				wSubclassAtom	= 0;		// Globale Initalisierung fr SubClass





extern "C" WINBASEAPI BOOL WINAPI CheckTokenMembership(HANDLE TokenHandle,PSID SidToCheck,PBOOL IsMember);
static LRESULT CALLBACK OfnWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

static void LoadUxThemeDll();

typedef BOOL (WINAPI *ChangeWindowMessageFilterT)(UINT  uMessage,DWORD dwFlag);


//*****************************************************************************
//*
//*		Variabeln fr FileOpenDialog Funktionen
//*
//*****************************************************************************
typedef BOOL (_stdcall *OfnProcType)(LPOPENFILENAME);

static TCHAR			cListPath[MAX_PATH];
static TCHAR			cListName[MAX_PATH];
static OfnProcType		OldGetOpenFileNameA	= 0;
static OfnProcType		OldGetSaveFileNameA	= 0;
static LPCTSTR			pRenameReadOnly		= 0;
static LPCTSTR			pOfnComoEntry		= 0;
static BOOL volatile	bListPathNew		= 0;
static BOOL volatile	bListNameNew		= 0;
static BOOL volatile	bScrollListOn		= 0;
static HWND				hOfnScrollList		= 0;
static HWND				hOfnHookDlg			= 0;
static UINT				uOfnComboMode		= 0;
static UINT				uOfnSaveMode		= 0;
static BOOL				bOfnSetSave			= 0;
static WNDPROC			pPrevWndFunc		= 0;
static LPOFNHOOKPROC	pLastHook			= 0;
static int				iDialogAddY			= 0;
static int				iWindowOpen			= 0;
static int				iZoomDone			= 0;
static HANDLE			hListSem			= 0;



//*****************************************************************************
//*
//*		CFileDialogEx
//*
//*****************************************************************************
class CFileDialogEx : public CFileDialog
{
public:

	CFileDialog	   *m_pOldWnd;

	CFileDialogEx():CFileDialog(FALSE){};
   ~CFileDialogEx(){};

	BOOL SetHwnd(HWND hWnd);
	virtual BOOL OnNotify(WPARAM wParam,LPARAM lParam,LRESULT *pResult);

};

BOOL CFileDialogEx::SetHwnd(HWND hWnd)
{
		m_pOldWnd = (CFileDialog*)CWnd::FromHandlePermanent(hWnd);
	if(!m_pOldWnd || m_pOldWnd->m_hWnd!=hWnd)return FALSE;

	m_pOldWnd->Detach();
	m_pOldWnd->m_hWnd=hWnd;
	m_hWnd = 0;
	Attach(hWnd);

	return TRUE;
}

BOOL CFileDialogEx::OnNotify(WPARAM wParam,LPARAM lParam,LRESULT *pResult)
{
	NMHDR  *pHdr=(NMHDR*)lParam;
	HWND	hParent;
	HWND	hWnd;

	if(pHdr && pHdr->code>=(UINT)CDN_INCLUDEITEM && pHdr->code<=(UINT)CDN_INITDONE)
		{
		hWnd = m_hWnd;

		if(!::GetDlgItem(m_hWnd,0x480))
			{
			   hParent  = ::GetParent (hWnd);
			if(hParent && ::GetDlgItem(hParent,0x480))
				{
				hWnd = hParent;
				}
			}

		OfnWndProc(hWnd,WM_NOTIFY,wParam,lParam);
		}

	return CFileDialog::OnNotify(wParam,lParam,pResult);
}

static	CFileDialogEx	*pFileDlgEx;

//*****************************************************************************
//*
//*		SwapRGB
//*
//*****************************************************************************

#ifdef	   _MSC_VER
#pragma		warning( push )
#pragma		warning( disable :4035 )
#else
#ifndef		NO_ASM
#define		NO_ASM
#endif
#endif

static inline unsigned SwapRGB(unsigned uColor)
{
#ifdef		NO_ASM

	return ((uColor&0x00FF0000)>>16)|(uColor&0xFF00FF00)|((uColor&0x000000FF)<<16);

#elif defined(_WIN64) || !defined(_M_IX86)

	return _rotr(_byteswap_ulong(uColor),8);

#else

_asm	{
		mov		eax,uColor
		bswap	eax;				;// Tausche Bytes in EAX
		ror		eax,8
		}

#endif
}

#ifdef	   _MSC_VER
#pragma		warning( pop )
#endif



//*****************************************************************************
//*
//*		Reframe
//*
//*****************************************************************************
//	Begibt sich in den Vergrerungsmodus fr ein Rechteck
//	pWnd		: Ist das Fenster in dem der Frame vergrert wird
//	sFrame		: Rechteck das vergrert wird (Screen-Koordinaten)
//	sOffset		: Ist der Offset im Rechteck (Screen-Koordinaten)
//	sMin		: Minimale Gre fr das Rechteck
//	Ergibt TRUE wenn die Gre verndert wurde
BOOL AFXAPI Reframe(CWnd *pWnd,CRect &sFrame,CPoint sOffset,CSize sMin)
{
UINT	uMode;
HCURSOR	hCursor;
CPoint	sPoint(0,0);
CSize	sSize;
CSize	sSizeL;
CRect	sRectL;
CRect	sRect;
int		iExit;
MSG		sMsg;
CWnd   *pTop;
CDC	   *pDc;


	             uMode =0x00;
	if(sMin.cx<0)uMode|=0x03;
	if(sMin.cy<0)uMode|=0x0C;

	uMode = CheckReframe(sFrame,sOffset,0,uMode,&hCursor);

	if(uMode==0)return 0;

	if(GetCapture()!=NULL)return FALSE;

	   pTop	= pWnd->GetDesktopWindow();
	if(pTop->LockWindowUpdate())
			pDc = pTop->GetDCEx(NULL,DCX_WINDOW|DCX_CACHE|DCX_LOCKWINDOWUPDATE);
	else 	pDc = pTop->GetDCEx(NULL,DCX_WINDOW|DCX_CACHE);

	while(PeekMessage(&sMsg,NULL,WM_PAINT,WM_PAINT,PM_NOREMOVE))
		{
		if(!GetMessage(&sMsg,NULL,WM_PAINT,WM_PAINT))
			{
			pTop->UnlockWindowUpdate();
			return FALSE;
			}
		DispatchMessage(&sMsg);
		}

	hCursor = SetCursor(hCursor);

	pWnd->SetCapture();

	sRect  = sFrame;
	sSize  = CSize(4,4);
	sSizeL = CSize(0,0);
	sRectL.SetRectEmpty();

	pDc->SetBkColor(RGB(192,255,255));
	pDc->DrawDragRect(&sRect,sSize, &sRectL,sSizeL);

	sRectL = sRect;
	sSizeL = sSize;

//******************** Message Schleife ***************************************

	iExit=0;

	while(!iExit && pWnd->GetCapture()==pWnd)
		{
		if(!GetMessage(&sMsg, NULL, 0, 0))
			{
			AfxPostQuitMessage((int)sMsg.wParam);
			iExit=2;
			break;
			}

		switch (sMsg.message)
			{
			case WM_MOUSEMOVE:

					sPoint.x = sMsg.pt.x-sOffset.x;
					sPoint.y = sMsg.pt.y-sOffset.y;

					sRect    = sFrame;

					if(uMode&0x01)
						{
						   sRect.left	+= sPoint.x;
						if(sRect.Width()<sMin.cx)sRect.left=sRect.right-sMin.cx;
						}

					if(uMode&0x02)
						{
						   sRect.right	+= sPoint.x;
						if(sRect.Width()<sMin.cx)sRect.right=sRect.left+sMin.cx;
						}

					if(uMode&0x04)
						{
						   sRect.top	+= sPoint.y;
						if(sRect.Height()<sMin.cy)sRect.top=sRect.bottom-sMin.cy;
						}

					if(uMode&0x08)
						{
						   sRect.bottom	+= sPoint.y;
						if(sRect.Height()<sMin.cy)sRect.bottom=sRect.top+sMin.cy;
						}

					if(sRect!=sRectL)
						{
						pDc->DrawDragRect(&sRect,sSize,&sRectL,sSizeL);
						sRectL   = sRect;
						sSizeL   = sSize;
						}

					break;

			case WM_KEYDOWN:

					if(sMsg.wParam==VK_ESCAPE)
					iExit=2;
					break;

			case WM_LBUTTONUP:

					iExit=1;
					break;

			case WM_RBUTTONDOWN:

					iExit=2;
					break;

			default:DispatchMessage(&sMsg);
					break;
			}
		}


//******************** Ende ***************************************************


	SetCursor(hCursor);
	sRect.SetRectEmpty();
	sSize=CSize(0,0);

	pDc->DrawDragRect(&sRect,sSize,&sRectL,sSizeL);
	pTop->UnlockWindowUpdate();
	ReleaseCapture();


	if(iExit==2)return FALSE;

	sFrame = sRectL;


return TRUE;
}


//*****************************************************************************
//*
//*		Resize
//*
//*****************************************************************************
//	Begibt sich in den Verschiebemodus. Ein Balken wird dabei XOR verknpft in
//	einem Recheck verschoben.
//	pWnd		: Ist das Fenster in dem der Balken verschoben wird
//	iMode		: Bestimmt welcher Verschiebemodus benutzt werden soll
//					 0 = vertikal
//					 1 = horizontal 
//					 2 = beide
//	sFrameIn	: Rechteck in dem verschoben wird (Screen-Koordinaten)
//	iStart		: Anfangs Verschub fr den Balken
//	sOffset		: Ist der Offset im Balken wo die Maus angreift
//	iWidth		: Ist die Breite des Balkens in Pixel
//	iGridWidth	: Ist die Breite des gezeichnete Balkens
//				  Bei 0 wird iWidth als gezeichnete Breite benutzt
//	iGridOff	: Ist der Verschub des gezeichneten Balkens im Balken.
//				  Bei DEFAULT_OFFSET wird dieser automatisch berechnet
//	Ergibt den Verschub in Pixel vom Balken mit der Maus.
int AFXAPI Resize(CWnd *pWnd,int iMode,CRect &sFrameIn,int iStart,CPoint sOffset,int iWidth,int iGridWidth,int iGridOff)
{
CSize	sSzNx,sSzNxL;
CSize	sSzPr,sSzPrL;
CSize	sSize,sSizeL;
CRect	sRect,sRectL;
CRect	sPrev,sPrevL;
CRect	sNext,sNextL;
CRect	sFrame;
int		iGridOffX;
int		iGridOffY;
int		iStartX;
int		iStartY;
int		iValue;
int		iExit;
int		iEnd;
MSG		sMsg;
CWnd   *pTop;
CDC	   *pDc;


	ASSERT(iMode>=0 && iMode<=2);
	
	pTop   = pWnd->GetDesktopWindow();
	sFrame = sFrameIn;

	if(iWidth    < 1)iWidth=1;
	if(iGridWidth<=0)iGridWidth=iWidth;


	if(GetCapture()!= NULL)return 0;

	if(pTop->LockWindowUpdate())
			pDc = pTop->GetDCEx(NULL, DCX_WINDOW|DCX_CACHE|DCX_LOCKWINDOWUPDATE);
	else 	pDc = pTop->GetDCEx(NULL, DCX_WINDOW|DCX_CACHE);

	while(PeekMessage(&sMsg,NULL,WM_PAINT,WM_PAINT,PM_NOREMOVE))
		{
		if(!GetMessage(&sMsg,NULL,WM_PAINT,WM_PAINT))
			{
			pTop->UnlockWindowUpdate();
			return 0;
			}
		 DispatchMessage(&sMsg);
		 }


	pWnd->SetCapture();
	pDc->SetBkColor(RGB(192,255,255));


	if(iGridOff==DEFAULT_OFFSET && iMode!=2)		// Gezeichneten Offset berechnen
		{
		iGridOff = (iWidth-iGridWidth+1)/2;
		}

	if(sOffset==DEFAULT_POINT)						// Wurde ein Offset angegeben
		{
		sOffset  = CPoint(iWidth/2,iWidth/2);
		}

	

	switch(iMode)
		{
	default:										// Horizontal verschieben

		   sFrame.right -= iGridWidth;
		if(sFrame.right<sFrame.left)sFrame.right=sFrame.left;
		   sOffset.x	-= iGridOff;
	
		if(iStart>sFrame.Width())iStart=sFrame.Width();
		if(iStart<0)iStart=0;

		sRect.top    = sFrame.top;
		sRect.bottom = sFrame.bottom;
		sRect.left   = sFrame.left+iGridOff+iStart;
		sRect.right	 = sRect .left+iGridWidth;
		break;

	case 0:											// Vertikal verschieben

		   sFrame.bottom -= iGridWidth;
		if(sFrame.bottom<sFrame.top)sFrame.bottom=sFrame.top;
		   sOffset.y 	 -= iGridOff;

		if(iStart>sFrame.Height())iStart=sFrame.Height();
		if(iStart<0)iStart=0;

		sRect.left   = sFrame.left;
		sRect.right  = sFrame.right;
		sRect.top    = sFrame.top+iGridOff+iStart;
		sRect.bottom = sRect .top+iGridWidth;
		
		break;

	case 2:											// Beide Richtungen verschieben

		if(iGridOff==DEFAULT_OFFSET)				// Gezeichneten Offset berechnen
			{
			iGridOffX = (iWidth-iGridWidth+1)/2;
			iGridOffY = iGridOffX;
			}
		else{
			iGridOffX =	GET_X_LPARAM(iGridOff);
			iGridOffY =	GET_X_LPARAM(iGridOff);
			}

		iStartX		  = GET_X_LPARAM(iStart);
		iStartY		  = GET_Y_LPARAM(iStart);

		   sFrame.right  -= iGridWidth;
		if(sFrame.right<sFrame.left)sFrame.right=sFrame.left;
		   sFrame.bottom -= iGridWidth;
		if(sFrame.bottom<sFrame.top)sFrame.bottom=sFrame.top;
		
		sOffset.x 	 -= iGridOffX;
		sOffset.y 	 -= iGridOffY;

		if(iStartX>sFrame.Width ())iStartX=sFrame.Width();
		if(iStartX<0)iStartX=0;
		if(iStartY>sFrame.Height())iStartY=sFrame.Height();
		if(iStartY<0)iStartY=0;

		sRect.left   = sFrame.left  +iGridOffX;
		sRect.right  = sFrame.right +iGridWidth;
		sRect.top    = sFrame.top   +iGridOffY+iStartY;
		sRect.bottom = sRect .top   +iGridWidth;

		sPrev.top    = sFrame.top;
		sPrev.bottom = sRect .top;
		sPrev.left   = sFrame.left  +iGridOffX+iStartX;
		sPrev.right	 = sPrev .left  +iGridWidth;
		
		sNext.top    = sRect .bottom;
		sNext.bottom = sFrame.bottom+iGridWidth;
		sNext.left   = sFrame.left  +iStartX;
		sNext.right	 = sPrev .left  +iGridWidth;

		sSzPr  = sPrev.Size();
		sSzPrL = CSize(0,0);
		sPrevL.SetRectEmpty();

		sSzNx  = sNext.Size();
		sSzNxL = CSize(0,0);
		sNextL.SetRectEmpty();

		pDc->DrawDragRect(&sPrev,sSzPr, &sPrevL, sSzPrL);
		pDc->DrawDragRect(&sNext,sSzNx, &sNextL, sSzNxL);
		sPrevL = sPrev;
		sSzPrL = sSzPr;
		sNextL = sNext;
		sSzNxL = sSzNx;

		break;
		}


	sSize  = sRect.Size();
	sSizeL = CSize(0,0);
	sRectL.SetRectEmpty();

	pDc->DrawDragRect(&sRect,sSize, &sRectL, sSizeL);

	sRectL = sRect;
	sSizeL = sSize;

//******************** Message Schleife ***************************************

	iExit=0;

	while(!iExit && pWnd->GetCapture()==pWnd)
		{
		if(!GetMessage(&sMsg,NULL,0,0))
			{
			AfxPostQuitMessage((int)sMsg.wParam);
			iExit=2;
			break;
			}

		switch(sMsg.message)						// Nachrichten auswerten
			{
			case WM_MOUSEMOVE:

				sMsg.pt.x -= sOffset.x;
				sMsg.pt.y -= sOffset.y;

				switch(iMode)
					{				
				default:							// Horizontal verschieben

					   sRect.left =sMsg.pt.x;
					if(sRect.left >sFrame.right)sRect.left=sFrame.right;
					if(sRect.left <sFrame.left )sRect.left=sFrame.left;
					   sRect.right=sRect .left+iGridWidth;
					break;

				case 0:								// Vertikal verschieben

					   sRect.top   =sMsg.pt.y;
					if(sRect.top   >sFrame.bottom)sRect.top=sFrame.bottom;
					if(sRect.top   <sFrame.top   )sRect.top=sFrame.top;
					   sRect.bottom=sRect .top+iGridWidth;

					break;

				case 2:								// Beide Richtungen verschieben

					   sRect.top   =sMsg.pt.y;
					if(sRect.top   >sFrame.bottom)sRect.top=sFrame.bottom;
					if(sRect.top   <sFrame.top   )sRect.top=sFrame.top;
					   sRect.bottom=sRect .top+iGridWidth;

					   iValue=sMsg.pt.x;
					if(iValue>sFrame.right)iValue=sFrame.right;
					if(iValue<sFrame.left )iValue=sFrame.left;

					sPrev.bottom = sRect .top;
					sPrev.left   = iValue;
					sPrev.right	 = iValue+iGridWidth;
					
					sNext.top    = sRect .bottom;
					sNext.left   = iValue;
					sNext.right	 = iValue+iGridWidth;

					pDc->DrawDragRect(&sPrev,sSzPr, &sPrevL, sSzPrL);
					pDc->DrawDragRect(&sNext,sSzNx, &sNextL, sSzNxL);
					sPrevL = sPrev;
					sSzPrL = sSzPr;
					sNextL = sNext;
					sSzNxL = sSzNx;
					break;
					}

					pDc->DrawDragRect(&sRect,sSize,&sRectL,sSizeL);
					sRectL = sRect;
					sSizeL = sSize;
					break;

			case WM_KEYDOWN:

					if(sMsg.wParam==VK_ESCAPE)
					iExit=2;
					break;

			case WM_LBUTTONUP:

					iExit=1;
					break;

			case WM_RBUTTONDOWN:

					iExit=2;
					break;

			default:DispatchMessage(&sMsg);
					break;
			}
		}


//******************** Ende ***************************************************


	switch(iMode)
		{
	default:										// Horizontal verschieben
	
		sFrame.left    += iGridOff;
		sFrame.right   += iGridOff-iGridWidth+iWidth;

		if(sRect.left>sFrame.right)sRect.left=sFrame.right;
		if(sRect.left<sFrame.left )sRect.left=sFrame.left;

		iEnd	= sRect.left-sFrame.left;
		iValue	= iEnd-iStart;
		
		break;
		
	case 0:											// Vertikal verschieben

		sFrame.top     += iGridOff;
		sFrame.bottom  += iGridOff-iGridWidth+iWidth;

		if(sRect.top >sFrame.bottom)sRect.top=sFrame.bottom;
		if(sRect.top <sFrame.top   )sRect.top=sFrame.top;

		iEnd	= sRect.top-sFrame.top;
		iValue	= iEnd-iStart;

		break;

	case 2:											// Beide Richtungen verschieben

		sFrame.left    += iGridOffX;
		sFrame.right   += iGridOffX-iGridWidth+iWidth;
		sFrame.top     += iGridOffY;
		sFrame.bottom  += iGridOffY-iGridWidth+iWidth;

		if(sNext.left>sFrame.right )sNext.left=sFrame.right;
		if(sNext.left<sFrame.left  )sNext.left=sFrame.left;
		if(sRect.top >sFrame.bottom)sRect.top =sFrame.bottom;
		if(sRect.top <sFrame.top   )sRect.top =sFrame.top;

		iEnd	= sNext.left-sFrame.left;
		iValue	= (iEnd-iStartX)&0xFFFF;

		iEnd	= sRect.top-sFrame.top;
		iValue |= (iEnd-iStartY)<<16;

		sPrev.SetRectEmpty();
		sSzPr=CSize(0,0);
		sNext.SetRectEmpty();
		sSzNx=CSize(0,0);

		pDc->DrawDragRect(&sPrev,sSzPr, &sPrevL, sSzPrL);
		pDc->DrawDragRect(&sNext,sSzNx, &sNextL, sSzNxL);

		break;
		}

	sRect.SetRectEmpty();
	sSize=CSize(0,0);
	iEnd+=iGridOff;

	pDc->DrawDragRect(&sRect,sSize, &sRectL, sSizeL);

	sRectL = sRect;
	sSizeL = sSize;

	pTop->UnlockWindowUpdate();
	ReleaseCapture();


	if(iExit==2)return 0;



return iValue;
}

//*****************************************************************************
//*
//*		Remove
//*
//*****************************************************************************
//	Begibt sich in den Verschiebe Modus fr ein Rechteck
//	pWnd		: Ist das Fenster in dem der Balken verschoben wird
//	sFrame		: Rechteck das verschoben wird (Screen-Koordinaten)
//	sOffset		: Ist der Offset im Balken
//	Ergibt den Verschub in Pixel via einer POINT Struktur
POINT AFXAPI Remove(CWnd *pWnd,CRect &sFrame,CPoint sOffset)
{
int		iExit;
CPoint	sPoint(0,0);
CSize	sSize,sSizeL;
CRect	sRect,sRectL;
MSG		sMsg;
CWnd   *pTop;
CDC	   *pDc;


	pTop = pWnd->GetDesktopWindow();


	if(GetCapture() != NULL)return sPoint;


	if(pTop->LockWindowUpdate())
			pDc = pTop->GetDCEx(NULL,DCX_WINDOW|DCX_CACHE|DCX_LOCKWINDOWUPDATE);
	else 	pDc = pTop->GetDCEx(NULL,DCX_WINDOW|DCX_CACHE);

	while(PeekMessage(&sMsg,NULL,WM_PAINT,WM_PAINT,PM_NOREMOVE))
		{
		if(!GetMessage(&sMsg,NULL,WM_PAINT,WM_PAINT))
			{
			pTop->UnlockWindowUpdate();
			return sPoint;
			}
		DispatchMessage(&sMsg);
		}


	pWnd->SetCapture();

	sRect  = sFrame;
	sSize  = CSize(4,4);
	sSizeL = CSize(0,0);
	sRectL.SetRectEmpty();

	pDc->SetBkColor(RGB(192,255,255));
	pDc->DrawDragRect(&sRect,sSize, &sRectL, sSizeL);

	sRectL = sRect;
	sSizeL = sSize;

//******************** Message Schleife ***************************************

	iExit=0;

	while(!iExit && pWnd->GetCapture()==pWnd)
		{
		if(!GetMessage(&sMsg, NULL, 0, 0))
			{
			AfxPostQuitMessage((int)sMsg.wParam);
			iExit=2;
			break;
			}

		switch (sMsg.message)
			{
			case WM_MOUSEMOVE:

					sPoint.x = sMsg.pt.x-sOffset.x;
					sPoint.y = sMsg.pt.y-sOffset.y;

					sRect    = sFrame;
					sRect   += sPoint;

					pDc->DrawDragRect(&sRect,sSize, &sRectL,sSizeL);

					sRectL   = sRect;
					sSizeL   = sSize;
					break;

			case WM_KEYDOWN:

					if(sMsg.wParam==VK_ESCAPE)
					iExit=2;
					break;

			case WM_LBUTTONUP:

					iExit=1;
					break;

			case WM_RBUTTONDOWN:

					iExit=2;
					break;

			default:DispatchMessage(&sMsg);
					break;
			}
		}


//******************** Ende ***************************************************


	sRect.SetRectEmpty();
	sSize=CSize(0,0);

	pDc->DrawDragRect(&sRect,sSize, &sRectL, sSizeL);

	sRectL = sRect;
	sSizeL = sSize;

	pTop->UnlockWindowUpdate();
	ReleaseCapture();


	if(iExit==2)return CPoint(0,0);



return sPoint;
}

//*****************************************************************************
//*
//*		Cursor- und Icon-Daten
//*
//*****************************************************************************

static DWORD aCursorData[]=
	{
	// Pfeil oulr
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00800100,0x00400200,0x00200400,0x00100800,0x00081000,0x00FC3F00,0x000A5000,0x00899100,0x80481201,0x40281402,
	0x40281402,0x80481201,0x00899100,0x000A5000,0x00FC3F00,0x00081000,0x00100800,0x00200400,0x00400200,0x00800100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1FF8FF,0xFF0FF0FF,0xFF07E0FF,0xFF03C0FF,0xFFF18FFF,0xFF700EFF,0x7F300CFE,0x3F1008FC,
	0x3F1008FC,0x7F300CFE,0xFF700EFF,0xFFF18FFF,0xFF03C0FF,0xFF07E0FF,0xFF0FF0FF,0xFF1FF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil o
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00800100,0x00400200,0x00200400,
	0x00200400,0x00400200,0x00800100,0x00000000,0x00FC3F00,0x00042000,0x00081000,0x00100800,0x00200400,0x00400200,0x00800100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1FF8FF,
	0xFF1FF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFF03C0FF,0xFF03C0FF,0xFF07E0FF,0xFF0FF0FF,0xFF1FF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil u
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00800100,0x00400200,0x00200400,0x00100800,0x00081000,0x00042000,0x00FC3F00,0x00000000,0x00800100,0x00400200,0x00200400,
	0x00200400,0x00400200,0x00800100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1FF8FF,0xFF0FF0FF,0xFF07E0FF,0xFF03C0FF,0xFF03C0FF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1FF8FF,
	0xFF1FF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil l
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x000C0000,0x000A0000,0x00090000,0x80880100,0x40480200,0x20280400,
	0x20280400,0x40480200,0x80880100,0x00090000,0x000A0000,0x000C0000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFF3FFFF,0xFFF1FFFF,0xFFF0FFFF,0x7F70FEFF,0x3F30FCFF,0x1F10F8FF,
	0x1F10F8FF,0x3F30FCFF,0x7F70FEFF,0xFFF0FFFF,0xFFF1FFFF,0xFFF3FFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil lo
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00800100,0x00400200,0x80210400,
	0x80220400,0x80440200,0x80880100,0x80100000,0x80200000,0x80400000,0x80800000,0x80000100,0x80FF0100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0x7F1EF8FF,
	0x7F1CF8FF,0x7F38FCFF,0x7F70FEFF,0x7FE0FFFF,0x7FC0FFFF,0x7F80FFFF,0x7F00FFFF,0x7F00FEFF,0x7F00FEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil lu
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x80FF0100,0x80000100,0x80800000,0x80400000,0x80200000,0x80100000,0x80880100,0x80440200,0x80220400,
	0x80210400,0x00400200,0x00800100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0x7F00FEFF,0x7F00FEFF,0x7F00FFFF,0x7F80FFFF,0x7FC0FFFF,0x7FE0FFFF,0x7F70FEFF,0x7F38FCFF,0x7F1CF8FF,
	0x7F1EF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil r
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00003000,0x00005000,0x00009000,0x00801101,0x00401202,0x00201404,
	0x00201404,0x00401202,0x00801101,0x00009000,0x00005000,0x00003000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFCFFF,0xFFFF8FFF,0xFFFF0FFF,0xFF7F0EFE,0xFF3F0CFC,0xFF1F08F8,
	0xFF1F08F8,0xFF3F0CFC,0xFF7F0EFE,0xFFFF0FFF,0xFFFF8FFF,0xFFFFCFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil ro
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00800100,0x00400200,0x00208401,
	0x00204401,0x00402201,0x00801101,0x00000801,0x00000401,0x00000201,0x00000101,0x00800001,0x0080FF01,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1F78FE,
	0xFF1F38FE,0xFF3F1CFE,0xFF7F0EFE,0xFFFF07FE,0xFFFF03FE,0xFFFF01FE,0xFFFF00FE,0xFF7F00FE,0xFF7F00FE,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil ru
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x0080FF01,0x00800001,0x00000101,0x00000201,0x00000401,0x00000801,0x00801101,0x00402201,0x00204401,
	0x00208401,0x00400200,0x00800100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7F00FE,0xFF7F00FE,0xFFFF00FE,0xFFFF01FE,0xFFFF03FE,0xFFFF07FE,0xFF7F0EFE,0xFF3F1CFE,0xFF1F38FE,
	0xFF1F78FE,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil lr
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x000C3000,0x000A5000,0x00099000,0x80881101,0x40481202,0x20281404,
	0x20281404,0x40481202,0x80881101,0x00099000,0x000A5000,0x000C3000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFF3CFFF,0xFFF18FFF,0xFFF00FFF,0x7F700EFE,0x3F300CFC,0x1F1008F8,
	0x1F1008F8,0x3F300CFC,0x7F700EFE,0xFFF00FFF,0xFFF18FFF,0xFFF3CFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	// Pfeil ou
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00800100,0x00400200,0x00200400,0x00100800,0x00081000,0x00042000,0x00FC3F00,0x00000000,0x00800100,0x00400200,0x00200400,
	0x00200400,0x00400200,0x00800100,0x00000000,0x00FC3F00,0x00042000,0x00081000,0x00100800,0x00200400,0x00400200,0x00800100,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1FF8FF,0xFF0FF0FF,0xFF07E0FF,0xFF03C0FF,0xFF03C0FF,0xFFFFFFFF,0xFF7FFEFF,0xFF3FFCFF,0xFF1FF8FF,
	0xFF1FF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFF03C0FF,0xFF03C0FF,0xFF07E0FF,0xFF0FF0FF,0xFF1FF8FF,0xFF3FFCFF,0xFF7FFEFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,
	};

static DWORD aIconData[]=
	{
	// Icon oulr
	0x00000000,0x00000000,0x00000000,0x00000000,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xF7FFFFFF,0xFFFFFF7F,0xF0FFFFFF,
	0xFFFFFF0F,0x77FFFFFF,0xFFFFFF77,0xF0FFFFFF,0xFFFFFF0F,0x77F7FFFF,0xFFFF7F77,0xF0FFFFFF,0xFFFFFF0F,0x7777FFFF,0xFFFF7777,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFF7FFF,0xFFF7FFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFF7FF7,0x7FF7FFFF,0xF0FFFFFF,0xFFFFFF0F,0xF7FF7F77,0x77F7FF7F,0xF0FFFFFF,0xF7FFFF0F,0x77FF7F77,0x77F7FF77,0xF0FFFF7F,
	0xF7FFFF0F,0x77FF7F77,0x77F7FF77,0xF0FFFF7F,0xFFFFFF0F,0xF7FF7F77,0x77F7FF7F,0xF0FFFFFF,0xFFFFFF0F,0xFFFF7FF7,0x7FF7FFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFF7FFF,0xFFF7FFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0x7777FFFF,0xFFFF7777,0xF0FFFFFF,0xFFFFFF0F,0x77F7FFFF,0xFFFF7F77,0xF0FFFFFF,0xFFFFFF0F,0x77FFFFFF,0xFFFFFF77,0xF0FFFFFF,
	0xFFFFFF0F,0xF7FFFFFF,0xFFFFFF7F,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	// Icon lr
	0x00000000,0x00000000,0x00000000,0x00000000,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFF7FF,0xFF7FFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFF77FF,0xFF77FFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFF77F7,0x7F77FFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFF7777,0x7777FFFF,0xF0FFFFFF,0xF7FFFF0F,0xF7FF7777,0x7777FF7F,0xF0FFFF7F,0x77FFFF0F,0x77FF7777,0x7777FF77,0xF0FFFF77,
	0x77FFFF0F,0x77FF7777,0x7777FF77,0xF0FFFF77,0xF7FFFF0F,0xF7FF7777,0x7777FF7F,0xF0FFFF7F,0xFFFFFF0F,0xFFFF7777,0x7777FFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFF77F7,0x7F77FFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFF77FF,0xFF77FFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFF7FF,0xFF7FFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
		// Icon ou
	0x00000000,0x00000000,0x00000000,0x00000000,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xF7FFFFFF,0xFFFFFF7F,0xF0FFFFFF,0xFFFFFF0F,0x77FFFFFF,0xFFFFFF77,0xF0FFFFFF,
	0xFFFFFF0F,0x77F7FFFF,0xFFFF7F77,0xF0FFFFFF,0xFFFFFF0F,0x7777FFFF,0xFFFF7777,0xF0FFFFFF,0xFFFFFF0F,0x7777F7FF,0xFF7F7777,0xF0FFFFFF,0xFFFFFF0F,0x777777FF,0xFF777777,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xF7FFFFFF,0xFFFFFF7F,0xF0FFFFFF,0xFFFFFF0F,0x77FFFFFF,0xFFFFFF77,0xF0FFFFFF,
	0xFFFFFF0F,0x77FFFFFF,0xFFFFFF77,0xF0FFFFFF,0xFFFFFF0F,0xF7FFFFFF,0xFFFFFF7F,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0x777777FF,0xFF777777,0xF0FFFFFF,0xFFFFFF0F,0x7777F7FF,0xFF7F7777,0xF0FFFFFF,0xFFFFFF0F,0x7777FFFF,0xFFFF7777,0xF0FFFFFF,0xFFFFFF0F,0x77F7FFFF,0xFFFF7F77,0xF0FFFFFF,
	0xFFFFFF0F,0x77FFFFFF,0xFFFFFF77,0xF0FFFFFF,0xFFFFFF0F,0xF7FFFFFF,0xFFFFFF7F,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,
	0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0xFFFFFF0F,0xFFFFFFFF,0xFFFFFFFF,0xF0FFFFFF,0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
	};

static int	 volatile iCursorEnd;
static int	 volatile iCursorStop=0;
static int			  iCursorType=0;
static int			  iCursorSpeed=0;
static CWnd			 *pCursorWnd=0;

//*****************************************************************************
//*
//*		ScrollCursorProc
//*
//*****************************************************************************
static UINT _cdecl ScrollCursorProc(LPVOID pParam)
{
int			 i,j,iXpos,iYpos;
CScrollBar	*pScrollV,*pScrollH;
CWnd		*pWnd;


		pWnd=pCursorWnd;
	if(!pWnd)return 0;


	pScrollH=pWnd->GetScrollBarCtrl(SB_HORZ);
	pScrollV=pWnd->GetScrollBarCtrl(SB_VERT);

	while(!iCursorStop)
		{
		i=iCursorType/3;
		j=iCursorType%3;

		if(i>0)
			{
			iXpos =pCursorWnd->GetScrollPos(SB_HORZ);
			iXpos+=(i==2)? -iCursorSpeed:iCursorSpeed;
			pWnd->PostMessage(WM_HSCROLL,MAKELONG(SB_THUMBTRACK,iXpos),(LPARAM)pScrollH);
			}

		if(j>0)
			{
			iYpos =pCursorWnd->GetScrollPos(SB_VERT);
			iYpos+=(j==2)? -iCursorSpeed:iCursorSpeed;
			pWnd->PostMessage(WM_VSCROLL,MAKELONG(SB_THUMBTRACK,iYpos),(LPARAM)pScrollV);
			}

		Sleep(200);
		}

	iCursorEnd=1;



return 0;
}

//*****************************************************************************
//*
//*		ScrollCursor
//*
//*****************************************************************************
//	Blendet einen Scroll-Cursor ein und scrollt ein Fenster.
//	pWnd	: Das Fenster das gescrollt werden soll.
//	iPos	: Position im Fenster wo das Scroll-Icon hinkommen soll.
//	iMode	: Scroll Art	1: Horizontal
//						2: Vertikal
//						3: Horizontal und Vertikal
//	Ergibt TRUE wenn allse ok war.
BOOL AFXAPI ScrollCursor(CWnd *pWnd,CPoint iPos,int iMode)
{
int			iExit,iNum,i,j,k,iTicks,iVal,iBits;
MSG			sMsg;
HDC			hDc;
HICON		hIcon;
HCURSOR		hCursor[9],hCursorOld;
BYTE	   *pPtr,*pTarget,aData[32*32*4];
CPoint		sOffset;
CStatic		sIconWnd;
CRect		sRect;


	if(iMode<=0)return FALSE;
	if(iMode> 3)return FALSE;
	if(!pWnd)return FALSE;
	if(!IsWindow(pWnd->m_hWnd))return FALSE;

	iCursorType = 0;
	iCursorStop	= 0;
	pCursorWnd	= pWnd;

	AfxBeginThread(ScrollCursorProc,0);

	for(iNum=0;iNum<9;iNum++)						// Icons erzeugen
		{
		if(iNum)k=iNum*64;
		else{
			k=(9-1+iMode)*64;
			if(iMode==3)k=0;
			}

		hCursor[iNum]=CreateCursor(	AfxGetInstanceHandle(),
									16,16,32,32,
									aCursorData+k+32,
									aCursorData+k);
		}

	k=160*iMode;
	if(iMode==3)k=0;

	hDc   = GetDC(pWnd->m_hWnd);
	iBits = GetDeviceCaps(hDc,BITSPIXEL);			// Icon erzeugen
	ReleaseDC(pWnd->m_hWnd,hDc);

	pPtr		= (BYTE*)(aIconData+k);
	pTarget	= aData;
	memset(aData,0,32*32*iBits/8);

	for(i=0;i<32*32;i++)
		{
		j=pPtr[i>>1];
		if(i&1)j&=0x0F;
		else   j>>=4;

		if(!j)continue;

		switch(iBits)
			{
		default:	iBits=1;
		case  1:	if(j==15)pTarget[i>>3]|=0x80>>(i&7);	break;
		case  4:	pTarget[i>>3]|=j<<((~i&1)<<2);			break;
		case  8:	pTarget[i>>3] =j;						break;
		case 15:	j =(j<<1)|0x01;
					j|=(j<<5)|(j<<10);
					*(short*)(pTarget+i*2)=j;				break;
		case 16:	j =(j<<1)|0x01;
					j|=(j<<6)|(j<<11);
					*(short*)(pTarget+i*2)=j;				break;
		case 24:	j =(j<<4)|0x0F;
					j|=(j<<8)|(j<<16);
					*(int*)(pTarget+i*3)=j;				break;
		case 32:	j =(j<<4)|0x0F;
					j|=(j<<8)|(j<<16);
					*(int*)(pTarget+i*4)=j;				break;
			}
		}


	hIcon = CreateIcon(AfxGetInstanceHandle(),32,32,1,iBits,(unsigned char*)(aIconData+k+128),aData);

	sOffset=iPos;
	pWnd->ClientToScreen(&sOffset);
	pWnd->SetCapture();

	sRect.SetRect(iPos.x-16,iPos.y-16,iPos.x+16,iPos.y+16);
	sIconWnd.Create(0,SS_ICON|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN,sRect,pWnd);
	sIconWnd.SetIcon(hIcon);
	hCursorOld=SetCursor(hCursor[0]);

//******************** Message Schleife ***************************************

	iCursorSpeed=1;
	iExit		=0;

	while(!iExit && pWnd->GetCapture() == pWnd)
		{
		if(!GetMessage(&sMsg, NULL, 0, 0))
			{
			AfxPostQuitMessage((int)sMsg.wParam);
			iExit=2;
			break;
			}

		switch (sMsg.message)
			{
		case WM_MOUSEMOVE:

			i=sMsg.pt.x-sOffset.x;
			j=sMsg.pt.y-sOffset.y;

			if(i==0)i=1;
			if(j==0)j=1;

			if(i>0)
				{
				   iTicks=(j*100)/i;
							 k=2;
				if(iTicks>-240)k=5;
				if(iTicks>- 40)k=3;
				if(iTicks>  40)k=4;
				if(iTicks> 240)k=1;
				}
			else{
				   iTicks=(j*100)/i;
							 k=1;
				if(iTicks>-240)k=7;
				if(iTicks>- 40)k=6;
				if(iTicks>  40)k=8;
				if(iTicks> 240)k=2;
				}

			if(i*i+j*j<20*20)k=0;

			if(iMode==1)k-=k%3;
			if(iMode==2)k =k%3;

			if(k!=iCursorType)
				{
				iCursorType=k;
				SetCursor(hCursor[iCursorType]);
				}

					  k = 0;			// Scrollgeschwindigkeit
			if(iMode&1)k = i>>4;
			if(iMode&2)k+= j>>4;
			if(k<0)k=-k;

			iCursorSpeed=k;

			break;

		case WM_KEYDOWN:if (sMsg.wParam == VK_ESCAPE)iExit=1;break;
		case WM_LBUTTONDOWN:						 iExit=1;break;
		case WM_RBUTTONDOWN:						 iExit=1;break;
		case WM_MBUTTONDOWN:						 iExit=1;break;
		case WM_MOUSEWHEEL:							 	     break;
		case WM_KILLFOCUS:							 iExit=1;
		default:DispatchMessage(&sMsg);				 	     break;
			}
		}


//******************** Ende ***************************************************

	iCursorStop=1;

	while(!iCursorEnd)Sleep(50);			// Warte auf Thread ende

	iCursorType=0;

	SetCursor(hCursorOld);
	ReleaseCapture();
	sIconWnd.DestroyWindow();
	DestroyIcon(hIcon);

	for(iNum=0;iNum<9;iNum++)DestroyCursor(hCursor[iNum]);

	iVal=pWnd->GetScrollPos(SB_HORZ);
	pWnd->PostMessage(WM_HSCROLL,MAKELONG(SB_THUMBPOSITION,iVal),(LPARAM)pWnd->GetScrollBarCtrl(SB_HORZ));

	iVal=pWnd->GetScrollPos(SB_VERT);
	pWnd->PostMessage(WM_VSCROLL,MAKELONG(SB_THUMBPOSITION,iVal),(LPARAM)pWnd->GetScrollBarCtrl(SB_VERT));


return TRUE;
}

//*****************************************************************************
//*
//*		GetWindowPt
//*
//*****************************************************************************
//	Holt die Bildschirmposition von einem Fenster
//	pWnd	: Ist der Zeiger auf das Fenster.
//	Ergibt die Bildschirmposition
POINT AFXAPI GetWindowPt(CWnd  *pWnd)
{
RECT	sRect;
POINT	sPoint;


	ASSERT(pWnd!=0);
	ASSERT(IsWindow(pWnd->m_hWnd));

	pWnd->GetWindowRect(&sRect);

	sPoint.x = sRect.left;
	sPoint.y = sRect.top;


return sPoint;
}

//*****************************************************************************
//*
//*		GetPosRect
//*
//*****************************************************************************
//	Speichert die Position von einem Fenster im Elterfenster
//	pWnd	: Zeiger auf das Fenster
//	pRect	: Hier wird die Position gespeichert
//	Ergibt 1 wenn die Position ermittelt werden konnte
BOOL AFXAPI GetPosRect(HWND hWnd,LPRECT pRect)
{
HWND    hParent;
POINT	sPoint={0,0};



				GetWindowRect(hWnd,pRect);
		hParent=GetParent    (hWnd);
	if(!hParent)return FALSE;

	ClientToScreen(hParent,&sPoint);

	pRect->left	  -=sPoint.x;
	pRect->right  -=sPoint.x;
	pRect->top	  -=sPoint.y;
	pRect->bottom -=sPoint.y;



return TRUE;
}

//*****************************************************************************
//*
//*		GetDlgPosRect
//*
//*****************************************************************************
//	Speichert die Position von einem Unterfenster eines Dialoges
//	pDlg	: Ist der Zeiger auf den Dialog
//	iId		: Ist die ID des Unterfensters
//	pRect	: Hier wird die Position gespeichert
//	Ergibt 1 wenn die Position ermittelt werden konnte
BOOL AFXAPI GetDlgPosRect(CDialog *pDlg,int iId,LPRECT pRect)
{
POINT	sPoint={0,0};
CWnd   *pWnd;



	if(!pDlg)return FALSE;
		pWnd=pDlg->GetDlgItem(iId);
	if(!pWnd)return FALSE;

	GetWindowRect (pWnd->m_hWnd,pRect);
	ClientToScreen(pDlg->m_hWnd,&sPoint);

	pRect->left	  -= sPoint.x;
	pRect->right  -= sPoint.x;
	pRect->top	  -= sPoint.y;
	pRect->bottom -= sPoint.y;



return TRUE;
}


//*****************************************************************************
//*
//*		MoveWindow
//*
//*****************************************************************************
//	Verschiebt das ein Dialogunterfenster ber ein anders Unterfenster
//	pDlg		: Ist der Zeiger auf den Dialog
//	iIdMove		: Ist die ID des Unterfensters das verschoben werden soll
//	iIdFrom		: Ist die ID des Unterfensters mit der Zielposition
//	Ergibt 1 wenn das Fenster verschoben werden konnte.
BOOL AFXAPI MoveWindow(CDialog *pDlg,int iIdMove,int iIdFrom)
{
RECT	sRect;
CWnd   *pWnd;


	if(!pDlg)return FALSE;
	if(!GetDlgPosRect(pDlg,iIdFrom,&sRect))return FALSE;

		pWnd=pDlg->GetDlgItem(iIdMove);
	if(!pWnd)return FALSE;
		pWnd->MoveWindow(&sRect);

return 1;
}

//*****************************************************************************
//*
//*		MoveWindow
//*
//*****************************************************************************
//	Verschiebt ein Fenster um einige Pixel
//	hWnd		: Ist das das zu verschiebende Fenster
//	iPosX		: Ist die X-Position zu der das Fenster verschoben werden soll
//	iPosY		: Ist die Y-Position zu der das Fenster verschoben werden soll
//	iDelta		: Bestimmt die Art wie das Fenster verschoben werden soll
//					==0		Zu absoluten Position verschieben
//					==1		Nur relativ verschieben verschieben
//	Ergibt TRUE wenn das Fenster verschoben werden konnte.
BOOL AFXAPI MoveWindow(HWND hWnd,int iPosX,int iPosY,BOOL iDelta)
{
RECT	sRect;


	if(iDelta)
		{
		GetPosRect(hWnd,&sRect);
		return SetWindowPos(hWnd,0,sRect.left+iPosX,sRect.top+iPosY,0,0,SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_NOZORDER);
		}
	else{
		return SetWindowPos(hWnd,0,iPosX,iPosY,0,0,SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_NOZORDER);
		}
}

//*****************************************************************************
//*
//*		SizeWindow
//*
//*****************************************************************************
//	Verndert die Gre eines Fensters um einige Pixel
//	hWnd		: Ist das zu verndernde Fenster
//	iSizeX		: Ist die neue X-Gre des Fensters
//	iSizeY		: Ist die neue Y-Gre des Fensters
//	iDelta		: Bestimmt die Art wie das Fenster vergrert werden soll
//					==0		iSizeX/iSizeY ist die absolute neue Gre
//					==1		iSizeX/iSizeY ist die relative neue Gre
//	Ergibt TRUE wenn das Fenster verndert werden konnte.
BOOL AFXAPI SizeWindow(HWND hWnd,int iSizeX,int iSizeY,BOOL iDelta)
{
		RECT	sRect;

	if(iDelta)
		{
		GetWindowRect(hWnd,&sRect);
		return SetWindowPos(hWnd,0,0,0,sRect.right-sRect.left+iSizeX,sRect.bottom-sRect.top+iSizeY,SWP_NOOWNERZORDER|SWP_NOMOVE|SWP_NOZORDER);
		}
	else{
		return SetWindowPos(hWnd,0,0,0,iSizeX,iSizeY,SWP_NOOWNERZORDER|SWP_NOMOVE|SWP_NOZORDER);
		}

}

//*****************************************************************************
//*
//*		DDX_Text
//*
//*****************************************************************************
//	Diehnt zum Austausch von Daten in char Feldern
//	iMaxSize	: Ist die Gre des Feldes in
/*
void AFXAPI DDX_Text(CDataExchange *pDX, int nIDC, LPTSTR pText,int iMaxSize)
{
HWND	hWndCtrl;



	hWndCtrl = pDX->PrepareCtrl(nIDC);


	if (pDX->m_bSaveAndValidate)
		{
		GetWindowText(hWndCtrl,pText,iMaxSize);
		}
	else{
		SetWindowText(hWndCtrl,pText);
		}
} */

//*****************************************************************************
//*
//*		DDX_Float
//*
//*****************************************************************************
//	Diehnt zum Austausch von Daten in double Variablen mit einem Umrechnungsfaktor.
//	Die Zahlen werden in der Form "12 3456.7" dargestellt
//	pDx		: Zeiger DataExchange Objekt
//	iId		: Ist die ID des Dialogfensters
//	dValue	: Ist die Referenz auf die Variabel
//	iComma	: Ist die Anzahl der Kommastellen
//	dFact	: Ist der Factor mit dem die Zahl umgerechnet wird
void AFXAPI DDX_Float(CDataExchange *pDX,int iId,float &dValue,int iComma,double dFact)
{
double		dTemp;


	if(pDX->m_bSaveAndValidate==0)dTemp=dValue*dFact;

	DDX_Float(pDX,iId,dTemp,iComma);

	if(pDX->m_bSaveAndValidate!=0)dValue=(float)(dTemp/dFact);

}

//*****************************************************************************
//*
//*		DDX_Float
//*
//*****************************************************************************
//	Diehnt zum Austausch von Daten in double Variablen.
//	Die Zahlen werden in der Form "12 3456.7" dargestellt
//	pDx		: Zeiger DataExchange Objekt
//	iId		: Ist die ID des Dialogfensters
//	dValue	: Ist die Referenz auf die Variabel
//	iComma	: Ist die Anzahl der Kommastellen
//	dFact	: Ist der Factor mit dem die Zahl umgerechnet wird
void AFXAPI DDX_Float(CDataExchange *pDX,int iId,float &dValue,int iComma)
{
double		dTemp;


	if(pDX->m_bSaveAndValidate==0)dTemp=dValue;

	DDX_Float(pDX,iId,dTemp,iComma);

	if(pDX->m_bSaveAndValidate!=0)dValue=(float)dTemp;

}

//*****************************************************************************
//*
//*		DDX_Float
//*
//*****************************************************************************
//	Diehnt zum Austausch von Daten in double Variablen mit einem Umrechnungsfaktor.
//	Die Zahlen werden in der Form "12 3456.7" dargestellt
//	pDx		: Zeiger DataExchange Objekt
//	iId		: Ist die ID des Dialogfensters
//	dValue	: Ist die Referenz auf die Variabel
//	iComma	: Ist die Anzahl der Kommastellen
//	dFact	: Ist der Factor mit dem die Zahl umgerechnet wird
void AFXAPI DDX_Float(CDataExchange *pDX,int iId,double &dValue,int iComma,double dFact)
{
double		dTemp;


	if(pDX->m_bSaveAndValidate==0)dTemp=dValue*dFact;

	DDX_Float(pDX,iId,dTemp,iComma);

	if(pDX->m_bSaveAndValidate!=0)dValue=dTemp/dFact;

}

//*****************************************************************************
//*
//*		DDX_Float
//*
//*****************************************************************************
//	Diehnt zum Austausch von Daten in double Variablen
//	Die Zahlen werden in der Form "12 3456.7" dargestellt
//	pDx		: Zeiger DataExchange Objekt
//	iId		: Ist die ID des Dialogfensters
//	dValue	: Ist die Referenz auf die Variabel
//	iComma	: Ist die Anzahl der Kommastellen
void AFXAPI DDX_Float(CDataExchange *pDX,int iId,double &dValue,int iComma)
{
static const int	aFactors[]={1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000};
int					iVal,iValK,i,j,iMax,iMinus=0;
TCHAR				cStr [32],*pPtr;
TCHAR				cText[32];
unsigned __int64	uComa64;
unsigned __int64	uVal64;
double				dVal;
CWnd			   *pWnd;



	ASSERT(iComma>=0 && iComma<=9);
	pWnd=pDX->m_pDlgWnd->GetDlgItem(iId);
	ASSERT(pWnd!=0);
	if(!pWnd)return;

	if(iComma>9)iComma=9;
	if(iComma<0)iComma=0;

	if(pDX->m_bSaveAndValidate)							// Welche Richtung ?
		{
		iMax = pWnd->GetWindowText(cStr,sizeof(cStr)/sizeof(TCHAR));
		iVal = 0;

		for(i=0;i<iMax;i++)
			{
			if(cStr[i]==' ')continue;
			if(cStr[i]=='-' && !iMinus){iMinus=1;continue;}
			if(cStr[i]=='.' || cStr[i]==',')break;
			if(cStr[i]< '0' || cStr[i]> '9')break;		// Suche Komma

			iVal*=10;
			iVal+=cStr[i]-'0';
			}

		iValK=0;j=0;

		if(cStr[i]=='.' || cStr[i]==',')				// Kommastellen
		for(i++;i<iMax && j<iComma;i++)
			{
			if(cStr[i]==' ')continue;
			if(cStr[i]< '0' || cStr[i]> '9')break;
				iValK*=10;
				iValK+=cStr[i]-'0';
				j++;
			}

		dValue=(double)iVal+(double)iValK/(double)aFactors[j];
		if(iMinus)dValue=-dValue;
		}
	else{												// Zahl in Text umwandeln
		pPtr = cStr;
		dVal = dValue;

		if(dValue<0.0)									// Negative Zahl
			{
			*pPtr='-';
			pPtr++;
			dVal=-dVal;
			}

		j = aFactors[iComma];

		dVal	*= (double)j;
		dVal	+= 0.4999999;
		uVal64	 =        (unsigned __int64)dVal;
		uComa64	 = uVal64%(unsigned __int64)j;
		uVal64  /=        (unsigned __int64)j;

		if(uVal64>0xFFFFFFFFl)
				_ui64tot(          uVal64,pPtr,10);
		else	_ultot  ((unsigned)uVal64,pPtr,10);

		i=(int)_tcslen(pPtr);

		if(i>12){memmove(pPtr+i-11,pPtr+i-12,13*sizeof(TCHAR));pPtr[i-12]=' ';i++;}
		if(i> 9){memmove(pPtr+i- 8,pPtr+i- 9,10*sizeof(TCHAR));pPtr[i- 9]=' ';i++;}
		if(i> 6){memmove(pPtr+i- 5,pPtr+i- 6, 7*sizeof(TCHAR));pPtr[i- 6]=' ';i++;}
		if(i> 3){memmove(pPtr+i- 2,pPtr+i- 3, 4*sizeof(TCHAR));pPtr[i- 3]=' ';i++;}

		iValK = (unsigned)uComa64+j;
		_itot(iValK,pPtr+i,10);

		pPtr[i]=(iComma>0)?'.':0;

		pWnd->GetWindowText(cText,sizeof(cText)/sizeof(TCHAR));

		if(_tcscmp(cStr,cText))							// Hat sich der Text verndert
			{
			pWnd->SetWindowText(cStr);
			}
		}


}



//*****************************************************************************
//*
//*		DDX_MiniMax
//*
//*****************************************************************************
//	Ermglicht den Datenaustauch zwischen einen Filter (iMin iMax iMode)
//	iMode == 0	Filter   aus (Bit 0 in iFlags muss auf 1 sein)
//	iMode == 1	Gleich      		 		*
//	iMode == 2	Unleich     		 		*
//	iMode == 3	Kleiner     		 		*
//	iMode == 4	Grer      		 		*
//	iMode == 5	Zwischen iMin und iMax		*
//	nIDC muss auf die erste ID der Gruppe zeigen dem iMin-Feld
//	Ist die folgende ID ein Static Fenster so wird der Name je nach
//  Modus zwischen "Wert :" bzw. "Von :" hin und her geschalten
//	Das nchste Fenster muss das iMax-Feld sein
//	Ist die folgende ID ein Static Fenster so wird der Name je nach
//  Modus zwischen " " bzw. "Bis :" hin und her geschalten
//	Das nchste Fenster ist das iMode-Feld es kann eine Gruppe aus Radio-Button's
//	Oder ein Dropdown-Listen-Feld sein
//	Fr alle Modi mssen die Bits in iFlags gesetzt sein
void AFXAPI DDX_MiniMax(CDataExchange *pDX,int nIDC,int &iMin,int &iMax,int &iMode,int iFlags)
{
HWND	hWnd,hMaxWnd,hMinWnd,hStatic1=0,hStatic2=0;
TCHAR	cBuffer[32];
int		i,iId,iVal;




	hMinWnd=hWnd=pDX->PrepareCtrl(nIDC);

	iVal=iMode;										// Mode korrigieren

	for(i=0;i<6 && iVal>0;i++)
		{
		if(~iFlags & (1<<i))iVal--;
		}
	if(iVal>5)iVal=0;


	if(pDX->m_bSaveAndValidate)						// Daten in Variabeln
		{
		::GetWindowText(hWnd,cBuffer,sizeof(cBuffer)/sizeof(TCHAR));
		iMin=_ttoi(cBuffer);

		iId  = ::GetWindowLong(hWnd, GWL_ID);
		hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);

		if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_STATIC)
			{
			hStatic1=hWnd;
			hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);
			}

		hMaxWnd=hWnd;
		::GetWindowText(hWnd,cBuffer,sizeof(cBuffer)/sizeof(TCHAR));
		iMax=_ttoi(cBuffer);
		hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);

		if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_STATIC)
			{
			hStatic2 = hWnd;
			hWnd     = ::GetWindow(hWnd,GW_HWNDNEXT);
			}

		iId=::GetWindowLong(hWnd, GWL_ID);
		if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_RADIOBUTTON)
				DDX_Radio  (pDX,iId,iVal);
		else	DDX_CBIndex(pDX,iId,iVal);
		}
	else{											// Date aus Variabeln holen
		_itot(iMin,cBuffer,10);
		::SetWindowText(hWnd,cBuffer);


		hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);

		if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_STATIC)
			{
			hStatic1 = hWnd;
			hWnd     = ::GetWindow(hWnd,GW_HWNDNEXT);
			}

		hMaxWnd=hWnd;
		_itot(iMax,cBuffer,10);
		::SetWindowText(hWnd,cBuffer);
		hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);

		if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_STATIC)
			{
			hStatic2=hWnd;
			hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);
			}

		iId=::GetWindowLong(hWnd, GWL_ID);
		if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_RADIOBUTTON)
				DDX_Radio  (pDX,iId,iVal);
		else	DDX_CBIndex(pDX,iId,iVal);
		}


	if(pDX->m_bSaveAndValidate)						// Mode korrigieren
		{
		if(iVal>5)iVal=5;
		for(i=0;i<6;i++)
			{
			if(iFlags & (1<<i))
				{
				   iVal--;
				if(iVal<0)break;
				}
			}
		if(i>5)i=0;
		iMode=i;
		}


	if(hStatic1)::SetWindowText(hStatic1,(iMode==5)? _T("Von :"):_T("Wert :"));
	if(hStatic2)::SetWindowText(hStatic2,(iMode==5)? _T("Bis :"):_T(""));

	EnableWindow(hMinWnd,iMode!=0);
	EnableWindow(hMaxWnd,iMode==5);

}

//*****************************************************************************
//*
//*		DDX_MiniMax
//*
//*****************************************************************************
//	Ermglicht den Datenaustauch zwischen einen Filter (iMin iMax iMode)
//	iMode == 0	Filter   aus (Bit 0 in iFlags muss auf 1 sein)
//	iMode == 1	Gleich      		 		*
//	iMode == 2	Unleich     		 		*
//	iMode == 3	Kleiner     		 		*
//	iMode == 4	Grer      		 		*
//	iMode == 5	Zwischen iMin und iMax		*
//	nIDC muss auf die erste ID der Gruppe zeigen dem iMin-Feld
//	Ist die folgende ID ein Static Fenster so wird der Name je nach
//  Modus zwischen "Wert :" bzw. "Von :" hin und her geschalten
//	Das nchste Fenster muss das iMax-Feld sein
//	Ist die folgende ID ein Static Fenster so wird der Name je nach
//  Modus zwischen " " bzw. "Bis :" hin und her geschalten
//	Das nchste Fenster ist das iMode-Feld es kann eine Gruppe aus Radio-Button's
//	Oder ein Dropdown-Listen-Feld sein
//	Fr alle Modi mssen die Bits in iFlags gesetzt sein
//	iComma ist die Anzahl der iComma stellen bei den Zahlen
void AFXAPI DDX_MiniMax(CDataExchange *pDX,int nIDC,double &iMin,double &iMax,int &iMode,int iComma,int iFlags)
{
HWND	hWnd,hMaxWnd,hMinWnd,hStatic1=0,hStatic2=0;
int		iId,i,iVal;



	hMinWnd=hWnd=pDX->PrepareCtrl(nIDC);

	iVal=iMode;								// Mode korrigieren
	for(i=0;i<6 && iVal>0;i++)
		{
		if(~iFlags & (1<<i))iVal--;
		}
	if(iVal>5)iVal=0;



	DDX_Float(pDX,nIDC,iMin,iComma);
	hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);

	if(::SendMessage(hWnd,WM_GETDLGCODE,0,0)& DLGC_STATIC)
		{
		hStatic1=hWnd;
		hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);
		}

	hMaxWnd=hWnd;
	iId=::GetWindowLong(hWnd, GWL_ID);
	DDX_Float(pDX,iId,iMax,iComma);
	hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);

	if(::SendMessage(hWnd,WM_GETDLGCODE,0,0)& DLGC_STATIC)
		{
		hStatic2=hWnd;
		hWnd = ::GetWindow(hWnd,GW_HWNDNEXT);
		}

	iId=::GetWindowLong(hWnd, GWL_ID);

	if(::SendMessage(hWnd, WM_GETDLGCODE,0,0)& DLGC_RADIOBUTTON)
			DDX_Radio  (pDX,iId,iVal);
	else	DDX_CBIndex(pDX,iId,iVal);



	if(pDX->m_bSaveAndValidate)				// Mode korrigieren
		{
		if(iVal>5)iVal=5;
		for(i=0;i<6;i++)
			{
			if(iFlags & (1<<i))
				{
				   iVal--;
				if(iVal<0)break;
				}
			}
		if(i>5)i=0;
		iMode=i;
		}

	if(hStatic1)::SetWindowText(hStatic1,(iMode==5)? _T("Von :"):_T("Wert :"));
	if(hStatic2)::SetWindowText(hStatic2,(iMode==5)? _T("Bis :"):_T(""));

	EnableWindow(hMinWnd,iMode!=0);
	EnableWindow(hMaxWnd,iMode==5);
}


//*****************************************************************************
//*
//*		scantext
//*
//*****************************************************************************
static int scantext(LPCTSTR pText,LPTSTR pScan,int iMax)
{
int		iPos;


	iMax<<=3;

	for(iPos=0;iPos<iMax;pText++)
		{
		if(*pText==0)break;
		if(*pText==' ' || *pText=='\n' || *pText==':' || *pText==',' || *pText=='/' ||
		   *pText=='*' || *pText=='\t' || *pText=='.' || *pText==';' || *pText=='-' )
			{
			iPos+= 7;
			iPos&=~7;
			pScan[iPos]=0;
			continue;
			}

		pScan[iPos]=*pText;iPos++;
		pScan[iPos]=0;
		}


return (iPos+7)>>3;
}


//*****************************************************************************
//*
//*		monthtoi
//*
//*****************************************************************************
static  LPCTSTR aDayStr [ 8]={_T("Mo "),_T("Di "),_T("Mi "),_T("Do "),_T("Fr "),_T("Sa "),_T("So "),_T("?? ")};
static  LPCTSTR aDayEng [ 8]={_T("Mo "),_T("Tu "),_T("We "),_T("Th "),_T("Fr "),_T("Sa "),_T("So "),_T("?? ")};
static	LPCTSTR aDateStr[16]={_T("??? "),_T("Jan."),_T("Feb."),_T("Mrz "),_T("April "),_T("Mai "),_T("Juni "),_T("Juli "),
							  _T("Aug."),_T("Sep."),_T("Okt."),_T("Nov." ),_T("Dez."  ),_T("??? "),_T("??? " ),_T("??? " )};
static	LPCTSTR aDateEng[16]={_T("??? "),_T("Jan."),_T("Feb."),_T("March"),_T("April "),_T("May "),_T("June "),_T("July "),
							  _T("Aug."),_T("Seb."),_T("Oct."),_T("Nov." ),_T("Dec."  ),_T("??? "),_T("??? " ),_T("??? " )};
int AFXAPI monthtoi(LPCTSTR pText)
{
int		i,iNum,iBits,iCount;
TCHAR	c,d,e;


	   i=_ttoi(pText);
	if(i)return i;

	while(*pText==' ')pText++;

	iBits  = 0;
	iCount = 12;

	for(i=0;i<3;i++)
		{
		for(iNum=11;iNum>=0;iNum--)
			{
			if(iBits&(1<<iNum))continue;

			c=pText           [i];
			d=aDateStr[iNum+1][i];
			e=aDateEng[iNum+1][i];

			if(c>='A' && c<='Z')c+=32;
			if(d>='A' && d<='Z')d+=32;
			if(e>='A' && e<='Z')e+=32;

			if(c!=d && c!=e)
				{
				iBits|=1<<iNum;
				   iCount--;
				if(iCount<=1)break;
				}
			}

		if(iCount<=1)break;
		}

	for(iNum=11;iNum>=0;iNum--)
		{
		if(!(iBits&(1<<iNum)))break;
		}


return iNum+1;
}


//*****************************************************************************
//*
//*		weekday
//*
//*****************************************************************************
static int weekday(int iDay,int iMonth,int iYear)
{
static	int		aMonthLen[]={0,31,28,31,30,31,30,31,31,30,31,30,31};
int				i,j;


	iMonth &=0x0F;
	iDay   &=0x1F;

	i =  4;								// Start-iDay  1.Jan.0000 = Fr
	i+=  iYear;							// Jedes iYear ein iDay mehr
	i+=((iYear+3)>>2);					// Jedes Schaltjahr ein iDay mehr
	i%=7;

	for(j=1;j<iMonth;j++)
		{
		i+=aMonthLen[j];
		if((j==2)&&!(iYear&3))i++;       // Februar mit 29 Tagen
		i%=7;
		}

	i+=iDay-1;
	i%=7;

return(i);
}

//*****************************************************************************
//*
//*		strtodate
//*
//*****************************************************************************
//	Wandelt eine Zeichenfolge in ein Datum um
//	Format	1.Aug.2000 oder Di 14.Mai.1999  oder Di 14.3.99
//	Ist die Angabe nicht vollstndig so werden die aktuellen Daten eingefgt
//	Jahres Zahlen kleiner 30 werden auf 2000 erweitert
//	Jahres Zahlen grer  30 und kleiner 100 werden auf 1900 erweitert
//	Eine Wochentag angabe wird bersprungen
//	Ergibt wie viele Angaben gefunden wurden
//		0	: Keine
//		1	: Tag
//		2	: Tag und Monat
//		3	: Tag und Monat und Jahr
int AFXAPI strtodate(LPCTSTR pText,DBDATE &sDate)
{
TCHAR	cText[4*8+2];
int		iNum,i,j;


	iNum = scantext(pText,cText,4);

	if(*cText<'0' || *cText>'9')				// Wochentag berspringen
		{
		memmove(cText,cText+8,(sizeof(cText)-8)/sizeof(TCHAR));
		iNum--;
		}

	if(iNum<3)									// Aktuelles Datum benutzen
		{
		time_t	    iTime;
		struct  tm *pTime;

		iTime = time(0);
		pTime = localtime(&iTime);

		sDate.day   = pTime->tm_mday;
		sDate.month = pTime->tm_mon;
		sDate.year  = pTime->tm_year+1900;
		}

	if(iNum==2)									// Englisches Format ? MM-DD
	if(cText[0]< '0' || cText[0]> '9')
	if(cText[8]>='0' && cText[8]<='9')
		{
		memcpy(cText+8*3,cText+8*0,8*sizeof(TCHAR));
		memcpy(cText+8*0,cText+8*1,8*sizeof(TCHAR));
		memcpy(cText+8*1,cText+8*3,8*sizeof(TCHAR));
		}

	if(iNum>=1)
		{
		i = _ttoi(cText+0*8);

		if(i>=1000 && iNum>=3)					// Englisches Format ? YYYY-MM-DD
			{
			   j =_ttoi(cText+2*8);
			if(j<=31)
				{
				memcpy(cText+2*8,cText+0*8,8*sizeof(TCHAR));
				i=j;
				}
			}

		sDate.day = i&0x1F;
		}

	if(iNum>=2)
		{
		i = monthtoi(cText+1*8);

		if(iNum==2)								// Englisches Format ? YYYY-MM-DD
		if(i>12 && sDate.day<=12)
			{
			j = i;
			i =	sDate.day;
			sDate.day = j&0x1F;
			}

		sDate.month = i&0x0F;
		}

	if(iNum>=3)
		{
		i=_ttoi(cText+2*8);
		if(i<100)i+=(i<30)? 2000:1900;
		sDate.year=i;
		}



return (iNum>3)? 3:iNum;
}

//*****************************************************************************
//*
//*		datetostr
//*
//*****************************************************************************
//	Wandelt ein Datum in eine Zeichenfolge um
//	pText	: Ist der Zeiger auf Puffer fr die Zeichenfolge.
//			  Der Puffer sollte mindestens 16 Byte lang sein.
//	sData	: Ist die Datumsangabe, die in einem Text umgewandelt werden soll.
//	iMode	: Ist dieser Wert ungleich 0, so wird der Wochentag an den Anfang
//			  des Textes gestellt.
//	Ergibt die Lnger der Zeichenfolge
int AFXAPI datetostr(LPTSTR pText,DBDATE &sDate,int iMode)
{
TCHAR	*pPtr;
int		 i;


	pPtr=pText;

	if(iMode&1)												// Wochentag anhngen
		{
		i=weekday(sDate.day,sDate.month,sDate.year);
		_tcscpy(pPtr,(iMode&2)? aDayEng[i]:aDayStr[i]);
		pPtr+=3;
		}

	_itot(sDate.day,pPtr,10);								// Tag
	pPtr+=_tcslen(pPtr);
	pPtr[0]='.';pPtr++;
	if(iMode&2)
		{
		_tcscpy(pPtr,aDateStr[sDate.month&0x0F]);			// Monatsname
		}
	else{
		_tcscpy(pPtr,aDateEng[sDate.month&0x0F]);			// Monatsname
		}

	pPtr+=_tcslen(pPtr);
	_itot(sDate.year,pPtr,10);
	pPtr+=_tcslen(pPtr);


return (int)(pPtr-pText);
}

//*****************************************************************************
//*
//*		strtotime
//*
//*****************************************************************************
//	Wandelt eine Zeichenfolge cText eine Zeit um
//	iPos ist die Position an der die Zeit steht (Wort-Nummer)
//	Format	HH:MM:SS
//	Ergibt wie viele Angaben gefunden wurden
//		0	: Keine
//		1	: Stunden
//		2	: Minuten
//		3	: Sekunden
int AFXAPI strtotime(LPCTSTR pText,DBTIME &sTime,int iPos)
{
TCHAR	cText[7*8+2],*pPtr;
int		iNum;




	iNum  = scantext(pText,cText,7);
	pPtr  = cText+8*iPos;
	iNum -= iPos;

	if(iNum<3)													// Aktuelle Zeit verwenden
		{
		time_t		iTime;
		struct tm  *pTime;

		iTime = time(0);
		pTime = localtime(&iTime);

		sTime.hour   = pTime->tm_hour;
		sTime.minute = pTime->tm_min;
		sTime.second = pTime->tm_sec;
		}


	if(iNum>=1)sTime.hour  =_ttoi(pPtr+0*8)%24;
	if(iNum>=2)sTime.minute=_ttoi(pPtr+1*8)%60;
	if(iNum>=3)sTime.second=_ttoi(pPtr+2*8)%60;



return (iNum>3)? 3:iNum;
}

//*****************************************************************************
//*
//*		timetostr
//*
//*****************************************************************************
//	Wandelt eine Zeit in ein Zeichenfolge um
//	Ist iMode !=0 werden keine Sekunden angezeigt
//	pText sollte mindestens 9 Byte gro sein
//	Ergibt die Lnge der Zeichenfolge
int AFXAPI timetostr(LPTSTR pText,DBTIME &sTime,int iMode)
{

	pText[0] = '0'+sTime.hour/10;
	pText[1] = '0'+sTime.hour%10;
	pText[2] = ':';
	pText[3] = '0'+sTime.minute/10;
	pText[4] = '0'+sTime.minute%10;
	pText[5] = (iMode)? 0:':';
	pText[6] = '0'+sTime.second/10;
	pText[7] = '0'+sTime.second%10;
	pText[8] =  0;

return (iMode)? 5:8;
}


//*****************************************************************************
//*
//*		DDX_Date
//*
//*****************************************************************************
//	Speichert/holt ein Datum aus einer DBDATE Struktur
//	Mode	= Wochentag anzeigen
void AFXAPI DDX_Date  (CDataExchange *pDX,int nIDC,DBDATE &sDate,int iMode)
{
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
TCHAR	cText[32];




	if (pDX->m_bSaveAndValidate)								// Datum setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		cText[sizeof(cText)/sizeof(TCHAR)-1]=0;
		strtodate(cText,sDate);
		}
	else{														// Datum holen
		datetostr(cText,sDate,iMode);
		TCHAR cTemp[32];	    ::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}




//*****************************************************************************
//*
//*		DDX_Date
//*
//*****************************************************************************
//	Speichert/holt ein Datum aus einer DBTIMESTAMP Struktur
//	iMode	= Wochentag anzeigen
void AFXAPI DDX_Date(CDataExchange *pDX,int nIDC,DBTIMESTAMP &sDateTime,int iMode)
{
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
DBDATE	sDate;
TCHAR	cText[32];
TCHAR	cTemp[32];



	if (pDX->m_bSaveAndValidate)								// Datum setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		strtodate(cText,sDate);

		sDateTime.day   = sDate.day;
		sDateTime.month = sDate.month;
		sDateTime.year  = sDate.year;
		}
	else{														// Datum holen
		sDate.day   = sDateTime.day;
		sDate.month = sDateTime.month;
		sDate.year  = sDateTime.year;

		datetostr(cText,sDate,iMode);
		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}


//*****************************************************************************
//*
//*		DDX_Date
//*
//*****************************************************************************
//	Speichert/holt ein Datum aus einer CTime Klasse
//	Mode	= Wochentag anzeigen
void AFXAPI DDX_Date(CDataExchange *pDX,int nIDC,CTime &sDateTime,int sMode)
{
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
DBDATE	sDate;
TCHAR	cText[32];
TCHAR	cTemp[32];



	if (pDX->m_bSaveAndValidate)								// Datum setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		strtodate(cText,sDate);

		sDateTime=CTime(sDate.year, sDate.month, sDate.day,
						sDateTime.GetHour(),sDateTime.GetMinute(),sDateTime.GetSecond());
		}
	else{														// Datum holen
		sDate.day   = sDateTime.GetDay();
		sDate.month = sDateTime.GetMonth();
		sDate.year  = sDateTime.GetYear();

		datetostr(cText,sDate,sMode);
		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}

}

//*****************************************************************************
//*
//*		DDX_Time
//*
//*****************************************************************************
//	Speichert/holt eine Zeit aus einer CTime Klasse
//	iMode	= Sekunden nicht anzeigen
void AFXAPI DDX_Time(CDataExchange *pDX,int nIDC,CTime &sDateTime,int iMode)
{
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
DBTIME	sTime;
TCHAR	cTemp[32];
TCHAR	cText[32];



	if(pDX->m_bSaveAndValidate)			// Zeit setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		cText[sizeof(cText)/sizeof(TCHAR)-1]=0;

		strtotime(cText,sTime,0);
		if(iMode)sTime.second=0;

		sDateTime=CTime(	sDateTime.GetYear(), sDateTime.GetMonth(), sDateTime.GetDay(),
						sTime.hour,			sTime.minute,		 sTime.second);
		}
	else{								// Zeit holen
		sTime.hour   = sDateTime.GetHour();
		sTime.minute = sDateTime.GetMinute();
		sTime.second = sDateTime.GetSecond();
		timetostr(cText,sTime,iMode);
		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}

//*****************************************************************************
//*
//*		DDX_Time
//*
//*****************************************************************************
//	Speichert/holt eine Zeit aus einer DBTIME	Struktur
//	Mode	= Sekunden nicht anzeigen
void AFXAPI DDX_Time(CDataExchange *pDX,int nIDC,DBTIME &Time,int Mode)
{
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
TCHAR	cText[32];
TCHAR	cTemp[32];




	if (pDX->m_bSaveAndValidate)		// Zeit setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		cText[sizeof(cText)/sizeof(TCHAR)-1]=0;
		strtotime(cText,Time,0);
		if(Mode)Time.second=0;
		}
	else{								// Zeit holen
		timetostr(cText,Time,Mode);
		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}



//*****************************************************************************
//*
//*		DDX_Time
//*
//*****************************************************************************
//	Speichert/holt eine Zeit aus einer DBTIMESTAMP	Struktur
//	iMode	= Sekunden nicht anzeigen
void AFXAPI DDX_Time(CDataExchange *pDX,int nIDC,DBTIMESTAMP &sDateTime,int iMode)
{
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
DBTIME	sTime;
TCHAR	cTemp[32];
TCHAR	cText[32];




	if (pDX->m_bSaveAndValidate)		// Zeit setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		cText[sizeof(cText)/sizeof(TCHAR)-1]=0;

		strtotime(cText,sTime,0);
		if(iMode)sTime.second=0;

		sDateTime.hour   = sTime.hour;
		sDateTime.minute = sTime.minute;
		sDateTime.second = sTime.second;
		sDateTime.fraction=0;
		}
	else{								// Zeit holen
		sTime.hour   = sDateTime.hour;
		sTime.minute = sDateTime.minute;
		sTime.second = sDateTime.second;
		timetostr(cText,sTime,iMode);
		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}


//*****************************************************************************
//*
//*		DDX_TStamp
//*
//*****************************************************************************
//	Speichert/holt eine Datum/Zeit aus einer CTime Klase
//	iMode&1	= Sekunden nicht anzeigen
//	iMode&2	= Wochentag anzeigen
//	iMode&4	= Monate in Englisch
void AFXAPI DDX_TStamp(CDataExchange *pDX,int nIDC,CTime &sDateTime,int iMode)
{
TCHAR  *pPtr;
TCHAR	cTemp[32];
TCHAR	cText[32];
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
DBDATE	sDate;
DBTIME	sTime;
int		iNum;




	if (pDX->m_bSaveAndValidate)		// Datum setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		cText[sizeof(cText)/sizeof(TCHAR)-1]=0;


		pPtr=cText;
		while(*pPtr==' ')pPtr++;
		iNum=(*pPtr<'0' || *pPtr>'9')? 1:0;

		strtodate(pPtr,sDate);
		strtotime(pPtr,sTime,3+iNum);
		if(iMode&1)sTime.second=0;

		sDateTime=CTime(	sDate.year, sDate.month,  sDate.day,
						sTime.hour, sTime.minute,	sTime.second);

		}
	else{								// Datum holen
		sTime.hour   = sDateTime.GetHour();
		sTime.minute = sDateTime.GetMinute();
		sTime.second = sDateTime.GetSecond();
		sDate.day    = sDateTime.GetDay();
		sDate.month  = sDateTime.GetMonth();
		sDate.year   = sDateTime.GetYear();

		iNum=datetostr(cText,sDate,iMode>>1);
		cText[iNum]=' ';iNum++;
		cText[iNum]=' ';iNum++;
		timetostr(cText+iNum,sTime,iMode&1);

		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}

//*****************************************************************************
//*
//*		DDX_TStamp
//*
//*****************************************************************************
//	Speichert/holt eine Datum/Zeit aus einer DBTIMESTAMP Struktur
//	iMode&1	= Sekunden nicht anzeigen
//	iMode&2	= Wochentag anzeigen
//	iMode&4	= Monate in Englisch
void AFXAPI DDX_TStamp(CDataExchange *pDX,int nIDC, DBTIMESTAMP	&sDateTime,int iMode)
{
TCHAR  *pPtr;
TCHAR	cText[32];
TCHAR	cTemp[32];
HWND	hWndCtrl = pDX->PrepareCtrl(nIDC);
DBDATE	sDate;
DBTIME	sTime;
int		iNr;




	if (pDX->m_bSaveAndValidate)		// Datum setzen
		{
		::GetWindowText(hWndCtrl,cText,sizeof(cText)/sizeof(TCHAR));
		cText[sizeof(cText)/sizeof(TCHAR)-1]=0;

		pPtr=cText;
		while(*pPtr==' ')pPtr++;
		iNr=(*pPtr<'0' || *pPtr>'9')? 1:0;

		strtodate(pPtr,sDate);
		sDateTime.day   = sDate.day;
		sDateTime.month = sDate.month;
		sDateTime.year  = sDate.year;

		strtotime(pPtr,sTime,3+iNr);
		if(iMode&1)sTime.second=0;

		sDateTime.hour   = sTime.hour;
		sDateTime.minute = sTime.minute;
		sDateTime.second = sTime.second;
		sDateTime.fraction=0;
		}
	else{								// Datum holen

		sDate.day   = sDateTime.day;
		sDate.month = sDateTime.month;
		sDate.year  = sDateTime.year;
		iNr=datetostr(cText,sDate,iMode>>1);

		cText[iNr]=' ';iNr++;
		cText[iNr]=' ';iNr++;

		sTime.hour   = sDateTime.hour;
		sTime.minute = sDateTime.minute;
		sTime.second = sDateTime.second;
		timetostr(cText+iNr,sTime,iMode&1);

		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cText,cTemp))::SetWindowText(hWndCtrl,cText);
		}
}


//*****************************************************************************
//*
//*		DDX_Text_
//*
//*****************************************************************************
void AFXAPI DDX_Text_(CDataExchange *pDX,int nIDC,int &iValue)
{
HWND	hWndCtrl = pDX->PrepareEditCtrl(nIDC);
TCHAR	cTemp[32];
TCHAR	cStr [32];


	if (pDX->m_bSaveAndValidate)
		{
		::GetWindowText(hWndCtrl,cStr,sizeof(cStr)/sizeof(TCHAR));
		iValue=_ttoi(cStr);
		}
		else
		{
		_itot(iValue,cStr,10);

		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cStr,cTemp))::SetWindowText(hWndCtrl,cStr);
		}

}

//*****************************************************************************
//*
//*		DDX_Text_
//*
//*****************************************************************************
void AFXAPI DDX_Text_(CDataExchange *pDX,int nIDC,unsigned &uValue)
{
HWND	hWndCtrl = pDX->PrepareEditCtrl(nIDC);
TCHAR	cTemp[32];
TCHAR	cStr [32];


	if (pDX->m_bSaveAndValidate)
		{
		::GetWindowText(hWndCtrl,cStr,sizeof(cStr)/sizeof(TCHAR));
		uValue=_ttoi(cStr);
		}
		else
		{
		_itot(uValue,cStr,10);

		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(cStr,cTemp))::SetWindowText(hWndCtrl,cStr);
		}

}

//*****************************************************************************
//*
//*		DDX_Text
//*
//*****************************************************************************
void AFXAPI DDX_Text_(CDataExchange *pDX, int nIDC,LPTSTR pText,int iMax)
{
HWND	hWndCtrl = pDX->PrepareEditCtrl(nIDC);
TCHAR	cTemp[260];


	if (pDX->m_bSaveAndValidate)
		{
		::GetWindowText(hWndCtrl, pText, iMax);
		}
	else{
		::GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));
		if(_tcscmp(pText,cTemp))::SetWindowText(hWndCtrl,pText);
		}

}

//*****************************************************************************
//*
//*		DDX_Text
//*
//*****************************************************************************
//	Holt den Text aus einer ComboBox und bercksichtig dabei das List-Feld
//	Achtung: Wenn ein Eintrag einer aus dem List-Feld war, und dann der
//	Text extrahiert wurde wird weiterhin der Text aus dem List-Feld genommen.
//	Lsung: Bei CBN_EDITCHANGE muss der Eintrag auf -1 gesetzt mit ComboBoxChange.
void AFXAPI DDX_ComboEx(CDataExchange *pDX, int nIDC,CString &sText)
{
HWND		hWndCtrl = pDX->PrepareEditCtrl(nIDC);
TCHAR		cTemp[1024];
int			iNum,iLen;



	iNum   = (int)SendMessage(hWndCtrl,CB_GETCURSEL,0,0);

	if(!pDX->m_bSaveAndValidate)
		{
		if(iNum>=0)
			{
			iLen = (int)SendMessage(hWndCtrl,CB_GETLBTEXTLEN,iNum,0);

			if(iLen<sizeof(cTemp)/sizeof(TCHAR))
				{
				SendMessage(hWndCtrl,CB_GETLBTEXT,iNum,(LPARAM)cTemp);
				}
			else{
				_tcsncpy(cTemp,sText,sizeof(cTemp)/sizeof(TCHAR));
				cTemp[sizeof(cTemp)/sizeof(TCHAR)-1]=0;
				}

			if(sText!=cTemp)
				{
//				SendMessage  (hWndCtrl,CB_SETCURSEL,-1,0);
				SetWindowText(hWndCtrl,sText);
				}
			}
		else{
			GetWindowText(hWndCtrl,cTemp,sizeof(cTemp)/sizeof(TCHAR));

			if(sText!=cTemp)
				{
				SetWindowText(hWndCtrl,sText);
				}
			}
		}
	else{
		if(iNum>=0)
			{
			iLen = (int)SendMessage(hWndCtrl,CB_GETLBTEXTLEN,iNum,0);
			SendMessage(hWndCtrl,CB_GETLBTEXT,iNum,(LPARAM)(sText.GetBuffer(iLen+1)));
			sText.ReleaseBuffer(iLen);
			}
		else{
			iLen = GetWindowTextLength(hWndCtrl);
			       GetWindowText      (hWndCtrl,sText.GetBuffer(iLen+1),iLen+1);
			sText.ReleaseBuffer(iLen);
			}
		}


}


//*****************************************************************************
//*
//*		SendNotify
//*
//*****************************************************************************
//	Sendet eine WM_NOTIFY Nachricht an das Elternfenster
//	pData		: Zeiger auf die Fensterdaten
//	pNotify		: Zeiger auf die Notify-Daten
//	Ergibt den Rckgabewert der WM_NOTIFY Nachrich
static LRESULT SendNotify(HWND hWnd,NMHDR *pNotify)
{
LRESULT		lRet;


	pNotify->hwndFrom	= hWnd;
    pNotify->idFrom		= GetWindowLong(hWnd,GWL_ID);

	lRet = SendMessage(GetParent(hWnd),WM_NOTIFY,pNotify->idFrom,(LPARAM)pNotify);

	if(pNotify->idFrom==0x12345678)lRet=1;


return lRet;
}


//*****************************************************************************
//*
//*		ComboBoxChange
//*
//*****************************************************************************
//	Gleicht den Wechsel beim ndern einer ComboBox aus (von >=0 auf -1)
//	pCombo	: Ist die ComboBox
void AFXAPI ComboBoxChange(CComboBox *pCombo)
{
CString		sText;
unsigned 	uCursor;
int			iSel;



	   iSel = pCombo->GetCurSel();
	if(iSel==-1)return;

	uCursor = pCombo->GetEditSel();
			  pCombo->GetWindowText(sText);
			  pCombo->SetWindowText(sText);
			  pCombo->SetEditSel(uCursor&0xFFFF,uCursor>>16);

}

//*****************************************************************************
//*
//*		SubclassInit
//*
//*****************************************************************************
//	Initalisiert die Werte fr die Subclass-Funktionen.
static void SubclassInit()
{
WNDCLASS	sClass;
	

	GetClassInfo(NULL,_T("EDIT"),&sClass);
	pOldEditProc   = sClass.lpfnWndProc;

	GetClassInfo(NULL,_T("COMBOBOX"),&sClass);
	pOldCBoxProc   = sClass.lpfnWndProc;

	wSubclassAtom  = GlobalAddAtomW(L"CeData");

}


//*****************************************************************************
//*
//*		SCProcCb1E
//*
//*****************************************************************************
//	Speichert bei WM_KILLFOCUS die Cursorposition in GWL_ID in einem Editfenster.
//	Leitet die WM_KILLFOCUS  und WM_SETFOCUS Nachrichten weiter (EN_???FOCUS)
LRESULT __stdcall SCProcCb1E(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
HWND	hParent,hDlg;
WNDPROC pOldProc;
int		iId;


	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);
	

	if(uMsg==WM_ATTACH)								// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb1E)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb1E);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)								// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_KILLFOCUS)							// Cursor-Position in Id speichern
		{
		if(hParent=GetParent(hWnd))
			{
			iId=GetWindowLong(hParent,GWL_ID);
			if(hDlg=GetParent(hParent))
				{
				SendMessage(hDlg,WM_COMMAND,MAKELONG(iId,EN_KILLFOCUS),(LPARAM)hWnd);
				}
			}

		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);
		iId=(int)CallWindowProc(pOldProc,hWnd,EM_GETSEL,0,0);
		SetWindowLong(hWnd,GWL_ID,iId);
		}

	if(uMsg==WM_SETFOCUS)							// Cursor-Position in Id speichern
		{
		if(hParent=GetParent(hWnd))
			{
			iId=GetWindowLong(hParent,GWL_ID);
			if(hDlg=GetParent(hParent))
				{
				SendMessage(hDlg,WM_COMMAND,MAKELONG(iId,EN_SETFOCUS),(LPARAM)hWnd);
				}
			}
		}

	
	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb1
//*
//*****************************************************************************
//	Liest die Cursorposition aus GWL_ID des Edit Fensters aus
//	Leitet Farbe-Einstellungen fr das Edit-Fenster weiter
LRESULT __stdcall SCProcCb1(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC pOldProc;
HWND	hParent;
HWND	hTemp;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)								// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb1)
			{
			pOldProc = pOldCBoxProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb1);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return SCProcCb1E(GetWindow(hWnd,GW_CHILD),WM_ATTACH,0,0);
		}


	if(uMsg==WM_DETACH)								// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_CTLCOLOREDIT)						// Farbgebung weiter leiten an ComboBox
		{
		hParent  = GetParent(hWnd);
		pOldProc = (WNDPROC)GetWindowLongPtr(hParent,GWL_WNDPROC);
		
		return CallWindowProc(pOldProc,hParent,uMsg,wParam,(LPARAM)hWnd);
		}


	if(uMsg==CB_GETEDITSEL)							// Cursorposition abfragen
		{
		hTemp = GetWindow(hWnd,GW_CHILD);
		if(GetFocus()!=hTemp)
		if(GetFocus()!=hWnd)
			{
			return GetWindowLong(hTemp,GWL_ID);
			}
		}


	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb2E
//*
//*****************************************************************************
//	TAB+ENTER an Eltern Fenster weiterleiten
LRESULT __stdcall SCProcCb2E(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC			pOldProc;
NMKEY			sHeader;
static WPARAM	wLast;
HWND			hBox;
LRESULT			lRet;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

	
	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb2E)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb2E);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg>=WM_KEYFIRST && uMsg<=WM_KEYLAST)	// Tastennachrichten
		{
		if(uMsg!=WM_KEYDOWN && wLast==wParam)
			{
			return 0;
			}

		if(wParam==VK_TAB || wParam==VK_RETURN)
			{
			hBox					= GetParent(hWnd);
			sHeader.hdr.hwndFrom	= hBox;
			sHeader.hdr.code		= (wParam==VK_RETURN)? NM_RETURN:NM_KEYDOWN;
			sHeader.hdr.idFrom		= GetWindowLong(hBox,GWL_ID);
			sHeader.nVKey			= (UINT)wParam;
			sHeader.uFlags			= (UINT)lParam;


			lRet = SendMessage(hBox,CB_SHOWDROPDOWN,FALSE,0);
			lRet = SendMessage(GetParent(hBox),WM_NOTIFY,sHeader.hdr.idFrom,(LPARAM)&sHeader);

			if(lRet)
				{
				wLast = wParam;
				return 0;
				}

			wLast = 0;
			}

		if(wParam==VK_DOWN)
			{
			hBox = GetParent(hWnd);

				lRet = SendMessage(hBox,CB_GETDROPPEDSTATE,0,0);
			if(!lRet)
				{
				   lRet = SendMessage(hBox,CB_GETCOUNT,0,0);
				if(lRet>0)
					{
					lRet = SendMessage(hBox,CB_SHOWDROPDOWN,TRUE,0);
					return 0;
					}
				}
			}
		}

	
	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb2
//*
//*****************************************************************************
//	TAB+ENTER an Eltern Fenster weiterleiten
LRESULT __stdcall SCProcCb2(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC			pOldProc;
NMKEY			sHeader;
static WPARAM	wLast;
LRESULT			lRet;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb2)
			{
			pOldProc = pOldCBoxProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb2);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return SCProcCb2E(GetWindow(hWnd,GW_CHILD),WM_ATTACH,0,0);
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg>=WM_KEYFIRST && uMsg<=WM_KEYLAST)	// Tastennachrichten
		{
		if(uMsg!=WM_KEYDOWN && wLast==wParam)
			{
			return 0;
			}

		if(wParam==VK_TAB)
			{
			sHeader.hdr.hwndFrom	= hWnd;
			sHeader.hdr.code		= NM_KEYDOWN;
			sHeader.hdr.idFrom		= GetWindowLong(hWnd,GWL_ID);
			sHeader.nVKey			= (UINT)wParam;
			sHeader.uFlags			= (UINT)lParam;

			lRet = SendMessage(hWnd,CB_SHOWDROPDOWN,FALSE,0);
			lRet = SendMessage(GetParent(hWnd),WM_NOTIFY,sHeader.hdr.idFrom,(LPARAM)&sHeader);

			if(lRet)
				{
				wLast = wParam;
				return 0;
				}

			wLast = 0;
			}

		if(wParam==VK_DOWN)
			{
				lRet = SendMessage(hWnd,CB_GETDROPPEDSTATE,0,0);
			if(!lRet)
				{
				   lRet = SendMessage(hWnd,CB_GETCOUNT,0,0);
				if(lRet>0)
					{
					lRet = SendMessage(hWnd,CB_SHOWDROPDOWN,TRUE,0);
					return 0;
					}
				}
			}
		}

	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb3E
//*
//*****************************************************************************
//	Weiterleiten von WM_SETTEXT Nachrichten zu einem anderen EDIT-Fenster
LRESULT __stdcall SCProcCb3E(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
TCHAR			cText[1024];
WNDPROC			pOldProc;
NMKEY			sNotify;
HWND			hParent;
HWND			hCombo;
HWND			hEdit;
LRESULT			lRet;
UINT			uId;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb3E)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb3E);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_SETTEXT)						// Nachrichten zu Edit-Fenster weiterleiten
		{
			lRet = CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
		if(!lRet)return lRet;

		hCombo  = GetParent    (hWnd);
		hParent = GetParent    (hCombo);
		uId	    = GetWindowLong(hCombo,GWL_ID);
		hEdit   = GetDlgItem   (hParent,uId^0x5555);

		SendMessage(hEdit,WM_GETEDITTEXT,1024,(LPARAM)cText);
		cText[sizeof(cText)-1] = 0;

		if(_tcscmp(cText,(LPCTSTR)lParam))		// Hat sich der Text verndert
			{
			SendMessage(hEdit,WM_SETEDITTEXT,0,lParam);
			SendMessage(hParent,WM_COMMAND,MAKELONG(uId,EN_CHANGE),(LPARAM)hCombo);
			}

		return lRet;
		}


	if(uMsg==WM_KEYDOWN)						// Key-Down abfangen
		{
		sNotify.hdr.code	= NM_KEYDOWN;
		sNotify.nVKey		= wParam;
		sNotify.uFlags		= lParam;

		if(SendNotify(hWnd,&sNotify.hdr))return 0;
		}


return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb3
//*
//*****************************************************************************
//	ComboBox verhlt sich wie Edit-Control.
//	Fallengelassene Dateien werden als Text eingetragen
LRESULT __stdcall SCProcCb3(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
static const WORD	aSubList[]={EN_CHANGE,EN_CORRECTTEXT,EN_DROPFILES,EN_ERRSPACE,EN_KILLFOCUS,EN_MAXTEXT,EN_SELCHANGE,EN_SETFOCUS,EN_STOPNOUNDO,EN_UPDATE,EN_VSCROLL,EN_HSCROLL};
WNDPROC				pOldProc;
LPNMHDR				pNotify;
WORD				uSubCmd;
HWND				hParent;
NMKEY				sNotify;
HWND				hItem;
HWND				hEdit;
UINT				uMyId;
UINT				uPos;
LRESULT				lRet;
LRESULT				lMax;




	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb3)
			{
			pOldProc = pOldCBoxProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb3);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return SCProcCb3E(GetWindow(hWnd,GW_CHILD),WM_ATTACH,0,0);
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_COMMAND)						// Nachricht von Edit-Fenster
		{
		uSubCmd = HIWORD(wParam);

		for(uPos=0;uPos<sizeof(aSubList)/sizeof(aSubList[0]);uPos++)
			{
			if(uSubCmd!=aSubList[uPos])continue;

			   hEdit = GetWindow(hWnd,GW_CHILD);
			if(hEdit!=(HWND)lParam)break;

			uMyId	= GetWindowLong(hWnd,GWL_ID);
			hParent = GetParent(hWnd);
			lRet	= CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);

			wParam &= ~0xFFFF;
			wParam |= uMyId;
			SendMessage(hParent,uMsg,wParam,lParam);

			if(uSubCmd!=EN_CHANGE)				// Text im parallel Fenster setzen
				{
				return lRet;
				}

				hItem = GetDlgItem(hParent,uMyId^0x5555);
			if(!hItem)return lRet;				// Gibt es ein parallel Fenster

			TCHAR	cText[MAX_PATH];

			cText[0] = 0;

			SendMessage(hEdit,WM_GETTEXT,MAX_PATH,(LPARAM)cText);
			SendMessage(hItem,WM_SETEDITTEXT,0   ,(LPARAM)cText);

			uMyId	= GetWindowLong(hEdit,GWL_ID);
			CallWindowProc(pOldProc,hWnd,WM_COMMAND,MAKELONG(uMyId,EN_CHANGE),(LPARAM)hEdit);

			return lRet;
			}
		}


	if(uMsg==WM_NOTIFY)							// Notify-Nachrichten von Edit weiterleiten
		{
		hEdit = GetWindow(hWnd,GW_CHILD);

		   pNotify = (LPNMHDR)lParam;
		if(pNotify && pNotify->hwndFrom==hEdit)
			{
			hParent = GetParent(hWnd);
			lRet	= CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
					  SendMessage   (hParent      ,uMsg,wParam,lParam);

			return lRet;
			}
		}



	if(uMsg>=0x00B0 && uMsg<=0x00D9)			// Nachrichten zu Edit-Fenster weiterleiten
		{
		hEdit = GetWindow(hWnd,GW_CHILD);
		return SendMessage(hEdit,uMsg,wParam,lParam);
		}



	if(uMsg==WM_SETTEXT)						// Text-Setzen zu Edit-Fenster weiterleiten
		{
		hEdit   = GetWindow    (hWnd,GW_CHILD);
		uMyId   = GetWindowLong(hWnd,GWL_ID  );
		hParent = GetParent    (hWnd);

		CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);

		   hItem = GetDlgItem(hParent,uMyId^0x5555);
		if(hItem && lParam)						// Gibt es ein parallel Fenster
			{
			TCHAR	cText[MAX_PATH];

			cText[0] = cText[MAX_PATH-1] = 0;

			SendMessage(hItem,WM_GETEDITTEXT,MAX_PATH-1,(LPARAM)cText);

			if(_tcscmp(cText,(LPCTSTR)lParam))
				{
				SendMessage(hItem,WM_SETEDITTEXT,wParam,lParam);
				}
			}

		return SendMessage(hEdit,uMsg,wParam,lParam);
		}


	if(uMsg==WM_GETTEXT)						// Text-Holen zu Edit-Fenster weiterleiten
		{
		hEdit = GetWindow(hWnd,GW_CHILD);
		lRet  = CallWindowProc(pOldProc,hWnd,CB_GETCURSEL,0,0);

		if(lRet>=0)
			{
			TCHAR	cText[1024];

			   lMax  = CallWindowProc(pOldProc,hWnd,CB_GETLBTEXTLEN,lRet,0);
			if(lMax<(int)wParam && (int)wParam>0)
				{
				return CallWindowProc(pOldProc,hWnd,CB_GETLBTEXT,lRet,lParam);
				}

			if(lMax>=1024 || lMax<=0)
				{
				if((int)wParam>0)((LPTSTR)lParam)[0]=0;
				return 0;
				}

			lRet  = CallWindowProc(pOldProc,hWnd,CB_GETLBTEXT,lRet,(LPARAM)cText);
			memcpy((LPTSTR)lParam,cText,wParam*sizeof(TCHAR));
			((LPTSTR)lParam)[wParam-1] = 0;
			return wParam-1;
			}

		return SendMessage(hEdit,uMsg,wParam,lParam);
		}

	if(uMsg==WM_GETTEXTLENGTH)					// Text-Lnge zu Edit-Fenster weiterleiten
		{
		hEdit = GetWindow(hWnd,GW_CHILD);
		lRet  = CallWindowProc(pOldProc,hWnd,CB_GETCURSEL,0,0);

		if(lRet>=0)
			{
			return CallWindowProc(pOldProc,hWnd,CB_GETLBTEXTLEN,lRet,0);
			}

		return SendMessage(hEdit,uMsg,wParam,lParam);
		}


	if(uMsg==WM_DROPFILES)						// Datei an Edit-Fenster weiter leiten
		{
		if(GetWindowLong(hWnd,GWL_EXSTYLE)&WS_EX_ACCEPTFILES)
			{
			HDROP	hDropInfo=(HDROP)wParam;
			TCHAR	cFile[MAX_PATH];
			int		iNum;


			   iNum=DragQueryFile(hDropInfo,-1,0,0);
			if(iNum>=1)
				{
				hParent = GetParent(hWnd);
				uMyId   = GetWindowLong(hWnd,GWL_ID);
				DragQueryFile (hDropInfo,0,cFile,sizeof(cFile)/sizeof(TCHAR));
				CallWindowProc(pOldProc,hWnd,CB_SETCURSEL,-1,0);
				CallWindowProc(pOldProc,hWnd,WM_SETTEXT,0,(LPARAM)cFile);

				   hItem = GetDlgItem(hParent,uMyId^0x5555);
				if(hItem)						// Gibt es ein parallel Fenster
					{
					SendMessage(hItem,WM_SETEDITTEXT,0,(LPARAM)cFile);
					}

				PostMessage(hParent,WM_COMMAND,MAKELONG(uMyId,CBN_EDITCHANGE),(LPARAM)hWnd);
				PostMessage(hParent,WM_COMMAND,MAKELONG(uMyId,EN_CHANGE     ),(LPARAM)hWnd);
				PostMessage(hParent,WM_COMMAND,MAKELONG(uMyId,EN_DROPFILES  ),(LPARAM)hWnd);
				}

			DragFinish(hDropInfo);

			return 0;
			}
		}

	if(uMsg==WM_KEYDOWN)						// Key-Down abfangen
		{
		sNotify.hdr.code	= NM_KEYDOWN;
		sNotify.nVKey		= wParam;
		sNotify.uFlags		= lParam;

		if(SendNotify(hWnd,&sNotify.hdr))return 0;
		}



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb4E
//*
//*****************************************************************************
//	Fallengelassene Dateien werden als Text eingetragen
LRESULT __stdcall SCProcCb4E(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC pOldProc;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb4E)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb4E);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_DROPFILES)						// Datei an Edit-Fenster weiter leiten
		{
		HDROP	hDropInfo=(HDROP)wParam;
		TCHAR	cFile[MAX_PATH];
		HWND	hBox;
		int		iNum;
		int		iId;

		   iNum=DragQueryFile(hDropInfo,-1,0,0);
		if(iNum>=1)
			{
			hBox = GetParent(hWnd);
			iId  = GetWindowLong(hBox,GWL_ID);
			DragQueryFile(hDropInfo,0,cFile,sizeof(cFile)/sizeof(TCHAR));

			CallWindowProc(pOldProc,hWnd,CB_SETCURSEL,-1,0);
			CallWindowProc(pOldProc,hWnd,WM_SETTEXT,0,(LPARAM)cFile);

			PostMessage(GetParent(hBox),WM_COMMAND,MAKELONG(iId,CBN_EDITCHANGE),(LPARAM)hWnd);
			PostMessage(GetParent(hBox),WM_COMMAND,MAKELONG(iId,EN_DROPFILES  ),(LPARAM)hWnd);
			}

		DragFinish(hDropInfo);

		return 0;
		}


return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcCb4
//*
//*****************************************************************************
//	Fallengelassene Dateien werden als Text eingetragen
LRESULT __stdcall SCProcCb4(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC pOldProc;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcCb4)
			{
			pOldProc = pOldCBoxProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcCb4);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return SCProcCb4E(GetWindow(hWnd,GW_CHILD),WM_ATTACH,0,0);
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_DROPFILES)						// Datei an Edit-Fenster weiter leiten
		{
		HDROP	hDropInfo=(HDROP)wParam;
		TCHAR	cFile[MAX_PATH];
		int		iNum;
		int		iId;

		   iNum=DragQueryFile(hDropInfo,-1,0,0);
		if(iNum>=1)
			{
			iId = GetWindowLong(hWnd,GWL_ID);
			DragQueryFile(hDropInfo,0,cFile,sizeof(cFile)/sizeof(TCHAR));

			CallWindowProc(pOldProc,hWnd,CB_SETCURSEL,-1,0);
			CallWindowProc(pOldProc,hWnd,WM_SETTEXT,0,(LPARAM)cFile);

			PostMessage(GetParent(hWnd),WM_COMMAND,MAKELONG(iId,CBN_EDITCHANGE),(LPARAM)hWnd);
			PostMessage(GetParent(hWnd),WM_COMMAND,MAKELONG(iId,EN_DROPFILES  ),(LPARAM)hWnd);
			}

		DragFinish(hDropInfo);

		return 0;
		}


return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcEd1
//*
//*****************************************************************************
//	Farbkorrektur bei gesperrten Fenster.
LRESULT __stdcall SCProcEd1(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC		pOldProc;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcEd1)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcEd1);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_GETDLGCODE)					// Keine Tasten annehmen wenn disable
		{
		if(!IsWindowEnabled(hWnd))
			{
			return DLGC_STATIC;
			}
		}

	if(uMsg==WM_SETFOCUS)					// Keinen Focus annehmen wenn disable
		{
		if(!IsWindowEnabled(hWnd))
			return 0;
		}

	if(uMsg==WM_ENABLE)wParam=1;			// Immer enable vorgaukeln



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcEd2
//*
//*****************************************************************************
//	TAB's an Eltern Fenster weiterleiten
LRESULT __stdcall SCProcEd2(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC			pOldProc;
NMKEY			sHeader;
static WPARAM	wLast;
LRESULT			lRet;


	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcEd5)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcEd5);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg>=WM_KEYFIRST && uMsg<=WM_KEYLAST)	// Tatsennachrichten
		{
		if(uMsg!=WM_KEYDOWN && wLast==wParam)
			{
			return 0;
			}

		if(wParam==VK_TAB || wParam==VK_RETURN)
			{
			sHeader.hdr.hwndFrom	= hWnd;
			sHeader.hdr.code		= NM_KEYDOWN;
			sHeader.hdr.idFrom		= GetWindowLong(hWnd,GWL_ID);
			sHeader.nVKey			= (UINT)wParam;
			sHeader.uFlags			= (UINT)lParam;

			   lRet = SendMessage(GetParent(hWnd),WM_NOTIFY,sHeader.hdr.idFrom,(LPARAM)&sHeader);
			if(lRet)
				{
				wLast = wParam;
				return 0;
				}

			wLast = 0;
			}
		}


	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SCProcEd3
//*
//*****************************************************************************
//	Im Textnderungen knnen mit EnableWindow() aus eingeschalten werden
LRESULT __stdcall SCProcEd3(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC pOldProc=0;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcEd3)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcEd3);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_GETDLGCODE)						// Nur Cursor-Tasten annehmen
		{
		if(IsWindowEnabled(hWnd))
			{
			return DLGC_WANTARROWS;
			}
		}


	if(uMsg==WM_ENABLE)							// Fr Farbe Enable ist ein
		{
		wParam=1;
		}

	if(!IsWindowEnabled(hWnd))					// Keine Textnderungen erlaubt
		{
		if(uMsg==WM_CUT  )return 0;
		if(uMsg==WM_PASTE)return 0;
		if(uMsg==WM_CLEAR)return 0;


		if(uMsg>=WM_KEYFIRST)
		if(uMsg<=WM_KEYLAST)
			{
			if(uMsg  ==WM_CHAR	)return 0;
			if(wParam==VK_BACK	)return 0;
			if(wParam==VK_DELETE)return 0;
			}
		}


	pOldProc = (WNDPROC)GetWindowLongPtr(hWnd,GWL_USERDATA);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		SCProcEd4
//*
//*****************************************************************************
//	Fallengelassene Dateien werden als Text eingetragen.
LRESULT __stdcall SCProcEd4(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC pOldProc;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcEd4)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcEd4);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_DROPFILES)						// Datei an Edit-Fenster weiter leiten
		{
		HDROP	hDropInfo=(HDROP)wParam;
		TCHAR	cFile[MAX_PATH];
		int		iNum;
		int		iId;

		   iNum=DragQueryFile(hDropInfo,-1,0,0);
		if(iNum>=1)
			{
			iId  = GetWindowLong(hWnd,GWL_ID);
			DragQueryFile(hDropInfo,0,cFile,sizeof(cFile)/sizeof(TCHAR));
			CallWindowProc(pOldProc,hWnd,WM_SETTEXT,0,(LPARAM)cFile);
			PostMessage(GetParent(hWnd),WM_COMMAND,MAKELONG(iId,EN_CHANGE   ),(LPARAM)hWnd);
			PostMessage(GetParent(hWnd),WM_COMMAND,MAKELONG(iId,EN_DROPFILES),(LPARAM)hWnd);
			}

		DragFinish(hDropInfo);

		return 0;
		}


return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		SCProcEd5
//*
//*****************************************************************************
//	Der Text im Fenster kann nur ausgewhlt werden aber nicht editiert werten.
LRESULT __stdcall SCProcEd5(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC		pOldProc;


	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcEd2)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcEd2);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}


	if(uMsg==WM_GETDLGCODE)					// Nur Cursortasten annehmen
		{
		return DLGC_WANTARROWS;
		}

	if(uMsg==WM_CUT  )return 0;				// Keine nderungen
	if(uMsg==WM_PASTE)return 0;
	if(uMsg==WM_CLEAR)return 0;


	if(uMsg>=WM_KEYFIRST)
	if(uMsg<=WM_KEYLAST)
		{
		if(uMsg  ==WM_CHAR	)return 0;
		if(wParam==VK_BACK	)return 0;
		if(wParam==VK_DELETE)return 0;
		}

	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		SCProcEd6
//*
//*****************************************************************************
//	Weiterleiten von Nachrichten zu einem anderen EDIT-Fenster
LRESULT __stdcall SCProcEd6(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC			pOldProc;
NMKEY			sNotify;
HWND			hEdit;
LRESULT			lRet;
UINT			uId;



	pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);


	if(uMsg==WM_ATTACH)							// Eine andere alte Fensterfunktion bernehmen
		{
		   pOldProc	= (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
		if(pOldProc==SCProcEd6)
			{
			pOldProc = pOldEditProc;
			}
		
		if(lParam)
				pOldProc = (WNDPROC)lParam;
		else	SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)SCProcEd6);	

		SetPropW(hWnd,(LPCWSTR)wSubclassAtom,pOldProc);

		return TRUE;
		}


	if(uMsg==WM_DETACH)							// Fenster abhngen 
		{
		pOldProc = (WNDPROC)GetPropW(hWnd,(LPCWSTR)wSubclassAtom);

		if(!lParam)
			{
			SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)pOldProc);
			}

		RemovePropW(hWnd,(LPCWSTR)wSubclassAtom);
		
		return (LPARAM)pOldProc;
		}

												// Nachrichten zu Edit-Fenster weiterleiten
	if((uMsg>=0x00B0 && uMsg<=0x00D9) || uMsg==WM_SETTEXT || uMsg==WM_GETTEXT || uMsg==WM_GETTEXTLENGTH)
		{
		lRet  = CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
		uId	  = GetWindowLong (hWnd,GWL_ID)^0x5555;
		hEdit = GetDlgItem    (GetParent(hWnd),uId);
		return SendMessage(hEdit,uMsg,wParam,lParam);
		}

	
	if(uMsg==WM_SETEDITTEXT)					// Text einstellen
		{
		uMsg = WM_SETTEXT;
		}

	
	if(uMsg==WM_GETEDITTEXT)					// Text abfragen
		{
		uMsg = WM_GETTEXT;
		}


	if(uMsg==WM_KEYDOWN && wParam==VK_RETURN)	// Wurde Enter gedrckt
		{
		sNotify.hdr.code	= NM_KEYDOWN;
		sNotify.nVKey		= wParam;
		sNotify.uFlags		= lParam;

		uId	  = GetWindowLong (hWnd,GWL_ID)^0x5555;
		hEdit = GetDlgItem    (GetParent(hWnd),uId);

		if(SendNotify(hEdit,&sNotify.hdr))return 0;
		}


return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		SubclassComboBox
//*
//*****************************************************************************
//	Ermglicht das es bei einer ComboBox spezielle Nachrichten funktionieren.
//	Das Fenster muss WM_ATTACH untersttzen.
//	hBox	: Ist das ComboBox-Fenster
//	pProc	: Ist die neue Fensterfunktion
//				SCB_COLORMSG	Hintergrundfarben via WM_CTLCOLOREDIT 
//				SCB_EDITCOMBO	ComboBox verhlt sich wie EDIT
//				SCB_TABENTER	TAB+ENTER an Eltern Fenster weiterleiten
//				SCB_DROPFILE	Dateien fallenlassen
//				SCB_TEXTCOLOR	Buchstabenfarben einstellbar 
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler.
BOOL AFXAPI SubclassComboBox(HWND hBox,WNDPROC pProc)
{
BOOL		bOk;


	#ifdef 	_DEBUG
	char    cName[32]="";
	GetClassNameA(hBox,cName,sizeof(cName));

	ASSERT(pProc!=SCE_COLOR     );
	ASSERT(pProc!=SCE_NOCHANGE	);
	ASSERT(pProc!=SCE_EDITCHANGE);
	ASSERT(pProc!=SCE_DROPFILE	);
	ASSERT(pProc!=SCE_TABENTER	);
	ASSERT(pProc!=SCE_REDIRECT	);

	ASSERT(!stricmp(cName,"COMBOBOX"));
	ASSERT(IsWindow(hBox));
	ASSERT(pProc!=SCE_DROPFILE || (GetWindowLong(hBox,GWL_EXSTYLE)&WS_EX_ACCEPTFILES));
	ASSERT(GetWindow(hBox,GW_CHILD));

	#endif


	if(!wSubclassAtom)									// Globale Initalisierung
		{
		SubclassInit();	
		}

	bOk = pProc(hBox,WM_ATTACH,0,0);					// Beim Fenster einhngen

	ASSERT(bOk);


return TRUE;
}

//*****************************************************************************
//*
//*		SubclassEdit
//*
//*****************************************************************************
//	Ermglicht es das bei einem Edit-Fenster spezielle Nachrichten funktionieren.
//	Das Fenster muss WM_ATTACH untersttzen.
//	hEdit	: Ist das Edit-Fenster
//	pProc	: Ist die Fenster-Funktion
//				SCE_COLOR	   	= Keine Graueschrift bei gesperrten Fenster
//				SCE_NOCHANGE   	= Keine Textnderung mglich
//				SCE_EDITCHANGE 	= Keine Graueschrift bei gesperrten Fenster Textnderung mglich wenn freigegeben
//				SCE_TABENTER   	= TAB's an Eltern Fenster
//				SCE_DROPFILE   	= Dateien fallenlassen
//				SCE_REDIRECT	= Weiterleiten von Nachrichten
//				SCE_TEXTCOLOR	= Buchstabenfarben einstellbar
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler.
BOOL AFXAPI SubclassEdit(HWND hEdit,WNDPROC pProc)
{
BOOL	bOk;


	if(!pProc)return FALSE;

	#ifdef 	_DEBUG
	char    cName[32]="";
	GetClassNameA(hEdit,cName,sizeof(cName));
	
	ASSERT(pProc!=SCB_COLORMSG  );
	ASSERT(pProc!=SCB_EDITCOMBO );
	ASSERT(pProc!=SCB_TABENTER  );
	ASSERT(pProc!=SCB_DROPFILE  );

	ASSERT(IsWindow(hEdit));
	ASSERT(!stricmp(cName,"EDIT"));
	ASSERT(pProc!=SCE_DROPFILE || (GetWindowLong(hEdit,GWL_EXSTYLE)&WS_EX_ACCEPTFILES));
	#endif

	if(!wSubclassAtom)									// Globale Initalisierung
		{
		SubclassInit();	
		}

	bOk = pProc(hEdit,WM_ATTACH,0,0);					// Beim Fenster einhngen

	ASSERT(bOk);


return bOk;
}


//*****************************************************************************
//*
//*		SubclassWnd
//*
//*****************************************************************************
//	Hngt eine ander Fensterfunktion ein. Die alte Fensterfunktion wird
//	in GWL_USERDATA gespeichert.
//	hEdit	: Ist das Edit-Fenster
//	pProc	: Ist die Fenster-Funktion
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler.
BOOL AFXAPI SubclassWnd(HWND hWnd,WNDPROC pProc)
{
WNDPROC		pOld;


	ASSERT(IsWindow(hWnd));

	ASSERT(pProc!=SCE_COLOR     );
	ASSERT(pProc!=SCE_NOCHANGE	);
	ASSERT(pProc!=SCE_EDITCHANGE);
	ASSERT(pProc!=SCE_DROPFILE	);
	ASSERT(pProc!=SCE_TABENTER	);
	ASSERT(pProc!=SCE_REDIRECT	);

	ASSERT(pProc!=SCB_COLORMSG  );
	ASSERT(pProc!=SCB_EDITCOMBO );
	ASSERT(pProc!=SCB_TABENTER  );
	ASSERT(pProc!=SCB_DROPFILE  );

	if(!pProc)return FALSE;

	pOld = (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);

	ASSERT(pProc!=pOld);

	SetWindowLongPtr(hWnd ,GWL_USERDATA,(LPARAM)pOld );
	SetWindowLongPtr(hWnd ,GWL_WNDPROC ,(LPARAM)pProc);



return TRUE;
}

//*****************************************************************************
//*
//*		GetIconNr
//*
//*****************************************************************************
//	Holt die Iconnummer zu einer Datei fr die System-Icon-Liste
//	pFilename	: Ist der Zeiger auf den Dateinamen
//	iMode		:	SHGFI_LARGEICON				Groe Icons
//					SHGFI_SMALLICON				Kleines Icon
//					SHGFI_OPENICON				Icon geffnet
//					SHGFI_USEFILEATTRIBUTES		Icon aus Sufixholen
//	Ergibt die Iconnummer bzw. -1 bei einem Fehler
int	AFXAPI GetIconNr(LPCTSTR pFilename,int iMode)
{
void	   *pIcon=0;
SHFILEINFO	sInfo;
LRESULT		lRet;
int			iLen;
int			iRet;
int			iPos;



	if(iMode&SHGFI_USEFILEATTRIBUTES)						// Icon via Datei Suffix holen
		{
		iLen = (int)_tcslen(pFilename);

		for(iPos=iLen-1;;iPos--)
			{
			if(iPos<=0              ){iPos=iLen;break;}
			if(pFilename[iPos]=='.' ){iPos+=1  ;break;}
			if(pFilename[iPos]=='/' ){iPos=iLen;break;}
			if(pFilename[iPos]=='\\'){iPos=iLen;break;}
			}

		   iRet = sIconCache.GetIcon(pFilename+iPos,iMode&3,&pIcon);
		if(iRet>=0)return iRet;
		}

	if(pFilename[0]!=0 &&  pFilename[1]==':')				// Icon von Laufwerk holen
	if(pFilename[2]==0 || (pFilename[3]==0 && (pFilename[2]=='\\' || pFilename[2]=='/')))
		{
		   iRet = CIconChache::GetDriveIcon(pFilename[0],iMode);
		if(iRet>=-1)return iRet;
		}


	   lRet=SHGetFileInfo(pFilename,FILE_ATTRIBUTE_NORMAL,&sInfo,sizeof(sInfo),SHGFI_SYSICONINDEX|iMode);
	if(lRet)
		{
		if(pIcon)sIconCache.SetIcon(iMode&3,sInfo.iIcon,pIcon);

		return sInfo.iIcon;
		}


return -1;
}


//*****************************************************************************
//*
//*		GetIconList
//*
//*****************************************************************************
//	Holt ein Handle auf die System-Icon-Liste
//	iLarge		: Bestimmt ob die Liste fr groe oder kleine Icons geholt wird.
//	Ergibt ein HIMAGELIST Handle
HIMAGELIST AFXAPI GetIconList(int iLarge)
{
return 	CIconChache::GetImageList(iLarge);
}


//*****************************************************************************
//*
//*		GetClipboardText
//*
//*****************************************************************************
//	Holt einen Text aus der Zwischenablage.
//	pLen	: Hier wird die Lnge des Textes gespeichert.
//	Ergibt einen Zeiger auf den Text der in der Zwischenablage liegt.
//	Der Zeiger muss spter wieder mit delete gelscht werden
//	Ist kein Text in der Zwischenablage so wird 0 zurck gegeben.
TCHAR * AFXAPI GetClipboardText(int *pLen)
{
int			iNum;
TCHAR	   *pPtr;
TCHAR	   *pData;
HGLOBAL		hGlobal;




	if(!IsClipboardFormatAvailable(CF_TEXT_EX))		// Ist ein Text gespeichert ?
		{
		if(pLen)*pLen=0;
		return 0;
		}

	if(!OpenClipboard(0))
		{
		if(pLen)*pLen=0;
		return 0;
		}

		hGlobal = GetClipboardData(CF_TEXT_EX);
	if(!hGlobal)
		{
		CloseClipboard();
		if(pLen)*pLen=0;
		return 0;
		}

		pData=(TCHAR*)GlobalLock(hGlobal);			// Speicher erzeugen
	if(!pData)
		{
		CloseClipboard();
		if(pLen)*pLen=0;
		return 0;
		}

	   iNum=(int)_tcslen(pData);
	if(iNum>0)
		{
		pPtr=new TCHAR[iNum+1];
		memcpy(pPtr,pData,(iNum+1)*sizeof(TCHAR));
		if(pLen)*pLen=iNum;
		}
	else{
		if(pLen)*pLen=0;
		pPtr=0;
		}


	GlobalUnlock(hGlobal);
	CloseClipboard();



return pPtr;
}



//*****************************************************************************
//*
//*		GetClipboardText
//*
//*****************************************************************************
//	Holt einen Text aus der Zwischenablage
//	pText	: Ist der Zeiger auf den Puffer in dem der Text gespeichert wird.
//	iSize	: Ist die Gre des Puffers inklusive Nullzeichen.
//	Ergibt die Lnge des Textes ohne Nullzeichen bzw. 0 wenn kein Text kopiert wurde.
int AFXAPI GetClipboardText(TCHAR *pText,int iSize)
{
TCHAR *pPtr;
int    iLen;


	if(iSize<=0)return 0;

		pPtr=GetClipboardText(&iLen);
	if(!pPtr)
		{
		pText[0]=0;
		return 0;
		}

	if(iLen+1>iSize)iLen=iSize-1;
	memcpy(pText,pPtr,(iLen+1)*sizeof(TCHAR));
	delete pPtr;


return iLen;
}



//*****************************************************************************
//*
//*		SetClipboardText
//*
//*****************************************************************************
//	Speichert einen Text in die Zwischenablage
//	pText	: Ist der Zeiger auf den Text
//	iSize	: Ist die maximale Lnge vom Text
//			  Wenn iSize kleiner Null ist wird die Lnge mit strlen bestimmt.
//	Ergibt die Lnge des gespeicherten Textes bzw. 0 wenn kein Text gespeichert wurde.
int AFXAPI SetClipboardText(LPCTSTR pText,int iSize)
{
TCHAR	   *pNew;
int			iOk=0;
HGLOBAL		hGlobal;


	if(iSize< 0)iSize=(int)_tcslen(pText);
	if(iSize<=0)return 0;

	hGlobal=GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,(iSize+1)*sizeof(pText[0]));
	pNew=(TCHAR*)GlobalLock(hGlobal);
	memcpy(pNew,pText,iSize*sizeof(TCHAR));
	pNew[iSize]=0;

	GlobalUnlock(hGlobal);

	if(OpenClipboard(0))
		{
		EmptyClipboard();
		if(!SetClipboardData(CF_TEXT_EX,hGlobal))GlobalFree(hGlobal);
		CloseClipboard();
		iOk=iSize;
		}
	else{
		GlobalFree(hGlobal);
		}


return iOk;
}



//*****************************************************************************
//*
//*		FindWindow
//*
//*****************************************************************************
//	Sucht das oberste Fenster bei einem Punkt
//	pPoint		: Sind die Koordinaten des Punktes
//	pBaseWnd	: Ist Ausgangsfenster fr die Suche (NULL fr den Desktop)
//	bVisible	: Nur nach sichtbaren Fenstern suchen
//	Ergibt das gefundene Fenster bzw. 0 wenn keines gefunden wird.
CWnd * AFXAPI FindWindowPtr(LPPOINT	pPoint,CWnd *pBaseWnd,BOOL bVisible)
{
HWND	hWnd;


	hWnd = (pBaseWnd)? pBaseWnd->m_hWnd:0;
	hWnd = FindWindowPtr(pPoint,hWnd,bVisible);

	if(!hWnd)return 0;


return CWnd::FromHandle(hWnd);
}

//*****************************************************************************
//*
//*		FindWindow
//*
//*****************************************************************************
//	Sucht das oberste Fenster bei einem Punkt
//	pPoint		: Sind die Koordinaten des Punktes
//	hBaseWnd	: Ist Ausgangsfenster fr die Suche (NULL fr den Desktop)
//	bVisible	: Nur nach sichtbaren Fenstern suchen
//	Ergibt das gefundene Fenster bzw. 0 wenn keines gefunden wird.
HWND AFXAPI FindWindowPtr(LPPOINT pPoint,HWND hBaseWnd,BOOL bVisible)
{
HWND	hWnd;
RECT	sRect;
int		iXsize;
int		iYsize;
TCHAR	cName [256];
TCHAR	cClass[256];


	hWnd = 0;

	for(;;)
		{
			hWnd=FindWindowEx(hBaseWnd,hWnd,0,0);
		if(!hWnd)
			{
			if(hBaseWnd)return hBaseWnd;
			return 0;
			}

		if(bVisible && !(GetWindowLong(hWnd,GWL_STYLE)&WS_VISIBLE))continue;

		GetWindowRect(hWnd,&sRect);

		if(!PtInRect(&sRect,*pPoint))continue;


		GetWindowText(hWnd,cName ,sizeof(cName )/sizeof(TCHAR));
		GetClassName (hWnd,cClass,sizeof(cClass)/sizeof(TCHAR));

		iXsize   = sRect.right -sRect.left;
		iYsize   = sRect.bottom-sRect.top;
		hBaseWnd = hWnd;
		hWnd     = 0;
		}


return 0;
}


//*****************************************************************************
//*
//*		ListInsert
//*
//*****************************************************************************
//	Fgt in eine ComboBox oder ListBox Texte ein
//	hWnd	: Fenster-Handle fr ComboBox
//	pText	: Zeiger auf Liste mit Texten
//	cCut	: Ist das Trennzeichen mit dem die einzenen Eintrge in
//			  pText getrennt sind. Null ist auch erlaubt.
//	bClear	: Sollen alle vorhanden Eintge vorher gelscht werden
//	Ergibt die Anzahl der eingefgten Eintrge
int AFXAPI ListInsert(HWND hWnd,LPCTSTR pText,TCHAR cCut,BOOL bClear)
{
TCHAR	cBuffer[256];
int		iStart;
int		iIdx;
int		iLen;
int		iNum;
int		iClr;
int		iMsg;
int		iSel;
int		iSet;
int		i;



	GetClassName(hWnd,cBuffer,sizeof(cBuffer)/sizeof(TCHAR));

	if(!_tcscmp(cBuffer,_T("LISTBOX")))
		{
		iClr=LB_DELETESTRING;
		iMsg=LB_ADDSTRING;
		iSel=LB_GETCURSEL;
		iSet=LB_SETCURSEL;
		}
	else{
		iClr=CB_DELETESTRING;
		iMsg=CB_ADDSTRING;
		iSel=CB_GETCURSEL;
		iSet=CB_SETCURSEL;
		}

	iNum = 0;
	iIdx = (int)SendMessage(hWnd,iSel,0,0);

	if(bClear)									// Alles lschen
		{
		for(;;)
			{
			if(SendMessage(hWnd,iClr,0,0)<0)break;
			}
		}

	for(i=0,iStart=0;;i++)
		{
		if(pText[i] && pText[i]!=cCut)continue;

		   iLen=i-iStart;
		if(iLen>0)
			{
			if(iLen>sizeof(cBuffer)/sizeof(TCHAR)-1)iLen=sizeof(cBuffer)/sizeof(TCHAR)-1;
			memcpy(cBuffer,pText+iStart,iLen*sizeof(TCHAR));
			cBuffer[iLen]=0;
			SendMessage(hWnd,iMsg,0,(LPARAM)cBuffer);
			iNum++;
			}

		iStart=i+1;

		if(pText[i]==0)							// String Ende
			{
			if(cCut)break;
			if(pText[i+1]==0)break;
			}
		}

	if(iIdx>=0)
		{
		if(bClear)SendMessage(hWnd,0   ,0,0);
		else	  SendMessage(hWnd,iIdx,0,0);
		}


return iNum;
}

//*****************************************************************************
//*
//*		ListAdd
//*
//*****************************************************************************
//	Fgt in eine ComboBox oder ListBox eine Textzeile am Anfang ein.
//	Gleiche Textzeilen werden entfernt.
//	hWnd	: Fenster-Handle fr ComboBox
//	pText	: Zeiger auf den einzufgenden pText
//	iCase	: Solle zwischen Gro und Kleinbuchstaben unterschieden werden ?
//	iMax	: Maximale Anzahl an Eintrgen fr das Fenster
//	Ergibt die Anzahl der eingefgten Eintrge
int AFXAPI ListAdd(HWND hWnd,LPCTSTR pText,int iMax,BOOL iCase)
{
int  (_cdecl *pCmp)(LPCTSTR,LPCTSTR);
TCHAR  *pPtr,*pMem=0;
TCHAR	cBuffer[256];
int		iSize;
int		iIdx;
int		iNum;
int		iMsg;
int		iDel;
int		iLen;
int		iGet;
int		iSel;
int		iSet;
int		i;



	pCmp = (iCase)? _tcscmp:_tcsicmp;

	GetClassName(hWnd,cBuffer,sizeof(cBuffer)/sizeof(TCHAR));
	if(!_tcscmp(cBuffer,_T("LISTBOX")))
		{
		iMsg = LB_INSERTSTRING;
		iDel = LB_DELETESTRING;
		iLen = LB_GETTEXTLEN;
		iGet = LB_GETTEXT;
		iSel = LB_GETCURSEL;
		iSet = LB_SETCURSEL;
		}
	else{
		iMsg = CB_INSERTSTRING;
		iDel = CB_DELETESTRING;
		iLen = CB_GETLBTEXTLEN;
		iGet = CB_GETLBTEXT;
		iSel = CB_GETCURSEL;
		iSet = CB_SETCURSEL;
		}

	iNum = 0;
	iIdx = (int)SendMessage(hWnd,iSel,0,0);
	SendMessage(hWnd,iMsg,0,(LPARAM)pText);

	for(i=1;;i++)
		{
		   iSize=(int)SendMessage(hWnd,iLen,i,0);
		if(iSize<0)break;

		if(i>iMax)
			{
			SendMessage(hWnd,iDel,i,0);
			i--;
			continue;
			}


		if(iSize>sizeof(cBuffer)/sizeof(TCHAR)-1)
			{
			if(pMem)delete pMem;
			   pMem = new TCHAR[iSize+1];
			if(pMem==0)break;
			pPtr = pMem;
			}
		else{
			pPtr = cBuffer;
			}

		SendMessage(hWnd,iGet,i,(LPARAM)pPtr);

		if(!pCmp(pPtr,pText))
			{
			SendMessage(hWnd,iDel,i,0);
			i--;
			}
		}

	if(iIdx>=0)SendMessage(hWnd,iSet,0,0);
	if(pMem)delete pMem;


return iNum;
}


//*****************************************************************************
//*
//*		ComboBoxLoad
//*
//*****************************************************************************
//	Ld Texte aus der Registry in eine ComboBox
//	pDlg	: Zeiger auf Dialog-Klasse
//	iId		: ID der ComboBox
//	pEntry	: Name des Registry-Werts. Wenn der Name mit # anfngt wird
//			  auch der Wert fr das Textfeld geladen.
//	pPath	: Registry Pfad von dem die Werte geladen werden. Pfade die
//			  mit # beginnen sind relative Pfade ausgehen vom aktuellen Pfad ausgehen.
//	sKey	: Registry-Objekt von wo die Daten geladen werden.
//	pBuffer	: Wenn dieser Zeiger ungleich 0 ist, wird in diesem Puffer der Wert
//			  fr das Textfeld geladen. Wenn kein Textfeld gespeichert ist dann
//			  wird der erste Listeneintrag genommen. Falls kein Eintrag gefunden
//			  wird bleibt der Puffer unverndert.
//	iSize	: Ist die Gre des Textpuffers Puffer in dem das Textfeld abgelegt wird.
//	Ergibt die Anzahl der geladenen Texte
int AFXAPI ComboBoxLoad(CDialog *pDlg,int iId,LPCTSTR pEntry,LPCTSTR pPath,CString &sTextField)
{
int		iRet;


	iRet = ComboBoxLoad(pDlg,iId,pEntry,pPath,sTextField.GetBuffer(2048),2048);
	sTextField.ReleaseBuffer();


return iRet;
}

int AFXAPI ComboBoxLoad(CDialog *pDlg,int iId,LPCTSTR pEntry,CRegKeys &sKey,CString &sTextField)
{
int		iRet;


	iRet = ComboBoxLoad(pDlg,iId,pEntry,sKey,sTextField.GetBuffer(2048),2048);
	sTextField.ReleaseBuffer();


return iRet;
}

int AFXAPI ComboBoxLoad(CDialog *pDlg,int iId,LPCTSTR pEntry,LPCTSTR pPath,LPTSTR pBuffer,int iSize)
{
CRegKeys	sKey;



	if(pPath && *pPath=='#')
		{
		if(!sKey.Open(HKEY_CURRENT_USER,0,CRK_READ))return 0;
		if(pPath[1] && sKey.Up(pPath+1)==0)return 0;
		}
	else{
		if(!sKey.Open(HKEY_CURRENT_USER,pPath,CRK_READ))return 0;
		}


return ComboBoxLoad(pDlg,iId,pEntry,sKey,pBuffer,iSize);
}

int AFXAPI ComboBoxLoad(CDialog *pDlg,int iId,LPCTSTR pEntry,CRegKeys &sKey,LPTSTR pBuffer,int iSize)
{
CComboBox  *pBox;
TCHAR 	   *pPtr;
int			iNum;
int			iAdd;
int			iLen;
int			iOff;



	if(sKey.Level()<0)return 0;
	

	pBox=(CComboBox*)pDlg->GetDlgItem(iId);


	if(pEntry && *pEntry=='#')				// Auch das Textfeld laden
		{
		pEntry++;
		iAdd=1;
		}
	else{
		iAdd=0;
		}

	if(!sKey.GetMulti(&pPtr,pEntry))
		{
		return 0;
		}

	if(iAdd)								// Auch das Textfeld laden
		{
		pBox->ResetContent();
		}
	else{									// Nur Liste laden
		while(pBox->DeleteString(0)!=CB_ERR);
		}


	if(iAdd)								// Textfeld speichern
		{
		if(*pPtr!='\x02')
			{
			iAdd=0;
			}
		else{
			iAdd=(int)_tcslen(pPtr);
			pBox->SetWindowText(pPtr+1);
			if(pPtr[iAdd+1])iAdd++;
			}
		}


	if(pBuffer && iSize>0)					// Textfeld in Puffer speichern
	if(pPtr[0] || pPtr[1])
		{
		iSize--;
		_tcsncpy(pBuffer,(*pPtr!='\x02')? pPtr:pPtr+1,iSize);
		pBuffer[iSize]=0;
		}

	if(pPtr[iAdd]=='\x02')
		{
		iAdd++;

		for(iOff=iAdd;pPtr[iOff];iOff+=iNum)
			{
			iNum = (int)_tcslen(pPtr+iOff)+1;
			}

		iLen  = iOff+1;
		iOff  = iAdd+(int)_tcslen(pPtr+iAdd)+1;

		for(;iOff<iLen;iOff+=iNum)			// Suche doppelte Texte
			{
			iNum = (int)_tcslen(pPtr+iOff)+1;

			if(_tcscmp(pPtr+iAdd,pPtr+iOff))continue;

			memmove(pPtr+iOff,pPtr+iOff+iNum,iLen-iOff-iNum);
			iLen -= iNum;
			iNum  = 0;
			}
		}



	iNum = ListInsert(pBox->m_hWnd,pPtr+iAdd,0,0);

	delete pPtr;



return iNum;
}


//*****************************************************************************
//*
//*		ComboBoxSave
//*
//*****************************************************************************
//	Speichert Texte aus einer ComboBox in der Registry
//	pDlg	: Zeiger auf dialog Klasse
//	iId		: ID der ComboBox
//	pEntry	: Name des Registry-Werts. Wenn der Name mit # anfngt wird
//			  auch der Wert fr das Textfeld geladen.
//	pPath	: Registry Pfad in dem die Werte gespeichert werden. Pfade die
//			  mit # beginnen sind relative Pfade ausgehen vom aktuellen Pfad ausgehen.
//	sKey	: Registry-Objekt von wo die Daten geladen werden.
//	Ergibt 1 wenn der Text eingefgt wurde
int AFXAPI ComboBoxSave(CDialog *pDlg,int iId,LPCTSTR pEntry,LPCTSTR pPath)
{
CRegKeys	sKey;


	if(pPath && *pPath=='#')
		{
		if(!sKey.Open(HKEY_CURRENT_USER,0))return 0;
		if(!sKey.Up(pPath+1))return 0;
		}
	else{
		if(!sKey.Open(HKEY_CURRENT_USER,pPath))return 0;
		}


return ComboBoxSave(pDlg,iId,pEntry,sKey);
}

int AFXAPI ComboBoxSave(CDialog *pDlg,int iId,LPCTSTR pEntry,CRegKeys &sKey)
{
CString		sNew;
CString		sLine;
CString		sText;
CComboBox  *pBox;
TCHAR	   *pPtr;
int			iNum;
int			iAnz;
int			iSel;
int			iPos;
int			iAdd;


	if(sKey.Level()<0)return 0;		    

	pBox = (CComboBox*)pDlg->GetDlgItem(iId);
	iAdd = 0;

	if(pEntry)
		{
		if(*pEntry=='*'){iAdd=2;pEntry++;}
		if(*pEntry=='#'){iAdd++;pEntry++;}
		}


	pBox->GetWindowText(sLine);

	   iSel = pBox->GetCurSel();
	if(iSel>=0 && !sLine.GetLength())		// Text oder Auswahl verwenden
		{
		pBox->GetLBText(iSel,sLine);
		}

	if(iAdd<2 && sLine==_T(""))				// Keine Leerfelder speichern ?
		{
		return 0;
		}

	if(iAdd)								// Textfeld einfgen
		{
		sNew  = _T("\x02");
		sNew += sLine;
		sNew += _T("\x01");
		iAdd  = sNew.GetLength();
		}

	sNew += sLine;
	iNum  = pBox->GetCount();

	for(iAnz=1,iPos=0;iPos<iNum;iPos++)
		{
		pBox->GetLBText(iPos,sText);

		if(sText==_T(""))continue;
		if(sText!=sLine)
			{
			sNew+=_T("\x01");
			sNew+=sText;
			iAnz++;
			if(iAnz>=16)break;
			}
		}


	iNum=sNew.GetLength();
	pPtr=sNew.GetBuffer(iNum+2);
	pPtr[iNum+1]=0;

	for(;iNum>=0;iNum--)					// \x01 gegen Nullzeichen tauschen
		{
		if(pPtr[iNum]==1)pPtr[iNum]=0;
		}

	if(iSel<0)								// Eine neue Liste in die ComboBox einfgen
		{
		iNum=ListInsert(pBox->m_hWnd,(LPCTSTR)sNew+iAdd,0,1);
		}

	if(!sKey.SetMulti(pPtr,pEntry))return 0;




return iAnz;
}

//*****************************************************************************
//*
//*		CalcTextWidht
//*
//*****************************************************************************
//	Berechnet die Lnge eines Textes in Pixel anhand einer Breitentabelle.
//	Bei Null-Zeichen oder Zeilenumbrchen wird abgebrochen.
//	pText		: Ist der Zeiger auf den Text.
//	hFont		: Ist der verwentete Font
//	iMax		: Ist die maximale Textlnge (bei -1 mit strlen holen)
//	pHeight		: Hier wird die Hhe gespeichert wenn der Zeiger nicht 0 ist.
//	Ergibt die Textbreite in Pixel.
int AFXAPI GetTextWidth(LPCTSTR pText,HFONT hFont,int iMax,int *pHeight)
{
CSize			sSize;
HDC			    hDc;


	if(!pText)return 0;

	if(iMax<0)											// Textlnge holen
		{
		iMax = (int)_tcslen(pText);
		}

	hDc  = GetDC(NULL);

	SelectObject(hDc,hFont);

	if(!GetTextExtentPoint(hDc,pText,iMax,&sSize))		// Abmessungen berechnen
		{
		sSize.cx = 0;
		sSize.cy = 0;
		}

	ReleaseDC(NULL,hDc);

	if(pHeight)*pHeight=sSize.cy;


return sSize.cx;
}

//*****************************************************************************
//*
//*		CalcTextWidht
//*
//*****************************************************************************
//	Berechnet die Lnge eines Textes in Pixel anhand einer Breitentabelle.
//	Bei Null-Zeichen oder Zeilenumbrchen wird abgebrochen.
//	pText		: Ist der Zeiger auf den Text.
//	hWnt		: Ist das Fenster aus dem der Font geholt wird
//	iMax		: Ist die maximale Textlnge (bei -1 mit strlen holen)
//	pHeight		: Hier wird die Hhe gespeichert wenn der Zeiger nicht 0 ist.
//	Ergibt die Textbreite in Pixel.
int AFXAPI GetTextWidth(LPCTSTR pText,HWND hWnd,int iMax,int *pHeight)
{
CSize			sSize;
HFONT			hFont;
HDC			    hDc;


	if(!pText)return 0;

	ASSERT(IsWindow(hWnd));

	if(iMax<0)											// Textlnge holen
		{
		iMax = (int)_tcslen(pText);
		}

	hFont	= (HFONT)SendMessage(hWnd,WM_GETFONT,0,0);
	hDc		= GetDC(hWnd);

	ASSERT(hFont);

	SelectObject(hDc,hFont);

	if(!GetTextExtentPoint(hDc,pText,iMax,&sSize))		// Abmessungen berechnen
		{
		sSize.cx = 0;
		sSize.cy = 0;
		}

	ReleaseDC(hWnd,hDc);

	if(pHeight)*pHeight=sSize.cy;


return sSize.cx;
}

//*****************************************************************************
//*
//*		GetTextWidth
//*
//*****************************************************************************
//	Berechnet die Lnge eines Textes in Pixel anhand einer Breitentabelle.
//	Bei Null-Zeichen oder Zeilenumbrchen wird abgebrochen.
//	pText		: Ist der Zeiger auf den Text.
//	pSize		: Ist der Zeiger auf die Breitentabelle
//	iMax		: Ist die maximale Textlnge
//	Ergibt die Textbreite in Pixel.
int AFXAPI GetTextWidth(LPCTSTR pText,const BYTE *pSize,int iMax)
{
unsigned	uOffset;
int			iSize;
int			iPos;


	if(!pSize)											// Nur Buchstaben zhlen
		{
  		for(iPos=0;iPos<iMax;iPos++)
			{
			if(pText[iPos]== 0  )break;
			if(pText[iPos]=='\n')break;
			if(pText[iPos]=='\r')break;
			}

		return iPos;
		}


	iSize = 0;

  	for(iPos=0;iPos<iMax;iPos++)						// Lngen auf addieren
		{
		if(pText[iPos]== 0  )break;
		if(pText[iPos]=='\n')break;
		if(pText[iPos]=='\r')break;

		#ifdef UNICODE
		   uOffset = pText[iPos];
		if(uOffset>255)uOffset='A';
		#else
		uOffset = (BYTE)pText[iPos];
		#endif

		iSize  += pSize[uOffset];
		}


return iSize;
}

//*****************************************************************************
//*
//*		GetCharWidths
//*
//*****************************************************************************
//	Holt die Buchstabenbreiten vom aktuellen Font und speichert sie in einem Datenfeld.
//	hDC		: Handle vom Gerte Context mit Font
//	pSize	: Ist ein Zeiger auf ein 256 Byte groes Feld.
void AFXAPI GetCharWidths(HDC hDC,BYTE *pSize)
{
INT		aSize[256];
int		i;


	GetCharWidth32(hDC,0,255,aSize);
	for(i=0;i<256;i++)pSize[i]=aSize[i];

}

//*****************************************************************************
//*
//*		GetCharWidths
//*
//*****************************************************************************
//	Holt die Buchstabenbreiten fr einen Font und speichert sie in einem Datenfeld
//	pSize	: Ist ein Zeiger auf ein 256 Byte groes Feld.
//	iFont	: Ist der gewhlte Font, bei -1 wird ANSI_VAR_FONT benutzt.
//			  Ansonsten wird GetStockObject(iFont) benutzt.
void AFXAPI GetCharWidths(BYTE *pSize,int iFont)
{
INT		aSize[256];
HDC		hDC;
int		i;


	if(iFont==-1)iFont=ANSI_VAR_FONT;

	hDC = GetDC(0);

	SelectObject  (hDC,GetStockObject(iFont));
	GetCharWidth32(hDC,0,255,aSize);
	ReleaseDC     (0,hDC);

	for(i=0;i<256;i++)pSize[i]=aSize[i];

}

//*****************************************************************************
//*
//*		GetCharWidths
//*
//*****************************************************************************
//	Holt die Buchstabenbreiten fr einen Font und speichert sie in einem Datenfeld
//	pSize	: Ist ein Zeiger auf ein 256 Byte groes Feld
//	hFont	: Ist das Handle des Fonts
void AFXAPI GetCharWidths(BYTE *pSize,HFONT hFont)
{
INT		aSize[256];
HDC		hDC;
int		i;


	hDC=::GetDC(0);
	SelectObject(hDC,hFont);
	GetCharWidth32(hDC,0,255,aSize);
	ReleaseDC(0,hDC);
	for(i=0;i<256;i++)pSize[i]=aSize[i];

}

//*****************************************************************************
//*
//*		CommpressFileName
//*
//*****************************************************************************
//	Erzeugt eine Dateinamen der hchstens iMax Pixel lang ist.
//	berzhlige Pfadangaben werden durch "..." ersetzt.
//	pFilename	: Zeiger auf den Dateinamen
//	pTarget		: Speicher fr neuen Namen
//	iLen		: Speichergre
//	iMax		: iMaximale Pixelbreite den neuen
//	pSize		: Feld mit den Gren der Buchstaben, wenn 0 dann immer 1 Pixel
//	iBase		: Anzahl der Verzeichnisse die am Anfang stehen
//	pPreText	: Ist der Text der vor dem Dateinamen steht
//	pPostText	: Ist der Text der nach dem Dateinamen steht
//	iPostLen	: Ist die Lnge des Textes nach dem Dateinamen
//	iPreLen 	: Ist die Lnge des Textes nach dem Dateinamen
//	Ergibt die Lnge des Strings in Byte
int AFXAPI CommpressFileName(LPCTSTR pFilename,LPTSTR pTarget,int iLen,int iMax,BYTE *pSize,int iBase,LPCTSTR pPreText,LPCTSTR pPostText,int iPostLen,int iPreLen)
{
int		iDiff;


	if(pPreText)										// Text vor dem Dateinamen bercksichtigen
		{
		   iDiff = (int)(pFilename-pPreText);
		if(iDiff>=0 && iDiff<iPreLen)
			{
			iPreLen = iDiff;
			}

		iMax -= GetTextWidth(pPreText,pSize,iPreLen);
		}

	if(pPostText)										// Text nach dem Dateinamen bercksichtigen
		{
		iMax -= GetTextWidth(pPostText,pSize,iPostLen);
		}



return CommpressFileName(pFilename,pTarget,iLen,iMax,pSize,iBase);
}

int AFXAPI CommpressFileName(LPCTSTR pFilename,LPTSTR pTarget,int iLen,int iMax,BYTE *pSize,int iBase)
{
int			aOff[32];
int			iPos,iEnd,iAnf,iNum;
int			iSize,iCount;
unsigned	uOffset;
TCHAR		cChar;
LPTSTR		pText;
LPCTSTR		pStart;
LPCTSTR		pPtr;


	if(iLen<=1)
		{
		if(iLen>0)*pTarget=0;
		return 0;
		}

	pStart = pTarget;
	iPos   = 0;

	if(pFilename[iPos]=='\\' || pFilename[iPos]=='/')iPos++;
	if(pFilename[iPos]=='\\' || pFilename[iPos]=='/')iPos++;

	for(;;iPos++)										// Zum Ende vom ersten Abschnitt
		{
		cChar = pFilename[iPos];

		if(cChar== 0  )break;
		if(cChar!='\\')
		if(cChar!='/' )continue;
														// Ist es eine URL z.B.: "http://www.google.de/xxxx"
		if(pFilename[iPos+1]=='\\' || pFilename[iPos+1]=='/')
			{
			iPos++;
			}

		break;
		}


	if(!pFilename[iPos])								// Keine Eintrge (nur Datei)
		{
		if(iPos>iLen)iPos=iLen;
		memcpy(pTarget,pFilename,iPos);
		pTarget[iPos]=0;
		return iPos;
		}


	iLen--;
	iNum=0;
	aOff[0]=0;

	while(pFilename[iPos])								// Zhle Verzeichnisse (ohne Datei)
		{
		for(;;)
			{
			cChar = pFilename[iPos];

			if(cChar=='\\'){iPos++;break;}
			if(cChar=='/' ){iPos++;break;}
			if(cChar== 0  ){       break;}

			iPos++;
			}

		iNum++;
		aOff[iNum]=iPos;
		if(iNum>=31)break;
		}

	if(iNum>0 && aOff[iNum-1]+1==aOff[iNum])
		{
		aOff[iNum-1]=aOff[iNum];
		iNum--;
		}

	iCount = aOff[iNum]-aOff[iNum-1];					// Dateinamengre berechnen

	if(!pSize)
		{
		iSize = iCount;
		}
	else{
		pPtr  = pFilename+aOff[iNum-1];
		iSize = 0;

		for(iCount--;iCount>=0;iCount--)
			{
			#ifdef UNICODE
			   uOffset = pPtr[iCount];
			if(uOffset>255)uOffset='A';
			#else
			uOffset = (BYTE)pPtr[iCount];
			#endif
			iSize  += pSize[uOffset];
			}
		}

  	iMax -= iSize;
	iEnd  = iNum-1;
	iAnf  = 0;

	if(!pSize)iMax-=4;
	else	  iMax-=3*pSize['.']+pSize['\\'];

	while(iMax>0)										// Scanne Gre
		{
		if(iEnd<=iAnf)break;

		if(iAnf<iBase)
			{
			pPtr   = pFilename   +aOff[iAnf];
			iCount = aOff[iAnf+1]-aOff[iAnf];
			}
		else{
			pPtr   = pFilename +aOff[iEnd-1];
			iCount = aOff[iEnd]-aOff[iEnd-1];
			}


		if(!pSize)iSize=iCount;
		else{
			iSize=0;
			for(iCount--;iCount>=0;iCount--)
				{
				#ifdef UNICODE
				   uOffset = pPtr[iCount];
				if(uOffset>255)uOffset='A';
				#else
				uOffset = (BYTE)pPtr[iCount];
				#endif
				iSize  += pSize[uOffset];
				}
			}

		if(iSize<=iMax)
			{
			if(iAnf<iBase)
				   iAnf++;
			else   iEnd--;
			}

		iMax-=iSize;
		}

	if(iEnd<iAnf)iEnd=iAnf;								// Erzeuge neuen Dateinamen

	   iSize=aOff[iAnf];
	if(iSize>iLen)iSize=iLen;

	memmove(pTarget,pFilename,iSize*sizeof(TCHAR));
	pTarget += iSize;
	iLen	-= iSize;


	if(iEnd>iAnf)
		{
		   iSize=4;
		if(iSize>iLen)iSize=iLen;

		pText    = pTarget;
		pTarget += iSize;
		iLen	-= iSize;
		}
	else{
		pText	 = 0;
		}

	   iSize=aOff[iNum]-aOff[iEnd];
	if(iSize>iLen)iSize=iLen;

	memmove(pTarget,pFilename+aOff[iEnd],iSize*sizeof(TCHAR));
	pTarget += iSize;
	iLen	-= iSize;

	pTarget[0]=0;

	if(pText)memcpy(pText,_T("...\\"),4*sizeof(TCHAR));



return (int)(pTarget-pStart);
}


//*****************************************************************************
//*
//*		LoadToolBar
//*
//*****************************************************************************
#if _MFC_VER >= 0x0700
BOOL CToolBarEx::LoadToolBar(LPCTSTR pResourceName)
{
BOOL		bResult;
HGLOBAL		hGlobal;
HINSTANCE	hInst;
HRSRC		hRsrc;
UINT       *pItems;
int			i;

struct CToolBarData
	{
	WORD	wVersion;
	WORD	wWidth;
	WORD	wHeight;
	WORD	wItemCount;
	WORD * items()
		{
		return (WORD*)(this+1);
		}
	};


	ASSERT_VALID(this);
	ASSERT(pResourceName != NULL);


	   hInst = AfxFindResourceHandle(pResourceName, RT_TOOLBAR);	// determine location of the bitmap in resource fork
	   hRsrc = FindResource(hInst,   pResourceName, RT_TOOLBAR);
	if(hRsrc == NULL)return FALSE;

	   hGlobal = LoadResource(hInst, hRsrc);
	if(hGlobal == NULL)
		{
		return FALSE;
		}

	CToolBarData* pData = (CToolBarData*)LockResource(hGlobal);

	if(pData == NULL)
		{
		return FALSE;
		}

	ASSERT(pData->wVersion==1);

	pItems = new UINT[pData->wItemCount];

	for(i=0;i<pData->wItemCount;i++)
		{
		pItems[i] = pData->items()[i];
		}

	bResult = SetButtons(pItems, pData->wItemCount);

	delete pItems;

	if (bResult)
		{
		CSize sImage (pData->wWidth  ,pData->wHeight  );			// set new sizes of the buttons
		CSize sButton(pData->wWidth+7,pData->wHeight+8);

		SetSizes(sButton,sImage);

		bResult = LoadBitmap(pResourceName);						// load bitmap now that sizes are known by the toolbar control
		}


	UnlockResource(hGlobal);
	FreeResource  (hGlobal);



return bResult;
}
#endif

//*****************************************************************************
//*
//*		CheckReframe
//*
//*****************************************************************************
//	Prft ob man im Rahmen fr's Vergreren ist
//	sFrame		: Rechteck das vergrert werden soll
//	sOffset		: Ist der Cursor
//	iFrame		: Ist die Breite des (wenn kleiner Null dann +/-)
//	iMask		: Maske fr Richtungen die nicht erlaubt sind
//					Bit0 = links
//					Bit1 = Rechts
//					Bit2 = oben
//					Bit3 = unten
//	pCursor		: Hier wird das Handle des Cursors gespeichert
//	Ergibt die Modusbits (Bit0=links Bit1=Rechts Bit2=oben Bit3=unten)
int AFXAPI CheckReframe(CRect &sFrame,CPoint sOffset,int iFrame,int iMask,HCURSOR *pCursor)
{
int		iDiffX;
int		iDiffY;
int		iStepX;
int		iStepY;
int		iSizeX;
int		iSizeY;
UINT	uMode;
CRect	sRect;
LPCTSTR	pMyId;


	if(pCursor)*pCursor=0;

	if(iFrame)												// Rahmen prfen
		{
		if(iFrame<0)
			{
			sRect = sFrame;
			sRect.InflateRect(-iFrame,-iFrame);
			if(!sRect.PtInRect(sOffset))return 0;
			}
		else{
			if(!sFrame.PtInRect(sOffset))return 0;
			iFrame = -iFrame;
			}

		sRect = sFrame;
		sRect.InflateRect(iFrame,iFrame);
		if(sRect.PtInRect(sOffset))return 0;
		}

	uMode	= 0;
	iSizeX	= sFrame.Width();
	iStepX	= (iSizeX<40)? iSizeX/2:20;
	iDiffX	= sOffset.x-sFrame.left;
	iSizeY	= sFrame.Height();
	iStepY	= (iSizeY<40)? iSizeY/2:20;
	iDiffY	= sOffset.y-sFrame.top;

	if(iDiffY<iStepY)									// nderungsart berechnen
		{
			 if(iDiffX< iStepX       )uMode=0x05;
		else if(iDiffX>=iSizeX-iStepX)uMode=0x06;
		else 						  uMode=0x04;
		}
	else if(iDiffY>=iSizeY-iStepY)
		{
			 if(iDiffX< iStepX       )uMode=0x09;
		else if(iDiffX>=iSizeX-iStepX)uMode=0x0A;
		else 						  uMode=0x08;
		}
	else if(iDiffY>=iStepY && iDiffY<iSizeY-iStepY)
		{
			 if(iDiffX< iStepX       )uMode=0x01;
		else if(iDiffX>=iSizeX-iStepX)uMode=0x02;
		}

	uMode &= ~iMask;

	if(pCursor)
		{
		switch(uMode)									// Cursor ID holen
			{
		case 0x01:	pMyId=IDC_SIZEWE  ;break;
		case 0x02:	pMyId=IDC_SIZEWE  ;break;
		case 0x04:	pMyId=IDC_SIZENS  ;break;
		case 0x08:	pMyId=IDC_SIZENS  ;break;
		case 0x06:	pMyId=IDC_SIZENESW;break;
		case 0x0A:	pMyId=IDC_SIZENWSE;break;
		case 0x05:	pMyId=IDC_SIZENWSE;break;
		case 0x09:	pMyId=IDC_SIZENESW;break;
		default:	pMyId=0           ;break;
			}

		if(pMyId)*pCursor=LoadCursor(NULL,pMyId);
		else	 *pCursor=0;
		}

return uMode;
}


//*****************************************************************************
//*
//*		CheckShifterV
//*
//*****************************************************************************
//	Prft od der Cursor auf einer vertikalen Taste ist.
//	iPos		: X-Position an der der Separator beginnt
//	iSize		: Ist die Hhe des Separators
//	uMode		: Bestimmt die Art der Taste
//					Bit  0..15 = Pixel-Offset
//					Bit 16..17 = Lage (0=oben 1=mittig 2=unten)
//	sPoint		: Ist die Cursor-Position
//	Ergibt 1 wenn der Cursor auf der Taste ist.
int AFXAPI CheckShifterV(int iPos,int iSize,unsigned uMode,CPoint sPoint)
{
int		iOff;


	if(sPoint.x<iPos  )return 0;
	if(sPoint.x>iPos+6)return 0;

	iOff = (short)uMode;

	switch((uMode>>16)&3)
		{
	case 1:	iOff += iSize/2-SP_SHIFTER/2;	break;
	case 2:	iOff += iSize  -SP_SHIFTER  ;	break;
		}

	if(sPoint.y<iOff             )return 0;
	if(sPoint.y>iOff+SP_SHIFTER-1)return 0;


return 1;
}

//*****************************************************************************
//*
//*		DrawShifterV
//*
//*****************************************************************************
//	Zeichnet eine vertikale Taste auf einem Separator.
//	hDc			: Ist der DC auf dem gezeichnet werden soll
//	iPos		: X-Position an der der Separator beginnt
//	iSize		: Ist die Hhe des Separators
//	uMode		: Bestimmt die Art der Taste
//					Bit  0..15 = Pixel-Offset
//					Bit 16..17 = Lage (0=oben 1=mittig 2=unten)
//					Bit 18..19 = Pfeilrichtung (nach rechts wenn nicht 0)
void AFXAPI DrawShifterV(HDC hDc,int iPos,int iSize,unsigned uMode)
{
COLORREF	uColor1;
COLORREF	uColor2;
COLORREF	uColor3;
COLORREF	uColor4;
COLORREF	uOldC;
RECT		sRect;
int			iAdd;
int			iOff;


	iOff			= (short)uMode;

	switch((uMode>>16)&3)
		{
	case 1:	sRect.top	= iOff+iSize/2-SP_SHIFTER/2;	break;
	case 2:	sRect.top	= iOff+iSize  -SP_SHIFTER  ;	break;
	default:sRect.top	= iOff;							break;
		}


	sRect.left		= iPos+1;
	sRect.right		= sRect.left+5;
	sRect.bottom	= sRect.top+SP_SHIFTER;


	uColor1			= GetSysColor(COLOR_3DSHADOW);
	uColor2			= GetSysColor(COLOR_3DLIGHT);
	uColor3			= ((uColor1>>1)&0x007F7F7F)+((uColor1>>2)&0x003F3F3F);

	uOldC			= SetBkColor(hDc,uColor3);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// mittlere Flche

	sRect.left     += 1;
	sRect.right	   -= 1;
	sRect.top	   -= 1;
	sRect.bottom	= sRect.top+1;
	uColor4			= ((uColor3>>1)&0x007F7F7F)+((uColor2>>1)&0x007F7F7F);

	SetBkColor(hDc,uColor4);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// obere Linie

	sRect.top	   += SP_SHIFTER+1;
	sRect.bottom	= sRect.top+1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// untere Linie

	sRect.left	   -= 1;
	sRect.right		= sRect.left+1;
	uColor4			= ((uColor3>>1)&0x007F7F7F)+0x007F7F7F;

	SetBkColor(hDc,uColor4);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// linke Punkte

	sRect.top	   -= SP_SHIFTER+1;
	sRect.bottom	= sRect.top+1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);


	sRect.left	   += 4;
	sRect.right		= sRect.left+1;
	uColor4			= ((uColor3>>1)&0x007F7F7F)+((uColor1>>1)&0x007F7F7F);

	SetBkColor(hDc,uColor4);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// rechte Punkte

	sRect.top	   += SP_SHIFTER+1;
	sRect.bottom	= sRect.top+1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);

	sRect.left	   -= 1;
	sRect.right		= sRect.left+1;
	sRect.top	   -= (SP_SHIFTER/2)+3;
	sRect.bottom	= sRect.top+5;

	if(uMode&0x000C0000)
		{
		sRect.left -= 2;
		sRect.right-= 2;
		iAdd        = 1;
		}
	else{
		iAdd		=-1;
		}

	SetBkColor(hDc,uColor2);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// Pfeil

	sRect.left	   += iAdd;
	sRect.right	   += iAdd;
	sRect.top	   += 1;
	sRect.bottom   -= 1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);

	sRect.left	   += iAdd;
	sRect.right	   += iAdd;
	sRect.top	   += 1;
	sRect.bottom   -= 1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);


	SetBkColor(hDc,uOldC);


}

//*****************************************************************************
//*
//*		DrawShifterH
//*
//*****************************************************************************
//	Zeichnet eine horizontale Taste auf einem Separator.
//	hDc			: Ist der DC auf dem gezeichnet werden soll
//	iPos		: Y-Position an der der Separator beginnt
//	iSize		: Ist die Breite des Separators
//	uMode		: Bestimmt die Art der Taste
//					Bit  0..15 = Pixel-Offset
//					Bit 16..17 = Lage (0=links 1=mittig 2=rechts)
//					Bit 18..19 = Pfeilrichtung (nach unten wenn nicht 0)
void AFXAPI DrawShifterH(HDC hDc,int iPos,int iSize,unsigned uMode)
{
COLORREF	uColor1;
COLORREF	uColor2;
COLORREF	uColor3;
COLORREF	uColor4;
COLORREF	uOldC;
RECT		sRect;
int			iAdd;
int			iOff;


	iOff			= (short)uMode;

	switch((uMode>>16)&3)
		{
	case 1:	sRect.left	= iOff+iSize/2-SP_SHIFTER/2;	break;
	case 2:	sRect.left	= iOff+iSize  -SP_SHIFTER  ;	break;
	default:sRect.left	= iOff;							break;
		}


	sRect.top		= iPos+1;
	sRect.bottom	= sRect.top+5;
	sRect.right		= sRect.left+SP_SHIFTER;


	uColor1			= GetSysColor(COLOR_3DSHADOW);
	uColor2			= GetSysColor(COLOR_3DLIGHT);
	uColor3			= ((uColor1>>1)&0x007F7F7F)+((uColor1>>2)&0x003F3F3F);

	uOldC			= SetBkColor(hDc,uColor3);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// mittlere Flche

	sRect.top      += 1;
	sRect.bottom   -= 1;
	sRect.left	   -= 1;
	sRect.right		= sRect.left+1;
	uColor4			= ((uColor3>>1)&0x007F7F7F)+((uColor2>>1)&0x007F7F7F);

	SetBkColor(hDc,uColor4);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// linke Linie

	sRect.left	   += SP_SHIFTER+1;
	sRect.right		= sRect.left+1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// recht Linie

	sRect.top	   -= 1;
	sRect.bottom	= sRect.top+1;
	uColor4			= ((uColor3>>1)&0x007F7F7F)+0x007F7F7F;

	SetBkColor(hDc,uColor4);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// obere Punkte

	sRect.left	   -= SP_SHIFTER+1;
	sRect.right		= sRect.left+1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);


	sRect.top	   += 4;
	sRect.bottom	= sRect.top+1;
	uColor4			= ((uColor3>>1)&0x007F7F7F)+((uColor1>>1)&0x007F7F7F);

	SetBkColor(hDc,uColor4);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// untere Punkte

	sRect.left	   += SP_SHIFTER+1;
	sRect.right		= sRect.left+1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);

	sRect.top	   -= 1;
	sRect.bottom	= sRect.top+1;
	sRect.left	   -= (SP_SHIFTER/2)+3;
	sRect.right	= sRect.left+5;

	if(uMode&0x000C0000)
		{
		sRect.top   -= 2;
		sRect.bottom-= 2;
		iAdd         = 1;
		}
	else{
		iAdd		 =-1;
		}

	SetBkColor(hDc,uColor2);
	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);				// Pfeil

	sRect.top	   += iAdd;
	sRect.bottom   += iAdd;
	sRect.left	   += 1;
	sRect.right    -= 1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);

	sRect.top	   += iAdd;
	sRect.bottom   += iAdd;
	sRect.left	   += 1;
	sRect.right    -= 1;

	ExtTextOut(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);


	SetBkColor(hDc,uOldC);


}

//*****************************************************************************
//*
//*		DrawSeparator
//*
//*****************************************************************************
//	Zeichnet einen Separator
//	hDc			: Ist der DC auf dem gezeichnet werden soll
//	iPos		: X bzw. Y-Position an der der Separator beginnt
//	iSize		: Ist die Hhe bzw. Breite des Separators
//	bHorz		: Horizontalen oder vertikalen Separator zeichnen
//					0=vertikal	1=horizontanl
//	Ergibt die Breite des Separators in Pixel.
int AFXAPI DrawSeparator(HDC hDc,int iPos,int iSize,BOOL bHorz)
{
HGDIOBJ		hOldB;
HGDIOBJ		hOldP;
HGDIOBJ		hObj;

	iSize++;

	if(bHorz)
		{
		hObj	= GetStockObject   (    NULL_PEN);
		hOldP	= SelectObject	   (hDc,hObj);
		hOldB	= SelectObject     (hDc,GetSysColorBrush(COLOR_3DLIGHT));
				  Rectangle        (hDc,0,iPos  ,iSize,iPos+2);
		hObj	= GetStockObject   (    WHITE_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,0,iPos+1,iSize,iPos+3);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DFACE));
				  Rectangle        (hDc,0,iPos+2,iSize,iPos+8);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DSHADOW));
				  Rectangle        (hDc,0,iPos+5,iSize,iPos+7);
		hObj	= GetStockObject   (    BLACK_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,0,iPos+6,iSize,iPos+8);

		}
	else{
		hObj	= GetStockObject   (    NULL_PEN);
		hOldP	= SelectObject	   (hDc,hObj);
		hOldB	= SelectObject     (hDc,GetSysColorBrush(COLOR_3DLIGHT));
				  Rectangle        (hDc,iPos  ,0,iPos+2,iSize);
		hObj	= GetStockObject   (    WHITE_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,iPos+1,0,iPos+3,iSize);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DFACE));
				  Rectangle        (hDc,iPos+2,0,iPos+8,iSize);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DSHADOW));
				  Rectangle        (hDc,iPos+5,0,iPos+7,iSize);
		hObj	= GetStockObject   (    BLACK_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,iPos+6,0,iPos+8,iSize);
		}

	SelectObject(hDc,hOldB);
	SelectObject(hDc,hOldP);


return 7;
}

//*****************************************************************************
//*
//*		DrawSeparator
//*
//*****************************************************************************
//	Zeichnet einen Separator
//	iOff		: Offset vom Rand
//	hDc			: Ist der DC auf dem gezeichnet werden soll
//	iPos		: X bzw. Y-Position an der der Separator beginnt
//	iSize		: Ist die Hhe bzw. Breite des Separators
//	bHorz		: Horizontalen oder vertikalen Separator zeichnen
//					0=vertikal	1=horizontanl
//	Ergibt die Breite des Separators in Pixel.
int AFXAPI DrawSeparator(int iOff,HDC hDc,int iPos,int iSize,BOOL bHorz)
{
HGDIOBJ		hOldB;
HGDIOBJ		hOldP;
HGDIOBJ		hObj;


	iSize += iOff+1;

	if(bHorz)
		{
		hObj	= GetStockObject   (    NULL_PEN);
		hOldP	= SelectObject	   (hDc,hObj);
		hOldB	= SelectObject     (hDc,GetSysColorBrush(COLOR_3DLIGHT));
				  Rectangle        (hDc,iOff,iPos  ,iSize,iPos+2);
		hObj	= GetStockObject   (    WHITE_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,iOff,iPos+1,iSize,iPos+3);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DFACE));
				  Rectangle        (hDc,iOff,iPos+2,iSize,iPos+8);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DSHADOW));
				  Rectangle        (hDc,iOff,iPos+5,iSize,iPos+7);
		hObj	= GetStockObject   (    BLACK_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,iOff,iPos+6,iSize,iPos+8);

		}
	else{
		hObj	= GetStockObject   (    NULL_PEN);
		hOldP	= SelectObject	   (hDc,hObj);
		hOldB	= SelectObject     (hDc,GetSysColorBrush(COLOR_3DLIGHT));
				  Rectangle        (hDc,iPos  ,iOff,iPos+2,iSize);
		hObj	= GetStockObject   (    WHITE_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,iPos+1,iOff,iPos+3,iSize);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DFACE));
				  Rectangle        (hDc,iPos+2,iOff,iPos+8,iSize);
				  SelectObject     (hDc,GetSysColorBrush(COLOR_3DSHADOW));
				  Rectangle        (hDc,iPos+5,iOff,iPos+7,iSize);
		hObj	= GetStockObject   (    BLACK_BRUSH);
				  SelectObject	   (hDc,hObj);
				  Rectangle        (hDc,iPos+6,iOff,iPos+8,iSize);
		}

	SelectObject(hDc,hOldB);
	SelectObject(hDc,hOldP);


return 7;
}

//*****************************************************************************
//*
//*		DibToBitmap
//*
//*****************************************************************************
//	Wandelt ein DIB-Speicher-Image in ein Bitmap um
//	pDib		: Zeiger auf das DIP-Speicher-Image
//	uFlags		: Diverse Flags
//					Bit0 = Sollen die Standartfarben konvertiert werden.
//					Bit1 = Alpha-Werte anpassen
//	hWnd		: Fenster fr das das Bitmap erzeugt werden soll
//	Ergibt ein HBITMAP Handle oder NULL bei einem Fehler
HBITMAP AFXAPI DibToBitmap(const void *pDib,unsigned uFlags,HWND hWnd)
{
#define 		GBR(b,g,r)  ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
BYTE			aData[sizeof(BITMAPINFOHEADER)+256*4];
BYTE		   *pData;
BYTE		   *pBits;
BITMAPINFO	   *pInfo;
COLORREF	   *pCol;
COLORREF		uCol1;
COLORREF		uCol2;
COLORREF		uCol3;
HBITMAP			hBmp;
UINT			uTmp;
UINT			uNum;
UINT			uOff;
UINT			uMax;
HDC				hDC;
int 			iRow;
int				iCol;
int				iLen;



	pInfo = (BITMAPINFO*)pDib;

	if(pInfo->bmiHeader.biSize!=sizeof(BITMAPINFOHEADER))
		{
		return NULL;
		}

	iLen  = pInfo->bmiHeader.biSizeImage;

	if(iLen<=0)
		{
		if(iLen || pInfo->bmiHeader.biCompression!=BI_RGB)
			{
			return NULL;
			}

		iLen	= pInfo->bmiHeader.biBitCount*pInfo->bmiHeader.biWidth+31;
		iLen	= (iLen/32)*4;
		iLen   *= pInfo->bmiHeader.biHeight;
		}

	uOff  = sizeof(BITMAPINFOHEADER);
	pBits = NULL;


	if(pInfo->bmiHeader.biBitCount<=8)						// Bild mit Farbtabelle
		{
		uNum = 1<<pInfo->bmiHeader.biBitCount;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uNum)uMax=uNum;

		uOff += uMax*4;
		pData = ((LPBYTE)pDib)+uOff;

		if(uFlags&1)
			{
			memcpy(aData,pInfo,uOff);
			pInfo = (BITMAPINFO*)aData;
			pCol  = (COLORREF*)pInfo->bmiColors;
			uCol1 = SwapRGB(GetSysColor(COLOR_3DSHADOW));
			uCol2 = SwapRGB(GetSysColor(COLOR_3DFACE));
			uCol3 = SwapRGB(GetSysColor(COLOR_3DLIGHT));

			for(uNum=0;uNum<uMax;uNum++)
				{
				if(pCol[uNum]==GBR(128,128,128)){pCol[uNum]=uCol1;continue;}
				if(pCol[uNum]==GBR(192,192,192)){pCol[uNum]=uCol2;continue;}
				if(pCol[uNum]==GBR(223,223,223)){pCol[uNum]=uCol3;continue;}
				}
			}
		}
	else{													// RGB Bild
		if(uFlags&1)
			{
			if(pInfo->bmiHeader.biCompression==BI_RGB)
				{
				iCol = 0;
				}
			else if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)
				{
				iCol = sizeof(DWORD)*3;
				}
			else{
				return NULL;								// Das Bild ist komprimiert
				}

			pBits = new BYTE[iLen];
			pData = pBits+iCol;
			memcpy(pBits,pInfo->bmiColors,iLen);

			uCol1 = SwapRGB(GetSysColor(COLOR_3DSHADOW));
			uCol2 = SwapRGB(GetSysColor(COLOR_3DFACE  ));
			uCol3 = SwapRGB(GetSysColor(COLOR_3DLIGHT ));

			if(pInfo->bmiHeader.biBitCount==32)				// 32-Bit-Format
				{
				pCol = (COLORREF*)pData;
				uMax = iLen/4;

				for(uNum=0;uNum<uMax;uNum++)
					{
					if(pCol[uNum]==GBR(128,128,128)){pCol[uNum]=uCol1;continue;}
					if(pCol[uNum]==GBR(192,192,192)){pCol[uNum]=uCol2;continue;}
					if(pCol[uNum]==GBR(223,223,223)){pCol[uNum]=uCol3;continue;}
					}
				}
			else if(pInfo->bmiHeader.biBitCount==24)		// 24-Bit-Format
				{
				for(iRow=0;iRow<pInfo->bmiHeader.biHeight;iRow++)
					{
					for(iCol=0;iCol<pInfo->bmiHeader.biWidth;iCol++)
						{
						uTmp  = *(UINT*)(pBits+iCol*3);
						uTmp &= 0x00FFFFFF;

						if(uTmp==GBR(128,128,128)){*(UINT*)(pBits+iCol*3)&=0xFF000000;*(UINT*)(pBits+iCol*3)|=uCol1;continue;}
						if(uTmp==GBR(192,192,192)){*(UINT*)(pBits+iCol*3)&=0xFF000000;*(UINT*)(pBits+iCol*3)|=uCol2;continue;}
						if(uTmp==GBR(223,223,223)){*(UINT*)(pBits+iCol*3)&=0xFF000000;*(UINT*)(pBits+iCol*3)|=uCol3;continue;}
						}

					pBits += (pInfo->bmiHeader.biWidth*3+3)&~3;
					}
				}
			else{
				ASSERT(0);									// Farbformat nicht untersttzt
				}
			}
		else{
			if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)
					iCol = 3;
			else	iCol = 0;

			pData = (LPBYTE)(pInfo->bmiColors+iCol);
			}


		if((uFlags&2) && pInfo->bmiHeader.biBitCount==32)	// Alpha-Werte anpassen
			{
			if(!pBits)
				{
				pBits = new BYTE[iLen];
				pData = pBits+iCol;
				memcpy(pBits,pInfo->bmiColors,iLen);
				}

			uMax = iLen;

			for(uNum=0;uNum<uMax;uNum+=4)
				{
				if(pData[uNum+3]==0)
					{
					pData[uNum+0] = 0;
					pData[uNum+1] = 0;
					pData[uNum+2] = 0;
					}
				else if(pData[3]!=255)
					{
					pData[uNum+0] = (BYTE)((pData[uNum+0]*pData[uNum+3])/255);
					pData[uNum+1] = (BYTE)((pData[uNum+1]*pData[uNum+3])/255);
					pData[uNum+2] = (BYTE)((pData[uNum+2]*pData[uNum+3])/255);
					}
				}
			}
		}



	hDC		  = GetDC(hWnd);
	hBmp	  = CreateDIBitmap(hDC,&pInfo->bmiHeader,CBM_INIT,pData,pInfo,DIB_RGB_COLORS);

	ReleaseDC(hWnd,hDC);

	if(pBits)delete pBits;


return hBmp;
}

//*****************************************************************************
//*
//*		OfnListProc
//*
//*****************************************************************************
static DWORD WINAPI OfnListProc(LPVOID pParam)
{
TCHAR			cPath[MAX_PATH];
TCHAR			cName[MAX_PATH];
HWND			hDlgWnd;
CStringChain	sList;
WIN32_FIND_DATA	sData;
HANDLE			hFind;
LPCTSTR			pText;
LPTSTR			pName;
int				iTurn;
int				iLen;
int				iNum;
int				iPos;
int				iAll;


	hDlgWnd	= (HWND)pParam;
	hFind	= NULL;
	iNum	= 0;
	iPos	= 0;
	iAll	= 0;


	while(bScrollListOn)
		{
		if(bListPathNew)							// Neues Verzeichnis gefunden
			{
			WaitForSingleObject(hListSem,INFINITE);
			iLen = strlcpy(cPath,cListPath,MAX_PATH-4);
			bListPathNew = FALSE;
			ReleaseSemaphore(hListSem,1,NULL);

			if(hFind)
				{
				FindClose(hFind);
				hFind = NULL;
				}

			sList.Del();
			iPos = 0;
			iAll = 0;

			if(hOfnScrollList)						// Die Listbox lschen
				{
				PostMessage(hOfnScrollList,LB_RESETCONTENT,0,0);
				}

			if(!iLen)continue;

			iLen = AddBackSlash(cPath,iLen);
			cPath[iLen  ] = '*';
			cPath[iLen+1] = 0;

			iTurn = 1;
			hFind = FindFirstFile(cPath,&sData);
			}										// Nchste Datei suchen
		else if(hFind && !FindNextFile(hFind,&sData))
			{
			FindClose(hFind);
			hFind = NULL;
			}

		if(bListNameNew)							// Neuer Namensfilter
			{
			WaitForSingleObject(hListSem,INFINITE);
			iNum = strlcpy(cName,cListName,MAX_PATH-4);
			bListNameNew = FALSE;
			ReleaseSemaphore(hListSem,1,NULL);

			iPos = 0;
			iAll = 0;

			if(hOfnScrollList)						// Die Listbox lschen
				{
				PostMessage(hOfnScrollList,LB_RESETCONTENT,0,0);
				}
			}

		if(hFind && !IsDots(sData.cFileName))
			{
			iLen = _tcslen(sData.cFileName);
			sList.Add(iLen,sData.cFileName);

			if(sList.Count()>2000)					// Zu viele Dateien
				{
				FindClose(hFind);
				hFind = NULL;
				}
			}

													// In Listbox einfgen
		if(hOfnScrollList && iNum && iPos<sList.Count() && iAll<100)
			{
			pText = sList.Get(iPos,iLen);

			if(!_tcsnicmp(cName,pText,iNum))
				{
				pName = new TCHAR[iLen+1];
				memcpy(pName,pText,(iLen+1)*sizeof(TCHAR));

				if(!PostMessage(hOfnScrollList,LB_ADDBUFFER,LB_FREEDATA,(LPARAM)pName))
					{
					Sleep(10);
					iTurn = 1;
					delete pName;
					}
				else{								// Erstes Element eingefgt
					if(iAll==0 && !PostMessage(hDlgWnd,WM_COMMAND,MAKELONG(0x0580,LBN_SETFIRST),(LPARAM)hOfnScrollList))
						{
						Sleep(10);
						PostMessage(hDlgWnd,WM_COMMAND,MAKELONG(0x0580,LBN_SETFIRST),(LPARAM)hOfnScrollList);
						}

					iAll += 1;
					iPos += 1;
					continue;
					}
				}
			else{
				iPos += 1;
				}
			}

		if(hFind || iPos<sList.Count())				// Schnell weiter machen
			{
			if(iTurn%256==0)Sleep(10);
			iTurn++;
			continue;
			}

		Sleep(1000);
		}


	if(hFind)
		{
		FindClose(hFind);
		hFind = NULL;
		}



return 0;
}

//*****************************************************************************
//*
//*		OfnFillComboList
//*
//*****************************************************************************
//	Fillt die Liste der ComboBox des FileDialog.
//	hWnd			: Fenster-Handle der ComboBox
//	uOfnComboMode	: Modus fr ComboBox
//						OFN_COMBOAUTO		0x00000000	Die ComboBox automtisch erstellen (nur Pfade)
//						OFN_COMBOAUTOALL	0x10000000	Die ComboBox automtisch erstellen (Pfade+Dateien)
//						OFN_COMBOAUTOFILES	0x20000000	Die ComboBox automtisch erstellen (nur Dateien)
//						OFN_COMBOLIST		0x30000000	Eine Liste mit Dateien in lpstrCustomFilter bergeben
//						OFN_COMBOREG		0x40000000	Die ComboBox via Registry erstellen (nur Pfade)
//						OFN_COMBOREGALL		0x50000000	Die ComboBox via Registry erstellen (Pfade+Dateien)
//						OFN_COMBOREGFILES	0x60000000	Die ComboBox via Registry erstellen (nur Dateien)
//						OFN_COMBONONE		0x70000000	Keine ComboBox erstellen
//	pEntry			: Liste mit den Eintrgen oder der Registry-Schlssten mit Typ
//	bSave			: Soll die Liste in der Registry gespeichert werden
static void OfnFillComboList(HWND hWnd,UINT uOfnComboMode,LPCTSTR pEntry,BOOL bSave)
{
TCHAR		cPath[128];
TCHAR		cType[ 32];
LPCTSTR		pRegName;
LPCTSTR		pAppName;
LPTSTR		pList=0;
HKEY		hKey;
int			iPos;
int			iLen;
int			iAdd;


	cPath[0] = 0;
	cType[0] = 0;

	if(uOfnComboMode<=OFN_COMBOAUTOFILES)					// Registry-Pfad automatisch ermitteln
		{
			pRegName=AfxGetApp()->m_pszRegistryKey;
			pAppName=AfxGetApp()->m_pszAppName;
		if(!pRegName)pRegName=_T("");
		if(!pAppName)pAppName=_T("");

		if(!*pRegName && *pAppName)
			{
			strlcpy(cPath,_T("Software\\AZ\\"),128);
			strlcat(cPath,pAppName,128);

			if(RegOpenKeyEx(HKEY_CURRENT_USER,cPath,0,KEY_READ,&hKey)==ERROR_SUCCESS)
				{
				pRegName = _T("AZ");
				RegCloseKey(hKey);
				}
			}

		if(!*pRegName || !*pAppName)
			{
			pRegName = _T("AZ\\Common");
			pAppName = _T("OfnList");
			}

		strlcpy(cPath,_T("Software\\"),128);
		strlcat(cPath,pRegName        ,128);
		strlcat(cPath,_T("\\")        ,128);
		strlcat(cPath,pAppName        ,128);
		strlcpy(cType,_T("OfnList")   ,32);

		iPos = _tcslen(pEntry);

		for(iPos--;iPos>=0;iPos--)
			{
			if(pEntry[iPos]=='.')break;
			if(pEntry[iPos]=='*')break;
			if(pEntry[iPos]=='?')break;
			}

		strlcpy(cType+7,pEntry+iPos+1,32-7);
		if(cType[7]>='a' && cType[7]<='z')cType[7]-=0x20;
		if(cType[8])_tcslwr(cType+8);
		}
	else if(uOfnComboMode>=OFN_COMBOREG)					// Registry-Pfad als bergabeparameter
		{
		iPos = strlcpy(cPath,pEntry,128);

		for(iPos--;iPos>0;iPos--)
			{
			if(cPath[iPos]=='\\')break;
			}

		strlcpy(cType,cPath+iPos+1,32);
		cPath[iPos] = 0;
		}


	if(uOfnComboMode!=OFN_COMBOLIST)						// Liste aus Registry holen
		{
		CRegKeys	sKey;

		sKey.Open(HKEY_CURRENT_USER,cPath,(bSave)? CRK_CREATE:CRK_READ);

		if(bSave)
			{
			pList = new TCHAR[4096];
			iLen  = 0;

			for(iPos=0;iPos<16;iPos++)						// Liste aus der ComboBox holen
				{
				   iAdd=SendMessage(hWnd,CB_GETLBTEXTLEN,iPos,0);
				if(iAdd<=0 || iLen+iAdd+3>4096)continue;
				SendMessage(hWnd,CB_GETLBTEXT,iPos,(LPARAM)(pList+iLen));
				iLen += iAdd+1;
				}

			pList[iLen] = 0;
			sKey.SetMulti(pList,cType);
			delete pList;
			return;
			}

		sKey.GetMulti(&pList,cType);
		if(!pList)return;
		pEntry=pList;
		}
	else if(bSave)
		{
		return;
		}

	for(iPos=0;iPos<32;iPos++)								// Liste in die Combobox einfgen
		{
		if(*pEntry==0)break;
		iLen = _tcslen(pEntry);
		SendMessage(hWnd,CB_INSERTSTRING,iPos,(LPARAM)pEntry);
		pEntry += iLen+1;
		}


	if(pList)delete pList;

}

//*****************************************************************************
//*
//*		OfnWndProc
//*
//*****************************************************************************
//	WindowProc fr FileOpenDialog Fenster
static LRESULT CALLBACK OfnWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
TCHAR		cText[MAX_PATH];
HANDLE		hHandle;
LPOFNOTIFY  pNotify;
LPNMKEY		pNmKey;
static int	iLock=0;
int			iHeight;
int			iWitdh;
int			iIsDir;
LPOFNOTIFY	pInfo;
DWORD		uAttr;
CRect		sRect;
HWND		hList;
HWND		hText;
HWND		hEdit;
int			iFlag;
int			iStop;
int			iMin;
int			iPos;



	if(uMsg==WM_SHOWWINDOW && wParam)
		{
		if(!iZoomDone && !iLock)						// Den Dialog vergern
			{
			iLock	  = 1;
			iZoomDone = 1;

			GetWindowRect(hWnd,&sRect);

			iWitdh	  = 600;
			iHeight	  = 450+iDialogAddY;
			iMin	  = GetSystemMetrics(SM_CXICON);

			if(iMin>32)
				{
				iWitdh   = (iWitdh *iMin)/32;
				iHeight  = (iHeight*iMin)/32;
				}

			SetWindowPos(hWnd,NULL,sRect.left,sRect.top,iWitdh,iHeight,SWP_NOMOVE|SWP_NOZORDER);

			iLock = 0;
			}

		if(pRenameReadOnly)								// Das "Read Only" Feld umbenennen
			{
			   hEdit  = GetDlgItem(hWnd,0x480);
			if(hEdit && GetClientRect(hEdit,&sRect))
				{
				iMin = sRect.right-sRect.left;
				}
			else{
				iMin = 450;
				}

			   hText =  GetDlgItem(hWnd,0x410);
			if(hText && GetClientRect(hText,&sRect))
				{
				if(iMin>sRect.right-sRect.left)
					{
					iHeight	  = sRect.bottom-sRect.top;
					SetWindowPos(hText,NULL,sRect.left,sRect.top,iMin,iHeight,SWP_NOMOVE|SWP_NOZORDER);
					}
				}

			if(bOfnSetSave)								// "ffnen" umbenenen zu "Speicheren"
				{
				bOfnSetSave = FALSE;
				hText = GetDlgItem(hWnd,IDOK);
				GetWindowText(hText,cText,MAX_PATH);

				if(!_tcscmp(cText,_T("&ffnen")))
						SetWindowText(hText,_T("&Speichern"));
				else	SetWindowText(hText,_T("&Save"     ));
				}

			SetDlgItemText(hWnd,0x410,pRenameReadOnly);
			pRenameReadOnly = NULL;
			}

		if(uOfnComboMode!=OFN_COMBONONE)				// ComboBox statt Textfeld
			{
			   hEdit  = GetDlgItem(hWnd,0x480);
			if(hEdit && GetWindowRect(hEdit,&sRect))
				{
				ScreenToClient(hWnd,(LPPOINT)&sRect.left );
				ScreenToClient(hWnd,(LPPOINT)&sRect.right);

				hList=CreateWindowEx(WS_EX_ACCEPTFILES,_T("ComboBox"),_T(""),WS_VISIBLE|WS_CHILDWINDOW|WS_TABSTOP|CBS_DROPDOWN|CBS_AUTOHSCROLL,sRect.left,sRect.top,sRect.Width(),260,hWnd,(HMENU)0x480,NULL,0);
				SetWindowPos    (hList,hEdit,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
				GetWindowText   (hEdit,cText,MAX_PATH);
				SetWindowText   (hList,cText);
				SendMessage     (hList,WM_SETFONT,SendMessage(hEdit,WM_GETFONT,0,0),0);
				ShowWindow      (hEdit,SW_HIDE);
				SetWindowLong	(hEdit,GWL_ID,0x480^0x5555);
				SubclassEdit    (hEdit,SCProcEd6);
				SubclassComboBox(hList,SCProcCb3);
				SetFocus		(hList);	

				OfnFillComboList(hList,uOfnComboMode,pOfnComoEntry,FALSE);

				if(!hOfnScrollList)						// Datei Vorschau erzeugen
					{
					if(!hListSem)CreateSemaphore(NULL,1,0x7FFF,NULL);
					bScrollListOn  = TRUE;
					hOfnScrollList = CreateScrollList(WS_BORDER,NULL,hWnd,0x0580);
					hHandle = CreateThread(NULL,0x1000,OfnListProc,hWnd,0,&uAttr);
					CloseHandle(hHandle);
					}
				}
			}
		}

	if(uMsg==WM_DESTROY)								// Dialog schliesen
		{
		if(hOfnScrollList)
			{
			WaitForSingleObject(hListSem,INFINITE);
			cListPath[0] = 0;
			ReleaseSemaphore(hListSem,1,NULL);

			DestroyWindow(hOfnScrollList);
			bScrollListOn  = FALSE;
			hOfnScrollList = NULL;
			}

		if(pLastHook)
			{
			pLastHook(hOfnHookDlg,uMsg,wParam,lParam);
			}
		}

	if(uMsg==WM_MOVING && hOfnScrollList)				// Der Dialog wird bewegt
		{
		if(IsWindowVisible(hOfnScrollList))
			{
			ShowWindow(hOfnScrollList,SW_HIDE);
			}
		}
														// In der Liste wurde ein Eintrag ausgewhlt
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x0580,LBN_SELCHANGE) && hOfnScrollList)
		{
		   iPos    = SendMessage(hOfnScrollList,LB_GETCURSEL,0,0);
		if(iPos>0 && SendMessage(hOfnScrollList,LB_GETTEXT,iPos,(LPARAM)cText)>0)
			{
			hEdit  = GetDlgItem(hWnd,0x480);
			SendMessage(hEdit,CB_SETCURSEL,-1,0);
			SendMessage(hEdit,WM_SETTEXT,0,(LPARAM)cText);
			SendMessage(hEdit,CB_SETEDITSEL,0,MAKELPARAM(0,255));
			ShowWindow(hOfnScrollList,SW_HIDE);
			}
		}

	if(uMsg==WM_LBUTTONDOWN && hOfnScrollList)			// Bei Klick die Liste schlieen
		{
		ShowWindow(hOfnScrollList,SW_HIDE);
		}
														// Liste einblenden nach ersten Element
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x0580,LBN_SETFIRST) && hOfnScrollList)
		{
		hEdit  = GetDlgItem(hWnd,0x480);

		if(cListName[0] && !IsWindowVisible(hOfnScrollList) && !SendMessage(hEdit,CB_GETDROPPEDSTATE,0,0))
			{
			GetWindowRect(hEdit,&sRect);
			MoveWindow(hOfnScrollList,sRect.left,sRect.bottom,sRect.right-sRect.left-20,120,TRUE);
			ShowWindow(hOfnScrollList,SW_SHOWNOACTIVATE);
			}
		}
														// Die Combobox verliert den Fokus
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x480,CBN_KILLFOCUS) && hOfnScrollList)
		{
		hEdit = GetFocus();

		if(hEdit==hOfnScrollList || GetParent(hEdit)==hOfnScrollList)
			{
//			SetFocus(GetDlgItem(hWnd,0x480));
			}
		else if(IsWindowVisible(hOfnScrollList))
			{
			ShowWindow(hOfnScrollList,SW_HIDE);
			}
		}
														// Text in Combobox verndert
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x480,CBN_EDITCHANGE) && hOfnScrollList)
		{
		hEdit  = GetDlgItem(hWnd,0x480);

		WaitForSingleObject(hListSem,INFINITE);
		SendMessage(hEdit,WM_GETTEXT,MAX_PATH-1,(LPARAM)cListName);
		bListNameNew = TRUE;
		ReleaseSemaphore(hListSem,1,NULL);
														// Liste ausblenden
		if(cListName[0]==0 && IsWindowVisible(hOfnScrollList))
			{
			ShowWindow(hOfnScrollList,SW_HIDE);
			}
		}

														// Drop-Liste in der Combobox
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x480,CBN_DROPDOWN) && hOfnScrollList)
		{
		hEdit  = GetDlgItem(hWnd,0x480);

		if(IsWindowVisible(hOfnScrollList))
			{
			ShowWindow(hOfnScrollList,SW_HIDE);
			}
		}
														// Close in der Combobox
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x480,CBN_CLOSEUP) && uOfnComboMode!=OFN_COMBONONE)
		{
		hEdit  = GetDlgItem(hWnd,0x480);
		iPos   = SendMessage(hEdit,CB_GETCURSEL,0,0);

		if(iPos>=0 && SendMessage(hEdit,CB_GETLBTEXT,iPos,(LPARAM)cText)>0)
			{
			   uAttr = GetFileAttributes(cText);
			if(uAttr!=0xFFFFFFFF && (uAttr&FILE_ATTRIBUTE_DIRECTORY))
				{
				PostMessage(hWnd,WM_COMMAND,IDOK,0);
				}
			}
		}
														// Text im alten Textfenster bernehmen
	if(uMsg==WM_COMMAND && wParam==MAKELONG(0x480,EN_CHANGE) && uOfnComboMode!=OFN_COMBONONE)
		{
		TCHAR	cTemp[MAX_PATH];

		cTemp[0] = 0;

		hEdit  = GetDlgItem(hWnd,0x480);
		hText  = GetDlgItem(hWnd,0x480^0x5555);

		SendMessage(hText,WM_GETEDITTEXT,MAX_PATH,(LPARAM)cTemp);
		SendMessage(hEdit,WM_GETTEXT    ,MAX_PATH,(LPARAM)cText);

		if(hText && _tcscmp(cText,cTemp))
			{
			SendMessage(hText,WM_SETEDITTEXT,0,(LPARAM)cTemp);
			}

		CallWindowProc(pPrevWndFunc,hWnd,WM_COMMAND,MAKELONG(0x480,EN_CHANGE),(LPARAM)hEdit);
		}
														// OK wurde gedrckt
	if(uMsg==WM_COMMAND && LOWORD(wParam)==IDOK && uOfnComboMode!=OFN_COMBONONE && uOfnComboMode!=OFN_COMBOLIST)
		{
		hEdit	= GetDlgItem(hWnd,0x480);
		hText   = GetDlgItem(hWnd,0x480^0x5555);
		iPos	= GetWindowText(hEdit,cText,MAX_PATH);

		goto Set;
		}
														// Aktuellen Pfad kopieren
	if(uMsg==WM_COMMAND && LOWORD(wParam)==ID_COPYOFNPATH)
		{
		TCHAR	cPath[MAX_PATH];

		cPath[0] = 0;
		SendMessage(hWnd,CDM_GETFOLDERPATH,MAX_PATH-1,(LPARAM)cPath);
		cPath[MAX_PATH-1] = 0;
		if(cPath[0])SetClipboardText(cPath);
		}

	if(uMsg==WM_CONTEXTMENU && (HWND)wParam==hWnd)
		{
		HMENU	hMenu;

		hMenu = CreatePopupMenu();
		AppendMenu(hMenu,MF_STRING,ID_COPYOFNPATH,_T("Kopiere aktuellen Pfad"));
		TrackPopupMenu(hMenu,TPM_BOTTOMALIGN|TPM_TOPALIGN,GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam),0,hWnd,NULL);
		DestroyMenu(hMenu);
		return 0;
		}
														// Auf/ab in der Liste
	if(uMsg==WM_NOTIFY && ((LPOFNOTIFY)lParam)->hdr.code==NM_KEYDOWN && hOfnScrollList)
		{
		pNmKey	= (LPNMKEY)lParam;
		iPos	= 0;

		if(pNmKey->nVKey==VK_DOWN)iPos= 1;
		if(pNmKey->nVKey==VK_UP  )iPos=-1;

		if(iPos && IsWindowVisible(hOfnScrollList))
			{
			hEdit  = GetDlgItem(hWnd,0x480);
			iMin   = SendMessage(hOfnScrollList,LB_GETCURSEL,0,0);
			         SendMessage(hOfnScrollList,LB_SETCURSEL,iMin+iPos,0);
			iPos   = SendMessage(hOfnScrollList,LB_GETCURSEL,0,0);

			if(iPos!=iMin)
				{
				SendMessage(hOfnScrollList,LB_GETTEXT,iPos,(LPARAM)cText);
				SendMessage(hEdit,CB_SETCURSEL,-1,0);
				SendMessage(hEdit,WM_SETTEXT,0,(LPARAM)cText);
				SendMessage(hEdit,CB_SETEDITSEL,0,MAKELPARAM(0,255));
				}

			pNmKey->hdr.idFrom = 0x12345678;

			return 1;
			}
														// '/' zu '\' umwandeln												
		if(pNmKey->nVKey==VK_RETURN && pNmKey->hdr.idFrom==0x480)					
			{
			hEdit  = GetDlgItem(hWnd,0x480);
			iPos   = SendMessage(hEdit,CB_GETCURSEL,0,0);

			if(iPos>=0)
					SendMessage(hEdit,LB_GETTEXT,iPos    ,(LPARAM)cText);
			else	SendMessage(hEdit,WM_GETTEXT,MAX_PATH,(LPARAM)cText);

			for(iPos=0,iMin=0;iPos<MAX_PATH;iPos++)
				{
				if(cText[iPos]== 0 )break;
				if(cText[iPos]!='/')continue;
				cText[iPos] = '\\';
				iMin++;
				}

			if(iMin)
				{								
				SendMessage(hEdit,CB_SETCURSEL,-1,0);
				SendMessage(hEdit,WM_SETTEXT,0,(LPARAM)cText);
				SendMessage(hEdit,CB_SETEDITSEL,0,MAKELPARAM(0,255));
				}
			}
		}
														// Wurde ein neuer Pfad gewhlt
	if(uMsg==WM_NOTIFY && ((LPOFNOTIFY)lParam)->hdr.code==CDN_FOLDERCHANGE)
		{
		pNotify = (LPOFNOTIFY)lParam;

		if(hOfnScrollList)
			{
			ShowWindow(hOfnScrollList,SW_HIDE);
			}

		WaitForSingleObject(hListSem,INFINITE);
		SendMessage(hWnd,CDM_GETFOLDERPATH,MAX_PATH-1,(LPARAM)cListPath);
		bListPathNew = TRUE;
		bListNameNew = TRUE;
		cListName[0] = 0;
		ReleaseSemaphore(hListSem,1,NULL);
		}
														// Wurde eine Datei ausgewhlt
	if(uMsg==WM_NOTIFY && ((LPOFNOTIFY)lParam)->hdr.code==CDN_FILEOK)
		{
		if(hOfnScrollList)
			{
			ShowWindow(hOfnScrollList,SW_HIDE);
			}

		pInfo = (LPOFNOTIFY)lParam;

		   iPos	=_tcslen(pInfo->lpOFN->lpstrFile);
		if(iPos>=MAX_PATH)iPos=MAX_PATH-1;
		memcpy(cText,pInfo->lpOFN->lpstrFile,iPos*sizeof(TCHAR));
		cText[iPos]=0;
Set:													// Backslash entfernen
		if(iPos>1 && (cText[iPos-1]=='\\' || cText[iPos-1]=='/'))
			{
			iPos--;
			cText[iPos]=0;
			}

		uAttr	= GetFileAttributes(cText);
		iStop	= (uAttr&FILE_ATTRIBUTE_DIRECTORY)? 0:1;

														// Existiert wenigstens der Pfad vom Text
		if(uAttr==0xFFFFFFFF && !uOfnSaveMode && (uOfnComboMode&0x30000000)==0)
			{
			for(iMin=iPos-1;iMin>0;iMin--)
				{
				if(cText[iMin]=='\\')break;
				if(cText[iMin]=='/' )break;
				}

			if(iMin>0)									// Pfad vor Datei gefunden
				{
				cText[iMin]=0;

				   uAttr = GetFileAttributes(cText);
				if(uAttr==0xFFFFFFFF)
						cText[iMin]='\\';
				else	iPos = iMin;
				}
			else{
				goto Exit;
				}
			}

		if(uAttr!=0xFFFFFFFF)							// Existiert die Datei
			{
			if(((uAttr&FILE_ATTRIBUTE_DIRECTORY) && iPos>0) &&
				(cText[iPos-1]!='\\' && cText[iPos-1]!='/'))
				{
				cText[iPos] = '\\';	iPos++;
				cText[iPos] = 0;
				}
			else if((uOfnComboMode&0x30000000)==0)		// Nur den Pfad benutzen
				{
				while(iPos>0)
					{
					if(cText[iPos-1]=='\\')break;
					if(cText[iPos-1]=='/' )break;
					iPos--;
					}

				cText[iPos]=0;
				uAttr = FILE_ATTRIBUTE_DIRECTORY;
				}
			}

		iFlag	= 0;
		iIsDir	= (uAttr!=0xFFFFFFFF && (uAttr&FILE_ATTRIBUTE_DIRECTORY));

		switch(uOfnComboMode&0x30000000)
			{											// Nur Verzeichnisse
		case 0x00000000:if(uOfnSaveMode==0 && uAttr==0xFFFFFFFF)break;
						if(iIsDir!=0)iFlag=1;break;
														// Dateien+Verzeichnisse
		case 0x10000000:if(uOfnSaveMode==0 && uAttr==0xFFFFFFFF)break;
						iFlag=1;break;
														// Nur Dateien
		case 0x30000000:if(uOfnSaveMode==0 && uAttr==0xFFFFFFFF)break;
						if(iIsDir==0)iFlag=1;break;
			}

		if(iFlag)										// In die Liste einfgen
			{
			   hEdit= GetDlgItem(hWnd,0x480);
			   iPos =  SendMessage(hEdit,CB_FINDSTRING,-1,(LPARAM)cText);
			if(iPos>0)
				{
				SendMessage(hEdit,CB_INSERTSTRING,0,(LPARAM)cText);
				SendMessage(hEdit,CB_DELETESTRING,iPos+1,0);
				if(!iStop)SendMessage(hEdit,CB_SETCURSEL,0,0);
				}
			else if(iPos<0)
				{
				SendMessage(hEdit,CB_INSERTSTRING,0,(LPARAM)cText);
				}

			OfnFillComboList(hEdit,uOfnComboMode,pOfnComoEntry,TRUE);
			}
Exit:	;
		}

	/*
	if(uMsg==WM_DESTROY && iZoomDone)
		{
		iZoomDone = 0;
		}
	*/


return CallWindowProc(pPrevWndFunc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		OfnHookProc
//*
//*****************************************************************************
//	Hook Funktion fr FileOpenDialog Fenster
static UINT_PTR CALLBACK OfnHookProc(HWND hDlgItem,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
HWND		hWnd;


	if(uMsg==WM_INITDIALOG)
		{
		if(pFileDlgEx==NULL)
			{
			pFileDlgEx=new CFileDialogEx;
			}

		if(pFileDlgEx)
			{
			pFileDlgEx->SetHwnd(hDlgItem);
			}

		hOfnHookDlg = hDlgItem;
		}


	if(!pPrevWndFunc)
		{
		hWnd		   = GetParent(hDlgItem);
		pPrevWndFunc   = (WNDPROC)GetWindowLongPtr(hWnd,DWL_DLGPROC);
		SetWindowLongPtr(hWnd,DWL_DLGPROC,(LPARAM)OfnWndProc);
		}

	if(pLastHook)
		{
		return pLastHook(hDlgItem,uMsg,wParam,lParam);
		}


return 0;
}

//*****************************************************************************
//*
//*		GetOpenFileNameAD
//*
//*****************************************************************************
static BOOL _stdcall GetOpenFileNameAD(LPOPENFILENAME pOfn)
{
CString	sText;
DWORD	dwFlags;
DWORD	dwLen;
BOOL	bRet;


	dwFlags = pOfn->Flags&~OFN_READONLY;

	if(!(dwFlags&OFN_ENABLETEMPLATE))
		{
		pOfn->Flags|=OFN_ENABLESIZING;
		}

	if(dwFlags&OFN_RENAMERO)								// Rename-Flag umbenenen
		{
		pOfn->Flags    &=~OFN_RENAMERO;
		pRenameReadOnly	= pOfn->lpstrFilter;

		for(dwLen=0;pRenameReadOnly[dwLen];dwLen++)
			{
			if(pRenameReadOnly[dwLen]!='@')continue;
			pOfn->lpstrFilter += dwLen+1;
			break;
			}

		sText.Format(_T("%.*s"),dwLen,pRenameReadOnly);
		pRenameReadOnly = sText;
		}
	else{
		pRenameReadOnly = 0;
		}

	   uOfnComboMode = pOfn->Flags&OFN_COMBONONE;			// ComboBox statt Textfeld
	if(uOfnComboMode<=OFN_COMBOAUTOFILES)
		{
			pOfnComoEntry = pOfn->lpstrDefExt;
		if(!pOfnComoEntry)pOfnComoEntry=_T("");
		}
	else if(uOfnComboMode!=OFN_COMBONONE)
		{
			pOfnComoEntry = pOfn->lpstrCustomFilter;
		if(!pOfnComoEntry)pOfnComoEntry=_T("\0");
		pOfn->lpstrCustomFilter = NULL;
		}
	else{
		pOfnComoEntry = NULL;
		}

	uOfnSaveMode = bOfnSetSave;

															// BUG in MFC abfangen
	if(pOfn->lpstrDefExt && IsBadStringPtr(pOfn->lpstrDefExt,256))
		{
		pOfn->lpstrDefExt = NULL;
		}

	if(iZoomDone || iWindowOpen || !(pOfn->Flags&OFN_ENABLESIZING) || !(pOfn->Flags&OFN_EXPLORER))
		{
		pPrevWndFunc   	= 0;
		pLastHook  	   	= (pOfn->Flags&OFN_ENABLEHOOK)? pOfn->lpfnHook:0;
		pOfn->lpfnHook 	= OfnHookProc;
		pOfn->Flags    |= OFN_ENABLEHOOK;
		bRet			= OldGetOpenFileNameA(pOfn);
		pOfn->Flags    &= OFN_READONLY;
		pOfn->Flags    |= dwFlags;
		return bRet;
		}

	iWindowOpen    	= 1;
	pPrevWndFunc   	= 0;
	iDialogAddY	   	= (pOfn->lpTemplateName)? 100:0;
	pLastHook  	   	= (pOfn->Flags&OFN_ENABLEHOOK)? pOfn->lpfnHook:0;
	pOfn->lpfnHook 	= OfnHookProc;
	pOfn->Flags    |= OFN_ENABLEHOOK;
	bRet           	= OldGetOpenFileNameA(pOfn);
	pOfn->lpfnHook 	= pLastHook;
	pOfn->Flags    &= OFN_READONLY;
	pOfn->Flags    |= dwFlags;
	iWindowOpen    	= 0;


return bRet;
}

//*****************************************************************************
//*
//*		GetSaveFileNameAD
//*
//*****************************************************************************
static BOOL _stdcall GetSaveFileNameAD(LPOPENFILENAME pOfn)
{
CString	sText;
DWORD	dwFlags;
BOOL	bRet;



	dwFlags = pOfn->Flags&~OFN_READONLY;

	if(dwFlags&OFN_RENAMERO)								// Umbenennen von READ-ONLY nur mit Open...
		{
		bOfnSetSave = TRUE;
		bRet = GetOpenFileNameAD(pOfn);
		bOfnSetSave = FALSE;
		return bRet;
		}

	pRenameReadOnly = 0;


	if(!(dwFlags&OFN_ENABLETEMPLATE))
		{
		pOfn->Flags|=OFN_ENABLESIZING;
		}

															// BUG in MFC abfangen
	   uOfnComboMode = pOfn->Flags&OFN_COMBONONE;			// ComboBox statt Textfeld
	if(uOfnComboMode<=OFN_COMBOAUTOFILES)
		{
			pOfnComoEntry = pOfn->lpstrDefExt;
		if(!pOfnComoEntry)pOfnComoEntry=_T("");
		}
	else if(uOfnComboMode!=OFN_COMBONONE)
		{
			pOfnComoEntry = pOfn->lpstrCustomFilter;
		if(!pOfnComoEntry)pOfnComoEntry=_T("\0");
		pOfn->lpstrCustomFilter = NULL;
		}
	else{
		pOfnComoEntry = NULL;
		}

	uOfnSaveMode = TRUE;


	if(pOfn->lpstrDefExt && IsBadStringPtr(pOfn->lpstrDefExt,256))
		{
		pOfn->lpstrDefExt = NULL;
		}

	if(iZoomDone || iWindowOpen || !(pOfn->Flags&OFN_ENABLESIZING) || !(pOfn->Flags&OFN_EXPLORER))
		{
		pPrevWndFunc   	= 0;
		pLastHook  	   	= (pOfn->Flags&OFN_ENABLEHOOK)? pOfn->lpfnHook:0;
		pOfn->lpfnHook 	= OfnHookProc;
		pOfn->Flags    |= OFN_ENABLEHOOK;
		bRet			= OldGetSaveFileNameA(pOfn);
		pOfn->Flags    &= OFN_READONLY;
		pOfn->Flags    |= dwFlags;
		return bRet;
		}

	iWindowOpen		= 1;
	pPrevWndFunc   	= 0;
	pLastHook  	   	= (pOfn->Flags&OFN_ENABLEHOOK)? pOfn->lpfnHook:0;
	pOfn->lpfnHook 	= OfnHookProc;
	pOfn->Flags    |= OFN_ENABLEHOOK;
	bRet           	= OldGetSaveFileNameA(pOfn);
	pOfn->lpfnHook 	= pLastHook;
	pOfn->Flags    &= OFN_READONLY;
	pOfn->Flags    |= dwFlags;
	iWindowOpen    	= 0;


return bRet;
}

//*****************************************************************************
//*
//*		AfxUtilityDoExit
//*
//*****************************************************************************
static void __cdecl AfxUtilityDoExit(void)
{
	AfxUtilityExit();
}

//*****************************************************************************
//*
//*		AfxUtilityInit
//*
//*****************************************************************************
//	Stellt diverse spezial Funktionen ein.
//	pModuleName		: Ist der DLL-Name bzw. 0 bei EXE-Dateien
//	Ergibt TRUE wenn erfolgreich
//	Anmerkung:	Diese nderungen funktionieren nur bei einer statisch
//				gelinkten MFC Bibliothek
int AFXAPI AfxUtilityInit(LPCTSTR pModuleName)
{
ChangeWindowMessageFilterT	pChangeWindowMessageFilter;
char						cDllNames[32*8];
int						 	iDllCount=0;
HMODULE					 	hDll;
IMAGE_NT_HEADERS		   *pPe;
IMAGE_THUNK_DATA		   *pNameThunk;
IMAGE_THUNK_DATA		   *pAddrThunk;
IMAGE_IMPORT_DESCRIPTOR	   *pIData;
const char 				   *pName;
int							iTurn;
int							i,j;


#ifdef	   _WIN64
#define 	UTYPE			ULONGLONG
#define 	PADD(ptr,add)	(((const char*)(ptr))+(ULONGLONG)(add))
#else
#define 	UTYPE			DWORD
#define 	PADD(ptr,add)	(((const char*)(ptr))+(DWORD)(add))
#endif


	atexit(AfxUtilityDoExit);

	for(iTurn=-1;iTurn<iDllCount;iTurn++)
		{
		#ifdef UNICODE
		if(pModuleName)
			{
			char cName[MAX_PATH];
			strawcpy(cName,pModuleName,MAX_PATH);
			hDll=GetModuleHandleA((iTurn<0)? cName:cDllNames+iTurn*32);
			}
		else{
			hDll=GetModuleHandleA((iTurn<0)? NULL:cDllNames+iTurn*32);
			}
		#else
		hDll=GetModuleHandleA((iTurn<0)? pModuleName:cDllNames+iTurn*32);
		#endif



		pPe    = (IMAGE_NT_HEADERS       *)PADD(hDll,((IMAGE_DOS_HEADER*)hDll)->e_lfanew);
		pIData = (IMAGE_IMPORT_DESCRIPTOR*)PADD(hDll,pPe->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);

		for(i=0;;i++)				// Suche Import Dll's
			{
			if(i>=256)break;
			if(!pIData[i].Name	    )break;
			if(!pIData[i].FirstThunk)break;

			pName=(char*)PADD(hDll,pIData[i].Name);

			#ifdef _AFXDLL

			if(iTurn<0 && iDllCount<8 && !strnicmp(pName,"mfc",3))
				{
				strncpy(cDllNames+iDllCount*32,pName,32);
				cDllNames[iDllCount*32+31]=0;
				iDllCount++;
				}

			#endif

			if(strnicmp(pName  ,"comdlg32",8    ))continue;
			if(stricmp (pName+8,".dll") && *pName)continue;


			pNameThunk = (IMAGE_THUNK_DATA*)PADD(hDll,pIData[i].OriginalFirstThunk);
			pAddrThunk = (IMAGE_THUNK_DATA*)PADD(hDll,pIData[i].FirstThunk);

			for(j=0;;j++)
				{
				UTYPE dwPos;
				DWORD dwOld;

				if(j>=4096)break;;
				if(!pNameThunk[j].u1.AddressOfData)break;;

				   dwPos=pNameThunk[j].u1.Ordinal;
				if(dwPos&IMAGE_ORDINAL_FLAG)continue;

				pName = (char*)PADD(hDll,dwPos+2);

				#ifdef UNICODE
				if(!strcmp(pName,"GetOpenFileNameW"))
				#else
				if(!strcmp(pName,"GetOpenFileNameA"))
				#endif
					{
					OldGetOpenFileNameA=(OfnProcType)pAddrThunk[j].u1.Function;
					VirtualProtect(&pAddrThunk[j].u1.Function,4,PAGE_WRITECOPY,&dwOld);
					*(UTYPE*)&pAddrThunk[j].u1.Function = (UTYPE)GetOpenFileNameAD;
					}

				#ifdef UNICODE
				if(!strcmp(pName,"GetSaveFileNameW"))
				#else
				if(!strcmp(pName,"GetSaveFileNameA"))
				#endif
					{
					OldGetSaveFileNameA=(OfnProcType)pAddrThunk[j].u1.Function;
					VirtualProtect(&pAddrThunk[j].u1.Function,4,PAGE_WRITECOPY,&dwOld);
					*(UTYPE*)&pAddrThunk[j].u1.Function = (UTYPE)GetSaveFileNameAD;
					}
				}

			#ifndef _AFXDLL

			break;

			#endif
			}
		}

	#ifdef _AFXDLL

	unsigned 	uCount;
	unsigned 	uNameC;
	unsigned 	uIndex;
	DWORD    	dwOld;
	DWORD	   *pNames;
	UTYPE	   *pAddrs;
	WORD	   *pOrtinal;
	char       *pPtr;
	IMAGE_EXPORT_DIRECTORY	*pEData;


		hDll = GetModuleHandleA("comdlg32");
	if(!hDll)
		{
			hDll = LoadLibraryA("comdlg32");
		if(!hDll)return TRUE;
		}

	if(!OldGetOpenFileNameA)
		{
		#ifdef UNICODE
		OldGetOpenFileNameA = (OfnProcType)GetProcAddress(hDll,"GetOpenFileNameW");
		#else
		OldGetOpenFileNameA = (OfnProcType)GetProcAddress(hDll,"GetOpenFileNameA");
		#endif
		}

	if(!OldGetSaveFileNameA)
		{
		#ifdef UNICODE
		OldGetSaveFileNameA = (OfnProcType)GetProcAddress(hDll,"GetSaveFileNameW");
		#else
		OldGetSaveFileNameA = (OfnProcType)GetProcAddress(hDll,"GetSaveFileNameA");
		#endif
		}


	pPe      = (IMAGE_NT_HEADERS      *)PADD(hDll,((IMAGE_DOS_HEADER*)hDll)->e_lfanew);
	pEData   = (IMAGE_EXPORT_DIRECTORY*)PADD(hDll,pPe->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress);

	if(!pEData)
		{
		return TRUE;
		}

	uCount	 = pEData->NumberOfFunctions;
	uNameC	 = pEData->NumberOfNames;

	pNames   = (DWORD*)PADD(hDll,pEData->AddressOfNames);
	pAddrs   = (UTYPE*)PADD(hDll,pEData->AddressOfFunctions);
	pOrtinal = ( WORD*)PADD(hDll,pEData->AddressOfNameOrdinals);

	for(uIndex=0;;uIndex++)
		{
		if(uIndex>=uNameC)break;
		pPtr=(char*)hDll+pNames[uIndex];

		#ifdef UNICODE
		if(OldGetOpenFileNameA && !strcmp(pPtr,"GetOpenFileNameW"))
		#else
		if(OldGetOpenFileNameA && !strcmp(pPtr,"GetOpenFileNameA"))
		#endif
			{
			   uIndex = pOrtinal[uIndex];
			if(uIndex>=uCount)continue;

			if(VirtualProtect(pAddrs+uIndex,4,PAGE_WRITECOPY,&dwOld))
				{
				pAddrs[uIndex]=(UTYPE)GetOpenFileNameAD-(UTYPE)hDll;
				}
			}

		#ifdef UNICODE
		if(OldGetSaveFileNameA && !strcmp(pPtr,"GetSaveFileNameW"))
		#else
		if(OldGetSaveFileNameA && !strcmp(pPtr,"GetSaveFileNameA"))
		#endif
			{
			   uIndex = pOrtinal[uIndex];
			if(uIndex>=uCount)continue;

			if(VirtualProtect(pAddrs+uIndex,4,PAGE_WRITECOPY,&dwOld))
				{
				pAddrs[uIndex]=(UTYPE)GetSaveFileNameAD-(UTYPE)hDll;
				}
			}
		}

	#endif


	   pChangeWindowMessageFilter  = (ChangeWindowMessageFilterT)GetProcAddress(GetModuleHandle(_T("USER32")),"ChangeWindowMessageFilter");
	if(pChangeWindowMessageFilter)						// Darg&Drop auf Win10 freischalten
		{
		pChangeWindowMessageFilter(WM_COPYGLOBALDATA,MSGFLT_ADD);
		pChangeWindowMessageFilter(WM_COPYDATA		,MSGFLT_ADD);
		pChangeWindowMessageFilter(WM_DROPFILES		,MSGFLT_ADD);
		}




return TRUE;
}



//*****************************************************************************
//*
//*		AfxUtilityExit
//*
//*****************************************************************************
int AFXAPI AfxUtilityExit()
{

	if(pFileDlgEx)
		{
		delete pFileDlgEx;
		pFileDlgEx = 0;
		}

return TRUE;
}

//*****************************************************************************
//*
//*		RemoveButtonImages
//*
//*****************************************************************************
//	Lscht alle ImageListen fr Buttons
static void _cdecl RemoveButtonImages()
{
BUTTON_IMGLIST  *pList;
BUTTON_IMGLIST  *pLast;


	pList = pIlFirst;

	while(pList)
		{
		pLast = pList;
		ImageList_Destroy(pList->himl);
		pList = (BUTTON_IMGLIST*)pList->pNext;
		delete pLast;
		}


	pIlFirst = 0;


}

//*****************************************************************************
//*
//*		SetButtonBitmap
//*
//*****************************************************************************
//	Stellt das Bitmap bei einer Taste ein (der XP-Style wird dabei bercksichtigt)
//	hWnd		: Handle der Taste
//	uId			: Resource Nummer fr das Bitmap, RGB(192,192,192)==durchsichtig
//				  Wenn grer 0xFFFF dann ist hWnd ein Bitmap-Handle.
//				  Dieses Bitmap-Handle wird automatisch gelscht.
//	Ergibt 1 wenn wenn das Bild gesetzt wurde
BOOL AFXAPI SetButtonBitmap(HWND hWnd,LPARAM uId)
{
static BOOL		bInit=0;
static HMODULE	hDll;
static FARPROC	pProc;
HDC				hDc;
BYTE		   *pData;
BYTE		   *pCols;
BITMAPINFO	   *pInfo;
BUTTON_IMGLIST *pList;
BUTTON_IMGLIST *pLast;
BYTE			bTemp[sizeof(BITMAPINFOHEADER)+256*sizeof(RGBQUAD)];
HBITMAP			hBitmaps[6];
HBITMAP			hBitmap;
HBITMAP			hGrayBm;
COLORREF		uScalar;
int				iColors;
int				iFound;
int				iBits;
int				iLine;
int				iLen;
int				iAdd;
int				iOff;
int				iPos;




	ASSERT(IsWindow(hWnd));
	ASSERT(GetWindowLong(hWnd,GWL_STYLE)&BS_BITMAP);

	#if _DEBUG
	GetWindowText(hWnd,(LPTSTR)bTemp,256);
	ASSERT(((LPTSTR)bTemp)[0]==0);
	#endif


	if(!bInit)										// Prfen ob ein XP-Style aktiv ist
		{
		bInit = TRUE;

		   hDll = LoadLibraryA("UxTheme.dll");
		if(hDll)
			{
			pProc=GetProcAddress(hDll,"IsThemeActive");
			}
		}


	if(!pProc || !pProc())
		{
		goto NoXpStyle;
		}


	if(pIlFirst)									// ImageListe initialisieren
		{
		pList = pIlFirst;

		while(pList)
			{
			pLast = pList;
			if(pList->uMyId==uId)break;
			pList = (BUTTON_IMGLIST*)pList->pNext;
			}

		if(pList)
			{
			iFound=1;
			goto ListFound;
			}
		}
	else{
		pLast = 0;
		}


	if(uId<0x10000)									// Resurcen ID
		{
			hBitmap	= LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uId));
		if(!hBitmap)
			{
			return FALSE;
			}
		}
	else{											// Bitmap in Speicher
		hBitmap = DibToBitmap((LPBYTE)uId,0);
		}



	hDc		= GetDC(hWnd);
	iBits	= GetDeviceCaps(hDc,BITSPIXEL);
	pInfo	= (BITMAPINFO*)bTemp;
	iFound	= 0;


	pInfo->bmiHeader.biSize		  		= sizeof(BITMAPINFOHEADER);
	pInfo->bmiHeader.biWidth		  	= 0;
	pInfo->bmiHeader.biHeight	  		= 0;
	pInfo->bmiHeader.biPlanes	  		= 1;
	pInfo->bmiHeader.biBitCount	  		= 0;
	pInfo->bmiHeader.biCompression 		= BI_RGB;
	pInfo->bmiHeader.biSizeImage		= 0;
	pInfo->bmiHeader.biXPelsPerMeter	= 0;
	pInfo->bmiHeader.biYPelsPerMeter	= 0;

		iLine = GetDIBits(hDc,hBitmap,0,0,NULL,pInfo,DIB_RGB_COLORS);
	if(!iLine)
		{
		DeleteObject(hBitmap);
		ReleaseDC(hWnd,hDc);
		goto NoXpStyle;
		}


	iBits    = pInfo->bmiHeader.biBitCount;iColors =(iBits>8)? 0:1<<iBits;
			   pInfo->bmiHeader.biClrUsed		   = iColors;
			   pInfo->bmiHeader.biClrImportant	   = iColors;

	if(iBits==16 && pInfo->bmiHeader.biCompression==BI_BITFIELDS)
		{
		iBits=15;
		}

	if(!pInfo->bmiHeader.biSizeImage)
		{
		pInfo->bmiHeader.biSizeImage  = 4;
		pInfo->bmiHeader.biSizeImage *= pInfo->bmiHeader.biWidth;
		pInfo->bmiHeader.biSizeImage *= pInfo->bmiHeader.biHeight;
		}


	pData = new BYTE[pInfo->bmiHeader.biSizeImage];

		iLine = GetDIBits(hDc,hBitmap,0,pInfo->bmiHeader.biHeight,pData,pInfo,DIB_RGB_COLORS);
	if(!iLine)
		{
		delete pData;
		DeleteObject(hBitmap);
		ReleaseDC(hWnd,hDc);
		goto NoXpStyle;
		}


	switch(iBits)									// Graubilder erzeugen je nach Farbtiefe
		{
	default:	pCols = (BYTE*)(pInfo+1);

				for(iOff=0;iOff<iColors;iOff++)
					{
					if((*(unsigned*)(pCols+iOff)&0xFFFFFF)==RGB(192,192,192))continue;

					uScalar = (pCols[iOff+2]*76+pCols[iOff+1]*152+pCols[iOff]*29)>>8;

					if(uScalar>192)
						{
						uScalar			= (uScalar-192+3+192*4)/4;
						pCols[iOff  ]	= (BYTE)uScalar;
						pCols[iOff+1]	= (BYTE)uScalar;
						pCols[iOff+2]	= (BYTE)uScalar;
						}
					else if(uScalar<192)
						{
						uScalar			= (uScalar/4)+192*3/4;
						pCols[iOff  ]	= (BYTE)uScalar;
						pCols[iOff+1]	= (BYTE)uScalar;
						pCols[iOff+2]	= (BYTE)uScalar;
						}
					else{
						pCols[iOff  ]	= 191;
						pCols[iOff+1]	= 191;
						pCols[iOff+2]	= 191;
						}
					}

	case 15:
	case 16:	break;

	case 24:	iLen = pInfo->bmiHeader.biSizeImage;
				iAdd = 0;

				for(iOff=0;iOff<iLen;iOff+=3,iAdd--)
					{
					;
					if(iAdd<=0)
						{
						iOff = (iOff+3)&~3;
						iAdd = pInfo->bmiHeader.biWidth;
						}

					if((*(unsigned*)(pData+iOff)&0xFFFFFF)==RGB(192,192,192))continue;

					uScalar = (pData[iOff+2]*76+pData[iOff+1]*152+pData[iOff]*29)>>8;

					if(uScalar>192)
						{
						uScalar			= (uScalar-192+3+192*4)/4;
						pData[iOff  ]	= (BYTE)uScalar;
						pData[iOff+1]	= (BYTE)uScalar;
						pData[iOff+2]	= (BYTE)uScalar;
						}
					else if(uScalar<192)
						{
						uScalar			= (uScalar/4)+192*3/4;
						pData[iOff  ]	= (BYTE)uScalar;
						pData[iOff+1]	= (BYTE)uScalar;
						pData[iOff+2]	= (BYTE)uScalar;
						}
					else{
						pData[iOff  ]	= 191;
						pData[iOff+1]	= 191;
						pData[iOff+2]	= 191;
						}
					}

				break;

	case 32:	iLen = pInfo->bmiHeader.biSizeImage;

				for(iOff=0;iOff<iLen;iOff+=4)
					{
					if((*(unsigned*)(pData+iOff)&0xFFFFFF)==RGB(192,192,192))continue;


					uScalar = (pData[iOff+2]*76+pData[iOff+1]*152+pData[iOff]*29)>>8;

					if(uScalar>192)
						{
						uScalar			= (uScalar-192+3+192*4)/4;
						pData[iOff  ]	= (BYTE)uScalar;
						pData[iOff+1]	= (BYTE)uScalar;
						pData[iOff+2]	= (BYTE)uScalar;
						}
					else if(uScalar<192)
						{
						uScalar			= (uScalar/4)+192*3/4;
						pData[iOff  ]	= (BYTE)uScalar;
						pData[iOff+1]	= (BYTE)uScalar;
						pData[iOff+2]	= (BYTE)uScalar;
						}
					else{
						pData[iOff  ]	= 191;
						pData[iOff+1]	= 191;
						pData[iOff+2]	= 191;
						}
					}

				break;
		}


	hGrayBm = CreateDIBitmap(hDc,(BITMAPINFOHEADER*)pInfo,CBM_INIT,pData,pInfo,DIB_RGB_COLORS);

	ReleaseDC(hWnd,hDc);
	delete pData;

	pList = new BUTTON_IMGLIST;


	if(uId<0x10000)									// ImageListe mit Bitmaps aus ID's fllen
		{
		hBitmaps[0]	= hBitmap;
		hBitmaps[1]	= LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uId));
		hBitmaps[2]	= LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uId));
		hBitmaps[3]	= hGrayBm;
		hBitmaps[4]	= LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uId));
		hBitmaps[5]	= LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uId));
		}
	else{											// ImageListe mit Speicher-Bitmaps fllen
		hBitmaps[0]	= hBitmap;
		hBitmaps[1]	= DibToBitmap((LPBYTE)uId,0);
		hBitmaps[2]	= DibToBitmap((LPBYTE)uId,0);
		hBitmaps[3]	= hGrayBm;
		hBitmaps[4]	= DibToBitmap((LPBYTE)uId,0);
		hBitmaps[5]	= DibToBitmap((LPBYTE)uId,0);
		}


	pList->margin.left	= 0;
	pList->margin.right	= 0;
	pList->margin.top 	= 0;
	pList->margin.bottom= 0;
	pList->pNext		= 0;
	pList->uMyId		= uId;
	pList->uAlign		= BUTTON_IMAGELIST_ALIGN_CENTER;
	pList->himl			= ImageList_Create(pInfo->bmiHeader.biWidth,pInfo->bmiHeader.biHeight,ILC_COLORDDB|ILC_MASK,5,1);

	for(iPos=0;iPos<6;iPos++)ImageList_AddMasked(pList->himl,hBitmaps[iPos],RGB(192,192,192));
	for(iPos=0;iPos<6;iPos++)DeleteObject(hBitmaps[iPos]);


ListFound:

													// ImageList an Tasten bergeben
	if(SendMessage(hWnd,BCM_SETIMAGELIST,0,(LPARAM)pList))
		{
		if(iFound)return TRUE;

		if(!pLast)
			{
			pIlFirst = pList;
			atexit(RemoveButtonImages);
			}
		else{
			pLast->pNext = pList;
			}

		return TRUE;
		}


	ImageList_Destroy(pList->himl);
	delete pList;


NoXpStyle:
													// Kein Windows Thema aktiv
	if(uId&~0xFFFF)
		{
		hBitmap = DibToBitmap((LPBYTE)uId,1);
		}
	else{
		hBitmap = (HBITMAP)LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(uId),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
		}

	if(!hBitmap)return FALSE;


return (SendMessage(hWnd,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hBitmap)==0)? FALSE:TRUE;
}

//*****************************************************************************
//*
//*		DelButtonBitmap
//*
//*****************************************************************************
//	Lscht Bitmaps von Buttons
void AFXAPI DelButtonBitmap(HWND hWnd)
{
HBITMAP		hBitmap;


	ASSERT(IsWindow(hWnd));


	   hBitmap = (HBITMAP)SendMessage(hWnd,BM_GETIMAGE,IMAGE_BITMAP,0);
	if(hBitmap)DeleteObject(hBitmap);


}

//*****************************************************************************
//*
//*		ShowConsole
//*
//*****************************************************************************
//	Blendet eine Console fr printf Ausgaben ein
void AFXAPI ShowConsole()
{
static int	iInit=0;
int			iOutHandle;
FILE	   *pOutFile;


	if(iInit)return;

	iInit=1;

	AllocConsole();

	iOutHandle = _open_osfhandle((long) GetStdHandle(STD_OUTPUT_HANDLE), _O_TEXT);
	pOutFile   = _fdopen( iOutHandle, "w" );
	*stdout    = *pOutFile;


}

//*****************************************************************************
//*
//*		ForceWindowToTop
//*
//*****************************************************************************
//	Bringt ein Fenster in den Vordergrund
//	hWnd		: Handle des Fensters
void AFXAPI ForceWindowToTop(HWND hWnd)
{
DWORD		dwForeThread;
DWORD		dwAppThread;


	ASSERT(IsWindow(hWnd));

	dwForeThread = GetWindowThreadProcessId(GetForegroundWindow(),0);
	dwAppThread  = GetCurrentThreadId();

	if(dwForeThread!=dwAppThread)
		{
		AttachThreadInput(dwForeThread,dwAppThread,TRUE);
		BringWindowToTop(hWnd);
		ShowWindow(hWnd,IsZoomed(hWnd)? SW_MAXIMIZE:SW_RESTORE);
		AttachThreadInput(dwForeThread,dwAppThread,FALSE);
		}
	else{
		BringWindowToTop(hWnd);
		ShowWindow(hWnd,IsZoomed(hWnd)? SW_MAXIMIZE:SW_RESTORE);
		}


}


//*****************************************************************************
//*
//*		DragFile
//*
//*****************************************************************************
//	Begint mit dem Darg einer Datei
//	pText		: Zeiger auf den Text
//	Ergibt 1 wenn der Drag ausgefhrt wurde, bzw. 0 bei einem Fehler.
BOOL AFXAPI DragFile(LPCTSTR pFileName)
{
TCHAR			cName[MAX_PATH];
COleDataSource	sDragData;
LPTSTR			pPart;
STGMEDIUM		pData;
int				iLen;
LPTSTR			pMem;


	#ifdef	_DEBUG
	_AFX_THREAD_STATE *pState = AfxGetThreadState();
	ASSERT(pState->m_bNeedTerm);							// Wurde AfxOleInit()+AfxEnableControlContainer() aufgerufen ?
	#endif

	   iLen= GetFullPathName(pFileName,MAX_PATH,cName,&pPart)*sizeof(TCHAR);
	if(iLen<=0 || iLen>=MAX_PATH)return FALSE;
	if(GetFileAttributes(cName)==0xFFFFFFFF)return FALSE;

	pData.pUnkForRelease	= 0;
	pData.tymed				= TYMED_HGLOBAL;
	pData.hGlobal			= GlobalAlloc(GMEM_ZEROINIT,iLen+24);

	pMem	 = (LPTSTR)GlobalLock(pData.hGlobal);
	pMem[0]	 = 20;
	#ifdef UNICODE
	pMem[8]  = 1;
	#endif
	pMem	+= 20/sizeof(TCHAR);

	memcpy(pMem,pFileName,iLen);

	GlobalUnlock(pData.hGlobal);
	sDragData.CacheGlobalData(CF_HDROP,pData.hGlobal);
	sDragData.DoDragDrop();
	sDragData.Empty();


return TRUE;
}

//*****************************************************************************
//*
//*		DragText
//*
//*****************************************************************************
//	Begint mit dem Darg eines Textes
//	pText		: Zeiger auf den Text
//	iSize		: Lnge des Textes in Zeichen.
//				  Bei -1 wird sie mit strlen() ermittelt.
//	iMode		: Art des Textes
//					0 = Ansi
//					1 = UTF8
//					2 = UTF16
//	Ergibt 1 wenn der Drag ausgefhrt wurde, bzw. 0 bei einem Fehler.
BOOL AFXAPI DragText(const void *pText,int iSize,int iMode)
{
COleDataSource	sDragData;
STGMEDIUM		pData16;
STGMEDIUM		pData;
char		   *pTemp;
char           *pMem;




	if(iSize==0)return 0;


	#ifdef	_DEBUG
	_AFX_THREAD_STATE *pState = AfxGetThreadState();
	ASSERT(pState->m_bNeedTerm);							// Wurde AfxOleInit()+AfxEnableControlContainer() aufgerufen ?
	#endif


	pTemp = NULL;


	if(iMode)
		{
		if(iMode==1)										// Ist es UTF8
			{
			if(iSize<0)iSize=(int)strlen((char*)pText);
			pTemp = new char[iSize*2+2];
			iSize = strfromutf8((wchar_t*)pTemp,(char*)pText,iSize+1,iSize);
			}
		else{												// Ist es UTF16
			if(iSize<0)iSize=(int)wcslen((wchar_t*)pText);
			pTemp = new char[iSize*1];
			}

		pData16.pUnkForRelease	= 0;
		pData16.tymed			= TYMED_HGLOBAL;
		pData16.hGlobal 		= GlobalAlloc(0,iSize*2+2);
		pMem		    		= (char*)GlobalLock(pData16.hGlobal);
		pMem[iSize*2  ]  		= 0;
		pMem[iSize*2+1]  		= 0;

		memcpy(pMem,pText,iSize*2);
		GlobalUnlock(pData16.hGlobal);

		sDragData.CacheGlobalData(CF_UNICODETEXT,pData16.hGlobal);

		strawcpy(pTemp,(wchar_t*)pText,iSize+1,iSize);
		}
	else{
		if(iSize<0)iSize=(int)strlen((char*)pText);
		}



	pData.pUnkForRelease	= 0;								// ANSI Text
	pData.tymed				= TYMED_HGLOBAL;
	pData.hGlobal   		= GlobalAlloc(0,iSize+1);
	pMem		    		= (char*)GlobalLock(pData.hGlobal);
	pMem[iSize]      		= 0;

	memcpy(pMem,pText,iSize);
	GlobalUnlock(pData.hGlobal);

	sDragData.CacheGlobalData(CF_TEXT,pData.hGlobal);


	sDragData.DoDragDrop();										// Drag ausfhren
	sDragData.Empty();

	if(pTemp)delete pTemp;



return 1;
}



static CDataList   *pSubBitmapCache	= 0;				// Cache fr GetSubBitmap(...)
static HANDLE		hSubBitmapSem   = 0;				// Semaphore fr GetSubBitmap(...)

typedef struct
	{
	UINT	uKey;										// Key fr die Schnellsuche (muss erstes sein)
	UINT	uType;										// Typ des Eintrages
	WORD	uPosX;										// Gre des Eintrages
	WORD	uPosY;										//		*
	WORD	uSizeX;										// Offset in Quelle
	WORD	uSizeY;										//		*
	LPVOID	pSource;									// Quell-Handle
	LPVOID	pItem;										// Ziel-Handle    (muss ganz hinten sein)
	LPVOID	pHandle;									// Diverse Handle (muss ganz hinten sein)
	}SubBitmapCache;

typedef struct
	{
	WORD	wVersion;									// Version der Toolbar (sollte 1 sein)
	WORD	wWidth;										// Hhe der Icons
	WORD	wHeight;									// Breite der Icons
	WORD	wItemCount;									// Anzahl der Icons
	WORD	wItems[1];									// Feld mit Icons
	}ToolBarData;

#pragma comment(lib, "Msimg32.lib")

//*****************************************************************************
//*
//*		DeleteSubBitmap
//*
//*****************************************************************************
//	Lscht den SubBitmap-Cache
static void _cdecl DeleteSubBitmap()
{
SubBitmapCache *pEntry;
int				iPos;


	if(!pSubBitmapCache)return;

	WaitForSingleObject(hSubBitmapSem,INFINITE);

	for(iPos=0;iPos<pSubBitmapCache->Count();iPos++)
		{
		pEntry = (SubBitmapCache*)pSubBitmapCache->Get(iPos);

		switch(pEntry->uType)
			{
		case GSB_BITMAP:

			DeleteObject(pEntry->pItem);
			break;

		case GSB_HDC:

			DeleteDC((HDC)pEntry->pItem);
			break;
			}
		}

	pSubBitmapCache->Del();
	delete pSubBitmapCache;
	pSubBitmapCache = 0;

	ReleaseSemaphore(hSubBitmapSem,1,NULL);
	CloseHandle(hSubBitmapSem);
	hSubBitmapSem = NULL;


}

//*****************************************************************************
//*
//*		SearchSubBitmap
//*
//*****************************************************************************
//	Suche einen Eintrag im SubBitmap-Cache
static LPVOID SearchSubBitmap(const SubBitmapCache *pFind)
{
SubBitmapCache *pEntry;
int				iPos;


	if(!pSubBitmapCache)return NULL;

	WaitForSingleObject(hSubBitmapSem,INFINITE);


	   iPos = pSubBitmapCache->FindFast(pFind->uKey,0,0x7FFFFFFF,0,0x03);
	if(iPos>=0)
		{
		for(;iPos<pSubBitmapCache->Count();iPos++)
			{
			   pEntry = (SubBitmapCache*)pSubBitmapCache->Get(iPos);
			if(pEntry->uKey!=pFind->uKey)break;
			if(memcmp(&pEntry->uType,&pFind->uType,offsetof(SubBitmapCache,pItem)-sizeof(UINT))==0)
				{
				ReleaseSemaphore(hSubBitmapSem,1,NULL);
				return pEntry->pItem;
				}
			}
		}


	ReleaseSemaphore(hSubBitmapSem,1,NULL);


return 0;
}


//*****************************************************************************
//*
//*		InsertSubBitmap
//*
//*****************************************************************************
//	Suche einen Eintrag im SubBitmap-Cache
static LPVOID InsertSubBitmap(const SubBitmapCache *pItem)
{
int			iPos;


	if(pSubBitmapCache==0)
		{
		hSubBitmapSem	= CreateSemaphore(NULL,1,0x7FFFFFFF,NULL);
		pSubBitmapCache	= new CDataList(sizeof(SubBitmapCache));
		atexit(DeleteSubBitmap);
		}

	WaitForSingleObject(hSubBitmapSem,INFINITE);

	iPos = pSubBitmapCache->FindFast(pItem->uKey,0,0x7FFFFFFF,0,0x09);
	pSubBitmapCache->Add(pItem,iPos);

	ReleaseSemaphore(hSubBitmapSem,1,NULL);


return 0;
}

//*****************************************************************************
//*
//*		GetSubBitmap
//*
//*****************************************************************************
//	Ld ein Bitmap aus einen andern Bitmap, einer Resource oder einer Toolbar
//	hSource		: Handle zu Quell-Bitmap, Resource oder Toolbar
//	iPosX/Y		: Position in der Quell-Bitmap (iPosX ist ID bei einer Toolbar)
//	iSizeX/Y	: Gre des neuen Bitmaps (GSB_SIZEFROMSRC fr iSizeY mglich)
//	uFlags		: Diverse Flags fr das Laden
//					GSB_CACHE			Quell-DC cachen fr nchsten Zugriff
//					GSB_AUTODELETE		Das Ergebnis-Bitmap cachen
//					GSB_TRANSPARENT		Die Quelle Transparent zeichnen
//					GSB_TRANSFIRST		Transparent zeichnen mit Pixel links/oben
//					GSB_BITMAP			hSource ist ein HBITMAP-Handle
//					GSB_RECOURCE		hSource ist ein Resourcen-Name
//					GSB_TOOLBAR			hSource ist ein Toolbar-Name
//					GSB_COLOR(r,g,b)	Farbe fr Transparenzbzw. Fllung
//	uBkColor	: Ist die Hintergrundfarbe frs Transparentzeichen
//	Ergibt ein HBITMAP-Handle oder NULL bei einem Fehler
HBITMAP AFXAPI GetSubBitmap(HBITMAP hSource,int iPosX,int iPosY,int iSizeX,int iSizeY,unsigned uFlags,COLORREF uBkColor)
{
ToolBarData    *pData;
SubBitmapCache	sEntry;
SubBitmapCache	sMemDc;
SubBitmapCache	sLoad;
BITMAPINFO		sInfo;
HWND			hWnd=0;
RECT			sRect;
HRSRC			hRsrc;
HBITMAP			hBitmap;
HGLOBAL			hGlobal;
LPDWORD			pPixel;
HDC				hSrcDc;
HDC				hMemDc;
HDC				hWndDc;
COLORREF		uColor;
UINT			uOffset;
UINT			uDcMode;
UINT			uIndex;
UINT			uType;
UINT			uBits;




	if(hSource==0)return NULL;
	if(iSizeX <=0)return NULL;
	if(iSizeY <=0)return NULL;


	uType = uFlags&GSB_TYPEMASK;


	if(uFlags&GSB_AUTODELETE)							// Soll das Bitmap am Ende gelscht werden
		{
		uFlags         |= GSB_CACHE;
		sEntry.uKey		= iPosX;
		sEntry.uKey	   += iPosY *(2011);
		sEntry.uKey	   += iSizeX*(2011*61);
		sEntry.uKey	   += iSizeY*(2011*61*19);
		sEntry.uKey	   ^= uType;
		sEntry.uKey	   ^= (UINT)hSource;
		sEntry.uType   	= uType;
		sEntry.uSizeX  	= iSizeX;
		sEntry.uSizeY  	= iSizeY;
		sEntry.uPosX   	= iPosX;
		sEntry.uPosY   	= iPosY;
		sEntry.pSource 	= hSource;

		if(uFlags&(GSB_TRANSPARENT|GSB_TRANSFIRST))
			{
			sEntry.uKey^= uFlags&(GSB_TRANSPARENT|GSB_TRANSFIRST|0xFFFFFF);
			sEntry.uKey^= uBkColor;
			}

		   hBitmap = (HBITMAP)SearchSubBitmap(&sEntry);
		if(hBitmap)return hBitmap;
		}


	switch(uType)										// Das Quell-Bitmap holen
		{
	case GSB_BITMAP:

		break;

	case GSB_TOOLBAR:									// Aus Toolbar laden

		uFlags         |= GSB_CACHE;
		sLoad.uKey		= GSB_TOOLBAR;
		sLoad.uKey	   ^= (UINT)hSource;
		sLoad.uType   	= GSB_TOOLBAR;
		sLoad.uSizeX  	= 0;
		sLoad.uSizeY  	= 0;
		sLoad.uPosX   	= 0;
		sLoad.uPosY   	= 0;
		sLoad.pSource 	= hSource;

		    pData = (ToolBarData*)SearchSubBitmap(&sLoad);
		if(!pData)										// Lade Toolbar
			{
				hRsrc  = FindResource(AfxGetResourceHandle(),(LPCTSTR)sLoad.pSource,RT_TOOLBAR);
			if(!hRsrc  )return NULL;
				hGlobal= LoadResource(AfxGetResourceHandle(),hRsrc);
			if(!hGlobal)return NULL;
				pData  = (ToolBarData*)LockResource(hGlobal);
			if(!pData  ){FreeResource(hGlobal);return NULL;}

			ASSERT(pData->wVersion==1);

			sLoad.pItem		= pData;
			sLoad.pHandle	= hGlobal;
			InsertSubBitmap(&sLoad);
			}

		iSizeX	= pData->wWidth;
		iSizeY	= pData->wHeight;

		for(uIndex=0,uOffset=0;;uIndex++)				// Suche die ID in der Toolbar
			{
			if(uIndex>=pData->wItemCount)
				{
				return NULL;
				}

			if(iPosX==pData->wItems[uIndex])			// ID gefunden
				{
				iPosX = uOffset;
				break;
				}

			if(pData->wItems[uIndex])					// Kein Separator
				{
				uOffset += pData->wWidth;
				}
			}

	case GSB_RECOURCE:									// Quell-Bitmap aus Resurce

		uFlags         |= GSB_CACHE;
		sLoad.uKey		= GSB_BITMAP;
		sLoad.uKey	   ^= (UINT)hSource;
		sLoad.uType   	= GSB_BITMAP;
		sLoad.uSizeX  	= 0;
		sLoad.uSizeY  	= 0;
		sLoad.uPosX   	= 0;
		sLoad.uPosY   	= 0;
		sLoad.pSource 	= hSource;

		    hSource = (HBITMAP)SearchSubBitmap(&sLoad);
		if( hSource)break;
			hSource = LoadBitmap(AfxGetResourceHandle(),(LPCTSTR)sLoad.pSource);
		if(!hSource)return NULL;

		sLoad.pItem	= hSource;
		InsertSubBitmap(&sLoad);

		break;

	default:											// Falscher Typ

		return NULL;
		}



	hWndDc	= GetDC(hWnd);

	if(iSizeY==GSB_SIZEFROMSRC)							// Hhe von der Quelle benutzen
		{
		sInfo.bmiHeader.biSize		  	= sizeof(BITMAPINFOHEADER);
		sInfo.bmiHeader.biBitCount	  	= 0;
		sInfo.bmiHeader.biCompression 	= BI_RGB;

		if(!GetDIBits(hWndDc,hSource,0,0,NULL,&sInfo,DIB_RGB_COLORS))
			{
			ReleaseDC(hWnd,hWndDc);
			return 0;
			}

		iSizeY = sInfo.bmiHeader.biHeight;
		}


	if(uFlags&GSB_CACHE)								// Quell-CD aus Cache holen
		{
		sMemDc.uKey		= GSB_HDC;
		sMemDc.uKey	   ^= (UINT)hSource;
		sMemDc.uType   	= GSB_HDC;
		sMemDc.uSizeX  	= 0;
		sMemDc.uSizeY  	= 0;
		sMemDc.uPosX   	= 0;
		sMemDc.uPosY   	= 0;
		sMemDc.pSource 	= hSource;
		uDcMode			= 2;

			hSrcDc =(HDC)SearchSubBitmap(&sMemDc);
		if(!hSrcDc)
			{
			hSrcDc	= CreateCompatibleDC(hWndDc);
			uDcMode = 1;
			}
		}
	else{												// Quell-CD erzeugen
		hSrcDc	= CreateCompatibleDC(hWndDc);
		uDcMode	= 0;
		}


	hMemDc	= CreateCompatibleDC(hWndDc);
	uBits	= GetDeviceCaps(hWndDc,BITSPIXEL);

	if(uBits!=32)										// Keine Alpha-Maske
		{
		hBitmap	= CreateCompatibleBitmap(hWndDc,iSizeX,iSizeY);
		pPixel  = NULL;
		}
	else{												// Mit Alpha-Maske
		BITMAPINFO		sInfo;

		memset(&sInfo,0,sizeof(sInfo));

		sInfo.bmiHeader.biPlanes		= 1;
		sInfo.bmiHeader.biBitCount		= uBits;
		sInfo.bmiHeader.biWidth			= iSizeX;
		sInfo.bmiHeader.biHeight		= iSizeY;
		sInfo.bmiHeader.biCompression	= BI_RGB;
		sInfo.bmiHeader.biSize			= sizeof(BITMAPV4HEADER);

		hBitmap = CreateDIBSection(hWndDc,&sInfo,DIB_RGB_COLORS,(LPVOID*)&pPixel,NULL,0);
		}


	ReleaseDC(hWnd,hWndDc);

	SelectObject(hSrcDc,hSource);
	SelectObject(hMemDc,hBitmap);




	if(uFlags&(GSB_TRANSPARENT|GSB_TRANSFIRST))			// Den DC des neuen Bitmaps bemalen
		{
		if(uFlags&GSB_TRANSFIRST)						// Transparensfarbe von links oben
			{
			uColor = GetPixel(hSrcDc,0,0);
			}
		else{
			uColor = uFlags;
			}

		uColor   &= 0x00FFFFFF;
		uBkColor &= 0x00FFFFFF;

		if(!pPixel)
			{
			sRect.top		= 0;
			sRect.left		= 0;
			sRect.right		= iSizeX;
			sRect.bottom	= iSizeY;

			SetBkColor(hMemDc,uBkColor);
			ExtTextOut(hMemDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
			TransparentBlt(hMemDc,0,0,iSizeX,iSizeY,hSrcDc,iPosX,iPosY,iSizeX,iSizeY,uColor);
			}
		else{
			BitBlt(hMemDc,0,0,iSizeX,iSizeY,hSrcDc,iPosX,iPosY,SRCCOPY);
			uIndex = iSizeX*iSizeY;

			while(uIndex)
				{
				uIndex--;

				if((pPixel[uIndex]&0x00FFFFFF)!=uColor)
						pPixel[uIndex] |= 0xFF000000;
				else	pPixel[uIndex]  = uBkColor;
				}
			}
		}
	else{
		BitBlt(hMemDc,0,0,iSizeX,iSizeY,hSrcDc,iPosX,iPosY,SRCCOPY);
		}


	if(uFlags&GSB_AUTODELETE)							// Soll das Bitmap am Ende gelscht werden
		{
		sEntry.pItem	= hBitmap;
		InsertSubBitmap(&sEntry);
		}

	if(uDcMode==0)										// DC wieder lschen
		{
		DeleteDC(hSrcDc);
		}
	else if(uDcMode==1)									// DC speichern
		{
		sMemDc.pItem	= hSrcDc;
		InsertSubBitmap(&sMemDc);
		}

	DeleteDC(hMemDc);



return hBitmap;
}

//*****************************************************************************
//*
//*		AddMenuBitmap
//*
//*****************************************************************************
//	Fgt zu einem Context-Men ein Icon hinzu
//	pMenu		: Zeige auf das Context-Men
//	uCommand	: Ist die Kommando ID im Context-Men. 
//				  Mit Bit31 wird der Inext benutzt.
//	iBitmapId	: Ist die ID vom Bitmap mit den Icons
//	iIndex		: Ist der Index des Icons das benutzt werden soll	
//	iSizeX		: Ist die Breite eines Icons in Pixel
//	Ergibt TRUE wenn das Icon gesetzt werden konnte
BOOL AFXAPI AddMenuBitmap(CMenu *pMenu,UINT uCommand,int iBitmapId,int iIndex,int iSizeX)
{  
INT			iMode;
HBITMAP		hBmp;	
BOOL		bOk;




		hBmp = GetSubBitmap(iBitmapId,iSizeX*iIndex,0,iSizeX,GSB_SIZEFROMSRC,GSB_CACHE|GSB_AUTODELETE|GSB_TRANSFIRST,GetSysColor(COLOR_MENU));
	if(!hBmp)return FALSE;
	

	if(uCommand&0x80000000)
		{
		uCommand &= 0x7FFFFFFF;
		iMode	  = MF_BYPOSITION; 
		}
	else{
		iMode	  = MF_BYCOMMAND; 
		}
	
	bOk = pMenu->SetMenuItemBitmaps(uCommand,iMode,CBitmap::FromHandle(hBmp),NULL);



return bOk;
}

//*****************************************************************************
//*
//*		ClearFile
//*
//*****************************************************************************
//	Eine Datei in den Papierkorb verschieben
//	pFilename		: Name der zu lschenden Datei
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler.
BOOL AFXAPI ClearFile(LPCTSTR pFilename)
{
TCHAR			cPath[MAX_PATH];
SHFILEOPSTRUCT	sFileOp;
int				iLen;


	memset(&sFileOp,0,sizeof(sFileOp));
	iLen = strlcpy(cPath,pFilename,MAX_PATH-1);
	cPath[iLen+1] = 0;

    sFileOp.wFunc	= FO_DELETE;
    sFileOp.pFrom	= cPath;
    sFileOp.fFlags	= FOF_NOCONFIRMATION|FOF_NOERRORUI|FOF_ALLOWUNDO|FOF_SILENT;

	if(SHFileOperation(&sFileOp))
		{
		return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		MessageBoxSpecial
//*
//*****************************************************************************
//	ffnet eine MessageBox mit Farben wo der Text kopiert werden kann.
//	Siehe MessageBoxIndirectEx() fr eine genaue Beschreibung.
int AFXAPI MessageBoxSpecial(HWND hWnd,LPCTSTR pText,LPCTSTR pCaption,UINT uType)
{
MSGBOXPARAMS	sParams;


	#ifdef _DEBUG
	WNDCLASS sInfo;
	ASSERT(GetClassInfo(AfxGetInstanceHandle(), _T("ColorListBox"), &sInfo));
	// ColorListBoxRegister(hInstance)	muss aufgerufen werden
	#endif 	

	sParams.cbSize				= sizeof(sParams);
	sParams.hwndOwner			= hWnd;
	sParams.hInstance			= 0;
	sParams.lpszText			= pText;
	sParams.lpszCaption 		= pCaption;
	sParams.dwStyle				= uType;
	sParams.lpszIcon			= NULL;
	sParams.dwContextHelpId 	= 0;
	sParams.lpfnMsgBoxCallback	= NULL;
	sParams.dwLanguageId 		= LANG_NEUTRAL;

return MessageBoxIndirectEx(&sParams,0,0);
}
