//*****************************************************************************
//*
//*
//*		FastListWnd.cpp
//*
//*
//*****************************************************************************
//
//	Dieser Code erstellt ein List-Fenster fr groe Mengen an Eintrgen
//
//
//	Copyright (C) Anton Zechner 2010
//
//	FastListWnd is distributed under the GNU GENERAL PUBLIC LICENSE (GPL)
//	Sourcecode which use FastListWnd must be published. Commercial users
//	must published their code too, or make an licence agreement with me.
//
//
//	FastListWnd wird unter GNU GENERAL PUBLIC LICENSE (GPL) vertreiben.
//	Sourcecode welcher FastListWnd verwendet muss verffentlicht werden.
//	Komerzielle Nutzer mssen ihren Code ebenfalls verffentlichen, oder
//	eine Nutzungsvereinbarung mit mir treffen.
//
//	az_software@inode.at
//
//	Version:	1.72		   
//
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#if		   !defined(WINVER)
#define		WINVER 	0x0501
#endif 	
#if		    WINVER <0x0500
#undef		WINVER
#define 	WINVER 	0x0501
#endif 	

#ifdef		UNICODE
#ifndef	   _UNICODE
#define    _UNICODE
#endif
#endif

#include	<tchar.h>
#include	<stdio.h>
#include	<string.h>
#include	<malloc.h>
#include	<windows.h>
#include	<commctrl.h>

#include	"FastListWnd.h"
#include	"WinExtension.h"

#ifdef	   _MSC_VER
#pragma		warning( disable :4996 )
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#ifndef		GWLP_USERDATA
#define 	GWLP_USERDATA		GWL_USERDATA
#endif
#ifndef 	GWLP_WNDPROC
#define 	GWLP_WNDPROC		GWL_WNDPROC
#endif
#ifndef	   _WIN64
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr	SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr	GetWindowLong
#endif
#ifndef		DWORD_PTR
#define		DWORD_PTR			DWORD
#endif
#ifndef		LONG_PTR
#define		LONG_PTR			LONG
#endif
#ifndef		TVP_GLYPH
#define		TVP_GLYPH			2
#endif
#ifndef		GLPS_CLOSED
#define		GLPS_CLOSED			1
#endif
#ifndef		GLPS_OPENED
#define		GLPS_OPENED			2
#endif
#endif
#ifdef		UNICODE
#define 	str_len				(unsigned)wcslen
#define 	str_cmp				wcscmp
#define 	str_ncpy			wcsncpy
#define 	str_ncmp			wcsncmp
#define 	str_icmp			wcsicmp
#else
#define 	str_len				(unsigned)strlen
#define 	str_cmp				strcmp
#define 	str_ncpy			strncpy
#define 	str_ncmp			strncmp
#define 	str_icmp		   _stricmp
#endif
#ifndef		WM_MOUSEWHEEL
#define		WM_MOUSEWHEEL		0x020A
#endif
#ifndef		WHEEL_DELTA
#define		WHEEL_DELTA			120
#endif
#define		MAX_COLORS			13
#define 	SPECIAL_MAX			24
#define 	SPECIAL_WIDTH		16
#define 	EN_SETTEXT			0x1000
#define 	EN_RETURN			0x1578
#define 	EN_ESCAPE			0x1579
#define 	ID_UPDATE			0x3911
#define 	ID_TOOLTIPCHECK		0x3912
#define 	FIRST_LINE			0xFFFFFFFE
#define 	FROM_HEADER			0x88776655
#define 	NOTHEME				((LPVOID)1)
#define 	U(h)				((unsigned)(h))
#define 	THEMEIMGLIST		((HIMAGELIST)1)
#define		CF_TEXT_EX			((sizeof(TCHAR)>1)? CF_UNICODETEXT:CF_TEXT)
#define 	GetHandle(h)		((FastListData*)GetWindowLongPtr(h,0))
#define 	SYNCH_TYPE			CRITICAL_SECTION
#define 	SYNCH_CREATE(d)		InitializeCriticalSection(&d->sSynch);
#define 	SYNCH_DELETE(d)		DeleteCriticalSection(&d->sSynch);
#define 	UNLOCK(d)			{													\
								if(d->sSynch.LockCount==0xFFFFFFFF)					\
									{												\
									char aLine[16];									\
									sprintf(aLine,"%i",__LINE__);					\
									MessageBoxA(0,aLine,"Unlock Error",MB_OK);		\
									}												\
								LeaveCriticalSection(&d->sSynch);					\
								}
#define 	N					(sizeof(int)   /sizeof(TCHAR))
#define 	M					(sizeof(LPBYTE)/sizeof(TCHAR))
#define 	LOCK(d)				EnterCriticalSection(&d->sSynch);
#define 	LVIS_EDIT(m)		((1<<m)&((1<<LVAX_EDIT)|(1<<LVAX_COMBO)|(1<<LVAX_STEPED)|(1<<LVAX_CHECKED)))
#define 	LVIS_TRACKED		(LVIX_TRACKED<<16)
#define 	LVC_DESELECT		0x8000
#define 	BPBF_COMPATIBLEBM	0
#define 	LVIX_FIRSTSEL		0x01						// Der Eintrag war der ausgewhlte Eintrag
#define 	LVIX_UPDATE			0x02						// Der Eintrag muss upgedatet werden
#define 	LVIX_TRACKED		0x08						// Der Eintrag unter dem Cursor
#define 	LVIX_FOCUSED		0x40						// Der Eintrag hat einen Eingabe-Focus
#ifndef		BP_CHECKBOX
#define		BP_CHECKBOX			3
#endif
#ifndef		CBS_UNCHECKEDNORMAL
#define		CBS_UNCHECKEDNORMAL 1
#endif
#ifndef		CBS_UNCHECKEDHOT
#define		CBS_UNCHECKEDHOT	2
#endif
#ifndef		CBS_UNCHECKEDPRESSED
#define		CBS_UNCHECKEDPRESSED 3
#endif
#ifndef		CBS_UNCHECKEDDISABLED
#define		CBS_UNCHECKEDDISABLED 4
#endif
#ifndef		CBS_CHECKEDNORMAL
#define		CBS_CHECKEDNORMAL	5
#endif
#ifndef		CBS_CHECKEDHOT
#define		CBS_CHECKEDHOT		6
#endif
#ifndef		CBS_CHECKEDPRESSED
#define		CBS_CHECKEDPRESSED	7
#endif
#ifndef		CBS_CHECKEDDISABLED
#define		CBS_CHECKEDDISABLED	8
#endif
#ifndef		GET_X_LPARAM
#define		GET_X_LPARAM(x)		((short)LOWORD(x))
#endif
#ifndef		GET_Y_LPARAM
#define		GET_Y_LPARAM(x)		((short)HIWORD(x))
#endif
#ifndef		DC_BRUSH
#define 	DC_BRUSH			18
#endif
#ifndef		DC_PEN
#define		DC_PEN				19
#endif
#ifdef		DrawText
#undef 		DrawText
#define 	DrawText(h,p,n,r,f)	DrawTextEx(h,(LPTSTR)(p),n,r,f,0)
#endif


#define 	LVAX_NONE			(LVAE_NONE   >>LVAE_MODEPOS)// Kein atomatisches editieren
#define 	LVAX_EDIT			(LVAE_EDIT	 >>LVAE_MODEPOS)// Atomatisches editieren mit Edit-Fenster
#define 	LVAX_COMBO			(LVAE_COMBO	 >>LVAE_MODEPOS)// Atomatisches editieren mit ComboBox
#define 	LVAX_CBLIST			(LVAE_CBLIST >>LVAE_MODEPOS)// Atomatisches editieren mit ComboListBox
#define 	LVAX_STEP			(LVAE_STEP	 >>LVAE_MODEPOS)// Einzelnes Weiterschalten mit Enter
#define 	LVAX_STEPED			(LVAE_STEPED >>LVAE_MODEPOS)// Einzelnes Weiterschalten mit Enter und Edit
#define 	LVAX_CHECK			(LVAE_CHECK	 >>LVAE_MODEPOS)// Atomatisches editieren mit CheckBox
#define 	LVAX_CHECKED		(LVAE_CHECKED>>LVAE_MODEPOS)// Atomatisches editieren mit CheckBox und Edit

typedef struct
	{
	LPARAM		lParam;										// Ist der LPARAM Wert fr den Eintrag
	WORD		uState;										// Zustand des Eintrages
	BYTE		bFlags;										// Diverse Flags
	BYTE		bStart;										// Anzahl der Spezialzeichen
	}BaseItem;

typedef struct
	{
	void 	   *pCbData;									// Daten fr das Autoeditieren
	short 		sSize;										// Ist die soll Breite einer Spalte
	short 		sReal;										// Ist die wirkliche Breite einer Spalte
	short 		sMin;										// Ist die Ausrichtung einer Spalte
	short  	    sFixed;										// Ist die Spalte fixiert (ist die Breite vor dem Fixieren)
	BYTE		bMinEx;										// Darf die Spaltenbreite auch nicht vom User unterschritten werden
	BYTE		bWeight;									// Gewicht der variable Spalten
	BYTE		bNext;										// Ist die Spalte die nach der eigenen sichtbar ist	(gespeicherte Reihenfolge)
	BYTE		bIndex;										// Ist die Spalte in der diese Reihe sichtbar ist (sichtbarer Index)
	BYTE  	    bAlign;										// Textausrichtung fr die Spalten
	BYTE  	    bEdit;										// Automaisches Editieren einer Spalte (siehe LVAE_???>>7)
	BYTE  	    bFlags;										// Automaisches Editieren einer Spalte (siehe LVAE_???)
	BYTE  	    bEnable;									// Automaisches einer mit Statebits aktivieren
	BYTE  	    bCbSize;									// Maximale Anzahl der Eintrge in der Datenliste
	BYTE  	    bCbChar;									// Trennzeichen fr die Datenliste
	BYTE  	    bMark;										// Ist die Spalte markiert
	BYTE  	    bDummy[32-19-sizeof(void*)];				// Fllbytes auf 32 Grenze
	}ColumnData;

typedef struct
	{
	HWND		hWnd;										// Fenster Handle
	SYNCH_TYPE	sSynch;										// Zugriffsbeschgrnkung
	LPVOID		hThemeBt;									// Handle fr benutztes Thema (BUTTON)
	WNDPROC		pProcId3;									// Fenster Funktion fr ID3 Fenster
	HIMAGELIST	hStates;									// Handle der Icon-Liste fr States und Overlay
	HIMAGELIST	hImages;									// Handle der Icon-Liste
	HIMAGELIST	hChecks;									// Handle der Icon-Liste fr die Checkboxen in den Spalten
	HIMAGELIST	hSubImg;									// Handle der Icon-Liste fr die Spalten
	HIMAGELIST	hHdrImg;									// Handle der Icon-Liste fr den Header
	HFONT		hFontN;										// Ist der normale Zeichensatz
	HFONT		hFontB;										// Ist der fette Zeichensatz
	HFONT		hFontE;										// Ist der zweite Font fr's Einzelfarben
	HFONT		hFontF;										// Ist der dritte Font fr's Einzelfarben
	HFONT		hFontL;										// Der letzte zugewiesene Font
	HFONT		hFontX;										// Der letzte erzeugte fette Font
	HFONT		hFontT;										// Ist der Font fr das Tooltip
	HWND		hEdit;										// Handle des Edit-Fensters
	HWND		hHeader;									// Handle des Header Fensters
	HWND		hToolTip;									// Handle des Tooltip-Fensters
	WNDPROC		pToolProc;									// Alte Fensterfunktion des Tooltips
	COLORREF	aColors[MAX_COLORS];				 		// 0=Hintergrundfarbe  1=Abwechselnte Farbe  2=Farbe fr Trennlinien  3=Textfarbe
	PFNFLCLOSE	pCloseCallback;								// Callback beim Schlieen des Fensters
	LPVOID		pCloseCbParam;								// Parameter fr Schlieen-Callback
	PFNFLLINECB	pLineCallback;								// Callback um Zeilendaten zu holen
	LPVOID		pLineCbParam;								// Parameter fr Zeilen-Callback
	PFNFLDRAWCB	pDrawCallback;								// Callback um linken Breich zu zeichnen
	LPVOID		pDrawCbParam;								// Parameter fr Breichs-Callback
	UINT		uDrawCbSize;								// Breite des linken Breichs
	LPCOLORREF	pCharColors;								// Zeiger auf 32 Farben fr Buchstaben
	LPINT		pTempPos;									// Temporre Positionen
	LPTSTR		pTempPtr;									// Temporrer Text
	unsigned	uTempSize;									// Gre vom Temporr Speicher
	int			iFontHeight;								// Ist die Hhe des Fonts
	int			iFontLine;									// Ist die Position der Linie beim unterstreichen
	int			iFontOff;									// Ist die Position um der ein Text horizontal verschoben wird
	int			iStatesSizeX;								// Breite der States und Overlay Icons
	int			iStatesSizeY;								// Hhe   der States und Overlay Icons
	int			iChecksSizeX;								// Breite der States und Overlay Icons
	int			iChecksSizeY;								// Hhe   der States und Overlay Icons
	int			iImagesSizeX;								// Breite der Icons
	int			iImagesSizeY;								// Hhe   der Icons
	int			iSubImgXsize;								// Breite der Icons
	int			iSubImgYsize;								// Hhe   der Icons
	int			iRowHeight;									// Ist die Hhe einer Zeile
	int			iVarSize;									// Ist die Breite aller variablen Spalten
	int			iFixSize;									// Ist die Breite aller fixen Spalten
	int			iMaxSizeX;									// Die Gre des breitesten sichtbaren Eintrages
	int			iLeftColumn;								// Linkeste Spalte fr Tasterureingaben
	int			iFieldOffset;								// Offset der Daten in erxrenen Autozeiger
	int			iFieldSortMem;								// Offset des Sortierspeichers
	int		   *pFieldCounter;								// Zeiger auf die externe Gre
	LPBYTE    **pFieldPointer;								// Zeiger auf externen Autozeiger
	BaseItem   *pListItems;									// Zeiger auf Item Zeiger
	unsigned	uListItemsMax;								// Gre der Liste mit den vorhanden Eintrge (allokiert um 1 grer)
	unsigned	uListItemsCount;							// Anzahl der vorhanden Eintrge
	unsigned	uListItemsCountTmp;							// Anzahl der vorhanden Eintrge frs Schnelleinfgen
	unsigned	uLastScrolY;								// Wann wurde zuletzt die Y-Scrollbar gezeichnet
	unsigned	uScrollYtmp;								// Aktuelle Y-Scroll-Position fr schnell einfgen
	unsigned	uScrollY;									// Aktuelle Y-Scroll-Position
	unsigned	uScrollX;									// Aktuelle X-Scroll-Position
	unsigned	uSizeX;										// Aktuelle X-Fenster-Gre
	unsigned	uSizeY;										// Aktuelle Y-Fenster-Gre
	unsigned	uSizeYsub;									// Aktuelle Y-Fenster-Gre ohne Header
	unsigned	uStyle;										// Ist der aktuelle Style des Fensters
	unsigned	uStyleEx;									// Erweiterte Sytle-Flags (siehe LVS_EX_???)
	unsigned	uStartPixel;								// Ist die Y-Koordinate bei der der erste Eintrag beginnt
	unsigned	uUpdateEnsure;								// EnsureFisible bei Update machen
	unsigned	uUpdateEnMode;								// EnsureFisible bei Update Modus
	unsigned	uUpdateEnSub;								// EnsureFisible bei Update Sub
	unsigned	uUpdateRow;									// UpdateRows-Start bei Update
	unsigned	uUpdateEnd;									// UpdateRows-Anzahl bei Update
	unsigned	uUpdateTip;									// Soll das ToolTip aktualisiert werden
	unsigned	uMaxEnties;									// Anzahl der sichtbaren Eintrge (inkl. halbsichtbare)
	unsigned	uPageEnties;								// Anzahl der sichtbaren Eintrge (ohne  halbsichtbare)
	unsigned	uColumnCount;								// Anzahl der Spalten
	unsigned	uColumnCountVar;							// Anzahl der variabeln Spalten
	unsigned	uSelectedCount;								// Anzahl der ausgewhlten Eintrge
	unsigned	uSelectedBase;								// Ist der Eintrag ab dem gewhlt wurde
	unsigned	uSelectedItem;								// Ist der Eintrag der gerade gewhlt ist
	unsigned	uSelectedSub;								// Ist die Spalte die gerade gewhlt ist
	unsigned	uCheckedDown;								// Ist die Checkbox gerade gedrckt
	unsigned	uCheckedItem;								// Ist die Checkbox ber der der Cursor steht
	unsigned	uCheckedSub;								// Ist die Spalte der Checkbox ber der der Cursor steht
	unsigned	uFocusItem;									// Ist der Eintrag der einen leeren Fokus hat
	unsigned	uFocusSub;									// Ist die Spalte die einen leeren Fokus hat
	unsigned	uColorOff;									// Bei welchen LVIS_??? States sollen die Einzelfarben deaktiviert werden
	unsigned	uToolTipItem;								// Ist der ToolTip-Eintrag der gerade gewhlt ist
	unsigned	uToolTipShow;								// Ist die Zeitverzgerung in 500 ms Schritten fr das Tooltip
	unsigned	uToolTipSub;								// Ist die ToolTip-Spalte die gerade gewhlt ist
	POINT		sToolTipPos;								// Ist die globale Koordinate des ToolTips
	unsigned	uEditMode;									// Ist der Modus des Editfensters (0=Edit 1=ComboBox 2=ComboBox fix)
	unsigned	uEditItem;									// Ist der Eintrag der gerade editiert wird
	unsigned	uEditSub;									// Ist die Spalte die gerade editiert wird
	unsigned	uOldPageX;									// Alte Werte fr X-Scroll-Bar
	unsigned	uOldCountX;									//			*
	unsigned	uOldPageY;									// Alte Werte fr Y-Scroll-Bar
	unsigned	uOldCountY;									//			*
	unsigned	uTrippleB;									// Bereite des "..." Strings fr den fetten Fonts
	unsigned	uTrippleN;									// Bereite des "..." Strings fr den normalen Fonts
	unsigned	uTrackedItem;								// Ist der Eintrag der unterstrichen werden soll
	unsigned	uTrackedSub;								// Ist die Spalte des Eintrages der unterstrichen werden soll
	unsigned	uMarkedCols;								// Anzahl der markierten Spalten
	unsigned	uDragFlags;									// Welche Maustasten sind an
	unsigned	uDragItem;									// Eintrag fr Drag-Operation
	unsigned	uDragSub;									// Untereintrag fr Drag-Operation
	unsigned	uLastSel;									// Letzte Textauswahl beim Editieren
	unsigned	uLastMove;									// Letzte Cursorposition bei WM_MOUSEMOVE
	unsigned 	uButtonPos;									// Wo wurde eine Maustaste wurde zuletzt gedrckt
	unsigned 	uButtonLast;								// Wann wurde eine Maustaste wurde zuletzt gedrckt
	unsigned	uStartOffset;								// Leerbereich zwischen Header und erster Zeile
	unsigned	uToolTipSize;								// Textspeichergre fr Tooltip
	LPTSTR		pToolTipText;								// Textspeicher fr Tooltip
	TCHAR		cTempText1   [264];							// Erster Textpuffer fr Callbacks
	TCHAR		cTempText2   [2052];						// Zeiter Textpuffer fr Callbacks
	ColumnData	aColumn      [FL_MAX_COLUMNS];				// Daten der Spalten
	int			aColumnXpos  [FL_MAX_COLUMNS+2];			// Array mit den Positionen der Spalten
	BYTE		aColumnPos   [FL_MAX_COLUMNS+2];			// Array mit Anzeigepositionen der Spalten
	char		aColorChanged[MAX_COLORS];					// Welche Farbe wurden verndert
	char		cEditClickMode;								// Editklickoptionen (Bit0=nur auf Text, Bit1=direkt ohne Auswahl)
	char		cUpdateScrollY;								// Die Y-Scroll-Position aktualisieren
	char		cUpdateScrollX;								// Die X-Scroll-Position aktualisieren
	char		cUpdateResel;								// Es gab nderungen bei der Auswahl
	char		cUpdateTimer;								// Ist der Update-Timer an
	char		cUpdateItems;								// Updaten jedes einzelnen Eintrages
	char		cUpdateRows;								// Updaten von Zeilen
	char		cUpdateView;								// Das Fenster aktualisieren
	char		cUpdateFlag;								// Sollen diverse nderungen ber Updates gemacht werden
	char   	    cColumnStart;								// Wurde das Autoeditiren mit einer WM_CHAR Eingabe gestartet
	char 		cFixedHeight;								// Ist eine fixe Hhe eingestellt
	char		cLockChanges;								// Sperren von Fensternderungen (beim Sortieren)
	char		cButtonSize;								// Ist die Gre der der +- Taste
	char		cButtonFlag;								// Welche Maustaste wurde zuletzt gedrckt
	char		cStatesMode;								// Die hStates Image-Liste wurde fr die Checkboxen erzeugt
	char		cChecksMode;								// Die Checks Image-Liste wurde fr die Checkboxen erzeugt
	char		cSubImgMode;								// Die SubImg Image-Liste ist nicht die hImages Liste
	char		cImagesMode;								// Die allgemeine Image-Liste fr Icons
	char		cRedrawFlag;								// Das neuzeichnen sperren
	char		cKeyIgnore;									// Die nchste Taste nicht fr Sucher verwenden
	char		cClickFlag;									// Merker fr LBUTTON-DOWN bei Multiselect
	char		cClickEdit;									// Merker fr LBUTTON-DOWN bei Edit-Click
	char		cIsEnabled;									// Ist das Fenster freigegeben
	char		cFastFlag;									// Wurde etwas schnell eingefgt
	char		cHasFocus;									// Hat das Fenster den Fokus
	char		cReSelect;									// Soll die Auswahl neu selektiert werden
	}FastListData;

typedef	HRESULT (WINAPI *SetWindowThemeT )(HWND,LPCWSTR,LPCWSTR);
typedef	HRESULT (WINAPI *EndBufferedPtT  )(HANDLE,BOOL);
typedef	HANDLE  (WINAPI *BeginBufferedPnT)(HDC,RECT*,DWORD,LPVOID,HDC*);
typedef	HRESULT (WINAPI *BufferedPtInitT )(VOID);
typedef	HRESULT (WINAPI *BufferedPtInitT )(VOID);
typedef	LPVOID  (WINAPI *OpenThemeDataT  )(HWND hwnd,LPCWSTR pszClassList);
typedef	HRESULT (WINAPI *CloseThemeDataT )(LPVOID);
typedef	HRESULT (WINAPI *DrawThemeBackgT )(LPVOID,HDC,int,int,const RECT*,const RECT*);
typedef	HRESULT (WINAPI *GetThemeBackgRcT)(LPVOID,HDC,int,int,LPCRECT,LPRECT);
typedef	HRESULT (WINAPI *GetThemePartSzT )(LPVOID,HDC,int,int,LPCRECT,int,LPSIZE);

static HMODULE			hUxThemeDll		= NULL;
static SetWindowThemeT	pSetWindowTheme	= NULL;
static EndBufferedPtT	pEndBufferedPt  = NULL;
static BeginBufferedPnT	pBeginBufferedPt= NULL;
static BufferedPtInitT	pBufferedPtInit = NULL;
static BufferedPtInitT	pBufferedPtExit = NULL;
static OpenThemeDataT	pOpenThemeData	= NULL;
static CloseThemeDataT	pCloseThemeData	= NULL;
static DrawThemeBackgT	pDrawThemeBackg	= NULL;
static GetThemeBackgRcT	pGetThemeBackgRc= NULL;
static GetThemePartSzT	pGetThemePartSz = NULL;

static LPVOID			hTheme			= NULL;
static HPEN				hPatternPen		= NULL;
static HFONT			hDefaultFontN	= NULL;
static HFONT			hDefaultFontB	= NULL;
static LONG				lWindowCount	= -1;
static RECT				sToolRect={-2,0,2,64};
static TCHAR			cKeyData[16];
static unsigned 		uKeyLast;
static unsigned 		uKeyPos;
static int		 		iKeyItem;
static void				FastListDraw(HWND hWnd,HDC hDc,RECT *pRect);
static LRESULT CALLBACK FastListProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
static int				FastListSelectItem     (FastListData *pData,unsigned uItem,unsigned uSubItem,int iDel);
static int				FastListGetItemRect    (FastListData *pData,unsigned uItem,unsigned uFlags,RECT *pRect);
static int				FastListStartNotifyEdit(FastListData *pData,unsigned uItem,unsigned uSub,WPARAM wParam,LPARAM lParam);
static int				FastListStartAutoEdit  (FastListData *pData,unsigned uColumn,WPARAM wParam,LPARAM lParam);
static int				FastListEndLabelEdit   (FastListData *pData,int iMode);


//*****************************************************************************
//*
//*		FastListRegister
//*
//*****************************************************************************
//	Registiert das FastList Fenster.
//	Ergibt 1 wenn das Fenster erfolgreich registiert wurde.
int FastListRegister(HINSTANCE hInstance)
{
static int		iIsRegistered=FALSE;
WNDCLASSEX		sClass;


    if(iIsRegistered)return TRUE;


    memset(&sClass,0,sizeof(sClass));

    sClass.cbSize           = sizeof(sClass);
    sClass.style            = CS_DBLCLKS;
    sClass.lpfnWndProc      = FastListProc;
    sClass.cbClsExtra       = 0;
    sClass.cbWndExtra       = sizeof(FastListData*);
    sClass.hInstance        = hInstance;
    sClass.hIcon            = NULL;
    sClass.hCursor          = LoadCursor(NULL,IDC_ARROW);
    sClass.hbrBackground	= NULL;
    sClass.lpszMenuName     = NULL;
    sClass.hIconSm          = NULL;
    sClass.lpszClassName	= _T("FastList");

    if(!RegisterClassEx(&sClass))return 0;

    iIsRegistered = TRUE;


return TRUE;
}

//*****************************************************************************
//*
//*		GlobalInit
//*
//*****************************************************************************
static void GlobalInit()
{
LOGBRUSH	sLog;
long		lCount;



	   lCount = InterlockedIncrement(&lWindowCount);
	if(lCount>0)return;

	sLog.lbColor = GetSysColor(COLOR_BTNSHADOW);
	sLog.lbStyle = PS_SOLID;
	sLog.lbHatch = 0;
	hPatternPen  = ExtCreatePen(PS_COSMETIC|PS_ALTERNATE,1,&sLog,0,NULL);

    if(!hPatternPen)
		{
		hPatternPen = CreatePen(PS_DOT,1,RGB(0,0,0));
		}


	if(!hUxThemeDll)
		{
		   hUxThemeDll = LoadLibrary(_T("UxTheme.dll"));
		if(hUxThemeDll)
			{
			pSetWindowTheme  = (SetWindowThemeT )GetProcAddress(hUxThemeDll,"SetWindowTheme"     );
			pEndBufferedPt   = (EndBufferedPtT  )GetProcAddress(hUxThemeDll,"EndBufferedPaint"   );
			pBeginBufferedPt = (BeginBufferedPnT)GetProcAddress(hUxThemeDll,"BeginBufferedPaint" );
			pBufferedPtInit	 = (BufferedPtInitT	)GetProcAddress(hUxThemeDll,"BufferedPaintInit"  );
			pBufferedPtExit  = (BufferedPtInitT	)GetProcAddress(hUxThemeDll,"BufferedPaintUnInit");
			pOpenThemeData	 = (OpenThemeDataT	)GetProcAddress(hUxThemeDll,"OpenThemeData"		 );
			pCloseThemeData	 = (CloseThemeDataT	)GetProcAddress(hUxThemeDll,"CloseThemeData"	 );
			pDrawThemeBackg	 = (DrawThemeBackgT )GetProcAddress(hUxThemeDll,"DrawThemeBackground");
			pGetThemePartSz  = (GetThemePartSzT	)GetProcAddress(hUxThemeDll,"GetThemePartSize"   );
			pGetThemeBackgRc = (GetThemeBackgRcT)GetProcAddress(hUxThemeDll,"GetThemeBackgroundContentRect");

			}
		}

	if(pBufferedPtInit)
		{
		pBufferedPtInit();
		}

}


//*****************************************************************************
//*
//*		GlobalDeinit
//*
//*****************************************************************************
static void GlobalDeinit()
{
int	lCount;


	   lCount=InterlockedDecrement(&lWindowCount);
	if(lCount>=0)return;

    if(hPatternPen)
        {
        DeleteObject(hPatternPen);
        hPatternPen = NULL;
        }

	if(hTheme && hTheme!=NOTHEME)
		{
		pCloseThemeData(hTheme);
		hTheme = NULL;
		}

	if(pBufferedPtExit)
		{
		pBufferedPtExit();
		}

}


//*****************************************************************************
//*
//*		AllocTemp
//*
//*****************************************************************************
//	Temprren speicher allokieren
static inline void AllocTemp(FastListData *pData,LPINT *pPos,LPTSTR *pPtr,unsigned uTextSize)
{

	uTextSize += 4;

	if(pData->uTempSize<uTextSize)
		{
		if(pData->uTempSize)
			{
			delete pData->pTempPos;
			delete pData->pTempPtr;
			}

		pData->uTempSize = (uTextSize+0xFF)&~0xFF;
		pData->pTempPos	 = new INT  [pData->uTempSize+4];
		pData->pTempPtr	 = new TCHAR[pData->uTempSize+4];
		}

	if(pPos)*pPos=pData->pTempPos;
	if(pPtr)*pPtr=pData->pTempPtr;

}


//*****************************************************************************
//*
//*		SendNotify
//*
//*****************************************************************************
//	Sendet eine WM_NOTIFY Nachricht an das Elternfenster
//	pData		: Zeiger auf die Fensterdaten
//	pNotify		: Zeiger auf die Notify-Daten
//	Ergibt den Rckgabewert der WM_NOTIFY Nachrich
static LRESULT SendNotify(FastListData *pData,NMHDR	*pNotify)
{


	pNotify->hwndFrom	= pData->hWnd;
    pNotify->idFrom		= GetWindowLong(pNotify->hwndFrom,GWL_ID);


return SendMessage(GetParent(pNotify->hwndFrom),WM_NOTIFY,pNotify->idFrom,(LPARAM)pNotify);
}


//*****************************************************************************
//*
//*		EditProc
//*
//*****************************************************************************
//	Ist die Fensterfunktion fr das Edit Fenster
static LRESULT CALLBACK EditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
FastListData   *pData;
WNDPROC			pProc;
DWORD			dwStop;
DWORD			dwStart;
DWORD			dwCount;
HWND			hParent;
HWND			hCombo;
LRESULT			lResult;
int				iDelta;
int				iState;
int				iPos;
int				iId;


	hParent = GetParent(hWnd);
	iId		= GetWindowLong(hWnd,GWL_ID);

	if(iId==3)
		{
		hCombo  = hWnd;
		pData   = GetHandle(hParent);
		pProc   = pData->pProcId3;
		}
	else{
		hCombo  = hParent;
		hParent = GetParent(hParent);
		pData   = GetHandle(hParent);
		pProc   = (WNDPROC)GetWindowLongPtr(hWnd,GWLP_USERDATA);
		}


	if(uMsg==WM_KEYDOWN)
		{
		if(wParam==VK_RETURN)
			{
			SendMessage(hParent,WM_COMMAND,MAKELONG(3,EN_RETURN),(LPARAM)hWnd);
			return 0;
			}

		if(wParam==VK_ESCAPE)
			{
			SendMessage(hParent,WM_COMMAND,MAKELONG(3,EN_ESCAPE),(LPARAM)hWnd);
			return 0;
			}

		if((pData->uStyleEx&LVS_EX_STEPOUT) && !(GetAsyncKeyState(VK_SHIFT)&0x8000))
			{
			switch(wParam)										// Aus Fenster springen
				{
			case VK_UP:		if(pData->uEditMode)break;
							PostMessage(hParent,WM_COMMAND,MAKELONG(3,EN_RETURN),(LPARAM)hWnd);
							PostMessage(hParent,WM_KEYDOWN,VK_UP  ,0x00500001);
							PostMessage(hParent,WM_KEYUP  ,VK_UP  ,0x00500001);
							return 0;

			case VK_DOWN:	if(pData->uEditMode)break;
							PostMessage(hParent,WM_COMMAND,MAKELONG(3,EN_RETURN),(LPARAM)hWnd);
							PostMessage(hParent,WM_KEYDOWN,VK_DOWN,0x00500001);
							PostMessage(hParent,WM_KEYUP  ,VK_DOWN,0x00500001);
							return 0;

			case VK_LEFT:	if(pData->uEditMode && iId==3)break;
							SendMessage(hWnd,EM_GETSEL,(WPARAM)&dwStart,(LPARAM)&dwStop);
							if(dwStart || dwStop)break;
							PostMessage(hParent,WM_COMMAND,MAKELONG(3,EN_RETURN),(LPARAM)hWnd);
							PostMessage(hParent,WM_KEYDOWN,VK_LEFT,0x00500001);
							PostMessage(hParent,WM_KEYUP  ,VK_LEFT,0x00500001);
							return 0;

			case VK_RIGHT:	if(pData->uEditMode && iId==3)break;

							SendMessage(hWnd,EM_GETSEL,(WPARAM)&dwStart,(LPARAM)&dwStop);
							   dwCount=(DWORD)SendMessage(hWnd,EM_LINELENGTH,0,0);
							if(dwCount>dwStart)break;
							if(dwCount>dwStop )break;

							PostMessage(hParent,WM_COMMAND,MAKELONG(3,EN_RETURN),(LPARAM)hWnd);
							PostMessage(hParent,WM_KEYDOWN,VK_RIGHT,0x00500001);
							PostMessage(hParent,WM_KEYUP  ,VK_RIGHT,0x00500001);
							return 0;
				}
			}


		if(wParam==VK_DOWN && pData->uEditMode)
			{
			if(!SendMessage(hCombo,CB_GETDROPPEDSTATE,0,0))
				{
				SendMessage(hCombo,CB_SHOWDROPDOWN,1,0);
				return 0;
				}
			}
		}
	else if(uMsg==WM_CHAR)
		{
		if(wParam==VK_RETURN)
			{
			return 0;
			}

		if(wParam==VK_ESCAPE)
			{
			return 0;
			}
		}
	else if(uMsg==WM_COMMAND)
		{
		if(wParam==MAKELONG(3,EN_ESCAPE) || wParam==MAKELONG(3,EN_RETURN))
			{
			SendMessage(hParent,WM_COMMAND,wParam,(LPARAM)hWnd);
			return 0;
			}
		}
	else if(uMsg==WM_MOUSEWHEEL)
		{
		   iState=(int)CallWindowProc(pProc,hWnd,CB_GETDROPPEDSTATE,0,0);
		if(iState)
			{
			iDelta  = (short)HIWORD(wParam);
			iDelta /= WHEEL_DELTA;
			iPos	= (int)CallWindowProc(pProc,hWnd,CB_GETTOPINDEX,0,0);
			iPos   -= iDelta;
			CallWindowProc(pProc,hWnd,CB_SETTOPINDEX,iPos,0);
			return 0;
			}
		}
	else if(uMsg==WM_GETDLGCODE)						// Welche Tasten werden im Dialog benutzt
		{
		return DLGC_WANTALLKEYS;
		}
	else if(uMsg==WM_SETTEXT)
		{
		lResult = CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);;
		SendMessage(hParent,WM_COMMAND,MAKELONG(3,EN_SETTEXT),(LPARAM)hWnd);
		return lResult;
		}


return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		DrawSpecial
//*
//*****************************************************************************
static int DrawSpecial(HDC hDc,LPCTSTR pText,int iSize,LPRECT pRect,int iWidth,int iStep)
{
RECT		sRect;
RECT		sArea;
unsigned	uChar;
int			iOff;
int			iPos;
int			iMid;



	SelectObject(hDc,GetStockObject(GRAY_BRUSH));
	SelectObject(hDc,GetStockObject(NULL_PEN  ));


	sRect.left		= pRect->left;
	sRect.top		= pRect->top;
	sRect.bottom	= pRect->bottom;
	sRect.right		= sRect.left+iWidth;


	for(iPos=0;iPos<iSize;iPos++)						// Text durchlaufen
		{
		   uChar = pText[iPos];
		if(uChar>=SPECIAL_MAX)break;

		ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);

		iOff	=  sRect.left+iWidth/2;
		iMid	= (sRect.top+sRect.bottom-1)/2;

		switch(uChar&7)
			{
		case 1:											// | Linie zeichnen

				Rectangle(hDc,iOff,sRect.top,iOff+2,sRect.bottom+1);
				break;

		case 2:											// L Linie zeichnen
				Rectangle(hDc,iOff  ,sRect.top  ,iOff+2,iMid+2);
				Rectangle(hDc,iOff+1,iMid,sRect.right+1,iMid+2);
				break;

		case 3:											// T Linie zeichnen (90)
				Rectangle(hDc,iOff,sRect.top    ,iOff+2,sRect.bottom+1);
				Rectangle(hDc,iOff+1,iMid,sRect.right+1,iMid+2);
				break;

		case 4:											// - Linie zeichnen (lang)
				Rectangle(hDc,sRect.left,iMid,sRect.right+1,iMid+2);
				break;

		case 5:											// F Linie zeichnen
				Rectangle(hDc,iOff  ,iMid,iOff+2,sRect.bottom+1);
				Rectangle(hDc,iOff+1,iMid,sRect.right+1,iMid+2);
				break;

		case 6:											// T Linie zeichnen
				Rectangle(hDc,iOff  ,iMid,iOff+2,sRect.bottom+1);
				Rectangle(hDc,sRect.left,iMid,sRect.right+1,iMid+2);
				break;

		case 7:											// - Linie zeichnen (kurz)
				Rectangle(hDc,iOff+1,iMid,sRect.right+1,iMid+2);
				break;

			}

		if(uChar>=8)									// Klapptaste zeichnen
			{
			if(hTheme==NULL)
				{
				if(pOpenThemeData)
					{
					hTheme = pOpenThemeData(NULL,L"TREEVIEW");
					}

				if(!hTheme)hTheme=NOTHEME;
				}

			if(hTheme==NOTHEME)							// Kein Thema vorhanden
				{
				SelectObject(hDc,GetStockObject(WHITE_BRUSH));
				SelectObject(hDc,GetStockObject(BLACK_PEN  ));

				Rectangle(hDc,iOff-iStep,iMid-iStep,iOff+iStep+1,iMid+iStep+1);

				SelectObject(hDc,GetStockObject(NULL_PEN    ));
				SelectObject(hDc,GetStockObject(DKGRAY_BRUSH));

				iStep -= 2;

				if(uChar>=16)
				Rectangle(hDc,iOff      ,iMid-iStep,iOff      +2,iMid+iStep+2);
				Rectangle(hDc,iOff-iStep,iMid      ,iOff+iStep+2,iMid      +2);

				SelectObject(hDc,GetStockObject(GRAY_BRUSH));
				}
			else{										// Mit Thema zeichnen
				sArea.top	  = iMid-iStep;
				sArea.bottom  = iMid+iStep+1;
				sArea.left    = iOff-iStep;
				sArea.right   = iOff+iStep+1;

				pDrawThemeBackg(hTheme,hDc,TVP_GLYPH,(uChar>=16)? GLPS_CLOSED:GLPS_OPENED,&sArea,0);
				}
			}

		sRect.left  += iWidth;
		sRect.right	+= iWidth;
		}


return iPos;
}

//*****************************************************************************
//*
//*		GetDataEntry
//*
//*****************************************************************************
//	Holt die Daten von einen einzelnen Spalteneintrag
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages
//	uCol		: Ist die Nummer der Spalte
//	pEntry		: Hier werden die Daten gsepeichert
//	uState		: Status der via Callback bergeben wird
static void GetDataEntry(FastListData *pData,unsigned uItem,unsigned uCol,FL_ENTRY *pEntry,unsigned uState)
{

	*(LPINT)pData->cTempText2 = uItem;

    pEntry->pText			= pData->cTempText2+N+M;
	pEntry->iSize			= sizeof(pData->cTempText2)/sizeof(TCHAR)-1-N-M;
	pEntry->iImage			= LV_NOIMAGE;
	pEntry->uBkColor		= LV_NOCOLOR;
	pEntry->uTextColor		= LV_NOCOLOR;
	pEntry->uState			= uState;
	pData->cTempText2[N+M]	= 0;

														// Texte ber Callback holen
	if(pData->pLineCallback && uItem<pData->uListItemsCount && uCol<pData->uColumnCount)
		{
		pData->pLineCallback(pData->pLineCbParam,pData->pListItems[uItem].lParam,uCol,uCol+1,pEntry);
		}
	else{
		pEntry->iSize = 0;
		}

}

//*****************************************************************************
//*
//*		GetTextSize
//*
//*****************************************************************************
//	Berechnet die Lnge eines Textes in Pixel
//	pData		: Zeiger auf die Fensterdaten
//	pEntry 		: Ist der Zeiger auf die Textdaten
//	Ergibt die Texlnge in Pixel.
static int GetTextSize(FastListData *pData,const FL_ENTRY *pEntry)
{
RECT		sRect;
HDC			hDc;


	if(pEntry->iSize<=0)return 0;

	hDc			 = GetDC(NULL);
	sRect.top	 = 0;
	sRect.left	 = 0;
	sRect.right	 = 4096;
	sRect.bottom = 128;
	SelectObject(hDc,(pEntry->uState&LVIS_BOLD)? pData->hFontB:pData->hFontN);
	DrawText(hDc,pEntry->pText,pEntry->iSize,&sRect,DT_LEFT|DT_TOP|DT_SINGLELINE|DT_NOPREFIX|DT_CALCRECT);

	ReleaseDC(NULL,hDc);


return sRect.right-sRect.left;
}

//*****************************************************************************
//*
//*		ToolProc
//*
//*****************************************************************************
//	Ist die Fensterfunktion fr das ToolTip Fenster
static LRESULT CALLBACK ToolProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
FastListData   *pData;
POINT			sPoint;
UINT			uPos;


	if(uMsg==WM_SETFOCUS)
		{
		SetFocus((HWND)lParam);
		return 0;
		}

	pData = (FastListData*)GetWindowLongPtr(hWnd,GWLP_USERDATA);

	if(uMsg>=WM_MOUSEFIRST && uMsg<=WM_MOUSELAST)				// Mausklicks auf Tooltip zum Elternfenster
		{
		sPoint.x = GET_X_LPARAM(lParam);
		sPoint.y = GET_Y_LPARAM(lParam);

		ClientToScreen(hWnd       ,&sPoint);
		ScreenToClient(pData->hWnd,&sPoint);

		uPos = MAKELONG(sPoint.x,sPoint.y);

		return FastListProc(pData->hWnd,uMsg,wParam,uPos);
		}


return CallWindowProc(pData->pToolProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		ChangeColSize
//*
//*****************************************************************************
//	ndert die Gre der variablen Spalten
//	pData		: Zeiger auf die Fensterdaten
//	iDelta		: Ist die Grennderung in Pixel
static void ChangeColSize(FastListData *pData,int iDelta)
{
unsigned 	uPos;
HDITEM	 	sItem;
RECT		sRect;
LV_COLSIZE	sNotify;
int			iWeight;
int			iValue;
int			iPoint;
int			iStart;
int			iFirst;
int			iSize;
int			iRest;
int			iOff;
int			iNum;
int			iCnt;
int			iAll;
int			iVar;
int			iFix;



	sItem.mask	= HDI_WIDTH;
	iFirst		= -1;
	iCnt		= 0;
	iAll		= 0;

	for(uPos=0;;uPos++)									// Gesamt Gewicht berechnen
		{
		if(uPos>=pData->uColumnCount  )break;
		if(pData->aColumn[uPos].sFixed)continue;

		iWeight = pData->aColumn[uPos].bWeight;

		if(!iWeight)continue;
		if(iFirst<0)iFirst=uPos;

		iAll += iWeight;
		iCnt += 1;
		}


	if(iCnt<=1)											// Nur eine variable Spalte
		{
		if(iCnt==0)return;

		uPos	  = iFirst;
		iValue    =	pData->aColumn[uPos].sSize;
		iValue   += iDelta;
		sItem.cxy = iValue;

		pData->aColumn[uPos].sSize = (short)iValue;
		pData->iVarSize            =        iValue;

		if(sItem.cxy<pData->aColumn[uPos].sMin)
			{
			sItem.cxy = pData->aColumn[uPos].sMin;
			}

		if(pData->aColumn[uPos].sReal!=sItem.cxy)		// ndert sich die Breite
			{
			pData->aColumn[uPos].sReal = (short)sItem.cxy;
			Header_SetItem(pData->hHeader,uPos,&sItem);

			if(pData->uStyleEx&LVS_EX_HEADERCHGNOTIFY)
				{
				sNotify.hdr.code			= LVN_COLUMNCHANGED;
				sNotify.uColumn				= uPos;
				sNotify.uIndex				= pData->aColumn[uPos].bIndex;
				sNotify.uPosX				= pData->aColumnXpos[uPos];
				sNotify.iSize				= sItem.cxy;

				UNLOCK(pData);
				SendNotify(pData,&sNotify.hdr);
				LOCK(pData);
				}
			}

		return;
		}

	if(iDelta>0)
			iStart = (pData->uSizeX       )%iAll;
	else	iStart = (pData->uSizeX-iDelta)%iAll;

	for(uPos=0,iOff=0;;uPos++)							// Suchen die Anfangsspalte
		{
		if(pData->aColumn[uPos].sFixed)continue;

			iWeight = pData->aColumn[uPos].bWeight;
		if(!iWeight)continue;

		   iOff+=iWeight;
		if(iOff> iStart)break;
		}


	iPoint		= 0;
	iSize		= iDelta/iAll;
	iRest		= iDelta%iAll;
	iNum		= iRest;
	iOff	   -= iStart;

	iWeight		= iOff;
	iValue		= pData->aColumn[uPos].sSize;
	iValue	   += iSize *iWeight;
	iPoint	   += iRest *iWeight;
	iValue	   += iPoint/iAll;
	iNum	   -= iPoint/iAll;
	iPoint     %= iAll;

	pData->aColumn[uPos].sSize = (short)iValue;


	if(iWeight>=pData->aColumn[uPos].bWeight)			// Wurde die ganze Spalte berechnet
		{
		iCnt--;
		iOff=0;
		}

	while(iCnt>0)
		{
		uPos++;

		if(uPos>=pData->uColumnCount)uPos=0;

		if(pData->aColumn[uPos].sFixed)continue;

			iWeight=pData->aColumn[uPos].bWeight;
		if(!iWeight)continue;

		iValue		= pData->aColumn[uPos].sSize;

 		   iCnt--;
		if(iCnt)
			{
			iValue += iSize*iWeight;
			iPoint += iRest *iWeight;
			iValue += iPoint/iAll;
			iNum   -= iPoint/iAll;
			iPoint %= iAll;
			}
		else{
			iWeight-= iOff;
			iValue += iSize*iWeight;
			iValue += iNum;
			}

		pData->aColumn[uPos].sSize = (short)iValue;
		}


	iVar   =  0;
	iFix   =  0;
	iCnt   =  pData->uColumnCountVar;

	for(uPos=0;iCnt>0;uPos++)							// Ausgeben der neuen Breiten
		{
			iWeight=pData->aColumn[uPos].bWeight;
		if(!iWeight  || pData->aColumn[uPos].sFixed)
			{
			iFix     +=	pData->aColumn[uPos].sSize;
			continue;
			}

		    iVar     +=	pData->aColumn[uPos].sSize;
		    sItem.cxy = pData->aColumn[uPos].sSize;
		if( sItem.cxy < pData->aColumn[uPos].sMin)
			{
			sItem.cxy = pData->aColumn[uPos].sMin;
			}

		if(pData->aColumn[uPos].sReal!=sItem.cxy)		// ndert sich die Breite
			{
			pData->aColumn[uPos].sReal  = (short)sItem.cxy;
			Header_SetItem(pData->hHeader,uPos,&sItem);

			if(pData->uStyleEx&LVS_EX_HEADERCHGNOTIFY)
				{
				sNotify.hdr.code			= LVN_COLUMNCHANGED;
				sNotify.uColumn				= uPos;
				sNotify.uIndex				= pData->aColumn[uPos].bIndex;
				sNotify.uPosX				= pData->aColumnXpos[uPos];
				sNotify.iSize				= sItem.cxy;

				UNLOCK(pData);
				SendNotify(pData,&sNotify.hdr);
				LOCK(pData);
				}
			}

		iCnt--;
		}

	pData->iFixSize = iFix;
	pData->iVarSize = iVar;

	if(iDelta>0)
		{
		GetClientRect (pData->hHeader,&sRect);
		InvalidateRect(pData->hHeader,&sRect,FALSE);
		}

}

//*****************************************************************************
//*
//*		CreateToolTip
//*
//*****************************************************************************
//	Erzeugt ein ToolTip Fenster
//	pData		: Zeiger auf die Fensterdaten
static void CreateToolTip(FastListData *pData)
{
TOOLINFO	sInfo;


	if(pData->hToolTip)return;

	pData->hToolTip	   = CreateWindow(TOOLTIPS_CLASS,NULL,WS_POPUP,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,pData->hWnd,(HMENU)0,NULL,NULL);
	pData->pToolProc   = (WNDPROC)GetWindowLongPtr(pData->hToolTip,GWLP_WNDPROC);

    sInfo.cbSize       = sizeof(TOOLINFO);
    sInfo.uFlags       = TTF_ABSOLUTE|TTF_TRACK|TTF_IDISHWND;
    sInfo.hwnd         = pData->hWnd;
    sInfo.hinst		   = NULL;
    sInfo.uId          = (LPARAM)(pData->hWnd);
    sInfo.lpszText     = LPSTR_TEXTCALLBACK;

	GetClientRect   (pData->hWnd,&sInfo.rect);
	SendMessage     (pData->hToolTip,TTM_ADDTOOL,0,(LPARAM)&sInfo);
	SendMessage     (pData->hToolTip,TTM_SETMAXTIPWIDTH,0,10000);
	SetWindowLong   (pData->hToolTip,GWL_ID,2);
	SetWindowLongPtr(pData->hToolTip,GWLP_USERDATA,(LPARAM)pData);
	SetWindowLongPtr(pData->hToolTip,GWLP_WNDPROC ,(LPARAM)ToolProc);


}

//*****************************************************************************
//*
//*		CreateStateImageList
//*
//*****************************************************************************
//	Erzeugt eine Image-Liste mit zwei Checkboxen
//	pData		: Zeiger auf die Fensterdaten
//	iMode		: Welche Imageliste soll erzeugt werden (0=hStates 1=hChecks)
static void CreateStateImageList(FastListData *pData,int iMode)
{
BITMAPINFO	sInfo;
BYTE		aMem[0x1000];
RECT		sRect;
SIZE		sSize;
HDC			hDcSrc;
HDC			hDc;
HBITMAP		hBmp;
HBITMAP		hBmpNew;
int			iBits;


	if(pOpenThemeData)									// ber Thema zeichnen
		{
		if(!pData->hThemeBt)
			{
			pData->hThemeBt = pOpenThemeData(pData->hWnd,L"BUTTON");
			}

		if(pData->hThemeBt)
			{
			sRect.left			= 0;
			sRect.right			= 3;
			sRect.top			= 0;
			sRect.bottom		= 3;

			pGetThemePartSz(pData->hThemeBt,NULL,BP_CHECKBOX,CBS_UNCHECKEDNORMAL,&sRect,1,&sSize);

			sSize.cx           += 3;

			if(iMode)									// fr hChecks
				{
				if(pData->hChecks && pData->cChecksMode && pData->hChecks!=THEMEIMGLIST)
					{
					ImageList_Destroy(pData->hChecks);
					}

				pData->hChecks		= THEMEIMGLIST;
				pData->iChecksSizeX	= 16;
				pData->iChecksSizeY	= 16;
				pData->cChecksMode	= 1;

				if(pData->iChecksSizeX<sSize.cx)pData->iChecksSizeX=sSize.cx;
				if(pData->iChecksSizeY<sSize.cy)pData->iChecksSizeY=sSize.cy;
				}
			else{										// fr hStates
				if(pData->hStates && pData->cStatesMode && pData->hStates!=THEMEIMGLIST)
					{
					ImageList_Destroy(pData->hStates);
					}

				pData->hStates		= THEMEIMGLIST;
				pData->iStatesSizeX	= 16;
				pData->iStatesSizeY	= 16;
				pData->cStatesMode	= 1;

				if(pData->iStatesSizeX<sSize.cx)pData->iStatesSizeX=sSize.cx;
				if(pData->iStatesSizeY<sSize.cy)pData->iStatesSizeY=sSize.cy;
				}

			return;
			}
		}


	if(iMode)
		{
		if(pData->hChecks && pData->hChecks!=THEMEIMGLIST)return;
		}
	else{
		if(pData->hStates && pData->hStates!=THEMEIMGLIST)return;
		}


	hDcSrc	= GetDC(NULL);
	hDc		= CreateCompatibleDC(NULL);
	hBmp    = CreateCompatibleBitmap(hDcSrc,16*3,16);

	SelectObject(hDc,hBmp);
	SelectObject(hDc,GetStockObject(NULL_PEN));
	SetBkMode   (hDc,OPAQUE);
	SetBkColor	(hDc,GetSysColor(COLOR_WINDOW));
	SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT));
	Rectangle   (hDc,-1,-1,16*3+2,16+2);

	sRect.top	  = 8-6;
	sRect.bottom  = 8+7;
	sRect.left    = 16*1+8-7;
	sRect.right   = 16*1+8+6;

	DrawFrameControl(hDc,&sRect,DFC_BUTTON,DFCS_BUTTONCHECK|DFCS_FLAT);

	sRect.left    = 16*2+8-7;
	sRect.right   = 16*2+8+6;

	DrawFrameControl(hDc,&sRect,DFC_BUTTON,DFCS_BUTTONCHECK|DFCS_CHECKED|DFCS_FLAT);


	iBits = GetDeviceCaps(hDc,BITSPIXEL);

	sInfo.bmiHeader.biSize		  	= sizeof(BITMAPINFOHEADER);
	sInfo.bmiHeader.biWidth			= 16*3;
	sInfo.bmiHeader.biHeight		= 16;
	sInfo.bmiHeader.biPlanes	  	= 1;
	sInfo.bmiHeader.biBitCount	  	= (WORD)iBits;
	sInfo.bmiHeader.biCompression 	= BI_RGB;
	sInfo.bmiHeader.biSizeImage		= 0;
	sInfo.bmiHeader.biXPelsPerMeter	= 0;
	sInfo.bmiHeader.biYPelsPerMeter	= 0;
	sInfo.bmiHeader.biClrUsed		= (iBits>8)? 0:1<<iBits;;
	sInfo.bmiHeader.biClrImportant	= (iBits>8)? 0:1<<iBits;;

	GetDIBits(hDc,hBmp,0,0 ,NULL,&sInfo,DIB_RGB_COLORS);
	GetDIBits(hDc,hBmp,0,16,aMem,&sInfo,DIB_RGB_COLORS);

	hBmpNew = CreateCompatibleBitmap(hDc,16*3,16);

	SetDIBits(hDc,hBmpNew,0,16,aMem,&sInfo,DIB_RGB_COLORS);

	if(iMode==0)
		{
		pData->hStates		= ImageList_Create(16,16,ILC_COLORDDB|ILC_MASK,3,14);
		pData->iStatesSizeX	= 16;
		pData->iStatesSizeY	= 16;
		pData->cStatesMode	= 1;

		ImageList_AddMasked(pData->hStates,hBmpNew,GetSysColor(COLOR_HIGHLIGHT));
		}
	else{
		pData->hChecks		= ImageList_Create(16,16,ILC_COLORDDB|ILC_MASK,3,14);
		pData->iChecksSizeX	= 16;
		pData->iChecksSizeY	= 16;
		pData->cChecksMode	= 1;

		ImageList_AddMasked(pData->hChecks,hBmpNew,GetSysColor(COLOR_HIGHLIGHT));
		}


	DeleteObject(hBmpNew);
	DeleteObject(hBmp);
	DeleteDC(hDc);
	ReleaseDC(NULL,hDcSrc);


}

//*****************************************************************************
//*
//*		CreateDragImage
//*
//*****************************************************************************
//	Erzeugt eine Image-Liste mit zwei Checkboxen
//	pData		: Zeiger auf die Fensterdaten
//	uSub		: Ist die Spalte fr die das Drag-Image erzeugt werden soll
//	Ergibt ein Handle mit der Imageliste oder NULL bei einem Fehler
static HIMAGELIST CreateDragImage(FastListData *pData,unsigned uItem,unsigned uSub)
{
BaseItem   *pEntry;
HIMAGELIST	hList;
BITMAPINFO	sInfo;
BYTE	   *pMem;
FL_ENTRY	sData;
HDC			hDcSrc;
HDC			hDc;
HBITMAP		hBmp;
HBITMAP		hBmpNew;
RECT		sRect;
int			iAdd;
int			iBits;
int			iWidth;
int			iHeigh;
int			iYpos;




	if(uItem>pData->uListItemsCount)return NULL;

	pEntry = pData->pListItems+uItem;
	iHeigh = pData->iFontHeight;

	if(uSub>=pData->uColumnCount)return 0;

	GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);

	sData.pText += pEntry->bStart;
	sData.iSize += pEntry->bStart;
	iWidth		 = GetTextSize(pData,&sData);


	if(pData->hImages && sData.iImage>=0)					// Gren fr Images anpassen
		{
		if(iHeigh<pData->iImagesSizeY)iHeigh=pData->iImagesSizeY;
		iAdd    = pData->iImagesSizeX+2;
		iWidth += iAdd;
		}
	else{
		iAdd		 = 0;
		sData.iImage = 1;
		}


	if(iWidth>240)iWidth=240;
	if(iHeigh>32 )iHeigh=32;

		pMem = new BYTE[iHeigh*(iWidth+4)*4+1024];
	if(!pMem)return NULL;

	hDcSrc	= GetDC(NULL);
	hDc		= CreateCompatibleDC(NULL);
	hBmp    = CreateCompatibleBitmap(hDcSrc,iWidth,iHeigh);

	SelectObject(hDc,hBmp);
	SelectObject(hDc,GetStockObject(NULL_PEN));
	SelectObject(hDc,(sData.uState&LVIS_BOLD)? pData->hFontB:pData->hFontN);
	SetTextColor(hDc,pData->aColors[LVC_TEXT]);
	SetBkColor	(hDc,RGB(123,77,91));

	sRect.top	  = 0;
	sRect.bottom  = iHeigh;
	sRect.left    = 0;
	sRect.right   = iWidth;
	iYpos		  =(iHeigh-pData->iFontHeight)/2;

	ExtTextOut(hDc,iAdd,iYpos,ETO_OPAQUE|ETO_CLIPPED,&sRect,sData.pText,sData.iSize,NULL);

	if(sData.iImage>=0)
		{
		SetBkColor(hDc,GetSysColor(COLOR_WINDOW));
		ImageList_Draw(pData->hImages,sData.iImage,hDc,0,0,ILD_TRANSPARENT);
		}



	iBits = GetDeviceCaps(hDc,BITSPIXEL);

	sInfo.bmiHeader.biSize		  	= sizeof(BITMAPINFOHEADER);
	sInfo.bmiHeader.biWidth			= iWidth;
	sInfo.bmiHeader.biHeight		= iHeigh;
	sInfo.bmiHeader.biPlanes	  	= 1;
	sInfo.bmiHeader.biBitCount	  	= (WORD)iBits;
	sInfo.bmiHeader.biCompression 	= BI_RGB;
	sInfo.bmiHeader.biSizeImage		= 0;
	sInfo.bmiHeader.biXPelsPerMeter	= 0;
	sInfo.bmiHeader.biYPelsPerMeter	= 0;
	sInfo.bmiHeader.biClrUsed		= (iBits>8)? 0:1<<iBits;;
	sInfo.bmiHeader.biClrImportant	= (iBits>8)? 0:1<<iBits;;

	GetDIBits(hDc,hBmp,0,0     ,NULL,&sInfo,DIB_RGB_COLORS);
	GetDIBits(hDc,hBmp,0,iHeigh,pMem,&sInfo,DIB_RGB_COLORS);

	hBmpNew = CreateCompatibleBitmap(hDc,iWidth,iHeigh);

	SetDIBits(hDc,hBmpNew,0,iHeigh,pMem,&sInfo,DIB_RGB_COLORS);

	hList = ImageList_Create(iWidth,iHeigh,ILC_COLORDDB|ILC_MASK,1,0);

	ImageList_AddMasked(hList,hBmpNew,RGB(123,77,91));

	DeleteObject(hBmpNew);
	DeleteObject(hBmp);
	DeleteDC(hDc);
	ReleaseDC(NULL,hDcSrc);

	delete pMem;


return hList;
}

//*****************************************************************************
//*
//*		UpdateStart
//*
//*****************************************************************************
//	Startet ein 200ms verzgertes Update
//	pData		: Zeiger auf die Fensterdaten
static inline void UpdateStart(FastListData *pData)
{

	if(pData->cUpdateTimer)return;

	pData->cUpdateTimer = 1;

	if(PostMessage(pData->hWnd,LVM_STARTUPDATE,0,0))
		{
		return;
		}

	pData->cUpdateTimer = 1;
	SetTimer(pData->hWnd,ID_UPDATE,200,NULL);


}

//*****************************************************************************
//*
//*		UpdateColors
//*
//*****************************************************************************
//	Aktualisiert alle Farben
//	pData		: Zeiger auf die Fensterdaten
static void UpdateColors(FastListData *pData)
{
unsigned	uColOdd;
unsigned 	uColor;
int 		iDiff;
int 		iSum;


	if(!pData->aColorChanged[LVC_BK     ])pData->aColors[LVC_BK     ]  = GetSysColor(COLOR_WINDOW);
	if(!pData->aColorChanged[LVC_EVEN   ])pData->aColors[LVC_EVEN   ]  = GetSysColor(COLOR_WINDOW);
	if(!pData->aColorChanged[LVC_TEXT   ])pData->aColors[LVC_TEXT   ]  = GetSysColor(COLOR_WINDOWTEXT);
	if(!pData->aColorChanged[LVC_FRAME  ])pData->aColors[LVC_FRAME  ]  = GetSysColor(COLOR_3DFACE);
	if(!pData->aColorChanged[LVC_TRACK  ])pData->aColors[LVC_TRACK  ]  = GetSysColor(COLOR_WINDOWTEXT)^RGB(0,0,255);
	if(!pData->aColorChanged[LVC_ODD    ])pData->aColors[LVC_ODD    ]  = GetSysColor(COLOR_INFOBK);
	if(!pData->aColorChanged[LVC_COLBK  ])pData->aColors[LVC_COLBK  ]  = GetSysColor(COLOR_WINDOW);
	if(!pData->aColorChanged[LVC_COLODD ])pData->aColors[LVC_COLODD ]  = GetSysColor(COLOR_BTNSHADOW);
	if(!pData->aColorChanged[LVC_COLEVEN])pData->aColors[LVC_COLEVEN]  = GetSysColor(COLOR_WINDOW);
	if(!pData->aColorChanged[LVC_GRAYED ])pData->aColors[LVC_GRAYED ]  = GetSysColor(COLOR_SCROLLBAR);


	if(!pData->aColorChanged[LVC_NOFOCUS])
		{
		pData->aColors[LVC_NOFOCUS]  = ((GetSysColor(COLOR_3DFACE   )&0x00FCFCFC)>>2)*3;
		pData->aColors[LVC_NOFOCUS] += ((GetSysColor(COLOR_HIGHLIGHT)&0x00FCFCFC)>>2);
		}

	if(!pData->aColorChanged[LVC_GRAYED])
		{
		pData->aColors[LVC_GRAYED]   = ((GetSysColor(COLOR_SCROLLBAR)&0x00FCFCFC)>>2);
		pData->aColors[LVC_GRAYED]  += ((GetSysColor(COLOR_WINDOW   )&0x00FCFCFC)>>2)*3;
		}

	if(!pData->aColorChanged[LVC_ODD])
		{
		uColOdd = pData->aColors[LVC_ODD];
		iDiff   = ((uColOdd    )&0xFF)-((pData->aColors[LVC_EVEN]    )&0xFF); iSum  = iDiff*iDiff;
		iDiff   = ((uColOdd>> 8)&0xFF)-((pData->aColors[LVC_EVEN]>> 8)&0xFF); iSum += iDiff*iDiff;
		iDiff   = ((uColOdd>>16)&0xFF)-((pData->aColors[LVC_EVEN]>>16)&0xFF); iSum += iDiff*iDiff;

		if(iSum<64)												// Ist die alternierente Farbe fast gleich ?
			{
			uColOdd  =   pData->aColors[LVC_EVEN]&0x0000FFFF;
			uColOdd |= ((pData->aColors[LVC_EVEN]&0x00FF0000)-0x00080000)&0x00FF0000;
			}

		pData->aColors[LVC_ODD] = uColOdd;
		}

	if(!pData->aColorChanged[LVC_COLBK])
		{
		   uColor = GetSysColor(COLOR_WINDOW);
		if(uColor&0x00F00000)uColor-=0x000F0000;
		if(uColor&0x0000F000)uColor-=0x00000B00;
		if(uColor&0x000000F0)uColor-=0x0000000B;

		pData->aColors[LVC_COLBK] = uColor;
		}

	if(!pData->aColorChanged[LVC_COLODD])
		{
		   uColor = pData->aColors[LVC_ODD];
		if(uColor&0x00F00000)uColor-=0x000F0000;
		if(uColor&0x0000F000)uColor-=0x00000B00;
		if(uColor&0x000000F0)uColor-=0x0000000B;

		pData->aColors[LVC_COLODD] = uColor;
		}

	if(!pData->aColorChanged[LVC_COLEVEN])
		{
		   uColor = GetSysColor(COLOR_WINDOW);
		if(uColor&0x00F00000)uColor-=0x000F0000;
		if(uColor&0x0000F000)uColor-=0x00000B00;
		if(uColor&0x000000F0)uColor-=0x0000000B;

		pData->aColors[LVC_COLEVEN] = uColor;
		}

	if(!pData->aColorChanged[LVC_MARKODD ])pData->aColors[LVC_MARKODD ]  =((pData->aColors[LVC_ODD     ]>>3)&0x1F1F1F)*7;
	if(!pData->aColorChanged[LVC_MARKODD ])pData->aColors[LVC_MARKODD ] +=((GetSysColor(COLOR_HIGHLIGHT)>>3)&0x1F1F1F)*1;
	if(!pData->aColorChanged[LVC_MARKEVEN])pData->aColors[LVC_MARKEVEN]  =((pData->aColors[LVC_EVEN    ]>>3)&0x1F1F1F)*7;
	if(!pData->aColorChanged[LVC_MARKEVEN])pData->aColors[LVC_MARKEVEN] +=((GetSysColor(COLOR_HIGHLIGHT)>>3)&0x1F1F1F)*1;

}

//*****************************************************************************
//*
//*		UpdateHeight
//*
//*****************************************************************************
//	Prft ob die Zeilenhhe sich gendert hat
//	pData		: Zeiger auf die Fensterdaten
//	Ergibt 1 bei nderungen sonst 0
static int UpdateHeight(FastListData *pData)
{
int		iHeight;
RECT	sRect;


	if(pData->cFixedHeight)return 0;

	iHeight = 8;

	if(pData->hChecks)
	if(iHeight<pData->iChecksSizeY)iHeight=pData->iChecksSizeY;
	if(pData->hStates)
	if(iHeight<pData->iStatesSizeY)iHeight=pData->iStatesSizeY;
	if(iHeight<pData->iSubImgYsize)iHeight=pData->iSubImgYsize;
	if(iHeight<pData->iImagesSizeY)iHeight=pData->iImagesSizeY;

	if(pData->uStyleEx&(LVS_EX_ALTERNATECOLOR|LVS_EX_GRIDLINES))
		{
		iHeight += 2;
		}
	else{
		iHeight += 1;
		}

	if(iHeight<pData->iFontHeight+3)iHeight=pData->iFontHeight+3;
	if(pData->uStyleEx&LVS_EX_GRIDLINES)iHeight++;
	if(pData->uStyle  &LVS_NONEVENHEIGHT && (iHeight&1))iHeight++;
	if(pData->iRowHeight==iHeight)return 0;

	pData->iRowHeight	 = iHeight;
	pData->uMaxEnties	 = pData->uSizeY;
	pData->uMaxEnties	-= pData->uStartPixel;
	pData->uPageEnties	 = pData->uMaxEnties;
	pData->uMaxEnties	+= pData->iRowHeight-1;
	pData->uMaxEnties   /= pData->iRowHeight;
	pData->uPageEnties  /= pData->iRowHeight;

	GetClientRect (pData->hWnd,&sRect);
	InvalidateRect(pData->hWnd,&sRect,FALSE);


return 1;
}

//*****************************************************************************
//*
//*		UpdateRect
//*
//*****************************************************************************
//	Zeichnet Eintrge neu
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages
//	uSub		: Ist die Spaltennummer
//	uSizeX		: Anzahl der Spalten
//	uSizeY		: Anzahl der Zeilen
//	Ergibt 1 wenn der Eintrag sichtbar war
static int UpdateRect(FastListData *pData,unsigned uItem,unsigned uSub,unsigned uSizeX=1,unsigned uSizeY=1)
{
RECT		sRect;
UINT		uDiff;
UINT		uNext;
UINT		uPos;
UINT		uCol;


	if(uItem>=pData->uListItemsCount)return 0;				// Ist der Eintrag gltig
	if(uSizeX==0 || uSizeY==0)return 0;

	if(uItem<pData->uScrollY)
		{
		   uDiff = pData->uScrollY-uItem;
		if(uDiff>=uSizeY)return 0;
		uSizeY  -= uDiff;
		uItem   += uDiff;
		}

	   uPos = uItem-pData->uScrollY;
	if(uPos>=pData->uMaxEnties)return 0;					// Eintrag im Fenster sichtbar

	if(uSub>=pData->uColumnCount)return 0;

	uCol = pData->aColumn[uSub].bIndex;

	if(uCol+uSizeX>pData->uColumnCount)
		{
		uSizeX = pData->uColumnCount-uCol;
		}

	uNext		  = pData->aColumnPos [uCol+uSizeX];
	sRect.left    = pData->aColumnXpos[uSub];
	sRect.left   -= pData->uScrollX;
	sRect.right	  = pData->aColumnXpos[uNext];
	sRect.right  -= pData->uScrollX;
	sRect.top     = pData->uStartPixel;
	sRect.top    += pData->iRowHeight*uPos;
	sRect.bottom  = pData->iRowHeight*uSizeY+sRect.top;

	InvalidateRect(pData->hWnd,&sRect,FALSE);



return 1;
}


//*****************************************************************************
//*
//*		UpdateRows
//*
//*****************************************************************************
//	Zeichnet einen Eintrag ber die ganze Zeile neu
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages
//	Ergibt 1 wenn der Eintrag sichtbar war
static int UpdateRows(FastListData *pData,unsigned uItem,unsigned uCount=1)
{
RECT		sRect;
unsigned	uStop;
unsigned	uPos;



	if(uItem>=pData->uListItemsCount+pData->uMaxEnties/2)	// Ist der Eintrag gltig
		{
		return 0;
		}

	if(uItem<pData->uScrollY)								// Beginn vor Scroll-Position
		{
		if(uItem+uCount<pData->uScrollY)
			{
			return 0;
			}

		uCount -= uItem-pData->uScrollY;
		uItem	= pData->uScrollY;
		uPos	= 0;
		}
	else{
		   uPos = uItem-pData->uScrollY;
		if(uPos>=pData->uMaxEnties)							// Eintrag im Fenster sichtbar
			{
			return 0;
			}
		}

	if(uItem+uCount>pData->uListItemsCount+pData->uMaxEnties)
		{
		uCount = pData->uListItemsCount+pData->uMaxEnties-uItem;
		}

	if(uPos+uCount>pData->uMaxEnties)
		{
		uCount = pData->uMaxEnties-uPos;
		}

	if(uCount<=0)return 0;

	if(pData->cUpdateFlag)									// Direktes Update gesprerrt
		{
		uStop  = uItem+uCount;

		if(pData->cUpdateRows)
			{
			if(pData->uUpdateRow>uItem)pData->uUpdateRow=uItem;
			if(pData->uUpdateEnd<uStop)pData->uUpdateEnd=uStop;
			}
		else{
			pData->cUpdateRows = 1;
			pData->uUpdateRow  = uItem;
			pData->uUpdateEnd  = uStop;
			}

		UpdateStart(pData);
		return 0;
		}

	sRect.left			= 0;
	sRect.right			= pData->uSizeX;
	sRect.top     		= pData->uStartPixel;
	sRect.top		   += pData->iRowHeight*uPos;
	sRect.bottom  		= pData->iRowHeight*uCount+sRect.top;

	InvalidateRect(pData->hWnd,&sRect,FALSE);



return 1;
}

//*****************************************************************************
//*
//*		UpdateView
//*
//*****************************************************************************
//	Zeichnet das ganze Fenster neu
//	pData		: Zeiger auf die Fensterdaten
//	Ergibt 1 wenn der Eintrag sichtbar war
static void UpdateView(FastListData *pData)
{
RECT	sRect;


	if(pData->cUpdateFlag)										// Direktes Update gesprerrt
		{
		pData->cUpdateView = 1;
		UpdateStart(pData);
		return;
		}

	pData->cUpdateView = 0;

	GetClientRect (pData->hWnd,&sRect);
	sRect.top =    pData->uStartPixel;
	InvalidateRect(pData->hWnd,&sRect,FALSE);


}

//*****************************************************************************
//*
//*		UpdateHeader
//*
//*****************************************************************************
//	Zeichnet den Header neu
//	pData		: Zeiger auf die Fensterdaten
static void UpdateHeader(FastListData *pData)
{
RECT	sRect;


	if(!pData->hHeader)return;

	GetClientRect (pData->hHeader,&sRect);
	InvalidateRect(pData->hHeader,&sRect,FALSE);

}

//*****************************************************************************
//*
//*		UpdateScrollX
//*
//*****************************************************************************
//	Aktualisiert die X-Scroolbar
//	pData		: Zeiger auf die Fensterdaten
//	bUnlock		: Die Sperre aufheben
//	Ergibt 1 wenn der sich Einstellungen verndert haben
static void UpdateScrollX(FastListData *pData,BOOL bUnlock=TRUE)
{
SCROLLINFO  sInfo;
unsigned	uSize;
unsigned	uCols;



	   uCols = pData->uColumnCount;
	if(uCols)
			uSize = pData->aColumnXpos[uCols]-1;
	else	uSize = pData->iMaxSizeX-1;


	if(pData->uOldCountX==uSize)
	if(pData->uOldPageX ==pData->uSizeX)
		{
		return;
		}

	if(pData->cUpdateFlag)										// Direktes Update gesprerrt
		{
		pData->cUpdateScrollX = 1;
		UpdateStart(pData);
		return;
		}

	pData->uOldPageX		= pData->uSizeX;
	pData->uOldCountX		= uSize;
	pData->cUpdateScrollX	= 0;

	if(bUnlock)UNLOCK(pData);

	sInfo.cbSize	= sizeof(SCROLLINFO);
	sInfo.fMask		= SIF_ALL;
	sInfo.nMin		= 0;
	sInfo.nMax  	= uSize;
	sInfo.nPage 	= pData->uSizeX;
	sInfo.nPos  	= pData->uScrollX;
	sInfo.nTrackPos	= 0;


	if(pData->uStyle&LVS_NOSCROLL)
		{
		sInfo.nMax = 0;
		}
	else if(pData->uStyleEx&LVS_EX_AUTOHSCROLL)
		{
		sInfo.nMax = 0;
		}
	else if(sInfo.nMax>0)
		{
		sInfo.nMax--;
		}


	if((int)sInfo.nPage>=sInfo.nMax && pData->uScrollX>0)
		{
		sInfo.nPos      = 0;
		pData->uScrollX = 0;

		UpdateView(pData);

		if(pData->hHeader)
			{
			MoveWindow(pData->hHeader,0,0,pData->uSizeX,pData->uStartPixel-pData->uStartOffset,TRUE);
			}
		}

	SetScrollInfo(pData->hWnd,SB_HORZ,&sInfo,TRUE);

	if(bUnlock)LOCK(pData);

}

//*****************************************************************************
//*
//*		UpdateScrollY
//*
//*****************************************************************************
//	Aktualisiert die Y-Scroolbar
//	pData		: Zeiger auf die Fensterdaten
//	bUnlock		: Die Sperre aufheben
//	bForce		: Das Fenster immer neu Zeichen
//	Ergibt 1 wenn der sich Einstellungen verndert haben

//	Ergibt 1 wenn der sich Einstellungen verndert haben
static void UpdateScrollY(FastListData *pData,BOOL bUnlock=TRUE,BOOL bForce=FALSE)
{
SCROLLINFO  sInfo;
unsigned	uTick;
unsigned	uDiff;
BOOL		bDraw;
int			iMax;


	if(pData->uOldCountY==pData->uListItemsCount)
	if(pData->uOldPageY ==pData->uPageEnties    )
		{
		return;
		}

	if(pData->cUpdateFlag)									// Direktes Update gesprerrt
		{
		pData->cUpdateScrollY = 1;
		UpdateStart(pData);
		return;
		}

	if(bUnlock)UNLOCK(pData);

	sInfo.cbSize	= sizeof(SCROLLINFO);
	sInfo.fMask		= SIF_ALL;
	sInfo.nMin		= 0;
	sInfo.nMax  	= pData->uListItemsCount;
	sInfo.nPage 	= pData->uPageEnties;
	sInfo.nPos  	= pData->uScrollY;
	sInfo.nTrackPos	= 0;

	if(pData->uStyle&LVS_NOSCROLL)
		{
		sInfo.nMax = 0;
		}


	uTick = GetTickCount();

	if(bForce)												// Immer neu zeichnen
		{
		bDraw = TRUE;
		}
	else{
		   uDiff = uTick-pData->uLastScrolY;
		if(uDiff>200)										// Nur alle 200 ms neuzeichnen
			{
			bDraw				= TRUE;
			pData->uLastScrolY	= uTick;
			}
		else{
			bDraw = FALSE;
			}
		}


	iMax  = pData->uListItemsCount;
	iMax -=	pData->uPageEnties/2-1;

	if(sInfo.nPos>=iMax)sInfo.nPos=iMax;
	if(sInfo.nPos<0)sInfo.nPos=0;
	if(sInfo.nPos!=(int)pData->uScrollY)
		{
		pData->uScrollY = sInfo.nPos;

		if((int)sInfo.nPage>=sInfo.nMax && pData->uScrollY>0)
			{
			sInfo.nPos      = 0;
			pData->uScrollY = 0;
			}

		if(bDraw)
			{
			UpdateView (pData);
			}
		else{
			pData->cUpdateView = 1;
			UpdateStart(pData);
			}
		}

	if((int)sInfo.nPage>=sInfo.nMax && pData->uScrollY>0)
		{
		sInfo.nPos      = 0;
		pData->uScrollY = 0;

		if(bDraw)
			{
			UpdateView (pData);
			}
		else{
			pData->cUpdateView = 1;
			UpdateStart(pData);
			}
		}


	if(pData->uStyleEx&LVS_EX_ALWAYSSCROLLY)					// Scrollbar immer einblenden
		{
		sInfo.fMask |= SIF_DISABLENOSCROLL;
		}

  	SetScrollInfo(pData->hWnd,SB_VERT,&sInfo,bDraw);

	if(bDraw)
		{
		pData->uOldPageY	  = pData->uPageEnties;
		pData->uOldCountY	  = pData->uListItemsCount;
		pData->uLastScrolY	  = uTick;
		pData->cUpdateScrollY = 0;
		}
	else{
		pData->cUpdateScrollY = 1;
		UpdateStart(pData);
		}

	if(bUnlock)LOCK(pData);


}

//*****************************************************************************
//*
//*		UpdateScrollBars
//*
//*****************************************************************************
//	Die Scroolbars neu Zeichen
//	pData		: Zeiger auf die Fensterdaten
static void UpdateScrollBars(FastListData *pData)
{
SCROLLINFO  sInfo;


	GetScrollInfo(pData->hWnd,SB_VERT,&sInfo);
	SetScrollInfo(pData->hWnd,SB_VERT,&sInfo,TRUE);

	GetScrollInfo(pData->hWnd,SB_HORZ,&sInfo);
	SetScrollInfo(pData->hWnd,SB_HORZ,&sInfo,TRUE);

}


//*****************************************************************************
//*
//*		CheckToolTipPos
//*
//*****************************************************************************
//	Prft die Position vom Tooltip Fenster
static void CheckToolTipPos(FastListData *pData)
{
HMONITOR		hMonitor;
MONITORINFO		sMonInfo;
RECT			sRect;
int				iValX;
int				iValY;


		hMonitor = MonitorFromWindow(pData->hToolTip,MONITOR_DEFAULTTONEAREST);
	if(!hMonitor)return;

	sMonInfo.cbSize = sizeof(sMonInfo);
	
	if(!GetMonitorInfo(hMonitor,&sMonInfo))				// Prfen ob das Tooltip in den Nonitor pass
		{
		return;
		}


	GetWindowRect(pData->hToolTip,&sRect);


	iValX = 0;
	iValY = 0;

	
	if(sMonInfo.rcWork.right<sRect.right)				// X-Ausrichtung prfen
		{
		iValX = sMonInfo.rcWork.right-sRect.right;

		if(sMonInfo.rcWork.left>sRect.left+iValX)
			{
			iValX = sRect.left-sMonInfo.rcWork.left;
			}
		
		if(iValX>0)iValX=0;
		}
		
	
	if(sMonInfo.rcWork.bottom<sRect.bottom)				// Y-Ausrichtung prfen
		{
		iValY = sMonInfo.rcWork.bottom-sRect.bottom;

		if(sMonInfo.rcWork.top>sRect.top+iValY)
			{
			iValY = sRect.top-sMonInfo.rcWork.top;
			}
		
		if(iValY>0)iValY=0;
		}


	if(iValX || iValY)									// Das Tooltip verschieben
		{
		pData->sToolTipPos.x = sRect.left+iValX;
		pData->sToolTipPos.y = sRect.top +iValY;

		SendMessage(pData->hToolTip,TTM_TRACKPOSITION,0,MAKELONG(pData->sToolTipPos.x,pData->sToolTipPos.y));
		}

}

//*****************************************************************************
//*
//*		UpdateToolTip
//*
//*****************************************************************************
//	Ist die Fensterfunktion fr das FastList Fenster
//	pData	: Zeiger auf Fensterdaten
//	uItem	: Item auf den der Mauszeiger zeigt
//	uSub	: Ist die Spalte fr das Tooltip
//	uFlags	: Flags vom HitTest
static void UpdateToolTip(FastListData *pData,unsigned uItem,unsigned uSub,unsigned uFlags)
{
TCHAR			cTemp[INFOTIPSIZE];
INT				iPixels;
HWND			hToolTip;
NMLVGETINFOTIEX	sNotify;
TOOLINFO		sInfo;
BaseItem	   *pEntry;
FL_ENTRY		sData;
LPCTSTR	    	pText;
RECT			sRect;
unsigned		uSize;
unsigned		uCol;
unsigned		uLen;
LRESULT			lRet;




															// Tooltip ausblenden
	if(uItem==0xFFFFFFFF || (uItem==pData->uEditItem && LVHT_SUBTOCOL(uFlags)==pData->uEditSub))
		{
		if(pData->uToolTipItem<pData->uListItemsCount)
			{
			goto ExitTip;
			}

		return;
		}


	pEntry = pData->pListItems+uItem;

	if(uFlags&LVHT_ONITEM)
		{
		if(pData->uToolTipItem!=uItem || pData->uToolTipSub!=0)
			{
			if(uItem>=pData->uListItemsCount)				// Existiert der Eintrag noch ?
				{
				goto ExitTip;
				}

			FastListGetItemRect(pData,uItem,LVIR_SELECTBOUNDS|LVIR_GETCOLUMN,&sRect);

			if(sRect.right>(int)pData->uSizeX)
				{
				sRect.right = pData->uSizeX;
				}

			lRet = 0;

			GetDataEntry(pData,uItem,0,&sData,pEntry->uState);

			sData.pText += pEntry->bStart;
			sData.iSize += pEntry->bStart;
			iPixels      = GetTextSize(pData,&sData);


			if(pData->uStyleEx&LVS_EX_INFOTIP)				// Tooltip-Daten via speziellem Notify holen
				{
				sNotify.hdr.code	= LVN_GETINFOTIP;
				sNotify.dwFlags		= 0;
				sNotify.cchTextMax	= INFOTIPSIZE;
				sNotify.iItem		= uItem;
				sNotify.iSubItem	= 0;
				sNotify.lParam		= pEntry->lParam;
				sNotify.pszText		= cTemp;
				sNotify.cchTextMax	= INFOTIPSIZE-1;
				sNotify.uTime		= 0;
				sNotify.ptAction.x	= sRect.left;
				sNotify.ptAction.y	= sRect.top;

				str_ncpy(cTemp,sData.pText,INFOTIPSIZE);
				cTemp[INFOTIPSIZE-1]=0;

				UNLOCK(pData);
				lRet=SendNotify(pData,&sNotify.hdr);
				LOCK(pData);

				goto UserTip;
				}


			if(sRect.right-sRect.left<=iPixels+4)			// Passt der Text in die Spalte
				{
				pText	= sData.pText;
				uSize	= sData.iSize;

				if(!pText || *pText==0)goto ExitTip;

				   uLen = str_len(pText)+1;
				if(uLen>=pData->uToolTipSize)				// Tooltip-Speicher vergrern
					{
					delete pData->pToolTipText;
					pData->uToolTipSize = (uLen+255)&~0xFF;
					pData->pToolTipText = new TCHAR[pData->uToolTipSize+4];
					}

				memcpy(pData->pToolTipText,pText,uLen*sizeof(TCHAR));
				pData->pToolTipText[uSize] = 0;
				pData->hFontT = (sData.uState&LVIS_BOLD)? pData->hFontB:pData->hFontN;


				hToolTip				= pData->hToolTip;
				pData->sToolTipPos.x	= sRect.left;
				pData->sToolTipPos.y	= sRect.top;

				ClientToScreen(pData->hWnd,&pData->sToolTipPos);

				UNLOCK(pData);

				sInfo.cbSize			= sizeof(sInfo);
				sInfo.hwnd				= pData->hWnd;
				sInfo.uId				= (UINT_PTR)pData->hWnd;

				if(pData->uToolTipItem<pData->uListItemsCount)
					{
					SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,0,(LPARAM)&sInfo);
					pData->uToolTipItem = 0xFFFFFFFF;
					}

				SendMessage(pData->hToolTip,TTM_TRACKPOSITION,0,MAKELONG(pData->sToolTipPos.x,pData->sToolTipPos.y));
				SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,1,(LPARAM)&sInfo);

				CheckToolTipPos(pData);

				LOCK(pData);

				pData->uToolTipItem		= uItem;
				pData->uToolTipShow 	= 0;
				pData->uToolTipSub		= 0;

				SetTimer(pData->hWnd,ID_TOOLTIPCHECK,1500,NULL);
				}
			else if(pData->uToolTipItem<pData->uListItemsCount)
				{
				goto ExitTip;
				}
			}

		return;
		}

	if(uFlags&(LVHT_ONSUBICON|LVHT_ONSUBLABEL))
		{
		if(pData->uToolTipItem!=uItem || pData->uToolTipSub!=uSub)
			{
			lRet   = 0;
			uCol   = uSub;

			GetDataEntry(pData,uItem,uCol,&sData,pEntry->uState);
			iPixels = GetTextSize(pData,&sData);

			if(pData->uStyleEx&LVS_EX_INFOTIP)				// Tooltip-Daten via speziellem Notify holen
				{
				FastListGetItemRect(pData,uItem,LVIR_SELECTBOUNDS|LVIR_GETCOLUMN|LVIR_COLTOSUB(uCol),&sRect);

				if(sRect.right>(int)pData->uSizeX)
					{
					sRect.right = pData->uSizeX;
					}

				sNotify.hdr.code	= LVN_GETINFOTIP;
				sNotify.dwFlags		= 0;
				sNotify.cchTextMax	= INFOTIPSIZE;
				sNotify.iItem		= uItem;
				sNotify.iSubItem	= uCol;
				sNotify.lParam		= pEntry->lParam;
				sNotify.pszText		= cTemp;
				sNotify.cchTextMax	= INFOTIPSIZE-1;
				sNotify.uTime		= 0;
				sNotify.ptAction.x	= sRect.left;
				sNotify.ptAction.y	= sRect.top;

				str_ncpy(cTemp,sData.pText,INFOTIPSIZE);
				cTemp[INFOTIPSIZE-1]=0;

				UNLOCK(pData);
				lRet=SendNotify(pData,&sNotify.hdr);
				LOCK(pData);

				goto UserTip;
				}

															// Tooltip auf Unterspalte ?
			FastListGetItemRect(pData,uItem,LVIR_GETCOLUMN|LVIR_BOUNDS|LVIR_COLTOSUB(uCol),&sRect);

			if(sRect.right>(int)pData->uSizeX)
				{
				sRect.right = pData->uSizeX;
				}

			if(sRect.right-sRect.left<=iPixels+4)
				{
				pText	= sData.pText;
				uSize	= sData.iSize;

				if(!pText || *pText==0)goto ExitTip;

				   uLen = str_len(pText)+1;
				if(uLen>=pData->uToolTipSize)				// Tooltip-Speicher vergrern
					{
					delete pData->pToolTipText;
					pData->uToolTipSize = (uLen+255)&~0xFF;
					pData->pToolTipText = new TCHAR[pData->uToolTipSize+4];
					}

				memcpy(pData->pToolTipText,pText,uLen*sizeof(TCHAR));
				pData->hFontT =(sData.uState&LVIS_BOLD)? pData->hFontB:pData->hFontN;

				pData->sToolTipPos.x	= sRect.left;
				pData->sToolTipPos.y	= sRect.top;
				hToolTip				= pData->hToolTip;

				ClientToScreen(pData->hWnd,&pData->sToolTipPos);

				if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)	// Checkboxen statt Icons
					{
					pData->sToolTipPos.x += pData->iChecksSizeX;
					}
				else if(pData->hSubImg && sData.iImage!=LV_NOIMAGE)
					{
					pData->sToolTipPos.x += pData->iImagesSizeX;
					}

				UNLOCK(pData);

				sInfo.cbSize			= sizeof(sInfo);
				sInfo.hwnd				= pData->hWnd;
				sInfo.uId				= (UINT_PTR)pData->hWnd;

				if(pData->uToolTipItem<pData->uListItemsCount)
					{
					SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,0,(LPARAM)&sInfo);
					pData->uToolTipItem = 0xFFFFFFFF;
					}

				SendMessage(pData->hToolTip,TTM_TRACKPOSITION,0,MAKELONG(pData->sToolTipPos.x,pData->sToolTipPos.y));
				SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,1,(LPARAM)&sInfo);

				CheckToolTipPos(pData);

				LOCK(pData);

				pData->uToolTipItem		= uItem;
				pData->uToolTipSub		= uCol;
				pData->uToolTipShow 	= 0;

				SetTimer(pData->hWnd,ID_TOOLTIPCHECK,1500,NULL);
				}
			else if(pData->uToolTipItem<pData->uListItemsCount)
				{
				goto ExitTip;
				}
			}

		return;
 		}

ExitTip:

	if(pData->uToolTipItem!=0xFFFFFFFF)						// Tooltip ausblenden
		{
		sInfo.cbSize		= sizeof(sInfo);
		sInfo.hwnd			= pData->hWnd;
		sInfo.uId			= (UINT_PTR)pData->hWnd;

		UNLOCK(pData);

		SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,0,(LPARAM)&sInfo);

		LOCK(pData);

		pData->uToolTipItem = 0xFFFFFFFF;
		pData->uToolTipSub	= 0;
		pData->uToolTipShow = 0;

		KillTimer(pData->hWnd,ID_TOOLTIPCHECK);
		}


	return;


UserTip:

	pText	   = sNotify.pszText;							// Soll ein User-Tooltip angezeigt werden
	uSize	   = sNotify.cchTextMax;
	sRect.left = sNotify.ptAction.x;
	sRect.top  = sNotify.ptAction.y;

	if(!pText ||*pText==0)goto ExitTip;

	   uLen = str_len(pText)+1;
	if(uLen>=pData->uToolTipSize)							// Tooltip-Speicher vergrern
		{
		delete pData->pToolTipText;
		pData->uToolTipSize = (uLen+255)&~0xFF;
		pData->pToolTipText = new TCHAR[pData->uToolTipSize+4];
		}

	memcpy(pData->pToolTipText,pText,uLen*sizeof(TCHAR));
	pData->hFontT = (sData.uState&LVIS_BOLD)? pData->hFontB:pData->hFontN;

	ClientToScreen(pData->hWnd,&sNotify.ptAction);
	pData->sToolTipPos		= sNotify.ptAction;
	hToolTip				= pData->hToolTip;
															// Tooltip verzgert anzeigen
	if((sNotify.dwFlags&LVIF_TOOLTIPTIME) && sNotify.uTime>0)
		{
		pData->uToolTipShow = (unsigned)(sNotify.uTime+499)/500;
		pData->uToolTipSub	= sNotify.iSubItem;
		pData->uToolTipItem = uItem;

		SetTimer(pData->hWnd,ID_TOOLTIPCHECK,500,NULL);

		return;
		}

	UNLOCK(pData);

	sInfo.cbSize	= sizeof(sInfo);
	sInfo.hwnd		= pData->hWnd;
	sInfo.uId		= (UINT_PTR)pData->hWnd;

	if(pData->uToolTipItem<pData->uListItemsCount)			// Tooltip Fenster aktivieren
		{
		SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,0,(LPARAM)&sInfo);
		pData->uToolTipItem = 0xFFFFFFFF;
		}

	SendMessage(pData->hToolTip,TTM_TRACKPOSITION,0,MAKELONG(sNotify.ptAction.x,sNotify.ptAction.y));
	SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,1,(LPARAM)&sInfo);

	CheckToolTipPos(pData);

	LOCK(pData);

	pData->uToolTipShow = 0;
	pData->uToolTipItem = uItem;
	pData->uToolTipSub	= sNotify.iSubItem;

	SetTimer(pData->hWnd,ID_TOOLTIPCHECK,1500,NULL);


}

//*****************************************************************************
//*
//*		UpdateFont
//*
//*****************************************************************************
//	Erzeugt einen den fetten Font fr das Fenster
//	pData		: Zeiger auf die Fensterdaten
//	iRedraw		: Soll das Fenster neugezeichnet werden
//	Ergibt 1 wenn der Font verndert wurde
static int UpdateFont(FastListData *pData)
{
int			iRet;
HDC			hDc;
LOGFONT		sLog;
SIZE		sSize;
TEXTMETRIC	sMetrics;





	if(!hDefaultFontN)										// Den Standard-Font erzeugen
		{
		hDefaultFontN = GetDefaultFont(0);
		hDefaultFontB = GetDefaultFont(1);
		}


	if(pData->hFontN==NULL)									// Standard-Font benutzen
		{
		pData->hFontN = hDefaultFontN;
		}

	if(pData->hFontN==hDefaultFontN)						// Ist der Standard-Font eingestellt
		{
		pData->hFontB = hDefaultFontB;
		}
	else{
		pData->hFontB = (pData->hFontX)? pData->hFontX:pData->hFontN;
		}


	if(pData->hFontN!=pData->hFontL)						// Wurde ein neuer Font definiert
		{
		pData->hFontL=pData->hFontN;

		hDc = GetDC(NULL);
		SelectObject(hDc,pData->hFontN);
		GetTextMetrics(hDc,&sMetrics);
		pData->iFontHeight =  sMetrics.tmHeight;
		pData->iFontLine   =  sMetrics.tmAscent+1;
		pData->iFontOff    = (sMetrics.tmPitchAndFamily&TMPF_FIXED_PITCH)? 0:-1;
		if(pData->hFontN!=hDefaultFontN)GetTextFace(hDc,LF_FACESIZE,sLog.lfFaceName);
		ReleaseDC(NULL,hDc);

		if(pData->hFontN!=hDefaultFontN)					// Erstelle fetten Font
			{
			if(pData->hFontX)
				{
				DeleteObject(pData->hFontX);
				pData->hFontX = 0;
				}

			sLog.lfHeight			= sMetrics.tmHeight;
			sLog.lfWidth 			= sMetrics.tmAveCharWidth;
			sLog.lfEscapement 		= GM_COMPATIBLE;
			sLog.lfOrientation 		= 0;
			sLog.lfItalic 			= sMetrics.tmItalic;
			sLog.lfUnderline 		= sMetrics.tmUnderlined;
			sLog.lfStrikeOut 		= sMetrics.tmStruckOut;
			sLog.lfCharSet 			= sMetrics.tmCharSet;
			sLog.lfOutPrecision 	= OUT_DEVICE_PRECIS;
			sLog.lfClipPrecision 	= CLIP_DEFAULT_PRECIS;
			sLog.lfQuality 			= DEFAULT_QUALITY;
			sLog.lfPitchAndFamily 	= sMetrics.tmPitchAndFamily;
			sLog.lfWeight			= FW_BOLD;

			pData->hFontX = CreateFontIndirect(&sLog);
			if(pData->hFontX)pData->hFontB=pData->hFontX;
			}

		iRet=1;
		}
	else{
		iRet=0;
		}


	hDc = GetDC(NULL);										// Breite der "..." Texte
	SelectObject(hDc,pData->hFontN);
	GetTextExtentExPoint(hDc,_T("..."),3,256,NULL,NULL,&sSize);
	pData->uTrippleN =  sSize.cx;
	SelectObject(hDc,pData->hFontB);
	GetTextExtentExPoint(hDc,_T("..."),3,256,NULL,NULL,&sSize);
	pData->uTrippleB =  sSize.cx;
	ReleaseDC(NULL,hDc);




return iRet;
}

//*****************************************************************************
//*
//*		UpdateColumns
//*
//*****************************************************************************
//	Prft ob es Vernderungen in Spaltenbreiten gab
//	pData		: Zeiger auf die Fensterdaten
//	Ergibt die Breite ab der die Spalten verndert wurden oder 0x10000
static int UpdateColumns(FastListData *pData)
{
HWND	hHeader;
UINT	uNext;
UINT	uLast;
UINT	uCol;
UINT	uSub;
int		iSize;
int		iNum;
int		iNow;
int		iOld;
int		iRet;


	hHeader = pData->hHeader;
	uSub    = pData->aColumnPos[0];
	pData->aColumnXpos[uSub]  = 0;

	iRet = 0x10000;
	iOld = 0;
	iNow = 0;

	for(uCol=0;uCol<pData->uColumnCount;)					// Suche die erste genderte Spalte
		{
		uSub  = pData->aColumnPos[uCol];
		iSize = pData->aColumn[uSub].sReal;
		uSub  = pData->aColumn[uSub].bNext;
		iOld  = iNow;
		iNow += iSize;
		uCol += 1;

		if(uCol==1  )iNow -= 1;
		if(iNow<iOld)iNow  = iOld;
		if(uSub==pData->uColumnCount)
		if(iNow>=(int)pData->uSizeX-1)
			{
			iNow++;
			}

		iNum = pData->aColumnXpos[uSub];

		if(iNum==iNow)continue;
		if(iNum==0)iNum=iOld;
		if(iNum>=iNow)
			{
			iRet = iOld;
			}
		else{
			iRet = iOld;

			if(pData->uSelectedItem!=0xFFFFFFFF)			// Problem bei ausgewhlten leeren Eintrgen
				{
				   uNext = pData->aColumn[pData->uSelectedSub].bNext;
				if(uNext==uSub)
					{
					UpdateRect(pData,pData->uSelectedItem,pData->uSelectedSub);
					}
				}

			if(pData->uTrackedItem<pData->uListItemsCount)
				{
				   uNext = pData->aColumn[pData->uTrackedSub].bNext;
				if(uNext==uSub)
					{
					UpdateRect(pData,pData->uTrackedItem,pData->uTrackedSub);
					}
				}
			}


		pData->aColumnXpos[uSub] = iNow;
		break;
		}

	uLast = 0;

	while(uCol<pData->uColumnCount)							// Restliche Spalten berechnen
		{
		iOld  = iNow;
		uSub  = pData->aColumnPos[uCol];
		iSize = pData->aColumn[uSub].sReal;
		uSub  = pData->aColumn[uSub].bNext;

		iNow += iSize;
		uCol += 1;

		pData->aColumnXpos[uSub] = iNow;

		if(iSize>0)uLast=uSub;
		if(uCol==pData->uColumnCount)
		if(iNow>=(int)pData->uSizeX-1)						// Letze sichtbare Spalte bereiter machen
			{
			pData->aColumnXpos[uLast]++;
			iNow++;
			}
		}

	pData->aColumnXpos[pData->uColumnCount+1] = pData->uSizeX+1;



return iRet;
}

//*****************************************************************************
//*
//*		FastListSetOrderArray
//*
//*****************************************************************************
//	Stellt die anzeige Reihenfolge der Spalten ein
//	pData		: Zeiger auf die Fensterdaten
//	uItems		: Ist die Nummer des Eintrages
//	pArray		: Zeiger auf die Eintrge. Null steht fr die Standartreihenfolge.
//				  z.B. {0,2,1} meint die sichtbare Reihenfolge Col0,Col2,Col1
//	Ergibt   1 = Ok
//			 0 = Fehler
static int FastListSetOrderArray(FastListData *pData,unsigned uItems,unsigned *pArray)
{
BYTE		aFlags[FL_MAX_COLUMNS+1];
UINT		aArray[FL_MAX_COLUMNS+1];
LV_COLSIZE	sNotify;
UINT		uDiff;
UINT		uCol;
UINT 		uSub;


	if(!pArray)												// Spezialreihenfolge setzen
		{
		if(uItems==FROM_HEADER)								// Array aus Header holen
			{
			if(!Header_GetOrderArray(pData->hHeader,pData->uColumnCount,aArray))
				{
				return 0;
				}
			}
		else{
			for(uCol=pData->uColumnCount;uCol>0;uCol++)		// Standartreihenfolge
				{
				uCol--;
				aArray[uCol] = uCol;
				}
			}

		uItems = pData->uColumnCount;
		pArray = aArray;
		}
	else{
		if(pData->uColumnCount!=uItems || uItems==0)		// Prfe Array
			{
			return 0;
			}
		}


	memset(aFlags,0,sizeof(aFlags)-1);

	for(uCol=0,uDiff=0;uCol<uItems;uCol++)					// Die Eintrge prfen
		{
		   uSub	= pArray[uCol];
		if(uSub>=uItems)return 0;
		if(aFlags[uSub])return 0;

		aFlags[uSub] = (BYTE)(uCol+1);

		uDiff |= uCol^pData->aColumnPos[uSub];
		}

	if(uDiff==0)											// Alles blieb gleich
		{
		return 1;
		}

	aFlags[uItems] = (BYTE)uItems;

	for(uCol=0;uCol<uItems;uCol++)							// Die Eintrge anpassen
		{
		pData->aColumnPos[uCol]		= (BYTE)pArray[uCol];
		}

	for(uCol=0;uCol<uItems;uCol++)
		{
		uSub						= aFlags[uCol]-1;
		pData->aColumn[uCol].bIndex	= (BYTE)uSub;
		pData->aColumn[uCol].bNext	= pData->aColumnPos[uSub+1];
		}

	Header_SetOrderArray(pData->hHeader,uItems,pArray);
	UpdateColumns(pData);
	UpdateView(pData);


	if(pData->uStyleEx&LVS_EX_HEADERCHGNOTIFY)				// Alle Spalten haben sich verndert
		{
		UNLOCK(pData);

		for(uCol=0;uCol<uItems;uCol++)
			{
 			sNotify.hdr.code	= LVN_COLUMNCHANGED;
			sNotify.uColumn		= uCol;
			sNotify.uIndex		= pData->aColumn[uCol].bIndex;
			sNotify.uPosX		= pData->aColumnXpos[uCol];
			sNotify.iSize		= pData->aColumn[uCol].sReal;

			SendNotify(pData,&sNotify.hdr);
			}

		LOCK(pData);
		}



return 1;
}


//*****************************************************************************
//*
//*		FastListScrollX
//*
//*****************************************************************************
//	Scrollt zur einer X-Koordinate
//	pData		: Zeiger auf die Fensterdaten
//	iPos		: Neue X-Position
//	iMode		: Ist die Art des Scrollens
//					-1					Keine Notify-Anfrage senden
//					SB_????				ber Scroll-Leiste
//					SB_KEYDOWN			ber Tastatur
//					SB_MOUSEWHEEL		ber Mausrad
//					SB_SETPOSITION		ber LVM_SCROLL
//	Ergibt 0 wenn die Scrollposition angenommen wurde, bzw.1 wenn nicht.
static int FastListScrollX(FastListData *pData,int iPos,int iMode)
{
LV_SCROLLED		sNotify;
LRESULT			uRet;
UINT			uVal;
int				iMax;


	   uVal = pData->uColumnCount;
	if(uVal)iMax  = pData->aColumnXpos[uVal]-pData->uSizeX/2;
	else	iMax  = pData->iMaxSizeX;
			iMax -=	pData->uSizeX-pData->uSizeX/2;

	if(iPos>=iMax)iPos=iMax;								// Koordinate Prfen
	if(iPos<0)iPos=0;
	if(iPos==(int)pData->uScrollX)
		{
		return 0;
		}

	if((pData->uStyleEx&LVS_EX_SCROLLNOTIFY) && iMode>=0)	// Scrollen nur ber Notify
		{
		sNotify.hdr.code	= LVN_SCROLLED;
		sNotify.wBar		= SB_HORZ;
		sNotify.wMode		= (WORD)iMode;
		sNotify.iScrollX	= iPos;
		sNotify.iScrollY	= pData->uScrollY;

		UNLOCK(pData);
		uRet = SendNotify(pData,&sNotify.hdr);
		LOCK(pData);

		if(uRet)											// Abbruch gemeldet
			{
			return 1;
			}

		if(iPos>=iMax)iPos=iMax;
		if(iPos<0)iPos=0;
		if(iPos==(int)pData->uScrollX)
			{
			return 0;
			}
		}

	pData->uScrollX = iPos;
	SetScrollPos(pData->hWnd,SB_HORZ,iPos,TRUE);			// Scrollbar aktualisieren
	UpdateView(pData);

	if(pData->hHeader)										// Header-Fenster nachziehen
		{
		MoveWindow(pData->hHeader,-iPos,0,pData->uSizeX+iPos,pData->uStartPixel-pData->uStartOffset,TRUE);
		}


return 0;
}


//*****************************************************************************
//*
//*		FastListScrollY
//*
//*****************************************************************************
//	Scrollt zur einer Y-Koordinate
//	pData		: Zeiger auf die Fensterdaten
//	iPos		: Neue X-Position
//	iMode		: Ist die Art des Scrollens
//					-1					Keine Notify-Anfrage senden
//					SB_????				ber Scroll-Leiste
//					SB_KEYDOWN			ber Tastatur
//					SB_MOUSEWHEEL		ber Mausrad
//					SB_SETPOSITION		ber LVM_SCROLL
//	Ergibt 0 wenn die Scrollposition angenommen wurde, bzw.1 wenn nicht.
static int FastListScrollY(FastListData *pData,int iPos,int iMode)
{
LV_SCROLLED		sNotify;
LRESULT			uRet;
int				iMax;


	iMax  = pData->uListItemsCount;
	iMax -=	pData->uPageEnties-1;

	if(iPos>=iMax)iPos=iMax;								// Koordinate Prfen
	if(iPos<0)iPos=0;
	if(iPos==(int)pData->uScrollY)
		{
		return 0;
		}

	if((pData->uStyleEx&LVS_EX_SCROLLNOTIFY) && iMode>=0)	// Scrollen nur ber Notify
		{
		sNotify.hdr.code	= LVN_SCROLLED;
		sNotify.wBar		= SB_VERT;
		sNotify.wMode		= (WORD)iMode;
		sNotify.iScrollX	= pData->uScrollX;
		sNotify.iScrollY	= iPos;

		UNLOCK(pData);
		uRet = SendNotify(pData,&sNotify.hdr);
		LOCK(pData);

		if(uRet)											// Abbruch gemeldet
			{
			return 1;
			}

		if(iPos>=iMax)iPos=iMax;
		if(iPos<0)iPos=0;
		if(iPos==(int)pData->uScrollY)
			{
			return 0;
			}
		}

	pData->uScrollY		= iPos;
	pData->uScrollYtmp	= iPos;
	SetScrollPos(pData->hWnd,SB_VERT,iPos,TRUE);			// Scrollbar aktualisieren
	UpdateView(pData);


return 0;
}



//*****************************************************************************
//*
//*		FastListGetItemRect
//*
//*****************************************************************************
//	Holt das Rechteck eines Eintrages
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages
//	uFlags		: Bit 0..6   : 0=volle Zeile  1=Icon 2=nur Text	3=Text+Icon
//				  Bit 7      : 1=nur Spalte
//				  Bit 8      : 1=auf Spaltenbreite
//				  Bit 24..31 : Spaltennummer
//	Ergibt 1 wenn der Eintrag sichtbar war
static int FastListGetItemRect(FastListData *pData,unsigned uItem,unsigned uFlags,RECT *pRect)
{
BaseItem   *pEntry;
FL_ENTRY	sData;
int			iPixels;
int			iSize;
unsigned	uNext;
unsigned	uPos;
unsigned	uSub;




	if(uItem>pData->uListItemsCount)
		{
		memset(pRect,0,sizeof(RECT));
		return 0;
		}

	pEntry = pData->pListItems+uItem;

	   uPos = uItem-pData->uScrollY;
	if(uPos>=pData->uMaxEnties)								// Eintrag im Fenster sichtbar
	if(!(uFlags&LVIR_INVISIBLEALSO))
		{
		memset(pRect,0,sizeof(RECT));
		return 0;
		}

	pRect->top     = pData->uStartPixel;
	pRect->top    += pData->iRowHeight*uPos;
	pRect->bottom  = pData->iRowHeight+pRect->top;

	if((uFlags&0xFC)==LVIR_GETCOLUMN)						// Nur Spalten
		{
		   uSub = uFlags>>24;
		if(uSub>=pData->uColumnCount)uSub=0;

		uNext		   = pData->aColumn[uSub].bNext;
		pRect->left    = pData->aColumnXpos[uSub ];
		pRect->left   -= pData->uScrollX;
		pRect->right   = pData->aColumnXpos[uNext];
		pRect->right  -= pData->uScrollX;
		}
	else{
		uSub		   = 0;
		pRect->left    = 0;
		pRect->left   -= pData->uScrollX;
		pRect->right   = pData->uSizeX;
		}


	GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);


	switch(uFlags&0x7F)
		{
	case LVIR_LABEL:										// Nur Text ausgeben

		if(uSub>0)
			{
			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				   pRect->left+=pData->iChecksSizeX;
				if(pRect->left>pRect->right)pRect->left=pRect->right;
				}											// Hat der Extraeintrag ein Icon
			else if(pData->hSubImg && sData.iImage!=LV_NOIMAGE)
				{
				   pRect->left+=pData->iSubImgXsize;
				if(pRect->left>pRect->right)pRect->left=pRect->right;
				}
			}
		else{
			pRect->left = pData->aColumnXpos[0];

			if(pData->uDrawCbSize && pData->pDrawCallback)
				{
				pRect->left += pData->uDrawCbSize;
				}

			if(pEntry->bStart)								// Gibt es Spezialzeichen
				{
				sData.iSize	-= pEntry->bStart;
				sData.pText	+= pEntry->bStart;
				pRect->left += pEntry->bStart*SPECIAL_WIDTH;
				}

			if(pData->hStates)
				{
				pRect->left += pData->iStatesSizeX;
				}

			if(pData->uStyleEx&LVS_EX_GRIDLINES)
				{
				pRect->left += 1;
				if(sData.iImage!=LV_NOIMAGE)pRect->left++;
				}

			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				pRect->left += pData->iChecksSizeX;
				}											// Hat der Extraeintrag ein Icon
			else if(pData->hImages && sData.iImage!=LV_NOIMAGE)
				{
				pRect->left += pData->iImagesSizeX+1;
				}
			}

		if(pRect->left>pRect->right)
			{
			pRect->left=pRect->right;
			}


		iPixels	= GetTextSize(pData,&sData)+4;
		iSize   = pRect->right-pRect->left;


		if(iPixels<iSize)									// Ist der Text kleiner als das Rechteck
			{
			iSize -= iPixels;

			switch(pData->aColumn[uSub].bAlign)
				{
			default:		pRect->right -= iSize;
							break;

			case DT_RIGHT:	pRect->left  += iSize-1;
							pRect->right -= 1;
							break;

			case DT_CENTER:	pRect->left  += iSize/2;
							pRect->right -= iSize-iSize/2;
							break;
				}
			}

		break;

	case LVIR_ICON:											// Nur Icon ausgeben

		if(uSub>0)
			{
			pRect->right = pRect->left;

			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				pRect->right += pData->iChecksSizeX+2;
				}											// Hat der Extraeintrag ein Icon
			else if(pData->hSubImg && sData.iImage!=LV_NOIMAGE)
				{
				pRect->right += pData->iSubImgXsize+2;
				}
			}
		else{
			pRect->left = pData->aColumnXpos[0];

			if(pData->uDrawCbSize && pData->pDrawCallback)
				{
				pRect->left += pData->uDrawCbSize;
				}

			if(pEntry->bStart)								// Gibt es Spezialzeichen
				{
				sData.iSize	-= pEntry->bStart;
				sData.pText	+= pEntry->bStart;
				pRect->left += pEntry->bStart*SPECIAL_WIDTH;
				}

			if(pData->hStates)
				{
				pRect->left += pData->iStatesSizeX;
				}

			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				pRect->left += 1;
				}											// Hat der Extraeintrag ein Icon
			else if(pData->uStyleEx&LVS_EX_GRIDLINES)
				{
				pRect->left += 1;
				if(sData.iImage!=LV_NOIMAGE)pRect->left++;
				}

			pRect->right = pRect->left;

			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				pRect->right += pData->iChecksSizeX;
				}											// Hat der Extraeintrag ein Icon
			else if(pData->hImages && sData.iImage!=LV_NOIMAGE)
				{
				pRect->right += pData->iImagesSizeX+3;
				}
			}

		break;

	case LVIR_SELECTBOUNDS:									// Text mit Icon

		if(uSub>0)
			{

			}
		else{
			pRect->left = pData->aColumnXpos[0];

			if(pData->uDrawCbSize && pData->pDrawCallback)
				{
				pRect->left += pData->uDrawCbSize;
				}

			if(pEntry->bStart)								// Gibt es Spezialzeichen
				{
				pRect->left += pEntry->bStart*SPECIAL_WIDTH;
				}

			if(pData->hStates)
				{
				pRect->left += pData->iStatesSizeX;
				}

			if(pData->uStyleEx&LVS_EX_GRIDLINES)
				{
				pRect->left += 1;

				if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)	// Checkboxen vorhanden
					{
					pRect->left++;
					}
				else if(sData.iImage!=LV_NOIMAGE)
					{
					pRect->left++;
					}
				}

			if(pRect->left>pRect->right)
				{
				pRect->left=pRect->right;
				}
			}

		break;
		}



return 1;
}

//*****************************************************************************
//*
//*		FastListEnsureVisible
//*
//*****************************************************************************
//	Macht einen Eintrag sichtbar
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages
//	uSub		: Untereintrag der sichtbar sein soll
//						1			Halbzeile ok
//						0x80000000  Spalte wurde angegeben
//						0x10000000  Eingabe von Tastatur
//						0x8FFFFFFF	nur Zeile
//						FIRST_LINE	Item als oberster Eintrag
//	iMode		: Ist der Eingabemodus fr die Scroll-Position
//					   -1			Keine Notify-Nachricht
//					SB_????				ber Scroll-Leiste
//					SB_KEYDOWN			ber Tastatur
//					SB_MOUSEWHEEL		ber Mausrad
//					SB_SETPOSITION		ber LVM_SCROLL
//	Ergibt 1 wenn nur zum Eintrag gescrollt wurde bzw. 0 wenn nicht.
static int FastListEnsureVisible(FastListData *pData,unsigned uItem,unsigned uSub,int iMode=-1)
{
unsigned	uLine;
unsigned	uNext;
unsigned	uEnd;
int			iNum;
int			iAnf;
int			iOff;
int			iEnd;
int			iMax;
int			iRet;



	if(uItem>=pData->uListItemsCount)return -1;


	if(pData->cUpdateFlag)									// Direktes Update gesprerrt
		{
		pData->uUpdateEnMode = iMode;
		pData->uUpdateEnsure = uItem;
		pData->uUpdateEnSub  = uSub;
		UpdateStart(pData);
		return 0;
		}

	pData->uUpdateEnsure = 0xFFFFFFFF;

	uEnd	  = (uSub==1)? pData->uMaxEnties:pData->uPageEnties;
	uLine	  = pData->uScrollY;
	iRet	  = 0;

	if(uItem<pData->uScrollY)								// Vor erster Zeile
		{
		uLine = uItem;
		}
	else if(uSub==FIRST_LINE)								// Item als ersten Eintrag
		{
		uLine = uItem;
		uSub  = 0;
		}
	else if(uItem>=pData->uScrollY+uEnd)					// Nach letzter Zeile
		{
		iOff  = uItem-(pData->uPageEnties-1);
		iMax  = pData->uListItemsCount;
		iMax -=	pData->uPageEnties-1;

		if(iOff>=iMax)iOff=iMax;
		if(iOff<0)iOff=0;
		if(iOff!=(int)pData->uScrollY)
			{
			uLine = iOff;
			}
		}


	if(uLine!=pData->uScrollY)								// Hat sich die Scroll-Position verndert
		{
		if(FastListScrollY(pData,uLine,iMode))
			{
			return 0;
			}

		iRet = 1;
		}

	if(!(uSub&0x80000000))									// Auch zur Spalte scrollen
		{
		return iRet;
		}

	uSub &= 0x0FFFFFFF;

	if(uSub<pData->uColumnCount)							// Horizontal einrichten
		{
		uNext = pData->aColumn[uSub].bNext;
		iNum  = pData->uSizeX;
		iOff  = pData->uScrollX;
		iAnf  = pData->aColumnXpos[uSub ];
		iEnd  = pData->aColumnXpos[uNext];

		if(iOff+iNum< iAnf)iOff=iAnf;
		if(iOff     >=iEnd)iOff=iAnf;
		if(iOff+iNum< iEnd)iOff=iEnd-iNum;
		if(iOff     > iAnf)iOff=iAnf;

		iMax  = pData->aColumnXpos[pData->uColumnCount];
		iMax -= pData->uSizeX/2;

		if(iOff>iMax)iOff=iMax;
		if(iOff<   0)iOff=0;
		if(iOff!=(int)pData->uScrollX)						// Hat sich die Scroll-Position verndert
			{
			if(!FastListScrollX(pData,iOff,iMode))
				{
				iRet = 1;
				}
			}
		}


return iRet;
}

//*****************************************************************************
//*
//*		FastListIsVisible
//*
//*****************************************************************************
//	Prft ob ein Eintrag sichtbar ist
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages
//	uSub		: Untereintrag der geprft werden soll
//						0xFFFFFFFF nur Zeile prfen
//	Ergibt den Zustand des Eintrages:
//				   -1 = Unbekannter Eintrag
//					0 = Eintrag ist nicht sichtbar
//					1 = Eintrag ist teilweise sichtbar
//					2 = Eintrag ist ganz sichtbar
static int FastListIsVisible(FastListData *pData,unsigned uItem,unsigned uSub)
{
unsigned	uNext;
int			iNum;
int			iAnf;
int			iOff;
int			iEnd;



	if(uItem>=pData->uListItemsCount)return -1;


	if(uItem<pData->uScrollY)								// Vor erster Zeile
		{
		return 0;
		}

	if(uItem>=pData->uScrollY+pData->uMaxEnties)			// Nach letzter Zeile
		{
		return 0;
		}

	if(uItem==pData->uScrollY+pData->uPageEnties)			// Auf halbsichtbarer Zeile
		{
		if(uSub<pData->uColumnCount)
			{
			uNext = pData->aColumn[uSub].bNext;
			iNum  = pData->uSizeX;
			iOff  = pData->uScrollX;
			iAnf  = pData->aColumnXpos[uSub ];
			iEnd  = pData->aColumnXpos[uNext];

			if(iOff+iNum< iAnf)return 1;
			if(iOff     >=iEnd)return 1;
			}

		return 1;
		}

	if(uSub<pData->uColumnCount)							// Spalte prfen
		{
		uNext = pData->aColumn[uSub].bNext;
		iNum  = pData->uSizeX;
		iOff  = pData->uScrollX;
		iAnf  = pData->aColumnXpos[uSub ];
		iEnd  = pData->aColumnXpos[uNext];

		if(iOff+iNum< iAnf)return 1;
		if(iOff     >=iEnd)return 1;
		if(iOff+iNum< iEnd)return 3;
		if(iOff     > iAnf)return 3;
		}



return 2;
}

//*****************************************************************************
//*
//*		FastListDeleteItems
//*
//*****************************************************************************
//	Lscht einen oder mehrere Eintrge aus dem Fenster
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages der gelscht werden soll
//				  Mit LV_DELALL kann alles gelscht werden.
//	iCount		: Ist die Anzahl der zu lschenden Eintrge
//	Ergibt 1 wenn die Eintrge gelscht wurden.
static int FastListDeleteItems(FastListData *pData,unsigned uItem,int iCount)
{
NMLISTVIEW	sNotify;
BaseItem   *pEntry;
unsigned	uScroll;
unsigned	uDraw;
unsigned	uPos;
unsigned	uEnd;
unsigned	uOld;
LRESULT		lRet;



	if(pData->cLockChanges)return 0;


	if(uItem>=pData->uListItemsCount || iCount<=0)			// Prfe den Eintrag
		{
		return 0;
		}


	uEnd = uItem+iCount;

	if(uEnd>pData->uListItemsCount)
		{
		iCount = pData->uListItemsCount-uItem;
		uEnd   = pData->uListItemsCount;
		}


	for(uPos=uItem;uPos<uEnd;uPos++,pEntry++)				// Ausgewhlte Eintrge abwhlen
		{
		if(uPos>=pData->uListItemsCount)					// Prfen ob der Eintrag noch existiert
			{
			return 0;
			}

		pEntry = pData->pListItems+uPos;

		if(!(pEntry->uState&LVIS_SELECTED))
			{
			continue;
			}

		if(pData->uSelectedCount>0)							// Ausgewhlte Eintrge runter zhlen
			{
			pData->uSelectedCount--;
			}

		if(pData->uSelectedItem==uPos)
			{
			pData->uSelectedItem = 0xFFFFFFFF;
			pData->uSelectedSub  = 0x00000000;
			}

		if(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY)			// Keine nderungsnachrichten
			{
			continue;
			}

		if(pData->cUpdateFlag)								// Notify wegen Update gesperrt
			{
			pData->cUpdateResel = 1;
			continue;
			}

		sNotify.hdr.code	= LVN_ITEMCHANGED;
		sNotify.iItem		= uPos;
		sNotify.iSubItem	= pData->uSelectedSub;
		sNotify.uNewState	= pEntry->uState&~LVIS_SELECTED;
		sNotify.uOldState	= pEntry->uState;
		sNotify.uChanged	= LVIS_SELECTED;
		sNotify.lParam		= pEntry->lParam;
		sNotify.ptAction.x	= 0;
		sNotify.ptAction.y	= 0;

		UNLOCK(pData);
		lRet = SendNotify(pData,&sNotify.hdr);				// Bekanntgeben das der Eintrag nicht mehr ausgewhlt ist
		LOCK(pData);
		}



	if(pData->uTrackedItem!=0xFFFFFFFF)						// Einen unterstrichenen Eintrag lschen
		{
		if(pData->uTrackedItem>=uItem && pData->uTrackedItem<uEnd)
			{
			UpdateToolTip(pData,0xFFFFFFFF,0,0);
			pData->uTrackedItem  = 0xFFFFFFFF;
			pData->uTrackedSub   = 0x00000000;
			}
		else if(pData->uTrackedItem>uItem)
			{
			pData->uTrackedItem -= iCount;
			}
		}


	if(pData->uFocusItem!=0xFFFFFFFF)						// Einen fokusierten Eintrag lschen
		{
		if(pData->uFocusItem>=uItem && pData->uFocusItem<uEnd)
			{
			pData->uFocusItem    = 0xFFFFFFFF;
			pData->uFocusSub     = 0x00000000;
			}
		else if(pData->uFocusItem>uItem)
			{
			pData->uFocusItem   -= iCount;
			}
		}


	if(pData->uDragItem!=0xFFFFFFFF)						// Einen gedragten Eintrag lschen
		{
		if(pData->uDragItem>=uItem && pData->uDragItem<uEnd)
			{
			pData->uDragItem     = 0xFFFFFFFF;
			pData->uDragSub      = 0x00000000;
			}
		else if(uItem>pData->uDragItem)
			{
			pData->uDragItem    -= iCount;
			}
		}


	if(pData->uToolTipItem!=0xFFFFFFFF)						// Einen ToolTip-Eintrag lschen
		{
		if(pData->uToolTipItem>=uItem)
			{
			if(pData->cUpdateFlag)							// Direktes Update gesprerrt
				{
				pData->uToolTipItem  = 0xFFFFFFFF;
				pData->uToolTipSub   = 0x00000000;
				pData->uUpdateTip    = LVHT_NOWHERE;
				UpdateStart(pData);
				}
			else{
				UpdateToolTip(pData,0xFFFFFFFF,0,0);
				}
			}
		}


	if(pData->uEditItem!=0xFFFFFFFF)						// Einen fokusierten Eintrag lschen
		{
		if(pData->uEditItem>=uItem && pData->uEditItem<uEnd)
			{
			FastListEndLabelEdit(pData,0);
			}
		else if(pData->uEditItem<uItem)
			{
			pData->uEditItem    -= iCount;
			}
		}

	if(pData->uUpdateEnsure!=0xFFFFFFFF)					// Update EnsureVisible anpassen
		{
		if(pData->uUpdateEnsure>uEnd)
			{
			pData->uUpdateEnsure -= iCount;
			}
		else if(pData->uUpdateEnsure>uItem)
			{
			pData->uUpdateEnd = uItem;
			}
		}


	if(pData->cUpdateRows)									// Update Befehle anpassen
		{
		if(pData->uUpdateRow>uEnd)
			{
			pData->uUpdateRow -= iCount;
			}
		else if(pData->uUpdateRow>uItem)
			{
			pData->uUpdateRow = uItem;
			}

		if(pData->uUpdateEnd>uEnd)
			{
			pData->uUpdateEnd -= iCount;
			}
		else if(pData->uUpdateEnd>uItem)
			{
			pData->uUpdateEnd = uItem;
			}
		}
	else{
		pData->cUpdateRows	= 1;
		pData->uUpdateRow	= uItem;
		pData->uUpdateEnd	= uEnd;
		}


	uScroll = (pData->cFastFlag)? pData->uScrollYtmp:pData->uScrollY;


	if(uScroll>=uEnd)										// Muss die Scroll-Position angepasst werden
		{
		if(pData->cFastFlag)
			{
			pData->uScrollY  = pData->uScrollYtmp;
			pData->cFastFlag = 0;
			}

		pData->uScrollY -= iCount;
		uDraw = 0xFFFFFFFF;
		}
	else if(uScroll+pData->uMaxEnties<=uItem)
		{
		uDraw = 0xFFFFFFFF;
		}
	else if(uScroll>uItem)
		{
		if(pData->cFastFlag)
			{
			pData->uScrollY  = pData->uScrollYtmp;
			pData->cFastFlag = 0;
			}

		pData->uScrollY = uItem;
		uDraw = uItem;
		}
	else{
		uDraw = uItem;
		}


//******************** Eintrge lschen ***************************************


	uOld	= pData->uSelectedItem;

															// Keine Notify-Nachrichten beim Lschen
	if((pData->uStyleEx&LVS_EX_NODELNOTIFY) || pData->cUpdateFlag)
		{
		memmove(pData->pListItems+uItem,pData->pListItems+uEnd,(pData->uListItemsCount-uEnd)*sizeof(BaseItem));
		pData->uListItemsCount -= iCount;

		if((int)pData->uSelectedItem>(int)uItem)
			{
			pData->uSelectedItem -= iCount;
			}
		}
	else{
		for(uPos=uEnd;uPos>uItem;)							// Alle Eintrge lschen mit Notify
			{
			uPos--;

			pEntry				= pData->pListItems+uPos;
			sNotify.hdr.code	= LVN_DELETEITEM;
			sNotify.iItem		= uPos;
			sNotify.iSubItem	= 0;
			sNotify.uNewState	= pEntry->uState&~LVIS_SELECTED;
			sNotify.uOldState	= pEntry->uState;
			sNotify.uChanged	= LVIS_SELECTED;
			sNotify.lParam		= pEntry->lParam;
			sNotify.ptAction.x	= 0;
			sNotify.ptAction.y	= 0;

			UNLOCK(pData);
			SendNotify(pData,&sNotify.hdr);
			LOCK(pData);

			if(uPos>=pData->uListItemsCount)return 0;		// Prfen ob der Eintrag noch existiert

			memmove(pData->pListItems+uPos,pData->pListItems+uPos+1,(pData->uListItemsCount-uPos)*sizeof(BaseItem));
			pData->uListItemsCount--;

			if((int)pData->uSelectedItem>(int)uPos)
				{
				pData->uSelectedItem -= 1;
				}
			}
		}

	if(uOld!=pData->uSelectedItem)							// Hat sich die Auswahl verndert
	if(uOld<uItem || uOld>=uEnd)
	if(uOld<pData->uListItemsCount && pData->uSelectedItem<pData->uListItemsCount)
		{
		if(pData->cUpdateFlag)
			{
			pEntry				= pData->pListItems+pData->uSelectedItem;
			pEntry->bFlags	   |= LVIX_UPDATE;
			}
		else if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))	// Keine nderungsnachrichten
			{
			pEntry				= pData->pListItems+uOld;
			sNotify.hdr.code	= LVN_ITEMCHANGED;
			sNotify.iItem		= uOld;
			sNotify.iSubItem	= pData->uSelectedSub;
			sNotify.uNewState	= pEntry->uState;
			sNotify.uOldState	= pEntry->uState|LVIS_SELECTED;
			sNotify.uChanged	= LVIS_SELECTED;
			sNotify.lParam		= pEntry->lParam;
			sNotify.ptAction.x	= 0;
			sNotify.ptAction.y	= 0;

			UNLOCK(pData);
			lRet = SendNotify(pData,&sNotify.hdr);			// Bekanntgeben das der Eintrag nicht mehr ausgewhlt ist
			LOCK(pData);

			pEntry				= pData->pListItems+pData->uSelectedItem;
			sNotify.hdr.code	= LVN_ITEMCHANGED;
			sNotify.iItem		= pData->uSelectedItem;
			sNotify.iSubItem	= pData->uSelectedSub;
			sNotify.uNewState	= pEntry->uState;
			sNotify.uOldState	= pEntry->uState&~LVIS_SELECTED;
			sNotify.uChanged	= LVIS_SELECTED;
			sNotify.lParam		= pEntry->lParam;
			sNotify.ptAction.x	= 0;
			sNotify.ptAction.y	= 0;

			UNLOCK(pData);
			lRet = SendNotify(pData,&sNotify.hdr);			// Bekanntgeben das der Eintrag nicht mehr ausgewhlt ist
			LOCK(pData);
			}
		}

	UpdateScrollY(pData);

	if(uDraw!=0xFFFFFFFF)UpdateRows(pData,uDraw,pData->uMaxEnties);
	if(pData->uToolTipItem!=0xFFFFFFFF && pData->uToolTipItem>=pData->uListItemsCount==0)
		{
		if(pData->hToolTip)UpdateToolTip(pData,0xFFFFFFFF,0,0);
		UpdateView(pData);
		}



return 1;
}



//*****************************************************************************
//*
//*		FastListXorSelectItem
//*
//*****************************************************************************
//	Whlt einen Eintrag ab bzw. an
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages der ausgewhlt werden soll
//	Ergibt		1 wenn der Eintrag ab/angewhlt wurde
//				0 wenn der Eintrag nicht verndert wurde
static int FastListXorSelectItem(FastListData *pData,unsigned uItem)
{
NMLISTVIEW	sNotify;
BaseItem   *pEntry;
unsigned	uRet;
WORD		uOld;



	if(uItem>=pData->uListItemsCount)return 0;

	pEntry	= pData->pListItems+uItem;
	uOld	= pEntry->uState;


	if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
		{
		sNotify.hdr.code	= LVN_ITEMCHANGING;
		sNotify.iItem		= uItem;
		sNotify.iSubItem	= pData->uSelectedSub;
		sNotify.uNewState	= uOld^LVIS_SELECTED;
		sNotify.uOldState	= uOld;
		sNotify.uChanged	= LVIS_SELECTED;
		sNotify.lParam		= pEntry->lParam;
		sNotify.ptAction.x	= 0;
		sNotify.ptAction.y	= 0;

		UNLOCK(pData);
		uRet=U(SendNotify(pData,&sNotify.hdr));
		LOCK(pData);

		if(uRet)return 0;

		pEntry				= pData->pListItems+uItem;
		}


	pEntry->uState		   ^= LVIS_SELECTED;


	if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
		{
		sNotify.hdr.code	= LVN_ITEMCHANGED;

		UNLOCK(pData);
		SendNotify(pData,&sNotify.hdr);
		LOCK(pData);
		}


	if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
			UpdateRows(pData,uItem);
	else	UpdateRect(pData,uItem,0);


	if((uOld^pEntry->uState)&LVIS_SELECTED)
		{
		if(pEntry->uState&LVIS_SELECTED)
				pData->uSelectedCount++;
		else	pData->uSelectedCount--;
		}


return 1;
}


//*****************************************************************************
//*
//*		FastListRemoveFocus
//*
//*****************************************************************************
//	Whlt den Fokus ab
//	pData		: Zeiger auf die Fensterdaten
static void FastListRemoveFocus(FastListData *pData)
{
BaseItem   *pEntry;


	if(pData->uFocusItem==0xFFFFFFFF)return;

	if(pData->uFocusItem<pData->uListItemsCount)
		{
		pEntry			= pData->pListItems+pData->uFocusItem;
		pEntry->bFlags &= ~LVIX_FOCUSED;
		pEntry->uState &= ~LVIS_FOCUSED;

		UpdateRect(pData,pData->uFocusItem,pData->uFocusSub);
		}


	pData->uFocusItem = 0xFFFFFFFF;
	pData->uFocusSub  = 0x00000000;

}

//*****************************************************************************
//*
//*		FastListSetFocusColumn
//*
//*****************************************************************************
//	Die Spalte mit dem Focus auswhlen
//	pData		: Zeiger auf die Fensterdaten
//	uSub		: Ist die Nummer der Spalte
//	Ergibt 1 wenn erfolgreich bzw. 0 wenn nicht
static int FastListSetFocusColumn(FastListData *pData,unsigned uSub)
{


	if(  pData->uFocusItem==0xFFFFFFFF    )return 0;
	if(!(pData->uStyleEx&LVS_EX_SUBSELECT))return 0;
	if(  uSub  >=pData->uColumnCount      )return 0;

	pData->uFocusSub     = uSub;

	UpdateRows(pData,pData->uFocusItem);


return 1;
}



//*****************************************************************************
//*
//*		FastListSelectItem
//*
//*****************************************************************************
//	Whlt einen Eintrag aus
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist die Nummer des Eintrages der ausgewhlt werden soll
//	uSubItem	: Ist die Spalte die gewhlt werden soll
//	iDel		: Dieses Flag lscht die alte Auswahl
//	Ergibt		1 wenn der Eintrag gewhlt wurde
//				0 wenn der Eintrag nicht gewhlt wurde
static int FastListSelectItem(FastListData *pData,unsigned uItem,unsigned uSubItem,int iDel)
{
NMLISTVIEW	sNotify;
BaseItem   *pEntry;
BaseItem   *pTemp;
LPARAM		lParam;
LPARAM		lPaOld;
unsigned	uState;
unsigned	uStOld;
unsigned	uPos;
unsigned	uOld;
unsigned	uSub;



	uOld = pData->uSelectedItem;
	uSub = pData->uSelectedSub;


	if(uSubItem>=pData->uColumnCount && uSubItem>0)
		{
		return 0;
		}

	if(uItem>=pData->uListItemsCount)
		{
		return 0;
		}

	if(uItem==uOld && uSubItem==uSub)
	if(pData->uSelectedCount<=1 || (pData->uStyle&LVS_SINGLESEL))
		{
		return 1;
		}


	if(!(pData->uStyle&LVS_SINGLESEL))						// Ist die Mehrfachauswahl mglich
		{
		if(!iDel)
			{
			if(pData->uStyleEx&(LVS_EX_FULLROWSELECT|LVS_EX_SUBSELECT))
					UpdateRows(pData,uOld);
			else	UpdateRect(pData,uOld,uSub);

			uOld = 0xFFFFFFFF;
			uSub = 0x00000000;
			}
		else{												// Alle gewhlten Eintrge abwhlen
			if(pData->uSelectedCount>1 && pData->uListItemsCount)
				{
				for(uPos=pData->uListItemsCount;uPos;)
					{
					uPos--;
					pEntry = pData->pListItems+uPos;
					if(!(pEntry->uState&LVIS_SELECTED))continue;
					if(FastListXorSelectItem(pData,uPos))
					if(!pData->uSelectedCount)break;		// Wurden alle Eintrge abgewhlt
					}
				}
			}
		}
	else{
		iDel = 1;											// Alte Auswahl lschen
		}



	if(uItem>=pData->uListItemsCount)						// Neuen Status holen
		{
		if(uItem!=0xFFFFFFFF)return 0;

		pEntry = 0;
		uState = 0;
		lParam = 0;
		}
	else{
		pEntry = pData->pListItems+uItem;
		uState = pEntry->uState;
		lParam = pEntry->lParam;
		}


	if(uOld>=pData->uListItemsCount)						// Alten Status holen
		{
		pTemp  = 0;
		uStOld = 0;
		lPaOld = 0;
		}
	else{
		pTemp  = pData->pListItems+uOld;
		uStOld = pTemp->uState;
		lPaOld = pTemp->lParam;
		}


	if(!(uState&LVIS_SELECTED))								// Ist der neue Eintrag nicht selektiert
	if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
		{
		sNotify.hdr.code	= LVN_ITEMCHANGING;
		sNotify.iItem		= uItem;
		sNotify.iSubItem	= uSubItem;
		sNotify.uNewState	= uState|LVIS_SELECTED;
		sNotify.uOldState	= uState;
		sNotify.uChanged	= LVIS_SELECTED;
		sNotify.lParam		= pEntry->lParam;
		sNotify.ptAction.x	= 0;
		sNotify.ptAction.y	= 0;

		UNLOCK(pData);

		if(SendNotify(pData,&sNotify.hdr))					// Abfragen ob der Eintrag gewhlt werden darf
			{
			LOCK(pData);
			return 0;
			}

		LOCK(pData);
		}


	if(iDel && (uStOld&LVIS_SELECTED))						// Ist der alte Eintrag noch selektiert
	if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
		{
		sNotify.hdr.code	= LVN_ITEMCHANGING;
		sNotify.iItem		= uOld;
		sNotify.iSubItem	= uSub;
		sNotify.uNewState	= uStOld&~LVIS_SELECTED;
		sNotify.uOldState	= uStOld;
		sNotify.uChanged	= LVIS_SELECTED;
		sNotify.lParam		= pEntry->lParam;
		sNotify.ptAction.x	= 0;
		sNotify.ptAction.y	= 0;

		UNLOCK(pData);

		if(SendNotify(pData,&sNotify.hdr))					// Abfragen ob der Eintrag abgewhlt werden darf
			{
			LOCK(pData);
			return 0;
			}

		LOCK(pData);
		}


	if(uItem>=pData->uListItemsCount)						// Prfen ob der Eintrag noch existiert
		{
		return 0;
		}


	if(iDel)												// Den alten Eintrag abwhlen
		{
		if(pData->uSelectedItem<pData->uListItemsCount)
			{
			uOld    = pData->uSelectedItem;
			pTemp	= pData->pListItems+uOld;

			if(pTemp->uState&LVIS_SELECTED)
				{
				pTemp->uState &= ~LVIS_SELECTED;

				if(pData->uSelectedCount>0)
					{
					pData->uSelectedCount -= 1;
					}

				if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
					{
					sNotify.hdr.code	= LVN_ITEMCHANGED;
					sNotify.iItem		= uOld;
					sNotify.iSubItem	= uSub;
					sNotify.uNewState	= uStOld&~LVIS_SELECTED;
					sNotify.uOldState	= uStOld;
					sNotify.uChanged	= LVIS_SELECTED;
					sNotify.lParam		= pEntry->lParam;
					sNotify.ptAction.x	= 0;
					sNotify.ptAction.y	= 0;

					UNLOCK(pData);
					SendNotify(pData,&sNotify.hdr);
					LOCK(pData);
					}
				}

			pData->uSelectedSub  = 0x00000000;
			pData->uSelectedItem = 0xFFFFFFFF;

			if((pData->uStyleEx&LVS_EX_FULLROWSELECT) || pData->uSelectedSub)
					UpdateRows(pData,uOld);
			else	UpdateRect(pData,uOld,uSub);
			}
		}



	if(uItem<pData->uListItemsCount)						// Den neuen Eintrag whlen
		{
		pData->uSelectedSub  = uSubItem;
		pData->uSelectedItem = uItem;

		if(!(pEntry->uState&LVIS_SELECTED))
			{
			uState				  |= LVIS_SELECTED;
			pEntry->uState        |= LVIS_SELECTED;
			pData->uSelectedCount += 1;

			if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
				{
				sNotify.hdr.code	= LVN_ITEMCHANGED;
				sNotify.iItem		= uItem;
				sNotify.iSubItem	= uSubItem;
				sNotify.uNewState	= uState;
				sNotify.uOldState	= uState&~LVIS_SELECTED;
				sNotify.uChanged	= LVIS_SELECTED;
				sNotify.lParam		= pEntry->lParam;
				sNotify.ptAction.x	= 0;
				sNotify.ptAction.y	= 0;

				UNLOCK(pData);
				SendNotify(pData,&sNotify.hdr);
				LOCK(pData);
				}
			}

		if(pData->uStyleEx&(LVS_EX_FULLROWSELECT|LVS_EX_SUBSELECT))
				UpdateRows(pData,uItem);
		else	UpdateRect(pData,uItem,uSubItem);
		}
	else{
		pData->uSelectedItem = 0xFFFFFFFF;
		pData->uSelectedSub  = 0x00000000;
		}


	if(pData->uStyle&LVS_SHOWSELALWAYS)						// Auswahl immer einblenden
	if(pData->uSelectedItem<pData->uListItemsCount)
		{
		FastListEnsureVisible(pData,pData->uSelectedItem,pData->uSelectedSub|0x80000000);
		}



return 1;
}

//*****************************************************************************
//*
//*		FastListInsertItem
//*
//*****************************************************************************
//	Fgt einen Eintrag ins Fenster ein
//	pData		: Zeiger auf die Fensterdaten
//	pInsert		: Zeiger auf die ein zu fgenden Daten
//	Ergibt die Einfgeposition des neuen Eintrages oder 0 bei einem Fehler
static unsigned FastListInsertItem(FastListData *pData,LVITEM *pInsert)
{
NMLISTVIEW	sNotify;
BaseItem   *pNew;
BaseItem   *pOld;
BaseItem   *pItems;
unsigned	uBits;
unsigned	uMax;
unsigned	uPos;



	if(pData->cLockChanges)return 0;

	if(pData->uListItemsCount>=pData->uListItemsMax)		// Gre der Liste erhhen
		{
		pOld	= pData->pListItems;
		uMax	= pData->uListItemsMax;
		uMax   += pData->uListItemsMax/2;
		uMax   += 64;
		pItems  = new BaseItem[uMax+1];

		if(!pItems)
			{
			return 0;
			}

		memcpy(pItems ,pData->pListItems       ,sizeof(BaseItem)*(     pData->uListItemsMax+1));
		memset(pItems +pData->uListItemsMax+1,0,sizeof(BaseItem)*(uMax-pData->uListItemsMax  ));

		pData->uListItemsMax = uMax;
		pData->pListItems	 = pItems;
		delete pOld;
		}


//******************** Den neuen Eintrag erzeugen *****************************


	pItems	= pData->pListItems;
	uPos	= pInsert->iItem;

	if(uPos>pData->uListItemsCount)
		{
		uPos = pData->uListItemsCount;
		}

															// Erstelle den neuen Eintrag
	memmove(pItems+uPos+1,pItems+uPos,sizeof(BaseItem)*(pData->uListItemsCount-uPos));
	pNew	= pItems+uPos;
	memset(pNew,0,sizeof(BaseItem));

	uBits = pInsert->mask;

	if(uBits&LVIF_STATE)
		{
		pNew->uState = (WORD)(pInsert->state&pInsert->stateMask);
		}
	else if(pData->uStyleEx&LVS_EX_CHECKBOXES)
		{
		pNew->uState = 0x1000;
		}

	if(uBits&LVIF_PARAM)
		{
		pNew->lParam = pInsert->lParam;
		}



//******************** Eintrag einfgen ***************************************


	pData->uListItemsCount++;

	if((int)pData->uSelectedItem>=(int)uPos)				// Diverse Einrge verschieben
		{
		pData->uSelectedItem++;
		}

	if((int)pData->uFocusItem>=(int)uPos)
		{
		pData->uFocusItem++;
		}

	if((int)pData->uEditItem>=(int)uPos)
		{
		pData->uEditItem++;
		}

	if((int)pData->uTrackedItem>=(int)uPos)
		{
		pData->uTrackedItem++;
		}

	if((int)pData->uDragItem>=(int)uPos)
		{
		pData->uDragItem++;
		}

	if((int)pData->uUpdateEnsure>=(int)uPos)
		{
		pData->uUpdateEnsure++;
		}

	if(pData->cUpdateRows)
		{
		if(pData->uUpdateRow>=uPos)
			{
			pData->uUpdateRow = uPos;
			}

		if(pData->uUpdateEnd>=uPos)
			{
			pData->uUpdateEnd++;
			}
		}

	if(pNew->uState&LVIS_SELECTED)							// Den ausgewhlten Eintrag auswhlen
		{
		if(pData->cUpdateFlag)								// Direktes Update gesprerrt
			{
			pData->cUpdateItems = 1;
			pNew ->bFlags	   |= LVIX_UPDATE;
			UpdateStart(pData);
			}
		else{
			FastListSelectItem(pData,uPos,0,0);
			}
		}


	if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY) && !pData->cUpdateFlag)
		{
		sNotify.hdr.code	= LVN_INSERTITEM;
		sNotify.iItem		= uPos;
		sNotify.iSubItem	= 0;
		sNotify.uNewState	= pNew->uState;
		sNotify.uOldState	= 0;
		sNotify.uChanged	= pNew->uState;
		sNotify.lParam		= pNew->lParam;
		sNotify.ptAction.x	= 0;
		sNotify.ptAction.y	= 0;

		UNLOCK(pData);
		SendNotify(pData,&sNotify.hdr);
		LOCK(pData);
		}

	if(pInsert->mask&LVIF_FAST)								// Schnell einfgen ohne scrollen und neuzeichnen
		{
		if(!pData->cFastFlag)
			{
			pData->cFastFlag   = 1;
			pData->uScrollYtmp = pData->uScrollY;
			}

		if(uPos<pData->uScrollYtmp)
			{
			pData->uScrollYtmp++;
			}

		if(pInsert->mask&LVIF_ENDSCROLL)					// Beim Einfgen am Ende muss Eintrag sichtbar bleiben
			{
			if(uPos>=pData->uScrollYtmp+pData->uPageEnties-2)
			if(uPos<=pData->uScrollYtmp+pData->uPageEnties  )
				{
				if(pData->uPageEnties>=2)
						pData->uScrollYtmp = uPos-pData->uPageEnties+2;
				else	pData->uScrollYtmp = uPos;

				pData->cUpdateScrollY = 1;
				pData->cUpdateView	  = 1;

				UpdateStart(pData);

				return uPos;
				}
			}

		if(pInsert->mask&LVIF_SHOWSCROLL)					// Einfgeposition muss sichtbar bleiben
			{
			if(uPos<pData->uScrollYtmp || uPos>=pData->uScrollYtmp+pData->uPageEnties)
				{
				if(uPos<pData->uScrollYtmp)
						pData->uScrollYtmp = uPos;
				else	pData->uScrollYtmp = uPos-(pData->uPageEnties-1);

				pData->cUpdateScrollY = 1;
				pData->cUpdateView	  = 1;

				UpdateStart(pData);

				return uPos;
				}
			}

		if(uPos<pData->uScrollY+pData->uMaxEnties)			// Ist der neue Eintrag sichtbar
			{
			pData->cUpdateView	= 1;
			}

		pData->cUpdateScrollY	= 1;

		UpdateStart(pData);

		return uPos;
		}


	if(uPos<pData->uScrollY)
		{
		pData->uScrollY++;
		}

	if(pInsert->mask&LVIF_ENDSCROLL)						// Beim Einfgen am Ende muss Eintrag sichtbar bleiben
		{
		if(uPos>=pData->uScrollY+pData->uPageEnties-2)
		if(uPos<=pData->uScrollY+pData->uPageEnties  )
			{
			if(pData->uPageEnties>=2)
					pData->uScrollY = uPos-pData->uPageEnties+2;
			else	pData->uScrollY = uPos;

			UpdateView(pData);
			UpdateScrollY(pData);
			return uPos;
			}
		}
	else if(pInsert->mask&LVIF_SHOWSCROLL)					// Einfgeposition muss sichtbar bleiben
		{
		if(FastListEnsureVisible(pData,uPos,0))
			{
			return uPos;
			}
		}


	if(uPos<pData->uScrollY+pData->uMaxEnties)
		{
		UpdateRows(pData,uPos,pData->uMaxEnties);
		}


	UpdateScrollY(pData,FALSE);



return uPos;
}

//*****************************************************************************
//*
//*		FastListSetItem
//*
//*****************************************************************************
//	ndert einen Eintrag im Fenster
//	pData		: Zeiger auf die Fensterdaten
//	pItem		: Zeiger auf die ein zu ndernden Daten
//	Ergibt 1 wenn ok oder 0 bei einem Fehler
static int FastListSetItem(FastListData *pData,const LV_ITEM *pItem)
{
NMLISTVIEW		sNotify;
BaseItem	   *pEntry;
unsigned		uChange;
unsigned		uMask;
unsigned		uBits;
unsigned		uItem;
unsigned		uOld;
unsigned		uSet;
unsigned		uNew;
int				iRet;


	uChange = 0;


	   uItem = pItem->iItem;
	if(uItem>=pData->uListItemsCount)return 0;

	pEntry	 = pData->pListItems+uItem;
	uBits	 = pItem->mask;


	if(uBits&LVIF_PARAM)									// Eintragsdaten ndern
		{
		pEntry->lParam	= pItem->lParam;
		}


	if(uBits&LVIF_STATE)									// Den Status ndern
		{
		uSet  = pItem->state;
		uMask = pItem->stateMask;
		uOld  = pEntry->uState;
		uBits = uMask&(uOld^uSet);


		if(uBits&LVIS_FOCUSED)
			{
			pEntry->uState ^= LVIS_FOCUSED;

			if(!(uSet&LVIS_FOCUSED) || pData->uFocusItem!=0xFFFFFFFF)
				{
				FastListRemoveFocus(pData);					// Alten Focus lschen
				}

			if(uSet&LVIS_FOCUSED)
				{
				if(!(pData->uStyleEx&LVS_EX_SUBSELECT))
					{
					pData->uFocusSub = 0;
					}

				pData->uFocusItem    = uItem;
				pEntry->bFlags		|= LVIX_FOCUSED;

				FastListEnsureVisible(pData,uItem,pData->uFocusSub|0x80000000,SB_SETPOSITION);

				if(!((pEntry->uState^uBits)&LVIS_SELECTED))	// Eintrag auch selektieren
					{
					uBits ^= LVIS_SELECTED;
					uMask |= LVIS_SELECTED;
					uSet  |= LVIS_SELECTED;
					}
				}

			uChange=1;
			}

		if(uBits&~LVIS_SELECTED)							// Gibt es nderungen auer LVIS_SELECTED
			{
			uNew  = uOld^(uBits&~LVIS_SELECTED);

			if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
				{
				sNotify.hdr.code	= LVN_ITEMCHANGING;
				sNotify.iItem		= uItem;
				sNotify.iSubItem	= pData->uSelectedSub;
				sNotify.uNewState	= uNew;
				sNotify.uOldState	= uOld;
				sNotify.uChanged	= uOld^uNew;
				sNotify.lParam		= pEntry->lParam;
				sNotify.ptAction.x	= 0;
				sNotify.ptAction.y	= 0;

				UNLOCK(pData);
				iRet = U(SendNotify(pData,&sNotify.hdr));
				LOCK(pData);

				if(iRet)return 0;
				}

			pEntry->uState &= ~(uMask&~LVIS_SELECTED);		// Statusbits ndern (ohne LVIS_SELECTED)
			pEntry->uState |=  (uMask&~LVIS_SELECTED)&uSet;


			if(!(pData->uStyleEx&LVS_EX_NOCHANGENOTIFY))
				{
				sNotify.hdr.code	= LVN_ITEMCHANGED;

				UNLOCK(pData);
				iRet = U(SendNotify(pData,&sNotify.hdr));
				LOCK(pData);
				}
			}

		if((uBits&(LVIS_OVERLAYMASK|LVIS_CUT)) && pData->hImages)
			{
			uChange=1;
			}

		if((uBits&LVIS_STATEIMAGEMASK) && pData->hStates)
			{
			uChange=1;
			}

		if(uBits&(LVIS_BOLD|LVIS_UNTERLINE|LVIS_DROPHILITED))
			{
			uChange=1;
			}

		if(uBits&LVIS_SELECTED)
			{
			if(uSet&LVIS_SELECTED)
				{
				iRet = FastListSelectItem(pData,uItem,0,0);
				}

			uChange=1;
			}
		}

	if(uChange)												// Neuzeichnen des Eintrages
		{
		UpdateRows(pData,uItem,1);
		}



return 1;
}


//*****************************************************************************
//*
//*		FastListGetItem
//*
//*****************************************************************************
//	Daten von einem Eintrag abfragen
//	pData		: Zeiger auf die Fensterdaten
//	pItem		: Zeiger auf die den Datenspeicher
//	Ergibt 1 wenn ok oder 0 bei einem Fehler
static unsigned FastListGetItem(FastListData *pData,LV_ITEM *pItem)
{
BaseItem	   *pEntry;
FL_ENTRY		sData;
unsigned		uBits;
unsigned		uItem;




	   uItem = pItem->iItem;
	if(uItem>=pData->uListItemsCount)return 0;

	pEntry   = pData->pListItems+uItem;
	uBits    = pItem->mask;

	if(uBits&LVIF_PARAM)
		{
		pItem->lParam = pEntry->lParam;
		}

	if(uBits&LVIF_STATE)
		{
		pItem->state  = pEntry->uState;
		pItem->state &= pItem->stateMask;
		}

	if(uBits&(LVIF_TEXT|LVIF_IMAGE) || ((uBits&LVIF_STATE) && (pItem->stateMask&(LVIS_BOLD|LVIS_UNTERLINE))))
		{
		GetDataEntry(pData,uItem,pItem->iSubItem,&sData,pEntry->uState);

		if(uBits&LVIF_TEXT)
			{
			if(uBits&LVIF_TEXTPTR)
				{
				pItem->pszText		= sData.pText;
				pItem->cchTextMax	= sData.iSize;
				}
			else if(pItem->cchTextMax>0)
				{
				str_ncpy(pItem->pszText,sData.pText,pItem->cchTextMax);
				pItem->pszText[pItem->cchTextMax-1] = 0;
				}
			}

		pItem->iImage		= sData.iImage;
		pItem->state	   |= sData.uState&pItem->stateMask;
		}


return 1;
}

//*****************************************************************************
//*
//*		FastListLockUnlock
//*
//*****************************************************************************
//	Callback zum Sperren und Entsprerren des Controlls.
//	pParam		: Zeiger auf die Fensterdaten
//	uItem		: Ist der Eintrag ab dem es nderungen gab.
//				  Bit 31 wird frs Sperren gesetzt.
//	iCount		: Anzahl der Eintrge die gndert wurden.
//	uAction		: Ist die Art der nderung
//					0				= Nichts
//					1 				= Einfgen
//					2 				= Lschen
//					3 				= Sortieren
//					4 				= Gendert
//					5 				= Copy
//					LVIF_LOCKING	= LOCK ausfhren
//					LVIF_NONOTIFY	= Keine Notify Nachrichten senden
//					LVIF_SHOWSCROLL	= Eingefgter Eintrag muss sichtbar bleiben
//					LVIF_ENDSCROLL	= Immer zum Ende scrollen wenn es sichtbar ist
//					LVIF_FAST		= Verzgert ber Timer die Anzeige aktualisieren
//	Ergibt 1 wenn die Aktion erfolgreich war.
static int CALLBACK FastListLockUnlock(LPVOID pParam,LPARAM lParam,INT iCount,UINT uAction)
{
FastListData   *pData=(FastListData*)pParam;
BaseItem	   *pEntry;
LPBYTE		   *pField;
LPBYTE		    pPoint;
LPDWORD		    pState;
LV_ITEM			sItem;
unsigned		uState;
unsigned		uItem;
char 			cOld;
int				iMax;
int				iEnd;
int				iPos;



	pField	= *pData->pFieldPointer;
	iMax	= (pData->pFieldCounter)? *pData->pFieldCounter:pData->uListItemsCount;
	cOld	=  pData->cUpdateFlag;
	uItem	=  U(lParam);


	pData->cUpdateFlag = 1;


	if(uAction&LVIF_LOCKING)								// Sperren
		{
		LOCK(pData);

		switch(uAction&0xFF)
			{
		case 2:												// Lschen

			if(iCount<=0)break;
			if(uItem>=pData->uListItemsCount)break;

			FastListDeleteItems(pData,uItem,iCount);

			break;

		case 3:												// Vor Sortieren

			if(iCount<=0 || uItem>=pData->uListItemsCount)break;

			iEnd = uItem+iCount;

			if(iEnd>iMax)iEnd=iMax;

			pEntry = pData->pListItems+uItem;

			for(iPos=uItem;iPos<iEnd;iPos++,pEntry++)		// Zustand zwischen speichern
				{
				pPoint			= pField[iPos]+pData->iFieldSortMem;
				pState			= (LPDWORD)(&pEntry->uState);
				uState			= pState[0];
				*(UINT*)pPoint	= uState&~(LVIX_FIRSTSEL<<16);

				if(U(iPos)==pData->uSelectedItem)
				if(uState&LVNI_SELECTED)
					{
					*(UINT*)pPoint |= (LVIX_FIRSTSEL<<16);
					}
				}

		case 5:												// Nur Flags kopieren

			if(iCount<=0 || uItem>=pData->uListItemsCount)break;

			iEnd = uItem+iCount;

			if(iEnd>iMax)iEnd=iMax;

			pEntry = pData->pListItems+uItem;

			for(iPos=uItem;iPos<iEnd;iPos++,pEntry++)		// Zustand zwischen speichern
				{
				pPoint			= pField[iPos]+pData->iFieldSortMem;
				pState			= (LPDWORD)(&pEntry->uState);
				uState			= pState[0];
				*(UINT*)pPoint	= uState;
				}

			break;
			}

		pData->cUpdateFlag = cOld;
		}
	else{
		switch(uAction&0xFF)
			{
		case 1:												// Einfgen

			if(iCount<=0)break;

			iEnd = uItem+iCount;

			if(iEnd>iMax)iEnd=iMax;

			sItem.mask	 = LVIF_PARAM;
			sItem.mask	|= uAction&(LVIF_SHOWSCROLL|LVIF_ENDSCROLL|LVIF_FAST);


			for(iPos=uItem;iPos<iEnd;iPos++)				// Eintrge einfgen
				{
				pPoint		 = pField[iPos]+pData->iFieldOffset;
				sItem.iItem	 = iPos;
				sItem.lParam = (LPARAM)pPoint;
				FastListInsertItem(pData,&sItem);
				}

			iCount = 0x7FFFFFFF;
			break;

		case 2:												// Lschen

			iCount = 0x7FFFFFFF;
			break;

		case 3:												// Nach Sortieren

			if(iCount<=0 || uItem>=pData->uListItemsCount)break;

			iEnd = uItem+iCount;

			if(iEnd>iMax)iEnd=iMax;

			for(iPos=uItem;iPos<iEnd;iPos++)				// Zustand wieder herstellen
				{
				pPoint			= pField[iPos];
				pEntry			= pData->pListItems+iPos;
				pEntry->lParam	= (LPARAM)(pPoint+pData->iFieldOffset);
				pPoint		   += pData->iFieldSortMem;
				pState			= (LPDWORD)&pEntry->uState;
				uState			= *(UINT*)pPoint;
				pState[0]		= uState&~(LVIX_FIRSTSEL<<16);

				if(uState&(LVIX_FIRSTSEL<<16))
					{
					pData->uSelectedItem = iPos;
					}

				if(uState&(LVIX_FOCUSED<<16))
					{
					pData->uSelectedItem = iPos;
					}
				}

			break;

		case 4:												// Eintrag wurde verndert

			if(iCount<=0 || uItem>=pData->uListItemsCount)break;

			iEnd = uItem+iCount;

			if(iEnd>iMax)iEnd=iMax;

			pEntry = pData->pListItems+uItem;

			for(iPos=uItem;iPos<iEnd;iPos++,pEntry++)		// Callback-Paramerer aktualisieren
				{
				pPoint			= pField[iPos]+pData->iFieldOffset;
				pEntry->lParam	= (LPARAM)pPoint;
				}

			break;
			}

		if(iCount>0)										// Neu zeichnen
			{
			UpdateRows(pData,uItem,iCount);
			}

		pData->cUpdateFlag = cOld;

		UpdateStart(pData);

		UNLOCK(pData);
		}


return 1;
}

//*****************************************************************************
//*
//*		FastListSetDataField
//*
//*****************************************************************************
//	Stellet ein automatische Datenfeld ein
//	pData		: Zeiger auf die Fensterdaten
//	pInfo		: Zeiger auf die Datenfeldinfos
//	Ergibt 1 wenn etwas verndert wurde, bzw. 0 wenn nicht
static int FastListSetDataField(FastListData *pData,LV_DATAFIELD *pInfo)
{

	pInfo->pParam			= pData;
	pInfo->pLockCb			= FastListLockUnlock;
	pData->pFieldPointer	= (LPBYTE**)pInfo->pField;
	pData->pFieldCounter	=			pInfo->pCount;
	pData->iFieldOffset		=			pInfo->iOffset;
	pData->iFieldSortMem	=			pInfo->iSortMem;


return 1;
}

//*****************************************************************************
//*
//*		FastListDeleteColumn
//*
//*****************************************************************************
//	Lscht eine Spalte aus dem Header
//	pData		: Zeiger auf die Fensterdaten
//	uCol		: Ist die Nummer der Spalte die gelscht werden soll
//	Ergibt 1 wenn die Spalte gelscht wurde
static int FastListDeleteColumn(FastListData *pData,unsigned uCol)
{
RECT		sRect;
BYTE		bItem;
BYTE		bByte;
BaseItem   *pEntry;
unsigned	uPos;
unsigned	uSub;
unsigned	uIndex;
int			iDelta;
int			iXoff;
int			iNum;
int			iCnt;
int			iVar;
int			iSub;
int			iAll;
int			iFix;


	if(uCol>=pData->uColumnCount)return 0;

	if(uCol && uCol==pData->uSelectedSub)					// Ist die Auswahl in der Spalte
		{
		FastListSelectItem(pData,pData->uSelectedItem,0,0);
		}

	if(uCol && uCol==pData->uEditSub)
		{
		pData->uEditItem = 0xFFFFFFFF;
		pData->uEditSub  = 0x00000000;
		FastListEndLabelEdit(pData,0);
		}

	if(uCol && uCol==pData->uFocusSub)
		{
		if(pData->uFocusItem<pData->uListItemsCount)
			{
			pEntry			= pData->pListItems+pData->uFocusItem;
			pEntry->bFlags &= LVIX_FOCUSED;
			pEntry->uState &= LVIS_FOCUSED;
			UpdateRows(pData,pData->uFocusItem);
			}

		pData->uFocusItem	= 0xFFFFFFFF;
		pData->uFocusSub	= 0x00000000;
		}

	if(uCol==pData->uTrackedSub)
		{
		if(pData->uFocusItem<pData->uListItemsCount)
			{
			pEntry			= pData->pListItems+pData->uFocusItem;
			pEntry->bFlags &= LVIX_TRACKED;
			pEntry->uState &= LVIS_TRACKED;
			UpdateRows(pData,pData->uTrackedItem);
			}

		pData->uTrackedItem = 0xFFFFFFFF;
		pData->uTrackedSub  = 0x00000000;
		}



	GetClientRect(pData->hWnd,&sRect);


	iDelta	= pData->aColumn[uCol].sSize;
	iSub	= pData->aColumn[uCol].bWeight;
	iCnt	= 0;
	iVar	= 0;
	iFix	= 0;
	iAll	= 0;

	for(uPos=0;uPos<pData->uColumnCount;uPos++)				// Zhlern der variablen Spalten
		{
		if(uPos==uCol)continue;
		if(pData->aColumn[uPos].bWeight==0)
			{
			iFix +=	pData->aColumn[uPos].sSize;
			continue;
			}

		iVar +=	pData->aColumn[uPos].sSize;
		iAll += pData->aColumn[uPos].bWeight;
		iCnt += 1;
		}


	Header_DeleteItem(pData->hHeader,uCol);
	pData->uColumnCount--;

	if(pData->uColumnCount>0)								// Liste mit Extraeintrgen lschen
		{
		   iNum=uCol-1;
		if(iNum<0)iNum=0;
		}
	else{
		iNum=FL_MAX_COLUMNS;
		}

	if(pData->aColumn[uCol].bWeight)
		{
		pData->uColumnCountVar--;
		}

	if(pData->aColumn[uCol].bMark)
		{
		pData->uMarkedCols--;
		}

	uSub = pData->aColumnPos[uCol];

	memmove(pData->aColumn+uCol,pData->aColumn+uCol+1,(FL_MAX_COLUMNS-1-uCol)*sizeof(ColumnData));


															// Zuordnungs-Array anpassen
	for(uIndex=0,uPos=0;uIndex<=pData->uColumnCount+2;uIndex++)	
		{
		   bItem = pData->aColumnPos[uIndex];
		if(bItem==uCol)continue;
		if(bItem>uCol )bItem--;

		pData->aColumnPos[uPos] = bItem;
		uPos++;
		}

	for(uIndex=pData->uColumnCount;uIndex>0;)
		{
		uIndex--;
		bByte = pData->aColumn[uIndex].bIndex;

		if(bByte>=uSub)
			{
			bByte--;
			pData->aColumn[uIndex].bIndex = bByte;
			}

		pData->aColumn[uIndex].bNext = pData->aColumnPos[bByte+1];
		}

	pData->iFixSize   = iFix;
	pData->aColumn[pData->uColumnCount].bWeight=0;


	if(iCnt && iDelta)										// Variable Breiten anpassen
		{
		ChangeColSize(pData,iDelta);
		}
	else{
		if(iSub && !iCnt)
			{
			pData->iVarSize = 0;
			}
		}

	if(pData->uSelectedSub>uCol)							// Ist die Auswahl vor der Spalte
		{
		pData->uSelectedSub--;
		}

	if(pData->uEditSub>uCol)
		{
		pData->uEditSub--;
		}

	if(pData->uFocusSub>uCol)
		{
		pData->uFocusSub--;
		}

	if(pData->uTrackedSub>uCol)
		{
		pData->uTrackedSub--;
		}


	if(!pData->uColumnCount)								// Den Header lschen
		{
		DestroyWindow(pData->hHeader);
		pData->hHeader	   = NULL;
		pData->uStartPixel = 0;
		pData->iRowHeight  = 1;
		UpdateHeight  (pData);
		InvalidateRect(pData->hWnd,&sRect,FALSE);
		}


	   iXoff=UpdateColumns(pData);							// Hat sich die Spaltenbreiten verndert
	if(iXoff<0x10000)
		{
		sRect.left  = iXoff;
		sRect.left -= pData->uScrollX;
		sRect.top   = pData->uStartPixel;
		InvalidateRect(pData->hWnd,&sRect,FALSE);
		}


	UpdateScrollX(pData);




return 1;
}


//*****************************************************************************
//*
//*		FastListInsertColumn
//*
//*****************************************************************************
//	Fgt eine neue Spalte in den Header ein
//	pData		: Zeiger auf die Fensterdaten
//	uCol		: Ist die Nummer der Spalte die eingefgt wird
//	pInsert		: Zeiger auf die ein zu fgenden Daten
//	Ergibt die Einfgeposition der neuen Spalte bzw. -1 bei einem Fehler
static int FastListInsertColumn(FastListData *pData,unsigned uCol,LV_COLUMN *pColumn)
{
LV_COLSIZE	sNotify;
HDITEM	 	sItem;
RECT		sRect;
short 		sFixed;
UINT		uIndex;
BYTE		bByte;
BYTE		bItem;
BYTE		bMark;
BYTE		bMinEx;
BYTE		bAlign;
int			iWeight;
int			iDelta;
int			iSize;
int			iXoff;
int			iYoff;
int			iVar;
int			iAll;
int			iAdd;
int			iMin;
int			iFix;



	GetClientRect(pData->hWnd,&sRect);


	if(!pData->hHeader)										// Einen neuen Header erzeugen
		{
		iYoff = sRect.top+GetSystemMetrics(SM_CYHSCROLL);

		if(pData->uStyle&LVS_NOCOLUMNHEADER)
			{
			iYoff=0;
			}

			pData->hHeader=CreateWindow(WC_HEADER,NULL,WS_VISIBLE|WS_CHILD|HDS_HORZ|HDS_BUTTONS|HDS_DRAGDROP,sRect.left,sRect.top,sRect.right,iYoff,pData->hWnd,(HMENU)1,NULL,NULL);
		if(!pData->hHeader)return -1;

		pData->uStartPixel	= (pData->uStyle&LVS_NOCOLUMNHEADER)? 0:GetSystemMetrics(SM_CYHSCROLL);
		pData->uStartPixel +=  pData->uStartOffset;
		pData->iRowHeight	=  1;
		UpdateHeight(pData);


		InvalidateRect(pData->hWnd,&sRect,FALSE);
		SendMessage   (pData->hHeader,HDM_SETIMAGELIST,0,(LPARAM)((pData->hHdrImg)? pData->hHdrImg:pData->hImages));
		SendMessage   (pData->hHeader,WM_SETFONT,(WPARAM)hDefaultFontN,0);

		if(pData->uSizeX<=pData->uStartPixel)
				pData->uSizeYsub = 0;
		else	pData->uSizeYsub = pData->uSizeX-pData->uStartPixel;
		}


	if(pData->uColumnCount>=FL_MAX_COLUMNS)					// Prfe die Anzahl der Spalten
		{
		return -1;
		}


	memset(&sItem,0,sizeof(sItem));							// Die Spaltendaten zusammenstellen

	if(uCol>=pData->uColumnCount)
		{
		uCol = pData->uColumnCount;
		}

	if(pColumn->mask&LVCF_FMT)								// Welche Textausrichtung
		{
		sItem.mask    |= HDI_FORMAT;
		sItem.fmt      = pColumn->fmt;

		switch(sItem.fmt&HDF_JUSTIFYMASK)
			{
		case HDF_CENTER: bAlign = DT_CENTER;	break;
		case HDF_RIGHT:	 bAlign = DT_RIGHT;		break;
		default: 		 bAlign = DT_LEFT;		break;
			}
		}
	else{
		bAlign = DT_LEFT;
		}

	if(pColumn->mask&LVCF_IMAGE)							// Hat die Spalte auch ein Icon
		{
		sItem.mask    |=  HDI_IMAGE;
		sItem.iImage   =  pColumn->iImage;
		}

	if(pColumn->mask&LVCF_TEXT)								// Auch einen Text bergeben
		{
		sItem.mask    |=  HDI_TEXT;
		sItem.pszText  =  pColumn->pszText;
		}

	if(pColumn->mask&LVCF_MIN)								// Auch einen Min-Wert bergeben
		{
		iMin		   =  pColumn->iOrder;
		bMinEx		   =  1;

		if(iMin<0)
			{
			iMin	   = -iMin;
			bMinEx	   =  0;
			}
		}
	else{
		iMin		   =  16;
		bMinEx		   =  0;
		}

	if(pColumn->mask&LVCF_WIDTH)							// Fixe Breite fr die Spalte
		{
		iWeight		   =  0;
		sItem.mask    |=  HDI_WIDTH;
		sItem.cxy	   =  pColumn->cx;
		iSize		   =  pColumn->cx;
		iDelta		   = -pColumn->cx;
		iAdd		   =  0;
		}
	else{													// Variable vordefinierte Breite
		if(pColumn->mask&LVCF_VWIDTH)
			   iWeight =  pColumn->cx;
		else   iWeight =  1;

		iVar  = pData->iVarSize;
		iFix  = pData->iFixSize;
		iSize = pData->uSizeX-iVar-iFix;

		if(iWeight<= 0)iWeight=1;
		if(iWeight>255)iWeight=255;


		if(pData->uColumnCountVar)							// Gibt es schon variable Spalten
			{
			for(uIndex=0,iAll=0;uIndex<pData->uColumnCount;uIndex++)
				{
				if(pData->aColumn[uIndex].sFixed)continue;
				iAll += pData->aColumn[uIndex].bWeight;
				}

			iSize  = (iVar*iWeight)/(iAll+iWeight);
			iDelta = -iSize;
			}
		else{
			iDelta = 0;
			}

		sItem.mask    |= HDI_WIDTH;
		sItem.cxy      = iSize;
		iAdd		   = 1;

		if(sItem.cxy<iMin)sItem.cxy=iMin;
		}



	   uCol = Header_InsertItem(pData->hHeader,uCol,&sItem);
	if(uCol&0x80000000)return -1;


	memmove(pData->aColumn+uCol+1,pData->aColumn+uCol,(FL_MAX_COLUMNS-1-uCol)*sizeof(ColumnData));

	for(uIndex=pData->uColumnCount+2;uIndex>uCol;uIndex--)	// Zuordnungs-Array anpassen
		{
		   bItem = pData->aColumnPos[uIndex-1];
		if(bItem>=uCol)bItem++;

		pData->aColumnPos[uIndex] = bItem;
		}

	pData->aColumnPos[uCol] = (BYTE)uCol;

	while(uIndex>0)
		{
		uIndex--;

		   bItem=pData->aColumnPos[uIndex];
		if(bItem<uCol)continue;

		bItem++;
		pData->aColumnPos[uIndex] = bItem;
		}

	for(uIndex=pData->uColumnCount;;)
		{
		bByte = pData->aColumn[uIndex].bIndex;

		if(bByte>=uCol)
			{
			bByte++;
			pData->aColumn[uIndex].bIndex = bByte;
			}

		if(uIndex==0)break;
		uIndex--;
		}


	bMark  = 0;
	sFixed = 0;

	if(pColumn->mask&LVCF_MARK  )							// Ist die Spalte markiert
	if(pColumn->fmt &LVCFMT_MARK)
		{
		bMark = 1;
		}

	if(pColumn->mask&LVCF_FIXED  )							// Ist die Spalte fixiert
	if(pColumn->fmt &LVCFMT_FIXED)
		{
		sFixed = (short)((sItem.cxy>0)? sItem.cxy:100);
		}

	pData->aColumn[uCol].bWeight = (BYTE)iWeight;
	pData->aColumn[uCol].sReal   = (short)sItem.cxy;
	pData->aColumn[uCol].sSize   = (short)iSize;
	pData->aColumn[uCol].sMin    = (short)iMin;
	pData->aColumn[uCol].bIndex  = (BYTE)uCol;
	pData->aColumn[uCol].bMinEx  =  bMinEx;
	pData->aColumn[uCol].bAlign  =  bAlign;
	pData->aColumn[uCol].bMark   =  bMark;
	pData->aColumn[uCol].sFixed  =  sFixed;
	pData->uMarkedCols			+= 	bMark;


	for(uIndex=pData->uColumnCount;;)						// Nchste sichtbare Spalten aktualisieren
		{
		bByte						 = pData->aColumn[uIndex].bIndex;
		pData->aColumn[uIndex].bNext = pData->aColumnPos[bByte+1];
		if(uIndex==0)break;
		uIndex--;
		}


	if(pData->uColumnCountVar)								// Variable Breiten anpassen
		{
		if(iDelta)
			{
			ChangeColSize(pData,iDelta);
			pData->iVarSize  -= iDelta;
			}
		else if(!iAdd)
			{
			pData->iFixSize  += iSize;
			}
		}
	else{
		if(iAdd)pData->iVarSize  = iSize;
		else    pData->iFixSize += iSize;
		}


	pData->uColumnCountVar      +=  iAdd;
	pData->uColumnCount	        +=  1;


	if(pData->uSelectedSub>0 && pData->uSelectedSub>=uCol)
		{
		pData->uSelectedSub++;
		}

	if(pData->uTrackedSub>0 && pData->uTrackedSub>=uCol)
		{
		pData->uTrackedSub++;
		}

	if(pData->uFocusSub>0 && pData->uFocusSub>=uCol)
		{
		pData->uFocusSub++;
		}

	if(pData->uEditSub>0 && pData->uEditSub>=uCol)
		{
		pData->uEditSub++;
		}



	   iXoff=UpdateColumns(pData);							// Hat sich die Spaltenbreiten verndert
	if(iXoff<0x10000)
		{
		sRect.left  = iXoff;
		sRect.left -= pData->uScrollX;
		sRect.top   = pData->uStartPixel;
		InvalidateRect(pData->hWnd,&sRect,FALSE);
		}


	UpdateScrollX(pData);


	if(pData->uStyleEx&LVS_EX_HEADERCHGNOTIFY)
		{
 		sNotify.hdr.code	= LVN_COLUMNCHANGED;
		sNotify.uColumn		= uCol;
		sNotify.uIndex		= pData->aColumn[uCol].bIndex;
		sNotify.uPosX		= pData->aColumnXpos[uCol];
		sNotify.iSize		= pData->aColumn[uCol].sReal;

		UNLOCK(pData);
		SendNotify(pData,&sNotify.hdr);
		LOCK(pData);
		}



return uCol;
}

//*****************************************************************************
//*
//*		FastListScanColumn
//*
//*****************************************************************************
//	Berechnet die Breite der sichtbaren Eintrge einer Spalte
//	pData		: Zeiger auf die Fensterdaten
//	uSub		: Ist die Spalte
//	uPos		: Erstes Element
//	uStop		: Scannen bis
//	Ergibt sie gescannte Breite
static int FastListScanColumn(FastListData *pData,unsigned uSub,int iStart,int iStop)
{
FL_ENTRY	sData;
BaseItem   *pEntry;
int			iPixels;
unsigned	uStop;
unsigned	uChar;
UINT		uPos;
int			iMax;
int			iPos;



	if(uSub>=pData->uColumnCount)return 0;

	iMax    = 0;
	pEntry  = pData->pListItems;
	uPos	= (iStart<0)? 0:iStart;
	uStop	= (iStop <0)? 0:iStop;

	if(uStop>pData->uListItemsCount)
		{
		uStop = pData->uListItemsCount;
		}


	if(uSub>0)												// Extraspalte
		{
		for(;uPos<uStop;uPos++,pEntry++)
			{
			GetDataEntry(pData,uPos,uSub,&sData,pEntry->uState);
			iPixels = GetTextSize(pData,&sData);

			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
					iPos = pData->iChecksSizeX;
			else if(pData->hSubImg && sData.iImage!=LV_NOIMAGE)
					iPos = pData->iSubImgXsize;
			else	iPos = 0;


			   iPos += iPixels+8;
			if(iPos>iMax)iMax=iPos;
			}

		return iMax;
		}


	for(;uPos<uStop;uPos++,pEntry++)						// Erste Spalte
		{
		GetDataEntry(pData,uPos,uSub,&sData,pEntry->uState);
		iPixels = 0;

		while(sData.iSize>0)								// Spezialzeichen auslassen
			{
			   uChar = sData.pText[0];
			if(uChar>=SPECIAL_MAX)break;

			iPixels += SPECIAL_WIDTH;
			sData.pText++;
			sData.iSize--;
			}

		iPixels += GetTextSize(pData,&sData);

		if(sData.iImage!=LV_NOIMAGE)
				iPos = pData->iImagesSizeX+1;
		else	iPos = 0;


		   iPos += iPixels+8;
		if(iPos>iMax)iMax=iPos;
		}

	if(pData->uStyleEx&LVS_EX_GRIDLINES)					// Gibt es einen Rahmen
		{
		iMax += 1;
		}

	if(pData->hStates)										// Sind Checkboxen aktiv
		{
		iMax += pData->iStatesSizeX;
		}



return iMax;
}


//*****************************************************************************
//*
//*		FastListHitTest
//*
//*****************************************************************************
//	Prft wo eine Koordinate im Fenster ist
//	pData		: Zeiger auf die Fensterdaten
//	pInfo		: Zeiger auf die ein zu fgenden Daten
//	Ergibt das Item auf dem die Koordinate zeigt oder 0xFFFFFFFF wenn nicht.
static int FastListHitTest(FastListData *pData,LV_HITTESTINFO *pInfo)
{
BaseItem   *pEntry;
unsigned	uItem;
unsigned	uNext;
unsigned	uEndY;
unsigned	uSub;
unsigned	uCol;
FL_ENTRY	sData;
int			iPixels;
int			iWidth;
int			iPosX;
int			iPosY;
int			iPosZ;
int			iIcon;
int			iNum;



	iPosX = pInfo->pt.x;
	iPosY = pInfo->pt.y;

	if((unsigned)iPosX>=pData->uSizeX)						// X-Koordinate auserhalb vom Fenster
		{
		pInfo->iItem	= -1;
		pInfo->iSubItem	=  0;
		pInfo->flags	= (iPosX<0)? LVHT_TOLEFT:LVHT_TORIGHT;
		return -1;
		}

	uEndY  = pData->uSizeY;
	uEndY -= pData->uStartPixel;
	iPosY -= pData->uStartPixel;

	if((unsigned)iPosY>=uEndY)								// Y-Koordinate auserhalb vom Fenster
		{
		pInfo->iItem	= -1;
		pInfo->iSubItem	=  0;
		pInfo->flags	= (iPosY<0)? LVHT_ABOVE:LVHT_BELOW;
		return -1;
		}


	iPosZ  = iPosY/pData->iRowHeight;
	iPosZ +=       pData->uScrollY;

	if((unsigned)iPosZ>=pData->uListItemsCount)				// Auf keinem Eintrag
		{
		pInfo->iItem	= -1;
		pInfo->iSubItem	=  0;
		pInfo->flags	= LVHT_NOWHERE;
		return -1;
		}

	iPosX		+= pData->uScrollX;
	pInfo->iItem = iPosZ;
	uItem		 = iPosZ;
															// Sind wir im linke Draw-Bereich
	if(iPosX<(int)pData->uDrawCbSize && pData->pDrawCallback)
		{
		pInfo->iSubItem = 0;
		pInfo->flags	= LVHT_ONLEFTAREA;

		return uItem;
		}

	pEntry		 = pData->pListItems+uItem;
	uNext		 = pData->aColumn[0].bNext;

															// Auf Extraeintrag
	if(iPosX>=pData->aColumnXpos[uNext] || iPosX<pData->aColumnXpos[0])
		{
		for(uCol=0;uCol<pData->uColumnCount;uCol++)
			{
			uSub  = pData->aColumnPos[uCol  ];
			uNext = pData->aColumnPos[uCol+1];

			if(uSub==0)continue;							// Den Haupteintrag ignorieren

			if(iPosX>=pData->aColumnXpos[uNext])continue;
			   iPosX-=pData->aColumnXpos[uSub ];

			GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);
			iPixels = GetTextSize(pData,&sData);


			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				iIcon = pData->iChecksSizeX;
				}											// Hat der Extraeintrag ein Icon
			else if(sData.iImage!=LV_NOIMAGE && pData->hSubImg)
				{
				iIcon = pData->iSubImgXsize;
				}
			else{
				iIcon = 0;
				}

			pInfo->iSubItem = uSub;
			pInfo->flags    = uSub<<24;

			if(iPosX<iIcon)									// Auf Icon
				{
				pInfo->flags |= LVHT_ONSUBICON;
				return uItem;
				}

			if(!sData.iSize)								// Auf Text wenn leerer Eintrag
				{
				pInfo->flags |= LVHT_ONSUBLABEL;

				if(pData->aColumn[uSub].bAlign==DT_RIGHT)	// AUf den ersten 20-Pixel des Leerteils
					{
					iWidth  = pData->aColumnXpos[uNext];
					iWidth -= pData->aColumnXpos[uSub ];
					if(iPosX>=iWidth-20)pInfo->flags|=LVHT_ONSUBBASE;
					}
				else{
					if(iPosX-iIcon  <20)pInfo->flags|=LVHT_ONSUBBASE;
					}

				return uItem;
				}


			switch(pData->aColumn[uSub].bAlign)				// Textausrichtung
				{
			default:		if(iPosX-iIcon<iPixels+5)
								{
								pInfo->flags |= LVHT_ONSUBLABEL;
								return uItem;
								}
							break;

			case DT_RIGHT:	iWidth  = pData->aColumnXpos[uNext];
							iWidth -= pData->aColumnXpos[uSub ];

							if(iPosX>=iWidth-iPixels-5)
								{
								pInfo->flags |= LVHT_ONSUBLABEL;
								return uItem;
								}
							break;

			case DT_CENTER:	iWidth  = pData->aColumnXpos[uNext];
							iWidth -= pData->aColumnXpos[uSub ];
							iWidth += iIcon;
							iWidth /= 2;

							if(iPosX>=iWidth-iPixels/2-3)
							if(iPosX<=iWidth+iPixels/2+3)
								{
								pInfo->flags |= LVHT_ONSUBLABEL;
								return uItem;
								}
							break;
				}

			pInfo->flags |= LVHT_ONSUBRIGHT;
			return uItem;
			}


		pInfo->flags	= LVHT_ONRIGHTSPACE;
		pInfo->iSubItem	= 0;

		return uItem;
		}


	GetDataEntry(pData,uItem,0,&sData,pEntry->uState);

 	iPosX -= pData->aColumnXpos[0];


	if(pEntry->bStart)										// Gibt es Spezialzeichen am Anfang
		{
		iNum = pEntry->bStart*SPECIAL_WIDTH;

		if(pData->uDrawCbSize && pData->pDrawCallback)
			{
			iNum += pData->uDrawCbSize;
			}

		if(iPosX<iNum)
			{
			iPosX        /= SPECIAL_WIDTH;
			pInfo->flags  = LVHT_ONSPECIAL;
			pInfo->flags |= (iPosX&0x0F)<<13;
			pInfo->flags |= (sData.pText[iPosX]&0x1F)<<8;
			return uItem;
			}

		sData.pText += pEntry->bStart;
		sData.iSize -= pEntry->bStart;
		iPosX       -= iNum;

		if((pData->uStyleEx&LVS_EX_GRIDLINES) && !pData->aColumn[0].bIndex)
			{
			iPosX--;
			}
		}


	iPixels		    = GetTextSize(pData,&sData);
	pInfo->iSubItem	= 0;


	if(pData->uStyleEx&LVS_EX_GRIDLINES)
		{
		iPosX--;
		}

	if(pData->hStates)										// Auf der Auswahl-Box
		{
		iPosX -= pData->iStatesSizeX;

		if(iPosX<0)
			{
			pInfo->flags = LVHT_ONITEMSTATEICON;
			return uItem;
			}
		}


	if(sData.iImage!=LV_NOIMAGE)							// Auf dem Icon
	if(pData->hImages)
		{
		iPosX -= pData->iImagesSizeX+1;

		if(pData->uStyleEx&LVS_EX_GRIDLINES)iPosX--;

		if(iPosX<0)
			{
			pInfo->flags = LVHT_ONITEMICON;
			return uItem;
			}
		}

	if(iPosX<iPixels+5)										// Auf Text
		{
		pInfo->flags = LVHT_ONITEMLABEL|LVHT_ONITEMBASE;
		}
	else if(!sData.iSize)									// Leertext
		{
		pInfo->flags = (iPosX<20)? LVHT_ONITEMLABEL|LVHT_ONITEMBASE:LVHT_ONITEMLABEL;
		}
	else{
		pInfo->flags = LVHT_ONITEMRIGHT;
		}



return uItem;
}

//*****************************************************************************
//*
//*		FastListGetItemColor
//*
//*****************************************************************************
//	Holt die Farbe eins Feldes
//	pData	: Zeiger auf die Fensterdaten
//	uItem	: Ist die Nummer des Eintrages
//	uSub	: Ist die Spalte
//	iMode	: 0=Hintergrundfarbe 1=Textfarbe abfragen
//	Ergibt die alte Farbe oder LV_NOCOLOR wenn keine Farbe eingestellt war
static LRESULT FastListGetItemColor(FastListData *pData,unsigned uItem,unsigned uSub,int iMode)
{
FL_ENTRY	sData;
COLORREF	uColor;
BaseItem   *pEntry;



	if(uItem> pData->uListItemsCount)return LV_NOCOLOR;
	if(uSub >=pData->uColumnCount   )return LV_NOCOLOR;

	pEntry = pData->pListItems+uItem;

	GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);

	if(iMode)
			uColor = sData.uTextColor;
	else	uColor = sData.uBkColor;


return (LRESULT)uColor;
}

//*****************************************************************************
//*
//*		FastListSetTrackItem
//*
//*****************************************************************************
//	Setzt das unterstrichene Item
//	pData	: Zeiger auf die Fensterdaten
//	uItem	: Ist die Nummer des Eintrages
//	uSub	: Ist die Spalte
//	Ergibt 1 wenn der Eintrag unterstrichen wurde
static int FastListSetTrackItem(FastListData *pData,unsigned uItem,unsigned uSub)
{
BaseItem	   *pEntry;
TRACKMOUSEEVENT sEvent;
int				iRet=1;


	if(!(pData->uStyleEx&LVS_EX_SUBSELECT))
		{
		uSub  = 0;
		}
	else if(uSub>=pData->uColumnCount)						// Spalte prfen
		{
		uItem = 0xFFFFFFFF;
		uSub  = 0;
		iRet  = 0;
		}

	if(uItem>pData->uListItemsCount)						// Eintrag prfen
		{
		uItem = 0xFFFFFFFF;
		uSub  = 0;
		iRet  = 0;
		}
	else{
		if(uItem==pData->uTrackedItem)
		if(uSub ==pData->uTrackedSub )
			{
			return iRet;
			}
		}

	if(pData->uTrackedItem<pData->uListItemsCount)			// Den alten Eintrag zurcksetzen
		{
		   pEntry = pData->pListItems+pData->uTrackedItem;
		if(pEntry)
			{
			pEntry->bFlags &= ~LVIX_TRACKED;
			UpdateRect(pData,pData->uTrackedItem,pData->uTrackedSub);
			}
		}


	pData->uTrackedSub  = uSub;
	pData->uTrackedItem = uItem;


	if(uItem!=0xFFFFFFFF)									// Den neuen Eintrag setzen
		{
		sEvent.cbSize		= sizeof(TRACKMOUSEEVENT);
		sEvent.dwFlags		= TME_LEAVE;
		sEvent.hwndTrack	= pData->hWnd;

		_TrackMouseEvent(&sEvent);

		pEntry = pData->pListItems+uItem;
		pEntry->bFlags     |= LVIX_TRACKED;
		UpdateRect(pData,uItem,uSub);
		}



return iRet;
}

//*****************************************************************************
//*
//*		FastListGetNextItem
//*
//*****************************************************************************
//	Sucht den nchsten Eintrag
//	pData	: Zeiger auf die Fensterdaten
//	uItem	: Ist die Nummer des Eintrages
//	uFlags	: Bestimmt nach welchem Eintrag gesucht werden soll
//	Ergibt 1 wenn der Eintrag unterstrichen wurde
static int FastListGetNextItem(FastListData *pData,unsigned uItem,unsigned uFlags)
{
BaseItem	   *pEntry;


	switch(uFlags)
		{
	case LVNI_FIRSTVISIBLE:		if(pData->uListItemsCount<=pData->uScrollY)return -1;

								return pData->uScrollY;

	case LVNI_NEXTVISIBLE:		uItem++;
								if(uItem>=pData->uListItemsCount)return -1;
								if(uItem<=pData->uScrollY)return -1;
								if(uItem> pData->uScrollY+pData->uPageEnties)return -1;

								return uItem;

	case LVNI_PREVIOUSVISIBLE:	uItem--;
								if(uItem>=pData->uListItemsCount)return -1;
								if(uItem<=pData->uScrollY)return -1;
								if(uItem> pData->uScrollY+pData->uPageEnties)return -1;

								return uItem;

	case LVNI_LASTVISIBLE:		uItem = pData->uScrollY+pData->uPageEnties;
								if(uItem>=pData->uListItemsCount)return -1;
								if(uItem<=pData->uScrollY)return -1;
								if(uItem> pData->uScrollY+pData->uPageEnties)return -1;

								return uItem;

	case LVNI_ALL:				uItem++;
								if(uItem>=pData->uListItemsCount)return -1;

								return uItem;

	case LVNI_DROPHILITE:		return pData->uTrackedItem;

	case LVNI_DROPHILITESUB:	return pData->uTrackedSub;

	case LVNI_CARET:			return pData->uSelectedItem;

	case LVNI_CARETSUB:			return pData->uSelectedSub;

	case LVNI_FOCUS:			return (pData->uFocusItem!=0xFFFFFFFF)? pData->uFocusItem:pData->uSelectedItem;

	case LVNI_FOCUSSUB:			return (pData->uFocusItem!=0xFFFFFFFF)? pData->uFocusSub:pData->uSelectedSub;
		}



	if(uFlags==LVNI_SELECTED)								// Schnelltest fr First-Selected
		{
		if(pData->uSelectedCount==1 && pData->uSelectedItem!=0xFFFFFFFF)
			{
			if(uItem==0xFFFFFFFF || uItem<pData->uSelectedItem)
				{
				return pData->uSelectedItem;
				}
			else{
				return -1;
				}
			}

		if(pData->uSelectedCount==0)
			{
			return -1;
			}
		}


	if(uFlags&(LVNI_SELECTED|LVNI_CUT|LVNI_DROPHILITED|LVNI_FOCUSED))
		{
		uItem++;

		if(uItem>pData->uListItemsCount)return -1;

		uFlags &= LVNI_SELECTED|LVNI_CUT|LVNI_DROPHILITED|LVNI_FOCUSED;
		pEntry  = pData->pListItems+uItem;

		for(;uItem<pData->uListItemsCount;uItem++,pEntry++)
			{
			if(pEntry->uState&uFlags)return uItem;
			}
		}



return -1;
}


//*****************************************************************************
//*
//*		FastListFindItem
//*
//*****************************************************************************
//	Sucht einen Kindeintrag mit einem bestimmten Text
//	pData	: Zeiger auf die Fensterdaten
//	uItem	: Ist die Nummer des Elterneintrages
//	pFind	: Die Struktur mit den Suchparametern
//	Ergibt die Nummer des Eintrages bzw. -1 wenn nicht gefunden wurde
static int FastListFindItem(FastListData *pData,unsigned uItem,LVFIND *pFind)
{
FL_ENTRY		sData;
BaseItem	   *pEntry;
unsigned		uChkParam;
unsigned		uChkState;
unsigned		uChkText;
unsigned		uChkCase;
unsigned		uTextLen;
unsigned		uChar;
unsigned		uSub;



	if(uItem>pData->uListItemsCount)						// Ist der Eintrag gltig
		{
		return -1;
		}


	uChkParam = pFind->uFlags&LVIF_PARAM;
	uChkState = pFind->uFlags&LVIF_STATE;
	uChkText  = pFind->uFlags&LVIF_TEXT;
	uChkCase  = pFind->uFlags&LVIF_CASE;
	uSub	  = pFind->uColumn;
	uTextLen  = 0;


	if(uChkText)
		{
		uTextLen = str_len(pFind->pText);
		}

	pEntry = pData->pListItems+uItem;

	for(;;uItem++,pEntry++)		// Durchlaufe alle Kinder
		{
		if(uItem>=pData->uListItemsCount)
			{
			return -1;
			}

		pEntry = pData->pListItems+uItem;

		if(uChkParam && pFind->lParam!=pEntry->lParam)		// Vergleiche lParam
			{
			continue;
			}
															// Vergleiche die State-Bits
		if(uChkState && ((pEntry->uState^pFind->uState)&pFind->uStateMask))
			{
			continue;
			}

		if(uChkText==0)break;

		if(uSub>=pData->uColumnCount)continue;

		GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);

		if(uSub==0)
			{
			while(sData.iSize>0)							// Spezialzeichen berspringen
				{
				   uChar = sData.pText[0];
				if(uChar>=SPECIAL_MAX)break;

				sData.pText++;
				sData.iSize--;
				}
			}

		if(uTextLen!=(UINT)sData.iSize)continue;

		if(uChkCase)										// Zwischen Gro/Kleinbuchstaben unterscheiden
			{
			if(!str_icmp(sData.pText,pFind->pText))break;
			}
		else{
			if(!memcmp(sData.pText,pFind->pText,sData.iSize*sizeof(TCHAR)))break;
			}
		}



return uItem;
}

//*****************************************************************************
//*
//*		FastListMouseClick
//*
//*****************************************************************************
//	Soll ein Mausklick ausgefhrt werden. ACHTUNG UNLOCK wird ausgefhrt
//	pData	: Zeiger auf die Fensterdaten
//	uMsg	: Message des Mausklicks
//	wParam	: WPARAM des Mausklicks
//	lParam	: LPARAM des Mausklicks
static void FastListMouseClick(FastListData *pData,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
BaseItem	   *pEntry;
BaseItem	   *pTemp;
LV_HITTESTINFO	sInfo;
FL_ENTRY		sData;
NMLISTVIEW		sNotify;
unsigned		uOldSub;
unsigned		uOldItem;
unsigned		uMaskItem;
unsigned		uMaskSub;
unsigned		uMsgOld;
unsigned		uItem;
unsigned		uLine;
unsigned		uTemp;
unsigned		uStop;
unsigned		uSub;
unsigned		uSel;
unsigned		uPos;
int				iMode;
int				iAdd;



	if(!pData->cIsEnabled)									// Ist das Fenster freigegeben
		{
		return;
		}

	if(!pData->cHasFocus)									// Hat das Fenster den Fokus
		{
		if(GetFocus()!=pData->hWnd)
			{
			UNLOCK(pData);
			SetFocus(pData->hWnd);
			LOCK(pData);

			if(GetFocus()!=pData->hWnd)
				{
				UNLOCK(pData);
				return;
				}
			}
		else{
			pData->cHasFocus = 1;
			}
		}

	sInfo.flags = (UINT) wParam;
	sInfo.pt.x	= GET_X_LPARAM(lParam);
	sInfo.pt.y	= GET_Y_LPARAM(lParam);
	uItem		= FastListHitTest(pData,&sInfo);
	uMsgOld		= uMsg;


	if(uItem!=0xFFFFFFFF)									// Wurde auf einen Eintrag gedrckt
		{
		pEntry = pData->pListItems+uItem;

		if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
			{
			uMaskItem = LVHT_ONITEMICON|LVHT_ONITEMLABEL|LVHT_ONITEMBASE|LVHT_ONITEMSTATEICON|LVHT_ONITEMRIGHT|LVHT_ONLEFTAREA;
			uMaskSub  =	LVHT_ONSUBICON |LVHT_ONSUBLABEL |LVHT_ONSUBBASE |LVHT_ONSUBRIGHT;
			}
		else{
			uMaskItem = LVHT_ONITEMICON|LVHT_ONITEMLABEL|LVHT_ONITEMBASE|LVHT_ONITEMSTATEICON;
			uMaskSub  =	LVHT_ONSUBICON |LVHT_ONSUBLABEL |LVHT_ONSUBBASE;
			}


		if(sInfo.flags&LVHT_ONITEMSTATEICON)				// Checkbox umschalten
			{
			if(pData->uStyleEx&LVS_EX_CHECKBOXES)
			if(uMsg==WM_LBUTTONDOWN || uMsg==WM_LBUTTONDBLCLK)
				{
				LV_ITEM		sItem;
				NMLISTVIEW	sNotify;

				pData->uCheckedDown = 1;

				sItem.iItem			= uItem;
				sItem.mask			= LVIF_STATE;
				sItem.stateMask		= LVIS_STATEIMAGEMASK;

				if(pData->uStyleEx&LVS_EX_BITCHECKBOX)
						sItem.state	= (pEntry->uState^0x1000);
				else	sItem.state	= (pEntry->uState&0x1000)?	0x2000:0x1000;

				FastListSetItem(pData,&sItem);
				GetDataEntry(pData,uItem,0,&sData,pEntry->uState);

				sNotify.hdr.code	= LVN_CBSTATECHANGED;
				sNotify.iItem		= uItem;
				sNotify.iSubItem	= 0;
				sNotify.uNewState	= pEntry->uState;
				sNotify.uOldState	= pEntry->uState;
				sNotify.uChanged	= LVIS_STATEIMAGEMASK;
				sNotify.lParam		= pEntry->lParam;
				sNotify.ptAction.x	= sInfo.pt.x;
				sNotify.ptAction.y	= sInfo.pt.y;

				UNLOCK(pData);
				SendNotify(pData,&sNotify.hdr);
				LOCK(pData);
				}
			}
		else if(sInfo.flags&uMaskItem)						// Eintrag auswhlen
			{
			if(!(pData->uStyleEx&LVS_EX_DISABLEDRAGDROP))
				{
				if(uMsg==WM_LBUTTONDOWN)
					{
					pData->uDragFlags = MK_LBUTTON;
					pData->uDragItem  = uItem;
					pData->uDragSub   = 0;
					}

				if(uMsg==WM_RBUTTONDOWN)
					{
					pData->uDragFlags = MK_RBUTTON;
					pData->uDragItem  = uItem;
					pData->uDragSub   = 0;
					}
				}

			if(pData->uStyleEx&LVS_EX_NORIGHTSELECT)		// Keine Auswahl mit rechter Maustaste
			if(uMsg==WM_RBUTTONDOWN || uMsg==WM_RBUTTONDBLCLK)
				{
				goto End;
				}

			if(!(pData->uStyle&LVS_SINGLESEL))				// Mehrfachauswahl erlaubt
				{
				if(uMsg==WM_RBUTTONDOWN)					// Keine Abwahl wenn mehrer Eintrge aus gewhlt
				if(pData->uSelectedCount>1)
					{
					   pEntry=pData->pListItems+uItem;
					if(pEntry->uState&LVIS_SELECTED)
						{
						goto End;
						}
					}

				if(uMsg==WM_LBUTTONDOWN)					// Spezialsteuerung fr Multiselect bei Darg
				if(!(wParam&(MK_CONTROL|MK_SHIFT)))
				if(pData->uSelectedCount>0)
					{
					   pEntry =   pData->pListItems+uItem;
					if(pEntry && (pEntry->uState&LVIS_SELECTED))
						{
						pData->cClickFlag = 1;
						pData->cClickEdit = 0;
						goto End;
						}
					}

				if(uMsg==WM_LBUTTONUP && pData->cClickFlag)
					{
					wParam &= ~(MK_CONTROL|MK_SHIFT);
					uMsg    =   WM_LBUTTONDOWN;
					}


				if(wParam&MK_SHIFT)							// Bis zum angeklickten Auswhlen
					{
					if(uMsg!=WM_LBUTTONDOWN)
					if(uMsg!=WM_LBUTTONDBLCLK)goto End;

					pData->cClickEdit = 0;

					   uTemp = pData->uSelectedItem;
					if(uTemp>= pData->uListItemsCount)
						{
						   uTemp = pData->uFocusItem;
						if(uTemp>= pData->uListItemsCount || !pData->cReSelect)
							{
							goto End;
							}
						}

					   uLine = uTemp;
					if(uLine>=pData->uListItemsCount)goto End;

					   uStop = uItem;
					if(uStop>=pData->uListItemsCount)goto End;

					if(pData->uSelectedCount<=1)
						{
						pData->uSelectedBase = uTemp;
						}

														// Shift-Select neu auswhlen
					if(pData->cReSelect && pData->uSelectedBase!=0xFFFFFFFF)
						{
						FastListSelectItem   (pData,uItem,0,1);
						FastListEnsureVisible(pData,pData->uSelectedItem,pData->uSelectedSub|0x80000000,SB_SETPOSITION);

						uTemp = pData->uSelectedBase;
						pTemp = pData->pListItems+uTemp;
						uStop = uItem;

						if(uTemp<pData->uListItemsCount)
							{
							if(!(pTemp->uState&LVIS_SELECTED))
								{
								FastListXorSelectItem(pData,uTemp);
								}

							if(uTemp<uStop)
								{
								uStop = uItem;
								}
							else{
								uStop = uTemp;
								uTemp = uItem;
								}

							for(;uTemp<uStop;uTemp++)
								{
								pTemp = pData->pListItems+uTemp;
								if(pTemp->uState&LVIS_SELECTED)continue;
								FastListXorSelectItem(pData,uTemp);
								}
							}


						pData->cReSelect = 0;
						goto End;
						}


					FastListSelectItem(pData,uItem,0,0);

					iAdd = (uLine>uStop)? -1:1;
					uPos =  uLine;

					if(uPos!=uStop)
						{
						if(pData->uSelectedBase<pData->uListItemsCount)
							{
							if(iAdd<0)
								{if(pData->uSelectedBase>uPos && uPos>uStop)uPos--;}
							else{if(pData->uSelectedBase<uPos && uPos<uStop)uPos++;}
							}
						}



					for(;;uPos+=iAdd)						// Eintrge whlen
						{
						pEntry = pData->pListItems+uPos;
						uSel   = pEntry->uState&LVIS_SELECTED;

						if(uPos==uStop)break;

						if(uPos!=pData->uSelectedBase || !uSel)
							{
							FastListXorSelectItem(pData,uPos);
							}
						}


					FastListRemoveFocus(pData);

					pEntry = pData->pListItems+uItem;
					uSub   = sInfo.iSubItem;
					if(!(pData->uStyleEx&LVS_EX_SUBSELECT))uSub=0;

					pData->uFocusSub     = uSub;
					pData->uFocusItem    = uItem;
					pEntry->bFlags		|= LVIX_FOCUSED;
					pEntry->uState      &=~LVIS_FOCUSED;

					UpdateRect(pData,uItem,uSub);

					FastListSelectItem   (pData,uItem,0,0);
					FastListEnsureVisible(pData,pData->uSelectedItem,pData->uSelectedSub|0x80000000,SB_SETPOSITION);

					goto End;
					}


				if(wParam&MK_CONTROL)						// Einzelnen Eintrag umschalten
					{
					pData->uSelectedBase = uItem;
					pData->cReSelect	 = 1;
					pData->cClickEdit    = 0;

					   pEntry = pData->pListItems+uItem;
					if(pEntry && (pEntry->uState&LVIS_SELECTED))
						{
						if(uMsg!=WM_LBUTTONDOWN)
						if(uMsg!=WM_LBUTTONDBLCLK)goto End;

						FastListXorSelectItem(pData,uItem);

						   uTemp=pData->uFocusItem;
						if(uTemp<pData->uListItemsCount)	// Ist ein Focus definiert
							{
							FastListRemoveFocus(pData);
							}

						uSub = sInfo.iSubItem;
						if(!(pData->uStyleEx&LVS_EX_SUBSELECT))uSub=0;

						pData->uFocusItem = uItem;
						pData->uFocusSub  = uSub;
						pEntry->bFlags	 |= LVIX_FOCUSED;
						pEntry->uState	 |= LVNI_FOCUSED;

						UpdateRect(pData,uItem,uSub);

						goto End;
						}
					}
				}

			if(wParam&MK_CONTROL)							// Ist die Ctrl-Taste gedrckt
				{
				iMode = 0;
				}
			else{
				iMode = LVC_DESELECT;
				}

			uOldSub	  = pData->uSelectedSub;
			uOldItem  = pData->uSelectedItem;

			FastListRemoveFocus  (pData);
			FastListSelectItem   (pData,uItem,0,iMode);
			FastListEnsureVisible(pData,pData->uSelectedItem,pData->uSelectedSub|0x80000000,SB_SETPOSITION);
			pEntry = pData->pListItems+uItem;

			if(!(pEntry->uState&LVIS_FOCUSED))				// Fokus setzen
				{
				pData->uFocusItem = uItem;
				pData->uFocusSub  = 0;
				pEntry->bFlags   |= LVIX_FOCUSED;
				pEntry->uState	 |= LVNI_FOCUSED;

				UpdateRect(pData,uItem,0);
				}

			if(uMsg==WM_LBUTTONDBLCLK)
				{											// Auto-Edit mit Doppelklick
				if(pData->aColumn[0].bFlags&LVAE_DBLCLICK && pData->aColumn[0].bEdit)
					{
					FastListStartAutoEdit(pData,0,VK_DBLCLK,lParam);
					}
				else{
					FastListStartNotifyEdit(pData,pData->uSelectedItem,0,VK_DBLCLK,lParam);
					}
				}
			else if(uMsgOld==WM_LBUTTONDOWN)
				{
				if(pData->uStyleEx&LVS_EX_EDITCLICK)
				if(!(wParam&(MK_CONTROL|MK_SHIFT)))
				if((pData->cEditClickMode&2) || (uOldSub==pData->uSelectedSub && uOldItem==pData->uSelectedItem))
					{
					if(pData->cEditClickMode&1)
						{
						if(sInfo.flags&LVHT_ONITEMBASE)pData->cClickEdit=1;
						}
					else{
						if(sInfo.flags&uMaskItem&~LVHT_ONITEMICON)pData->cClickEdit=1;
						}
					}
				}
			else if(uMsgOld==WM_LBUTTONUP)
				{
				if(pData->uStyleEx&LVS_EX_EDITCLICK)
				if(pData->cClickFlag && !pData->cClickEdit)
				if(!(wParam&(MK_CONTROL|MK_SHIFT)))
				if((pData->cEditClickMode&2) || (uOldSub==pData->uSelectedSub && uOldItem==pData->uSelectedItem))
					{
					if(pData->cEditClickMode&1)
						{
						if(sInfo.flags&LVHT_ONITEMBASE)pData->cClickEdit=1;
						}
					else{
						if(sInfo.flags&uMaskItem&~LVHT_ONITEMICON)pData->cClickEdit=1;
						}
					}

				if(pData->cClickEdit)
					{
					pData->cClickEdit = 0;

					if(pData->aColumn[0].bEdit)
						{
						FastListStartAutoEdit(pData,0,VK_EDITCLK,lParam);
						}
					else{
						FastListStartNotifyEdit(pData,pData->uSelectedItem,0,VK_EDITCLK,lParam);
						}
					}
				}
			}
		else if(sInfo.flags&uMaskSub)						// Extra-Eintrag auswhlen
			{
			if(pData->uStyleEx&LVS_EX_SUBSELECT)
					uSub = sInfo.iSubItem;
			else	uSub = 0;

			if(!(pData->uStyleEx&LVS_EX_DISABLEDRAGDROP))
				{
				if(uMsg==WM_LBUTTONDOWN)
					{
					pData->uDragFlags = MK_LBUTTON;
					pData->uDragItem  = uItem;
					pData->uDragSub   = uSub;
					}

				if(uMsg==WM_RBUTTONDOWN)
					{
					pData->uDragFlags = MK_RBUTTON;
					pData->uDragItem  = uItem;
					pData->uDragSub   = uSub;
					}
				}

			if(pData->uStyleEx&LVS_EX_NORIGHTSELECT)		// Keine Auswahl mit rechter Maustaste
			if(uMsg==WM_RBUTTONDOWN || uMsg==WM_RBUTTONDBLCLK)
				{
				goto End;
				}

			if(wParam&MK_CONTROL)
				{
				if(!(pData->uStyle&LVS_SINGLESEL))			// Auswahl umschalten
				if(pData->uListItemsCount>uItem)
					{
					   pEntry = pData->pListItems+uItem;
					if(pEntry->uState&LVIS_SELECTED)
						{
						if(uMsg!=WM_LBUTTONDOWN)
						if(uMsg!=WM_LBUTTONDBLCLK)goto End;

						FastListXorSelectItem(pData,uItem);
						FastListRemoveFocus  (pData);

						pData->cClickEdit = 0;
						pData->uFocusItem = uItem;
						pData->uFocusSub  = uSub;
						pEntry->bFlags   |= LVIX_FOCUSED;
						pEntry->uState	 |= LVNI_FOCUSED;

						UpdateRect(pData,uItem,uSub);

						goto End;
						}
					}

				iMode = 0;
				}
			else{
				iMode = 1;
				}


			uOldSub	  = pData->uSelectedSub;
			uOldItem  = pData->uSelectedItem;

			FastListRemoveFocus  (pData);
			FastListSelectItem   (pData,uItem,uSub,(wParam&MK_CONTROL)? 0:1);
			FastListEnsureVisible(pData,pData->uSelectedItem,pData->uSelectedSub|0x80000000,SB_SETPOSITION);
			pEntry = pData->pListItems+uItem;

			if(uMsg==WM_LBUTTONDBLCLK)
				{
				if( pData->aColumn[uSub].bEdit &&			// Auto-Edit mit Doppelklick
				  ((pData->aColumn[uSub].bFlags&LVAE_DBLCLICK ) ||
				  ((pData->aColumn[uSub].bFlags&LVAE_ICONCLICK) && (sInfo.flags&LVHT_ONSUBICON))))
					{
					FastListStartAutoEdit(pData,uSub,(sInfo.flags&LVHT_ONSUBICON)? VK_ICONCLK:VK_DBLCLK,lParam);
					}
				else{
					FastListStartNotifyEdit(pData,uItem,uSub,VK_DBLCLK,lParam);
					}
				}
			else if(uMsg==WM_LBUTTONDOWN)
				{
				if(pData->aColumn[uSub].bEdit)				// Auto-Edit mit Klick auf Icon
				if(pData->aColumn[uSub].bFlags&LVAE_ICONCLICK)
				if(sInfo.flags&LVHT_ONSUBICON)
					{
					FastListStartAutoEdit(pData,uSub,VK_ICONCLK,lParam);
					}

				if((pData->uStyleEx&LVS_EX_EDITCLICK))
				if(uSub && !(wParam&(MK_CONTROL|MK_SHIFT)))
				if((pData->cEditClickMode&2) || (uOldSub==pData->uSelectedSub && uOldItem==pData->uSelectedItem))
					{
					if(pData->cEditClickMode&1)
						{
						if(sInfo.flags&LVHT_ONSUBBASE)pData->cClickEdit=1;
						}
					else{
						if(sInfo.flags&uMaskSub&~LVHT_ONSUBICON)pData->cClickEdit=1;
						}
					}
				}
			else if(uMsg==WM_LBUTTONUP)
				{
				if(pData->cClickEdit)
					{
					pData->cClickEdit = 0;

					if(pData->aColumn[uSub].bEdit)
						{
						FastListStartAutoEdit(pData,uSub,VK_EDITCLK,lParam);
						}
					else{
						FastListStartNotifyEdit(pData,uItem,uSub,VK_EDITCLK,lParam);
						}
					}
				}
			}
		else if(sInfo.flags&LVHT_ONSPECIAL)					// Auf Spezialzeichen
			{
			if(uMsg==WM_LBUTTONDOWN || uMsg==WM_LBUTTONDBLCLK)
				{
				NMLISTVIEW	sNotify;

				GetDataEntry(pData,uItem,0,&sData,pEntry->uState);

				sNotify.hdr.code	= LVN_SPECIALCLICK;
				sNotify.iItem		= uItem;
				sNotify.iSubItem	= LVHT_SPECIAL(sInfo.flags);
				sNotify.uChanged	= LVHT_SPECIALCHAR(sInfo.flags);
				sNotify.uNewState	= pEntry->uState;
				sNotify.uOldState	= pEntry->uState;
				sNotify.lParam		= pEntry->lParam;
				sNotify.ptAction.x	= sInfo.pt.x;
				sNotify.ptAction.y	= sInfo.pt.y;

				UNLOCK(pData);
				SendNotify(pData,&sNotify.hdr);
				LOCK(pData);
				}
			}
		}
	else{
		pEntry = NULL;
		uSub   = 0;
		}

End:


	switch(uMsgOld)
		{
	case WM_LBUTTONDOWN:	sNotify.hdr.code = NM_CLICK;	break;
	case WM_LBUTTONDBLCLK:	sNotify.hdr.code = NM_DBLCLK;	break;
	case WM_RBUTTONDOWN:	sNotify.hdr.code = NM_RCLICK;	break;
	case WM_RBUTTONDBLCLK:	sNotify.hdr.code = NM_RDBLCLK;	break;
	default:				UNLOCK(pData);					return;
		}


	if(pEntry)
		{
		sNotify.uNewState	= pEntry->uState;
		sNotify.iSubItem	= sInfo.iSubItem;
		sNotify.lParam		= pEntry->lParam;
		}
	else{
		sNotify.uNewState	= 0;
		sNotify.iSubItem	= 0;
		sNotify.lParam		= 0;
		}

	sNotify.uChanged		= 0;
	sNotify.uOldState		= sNotify.uNewState;
	sNotify.iItem			= uItem;
	sNotify.ptAction.x		= GET_X_LPARAM(lParam);
	sNotify.ptAction.y		= GET_Y_LPARAM(lParam);


	UNLOCK(pData);

	SendNotify(pData,&sNotify.hdr);

}

//*****************************************************************************
//*
//*		FastListPaste
//*
//*****************************************************************************
//	Fgt einen Text in einen Eintrag ein
//	Ergibt 1 wenn die Einfgeoperation erfolgreich war.
static int FastListPaste(FastListData *pData)
{
unsigned	uSub;



	if(pData->uSelectedItem==0xFFFFFFFF || !IsClipboardFormatAvailable(CF_TEXT_EX))
		{
		return 0;
		}


	uSub = pData->uSelectedSub;


	if(LVIS_EDIT(pData->aColumn[uSub].bEdit))		// AutoEdit bei dieser Spalte
	if(!(pData->aColumn[uSub].bFlags&LVAE_ONLYRETURN))
		{
		FastListStartAutoEdit(pData,uSub,VK_PASTE,0);
		return 1;
		}

	if(FastListStartNotifyEdit(pData,pData->uSelectedItem,uSub,VK_PASTE,0))

		{
		return 1;
		}


return 0;
}

//*****************************************************************************
//*
//*		FastListChar
//*
//*****************************************************************************
//	Eingabe von Buchstaben ber die WM_CHAR Nachricht
//	pData	: Zeiger auf die Fensterdaten
//	nChar	: Ist das Zeichen das eingegeben wurde
static void FastListChar(FastListData *pData,UINT nChar,LPARAM lParam)
{
FL_ENTRY		sData;
LPTSTR			pName;
BaseItem	   *pEntry;
unsigned		uDelta;
unsigned		uItem;
unsigned 		uTick;
unsigned		uChar;
unsigned		uSub;
unsigned		uPos;
unsigned		uVal;
int				iNum;
int				iMax;
int				i;



	if(nChar>=' ')
		{
		if(pData->cKeyIgnore)return;						// Taste soll ignoriert werden

		iMax	= pData->uListItemsCount;
		uSub	= pData->uSelectedSub;
		i		= 0;

		if(LVIS_EDIT(pData->aColumn[uSub].bEdit))			// Bei AutoEdit keine Auswahl
		if(!(pData->aColumn[uSub].bFlags&LVAE_ONLYRETURN))
			{
			FastListStartAutoEdit(pData,uSub,nChar,0);
			return;
			}

		if(FastListStartNotifyEdit(pData,pData->uSelectedItem,uSub,nChar,lParam))
			{
			return;
			}

		if(iMax<=0)return;

		if(!(pData->uStyleEx&LVS_EX_NOCHARSELCET))			// Suche Anfangsbuchstaben
			{
			uTick  = GetTickCount();
			uDelta = (uKeyPos>0)? 750:500;

			if(uKeyPos>=3           )uDelta=1000;
			if(uTick-uKeyLast>uDelta)uKeyPos=0;
			if(uKeyPos>=16          )uKeyPos=0;
			if(uKeyPos==0			)						// Hole die Startzeile
				{
				   iKeyItem = pData->uSelectedItem;						
				if(iKeyItem<0)iKeyItem=0;
				}

			if((nChar>='a' && nChar<='z') ||				// In Grosbuchstaben umwandeln
			   (nChar>=224 && nChar<=254))
				{
				nChar-='a'-'A';
				}

			cKeyData[uKeyPos] = (TCHAR)nChar;
			uKeyLast          = uTick;
			uKeyPos          += 1;

			for(i=iKeyItem+1,iNum=-1;i!=iKeyItem;i++)		// Suche bereinstimmung
				{
				if(i>=iMax){i=-1;continue;}
				
				uItem = i;

				GetDataEntry(pData,uItem,uSub,&sData,0);

				if(uSub==0)
					{
					while(sData.iSize>0)					// Spezialzeichen auslassen
						{
						   uChar = sData.pText[0];
						if(uChar>=SPECIAL_MAX)break;

						sData.pText++;
						sData.iSize--;
						}
					}

				pName  = sData.pText;


				for(uPos=0;uPos<uKeyPos;uPos++)				// Vergleiche die Texte
					{
					#if UNICODE
					uVal = pName[uPos];
					#else
					uVal = ((unsigned char*)pName)[uPos];
					#endif

					if((uVal>='a' && uVal<='z') ||			// In Grosbuchstaben umwandeln
					   (uVal>=224 && uVal<=254))
						{
						uVal-='a'-'A';
						}

					if(cKeyData[uPos]!=(TCHAR)uVal)
						{
						break;
						}
					}

				if(uPos<uKeyPos)
					{
					if(iNum==-1 && uPos>0)iNum=i;			// Ersten Anfangsbuchstaben speichern
					continue;
					}	
				

				if(FastListSelectItem(pData,uItem,uSub,1))
					{
					if(pData->uFocusItem!=uItem)
						{
						FastListRemoveFocus(pData);

						pData->uFocusItem   = uItem;
						pData->uFocusSub    = uSub;
						pEntry				= pData->pListItems+uItem;
						pEntry->bFlags	   |= LVIX_FOCUSED;
						pEntry->uState     |= LVIS_FOCUSED;
						}

					FastListEnsureVisible(pData,uItem,uSub|0x80000000,SB_KEYDOWN);
					pData->uFocusItem = uItem;
					}

				return;
				}

			if(iNum==-1)return;

			for(uPos=1;uPos<uKeyPos;uPos++)					// Anfangsbuchstaben durchlaufen
				{
				nChar = cKeyData[uPos];

				for(i=iNum+1;i!=iNum;i++)					// Suche Anfangsbuchstaben
					{
					if(i>=iMax){i=-1;continue;}
					
					uItem = i;

					GetDataEntry(pData,uItem,uSub,&sData,0);

					if(uSub==0)
						{
						while(sData.iSize>0)				// Spezialzeichen auslassen
							{
							   uChar = sData.pText[0];
							if(uChar>=SPECIAL_MAX)break;

							sData.pText++;
							sData.iSize--;
							}
						}

					pName  = sData.pText;

					#if UNICODE
					uVal = pName[0];
					#else
					uVal = ((unsigned char*)pName)[0];
					#endif

					if((uVal>='a' && uVal<='z') ||			// In Grosbuchstaben umwandeln
					   (uVal>=224 && uVal<=254))
						{
						uVal-='a'-'A';
						}

					if(cKeyData[uPos]==(TCHAR)uVal)
						{
						iNum = i;
						break;
						}
					}
				}

			uItem = iNum;

			if(FastListSelectItem(pData,uItem,uSub,1))
				{
				if(pData->uFocusItem!=uItem)
					{
					FastListRemoveFocus(pData);

					pData->uFocusItem   = uItem;
					pData->uFocusSub    = uSub;
					pEntry				= pData->pListItems+uItem;
					pEntry->bFlags	   |= LVIX_FOCUSED;
					pEntry->uState     |= LVIS_FOCUSED;
					}

				FastListEnsureVisible(pData,uItem,uSub|0x80000000,SB_KEYDOWN);
				pData->uFocusItem = uItem;
				}
			}
		}


}

//*****************************************************************************
//*
//*		FastListKeyDown
//*
//*****************************************************************************
//	Soll ein Tastendruck ausgefhrt werden. ACHTUNG UNLOCK wird ausgefhrt
//	pData	: Zeiger auf die Fensterdaten
//	wParam	: WPARAM des Mausklicks
//	lParam	: LPARAM des Mausklicks
static void FastListKeyDown(FastListData *pData,WPARAM wParam,LPARAM lParam)
{
BaseItem	   *pTemp;
BaseItem	   *pEntry;
LV_KEYDOWN_EX	sNotify;
unsigned		uTemp;
unsigned		uItem;
unsigned		uStop;
unsigned		uVal;
int				iLineCmp;
int				iOldLine;
int				iOldCol;
int				iShift;
int				iBase;
int				iLine;
int				iAdd;
int				iPos;
int				iSub;
int				iCol;
int				iMax;
int				iDel;
int				iScr;



	if(!pData->cIsEnabled)									// Ist das Fenster freigegeben
		{
		UNLOCK(pData);
		return;
		}

	if(wParam==VK_TAB)										// Fokus ans Elternfenster
		{
		if(pData->uStyleEx&LVS_EX_TABEXIT)
			{
			UNLOCK(pData);
			SetFocus(GetParent(pData->hWnd));
			return;
			}
		}

	if(!pData->cHasFocus)									// Hat das Fenster den Fokus
		{
		UNLOCK(pData);
		SetFocus(pData->hWnd);
		LOCK(pData);
		}

	if(wParam==VK_RETURN)									// Wurde Enter gedrckt
		{
		sNotify.hdr.code	=  NM_RETURN;
		sNotify.wVKey		= (WORD)(wParam);
		sNotify.wScan		= (WORD)(wParam>>16);
		sNotify.flags		= (UINT)(lParam);

		UNLOCK(pData);
		SendNotify(pData,&sNotify.hdr);
		LOCK(pData);

		iSub = pData->uSelectedSub;							// Auto-Edit starten

		if(pData->aColumn[iSub].bEdit)
			{
			if(GetAsyncKeyState(VK_CONTROL)&0x8000)
				{
				wParam = VK_ICONCLK;
				lParam = 0;
				}

			FastListStartAutoEdit(pData,iSub,wParam,lParam);
			}
		else{
			FastListStartNotifyEdit(pData,pData->uSelectedItem,iSub,wParam,lParam);
			}

		UNLOCK(pData);
		return;
		}


	pEntry = (pData->uSelectedItem<pData->uListItemsCount)? pData->pListItems+pData->uSelectedItem:0;
	iDel   = (GetAsyncKeyState(VK_SHIFT  )&0x8000)? 0:LVC_DESELECT;
	iScr   =  GetAsyncKeyState(VK_CONTROL)&0x8000;


	if((wParam==VK_INSERT && !iDel && !iScr) ||				// Text einfgen
	   (wParam=='V'       &&  iDel &&  iScr))
		{
		if(FastListPaste(pData))
			{
			UNLOCK(pData);
			return;
			}
		}


	if(wParam==VK_HOME || wParam==VK_END)					// Ende oder Anfang whlen
	if(iDel && iScr)
		{
		iDel = LVC_DESELECT;
		iScr = 0;
		}


	if(iDel && iScr)										// Das Fenster scrollen
		{
		iLine = pData->uScrollY;
		iSub  = pData->uScrollX;

		switch(wParam)
			{
		case VK_END:	iLine  = pData->uListItemsCount;	// Ans Ende scrollen
						iLine -= pData->uPageEnties;
						break;

		case VK_HOME:	iLine=0;							// Zum Anfang scrollen
						break;

		case VK_LEFT:	iSub-=16;							// Links scrollen
						break;

		case VK_RIGHT:	iSub+=16;							// Rechts scrollen
						break;

		case VK_UP:		iLine--;							// Nach oben scrollen
						break;

		case VK_DOWN:	iLine++;							// Nach unten scrollen
						break;

		case VK_PRIOR:	iLine-=pData->uSizeX;				// Eine Seite nach oben
						break;

		case VK_NEXT:	iLine+=pData->uSizeX;				// Eine Seite nach unten
						break;

		default:		goto Exit;
			}

		if(iLine!=(int)pData->uScrollY)
			{
			FastListScrollY(pData,iLine,SB_KEYDOWN);
			}

		if(iSub!=(int)pData->uScrollX)
			{
			FastListScrollX(pData,iSub,SB_KEYDOWN);
			}
		}
	else{													// Einen anderen Eintrag auswhlen
		iSub  = pData->uSelectedSub;
		iCol  = pData->aColumn[iSub].bIndex;

		if(!pEntry)
			{												// Ist noch nichts ausgewhlt
			iCol     =  pData->aColumnPos[0];;
			iOldCol	 =  iCol;
			iOldLine = -1;
			iLine    =  0;

			   uTemp = pData->uFocusItem;
			if(uTemp < pData->uListItemsCount)				// Ist ein Focus definiert
				{
				pTemp = pData->pListItems+uTemp;
				iSub  = pData->uFocusSub;
				iCol  = pData->aColumn[iSub].bIndex;
				iLine = uTemp;

				if(pData->uSelectedCount>1)
					{
					iOldCol	 = iCol;
					iOldLine = uTemp;
					}
				else{
					FastListRemoveFocus(pData);
					}
				}
			}
		else{												// Es ist etwas gewhlt
			iLine	 =  pData->uSelectedItem;
			iOldLine =  iLine;
			iOldCol	 =  iCol;
			}


		switch(wParam)
			{
		case VK_END:	iLine=pData->uListItemsCount-1;	break;
		case VK_HOME:	iLine=0;						break;
		case VK_LEFT:	if(pData->uStyleEx&LVS_EX_SUBSELECT)
						if(pData->uColumnCount>1)
						if(iCol>0)
							{
							while(iCol>0)
								{
								iCol--;
								iSub = pData->aColumnPos[iCol];
								if(pData->aColumn[iSub].sReal>0)break;
								}
							}

						break;

		case VK_RIGHT:	if(pData->uStyleEx&LVS_EX_SUBSELECT)
						if(pData->uColumnCount>1)
							{
							while(iCol+1<(int)pData->uColumnCount)
								{
								iCol++;
								iSub = pData->aColumnPos[iCol];
								if(pData->aColumn[iSub].sReal>0)break;
								}
							}

						break;

		case VK_UP:		iLine--;						break;
		case VK_DOWN:	iLine++;						break;

		case VK_PRIOR:	iAdd=pData->uPageEnties-1;			// Eine Seite nach oben
						if(iAdd<=0)iAdd=1;
						iLine-=iAdd;
						break;

		case VK_NEXT:	iAdd=pData->uPageEnties-1;			// Eine Seite nach unten
						if(iAdd<=0)iAdd=1;
						iLine+=iAdd;
						break;

		case VK_SPACE:
						if(pEntry && iCol==0 && (pData->uStyleEx&LVS_EX_CHECKBOXES))
							{
							LV_ITEM	 sItem;

							sItem.iItem		= pData->uSelectedItem;
							sItem.mask		= LVIF_STATE;
							sItem.stateMask	= LVIS_STATEIMAGEMASK;

							if(pData->uStyleEx&LVS_EX_BITCHECKBOX)
									sItem.state	= (pEntry->uState^0x1000);
							else	sItem.state = (pEntry->uState&0x1000)? 0x2000:0x1000;

							FastListSetItem(pData,&sItem);
							}

						break;

		default:		goto Exit;
			}

		if(iCol <      pData->iLeftColumn )iSub=pData->iLeftColumn;
		if(iCol >=(int)pData->uColumnCount)iSub=pData->uColumnCount-1;
		if(iCol <0)iCol=0;
		if(iLine>=(int)pData->uListItemsCount)iLine=pData->uListItemsCount-1;
		if(iLine<0)iLine=0;

		if(!(pData->uStyleEx&LVS_EX_SUBSELECT))				// Auswhlen nur in der ersten Spalte
			{
			iCol = pData->aColumn[0].bIndex;
			}


		if(pData->uListItemsCount>0)
		if(iLine!=iOldLine || iCol!=iOldCol)				// Wurde ein anderer Eintrag ausgewhlt
			{
			if(pData->uSelectedCount>1)
				{
				FastListRemoveFocus(pData);
				}
			else{
				pData->uSelectedBase = iOldLine;
				}
								    

			iShift = iDel;

			if(pData->cReSelect)							// Die Shift-Auswahl neu erstellen
				{
				iDel = LVC_DESELECT;
				}

			uItem = iLine;
			iSub  = pData->aColumnPos[iCol ];
			FastListSelectItem(pData,uItem,iSub,iDel);
			pData->uFocusItem = uItem;

			if(!(pData->uStyle&LVS_NOSCROLL))
				{
				FastListEnsureVisible(pData,pData->uSelectedItem,pData->uSelectedSub|0x80000000,SB_KEYDOWN);
				}

															// Shift-Select neu auswhlen
			if(pData->cReSelect && pData->uSelectedBase<pData->uListItemsCount)
				{
				uTemp = pData->uSelectedBase;
				pTemp = pData->pListItems+uTemp;
				uStop = uItem;

				if(!iShift)
					{
					if(!(pTemp->uState&LVIS_SELECTED))
						{
						FastListXorSelectItem(pData,uTemp);
						}

					   iLineCmp = pData->uSelectedBase;
					if(iLineCmp<iLine)
						{
						uStop = uItem;
						}
					else{
						uStop = uTemp;
						uTemp = uItem;
						}

					for(;uTemp<uStop;uTemp++)
						{
						pTemp = pData->pListItems+uTemp;
						if(pTemp->uState&LVIS_SELECTED)continue;
						FastListXorSelectItem(pData,uTemp);
						}
					}

				pData->cReSelect = 0;
				}


			if(!(pData->uStyle&LVS_SINGLESEL) && !iDel)
				{
				uVal  = pData->uSelectedBase;
				pTemp = pData->pListItems+uVal;
				iBase =(pTemp)? pData->uSelectedBase:-1;

				if(iLine>iOldLine)							// Nach oben oder nach unten
					{
					   iMax = (iOldLine>iBase)? iOldLine+1:iOldLine;
					if(iMax<0)iMax=0;
					   iPos = iLine;
					}
				else{
					   iMax = iLine;
					   iPos = (iOldLine<iBase)? iOldLine-1:iOldLine;
					if(iPos<0)iPos=0;
					}


				for(;iPos>=iMax;iPos--)						// bersprungene Eintrge mit aus/abwhlen
					{
					uItem = iPos;

					if(iPos!=iLine && iPos!=iBase)
						{
						if(!FastListXorSelectItem(pData,uItem))continue;
						}
					}
				}
			}
		}


Exit:

	sNotify.hdr.code	=  LVN_KEYDOWN;
	sNotify.wVKey		= (WORD)(wParam);
	sNotify.wScan		= (WORD)(wParam>>16);
	sNotify.flags		= (UINT)(lParam);

	UNLOCK(pData);

	pData->cKeyIgnore	= (char)SendNotify(pData,&sNotify.hdr);

}

//*****************************************************************************
//*
//*		FastListSortItems
//*
//*****************************************************************************
//	Sortiert die Kindereintrge eines Eintrages via Text
//	pData		: Zeiger auf die Fensterdaten
//	pSortData	: Ist ein Zeiger auf die Sortiertaten
//	iMode		: 1=Rekursiv sortieren
//	Ergibt 1 wenn ok sonst 0
static int FastListSortItems(FastListData *pData,LPARAM lSortParam,PFNLVCOMPARE pCompare)
{
#ifdef _WIN64
#define XCHANGE_MEM(a,b)	uTemp1=((__int64 *)(pList+a))[0];((__int64 *)(pList+a))[0]=((__int64 *)(pList+b))[0];((__int64 *)(pList+b))[0]=uTemp1;	\
							uTemp2=((unsigned*)(pList+a))[2];((unsigned*)(pList+a))[2]=((unsigned*)(pList+b))[2];((unsigned*)(pList+b))[2]=uTemp2;
#else
#define XCHANGE_MEM(a,b)	uTemp1=((unsigned*)(pList+a))[0];((unsigned*)(pList+a))[0]=((unsigned*)(pList+b))[0];((unsigned*)(pList+b))[0]=uTemp1;	\
							uTemp2=((unsigned*)(pList+a))[1];((unsigned*)(pList+a))[1]=((unsigned*)(pList+b))[1];((unsigned*)(pList+b))[1]=uTemp2;
#endif

BaseItem	   *pList;
BaseItem	   *pTemp;
BaseItem	   *pEntry;
LPARAM			lParam;
DWORD_PTR		uTemp1;
unsigned 		uTemp2;
int				aMemL[30];
int				aMemU[30];
int				iLower;
int				iUpper;
int				iMiddle;
int				iStart;
int				iLevel;
int				iLast;
int				iCmp;




	pData->cLockChanges=1;
	UNLOCK(pData);

	pList		= pData->pListItems;
	iLast		= pData->uListItemsCount-1;
	iStart		= 0;
	iLevel		= 0;

	for(;;)
		{
		iLower	=  iStart;
		iMiddle = (iStart+iLast)>>1;						// Mitte berechnen
		iUpper	=  iLast +1;


		XCHANGE_MEM(iMiddle,iLower);

		pTemp   = pList+iStart;
		lParam	= pTemp->lParam;


		for(;;)
			{
			do  {
				iLower++;
				if(iLower>iLast)break;
				pEntry = pList+iLower;
				iCmp   = pCompare(pEntry->lParam,lParam,lSortParam);
				}while(iCmp<=0);

			do  {
				iUpper--;
				if(iUpper<=iStart)break;
				pEntry = pList+iUpper;
				iCmp   = pCompare(pEntry->lParam,lParam,lSortParam);
				}while(iCmp>=0);

			if(iUpper<iLower)break;

			XCHANGE_MEM(iUpper,iLower);
			}


		XCHANGE_MEM(iStart,iUpper);


		if(iUpper-1-iStart >= iLast-iLower )
			{
			if(iStart+1<iUpper)
				{
				aMemL[iLevel] = iStart;
				aMemU[iLevel] = iUpper-1;
				iLevel++;
				}

			if(iLower<iLast)
				{
				iStart = iLower;
				continue;
				}
			}
		else{
			if(iLower<iLast)
				{
				aMemL[iLevel] = iLower;
				aMemU[iLevel] = iLast;
				iLevel++;
				}

			if(iStart+1<iUpper)
				{
				iLast = iUpper-1;
				continue;
				}
			}
															// Eine Ebene absteigen
		iLevel--;

		if(iLevel>=0)										// Noch Ebenen vorhanden
			{
			iStart = aMemL[iLevel];
			iLast  = aMemU[iLevel];
			continue;
			}

		break;
		}


	LOCK(pData);
	pData->cLockChanges=0;
	UpdateView(pData);


return 1;
}

//*****************************************************************************
//*
//*		FastListEndLabelEdit
//*
//*****************************************************************************
//	Beendet das editiert eines Eintrages
//	pData	: Zeiger auf Fensterdaten
//	iMode	: Gibt an wie das Editieren beendet wurde
//				0 = Es gab es einen Abbruch mit ESC
//				1 = Eingabe ohne Enter
//				2 = Eingabe mit  Enter
//	Ergibt das Handle des Edit-Controlls oder NULL bei einem Fehler
static int FastListEndLabelEdit(FastListData *pData,int iMode)
{
TCHAR			cText[2052];
NMLVDISPINFO	sNotify;
LRESULT			lRet;
unsigned		uSub;
unsigned		uItem;
BaseItem	   *pEntry;





	uItem = pData->uEditItem;
	uSub  = pData->uEditSub;

	pData->uEditItem = 0xFFFFFFFF;
	pData->uEditSub  = 0x00000000;


	if(uItem>=pData->uListItemsCount || uSub>=pData->uColumnCount)
		{
		return 0;
		}

   	pEntry = pData->pListItems+uItem;

	if(iMode)												// Eingabe
		{
		GetWindowText(pData->hEdit,cText,sizeof(cText)/sizeof(cText[0]));
		cText[sizeof(cText)/sizeof(cText[0])-1]=0;
		sNotify.item.mask		= LVIF_PARAM|LVIF_STATE|LVIF_TEXT;
		sNotify.item.cchTextMax = sizeof(cText)/sizeof(cText[0])-1;
		sNotify.item.pszText	= cText;
		}
	else{													// Abbruch
		sNotify.item.mask		= LVIF_PARAM|LVIF_STATE;
		sNotify.item.pszText	= NULL;
		sNotify.item.cchTextMax = 0;
		}


	sNotify.hdr.code		= LVN_ENDLABELEDIT;
	sNotify.item.iItem		= uItem;
	sNotify.item.iSubItem	= uSub;


	if(pData->cColumnStart)									// Wurde ein Text eingegeben
		{
		sNotify.item.mask |= LVIF_TEXTCHANGED;
		}

	if(iMode==2)											// Wurde der Text mit RETURN eingegeben
		{
		sNotify.item.mask |= LVIF_RETURNEXIT;
		}


	sNotify.item.state	= pEntry->uState;
	sNotify.item.lParam	= pEntry->lParam;


	UNLOCK(pData);
	ShowWindow(pData->hEdit,SW_HIDE);
	lRet=SendNotify(pData,&sNotify.hdr);
	LOCK(pData);


	if(lRet || !iMode)return 0;



	sNotify.hdr.code		= LVN_SETDISPINFO;
	sNotify.item.mask		= LVIF_PARAM|LVIF_STATE|LVIF_TEXT;
	sNotify.item.stateMask	= 0xFFFFFFFF;
	sNotify.item.iItem		= uItem;
	sNotify.item.iSubItem	= uSub;

	UNLOCK(pData);
	SendNotify(pData,&sNotify.hdr);
	LOCK(pData);


	if(pData->aColumn[uSub].bFlags&LVAE_NEXTLINE &&	iMode==2 && // In die nchste Zeile springen
	   pData->aColumn[uSub].bEdit!=LVAX_NONE     && pData->cColumnStart &&
	   pData->aColumn[uSub].bEdit!=LVAX_STEP)
		{
		uItem = pData->uSelectedItem+1;

		if(uItem && uItem<pData->uListItemsCount)
			{
			FastListSelectItem(pData,uItem,pData->uSelectedSub,1);
			}
		}


return 1;
}

//*****************************************************************************
//*
//*		FastListEditLabel
//*
//*****************************************************************************
//	Startet das editiert eines Eintrages
//	pData	: Zeiger auf Fensterdaten
//	uItem	: Item das editiert werden soll
//	uSub	: Spalte die editiert werden soll und andere Flags
//				LVIR_EDITCOL(n)		= Spalte angeben
//				LVIR_SELAREA(a,b)	= Einen Textbereich auswhlen
//				LVIR_SETCURSOR(n)	= Den Cursor auf eine bestimmte Textstelle
//				LVIR_SETAT(n)		= Den Cursor auf eine bestimmte Pixelstelle
//				LVIR_SELALL			= Den gesammten Text whlen
//				LVIR_EDITCOMBOLIST	= Statt dem Edit-Fenster eine ComboBox nur mit Listenauswahl einblenden
//				LVIR_EDITFULL		= Das Edit-Fenster ber die volle Breite einblenden
//				LVIR_EDITCOMBOBOX	= Statt dem Edit-Fenster eine ComboBox einblenden
//	Ergibt das Handle des Edit-Controlls oder NULL bei einem Fehler
static HWND FastListEditLabel(FastListData *pData,unsigned uItem,unsigned uSub)
{
HDC				hDc;
HWND			hWnd;
LRESULT			lRet;
FL_ENTRY		sData;
char			cTemp;
LPARAM			lParam;
BaseItem	   *pEntry;
NMLVDISPINFO	sNotify;
WNDPROC			pProc;
LPCTSTR			pText;
RECT			sRect;
SIZE			sSize;
HFONT			hFont;
unsigned		uCol;
unsigned		uSel;
unsigned		uChar;
unsigned		uNext;
unsigned		uBits;
unsigned		uSize;
unsigned		uStart;
unsigned		uFlags;
unsigned		uState;
unsigned		uHeight;
int				iPixels;
int				iWidth;
int				iTemp;



	uBits	=  uSub>>29;
	uSel    = (uSub>>8)&0x0FFFFF;
	uSub   &=  0xFF;


	if(uSub >=pData->uColumnCount   )return NULL;
	if(uItem>=pData->uListItemsCount)return NULL;


	pEntry = pData->pListItems+uItem;


	if(uItem!=pData->uSelectedItem || uSub!=pData->uSelectedSub)
		{
		uCol  = (pData->uStyleEx&LVS_EX_SUBSELECT)? uSub:0;
		iTemp = FastListSelectItem(pData,uItem,uCol,0);
		}

	FastListEnsureVisible(pData,uItem,uSub|0x80000000);

	if(pData->hEdit)										// Editfenster lschen
		{
		DestroyWindow(pData->hEdit);
		pData->hEdit=0;
		}


	switch(uBits&3)											// Editfenster neu erzeugen
		{
	case 1:	pData->hEdit=CreateWindow(_T("COMBOBOX"),NULL,WS_BORDER|WS_CHILD|CBS_AUTOHSCROLL|CBS_DROPDOWN,0,0,0,0,pData->hWnd,(HMENU)3,NULL,NULL);
			pData->uEditMode=1;
			SendMessage(pData->hEdit,CB_LIMITTEXT,2048,0);
			break;

	case 2:	pData->hEdit=CreateWindow(_T("COMBOBOX"),NULL,WS_BORDER|WS_CHILD|CBS_AUTOHSCROLL|CBS_DROPDOWNLIST,0,0,0,0,pData->hWnd,(HMENU)3,NULL,NULL);
			pData->uEditMode=2;
			SendMessage(pData->hEdit,CB_LIMITTEXT,2048,0);
			break;

	default:uFlags=ES_LEFT;

			if(uBits&4)
				{
				if(pData->aColumn[uSub].bAlign==DT_RIGHT )uFlags=ES_RIGHT;
				if(pData->aColumn[uSub].bAlign==DT_CENTER)uFlags=ES_CENTER;
				}

			pData->hEdit=CreateWindow(_T("EDIT"),NULL,WS_BORDER|WS_CHILD|ES_AUTOHSCROLL|uFlags,0,0,0,0,pData->hWnd,(HMENU)3,NULL,NULL);
			pData->uEditMode=0;
			SendMessage(pData->hEdit,EM_SETLIMITTEXT,2048,0);
			break;
		}



	if(!pData->hEdit)return NULL;

	if(pSetWindowTheme)										// Entferne die Visual-Styles (ab XP)
		{
		pSetWindowTheme(pData->hEdit,L"", L"");
		}


	pData->pProcId3 = (WNDPROC)GetWindowLongPtr(pData->hEdit,GWLP_WNDPROC);
	SetWindowLongPtr(pData->hEdit,GWLP_USERDATA,(LPARAM)pData);
	SetWindowLongPtr(pData->hEdit,GWLP_WNDPROC ,(LPARAM)EditProc);

	hWnd = GetWindow(pData->hEdit,GW_CHILD);

	while(hWnd)
		{
		pProc = (WNDPROC)GetWindowLongPtr(hWnd,GWLP_WNDPROC);
		SetWindowLongPtr(hWnd,GWLP_USERDATA,(LPARAM)pProc);
		SetWindowLongPtr(hWnd,GWLP_WNDPROC ,(LPARAM)EditProc);
		hWnd  = GetNextWindow(hWnd,GW_HWNDNEXT);
		}


	if(pData->uEditMode>=1)									// ComboBox leeren
		{
		SendMessage(pData->hEdit,CB_RESETCONTENT,0,0);
		}



	if(uSub==0)												// Haupteintrag bearbeiten
		{
		FastListGetItemRect(pData,uItem,LVIR_GETCOLUMN|LVIR_LABEL,&sRect);

		GetDataEntry(pData,uItem,0,&sData,pEntry->uState);

		while(sData.iSize>0)								// Spezialzeichen berspringen
			{
			   uChar = sData.pText[0];
			if(uChar>=SPECIAL_MAX)break;

			sData.pText++;
			sData.iSize--;
			}

		pText	= sData.pText;
		uSize	= sData.iSize;
		iPixels	= GetTextSize(pData,&sData);
		lParam	= pEntry->lParam;
		uState	= pEntry->uState;
		hFont	=(uState&LVIS_BOLD)? pData->hFontB:pData->hFontN;

		if(uBits&4)											// Volle Spaltenbreite
			{
			if(sData.iImage!=LV_NOIMAGE)
				{
				uNext		 = pData->aColumnPos[1];
				sRect.right  = pData->aColumnXpos[uNext];
				sRect.right -= pData->uScrollX;
				}

			iPixels	= sRect.right-sRect.left-2;
			}
		else{
			if(pData->uEditMode)
				{
				if(iPixels<60)iPixels=60;
				}
			else{
				if(iPixels<48)iPixels=48;
				}

			if(pText && *pText)
				{
				iPixels += str_len(pText);
				}

			if(pData->uEditMode)
				{
				iPixels+=GetSystemMetrics(SM_CXHSCROLL);
				}
			}
		}
	else{													// Extraeintrag bearbeiten
		if(uBits&4)
			{
			FastListGetItemRect(pData,uItem,LVIR_GETCOLUMN|LVIR_COLTOSUB(uSub),&sRect);
			}
		else{
			FastListGetItemRect(pData,uItem,LVIR_GETCOLUMN|LVIR_LABEL|LVIR_COLTOSUB(uSub),&sRect);
			}

		GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);

		pText	= sData.pText;
		uSize	= sData.iSize;
		iPixels	= GetTextSize(pData,&sData);
		lParam	= pEntry->lParam;
		uState	= pEntry->uState;
		uState |= sData.uState;
		hFont	=(uState&LVIS_BOLD)? pData->hFontB:pData->hFontN;


		if(uBits&4)											// Volle Spaltenbreite
			{
			if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)		// Checkboxen vorhanden
				{
				sRect.left += pData->iChecksSizeX+1;
				}
			else if(sData.iImage!=LV_NOIMAGE)				// Icon vorhanden
				{
				sRect.left += pData->iSubImgXsize+1;
				}

			iPixels	= sRect.right-sRect.left-2;
			}
		else{
			if(pData->uEditMode)
				{
				if(iPixels<60)iPixels=60;
				}
			else{
				if(iPixels<48)iPixels=48;
				}

			if(pText && *pText)
				{
				iPixels += str_len(pText);
				}

			if(pData->uEditMode)
				{
				iPixels+=GetSystemMetrics(SM_CXHSCROLL);
				}

			switch(pData->aColumn[uSub].bAlign)
				{
			case DT_RIGHT:	iWidth		= sRect.right-sRect.left;
							sRect.left += iWidth-iPixels;
							break;

			case DT_CENTER:	iWidth		= sRect.right-sRect.left;
							sRect.left += (iWidth-iPixels)/2;
							break;
				}
			}
		}


	UNLOCK(pData);

	sNotify.hdr.code		= LVN_BEGINLABELEDIT;
	sNotify.item.mask		= LVIF_PARAM|LVIF_STATE|LVIF_TEXT;
	sNotify.item.iItem		= uItem;
	sNotify.item.pszText	= (LPTSTR)pText;
	sNotify.item.lParam		= lParam;
	sNotify.item.state		= uState;
	sNotify.item.cchTextMax	= uSize;
	sNotify.item.stateMask	= 0xFFFFFFFF;
	sNotify.item.iSubItem	= uSub;

	lRet=SendNotify(pData,&sNotify.hdr);

	LOCK(pData);

	if(lRet)												// Das Editieren abbrechen
		{
		FastListEndLabelEdit(pData,0);
		return NULL;
		}


	pEntry = pData->pListItems+uItem;


	if(pData->uToolTipItem!=0xFFFFFFFF)						// Ein offenes Tooltip verstecken
		{
		UpdateToolTip(pData,0xFFFFFFFF,0,0);
		}




	UNLOCK(pData);
	SetFocus(pData->hEdit);
	LOCK(pData);

	if(pData->uEditMode)
		{
		sRect.top--;
		uHeight	= 260;
		}
	else{
		uHeight=pData->iFontHeight+4;
		}

	if(pData->uEditMode)
		{
		if(iPixels<60)iPixels=60;
		}
	else{
		if(iPixels<48)iPixels=48;
		}

	cTemp = pData->cColumnStart;
	SetWindowPos (pData->hEdit,HWND_TOP,sRect.left+2,sRect.top+1,iPixels,uHeight,SWP_SHOWWINDOW);
	SendMessage  (pData->hEdit,WM_SETFONT,(WPARAM)hFont,0);
	SetWindowText(pData->hEdit,pText);
	pData->cColumnStart=cTemp;

	switch(uSel>>18)										// Welche Textauswahl
		{
	case 3:	uStart = (uSel   )&0x01FF;						// Einen Textbereich markieren
			uSize  = (uSel>>9)&0x01FF;
			break;

	case 2:	uStart = uSel&0x3FFFF;							// Cursor auf eine bestimmte Stelle
			uSize  = uStart;
			break;

	case 1:	uSel  &= 0x3FFFF;
			if(uSel>4)uSel-=4;
			hDc=GetDC(pData->hEdit);
			SelectObject(hDc,hFont);
			GetTextExtentExPoint(hDc,pText,uSize,uSel,&iWidth,NULL,&sSize);

			if(uSize>0 && iWidth<(int)uSize-1)				// Halben Buchstaben addieren
				{
				GetTextExtentExPoint(hDc,pText+iWidth,1,uSel,NULL,NULL,&sSize);
				uSel += sSize.cx/2;
				GetTextExtentExPoint(hDc,pText,uSize,uSel,&iWidth,NULL,&sSize);
				}

			ReleaseDC(pData->hEdit,hDc);

			if(sSize.cx<=(int)uSel)
				{
				uStart = 0;
				break;
				}

			uStart	= iWidth;
			uSize	= iWidth;
			break;

	default:uStart = 0;										// Alles markieren
			break;
		}

	switch(pData->uEditMode)
		{
	case 0:	SendMessage(pData->hEdit,EM_SETSEL,uStart,uSize);					break;
	case 1:	SendMessage(pData->hEdit,CB_SETEDITSEL,0,MAKELPARAM(uStart,uSize));	break;
	default:uStart = 0; uSize=0xFFFF;											break;
		}


	RedrawWindow(pData->hEdit,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ERASE);

	pData->uLastSel  = MAKELPARAM(uStart,uSize);
	pData->uEditItem = uItem;
	pData->uEditSub	 = uSub;



return pData->hEdit;
}


//*****************************************************************************
//*
//*		FastListStartNotifyEdit
//*
//*****************************************************************************
//	Startet die Editierung fr einen Wert via Notyfy-Rckfrage.
//	pData		: Zeiger auf die Fensterdaten
//	uItem		: Ist der Eintrag der Editiert werden soll
//	uSub		: Ist die Nummer der Spalte
//	wParam		: Ist der W-Parameter des Tastendrucks
//					VK_EDITCLK	bei einem Clickauf das ausgewhlte Feld
//					VK_DBLCLK	bei einem Doppelclick
//					VK_RETURN	bei einen Enter-Druck
//					<char>		bei einer Zeicheneingabe
//	lParam		: Ist der L-Parameter des Tastendrucks (bzw. die Koordinaten)
//	Ergibt 1 das Editieren gestartet wurde, ansonsten 0
//				0 wenn der Eintrag nicht gewhlt wurde
static int FastListStartNotifyEdit(FastListData *pData,unsigned uItem,unsigned uSub,WPARAM wParam,LPARAM lParam)
{
TCHAR			cText[1024];
LV_STARTEDIT	sNotify;
BaseItem	   *pEntry;
FL_ENTRY		sData;
unsigned		uBits;
unsigned		uChar;
unsigned		uCnt;
unsigned		uMax;
unsigned		uLen;
unsigned		uNum;
LPCTSTR			pText;
RECT			sRect;
TCHAR			cChar;
LRESULT			lRet;
MSG				sMsg;
HWND			hWnd;
INT				iSel;



	if(!(pData->uStyle&LVS_EDITLABELS))return 0;
	if(uItem>=pData->uListItemsCount  )return 0;
	if(uSub>=pData->uColumnCount      )return 0;

	pEntry  =  pData->pListItems+uItem;
	GetDataEntry(pData,uItem,uSub,&sData,pEntry->uState);

	if(uSub==0)
		{
		while(sData.iSize>0)								// Spezialzeichen berspringen
			{
			   uChar = sData.pText[0];
			if(uChar>=SPECIAL_MAX)break;

			sData.pText++;
			sData.iSize--;
			}
		}

	if(wParam<' ' && wParam!=VK_RETURN)						// Falsche Taste
		{
		return 0;
		}

	if(wParam>=' ' && wParam<=0xFFFF)						// Shift und Cltr prfen
		{
		if(GetKeyState(VK_MENU)&0x8000)
			{
			return 0;
			}

		if(GetKeyState(VK_CONTROL)&0x8000)
			{
			return 0;
			}
		}


	sNotify.hdr.code			= LVN_STARTEDIT;
	sNotify.uAction				= (UINT)wParam;
	sNotify.uMaxEntries			= 255;
	sNotify.pTextEntries		= 0;
	sNotify.pTextList			= 0;
	sNotify.uHeight				= 0;
	sNotify.item.mask			= LVIF_TEXTPTR|LVIF_TEXT|LVIF_STATE|LVIF_PARAM;
	sNotify.item.state			= sData.uState|pEntry->uState;
	sNotify.item.stateMask		= 0xFFFFFFFF;
	sNotify.item.pszText		= sData.pText;
	sNotify.item.cchTextMax 	= sData.iSize;
	sNotify.item.iItem			= uItem;
	sNotify.item.iSubItem		= uSub;
	sNotify.item.iImage			= 0;
	sNotify.item.iIndent		= 0;
	sNotify.ptAction.x			= GET_X_LPARAM(lParam);
	sNotify.ptAction.y			= GET_Y_LPARAM(lParam);


	UNLOCK(pData);
	lRet=SendNotify(pData,&sNotify.hdr);
	LOCK(pData);

	if(!lRet)return 0;


	if(wParam==VK_RETURN)
		{
		wParam = VK_DBLCLK;
		uBits  = 0;
		}
	else if(wParam==VK_EDITCLK)
		{
		if(pData->uStyleEx&LVS_EX_NOCURSORSET)
			{
			uBits = 0;
			}
		else{
			FastListGetItemRect(pData,uItem,LVIR_COLTOSUB(uSub)|LVIR_GETCOLUMN|LVIR_LABEL,&sRect);
			uBits = LVIR_SETAT(LOWORD(lParam)-sRect.left);
			}
		}
	else{
		uBits = 0;
		}

	cChar  = (TCHAR)((lRet>>8)&0xFF);
	uBits |= U(lRet)&LVIR_EDITFULL;

	if(U(lRet)&LVIR_EDITCOMBOBOX)							// Eine Combobox anzeigen
		{
		uBits |= (U(lRet)&LVIR_EDITCOMBOLIST)? 0x40000000:0x20000000;
		}


		hWnd = FastListEditLabel(pData,uItem,uSub|uBits|U(lRet));
	if(!hWnd)return 0;

	if(lRet&LVIR_EDITCOMBOBOX)								// Die Combobox fllen
		{
		uMax = sNotify.uMaxEntries;
		iSel = -1;

		if(sNotify.pTextList)								// Texte berlisten Feld
			{
			for(uCnt=0;uCnt<uMax;uCnt++)
				{
					pText = sNotify.pTextList[uCnt];
				if(!pText)break;

				SendMessage(hWnd,CB_ADDSTRING,1,(LPARAM)pText);

				if(!_tcscmp(pText,sNotify.item.pszText))
					{
					iSel = uCnt;
					}
				}
			}
		else{												// Text mit
			pText = sNotify.pTextEntries;

			if(!pText)pText=_T("\0");

			for(uCnt=0;uCnt<uMax;uCnt++)
				{
				for(uLen=0;pText[uLen];uLen++)				// Subtextlnge holen
					{
					if(pText[uLen]==cChar)break;
					}

				if(!uLen && cChar)break;

				   uNum = uLen;
				if(uNum>=sizeof(cText)/sizeof(TCHAR))
					{
					uNum=sizeof(cText)/sizeof(TCHAR)-1;
					}

				memcpy(cText,pText,uNum*sizeof(TCHAR));
				cText[uNum]=0;
				SendMessage(hWnd,CB_ADDSTRING,1,(LPARAM)cText);

				if(!_tcscmp(cText,sNotify.item.pszText))
					{
					iSel = uCnt;
					}

				pText += uLen;
				if(!cChar || *pText)pText++;
				}

			if(lRet&LVIR_EDITCOMBODEL)						// Den Puffer lschen
				{
				delete (TCHAR*)sNotify.pTextEntries;
				}
			}

		if(iSel>=0)											// Listeneintrag auswhlen
			{
			SendMessage(hWnd,CB_SETCURSEL,iSel,0);
			}

		if(sNotify.uHeight)									// Hhe der Dropdown-Liste einstellen
			{
			SendMessage(hWnd,CB_SETDROPPEDWIDTH,sNotify.uHeight,0);
			}

		if(lRet&LVIR_EDITCOMBODOWN)							// Dropdown-Liste einblenden
			{
			SendMessage(hWnd,CB_SHOWDROPDOWN,1,0);
			}

		if(!(lRet&LVIR_EDITCOMBOLIST))						// Textauswahl wiederherstellen
			{
			SetWindowText(hWnd,sNotify.item.pszText);
			SendMessage(hWnd,CB_SETEDITSEL,0,pData->uLastSel);
			}
		}


	if(wParam<0x10000)										// Taste an Fenster senden
		{
		pData->cColumnStart = 1;
		sMsg.hwnd			= hWnd;
		sMsg.lParam			= lParam;
		sMsg.wParam			= wParam;
		sMsg.message		= WM_KEYDOWN;

		TranslateMessage(&sMsg);
		}
	else if(wParam==VK_PASTE && !(lRet&LVIR_EDITCOMBOLIST))	// Text via WM_PASTE einfgen
		{
		PostMessage(hWnd,WM_PASTE,0,0);
		pData->cColumnStart = 0;
		}
	else{
		pData->cColumnStart = 0;
		}



return 1;
}

//*****************************************************************************
//*
//*		FastListStartAutoEdit
//*
//*****************************************************************************
//	Startet die Autoeditierung fr eine Spalte
//	pData		: Zeiger auf die Fensterdaten
//	uColumn		: Ist die Nummer der Spalte
//	wParam		: Ist der W-Parameter des Tastendrucks
//					VK_EDITCLK	bei einem Clickauf das ausgewhlte Feld
//					VK_ICONCLK	bei einem Clickauf das Icon
//					VK_DBLCLK	bei einem Doppelclick
//	lParam		: Ist der L-Parameter des Tastendrucks (bzw. die Koordinaten)
//	Ergibt 1 das Editieren gestartet wurde, ansonsten 0
//				0 wenn der Eintrag nicht gewhlt wurde
static int FastListStartAutoEdit(FastListData *pData,unsigned uColumn,WPARAM wParam,LPARAM lParam)
{
TCHAR			cBuffer[256];
NMLVDISPINFO	sNotify;
BaseItem	   *pEntry;
LPTSTR		   *pList;
LPTSTR	    	pText;
FL_ENTRY		sData;
RECT			sRect;
TCHAR			cChar;
unsigned		uMode;
unsigned		uBits;
unsigned		uFlag;
unsigned		uItem;
unsigned		uChar;
unsigned		uMax;
unsigned		uPos;
unsigned		uLen;
unsigned		uSub;
HWND			hWnd;
int				iSel;




	if(  pData->uEditItem!=0xFFFFFFFF )return 0;
	if(  pData->uColumnCount<=uColumn )return 0;
	if(!(pData->uStyle&LVS_EDITLABELS))return 0;
	if(  pData->uSelectedItem>=pData->uListItemsCount)return 0;


	uBits = pData->aColumn[uColumn].bFlags;
	uMode = pData->aColumn[uColumn].bEdit;

	if(uMode==0)return 0;

	uItem	= pData->uSelectedItem;
	pEntry  = pData->pListItems+uItem;
	GetDataEntry(pData,uItem,uColumn,&sData,pEntry->uState);

	if(uColumn==0)
		{
		while(sData.iSize>0)									// Spezialzeichen berspringen
			{
			   uChar = sData.pText[0];
			if(uChar>=SPECIAL_MAX)break;

			sData.pText++;
			sData.iSize--;
			}
		}

	if(uBits&LVAE_STATEENABLE)									// Kann das Editieren gesperrt werden
	if(sData.uState&LVIS_DISABLEBIT)
		{
		return 0;
		}


	if(wParam!=VK_RETURN && wParam<0x10000)						// Zeicheneingabe
		{
		if(!LVIS_EDIT(uMode))return 0;
		if(uBits&LVAE_ONLYRETURN)return 0;
		if(wParam<'0')return 0;
		pData->cColumnStart = 1;
		}
	else{
		pData->cColumnStart = 0;
		}



		uMax=pData->aColumn[uColumn].bCbSize;
	if(!uMax)uMax=1024;


//******************** Weiterschalten mit Return ******************************


	if(uMode>=LVAX_STEP)
		{
		if((uMode&1) && wParam!=VK_ICONCLK)						// Ein Edit-Feld ffnen
			{
			uMode = LVAX_EDIT;
			goto EditField;
			}

		if(uMode>=LVAX_CHECK)									// State-Bits bei Checkboxen setzen
			{
			if(uBits&LVAE_STATEENABLE)
					uFlag = sData.uState&(~LVIS_STATEIMAGEMASK|LVIS_DISABLEBIT);
			else	uFlag = sData.uState&(~LVIS_STATEIMAGEMASK);

			if(pData->uStyleEx&LVS_EX_BITCHECKBOX)
					sData.uState	= (sData.uState^0x1000);
			else	sData.uState	= (sData.uState&0x1000)? 0x2000:0x1000;

			if(pData->hChecks==THEMEIMGLIST && wParam==VK_ICONCLK)
				{
				pData->uCheckedDown = 1;
				}

			sData.uState |= uFlag;
			}


		if(uBits&LVAE_PTRLIST)									// Zeigerliste  char *pTexte[]={"1","2",NULL};
			{
			pList = (LPTSTR*)pData->aColumn[uColumn].pCbData;

			if(!pList)
				{
				if(uMode<LVAX_CHECK)return 0;
				pText       =  sData.pText;
				uPos		=  0;
				goto NoTextChange;
				}

			for(uPos=0;;uPos++)
				{
				if(uPos>=uMax || !pList[uPos]){uPos=0;break;}
				if(str_cmp(sData.pText,pList[uPos]))continue;
				   uPos++;
				if(uPos>=uMax || !pList[uPos])uPos=0;
				break;
				}

				pText = pList[uPos];
			if(!pText)
				{
				if(uMode<LVAX_CHECK)return 0;
				pText       =  sData.pText;
				}
			}
		else{													// Textliste  char *pText="1|2|3";
			pText = (LPTSTR)pData->aColumn[uColumn].pCbData;
			cChar = (TCHAR )pData->aColumn[uColumn].bCbChar;

			if(!pText)
				{
				if(uMode<LVAX_CHECK)return 0;
				pText       =  sData.pText;
				uPos		=  0;
				goto NoTextChange;
				}

			for(uPos=0;;uPos++)
				{
				if(uPos>=uMax)
					{
					pText = (LPTSTR)pData->aColumn[uColumn].pCbData;
					uPos  = 0;
					break;
					}

				for(uLen=0;pText[uLen];uLen++)					// Subtextlnge bestimmen
					{
					if(pText[uLen]==cChar)break;
					}

				if(sData.iSize==(int)uLen)						// Ist der Subtext der aktuelle Text
				if(str_ncmp(sData.pText,pText,uLen)==0)
					{
					uPos++;

					if(uPos>=uMax)
						{
						pText = (LPTSTR)pData->aColumn[uColumn].pCbData;
						uPos  = 0;
						break;
						}

					   pText+=uLen;
					if(pText[0]==cChar)pText++;
					if(pText[0]==0)
						{
						pText = (LPTSTR)pData->aColumn[uColumn].pCbData;
						uPos  = 0;
						}

					break;
					}

				   pText+=uLen;
				if(pText[0]==cChar)pText++;
				if(pText[0]==0)
					{
					pText = (LPTSTR)pData->aColumn[uColumn].pCbData;
					uPos  = 0;
					break;
					}

				}

			for(uLen=0;pText[uLen] && uLen<256;uLen++)			// Ausgewhlten Text kopiren
				{
				if(pText[uLen]==cChar)break;
				cBuffer[uLen] = pText[uLen];
				}

			cBuffer[uLen] = 0;
			pText = cBuffer;
			}


NoTextChange:

		if(uMode<LVAX_CHECK)									// Icon weiterschalten
			{
			sNotify.hdr.code		= LVN_STEPSTATECHANGED;
			sNotify.item.mask 		= LVIF_TEXTPTR|LVIF_TEXT|LVIF_STATE|LVIF_PARAM;
			sNotify.item.iItem		= uItem;
			sNotify.item.iSubItem	= uColumn;
			sNotify.item.state		= sData.uState|pEntry->uState;
			sNotify.item.stateMask	= 0xFFFFFFFF;
			sNotify.item.pszText	= pText;
			sNotify.item.cchTextMax = (int)_tcslen(pText);
			sNotify.item.iImage		= 0;
			sNotify.item.lParam		= pEntry->lParam;
			sNotify.item.iIndent	= (int)lParam;

			UNLOCK(pData);
			SendNotify(pData,&sNotify.hdr);
			LOCK(pData);
			}
		else{													// Combobox verndert
			NMLISTVIEW	sNotifyEx;

			sNotifyEx.hdr.code		= LVN_CBSTATECHANGED;
			sNotifyEx.iItem			= uItem;
			sNotifyEx.iSubItem		= uColumn;
			sNotifyEx.uNewState		= sData.uState|pEntry->uState;
			sNotifyEx.uOldState		= sData.uState|pEntry->uState;
			sNotifyEx.uChanged		= LVIS_STATEIMAGEMASK;
			sNotifyEx.lParam		= pEntry->lParam;

			GetCursorPos(&sNotifyEx.ptAction);
			ScreenToClient(pData->hWnd,&sNotifyEx.ptAction);

			UNLOCK(pData);
			SendNotify(pData,&sNotifyEx.hdr);
			LOCK(pData);
			}

		return 1;
		}


//******************** Edit oder Combobox *************************************

EditField:

	uSub	 = (uMode-1)<<29;
	uSub    |=  uColumn;

	if(uBits&LVAE_FULLWIDTH)
		{
		uSub |= LVIR_EDITFULL;
		}


	if(wParam==VK_EDITCLK)										// Cursor auf Klickposition
	if(!(pData->uStyleEx&LVS_EX_NOCURSORSET))
		{
		FastListGetItemRect(pData,pData->uSelectedItem,LVIR_COLTOSUB(uColumn)|LVIR_GETCOLUMN|LVIR_LABEL,&sRect);
		uSub |= LVIR_SETAT(LOWORD(lParam)-sRect.left);
		}


		hWnd = FastListEditLabel(pData,pData->uSelectedItem,uSub);
	if(!hWnd)return 0;


	if(uMode!=LVAX_EDIT)
		{
		iSel = (uMode!=LVAX_CBLIST)? -1:0;

		if(uBits&LVAE_PTRLIST)									// Zeigerliste  char *pTexte[]={"1","2",NULL};
			{
			pList = (LPTSTR*)pData->aColumn[uColumn].pCbData;

			for(uPos=0;uPos<uMax;uPos++)
				{
				if(!pList[uPos])break;
				if(!str_cmp(sData.pText,pList[uPos]))iSel=uPos;
				SendMessage(hWnd,CB_ADDSTRING,0,(LPARAM)pList[uPos]);
				}
			}
		else{													// Textliste  char *pText="1|2|3";
			pText = (LPTSTR)pData->aColumn[uColumn].pCbData;
			cChar = (TCHAR )pData->aColumn[uColumn].bCbChar;

			for(uPos=0;uPos<uMax;uPos++)
				{
				for(uLen=0;pText[uLen];uLen++)
					{
					if(pText[uLen]==cChar)break;
					}

				if(sData.iSize==(int)uLen)
				if(str_ncmp(sData.pText,pText,uLen)==0)
					{
					iSel = uPos;
					}

				if(cChar)
					{
					if(uLen<256){memcpy(cBuffer,pText,sizeof(TCHAR)*uLen);cBuffer[uLen]=0;}
					else		{memcpy(cBuffer,pText,sizeof(TCHAR)*255 );cBuffer[255 ]=0;}
					SendMessage(hWnd,CB_ADDSTRING,0,(LPARAM)cBuffer);
					}
				else{
					SendMessage(hWnd,CB_ADDSTRING,0,(LPARAM)pText);
					}

				   pText+=uLen;
				if(pText[0]==cChar)pText++;
				if(pText[0]==0)break;
				}
			}

		if(iSel>=0)
			{
			SendMessage(hWnd,CB_SETCURSEL,iSel,0);
			}
		}



	if((uBits&LVAE_DROPDOWN) && (uMode&~1)==2)					// Dropdownliste aufklappen
		{
		SendMessage(hWnd,CB_SHOWDROPDOWN,1,0);
		}

																// Ersten Buchstaben ans Fenster bergeben
	if(LVIS_EDIT(uMode) && pData->cColumnStart && wParam!=VK_EDITCLK)
		{
		SendMessage(hWnd,WM_CHAR,wParam,0);
		}

	if(LVIS_EDIT(uMode) && wParam==VK_PASTE)					// Text via WM_PASTE einfgen
		{
		PostMessage(hWnd,WM_PASTE,0,0);
		}





return 1;
}

//*****************************************************************************
//*
//*		FastListProc
//*
//*****************************************************************************
//	Ist die Fensterfunktion fr das FastList Fenster
static LRESULT CALLBACK FastListProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
BaseItem	   *pEntry;
LV_SETSTATES   *pSetIt;
FastListData   *pData;
LV_ITEM		   *pItem;
MSG			   *pMsg;
LPARAM		   *pPtr;
LPARAM			lRet;
LV_ITEM			sItem;
LV_HITTESTINFO	sInfo;
RECT			sRect;
POINT			sPoint;
SCROLLINFO		sScroll;
unsigned		uChange;
unsigned		uDelta;
unsigned		uFlag;
unsigned		uMode;
unsigned		uTime;
unsigned		uItem;
unsigned		uVal;
unsigned		uOld;
unsigned		uSub;
char			cOld;
int				iDif;
int				iPos;
int				iMax;
HDC				hDc;




	switch(uMsg)
		{
	case WM_CREATE:												// Das Fenster erzeugen

				pData= new FastListData;
			if(!pData)return -1;

			memset(pData,0,sizeof(FastListData));
			pData->pToolTipText = new TCHAR[256];
			pData->uToolTipSize = 256;

			if(!pData->pToolTipText)
				{
				delete pData;
				return -1;
				}

				pData->pListItems = new BaseItem[1];
			if(!pData->pListItems)
				{
				delete pData->pToolTipText;
				delete pData;
				return -1;
				}

			GlobalInit();
							 
			SYNCH_CREATE(pData);
			SetWindowLongPtr(hWnd,0,(LONG_PTR)pData);
			pData->uStyle		 = GetWindowLong(hWnd,GWL_STYLE);
			pData->hWnd			 = hWnd;
			pData->cIsEnabled	 = (char)IsWindowEnabled(hWnd);
			pData->cButtonSize	 = (char)((4*GetSystemMetrics(SM_CYICON))/32);
			pData->uEditItem	 = 0xFFFFFFFF;
			pData->uDragItem	 = 0xFFFFFFFF;
			pData->uFocusItem	 = 0xFFFFFFFF;
			pData->uTrackedItem	 = 0xFFFFFFFF;
			pData->uCheckedItem	 = 0xFFFFFFFF;
			pData->uToolTipItem	 = 0xFFFFFFFF;
			pData->uSelectedItem = 0xFFFFFFFF;
			pData->uUpdateEnsure = 0xFFFFFFFF;
			pData->aColumnPos[0] = 0;
			pData->aColumnPos[1] = 1;
			pData->uColorOff	 = LVIS_SELECTED|LVIS_DROPHILITED;

			if(pData->cButtonSize>(SPECIAL_WIDTH-2)/2)
				{
				pData->cButtonSize = (SPECIAL_WIDTH-2)/2;
				}

			UpdateFont   (pData);
			UpdateHeight (pData);
			UpdateColors (pData);
			UpdateScrollY(pData,FALSE);
			CreateToolTip(pData);

			return 0;

	case WM_DESTROY:											// Das Fenster zerstren

			pData = GetHandle(hWnd);

			LOCK(pData);

			if(pData->pCloseCallback)
				{
				pData->pCloseCallback(pData->pCloseCbParam,pData->hWnd);
				}

			FastListDeleteItems(pData,0,0x7FFFFFFF);

			if(pData->hEdit   ){DestroyWindow(pData->hEdit   );pData->hEdit	  =0;}
			if(pData->hHeader ){DestroyWindow(pData->hHeader );pData->hHeader =0;}
			if(pData->hToolTip){DestroyWindow(pData->hToolTip);pData->hToolTip=0;}

			if(pData->uStyle&LVS_SHAREIMAGELISTS)
				{
				if(pData->hStates && pData->cStatesMode){ImageList_Destroy(pData->hStates);pData->hStates=0;}
				if(pData->hChecks && pData->cChecksMode){ImageList_Destroy(pData->hChecks);pData->hChecks=0;}
				}
			else{
				if(pData->hStates && pData->cStatesMode){ImageList_Destroy(pData->hStates);pData->hStates=0;}
				if(pData->hChecks && pData->cChecksMode){ImageList_Destroy(pData->hChecks);pData->hChecks=0;}
				if(pData->hSubImg && pData->cSubImgMode){ImageList_Destroy(pData->hSubImg);pData->hChecks=0;}
				if(pData->hImages && pData->cImagesMode){ImageList_Destroy(pData->hImages);pData->hChecks=0;}
				}

			if(pData->hThemeBt)
				{
				pCloseThemeData(pData->hThemeBt);
				pData->hThemeBt = 0;
				}

			if(pData->uTempSize)
				{
				delete pData->pTempPos;
				delete pData->pTempPtr;
				}

			UNLOCK(pData);
			return 0;

	case WM_NCDESTROY:											// Das Fenster zerstren

			pData = GetHandle(hWnd);
			LOCK(pData);

			SetWindowLongPtr(hWnd,0,0);
			delete pData->pToolTipText;
			delete pData->pListItems;

			UNLOCK      (pData);
			SYNCH_DELETE(pData);
			memset(pData,0,sizeof(FastListData));
			delete pData;

			GlobalDeinit();

			return 0;

	case WM_SHOWWINDOW:											// Fenster ein/ausblenden

			if(wParam)
				{
				pData = GetHandle(hWnd);

				LOCK(pData);

				sScroll.cbSize		= sizeof(SCROLLINFO);
				sScroll.fMask		= SIF_ALL;
				sScroll.nMin		= 0;
				sScroll.nMax  		= 0;
				sScroll.nPage 		= 0;
				sScroll.nPos  		= 0;
				sScroll.nTrackPos	= 0;

				SetScrollInfo(pData->hWnd,SB_HORZ,&sScroll,TRUE);

				if(pData->uStyleEx&LVS_EX_ALWAYSSCROLLY)
					{
					sScroll.fMask  |= SIF_DISABLENOSCROLL;
					}

				SetScrollInfo(pData->hWnd,SB_VERT,&sScroll,TRUE);

				pData->uOldCountX	= 0xFFFF;
				pData->uOldCountY	= 0xFFFF;

				UpdateScrollY(pData,FALSE);
				UpdateScrollX(pData,FALSE);

				UNLOCK(pData);
				}

			return 0;

	case WM_SIZE:												// Die Fenstergre wurde verndert

			pData = GetHandle(hWnd);
			uFlag = 0;

			LOCK(pData);

			   uVal = LOWORD(lParam);
			if(uVal && uVal!=pData->uSizeX)
				{
				uOld			= pData->uSizeX;
				pData->uSizeX	= uVal;


				if(pData->uColumnCountVar)						// Spalten mit variabler Breite nach fhren
					{
					int		iDelta;
					int		iNum;

					iDelta = uVal-uOld;

					ChangeColSize(pData,iDelta);

					iNum = UpdateColumns(pData);
					GetClientRect(hWnd,&sRect);
					sRect.left  = iNum;
					sRect.left -= pData->uScrollX;
					sRect.top   = pData->uStartPixel;
					InvalidateRect(hWnd,&sRect,FALSE);
					}

				if(uVal>uOld)									// Hat sich die Breite vergrert
					{
					GetClientRect (hWnd,&sRect);
					sRect.right  = uVal;
					sRect.left   = uOld-pData->uTrippleB-8;
					InvalidateRect(hWnd,&sRect,FALSE);
					}
				else{
					GetClientRect (hWnd,&sRect);
					sRect.right  = uOld;
					sRect.left   = uVal-pData->uTrippleB-8;
					InvalidateRect(hWnd,&sRect,FALSE);
					}

				pData->aColumnXpos[pData->uColumnCount+1] = uVal+1;

				MoveWindow(pData->hHeader,-(int)pData->uScrollX,0,uVal+pData->uScrollX,pData->uStartPixel-pData->uStartOffset,uVal>uOld);
				UpdateScrollX(pData);

				if(pData->uStartOffset)							// Gre des Startbereiches verndert
					{
					LV_STARTSIZE	sNotify;

					sNotify.hdr.code = LVN_STARTCHANGED;
					sNotify.iSizeX	 = pData->uSizeX;
					sNotify.iSizeY	 = pData->uStartOffset;
					sNotify.iOffset	 = pData->uStartPixel-pData->uStartOffset;

					SendNotify(pData,&sNotify.hdr);
					}
				}

			GetClientRect(hWnd,&sRect);
			uVal = sRect.bottom-sRect.top;

			if(uVal && uVal!=pData->uSizeY)
				{
				uFlag = 0;

				if(uVal>pData->uSizeY)							// Hat sich die Hhe vergrert
					{
					uFlag		  = 1;
					sRect.bottom  = uVal;
					sRect.top     = pData->uSizeY;
					InvalidateRect(hWnd,&sRect,FALSE);
					}

				pData->uSizeY		 =  uVal;
				pData->uSizeYsub	 = (uVal<=pData->uStartPixel)? 0:uVal-pData->uStartPixel;
				pData->uMaxEnties	 = pData->uSizeY;
				pData->uMaxEnties	-= pData->uStartPixel;
				pData->uPageEnties	 = pData->uMaxEnties;
				pData->uMaxEnties	+= pData->iRowHeight-1;
				pData->uMaxEnties   /= pData->iRowHeight;
				pData->uPageEnties  /= pData->iRowHeight;
																// Wenn Hhe vergrert dann Scroll-Position prfen
				if(uFlag && pData->uPageEnties>2 && pData->uScrollY)
					{
					if(pData->uScrollY+pData->uPageEnties+1>pData->uListItemsCount)
						{
						   iPos = pData->uListItemsCount-pData->uPageEnties+1;
						if(iPos<0)iPos=0;
						if(U(iPos)!=pData->uScrollY)
							{
							pData->uScrollY = iPos;
							UpdateView(pData);
							}
						}
					}

				UpdateScrollY(pData);
				}


			UNLOCK(pData);

			if(uFlag)
				{
				RedrawWindow(pData->hHeader,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ERASE);
				}

			return 0;

	case WM_ENABLE:												// Das Fenster freischalten oder sperren

			   pData = GetHandle(hWnd);
			if(pData->cIsEnabled!=((U(wParam))? 1:0))
				{
				uVal  = GetWindowLong(hWnd,GWL_STYLE);
				uVal &= (0xFFFF0000&~WS_DISABLED);
				uVal |= (0x0000FFFF| WS_DISABLED)&(pData->uStyle^WS_DISABLED);
				SetWindowLong(hWnd,GWL_STYLE,uVal);
				}

			return 0;

	case WM_SETFOCUS:											// Das Fenster bekommt den Fokus

				pData = GetHandle(hWnd);
			if(!pData->cHasFocus)
				{
				NMHDR	sNotify;

				LOCK(pData);
				pData->cHasFocus=1;

				if(pData->uSelectedCount<=1)
					{
					if(pData->uSelectedItem<pData->uListItemsCount)
						{
						if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
								UpdateRows(pData,pData->uSelectedItem);
						else	UpdateRect(pData,pData->uSelectedItem,pData->uSelectedSub);
						}
					}
				else{
					UpdateView(pData);
					}

				UNLOCK(pData);

				sNotify.code = NM_SETFOCUS;
				SendNotify(pData,&sNotify);
				}

			return 0;

	case WM_KILLFOCUS:											// Das Fenster bekommt den Fokus

			   pData = GetHandle(hWnd);
			if(pData->cHasFocus)
				{
				NMHDR	sNotify;

				LOCK(pData);
				pData->cHasFocus=0;

				if(pData->uSelectedCount<=1)
					{
					if(pData->uSelectedItem<pData->uListItemsCount)
						{
						if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
								UpdateRows(pData,pData->uSelectedItem);
						else	UpdateRect(pData,pData->uSelectedItem,pData->uSelectedSub);
						}
					}
				else{
					UpdateView(pData);
					}

				UNLOCK(pData);

				sNotify.code = NM_KILLFOCUS;
				SendNotify(pData,&sNotify);
				}

			return 0;

	case WM_MOUSELEAVE:											// Die Maus hat das Fenster verlassen

			GetCursorPos(&sPoint);
			ScreenToClient(hWnd,&sPoint);
			lParam = MAKELONG(sPoint.x,sPoint.y);
			wParam = 0x00000000;

	case WM_MOUSEMOVE:											// Gab es eine Mausbewegung

			pData = GetHandle(hWnd);
			LOCK(pData);

			sInfo.iSubItem	=-1;
			sInfo.iItem		= 0;
			sInfo.flags		= 0;

			if(!(pData->uStyleEx&LVS_EX_NOTOOLTIPS))
				{
				if(pData->cIsEnabled)							// Ist das Fenster freigegeben
					{
					sInfo.pt.x	= GET_X_LPARAM(lParam);
					sInfo.pt.y	= GET_Y_LPARAM(lParam);
					FastListHitTest(pData,&sInfo);
					UpdateToolTip(pData,sInfo.iItem,sInfo.iSubItem,sInfo.flags);
					}
				else if(pData->uToolTipItem!=0xFFFFFFFF)
					{
					UpdateToolTip(pData,0xFFFFFFFF,0,0);
					}
				}

			if(pData->uStyleEx&LVS_EX_TRACKSELECT)
				{
				if(pData->cIsEnabled)							// Ist das Fenster freigegeben
					{
					if(sInfo.iSubItem==-1)
						{
						sInfo.pt.x	= GET_X_LPARAM(lParam);
						sInfo.pt.y	= GET_Y_LPARAM(lParam);
						FastListHitTest(pData,&sInfo);
						}

					if(sInfo.iItem && (sInfo.flags&(LVHT_ONSUBITEM|LVHT_ONITEM)))
						{
						FastListSetTrackItem(pData,sInfo.iItem,sInfo.iSubItem);
						}
					else if(pData->uTrackedItem!=0xFFFFFFFF)
						{
						FastListSetTrackItem(pData,0xFFFFFFFF,0);
						}
					}
				else if(pData->uTrackedItem!=0xFFFFFFFF)
					{
					FastListSetTrackItem(pData,0xFFFFFFFF,0);
					}
				}

			if(pData->hStates==THEMEIMGLIST)				// Mit Thema zeichnen
			if(pData->uStyleEx&LVS_EX_CHECKBOXES)			// Ist Cursor ber Checkbox
				{
				if(sInfo.iSubItem==-1)
					{
					sInfo.pt.x	= GET_X_LPARAM(lParam);
					sInfo.pt.y	= GET_Y_LPARAM(lParam);
					FastListHitTest(pData,&sInfo);
					}

				if(U(sInfo.iItem)!=0xFFFFFFFF && (sInfo.flags&LVHT_ONITEMSTATEICON))
					{
					if(U(sInfo.iItem)!=pData->uCheckedItem || pData->uCheckedSub)
						{
						if(pData->uCheckedItem==0xFFFFFFFF)
							{
							TRACKMOUSEEVENT sEvent;

							sEvent.cbSize		= sizeof(TRACKMOUSEEVENT);
							sEvent.dwFlags		= TME_LEAVE;
							sEvent.hwndTrack	= pData->hWnd;

							_TrackMouseEvent(&sEvent);
							}

						UpdateRect(pData,pData->uCheckedItem,pData->uCheckedSub);
						pData->uCheckedDown = U(wParam)&MK_LBUTTON;
						pData->uCheckedItem = sInfo.iItem;
						pData->uCheckedSub	= 0;
						UpdateRect(pData,sInfo.iItem,0);
						}
					}
				else{
					if(pData->uCheckedItem!=0xFFFFFFFF)
						{
						UpdateRect(pData,pData->uCheckedItem,pData->uCheckedSub);
						pData->uCheckedItem = 0xFFFFFFFF;
						pData->uCheckedDown = 0;
						pData->uCheckedSub	= 0;
						}
					}
				}

			if(pData->hChecks==THEMEIMGLIST)					// Checkboxen in Unterspalten
				{
				sInfo.pt.x	= GET_X_LPARAM(lParam);
				uSub		= pData->aColumnPos[1];
				iPos		= pData->aColumnXpos[uSub];
				uFlag		= 0;

				if(sInfo.pt.x>=iPos)							// Cursor auf Extraeintrag
					{
					if(sInfo.iSubItem==-1)
						{
						sInfo.pt.y	= GET_Y_LPARAM(lParam);
						FastListHitTest(pData,&sInfo);
						}

																// Checkboxen statt Icons
					if(U(sInfo.iItem)!=0xFFFFFFFF && (sInfo.flags&LVHT_ONSUBICON))
						{
						uSub = LVHT_SUBTOCOL(sInfo.flags);

						if(pData->aColumn[uSub].bEdit>=LVAX_CHECK)
							{
							uFlag = 1;

							if(U(sInfo.iItem)!=pData->uCheckedItem || pData->uCheckedSub!=uSub)
								{
								if(pData->uCheckedItem==0xFFFFFFFF)
									{
									TRACKMOUSEEVENT sEvent;

									sEvent.cbSize		= sizeof(TRACKMOUSEEVENT);
									sEvent.dwFlags		= TME_LEAVE;
									sEvent.hwndTrack	= pData->hWnd;

									_TrackMouseEvent(&sEvent);
									}

								UpdateRect(pData,pData->uCheckedItem,pData->uCheckedSub);
								pData->uCheckedDown = U(wParam)&MK_LBUTTON;
								pData->uCheckedItem = sInfo.iItem;
								pData->uCheckedSub	= uSub;
								UpdateRect(pData,sInfo.iItem,uSub);
								}
							}
						}
					}

				if(!uFlag && pData->uCheckedItem!=0xFFFFFFFF && pData->uCheckedSub)
					{
					UpdateRect(pData,pData->uCheckedItem,pData->uCheckedSub);
					pData->uCheckedDown = 0;
					pData->uCheckedItem = 0;
					pData->uCheckedSub	= 0;
					}
				}

			if(  wParam & pData->uDragFlags & MK_LBUTTON)		// Drag beginnen
			if(U(lParam)!=pData->uLastMove )
				{
				NMLISTVIEW	sNotify;
				int			iDiffX;
				int			iDiffY;

				iDiffX = (short)(lParam    )-(short)(pData->uLastMove    );
				iDiffY = (short)(lParam>>16)-(short)(pData->uLastMove>>16);

				if(iDiffX<0)iDiffX=-iDiffX;
				if(iDiffY<0)iDiffY=-iDiffY;

				if(iDiffX<=2 && iDiffY<=2)						// Mehr als zwei Pixel-Verschub
					{
					UNLOCK(pData);
					return 0;
					}


				if(pData->uDragItem>=pData->uListItemsCount)
					{
					UNLOCK(pData);
					return 0;
					}

				pEntry = pData->pListItems+pData->uDragItem;

				sNotify.hdr.code		= LVN_BEGINDRAG;
				sNotify.iItem			= pData->uDragItem;
				sNotify.iSubItem		= pData->uDragSub;
				sNotify.uNewState		= pEntry->uState;
				sNotify.uOldState		= pEntry->uState;
				sNotify.lParam			= pEntry->lParam;
				sNotify.uChanged		= 0;
				sNotify.ptAction.x		= GET_X_LPARAM(lParam);
				sNotify.ptAction.y		= GET_Y_LPARAM(lParam);
				pData->uDragFlags		= 0;
				pData->cClickFlag		= 0;
				pData->cClickEdit		= 0;

				pData->uLastMove = U(lParam);

				UNLOCK(pData);

				SendNotify(pData,&sNotify.hdr);

				return 0;
				}


			pData->uLastMove = U(lParam);

			UNLOCK(pData);
			return 0;

	case WM_LBUTTONUP:											// Linken Mausklick aufheben

			pData = GetHandle(hWnd);
			pData->uDragFlags &= ~MK_LBUTTON;

			if(pData->cClickFlag || pData->cClickEdit)
				{
				LOCK(pData);
				FastListMouseClick(pData,uMsg,wParam,lParam);
				pData->cClickFlag = 0;
				pData->cClickEdit = 0;
				}

			if(pData->uCheckedDown)								// Checkbox neu zeichnen
				{
				pData->uCheckedDown = 0;

				if(pData->uCheckedItem!=0xFFFFFFFF)
					{
					UpdateRect(pData,pData->uCheckedItem,pData->uCheckedSub);
					}
				}

			return 0;

	case WM_LBUTTONDOWN:										// Mausklick

			pData = GetHandle(hWnd);

			LOCK(pData);

			uTime = GetTickCount();

			if(pData->cButtonFlag && pData->uToolTipItem)		// Doppelklick simulieren ber ToolTip
				{
				pData->cButtonFlag = 0;
				uDelta = uTime-pData->uButtonLast;

				if(uDelta<700)
					{
					iPos  = abs(GET_X_LPARAM(lParam)-GET_X_LPARAM(pData->uButtonPos));
					iPos += abs(GET_Y_LPARAM(lParam)-GET_Y_LPARAM(pData->uButtonPos));

					if(iPos<=6)
						{
						FastListMouseClick(pData,WM_LBUTTONDBLCLK,wParam,lParam);
						return 0;
						}
					}
				}

			pData->cButtonFlag = 1;
			pData->uButtonLast = uTime;
			pData->uButtonPos  = U(lParam);

			FastListMouseClick(pData,uMsg,wParam,lParam);

			return 0;

	case WM_RBUTTONUP:											// Rechten Mausklick aufheben

			pData = GetHandle(hWnd);
			pData->uDragFlags &= ~MK_RBUTTON;
			break;

	case WM_LBUTTONDBLCLK:										// Notify fr Mausklicks
	case WM_RBUTTONDBLCLK:
	case WM_RBUTTONDOWN:

			pData	= GetHandle(hWnd);
			LOCK(pData);

			pData->cButtonFlag = 0;
			FastListMouseClick(pData,uMsg,wParam,lParam);
			return 0;

	case WM_KEYDOWN:											// Tastendruck

			pData	= GetHandle(hWnd);
			LOCK(pData);
			FastListKeyDown(pData,wParam,lParam);
			return 0;

	case WM_KEYUP:												// Tastendruck

			DefWindowProc(hWnd,uMsg,wParam,lParam);
			return 1;

	case WM_CHAR:												// Zeicheneingabe

			pData	= GetHandle(hWnd);
			iMax	= lParam&0xFFFF;

			LOCK(pData);

			for(iPos=0;iPos<iMax;iPos++)
				{
				FastListChar(pData,(UINT)wParam,lParam);
				}

			UNLOCK(pData);
			return 0;

	case WM_SETREDRAW:											// Das Zeichnen sperren

			pData	= GetHandle(hWnd);

			LOCK(pData);

			if(U(wParam)==0)
				{
				pData->cRedrawFlag = 1;
				UNLOCK(pData);
				break;
				}
			else if(pData->cRedrawFlag==0)
				{
				UNLOCK(pData);
				break;
				}

			pData->cRedrawFlag = 0;

			UNLOCK(pData);

			lRet = DefWindowProc(hWnd,uMsg,wParam,lParam);

			UpdateView      (pData);
			UpdateHeader    (pData);
			UpdateScrollBars(pData);

			return lRet;


	case WM_DRAWITEM:											// Weietleiten von OwnerDraw des Headers

			if(wParam==1)
				{
				pData	= GetHandle(hWnd);
				return SendMessage(GetParent(hWnd),uMsg,GetWindowLong(hWnd,GWL_ID),lParam);
				}

			return 0;

	case WM_MOUSEWHEEL:											// Scrollen mit dem Mausrad

			if(!(LOWORD(wParam)&(MK_LBUTTON|MK_MBUTTON|MK_RBUTTON)))
				{
				pData = GetHandle(hWnd);

				if(pData->uEditItem!=0xFFFFFFFF)return 0;

				iDif  =	(short)HIWORD(wParam)/(WHEEL_DELTA/2);

				if(wParam&MK_CONTROL)
					{
					iDif *= 9;
					}
				else if(wParam&MK_SHIFT)
					{
					iDif *= 3;
					}

				iPos  = pData->uScrollY-iDif;

				LOCK(pData);
				FastListScrollY(pData,iPos,SB_MOUSEWHEEL);
				UNLOCK(pData);

				return 1;
				}

			return 0;

	case WM_HSCROLL:											// Vertikales scrollen

			pData	= GetHandle(hWnd);
			iPos	= pData->uScrollX;

			if(pData->uEditItem!=0xFFFFFFFF)return 0;

			switch(U(wParam)&0x0F)
				{
			case SB_LINEDOWN:		iPos+=16;				break;
			case SB_LINEUP:			iPos-=16;				break;
			case SB_PAGEDOWN:		iPos+=pData->uSizeX;	break;
			case SB_PAGEUP:			iPos-=pData->uSizeX;	break;
			case SB_THUMBPOSITION:	iPos =HIWORD(wParam);  	break;
			case SB_THUMBTRACK:		iPos =HIWORD(wParam);  	break;
			case SB_THUMBTRACKEX:	iPos =U(wParam)>>4;		break;
				}

			   uVal = pData->uColumnCount;
			if(uVal)iMax  = pData->aColumnXpos[uVal]-pData->uSizeX/2;
			else	iMax  = pData->iMaxSizeX;
					iMax -=	pData->uSizeX/2;

			if(iPos>=iMax)iPos=iMax;
			if(iPos<0)iPos=0;
			if(iPos!=(int)pData->uScrollX)
				{
				LOCK(pData);
				FastListScrollX(pData,iPos,LOWORD(wParam));
				UNLOCK(pData);
				}

			return 0;

	case WM_VSCROLL:											// Vertikales scrollen

			pData	= GetHandle(hWnd);
			iPos	= pData->uScrollY;

			if(pData->uEditItem!=0xFFFFFFFF)return 0;

			switch(U(wParam)&0x0F)
				{
			case SB_LINEDOWN:		iPos++;													break;
			case SB_LINEUP:			iPos--;													break;
			case SB_PAGEDOWN:		iPos+=(pData->uPageEnties>1)? pData->uPageEnties-1:1;	break;
			case SB_PAGEUP:			iPos-=(pData->uPageEnties>1)? pData->uPageEnties-1:1;	break;
			case SB_THUMBTRACKEX:	iPos =U(wParam)>>4;										break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:		if(pData->uListItemsCount<0x7F00)
										{
										iPos = HIWORD(wParam);
										}
									else{
										sScroll.cbSize = sizeof(SCROLLINFO);
										sScroll.fMask  = SIF_TRACKPOS;
										GetScrollInfo(hWnd,SB_VERT,&sScroll);
										iPos = sScroll.nTrackPos;
										}
				}

			iMax  = pData->uListItemsCount;
			iMax -=	pData->uPageEnties-1;

			if(iPos>=iMax)iPos=iMax;
			if(iPos<0)iPos=0;
			if(iPos!=(int)pData->uScrollY)
				{
				LOCK(pData);
				FastListScrollY(pData,iPos,LOWORD(wParam));
				UNLOCK(pData);
				}

			return 0;

	case WM_SYSCOLORCHANGE:										// Wurden die Systemfarben verndert

			pData = GetHandle(hWnd);
			LOCK(pData);

			if(pData->hThemeBt)
				{
				pCloseThemeData(pData->hThemeBt);
				pData->hThemeBt = NULL;
				}

			if(pData->cStatesMode)CreateStateImageList(pData,0);
			if(pData->cChecksMode)CreateStateImageList(pData,1);

			if(pData->hHeader)SendMessage(pData->hHeader,WM_SYSCOLORCHANGE,0,0);

			UpdateColors(pData);
			UNLOCK(pData);
			return 0;

	case WM_GETFONT:											// Aktuellen Font abfragen

			pData = GetHandle(hWnd);
			return (LRESULT)pData->hFontN;

	case WM_SETFONT:											// Einen neuen Font zuweisen

			pData = GetHandle(hWnd);
			LOCK(pData);

			pData->hFontN=(HFONT)wParam;
			if(UpdateFont(pData))
				{
				UpdateHeight(pData);
				UpdateView  (pData);
				}

			UNLOCK(pData);
			return 0;

	case WM_STYLECHANGED:										// Hat sich der Fensterstil gendert

			if(wParam==GWL_STYLE)
				{
				pData	= GetHandle(hWnd);
				lParam	= ((STYLESTRUCT*)lParam)->styleNew;

				LOCK(pData);
				uChange		   = U(lParam)^pData->uStyle;
				pData->uStyle  = U(lParam);

				if(uChange&LVS_NONEVENHEIGHT)
					{
					UpdateScrollY(pData);
					}

				if(uChange&LVS_SINGLESEL)
					{
					UpdateView(pData);
					}

  				if((uChange&LVS_NOCOLUMNHEADER) && pData->hHeader)
					{
					pData->uStartPixel  = (pData->uStyle&LVS_NOCOLUMNHEADER)? 0:GetSystemMetrics(SM_CYHSCROLL);
					pData->uStartPixel +=  pData->uStartOffset;
					MoveWindow(pData->hHeader,-(int)pData->uScrollX,0,pData->uSizeX+pData->uScrollX,pData->uStartPixel-pData->uStartOffset,TRUE);
					UpdateView(pData);

					if(pData->uStartOffset)						// Gre des Startbereiches verndert
						{
						LV_STARTSIZE	sNotify;

						sNotify.hdr.code = LVN_STARTCHANGED;
						sNotify.iSizeX	 = pData->uSizeX;
						sNotify.iSizeY	 = pData->uStartOffset;
						sNotify.iOffset	 = pData->uStartPixel-pData->uStartOffset;

						SendNotify(pData,&sNotify.hdr);
						}
					}

				if(uChange&LVS_NOSCROLL)
					{
					pData->uOldCountY = 0xFFFF;
					pData->uOldCountX = 0xFFFF;

					if(!(pData->uStyle&LVS_NOSCROLL))
						{
						sScroll.cbSize		= sizeof(SCROLLINFO);
						sScroll.fMask		= SIF_RANGE|SIF_PAGE;
						sScroll.nMin		= 0;
						sScroll.nMax  		= 100;
						sScroll.nPage 		= 10;

						UNLOCK(pData);							// WIN-BUG: Die Scrollbar muss an sein fr SIF_DISABLENOSCROLL
						SetScrollInfo(pData->hWnd,SB_VERT,&sScroll,TRUE);
						SetScrollInfo(pData->hWnd,SB_HORZ,&sScroll,TRUE);
						LOCK(pData);

						pData->uOldPageX   ^= 0x1234567;
						pData->uOldPageY   ^= 0x1234567;
						}

					UpdateScrollX(pData);
					UpdateScrollY(pData);
					}

				if(uChange&WS_DISABLED)
					{
					pData->cIsEnabled=(char)((pData->uStyle&WS_DISABLED)? 0:1);
					UpdateView(pData);
					if(!pData->cIsEnabled)UpdateToolTip(pData,0xFFFFFFFF,0,0);
					}

				UNLOCK(pData);
				}

			return 0;

	case WM_PAINT:												// Das Fenster zeichnen

			if(wParam)
				{
				FastListDraw(hWnd,(HDC)wParam,NULL);
				}
			else{
				PAINTSTRUCT sPaint;

				hDc = BeginPaint(hWnd,&sPaint);

				if(pBeginBufferedPt && pEndBufferedPt)
					{
					HDC		hDcBuffer;
					HANDLE	hBufferedPaint;

					GetClientRect(hWnd,&sRect);
					hBufferedPaint = pBeginBufferedPt(hDc,&sRect,BPBF_COMPATIBLEBM,NULL,&hDcBuffer);

					if(hBufferedPaint)
						{
						FastListDraw(hWnd,hDcBuffer,&sRect);
						pEndBufferedPt(hBufferedPaint,TRUE);
						}
					else{
						FastListDraw(hWnd,hDc,&sRect);
						}
					}
				else{
					FastListDraw(hWnd,hDc,&sPaint.rcPaint);
					}

				EndPaint(hWnd,&sPaint);
				}

			return 0;

	case WM_TIMER:												// Timer Funktion

			if(wParam==ID_UPDATE)
				{
				pData = GetHandle(hWnd);
				LOCK(pData);
				cOld  = pData->cUpdateFlag;
				pData->cUpdateFlag = 0;

				if(pData->cFastFlag)
					{
					pData->cUpdateTimer   = 2;
					pData->cFastFlag	  = 0;
					pData->cUpdateScrollY = 1;
					pData->uScrollY		  = pData->uScrollYtmp;
					}

				if(pData->uUpdateTip)
					{
					UpdateToolTip(pData,pData->uToolTipItem,pData->uToolTipSub,pData->uUpdateTip);
					pData->cUpdateTimer   = 2;
					pData->uUpdateTip	  = 0;
					}

				if(pData->uUpdateEnsure!=0xFFFFFFFF)
					{
					FastListEnsureVisible(pData,pData->uUpdateEnsure,pData->uUpdateEnSub,pData->uUpdateEnMode);
					pData->uUpdateEnsure  = 0xFFFFFFFF;
					pData->cUpdateTimer   = 2;
					}

				if(pData->cUpdateScrollY)
					{
					pData->cUpdateTimer   = 2;
					UpdateScrollY(pData);
					}

				if(pData->cUpdateScrollX)
					{
					pData->cUpdateTimer   = 2;
					UpdateScrollX(pData);
					}

				if(pData->cUpdateView)
					{
					pData->cUpdateRows	  = 0;
					pData->cUpdateView    = 0;
					pData->cUpdateTimer   = 2;
					GetClientRect (pData->hWnd,&sRect);
					sRect.top =    pData->uStartPixel;
					InvalidateRect(pData->hWnd,&sRect,TRUE);
					}

				if(pData->cUpdateRows)
					{
					pData->cUpdateRows    = 0;
					pData->cUpdateTimer   = 2;
					iDif = pData->uUpdateEnd-pData->uUpdateRow;
					UpdateRows(pData,pData->uUpdateRow,iDif);
					}

				if(pData->cUpdateResel)							// Auswahl neu berechnen
					{
					LV_RESELECT	sNotify;

					pData->cUpdateTimer		= 2;
					pData->cUpdateResel		= 0;
					pData->uSelectedCount	= 0;

					uItem	= pData->uListItemsCount;
					pEntry	= pData->pListItems+uItem;

					for(;uItem>0;uItem--)						// Zhle selektierte Eintrge
						{
						pEntry--;

						if(!(pEntry->uState&LVIS_SELECTED))
							{
							continue;
							}

						   pData->uSelectedCount++;
						if(pData->uSelectedItem==0xFFFFFFFF)
							{
							pData->uSelectedItem = uItem;
							}
						}

 					sNotify.hdr.code	= LVN_RESELECT;
					sNotify.uCount		= pData->uSelectedCount;
					sNotify.iSelected	= pData->uSelectedItem;

					UNLOCK(pData);
					SendNotify(pData,&sNotify.hdr);
					LOCK(pData);
					}

				if(pData->cUpdateItems)
					{
					unsigned	uItem;

					pData->cUpdateItems	  = 0;
					pData->cUpdateTimer   = 2;

					uItem	= pData->uListItemsCount;
					pEntry	= pData->pListItems+uItem;

					for(;uItem>0;uItem--)						// Zhle selektierte Eintrge
						{
						pEntry--;

						if(pEntry->bFlags&LVIX_UPDATE)
							{
							pEntry->bFlags &= ~LVIX_UPDATE;
							FastListSelectItem(pData,uItem,0,0);
							}
						}
					}

				if(cOld)										// Zulange Sperren verhintern
					{
					   pData->cUpdateTimer++;
					if(pData->cUpdateTimer>5)
						{
						cOld = 0;
						}
					}

				pData->cUpdateFlag = cOld;
				UNLOCK(pData);
				return 0;
				}

			if(wParam==ID_TOOLTIPCHECK)
				{
				   pData	= GetHandle(hWnd);
				if(pData->uToolTipItem!=0xFFFFFFFF)
					{
					HWND	hTop;

					GetCursorPos(&sPoint);

					sInfo.pt.x = sPoint.x;
					sInfo.pt.y = sPoint.y;

					ScreenToClient(hWnd,&sInfo.pt);
					hTop = WindowFromPoint(sPoint);
																// Ist ein anderes Fenster dazwischen
					if(hTop && hTop!=hWnd && hTop!=pData->hToolTip)
						{
						LOCK(pData);
						UpdateToolTip(pData,0xFFFFFFFF,0,0);
						UNLOCK(pData);
						return 0;
						}

					if(pData->uToolTipShow)						// Verzgertes einblenden
						{
						   pData->uToolTipShow--;
						if(pData->uToolTipShow)return 0;

						LOCK(pData);

						FastListHitTest(pData,&sInfo);

						if(sInfo.flags&LVHT_ONITEM)
						if(pData->uToolTipItem==U(sInfo.iItem))
						if(pData->uToolTipSub ==0)
							{
							TOOLINFO sInfo;

							UNLOCK(pData);

							sInfo.cbSize	= sizeof(sInfo);
							sInfo.hwnd		= pData->hWnd;
							sInfo.uId		= (UINT_PTR)pData->hWnd;

							if(pData->uToolTipItem!=0xFFFFFFFF)
								{
								SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,0,(LPARAM)&sInfo);
								}

							SendMessage(pData->hToolTip,TTM_TRACKPOSITION,0,MAKELONG(pData->sToolTipPos.x,pData->sToolTipPos.y));
							SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,1,(LPARAM)&sInfo);

							CheckToolTipPos(pData);

							return 0;
							}

						if(sInfo.flags&LVHT_ONSUBITEM)
						if(pData->uToolTipItem==U(sInfo.iItem) && U(sInfo.iSubItem)==pData->uToolTipSub)
							{
							TOOLINFO sInfo;

							UNLOCK(pData);

							sInfo.cbSize	= sizeof(sInfo);
							sInfo.hwnd		= pData->hWnd;
							sInfo.uId		= (UINT_PTR)pData->hWnd;

							if(pData->uToolTipItem!=0xFFFFFFFF)
								{
								SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,0,(LPARAM)&sInfo);
								}

							SendMessage(pData->hToolTip,TTM_TRACKPOSITION,0,MAKELONG(pData->sToolTipPos.x,pData->sToolTipPos.y));
							SendMessage(pData->hToolTip,TTM_TRACKACTIVATE,1,(LPARAM)&sInfo);

							CheckToolTipPos(pData);

							return 0;
							}

																// ToolTip wieder entfernen
						UpdateToolTip(pData,sInfo.iItem,sInfo.iSubItem,sInfo.flags);
						UNLOCK(pData);
						}

					LOCK(pData);

					GetCursorPos(&sInfo.pt);
					ScreenToClient(hWnd,&sInfo.pt);
					FastListHitTest(pData,&sInfo);
					UpdateToolTip(pData,sInfo.iItem,sInfo.iSubItem,sInfo.flags);

					UNLOCK(pData);
					}
				}

			return 0;

	case WM_COMMAND:											// Kommando Nachrichten

			if(LOWORD(wParam)==3)
				{
				uVal = HIWORD(wParam);

				if(uVal==EN_KILLFOCUS || uVal==EN_RETURN || uVal==CBN_KILLFOCUS)
					{
					   pData = GetHandle(hWnd);
					if(pData->uEditItem!=0xFFFFFFFF)
						{
						LOCK(pData);
						FastListEndLabelEdit(pData,(uVal==EN_RETURN)? 2:1);
						UNLOCK(pData);
						if(pData->uEditMode)
						if(wParam!=MAKELONG(3,EN_KILLFOCUS))
							{
							SetFocus(pData->hWnd);
							}
						}
					}
				else if(uVal==EN_ESCAPE)						// ESC-Taste in Edit-Fenster
					{
					   pData = GetHandle(hWnd);
					if(pData->uEditItem!=0xFFFFFFFF)
						{
						LOCK(pData);
						FastListEndLabelEdit(pData,0);
						UNLOCK(pData);
						if(pData->uEditMode)SetFocus(pData->hWnd);
						}
					}											// nderung in Edit-Fenster
				else if(uVal==EN_CHANGE || uVal==CBN_EDITCHANGE || uVal==CBN_SELCHANGE || uVal==EN_SETTEXT)
					{
					pData = GetHandle(hWnd);
					pData->cColumnStart = 1;
					}
				}
			else{												// Andere Nachrichten an Elternfenster weiterleiten
				return SendMessage(GetParent(hWnd),WM_COMMAND,wParam,lParam);
				}

			return 0;

	case WM_NOTIFY:												// Notify Nachrichten

			if(wParam==1)										// Header-Control
				{
				NMHEADER   *pHdr=(NMHEADER*)lParam;
				HDITEM		sItem;
				HDITEM		sTemp;
				int			iDelta;
				int			iCode;
				int			iSize;
				int			iNext;
				int			iCol;
				int			iSub;

				iCode = pHdr->hdr.code;

				if(iCode==HDN_ITEMCHANGED && (pHdr->pitem->mask&HDI_WIDTH))
					{
					pData	= GetHandle(hWnd);
					iCol	= pHdr->iItem;

					if(pData->aColumn[iCol].sReal!=pHdr->pitem->cxy)
						{
						iCode = HDN_TRACK;
						}
					}

				if(iCode==HDN_BEGINDRAG)						// Drag&Drop im Header
					{
					pData	= GetHandle(hWnd);

					if(!(pData->uStyleEx&LVS_EX_HEADERDRAGDROP))
						{
						return 1;
						}

					return 0;
					}

				if(iCode==HDN_ENDDRAG)							// Drag&Drop im Header fertig
					{
					pData	= GetHandle(hWnd);

					if(!(pData->uStyleEx&LVS_EX_HEADERDRAGDROP))
						{
						return 1;
						}

					PostMessage(hWnd,LVM_SETCOLUMNORDERARRAY,FROM_HEADER,0);

					return 0;
					}

				if(iCode==HDN_BEGINTRACK)
					{
					pData	= GetHandle(hWnd);

					if(!pData->cHasFocus)
						{
						SetFocus(pData->hWnd);
						}

					if(pData->uStyleEx&LVS_EX_NOCOLUMNRESIZE)	// Darf der User die Spaltenbreite ndern
						{
						return 1;
						}

					if(pData->uStyleEx&LVS_EX_FIXEDCOLSIZE)		// Fixe gesammte Spaltenbreite
						{
						iNext = pData->aColumn[pHdr->iItem].bIndex;

						for(iNext++;;iNext++)					// Suche nchste vernderbare Spalte
							{
							if(U(iNext)>=pData->uColumnCount)
								{
								return 1;
								}

							iSub = pData->aColumnPos[iNext];

							if(pData->aColumn[iSub].sFixed==0)
								{
								break;
								}
							}
						}

					if(U(pHdr->iItem)<pData->uColumnCount)		// Darf die Spalte verndert werden
					if(pData->aColumn[pHdr->iItem].sFixed)
						{
						POINT	sPoint;
						int		iCol;
						int		iSub;

						if(pData->aColumn[pHdr->iItem].sReal)
							{
							return 1;
							}

						GetCursorPos(&sPoint);					// Die nchste vernderbare Spalte greifen
						ScreenToClient(pData->hHeader,&sPoint);

						PostMessage(pData->hHeader,WM_LBUTTONUP,0,MAKELONG(sPoint.x,sPoint.y));

						iCol = pData->aColumn[pHdr->iItem].bIndex;
						iSub = pData->aColumnPos[iCol-1];

						PostMessage(pData->hHeader,WM_LBUTTONDOWN,0,MAKELONG(pData->aColumnXpos[iSub+1]-2,sPoint.y));

						return 1;
						}
					}

				if(iCode==HDN_DIVIDERDBLCLICK)					// Doppelklick auf Spaltentrenner
					{
					pData	= GetHandle(hWnd);

					if(!pData->cHasFocus)
						{
						SetFocus(pData->hWnd);
						}

					if(pData->uStyleEx&LVS_EX_NOCOLUMNRESIZE)	// Darf der User die Spaltenbreite ndern
						{
						return 0;
						}

					if(U(pHdr->iItem)<pData->uColumnCount)		// Darf die Spalte verndert werden
					if(pData->aColumn[pHdr->iItem].sFixed)
						{
						return 0;
						}

					LOCK(pData);

					   iSize=FastListScanColumn(pData,pHdr->iItem,pData->uScrollY-512,pData->uScrollY+1024);
					if(iSize)									// Spalte auf maximale Textbreite
						{
						sItem.cxy	= iSize;
						pHdr->pitem	= &sItem;
						iCode		= HDN_ENDTRACK;

						if(pData->aColumn[pHdr->iItem].bMinEx)	// Minimale Breite prfen
						if(pData->aColumn[pHdr->iItem].sMin>sItem.cxy)
							{
							sItem.cxy	 = pData->aColumn[pHdr->iItem].sMin;
							}
						}

					UNLOCK(pData);
					}

				if(iCode==HDN_TRACK || iCode==HDN_ENDTRACK)		// Wurde die Spaltenbreite verndert
					{
					pData	= GetHandle(hWnd);

					if(!pData->cHasFocus && iCode==HDN_ENDTRACK)
						{
						SetFocus(pData->hWnd);
						}

					LOCK(pData);

					iCol		= pHdr->iItem;
					sItem.mask	= HDI_WIDTH;
					sItem.cxy	= pHdr->pitem->cxy;

					if(pData->aColumn[iCol].bMinEx)				// Minimale Breite prfen
					if(pData->aColumn[iCol].sMin>sItem.cxy)
						{
						sItem.cxy		 = pData->aColumn[iCol].sMin;
						pHdr->pitem->cxy = sItem.cxy;

						if(sItem.cxy==pData->aColumn[iCol].sSize)
							{
							UNLOCK(pData);
							return 0;
							}
						}

					if(pData->uStyleEx&LVS_EX_FIXEDCOLSIZE)		// Fixe gesammte Spaltenbreite
						{
						if(iCol==0 && sItem.cxy<=0)
							{
							sItem.cxy		 = 1;
							pHdr->pitem->cxy = 1;

							if(sItem.cxy==pData->aColumn[iCol].sSize)
								{
								UNLOCK(pData);
								return 0;
								}
							}

						iNext = pData->aColumn[iCol].bIndex;

						for(iNext++;;iNext++)					// berspringe fixierte Spalten
							{
							if(U(iNext)>=pData->uColumnCount)
								{
								UNLOCK(pData);
								return 0;
								}

							iSub = pData->aColumnPos[iNext];

							if(pData->aColumn[iSub].sFixed==0)
								{
								break;
								}
							}

						iDelta    = pData->aColumn[iCol].sReal-sItem.cxy;
						sTemp.cxy = pData->aColumn[iSub].sReal+iDelta;


						if(iDelta<0)							// Nchste Spalte wird zu klein
							{
							if(sTemp.cxy<0)
								{
								sTemp.cxy  =  0;
								iDelta     = -pData->aColumn[iSub].sReal;
								sItem.cxy  =  pData->aColumn[iCol].sReal-iDelta;
								}

							if(pData->aColumn[iSub].bMinEx)		// Minimale Breite prfen
							if(pData->aColumn[iSub].sMin>sTemp.cxy)
								{
								iDelta    +=  pData->aColumn[iSub].sMin-sTemp.cxy;
								sTemp.cxy  =  pData->aColumn[iSub].sMin;
								sItem.cxy  =  pData->aColumn[iCol].sReal-iDelta;
								}

							pHdr->pitem->cxy = sItem.cxy;

							if(iDelta>=0)						// Keine nderung
								{
								UNLOCK(pData);
								return 0;
								}
							}

						if(pData->aColumn[iSub].bWeight)		// Variable Spalte
							{
							pData->iVarSize -= pData->aColumn[iSub].sSize;
							pData->iVarSize += sTemp.cxy;
							}
						else{									// Fixe Spalte
							pData->iFixSize -= pData->aColumn[iSub].sSize;
							pData->iFixSize += sTemp.cxy;
							}

						sTemp.mask	= HDI_WIDTH;

						iDif						= pData->aColumn[iSub].sReal;
						pData->aColumn[iSub].sSize = (short)sTemp.cxy;
						pData->aColumn[iSub].sReal = (short)sTemp.cxy;
						Header_SetItem(pData->hHeader,iSub,&sTemp);

																// Breite verndert
						if(iDif!=sTemp.cxy && (pData->uStyleEx&LVS_EX_HEADERCHGNOTIFY))
							{
							LV_COLSIZE	sNotify;

 							sNotify.hdr.code			= LVN_COLUMNCHANGED;
							sNotify.uColumn				= iNext;
							sNotify.uIndex				= pData->aColumn[iSub].bIndex;
							sNotify.uPosX				= pData->aColumnXpos[iSub];
							sNotify.iSize				= sTemp.cxy;

							UNLOCK(pData);
							SendNotify(pData,&sNotify.hdr);
							LOCK(pData);
							}
						}


					if(pData->aColumn[iCol].bWeight)			// Ist es eine variable Spalte
						{
						pData->iVarSize -= pData->aColumn[iCol].sSize;
						pData->iVarSize += sItem.cxy;
						}
					else{										// Fixe Spalte
						pData->iFixSize -= pData->aColumn[iCol].sSize;
						pData->iFixSize += sItem.cxy;
						}

					iDif					   = pData->aColumn[iCol].sReal;
					pData->aColumn[iCol].sSize = (short)sItem.cxy;
					pData->aColumn[iCol].sReal = (short)sItem.cxy;
					Header_SetItem(pData->hHeader,iCol,&sItem);

					   iSize = UpdateColumns(pData);
					if(iSize<0x10000)							// Spalten neu zeichnen
						{
						GetClientRect (hWnd,&sRect);
						sRect.left  = iSize;
						sRect.left -= pData->uScrollX;
						InvalidateRect(hWnd,&sRect,FALSE);
						}

					UpdateScrollX(pData);
					UNLOCK(pData);
																// Breite verndert
					if(iDif!=sItem.cxy && (pData->uStyleEx&LVS_EX_HEADERCHGNOTIFY))
						{
						LV_COLSIZE	sNotify;

 						sNotify.hdr.code	= LVN_COLUMNCHANGED;
						sNotify.uColumn		= iCol;
						sNotify.uIndex		= pData->aColumn[iCol].bIndex;
						sNotify.uPosX		= pData->aColumnXpos[iCol];
						sNotify.iSize		= sItem.cxy;

						SendNotify(pData,&sNotify.hdr);
						}

					}
																// Weiterleiten an Elternfenster
				if(iCode==HDN_ITEMCLICK || iCode==HDN_ITEMDBLCLICK)
					{
					NMLISTVIEW	sNotify;

					pData	= GetHandle(hWnd);

					if(!pData->cHasFocus)
						{
						SetFocus(pData->hWnd);
						}

					sNotify.hdr			= pHdr->hdr;
					sNotify.iItem		= -1;
					sNotify.iSubItem	= pHdr->iItem;
					sNotify.uNewState	= 0;
					sNotify.uOldState	= 0;
					sNotify.ptAction.x	= 0;
					sNotify.ptAction.y	= 0;
					sNotify.lParam		= 0;

					if(iCode==HDN_ITEMCLICK)
						{
						sNotify.hdr.code = LVN_COLUMNCLICK;
						}

					return SendNotify(pData,&sNotify.hdr);
					}

				if(iCode==NM_RCLICK)							// Rechte Maustaste im Header
					{
					LV_HDRCLICK		sNotify;

					pData = GetHandle(hWnd);
					GetCursorPos(&sNotify.sPoint);
					ScreenToClient(pData->hWnd,&sNotify.sPoint);

					if(SendMessage(pData->hHeader,HDM_HITTEST,0,(LPARAM)&sNotify.sPoint)>=0)
						{
						sNotify.hdr.code = LVN_COLUMNRCLICK;
						return SendNotify(pData,&sNotify.hdr);
						}
					}
				}
			else{
				NMHDR	*pHdr = (NMHDR*)lParam;

				if(pHdr->code<=TTN_FIRST && pHdr->code>=TTN_LAST)
					{											// Tooltip-Control
					NMTTDISPINFO   *pInfo;

					switch(pHdr->code)
						{
					case TTN_GETDISPINFO:

							pData			= GetHandle(hWnd);
							pInfo			= (NMTTDISPINFO*)pHdr;
							pInfo->lpszText = pData->pToolTipText;
							SendMessage(pData->hToolTip,WM_SETFONT,(WPARAM)pData->hFontT,0);
							break;
						}
					}
				else{											// Nachrichten von anderen Fenstern weiterleiten
					return SendMessage(GetParent(hWnd),WM_NOTIFY,wParam,lParam);
					}
				}


			return 0;

	case WM_GETDLGCODE:											// Welche Tasten werden im Dialog benutzt

			   pMsg=(MSG*)lParam;
			if(pMsg && pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_RETURN)
				{
				return DLGC_WANTALLKEYS;
				}

			return DLGC_WANTCHARS|DLGC_WANTARROWS;

	case WM_PASTE:												// Weiterleiten an Edit-Control^
	case WM_CLEAR:
	case WM_COPY:
	case WM_CUT:

			pData = GetHandle(hWnd);

			if(pData->hEdit && IsWindowVisible(pData->hEdit))
				{
				PostMessage(pData->hEdit,uMsg,0,0);
				return 0;
				}

			if(uMsg==WM_PASTE && pData->uSelectedItem && IsClipboardFormatAvailable(CF_TEXT_EX))
				{
				LOCK(pData);
				uVal = FastListPaste(pData);
				UNLOCK(pData);

				if(uVal)return 0;
				}

			break;

	case LVM_STARTUPDATE:										// Verzgertes Update starten

			pData = GetHandle(hWnd);
			pData->cUpdateTimer = 2;
			SetTimer(hWnd,ID_UPDATE,200,NULL);
			return 0;

	case LVM_SETIMAGELIST:										// Die Image-Liste einstellen

			pData	= GetHandle(hWnd);
			uFlag   = U(wParam)&LVSIL_NOTDEL;

			LOCK(pData);

			switch(U(wParam)&~LVSIL_NOTDEL)
				{
			case LVSIL_SMALL:	   lRet=(LPARAM)pData->hImages;
								if(lRet==lParam)break;

								if(pData->cImagesMode && !(pData->uStyle&LVS_SHAREIMAGELISTS))
									{
									ImageList_Destroy(pData->hImages);
									}

									pData->hImages=(HIMAGELIST)lParam;
								if(!pData->hImages)
									{
									pData->iImagesSizeX = 0;
									pData->iImagesSizeY = 0;
									pData->cImagesMode  = 0;
									}
								else{
									IMAGEINFO sInfo;
									ImageList_GetImageInfo(pData->hImages,0,&sInfo);
									pData->iImagesSizeX = sInfo.rcImage.right -sInfo.rcImage.left;
									pData->iImagesSizeY = sInfo.rcImage.bottom-sInfo.rcImage.top;
									pData->cImagesMode  = (char)((uFlag)? 0:1);
									if(!pData->hHdrImg)
										{
										   pData->hHdrImg = pData->hImages;
										if(pData->hHeader)
											{
											SendMessage(pData->hHeader,HDM_SETIMAGELIST,0,(LPARAM)pData->hImages);
											}
										}
									}
																// Auch fr Images in Spalten verwenden
								if(!pData->cSubImgMode || pData->hSubImg==pData->hImages)
									{
									pData->cSubImgMode  = 0;
									pData->hSubImg      = pData->hImages;
									pData->iSubImgXsize = pData->iImagesSizeX;
									pData->iSubImgYsize = pData->iImagesSizeY;
									}

								if(!pData->cFixedHeight)
									{
									pData->iRowHeight=1;
									UpdateHeight (pData);
									UpdateScrollY(pData);
									}
								else{
									UpdateView(pData);
									}

								break;

			case LVSIL_STATE:	   lRet=(LPARAM)pData->hStates;
								if(lRet==lParam)break;

								if(pData->cStatesMode && pData->hStates!=THEMEIMGLIST)
									{
									ImageList_Destroy(pData->hStates);
									}

									pData->hStates=(HIMAGELIST)lParam;
								if(!pData->hStates)
									{
									pData->iStatesSizeX = 0;
									pData->iStatesSizeY = 0;
									pData->cStatesMode  = 0;

									if(pData->uStyleEx&LVS_EX_CHECKBOXES)
										{
										CreateStateImageList(pData,0);
										}
									}
								else if(pData->hStates==THEMEIMGLIST)
									{
									pData->iStatesSizeX = 16;
									pData->iStatesSizeY = 16;
									pData->cStatesMode  = 0;
									if(!pData->hThemeBt)CreateStateImageList(pData,0);
									}
								else{
									IMAGEINFO sInfo;
									ImageList_GetImageInfo(pData->hStates,0,&sInfo);
									pData->iStatesSizeX = sInfo.rcImage.right -sInfo.rcImage.left;
									pData->iStatesSizeY = sInfo.rcImage.bottom-sInfo.rcImage.top;
									pData->cStatesMode  = (char)((uFlag)? 0:1);
									}

								if(!pData->cFixedHeight)
									{
									pData->iRowHeight=1;
									UpdateHeight (pData);
									UpdateScrollY(pData);
									}
								else{
									UpdateView(pData);
									}

								break;

			case LVSIL_CHECK:	   lRet=(LPARAM)pData->hChecks;
								if(lRet==lParam)break;

								if(pData->cChecksMode)
									{
									if(pData->hChecks!=THEMEIMGLIST)
										{
										ImageList_Destroy(pData->hChecks);
										}

									pData->cChecksMode = 0;
									}

									pData->hChecks=(HIMAGELIST)lParam;
								if(!pData->hChecks)
									{
									pData->iChecksSizeX = 0;
									pData->iChecksSizeY = 0;
									pData->cChecksMode  = 0;

									if(pData->uColumnCount)
										{
										CreateStateImageList(pData,1);
										}
									}
								else if(pData->hChecks==THEMEIMGLIST)
									{
									pData->iChecksSizeX = 16;
									pData->iChecksSizeY = 16;
									pData->cChecksMode  = 0;
									if(!pData->hThemeBt)CreateStateImageList(pData,1);
									}
								else{
									IMAGEINFO sInfo;
									ImageList_GetImageInfo(pData->hChecks,0,&sInfo);
									pData->iChecksSizeX = sInfo.rcImage.right -sInfo.rcImage.left;
									pData->iChecksSizeY = sInfo.rcImage.bottom-sInfo.rcImage.top;
									pData->cChecksMode  = (char)((uFlag)? 0:1);
									}

								if(!pData->cFixedHeight)
									{
									pData->iRowHeight=1;
									UpdateHeight (pData);
									UpdateScrollY(pData);
									}
								else{
									UpdateView(pData);
									}

								break;

			case LVSIL_SUBIMAGES:  lRet=(LPARAM)pData->hSubImg;
								if(lRet==lParam)break;

								if(pData->cSubImgMode)
									{
									ImageList_Destroy(pData->hSubImg);
									}

									pData->hSubImg=(HIMAGELIST)lParam;
								if(!pData->hSubImg || pData->hSubImg==pData->hImages)
									{
									pData->hSubImg      = pData->hImages;
									pData->iSubImgXsize = pData->iImagesSizeX;
									pData->iSubImgYsize = pData->iImagesSizeY;
									pData->cSubImgMode  = 0;
									}
								else{
									IMAGEINFO sInfo;
									ImageList_GetImageInfo(pData->hSubImg,0,&sInfo);
									pData->iSubImgXsize = sInfo.rcImage.right -sInfo.rcImage.left;
									pData->iSubImgYsize = sInfo.rcImage.bottom-sInfo.rcImage.top;
									pData->cSubImgMode  = (char)((uFlag)? 0:1);
									}

								if(!pData->cFixedHeight)
									{
									pData->iRowHeight=1;
									UpdateHeight (pData);
									UpdateScrollY(pData);
									}
								else{
									UpdateView(pData);
									}

								break;

			case LVSIL_HEADER:	   lRet=(LPARAM)pData->hHdrImg;
								if(lRet==lParam)break;

								   pData->hHdrImg = (HIMAGELIST)lParam;
								if(pData->hHeader)
									{
									SendMessage(pData->hHeader,HDM_SETIMAGELIST,0,(LPARAM)((pData->hHdrImg)? pData->hHdrImg:pData->hImages));
									}

								UpdateView(pData);
								break;


			default:			lRet=0;
				}


			UNLOCK(pData);
			return lRet;

	case LVM_GETIMAGELIST:										// Die Image-Liste abfragen

				pData	= GetHandle(hWnd);
			if(!pData)return 0;

			switch((int)wParam)
				{
			case LVSIL_SMALL:	 lRet=(LPARAM)pData->hImages; break;
			case LVSIL_STATE:	 lRet=(LPARAM)pData->hImages; break;
			case LVSIL_CHECK:	 lRet=(LPARAM)pData->hChecks; break;
			case LVSIL_SUBIMAGES:lRet=(LPARAM)pData->hSubImg; break;
			case LVSIL_HEADER:	 lRet=(LPARAM)pData->hHdrImg; break;
			default:			 lRet=0;
				}

			return lRet;

	case LVM_COLUMNAUTOEDIT:									// AutoEdit fr eine Spalte einstellen

			pData = GetHandle(hWnd);
			uVal  = (wParam>>11)&0x3F;

			if(uVal>=pData->uColumnCount)
				{
				return 0;
				}

			uMode = (U(wParam)>>LVAE_MODEPOS)&7;

			if(uMode==LVAX_NONE)
				{
				wParam = 0;
				}
			else if(uVal==0 && uMode>=LVAX_CHECK)				// Checkboxes are not allowed in the first column
				{
				return 0;
				}

			LOCK(pData);

			uChange  = pData->aColumn[uVal].bEdit<<LVAE_MODEPOS;
			uChange |= pData->aColumn[uVal].bFlags&LVAE_STATEENABLE;

			pData->aColumn[uVal].bEdit   = (BYTE)(uMode     );
			pData->aColumn[uVal].bFlags  = (BYTE)(wParam    );
			pData->aColumn[uVal].bCbChar = (BYTE)(wParam>>17);
			pData->aColumn[uVal].bCbSize = (BYTE)(wParam>>25);
			pData->aColumn[uVal].pCbData = (void*)lParam;


			if(uMode>=LVAX_CHECK)								// Sollen Checkboxen dargestellt werden
				{
				if(!pData->hChecks)
					{
					CreateStateImageList(pData,1);
					UpdateHeight(pData);
					}

				if((uChange^wParam)&((LVAE_MODEMASK^LVAE_CHECK^LVAE_CHECKED)|LVAE_STATEENABLE))
					{
					UpdateRect(pData,pData->uScrollY,uVal,1,pData->uMaxEnties);
					}
				}
			else if((uChange&LVAE_MODEMASK)>=LVAE_CHECK)		// Waren Checkboxen dargestellt
				{
				if((uChange^wParam)&((LVAE_MODEMASK^LVAE_CHECK^LVAE_CHECKED)|LVAE_STATEENABLE))
					{
					UpdateRect(pData,pData->uScrollY,uVal,1,pData->uMaxEnties);
					}
				}

			UNLOCK(pData);
			return 1;

	case LVM_GETITEMSTATE:										// Die Statusbits eines Eintrags abfragen

			pData = GetHandle(hWnd);
			LOCK(pData);

			if(U(wParam)<pData->uListItemsCount)
				{
				FL_ENTRY  sData;

				pEntry = pData->pListItems+U(wParam);
				lRet   = pEntry->uState;

				if(lParam&(LVIS_UNTERLINE|LVIS_BOLD))
					{
					GetDataEntry(pData,U(wParam),0,&sData,pEntry->uState);
					lRet |= sData.uState;
					}
				}
			else{
				lRet = 0;
				}

			UNLOCK(pData);
			return lRet;

	case LVM_SETITEMSTATE:										// Die Statusbits eines Eintrags einstellen

			pData = GetHandle(hWnd);
			pItem = (LV_ITEM*)lParam;

			LOCK(pData);

			pItem->iItem = U(wParam);
			pItem->mask  = LVIF_STATE;
			lRet		 = FastListSetItem(pData,pItem);

			UNLOCK(pData);
			return lRet;

	case LVM_SETITEMTEXT:										// Den Text eines Eintrages einstellen

			return 0;

	case LVM_SETSELECTIONMARK:									// Die Auswahlmarke setzen

			pData = GetHandle(hWnd);
			LOCK(pData);

			lRet  = pData->uSelectedItem;
			FastListSelectItem(pData,U(lParam),U(wParam),0);

			UNLOCK(pData);
			return lRet;

	case LVM_GETSELECTEDCOUNT:									// Anzahls der ausgewhlten Eintrge

			pData = GetHandle(hWnd);
			return pData->uSelectedCount;

	case LVM_GETSELECTIONMARK:									// Abfrage des selektierten Eintrages

			pData = GetHandle(hWnd);
			return pData->uSelectedItem;

	case LVM_GETSTRINGWIDTH:									// Abfrage der Breite eines Textes

			pData = GetHandle(hWnd);
			LOCK(pData);
			{
			FL_ENTRY  sData;

			sData.pText  = (LPTSTR)lParam;
			sData.iSize  = str_len(sData.pText);
			sData.uState = (wParam)? LVIS_BOLD:0;
			lRet = GetTextSize(pData,&sData);
			}
			UNLOCK(pData);
			return lRet;

	case LVM_GETITEMTEXT:										// Die Statusbits eines Eintrags abfragen

			pData = GetHandle(hWnd);
			pItem = (LV_ITEM*)lParam;

			LOCK(pData);

			if(U(wParam)<pData->uListItemsCount && pItem->cchTextMax>0 && (pItem->iSubItem==0 || U(pItem->iSubItem)<pData->uColumnCount))
				{
				FL_ENTRY  sData;
				unsigned  uChar;

				GetDataEntry(pData,U(wParam),pItem->iSubItem,&sData,0);

				if(pItem->iSubItem==0)
					{
					while(sData.iSize>0)						// Spezialzeichen berspringen
						{
						   uChar = sData.pText[0];
						if(uChar>=SPECIAL_MAX)break;

						sData.pText++;
						sData.iSize--;
						}
					}

				str_ncpy(pItem->pszText,sData.pText,pItem->cchTextMax);
				pItem->pszText[pItem->cchTextMax-1]=0;
				pItem->cchTextMax = sData.iSize;
				lRet			  = sData.iSize;
				}
			else{
				if(pItem->cchTextMax>0)
					{
					pItem->pszText[0]=0;
					}

				pItem->cchTextMax = 0;
				lRet              = 0;
				}

			UNLOCK(pData);
			return lRet;

	case LVM_GETNEXTITEM:										// Einen Eintrag suchen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListGetNextItem(pData,(int)wParam,U(lParam));
			UNLOCK(pData);
			return lRet;

	case LVM_GETITEM:											// Eintrge abfragen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListGetItem(pData,(LV_ITEM*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_SETITEM:											// Eintrge ndern

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListSetItem(pData,(LV_ITEM*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_SETITEMSTATES:										// Stati fr mehrere Items seten

			pData = GetHandle(hWnd);
			LOCK(pData);

			lRet			= 0;
			pSetIt			= (LV_SETSTATES*)lParam;
			uItem			= pSetIt->iStart;
			uVal			= pSetIt->iEnd;
			pEntry			= pData->pListItems+uItem;
			sItem.mask		= LVIF_STATE;
			sItem.stateMask	= pSetIt->uMask;
			sItem.state		= pSetIt->uState;

			if(uVal>pData->uListItemsCount)
				{
				uVal = pData->uListItemsCount;
				}

			while(uItem<uVal && uItem<pData->uListItemsCount)
				{
				if((pEntry->uState^sItem.state)&sItem.stateMask)
					{
					sItem.iItem	= uItem;
					FastListSetItem(pData,&sItem);
					lRet++;
					}

				pEntry++;
				uItem++;
				}

			UNLOCK(pData);
			return lRet;

	case LVM_SETDATAFIELD:										// Ein Datenfeld einstellen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListSetDataField(pData,(LV_DATAFIELD*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_INSERTITEM:										// Eintrge einfgen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet = FastListInsertItem(pData,(LV_ITEM*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_INSERTMULTI:										// Mehrfach Eintrge einfgen

			pData = GetHandle(hWnd);
			LOCK(pData);

			sItem.mask	 = LVIF_PARAM;
			sItem.mask	|= wParam&(LVIF_SHOWSCROLL|LVIF_ENDSCROLL|LVIF_FAST);
			sItem.iItem	 = pData->uListItemsCount;
			sItem.lParam = lParam;
			iMax		 = (int)wParam&~(LVIF_SHOWSCROLL|LVIF_ENDSCROLL|LVIF_FAST);

			for(iPos=0,lRet=0;iPos<iMax;iPos++)
				{
				if(FastListInsertItem(pData,&sItem))
					{
					lRet++;
					}

				sItem.lParam++;
				sItem.iItem++;
				}

			UNLOCK(pData);
			return lRet;

	case LVM_INSERTMULTIPTR:									// Mehrfach Eintrge einfgen ber Array

			pData = GetHandle(hWnd);
			LOCK(pData);

			sItem.mask	 = LVIF_PARAM;
			sItem.mask	|= wParam&(LVIF_SHOWSCROLL|LVIF_ENDSCROLL|LVIF_FAST);
			sItem.iItem	 = pData->uListItemsCount;
			pPtr		 = (LPARAM*)lParam;
			iMax		 = (int)wParam&~(LVIF_SHOWSCROLL|LVIF_ENDSCROLL|LVIF_FAST);

			for(iPos=0,lRet=0;iPos<iMax;iPos++)
				{
				sItem.lParam = pPtr[iPos];

				if(FastListInsertItem(pData,&sItem))
					{
					lRet++;
					}

				sItem.iItem	+= 1;
				}

			UNLOCK(pData);
			return lRet;

	case LVM_DELETEITEM:										// Einen Eintrag lschen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListDeleteItems(pData,U(wParam),1);
			UNLOCK(pData);
			return lRet;

	case LVM_DELETEALLITEMS:									// Alle Eintrge lschen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListDeleteItems(pData,0,0x7FFFFFFF);
			UNLOCK(pData);
			return lRet;

	case LVM_DELETEITEMS:										// Eintrge lschen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListDeleteItems(pData,U(wParam),U(lParam));
			UNLOCK(pData);
			return lRet;

	case LVM_FINDITEM:											// Eintrge suchen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListFindItem(pData,U(wParam),(LV_FIND*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_DELETECOLUMN:										// Lschen einer Spalte im Header

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListDeleteColumn(pData,U(wParam));
			UNLOCK(pData);
			return lRet;

	case LVM_INSERTCOLUMN:										// Einfgen einer Spalte im Header

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListInsertColumn(pData,(int)wParam,(LV_COLUMN*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_GETCOLUMNCOUNT:									// Abfragen der Spaltenanzahl

			pData = GetHandle(hWnd);
			return (LRESULT)pData->uColumnCount;

	case LVM_GETHEADER:											// Abfragen des Header-Fensters

			pData = GetHandle(hWnd);
			return (LRESULT)pData->hHeader;

	case LVM_GETEXTENDEDLISTVIEWSTYLE:							// Abfragen der erweiterten Style-Bits

			pData = GetHandle(hWnd);
			return pData->uStyleEx;

	case LVM_SETEXTENDEDLISTVIEWSTYLE:							// Einstellen der erweiterten Style-Bits

				pData = GetHandle(hWnd);
			if(!wParam)wParam=0xFFFFFFFF;

			uVal  = pData->uStyleEx &~U(wParam);
			uVal |=	U(lParam)& U(wParam);

			if(pData->uStyleEx!=uVal)							// Gab es nderungen
				{
				LOCK(pData);
				uChange = pData->uStyleEx^uVal;
				pData->uStyleEx = uVal;

				if(uChange&LVS_EX_AUTOHSCROLL)
					{
					UpdateScrollX(pData);
					}

				if(((uChange&LVS_EX_GRAYEDDISABLE) && !pData->cIsEnabled) || (uChange&LVS_EX_TRACKSELECT))
					{
					UpdateView(pData);
					}

				if(uChange&LVS_EX_NOTOOLTIPS)
					{
					if(pData->uStyleEx&LVS_EX_NOTOOLTIPS)
						{
						UpdateToolTip(pData,0,0,0);
						}
					else{
						CreateToolTip(pData);
						}
					}

				if(uChange&(LVS_EX_GRIDLINES|LVS_EX_ALWAYSSCROLLY))
					{
					if(uChange&LVS_EX_ALWAYSSCROLLY)
						{
						pData->uOldPageY	= 0xFFFFFFFF;

						if(U(lParam)&LVS_EX_ALWAYSSCROLLY)
							{
							sScroll.cbSize		= sizeof(SCROLLINFO);
							sScroll.fMask		= SIF_RANGE|SIF_PAGE;
							sScroll.nMin		= 0;
							sScroll.nMax  		= 100;
							sScroll.nPage 		= 10;

							UNLOCK(pData);						// WIN-BUG: Die Scrollbar muss an sein fr SIF_DISABLENOSCROLL
							SetScrollInfo(pData->hWnd,SB_VERT,&sScroll,TRUE);
							LOCK(pData);
							}
						else if(pData->uPageEnties>=pData->uListItemsCount)
							{
							UNLOCK(pData);
							ShowScrollBar(pData->hWnd,SB_VERT,FALSE);
							LOCK(pData);
							}
						}

					if(uChange&LVS_EX_GRIDLINES)
						{
						pData->iRowHeight = 1;
						}

					UpdateHeight (pData);
					UpdateScrollY(pData);
					}

				if(uChange&LVS_EX_CHECKBOXES)
					{
					if(pData->hStates==NULL && (uVal&LVS_EX_CHECKBOXES))
						{
						CreateStateImageList(pData,0);
						}

					if(!(uVal&LVS_EX_CHECKBOXES))
						{
						if(pData->cStatesMode && pData->hStates)
							{
							ImageList_Destroy(pData->hStates);
							pData->hStates     = NULL;
							pData->cStatesMode = 0;
							}
						}

					UpdateHeight(pData);
					UpdateView(pData);
					}

				if(uChange&(LVS_EX_ALTERNATECOLOR|LVS_EX_SUBSELECT|LVS_EX_FULLROWSELECT))
					{
					UpdateView(pData);
					}

				if((uChange&~U(lParam))&LVS_EX_SUBSELECT)
					{
					FastListSelectItem(pData,pData->uSelectedItem,0,0);
					}

				UNLOCK(pData);
				}

			return uVal;

	case LVM_GETTEXTBKCOLOR:wParam=LVC_BK;	goto GetColor;
	case LVM_GETTEXTCOLOR:	wParam=LVC_TEXT;
	case LVM_GETBKCOLOR:
	GetColor:
			if(wParam<0 || wParam>=MAX_COLORS)return 0xFFFFFFFF;
			pData = GetHandle(hWnd);
			return pData->aColors[U(wParam)];


	case LVM_SETTEXTBKCOLOR:wParam=LVC_BK;	goto SetColor;
	case LVM_SETTEXTCOLOR:	wParam=LVC_TEXT;
	case LVM_SETBKCOLOR:
	SetColor:
			if(wParam<0 || wParam>=MAX_COLORS)return 0xFFFFFFFF;

			pData = GetHandle(hWnd);

			LOCK(pData);

			lRet=pData->aColors[U(wParam)];

			if((COLORREF)lParam==LV_NOCOLOR)					// Standartfarbe einstellen
				{
				if(pData->aColorChanged[U(wParam)])
					{
					pData->aColorChanged[U(wParam)]=0;
					UpdateColors(pData);
					UpdateView  (pData);
					}
				}
			else{
				pData->aColorChanged[U(wParam)]=1;
				pData->aColors      [U(wParam)]=(COLORREF)lParam;

				if(lRet!=lParam)UpdateView(pData);
				}

			UNLOCK(pData);
			return lRet;

	case LVM_HITTEST:											// Abfragen von Koordinatenpositionen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListHitTest(pData,(LVHITTESTINFO*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_SUBITEMHITTEST:

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListHitTest(pData,(LVHITTESTINFO*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_SELECTSUBITEM:										// Einen (Sub)Eintrag auswhlen

			pData = GetHandle(hWnd);
			LOCK(pData);
			if(!(pData->uStyleEx&LVS_EX_SUBSELECT))wParam=0;
			lRet=FastListSelectItem(pData,U(lParam),U(wParam),0);
			if(lRet>1)lRet=1;
			UNLOCK(pData);
			return lRet;

	case LVM_SELECTITEM:										// Einen Eintrag auswhlen

			pData = GetHandle(hWnd);
			LOCK(pData);

			switch(wParam)
				{
			case LVNI_CARET:		lRet=FastListSelectItem(pData,U(lParam),0,0);
									if(lRet>1)lRet=1;
									break;
			case LVNI_DROPHILITE:	lRet=FastListSetTrackItem(pData,U(lParam),0);
									break;

			case LVNI_FIRSTVISIBLE:	lRet=FastListEnsureVisible(pData,U(lParam),FIRST_LINE);
									lRet=(lRet<0)? 0:1;
									break;

			default:				lRet=0;
				}

			UNLOCK(pData);
			return lRet;

	case LVM_GETCOLUMNORDERARRAY:								// Spaltensortierung abfragen

			if(!lParam)return 0;

			pData = GetHandle(hWnd);

			if(!pData->hHeader)return 0;

			return Header_GetOrderArray(pData->hHeader,U(wParam),lParam);

	case LVM_SETCOLUMNORDERARRAY:								// Spalten sortieren

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet = FastListSetOrderArray(pData,U(wParam),(unsigned*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_GETITEMCOUNT:										// Anzahl der Eintrge abfragen

			pData = GetHandle(hWnd);
			return pData->uListItemsCount;

	case LVM_GETITEMHEIGHT:										// Zeilenhhe abfragen

			pData = GetHandle(hWnd);
			return pData->iRowHeight;

	case LVM_SETITEMHEIGHT:										// Zeilenhhe abfragen

			pData = GetHandle(hWnd);
			lRet  = pData->iRowHeight;

			if(wParam==-1)
				{
				LOCK(pData);
				pData->cFixedHeight=0;
				UpdateHeight (pData);
				UpdateScrollY(pData);
				UNLOCK(pData);
				return lRet;
				}

			if(wParam&1 )
			if(!(pData->uStyleEx&LVS_NONEVENHEIGHT))wParam--;
			if(wParam<  1)wParam=  1;
			if(wParam>256)wParam=256;

			if(lRet!=(LPARAM)wParam)
				{
				LOCK(pData);
				pData->cFixedHeight = 1;
				pData->iRowHeight   = (int)wParam;
				UpdateView(pData);
				UNLOCK(pData);
				}

			return lRet;

	case LVM_GETVISIBLECOUNT:									// Abfragen der sichtbaren Zeilen (ohne halbe Zeilen)

			pData = GetHandle(hWnd);
			return pData->uPageEnties;

	case LVM_ENSUREVISIBLE:										// Einen Eintrag ins Sichtfenster legen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListEnsureVisible(pData,(int)wParam,U(lParam));
			UNLOCK(pData);
			return lRet;

	case LVM_ISITEMVISIBLE:										// Ist ein Eintrag sichtbar

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListIsVisible(pData,U(lParam),(int)wParam);
			UNLOCK(pData);

			return lRet;

	case LVM_GETITEMRECT:										// Das Rechteck eines Eintrages abfragen

			pData = GetHandle(hWnd);
			LOCK(pData);
			uVal=*(unsigned*)lParam;
			lRet=FastListGetItemRect(pData,U(wParam),uVal,(RECT*)lParam);
			UNLOCK(pData);

			return lRet;

	case LVM_GETSUBITEMRECT:

			pData = GetHandle(hWnd);
			LOCK(pData);
			uVal  = ((unsigned*)lParam)[0];
			uVal |=	LVIR_COLTOSUB(((unsigned*)lParam)[1]);
			lRet=FastListGetItemRect(pData,U(wParam),uVal,(RECT*)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_GETITEMBKCOLOR:									// Hintergrundfarbe eines Eintrages abfragen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListGetItemColor(pData,U(wParam),U(lParam),0);
			UNLOCK(pData);
			return lRet;

	case LVM_GETITEMTEXTCOLOR:									// Textfarbe eines Eintrages abfragen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet=FastListGetItemColor(pData,U(wParam),U(lParam),1);
			UNLOCK(pData);
			return lRet;

	case LVM_SORTITEMS:											// Sortieren mit Funktion

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet  = FastListSortItems(pData,wParam,(PFNLVCOMPARE)lParam);
			UNLOCK(pData);
			return lRet;

	case LVM_GETCOUNTPERPAGE:									// Hole die Anzahl der darstellbaren Reihen (mit halben Zeilen)

			pData = GetHandle(hWnd);
			return pData->uMaxEnties;

	case LVM_EDITLABEL:											// Einen Eintrag editieren

			pData = GetHandle(hWnd);
			if(!(pData->uStyle&LVS_EDITLABELS))return 0;

			LOCK(pData);

			if((lParam&0xFFFFFF00)==LVLE_DONOTIFY)				// Notify starten
				{
				lRet=FastListStartNotifyEdit(pData,U(wParam),LVIR_EDITCOL(lParam),VK_RETURN,0);
				}
			else{
				pData->cColumnStart = 0;
				lRet=(LRESULT)FastListEditLabel(pData,U(wParam),U(lParam));
				}

			UNLOCK(pData);
			return lRet;

	case LVM_GETEDITCONTROL:									// Das Handle des Edit-Fensters abfragen

			pData = GetHandle(hWnd);
			return (LRESULT)pData->hEdit;

	case LVM_GETTOPINDEX:										// Dan ersten sichtbaren Eintrag abfragen

			pData = GetHandle(hWnd);
			if(pData->uListItemsCount==0)return -1;
			return (LRESULT)pData->uScrollY;

	case LVM_GETTOOLTIPS:										// Das Handle des ToolTip-Fensters abfragen

			pData = GetHandle(hWnd);
			return (LRESULT)pData->hToolTip;

	case LVM_REDRAWITEMS:										// Eintrge neu zeichnen

			pData = GetHandle(hWnd);
			LOCK(pData);

			lRet = U(lParam)-U(wParam);

			if(lRet>=0)
					{uVal=U(wParam);}
			else	{uVal=U(lParam);lRet=-lRet;}


			if(uVal<pData->uListItemsCount)
				{
				UpdateRows(pData,uVal,U(lRet)+1);
				}
			else{
				lRet = 0;
				}

			UNLOCK(pData);
			return (lRet==0)? 0:1;

	case LVM_REDRAWITEMS_EX:									// Diverse Eintrge neu zeichnen

			pData = GetHandle(hWnd);
			LOCK(pData);

			lRet  = UpdateRect(pData,U(wParam)&0x00FFFFFF,U(wParam)>>24,U(lParam)>>24,U(lParam)&0x00FFFFFF);

			UNLOCK(pData);

			return (lRet==0)? 0:1;

	case LVM_SCROLL:											// Das Fenster scrollen

			pData = GetHandle(hWnd);
			LOCK(pData);

			if(wParam)FastListScrollX(pData,pData->uScrollX+(int)wParam                  ,SB_SETPOSITION);
			if(lParam)FastListScrollY(pData,pData->uScrollY+(int)lParam/pData->iRowHeight,SB_SETPOSITION);

			UNLOCK(pData);
			return pData->uScrollY;

	case LVM_SETTOPINDEX:										// Die Y-Scroll-Position einstellen

			pData = GetHandle(hWnd);

			LOCK(pData);

			FastListScrollY(pData,(int)wParam,-1);

			UNLOCK(pData);
			return 1;

	case LVM_SETTOOLTIPS:										// Das Handle fr das ToolTip-Fensters setzen

			pData = GetHandle(hWnd);
			lRet  = (LRESULT)pData->hToolTip;
			pData->hToolTip = (HWND)wParam;
			return lRet;

	case LVM_SETCOLUMN:											// Einen Spalten-Header einstellen

			pData = GetHandle(hWnd);
			if(pData->hHeader && U(wParam)<pData->uColumnCount)
				{
				HDITEM		sItem;
				LV_COLUMN  *pCol;
				unsigned	uBit;
				unsigned	uCol;
				int			iOld;

				pCol	= (LV_COLUMN*)lParam;
				uCol	= U(wParam);
				iOld	= pData->aColumn[uCol].sReal;

				   uVal = pCol->cx;
				if(uVal==LVCF_LASTSIZE)							// Breite vor Fixierung benutzen
					{
					if(pData->aColumn[uCol].sFixed>0)
						{
						uVal = pData->aColumn[uCol].sFixed;
						}
					else{
						uVal = pData->aColumn[uCol].sReal;
						}
					}

				if(pCol->mask&LVCF_FIXED)						// Die Spalte fixieren
					{
					uBit = pCol->fmt&LVCFMT_FIXED;

					if(uBit!=0 && pData->aColumn[uCol].sFixed==0)
						{
						    pData->aColumn[uCol].sFixed=pData->aColumn[uCol].sReal;
						if(!pData->aColumn[uCol].sFixed)pData->aColumn[uCol].sFixed=100;
						}

					if(uBit==0 && pData->aColumn[uCol].sFixed!=0)
						{
						pData->aColumn[uCol].sFixed=0;
						}
					}

				sItem.cxy  = 0;
				sItem.mask = 0;

				if(pCol->mask&LVCF_FMT  ){sItem.mask|=HDI_FORMAT; sItem.fmt    =pCol->fmt;    }
				if(pCol->mask&LVCF_IMAGE){sItem.mask|=HDI_IMAGE;  sItem.iImage =pCol->iImage; }
				if(pCol->mask&LVCF_WIDTH){sItem.mask|=HDI_WIDTH;  sItem.cxy    =uVal;pData->aColumn[U(wParam)].sSize=(short)sItem.cxy;}
				if(pCol->mask&LVCF_TEXT ){sItem.mask|=HDI_TEXT;   sItem.pszText=pCol->pszText;  sItem.cchTextMax=pCol->cchTextMax    ;}


				if(sItem.mask)
					{
					lRet=SendMessage(pData->hHeader,HDM_SETITEM,uCol,(LPARAM)&sItem);
					}
				else{
					lRet=1;
					}

				if(lRet && (pCol->mask&LVCF_FMT))				// Hat sich die Ausrichtung verndert
					{
					BYTE	bAlign;
					UINT	uNext;

					switch(pCol->fmt)
						{
					case LVCFMT_CENTER: bAlign = DT_CENTER;	break;
					case LVCFMT_RIGHT:	bAlign = DT_RIGHT;	break;
					default: 			bAlign = DT_LEFT;	break;
						}

					if(pData->aColumn[uCol].bAlign!=bAlign)
						{
						pData->aColumn[uCol].bAlign = bAlign;

						uNext		 = pData->aColumn    [uCol ].bNext;
						sRect.left   = pData->aColumnXpos[uCol ];
						sRect.right  = pData->aColumnXpos[uNext]+1;
						sRect.bottom = pData->uScrollX;
						sRect.top    = pData->uSizeY;
						InvalidateRect(pData->hWnd,&sRect,FALSE);
						}
					}

				if(lRet && (pCol->mask&LVCF_MARK))				// Die Spalte markieren
					{
					UINT	uNext;

					   uVal = (pCol->fmt&LVCFMT_MARK)? 1:0;
					if(uVal!=pData->aColumn[uCol].bMark)
						{
						pData->aColumn[uCol].bMark = (BYTE)uVal;
						pData->uMarkedCols		  +=  uVal*2-1;

						uNext		 = pData->aColumn    [uCol ].bNext;
						sRect.left   = pData->aColumnXpos[uCol ];
						sRect.right  = pData->aColumnXpos[uNext]+1;
						sRect.bottom = pData->uScrollX;
						sRect.top    = pData->uSizeY;
						InvalidateRect(pData->hWnd,&sRect,FALSE);
						}
					}
																// Variablespalten wieder auf die volle Lnge zoomen
				if((pCol->mask&LVCF_RECALC) && pData->uColumnCountVar && (sItem.mask&HDI_WIDTH))
					{
					int		iDelta;
					int		iNum;

					if(pCol->fmt&LVCFMT_RECALC)					// Breite aus allen Spalten
						{
						for(uCol=0,iNum=0;uCol<pData->uColumnCount;uCol++)
							{
							if(pData->aColumn[uCol].bWeight!=0)
							if(pData->aColumn[uCol].sFixed ==0)
								{
								pData->aColumn[uCol].sSize = 0;
								continue;
								}

							iNum += pData->aColumn[uCol].sSize;
							}

						iDelta = pData->uSizeX-iNum;
						ChangeColSize(pData,iDelta);
						}
					else{										// nderung einer Spalte
						iDelta = iOld-sItem.cxy;

						if((pCol->mask&LVCF_FIXED) && !iOld && sItem.cxy && !pData->aColumn[uCol].sFixed && pData->aColumn[uCol].bWeight)
							{
							pData->aColumn[uCol].sFixed = (short)sItem.cxy;
							ChangeColSize(pData,iDelta);
							pData->aColumn[uCol].sFixed = 0;
							}
						else{
							ChangeColSize(pData,iDelta);
							}
						}

					iNum = UpdateColumns(pData);
					GetClientRect(hWnd,&sRect);
					sRect.left  = iNum;
					sRect.left -= pData->uScrollX;
					sRect.top   = pData->uStartPixel;
					InvalidateRect(hWnd,&sRect,FALSE);
					}
																// Srollbar aktualisieren
				if(pCol->mask&(LVCFMT_FIXED|LVCF_RECALC|LVCF_WIDTH))
					{
					UpdateScrollX(pData,FALSE);
					}
				}
			else{
				lRet =0;
				}

			return lRet;


	case LVM_GETCOLUMN:											// Einen Spalten-Header abfragen

			pData = GetHandle(hWnd);
			if(pData->hHeader)
				{
				HDITEM		sItem;
				LV_COLUMN  *pCol=(LV_COLUMN*)lParam;

				sItem.mask = 0;
				if(pCol->mask&LVCF_FMT  ){sItem.mask|=HDI_FORMAT;}
				if(pCol->mask&LVCF_IMAGE){sItem.mask|=HDI_IMAGE; }
				if(pCol->mask&LVCF_WIDTH){sItem.mask|=HDI_WIDTH; }
				if(pCol->mask&LVCF_TEXT ){sItem.mask|=HDI_TEXT ;sItem.pszText=pCol->pszText;  sItem.cchTextMax=pCol->cchTextMax;}

				lRet=SendMessage(pData->hHeader,HDM_GETITEM,wParam,(LPARAM)&sItem);

				pCol->mask = 0;

				if(sItem.mask|=HDI_FORMAT){pCol->mask|=LVCF_FMT  ; pCol->fmt    =sItem.fmt;    }
				if(sItem.mask|=HDI_IMAGE ){pCol->mask|=LVCF_IMAGE; pCol->iImage =sItem.iImage; }
				if(sItem.mask|=HDI_WIDTH ){pCol->mask|=LVCF_WIDTH; pCol->cx     =sItem.cxy;    }
				if(sItem.mask|=HDI_TEXT  ){pCol->mask|=LVCF_TEXT ; pCol->pszText=sItem.pszText;  pCol->cchTextMax=sItem.cchTextMax;}
				}
			else{
				lRet =0;
				}

			return lRet;

	case LVM_SETCOLUMNWIDTH:									// Die Spaltenbreite einstellen

			pData = GetHandle(hWnd);
			if(pData->hHeader)
				{
				HDITEM sItem;

				sItem.mask = HDI_WIDTH;
				sItem.cxy  = (int)lParam;
				lRet=SendMessage(pData->hHeader,HDM_SETITEM,wParam,(LPARAM)&sItem);
				}
			else{
				lRet=0;
				}

			return lRet;

	case LVM_SETFOCUSITEM:									// Spalte mit Focus whlen

			pData	= GetHandle(hWnd);
			lRet	= 0;

			LOCK(pData);

			if(U(lParam)!=0xFFFFFFFF)
				{
				sItem.iItem		= U(lParam);
				sItem.iSubItem	=(LOWORD(wParam)!=0xFFFF)? LOWORD(wParam):0;
				sItem.mask		= LVIF_STATE;
				sItem.state		= LVIS_FOCUSED;
				sItem.stateMask	= LVIS_FOCUSED;

				lRet = FastListSetItem(pData,&sItem);
				}
			else{
				sItem.iItem		= pData->uFocusItem;
				}

			if(LOWORD(wParam)!=0xFFFF)
				{
				lRet = FastListSetFocusColumn(pData,LOWORD(wParam));
				}
			else{
				wParam &= ~0xFFFF;
				}

			if(U(wParam)&0x40000000)
				{
				FastListSelectItem(pData,sItem.iItem,LOWORD(wParam),1);
				}

			if(U(wParam)&0x80000000)
				{
				FastListEnsureVisible(pData,sItem.iItem,U(wParam));
				}

			UNLOCK(pData);

			return lRet;

	case LVM_GETSETOPTION:										// Diverse Optionen einstellen

			pData	= GetHandle(hWnd);
			lRet	= 0;

			switch(U(wParam)&~LVOP_WRITEOPTION)
				{
			case LVOP_LINEPARAM:								// Parameter fr den Callback

				lRet = (LPARAM)pData->pLineCbParam;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->pLineCbParam = (LPVOID)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_LINECALLBACK:								// Callback fr Daten

				lRet = (LPARAM)pData->pLineCallback;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);

					pData->pLineCallback = (PFNFLLINECB)lParam;

					if(pData->pLineCallback)
						{
						UpdateView(pData);
						}

					UNLOCK(pData);
					}

				break;

			case LVOP_DRAWPARAM:								// Parameter fr den Callback

				lRet = (LPARAM)pData->pDrawCbParam;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->pDrawCbParam = (LPVOID)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_DRAWCALLBACK:								// Callback fr linken Bereich

				lRet = (LPARAM)pData->pDrawCallback;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);

					pData->pDrawCallback = (PFNFLDRAWCB)lParam;
					UpdateView(pData);

					UNLOCK(pData);
					}

				break;

			case LVOP_DRAWSIZE:									// Breite des linken Draw-Bereichs

				lRet = pData->uDrawCbSize;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);

					pData->uDrawCbSize = U(lParam);
					UpdateView(pData);

					UNLOCK(pData);
					}

				break;

			case LVOP_CLOSEPARAM:								// Parameter fr die Callback

				lRet = (LPARAM)pData->pCloseCbParam;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->pCloseCbParam = (LPVOID)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_CLOSECALLBACK:							// Callback fr Daten

				lRet = (LPARAM)pData->pCloseCallback;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);

					pData->pCloseCallback = (PFNFLCLOSE)lParam;

					if(pData->pCloseCallback)
						{
						UpdateView(pData);
						}

					UNLOCK(pData);
					}

				break;

			case LVOP_MINCOLUMN:								// Linkeste Spalte fr Tasterureingaben

				lRet = (LPARAM)pData->iLeftColumn;
				pData->iLeftColumn = U(lParam);

				break;

			case LVOP_SELECTIONCOUNT:							// Anzahl der ausgewhlten Eintrge abfragen

				lRet = pData->uSelectedCount;
				break;

			case LVOP_EDITCLICKMODE:							// Editklickoptionen (Bit0=nur auf Text, Bit1=direkt ohne Auswahl)

				lRet = pData->cEditClickMode;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->cEditClickMode = (BYTE)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_CHARCOLORS:								// Farbliste fr einzelne Buchstaben

				lRet = (LPARAM)pData->pCharColors;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->pCharColors = (LPCOLORREF)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_CHARFONT2:								// Font Nummer 2 fr Einzelfarben

				lRet = (LPARAM)pData->hFontE;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->hFontE = (HFONT)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_CHARFONT3:								// Font Nummer 3 fr Einzelfarben

				lRet = (LPARAM)pData->hFontF;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->hFontF = (HFONT)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_COLOROFFSTATES:							// Bei welchen LVIS_??? States die Einzelfarben deaktivieren

				lRet = pData->uColorOff;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->uColorOff = (DWORD)lParam;
					UNLOCK(pData);
					}

				break;

			case LVOP_STARTOFFSET:								// Leerbereich zwischen Header und erster Zeile

				lRet = pData->uStartOffset;

				if((wParam&LVOP_WRITEOPTION) && lParam!=lRet)
					{
					LOCK(pData);
					pData->uStartPixel -=  pData->uStartOffset;
					pData->uStartOffset = (DWORD)lParam;
					pData->uStartPixel += (DWORD)lParam;
					UpdateView(pData);
					UNLOCK(pData);

					if(pData->uStartOffset)						// Gre des Startbereiches verndert
						{
						LV_STARTSIZE	sNotify;

						sNotify.hdr.code = LVN_STARTCHANGED;
						sNotify.iSizeX	 = pData->uSizeX;
						sNotify.iSizeY	 = pData->uStartOffset;
						sNotify.iOffset	 = pData->uStartPixel-pData->uStartOffset;

						SendNotify(pData,&sNotify.hdr);
						}
					}

				break;

			case LVOP_WINDOWPROC:								// Fensterfunktion abfragen

				lRet = (LPARAM)FastListProc;
				break;
				}

			return lRet;

	case LVM_GETITEMDATA:										// Den Parameter eines Eintrages abfragen

			pData = GetHandle(hWnd);

			if(U(lParam)<pData->uListItemsCount)
				{
				pEntry   = pData->pListItems+U(lParam);
				return pEntry->lParam;
				}

			return 0;

	case LVM_SETITEMDATA:										// Den Parameter eines Eintrages abfragen

			pData = GetHandle(hWnd);
			lRet  = FALSE;

			LOCK(pData);

			if(U(lParam)<pData->uListItemsCount)
				{
				pEntry         = pData->pListItems+U(lParam);
				pEntry->lParam = wParam;
				lRet		   = TRUE;
				}

			UNLOCK(pData);
			
			return lRet;

	case LVM_GETCOLUMNWIDTH:									// Die Spaltenbreite abfragen

			pData = GetHandle(hWnd);
			if(pData->hHeader)
				{
				HDITEM sItem;

				sItem.mask = HDI_WIDTH;
				sItem.cxy  = (int)lParam;
				SendMessage(pData->hHeader,HDM_GETITEM,wParam,(LPARAM)&sItem);
				lRet = sItem.cxy;
				}
			else{
				lRet=0;
				}

			return lRet;

	case LVM_CREATEDRAGIMAGE:									// Ein Drag-Image erzeugen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet = (LRESULT)CreateDragImage(pData,U(lParam),U(wParam));
			UNLOCK(pData);
			return lRet;

	case LVM_ENDEDITLABELNOW:									// Die aktuelle Eingabe abbrechen

			pData = GetHandle(hWnd);
			LOCK(pData);
			lRet = (FastListEndLabelEdit(pData,(wParam)? 0:1))? 1:0;
			UNLOCK(pData);
			return 0;

	case LVM_GETISEARCHSTRING:									// Holt den aktuellen Suchtext

			uDelta = GetTickCount()-uKeyLast;

			if(!lParam)
				{
				return (uDelta<=750)? uKeyPos:0;
				}

			if(uDelta>750)
				{
				((TCHAR*)lParam)[0]=0;
				return FALSE;
				}

			memcpy((TCHAR*)lParam,cKeyData,uKeyPos*sizeof(TCHAR));
			((TCHAR*)lParam)[uKeyPos]=0;
			return TRUE;

	case LVM_GETUNICODEFORMAT:									// Wird gerade UNI-Code verwendet

			#if UNICODE
			return 1;
			#else
			return 0;
			#endif

		}


return DefWindowProc(hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		FastListDraw
//*
//*****************************************************************************
//	Zeichnet das Fenster
static void FastListDraw(HWND hWnd,HDC hDc,RECT *pRect)
{
COLORREF		uBgColor;
COLORREF		uEcColor;
COLORREF		uEvColor;
COLORREF		uBkColor;
COLORREF		uOdColor;
COLORREF		uOcColor;
COLORREF		uFrColor;
COLORREF		uOldColor;
COLORREF		uOutColor;
COLORREF		uTempColor;
COLORREF		uTextColor;
COLORREF		uDrawColor;
HRGN			hRgnMain;
HRGN			aRgn    [FL_MAX_COLUMNS+1];
FL_ENTRY		aEntries[FL_MAX_COLUMNS+1];
INT				aRnType [FL_MAX_COLUMNS+1];
TCHAR			cTemp   [FL_MAX_COLUMNS*256+8];
LPTSTR			pTextPtr;
LPTSTR			pBasePtr;
SIZE			sSize;
RECT			sRect;
RECT			sArea;
RECT			sButton;
FL_ENTRY	   *pColItem;
FastListData   *pData;
BaseItem	   *pEntry;
LPCTSTR			pText;
LPBYTE		    pColors;
HIMAGELIST		hImgList;
unsigned		uTextSize;
unsigned		uRgnCount;
unsigned		uDrawSize;
unsigned		uDrawFlags;
unsigned		uTextFlags;
unsigned		uFirstPos;
unsigned		uStartPos;
unsigned		uStyleEx;
unsigned		uColMark;
unsigned		uColumn;
unsigned		uEndCol;
unsigned		uState;
unsigned		uStyle;
unsigned		uExtra;
unsigned		uNext;
unsigned		uItem;
unsigned		uMark;
unsigned		uBits;
unsigned		uPos;
unsigned		uCol;
unsigned		uMax;
int			   *pOffsets;
int				iScrollX;
int				iPixels;
int				iHeight;
int				iDelta;
int				iImage;
int				iStart;
int				iCount;
int				iSize;
int				iYpos;
int				iMaxX;
int				iDiff;
int				iValT;
int				iValB;
int				iAdd;
int				i;




	pData=GetHandle(hWnd);

	LOCK(pData);

	GetClientRect(hWnd,&sRect);

	if(!pRect)pRect=&sRect;


	iScrollX = -(int)pData->uScrollX;
	pOffsets = pData->aColumnXpos;
	hRgnMain = CreateRectRgn(pRect->left,pRect->top,pRect->right,pRect->bottom);

		uMax = pData->uColumnCount;
	if(!uMax)
		{
			aRgn   [  0 ]	= CreateRectRgn(sRect.left,sRect.top,sRect.right,sRect.bottom);
			aRnType[  0 ]	= CombineRgn(aRgn[0],aRgn[0],hRgnMain,RGN_AND);
			uRgnCount		= 1;
			uEndCol			= 1;
		}
	else{
		for(uPos=0;uPos<uMax;uPos++)
			{
			uExtra = pData->aColumnPos[uPos  ];
			uNext  = pData->aColumnPos[uPos+1];
			aRgn   [uExtra]	= CreateRectRgn(sRect.left+pOffsets[uExtra]+iScrollX,sRect.top,sRect.left+pOffsets[uNext]+iScrollX,sRect.bottom);
			aRnType[uExtra]	= CombineRgn(aRgn[uExtra],aRgn[uExtra],hRgnMain,RGN_AND);
			}

		aRgn   [uPos]	= CreateRectRgn(sRect.left+pOffsets[uPos]+iScrollX,sRect.top,sRect.right,sRect.bottom);
		aRnType[uPos]	= CombineRgn(aRgn[uPos],aRgn[uPos],hRgnMain,RGN_AND);
		uRgnCount		= uMax+1;
		uEndCol			= uMax;
		}



	iHeight		  = pData->iRowHeight;
	uStyleEx 	  = pData->uStyleEx;
	uStyle	 	  = pData->uStyle;
	uPos	 	  = pData->uScrollY;
	uMax	 	  = pData->uMaxEnties+uPos;
	uNext		  = pData->aColumn[0].bNext;
	uFirstPos     = pData->aColumnXpos[uNext];
	uStartPos	  = pData->aColumnXpos[0];
	uDrawSize	  = pData->uDrawCbSize;

	if(uDrawSize)												// Existiert ein linker Draw-Bereich
		{
		if(pData->pDrawCallback)
			{
			uStartPos += uDrawSize;

			if(iScrollX<=-(int)uDrawSize)
				{
				uDrawSize = 0;
				}
			else{												// Init-Call
				memset(&sArea,0,sizeof(sArea));
				pData->pDrawCallback(pData->pDrawCbParam,0,0xFFFFFFFF,0,hDc,&sArea);
				}
			}
		else{
			uDrawSize  = 0;
			}
		}


	if(aRnType[0]==NULLREGION)
			iMaxX = pData->iMaxSizeX;
	else	iMaxX = uFirstPos-1;

	if(uStyleEx&LVS_EX_GRIDLINES)
		{
		iHeight--;
		}

	if(uMax>pData->uListItemsCount)
		{
		uMax = pData->uListItemsCount;
		}


	uBkColor  = pData->aColors[LVC_BK   ];
	uFrColor  = pData->aColors[LVC_FRAME];

	if(pData->uStyleEx&LVS_EX_ALTERNATECOLOR)					// Abwechselnde Farben
		{
		uOdColor = pData->aColors[LVC_ODD    ];
		uEvColor = pData->aColors[LVC_EVEN   ];
		uOcColor = pData->aColors[LVC_COLODD ];
		uEcColor = pData->aColors[LVC_COLEVEN];
		}
	else{
		uOdColor = uBkColor;
		uEvColor = uBkColor;
		uOcColor = pData->aColors[LVC_COLBK];
		uEcColor = pData->aColors[LVC_COLBK];
		}


	if(!pData->cIsEnabled)										// Wenn Fenster gessperrt grau zeichnen
	if( pData->uStyleEx&LVS_EX_GRAYEDDISABLE)
		{
		uBkColor = pData->aColors[LVC_GRAYED];
		uEvColor = uEcColor;
		uOdColor = uOcColor;
		}

	iStart	  = uStartPos;
	sArea.top = sRect.top+pData->uStartPixel;
	SelectObject(hDc,pData->hFontN);
	SelectObject(hDc,hPatternPen);
	SetBkColor	(hDc,uBkColor);
	SetBkMode   (hDc,TRANSPARENT);
	SetTextAlign(hDc,TA_LEFT|TA_TOP);
	SetTextColor(hDc,pData->aColors[LVC_TEXT]);



//******************** Eintrge zeichnen **************************************

	uDrawFlags					= DT_LEFT|DT_VCENTER|DT_SINGLELINE|DT_NOPREFIX;
	uDrawFlags				   |= pData->uColorOff&0xF0000000;
	uTextFlags					= ETO_OPAQUE|ETO_CLIPPED|ETO_FONTCNT_1;
	uTextFlags				   |= pData->uColorOff&0xF0000000;
	pBasePtr					= cTemp+N;
	pBasePtr[FL_MAX_COLUMNS*256]= 0;

	aEntries[uEndCol].iSize		= 0;							// Daten fr Fllspalte am Ende
	aEntries[uEndCol].pText		= _T("");
	aEntries[uEndCol].iImage	= LV_NOIMAGE;
	aEntries[uEndCol].uBkColor	= LV_NOCOLOR;
	aEntries[uEndCol].uTextColor= LV_NOCOLOR;
	aEntries[uEndCol].uState	= 0;


	for(;uPos<uMax;uPos++)										// Alle Eintrge ausgeben
		{
		uItem	= uPos;
		pEntry	= pData->pListItems+uItem;

		*(LPINT)(cTemp) = uItem;								// Zeilenummer bergeben

		for(uCol=0;uCol<uEndCol;uCol++)							// Felder initalisieren
			{
			pTextPtr					= pBasePtr+uCol*256+M;
			aEntries[uCol].iSize		= 256-M;
			aEntries[uCol].pText		= pTextPtr;
			aEntries[uCol].iImage		= LV_NOIMAGE;
			aEntries[uCol].uBkColor		= LV_NOCOLOR;
			aEntries[uCol].uTextColor	= LV_NOCOLOR;
			aEntries[uCol].uState		= pEntry->uState;
			pTextPtr[0]					= 0;
			}

																// Texte ber Callback holen
		if(pData->pLineCallback && !pData->pLineCallback(pData->pLineCbParam,pEntry->lParam,0,uEndCol,aEntries))
			{
			for(uCol=0;uCol<uEndCol;uCol++)
				{
				aEntries[uCol].iSize = 0;
				}
			}


		if((pEntry->uState&LVIS_SELECTED) && (uStyleEx&LVS_EX_FULLROWSELECT))
			{
			if(uStyleEx&LVS_EX_ALTERNATECOLOR)
					uOutColor = (uPos&1)? pData->aColors[LVC_MARKODD]:pData->aColors[LVC_MARKEVEN];
			else	uOutColor = pData->aColors[LVC_MARK];

			aEntries[0].uBkColor = LV_NOCOLOR;
			uColMark  = 0;
			}
		else if(uPos&1)											// Farbe wechselweise ndern
			{
			uColMark  =  pData->aColumn[0].bMark;
			uOutColor = (uColMark)? uOcColor:uOdColor;
			}
		else{
			uColMark  =  pData->aColumn[0].bMark;
			uOutColor = (uColMark)? uEcColor:uEvColor;
			}

		sArea.bottom  = sArea.top+pData->iRowHeight;
		sArea.left	  = iScrollX+uStartPos;


		if(aRnType[0]==NULLREGION)
			{
			goto ExtraDraw;
			}

		SelectObject(hDc,aRgn[0]);

		if(uDrawSize)	 										// Linken Bereich via Callback zeichnen
			{
			sArea.right	= sArea.left;
			sArea.left -= uDrawSize;
			uDrawColor	= pData->pDrawCallback(pData->pDrawCbParam,pEntry->lParam,uPos,pEntry->uState,hDc,&sArea);

			if(uDrawColor<LV_NOCOLOR)							// Das Rechteck mit einer Farbe fllen
				{
				if(uDrawColor&0x80000000)
					{
					uDrawColor = pData->aColors[uDrawColor&0x0F];
					}

				SetBkColor (hDc,uDrawColor);
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
				}

			sArea.left += uDrawSize;
			}


		pText				=  aEntries[0].pText;
		uTextSize			=  aEntries[0].iSize;
		iImage				=  aEntries[0].iImage;
		uBgColor			=  aEntries[0].uBkColor;
		uTextColor			=  aEntries[0].uTextColor;
		uBits				=  aEntries[0].uState;
		uBits			   |=  pEntry->uState;
		uBits			   &=  0xFFFF;
		uBits   		   |=  pEntry->bFlags<<16;
		pColors				=  NULL;

		if(uTextColor==LV_CHARCOLOR)							// Farben pro Buchstaben definiert
			{
			uTextColor	= LV_NOCOLOR;
			pColors		= *(LPBYTE*)pBasePtr;
			}

		if(uItem==pData->uSelectedItem && pData->uSelectedSub)
			{
			if(pData->uSelectedCount<=1 || !(pData->uStyle&LVS_EX_SUBSELECT))
				{
				uBits &= ~LVIS_SELECTED;
				}
			}

		if(uItem!=pData->uTrackedItem && pData->uTrackedSub)
			{
			uBits  &= ~LVIS_TRACKED;
			}

		if(uItem!=pData->uFocusItem && pData->uFocusSub)
			{
			uBits  &= ~LVIS_FOCUSED;
			}


		if(uTextSize && *pText<SPECIAL_MAX)						// Gibt es Spezialzeichen
			{
 			if(!pData->aColumn[0].bIndex)
				{
				SetBkColor(hDc,pData->aColors[LVC_BK]);
				}
			else if(uBgColor==LV_NOCOLOR)						// Hat Eintrag keine eigene Farbe
				{
				SetBkColor(hDc,uOutColor);
				}
			else if(uOutColor)									// Ist die Spalte markiert
				{
				SetBkColor(hDc,uBgColor-((uBgColor>>3)&0x001F1F1F));
				}
			else{
				SetBkColor(hDc,uBgColor);
				}

			iAdd = DrawSpecial(hDc,pText,uTextSize,&sArea,SPECIAL_WIDTH,pData->cButtonSize);
			pEntry->bStart = (BYTE)iAdd;

			if(iAdd)											// Spezialzeichen gefunden
				{
				pText	   += iAdd;
				uTextSize  -= iAdd;
				sArea.left += iAdd*SPECIAL_WIDTH;

				if(uStyleEx&LVS_EX_GRIDLINES)					// Seitliche Linie
					{
					SetBkColor(hDc,uFrColor);

					if(pData->aColumn[0].bIndex)
						{
						sButton.right	= sArea.left;
						sButton.left	= sArea.left-iAdd*SPECIAL_WIDTH;
						sButton.bottom	= sArea.bottom;
						sButton.top		= sArea.bottom-1;
						ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sButton,NULL,0,NULL);
						}
					else{
						sArea.right		= sArea.left+1;
						ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
						sArea.left		= sArea.right;
						}
					}
				}
			}
		else{
			pEntry->bStart = 0;
			}


		SetBkColor(hDc,uOutColor);

		if(uStyleEx&LVS_EX_GRIDLINES)							// Linien um den Eintrag zeichnen
			{
			sArea.right		= sArea.left+1;
			iStart			= sArea.left;
			iAdd			= 0;
			}
		else{
			iAdd = 0;
			}

		SetBkColor  (hDc,(uBgColor!=LV_NOCOLOR)? uBgColor:uOutColor);
		SelectObject(hDc,(uBits&LVIS_BOLD     )? pData->hFontB:pData->hFontN);

		if(pData->hStates)										// State-Icons anzeigen
			{
			sArea.right		= sArea.left+pData->iStatesSizeX;
			iYpos			= sArea.top+(iHeight-pData->iStatesSizeY)/2;
			i				= (uBits&LVIS_STATEIMAGEMASK)>>12;

			sArea.right    += iAdd;
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			sArea.left     += iAdd;

			if(pData->hStates==THEMEIMGLIST)					// Mit Thema zeichnen
				{
				if(pData->uStyleEx&LVS_EX_BITCHECKBOX)i++;

				if(i>=1 && i<=2)
					{
					if(pData->uCheckedItem!=uItem || pData->uCheckedSub)
						{
						uState = (i==1)? CBS_UNCHECKEDNORMAL:CBS_CHECKEDNORMAL;
						}
					else if(pData->uCheckedDown)
						{
						uState = (i==1)? CBS_UNCHECKEDPRESSED:CBS_CHECKEDPRESSED;
						}
					else{
						uState = (i==1)? CBS_UNCHECKEDHOT:CBS_CHECKEDHOT;
						}

					   iDiff = sArea.bottom-sArea.top;
					   iDiff-= pData->iStatesSizeY;
					if(iDiff > 0)
						{
						iValT	      = sArea.top;
						iValB		  = sArea.bottom;
						sArea.top	 += (iDiff+1)/2;
						sArea.bottom  = sArea.top+pData->iStatesSizeY;

						pDrawThemeBackg(pData->hThemeBt,hDc,BP_CHECKBOX,uState,&sArea,0);

						sArea.top	  = iValT;
						sArea.bottom  = iValB;
						}
					else{
						pDrawThemeBackg(pData->hThemeBt,hDc,BP_CHECKBOX,uState,&sArea,0);
						}
					}
				}
			else{
				ImageList_Draw(pData->hStates,i,hDc,sArea.left,iYpos,ILD_TRANSPARENT);
				}

			sArea.left     += pData->iStatesSizeX;
			iAdd		    = 0;
			}

		if(pData->hImages && iImage!=LV_NOIMAGE)				// Icon zeichnen vom Haupteintrag
			{
			sArea.right		= sArea.left+pData->iImagesSizeX+1;
			iYpos			= sArea.top+(iHeight-pData->iImagesSizeY)/2;

			sArea.right    += iAdd;
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			sArea.left     += iAdd;
			ImageList_Draw(pData->hImages,iImage,hDc,sArea.left+1,iYpos,ILD_TRANSPARENT|(uBits&(LVIS_OVERLAYMASK|LVIS_CUT)));

			sArea.left     += pData->iImagesSizeX+1;
			iAdd		    = 0;
			}

		sArea.right = uFirstPos;								// Text ausgeben vom Haupteintrag
		iYpos		= sArea.top+(iHeight-pData->iFontHeight)/2;


		if((uBits&(LVIS_SELECTED|LVIS_DROPHILITED|LVIS_UNTERLINE|LVIS_TRACKED|LVIS_FOCUSED)) || uTextColor!=LV_NOCOLOR)
			{													// Das Feld speziel zeichnen
			LPTSTR	pPtr;
			LPINT	pPos;

			if(uBits&pData->uColorOff)pColors=0;
			AllocTemp(pData,&pPos,&pPtr,uTextSize);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

			sButton.top		= iYpos;
			sButton.left    = sArea.left+4;
			sButton.right	= sArea.right;
			sButton.bottom	= iYpos+pData->iFontHeight+2;


			if(!uTextSize)										// Feld ohne Text ?
				{
				sButton.right-=2;
				sButton.bottom--;
				iPixels = 0;
				}
			else{
				if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
				if(pData->cHasFocus==0 || uItem!=pData->uSelectedItem || pData->uSelectedSub)
				if((uBits&LVIS_SELECTED) && !(uBits&(LVIS_DROPHILITED|LVIS_FOCUSED)))
					{
					sButton.left-=2;
					}
																// Ausgabegre berechnen
				DrawTextColor(hDc,pText,uTextSize,&sButton,uDrawFlags|DT_CALCRECT,pColors,pData->pCharColors,&pData->hFontN);
				iPixels = sButton.right-sButton.left;
				}

																// Passt der Text in die Spalte
			if(sButton.left+iPixels>=(int)(sArea.right-pData->uScrollX))
				{
				   iSize  = sArea.right-pData->uScrollX-sButton.left-2;
				   iSize -= (uBits&LVIS_BOLD)? pData->uTrippleB:pData->uTrippleN;
				if(iSize<3)
					{
					iCount = 0;
					}
				else{
					GetTextExtentEx(hDc,pText,uTextSize,iSize-2,&iCount,pPos,&sSize,pColors,&pData->hFontN);
					}
																// Temporren Text mit "..." erzeugen
				memcpy(pPtr       ,pText,iCount*sizeof(TCHAR));
				memcpy(pPtr+iCount,_T("..."),4 *sizeof(TCHAR));

				pText		  = pPtr;
				uTextSize	  = iCount+3;
				sButton.right = sArea.right-2;
				}

																// Das Feld selektiert zeichnen
			if((uBits&LVIS_SELECTED) && pData->cHasFocus && uItem==pData->uSelectedItem && !pData->uSelectedSub)
				{
				uTempColor=GetSysColor(COLOR_HIGHLIGHTTEXT);
				SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT));
				Rectangle   (hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
				}
			else{
				if(uBits&LVIS_DROPHILITED)
					{
					uTempColor =     GetSysColor     (COLOR_HIGHLIGHTTEXT);
					SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT   ));
					SelectObject(hDc,GetStockObject  (NULL_PEN          ));
					Rectangle   (hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
					}											// Ist das Feld ohne Focus ausgewhlt
				else if(uBits&LVIS_SELECTED)
					{
					if(pData->cHasFocus)
						{
						uTempColor =     GetSysColor     (COLOR_HIGHLIGHTTEXT);
						SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT));
						SelectObject(hDc,GetStockObject  (NULL_PEN       ));
						}
					else{
						if(uTextColor!=LV_NOCOLOR)
								uTempColor = uTextColor;
						else	uTempColor = pData->aColors[LVC_TEXT];

						if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
							{
							SelectObject(hDc,GetStockObject(NULL_BRUSH));
							}
						else{
							if(pData->uStyleEx&LVS_EX_ALTERNATECOLOR)
								{
								SetDCBrushColor(hDc,pData->aColors[LVC_NOFOCUS]);
								SelectObject(hDc,GetStockObject(DC_BRUSH));
								}
							else{
								SelectObject(hDc,GetSysColorBrush(COLOR_3DFACE));
								}
							}

						SelectObject(hDc,GetStockObject(NULL_PEN));
						}

					Rectangle(hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
					}
				else{											// Das Feld normal zeichnen
						 if(uBits&LVIS_TRACKED    )uTempColor = pData ->aColors[LVC_TRACK];
					else if(uTextColor==LV_NOCOLOR)uTempColor = pData ->aColors[LVC_TEXT ];
					else						   uTempColor = uTextColor;
					sButton.right--;
					sButton.left --;
					}

				SelectObject(hDc,hPatternPen);

				if(uBits&LVIS_FOCUSED)							// Einen punktierten Rahmen um den Text zeichnen
					{
					SelectObject(hDc,GetStockObject(NULL_BRUSH));
					Rectangle   (hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
					}
				}

			SetTextColor(hDc,uTempColor);
			sButton.left+=pData->iFontOff;
			DrawTextColor(hDc,pText,uTextSize,&sButton,uDrawFlags,pColors,pData->pCharColors,&pData->hFontN);


			if(uBits&(LVIS_UNTERLINE|LVIS_TRACKED))				// Text unterstreichen
			if(pText && *pText)
				{
				sButton.left   -= pData->iFontOff;
				sButton.right  -= pData->iFontOff;
				sButton.top	   += pData->iFontLine;
				sButton.bottom  = sButton.top+1;
				uOldColor=SetBkColor(hDc,uTempColor);
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sButton,NULL,0,NULL);
				SetBkColor (hDc,uOldColor);
				}

			SetTextColor(hDc,pData->aColors[LVC_TEXT]);
			}
		else{													// Das Feld normal ausgeben
			if(uTextSize)
				{
				sButton.top		= iYpos;
				sButton.left    = sArea.left+4;
				sButton.right	= sArea.right;
				sButton.bottom	= iYpos+pData->iFontHeight+2;
																// Textbreite berechnen
				DrawTextColor(hDc,pText,uTextSize,&sButton,uDrawFlags|DT_CALCRECT,pColors,pData->pCharColors,&pData->hFontN);

				iPixels = sButton.right-sButton.left;
				}
			else{
				iPixels = 0;
				}
																// Ist der Text grer als die Spalte
			if(sArea.left+iPixels>=(int)(sArea.right-pData->uScrollX))
				{
				LPINT	pPos;

				AllocTemp(pData,&pPos,NULL,uTextSize);

				   iSize  = sArea.right-sArea.left-pData->uScrollX;
				   iSize -= (uBits&LVIS_BOLD)? pData->uTrippleB:pData->uTrippleN;
				if(iSize<3)
					{
					iCount = 0;
					}
				else{
					GetTextExtentEx(hDc,pText,uTextSize,iSize-2,&iCount,pPos,&sSize,pColors,&pData->hFontN);
					}

				if(iCount>0)									// Passen noch Buchstaben vor "..."
					{
					sButton.right	= sArea.right;
					sArea.right		= sArea.left+2+pPos[iCount-1];

					ExtTextColor(hDc,sArea.left+2,iYpos,uTextFlags,&sArea,pText,iCount,pColors,pData->pCharColors,&pData->hFontN);

					sArea.left		= sArea.right;
					sArea.right		= sButton.right;

					ExtTextOutW(hDc,sArea.left  ,iYpos,ETO_OPAQUE|ETO_CLIPPED,&sArea,L"...",3,NULL);
					}
				else{
					ExtTextOutW(hDc,sArea.left+2,iYpos,ETO_OPAQUE|ETO_CLIPPED,&sArea,L"...",3,NULL);
					}
				}
			else if(!uTextSize)									// Win7 hat ein Problem mit Lnge 0 und ExtTextOut und Aero	
				{
				HGDIOBJ hOldPen;
				HGDIOBJ hOldBck;

				hOldPen = SelectObject(hDc,GetStockObject(NULL_PEN));
				hOldBck = SelectColorBrush(hDc,GetBkColor(hDc));

				Rectangle(hDc,sArea.left,sArea.top,sArea.right+1,sArea.bottom+1);

				SelectObject(hDc,hOldBck);
				SelectObject(hDc,hOldPen);
				}
			else{
				ExtTextColor(hDc,sArea.left+2,iYpos,uTextFlags,&sArea,pText,uTextSize,pColors,pData->pCharColors,&pData->hFontN);
				}
			}

		   i  = sArea.left-iScrollX;
		   i += iPixels+5;
		if(i>iMaxX)iMaxX=i;

		if(uStyleEx&LVS_EX_GRIDLINES)							// Linien um den Eintrag zeichnen
			{
			SetBkColor(hDc,uFrColor);

			sArea.top    += iHeight;
			sArea.left	  = iStart;
			sArea.bottom  = sArea.top+1;

			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

			sArea.top    -= iHeight;
			}

		//************ Extraeintrge zeichnen *********************************

ExtraDraw:

		for(uColumn=0;uColumn<=pData->uColumnCount;uColumn++)	// Extra Spalten zeichnen
			{
			uExtra = pData->aColumnPos[uColumn  ];
			uNext  = pData->aColumnPos[uColumn+1];

			if(uExtra==0)continue;								// Haupeintrag nicht Zeichen

			if(pData->aColumn[uExtra].sReal==0)					// Ist die Spalte sichtbar
			if(uColumn<pData->uColumnCount)
				{
				continue;
				}

			if(uColMark!=pData->aColumn[uExtra].bMark)			// Ist die Spalte anderst markiert
			if(!(pEntry->uState&LVIS_SELECTED) || !(uStyleEx&LVS_EX_FULLROWSELECT))
				{
				if(uPos&1)
					{
					uColMark  =  pData->aColumn[uExtra].bMark;
					uOutColor = (uColMark)? uOcColor:uOdColor;
					}
				else{
					uColMark  =  pData->aColumn[uExtra].bMark;
					uOutColor = (uColMark)? uEcColor:uEvColor;
					}
				}

			GetRgnBox(aRgn[uExtra],&sButton);

			if(aRnType[uExtra]==NULLREGION)continue;

			SelectObject(hDc,aRgn[uExtra]);

			sArea.left  = pData->aColumnXpos[uExtra];
			sArea.left += iScrollX;


			if(uStyleEx&LVS_EX_GRIDLINES)						// Linie um den Eintrag zeichnen
				{
				SetBkColor(hDc,uFrColor);
																// Linke Linie
				sArea.right   = sArea.left+1;
				sArea.bottom += 1;

				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

				sArea.left   += 1;								// Untere Linie
				sArea.top    += iHeight;
				sArea.bottom  = sArea.top+1;
				sArea.right	  = pData->aColumnXpos[uNext];
				if(uColumn<pData->uColumnCount)sArea.right+=iScrollX;

				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

				sArea.top    -= iHeight;
				sArea.bottom -= 1;
				iAdd		  = 1;
				}

			if(sArea.left>(int)pData->uSizeX)break;				// Noch im sichtbaren Bereich

			sArea.right	 = pData->aColumnXpos[uNext];


			if(uExtra<pData->uColumnCount)						// Ist es die letzte Spalte ?
				{
				sArea.right += iScrollX;
				}


			pColItem		=  aEntries+uExtra;
			iSize			=  pData->iSubImgXsize;
			hImgList		=  pData->hSubImg;
			pText			=  pColItem->pText;
			uTextSize		=  pColItem->iSize;
			iImage			=  pColItem->iImage;
			uBgColor		=  pColItem->uBkColor;
			uTextColor		=  pColItem->uTextColor;
			uBits			=  pColItem->uState;
			uBits	 	   |=  pEntry->uState;
			uBits	 	   &=  0xFFFF;
			uBits    	   |=  pEntry->bFlags<<16;
			pColors			=  NULL;

			if(uTextColor==LV_CHARCOLOR)						// Farben pro Buchstaben definiert
				{
				uTextColor	= LV_NOCOLOR;
				pTextPtr	=  pBasePtr+uExtra*256;
				pColors		= *(LPBYTE*)pTextPtr;
				}

			if(uExtra!=pData->uSelectedSub)
				{
				uBits  &= ~LVIS_SELECTED;
				}

			if(uExtra!=pData->uTrackedSub)
				{
				uBits  &= ~LVIS_TRACKED;
				}

			if(uExtra!=pData->uFocusSub)
				{
				uBits  &= ~LVIS_FOCUSED;
				}

			if(uBgColor==LV_NOCOLOR)							// Hat Eintrag keine eigene Farbe
				{
				SetBkColor(hDc,uOutColor);
				}
			else if(uColMark)									// Ist die Spalte markiert
				{
				SetBkColor(hDc,uBgColor-((uBgColor>>3)&0x001F1F1F));
				}
			else{
				SetBkColor(hDc,uBgColor);
				}


			if(pData->aColumn[uExtra].bEdit>=LVAX_CHECK)		// Checkboxen statt Icons
				{
				hImgList =  pData->hChecks;
				iSize	 =  pData->iChecksSizeX;
				iImage   = (uBits&LVIS_STATEIMAGEMASK)>>12;
				uBits   &= ~LVIS_OVERLAYMASK;

				if(iImage&8)
				if(pData->aColumn[uExtra].bFlags&LVAE_STATEENABLE)
					{
					iImage &= 7;
					}
				}

			if(hImgList && iImage!=LV_NOIMAGE)					// Icon zeichnen
				{
				sArea.right     = sArea.left+iSize+2;
				iYpos		    = sArea.top+(iHeight-iSize)/2;

				SelectObject(hDc,(uBits&LVIS_BOLD)? pData->hFontB:pData->hFontN);
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

				if(hImgList==THEMEIMGLIST)						// Mit Thema zeichnen
					{
					if(pData->uStyleEx&LVS_EX_BITCHECKBOX)iImage++;

					if(iImage==1 || iImage==2)
						{
						if(pData->uCheckedItem!=uItem || pData->uCheckedSub!=uExtra)
							{
							uState = (iImage==1)? CBS_UNCHECKEDNORMAL:CBS_CHECKEDNORMAL;
							}
						else if(pData->uCheckedDown)
							{
							uState = (iImage==1)? CBS_UNCHECKEDPRESSED:CBS_CHECKEDPRESSED;
							}
						else{
							uState = (iImage==1)? CBS_UNCHECKEDHOT:CBS_CHECKEDHOT;
							}

						   iDiff = sArea.bottom-sArea.top;
						   iDiff-= pData->iChecksSizeY;
						if(iDiff > 0)
							{
							iValT	      = sArea.top;
							iValB		  = sArea.bottom;
							sArea.top	 += (iDiff+1)/2;
							sArea.bottom  = sArea.top+pData->iChecksSizeY;

							pDrawThemeBackg(pData->hThemeBt,hDc,BP_CHECKBOX,uState,&sArea,0);

							sArea.top	  = iValT;
							sArea.bottom  = iValB;
							}
						else{
							pDrawThemeBackg(pData->hThemeBt,hDc,BP_CHECKBOX,uState,&sArea,0);
							}
						}
					}
				else{
					ImageList_Draw(hImgList,iImage,hDc,sArea.left+1,iYpos,ILD_TRANSPARENT|(uBits&(LVIS_OVERLAYMASK|LVIS_CUT)));
					}

				sArea.left  += iSize+1;
				sArea.right  = pData->aColumnXpos[uNext];
				sArea.right += iScrollX;
				}


			iYpos = sArea.top+(iHeight-pData->iFontHeight)/2;
			SelectObject(hDc,(uBits&LVIS_BOLD)? pData->hFontB:pData->hFontN);


			if((uBits&(LVIS_SELECTED|LVIS_DROPHILITED|LVIS_UNTERLINE|LVIS_TRACKED|LVIS_FOCUSED)) || uTextColor!=LV_NOCOLOR)
				{												// Text ausgeben in speziellem Format
				LPTSTR	pPtr;
				LPINT	pPos;

				if(uBits&pData->uColorOff)pColors=0;
				AllocTemp(pData,&pPos,&pPtr,uTextSize);
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

				sButton.top		= iYpos;
				sButton.left    = sArea.left+4;
				sButton.right	= sArea.right;
				sButton.bottom	= iYpos+pData->iFontHeight+2;

				if(!uTextSize)									// Breite und Hhe berechnen
					{
					sButton.left   -= 1;
					sButton.right  -= 2;
					sButton.bottom -= 1;
					iPixels = 0;
					}
				else{
					if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
					if(pData->cHasFocus==0 || uItem!=pData->uSelectedItem)
					if((uBits&LVIS_SELECTED) && !(uBits&(LVIS_DROPHILITED|LVIS_FOCUSED)))
						{
						sButton.left-=2;
						}

					DrawTextColor(hDc,pText,uTextSize,&sButton,uDrawFlags|DT_CALCRECT,pColors,pData->pCharColors,&pData->hFontN);
					iPixels = sButton.right-sButton.left;
					}


				if(sButton.left+iPixels>=sArea.right)			// Passt der Text in die Spalte
					{
					if(uTextSize>253)uTextSize=253;

					   iSize  = sArea.right-sButton.left-2;
					   iSize -= (uBits&LVIS_BOLD)? pData->uTrippleB:pData->uTrippleN;
					if(iSize<3)
						{
						iCount = 0;
						}
					else{
						GetTextExtentEx(hDc,pText,uTextSize,iSize-2,&iCount,pPos,&sSize,pColors,&pData->hFontN);
						}

					memcpy(pPtr       ,pText,iCount*sizeof(TCHAR));
					memcpy(pPtr+iCount,_T("..."),4 *sizeof(TCHAR));

					pText		  = pPtr;
					uTextSize	  = iCount+3;
					sButton.right = sArea.right-2;
					}


				switch(pData->aColumn[uExtra].bAlign)			// Textausrichtung ausgleichen
					{
				case DT_CENTER:	iDelta	= sArea  .right-sArea  .left;
								iDelta -= sButton.right-sButton.left;
								iDelta -= 6;
								iDelta /= 2;
								sButton.right += iDelta;
								sButton.left  += iDelta;
								break;

				case DT_RIGHT:	iDelta	= sArea  .right-sArea  .left;
								iDelta -= sButton.right-sButton.left;
								iDelta -= 6;
								sButton.right += iDelta;
								sButton.left  += iDelta;
								break;

					}
																// Ist das Feld ohne Focus ausgewhlt
				if((uBits&LVIS_SELECTED) && pData->cHasFocus && uItem==pData->uSelectedItem)
					{
					uTempColor = GetSysColor(COLOR_HIGHLIGHTTEXT);
					SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT));
					Rectangle   (hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
					}
				else{
					if(uBits&LVIS_DROPHILITED)
						{
						uTempColor =     GetSysColor     (COLOR_HIGHLIGHTTEXT);
						SelectObject(hDc,GetSysColorBrush(COLOR_HIGHLIGHT   ));
						SelectObject(hDc,GetStockObject  (NULL_PEN          ));
						Rectangle   (hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
						}
					else if(uBits&LVIS_SELECTED && uItem==pData->uSelectedItem)
						{
						if(uTextColor!=LV_NOCOLOR)
								uTempColor = uTextColor;
						else	uTempColor = pData->aColors[LVC_TEXT];

						if(pData->uStyleEx&LVS_EX_FULLROWSELECT)
							{
							SelectObject(hDc,GetStockObject(NULL_BRUSH));
							}
						else{
							if(pData->uStyleEx&LVS_EX_ALTERNATECOLOR)
								{
								SetDCBrushColor(hDc,pData->aColors[LVC_NOFOCUS]);
								SelectObject(hDc,GetStockObject(DC_BRUSH));
								}
							else{
								SelectObject(hDc,GetSysColorBrush(COLOR_3DFACE));
								}
							}

						SelectObject(hDc,GetStockObject(NULL_PEN));
						Rectangle(hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
						}
					else{
							 if(uBits&LVIS_TRACKED    )uTempColor = pData ->aColors[LVC_TRACK];
						else if(uTextColor==LV_NOCOLOR)uTempColor = pData ->aColors[LVC_TEXT ];
						else						   uTempColor = uTextColor;
						sButton.right--;
						sButton.left --;
						}

					SelectObject(hDc,hPatternPen);

					if(uBits&LVIS_FOCUSED)						// Punktierten Rahmen um Text zeichnen
						{
						SelectObject(hDc,GetStockObject(NULL_BRUSH));
						Rectangle   (hDc,sButton.left-2,sButton.top-1,sButton.right+2,sButton.bottom+1);
						}
					}

				SetTextColor(hDc,uTempColor);
				sButton.left+=pData->iFontOff;

				DrawTextColor(hDc,pText,uTextSize,&sButton,uDrawFlags,pColors,pData->pCharColors,&pData->hFontN);

				if(uBits&(LVIS_UNTERLINE|LVIS_TRACKED))			// Text unterstreichen
				if(pText && *pText)
					{
					sButton.left   -= pData->iFontOff;
					sButton.right  -= pData->iFontOff;
					sButton.top	   += pData->iFontLine;
					sButton.bottom  = sButton.top+1;
					uOldColor=SetBkColor(hDc,uTempColor);
					ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sButton,NULL,0,NULL);
					SetBkColor (hDc,uOldColor);
					}

				SetTextColor(hDc,pData->aColors[LVC_TEXT]);
				}
			else{												// Den Text ganz normal ausgeben
				sButton.top		= iYpos;
				sButton.left    = sArea.left+4;
				sButton.right	= sArea.right;
				sButton.bottom	= iYpos+pData->iFontHeight+2;

				if(uTextSize)									// Textbreite berechnen
					{
					DrawTextColor(hDc,pText,uTextSize,&sButton,uDrawFlags|DT_CALCRECT,pColors,pData->pCharColors,&pData->hFontN);
					iPixels = sButton.right-sButton.left;
					}
				else{
					iPixels = 0;
					}

				if(sArea.left+iPixels>=sArea.right)				// Ist der Text grer als die Spalte
					{
					LPINT	pPos;

					AllocTemp(pData,&pPos,NULL,uTextSize);

					   iSize  = sArea.right-sArea.left;
					   iSize -= (uBits&LVIS_BOLD)? pData->uTrippleB:pData->uTrippleN;
					if(iSize<3)
						{
						iCount = 0;
						}
					else{
						GetTextExtentEx(hDc,pText,uTextSize,iSize-2,&iCount,pPos,&sSize,pColors,&pData->hFontN);
						}

					if(iCount>0)								// Passen noch Buchstaben vor "..."
						{
						sButton.right	= sArea.right;
						sArea.right		= sArea.left+2+pPos[iCount-1];

						ExtTextColor(hDc,sArea.left+2,iYpos,uTextFlags,&sArea,pText,iCount,pColors,pData->pCharColors,&pData->hFontN);

						sArea.left		= sArea.right;
						sArea.right		= sButton.right;

						ExtTextOut(hDc,sArea.left  ,iYpos,ETO_OPAQUE|ETO_CLIPPED,&sArea,_T("..."),3,NULL);
						}
					else{
						ExtTextOut(hDc,sArea.left+2,iYpos,ETO_OPAQUE|ETO_CLIPPED,&sArea,_T("..."),3,NULL);
						}
					}
				else{
					if(!uTextSize)								// Win7 hat ein Problem mit Lnge 0 und ExtTextOut und Aero	
						{
						HGDIOBJ hOldPen;
						HGDIOBJ hOldBck;

						hOldPen = SelectObject(hDc,GetStockObject(NULL_PEN));
						hOldBck = SelectColorBrush(hDc,GetBkColor(hDc));

						Rectangle(hDc,sArea.left,sArea.top,sArea.right+1,sArea.bottom+1);

						SelectObject(hDc,hOldBck);
						SelectObject(hDc,hOldPen);
						}
					else{
						switch(pData->aColumn[uExtra].bAlign)	// Textausrichtung
							{
						case DT_CENTER:	SetTextAlign(hDc,TA_CENTER|TA_TOP);
										ExtTextColor(hDc,(sArea.right+sArea.left)/2,iYpos,uTextFlags,&sArea,pText,uTextSize,pColors,pData->pCharColors,&pData->hFontN);
										SetTextAlign(hDc,TA_LEFT|TA_TOP);
										break;

						case DT_RIGHT:	SetTextAlign(hDc,TA_RIGHT|TA_TOP);
										ExtTextColor(hDc,sArea.right-2,iYpos,uTextFlags,&sArea,pText,uTextSize,pColors,pData->pCharColors,&pData->hFontN);
										SetTextAlign(hDc,TA_LEFT|TA_TOP);
										break;

						default:		ExtTextColor(hDc,sArea.left+2,iYpos,uTextFlags,&sArea,pText,uTextSize,pColors,pData->pCharColors,&pData->hFontN);
										break;
							}
						}
					}
				}
			}


		sArea.top += pData->iRowHeight;

		if(sArea.top>=sRect.bottom)								// Unteres Ende des Fentser erreicht
			{
			break;
			}
		}


	if(sArea.top<sRect.bottom)									// Untere Flche ohne Eintrge fllen
		{
		SelectObject(hDc,hRgnMain);
																// Gibt es markierte Spalten
		if(pData->uMarkedCols>0 && (pData->cIsEnabled || !(pData->uStyleEx&LVS_EX_GRAYEDDISABLE)))
			{
			sRect.right = 0-pData->uScrollX;

			for(uColumn=0;uColumn<pData->uColumnCount;uColumn++)
				{
				uExtra		 = pData->aColumnPos[uColumn  ];
				uNext		 = pData->aColumnPos[uColumn+1];
				uMark		 = pData->aColumn[uExtra].bMark;
				sRect.top    = sArea.top;
				sRect.left   = sRect.right;
				sRect.right  = pData->aColumnXpos[uNext]+uMark;
				sRect.right -= pData->uScrollX;
				if(sRect.right==sRect.left+1)uMark=0;
				SetBkColor (hDc,(uMark)? pData->aColors[LVC_COLBK]:uBkColor);
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
				}

			sRect.top   = sArea.top;
			sRect.left  = sRect.right;
			sRect.right = pData->uSizeX;
			SetBkColor (hDc,uBkColor);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);
			}
		else{													// Keine markierten Spalten
			sRect.top	=	sArea.top;
			SetBkColor (hDc,uBkColor);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sRect,L" ",1,NULL);
			}
		}


	if(uDrawSize)												// Existiert ein linker Draw-Bereich
		{
		memset(&sArea,0,sizeof(sArea));							// Exit-Call
		pData->pDrawCallback(pData->pDrawCbParam,0,0xFFFFFFFF,0,hDc,&sArea);
		}


	if(pData->iMaxSizeX!=iMaxX)									// X-Scrollbar aktualisieren
		{
		   pData->iMaxSizeX=iMaxX;
		if(pData->uColumnCount==0)
		if(pData->iMaxSizeX!=(int)pData->uOldCountX)
			{
			UpdateScrollX(pData);
			}
		}


	UNLOCK(pData);

 	DeleteObject(hRgnMain);

    for(uPos=0;uPos<uRgnCount;uPos++)
		{
        DeleteObject(aRgn[uPos]);
        }

}



