//*****************************************************************************
//*
//*
//*		TextBase.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#include 	<winreg.h>
#include 	<memory.h>
#include 	<stdlib.h>
#include 	<string.h>
#include 	"../RegKeys.h"
#include 	"../StringFunctions.h"


#ifdef		TO_TEXTWND
	#define	CTextView	CTextWnd
	#define	CAnsiView	CAnsiWnd
	#define CView		CWnd
#else
	#ifdef	CTextView
	#undef 	CTextView
	#endif
	#ifdef	CAnsiView
	#undef 	CAnsiView
	#endif
	#ifdef	CView
	#undef 	CView
	#endif
#endif


#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef		USE_VIRTUAL_LINES
#define 	TEXT_STEP(a,b)		TranslateLine(a,b)
#else
#define 	TEXT_STEP(a,b)		((a)+(b))
#endif

#define 	ENTRIES(a)			(sizeof(a)/sizeof((a)[0]))

#ifndef 	TO_TEXTWND
#define 	NOT_PRINTER			&& !(iFlags&1)
#else
#define 	NOT_PRINTER
#endif


const int	iKeyMaskFirst       = (30<< 0)|(28<< 5)|(24<<10)|(16<<15);
const int	iKeyMaskDefault		= (28<< 0)|(28<< 5)|( 3<<10)|( 3<<15)|(3<<20);
const int	iKeyMaskDefaultUl	= (24<< 0)|(24<< 5)|(24<<10)|( 7<<15)|(7<<20);
const int	iKeyMaskExtentedUl	= ( 6<< 0)|( 1<< 5)|( 1<<10);
const int	iKeyMaskExtented	= ( 2<< 0)|( 1<< 5);
const int	iKeyMaskUpperCase   = (16<<10)|(16<<15);

inline	int strtoc      (const unsigned char *pStr,int      *pLen ){return strtoc      ((const char   *)pStr,pLen )+strwlen("");}
inline	int chartoutf8  (const unsigned char *pStr,unsigned	 uChar){return chartoutf8  ((      char   *)pStr,uChar);}
inline	int utf8tochar  (const unsigned char *pStr,unsigned &uChar){return utf8tochar  ((const char   *)pStr,uChar);}
inline	int utf8prechar (const unsigned char *pStr,unsigned &uChar){return utf8prechar ((const char   *)pStr,uChar);}
inline	int chartoutf16 (const unsigned char *pStr,unsigned &uChar){return chartoutf16 ((      wchar_t*)pStr,uChar);}
inline	int utf16tochar (const unsigned char *pStr,unsigned &uChar){return utf16tochar ((const wchar_t*)pStr,uChar);}
inline	int utf16prechar(const unsigned char *pStr,unsigned &uChar){return utf16prechar((const wchar_t*)pStr,uChar);}


//*****************************************************************************
//*
//*     Definitionen fr nicht Implementierte  Menfunktionen
//*
//*****************************************************************************

#ifndef		ID_EDIT_FIND
#define		ID_EDIT_FIND		0x880F						// Suchen Dialog
#endif
#ifndef		ID_EDIT_FIND_NEXT
#define		ID_EDIT_FIND_NEXT	0x8810						// Suche weiter
#endif
#ifndef		ID_EDIT_FIND_WORD
#define		ID_EDIT_FIND_WORD	0x8811						// Suche markiertes Word
#endif
#ifndef		ID_EDIT_REPLACE
#define		ID_EDIT_REPLACE		0x8812						// ndern Dialog
#endif
#ifndef		ID_EDIT_CONFIG
#define		ID_EDIT_CONFIG		0x8813						// Text Einstellungen
#endif
#ifndef		ID_EDIT_CUT
#define		ID_EDIT_CUT   		0x8814						// Text Ausschneiden
#endif
#ifndef		ID_EDIT_COPY
#define		ID_EDIT_COPY   		0x8815						// Text Kopieren
#endif
#ifndef		ID_EDIT_CLEAR
#define		ID_EDIT_CLEAR		0x8816						// Text lschen
#endif
#ifndef		ID_EDIT_PASTE
#define		ID_EDIT_PASTE		0x8817						// Text einfgen
#endif
#ifndef		ID_EDIT_UNDO
#define		ID_EDIT_UNDO		0x8818						// Rckgngig machen
#endif
#ifndef		ID_EDIT_UNDOBACK
#define		ID_EDIT_UNDOBACK	0x8819						// Widerherstellen
#endif
#ifndef		ID_EDIT_COPY_0
#define		ID_EDIT_COPY_0		0x8820						// Kopieren in Speicher(0-9)
#endif
#ifndef		ID_EDIT_COPY_9
#define		ID_EDIT_COPY_9		0x8829						// Kopieren in Speicher(0-9)
#endif
#ifndef		ID_EDIT_PASTE_0
#define		ID_EDIT_PASTE_0		0x8830						// Einfgen aus Speicher(0-9)
#endif
#ifndef		ID_EDIT_PASTE_9
#define		ID_EDIT_PASTE_9		0x8839						// Einfgen aus Speicher(0-9)
#endif
#ifndef		ID_EDIT_CUT_0
#define		ID_EDIT_CUT_0		0x8840						// Auschneiden in Speicher(0-9)
#endif
#ifndef		ID_EDIT_CUT_9
#define		ID_EDIT_CUT_9		0x8849						// Auschneiden in Speicher(0-9)
#endif
#ifndef		ID_EDIT_SELECTALL
#define		ID_EDIT_SELECTALL	0x884A						// Alles auswhlen
#endif
#ifndef		ID_EDIT_SELECTWORD
#define		ID_EDIT_SELECTWORD	0x884B						// Das Word beim Cursor whlen
#endif
#ifndef		ID_WORD_COPY
#define 	ID_WORD_COPY		0x884C						// Das aktuelle Wort kopieren
#endif
#ifndef		ID_DICONOFF
#define 	ID_DICONOFF			0x884D						// Rechschreibprfung ein/aus
#endif
#ifndef		ID_WORD_MARK
#define 	ID_WORD_MARK		0x884E						// Alle Wter wie das beim Cursor markieren
#endif

#define		ID_STATUSBARSET		0x88881212					// Statusbar ID
#define		ID_UPDATETICK		0x00001213					// Ticker fr Wordmarkierung
#define		STB_TIMER			330							// Statusbar Timer
#define		STB_COUNT			2							// Statusbar Anzahl
#define 	COLOR_MARK			1							// Farbe fr Markierung
#define 	COLOR_HIGH			2							// Farbe fr Worthervorhebung
#define 	COLOR_WORD			3							// Farbe fr Wortmarkierungen
#define 	DIC_INFO			3							// Positions der Rechtschreibinfos
#define 	TAB32_TEXT			"                                "

// Konstanten fr Undo Funktionen

#define		UNDO_DEL			0x00000001					// Bereich ist zum Lschen
#define 	UNDO_INS			0x00000002					// Text einfgen
#define 	UNDO_CHAR 			0x00000004					// Zeichen Eingabe
#define 	UNDO_OVERWR			0x00000008					// berschreiben einschalten
#define 	UNDO_2TRUNS			0x00000010					// Zwei Undo's wiederholen
#define 	UNDO_SETPOS			0x00000020					// Cursor auf Anfangsposition (pos.x/y)
#define 	UNDO_SETDEL			0x00000040					// Cursor auf Endposition     (sDelPt.x/y)

// Konstanten fr Wrter in **m_pWordList Liste

#define		WAM					0							// Zeichen muss vor Anfang sein
#define		WEM					1							// Zeichen muss nach Ende sein
#define		WSO					2							// Solange-Gruppe weiter zeichnen
#define		WAN					3							// Zeichen darf nicht vor Anfang sein
#define		WGE					4							// Gruppe einschalten
#define		WGA					5							// Gruppe ausschalten
#define		WNO					6							// Gruppen die eingeschalten sein mssen
#define		WFB					7							// Farbe fr Wort
#define		WAR					8							// Art des Wortes
#define 	WCH					9							// Zeilenweiter Zeichen
#define		WLE					10							// Lnge des Wortes
#define		WBU					11							// Erster Buchstabe

#ifdef		USE_UTF8
#define 	TEXT_IS_DEF			TEXT_IS_UTF8				// Standartformat ist UTF8
#define 	FIND_DEF			0x0100
#else
#define 	TEXT_IS_DEF			0							// Standartformat ist ANSI
#define 	FIND_DEF			0
#endif

#ifdef		UNICODE
#define 	TEXT_IS_MODE		TEXT_IS_WIDE				// IO-Format ist UNICODE
#else
#define 	TEXT_IS_MODE		0							// IO-Format ist ANSI
#endif

#define 	SET_BIT(array,idx)	if((UINT)(idx)<sizeof(array)*8)(array)[(idx)/8]|=1<<((idx)&7);




//*****************************************************************************
//*
//*     Nachrichten Verarbeitung
//*
//*****************************************************************************

#ifndef 	TO_TEXTWND
IMPLEMENT_DYNCREATE(CTextView,CAnsiView)
#endif

BEGIN_MESSAGE_MAP  (CTextView,CAnsiView)
	//{{AFX_MSG_MAP(CTextView)
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_COMMAND(ID_WORD_COPY		 	      ,OnCopyWord)
	ON_COMMAND(ID_EDIT_UNDOBACK			  ,OnUndoBack)
	ON_COMMAND(ID_EDIT_UNDO				  ,OnUndo)
	ON_COMMAND(ID_EDIT_CUT				  ,OnCut)
	ON_COMMAND(ID_EDIT_COPY				  ,OnCopy)
	ON_COMMAND(ID_EDIT_CLEAR			  ,OnClear)
	ON_COMMAND(ID_EDIT_PASTE              ,OnPaste)
	ON_COMMAND(ID_EDIT_CONFIG			  ,OnConfigView)
	ON_COMMAND(ID_EDIT_REPLACE			  ,OnRepalceView)
	ON_COMMAND(ID_EDIT_FIND   			  ,OnFindView)
	ON_COMMAND(ID_EDIT_FIND_NEXT		  ,OnFindNext)
	ON_COMMAND(ID_EDIT_FIND_WORD		  ,OnFindWord)
	ON_COMMAND(ID_EDIT_SELECTALL		  ,OnSelectAll)
	ON_COMMAND(ID_EDIT_SELECTWORD		  ,OnSelectWord)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT      ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY     ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR	  ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO	  ,OnMenuUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDOBACK ,OnMenuUndoBack)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE	  ,OnMenuClipboard)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND_NEXT,OnMenuFind)
	ON_MESSAGE(WM_ANSIINFO				  ,OnTextInfo)
	//}}AFX_MSG_MAP
	#ifdef	USE_DICIONARY
	ON_COMMAND(ID_DICONOFF				  ,OnDicOnOff)
	ON_UPDATE_COMMAND_UI(ID_DICONOFF	  ,OnMenuDicOn)
	#endif
	#ifdef	USE_MARK_HIGHLIGHT
	ON_COMMAND(ID_WORD_MARK				  ,OnMarkOnOff)
	ON_UPDATE_COMMAND_UI(ID_WORD_MARK	  ,OnMenuMarkOn)
	#endif


END_MESSAGE_MAP()

//*****************************************************************************
//*
//*     Statische Variabeln
//*
//*****************************************************************************

int		CTextView::m_iWindowCount	= 0;					// Anzahl der Fenster insgesamt
int		CTextView::m_iTabWidth		= 4;					// Breite der Tab's
int		CTextView::m_iFlags			= FLAG_BRACKET|			// Flags fr Text-Fenster
									  FLAG_BRACKET_MODE|
									  FLAG_WORD_JMP_MISC|
									  FLAG_VIRTUAL_SCREEN|
									  FLAG_FIND_ALL;

#ifdef 	USE_DICIONARY
int		CTextView::m_iDicFlags		= DIC_DEFAULT;			// Flags fr die Rechtschreibprfung
HDIC	CTextView::m_hDicGlobal		= 0;					// Wrterbuch
HDIC	CTextView::m_hDicLocal		= 0;					// Pershnlichse Wrterbuch
char	CTextView::m_cDicNameG[64]	= "";					// Name des geladenen Wrterbuchs
char	CTextView::m_cDicNameL[64]	= "";					// Name des geladenen Wrterbuchs
#endif

char	CTextView::m_aAccelTab1[]={ "+-,.#<" };
char	CTextView::m_aAccelTab2[]={	(char)0xBA,(char)0xC0,(char)0xDE,
									(char)0xBB,(char)0xBD,(char)0xBC,
									(char)0xBE,(char)0xBF,(char)0xDB,
									(char)0xE2,(char)0xDD,0 };

//*****************************************************************************
//*
//*     Konstruktor
//*
//*****************************************************************************
CTextView::CTextView(int iCharMax,int iLinesMax,int iMode,char *pGroup):CAnsiView( pGroup )
{

	ASSERT(iLinesMax>16);

	#ifdef USE_VIRTUAL_LINES
	ASSERT(iLinesMax<65535 || TEXT_MAX_LINES>=65535);
	#endif


	m_iWindowCount     += 1;
	m_cNotChange		= iMode&FLAG_DONT_CHANGE;
	m_iLineWidthMax		= iCharMax;
	m_iMaxChars			= iCharMax;
	m_cHasTabLoop 		= 0;
	m_iColorMode   		= 0;
	m_cChanged    		= 0;
	m_iUntilColors		= 0;
	m_iTextMargin		= 32;


	m_pNullLine			= new uchar [iCharMax+16];			// Temporre Zeile fr interen Gebrauch
	m_pLineList			= new TextLinePtr[TEXT_LINES_ADD];	// Speicherblock fr Zeilenadressen
	m_iLineListSize		= TEXT_LINES_ADD;
	m_iLinesMax			= iLinesMax;
	m_iLineCount		= 0;
	m_pColumColors		= 0;

	m_iWordPosX			= 0;								// Wort-Position fr rechten Mausklick
	m_iWordPosY			= 0;
	m_iCursorLastX		= 0;
	m_iCursorX			= 0;								// Cursor-Position
	m_iCursorY			= 0;
	m_iScrollX			= 0;								// Scrollposition
	m_iScrollY			= 0;
	m_iMarkX			= 0; 								// Markierungsposition
	m_iMarkY			= 0;
	m_iMarkOn			= 0;								// Nichts ist markiert


	#ifdef USE_WORD_HIGHLIGHT

	m_iFlags		   |= FLAG_HAS_HIGHLIGHT;
	m_ucHighlightChar	= 0;								// Erstes Zeichen des hervorgehoben Wortes
	m_ucHighlightSize	= 0;								// Lnge des hervorgehoben Wortes
	m_ucHighlightMode	= (iMode&FLAG_DONT_HIGHLIGHT)? 255:0;

	#endif

	#ifdef USE_MARK_HIGHLIGHT

	m_iFlags		   |= FLAG_HAS_WORDMARK;
	m_ucWordMarkChar	= 0;								// Erstes Zeichen des hervorgehoben Wortes
	m_ucWordMarkSize	= 0;								// Lnge des hervorgehoben Wortes
	m_ucWordMarkMode	= (iMode&FLAG_DONT_MARKWORDS)? 255:0;
	m_ucWordMarkTicker	= 0;

	#endif


	if(m_pGroup->iColorCount<=1)
		{
		ColorAdd(RGB(255,255,255),RGB(0,0,255),"Markierung",2);
		}

	#ifdef USE_WORD_HIGHLIGHT

	if(m_pGroup->iColorCount<=2 && m_ucHighlightMode!=255)
		{
		ColorAdd(RGB(255,255,255),RGB(255,215,175),"Worthervorherbung",3);
		}

	#endif

	#ifdef USE_MARK_HIGHLIGHT

	if(m_pGroup->iColorCount<=3 && m_ucHighlightMode!=255)
		{
		ColorAdd(RGB(255,255,255),RGB(255,255,200),"Wortmarkierungen",4);
		}

	#endif

	memset(m_aAccelNamen,0,sizeof(m_aAccelNamen));
	memset(m_aCopyLen   ,0,sizeof(m_aCopyLen   ));
	memset(m_pCopyMem   ,0,sizeof(m_pCopyMem   ));
	memset(m_aUndo      ,0,sizeof(m_aUndo      ));			// Undo-Speicher rcksetzen

	m_iUndoPos			= 0;
	m_iUndoMax			= 0;
	m_iUndoMin			= 0;

	m_pChangeText		= 0;								// ndern Text
	m_pFindText			= 0;								// Suchen Text
	m_pFindSelection	= 0;								// Suchen Auswahl
	m_cStatusbarInit	= 0;

	m_iAreaStartX		= 0;								// ndern Bereich
	m_iAreaStopX		= 0;								//		*
	m_iAreaStartY		= 0;								//		*
	m_iAreaStopY		= 0;								//		*

	m_pWordList			= 0;								// Fabkonfiguration
	m_iWordCount		= 0;								// Anzahl der gespeicherten Worte
	m_pBracketMode		= 0;								// Art fr Klammern "([{<\x00)]}>"
	m_iBracketArea		= 0;								// Den ganzen Klammerbereich markieren
	m_uBracketOff		= 0;								// Ist Klammer sichtbar
	m_iBracketColor		= 0;								// Farbnummer fr Klammern

	m_iVirtualLines		= 0;								// Virtuelle Zeilenanzeige ein
	m_cIgnorChar		= 0;								// Das nchste CHAR Zeichen ignorieren
	m_cUndoLocked		= 0;								// Zeichen kommt von m_aUndo

	m_uLastDblClick		= 0;								// Wann gab es den letzten Doppelklick
	m_iLastDblClickX	= 0;								// Koordinaten des letzten Doppelklicks
	m_iLastDblClickY	= 0;								//			*

	m_iLastClickX		= 0;								// Koordinaten des letzten Klicks
	m_iLastClickY		= 0;								//			*
	m_iLastClick		= 0;								// Gab es einen Klick fr Drag

	m_ucHasDrop			= 1;								// Ist ein Einggen mittels Drop erlaubt
	m_ucHasDrag			= 1;								// Ist ein Whlen des Texte muittels Drag erlaubt
	m_ucDoDrag			= 0;								// Wird gerade ein Drag ausgefhrt

	m_sChngeDlg			= new CTextChangeDlg(this);			// ndern Dialog
	m_sFindDlg			= new CTextFindDlg  (this);			// Suchen Dialog

	m_iKeyStepMask		= iKeyMaskDefault;					// Maske fr Wortsprnge mit der Tastatur
	m_cConfigName[0]	= 0;


	m_pHookChangeLine		  = 0;							// Hook Funktionen
	m_pHookChangeLineParam	  = 0;  						//		*
	m_pHookInsertLine		  = 0;							//		*
	m_pHookInsertLineParam	  = 0;							//		*
	m_pHookDeleteLine		  = 0;							//		*
	m_pHookDeleteLineParam	  = 0;							//		*
	m_pHookMarginText		  = 0;							//		*
	m_pHookMarginTextParam	  = 0;							//		*
	m_pHookMoveCursor		  = 0;							//		*
	m_pHookMoveCursorParam	  = 0;							//		*
	m_pHookStatusbarText	  = 0;							//		*
	m_pHookStatusbarTextParam = 0;							//		*
	m_pHookChangeText		  = 0;							//		*
	m_pHookChangeTextParam	  = 0;							//		*
	m_pHookContextMenu		  = 0;							//		*
	m_pHookContextMenuParam	  = 0;							//		*


	ConfigLoad();
	ConfigText();
	SetCursorMode(3);


	#ifdef USE_DICIONARY
	m_iDicContextX1	= 0;									// Position der letzten Kontextmenauswahl
	m_iDicContextX2	= 0;									//			*
	#endif


}

//*****************************************************************************
//*
//*     Destruktor
//*
//*****************************************************************************
CTextView::~CTextView()
{
TextLine   *pLine;
int			iPos;


	#if USE_TEXT_DRAGDROP
	DROP_FUNC_UNREGISTER();
	#endif

	m_iWindowCount--;

	if(m_iFlags&FLAG_CONFIG_SAFE)							// Konfiguration Speichern
		{
		m_iFlags &= ~FLAG_CONFIG_SAFE;
		ConfigSave();
		}

	UndoClear  ();
	ConfigText ();
	ConfigAccel();

	#ifdef 		USE_DICIONARY
	if(m_hDicGlobal && m_iWindowCount<=0)					// Wrterbuch lschen
		{
		DicDelete(m_hDicGlobal);
		m_hDicGlobal=0;
		}

	if(m_hDicLocal && m_iWindowCount<=0)					// Pershnliches Wrterbuch lschen
		{
		DicDelete(m_hDicLocal);
		m_hDicGlobal=0;
		}
	#endif

	for(iPos=0;iPos<10;iPos++)								// Copy Speicher lschen
		{
		if(   !m_pCopyMem[iPos])continue;
		delete m_pCopyMem[iPos];
		}


	if(m_pFindText	   )delete m_pFindText;					// Speicher freigeben
	if(m_pFindSelection)delete m_pFindSelection;
	if(m_pColumColors  )delete m_pColumColors;
	if(m_pChangeText   )delete m_pChangeText;


	if(!m_iVirtualLines)
		{
		while(m_iLineCount>0)								// Zeilen Speicher freigeben
			{
			m_iLineCount--;
			   pLine=m_pLineList[m_iLineCount];
			if(pLine->pColors)delete pLine->pColors;		// Farbspeicher lschen
			delete pLine;									// Textspeicher lschen
			}
		}

	m_iLineListSize=0;										// Zeilenadressenspeicher freigeben

	delete m_pLineList;
	delete m_sChngeDlg;										// ndern Dialog lschen
	delete m_sFindDlg;										// Suchen Dialog lschen
	delete m_pNullLine;

}

//*****************************************************************************
//*
//*		OnCreate  Fenstererzeugung
//*
//*****************************************************************************
//	Erzeugen eines Fensters.
int CTextView::OnCreate(LPCREATESTRUCT pCreateStruct)
{
int		iRet;

	   iRet = CAnsiView::OnCreate(pCreateStruct);
	if(iRet)return iRet;

	#if USE_TEXT_DRAGDROP
	DROP_FUNC_REGISTER();
	#endif

	#ifdef USE_MARK_HIGHLIGHT
	if(m_ucWordMarkMode!=255)SetTimer(ID_UPDATETICK,300,NULL);
	#endif


return 0;
}



//*****************************************************************************
//*
//*		CharType
//*
//*****************************************************************************
//	Holt den Typ von einem Zeichen
//	uChar		: Ist das Zeichen das analysiert werden soll.
//	Ergibt den Typ des Zeichens
//				0 = Leerzeichen
//				1 = Diverse Zeichen
//				2 = Das '_' Zeichen
//				3 = Kleinbuchstaben oder Zahlen
//				4 = Grosbuchstaben
inline int CTextView::CharType(unsigned uChar)
{

	if(uChar>'Z')
		{
		if(uChar< 'a')
			{
			if(uChar=='_')return 2;
			return 1;
			}

		if(uChar<='z')return 3;
		if(uChar>=221)return 3;
		if(uChar>=192)return 4;
		return 1;
		}
	else{
		if(uChar>='A')return 4;
		if(uChar<=' ')return 0;
		if(uChar< '0')return 1;
		if(uChar> '9')return 1;
		}

return 3;
}

//*****************************************************************************
//*
//*		CharType
//*
//*****************************************************************************
//	Holt den Typ von ersten Zeichen aus einem Text
//	pChar		: Ist der Zeiger auf den Text der  analysiert werden soll.
//	Ergibt den Typ des Zeichens
//				0 = Leerzeichen
//				1 = Diverse Zeichen
//				2 = Das '_' Zeichen
//				3 = Kleinbuchstaben oder Zahlen
//				4 = Grosbuchstaben
inline int CTextView::CharType(const uchar *pChar)
{
unsigned	uChar;


	uChar = *pChar;

	#ifdef USE_UTF8

	if(uChar>=0xC0)
		{
		utf8tochar(pChar,uChar);
		}

	#endif




return CharType(uChar);
}

//*****************************************************************************
//*
//*		OnChar
//*
//*****************************************************************************
//	Eingabe eines Buchstabens
int CTextView::OnChar(UINT nChar,UINT nFlags)
{


	if(nChar=='\t' && m_iMarkOn)							// Block Tabulator
	if(m_iCursorY !=  m_iMarkY )
		{
		SelectionTab(m_iKeyState&KEY_SHIFT);
		return 1;
		}

	if(nChar>=' ' || !m_cIgnorChar)
		{
		if(nChar==127)nChar=8;								// Strg+BACK in BACK umwandeln
		CharInput(nChar);
		}


return 0;
}

//*****************************************************************************
//*
//*     Cmp
//*
//*****************************************************************************
//	Vergleich zwei Speicherbereiche. Gros/Kleinbuchstaben werden
//	ber die Tabelle m_aCaseTable umgewandelt.
//	pBuffer1	: Zeiger auf den ersten  Speicherbereich
//	pBuffer2	: Zeiger auf den zweiten Speicherbereich
//	uCount		: Gre des Bereiches in Byte
//	iUpper		: Soll zwischen Gro/Kleinbuchstaben nicht unterschieden werden.
//	Ergibt:	0 wenn Speicherbereiche gleich sind
//		   >0 wenn pBuffer1 > pBuffer2
//		   <0 wenn pBuffer1 > pBuffer2
inline int CTextView::Cmp(const void *pPtr1,const void *pPtr2,unsigned uCount,int iUpper)
{
const uchar    *pBuffer1=(uchar*)pPtr1;
const uchar    *pBuffer2=(uchar*)pPtr2;
unsigned	 	uChar1;
unsigned	 	uChar2;
unsigned		uPos;
int				iAdd=1;



	if(!iUpper)
		{
		return memcmp(pBuffer1,pBuffer2,uCount);
		}

	#ifdef USE_UTF8
	m_iCmpDiff = 0;
	#endif

	for(uPos=0;;uPos+=iAdd)
		{
		if(uPos>=uCount)return 0;

		uChar1 = pBuffer1[uPos];
		uChar2 = pBuffer2[uPos];

		#ifdef USE_UTF8

		if(uChar1>=0xC0)
			{
			iAdd   = utf8tochar(pBuffer1+uPos,uChar1);
			if(uChar1<256)uChar1 = m_aCaseTable[uChar1];
			}
		else{
			iAdd   = 1;
			uChar1 = m_aCaseTable[uChar1];
			}

		if(uChar2>=0xC0)
			{
			m_iCmpDiff += utf8tochar(pBuffer2+uPos+m_iCmpDiff,uChar2)-iAdd;
			if(uChar2<256)uChar2 = m_aCaseTable[uChar2];
			}
		else{
			uChar2 = m_aCaseTable[uChar2];
			m_iCmpDiff += 1-iAdd;
			}

		#else

		uChar1 = m_aCaseTable[uChar1];
		uChar2 = m_aCaseTable[uChar2];

		#endif

		if(uChar2!=uChar1)break;
		}


return uChar1-uChar2;
}

//*****************************************************************************
//*
//*		CmpN
//*
//*****************************************************************************
//	Vergleich das erste Zeichen eines Speicherbereiches.
//	Gros/Kleinbuchstaben werden ber die Tabelle m_aCaseTable umgewandelt.
//	uChar1		: Zeichen das verglichen werden soll
//	pBuffer2	: Zeiger auf den zweiten Speicherbereich
//	iUpper		: Soll zwischen Gro/Kleinbuchstaben nicht unterschieden werden.
//	Ergibt:	0 wenn Zeichen gleich sind
//		   >0 wenn Zeichen > pBuffer2
//		   <0 wenn Zeichen > pBuffer2
inline int CTextView::CmpN(unsigned uChar1,const void *pPtr2,int iUpper)
{
const uchar    *pBuffer2=(uchar*)pPtr2;
unsigned	 	uChar2;


	uChar2 = pBuffer2[0];


	if(!iUpper)
		{
		#ifdef USE_UTF8

		if(uChar2>=0xC0)
			{
			m_iCmpDiff = utf8tochar(pBuffer2,uChar2);
			}
		else{
			m_iCmpDiff = 1;
			}

		#endif
		}
	else{
		#ifdef USE_UTF8

		if(uChar1<256)uChar1=m_aCaseTable[uChar1];

		if(uChar2>=0xC0)
			{
			m_iCmpDiff = utf8tochar(pBuffer2,uChar2);
			if(uChar2<256)uChar2 = m_aCaseTable[uChar2];
			}
		else{
			m_iCmpDiff = 1;
			uChar2 = m_aCaseTable[uChar2];
			}

		#else

		uChar1 = m_aCaseTable[uChar1];
		uChar2 = m_aCaseTable[uChar2];

		#endif
		}



return uChar1-uChar2;
}

//*****************************************************************************
//*
//*     CmpC
//*
//*****************************************************************************
//	Vergleich zwei Speicherbereiche. Der erste Eintrag ist immer ein Farbwort.
//	Gros/Kleinbuchstaben werden ber die Tabelle m_aCaseTable umgewandelt.
//	pBuffer1	: Zeiger auf den ersten  Speicherbereich
//	pBuffer2	: Zeiger auf den zweiten Speicherbereich
//	uCount		: Gre des Bereiches in Byte
//	iUpper		: Soll zwischen Gro/Kleinbuchstaben nicht unterschieden werden.
//	Ergibt:	0 wenn Speicherbereiche gleich sind
//		   >0 wenn pBuffer1 > pBuffer2
//		   <0 wenn pBuffer1 > pBuffer2
inline int CTextView::CmpC(const uchar *pBuffer1,const uchar *pPtr2,unsigned uCount,int iUpper)
{
const uchar    *pBuffer2=(uchar*)pPtr2;
unsigned	 	uChar1;
unsigned	 	uChar2;
unsigned		uPos;



	if(!iUpper)
		{
		#ifdef USE_UTF8

		m_iCmpDiff = 0;

		for(uPos=0;;uPos++)
			{
			if(uPos>=uCount)return 0;

			uChar1 = pBuffer1[uPos];
			uChar2 = pBuffer2[uPos+m_iCmpDiff];

			if(uChar2>=0xC0)
				{
				m_iCmpDiff += utf8tochar(pBuffer2+uPos+m_iCmpDiff,uChar2)-1;
				}

			if(uChar2!=uChar1)
				{
				return uChar1-uChar2;
				}
			}

		#else

		return memcmp(pBuffer1,pBuffer2,uCount);

		#endif
		}

	for(uPos=0;;uPos++)
		{
		if(uPos>=uCount)return 0;

		uChar1 = m_aCaseTable[pBuffer1[uPos]];


		#ifdef USE_UTF8

		m_iCmpDiff = 0;

		uChar2 = pBuffer2[uPos+m_iCmpDiff];

		if(uChar2>=0xC0)
			{
			m_iCmpDiff += utf8tochar(pBuffer2+uPos+m_iCmpDiff,uChar2)-1;
			if(uChar2<256)uChar2 = m_aCaseTable[uChar2];
			}
		else{
			uChar2 = m_aCaseTable[uChar2];
			}

		#else

		uChar2 = m_aCaseTable[pBuffer2[uPos]];

		#endif


		if(uChar2!=uChar1)break;
		}


return uChar1-uChar2;
}

//*****************************************************************************
//*
//*     CmpF
//*
//*****************************************************************************
//	Vergleicht zwei Speicherbereiche mit dem Wildcard '?'.
//	Alle Zeichen in pBuffer1 die '?' sind werden bersprungen
//	Ist iUpper==0 wird zwischen Gro und Klein Buchstaben unterschieden
//	Ist iUpper!=0 wird zwischen Gro und Klein Buchstaben nicht unterschieden
//	Ergibt:	0 wenn Speicherbereiche gleich sind
//		   >0 wenn pBuffer1 > pBuffer2
//		   <0 wenn pBuffer1 > pBuffer2
inline int CTextView::CmpF(const void *pPtr1,const void *pPtr2,unsigned uCount,int iUpper)
{
const uchar    *pBuffer1=(uchar*)pPtr1;
const uchar    *pBuffer2=(uchar*)pPtr2;
unsigned	 	uChar1;
unsigned	 	uChar2;
unsigned		uPos;
int				iAdd=1;



	#ifdef USE_UTF8
	m_iCmpDiff = 0;
	#endif

	if(!iUpper)											// Gross/Kleinbuchstaben wird unterschieden
		{
		for(uPos=0;;uPos+=iAdd)
			{
			if(uPos>=uCount)return 0;

			#ifdef USE_UTF8

			uChar1 = pBuffer1[uPos];
			uChar2 = pBuffer2[uPos+m_iCmpDiff];

			if(uChar1>=0xC0)
					iAdd = utf8tochar(pBuffer1+uPos,uChar1);
			else	iAdd = 1;

			if(uChar2>=0xC0)
					m_iCmpDiff += utf8tochar(pBuffer2+uPos+m_iCmpDiff,uChar2)-iAdd;
			else	m_iCmpDiff += 1-iAdd;

			if(uChar1=='?')continue;

			#else

			uChar1 = pBuffer1[uPos];

			if(uChar1=='?')continue;

			uChar2 = pBuffer2[uPos];


			#endif

			if(uChar2!=uChar1)break;
			}

		return memcmp(pBuffer1,pBuffer2,uCount);
		}
	else{												// Gross/Kleinbuchstaben ist egal
		for(uPos=0;;uPos+=iAdd)
			{
			if(uPos>=uCount)return 0;

			#ifdef USE_UTF8

			uChar1 = pBuffer1[uPos];
			uChar2 = pBuffer2[uPos+m_iCmpDiff];

			if(uChar1>=0xC0)
					iAdd = utf8tochar(pBuffer1+uPos,uChar1);
			else	iAdd = 1;

			if(uChar2>=0xC0)
					m_iCmpDiff += utf8tochar(pBuffer2+uPos+m_iCmpDiff,uChar2)-iAdd;
			else	m_iCmpDiff += 1-iAdd;

			if(uChar1=='?')continue;

			if(uChar1<256)uChar1=m_aCaseTable[uChar1];
			if(uChar2<256)uChar2=m_aCaseTable[uChar2];

			#else

			uChar1 = pBuffer1[uPos];

			if(uChar1=='?')continue;

			uChar1 = m_aCaseTable[uChar1];
			uChar2 = m_aCaseTable[pBuffer2[uPos]];

			#endif

			if(uChar2!=uChar1)break;
			}
		}


return uChar1-uChar2;
}

//*****************************************************************************
//*
//*     CmpX
//*
//*****************************************************************************
//	Sucht eine spezielle Zeichenfolge *Suche in *Text
//	Wurde Nichts gefunden ergibt die Funktion 0
//	pFind	: Ist der Suchtext nach dem in gesucht wird.
//	'?'  in *pFind steht fr einen beliebiges Zeichen
//	'*'  in *pFind steht fr eine  beliebige  Zeichenfolge
//	'\\' in *pFind steht fr '\'
//	'\*' in *pFind steht fr '*'
//	'\?' in *pFind steht fr '?'
//	'\w' in *pFind steht fr ein Wort A-Z a-z 0-9 '_' und >128
//	'\z' in *pFind steht fr ein Wort das mit '0'bis '9' anfngt
//	'\_' in *pFind steht fr einen Leerbereich mindestens ein Zeichen lang
//	'\.' in *pFind steht fr einen Leerbereich auch 0 Zeichen lang
//	'\a' in *pFind steht fr den Bereichsanfang
//	'\e' in *pFind steht fr den Bereichsende
//	'\g' in *pFind steht fr einen Wortanfang
//	'\f' in *pFind steht fr ein Wortende
//	'\p' in *pFind steht fr eine  Zahlenzeichen 0-9
//	'\m' in *pFind steht fr einem Buchstaben    A-Z a-z '_'
//	'\o' in *pFind steht fr eine Zahlenzeichen oder Buchstaben
//	'\##'in *pFind steht fr eine Zeichenfolge aus strwlen Zeichen oder nichts
//	'\&&'in *pFind steht fr ein  Zeichen via strwchar (mit Hex-Zahl).
//	'\$$'in *pFind steht fr ein  Zeichen via strwchar (mit Hex-Zahl). (auch leere Menge)
//	\||  in *pFind steht fr eine Zeichenfolge ohne Zeichen in der Klammer oder nichts
//	\<>  in *pFind steht fr eine Zeichenfolge aus  Zeichen in der Klammer oder nichts
//	\[]  in *pFind steht fr ein  Zeichen in der Klammer
//	\{}  in *pFind steht fr ein  Zeichen das nicht in der in der Klammer ist
//	\()  in *pFind steht fr ein  Zeichen in der Klammer oder garnichts
//		 in *pFind werden auch alle anderen Escapefolgen beachtet
//	Ist iUpper Bit!=0  wird zwischen Gro/Kleinschreibung nicht unterschieden
//	Ist iUpper Bit!=1  werden "*.*" am Ende von Suche in "*" umgewandelt
//	Ist iUpper Bit!=2  dann muss der Vergleich nicht die Ganze Lnge haben
//					   auerdem wird die gefundene Lnge zurckgegeben
//	Ist iUpper Bit!=3  dann ist die Zeile nicht der Bereichs Anfang
//	Ist iUpper Bit!=4  dann war das letzte Zeichen ein Buchstabe
//	Ist iUpper Bit!=5  dann ist -1 das Ergebnis bei fehlerhaften Lngenvergelichen
//	Ergibt:	0 wenn Speicherbereiche gleich sind
//		    1 wenn ungleich
int	CTextView::CmpX(const uchar *pFind,int iLenF,const uchar *pText,int iLenT,int iUpper)
{
unsigned 	uChar;
int			iPosT;
int			iPosF;
int			iLast;
int			iStar;
int			iMode;
int			iTemp;
int			iFlag;
int			iWord;
int			iNone;
int			iOff;
int			iRet;
int			iEnd;
int			iNum;
int			iLen;
int			iAsk;
int			iAdd;
int			iCnt;



	if(iLenF<=0)return 0;
	if(iUpper&2 && iLenF>=3)								// "*.*" in "*" umwandeln
	if(pFind[iLenF-1]=='*' )
	if(pFind[iLenF-2]=='.' )
		{
		iLenF-=2;
		}


	iStar = 0;												// Sterne am Ende suchen
	iCnt  = 0;
	iAdd  = 2;

	while(iLenF>0)
		{
		if(pFind[iLenF-1]!='*')break;
		iLenF--;
		iStar++;
		}

	iNone	= (iUpper&0x20)? -1:0;
	iLast	= (iUpper&0x10);
	iMode	= (iUpper);
	iUpper &= 1;
	iPosF	= 0;
	iPosT	= 0;
	iCnt	= 0;


//*****************************************************************************


	for(;;) 												// Suchenschleife
		{
		if(iLenF<=0)break;
		if(iLenT<=0)
			{
			for(;;) 										// Sind Leerbereiche am Ende ?
				{
				if(iLenF>=1 && pFind[0]=='*')
					{
					iLenF--;
					pFind++;
					continue;
					}

				if(iLenF<2)break;
				if(pFind[0]!='\\')break;

				if(pFind[1]=='(')
					{
					for(iNum=2;iNum<iLenF;iNum++)
						{
						if(pFind[iNum]==')' )break;
						if(pFind[iNum]=='\\')iNum++;
						}

					if(pFind[iNum]!=')')break;iNum++;
					}
				else if(pFind[1]=='<')
					{
					for(iNum=2;iNum<iLenF;iNum++)
						{
						if(pFind[iNum]=='>' )break;
						if(pFind[iNum]=='\\')iNum++;
						}

					if(pFind[iNum]!='>')break;iNum++;
					}
				else if(pFind[1]=='|')
					{
					for(iNum=2;iNum<iLenF;iNum++)
						{
						if(pFind[iNum]=='|' )break;
						if(pFind[iNum]=='\\')iNum++;
						}

					if(pFind[iNum]!='|')break;iNum++;
					}
				else if(pFind[1]=='f')
					{
					if(!iLast)break;
					iNum=2;
					}
				else{
					if(pFind[1]!='e' && pFind[1]!='.')break;
					iNum=2;
					}

				iLenF -= iNum;
				pFind += iNum;
				}

			if(iLenF==0)break;

			return (iMode&0x24)? iNone:1;
			}

		iLen=0;

		while(iLen<iLenF)								// Wortlnge holen
			{
			if(pFind[iLen]=='*' )break;
			if(pFind[iLen]=='\\')break;
			iLen++;
			}

		if(iLenT<iLen)return (iMode&0x24)? iNone:1;
		if(iLen)
			{
			if(CmpF(pFind,pText,iLen,iUpper))return (iMode&0x24)? iNone:1;

			iLenF -= iLen; pFind+=iLen;
			iLenT -= iLen; pText+=iLen;
	 					    iCnt+=iLen;

			#ifdef USE_UTF8
			iLenT -= m_iCmpDiff;
			pText += m_iCmpDiff;
			iCnt  += m_iCmpDiff;
			utf8prechar(pText,uChar);
			#else
			uChar  = pText[-1];
			#endif

			iLast  = m_aCharType[uChar]&3;

			continue;
			}


//******************** Spezial Zeichen ****************************************


		if(*pFind=='\\')
			{
			switch(pFind[1])
					{
			case'z':if(iLast){iLen=-1;iAdd=2;break;}
					if(pText[0]<'0' || pText[0]>'9'){iLen=-1;iAdd=2;break;}
			case'w':if(iLast){iLen=-1;iAdd=2;break;}
					iLen=TypeLen(pText,0x3000000F,iLenT);
					if(!iLen)iLen=-1;iAdd=2;break;
			case'_':iLen=TypeLen(pText,0x00000020,iLenT);
					if(!iLen && (iCnt || (iMode&0x08)))iLen=-1;iAdd=2;break;
			case'.':iLen=TypeLen(pText,0x20,iLenT);			   iAdd=2;break;
			case'a':iLen=(iCnt||(iMode&0x08))? -1:0;		   iAdd=2;break;
			case'e':iLen=(iLenT)?        -1:0;				   iAdd=2;break;
			case'g':iAdd=2;iLen=-1;
					if(iLast)break;
					uChar = pText[0];
					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						utf8tochar(pText,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif
					if(!(m_aCharType[uChar]&3))break;
					iLen=0;break;
			case'f':iAdd=2;iLen=-1;
					if(!iLast)break;
					uChar = pText[0];
					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						utf8tochar(pText,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif
					if((m_aCharType[uChar]&3))break;
					iLen=0;break;
			case'm':iAdd=2;iLen=-1;iTemp=1;
					uChar = pText[0];
					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						iTemp=utf8tochar(pText,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif
					if(m_aCharType[uChar]&2)iLen=iTemp;
					break;
			case'p':iAdd=2;iLen=-1;iTemp=1;
					uChar = pText[0];
					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						iTemp=utf8tochar(pText,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif
					if(m_aCharType[uChar]&1)iLen=iTemp;
					break;
			case'o':iAdd=2;iLen=-1;iTemp=1;
					uChar = pText[0];
					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						iTemp=utf8tochar(pText,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif
					if(m_aCharType[uChar]&3)iLen=iTemp;
					break;
			case'&':iAdd =strlchar (0x00070001 , (char*)pFind+ 2,STR_MUST('&'),iLenF-2);
					iRet =strtoh   ((char*)pFind+2,iAdd);iAdd+=2;if(pFind[iAdd]=='&')iAdd++;
					iLen =strwchara(pText[0],iRet)? 1:-1;
					break;
			case'$':iAdd =strlchar (0x00070001 , (char*)pFind+ 2,STR_MUST('$'),iLenF-2);
					iRet =strtoh   ((char*)pFind+2,iAdd);iAdd+=2;if(pFind[iAdd]=='$')iAdd++;
					iLen =strwchara(pText[0],iRet)? 1:0;
					break;
			case'#':iAdd =strlchar (0x00070001 , (char*)pFind+ 2,STR_MUST('#'),iLenF-2);
					iRet =strtoh   ((char*)pFind+2,iAdd);iAdd+=3;if(pFind[iAdd]=='#')iAdd++;
					iLen =strwlen  ((char*)pText,iRet,iLenT);
					break;
			case'|':for(iAdd=2,iLen=0;iAdd<iLenF && iLen<iLenT;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar=='|')
							{
							iAdd++;
							if(iAdd<iLenF)
								{
								iFlag = 0x2C|iUpper;

								if(iLen>0)
									{
									#ifdef USE_UTF8
									utf8prechar(pText+iLen,uChar);
									if(uChar>=256)uChar=255;
									#else
									uChar = pText[iLen-1];
									#endif
									if(m_aCharType[uChar]&3)iFlag|=0x10;
									}
								else if(iLast)
									{
									iFlag |= 0x10;
									}

								   iEnd=CmpX(pFind+iAdd,iLenF-iAdd,pText+iLen,iLenT-iLen,iFlag);
								if(iEnd>=0)
									{
									iAdd  = iLenF;
									iLen += iEnd;
									if(iLen>iLenT && iLenT>0)iLen=iLenT;
									break;
									}
								}

							#ifdef USE_UTF8
							iLen+=utf8tochar(pText+iLen,uChar);
							#else
							iLen+=1;
							#endif
							iAdd=1;
							continue;
							}
						if(uChar=='\\' && iAdd+1<iLenF)
							{
							if(pFind[iAdd+1]=='|')
									{uChar='|';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#endif
						if(!CmpN(uChar,pText+iLen,iUpper))break;
						}
					for(;iAdd<iLenF;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar=='|')  {iAdd++;break;}
						if(uChar=='\\' && iAdd+1<iLenF)
							{
							if(pFind[iAdd+1]=='|')
									{uChar='|';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#endif
						}
					break;
			case'<':for(iAdd=2,iLen=0;iAdd<iLenF && iLen<iLenT;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar=='>')  {iAdd++;break;}
						if(uChar=='\\'&&(iAdd+1<iLenF))
							{
							if(pFind[iAdd+1]=='>')
									{uChar='>';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						if(CmpN(uChar,pText+iLen,iUpper))continue;
						iLen += m_iCmpDiff;
						#else
						if(CmpN(uChar,pText+iLen,iUpper))continue;
						iLen += 1;
						#endif
						iAdd  = 1;
						}
					for(iAdd=2;iAdd<iLenF;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar=='>')  {iAdd++;break;}
						if(uChar=='\\' && iAdd+1<iLenF)
							{
							if(pFind[iAdd+1]=='>')
									{uChar='>';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#endif
						}
					break;
			case'[':for(iAdd=2,iLen=-1;iAdd<iLenF;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar==']')  {iAdd++;break;}
						if(uChar=='\\' && iAdd+1<iLenF)
							{
							if(pFind[iAdd+1]==']')
									{uChar=']';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						if(iLen>=1)continue;
						if(!CmpN(uChar,pText,iUpper))iLen=m_iCmpDiff;
						#else
						if(iLen==1)continue;
						if(!CmpN(uChar,pText,iUpper))iLen=1;
						#endif
						}
					break;
			case'(':for(iAdd=2,iLen=0;iAdd<iLenF;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar==')')  {iAdd++;break;}
						if(uChar=='\\' && iAdd+1<iLenF)
							{
							if(pFind[iAdd+1]==')')
									{uChar=')';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						if(iLen>=1)continue;
						if(!CmpN(uChar,pText,iUpper))iLen=m_iCmpDiff;
						#else
						if(iLen==1)continue;
						if(!CmpN(uChar,pText,iUpper))iLen=1;
						#endif
						}
					break;
			case'{':
					#ifdef USE_UTF8
					iLen=utf8tochar(pText,uChar);
					#else
					iLen=1;
					#endif
					for(iAdd=2;iAdd<iLenF;iAdd++)
						{
						   uChar = pFind[iAdd];
						if(uChar=='}')  {iAdd++;break;}
						if(uChar=='\\' && iAdd+1<iLenF)
							{
							if(pFind[iAdd+1]=='}')
									{uChar='}';iAdd++;}
							else	{uChar=strtoc(pFind+iAdd,&iNum);iAdd+=iNum-1;}
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#ifdef USE_UTF8
						else if(uChar>=0xC0)
							{
							iAdd+=utf8tochar(pFind+iAdd,uChar)-1;
							if(iAdd>iLenF)iAdd=iLenF;
							}
						#endif
						if(iLen==-1)continue;
						if(!CmpN(uChar,pText,iUpper))iLen=-1;
						}
					break;
			case'\\':
			case'*':
			case'?':iAdd=2;iLen=1;
					if(pFind[1]!=pText[0])iLen=-1;
					break;
			default:uChar=strtoc(pFind,&iAdd);
					#ifdef USE_UTF8
					if(!Cmp(&uChar,pText,1,iUpper))iLen=m_iCmpDiff;
					#else
					if(!Cmp(&uChar,pText,1,iUpper))iLen=1;
					#endif
					}

			if(iAdd>iLenF)
				{
				iAdd=iLenF;
				iLen=Cmp(pFind,pText,iLenF,iUpper);
				if(iLen)iLen=-1;
				}

			if(iLen<0)
				{
				return (iMode&0x24)? iNone:1;
				}

			pFind += iAdd;iLenF-=iAdd;
			pText += iLen;iLenT-=iLen;
			 iCnt += iLen;
			uChar  = pText[-1];

			#ifdef USE_UTF8
			if(uChar>=0x80)
				{
				utf8prechar(pText,uChar);
				if(uChar>=256)uChar=255;
				}
			#endif

			iLast  = m_aCharType[uChar]&3;

			continue;
			}


//******************** Wildcard '*' *******************************************


		iAsk=0;

		while(iLenF>0)									// Wildcard berspringen
			{
			if(*pFind=='?'){iAsk++;pFind++;iLenF--;continue;}
			if(*pFind!='*')break;
				pFind++;iLenF--;
			}

		if(iLenT<iAsk)return (iMode&0x24)? iNone:1;
		if(iLenF<= 0 ){iStar=1;break;}

		if(iAsk>0)										// Zeichen fr '?' berspringen
			{
			#ifdef USE_UTF8

			for(;iAsk>0;iAsk--)
				{
				iTemp  = utf8tochar(pText,uChar);
				iLenT -= iTemp;
				pText += iTemp;
				iCnt  += iTemp;
				}

			if(uChar>=256)uChar=255;

			#else

			iLenT -= iAsk;
			pText += iAsk;
			iCnt  += iAsk;
			uChar  = pText[-1];

			#endif

			iLast  = m_aCharType[uChar]&3;
			}

		iLen  = 0;
		iEnd  = 0;
		iWord = 0;

		while(iLen<iLenF)								// Textlnge bis '*' oder '\' holen
			{
			if(pFind[iLen]=='*' )break;
			if(pFind[iLen]=='\\')break;
			iLen++;
			}

		for(iOff=iLen;iOff<iLenF-1;iOff++)
			{
			if(pFind[iOff]!='*')break;
			}


		if(pFind[iOff]=='\\')							// Spezialabschlsse
			{
			iEnd = iOff+1;

			for(;iEnd<iLenF;iEnd++)
				{
		  		uChar = pFind[iEnd];

				#ifdef USE_UTF8
				if(uChar>=0xC0)
						iEnd+=utf8tochar(pFind+iEnd,uChar);
				else	iEnd+=1;
				#else
				iEnd += 1;
				#endif

					 if(uChar=='.');					// Leerstelle oder nichts
				else if(uChar=='e')						// Bereichsende
					{
					if(iEnd+1<iLenF)break;
					}
				else if(uChar=='f')						// Bereichsende
					{
					if(iEnd+1<iLenF)break;
					iWord = 1;
					}
				else if(uChar=='(')						// Zeichen in der Klammer oder nichts
					{
					for(;iEnd<iLenF;iEnd++)
						{
						if(pFind[iEnd]=='\\') iEnd++;
						if(pFind[iEnd]==')' ){iEnd++;break;}
						}
					}
				else if(uChar=='<')						// Zeichenfolge aus Zeichen in in der Klammer oder nichts
					{
					for(;iEnd<iLenF;iEnd++)
						{
						if(pFind[iEnd]=='\\') iEnd++;
						if(pFind[iEnd]=='>' ){iEnd++;break;}
						}
					}
				else if(uChar=='|')						// Zeichenfolge ohne Zeichen in der Klammer oder nichts
					{
					for(;iEnd<iLenF;iEnd++)
						{
						if(pFind[iEnd]=='\\') iEnd++;
						if(pFind[iEnd]=='|' ){iEnd++;break;}
						}
					}
				else{
					break;
					}

				if(iEnd>=iLenF || pFind[iEnd]!='\\')break;
				}
			}

		while(iLenT>=iLen)								// Suchenwortteil
			{
			if(!CmpF(pFind,pText,iLen,iUpper))
				{
				if(iLenF==iLen)
					{
					if(iMode&0x24)
						{
						return (iStar)? iCnt+iLenT:iCnt+iLen;
						}

					return 0;
					}

				uChar = pText[iLen-1];

				#ifdef USE_UTF8
				if(uChar>=0x80)
					{
					utf8prechar(pText+iLen,uChar);
					if(uChar>=256)uChar=255;
					}
				#endif

				iFlag = (m_aCharType[uChar]&3)? 0x10:0x00;

				if(iLenT>iLen)							// Gibt es noch Text zum Vergleichen
					{
					iNum = CmpX(pFind+iLen,iLenF-iLen,pText+iLen,iLenT-iLen,iUpper|iFlag|0x2C);
					}
				else{
					iNum = -1;

					if(iLenF >0 && iEnd>=iLenF)			// Spezialabschlsse berspringen
					if(iWord==0 || iFlag)
						{
						iNum = 0;
						}
					}

				if(iNum>=0)								// Text wurde gefunden
					{
					if(iMode&0x24)
						{
						if(iStar)return iCnt+iLenT;

						if(iLen+iNum>iLenT && iCnt+iLenT>0)
							{
							return iCnt+iLenT;
							}

						return iCnt+iLen+iNum;
						}

					if(iStar)return iNone;

					return (iNum+iLen!=iLenT)? 1:0;
					}
				}

			#ifdef USE_UTF8
			iTemp  = utf8tochar(pText,uChar);
			iLenT -= iTemp;
			pText += iTemp;
			iCnt  += iTemp;
			#else
			iLenT -= 1;
			pText += 1;
			iCnt  += 1;
			#endif
			}

		return (iMode&0x24)? iNone:1;
		}


//********************** Suche Text wurde ganz abgearbeitet ********************


	if(iMode&0x24)return (iStar)? iCnt+iLenT:iCnt;		// Lnge zurckgeben
	if(iLenT>0 && iStar==0)return 1;					// Stern am Wortende


return 0;
}


//*****************************************************************************
//*
//*     TypeLen
//*
//*****************************************************************************
//	Ergibt die Lnge einer Zeichengruppe.
//	pStr		: Ist det Zeiger auf den Text mit der Zeichengruppe.		:
//	iLen		: Ist die maximale Textnge.
//	iMode		: Bestimmt die Art der Zeichengruppe
//					Bit0 != 0	Zahlen
//					Bit1 != 0	Grobuchstaben
//					Bit2 != 0	Kleinbuchstaben
//	Ergibt die Lnge der Zeichengruppe.
int CTextView::TypeLen(const uchar *pStr,int iMode,int iLen)
{
unsigned 	uChar;
int			iFlag;
int			iPos;
int			iAdd;

	iFlag	= iMode;
	iPos	= 0;
	iAdd	= 1;

	for(iPos=0;iPos<iLen;iPos+=iAdd)
		{
		uChar = pStr[iPos];

		#ifdef USE_UTF8
		if(uChar>=0xC0)
			{
			iAdd=utf8tochar(pStr+iPos,uChar);
			if(uChar>=256)uChar=255;
			}
		else{
			iAdd=1;
			}
		#endif

		if(iFlag&0x01F)
			{
			if(iFlag&0x0001)
				{
				if(uChar>='0' && uChar<='9')continue;
				}

			if(iFlag&0x0002)
				{
				if((uChar>='A' )&& uChar<='Z')continue;
				if((m_aCharType[uChar]&0x02) && m_aCharType[uChar]==uChar)continue;
				}

			if(iFlag&0x0004)
				{
				if(uChar>='a' && uChar<='z')continue;
				if((m_aCharType[uChar]&0x02) && m_aCharType[uChar]!=uChar)continue;
				}

			if((iFlag&0x0008) && uChar=='_')continue;
			if((iFlag&0x0010) && uChar<  0 )continue;
			}

		if(iFlag&0x00E0)
			{
			if((iFlag&0x0020) && (uChar==' '  || uChar=='\t'))continue;
			if((iFlag&0x0040) && (uChar=='\n' || uChar=='\r'))continue;
			if((iFlag&0x0080) && (uChar=='\"' || uChar=='\''))continue;
			}

		if(iFlag&0x0100)
			{
			if(uChar>='!'  && uChar<='/'  )continue;
			if(uChar>=':'  && uChar<='@'  )continue;
			if(uChar>='['  && uChar<='\'' )continue;
			if(uChar>='{'  && uChar<='x7F')continue;
			}

		if(iFlag&0x0200)
			{
			if(uChar=='' || uChar<='')continue;
			if(uChar=='' || uChar<='')continue;
			if(uChar=='' || uChar<='')continue;
			if(uChar==''  			   )continue;
			}

		if(iFlag&0xF000)
			{
			if((iFlag&0x1000) && (uChar=='(' || uChar==')'))continue;
			if((iFlag&0x2000) && (uChar=='[' || uChar==']'))continue;
			if((iFlag&0x4000) && (uChar=='{' || uChar=='}'))continue;
			if((iFlag&0x8000) && (uChar=='<' || uChar=='>'))continue;
			}

		break;
		}



return iPos;
}


//*****************************************************************************
//*
//*     OnScrollChange
//*
//*****************************************************************************
//	Die Scroll-Position hat sich verndert
#ifdef 	USE_MARK_HIGHLIGHT
void CTextView::OnTimer(UINT_PTR uIdEvent)
{
TextLine   *pLine;
uchar	   *pText;
int			iMode;
int			iVal1;
int			iVal2;
int			iEnd1;
int			iEnd2;
int			iLen;
int			iPos;


	if(uIdEvent==ID_UPDATETICK)
		{
		if(!m_ucWordMarkTicker)return;
			m_ucWordMarkTicker--;
		if( m_ucWordMarkTicker!=0)return;

		iMode = m_iFlags&FLAG_WORDMARK_TYPE;

		switch(iMode)
			{
		default:												// Keine Markierung zulassen

				if(m_ucWordMarkChar)MarkHighlight("",0);
				return;

		case FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE>>1):		// Wort unter Cursor makieren

				if(m_iMarkOn)
					{
					if(m_ucWordMarkChar)MarkHighlight("",0);	// Keine Markierung bei Auswahl
					return;
					}

				pLine	=  GetLine(m_iCursorY);
				pText	=  pLine->aText;
				iLen	=  pLine->uSize;
				iPos	=  TextPosition(m_iCursorX,pText,iLen);
				iVal1	=  CharAbc(iPos,pText,iLen,0,&iEnd1);
				iVal2	=  CharAbc(iPos,pText,iLen,1,&iEnd2);

				if(iEnd1>=iLen)
					{
					   iPos = ViewPosition(iEnd1,pText,iLen);
					if(iPos<m_iCursorX)							// Ist Cursor nach dem Text
						{
						if(m_ucWordMarkChar)MarkHighlight("",0);// Markierung lschen
						return;
						}
					}

				break;

		case FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE<<1):		// Das ausgewhlte Wort markieren

				if(m_iMarkOn!=1)
					{
					if(m_ucWordMarkChar)MarkHighlight("",0);	// Keine Markierung bei Auswahl
					return;
					}

				pLine	=  GetLine(m_iMarkY);
				pText	=  pLine->aText;
				iLen	=  pLine->uSize;
				iPos	=  TextPosition((m_iCursorX<m_iMarkX)? m_iCursorX:m_iMarkX,pText,iLen);
				iVal1	=  CharAbc(iPos,pText,iLen,0,&iEnd1);
				iVal2	=  CharAbc(iPos,pText,iLen,1,&iEnd2);

				if(iVal2 || iVal1!=abs(m_iCursorX-m_iMarkX))
					{
					if(m_ucWordMarkChar)MarkHighlight("",0);	// Keine ganzes Wort markiert
					return;
					}

				break;

		case FLAG_WORDMARK_TYPE:								// Die Markirung wird extern vorgegben

				return;
			}


		iLen = iEnd1-iEnd2;

		if(iLen<=0 || iLen>sizeof(m_ucHighlightWord))			// Cursor ist auf keinem Wort
			{
			if(m_ucWordMarkChar)MarkHighlight("",0);
			}													// Ein neues Word markieren
		else if(!m_ucWordMarkChar || m_ucWordMarkSize!=iLen || memcmp(pText+iEnd2,m_ucHighlightWord,iLen))
			{
			#ifdef USE_UTF8
			MarkHighlight(pText+iEnd2,(iLen<<24)|TEXT_WORD|TEXT_HAS_LENGTH|TEXT_IS_UTF8);
			#else
			MarkHighlight(pText+iEnd2,(iLen<<24)|TEXT_WORD|TEXT_HAS_LENGTH);
			#endif
			}

		return;
		}

	CAnsiView::OnTimer(uIdEvent);
}
#endif

//*****************************************************************************
//*
//*     OnScrollChange
//*
//*****************************************************************************
//	Die Scroll-Position hat sich verndert
void CTextView::OnScrollChange()
{
static int iLock=0;


	if(m_cBracketOn && !iLock)
		{
		iLock=1;
		PositionOk(0,0,(m_iMarkOn)? 3:1);
		iLock=0;
		}

}

//*****************************************************************************
//*
//*     OnKeyDown
//*
//*****************************************************************************
int CTextView::OnKeyDown(UINT nChar,UINT nFlags)
{
TextLine   *pLine;
uchar	   *pText;
unsigned	uChar;
int			iStart;
int			iMode;
int			iType;
int			iFlag;
int			iNext;
int			iPosY;
int			iPos1;
int			iPos2;
int			iOldX;
int			iEnd;
int			iBit;
int			iLen;
int			iPos;
int			iNum;
int			iRet;


	m_cIgnorChar = 0;
																// Tastenkrzel ausgeben	
	if((m_iKeyState&KEY_CLTR) && !(nFlags&0x2000))				
		{
		if(nChar>='0' && nChar<='Z')
			{
			m_cIgnorChar=1;
																// Texte aus Registry einfgen
			if(m_aAccelNamen[nChar-'0'] && !(m_iKeyState&KEY_SHIFT))
				{
				SelectionInsert(nChar);
				}
			else{												// Standard Funktionen
				if(nChar=='X'){OnCut();			return 1;}
				if(nChar=='C'){OnCopy();		return 1;}
				if(nChar=='V'){OnPaste();		return 1;}
				if(nChar=='F'){OnFindView();	return 1;}
				if(nChar=='H'){OnRepalceView();	return 1;}
				if(nChar=='A'){OnSelectAll();	return 1;}
				if(nChar=='Y'){OnUndoBack();	return 1;}
				if(nChar=='Z'){OnUndo();		return 1;}
				#ifndef TO_ANSIWND
				if(nChar=='P'){OnFilePrint();	return 1;}
				#endif
				}

			return 0;
			}
		else{
			if(nChar==VK_TAB && (m_iKeyState&KEY_CLTR))
				{
				NextField((m_iKeyState&KEY_SHIFT)? 1:0);
				return 1;
				}

			nChar&=0xFF;

			iPos = strcspn(m_aAccelTab2,(char*)&nChar);
																// Sezielletasten aus Registry "+-,.#<"
			if(m_aAccelTab2[iPos] && m_aAccelNamen['Z'-'0'+iPos+1])								
				{
				SelectionInsert('Z'+iPos+1);
				}
			}
		}

	if(nChar==VK_INSERT)										// Einfgemodus ein/aus
		{
		if(m_iKeyState&KEY_CLTR ){OnCopy() ;return 1;}
		if(m_iKeyState&KEY_SHIFT){OnPaste();return 1;}
		SetCursorMode((m_iCursorMode^1)|2);
		StatusbarSet();
		return 1;
		}

	if(nChar==VK_DELETE)										// DEL-Taste
		{
		if(m_iKeyState&KEY_SHIFT){OnCut();return 1;}
		CharInput(0x07);										// DEL zu 0x07 umwandeln
		return 1;
		}

	if(nChar==VK_END)											// END-Taste
		{
		if(m_iKeyState&KEY_CLTR)return 0;
		iMode  = (m_iKeyState&KEY_SHIFT)? 2:0;
		pLine  = GetLine(m_iCursorY);
		PositionOk(pLine->uEnd,m_iCursorY,iMode);
		return 1;
		}

	if(nChar==VK_HOME)											// HOME-Taste
		{
		if(m_iKeyState&KEY_CLTR)return 0;
		iMode  = (m_iKeyState&KEY_SHIFT)? 2:0;
		pLine  = GetLine(m_iCursorY);
		iStart = pLine->uStart;

		if(m_iCursorX<=iStart && m_iCursorX)
			{
			iStart=0;
			}
		
		iOldX = m_iCursorX;

		PositionOk(iStart,m_iCursorY,iMode);

		if(iOldX>m_iCursorX && m_iCursorX<=8 && m_iScreenX>16)
			{
			m_iScrollX = 0;
			}

		return 1;
		}

	if(nChar==VK_UP)											// Hinauf-Taste
		{
		iRet  = 0;
		iFlag = (m_iCursorY!=m_iMarkY) || (m_iCursorX!=m_iMarkX);

		if(!(m_iKeyState&(KEY_CLTR|KEY_SHIFT)))					// Marke berspringen
			{
			     if(m_iCursorY>m_iMarkY){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			else if(m_iCursorY<m_iMarkY){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			else if(m_iCursorX>m_iMarkX){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			else if(m_iCursorX<m_iMarkX){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			}

		if(iFlag && iRet)DoScroll();

		return iRet;
		}

	if(nChar==VK_DOWN)											// Runter-Taste
		{
		iRet  = 0;
		iFlag = (m_iCursorY!=m_iMarkY) || (m_iCursorX!=m_iMarkX);

		if(!(m_iKeyState&(KEY_CLTR|KEY_SHIFT)))					// Marke berspringen
			{
			     if(m_iCursorY>m_iMarkY){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			else if(m_iCursorY<m_iMarkY){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			else if(m_iCursorX>m_iMarkX){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			else if(m_iCursorX<m_iMarkX){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			}

		if(iFlag && iRet)DoScroll();

		return iRet;
		}

	if(nChar==VK_LEFT)											// Links-Taste
		{
		if(!(m_iKeyState&KEY_CLTR))								// Marke berspringen
			{
			if(m_iKeyState&KEY_SHIFT)return 0;

			iRet  = 0;
			iFlag = (m_iCursorY!=m_iMarkY) || (m_iCursorX!=m_iMarkX);

			     if(m_iCursorY>m_iMarkY){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			else if(m_iCursorY<m_iMarkY){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			else if(m_iCursorX>m_iMarkX){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			else if(m_iCursorX<m_iMarkX){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}

			if(iFlag && iRet)DoScroll();

			return iRet;
			}

		iMode = (m_iKeyState&KEY_SHIFT)? 2:0;					// Auf vorheriges Wort

		if(m_iCursorX==0 && m_iCursorY>0)
			{
			pLine = GetLine(m_iCursorY-1);
			iEnd  = pLine->uEnd;
			PositionOk(iEnd,-1,iMode|1);
			return 1;
			}

		pLine  =  GetLine(m_iCursorY);
		pText  =  pLine->aText;
		iLen   =  pLine->uSize;
		iPos   =  TextPosition(m_iCursorX,pText,iLen);
		uChar  =  pText[iPos-1];
		iNum   =  1;

		#ifdef USE_UTF8
		if(uChar>=0x80)iNum=utf8prechar(pText+iPos,uChar);
		#endif

		iType  =  CharType(uChar);

		for(iPos-=iNum;iPos>0;iPos-=iNum)
			{
			uChar = pText[iPos-1];
			iNum  = 1;

			#ifdef USE_UTF8
			if(uChar>=0x80)iNum=utf8prechar(pText+iPos,uChar);
			#endif

			iNext = CharType(uChar);
			iBit  = 1<<(iType+iNext*5);
			if(m_iKeyStepMask&iBit)break;
			iType = iNext;
			}

		iPos   = ViewPosition(iPos,pText,iLen);
		PositionOk(iPos,m_iCursorY,iMode);

		return 1;
		}

	if(nChar==VK_RIGHT)											// CLTR+Rechts-Taste
		{
		if(!(m_iKeyState&KEY_CLTR))								// Marke berspringen
			{
			if(m_iKeyState&KEY_SHIFT)return 0;

			iRet  = 0;
			iFlag = (m_iCursorY!=m_iMarkY) || (m_iCursorX!=m_iMarkX);

			     if(m_iCursorY>m_iMarkY){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			else if(m_iCursorY<m_iMarkY){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}
			else if(m_iCursorX>m_iMarkX){PositionOk(m_iCursorX,m_iCursorY,0);iRet=1;}
			else if(m_iCursorX<m_iMarkX){PositionOk(m_iMarkX  ,m_iMarkY  ,0);iRet=1;}

			if(iFlag && iRet)DoScroll();

			return iRet;
			}

		if(m_iCursorY>=m_iLineCount)return 0;					// Auf nchstes Wort

		iMode  = (m_iKeyState&KEY_SHIFT)? 2:0;
		pLine  = GetLine(m_iCursorY);
		iEnd   = pLine->uEnd;

		if(m_iCursorX>=iEnd)
			{
			PositionOk(-m_iCursorX,1,iMode|1);
			return 1;
			}

		pLine  = GetLine(m_iCursorY);
		pText  = pLine->aText;
		iLen   = pLine->uSize;
		iPos   = TextPosition(m_iCursorX,pText,iLen);
		uChar  = pText[iPos];
		iNum   = 1;

		#ifdef USE_UTF8
		if(uChar>=0xC0)iNum=utf8tochar(pText+iPos,uChar);
		#endif

		iType  = CharType(uChar);

		for(iPos+=iNum;iPos<iLen;iPos+=iNum)
			{
			uChar = pText[iPos];
			iNum  = 1;

			#ifdef USE_UTF8
			if(uChar>=0xC0)iNum=utf8tochar(pText+iPos,uChar);
			#endif

			iNext = CharType(uChar);
			iBit  = 1<<(iType*5+iNext);
			if(m_iKeyStepMask&iBit)break;
			iType = iNext;
			}

		iPos = ViewPosition(iPos,pText,iLen);
		PositionOk(iPos,m_iCursorY,iMode);

		return 1;
		}

	if(nChar==VK_CLEAR)											// '5'-Taste + CLTR/SHIFT
	if(m_iKeyState&(KEY_CLTR|KEY_SHIFT))
		{
		char     cText[16];
		char     cNext[16];
		int	     iVal;

		if(m_iMarkOn==2)return 0;

		iPosY	 = m_iCursorY;
		iPos1	 = m_iCursorX;
		iPos2	 = m_iMarkX;
		cNext[0] = 0;

		if(m_iKeyState&KEY_CLTR )								// Zahlen aufwrts Zhlen
		if(m_iKeyState&KEY_SHIFT)
		if(m_iMarkOn==1)
			{
			   iLen = GetClipboardText(cText,sizeof(cText));
			if(iLen>=1 && iLen<16 && cText[0]>='0' && cText[0]<='9')
				{
				if(cText[0]=='0' && (cText[1]=='x'||cText[1]=='X') && iLen>2)
					{
					iVal = strtoi(cText)+1;
					iLen = ((iLen-2)<<8)&0x3F00;
					itostr(iVal,cNext,iLen|0x4001);
					}
				else{
					iVal = strtoi(cText)+1;
					iLen = (iLen<<8)&0x3F00;
					itostr(iVal,cNext,iLen|0x4000);
					}
				}
			}

		if(!SelectionInsert())return 1;

		   iPos = m_iScreenY-7;
		if(iPos<=0)iPos=(m_iScreenY*3)/4;

		if(iPosY-m_iScrollY>=iPos)								// Am unteren Fnftel mit scrollen
			{
			m_iScrollY++;
			}

		PositionOk(iPos2,iPosY+1,0);							// Eine Zeile tiefer
		PositionOk(iPos1,iPosY+1,2);

		if(cNext[0])											// Nchste Zahl kopieren
			{
			SetClipboardText(cNext);
			}

		return 1;
		}


return 0;
}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
int CTextView::OnLButtonDown(UINT nFlags,CPoint sPoint,int iPosX,int iPosY)
{
TextLine   *pLine;
unsigned	uDiff;


	for(;;)
		{
		if(m_uLastDblClick==0)
			{
			break;
			}

		if(m_iLastDblClickX!=iPosX || m_iLastDblClickY!=iPosY)		// Bei Doppelklick und Klick, Zeile auswhlen
			{
			m_uLastDblClick = 0;
			break;
			}

		uDiff = GetTickCount()-m_uLastDblClick;

		m_uLastDblClick = 0;

		if(uDiff>300)break;


		pLine	=  GetLine(iPosY);

		if(iPosX!=m_iMarkX || iPosY!=m_iMarkY)
				m_iRedrawFlags =NZ_ALL;
		else	m_iRedrawFlags|=NZ_LINE;


		PositionOk(0,iPosY,0);										// Ganze Zeile markieren
		PositionOk(pLine->uEnd,iPosY,2);
		NoScroll();


		return 1;
		}

	if(m_ucHasDrag     && !(nFlags&~MK_LBUTTON))					// Bei Darg erst mit loslassen
	if(m_iLastClick==0 && IsSelected(iPosX,iPosY))
		{
		m_sLastClickPt	= sPoint;
		m_iLastClickX	= iPosX;
		m_iLastClickY	= iPosY;
		m_iLastClick	= 1;
		return 1;
		}


return 0;
}


//*****************************************************************************
//*
//*		OnMouseMove
//*
//*****************************************************************************
int CTextView::OnMouseMove(UINT nFlags,CPoint sPoint,int iPosX,int iPosY)
{

	if(m_iLastClick && (iPosX!=m_iLastClickX || iPosY!=m_iLastClickY))
		{
		m_iLastClick = 0;

		if(!BeginDrag())
			{
			CAnsiView::OnLButtonDown(ANSI_NO_SUBCALL|MK_LBUTTON,m_sLastClickPt);
			}
		}


return 0;
}

//*****************************************************************************
//*
//*		OnLButtonUp
//*
//*****************************************************************************
int CTextView::OnLButtonUp(UINT nFlags,CPoint sPoint,int iPosX,int iPosY)
{

	if(m_iLastClick)												// Bei Darg den Klick nach holen
		{
		m_iLastClick = 0;
		CAnsiView::OnLButtonDown(ANSI_NO_SUBCALL|MK_LBUTTON,m_sLastClickPt);
		}


return 0;
}

//*****************************************************************************
//*
//*     OnLButtonDblClk
//*
//*****************************************************************************
//	Ergibt 1 wenn ein Wort ausgewhlt wurde
int CTextView::OnLButtonDblClk(UINT nFlags,CPoint sPoint,int iPosX,int iPosY)
{
TextLine   *pLine;
uchar	   *pText;
int			iVal1;
int			iVal2;
int			iLen;
int			iPos;
int			iOff;



	if(iPosY<0 || iPosY>=m_iLineCount)return 0;

	m_uLastDblClick		= GetTickCount();
	m_iLastDblClickX	= iPosX;
	m_iLastDblClickY	= iPosY;

	pLine	=  GetLine(iPosY);
	pText	=  pLine->aText;
	iLen	=  pLine->uSize;
	iPos	=  TextPosition(iPosX,pText,iLen);				// Offset der Cursor-Position im Text holen

	if(iPos>=iLen)
		{
		   iOff = ViewPosition(iPos,pText,iLen);
		if(iOff<iPosX)										// Sind wir hinterem Zeilenende
			{
			return 0;
			}
		}

	iVal1	=  CharAbc(iPos,pText,iLen,0);
	iVal2	=  CharAbc(iPos,pText,iLen,1);


	if(iVal1<=0 && iVal2<=0)								// Kein Wort gefunden
		{
		iVal1 = SignAbc(iPos,pText,iLen,0);
		iVal2 = SignAbc(iPos,pText,iLen,1);

		if(iVal1<=0 && iVal2<=0)
			{
			return 0;
			}
		}


	PositionOk(iPosX-iVal2,iPosY,0);						// An den Wortanfang
	PositionOk(iPosX+iVal1,iPosY,2);						// Markiere bis zum Wortende


return 1;
}

//*****************************************************************************
//*
//*     IsWord
//*
//*****************************************************************************
//	Ist auf der Position ein Wort
//	iPosX/Y		: Ist die Position die geprft werden soll
//	Ergibt die Buchstaben nach links und rechts.
int CTextView::IsWord(int iPosX,int iPosY,int iCopy)
{
TextLine   *pLine;
uchar	   *pText;
int			iVal1;
int			iVal2;
int			iLen;
int			iPos;



	if(iPosY<0 || iPosY>=m_iLineCount)return 0;

	pLine	=  GetLine(iPosY);
	pText	=  pLine->aText;
	iLen	=  pLine->uSize;
	iPos	=  TextPosition(iPosX,pText,iLen);
	iVal1	=  CharAbc(iPos,pText,iLen,0);
	iVal2	=  CharAbc(iPos,pText,iLen,1);

	if(iCopy && (iVal1|iVal2))
		{
		SetClipboardText((char*)pText+iPos-iVal2,iVal1+iVal2);
		}



return MAKELONG(iVal1,iVal2);
}

//*****************************************************************************
//*
//*     OnSetFocus
//*
//*****************************************************************************
void CTextView::OnSetFocus(CWnd *pOldWnd)
{

	CAnsiView::OnSetFocus(pOldWnd);
	StatusbarInit();
	SendNotify(TXT_SETFOCUS);

}

//*****************************************************************************
//*
//*     OnKillFocus
//*
//*****************************************************************************
void CTextView::OnKillFocus(CWnd *pNewWnd)
{

	CAnsiView::OnKillFocus(pNewWnd);
	StatusbarExit();
	SendNotify(TXT_KILLFOCUS);

}

//*****************************************************************************
//*
//*     OnCut OnCopy OnClear OnPaste .....
//*
//*****************************************************************************
void CTextView::OnUndo      (){Undo              (-1);}
void CTextView::OnUndoBack  (){Undo              ( 1);}
void CTextView::OnClear     (){SelectionClear    (  );}
void CTextView::OnCut       (){SelectionCut      (-1);}
void CTextView::OnCopy      (){SelectionCopy     (-1);}
void CTextView::OnPaste     (){SelectionInsert   (-1);}
void CTextView::OnCutRange  (int iId){SelectionCopy  (iId-ID_EDIT_CUT_0  );}
void CTextView::OnCopyRange (int iId){SelectionCopy  (iId-ID_EDIT_COPY_0 );}
void CTextView::OnPasteRange(int iId){SelectionInsert(iId-ID_EDIT_PASTE_0);}

//*****************************************************************************
//*
//*		OnCopyWord
//*
//*****************************************************************************
//	Ein Wort mit rechtem Mausklick kopieren
void CTextView::OnCopyWord()
{

	IsWord(m_iWordPosX,m_iWordPosY,1);

}

//*****************************************************************************
//*
//*		OnDicOnOff
//*
//*****************************************************************************
//	Rechtschreibprfung ein/ausschalten
#ifdef 		USE_DICIONARY
void CTextView::OnDicOnOff()
{
	SetDicFlags(m_iDicFlags^FLAG_DICON,FLAG_DICON);
}
#endif


//*****************************************************************************
//*
//*		OnMarkOnOff
//*
//*****************************************************************************
//	Wortmarkierungen ein/ausschalten
#ifdef 		USE_MARK_HIGHLIGHT
void CTextView::OnMarkOnOff()
{
int		iMode;


	if(m_ucWordMarkMode==255)return;


	   iMode = m_iFlags&FLAG_WORDMARK_TYPE;
	if(iMode==FLAG_WORDMARK_TYPE)
		{
		return;												// Externer Modus
		}

	ASSERT(FLAG_WORDMARK_LAST==(FLAG_WORDMARK_TYPE<<2));

	if(iMode==0)
		{
			iMode = (m_iFlags&FLAG_WORDMARK_LAST)>>2;
		if(!iMode)iMode=FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE>>1);
		}
	else{
		m_iFlags &= ~FLAG_WORDMARK_LAST;
		m_iFlags |=  iMode<<2;
		iMode	  =  0;
		}

	SetFlags(iMode,FLAG_WORDMARK_TYPE);

}
#endif

//*****************************************************************************
//*
//*		OnMenuMarkOn
//*
//*****************************************************************************
//	Wortmarkierungen prfen ob es geht
#ifdef 		USE_MARK_HIGHLIGHT
void CTextView::OnMenuMarkOn(CCmdUI *pCmdUI)
{
int		iMode;


	if((m_iFlags&FLAG_HAS_WORDMARK) && m_ucWordMarkMode!=255)
		{
		iMode = m_iFlags&FLAG_WORDMARK_TYPE;
		pCmdUI->Enable  (iMode!=FLAG_WORDMARK_TYPE);
		pCmdUI->SetCheck(iMode!=0);
		}
	else{
		pCmdUI->Enable  (FALSE);
		pCmdUI->SetCheck(FALSE);
		}

}
#endif


//*****************************************************************************
//*
//*     CheckBlock
//*
//*****************************************************************************
//	Prft ob ein Speicherblock fr Zeilenadressen gro genug ist.
//	Ergibt 0 fr ok und 1 bei einem Fehler
void CTextView::CheckBlock()
{
TextLinePtr    *pTemp;
TextLinePtr    *pLine;
int				iNew;


	if(m_iVirtualLines)return;


	if(m_iLineCount<m_iLineListSize/2 && m_iLineCount<TEXT_LINES_ADD*8)
		{
		iNew  =  m_iLineListSize/2+TEXT_LINES_ADD;		// Block verkleinern
		}
	else if(m_iLineCount>=m_iLineListSize)
		{
		iNew  = (m_iLineListSize*3/2+TEXT_LINES_ADD);	// Block vergern
		}
	else{
		return;											// Keine nderung
		}

	ASSERT(m_iLineCount>=0 && m_iLineCount<=iNew);

	pLine = new TextLinePtr[iNew+1];					// Neuen greren Block erstellen und alten zerstren

	memcpy(pLine,m_pLineList,m_iLineCount*sizeof(char*));

	m_iLineListSize = iNew;
	pTemp			= m_pLineList;
	m_pLineList		= pLine;

	delete pTemp;


}

//*****************************************************************************
//*
//*		SendNotify
//*
//*****************************************************************************
void CTextView::SendNotify(int iType,int iParam1,int iParam2,int iParam3)
{
TXT_NMHDR	 sNotify;

CWnd		*pWnd;

	   pWnd=GetParent();
	if(pWnd)
		{
		sNotify.sHdr.code		= iType;
		sNotify.sHdr.hwndFrom	= m_hWnd;
		sNotify.sHdr.idFrom		= GetWindowLong(m_hWnd,GWL_ID);
		sNotify.iParam1			= iParam1;
		sNotify.iParam2			= iParam2;
		sNotify.iParam3			= iParam3;

		GetParent()->SendMessage(WM_NOTIFY,sNotify.sHdr.idFrom,(LPARAM)&sNotify);
		}

}

//*****************************************************************************
//*
//*     LineCreate
//*
//*****************************************************************************
//	Erzeugt eine neue Zeile.
//	pText		: Ist der Text der in der Zeile steht
//	uLen		: Ist die Lnge des Textes in der Zeile.
//	Ergibt den Zeiger auf die neuen Zeile, bzw. 0 bei Fehler.
CTextView::TextLine *CTextView::LineCreate(const unsigned char *pText,unsigned uLen)
{
TextLine   *pLine;
unsigned 	uSize;



	uSize			= LINE_HEADER+((uLen+0x0F)&~0x0F);		// Neue Zeile erzeugen
	pLine			= (TextLine*)new char[uSize+4];
	pLine->uSize	= uLen;
	pLine->bGroup	= 0;
	pLine->dwData	= 0;
	pLine->bColor	= 0;
	pLine->pColors	= 0;
	#ifdef USE_VIRTUAL_LINES
	pLine->uNext	= 0;
	pLine->uPrev	= 0;
	#endif

	#ifdef USE_DICIONARY
	pLine->aText[uSize-LINE_HEADER+DIC_INFO]=0;
	#endif

	ASSERT(uLen+LINE_HEADER<=uSize);
	memcpy(pLine->aText,pText,uLen);
	pLine->aText[uLen]=0;

	LineBeginEnd(pLine);									// Start und Endpositionen berechnen


return pLine;
}

//*****************************************************************************
//*
//*     LineBeginEnd
//*
//*****************************************************************************
//	Start und Endpositionen berechnen einet Zeile berechnen.
//	Jedes Tabulator-Zeichen wird mit auf den nchsten Tabraster gebracht
void CTextView::LineBeginEnd(TextLine *pLine)
{
uchar	   *pText;
unsigned	uStart;
unsigned	uChar;
unsigned	uPos;
unsigned	uLen;
unsigned	uEnd;
int			iTab;


	iTab	= m_iTabWidth;
	pText	= pLine->aText;
	uLen	= pLine->uSize;


	for(uPos=0,uStart=0;uPos<uLen;uPos++)					// Suche erstes Zeichen im Text
		{
		uChar = pText[uPos];

		if(uChar==' ' ){uStart++;							continue;}
		if(uChar=='\t'){uStart+=iTab; uStart-=uStart%iTab;	continue;}
		break;
		}


	for(uEnd=uStart;uPos<uLen;uPos++)						// Suche Ende des Textes
		{
		uChar = pText[uPos];
		#ifdef USE_UTF8
		if(uChar>=0xC0)uPos+=utf8tochar(pText+uPos,uChar)-1;
		#endif

		if(uChar=='\t'){uEnd+=iTab; uEnd-=uEnd%iTab;	 continue;}
		uEnd++;
		}


	pLine->uStart = uStart;
	pLine->uEnd   = uEnd;

}

//*****************************************************************************
//*
//*     LineInsert
//*
//*****************************************************************************
//	Fgt bei einer Zeile eine neue Zeile ein
//	uLine	: Nummer der Zeile
//	pText	: Neuer Text der Zeile
//	uLen	: Lnge des neuen Textes
//	Ergibt 0 bei Fehler und 1 wenn ok
int	CTextView::LineInsert(unsigned uLine,const unsigned char *pText,unsigned uLen)
{
TextLine  *pLine;


	if(m_iVirtualLines          )return 0;
	if(m_iLineCount>=m_iLinesMax)return 0;
	if(uLine>(uint)m_iLineCount )uLine=m_iLineCount;
	if(uLen >(uint)m_iMaxChars  )uLen =m_iMaxChars;


	CheckBlock();

	pLine = LineCreate(pText,uLen);

	ASSERT(pLine!=0);


	#ifdef  USE_VIRTUAL_LINES

	if(uLine<(uint)m_iLineCount)							// Zugeklappten Bereich korrigieren
	if(m_pLineList[uLine]->uPrev>1)
		{
		int		iPos;
		int		iEnd;

		pLine->uPrev = m_pLineList[uLine]->uPrev;
		pLine->uNext = m_pLineList[uLine]->uNext+1;

		iEnd = uLine+pLine->uNext;

		for(iPos=uLine;iPos<iEnd;iPos++)
			{
			m_pLineList[iPos]->uPrev++;
			}

		iEnd = uLine-pLine->uPrev;

		for(iPos=uLine-1;iPos>iEnd;iPos--)
			{
			m_pLineList[iPos]->uNext++;
			}
		}

	#endif

	ASSERT(m_iLineCount>=0 && m_iLineCount<m_iLineListSize);
	ASSERT(uLine<(unsigned)m_iLineListSize);

	if(uLine<(unsigned)m_iLineCount)						// Zeilenadresse ein Block einfgen
		{
		memmove(m_pLineList+uLine+1,m_pLineList+uLine,(m_iLineCount-uLine)*sizeof(TextLinePtr));
		}

	m_pLineList[uLine] = pLine;
	m_iLineCount++;


	if(m_pHookInsertLine)
		{
		m_pHookInsertLine(this,m_pHookInsertLineParam,uLine);
		}


return 1;
}

//*****************************************************************************
//*
//*     LineChange
//*
//*****************************************************************************
//	Tauscht den Text einer Zeile mit einem neuen Text aus.
//	uLine	: Nummer der Zeile
//	pText	: Neuer Text der Zeile
//	uLen		: Lnge des neuen Textes
//	Ergibt 0 bei Fehler und 1 wenn ok
int CTextView::LineChange(unsigned uLine,const unsigned char *pText,unsigned uLen)
{
TextLine   *pLine1;
TextLine   *pLine2;


	if(m_iVirtualLines)return 0;

	if(uLine>=(uint)m_iLineCount)							// Zeile hinten anhngen
		{
		return LineInsert(uLine,pText,uLen);
		}

	if(uLen>(uint)m_iMaxChars)uLen=m_iMaxChars;

	pLine1			= m_pLineList[uLine];					// Neuen Block einfgen
	pLine2			= LineCreate(pText,uLen);
	pLine2->bGroup	= pLine1->bGroup;
	pLine2->dwData	= pLine1->dwData;
	pLine2->bColor	= pLine1->bColor;
	#ifdef  USE_VIRTUAL_LINES
	pLine2->uNext	= pLine1->uNext;
	pLine2->uPrev	= pLine1->uPrev;
	#endif

	m_pLineList[uLine]=pLine2;

	if(pLine1->pColors)										// Farbspeicher lschen
		{
		#ifdef USE_DICIONARY
		int iSize1;
		int iSize2;

		iSize1 = ((pLine1->uSize+0x0F)&~0x0F)+DIC_INFO;
		iSize2 = ((pLine2->uSize+0x0F)&~0x0F)+DIC_INFO;
		pLine2->aText[iSize2] = pLine1->aText[iSize1];

		#endif

		delete pLine1->pColors;
		}

	delete pLine1;											// Textspeicher lschen



return 1;
}

//*****************************************************************************
//*
//*     LineDelete
//*
//*****************************************************************************
//	Lscht eine Zeile.
//	uLine	: Nummer der Zeile
//	Ergibt 0 bei Fehler und 1 wenn ok
int CTextView::LineDelete(unsigned uLine)
{
TextLine  *pLine;


	if(m_iVirtualLines)return 0;

	if(uLine>=(uint)m_iLineCount)return 1;


	if(m_pHookDeleteLine)
		{
		m_pHookDeleteLine(this,m_pHookDeleteLineParam,uLine);
		}


	   pLine = m_pLineList[uLine];
	if(pLine->pColors)										// Farbspeicher lschen
		{
		delete pLine->pColors;
		pLine->pColors = 0;
		}



	#ifdef  USE_VIRTUAL_LINES

	if(pLine->uNext)										// Zugeklappten Bereich korrigieren
		{
		int		iPos;
		int		iEnd;

		iEnd = uLine+pLine->uNext;

		for(iPos=uLine+1;iPos<iEnd;iPos++)
			{
			m_pLineList[iPos]->uPrev--;
			}

		iEnd = uLine-pLine->uPrev;

		for(iPos=uLine-1;iPos>iEnd;iPos--)
			{
			m_pLineList[iPos]->uNext--;
			}
		}

	#endif


	delete pLine;											// Textspeicher lschen

	m_iLineCount--;
	memmove(m_pLineList+uLine,m_pLineList+uLine+1,(m_iLineCount-uLine)*sizeof(char*));

	CheckBlock();



return 1;
}


//*****************************************************************************
//*
//*     PositionOk
//*
//*****************************************************************************
//	Eine neue Cursor-Position setzen und prfen.
//	iPosX/iPosY		: Ist die neue Cursor Position, absolut oder relativ je nach Art
//  iMode			: Bestimmt die Art der Cursor-Verschiebung.
//							Bit 0 = 0 : Absolute Koordinaten
//							Bit 0 = 1 : Relative Koordinaten
//							Bit 1 = 1 : Ziehen mit Shift oder Maus
//							Bit 2 = 1 : CLTR ist gedrckt
//							Bit 3 = 1 : Eingabe ber Maus
//							Bit 4 = 1 : Maus Taste zum ersten mal gedrckt
//							Bit 7 = 1 : Links/Rechts/Auf/Ab Taste wurde gedrckt
//	Ergibt 1 wenn Koordinaten verntert wurden;
int CTextView::PositionOk(int iPosX,int iPosY,int iMode=0)
{
TextLine   *pLine;
uchar	   *pText;
uchar		aChar[2];
int			iCursorNewX;
int			iCursorNewY;
int			iBracketNewX;
int			iBracketNewY;
int			iBracket;
int			iVert;
int			iPos;
int			iLen;
int			iEnd;
int			iVal;



	iVert=0;

	if(iMode&1)
		{													// Relative Position
		iCursorNewX = m_iCursorX+iPosX;
		iCursorNewY = TEXT_STEP(m_iCursorY,iPosY);

		if(iPosX==0 && iPosY!=0 && !(m_iFlags&FLAG_VIRTUAL_SCREEN))
			{
			iCursorNewX	= m_iCursorLastX;
			iVert		= 1;
			}

		if(m_iMarkOn && !(iMode&2))							// Zum Markenanfang
			{
			if((iPosX==-1 && iPosY==0) || (iPosX==0 && iPosY==-1))
			if( m_iCursorY>m_iMarkY    || (m_iCursorY==m_iMarkY && m_iCursorX>m_iMarkX))
				{
				if(iPosY){iCursorNewY=m_iMarkY-1;}
				else	 {iCursorNewX=m_iMarkX;iCursorNewY=m_iMarkY;}
				}
															// Zum Markenende
			if((iPosX==1 && iPosY==0) || (iPosX==0 && iPosY==1))
			if( m_iCursorY<m_iMarkY   || (m_iCursorY==m_iMarkY && m_iCursorX<m_iMarkX))
				{
				if(iPosY){iCursorNewY=m_iMarkY+1;}
				else	 {iCursorNewX=m_iMarkX;iCursorNewY=m_iMarkY;}
				}
			}
		}
	else{
		iCursorNewX = iPosX;								// Absolute Position
		iCursorNewY = TEXT_STEP(iPosY,0);
		}


//*****************************************************************************


	do{

	if(iCursorNewY<0)
		{
		iCursorNewY = TEXT_STEP(0,0);
		}

	if(iCursorNewX<0)										// Rckschritt am Zeilenanfang
	do	{
		if((iMode&8) || (iCursorNewY<=0)){iCursorNewX=0;break;}
		if(iCursorNewY-1>=m_iLineCount)break;

		iCursorNewY = TEXT_STEP(iCursorNewY,-1);
		pLine		= GetLine(iCursorNewY);
		iCursorNewX	= pLine->uEnd;
		}while(0);

	if(iCursorNewY>=m_iLineCount)							// Prfe ob ber letzter Zeile
		{
		if(m_iCursorY>=m_iLineCount || !(m_iFlags&FLAG_VIRTUAL_SCREEN))
			{
			iCursorNewX = 0;
			}

		iCursorNewY = m_iLineCount;
		break;
		}

	pLine = GetLine(iCursorNewY);
	pText = pLine->aText;
	iLen  = pLine->uSize;
	iEnd  = pLine->uEnd;
	iPos  = TextPosition(iCursorNewX,pText,iLen);

	if(iCursorNewX>iEnd)									// Cursor hinter Zeile
		{
		if(m_iFlags&FLAG_VIRTUAL_SCREEN)break;
		if((iMode&1) && (iPosX>0) && !(iMode&8))
			{
			iCursorNewY = TEXT_STEP(iCursorNewY,1);
			iCursorNewX = 0;
			}
		else{
			iCursorNewX = iEnd;
			}

		break;
		}

	if(!iPos || !(iCursorNewX%m_iTabWidth))break;

	if(pText[iPos-1]==9)									// Cursor auf TAB-Zeichen
		{
		if((iMode&1)&((iPosX>0)? 1:0))
				iCursorNewX += -iCursorNewX%m_iTabWidth+m_iTabWidth;
		else	iCursorNewX  =  ViewPosition(iPos-1,pText,iLen);
		}

	}while(0);


//*****************************************************************************


	if(iMode&2)												// Marke nicht nachziehen
		{
		if(iCursorNewY==m_iCursorY)
				DrawViewCursorLine();
		else	DrawViewArea(m_iCursorY,iCursorNewY);

								 m_iMarkOn=0;
		if(iCursorNewX!=m_iMarkX)m_iMarkOn=1;
		if(iCursorNewY!=m_iMarkY)m_iMarkOn=2;
		}
	else{													// Marke nachziehen
		if(m_iMarkOn)
			{
			if(m_iMarkOn==2)
				{
				DrawViewArea(m_iMarkY,m_iCursorY);
				}
			else if(m_iMarkY==iCursorNewY)
				{
				DrawViewCursorLine();
				}
			else{
				DrawViewLine(m_iMarkY);
				}
			}

		m_iMarkX  = iCursorNewX;
		m_iMarkY  = iCursorNewY;
		m_iMarkOn = 0;
		}


//******************* Nach Klammern suchen ************************************


	if(m_pBracketMode && (m_iFlags&FLAG_BRACKET))
	do	{
		m_iBracketArea	= 0;
		iBracket		= 0;
		iBracketNewX	= iCursorNewX;
		iBracketNewY	= iCursorNewY;

		if(iBracketNewY<m_iLineCount)
		do	{
			pLine = GetLine(iBracketNewY);
			pText = pLine->aText;
			iLen  = pLine->uSize;
			iPos  = TextPosition(iBracketNewX,pText,iLen);

			aChar[1]=0;
			aChar[0]=(iPos<iLen)? pText[iPos]:0;


			if(m_uBracketOff)								// Gewisse Farben auslassen
				{
				unsigned uColor,uTemp;

				uColor = GetColorPos(iPos,iBracketNewY);

				for(uTemp=m_uBracketOff;uTemp;uTemp>>=8)
					{
					if(!((uTemp^uColor)&0xFF)){aChar[0]=0;break;}
					}
				}

			//**************** Suche Rckwrts ********************************
			if(strspn((char*)aChar,(char*)m_pBracketMode+5))
				{
				iVal=1;
				iEnd=m_iScrollY;
				while(iBracketNewY>=iEnd)
					{
					iPos--;
					if(iPos<0)								// Neue Zeile ?
						{
						   iBracketNewY--;
						if(iBracketNewY<iEnd)break;
						pLine = GetLine(iBracketNewY);
						pText = pLine->aText;
						iLen  = pLine->uSize;
						iPos  = iLen;
						continue;
						}

					aChar[0] = pText[iPos];

					if(m_uBracketOff)						// Gewisse Farben auslassen
						{
						unsigned uColor,uTemp;

						uColor=GetColorPos(iPos,iBracketNewY);

						for(uTemp=m_uBracketOff;uTemp;uTemp>>=8)
							{
							if(!((uTemp^uColor)&0xFF)){aChar[0]=0;break;}
							}
						}

					if(strspn((char*)aChar,(char*)m_pBracketMode  ))iVal--;
					if(strspn((char*)aChar,(char*)m_pBracketMode+5))iVal++;

					if(!iVal)								// Klammer gefunden
						{
						iBracket=1;
						iBracketNewX=ViewPosition(iPos,pText,iLen);
						break;
						}
					}

				 if(m_iFlags&FLAG_BRACKET_MODE)
					{
					m_iBracketArea = -1;

					if(!iBracket)
						{
						iBracket	 = 1;
						iBracketNewX = 0;
						iBracketNewY = iEnd;
						}
					}
				 }
			//**************** Suche Vorwrts *********************************
			else if(strspn((char*)aChar,(char*)m_pBracketMode))
				{
				iVal	= 1;
				iEnd	= m_iScrollY+m_iScreenY;

				if(iEnd>m_iLineCount)iEnd=m_iLineCount;

				while(iBracketNewY<iEnd)
					{
					iPos++;

					if(iPos>=iLen)							// Neue Zeile ?
						{
						   iBracketNewY++;
						if(iBracketNewY>=iEnd)break;

						pLine = GetLine(iBracketNewY);
						pText = pLine->aText;
						iLen  = pLine->uSize;
						iPos  = 0;
						}

					aChar[0]  = pText[iPos];

					if(m_uBracketOff)						// Gewisse Farben auslassen
						{
						unsigned uColor,uTemp;

						uColor=GetColorPos(iPos,iBracketNewY);

						for(uTemp=m_uBracketOff;uTemp;uTemp>>=8)
							{
							if(!((uTemp^uColor)&0xFF)){aChar[0]=0;break;}
							}
						}

					if(strspn((char*)aChar,(char*)m_pBracketMode  ))iVal++;
					if(strspn((char*)aChar,(char*)m_pBracketMode+5))iVal--;

					if(!iVal)								// Klammer gefunden
						{
						iBracket=1;
						iBracketNewX=ViewPosition(iPos,pText,iLen);
						break;
						}
					}

				 if(m_iFlags&FLAG_BRACKET_MODE)
					{
					m_iBracketArea = 1;

					if(!iBracket)
						{
						iBracket	 = 1;
						iBracketNewX = 0;
						iBracketNewY = iEnd;
						}
					}
				 }
			}while(0);


		if(!m_cBracketOn && !iBracket)break;
		if( m_cBracketOn &&  iBracket)
		do	{
			if( m_iBracketY==  m_iCursorY)
			if(iBracketNewY== iCursorNewY)break;
			if( iCursorNewY==  m_iCursorY)
			if(iBracketNewY== m_iBracketY)
				{ m_iRedrawFlags|=NZ_LINE;break;}
				  m_iRedrawFlags =NZ_ALL;
			}while(0);

		if(m_cBracketOn)
		do	{
			m_cBracketOn=0;
			if(  m_iFlags&FLAG_BRACKET_MODE)
			   { m_iRedrawFlags =NZ_ALL;break;}
			if(( m_iRedrawFlags &NZ_LINE_YY) &&
			  (( m_iRedrawFlags &NZ_LINE_XX)!=m_iBracketY))
			   { m_iRedrawFlags =NZ_ALL;break; }
			else m_iRedrawFlags|=NZ_LINE_NR | m_iBracketY;

			if(m_iCursorY==m_iBracketY)break;
			if(m_iCursorY==iCursorNewY)
			   { m_iRedrawFlags|=NZ_LINE;break; }
				 m_iRedrawFlags =NZ_ALL;
			}while(0);

		if(iBracket)										// Neue Klammer Position
		do	{
			m_cBracketOn = 1;
			m_iBracketX  = iBracketNewX;
			m_iBracketY  = iBracketNewY;

			if(m_iFlags&FLAG_BRACKET_MODE)
			  { m_iRedrawFlags =NZ_ALL; break;}
			if(iCursorNewY==iBracketNewY)
			  {	m_iRedrawFlags|=NZ_LINE;break;}
			if( m_iRedrawFlags &NZ_LINE_YY)
			if((m_iRedrawFlags &NZ_LINE_XX)!=m_iBracketY)
			  {	m_iRedrawFlags =NZ_ALL;	break;}
 				m_iRedrawFlags|=NZ_LINE_CURSOR|NZ_LINE_NR|m_iBracketY;
			}while(0);
		}while(0);

//*****************************************************************************


	#ifdef USE_MARK_HIGHLIGHT

	if(m_ucWordMarkMode!=255 && (m_iCursorX!=iCursorNewX || m_iCursorY!=iCursorNewY))
		{
		m_ucWordMarkTicker = 3;								// Wortmarkierung verzgert starten
		}

	#endif

															// Maus-Move-Hook
	if(m_pHookMoveCursor &&	(m_iCursorX!=iCursorNewX || m_iCursorY!=iCursorNewY))
		{
		m_iCursorX = iCursorNewX;
		m_iCursorY = iCursorNewY;
	 	m_pHookMoveCursor(this,m_pHookMoveCursorParam,m_iCursorX,m_iCursorY);
		}
	else{
		m_iCursorX = iCursorNewX;
		m_iCursorY = iCursorNewY;
		}

	if(!iVert)m_iCursorLastX=iCursorNewX;

	StatusbarSet();


return TRUE;
}



//*****************************************************************************
//*
//*     TextPosition
//*
//*****************************************************************************
//	Konvertiert eine X-Koordinate in einen Offset im Textspeicher um.
//	iPos	: Ist die X-Koordinate im Fenster.
//	pText	: Zeiger auf den Zeilentext.
//	uLen	: Ist die Lnge des Textspeichers
//	Ergibt den Offset im Zeilentext.
int	CTextView::TextPosition(int iPos,unsigned char *pText,unsigned uLen)
{
unsigned	uChar;
unsigned	uTab;
unsigned	uNum;
int			iNow;


	iNow = 0;
	uNum = 0;
	uTab = m_iTabWidth;

	while(iNow<iPos)
		{
		if(uNum>=uLen)break;

		uChar = pText[uNum];

		if(uChar=='\t')									// TAB-Zeichen
			{
			iNow += uTab;
			iNow -= iNow%uTab;
			}
		else{
			iNow++;
			}


		#ifdef USE_UTF8
		if(uChar>=0xC0)uNum+=utf8tochar(pText+uNum,uChar);
		else
		#endif

		uNum++;
		}


return uNum;
}

//*****************************************************************************
//*
//*     ViewPosition
//*
//*****************************************************************************
//	Konvertiert einen Offset im Textspeicher in eine X-Koordinate.
//	iPos	: Ist der Offset im Textspeicher
//	pText	: Zeiger auf den Zeilentext.
//	uLen	: Ist die Lnge des Textspeichers
//	Ergibt die X-Koordinate im Fenster.
int	CTextView::ViewPosition(int iPos,unsigned char *pText,unsigned uLen)
{
unsigned	uChar;
unsigned	uTab;
unsigned	uNow;
unsigned	uNum;


	uNow = 0;
	uNum = 0;
	uTab = m_iTabWidth;

	while((int)uNum<iPos)
		{
		if(uNum>=uLen)break;

		uChar = pText[uNum];

		if(uChar=='\t')										// TAB-Zeichen
			{
			uNow += uTab;
			uNow -= uNow%uTab;
			}
		else{
			uNow++;
			}

		#ifdef USE_UTF8
		if(uChar>=0xC0)uNum+=utf8tochar(pText+uNum,uChar);
		else
		#endif

		uNum++;
		}


return uNow;
}

//*****************************************************************************
//*
//*     CharInput
//*
//*****************************************************************************
//	Eingabe eines einzelnen Zeichens ber OnChar
//	nChar		: Zeichen das eingegeben werden soll.
//	iUndoEn		: Ist Undo eralaubt
//	Ergibt 1 wenn Text gendert wurde sonst 0.
int	CTextView::CharInput(unsigned nChar,int iUndoEn)
{
unsigned	    uOld;
unsigned char  *pNew;
unsigned char  *pText;
unsigned char  *pTemp;
TextLine	   *pEntry;
TextLine	   *pLine;
UndoBlock	   *pUndo;
int				iMark;
int				iLine;
int				iPosX;
int				iPosY;
int				iPos;
int				iLen;
int				iEnd;
int				iOff;
int				iNum;
int				x,y;


	if(m_cNotChange)         								// Darf gendert werden ?
		{
		if(nChar==VK_TAB)
			{
			if(m_cHasTabLoop)SendNotify(TXT_TABLOOP,(m_iKeyState&KEY_SHIFT)? 1:0);
			return 0;
			}

		MessageBeep(MB_ICONASTERISK);
		return 0;
		}

	if(nChar<' ')											// Nur gewisse ASCII-Zeichen bernemmen
		{
		if(nChar==VK_TAB)
			{
			if(m_cHasTabLoop)
				{
				SendNotify(TXT_TABLOOP,(m_iKeyState&KEY_SHIFT)? 1:0);
				return 0;
				}
			}
		else if(nChar!=7 && nChar!=VK_BACK && nChar!=VK_RETURN)
			{
			return 0;
			}
		}


	if(m_iMarkOn)											// Marke lschen
		{
		if(m_pHookChangeText)								// Callback fr nderungen abfragen
			{
			GetSelectionPos(iPosX,iPosY);

			if(!m_pHookChangeText(this,m_pHookChangeTextParam,iPosX,iPosY,m_cChanged))
				{
				return FALSE;
				}
			}

		   iMark=SelectionClear();
		if(iMark)
			{
			m_cChanged=1;

			if(m_cBracketOn)
				{
				PositionOk(0,0,1);
				m_iRedrawFlags = NZ_ALL;
				}

			if(nChar==7 || nChar==8)
				{
				m_iCursorLastX = m_iCursorX;
				return 1;
				}
			}
		}
	else{
		iMark=0;
		}


	if(iUndoEn)												// Undo-Eintrag erstellen
		{
		pUndo			= m_aUndo+m_iUndoPos;
		pUndo->cChanged	= m_cChanged;
		pUndo->sPoint.x	= m_iCursorX;
		pUndo->sPoint.y	= m_iCursorY;
		pUndo->sDelPt	= pUndo->sPoint;
		pUndo->uOldChar	= nChar;
		}
	else{
		pUndo = 0;
		}


//*********** Cursor unter letzter Zeile **************************************


	iLine = m_iCursorY;										// Grunddaten

	if(iLine>=m_iLineCount)									// Neue Zeile erzeugen ?
		{
		switch(nChar)
			{
		case 13:											// RETURN es wird nur eine weiter Leerzeile eingefgt
					if(iLine>=m_iLinesMax)					// Zuviele Zeilen
						{
						MessageBeep(MB_ICONASTERISK);
						return iMark;
						}

					if(m_pHookChangeText)					// Callback fr nderungen abfragen
						{
						if(!m_pHookChangeText(this,m_pHookChangeTextParam,0,iLine,m_cChanged))
							{
							return FALSE;
							}
						}

					LineInsert  (iLine,NULL,0);
					DrawViewFrom(iLine);
					PositionOk(0,iLine+1,0);
					PrintColor(  iLine);

					break;

		case  7:											// DEL-Taste wird ignoriert
					MessageBeep(MB_ICONASTERISK);
					return iMark;

		case  8:											// RCK-Taste wird in eine Cursorbewegung umgewandelt
					if(m_iCursorX>0)
						{
						PositionOk(-1, 0,1);
						m_iRedrawFlags|=NZ_CURSOR;
						return iMark;
						}

					if(iLine<=0)
						{
						MessageBeep(MB_ICONASTERISK);
						return iMark;
						}

					pLine  = GetLine(iLine-1);
					iEnd   = pLine->uEnd;

					PositionOk(iEnd,iLine-1,0);

					m_iRedrawFlags|=NZ_CURSOR;

					return iMark;

		default:											// ASCII-Zeichen in Zeile einfgen
					if(nChar<' ' && nChar!='\t')return iMark;

					if(m_pHookChangeText)					// Callback fr nderungen abfragen
						{
						if(!m_pHookChangeText(this,m_pHookChangeTextParam,0,iLine,m_cChanged))
							{
							return FALSE;
							}
						}

					x    = m_iCursorX/m_iTabWidth;
					y    = m_iCursorX%m_iTabWidth;
					pNew = m_pNullLine;

					memset(pNew  ,'\t',x);
					memset(pNew+x,' ' ,y);

					#ifdef USE_UTF8
					if(nChar>=0x80)iNum=chartoutf8(pNew+x+y,nChar);
					else
					#endif
					{
					pNew[x+y] = nChar;
					iNum      = 1;
					}

					LineInsert(iLine,pNew,x+y+iNum);

					if(nChar=='\t')
							PositionOk(m_iTabWidth-m_iCursorX%m_iTabWidth,0,1);
					else	PositionOk(1,0,1);
				     		PrintColor(iLine);

					m_iRedrawFlags |= NZ_LINE;
			}


		if(iUndoEn)
			{
			UndoAdd();
			pUndo->sDelPt.x	= m_iCursorX;					// Undo-Koordinaten
			pUndo->sDelPt.y	= m_iCursorY;
			pUndo->cMode	= UNDO_DEL;
			}

		m_cChanged = 1;

		return 1;
		}


//**************** Grunddaten *************************************************


	pLine	= GetLine(iLine);
	pText	= pLine->aText;
	iLen	= pLine->uSize;
	iEnd	= pLine->uEnd;
	iPos	= TextPosition(m_iCursorX,pText,iLen);			// Position im Text


//**************** RETURN Eingabe *********************************************


	if(nChar==13)											// RETURN Taste
		{
		if(iLine>=m_iLinesMax)								// Zuviele Zeilen
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}

		if(m_pHookChangeText)								// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
				{
				return FALSE;
				}
			}

		if(m_cUndoLocked)									// Bei UNDO keine Einrckung
			{
			iOff = 0;
			}
		else{
			iOff = pLine->uStart;
			if(m_iCursorX<iOff)iOff=0;
			}

		x = iOff/m_iTabWidth;
		y = iOff%m_iTabWidth;

		pNew = m_pNullLine;									// Neue Zeile erzeugen

		memset (pNew  ,'\t',x);
		memset (pNew+x,' ' ,y);
		memmove(pNew+x+y,pText+iPos,iLen-iPos);				// Resttext anhngen

		LineInsert(iLine+1,pNew,iLen-iPos+x+y);


		if(((iLen+15)&~0x0F)-iPos>=16)						// Zeile krzen ?
			{
			LineChange(iLine,pText,iPos);
			}
		else{
			pLine->uSize=iPos;
			LineBeginEnd(pLine);
			}

		DrawViewFrom(iLine);
		PositionOk(iOff,iLine+1,0);

		iOff = PrintColor(iLine);
		if(iOff<=iLine+1)PrintColor(iLine+1);

		if(iUndoEn)											// Undo mit DEL-Taste
			{
			UndoAdd();
			pUndo->sDelPt.x	= m_iCursorX;					// Undo-Koordinaten
			pUndo->sDelPt.y	= m_iCursorY;
			pUndo->cMode	= UNDO_DEL;
			}

		m_cChanged = 1;

		return 1;
		}


//**************** TAB-Taste **************************************************


	if(nChar=='\t')											// TAB wird in eine Cursorbewegung umgewandelt
		{
		iOff  = m_iCursorX+m_iTabWidth;
		iOff -= iOff      %m_iTabWidth;

		if(iPos>=iLen)										// Hinter Zeilenende
			{
			if(m_iFlags&FLAG_VIRTUAL_SCREEN)
				{
				PositionOk(iOff,iLine,0);
				return iMark;
				}
			else{
				iPos=iLen;
				}
			}

		if(iLen+1>m_iMaxChars)								// Zeile zu lang
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}


		if(m_pHookChangeText)								// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
				{
				return FALSE;
				}
			}


		if(m_cUndoLocked==0)
		if(iOff-m_iTabWidth<m_iCursorX && iPos>0)			// berflssige Leerzeichen entfernen
			{
			for(x=0;x<m_iCursorX%m_iTabWidth;x++)
				{
				if(pText[iPos-x-1]!=' ')break;
				}

			if(x>0)											// SPACE lschen
				{
				if(iUndoEn)
					{
					UndoAdd();
					pUndo->cMode	= UNDO_INS;
					pUndo->cChanged	= m_cChanged;
					pUndo->sPoint.x	= m_iCursorX-x;			// Einfgeposition
					pUndo->pData	= new uchar[x+1];
					pUndo->pData[x]	= 0;
					memset(pUndo->pData,' ',x);
					}

				if(x>1)memmove(pText+iPos-x+1,pText+iPos,iLen-iPos);
				pText[iPos-x]  = 9;
				pLine->uSize  -= x-1;
				LineBeginEnd(pLine);						// Start/Ende neu berechnen

				m_iRedrawFlags|=NZ_LINE;
				PositionOk(iOff,iLine,0);
				PrintColor(iLine);

				if(iUndoEn)
					{
					pUndo			= m_aUndo+m_iUndoPos;	// Undo-Info
					UndoAdd();
					pUndo->cMode	= UNDO_CHAR|UNDO_2TRUNS;
					pUndo->uNewChar	= 8;
					pUndo->cChanged	= 1;
					pUndo->sPoint.x	= m_iCursorX;
					pUndo->sPoint.y	= m_iCursorY;
					pUndo->sDelPt  	= pUndo->sPoint;
					pUndo->uOldChar	= nChar;
					}

				m_cChanged=1;

				return 1;
				}
			}


		if(m_cUndoLocked && !(m_iCursorMode&1) && iPos<iLen)
			{
			if(iUndoEn)										// Undo berschreiben
				{
				UndoAdd();
				pUndo->uNewChar	= pText[iPos];
				pUndo->cMode	= UNDO_CHAR|UNDO_OVERWR;
				}

			pText[iPos] = nChar;
			LineBeginEnd(pLine);							// Start/Ende neu berechnen
			m_iRedrawFlags|=NZ_LINE;
			m_cChanged  = 1;

			return 1;
			}

		if(iLen+1 <= ((iLen+15)&~0x0F))						// Ist Zeilenspeicher gro genug
			{
			memmove(pText+iPos+1,pText+iPos,iLen-iPos);
			pText[iPos]   = '\t';
			pLine->uSize += 1;
			LineBeginEnd(pLine);							// Start/Ende neu berechnen
			}
		else{
			pNew = m_pNullLine;								// Zeile neu ersteliLen
			memmove(pNew,pText,iPos);
			pNew[iPos] = '\t';
			memmove(pNew+iPos+1,pText+iPos,iLen-iPos);
			LineChange(iLine,pNew,iLen+1);
			}

		m_iRedrawFlags|=NZ_LINE;
		PositionOk(iOff,iLine,0);
		PrintColor(iLine);

		if(iUndoEn)											// Undo mit DEL-Taste
			{
			UndoAdd();
			pUndo->cMode	= UNDO_CHAR;
			pUndo->uNewChar	= 7;
			}

		m_cChanged = 1;

		return 1;
		}


//**************** RCK-Taste *************************************************


	if(nChar==8)											// RCK-Taste
		{
		if(m_iCursorX>iEnd || m_iVirtualLines)				// Hinter Zeilenende, dann zurck
			{
			x = iEnd-m_iCursorX;
			if(x>=0)x=-1;
			PositionOk(x,0,1);
			return iMark;
			}


		if(m_pHookChangeText)								// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
				{
				return FALSE;
				}
			}


		if(iPos>0)											// Einen Buchstaben lschen
			{
			uOld = pText[iPos-1];
			iNum = 1;

			#ifdef USE_UTF8
			if(uOld>=0x80)iNum=utf8prechar(pText+iPos,uOld);
			#endif


			memmove(pText+iPos-iNum,pText+iPos,iLen-iPos+1);
			x     = ViewPosition(iPos-iNum,pText,iLen);
			iLen -= iNum;

			if(((iLen+15)&~0x0F)-iPos>=16)					// Zeile krzen ?
				{
				LineChange(iLine,pText,iLen);
				}
			else{
				pLine->uSize = iLen;
				LineBeginEnd(pLine);						// Start/Ende neu berechnen
				}

			#ifdef USE_WORD_HIGHLIGHT
			if(m_ucHighlightChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			#ifdef USE_MARK_HIGHLIGHT
			if(m_ucWordMarkChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			m_iRedrawFlags |= NZ_LINE_CURSOR;
			PositionOk(x,m_iCursorY,0);
			PrintColor(iLine);

			if(iUndoEn)										// Undo mit Buchstaben
				{
				UndoAdd();
				pUndo->sDelPt.x	= m_iCursorX;
				pUndo->sDelPt.y	= m_iCursorY;
				pUndo->uNewChar	= uOld;
				pUndo->cMode	= UNDO_CHAR;
				}

			m_iCursorLastX = m_iCursorX;
			m_cChanged     = 1;

			return 1;
			}

		if(iLine<=0)										// Am Textanfang
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}

		iLine--;
		ExpandCheck(iLine);
															// Eine Zeile zurck
		pEntry  = m_pLineList[iLine];
		pTemp	= pEntry->aText;
		iEnd	= pEntry->uEnd;
		iNum	= pEntry->uSize;

		if(iLen+iNum > m_iMaxChars)							// Wird Zeile zu breit
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}

		pNew = m_pNullLine;									// Neue Zeile erzeugen
		memmove(pNew     ,pTemp,iNum);
		memmove(pNew+iNum,pText,iLen);
		LineChange(iLine,pNew,iLen+iNum);
		LineDelete(iLine+1);

		DrawViewFrom(iLine);

		iOff=PrintColor(iLine);
		if(iOff<=iLine+1)PrintColor(iLine+1);

		PositionOk(iEnd,iLine,0);

		if(iUndoEn)
			{
			UndoAdd();
			pUndo->sDelPt.x	= m_iCursorX;					// Undo-Koordinaten
			pUndo->sDelPt.y	= m_iCursorY;
			pUndo->uNewChar	= 13;
			pUndo->cMode	= UNDO_CHAR;
			}

		m_iCursorLastX = m_iCursorX;
		m_cChanged	   = 1;

		return 1;
		}


//**************** DEL-Taste ***************************************************


	if(nChar==7)											// DEL-Taste
		{
		if(m_iVirtualLines)
			{
			return 1;
			}


		if(m_pHookChangeText)								// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
				{
				return FALSE;
				}
			}


		if(iPos<iLen)										// Vor Zeilenende, dann Zeichen lschen
			{
			if(iUndoEn)										// Undo mit Buchstaben
				{
				UndoAdd();
				pUndo->uNewChar	= pText[iPos];
				pUndo->cMode	= UNDO_CHAR|UNDO_SETPOS;
				}

			iNum = 1;

			#ifdef USE_UTF8
			if(pText[iPos]>=0xC0)iNum=utf8tochar(pText+iPos,uOld);
			#endif

			memmove(pText+iPos,pText+iPos+iNum,iLen-iPos-iNum+1);
			iLen -= iNum;

			if(((iLen+15)&~0x0F)-iPos>=16)					// Zeile krzen ?
				{
				LineChange(iLine,pText,iLen);
				}
			else{
				pLine->uSize = iLen;
				LineBeginEnd(pLine);						// Start/Ende neu berechnen
				}

			#ifdef USE_WORD_HIGHLIGHT
			if(m_ucHighlightChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			#ifdef USE_MARK_HIGHLIGHT
			if(m_ucWordMarkChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			m_iRedrawFlags|=NZ_LINE_CURSOR;
			PrintColor(iLine);

			m_cChanged=1;
			return 1;
			}

		if(iLine+1>=m_iLineCount)							// In letzter Zeile
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}

		if(m_iCursorX<=iEnd)								// Cursor hinter Zeilenende
			{
			x = 0;
			y = 0;
			}
		else{
			   iOff = m_iCursorX-m_iCursorX%m_iTabWidth;
			if(iOff<=iEnd)
				{
				x =  0;
				y =  m_iCursorX-iEnd;
				}
			else{
				y =  m_iCursorX  %m_iTabWidth;
				x = (iOff-iEnd-1)/m_iTabWidth+1;
				}
			}


		ExpandCheck(iLine+1);

		pEntry  = m_pLineList[iLine+1];						// Nchste Zeile heranziehen
		pTemp	= pEntry->aText;
		iOff    = pEntry->uSize;

		if(iLen+x+y+iOff>m_iMaxChars)						// Wird die Zeile zu breit
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}

		pNew = m_pNullLine;									// Neu Zeile erzeugen

		memmove(pNew,pText     ,iLen);
		memset (pNew+iLen,'\t' ,   x);	iLen+=x;
		memset (pNew+iLen,' '  ,   y);	iLen+=y;
		memmove(pNew+iLen,pTemp,iOff);	iLen+=iOff;

		LineChange(iLine,pNew,iLen);
		LineDelete(iLine+1);

		DrawViewFrom(iLine);

		iOff = PrintColor(iLine);
		if(iOff<=iLine+1)PrintColor(iLine+1);

		if(iUndoEn)											// Undo mit Return
			{
			UndoAdd();
			pUndo->uNewChar	= 13;
			pUndo->cMode	= UNDO_CHAR|UNDO_SETPOS;
			}

		m_cChanged=1;
		return 1;
		}


//************ ASCII Zeichen bearbeiten ***************************************


	if(m_iVirtualLines)return iMark;
	if( nChar<' '     )return iMark;

	if(iLen>=m_iMaxChars)									// berschreitung der maximalen Zeichenanzahl
		{
		MessageBeep(MB_ICONASTERISK);
		return iMark;
		}


//************ Hinter den Zeilenende einfgen *********************************


	if(m_pHookChangeText)									// Callback fr nderungen abfragen
		{
		if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
			{
			return FALSE;
			}
		}


	do	{
		if(m_iCursorX>iEnd)									// Cursor hinter Zeilenende
			{
			if(iUndoEn)pUndo->sPoint.x=iEnd;

			iOff = m_iCursorX-m_iCursorX%m_iTabWidth;

			if(iOff<=iEnd)
				{
				x =  0;
				y =  m_iCursorX-iEnd;
				}
			else{
				y =  m_iCursorX  %m_iTabWidth;
				x = (iOff-iEnd-1)/m_iTabWidth+1;
				}


			pNew = m_pNullLine;

			memmove(pNew,pText ,iLen);
			memset (pNew+iLen,'\t',x);	iLen+=x;
			memset (pNew+iLen,' ' ,y);	iLen+=y;


			#ifdef USE_UTF8
			iLen += chartoutf8(pNew+iLen,nChar);
			#else
			pNew[iLen] =nChar;
			iLen += 1;
			#endif

			LineChange(iLine,pNew,iLen);

			m_iRedrawFlags|=NZ_LINE_CURSOR;
			PositionOk(1,0,1);
			PrintColor(iLine);

			if(iUndoEn)
				{
				UndoAdd();
				pUndo->sDelPt.x	= m_iCursorX;				// Undo-Koordinaten
				pUndo->sDelPt.y	= m_iCursorY;
				pUndo->cMode	= UNDO_DEL;
				}

			m_cChanged = 1;

			return 1;
			}


//************ Zeichen berschreiben ******************************************


		if(iPos<iLen && !(m_iCursorMode&1) && !iMark)		// Zeichen berschreiben
			{
			uOld = pText[iPos];

			#ifdef USE_UTF8
			if(uOld>=0xC0)
					iNum=utf8tochar(pText+iPos,uOld);
			else	iNum=1;
			#endif

			if(iUndoEn)										// Undo durch berschreiben
				{
				UndoAdd();
				pUndo->uNewChar	= uOld;
				pUndo->cMode	= UNDO_CHAR|UNDO_OVERWR;
				}

			#ifdef USE_UTF8

			if(nChar>=0x80 || uOld>=0x80)
				{
				pNew = m_pNullLine;
				x	 = chartoutf8(pNew+iPos,nChar);

				memcpy(pNew       ,pText          ,iPos          );
				memcpy(pNew+iPos+x,pText+iPos+iNum,iLen-iPos-iNum);

				iLen += x-iNum;

				LineChange(iLine,pNew,iLen);

				#ifdef USE_WORD_HIGHLIGHT
				if(m_ucHighlightChar)m_iRedrawFlags|=NZ_LINE;else
				#endif

				#ifdef USE_MARK_HIGHLIGHT
				if(m_ucWordMarkChar)m_iRedrawFlags|=NZ_LINE;else
				#endif

				m_iRedrawFlags|=NZ_LINE_CURSOR;

				break;
				}

			#endif

			pText[iPos]	= nChar;
			LineBeginEnd(pLine);							// Start/Ende neu berechnen

			#ifdef USE_WORD_HIGHLIGHT
			if(m_ucHighlightChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			#ifdef USE_MARK_HIGHLIGHT
			if(m_ucWordMarkChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			m_iRedrawFlags|=NZ_LINE_CURSOR;

			break;
			}


//************ Zeichen einfgen ***********************************************



		#ifdef USE_UTF8
		if(nChar>=0x80)iNum=utf8length(nChar);
		else
		#endif
		iNum = 1;


		if(iLen+iNum>m_iMaxChars)							// Wird Zeile zu breit
			{
			MessageBeep(MB_ICONASTERISK);
			return iMark;
			}

		if(iUndoEn)											// Undo mit Del
			{
			UndoAdd();
			pUndo->uNewChar	= 7;
			pUndo->cMode	= UNDO_CHAR;
			}

		if((iLen+15)/16 == (iLen+iNum+15)/16)				// Noch Bytes frei
			{
			memmove(pText+iPos+iNum,pText+iPos,iLen-iPos+1);// Zeichen einfgen
			pLine->uSize += iNum;

			#ifdef USE_UTF8
			if(nChar>=0x80)chartoutf8(pText+iPos,nChar);
			else
			#endif

			pText[iPos]=nChar;

			if(pLine->uStart>m_iCursorX)
				{
				pLine->uStart = m_iCursorX;
				}

			pLine->uEnd = ViewPosition(iLen+iNum,pText,iLen+iNum);
			LineBeginEnd(pLine);							// Start/Ende neu berechnen

			#ifdef USE_WORD_HIGHLIGHT
			if(m_ucHighlightChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			#ifdef USE_MARK_HIGHLIGHT
			if(m_ucWordMarkChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			m_iRedrawFlags |= NZ_LINE_CURSOR;
			}
		else{
			pNew = m_pNullLine;								// Neue Zeile erzeugen

			memcpy(pNew          ,pText     ,iPos     );
			memcpy(pNew+iPos+iNum,pText+iPos,iLen-iPos);

			#ifdef USE_UTF8
			if(nChar>=0x80)chartoutf8(pNew+iPos,nChar);
			else
			#endif

			pNew[iPos]=nChar;

			LineChange(iLine,pNew,iLen+iNum);

			#ifdef USE_WORD_HIGHLIGHT
			if(m_ucHighlightChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			#ifdef USE_MARK_HIGHLIGHT
			if(m_ucWordMarkChar)m_iRedrawFlags|=NZ_LINE;else
			#endif

			m_iRedrawFlags|=NZ_LINE_CURSOR;
			}

		}while(0);


//*****************************************************************************


	PositionOk(1,0,1);
	PrintColor(iLine);
	DoScroll();
	PositionCheck();
	m_cChanged=1;


return 1;
}

//*****************************************************************************
//*
//*     CharAbc
//*
//*****************************************************************************
//  Zhlt Buchstaben bis zum Ende eines Wortes.
//  Als Buchstaben werden alle Zeichen die in m_aCharType als Ziffern oder
//	Buchstaben makiert sind (0x03), und das '_' Zeichen erkannt.
//	iPos		: Ist die aktuelle Offset im Text.
//	pText		: Ist der Zeiger auf den Text.
//	iLen		: Ist die Lnge des Textes
//  iFlags		: In welche Richtung soll gesucht werden (0=vorwrs 1=rckwrts)
//	pEnd		: Hier wird die Endposition gespeichert wenn nicht NULL
//  Ergibt    0 wenn nichts gefunden
//			 >0 Lnge eines Wortes in Zeichen (nicht in Byte)
int	CTextView::CharAbc(int iPos,unsigned char *pText,int iLen,int iDir,int *pEnd)
{
unsigned		uChar;
unsigned		uType;
unsigned 		uMode;
int				iCnt;
int				iNum;


	iCnt  = 0;
	uMode =	(m_iFlags&FLAG_WORD_JMP_UNTER)? 0x07:0x03;

	if(iDir)												// Nach hinten suchen
		{
		if(iPos<=0 || iPos>iLen)
			{
			if(pEnd)*pEnd=iPos;
			return 0;
			}

		uChar = pText[iPos-1];
		iNum  = 1;

		#ifdef USE_UTF8
		if(uChar>=0x80)iNum=utf8prechar(pText+iPos,uChar);
		#endif

		uType = 1<<CharType(uChar);

		while(iPos>0)
			{
			uChar  = pText[iPos-1];

			#ifdef USE_UTF8
			if(uChar>=0x80)iNum=utf8prechar(pText+iPos,uChar);
			else		   iNum=1;
			#endif

			   uType  = 1<<CharType(uChar);
			if(uType&uMode)break;

			iPos -= iNum;
			iCnt += 1;
			}
		}
	else{													// Nach vorne suchen
		if(iPos<0 || iPos>=iLen)
			{
			if(pEnd)*pEnd=iPos;
			return 0;
			}

		uChar = pText[iPos];
		iNum  = 1;

		#ifdef USE_UTF8
		if(uChar>=0xC0)iNum=utf8tochar(pText+iPos,uChar);
		#endif

		uType = 1<<CharType(uChar);

		while(iPos<iLen)
			{
			uChar  = pText[iPos];

			#ifdef USE_UTF8
			if(uChar>=0xC0)iNum=utf8tochar(pText+iPos,uChar);
			else		   iNum=1;
			#endif

			   uType = 1<<CharType(uChar);
			if(uType&uMode)break;

			iPos += iNum;
			iCnt += 1;
			}
		}


	if(pEnd)*pEnd=iPos;										// Endposition speichern


return iCnt;
}

//*****************************************************************************
//*
//*     SignAbc
//*
//*****************************************************************************
//  Zhlt Zeichen die keine Buchstaben und Leerzeichen sind bis zum Ende.
//  Als Buchstaben werden alle Zeichen die in m_aCharType als Ziffern oder
//	Buchstaben makiert sind (0x03), und das '_' Zeichen erkannt.
//	iPos		: Ist die aktuelle Offset im Text.
//	pText		: Ist der Zeiger auf den Text.
//	iLen		: Ist die Lnge des Textes
//  iDir		: In welche Richtungs soll gesucht werden (0=vorwrs 1=rckwrts)
//  Ergibt    0 wenn nichts gefunden
//			 >0 Lnge eines Wortes in Zeichen (nicht in Byte)
int	CTextView::SignAbc(int iPos,unsigned char *pText,int iLen,int iDir)
{
unsigned		uChar;
int				iCnt;
int				iNum;


	iCnt  = 0;
	iNum  = 1;

	if(iDir)												// Nach hinten suchen
		{
		if(iPos<=0 || iPos>iLen)return 0;

		while(iPos>0)
			{
			uChar  = pText[iPos-1];

			#ifdef USE_UTF8
			if(uChar>=0x80)iNum=utf8prechar(pText+iPos,uChar);
			else		   iNum=1;
			#endif

			if(CharType(uChar)!=1)break;

			iPos -= iNum;
			iCnt += 1;
			}
		}
	else{													// Nach vorne suchen
		if(iPos<0 || iPos>=iLen)return 0;

		while(iPos<iLen)
			{
			uChar  = pText[iPos];

			#ifdef USE_UTF8
			if(uChar>=0xC0)iNum=utf8tochar(pText+iPos,uChar);
			else		   iNum=1;
			#endif

			if(CharType(uChar)!=1)break;

			iPos += iNum;
			iCnt += 1;
			}
		}


return iCnt;
}

//*****************************************************************************
//*
//*     OnPreparePrinting
//*
//*****************************************************************************
// Wird aufgerufen vor dem Drucken hie wird die Seiten anzahl berechent
#ifndef 	TO_TEXTWND
BOOL CTextView::OnPreparePrinting(CPrintInfo *pInfo)
{

	if(m_iMarkOn)
		{
		pInfo->m_pPD->m_pd.Flags &= ~PD_NOSELECTION;
		pInfo->m_pPD->m_pd.Flags |=  PD_SELECTION;

		if(m_iMarkY<m_iCursorY || (m_iMarkY==m_iCursorY && m_iMarkX<m_iCursorX))
				{
				m_sPrinterData.iMarkStartX = m_iMarkX;
				m_sPrinterData.iMarkStartY = m_iMarkY;
				m_sPrinterData.iMarkStopX  = m_iCursorX;
				m_sPrinterData.iMarkStopY  = m_iCursorY;
				}
		else	{
				m_sPrinterData.iMarkStartX = m_iCursorX;
				m_sPrinterData.iMarkStartY = m_iCursorY;
				m_sPrinterData.iMarkStopX  = m_iMarkX;
				m_sPrinterData.iMarkStopY  = m_iMarkY;
				}

		if((m_iFlags&FLAG_LINE_MARK) && m_iMarkY!=m_iCursorY)
				{
				m_sPrinterData.iMarkStartX = 0;
				m_sPrinterData.iMarkStopX  = 100000;
				}
		}


return CAnsiView::OnPreparePrinting(pInfo);
}
#endif


//*****************************************************************************
//*
//*		SelectDicWord
//*
//*****************************************************************************
//	Whlt letzte Wort das mit dem Kontext-Men gewhlt wurde
#ifdef 		USE_DICIONARY
int CTextView::SelectDicWord()
{
TextLine   *pLine;
int			iPosX;


		pLine = GetLine(m_iContextY);
	if(!pLine)return 0;

	iPosX = ViewPosition(m_iDicContextX1,pLine->aText,pLine->uSize);

	SetCursor(iPosX,m_iContextY);

	iPosX = ViewPosition(m_iDicContextX2,pLine->aText,pLine->uSize);

	SetSelection(iPosX,m_iContextY);


return IsSelected();
}
#endif

//*****************************************************************************
//*
//*		SelectWord
//*
//*****************************************************************************
//	Whlt das Wort bei einer Position aus
//	iPosX/Y		: Ist die Position im Text
int CTextView::SelectWord(int iPosX,int iPosY)
{
return OnLButtonDblClk(0,CPoint(0,0),iPosX,iPosY);
}

//*****************************************************************************
//*
//*		SelectWord
//*
//*****************************************************************************
//	Whlt das Wort beim Cursor aus
void CTextView::OnSelectWord(){SelectWord();}
int  CTextView::SelectWord()
{
return OnLButtonDblClk(0,CPoint(0,0),m_iCursorX,m_iCursorY);
}

//*****************************************************************************
//*
//*		SelectionArea
//*
//*****************************************************************************
//	Den Breich der markierten Zeilen abfragen.
//	iStart		: Hier wird die erste Zeile gespeichert
//	iStop		: Hier wird die Zeile nach der letzen gewhlten gespeichert
//	Ergibt die Anzahl der ausgewhlten Zeilen
int CTextView::SelectionArea(int &iStart,int &iStop)
{

	if(m_iMarkOn!=2)
		{
		iStart	= 0;
		iStop	= 0;
		return 0;
		}

	if(m_iCursorY<m_iMarkY)
		{
		iStart	= m_iCursorY;
		iStop	= m_iMarkY;
		if(m_iMarkX>0)iStop++;
		}
	else{
		iStart	= m_iMarkY;
		iStop	= m_iCursorY;
		if(m_iCursorX>0)iStop++;
		}


return iStop-iStart;
}

//*****************************************************************************
//*
//*     SelectionTab
//*
//*****************************************************************************
//	Verschiebt den markierten Bereich um eine Tabulator-Breite.
//	iMode	: Bestimmt die Vershieberichtung
//				0 = Tabs einfgen
//				1 = Tabs entfernen
//	Ergibt 1 wenn alles ok
int CTextView::SelectionTab(int iMode)
{
UndoBlock  *pUndo;
uchar	   *pNew;
uchar	   *pText;
uchar	    ucChar;
int			iLines;
int			iPos1;
int			iPos2;
int			iPos;
int			iVal;
int			iOff;
int			iIdx;
int			iCnt;
int			iNum;


	if(m_cNotChange)         							// Darf Fenster gendert werden ?
		{
		MessageBeep(MB_ICONASTERISK);
		return 0;
		}

	if(m_iCursorY==m_iMarkY)							// Einzeilige Marken nicht verndern
		{
		return 0;
		}

	if(m_iCursorY <m_iMarkY)							// Marke anpassen
		{
		if(m_iMarkX)m_iMarkY++;

		iPos  		= 0;
		iPos1 		= m_iCursorY;
		iPos2		= m_iMarkY;
		m_iMarkX	= 0;
		m_iCursorX	= 0;
		}
	else{
		if(m_iCursorX)m_iCursorY++;

		iPos 		= 1;
		iPos1		= m_iMarkY;
		iPos2		= m_iCursorY;
		m_iMarkX	= 0;
		m_iCursorX	= 0;
		}


	if(m_pHookChangeText)								// Callback fr nderungen abfragen
		{
		if(!m_pHookChangeText(this,m_pHookChangeTextParam,iPos,iPos1,m_cChanged))
			{
			return 0;
			}
		}


	if(m_iFlags&FLAG_LINE_MARK)							// Linienweise markiert
		{
		if(m_iCursorY<m_iMarkY)
			 iCnt=TextCopy(&pText,0,m_iCursorY  ,0,m_iMarkY+1);
		else iCnt=TextCopy(&pText,0,m_iCursorY+1,0,m_iMarkY  );
		}
	else{
		iCnt = TextCopy(&pText,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY);
		}


	if(iMode)											// Tabs lschen
		{
		iVal	= 0;
		iOff	= 0;
		ucChar	= '\n';

		while(iVal<iCnt)
			{
			if(ucChar=='\n')
				{
				for(iIdx=0;iIdx<m_iTabWidth;iIdx++,iVal++)
					{
					if(pText[iVal]==' ' )  continue;
					if(pText[iVal]=='\t'){iVal++;break;}
					break;
					}
				}

			pText[iOff] = pText[iVal];
			ucChar		= pText[iVal];
			iVal	   += 1;
			iOff	   += 1;
			}

		iNum		= iOff;
		pNew		= pText;
		pNew[iOff]	= 0;
		}
	else{												// Tabs einfgen
		iLines=1;

		for(iVal=0;iVal<iCnt;iVal++)
			{
			if(pText[iVal]=='\n')iLines++;
			}

		pNew	= new uchar[iCnt+iLines+1];
		ucChar	= '\n';
		iVal	= 0;
		iOff	= 0;

		while(iVal<iCnt)
			{
			if(ucChar=='\n'){pNew[iOff]='\t';iOff++;}

			pNew[iOff]  = pText[iVal];
			ucChar		= pText[iVal];
			iVal	   += 1;
			iOff	   += 1;
			}

		if(iOff && pText[iOff]=='\t')iOff--;

		pNew[iOff]	= 0;
		iNum		= iOff;
		}

	iVal=(m_iFlags&FLAG_INSERT_BEFOR)?  TEXT_CURSOR_LEFT:TEXT_CURSOR_RIGHT;

	if(m_iFlags&FLAG_LINE_MARK   )
		{
		iCnt = strcwlen((char*)pText,0x40);				// Suche Zeilenende

		if(pText[iCnt]=='\n')iVal|=TEXT_LINE;
		if(pText[iCnt]=='\r')iVal|=TEXT_LINE;

		m_iCursorX=0;
		}


	if(SelectionClear())								// Markierten Bereich lschen
		{
		iVal = (m_iUndoPos+TEXT_UNDO_MAX-1)%TEXT_UNDO_MAX;
		m_aUndo[iVal].cMode |= UNDO_2TRUNS;
		}

	iOff	= m_iCursorY;
	iVal	= TextInsert(pNew,m_iCursorX,m_iCursorY,iVal|TEXT_UNDO);
	iVal   += iOff;										// Farben aktualisieren


	for(;;)
		{
		iOff=PrintColor(iOff);
		if(iOff>iVal)break;
		}


	m_cChanged		= 1;
	pUndo			= m_aUndo+m_iUndoPos;
	UndoAdd();
	pUndo->cMode	= UNDO_DEL|UNDO_2TRUNS;
	pUndo->cChanged	= 1;


	if(pText         )delete pText;
	if(pNew && !iMode)delete pNew;

	if(iPos)											// Neue Marke setzen
		{
		ExpandCheck(iPos2);

		m_iCursorY	= iPos2;
		m_iMarkY	= iPos1;
		m_iCursorX	= 0;
		m_iMarkX	= 0;
		}
	else{
		ExpandCheck(iPos1);

		m_iCursorY	= iPos1;
		m_iMarkY	= iPos2;
		m_iCursorX	= 0;
		m_iMarkX	= 0;
		}

	m_iMarkOn=2;
	DrawView(1);


return 1;
}

//*****************************************************************************
//*
//*     SelectionCut
//*
//*****************************************************************************
//	Kopiert die markierten Zeichen und lscht sie nachher
//	iNum	: Speichernummer der Zwischenablage (-1=globale)
//	Ergibt Anzahl der kopierten Bytes
int CTextView::SelectionCut(int iNum)
{
int		iRet;


	if(!m_iMarkOn)return 0;


	   iRet=SelectionCopy(iNum);
	if(iRet)SelectionClear( );



return iRet;
}

//*****************************************************************************
//*
//*     SelectionClear
//*
//*****************************************************************************
//	Lscht die markierten Zeichen
//	Ergibt 0 wenn keine Marke vohanden sonst 1
int CTextView::SelectionClear(int iUndo2)
{
UndoBlock  *pUndo;
TextLine   *pLine;
char	   *pTemp;
int			iPosY;
int			iPosX;
int			iEnd;




	if(!m_iMarkOn)return 0;

	if(m_cNotChange)         							// Darf Fenster gendert werden ?
		{
		MessageBeep(MB_ICONASTERISK);
		return 0;
		}

	pUndo			=  m_aUndo+m_iUndoPos;				// Undo-Info
	UndoAdd();
	pUndo->cMode	= (m_iFlags&FLAG_INSERT_BEFOR)? UNDO_INS:UNDO_INS|UNDO_SETPOS;
	pUndo->cChanged	=  m_cChanged;

	if(iUndo2)pUndo->cMode|=UNDO_2TRUNS;


//******************** Mehrzeilige Marke **************************************


	if(m_iCursorY!=m_iMarkY)
		{
		if(m_iCursorY>m_iMarkY)							// Cursor auf niedere Position
			{
			iPosY		= m_iCursorY;
			iPosX		= m_iCursorX;
			m_iCursorY	= m_iMarkY;
			m_iCursorX	= m_iMarkX;
			m_iMarkY	= iPosY;
			m_iMarkX	= iPosX;
			}


		if(m_pHookChangeText)							// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
				{
				return 0;
				}
			}


		pUndo->sPoint.x = m_iCursorX;					// Einfgeposition
		pUndo->sPoint.y = m_iCursorY;


		if(m_iFlags&FLAG_LINE_MARK)						// Linienweise markieren
			{
			TextCopy (&pUndo->pData,0,m_iCursorY,0,m_iMarkY+1);	// Undo-Speicher
			TextClear(              0,m_iCursorY,0,m_iMarkY+1,0);
			m_iCursorX = 0;
			}
		else{
			pLine = GetLine(m_iCursorY);
			iEnd  = (pLine)? pLine->uEnd:m_iCursorX;

			TextCopy (&pUndo->pData,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY);// Undo-Speicher
			TextClear(              m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY);

			if(m_iCursorX>iEnd)							// Beginnt die Marke hinterm Zeilenende
				{
				pTemp = new char[m_iCursorX-iEnd+1];
				strtab(pTemp,iEnd,m_iCursorX,m_iTabWidth);
				TextInsert(pTemp,iEnd,m_iCursorY,TEXT_UNDO);
				delete pTemp;

				pUndo->cMode	|= UNDO_DEL;
				pUndo->cMode	^= UNDO_SETDEL|UNDO_SETPOS;
				pUndo->sPoint.x	 = iEnd;				// Einfgeposition
				pUndo->sDelPt.x	 = m_iCursorX;
				pUndo->sDelPt.y	 = m_iCursorY;
				}

			}

		m_iMarkX	= m_iCursorX;
		m_iMarkY	= m_iCursorY;
		m_iMarkOn	= 0;
		m_cChanged	= 1;

		PrintColor(m_iCursorY);
		DrawView(1);

		return(1);
		}


//******************** Einzeilige Marke ***************************************


	if(m_iCursorX>m_iMarkX)								// Cursor auf niedere Position
		{
		iPosX		= m_iCursorX;
		m_iCursorX	= m_iMarkX;
		m_iMarkX	= iPosX;
		}


	if(m_pHookChangeText)								// Callback fr nderungen abfragen
		{
		if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
			{
			return 0;
			}
		}


	pUndo->sPoint.x = m_iCursorX;						// Einfgeposition
	pUndo->sPoint.y = m_iCursorY;


	TextCopy (&pUndo->pData,m_iCursorX,m_iCursorY,m_iMarkX,m_iCursorY);
	TextClear(              m_iCursorX,m_iCursorY,m_iMarkX,m_iCursorY);


	m_iMarkX	= m_iCursorX;
	m_iMarkOn	= 0;
	m_cChanged	= 1;

	PrintColor(m_iCursorY);
	DrawView(1);


return(1);
}

//*****************************************************************************
//*
//*     SelectionCopy
//*
//*****************************************************************************
//	Kopiert die Marke in die Zwischenablage
//	iNum	: Speichernummer der Zwischenablage (-1=globale)
//	Ergibt Anzahl der kopierten Bytes
int CTextView::SelectionCopy(int iNum)
{
unsigned char  *pText;
int				iCnt;



	if(m_iCursorY==m_iMarkY)							// Einzeilige Marke
		{
		iCnt = TextCopy(&pText,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY);

		if(!iCnt && (m_iFlags&FLAG_VIRTUAL_SCREEN))
			{
			delete pText;

			   iCnt = m_iCursorX-m_iMarkX;
			if(iCnt<0)iCnt = -iCnt;

			pText = new unsigned char[iCnt+1];
			memset(pText,' ',iCnt);
			pText[iCnt] = 0;
			}
		}
	else{
		if(m_iFlags&FLAG_LINE_MARK)						// Linienweise markiert
			{
			if(m_iCursorY<m_iMarkY)
				 iCnt = TextCopy(&pText,0,m_iCursorY  ,0,m_iMarkY+1);
			else iCnt = TextCopy(&pText,0,m_iCursorY+1,0,m_iMarkY  );
			}
		else{
			iCnt = TextCopy(&pText,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY);
			}
		}


//******************** In Copy-Speicher kopieren ******************************


	if(iCnt && iNum>=0 && iNum<10)
		{
		if(iCnt<256)m_iFlags|=FLAG_CONFIG_SAFE;
		if(m_pCopyMem[iNum])delete m_pCopyMem[iNum];
		   m_pCopyMem[iNum]=pText;
		   m_aCopyLen[iNum]=iCnt;

		return iCnt;
		}


//******************** In Zwischenablage kopieren *****************************


	if(iCnt)
		{
		SetClipboardText((char*)pText,iCnt);
		}

	delete pText;


return iCnt;
}

//*****************************************************************************
//*
//*     SelectionInsert
//*
//*****************************************************************************
//	Fgt die Zwischenablage in den Text ein.
//	iNum	: Speichernummer der Zwischenablage (-1=globale)
//	Ergibt 1 wenn Marke eingefgt wurde.
int CTextView::SelectionInsert(int iNum)
{
char 	   *pText=0;
uchar	   *pData=0;
UndoBlock  *pUndo;
int			iMark;
int			iVal;
int			iPos;
int			iCnt;



	if(m_cNotChange)         							// Darf Fenster gendert werden ?
		{
		MessageBeep(MB_ICONASTERISK);
		return 0;
		}

	if(iNum>=0 && iNum<10)								// Daten aus Copy-Speicher holen
		{
		pData=m_pCopyMem[iNum];
		if(1>=m_aCopyLen[iNum] || !pData)return 0;
		}
	else if(iNum>='0' && iNum<='Z'+12)
		{												// Daten aus Tasten-Speicher holen
		pData=(uchar*)m_aAccelNamen[iNum-'0'];
		if(!pData || !*pData)return 0;
		}


	if(!pData)											// Daten aus Zwischenablage holen
		{
		if(!GetClipboardText(&pText))
			{
			return 0;
			}

		pData = (uchar*)pText;
		}


	if(m_pHookChangeText)								// Callback fr nderungen abfragen
		{
		if(!m_pHookChangeText(this,m_pHookChangeTextParam,m_iCursorX,m_iCursorY,m_cChanged))
			{
			if(pText)delete pText;
			return 0;
			}
		}


	iVal = (m_iFlags&FLAG_INSERT_BEFOR)?  TEXT_CURSOR_LEFT:TEXT_CURSOR_RIGHT;

	if(m_iFlags&FLAG_LINE_MARK)
		{
		iCnt=strcwlen((char*)pData,0x40);				// Suche Zeilenende
		if(pData[iCnt]=='\n')iVal|=TEXT_LINE;
		if(pData[iCnt]=='\r')iVal|=TEXT_LINE;
		if(iVal&TEXT_LINE)m_iCursorX=0;
		}
	
	iMark = m_iMarkOn;

	SelectionClear();

	iPos  = m_iCursorY;
	iVal  = TextInsert(pData,m_iCursorX,m_iCursorY,iVal|TEXT_UNDO);
	iVal += iPos;

	for(;;)												// Farben aktualisieren
		{
		iPos=PrintColor(iPos);
		if(iPos>iVal)break;
		}


	pUndo			= m_aUndo+m_iUndoPos;
	UndoAdd();
	pUndo->cChanged	= m_cChanged;
	pUndo->cMode	= (iMark==1)? UNDO_DEL|UNDO_2TRUNS:UNDO_DEL;

	if(pText)delete pText;
	m_cChanged=1;
	DrawView(1);


return 1;
}

//*****************************************************************************
//*
//*     ConfigSave
//*
//*****************************************************************************
//	Speichert Flags und TAB-Breite im Registry Pfad
//	Ist Pfad=0 wird der Pfad aus m_pGroup->pConfig gennommen
//	Ergibt 1 wenn alles gespeichert wurde
int CTextView::ConfigSave(const char *pPath)
{
char	    cName[1024];
char	   *pText;
CRegKeys	sKey;
int			iLen;
int			iPos;



	ConfigPath(cName,sizeof(cName),pPath);
	if(!sKey.Open(cName))return 0;


//****************** Config speichern *****************************************


	sKey.Set(m_iFlags    ,"Flags"      );
	sKey.Set(m_iTabWidth ,"Tabualtor"  );
	#ifdef USE_DICIONARY
	sKey.Set(m_iDicFlags ,"DicFlags"   );
	sKey.Set(m_cDicNameG ,"DicName"    );
	sKey.Set(m_cDicNameL ,"DicPersName");
	#endif

	if(m_pFindSelection)
		{
		iLen	= 1;
		pText	= m_pFindSelection;

		while(*pText)									// Lnge berechnen
			{
			iPos   = strlen(pText)+1;
			pText += iPos;
			iLen  += iPos;
			}

		sKey.SetMulti(m_pFindSelection,iLen,"Find");
		}


//****************** Copy-Speicher sichern ************************************


	strcpy(cName,"Copy?");

	for(iPos=0;iPos<10;iPos++)
		{
		if( m_aCopyLen[iPos]>256)continue;
		if( m_aCopyLen[iPos]<= 0)continue;
		if(!m_pCopyMem[iPos]    )continue;

		cName[4]='0'+iPos;
		sKey.Set(m_pCopyMem[iPos],cName);
		}


return 1;
}

//*****************************************************************************
//*
//*     ConfigLoad
//*
//*****************************************************************************
//	Ld die Konfiguration und die Farben aus der Registry.
//	Der Registry-Pfad ist "<RegistryKey>/<AppName>/<Pfad>"
//	pPath		: Ist der Pfad der angengt wir
//	Ergibt 1 wenn alles gespeichert wurde.
int CTextView::ConfigLoad(const char *pPath)
{
char		   cName[1024];
unsigned char *pText;
CRegKeys	   sKey;
int			   iPos;
int			   iAnd;
int			   iVal;



	ConfigPath(cName,sizeof(cName),pPath);


//****************** Farben laden **********************************************


	ColorConfig(cName,1);								// Standard Einstellung
	ColorConfig(cName,0);								// Benutzer Einstellung


//***************** Konfiguration laden ***************************************


	if(sKey.Open(cName,CRK_READ)==0)return 0;

	if(sKey.Get(iVal,"Flags"))
		{
		iAnd = (FLAG_CONFIG_SAFE|FLAG_HAS_HIGHLIGHT|FLAG_HAS_WORDMARK);

		if(!(m_iFlags&FLAG_HAS_WORDMARK))iAnd|=FLAG_WORDMARK_TYPE;

		m_iFlags &=  iAnd;
		m_iFlags |= ~iAnd&iVal;
		}


	if(sKey.Get(iVal,"Tabualtor"))
		{
		m_iTabWidth = iVal;
		if(iVal<1 || iVal>32)m_iTabWidth=4;
		}

	if(!m_pFindSelection)
		{
		sKey.Get((void**)&m_pFindSelection,"Find",REG_MULTI_SZ);
		}

	if(m_iFlags&FLAG_WORD_JMP_UNTER)
		{
		m_iKeyStepMask =iKeyMaskDefaultUl;

		if(m_iFlags&FLAG_WORD_JMP_MISC)
			{
			m_iKeyStepMask|=iKeyMaskExtentedUl;
			}
		}
	else{
		m_iKeyStepMask =iKeyMaskDefault;

		if(m_iFlags&FLAG_WORD_JMP_MISC)
			{
			m_iKeyStepMask|=iKeyMaskExtented;
			}
		}

	if(m_iFlags&FLAG_WORD_JMP_UPPER)m_iKeyStepMask |= iKeyMaskUpperCase;
	if(m_iFlags&FLAG_WORD_JMP_FIRST)m_iKeyStepMask &= iKeyMaskFirst;


//****************** Copy-Speicher laden **************************************


	strcpy(cName,"Copy?");

	for(iPos=0;iPos<10;iPos++)
		{
		cName[4]='0'+iPos;
		if(!sKey.Get(&pText,cName))continue;
		if(m_pCopyMem[iPos])delete m_pCopyMem[iPos];
		   m_pCopyMem[iPos] = pText;
		   m_aCopyLen[iPos] = sKey.Len()-1;
		}


//****************** Wrterbuch laden *****************************************
#ifdef USE_DICIONARY

	iVal	 = m_iDicFlags;
	cName[0] = 0;

	sKey.Get(iVal,"DicFlags" );
	sKey.Get(cName,sizeof(m_cDicNameG),"DicName");
	ConfigDic(cName,iVal,0xFFFFFFFF);

	cName[0]=0;
	sKey.Get(cName,sizeof(m_cDicNameL),"DicPersName");
	ConfigDic(cName,iVal,0xFFFFFFFF,1);

#endif

	SetMargin((m_iFlags&FLAG_LINENUMBERS)? m_iTextMargin:0);
	m_iFlags &= ~FLAG_CONFIG_SAFE;


return 1;
}

//*****************************************************************************
//*
//*     ConfigView
//*
//*****************************************************************************
//	Ruft ein Dialog-Fenster fr die Konfiguration auf.
void CTextView::OnConfigView(){ConfigView();}
int CTextView::ConfigView()
{
CTextConfigDlg	sDlg(this);
int				iRet;


	iRet = sDlg.DoModal(this,m_iFlags,m_iTabWidth);
	SetCursorMode();


return iRet;
}

//*****************************************************************************
//*
//*     ConfigText
//*
//*****************************************************************************
//	Konfiguriert die Farbdarstellung der Texte.
//	iColor		: Ist die Standard Farbe
//	Ergibt 1 wenn die Farbe gefunden wurde
int CTextView::ConfigText(int iColor)
{
int		iRet=1;


	ConfigText();

	if(iColor>0)										// Farbe suchen
		{
		   iColor=FindColor(iColor);
		if(iColor<0)iRet=0;
		}

	if(m_pColumColors){delete m_pColumColors;m_pColumColors=0;}
	if(iColor<0)iColor=0;

	m_iColorMode = iColor;

	SET_BIT(m_cColorList,iColor);


return iRet;
}

//*****************************************************************************
//*
//*     ConfigText
//*
//*****************************************************************************
//	Konfiguriert die Farbdarstellung der Texte.
//	pColors		: Ist ein Array mit Farbnummern.
//	iLen		: Ist die Anzahl der Farben im Array.
//	iDef		: Ist die Nummer der Standardfarbe.
//	Ergibt 1 wenn alle Farben gefunden wurden
int CTextView::ConfigText(unsigned char *pColors,int iLen,int iDef)
{
int		iPos,iNum,iRet=1;



	ConfigText();

	if(iLen<=0 || !pColors)								// Keine Angaben
		{
		return ConfigText(0);
		}

	if(iDef<=0)											// Standardfarbe
		{
		iDef=0;
		}
	else{
		iDef=FindColor(iDef);
		if(iDef<0){iDef=0;iRet=0;}
		SET_BIT(m_cColorList,iDef);
		}


	if(!m_pColumColors)
		{
		m_pColumColors=new uchar[m_iMaxChars+16];
		}

	memset(m_pColumColors,iDef,m_iMaxChars+16);


	if(iLen>m_iMaxChars)iLen=m_iMaxChars;


	for(iPos=0;iPos<iLen;iPos++)						// Neuer Farbtext
		{
		iNum = FindColor(pColors[iPos]);
		if(iNum<0){iRet=0;continue;}
		m_pColumColors[iPos]=iNum;
		SET_BIT(m_cColorList,iNum);
		}

	m_iColorMode=iDef;



return iRet;
}

//*****************************************************************************
//*
//*     ConfigText
//*
//*****************************************************************************
//	Konfiguriert die Farbdarstellung der Texte ber die Registry.
//	Der Pfad muss zuvor ber ColorConfig() in m_pGroup->pConfig
//	gespeichert werden
//	pPath	: Ist die Untergruppe zum Laden. (z.B. "cpp",".txt")
//			  Ist pPfad gleich 0 so wird die aktuelle Konfiguration gelscht.
//			  Fngt Pfad mit ".****" and so wird Pfad aus der Registry
//			  geladen mit dem  Name  ".****".
//	Ergibt 1 wenn der Pfad gefunden wurde.
int CTextView::ConfigText(const char *pPath)
{
TextLine   *pLine;
int			iBit;
int			iPos;
int			iOff;




	if(m_pWordList)										// Speicher freigeben
		{
		for(iPos=0;iPos<m_iWordCount;iPos++)
			{
			delete m_pWordList[iPos];
			}

		delete m_pWordList;
		m_pWordList=0;
		}

	if(!m_iVirtualLines)
		{
		for(iPos=0;iPos<m_iLineCount;iPos++)			// Farbdaten lschen
			{
			pLine = GetLine(iPos);
			pLine->bColor = 0;

			if(!pLine->pColors)continue;

			delete pLine->pColors;
			pLine->pColors=0;
			}
		}


	for(iPos= 0 ;iPos<256 ;iPos++)						// Gros-Klein Umwandlung initialisieren
		{
		m_aCaseTable[iPos] = iPos;
		}

	for(iPos='a';iPos<='z';iPos++)
		{
		m_aCaseTable[iPos] = iPos-32;
		}

	memset(m_aWordNum     ,0x00,sizeof(m_aWordNum  ));	// Anzahl der Worte fr Buchstaben
	memset(m_aFixColors   ,0x00,sizeof(m_aFixColors));	// Fixfarben
	memset(m_aGroupOn     ,0x00,sizeof(m_aGroupOn  ));	// Gruppe einschalten
	memset(m_aGroupOff    ,0xFF,sizeof(m_aGroupOff ));	// Gruppe aufschalten
	memset(m_aCharType    ,0x00,sizeof(m_aCharType ));	// Art eines Buchstaben
	memset(m_aCharType+'0',0x01,'9'-'0'+1);				// Zifferngruppe
	memset(m_aCharType+'A',0x02,'Z'-'A'+1);				// Buchstabengruppe
	memset(m_aCharType+'a',0x02,'z'-'a'+1);

	#ifdef 		USE_DICIONARY
	memset(m_aDicColors   ,0x00,sizeof(m_aDicColors));	// Fr welche Farben ist das Wrterbuch an
	m_aDicColors[0] = 0xFF;
	m_aDicColors[1] = 0xFF;
	#endif

	m_aCharType['\n']  |= 0x04;							// Trennzeichen-Gruppe
	m_aCharType['\r']  |= 0x04;
	m_aCharType['\t']  |= 0x04;
	m_aCharType[' ' ]  |= 0x04;

	m_iUntilColors		= 0;
	m_iWordCount		= 0;
	m_cBracketOn		= 0;							// Nach Klammern Suche ausschalten
	m_uBracketOff		= 0;							// Farben die ausgelassen werden
	m_iGroupUntil		= 0;
	m_iGroupColorsOn	= 0;							// Gibt es Gruppen Farben
	m_iGroupLines		= 0;							// Gruppen die bei Zeilenenden mit Zeichen weitergehen
	m_uCaseMode			= 0;							// Gro/Kleinschreibung
	m_uGroupChar		= '\\';							// Zeichen fr Zeilenenden bei denen Gruppen weitergehen
	m_iColorMode		= 0;

	if(m_pBracketMode){delete m_pBracketMode;m_pBracketMode=0;}
	if(m_pColumColors){delete m_pColumColors;m_pColumColors=0;}



	if(!pPath)											// Farben neu setzen
		{
		for(iPos=0;iPos<m_iLineCount;)
			{
			iPos = PrintColor(iPos);
			}

		m_cConfigName[0]=0;

		return 0;
		}

	m_iColorMode = -1;


//****************** Konfiguration laden **************************************
const char *pGroups[]={	"Numbers","Letters","Separators","Group1","Group2" ,"Group3" ,"Group4","Group5"};
uchar 	    aMode  [WBU];
uchar 	    aUntil [WBU];
char	    cBuffer[256];
char	    cName  [256];
char	   *pName;
char	   *pText;
uchar 	   *pWord;
CRegKeys	sKey;
DWORD		dwCount;
DWORD		dwType;
DWORD		dwSize;
int			iTemp;
int			iVal;
int			iNum;
int			iOk1;
int			iOk2;
int			iOk3;
int			iOk4;



	memset(m_cColorList,0,sizeof(m_cColorList));
	m_cColorList[0]  = 0x03;

	#ifdef USE_WORD_HIGHLIGHT
	m_cColorList[0] |= 0x04;
	#endif

	#ifdef USE_MARK_HIGHLIGHT
	m_cColorList[0] |= 0x08;
	#endif

	iTemp = '\\';

		      pName = m_pConfigPath;
	if(!pName)pName = m_pGroup->pConfig;
	if(!pName)return 0;
	if(!sKey.Open(HKEY_LOCAL_MACHINE,pName,CRK_READ))
	if(!sKey.Open(HKEY_CURRENT_USER ,pName,CRK_READ))return 0;

	if(*pPath=='.' || *pPath=='#')						// Pfad aus Schlssel laden
		{
		if(!sKey.Get(cBuffer,sizeof(cBuffer),pPath))return 0;
		strupr(cBuffer);
		pPath =cBuffer;
		}

	if(!sKey.Up(pPath))return 0;						// Sub - Schlssel

	strlcpy(m_cConfigName,pPath,sizeof(m_cConfigName));

	iOk1 = sKey.Get(iNum,"Color");						// Nur eine fixe Farbe
	iOk2 = sKey.Get((void*)cBuffer,sizeof(cBuffer),"ColorArray");

	if(iOk2)return ConfigText((uchar*)cBuffer,sKey.Len(),(iOk1)? iNum:0);
	if(iOk1)return ConfigText(iNum);

	if(sKey.Get(cBuffer,sizeof(cBuffer),"UpperLower"))
		{
		dwSize=sKey.Len();
		m_uCaseMode = 1;
		for(iPos=0,dwSize--;iPos<(int)dwSize;iPos+=2)
			{
			iOff=(uchar)cBuffer[iPos];
			m_aCaseTable[iOff]=cBuffer[iPos+1];
			}
		}

	sKey.Get(iTemp         ,"GroupChar"    );m_uGroupChar=iTemp;
	sKey.Get(m_iGroupLines ,"GroupContinue");
	sKey.Get(m_iGroupUntil ,"Groups"       );			// Gruppen die weitergehen


	if(sKey.Get(iVal,"BracketOn"))						// Klammern
		{
		m_iBracketColor		= FindColor( iVal    &0xFF);
		m_iBracketColorEx	= FindColor((iVal>>8)&0xFF);
		m_pBracketMode		= new char[10];
		m_pBracketMode[0]	= 0;
		m_pBracketMode[5]	= 0;

		if(iVal&0x80000000){strcat(m_pBracketMode,"(");strcat(m_pBracketMode+5,")");}
		if(iVal&0x40000000){strcat(m_pBracketMode,"[");strcat(m_pBracketMode+5,"]");}
		if(iVal&0x20000000){strcat(m_pBracketMode,"{");strcat(m_pBracketMode+5,"}");}
		if(iVal&0x10000000){strcat(m_pBracketMode,"<");strcat(m_pBracketMode+5,">");}

		SET_BIT(m_cColorList,m_iBracketColor  );
		SET_BIT(m_cColorList,m_iBracketColorEx);
		}

	if(sKey.Get(iVal,"BracketOff"))						// Klammernfarben die
		{
		iOk1           = FindColor( iVal     &0xFF);
		iOk2           = FindColor((iVal>> 8)&0xFF);
		iOk3           = FindColor((iVal>>16)&0xFF);
		iOk4           = FindColor((iVal>>24)&0xFF);

		m_uBracketOff  = (iOk1&0xFF);
		m_uBracketOff |= (iOk2&0xFF)<<8;
		m_uBracketOff |= (iOk3&0xFF)<<16;
		m_uBracketOff |= (iOk4&0xFF)<<24;

		SET_BIT(m_cColorList,iOk1);
		SET_BIT(m_cColorList,iOk2);
		SET_BIT(m_cColorList,iOk3);
		SET_BIT(m_cColorList,iOk4);
		}


//******************* Gruppendaten laden **************************************


	for(iNum=0,iBit=1;iNum<8;iNum++,iBit<<=1)
		{
		if(sKey.Get(cBuffer,sizeof(cBuffer),pGroups[iNum]))
			{
			for(dwSize=sKey.Len()-2;(int)dwSize>=0;dwSize--)
				{
				iVal=(uchar)cBuffer[dwSize];
				m_aCharType[iVal] |= iBit;
				}
			}

		if(iNum<3)continue;

		strcpy(cName,pGroups[iNum]);					// Gruppe einschalten
		strcat(cName,"On");

		if(sKey.Get(cBuffer,sizeof(cBuffer),cName))
			{
			for(dwSize=sKey.Len()-2;(int)dwSize>=0;dwSize--)
				{
				iVal=(uchar)cBuffer[dwSize];
				m_aGroupOn[iVal] |= iBit;
				}
			}

		strcpy(cName,pGroups[iNum]);					// Gruppe ausschalten
		strcat(cName,"Off");

		if(sKey.Get(cBuffer,sizeof(cBuffer),cName))
			{
			for(dwSize=sKey.Len()-2;(int)dwSize>=0;dwSize--)
				{
				iVal=(uchar)cBuffer[dwSize];
				m_aGroupOff[iVal] &= ~iBit;
				}
			}

		strcpy(cName,pGroups[iNum]);					// Gruppen Farbe
		strcat(cName,"Color");

		dwSize = 256;
		dwType = REG_DWORD;
		iVal   = 0;

		if(sKey.Get(iVal,cName))
			{
			iOk1					= FindColor(iVal);
			m_aGroupColors[iNum-3]	= iOk1;
			m_iGroupColorsOn	   |= iBit;

			SET_BIT(m_cColorList,iOk1);
			}
		}

//****************** Wrterbuchfarben *****************************************
#ifdef USE_DICIONARY

	if(sKey.Get((void*)cBuffer,128,"DicColors"))
		{
		iOff = sKey.Len();

		for(iPos=0;iPos<iOff;iPos++)
			{
			iNum = cBuffer[iPos]&0xFF;

			if(iNum==0xFF){memset(m_aDicColors,0x00,128);continue;}
			if(iNum==0x7F){memset(m_aDicColors,0xFF,128);continue;}

			iVal = FindColor(iNum&0x7F);

			SET_BIT(m_cColorList,iVal);

			if(iNum&0x80)m_aDicColors[iVal&0x7F]=0x00;
			else         m_aDicColors[iVal&0x7F]=0xFF;
			}
		}

	if(sKey.Get(iOff,"DicOnOff"))						// Wrterbuch ein/ausschalten
		{
		if(iOff)SetDicFlags(FLAG_DICON,FLAG_DICON);
		else    SetDicFlags(0         ,FLAG_DICON);
		}

#endif

//****************** Worte laden **********************************************


	if(sKey.Up("Words"))
		{
		for(iNum=0;iNum<256;iNum++)
			{
			if(!sKey.Up())break;						// Nchstes Wort

			dwSize = WLE-2;

			memcpy(aMode,"\x04\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00",WBU);

			sKey.Get((void*)aMode,dwSize,"Mode");
			sKey.Get(iVal,"Color");

			aMode[WFB] = FindColor(iVal);
			aMode[WAR] = 1;								// Art

			SET_BIT(m_cColorList,aMode[WFB]);

			for(iPos=0;iPos<2048;iPos++)				// Worte suchen
				{
					pText = sKey.ValueName(iPos);
				if(!pText)break;

				if( sKey.Type()!=REG_SZ)continue;
				if(!sKey.Get(cBuffer,256,pText))break;

				WordInsert(aMode,cBuffer,sKey.Len());
				}

			sKey.Down();
			}

		sKey.Down();
		}


//****************** Bis-Worte laden ******************************************


	if(sKey.Up("Until"))
		{
		for(iNum=0;iNum<256;iNum++)
			{
			if(!sKey.Up())break;

			dwSize = WLE-2;

			memcpy(aMode ,"\x04\x04\x00\x00\x04\x04\x00\x00\x00\x00\x00",WBU);
			memcpy(aUntil,"\x04\x04\x00\x00\x04\x04\x00\x00\x00\x00\x00",WBU);

			sKey.Get((void*)aMode ,dwSize,"Mode1");
			sKey.Get((void*)aUntil,dwSize,"Mode2");
			sKey.Get(iVal,"Color");

			if(!sKey.Get(cBuffer,256,"Data1"))continue;dwSize =sKey.Len();
			if(!sKey.Get(cName  ,256,"Data2"))continue;dwCount=sKey.Len();

			aUntil[WCH] = aMode[WSO];
			aMode [WFB] = FindColor(iVal);
			aMode [WAR] = (aMode[WSO])? 4:3;			// Mit/ohne Zeilenende
			aMode [WSO] = m_iUntilColors;
			aUntil[WFB] = m_iUntilColors;
			aUntil[WAR] = 7;

			SET_BIT(m_cColorList,aMode[WFB]);

			if(dwCount<2)
				{
				dwCount  = 2;
				cName[0] = '*';
				cName[1] = 0;
				memcpy(aUntil,"\x80\x80\x00\x00\x00\x00",6);
				}

			WordInsert(aMode ,cBuffer,dwSize );
			WordInsert(aUntil,cName  ,dwCount);

			m_iUntilColors++;


			sKey.Down();
			}

		sKey.Down();
		}


//****************** Fixfarben laden ******************************************


	if(sKey.Up("Fixed"))
		{
		for(iNum=0;iNum<256;iNum++)
			{
			if(!sKey.Up())break;
			if(!sKey.Get(iVal       ,"Color"  ))continue;
			if(!sKey.Get(cBuffer,256,"Letters"))continue;

			dwSize = sKey.Len();

			   iPos=FindColor(iVal);
			if(iPos!=-1)
				{
				SET_BIT(m_cColorList,iPos);

				for(iOff=0,dwSize--;iOff<(int)dwSize;iOff++)
					{
		 			iVal=(uchar)cBuffer[iOff];
					m_aFixColors[iVal]=iPos;
					}
				}

			sKey.Down();
			}

		sKey.Down();
		}


//*****************************************************************************

	qsort(m_pWordList,m_iWordCount,sizeof(LPSTR),WordCmp);

	m_iUntilColors = m_iWordCount-m_iUntilColors;

	for(iPos=0,iOff=-1;iPos<m_iWordCount;iPos++)		// Anfnge suchen
		{
		pWord=m_pWordList[iPos];

		if(pWord[WAR]==7)break;
		if(pWord[WBU]==iOff)							// Weiteres Wort
			{
			m_aWordNum[iOff]++;
			}
		else{
			iOff=pWord[WBU];							// Neuer Anfangsbuchstabe
			m_aWordStart[iOff]=iPos;
			m_aWordNum  [iOff]=1;
			}
		}

	if(m_uCaseMode)										// Groklein Buchstaben
		{
		for(iPos=0;iPos<256;iPos++)
			{
			   iOff=m_aCaseTable[iPos];
			if(iOff==iPos)continue;

			m_aWordStart[iPos]=m_aWordStart[iOff];		// Wortlisten gleichsetzen
			m_aWordNum  [iPos]=m_aWordNum  [iOff];
			}
		}

	for(iPos=0;iPos<m_iLineCount;)						// Farben neu setzen
		{
		iPos=PrintColor(iPos);
		}


return 1;
}

//*****************************************************************************
//*
//*     WordCmp
//*
//*****************************************************************************
//	Vergleichsfunktion fr qsort in Config_Farben()
//	Bis-Wrter ganz nach hinten
//	Dann nach Anfangsbuchstanen sortieren
//	Bei gleichen Anfangsbuchstanen nach Lnge sortieren (lngere nach vor)
int __cdecl CTextView::WordCmp(const void *pEntry1, const void *pEntry2 )
{
unsigned char	*pWord1;
unsigned char	*pWord2;



	pWord1 = *(unsigned char**)pEntry1;
	pWord2 = *(unsigned char**)pEntry2;

	if(pWord1[WAR]==7)									// Bis-Wrter nach hinten
		{
		if(pWord2[WAR]!=7)return 1;
		return (int)pWord1[WFB]-(int)pWord2[WFB];		// Bis Nummer
		}


	if(pWord2[WAR]==7)return -1;						// Nur ein Bis-Word

	if(pWord1[WBU]==pWord2[WBU])						// Gleiche Buchstaben
		{
		return  (int)pWord2[WLE]-(int)pWord1[WLE];		// Wortlnge
		}


return  (int)pWord1[WBU]-(int)pWord2[WBU];				// Anfangs Buchstaben
}

//*****************************************************************************
//*
//*     WordInsert
//*
//*****************************************************************************
//	Fgt ein Wort in die **m_pWordList Liste ein.
//	pMode		: [WAR]:Bit 0-2 = (1=Wort,3/4=1.Bis-Wort,7=2.Bis-Wort)
//	pText		: Zeiger auf das Wort.
//	iLen		: Lnge des Wortes inklusive Daten..
//	Ergibt die Anzahl der Worte in der Liste.
int	CTextView::WordInsert(uchar *pMode,char *pText,int iLen)
{
uchar    *pWord;
uchar   **pNew;



	if(iLen<2 || m_iWordCount>=4096)return 0;


	if(m_uCaseMode)										// Anfangsbuchstaben gro machen ?
		{
		pText[0] = m_aCaseTable[(uchar)pText[0]];
		pText[1] = m_aCaseTable[(uchar)pText[1]];
		}


	if(!(m_iWordCount&0x3F))							// Alle Wort-Indexe verbraucht ?
		{
		pNew = (uchar**)new int[m_iWordCount+65];

		if(m_pWordList)
			{
			memcpy(pNew,m_pWordList,sizeof(int)*m_iWordCount);
			delete m_pWordList;
			}

		m_pWordList = pNew;
		}


	pWord		= new uchar[iLen+WBU];					// Wort speichern

	memcpy(pWord    ,pMode ,WLE);
	memcpy(pWord+WBU,pText,iLen);

	pWord[WLE]	= (uchar)iLen-1;
	pWord[WGA]	= ~pWord[WGA];

	m_pWordList[m_iWordCount] = pWord;
	m_iWordCount++;



return m_iWordCount;
}

//*****************************************************************************
//*
//*		FindColor
//*
//*****************************************************************************
//	Sucht eine Farbe in der Farbtabelle.
//	uIndex		: Ist die Index-Nummer der Farbe in der Registry
//	Ergibt die Nummer in der Farbtabelle
inline int CTextView::FindColor(unsigned uIndex)
{

	if(!m_pGroup->pColorTable)
		{
		m_pGroup->pColorTable=ColorList(m_pGroup->pColorList);
		}


	if(uIndex>=256)return 0;


return m_pGroup->pColorTable[uIndex]-1;
}

//*****************************************************************************
//*
//*     SetColor
//*
//*****************************************************************************
//	Konfiguriert die Farbdarstellung einer Zeile.
//	Dies funktioniert nur wenn der Text nicht vernderbar ist
//	siehe SetModify(0) und der Text nicht mit ConfigText(char *Pfad)
//	konfiguriert wurde (m_iColorMode!=-1)
//	pColors		: Ist ein Array mit Farbnummer mit der Lnge iLen.
//				  Die Farbnummern sind die Indizes die bei ColorAdd
//				  verwendet wurden.
//				  Ist Farben==0 so werden vorhande Farben gelscht.
//	iDef		: Ist die Farbe mit der die Zeile aufgefllt wird.
//				  Ist iDef==-1 so wird der m_iColorMode genommen.
//	iAdd		: Ist die Zahl um die die Farbeintrge auseinander liegen.
//	Ergibt 1 wenn alle Farben gefunden wurden.
int CTextView::SetColor(int iLine,uchar *pColors,int iLen,int iDef,int iAdd)
{
unsigned char  *pData;
TextLine	   *pLine;
int				iSize;
int				iPos;
int				iNum;
int				iRet;
int				iOld;



	if(m_iColorMode< 0)return 0;						// Variable Farben
	if(m_cNotChange==0)return 0;						// Vernderbarer Text

	if(iLine<0 || iLine>=m_iLineCount)					// Falsche Zeile
		{
		return 0;
		}

	iNum	= 0;
	iRet	= 1;
	pLine   = GetLine(iLine);							// Zeilendaten
	iSize	= pLine->uSize;
	pData   = pLine->pColors;

	if(!pColors)										// Farben lschen
		{
		if(pData){delete pData;pLine->pColors=0;}
		DrawViewLine(iLine);
		return 1;
		}

	if(!pData)											// Neuer Farbspeicher
		{
		pData   = new uchar[iSize];
		pLine->pColors= pData;
		}

	if(iDef<0)iDef=m_iColorMode;						// Standartfarbe
	if(iDef>0)
		{
		iDef=FindColor(iDef);
		if(iDef<0){iDef=0;iRet=0;}
		}

	memset(pData,iDef,iSize);

	if(iLen>iSize)iLen=iSize;


	for(iPos=0,iOld=-1;iPos<iLen;iPos++)				// Neuer Farb String
		{
		if(iOld!=*pColors)
			{
			iNum = FindColor(*pColors);
			if(iNum<0){iRet=0;pColors+=iAdd;continue;}
			iOld =* pColors;
			}

		pData[iPos]  = iNum;
		pColors     += iAdd;
		}

	DrawViewLine(iLine);


return iRet;
}

//*****************************************************************************
//*
//*		TextInsert
//*
//*****************************************************************************
//	Fgt einen Text beim Cursor ein. Ausgewhlte Texte werden dabei gelscht.
//	pText		: Text der eingefgt werden soll.
//	iMode		: Bestimt die Einfgemethode.
//					TEXT_IS_UTF8		Der Text ist im UTF8 -Format
//					TEXT_IS_UTF16		Der Text ist im UTF16-Format
int CTextView::TextInsert(const uchar *pText,int iMode)
{
UndoBlock  *pUndo;
int			iCnt;
int			iVal;
int			iPos;


	iMode |= (m_iFlags&FLAG_INSERT_BEFOR)?  TEXT_CURSOR_LEFT|TEXT_UNDO:TEXT_CURSOR_RIGHT|TEXT_UNDO;

	if(m_iFlags&FLAG_LINE_MARK)
		{
		iCnt=strcwlen((char*)pText,0x40);				// Suche Zeilenende
		if(pText[iCnt]=='\n')iMode|=TEXT_LINE;
		if(pText[iCnt]=='\r')iMode|=TEXT_LINE;
		if(iMode & TEXT_LINE)m_iCursorX=0;
		}

	SelectionClear();

	iPos  = m_iCursorY;
	iVal  = TextInsert(pText,m_iCursorX,m_iCursorY,iMode);
	iVal += iPos;

	for(;;)												// Farben aktualisieren
		{
		iPos=PrintColor(iPos);
		if(iPos>iVal)break;
		}

	pUndo			= m_aUndo+m_iUndoPos;
	UndoAdd();
	pUndo->cChanged	= m_cChanged;
	pUndo->cMode	= UNDO_DEL;
	m_cChanged		= 1;

	DrawView(1);


return 1;
}

//*****************************************************************************
//*
//*     TextInsert
//*
//*****************************************************************************
//	Fgt einen Text in Fenster ein.
//	pText		: Text der eingefgt werden soll.
//	iInsX/iInsY	: Ist die Einfgeposition.
//	iMode		: Bestimt die Einfgemethode.
//					TEXT_LINE			Zeilenweise einfgen
//					TEXT_CURSOR_LEFT   	Cursor an den Anfang setzen
//					TEXT_CURSOR_RIGHT   Cursor ans Ende setzen
//					TEXT_REDRAW   		Fenster nacher neuzeichen
//	    			TEXT_CURSOR     	iInsX/iInsY durch m_iCursorX/m_iCursorY ersetzen
//	    			TEXT_UNDO       	Undo-Koordinaten speichern
//	    			TEXT_UNDOADD        UndoAdd aufrufen und den das Undo einfgen
//					TEXT_UNDOTWOTURNS	Zweilmal rckgngig einfgen
//					TEXT_IS_UTF8		Der Text ist im UTF8 -Format
//					TEXT_IS_UTF16		Der Text ist im UTF16-Format
//	iSize		: Ist die Lnge des einzufgenden Textes in Byte.
//	Ergibt Anzahl der eingefgten Zeilen und -1 bei einem Fehler.
int CTextView::TextInsert(const uchar *pText,int iInsX,int iInsY,int iMode,int iSize)
{
unsigned		uChar;
unsigned char  *pOut;
unsigned char  *pPtr;
unsigned char  *pNew;
TextLine	   *pLine;
UndoBlock	   *pUndo;
int				iSpace;
int				iStart;
int				iLast;
int				iByte;
int				iLine;
int				iCurX;
int				iCurY;
int				iCnt;
int				iOut;
int				iVal;
int				iPos;
int				iOff;
int				iLen;
int				iEnd;
int				iNum;
int				iTab;
int				iOk;


	iOk		= 1;
	pUndo	= 0;
	iLine	= 0;
	iByte	= iSize;

	if(iMode&TEXT_IS_UTF16)								// Suche Zeilenende
			iCnt=strcwlen((wchar_t*)pText,0x40,iByte/2)*2;
	else	iCnt=strcwlen((char   *)pText,0x40,iByte  );


	if(iByte<=0)										// Leertext einfgen
		{
		if(!(iMode&TEXT_LINE))return 0;
		iOk=LineInsert(iInsY,(uchar*)"*",0);
		if(iOk>=0)PrintColor(iInsY);
		return (iOk)? 1:-1;
		}

	if(iMode&TEXT_CURSOR)
		{
		iInsX = m_iCursorX;
		iInsY = m_iCursorY;
		}

	if(iMode&TEXT_UNDO)
		{
		pUndo			= m_aUndo+m_iUndoPos;
		pUndo->sPoint.x = iInsX;
		pUndo->sPoint.y = iInsY;
		}


	iCurX	= iInsX;
	iCurY	= iInsY;
	iStart	= iInsY;

//*************** In vorhandene Zeile einfgen ********************************


	if(iInsY<m_iLineCount && !(iMode&TEXT_LINE))
	do	{
		if(iCnt<iByte && iInsX<=0)break;

		pLine	= m_pLineList[iInsY];
		pPtr	= pLine->aText;
		iLen	= pLine->uSize;
		iEnd	= pLine->uEnd;
		iPos	= TextPosition(iInsX,pPtr,iLen);
		pOut	= m_pNullLine;

		if(iInsX<=iEnd)
			{
			iTab   = 0;
			iSpace = 0;
			}
		else{											// Einfgen hinter Zeilenende
			iVal = iInsX-iInsX%m_iTabWidth;

			if(iVal<=iEnd)
				{
				iTab   = 0;
				iSpace = iInsX-iEnd;
				}
			else{
				iSpace = iInsX%m_iTabWidth;
				iTab   = (iVal-iEnd-1)/m_iTabWidth+1;
				}
			}


		iNum = (iCnt<iByte)? 0:iLen-iPos;				// Restlnge der Zeile


		if(m_iMaxChars<iPos+iTab+iSpace+iNum)			// Zuviele Zeichen ?
			{
			if(iPos)iInsY++;
			iInsX=0;
			break;
			}

		memcpy(pOut     ,pPtr,iPos  );iOut =iPos;
		memset(pOut+iOut, 9  ,iTab  );iOut+=iTab;
		memset(pOut+iOut,' ' ,iSpace);iOut+=iSpace;


		#ifdef USE_UTF8

		if(iMode&TEXT_IS_UTF16)							// UTF16 zu UTF8 umwandeln
			{
			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf16tochar(pText+iOff,uChar)*2;
				iOut += chartoutf8(pOut+iOut,uChar);

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut+4>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else if(!(iMode&TEXT_IS_UTF8))					// ANSI zu UTF8 umwandeln
			{
			for(iOff=0,iLast=-1;iOff<iCnt;iOff++)
				{
				uChar = pText[iOff];
				iOut += chartoutf8(pOut+iOut,uChar);

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut+4>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else{											// UTF8 zu UTF8
			if(iOut+iCnt>=m_iMaxChars)
				{
				iCnt = m_iMaxChars-iOut;

				for(iLast=1;iLast<m_iMaxChars/4;iLast++)
					{
					if(iLast>=iCnt)break;
					if(pText[iCnt-iLast]!=' ' )
					if(pText[iCnt-iLast]!='\t')continue;
					iCnt -= iLast-1;
					break;
					}
				}

			memcpy(pOut+iOut,pText,iCnt);
			iOut += iCnt;
			}

		#else

		if(iMode&TEXT_IS_UTF8)							// UTF8 zu ANSI umwandeln
			{
			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf8tochar(pText+iOff,uChar);
				if(uChar>=256)uChar=255;
				pOut[iOut] = uChar;
				iOut      += 1;

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else if(iMode&TEXT_IS_UTF16)					// UTF16 zu ANSI umwandeln
			{
			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf16tochar(pText+iOff,uChar)*2;
				if(uChar>=256)uChar=255;
				pOut[iOut] = uChar;
				iOut      += 1;

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else{											// ANSI zu ANSI
			if(iOut+iCnt>=m_iMaxChars)
				{
				iCnt = m_iMaxChars-iOut;

				for(iLast=1;iLast<m_iMaxChars/4;iLast++)
					{
					if(iLast>=iCnt)break;
					if(pText[iCnt-iLast]!=' ' )
					if(pText[iCnt-iLast]!='\t')continue;
					iCnt -= iLast-1;
					break;
					}
				}

			memcpy(pOut+iOut,pText,iCnt);
			iOut += iCnt;
			}

		#endif


		if(m_iMaxChars<iOut+iNum)						// Zuviele Zeichen ?
			{
			if(iPos)iInsY++;
			iInsX=0;
			break;
			}


		if(iCnt<iByte)									// Gibt es weitere Zeilen im Einfgetext
			{
			if(m_iLineCount>=m_iLinesMax)				// Zuviele Zeilen
				{
				MessageBeep(MB_ICONASTERISK);
				break;
				}

			iOk = LineInsert(iInsY+1,pPtr+iPos,iLen-iPos);
			iLine++;

			if(m_iCursorY>iInsY)m_iCursorY++;

			m_iRedrawFlags = NZ_ALL;
			iNum		   = 0;
			}


		memcpy(pOut+iOut,pPtr+iPos,iNum);				// Restliche Zeile hinten anhngen

		iOk = LineChange(iInsY,pOut,iOut+iNum);

		if(m_iCursorY==iInsY)
			{
			m_iRedrawFlags|=NZ_LINE;
			}
		else{
			DrawViewLine(iInsY);
			}

		if(iCnt<iByte)
			{
			if(m_iCursorY>iInsY)m_iCursorY++;
			iInsY++;iInsX=0;
			}
		else{
			iInsX = ViewPosition(iOut,pOut,iOut+iNum);
			}

		if(iMode&TEXT_IS_UTF16)
			{
			if(iByte>iCnt+1 && pText[iCnt  ]=='\r' && pText[iCnt+1]==0)iCnt+=2;
			if(iByte>iCnt+1 && pText[iCnt  ]=='\r' && pText[iCnt+1]==0)
			if(iByte>iCnt+3 && pText[iCnt+1]=='\n' && pText[iCnt+3]==0)iCnt+=2;
			if(iByte>iCnt+1 && pText[iCnt  ]=='\n' && pText[iCnt+1]==0)iCnt+=2;
			}
		else{
			if(iByte>iCnt   && pText[iCnt  ]=='\r')iCnt++;
			if(iByte>iCnt   && pText[iCnt  ]=='\r')
			if(iByte>iCnt+1 && pText[iCnt+1]=='\n')iCnt++;
			if(iByte>iCnt   && pText[iCnt  ]=='\n')iCnt++;
			}

		pText += iCnt;
		iByte -= iCnt;
		}while(0);


//******************* Zeilen einfgen *****************************************


	while(iByte>0)
		{
		m_iRedrawFlags =NZ_ALL;

		if(iMode&TEXT_IS_UTF16)							// Suche Zeilenende
				iCnt = strcwlen((wchar_t*)pText,0x40,iByte/2)*2;
		else	iCnt = strcwlen((char   *)pText,0x40,iByte  );


		if(m_iLineCount>=m_iLinesMax)					// Zuviele Zeilen
			{
			MessageBeep(MB_ICONASTERISK);
			iOk=0;
			break;
			}

		pOut = (uchar*)pText;
		iOut = iCnt;

		#ifdef USE_UTF8

		if(iMode&TEXT_IS_UTF16)							// UTF16 zu UTF8 umwandeln
			{
			pOut = m_pNullLine;
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf16tochar(pText+iOff,uChar)*2;
				iOut += chartoutf8 (pOut +iOut,uChar);

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut+4>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else if(!(iMode&TEXT_IS_UTF8))					// ANSI zu UTF8 umwandeln
			{
			pOut = m_pNullLine;
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;iOff++)
				{
				uChar = pText[iOff];
				iOut += chartoutf8(pOut+iOut,uChar);

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut+4>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}

		#else

		if(iMode&TEXT_IS_UTF8)							// UTF8 zu ANSI umwandeln
			{
			pOut = m_pNullLine;
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;iOut++)
				{
				iOff += utf8tochar(pText+iOff,uChar);
				if(uChar>=256)uChar=255;
				pOut[iOut] = uChar;

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else if(iMode&TEXT_IS_UTF16)					// UTF16 zu ANSI umwandeln
			{
			pOut = m_pNullLine;
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf16tochar(pText+iOff,uChar)*2;
				if(uChar>=256)uChar=255;
				pOut[iOut] = uChar;
				iOut      += 1;

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}

		#endif

		if(iCnt>m_iMaxChars)							// Ist die Zeile zu lang
			{
			iCnt   = m_iMaxChars;

			for(iLast=1;iLast<m_iMaxChars/4;iLast++)
				{
				if(iLast>=iCnt)break;
				if(pText[iCnt-iLast]!=' ' )
				if(pText[iCnt-iLast]!='\t')continue;
				iCnt -= iLast-1;
				break;
				}

			iOut = iCnt;
			}
														// Gibt es weitere Zeilen im Einfgetext
		if(iCnt>=iByte && !(iMode&TEXT_LINE) && iInsY<m_iLineCount)
			{
			if(iInsY+1>=m_iLineCount)break;
			pLine  = m_pLineList[iInsY+1];
			iLen   = pLine->uSize;
			if(iLen+iCnt<m_iMaxChars)break;				// Ist in der nchste Zeile genug Platz
			}

		if(iInsX<=0)
			{
			iOk    = LineInsert(iInsY,pOut,iOut);
			}
		else{
			iTab   = iInsX/m_iTabWidth;
			iSpace = iInsX%m_iTabWidth;
			pNew   = new uchar [iTab+iSpace+iOut];

			memset(pNew     ,'\t',iTab  );iVal =iTab;
			memset(pNew+iVal,' ' ,iSpace);iVal+=iSpace;
			memcpy(pNew+iVal,pOut,iOut  );iVal+=iOut;

			iOk = LineInsert(iInsY,pNew,iVal);

			delete pNew;
			}


		if(m_iCursorY>=iInsY)m_iCursorY++;
		if(iOk==0)break;								// Fehler beim Einfgen ?

		iLine += 1;
		iByte -= iCnt;
		pText += iCnt;

		if(iByte>0 || (iMode&TEXT_LINE))
			{
			iInsY++;
			iInsX=0;
			}
		else{
			if(iInsY>=m_iLineCount)iInsY=m_iLineCount-1;
			pLine = m_pLineList[iInsY];
			iInsX = pLine->uEnd;
			}

		if(iMode&TEXT_IS_UTF16)
			{
			if(pText[0]=='\r' && pText[1]==0 && iByte>2){pText+=2;iByte-=2;}
			if(pText[0]=='\r' && pText[1]==0 && iByte>4)
			if(pText[2]=='\n' && pText[3]==0 && iByte>4){pText+=2;iByte-=2;}
			if(pText[0]=='\n' && pText[1]==0 && iByte>2){pText+=2;iByte-=2;}
			}
		else{
			if(pText[0]=='\r' && iByte>0){pText++;iByte--;}
			if(pText[0]=='\r' && iByte>1)
			if(pText[1]=='\n' && iByte>1){pText++;iByte--;}
			if(pText[0]=='\n' && iByte>0){pText++;iByte--;}
			}
		}


//******************** Letzte Zeile *******************************************


	while(iByte>0)
		{
		if(iInsY>=m_iLineCount)break;


		if(iMode&TEXT_IS_UTF16)
			{
			if(pText[0]=='\r' && pText[1]==0){pText+=2;iByte-=2;}
			if(pText[0]=='\r' && pText[1]==0)
			if(pText[2]=='\n' && pText[3]==0){pText+=2;iByte-=2;}
			if(pText[0]=='\n' && pText[1]==0){pText+=2;iByte-=2;}
			iCnt = strcwlen((wchar_t*)pText,0x40,iByte)*2;
			}
		else{
			if(pText[0]=='\r'){pText++;iByte--;}
			if(pText[0]=='\r')
			if(pText[1]=='\n'){pText++;iByte--;}
			if(pText[0]=='\n'){pText++;iByte--;}
			iCnt = strcwlen((char*)pText,0x40,iByte);
			}

		pLine = m_pLineList[iInsY];
		pPtr  = pLine->aText;
		iLen  = pLine->uSize;
		pOut  = m_pNullLine;


		#ifdef USE_UTF8

		if(iMode&TEXT_IS_UTF16)							// UTF16 zu UTF8 umwandeln
			{
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf16tochar(pText+iOff,uChar)*2;
				iOut += chartoutf8(pOut+iOut,uChar);

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut+4>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else if(!(iMode&TEXT_IS_UTF8))					// ANSI zu UTF8 umwandeln
			{
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;iOff++)
				{
				uChar = pText[iOff];
				iOut += chartoutf8(pOut+iOut,uChar);

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut+4>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else{											// UTF8 zu UTF8
			if(iCnt+iLen>m_iMaxChars)
				{
				iCnt = m_iMaxChars-iLen;

				for(iLast=1;iLast<m_iMaxChars/4;iLast++)
					{
					if(iLast>=iCnt)break;
					if(pText[iCnt-iLast]!=' ' )
					if(pText[iCnt-iLast]!='\t')continue;
					iCnt -= iLast-1;
					break;
					}
				}

			memcpy(pOut,pText,iCnt);
			iOut = iCnt;
			}

		#else

		if(iMode&TEXT_IS_UTF8)							// UTF8 zu ANSI umwandeln
			{
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;iOut++)
				{
				iOff += utf8tochar(pText+iOff,uChar);
				if(uChar>=256)uChar=255;
				pOut[iOut] = uChar;

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else if(iMode&TEXT_IS_UTF16)					// UTF16 zu ANSI umwandeln
			{
			iOut = 0;

			for(iOff=0,iLast=-1;iOff<iCnt;)
				{
				iOff += utf16tochar(pText+iOff,uChar)*2;
				if(uChar>=256)uChar=255;
				pOut[iOut] = uChar;
				iOut      += 1;

				if(uChar==' ' || uChar=='\t')
					{
					iLast = iOut;
					}

				if(iOut>=m_iMaxChars)
					{
					iCnt = (iLast>m_iMaxChars/4*3)? iLast:iOff;
					break;
					}
				}
			}
		else{											// ANSI zu ANSI
			if(iCnt+iLen>m_iMaxChars)
				{
				iCnt = m_iMaxChars-iLen;

				for(iLast=1;iLast<m_iMaxChars/4;iLast++)
					{
					if(iLast>=iCnt)break;
					if(pText[iCnt-iLast]!=' ' )
					if(pText[iCnt-iLast]!='\t')continue;
					iCnt -= iLast-1;
					break;
					}
				}

			memcpy(pOut,pText,iCnt);
			iOut = iCnt;
			}

		#endif


		memcpy(pOut+iOut,pPtr,iLen);					// Alten Zeilentext anhngen

		iOk = LineChange(iInsY,pOut,iOut+iLen);

		if(iMode&TEXT_LINE)								// End-Cursor bestimmen
			{
			if(m_iCursorY>iInsY)m_iCursorY++;
			iInsY++;
			iInsX=0;
			}
		else{
			iInsX = ViewPosition(iOut,pOut,iOut+iLen);
			}

		break;
		}


//******************** Cursor setzen ******************************************


	if(iMode&TEXT_CURSOR_LEFT )PositionOk(iCurX,iCurY,0);
	if(iMode&TEXT_CURSOR_RIGHT)PositionOk(iInsX,iInsY,0);
	if(iMode&TEXT_REDRAW      )DrawView(1);
	if(iMode&TEXT_UNDO)
		{
		pUndo->sDelPt.x = iInsX;
		pUndo->sDelPt.y = iInsY;

		if(iMode&TEXT_UNDOADD)
			{
			pUndo->cChanged	= m_cChanged;
			pUndo->cMode	= (iMode&TEXT_UNDOTWOTURNS)? UNDO_DEL|UNDO_2TRUNS:UNDO_DEL;
			UndoAdd();
			}
		}

	if(!iOk)return -1;


	PrintColor(iStart);									// Farben aktualisieren


return iLine;
}


//*****************************************************************************
//*
//*     TextCopy
//*
//*****************************************************************************
//	Kopiert einen Text zwischen zwei Positionen.
//	pText		: Hier wird der Zeiger mit dem Text abgelegt.
//				  Dieser Zeiger muss mit delete freigegeben werden.
//				  Der allokierte Zeiger hat 6 Bytes Reserve am Ende.
//				  Dieser Zeiger muss mit delete freigegeben werden.
//	iPosX/iPosY	: Koordinaten von wo mit der Kopie begonnen wird.
//	iEndX/iEndY	: Koordinaten von wo mit der Kopie endet.
//	iMode		: Bestimmt die Art des Kopierens
//					TEXT_WORD       	Wort auf dem iPosX/iPosY steht kopieren
//					TEXT_CURSOR     	iPosX/iPosY durch m_iCursorX/m_iCursorY ersetzen
//					TEXT_SELECTION		iEndX/iEndY durch m_iMarkX  /m_iMarkY   ersetzen
//					TEXT_IS_UTF8		Der Text soll im UTF8 -Format kopiert werden
//					TEXT_IS_UTF16		Der Text soll im UTF16-Format kopiert werden
//	Ergibt die Anzahl der kopierten Bytes ohne Nullbyte. 
int CTextView::TextCopy(uchar **pText,int iPosX,int iPosY,int iEndX,int iEndY,int iMode)
{
unsigned char  *pPtr;
unsigned char  *pNew;
TextLine	   *pLine;
unsigned		uChar;
int				iLine;
int				iPos1;
int				iPos2;
int				iPos;
int				iVal;
int				iLen;
int				iCnt;
int				iOff;
int				iOut;




	if(iMode&TEXT_SELECTION){iEndX=m_iMarkX  ;iEndY=m_iMarkY  ;}
	if(iMode&TEXT_CURSOR   ){iPosX=m_iCursorX;iPosY=m_iCursorY;}
	if(iMode&TEXT_WORD)
		{
		if(iPosY>=m_iLineCount)
			{
			*pText=0;
			return 0;
			}

		pLine	= GetLine(iPosY);
		pPtr	= pLine->aText;
		iLen	= pLine->uSize;
		iPos	= TextPosition(iPosX,pPtr,iLen);

		iPos1	= CharAbc(iPos,pPtr,iLen,0);			// Wortlnge bestimmen
		iPos2	= CharAbc(iPos,pPtr,iLen,1);

		if(iPos1<=0 && iPos2<=0)
			{
			*pText=0;
			return 0;
			}

		iEndY	= iPosY;
		iEndX	= iPosX+iPos1;
		iPosX	= iPosX-iPos2;
		}


//****************** Koordinaten tauschen *************************************


	if(iPosY>iEndY || (iPosY==iEndY && iPosX>iEndX))
		{
		iPos1 = iPosX; iPosX = iEndX; iEndX	= iPos1;
		iPos2 = iPosY; iPosY = iEndY; iEndY	= iPos2;
		}

	if(iPosY>=m_iLineCount || (iPosY==iEndY && iPosX==iEndX))	// Nichts kopieren
		{
		pNew	= new uchar[8];
		pNew[0]	= 0;
	   *pText	= pNew;

		return 0;
		}


//**************** Einzeilige Kopie *******************************************


	if(iPosY==iEndY)
		{
		pLine	= GetLine(iPosY);
		pPtr	= pLine->aText;
		iLen	= pLine->uSize;
		iPos1	= TextPosition(iPosX,pPtr,iLen);
		iPos2	= TextPosition(iEndX,pPtr,iLen);
		iCnt	= iPos2-iPos1;
		pPtr   += iPos1;

		#ifdef USE_UTF8

		if(iMode&TEXT_IS_UTF16)							// UTF8 in UTF16 konvertieren
			{
			for(iOut=1,iOff=0;iOff<iCnt;iOut++)
				{
				iOff += utf8tochar(pPtr+iOff,uChar);
				if(uChar>=0x10000)iOut++;
				}

			pNew = new uchar[iOut*2+8];

			for(iOut=0,iOff=0;iOff<iCnt;)
				{
				iOff += utf8tochar (pPtr+iOff,uChar);
				iOut += chartoutf16(pNew+iOut,uChar)*2;
				}

			pNew[iOut  ]=0;
			pNew[iOut+1]=0;
			pText[0]=pNew;

			return iOut;
			}
		else if(!(iMode&TEXT_IS_UTF8))					// UTF8 in ANSI konvertieren
			{
			pNew = new uchar[iCnt+8];

			for(iOut=0,iOff=0;iOff<iCnt;iOut++)
				{
				iOff += utf8tochar(pPtr+iOff,uChar);
				if(uChar>=256)uChar=255;
				pNew[iOut]=uChar;
				}

			pNew[iOut]=0;
			pText[0]=pNew;

			return iOut;
			}

		#else

		if(iMode&TEXT_IS_UTF16)							// ANSI in UTF16 konvertieren
			{
			pNew = new uchar[iCnt*2+8];

			for(iOff=0;iOff<iCnt;iOff++)
				{
				pNew[iOff*2  ] = pPtr[iOff];
				pNew[iOff*2+1] = 0;
				}

			pNew[iOff*2  ]=0;
			pNew[iOff*2+1]=0;
			pText[0]=pNew;

			return iOff*2;
			}

		if(iMode&TEXT_IS_UTF8)							// ANSI in UTF8 konvertieren
			{
			for(iOut=0,iOff=0;iOff<iCnt;iOff++)
				{
				iOut += utf8length(pPtr[iOff]);
				}

			pNew = new uchar[iOut+8];

			for(iOut=0,iOff=0;iOff<iCnt;iOff++)
				{
				uChar = pPtr[iOff];
				iOut += chartoutf8(pNew+iOut,uChar);
				}

			pNew[iOut]=0;
			pText[0]=pNew;

			return iOut;
			}

		#endif

		pNew = new uchar[iCnt+8];						// Keine Konvertierung
		memcpy(pNew,pPtr,iCnt);
		pText[ 0  ] = pNew;
		pNew [iCnt] = 0;

		return iCnt;
		}


//**************** Mehrzeilige Kopie ******************************************


	for(iCnt=0,iLine=iPosY;iLine<=iEndY;iLine++)		// Bytes in Zeilen zhlen
		{
		if(iLine>=m_iLineCount)break;

		pLine = GetLine(iLine);
		iLen  = pLine->uSize;

		if(iLine==iPosY){iLen-=     TextPosition(iPosX,pLine->aText,iLen);}
		if(iLine==iEndY){iLen-=iLen-TextPosition(iEndX,pLine->aText,iLen);iCnt-=2;}

		iCnt += iLen+2;
		}


	pNew = new uchar[iCnt+8];


	for(iCnt=0,iLine=iPosY;iLine<=iEndY;iLine++)		// Bytes in Zeilen zhlen
		{
		if(iLine>=m_iLineCount)break;

		pLine	= GetLine(iLine);
		pPtr	= pLine->aText;
		iLen	= pLine->uSize;

		if(iLine==iPosY)
			{
			iVal  = TextPosition(iPosX,pLine->aText,iLen);
			pPtr += iVal;
			iLen -= iVal;
			}

		if(iLine==iEndY)
			{
			iVal = iLen-TextPosition(iEndX,pLine->aText,iLen);
			iLen-= iVal;
			}

		memcpy(pNew+iCnt,pPtr,iLen);
		iCnt += iLen;

		if(iLine!=iEndY)
			{
			memcpy(pNew+iCnt,"\r\n",2);
			iCnt+=2;
			}
		}


//*****************************************************************************


	#ifdef USE_UTF8

	if(iMode&TEXT_IS_UTF16)								// UTF8 in UTF16 konvertieren
		{
		pPtr = pNew;

		for(iOut=1,iOff=0;iOff<iCnt;iOut++)
			{
			iOff += utf8tochar(pPtr+iOff,uChar);
			if(uChar>=0x10000)iOut++;
			}

		pNew = new uchar[iOut*2+8];

		for(iOut=0,iOff=0;iOff<iCnt;)
			{
			iOff += utf8tochar (pPtr+iOff,uChar);
			iOut += chartoutf16(pNew+iOut,uChar)*2;
			}

		pNew[iOut  ]=0;
		pNew[iOut+1]=0;
		pText[0]=pNew;
		delete	 pPtr;

		return iOut;
		}
	else if(!(iMode&TEXT_IS_UTF8))						// UTF8 in ANSI konvertieren
		{
		for(iOut=0,iOff=0;iOff<iCnt;iOut++)
			{
			iOff += utf8tochar(pNew+iOff,uChar);
			if(uChar>=256)uChar=255;
			pNew[iOut]=uChar;
			}

		pNew [iOut] = 0;
		pText[ 0  ] = pNew;
		iCnt = iOut;
		return iOut;
		}

	#else

	if(iMode&TEXT_IS_UTF16)								// ANSI in UTF16 konvertieren
		{
		pPtr = pNew;
		pNew = new uchar[iCnt*2+8];

		for(iOff=0;iOff<iCnt;iOff++)
			{
			pNew[iOff*2  ] = pPtr[iOff];
			pNew[iOff*2+1] = 0;
			}

		pNew[iOff*2  ]=0;
		pNew[iOff*2+1]=0;
		pText[0]=pNew;
		delete   pPtr;

		return iOff*2;
		}

	if(iMode&TEXT_IS_UTF8)								// ANSI in UTF8 konvertieren
		{
		pPtr = pNew;

		for(iOut=0,iOff=0;iOff<iCnt;iOff++)
			{
			iOut += utf8length(pPtr[iOff]);
			}

		pNew = new uchar[iOut+8];

		for(iOut=0,iOff=0;iOff<iCnt;iOff++)
			{
			uChar = pPtr[iOff];
			iOut += chartoutf8(pNew+iOut,uChar);
			}

		pNew [iOut] = 0;
		pText[ 0  ] = pNew;
		delete        pPtr;

		return iOut;
		}


	#endif


	pNew[iCnt]	= 0;
   *pText		= pNew;


return iCnt;
}

//*****************************************************************************
//*
//*		TextCopy
//*
//*****************************************************************************
//	Kopiert einen Text zwischen zwei Positionen.
//	pText		: Zeiger auf den fixen Speicher.
//	iMax		: Ist die Gre des fixen Speichers.
//	iPosX/iPosY	: Koordinaten von wo mit der Kopie begonnen wird.
//	iEndX/iEndY	: Koordinaten von wo mit der Kopie endet.
//	iMode		: Bestimmt die Art des Kopierens
//					TEXT_WORD       	Wort auf dem iPosX/iPosY steht kopieren
//					TEXT_CURSOR     	iPosX/iPosY durch m_iCursorX/m_iCursorY ersetzen
//					TEXT_SELECTION		iEndX/iEndY durch m_iMarkX  /m_iMarkY   ersetzen
//					TEXT_IS_UTF8		Der Text soll im UTF8 -Format kopiert werden
//					TEXT_IS_UTF16		Der Text soll im UTF16-Format kopiert werden
//	Ergibt die kopierte Textlnge in Byte ohne Nullbyte.
int CTextView::TextCopy(uchar *pText,int iMax,int iPosX,int iPosY,int iEndX,int iEndY,int iMode)
{
uchar  *pPtr;
int		iLen;


	if(iMax<=0)return 0;

	iLen = TextCopy(&pPtr,iPosX,iPosY,iEndX,iEndY,iMode);

	if(!pPtr)
		{
		pText[0]=0;
		return 0;
		}

	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,pPtr,iLen);
	pText[iLen]=0;

	delete pPtr;


return iLen;
}



//*****************************************************************************
//*
//*		TextCopy
//*
//*****************************************************************************
//	Den markierten Text in einen fixen Speicher kopieren.
//	pText		: Zeiger auf den fixen Speicher.
//	iMax		: Ist die Gre des fixen Speichers.
//	iMode		: Bestimmt die Art des Kopierens
//					TEXT_WORD       	Wort auf dem iPosX/iPosY steht kopieren
//					TEXT_CURSOR     	iPosX/iPosY durch m_iCursorX/m_iCursorY ersetzen
//					TEXT_SELECTION		iEndX/iEndY durch m_iMarkX  /m_iMarkY   ersetzen
//					TEXT_IS_UTF8		Der Text soll im UTF8 -Format kopiert werden
//					TEXT_IS_UTF16		Der Text soll im UTF16-Format kopiert werden
//	Ergibt die kopierte Textlnge in Byte ohne Nullbyte.
int CTextView::TextCopy(uchar *pText,int iMax,int iMode)
{
uchar  *pPtr;
int		iLen;


	if(iMax<=0)return 0;

	iLen = TextCopy(&pPtr,iMode);

	if(!pPtr)
		{
		pText[0]=0;
		return 0;
		}

	if(iLen>=iMax)iLen=iMax-1;
	memcpy(pText,pPtr,iLen);
	pText[iLen]=0;

	delete pPtr;


return iLen;
}


//*****************************************************************************
//*
//*     TextClear
//*
//*****************************************************************************
//	Lscht einen angegeben Textbereich.
//	iPosX/iPosY		: Koordinaten von wo der Textbereich beginnt.
//	iEndX/iEndY		: Koordinaten von wo der Textbereich endet.
//	iMode			: Bestimmt die Art des Lschens
//							TEXT_CURSOR     	iPosX/iPosY durch m_iCursorX/m_iCursorY ersetzen
//  						TEXT_SELECTION		iEndX/iEndY durch m_iMarkX  /m_iMarkY   ersetzen
//							TEXT_CURSOR_LEFT   	Cursor nach setzen
//							TEXT_CURSOR_RIGHT   Cursor nach setzen
//							TEXT_REDRAW   		Fenster nacher neuzeichen
//	Ergibt 0 wenn kein Text gelscht wurde sonst 1
int CTextView::TextClear(int iPosX,int iPosY,int iEndX,int iEndY,int iMode)
{
TextLine	   *pLine2;
TextLine	   *pLine1;
unsigned char  *pPtr2;
unsigned char  *pPtr1;
unsigned char  *pNew;
int				iClear;
int				iPos2;
int				iPos1;
int				iLen2;
int				iLen1;
int				iVal;
int				iPos;



	if(m_iVirtualLines)return 0;

	if(iMode&TEXT_CURSOR   ){iPosX=m_iCursorX;iPosY=m_iCursorY;}
	if(iMode&TEXT_SELECTION){iEndX=m_iMarkX  ;iEndY=m_iMarkY  ;}


//****************** Koordinaten tauschen *************************************


	if(iPosY>iEndY || (iPosY==iEndY && iPosX>iEndX))
		{
		iPos2 =iPosY; iPos1 = iPosX;
		iPosY =iEndY; iPosX = iEndX;
		iEndY =iPos2; iEndX = iPos1;
		}

	if(iPosY>=m_iLineCount         )return 0;			// Nichts lschen
	if(iPosY==iEndY && iPosX==iEndX)return 0;


//****************** Mehrere Zeilen lschen ***********************************

	if(iPosY!=iEndY)
	do	{
		m_iRedrawFlags = NZ_ALL;

		if(iEndY>=m_iLineCount)							// ber Textende ?
			{
			iEndY  = m_iLineCount-1;
			iEndX  = 100000;
			iClear = 1;

			if(iEndY==iPosY)break;
			}
		else{
			iClear = 0;
			}

		pLine1	= m_pLineList[iPosY];
		pLine2	= m_pLineList[iEndY];
		pPtr1 	= pLine1->aText;
		pPtr2 	= pLine2->aText;
		iLen1 	= pLine1->uSize;
		iLen2 	= pLine2->uSize;
		iPos1 	= TextPosition(iPosX,pPtr1,iLen1);
		iPos2 	= TextPosition(iEndX,pPtr2,iLen2);
		iVal	= iPos1+iLen2-iPos2;					// Neue Zeile erzeugen

		if(!iVal)
			{
			LineChange(iPosY,(uchar*)&iVal,0);
			}
		else{
			pNew = new uchar[iVal];

			memcpy(pNew      ,pPtr1      ,      iPos1);
			memcpy(pNew+iPos1,pPtr2+iPos2,iLen2-iPos2);

			LineChange(iPosY,pNew,iVal);

			delete pNew;
			iClear = 0;
			}

		for(iPos=iEndY;iPos>iPosY;iPos--)
			{
			if(m_iCursorY>=iPos)m_iCursorY--;
			LineDelete(iPos);
			}

		if(iClear)
			{
			LineDelete(iPos);
			if(m_iCursorY>=iPos)m_iCursorY=m_iLineCount;
			}

		}while(0);


//****************** Aus Zeile lschen ****************************************


	if(iPosY==iEndY)
		{
		m_iRedrawFlags |= NZ_LINE;

		pLine1	= m_pLineList[iPosY];
		pPtr1 	= pLine1->aText;
		iLen1 	= pLine1->uSize;
		iPos1 	= TextPosition(iPosX,pPtr1,iLen1);
		iPos2 	= TextPosition(iEndX,pPtr1,iLen1);
		iVal	= iPos1+iLen1-iPos2;					// Neue Zeile erzeugen
		pNew	= new uchar[iVal];

		memcpy(pNew      ,pPtr1      ,      iPos1);
		memcpy(pNew+iPos1,pPtr1+iPos2,iLen1-iPos2);

		LineChange(iPosY,pNew,iVal);

		delete pNew;
		}


//******************** Cursor setzen ******************************************


	if(iMode&TEXT_CURSOR_LEFT )PositionOk(0,0,1);
	if(iMode&TEXT_CURSOR_RIGHT)PositionOk(0,0,1);
	if(iMode&TEXT_REDRAW      )DrawView(1);


return 1;
}

//*****************************************************************************
//*
//*     TextExchange
//*
//*****************************************************************************
//	Tauscht den Text in einer Zeile gegen einen anderen Text aus.
//	pText	: Ist der neuen Text fr die Zeile.
//	iPosY	: Ist die Zeilennummer.
//	iSize	: Ist die Lnge der neuen Zeile.
//	iMode	: Beszimmt das Format des Textes
//					TEXT_IS_UTF8		Der Text soll im UTF8 -Format kopiert werden
//					TEXT_IS_UTF16		Der Text soll im UTF16-Format kopiert werden
//	Ergibt die Zeilennummer der neuen Zeile bzw -1 bei einem Fehler.
int CTextView::TextExchange(const uchar *pText,int iPosY,int iSize,int iMode)
{
unsigned 	uChar;
int			iPos;
int			iOut;
int			iOff;



	if(pText==0 || iPosY<0)return -1;


	#ifdef USE_UTF8

	if(iMode&TEXT_IS_UTF16)								// UTF16 in UTF8 konvertieren
		{
		for(iOut=0,iOff=0;iOff<iSize;iOff++)
			{
			iOff += utf16tochar(pText+iOff,uChar)*2;
			iOut += chartoutf8(m_pNullLine+iOut,uChar);
			if(iOut+4>=m_iMaxChars)break;
			}

		pText = m_pNullLine;
		iSize = iOut;
		}
	else if(!(iMode&TEXT_IS_UTF8))						// ANSI in UTF8 konvertieren
		{
		for(iOut=0,iOff=0;iOff<iSize;iOff++)
			{
			uChar = pText[iOff];
			iOut += chartoutf8(m_pNullLine+iOut,uChar);
			if(iOut+4>=m_iMaxChars)break;
			}

		pText = m_pNullLine;
		iSize = iOut;
		}

	#else

	if(iMode&TEXT_IS_UTF16)								// UTF16 in ANSI konvertieren
		{
		for(iOut=0,iOff=0;iOff<iSize;iOut++)
			{
			if(iOut>=m_iMaxChars)break;
			iOff += utf16tochar(pText+iOff,uChar)*2;
			if(uChar>=256)uChar=255;
			m_pNullLine[iOut]=uChar;
			}

		pText = m_pNullLine;
		iSize = iOut;
		}
	else if(iMode&TEXT_IS_UTF8)							// UTF8 in ANSI konvertieren
		{
		for(iOut=0,iOff=0;iOff<iSize;iOut++)
			{
			if(iOut>=m_iMaxChars)break;
			iOff += utf8tochar(pText+iOff,uChar);
			if(uChar>=256)uChar=255;
			m_pNullLine[iOut]=uChar;
			}

		pText = m_pNullLine;
		iSize = iOut;
		}

	#endif


	if(iPosY>=m_iLineCount)								// Zeile am Ende anhngen
		{
		iPos  = LineInsert(m_iLineCount,pText,iSize);
		iPosY = (iPos)?    m_iLineCount-1:-1;

		m_cChanged = 1;

		return iPosY;
		}
	else{
			iPos=LineChange(iPosY,pText,iSize);
		if(!iPos)iPosY=-1;
		}



	if(iPosY==-1)return -1;


	PrintColor(iPosY);


	if(iPosY>=m_iScrollY && iPosY<=m_iScrollY+m_iScreenY+1)
		{
		DrawViewLine(iPosY);
		DrawView(1);
		}


	m_cChanged=1;



return  iPosY;
}

//*****************************************************************************
//*
//*     TextData
//*
//*****************************************************************************
//	Schreibt oder liest den Datenspeicher einer Zeile
//	Ist iMode == 0 dann wird nur gelesen
//	Ist iMode != 0 dann wird TextLine->dwData mit >Daten ersetzt
//	Ergibt den alten Wert von TextLine->dwData
int	CTextView::TextData(int iLine,int iMode,int iData)
{
TextLine   *pLine;
int			iOld;


	if(iLine>m_iLineCount)return 0;

	pLine	= GetLine(iLine);
	iOld	= pLine->dwData;

	if(iMode)pLine->dwData = iData;



return iOld;
}

//*****************************************************************************
//*
//*     TextNew
//*
//*****************************************************************************
//	Lscht das gesammte Fenster und setzt das Gendert-Flag wieder auf 0.
//	Ergibt den alten Wert vom Gendert-Flag
int	 CTextView::TextNew()
{
TextLine   *pLine;
int			iPos;
int			iOld;


	
	if(!m_iVirtualLines)
		{
		iPos = m_iLineCount-1;
		m_iLineCount = 0;

		for(;iPos>=0;iPos--)
			{
			// LineDelete(iPos);							// Der folgende Code wurde statt LineDelete(iPos) eingefgt	

			if(m_pHookDeleteLine)
				{
				m_pHookDeleteLine(this,m_pHookDeleteLineParam,iPos);
				}

			   pLine = m_pLineList[iPos];
			if(pLine->pColors)								// Farbspeicher lschen
				{
				delete pLine->pColors;
				pLine->pColors = 0;
				}

			delete pLine;									// Textspeicher lschen
			}

		m_iLineCount = 0;

		CheckBlock();
		}
	

	ConfigText ();
	ConfigAccel();
	UndoClear  ();
	PositionOk (0,0,0);
	DrawView   ();

	iOld = m_cChanged;
	m_cChanged = 0;


return iOld;
}

//*****************************************************************************
//*
//*     StartMenu
//*
//*****************************************************************************
//	Startet ein Kontextmen.
//	sPos		: Koordinaten bei denen das Kontextmen eingeblendet wird.
//	pMenu		: Zeiger auf das Men
//				  Ist pMenu=0 wird ein neues Men erzeugt.
void CTextView::StartMenu(CPoint sPos,CMenu *pMenu)
{
const char *pWord=0;
CMenu		sMenu;
CRect		sRect;
unsigned	uWord;
unsigned	uId;



	if(!pMenu)											// Neues Men
		{
		pMenu = &sMenu;
		sMenu.CreatePopupMenu();
		}


	if(m_pHookContextMenu)								// Kontextmen
		{
		#ifdef	USE_DICIONARY

		char		   cWord[64];
		TextLine      *pLine;
		unsigned char *pText;
		unsigned char *pData;
		int			   iPos;
		int			   iLen;

		if(m_iContextX>=0 && (m_iDicFlags&DIC_CONTEXT))	// Men fr Rechtschreibprfung
			{
			   pLine = GetLine(m_iContextY);
			if(pLine && pLine->pColors && m_pHookContextMenu)
				{
				pText = pLine->aText;					// Position im Text
				pData = pLine->pColors;
				iPos  = TextPosition(m_iContextX,pText,pLine->uSize);

				if(pLine->pColors[iPos]&0x80)			// Ist das Wort fehlerhaft
					{
					iLen = 1;

					while(iPos>0 && (pData[iPos-1]&0x80))
						{
						iPos--;
						iLen++;
						}

					while(iPos+iLen<pLine->uSize && (pData[iPos+iLen]&0x80))
						{
						iLen++;
						}

					if(iLen<sizeof(cWord))
						{
						memcpy(cWord,pText+iPos,iLen);
						m_iDicContextX2 = iPos+iLen;
						m_iDicContextX1 = iPos;
						cWord[iLen]		= 0;
						pWord			= cWord;
						}
					}
				}
			}

		#endif
														// Hook-Funktion aufrufen
		if(m_pHookContextMenu(this,m_pHookContextMenuParam,pMenu,m_iContextX,m_iContextY,pWord))
			{
			return;
			}
		}


	if(m_iMarkOn==0)
		{
		PointToPos(sPos,m_iWordPosX,m_iWordPosY);
		uWord = IsWord (m_iWordPosX,m_iWordPosY);
		uId   = ID_WORD_COPY;
		}
	else{
		uWord = 0;
		uId   = ID_EDIT_COPY;
		}

	pMenu->AppendMenu(MF_STRING,ID_EDIT_CUT		     , "&Ausschneiden" );
	pMenu->AppendMenu(MF_STRING,uId,(uWord)?"&Kopiere Wort":"&Kopieren");
	pMenu->AppendMenu(MF_STRING,ID_EDIT_PASTE  	     , "&Einfgen"     );
	pMenu->AppendMenu(MF_STRING,ID_EDIT_CLEAR  	     , "&Lschen"      );
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_STRING,ID_EDIT_FIND	     , "&Suchen"       );
	pMenu->AppendMenu(MF_STRING,ID_EDIT_REPLACE	     , "&Erset&zen"    );
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_STRING,ID_EDIT_CONFIG	     , "&Einstellungen");

	#ifdef TEXT_ICONS

	AddMenuBitmap(sMenu,ID_EDIT_CUT   ,TEXT_ICONS,0);
	AddMenuBitmap(sMenu,ID_EDIT_PASTE ,TEXT_ICONS,1);
	AddMenuBitmap(sMenu,uId           ,TEXT_ICONS,2);
	AddMenuBitmap(sMenu,ID_EDIT_CLEAR ,TEXT_ICONS,3);
	AddMenuBitmap(sMenu,ID_EDIT_FIND  ,TEXT_ICONS,4);

	#endif

	if(m_iMarkOn==0)
		{
		if(uWord==0)
		pMenu->EnableMenuItem(ID_WORD_COPY ,MF_GRAYED);
		pMenu->EnableMenuItem(ID_EDIT_CUT  ,MF_GRAYED);
		pMenu->EnableMenuItem(ID_EDIT_CLEAR,MF_GRAYED);
		}

	if(m_cNotChange)
		{
		pMenu->EnableMenuItem(ID_EDIT_REPLACE,MF_GRAYED);
		}

	if(m_cNotChange || !IsClipboardFormatAvailable(CF_TEXT))
		{
		pMenu->EnableMenuItem(ID_EDIT_PASTE,MF_GRAYED);
		}


	CAnsiView::StartMenu(sPos,pMenu);

	if(pMenu==&sMenu)sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*     Update
//*
//*****************************************************************************
//	Fenster auf den neuersten Stand bringen.
//	iMode	: Bestimmt was aktalisiert werden soll.
//					Bit 0	LineBeginEnd aktualisieren
//					Bit 1	Zeilenfarben aktualisieren
//					Bit 2	Fenster neuzeichen
//					Bit 3	Fenstergren prfen
void CTextView::Update(int iMode)
{
int		iPos;


	if(iMode&1)											// Start Ende neu berechnen
		{
		iPos=m_iLineCount;
		for(iPos--;iPos>=0;iPos--)LineBeginEnd(GetLine(iPos));
		}

	if(iMode&2)											// Farbe neu berechnen
		{
		for(iPos=0;iPos<m_iLineCount;)iPos=PrintColor(iPos);
		}

	if(iMode&4)											// Neu zeichnen
		{
		DrawView(1);
		}

	if(iMode&8)											// Fenstergren prfen
		{
		PositionCheck();
		}

}

//*****************************************************************************
//*
//*     FindUpdate
//*
//*****************************************************************************
//	Fgt einen neuen Text in die Suchliste ein.
//	pText		: Zeiger auf den neuen Text.
void CTextView::FindUpdate(uchar *pText)
{
uchar	       *pOldFind;
char	       *pNewFind;
CStringChain	sList;
int				iSize;



	if(!*pText)return;

	pOldFind = m_pFindText;
	pNewFind = (char*)pText;
	iSize    = strlen(pNewFind);


	if(m_pFindText!=pText)
		{
		m_pFindText = new uchar[iSize+1];
		memcpy(m_pFindText,pNewFind,iSize+1);

		if(pOldFind)delete pOldFind;
		}


	#ifdef USE_UTF8

	char		cBuffer[260];
	unsigned	uChar;
	int			iCnt;
	int			iOff;


	for(iCnt=0,iOff=0;iOff<iSize;)						// Suchtext von UTF8 auf ANSI
		{
		iOff += utf8tochar(pText+iOff,uChar);
		if(uChar>=256)uChar=255;
		cBuffer[iCnt]=uChar;
		iCnt += 1;
		if(iCnt>=256)break;
		}

	cBuffer[iCnt]=0;
	pNewFind=cBuffer;

	#endif


	if(!m_pFindSelection || strcmp(pNewFind,m_pFindSelection))
		{
		sList.ContainerInit(TEXT_FIND_MAX);

		if(m_pFindSelection)
			{
			sList.KAdd(m_pFindSelection);
			sList.CAdd(pNewFind);
			delete m_pFindSelection;
			m_pFindSelection=0;
			}
		else{
			sList.CAdd(pNewFind);
			}

		sList.Chain(&m_pFindSelection);

		m_iFlags|=FLAG_CONFIG_SAFE;
		}

}

//*****************************************************************************
//*
//*     FindNext
//*
//*****************************************************************************
//	Sucht ab der Cursor-Position nach dem letzten Suchtext.
//  ber die die Bits in m_iFlags kann die Art des Suchens bestimmt werden:
//  		FLAG_FIND_CASE			Gro/Kleinschreibung ignorieren
//  		FLAG_FIND_UPWARDS		Abwrts suchen
//  		FLAG_FIND_ALL			Die gesammte Datei durchsuchen
//			FLAG_FIND_EXPRESSION	Nach Ausdrcken mit * und ? suchen
//	Ergibt 1 wenn Text gefunden ansonsten sontst 0.
void CTextView::OnFindNext(){FindNext();}
int  CTextView::FindNext()
{
HCURSOR	hOld;
int		iRet;


	hOld	= ::SetCursor(IDC_WAIT);
	iRet	=   Find((char*)m_pFindText,4|FIND_DEF);
			  ::SetCursor(hOld);

	if(!iRet)MessageBeep(MB_ICONASTERISK);


return iRet;
}

//*****************************************************************************
//*
//*     Find
//*
//*****************************************************************************
//	Sucht ab der Cursor-Position nach einem Text einzeiligen Text.
//  ber die die Bits in m_iFlags kann die Art des Suchens bestimmt werden.
//  			FLAG_FIND_CASE			Gro/Kleinschreibung ignorieren
//  			FLAG_FIND_UPWARDS		Abwrts suchen
//  			FLAG_FIND_ALL			Die gesammte Datei durchsuchen
//				FLAG_FIND_EXPRESSION	Nach Ausdrcken mit * und ? suchen
//	pText	: Ist der Text nach dem gesucht werden soll.
//			  Ist Text=0 so wird der aktuelle Suchtext benutzt.
//	iMode	: Bestimmt die diverse Sucheeigenschaften:
//				Bit 0 != 0 wird das Fenster nicht neugezeichnet (fr Alles ndern)
//  			Bit 1 != 0 wird der Text nicht gespeichert
//  			Bit 2 != 0 wird das nchste Wort gesucht
//				Bit 3 != 0 wird nur im Bereich gesucht
//				Bit 4 != 0 wird vor dem Suchen ein Schritt vor gegangen
//				Bit 5 != 0 wird vor dem Suchen ein Schritt zurck gegangen
//				Bit	8	   dann ist der Text UTF8 kodiert
//	Ergibt 1 wenn Text gefunden wurde, ansontsten 0.
int	 CTextView::Find(const char *pText,int iMode)
{
unsigned    uChar;
uchar      *pPtr;
uchar      *pMem;
TextLine   *pLine;
int			iUpper;
int			iEndX;
int			iEndY;
int			iPosX;
int			iPosY;
int			iLoop;
int			iSize;
int			iFlag;
int			iCnt;
int			iLen;
int			iOff;
int			iNum;



	if(!pText)											// Nach vorherigen Text suchen
		{
		if(!m_pFindText)return 0;
		pText  = (char*)m_pFindText;
		iMode &= 0x00FF;
		#ifdef USE_UTF8
		iMode |= 0x0100;
		#endif
		}




	pPtr	= 0;
	pMem	= 0;
	iUpper	= (m_iFlags&FLAG_FIND_CASE)? 1:0;
	iSize	= strlen(pText);
	iCnt	= iSize;

	#ifdef USE_UTF8

	if(!(iMode&0x0100))									// ANSI zu UTF8 konvertieren
		{
		for(iCnt=0,iOff=0;iOff<iSize;iOff++)
			{
			uChar = ((uchar*)pText)[iOff];
			iCnt += chartoutf8(m_pNullLine+iCnt,uChar);
			if(iCnt+4>=m_iMaxChars)break;
			}

		m_pNullLine[iCnt] = 0;
		iSize = iCnt;
		pText = (char*)m_pNullLine;
		}

	#else

	if(iMode&0x0100)									// UTF8 zu ANSI konvertieren
		{
		for(iCnt=0,iOff=0;iOff<iSize;)
			{
			iOff += utf8tochar(pText+iOff,uChar);
			if(uChar>=256)uChar=255;
			m_pNullLine[iCnt]=uChar;
			iCnt += 1;
			if(iCnt>=m_iMaxChars)break;
			}

		m_pNullLine[iCnt] = 0;
		iSize = iCnt;
		pText = (char*)m_pNullLine;
		}

	#endif



	if(!m_iLineCount || iCnt<=0)return 0;

	iPosX	= m_iCursorX;
	iPosY	= m_iCursorY;


	if(!(iMode&2))										// Suchliste aktualisieren
		{
		FindUpdate((uchar*)pText);
		}

	if(m_iLineCount<=0)return 0;

	iLoop=0;


	if(m_iFlags&FLAG_FIND_EXPRESSION)					// Wortsuche mit Wildchards korrigieren
	if(m_iFlags&FLAG_FIND_WORD)
	if(iSize+3<m_iMaxChars && iSize>=1)
	if(iSize<2 || pText[iSize-1]!='f' || pText[iSize-2]!='\\')
		{
		#ifdef USE_UTF8
		iOff = utf8prechar(pText+iSize,uChar);
		if(iSize-iOff>=0 && pText[iSize-iOff]=='\\')uChar='\\';
		#else
		uChar = ((uchar*)pText)[iSize-1];
		if(iSize>=2 && pText[iSize-2]=='\\')uChar='\\';
		#endif

		if(uChar=='*' || uChar=='?' || CharType(uChar)>=2)
			{
			if(pText!=(char*)m_pNullLine)
				{
				memcpy(m_pNullLine,pText,iSize+1);
				pText = (char*)m_pNullLine;
				}

			m_pNullLine[iSize] = '\\';	iSize++;
			m_pNullLine[iSize] = 'f' ;	iSize++;
			m_pNullLine[iSize] =  0  ;
			}
		}


//********************** Abwrts suchen (Zeilen--) ****************************


	if(m_iFlags&FLAG_FIND_UPWARDS)
		{
		if(m_iMarkOn==1 && !(iMode&8))					// Vor der Auswahl mit der Suche beginnen
		if(m_iMarkX<iPosX)
			{
			m_iMarkX=iPosX;
			}

		if(iPosY>=m_iLineCount)							// Hinter Text
			{
			iPosY = m_iLineCount-1;
			iPosX = 100000;
			}

		pLine	= GetLine(iPosY);
		pPtr	= pLine->aText;
		iLen	= pLine->uSize;
		iPosX	= TextPosition(iPosX,pPtr,iLen);
		iEndX	= iPosX;
		iEndY	= iPosY;

		if(iLen && iEndX>=iLen-1)
			{
			iEndX=iLen-1;
			}

		for(;;)
			{
			   iPosX--;
			if(iPosX<0)									// Neue Zeile
				{
				iPosY--;

				if(iPosY<0)
					{
					if(iLoop)break;
					if(m_iFlags&FLAG_FIND_ALL)			// Ganzen Text durchsuchen
						{
						iPosY = m_iLineCount-1;
						iLoop = 1;
						}
					else{
						break;
						}
					}

				pLine	= GetLine(iPosY);
				pPtr	= pLine->aText;
				iLen	= pLine->uSize;
				iPosX	= iLen;
				}

			#ifdef USE_UTF8
			else{
				if(pPtr[iPosX]>=0x80 && iPosX>0)
					{
					iPosX -= utf8prechar(pPtr+iPosX+1,uChar)-1;
					}
				}
			#endif

			if(iLoop)									// Ende erreicht ?
				{
				if(iPosY==iEndY && iPosX<iEndX)break;
				if(iPosY< iEndY               )break;
				}

			if(m_iFlags&FLAG_FIND_EXPRESSION)			// Nach Ausdruck suchen ('*','?')
				{
				if(iLoop && iPosY==iEndY && iPosX<iEndX)break;

				iFlag = iUpper|0x24;

				if(iPosX)
					{
					iFlag |= 0x08;
					uChar  = pPtr[iPosX-1];

					#ifdef USE_UTF8
					if(uChar>=0x80 && iPosX>0)
						{
						utf8prechar(pPtr+iPosX,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif

					if(m_aCharType[uChar]&3)iFlag|=0x10;
					}

				   iCnt = CmpX((uchar*)pText,iSize,pPtr+iPosX,iLen-iPosX,iFlag);
				if(iCnt<=0)continue;
				}
			else{										// Nach Text suchen
				if(iLen-iPosX<iCnt)continue;
				if(Cmp(pText,pPtr+iPosX,iCnt,iUpper))continue;
				}

			if(m_iFlags&FLAG_FIND_WORD)					// Ganze Wrter suchen
				{
				if(iPosX>0)
					{
					uChar = pPtr[iPosX-1];

					#ifdef USE_UTF8
					if(uChar>=0x80)
						{
						utf8prechar(pPtr+iPosX,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif

					if(m_aCharType[uChar]&0x03)continue;
					}


				if(iPosX+iCnt<iLen)
					{
					uChar = pPtr[iPosX+iCnt];

					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						utf8tochar(pPtr+iPosX+iCnt,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif

					if(m_aCharType[uChar]&0x03)continue;
					}
				}

			iOff = ViewPosition(iPosX     ,pPtr,iLen);
			iNum = ViewPosition(iPosX+iCnt,pPtr,iLen);

			if(iMode&8)									// Im Bereich ?
				{
				if(!CheckRange(iOff  ,iPosY))continue;
				if(!CheckRange(iNum-1,iPosY))continue;
				}

			if(iMode&1)
				{
				ExpandCheck(iPosY);

				m_iCursorX = iOff ;
				m_iCursorY = iPosY;
				m_iMarkX   = iNum ;
				m_iMarkY   = iPosY;
				}
			else{
				PositionOk(iNum,iPosY,0);
				PositionOk(iOff,iPosY,2);
				PositionCheck(1);
				DrawView(1);
				}

			return 1;
			}
		}

//********************** Aufwrts suchen (Zeilen++) **************************************
	else{
		if(iPosY>=m_iLineCount)							// Hinter Text
			{
			iPosY = 0;
			iPosX = 0;
			}

		pLine	= GetLine(iPosY);
		pPtr	= pLine->aText;
		iLen	= pLine->uSize;

		if(iMode&0x10)									// Einen Schritt vor
			{
			#ifdef USE_UTF8
			if(pPtr[iPosX]>=0xC0)
				{
				iPosX += utf8tochar(pPtr+iPosX,uChar);
				}
			else
			#endif

			   iPosX++;
			if(iPosX>=iLen)
				{
				iPosX=0;
				iPosY++;

				if(iPosY>=m_iLineCount)					// Hinter Text
					{
					iPosY=0;
					}

				pLine	= GetLine(iPosY);
				pPtr	= pLine->aText;
				iLen	= pLine->uSize;
				}
			}
		else if((iMode&0x20) && iPosX>0)				// Einen Schritt zurck
			{
			#ifdef USE_UTF8
			if(pPtr[iPosX-1]>=0x80)
				{
				iPosX -= utf8prechar(pPtr+iPosX,uChar);
				}
			else
			#endif
			iPosX--;
			}

		iPosX = TextPosition(iPosX,pPtr,iLen);
		iEndX = iPosX;
		iEndY = iPosY;

		if(iLen && iEndX>=iLen-1)
			{
			iEndX=iLen-1;
			}

		if(!(iMode&4) && (!m_iMarkOn || m_iCursorX<m_iMarkX))
			{
			iPosX--;
			#ifdef USE_UTF8
			if(pPtr[iPosX]>=0x80 && iPosX>0)
				{
				iPosX -= utf8prechar(pPtr+iPosX+1,uChar)-1;
				}
			#endif
			}

		for(;;)
			{											// Neue Zeile
			#ifdef USE_UTF8
			if(pPtr[iPosX]>=0xC0)
				{
				iPosX += utf8tochar(pPtr+iPosX,uChar);
				}
			else
			#endif

			   iPosX++;
			if(iPosX>iLen)
				{
				iPosY++;
				if(iPosY>=m_iLineCount)
					{
					if(iLoop)break;
					if(m_iFlags&FLAG_FIND_ALL)			// Ganze Wrter suchen
						 {iPosY=0;iLoop=1;}
					else break;
					}

				pLine   = GetLine(iPosY);
				pPtr	= pLine->aText;
				iLen	= pLine->uSize;
				iPosX	= 0;
				}

			if(iLoop)
				{
				if((iPosY==iEndY)&&(iPosX>iEndX))break;
				if( iPosY >iEndY)			     break;
				}

			if(m_iFlags&FLAG_FIND_EXPRESSION)			// Nach Ausdruck suchen ('*','?')
				{
				if(*pText=='*')
					{
					if(iPosX>0 && iPosX<iLen)
						{
						uChar = pPtr[iPosX-1];
						if(m_aCharType[uChar]&0x03)continue;
						}

					if(iPosX<iLen)
						{
						uChar = pPtr[iPosX];
						if(!(m_aCharType[uChar]&0x03))continue;
						}
					}

				if(iLoop && iPosY==iEndY && iPosX>iEndX)break;

				iFlag = iUpper|0x04;

				if(iPosX>0)
					{
					iFlag  |= 0x08;
					uChar  = pPtr[iPosX-1];

					#ifdef USE_UTF8
					if(uChar>=0x80 && iPosX>0)
						{
						utf8prechar(pPtr+iPosX,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif

					if(m_aCharType[uChar]&3)iFlag|=0x10;
					}

				   iCnt=CmpX((uchar*)pText,iSize,pPtr+iPosX,iLen-iPosX,iFlag);
				if(iCnt<=0)continue;
				}
			else{										// Nach Text suchen
				if(iLen-iPosX<iCnt)continue;
				if(Cmp(pText,pPtr+iPosX,iCnt,iUpper))continue;
				}

			if(m_iFlags&FLAG_FIND_WORD)					// Ganze Wrter suchen
				{
				if(iPosX>0)
					{
					uChar = pPtr[iPosX-1];

					#ifdef USE_UTF8
					if(uChar>=0x80)
						{
						utf8prechar(pPtr+iPosX,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif

					if(m_aCharType[uChar]&0x03)continue;
					}


				if(iPosX+iCnt<iLen)
					{
					uChar = pPtr[iPosX+iCnt];

					#ifdef USE_UTF8
					if(uChar>=0xC0)
						{
						utf8tochar(pPtr+iPosX+iCnt,uChar);
						if(uChar>=256)uChar=255;
						}
					#endif

					if(m_aCharType[uChar]&0x03)continue;
					}
				}

			iOff = ViewPosition(iPosX     ,pPtr,iLen);
			iNum = ViewPosition(iPosX+iCnt,pPtr,iLen);

			if(iMode&8)									// Im Bereich ?
				{
				if(!CheckRange(iOff  ,iPosY))continue;
				if(!CheckRange(iNum-1,iPosY))continue;
				}

			if(iMode&1)
				{
				ExpandCheck(iPosY);

				m_iCursorX = iOff ;
				m_iCursorY = iPosY;
				m_iMarkX   = iNum ;
				m_iMarkY   = iPosY;
				}
			else{
				PositionOk(iNum,iPosY,0);
				PositionOk(iOff,iPosY,2);
				PositionCheck(1);
				DrawView(1);
				}

			return 1;
			}
		}


return 0;

}

//*****************************************************************************
//*
//*     FindWord
//*
//*****************************************************************************
//	Sucht ab der Cursor-Position nach dem Wort bzw. dem markierten Text
//  auf den der Cursor steht.
//  ber die die Bits in m_iFlags kann die Art des Suchens bestimmt werden:
//  		FLAG_FIND_CASE			Gro/Kleinschreibung ignorieren
//  		FLAG_FIND_UPWARDS       Abwrts suchen
//  		FLAG_FIND_ALL			Die gesammte Datei Durchsuchen
//			FLAG_FIND_EXPRESSION	Nach Ausdrcken mit * und ? suchen
//	Ergibt 1 wenn Text gefunden sontst 0
void CTextView::OnFindWord(){FindWord();}
int	 CTextView::FindWord()
{
uchar	   *pPtr=0;
int			iRet;



	if(m_iMarkOn==1)
		{
		TextCopy(&pPtr,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY,TEXT_IS_DEF);

		if((m_iFlags&FLAG_FIND_UPWARDS) && m_iMarkX<m_iCursorX)
			{
			iRet			= m_iCursorX;
			m_iCursorX		= m_iMarkX;
			m_iMarkX		= iRet;
			m_iRedrawFlags |= NZ_LINE;
			}
		}
	else{
		TextCopy(&pPtr,m_iCursorX,m_iCursorY,0,0,TEXT_WORD|TEXT_IS_DEF);
		}

	if(!pPtr || !*pPtr)
		{
		iRet = FindView((char*)m_pFindText,FIND_DEF);
		}
	else if(m_iMarkOn && m_iCursorX>m_iMarkX && m_iCursorY==m_iMarkY)
		{
		iRet = Find((char*)pPtr,0x24|FIND_DEF);				// Mit Schritt zurck
		}
	else{
		iRet = Find((char*)pPtr,0x04|FIND_DEF);
		}

	if(pPtr)delete pPtr;
	if(m_iRedrawFlags)DrawView(1);


return iRet;
}

//*****************************************************************************
//*
//*     FindView
//*
//*****************************************************************************
//	Ruft ein Dialog-Fenster fr das Suchen von Texten auf.
//	iMode		: Bestimmt die Codierung des Textes
//					0x0000	= ANSI
//					0x0100	= UTF8
//	OnFindView ist fr die Menaufrufe
void CTextView::OnFindView(){FindView();}
int CTextView::FindView(const char *pText,int iMode)
{
char		cBuffer[260];
uchar	   *pSelect=0;
unsigned	uChar;
int			iRet;
int			iLen;
int			iOff;
int			iCnt;


	if(!pText)
		{
		if(m_iMarkOn==1)TextCopy(&pSelect,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY,TEXT_IS_MODE);
		if(m_iMarkOn==0)TextCopy(&pSelect,m_iCursorX,m_iCursorY,0,0    ,TEXT_WORD|TEXT_IS_MODE);

		if(pSelect && *pSelect)pText=(char*)pSelect;
		if(pText==0)pText=(char*)m_pFindText;
		if(pText==0)pText="";

		#ifdef UNICODE
		iMode=0x0200;
		#else
		iMode=0x0000;
		#endif
		}


	iLen = strlcpy(cBuffer,pText,sizeof(cBuffer)-4);

	if(iMode&0x0100)									// UTF8 in ANSI konvertieren
		{
		for(iOff=0,iCnt=0;iOff<iLen;)
			{
			iOff += utf8tochar(cBuffer+iOff,uChar);
			if(uChar>=256)uChar=255;
			cBuffer[iCnt]=uChar;
			iCnt+=1;
			}

		cBuffer[iCnt]=0;
		}



	iRet = m_sFindDlg->DoModal(this,cBuffer,sizeof(cBuffer),m_iFlags,m_pFindSelection);

	SetCursorMode();

	if(pSelect)delete pSelect;



return iRet;
}

//*****************************************************************************
//*
//*     Replace
//*
//*****************************************************************************
//	Sucht ab der Cursor-Position nach einem Text und ndert ihn.
//  ber die die Bits in m_iFlags kann die art des suchens bestimmt werden
//  				FLAG_FIND_CASE			Gro/Kleinschreibung ignorieren
//  				FLAG_FIND_UPWARDS       Abwrts suchen
//  				FLAG_FIND_ALL			Die gesammte Datei Durchsuchen
//					FLAG_FIND_EXPRESSION	Nach Ausdrcken mit * und ? suchen
//	pText		: Ist der Text nach dem gesucht wird.
//				  Ist pText=0 so wird nach dem pText in m_pFindText gesucht.
//	pChange		: Ist der neue Text in den der alte gendert wird.
//				  Ist pChange=0 so wird der pText durch m_pChangeText ersetzt
//	iMode		: Bestimmt diverse Suchoptionen:
//				  Ist iMode        == 0 wird die aktuelle einzeilige Marke gendert
//				  Ist iMode        == 1 Es wird zuerst nach einem Text gesucht
//				  Ist iMode        == 2 werden alle Texte gendert
//				  Ist iMode&0x8000 != 0 werden nur Texte in der Auswahl gendert
//				  Ist iMode&0x4000 != 0 wird die Marke wieder auf den Bereich gesetzt
//				  Ist iMode&0x0100 != 0 dann ist der Text UTF8 kodiert.
//				  Ist iMode&0x1000 != 0 dann ist der nderntext UTF8 kodiert.
//	Ergibt 1 wenn pText gefunden sontst 0.
int	 CTextView::Replace(const char *pText,const char *pChange,int iMode)
{
UndoBlock	*pUndo;
uchar		*pUndoMem;
unsigned	 uChar;
char		 cBuffer[260];
int			 iFlagOld;
int			 iFirst;
int			 iDelta;
int			 iMark;
int			 iLoop;
int			 iKorX;
int			 iKorY;
int			 iPosX;
int			 iPosY;
int			 iOldX;
int			 iOldY;
int			 iMrkX;
int			 iMrkY;
int			 iSize;
int			 iVal;
int			 iCnt;
int			 iNew;
int			 iSel;
int			 iOff;


	iMark	= iMode&0x4000;
	iSel	= iMode&0x8000;

	if(!pChange)											// Alter nderntext
		{
			pChange=(char*)m_pChangeText;
		if(!pChange)return 0;

		iNew   =  0;
		iCnt   =  strlen(pChange);
		iMode &= ~0x3000;

		#ifdef USE_UTF8
		iMode |=  0x1000;
		#endif
		}
	else{													// Neuer nderntext
		iCnt   =  strlen(pChange);

		if(pChange==(char*)m_pChangeText)
			{
			iNew=0;
			}
		else{
			if(m_pChangeText)delete m_pChangeText;
			m_pChangeText = new uchar[iCnt+1];
			memcpy(m_pChangeText,pChange,iCnt+1);
			iNew=1;
			}
		}


	#ifdef	USE_UTF8

	#define INS_FLAGS	TEXT_IS_UTF8

	if(!(iMode&0x1000))										// ANSI zu UTF8 konvertieren
		{
		iSize = iCnt;
		for(iCnt=0,iOff=0;iOff<iSize;iOff++)
			{
			uChar = (uchar)pChange[iOff];
			iCnt += chartoutf8(cBuffer+iCnt,uChar);
			if(iCnt+4>=m_iMaxChars)break;
			}

		cBuffer[iCnt] = 0;
		iSize   = iCnt;
		pChange = cBuffer;
		}

	#else

	#define INS_FLAGS	0

	if(iMode&0x0100)										// UTF8 zu ANSI konvertieren
		{
		iSize = iCnt;

		for(iCnt=0,iOff=0;iOff<iSize;)
			{
			if(iCnt>=m_iMaxChars)break;
			iOff += utf8tochar(pChange+iOff,uChar);
			if(uChar>=256)uChar=255;
			cBuffer[iCnt]=uChar;
			iCnt += 1;
			}

		cBuffer[iCnt] = 0;
		iSize   = iCnt;
		pChange = cBuffer;
		}

	#endif

	iMode &= 0xFF;

	
	if(iCnt>0)												// Suchliste aktualisieren
		{
		FindUpdate((uchar*)pChange);
		}


//*****************************************************************************


	if(m_cNotChange)         								// Darf das Fenster gendert werden ?
		{
		MessageBeep(MB_ICONASTERISK);
		return 0;
		}


	iKorX  = (m_iFlags&FLAG_FIND_UPWARDS)?  TEXT_CURSOR_LEFT:TEXT_CURSOR_RIGHT;
	iKorX |= TEXT_UNDO;

	if(iMode<2)												// Das nchste gefundene ndern
		{
		if(iMode==1)iKorX=Find(pText,iMode&0x0300);
		if(m_iCursorY!=m_iMarkY)return 0;
		if(m_iCursorX==m_iMarkX)return 0;

		iVal = SelectionClear(1);

		TextInsert((uchar*)pChange,m_iCursorX,m_iCursorY,iKorX);

		pUndo	= m_aUndo+m_iUndoPos;						// Undo Daten speichern
		UndoAdd();

		        pUndo->cMode  = UNDO_DEL|UNDO_SETPOS;
		if(iVal)pUndo->cMode |= UNDO_2TRUNS;

		m_iRedrawFlags|=NZ_LINE;
		PrintColor(m_iCursorY);
		DrawView(1);

		return 1;
		}


//****************** Alles ndern *********************************************


	iOldX  = m_iCursorX;
	iOldY  = m_iCursorY;
	iPosX  = m_iCursorX;
	iPosY  = m_iCursorY;
	iMrkX  = m_iMarkX;
	iMrkY  = m_iMarkY;
	iFirst = 1;
	iLoop  = 0;
	iVal   = 0;

	if(m_iMarkOn)
		{
		SetCursor(m_iCursorX,m_iCursorY);
		}


	iFlagOld  =  m_iFlags;
	m_iFlags &= ~FLAG_FIND_UPWARDS;							// Zeilen nach unten durchlaufen

	for(;;)
		{
			iKorX=Find(pText,1|(iMode&0x0300));				// Text suchen
		if(!iKorX)break;

		if(!iFirst || m_iCursorX!=iOldX || m_iCursorY!=iOldY)
			{
			if(m_iCursorY==iOldY)							// Seiten Ende noch nicht erreicht
			if(m_iCursorX<=iOldX)iLoop++;
			if(m_iCursorY< iOldY)iLoop++;
			}

		iFirst = 1;

		if(iLoop>1)break;									// Bei 2. Durchlauf abbrechen

		iOldX = m_iCursorX;
		iOldY = m_iCursorY;

		if(iLoop)											// Bei Anfangasposition abbrechen
			{
			if(m_iCursorY==iPosY)
			if(m_iCursorX>=iPosX)break;
			if(m_iCursorY> iPosY)break;
			}

		iKorY = m_iCursorY;

		if(m_iCursorX<m_iMarkX)
			{
			iKorX = m_iCursorX;
			iOff  = m_iMarkX;
			}
		else{
			iOff  = m_iCursorX;
			iKorX = m_iMarkX;
			}


		if(m_pHookChangeText)								// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,iKorX,iKorY,m_cChanged))
				{
				break;
				}
			}

		if(iSel)											// Ist die Marke im Auswahlbereich
		if(!CheckRange(m_iCursorX,m_iCursorY) ||
		   !CheckRange(m_iMarkX-1,m_iMarkY ))
			{
			m_iCursorX++;
			continue;
			}

		TextCopy  (&pUndoMem,iKorX,iKorY,iOff,iKorY);
		TextClear (          iKorX,iKorY,iOff,iKorY);
		TextInsert((uchar*)pChange,iKorX,iKorY,TEXT_CURSOR_RIGHT|INS_FLAGS);

		pUndo=&m_aUndo[m_iUndoPos];							// Undo Daten speichern
		UndoAdd();

		m_cChanged		= 1;
		pUndo->sPoint.x = iKorX;
		pUndo->sPoint.y = iKorY;
		pUndo->sDelPt.x = m_iCursorX;
		pUndo->sDelPt.y = iKorY;
		pUndo->pData    = pUndoMem;
		pUndo->cMode    = UNDO_INS|UNDO_DEL|UNDO_SETPOS;
		iDelta			= m_iCursorX-iOff;

		if(iPosY==m_iCursorY && iPosX>iKorX)				// Einfhge Verschiebungen
			{
			iPosX += iDelta;
			}

		if(iSel && m_iAreaStopY==m_iCursorY && m_iAreaStopX>iKorX)
			{
			m_iAreaStopX += iDelta;
			}


		if((iMode&4) || m_iMarkOn)
			{
			if(m_iCursorX>0)								// Einen Buchstaben zurck
				{
				m_iCursorX--;
				}
			else if(m_iCursorY>0)
				{
				m_iCursorX=10000;
				m_iCursorY--;
				}
			}

		PrintColor(iKorY);
		if(iVal>=10000)break;
		iVal++;
		}

	if(iMark)												// Markierung wieder anzeigen
		{
		if(m_cAreaMode)
			{
			ExpandCheck(m_iAreaStartY);

			m_iCursorX = m_iAreaStartX;
			m_iCursorY = m_iAreaStartY;
			m_iMarkX   = m_iAreaStopX;
			m_iMarkY   = m_iAreaStopY;
			}
		else{
			ExpandCheck(m_iAreaStopY);

			m_iCursorX = m_iAreaStopX;
			m_iCursorY = m_iAreaStopY;
			m_iMarkX   = m_iAreaStartX;
			m_iMarkY   = m_iAreaStartY;
			}

		if(m_iMarkY!=m_iCursorY)
			{
			m_iMarkOn  = 2;
			}
		else if(m_iMarkX=m_iCursorX)
			{
			m_iMarkOn  = 1;
			}
		else{
			m_iMarkOn  = 0;
			}
		}

	m_iFlags		= iFlagOld;
	m_iRedrawFlags  = NZ_ALL;

	if(!iMark)PositionOk(iPosX,iPosY,0);

	DrawView(1);


return iVal;
}

//*****************************************************************************
//*
//*     ReplaceView
//*
//*****************************************************************************
//	Ruft Dialog-Fenster fr das ndern von Texten auf
//	Ist iMode&0x0100 != 0 dann ist der Text UTF8 kodiert.
//	Ist iMode&0x1000 != 0 dann ist der nderntext UTF8 kodiert.
void CTextView::OnRepalceView(){ReplaceView();}
int  CTextView::ReplaceView(const char *pText,const char *pChange,int iMode)
{
char		cTemp[260];
char		cText[260];
uchar	   *pPtr=0;
unsigned	uChar;
int			iRet;
int			iLen;
int			iOff;
int			iCnt;


	if(!pText)
		{
		if(m_iMarkOn==1)									// Einzeilige Marke
			 TextCopy(&pPtr,m_iCursorX,m_iCursorY,m_iMarkX,m_iMarkY,TEXT_IS_MODE);
		else TextCopy(&pPtr,m_iCursorX,m_iCursorY,0,0    ,TEXT_WORD|TEXT_IS_MODE);

		if(pPtr && *pPtr)pText=(char*)pPtr;
		if(pText==0     )pText=(char*)m_pFindText;

		iMode &= ~0x0300;

		#ifdef UNICODE
		iMode |=  0x0200;
		#endif
		}


	if(!pChange)
		{
		pChange=(char*)m_pChangeText;
		iMode &= ~0x3000;
		#ifdef USE_UTF8
		iMode |=  0x1000;
		#endif
		}
	else{
		if(pChange!=(char*)m_pChangeText)
			{
			if(m_pChangeText)delete m_pChangeText;

			iRet		  = strlen(pChange)+1;
			m_pChangeText = new uchar[iRet];

			memcpy(m_pChangeText,pChange,iRet);
			}
		}

	if(m_iCursorY!=m_iMarkY)								// In Auswahl ndern
			m_iFlags |=  FLAG_CHANGE_SELECTION;
	else	m_iFlags &= ~FLAG_CHANGE_SELECTION;

	SetRange();

	cTemp[0] = 0;

	if(pText==0)
		{
		pText="";
		iMode &= ~0x0300;
		#ifdef UNICODE
		iMode |=  0x0200;
		#endif
		}

	if(pChange)
		{
		iLen = strlcpy(cTemp,pChange,sizeof(cTemp));

		if(iMode&0x1000)									// UTF8 in ANSI konvertieren
			{
			for(iOff=0,iCnt=0;iOff<iLen;)
				{
				iOff += utf8tochar(cTemp+iOff,uChar);
				if(uChar>=256)uChar=255;
				cTemp[iCnt]=uChar;
				iCnt+=1;
				}

			cTemp[iLen]=0;
			}
		}



	iLen = strlcpy(cText,pText,sizeof(cText));

	if(iMode&0x0100)										// UTF8 in ANSI konvertieren
		{
		for(iOff=0,iCnt=0;iOff<iLen;)
			{
			iOff += utf8tochar(cText+iOff,uChar);
			if(uChar>=256)uChar=255;
			cText[iCnt]=uChar;
			iCnt+=1;
			}

		cText[iLen]=0;
		}



	iRet = m_sChngeDlg->DoModal(this,cText,sizeof(cText),cTemp,sizeof(cTemp),m_iFlags,(char*)m_pFindSelection);

	SetCursorMode();

	if(pPtr)delete pPtr;


return iRet;
}

//*****************************************************************************
//*
//*     Menu????
//*
//*****************************************************************************
//	Funktionen zum ein/ausschalten von Men Funktionen
void CTextView::OnMenuSelection(CCmdUI *pCmdUI){pCmdUI->Enable(m_iMarkOn             ); }
void CTextView::OnMenuUndo     (CCmdUI *pCmdUI){pCmdUI->Enable(m_iUndoMin!=m_iUndoPos);	}
void CTextView::OnMenuUndoBack (CCmdUI *pCmdUI){pCmdUI->Enable(m_iUndoMax!=m_iUndoPos);	}
void CTextView::OnMenuFind     (CCmdUI *pCmdUI){pCmdUI->Enable(m_pFindText!=0        ); }
void CTextView::OnMenuClipboard(CCmdUI *pCmdUI){pCmdUI->Enable(!m_cNotChange && IsClipboardFormatAvailable(CF_TEXT)); }
#ifdef 		USE_DICIONARY
void CTextView::OnMenuDicOn    (CCmdUI *pCmdUI){pCmdUI->SetCheck((m_iDicFlags&FLAG_DICON)? 1:0);}
#endif

//*****************************************************************************
//*
//*     StatusbarSet
//*
//*****************************************************************************
//	Aktualisiert die Statuszeile
int CTextView::StatusbarSet()
{
char		 cText[256];
char		 cTemp[ 64];
char		*pInfo;
int			 iPos;


	if(!m_cFocusOn      )return 0;
	if(!m_cStatusbarInit)return 0;

	if(m_pHookStatusbarText)
		{
		iPos=m_pHookStatusbarText(this,m_pHookStatusbarTextParam,m_iCursorX,m_iCursorY,m_iStatusbarCode,cText);
		if(iPos==m_iStatusbarCode)return 0;
		m_iStatusbarCode=iPos;
		}
	else{
		iPos = (m_iCursorX<<2)|(m_iCursorY<<16)|(m_iCursorMode&3);
		if(iPos==m_iStatusbarCode)return 0;
		m_iStatusbarCode=iPos;

		strcpy(cText," Zeile: "  );	itoa(m_iCursorY+1,cTemp,10);
		strcat(cText,cTemp       );
		strcat(cText,"  Spalte: ");	itoa(m_iCursorX+1,cTemp,10);
		strcat(cText,cTemp       );

		if(m_iMarkOn)
			{
			if(m_iMarkY==m_iCursorY)
				{
				pInfo="X:";
				iPos=m_iMarkX-m_iCursorX;
				if(iPos<0)iPos=-iPos;
				}
			else{
				pInfo="Y:";
				iPos=m_iMarkY-m_iCursorY;
				if(iPos<0)
					{
					iPos=-iPos;
					if(m_iCursorX>0)iPos++;
					}
				else{
					if(m_iMarkX>0)iPos++;
					}
				}

			sprintf(cTemp," (%s%i)",pInfo,iPos);
			strcat (cText,cTemp);
			}
		}


	STATUSBAR_SET(0,cText,true);
	STATUSBAR_SET(1,(m_iCursorMode&1)? "Einf.":"ber.",true);


return 1;
}

//*****************************************************************************
//*
//*     StatusbarInit
//*
//*****************************************************************************
//	Erzeugt eine neue Statuszeile
int CTextView::StatusbarInit()
{
INT		aSize[] = {-22,-4};
INT		aId  [] = {0,0};


	STATUSBAR_INIT(aId,aSize,2);

	m_iStatusbarCode = -1;
	m_cStatusbarInit =  1;

	StatusbarSet();
	SetTimer(ID_STATUSBARSET,STB_TIMER,0);


return 1;
}

//*****************************************************************************
//*
//*     StatusbarExit
//*
//*****************************************************************************
//	Erzeugt eine neue Statuszeile
int CTextView::StatusbarExit()
{

	STATUSBAR_INIT(0,0,0)

	KillTimer(ID_STATUSBARSET);
	m_cStatusbarInit	=  0;
	m_iStatusbarCode	= -1;


return 1;
}

//*****************************************************************************
//*
//*     LineLength
//*
//*****************************************************************************
//	Ergibt die Lnge einer Zeile in Spalten (nicht in Bytes)
int CTextView::LineLength(int iLine)
{
TextLine  *pLine;


	if(iLine>=m_iLineCount)return 0;

	pLine =GetLine(iLine);


return pLine->uEnd;
}

//*****************************************************************************
//*
//*     ColorView
//*
//*****************************************************************************
//	ffnet einen Dialog zum ndern einer Farbe
//	Ergibt IDOK wenn Farbe gendert wurde
int CTextView::ColorView()
{
CAnsiColorDlg	sDlg(this);
TextLine 	   *pLine;
uchar	 	   *pPtr;
int				iRet;
int				iLen;
int				iCol;


	iCol	= 0;
	pLine	= 0;

	if(m_iCursorY<m_iLineCount)							// Farbe suchen
	do	{
		pLine = GetLine(m_iCursorY);					// Zeilendaten
		iLen  = pLine->uSize;
		pPtr  = pLine->pColors;

		if(m_iColorMode>=0)								// Fixe Farben
			{
			iCol=m_iColorMode;
			if(!m_pColumColors && !pPtr)break;			// Farben Zeile
			if(!pPtr)pPtr=m_pColumColors;
			}

		if(iLen<=0 || !pPtr)
			{
			iCol=pLine->bColor;
			break;
			}

		iRet = TextPosition(m_iCursorX,pLine->aText,iLen);

		if(iRet>=iLen && iLen>0)iRet=iLen-1;

		iCol=pPtr[iRet];

		}while(0);

														// Dialog zum Farben verndern aufrufen
	iRet = sDlg.DoModal(m_pGroup->pColorList,m_pGroup->hFont,iCol,(m_cConfigName[0])? m_cColorList:NULL);

	SetCursorMode();

	if(iRet==IDOK)
		{
		ColorSave();
		RedrawGroup();
		}


	if(m_iColorMode>=0)									// Fixe Farben
		{
		iCol = m_iColorMode;

		if(m_pColumColors && !pLine->pColors)			// Farbenzeile
			{
			pPtr = m_pColumColors;
			}
		}


return iRet;
}

//*****************************************************************************
//*
//*     SetTabSize
//*
//*****************************************************************************
//	Stellt eine neue Tabulatorbreite  ein.
//  iWidth		: Ist die neue Breite zwischen 1 und 32.
//	Ergibt die alte Tabulatorbreite.
int CTextView::SetTabSize(int iWidth)
{
int iOld;


	iOld = m_iTabWidth;

	if(iWidth<1 || iWidth>32 || m_iTabWidth==iWidth)return iOld;

	m_iTabWidth = iWidth;

	UpdateGroup(1);
	RedrawGroup();

	m_iFlags |= FLAG_CONFIG_SAFE;


return iOld;
}

//*****************************************************************************
//*
//*     SetFlags
//*
//*****************************************************************************
//	Setzt diverse Flags fr das Fenster
//	iFlags		: Sind die Werte fr die neuen Flags.
//					FLAG_VIRTUAL_SCREEN		: Cursor kann berall stehen
//					FLAG_LINE_MARK		 	: Zeilenweise Markieren
//					FLAG_INSERT_BEFOR	 	: Hinter Cursor einfgen
//					FLAG_BRACKET      	 	: Nach Klammern suchen
//					FLAG_BRACKET_MODE	 	: Klammern bereichsweise markieren
//					FLAG_CONFIG_SAFE     	: Konfiguration gendert
//					FLAG_FIND_CASE			: Gro/Kleinschreibung ignorieren
//					FLAG_FIND_UPWARDS       : Abwrts suchen
//					FLAG_FIND_ALL    		: Die gesammte Datei Durchsuchen
//					FLAG_FIND_WORD     		: Ganze Wrter suchen
//					FLAG_FIND_EXPRESSION 	: Nach Ausdrcken mit * und ? suchen
//					FLAG_MARK_TO_END	 	: Bis zum Zeilenende markieren
//					FLAG_LINENUMBERS        : Zeilennummern anzeigen
//					FLAG_WORDMARK_TYPE		: Ausgewhlte Wrter hervorheben
//					FLAG_WORD_JMP_MISC		: Auch diversen Zeichen anhalten.
//					FLAG_WORD_JMP_FIRST		: Nur am Beginn eines Wortes/Bereichs anhalten.
//					FLAG_WORD_JMP_UPPER		: Auch Gro/Kleinbergngen anhalten.
//					FLAG_WORD_JMP_UNTER		: Das '-' nicht als Buchstaben betrachten.
//	iMask		: Ist die Maske mit den Flags die Verndert werden drfen.
//	Ergibt den zuvor eingestellten Flags.
int CTextView::SetFlags(int iFlags,int iMask)
{
int		iOld,iChanged;



	iOld	= m_iFlags;
	iFlags &= iMask;
	iFlags |= iOld&~iMask;


		iChanged=(m_iFlags^iFlags)&iMask;
	if(!iChanged)return iOld;

	if(iChanged&FLAG_LINENUMBERS)						// Zeilennummern am linken Rand
		{
		SetMargin((iFlags&FLAG_LINENUMBERS)? m_iTextMargin:0);
		}

	if(iChanged&(FLAG_LINE_MARK|FLAG_BRACKET|FLAG_LINENUMBERS))
		{
		m_cBracketOn=0;
		RedrawGroup();
		}

	#ifdef USE_WORD_HIGHLIGHT
														// Farben der hervorgehobenen Wrter lschen
	if((iChanged&FLAG_FIND_HIGHLIGHT) && m_ucHighlightChar)
		{
		WordHighlight("",0);
		}

	#endif

	#ifdef USE_MARK_HIGHLIGHT

	if((iChanged&FLAG_WORDMARK_TYPE))					// Farben der markierten Wrter lschen
		{
		MarkHighlight("",0);
		m_ucWordMarkTicker = 1;
		}

	#endif


	if(iChanged&(FLAG_WORD_JMP_MISC|FLAG_WORD_JMP_FIRST|FLAG_WORD_JMP_UPPER|FLAG_WORD_JMP_UNTER))
		{
		if(iFlags&FLAG_WORD_JMP_UNTER)
			{
			m_iKeyStepMask =iKeyMaskDefaultUl;

			if(iFlags&FLAG_WORD_JMP_MISC)
				{
				m_iKeyStepMask|=iKeyMaskExtentedUl;
				}
			}
		else{
			m_iKeyStepMask =iKeyMaskDefault;

			if(iFlags&FLAG_WORD_JMP_MISC)
				{
				m_iKeyStepMask|=iKeyMaskExtented;
				}
			}

		if(iFlags&FLAG_WORD_JMP_UPPER)m_iKeyStepMask |= iKeyMaskUpperCase;
		if(iFlags&FLAG_WORD_JMP_FIRST)m_iKeyStepMask &= iKeyMaskFirst;
		}

	m_iFlags  &= ~iMask;
	m_iFlags  |=  iFlags|FLAG_CONFIG_SAFE;


return iOld;
}

//*****************************************************************************
//*
//*     SetModify
//*
//*****************************************************************************
// 	Setzt das Gendert-Flag
//	iNew		: Ist der neue Wert fr das Flag.
//	Ergibt alten Zustand des Flags
BOOL CTextView::SetModify(BOOL iNew)
{
int  iOld;


	iOld		= m_cChanged;
	m_cChanged	= iNew;


return iOld;
}

//*****************************************************************************
//*
//*     SetCanModify
//*
//*****************************************************************************
// 	Einstellen ob der Text gendert werden darf
//	iNew		: Ist der neue Wert fr das Flag.
//	Ergibt alten Zustand des Flags.
BOOL CTextView::SetCanModify(BOOL iNew)
{
int  iOld;


	iOld			= !m_cNotChange;
	m_cNotChange	= !iNew;


return iOld;
}

//*****************************************************************************
//*
//*     GetSelection
//*
//*****************************************************************************
// 	Ergibt die Position der Marke
//  Wenn nichts makiert ist die Cursor Position
CPoint CTextView::GetSelection()
{


	if(!m_iMarkOn)return GetCursor();


return CPoint(m_iMarkX,m_iMarkY);
}

//*****************************************************************************
//*
//*     SetSelection
//*
//*****************************************************************************
// 	Stellt die Marke ein.
//	sPos,iPsoX/iPsoY	: Ist die Position bei der die Marke beginnt.
//  Ergibt die alte Markenposition
CPoint CTextView::SetSelection(CPoint sPos){return SetSelection(sPos.x,sPos.y);}
CPoint CTextView::SetSelection(int iPosX,int iPosY)
{
CPoint	sOld;


	sOld = (m_iMarkOn)? CPoint(m_iMarkX,m_iMarkY):GetCursor();
	SetCursor(iPosX,iPosY,1);


return sOld;
}

//*****************************************************************************
//*
//*		SetTextMargin
//*
//*****************************************************************************
//	Stellt die Standartbreite fr den Rand ein (1-256)
//	iWidth		: Ist die neue Breite.
//	Ergibt die alte Breite des Randes.
int CTextView::SetTextMargin(int iWidth)
{
int	iOld;


	iOld = m_iTextMargin;

	if(iWidth <  1 )iWidth=1;
	if(iWidth >256 )iWidth=256;
	if(iWidth==iOld)return iOld;

	if(m_iFlags&FLAG_LINENUMBERS)
		{
		SetMargin(m_iTextMargin);
		}


return iOld;
}


//*****************************************************************************
//*
//*     UndoSave
//*
//*****************************************************************************
// 	Speichert einige Zeilen im Undo-Speicher
//	Diese Funktion nur in Verbindung mit UndoLoad(...) verwenden.
//	iLine1		: Ist die erstste Zeile des Bereiches.
//	iLine2		: Ist die letzte  Zeile des Bereiches.
//	Ergibt die Anzahl der gespeicheren Zeilen.
int CTextView::UndoSave(int iLine1,int iLine2)
{
UndoBlock  *pUndo;
int			iTemp;



	if(m_cNotChange)return 0; 							// Darf Fenster gendert werden ?

	if(iLine1>m_iLineCount)iLine1=m_iLineCount;
	if(iLine2>m_iLineCount)iLine2=m_iLineCount;
	if(iLine1<0           )iLine1=0;
	if(iLine2<0           )iLine2=0;
	if(iLine2< iLine1     ){iTemp=iLine1;iLine2=iLine1;iLine1=iTemp;}
	if(iLine2==iLine1     )return 0;

	pUndo			= m_aUndo+m_iUndoPos;				// Undo-Info
	UndoAdd();
	pUndo->sPoint.x	= 0;
	pUndo->sPoint.y	= iLine1;
	pUndo->sDelPt.x	= 0;
	pUndo->sDelPt.y	= iLine2;
	pUndo->cMode	= UNDO_INS|UNDO_2TRUNS;
	pUndo->cChanged	= m_cChanged;

	TextCopy(&pUndo->pData,0,iLine1,0,iLine2,TEXT_IS_DEF);


return iLine2-iLine1;
}

//*****************************************************************************
//*
//*     UndoLoad
//*
//*****************************************************************************
// 	Makiert einen Bereich fr den Undo-Speicher als zum Ersetzen mit dem
//	vorhergehenden UNDO_INS - Kommando. Siehe UndoSave(...)
//	iLine1		: Ist die erstste Zeile des Bereiches.
//	iLine2		: Ist die letzte  Zeile des Bereiches.
//	Ergibt die Anzahl der markierten Zeilen.
int CTextView::UndoLoad(int iLine1,int iLine2)
{
int			iTemp;
UndoBlock  *pUndo;



	if(m_cNotChange)return 0; 							// Darf Fenster gendert werden ?

	if(iLine1>m_iLineCount)iLine1=m_iLineCount;
	if(iLine2>m_iLineCount)iLine2=m_iLineCount;
	if(iLine1<0           )iLine1=0;
	if(iLine2<0           )iLine2=0;
	if(iLine2< iLine1     ){iTemp=iLine1;iLine2=iLine1;iLine1=iTemp;}
	if(iLine2==iLine1     )return 0;

	pUndo			= m_aUndo+m_iUndoPos;				// Undo-Info
	UndoAdd();
	pUndo->sPoint.x	= 0;
	pUndo->sPoint.y	= iLine1;
	pUndo->sDelPt.x	= 0;
	pUndo->sDelPt.y	= iLine2;
	pUndo->cMode	= UNDO_DEL|UNDO_2TRUNS;
	pUndo->cChanged	= m_cChanged;


return iLine2-iLine1;
}

//*****************************************************************************
//*
//*     UndoClear
//*
//*****************************************************************************
// 	Lscht den gesammten Undo-Speicher.
void CTextView::UndoClear()
{
int iPos;


	for(iPos=0;iPos<TEXT_UNDO_MAX;iPos++)				// Undo Speicher lschen
		{
			   m_aUndo[iPos].cMode=0;
		if(   !m_aUndo[iPos].pData)continue;
		delete m_aUndo[iPos].pData;
			   m_aUndo[iPos].pData=0;
		}

	m_iUndoPos = 0;
	m_iUndoMin = 0;
	m_iUndoMax = 0;
}

//*****************************************************************************
//*
//*     UndoAdd
//*
//*****************************************************************************
// 	Erhht den Undo-Zeiger um eins
void CTextView::UndoAdd()
{
int iPos;



	if(m_iUndoPos==m_iUndoMax)							// Am Ende der Kette ?
		{
		m_iUndoPos = (m_iUndoPos+1)%TEXT_UNDO_MAX;
		m_iUndoMax =  m_iUndoPos;

		if(m_iUndoMax!=m_iUndoMin)return; 				// berlauf ?

		   m_aUndo[m_iUndoMin].cMode=0;					// Neue Position leeren
		   m_aUndo[m_iUndoMin].cChanged=1;
		if(m_aUndo[m_iUndoMin].pData)
			{
			delete m_aUndo[m_iUndoMin].pData;
				   m_aUndo[m_iUndoMin].pData=0;
			}

		m_iUndoMin = (m_iUndoMin+1)%TEXT_UNDO_MAX;

		return;
		}


	m_iUndoPos	= (m_iUndoPos+1)%TEXT_UNDO_MAX;			// Neue Position
	iPos		=  m_iUndoPos;

	while(iPos!=m_iUndoMax)								// Bis max alles lschen
		{
		   m_aUndo[iPos].cMode=0;
		if(m_aUndo[iPos].pData)
			{
			delete m_aUndo[iPos].pData;
				   m_aUndo[iPos].pData=0;
			}

		iPos = (iPos+1)%TEXT_UNDO_MAX;
		}

	m_iUndoMax =  m_iUndoPos;



}

//*****************************************************************************
//*
//*     Undo
//*
//*****************************************************************************
//	Rckgngig machen von nderungen.
//	iCount		: Ist die Anzahl der nderungen die rckgngig gemacht werden
//				  sollen. Wenn kleiner 0 dann rckgngig, wenn grer 0 dann
//				  dann wiederherstellen.
//	Ergibt die Anzahl der rckgenommen nderung.
int CTextView::Undo(int iCount)
{
UndoBlock  *pUndo;
UndoBlock	sUndo;
int			iDoLoop;
int			iTarget;
int			iBlock;
int			iMul2;
int			iLoop;
int			iNext;
int			iOldX;
int			iOldY;
int			iPos;
int			iNum;
int			iDir;
int			iAdd;
int			iVal;
int			iOff;
int			iOk;



	if(!iCount || m_cNotChange)return 0;

	iTarget	= (iCount>0);
	iLoop	= 0;
	iMul2	= 0;
	iPos	= 0;
	iNum	= 0;
	iDir	= 0;
	iAdd	= 0;

	while(iCount || iMul2 || iLoop)
		{
		iDoLoop = (iLoop && !iCount && !iMul2)? 1:0;

		if(!iTarget)
			{
			if(m_iUndoPos==m_iUndoMin)break;			// Falsche Position	?
			if(iCount)iCount++;
			iBlock = (m_iUndoPos+TEXT_UNDO_MAX-1)%TEXT_UNDO_MAX;
			iNext  =  iBlock;
			}
		else{
			if(m_iUndoPos==m_iUndoMax)break;			// Falsche Position	?
			if(iCount)iCount--;
			iBlock =  m_iUndoPos;
			iNext  = (m_iUndoPos+1)%TEXT_UNDO_MAX;
			}

		if(iBlock==m_iUndoMax)
			{
			m_iUndoPos = iNext;
			break;
			}


		if(m_pHookChangeText)							// Callback fr nderungen abfragen
			{
			if(!m_pHookChangeText(this,m_pHookChangeTextParam,pUndo->sPoint.x,pUndo->sPoint.y,m_cChanged))
				{
				break;
				}
			}


		pUndo		= m_aUndo+iBlock;					// Anfangsdaten
		sUndo.sPoint= pUndo->sPoint;
		sUndo.cMode	= pUndo->cMode&(UNDO_2TRUNS|UNDO_SETPOS);
		sUndo.pData	= 0;
		iOk			= 0;


		if(iDoLoop)										// Ganze Wrter wieder herstellen
			{
			if((iLoop&2) && CharType(pUndo->uOldChar)<2)break;
			if((iLoop&8) && CharType(pUndo->uNewChar)<2)break;
			if( iLoop&1)
				{
				     if(pUndo->uOldChar=='\t')iPos-=(iPos&0x3FFF)%m_iTabWidth-pUndo->sDelPt.x%m_iTabWidth;
				else if(pUndo->uOldChar!=' ' )break;
				}

			if(iLoop&4)
				{
				     if(pUndo->uNewChar=='\t')iPos+=(iAdd)? 4-(iPos&0x3FFF)%m_iTabWidth:0;
				else if(pUndo->uNewChar!=' ' )break;
				}

			if(iPos!=pUndo->sDelPt.x+(pUndo->sDelPt.y<<14))break;
			}

		m_iUndoPos = iNext;


		if(pUndo->cMode&UNDO_DEL)						// Einen Teil lschen
			{
			TextCopy(&sUndo.pData,
							pUndo->sPoint.x,pUndo->sPoint.y,
							pUndo->sDelPt.x,pUndo->sDelPt.y,TEXT_IS_DEF);
			TextClear(		pUndo->sPoint.x,pUndo->sPoint.y,
							pUndo->sDelPt.x,pUndo->sDelPt.y);

			PrintColor(pUndo->sPoint.y);

			sUndo.cMode |= UNDO_INS;

			iOldX = m_iCursorX;
			iOldY = m_iCursorY;

			PositionOk(pUndo->sPoint.x,pUndo->sPoint.y,0);

			if(iOldY!=m_iCursorY && (m_iRedrawFlags&(NZ_LINE|NZ_LINE_NEXT|NZ_LINE_CURSOR)))
				{
				if(m_iRedrawFlags&NZ_LINE_YY)
					{
					m_iRedrawFlags = NZ_ALL;
					}
				else if(!(m_iRedrawFlags&NZ_LINE_NEXT))
					{
					m_iRedrawFlags = NZ_LINE_NR|iOldY;
					}
				else if(m_iRedrawFlags==NZ_LINE_NEXT)
					{
					m_iRedrawFlags = NZ_LINE_FROM|iOldY;
					}
				else{
					m_iRedrawFlags = NZ_LINE_FROM|(iOldY-1);
					}
				}
			else if(iOldX!=m_iCursorX && (m_iRedrawFlags&NZ_LINE_CURSOR))
				{
				m_iRedrawFlags |= NZ_LINE;
				}


			iLoop = 0;
			iOk   = 1;
			}

		if(pUndo->cMode&UNDO_INS && pUndo->pData)		// Einen Teil einfgen
			{
			iOldX = m_iCursorX;
			iOldY = m_iCursorY;
			iVal  = TextInsert(pUndo->pData,pUndo->sPoint.x,pUndo->sPoint.y,TEXT_CURSOR_RIGHT|TEXT_IS_DEF);
			iOff  = pUndo->sPoint.y;					// Farben aktualisieren
			iVal += iOff;

			for(;;)
				{
				iOff=PrintColor(iOff);
				if(iOff>iVal)break;
				}

			sUndo.sDelPt.x	= m_iCursorX;
			sUndo.sDelPt.y	= m_iCursorY;
			sUndo.cMode	   |= UNDO_DEL;
			iLoop			= 0;
			iOk				= 1;

			if(pUndo->cMode&UNDO_SETPOS)				// Auf Zeichen setzen ?
				{
				PositionOk(pUndo->sPoint.x,pUndo->sPoint.y,0);
				}

			if(pUndo->cMode&UNDO_SETDEL)				// Auf Zeichen setzen ?
				{
				PositionOk(pUndo->sDelPt.x,pUndo->sDelPt.y,0);
				}


			if(iOldY!=m_iCursorY && (m_iRedrawFlags&(NZ_LINE|NZ_LINE_NEXT|NZ_LINE_CURSOR)))
				{
				if(m_iRedrawFlags&NZ_LINE_YY)
					{
					m_iRedrawFlags = NZ_ALL;
					}
				else if(!(m_iRedrawFlags&NZ_LINE_NEXT))
					{
					m_iRedrawFlags = NZ_LINE_NR|iOldY;
					}
				else if(m_iRedrawFlags==NZ_LINE_NEXT)
					{
					m_iRedrawFlags = NZ_LINE_FROM|iOldY;
					}
				else{
					m_iRedrawFlags = NZ_LINE_FROM|(iOldY-1);
					}
				}
			else if(iOldX!=m_iCursorX && (m_iRedrawFlags&NZ_LINE_CURSOR))
				{
				m_iRedrawFlags |= NZ_LINE;
				}
			}

		if(pUndo->cMode&UNDO_CHAR)						// Zeichen eingeben
			{
			iVal = m_iCursorMode;

			if(pUndo->cMode&UNDO_OVERWR)
					m_iCursorMode &= ~1;
			else	m_iCursorMode |=  1;

			PositionOk(pUndo->sDelPt.x,pUndo->sDelPt.y ,0);

			m_cUndoLocked = 1;
			CharInput(pUndo->uNewChar,0);
			m_cUndoLocked = 0;
														// Auf Zeichen setzen ?
			if(pUndo->cMode&UNDO_SETPOS ||(pUndo->cMode&UNDO_OVERWR && !iTarget))
				{
				PositionOk(pUndo->sDelPt.x,pUndo->sDelPt.y,0);
				}

			if(!iLoop)									// Ganze Wrter wieder herstellen
				{
				iDir = iTarget;

				if(!iTarget && pUndo->uOldChar==8)iDir=1;
				if( iTarget && pUndo->uNewChar==8)iDir=0;
				if(!iTarget && pUndo->uOldChar==7)iDir=1;
				if( iTarget && pUndo->uNewChar==7)iDir=0;

					 if(!iDir && (pUndo->uOldChar==' '||pUndo->uOldChar=='\t'))iLoop=1;
				else if(!iDir && (CharType(pUndo->uOldChar)>=2               ))iLoop=2;
				else if( iDir && (pUndo->uNewChar==' '||pUndo->uNewChar=='\t'))iLoop=4;
				else if( iDir && (CharType(pUndo->uNewChar)>=2               ))iLoop=8;

				if(iLoop)
					{
					m_iRedrawFlags|=NZ_LINE;

					iAdd  = (!iDir)? -1:1;
					iPos  = pUndo->sDelPt.x;
					iPos += pUndo->sDelPt.y<<14;

					if( pUndo->uOldChar==7 && !iTarget)iAdd=0;// Spezial Flle mit DEL Taste
					if((pUndo->uNewChar==7 || pUndo->uOldChar==7) && iTarget)
					if( pUndo->sDelPt.x==m_aUndo[m_iUndoPos].sDelPt.x)
					if( pUndo->sDelPt.y==m_aUndo[m_iUndoPos].sDelPt.y)
						{
						iAdd=0;
						}
					}
				}
			else{
				if((iLoop&1) && pUndo->uOldChar!=' ' && pUndo->uOldChar!='\t')iLoop=0;
				if((iLoop&2) && CharType(pUndo->uOldChar)<2                  )iLoop=0;
				if((iLoop&4) && pUndo->uNewChar!=' ' && pUndo->uNewChar!='\t')iLoop=0;
				if((iLoop&8) && CharType(pUndo->uNewChar)<2                  )iLoop=0;
				}

			iPos		   += iAdd;
			m_iCursorMode	= iVal;

			sUndo.cMode     = pUndo->cMode;
			sUndo.sDelPt	= pUndo->sPoint;
			sUndo.sPoint	= pUndo->sDelPt;
			sUndo.uNewChar	= pUndo->uOldChar;
			sUndo.uOldChar	= pUndo->uNewChar;
			iOk				= 1;
			}


		if(iOk)											// Daten bernehmen
			{
			if(pUndo->pData)delete pUndo->pData;

			if(iCount || iMul2 || !(pUndo->cMode&UNDO_2TRUNS))
					iMul2=0;
			else	iMul2=1;

			sUndo.cChanged	= m_cChanged;
			m_cChanged		= pUndo->cChanged;
			*pUndo			= sUndo;
			iNum		   += 1;
			}
		}


	PositionCheck(1);
	DrawView(1);


return iNum;
}

//*****************************************************************************
//*
//*		GetLineText
//*
//*****************************************************************************
//	Ergibt einen Zeiger auf den Zeilentext einer Zeile
//	uLine		: Nummer der Zeile.
//	pLen		: Wenn ungleich 0 dann wird dort die Zeilenlnge gespeichert
//	Ergibt den Zeiger auf den Zeilentext oder 0 bei einem Fehler.
char *CTextView::GetLineText(unsigned uLine,int *pLen)
{
TextLine	*pPtr;


	if(uLine>=(unsigned)m_iLineCount)
		{
		if(pLen)*pLen=0;
		return 0;
		}

	pPtr = m_pLineList[uLine];
	if(pLen)*pLen=pPtr->uSize;


return (char*)pPtr->aText;
}

//*****************************************************************************
//*
//*		GetLineText
//*
//*****************************************************************************
//	Ergibt einen Zeiger auf den Zeilentext einer Zeile (static Version)
//	pThisPtr	: Zeiger auf die Klasse
//	uLine		: Nummer der Zeile.
//	pLen		: Wenn ungleich 0 dann wird dort die Zeilenlnge gespeichert
//	Ergibt den Zeiger auf den Zeilentext oder 0 bei einem Fehler.
char *CTextView::GetLineText(void *pThisPtr,unsigned uLine,int *pLen)
{
CTextView   *pThis=(CTextView*)pThisPtr;
TextLine	*pPtr;


	if(uLine>=(unsigned)pThis->m_iLineCount)
		{
		if(pLen)*pLen=0;
		return 0;
		}

	pPtr = pThis->m_pLineList[uLine];
	if(pLen)*pLen=pPtr->uSize;


return (char*)pPtr->aText;
}

//*****************************************************************************
//*
//*     GetLine
//*
//*****************************************************************************
CTextView::TextLine  CTextView::m_sNullLine = {0,0,0,0 ,0,0,0, 0};
CTextView::TextLine *CTextView::GetLine(unsigned uLine)
{


	if(uLine>=(unsigned)m_iLineCount)return &m_sNullLine;


return m_pLineList[uLine];
}

//*****************************************************************************
//*
//*     PrintColor
//*
//*****************************************************************************
//	Schreib die Farbinformationen in den Farbspeicher der Zeilen.
//	iLine	 : Zeilennummer des Textes bei der begonnen wird.
//	Ergibt die Zeile bei der zum schreiben aufgehrt wurde.
int CTextView::PrintColor(int iLine)
{
unsigned char  *pText;
unsigned char  *pColor;
unsigned char  *pColData;
TextLine	   *pLine1;
TextLine	   *pLine2;
unsigned		uChar;
unsigned		uLast;
int				iColor;
int				iColorCnt;
int				iColorMode;
int				iColorNext;
int				iColorNew;
int				iColorNum;
int				iLastMode;
int				iNewFrom;
int				iChange;
int				iUpper;
int				iUntil;
int				iOnOff;
int				iBits;
int				iSize;
int				iMask;
int				iMode;
int				iLast;
int				iOff;
int				iNum;
int				iVal;
int				iLen;
int				iPos;
int				iCnt;
int				iAdd;


	pColData   = 0;
	iColorNext = 0;
	iColorNum  = 0;
	iColorCnt  = 0;

	if(m_pHookChangeLine)								// Zeilen Change Hook
		{
		m_pHookChangeLine(this,m_pHookChangeLineParam,iLine);
		}

	if(m_iColorMode!=-1)								// Fixe Farben fr jede Zeile
		{
		if(iLine<=m_iLineCount)return m_iLineCount+1;
		return 	iLine+1;
		}

	iNewFrom = iLine+1;									// Neuzeichen Grenzen

do	{
	if(iLine>=m_iLineCount)
		{
		if(iNewFrom<iLine)break;
		return iLine+1;
		}

	iPos		= 0;									// Grundeinstellung
	iCnt		= 0;
	iOnOff		= 0;
	iColorMode	= 0;
	iColorNew	= 0;
	iChange		= 0;
	iUntil		= 0;

	pLine1      = GetLine(iLine);						// Zeilendaten
	pText		= pLine1->aText;
	iSize		= pLine1->uSize;
	pColor		= pLine1->pColors;
	iLen		= iSize;


//*********************** Anfangsfarbe ****************************************


	if(iLine>0)
		{
		pLine2		= GetLine(iLine-1);					// Vorherige Zeile
		iColorNum	= pLine2->bColor;
		iOnOff     |= pLine2->bGroup&m_iGroupUntil;

		if(m_iGroupLines && pLine2->uSize)				// Zeilen mit '\\' Abschluss
		if(pLine2->aText[pLine2->uSize-1]==m_uGroupChar)
			{
			iOnOff |= pLine2->bGroup&m_iGroupLines;
			}

		if(iColorNum)
			{
			pColData	= m_pWordList[iColorNum-1];		// 1.Bis-Wort laden
			iColorNext	= pColData[WSO];				// 2.Bis-Wort Nummer
			iColorNew	= pColData[WFB];				// Farbe fr bis Wrter

			pColData	= m_pWordList[iColorNext+m_iUntilColors];// 2.Bis-Wort laden
			iColorNext	= pColData[WFB];				// Bis Farbe
			iColorCnt	= 0;							// Rest Lnge = 0
			iColorMode	= 4;							// Weiter ohne Zeilenende
			}
		}

	iColor = iColorNew;


//*********************** Zeichenschleife *************************************


	iOnOff	   |= m_aGroupOn ['\r'];					// Anfangszustand
	iLastMode	= m_aCharType['\r']|iOnOff;
	iLast	    = '\r';

	while(iLen>=0)
		{
		uChar	= (iLen)? *pText:'\n';
		iOnOff &= m_aGroupOff[iLast];					// Gruppe ausschalten
		iOnOff |= m_aGroupOn [uChar];					// Gruppe einschalten
		iMode   = m_aCharType[uChar];					// Art des Buchstaben
		iMode  |= iOnOff;
		iAdd	= 1;

		#ifdef USE_UTF8
		if(uChar>=0xC0)
			{
			iAdd=utf8tochar(pText,uChar);
			if(uChar>=256)uChar=255;
			}
		#endif


//*********************** Farbenart *******************************************


		switch(iColorMode)
			{
		case 1:	iColorCnt--;							// Einzelnes Wort + Zeichen
				if(iColorCnt >    0)break;
				if(iColorNext&iMode)break;				// Solage die Gruppe aktiv ist weiter machen

		case 2:	iColorNew=0;
				iColorMode=0;							// Fixfarben
				break;

		case 3:	if(iLen<=0)								// Bis Wort oder Zeilenende
					{
					iColorNew=0;
					iColorMode=0;
					break;
					}

		case 4:	if(iLen<=0 && pColData[WCH]>1)			// Abbrechen wenn kein Zeichen am Ende
					{
					uLast = pText[-1];

					#ifdef USE_UTF8
					if(uLast>=0x80)utf8prechar(pText,uLast);
					#endif

					if(iSize<=0 || uLast!=pColData[WCH])
						{
						iColorNew  = 0;
						iColorMode = 0;
						break;
						}
					}

				   iColorCnt--;							// Bis Wort ohne Zeilenende
				if(iColorCnt>0)break;
				if(iColorNext&iMode)					// Jump-Zeichen gefunden ?
				if(iLen>1 || !pColData[WCH])
					{
					iColorMode+=2;
					break;
					}

				if(m_uCaseMode)							// Stimmt Anfangszeichen
						iUpper=m_aCaseTable[uChar];
				else	iUpper=uChar;

				if(pColData[WBU]!=iUpper  )break;
				if(pColData[WAN]&iLastMode)break;		// Stimmt Vorzeichen
				if(pColData[WAM])						// Stimmt Vorzeichen
					{
					if(!(pColData[WAM]&iLastMode))break;
					}
				if(pColData[WNO])						// Stimmt Vorzeichen (alle)
					{
					if((pColData[WNO]^iLastMode)&pColData[WNO])break;
					}
				

				iOff=pColData[WLE];						// Wort Lnge
				if(iOff>iLen)break;						// Wort vergleichen
			 	if(CmpC(pColData+WBU+1,pText+iAdd,iOff-1,m_uCaseMode))break;

				if(pColData[WEM])						// Stimmt Wortende
					{
					#ifdef USE_UTF8

					uLast = pText[iOff+m_iCmpDiff];

					if(uLast>=0xC0)
						{
						utf8tochar(pText+iOff+m_iCmpDiff,uLast);
						if(uLast>=256)uLast=255;
						}

					#else

					uLast = pText[iOff];

					#endif

					uLast = (iLen-iOff>0)? uLast:'\n';
					iVal  = m_aCharType[uLast];
					if(!(pColData[WEM]&iVal))break;
					}

				iColorCnt	= iOff;						// Bei Einzelwort bis
				iColorMode  = 1;
				iColorNext  = 0;						// Keine Solange-Gruppe
				break;

		case 5:
		case 6:	iColorMode-=2;							// Jump-Zeichen berspringen
				break;
			}


//*********************** Farbenart neu prfen ********************************


		if(!iColorMode)
		do	{											// Gruppenfarbe
			if(m_iGroupColorsOn&iMode)
				{
				if(iMode&0x08){iColorNew=m_aGroupColors[0];iColorMode=2;}
				if(iMode&0x10){iColorNew=m_aGroupColors[1];iColorMode=2;}
				if(iMode&0x20){iColorNew=m_aGroupColors[2];iColorMode=2;}
				if(iMode&0x40){iColorNew=m_aGroupColors[3];iColorMode=2;}
				if(iMode&0x80){iColorNew=m_aGroupColors[4];iColorMode=2;}
				}

			if(m_aFixColors[uChar])						// Fixfarbe gefunden
				{
				iColorMode = 2;
				iColorNew  = m_aFixColors[uChar];
				}

			if(!m_aWordNum[uChar])break;				// Alle Wrter Prfen

			iNum  = m_aWordNum  [uChar];
			iOff  = m_aWordStart[uChar];

			for(;iNum;iNum--,iOff++)
				{
				pColData  = m_pWordList[iOff];			// Wort laden
				iColorCnt = pColData[WLE];				// Wortlnge

				if(pColData[WAN]&iLastMode)continue;	// Stimmt Vorzeichen
				if(pColData[WAM])						// Stimmt Vorzeichen
					{
					if(!(pColData[WAM]&iLastMode))continue;
					}
				if(pColData[WNO])						// Stimmt Vorzeichen (alle)
					{
					if((pColData[WNO]^iLastMode)&pColData[WNO])continue;
					}

				if(iColorCnt>1)							// Wort vergleichen
					{
					if(iColorCnt>iLen)continue;
					if(CmpC(pColData+WBU+1,pText+iAdd,iColorCnt-1,m_uCaseMode))
						{
						continue;
						}
					}

				if(pColData[WEM])						// Stimmt Wortende
					{
					#ifdef USE_UTF8

					uLast = pText[iColorCnt+m_iCmpDiff];

					if(uLast>=0xC0)
						{
						utf8tochar(pText+iColorCnt+m_iCmpDiff,uLast);
						if(uLast>=256)uLast=255;
						}

					#else

					uLast = pText[iColorCnt];

					#endif

					uLast = (iLen-iColorCnt>0)? uLast:'\n';


					iVal  = m_aCharType[uLast];
					if(!(pColData[WEM]&iVal))continue;
					}

				iColorNum	= iOff+1;
				iColorMode  = pColData[WAR];			// Art laden
				iColorNew	= pColData[WFB];			// Farbe laden
				iColorNext  = pColData[WSO];			// Bis-Wort Nummer
				iOnOff	   |= pColData[WGE];			// Gruppe einschalten
				iOnOff     &= pColData[WGA];			// Gruppe ausschalten
				iMode	   &= pColData[WGA];
				iMode	   |= iOnOff;

				if(iColorMode<3)break;					// Bis Wrter ?
				pColData	= m_pWordList[iColorNext+m_iUntilColors];
				iColorNext  = pColData[WSO];			// Jump-Zeichen
				break;
				}

			}while(0);


//*********************** Zeilenende Farbe prfen *****************************


		pText    += iAdd;								// Nchstes Zeichen
		iLen     -= iAdd;
		iLast	  = uChar;
		iLastMode = iMode;

		if(iLen<0)										// Prfe ob Gruppe weitergeht
			{
			iBits = m_aGroupOff['\n'];
			iMask = m_iGroupUntil;

			if(m_iGroupLines)
				{
				iMask |= m_iGroupLines;

				if(iSize>0)
					{
					uChar  = pText[-1-iAdd];

					#ifdef USE_UTF8
					if(uChar>=0x80)utf8prechar(pText-iAdd,uChar);
					#endif

					if(uChar==m_uGroupChar)
							iBits  |=  m_iGroupLines;
					else	iOnOff &= ~m_iGroupLines;
					}
				else{
					iOnOff &= ~m_iGroupLines;
					}
				}

			iOnOff &= iBits;							// Gruppe ausschalten
			iOnOff &= iMask;

			if((pLine1->bGroup^iOnOff)&iMask)
				{
				pLine1->bGroup &= ~iMask;
				pLine1->bGroup |=  iOnOff;
				iUntil=1;
				}

			if(iColorMode != 4)iColorNum=0;				// Prfe ob Farbe weitergeht
			if(pLine1->bColor!=iColorNum)
				{
				pLine1->bColor =iColorNum;
				iUntil		   =1;
				}

			break;
			}


//*********************** Farbe eintagen **************************************


		if(iColorNew!=iColor)
			{
			if(!pColor)									// Neuen Farbspeicher erzeugen
				{
				ASSERT((unsigned)iSize==pLine1->uSize);
				pColor=new uchar[(iSize+15)&~0x0F];
				pLine1->pColors = pColor;
				memset(pColor,iColor,iPos);
				if(iSize)pColor[0]=0xFF;
				}

			iColor  = iColorNew;
			iChange = 1;
			}

		if(pColor)
			{
			if(iChange!=2 && pColor[iPos]!=iColor)
				{
				if(m_iCursorY==iLine)
						DrawViewCursorLine();
				else	DrawViewLine(iLine);

				iChange=2;
				}

			ASSERT((unsigned)(iPos+iAdd)<=pLine1->uSize);

			pColor[iPos]=iColor;

			while(iAdd>1)
				{
				iAdd--;
				iPos++;
				pColor[iPos]=iColor;
				}
			}

		iPos++;
		}


//*********************** Wrterbuch ******************************************


	#ifdef USE_DICIONARY

	if(PrintDicionary(iLine))							// Wrterbuch
		{
		if(iChange!=2)
			{
			if(m_iCursorY==iLine)
				{
				m_iRedrawFlags |= NZ_LINE;
				}
			else{
				DrawViewLine(iLine);
				}

			iChange=2;
			}
		else{
			iChange=1;
			}
		}

	#endif

	if(!iChange && pColor)
		{
		delete  pColor;
		pLine1->pColors=0;
		}

	iLine++;
	}while(iUntil);


//*****************************************************************************


	if(iLine>iNewFrom)									// Neu Zeichengrenzen
	do	{
		iNum = (iLine-1==iNewFrom)? NZ_LINE_NR:NZ_LINE_FROM;

		if(!(m_iRedrawFlags&NZ_LINE_YY))
		   {
		   m_iRedrawFlags |= iNum|iNewFrom;
		   break;
		   }

		iVal = m_iRedrawFlags&NZ_LINE_XX;

		if(m_iRedrawFlags&NZ_LINE_NR)
			{
			if(iVal==iNewFrom && iNum==NZ_LINE_NR)break;
			if(iVal >iNewFrom)iVal=iNewFrom;

			m_iRedrawFlags &= ~NZ_LINE_XX;
			m_iRedrawFlags |=  NZ_LINE_FROM|iVal;

			continue;
			}

		if(m_iRedrawFlags&NZ_LINE_FROM)
			{
			if(iVal<=iNewFrom)break;

			m_iRedrawFlags &= ~NZ_LINE_XX;
			m_iRedrawFlags |=  NZ_LINE_FROM|iNewFrom;
			}

		m_iRedrawFlags= NZ_ALL;

		}while(0);


return iLine;
}

//*****************************************************************************
//*
//*     PrintLine
//*
//*****************************************************************************
//	Eine Zeile auf den Schirm zeichnen.
//	hDc		: Gertekontext
//	pRect	: Pixelkoordinaten des Bereiches
//	iLine	: Zeilen-Nummer des Textes
//	iStart	: Startzeichen in der Zeile (Spalte)
//	iSize	: Anzahl der auszugebenden Zeichen (Anzahl der Spalten)
//	iFlags  : Diverse Bits fr die Zeile
//				Bit0	  = Ist fr die die Ausgabe auf einem Drucker bei einem Aufruf aus OnPrint()
//				Bit1	  = Ist es nicht das aktive Feld bei TO_ANSISPLIT
//				Bit8..9   = Ist die Feldnummer bei TO_ANSISPLIT
//				Bit12..31 = Ist der X-Ursprung fr Tabulatoren
//			  iFlags muss an ColorChose weiter gegeben werden !
//	Ergibt die letzte Koordinate in Zeichen der ausgegeben Zeile.
int CTextView::PrintLine(HDC hDc,RECT *pRect,int iLine,int iStart,int iSize,int iFlags)
{
unsigned short	aColors[TEXT_CHARS_MAX+4];
unsigned char  *pText;
unsigned char  *pData;
unsigned char  *pColor;
TextLine	   *pLine1;
TextLine	   *pLine2;
CRect			sArea;
unsigned		uSign;
int				iMarkStop;
int				iMarkStart;
int				iColorStart;
int				iColorNow;
int				iChars;
int				iBase;
int				iTab;
int				iVal;
int				iEnd;
int				iLen;
int				iNow;
int				iPos;



	if(iLine>=m_iLineCount)return 0;
	if(iSize<=0           )return 0;


	iNow		= 0;
	iPos		= 0;
	iColorStart	= 0;
	pLine1		= GetLine(iLine);
	pText    	= pLine1->aText;
	iLen     	= pLine1->uSize;
	pColor		= pLine1->pColors;


	#ifndef 	TO_TEXTWND

	if(iFlags&1)
		{
		iTab	=  m_sPrinterData.iFontSizeX*m_iTabWidth;
		}
	else
	#endif
		{
		iTab	=  m_iFontSizeX*m_iTabWidth;
		}


//*********************** Anfangsfarbe ermitteln ******************************


	if(m_iColorMode>=0)									// Fixe Farben
		{
		iColorStart	= m_iColorMode;

		if(m_pColumColors && !pColor)					// Farbenzeile
			{
			pColor = m_pColumColors;
			}

		if(pColor)iColorStart=pColor[0];
		}
	else{												// Variable Farben
		if(iLine>0 && m_iColorMode==-1)
			{
			pLine2		= GetLine(iLine-1);				// Vorherige Zeile
			iColorStart	= pLine2->bColor;

			if(iColorStart)								// 1.Bis-Wort laden
				{	
				pData		= m_pWordList[iColorStart-1];	
				iColorStart = pData[WFB];				// Farbe am Zeilenanfang
				}
			}
		}


//********************** Prfe ob Cursor vor Marke ****************************

	#ifdef USE_WORD_HIGHLIGHT

	int		iHigh=0;

	#endif

	#ifdef USE_MARK_HIGHLIGHT

	int		iMark=0;
	#define NOT_MARK	&& !iMark

	#else

	#define NOT_MARK

	#endif


do	{
	iMarkStart = 100000;
	iMarkStop  = 100000;
																			
	#ifndef TO_TEXTWND
	if(iFlags&1)break;									// Keine Marke beim Drucken
	#endif

	if(m_iCursorY==m_iMarkY)							// Einzeilige Marke
		{
		if(iLine!=m_iCursorY ||	m_iMarkX==m_iCursorX)	// Andere Zeile ?
			{
			break;
			}

		if(m_iMarkX<m_iCursorX)
			{
			iMarkStart = m_iMarkX;
			iMarkStop  = m_iCursorX;
			break;
			}
		else{
			iMarkStart = m_iCursorX;
			iMarkStop  = m_iMarkX;
			break;
			}
		}

	if(m_iMarkY<m_iCursorY)								// Marke vor Cursor
		{
		if(iLine<m_iMarkY || iLine>m_iCursorY)
			{
			break;
			}

		if(!(m_iFlags&FLAG_LINE_MARK))
			{
			if(iLine==m_iMarkY)
				{
				iMarkStart = m_iMarkX;
				break;
				}

			if(iLine==m_iCursorY)
				{
				iMarkStart = 0;
				iMarkStop  = m_iCursorX;
				break;
				}
			}

		iMarkStart = 0;
		}
	else{												// Marke nach Cursor
		if(iLine<m_iCursorY || iLine>m_iMarkY)
			{
			break;
			}

		if(!(m_iFlags&FLAG_LINE_MARK))
			{
			if(iLine==m_iMarkY)
				{
				iMarkStart = 0;
				iMarkStop  = m_iMarkX;
				break;
				}

			if(iLine==m_iCursorY)
				{
				iMarkStart = m_iCursorX;
				break;
				}
			}

		iMarkStart = 0;
		}
	}while(0);


//*********************** Vor Zeilenbegin *************************************


	for(;;)
		{
		if(iPos>=iStart || iNow>=iLen)					// Zeilenbegin oder Textende erreicht
			{
			iBase	= iNow;
			iChars	= 0;
			break;
			}

		uSign = pText[iNow];

		#ifdef USE_UTF8

		if(uSign>=0xC0)									// Ein UTF8 Zeichen dekodieren
			{
			iNow += utf8tochar(pText+iNow,uSign);
			iPos += 1;
			continue;
			}

		#endif


		if(uSign!=9)									// Normales Zeichen
			{
			iPos += 1;
			iNow += 1;
			continue;
			}

		iPos     +=      m_iTabWidth;					// Tabulator gefunden
		iPos     -= iPos%m_iTabWidth;

		if(iPos<=iStart)								// berspringt Tabulator den Zeilenbeginn
			{
			iNow++;
			continue;
			}

		iBase	= iNow;
		iChars	= 1;
		iNow   += 1;

		if(iPos>=iMarkStart)							// Wenn Marke aktiv dann Farbe wechseln
		if(iPos< iMarkStop )
		if(iPos!=iMarkStart || iPos<=iStart)
			{
			aColors[0] = COLOR_MARK;
			break;
			}

		iColorNow = iColorStart;

		if(m_cBracketOn && m_iBracketArea)				// Bei Klammermarkierung den Hintergund einfrben
			{
			if(m_iBracketArea<0)
				{
				iVal = iLine*0x4000+iPos;

				if(m_iBracketY*0x4000+m_iBracketX <= iVal)
				if(m_iCursorY *0x4000+m_iCursorX  >= iVal)
					{
					iColorNow |= m_iBracketColorEx<<8;
					}
				}
			else{
				iVal = iLine*0x4000+iPos;

				if(m_iBracketY*0x4000+m_iBracketX >= iVal)
				if(m_iCursorY *0x4000+m_iCursorX  <= iVal)
					{
					iColorNow |= m_iBracketColorEx<<8;
					}
				}
			}

		if(iPos>=iMarkStart)							// Wenn Marke aktiv dann Farbe wechseln
		if(iPos< iMarkStop )
		if(iPos!=iMarkStart || iPos<=iStart)
			{
			iColorNow = COLOR_MARK;
			}

		aColors[0] = iColorNow;

		break;
		}


//*********************** Buchstaben ausgeben *********************************


	
	iEnd = iStart+iSize;								// Letzte Spalte berechnen	
	

	for(;;)
		{
		if(iNow>=iLen || iPos>=iEnd)					// Textende erreicht
			{
			break;
			}


		uSign = pText[iNow];							// Nchstes Zeichen aus dem Text holen


		if(iPos>=iMarkStart && iPos<iMarkStop)			// Marke aktiv ?
			{
			iColorNow = COLOR_MARK;
			goto Done;
			}


		if(pColor)										// Pro Buchstabe eine Farbe
				iColorNow = pColor[iNow];
		else	iColorNow = iColorStart;
			

		if(m_cBracketOn)								// Bei Klammermarkierung den Hintergund einfrben
			{
			if(m_iBracketArea)
				{
				if(m_iBracketArea<0)
					{
					iVal = iLine*0x4000+iPos;

					if(m_iBracketY*0x4000+m_iBracketX <= iVal)
					if(m_iCursorY *0x4000+m_iCursorX  >= iVal)
						{
						iColorNow |= m_iBracketColorEx<<8;
						}
					}
				else{
					iVal = iLine*0x4000+iPos;

					if(m_iBracketY*0x4000+m_iBracketX >= iVal)
					if(m_iCursorY *0x4000+m_iCursorX  <= iVal)
						{
						iColorNow |= m_iBracketColorEx<<8;
						}
					}
				}
			else{										// Nur Klammern einfrben
				if(iLine==m_iCursorY  && iPos==m_iCursorX )iColorNow|=m_iBracketColor<<8;
				if(iLine==m_iBracketY && iPos==m_iBracketX)iColorNow|=m_iBracketColor<<8;
				}
			}


		#ifdef USE_WORD_HIGHLIGHT

		if(m_ucHighlightChar && (uSign&m_ucHighlightAnd)==m_ucHighlightChar && !iHigh NOT_MARK)
			{
			if((m_ucHighlightAnd==0xDF && !memicmp(pText+iNow,m_ucHighlightWord,m_ucHighlightSize)) ||
			   (m_ucHighlightAnd==0xFF && !memcmp (pText+iNow,m_ucHighlightWord,m_ucHighlightSize)))
			if(!m_ucHighlightMode || (CharType(pText[iNow+m_ucHighlightSize])<2 && (iNow<=0 || CharType(pText[iNow-1])<2)))
				{
				#ifdef USE_UTF8
				if(uSign>=0xC0)iMark=m_ucWordMarkSize-utf8tochar(pText+iNow,uSign);else 
				#endif 	

				iHigh      = m_ucHighlightSize-1;
				iColorNow &= 0x00FF;
				iColorNow |= COLOR_HIGH<<8;
				goto Done;
				}
			}
		else if(iHigh>0)								// Restliche Zeichen von Worthervorherbung
			{
			iColorNow &= 0x00FF;
			iColorNow |= COLOR_HIGH<<8;

			#ifdef USE_UTF8
			if(uSign>=0xC0)iHigh-=utf8tochar(pText+iNow,uSign);else 
			#endif 	

			iHigh--;
			goto Done;
			}

		#endif

		#ifdef USE_MARK_HIGHLIGHT

		if(m_ucWordMarkChar && (uSign&m_ucWordMarkAnd)==m_ucWordMarkChar && !iMark)
			{
			if((m_ucWordMarkAnd==0xDF && !memicmp(pText+iNow,m_ucWordMarkWord,m_ucWordMarkSize)) ||
			   (m_ucWordMarkAnd==0xFF && !memcmp (pText+iNow,m_ucWordMarkWord,m_ucWordMarkSize)))
			if(!m_ucWordMarkMode || (CharType(pText[iNow+m_ucWordMarkSize])<2 && (iNow<=0 || CharType(pText[iNow-1])<2)))
				{
				#ifdef USE_UTF8
				if(uSign>=0xC0)iMark=m_ucWordMarkSize-utf8tochar(pText+iNow,uSign);else 
				#endif 	

				iMark      = m_ucWordMarkSize-1;
				iColorNow &= 0x00FF;
				iColorNow |= COLOR_WORD<<8;
				goto Done;
				}
			}
		else if(iMark>0)								// Restliche Zeichen von Worthervorherbung
			{
			iColorNow &= 0x00FF;
			iColorNow |= COLOR_WORD<<8;

			#ifdef USE_UTF8
			if(uSign>=0xC0)iHigh-=utf8tochar(pText+iNow,uSign);else 
			#endif 	

			iMark--;
			}

		#endif


Done:

		aColors[iChars]	= iColorNow;
		iChars++;


		#ifdef USE_UTF8

		if(uSign>=0xC0)									// Ein UTF8 Zeichen dekodieren und gleich ausgeben
			{
			iNow    += utf8tochar(pText+iNow,uSign);
			iPos	+= 1;
			continue;
			}

		#endif

		if(uSign==9)									// Tabulator gefunden
			{
			iVal     = m_iTabWidth-(iPos%m_iTabWidth);
			iPos	+= iVal;
			iNow	+= 1;
			}
		else{											// Normales Zeichen
			iPos	+= 1;
			iNow	+= 1;
			}
		}


	iFlags &= ~0x0F00;

	#ifdef USE_UTF8

	iFlags |=  0x0400;									// Flag um UTF8 Zeichen auszugeben

	#endif 
	
	#ifdef USE_DICIONARY	

	iFlags |=  0x0800;									// Flag um Unterstreichen zu ermglichen

	#endif 	


//******************** Ende der Textausgabe ***********************************


	if(iMarkStart!=100000)								// Marke auf freiem Raum hinter dem Text
	if(iMarkStart< iEnd)
	if(iMarkStop >=iPos)
	if(m_iFlags&FLAG_VIRTUAL_SCREEN)
		{
		if(iPos<iStart)iPos=iStart;

		aColors[iChars] = 0;

		iVal		 = iPos-iStart;
		sArea.bottom = pRect->bottom;
		sArea.left	 = pRect->left;
		sArea.top	 = pRect->top;
		sArea.right	 = sArea.left+m_iFontSizeX*iVal;
														// Bis zur Marke zeichnen
		TabbedTextOutEx(hDc,&sArea,pText+iBase,aColors,iChars,iFlags|0x0200,m_iTabWidth);

		if(iMarkStop==100000 && !(m_iFlags&FLAG_MARK_TO_END))
			{
			iMarkStop = iPos+1;
			}

		if(iMarkStart>iPos)								// Leerraum nach Text und vor Marke zeichen
			{
			iVal		 = iMarkStart-iPos;
			sArea.left	 = sArea.right;
			sArea.right  = sArea.left+m_iFontSizeX*iVal;

			ColorChose (hDc,0,iFlags);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

			iPos = iMarkStart;
			}
		
		   iVal = iMarkStop-iPos;
		if(iVal+iPos>iEnd)iVal=iEnd-iPos;

		sArea.left	 = sArea.right;						// Die Marke zeichnen
		sArea.right += m_iFontSizeX*iVal;

		ColorChose (hDc,COLOR_MARK,iFlags);
		ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

		if(sArea.right<pRect->right)					// Leeraum nach Marke zeichnen
			{
			sArea.left	 = sArea .right;
			sArea.right  = pRect->right;

			ColorChose (hDc,0,iFlags);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			}

		return iSize; 
		}


//*********************** Marke oder Klammerbereich ber ganze Zeile **********

	
	iFlags |= 0x0200;									// Bis zum Ende ausmahlen
	aColors[iChars] = 0;

	if(iMarkStart!=100000 && iMarkStop==100000 && iPos<iEnd)
		{												// Marke prfen
		if(m_iFlags&FLAG_MARK_TO_END)
			{
			aColors[iChars]    = COLOR_MARK;
			}
		else{
			iFlags			  |= 0x0100;
			aColors[iChars  ]  = COLOR_MARK;
			aColors[iChars+1]  = 0;
			}
		}												// Klammerbereich prfen
	else if(m_cBracketOn && m_iBracketArea && m_iBracketY!=m_iCursorY && iPos<iEnd)				
		{
		if(m_iBracketArea<0)
			{
			iVal = (iLine>=m_iBracketY && iLine<m_iCursorY)? 1:0;
			}

		if(m_iBracketArea>0)
			{
			iVal = (iLine<m_iBracketY && iLine>=m_iCursorY)? 1:0;
			}

		if(iVal)
			{
			aColors[iChars] = m_iBracketColorEx;
			}
		}

														// Die Zeile zeichnen
	TabbedTextOutEx(hDc,pRect,pText+iBase,aColors,iChars,iFlags,m_iTabWidth);



return iSize; 
}

//*****************************************************************************
//*
//*     ConfigAccel
//*
//*****************************************************************************
//	Konfiguriert die Tastenkrzel. Der Pfad muss zuvor ber ColorConfig()
//	in m_pGroup->pConfig gespeichert werden.
//	Pfad ist die Untergruppe zum laden z.B "BAT" oder ".cpp"
//	Ist Pfad==0 so wird die aktuelle Konfiguration gelscht.
//	Fngt Pfad mit '.' and so wird Pfad aus der Registry geladen.
//	Ergibt 1 wenn der Pfad gefunden wurde.
int CTextView::ConfigAccel(const char *pPath)
{
char	 cBuffer[256];
char	*pName;
int		 iChar;
int		 iPos;
int		 iVal;
int		 iLen;


	for(iPos=0;iPos<='Z'-'0'+12;iPos++)					// Kurz Tasten lschen
		{
		if(   !m_aAccelNamen[iPos])continue;
		delete m_aAccelNamen[iPos];
			   m_aAccelNamen[iPos]=0;
		}

	if(!pPath)return 0;									// Tasten lschen


//****************** Konfiguration laden **************************************
CRegKeys	sKey;
char	   *pReg;


		pReg=m_pConfigPath;
	if(!pReg)pReg=m_pGroup->pConfig;
	if(!pReg)return 0;
	if(!sKey.Open(HKEY_LOCAL_MACHINE,pReg,CRK_READ))
	if(!sKey.Open(HKEY_CURRENT_USER ,pReg,CRK_READ))return 0;

	if(*pPath=='.')										// Pfad aus Schlssel laden
		{
		if(!sKey.Get(cBuffer,sizeof(cBuffer),pPath))return 0;
		strupr(cBuffer);
		pPath = cBuffer;
		}

	if(!sKey.Up(pPath  ))return 0;						// Sub - Schlssel
	if(!sKey.Up("Accel"))return 0;


	for(iVal=0;iVal<256;iVal++)							// Tasten suchen
		{
		pName = sKey.ValueName(iVal);

		if(!pName)break;
		if( sKey.Type()!=REG_SZ)continue;
		if(!sKey.Get(cBuffer,256,pName))break;
														// Tastenwert
		iChar = 0;

		if(cBuffer[0]== 0 )continue;
		if(cBuffer[1]!=':')continue;
		if(cBuffer[2]== 0 )continue;

		cBuffer[1]	= 0;
		iChar		= cBuffer[0];
		iPos		= strcspn(m_aAccelTab1,cBuffer);

		if(m_aAccelTab1[iPos])
			{
			iChar	= 'Z'+iPos+1;
			}
		else{
			if(iChar<'0')continue;
			if(iChar>'Z')continue;
			}

		iChar -= '0';
		iLen   = strlen(cBuffer+2)+1;					// Namen speichern

		if(m_aAccelNamen[iChar])delete m_aAccelNamen[iChar];
		   m_aAccelNamen[iChar]=new char[iLen];

		iLen = strtomem(m_aAccelNamen[iChar],iLen|STR_NOQUOTE,cBuffer+2);
		m_aAccelNamen[iChar][iLen]=0;
		}


return 1;
}


//*****************************************************************************
//*
//*		OnTextInfo
//*
//*****************************************************************************
LRESULT CTextView::OnTextInfo(WPARAM wParam,LPARAM lParam)
{
TextInfo   *pInfo;
CPoint		sPoint;
CSize		sSize;


	switch(wParam)
		{
	case ANSI_GETMARK:									// Marken-Position lesen

			sPoint=GetSelection();
			return MAKELONG(sPoint.x,sPoint.y);

	case ANSI_SETMARK:									// Marken-Position setzen

			sPoint=SetSelection((CPoint)lParam);
			return MAKELONG(sPoint.x,sPoint.y);

	case ANSI_SETFLAGS:									// Flags setzen

			pInfo=(TextInfo*)lParam;
			return SetFlags(pInfo->iMode,pInfo->iMask);

	case ANSI_GETFLAGS:									// Flags lesen

			return GetFlags();

	case ANSI_FIND:										// Text suchen

			pInfo=(TextInfo*)lParam;
			return Find(pInfo->pText,pInfo->iMode);

	case ANSI_REPLACE:									// Text ndern

			pInfo=(TextInfo*)lParam;
			return Replace(pInfo->pText,pInfo->pChange,pInfo->iMode);

	case ANSI_GETFONTSIZE:								// Schriftgre holen

			sSize=GetFontSize();
			return MAKELONG(sSize.cx,sSize.cy);

	case ANSI_SETTABSIZE:								// Tabulator-Breite setzen

			return SetTabSize(lParam);

	case ANSI_HIGHLIGHT:								// Suchwrter hervorheben

			#ifdef USE_WORD_HIGHLIGHT
			pInfo=(TextInfo*)lParam;
			return WordHighlight(pInfo->pText,pInfo->iMode);
			#else
			return 0;
			#endif

	case ANSI_WORDMARK:									// Wrter markieren

			#ifdef USE_MARK_HIGHLIGHT
			pInfo=(TextInfo*)lParam;
			return MarkHighlight(pInfo->pText,pInfo->iMode);
			#else
			return 0;
			#endif
		}


return CAnsiView::OnAnsiInfo(wParam,lParam);
}


//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
//	Den gesamten Text markieren
void CTextView::OnSelectAll()
{

	SetCursor(0,0);
	SetSelection (0,m_iLineCount);

}

//*****************************************************************************
//*
//*		SetRange
//*
//*****************************************************************************
//	Die Koordinaten der aktuellen Marke als Bereich bernehmen
//	Ergibt 2 wenn Bereich mehrzeilig 1 wenn Bereich einzeilig sonst 0
int CTextView::SetRange()
{


	if(m_iMarkOn==0)									// Keine Marke
		{
		m_iAreaStartX = m_iCursorX;
		m_iAreaStartY = m_iCursorY;
		m_iAreaStopX  = m_iCursorX;
		m_iAreaStopY  = m_iCursorY;
		return 0;
		}

	if(m_iMarkOn==2)									// Mehrzeilige Marke
		{
		if(m_iCursorY<m_iMarkY)
			{
			m_iAreaStartX = m_iCursorX;
			m_iAreaStartY = m_iCursorY;
			m_iAreaStopX  = m_iMarkX;
			m_iAreaStopY  = m_iMarkY;
			}
		else{
			m_iAreaStartX = m_iMarkX;
			m_iAreaStartY = m_iMarkY;
			m_iAreaStopX  = m_iCursorX;
			m_iAreaStopY  = m_iCursorY;
			}
		}
	else{												// Einzeilige Marke
		m_iAreaStartY = m_iAreaStopY=m_iCursorY;

		if(m_iCursorX<m_iMarkX)
			{
			m_iAreaStartX = m_iCursorX;
			m_iAreaStopX  = m_iMarkX;
			}
		else{
			m_iAreaStartX = m_iMarkX;
			m_iAreaStopX  = m_iCursorX;
			}
		}

return m_iMarkOn;
}


//*****************************************************************************
//*
//*		SetRange
//*
//*****************************************************************************
//	Die Koordinaten von iPosX iPosY ... als Bereich bernehmen.
//	Ergibt 2 wenn Bereich mehrzeilig 1 wenn Bereich einzeilig sonst 0
int CTextView::SetRange(int iPosX,int iPosY,int iEndX,int iEndY)
{


	if(iEndY==iPosY)									// Einzeilig ?
		{
		m_iAreaStartY = iPosY;
		m_iAreaStopY  = iPosY;

		if(iPosX<iEndX)
			{
			m_iAreaStartX = iPosX;
			m_iAreaStopX  = iEndX;
			m_cAreaMode   = 0;
			}
		else{
			m_iAreaStartX = iEndX;
			m_iAreaStopX  = iPosX;
			m_cAreaMode   = 1;
			}

		return (iPosX==iEndX)? 0:1;
		}

	if(iPosY<iEndY)
		{
		m_iAreaStartX = iPosX;
		m_iAreaStartY = iPosY;
		m_iAreaStopX  = iEndX;
		m_iAreaStopY  = iEndY;
		m_cAreaMode   = 0;
		}
	else{
		m_iAreaStartX = iEndX;
		m_iAreaStartY = iEndY;
		m_iAreaStopX  = iPosX;
		m_iAreaStopY  = iPosY;
		m_cAreaMode   = 1;
		}


return 2;
}


//*****************************************************************************
//*
//*		CheckRange
//*
//*****************************************************************************
//	Ergibt 1 wenn die Position im Bereich ist
int CTextView::CheckRange(int iPosX,int iPosY)
{

	if(iPosY< m_iAreaStartY)return 0;
	if(iPosY==m_iAreaStartY)
	if(iPosX< m_iAreaStartX)return 0;

	if(iPosY> m_iAreaStopY )return 0;
	if(iPosY==m_iAreaStopY )
	if(iPosX>=m_iAreaStopX )return 0;

return 1;
}

//*****************************************************************************
//*
//*		CheckRange
//*
//*****************************************************************************
//	Ergibt 1 wenn die Position im Bereich ist.
int CTextView::CheckRange(CPoint sPos)
{

	if(sPos.y< m_iAreaStartY)return 0;
	if(sPos.y==m_iAreaStartY)
	if(sPos.x< m_iAreaStartX)return 0;

	if(sPos.y> m_iAreaStopY )return 0;
	if(sPos.y==m_iAreaStopY )
	if(sPos.x>=m_iAreaStopX )return 0;


return 1;
}


//*****************************************************************************
//*
//*     PrintDicionary
//*
//*****************************************************************************
//	Prft die Rechtschreibung fr eine Zeile
//	Bei Buchstaben mit Rechtschreibfehler wird das Bit7 in den Farben gesetzt.
//	iLine	: Ist die Zeile die geprft werden soll.
//	Ergibt 1 wenn in den Farben etwas verndert wurde
#ifdef USE_DICIONARY
int CTextView::PrintDicionary(int iLine)
{
char		    cWord[64];
unsigned char  *pColor;
unsigned char  *pText;
TextLine	   *pLine;
int				iFirst;
int				iFlag;
int				iSize;
int				iChg;
int				iOff;
int				iVal;
int				iPos;
int				iLen;
int				iEnd;
int				iCnt;
int				iErr;
int				iOld;


	if(!(m_iDicFlags&FLAG_DICON     ))return 0;			// Keine Rechtschreibprfung
	if(! m_hDicGlobal && !m_hDicLocal)return 0;			// Kein Wrterbuch vorhanden
	if(  m_iColorMode    !=        -1)return 0;			// Fixe Farben


	pLine	= GetLine(iLine);							// Zeilendaten
	pColor	= pLine->pColors;
	pText	= pLine->aText;
	iCnt	= pLine->uSize;
	iSize	= ((iCnt+0x0F)&~0x0F)+DIC_INFO;
	iOld	= pLine->aText[iSize];
	iChg	= 0;
	iErr	= 0;
	iFlag	= 0;


	if(!pColor && !m_aDicColors[pLine->bColor&0x7F])	// Zeile mit falscher Farbe
		{
		return 0;
		}


	iFirst = 1;

	#ifdef USE_UTF8
	iFlag  = DIC_UTF8;
	#endif

	for(iPos=0;iPos<iCnt;)								// Wortanfang suchen
		{
		iLen = DicNextWord((char*)pText+iPos,iCnt-iPos,m_iDicFlags|iFlag,&iFirst);

		if(pColor)										// Prfe Farbe
			{
			iEnd = iPos+iLen-1;

			for(iOff=iPos;;iOff++)						// Lsche Fehler vor dem ersten Word
				{
				if(iOff>=iEnd)
					{
					iFirst=1;
					break;
					}

				if((pColor[iOff]^pColor[iOff+1])&0x7F)iFirst=1;
				if((pColor[iOff]&0x80)==0)continue;

				pColor[iOff]&=~0x80;
				iChg=1;
				continue;
				}
			}

		iPos += iLen;

		if(iFirst)iFirst=DIC_FIRST;



		   iLen = DicCheckWord(m_hDicGlobal,m_hDicLocal,(char*)pText+iPos,iCnt-iPos,m_iDicFlags|iFirst|iFlag,cWord);
		if(iLen<=0)iLen=1;

		   iEnd = iPos+iLen;
		if(iEnd>iCnt)iEnd=iCnt;


		if(pColor)
			{
			for(iOff=iPos;iOff<iEnd;iOff++)				// Prfe ob Farbe stimmt
				{
				iVal=pColor[iOff]&0x7F;
				if(!m_aDicColors[iVal]){cWord[0]=0;break;}
				}
			}

		if(!cWord[0])									// Als richtig markieren
			{
			if(pColor)
				{
				for(iOff=iPos;iOff<iEnd;iOff++)
					{
					if((pColor[iOff]&0x80)==0)continue;

					pColor[iOff] &= ~0x80;
					iChg		  =  1;
					}
				}

			iPos = iEnd;

			continue;
			}

		if(!pColor)										// Farben erzeugen
			{
			iLen   = (iCnt+15)&~0x0F;
			pColor = new uchar[iLen];

			pLine->pColors = pColor;
			memset(pColor,pLine->bColor,iLen);
			}

		for(iOff=iPos;iOff<iEnd;iOff++)					// Als falsch markieren
			{
			if(pColor[iOff]&0x80)continue;

			pColor[iOff] |= 0x80;
			iChg          = 1;
			}

		iPos  = iEnd;
		iErr += 1;
		}

	pLine->aText[iSize] = iErr;
	if(iErr!=iOld)iChg=1;


return iChg;
}
#endif

//*****************************************************************************
//*
//*		SetDicFlags
//*
//*****************************************************************************
//	Setzt die Flags fr die Rechtschreibprfung
//	iFlags		: Die neuen Flag-Werte
//					DIC_NOUPPER		Grogeschriebene Wrter auslassen
//					DIC_NONUMBER	Wrter mit Zahlen ignorieren
//					DIC_LATEXUML	Latex Umlaute beachten (A" O" ... )
//					FLAG_DICON		Rechschreibprfung einschalten
//	iMask		: Ist die Flag-Maske
//  Ergibt die aktuellen Flags.
#ifdef USE_DICIONARY
int	 CTextView::SetDicFlags(int iFlags,int iMask)
{
int iOld,iPos;



	iOld		 =  m_iDicFlags;
	m_iDicFlags &= ~iMask;
	m_iDicFlags |=  iMask&iFlags;

	if(iOld!=m_iDicFlags)								// Fenstern neuzeichen
		{
		m_iFlags |= FLAG_CONFIG_SAFE;

		for(iPos=0;iPos<m_iLineCount;)
			{
			iPos = PrintColor(iPos);
			}
		}

	if(m_iDicFlags&FLAG_DICON)							// Wrterbuch laden
		{
		if(!m_hDicGlobal)ConfigDic(m_cDicNameG);
		if(!m_hDicLocal )ConfigDic(m_cDicNameL,0,0,1);
		}


	if(IsWindow(m_hWnd))DrawView(0);


return m_iDicFlags;
}
#endif

//*****************************************************************************
//*
//*		ConfigDic
//*
//*****************************************************************************
//	Ld	ein Wrterbuch je nach dem Regitry-Schlssel
//			HKEY_LOCAL_MACHINE\SOFTWARE\AZ\Dictionary\<Pfad>
//	pPath	: Ist der Registry-Pfadanhang. (Bei 0 wir "Default" benutzt)
//	iFlags	: Die neuen Flag-Werte, mgliche iFlags:
//				DIC_NOUPPER		Grogeschriebene Wrter auslassen
//				DIC_NONUMBER	Wrter mit Zahlen ignorieren
//				DIC_LATEXUML	Latex Umlaute beachten (A" O" ... )
//				DIC_MULITWORDS  Suche zusammengesetzte Worte
//				DIC_CONTEXT		Prfung ber Kontextmen
//				FLAG_DICON		Rechschreibprfung einschalten
//	iMask	: Die Flag-Maske
//	iMode	: Wenn !=0 wird das pershnliche Wrterbuch geladen.
//  Ergibt 1 wenn das Wrderbuch geladen wurde.
#ifdef 		USE_DICIONARY
int	 CTextView::ConfigDic(const char *pPath,int iFlags,int iMask,int iMode)
{
HDIC	    hDic;
int			iRedraw;
int			iPos;
int			iOld;
int			iRet;


	iRet		 =  1;
	iRedraw		 =  0;
	iOld		 =  m_iDicFlags;
	m_iDicFlags &= ~iMask;
	m_iDicFlags |=  iMask&iFlags;

	if(!pPath)pPath="";


	if(iOld!=m_iDicFlags)
		{
		m_iFlags |= FLAG_CONFIG_SAFE;
		iRedraw   = 1;
		}

	if(iMode)											// Wrterbuch laden
		{
		if(strcmp(pPath,m_cDicNameL))
			{
			strlcpy(m_cDicNameL,pPath,sizeof(m_cDicNameL));
			m_iFlags |= FLAG_CONFIG_SAFE;
			}

		   hDic =DicLoadLocal(pPath,m_hDicLocal);
		if(hDic!=m_hDicLocal){iRedraw=1;m_hDicLocal=hDic;}
		if(hDic==0)iRet=0;
		}
	else{
		if(strcmp(pPath,m_cDicNameG))
			{
			strlcpy(m_cDicNameG,pPath,sizeof(m_cDicNameG));
			m_iFlags |= FLAG_CONFIG_SAFE;
			}

		   hDic =DicLoadGlobal(pPath,m_hDicGlobal);
		if(hDic!=m_hDicGlobal){iRedraw=1;m_hDicGlobal=hDic;}
		if(hDic==0)iRet=0;
		}

	if(iRedraw)											// Fenster neuzeichen ?
		{
		for(iPos=0;iPos<m_iLineCount;)
			{
			iPos=PrintColor(iPos);
			}

		if(IsWindow(m_hWnd))DrawView(0);
		}



return iRet;
}
#endif


//*****************************************************************************
//*
//*		ColorCopy
//*
//*****************************************************************************
//	Kopiert einen Textbereich samt Farbe.
//	pText		: Dort wird ein Zeiger gespeichert mit dem Text.
//				  Der Zeiger muss mit delete wieder freigegeben werden.
//	pColor		: Dort wird ein Zeiger gespeichert mit der Farbe.
//				  Der Zeiger muss mit delete wieder freigegeben werden.
//	iPosY		: Zeile die kopiert werden soll.
//	iPosX1		: Erstes Zeichen das kopiert werden soll.
//	iPosX2		: Zeichen bis zu dem kopiert werden soll (-1=bis Zeilenende).
//	iMode		: Bit 0 = Tabulatoren in Leerzeichen umwandeln.
//				  Bit 8 = In UTF8  codieren
//				  Bit 9 = In UTF16 codieren
//	Ergibt die Zeichen die in Puffer eingefgt wurden.
int	 CTextView::ColorCopy(uchar **pText,uchar **pColor,int iPosY,int iPosX1,int iPosX2,int iMode)
{
TextLine	   *pLine1;
TextLine	   *pLine2;
unsigned char  *pPtr;
unsigned char  *pCol;
unsigned char  *pNew;
unsigned char  *pTmp;
unsigned char  *pTxt;
unsigned		uChar;
int				iOff1;
int				iOff2;
int				iVal;
int				iCol;
int				iLen;
int				iMax;
int				iNum;
int				iCnt;
int				iMul;



	pLine1  = GetLine(iPosY);
	pPtr	= pLine1->aText;
	iLen	= pLine1->uSize;
	iMax	= pLine1->uEnd;
	pCol	= pLine1->pColors;
	iCol	= pLine1->bColor;

	if(iPosX1<  0 )iPosX1=0;
	if(iPosX2<  0 )iPosX2=iMax;
	if(iPosX1>iMax)iPosX1=iMax;
	if(iPosX2>iMax)iPosX2=iMax;


//*****************************************************************************


	if(m_iColorMode>=0)									// Fixe Farben
		{
		iCol = m_iColorMode;

		if(m_pColumColors && !pCol)						// Farben Zeile
			{
			pCol = m_pColumColors;
			}
		}
	else{												// Variable Farben
		if(!pCol && iPosY>0 && m_iColorMode==-1)
			{
			pLine2 = GetLine(iPosY-1);					// Vorherige Zeile
			iCol   = pLine2->bColor;

			if(iCol>0)
				{
				pTxt = m_pWordList[iCol-1];				// 1.Bis-Wort laden
				iCol = pTxt[WFB];						// Farbe am Zeilenanfang
				}
			}
		}


//*****************************************************************************


	iOff1 = TextPosition(iPosX1,pPtr,iLen);
	iOff2 = TextPosition(iPosX2,pPtr,iLen);
	iMul  = 0;

	if(iMode&0x0200)									// Allokiergre fr UTF16 anpassen
		{
		#ifdef USE_UTF8

		for(iVal=iOff1;iVal<iOff2;iVal++)
			{
			if(pPtr[iOff1]>=0xC0)iMax++;
			}

		#endif

		iMul = 1;
		}
	else if(iMode&0x0100)								// Allokiergre fr UTF8 anpassen
		{
		for(iVal=iOff1;iVal<iOff2;iVal++)
			{
			#ifdef USE_UTF8

			if(pPtr[iOff1]>=0xC0)iMax+=3;

			#else

			if(pPtr[iOff1]>=0x80)iMax+=3;

			#endif
			}
		}


	pNew  = new uchar[(iMax+4)<<iMul];
	pTmp  = new uchar[(iMax+4)      ];



	for(iVal=0;iOff1<iOff2 && iVal<iMax;iOff1+=iNum)	// Zeichen ausgeben
		{
		uChar = pPtr[iOff1];
		iNum  = 1;

		#ifdef USE_UTF8

		if(uChar>=0xC0)
			{
			iNum = utf8tochar(pPtr+iOff1,uChar);
			}

		#endif


		if(pCol)iCol=pCol[iOff1];


		if(uChar=='\t' && (iMode&1))					// Spezialfall Tabulator
			{
			iLen	= m_iTabWidth - iPosX1%m_iTabWidth;
			iPosX1 += iLen;

			for(;iLen>0;iLen--)
				{
				pNew[ iVal<<iMul   ] = ' ';
				pNew[(iVal<<iMul)+1] = 0;
				pTmp[ iVal         ] = iCol;

				iVal++;
				}
			}
		else if(iMode&0x0200)							// Im UTF16-Format ausgeben
			{
			iCnt = chartoutf16(pNew+iVal*2,uChar);
			memset(pTmp+iVal,iCol,iCnt);

			iPosX1    +=  1;
			iVal      +=  iCnt;
			}
		else if(uChar>=0x80 && (iMode&0x0100))			// Im UTF8-Format ausgeben
			{
			#ifdef USE_UTF8
			if(uChar>=256)uChar=255;
			#endif

			iCnt = chartoutf8(pNew+iVal,uChar);
			memset(pTmp+iVal,iCol,iCnt);

			iPosX1    +=  1;
			iVal      +=  iCnt;
			}
		else{											// Im ANSI-Format ausgeben
			#ifdef USE_UTF8
			if(uChar>=256)uChar=255;
			#endif

			pNew[iVal] = uChar;
			pTmp[iVal] = iCol;
			iPosX1    += 1;
			iVal      += 1;
			}
		}

	pNew[iVal] = 0;
	pTmp[iVal] = 0;

	if(iVal>0 && pTmp[0]==0xFF)
		{
		pTmp[0]=0;
		}

	*pText  = pNew;
	*pColor = pTmp;


return iVal;
}


//*****************************************************************************
//*
//*		GetColorPos
//*
//*****************************************************************************
//	Ergibt die Farbe des Zeichens auf einner Posiition.
//	iPosX/iPosY		: Sind die Koordinaten der Posiition.
//					  Achtung iPosX ist das Offset und nicht die Cursor-Position
//	Ergibt den Farbindex.
int	 CTextView::GetColorPos(int iPosX,int iPosY)
{
TextLine	   *pLine1;
TextLine	   *pLine2;
uchar	   	   *pColor;
uchar	   	   *pText;
int				iColor;



	pLine1	= GetLine(iPosY);
	pColor	= pLine1->pColors;


	if(pColor && (unsigned)iPosX<pLine1->uSize)
		{
		return pColor[iPosX];
		}


	if(m_iColorMode>=0)									// Fixe Farben
		{
		if(m_pColumColors && (unsigned)iPosX<(unsigned)m_iMaxChars)
			{
			return m_pColumColors[iPosX];
			}

		return m_iColorMode;
		}


	if(iPosY<=0)return 0;

	pLine2 = GetLine(iPosY-1);							// Vorherige Zeile
	iColor = pLine1->bColor;

	if(pLine2->bColor>0)
		{
		pText = m_pWordList[pLine2->bColor-1];			// 1.Bis-Wort laden
		return pText[WFB];								// Farbe am Zeilenanfang
		}


return iColor;
}


//*****************************************************************************
//*
//*		PrintMargin
//*
//*****************************************************************************
//	Zeilennummern am linken Rand ausgeben.
void CTextView::PrintMargin (HDC hDc,RECT *pRect,int iLine)
{
char		cText[64];
HGDIOBJ		hOldFont;
COLORREF	uOldText;
COLORREF	uOldBk;
RECT		sRect;
HICON		hIcon;
int			iFlags;
int			iMode;
int			iOff;



	hOldFont	= SelectObject(hDc,GetStockObject(ANSI_VAR_FONT));
	uOldText	= SetTextColor(hDc,RGB(128,128,128));
	uOldBk		= SetBkColor  (hDc,RGB(192,192,192));
	iFlags		= DT_TOP|DT_RIGHT;
	sRect		= *pRect;

	itoa(iLine+1,cText,10);

	ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sRect,NULL,0,NULL);

	if(m_pHookMarginText)
		{
		hIcon	= 0;
		iMode	= m_pHookMarginText(this,m_pHookMarginTextParam,iLine,cText,sizeof(cText),&hIcon);
		iOff	= iMode;

		if(iMode&0x10000)
			{
			sRect.left += 4;
			iFlags      = DT_TOP|DT_LEFT;
			if(hIcon)DrawIcon(hDc,sRect.right,sRect.top,hIcon);
			sRect.left += iOff;
			}
		else{
			sRect.right -= 4;
			sRect.right -= iOff;
			if(hIcon)DrawIcon(hDc,sRect.left,sRect.top,hIcon);
			}
		}
	else{
		sRect.right-=4;
		}

	DrawText    (hDc,cText,-1,&sRect,iFlags);
	SelectObject(hDc,hOldFont);
	SetTextColor(hDc,uOldText);
	SetBkColor  (hDc,uOldBk);

}

//*****************************************************************************
//*
//*		SetHookProc
//*
//*****************************************************************************
//	Setzt eine Hook-Funktion.
//	iMode		: Welche Hook-Funktion soll gesetzt werden
//					HOOK_CHANGE_LINE	= Wenn sich eine Zeile ndert.
//					HOOK_RAND_TEXT		= Text fr Rand.
//					HOOK_MOVE_CURSOR	= Wenn sich der Cursor ndert.
//					HOOK_STATUSBAR_TEXT	= Text fr die Statusbar.
//	pProc		: Zeiger auf die Hook-Funktion.
//	pParam		: bergabeparameter fr Hook-Funktion.
//	Ergibt die zuletzt eingestellte Hook-Funktion.
void *CTextView::SetHookProc(int iMode,void *pProc,void *pParam)
{
void	*pOld=0;



	switch(iMode)
		{
	case HOOK_CHANGE_LINE:

		pOld  =	m_pHookChangeLine;
		 		m_pHookChangeLine=(void(__cdecl*)(CTextView*,void*,int))pProc;
				m_pHookChangeLineParam=pParam;
		break;

	case HOOK_INSERT_LINE:

		pOld  = m_pHookInsertLine;
		 		m_pHookInsertLine=(void(__cdecl*)(CTextView*,void*,int))pProc;
				m_pHookInsertLineParam=pParam;

		break;

	case HOOK_DELETE_LINE:

		pOld  = m_pHookDeleteLine;
		 		m_pHookDeleteLine=(void(__cdecl*)(CTextView*,void*,int))pProc;
				m_pHookDeleteLineParam=pParam;

		break;

	case HOOK_RAND_TEXT:

		pOld  = m_pHookMarginText;
		 		m_pHookMarginText=(int(__cdecl*)(CTextView*,void*,int,char*,int,HICON*))pProc;
				m_pHookMarginTextParam=pParam;
		break;

	case HOOK_MOVE_CURSOR:

		pOld  = m_pHookMoveCursor;
		 		m_pHookMoveCursor=(int(__cdecl*)(CTextView*,void*,int,int))pProc;
				m_pHookMoveCursorParam=pParam;

		break;

	case HOOK_STATUSBAR_TEXT:

		pOld  = m_pHookStatusbarText;
		 		m_pHookStatusbarText=(int(__cdecl*)(CTextView*,void*,int,int,int,char*))pProc;
				m_pHookStatusbarTextParam=pParam;

		break;

	case HOOK_CHANGE_TEXT:

		pOld  = m_pHookChangeText;
		 		m_pHookChangeText=(int(__cdecl*)(CTextView*,void*,int,int,int))pProc;
				m_pHookChangeTextParam=pParam;

		break;

	case HOOK_CONTEXT_MENU:

		pOld  = m_pHookContextMenu;
		 		m_pHookContextMenu=(int(__cdecl*)(CTextView*,void*,CMenu*,int,int,const char*))pProc;
				m_pHookContextMenuParam=pParam;

		break;
		}

return pOld;
}


//*****************************************************************************
//*
//*		IsSelected
//*
//*****************************************************************************
//	Prft ob ein Zeichen markiert ist.
//	iPoxX/Y			: Position des Zeichens
//	Ergibt 0=nichts 1=einzeilig 2=zweizeilig
int CTextView::IsSelected(int iPosX,int iPosY)
{

	switch(m_iMarkOn)
		{
	case 1:	if(iPosY!=m_iCursorY)break;
			if(m_iCursorX<m_iMarkX)
				{
				if(iPosX<m_iCursorX)break;
				if(iPosX>m_iMarkX  )break;
				}
			else{
				if(iPosX>m_iCursorX)break;
				if(iPosX<m_iMarkX  )break;
				}

			return 1;
	case 2:
			if(m_iCursorY<m_iMarkY)
				{
				if(iPosY< m_iCursorY)break;
				if(iPosY> m_iMarkY  )break;
				if(iPosY==m_iCursorY && iPosX<m_iCursorX)break;
				if(iPosY==m_iMarkY   && iPosX>m_iMarkX  )break;
				}
			else{
				if(iPosY> m_iCursorY)break;
				if(iPosY< m_iMarkY  )break;
				if(iPosY==m_iCursorY && iPosX>m_iCursorX)break;
				if(iPosY==m_iMarkY   && iPosX<m_iMarkX  )break;
				}

			return 2;
		}


return 0;
}

//*****************************************************************************
//*
//*		TranslateLine
//*
//*****************************************************************************
//	Falls Textzeile zugeklappt sind werden die virtuellen Zeilen in reale umgerechnet.
//	uLine		: Ist die Linie von der ausgeggangen wird
//	iDelta		: Ist die Richtung und Zeilenanzahl in die bersprungen wird.
//	Ergibt die neue Zeile
#ifdef USE_VIRTUAL_LINES
int	 CTextView::TranslateLine(unsigned uLine,int iDelta)
{
TextLine   *pLine;
int			iDiff;



	if(uLine>=(uint)m_iLineCount)						// Sind wir hinter dem Textende
		{
		if(iDelta>=0)return uLine+iDelta;
		if(uLine ==0)return 0;

		iDiff   = uLine-m_iLineCount+1;
		uLine   = m_iLineCount-iDiff;
		iDelta += iDiff;
		}

	if(iDelta<0)										// Richtung Anfang
		{
		do	{
			if(!uLine)return uLine+iDelta;
			iDelta += 1;
			uLine  -= 1;
			pLine	= m_pLineList[uLine];
			uLine  -= pLine->uPrev;
			}while(iDelta);
		}
	else if(iDelta>0)									// Richtung Ende
		{
		do	{
			iDelta -= 1;
			uLine  += 1;
			if(uLine>=(uint)m_iLineCount)return uLine+iDelta;
			pLine	= m_pLineList[uLine];
			uLine  += pLine->uNext;
			}while(iDelta);
		}
	else{
		pLine	= m_pLineList[uLine];
		uLine  += pLine->uNext;
		}



return uLine;
};
#endif

//*****************************************************************************
//*
//*		BeginDrag
//*
//*****************************************************************************
#if USE_TEXT_DRAGDROP

DROP_FUNC_SIMPLE(CTextView)

int CTextView::BeginDrag()
{
char   *pText;
int		iMode;
int		iRet;
int		iLen;


	if(!m_ucHasDrag || !m_iMarkOn)						// Drag erlaubt ?
		{
		return 0;
		}


	#ifdef USE_UTF8

    iLen  = TextCopy(&pText,TEXT_CURSOR|TEXT_SELECTION|TEXT_IS_UTF16);
	iMode = 2;

	#else

	iLen  = TextCopy(&pText,TEXT_CURSOR|TEXT_SELECTION);
	iMode = 0;

	#endif

	if(!iLen || !pText)
		{
		if(pText)delete pText;
		return 0;
		}

	m_ucDoDrag = 1;
	iRet	   = DragText(pText,iLen,iMode);
	m_ucDoDrag = 0;

	delete pText;



return iRet;
}

//*****************************************************************************
//*
//*		OnDrop
//*
//*****************************************************************************
BOOL CTextView::OnDrop(COleDataObject *pDataObject,DROPEFFECT dEff,CPoint sPoint)
{
char		   *pText;
STGMEDIUM		sData;
int				iPosX;
int				iPosY;
int				iSize;
int				iOffY;
int				iEndY;
int				iOffX;
int				iEndX;
int				iFlag;
int				iVal;
int				iOk;




	if(m_cNotChange || !m_ucHasDrop || m_uDropMode==DROPEFFECT_NONE)
		{
		return FALSE;
		}

	PointToPos(sPoint,iPosX,iPosY,1);
	iFlag = 0;
	iOk   = 0;

	if(m_pHookChangeText)								// Callback fr nderungen abfragen
		{
		if(!m_pHookChangeText(this,m_pHookChangeTextParam,iPosX,iPosY,m_cChanged))
			{
			return FALSE;
			}
		}


	if(m_ucDoDrag && m_iMarkOn)							// Drop auf's eigene Fenster
		{
		if(IsSelected(iPosX,iPosY))
			{
			return FALSE;
			}

		if(!(GetAsyncKeyState(VK_CONTROL)&0x8000))
			{											// Einzelige Position korrigiern
			if(m_iMarkOn==1 && m_iCursorY==iPosY)
				{
				if(m_iCursorX<m_iMarkX)
					{
					iOffX = m_iCursorX;
					iEndX = m_iMarkX;
					}
				else{
					iEndX = m_iCursorX;
					iOffX = m_iMarkX;
					}

				if(iOffX<iPosX)iPosX-=iEndX-iOffX;
				}

			if(m_iMarkOn==2)							// Mehrzelige Position korrigiern
				{
				if(m_iCursorY<m_iMarkY)
					{
					iOffX = m_iCursorX;
					iOffY = m_iCursorY;
					iEndX = m_iMarkX;
					iEndY = m_iMarkY;
					}
				else{
					iEndX = m_iCursorX;
					iEndY = m_iCursorY;
					iOffX = m_iMarkX;
					iOffY = m_iMarkY;
					}

				if(iPosY==iEndY)
					{
					iPosY -= iEndY-iOffY;
					iPosX -= iEndX-iOffX;
					}
				else if(iPosY>iEndY)
					{
					iPosY -= iEndY-iOffY;
					}
				}

			SelectionClear();							// Auswahl lschen
			m_cChanged = 1;
			iFlag = TEXT_UNDOTWOTURNS;
			}
		}



	iVal = 0;

	if(pDataObject->GetData(CF_UNICODETEXT,&sData))		// Unicode vorhanden
		{
		iSize	=        GlobalSize(sData.hGlobal);
		pText	= (char*)GlobalLock(sData.hGlobal);

		if(pText && iSize>0)
			{
			iOk   = 1;
			iSize = strnlen((wchar_t*)pText,iSize/2)*2;
			iVal  = TextInsert(pText,iPosX,iPosY,TEXT_CURSOR_RIGHT|TEXT_UNDO|TEXT_UNDOADD|TEXT_REDRAW|TEXT_IS_UTF16|iFlag,iSize);
			m_cChanged = 1;
			}
		}
	else if(pDataObject->GetData(CF_TEXT,&sData))		// Ansi-Text vorhanden
		{
		iSize	=        GlobalSize(sData.hGlobal);
		pText	= (char*)GlobalLock(sData.hGlobal);

		if(pText && iSize>0)
			{
			iOk   = 1;
			iSize = strnlen(pText,iSize);
			iVal  = TextInsert(pText,iPosX,iPosY,TEXT_CURSOR_RIGHT|TEXT_UNDO|TEXT_UNDOADD|TEXT_REDRAW|iFlag,iSize);
			m_cChanged = 1;
			}
		}


	iVal += iPosY;

	for(;;)												// Die Farben aktualisieren
		{
		iPosY=PrintColor(iPosY);
		if(iPosY>iVal)break;
		}




	OnDragLeave();



return iOk;
}

//*****************************************************************************
//*
//*		OnDragOver
//*
//*****************************************************************************
DROPEFFECT CTextView::OnDragOver(COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint)
{

	if(m_cNotChange || !m_ucHasDrop)
		{
		m_uDropMode = DROPEFFECT_NONE;
		}
	else if(!pDataObject->IsDataAvailable(CF_TEXT) && !pDataObject->IsDataAvailable(CF_UNICODETEXT))
		{
		m_uDropMode = DROPEFFECT_NONE;
		}
	else if(m_ucDoDrag && GetAsyncKeyState(VK_CONTROL)&0x8000)
		{
		m_uDropMode = DROPEFFECT_COPY;
		}
	else{
		m_uDropMode = DROPEFFECT_MOVE;
		}


return m_uDropMode;
}


//*****************************************************************************
//*
//*		OnRenderData
//*
//*****************************************************************************
//	Wird aufgerufen wenn das Drop-Ziel die Daten anfordert
BOOL CTextView::OnRenderData(LPFORMATETC pFormatEtc,LPSTGMEDIUM pStgMedium)
{
return TRUE;
}

#else

int CTextView::BeginDrag(){return 0;}

#endif


#ifdef USE_VIRTUAL_LINES

//*****************************************************************************
//*
//*		ExpandCheck
//*
//*****************************************************************************
//	Klappt einen Bereich auf wenn die Line nicht sichtbar ist.
//	uLine		: Ist die Zeile die geprft wird.
//	Ergibt Anzahl der aufgeklappten Zeilen.
int	CTextView::ExpandCheck(uint uLine)
{
TextLine  *pLine;



	if(uLine>=(uint)m_iLineCount)return 0;

	pLine = m_pLineList[uLine];

	if(pLine->uNext==0)return 0;


return Expand(uLine,TEXT_EXPAND);
}

//*****************************************************************************
//*
//*		Expand
//*
//*****************************************************************************
//	Einen Bereich aub bzw. zuklappen
//	uLine		: Ist die Zeile die auf/zugeklapt wird
//	iCount		: Ist die Zeilenanzahl die zugeklappt wird. Bei TEXT_EXPAND
//				  wird der Bereich oder die nchsten Zeilen auf geklappt.
//	Ergibt die Anzahl der genderten Zeilen
int	CTextView::Expand(uint uLine,int iCount)
{
TextLine   *pLine;
int			iRedraw;
int			iStart;
int			iPos;


	if(uLine>=(uint)m_iLineCount)return 0;

	iRedraw = m_iRedrawFlags;
	pLine   = m_pLineList[uLine];


	if(iCount==TEXT_EXPAND)								// Aufklappen
		{
		if(pLine->uNext==0)
			{
			uLine++;
			if(uLine>=(uint)m_iLineCount)return 0;
			pLine  = m_pLineList[uLine];
			}
		else{
			uLine -= pLine->uPrev-1;
			pLine  = m_pLineList[uLine];
			}

			iCount = pLine->uNext;
		if(!iCount)return 0;

		DrawViewFrom(uLine);

		for(iPos=0;iPos<iCount;iPos++)
			{
			pLine->uNext = 0;
			pLine->uPrev = 0;
			uLine		+= 1;
			pLine		 = m_pLineList[uLine];
			}
		}
	else{												// Zuklappen
		if((int)uLine+iCount>m_iLineCount)
			{
			iCount = m_iLineCount-uLine;
			}

		DrawViewFrom(uLine);

		if(iCount>0xFF00)iCount=0xFF00;

		iStart = uLine;

		for(iPos=0;iPos<iCount;iPos++)
			{
			uLine		+= 1;
			pLine->uPrev = (WORD)(iPos+1);
			pLine->uNext = (WORD)(iCount-iPos);
			pLine		 = m_pLineList[uLine];
			}

		if(m_iScrollY<(int)uLine && m_iScrollY>=iStart)	// Scroll-Position im Bereich
			{
			m_iScrollY = TEXT_STEP(m_iScrollY,-1);
			PositionOk(m_iCursorX,m_iCursorY);
			}

		if(m_iCursorY<(int)uLine && m_iCursorY>=iStart)	// Cursor-Position im Bereich
			{
			m_iCursorY = TEXT_STEP(m_iCursorY,1);
			PositionOk(m_iCursorX,m_iCursorY);
			}
		}



	if(!iRedraw && m_iRedrawFlags)						// Das Fenster neuzeichen
		{
		DrawView(1);
		}



return iCount;
}

#endif


//*****************************************************************************
//*
//*		GetMarkingText
//*
//*****************************************************************************
//	Wantelt einen Text in einen internen Markierungs-String um
//	pText		: Ist der Zeiger auf den Text
//	pBuffer		: Zeiger auf den Puffer fr den Markierungs-String.
//	iSize		: Ist die Gre des Puffers.
//	iMode		: Bestimt die Einfgemethode.
//					TEXT_IS_UTF8		Der Text ist im UTF8 -Format
//					TEXT_IS_UTF16		Der Text ist im UTF16-Format
//					TEXT_WORD       	Nur ganze Wter makieren
//					TEXT_NOCASE			Keine Gro-Klein-Unterscheidung
//					TEXT_HAS_LENGTH		Die Textlnge ist in den oberen 8-Bits
//	Ergibt die Lnge des erzeugten Markierungs-Strings.
#if defined(USE_MARK_HIGHLIGHT) || defined(USE_WORD_HIGHLIGHT)
int	CTextView::GetMarkingText(const uchar *pText,uchar *pBuffer,int iSize,int iMode)
{
unsigned	uChar;
int			iOut;
int			iOff;
int			iMax;


	iOut	= 0;
	iOff	= 0;

	if(iMode&TEXT_HAS_LENGTH)							// Lnge aus Modus holen
		{
		iMax = (uchar)(iMode>>24);
		}
	else{
		iMax = iSize*2;
		}


	#ifdef USE_UTF8

	if(iMode&TEXT_IS_UTF16)								// UTF16 zu UTF8 umwandeln
		{
		iSize -= 4;

		while(iOff<iMax)
			{
			iOff += utf16tochar(pText+iOff,uChar)*2;
			if(uChar==0)break;
			iOut += chartoutf8(pBuffer+iOut,uChar);
			if(iOut>=iSize)break;
			}
		}
	else if(!(iMode&TEXT_IS_UTF8))						// ANSI zu UTF8 umwandeln
		{
		iSize -= 2;

		while(iOff<iMax)
			{
			uChar = pText[iOff];
			if(uChar==0)break;
			iOut += chartoutf8(pBuffer+iOut,uChar);
			if(iOut>=iSize)break;
			iOff      += 1;
			}
		}
	else{												// UTF8 zu UTF8
		iSize -= 1;

		while(iOff<iMax)
			{
			uChar = pText[iOff];
			if(uChar==0)break;
			pBuffer[iOut] = uChar;
			iOut	  += 1;
			if(iOut>=iSize)break;
			iOff      += 1;
			}
		}

	#else

	iSize -= 1;

	if(iMode&TEXT_IS_UTF8)								// UTF8 zu ANSI umwandeln
		{
		while(iOff<iMax)
			{
			iOff += utf8tochar(pText+iOff,uChar);
			if(uChar==0)break;
			if(uChar>=256)uChar=255;
			pBuffer[iOut] = uChar;
			iOut      += 1;
			if(iOut>=iSize)break;
			}
		}
	else if(iMode&TEXT_IS_UTF16)						// UTF16 zu ANSI umwandeln
		{
		while(iOff<iMax)
			{
			iOff += utf16tochar(pText+iOff,uChar)*2;
			if(uChar==0)break;
			if(uChar>=256)uChar=255;
			pBuffer[iOut] = uChar;
			iOut      += 1;
			if(iOut>=iSize)break;
			}
		}
	else{												// ANSI zu ANSI
		while(iOff<iMax)
			{
			uChar = pText[iOff];
			if(uChar==0)break;
			pBuffer[iOut] = uChar;
			iOut	  += 1;
			if(iOut>=iSize)break;
			iOff	  += 1;
			}
		}

	#endif


	pBuffer[iOut]	= 0;



return iOut;
}
#endif

//*****************************************************************************
//*
//*		WordHighlight
//*
//*****************************************************************************
//	Stellt einen neuen Highligt-Text ein, der berallmarkiert werden soll.
//	pText		: Text der eingefgt werden soll.
//	iMode		: Bestimt die Einfgemethode
//					TEXT_IS_UTF8		Der Text ist im UTF8 -Format
//					TEXT_IS_UTF16		Der Text ist im UTF16-Format
//					TEXT_WORD       	Nur ganze Wter makieren
//					TEXT_NOCASE			Keine Gro-Klein-Unterscheidung
//					TEXT_HAS_LENGTH		Die Textlnge ist in den oberen 8-Bits
//	Ergibt die Lnge des neunen Highligt-Textes
#ifdef USE_WORD_HIGHLIGHT
int	CTextView::WordHighlight(const uchar *pText,int iMode)
{
unsigned	aLines[4];
unsigned	uCount;
unsigned	uIndex;
unsigned	uPlace;
int			iPos;
int			iEnd;
int			iOut;


	if(m_ucHighlightMode==255)							// Sind Highligt-Texte gesperrt
		{
		return 0;
		}

	uCount	= 0;
	iEnd	= TEXT_STEP(m_iScrollY,m_iScreenY);


	if(m_ucHighlightChar)								// Sind schon Worte markiert
		{
		for(iPos=m_iScrollY;iPos<=iEnd;iPos=TEXT_STEP(iPos,1))
			{
			if(HighlightInLine(iPos)<0)continue;

			if(uCount>=ENTRIES(aLines))
				{
				uCount++;
				break;
				}

			if(iPos==m_iCursorY)						// Zeile fr's zeichnen merken
				{
				DrawViewCursorLine();
				continue;
				}

			aLines[uCount] = iPos;
			uCount++;
			}
		}

	iOut = GetMarkingText(pText,m_ucHighlightWord,sizeof(m_ucHighlightWord),iMode);

	m_ucHighlightSize	= iOut;
	m_ucHighlightMode	= (iMode&TEXT_WORD);			// Nur ganze Wrter markieren
	m_ucHighlightAnd	= (iMode&TEXT_NOCASE)? ~0x20:0xFF;
	m_ucHighlightChar	= m_ucHighlightWord[0]&m_ucHighlightAnd;



	if(m_ucHighlightChar)								// Mssen Worte markiert werden
		{
		for(iPos=m_iScrollY;iPos<=iEnd;iPos=TEXT_STEP(iPos,1))
			{
			if(HighlightInLine(iPos)<0)continue;

			if(uCount>=ENTRIES(aLines))
				{
				uCount++;
				break;
				}

			if(iPos==m_iCursorY)						// Zeile fr's zeichnen merken
				{
				DrawViewCursorLine();
				continue;
				}

			for(uIndex=0;;uIndex++)						// Die Zeile in die Liste einfgen
				{
				if(uIndex>=uCount)
					{
					aLines[uCount] = iPos;				// Zeile am Ende anhngen
					uCount++;
					break;
					}

				if(aLines[uIndex]<(UINT)iPos)
					{
					continue;
					}

				if(aLines[uIndex]==(UINT)iPos)			// Zeile ist schon in der Liste
					{
					break;
					}

				for(uPlace=uCount;uPlace>uIndex;uPlace--)
					{
					aLines[uPlace] = aLines[uPlace-1];
					}

				aLines[uIndex] = iPos;					// Zeile einfgen
				uCount++;
				break;
				}
			}
		}


	if(uCount>0 || m_iRedrawFlags)						// Die vernderten Zeilen zeichnen
		{
		if(uCount==0)
			{
			DrawView(1);
			}
		else if(uCount>ENTRIES(aLines))
			{
			DrawViewFrom(aLines[0]);
			DrawView(1);
			}
		else for(uIndex=0;uIndex<uCount;uIndex++)
			{
			DrawViewFrom(aLines[uIndex]);
			DrawView(1);
			}
		}



return iOut;
}

#endif


//*****************************************************************************
//*
//*		HighlightInLine
//*
//*****************************************************************************
//	Prft ob ein Highligt-Text in einer Zeile ist
//	iLine		: ist die Zeilenummer
//	Ergibt die Position des Highligt-Textes in der Zeile, oder -1 wenn nicht vorhanden.
#ifdef USE_WORD_HIGHLIGHT
int	CTextView::HighlightInLine(int iLine)
{
const char     *pText;
unsigned char	ucChar;
int				iLen;
int				iPos;


		pText = GetLineText(iLine,&iLen);
	if(!pText)return -1;


	for(iPos=0;iPos<iLen;iPos++)						// Die Buchstaben der Zeile abschreiten
		{
		ucChar	= pText[iPos];

		if((ucChar&m_ucHighlightAnd)!=m_ucHighlightChar)// Passt der ertste Buchstabe
			{
			continue;
			}

		if((m_ucHighlightAnd==0xDF && !memicmp(pText+iPos,m_ucHighlightWord,m_ucHighlightSize)) ||
		   (m_ucHighlightAnd==0xFF && !memcmp (pText+iPos,m_ucHighlightWord,m_ucHighlightSize)))
			{
			if(!m_ucHighlightMode)
				{
				return iPos;
				}
														// Ist es ein ganzes Wort
			if(CharType(pText[iPos+m_ucHighlightSize])<2 && (iPos<=0 || CharType(pText[iPos-1])<2))
				{
				return iPos;
				}
			}
		}


return -1;
}

#endif



//*****************************************************************************
//*
//*		MarkHighlight
//*
//*****************************************************************************
//	Stellt ein neues Wort ein, das berall markiert werden soll
//	pText		: Text der eingefgt werden soll.
//	iMode		: Bestimt die Einfgemethode.
//					TEXT_IS_UTF8		Der Text ist im UTF8 -Format
//					TEXT_IS_UTF16		Der Text ist im UTF16-Format
//					TEXT_WORD       	Nur ganze Wter makieren
//					TEXT_NOCASE			Keine Gro-Klein-Unterscheidung
//					TEXT_HAS_LENGTH		Die oberen 8-Bit sind die Lnge
//	Ergibt die Lnge des neunen Highligt-Textes
#ifdef USE_MARK_HIGHLIGHT
int	CTextView::MarkHighlight(const uchar *pText,int iMode)
{
unsigned	aLines[4];
unsigned	uCount;
unsigned	uIndex;
unsigned	uPlace;
int			iPos;
int			iEnd;
int			iOut;


	if(m_ucWordMarkMode==255)							// Sind Wordmarkierungen gesperrt
		{
		return 0;
		}

	uCount	= 0;
	iEnd	= TEXT_STEP(m_iScrollY,m_iScreenY);


	if(m_ucWordMarkChar)								// Sind schon Worte markiert
		{
		for(iPos=m_iScrollY;iPos<=iEnd;iPos=TEXT_STEP(iPos,1))
			{
			if(MarkedWordInLine(iPos)<0)continue;

			if(uCount>=ENTRIES(aLines))
				{
				uCount++;
				break;
				}

			if(iPos==m_iCursorY)						// Zeile fr's zeichnen merken
				{
				DrawViewCursorLine();
				continue;
				}

			aLines[uCount] = iPos;
			uCount++;
			}
		}


	iOut = GetMarkingText(pText,m_ucWordMarkWord,sizeof(m_ucWordMarkWord),iMode);

	m_ucWordMarkSize	= iOut;
	m_ucWordMarkMode	= (iMode&TEXT_WORD);			// Nur ganze Wrter markieren
	m_ucWordMarkAnd		= (iMode&TEXT_NOCASE)? ~0x20:0xFF;
	m_ucWordMarkChar	= m_ucWordMarkWord[0]&m_ucWordMarkAnd;



	if(m_ucWordMarkChar)								// Mssen Worte markiert werden
		{
		for(iPos=m_iScrollY;iPos<=iEnd;iPos=TEXT_STEP(iPos,1))
			{
			if(MarkedWordInLine(iPos)<0)continue;

			if(uCount>=ENTRIES(aLines))
				{
				uCount++;
				break;
				}

			if(iPos==m_iCursorY)						// Zeile fr's zeichnen merken
				{
				DrawViewCursorLine();
				continue;
				}

			for(uIndex=0;;uIndex++)						// Die Zeile in die Liste einfgen
				{
				if(uIndex>=uCount)
					{
					aLines[uCount] = iPos;				// Zeile am Ende anhngen
					uCount++;
					break;
					}

				if(aLines[uIndex]<(UINT)iPos)
					{
					continue;
					}

				if(aLines[uIndex]==(UINT)iPos)			// Zeile ist schon in der Liste
					{
					break;
					}

				for(uPlace=uCount;uPlace>uIndex;uPlace--)
					{
					aLines[uPlace] = aLines[uPlace-1];
					}

				aLines[uIndex] = iPos;					// Zeile einfgen
				uCount++;
				break;
				}
			}
		}


	if(uCount>0 || m_iRedrawFlags)						// Die vernderten Zeilen zeichnen
		{
		if(uCount==0)
			{
			DrawView(1);
			}
		else if(uCount>ENTRIES(aLines))
			{
			DrawViewFrom(aLines[0]);
			DrawView(1);
			}
		else for(uIndex=0;uIndex<uCount;uIndex++)
			{
			DrawViewFrom(aLines[uIndex]);
			DrawView(1);
			}
		}


return iOut;
}

#endif


//*****************************************************************************
//*
//*		MarkedWordInLine
//*
//*****************************************************************************
//	Prft ob ein Word in einer Zeile markiert ist
//	iLine		: ist die Zeilenummer
//	Ergibt die Position des Highligt-Textes in der Zeile, oder -1 wenn nicht vorhanden.
#ifdef USE_MARK_HIGHLIGHT
int	CTextView::MarkedWordInLine(int iLine)
{
const char     *pText;
unsigned char	ucChar;
int				iLen;
int				iPos;


		pText = GetLineText(iLine,&iLen);
	if(!pText)return -1;


	for(iPos=0;iPos<iLen;iPos++)						// Die Buchstaben der Zeile abschreiten
		{
		ucChar	= pText[iPos];

		if((ucChar&m_ucWordMarkAnd)!=m_ucWordMarkChar)	// Passt der ertste Buchstabe
			{
			continue;
			}

		if((m_ucWordMarkAnd==0xDF && !memicmp(pText+iPos,m_ucWordMarkWord,m_ucWordMarkSize)) ||
		   (m_ucWordMarkAnd==0xFF && !memcmp (pText+iPos,m_ucWordMarkWord,m_ucWordMarkSize)))
			{
			if(!m_ucWordMarkMode)
				{
				return iPos;
				}
														// Ist es ein ganzes Wort
			if(CharType(pText[iPos+m_ucWordMarkSize])<2 && (iPos<=0 || CharType(pText[iPos-1])<2))
				{
				return iPos;
				}
			}
		}


return -1;
}

#endif


