//****************************************************************************
//*
//*
//*		FileFunctions.cpp
//*
//*
//****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
//	Allgemeine File Funktioen:
//
// 		char   *GetFileType  (char*,int*=0)			Datei Typ holen
// 		char   *GetFileName  (char*,int*=0)			Datei Namen holen
// 		char   *GetFilePath  (char*,int*=0)			Datei Pfad holen
// 		char   *GetFilePathR (char*,int*=0)			Datei Pfad holen (relativ)
// 		int		GetExeName   (char*,int=1024)		Ergibt Exe Dateinamen
// 		int		GetExePath   (char*,int=1024)		Ergibt Exe Dateipfad
//		int		FilePathLen  (char*,int)			Ergibt Lnge des Pfades bis Ebene
// 		int		FilePathLen  (char*)				Ergibt Lnge des Pfades
// 		int     FileDriveLen (char*)				Ergibt Lnge des Laufwerkes
//		int		FileNameLen  (char*)				Ergibt Lnge eines Namens
// 		int     GetFileDrive (char*)				Datei Laufwerk holen
// 		int		CreatePath   (char*)				Einen Pfad erzeugen
// 		int		ExistFile    (char*)				Prfen ob Datei vorhanden
//		int		LengthFile	 (HFILE)				Dateilnger holen
//		int		RemoveFile   (char*)		    	Lscht Datei
// 		int		AddBackSlash (char*,int=-1)			Hngt  ein '\' wenn es fehlt
// 		int		DelBackSlash (char*,int=-1)			Lscht ein '\' wenn es existiert
// 		int		HasBackSlash (char*,int=-1)			Ergibt 1 wenn ein '\' existiert
//		int		CmpFileName  (char*,char*,int=7)	Dateinamen vergleichen
//		int		CmpFileNameN (char*,char*)			Dateinamen vergleichen
//		int		CmpFileNameG (char*,char*)			Dateinamen vergleichen
//		int		CmpFileNameN (char*,char*,int)		Dateinamen vergleichen
//		int		CmpFileNameG (char*,char*,int)		Dateinamen vergleichen
//		int		SetFileName  (char*,char *,char *,int=1024)
//		int		SetFileName  (char*,	   char *,int=1024)
//		int		PathConvert  (char*,int='\')		Dateinamen '/' zu '\' tauschen
//		int		PathFullMake (char*,char*,char*,int,int)
//		int		PathOffset   (char*,char*,char*,int,int)
//		int		PathCompress (char*,char*,int)		".." und "." aus einem Dateinamen entfernen
//		int     MakeLongPath (char*,char*,int)		Einen langen Dateinamen erzeugen
//		int     MakeShortPath(char*,char*,int)		Einen kurzen Dateinamen erzeugen
//		int		CopyFileTime (char*,char*)			Dateizeit kopieren
//		int		FindFile     (char*,WIN32_FIND_DATA*)
//		int		FindFile     (char*,WIN32_FILE_ATTRIBUTE_DATA*)
//
#include	<string.h>
#include	<malloc.h>
#include	<stdlib.h>
#include	"FileFunctions.h"


#ifdef		AZ_LIB_ADDAFX
#include	<Afx.h>
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif



#ifdef	_MSC_VER
#pragma warning( disable :4996 )
#endif

#ifdef		Z
#undef 		Z
#endif

#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)			L##a
#define 	zchar			wchar_t
#define 	strzlen			(int)wcslen
#else
#define 	Z(a)			a
#define 	zchar			char
#define 	strzlen			(int)strlen
#endif

#define 	DEC				256+0x0080

static const unsigned short aNameTableG[256] =
	{
	0x0000 ,0x0100 ,0x0200 ,0x0300 ,0x0400 ,0x0500 ,0x0600 ,0x0700 ,
	0x0800 ,0x0900 ,0x0A00 ,0x0B00 ,0x0C00 ,0x0D00 ,0x0E00 ,0x0F00 ,
	0x1000 ,0x1100 ,0x1200 ,0x1300 ,0x1400 ,0x1500 ,0x1600 ,0x1700 ,
	0x1800 ,0x1900 ,0x1A00 ,0x1B00 ,0x1C00 ,0x1D00 ,0x1E00 ,0x1F00 ,
	0x0003 ,'!'*256,'"'*256,'#'*256,'$'*256,'%'*256,'&'*256,0x2700 ,
	0x0008 ,0x000C ,'*'*256,'+'*256,0x0103 ,'-'*256,0x0002 ,0x0001 ,
	'0'*DEC,'1'*DEC,'2'*DEC,'3'*DEC,'4'*DEC,'5'*DEC,'6'*DEC,'7'*DEC,
	'8'*DEC,'9'*DEC,0x0101 ,0x0102 ,0x000B ,'='*256,0x000F ,'?'*256,
	'@'*256,'A'*256,'B'*256,'C'*256,'D'*256,'E'*256,'F'*256,'G'*256,
	'H'*256,'I'*256,'J'*256,'K'*256,'L'*256,'M'*256,'N'*256,'O'*256,
	'P'*256,'Q'*256,'R'*256,'S'*256,'T'*256,'U'*256,'V'*256,'W'*256,
	'X'*256,'Y'*256,'Z'*256,0x0009 , 0x0001,0x000D ,'^'*256,0x0004 ,
	'`'*256,'a'*256,'b'*256,'c'*256,'d'*256,'e'*256,'f'*256,'g'*256,
	'h'*256,'i'*256,'j'*256,'k'*256,'l'*256,'m'*256,'n'*256,'o'*256,
	'p'*256,'q'*256,'r'*256,'s'*256,'t'*256,'u'*256,'v'*256,'w'*256,
	'x'*256,'y'*256,'z'*256,0x000A ,0x0104 ,0x000E ,'~'*256,0x7F00 ,
	0x8000 ,0x8100 ,0x8200 ,0x8300 ,0x8400 ,0x8500 ,0x8600 ,0x8700 ,
	0x8800 ,0x8900 ,0x8A00 ,0x8B00 ,0x8C00 ,0x8D00 ,0x8E00 ,0x8F00 ,
	0x9000 ,0x9100 ,0x9200 ,0x9300 ,0x9400 ,0x9500 ,0x9600 ,0x9700 ,
	0x9800 ,0x9900 ,0x9A00 ,0x9B00 ,0x9C00 ,0x9D00 ,0x9E00 ,0x9F00 ,
	0xA000 ,0xA100 ,0xA200 ,0xA300 ,0xA400 ,0xA500 ,0xA600 ,0xA700 ,
	0xA800 ,0xA900 ,0xAA00 ,0xAB00 ,0xAC00 ,0xAD00 ,0xAE00 ,0xAF00 ,
	0xB000 ,0xB100 ,0xB200 ,0xB300 ,0xB400 ,0xB500 ,0xB600 ,0xB700 ,
	0xB800 ,0xB900 ,0xBA00 ,0xBB00 ,0xBC00 ,0xBD00 ,0xBE00 ,0xBF00 ,
	0x4101 ,0x4102 ,0x4103 ,0x4104 ,0x4105 ,0x4106 ,0x4107 ,0x6701 ,
	0x4501 ,0x4502 ,0x4503 ,0x4504 ,0x4901 ,0x4902 ,0x4903 ,0x4904 ,
	0x4401 ,0x4E01 ,0x4F01 ,0x4F02 ,0x4F03 ,0x4F04 ,0x4F05 ,0xD700 ,
	0xD800 ,0x5501 ,0x5502 ,0x5503 ,0x5504 ,0xDD00 ,0x5901 ,0xDF00 ,
	0x6101 ,0x6102 ,0x6103 ,0x6104 ,0x6105 ,0x6106 ,0x6107 ,0x6701 ,
	0x6501 ,0x6502 ,0x6503 ,0x6504 ,0x6901 ,0x6902 ,0x6903 ,0x6904 ,
	0x6401 ,0x6E01 ,0x6F01 ,0x6F02 ,0x6F03 ,0x6F04 ,0x6F05 ,0xF700 ,
	0xF800 ,0x7501 ,0x7502 ,0x7503 ,0x7504 ,0xFD00 ,0x7901 ,0xFF00 ,
	};

static const unsigned short aNameTableN[256] =
	{
	0x0000 ,0x0100 ,0x0200 ,0x0300 ,0x0400 ,0x0500 ,0x0600 ,0x0700 ,
	0x0800 ,0x0900 ,0x0A00 ,0x0B00 ,0x0C00 ,0x0D00 ,0x0E00 ,0x0F00 ,
	0x1000 ,0x1100 ,0x1200 ,0x1300 ,0x1400 ,0x1500 ,0x1600 ,0x1700 ,
	0x1800 ,0x1900 ,0x1A00 ,0x1B00 ,0x1C00 ,0x1D00 ,0x1E00 ,0x1F00 ,
	0x0003 ,'!'*256,'"'*256,'#'*256,'$'*256,'%'*256,'&'*256,0x2700 ,
	0x0008 ,0x000C ,'*'*256,'+'*256,0x0103 ,'-'*256,0x0002 ,0x0001 ,
	'0'*DEC,'1'*DEC,'2'*DEC,'3'*DEC,'4'*DEC,'5'*DEC,'6'*DEC,'7'*DEC,
	'8'*DEC,'9'*DEC,0x0101 ,0x0102 ,0x000B ,'='*256,0x000F ,'?'*256,
	'@'*256,'a'*256,'b'*256,'c'*256,'d'*256,'e'*256,'f'*256,'g'*256,
	'h'*256,'i'*256,'j'*256,'k'*256,'l'*256,'m'*256,'n'*256,'o'*256,
	'p'*256,'q'*256,'r'*256,'s'*256,'t'*256,'u'*256,'v'*256,'w'*256,
	'x'*256,'y'*256,'z'*256,0x0009 , 0x0001,0x000D ,'^'*256,0x0004 ,
	'`'*256,'a'*256,'b'*256,'c'*256,'d'*256,'e'*256,'f'*256,'g'*256,
	'h'*256,'i'*256,'j'*256,'k'*256,'l'*256,'m'*256,'n'*256,'o'*256,
	'p'*256,'q'*256,'r'*256,'s'*256,'t'*256,'u'*256,'v'*256,'w'*256,
	'x'*256,'y'*256,'z'*256,0x000A ,0x0104 ,0x000E ,'~'*256,0x7F00 ,
	0x8000 ,0x8100 ,0x8200 ,0x8300 ,0x8400 ,0x8500 ,0x8600 ,0x8700 ,
	0x8800 ,0x8900 ,0x8A00 ,0x8B00 ,0x8C00 ,0x8D00 ,0x8E00 ,0x8F00 ,
	0x9000 ,0x9100 ,0x9200 ,0x9300 ,0x9400 ,0x9500 ,0x9600 ,0x9700 ,
	0x9800 ,0x9900 ,0x9A00 ,0x9B00 ,0x9C00 ,0x9D00 ,0x9E00 ,0x9F00 ,
	0xA000 ,0xA100 ,0xA200 ,0xA300 ,0xA400 ,0xA500 ,0xA600 ,0xA700 ,
	0xA800 ,0xA900 ,0xAA00 ,0xAB00 ,0xAC00 ,0xAD00 ,0xAE00 ,0xAF00 ,
	0xB000 ,0xB100 ,0xB200 ,0xB300 ,0xB400 ,0xB500 ,0xB600 ,0xB700 ,
	0xB800 ,0xB900 ,0xBA00 ,0xBB00 ,0xBC00 ,0xBD00 ,0xBE00 ,0xBF00 ,
	0x6101 ,0x6102 ,0x6103 ,0x6104 ,0x6105 ,0x6106 ,0x6107 ,0x6701 ,
	0x6501 ,0x6502 ,0x6503 ,0x6504 ,0x6901 ,0x6902 ,0x6903 ,0x6904 ,
	0x6401 ,0x6E01 ,0x6F01 ,0x6F02 ,0x6F03 ,0x6F04 ,0x6F05 ,0xF700 ,
	0xF800 ,0x7501 ,0x7502 ,0x7503 ,0x7504 ,0xFD00 ,0x7901 ,0xDF00 ,
	0x6101 ,0x6102 ,0x6103 ,0x6104 ,0x6105 ,0x6106 ,0x6107 ,0x6701 ,
	0x6501 ,0x6502 ,0x6503 ,0x6504 ,0x6901 ,0x6902 ,0x6903 ,0x6904 ,
	0x6401 ,0x6E01 ,0x6F01 ,0x6F02 ,0x6F03 ,0x6F04 ,0x6F05 ,0xF700 ,
	0xF800 ,0x7501 ,0x7502 ,0x7503 ,0x7504 ,0xFD00 ,0x7901 ,0xFF00 ,
	};


extern	int	   _cdecl  strtoi   (const char    *pString,          int iBase,int *pLen);
extern	int	   _cdecl  strtoi   (const wchar_t *pString,          int iBase,int *pLen);
extern	int	   _cdecl  strtoni  (const char    *pString,int iMax ,int iBase,int *pLen);
extern	int	   _cdecl  strtoni  (const wchar_t *pString,int iMax ,int iBase,int *pLen);
extern	int	   _cdecl  memfilter(const char    *pText  ,int iSize,const char    *pFilter,int iMode=0,char    cSign=';');
extern	int	   _cdecl  memfilter(const wchar_t *pText  ,int iSize,const wchar_t *pFilter,int iMode=0,wchar_t cSign=';');



//****************************************************************************
//*
//*		CreatePath
//*
//****************************************************************************
//	Erzeugt einen Pfad rekursiv in dem alle Verzeichnisse erstellt werden.
//	pPath		: Ist der name des Pfades.
//				  Am Ende des Pfades kann auch ein '\' oder '/' stehen.
//	iPathLen	: Ist die Lnge des Pfades, Textzeichen danach werden ignoriert.
//					CP_FULL_LEN	0x0000	= Den ganzen Pfad benutzen
//					CP_PATH_LEN	0xFFFF	= Den Dateinamen am Ende entfernen
//	Ergibt 0 bei einem Fehler
//		   1 wenn der Pfad erzeugt wurde
//         2 wenn der Pfad bereits existiert
int _cdecl CreatePath(const char *pPath){return CreatePath(pPath,CP_FULL_LEN);}
int _cdecl CreatePath(const char *pPath,int iPathLen)
{
int	    i,iLen,iNum,iDrive,iPos,iNew,iStart=0;
char    cSign,cBuffer[MAX_PATH+16];
DWORD	dwAttr;



	if(pPath[0] && pPath[1]==':')						// Laufwerk prfen
		{
		iDrive=pPath[0];
		if(iDrive>='a' && iDrive<='z')iDrive-=32;
		if(iDrive< 'A' || iDrive> 'Z')return 0;			// Falsche Laufwerksnummer
		   iDrive-='A';

		if(!(GetLogicalDrives()&(1<<iDrive)))			// Existiert Laufwerk
			{
			return 0;
			}
		}

	cBuffer[0] = 0;

		iLen=GetFullPathNameA(pPath,MAX_PATH,cBuffer,0);
	if((iLen>=3)&&(cBuffer[iLen-2]==':')&&(cBuffer[iLen-1]=='/' || cBuffer[iLen-1]=='\\'))
		{
		return 2;										// Pfad ist Laufwerk
		}


	if(iPathLen>0)										// Den Pfad krzen
		{
		iNum = (int)strlen(pPath);

		if(iPathLen==CP_PATH_LEN)
			{
			iPathLen = FilePathLen(iNum,pPath);			// Dateinamen am Ende entfernen
			}

		   iNum -= iPathLen;
		if(iNum>=iLen)
			{
			return 0;
			}

		iLen -= iNum;
		cBuffer[iLen] = 0;
		}


	if(iLen)											// '/' am Ende entfernen
	if(cBuffer[iLen-1]=='/' || cBuffer[iLen-1]=='\\')
		{
		iLen--;
		cBuffer[iLen]=0;
		}


	if(iLen>=2)											// Ist Pfad Netzlaufwerk '\\...'
	if(cBuffer[0]=='\\' && cBuffer[1]=='\\')
		{
		for(i=2;i<iLen;i++)
			{
			if(cBuffer[i]=='/' )break;
			if(cBuffer[i]=='\\')break;
			}
		if(i>=iLen)return 2;

		iStart=i+1;
		}
	else{
		iStart=0;
		}


	   dwAttr=GetFileAttributesA(cBuffer);				// Existiert Pfad bereits ?
	if(dwAttr!=0xFFFFFFFF)
		{
		return (dwAttr&FILE_ATTRIBUTE_DIRECTORY)? 2:0;
		}


	iNew = 0;
	iPos = (int)strcspn(cBuffer+iStart,"\\/")+iStart;

	while(iPos<iLen)
		{
		if(cBuffer[iPos])iPos++;
		i=(int)strcspn(cBuffer+iPos,"\\/");
		if(!i)return 0;
		iPos+=i;

		cSign=cBuffer[iPos];
			  cBuffer[iPos]=0;

		if(!iNew)
			{
			   dwAttr=GetFileAttributesA(cBuffer);		// Existiert Pfad ?
			if(dwAttr!=0xFFFFFFFF)
				{
				cBuffer[iPos]=cSign;
				continue;
				}

			iNew=1;
			}

		if(!CreateDirectoryA(cBuffer,NULL))				// Verzeichnis erzeugen ?
		if(GetLastError()!=ERROR_ALREADY_EXISTS)
			{
			return 0;
			}

		cBuffer[iPos]=cSign;
		};



return 1;
}

int _cdecl CreatePath(const wchar_t *pPath){return CreatePath(pPath,CP_FULL_LEN);}
int _cdecl CreatePath(const wchar_t *pPath,int iPathLen)
{
int			i,iLen,iNum,iDrive,iPos,iNew,iStart=0;
wchar_t		cSign,cBuffer[MAX_PATH+16]=L"";
DWORD		dwAttr;



	if(pPath[0] && pPath[1]==':')						// Laufwerk prfen
		{
		iDrive=pPath[0];
		if(iDrive>='a' && iDrive<='z')iDrive-=32;
		if(iDrive< 'A' || iDrive> 'Z')return 0;			// Falsche Laufwerksnummer
		   iDrive-='A';

		if(!(GetLogicalDrives()&(1<<iDrive)))			// Existiert Laufwerk
			{
			return 0;
			}
		}

		iLen=GetFullPathNameW(pPath,MAX_PATH,cBuffer,0);
	if((iLen>=3)&&(cBuffer[iLen-2]==':')&&(cBuffer[iLen-1]=='/' || cBuffer[iLen-1]=='\\'))
		{
		return 2;										// Pfad ist Laufwerk
		}


	if(iPathLen>0)										// Den Pfad krzen
		{
		iNum = (int)wcslen(pPath);

		if(iPathLen==CP_PATH_LEN)
			{
			iPathLen = FilePathLen(iNum,pPath);			// Dateinamen am Ende entfernen
			}

		   iNum -= iPathLen;
		if(iNum>=iLen)
			{
			return 0;
			}

		iLen -= iNum;
		cBuffer[iLen] = 0;
		}


	if(iLen)											// '/' am Ende entfernen
	if(cBuffer[iLen-1]=='/' || cBuffer[iLen-1]=='\\')
		{
		iLen--;
		cBuffer[iLen]=0;
		}


	if(iLen>=2)											// Ist Pfad Netzlaufwerk '\\...'
	if(cBuffer[0]=='\\' && cBuffer[1]=='\\')
		{
		for(i=2;i<iLen;i++)
			{
			if(cBuffer[i]=='/' )break;
			if(cBuffer[i]=='\\')break;
			}
		if(i>=iLen)return 2;

		iStart=i+1;
		}
	else{
		iStart=0;
		}


	   dwAttr=GetFileAttributesW(cBuffer);				// Existiert Pfad bereits ?
	if(dwAttr!=0xFFFFFFFF)
		{
		return (dwAttr&FILE_ATTRIBUTE_DIRECTORY)? 2:0;
		}


	iNew = 0;
	iPos = (int)wcscspn(cBuffer+iStart,L"\\/")+iStart;

	while(iPos<iLen)
		{
		if(cBuffer[iPos])iPos++;
		i=(int)wcscspn(cBuffer+iPos,L"\\/");
		if(!i)return 0;
		iPos+=i;

		cSign=cBuffer[iPos];
			  cBuffer[iPos]=0;

		if(!iNew)
			{
			   dwAttr=GetFileAttributesW(cBuffer);		// Existiert Pfad ?
			if(dwAttr!=0xFFFFFFFF)
				{
				cBuffer[iPos]=cSign;
				continue;
				}

			iNew=1;
			}

		if(!CreateDirectoryW(cBuffer,NULL))				// Verzeichnis erzeugen ?
		if(GetLastError()!=ERROR_ALREADY_EXISTS)
			{
			return 0;
			}

		cBuffer[iPos]=cSign;
		};



return 1;
}


//****************************************************************************
//*
//*		ExistFile
//*
//****************************************************************************
//	Prft ob eine Datei existiert
//	pPath	: Ist der Pfad der Datei.
//	Ergibt 0 wenn Datei nicht existiert
//		   1 wenn Datei existiert
//         2 wenn Datei ein Verzeichnis ist
//         3 wenn Datei ein Laufwerk ist
//         4 wenn Datei ein Netzlaufwerk ist
int _cdecl ExistFile(const char *pPath)
{
char    cBuffer[MAX_PATH+16];
DWORD	dwAttr;
int		iDrive;


	if(!pPath)return 0;									// Kein Pfad angegeben

	if( pPath[0] && (pPath[1]==':'))					// Laufwerk prfen
		{
		iDrive=pPath[0];

		if(iDrive>='a' && iDrive<='z' )iDrive-=32;
		if(iDrive< 'A' || iDrive> 'Z' )return 0;		// Falsche Laufwerksnummer
		   iDrive-='A';

		if(!(GetLogicalDrives()&(1<<iDrive)))			// Existiert Laufwerk
			{
			return 0;
			}

		if(pPath[2]=='/' || pPath[2]=='\\')
		if(pPath[3]==0)return 3;
		if(pPath[2]==0)
			{
			GetFullPathNameA(pPath,MAX_PATH,cBuffer,0);
			return (cBuffer[3]==0)? 3:2;
			}
		}


	   dwAttr=GetFileAttributesA(pPath);
	if(dwAttr==0xFFFFFFFF)return 0;



return (dwAttr&FILE_ATTRIBUTE_DIRECTORY)? 2:1;
}

int _cdecl ExistFile(const wchar_t *pPath)
{
wchar_t		cBuffer[MAX_PATH+16];
DWORD		dwAttr;
int			iDrive;


	if(!pPath)return 0;									// Kein Pfad angegeben

	if( pPath[0] && (pPath[1]==':'))					// Laufwerk prfen
		{
		iDrive=pPath[0];

		if(iDrive>='a' && iDrive<='z' )iDrive-=32;
		if(iDrive< 'A' || iDrive> 'Z' )return 0;		// Falsche Laufwerksnummer
		   iDrive-='A';

		if(!(GetLogicalDrives()&(1<<iDrive)))			// Existiert Laufwerk
			{
			return 0;
			}

		if(pPath[2]=='/' || pPath[2]=='\\')
		if(pPath[3]==0)return 3;
		if(pPath[2]==0)
			{
			GetFullPathNameW(pPath,MAX_PATH,cBuffer,0);
			return (cBuffer[3]==0)? 3:2;
			}
		}

	   dwAttr=GetFileAttributesW(pPath);
	if(dwAttr==0xFFFFFFFF)return 0;



return (dwAttr&FILE_ATTRIBUTE_DIRECTORY)? 2:1;
}

//*****************************************************************************
//*
//*		LengthFile
//*
//*****************************************************************************
//	Ergibt Dateilnge bzw -1 bei einem Fehler
int	_cdecl LengthFile(HFILE  hHandle){return GetFileSize((HANDLE)hHandle,0);}
int	_cdecl LengthFile(HANDLE hHandle){return GetFileSize((HANDLE)hHandle,0);}
int	_cdecl LengthFile(FILE *pFile)
{
unsigned	uPos;
unsigned	uLen;

	if(!pFile)return -1;

	uPos = ftell(pFile);

	fseek(pFile,0,SEEK_END);

	uLen = ftell(pFile);

	fseek(pFile,uPos,SEEK_SET);

return uLen;
}

int	_cdecl LengthFile(const char *pPath)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;


	if(!GetFileAttributesExA(pPath,GetFileExInfoStandard,&sFind))return -1;

	if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)return -1;


return sFind.nFileSizeLow;
}

int	_cdecl LengthFile(const wchar_t *pPath)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;


	if(!GetFileAttributesExW(pPath,GetFileExInfoStandard,&sFind))return -1;

	if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)return -1;


return sFind.nFileSizeLow;
}


int	_cdecl LengthFile(HFILE  hHandle,void *pLen64)
{
DWORD	uHigh;
DWORD	uLow;
DWORD	uRet;


	uLow = GetFileSize((HANDLE)hHandle,&uHigh);
	uRet = uLow;

	if(uLow==0xFFFFFFFF)
		{
		if(GetLastError()!=NO_ERROR)
				uHigh = 0xFFFFFFFF;
		else	uRet  = 0xFFFFFFFE;
		}

	*(__int64*)pLen64  = uHigh;
	*(__int64*)pLen64<<= 32;
	*(__int64*)pLen64 += uLow;


return uRet;
}

int	_cdecl LengthFile(HANDLE hHandle,void *pLen64)
{
DWORD	uHigh;
DWORD	uLow;
DWORD	uRet;


	uLow = GetFileSize((HANDLE)hHandle,&uHigh);
	uRet = uLow;

	if(uLow==0xFFFFFFFF)
		{
		if(GetLastError()!=NO_ERROR)
				uHigh = 0xFFFFFFFF;
		else	uRet  = 0xFFFFFFFE;
		}

	*(__int64*)pLen64  = uHigh;
	*(__int64*)pLen64<<= 32;
	*(__int64*)pLen64 += uLow;


return uRet;
}

int	_cdecl LengthFile(FILE *pFile,void *pLen64)
{
unsigned	uPos;
unsigned	uLen;

	if(!pFile)
		{
		*(__int64*)pLen64=-1;
		return -1;
		}

	uPos = ftell(pFile);

	fseek(pFile,0,SEEK_END);

	uLen = ftell(pFile);

	fseek(pFile,uPos,SEEK_SET);

	*(__int64*)pLen64 = uLen;

return uLen;
}

int	_cdecl LengthFile(const char *pPath,void *pLen64)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;

	
	if(!GetFileAttributesExA(pPath,GetFileExInfoStandard,&sFind))
		{
		*(__int64*)pLen64=-1;
		return -1;
		}

	if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
		{
		*(__int64*)pLen64=-1;
		return -1;
		}

	*(__int64*)pLen64  = sFind.nFileSizeHigh;
	*(__int64*)pLen64<<= 32;
	*(__int64*)pLen64 += sFind.nFileSizeLow;

	if(sFind.nFileSizeLow==0xFFFFFFFF)
		{
		return 0xFFFFFFFE;
		}


return sFind.nFileSizeLow;
}

int	_cdecl LengthFile(const wchar_t *pPath,void *pLen64)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;

	
	if(!GetFileAttributesExW(pPath,GetFileExInfoStandard,&sFind))
		{
		*(__int64*)pLen64=-1;
		return -1;
		}

	if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
		{
		*(__int64*)pLen64=-1;
		return -1;
		}

	*(__int64*)pLen64  = sFind.nFileSizeHigh;
	*(__int64*)pLen64<<= 32;
	*(__int64*)pLen64 += sFind.nFileSizeLow;

	if(sFind.nFileSizeLow==0xFFFFFFFF)
		{
		return 0xFFFFFFFE;
		}


return sFind.nFileSizeLow;
}




//****************************************************************************
//*
//*		GetFileType
//*
//****************************************************************************
//	Sucht den Typanhang in einen Dateinamen
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pPath		: Ist der Zeiger auf den Dateinamen.
//	pLen		: Ist pLen != 0 wird in hier die Lnge des Typanhangs gespeichert.
//	Ergibt einen Zeiger auf den Typanhang im Dateinamen exklusive '.'
//	bzw. "\00" wenn kein Typ-Anhang gefunden wurde.
char * _cdecl GetFileType(int iNum,const char *pPath,int *pLen)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='.' )
			{
			if(iPos==0            ){iPos=iNum;break;}
			if(pPath[iPos-1]=='\\'){iPos=iNum;break;}
			if(pPath[iPos-1]=='/' ){iPos=iNum;break;}
			if(pPath[iPos-1]==':' ){iPos=iNum;break;}
			break;
			}
		
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		}

	if(iPos<0 || pPath[iPos]!='.')
		{
		if(pLen)*pLen=0;
		return (char*)pPath+iNum;
		}

	if(pLen)*pLen=iNum-iPos-1;


return (char*)pPath+iPos+1;
}

wchar_t * _cdecl GetFileType(int iNum,const wchar_t *pPath,int *pLen)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='.' )
			{
			if(iPos==0            ){iPos=iNum;break;}
			if(pPath[iPos-1]=='\\'){iPos=iNum;break;}
			if(pPath[iPos-1]=='/' ){iPos=iNum;break;}
			if(pPath[iPos-1]==':' ){iPos=iNum;break;}
			break;
			}
		
		if(pPath[iPos]=='.' )break;
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		}

	if(iPos<0 || pPath[iPos]!='.')
		{
		if(pLen)*pLen=0;
		return (wchar_t*)pPath+iNum;
		}

	if(pLen)*pLen=iNum-iPos-1;


return (wchar_t*)pPath+iPos+1;
}

//****************************************************************************
//*
//*		GetFileType
//*
//****************************************************************************
//	Speichert den Typanhang in einen Dateinamen in einem Puffer exlusive '.'
//	pBuffer		: Zeiger auf den Puffer
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pPath		: Ist der Zeiger auf den Dateinamen.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	Ergibt die Lnge von des Typanhang in Zeichen.
int _cdecl GetFileType(char *pBuffer,int iNum,const char *pPath,int iMax)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='.' )
			{
			if(iPos==0            ){iPos=iNum;break;}
			if(pPath[iPos-1]=='\\'){iPos=iNum;break;}
			if(pPath[iPos-1]=='/' ){iPos=iNum;break;}
			if(pPath[iPos-1]==':' ){iPos=iNum;break;}
			break;
			}
		
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		}

	   iNum-=iPos+1;
	if(iPos<0 || pPath[iPos]!='.' || iNum>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,pPath+iPos+1,iNum);
	pBuffer[iNum]=0;


return iNum;
}

int _cdecl GetFileType(wchar_t *pBuffer,int iNum,const wchar_t *pPath,int iMax)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='.' )
			{
			if(iPos==0            ){iPos=iNum;break;}
			if(pPath[iPos-1]=='\\'){iPos=iNum;break;}
			if(pPath[iPos-1]=='/' ){iPos=iNum;break;}
			if(pPath[iPos-1]==':' ){iPos=iNum;break;}
			break;
			}
		
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		}

	   iNum-=iPos+1;
	if(iPos<0 || pPath[iPos]!='.' || iNum>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,pPath+iPos+1,iNum*2);
	pBuffer[iNum]=0;


return iNum;
}

//****************************************************************************
//*
//*		GetFileName
//*
//****************************************************************************
//	Sucht den Dateinamen in einem Pfad.
//	iNum		: Ist die Lnge des Dateinamen in Zeichen
//	pPath		: Ist der Zeiger auf den Pfad
//	pLen		: Wenn pLen != 0 ist, wird hier die Lnge des Dateinamens gespeichert
//	Ergibt einen Zeiger auf den Dateinamen eines Pfades
char * _cdecl GetFileName(int iNum,const char *pPath,int *pLen)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		if(pPath[iPos]==':' )break;
		}

	if(pLen)*pLen=iNum-iPos-1;



return (char*)pPath+iPos+1;
}

wchar_t  * _cdecl GetFileName(int iNum,const wchar_t *pPath,int *pLen)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		if(pPath[iPos]==':' )break;
		}

	if(pLen)*pLen=iNum-iPos-1;



return (wchar_t*)pPath+iPos+1;
}

//****************************************************************************
//*
//*		GetFileName
//*
//****************************************************************************
//	Sucht den Dateinamen in einem Pfad und speichert diesen in einem Puffer.
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pBuffer		: Zeiger auf den Puffer
//	pPath		: Ist der Zeiger auf den Pfad.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	Ergibt die Lnge des Dateinamens in Zeichen.
int _cdecl GetFileName(char *pBuffer,int iNum,const char *pPath,int iLen)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		if(pPath[iPos]==':' )break;
		}

	   iNum-=iPos+1;
	if(iNum>=iLen)
		{
		if(iLen>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,pPath+iPos+1,iNum);
	pBuffer[iNum]=0;


return iNum;
}


int _cdecl GetFileName(wchar_t *pBuffer,int iNum,const wchar_t *pPath,int iLen)
{
int		iPos;


	for(iPos=iNum-1;iPos>=0;iPos--)
		{
		if(pPath[iPos]=='\\')break;
		if(pPath[iPos]=='/' )break;
		if(pPath[iPos]==':' )break;
		}

	   iNum-=iPos+1;
	if(iNum>=iLen)
		{
		if(iLen>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,pPath+iPos+1,iNum*2);
	pBuffer[iNum]=0;


return iNum;
}

//*****************************************************************************
//*
//*		GetFileBody
//*
//*****************************************************************************
//	Holt den Namenskern aus einem Dateinamen ohne Suffix.
//	Es wird dabei ein Speicherbereich fr den Pfad reserviert der spter
//	wieder mit delete freigegeben werden muss !!!
//	z.B.  "C:\Temp\Test.txt" --> "Test"
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pPath		: Ist der Zeiger auf den Dateinamen aus dem der
//				  Namenskern geholt wird.
//	pLen		: Ist pLen != 0 so wird hier die Lnge des
//				  Namenskern gespeichert.
//	Ergibt den Zeiger auf den Puffer mit dem Dateipfad inklusive letzten '\'
char * _cdecl GetFileBody(int iNum,const char *pPath,int *pLen)
{
int		iSize;
char   *pType;
char   *pName;
char   *pBody;


	pName = GetFileName(iNum,pPath);
	pType = GetFileType(     pName);
	iSize = (int)(pType-pName);

	if(iSize>0 && pType[-1]=='.')iSize--;

	pBody = new char[iSize+1];
	memcpy(pBody,pName,iSize);
	pBody[iSize]=0;

	if(pLen)*pLen=iSize;


return pBody;
}

wchar_t  * _cdecl GetFileBody(int iNum,const wchar_t *pPath,int *pLen)
{
int			iSize;
wchar_t    *pType;
wchar_t    *pName;
wchar_t    *pBody;


	pName = GetFileName(iNum,pPath);
	pType = GetFileType(     pName);
	iSize = (int)(pType-pName);

	if(iSize>0 && pType[-1]=='.')iSize--;

	pBody = new wchar_t[iSize+1];
	memcpy(pBody,pName,iSize*sizeof(wchar_t));
	pBody[iSize]=0;

	if(pLen)*pLen=iSize;


return pBody;
}



//****************************************************************************
//*
//*		GetFileBody
//*
//****************************************************************************
//	Holt den Namenskern aus einem Dateinamen ohne Suffix.
//	z.B.  "C:\Temp\Test.txt" --> "Test"
//	pBuffer		: Zeiger auf den Puffer in dem der Namenskern
//				  gespeichert wird.
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pPath		: Ist der Zeiger auf den Dateinamen aus dem der
//				  Namenskern geholt wird.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	Die Lnge des gespeicherten Namenskerns.
int _cdecl GetFileBody(char *pBuffer,int iNum,const char *pPath,int iMax)
{
char   *pType;
char   *pName;
int		iSize;


	pName = GetFileName(iNum,pPath);
	pType = GetFileType(pName);
	iSize = (int)(pType-pName);

	if(iSize>0 && pType[-1]=='.')iSize--;
	if(iSize>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return  0;
		}

	memcpy(pBuffer,pName,iSize);
	pBuffer[iSize]=0;



return iSize;
}

int _cdecl GetFileBody(wchar_t *pBuffer,int iNum,const wchar_t *pPath,int iMax)
{
wchar_t    *pType;
wchar_t    *pName;
int			iSize;


	pName = GetFileName(iNum,pPath);
	pType = GetFileType(pName);
	iSize = (int)(pType-pName);

	if(iSize>0 && pType[-1]=='.')iSize--;
	if(iSize>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return  0;
		}

	memcpy(pBuffer,pName,iSize*sizeof(wchar_t));
	pBuffer[iSize]=0;



return iSize;
}

//****************************************************************************
//*
//*		GetFilePath
//*
//****************************************************************************
//	Holt den Dateipfad ohne Datenamen und speichert diesen in einem Puffer.
//	Es wird dabei ein Speicherbereich fr den Pfad reserviert der spter
//	wieder mit delete freigegeben werden muss !!!
//	Bei dieser Funktion wird der Pfadname immer auf den vollen Pfad erweitert.
//	(z.B.  C:\Temp\Test.txt --> C:\Temp\)
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pLen		: Ist pLen != 0 so wird hier die Lnge des Dateipfades gespeichert.
//	Ergibt den Zeiger auf den Puffer mit dem Dateipfad inklusive letzten '\'
char * _cdecl GetFilePath(const char *pPath,int *pLen)
{
int		iNum,iSize;
char    cBuffer[MAX_PATH]="",*pName;



	iNum  = GetFullPathNameA(pPath,MAX_PATH,cBuffer,0);
	pName = GetFileName(cBuffer,&iSize);
	iNum -= iSize;

	pName = new char[iNum+1];
	memcpy(pName,cBuffer,iNum);
	pName[iNum]=0;

	if(pLen)*pLen=iNum;



return pName;
}

wchar_t  * _cdecl GetFilePath(const wchar_t *pPath,int *pLen)
{
int			iNum,iSize;
wchar_t		cBuffer[MAX_PATH]=L"";
wchar_t    *pName;



	iNum  = GetFullPathNameW(pPath,MAX_PATH,cBuffer,0);
	pName = GetFileName(cBuffer,&iSize);
	iNum -= iSize;

	pName = new wchar_t[iNum+1];
	memcpy(pName,cBuffer,iNum*2);
	pName[iNum]=0;

	if(pLen)*pLen=iNum;



return pName;
}

//****************************************************************************
//*
//*		GetFilePathR
//*
//****************************************************************************
//	Holt den Dateipfad ohne Datenamen und speichert diesen in einem Puffer.
//	Es wird dabei ein Speicherbereich fr den Pfad reserviert der spter
//	wieder mit delete freigegeben werden muss !!!
//	Bei dieser Funktion wird der Pfadname nicht auf den vollen erweitert.
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pPath		: Ist der Zeiger auf den gesamten Pfad.
//	pLen		: Ist pLen != 0 so wird hier die Lnge des Dateipfades gespeichert.
//	Ergibt den Zeiger auf den Puffer mit dem Dateipfad inklusive letzten '\'
char * _cdecl GetFilePathR(int iNum,const char *pPath,int *pLen)
{
char   *pName;


	 pName = GetFileName(iNum,pPath);
	 iNum  = (int)(pPath-pName);

	 pName = new char[iNum+1];
	 memcpy(pName,pPath,iNum);
	 pName[iNum]=0;

	if(pLen)*pLen=iNum;


return pName;
}

wchar_t  * _cdecl GetFilePathR(int iNum,const wchar_t *pPath,int *pLen)
{
wchar_t	   *pName;


	 pName = GetFileName(iNum,pPath);
	 iNum  = (int)(pPath-pName);

	 pName = new wchar_t[iNum+1];
	 memcpy(pName,pPath,iNum*2);
	 pName[iNum]=0;

	if(pLen)*pLen=iNum;


return pName;
}

//****************************************************************************
//*
//*		GetFilePath
//*
//****************************************************************************
//	Holt den Dateipfad ohne Datenamen und speichert diesen in einem Puffer.
//	Bei dieser Funktion wird der Pfadname immer auf den vollen Pfad erweitert.
//	(z.B.  C:\Temp\Test.txt --> C:\Temp\)
//	pBuffer		: Zeiger auf den Puffer
//	pPath		: Ist der Zeiger auf den gesamten Pfad.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	Ergibt den Zeiger auf den Puffer mit dem Dateipfad inklusive letzten '\'
int _cdecl GetFilePath(char *pBuffer,const char *pPath,int iMax)
{
int		iNum,iLen;
char    cBuffer[MAX_PATH]="",*pName;


	iNum  = GetFullPathNameA(pPath,MAX_PATH,cBuffer,0);
	pName = GetFileName(cBuffer,&iLen);
	iNum -= iLen;

	if(iNum>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,cBuffer,iNum);
	pBuffer[iNum]=0;

return iNum;
}

int _cdecl GetFilePath(wchar_t *pBuffer,const wchar_t *pPath,int iMax)
{
int			iNum,iLen;
wchar_t		cBuffer[MAX_PATH]=L"",*pName;


	iNum  = GetFullPathNameW(pPath,MAX_PATH,cBuffer,0);
	pName = GetFileName(cBuffer,&iLen);
	iNum -= iLen;

	if(iNum>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,cBuffer,iNum*2);
	pBuffer[iNum]=0;


return iNum;
}

//****************************************************************************
//*
//*		GetFilePathR
//*
//****************************************************************************
//	Holt den Dateipfad ohne Datenamen und speichert diesen in einem Puffer.
//	Bei dieser Funktion wird der Pfadname nicht auf den vollen erweitert.
//	pBuffer		: Zeiger auf den Puffer
//	iNum		: Ist die Lnge des Dateinamens in Zeichen
//	pPath		: Ist der Zeiger auf den gesamten Pfad.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	Ergibt den Zeiger auf den Puffer mit dem Dateipfad inklusive letzten '\'
int _cdecl GetFilePathR(char *pBuffer,int iNum,const char *pPath,int iMax)
{
char    *pName;


	pName = GetFileName(iNum,pPath);
	iNum  = (int)(pName-pPath);

	if(iNum>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,pPath,iNum);
	pBuffer[iNum]=0;


return iNum;
}

int _cdecl GetFilePathR(wchar_t *pBuffer,int iNum,const wchar_t *pPath,int iMax)
{
wchar_t    *pName;


	pName = GetFileName(iNum,pPath);
	iNum  = (int)(pName-pPath);

	if(iNum>=iMax)
		{
		if(iMax>0)pBuffer[0]=0;
		return 0;
		}


	memcpy(pBuffer,pPath,iNum*2);
	pBuffer[iNum]=0;


return iNum;
}

//****************************************************************************
//*
//*		GetFileDrive
//*
//****************************************************************************
// Ergibt die Nummer des Laufwerkes (0 fr A ... ) von Pfad
int _cdecl GetFileDrive(const char *pPath)
{
char		cBuffer[MAX_PATH];
unsigned 	uNum;


	if(!pPath[0] || pPath[1]!=':')
		{
		cBuffer[0] = 0;
		GetFullPathNameA(pPath,MAX_PATH,cBuffer,0);
		pPath=cBuffer;
		}

	uNum=pPath[0];

	if(uNum>='a' && uNum<='b')uNum-=32;


return (uNum>'Z')? -1:(int)uNum;
}

int _cdecl GetFileDrive(const wchar_t *pPath)
{
unsigned 	uNum;
wchar_t		cBuffer[MAX_PATH]=L"";


	if(!pPath[0] || pPath[1]!=':')
		{
		GetFullPathNameW(pPath,MAX_PATH,cBuffer,0);
		pPath=cBuffer;
		}

	uNum=pPath[0];

	if(uNum>='a' && uNum<='b')uNum-=32;


return (uNum>'Z')? -1:(int)uNum;
}

//*****************************************************************************
//*
//*		FilePathLen
//*
//*****************************************************************************
//  Ergibt Lnge des Pfades im Dateiname Pfad inklusive dem letzten '\'
int	_cdecl FilePathLen(int iLen,const char *pPath)
{
int		iPos;



	iLen=(int)strlen(pPath);

	for(iPos=iLen-1;iPos>=0;iPos--)
		{
		if(	pPath[iPos]=='\\' ||
			pPath[iPos]=='/'  ||
			pPath[iPos]==':'	)return iPos+1;
		}


return 0;
}

int	_cdecl FilePathLen(int iLen,const wchar_t *pPath)
{
int		iPos;



	iLen=(int)wcslen(pPath);

	for(iPos=iLen-1;iPos>=0;iPos--)
		{
		if(	pPath[iPos]=='\\' ||
			pPath[iPos]=='/'  ||
			pPath[iPos]==':'	)return iPos+1;
		}


return 0;
}

//*****************************************************************************
//*
//*		FilePathLen
//*
//*****************************************************************************
//  Holt die Lnge des Pfades in einem Dateinamen fr die Anzahl an Ebenen
//	pPath	: Zeiger auf den Dateinamen
//	iLevel	: Ist die Nummer der Ebenen
//	Ergibt die Lnge des Pfades in Zeichen.
int	_cdecl FilePathLen(const char *pPath,int iLevel)
{
int	iPos;


	if(iLevel<=0)return 0;

	   iPos=FileDriveLen(pPath);
	if(iPos>0)iLevel --;
	if(pPath[iPos]=='\\' || pPath[iPos]=='/')iPos++;

	for(iPos;iLevel>0;iPos++)
		{
		if(pPath[iPos]== 0  )break;
		if(pPath[iPos]=='\\')iLevel--;
		if(pPath[iPos]=='/' )iLevel--;
		}


return iPos;
}

int	_cdecl FilePathLen(const wchar_t *pPath,int iLevel)
{
int	iPos;


	if(iLevel<=0)return 0;

	   iPos=FileDriveLen(pPath);
	if(iPos>0)iLevel --;
	if(pPath[iPos]=='\\' || pPath[iPos]=='/')iPos++;

	for(iPos;iLevel>0;iPos++)
		{
		if(pPath[iPos]== 0  )break;
		if(pPath[iPos]=='\\')iLevel--;
		if(pPath[iPos]=='/' )iLevel--;
		}


return iPos;
}

//*****************************************************************************
//*
//*		FileDriveLen
//*
//*****************************************************************************
//  Ergibt Lnge der Laufwerksangabe im Dateiname Pfad exklusive dem letzten '\'
int _cdecl FileDriveLen(const char *pPath)
{
int iLen;


	if(pPath[0]=='\\' || pPath[0]=='/')				// Netzlaufwerk
	if(pPath[1]=='\\' || pPath[1]=='/')
		{
		for(iLen=2;;iLen++)
			{
			if(pPath[iLen]=='\\'||
			   pPath[iLen]=='/' ||
			   pPath[iLen]== 0  )return iLen;
			if(pPath[iLen]==':' )return iLen+1;
			}
		return iLen;
		}

	for(iLen=0;;iLen++)								// Normales Laufwerk
		{
		if(pPath[iLen]=='\\'||
		   pPath[iLen]=='/' ||
		   pPath[iLen]== 0  )return 0;
		if(pPath[iLen]==':' )break;
		}

	iLen++;
	if(pPath[iLen  ]=='\\'|| pPath[iLen  ]=='/')	// Protokoll (http://)
	if(pPath[iLen+1]=='\\'|| pPath[iLen+1]=='/')iLen++;


return iLen;
}

int _cdecl FileDriveLen(const wchar_t *pPath)
{
int iLen;


	if(pPath[0]=='\\' || pPath[0]=='/')				// Netzlaufwerk
	if(pPath[1]=='\\' || pPath[1]=='/')
		{
		for(iLen=2;;iLen++)
			{
			if(pPath[iLen]=='\\'||
			   pPath[iLen]=='/' ||
			   pPath[iLen]== 0  )return iLen;
			if(pPath[iLen]==':' )return iLen+1;
			}
		return iLen;
		}

	for(iLen=0;;iLen++)								// Normales Laufwerk
		{
		if(pPath[iLen]=='\\'||
		   pPath[iLen]=='/' ||
		   pPath[iLen]== 0  )return 0;
		if(pPath[iLen]==':' )break;
		}

	iLen++;
	if(pPath[iLen  ]=='\\'|| pPath[iLen  ]=='/')	// Protokoll (http://)
	if(pPath[iLen+1]=='\\'|| pPath[iLen+1]=='/')iLen++;


return iLen;
}

//*****************************************************************************
//*
//*		FileNameLen
//*
//*****************************************************************************
//  Ergibt Lnge des ersten Namen im Pfad bis zum ersten "/\:"
//	z.B.   "Windows\wxyz0001.bmp" ergibt 7 von "Windows"
int _cdecl FileNameLen(const char *pPath)
{
int		iLen;


	for(iLen=0;1;iLen++)
		{
		if( (pPath[iLen]=='\\')||
			(pPath[iLen]=='/' )||
			(pPath[iLen]==':' )||
			(pPath[iLen]== 0  ))return iLen;
		}


return iLen;
}

int _cdecl FileNameLen(const wchar_t *pPath)
{
int		iLen;


	for(iLen=0;1;iLen++)
		{
		if( (pPath[iLen]=='\\')||
			(pPath[iLen]=='/' )||
			(pPath[iLen]==':' )||
			(pPath[iLen]== 0  ))return iLen;
		}


return iLen;
}

//*****************************************************************************
//*
//*		AddBackSlash
//*
//*****************************************************************************
//	Hngt  ein '\' an einen Pfad an wenn es fehlt.
//	pPath	: Zeiger auf den Pfad
//	iLen	: Ist die Lnge des Pfades, wenn sie kleiner 0 ist,
//			  dann wird die String-Lnge mit strlen ermittelt
//	Ergibt die neue Lnge des Pfades
int	_cdecl AddBackSlash(char *pPath,int iLen)
{

	if(iLen<0)iLen=(int)strlen(pPath);
	if(iLen)
	if(pPath[iLen-1]=='/' || pPath[iLen-1]=='\\')return iLen;

	pPath[iLen]='\\';iLen++;
	pPath[iLen]=0;


return iLen;
}

int	_cdecl AddBackSlash(wchar_t *pPath,int iLen)
{

	if(iLen<0)iLen=(int)wcslen(pPath);
	if(iLen)
	if(pPath[iLen-1]=='/' || pPath[iLen-1]=='\\')return iLen;

	pPath[iLen]='\\';iLen++;
	pPath[iLen]=0;


return iLen;
}

int	_cdecl AddBackSlash(char cSign,char *pPath,int iLen)
{

	if(iLen<0)iLen=(int)strlen(pPath);
	if(iLen)
	if(pPath[iLen-1]=='/' || pPath[iLen-1]=='\\')return iLen;

	pPath[iLen]=cSign;iLen++;
	pPath[iLen]=0;


return iLen;
}

int	_cdecl AddBackSlash(wchar_t cSign,wchar_t *pPath,int iLen)
{

	if(iLen<0)iLen=(int)wcslen(pPath);
	if(iLen)
	if(pPath[iLen-1]=='/' || pPath[iLen-1]=='\\')return iLen;

	pPath[iLen]=cSign;iLen++;
	pPath[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*		DelBackSlash
//*
//*****************************************************************************
//	Lscht ein '\' am Ende eines Pfades wenn es existiert.
//	pPath	: Zeiger auf den Pfad
//	iLen	: Ist die Lnge des Pfades, wenn sie kleiner 0 ist,
//			  dann wird die String-Lnge mit strlen ermittelt
//	Ergibt die neue Lnge des Pfades
int	_cdecl DelBackSlash(char *pPath,int iLen)
{

	if( iLen<0)iLen=(int)strlen(pPath);
	if(!iLen)return 0;
	if( pPath[iLen-1]!='/' && pPath[iLen-1]!='\\')return iLen;

		  iLen--;
	pPath[iLen]=0;


return iLen;
}

int	_cdecl DelBackSlash(wchar_t *pPath,int iLen)
{

	if( iLen<0)iLen=(int)wcslen(pPath);
	if(!iLen)return 0;
	if( pPath[iLen-1]!='/' && pPath[iLen-1]!='\\')return iLen;

		  iLen--;
	pPath[iLen]=0;


return iLen;
}

//*****************************************************************************
//*
//*		HasBackSlash
//*
//*****************************************************************************
//	Prft ob ein '\' oder ein '/' Zeichen am Ende eines Pfades ist.
//	pPath	: Zeiger auf den Pfad
//	iLen	: Ist die Lnge des Pfades, wenn sie kleiner 0 ist,
//			  dann wird die String-Lnge mit strlen ermittelt
//	Ergibt 1 wenn ein '\' am Ende existiert
int	_cdecl HasBackSlash(const char *pPath,int iLen)
{

	if( iLen<0)iLen=(int)strlen(pPath);
	if(!iLen)return 0;
	if( pPath[iLen-1]=='/' || pPath[iLen-1]=='\\')return 1;


return 0;
}

int	_cdecl HasBackSlash(const wchar_t *pPath,int iLen)
{

	if( iLen<0)iLen=(int)wcslen(pPath);
	if(!iLen)return 0;
	if( pPath[iLen-1]=='/' || pPath[iLen-1]=='\\')return 1;


return 0;
}

//*****************************************************************************
//*
//*		RemoveFile
//*
//*****************************************************************************
//	Lscht eine Datei, auch wenn sie schreibgeschtzt ist.
//	pPath	: Zeiger auf den Dateinamen
//	Ergibt 1 wenn Datei gelscht wurde
int	_cdecl RemoveFile(const char *pPath)
{

	if(DeleteFileA(pPath))return 1;
	if(GetLastError()!=ERROR_ACCESS_DENIED)return 0;

	   SetFileAttributesA(pPath,FILE_ATTRIBUTE_NORMAL);
	if(DeleteFileA(pPath))return 1;


return 0;
}

int	_cdecl RemoveFile(const wchar_t *pPath)
{

	if(DeleteFileW(pPath))return 1;
	if(GetLastError()!=ERROR_ACCESS_DENIED)return 0;

	   SetFileAttributesW(pPath,FILE_ATTRIBUTE_NORMAL);
	if(DeleteFileW(pPath))return 1;


return 0;
}

//*****************************************************************************
//*
//*		PasteFileType
//*
//*****************************************************************************
//	Fft einen Suffix vor dem Typanhang eines Dateinamens (z.B. Test.txt --> Text.XXX.txt )
//	iLen		: Ist die Lnge des Dateinamens in Zeichen.
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der neue
//				  Dateiname gespeichert wird.
//	pPath		: Ist der Dateinamen der gendert werden soll. Wenn dieser
//				  Parameter nicht angegeben ist, steht der Dateiname in pBuffer.
//	pType		: Ist der neue Typanhang der eingefgt wird.
//				  Er kann auch "." oder "*." am Anfang enthalten.
//	iMax		: Ist die Gre des Puffers
//	Ergibt die neue Lnge des Dateinamens im Puffer.
int _cdecl PasteFileType(int iLen,char *pBuffer,const char *pPath,const char *pType,int iMax)
{
int		i,iAdd;


	   iMax--;
	if(iMax<0)return 0;

	if(*pType=='*')pType++;
	if(*pType=='.')pType++;

	iAdd=(int)strlen(pType);

	for(i=iLen;i>=0;i--)								// Suche Typ
		{
		if(pPath[i]=='.' )break;
		if(pPath[i]=='\\' ||
		   pPath[i]=='/'  ||
		   pPath[i]==':'		){i=iLen;break;}
		}

	if(i<0)i=iLen;

	if(iLen+iAdd+1>iMax)								// Zu wenig Speicher
		{
		if(pBuffer!=pPath)
			{
			memcpy(pBuffer,pPath,iMax);
			pBuffer[iMax]=0;
			}

		return iMax;
		}

	if(pBuffer!=pPath)									// Pfad bis '.' kopieren
		{
		memmove(pBuffer,pPath,i);					
		}

	memmove(pBuffer+i+iAdd+1,pPath+i,iLen-i+1);			// Dateianhang verschieben


	pBuffer[i] = '.';
	memcpy(pBuffer+i+1,pType,iAdd);						// Typ einfgen
														

return iLen+iAdd+1;
}

int _cdecl PasteFileType(int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pType,int iMax)
{
int		i,iAdd;


	   iMax--;
	if(iMax<0)return 0;

	if(*pType=='*')pType++;
	if(*pType=='.')pType++;

	iAdd=(int)wcslen(pType);

	for(i=iLen;i>=0;i--)								// Suche Typ
		{
		if(pPath[i]=='.' )break;
		if(pPath[i]=='\\' ||
		   pPath[i]=='/'  ||
		   pPath[i]==':'		){i=iLen;break;}
		}

	if(i<0)i=iLen;

	if(iLen+iAdd+1>iMax)								// Zu wenig Speicher
		{
		if(pBuffer!=pPath)
			{
			memcpy(pBuffer,pPath,iMax*2);
			pBuffer[iMax]=0;
			}

		return iMax;
		}

	if(pBuffer!=pPath)									// Pfad bis '.' kopieren
		{
		memmove(pBuffer,pPath,i*2);					
		}

	memmove(pBuffer+i+iAdd+1,pPath+i,(iLen-i+1)*2);		// Dateianhang verschieben


	pBuffer[i] = '.';
	memcpy(pBuffer+i+1,pType,iAdd*2);					// Typ einfgen


return iLen+iAdd+1;
}

//*****************************************************************************
//*
//*		SetFileType
//*
//*****************************************************************************
//	ndert den Typanhang eines Dateinamens (z.B. Test.txt --> Text.log )
//	iLen		: Ist die Lnge des Dateinamens in Zeichen
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der neue
//				  Dateiname gespeichert wird.
//	pPath		: Ist der Dateinamen der gendert werden soll. Wenn dieser
//				  Parameter nicht angegeben ist, steht der Dateiname in pBuffer.
//	pType		: Ist der neue Typanhang der eingefgt wird.
//				  Er kann auch "." oder "*." am Anfang enthalten.
//	iMax		: Ist die Gre des Puffers
//	Ergibt die neue Lnge des Dateinamens im Puffer.
int _cdecl SetFileType(int iLen,char *pBuffer,const char *pPath,const char *pType,int iMax)
{
int		i;


	   iMax--;
	if(iMax<0)return 0;

	if(*pType=='*')pType++;
	if(*pType=='.')pType++;

	for(i=iLen;i>=0;i--)								// Suche Typ
		{
		if(pPath[i]=='.' )
			{
			if(i==0            ){i=iLen;break;}
			if(pPath[i-1]=='\\'){i=iLen;break;}
			if(pPath[i-1]=='/' ){i=iLen;break;}
			if(pPath[i-1]==':' ){i=iLen;break;}
			break;
			}
		
		if(pPath[i]=='\\' ||
		   pPath[i]=='/'  ||
		   pPath[i]==':'	   ){i=iLen;break;}
		}

	if(i<0)i=iLen;

	if(i+1>=iMax)										// Zu wenig Speicher
		{
		if(pBuffer!=pPath)
			{
			memcpy(pBuffer,pPath,iMax);
			pBuffer[iMax]=0;
			}

		return iMax;
		}

	if(pBuffer!=pPath)									// Pfad bis '.' kopieren
		{
		memmove(pBuffer,pPath,i);						
		}

	if(*pType==0)										// Kein Typ
		{
		pBuffer[i]=0;
		return i;
		}

	pBuffer[i]='.';i++;

	while(i<iMax)										// Typ anhngen
		{
		pBuffer[i]=*pType;
		i++;pType++;
		if(*pType==0)break;
		}


	pBuffer[i]=0;


return i;
}

int _cdecl SetFileType(int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pType,int iMax)
{
int		i;


	   iMax--;
	if(iMax<0)return 0;

	if(*pType=='*')pType++;
	if(*pType=='.')pType++;


	for(i=iLen;i>=0;i--)								// Suche Typ
		{
		if(pPath[i]=='.' )
			{
			if(i==0            ){i=iLen;break;}
			if(pPath[i-1]=='\\'){i=iLen;break;}
			if(pPath[i-1]=='/' ){i=iLen;break;}
			if(pPath[i-1]==':' ){i=iLen;break;}
			break;
			}

		if(pPath[i]=='\\' ||
		   pPath[i]=='/'  ||
		   pPath[i]==':'	   ){i=iLen;break;}
		}

	if(i<0)i=iLen;

	if(i+1>=iMax)										// Zu wenig Speicher
		{
		if(pBuffer!=pPath)
			{
			memcpy(pBuffer,pPath,iMax*2);
			pBuffer[iMax]=0;
			}

		return iMax;
		}

	if(pBuffer!=pPath)									// Pfad bis '.' kopieren
		{
		memmove(pBuffer,pPath,i*2);						
		}

	if(*pType==0)										// Kein Typ
		{
		pBuffer[i]=0;
		return i;
		}

	pBuffer[i]='.';i++;

	while(i<iMax)										// Typ anhngen
		{
		pBuffer[i]=*pType;
		i++;pType++;
		if(*pType==0)break;
		}


	pBuffer[i]=0;


return i;
}

//*****************************************************************************
//*
//*		SetFileName
//*
//*****************************************************************************
//	ndert den Dateinamen eines Pfade (z.B. C:\Temp\Test.txt --> C:\Temp\Abcd.log )
//	iLen		: Ist die Lnge des Pfades in Zeichen
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der neue
//				  Pfad gespeichert wird.
//	pPath		: Ist der Pfad der gendert werden soll. Wenn dieser Parameter
//				  nicht angegeben ist, steht der Pfad in pBuffer.
//	pName		: Ist der neue Dateiname der eingefgt wird.
//	iMax		: Ist die Gre des Puffers
//	iNameSize	: Ist die Lnge des neuen Dateinames, bei -1 wird er mit strlen() 
//				  ermittelt.
//	Ergibt die neue Lnge des Dateinamens im Puffer.
int _cdecl SetFileName(int iLen,char *pBuffer,const char *pPath,const char *pName,int iMax,int iNameSize)
{
int		i;


	   iMax--;
	if(iMax<0)return 0;

	
	for(i=iLen;i>0;i--)								// Suche Dateinamen
		{
		if(pPath[i]=='\\' || pPath[i]=='/' || pPath[i]==':')
			{
			i++;
			break;
			}
		}

	if(i>=iMax)										// Zu wenig Speicher
		{
		if(pBuffer!=pPath)
			{
			memcpy(pBuffer,pPath,iMax);
			pBuffer[iMax]=0;
			}

		return iMax;
		}

	if(pBuffer!=pPath)
		{
		memmove(pBuffer,pPath,i);
		}

	if(iNameSize>=0)								// Lnge des Namens bekannt
		{
		if(i+iNameSize>iMax)
			{
			iNameSize = iMax-i;
			}

		memcpy(pBuffer+i,pName,iNameSize);
		i += iNameSize;
		}
	else{
		while(i<iMax)								// Name anhngen
			{
			if(*pName==0)break;
			pBuffer[i]=*pName;
			i++;pName++;
			}
		}

	pBuffer[i]=0;


return i;
}

int _cdecl SetFileName(int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax,int iNameSize)
{
int		i;


	   iMax--;
	if(iMax<0)return 0;

	
	for(i=iLen;i>0;i--)								// Suche Dateinamen
		{
		if(pPath[i]=='\\' || pPath[i]=='/' || pPath[i]==':')
			{
			i++;
			break;
			}
		}

	if(i>=iMax)										// Zu wenig Speicher
		{
		if(pBuffer!=pPath)
			{
			memcpy(pBuffer,pPath,iMax*2);
			pBuffer[iMax]=0;
			}

		return iMax;
		}

	if(pBuffer!=pPath)
		{
		memmove(pBuffer,pPath,i*2);
		}

	if(iNameSize>=0)								// Lnge des Namens bekannt
		{
		if(i+iNameSize>iMax)
			{
			iNameSize = iMax-i;
			}

		memcpy(pBuffer+i,pName,iNameSize*2);
		i += iNameSize;
		}
	else{
		while(i<iMax)								// Name anhngen
			{
			if(*pName==0)break;
			pBuffer[i]=*pName;
			i++;pName++;
			}
		}

	pBuffer[i]=0;


return i;
}

//*****************************************************************************
//*
//*		GetExePath
//*
//*****************************************************************************
//	Speichert den Pfad der aktuellen EXE-Datei in einem Puffer
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der Pfad gespeichert wird.
//	iMax		: Ist die Gre des Puffers in Zeichen
//	Ergibt die Lnge des Pfades in Zeichen inklusive '\' am Ende.
int _cdecl GetExePath(char *pBuffer,int iMax)
{
       GetExeName (pBuffer,   iMax  );
return SetFileName(pBuffer,"",iMax,0);
}

int _cdecl GetExePath(wchar_t *pBuffer,int iMax)
{
       GetExeName (pBuffer,    iMax  );
return SetFileName(pBuffer,L"",iMax,0);
}



//*****************************************************************************
//*
//*		GetExeName
//*
//*****************************************************************************
//	Speichert den Namen der aktuellen EXE-Datei in einem Puffer
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der Pfad gespeichert wird.
//	iMax		: Ist die Gre des Puffers in Zeichen
//	Ergibt die Lnge des Pfades in Zeichen.
int _cdecl GetExeName(char *pBuffer,int iMax)
{
int			i;


	i=GetModuleFileNameA(GetModuleHandle(0),pBuffer,iMax);

	if(i==0 && iMax>0)*pBuffer=0;


return i;
}

int _cdecl GetExeName(wchar_t *pBuffer,int iMax)
{
int			i;


	i=GetModuleFileNameW(GetModuleHandle(0),pBuffer,iMax);

	if(i==0 && iMax>0)*pBuffer=0;


return i;
}



#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)


//*****************************************************************************
//*
//*		CreateTemPath
//*
//*****************************************************************************
//	Erzeugt ein temporres Verzeichnis samt Unterverzeichnissen
//	sTarget	: Hier wird der Verzeichnisname samt Backslash gespeichert.
//	pName?	: Sind die das Unterverzeichnisse die angehngt werden. Wenn ein
//			  Name  mit '*' beginnt, wird der der vorherige Backslash entfernt.
//			  Wenn ein Name  mit '?' beginnt, ist der letzte Abschnitt eine Datei.
//			  Wenn ein Name mit '#' beginnt, wird das vorherige Suffix verndert.
//			  ('*' und '#' mssen gegebenfalls vor '?' stehen)
//			  Der Name kann mit und ohne Backslash beginnen bzw. enden.
//					CTP_USEEXE	= Statt GetTempPath wird GetExePath benutzt (nur bei pName1)
//					CTP_UNIQUE	= Eine eindeutige 8 stellige ID anhngen
//					CTP_UNIADD	= Eine eindeutige 8 stellige ID anhngen ohne Backslash
//	pLen	: Hier wird die Lnge des Verzeichnisnamens gespeichert
//			  wenn dieser Zeiger nicht NULL ist.
//	Ergibt 0 bei einem Fehler
//		   1 wenn der Pfad erzeugt wurde
//         2 wenn der Pfad bereits existiert
int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int *pLen)
{
zchar  *pPath;
int		iRet;

	pPath = sTarget.GetBuffer(1024);
	iRet  = CreateTempPath(pPath,1024,pName1,pName2,pName3,pName4,pLen);
	sTarget.ReleaseBuffer();

return iRet;
}

#ifdef 	_DEBUG

int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int &iLen){return CreateTempPath(sTarget,pName1,pName2,pName3,pName4,&iLen);}
int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2,const void *pName3                   ,int &iLen){return CreateTempPath(sTarget,pName1,pName2,pName3,0     ,&iLen);}
int  _cdecl CreateTempPath(CString &sTarget,const void *pName1,const void *pName2                                      ,int &iLen){return CreateTempPath(sTarget,pName1,pName2,0     ,0     ,&iLen);}
int  _cdecl CreateTempPath(CString &sTarget,const void *pName1                                                         ,int &iLen){return CreateTempPath(sTarget,pName1,0     ,0     ,0     ,&iLen);}

#endif

//*****************************************************************************
//*
//*		PasteFileType
//*
//*****************************************************************************
//	Fft einen Suffix vor dem Typanhang eines Dateinamens (z.B. Test.txt --> Text.XXX.txt )
//	sTarget			: Ist das CString  Objekt in dem der neue Dateiname gespeichert wird.
//	pPath/sSource	: Ist der Dateinamen der gendert werden soll. Wenn dieser
//					  Parameter nicht angegeben ist, steht der Dateiname in pBuffer.
//	pType			: Ist der neue Typanhang der eingefgt wird.
//					  Er kann auch "." oder "*." am Anfang enthalten.
//	Ergibt die neue Lnge des Dateinamens im Puffer.
int _cdecl PasteFileType(CString &sTarget,const zchar *pType)
{
zchar  *pPtr;	
int		iAdd;
int		iLen;


	iAdd = (int)strzlen(pType)+2;
	iLen = sTarget.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iAdd);

	iLen = PasteFileType(iLen,pPtr,pPtr,pType,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}


int _cdecl PasteFileType(CString &sTarget,const zchar *pPath,const zchar *pType)
{
zchar  *pPtr;	
int		iAdd;
int		iLen;


	iAdd = (int)strzlen(pType)+2;
	iLen = (int)strzlen(pPath);
	pPtr = sTarget.GetBuffer(iLen+iAdd);

	iLen = PasteFileType(iLen,pPtr,pPath,pType,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int	 _cdecl	PasteFileType(CString &sTarget,CString &sSource,const zchar *pType)
{
const zchar *pStr;
zchar       *pPtr;	
int			 iAdd;
int			 iLen;


	iAdd = (int)strzlen(pType)+2;
	iLen = sSource.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iAdd);
	pStr = sSource;

	iLen = PasteFileType(iLen,pPtr,pStr,pType,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

//*****************************************************************************
//*
//*		SetFileType
//*
//*****************************************************************************
//	ndert den Typanhang eines Dateinamens (z.B. Test.txt --> Text.log )
//	sTarget			: Ist das CString  Objekt in dem der neue Dateiname gespeichert wird.
//	pPath/sSource	: Ist der Dateinamen der gendert werden soll. Wenn dieser
//					  Parameter nicht angegeben ist, steht der Dateiname in sTarget.
//	pType			: Ist der neue Typanhang der eingefgt wird.
//					  Er kann auch "." oder "*." am Anfang enthalten.
//	Ergibt die neue Lnge des neuen Pfades.
int _cdecl SetFileType(CString &sTarget,const zchar *pType)
{
zchar  *pPtr;	
int		iAdd;
int		iLen;


	iAdd = (int)strzlen(pType)+2;
	iLen = sTarget.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iAdd);

	iLen = SetFileType(iLen,pPtr,pPtr,pType,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl SetFileType(CString &sTarget,const zchar *pPath,const zchar *pType)
{
zchar  *pPtr;	
int		iAdd;
int		iLen;


	iAdd = (int)strzlen(pType)+2;
	iLen = (int)strzlen(pPath);
	pPtr = sTarget.GetBuffer(iLen+iAdd);

	iLen = SetFileType(iLen,pPtr,pPath,pType,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl SetFileType(CString &sTarget,CString &sSource,const zchar *pType)
{
const zchar *pStr;
zchar       *pPtr;	
int			 iAdd;
int			 iLen;


	iAdd = (int)strzlen(pType)+2;
	iLen = sSource.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iAdd);
	pStr = sSource;

	iLen = SetFileType(iLen,pPtr,pStr,pType,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

//*****************************************************************************
//*
//*		SetFileName
//*
//*****************************************************************************
//	ndert den Dateianhang eines Pfades (z.B. C:\Temp\Test.txt --> C:\Temp\Abcd.log )
//	sTarget			: Ist das CString  Objekt in dem der neue Dateiname gespeichert wird.
//	pPath/sSource	: Ist der Pfad der gendert werden soll. Wenn dieser
//					  Parameter nicht angegeben ist, steht der Pfad in sTarget.
//	pName			: Ist der neue Dateianhang der eingefgt wird.
//	iNameSize		: Ist die Lnge des neuen Pfadnamens in Zeichen.
//					  Bei -1 wird die Lnge mit strlen(...) ermittelt
//	Ergibt die neue Lnge des neuen Pfades.
int _cdecl SetFileName(CString &sTarget,const zchar *pName,int iNameSize)
{
zchar  *pPtr;	
int		iLen;


	if(iNameSize<0)
		{
		iNameSize = (int)strzlen(pName);
		}
	
	iLen = sTarget.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iNameSize+2);

	iLen = SetFileName(iLen,pPtr,pPtr,pName,iLen+iNameSize+2,iNameSize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl SetFileName(CString &sTarget,const zchar *pPath,const zchar *pName,int iNameSize)
{
zchar  *pPtr;	
int		iLen;

	if(iNameSize<0)
		{
		iNameSize = (int)strzlen(pName);
		}
	
	iLen = (int)strzlen(pPath);
	pPtr = sTarget.GetBuffer(iLen+iNameSize+2);

	iLen = SetFileName(iLen,pPtr,pPath,pName,iLen+iNameSize+2,iNameSize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl SetFileName(CString &sTarget,CString &sSource,const zchar *pName,int iNameSize)
{
const zchar *pStr;
zchar       *pPtr;	
int			 iLen;


	if(iNameSize<0)
		{
		iNameSize = (int)strzlen(pName);
		}
	
	iLen = sSource.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iNameSize+2);
	pStr = sSource;

	iLen = SetFileName(iLen,pPtr,pStr,pName,iLen+iNameSize+2,iNameSize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

//*****************************************************************************
//*
//*		AddBackSlash
//*
//*****************************************************************************
//	Hngt ein '\' an einen Pfad an wenn es fehlt.
//	sPath	: Ist der Pfad
//	Ergibt die neue Lnge des Pfades
int _cdecl	AddBackSlash(CString &sPath)
{
int		iLen;
zchar 	cChar;



	   iLen=sPath.GetLength();
	if(iLen>0)
		{
		cChar = sPath[iLen-1];

		if(cChar=='\\' || cChar=='/')return iLen;
		}

	sPath += "\\";


return iLen+1;
}

int _cdecl	AddBackSlash(CString &sPath,zchar cSign)
{
zchar 	cAdd[2]={cSign,0};
zchar 	cChar;
int		iLen;



	   iLen=sPath.GetLength();
	if(iLen>0)
		{
		cChar = sPath[iLen-1];

		if(cChar=='\\' || cChar=='/')return iLen;
		}

	sPath += cAdd;


return iLen+1;
}

//*****************************************************************************
//*
//*		DelBackSlash
//*
//*****************************************************************************
//	Lscht ein '\' oder ein '/' Zeichen am Ende eines Pfades.
//	sPath	: Ist der Pfad
//	Ergibt die neue Lnge des Pfades
int _cdecl	DelBackSlash(CString &sPath)
{
int		iLen;
zchar 	cChar;


	   iLen=sPath.GetLength();
	if(iLen<=0)return 0;

	cChar=sPath[iLen-1];

	if(cChar!='\\' && cChar!='/')return iLen;

	sPath=sPath.Left(iLen-1);


return iLen-1;
}

//*****************************************************************************
//*
//*		GetFileBody
//*
//*****************************************************************************
//	Holt den Namenskern aus einem Dateinamen ohne Suffix.
//	z.B.  "C:\Temp\Test.txt" --> "Test"
//	sTarget		: Hier wird der Pfad gespeichert
//	pPath		: Ist der Zeiger auf den Dateinamen aus dem der
//				  Namenskern geholt wird.
//	Ergibt die Lnge des Pfades in Zeichen
int _cdecl GetFileBody(CString &sTarget,const zchar *pPath)
{
zchar  *pPtr;
int		iLen;



	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		iLen  = sTarget.GetLength();
		pPath = (zchar*)alloca((iLen+1)*sizeof(zchar));
		memcpy ((zchar*)pPath,pPtr,iLen);
		}
	else{
		iLen  = (int)strzlen(pPath);
		}

	pPtr = sTarget.GetBuffer(MAX_PATH);
	iLen = GetFileBody(pPtr,iLen,pPath,MAX_PATH);
	sTarget.ReleaseBuffer(iLen);


return iLen;
}

//*****************************************************************************
//*
//*		GetFilePath
//*
//*****************************************************************************
//	Holt den Pfad aus einem Dateinamen (z.B.  C:\Temp\Test.txt --> C:\Temp\)
//	Bei dieser Funktion wird der Pfadname immer auf den vollen Pfad erweitert.
//	sTarget		: Hier wird der Pfad gespeichert
//	pPath		: Ist der Zeiger auf den vollen Dateinamen
//	Ergibt die Lnge des Pfades in Zeichen
int _cdecl GetFilePath(CString &sTarget,const zchar *pPath)
{
zchar  *pPtr;
int		iLen;


	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		iLen  = (sTarget.GetLength()+1)*sizeof(zchar);
		pPath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pPath,pPtr,iLen);
		}

	pPtr = sTarget.GetBuffer(MAX_PATH);*pPtr=0;
	iLen = GetFullPathName(pPath,MAX_PATH,pPtr,0);
	iLen = FilePathLen(pPtr);

	pPtr[iLen]=0;
	sTarget.ReleaseBuffer(iLen);


return iLen;
}

//*****************************************************************************
//*
//*		GetFilePathR
//*
//*****************************************************************************
//	Holt den Pfad aus einem Dateinamen (z.B.  C:\Temp\Test.txt --> C:\Temp\)
//	Bei dieser Funktion wird der Pfadname nie auf den vollen Pfad erweitert.
//	sTarget		: Hier wird der Pfad gespeichert
//	pPath		: Ist der Zeiger auf den vollen Dateinamen
//	Ergibt die Lnge des Pfades in Zeichen
int _cdecl GetFilePathR(CString &sTarget,const zchar *pPath)
{
zchar   *pPtr;
int		 iLen;




	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		iLen  = (sTarget.GetLength()+1)*sizeof(zchar);
		pPath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pPath,pPtr,iLen);
		}

	iLen = FilePathLen(pPath);
	pPtr = sTarget.GetBuffer(iLen+1);
	memcpy(pPtr,pPath,iLen*sizeof(zchar));

	pPtr[iLen] = 0;
	sTarget.ReleaseBuffer(iLen);



return iLen;
}

//*****************************************************************************
//*
//*		GetFileName
//*
//*****************************************************************************
//	Holt den Dateianhang aus einem Dateinamen (z.B.  C:\Temp\Test.txt --> Test.txt)
//	sTarget		: Hier wird der Dateianhang gespeichert
//	pPath		: Ist der Zeiger auf den vollen Dateinamen
//	Ergibt die Lnge des Dateianhangs in Zeichen
int _cdecl GetFileName(CString &sTarget,const zchar *pPath)
{
       sTarget=GetFileName(pPath);
return sTarget.GetLength();
}

//*****************************************************************************
//*
//*		GetFileType
//*
//*****************************************************************************
//	Holt den Dateityp aus einem Dateinamen (z.B.  C:\Temp\Test.txt --> txt)
//	sTarget		: Hier wird der Dateityp gespeichert
//	pPath		: Ist der Zeiger auf den vollen Dateinamen
//	Ergibt die Lnge des Dateianhangs in Zeichen
int _cdecl GetFileType(CString &sTarget,const zchar *pPath)
{
       sTarget=GetFileType(pPath);
return sTarget.GetLength();
}

//*****************************************************************************
//*
//*		GetExeName
//*
//*****************************************************************************
//	Speichert den Namen der aktuellen EXE-Datei in einem CString Objekt
//	sPath		: Hier wird der Dateiname gespeichert.
//	Ergibt die Lnge des Pfades in Zeichen.
int _cdecl GetExeName(CString &sPath)
{
zchar  *pPtr;
int		iLen;


	pPtr = sPath.GetBuffer(MAX_PATH);
	iLen = GetExeName(pPtr,MAX_PATH);
	sPath.ReleaseBuffer(iLen);


return iLen;
}

//*****************************************************************************
//*
//*		GetExePath
//*
//*****************************************************************************
//	Speichert den Pfadanteil der aktuellen EXE-Datei in einem CString Objekt
//	sPath		: Hier wird der Pfad gespeichert.
//	Ergibt die Lnge des Pfades in Zeichen inklusive '\' am Ende.
int _cdecl GetExePath(CString &sPath)
{
       GetExeName (sPath);
return SetFileName(sPath,Z(""),0);
}

#endif

//*****************************************************************************
//*
//*		CmpFileType
//*
//*****************************************************************************
//	Vergleicht den Datei-Typ von einem Pfad mit einem Typ-Suffix
//	pPath	: Zeiger auf den Dateinamen
//	pType	: Zeiger auf die Typ-Sufixe. Es knnen auch meherer Typen
//			  gespeichert sein (z.B. "exe;txt;cpp" )
//	Ergibt 1 wenn Typen gleich sind sonst 0.
int	 _cdecl	CmpFileType(const char *pPath,const char *pType,int iLen)
{
int 	iNum;
int		iPos;



	iNum = iLen;

	for(iLen--;iLen>=0;iLen--)						// Suche Typ-Suffix
		{
		if(pPath[iLen]=='\\'){iLen=-1;break;}
		if(pPath[iLen]=='/' ){iLen=-1;break;}
		if(pPath[iLen]==':' ){iLen=-1;break;}
		if(pPath[iLen]=='.' )
			{
			if(iLen==0            ){iLen=iNum;break;}
			if(pPath[iLen-1]=='\\'){iLen=iNum;break;}
			if(pPath[iLen-1]=='/' ){iLen=iNum;break;}
			if(pPath[iLen-1]==':' ){iLen=iNum;break;}
			iLen++; 
			break;
			}
		}

	if(iLen<0)iLen=iNum;							// Kein Typ-Suffix gefunden

	pPath+=iLen;
	iNum -=iLen;

	for(iPos=1;;iPos++)
		{
		for(iLen=0;;iLen++)							// Typelnge holen
			{
			if(pType[iLen]== 0 )break;
			if(pType[iLen]==';')break;
			}

		if(iLen==iNum && !strnicmp(pPath,pType,iNum))
			{
			return iPos;
			}

			pType+=iLen;							// Nchster Typ
		if(*pType==0)break;

		pType++;
		}


return 0;
}

int	 _cdecl	CmpFileType(const wchar_t *pPath ,const wchar_t *pType,int iLen)
{
int 	iNum;
int		iPos;


	iNum = iLen;

	for(iLen--;iLen>=0;iLen--)						// Suche Typ-Suffix
		{
		if(pPath[iLen]=='\\'){iLen=-1;break;}
		if(pPath[iLen]=='/' ){iLen=-1;break;}
		if(pPath[iLen]==':' ){iLen=-1;break;}
		if(pPath[iLen]=='.' )
			{
			if(iLen==0            ){iLen=iNum;break;}
			if(pPath[iLen-1]=='\\'){iLen=iNum;break;}
			if(pPath[iLen-1]=='/' ){iLen=iNum;break;}
			if(pPath[iLen-1]==':' ){iLen=iNum;break;}
			iLen++; 
			break;
			}
		}

	if(iLen<0)iLen=iNum;							// Kein Typ-Suffix gefunden

	pPath+=iLen;
	iNum -=iLen;

	for(iPos=1;;iPos++)
		{
		for(iLen=0;;iLen++)							// Typelnge holen
			{
			if(pType[iLen]== 0 )break;
			if(pType[iLen]==';')break;
			}

		if(iLen==iNum && !wcsnicmp(pPath,pType,iNum))
			{
			return iPos;
			}

			pType+=iLen;							// Nchster Typ
		if(*pType==0)break;

		pType++;
		}


return 0;
}

//*****************************************************************************
//*
//*		CmpFileNameN
//*
//*****************************************************************************
//	Vergleiche zwei Dateinamen ohne gro/klein Unterscheitung
//	pPath1	: Zeiger auf den ersten Pfad
//	pPath2	: Zeiger auf den zweiten Pfad
//	Ergibt	:	=0 wenn die Dateien gleich sind
//				>0 wenn pPath1 grer  pPath2
//				<0 wenn pPath1 kleiner pPath2
int _cdecl CmpFileNameN(const char *pPath1,const char *pPath2)
{
int 	c,d,e;
int		i,j;


	for(i=0;;i++)									// Vergleiche die Pfade
		{
		c = aNameTableN[((unsigned char*)pPath1)[i]];
		d = aNameTableN[((unsigned char*)pPath2)[i]];

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		c = aNameTableN[((unsigned char*)pPath1)[j]];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		d = aNameTableN[((unsigned char*)pPath2)[i]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameN(const wchar_t *pPath1,const wchar_t *pPath2)
{
int 	c,d,e;
int		i,j;


	for(i=0;;i++)									// Vergleiche die Pfade
		{
		c = pPath1[i];
		c = (c<256)? c=aNameTableN[c]:c<<8;

		d = pPath2[i];
		d = (d<256)? d=aNameTableN[d]:d<<8;

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		c = pPath1[j];
		if(c<128)c=aNameTableN[c];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		d = pPath2[i];
		if(d<128)d=aNameTableN[d];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameN(const char *pPath1,const char *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j,k;


	k = (iLen1<iLen2)? iLen1:iLen2;

	for(i=0;;i++)									// Vergleiche die Pfade
		{
		if(i>=k)									// Ende erreicht
			{
			return iLen1-iLen2;
			}

		c = aNameTableN[((unsigned char*)pPath1)[i]];
		d = aNameTableN[((unsigned char*)pPath2)[i]];

		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		if(j>=iLen1){c=0;break;}
		c = aNameTableN[((unsigned char*)pPath1)[j]];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen2){d=0;break;}
		d = aNameTableN[((unsigned char*)pPath2)[i]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameN(const wchar_t *pPath1,const wchar_t *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j,k;


	k = (iLen1<iLen2)? iLen1:iLen2;

	for(i=0;;i++)									// Vergleiche die Pfade
		{
		if(i>=k)									// Ende erreicht
			{
			return iLen1-iLen2;
			}

		c = pPath1[i];
		c = (c<256)? c=aNameTableN[c]:c<<8;

		d = pPath2[i];
		d = (d<256)? d=aNameTableN[d]:d<<8;


		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		if(j>=iLen1){c=0;break;}
		c = pPath1[j];
		if(c<128)c=aNameTableN[c];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen2){d=0;break;}
		d = pPath2[i];
		if(d<128)d=aNameTableN[d];
		}

	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

//*****************************************************************************
//*
//*		CmpFileNameG
//*
//*****************************************************************************
//	Vergleiche zwei Dateinamen mit gro/klein Unterscheitung
//	pPath1	: Zeiger auf den ersten Pfad
//	pPath2	: Zeiger auf den zweiten Pfad
//	Ergibt	:	=0 wenn die Dateien gleich sind
//				>0 wenn pPath1 grer  pPath2
//				<0 wenn pPath1 kleiner pPath2
//	Ergibt Null wenn die Dateien gleich sind
int _cdecl CmpFileNameG(const char *pPath1,const char *pPath2)
{
int 	c,d,e;
int		i,j;


	for(i=0;;i++)									// Vergleiche die Pfade
		{
		c = aNameTableG[((unsigned char*)pPath1)[i]];
		d = aNameTableG[((unsigned char*)pPath2)[i]];

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		c = aNameTableG[((unsigned char*)pPath1)[j]];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		d = aNameTableG[((unsigned char*)pPath2)[i]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameG(const wchar_t *pPath1,const wchar_t *pPath2)
{
int 	c,d,e;
int		i,j;


	for(i=0;;i++)									// Vergleiche die Pfade
		{
		c = pPath1[i];
		c = (c<256)? c=aNameTableG[c]:c<<8;

		d = pPath2[i];
		d = (d<256)? d=aNameTableG[d]:d<<8;

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		c = pPath1[j];
		if(c<128)c=aNameTableG[c];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		d = pPath2[i];
		if(d<128)d=aNameTableG[d];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameG(const char *pPath1,const char *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j,k;


	k = (iLen1<iLen2)? iLen1:iLen2;

	for(i=0;;i++)									// Vergleiche die Pfade
		{
		if(i>=k)									// Ende erreicht
			{
			return iLen1-iLen2;
			}

		c = aNameTableG[((unsigned char*)pPath1)[i]];
		d = aNameTableG[((unsigned char*)pPath2)[i]];

		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		if(j>=iLen1){c=0;break;}
		c = aNameTableG[((unsigned char*)pPath1)[j]];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen2){d=0;break;}
		d = aNameTableG[((unsigned char*)pPath2)[i]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameG(const wchar_t *pPath1,const wchar_t *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j,k;


	k = (iLen1<iLen2)? iLen1:iLen2;

	for(i=0;;i++)									// Vergleiche die Pfade
		{
		if(i>=k)									// Ende erreicht
			{
			return iLen1-iLen2;
			}

		c = pPath1[i];
		c = (c<256)? c=aNameTableG[c]:c<<8;

		d = pPath2[i];
		d = (d<256)? d=aNameTableG[d]:d<<8;


		if(c!=d)break;
		}

	e = c-d;

	for(j=i;c>1;j++)								// Zum nchsten Segment
		{
		if(j>=iLen1){c=0;break;}
		c = pPath1[j];
		if(c<128)c=aNameTableG[c];
		}

	for(;d>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen2){d=0;break;}
		d = pPath2[i];
		if(d<128)d=aNameTableG[d];
		}

	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

//*****************************************************************************
//*
//*		CmpFileNameV
//*
//*****************************************************************************
//	Vergleiche zwei Dateinamen ohne gro/klein Unterscheitung mit Zahlen
//	pPath1	: Zeiger auf den ersten Pfad
//	pPath2	: Zeiger auf den zweiten Pfad
//	Ergibt	:	=0 wenn die Dateien gleich sind
//				>0 wenn pPath1 grer  pPath2
//				<0 wenn pPath1 kleiner pPath2
int _cdecl CmpFileNameV(const char *pPath1,const char *pPath2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = aNameTableN[((unsigned char*)pPath1)[i]];
		d = aNameTableN[((unsigned char*)pPath2)[j]];

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoi(pPath1+i,0,&m);
		d  = strtoi(pPath2+i,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;
			c = aNameTableN[((unsigned char*)pPath1)[i]];
			d = aNameTableN[((unsigned char*)pPath2)[j]];
			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = stricmp(pPath1+i-m,pPath1+i-n);
			c = aNameTableN[((unsigned char*)pPath1)[i]];
			d = aNameTableN[((unsigned char*)pPath2)[j]];
			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		c = aNameTableN[((unsigned char*)pPath1)[i]];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		d = aNameTableN[((unsigned char*)pPath2)[j]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameV(const wchar_t *pPath1,const wchar_t *pPath2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = pPath1[i];
		c = (c<256)? c=aNameTableN[c]:c<<8;

		d = pPath2[j];
		d = (d<256)? d=aNameTableN[d]:d<<8;

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoi(pPath1+i,0,&m);
		d  = strtoi(pPath2+i,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;
			c = pPath1[i];
			c = (c<256)? c=aNameTableN[c]:c<<8;
			d = pPath2[j];
			d = (d<256)? d=aNameTableN[d]:d<<8;
			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = wcsicmp(pPath1+i-m,pPath1+i-n);
			c = pPath1[i];
			c = (c<256)? c=aNameTableN[c]:c<<8;
			d = pPath2[j];
			d = (d<256)? d=aNameTableN[d]:d<<8;
			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		c = pPath1[i];
		if(c<128)c=aNameTableN[c];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		d = pPath2[j];
		if(d<128)d=aNameTableN[d];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameV(const char *pPath1,const char *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = aNameTableN[((unsigned char*)pPath1)[i]];
		d = aNameTableN[((unsigned char*)pPath2)[j]];

		if(i>=iLen1 || j>=iLen2)					// Ende erreicht
			{
			return (iLen1-i)-(j-iLen2);
			}

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoni(pPath1+i,iLen1-i,0,&m);
		d  = strtoni(pPath2+i,iLen2-j,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;
			c = (i<iLen1)? aNameTableN[((unsigned char*)pPath1)[i]]:0;
			d = (j<iLen2)? aNameTableN[((unsigned char*)pPath2)[j]]:0;
			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = (m<n)? m:n;
			e = strnicmp(pPath1+i-m,pPath1+i-n,e);
			if(e==0)e=m-n;
			c = (1<iLen1)? aNameTableN[((unsigned char*)pPath1)[i]]:0;
			d = (j<iLen2)? aNameTableN[((unsigned char*)pPath2)[j]]:0;
			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen1){c=0;break;}
		c = aNameTableN[((unsigned char*)pPath1)[i]];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		if(j>=iLen2){d=0;break;}
		d = aNameTableN[((unsigned char*)pPath2)[j]];
		}

	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameV(const wchar_t *pPath1,const wchar_t *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = pPath1[i];
		c = (c<256)? c=aNameTableN[c]:c<<8;

		d = pPath2[i];
		d = (d<256)? d=aNameTableN[d]:d<<8;

		if(i>=iLen1 || j>=iLen2)					// Ende erreicht
			{
			return (iLen1-i)-(j-iLen2);
			}

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoni(pPath1+i,iLen1-i,0,&m);
		d  = strtoni(pPath2+i,iLen2-j,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;

			if(i<iLen1)
				{
				c = pPath1[i];
				c = (c<256)? c=aNameTableN[c]:c<<8;
				}
			else{
				c = 0;
				}

			if(j<iLen2)
				{
				d = pPath2[i];
				d = (d<256)? d=aNameTableN[d]:d<<8;
				}
			else{
				d = 0;
				}

			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = (m<n)? m:n;
			e = wcsnicmp(pPath1+i-m,pPath1+i-n,e);
			if(e==0)e=m-n;

			if(i<iLen1)
				{
				c = pPath1[i];
				c = (c<256)? c=aNameTableN[c]:c<<8;
				}
			else{
				c = 0;
				}

			if(j<iLen2)
				{
				d = pPath2[i];
				d = (d<256)? d=aNameTableN[d]:d<<8;
				}
			else{
				d = 0;
				}

			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen1){c=0;break;}
		c = aNameTableN[((unsigned char*)pPath1)[i]];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		if(j>=iLen2){d=0;break;}
		d = aNameTableN[((unsigned char*)pPath2)[j]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

//*****************************************************************************
//*
//*		CmpFileNameW
//*
//*****************************************************************************
//	Vergleiche zwei Dateinamen mit gro/klein Unterscheitung mit Zahlen
//	pPath1	: Zeiger auf den ersten Pfad
//	pPath2	: Zeiger auf den zweiten Pfad
//	Ergibt	:	=0 wenn die Dateien gleich sind
//				>0 wenn pPath1 grer  pPath2
//				<0 wenn pPath1 kleiner pPath2
int _cdecl CmpFileNameW(const char *pPath1,const char *pPath2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = aNameTableG[((unsigned char*)pPath1)[i]];
		d = aNameTableG[((unsigned char*)pPath2)[j]];

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoi(pPath1+i,0,&m);
		d  = strtoi(pPath2+i,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;
			c = aNameTableG[((unsigned char*)pPath1)[i]];
			d = aNameTableG[((unsigned char*)pPath2)[j]];
			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = stricmp(pPath1+i-m,pPath1+i-n);
			c = aNameTableG[((unsigned char*)pPath1)[i]];
			d = aNameTableG[((unsigned char*)pPath2)[j]];
			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		c = aNameTableG[((unsigned char*)pPath1)[i]];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		d = aNameTableG[((unsigned char*)pPath2)[j]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameW(const wchar_t *pPath1,const wchar_t *pPath2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = pPath1[i];
		c = (c<256)? c=aNameTableG[c]:c<<8;

		d = pPath2[j];
		d = (d<256)? d=aNameTableG[d]:d<<8;

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoi(pPath1+i,0,&m);
		d  = strtoi(pPath2+i,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;
			c = pPath1[i];
			c = (c<256)? c=aNameTableG[c]:c<<8;
			d = pPath2[j];
			d = (d<256)? d=aNameTableG[d]:d<<8;
			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = wcsicmp(pPath1+i-m,pPath1+i-n);
			c = pPath1[i];
			c = (c<256)? c=aNameTableG[c]:c<<8;
			d = pPath2[j];
			d = (d<256)? d=aNameTableG[d]:d<<8;
			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		c = pPath1[i];
		if(c<128)c=aNameTableG[c];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		d = pPath2[j];
		if(d<128)d=aNameTableG[d];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameW(const char *pPath1,const char *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = aNameTableG[((unsigned char*)pPath1)[i]];
		d = aNameTableG[((unsigned char*)pPath2)[j]];

		if(i>=iLen1 || j>=iLen2)					// Ende erreicht
			{
			return (iLen1-i)-(j-iLen2);
			}

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoni(pPath1+i,iLen1-i,0,&m);
		d  = strtoni(pPath2+i,iLen2-j,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;
			c = (i<iLen1)? aNameTableG[((unsigned char*)pPath1)[i]]:0;
			d = (j<iLen2)? aNameTableG[((unsigned char*)pPath2)[j]]:0;
			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = (m<n)? m:n;
			e = strnicmp(pPath1+i-m,pPath1+i-n,e);
			if(e==0)e=m-n;
			c = (1<iLen1)? aNameTableG[((unsigned char*)pPath1)[i]]:0;
			d = (j<iLen2)? aNameTableG[((unsigned char*)pPath2)[j]]:0;
			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen1){c=0;break;}
		c = aNameTableG[((unsigned char*)pPath1)[i]];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		if(j>=iLen2){d=0;break;}
		d = aNameTableG[((unsigned char*)pPath2)[j]];
		}

	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

int _cdecl CmpFileNameW(const wchar_t *pPath1,const wchar_t *pPath2,int iLen1,int iLen2)
{
int 	c,d,e;
int		i,j;
int  	m,n;


	for(i=0,j=0;;i++,j++)							// Vergleiche die Pfade
		{
		c = pPath1[i];
		c = (c<256)? c=aNameTableG[c]:c<<8;

		d = pPath2[i];
		d = (d<256)? d=aNameTableG[d]:d<<8;

		if(i>=iLen1 || j>=iLen2)					// Ende erreicht
			{
			return (iLen1-i)-(j-iLen2);
			}

		if(c==0 || d==0)return c-d;					// Ende erreicht

		if(!(c&d&0x80))								// Kein Zahlenvergleich
			{
			if(c==d)continue;
			e = c-d;
			break;
			}

		c  = strtoni(pPath1+i,iLen1-i,0,&m);
		d  = strtoni(pPath2+i,iLen2-j,0,&n);
		i += m;
		j += n;

		if(c!=d)									// Die Zahlen sind ungleich
			{
			e = c-d;

			if(i<iLen1)
				{
				c = pPath1[i];
				c = (c<256)? c=aNameTableG[c]:c<<8;
				}
			else{
				c = 0;
				}

			if(j<iLen2)
				{
				d = pPath2[i];
				d = (d<256)? d=aNameTableG[d]:d<<8;
				}
			else{
				d = 0;
				}

			break;
			}

		if(m!=n)									// Die Zahlen sind ungleich lang
			{
			e = (m<n)? m:n;
			e = wcsncmp(pPath1+i-m,pPath1+i-n,e);
			if(e==0)e=m-n;

			if(i<iLen1)
				{
				c = pPath1[i];
				c = (c<256)? c=aNameTableG[c]:c<<8;
				}
			else{
				c = 0;
				}

			if(j<iLen2)
				{
				d = pPath2[i];
				d = (d<256)? d=aNameTableG[d]:d<<8;
				}
			else{
				d = 0;
				}

			break;
			}

		i--;
		j--;
		}


	for(;c>1;i++)									// Zum nchsten Segment
		{
		if(i>=iLen1){c=0;break;}
		c = aNameTableG[((unsigned char*)pPath1)[i]];
		}

	for(;d>1;j++)									// Zum nchsten Segment
		{
		if(j>=iLen2){d=0;break;}
		d = aNameTableG[((unsigned char*)pPath2)[j]];
		}


	if(c==d)return e;								// Gleicher Segmentabschluss


return c-d;
}

//*****************************************************************************
//*
//*		CmpFileName
//*
//*****************************************************************************
//	Vergleiche zwei Dateinamen
//	pPath1	: Zeiger auf den ersten Pfad
//	pPath2	: Zeiger auf den zweiten Pfad
//	iMode	: Bit 0: Ist != 0 wenn Paht1 nicht der volle Dateiname ist
//				  1: Ist != 0 wenn Paht2 nicht der volle Dateiname ist
//				  2: Ist != 0 wenn zwischen Gro und Kleinbuchstaben nicht
//					 unterschieden werden soll
//				  3: Ist != 0 wenn Zahlen bercksichtigt werden sollen
//				  4: Ist != 0 wenn "." und ".." bercksichtig werden sollen
//	Ergibt Null wenn die Dateien gleich sind
int _cdecl CmpFileName(const char *pPath1,const char *pPath2,int iMode)
{
char	cBuffer1[MAX_PATH];
char	cBuffer2[MAX_PATH];



	if(iMode&1)										// Auf ganzen Pfad erweitern
		{
		cBuffer1[0] = 0;
		GetFullPathNameA(pPath1,MAX_PATH,cBuffer1,0);
		if(iMode&0x10)PathCompress(cBuffer1,MAX_PATH);
		pPath1 = cBuffer1;	
		}
	else if(iMode&0x10)
		{
		PathCompress(cBuffer1,pPath1,MAX_PATH);
		pPath1 = cBuffer1;	
		}

	if(iMode&2)
		{
		cBuffer2[0] = 0;
		GetFullPathNameA(pPath2,MAX_PATH,cBuffer2,0);
		if(iMode&0x10)PathCompress(cBuffer2,MAX_PATH);
		}
	else if(iMode&0x10)
		{
		PathCompress(cBuffer2,pPath2,MAX_PATH);
		}

	if(iMode&4)										// Gro und Kleinbuchstaben nicht unterscheiden
		{
		return (iMode&8)? CmpFileNameV(pPath1,pPath2):CmpFileNameN(pPath1,pPath2);
		}


return (iMode&8)? CmpFileNameW(pPath1,pPath2):CmpFileNameG(pPath1,pPath2);
}


int _cdecl CmpFileName(const wchar_t *pPath1,const wchar_t *pPath2,int iMode)
{
wchar_t		cBuffer1[MAX_PATH];
wchar_t		cBuffer2[MAX_PATH];


	if(iMode&1)										// Auf ganzen Pfad erweitern
		{
		cBuffer1[0] = 0;
		GetFullPathNameW(pPath1,MAX_PATH,cBuffer1,0);
		if(iMode&0x10)PathCompress(cBuffer1,MAX_PATH);
		pPath1 = cBuffer1;	
		}
	else if(iMode&0x10)
		{
		PathCompress(cBuffer1,pPath1,MAX_PATH);
		pPath1 = cBuffer1;	
		}

	if(iMode&2)
		{
		cBuffer2[0] = 0;
		GetFullPathNameW(pPath2,MAX_PATH,cBuffer2,0);
		if(iMode&0x10)PathCompress(cBuffer2,MAX_PATH);
		}
	else if(iMode&0x10)
		{
		PathCompress(cBuffer2,pPath2,MAX_PATH);
		}

	if(iMode&4)										// Gro und Kleinbuchstaben nicht unterscheiden
		{
		return (iMode&8)? CmpFileNameV(pPath1,pPath2):CmpFileNameN(pPath1,pPath2);
		}


return (iMode&8)? CmpFileNameW(pPath1,pPath2):CmpFileNameG(pPath1,pPath2);
}



//*****************************************************************************
//*
//*		PathConvert
//*
//*****************************************************************************
//	Konvertiert Die Backslaches auf '\' oder auf '/'
//	pPath	: Ist der Zeiger auf den Pfad der konvertiert werden soll.
//	iMode	: Ist iMode auf 0 oder '/' wird auf '/' konvertiert
//	Ergibt die Lnge des Pfades
int	 _cdecl	PathConvert(char *pPath,int iMode)
{
int		iLen;


	if(!pPath)return 0;


	if(iMode=='/' || !iMode)
		{
		for(iLen=0;*pPath;pPath++,iLen++)
			{
			if(*pPath=='\\')*pPath='/';
			}

		return iLen;
		}

	for(iLen=0;*pPath;pPath++,iLen++)
		{
		if(*pPath=='/')*pPath='\\';
		}

return iLen;
}

int	 _cdecl	PathConvert(wchar_t *pPath,int iMode)
{
int		iLen;


	if(!pPath)return 0;


	if(iMode=='/' || !iMode)
		{
		for(iLen=0;*pPath;pPath++,iLen++)
			{
			if(*pPath=='\\')*pPath='/';
			}

		return iLen;
		}

	for(iLen=0;*pPath;pPath++,iLen++)
		{
		if(*pPath=='/')*pPath='\\';
		}

return iLen;
}

//*****************************************************************************
//*
//*		PathConvert
//*
//*****************************************************************************
//	Konvertiert Die Backslaches auf '\' oder auf '/'
//	pPath1	: Ist der Zeiger auf den Zielpuffer
//	pPath2	: Ist der Zeiger auf den Pfad der konvertiert werden soll.
//	iSize	: Ist gre des Zielpuffers in Zeichen
//	iMode	: Ist iMode auf 0 oder '/' wird auf '/' konvertiert
//	Ergibt die Lnge des Pfades
int	 _cdecl	PathConvert(char *pPath1,const char *pPath2,int iSize,int iMode)
{
char	cSign;
int		iLen;


	if(!pPath1)return 0;
	if(iSize<=1)
		{
		if(iSize>0)pPath1[0]=0;
		return 0;
		}


	if(iMode=='/' || !iMode)
		{
		for(iLen=0;iLen<iSize;iLen++)
			{
			   cSign = pPath2[iLen];
			if(cSign== 0  )break;
			if(cSign=='\\')cSign='/';

			pPath1[iLen] = cSign;
			}
		}
	else{
		for(iLen=0;iLen<iSize;iLen++)
			{
			   cSign = pPath2[iLen];
			if(cSign== 0  )break;
			if(cSign=='/' )cSign='\\';

			pPath1[iLen] = cSign;
			}
		}

	pPath1[iLen] = 0;


return iLen;
}

int	 _cdecl	PathConvert(wchar_t *pPath1,const wchar_t *pPath2,int iSize,int iMode)
{
wchar_t	cSign;
int		iLen;


	if(!pPath1)return 0;
	if(iSize<=1)
		{
		if(iSize>0)pPath1[0]=0;
		return 0;
		}


	if(iMode=='/' || !iMode)
		{
		for(iLen=0;iLen<iSize;iLen++)
			{
			   cSign = pPath2[iLen];
			if(cSign== 0  )break;
			if(cSign=='\\')cSign='/';

			pPath1[iLen] = cSign;
			}
		}
	else{
		for(iLen=0;iLen<iSize;iLen++)
			{
			   cSign = pPath2[iLen];
			if(cSign== 0  )break;
			if(cSign=='/' )cSign='\\';

			pPath1[iLen] = cSign;
			}
		}

	pPath1[iLen] = 0;


return iLen;
}


//****************************************************************************
//*
//*		AddFileName
//*
//****************************************************************************
//	Hngt den Dateinamen pName an Pfad an und speichert alles in einem Puffer.
//	iLen		: Ist die Lnge des Pfad in Zeichen.
//	pBuffer		: Ist ein Zeiger auf den Puffer in dem der neue Pfad gespeichert wird.
//	pPath		: Ist ein Zeiger auf den Pfad.
//	pName		: Ist der Dateiname der angehngt werden soll.
//	iMax		: Ist die Puffergre
//	Ergibt die neue Lnge des Pfades bzw. 0 bei einem Fehler
int _cdecl AddFileName(int iLen,char *pBuffer,const char *pPath,const char *pName,int iMax)
{
int		iNum;


	if(iMax<=1)return 0;
	
	iMax--;
	
	if(iLen>0)
	if(pPath[iLen-1]=='\\' || pPath[iLen-1]=='/')iLen--;
	if(pName[ 0    ]=='\\' || pName[ 0    ]=='/')pName++;


	iNum=(int)strlen(pName);
	if(iLen+1+iNum>iMax)return 0;

	if(pBuffer!=pPath)
	memcpy(pBuffer	     ,pPath,iLen  );
	memcpy(pBuffer+iLen+1,pName,iNum+1);
		   pBuffer[iLen]='\\';


return iLen+iNum+1;
}

int _cdecl AddFileName(int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax)
{
int		iNum;


	if(iMax<=1)return 0;
	
	iMax--;
	
	if(iLen>0)
	if(pPath[iLen-1]=='\\' || pPath[iLen-1]=='/')iLen--;
	if(pName[ 0    ]=='\\' || pName[ 0    ]=='/')pName++;


	iNum=(int)wcslen(pName);
	if(iLen+1+iNum>iMax)return 0;

	if(pBuffer!=pPath)
	memcpy(pBuffer	     ,pPath, iLen   *2);
	memcpy(pBuffer+iLen+1,pName,(iNum+1)*2);
		   pBuffer[iLen]='\\';


return iLen+iNum+1;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

//****************************************************************************
//*
//*		AddFileName
//*
//****************************************************************************
//	Hngt an einen Pfad einen Dateinamen an.
//	sPath		: Ist der Pfad an dem der Dateinamen angehngt wird.
//	pName		: Ist der Dateiname der angehngt werden soll.
//	Ergibt die neue Lnge des Pfades bzw. 0 bei einem Fehler
int _cdecl	AddFileName(CString &sPath,const zchar *pName)
{
zchar  *pPtr;
int		iLen;
int		iAdd;


	iAdd = strzlen(pName)+2;
	iLen = sPath.GetLength();
	pPtr = sPath.GetBuffer(iLen+iAdd);

	iLen = AddFileName(iLen,pPtr,pName,iLen+iAdd);

	sPath.ReleaseBuffer(iLen);


return iLen;
}


//****************************************************************************
//*
//*		AddFileName
//*
//****************************************************************************
//	Hngt an einen Pfad einen Dateinamen an.
//	sTarget		: Ist das CString-Objekt in dem der neu Pfad gespeichert wird.
//	pPath		: Ist der Pfad an dem der Dateinamen angehngt wird.
//	pName		: Ist der Dateiname der angehngt werden soll.
//	Ergibt die neue Lnge des Pfades bzw. 0 bei einem Fehler
int _cdecl	AddFileName(CString &sTarget,const zchar *pPath,const zchar *pName)
{
zchar  *pPtr;
int		iLen;
int		iAdd;


	iAdd = strzlen(pName)+2;
	iLen = strzlen(pPath);
	pPtr = sTarget.GetBuffer(iLen+iAdd);

	iLen = AddFileName(iLen,pPtr,pPath,pName,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);


return iLen;
}

//****************************************************************************
//*
//*		AddFileName
//*
//****************************************************************************
//	Hngt an einen Pfad einen Dateinamen an.
//	sTarget		: Ist das CString-Objekt in dem der neu Pfad gespeichert wird.
//	sSource		: Ist der Pfad an dem der Dateinamen angehngt wird.
//	pName		: Ist der Dateiname der angehngt werden soll.
//	Ergibt die neue Lnge des Pfades bzw. 0 bei einem Fehler
int _cdecl	AddFileName(CString &sTarget,CString &sSource,const zchar *pName)
{
const zchar  *pStr;
zchar        *pPtr;
int		     iLen;
int		     iAdd;


	iAdd = strzlen(pName)+2;
	iLen = sSource.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iAdd);
	pStr = sSource;

	iLen = AddFileName(iLen,pPtr,pStr,pName,iLen+iAdd);

	sTarget.ReleaseBuffer(iLen);


return iLen;
}

#endif


//*****************************************************************************
//*
//*		SubFileName
//*
//*****************************************************************************
//	Lscht den letzten Pfadnamen sammt '\' (z.B.:  C:\Temp\Test.txt --> C:\Temp)
//	iLen		: Ist die Lnge des Pfades in Zeichen.
//	pPath		: Ist der Zeiger auf den Puffer mit dem Pfad.
//	Ergibt die neue Lnge des Dateinamens bzw. 0 bei einem Fehler
int	_cdecl	SubFileName(int iLen,char *pPath)
{


	for(iLen--;iLen>=0;iLen--)
		{
		if( pPath[iLen]!='\\' &&
			pPath[iLen]!='/'  &&
			pPath[iLen]!=':'		)continue;

		if( iLen>0			  &&
			pPath[iLen-1]!='\\' &&
			pPath[iLen-1]!='/'  &&
			pPath[iLen-1]!=':'	)
				{
				pPath[iLen]=0;
				return iLen;
				}

		pPath[iLen+1]=0;
		return iLen+1;
		}

	pPath[0]=0;


return 0;
}

int	_cdecl	SubFileName(int iLen,wchar_t *pPath)
{


	for(iLen--;iLen>=0;iLen--)
		{
		if( pPath[iLen]!='\\' &&
			pPath[iLen]!='/'  &&
			pPath[iLen]!=':'		)continue;

		if( iLen>0			  &&
			pPath[iLen-1]!='\\' &&
			pPath[iLen-1]!='/'  &&
			pPath[iLen-1]!=':'	)
				{
				pPath[iLen]=0;
				return iLen;
				}

		pPath[iLen+1]=0;
		return iLen+1;
		}

	pPath[0]=0;


return 0;
}

//*****************************************************************************
//*
//*		SubFileName
//*
//*****************************************************************************
//	Lscht den letzten Pfadnamen sammt '\' (z.B.:  C:\Temp\Test.txt --> C:\Temp)
//	sPath		: Ist der Pfad in dem der Pfadnamen gelscht wird.
//	Ergibt die neue Lnge des Dateinamens bzw. 0 bei einem Fehler.
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int	_cdecl	SubFileName(CString &sPath)
{
zchar  *pPtr;
int		iLen;


	iLen = sPath.GetLength();
	pPtr = sPath.GetBuffer(iLen);
	iLen = SubFileName(iLen,pPtr);

	sPath.ReleaseBuffer(iLen);


return iLen;
}

#endif

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

#ifdef 	_DEBUG
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int	 _cdecl	PathConvert(CString &sPath,int iMode){return PathConvert((zchar*)((const zchar*)sPath),iMode);}

#endif
#endif


//*****************************************************************************
//*
//*		PathCompress
//*
//*****************************************************************************
//	Entfernt . und .. aus einem Dateinamen
//	pBuffer	: Zeiger auf Puffer fr den neuen Pfad.
//	pFrom	: Zeiger auf zu komprimierenten Pfad
//	iSize	: Gre des Puffers in Zeichen
//	iLen	: Ist die Lnge des Pfades
//	pName	: Zeiger auf zu komprimierenten Zusatzpfad
//	iAdd	: Ist die Lnge des Zusatzpfads
//	Ergibt die neue Lnge des Pfades bzw. -1 bei einem Fehler
int _cdecl PathCompress(char *pBuffer,const char *pPath,int iSize)
{
int		iNum,iPos,iPosQ,iPosZ=0,iAddZ=0;



	if(iSize<=1)										// Zu kleiner Puffer
		{
		if(iSize==1)*pBuffer=0;
		return -1;
		}

	iSize--;

	if((pPath[0]=='\\' || pPath[0]=='/') &&				// Netzlaufwerk
	   (pPath[1]=='\\' || pPath[1]=='/'))
		{
		for(iPosQ=2;pPath[iPosQ];iPosQ++)
			{
			if(pPath[iPosQ]=='\\')break;
			if(pPath[iPosQ]=='/' )break;
			}
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Suche Laufwerk
			{
			if(pPath[iPosQ]== 0  ){iPosQ=0;break;};
			if(pPath[iPosQ]=='\\'){iPosQ=0;break;};
			if(pPath[iPosQ]=='/ '){iPosQ=0;break;};
			if(pPath[iPosQ]!=':')continue;
					 iPosQ++;

			if(pPath[iPosQ  ]=='\\' || pPath[iPosQ  ]=='/')
			if(pPath[iPosQ+1]=='\\' || pPath[iPosQ+1]=='/')iPosQ++;


			break;
			}
		}

	if(iPosQ>iSize){*pBuffer=0;return -1;}

	memmove(pBuffer,pPath,iPosQ);						// Laufwerksangabe kopieren
	pPath   += iPosQ;
	pBuffer += iPosQ;
	iSize   -= iPosQ;
	iAddZ    = iPosQ;


	for(iPosZ=0,iPosQ=0;pPath[iPosQ];)
		{
		for(iNum=iPosQ;pPath[iNum];iNum++)
			{
			if(pPath[iNum]=='\\')break;
			if(pPath[iNum]=='/' )break;
			}

		iNum -= iPosQ;

		if(iNum==1 && pPath[iPosQ]=='.')				// berspringe '.'
			{
			if(pPath[iPosQ+1]!=0)
				{
				iPosQ+=2;
				continue;
				}

			if(iPosZ>=2)
				{
				iPosZ--;
				pBuffer[iPosZ]=0;
				return iPosZ;
				}
			}

		if(iNum ==2)									// berspringe '..'
		if(iPosZ>=2)
		if(pPath  [iPosQ  ]=='.' )
		if(pPath  [iPosQ+1]=='.' )
		if(pBuffer[iPosZ-2]!=':' )
		if(pBuffer[iPosZ-2]!='/' )
		if(pBuffer[iPosZ-2]!='\\')
			{
			for(iPos=iPosZ-2;iPos>=0;iPos--)
				{
				if(pBuffer[iPos]=='\\')break;
				if(pBuffer[iPos]=='/' )break;
				if(pBuffer[iPos]==':' )break;
				}

			if(pBuffer[iPos+1]=='.')					// Doppeltes '..'
			if(pBuffer[iPos+2]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(pPath[iPosQ+2]==0)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPos<0)									// Einfaches '.'
			if(pBuffer[iPos+1]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(pPath[iPosQ+2]==0)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(pPath[iPosQ+2]!=0)						// Backslash am Ende
				{
				if(iPos>=0)
					{
					iPosZ =iPos+1;
					iPosQ += 3;
					continue;
					}
				else{
					pBuffer[iPos+1]='.';
					pBuffer[iPos+2]=pPath[iPosQ+2];
					iPosZ=iPos+3;
					iPosQ += 3;
					continue;
					}
				}
			else{										// Kein Backslash am Ende
				if(iPos<0)
					{
					pBuffer[iPos+1]=0;
					return iPos+iAddZ+1;
					}
			
				if(iPos==0)
					{
					pBuffer[iPos+1]='.';
					iPos+=2;
					}
			
				pBuffer[iPos]=0;
				return iPos+iAddZ;
				}
			}

		if(pPath[iPosQ+iNum]=='\\' ||					// Hnge '\' an
		   pPath[iPosQ+iNum]=='/' )
			{
			iNum++;
			}

		if(iPosZ+iNum>iSize)							// Zuwenig Speicher ?
			{
			pBuffer[-iAddZ]=0;
			return -1;
			}

		memmove(pBuffer+iPosZ,pPath+iPosQ,iNum);		// Kopiere Pfadteil
		iPosZ+=iNum;
		iPosQ+=iNum;
		}


	pBuffer[iPosZ]=0;


return iPosZ+iAddZ;
}

int _cdecl PathCompress(wchar_t *pBuffer,const wchar_t *pPath,int iSize)
{
int		iNum,iPos,iPosQ,iPosZ=0,iAddZ=0;



	if(iSize<=1)										// Zu kleiner Puffer
		{
		if(iSize==1)*pBuffer=0;
		return -1;
		}

	iSize--;

	if((pPath[0]=='\\' || pPath[0]=='/') &&				// Netzlaufwerk
	   (pPath[1]=='\\' || pPath[1]=='/'))
		{
		for(iPosQ=2;pPath[iPosQ];iPosQ++)
			{
			if(pPath[iPosQ]=='\\')break;
			if(pPath[iPosQ]=='/' )break;
			}
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Suche Laufwerk
			{
			if(pPath[iPosQ]== 0  ){iPosQ=0;break;};
			if(pPath[iPosQ]=='\\'){iPosQ=0;break;};
			if(pPath[iPosQ]=='/ '){iPosQ=0;break;};
			if(pPath[iPosQ]!=':')continue;
					 iPosQ++;

			if(pPath[iPosQ  ]=='\\' || pPath[iPosQ  ]=='/')
			if(pPath[iPosQ+1]=='\\' || pPath[iPosQ+1]=='/')iPosQ++;


			break;
			}
		}

	if(iPosQ>iSize){*pBuffer=0;return -1;}

	memmove(pBuffer,pPath,iPosQ*2);						// Laufwerksangabe kopieren
	pPath   += iPosQ;
	pBuffer += iPosQ;
	iSize   -= iPosQ;
	iAddZ    = iPosQ;


	for(iPosZ=0,iPosQ=0;pPath[iPosQ];)
		{
		for(iNum=iPosQ;pPath[iNum];iNum++)
			{
			if(pPath[iNum]=='\\')break;
			if(pPath[iNum]=='/' )break;
			}

		iNum -= iPosQ;

		if(iNum==1 && pPath[iPosQ]=='.')				// berspringe '.'
			{
			if(pPath[iPosQ+1]!=0)
				{
				iPosQ+=2;
				continue;
				}

			if(iPosZ>=2)
				{
				iPosZ--;
				pBuffer[iPosZ]=0;
				return iPosZ;
				}
			}

		if(iNum ==2)									// berspringe '..'
		if(iPosZ>=2)
		if(pPath  [iPosQ  ]=='.' )
		if(pPath  [iPosQ+1]=='.' )
		if(pBuffer[iPosZ-2]!=':' )
		if(pBuffer[iPosZ-2]!='/' )
		if(pBuffer[iPosZ-2]!='\\')
			{
			for(iPos=iPosZ-2;iPos>=0;iPos--)
				{
				if(pBuffer[iPos]=='\\')break;
				if(pBuffer[iPos]=='/' )break;
				if(pBuffer[iPos]==':' )break;
				}

			if(pBuffer[iPos+1]=='.')					// Doppeltes '..'
			if(pBuffer[iPos+2]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(pPath[iPosQ+2]==0)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPos<0)									// Einfaches '.'
			if(pBuffer[iPos+1]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(pPath[iPosQ+2]==0)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(pPath[iPosQ+2]!=0)						// Backslash am Ende
				{
				if(iPos>=0)
					{
					iPosZ =iPos+1;
					iPosQ += 3;
					continue;
					}
				else{
					pBuffer[iPos+1]='.';
					pBuffer[iPos+2]=pPath[iPosQ+2];
					iPosZ=iPos+3;
					iPosQ += 3;
					continue;
					}
				}
			else{										// Kein Backslash am Ende
				if(iPos<0)
					{
					pBuffer[iPos+1]=0;
					return iPos+iAddZ+1;
					}
			
				if(iPos==0)
					{
					pBuffer[iPos+1]='.';
					iPos+=2;
					}
			
				pBuffer[iPos]=0;
				return iPos+iAddZ;
				}
			}

		if(pPath[iPosQ+iNum]=='\\' ||					// Hnge '\' an
		   pPath[iPosQ+iNum]=='/' )
			{
			iNum++;
			}

		if(iPosZ+iNum>iSize)							// Zuwenig Speicher ?
			{
			pBuffer[-iAddZ]=0;
			return -1;
			}

		memmove(pBuffer+iPosZ,pPath+iPosQ,iNum*2);		// Kopiere Pfadteil
		iPosZ+=iNum;
		iPosQ+=iNum;
		}


	pBuffer[iPosZ]=0;


return iPosZ+iAddZ;
}

int _cdecl PathCompress(char *pBuffer,const char *pPath,int iSize,int iLen)
{
int		iNum,iPos,iPosQ,iPosZ=0,iAddZ=0;



	if(iSize<=1)										// Zu kleiner Puffer
		{
		if(iSize==1)*pBuffer=0;
		return -1;
		}

	iSize--;

	if(iLen>=2 && 
	   (pPath[0]=='\\' || pPath[0]=='/') &&				// Netzlaufwerk
	   (pPath[1]=='\\' || pPath[1]=='/'))
		{
		for(iPosQ=2;iPosQ<iLen;iPosQ++)
			{
			if(pPath[iPosQ]=='\\')break;
			if(pPath[iPosQ]=='/' )break;
			}
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Suche Laufwerk
			{
			if(iPosQ       >=iLen){iPosQ=0;break;};
			if(pPath[iPosQ]=='\\'){iPosQ=0;break;};
			if(pPath[iPosQ]=='/ '){iPosQ=0;break;};
			if(pPath[iPosQ]!=':' )continue;
			if(iPosQ+2     > iLen){iPosQ=0;break;};
			
			iPosQ++;

			if(pPath[iPosQ  ]=='\\' || pPath[iPosQ  ]=='/')
			if(pPath[iPosQ+1]=='\\' || pPath[iPosQ+1]=='/')iPosQ++;

			break;
			}
		}

	if(iPosQ>iSize){*pBuffer=0;return -1;}

	memmove(pBuffer,pPath,iPosQ);						// Laufwerksangabe kopieren
	pPath   += iPosQ;
	pBuffer += iPosQ;
	iSize   -= iPosQ;
	iAddZ    = iPosQ;
	iLen    -= iPosQ;


	for(iPosZ=0,iPosQ=0;iPosQ<iLen;)
		{
		for(iNum=iPosQ;iNum<iLen;iNum++)
			{
			if(pPath[iNum]=='\\')break;
			if(pPath[iNum]=='/' )break;
			}

		iNum -= iPosQ;

		if(iNum==1 && pPath[iPosQ]=='.')				// berspringe '.'
			{
			if(iPosQ+1<=iLen)
				{
				iPosQ+=2;
				continue;
				}

			if(iPosZ>=2)
				{
				iPosZ--;
				pBuffer[iPosZ]=0;
				return iPosZ;
				}
			}

		if(iNum ==2)									// berspringe '..'
		if(iPosZ>=2)
		if(pPath  [iPosQ  ]=='.' )
		if(pPath  [iPosQ+1]=='.' )
		if(pBuffer[iPosZ-2]!=':' )
		if(pBuffer[iPosZ-2]!='/' )
		if(pBuffer[iPosZ-2]!='\\')
			{
			for(iPos=iPosZ-2;iPos>=0;iPos--)
				{
				if(pBuffer[iPos]=='\\')break;
				if(pBuffer[iPos]=='/' )break;
				if(pBuffer[iPos]==':' )break;
				}

			if(pBuffer[iPos+1]=='.')					// Doppeltes '..'
			if(pBuffer[iPos+2]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPos<0)									// Einfaches '.'
			if(pBuffer[iPos+1]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;

				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPosQ+2<=iLen)							// Backslash am Ende
				{
				if(iPos>=0)
					{
					iPosZ =iPos+1;
					iPosQ += 3;
					continue;
					}
				else{
					pBuffer[iPos+1]='.';
					pBuffer[iPos+2]=pPath[iPosQ+2];
					iPosZ=iPos+3;
					iPosQ += 3;
					continue;
					}
				}
			else{										// Kein Backslash am Ende
				if(iPos<0)
					{
					pBuffer[iPos+1]=0;
					return iPos+iAddZ+1;
					}
			
				if(iPos==0)
					{
					pBuffer[iPos+1]='.';
					iPos+=2;
					}
			
				pBuffer[iPos]=0;
				return iPos+iAddZ;
				}
			}
														// Hnge '\' an
		if(iPosQ+iNum<iLen && (pPath[iPosQ+iNum]=='\\' || pPath[iPosQ+iNum]=='/' ))
			{
			iNum++;
			}

		if(iPosZ+iNum>iSize)							// Zuwenig Speicher ?
			{
			pBuffer[-iAddZ]=0;
			return -1;
			}

		memmove(pBuffer+iPosZ,pPath+iPosQ,iNum);		// Kopiere Pfadteil
		iPosZ+=iNum;
		iPosQ+=iNum;
		}


	pBuffer[iPosZ]=0;


return iPosZ+iAddZ;
}


int _cdecl PathCompress(wchar_t *pBuffer,const wchar_t *pPath,int iSize,int iLen)
{
int		iNum,iPos,iPosQ,iPosZ=0,iAddZ=0;



	if(iSize<=1)										// Zu kleiner Puffer
		{
		if(iSize==1)*pBuffer=0;
		return -1;
		}

	iSize--;

	if(iLen>=2 && 
	   (pPath[0]=='\\' || pPath[0]=='/') &&				// Netzlaufwerk
	   (pPath[1]=='\\' || pPath[1]=='/'))
		{
		for(iPosQ=2;iPosQ<iLen;iPosQ++)
			{
			if(pPath[iPosQ]=='\\')break;
			if(pPath[iPosQ]=='/' )break;
			}
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Suche Laufwerk
			{
			if(iPosQ       >=iLen){iPosQ=0;break;};
			if(pPath[iPosQ]=='\\'){iPosQ=0;break;};
			if(pPath[iPosQ]=='/ '){iPosQ=0;break;};
			if(pPath[iPosQ]!=':' )continue;
			if(iPosQ+2     > iLen){iPosQ=0;break;};
			
			iPosQ++;

			if(pPath[iPosQ  ]=='\\' || pPath[iPosQ  ]=='/')
			if(pPath[iPosQ+1]=='\\' || pPath[iPosQ+1]=='/')iPosQ++;

			break;
			}
		}

	if(iPosQ>iSize){*pBuffer=0;return -1;}

	memmove(pBuffer,pPath,iPosQ*2);						// Laufwerksangabe kopieren
	pPath   += iPosQ;
	pBuffer += iPosQ;
	iSize   -= iPosQ;
	iAddZ    = iPosQ;
	iLen    -= iPosQ;


	for(iPosZ=0,iPosQ=0;iPosQ<iLen;)
		{
		for(iNum=iPosQ;iNum<iLen;iNum++)
			{
			if(pPath[iNum]=='\\')break;
			if(pPath[iNum]=='/' )break;
			}

		iNum -= iPosQ;

		if(iNum==1 && pPath[iPosQ]=='.')				// berspringe '.'
			{
			if(iPosQ+1<=iLen)
				{
				iPosQ+=2;
				continue;
				}

			if(iPosZ>=2)
				{
				iPosZ--;
				pBuffer[iPosZ]=0;
				return iPosZ;
				}
			}

		if(iNum ==2)									// berspringe '..'
		if(iPosZ>=2)
		if(pPath  [iPosQ  ]=='.' )
		if(pPath  [iPosQ+1]=='.' )
		if(pBuffer[iPosZ-2]!=':' )
		if(pBuffer[iPosZ-2]!='/' )
		if(pBuffer[iPosZ-2]!='\\')
			{
			for(iPos=iPosZ-2;iPos>=0;iPos--)
				{
				if(pBuffer[iPos]=='\\')break;
				if(pBuffer[iPos]=='/' )break;
				if(pBuffer[iPos]==':' )break;
				}

			if(pBuffer[iPos+1]=='.')					// Doppeltes '..'
			if(pBuffer[iPos+2]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPos<0)									// Einfaches '.'
			if(pBuffer[iPos+1]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;

				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPosQ+2<=iLen)							// Backslash am Ende
				{
				if(iPos>=0)
					{
					iPosZ =iPos+1;
					iPosQ += 3;
					continue;
					}
				else{
					pBuffer[iPos+1]='.';
					pBuffer[iPos+2]=pPath[iPosQ+2];
					iPosZ=iPos+3;
					iPosQ += 3;
					continue;
					}
				}
			else{										// Kein Backslash am Ende
				if(iPos<0)
					{
					pBuffer[iPos+1]=0;
					return iPos+iAddZ+1;
					}
			
				if(iPos==0)
					{
					pBuffer[iPos+1]='.';
					iPos+=2;
					}
			
				pBuffer[iPos]=0;
				return iPos+iAddZ;
				}
			}
														// Hnge '\' an
		if(iPosQ+iNum<iLen && (pPath[iPosQ+iNum]=='\\' || pPath[iPosQ+iNum]=='/' ))
			{
			iNum++;
			}

		if(iPosZ+iNum>iSize)							// Zuwenig Speicher ?
			{
			pBuffer[-iAddZ]=0;
			return -1;
			}

		memmove(pBuffer+iPosZ,pPath+iPosQ,iNum*2);		// Kopiere Pfadteil
		iPosZ+=iNum;
		iPosQ+=iNum;
		}


	pBuffer[iPosZ]=0;


return iPosZ+iAddZ;
}

int _cdecl PathCompress(char *pBuffer,const char *pPath,int iSize,int iLen,const char *pName,int iAdd)
{
int		iNum,iPos,iPosQ,iPosZ=0,iAddZ=0;



	if(iSize<=1)										// Zu kleiner Puffer
		{
		if(iSize==1)*pBuffer=0;
		return -1;
		}

	iSize--;


	if(iAdd>=2 &&										// Ist der Zustatz ein Netzlaufwerk
	   (pName[0]=='\\' || pName[0]=='/') &&				
	   (pName[1]=='\\' || pName[1]=='/'))
		{
		for(iPosQ=2;iPosQ<iAdd;iPosQ++)
			{
			if(pName[iPosQ]=='\\')break;
			if(pName[iPosQ]=='/' )break;
			}

		pPath = pName;
		iLen  = iAdd;
		iAdd  = 0;

		goto Set;
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Ist Zustatz ein Laufwerk
			{
			if(iPosQ       >=iAdd){iPosQ=0;break;};
			if(pName[iPosQ]=='\\'){iPosQ=0;break;};
			if(pName[iPosQ]=='/ '){iPosQ=0;break;};
			if(pName[iPosQ]!=':' )continue;
			if(iPosQ+2     > iAdd){iPosQ=0;break;};
			
			iPosQ++;

			if(pName[iPosQ  ]=='\\' || pName[iPosQ  ]=='/')
			if(pName[iPosQ+1]=='\\' || pName[iPosQ+1]=='/')iPosQ++;

			pPath = pName;
			iLen  = iAdd;
			iAdd  = 0;
			
			goto Set;
			}
		}

	
	if(iLen>=2 && 
	   (pPath[0]=='\\' || pPath[0]=='/') &&				// Netzlaufwerk
	   (pPath[1]=='\\' || pPath[1]=='/'))
		{
		for(iPosQ=2;iPosQ<iLen;iPosQ++)
			{
			if(pPath[iPosQ]=='\\')break;
			if(pPath[iPosQ]=='/' )break;
			}
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Suche Laufwerk
			{
			if(iPosQ       >=iLen){iPosQ=0;break;};
			if(pPath[iPosQ]=='\\'){iPosQ=0;break;};
			if(pPath[iPosQ]=='/ '){iPosQ=0;break;};
			if(pPath[iPosQ]!=':' )continue;
			if(iPosQ+2     > iLen){iPosQ=0;break;};
			
			iPosQ++;

			if(pPath[iPosQ  ]=='\\' || pPath[iPosQ  ]=='/')
			if(pPath[iPosQ+1]=='\\' || pPath[iPosQ+1]=='/')iPosQ++;

			break;
			}
		}


Set:

	if(iPosQ>iSize){*pBuffer=0;return -1;}

	memmove(pBuffer,pPath,iPosQ);						// Laufwerksangabe kopieren
	pPath   += iPosQ;
	pBuffer += iPosQ;
	iSize   -= iPosQ;
	iAddZ    = iPosQ;
	iLen    -= iPosQ;


	for(iPosZ=0,iPosQ=0;;)
		{
		if(iPosQ>=iLen)									// Ende vom Pfad erreicht
			{
			if(iAdd<=0)break;

			pPath = pName;
			iLen  = iAdd;
			iAdd  = 0;
			iPosQ = 0;

			if(iPosZ>0 && (pBuffer[iPosZ-1]=='\\' || pBuffer[iPosZ-1]=='/'))
				{
				if(*pPath=='\\' || *pPath=='/')
					{
					pPath++;
					iLen--;
					if(iLen<=0)break;
					} 
				}
			else if(*pPath!='\\' && *pPath!='/' && iPosZ<iSize)
				{
				pBuffer[iPosZ] = '\\';
				iPosZ++;
				}
			}


		for(iNum=iPosQ;iNum<iLen;iNum++)				// Lnge vom Segment holen
			{
			if(pPath[iNum]=='\\')break;
			if(pPath[iNum]=='/' )break;
			}

		iNum -= iPosQ;

		if(iNum==1 && pPath[iPosQ]=='.')				// berspringe '.'
			{
			if(iPosQ+1<=iLen)
				{
				iPosQ+=2;
				continue;
				}

			if(iPosZ>=2)
				{
				iPosZ--;
				pBuffer[iPosZ]=0;
				return iPosZ;
				}
			}

		if(iNum ==2)									// berspringe '..'
		if(iPosZ>=2)
		if(pPath  [iPosQ  ]=='.' )
		if(pPath  [iPosQ+1]=='.' )
		if(pBuffer[iPosZ-2]!=':' )
		if(pBuffer[iPosZ-2]!='/' )
		if(pBuffer[iPosZ-2]!='\\')
			{
			for(iPos=iPosZ-2;iPos>=0;iPos--)
				{
				if(pBuffer[iPos]=='\\')break;
				if(pBuffer[iPos]=='/' )break;
				if(pBuffer[iPos]==':' )break;
				}

			if(pBuffer[iPos+1]=='.')					// Doppeltes '..'
			if(pBuffer[iPos+2]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPos<0)									// Einfaches '.'
			if(pBuffer[iPos+1]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;

				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPosQ+2<=iLen)							// Backslash am Ende
				{
				if(iPos>=0)
					{
					iPosZ =iPos+1;
					iPosQ += 3;
					continue;
					}
				else{
					pBuffer[iPos+1]='.';
					pBuffer[iPos+2]=pPath[iPosQ+2];
					iPosZ=iPos+3;
					iPosQ += 3;
					continue;
					}
				}
			else{										// Kein Backslash am Ende
				if(iPos<0)
					{
					pBuffer[iPos+1]=0;
					return iPos+iAddZ+1;
					}
			
				if(iPos==0)
					{
					pBuffer[iPos+1]='.';
					iPos+=2;
					}
			
				pBuffer[iPos]=0;
				return iPos+iAddZ;
				}
			}
														// Hnge '\' an
		if(iPosQ+iNum<iLen && (pPath[iPosQ+iNum]=='\\' || pPath[iPosQ+iNum]=='/' ))
			{
			iNum++;
			}

		if(iPosZ+iNum>iSize)							// Zuwenig Speicher ?
			{
			pBuffer[-iAddZ]=0;
			return -1;
			}

		memmove(pBuffer+iPosZ,pPath+iPosQ,iNum);		// Kopiere Pfadteil
		iPosZ+=iNum;
		iPosQ+=iNum;
		}


	pBuffer[iPosZ]=0;


return iPosZ+iAddZ;
}


int _cdecl PathCompress(wchar_t *pBuffer,const wchar_t *pPath,int iSize,int iLen,const wchar_t *pName,int iAdd)
{
int		iNum,iPos,iPosQ,iPosZ=0,iAddZ=0;



	if(iSize<=1)										// Zu kleiner Puffer
		{
		if(iSize==1)*pBuffer=0;
		return -1;
		}

	iSize--;

	if(iAdd>=2 &&										// Ist der Zustatz ein Netzlaufwerk
	   (pName[0]=='\\' || pName[0]=='/') &&				
	   (pName[1]=='\\' || pName[1]=='/'))
		{
		for(iPosQ=2;iPosQ<iAdd;iPosQ++)
			{
			if(pName[iPosQ]=='\\')break;
			if(pName[iPosQ]=='/' )break;
			}

		pPath = pName;
		iLen  = iAdd;
		iAdd  = 0;

		goto Set;
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Ist Zustatz ein Laufwerk
			{
			if(iPosQ       >=iAdd){iPosQ=0;break;};
			if(pName[iPosQ]=='\\'){iPosQ=0;break;};
			if(pName[iPosQ]=='/ '){iPosQ=0;break;};
			if(pName[iPosQ]!=':' )continue;
			if(iPosQ+2     > iAdd){iPosQ=0;break;};
			
			iPosQ++;

			if(pName[iPosQ  ]=='\\' || pName[iPosQ  ]=='/')
			if(pName[iPosQ+1]=='\\' || pName[iPosQ+1]=='/')iPosQ++;

			pPath = pName;
			iLen  = iAdd;
			iAdd  = 0;
			
			goto Set;
			}
		}


	if(iLen>=2 && 
	   (pPath[0]=='\\' || pPath[0]=='/') &&				// Netzlaufwerk
	   (pPath[1]=='\\' || pPath[1]=='/'))
		{
		for(iPosQ=2;iPosQ<iLen;iPosQ++)
			{
			if(pPath[iPosQ]=='\\')break;
			if(pPath[iPosQ]=='/' )break;
			}
		}
	else{
		for(iPosQ=0;;iPosQ++)							// Suche Laufwerk
			{
			if(iPosQ       >=iLen){iPosQ=0;break;};
			if(pPath[iPosQ]=='\\'){iPosQ=0;break;};
			if(pPath[iPosQ]=='/ '){iPosQ=0;break;};
			if(pPath[iPosQ]!=':' )continue;
			if(iPosQ+2     > iLen){iPosQ=0;break;};
			
			iPosQ++;

			if(pPath[iPosQ  ]=='\\' || pPath[iPosQ  ]=='/')
			if(pPath[iPosQ+1]=='\\' || pPath[iPosQ+1]=='/')iPosQ++;

			break;
			}
		}

Set:

	if(iPosQ>iSize){*pBuffer=0;return -1;}

	memmove(pBuffer,pPath,iPosQ*2);						// Laufwerksangabe kopieren
	pPath   += iPosQ;
	pBuffer += iPosQ;
	iSize   -= iPosQ;
	iAddZ    = iPosQ;
	iLen    -= iPosQ;


	for(iPosZ=0,iPosQ=0;iPosQ<iLen;)
		{
		if(iPosQ>=iLen)									// Ende vom Pfad erreicht
			{
			if(iAdd<=0)break;

			pPath = pName;
			iLen  = iAdd;
			iAdd  = 0;
			iPosQ = 0;

			if(iPosZ>0 && (pBuffer[iPosZ-1]=='\\' || pBuffer[iPosZ-1]=='/'))
				{
				if(*pPath=='\\' || *pPath=='/')
					{
					pPath++;
					iLen--;
					if(iLen<=0)break;
					} 
				}
			else if(*pPath!='\\' && *pPath!='/' && iPosZ<iSize)
				{
				pBuffer[iPosZ] = '\\';
				iPosZ++;
				}
			}


		for(iNum=iPosQ;iNum<iLen;iNum++)				// Lnge vom Segment holen
			{
			if(pPath[iNum]=='\\')break;
			if(pPath[iNum]=='/' )break;
			}

		iNum -= iPosQ;

		if(iNum==1 && pPath[iPosQ]=='.')				// berspringe '.'
			{
			if(iPosQ+1<=iLen)
				{
				iPosQ+=2;
				continue;
				}

			if(iPosZ>=2)
				{
				iPosZ--;
				pBuffer[iPosZ]=0;
				return iPosZ;
				}
			}

		if(iNum ==2)									// berspringe '..'
		if(iPosZ>=2)
		if(pPath  [iPosQ  ]=='.' )
		if(pPath  [iPosQ+1]=='.' )
		if(pBuffer[iPosZ-2]!=':' )
		if(pBuffer[iPosZ-2]!='/' )
		if(pBuffer[iPosZ-2]!='\\')
			{
			for(iPos=iPosZ-2;iPos>=0;iPos--)
				{
				if(pBuffer[iPos]=='\\')break;
				if(pBuffer[iPos]=='/' )break;
				if(pBuffer[iPos]==':' )break;
				}

			if(pBuffer[iPos+1]=='.')					// Doppeltes '..'
			if(pBuffer[iPos+2]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;
				
				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPos<0)									// Einfaches '.'
			if(pBuffer[iPos+1]=='.')
			if((iPos>=0 && iPosZ-iPos==4) ||
			   (iPos< 0 && iPosZ-iPos==3))
				{
				pBuffer[iPosZ  ]='.';
				pBuffer[iPosZ+1]='.';
				iPosZ+=2;

				if(iPosQ+2>=iLen)
					{
					pBuffer[iPosZ]=0;
					return iPosZ+iAddZ;
					}
				
				pBuffer[iPosZ]=pPath[iPosQ+2];
				iPosQ+=3;
				iPosZ++;
				continue;
				}

			if(iPosQ+2<=iLen)							// Backslash am Ende
				{
				if(iPos>=0)
					{
					iPosZ =iPos+1;
					iPosQ += 3;
					continue;
					}
				else{
					pBuffer[iPos+1]='.';
					pBuffer[iPos+2]=pPath[iPosQ+2];
					iPosZ=iPos+3;
					iPosQ += 3;
					continue;
					}
				}
			else{										// Kein Backslash am Ende
				if(iPos<0)
					{
					pBuffer[iPos+1]=0;
					return iPos+iAddZ+1;
					}
			
				if(iPos==0)
					{
					pBuffer[iPos+1]='.';
					iPos+=2;
					}
			
				pBuffer[iPos]=0;
				return iPos+iAddZ;
				}
			}
														// Hnge '\' an
		if(iPosQ+iNum<iLen && (pPath[iPosQ+iNum]=='\\' || pPath[iPosQ+iNum]=='/' ))
			{
			iNum++;
			}

		if(iPosZ+iNum>iSize)							// Zuwenig Speicher ?
			{
			pBuffer[-iAddZ]=0;
			return -1;
			}

		memmove(pBuffer+iPosZ,pPath+iPosQ,iNum*2);		// Kopiere Pfadteil
		iPosZ+=iNum;
		iPosQ+=iNum;
		}


	pBuffer[iPosZ]=0;


return iPosZ+iAddZ;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int _cdecl PathCompress(CString &sPath)
{
int		iNum;
zchar  *pPtr;


	pPtr = sPath.GetBuffer(sPath.GetLength());
	iNum = PathCompress((zchar*)pPtr,pPtr,sPath.GetLength()+1);
	       sPath.ReleaseBuffer((iNum<=0)? 0:iNum);

return iNum;
}

int _cdecl PathCompress(CString &sTarget,const zchar *pPath)
{
int		 iNum;
zchar   *pPtr;



	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		iNum  = (sTarget.GetLength()+1)*sizeof(zchar);
		pPath = (zchar*)alloca(iNum);
		memcpy ((zchar*)pPath,pPtr,iNum);
		}

	pPtr = sTarget.GetBuffer(MAX_PATH+256);
	iNum = PathCompress(pPtr,pPath,MAX_PATH+256);
	       sTarget.ReleaseBuffer((iNum<=0)? 0:iNum);


return iNum;
}

int _cdecl PathCompress(CString &sTarget,const zchar *pPath,int iLen)
{
int		 iNum;
zchar   *pPtr;



	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		pPath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pPath,pPtr,iLen);
		}

	pPtr = sTarget.GetBuffer(MAX_PATH+256);
	iNum = PathCompress(pPtr,pPath,MAX_PATH+256,iLen);
	       sTarget.ReleaseBuffer((iNum<=0)? 0:iNum);


return iNum;
}

#endif

//*****************************************************************************
//*
//*		PathOffset
//*
//*****************************************************************************
//	Erzeugt einen realitven Pfad : pFrom-->pTo
//	pBuffer		: Speicher fr neuen Pfad
//	pFrom		: Zeiger auf Anfangspfad (absoluter Pfad !)
//	pTo 		: Zeiger zum Zeilpfad     (absoluter Pfad !)
//	iSize		: Gre des Zielspeichers pTo
//	iLevel		: Die Nummer im Verzeichnis unter die nicht gegangen werden darf
//	Ergibt die neue Lnge des Pfades bzw -1 bei einem Fehler
int _cdecl PathOffset(char *pBuffer,const char *pFrom,const char *pTo,int iSize,int iLevel)
{
int		iUp=0,iLen,iPos=0,iNum,iSlash='\\';
char	cBufF[MAX_PATH],cBufT[MAX_PATH];


	if(iSize<=0)return -1;
	   iSize--;

	if(pFrom>=pBuffer && pFrom<pBuffer+iSize)			// berschneiden sich die Buffer
		{
		strncpy(cBufF,pFrom,sizeof(cBufF));
		pFrom=cBufF;
		}

	if(pTo>=pBuffer && pTo<pBuffer+iSize)
		{
		strncpy(cBufT,pTo,sizeof(cBufT));
		pTo=cBufT;
		}

	if(pFrom[0]=='\\' || pFrom[0]=='/')					// Netzlaufwerk/Root berspringen
		{
		if(pFrom[1]=='\\' || pFrom[1]=='/')
				iLen=2;
		else	iLen=1;

		if((pTo[0]!='\\' && pTo[0]!='/') ||
		   (pTo[1]!='\\' && pTo[1]!='/' && iLen>=2) ||
		  ((pTo[2]== 0   || pFrom [2]== 0 )&& iLen>=2))
			{
			pBuffer[0]=0;return -1;
			}

		pFrom += iLen;
		pTo   += iLen;

		for(iLen=0,iNum=0;iNum<iLevel;iLen++)			// Ebene berspringen
			{
			if(pFrom [iLen]==0                   ){iLen=-1;break;}
			if(pFrom [iLen]!='\\' && pFrom [iLen]!='/')continue;
			if(pTo[iLen]!='\\' && pTo[iLen]!='/' ){iLen=-1;break;}
			if(strnicmp(pFrom,pTo,iLen)          ){iLen=-1;break;}
			if(iLen<=0                           ){iLen=-1;break;}

			pFrom += iLen+1;
			pTo   += iLen+1;
			iLen   = 0;
			iNum  += 1;
			}

		if(iNum<iLevel || iLen<0)						// Kein Netzlaufwerk vorhanden
			{
			pBuffer[0]=0;
			return -1;
			}
		}
	else{												// Laufwerksangabe
		for(iLen=0,iNum=0;iNum<iLevel;iLen++)
			{
			if(pFrom[iLen]==0){iLen=-1;break;}
			if(pFrom[iLen]==':'  && iNum==0)
				{
				iLen++;
				if(pTo[iLen]!='\\' && pTo[iLen]!='/'){iLen=-1;break;}
				}

			if(pFrom [iLen]!='\\' && pFrom [iLen]!='/')continue;
			if(pTo[iLen]!='\\' && pTo[iLen]!='/' ){iLen=-1;break;}
			if(strnicmp(pFrom,pTo,iLen)          ){iLen=-1;break;}
			if(iLen<=0                           ){iLen=-1;break;}

			pFrom += iLen+1;
			pTo   += iLen+1;
			iLen   = 0;
			iNum  += 1;

			if(iNum>1)continue;
			if(*pFrom !='\\' && *pFrom !='/')continue;
			if(*pTo!='\\' && *pTo!='/')continue;
			pFrom ++;
			pTo++;
			}

		if(iNum<iLevel || iLen<0)						// Kein Laufwerk vorhanden
			{
			pBuffer[0]=0;return -1;
			}
		}



	for(;;) 											// Gleiche Verzeichnisse berspringen
		{
		iLen=0;

		for(;;iLen++)
			{
			if(pFrom[iLen]== 0  )break;
			if(pFrom[iLen]=='\\')break;
			if(pFrom[iLen]=='/' )break;
			}

		if(strnicmp(pFrom,pTo,iLen))break;

		pFrom += iLen;
		pTo   += iLen;

		if(*pFrom==0)break;								// Ende des Anfangspfades
		if(*pTo  ==0)break;								// Ende des Zielpfades

		iSlash=*pFrom;
		pFrom ++;										// Backslash berspringen
		iNum  ++;
		pTo   ++;
		}

	iLen=(int)strlen(pFrom)-1;							// Vor auf Ende

	if(iLen>0)
	if(pFrom[iLen]!='\\' && pFrom[iLen]!='/')
		{
		if(iPos+3>iSize){pBuffer[0]=0;return -1;}
		pBuffer[iPos  ]=iSlash;
		pBuffer[iPos+1]='.';
		pBuffer[iPos+2]='.';
		iPos+=3;
		}

	while(iLen>=0)										// Pfad cBufT unten springen
		{
		if(pFrom[iLen]=='\\' || pFrom[iLen]=='/')
			{
			if(iPos+2>iSize){pBuffer[0]=0;return -1;}
			pBuffer[iPos+0]='.';
			pBuffer[iPos+1]='.';
			if(iLen<=0){iPos+=(iUp)? -1:1;break;}
			iSlash=pFrom[iLen];
			iPos+=2;
			iLen--;
			continue;
			}

		for(;iLen>=0;iLen--)							// Zurck auf Backslash
			{
			if(pFrom[iLen]=='\\')break;
			if(pFrom[iLen]=='/' )break;
			}

		if(iPos>=iSize){pBuffer[0]=0;return -1;}
		pBuffer[iPos]=iSlash;
		iPos++;
		iUp++;
		}

	if(iPos+3>iSize || iNum<iLevel)
		{
		pBuffer[0]=0;
		return -1;
		}

	iLen = (int)strlen(pTo);							// Restlichen Pfad anhngen
	if(iPos+iLen>iSize){pBuffer[0]=0;return -1;}
	memcpy(pBuffer+iPos,pTo,iLen+1);
	iPos+=iLen;


return iPos;
}

int _cdecl PathOffset(wchar_t *pBuffer,const wchar_t *pFrom,const wchar_t *pTo,int iSize,int iLevel)
{
int			iUp=0,iLen,iPos=0,iNum,iSlash='\\';
wchar_t		cBufF[MAX_PATH],cBufT[MAX_PATH];


	if(iSize<=0)return -1;
	   iSize--;

	if(pFrom>=pBuffer && pFrom<pBuffer+iSize)			// berschneiden sich die Buffer
		{
		wcsncpy(cBufF,pFrom,sizeof(cBufF)/2);
		pFrom=cBufF;
		}

	if(pTo>=pBuffer && pTo<pBuffer+iSize)
		{
		wcsncpy(cBufT,pTo,sizeof(cBufT)/2);
		pTo=cBufT;
		}

	if(pFrom[0]=='\\' || pFrom[0]=='/')					// Netzlaufwerk/Root berspringen
		{
		if(pFrom[1]=='\\' || pFrom[1]=='/')
				iLen=2;
		else	iLen=1;

		if((pTo[0]!='\\' && pTo[0]!='/') ||
		   (pTo[1]!='\\' && pTo[1]!='/' && iLen>=2) ||
		  ((pTo[2]== 0   || pFrom [2]== 0 )&& iLen>=2))
			{
			pBuffer[0]=0;return -1;
			}

		pFrom += iLen;
		pTo   += iLen;

		for(iLen=0,iNum=0;iNum<iLevel;iLen++)			// Ebene berspringen
			{
			if(pFrom [iLen]==0                   ){iLen=-1;break;}
			if(pFrom [iLen]!='\\' && pFrom [iLen]!='/')continue;
			if(pTo[iLen]!='\\' && pTo[iLen]!='/' ){iLen=-1;break;}
			if(wcsnicmp(pFrom,pTo,iLen)          ){iLen=-1;break;}
			if(iLen<=0                           ){iLen=-1;break;}

			pFrom += iLen+1;
			pTo   += iLen+1;
			iLen   = 0;
			iNum  += 1;
			}

		if(iNum<iLevel || iLen<0)						// Kein Netzlaufwerk vorhanden
			{
			pBuffer[0]=0;
			return -1;
			}
		}
	else{												// Laufwerksangabe
		for(iLen=0,iNum=0;iNum<iLevel;iLen++)
			{
			if(pFrom[iLen]==0){iLen=-1;break;}
			if(pFrom[iLen]==':'  && iNum==0)
				{
				iLen++;
				if(pTo[iLen]!='\\' && pTo[iLen]!='/'){iLen=-1;break;}
				}

			if(pFrom [iLen]!='\\' && pFrom [iLen]!='/')continue;
			if(pTo[iLen]!='\\' && pTo[iLen]!='/' ){iLen=-1;break;}
			if(wcsnicmp(pFrom,pTo,iLen)          ){iLen=-1;break;}
			if(iLen<=0                           ){iLen=-1;break;}

			pFrom += iLen+1;
			pTo   += iLen+1;
			iLen   = 0;
			iNum  += 1;

			if(iNum>1)continue;
			if(*pFrom !='\\' && *pFrom !='/')continue;
			if(*pTo!='\\' && *pTo!='/')continue;
			pFrom ++;
			pTo++;
			}

		if(iNum<iLevel || iLen<0)						// Kein Laufwerk vorhanden
			{
			pBuffer[0]=0;return -1;
			}
		}



	for(;;) 											// Gleiche Verzeichnisse berspringen
		{
		iLen=0;

		for(;;iLen++)
			{
			if(pFrom[iLen]== 0  )break;
			if(pFrom[iLen]=='\\')break;
			if(pFrom[iLen]=='/' )break;
			}

		if(wcsnicmp(pFrom,pTo,iLen))break;

		pFrom += iLen;
		pTo   += iLen;

		if(*pFrom==0)break;								// Ende des Anfangspfades
		if(*pTo  ==0)break;								// Ende des Zielpfades

		iSlash=*pFrom;
		pFrom ++;										// Backslash berspringen
		iNum  ++;
		pTo   ++;
		}

	iLen=(int)wcslen(pFrom)-1;							// Vor auf Ende

	if(iLen>0)
	if(pFrom[iLen]!='\\' && pFrom[iLen]!='/')
		{
		if(iPos+3>iSize){pBuffer[0]=0;return -1;}
		pBuffer[iPos  ]=iSlash;
		pBuffer[iPos+1]='.';
		pBuffer[iPos+2]='.';
		iPos+=3;
		}

	while(iLen>=0)										// Pfad cBufT unten springen
		{
		if(pFrom[iLen]=='\\' || pFrom[iLen]=='/')
			{
			if(iPos+2>iSize){pBuffer[0]=0;return -1;}
			pBuffer[iPos+0]='.';
			pBuffer[iPos+1]='.';
			if(iLen<=0){iPos+=(iUp)? -1:1;break;}
			iSlash=pFrom[iLen];
			iPos+=2;
			iLen--;
			continue;
			}

		for(;iLen>=0;iLen--)							// Zurck auf Backslash
			{
			if(pFrom[iLen]=='\\')break;
			if(pFrom[iLen]=='/' )break;
			}

		if(iPos>=iSize){pBuffer[0]=0;return -1;}
		pBuffer[iPos]=iSlash;
		iPos++;
		iUp++;
		}

	if(iPos+3>iSize || iNum<iLevel)
		{
		pBuffer[0]=0;
		return -1;
		}

	iLen = (int)wcslen(pTo);							// Restlichen Pfad anhngen
	if(iPos+iLen>iSize){pBuffer[0]=0;return -1;}
	memcpy(pBuffer+iPos,pTo,(iLen+1)*2);
	iPos+=iLen;


return iPos;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int _cdecl PathOffset(CString &sTarget,const zchar *pFrom,const zchar *pTo,int iLevel)
{
int		 iLen;
zchar   *pPtr;

	pPtr	= sTarget.GetBuffer(MAX_PATH+64);
	iLen    = PathOffset(pPtr,pFrom,pTo,MAX_PATH+64,iLevel);
	sTarget.ReleaseBuffer(iLen);


return iLen;
}

#endif

//*****************************************************************************
//*
//*		PathFullMake
//*
//*****************************************************************************
//	Erzeugt einen ganzen Pfad aus pFilePath und pBasePath
//	Der neue Pfad wird in pBuffer gespeichert
//	pBasePath	: Absoluter Ausgangspfad		  "C:\abc\"
//												  "\\Netzlaufwerk\abc\"
//												  "http://abc"
//	pFilePath	: Relativer Pfad wird angehngt	  "..\abc\.\xyz.txt"
//				: Root Pfad bei Ebene angehngen  "\abc\.\xyz.txt"
//				: Absoluter ersetzen
//	iSize		: Gre des Puffer pBuffer
//	Ebene		: Die Pfadebene die nicht unter schritten wird
//	Ergibt die neue Lnge des Puffers bzw -1 bei einem Fehler
int _cdecl PathFullMake(char *pBuffer,const char *pBasePath,const char *pFilePath,int iSize,int iEbene)
{
int		iLen,iNum,iPosE=-1;
char	cSlash='\\';
char	cBufB[MAX_PATH];
char	cBufF[MAX_PATH];


	if(iSize<=0)return -1;

	iSize--;

	if(pBasePath>=pBuffer && pBasePath<pBuffer+iSize)		// berschneiden sich die Puffer
		{
		strncpy(cBufB,pBasePath,sizeof(cBufB));
		pBasePath=cBufB;
		}

	if(pFilePath>=pBuffer && pFilePath<pBuffer+iSize)
		{
		strncpy(cBufF,pFilePath,sizeof(cBufF));
		pFilePath=cBufF;
		}

	pBuffer[0]=0;

	if((pFilePath[0]=='\\' || pFilePath[0]=='/')&&			// Netzlaufwerk
	   (pFilePath[1]=='\\' || pFilePath[1]=='/'))
		{
		iLen=(int)strlen(pFilePath);
		}
	else{
		for(iLen=0;;iLen++)									// Ist es "http://"
			{
			if(pFilePath[iLen]== 0  ){iLen=0;break;}
			if(pFilePath[iLen]=='\\'){iLen=0;break;}
			if(pFilePath[iLen]=='/' ){iLen=0;break;}
			if(pFilePath[iLen]!=':' )continue;
			iLen++;
			if(pFilePath[iLen+1]!='\\' && pFilePath[iLen+1]!='/' &&
			  (iLen!=2 || (pFilePath[iLen]!='\\' && pFilePath[iLen]!='/')) &&
			   strnicmp(pBasePath,pFilePath,iLen)==0)		// "http:...." gefunden wie Basis
				{
				pFilePath+=iLen;
				iLen=0;
				break;
				}
			else{											// "http://...." gefunden
				iLen=(int)strlen(pFilePath);
				break;
				}
			}
		}

	if(iLen)												// Absoluter Pfad
		{
		if(iLen>iSize)return -1;
		return PathCompress(pBuffer,pFilePath,iSize+1);
		}

	if(pFilePath[0]=='\\' || pFilePath[0]=='/')				// Ist File-Pfad ein Root-Pfad
		{
		iLen   = 0;
		cSlash = pFilePath[0];
				 pFilePath++;


		if(pBasePath[0]=='\\' || pBasePath[0]=='/')
		if(pBasePath[1]!=0    && iEbene>0)
			{
			iLen = 1;

			if(pBasePath[1]=='\\' || pBasePath[1]=='/')
			if(pBasePath[2]!=0    && iEbene>0)
				{
				iLen = 2;
				}
			}

		if(iEbene>0)
		for(iNum=0;pBasePath[iLen];iLen++)					// Suche Anfgeposition im Basispfad
			{
			if(pBasePath[iLen  ]=='\\' || pBasePath[iLen]=='/' )
				{
				if(!pBasePath[iLen+1])break;

				iNum++;

				if(iNum>=iEbene)break;

				if(pBasePath[iLen+1]=='\\' || pBasePath[iLen+1]=='/' )
					{
					if(!pBasePath[iLen+2])break;
					iLen++;
					}
				}
			}

		if(pBasePath[iLen  ]=='\\' || pBasePath[iLen  ]=='/')
		if(pBasePath[iLen+1]=='\\' || pBasePath[iLen+1]=='/')
			{
			cSlash = pBasePath[iLen];
			iLen++;
			}

		iPosE=iLen;
		}
	else{													// Relativer Pfad
		for(iLen=0;pBasePath[iLen];iLen++)
			{
			     if(pBasePath[iLen]=='\\')cSlash='\\';
			else if(pBasePath[iLen]=='/' )cSlash='/' ;
			else continue;

			if(pBasePath[iLen+1]==0)break;					// Keine Slash am Ende
			iLen++;
			}
		}

	iNum = (int)strlen(pFilePath);
	if(iLen+1+iNum>iSize)return -1;

	memmove(pBuffer        ,pBasePath,iLen);				// Pfad kopieren
	memmove(pBuffer+iLen+1 ,pFilePath,iNum);
			pBuffer[iLen]=cSlash;
			pBuffer[iLen+1+iNum]=0;

	if(iPosE<0)												// Position der Basisebene
		{
		if((pBuffer[0]=='\\'||pBuffer[0]=='/')&&			// Netzlaufwerk
		   (pBuffer[1]=='\\'||pBuffer[1]=='/'))
				iPosE=2;
		else	iPosE=0;

		for(iNum=0;pBuffer[iPosE];iPosE++)					// Suche Ebenenbegin
			{
			if(pBuffer[iPosE+1]=='\\' || pBuffer[iPosE+1]=='/' )
				{
				iNum++;
				if(pBuffer[iPosE+1]=='\\' ||
				   pBuffer[iPosE+1]=='/' )iPosE++;
				}

			if(iNum>=iEbene)break;
			}

		if(pBuffer[iPosE  ]=='\\' || pBuffer[iPosE  ]=='/')
		if(pBuffer[iPosE+1]=='\\' || pBuffer[iPosE+1]=='/')iPosE++;
		}

	iNum=PathCompress(pBuffer+iPosE,iSize-iPosE);


return iPosE+iNum;
}

int _cdecl PathFullMake(wchar_t *pBuffer,const wchar_t *pBasePath,const wchar_t *pFilePath,int iSize,int iEbene)
{
int			iLen,iNum,iPosE=-1;
wchar_t		cSlash='\\';
wchar_t		cBufB[MAX_PATH];
wchar_t		cBufF[MAX_PATH];


	if(iSize<=0)return -1;

	iSize--;

	if(pBasePath>=pBuffer && pBasePath<pBuffer+iSize)		// berschneiden sich die Puffer
		{
		wcsncpy(cBufB,pBasePath,sizeof(cBufB)/2);
		pBasePath=cBufB;
		}

	if(pFilePath>=pBuffer && pFilePath<pBuffer+iSize)
		{
		wcsncpy(cBufF,pFilePath,sizeof(cBufF)/2);
		pFilePath=cBufF;
		}

	pBuffer[0]=0;

	if((pFilePath[0]=='\\' || pFilePath[0]=='/')&&			// Netzlaufwerk
	   (pFilePath[1]=='\\' || pFilePath[1]=='/'))
		{
		iLen=(int)wcslen(pFilePath);
		}
	else{
		for(iLen=0;;iLen++)									// Ist es "http://"
			{
			if(pFilePath[iLen]== 0  ){iLen=0;break;}
			if(pFilePath[iLen]=='\\'){iLen=0;break;}
			if(pFilePath[iLen]=='/' ){iLen=0;break;}
			if(pFilePath[iLen]!=':' )continue;
			iLen++;
			if(pFilePath[iLen+1]!='\\' && pFilePath[iLen+1]!='/' &&
			  (iLen!=2 || (pFilePath[iLen]!='\\' && pFilePath[iLen]!='/')) &&
			   wcsnicmp(pBasePath,pFilePath,iLen)==0)		// "http:...." gefunden wie Basis
				{
				pFilePath+=iLen;
				iLen=0;
				break;
				}
			else{											// "http://...." gefunden
				iLen=(int)wcslen(pFilePath);
				break;
				}
			}
		}

	if(iLen)												// Absoluter Pfad
		{
		if(iLen>iSize)return -1;
		return PathCompress(pBuffer,pFilePath,iSize+1);
		}

	if(pFilePath[0]=='\\' || pFilePath[0]=='/')				// Ist File-Pfad ein Root-Pfad
		{
		iLen   = 0;
		cSlash = pFilePath[0];
				 pFilePath++;


		if(pBasePath[0]=='\\' || pBasePath[0]=='/')
		if(pBasePath[1]!=0    && iEbene>0)
			{
			iLen = 1;

			if(pBasePath[1]=='\\' || pBasePath[1]=='/')
			if(pBasePath[2]!=0    && iEbene>0)
				{
				iLen = 2;
				}
			}

		if(iEbene>0)
		for(iNum=0;pBasePath[iLen];iLen++)					// Suche Anfgeposition im Basispfad
			{
			if(pBasePath[iLen  ]=='\\' || pBasePath[iLen]=='/' )
				{
				if(!pBasePath[iLen+1])break;

				iNum++;

				if(iNum>=iEbene)break;

				if(pBasePath[iLen+1]=='\\' || pBasePath[iLen+1]=='/' )
					{
					if(!pBasePath[iLen+2])break;
					iLen++;
					}
				}
			}

		if(pBasePath[iLen  ]=='\\' || pBasePath[iLen  ]=='/')
		if(pBasePath[iLen+1]=='\\' || pBasePath[iLen+1]=='/')
			{
			cSlash = pBasePath[iLen];
			iLen++;
			}

		iPosE=iLen;
		}
	else{													// Relativer Pfad
		for(iLen=0;pBasePath[iLen];iLen++)
			{
			     if(pBasePath[iLen]=='\\')cSlash='\\';
			else if(pBasePath[iLen]=='/' )cSlash='/' ;
			else continue;

			if(pBasePath[iLen+1]==0)break;					// Keine Slash am Ende
			iLen++;
			}
		}

	iNum = (int)wcslen(pFilePath);
	if(iLen+1+iNum>iSize)return -1;

	memmove(pBuffer       ,pBasePath,iLen*2);				// Pfad kopieren
	memmove(pBuffer+iLen+1,pFilePath,iNum*2);
			pBuffer[iLen]=cSlash;
			pBuffer[iLen+1+iNum]=0;

	if(iPosE<0)												// Position der Basisebene
		{
		if((pBuffer[0]=='\\'||pBuffer[0]=='/')&&			// Netzlaufwerk
		   (pBuffer[1]=='\\'||pBuffer[1]=='/'))
				iPosE=2;
		else	iPosE=0;

		for(iNum=0;pBuffer[iPosE];iPosE++)					// Suche Ebenenbegin
			{
			if(pBuffer[iPosE+1]=='\\' || pBuffer[iPosE+1]=='/' )
				{
				iNum++;
				if(pBuffer[iPosE+1]=='\\' ||
				   pBuffer[iPosE+1]=='/' )iPosE++;
				}

			if(iNum>=iEbene)break;
			}

		if(pBuffer[iPosE  ]=='\\' || pBuffer[iPosE  ]=='/')
		if(pBuffer[iPosE+1]=='\\' || pBuffer[iPosE+1]=='/')iPosE++;
		}

	iNum=PathCompress(pBuffer+iPosE,iSize-iPosE);


return iPosE+iNum;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int _cdecl PathFullMake(CString &sTarget,const zchar *pBasePath,const zchar *pFilePath,int iLevel)
{
int		iLen;
zchar  *pPtr;


	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pBasePath)										// Werden die gleichen Puffer benutzt
		{
		iLen      = (sTarget.GetLength()+1)*sizeof(zchar);
		pBasePath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pBasePath,pPtr,iLen);
		}

	if(pPtr==pFilePath)
		{
		iLen      = (sTarget.GetLength()+1)*sizeof(zchar);
		pFilePath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pFilePath,pPtr,iLen);
		}


	pPtr	= sTarget.GetBuffer(MAX_PATH+64);
	iLen    = PathFullMake(pPtr,pBasePath,pFilePath,MAX_PATH+64,iLevel);
	sTarget.ReleaseBuffer(iLen);


return iLen;
}

#endif

//*****************************************************************************
//*
//*		MakeLongPath
//*
//*****************************************************************************
//	Wandelt einen pPath in einen langen Dateinamen um
//	pBuffer	: Speicher fr den neuen Namen
//	pPath	: Quellpfad der umgewandelt werden soll
//	iSize	: Gre der Zielspeichers
//	Ergibt die neue Lnge der Pfades
int _cdecl MakeLongPath(char *pBuffer,const char *pPath,int iSize)
{
char				cTemp[MAX_PATH+128]="",cText[MAX_PATH+128];
int					iLen,iNum,iPos,iMax,iStart;
HANDLE				hFind;
WIN32_FIND_DATAA	sData;



	iMax=GetFullPathNameA(pPath,sizeof(cTemp),cTemp,0);

	iSize--;
	if(iSize<0)return 0;
	pBuffer[0]=0;

	iPos=0;

	if(cTemp[0]!= 0   && cTemp[1]==':')					// Laufwerksbezeichnung
	if(cTemp[2]=='\\' || cTemp[2]=='/')
		{
		memcpy(cText,cTemp,3);
		iPos=3;
		iNum=3;
		}

	for(;iPos<iMax;)
		{
		for(;iPos<iMax;iPos++)							// Dateinamenanfang suchen
			{
			if(cTemp[iPos]!='\\')
			if(cTemp[iPos]!='/' )break;

			cText[iNum]=cTemp[iPos];
			iNum++;
			}

		iStart=iPos;

		for(;iPos<iMax;iPos++)							// Dateinamenende suchen
			{
			if(cTemp[iPos]=='\\')break;
			if(cTemp[iPos]=='/' )break;
			}

		iLen=iPos-iStart;
		if(iLen==0)continue;
		if(iLen+iNum>sizeof(cText)-1)return 0;
		memcpy(cText+iNum,cTemp+iStart,iLen);
		cText[iNum+iLen]=0;

		for(;iStart<iPos;iStart++)						// Wildcards berspringen
			{
			if(cTemp[iStart]=='*')break;
			if(cTemp[iStart]=='?')break;
			}

		if(iStart<iPos)
			{
			iNum+=iLen;
			continue;
			}


		   hFind=FindFirstFileA(cText,&sData);			// Suche Datei
 		if(hFind!=INVALID_HANDLE_VALUE)
			{
			FindClose(hFind);
			iLen=(int)strlen(sData.cFileName);
			if(iLen+iNum>sizeof(cText)-1)return 0;
			memcpy(cText+iNum,sData.cFileName,iLen+1);
			}

		iNum+=iLen;
		}

	if(iNum>iSize)return 0;
	memcpy(pBuffer,cText,iNum+1);


return iNum;
}

int _cdecl MakeLongPath(wchar_t *pBuffer,const wchar_t *pPath,int iSize)
{
wchar_t				cTemp[MAX_PATH+128]=L"",cText[MAX_PATH+128];
int					iLen,iNum,iPos,iMax,iStart;
HANDLE				hFind;
WIN32_FIND_DATAW	sData;



	iMax=GetFullPathNameW(pPath,sizeof(cTemp)/2,cTemp,0);

	iSize--;
	if(iSize<0)return 0;
	pBuffer[0]=0;

	iPos=0;

	if(cTemp[0]!= 0   && cTemp[1]==':')					// Laufwerksbezeichnung
	if(cTemp[2]=='\\' || cTemp[2]=='/')
		{
		memcpy(cText,cTemp,3*2);
		iPos=3;
		iNum=3;
		}

	for(;iPos<iMax;)
		{
		for(;iPos<iMax;iPos++)							// Dateinamenanfang suchen
			{
			if(cTemp[iPos]!='\\')
			if(cTemp[iPos]!='/' )break;

			cText[iNum]=cTemp[iPos];
			iNum++;
			}

		iStart=iPos;

		for(;iPos<iMax;iPos++)							// Dateinamenende suchen
			{
			if(cTemp[iPos]=='\\')break;
			if(cTemp[iPos]=='/' )break;
			}

		iLen=iPos-iStart;
		if(iLen==0)continue;
		if(iLen+iNum>sizeof(cText)-1)return 0;
		memcpy(cText+iNum,cTemp+iStart,iLen*2);
		cText[iNum+iLen]=0;

		for(;iStart<iPos;iStart++)						// Wildcards berspringen
			{
			if(cTemp[iStart]=='*')break;
			if(cTemp[iStart]=='?')break;
			}

		if(iStart<iPos)
			{
			iNum+=iLen;
			continue;
			}


		   hFind=FindFirstFileW(cText,&sData);			// Suche Datei
 		if(hFind!=INVALID_HANDLE_VALUE)
			{
			FindClose(hFind);
			iLen=(int)wcslen(sData.cFileName);
			if(iLen+iNum>sizeof(cText)-1)return 0;
			memcpy(cText+iNum,sData.cFileName,(iLen+1)*2);
			}

		iNum+=iLen;
		}

	if(iNum>iSize)return 0;
	memcpy(pBuffer,cText,(iNum+1)*2);


return iNum;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int _cdecl MakeLongPath(CString &sTarget,const zchar *pPath)
{
zchar *pPtr;
int    iLen;


	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		iLen  = (sTarget.GetLength()+1)*sizeof(zchar);
		pPath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pPath,pPtr,iLen);
		}

	pPtr  = sTarget.GetBuffer(MAX_PATH*2);
	iLen  = MakeLongPath(pPtr,pPath,MAX_PATH*2);
	sTarget.ReleaseBuffer(iLen);


return iLen;
}

#endif

//*****************************************************************************
//*
//*		MakeShortPath
//*
//*****************************************************************************
//	Wandelt pPath in einen langen Dateinamen um
//	pBuffer	: Speicher fr den neuen Namen
//	pPath	: Quellpfad der umgewandelt werden soll
//	iSize	: Gre der Zielspeichers
//	Ergibt die neue Lnge der Pfades
int _cdecl MakeShortPath(char *pBuffer,const char *pPath,int iSize)
{
char		    *pPtr,cTemp[MAX_PATH+128]="",cText[MAX_PATH+128];
int				 iLen,iPos,iMax,iStart,iNum=0;
HANDLE			 hFind;
WIN32_FIND_DATAA sData;



	iMax=GetFullPathNameA(pPath,sizeof(cTemp),cTemp,0);

	iSize--;
	if(iSize<0)return 0;
	pBuffer[0]=0;

	iPos=0;

	if(cTemp[0]!= 0   && cTemp[1]==':')					// Laufwerksbezeichnung
	if(cTemp[2]=='\\' || cTemp[2]=='/')
		{
		memcpy(cText,cTemp,3);
		iPos=3;
		iNum=3;
		}

	for(;iPos<iMax;)
		{
		for(;iPos<iMax;iPos++)							// Dateinamenanfang suchen
			{
			if(cTemp[iPos]!='\\')
			if(cTemp[iPos]!='/' )break;

			cText[iNum]=cTemp[iPos];
			iNum++;
			}

		iStart=iPos;

		for(;iPos<iMax;iPos++)							// Dateinamenende suchen
			{
			if(cTemp[iPos]=='\\')break;
			if(cTemp[iPos]=='/' )break;
			}

		iLen=iPos-iStart;
		if(iLen==0)continue;
		if(iLen+iNum>sizeof(cText)-1)return 0;
		memcpy(cText+iNum,cTemp+iStart,iLen);
		cText[iNum+iLen]=0;

		for(;iStart<iPos;iStart++)						// Wildcards berspringen
			{
			if(cTemp[iStart]=='*')break;
			if(cTemp[iStart]=='?')break;
			}

		if(iStart<iPos)
			{
			iNum+=iLen;
			continue;
			}

		   hFind=FindFirstFileA(cText,&sData);			// Suche Datei
 		if(hFind!=INVALID_HANDLE_VALUE)
			{
			FindClose(hFind);
			pPtr=sData.cAlternateFileName;
			iLen=(int)strlen(pPtr);
			if(iLen<=0)
				{
				pPtr=sData.cFileName;
				iLen=(int)strlen(pPtr);
				}

			if(iLen+iNum>sizeof(cText)-1)return 0;
			memcpy(cText+iNum,pPtr,iLen+1);
			}

		iNum+=iLen;
		}

	if(iNum>iSize)return 0;
	memcpy(pBuffer,cText,iNum);
	pBuffer[iNum]=0;


return iNum;
}

int _cdecl MakeShortPath(wchar_t *pBuffer,const wchar_t *pPath,int iSize)
{
wchar_t		    *pPtr,cTemp[MAX_PATH+128]=L"",cText[MAX_PATH+128];
int				 iLen,iPos,iMax,iStart,iNum=0;
HANDLE			 hFind;
WIN32_FIND_DATAW sData;



	iMax=GetFullPathNameW(pPath,sizeof(cTemp),cTemp,0);

	iSize--;
	if(iSize<0)return 0;
	pBuffer[0]=0;

	iPos=0;

	if(cTemp[0]!= 0   && cTemp[1]==':')					// Laufwerksbezeichnung
	if(cTemp[2]=='\\' || cTemp[2]=='/')
		{
		memcpy(cText,cTemp,3*2);
		iPos=3;
		iNum=3;
		}

	for(;iPos<iMax;)
		{
		for(;iPos<iMax;iPos++)							// Dateinamenanfang suchen
			{
			if(cTemp[iPos]!='\\')
			if(cTemp[iPos]!='/' )break;

			cText[iNum]=cTemp[iPos];
			iNum++;
			}

		iStart=iPos;

		for(;iPos<iMax;iPos++)							// Dateinamenende suchen
			{
			if(cTemp[iPos]=='\\')break;
			if(cTemp[iPos]=='/' )break;
			}

		iLen=iPos-iStart;
		if(iLen==0)continue;
		if(iLen+iNum>sizeof(cText)-1)return 0;
		memcpy(cText+iNum,cTemp+iStart,iLen*2);
		cText[iNum+iLen]=0;

		for(;iStart<iPos;iStart++)						// Wildcards berspringen
			{
			if(cTemp[iStart]=='*')break;
			if(cTemp[iStart]=='?')break;
			}

		if(iStart<iPos)
			{
			iNum+=iLen;
			continue;
			}

		   hFind=FindFirstFileW(cText,&sData);			// Suche Datei
 		if(hFind!=INVALID_HANDLE_VALUE)
			{
			FindClose(hFind);
			pPtr=sData.cAlternateFileName;
			iLen=(int)wcslen(pPtr);
			if(iLen<=0)
				{
				pPtr=sData.cFileName;
				iLen=(int)wcslen(pPtr);
				}

			if(iLen+iNum>sizeof(cText)-1)return 0;
			memcpy(cText+iNum,pPtr,(iLen+1)*2);
			}

		iNum+=iLen;
		}

	if(iNum>iSize)return 0;
	memcpy(pBuffer,cText,iNum*2);
	pBuffer[iNum]=0;


return iNum;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int _cdecl MakeShortPath(CString &sTarget,const zchar *pPath)
{
zchar  *pPtr;
int		iLen;


	   pPtr = (zchar*)((LPCTSTR)sTarget);
	if(pPtr==pPath)										// Werden die gleichen Puffer benutzt
		{
		iLen  = (sTarget.GetLength()+1)*sizeof(zchar);
		pPath = (zchar*)alloca(iLen);
		memcpy ((zchar*)pPath,pPtr,iLen);
		}

	pPtr = sTarget.GetBuffer(MAX_PATH*2);
	iLen = MakeShortPath(pPtr,pPath,MAX_PATH*2);
	sTarget.ReleaseBuffer(iLen);


return iLen;
}

#endif

//*****************************************************************************
//*
//*		ChangeFileTime
//*
//*****************************************************************************
//	ndert die Dateizeiten einer Datei
//	pFileName		: Ist der Namen der Datei.
//	iLastWriteTime	: Ist die neue nderungszeit,
//					  oder -1 wenn sie nicht gendert werden soll.
//	iCreationTime	: Ist die neue Erstellungszeit,
//					  oder -1 wenn sie nicht gendert werden soll.
//	iLastAccessTime	: Ist die neue Zugriffszeitzeit,
//					  oder -1 wenn sie nicht gendert werden soll.
//	Ergibt 1 wenn die Zeiten gespeichert wurden, bzw. 0 bei einem Fehler.
int _cdecl ChangeFileTime(const char *pFileName,time_t iLastWriteTime,time_t iCreationTime,time_t iLastAccessTime)
{
FILETIME	aTimes[3];


	UtcTimeToFileTime(iLastWriteTime ,aTimes  );
	UtcTimeToFileTime(iCreationTime  ,aTimes+1);
	UtcTimeToFileTime(iLastAccessTime,aTimes+2);


return ChangeFileTime(pFileName,(iLastWriteTime<0)? 0:aTimes+0,(iCreationTime<0)? 0:aTimes+1,(iLastAccessTime<0)? 0:aTimes+2);
}

int _cdecl ChangeFileTime(const wchar_t *pFileName,time_t iLastWriteTime,time_t iCreationTime,time_t iLastAccessTime)
{
FILETIME	aTimes[3];


	UtcTimeToFileTime(iLastWriteTime ,aTimes  );
	UtcTimeToFileTime(iCreationTime  ,aTimes+1);
	UtcTimeToFileTime(iLastAccessTime,aTimes+2);


return ChangeFileTime(pFileName,(iLastWriteTime<0)? 0:aTimes+0,(iCreationTime<0)? 0:aTimes+1,(iLastAccessTime<0)? 0:aTimes+2);
}

//*****************************************************************************
//*
//*		ChangeFileTime
//*
//*****************************************************************************
//	ndert die Dateizeiten einer Datei
//	pFileName		: Ist der Namen der Datei.
//	pLastWriteTime	: Ist ein Zeiger auf die neue nderungszeit,
//					  oder NULL wenn sie nicht gendert werden soll.
//	pCreationTime	: Ist ein Zeiger auf die neue Erstellungszeit,
//					  oder NULL wenn sie nicht gendert werden soll.
//	pLastAccessTime	: Ist ein Zeiger auf die neue Zugriffszeitzeit,
//					  oder NULL wenn sie nicht gendert werden soll.
//	Ergibt 1 wenn die Zeiten gespeichert wurden, bzw. 0 bei einem Fehler.
int _cdecl ChangeFileTime(const char *pFileName,const FILETIME *pLastWriteTime,const FILETIME *pCreationTime,const FILETIME *pLastAccessTime)
{
HANDLE		hFile;
int			iRet;


	   hFile=CreateFileA(pFileName,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING,0);
	if(hFile==INVALID_HANDLE_VALUE)return 0;

	iRet = SetFileTime(hFile,pCreationTime,pLastAccessTime,pLastWriteTime);

	CloseHandle(hFile);


return iRet;
}

int _cdecl ChangeFileTime(const wchar_t *pFileName,const FILETIME *pLastWriteTime,const FILETIME *pCreationTime,const FILETIME *pLastAccessTime)
{
HANDLE		hFile;
int			iRet;

	   hFile=CreateFileW(pFileName,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING,0);
	if(hFile==INVALID_HANDLE_VALUE)return 0;

	iRet = SetFileTime(hFile,pCreationTime,pLastAccessTime,pLastWriteTime);

	CloseHandle(hFile);


return iRet;
}

//*********************+*******************************************************
//*
//*		CopyFileTime
//*
//*****************************************************************************
//	Kopiert alle Zeitangaben von der Datei Quelle in die Datei Ziel.
//	Ergibt 1 wenn alles kopiert wurde.
int _cdecl CopyFileTime(const char *pSource,const char *pTarget)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;
HANDLE						hFile;


	if(!GetFileAttributesExA(pSource,GetFileExInfoStandard,&sFind))
		{
		return 0;
		}

	   hFile=CreateFileA(pTarget,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING,0);
	if(hFile==INVALID_HANDLE_VALUE)return 0;

	SetFileTime(hFile,	&sFind.ftCreationTime,
						&sFind.ftLastAccessTime,
						&sFind.ftLastWriteTime);

	CloseHandle(hFile);


return 1;
}

int _cdecl CopyFileTime(const wchar_t *pSource,const wchar_t *pTarget)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;
HANDLE						hFile;


	if(!GetFileAttributesExW(pSource,GetFileExInfoStandard,&sFind))
		{
		return 0;
		}

	   hFile=CreateFileW(pTarget,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING,0);
	if(hFile==INVALID_HANDLE_VALUE)return 0;

	SetFileTime(hFile,	&sFind.ftCreationTime,
						&sFind.ftLastAccessTime,
						&sFind.ftLastWriteTime);

	CloseHandle(hFile);


return 1;
}

//*****************************************************************************
//*
//*		FindFile
//*
//*****************************************************************************
//	Sucht nach einem einer einzelnen Datei
//	Ergibt:	2 wenn ein Verzeichnis gefunden wurde
//			1 wenn eine Datei gefunden wurde
//			0 wenn keine Datei gefunden wurde
int _cdecl FindFile(const char *pFile,WIN32_FIND_DATAA *pFind)
{
HANDLE	hFile;
int		iPos;


	hFile=INVALID_HANDLE_VALUE;

	for(iPos=0;pFile[iPos];iPos++)				// Suche Wildcards
		{
		if(pFile[iPos]=='*')break;
		if(pFile[iPos]=='?')break;
		}

	if(!pFile[iPos])							// Ist der Pfad ok
		{
		hFile=FindFirstFileA(pFile,pFind);
		}

	if(hFile==INVALID_HANDLE_VALUE)				// Wurde die Datei gefunden
		{
		pFind->cFileName[0]     = 0;
		pFind->dwFileAttributes = 0;
		pFind->nFileSizeLow     = 0;
		pFind->nFileSizeHigh    = 0;
		return 0;
		}

	FindClose(hFile);


return (pFind->dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)? 2:1;
}

int _cdecl FindFile(const wchar_t *pFile,WIN32_FIND_DATAW *pFind)
{
HANDLE	hFile;
int		iPos;


	hFile=INVALID_HANDLE_VALUE;

	for(iPos=0;pFile[iPos];iPos++)				// Suche Wildcards
		{
		if(pFile[iPos]=='*')break;
		if(pFile[iPos]=='?')break;
		}

	if(!pFile[iPos])							// Ist der Pfad ok
		{
		hFile=FindFirstFileW(pFile,pFind);
		}

	if(hFile==INVALID_HANDLE_VALUE)				// Wurde die Datei gefunden
		{
		pFind->cFileName[0]     = 0;
		pFind->dwFileAttributes = 0;
		pFind->nFileSizeLow     = 0;
		pFind->nFileSizeHigh    = 0;
		return 0;
		}

	FindClose(hFile);


return (pFind->dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)? 2:1;
}

int _cdecl FindFile(const char *pFile,WIN32_FILE_ATTRIBUTE_DATA *pFind)
{
												// Ist der Pfad ok
	if(!GetFileAttributesExA(pFile,GetFileExInfoStandard,pFind))
		{
		pFind->dwFileAttributes = 0;
		pFind->nFileSizeLow     = 0;
		pFind->nFileSizeHigh    = 0;
		return 0;
		}

return (pFind->dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)? 2:1;
}

int _cdecl FindFile(const wchar_t *pFile,WIN32_FILE_ATTRIBUTE_DATA *pFind)
{
												// Ist der Pfad ok
	if(!GetFileAttributesExW(pFile,GetFileExInfoStandard,pFind))
		{
		pFind->dwFileAttributes = 0;
		pFind->nFileSizeLow     = 0;
		pFind->nFileSizeHigh    = 0;
		return 0;
		}

return (pFind->dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)? 2:1;
}

//******************************************************************************
//*
//*		SaveMemory
//*
//******************************************************************************
//	Speichert einen Speicherbereich in einer Datei ab.
//	pPath		: Ist der Name der Datei.
//	pMemory		: Ist der Zeiger auf den Speicherbereich.
//	iSize		: Ist die Gre des Speicherbereiches in Byte.
//	iAtEnd		: Daten am Ende anhngen
//	Ergibt 1 wenn die Datei erstellt wurde, bzw. 0 bei einem Fehler
int _cdecl SaveMemory(const char *pPath,const void *pMemory,int iSize,int iAtEnd)
{
HANDLE		hFile;
DWORD		uByte;
BOOL		bOk;



	if(iSize<0)return 0;

	   hFile=CreateFileA(pPath,GENERIC_WRITE,0,0,(iAtEnd)? OPEN_ALWAYS:CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hFile==INVALID_HANDLE_VALUE)return 0;

	if(iAtEnd)
		{
		SetFilePointer(hFile,0,NULL,FILE_END);
		}


	bOk = WriteFile(hFile,pMemory,iSize,&uByte,NULL);
	CloseHandle(hFile);


	if(!bOk && (int)uByte!=iSize)return 0;


return 1;
}

int _cdecl SaveMemory(const wchar_t *pPath,const void *pMemory,int iSize,int iAtEnd)
{
HANDLE		hFile;
DWORD		uByte;
BOOL		bOk;



	if(iSize<0)return 0;

	   hFile=CreateFileW(pPath,GENERIC_WRITE,0,0,(iAtEnd)? OPEN_ALWAYS:CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hFile==INVALID_HANDLE_VALUE)return 0;

	if(iAtEnd)
		{
		SetFilePointer(hFile,0,NULL,FILE_END);
		}


	bOk = WriteFile(hFile,pMemory,iSize,&uByte,NULL);
	CloseHandle(hFile);


	if(!bOk && (int)uByte!=iSize)return 0;


return 1;
}

//******************************************************************************
//*
//*		LoadMemory
//*
//******************************************************************************
//	Ld eine Datei in einen Speicherbereich. Es wird dabei eine Null automatisch
//	an die geladenen Daten angehngt. Die letzten beiden Bytes des Speicher
//	werden nicht mit Daten beschrieben, sondern nur mit 0 gefllt wenn notwendig.
//	pPath		: Ist der Name der Datei.
//	pMemory		: Ist der Zeiger auf den Speicherbereich.
//				  Dieser muss mindestens 2 Byte gro sein.
//	iSize		: Ist die Gre des Speicherbereiches in Byte.
//	iFail		: Wenn die Datei zu gro ist einen Fehler ausgeben.
//	Ergibt die geladenen Bytes, bzw. 0 bei einem Fehler.
int _cdecl LoadMemory(const char *pPath,void *pMemory,int iSize,int iFail)
{
HANDLE		hFile;
DWORD		uByte;
BOOL		bOk;



	if(iSize<2)
		{
		if(iSize==1)memset(pMemory,0,1);
		return 0;
		}

	   hFile=CreateFileA(pPath,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hFile==INVALID_HANDLE_VALUE)
		{
		memset(pMemory,0,2);
		return 0;
		}


	bOk = ReadFile(hFile,pMemory,iSize-2,&uByte,NULL);
	CloseHandle(hFile);


	if(!bOk && uByte==0)
		{
		memset(pMemory,0,2);
		return 0;
		}

	memset((char*)pMemory+uByte,0,2);


return uByte;
}

int _cdecl LoadMemory(const wchar_t *pPath,void *pMemory,int iSize)
{
HANDLE		hFile;
DWORD		uByte;
BOOL		bOk;



	if(iSize<2)
		{
		if(iSize==1)memset(pMemory,0,1);
		return 0;
		}

	   hFile=CreateFileW(pPath,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hFile==INVALID_HANDLE_VALUE)
		{
		memset(pMemory,0,2);
		return 0;
		}


	bOk = ReadFile(hFile,pMemory,iSize-2,&uByte,NULL);
	CloseHandle(hFile);


	if(!bOk && uByte==0)
		{
		memset(pMemory,0,2);
		return 0;
		}

	memset((char*)pMemory+uByte,0,2);


return uByte;
}

//*****************************************************************************
//*
//*		RemovePath
//*
//*****************************************************************************
//	Lscht ganze Verzeichnisse samt Unterverzeichnissen
//	pPath		: Verzeichnis das gelscht werden soll
//	iOnlySub	: Nur Unterverzeichnisse lschen
//	iDelta		: Wieviele Skunden mssen die Dateien lter sein
//	pFilter		: Filter fr zu lschende Dateien
//	Ergibt 1 wenn das Verzeichnis gelscht wurde, bzw. 0 bei einem Fehler
int _cdecl RemovePath(const char *pPath,int iOnlySub)
{
WIN32_FIND_DATAA	sFind;
HANDLE				hFind;
char				cFile[MAX_PATH];
int					iLen;
int					iRet;
int					iOk;


	strcpy(cFile,pPath);
	iLen=(int)strlen(cFile);
	if(iLen<=0)return 0;

	if(cFile[iLen-1]!='\\' && cFile[iLen-1]!='/')
		{
		cFile[iLen]='\\';
		iLen++;
		}

	cFile[iLen  ]='*';
	cFile[iLen+1]=0;
	iOk=1;

	   hFind=FindFirstFileA(cFile,&sFind);
	if(hFind!=INVALID_HANDLE_VALUE)
		{
		do	{
			if(sFind.cFileName[0]=='.')
				{
				if(sFind.cFileName[1]=='.')
				if(sFind.cFileName[2]== 0 )continue;
				if(sFind.cFileName[1]== 0 )continue;
				}

			strcpy(cFile+iLen,sFind.cFileName);

			if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
					iRet=RemovePath(cFile,iOnlySub&2);
			else	iRet=RemoveFile(cFile);

			if(!iRet)iOk=0;

			}while(FindNextFileA(hFind,&sFind));

		FindClose(hFind);
		}

	if(iOnlySub)return iOk;

	cFile[iLen]=0;

return RemoveDirectoryA(cFile);
}

int _cdecl RemovePath(const wchar_t *pPath,int iOnlySub)
{
WIN32_FIND_DATAW	sFind;
HANDLE				hFind;
wchar_t				cFile[MAX_PATH];
int					iLen;
int					iRet;
int					iOk;


	wcscpy(cFile,pPath);
	iLen=(int)wcslen(cFile);
	if(iLen<=0)return 0;

	if(cFile[iLen-1]!='\\' && cFile[iLen-1]!='/')
		{
		cFile[iLen]='\\';
		iLen++;
		}

	cFile[iLen  ]='*';
	cFile[iLen+1]=0;
	iOk=1;

	   hFind=FindFirstFileW(cFile,&sFind);
	if(hFind!=INVALID_HANDLE_VALUE)
		{
		do	{
			if(sFind.cFileName[0]=='.')
				{
				if(sFind.cFileName[1]=='.')
				if(sFind.cFileName[2]== 0 )continue;
				if(sFind.cFileName[1]== 0 )continue;
				}

			wcscpy(cFile+iLen,sFind.cFileName);

			if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
					iRet=RemovePath(cFile,iOnlySub&2);
			else	iRet=RemoveFile(cFile);

			if(!iRet)iOk=0;

			}while(FindNextFileW(hFind,&sFind));

		FindClose(hFind);
		}

	if(iOnlySub)return iOk;

	cFile[iLen]=0;

return RemoveDirectoryW(cFile);
}

int _cdecl RemovePath(const char *pPath,int iOnlySub,__int64 iDelta,const char *pFilter,__int64 iNow)
{
WIN32_FIND_DATAA	sFind;
HANDLE				hFind;
char				cFile[MAX_PATH];
__int64				iDiff;
int					iLen;
int					iRet;
int					iOk;


	if(!iNow)												// Aktuelle Zeit holen
		{
		if(pFilter && !*pFilter)pFilter=NULL;
		GetSystemTimeAsFileTime((LPFILETIME)&iNow);
		iDelta *= 10000000;									// Sekunden zu 10ns
		}

	strcpy(cFile,pPath);
	iLen=(int)strlen(cFile);
	if(iLen<=0)return 0;

	if(cFile[iLen-1]!='\\' && cFile[iLen-1]!='/')
		{
		cFile[iLen]='\\';
		iLen++;
		}

	cFile[iLen  ]='*';
	cFile[iLen+1]=0;
	iOk=1;

	   hFind=FindFirstFileA(cFile,&sFind);
	if(hFind!=INVALID_HANDLE_VALUE)
		{
		do	{
			if(sFind.cFileName[0]=='.')
				{
				if(sFind.cFileName[1]=='.')
				if(sFind.cFileName[2]== 0 )continue;
				if(sFind.cFileName[1]== 0 )continue;
				}

			strcpy(cFile+iLen,sFind.cFileName);

			if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
				{
				iRet = RemovePath(cFile,iOnlySub&2,iDelta,pFilter,iNow);
				}
			else if(!pFilter || memfilter(sFind.cFileName,(int)strlen(sFind.cFileName),pFilter,3)>0)
				{
				   iDiff = iNow-*(__int64*)&sFind.ftLastWriteTime;
				if(iDiff>iDelta)
						iRet = RemoveFile(cFile);
				else	iRet = 1;
				}
			else{
				iRet = 1;
				}

			if(!iRet)iOk=0;

			}while(FindNextFileA(hFind,&sFind));

		FindClose(hFind);
		}

	if(iOnlySub)return iOk;

	cFile[iLen]=0;

return RemoveDirectoryA(cFile);
}

int _cdecl RemovePath(const wchar_t *pPath,int iOnlySub,__int64 iDelta,const wchar_t *pFilter,__int64 iNow)
{
WIN32_FIND_DATAW	sFind;
HANDLE				hFind;
wchar_t				cFile[MAX_PATH];
__int64				iDiff;
int					iLen;
int					iRet;
int					iOk;


	if(!iNow)												// Aktuelle Zeit holen
		{
		if(pFilter && !*pFilter)pFilter=NULL;
		GetSystemTimeAsFileTime((LPFILETIME)&iNow);
		iDelta *= 10000000;									// Sekunden zu 10ns
		}

	wcscpy(cFile,pPath);
	iLen=(int)wcslen(cFile);
	if(iLen<=0)return 0;

	if(cFile[iLen-1]!='\\' && cFile[iLen-1]!='/')
		{
		cFile[iLen]='\\';
		iLen++;
		}

	cFile[iLen  ]='*';
	cFile[iLen+1]=0;
	iOk=1;

	   hFind=FindFirstFileW(cFile,&sFind);
	if(hFind!=INVALID_HANDLE_VALUE)
		{
		do	{
			if(sFind.cFileName[0]=='.')
				{
				if(sFind.cFileName[1]=='.')
				if(sFind.cFileName[2]== 0 )continue;
				if(sFind.cFileName[1]== 0 )continue;
				}

			wcscpy(cFile+iLen,sFind.cFileName);

			if(sFind.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
				{
				iRet = RemovePath(cFile,iOnlySub&2,iDelta,pFilter,iNow);
				}
			else if(!pFilter || memfilter(sFind.cFileName,(int)wcslen(sFind.cFileName),pFilter,3)>0)
				{
				   iDiff = iNow-*(__int64*)&sFind.ftLastWriteTime;
				if(iDiff>iDelta)
						iRet = RemoveFile(cFile);
				else	iRet = 1;
				}
			else{
				iRet = 1;
				}

			if(!iRet)iOk=0;

			}while(FindNextFileW(hFind,&sFind));

		FindClose(hFind);
		}

	if(iOnlySub)return iOk;

	cFile[iLen]=0;

return RemoveDirectoryW(cFile);
}



//*****************************************************************************
//*
//*		FindPathFile
//*
//*****************************************************************************
//	Suche eine Datei unter Zuhilfename der PATH-Enviroment-Variable
//	pTarget		: Ist der Puffer in dem der Pfad abgelegt wird
//	pFilename	: Ist der Name der zu suchenden Datei
//	iMax		: Ist die Pufferegre in Zeichen
//	pSufixes	: Ist eine Liste mit Suffixes nachdenen gesucht werden soll.
//					z.B.  "exe;bat;bin"
//	iType		: Was soll gesucht werden (0=Datei 1=Verzeichnis)
//	Ergibt die Lnge des gespeicherten Namens in Zeichen.
int _cdecl FindPathFile(char *pTarget,const char *pFilename,int iMax,const char *pSufixes,int iType)
{
const char *pPtr;
char	   *pEnv;
char		cFile[MAX_PATH];
int			iEnd;
int			iSuf;
int			iLen;
int			iPos;
int			iAdd;
int			iNum;
int			iOff;


	if(iMax<=0)return 0;

	iMax   -= 1;
	iLen	= GetEnvironmentVariableA("PATH",cFile,0);
	pEnv	= new char[iLen+4];
	iLen	= GetEnvironmentVariableA("PATH",pEnv,iLen);
	iType	= (iType)? 2:1;

	pEnv[iLen  ] = ';';											// Den aktuellen Pfadeinfgen
	pEnv[iLen+1] = '.';
	pEnv[iLen+2] =  0 ;

	if(!pSufixes)pSufixes="";

	if(*pFilename=='\\' || *pFilename=='/')
		{
		pFilename++;
		}


	iNum = (int)strlen(pFilename);

	for(iEnd=iNum;iEnd>0;iEnd--)								// Suche die Sufixposition
		{
		if(pFilename[iEnd]=='.')break;
		}

	if(iEnd<=0)iEnd=iNum;


	for(iPos=0;iPos<iLen;iPos+=iAdd)							// Welcher Pfad passt
		{
		for(iAdd=0;pEnv[iPos+iAdd];iAdd++)
			{
			if(pEnv[iPos+iAdd]==';')break;
			}

		pEnv[iPos+iAdd]='\\';
		iAdd++;

		if(iAdd+iNum>=iMax)continue;

		memcpy(pTarget     ,pEnv+iPos,iAdd  );
		memcpy(pTarget+iAdd,pFilename,iNum+1);

		if(ExistFile(pTarget)==iType)
			{
			delete pEnv;
			return iAdd+iNum;
			}

		iOff = iAdd+iEnd;
		pPtr = pSufixes;

		for(;*pPtr;pPtr+=iSuf)									// Alle Sufixes Testen
			{
			for(iSuf=0;pPtr[iSuf];iSuf++)
				{
				if(pPtr[iSuf]==';')break;
				}

			if(iEnd>=iNum || stricmp(pPtr,pFilename+iEnd+1))
			if(iOff+iSuf+2<iMax)
				{
				memcpy(pTarget+iOff+1,pPtr,iSuf);
				pTarget[iOff+1+iSuf] =  0;
				pTarget[iOff       ] = '.';

				if(ExistFile(pTarget)==iType)
					{
					delete pEnv;
					return iOff+1+iSuf;
					}
				}

			if(*pPtr)iSuf++;
			}

		}


	pTarget[0] = 0;
	delete pEnv;


return 0;
}


int _cdecl	FindPathFile(wchar_t *pTarget,const wchar_t *pFilename,int iMax,const wchar_t *pSufixes,int iType)
{
const wchar_t  *pPtr;
wchar_t	       *pEnv;
wchar_t			cFile[MAX_PATH];
int				iEnd;
int				iSuf;
int				iLen;
int				iPos;
int				iAdd;
int				iNum;
int				iOff;


	if(iMax<=0)return 0;

	iMax   -= 1;
	iLen	= GetEnvironmentVariableW(L"PATH",cFile,0);
	pEnv	= new wchar_t[iLen+4];
	iLen	= GetEnvironmentVariableW(L"PATH",pEnv,iLen);
	iType	= (iType)? 2:1;

	pEnv[iLen  ] = ';';											// Den aktuellen Pfadeinfgen
	pEnv[iLen+1] = '.';
	pEnv[iLen+2] =  0 ;

	if(!pSufixes)pSufixes=L"";

	if(*pFilename=='\\' || *pFilename=='/')
		{
		pFilename++;
		}


	iNum = (int)wcslen(pFilename);

	for(iEnd=iNum;iEnd>0;iEnd--)								// Suche die Sufixposition
		{
		if(pFilename[iEnd]=='.')break;
		}

	if(iEnd<=0)iEnd=iNum;


	for(iPos=0;iPos<iLen;iPos+=iAdd)							// Welcher Pfad passt
		{
		for(iAdd=0;pEnv[iPos+iAdd];iAdd++)
			{
			if(pEnv[iPos+iAdd]==';')break;
			}

		pEnv[iPos+iAdd]='\\';
		iAdd++;

		if(iAdd+iNum>=iMax)continue;

		memcpy(pTarget     ,pEnv+iPos,iAdd*2  );
		memcpy(pTarget+iAdd,pFilename,iNum*2+2);

		if(ExistFile(pTarget)==iType)
			{
			delete pEnv;
			return iAdd+iNum;
			}

		iOff = iAdd+iEnd;
		pPtr = pSufixes;

		for(;*pPtr;pPtr+=iSuf)									// Alle Sufixes Testen
			{
			for(iSuf=0;pPtr[iSuf];iSuf++)
				{
				if(pPtr[iSuf]==';')break;
				}

			if(iEnd>=iNum || wcsicmp(pPtr,pFilename+iEnd+1))
			if(iOff+iSuf+2<iMax)
				{
				memcpy(pTarget+iOff+1,pPtr,iSuf*2);
				pTarget[iOff+1+iSuf] =  0;
				pTarget[iOff       ] = '.';

				if(ExistFile(pTarget)==iType)
					{
					delete pEnv;
					return iOff+1+iSuf;
					}
				}

			if(*pPtr)iSuf++;
			}

		}


	pTarget[0] = 0;
	delete pEnv;


return 0;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int _cdecl FindPathFile(CString &sTarget,const zchar *pFilename,const zchar *pSufixes,int iType)
{
int		iLen;
zchar  *pPtr;


	pPtr = sTarget.GetBuffer(MAX_PATH);
	iLen = FindPathFile(pPtr,pFilename,MAX_PATH,pSufixes,iType);
	       sTarget.ReleaseBuffer(iLen);


return iLen;
}

#endif

//*****************************************************************************
//*
//*		SetFileBody
//*
//*****************************************************************************
//	ndert den Rumpf eines Dateinamens (z.B. C:\Test.txt --> C:\Abc.txt )
//	iLen		: Ist die Lnges des Dateinamen in Zeichen.
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der neue
//				  Dateiname gespeichert wird.
//	pPath		: Ist der Dateinamen der gendert werden soll. Wenn dieser
//				  Parameter nicht angegeben ist, steht der Dateiname in pBuffer.
//	pBody		: Ist der neue Rumpf der eingefgt wird.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	iBodySize	: Ist die Lnge der Rumpfangabe in Zeichen.
//				  Bei -1 wird die Lnge mit strlen(...) ermittelt
//	Ergibt die neue Lnge des Dateinamens im Puffer.
int _cdecl SetFileBody(int iLen,char *pBuffer,const char *pPath,const char *pBody,int iMax,int iBodySize)
{
int		i,iNum,iEnd,iDiff;


	   iMax--;
	if(iMax<0)return 0;

	if(iBodySize<0)
		{
		iNum = (int)strlen(pBody);
		}
	else{
		iNum = iBodySize;
		}

	iEnd = -1;

	for(i=iLen;i>0;i--)									// Suche Pfadende
		{
		if(pPath[i]=='.' && iEnd<0)
			{
			iEnd=i;
			continue;
			}

		if(pPath[i]=='\\' || pPath[i]=='/' || pPath[i]==':')
			{
			i++;
			break;
			}
		}

	if(iEnd<0)iEnd=iLen;

	iDiff = iNum-(iEnd-i);

	if(iLen+iDiff>iMax)return iLen;						// Ist der Buffer zu klein ?

	if(pBuffer!=pPath)
	memmove(pBuffer       ,pPath,i);					// Dateipfad   kopieren
	memmove(pBuffer+i+iNum,pPath+iEnd,iLen-iEnd+1);		// Dateianhang kopieren
	memmove(pBuffer+i     ,pBody,iNum);					// Dateirumpf  kopieren


return iLen+iDiff;
}

int _cdecl SetFileBody(int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pBody,int iMax,int iBodySize)
{
int		i,iNum,iEnd,iDiff;


	   iMax--;
	if(iMax<0)return 0;

	if(iBodySize<0)
		{
		iNum = (int)wcslen(pBody);
		}
	else{
		iNum = iBodySize;
		}

	iEnd = -1;

	for(i=iLen;i>0;i--)									// Suche Pfadende
		{
		if(pPath[i]=='.' && iEnd<0)
			{
			iEnd=i;
			continue;
			}

		if(pPath[i]=='\\' || pPath[i]=='/' || pPath[i]==':')
			{
			i++;
			break;
			}
		}

	if(iEnd<0)iEnd=iLen;

	iDiff = iNum-(iEnd-i);

	if(iLen+iDiff>iMax)return iLen;						// Ist der Buffer zu klein ?

	if(pBuffer!=pPath)
	memmove(pBuffer       ,pPath     ,i            *sizeof(wchar_t));
	memmove(pBuffer+i+iNum,pPath+iEnd,(iLen-iEnd+1)*sizeof(wchar_t));
	memmove(pBuffer+i     ,pBody     ,iNum         *sizeof(wchar_t));


return iLen+iDiff;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

int	_cdecl	SetFileBody(CString &sTarget,const zchar *pBody,int iBodySize)
{
zchar  *pPtr;	
int		iLen;


	if(iBodySize<0)
		{
		iBodySize = (int)strzlen(pBody);
		}

	iLen = sTarget.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iBodySize+2);

	iLen = SetFileBody(iLen,pPtr,pPtr,pBody,iLen+iBodySize+2,iBodySize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl	SetFileBody(CString &sTarget,const zchar *pPath,const zchar *pBody,int iBodySize)
{
zchar  *pPtr;	
int		iLen;


	if(iBodySize<0)
		{
		iBodySize = (int)strzlen(pBody);
		}

	iLen = (int)strzlen(pPath);
	pPtr = sTarget.GetBuffer(iLen+iBodySize+2);

	iLen = SetFileBody(iLen,pPtr,pPath,pBody,iLen+iBodySize+2,iBodySize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl	SetFileBody(CString &sTarget,CString &sSource,const zchar *pBody,int iBodySize)
{
const zchar *pStr;
zchar       *pPtr;	
int			 iLen;


	if(iBodySize<0)
		{
		iBodySize = (int)strzlen(pBody);
		}

	iLen = sSource.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iBodySize+2);
	pStr = sSource;

	iLen = SetFileBody(iLen,pPtr,pStr,pBody,iLen+iBodySize+2,iBodySize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

#endif

//*****************************************************************************
//*
//*		SetFilePath
//*
//*****************************************************************************
//	ndert den Rumpf eines Dateinamens (z.B. C:\XX\Test.txt --> D:\A\Test.txt )
//	Ilen		: Ist die Lnge des Dateinamens
//	pBuffer		: Ist der Zeiger auf den Puffer in dem der neue
//				  Dateiname gespeichert wird.
//	pPath		: Ist der Dateinamen der gendert werden soll. Wenn dieser
//				  Parameter nicht angegeben ist, steht der Dateiname in pBuffer.
//	pName		: Ist der neue Pfatname der eingefgt wird.
//	iMax		: Ist die Gre des Puffers in Zeichen.
//	iNameSize	: Ist die Lnge des neuen Pfadnamens in Zeichen.
//				  Bei -1 wird die Lnge mit strlen(...) ermittelt
//	Ergibt die neue Lnge des Dateinamens im Puffer.
int _cdecl SetFilePath(int iLen,char *pBuffer,const char *pPath,const char *pName,int iMax,int iNameSize)
{
int		i,iAdd,iNum,iDiff;


	   iMax--;
	if(iMax<0)return 0;

	if(iNameSize<0)
		{
		iNum = (int)strlen(pName);
		}
	else{
		iNum = iNameSize;
		}

	if(iNum>0 && (pName[iNum-1]=='\\' || pName[iNum-1]=='/'))
		{
		iAdd = 0;
		}
	else{
		iAdd = 1;
		}


	for(i=iLen;i>=0;i--)								// Suche Pfadende
		{
		if(pPath[i]=='\\' || pPath[i]=='/' || pPath[i]==':')
			{
			i++;
			break;
			}
		}



	iDiff = iNum-i+iAdd;

	if(iLen+iDiff>iMax)return iLen;						// Ist der Buffer zu klein ?


	memmove(pBuffer+i+iDiff,pPath+i,iLen-i+1);			// Dateianamen kopieren
	memmove(pBuffer,pName,iNum);						// Dateipfad   kopieren

	if(iAdd)pBuffer[iNum]='\\';



return iLen+iDiff;
}

int _cdecl SetFilePath(int iLen,wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax,int iNameSize)
{
int		i,iAdd,iNum,iDiff;


	   iMax--;
	if(iMax<0)return 0;

	if(iNameSize<0)
		{
		iNum = (int)wcslen(pName);
		}
	else{
		iNum = iNameSize;
		}

	if(iNum>0 && (pName[iNum-1]=='\\' || pName[iNum-1]=='/'))
		{
		iAdd = 0;
		}
	else{
		iAdd = 1;
		}

	for(i=iLen;i>=0;i--)								// Suche Pfadende
		{
		if(pPath[i]=='\\' || pPath[i]=='/' || pPath[i]==':')
			{
			i++;
			break;
			}
		}




	iDiff = iNum-i+iAdd;

	if(iLen+iDiff>iMax)return iLen;						// Ist der Buffer zu klein ?


	memmove(pBuffer+i+iDiff,pPath+i,(iLen-i+1)*sizeof(wchar_t));
	memmove(pBuffer,pName          , iNum     *sizeof(wchar_t));

	if(iAdd)pBuffer[iNum]='\\';



return iLen+iDiff;
}

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)


int _cdecl SetFilePath(CString &sTarget,const zchar *pName,int iNameSize)
{
zchar  *pPtr;	
int		iLen;


	if(iNameSize<0)
		{
		iNameSize = (int)strzlen(pName);
		}
	
	iLen = sTarget.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iNameSize+2);

	iLen = SetFilePath(iLen,pPtr,pPtr,pName,iLen+iNameSize+2,iNameSize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl SetFilePath(CString &sTarget,const zchar *pPath,const zchar *pName,int iNameSize)
{
zchar  *pPtr;	
int		iLen;

	if(iNameSize<0)
		{
		iNameSize = (int)strzlen(pName);
		}
	
	iLen = (int)strzlen(pPath);
	pPtr = sTarget.GetBuffer(iLen+iNameSize+2);

	iLen = SetFilePath(iLen,pPtr,pPath,pName,iLen+iNameSize+2,iNameSize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

int _cdecl SetFilePath(CString &sTarget,CString &sSource,const zchar *pName,int iNameSize)
{
const zchar *pStr;
zchar       *pPtr;	
int			 iLen;


	if(iNameSize<0)
		{
		iNameSize = (int)strzlen(pName);
		}
	
	iLen = sSource.GetLength();
	pPtr = sTarget.GetBuffer(iLen+iNameSize+2);
	pStr = sSource;

	iLen = SetFilePath(iLen,pPtr,pStr,pName,iLen+iNameSize+2,iNameSize);

	sTarget.ReleaseBuffer(iLen);
	

return iLen;
}

#endif

//*****************************************************************************
//*
//*		CopyFileProgress
//*
//*****************************************************************************
//	Kopiert eine Datei mit Verlaufsstatistik
//	uFlags			: Diverse Einstellungen:
//						CFP_POS64		= Die Position ist ein 64-Bit-Wert
//						CFP_MAX64		= Der Maximalwert ist ein 64-Bit-Wert
//						CFP_POSADD		= Die Position wird zum Anfangswert addiert
//						CFP_FAILIFEXIST	= Nicht kopieren wenn die Zieldatei existiert
//						CFP_TEMPRENAME	= Zuerst in eine temporre Datei kopieren
//						CFP_COPYTIME	= Auch die Dateizeiten kopieren
//						CFP_READONLY	= Auch ReadOnly Dateien berschreiben
//						CFP_COPYATTRIB	= Attribute mit kopieren
//						CFP_CREATEPATH	= Zielpfad erzeugen falls er nicht existiert
//						CFP_DELETEPATH	= Bei Zielpfaderzeugung Dateien mit gleichen Namen wie Pfad lschen
//						CFP_MOVEFILE	= Wenn erfolgreich dann die Quelldatei lschen
//						CFP_FORCEMOVE	= Die Quelldatei auch lschen wenn sie schreibgeschtzt ist
//						CFP_ADDALWAYS	= Die Lnge auch bei Fehlern addieren
//	pExistingFile	: Ist den Name der zu kopierenden Datei.
//	pNewFileName	: Ist den Name der Zieldatei.
//	pCurrentPos		: Hier wird die aktuelle Position abgelegt.
//					  Bei Null wird nichts gespeichert.
//					  Die Wertgre kann in uFlags angegeben werden.
//					  Es ist auch mglich den Wert als Offset einzutragen.
//	pMaximalPos		: Hier wird die Dateigre abgelegt.
//					  Bei Null wird nichts gespeichert.
//					  Die Wertgre kann in uFlags angegeben werden.
//	pBreakPtr		: ber diesen Zeiger kann ein User-Abbruch ausgelst werden.
//	Ergibt 1 wenn die Datei kopiert wurde oder einen Fehlernummer:
//						-7 = Die Quelldatei konne nicht gelscht werden
//						-6 = Kann temporre Datei nicht umbenennen
//						-5 = Lesefehler
//						-4 = Schreibfehler
//						-3 = Quelldatei nicht gefunden
//						-2 = Zieldatei konnte nicht erzeugt werden
//						-1 = Zieldatei existiert bereits
//						 0 = User-Abbruch
//						 1 = Kopieren war erfolgreich.
int _cdecl CopyFileProgress(unsigned uFlags,const char *pExistingFile,const char *pNewFileName,void *pCurrentPos,void *pMaximalPos,const void *pBreakPtr)
{
char volatile      *pBreak=(char volatile   *)pBreakPtr;
unsigned	       *pPos32=(unsigned        *)pCurrentPos;
unsigned __int64   *pPos64=(unsigned __int64*)pCurrentPos;
unsigned __int64   	uLength;
unsigned char		aBuffer[4096];
char                aTempName[MAX_PATH];
const char         *pOpenName;
HANDLE				hSource;
HANDLE				hTarget;
DWORD				uWrite;
DWORD				uByte;
DWORD				uAttr;
INT					iRet;
INT					iLen;
BOOL				bOk;



	if(pCurrentPos && !(uFlags&CFP_POSADD))				// Den Verlaufswert 0 setzen
		{
		if(uFlags&CFP_POS64)
				*pPos64=0;
		else	*pPos32=0;
		}


	if(pMaximalPos || pCurrentPos)						// Datei Gre holen
		{
		   iLen = LengthFile(pExistingFile,&uLength);
		if(iLen==-1)
			{
			if(pMaximalPos)
				{
				if(uFlags&CFP_MAX64)
						*(__int64*)pMaximalPos = 0;
				else	*(DWORD  *)pMaximalPos = 0;
				}

			return -3;
			}

		if(pMaximalPos)									// Datei Gre speichern
			{
			if(uFlags&CFP_MAX64)
					*(__int64*)pMaximalPos =           uLength;
			else	*(DWORD  *)pMaximalPos = (unsigned)uLength;
			}
		}


	if(uFlags&CFP_FAILIFEXIST)							// Prfen ob die Zieldatei existiert
		{
		   uAttr = GetFileAttributesA(pNewFileName);
		if(uAttr!=0xFFFFFFFF)
			{
			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			if(uAttr&FILE_ATTRIBUTE_DIRECTORY)
				{
				SetLastError(ERROR_DIRECTORY);
				return -2;
				}

			SetLastError(ERROR_FILE_EXISTS);
			return -1;
			}
		}


	if(uFlags&CFP_MOVEFILE)								// Soll die Datei nur verschoben werden
		{
ReMove:													// Die Datei verschieben
		if(MoveFileExA(pExistingFile,pNewFileName,MOVEFILE_REPLACE_EXISTING))
			{
			if(pCurrentPos)								// Den Verlaufswert erhhen
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return 1;
			}

		if(GetLastError()==ERROR_ACCESS_DENIED)			// Ist die Zieldatei schreibgeschtzt
			{
			if((uFlags&CFP_READONLY) && SetFileAttributesA(pNewFileName,FILE_ATTRIBUTE_NORMAL))
				{
				uFlags &= ~CFP_READONLY;
				goto ReMove;
				}

			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return -2;
			}

		if(GetLastError()==ERROR_PATH_NOT_FOUND)		// Existiert der Zielpfad nicht
			{
			if(uFlags&CFP_CREATEPATH)
				{
				iRet = GetFilePath ((char*)aBuffer,pNewFileName,sizeof(aBuffer));
					   DelBackSlash((char*)aBuffer,iRet);

				if(uFlags&CFP_DELETEPATH)
					{
					RemoveFile((char*)aBuffer);
					}

				if(CreatePath((char*)aBuffer))			// Pfad erzeugen
					{
					uFlags &= ~CFP_CREATEPATH;
					goto ReMove;
					}

				SetLastError(ERROR_PATH_NOT_FOUND);
				}

			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return -2;
			}

		if(GetLastError()==ERROR_FILE_NOT_FOUND)		// Existiert der Quellpfad nicht
			{
			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return -3;
			}
		}

														// Quelldatei ffnen
	   hSource=CreateFileA(pExistingFile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hSource==INVALID_HANDLE_VALUE)
		{
		if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
			{
			if(uFlags&CFP_POS64)
					*pPos64+=(unsigned)uLength;
			else	*pPos32+=(unsigned)uLength;
			}

		return -3;
		}


	if(uFlags&CFP_TEMPRENAME)							// Zuerst eine temporre Datei erzeugen
		{
		aTempName[MAX_PATH-8] = 0;
		strncpy(aTempName,pNewFileName,MAX_PATH-8);
		strcat (aTempName,".cfp.tmp");
		pOpenName = aTempName;
		}
	else{
		pOpenName = pNewFileName;
		}


ReOpen:
														// Zieldatei ffnen
	   hTarget=CreateFileA(pOpenName,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hTarget==INVALID_HANDLE_VALUE)
		{
														// Auch schreibgeschtzte berschreiben
		if((uFlags&CFP_READONLY) && GetLastError()==ERROR_ACCESS_DENIED)
			{
			if(SetFileAttributesA(pOpenName,FILE_ATTRIBUTE_NORMAL))
				{
				uFlags &= ~CFP_READONLY;
				goto ReOpen;
				}
			}
														// Auch den Zielpfad erzeugen
		if((uFlags&CFP_CREATEPATH) && GetLastError()==ERROR_PATH_NOT_FOUND)
			{
			iLen = GetFilePath ((char*)aBuffer,pOpenName,sizeof(aBuffer));
				   DelBackSlash((char*)aBuffer,iLen);

			if(uFlags&CFP_DELETEPATH)
				{
				RemoveFile((char*)aBuffer);
				}

			if(CreatePath((char*)aBuffer))				// Pfad erzeugen
				{
				uFlags &= ~CFP_CREATEPATH;
				goto ReOpen;
				}

			SetLastError(ERROR_PATH_NOT_FOUND);
			}

		CloseHandle(hSource);

		if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
			{
			if(uFlags&CFP_POS64)
					*pPos64+=(unsigned)uLength;
			else	*pPos32+=(unsigned)uLength;
			}

		return -2;
		}


	for(;;)												// Kopierschleife
		{
		if(pBreak && *pBreak)
			{
			iRet = 0;
			break;
			}
														// Daten lesen
			bOk  = ReadFile(hSource,aBuffer,sizeof(aBuffer),&uByte,NULL);
		if(!bOk)
			{
			iRet = -5;
			break;
			}

		if(!uByte)										// Datei Ende erreicht
			{
			iRet = 1;
			break;
			}

		if(pBreak && *pBreak)
			{
			iRet = 0;
			break;
			}
														// Daten schreiben
			bOk  = WriteFile(hTarget,aBuffer,uByte,&uWrite,NULL);
		if(!bOk)
			{
			iRet = -4;
			break;
			}

		if(uByte!=uWrite)
			{
			iRet = -4;
			break;
			}

		if(pCurrentPos)									// Den Verlaufswert erhhen
			{
			if(uFlags&CFP_POS64)
					*pPos64+=uByte;
			else	*pPos32+=uByte;

			uLength -= uByte;
			}

		if(uByte<sizeof(aBuffer))						// Datei Ende erreicht
			{
			iRet = 1;
			break;
			}

		#if _DEBUG
		if(uFlags&CFP_DEBUGSLEEP)						// Verlauf fr Debug-Zwecke verlangsamen
			{
			Sleep(500);
			}

		#endif
		}


	if(iRet<=0)											// Bei Fehlern Zieldatei auf 0 krzen
		{
		SetFilePointer(hTarget,0,0,FILE_BEGIN);
		SetEndOfFile(hTarget);
		}


	CloseHandle(hTarget);
	CloseHandle(hSource);


	if(iRet<=0)											// Bei Fehlern Zieldatei lschen
		{
		DeleteFileA(pOpenName);
		}
	else if(uFlags&CFP_TEMPRENAME)						// Temporre Datei umbenennen
		{
ReTry:	if(!DeleteFileA(pNewFileName) && GetLastError()==ERROR_ACCESS_DENIED)
			{
			if(uFlags&CFP_READONLY)
				{
				SetFileAttributesA(pNewFileName,FILE_ATTRIBUTE_NORMAL);
				uFlags &= ~CFP_READONLY;
				goto ReTry;
				}

			DeleteFileA(pOpenName);
			SetLastError(ERROR_ACCESS_DENIED);
			iRet = -2;
			}
		else if(!MoveFileA(pOpenName,pNewFileName))
			{
			DeleteFileA(pOpenName);
			iRet = -6;
			}
		}


	if(iRet>0 && (uFlags&CFP_COPYTIME))					// Dateizeiten kopiern
		{
		CopyFileTime(pExistingFile,pNewFileName);
		}


	if(iRet>0 && (uFlags&CFP_COPYATTRIB))				// Dateiattribute kopiern
		{
		uAttr = GetFileAttributesA(pExistingFile);
				SetFileAttributesA(pNewFileName,uAttr);
		}


	if(iRet>0 && (uFlags&CFP_MOVEFILE))					// Wenn erfolgreich dann die Quelldatei lschen
		{
ReDel:	if(!DeleteFileA(pExistingFile))
			{
			if((uFlags&CFP_FORCEMOVE) && GetLastError()==ERROR_ACCESS_DENIED)
				{
				SetFileAttributesA(pExistingFile,FILE_ATTRIBUTE_NORMAL);
				uFlags &= ~CFP_FORCEMOVE;
				goto ReDel;
				}

			iRet = -7;
			}
		}
														// Nicht kopierte Bytes zu Verlauf addieren
	if(iRet<=0 && (uFlags&CFP_ADDALWAYS) && pCurrentPos && !(uLength>>63))
		{
		if(uFlags&CFP_POS64)
				*pPos64+=(unsigned)uLength;
		else	*pPos32+=(unsigned)uLength;
		}



return iRet;
}

int _cdecl CopyFileProgress(unsigned uFlags,const wchar_t *pExistingFile,const wchar_t *pNewFileName,void *pCurrentPos,void *pMaximalPos,const void *pBreakPtr)
{
char volatile      *pBreak=(char volatile   *)pBreakPtr;
unsigned	       *pPos32=(unsigned        *)pCurrentPos;
unsigned __int64   *pPos64=(unsigned __int64*)pCurrentPos;
unsigned __int64   	uLength;
unsigned char		aBuffer[4096];
wchar_t             aTempName[MAX_PATH];
const wchar_t      *pOpenName;
HANDLE				hSource;
HANDLE				hTarget;
DWORD				uWrite;
DWORD				uByte;
DWORD				uAttr;
INT					iRet;
INT					iLen;
BOOL				bOk;


	if(pCurrentPos && !(uFlags&CFP_POSADD))				// Den Verlaufswert 0 setzen
		{
		if(uFlags&CFP_POS64)
				*pPos64=0;
		else	*pPos32=0;
		}


	if(pMaximalPos || pCurrentPos)						// Datei Gre holen
		{
		   iLen = LengthFile(pExistingFile,&uLength);
		if(iLen==-1)
			{
			if(pMaximalPos)
				{
				if(uFlags&CFP_MAX64)
						*(__int64*)pMaximalPos = 0;
				else	*(DWORD  *)pMaximalPos = 0;
				}

			return -3;
			}

		if(pMaximalPos)									// Datei Gre speichern
			{
			if(uFlags&CFP_MAX64)
					*(__int64*)pMaximalPos =           uLength;
			else	*(DWORD  *)pMaximalPos = (unsigned)uLength;
			}
		}


	if(uFlags&CFP_FAILIFEXIST)							// Prfen ob die Zieldatei existiert
		{
		   uAttr = GetFileAttributesW(pNewFileName);
		if(uAttr!=0xFFFFFFFF)
			{
			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			if(uAttr&FILE_ATTRIBUTE_DIRECTORY)
				{
				SetLastError(ERROR_DIRECTORY);
				return -2;
				}

			SetLastError(ERROR_FILE_EXISTS);
			return -1;
			}
		}


	if(uFlags&CFP_MOVEFILE)								// Soll die Datei nur verschoben werden
		{
ReMove:													// Die Datei verschieben
		if(MoveFileExW(pExistingFile,pNewFileName,MOVEFILE_REPLACE_EXISTING))
			{
			if(pCurrentPos)								// Den Verlaufswert erhhen
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)iLen;
				else	*pPos32+=(unsigned)iLen;
				}

			return 1;
			}

		if(GetLastError()==ERROR_ACCESS_DENIED)			// Ist die Zieldatei schreibgeschtzt
			{
			if((uFlags&CFP_READONLY) && SetFileAttributesW(pNewFileName,FILE_ATTRIBUTE_NORMAL))
				{
				uFlags &= ~CFP_READONLY;
				goto ReMove;
				}

			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return -2;
			}

		if(GetLastError()==ERROR_PATH_NOT_FOUND)		// Existiert der Zielpfad nicht
			{
			if(uFlags&CFP_CREATEPATH)
				{
				iRet = GetFilePath ((wchar_t*)aBuffer,pNewFileName,sizeof(aBuffer));
					   DelBackSlash((wchar_t*)aBuffer,iRet);

				if(uFlags&CFP_DELETEPATH)
					{
					RemoveFile((wchar_t*)aBuffer);
					}

				if(CreatePath((wchar_t*)aBuffer))			// Pfad erzeugen
					{
					uFlags &= ~CFP_CREATEPATH;
					goto ReMove;
					}

				SetLastError(ERROR_PATH_NOT_FOUND);
				}

			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return -2;
			}

		if(GetLastError()==ERROR_FILE_NOT_FOUND)		// Existiert der Quellpfad nicht
			{
			if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
				{
				if(uFlags&CFP_POS64)
						*pPos64+=(unsigned)uLength;
				else	*pPos32+=(unsigned)uLength;
				}

			return -3;
			}
		}

														// Quelldatei ffnen
	   hSource=CreateFileW(pExistingFile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hSource==INVALID_HANDLE_VALUE)
		{
		if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
			{
			if(uFlags&CFP_POS64)
					*pPos64+=(unsigned)uLength;
			else	*pPos32+=(unsigned)uLength;
			}

		return -3;
		}


	if(uFlags&CFP_TEMPRENAME)							// Zuerst eine temporre Datei erzeugen
		{
		aTempName[MAX_PATH-8] = 0;
		wcsncpy(aTempName,pNewFileName,MAX_PATH-8);
		wcscat (aTempName,L".cfp.tmp");
		pOpenName = aTempName;
		}
	else{
		pOpenName = pNewFileName;
		}




ReOpen:
														// Zieldatei ffnen
	   hTarget=CreateFileW(pOpenName,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,0);
	if(hTarget==INVALID_HANDLE_VALUE)
		{
														// Auch schreibgeschtzte berschreiben
		if((uFlags&CFP_READONLY) && GetLastError()==ERROR_ACCESS_DENIED)
			{
			if(SetFileAttributesW(pOpenName,FILE_ATTRIBUTE_NORMAL))
				{
				uFlags &= ~CFP_READONLY;
				goto ReOpen;
				}
			}
														// Auch den Zielpfad erzeugen
		if((uFlags&CFP_CREATEPATH) && GetLastError()==ERROR_PATH_NOT_FOUND)
			{
			iLen = GetFilePath ((wchar_t*)aBuffer,pOpenName,sizeof(aBuffer)/2);
				   DelBackSlash((wchar_t*)aBuffer,iLen);

			if(uFlags&CFP_DELETEPATH)
				{
				RemoveFile((wchar_t*)aBuffer);
				}

			if(CreatePath((wchar_t*)aBuffer))			// Pfad erzeugen
				{
				uFlags &= ~CFP_CREATEPATH;
				goto ReOpen;
				}

			SetLastError(ERROR_PATH_NOT_FOUND);
			}


		CloseHandle(hSource);

		if((uFlags&CFP_ADDALWAYS) && pCurrentPos)
			{
			if(uFlags&CFP_POS64)
					*pPos64+=(unsigned)uLength;
			else	*pPos32+=(unsigned)uLength;
			}

		return -2;
		}


	for(;;)												// Kopierschleife
		{
		if(pBreak && *pBreak)
			{
			iRet = 0;
			break;
			}
														// Daten lesen
			bOk  = ReadFile(hSource,aBuffer,sizeof(aBuffer),&uByte,NULL);
		if(!bOk)
			{
			iRet = -5;
			break;
			}

		if(!uByte)										// Datei Ende erreicht
			{
			iRet = 1;
			break;
			}

		if(pBreak && *pBreak)
			{
			iRet = 0;
			break;
			}
														// Daten schreiben
			bOk  = WriteFile(hTarget,aBuffer,uByte,&uWrite,NULL);
		if(!bOk)
			{
			iRet = -4;
			break;
			}

		if(uByte!=uWrite)
			{
			iRet = -4;
			break;
			}

		if(pCurrentPos)									// Den Verlaufswert erhhen
			{
			if(uFlags&CFP_POS64)
					*pPos64+=uByte;
			else	*pPos32+=uByte;

			uLength -= uByte;
			}

		if(uByte<sizeof(aBuffer))						// Datei Ende erreicht
			{
			iRet = 1;
			break;
			}

		#if _DEBUG
		if(uFlags&CFP_DEBUGSLEEP)						// Verlauf fr Debug-Zwecke verlangsamen
			{
			Sleep(500);
			}
		#endif
		}


	if(iRet<=0)											// Bei Fehlern Zieldatei auf 0 krzen
		{
		SetFilePointer(hTarget,0,0,FILE_BEGIN);
		SetEndOfFile(hTarget);
		}


	CloseHandle(hTarget);
	CloseHandle(hSource);


	if(iRet<=0)											// Bei Fehlern Zieldatei lschen
		{
		DeleteFileW(pOpenName);
		}
	else if(uFlags&CFP_TEMPRENAME)						// Temporre Datei umbenennen
		{
ReTry:	if(!DeleteFileW(pNewFileName) && GetLastError()==ERROR_ACCESS_DENIED)
			{
			if(uFlags&CFP_READONLY)
				{
				SetFileAttributesW(pNewFileName,FILE_ATTRIBUTE_NORMAL);
				uFlags &= ~CFP_READONLY;
				goto ReTry;
				}

			DeleteFileW(pOpenName);
			SetLastError(ERROR_ACCESS_DENIED);
			iRet = -2;
			}
		else if(!MoveFileW(pOpenName,pNewFileName))
			{
			DeleteFileW(pOpenName);
			iRet = -6;
			}
		}


	if(iRet>0 && (uFlags&CFP_COPYTIME))					// Dateizeiten kopiern
		{
		CopyFileTime(pExistingFile,pNewFileName);
		}


	if(iRet>0 && (uFlags&CFP_COPYATTRIB))				// Dateiattribute kopiern
		{
		uAttr = GetFileAttributesW(pExistingFile);
				SetFileAttributesW(pNewFileName,uAttr);
		}


	if(iRet>0 && (uFlags&CFP_MOVEFILE))					// Wenn erfolgreich dann die Quelldatei lschen
		{
ReDel:	if(!DeleteFileW(pExistingFile))
			{
			if((uFlags&CFP_FORCEMOVE) && GetLastError()==ERROR_ACCESS_DENIED)
				{
				SetFileAttributesW(pExistingFile,FILE_ATTRIBUTE_NORMAL);
				uFlags &= ~CFP_FORCEMOVE;
				goto ReDel;
				}

			iRet = -7;
			}
		}

	if(iRet<=0 && (uFlags&CFP_ADDALWAYS) && pCurrentPos && !(uLength>>63))
		{
		if(uFlags&CFP_POS64)
				*pPos64+=(unsigned)uLength;
		else	*pPos32+=(unsigned)uLength;
		}


return iRet;
}

//*****************************************************************************
//*
//*		ChainFile
//*
//*****************************************************************************
//	Erzeugt eine Kette aus durchnummerierten Dateien. Bei jedem Aufruf werden
//	alle vorhanden Dateinamen je nach dem Format um eins erhht bis eine Lcke
//	gefunden wird. (aus  "Hallo00" wird "Hallo01" usw. )
//	pSource		: Ist die aktuelle Datei die zur ersten Datei mit der
//				  Nummer 0 in der Kette werden soll.
//	pFormat		: Ist das Format fr die Dateinamen.
//				  '*'	am Anfang steht fr den Dateinamen aus pPath/pSource
//				  '?'	am Anfang steht fr den Datei-Body aus pPath/pSource
//				  '#X#' steht fr die Zahl (X=1..4) iPos muss -1 sein
//				  '$X'  steht fr X Suffixe vom Namensende entfernen
//				  Ist kein Pfad angegeben so wird der aus pPath/pSource benutzt.
//				  z.B.  "D:\Temp\*.#2#.tmp"	--> "D:\Temp\Body.xxx.00.tmp"
//						"D:\Temp\?.#2#.tmp"	--> "D:\Temp\Body.00.tmp"
//						"Hallo_#2#_xxx.tmp"	--> "Hallo_00_xxx.tmp"
//						"?.tmp"				--> "Body.0.tmp"
//						"*.tmp"				--> "Body.xxx.0.tmp"
//						".tmp"				--> "Body.xxx.0.tmp"
//	iMode		: Wie soll die Datei umkopiert werden.
//						Bit0 = (0=verschieben 1=kopieren)
//						Bit1 = (0=immer 1=nur wenn erste nicht existiert)
//						Bit2 = (1=keinen Nummern fr ReplaceFile(...))
//	iMax		: Ist die hchste Nummer fr die Kette. (0=automatisch)
//	iPos		: Position der Zahl in der Formatangabe.
//				  Der Wert -1 steht fr automatisch aus der Angabe holen.
//	pPath		: Ist der Pfad aus den die Dateidatein geholt werden.
//				  Wenn dieser Zieger 0 ist wird pSource benutzt.
//	iDelta		: Ist die Breite der Angabe falls iPos>=0 ist.
//	Ergibt 1 wenn alles ok war, ansonsten 0 bei einem Fehler.
int _cdecl ChainFile(const char *pSource,const char *pFormat,int iMode,int iMax,int iPos,int iDelta,const char *pPath)
{
char		cBuffer[MAX_PATH+16];
char		cPathTo[MAX_PATH+16];
int			iSize;
int			iOff;
int			iNum;
int			iEnd;
int			iLen;
int			i;


	if(iDelta<1 || iDelta>4 || iMax<0)return 0;
	   iLen = (int)strlen(pFormat);
	if(iLen>MAX_PATH)return 0;
	if(pPath==NULL)pPath=pSource;

	iEnd = iDelta;

	if(iPos<0)									// Suche Zahlenformat
		{
		for(iOff=iLen;iOff>=0;iOff--)
			{
			if(pFormat[iOff  ] == ':')break;
			if(pFormat[iOff  ] == '/')break;
			if(pFormat[iOff  ] =='\\')break;
			if(pFormat[iOff  ] == '#')
			if(pFormat[iOff+1] >= '1')
			if(pFormat[iOff+1] <= '4')
			if(pFormat[iOff+2] == '#')
				{
				iDelta = pFormat[iOff+1]-'0';
				iPos   = iOff;
				iEnd   = 3;
				}
			}
		}
	else{										// Suche Dateinamen
		for(iOff=iLen;iOff>=0;iOff--)
			{
			if(pFormat[iOff] == ':')break;
			if(pFormat[iOff] == '/')break;
			if(pFormat[iOff] =='\\')break;
			}
		}


	if(iOff<0)									// Pfad aus Quelle holen
		{
		iSize = GetFilePath(cBuffer,pPath,MAX_PATH);
		}
	else{										// Es gibt einen Pfad im Format
		iSize    = iOff+1;
		memcpy(cBuffer,pFormat,iSize);
		pFormat += iSize;
		iLen    -= iSize;
		iPos    -= iSize;
		}
												// Dateinamen aus Pfad holen
	if(*pFormat=='*' || (iPos<0 && *pFormat!='?'))
		{
		   iSize += GetFileName(cBuffer+iSize,pPath,MAX_PATH+8-iSize);
		if(iSize>MAX_PATH)return 0;
		if(*pFormat=='*')
			{
			pFormat++;
			iLen--;
			iOff--;
			iPos--;
			}
		}
	else if(*pFormat=='?')						// Datei-Body aus Pfad holen
		{
		   iSize += GetFileBody(cBuffer+iSize,pPath,MAX_PATH+8-iSize);
		if(iSize>MAX_PATH)return 0;
		pFormat++;
		iLen--;
		iOff--;
		iPos--;
		}
												// Suffixe entfernen
	if(*pFormat=='$' && pFormat[1]<='9' && pFormat[1]>='1')
		{
		iNum	 = pFormat[1]-'0';
		pFormat += 2;
		iLen    -= 2;
		iOff    -= 2;
		iPos    -= 2;

		while(iNum>0 && iSize>0)
			{
			iSize--;

			if(cBuffer[iSize]=='.' ){iNum--;continue;}
			if(cBuffer[iSize]=='\\')break;
			if(cBuffer[iSize]=='/' )break;
			}
		}

	if(iSize+iLen>MAX_PATH+8)
		{
		return 0;
		}

	if(iPos>=0)									// Nummernformat vorhanden
		{
		memcpy(cBuffer+iSize,pFormat,iPos);
		iSize   += iPos;
		pFormat += iPos+iEnd;
		iLen    -= iPos+iEnd;
		iPos	 = iSize;
		iEnd     = iSize+iDelta-1;

		for(i=0;i<iDelta;i++)					// Zahl mit '0' fllen
			{
			cBuffer[iSize] = '0';
			iSize++;
			}
		}
	else if(!(iMode&4))							// Einzahlige Nummerierung einfgen
		{
		cBuffer[iSize] = '.';iSize++;
		iPos  = iSize;
		iEnd  = iSize;
		cBuffer[iSize] = '0';iSize++;
		iDelta = 1;
		}
	else{										// Keine Zahlen (speziel fr ReplaceFile(...))
		iPos   = iSize;
		iEnd   = iSize;
		iDelta = 0;
		}

	memcpy(cBuffer+iSize,pFormat,iLen+1);
	iSize+= iLen+1;

	iNum = 1;

	for(i=iDelta;i>0;i--)						// Hchste Nummer prfen
		{
		iNum*=10;
		}

	if(iMax==0)
		{
		iMax = iNum;
		}
	else if(iMax>iNum)
		{
		iMax = iNum;
		}

	iNum  = 0;
	iMax -= 1;



	for(iNum=0;;iNum++)							// Suche Lcke
		{
		if(!ExistFile(cBuffer))break;

		if(iNum==0 && (iMode&2))				// Nicht umkopieren wenn die erste existiert
			{
			return 0;
			}

		if(iNum>=iMax)							// Keine Lcke gefunden
			{
			if(!RemoveFile(cBuffer))return 0;
			break;
			}

		for(i=0;i<iDelta;i++)					// Nchste Nummer
			{
			   cBuffer[iEnd-i]++;
			if(cBuffer[iEnd-i]<='9')break;
			   cBuffer[iEnd-i] ='0';
			}
		}


	memcpy(cPathTo,cBuffer,iSize);				// Neuen Namen erzeugen


	for(;iNum>0;iNum--)							// Kette umbenennen
		{
		for(i=0;i<iDelta;i++)					// Vorherige Nummer
			{
			   cBuffer[iEnd-i]--;
			if(cBuffer[iEnd-i]>='0')break;
			   cBuffer[iEnd-i] ='9';
			}

		if(!MoveFileA(cBuffer,cPathTo))return 0;

		memcpy(cPathTo+iPos,cBuffer+iPos,iDelta);
		}

	if(iMode&1)									// Original kopieren
		{
		if(!CopyFileA(pSource,cBuffer,TRUE))return 0;
		}
	else{										// Original verschieben
		if(!MoveFileA(pSource,cBuffer))return 0;
		}


return 1;
}

int _cdecl ChainFile(const wchar_t *pSource,const wchar_t *pFormat,int iMode,int iMax,int iPos,int iDelta,const wchar_t *pPath)
{
wchar_t			cBuffer[MAX_PATH+16];
wchar_t			cPathTo[MAX_PATH+16];
int				iSize;
int				iOff;
int				iNum;
int				iEnd;
int				iLen;
int				i;


	if(iDelta<1 || iDelta>4 || iMax<0)return 0;
	   iLen = (int)wcslen(pFormat);
	if(iLen>MAX_PATH)return 0;
	if(pPath==NULL)pPath=pSource;

	iEnd = iDelta;

	if(iPos<0)									// Suche Zahlenformat
		{
		for(iOff=iLen;iOff>=0;iOff--)
			{
			if(pFormat[iOff  ] == ':')break;
			if(pFormat[iOff  ] == '/')break;
			if(pFormat[iOff  ] =='\\')break;
			if(pFormat[iOff  ] == '#')
			if(pFormat[iOff+1] >= '1')
			if(pFormat[iOff+1] <= '4')
			if(pFormat[iOff+2] == '#')
				{
				iDelta = pFormat[iOff+1]-'0';
				iPos   = iOff;
				iEnd   = 3;
				}
			}
		}
	else{										// Suche Dateinamen
		for(iOff=iLen;iOff>=0;iOff--)
			{
			if(pFormat[iOff] == ':')break;
			if(pFormat[iOff] == '/')break;
			if(pFormat[iOff] =='\\')break;
			}
		}


	if(iOff<0)									// Pfad aus Quelle holen
		{
		iSize = GetFilePath(cBuffer,pPath,MAX_PATH);
		}
	else{										// Es gibt einen Pfad  im Format
		iSize    = iOff+1;
		memcpy(cBuffer,pFormat,iSize*sizeof(cBuffer[0]));
		pFormat += iSize;
		iLen    -= iSize;
		iPos    -= iSize;
		}
												// Dateinamen aus Pfad holen
	if(*pFormat=='*' || (iPos<0 && *pFormat!='?'))
		{
		   iSize += GetFileName(cBuffer+iSize,pPath,MAX_PATH+8-iSize);
		if(iSize>MAX_PATH)return 0;
		if(*pFormat=='*')
			{
			pFormat++;
			iLen--;
			iOff--;
			iPos--;
			}
		}
	else if(*pFormat=='?')						// Datei-Body aus Pfad holen
		{
		   iSize += GetFileBody(cBuffer+iSize,pPath,MAX_PATH+8-iSize);
		if(iSize>MAX_PATH)return 0;
		pFormat++;
		iLen--;
		iOff--;
		iPos--;
		}

												// Suffixe entfernen
	if(*pFormat=='$' && pFormat[1]<='9' && pFormat[1]>='1')
		{
		iNum	 = pFormat[1]-'0';
		pFormat += 2;
		iLen    -= 2;
		iOff    -= 2;
		iPos    -= 2;

		while(iNum>0 && iSize>0)
			{
			iSize--;

			if(cBuffer[iSize]=='.' ){iNum--;continue;}
			if(cBuffer[iSize]=='\\')break;
			if(cBuffer[iSize]=='/' )break;
			}
		}

	if(iSize+iLen>MAX_PATH+8)
		{
		return 0;
		}

	if(iPos>=0)									// Nummernformat vorhanden
		{
		memcpy(cBuffer+iSize,pFormat,iPos*sizeof(cBuffer[0]));
		iSize   += iPos;
		pFormat += iPos+iEnd;
		iLen    -= iPos+iEnd;
		iPos	 = iSize;
		iEnd     = iSize+iDelta-1;

		for(i=0;i<iDelta;i++)					// Zahl mit '0' fllen
			{
			cBuffer[iSize] = '0';
			iSize++;
			}
		}
	else if(!(iMode&4))							// Einzahlige Nummerierung einfgen
		{
		cBuffer[iSize] = '.';iSize++;
		iPos  = iSize;
		iEnd  = iSize;
		cBuffer[iSize] = '0';iSize++;
		iDelta = 1;
		}
	else{										// Keine Zahlen (speziel fr ReplaceFile(...))
		iPos   = iSize;
		iEnd   = iSize;
		iDelta = 0;
		}

	memcpy(cBuffer+iSize,pFormat,(iLen+1)*sizeof(cBuffer[0]));
	iSize+= iLen+1;

	iNum = 1;

	for(i=iDelta;i>0;i--)						// Hchste Nummer prfen
		{
		iNum*=10;
		}

	if(iMax==0)
		{
		iMax = iNum;
		}
	else if(iMax>iNum)
		{
		iMax = iNum;
		}

	iNum  = 0;
	iMax -= 1;

	for(iNum=0;;iNum++)							// Suche Lcke
		{
		if(!ExistFile(cBuffer))break;

		if(iNum==0 && (iMode&2))				// Nicht umkopieren wenn die erste existiert
			{
			return 0;
			}

		if(iNum>=iMax)							// Keine Lcke gefunden
			{
			if(!RemoveFile(cBuffer))return 0;
			break;
			}

		for(i=0;i<iDelta;i++)					// Nchste Nummer
			{
			   cBuffer[iEnd-i]++;
			if(cBuffer[iEnd-i]<='9')break;
			   cBuffer[iEnd-i] ='0';
			}
		}

												// Neuen Namen erzeugen
	memcpy(cPathTo,cBuffer,iSize*sizeof(cPathTo[0]));


	for(;iNum>0;iNum--)							// Kette umbenennen
		{
		for(i=0;i<iDelta;i++)					// Vorherige Nummer
			{
			   cBuffer[iEnd-i]--;
			if(cBuffer[iEnd-i]>='0')break;
			   cBuffer[iEnd-i] ='9';
			}

		if(!MoveFileW(cBuffer,cPathTo))return 0;

		memcpy(cPathTo+iPos,cBuffer+iPos,iDelta*sizeof(cPathTo[0]));
		}

	if(iMode&1)									// Original kopieren
		{
		if(!CopyFileW(pSource,cBuffer,TRUE))return 0;
		}
	else{										// Original verschieben
		if(!MoveFileW(pSource,cBuffer))return 0;
		}


return 1;
}

//*****************************************************************************
//*
//*		ReplaceFile
//*
//*****************************************************************************
//	Tauscht eine Datei gegen eine andere aus. Die alte Datei wird dabei
//	gelscht oder es wird eine Sicherheitskopie von ihr erzeugt.
//	Falls etwas fehlschlgt wird die alte Datei wieder hergestellt.
//	pSource		 : Ist die aktuelle Datei die neuen werden soll.
//	pTarget		 : Ist die Zieldatei die ersetzt werden soll.
//				   Bei "*.xxx" wir die Zieldatei aus pSource erstellt.
//				   (z.B.: "D:\Test.tmp" + "*.txt" --> "D:\Test.txt")
//	iFlags		 : Diverse Flags fr's Kopieren.
//						Bit0 = Quelle lschen bei Fehlern
//						Bit1 = Die Zieldatei muss nicht existieren
//						Bit2 = Schreibgeschtzte Dateien nicht lschen.
//						Bit3 = Die alte Datei auch in die neue umbenennen
//	pBackup		 : Ist das Format fr die Sicherheitskopie. (NULL=Keine)
//				   z.B. "D:\Temp\*.#2#.tmp"	--> "D:\Temp\Body.xxx.00.tmp"
//						"D:\Temp\?.#2#.tmp"	--> "D:\Temp\Body.00.tmp"
//						"Hallo_#2#_xxx.tmp"	--> "Hallo_00_xxx.tmp"
//						"?.tmp"				--> "Body.0.tmp"
//						"*.tmp"				--> "Body.xxx.0.tmp"
//						".tmp"				--> "Body.xxx.0.tmp"
//	iForceBackup : Bestimmt wie die Sicherheitskopie erstellt werden soll.
//						0    = vorhandene nie berschreiben
//						1    = nur eine Sicherheitskopie erstellen
//						2..n = bis zu N Sicherheitskopien erstellen
//	Ergibt 1 wenn alles ok war, ansonsten 0 bei einem Fehler.
int _cdecl ReplaceFile(const char *pSource,const char *pTarget,int iFlags,const char *pBackup,int iForceBackup)
{
char		cBuffer[MAX_PATH+8];
char		cTarget[MAX_PATH+8];
int			iBits;
int			iLen;



	if(pTarget[0]=='*')									// Target aus Quelle erstellen
		{
		   iLen = (int)strlen(pSource)+1;
		if(iLen>=MAX_PATH)return 0;

		memcpy(cTarget,pSource,iLen);
	    iLen    = SetFileType(cTarget,pTarget,MAX_PATH+8);
		pTarget = cTarget;
		}
	else{
		iLen = (int)strlen(pTarget);
		}

	if(iLen>MAX_PATH)return 0;




	memcpy(cBuffer,pTarget,iLen);
	memcpy(cBuffer+iLen,".rf.tmp",8);
	RemoveFile(cBuffer);

	if(!MoveFileA(pTarget,cBuffer))						// Alte Datei sichern
		{
		if(!(iFlags&2) || ExistFile(pTarget))
			{
			if(iFlags&1)
				{
				if(iFlags&4)
						DeleteFileA(pSource);
				else	RemoveFile (pSource);
				}

			return 0;
			}
		}

	if(!MoveFileA(pSource,pTarget))						// Quelle umkopieren
		{
		MoveFileA(cBuffer,pTarget);

		if(iFlags&1)
			{
			if(iFlags&4)
					DeleteFileA(pSource);
			else	RemoveFile (pSource);
			}

		return 0;
		}

	if(iFlags&8)										// Die alte Datei auch in die neue umbenennen
		{
		if(MoveFileA(cBuffer,pSource))return 1;
		MoveFileA(pTarget,pSource);
		MoveFileA(cBuffer,pTarget);
		return 0;
		}

	if(!pBackup)
		{
		DeleteFileA(cBuffer);
		}
	else{												// Sicherheitskopie erstellen
		     if(iForceBackup<=0){iBits=6;iForceBackup=1;}
		else if(iForceBackup==1){iBits=4;iForceBackup=1;}
		else 					{iBits=0;}

		ChainFile(cBuffer,pBackup,iBits,iForceBackup,-1,1,pTarget);
		}



return 1;
}

int _cdecl ReplaceFile(const wchar_t *pSource,const wchar_t *pTarget,int iFlags,const wchar_t *pBackup,int iForceBackup)
{
wchar_t		cBuffer[MAX_PATH+8];
wchar_t		cTarget[MAX_PATH+8];
int			iBits;
int			iLen;



	if(pTarget[0]=='*')									// Target aus Quelle erstellen
		{
		   iLen = (int)wcslen(pSource)+1;
		if(iLen>=MAX_PATH)return 0;

		memcpy(cTarget,pSource,iLen*sizeof(wchar_t));
	    iLen    = SetFileType(cTarget,pTarget,MAX_PATH+8);
		pTarget = cTarget;
		}
	else{
		iLen = (int)wcslen(pTarget);
		}

	if(iLen>MAX_PATH)return 0;

	memcpy(cBuffer,pTarget,iLen);
	memcpy(cBuffer+iLen,L".rf.tmp",8*sizeof(wchar_t));
	RemoveFile(cBuffer);

	if(!MoveFileW(pTarget,cBuffer))						// Alte Datei sichern
		{
		if(!(iFlags&2) || ExistFile(pTarget))
			{
			if(iFlags&1)
				{
				if(iFlags&4)
						DeleteFileW(pSource);
				else	RemoveFile (pSource);
				}

			return 0;
			}
		}

	if(!MoveFileW(pSource,pTarget))						// Quelle umkopieren
		{
		MoveFileW(cBuffer,pTarget);

		if(iFlags&1)
			{
			if(iFlags&4)
					DeleteFileW(pSource);
			else	RemoveFile (pSource);
			}

		return 0;
		}

	if(iFlags&8)										// Die alte Datei auch in die neue umbenennen
		{
		if(MoveFileW(cBuffer,pSource))return 1;
		MoveFileW(pTarget,pSource);
		MoveFileW(cBuffer,pTarget);
		return 0;
		}

	if(!pBackup)
		{
		DeleteFileW(cBuffer);
		}
	else{												// Sicherheitskopie erstellen
		     if(iForceBackup<=0){iBits=6;iForceBackup=1;}
		else if(iForceBackup==1){iBits=4;iForceBackup=1;}
		else 					{iBits=0;}

		ChainFile(cBuffer,pBackup,iBits,iForceBackup,-1,1,pTarget);
		}



return 1;
}

//*****************************************************************************
//*
//*		FileTime
//*
//*****************************************************************************
//	Holt die UTC-Zeit zu einer Datei
//	pFilename	: Ist der Dateiname
//	iMode		: Welche Zeit soll gehlolt werden (0=Write 1=Create 2=Modify)
//	Ergibt die UTC-Zeit oder 0 bei einem Fehler
unsigned _cdecl FileTime(const char *pFilename,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;
FILETIME				   *pFrom;
unsigned					uTime;


												// Datei Infos holen
	if(!GetFileAttributesExA(pFilename,GetFileExInfoStandard,&sFind))
		{
		return 0;
		}

	switch(iMode)
		{
	case 0:	pFrom = &sFind.ftLastWriteTime;		break;
	case 1:	pFrom = &sFind.ftCreationTime;		break;
	case 2:	pFrom = &sFind.ftLastAccessTime;	break;
	default:	return 0;
		}

	if(!FileTimeToUtcTime(pFrom,&uTime))
		{
		return 0;
		}


return uTime;									// Unix Zeit zurck geben
}

unsigned _cdecl FileTime(const wchar_t *pFilename,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind;
FILETIME				   *pFrom;
unsigned					uTime;


												// Datei Infos holen
	if(!GetFileAttributesExW(pFilename,GetFileExInfoStandard,&sFind))
		{
		return 0;
		}

	switch(iMode)
		{
	case 0:	pFrom = &sFind.ftLastWriteTime;		break;
	case 1:	pFrom = &sFind.ftCreationTime;		break;
	case 2:	pFrom = &sFind.ftLastAccessTime;	break;
	default:	return 0;
		}

	if(!FileTimeToUtcTime(pFrom,&uTime))
		{
		return 0;
		}


return uTime;									// Unix Zeit zurck geben
}

//*****************************************************************************
//*
//*		CmpFileData
//*
//*****************************************************************************
//	Vergleicht zwei Dateien
//	pFile1		: Name der ersten Datei
//	pFile2		: Name der zweiten Datei
//	Ergibt 1 wenn die Dateien gleich sind, bzw. 0 wenn nicht.
int _cdecl CmpFileData(const char *pFile1,const char *pFile2)
{
BYTE		aBuffer1[4096];
BYTE		aBuffer2[4096];
HANDLE		hHandle1;
HANDLE		hHandle2;
DWORD		dwSizeL;
DWORD		dwSizeH;
__int64		iSize1;
__int64		iSize2;
int			iRet;



	   hHandle1 = CreateFileA(pFile1,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hHandle1==INVALID_HANDLE_VALUE)
		{
		return 0;
		}

	   hHandle2 = CreateFileA(pFile2,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hHandle2==INVALID_HANDLE_VALUE)
		{
		CloseHandle(hHandle1);
		return 0;
		}

	dwSizeL  = GetFileSize(hHandle1,&dwSizeH);
	iSize1   = dwSizeH;
	iSize1 <<= 32;
	iSize1  |= dwSizeL;

	dwSizeL  = GetFileSize(hHandle2,&dwSizeH);
	iSize2   = dwSizeH;
	iSize2 <<= 32;
	iSize2  |= dwSizeL;

	if(iSize1!=iSize2)									// Sind die Dateigren gleich
		{
		CloseHandle(hHandle1);
		CloseHandle(hHandle2);
		return 0;
		}


	iRet = 0;

	for(;;)												// Vergleiche die Dateien
		{
		if(!ReadFile(hHandle1,aBuffer1,sizeof(aBuffer1),&dwSizeL,NULL))
			{
			break;
			}

		if(!ReadFile(hHandle2,aBuffer2,sizeof(aBuffer2),&dwSizeH,NULL))
			{
			break;
			}

		if(dwSizeH!=dwSizeL)break;
		if(memcmp(aBuffer1,aBuffer2,dwSizeL))break;

		if(dwSizeL<sizeof(aBuffer1))
			{
			iRet = 1;
			break;
			}
		}


	CloseHandle(hHandle1);
	CloseHandle(hHandle2);


return iRet;
}

int _cdecl CmpFileData(const wchar_t *pFile1,const wchar_t *pFile2)
{
BYTE		aBuffer1[4096];
BYTE		aBuffer2[4096];
HANDLE		hHandle1;
HANDLE		hHandle2;
DWORD		dwSizeL;
DWORD		dwSizeH;
__int64		iSize1;
__int64		iSize2;
int			iRet;



	   hHandle1 = CreateFileW(pFile1,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hHandle1==INVALID_HANDLE_VALUE)
		{
		return 0;
		}

	   hHandle2 = CreateFileW(pFile2,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hHandle2==INVALID_HANDLE_VALUE)
		{
		CloseHandle(hHandle1);
		return 0;
		}

	dwSizeL  = GetFileSize(hHandle1,&dwSizeH);
	iSize1   = dwSizeH;
	iSize1 <<= 32;
	iSize1  |= dwSizeL;

	dwSizeL  = GetFileSize(hHandle2,&dwSizeH);
	iSize2   = dwSizeH;
	iSize2 <<= 32;
	iSize2  |= dwSizeL;

	if(iSize1!=iSize2)									// Sind die Dateigren gleich
		{
		CloseHandle(hHandle1);
		CloseHandle(hHandle2);
		return 0;
		}


	iRet = 0;

	for(;;)												// Vergleiche die Dateien
		{
		if(!ReadFile(hHandle1,aBuffer1,sizeof(aBuffer1),&dwSizeL,NULL))
			{
			break;
			}

		if(!ReadFile(hHandle2,aBuffer2,sizeof(aBuffer2),&dwSizeH,NULL))
			{
			break;
			}

		if(dwSizeH!=dwSizeL)break;
		if(memcmp(aBuffer1,aBuffer2,dwSizeL))break;

		if(dwSizeL<sizeof(aBuffer1))
			{
			iRet = 1;
			break;
			}
		}


	CloseHandle(hHandle1);
	CloseHandle(hHandle2);


return iRet;
}

//*****************************************************************************
//*
//*		ChangeFile
//*
//*****************************************************************************
//	ndert Daten in einer Datei. Dabei kann eine Sicherheitskopie erstellt werden.
//	pPath		: Ist der Dateiname
//	iPos		: Ist die die Position der Daten
//	iByte		: Ist die die Lnge der der Daten in der Datei in Byte
//	pPtr		: Zeiger auf die neuen Daten
//	iSize		: Ist die Lnge der neuen Daten in Byte
//	pBackup		 : Ist das Format fr die Sicherheitskopie. (NULL=Keine)
//				   z.B. "D:\Temp\*.#2#.tmp"	--> "D:\Temp\Body.xxx.00.tmp"
//						"D:\Temp\?.#2#.tmp"	--> "D:\Temp\Body.00.tmp"
//						"Hallo_#2#_xxx.tmp"	--> "Hallo_00_xxx.tmp"
//						"?.tmp"				--> "Body.0.tmp"
//						"*.tmp"				--> "Body.xxx.0.tmp"
//						".tmp"				--> "Body.xxx.0.tmp"
//	iForceBackup : Bestimmt wie die Sicherheitskopie erstellt werden soll.
//						0    = vorhandene nie berschreiben
//						1    = nur eine Sicherheitskopie erstellen
//						2..n = bis zu N Sicherheitskopien erstellen
//	Ergibt 1 wenn alles ok war, ansonsten 0 bei einem Fehler.
int _cdecl ChangeFile(const char *pPath,int iPos,int iByte,const void *pPtr,int iSize,const char *pBackup,int iForceBackup)
{
char		cBuffer[MAX_PATH+8];
char		cTemp[4096];
DWORD		uBytes;
HANDLE		hFrom;
HANDLE		hFile;
int			iBits;
int			iLen;
int			iNum;
int			iOff;
int			iOk;


	if(iPos<0 || iByte<0 || iSize<0)return 0;


	   iNum = LengthFile(pPath);
	if(iNum<0)return 0;

	if(iPos>iNum || iPos<0)return 0;
	if(iPos+iByte>iNum)iByte=iNum-iPos;



	if(iByte==iSize)									// Bei gleicher Gre direkt schreiben
		{
		if(pBackup || iByte!=iSize)						// Backup erstellen
			{
				 if(iForceBackup<=0){iBits=7;iOk=1;}
			else if(iForceBackup==1){iBits=5;iOk=1;}
			else 					{iBits=1;iOk=iForceBackup;}

			if(!ChainFile(pPath,pBackup,iBits,iOk))
				{
				if(iForceBackup)return 0;
				}
			}

														// Datei ffnen
		   hFile = CreateFileA(pPath,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile==INVALID_HANDLE_VALUE)return 0;

		if(SetFilePointer(hFile,iPos,NULL,FILE_BEGIN)==0xFFFFFFFF)
			{
			CloseHandle(hFile);
			return 0;
			}

		iOk = WriteFile(hFile,pPtr,iSize,&uBytes,NULL);	// Daten schreiben

		if(iOk && (UINT)iSize!=uBytes)
			{
			iOk = 0;
			}

		CloseHandle(hFile);

		return iOk;
		}


	   iLen = (int)strlen(pPath);
	if(iLen>MAX_PATH)return 0;


	memcpy(cBuffer,pPath,iLen);
	memcpy(cBuffer+iLen,".cf.tmp",8);


														// Dateien ffnen
	   hFrom = CreateFileA(pPath,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hFrom==INVALID_HANDLE_VALUE)
		{
		return 0;
		}

	   hFile = CreateFileA(cBuffer,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hFile==INVALID_HANDLE_VALUE)
		{
		CloseHandle(hFrom);
		return 0;
		}


	iOk = 1;

	for(iOff=0;iOff<iPos;iOff+=iLen)					// Ersten Teil kopieren
		{
		   iLen = iPos-iOff;
		if(iLen>sizeof(cTemp))
			{
			iLen=sizeof(cTemp);
			}

	 	    iOk=ReadFile(hFrom,cTemp,iLen,&uBytes,NULL);	// Daten lesen
		if(!iOk || (UINT)iLen!=uBytes)
			{
			iOk = 0;
			break;
			}

		    iOk=WriteFile(hFile,cTemp,iLen,&uBytes,NULL);// Daten schreiben
		if(!iOk || (UINT)iLen!=uBytes)
			{
			iOk = 0;
			break;
			}
		}

	if(iOk)												// Alte Daten berspringen
		{
		if(SetFilePointer(hFrom,iByte,NULL,FILE_CURRENT)==0xFFFFFFFF)
			{
			iOk = 0;
			}

		iOff += iByte;
		}

	if(iOk)
		{
		   iOk=WriteFile(hFile,pPtr,iSize,&uBytes,NULL);// Neue Daten schreiben
		if(iOk && (UINT)iSize!=uBytes)
			{
			iOk = 0;
			}
		}

	if(iOk)												// Zweiten Teil kopieren
		{
		iLen  = sizeof(cTemp);
		iLen -= iOff%sizeof(cTemp);

	  	while(iOff<iNum)
			{
			if(iOff+iLen>iNum)
				{
				iLen = iNum-iOff;
				}
														// Daten lesen
	 		    iOk=ReadFile(hFrom,cTemp,iLen,&uBytes,NULL);
			if(!iOk || (UINT)iLen!=uBytes)
				{
				iOk = 0;
				break;
				}
														// Daten schreiben
			    iOk=WriteFile(hFile,cTemp,iLen,&uBytes,NULL);
			if(!iOk || (UINT)iLen!=uBytes)
				{
				iOk = 0;
				break;
				}

			iOff += iLen;
			iLen  = sizeof(cTemp);
			}
		}

	CloseHandle(hFrom);
	CloseHandle(hFile);

	if(iOk)													// Dateien tauschen
		{
		iOk = ReplaceFile(cBuffer,pPath,1,pBackup,iForceBackup);
		}
	else{
		RemoveFile(cBuffer);
		}


return iOk;
}

int _cdecl ChangeFile(const wchar_t *pPath,int iPos,int iByte,const void *pPtr,int iSize,const wchar_t *pBackup,int iForceBackup)
{
wchar_t		cBuffer[MAX_PATH+8];
char		cTemp[4096];
DWORD		uBytes;
HANDLE		hFrom;
HANDLE		hFile;
int			iBits;
int			iLen;
int			iNum;
int			iOff;
int			iOk;


	if(iPos<0 || iByte<0 || iSize<0)return 0;


	   iNum = LengthFile(pPath);
	if(iNum<0)return 0;

	if(iPos>iNum || iPos<0)return 0;
	if(iPos+iByte>iNum)iByte=iNum-iPos;



	if(iByte==iSize)									// Bei gleicher Gre direkt schreiben
		{
		if(pBackup || iByte!=iSize)						// Backup erstellen
			{
				 if(iForceBackup<=0){iBits=7;iOk=1;}
			else if(iForceBackup==1){iBits=5;iOk=1;}
			else 					{iBits=1;iOk=iForceBackup;}

			if(!ChainFile(pPath,pBackup,iBits,iForceBackup))
				{
				if(iForceBackup)return 0;
				}
			}

														// Datei ffnen
		   hFile = CreateFileW(pPath,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile==INVALID_HANDLE_VALUE)return 0;

		if(SetFilePointer(hFile,iPos,NULL,FILE_BEGIN)==0xFFFFFFFF)
			{
			CloseHandle(hFile);
			return 0;
			}

		iOk = WriteFile(hFile,pPtr,iSize,&uBytes,NULL);	// Daten schreiben

		if(iOk && (UINT)iSize!=uBytes)
			{
			iOk = 0;
			}

		CloseHandle(hFile);

		return iOk;
		}


	   iLen = (int)wcslen(pPath);
	if(iLen>MAX_PATH)return 0;


	memcpy(cBuffer,pPath,iLen);
	memcpy(cBuffer+iLen,".cf.tmp",8);


														// Dateien ffnen
	   hFrom = CreateFileW(pPath,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hFrom==INVALID_HANDLE_VALUE)
		{
		return 0;
		}

	   hFile = CreateFileW(cBuffer,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hFile==INVALID_HANDLE_VALUE)
		{
		CloseHandle(hFrom);
		return 0;
		}


	iOk = 1;

	for(iOff=0;iOff<iPos;iOff+=iLen)					// Ersten Teil kopieren
		{
		   iLen = iPos-iOff;
		if(iLen>sizeof(cTemp))
			{
			iLen=sizeof(cTemp);
			}

	 	    iOk=ReadFile(hFrom,cTemp,iLen,&uBytes,NULL);	// Daten lesen
		if(!iOk || (UINT)iLen!=uBytes)
			{
			iOk = 0;
			break;
			}

		    iOk=WriteFile(hFile,cTemp,iLen,&uBytes,NULL);// Daten schreiben
		if(!iOk || (UINT)iLen!=uBytes)
			{
			iOk = 0;
			break;
			}
		}

	if(iOk)												// Alte Daten berspringen
		{
		if(SetFilePointer(hFrom,iByte,NULL,FILE_CURRENT)==0xFFFFFFFF)
			{
			iOk = 0;
			}

		iOff += iByte;
		}

	if(iOk)
		{
		   iOk=WriteFile(hFile,pPtr,iSize,&uBytes,NULL);// Neue Daten schreiben
		if(iOk && (UINT)iSize!=uBytes)
			{
			iOk = 0;
			}
		}

	if(iOk)												// Zweiten Teil kopieren
		{
		iLen  = sizeof(cTemp);
		iLen -= iOff%sizeof(cTemp);

	  	while(iOff<iNum)
			{
			if(iOff+iLen>iNum)
				{
				iLen = iNum-iOff;
				}
														// Daten lesen
	 		    iOk=ReadFile(hFrom,cTemp,iLen,&uBytes,NULL);
			if(!iOk || (UINT)iLen!=uBytes)
				{
				iOk = 0;
				break;
				}
														// Daten schreiben
			    iOk=WriteFile(hFile,cTemp,iLen,&uBytes,NULL);
			if(!iOk || (UINT)iLen!=uBytes)
				{
				iOk = 0;
				break;
				}

			iOff += iLen;
			iLen  = sizeof(cTemp);
			}
		}

	CloseHandle(hFrom);
	CloseHandle(hFile);

	if(iOk)													// Dateien tauschen
		{
		iOk = ReplaceFile(cBuffer,pPath,1,pBackup,iForceBackup);
		}
	else{
		RemoveFile(cBuffer);
		}


return iOk;
}

//*****************************************************************************
//*
//*		IsFullPathName
//*
//*****************************************************************************
//	Prft ob ein Pfad ein absoluter Pfad ist
//	pPath		: Ist der zu prfende Pfad
//  Ergibt 0 wenn es ein relativer Pfad ist oder:
//					0 = "abc..."
//					1 = "/abc..."   oder "\abc..."
//					2 = "D:abc..."
//					3 = "D:/abc..." oder "D:\abc..." oder
//					4 = "//..." oder "\\..."
int _cdecl IsFullPathName(const char *pPath)
{
char	cSign;


	if(pPath[0]==0)return 0;

	if(pPath[1]==':')
		{
		   cSign = pPath[0]&~0x20;
		if(cSign<'A' || cSign>'Z')return 0;
		return (pPath[2]!='\\' && pPath[2]!='/')? 2:3;
		}


	if(pPath[0]!='\\' && pPath[0]!='/')return 0;
	if(pPath[1]!='\\' && pPath[1]!='/')return 1;


return 4;
}

int _cdecl IsFullPathName(const wchar_t *pPath)
{
wchar_t		cSign;


	if(pPath[0]==0)return 0;

	if(pPath[1]==':')
		{
		   cSign = pPath[0]&~0x20;
		if(cSign<'A' || cSign>'Z')return 0;
		return (pPath[2]!='\\' && pPath[2]!='/')? 2:3;
		}


	if(pPath[0]!='\\' && pPath[0]!='/')return 0;
	if(pPath[1]!='\\' && pPath[1]!='/')return 1;


return 4;
}


//*****************************************************************************
//*
//*		CreateTemPath
//*
//*****************************************************************************
//	Erzeugt ein temporres Verzeichnis samt Unterverzeichnissen
//	pPath	: Hier wird der Verzeichnisname samt Backslash gespeichert.
//	iSize	: Ist die Gre des Namenpuffers in Zeichen.
//	pName?	: Sind die das Unterverzeichnisse die angehngt werden. Wenn ein
//			  Name  mit '*' beginnt, wird der der vorherige Backslash entfernt.
//			  Wenn ein Name mit '#' beginnt, wird das vorherige Suffix verndert.
//			  Wenn ein Name  mit '?' beginnt, ist der letzte Abschnitt eine Datei.
//			  ('*' und '#' mssen gegebenfalls vor '?' stehen)
//			  Der Name kann mit und ohne Backslash beginnen bzw. enden.
//					CTP_USEEXE	= Statt GetTempPath wird GetExePath benutzt (nur bei pName1)
//					CTP_UNIQUE	= Eine eindeutige 8 stellige ID anhngen
//					CTP_UNIADD	= Eine eindeutige 8 stellige ID anhngen ohne Backslash
//	pLen	: Hier wird die Lnge des Verzeichnisnamens gespeichert
//			  wenn dieser Zeiger nicht NULL ist.
//	Ergibt 0 bei einem Fehler
//		   1 wenn der Pfad erzeugt wurde
//         2 wenn der Pfad bereits existiert
int _cdecl CreateTempPath(char *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int *pLen)
{
const char *pName;
FILETIME	sTime;
unsigned 	uBits;
unsigned 	uTurn;
unsigned 	uName;
unsigned	uMode;
unsigned	uFlag;
unsigned 	uVal;
int			iNum;
int			iLen;
int			iPos;


	if(pLen)*pLen=0;


	if(pName1==(const char*)CTP_USEEXE)						// Pfad der EXE-Datei benutzen
		{
		pName1	= NULL;
		iLen	= GetExePath(pPath,iSize);
		if(iLen+1>=iSize)return 0;
		}
	else{													// Temporren Windows-Pfad benutzen
		if(iSize>1024)iSize=1024;
		iLen	= GetTempPathA(iSize,pPath);
		if(iLen>iSize)return 0;
		}

	uMode = CP_FULL_LEN;
	uFlag = 0;

	for(uName=0;uName<4;uName++)							// Unterverzeichnisse anhngen
		{
		switch(uName)
			{
		case 0:	pName=(const char*)pName1;	break;
		case 1:	pName=(const char*)pName2;	break;
		case 2:	pName=(const char*)pName3;	break;
		case 3:	pName=(const char*)pName4;	break;
			}

		if(pName==NULL)continue;


		if(pName==(const char*)CTP_UNIADD)					// Eindeutige ID anhngen ohne Backslash
			{
			if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
				{
				iLen--;
				}

			pName =  (const char*)CTP_UNIQUE;
			}


		if(pName==(const char*)CTP_NAMEADD)					// Nur den Dateinamen des nchsten Abschnitts anhngen
			{
			uFlag = 1;
			continue;
			}


		if(pName==(const char*)CTP_UNIQUE)					// Eine eindeutige ID anhngen
			{
			if(iLen+10>iSize)return 0;

			GetSystemTimeAsFileTime(&sTime);

			uVal	= sTime.dwLowDateTime;
			uVal   ^= GetTickCount();
			uVal   ^= rand();
			uVal   ^= rand()<<16;

			for(uTurn=0;;uTurn++)							// Suche nichtexistentes Verzeichnis
				{
				if(uTurn>0xFFFF)return 0;

				for(iNum=0;iNum<8;iNum++)
					{
					uBits = (uVal>>(iNum*4))&0x0F;
					pPath[iLen+iNum] = "0123456789ABCDEF"[uBits];
					}

				pPath[iLen+8]=0;

				if(GetFileAttributesA(pPath)==0xFFFFFFFF)	// Gibt es das Verzeichnis schon
					{
					break;
					}

				uVal++;
				}

			iLen += 8;
			pPath[iLen] = '\\';
			iLen += 1;

			continue;
			}

		if(*pName=='*')										// Vorherigen Backslash lschen
			{
			if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
				{
				iLen--;
				}

			pName++;
			}

		if(*pName=='#')										// Vorheriges Suffix anpassen
			{
			if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
				{
				iLen--;
				}

			pName++;

			if(*pName=='.')pName++;

			for(iPos=iLen-1;iPos>0;iPos--)
				{
				if(pPath[iPos]=='\\')break;
				if(pPath[iPos]=='/' )break;
				if(pPath[iPos]!='.' )continue;
				iLen = iPos+1;
				break;
				}
			}

		if(*pName=='?')										// Letztes Verzeichnis ist eine Datei
			{
			uMode = CP_PATH_LEN;
			pName++;
			}

		if(uFlag)											// Nur den Dateinamen des Abschnitts anhngen
			{
			pName = GetFileName(pName);
			uMode = CP_PATH_LEN;
			uFlag = 0;
			}

		if(*pName=='\\')pName++;
		if(*pName=='/' )pName++;

		while(*pName)										// Namen kopieren
			{
			if(iLen+2>=iSize)return 0;
			pPath[iLen] = *pName;
			pName++;
			iLen++;
			}
															// Ist schon ein Backslash vorhanden
		if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
			{
			continue;
			}

		pPath[iLen] = '\\';
		iLen++;
		}

	if(uMode==CP_PATH_LEN && iLen>0)						// Letztes Verzeichnis ist eine Datei
		{
		iLen--;
		}

	pPath[iLen] = 0;
	if(pLen)*pLen=iLen;



return CreatePath(pPath,uMode);
}

int _cdecl CreateTempPath(wchar_t *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int *pLen)
{
const wchar_t *pName;
FILETIME	sTime;
unsigned 	uBits;
unsigned 	uTurn;
unsigned 	uName;
unsigned	uMode;
unsigned	uFlag;
unsigned 	uVal;
int			iNum;
int			iLen;
int			iPos;


	if(pLen)*pLen=0;


	if(pName1==(const wchar_t*)CTP_USEEXE)					// Pfad der EXE-Datei benutzen
		{
		pName1	= NULL;
		iLen	= GetExePath(pPath,iSize);
		if(iLen+1>=iSize)return 0;
		}
	else{													// Temporren Windows-Pfad benutzen
		if(iSize>1024)iSize=1024;
		iLen	= GetTempPathW(iSize,pPath);
		if(iLen>iSize)return 0;
		}

	uMode = CP_FULL_LEN;
	uFlag = 0;

	for(uName=0;uName<4;uName++)							// Unterverzeichnisse anhngen
		{
		switch(uName)
			{
		case 0:	pName=(const wchar_t*)pName1;	break;
		case 1:	pName=(const wchar_t*)pName2;	break;
		case 2:	pName=(const wchar_t*)pName3;	break;
		case 3:	pName=(const wchar_t*)pName4;	break;
			}

		if(pName==NULL)continue;


		if(pName==(const wchar_t*)CTP_UNIADD)				// Eindeutige ID anhngen ohne Backslash
			{
			if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
				{
				iLen--;
				}

			pName =  (const wchar_t*)CTP_UNIQUE;
			}


		if(pName==(const wchar_t*)CTP_NAMEADD)				// Nur den Dateinamen des nchsten Abschnitts anhngen
			{
			uFlag = 1;
			continue;
			}


		if(pName==(const wchar_t*)CTP_UNIQUE)				// Eine eindeutige ID anhngen
			{
			if(iLen+10>iSize)return 0;

			GetSystemTimeAsFileTime(&sTime);

			uVal	= sTime.dwLowDateTime;
			uVal   ^= GetTickCount();
			uVal   ^= rand();
			uVal   ^= rand()<<16;

			for(uTurn=0;;uTurn++)							// Suche nichtexistentes Verzeichnis
				{
				if(uTurn>0xFFFF)return 0;

				for(iNum=0;iNum<8;iNum++)
					{
					uBits = (uVal>>(iNum*4))&0x0F;
					pPath[iLen+iNum] = "0123456789ABCDEF"[uBits];
					}

				pPath[iLen+8]=0;

				if(GetFileAttributesW(pPath)==0xFFFFFFFF)	// Gibt es das Verzeichnis schon
					{
					break;
					}

				uVal++;
				}

			iLen += 8;
			pPath[iLen] = '\\';
			iLen += 1;

			continue;
			}

		if(*pName=='*')										// Vorherigen Backslash lschen
			{
			if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
				{
				iLen--;
				}

			pName++;
			}

		if(*pName=='#')										// Vorheriges Suffix anpassen
			{
			if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
				{
				iLen--;
				}

			pName++;

			if(*pName=='.')pName++;

			for(iPos=iLen-1;iPos>0;iPos--)
				{
				if(pPath[iPos]=='\\')break;
				if(pPath[iPos]=='/' )break;
				if(pPath[iPos]!='.' )continue;
				iLen = iPos+1;
				break;
				}
			}

		if(*pName=='?')										// Letztes Verzeichnis ist eine Datei
			{
			uMode = CP_PATH_LEN;
			pName++;
			}

		if(uFlag)											// Nur den Dateinamen des Abschnitts anhngen
			{
			pName = GetFileName(pName);
			uMode = CP_PATH_LEN;
			uFlag = 0;
			}

		if(*pName=='\\')pName++;
		if(*pName=='/' )pName++;

		while(*pName)										// Namen kopieren
			{
			if(iLen+2>=iSize)return 0;
			pPath[iLen] = *pName;
			pName++;
			iLen++;
			}
															// Ist schon ein Backslash vorhanden
		if(iLen>0 && (pPath[iLen-1]=='\\' || pPath[iLen-1]=='/'))
			{
			continue;
			}

		pPath[iLen] = '\\';
		iLen++;
		}

	if(uMode==CP_PATH_LEN && iLen>0)						// Letztes Verzeichnis ist eine Datei
		{
		iLen--;
		}

	pPath[iLen] = 0;
	if(pLen)*pLen=iLen;



return CreatePath(pPath,uMode);
}



#ifdef 	_DEBUG

int   	 _cdecl PathCompress    (char    *pTarget,const char    *pPath,int iSize,int iLen,const char    *pName){return PathCompress(pTarget,pPath,iSize,iLen,pName,strlen(pName));}
int   	 _cdecl PathCompress    (wchar_t *pTarget,const wchar_t *pPath,int iSize,int iLen,const wchar_t *pName){return PathCompress(pTarget,pPath,iSize,iLen,pName,wcslen(pName));}
int		 _cdecl PathCompress    (char    *pPath,int iSize){return PathCompress(pPath,pPath,iSize);}
int  	 _cdecl PathCompress    (wchar_t *pPath,int iSize){return PathCompress(pPath,pPath,iSize);}

int   	 _cdecl SubFileName     (         char    *pPath){return SubFileName((int)strlen(pPath),pPath);}
int   	 _cdecl SubFileName     (         wchar_t *pPath){return SubFileName((int)wcslen(pPath),pPath);}

int   	 _cdecl AddFileName     (int iLen,char    *pBuffer,                     const char    *pName,int iMax){return AddFileName  (iLen                ,pBuffer,pBuffer,pName,iMax);}
int   	 _cdecl AddFileName     (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax){return AddFileName  (iLen                ,pBuffer,pBuffer,pName,iMax);}
int   	 _cdecl AddFileName     (         char    *pBuffer,                     const char    *pName,int iMax){return AddFileName  ((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax);}
int   	 _cdecl AddFileName     (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax){return AddFileName  ((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax);}
int   	 _cdecl AddFileName     (         char    *pBuffer,const char    *pPath,const char    *pName,int iMax){return AddFileName  ((int)strlen(pPath  ),pBuffer,pPath  ,pName,iMax);}
int   	 _cdecl AddFileName     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax){return AddFileName  ((int)wcslen(pPath  ),pBuffer,pPath  ,pName,iMax);}

int   	 _cdecl PasteFileType   (int iLen,char    *pBuffer,                     const char    *pType,int iMax){return PasteFileType(iLen                ,pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl PasteFileType   (int iLen,wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return PasteFileType(iLen                ,pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl PasteFileType   (         char    *pBuffer,                     const char    *pType,int iMax){return PasteFileType((int)strlen(pBuffer),pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl PasteFileType   (         wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return PasteFileType((int)wcslen(pBuffer),pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl PasteFileType   (         char    *pBuffer,const char    *pPath,const char    *pType,int iMax){return PasteFileType((int)strlen(pPath)  ,pBuffer,pPath  ,pType,iMax);}
int   	 _cdecl PasteFileType   (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pType,int iMax){return PasteFileType((int)wcslen(pPath)  ,pBuffer,pPath  ,pType,iMax);}

int   	 _cdecl SetFileType     (int iLen,char    *pBuffer,                     const char    *pType,int iMax){return SetFileType  ((int)strlen(pBuffer),pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl SetFileType     (int iLen,wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return SetFileType  ((int)wcslen(pBuffer),pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl SetFileType     (         char    *pBuffer,                     const char    *pType,int iMax){return SetFileType  ((int)strlen(pBuffer),pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl SetFileType     (         wchar_t *pBuffer,                     const wchar_t *pType,int iMax){return SetFileType  ((int)wcslen(pBuffer),pBuffer,pBuffer,pType,iMax);}
int   	 _cdecl SetFileType     (         char    *pBuffer,const char    *pPath,const char    *pType,int iMax){return SetFileType  ((int)strlen(pPath  ),pBuffer,pPath  ,pType,iMax);}
int   	 _cdecl SetFileType     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pType,int iMax){return SetFileType  ((int)wcslen(pPath  ),pBuffer,pPath  ,pType,iMax);}

int   	 _cdecl SetFileName     (int iLen,char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFileName((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFileName     (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFileName((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFileName     (         char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFileName((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFileName     (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFileName((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFileName     (         char    *pBuffer,const char    *pPath,const char    *pName,int iMax,int iNameSize){return SetFileName((int)strlen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}
int   	 _cdecl SetFileName     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax,int iNameSize){return SetFileName((int)wcslen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}

int   	 _cdecl SetFilePath     (int iLen,char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFilePath((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFilePath     (int iLen,wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFilePath((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFilePath     (         char    *pBuffer,                     const char    *pName,int iMax,int iNameSize){return SetFilePath((int)strlen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFilePath     (         wchar_t *pBuffer,                     const wchar_t *pName,int iMax,int iNameSize){return SetFilePath((int)wcslen(pBuffer),pBuffer,pBuffer,pName,iMax,iNameSize);}
int   	 _cdecl SetFilePath     (         char    *pBuffer,const char    *pPath,const char    *pName,int iMax,int iNameSize){return SetFilePath((int)strlen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}
int   	 _cdecl SetFilePath     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pName,int iMax,int iNameSize){return SetFilePath((int)wcslen(pPath  ),pBuffer,pPath  ,pName,iMax,iNameSize);}

int   	 _cdecl SetFileBody     (int iLen,char    *pBuffer,                     const char    *pBody,int iMax,int iBodySize){return SetFileBody((int)strlen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
int   	 _cdecl SetFileBody     (int iLen,wchar_t *pBuffer,                     const wchar_t *pBody,int iMax,int iBodySize){return SetFileBody((int)wcslen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
int   	 _cdecl SetFileBody     (         char    *pBuffer,                     const char    *pBody,int iMax,int iBodySize){return SetFileBody((int)strlen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
int   	 _cdecl SetFileBody     (         wchar_t *pBuffer,                     const wchar_t *pBody,int iMax,int iBodySize){return SetFileBody((int)wcslen(pBuffer),pBuffer,pBuffer,pBody,iMax,iBodySize);}
int   	 _cdecl SetFileBody     (         char    *pBuffer,const char    *pPath,const char    *pBody,int iMax,int iBodySize){return SetFileBody((int)strlen(pPath  ),pBuffer,pPath  ,pBody,iMax,iBodySize);}
int   	 _cdecl SetFileBody     (         wchar_t *pBuffer,const wchar_t *pPath,const wchar_t *pBody,int iMax,int iBodySize){return SetFileBody((int)wcslen(pPath  ),pBuffer,pPath  ,pBody,iMax,iBodySize);}

int   	 _cdecl CmpFileType     (const char    *pPath ,const char    *pType){return CmpFileType(pPath,pType,(int)strlen(pPath));}
int   	 _cdecl CmpFileType     (const wchar_t *pPath ,const wchar_t *pType){return CmpFileType(pPath,pType,(int)wcslen(pPath));}

int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,int              *pCurrentPos,int              *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,int              *pCurrentPos,int              *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const void *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,pBreakPtr);}

int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,int              *pCurrentPos,int              *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,int              *pCurrentPos,int              *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned         *pCurrentPos,unsigned         *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,__int64          *pCurrentPos,__int64          *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const char    *pExistingFile,const char    *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}
int   	 _cdecl CopyFileProgress(const wchar_t *pExistingFile,const wchar_t *pNewFileName,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const void volatile *pBreakPtr,unsigned uFlags){return CopyFileProgress(uFlags|CFP_POS64|CFP_MAX64,pExistingFile,pNewFileName,pCurrentPos,pMaximalPos,(const void*)pBreakPtr);}

int   	 _cdecl	GetFileType     (char *pTarget,const char *pPath,int iLen){return GetFileType (pTarget,(int)strlen(pPath),pPath,iLen);}
int   	 _cdecl	GetFileName     (char *pTarget,const char *pPath,int iLen){return GetFileName (pTarget,(int)strlen(pPath),pPath,iLen);}
int   	 _cdecl	GetFileBody     (char *pTarget,const char *pPath,int iLen){return GetFileBody (pTarget,(int)strlen(pPath),pPath,iLen);}
int   	 _cdecl	GetFilePathR    (char *pTarget,const char *pPath,int iLen){return GetFilePathR(pTarget,(int)strlen(pPath),pPath,iLen);}
char* 	 _cdecl	GetFileType     (const char *pPath,int *pLen){return GetFileType ((int)strlen(pPath),pPath,pLen);}
char* 	 _cdecl	GetFileName     (const char *pPath,int *pLen){return GetFileName ((int)strlen(pPath),pPath,pLen);}
char* 	 _cdecl	GetFileBody     (const char *pPath,int *pLen){return GetFileBody ((int)strlen(pPath),pPath,pLen);}
char* 	 _cdecl	GetFilePathR    (const char *pPath,int *pLen){return GetFilePathR((int)strlen(pPath),pPath,pLen);}

int   	 _cdecl	GetFileType     (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFileType (pTarget,(int)wcslen(pPath),pPath,iLen);}
int   	 _cdecl	GetFileName     (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFileName (pTarget,(int)wcslen(pPath),pPath,iLen);}
int   	 _cdecl	GetFileBody     (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFileBody (pTarget,(int)wcslen(pPath),pPath,iLen);}
int   	 _cdecl	GetFilePathR    (wchar_t *pTarget,const wchar_t *pPath,int iLen){return GetFilePathR(pTarget,(int)wcslen(pPath),pPath,iLen);}
wchar_t* _cdecl	GetFileType     (const wchar_t *pPath,int *pLen){return GetFileType ((int)wcslen(pPath),pPath,pLen);}
wchar_t* _cdecl	GetFileName     (const wchar_t *pPath,int *pLen){return GetFileName ((int)wcslen(pPath),pPath,pLen);}
wchar_t* _cdecl	GetFileBody     (const wchar_t *pPath,int *pLen){return GetFileBody ((int)wcslen(pPath),pPath,pLen);}
wchar_t* _cdecl	GetFilePathR    (const wchar_t *pPath,int *pLen){return GetFilePathR((int)wcslen(pPath),pPath,pLen);}

int		 _cdecl FilePathLen     (const char    *pPath){return FilePathLen((int)strlen(pPath),pPath);}
int		 _cdecl FilePathLen     (const wchar_t *pPath){return FilePathLen((int)wcslen(pPath),pPath);}

int      _cdecl SaveMemory      (const char    *pPath,const char    *pText){return SaveMemory(pPath,pText,(int)strlen(pText));}
int      _cdecl SaveMemory      (const char    *pPath,const wchar_t *pText){return SaveMemory(pPath,pText,(int)wcslen(pText)*sizeof(wchar_t));}
int      _cdecl SaveMemory      (const wchar_t *pPath,const char    *pText){return SaveMemory(pPath,pText,(int)strlen(pText));}
int      _cdecl SaveMemory      (const wchar_t *pPath,const wchar_t *pText){return SaveMemory(pPath,pText,(int)wcslen(pText)*sizeof(wchar_t));}

BOOL	 _cdecl IsDots          (const char    *pPath){if(pPath[0]!='.')return FALSE;if(pPath[1]== 0 )return TRUE;if(pPath[1]=='.' && pPath[2]==0){return TRUE;}return FALSE;}
BOOL	 _cdecl IsDots          (const wchar_t *pPath){if(pPath[0]!='.')return FALSE;if(pPath[1]== 0 )return TRUE;if(pPath[1]=='.' && pPath[2]==0){return TRUE;}return FALSE;}

int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,pName4,&iLen);}
int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3                   ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,0     ,&iLen);}
int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1,const void *pName2                                      ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,0     ,0     ,&iLen);}
int      _cdecl CreateTempPath  (      char    *pPath,int iSize,const void *pName1                                                         ,int &iLen){return CreateTempPath(pPath,iSize,pName1,0     ,0     ,0     ,&iLen);}
int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3,const void *pName4,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,pName4,&iLen);}
int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2,const void *pName3                   ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,pName3,0     ,&iLen);}
int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1,const void *pName2                                      ,int &iLen){return CreateTempPath(pPath,iSize,pName1,pName2,0     ,0     ,&iLen);}
int      _cdecl CreateTempPath  (      wchar_t *pPath,int iSize,const void *pName1                                                         ,int &iLen){return CreateTempPath(pPath,iSize,pName1,0     ,0     ,0     ,&iLen);}

#endif

//*****************************************************************************
//*
//*		FileTimeToUtcTime
//*
//*****************************************************************************/
//	Konvertiert eine FILETIME Zeit in Unix-Sekunten seit 1.Jan.1970
//	pFileTime	: Zeiger auf die FILETIME Zeit
//	pUtcTime	: Zeiger auf die UTC-Zeit w
//	Ergibt TRUE wenn die Konversion erfolgreich war.
BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,LONGLONG *pUtcTime)
{
__int64		iSeconds;


	iSeconds  = *(__int64*)pFileTime;
	iSeconds -= 0x019DB1DED53E8000;

	if(iSeconds<0)
		{
		*pUtcTime = 0;
		return FALSE;
		}

	iSeconds   /= 10000000;
	*pUtcTime	= iSeconds;


return 1;
}

//*****************************************************************************
//*
//*		FileTimeToUtcTime
//*
//*****************************************************************************/
//	Konvertiert eine FILETIME-Zeit in eine UTC-Zeit (Sekunden seit 1.Jan.1970)
//	pFileTime	: Zeiger auf die FILETIME-Zeit
//	pUtcTime	: Zeiger auf die UTC-Zeit
//	Ergibt TRUE wenn die Konversion erfolgreich war.
BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,__time32_t *pUtcTime)
{
union	{
		__int64	i64;
		DWORD	dw[2];
		}sTime;


	sTime.i64  = *(__int64*)pFileTime;
	sTime.i64 -= 0x019DB1DED53E8000;

	if(sTime.dw[1]&0x80000000)					// Zeit vor Mi 1.Jan.1970
		{
		*pUtcTime = 0;
		return FALSE;
		}

	sTime.i64 /= 10000000;						// 100ns zu Sekunden umwandeln

	if(sizeof(time_t)==4)
		{										// ber Jan.2038
		if(sTime.dw[1] || (sTime.dw[0]&0x80000000))
			{
			*pUtcTime = 0x7FFFFFFF;
			return FALSE;
			}

		*pUtcTime = (__time32_t)sTime.dw[0];	// Unix Zeit speichern
		}
	else{
		*pUtcTime = (__time32_t)sTime.i64;
		}


return TRUE;
}

BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,LPDWORD pUtcTime)
{
union	{
		__int64	i64;
		DWORD	dw[2];
		}sTime;


	sTime.i64  = *(__int64*)pFileTime;
	sTime.i64 -= 0x019DB1DED53E8000;

	if(sTime.dw[1]&0x80000000)					// Zeit vor Mi 1.Jan.1970
		{
		*pUtcTime = 0;
		return FALSE;
		}

	if(sTime.dw[1]>=0x0098967F)					// ber Jahr 2106
		{
		*pUtcTime = 0xFFFFFFFE;
		return FALSE;
		}

	sTime.i64 /= 10000000;						// 100ns zu Sekunden umwandeln
	*pUtcTime  = sTime.dw[0];					// Unix Zeit speichern


return TRUE;
}

#ifdef 	_DEBUG

BOOL _cdecl FileTimeToUtcTime(CONST FILETIME *pFileTime,unsigned *pUtcTime)
{
return FileTimeToUtcTime(pFileTime,(LPDWORD)pUtcTime);
}

#endif

//*****************************************************************************
//*
//*		UtcTimeToFileTime
//*
//*****************************************************************************/
//	Konvertiert UTC-Zeit (Sekunden seit 1.Jan.1970) in eine FILETIME-Zeit.
//	iUtcTime	: Ist die UTC-Zeit
//	pFileTime	: Zeiger auf die FILETIME Zeit
//	Ergibt TRUE wenn die Konversion erfolgreich war.
BOOL _cdecl UtcTimeToFileTime(LONGLONG iUtcTime,FILETIME *pFileTime)
{

	if(iUtcTime<=0)
		{
		pFileTime->dwLowDateTime  = 0;
		pFileTime->dwHighDateTime = 0;
		return FALSE;
		}

	iUtcTime *= 10000000;
	iUtcTime += 0x019DB1DED53E8000;

	*(__int64*)pFileTime = iUtcTime;


return TRUE;
}

//*****************************************************************************
//*
//*		CmpFileTime
//*
//*****************************************************************************
//	Vergleicht zwei Dateizeiten. Es knnen dabei UTC und FileTime vermischt werden.
//	UTC Zeiten die auf -1 sind (0xFFFFFFFF) werden vor dem Vergleich auf 0 gesetzt.
//	iMode		: Ist der Vergleichsmodus
//					0 = Nanosekunden genau
//					1 = Sekunden genau
//					2 = Zwei Sekunden genau (fr DOS-Zeit)
//					3 = Zwei Sekunden genau mit ein Stundenschutz
//	Ergibt folgende Ergebnisse fr den Vergleich:
//				-1 wenn Time1 kleiner Time2	ist
//				+1 wenn Time1 grer  Time2	ist
//				 0 wenn Time1 gleich  Time2 ist
LONG _cdecl CmpFileTime(CONST FILETIME *pTime1,CONST FILETIME *pTime2,int iMode)
{
LONGLONG 	iTime1;
LONGLONG 	iTime2;
LONGLONG	iDiff;


	switch(iMode)
		{
	case 0:											// Nanosekunden genau

			iTime1 = *(PLONGLONG)&pTime1;
			iTime2 = *(PLONGLONG)&pTime2;
			break;

	case 1:											// Sekunden genau

			FileTimeToUtcTime(pTime1,&iTime1);
			FileTimeToUtcTime(pTime2,&iTime2);
			break;

	case 2:											// Zwei Sekunden genau

			FileTimeToUtcTime(pTime1,&iTime1);
			FileTimeToUtcTime(pTime2,&iTime2);
			iTime1 &= ~(LONGLONG)1;
			iTime2 &= ~(LONGLONG)1;
			break;

	case 3:											// Mit ein Stundenschutz

			FileTimeToUtcTime(pTime1,&iTime1);
			FileTimeToUtcTime(pTime2,&iTime2);
			iTime1 >>= 1;
			iTime2 >>= 1;
			iDiff    = iTime1-iTime2;

			if(iDiff> 1801)break;
			if(iDiff<-1801)break;
			if(iDiff<1799 && iDiff>-1799)break;

			return 0;

	default:										// Unbekannter Modus

			return 0;
		}

	if(iTime1<iTime2)return -1;
	if(iTime1>iTime2)return +1;


return 0;
}

LONG _cdecl CmpFileTime(LONGLONG iTime1,CONST FILETIME *pTime2,int iMode)
{
LONGLONG 	iTime2;
LONGLONG	iDiff;


	iTime2 = *(PLONGLONG)&pTime2;

	switch(iMode)
		{
	case 0:											// Nanosekunden genau

			UtcTimeToFileTime(iTime1,(FILETIME*)&iTime1);
			break;

	case 1:											// Sekunden genau

			FileTimeToUtcTime(pTime2,&iTime2);
			break;

	case 2:											// Zwei Sekunden genau

			FileTimeToUtcTime(pTime2,&iTime2);
			iTime1 &= ~(LONGLONG)1;
			iTime2 &= ~(LONGLONG)1;
			break;

	case 3:											// Mit ein Stundenschutz

			FileTimeToUtcTime(pTime2,&iTime2);
			iTime1 >>= 1;
			iTime2 >>= 1;
			iDiff    = iTime1-iTime2;

			if(iDiff> 1801)break;
			if(iDiff<-1801)break;
			if(iDiff<1799 && iDiff>-1799)break;

			return 0;

	default:										// Unbekannter Modus

			return 0;
		}

	if(iTime1<iTime2)return -1;
	if(iTime1>iTime2)return +1;


return 0;
}

LONG _cdecl CmpFileTime(CONST FILETIME *pTime1,LONGLONG iTime2,int iMode)
{
LONGLONG 	iTime1;
LONGLONG	iDiff;


	iTime1 = *(PLONGLONG)&pTime1;

	switch(iMode)
		{
	case 0:											// Nanosekunden genau

			UtcTimeToFileTime(iTime2,(FILETIME*)&iTime2);
			break;

	case 1:											// Sekunden genau

			FileTimeToUtcTime(pTime1,&iTime1);
			break;

	case 2:											// Zwei Sekunden genau

			FileTimeToUtcTime(pTime1,&iTime1);
			iTime1 &= ~(LONGLONG)1;
			iTime2 &= ~(LONGLONG)1;
			break;

	case 3:											// Mit ein Stundenschutz

			FileTimeToUtcTime(pTime1,&iTime1);
			iTime1 >>= 1;
			iTime2 >>= 1;
			iDiff    = iTime1-iTime2;

			if(iDiff> 1801)break;
			if(iDiff<-1801)break;
			if(iDiff<1799 && iDiff>-1799)break;

			return 0;

	default:										// Unbekannter Modus

			return 0;
		}

	if(iTime1<iTime2)return -1;
	if(iTime1>iTime2)return +1;


return 0;
}

LONG _cdecl CmpFileTime(LONGLONG iTime1,LONGLONG iTime2,int iMode)
{
LONGLONG	iDiff;


	switch(iMode)
		{
	case 0:											// Nanosekunden genau

			break;

	case 1:											// Sekunden genau

			break;

	case 2:											// Zwei Sekunden genau

			iTime1 &= ~(LONGLONG)1;
			iTime2 &= ~(LONGLONG)1;
			break;

	case 3:											// Mit ein Stundenschutz

			iTime1 >>= 1;
			iTime2 >>= 1;
			iDiff    = iTime1-iTime2;

			if(iDiff> 1801)break;
			if(iDiff<-1801)break;
			if(iDiff<1799 && iDiff>-1799)break;

			return 0;

	default:										// Unbekannter Modus

			return 0;
		}

	if(iTime1<iTime2)return -1;
	if(iTime1>iTime2)return +1;


return 0;
}

LONG _cdecl CmpFileTime(const char *pPath1,const char *pPath2,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind1;
WIN32_FILE_ATTRIBUTE_DATA	sFind2;


	if(!GetFileAttributesExA(pPath1,GetFileExInfoStandard,&sFind1))
		{
		sFind1.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}

	if(!GetFileAttributesExA(pPath2,GetFileExInfoStandard,&sFind2))
		{
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}


return CmpFileTime(&sFind1.ftLastWriteTime,&sFind2.ftLastWriteTime,iMode);
}

LONG _cdecl CmpFileTime(const wchar_t *pPath1,const wchar_t *pPath2,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind1;
WIN32_FILE_ATTRIBUTE_DATA	sFind2;


	if(!GetFileAttributesExW(pPath1,GetFileExInfoStandard,&sFind1))
		{
		sFind1.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}

	if(!GetFileAttributesExW(pPath2,GetFileExInfoStandard,&sFind2))
		{
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}


return CmpFileTime(&sFind1.ftLastWriteTime,&sFind2.ftLastWriteTime,iMode);
}

LONG _cdecl CmpFileTime(LONGLONG iTime1,const wchar_t *pPath2,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind2;


													// Zeit aus Datei holen
	if(!GetFileAttributesExW(pPath2,GetFileExInfoStandard,&sFind2))
		{
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}


return CmpFileTime(iTime1,&sFind2.ftLastWriteTime,iMode);
}

LONG _cdecl CmpFileTime(CONST FILETIME *pTime1,const wchar_t *pPath2,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind2;


	if(!GetFileAttributesExW(pPath2,GetFileExInfoStandard,&sFind2))
		{
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}


return CmpFileTime(pTime1,&sFind2.ftLastWriteTime,iMode);
}

LONG _cdecl CmpFileTime(LONGLONG iTime1,const char *pPath2,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind2;


													// Zeit aus Datei holen
	if(!GetFileAttributesExA(pPath2,GetFileExInfoStandard,&sFind2))
		{
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}


return CmpFileTime(iTime1,&sFind2.ftLastWriteTime,iMode);
}

LONG _cdecl CmpFileTime(CONST FILETIME *pTime1,const char *pPath2,int iMode)
{
WIN32_FILE_ATTRIBUTE_DATA	sFind2;



	if(!GetFileAttributesExA(pPath2,GetFileExInfoStandard,&sFind2))
		{
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		sFind2.ftLastWriteTime.dwHighDateTime	= 0;
		}


return CmpFileTime(pTime1,&sFind2.ftLastWriteTime,iMode);
}

#define 	MAX_LEVELS		16					// Maximle Rekursion bei CountFiles

//*****************************************************************************
//*
//*		CountFiles
//*
//*****************************************************************************
//	Zhlt alle Dateien in einem Verzeichnis
//	uFlags		: Diverse Einstellungen
//					CFP_MAX64		0x00000002	Der Maximalwert ist ein 64-Bit-Wert
//					CFP_POSADD		0x00000004	Die Position wird zum Anfangswert addiert
//					CFP_USEPATH		0x00002000	Den Dateinamen vom Pfad entfernen
//					CFP_RECURSIVE	0x00010000	Auch Unterverzeichnisse beachten
//					CFP_NODONECB	0x20000000	Keinen DONE-Callback aufrufen
//					CFP_ONLYINIT	0x40000000	Nur Datenstruktur initialisieren
//	pPath		: Ist der Pfad der durchsucht werden soll (mit oder ohne Backslash)
//				  Mit dem Flag CFP_USEPATH wird der Dateiname am Ende vorher entfernt.
//	pData		: Diverse Parameter  fr die Steuerung.
//					iSizeNow  [out]	Anzahl der kopierten Bytes
//					iSizeMax  [out]	Gesamtanzahl der zu kopierenden Bytes
//					iFileNow  [out]	Anzahl der kopierten Dateien
//					iFileMax  [out]	Gesamtanzahl der zu kopierenden Dateien
//					iPathNow  [out]	Anzahl der erstelleten Pfade
//					iPathMax  [out]	Gesamtanzahl der zu erstellenden Pfade
//					iLevel 	  [out]	Ist die Pfadebene (0=Root)
//					sFilter   [out]	Anzahl der Plusfilter
//					sNameSize [out]	Lnge des Dateinamens (ohne Pfad)
//					iFileSize [out]	Gre der Datei fr Callback
//					pFileInfo [out]	Datei-Infos fr fr Callback
//					pFilterPlus 	Ist der Plusfilter (z.B.: "*.h *.cpp")
//					pFilterMinus	Ist der Plusfilter (z.B.: "*.h *.cpp")
//					pCurrentPos 	Zeiger auf die Anzahl der kopierten Bytes (32/64 Bit CFP_POS64)
//					pMaximalPos 	Zeiger auf Gesamtanzahl der zu kopierenden Bytes (32/64 Bit CFP_MAX64)
//					pBreakPtr 		ber diesen Zeiger kann ein User-Abbruch ausgelst werden (mit Byte[0])
//					pCallback 		Ist die Callback Funktion fr Dateien, Pfade und Fehler.
//					pCbParam 		User-Parameter fr Callback Funktion
//	Ergibt die Anzahl der gefunden Dateien plus 1 oder einen Fehlernummer:
//					-9 = Quellverzeichnis nicht gefunden
//					-8 = Der Pfad war zu lang
//					-5 = Lesefehler
//					 0 = User-Abbruch
//				    >0 = Gefundene Dateien plus 1
int _cdecl CountFiles(unsigned uFlags,const char *pPath,FileInfoA *pData)
{
int					aSize[MAX_LEVELS];
HANDLE				aFind[MAX_LEVELS];
char				cPath[MAX_PATH*2];
WIN32_FIND_DATAA	sInfo;
const char 		   *pMinus;
__int64				iBytes;
int					iFilter;
int					iLevel;
int					iAll;
int					iLen;
int					iPos;
int					iRet;




	if(uFlags&CFP_USEPATH)							// Dateiname vom Pfad trennen
		{
		iLen = GetFilePathR(cPath,pPath,MAX_PATH);
		}
	else{
		   iLen = (int)strlen(pPath);				// Dateinamen kopieren
		if(iLen>=MAX_PATH-1)iLen=MAX_PATH-2;

		memcpy(cPath,pPath,iLen);
		if(iLen>0 && pPath[iLen-1]!='\\' && pPath[iLen-1]!='/')
			{
			cPath[iLen] = '\\';
			iLen++;
			}
		}


	if(iLen>=MAX_PATH-4)							// Ist der Pfad zu lang
		{
		SetLastError(ERROR_BAD_PATHNAME);
		if(!pData->pCallback)return -8;

		sInfo.dwFileAttributes	= FILE_ATTRIBUTE_DIRECTORY;
		cPath[iLen]				= 0;
		pData->sNameSize		= 0;
		pData->iFileSize		= -8;
		pData->pFileInfo		= &sInfo;
		pData->pCallback(pData->pCbParam,pPath,(int)strlen(pPath),CFP_ACTION_ERR,pData);

		iRet = -8;

		goto Exit;
		}



	if(pData->pFilterPlus && pData->pFilterPlus[0])	// Anzahl der Filter berechnen
		{
		iFilter	= 1;

		for(iPos=0;pData->pFilterPlus[iPos];iPos++)
			{
			if(pData->pFilterPlus[iPos]!=';')continue;
			iFilter++;
			}

		if(iPos==1 && pData->pFilterPlus[0]!='*')
			{
			iFilter = 0;
			}
		}
	else{											// Kein Plusfilter
		iFilter	= 0;
		}

	pData->sFilter	= iFilter;

	if(iFilter==1 && !(uFlags&CFP_RECURSIVE))		// Nur ein Filter, dann direkt anhngen
		{
		if(iLen+iPos>=MAX_PATH)
			{
			SetLastError(ERROR_BAD_PATHNAME);
			return -8;
			}

		iPos++;

		memcpy(cPath+iLen,pData->pFilterPlus,iPos);
		iAll			= iLen+iPos;
		iFilter			= 0;
		}
	else{
		cPath[iLen  ]	= '*';
		cPath[iLen+1]	= 0;
		iAll			= iLen+3;
		}


	   pMinus = pData->pFilterMinus;
	if(pMinus && !*pMinus)pMinus=0;					// Gibt es einen Minusfilter


	pData->iLevel 	= 0;

	if(!(uFlags&CFP_POSADD))						// Werte initalisieren
		{
		pData->iSizeNow	= 0;
		pData->iSizeMax	= 0;
		pData->iFileNow	= 0;
		pData->iFileMax	= 0;
		pData->iPathNow	= 0;
		pData->iPathMax	= 0;

		if(pData->pMaximalPos)
			{
			if(uFlags&CFP_MAX64)
					*((__int64*)pData->pMaximalPos)=0;
			else	*((  int  *)pData->pMaximalPos)=0;
			}

		if(pData->pCurrentPos)
			{
			if(uFlags&CFP_MAX64)
					*((__int64*)pData->pCurrentPos)=0;
			else	*((  int  *)pData->pCurrentPos)=0;
			}
		}


	if(uFlags&CFP_ONLYINIT)							// Nur die Datenstruktur initialisieren
		{
		if(pData->pFileInfo)
			{
			memcpy(pData->pFileInfo,cPath,iAll);
			pData->iFileSize = (__int64)pMinus;
			pData->sNameSize = (short)iLen;
			}

		return 1;
		}											// Zwischenspeichen fr CopyFolder(...)
	else if((uFlags&CFP_NODONECB) && pData->pFileInfo)
		{
		memcpy(pData->pFileInfo,cPath,iAll);
		}


	aSize[0] = iLen;
	aFind[0] = FindFirstFileA(cPath,&sInfo);

	if(aFind[0]==INVALID_HANDLE_VALUE)				// Wurde der Pfad nicht gefunden
		{
		if(GetLastError()==ERROR_PATH_NOT_FOUND)
				iRet=-9;
		else	iRet=-5;

		if(pData->pCallback)						// Callback fr Fehler
			{
			sInfo.dwFileAttributes	= FILE_ATTRIBUTE_DIRECTORY;
			cPath[iLen]				= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= iRet;
			pData->pCallback(pData->pCbParam,cPath,iLen,CFP_ACTION_ERR,pData);
			}

		goto Exit;
		}


	iLevel			 = 0;
	pData->iLevel	 = iLevel;
	pData->pFileInfo = &sInfo;


	for(;;)											// Die Dateien suchen
		{
		if(pData->pBreakPtr && *(LPBYTE)pData->pBreakPtr)
			{
			iRet = 0;								// User-Abbruch
			break;
			}

		iLen = (int)strlen(sInfo.cFileName);

													// Wurde ein Verzeichnis gefunden
		if(sInfo.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(sInfo.cFileName[0]=='.' && iLen<=2)
				{
				if(sInfo.cFileName[1]== 0 )goto Next;
				if(sInfo.cFileName[1]=='.')goto Next;
				}

			pData->iPathMax++;

			if(uFlags&CFP_RECURSIVE)				// Auch Unterverzeichnisse durchsuchen
				{
				iAll  = aSize[iLevel];
				memcpy(cPath+iAll,sInfo.cFileName,iLen);
				iAll += iLen;

				cPath[iAll] = '\\'; iAll++;
				cPath[iAll] = 0;


				if(iAll>=MAX_PATH-3)				// Wird der Pfad zu lang
					{
					if(!pData->pCallback)goto Next;

					pData->iFileSize	= -8;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_ERR,pData);

					if(iRet<0)break;

					goto Next;
					}


				if(pData->pCallback)				// Callback fr Pfad
					{
					pData->iFileSize	= 0;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_PATH,pData);

					if(iRet>0)						// Diesen Pfad ignoriren
						{
						pData->iPathMax--;
						goto Next;
						}

					if(iRet<0)						// User-Abbruch
						{
						iRet = 0;
						break;
						}
					}

				cPath[iAll  ] = '*';
				cPath[iAll+1] =  0;

				if(iLevel>=MAX_LEVELS-1)
					{
					goto Next;
					}

				iLevel++;							// Neue Ebene
				aSize[iLevel] = iAll;
				aFind[iLevel] = FindFirstFileA(cPath,&sInfo);

				if(aFind[iLevel]!=INVALID_HANDLE_VALUE)
					{
					pData->iLevel = iLevel;
					continue;
					}

				if(pData->pCallback)				// Callback fr Fehler
					{
					pData->sNameSize	= (short)iLen;
					pData->iFileSize	= (GetLastError()==ERROR_PATH_NOT_FOUND)? -9:-5;
					iRet				= pData->pCallback(pData->pCbParam,cPath,iAll-iLen,CFP_ACTION_ERR,pData);

					if(iRet<0)break;
					}

				iLevel--;
				}
			}
		else{
			if(iFilter && memfilter(sInfo.cFileName,iLen,pData->pFilterPlus,0x03)<=0)
				{
				goto Next;
				}

			if(pMinus && memfilter(sInfo.cFileName,iLen,pMinus,0x03)>0)
				{
				goto Next;
				}

			iBytes   = sInfo.nFileSizeHigh;
			iBytes <<= 32;
			iBytes  |= sInfo.nFileSizeLow;


			if(pData->pCallback)					// Callback fr Dateien
				{
				iAll = aSize[iLevel];

				memcpy(cPath+iAll,sInfo.cFileName,iLen+1);

				pData->iFileSize	= iBytes;
				pData->sNameSize	= (short)iLen;
				iRet				= pData->pCallback(pData->pCbParam,cPath,iAll,CFP_ACTION_FILE,pData);

				if(iRet>0)goto Next;
				if(iRet<0)
					{
					iRet = 0;
					break;
					}
				}

			pData->iFileMax += 1;
			pData->iSizeMax	+= iBytes;

			if(pData->pMaximalPos && pData->pMaximalPos!=&pData->iSizeMax)
				{
				if(uFlags&CFP_MAX64)
						*((__int64*)pData->pMaximalPos)+=     iBytes;
				else	*((  int  *)pData->pMaximalPos)+=(int)iBytes;
				}
			}

Next:

		if(!FindNextFileA(aFind[iLevel],&sInfo))	// Nchste Datei suchen
			{
			FindClose(aFind[iLevel]);
			   iLevel--;
			if(iLevel<0)
				{
				iRet = pData->iFileMax;
				break;
				}

			pData->iLevel = iLevel;
			goto Next;
			}
		}


	while(iLevel>=0)								// Such-Handles schlieen
		{
		FindClose(aFind[iLevel]);
		iLevel--;
		}

Exit:

	if(pData->pCallback && !(uFlags&CFP_NODONECB))	// Callback fr Ende
		{
		sInfo.cFileName[0]	= 0;
		pData->sNameSize	= 0;
		pData->iFileSize	= iRet;
		pData->pCallback(pData->pCbParam,"",0,CFP_ACTION_DONE,pData);
		}

	if((uFlags&CFP_NODONECB) && pData->pFileInfo)	// Daten CopyFolder(...)
		{
		pData->iFileSize = (__int64)pMinus;
		pData->sNameSize = (short)aSize[0];
		}


return iRet;
}

int _cdecl CountFiles(unsigned uFlags,const wchar_t *pPath,FileInfoW *pData)
{
int					aSize[MAX_LEVELS];
HANDLE				aFind[MAX_LEVELS];
wchar_t				cPath[MAX_PATH*2];
WIN32_FIND_DATAW	sInfo;
const wchar_t	   *pMinus;
__int64				iBytes;
int					iFilter;
int					iLevel;
int					iAll;
int					iLen;
int					iPos;
int					iRet;




	if(uFlags&CFP_USEPATH)							// Dateiname vom Pfad trennen
		{
		iLen = GetFilePathR(cPath,pPath,MAX_PATH);
		}
	else{
		   iLen = (int)wcslen(pPath);				// Dateinamen kopieren
		if(iLen>=MAX_PATH-1)iLen=MAX_PATH-2;

		memcpy(cPath,pPath,iLen*sizeof(wchar_t));
		if(iLen>0 && pPath[iLen-1]!='\\' && pPath[iLen-1]!='/')
			{
			cPath[iLen] = '\\';
			iLen++;
			}
		}


	if(iLen>=MAX_PATH-4)							// Ist der Pfad zu lang
		{
		SetLastError(ERROR_BAD_PATHNAME);
		if(!pData->pCallback)return -8;

		sInfo.dwFileAttributes	= FILE_ATTRIBUTE_DIRECTORY;
		cPath[iLen]				= 0;
		pData->sNameSize		= 0;
		pData->iFileSize		= -8;
		pData->pFileInfo		= &sInfo;
		pData->pCallback(pData->pCbParam,pPath,(int)wcslen(pPath),CFP_ACTION_ERR,pData);

		iRet = -8;

		goto Exit;
		}



	if(pData->pFilterPlus && pData->pFilterPlus[0])	// Anzahl der Filter berechnen
		{
		iFilter	= 1;

		for(iPos=0;pData->pFilterPlus[iPos];iPos++)
			{
			if(pData->pFilterPlus[iPos]!=';')continue;
			iFilter++;
			}

		if(iPos==1 && pData->pFilterPlus[0]!='*')
			{
			iFilter = 0;
			}
		}
	else{											// Kein Plusfilter
		iFilter	= 0;
		}

	pData->sFilter	= iFilter;

	if(iFilter==1 && !(uFlags&CFP_RECURSIVE))		// Nur ein Filter, dann direkt anhngen
		{
		if(iLen+iPos>=MAX_PATH)
			{
			SetLastError(ERROR_BAD_PATHNAME);
			return -8;
			}

		iPos++;

		memcpy(cPath+iLen,pData->pFilterPlus,iPos*sizeof(wchar_t));
		iAll			= iLen+iPos;
		iFilter			= 0;
		}
	else{
		cPath[iLen  ]	= '*';
		cPath[iLen+1]	= 0;
		iAll			= iLen+3;
		}


	   pMinus = pData->pFilterMinus;
	if(pMinus && !*pMinus)pMinus=0;					// Gibt es einen Minusfilter


	pData->iLevel 	= 0;

	if(!(uFlags&CFP_POSADD))						// Werte initalisieren
		{
		pData->iSizeNow	= 0;
		pData->iSizeMax	= 0;
		pData->iFileNow	= 0;
		pData->iFileMax	= 0;
		pData->iPathNow	= 0;
		pData->iPathMax	= 0;

		if(pData->pMaximalPos)
			{
			if(uFlags&CFP_MAX64)
					*((__int64*)pData->pMaximalPos)=0;
			else	*((  int  *)pData->pMaximalPos)=0;
			}

		if(pData->pCurrentPos)
			{
			if(uFlags&CFP_MAX64)
					*((__int64*)pData->pCurrentPos)=0;
			else	*((  int  *)pData->pCurrentPos)=0;
			}
		}


	if(uFlags&CFP_ONLYINIT)							// Nur die Datenstruktur initialisieren
		{
		if(pData->pFileInfo)
			{
			memcpy(pData->pFileInfo,cPath,iAll*sizeof(wchar_t));
			pData->iFileSize = (__int64)pMinus;
			pData->sNameSize = (short)iLen;
			}

		return 1;
		}											// Zwischenspeichen fr CopyFolder(...)
	else if((uFlags&CFP_NODONECB) && pData->pFileInfo)
		{
		memcpy(pData->pFileInfo,cPath,iAll*sizeof(wchar_t));
		}


	aSize[0] = iLen;
	aFind[0] = FindFirstFileW(cPath,&sInfo);

	if(aFind[0]==INVALID_HANDLE_VALUE)				// Wurde der Pfad nicht gefunden
		{
		if(GetLastError()==ERROR_PATH_NOT_FOUND)
				iRet=-9;
		else	iRet=-5;

		if(pData->pCallback)						// Callback fr Fehler
			{
			sInfo.dwFileAttributes	= FILE_ATTRIBUTE_DIRECTORY;
			cPath[iLen]				= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= iRet;
			pData->pCallback(pData->pCbParam,cPath,iLen,CFP_ACTION_ERR,pData);
			}

		goto Exit;
		}


	iLevel			 = 0;
	pData->iLevel	 = iLevel;
	pData->pFileInfo = &sInfo;


	for(;;)											// Die Dateien suchen
		{
		if(pData->pBreakPtr && *(LPBYTE)pData->pBreakPtr)
			{
			iRet = 0;								// User-Abbruch
			break;
			}

		iLen = (int)wcslen(sInfo.cFileName);

													// Wurde ein Verzeichnis gefunden
		if(sInfo.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(sInfo.cFileName[0]=='.' && iLen<=2)
				{
				if(sInfo.cFileName[1]== 0 )goto Next;
				if(sInfo.cFileName[1]=='.')goto Next;
				}

			pData->iPathMax++;

			if(uFlags&CFP_RECURSIVE)				// Auch Unterverzeichnisse durchsuchen
				{
				iAll  = aSize[iLevel];
				memcpy(cPath+iAll,sInfo.cFileName,iLen*sizeof(wchar_t));
				iAll += iLen;

				cPath[iAll] = '\\'; iAll++;
				cPath[iAll] = 0;


				if(iAll>=MAX_PATH-3)				// Wird der Pfad zu lang
					{
					if(!pData->pCallback)goto Next;

					pData->iFileSize	= -8;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_ERR,pData);

					if(iRet<0)break;

					goto Next;
					}


				if(pData->pCallback)				// Callback fr Pfad
					{
					pData->iFileSize	= 0;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_PATH,pData);

					if(iRet>0)						// Diesen Pfad ignoriren
						{
						pData->iPathMax--;
						goto Next;
						}

					if(iRet<0)						// User-Abbruch
						{
						iRet = 0;
						break;
						}
					}

				cPath[iAll  ] = '*';
				cPath[iAll+1] =  0;

				if(iLevel>=MAX_LEVELS-1)
					{
					goto Next;
					}

				iLevel++;							// Neue Ebene
				aSize[iLevel] = iAll;
				aFind[iLevel] = FindFirstFileW(cPath,&sInfo);

				if(aFind[iLevel]!=INVALID_HANDLE_VALUE)
					{
					pData->iLevel = iLevel;
					continue;
					}

				if(pData->pCallback)				// Callback fr Fehler
					{
					pData->sNameSize	= (short)iLen;
					pData->iFileSize	= (GetLastError()==ERROR_PATH_NOT_FOUND)? -9:-5;
					iRet				= pData->pCallback(pData->pCbParam,cPath,iAll-iLen,CFP_ACTION_ERR,pData);

					if(iRet<0)break;
					}

				iLevel--;
				}
			}
		else{
			if(iFilter && memfilter(sInfo.cFileName,iLen,pData->pFilterPlus,0x03)<=0)
				{
				goto Next;
				}

			if(pMinus && memfilter(sInfo.cFileName,iLen,pMinus,0x03)>0)
				{
				goto Next;
				}

			iBytes   = sInfo.nFileSizeHigh;
			iBytes <<= 32;
			iBytes  |= sInfo.nFileSizeLow;


			if(pData->pCallback)					// Callback fr Dateien
				{
				iAll = aSize[iLevel];

				memcpy(cPath+iAll,sInfo.cFileName,(iLen+1)*sizeof(wchar_t));

				pData->iFileSize	= iBytes;
				pData->sNameSize	= (short)iLen;
				iRet				= pData->pCallback(pData->pCbParam,cPath,iAll,CFP_ACTION_FILE,pData);

				if(iRet>0)goto Next;
				if(iRet<0)
					{
					iRet = 0;
					break;
					}
				}

			pData->iFileMax += 1;
			pData->iSizeMax	+= iBytes;

			if(pData->pMaximalPos && pData->pMaximalPos!=&pData->iSizeMax)
				{
				if(uFlags&CFP_MAX64)
						*((__int64*)pData->pMaximalPos)+=     iBytes;
				else	*((  int  *)pData->pMaximalPos)+=(int)iBytes;
				}
			}

Next:

		if(!FindNextFileW(aFind[iLevel],&sInfo))	// Nchste Datei suchen
			{
			FindClose(aFind[iLevel]);
			   iLevel--;
			if(iLevel<0)
				{
				iRet = pData->iFileMax;
				break;
				}

			pData->iLevel = iLevel;
			goto Next;
			}
		}


	while(iLevel>=0)								// Such-Handles schlieen
		{
		FindClose(aFind[iLevel]);
		iLevel--;
		}

Exit:

	if(pData->pCallback && !(uFlags&CFP_NODONECB))	// Callback fr Ende
		{
		sInfo.cFileName[0]	= 0;
		pData->sNameSize	= 0;
		pData->iFileSize	= iRet;
		pData->pCallback(pData->pCbParam,L"",0,CFP_ACTION_DONE,pData);
		}

	if((uFlags&CFP_NODONECB) && pData->pFileInfo)	// Daten CopyFolder(...)
		{
		pData->iFileSize = (__int64)pMinus;
		pData->sNameSize = (short)aSize[0];
		}


return iRet;
}

#ifdef 	_DEBUG

int _cdecl CountFiles(const char *pPath,__int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CountFiles(uFlags|CFP_MAX64,pPath,&sData);
}

int _cdecl CountFiles(const char *pPath,  int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CountFiles(uFlags,pPath,&sData);
}

int _cdecl CountFiles(void *pParam,FileInfoCbA pProc,const char *pPath,const char *pFilterPlus,const char *pFilterMinus,unsigned uFlags)
{
FileInfoA	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

return CountFiles(uFlags,pPath,&sData);
}

int _cdecl CountFiles(const char *pPath,unsigned __int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
int _cdecl CountFiles(const char *pPath,unsigned   int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

int _cdecl CountFiles(const wchar_t *pPath,__int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CountFiles(uFlags|CFP_MAX64,pPath,&sData);
}

int _cdecl CountFiles(const wchar_t *pPath,  int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pCurrentPos	= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CountFiles(uFlags,pPath,&sData);
}

int _cdecl CountFiles(void *pParam,FileInfoCbW pProc,const wchar_t *pPath,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,unsigned uFlags)
{
FileInfoW	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

return CountFiles(uFlags,pPath,&sData);
}

int _cdecl CountFiles(const wchar_t *pPath,unsigned __int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
int _cdecl CountFiles(const wchar_t *pPath,unsigned   int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CountFiles(pPath,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

#endif

//*****************************************************************************
//*
//*		CopyFolder
//*
//*****************************************************************************
//	Kopiert alle Dateien in einem Verzeichnis in ein anderes Verzeichnis.
//	uFlags		: Diverse Einstellungen
//					CFP_POS64		0x00000001	Die Position ist ein 64-Bit-Wert
//					CFP_MAX64		0x00000002	Der Maximalwert ist ein 64-Bit-Wert
//					CFP_POSADD		0x00000004	Die Position wird zum Anfangswert addiert
//					CFP_FAILIFEXIST	0x00000008	Nicht kopieren wenn die Zieldatei existiert
//					CFP_TEMPRENAME	0x00000010	Zuerst in eine temporre Datei kopieren
//					CFP_COPYTIME	0x00000020	Auch die Dateizeiten kopieren
//					CFP_COPYATTRIB	0x00000040	Attribute mit kopieren
//					CFP_READONLY	0x00000080	Auch ReadOnly Dateien berschreiben
//					CFP_CREATEPATH	0x00000100	Zielpfad erzeugen falls er nicht existiert
//					CFP_DELETEPATH	0x00000200	Alles im Zielpfad lschen
//					CFP_MOVEFILE	0x00000400	Wenn erfolgreich dann die Quelldatei lschen
//					CFP_FORCEMOVE	0x00000800	Die Quelldatei auch lschen wenn sie schreibgeschtzt ist
//					CFP_USEPATH		0x00002000	Den Dateinamen vom Pfad entfernen
//					CFP_USEPATHNEW	0x00004000	Den Dateinamen vom Pfad entfernen (fr Ziel)
//					CFP_STOPATERROR	0x00008000	Nach jedem Fehler anhalten
//					CFP_RECURSIVE	0x00010000	Auch Unterverzeichnisse beachten
//					CFP_DEBUGSLEEP	0x10000000	Den Kopiervorgang verlangsammen zum Debuggen
//	pSourcePath: Ist der Pfad der kopiert werden soll (mit oder ohne Backslash)
//				  Mit dem Flag CFP_USEPATH wird der Dateiname am Ende vorher entfernt.
//	pTargetPath: Ist der zu dem die Dateien kopiert werden sollen (mit oder ohne Backslash)
//				  Mit dem Flag CFP_USEPATHNEW wird der Dateiname am Ende vorher entfernt.
//				  Mit CFP_CREATEPATH wird der Pfad rekursiv erstellt.
//				  Mit CFP_DELETEPATH werden alle Dateien im Pfad gelscht.
//	pData		: Diverse Parameter fr die Steuerung.
//					iSizeNow  [out]	Anzahl der kopierten Bytes
//					iSizeMax  [out]	Gesamtanzahl der zu kopierenden Bytes
//					iFileNow  [out]	Anzahl der kopierten Dateien
//					iFileMax  [out]	Gesamtanzahl der zu kopierenden Dateien
//					iPathNow  [out]	Anzahl der erstelleten Pfade
//					iPathMax  [out]	Gesamtanzahl der zu erstellenden Pfade
//					iLevel 	  [out]	Ist die Pfadebene (0=Root)
//					sFilter   [out]	Anzahl der Plusfilter
//					sNameSize [out]	Lnge des Dateinamens (ohne Pfad)
//					iFileSize [out]	Gre der Datei fr Callback
//					pFileInfo [out]	Datei-Infos fr fr Callback
//					pFilterPlus 	Ist der Plusfilter (z.B.: "*.h *.cpp")
//					pFilterMinus	Ist der Plusfilter (z.B.: "*.h *.cpp")
//					pCurrentPos 	Zeiger auf die Anzahl der kopierten Bytes (32/64 Bit CFP_POS64)
//					pMaximalPos 	Zeiger auf Gesamtanzahl der zu kopierenden Bytes (32/64 Bit CFP_MAX64)
//					pBreakPtr 		ber diesen Zeiger kann ein User-Abbruch ausgelst werden (mit Byte[0])
//					pCallback 		Ist die Callback Funktion fr Dateien, Pfade und Fehler.
//					pCbParam 		User-Parameter fr Callback Funktion
//	Ergibt die Anzahl der gefunden Dateien plus 1 oder einen Fehlernummer:
//					-11 = Der Zielpfad konnte nicht gelscht werden
//					-10 = Der Zielpfad konnte nicht erstellt werden
//					-9  = Quellverzeichnis nicht gefunden
//					-8  = Der Pfad war zu lang
//					-7  = Die Quelldatei konnte nicht gelscht werden
//					-6  = Kann temporre Datei nicht umbenennen
//					-5  = Lesefehler
//					-4  = Schreibfehler
//					-3  = Quelldatei nicht gefunden
//					-2  = Zieldatei konnte nicht erzeugt werden
//					-1  = Zieldatei existiert bereits
//					 0  = Userabbruch
//				    >0  = Gefundene Dateien plus 1
int _cdecl CopyFolder(unsigned uFlags,const char *pSourcePath,const char *pTargetPath,FileInfoA *pData)
{
int					aName[MAX_LEVELS];
int					aSize[MAX_LEVELS];
HANDLE				aFind[MAX_LEVELS];
char				cPath[MAX_PATH*2];
char				cTemp[MAX_PATH*2];
WIN32_FIND_DATAA	sInfo;
const char 		   *pMinus;
unsigned			uValue;
__int64				iBytes;
int					iFilter;
int					iLevel;
int					iSign;
int					iAll;
int					iLen;
int					iRet;




	uValue = (pData->pMaximalPos)? CFP_NODONECB:CFP_ONLYINIT;
	pData->pFileInfo = (LPWIN32_FIND_DATAA)cPath;

	   iRet = CountFiles(uFlags|uValue,pSourcePath,pData);
	if(iRet<=0)goto Exit;


	pMinus	= (const char*)pData->iFileSize;		// Daten aus Berechnung bernehmen
	iLen	= pData->sNameSize;
	iFilter	= pData->sFilter;
	iLevel	= -1;



	aSize[0] = iLen;
	aFind[0] = FindFirstFileA(cPath,&sInfo);

	if(aFind[0]==INVALID_HANDLE_VALUE)				// Wurde der Pfad nicht gefunden
		{
		if(GetLastError()==ERROR_PATH_NOT_FOUND)
				iRet=-9;
		else	iRet=-5;

		if(pData->pCallback)						// Callback fr Fehler
			{
			sInfo.dwFileAttributes	= FILE_ATTRIBUTE_DIRECTORY;
			cPath[iLen]				= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= iRet;
			pData->pCallback(pData->pCbParam,cPath,iLen,CFP_ACTION_ERR,pData);
			}

		goto Exit;
		}



	if(uFlags&CFP_USEPATHNEW)						// Dateiname vom Pfad trennen
		{
		iLen = GetFilePathR(cTemp,pTargetPath,MAX_PATH);
		}
	else{
		   iLen = (int)strlen(pTargetPath);			// Dateinamen kopieren
		if(iLen>=MAX_PATH-1)iLen=MAX_PATH-2;

		memcpy(cTemp,pTargetPath,iLen);
		if(iLen>0 && pTargetPath[iLen-1]!='\\' && pTargetPath[iLen-1]!='/')
			{
			cTemp[iLen] = '\\';
			iLen++;
			}

		cTemp[iLen] = 0;
		}


	if(uFlags&CFP_CREATEPATH)						// Den Zielpfad erstellen
		{
			iRet = CreatePath(cTemp);
		if(!iRet)
			{
			iRet = -10;
			goto Exit;
			}

				   uFlags&=~CFP_CREATEPATH;
		if(iRet==1)uFlags&=~CFP_DELETEPATH;
		}


	if(uFlags&CFP_DELETEPATH)						// Alles im Zielpfad lschen
		{
		uFlags &= ~CFP_DELETEPATH;

		if(pData->pCallback && iRet)				// Fehler ber Callback melden
			{
			iSign	= sInfo.cFileName[0];
			sInfo.cFileName[0]		= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= 0;
			pData->pFileInfo		= &sInfo;
			iRet					= pData->pCallback(pData->pCbParam,cTemp,iLen,CFP_ACTION_DEL,pData);

			if(iRet>0)goto None;
			if(iRet<0)
				{
				iRet = 0;
				goto Exit;
				}

			sInfo.cFileName[0]		= iSign;
			}

		iRet = RemovePath(cTemp,1);

		if((uFlags&CFP_STOPATERROR) && !iRet)
			{
			iRet = -11;
			goto Exit;
			}

		if(pData->pCallback && iRet)				// Fehler ber Callback melden
			{
			iSign	= sInfo.cFileName[0];
			sInfo.cFileName[0]		= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= -11;
			pData->pFileInfo		= &sInfo;
			iRet					= pData->pCallback(pData->pCbParam,cTemp,iLen,CFP_ACTION_ERR,pData);

			if(iRet<0)goto Exit;

			sInfo.cFileName[0]		= iSign;
			}
		}

None:

	iLevel			 = 0;
	aName[0]		 = iLen;
	pData->iLevel	 = iLevel;
	pData->pFileInfo = &sInfo;
	uFlags			|= CFP_ADDALWAYS|CFP_POSADD;


	for(;;)											// Die Dateien suchen
		{
		if(pData->pBreakPtr && *(LPBYTE)pData->pBreakPtr)
			{
			iRet = 0;								// User-Abbruch
			break;
			}

		iLen = (int)strlen(sInfo.cFileName);
		memcpy(cPath+aSize[iLevel],sInfo.cFileName,iLen+1);

													// Wurde ein Verzeichnis gefunden
		if(sInfo.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(sInfo.cFileName[0]=='.' && iLen<=2)
				{
				if(sInfo.cFileName[1]== 0 )goto Next;
				if(sInfo.cFileName[1]=='.')goto Next;
				}

			pData->iPathNow++;

			if(uFlags&CFP_RECURSIVE)				// Auch Unterverzeichnisse durchsuchen
				{
				iAll  = aSize[iLevel];
				iAll += iLen;

				cPath[iAll] = '\\'; iAll++;
				cPath[iAll] = 0;


				if(iAll>=MAX_PATH-3)				// Wird der Pfad zu lang
					{
					if(!pData->pCallback)goto Next;

					pData->iFileSize	= -8;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_ERR,pData);

					if(iRet<0)break;

					goto Next;
					}


				if(pData->pCallback)				// Callback fr Pfad
					{
					pData->iFileSize	= 0;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_PATH,pData);

					if(iRet>0)						// Diesen Pfad ignoriren
						{
						pData->iPathNow--;
						goto Next;
						}

					if(iRet<0)						// User-Abbruch
						{
						iRet = 0;
						break;
						}
					}

				cPath[iAll  ] = '*';
				cPath[iAll+1] =  0;

				if(iLevel>=MAX_LEVELS-1)
					{
					goto Next;
					}

				memcpy(cTemp+aName[iLevel],sInfo.cFileName,iLen);

				iLevel++;							// Neue Ebene
				aSize[iLevel] = iAll;
				aFind[iLevel] = FindFirstFileA(cPath,&sInfo);

				if(aFind[iLevel]!=INVALID_HANDLE_VALUE)
					{
					aName[iLevel] = aName[iLevel-1]+iLen+1;
					cTemp[aName[iLevel]-1] = '\\';
					cTemp[aName[iLevel]  ] = 0;

					   iRet = CreatePath(cTemp);
					if(iRet>0)						// Konnte der Pfad erstellt werden
						{
						if(pData->iPathMax<pData->iPathNow)
							{
							pData->iPathMax = pData->iPathNow;
							}

						pData->iLevel = iLevel;
						continue;
						}

					iRet = -10;
					}
				else{
					iRet = (GetLastError()==ERROR_PATH_NOT_FOUND)? -9:-5;
					}

				if(uFlags&CFP_STOPATERROR)
					{
					goto Exit;
					}

				if(pData->pCallback)				// Callback fr Fehler
					{
					pData->sNameSize	= (short)iLen;
					pData->iFileSize	= iRet;
					iRet				= pData->pCallback(pData->pCbParam,cPath,iAll-iLen,CFP_ACTION_ERR,pData);

					if(iRet<0)break;
					}

				iLevel--;
				}
			}
		else{
			if(iFilter && memfilter(sInfo.cFileName,iLen,pData->pFilterPlus,0x03)<=0)
				{
				goto Next;
				}

			if(pMinus && memfilter(sInfo.cFileName,iLen,pMinus,0x03)>0)
				{
				goto Next;
				}

			memcpy(cTemp+aName[iLevel],sInfo.cFileName,iLen+1);

			iBytes   = sInfo.nFileSizeHigh;
			iBytes <<= 32;
			iBytes  |= sInfo.nFileSizeLow;


			if(pData->pCallback)					// Callback fr Dateien
				{
				pData->iFileSize	= iBytes;
				pData->sNameSize	= (short)iLen;
				iRet				= pData->pCallback(pData->pCbParam,cPath,aName[iLevel],CFP_ACTION_COPY,pData);

				if(iRet>0)goto Next;
				if(iRet<0)
					{
					iRet = 0;
					break;
					}
				}
													// Eine einzelne Datei kopieren
			iRet = CopyFileProgress(uFlags,cPath,cTemp,pData->pCurrentPos,NULL,(void*)pData->pBreakPtr);

			if(iRet<0)								// Gab es einen Fehler
				{
				if((uFlags&CFP_STOPATERROR))
					{
					goto Exit;
					}

				if(pData->pCallback)				// Callback fr Fehler
					{
					pData->iFileSize	= iBytes;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aName[iLevel],CFP_ACTION_ERR,pData);

					if(iRet<0)break;
					}
				}

			pData->iFileNow += 1;

			if(pData->pCurrentPos!=&pData->iSizeNow)
				{
				pData->iSizeNow	+= iBytes;
				}

			if(pData->iSizeMax<pData->iSizeNow)
				{
				pData->iSizeMax = pData->iSizeNow;
				}

			if(pData->iFileMax<pData->iFileNow)
				{
				pData->iFileMax = pData->iFileNow;
				}
			}

Next:

		if(!FindNextFileA(aFind[iLevel],&sInfo))	// Nchste Datei suchen
			{
			FindClose(aFind[iLevel]);
			   iLevel--;
			if(iLevel<0)
				{
				iRet = pData->iFileMax;
				break;
				}

			pData->iLevel = iLevel;
			goto Next;
			}
		}


Exit:

	while(iLevel>=0)								// Such-Handles schlieen
		{
		FindClose(aFind[iLevel]);
		iLevel--;
		}

	if(pData->pCallback && !(uFlags&CFP_NODONECB))	// Callback fr Ende
		{
		sInfo.cFileName[0]	= 0;
		pData->sNameSize	= 0;
		pData->iFileSize	= iRet;
		pData->pCallback(pData->pCbParam,"",0,CFP_ACTION_DONE,pData);
		}


return iRet;
}

int _cdecl CopyFolder(unsigned uFlags,const wchar_t *pSourcePath,const wchar_t *pTargetPath,FileInfoW *pData)
{
int					aName[MAX_LEVELS];
int					aSize[MAX_LEVELS];
HANDLE				aFind[MAX_LEVELS];
wchar_t				cPath[MAX_PATH*2];
wchar_t				cTemp[MAX_PATH*2];
WIN32_FIND_DATAW	sInfo;
const wchar_t	   *pMinus;
unsigned			uValue;
__int64				iBytes;
int					iFilter;
int					iLevel;
int					iSign;
int					iAll;
int					iLen;
int					iRet;




	uValue = (pData->pMaximalPos)? CFP_NODONECB:CFP_ONLYINIT;
	pData->pFileInfo = (LPWIN32_FIND_DATAW)cPath;

	   iRet = CountFiles(uFlags|uValue,pSourcePath,pData);
	if(iRet<=0)goto Exit;


	pMinus	= (const wchar_t*)pData->iFileSize;		// Daten aus Berechnung bernehmen
	iLen	= pData->sNameSize;
	iFilter	= pData->sFilter;
	iLevel	= -1;



	aSize[0] = iLen;
	aFind[0] = FindFirstFileW(cPath,&sInfo);

	if(aFind[0]==INVALID_HANDLE_VALUE)				// Wurde der Pfad nicht gefunden
		{
		if(GetLastError()==ERROR_PATH_NOT_FOUND)
				iRet=-9;
		else	iRet=-5;

		if(pData->pCallback)						// Callback fr Fehler
			{
			sInfo.dwFileAttributes	= FILE_ATTRIBUTE_DIRECTORY;
			cPath[iLen]				= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= iRet;
			pData->pCallback(pData->pCbParam,cPath,iLen,CFP_ACTION_ERR,pData);
			}

		goto Exit;
		}



	if(uFlags&CFP_USEPATHNEW)						// Dateiname vom Pfad trennen
		{
		iLen = GetFilePathR(cTemp,pTargetPath,MAX_PATH);
		}
	else{
		   iLen = (int)wcslen(pTargetPath);				// Dateinamen kopieren
		if(iLen>=MAX_PATH-1)iLen=MAX_PATH-2;

		memcpy(cTemp,pTargetPath,iLen*sizeof(wchar_t));
		if(iLen>0 && pTargetPath[iLen-1]!='\\' && pTargetPath[iLen-1]!='/')
			{
			cTemp[iLen] = '\\';
			iLen++;
			}

		cTemp[iLen] = 0;
		}


	if(uFlags&CFP_CREATEPATH)						// Den Zielpfad erstellen
		{
			iRet = CreatePath(cTemp);
		if(!iRet)
			{
			iRet = -10;
			goto Exit;
			}

				   uFlags&=~CFP_CREATEPATH;
		if(iRet==1)uFlags&=~CFP_DELETEPATH;
		}


	if(uFlags&CFP_DELETEPATH)						// Alles im Zielpfad lschen
		{
		uFlags &= ~CFP_DELETEPATH;

		if(pData->pCallback && iRet)				// Fehler ber Callback melden
			{
			iSign	= sInfo.cFileName[0];
			sInfo.cFileName[0]		= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= 0;
			pData->pFileInfo		= &sInfo;
			iRet					= pData->pCallback(pData->pCbParam,cTemp,iLen,CFP_ACTION_DEL,pData);

			if(iRet>0)goto None;
			if(iRet<0)
				{
				iRet = 0;
				goto Exit;
				}

			sInfo.cFileName[0]		= iSign;
			}

		iRet = RemovePath(cTemp,1);

		if((uFlags&CFP_STOPATERROR) && !iRet)
			{
			iRet = -11;
			goto Exit;
			}

		if(pData->pCallback && iRet)				// Fehler ber Callback melden
			{
			iSign	= sInfo.cFileName[0];
			sInfo.cFileName[0]		= 0;
			pData->sNameSize		= 0;
			pData->iFileSize		= -11;
			pData->pFileInfo		= &sInfo;
			iRet					= pData->pCallback(pData->pCbParam,cTemp,iLen,CFP_ACTION_ERR,pData);

			if(iRet<0)goto Exit;

			sInfo.cFileName[0]		= iSign;
			}
		}

None:

	iLevel			 = 0;
	aName[0]		 = iLen;
	pData->iLevel	 = iLevel;
	pData->pFileInfo = &sInfo;
	uFlags			|= CFP_ADDALWAYS|CFP_POSADD;


	for(;;)											// Die Dateien suchen
		{
		if(pData->pBreakPtr && *(LPBYTE)pData->pBreakPtr)
			{
			iRet = 0;								// User-Abbruch
			break;
			}

		iLen = (int)wcslen(sInfo.cFileName);
		memcpy(cPath+aSize[iLevel],sInfo.cFileName,(iLen+1)*sizeof(wchar_t));

													// Wurde ein Verzeichnis gefunden
		if(sInfo.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(sInfo.cFileName[0]=='.' && iLen<=2)
				{
				if(sInfo.cFileName[1]== 0 )goto Next;
				if(sInfo.cFileName[1]=='.')goto Next;
				}

			pData->iPathNow++;

			if(uFlags&CFP_RECURSIVE)				// Auch Unterverzeichnisse durchsuchen
				{
				iAll  = aSize[iLevel];
				iAll += iLen;

				cPath[iAll] = '\\'; iAll++;
				cPath[iAll] = 0;


				if(iAll>=MAX_PATH-3)				// Wird der Pfad zu lang
					{
					if(!pData->pCallback)goto Next;

					pData->iFileSize	= -8;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_ERR,pData);

					if(iRet<0)break;

					goto Next;
					}


				if(pData->pCallback)				// Callback fr Pfad
					{
					pData->iFileSize	= 0;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aSize[iLevel],CFP_ACTION_PATH,pData);

					if(iRet>0)						// Diesen Pfad ignoriren
						{
						pData->iPathNow--;
						goto Next;
						}

					if(iRet<0)						// User-Abbruch
						{
						iRet = 0;
						break;
						}
					}

				cPath[iAll  ] = '*';
				cPath[iAll+1] =  0;

				if(iLevel>=MAX_LEVELS-1)
					{
					goto Next;
					}

				memcpy(cTemp+aName[iLevel],sInfo.cFileName,iLen*sizeof(wchar_t));

				iLevel++;							// Neue Ebene
				aSize[iLevel] = iAll;
				aFind[iLevel] = FindFirstFileW(cPath,&sInfo);

				if(aFind[iLevel]!=INVALID_HANDLE_VALUE)
					{
					aName[iLevel] = aName[iLevel-1]+iLen+1;
					cTemp[aName[iLevel]-1] = '\\';
					cTemp[aName[iLevel]  ] = 0;

					   iRet = CreatePath(cTemp);
					if(iRet>0)						// Konnte der Pfad erstellt werden
						{
						if(pData->iPathMax<pData->iPathNow)
							{
							pData->iPathMax = pData->iPathNow;
							}

						pData->iLevel = iLevel;
						continue;
						}

					iRet = -10;
					}
				else{
					iRet = (GetLastError()==ERROR_PATH_NOT_FOUND)? -9:-5;
					}

				if(uFlags&CFP_STOPATERROR)
					{
					goto Exit;
					}

				if(pData->pCallback)				// Callback fr Fehler
					{
					pData->sNameSize	= (short)iLen;
					pData->iFileSize	= iRet;
					iRet				= pData->pCallback(pData->pCbParam,cPath,iAll-iLen,CFP_ACTION_ERR,pData);

					if(iRet<0)break;
					}

				iLevel--;
				}
			}
		else{
			if(iFilter && memfilter(sInfo.cFileName,iLen,pData->pFilterPlus,0x03)<=0)
				{
				goto Next;
				}

			if(pMinus && memfilter(sInfo.cFileName,iLen,pMinus,0x03)>0)
				{
				goto Next;
				}

			memcpy(cTemp+aName[iLevel],sInfo.cFileName,(iLen+1)*sizeof(wchar_t));

			iBytes   = sInfo.nFileSizeHigh;
			iBytes <<= 32;
			iBytes  |= sInfo.nFileSizeLow;


			if(pData->pCallback)					// Callback fr Dateien
				{
				pData->iFileSize	= iBytes;
				pData->sNameSize	= (short)iLen;
				iRet				= pData->pCallback(pData->pCbParam,cPath,aName[iLevel],CFP_ACTION_COPY,pData);

				if(iRet>0)goto Next;
				if(iRet<0)
					{
					iRet = 0;
					break;
					}
				}
													// Eine einzelne Datei kopieren
			iRet = CopyFileProgress(uFlags,cPath,cTemp,pData->pCurrentPos,NULL,(void*)pData->pBreakPtr);

			if(iRet<0)								// Gab es einen Fehler
				{
				if((uFlags&CFP_STOPATERROR))
					{
					goto Exit;
					}

				if(pData->pCallback)				// Callback fr Fehler
					{
					pData->iFileSize	= iBytes;
					pData->sNameSize	= (short)iLen;
					iRet				= pData->pCallback(pData->pCbParam,cPath,aName[iLevel],CFP_ACTION_ERR,pData);

					if(iRet<0)break;
					}
				}

			pData->iFileNow += 1;

			if(pData->pCurrentPos!=&pData->iSizeNow)
				{
				pData->iSizeNow	+= iBytes;
				}

			if(pData->iSizeMax<pData->iSizeNow)
				{
				pData->iSizeMax = pData->iSizeNow;
				}

			if(pData->iFileMax<pData->iFileNow)
				{
				pData->iFileMax = pData->iFileNow;
				}
			}

Next:

		if(!FindNextFileW(aFind[iLevel],&sInfo))	// Nchste Datei suchen
			{
			FindClose(aFind[iLevel]);
			   iLevel--;
			if(iLevel<0)
				{
				iRet = pData->iFileMax;
				break;
				}

			pData->iLevel = iLevel;
			goto Next;
			}
		}


Exit:

	while(iLevel>=0)								// Such-Handles schlieen
		{
		FindClose(aFind[iLevel]);
		iLevel--;
		}

	if(pData->pCallback && !(uFlags&CFP_NODONECB))	// Callback fr Ende
		{
		sInfo.cFileName[0]	= 0;
		pData->sNameSize	= 0;
		pData->iFileSize	= iRet;
		pData->pCallback(pData->pCbParam,L"",0,CFP_ACTION_DONE,pData);
		}


return iRet;
}

#ifdef 	_DEBUG

int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,__int64 *pCurrentPos,__int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CopyFolder(uFlags|CFP_MAX64,pSourcePath,pTargetPath,&sData);
}

int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,  int   *pCurrentPos,  int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoA	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
}

int _cdecl CopyFolder(void *pParam,FileInfoCbA pProc,const char *pSourcePath,const char *pTargetPath,const char *pFilterPlus,const char *pFilterMinus,unsigned uFlags)
{
FileInfoA	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
}

int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(__int64*)pCurrentPos,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
int _cdecl CopyFolder(const char *pSourcePath,const char *pTargetPath,unsigned   int   *pCurrentPos,unsigned   int   *pMaximalPos,const char *pFilterPlus,const char *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(  int  *)pCurrentPos,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}


int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,__int64 *pCurrentPos,__int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CopyFolder(uFlags|CFP_MAX64,pSourcePath,pTargetPath,&sData);
}

int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,  int   *pCurrentPos,  int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags)
{
FileInfoW	sData;

	sData.pCallback		= 0;
	sData.pBreakPtr		= pBreakPtr;
	sData.pCurrentPos	= pCurrentPos;
	sData.pMaximalPos	= pMaximalPos;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;

return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
}

int _cdecl CopyFolder(void *pParam,FileInfoCbW pProc,const wchar_t *pSourcePath,const wchar_t *pTargetPath,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,unsigned uFlags)
{
FileInfoW	sData;

	sData.pCallback		= pProc;
	sData.pCbParam		= pParam;
	sData.pFilterPlus	= pFilterPlus;
	sData.pFilterMinus	= pFilterMinus;
	sData.pCurrentPos	= 0;
	sData.pMaximalPos	= 0;
	sData.pBreakPtr		= 0;

return CopyFolder(uFlags,pSourcePath,pTargetPath,&sData);
}


int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned __int64 *pCurrentPos,unsigned __int64 *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(__int64*)pCurrentPos,(__int64*)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}
int _cdecl CopyFolder(const wchar_t *pSourcePath,const wchar_t *pTargetPath,unsigned   int   *pCurrentPos,unsigned   int   *pMaximalPos,const wchar_t *pFilterPlus,const wchar_t *pFilterMinus,const void volatile *pBreakPtr,unsigned uFlags){return CopyFolder(pSourcePath,pTargetPath,(  int  *)pCurrentPos,(  int  *)pMaximalPos,pFilterPlus,pFilterMinus,pBreakPtr,uFlags);}

#endif
