//*****************************************************************************
//*
//*
//*		Klasse BitmapImage
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#include	<string.h>
#include	<stddef.h>
#include	<malloc.h>
#include	"BitmapImage.h"

#ifdef		 AZ_LIB_ADDAFX
#include	<Afx.h>
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
#endif

#ifndef		_MSC_VER
#define		uint64	 		unsigned long long
#else
#define		uint64	 		unsigned __int64
#endif


#define 	BMI_SIZE		  (sizeof(BITMAPINFOHEADER)+256*sizeof(RGBQUAD))
#define 	BMI_SIZE_EX(a)	  (sizeof(BITMAPINFOHEADER)+256*(a))
#define 	ENTRIES(a)		  (sizeof(a)/sizeof((a)[0]))
#define 	PTR_SUB(p,a)	  *(char**)&(p) = ((char*)(p))-(a);
#define 	PTR_ADD(p,a)	  *(char**)&(p) = ((char*)(p))+(a);
#define 	PTR_INT(p,a)	  (*(int*)(((char*)(p))+(a)))

#define 	C12L_TO_RGB(C)	  ((((C)&0x0000F0)   )|(((C)&0x00000F)<<12)|(((C)&0x00F000)<< 8))
#define 	C12H_TO_RGB(C)	  ((((C)&0x00F000)>>8)|(((C)&0xF00000)>> 8)|(((C)&0x0F0000)<< 4))
#define 	C12_TO_RGB(C,O)	  (((O)&1)?C12H_TO_RGB(C):C12L_TO_RGB(C))

#define 	C15_TO_RGB(C)	  ((((C)&0x001F)<<3)|(((C)&0x03E0)<< 6)|(((C)&0x7C00)<< 9)|(((C)&0x8000)<<16))
#define 	C16_TO_RGB(C)	  ((((C)&0x001F)<<3)|(((C)&0x07E0)<< 5)|(((C)&0xF800)<< 8))
#define 	P24_TO_RGB(P)	  ((*(unsigned*)(P))&0x00FFFFFF)
#define 	P32_TO_RGB(P)	  ((*(unsigned*)(P)))

#define 	RGB_TO_C24(C)	  (  (C)&0xFFFFFF)
#define 	RGB_TO_C16(C)	  ((((C)&0x0000F8)>>3)|(((C)&0x00FC00)>> 5)|(((C)&0xF80000)>> 8))
#define 	RGB_TO_C15(C)	  ((((C)&0x0000F8)>>3)|(((C)&0x00F800)>> 6)|(((C)&0xF80000)>> 9)|(((C)>>16)&0x8000))
#define 	RGB_TO_C12(C)	  ((((C)&0x0000F0)>>4)|(((C)&0x00F000)>> 8)|(((C)&0xF00000)>>12))
#define 	RGB_TO_C12L(C)    ((((C)&0x0000F0)   )|(((C)&0x00F000)>>12)|(((C)&0xF00000)>> 8))
#define 	RGB_TO_C12H(C)    ((((C)&0x0000F0)<<4)|(((C)&0x00F000)<< 8)|(((C)&0xF00000)>> 4))


#define 	RGB_TO_P12L(C,P)  {(*(unsigned*)(P))&=0xFFF0F00;(*(unsigned*)(P))|=(((C)&0x0000F0)    )|(((C)&0x00F000)>>12)|(((C)&0xF00000)>> 8);}
#define 	RGB_TO_P12H(C,P)  {(*(unsigned*)(P))&=0x000F0FF;(*(unsigned*)(P))|=(((C)&0x0000F0)<< 4)|(((C)&0x00F000)<< 8)|(((C)&0xF00000)>> 4);}
#define 	RGB_TO_P12(C,P,O) {if((O)&1)RGB_TO_P12H(C,P) else RGB_TO_P12L(C,P)}

#define 	RGB_TO_P15(C,P)	  {(*(unsigned short*)(P))=(unsigned short)((((C)&0x0000F8)>>3)|(((C)&0x00F800)>>6)|(((C)&0xF80000)>>9)| (((C)>>16)&0x8000));}
#define 	RGB_TO_P16(C,P)	  {(*(unsigned short*)(P))=(unsigned short)((((C)&0x0000F8)>>3)|(((C)&0x00FC00)>>5)|(((C)&0xF80000)>>8));}
#define 	RGB_TO_P24(C,P)	  {(*(unsigned short*)(P))=(unsigned short)(  (C));*(((unsigned char*)(P))+2) = (unsigned char)((C)>>16);}
#define 	RGB_TO_P32(C,P)	  {(*(unsigned      *)(P))=(unsigned      )(  (C));}

#define 	GET_WORD(P)		  (*(unsigned short*)(P))
#define 	GET_DW(P)		  (*(unsigned*)(P))
#define 	SET_DW(P,V)		   *(unsigned*)(P)=(V)

#ifndef 	CF_DIBV5
#define 	CF_DIBV5			17
#endif

static const unsigned char	ADD[33] =
							{
							0x00,0x01,0x01,0x00,0x01,0x00,0x00,0x00,
							0x01,0x00,0x00,0x00,0x03,0x00,0x00,0x02,
							0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04
							};

static const unsigned char	ROL[33] =
							{
							0x00,0x01,0x11,0x00,0x55,0x00,0x00,0x00,
							0xFF,0x00,0x00,0x00,0x55,0x00,0x00,0xFF,
							0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF
							};

static const unsigned char  COL[33] =
							{
							0x00,0x07,0x03,0x00,0x01,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
							};

static const unsigned char  SHL[33] =
							{
							0x00,0x03,0x02,0x00,0x01,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
							};

static const unsigned short SIN[] =
							{
							0x0000,0x0192,0x0324,0x04B6,0x0648,0x07D9,0x096B,0x0AFB,
							0x0C8C,0x0E1C,0x0FAB,0x113A,0x12C8,0x1455,0x15E2,0x176E,
							0x18F9,0x1A83,0x1C0C,0x1D93,0x1F1A,0x209F,0x2224,0x23A7,
							0x2528,0x26A8,0x2827,0x29A4,0x2B1F,0x2C99,0x2E11,0x2F87,
							0x30FC,0x326E,0x33DF,0x354E,0x36BA,0x3825,0x398D,0x3AF3,
							0x3C57,0x3DB8,0x3F17,0x4074,0x41CE,0x4326,0x447B,0x45CD,
							0x471D,0x486A,0x49B4,0x4AFB,0x4C40,0x4D81,0x4EC0,0x4FFB,
							0x5134,0x5269,0x539B,0x54CA,0x55F6,0x571E,0x5843,0x5964,
							0x5A82,0x5B9D,0x5CB4,0x5DC8,0x5ED7,0x5FE4,0x60EC,0x61F1,
							0x62F2,0x63EF,0x64E9,0x65DE,0x66D0,0x67BD,0x68A7,0x698C,
							0x6A6E,0x6B4B,0x6C24,0x6CF9,0x6DCA,0x6E97,0x6F5F,0x7023,
							0x70E3,0x719E,0x7255,0x7308,0x73B6,0x7460,0x7505,0x75A6,
							0x7642,0x76D9,0x776C,0x77FB,0x7885,0x790A,0x798A,0x7A06,
							0x7A7D,0x7AEF,0x7B5D,0x7BC6,0x7C2A,0x7C89,0x7CE4,0x7D3A,
							0x7D8A,0x7DD6,0x7E1E,0x7E60,0x7E9D,0x7ED6,0x7F0A,0x7F38,
							0x7F62,0x7F87,0x7FA7,0x7FC2,0x7FD9,0x7FEA,0x7FF6,0x7FFE,
							0x8000,
							};

static const unsigned short	SIZE_ARRAY[] =
							{
							0x8000,0x7FFE,0x7FFB,0x7FF6,0x7FEF,0x7FE6,0x7FDB,0x7FCE,
							0x7FBF,0x7FAE,0x7F9B,0x7F86,0x7F6F,0x7F56,0x7F3B,0x7F1E,
							0x7EFE,0x7EDD,0x7EBA,0x7E94,0x7E6D,0x7E43,0x7E18,0x7DEA,
							0x7DBA,0x7D88,0x7D54,0x7D1E,0x7CE6,0x7CAB,0x7C6F,0x7C30,
							0x7BEF,0x7BAC,0x7B66,0x7B1F,0x7AD5,0x7A89,0x7A3A,0x79E9,
							0x7996,0x7941,0x78E9,0x788F,0x7833,0x77D4,0x7772,0x770F,
							0x76A8,0x763F,0x75D4,0x7566,0x74F6,0x7483,0x740D,0x7394,
							0x7319,0x729B,0x721A,0x7197,0x7110,0x7087,0x6FFB,0x6F6C,
							0x6ED9,0x6E44,0x6DAC,0x6D10,0x6C71,0x6BCF,0x6B29,0x6A80,
							0x69D4,0x6924,0x6870,0x67B9,0x66FE,0x663F,0x657D,0x64B6,
							0x63EB,0x631C,0x6249,0x6171,0x6094,0x5FB3,0x5ECE,0x5DE3,
							0x5CF3,0x5BFE,0x5B04,0x5A04,0x58FE,0x57F2,0x56E1,0x55C8,
							0x54A9,0x5384,0x5257,0x5122,0x4FE6,0x4EA1,0x4D54,0x4BFE,
							0x4A9E,0x4934,0x47BF,0x463F,0x44B3,0x431A,0x4173,0x3FBD,
							0x3DF7,0x3C1F,0x3A34,0x3834,0x361C,0x33E9,0x3199,0x2F26,
							0x2C8A,0x29BF,0x26BA,0x236D,0x1FBF,0x1B8C,0x1689,0x0FF7,
							0x0000,
							};

static const unsigned short	ARC_ARRAY[] =
							{
							0x0000,0x0145,0x028B,0x03D1,0x0517,0x065C,0x07A2,0x08E7,
							0x0A2C,0x0B70,0x0CB4,0x0DF8,0x0F3B,0x107E,0x11C1,0x1303,
							0x1444,0x1584,0x16C4,0x1804,0x1942,0x1A80,0x1BBD,0x1CF9,
							0x1E34,0x1F6F,0x20A8,0x21E1,0x2319,0x244F,0x2585,0x26B9,
							0x27EC,0x291F,0x2A50,0x2B80,0x2CAE,0x2DDC,0x2F08,0x3033,
							0x315C,0x3285,0x33AC,0x34D1,0x35F5,0x3718,0x383A,0x3959,
							0x3A78,0x3B95,0x3CB1,0x3DCB,0x3EE3,0x3FFA,0x4110,0x4224,
							0x4336,0x4447,0x4556,0x4664,0x4770,0x487A,0x4983,0x4A8A,
							0x4B90,0x4C94,0x4D96,0x4E97,0x4F96,0x5093,0x518F,0x5289,
							0x5381,0x5478,0x556D,0x5661,0x5752,0x5843,0x5931,0x5A1E,
							0x5B09,0x5BF3,0x5CDB,0x5DC1,0x5EA6,0x5F89,0x606A,0x614A,
							0x6228,0x6304,0x63DF,0x64B9,0x6590,0x6666,0x673B,0x680E,
							0x68DF,0x69AF,0x6A7D,0x6B4A,0x6C15,0x6CDF,0x6DA7,0x6E6E,
							0x6F33,0x6FF6,0x70B8,0x7179,0x7238,0x72F6,0x73B2,0x746D,
							0x7526,0x75DE,0x7695,0x774A,0x77FD,0x78B0,0x7960,0x7A10,
							0x7ABE,0x7B6B,0x7C16,0x7CC1,0x7D69,0x7E11,0x7EB7,0x7F5C,
							0x8000,0x80A2,
							};

typedef struct
	{
	DWORD        bV5Size;
	LONG         bV5Width;
	LONG         bV5Height;
	WORD         bV5Planes;
	WORD         bV5BitCount;
	DWORD        bV5Compression;
	DWORD        bV5SizeImage;
	LONG         bV5XPelsPerMeter;
	LONG         bV5YPelsPerMeter;
	DWORD        bV5ClrUsed;
	DWORD        bV5ClrImportant;
	DWORD        bV5RedMask;
	DWORD        bV5GreenMask;
	DWORD        bV5BlueMask;
	DWORD        bV5AlphaMask;
	DWORD        bV5CSType;
	CIEXYZTRIPLE bV5Endpoints;
	DWORD        bV5GammaRed;
	DWORD        bV5GammaGreen;
	DWORD        bV5GammaBlue;
	DWORD        bV5Intent;
	DWORD        bV5ProfileData;
	DWORD        bV5ProfileSize;
	DWORD        bV5Reserved;
	}BITMAPV5HEADER_;

//*****************************************************************************
//*
//*		SwapDword
//*
//*****************************************************************************

#if !defined(NO_ASM) && defined(_MSC_VER) && (_MSC_VER<1300) && defined(_M_IX86)

	#ifdef	   _MSC_VER
	#pragma		warning( push )
	#pragma		warning( disable :4035 )
	#endif

	static inline unsigned SwapDword(unsigned uValue)
	{
	_asm{
		mov		eax,uValue
		bswap	eax;
		}
	}

	#ifdef	   _MSC_VER
	#pragma		warning( pop )
	#endif

#elif !defined(NO_ASM) && defined(_MSC_VER)

	static inline unsigned SwapDword(unsigned uValue)
	{
		return _byteswap_ulong(uValue);
	}

#else

	static inline unsigned SwapDword(unsigned uValue)
	{
		return ((uValue&0xFF000000)>>24)|((uValue&0x00FF0000)>>8)|((uValue&0x0000FF00)<<8)|((uValue&0x000000FF)<<24);
	}

#endif

//*****************************************************************************
//*
//*		CopyLineL
//*
//*****************************************************************************
//	Kopiert Bits aus einer Zeile von Farben.
//	Dabei werden DWORD's aufsteigent kopiert.
//	iStart		: Ist das Startbit. Wenn kleiner 0 werden low Bits am
//				  Anfang eingefgt.
//	iCount		: Ist die Anzahl der zu koierenten DWORD's nach pTarget.
//	pSource		: Ist der Zeiger auf das erste DWORD
//	pTarget		: Ist der Zeiger auf das erste DWORD im Ziel
//	iSize		: Ist die Breite der (pSource) Zeile in Bits
//				  Bei 0 werden die Bits auf 0 gesetzt.
//				  Wenn die Make ungleich 0 ist wird um ein DRORD mehr koppiert

#if !defined(NO_ASM) && defined(_MSC_VER) && defined(_M_IX86)

	__declspec(naked) void __fastcall CopyLineL(int iStart,int iCount,unsigned *pSource,unsigned *pTarget,int iSize)
	{
	_asm{
		cmp		edx,0									;//	Prfe Zielgre
		jle		Exit									;//			*

		push	ebx										;// Register retten
		push	esi										;//			*
		push	edi										;//			*
		push	0xFFFFFFFF								;//	Speicher fr die Maske
	//	mov		edx,iCount;								;// Anzahl der DWORD's
	//	mov		ecx,iStart;								;// Anzahl der DWORD's
		mov		esi,[esp+20]			;pSource		;// Zeiger auf die Quelle
		mov		edi,[esp+24]			;pTarget		;// Zeiger auf das Ziel

		mov		ebx,dword ptr [esp+28]	;iSize			;// Breite nach EBX
		cmp		ecx,ebx									;// iStart>=iSize
		jge		Rest									;//			*
		cmp		ebx,0									;//	iSize<=0
		jle		Rest									;//			*

		test	ebx,0x1F								;//	Maske erstellen
		jz		Zero									;//			*
		xchg	ebx,ecx									;//			*
		mov		eax,0xFFFFFFFF							;//			*
		shr		eax,cl									;//			*
		not		eax										;//			*
		xchg	ebx,ecx									;//			*
		mov		dword ptr [esp],eax						;//			*
	Zero:
		cmp		ecx,-31									;// Leerraum vor dem Begin
		jge		Done									;//			*
		xor		eax,eax									;//			*
		add		ecx,31									;//			*
	Null:
		stosd											;//	Speichere 0
		sub		edx,1									;// Alles gespeichert
		jle		Ende									;//			*
		add		ecx,32									;//			*
		jnc		Null									;//			*
		sub		ecx,31									;//			*
	Done:
		test	ecx,0x1F								;// Kein Vershub ?
		jnz		Jump									;//			*

	;//*************** Kopieren ohne Vershub **********************************

		mov		eax,ecx									;//	pSource += iStart/32
		sub		ebx,ecx									;//	iSize   -= iStart
		shr		eax,5									;//			*
		lea		esi,[esi+eax*4];						;//			*
	Copy:
		lodsd											;// Kopiere nchstes DWORD
		sub		ebx,32									;// Ende erreicht
		jle		Stop									;//			*
		stosd											;//			*
		dec		edx										;// Gibt es weitere DWORD's
		jnle	Copy									;//			*
		jmp		Ende									;//			*
	Stop:
		mov		ebx,dword ptr [esp]		;Mask			;//	EAX &= Mask
		bswap	ebx										;//			*
		and		eax,ebx									;//			*
		stosd											;//			*
		dec		edx										;// Gibt es weitere DWORD
		jle		Ende									;//			*
		jmp		Rest									;//	Hinteren Leerraum kopierm

	;//*************** Kopieren mit Verschub **********************************

	Jump:
		cmp		ecx,0									;// if(iSize>=32)
		jge		Step									;//			*

		lodsd											;// Lade erstes DWORD
		bswap	eax										;//			*
		sub		dword ptr [esp+28],32	;iSize			;// if(iSize>=32)
		mov		ebx,0									;//			*
		jge		Save									;//	0:M		*
		and		eax,dword ptr [esp]		;Mask			;//	EAX &= Mask
		jmp		Mask									;//			*
	Step:
		mov		eax,ecx									;//	iSize -= iStart&0x1F
		and		eax,~0x1F								;//			*
		sub		dword ptr [esp+28],eax	;iSize			;//			*
		shr		eax,3									;//	pSource += iStart/32;
		add		esi,eax									;//			*
		lodsd											;// Lade erstes DWORD
		bswap	eax										;//			*
		sub		dword ptr [esp+28],32	;iSize			;// if(iSize>=32)
		mov		ebx,eax									;//			*
		jg		Next									;//			*
		mov		eax,0									;//			*
		je		Mask									;//			*
		and		ebx,dword ptr [esp]		;Mask			;//	EAX &= Mask
		jmp		Last									;//			*

	Load:
		lodsd											;//	Lade das nchste DWORD
		bswap	eax										;//			*
	Save:
		shld	ebx,eax,cl								;// EBX:EAX <<= CL
		xchg	ebx,eax									;// Speichere EBX
		bswap	eax										;//			*
		stosd											;//			*
		dec		edx										;// Weitere DWORD's laden
		jle		Ende									;//			*
	Next:
		sub		dword ptr [esp+28],32	;iSize			;//	while(iSize>=32)
		jnb		Load									;//			*

		cmp		dword ptr [esp+28],-32	;iSize			;//	if(iSize>=32)
		mov		eax,0									;//			*
		jle		Mask									;//			*
		lodsd											;//	Lade das letztes DWORD mit Maske
		bswap	eax										;//			*
		and		eax,dword ptr [esp]		;Mask			;//	EAX &= Mask

	Mask:
		shld	ebx,eax,cl								;// EBX:EAX <<= CL
		xchg	ebx,eax									;// Speichere EBX
		bswap	eax										;//			*
		stosd											;//			*
		dec		edx										;// Weitere DWORD's laden
		jle		Ende									;//			*
		xor		eax,eax									;//			*
	Last:
		shld	ebx,eax,cl								;// EBX:EAX <<= CL
		xchg	ebx,eax									;// Speichere EBX
		bswap	eax										;//			*
		stosd											;//			*
		dec		edx										;// Weitere DWORD's laden
		jle		Ende									;//			*

	;//************************************************************************

	Rest:
		xor		eax,eax									;// Leerraum am Ende
		mov		ecx,edx									;//			*
		rep		stosd									;//			*
	Ende:
		pop		eax										;// Speicher fr die Maske
		pop		edi										;// Register wiederherstellen
		pop		esi										;//			*
		pop		ebx										;//			*
	Exit:
		ret		12										;//	Zurck springen
		}
	}

#else

	static void CopyLineL(int iStart,int iCount,unsigned *pSource,unsigned *pTarget,int iSize)
	{
	unsigned __int64	uBits;
	unsigned			uMask;

	if(iCount<=0)										// Prfe Zielgre
		{
		return;
		}

	if(iSize<=0 || iStart>=iSize)						// Keine Bilddaten zum Ausgeben
		{
		goto Rest;
		}

	while(iStart<-31)									// Leerraum vor dem Begin
		{
		iStart    += 32;
		pTarget[0] = 0;
		pTarget   += 1;
		iCount    -= 1;
		if(iCount<=0)return;
		}

	if((iStart&0x1F)==0)								// Nicht verschieben
		{
		pSource += iStart/32;
		iSize   -= iStart;

		while(iSize>=32)								// DWORD's kopieren
			{
			pTarget[0]  = pSource[0];
			iCount     -= 1;
			if(iCount<=0)return;
			pTarget    += 1;
			pSource    += 1;
			iSize      -= 32;
			}

		if(iSize>0)										// Letztes DWORD mit Maske
			{
			uMask		= 0xFFFFFFFF>>iSize;
			pTarget[0]  = pSource[0]&SwapDword(~uMask);
			pTarget    += 1;
			iCount     -= 1;
			}
		}
	else{												// Mit Verschub kopieren
		if(iStart<0)
			{
			iStart     &= 0x1F;

			if(iSize<32)
				{
				uMask	= 0xFFFFFFFF>>iSize;
				uBits   = SwapDword(pSource[0])&~uMask;
				goto Save;
				}

			uBits	    = SwapDword(pSource[0]);
			pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
			iCount     -= 1;
			if(iCount<=0)return;
			pSource    += 1;
			pTarget    += 1;
			iSize      -= 32;
			uBits     <<= 32;
			}
		else{
			pSource	   += iStart/32;
			iSize	   -= iStart&~0x1F;
			iStart     &= 0x1F;

			if(iSize<32)
				{
				uMask	= 0xFFFFFFFF>>iSize;
				uBits   = SwapDword(pSource[0])&~uMask;
				uBits <<= 32;
				goto Save;
				}

			uBits		= SwapDword(pSource[0]);
			uBits     <<= 32;
			iSize	   -= 32;
			pSource    += 1;
			}

		while(iSize>=32)								// DWORD's ohne Masken
			{
			uBits	   |= SwapDword(pSource[0]);
			pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
			iCount     -= 1;
			if(iCount<=0)return;
			pSource    += 1;
			pTarget    += 1;
			iSize      -= 32;
			uBits     <<= 32;
			}

		if(iSize>0)										// Letztes DWORD mit Maske
			{
			uMask		= 0xFFFFFFFF>>iSize;
			uBits	   |= SwapDword(pSource[0])&~uMask;
			}
	Save:

		pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
		pTarget    += 1;
		iCount     -= 1;
		if(iCount<=0)return;
		uBits     <<= 32;
		pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
		pTarget    += 1;
		iCount     -= 1;
		}

	Rest:

	while(iCount>0)										// Leerraum am Ende
		{
		pTarget[0]  = 0;
		pTarget    += 1;
		iCount     -= 1;
		}
	}

#endif

//*****************************************************************************
//*
//*		CopyLineR
//*
//*****************************************************************************
//	Kopiert eine Zeile von Farben, mit einen Bitverschub nach links von der
//	Quelle. Dabei werden die DWORD's absteigent kopiert.
//	iStart		: Ist das Startbit. Wenn kleiner 0 werden low Bits am
//				  Anfang eingefgt.
//	iCount		: Ist die Anzahl der zu koierenten DWORD's nach pTarget.
//	pSource		: Ist der Zeiger auf das erste DWORD
//	pTarget		: Ist der Zeiger auf das erste DWORD im Ziel
//	iSize		: Ist die Breite der (pSource) Zeile in Bits
//				  Bei 0 werden die Bits auf 0 gesetzt.
//				  Wenn die Make ungleich 0 ist wird um ein DRORD mehr koppiert

#if !defined(NO_ASM) && defined(_MSC_VER) && defined(_M_IX86)

	__declspec(naked) void __fastcall CopyLineR(int iStart,int iCount,unsigned *pSource,unsigned *pTarget,int iSize)
	{
	_asm{
		cmp		edx,0									;//	Prfe Zielgre
		jle		Exit									;//			*

		push	ebx										;// Register retten
		push	esi										;//			*
		push	edi										;//			*
		push	0xFFFFFFFF								;//	Speicher fr die Maske
		std												;//	Richtung abwrts
	//	mov		edx,iCount;								;// Anzahl der DWORD's
	//	mov		ecx,iStart;								;// Anzahl der DWORD's
		mov		esi,[esp+20]	;pSource				;// Zeiger auf die Quelle
		mov		edi,[esp+24]	;pTarget				;// Zeiger auf das Ziel

		lea		edi,[edi+edx*4-4]						;// pTarget += iCount-1;

		mov		ebx,dword ptr [esp+28]	;iSize			;// Breite nach EBX
		cmp		ecx,ebx									;// iStart>=iSize
		jge		Rest									;//			*
		cmp		ebx,0									;//	iSize<=0
		jle		Rest									;//			*

		shl		edx,5									;//	iStart += iCount*32;
		add		ecx,edx									;//			*
		shr		edx,5									;//			*
		cmp		ebx,ecx									;//	if(iSize>=iStart)
		jge		Same									;//			*
		add		ebx,32									;// EBX = iSize-32
		xor		eax,eax									;//			*
	Null:
		cmp		ecx,ebx									;// if(iStart-32<iSize)break;
		jl		Done
		stosd											;//	pTarget[0] = 0;
		sub		edx,1									;// if(iCount<=0)return;
		jle		Ende									;//			*
		sub		ecx,32									;//			*
		jmp		Null									;//			*
	Same:
		cmp		ecx,0									;//	if(iStart<0)
		jle		Rest									;//
		mov		dword ptr [esp+28],ecx	;iSize			;//	iSize = iStart
		mov		ebx,ecx									;//			*
	Done:
		test	ebx,0x1F								;//	Maske erstellen
		jz		Zero									;//			*
		xchg	ebx,ecx									;//			*
		mov		eax,0xFFFFFFFF							;//			*
		shr		eax,cl									;//			*
		not		eax										;//			*
		xchg	ebx,ecx									;//			*
		mov		dword ptr [esp],eax		;Mask			;//			*
	Zero:
		mov		ebx,ecx									;// pSource += iStart/32;
		shr		ebx,5									;//			*
		lea		esi,[esi+ebx*4]							;//			*
		test	ecx,0x1F								;// Kein Vershub ?
		jnz		Jump									;//			*

	;//*************** Kopieren ohne Vershub **********************************

		sub		esi,4									;// pSource -= 1
		mov		ebx,dword ptr [esp+28]	;iSize			;//	EBX = iSize

		test	ebx,0x1F								;// if(!(iSize&0x1F))
		jz		Copy									;//			*
		lodsd											;// Kopiere letzes DWORD mit Maske
		mov		ecx,dword ptr [esp]		;Mask			;//	ECX = SwapDword(Mask)
		bswap	ecx										;//			*
		and		eax,ecx									;//			*
		stosd											;//			*
		sub		edx,1									;// if(iCount<=0)return;
		jle		Ende									;//			*
	Copy:
		sub		ebx,32									;// if(iSize<32)
		jl		Rest									;//			*
		lodsd											;// Kopiere nchstes DWORD
		stosd											;//			*
		sub		edx,1									;// if(iCount<=0)return;
		jg		Copy									;//			*
		jmp		Ende

	;//************************************************************************

	Jump:
		mov		ebx,dword ptr [esp+28]	;iSize			;// EBX = iSize
		cmp		ecx,ebx									;// if(iStart<=iSize)
		jle		Step									;//			*
		dec		ebx										;// if(iStart^(iSize-1))&~0x1F)
		xor		ebx,ecx									;//			*
		test	ebx,~0x1F								;//			*
		jz		Step									;//			*

		sub		esi,4									;//	pSource -= 1;
		neg		ecx										;//	iStart = -iStart
		lodsd											;// Lade erstes DWORD
		bswap	eax										;//			*
		and		eax,dword ptr [esp]		;Mask			;//	EAX &= Mask
		xor		ebx,ebx									;//	M:0	in (A:B)
		shrd	ebx,eax,cl								;// EAX:EBX >>= -CL
		xchg	ebx,eax									;//	M:_ in (B:A)
		bswap	eax										;//			*
		stosd											;//	Save (EAX:EBX>>-iStart)
		sub		edx,1									;// if(iCount<=0)return;
		jle		Ende									;//			*
		sub		dword ptr [esp+28],32	;iSize			;//	iSize -= 32
		jg		Load									;//	if(iSize>0)
		jmp		Stop									;//			*
	Step:
		neg		ecx										;//	iStart = -iStart
		lodsd											;// Lade erstes DWORD
		bswap	eax										;//			*
		and		eax,dword ptr [esp]		;Mask			;//	EAX &= Mask
		test	dword ptr [esp+28],0x1F	;iSize			;//	if(iSize&0x1F))
		mov		ebx,eax									;//	_:* in (A:B)
		jz		Next									;//			*
		cmp		dword ptr [esp+28],31	;iSize			;//	if(iSize<0)
		jle		Stop									;//			*
		and		dword ptr [esp+28],~0x1F;iSize			;//			*

	Load:
		lodsd											;// Lade DWORD _:* in (A:B)
		bswap	eax										;//	_:* zu *:* in (A:B)
		xchg	ebx,eax									;//	*:* in (B:A)
		shrd	eax,ebx,cl								;// EAX:EBX >>= -CL
		bswap	eax										;//			*
		stosd											;//	*:_	in (B:A)
		sub		edx,1									;// if(iCount<=0)return;
		jle		Ende									;//			*
	Next:
		sub		dword ptr [esp+28],32	;iSize			;//	iSize -= 32
		jg		Load									;//	while(iSize>0)
		mov		eax,ebx									;//	_:* in (B:A)

	Stop:
		xor		eax,eax									;// 0:*  (A:B)
		shrd	ebx,eax,cl								;// EAX:EBX >>= -CL
		bswap	ebx										;//			*
		mov		eax,ebx									;//			*
		stosd											;//	Save (EAX:EBX>>-iStart)
		sub		edx,1									;// if(iCount<=0)return;
		jle		Ende									;//			*

	;//************************************************************************

	Rest:
		xor		eax,eax									;// Leerraum am Ende
		mov		ecx,edx									;//			*
		rep		stosd									;//			*
	Ende:
		cld												;//	Richtung aufwrts
		pop		eax										;// Speicher fr die Maske
		pop		edi										;// Register wiederherstellen
		pop		esi										;//			*
		pop		ebx										;//			*
	Exit:
		ret		12										;//	Zurck springen
		}
	}

#else

	static void CopyLineR(int iStart,int iCount,unsigned *pSource,unsigned *pTarget,int iSize)
	{
	unsigned __int64	uBits;
	unsigned			uMask;

	if(iCount<=0)										// Prfe Zielgre
		{
		return;
		}

	pTarget += iCount-1;

	if(iSize<=0 || iStart>=iSize)						// Keine Bilddaten zum Ausgeben
		{
		goto Rest;
		}

	iStart	+= iCount*32;

	if(iStart<=0)
		{
		goto Rest;
		}

	if(iSize>=iStart)
		{
		iSize	= iStart;
		}
	else for(;;)										// Leerraum am Ende
		{
		if(iStart-32<iSize)break;
		pTarget[0] = 0;
		iCount    -= 1;
		if(iCount<=0)return;
		pTarget   -= 1;
		iStart    -= 32;
		}

	pSource += iStart/32;

	if((iStart&0x1F)==0)								// Nicht verschieben
		{
		pSource    -= 1;

		if(iSize&0x1F)									// Letztes DWORD mit Maske
			{
			uMask		= 0xFFFFFFFF>>iSize;
			pTarget[0]  = pSource[0]&SwapDword(~uMask);
			pTarget    -= 1;
			pSource    -= 1;
			iCount     -= 1;
			if(iCount<=0)return;
			}

		while(iSize>=32)								// DWORD's kopieren
			{
			pTarget[0]  = pSource[0];
			iCount     -= 1;
			if(iCount<=0)return;
			pTarget    -= 1;
			pSource    -= 1;
			iSize      -= 32;
			}
		}
	else if(iSize>0 && iStart>0)						// Mit Verschub kopieren
		{
		if(iStart>iSize && (iStart^(iSize-1))&~0x1F)
			{
			pSource    -= 1;
			iStart	   &= 0x1F;
			uBits		= SwapDword(pSource[0]);		// Letztes DWORD mit Maske

			if(iSize&0x1F)
				{
				uMask	= 0xFFFFFFFF>>iSize;
				uBits  &= ~uMask;
				}

			uBits	  <<= 32;
			pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
			iCount     -= 1;
			if(iCount<=0)return;
			pTarget    -= 1;
			pSource    -= 1;
			iSize	   -= 32;
			uBits	  >>= 32;
			}
		else{
			uBits	    = SwapDword(pSource[0]);
			iStart	   &= 0x1F;
			pSource    -= 1;

			if(iSize&0x1F)
				{
				uMask	= 0xFFFFFFFF>>iSize;
				uBits  &= ~uMask;
				iSize  &= ~0x1F;
				}
			else{
				iSize  -= 32;
				}
			}

		while(iSize>0)									// DWORD's ohne Masken
			{
			uBits	   |= (__int64)(SwapDword(pSource[0]))<<32;
			pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
			iCount     -= 1;
			if(iCount<=0)return;
			pSource    -= 1;
			pTarget    -= 1;
			iSize      -= 32;
			uBits     >>= 32;
			}

		pTarget[0]  = SwapDword((unsigned)((uBits<<iStart)>>32));
		pTarget    -= 1;
		iCount     -= 1;
		}

	Rest:

	while(iCount>0)										// Leerraum am Begin
		{
		pTarget[0]  = 0;
		pTarget    -= 1;
		iCount     -= 1;
		}
	}

#endif

//*****************************************************************************
//*
//*		BitmapImageCoder
//*
//*****************************************************************************
BitmapImageCoder::BitmapImageCoder()
{
	pComment=0;
	Initialize();
}

//*****************************************************************************
//*
//*		BitmapImageCoder
//*
//*****************************************************************************
BitmapImageCoder::~BitmapImageCoder()
{
	SetComment((char*)0);
}

//*****************************************************************************
//*
//*		DoCopy
//*
//*****************************************************************************
void BitmapImageCoder::DoCopy(const BitmapImageCoder &sSource)
{

	pProgressProc	= sSource.pProgressProc;
	pProgressData   = sSource.pProgressData;
	iCommentLen		= sSource.iCommentLen;
	pComment		= new char [sSource.iCommentLen+1];

	memcpy(pComment,sSource.pComment,iCommentLen);
	pComment[iCommentLen]=0;
}

//*****************************************************************************
//*
//*		Initialize
//*
//*****************************************************************************
void BitmapImageCoder::Initialize()
{
	if(pComment)delete pComment;
	pProgressProc	= 0;
	pProgressData   = 0;
	pComment		= 0;
	iCommentLen		= 0;
};

//*****************************************************************************
//*
//*		SetComment
//*
//*****************************************************************************
//	Stellt den Text fr den Kommentar ein
//	pText		: Ist der Zeiger auf den neuen Kommentar
//	Ergibt den Zeiger auf den Textpuffer fr den Kommentar
char *BitmapImageCoder::SetComment(const char *pText)
{

	if(pComment)
		{
		delete pComment;
		pComment	= 0;
		iCommentLen	= 0;
		}

	if(pText)
		{
		iCommentLen = (int)strlen(pText)+1;
		pComment	= new char[iCommentLen];
		memcpy(pComment,pText ,iCommentLen);
		}


return pComment;
}

//*****************************************************************************
//*
//*		SetComment
//*
//*****************************************************************************
char *BitmapImageCoder::SetComment(const wchar_t *pText)
{
char   *pTemp;
int		iLen;
int		iPos;



	iLen	= wcslen(pText)+1;
	pTemp	= new char[iLen+1];

	for(iPos=0;iPos<iLen;iPos++)
		{
		if(pText[iPos]&0xFF000)
				pTemp[iPos]='\xFF';
		else	pTemp[iPos]=(char)pText[iPos];
		}


return SetComment(pTemp);
}

//*****************************************************************************
//*
//*		Square
//*
//*****************************************************************************
static inline int Square(int iVal)
{
	return iVal*iVal;
}

//*****************************************************************************
//*
//*		SinInt
//*
//*****************************************************************************
//	Berechnet einen Integer-Sinus
//	iAngel		: Ist der Winkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	Ergibt den Sinus multipliziert mit 0x10000 als Ganzzahl.
static int SinInt(int iAngel)
{
int			iVal1;
int			iVal2;
int			iSub;
int			iIdx;


	iIdx  =  iAngel&0xFFFF;

	if(iIdx&0x8000)
		{
		iIdx = 0x10000-iIdx;
		}

	iSub  =  iIdx&0xFF;
	iIdx /=  0x100;


	iVal1 =  SIN[iIdx  ];
	iVal2 =  SIN[iIdx+1];

	if(iAngel&0x10000)
		{
		iVal1 = -iVal1;
		iVal2 = -iVal2;
		}

	if(iSub==0)
		{
		return iVal1*2;
		}

	iVal2 *=      iSub;
	iVal1 *=  256-iSub;


return (iVal1+iVal2)/128;
}

//*****************************************************************************
//*
//*		CosInt
//*
//*****************************************************************************
//	Berechnet einen Integer-Cosinus
//	iAngel		: Ist der Winkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	Ergibt den Sinus multipliziert mit 0x10000 als Ganzzahl.
static inline int CosInt(int iAngel)
{
return SinInt(iAngel+0x8000);
}

//*****************************************************************************
//*
//*		ArcInt
//*
//*****************************************************************************
//	Berechnet der Arcus-Tangens als Integer
//	iValX/Y		: Vom Wert Y/X wir der Arcus-Tangens berechnet.
//	Ergibt den Winkel (0=0 90=0x8000 180=0x10000 360=0x20000)
int ArcInt(int iValY,int iValX)
{
unsigned	uNxt;
unsigned	uArc;
unsigned	uVal;
int			iAdd;
int			iDiv;


	iAdd = 0;
	iDiv = 2;

	if(iValY<0)
		{
		iValY = -iValY;
		iDiv  = -2;
		}

	if(iValX<0)
		{
		iAdd  =  0x20000;
		iValX = -iValX;
		iDiv  = -iDiv;
		}

	if(iValX<iValY)
		{
		uVal  =  iValX;
		iValX =  iValY;
		iValY =  uVal;

		iAdd -=  0x10000;
		iDiv  = -iDiv;
		}
	else if(iValX==0)
		{
		return 0;
		}

	if(iValY<0x00008000)
		{
		uVal = (iValY*0x10000)/iValX;
		}
	else if(iValY<0x00080000)
		{
		uVal = (iValY*0x1000)/(iValX/0x10);
		}
	else if(iValY<0x00800000)
		{
		uVal = (iValY*0x100)/(iValX/0x100);
		}
	else if(iValY<0x08000000)
		{
		uVal = (iValY*0x10)/(iValX/0x1000);
		}
	else{
		uVal = (iValY)/(iValX/0x10000);
		}

	uArc  = ARC_ARRAY[uVal/0x200  ];
	uNxt  = ARC_ARRAY[uVal/0x200+1];
	uArc += ((uNxt-uArc)*(uVal&0x1FF))/0x200;



return ((int)(uArc+iAdd)/iDiv)&0x1FFFF;
}

//*****************************************************************************
//*
//*		ValueFrom
//*
//*****************************************************************************
//	Berechnet den positiven Betrag einer Zahl
//	iValue		: Ist die Zahl
//	Ergibt den positiven Betrag.
static int ValueFrom(int iValue)
{
	if(iValue>=0)return iValue;

return -iValue;
}

//*****************************************************************************
//*
//*		RoundRow
//*
//*****************************************************************************
static inline unsigned RoundRow(unsigned uWidth)
{
unsigned uResult;


	uResult = (uWidth+BitmapImage::RowRounding-1) & ~(BitmapImage::RowRounding-1);


return uResult;
}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
BitmapImage::BitmapImage()
{
char *pBuffer;

   	pUserPtr		= 0;
	pBuffer      	= new char[BMI_SIZE];
	pBitmapInfo  	= (BITMAPINFO   *) pBuffer;
	pColorMap	 	= (ColorMapEntry*)&pBitmapInfo->bmiColors;
	pColorUsage	 	= 0;
	pColorAreas  	= 0;

	pImageMem	 	= 0;
	pImageRow	 	= 0;
	pImageData	 	= 0;
	pImageBase		= 0;
	uImageWidth	 	= 0;
	uImageHeight 	= 0;

	pSet0		 	= 0;
	pSet1		 	= 0;
	hBitmap			= 0;
	uDelData		= 0;
	cTextAlignX	 	= 0;
	cTextAlignY	 	= 0;
	pActualFont	 	= 0;
	uAreaCount	 	= 0;
	uMaskDotted		= 0xAAAAAAAA;
	uMaskDashed		= 0xF0F0F0F0;
	iTextHole		= TEXT_AUTOSPACE;

	pProgressProc	= NULL ;
	pProgressData   = NULL ;

	ClearData();

}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
BitmapImage::BitmapImage(const BitmapImage &sSource)
{

	BitmapImage();
	DoCopy(sSource);

}

//*****************************************************************************
//*
//*		operator=
//*
//*****************************************************************************
BitmapImage &BitmapImage::operator=(const BitmapImage &sSource)
{

	DoCopy(sSource);


return *this;
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
BitmapImage::~BitmapImage()
{

	if(pBitmapInfo           )delete pBitmapInfo;
	if(pImageMem && !uDelData)delete pImageMem;
	if(pImageRow &&  uDelData)delete pImageRow;

}

//*****************************************************************************
//*
//*		ClearData
//*
//*****************************************************************************
void BitmapImage::ClearData()
{

	if(pColorUsage){delete pColorUsage;pColorUsage = 0;}
	if(pColorAreas){delete pColorAreas;pColorAreas = 0;}
	if(pImageMem  )
		{
		if(!uDelData)delete pImageMem;
		pImageData = 0;
		pImageMem  = 0;
		}

	if(uDelData && pImageRow)
		{
		delete pImageRow;
		}

	if(hBitmap)
		{
		#ifdef	WIN32
		DeleteObject(hBitmap);
		#endif
		hBitmap		= 0;
		}

	pImageRow		= 0;
	uImageBits		= 0;
	uImageSize		= 0;
	pImageData		= 0;
	uImageWidth		= 0;
	uImageHeight	= 0;
	uColorCount		= 0;
	pColorUsage		= 0;
	pColorAreas		= 0;
	uAreaCount		= 0;
	uDelData		= 0;
	cLastError		= 0;

	Get1Row_		= Get1Row0;
	Get3Row_		= Get3Row0;
	Get4Row_    	= Get4Row0;
	Get1RowT_   	= Get1Row0;
	Get3RowT_   	= Get3Row0;
	Get4RowT_   	= Get4Row0;
	GetPixel_   	= GetPixel0;
	SetPixel_   	= SetPixel0;
	RgbToPixel_ 	= RgbToPixel0;

	memset(pBitmapInfo,0,BMI_SIZE);

}

//*****************************************************************************
//*
//*		GetPixel??? Funktionen
//*
//*****************************************************************************
//	Holt aus einer Bild Reihe die Pixel Nummer an der Stelle uPosX

unsigned BitmapImage::GetPixel0(unsigned char *pRow,unsigned uPosX)
	{
	return 0;
	}

unsigned BitmapImage::GetPixel1(unsigned char *pRow,unsigned uPosX)
	{
	return (pRow[uPosX>>3]>>(~uPosX&0x07))&0x01;
	}

unsigned BitmapImage::GetPixel2(unsigned char *pRow,unsigned uPosX)
	{
	return (pRow[uPosX>>2]>>((~uPosX&0x03)<<1))&0x03;
	}

unsigned BitmapImage::GetPixel4(unsigned char *pRow,unsigned uPosX)
	{
	return (pRow[uPosX>>1]>>((~uPosX&0x01)<<2))&0x0F;
	}

unsigned BitmapImage::GetPixel8(unsigned char *pRow,unsigned uPosX)
	{
	return   pRow[uPosX];
	}

unsigned BitmapImage::GetPixel12(unsigned char *pRow,unsigned uPosX)
	{
	unsigned uVal;
	pRow += ((uPosX>>1)<<1)+(uPosX>>1);
	uVal  = GET_DW(pRow);
	return C12_TO_RGB(uVal,uPosX);
	}

unsigned BitmapImage::GetPixel15(unsigned char *pRow,unsigned uPosX)
	{
	uPosX=((unsigned short*)pRow)[uPosX];
	return C15_TO_RGB(uPosX);
	}

unsigned BitmapImage::GetPixel16(unsigned char *pRow,unsigned uPosX)
	{
	uPosX=((unsigned short*)pRow)[uPosX];
	return C16_TO_RGB(uPosX);;
	}

unsigned BitmapImage::GetPixel24(unsigned char *pRow,unsigned uPosX)
	{
	return P24_TO_RGB(pRow+uPosX+(uPosX<<1));
	}

unsigned BitmapImage::GetPixel32(unsigned char *pRow,unsigned uPosX)
	{
	return P32_TO_RGB(((unsigned*)pRow)+uPosX);
	}

//*****************************************************************************
//*
//*		RgbToPixel??? Funktionen
//*
//*****************************************************************************
//	Wandelt einen RGB-Wert in einen Pixel um

unsigned  FC BitmapImage::RgbToPixel0 (COLORRGB uColor){return uColor;}
unsigned  FC BitmapImage::RgbToPixel1 (COLORRGB uColor){return uColor;}
unsigned  FC BitmapImage::RgbToPixel2 (COLORRGB uColor){return uColor;}
unsigned  FC BitmapImage::RgbToPixel4 (COLORRGB uColor){return uColor;}
unsigned  FC BitmapImage::RgbToPixel8 (COLORRGB uColor){return uColor;}
unsigned  FC BitmapImage::RgbToPixel12(COLORRGB uColor){return RGB_TO_C12(uColor);}
unsigned  FC BitmapImage::RgbToPixel15(COLORRGB uColor){return RGB_TO_C15(uColor);}
unsigned  FC BitmapImage::RgbToPixel16(COLORRGB uColor){return RGB_TO_C16(uColor);}
unsigned  FC BitmapImage::RgbToPixel24(COLORRGB uColor){return uColor;}
unsigned  FC BitmapImage::RgbToPixel32(COLORRGB uColor){return uColor;}

//*****************************************************************************
//*
//*		SetPixel??? Funktionen
//*
//*****************************************************************************
//	Speichert einen Pixel in der einer Bildzeile
//	pRow	: Ist der Zeiger auf die Bildzeile
//	uPosX	: Ist die X-Koordinate in der Bildzeile
//	uPixel	: Ist der zu setzende Pixelwert

void BitmapImage::SetPixel0(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	}

void BitmapImage::SetPixel1(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow +=(uPosX>>3);
	uPixel=(uPixel&0x01)<<(~uPosX&0x07);
	uPosX  =     ~(0x01 <<(~uPosX&0x07));
	*pRow&=uPosX;
	*pRow|=uPixel;
	}

void BitmapImage::SetPixel2(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow   += (uPosX>>2);
	uPixel	= (uPixel&0x03)<<((~uPosX&0x03)<<1);
	uPosX	=       ~(0x03 <<((~uPosX&0x03)<<1));
	*pRow  &=  uPosX;
	*pRow  |=  uPixel;
	}

void BitmapImage::SetPixel4(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow+=(uPosX>>1);
	if(uPosX&1)*pRow=(unsigned char)((*pRow&0xF0)|((uPixel&0x0F)));
	else	   *pRow=(unsigned char)((*pRow&0x0F)|((uPixel&0x0F)<<4));
	}

void BitmapImage::SetPixel8(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow[uPosX]=(unsigned char)uPixel;
	}

void BitmapImage::SetPixel12(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow+=((uPosX>>1)<<1)+(uPosX>>1);
	if(uPosX&1)RGB_TO_P12H(uPixel,pRow)
	else  	 RGB_TO_P12L(uPixel,pRow)
	}

void BitmapImage::SetPixel15(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow+=(uPosX<<1);
	RGB_TO_P15(uPixel,pRow);
	}

void BitmapImage::SetPixel16(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow+=(uPosX<<1);
	RGB_TO_P16(uPixel,pRow);
	}

void BitmapImage::SetPixel24(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow+=uPosX+(uPosX<<1);
	RGB_TO_P24(uPixel,pRow);
	}

void BitmapImage::SetPixel32(unsigned char *pRow,unsigned uPosX,unsigned uPixel)
	{
	pRow+=(uPosX<<2);
	RGB_TO_P32(uPixel,pRow);
	}


//*****************************************************************************
//*
//*		Get1Row??? Funktionen
//*
//*****************************************************************************
//	Holt den Zeiger auf einer Bildzeile mit einem 8Bit Index je Bildpunkt.
//	Auer beim 8 Bit Modus sind die Zeilen temonrt und nur bis zum
//	nchsten Aufruf gltig.
//	pRow	: Ist der Zeiger auf die Bildzeile mit den originalen Daten
//	pImage	: Ist der Zeiger auf die Bilddaten
//	Ergibt einen Zeiger auf die INdex-Bildzeile

unsigned char* BitmapImage::Get1Row0(unsigned char *pRow,BitmapImage *pImage)
	{
	return (unsigned char*)"1234";
	}

unsigned char* BitmapImage::Get1Row1(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow++)
		{
		*pPtr=(unsigned char)((*pRow>>7)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>6)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>5)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>4)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>3)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>2)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>1)&1);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow   )&1);pPtr++;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get1Row2(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow++)
		{
		*pPtr=(unsigned char)((*pRow>>6)&3);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>4)&3);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow>>2)&3);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow   )&3);pPtr++;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get1Row4(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;


	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow++)
		{
		*pPtr=(unsigned char)((*pRow>>4)&0x0F);pPtr++;uCnt--;if(uCnt<=0)break;
		*pPtr=(unsigned char)((*pRow   )&0x0F);pPtr++;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get1Row8(unsigned char *pRow,BitmapImage *pImage)
	{
	return pRow;
	}

unsigned char* BitmapImage::Get1RowG(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCol;
	union 	{
			COLORRGB	    uColor;
			unsigned char	uRgb[4];
			unsigned char  *pPtr;
			}sTemp;

	pPtr	= pImage->pImageRow;
	uCol	= pImage->uImageWidth;

	while(uCol>0)
		{
		uCol--;
		sTemp.uColor = pImage->GetPixel_(pRow,uCol);
	   *pPtr = (unsigned char)RgbToGray(sTemp.uRgb[RedOffset],sTemp.uRgb[GreenOffset],sTemp.uRgb[BlueOffset]);
		pPtr++;
		}

	return pImage->pImageRow;
	}


//*****************************************************************************
//*
//*		Get3Row??? Funktionen
//*
//*****************************************************************************
//	Holt den Zeiger auf einer Bildzeile mit 3 Byte je Bildpunkt.
//	Das Format ist [0]=Blau,[1]=Grn,[2]=Rot, [3]=Blau,[4]=Grn,[5]=Rot, ...
//	Auer beim 24 Bit Modus sind die Zeilen temonrt und nur bis zum
//	nchsten Aufruf gltig.
//	pRow	: Ist der Zeiger auf die Bildzeile mit den originalen Daten
//	pImage	: Ist der Zeiger auf die Bilddaten
//	Ergibt einen Zeiger auf BGR-Bildzeile

unsigned char* BitmapImage::Get3Row0(unsigned char *pRow,BitmapImage *pImage)
	{
	return (unsigned char*)"1234";
	}

unsigned char* BitmapImage::Get3Row1(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--,pRow++)
		{
		SET_DW(pPtr,pMap[(*pRow>>7)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>6)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>5)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>4)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>3)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>2)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>1)&1]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow   )&1]);pPtr+=3;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row2(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--,pRow++)
		{
		SET_DW(pPtr,pMap[(*pRow>>6)&3]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>4)&3]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow>>2)&3]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow   )&3]);pPtr+=3;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row4(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--,pRow++)
		{
		SET_DW(pPtr,pMap[(*pRow>>4)&0x0F]);pPtr+=3;uCnt--;if(uCnt<=0)break;
		SET_DW(pPtr,pMap[(*pRow   )&0x0F]);pPtr+=3;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row8(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--)
		{
		SET_DW(pPtr,pMap[*pRow]);pPtr+=3;pRow++;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row12(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow+=3)
		{
		pPtr[0]=(unsigned char)((pRow[0]&0xF0));
		pPtr[1]=(unsigned char)((pRow[0]&0x0F)<<4);
		pPtr[2]=(unsigned char)((pRow[1]&0xF0));uCnt--;if(uCnt<=0)break;
		pPtr[3]=(unsigned char)((pRow[1]&0x0F)<<4);
		pPtr[4]=(unsigned char)((pRow[2]&0xF0));
		pPtr[5]=(unsigned char)((pRow[2]&0x0F)<<4);
		pPtr  +=6;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row15(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;
	unsigned		uVal;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow+=2)
		{
		uVal=*(unsigned short*)(pRow+0);
		SET_DW(pPtr,C15_TO_RGB(uVal));
		pPtr+=3;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row16(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;
	unsigned		uVal;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow+=2)
		{
		uVal=*(unsigned short*)(pRow+0);
		SET_DW(pPtr,C16_TO_RGB(uVal));
		pPtr+=3;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get3Row24(unsigned char *pRow,BitmapImage *pImage)
	{
	return (unsigned char*)pRow;
	}

unsigned char* BitmapImage::Get3Row32(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--)
		{
		SET_DW(pPtr,*(int*)pRow);
		pPtr+=3;
		pRow+=4;
		}

	return pImage->pImageRow;
	}

//*****************************************************************************
//*
//*		Get4Row??? Funktionen
//*
//*****************************************************************************
//	Holt den Zeiger auf einer Bildzeile mit 3 Byte je Bildpunkt.
//	Das Format ist [0]=Blau,[1]=Grn,[2]=Rot,[3]=---,[4]=Blau,[5]=Grn,[6]=Rot, ...
//	Auer beim 32 Bit Modus sind die Zeilen temonrt und nur bis zum
//	nchsten Aufruf gltig.
//	pRow	: Ist der Zeiger auf die Bildzeile mit den originalen Daten
//	pImage	: Ist der Zeiger auf die Bilddaten
//	Ergibt einen Zeiger auf BGR-Bildzeile

unsigned char* BitmapImage::Get4Row0(unsigned char *pRow,BitmapImage *pImage)
	{
	return (unsigned char*)"12345678";
	}

unsigned char* BitmapImage::Get4Row1 (unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--,pRow++)
		{
		*(int*)pPtr=pMap[(*pRow>>7)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>6)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>5)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>4)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>3)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>2)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>1)&1];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow   )&1];pPtr+=4;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row2(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--,pRow++)
		{
		*(int*)pPtr=pMap[(*pRow>>6)&3];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>4)&3];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow>>2)&3];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow   )&3];pPtr+=4;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row4(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--,pRow++)
		{
		*(int*)pPtr=pMap[(*pRow>>4)&0x0F];pPtr+=4;uCnt--;if(uCnt<=0)break;
		*(int*)pPtr=pMap[(*pRow   )&0x0F];pPtr+=4;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row8(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned	   *pMap;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;
	pMap	= (unsigned*)pImage->pColorMap;

	for(;uCnt>0;uCnt--)
		{
		*(int*)pPtr=pMap[*(unsigned char*)pRow];pPtr+=4;pRow++;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row12(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;


	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow+=3)
		{
		pPtr[0]=(unsigned char)((pRow[0]&0xF0));
		pPtr[1]=(unsigned char)((pRow[0]&0x0F)<<4);
		pPtr[2]=(unsigned char)((pRow[1]&0xF0));
		pPtr[3]=0;uCnt--;if(uCnt<=0)break;
		pPtr[4]=(unsigned char)((pRow[1]&0x0F)<<4);
		pPtr[5]=(unsigned char)((pRow[2]&0xF0));
		pPtr[6]=(unsigned char)((pRow[2]&0x0F)<<4);
		pPtr[7]=0;
		pPtr  +=8;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row15(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;
	unsigned		uVal;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow+=2)
		{
		uVal=*(unsigned short*)pRow;
		*(int*)pPtr=C15_TO_RGB(uVal);
		pPtr+=4;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row16(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;
	unsigned		uVal;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--,pRow+=2)
		{
		uVal=*(unsigned short*)pRow;
		*(int*)pPtr=C16_TO_RGB(uVal);
		pPtr+=4;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row24(unsigned char *pRow,BitmapImage *pImage)
	{
	unsigned char  *pPtr;
	unsigned		uCnt;

	pPtr	= pImage->pImageRow;
	uCnt	= pImage->uImageWidth;

	for(;uCnt>0;uCnt--)
		{
		*(int*)pPtr=P24_TO_RGB(pRow);
		pPtr+=4;
		pRow+=3;
		}

	return pImage->pImageRow;
	}

unsigned char* BitmapImage::Get4Row32(unsigned char *pRow,BitmapImage *pImage)
	{
	return pRow;
	}

unsigned char* BitmapImage::GetTRow(unsigned char *pRow,BitmapImage *pImage)
	{
	return (unsigned char*)memcpy(pImage->pImageRow,pRow,pImage->uRowWidth);
	}

//*****************************************************************************
//*
//*		SwapRGB?
//*
//*****************************************************************************
//	Tauscht die Farben von RGB auf BGR und umgekerrt
void BitmapImage::SwapRGB4(unsigned char *pRow,int Count)
	{
	unsigned char ucTemp;


	for(;Count>0;Count--,pRow+=4)
		{
		ucTemp  = pRow[0];
		pRow[0] = pRow[2];
		pRow[2] = ucTemp;
		}
	}

void BitmapImage::SwapRGB3(unsigned char *pRow,int Count)
	{
	unsigned char ucTemp;

	for(;Count>0;Count--,pRow+=3)
		{
		ucTemp  = pRow[0];
		pRow[0] = pRow[2];
		pRow[2] = ucTemp;
		}
	}


//*****************************************************************************
//*
//*		DoCopy
//*
//*****************************************************************************
//	Kopiert ein Bild
//	sSource		: Ist das Urspriungsbild das kopiert werden soll
void BitmapImage::DoCopy(const BitmapImage &sSource)
{

	ClearData();

	pProgressProc = sSource.pProgressProc;
	pProgressData = sSource.pProgressData;

	if(!SetSize(sSource.uImageBits,sSource.uImageWidth,sSource.uImageHeight,BI_NOT_INIT))
		{
		return;
		}

	memcpy(pBitmapInfo,sSource.pBitmapInfo,BMI_SIZE);
	memcpy(pImageData ,sSource.pImageData ,sSource.uImageSize);

}

//*****************************************************************************
//*
//*		Rotate
//*
//*****************************************************************************
//	Rotiert ein Bild
//	iMode	: Wie soll rotiert werden
//				0 =   0 im Uhrzeigersinn
//				1 =  90 im Uhrzeigersinn
//				2 = 180 im Uhrzeigersinn
//				3 = 270 im Uhrzeigersinn
//	iSwapX	: Um X-Achse spiegeln
//	iSwapY	: Um Y-Achse spiegeln
//	Ergibt TRUE wenn Bild erzeugt wurde.
bool BitmapImage::Rotate(const BitmapImage &sSource,int iMode,int iSwapX,int iSwapY)
{
unsigned	uPixel;
unsigned	uPosX;
unsigned	uPosY;
int			iAddX;
int			iAddY;
int			iOffX;
int			iOffY;
int			iSetX;
int			iSetY;


	iMode &=3;

	if(iMode&1)
		{
		if(!SetSize(sSource.uImageBits,sSource.uImageHeight,sSource.uImageWidth,BI_NOT_INIT))
			{
			return false;
			}

		if(iMode==3)
			{
			iSwapX=!iSwapX;
			}
		else{
			iSwapY=!iSwapY;
			}

		if(iSwapY)
			{
			iAddX = -1;
			iOffX =  sSource.uImageHeight-1;
			}
		else{
			iAddX =  1;
			iOffX =  0;
			}

		if(iSwapX)
			{
			iAddY = -1;
			iSetY =  sSource.uImageWidth-1;
			}
		else{
			iAddY =  1;
			iSetY =  0;
			}

		for(uPosY=0;uPosY<sSource.uImageHeight;uPosY++,iOffX+=iAddX)
			{
			iOffY = iSetY;

			for(uPosX=0;uPosX<sSource.uImageWidth;uPosX++,iOffY+=iAddY)
				{
				uPixel = sSource.GetPixel(uPosX,uPosY);
				SetPixel(iOffX,iOffY,uPixel);
				}
			}
		}
	else{
		if(!SetSize(sSource.uImageBits,sSource.uImageWidth,sSource.uImageHeight,BI_NOT_INIT))
			{
			return false;
			}

		if(iMode==2)
			{
			iSwapY=!iSwapY;
			iSwapX=!iSwapX;
			}

		if(iSwapY)
			{
			iAddX = -1;
			iSetX =  sSource.uImageWidth-1;
			}
		else{
			iAddX =  1;
			iSetX =  0;
			}

		if(iSwapX)
			{
			iAddY = -1;
			iOffY =  sSource.uImageHeight-1;
			}
		else{
			iAddY =  1;
			iOffY =  0;
			}

		for(uPosY=0;uPosY<sSource.uImageHeight;uPosY++,iOffY+=iAddY)
			{
			iOffX = iSetX;

			for(uPosX=0;uPosX<sSource.uImageWidth ;uPosX++,iOffX+=iAddX)
				{
				uPixel = sSource.GetPixel(uPosX,uPosY);
				SetPixel(iOffX,iOffY,uPixel);
				}
			}
		}


	memcpy(pColorMap,sSource.pColorMap,sizeof(pColorMap[0])*uColorCount);



return true;
}



//*****************************************************************************
//*
//*		SetSize
//*
//*****************************************************************************
//	Stellt das Aussehen des Bildes ein
//	uBits	: Anzahl der Bits pro Pixel fr das neue Bild
//	uSizeX	: Bild Breite in Pixel fr das neue Bild
//	uSizeY	: Bild Hhe	 in Pixel fr das neue Bild
//	uPixel	: Ist der Pixel fr die Initialisierung.
//				BI_NOT_INIT = nicht initialisieren
//	pData	: Zeiger auf die Bilddaten, bei 0 wird der Speicher erzeugt.
//			  Mit BI_BITMAP wird der Speicher auf einem HBITMAP Objekt erstellt.
//	Ergibt TRUE wenn Bild erzeugt wurde.
bool BitmapImage::SetSize(unsigned uBits,unsigned uSizeX,unsigned uSizeY,unsigned uPixel,void *pData)
{
int		i,j;



	ClearData();											// Altes Bild lschen

															// Sind Bild-Daten ok ?
	if(uSizeX>32768 || uSizeY  >32768   ){cLastError=1;return false;}
	if(uBits <1     || uBits   >32      ){cLastError=2;return false;}
	if(!((1<<(uBits-1))&BITMAPIMAGE_CFG)){cLastError=2;return false;}



	switch (uBits)
		{
	case  1: uColorMask=0x00FFFFFF;uColumMask=7;uShiftMask=0x01;uBytesPerPixel=1;GetPixel_=GetPixel1; Get1Row_=Get1Row1; Get3Row_=Get3Row1; Get4Row_=Get4Row1; SetPixel_=SetPixel1; RgbToPixel_=RgbToPixel1; break;
	case  2: uColorMask=0x00FFFFFF;uColumMask=3;uShiftMask=0x11;uBytesPerPixel=1;GetPixel_=GetPixel2; Get1Row_=Get1Row2; Get3Row_=Get3Row2; Get4Row_=Get4Row2; SetPixel_=SetPixel2; RgbToPixel_=RgbToPixel2; break;
	case  4: uColorMask=0x00FFFFFF;uColumMask=1;uShiftMask=0x55;uBytesPerPixel=1;GetPixel_=GetPixel4; Get1Row_=Get1Row4; Get3Row_=Get3Row4; Get4Row_=Get4Row4; SetPixel_=SetPixel4; RgbToPixel_=RgbToPixel4; break;
	case  8: uColorMask=0x00FFFFFF;uColumMask=0;uShiftMask=0xFF;uBytesPerPixel=1;GetPixel_=GetPixel8; Get1Row_=Get1Row8; Get3Row_=Get3Row8; Get4Row_=Get4Row8; SetPixel_=SetPixel8; RgbToPixel_=RgbToPixel8; break;
	case 12: uColorMask=0x00F0F0F0;uColumMask=1;uShiftMask=0x55;uBytesPerPixel=3;GetPixel_=GetPixel12;Get1Row_=Get1RowG; Get3Row_=Get3Row12;Get4Row_=Get4Row12;SetPixel_=SetPixel12;RgbToPixel_=RgbToPixel12;break;
	case 15: uColorMask=0x00F8F8F8;uColumMask=0;uShiftMask=0xFF;uBytesPerPixel=2;GetPixel_=GetPixel15;Get1Row_=Get1RowG; Get3Row_=Get3Row15;Get4Row_=Get4Row15;SetPixel_=SetPixel15;RgbToPixel_=RgbToPixel15;break;
	case 16: uColorMask=0x00F8FCF8;uColumMask=0;uShiftMask=0xFF;uBytesPerPixel=2;GetPixel_=GetPixel16;Get1Row_=Get1RowG; Get3Row_=Get3Row16;Get4Row_=Get4Row16;SetPixel_=SetPixel16;RgbToPixel_=RgbToPixel16;break;
	case 24: uColorMask=0x00FFFFFF;uColumMask=0;uShiftMask=0xFF;uBytesPerPixel=3;GetPixel_=GetPixel24;Get1Row_=Get1RowG; Get3Row_=Get3Row24;Get4Row_=Get4Row24;SetPixel_=SetPixel24;RgbToPixel_=RgbToPixel24;break;
	case 32: uColorMask=0x00FFFFFF;uColumMask=0;uShiftMask=0xFF;uBytesPerPixel=4;GetPixel_=GetPixel32;Get1Row_=Get1RowG; Get3Row_=Get3Row32;Get4Row_=Get4Row32;SetPixel_=SetPixel32;RgbToPixel_=RgbToPixel32;break;
	default: cLastError=2;return false;
		}

				 Get1RowT_=Get1Row_;						// Temporre Reihen Funktionen
				 Get3RowT_=Get3Row_;
				 Get4RowT_=Get4Row_;
	if(uBits== 8)Get1RowT_=GetTRow;
	if(uBits==24)Get3RowT_=GetTRow;
	if(uBits==32)Get4RowT_=GetTRow;

	uColumBit		= SHL[uBits];
	uColumMask		= COL[uBits];
	uShiftMask		= ROL[uBits];
	uBytesPerPixel	= ADD[uBits];


	if(uBits<12)											// Pallete einstellen bei nicht RGB-Bild
		{
		uIsRgb = 0;

		   uColorCount=1<<uBits;
		if(uColorCount>256)uColorCount=256;

		uRowWidth  = RoundRow((uBits*uSizeX+7)/8);


		if(uBits==1){SetColor( 0,0x00000000);				// Farben 0..1
					 SetColor( 1,0x00FFFFFF);}
		if(uBits==2){SetColor( 0,0x00000000);				// Farben 2..3
					 SetColor( 1,0x00008000);
					 SetColor( 2,0x00800000);
					 SetColor( 3,0x00FFFFFF);}
		if(uBits>=4){SetColor( 1,0x00000080);				// Farben 0..15
					 SetColor( 2,0x00008000);
					 SetColor( 3,0x00008080);
					 SetColor( 4,0x00800000);
					 SetColor( 5,0x00800080);
					 SetColor( 6,0x00808000);
					 SetColor( 7,0x00C0C0C0);
					 SetColor( 8,0x00808080);
					 SetColor( 9,0x000000FF);
					 SetColor(10,0x0000FF00);
					 SetColor(11,0x0000FFFF);
					 SetColor(12,0x00FF0000);
					 SetColor(13,0x00FF00FF);
					 SetColor(14,0x00FFFF00);
					 SetColor(15,0x00FFFFFF);}
		if(uBits==8){										// Farben 16..255
					for(i=128;i<256;i++)
						{
						SetColor(i,(unsigned char)((((i>>5)&0x3)<<6)+32),
								   (unsigned char)((((i>>2)&0x7)<<5)+16),
								   (unsigned char)((((i   )&0x3)<<6)+32));
						}
					for(i=16;i<32;i++)
						{
						SetColor(i,(unsigned char)((i&0xF)<<4),
								   (unsigned char)((i&0xF)<<4),
								   (unsigned char)((i&0xF)<<4));
						}
					for(i=32,j=0;j<216;i++,j++)
						{
						SetColor(i,(unsigned char)(((i/36)%6)*43+20),
								   (unsigned char)(((i/ 6)%6)*43+20),
								   (unsigned char)(((i   )%6)*43+20));

						}
					}


		}
	else{													// RGB-Bilde
		uIsRgb		= 1;
		uColorCount	= 0;

		if(uBits==12)uRowWidth = RoundRow((3 * uSizeX+1)/2);
		if(uBits==15)uRowWidth = RoundRow( 2 * uSizeX);
		if(uBits==16)uRowWidth = RoundRow( 2 * uSizeX);
		if(uBits==24)uRowWidth = RoundRow( 3 * uSizeX);
		if(uBits==32)uRowWidth = RoundRow( 4 * uSizeX);
		}

	uImageSize = uRowWidth*uSizeY;

	if(pData==0)pImageBase=(unsigned char*)pData;

	if(pData)												// Bildspeicher wird bergeben
		{
		uDelData	= 1;
		pImageMem	= (unsigned char*)pData;
		pImageData	= pImageMem;
		pImageData1	= pImageData+(uSizeY-1)*uRowWidth;
		pImageRow	= new unsigned char[uRowWidth+8];

		if(!pImageRow)
			{
			ClearData();
			cLastError=3;
			return false;
			}
		}
	else{													// Bildspeicher erzeugen
		i = uImageSize + uRowWidth+uSizeX*4+8;
			pImageMem = new unsigned char[i];
		if(!pImageMem)
			{
			ClearData();
			cLastError=3;
			return false;
			}

		pImageData	= pImageMem;
		while(((int)pImageData)&3)pImageData++;
		pImageData1	= pImageData+ (uSizeY-1) *uRowWidth;
		pImageRow	= pImageData+uImageSize+uRowWidth;
		}


	uPixelBit    = 0x00000001<<(uBits-1);
	uPixelMask   = 0xFFFFFFFF>>(32-uBits);
	uImageBits   = uBits;
	uImageWidth  = uSizeX;
	uImageHeight = uSizeY;


	pBitmapInfo->bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
	pBitmapInfo->bmiHeader.biWidth		   = uImageWidth;
	pBitmapInfo->bmiHeader.biHeight		   = uImageHeight;
	pBitmapInfo->bmiHeader.biBitCount      =(unsigned short)((uImageBits==15)? 16:uImageBits);
	pBitmapInfo->bmiHeader.biCompression   = BI_RGB;
	pBitmapInfo->bmiHeader.biPlanes        = 1;
	pBitmapInfo->bmiHeader.biSizeImage     = uImageSize;
	pBitmapInfo->bmiHeader.biXPelsPerMeter = 4705;
	pBitmapInfo->bmiHeader.biYPelsPerMeter = 4705;
	pBitmapInfo->bmiHeader.biClrImportant  = uColorCount;
	pBitmapInfo->bmiHeader.biClrUsed	   = uColorCount;


	if(pBitmapInfo->bmiHeader.biBitCount==16)				// Setzte Farbmasken fr 16 Bit
		{
		unsigned *pPtr;

		pBitmapInfo->bmiHeader.biCompression = BI_BITFIELDS;

		pPtr = (unsigned*)pColorMap;

		if(uImageBits<24)
			{
			pPtr[0] = 0x0000F800;
			pPtr[1] = 0x000007E0;
			pPtr[2] = 0x0000001F;
			pPtr[3] = 0x00000000;
			}
		}


	if(pImageMem==BI_BITMAP)								// Speicher aus einem Windows-Bitmap
		{
		#ifndef	_WIN32
		pImageMem =  new unsigned char[uImageSize];
		uDelData  =  0;

		if(!pImageMem)
			{
			ClearData();
			cLastError=3;
			return false;
			}

		#else
		HDC		hDc;

		hDc		  = GetDC(NULL);
		hBitmap   = CreateDIBSection(hDc,pBitmapInfo,DIB_RGB_COLORS,(LPVOID*)&pImageMem,0,0);
		ReleaseDC(NULL,hDc);

		#endif

		pImageData	= pImageMem;
		pImageData1	= pImageData+(uSizeY-1)*uRowWidth;
		}



	if(uPixel!=BI_NOT_INIT)
		{
		if(!uPixel || uImageBits==8)						// Alle Pixel initialisieren
				memset(pImageData,uPixel,uImageSize);
		else	Box(0,0,uSizeX,uSizeY,uPixel);
		}



return true;
}

//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
//	Das Bild lschen
bool BitmapImage::Clear()
{
bool	bOk;

	bOk=IsOk();
	ClearData();

return bOk;
}

//*****************************************************************************
//*
//*		SetProgressFunktion
//*
//*****************************************************************************
//	Einstellen der Verlauf-Callback-Funktion
//  pProc	: Zeiger auf die Callback-Funktion
//  pData	: Ist der Parameter der an die Funktion bergeben wird.
void BitmapImage::SetProgressFunction(IMAGEPROGRESSFUNCTION pProc,void *pData)
{

	pProgressProc = pProc;
	pProgressData = pData;

}

//*****************************************************************************
//*
//*		CallProgressFunction
//*
//*****************************************************************************
//  Aufrufen der Verlauf-Callback-Funktion
//	uPercent	: Wieviel Prozent sind bereits fertig
//  uPass		: Aktueller Durchlauf
//  uPassCount	: Anzahl der Durchlufe
void BitmapImage::CallProgressFunction(unsigned uPercent,unsigned uPass,unsigned uPassCount)
{
bool	bCancel;


	if(pProgressProc==NULL)return;
	if(uPercent>100)uPercent=100;

	bCancel = false;
	pProgressProc(*this,pProgressData,uPass,uPassCount,uPercent,bCancel);

	if(bCancel)throw 1;

}

//*****************************************************************************
//*
//*		FindColor
//*
//*****************************************************************************
// uColor Quantization Routines
//
//  Since I have received many requests for color quantization I have
//  whipped this up. I have to admit to knowing nothing about uColor
//  quantization (I have always had systems that did not need it). The
//  only techniques for quantization that I had been familiar with are
//  scaling uColor values and having a fixed uColor space. However, I thought
//  1-uPass methods such as those would be too cude for someone of my
//  programming skill.
//
//  What I have tried instead is to use two passes. What we do is create
//  a 3-dimensional hash table of uColor values. The we keep dividing the
//  uColorspace in half until we have set of uColor ranges.
//
//  Hey, it's probably not all that efficient but it's the best I could come
//  up with in an evening.
//
//  Description:
//    This pProc looks up the color pEntry in the color hash table
//    for a specified uColor value.
//
//  Parameters:
//    ucRed, ucGreen, ucBlue:  The uColor value to search for.
//
BitmapImage::ColorUsage *BitmapImage::FindColor(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
{
ColorUsage *pEntry;


	if(pColorUsage->pLists[ucRed  ][RedOffset  ] == NULL ||
	   pColorUsage->pLists[ucGreen][GreenOffset] == NULL ||
	   pColorUsage->pLists[ucBlue ][BlueOffset ] == NULL)
		{
		return NULL ;
		}

	pEntry = pColorUsage->pLists [ucRed][RedOffset];

	for(;pEntry;pEntry=pEntry->pNext[RedOffset])
		{
		if(pEntry->aColors[BlueOffset ]==ucBlue )
		if(pEntry->aColors[GreenOffset]==ucGreen)
			{
			return pEntry;
			}
		}


return NULL;
}

//*****************************************************************************
//*
//*		AddColor
//*
//*****************************************************************************
//  This pProc adds a new uColor value to the color hash table.
//
//  Parameters:
//    ucRed, ucGreen, ucBlue:  The uColor value to search for.
//
void BitmapImage::AddColor(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
{
ColorUsage *pEntry;


	pEntry = new ColorUsage ;								// Create the new color entry
	memset(pEntry,0,sizeof(*pEntry));

	pEntry->uUsage					= 1 ;
	pEntry->aColors [RedOffset  ]	= ucRed;
	pEntry->aColors [GreenOffset]	= ucGreen;
	pEntry->aColors [BlueOffset ]	= ucBlue;


	if(!pColorUsage->pLists[ucRed][RedOffset])				// Add the new entry to each hash chain
		{
		pColorUsage->pLists[ucRed][RedOffset] = pEntry;
		}
	else{
		pEntry->pNext[RedOffset] = pColorUsage->pLists[ucRed][RedOffset] ;
		pColorUsage->pLists [ucRed][RedOffset] = pEntry;
		}

	if(!pColorUsage->pLists[ucGreen][GreenOffset])
		{
		pColorUsage->pLists [ucGreen][GreenOffset] = pEntry;
		}
	else{
		pEntry->pNext[GreenOffset] = pColorUsage->pLists[ucGreen][GreenOffset] ;
		pColorUsage->pLists [ucGreen][GreenOffset] = pEntry;
		}

	if(!pColorUsage->pLists [ucBlue][BlueOffset])
		{
		pColorUsage->pLists [ucBlue][BlueOffset] = pEntry;
		}
	else{
		pEntry->pNext[BlueOffset] = pColorUsage->pLists[ucBlue][BlueOffset] ;
		pColorUsage->pLists [ucBlue][BlueOffset] = pEntry;
		}

	pColorUsage->uColorCount++;

}

//*****************************************************************************
//*
//*		ConvertTo8Bit
//*
//*****************************************************************************
//  Konvertiert ein RGB-Bild in ein 8 Bit Bild
//	sImage		: Ist das Bild das konvertiert werden soll
//	Bei der Konvertieruneg wird die pProgressProc aufgerufen
//	Ergibt TRUE  wenn konvertierung erfolgreich war
//		   FALSE bei einem Benutzer Abbruch oder einen Fehler
bool BitmapImage::ConvertTo8Bit(const BitmapImage &sImage)
{
unsigned	uPos;
unsigned	uVal;
unsigned	uNew;
int			iNum;


	if(!sImage.IsOk())
		{
		SetSize(8,0,0);
		return false;
		}


	if(sImage.uImageBits<12)							// Is es kein RGB-Bild
		{
		if(sImage.uImageBits==8)
			{
			DoCopy(sImage);
			return true;
			}
														// In 8-Bit-Bild umwandeln
		memcpy(pColorMap,sImage.pColorMap,sizeof(pColorMap[0])*256);
		SetSize(8,sImage.uImageWidth,sImage.uImageHeight,BI_NOT_INIT);
		return Put(sImage,0,0);
		}

	pProgressProc = sImage.pProgressProc;
	pProgressData = sImage.pProgressData;

														// Allocate space for the sImage.
	SetSize(8,sImage.uImageWidth,sImage.uImageHeight,BI_NOT_INIT);


	pColorAreas   = new ColorArea [256];				// Allocate temporary structures used for color quantization.
	pColorUsage   = new ColorUsageTable;
	memset(pColorUsage,0,sizeof(*pColorUsage));

	try	{
		FindColorUsage(sImage);
		}
	catch(int iUserBreak)								// Gab es einen Benuzerabruch
		{
		iUserBreak=1;
		FreeColorQuant();
		return false;
		}
	catch(...)
		{
		FreeColorQuant();
		return false;
		}

														// Set the first (zero'th) uArea to the entire uColor space.
	pColorAreas [0].aColorValues[RedOffset  ].ucLow  = 000;
	pColorAreas [0].aColorValues[RedOffset  ].ucHigh = 255;
	pColorAreas [0].aColorValues[GreenOffset].ucLow  = 000;
	pColorAreas [0].aColorValues[GreenOffset].ucHigh = 255;
	pColorAreas [0].aColorValues[BlueOffset ].ucLow  = 000;
	pColorAreas [0].aColorValues[BlueOffset ].ucHigh = 255;
	pColorAreas [0].uPixelCount = uImageHeight*uImageWidth;
	pColorAreas [0].uColorCount = pColorUsage->uColorCount;
	uAreaCount = 1 ;

														// Divide the color area in half.
	SplitAreaInHalf(7,0,0,RedOffset);					// Split uColor

	// It is possible that some of the areas could not be divided using the
	// previous process. If we have some remaining aColors we try to assign them
	// to the blocks with the largest size in the uColorspace.

	while(uAreaCount<256)
		{
		iNum = 0;
		uVal          = Square (pColorAreas[iNum].aColorValues[RedOffset  ].ucHigh -
								pColorAreas[iNum].aColorValues[RedOffset  ].ucLow)
					  + Square (pColorAreas[iNum].aColorValues[GreenOffset].ucHigh -
								pColorAreas[iNum].aColorValues[GreenOffset].ucLow)
					  + Square (pColorAreas[iNum].aColorValues[BlueOffset ].ucHigh -
								pColorAreas[iNum].aColorValues[BlueOffset ].ucLow)
					  * pColorAreas[iNum].uColorCount;

		for(uPos=1;uPos<uAreaCount;uPos++)
			{
			if(pColorAreas [uPos].uColorCount>1)
				{
				uNew  = Square (pColorAreas[uPos].aColorValues[RedOffset  ].ucHigh -
								pColorAreas[uPos].aColorValues[RedOffset  ].ucLow)
					  + Square (pColorAreas[uPos].aColorValues[GreenOffset].ucHigh -
								pColorAreas[uPos].aColorValues[GreenOffset].ucLow)
					  + Square (pColorAreas[uPos].aColorValues[BlueOffset ].ucHigh -
								pColorAreas[uPos].aColorValues[BlueOffset ].ucLow)
					  * pColorAreas[uPos].uColorCount;

				if(uNew>uVal)
					{
					uVal = uNew;
					iNum = uPos;
					}
				}
			}

		if(pColorAreas[iNum].uColorCount == 1)break;	// If we have not aColors to divide then stop.

														// Split this color block in half.
		SplitAreaInHalf(0,0,iNum,LargestColorArea(pColorAreas[iNum]));
		}

	for(uPos=0;uPos<uAreaCount;uPos++)
		{
		CreateColor(uPos);
		}

	try	{												// Assign aColors to the sImage.
		QuantizeSrcImage (sImage);
		}
	catch(int iUserBreak)
		{
		iUserBreak=1;
		FreeColorQuant();
		return false;
		}
	catch(...)
		{
		FreeColorQuant();
		return false;
		}

	FreeColorQuant();


return true;
}

//*****************************************************************************
//*
//*		FindColorUsage
//*
//*****************************************************************************
//    This pProc finds the aColors that are used and their frequency
//    within a sSource sImage.
//	Parameters:
//    sImage:   The sSource sImage.
void BitmapImage::FindColorUsage(const BitmapImage &sImage)
{
ColorUsage     *pEntry;
unsigned char  *pRow;
unsigned char	ucRed;
unsigned char	ucBlue;
unsigned char	ucGreen;
unsigned	    uClimit;
unsigned		uPos;
unsigned		uOff;




	uClimit = uImageWidth*3;

	for(uPos=0;uPos<uImageHeight;uPos++)		// Create a color entry for each distinct color.
		{
		pRow = sImage.GetRow3(uPos);

		for(uOff=0;uOff<uClimit;uOff+=3)
			{
			ucRed   = pRow[uOff+RedOffset  ];
			ucGreen = pRow[uOff+GreenOffset];
			ucBlue  = pRow[uOff+BlueOffset ];
			pEntry  = FindColor(ucRed,ucGreen,ucBlue);

			if(pEntry==NULL)
					AddColor(ucRed,ucGreen,ucBlue);
			else	pEntry->uUsage++;
			}

		CallProgressFunction(100*uPos/uImageHeight,1,2);
		}

	CallProgressFunction(100,1,2);

}

//*****************************************************************************
//*
//*		FreeColorQuant
//*
//*****************************************************************************
//    This pProc frees all the dynamic pData allocated during
//    uColor quantization.
void BitmapImage::FreeColorQuant()
{
ColorUsage *pEntry;
ColorUsage *pNext;
unsigned	uPos;



	for(uPos=0;uPos<256;uPos++)						// Get rid of al the temporary storage.
		{
		pEntry = pColorUsage->pLists[uPos][RedOffset];

		for(;pEntry;pEntry=pNext)
			{
			pNext = pEntry->pNext[RedOffset] ;
			delete pEntry;
			}
		}


	delete pColorUsage; pColorUsage = 0;
	delete pColorAreas; pColorAreas = 0;

}

//*****************************************************************************
//*
//*		SplitAreaInHalf
//*
//*****************************************************************************
//    This pProc divides an uArea of the uColorspace in half.
//  Parameters:
//    uDepth:        The search uDepth
//    uRetryDepth:   The number of retries
//    uAreaId:       The uArea to split
//    uSplitColor:   The uColor to split on.
void BitmapImage::SplitAreaInHalf(unsigned uDepth,unsigned uRetryDepth,unsigned uAreaId,unsigned uSplitColor)
{
ColorUsage	   *pEntry;
unsigned		uSplitSize;
unsigned		uSplitPixelCount;
unsigned		uSplituColorCount;
unsigned		uNewPixelCount;
unsigned		uNewColorCount;
unsigned		uNewLimith;
unsigned		uVal1;
unsigned		uVal2;


	if(     pColorAreas [uAreaId].uColorCount == 1)return;
	else if(pColorAreas [uAreaId].aColorValues [uSplitColor].ucHigh ==
			pColorAreas [uAreaId].aColorValues [uSplitColor].ucLow)
		{
		if(uRetryDepth<2)SplitAreaInHalf(uDepth,uRetryDepth+1,uAreaId,(uSplitColor+1)%3);
		return;
		}

	uVal1				= (uSplitColor+1)%3;
	uVal2				= (uSplitColor+2)%3;
	uSplitSize			= pColorAreas[uAreaId].uPixelCount/2 ;
	uSplitPixelCount	= 0 ;
	uSplituColorCount	= 0 ;

	uNewLimith			= pColorAreas [uAreaId].aColorValues [uSplitColor].ucLow;

	for(;uNewLimith<=pColorAreas[uAreaId].aColorValues[uSplitColor].ucHigh;uNewLimith++)
		{
		uNewPixelCount	= 0 ;
		uNewColorCount	= 0 ;
		pEntry		  	= pColorUsage->pLists[uNewLimith][uSplitColor];

		for(;pEntry;pEntry=pEntry->pNext[uSplitColor])
			{
			if( pEntry->aColors[uVal1] >= pColorAreas[uAreaId].aColorValues[uVal1].ucLow   &&
				pEntry->aColors[uVal1] <= pColorAreas[uAreaId].aColorValues[uVal1].ucHigh  &&
				pEntry->aColors[uVal2] >= pColorAreas[uAreaId].aColorValues[uVal2].ucLow   &&
				pEntry->aColors[uVal2] <= pColorAreas[uAreaId].aColorValues[uVal2].ucHigh)
				{
				uNewPixelCount+=pEntry->uUsage;
				uNewColorCount++;
				}
			}

	if(uNewColorCount == pColorAreas[uAreaId].uColorCount)
		{
		if(uRetryDepth<2)								// There is no way to split using this color.
			{
			SplitAreaInHalf(uDepth,uRetryDepth+1,uAreaId,(uSplitColor+1)%3);
			}

		return;
		}
	else if(uNewColorCount > pColorAreas[uAreaId].uColorCount)
		{
		throw "INTERNAL ERROR - Quantization area color count invalid";
		}

	if(uSplitPixelCount+uNewPixelCount >= uSplitSize)
		{
		if(uSplitPixelCount+uNewPixelCount != pColorAreas[uAreaId].uPixelCount)
			{
			uSplitPixelCount  += uNewPixelCount;
			uSplituColorCount += uNewColorCount;
			}
		else{
			uNewLimith--;
			}

		pColorAreas[uAreaCount]             = pColorAreas [uAreaId] ;
		pColorAreas[uAreaCount].uPixelCount = pColorAreas [uAreaId].uPixelCount-uSplitPixelCount;
		pColorAreas[uAreaCount].uColorCount = pColorAreas [uAreaId].uColorCount-uSplituColorCount;
		pColorAreas[uAreaCount].aColorValues[uSplitColor].ucLow  = (unsigned char)(uNewLimith+1);
		uAreaCount++;

		pColorAreas[uAreaId   ].aColorValues[uSplitColor].ucHigh = (unsigned char)uNewLimith;
		pColorAreas[uAreaId   ].uPixelCount = uSplitPixelCount;
		pColorAreas[uAreaId   ].uColorCount = uSplituColorCount;

		if(uDepth>0)
			{
			SplitAreaInHalf(uDepth-1,0,uAreaCount-1,LargestColorArea(pColorAreas[uAreaCount-1]));
			SplitAreaInHalf(uDepth-1,0,uAreaId,     LargestColorArea(pColorAreas[uAreaId     ]));
			}

		return;
		}
	else{
		uSplitPixelCount  += uNewPixelCount;
		uSplituColorCount += uNewColorCount;
		}
	}


	throw "INTERNAL ERROR - Quantization uArea pixel count invalid";
}

//*****************************************************************************
//*
//*		CreateColor
//*
//*****************************************************************************
//    This pProc creates a uColor from a uColor uArea then maps the aColors
//    in the sSource sImage to the new uColor map.
//
// Parameters:
//    uColor:   The new uColor index value
//
void BitmapImage::CreateColor(unsigned uColor)
{
ColorUsage *pEntry;
const int	uVal0 = RedOffset;
const int	uVal1 = GreenOffset;
const int	uVal2 = BlueOffset;
unsigned	uItemCount;
unsigned	ucGreen;
unsigned	ucBlue;
unsigned	ucRed;
unsigned	uOff;


	uItemCount	= 0 ;
	ucRed		= 0 ;
	ucGreen		= 0 ;
	ucBlue		= 0 ;

	uOff		= pColorAreas[uColor].aColorValues[uVal0].ucLow;

	for(;uOff<=pColorAreas[uColor].aColorValues[uVal0].ucHigh;uOff++)
		{
		pEntry = pColorUsage->pLists [uOff][uVal0];

		for(;pEntry;pEntry=pEntry->pNext[uVal0])
			{
			if(pEntry->aColors [uVal1] >= pColorAreas [uColor].aColorValues [uVal1].ucLow   &&
			   pEntry->aColors [uVal1] <= pColorAreas [uColor].aColorValues [uVal1].ucHigh	&&
			   pEntry->aColors [uVal2] >= pColorAreas [uColor].aColorValues [uVal2].ucLow	&&
			   pEntry->aColors [uVal2] <= pColorAreas [uColor].aColorValues [uVal2].ucHigh)
				{
				ucRed      += pEntry->aColors[RedOffset  ]*pEntry->uUsage;
				ucGreen    += pEntry->aColors[GreenOffset]*pEntry->uUsage;
				ucBlue     += pEntry->aColors[BlueOffset ]*pEntry->uUsage;
				uItemCount += pEntry->uUsage;
				}
			}
		}

	if(uItemCount==0)return;

	pColorMap[uColor].ucRed   = (unsigned char)((ucRed   + uItemCount/2) / uItemCount);
	pColorMap[uColor].ucGreen = (unsigned char)((ucGreen + uItemCount/2) / uItemCount);
	pColorMap[uColor].ucBlue  = (unsigned char)((ucBlue  + uItemCount/2) / uItemCount);

}

//*****************************************************************************
//*
//*		LargestColorArea
//*
//*****************************************************************************
//    This pProc finds the largest dimension of a uColor uArea.
//
// Parameters:
//    uArea:    The uColor uArea to use
//
int BitmapImage::LargestColorArea(ColorArea &uArea)
{
unsigned	uDeltaGreen;
unsigned	uDeltaBlue;
unsigned	uDeltaRed;


	uDeltaRed   = uArea.aColorValues[RedOffset  ].ucHigh - uArea.aColorValues[RedOffset  ].ucLow;
	uDeltaGreen = uArea.aColorValues[GreenOffset].ucHigh - uArea.aColorValues[GreenOffset].ucLow;
	uDeltaBlue  = uArea.aColorValues[BlueOffset ].ucHigh - uArea.aColorValues[BlueOffset ].ucLow;

	if(uDeltaRed>=uDeltaGreen && uDeltaRed>=uDeltaBlue)
		{
		return RedOffset;
		}

	if(uDeltaBlue>=uDeltaGreen && uDeltaBlue>=uDeltaRed)
		{
		return BlueOffset;
		}


return GreenOffset;
}

//*****************************************************************************
//*
//*		QuantizedColor
//*
//*****************************************************************************
//  This pProc returns the 8-bit quantized uColor value for and RGB uColor.
//
//	Parameters:
//
//    ucRed, ucGreen, ucBlue: The RGB value to convert
//
unsigned BitmapImage::QuantizedColor(unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
{
unsigned	uPos;


	for(uPos=0;uPos<uAreaCount;uPos++)
		{
		if(ucRed   >= pColorAreas [uPos].aColorValues[RedOffset  ].ucLow	&&
		   ucRed   <= pColorAreas [uPos].aColorValues[RedOffset  ].ucHigh	&&
		   ucGreen >= pColorAreas [uPos].aColorValues[GreenOffset].ucLow	&&
		   ucGreen <= pColorAreas [uPos].aColorValues[GreenOffset].ucHigh	&&
		   ucBlue  >= pColorAreas [uPos].aColorValues[BlueOffset ].ucLow	&&
		   ucBlue  <= pColorAreas [uPos].aColorValues[BlueOffset ].ucHigh)
			{
			return uPos;
			}
		}


	throw "INTERNAL ERROR - uPos not quantized";


return uPos;
}

//*****************************************************************************
//*
//*		QuantizedSourceImage
//*
//*****************************************************************************
//    This pProc converts the RGB uColor values in the sSource sImage
//    to 8-bit quantized uColor values.
//
// Parameters:
//    src:  The sSource sImage
//
void BitmapImage::QuantizeSrcImage(const BitmapImage &sSource)
{
unsigned char  *pSource;
unsigned char  *pTarget;
unsigned char	ucGreen;
unsigned char	ucBlue;
unsigned char	ucRed;
unsigned		uPos;
unsigned		uOff;


	for(uPos=0;uPos<uImageHeight;uPos++)
		{
		CallProgressFunction(uPos*100/uImageHeight,2,2);

		pSource = sSource.GetRow3(uPos);
		pTarget = GetRow_(uPos);

		for(uOff=0;uOff<uImageWidth;uOff++)
			{
			ucRed   = pSource[3*uOff+RedOffset  ];
			ucGreen = pSource[3*uOff+GreenOffset];
			ucBlue  = pSource[3*uOff+BlueOffset ];
			pTarget[uOff] = (unsigned char)QuantizedColor(ucRed,ucGreen,ucBlue);
			}
		}

	CallProgressFunction(100,2,2);

}

//*****************************************************************************
//*
//*		Copy
//*
//*****************************************************************************
//	Bild in Zwischenablage kopieren
bool BitmapImage::Copy(HWND hWnd)const
{
//char 		aTemp[BMI_SIZE_EX(3)];
char	   *pMem;
BITMAPINFO *pInfo;
//DWORD	   *pColors;
HGLOBAL		hGlobal;
bool     	bExit;
int		 	iLenB;
int		 	iLenC;
int		 	iLenI;



	if(!IsOk())return false;

	#if defined(_WIN32) || defined(_WIN64)

	if(uImageBits>8)
		{
		pBitmapInfo->bmiHeader.biClrUsed	  = 0;
		pBitmapInfo->bmiHeader.biClrImportant = 0;
		}


	iLenB	= sizeof(BITMAPINFOHEADER);
	iLenC	= pBitmapInfo->bmiHeader.biClrUsed*sizeof(RGBQUAD);
	pInfo	= pBitmapInfo;

	/*														// BI_RGB auf BI_BITFIELDS ndern
	if(iLenC==0 && pBitmapInfo->bmiHeader.biCompression==BI_RGB && pBitmapInfo->bmiHeader.biBitCount>=15)
		{
		iLenC = sizeof(RGBQUAD)*3;
		pInfo = (BITMAPINFO*)aTemp;
		memcpy(pInfo,pBitmapInfo,sizeof(BITMAPINFOHEADER));
		pInfo->bmiHeader.biCompression	= BI_BITFIELDS;
		pInfo->bmiHeader.biClrUsed		= 0;
		pColors = (DWORD*)pInfo->bmiColors;

		switch(pBitmapInfo->bmiHeader.biBitCount)
			{
		case 15:	pColors[0] = 0x00007300;
					pColors[1] = 0x00000370;
					pColors[2] = 0x0000001F;
					break;
		case 16:	pColors[0] = 0x0000F100;
					pColors[1] = 0x00000770;
					pColors[2] = 0x0000001F;
					break;
		default:	pColors[0] = 0x00FF0000;
					pColors[1] = 0x0000FF00;
					pColors[2] = 0x000000FF;
					break;
			}
		}
	*/

	iLenI	= uImageSize;
	hGlobal	= GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,iLenI+iLenC+iLenB);
	pMem	= (char*)GlobalLock(hGlobal);


	memcpy(pMem            ,pInfo     ,iLenC+iLenB);
	memcpy(pMem+iLenC+iLenB,pImageData,iLenI      );

	GlobalUnlock(hGlobal);

	bExit = false;

	if(OpenClipboard(hWnd))
		{
		EmptyClipboard();

		if(SetClipboardData(CF_DIB,hGlobal))
			{
			bExit = true;
			}

		CloseClipboard();
		}

	if(!bExit)GlobalFree(hGlobal);

	#else

	bExit = false;

	#endif

return bExit;
}

//*****************************************************************************
//*
//*		Swap
//*
//*****************************************************************************
//	Tausche zwei Bildklassen
//	sImage		: Klasse aus dem das Bild getauscht wird
bool BitmapImage::Swap(BitmapImage &sImage)
{
char   *pBuffer;


	pBuffer = (char*)alloca(sizeof(BitmapImage));

	memcpy(pBuffer,this   ,sizeof(BitmapImage));
	memcpy(this   ,&sImage,sizeof(BitmapImage));
	memcpy(&sImage,pBuffer,sizeof(BitmapImage));


return true;
}

//*****************************************************************************
//*
//*		Paste
//*
//*****************************************************************************
//	Bild aus Zwischenablage kopieren
//	iMode		: Einfgemodus (Bit0=Alphakanal nicht lschen)
bool BitmapImage::Paste(HWND hWnd,int iMode)
{
char	    *pData,*pTemp,*pPic;
unsigned	 uPos;
unsigned	 uOff;
BITMAPINFO   sInfo;
HGLOBAL		 hGlobal;


	#if defined(_WIN32) || defined(_WIN64)

	if(!IsClipboardFormatAvailable(CF_DIB))
		{
		return false;
		}

	if(!OpenClipboard(hWnd))							// Daten aus Zwischenablage holen
		{
		return false;
		}


	uOff = sizeof(BITMAPINFOHEADER);

		hGlobal=GetClipboardData(CF_DIB);
	if(!hGlobal)
		{
			hGlobal=GetClipboardData(CF_DIBV5);
		if(!hGlobal)
			{
			CloseClipboard();
			return false;
			}

		uOff = sizeof(BITMAPV5HEADER_);
		}


		pData=(char*)GlobalLock(hGlobal);
	if(!pData)
		{
		CloseClipboard();
		return false;
		}

	memcpy(&sInfo,pData,sizeof(BITMAPINFOHEADER));
	pTemp = pData+uOff;
	pPic  = pTemp+sInfo.bmiHeader.biClrUsed*sizeof(RGBQUAD);
	sInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);


	if((sInfo.bmiHeader.biCompression!= BI_RGB         &&
	   (sInfo.bmiHeader.biCompression!= BI_BITFIELDS)) ||
	   (sInfo.bmiHeader.biWidth		 <= 0            ) ||
	   (sInfo.bmiHeader.biHeight	 <= 0	        ))
		{
		GlobalUnlock(hGlobal);
		CloseClipboard();
		return false;
		}

	if(sInfo.bmiHeader.biCompression==BI_BITFIELDS)
		{
		pPic+=4*3;
		}

	SetSize(sInfo.bmiHeader.biBitCount,					// Neues Bild erzeugen
			sInfo.bmiHeader.biWidth,
			sInfo.bmiHeader.biHeight,BI_NOT_INIT);

	for(uPos=0;uPos<sInfo.bmiHeader.biClrUsed;uPos++)
		{
		pColorMap[uPos].ucBlue  =pTemp[0];
		pColorMap[uPos].ucGreen =pTemp[1];
		pColorMap[uPos].ucRed   =pTemp[2];

		pTemp+=sizeof(RGBQUAD);
		}

	memcpy(pImageData,pPic,uImageSize);

	if(sInfo.bmiHeader.biBitCount==32 && !(iMode&1))	// Alpha-Kanal lschen
		{
		for(uPos=3;uPos<uImageSize;uPos+=4)
			{
			pImageData[uPos] = 0;
			}
		}

	GlobalUnlock(hGlobal);
	CloseClipboard();

	#else

	return false;

	#endif


return true;
}


//*****************************************************************************
//*
//*		SetColor
//*
//*****************************************************************************
void BitmapImage::SetColor(unsigned uIndex,COLORRGB uColor)
{

	pColorMap[uIndex&0xFF].uRgb = uColor;

}

void BitmapImage::SetColor(unsigned uIndex,unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue)
{

	uIndex				     &= 0xFF;
	pColorMap[uIndex].ucRed   = ucRed;
	pColorMap[uIndex].ucGreen = ucGreen;
	pColorMap[uIndex].ucBlue  = ucBlue;

}

void BitmapImage::SetColor(unsigned uIndex,unsigned char ucRed,unsigned char ucGreen,unsigned char ucBlue,unsigned char ucAlpha)
{

	uIndex				     &= 0xFF;
	pColorMap[uIndex].ucRed   = ucRed;
	pColorMap[uIndex].ucGreen = ucGreen;
	pColorMap[uIndex].ucBlue  = ucBlue;
	pColorMap[uIndex].ucMask  = ucAlpha;

}

//*****************************************************************************
//*
//*		GetColor
//*
//*****************************************************************************
COLORRGB BitmapImage::GetColor(unsigned uIndex,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue) const
{
	uIndex  &= 0xFF;
	ucRed    = pColorMap[uIndex].ucRed;
	ucGreen  = pColorMap[uIndex].ucGreen;
	ucBlue   = pColorMap[uIndex].ucBlue;

return  pColorMap[uIndex].uRgb;
}

COLORRGB BitmapImage::GetColor(unsigned uIndex,unsigned char &ucRed,unsigned char &ucGreen,unsigned char &ucBlue,unsigned char &ucAlpha) const
{
	uIndex  &= 0xFF;
	ucRed    = pColorMap[uIndex].ucRed;
	ucGreen  = pColorMap[uIndex].ucGreen;
	ucBlue   = pColorMap[uIndex].ucBlue;
	ucAlpha  = pColorMap[uIndex].ucMask;

return  pColorMap[uIndex].uRgb;
}


//*****************************************************************************
//*
//*		Stretch
//*
//*****************************************************************************
//	Erzeugt ein gleiches Bild nur mit anderer Gre
//	sImage	: Quellbild
//	uSizeX	: Neue Breite
//	uSizeY	: Neue Hhe
//	iMode	: Konvertierungsmodus
//				Bit0 : 0 = Punktweise  1 = Fliesende bergnge
//				Bit1 : Auch Alphakanal erstellen
//	Ergibt TRUE wenn das Bild erzeugt werden konnte, ansonsten FALSE.
bool BitmapImage::Stretch(const BitmapImage &sImage,unsigned uSizeX,unsigned uSizeY,int iMode)
{
unsigned short *pMesOld;
unsigned short *pMesNew;
unsigned char  *pMemOld;
unsigned char  *pMemNew;
unsigned	   *pPtrOld;
unsigned	   *pPtrNew;
unsigned		uColor;
unsigned		uOldX;
unsigned		uOldY;
unsigned		uBits;
unsigned		uPosX;
unsigned		uPosY;
unsigned		uPos;
unsigned		uRgb;
unsigned		uCol;



	if(!sImage.IsOk())									// Leeres Bild ?
		{
		SetSize(sImage.uImageBits,0,0);
 		return false;
		}

	uOldX  = sImage.uImageWidth;
	uOldY  = sImage.uImageHeight;
	uBits  = sImage.uImageBits;
	uColor = sImage.uColorCount;

	if(uOldX==uSizeX && uOldY==uSizeY)					// Gleiche Gre ?
		{
		if(!(iMode&2))
			{
			DoCopy(sImage);
			return 1;
			}

		SetSize(32,uSizeX,uSizeY,BI_NOT_INIT);

		for(uPosY=0;uPosY<uSizeY;uPosY++)				// Reihen durchlaufen
			{
			pMemOld = sImage.GetRow4(uPosY);
			pMemNew = ROW_PTR(uPosY);
			memcpy(pMemNew,pMemOld,uSizeX*4);
			}

		return 1;
		}

	if((iMode&2) || sImage.uImageBits==32)				// Mit Alpha-Kanal
		{
		SetSize(32,uSizeX,uSizeY,BI_NOT_INIT);
		}
	else if(iMode&1)
		{
		SetSize(24,uSizeX,uSizeY,BI_NOT_INIT);
		}
	else{
		SetSize(uBits,uSizeX,uSizeY,BI_NOT_INIT);
		}


	for(uPos=0;uPos<uColor;uPos++)						// Farben kopieren
		{
		pColorMap[uPos]=sImage.pColorMap[uPos];
		}


//******************** Punktweise kopieren ************************************
if(!(iMode&1))
	{
	if(uImageBits==32 && sImage.uImageBits!=32)
		{
		for(uPosY=0;uPosY<uSizeY;uPosY++)				// Reihen durchlaufen
			{
			pPtrOld = (unsigned*)sImage.GetRow4((uPosY*uOldY)/uSizeY);
			pPtrNew = (unsigned*)ROW_PTR(uPosY);

			for(uPosX=0;uPosX<uSizeX;uPosX++)			// Spalten durchlaufen
				{
				uCol = (uPosX*uOldX)/uSizeX;
				pPtrNew[uPosX]=pPtrOld[uCol];
				}
			}

		return 1;
		}


	if(uImageBits==32)
		{
		for(uPosY=0;uPosY<uSizeY;uPosY++)				// Reihen durchlaufen
			{
			pPtrOld = (unsigned*)sImage[(uPosY*uOldY)/uSizeY];
			pPtrNew = (unsigned*)ROW_PTR(uPosY);

			for(uPosX=0;uPosX<uSizeX;uPosX++)			// Spalten durchlaufen
				{
				uCol = (uPosX*uOldX)/uSizeX;
				pPtrNew[uPosX]=pPtrOld[uCol];
				}
			}

		return 1;
		}

	if(uImageBits==24)
		{
		for(uPosY=0;uPosY<uSizeY;uPosY++)				// Reihen durchlaufen
			{
			pMemOld = sImage[(uPosY*uOldY)/uSizeY];
			pMemNew = ROW_PTR(uPosY);

			for(uPosX=uSizeX;uPosX>0;)				// Spalten durchlaufen
				{
				uPosX--;
				uCol = (uPosX*uOldX)/uSizeX;
				uRgb = GET_DW(pMemOld+uCol+(uCol <<1));
				pMemNew[uPosX*3+2]=(unsigned char)(uRgb>>16);
				pMemNew[uPosX*3+1]=(unsigned char)(uRgb>>8);
				pMemNew[uPosX*3  ]=(unsigned char)(uRgb);
				}
			}

		return 1;
		}

	if(uImageBits==16 || uImageBits==15)
		{
		for(uPosY=0;uPosY<uSizeY;uPosY++)				// Reihen durchlaufen
			{
			pMesOld = (unsigned short*)sImage[(uPosY*uOldY)/uSizeY];
			pMesNew = (unsigned short*)ROW_PTR(uPosY);

			for(uPosX=0;uPosX<uSizeX;uPosX++)			// Spalten durchlaufen
				{
				uCol = (uPosX*uOldX)/uSizeX;
				pMesNew[uPosX]=pMesOld[uCol];
				}
			}

		return 1;
		}


	for(uPosY=0;uPosY<uSizeY;uPosY++)					// Pixel 1 zu 1 bernehmen
	for(uPosX=0;uPosX<uSizeX;uPosX++)
		{
		uCol=sImage.GetPixel((uPosX*uOldX)/uSizeX,(uPosY*uOldY)/uSizeY);
		SetPixel(uPosX,uPosY,uCol);
		}

	return 1;
	}

//******************** Pixelbergnge gltten *********************************
unsigned   *pPtr;
unsigned   *pLine;
unsigned   *pDelta;
unsigned	r,g,b,a,d;
unsigned	uFactX;
unsigned	uFactY;
unsigned	uDiffX;
unsigned	uDiffY;
unsigned	uOldX3;
unsigned	uStart;
unsigned	uDelta;
unsigned	uEnd;
unsigned	uMul;
uint64		uVal;


	if(uOldX<uSizeX)									// Quelle ist kleiner
		{
		uFactX	= uOldX-1;
		uDiffX	= uSizeX-1;
		}
	else{
		uFactX	= uOldX;								// Quelle ist grer
		uDiffX	= uSizeX;
		}

	while(!((uFactX|uDiffX)&1))							// Faktoren krzen
		{
		uDiffX	>>= 1;
		uFactX	>>= 1;
		}

	uVal	= uSizeX;
	uVal   *= uFactX;
	uVal   *= 256;
	uVal  >>= 31;
	uMul    = (unsigned)uVal;

	while(uMul)											// Sind Faktoren zu gro
		{
		uMul	>>= 1;
		uDiffX	>>= 1;
		uFactX	>>= 1;
		}

	uFactX *= 256;

	if(!uDiffX)uDiffX=1;


	if(uOldY<uSizeY)									// Quelle ist kleiner
		{
		uFactY	= uOldY-1;
		uDiffY	= uSizeY-1;
		}
	else{
		uFactY	= uOldY;								// Quelle ist grer
		uDiffY	= uSizeY;
		}

	while(!((uFactY|uDiffY)&1))							// Faktoren krzen
		{
		uDiffY	>>= 1;
		uFactY	>>= 1;
		}

	uVal	= uSizeY;
	uVal   *= uFactY;
	uVal   *= 256;
	uVal  >>= 31;
	uMul    = (unsigned)uVal;

	while(uMul)											// Sind Faktoren zu gro
		{
		uMul	>>= 1;
		uDiffY	>>= 1;
		uFactY	>>= 1;
		}

	uFactY *= 256;

	if(!uDiffY)uDiffY=1;


if(uImageBits!=32)
	{
	uOldX3	= uOldX *3;
	pLine	= new unsigned[uOldX3];


	for(uPosY=0;uPosY<uSizeY;uPosY++)					// Spalten durchlaufen
		{
		uStart = ((uPosY  )*uFactY)/uDiffY;
		uEnd   = ((uPosY+1)*uFactY)/uDiffY;

		if(uStart+256>uEnd )uEnd=uStart+256;			// Stufe zu klein ?
		if(uEnd  /256>uOldY)uEnd=uOldY *256;

		   uDelta=uEnd-uStart;
		if(uDelta<=0)uDelta=1;

		uMul = 256-(uStart&0xFF);						// Start-Ziele holen

		pMemOld=sImage.GetRow3(uStart/256);

		for(uPosX=0;uPosX<uOldX3;uPosX++)
			{
			pLine[uPosX] = ((unsigned)pMemOld[uPosX]*uMul)>>8;
			}

		   uStart /= 256;								// Mitlere Zeilen addieren
		if(uStart<((uEnd-1)/256))
			{
			for(uStart++;uStart<uEnd/256;uStart++)
				{
				pMemOld = sImage.GetRow3(uStart);

				for(uPosX=0;uPosX<uOldX3;uPosX++)
					{
					pLine[uPosX]+=(unsigned)pMemOld[uPosX];
					}
				}

			uMul=uEnd&0xFF;								// Letzte Zeile addieren

			if(uMul)
				{
				pMemOld = sImage.GetRow3(uEnd/256);
				for(uPosX=0;uPosX<uOldX3;uPosX++)
					{
					pLine[uPosX] += ((unsigned)pMemOld[uPosX]*uMul)>>8;
					}
				}
			}

		if(uDelta!=256)									// Normieren
			{
			for(uPosX=0;uPosX<uOldX3;uPosX++)
				{
				pLine[uPosX] = (pLine[uPosX]<<8)/uDelta;
				}
			}

		pMemNew = ROW_PTR(uPosY);

		//**************** X-Richtung *********************************************

		for(uPosX=0;uPosX<uSizeX;uPosX++)
			{
			uStart = ((uPosX  )*uFactX)/uDiffX;
			uEnd   = ((uPosX+1)*uFactX)/uDiffX;

			if(uStart+256>uEnd )uEnd=uStart+256;		// Stufe zu klein ?
			if(uEnd  /256>uOldX)uEnd=uOldX *256;

			   uDelta=uEnd-uStart;
			if(uDelta<=0)uDelta=1;

			uMul	= 256-(uStart&0xFF);				// Start Pixel
			uStart /= 256;
			pPtr	= pLine+uStart*3;

			b = (pPtr[0]*uMul)>>8;
			g = (pPtr[1]*uMul)>>8;
			r = (pPtr[2]*uMul)>>8;
			     pPtr+=3;

			if(uStart<((uEnd-1)/256))					// Weitere Pixel vorhanden
				{
				uMul  = uEnd&0xFF;
				uEnd /= 256;

				for(uStart++;uStart<uEnd;uStart++)		// Mittlere Pixel
					{
					b+=pPtr[0];
					g+=pPtr[1];
					r+=pPtr[2];
					pPtr+=3;
					}

				if(uMul)								// Letzter Pixel
					{
					b+=(pPtr[0]*uMul)>>8;
					g+=(pPtr[1]*uMul)>>8;
					r+=(pPtr[2]*uMul)>>8;
					}
				}

			if(uDelta!=256)								// Normieren
				{
				b=(b<<8)/uDelta;
				g=(g<<8)/uDelta;
				r=(r<<8)/uDelta;
				}

			uCol=uPosX+(uPosX<<1);

			pMemNew[uCol  ]=(unsigned char)b;			// Pixel speichern
			pMemNew[uCol+1]=(unsigned char)g;
			pMemNew[uCol+2]=(unsigned char)r;
			}
		}

	delete pLine;

	return true;
	}

   a = sImage.HasAlphaEx();
if(a<2)													// 32-Bit ohne Alphakanal
	{
	if(a)a=0xFF;

	uOldX3	= uOldX *4;
	pLine	= new unsigned[uOldX3];


	for(uPosY=0;uPosY<uSizeY;uPosY++)					// Spalten durchlaufen
		{
		uStart = ((uPosY  )*uFactY)/uDiffY;
		uEnd   = ((uPosY+1)*uFactY)/uDiffY;

		if(uStart+256>uEnd )uEnd=uStart+256;			// Stufe zu klein ?
		if(uEnd  /256>uOldY)uEnd=uOldY *256;

		   uDelta=uEnd-uStart;
		if(uDelta<=0)uDelta=1;

		uMul = 256-(uStart&0xFF);						// Start-Ziele holen

		pMemOld=sImage.GetRow4(uStart/256);

		for(uPosX=0;uPosX<uOldX3;uPosX+=4)
			{
			pLine[uPosX  ] = ((unsigned)pMemOld[uPosX  ]*uMul)>>8;
			pLine[uPosX+1] = ((unsigned)pMemOld[uPosX+1]*uMul)>>8;
			pLine[uPosX+2] = ((unsigned)pMemOld[uPosX+2]*uMul)>>8;
			}

		   uStart /= 256;								// Mitlere Zeilen addieren
		if(uStart<((uEnd-1)/256))
			{
			for(uStart++;uStart<uEnd/256;uStart++)
				{
				pMemOld = sImage.GetRow4(uStart);

				for(uPosX=0;uPosX<uOldX3;uPosX+=4)
					{
					pLine[uPosX  ]+=(unsigned)pMemOld[uPosX  ];
					pLine[uPosX+1]+=(unsigned)pMemOld[uPosX+1];
					pLine[uPosX+2]+=(unsigned)pMemOld[uPosX+2];
					}
				}

			uMul=uEnd&0xFF;								// Letzte Zeile addieren

			if(uMul)
				{
				pMemOld = sImage.GetRow4(uEnd/256);
				for(uPosX=0;uPosX<uOldX3;uPosX+=4)
					{
					pLine[uPosX  ] += ((unsigned)pMemOld[uPosX  ]*uMul)>>8;
					pLine[uPosX+1] += ((unsigned)pMemOld[uPosX+1]*uMul)>>8;
					pLine[uPosX+2] += ((unsigned)pMemOld[uPosX+2]*uMul)>>8;
					}
				}
			}

		if(uDelta!=256)									// Normieren
			{
			for(uPosX=0;uPosX<uOldX3;uPosX += 4)
				{
				pLine[uPosX  ] = (pLine[uPosX  ]<<8)/uDelta;
				pLine[uPosX+1] = (pLine[uPosX+1]<<8)/uDelta;
				pLine[uPosX+2] = (pLine[uPosX+2]<<8)/uDelta;
				}
			}

		pMemNew = ROW_PTR(uPosY);

		//**************** X-Richtung *********************************************

		for(uPosX=0;uPosX<uSizeX;uPosX++)
			{
			uStart = ((uPosX  )*uFactX)/uDiffX;
			uEnd   = ((uPosX+1)*uFactX)/uDiffX;

			if(uStart+256>uEnd )uEnd=uStart+256;		// Stufe zu klein ?
			if(uEnd  /256>uOldX)uEnd=uOldX *256;

			   uDelta=uEnd-uStart;
			if(uDelta<=0)uDelta=1;

			uMul	= 256-(uStart&0xFF);				// Start Pixel
			uStart /= 256;
			pPtr	= pLine+uStart*4;

			b = (pPtr[0]*uMul)>>8;
			g = (pPtr[1]*uMul)>>8;
			r = (pPtr[2]*uMul)>>8;
			     pPtr+=4;

			if(uStart<((uEnd-1)/256))					// Weitere Pixel vorhanden
				{
				uMul  = uEnd&0xFF;
				uEnd /= 256;

				for(uStart++;uStart<uEnd;uStart++)		// Mittlere Pixel
					{
					b+=pPtr[0];
					g+=pPtr[1];
					r+=pPtr[2];
					pPtr+=4;
					}

				if(uMul)								// Letzter Pixel
					{
					b+=(pPtr[0]*uMul)>>8;
					g+=(pPtr[1]*uMul)>>8;
					r+=(pPtr[2]*uMul)>>8;
					}
				}

			if(uDelta!=256)								// Normieren
				{
				b=(b<<8)/uDelta;
				g=(g<<8)/uDelta;
				r=(r<<8)/uDelta;
				}

			uCol=uPosX*4;

			pMemNew[uCol  ]=(unsigned char)b;			// Pixel speichern
			pMemNew[uCol+1]=(unsigned char)g;
			pMemNew[uCol+2]=(unsigned char)r;
			pMemNew[uCol+3]=(unsigned char)a;
			}
		}


	delete pLine;

	return TRUE;
	}


	{
	uOldX3	= uOldX *4;									// Mit Alphakanal
	pLine	= new unsigned[uOldX3+uOldX];
	pDelta	= pLine+uOldX3;


	for(uPosY=0;uPosY<uSizeY;uPosY++)					// Spalten durchlaufen
		{
		uStart = ((uPosY  )*uFactY)/uDiffY;
		uEnd   = ((uPosY+1)*uFactY)/uDiffY;

		if(uStart+256>uEnd )uEnd=uStart+256;			// Stufe zu klein ?
		if(uEnd  /256>uOldY)uEnd=uOldY *256;

		   uDelta=uEnd-uStart;
		if(uDelta<=0)uDelta=1;

		uMul = 256-(uStart&0xFF);						// Start-Ziele holen

		pMemOld=sImage.GetRow4(uStart/256);

		for(uPosX=0;uPosX<uOldX3;uPosX+=4)
			{
				a = pMemOld[uPosX+3];
			if(!a)
				{
				pLine[uPosX  ] = 0;
				pLine[uPosX+1] = 0;
				pLine[uPosX+2] = 0;
				pLine[uPosX+3] = 0;
				PTR_INT(pDelta,uPosX) = 0;
				continue;
				}

			pLine[uPosX  ] = ((unsigned)pMemOld[uPosX  ]*uMul)>>8;
			pLine[uPosX+1] = ((unsigned)pMemOld[uPosX+1]*uMul)>>8;
			pLine[uPosX+2] = ((unsigned)pMemOld[uPosX+2]*uMul)>>8;
			pLine[uPosX+3] = ((unsigned)pMemOld[uPosX+3]*uMul)>>8;
			PTR_INT(pDelta,uPosX) = uMul;
			}

		   uStart /= 256;								// Mitlere Zeilen addieren
		if(uStart<((uEnd-1)/256))
			{
			for(uStart++;uStart<uEnd/256;uStart++)
				{
				pMemOld = sImage.GetRow4(uStart);

				for(uPosX=0;uPosX<uOldX3;uPosX+=4)
					{
						a = pMemOld[uPosX+3];
					if(!a)continue;

					pLine [uPosX  ] += (unsigned)pMemOld[uPosX  ];
					pLine [uPosX+1] += (unsigned)pMemOld[uPosX+1];
					pLine [uPosX+2] += (unsigned)pMemOld[uPosX+2];
					pLine [uPosX+3] += (unsigned)pMemOld[uPosX+3];
					PTR_INT(pDelta,uPosX) += 256;
					}
				}

			uMul=uEnd&0xFF;								// Letzte Zeile addieren

			if(uMul)
				{
				pMemOld = sImage.GetRow4(uEnd/256);
				for(uPosX=0;uPosX<uOldX3;uPosX+=4)
					{
						a = pMemOld[uPosX+3];
					if(!a)continue;

					pLine[uPosX  ] += ((unsigned)pMemOld[uPosX  ]*uMul)>>8;
					pLine[uPosX+1] += ((unsigned)pMemOld[uPosX+1]*uMul)>>8;
					pLine[uPosX+2] += ((unsigned)pMemOld[uPosX+2]*uMul)>>8;
					pLine[uPosX+3] += ((unsigned)pMemOld[uPosX+3]*uMul)>>8;
					PTR_INT(pDelta,uPosX) += uMul;
					}
				}
			}

		for(uPosX=0;uPosX<uOldX3;uPosX+=4)				// Farben normieren
			{
			   uMul = PTR_INT(pDelta,uPosX);
			if(uMul!=0 && uMul!=256)
				{
				pLine[uPosX  ] = (pLine[uPosX  ]<<8)/uMul;
				pLine[uPosX+1] = (pLine[uPosX+1]<<8)/uMul;
				pLine[uPosX+2] = (pLine[uPosX+2]<<8)/uMul;
				}
			}

		if(uDelta!=256)									// Alpha-Maske normieren
			{
			for(uPosX=3;uPosX<uOldX3;uPosX+=4)
				{
				pLine[uPosX] = (pLine[uPosX]<<8)/uDelta;
				}
			}

		pMemNew = ROW_PTR(uPosY);

		//**************** X-Richtung *********************************************

		for(uPosX=0;uPosX<uSizeX;uPosX++)
			{
			uStart = ((uPosX  )*uFactX)/uDiffX;
			uEnd   = ((uPosX+1)*uFactX)/uDiffX;

			if(uStart+256>uEnd )uEnd=uStart+256;		// Stufe zu klein ?
			if(uEnd  /256>uOldX)uEnd=uOldX *256;

			   uDelta=uEnd-uStart;
			if(uDelta<=0)uDelta=1;

			uMul	= 256-(uStart&0xFF);				// Start Pixel
			uStart /= 256;
			pPtr	= pLine+uStart*4;

			if(pPtr[3]==0)
				{
				d = 0;
				b = 0;
				g = 0;
				r = 0;
				a = 0;
				}
			else{
				d = uMul;
				b = (pPtr[0]*uMul)>>8;
				g = (pPtr[1]*uMul)>>8;
				r = (pPtr[2]*uMul)>>8;
				a = (pPtr[3]*uMul)>>8;
				}

			 pPtr+=4;

			if(uStart<((uEnd-1)/256))					// Weitere Pixel vorhanden
				{
				uMul  = uEnd&0xFF;
				uEnd /= 256;

				for(uStart++;uStart<uEnd;uStart++)		// Mittlere Pixel
					{
					if(pPtr[3])
						{
						d += 256;
						b += pPtr[0];
						g += pPtr[1];
						r += pPtr[2];
						a += pPtr[3];
						}

					pPtr+=4;
					}

				if(uMul)								// Letzter Pixel
					{
					if(pPtr[3])
						{
						d += uMul;
						b += (pPtr[0]*uMul)>>8;
						g += (pPtr[1]*uMul)>>8;
						r += (pPtr[2]*uMul)>>8;
						a += (pPtr[3]*uMul)>>8;
						}

					}
				}


			if(d!=0 && d!=256)							// Farbe normieren
				{
				b = (b<<8)/d;
				g = (g<<8)/d;
				r = (r<<8)/d;
				}

			if(uDelta!=256)								// Alpha-Wert normieren
				{
				a = (a<<8)/uDelta;
				}

			uCol = uPosX*4;

			pMemNew[uCol  ]=(unsigned char)b;			// Pixel speichern
			pMemNew[uCol+1]=(unsigned char)g;
			pMemNew[uCol+2]=(unsigned char)r;
			pMemNew[uCol+3]=(unsigned char)a;
			}
		}
	}

	delete pLine;


return true;
}

//*****************************************************************************
//*
//*		ConvertToColors
//*
//*****************************************************************************
//	Konvertiert ein Bild in ein Bild mit Farbpallete
//	sImage		: Ist das Bild das konvertiert werden soll
//	uMax		: Modus fr die Farberstellung
//					Bit  0..23 = Ist die maximale Farbanzahl (0=aus Zielbild)
//					Bit 24..31 = Ist die neue Bitanzahl (0=auto)
//	pColors		: Ist der Zeiger auf die Farben
//				    Bit  0...7 = Blau
//				    Bit  8..15 = Grn
//				    Bit 16..23 = Rot
//				  Bei NULL werden die Farben aus dem Zielbild geholt
//	Ergibt TRUE wenn das Bild konvertiert wurde
bool BitmapImage::ConvertToColors(const BitmapImage &sImage,unsigned uMax,COLORREF *pColors)
{
COLORREF		aColors[256];
unsigned char  *pRow;
unsigned		uBest;
unsigned		uDiff;
unsigned		uBits;
unsigned		uPosX;
unsigned		uPosY;
unsigned		uPos;
unsigned		uRgb;
unsigned		uMin;
unsigned		uNow;



	if(!sImage.IsOk())									// Ist das Quellbild ok
		{
		SetSize(0,0,0);
		return false;
		}

	uBits	= uMax>>24;
	uMax   &= 0x00FFFFFF;

	if(uMax==0)											// Farbzahl aus aktuellen Bild
		{
		if(uImageBits<8 && uImageBits>0)
				uMax=1<<uImageBits;
		else	uMax=256;
		}

	if(uBits==0)										// Bits fr neues Bild ermitteln
		{
			 if(uMax>16)uBits=8;
		else if(uMax> 4)uBits=4;
		else if(uMax> 2)uBits=2;
		else            uBits=1;
		}

	if(uMax>(unsigned)(1<<uBits))						// Maximale Farbanzahl prfen
		{
		uMax = 1<<uBits;
		}

	if(pColors==0)										// Farben aus aktuellen Bild
		{
		if(!IsOk())
			{
			SetSize(uBits,sImage.Width(),sImage.Height(),BI_NOT_INIT);
			uBits = 0;
			}

		for(uPos=0;uPos<uMax;uPos++)
			{
			aColors[uPos] = pColorMap[uPos].uRgb;
			}
		}
	else{												// Farben aus dem Array holen
		for(uPos=0;uPos<uMax;uPos++)
			{
			aColors[uPos] = pColors[uPos];
			}
		}

	if(uBits)
		{
		SetSize(uBits,sImage.Width(),sImage.Height(),BI_NOT_INIT);
		}


	if(sImage.IsRGB())									// RGB-Bild
		{
		for(uPosY=sImage.Height();uPosY!=0;)			// Zeilenweise scannen
			{
			uPosY--;
			pRow = sImage.GetRow_(uPosY);

			for(uPosX=sImage.Width();uPosX!=0;)			// Eine Zeile abarbeiten
				{
				uPosX--;
				uRgb	= sImage.GetPixel_(pRow,uPosX);
				uMin	= ColorDiff(uRgb,aColors[0]);
				uBest	= 0;

				for(uNow=1;uNow<uMax;uNow++)			// Welche Farbe passt am besten
					{
					   uDiff = ColorDiff(uRgb,aColors[uNow]);
					if(uDiff>=uMin)continue;
					uMin  = uDiff;
					uBest = uNow;
					}

				SetPixel(uPosX,uPosY,uBest);
				}
			}
		}												// Palletenbild
	else{
		for(uPosY=sImage.Height();uPosY!=0;)			// Zeilenweise scannen
			{
			uPosY--;
			pRow = ROW_PTR(uPosY);

			for(uPosX=sImage.Width();uPosX!=0;)			// Eine Zeile abarbeiten
				{
				uPosX--;
				uRgb	= sImage.GetPixel_(pRow,uPosX);
				uRgb	= sImage.pColorMap[uRgb].uRgb;
				uMin	= ColorDiff(uRgb,aColors[0]);
				uBest	= 0;

				for(uNow=1;uNow<uMax;uNow++)			// Welche Farbe passt am besten
					{
					   uDiff = ColorDiff(uRgb,aColors[uNow]);
					if(uDiff>=uMin)continue;
					uMin  = uDiff;
					uBest = uNow;
					}

				SetPixel(uPosX,uPosY,uBest);
				}
			}
		}



return true;
}

//*****************************************************************************
//*
//*		ConvertToRGB
//*
//*****************************************************************************
//	Konvertiert ein Bild in ein RGB-Bild
//	sImage		: Ist das Bild das konvertiert werden soll
//	uBits		: Ist das RGB Format (32,24,16,15,12)
//				  Ist Bits 0 so wird das 24-Bit-Format benutzt
//	Ergibt TRUE wenn das Bild konvertiert wurde
bool BitmapImage::ConvertToRGB(const BitmapImage &sImage,unsigned uBits)
{
unsigned	uMaxX;
unsigned	uMaxY;
unsigned	uPosX;
unsigned	uPosY;
unsigned	uCol;


	if(uBits==0)uBits=24;

	if(!sImage.IsOk() || uBits<12)
		{
		SetSize(0,0,0);
		return false;
		}

	if(sImage.uImageBits==uBits)
		{
		DoCopy(sImage);
		return 1;
		}

	uMaxX = sImage.uImageWidth;
	uMaxY = sImage.uImageHeight;

	SetSize(uBits,uMaxX,uMaxY,BI_NOT_INIT);

	for(uPosY=0;uPosY<uMaxY;uPosY++)
	for(uPosX=0;uPosX<uMaxX;uPosX++)
		{
		uCol = sImage.GetRGB(uPosX,uPosY);
		SetPixel(uPosX,uPosY,uCol);
		}


return true;
}


//*****************************************************************************
//*
//*		PutAlpha
//*
//*****************************************************************************
//	Speichert das Bild sImage in der Klasse mittels Alphablending.
//	Die Alpha-Maske des Hintergundbildes wird dabei als undurchsichtig beachtet.
//	sImage		: Ist das einzufgende Bild (muss 32 Bit sein)
//	iPosX/iPosY	: Einfgeposition
//	Ergibt 1 wenn das Bild gespeichert werden konnte.
bool BitmapImage::PutAlpha(const BitmapImage &sImage,int iPosX,int iPosY)
{
unsigned char  *pGet;
unsigned 		uAlpha1;
unsigned 		uAlpha2;
unsigned 		uValue;
unsigned 		uColor;
int				iPutBits;
int				iSizeX;
int				iSizeY;
int				iNewX;
int				iAddX;
int				iNewY;
int				i;


	iPutBits = sImage.uImageBits;
	iSizeX   = sImage.uImageWidth;
	iSizeY   = sImage.uImageHeight;
	iNewX    = 0;
	iNewY    = 0;

	if(!IsOk() || !IsRGB()     )return 0;				// Leeres Bild ?
	if(iPutBits!=32            )return 0;
	if(iSizeX<=0 || iSizeX<=0  )return 0;

	if(iPosX>=(int)uImageWidth )return 0;				// Position prfen
	if(iPosY>=(int)uImageHeight)return 0;
	if(iPosX+iSizeX<= 0        )return 0;
	if(iPosY+iSizeY<= 0        )return 0;
	if(iPosX       <  0        ){iNewX=-iPosX;iSizeX+=iPosX;iPosX=0;}
	if(iPosY       <  0        ){iNewY=-iPosY;iSizeY+=iPosY;iPosY=0;}
	if(iPosX+iSizeX> (int)uImageWidth ){iSizeX=uImageWidth -iPosX  ;}
	if(iPosY+iSizeY> (int)uImageHeight){iSizeY=uImageHeight-iPosY  ;}



//******************** Pixel kopieren *****************************************


	pGet	= sImage[iNewY]+(iNewX<<2);
	iAddX	= sImage.uRowWidth+4*iSizeX;


	for(;iSizeY>0;iSizeY--,iPosY++,pGet-=iAddX)			// Reihen kopieren
		{
		for(i=0;i<iSizeX;i++,pGet+=4)
			{
			if(!pGet[3])continue;						// Quellpunkt total durchsichtig

			uColor	= GetPixel(iPosX+i,iPosY);

			if(uColor<=0x00FFFFFF)						// Hintergrund durchsichtig
				{
				SetPixel(iPosX+i,iPosY,*(unsigned*)pGet);
				continue;
				}

			uAlpha1	= pGet[3]+1;
			uAlpha2	= 257-uAlpha1;

			if(uColor>=0xFF000000)						// Hintergrund undurchsichtig
				{
				uValue	= uColor&0xFF000000;
				uValue |= ((pGet[0]*uAlpha1+( uColor     &0xFF)*uAlpha2)>>8);
				uValue |= ((pGet[1]*uAlpha1+((uColor>> 8)&0xFF)*uAlpha2)   )&0x0000FF00;
				uValue |= ((pGet[2]*uAlpha1+((uColor>>16)&0xFF)*uAlpha2)<<8)&0x00FF0000;
				}
			else{
				uValue  = ((pGet[0]*uAlpha1+( uColor     &0xFF)*uAlpha2)>> 8);
				uValue |= ((pGet[1]*uAlpha1+((uColor>> 8)&0xFF)*uAlpha2)    )&0x0000FF00;
				uValue |= ((pGet[2]*uAlpha1+((uColor>>16)&0xFF)*uAlpha2)<< 8)&0x00FF0000;
				uValue |= ((pGet[3]*uAlpha1+((uColor>>24)&0xFF)*uAlpha2)<<16)&0xFF000000;
				}

			SetPixel(iPosX+i,iPosY,uValue);
			}
		}



return 1;
}

//*****************************************************************************
//*
//*		PutAlphaEx
//*
//*****************************************************************************
//	Speichert das Bild sImage in der Klasse mittels Alphablending. Die Alpha-
//	Maske des Hintergundbildes wird dabei als undurchsichtig betrachtet.
//	sImage		: Ist das einzufgende Bild (muss 32 Bit sein)
//	iPosX/iPosY	: Einfgeposition
//	Ergibt 1 wenn das Bild gespeichert werden konnte.
bool BitmapImage::PutAlphaEx(const BitmapImage &sImage,int iPosX,int iPosY)
{
unsigned char  *pGet;
unsigned char  *pSet;
unsigned char	aArray[4];
unsigned 		uAlpha1;
unsigned 		uAlpha2;
unsigned 		uValue;
unsigned 		uColor;
unsigned		uIndex;
int				iSizeX;
int				iSizeY;
int				iBits;
int				iNewX;
int				iAddX;
int				iNewY;
int				i;


	iSizeX  = sImage.uImageWidth;
	iSizeY  = sImage.uImageHeight;
	iBits	= sImage.uImageBits;
	iNewX   = 0;
	iNewY   = 0;

	if(IsOk()==0 || IsRGB()==0 )return 0;				// Leeres Bild ?
	if(iSizeX<=0 || iSizeX <=0 )return 0;

	if(iPosX>=(int)uImageWidth )return 0;				// Position prfen
	if(iPosY>=(int)uImageHeight)return 0;
	if(iPosX+iSizeX<= 0        )return 0;
	if(iPosY+iSizeY<= 0        )return 0;
	if(iPosX       <  0        ){iNewX=-iPosX;iSizeX+=iPosX;iPosX=0;}
	if(iPosY       <  0        ){iNewY=-iPosY;iSizeY+=iPosY;iPosY=0;}
	if(iPosX+iSizeX> (int)uImageWidth ){iSizeX=uImageWidth -iPosX  ;}
	if(iPosY+iSizeY> (int)uImageHeight){iSizeY=uImageHeight-iPosY  ;}


//******************** Quelle ist ein Pallettenbild ***************************


	if(iBits<=8)
		{
		for(;iSizeY>0;iSizeY--,iPosY++,iNewY++)			// Reihen kopieren
			{
			pSet =        GetRow(iPosY);
			pGet = sImage.GetRow(iNewY);

			for(i=0;i<iSizeX;i++)
				{
				uIndex = sImage.GetPixel_(pGet,iNewX+i);
				SET_DW(aArray,sImage.GetColor(uIndex));

				if(aArray[3]==0x00)						// Quellpunkt total durchsichtig
					{
					uValue	= GetPixel_(pSet,iPosX+i);
					uValue |= 0xFF000000;
					}
				else if(aArray[3]==0xFF)				// Quellpunkt total undurchsichtig
					{
					uValue  = GET_DW(aArray);
					}
				else{									// Quellpunkt teilweise durchsichtig
					uColor	= GetPixel_(pSet,iPosX+i);
					uAlpha1	= aArray[3]+1;
					uAlpha2	= 257-uAlpha1;

					uValue	= 0xFF000000;
					uValue |= ((aArray[0]*uAlpha1+( uColor     &0xFF)*uAlpha2)>> 8);
					uValue |= ((aArray[1]*uAlpha1+((uColor>> 8)&0xFF)*uAlpha2)    )&0x0000FF00;
					uValue |= ((aArray[2]*uAlpha1+((uColor>>16)&0xFF)*uAlpha2)<< 8)&0x00FF0000;
					}

				SetPixel_(pSet,iPosX+i,uValue);
				}
			}

		return 1;
		}


//******************** Quelle ist ein Bild ohne Alpha-Maske *******************


	if(iBits!=32)
		{
		for(;iSizeY>0;iSizeY--,iPosY++,iNewY++)			// Reihen kopieren
			{
			pSet =        GetRow(iPosY);
			pGet = sImage.GetRow(iNewY);

			for(i=0;i<iSizeX;i++)
				{
				SET_DW(aArray,sImage.GetPixel_(pGet,iNewX+i));

				if(aArray[3]==0x00)						// Quellpunkt total durchsichtig
					{
					uValue	= GetPixel_(pSet,iPosX+i);
					}
				else if(aArray[3]==0xFF)				// Quellpunkt total undurchsichtig
					{
					uValue  = GET_DW(aArray);
					}
				else{									// Quellpunkt teilweise durchsichtig
					uColor	= GetPixel_(pSet,iPosX+i);
					uAlpha1	= aArray[3]+1;
					uAlpha2	= 257-uAlpha1;

					uValue  = ((aArray[0]*uAlpha1+( uColor     &0xFF)*uAlpha2)>> 8);
					uValue |= ((aArray[1]*uAlpha1+((uColor>> 8)&0xFF)*uAlpha2)    )&0x0000FF00;
					uValue |= ((aArray[2]*uAlpha1+((uColor>>16)&0xFF)*uAlpha2)<< 8)&0x00FF0000;
					}

				SetPixel_(pSet,iPosX+i,uValue);
				}
			}

		return 1;
		}


//******************** Pixel kopieren *****************************************


	pGet	= sImage[iNewY]+(iNewX<<2);
	iAddX	= sImage.uRowWidth+4*iSizeX;


	for(;iSizeY>0;iSizeY--,iPosY++,pGet-=iAddX)			// Reihen kopieren
		{
		pSet = GetRow(iPosY);

		for(i=0;i<iSizeX;i++,pGet+=4)
			{
			if(pGet[3]==0x00)							// Quellpunkt total durchsichtig
				{
				uValue	= GetPixel_(pSet,iPosX+i);
				}
			else if(pGet[3]==0xFF)						// Quellpunkt total undurchsichtig
				{
				uValue  = GET_DW(pGet);
				uValue |= 0xFF000000;
				}
			else{										// Quellpunkt teilweise durchsichtig
				uColor	= GetPixel_(pSet,iPosX+i);
				uAlpha1	= pGet[3]+1;
				uAlpha2	= 257-uAlpha1;

				uValue	= 0xFF000000;
				uValue |= ((pGet[0]*uAlpha1+( uColor     &0xFF)*uAlpha2)>> 8);
				uValue |= ((pGet[1]*uAlpha1+((uColor>> 8)&0xFF)*uAlpha2)    )&0x0000FF00;
				uValue |= ((pGet[2]*uAlpha1+((uColor>>16)&0xFF)*uAlpha2)<< 8)&0x00FF0000;
				}

			SetPixel_(pSet,iPosX+i,uValue);
			}
		}



return 1;
}

//*****************************************************************************
//*
//*		PutMask
//*
//*****************************************************************************
//	Speichert das Bild sImage in der Klasse mittels Maske
//	sImage		: Ist das einzufgende Bild (muss 32 Bit sein)
//	iPosX/iPosY	: Einfgeposition
//	sMask		: Maske fr das Einfgen. (Nur Pixel mit 0 werden bertragen)
//	Ergibt 1 wenn das Bild gespeichert werden konnte.
bool BitmapImage::PutMask(const BitmapImage &sImage,int iPosX,int iPosY,const BitmapImage &sMask)
{
unsigned char  *pGet;
unsigned char  *pMask;
unsigned 		uColor;
int				iPutBits;
int				iSizeX;
int				iSizeY;
int				iNewX;
int				iNewY;
int				iEndX;
int				iOffX;
int				i;


	iPutBits = sImage.uImageBits;
	iSizeX   = sImage.uImageWidth;
	iSizeY   = sImage.uImageHeight;
	iNewX	 = 0;
	iNewY    = 0;

	if(!IsOk() ||!sImage.IsOk())return 0;				// Leeres Bild ?
	if(iSizeX<=0 || iSizeX<=0  )return 0;

	if(iPosX>=(int)uImageWidth )return 0;				// Position prfen
	if(iPosY>=(int)uImageHeight)return 0;
	if(iPosX+iSizeX<= 0        )return 0;
	if(iPosY+iSizeY<= 0        )return 0;
	if(iPosX       <  0        ){iNewX=-iPosX;iSizeX+=iPosX;iPosX=0;}
	if(iPosY       <  0        ){iNewY=-iPosY;iSizeY+=iPosY;iPosY=0;}
	if(iPosX+iSizeX> (int)uImageWidth ){iSizeX=uImageWidth -iPosX  ;}
	if(iPosY+iSizeY> (int)uImageHeight){iSizeY=uImageHeight-iPosY  ;}


//******************** Pixel kopieren *****************************************


	pGet	= sImage[iNewY];
	pMask	= sMask [iNewY];
	iEndX	= iNewX+iSizeX;
	iOffX	= iPosX-iNewX;


	if(!sImage.IsRGB() && IsRGB())
		{
		for(;iSizeY>0;iSizeY--,iPosY++)					// Reihen kopieren
			{
			for(i=iNewX;i<iEndX;i++)
				{
				if(sMask.GetPixel_(pMask,i))continue;
				uColor = sImage.GetPixel_(pGet,i);
				uColor = sImage.pColorMap[uColor].uRgb;
				SetPixel(iOffX+i,iPosY,uColor);
				}

			pGet  -= sImage.uRowWidth;
			pMask -= sMask .uRowWidth;
			}
		}
	else{
		for(;iSizeY>0;iSizeY--,iPosY++)					// Reihen kopieren
			{
			for(i=iNewX;i<iEndX;i++)
				{
				if(sMask.GetPixel_(pMask,i))continue;
				uColor = sImage.GetPixel_(pGet,i);
				SetPixel(iOffX+i,iPosY,uColor);
				}

			pGet  -= sImage.uRowWidth;
			pMask -= sMask .uRowWidth;
			}
		}


return 1;
}

//*****************************************************************************
//*
//*		Put
//*
//*****************************************************************************
//	Speichert ein Bild in der eigenen Bildinstanz
//	sImage	: Ist das Bild das eingefgt werden soll
//	iPosX	: Ist die X-Koordinate an der das Bild in die Instanz eingefgt wird
//	iPosY	: Ist die Y-Koordinate an der das Bild in die Instanz eingefgt wird
//	iMode	: Bit	24==1	Farbmaske fr sImage
//					25==1	Maskenbits in sImage nicht zeichnen
//					26==1	Maskenbits in sImage       zeichnen
//					27==1	Maskenbits in sImage nicht bermalen (fr 0x40000000 Maske)
//					28==1	Farbmaske fr *this
//					29==1	Maskenbits in *this nicht bermalen
//					30==1	Maskenbits in *this       bermalen
//					31==1	Maskenbits in *this nicht bermalen (fr 0x40000000 Maske)
bool BitmapImage::Put(const BitmapImage &sImage,int iPosX,int iPosY,int iMode)
{
unsigned char  *pPut;
unsigned char  *pGet;
int				iRgb;
int				iMul;
int				iMask;
int				iGetBits;
int				iPutBits;
int				iPutAdd;
int				iGetAdd;
int				iSizeX;
int				iSizeY;
int				iAlpha;
int				iNewX;
int				iEndX;
int				iAddX;
int				iNewY;
int				i,k;


	pPut	 = 0;
	iNewX	 = 0;
	iNewY	 = 0;
	iGetBits = uImageBits;
	iPutBits = sImage.uImageBits;
	iSizeX   = sImage.uImageWidth;
	iSizeY   = sImage.uImageHeight;


	if(!IsOk()                 )return 0;				// Leeres Bild ?
	if(iSizeX<=0 || iSizeX<=0  )return 0;
	if(iPosX>=(int)uImageWidth )return 0;				// Position prfen
	if(iPosY>=(int)uImageHeight)return 0;
	if(iPosX+iSizeX<= 0        )return 0;
	if(iPosY+iSizeY<= 0        )return 0;
	if(iPosX       <  0        ){iNewX=-iPosX;iSizeX+=iPosX;iPosX=0;}
	if(iPosY       <  0        ){iNewY=-iPosY;iSizeY+=iPosY;iPosY=0;}
	if(iPosX+iSizeX> (int)uImageWidth ){iSizeX=uImageWidth -iPosX  ;}
	if(iPosY+iSizeY> (int)uImageHeight){iSizeY=uImageHeight-iPosY  ;}

//******************** Modi korrigieren ***************************************

	if(       uPixelBit&0x008088FF)iMode&=~0xE0000000;	// Keine Maske
	if(sImage.uPixelBit&0x008088FF)iMode&=~0x0E000000;
	if(       uPixelBit&0x00004000)iMode&=~0x80000000;
	if(sImage.uPixelBit&0x00004000)iMode&=~0x08000000;
														// Falsche Modi lschen
	if(iMode&0x01000000)iMode&= 0xF1000000|sImage.uColorMask;
	if(iMode&0x10000000)iMode&= 0x1F000000|       uColorMask;
	if(iMode&0x02000000)iMode&=~0xF2FFFFFF;
	if(iMode&0x20000000)iMode&=~0x2FFFFFFF;
	if(iMode&0x04000000)iMode&=~0xF4FFFFFF;
	if(iMode&0x40000000)iMode&=~0x4FFFFFFF;


//******************** Gleiche Bitzahl ****************************************
if(iGetBits==iPutBits)
	{

	if((iMode&0xFF000000)==0)							// Normal Modus
	{
	pGet = ROW_PTR(iPosY);
	pPut = sImage [iNewY];


//******************** Normal <=12 Bits ***************************************

	if(iPutBits<=12 && iPutBits!=8)						// Keine gerade Bitzahl ?
	for(;;)
		{
		iMul=0;
		if(iPutBits==12)								// 12Bit zu 3*4Bit
			{
			iPosX*=3;iNewX*=3;iSizeX*=3;iPutBits=4;
			}
		if(iPutBits==1 && !(iPosX&7) && !(iNewX&7) && !(iSizeX&7))iMul=3;
		if(iPutBits==2 && !(iPosX&3) && !(iNewX&3) && !(iSizeX&3))iMul=2;
		if(iPutBits==4 && !(iPosX&1) && !(iNewX&1) && !(iSizeX&1))iMul=1;
		if(iMul){iPosX>>=iMul;iNewX>>=iMul;iSizeX>>=iMul;iPutBits=8;break;}

		unsigned (FC *GetP)(unsigned char*,unsigned);
		void     (FC *SetP)(unsigned char*,unsigned,unsigned);

		GetP	= GetPixel_;
		SetP	= SetPixel_;
		iAddX	= iPosX -iNewX;
		iEndX	= iSizeX+iNewX;
		iSizeX	= sImage.uRowWidth;
														// Pixel kopieren
		for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iSizeX)
		for(i=iNewX;i<iEndX;i++)
			{
			k=GetP(pPut,i);
			  SetP(pGet,i+iAddX,k);
			}

		return 1;
		}

//******************** Normal / 32,24,16,15,8+passente ************************

	iPutAdd  = ADD[iPutBits];
	iPosX	*= iPutAdd;
	iNewX	*= iPutAdd;
	iSizeX	*= iPutAdd;

	pGet	+= iPosX;									// Zum Anfang
	pPut	+= iNewX;
	iGetAdd  = uRowWidth;
	iPutAdd	 = sImage.uRowWidth;

	for(;iSizeY>0;iSizeY--)								// Reihen kopieren
		{
		memcpy(pGet,pPut,iSizeX);
		pGet-=iGetAdd;
		pPut-=iPutAdd;
		}

	return 1;
	}

//******************** Masken & Farbe fr 32Bit *******************************
if(iPutBits==32)
	{
	pGet =ROW_PTR(iPosY)+(iPosX<<2);
	pPut =sImage [iNewY]+(iNewX<<2);

	#undef	get
	#undef	put
	#define get	((unsigned*)pGet)
	#define put	((unsigned*)pPut)

	iAddX=sImage.uRowWidth;

	switch(iMode&0x0F000000)
		{
	case 0x00000000:									// Normales Put-Bild

		switch(iMode&0xF0000000)
			{
		case 0x10000000:								// 32 Normal/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if( ((get[i]^iMode)&0x00FFFFFF))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x20000000:								// 32 Normal/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x40000000:								// 32 Normal/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(! (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		default:										// 32 Normal/Maske4-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (get[i]      &0x40000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
			}break;

	case 0x01000000:									// Put-Bild Mit Farbausschluss

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 32 Farbe/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x00FFFFFF))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x10000000:								// 32 Farbe/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x00FFFFFF))continue;
							if( ((get[i]^iMode)&0x00FFFFFF))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x20000000:								// 32 Farbe/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x00FFFFFF))continue;
							if(  (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x40000000:								// 32 Farbe/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x00FFFFFF))continue;
							if(! (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		default:										// 32 Farbe/Maske4-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x00FFFFFF))continue;
							if(  (get[i]      &0x40000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
			}break;

	case 0x02000000:									// Put-Bild Mit Maske nicht zeichnen

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 32 Maske-/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x10000000:								// 32 Maske-/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x80000000))continue;
							if( ((get[i]^iMode)&0x00FFFFFF))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x20000000:								// 32 Maske-/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x80000000))continue;
							if(  (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x40000000:								// 32 Maske-/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x80000000))continue;
							if(! (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		default:										// 32 Maske-/Maske4-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x80000000))continue;
							if(  (get[i]      &0x40000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
			}break;

	case 0x04000000:									// Put-Bild Mit Maske zeichnen

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 32 Maske+/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(! (put[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x10000000:								// 32 Maske+/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(! (put[i]      &0x80000000))continue;
							if( ((get[i]^iMode)&0x00FFFFFF))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x20000000:								// 32 Maske+/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(! (put[i]      &0x80000000))continue;
							if(  (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x40000000:								// 32 Maske+/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(! (put[i]      &0x80000000))continue;
							if(! (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		default:										// 32 Maske+/Maske4-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(! (put[i]      &0x80000000))continue;
							if(  (get[i]      &0x40000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
			}break;

	case 0x08000000:									// Put-Bild Mit 0x40.. Maske nicht zeichnen

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 32 Maske4-/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x40000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x10000000:								// 32 Maske4-/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x80000000))continue;
							if( ((get[i]^iMode)&0x00FFFFFF))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x20000000:								// 32 Maske4-/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x40000000))continue;
							if(  (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		case 0x40000000:								// 32 Maske4-/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x40000000))continue;
							if(! (get[i]      &0x80000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
		default:										// 32 Maske4-/Maske4-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(  (put[i]      &0x40000000))continue;
							if(  (get[i]      &0x40000000))continue;
							get[i]&=0xFF000000;
							get[i]|=0x00FFFFFF&put[i];
							}break;
			}break;
		}

	return 1;
	}

//******************** Masken & Farbe fr 24Bit *******************************
if(iPutBits==24)
	{
	pGet = ROW_PTR(iPosY)+(iPosX*3);
	pPut = sImage [iNewY]+(iNewX*3);

	#undef	get
	#undef	put
	#define get	*((unsigned*)(pGet+i))
	#define put	*((unsigned*)(pPut+i))

	iAddX=sImage.uRowWidth;
	iSizeX*=3;

	switch(iMode&0xFF000000)
		{
	case 0x10000000:									// 24 Put=Normal Get=Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i+=3)
							{
							if( ((get^iMode)&0x00FFFFFF))continue;
							get&=0xFF000000;
							get|=0x00FFFFFF&put;
							}break;
	case 0x01000000:									// 24 Put=Farbe Get=Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i+=3)
							{
							if(!((put^iMode)&0x00FFFFFF))continue;
							get&=0xFF000000;
							get|=0x00FFFFFF&put;
							}break;
	default:											// 24 Put=Farbe Get=Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i+=3)
							{
							if( ((get^iMode)&0x00FFFFFF))continue;
							if(!((put^iMode)&0x00FFFFFF))continue;
							get&=0xFF000000;
							get|=0x00FFFFFF&put;
							}break;
		}
	return 1;
	}

//******************** Masken & Farbe fr 16Bit *******************************
if(iPutBits==16)
	{
	pGet = ROW_PTR(iPosY)+(iPosX<<1);
	pPut = sImage [iNewY]+(iNewX<<1);

	#undef	get
	#undef	put
	#define get	*((short*)(pGet+i))
	#define put	*((short*)(pPut+i))

	iAddX    = sImage.uRowWidth;
	iSizeX <<= 1;

	iMode=(iMode&0xFF000000)|(RGB_TO_C16(iMode)&0x00FFFFFF);


	switch(iMode&0xFF000000)
		{
	case 0x10000000:									// 16 Put=Normal Get=Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i+=2)
							{
							if( ((get^iMode)&0xFFFF))continue;
							get=put;
							}break;
	case 0x01000000:									// 16 Put=Farbe Get=Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i+=2)
							{
							if(!((put^iMode)&0xFFFF))continue;
							get=put;
							}break;
	default:											// 16 Put=Farbe Get=Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i+=2)
							{
							if( ((get^iMode)&0xFFFF))continue;
							if(!((put^iMode)&0xFFFF))continue;
							get=put;
							}break;
		}

	return 1;
	}

//******************** Masken & Farbe fr 15Bit *******************************
if(iPutBits==15)
	{
	pGet = ROW_PTR(iPosY)+(iPosX<<1);
	pPut = sImage [iNewY]+(iNewX<<1);

	#undef	get
	#undef	put
	#define get	((short*)pGet)
	#define put	((short*)pPut)

	iAddX = sImage.uRowWidth;
	iMode = (iMode&0xFF000000)|(RGB_TO_C15(iMode)&0x0000FFFF);


	switch(iMode&0x0F000000)
		{
	case 0x00000000:									// Normales Put-Bild

		switch(iMode&0xF0000000)
			{
		case 0x10000000:								// 16 Normal/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(((get[i]^iMode)&0x7FFF))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x20000000:								// 16 Normal/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if((get[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x40000000:								// 16 Normal/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!(get[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
			}break;

	case 0x01000000:									// Put-Bild Mit Farb Ausschlu

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 16 Farbe/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x7FFF))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x10000000:								// 16 Farbe/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x7FFF))continue;
							if( ((get[i]^iMode)&0x7FFF))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x20000000:								// 16 Farbe/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x7FFF))continue;
							if(  (get[i]      &0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x40000000:								// 16 Farbe/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!((put[i]^iMode)&0x7FFF))continue;
							if(! (get[i]      &0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
			}break;

	case 0x02000000:									// Put-Bild Mit Maske nicht zeichnen

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 16 Maske-/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if((put[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x10000000:								// 16 Maske-/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if( (put[i]      &0x8000))continue;
							if(((get[i]^iMode)&0x7FFF))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x20000000:								// 16 Maske-/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if((put[i]&0x8000))continue;
							if((get[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x40000000:								// 16 Maske-/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if( (put[i]&0x8000))continue;
							if(!(get[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
			}break;

	case 0x04000000:									// Put-Bild Mit Maske zeichnen

		switch(iMode&0xF0000000)
			{
		case 0x00000000:								// 16 Maske+/Normal
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!(put[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x10000000:								// 16 Maske+/Farbe
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!(put[i]      &0x8000))continue;
							if(((get[i]^iMode)&0x7FFF))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x20000000:								// 16 Maske+/Maske-
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!(put[i]&0x8000))continue;
							if( (get[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
		case 0x40000000:								// 16 Maske+/Maske+
						for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
						for(i=0;i<iSizeX;i++)
							{
							if(!(put[i]&0x8000))continue;
							if(!(get[i]&0x8000))continue;
							get[i]&=0x8000;
							get[i]|=0x7FFF&put[i];
							}break;
			}break;
		}

	return 1;
	}

}

//******************** Allgemeine *********************************************

	pGet = ROW_PTR(iPosY);
	pPut = sImage [iNewY];

	#undef	get
	#undef	put
	#define get	((short*)pGet)
	#define put	((short*)pPut)

	iAddX = sImage.uRowWidth;
	k     = sImage.uIsRgb;

	if(uIsRgb)											// Ist Unterlage RGB-Format ?
		{
		iAlpha = (iGetBits==32 && iPutBits<=24 && !(iMode&0xF0000000))? 0xFF000000:0;
		iMask  = sImage.uPixelMask;

		for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
		for(i=0;i<iSizeX;i++)
			{
			iRgb=GetPixel_(pGet,i+iPosX);
			if(iMode&0xF0000000)
			switch(iMode&0xF0000000)
				{
			case 0x10000000:if(!((iRgb^iMode)&0x00FFFFFF))continue;break;
			case 0x20000000:if( ((iRgb      )&0x80000000))continue;break;
			case 0x40000000:if(!((iRgb      )&0x80000000))continue;break;
			case 0x80000000:if( ((iRgb      )&0x40000000))continue;break;
				}

			iRgb=sImage.GetPixel_(pPut,i+iNewX);

			if(iMode&0x0F000000)
			switch(iMode&0x0F000000)
				{
			case 0x01000000:if(!((iRgb^iMode)&0x00FFFFFF))continue;break;
			case 0x02000000:if( ((iRgb      )&0x80000000))continue;break;
			case 0x04000000:if(!((iRgb      )&0x80000000))continue;break;
			case 0x08000000:if( ((iRgb      )&0x40000000))continue;break;
				}

			if(!k)iRgb=sImage.pColorMap[iRgb&iMask].uRgb;
			SetPixel_(pGet,i+iPosX,iRgb|iAlpha);
			}

		return 1;
		}
	else{												// Unterlage im Pixelformat
		for(;iSizeY>0;iSizeY--,pGet-=uRowWidth,pPut-=iAddX)
		for(i=0;i<iSizeX;i++)
			{
			iRgb=GetPixel_(pGet,i+iPosX);
			if((iMode&0xF0000000)==0x10000000)
			if(!((iRgb^iMode)&0x00FFFFFF))continue;

			iRgb=sImage.GetPixel_(pPut,i+iNewX);

			if(iMode&0x0F000000)
			switch(iMode&0x0F000000)
				{
			case 0x01000000:if(!((iRgb^iMode)&0x00FFFFFF))continue;break;
			case 0x02000000:if( ((iRgb      )&0x80000000))continue;break;
			case 0x04000000:if(!((iRgb      )&0x80000000))continue;break;
			case 0x08000000:if( ((iRgb      )&0x40000000))continue;break;
				}

			SetPixel_(pGet,i+iPosX,iRgb);
			}

		return 1;
		}



return 0;
}

//*****************************************************************************
//*
//*		Get
//*
//*****************************************************************************
//	Holt einen Bildausschnitt aus einem Bild
//	sImage	: Ist das Bild das aus dem der Ausschnitt geholt werden soll
//	iPosX	: Ist die X-Koordinate wo der Ausschnitt beginnt
//	iPosY	: Ist die Y-Koordinate wo der Ausschnitt beginnt
//	iSizeX	: Ist die Breite des Ausschnittes in Pixel
//	iSizeY	: Ist die Hhe   des Ausschnittes in Pixel
//	Ergibt true wenn erfolgreich
bool BitmapImage::Get(const BitmapImage &sImage,int iPosX,int iPosY,int iSizeX,int iSizeY)
{
unsigned   *pSource;
unsigned   *pTarget;
COLORRGB	uColor;
int			iStart;
int			iSize;
int			iEndX;
int			iAddI;
int			iAddO;
int			iNowY;
int			iEndY;
int			iLast;
int			iNull;
int			iPost;
int			iNum;



	if(!sImage.IsOk())
		{
		ClearData();
		return false;
		}

	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;iSizeX=-iSizeX;}
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;iSizeY=-iSizeY;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(!SetSize(sImage.BitCount(),iSizeX,iSizeY,BI_NOT_INIT))
		{
		ClearData();
		return false;
		}

	if(sImage.BitCount()<=8)							// Farben kpieren
		{
		for(iNum=0;iNum<(int)sImage.ColorCount();iNum++)
			{
			uColor = sImage.GetColor(iNum);
			SetColor(iNum,uColor);
			}
		}

	if(iEndX<=0 || iEndY<=0 || iPosX>=(int)sImage.uImageWidth || iPosY>=(int)sImage.uImageHeight)
		{
		memset(pImageMem,0,uImageSize);					// Ausschnitt nicht im Original
		return true;
		}



	if(iPosY+iSizeY<(int)sImage.uImageHeight)
		{
		iLast = iPosY+iSizeY;
		}
	else{
		iLast = sImage.uImageHeight;
		}


	if(iPosY<0)											// Oberer Rand auserhalb
		{
		Box(0,0,iSizeX,-iPosY,0);
		iNowY = -iPosY;
		iPosY =  0;
		}
	else{
		iNowY =  0;
		}


	pSource = (unsigned*)sImage.GetRow_(iPosY);
	pTarget = (unsigned*)       GetRow_(iNowY);
	iAddI	= sImage.uRowWidth/4;
	iAddO	=        uRowWidth/4;
	iNowY  += iLast-iPosY;
	iStart	= iPosX*(int)sImage.uImageBits;
	iSize	= sImage.uImageWidth*sImage.uImageBits;


	if((iStart&7) || (iSize&7))							// Nicht auf Byte-Grenze
		{
		for(;iPosY<iLast;iPosY++)						// Zeilenweise kopiern
			{
			CopyLineL(iStart,iAddO,pSource,pTarget,iSize);

			pSource -= iAddI;
			pTarget -= iAddO;
			}
		}
	else{												// Auf Bytegrenze
		iStart /= 8;
		iSize  /= 8;

		if(iStart<0)
			{
			iNull  = -iStart;
			}
		else{
			iNull  =  0;
			iSize -=  iStart;
			PTR_ADD(pSource,iStart);
			}

		   iPost = (iAddO*4)-iNull-iSize;
		if(iPost<0)
			{
			iSize += iPost;
			iPost  = 0;
			}

		for(;iPosY<iLast;iPosY++)						// Zeilenweise kopiern
			{
			memset(((char*)pTarget),0,iNull);
			memcpy(((char*)pTarget)+iNull,pSource,iSize);
			memset(((char*)pTarget)+iNull+iSize,0,iPost);

			pSource -= iAddI;
			pTarget -= iAddO;
			}
		}

	if(iPosY<iEndY)
		{
		Box(0,iNowY,iSizeX,uImageHeight-iNowY,0);
		iPosY = 0;
		}



return true;
}

//*****************************************************************************
//*
//*		Box
//*
//*****************************************************************************
//	Zeichnet ein Rechteck in das Bild.
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Box(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel)
{
unsigned char  *pMem;
int				iEndX;
int				iEndY;
int				iLen;
int				i,j,k;



	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;}		// Koordinaten
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iEndX>(int)uImageWidth )iEndX=uImageWidth;
	if(iEndY>(int)uImageHeight)iEndY=uImageHeight;
	if(iPosX<0)iPosX=0;
	if(iPosY<0)iPosY=0;

	if(iPosX>=iEndX)return 0;							// Leere Box
	if(iPosY>=iEndY)return 0;


	while(iPosX&uColumMask)								// Die ungeraden Spalten
		{
		pMem=ROW_PTR(iPosY);

		for(j=iPosY;j<iEndY;j++)
			{
			SetPixel_(pMem,iPosX,iPixel);
			pMem-=uRowWidth;
			}

		iPosX++;
		if(iPosX>=iEndX)return 1;
		}


	if(iPosX<(iEndX&~(int)uColumMask))					// Die ungeraden Spalten
		{
		iLen  = (iEndX-iPosX)>>uColumBit;
		iLen *=  uBytesPerPixel;
		pMem  =  ROW_PTR(iPosY);
		pMem += (iPosX>>uColumBit)*uBytesPerPixel;

		switch(uBytesPerPixel)
				{
		case 1:	     if(uImageBits==8)k=(iPixel&0xFF)*0x01010101;
				else if(uImageBits==4)k=(iPixel&0x0F)*0x11111111;
				else if(uImageBits==2)k=(iPixel&0x03)*0x55555555;
				else if(uImageBits==1)k=(iPixel&0x01)? -1:0;
				else				  k=(iPixel&0xFF)*0x01010101;

				for(j=iPosY;j<iEndY;j++)
					{
					memset(pMem,k,iLen);
					pMem-=uRowWidth;
					}
				break;

		case 2:	if(uImageBits==15)	k=RGB_TO_C15(iPixel);
				else				k=RGB_TO_C16(iPixel);

				for(j=iPosY;j<iEndY;j++,pMem-=uRowWidth)
				for(i=0;i<iLen;i+=2)*(short*)(pMem+i)=(short)k;

				break;

		case 3:	if(uImageBits==12)	k=RGB_TO_C12H(iPixel)|RGB_TO_C12L(iPixel);
				else				k=RGB_TO_C24(iPixel);

				for(j=iPosY;j<iEndY;j++,pMem-=uRowWidth)
				for(i=0;i<iLen;i+=3)RGB_TO_P24(k,pMem+i);

				break;

		case 4:	for(j=iPosY;j<iEndY;j++,pMem-=uRowWidth)
				for(i=0;i<iLen;i+=4)RGB_TO_P32(iPixel,pMem+i);

				break;
				}

		iPosX = iEndX&~uColumMask;
		}

	while(iPosX<iEndX)									// Die ungeraden EndSpalten
		{
		pMem=ROW_PTR(iPosY);

		for(j=iPosY;j<iEndY;j++)
			{
			SetPixel_(pMem,iPosX,iPixel);
			pMem-=uRowWidth;
			}

		iPosX++;
		}


return 1;
}

//*****************************************************************************
//*
//*		Box
//*
//*****************************************************************************
//	Zeichnet ein Rechteck in das Bild mit Alphablending.
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	iAlpha			: Ist der Wert fr das Alphablending (0=nicht sichtbar 255=vollgefllt)
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Box(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,int iAlpha)
{
unsigned		uAlpha1;
unsigned		uAlpha2;
unsigned		uColor;
unsigned		uValue;
unsigned		uVal1;
unsigned		uVal2;
unsigned		uVal3;
int				iEndX;
int				iEndY;
int				i;


	if(iAlpha<=  0)return 1;
	if(iAlpha>=255)return Box(iPosX,iPosY,iSizeX,iSizeY,iPixel);


	if(!IsOk()   || !IsRGB() )return 0;					// Leeres Bild ?
	if(iSizeX<=0 || iSizeX<=0)return 0;


	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;}		// Koordinaten
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iEndX>(int)uImageWidth )iEndX=uImageWidth;
	if(iEndY>(int)uImageHeight)iEndY=uImageHeight;
	if(iPosX<0)iPosX=0;
	if(iPosY<0)iPosY=0;

	if(iPosX>=iEndX)return 0;							// Leere Box
	if(iPosY>=iEndY)return 0;

	uAlpha1	= iAlpha+1;
	uAlpha2	= 257-uAlpha1;

	uVal1	= ((iPixel    )&0xFF)*uAlpha1;
	uVal2	= ((iPixel>> 8)&0xFF)*uAlpha1;
	uVal3	= ((iPixel>>16)&0xFF)*uAlpha1;

	for(;iPosY<iEndY;iPosY++)							// Reihen kopieren
		{
		for(i=iPosX;i<iEndX;i++)
			{
			uColor	= GetPixel(i,iPosY);
			uValue	= uColor&0xFF000000;
			uValue |= ((uVal1+( uColor     &0xFF)*uAlpha2)>>8);
			uValue |= ((uVal2+((uColor>> 8)&0xFF)*uAlpha2)   )&0xFF00;
			uValue |= ((uVal3+((uColor>>16)&0xFF)*uAlpha2)<<8)&0xFF0000;

			SetPixel(i,iPosY,uValue);
			}
		}



return 1;
}

//*****************************************************************************
//*
//*		Box
//*
//*****************************************************************************
//	Zeichnet ein Rechteck in das Bild, mittels Pixlel-Callback-Funktion.
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	pSet			: Ist die Funktion zum Fllen der Pixel
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Box(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFillSet pSet)
{
unsigned char  *pMem;
int				iEndX;
int				iEndY;
int				i;



	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;}		// Koordinaten
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iEndX>(int)uImageWidth )iEndX=uImageWidth;
	if(iEndY>(int)uImageHeight)iEndY=uImageHeight;
	if(iPosX<0)iPosX=0;
	if(iPosY<0)iPosY=0;

	if(iPosX>=iEndX)return 0;							// Leere Box
	if(iPosY>=iEndY)return 0;


	while(iPosY<iEndY)									// Die ungeraden EndSpalten
		{
		pMem = ROW_PTR(iPosY);

		for(i=iPosX;i<iEndX;i++)
			{
			pSet(this,pMem,i,iPosY,iPixel);
			}

		iPosY++;
		}


return 1;
}

//*****************************************************************************
//*
//*		BoxAlpha
//*
//*****************************************************************************
//	Zeichnet ein Rechteck in das Bild anhand der Bild-Alpha-Werte.
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::BoxAlpha(int   iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel)
{
unsigned char  *pMem;
unsigned		uColorR;
unsigned		uColorG;
unsigned		uColorB;
unsigned		uAlpha;
unsigned		uBeta;
int				iEndX;
int				iEndY;
int				iLen;
int				iAdd;
int				i,j;


	if(uImageBits!=32)									// Ist ein Alpha-Kanal vorhanden
		{
		return 0;
		}

	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;}		// Koordinaten
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iEndX>(int)uImageWidth )iEndX=uImageWidth;
	if(iEndY>(int)uImageHeight)iEndY=uImageHeight;
	if(iPosX<0)iPosX=0;
	if(iPosY<0)iPosY=0;

	if(iPosX>=iEndX)return 0;							// Leere Box
	if(iPosY>=iEndY)return 0;

	pMem	= ROW_PTR(iEndY-1);
	pMem   += iPosX*4;
	iLen	= iEndX-iPosX;
	iAdd	= uRowWidth;
	iAdd   -= iLen*4;

	iPixel &= 0x00FFFFFF;
	uColorB	= (iPixel    )&0xFF;
	uColorG	= (iPixel>> 8)&0xFF;
	uColorR	= (iPixel>>16);

	for(j=iEndY-iPosY;j>0;j--,pMem+=iAdd)				// Zeilen abarbeiten
		{
		for(i=iLen;i>0;i--,pMem+=4)
			{
			   uAlpha = pMem[3];
			if(uAlpha==255)
				{
				continue;
				}

			if(uAlpha==0)
				{
				P32_TO_RGB(pMem) = iPixel;
				continue;
				}

			uBeta	= 255-uAlpha;
			pMem[0]	= ((pMem[0]*uAlpha+uColorB*uBeta)*257)>>16;
			pMem[1]	= ((pMem[1]*uAlpha+uColorG*uBeta)*257)>>16;
			pMem[2]	= ((pMem[2]*uAlpha+uColorR*uBeta)*257)>>16;
			}
		}



return 1;
}

//*****************************************************************************
//*
//*		BoxAlpha
//*
//*****************************************************************************
//	Zeichnet ein Rechteck in das Bild anhand der Bild-Alpha-Werte.
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	iPaternSize		: Wie gro werden die Pattern (1<<iPaternSize)
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::BoxAlpha(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel1,int iPixel2,int iPaternSize)
{
unsigned char  *pMem;
unsigned		uColorR1;
unsigned		uColorG1;
unsigned		uColorB1;
unsigned		uColorR2;
unsigned		uColorG2;
unsigned		uColorB2;
unsigned		uAlpha;
unsigned		uBeta;
int				iEndX;
int				iEndY;
int				iMask;
int				iLen;
int				iAdd;
int				i,j;


	if(uImageBits!=32)									// Ist ein Alpha-Kanal vorhanden
		{
		return 0;
		}

	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;}		// Koordinaten
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iEndX>(int)uImageWidth )iEndX=uImageWidth;
	if(iEndY>(int)uImageHeight)iEndY=uImageHeight;
	if(iPosX<0)iPosX=0;
	if(iPosY<0)iPosY=0;

	if(iPosX>=iEndX)return 0;							// Leere Box
	if(iPosY>=iEndY)return 0;

	pMem	= ROW_PTR(iEndY-1);
	pMem   += iPosX*4;
	iLen	= iEndX-iPosX;
	iAdd	= uRowWidth;
	iAdd   -= iLen*4;
	iMask	= 1<<iPaternSize;

	iPixel1&= 0x00FFFFFF;
	uColorB1= (iPixel1    )&0xFF;
	uColorG1= (iPixel1>> 8)&0xFF;
	uColorR1= (iPixel1>>16);

	iPixel2&= 0x00FFFFFF;
	uColorB2= (iPixel2    )&0xFF;
	uColorG2= (iPixel2>> 8)&0xFF;
	uColorR2= (iPixel2>>16);

	for(j=iEndY;j>iPosY;j--,pMem+=iAdd)				// Zeilen abarbeiten
		{
		for(i=0;i<iLen;i++,pMem+=4)
			{
			   uAlpha = pMem[3];
			if(uAlpha==255)
				{
				continue;
				}

			if(uAlpha==0)
				{
				P32_TO_RGB(pMem) = ((j^i)&iMask)? iPixel2:iPixel1;
				continue;
				}

			uBeta	= 255-uAlpha;

			if((j^i)&iMask)
				{
				pMem[0]	= ((pMem[0]*uAlpha+uColorB2*uBeta)*257)>>16;
				pMem[1]	= ((pMem[1]*uAlpha+uColorG2*uBeta)*257)>>16;
				pMem[2]	= ((pMem[2]*uAlpha+uColorR2*uBeta)*257)>>16;
				}
			else{
				pMem[0]	= ((pMem[0]*uAlpha+uColorB1*uBeta)*257)>>16;
				pMem[1]	= ((pMem[1]*uAlpha+uColorG1*uBeta)*257)>>16;
				pMem[2]	= ((pMem[2]*uAlpha+uColorR1*uBeta)*257)>>16;
				}
			}
		}



return 1;
}

//*****************************************************************************
//*
//*		BoxAlpha
//*
//*****************************************************************************
//	Zeichnet ein Rechteck in das Bild mit Pattern (Schachbrett).
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel1/2		: Sind die Farben bzw. die Farbindizes fr das Rechteck.
//	iPaternSize		: Wie gro werden die Pattern (1<<iPaternSize)
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Box(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel1,int iPixel2,int iPaternSize)
{
unsigned char  *pMem;
int				iEndX;
int				iEndY;
int				iMask;
int				iLen;
int				iAdd;
int				i,j;


	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;}		// Koordinaten
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iEndX>(int)uImageWidth )iEndX=uImageWidth;
	if(iEndY>(int)uImageHeight)iEndY=uImageHeight;
	if(iPosX<0)iPosX=0;
	if(iPosY<0)iPosY=0;

	if(iPosX>=iEndX)return 0;							// Leere Box
	if(iPosY>=iEndY)return 0;

	pMem	= ROW_PTR(iEndY-1);
	iMask	= 1<<iPaternSize;
	iLen	= iEndX-iPosX;
	iAdd	= uRowWidth;

	for(j=iEndY;j>iPosY;j--,pMem+=iAdd)					// Zeilen abarbeiten
		{
		for(i=0;i<iLen;i++)
			{
			SetPixel_(pMem,iPosX+i,((j^i)&iMask)? iPixel2:iPixel1);
			}
		}



return 1;
}

//*****************************************************************************
//*
//*		Line
//*
//*****************************************************************************
//	Zeichnet eine Linie in das Bild.
//	iPosX/iPosY		: Ist die Position an der die Linie beginnt.
//	iEndX/iEndY		: Ist die Position an der die Linie endet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr die Linie.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Line(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel)
{
int		iSizeX  ,iSizeY;
int		iAddX   ,iAddY;
int		iNum    ,iOff;
int		iVal    ,iAdd;
int		iPos	,iMax;
int		iFlag   ,iEnd;



	iSizeX = iEndX-iPosX;


	if(iSizeX<0)										// Negative X-Steigung
		{
		iSizeX	= -iSizeX;
		iAddX	= -1;
		}
	else{
		iAddX	=  1;
		}


	iSizeY = iEndY-iPosY;

	if(iSizeY<0)										// Negative X-Steigung
		{
		iSizeY	= -iSizeY;
		iAddY	= -1;
		}
	else{
		iAddY	=  1;
		}


	if(iSizeX>=iSizeY)									// X oder Y-Steigung grer
		{
		iFlag	=  0;
		iMax	=  uImageWidth -1;
		iEnd	=  uImageHeight-1;

		if(iPosY>iEnd && iEndY>iEnd)return 0;
		if(iPosY<   0 && iEndY<   0)return 0;
		}
	else{
		iFlag	=  1;
		iMax	=  uImageHeight-1;
		iEnd	=  uImageWidth -1;

		if(iPosX>iEnd && iEndX>iEnd)return 0;
		if(iPosX<   0 && iEndX<   0)return 0;

		iVal	=  iPosX;
		iPosX	=  iPosY;
		iPosY	=  iVal;

		iVal	=  iAddX;
		iAddX	=  iAddY;
		iAddY	=  iVal;

		iVal	=  iSizeX;
		iSizeX	=  iSizeY;
		iSizeY	=  iVal;

		iFlag	=  1;
		}


	iOff =  iSizeX-iSizeY;
	iNum = (iOff+1)/2;
	iPos = (iAddX>0)? iPosX:iMax-iPosX;


	if(iPos<0)											// Start vor Bildrand
		{
		if(iAddX<0 && iPosX<0)return 0;
		if(iAddX>0 && iPosX>0)return 0;
		if(iSizeX==0         )return 0;

		iVal	= iNum+iPos*iSizeY;
		iAdd	= iVal/iSizeX;
		iNum	= iVal%iSizeX;

		if(iNum<=-iSizeY)
			{
			iNum += iSizeX;
			iAdd -= 1;
			}

		iPosX  -= iPos*iAddX;
		iPosY  -= iAdd*iAddY;
		iSizeX += iPos;
		iPos	= 0;
		}


	iSizeX++;

	if(iPos+iSizeX>iMax)								// Geht die Line ber den Bildrand
		{
		if(iPos>iMax)return 0;
		iSizeX	= iMax-iPos+1;
		}


	if(!iFlag)
		{
		while(iSizeX>0)									// Die Linie Zeichen (DX>DY)
			{
			SetPixel(iPosX,iPosY,iPixel);

			if(iNum>0)
				{
				iPosX += iAddX;
				iNum  -= iSizeY;
				}
			else{										// Beide Richtungen ndern
				iPosX += iAddX;
				iPosY += iAddY;
				iNum  += iOff;
				}

			iSizeX--;
			}
		}
	else{
		while(iSizeX>0)									// Die Linie Zeichen (DY>DX)
			{
			SetPixel(iPosY,iPosX,iPixel);

			if(iNum>0)
				{
				iPosX += iAddX;
				iNum  -= iSizeY;
				}
			else{										// Beide Richtungen ndern
				iPosX += iAddX;
				iPosY += iAddY;
				iNum  += iOff;
				}

			iSizeX--;
			}
		}

return 1;
}


//*****************************************************************************
//*
//*		Line
//*
//*****************************************************************************
//	Zeichnet eine Linie in das Bild.
//	iPosX/iPosY		: Ist die Position an der die Linie beginnt.
//	iEndX/iEndY		: Ist die Position an der die Linie endet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr die Linie.
//	pProc			: Ist die Zeichenfunktion
//						TEXT_SMOTH	: Mit Weichzeichner
//						TEXT_NORMAL	: Direkt setzen
//	iFull			: Auch den letzten Punkt zeichnen. Dieser Wert sollte
//					  Null sein wenn man verkettet Linien zeichnet.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Line(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel,PixelFunction pProc,int iFull)
{
int		iSizeX  ,iSizeY;
int		iAddX   ,iAddY;
int		iNum    ,iOff;
int		iVal    ,iAdd;
int		iPos	,iMax;
int		iFlag	,iEnd;



	iSizeX = iEndX-iPosX;


	if(iSizeX<0)										// Negative X-Steigung
		{
		iSizeX	= -iSizeX;
		iAddX	= -1;
		}
	else{
		iAddX	=  1;
		}


	iSizeY = iEndY-iPosY;

	if(iSizeY<0)										// Negative X-Steigung
		{
		iSizeY	= -iSizeY;
		iAddY	= -1;
		}
	else{
		iAddY	=  1;
		}


	if(iSizeX>=iSizeY)									// X oder Y-Steigung grer
		{
		iFlag	=  0;
		iMax	=  uImageWidth -1;
		iEnd	=  uImageHeight-1;

		if(iPosY>iEnd && iEndY>iEnd)return 0;
		if(iPosY<   0 && iEndY<   0)return 0;
		}
	else{
		iFlag	=  1;
		iMax	=  uImageHeight-1;
		iEnd	=  uImageWidth -1;

		if(iPosX>iEnd && iEndX>iEnd)return 0;
		if(iPosX<   0 && iEndX<   0)return 0;

		iVal	=  iPosX;
		iPosX	=  iPosY;
		iPosY	=  iVal;

		iVal	=  iAddX;
		iAddX	=  iAddY;
		iAddY	=  iVal;

		iVal	=  iSizeX;
		iSizeX	=  iSizeY;
		iSizeY	=  iVal;

		iFlag	=  1;
		}


	iOff =  iSizeX-iSizeY;
	iNum = (iOff+1)/2;
	iPos = (iAddX>0)? iPosX:iMax-iPosX;


	if(iPos<-2)											// Start vor Bildrand
		{
		if(iAddX<0 && iPosX<0)return 0;
		if(iAddX>0 && iPosX>0)return 0;
		if(iSizeX==0         )return 0;

		iPos   += 2;
		iVal	= iNum+iPos*iSizeY;
		iAdd	= iVal/iSizeX;
		iNum	= iVal%iSizeX;

		if(iNum<=-iSizeY)
			{
			iNum += iSizeX;
			iAdd -= 1;
			}

		iPosX  -= iPos*iAddX;
		iPosY  -= iAdd*iAddY;
		iSizeX += iPos;
		iPos	= -2;
		}


	if(iFull)iSizeX++;


	if(iPos+iSizeX>iMax)								// Geht die Line ber den Bildrand
		{
		if(iPos>iMax)return 0;
		iSizeX	= iMax-iPos+1;
		}

	if(uImageBits<=8)
	if(pProc==SetTextPixelSmoth)
		{
		pProc=SetTextPixelNormal;
		}

	if(uImageBits==32)
	if(pProc==SetTextPixelSmoth)
		{
		pProc=SetTextPixelSmoth32;
		}

	if(!iFlag)
		{
		while(iSizeX>0)									// Die Linie Zeichen (DX>DY)
			{
			pProc(this,iPosX,iPosY,iPixel);

			if(iNum>0)
				{
				iPosX += iAddX;
				iNum  -= iSizeY;
				}
			else{										// Beide Richtungen ndern
				iPosX += iAddX;
				iPosY += iAddY;
				iNum  += iOff;
				}

			iSizeX--;
			}
		}
	else{
		while(iSizeX>0)									// Die Linie Zeichen (DY>DX)
			{
			pProc(this,iPosY,iPosX,iPixel);

			if(iNum>0)
				{
				iPosX += iAddX;
				iNum  -= iSizeY;
				}
			else{										// Beide Richtungen ndern
				iPosX += iAddX;
				iPosY += iAddY;
				iNum  += iOff;
				}

			iSizeX--;
			}
		}

return 1;
}

//*****************************************************************************
//*
//*		Line
//*
//*****************************************************************************
//	Zeichnet eine Linie in das Bild.
//	iPosX/iPosY		: Ist die Position an der die Linie beginnt.
//	iEndX/iEndY		: Ist die Position an der die Linie endet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr die Linie.
//	pSet			: Ist die Zeichenfunktion
//	iFull			: Auch den letzten Punkt zeichnen. Dieser Wert sollte
//					  Null sein wenn man verkettet Linien zeichnet.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Line(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel,PixelFillSet pSet,int iFull)
{
unsigned char  *pMem;
int				iSizeX  ,iSizeY;
int				iAddX   ,iAddY;
int				iNum    ,iOff;
int				iVal    ,iAdd;
int				iPos	,iMax;
int				iFlag	,iEnd;



	iSizeX = iEndX-iPosX;


	if(iSizeX<0)										// Negative X-Steigung
		{
		iSizeX	= -iSizeX;
		iAddX	= -1;
		}
	else{
		iAddX	=  1;
		}


	iSizeY = iEndY-iPosY;

	if(iSizeY<0)										// Negative X-Steigung
		{
		iSizeY	= -iSizeY;
		iAddY	= -1;
		}
	else{
		iAddY	=  1;
		}


	if(iSizeX>=iSizeY)									// X oder Y-Steigung grer
		{
		iFlag	=  0;
		iMax	=  uImageWidth -1;
		iEnd	=  uImageHeight-1;

		if(iPosY>iEnd && iEndY>iEnd)return 0;
		if(iPosY<   0 && iEndY<   0)return 0;
		}
	else{
		iFlag	=  1;
		iMax	=  uImageHeight-1;
		iEnd	=  uImageWidth -1;

		if(iPosX>iEnd && iEndX>iEnd)return 0;
		if(iPosX<   0 && iEndX<   0)return 0;

		iVal	=  iPosX;
		iPosX	=  iPosY;
		iPosY	=  iVal;

		iVal	=  iAddX;
		iAddX	=  iAddY;
		iAddY	=  iVal;

		iVal	=  iSizeX;
		iSizeX	=  iSizeY;
		iSizeY	=  iVal;

		iFlag	=  1;
		}


	iOff =  iSizeX-iSizeY;
	iNum = (iOff+1)/2;
	iPos = (iAddX>0)? iPosX:iMax-iPosX;


	if(iPos<-2)											// Start vor Bildrand
		{
		if(iAddX<0 && iPosX<0)return 0;
		if(iAddX>0 && iPosX>0)return 0;
		if(iSizeX==0         )return 0;

		iPos   += 2;
		iVal	= iNum+iPos*iSizeY;
		iAdd	= iVal/iSizeX;
		iNum	= iVal%iSizeX;

		if(iNum<=-iSizeY)
			{
			iNum += iSizeX;
			iAdd -= 1;
			}

		iPosX  -= iPos*iAddX;
		iPosY  -= iAdd*iAddY;
		iSizeX += iPos;
		iPos	= -2;
		}


	if(iFull)iSizeX++;


	if(iPos+iSizeX>iMax)								// Geht die Line ber den Bildrand
		{
		if(iPos>iMax)return 0;
		iSizeX	= iMax-iPos+1;
		}


	if(!iFlag)
		{
		pMem = ROW_PTR(iPosY);

		while(iSizeX>0)									// Die Linie Zeichen (DX>DY)
			{
			pSet(this,pMem,iPosX,iPosY,iPixel);

			if(iNum>0)
				{
				iPosX += iAddX;
				iNum  -= iSizeY;
				}
			else{										// Beide Richtungen ndern
				iPosX += iAddX;
				iPosY += iAddY;
				iNum  += iOff;
				pMem   = ROW_PTR(iPosY);
				}

			iSizeX--;
			}
		}
	else{
		while(iSizeX>0)									// Die Linie Zeichen (DY>DX)
			{
			pMem = ROW_PTR(iPosX);
			pSet(this,pMem,iPosY,iPosX,iPixel);

			if(iNum>0)
				{
				iPosX += iAddX;
				iNum  -= iSizeY;
				}
			else{										// Beide Richtungen ndern
				iPosX += iAddX;
				iPosY += iAddY;
				iNum  += iOff;
				}

			iSizeX--;
			}
		}

return 1;
}

//*****************************************************************************
//*
//*		LineSmoth
//*
//*****************************************************************************
//	Zeichnet eine Linie in das Bild.
//	iPosX/iPosY		: Ist die Position an der die Linie beginnt.
//	iEndX/iEndY		: Ist die Position an der die Linie endet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr die Linie.
//	iFull			: Auch den letzten Punkt zeichnen. Dieser Wert sollte
//					  Null sein wenn man verkettet Linien zeichnet.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::LineSmoth(int iPosX,int iPosY,int iEndX,int iEndY,int iPixel,int iFull)
{
ColorMapEntry	sColPx,sColBg;
unsigned		uFact1,uFact2;
unsigned		uValue,uAdd,uJmp;
int				iSizeX,iSizeY;
int				iAddX1,iAddY1;
int				iAddX ,iAddY ;
int				iNumX ,iNumY;
int				iAdd  ,iPos;
int				iVal  ,iOld;


	iSizeX = iEndX-iPosX;
	iSizeY = iEndY-iPosY;

	if(uImageBits<=8 || iSizeX==0 || iSizeY==0)
		{
		return Line(iPosX,iPosY,iEndX,iEndY,iPixel);
		}


	iAddX  = 1;
	iAddY  = 1;
	iAddX1 = 1;
	iAddY1 = 1;


	if(iSizeX<0)
		{
		iAddX	= -1;
		iSizeX	= -iSizeX;
		}

	if(iSizeY<0)
		{
		iAddY	= -1;
		iSizeY	= -iSizeY;
		}



	sColPx.uRgb	=  iPixel;

	if(iSizeX==iSizeY)
		{
		if(iPosX<-1)									// Vor X-Start
			{
			if(iAddX<0)return 0;

			iAdd	= -iPosX-1;
			iPosY  +=  iAdd*iAddY;
			iPosX  +=  iAdd;
			iSizeX -=  iAdd;
			}
		else if(iPosX>(int)uImageWidth)					// Hinter X-Ende
			{
			if(iAddX>0)return 0;

			iAdd	=  iPosX-uImageWidth;
			iPosY  +=  iAdd*iAddY;
			iPosX  -=  iAdd;
			iSizeX -=  iAdd;
			}

		if(iPosY<-1)									// Vor Y-Start
			{
			if(iAddY<0)return 0;

			iAdd	= -iPosY-1;
			iPosX  +=  iAdd*iAddX;
			iPosY  +=  iAdd;
			iSizeX -=  iAdd;
			}
		else if(iPosY>(int)uImageHeight)				// Hinter Y-Ende
			{
			if(iAddY>0)return 0;

			iAdd	=  iPosY-uImageHeight;
			iPosX  +=  iAdd*iAddX;
			iPosY  -=  iAdd;
			iSizeX -=  iAdd;
			}


		if(iSizeX<0)return 0;

		SetPixel(iPosX,iPosY,sColPx.uRgb);

		if(iFull)iSizeX++;

		if(iSizeX>0)
			{
			if(iAddX>0)									// Nicht bis zum Ende zeichnen
				{
				if(iPosX+iSizeX>(int)uImageWidth)		// Ende hinter X+Bildrand
					{
					iSizeX = uImageWidth-iPosX+1;
					}
				}
			else{
				if(iPosX-iSizeX<0)						// Ende hinter X-Bildrand
					{
					iSizeX = iPosX+1;
					}
				}

			if(iAddY>0)									// Nicht bis zum Ende zeichnen
				{
				if(iPosY+iSizeX>(int)uImageHeight)		// Ende hinter Y+Bildrand
					{
					iSizeX = uImageWidth-iPosY+1;
					}
				}
			else{
				if(iPosY-iSizeX<0)						// Ende hinter Y-Bildrand
					{
					iSizeX = iPosY+1;
					}
				}

			sColBg.uRgb		=  GetPixel(iPosX,iPosY+iAddY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *32)+(sColBg.ucRed  *224))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *32)+(sColBg.ucBlue *224))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*32)+(sColBg.ucGreen*224))/256);

			SetPixel(iPosX,iPosY+iAddY,sColBg.uRgb);

			iPosX  += iAddX;
			iPosY  += iAddY;
			iSizeX -= 1;

			for(;;)
				{
				SetPixel(iPosX,iPosY,sColPx.uRgb);

				sColBg.uRgb		=  GetPixel(iPosX,iPosY-iAddY);
				sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *32)+(sColBg.ucRed  *224))/256);
				sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *32)+(sColBg.ucBlue *224))/256);
				sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*32)+(sColBg.ucGreen*224))/256);

				SetPixel(iPosX,iPosY-iAddY,sColBg.uRgb);

				iSizeX -= 1;
				if(iSizeX<=0)break;

				sColBg.uRgb		=  GetPixel(iPosX,iPosY+iAddY);
				sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *32)+(sColBg.ucRed  *224))/256);
				sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *32)+(sColBg.ucBlue *224))/256);
				sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*32)+(sColBg.ucGreen*224))/256);

				SetPixel(iPosX,iPosY+iAddY,sColBg.uRgb);

				iPosX  += iAddX;
				iPosY  += iAddY;
				}
			}
		}
	else if(iSizeX>iSizeY)
		{
		iAddX1	=  iAddX;
		iNumX	= (iSizeX-iSizeY+1)>>1;
		iNumY	= (iSizeX-iSizeY);
		iPos	= (iAddX>0)? iPosX:uImageWidth-iPosX-1;
		iOld	=  iSizeX;

		if(iPos<-1)										// Start vor Bildrand
			{
			if(iAddX<0 && iPosX<0)return 0;
			if(iAddX>0 && iPosX>0)return 0;
			if(iSizeX==0         )return 0;

			iPos   += 1;
			iVal	= iNumY-iPos*iSizeY;
			iAdd	= iVal/iSizeX;
			iNumX	= iVal%iSizeX;

			if(iNumX>iNumY)
				{
				iNumX -= iSizeX;
				iAdd  += 1;
				}

			iSizeX += iPos;
			iPosX  -= iPos*iAddX;
			iPosY  += iAdd*iAddY;
			iPos	= -1;
			}

		if(iPos+iSizeX>(int)uImageWidth)				// Ende hinter Bildrand
			{
			if(iPos>(int)uImageWidth)return 0;
			iSizeX = uImageWidth-iPos;
			}

		if(iPosY<               -1 && iEndY<               -1)return 0;
		if(iPosY>(int)uImageHeight && iEndY>(int)uImageHeight)return 0;

		iSizeX += 1;

		uValue	= ((1<<28)/iOld)*(iSizeY+iNumX);
		uAdd	= ((1<<28)/iOld)*(iSizeY);
		uJmp	= ((1<<28)/iOld)*(iNumY);

		if(iFull==0)iSizeX--;

		while(iSizeX>0)
			{
			uFact1			=  uValue>>20;
			uFact2			=  256-uFact1;

			sColBg.uRgb		=  GetPixel(iPosX,iPosY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

			SetPixel(iPosX,iPosY,sColBg.uRgb);

			sColBg.uRgb		=  GetPixel(iPosX,iPosY+iAddY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact2)+(sColBg.ucRed  *uFact1))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact2)+(sColBg.ucBlue *uFact1))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact2)+(sColBg.ucGreen*uFact1))/256);

			SetPixel(iPosX,iPosY+iAddY,sColBg.uRgb);

			if(iNumX>0)
				{
				iPosX  += iAddX1;
				iNumX  -= iSizeY;
				uValue -= uAdd;
				}
			else{
				iPosX  += iAddX;
				iPosY  += iAddY;
				iNumX  += iNumY;
				uValue += uJmp;
				}

			iSizeX--;
			}
		}
	else{
		iAddY1	=  iAddY;
		iNumY	= (iSizeY-iSizeX+1)>>1;
		iNumX	= (iSizeY-iSizeX);
		iPos	= (iAddY>0)? iPosY:uImageHeight-iPosY-1;
		iOld	=  iSizeY;

		if(iPos<-1)										// Start vor Bildrand
			{
			if(iAddY<0 && iPosY<0)return 0;
			if(iAddY>0 && iPosY>0)return 0;
			if(iSizeY==0         )return 0;

			iPos   += 1;
			iVal	= iNumX-iPos*iSizeX;
			iAdd	= iVal/iSizeY;
			iNumY	= iVal%iSizeY;

			if(iNumY>iNumX)
				{
				iNumY -= iSizeY;
				iAdd  += 1;
				}

			iSizeY += iPos;
			iPosY  -= iPos*iAddY;
			iPosX  += iAdd*iAddX;
			iPos	= -1;
			}

		if(iPos+iSizeY>(int)uImageHeight)				// Ende hinter Bildrand
			{
			if(iPos>(int)uImageHeight)return 0;
			iSizeY = uImageHeight-iPos;
			}

		if(iPosX<              -1 && iEndX<              -1)return 0;
		if(iPosX>(int)uImageWidth && iEndX>(int)uImageWidth)return 0;

		iSizeY += 1;

		uValue	= ((1<<28)/iOld)*(iSizeX+iNumY);
		uAdd	= ((1<<28)/iOld)*(iSizeX);
		uJmp	= ((1<<28)/iOld)*(iNumX);

		if(iFull==0)iSizeY--;

		while(iSizeY>0)
			{
			uFact1			=  uValue>>20;
			uFact2			=  256-uFact1;

			sColBg.uRgb		=  GetPixel(iPosX,iPosY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

			SetPixel(iPosX,iPosY,sColBg.uRgb);

			sColBg.uRgb		=  GetPixel(iPosX+iAddX,iPosY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact2)+(sColBg.ucRed  *uFact1))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact2)+(sColBg.ucBlue *uFact1))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact2)+(sColBg.ucGreen*uFact1))/256);

			SetPixel(iPosX+iAddX,iPosY,sColBg.uRgb);

			if(iNumY>0)
				{
				iPosY  += iAddY1;
				iNumY  -= iSizeX;
				uValue -= uAdd;
				}
			else{
				iPosY  += iAddY;
				iPosX  += iAddX;
				iNumY  += iNumX;
				uValue += uJmp;
				}

			iSizeY--;
			}
		}



return 1;
}



//*****************************************************************************
//*
//*		ConvertToGray
//*
//*****************************************************************************
//	Konvertiert ein Bild in ein Graustufenbild
//	sImage		: Ist das Bid das konvertiert werden soll.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::ConvertToGray(const BitmapImage &sImage)
{

	if(!sImage.IsOk())
		{
		ClearData();
		return false;
		}

	DoCopy(sImage);


return ConvertToGray();
}

bool BitmapImage::ConvertToGray()
{
unsigned char	ucGreen;
unsigned char	ucBlue;
unsigned char	ucRed;
unsigned		uGray;
unsigned		uPosX;
unsigned		uPosY;


	if(!IsOk())return false;

	if(!uIsRgb)
		{
		for(uPosX=0;uPosX<256;uPosX++)
			{
			GetColor(uPosX,ucRed,ucGreen,ucBlue);

			uGray   = (int)ucRed*76 + (int)ucGreen*152 + (int)ucBlue*29;
			uGray >>= 8;

			SetColor(uPosX,(unsigned char)uGray,(unsigned char)uGray,(unsigned char)uGray);
			}

		return true;
		}

	for(uPosY=0;uPosY<uImageHeight;uPosY++)
	for(uPosX=0;uPosX<uImageWidth ;uPosX++)
		{
		GetRGB(uPosX,uPosY,ucRed,ucGreen,ucBlue);

		uGray   = (int)ucRed*76 + (int)ucGreen*152 + (int)ucBlue*29;
		uGray >>= 8;

		SetRGB(uPosX,uPosY,(unsigned char)uGray,(unsigned char)uGray,(unsigned char)uGray);
		}


return true;
}

//*****************************************************************************
//*
//*		ConvertToGray8
//*
//*****************************************************************************
//	Konvertiert ein Bild in ein 8-Bit-Graustufenbild
//	sImage		: Ist das Bid das konvertiert werden soll.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::ConvertToGray8(const BitmapImage &sImage)
{
unsigned char	ucGreen;
unsigned char	ucBlue;
unsigned char	ucRed;
unsigned		uGray;
unsigned		uPosX;
unsigned		uPosY;
unsigned		uCol;


	if(!sImage.IsOk())return false;

	SetSize(8,sImage.Width(),sImage.Height(),BI_NOT_INIT);

	for(uCol=0;uCol<256;uCol++)
		{
		pColorMap[uCol].ucRed   = uCol;
		pColorMap[uCol].ucGreen = uCol;
		pColorMap[uCol].ucBlue  = uCol;
		pColorMap[uCol].ucMask  = 0;
		}


	for(uPosY=0;uPosY<uImageHeight;uPosY++)
	for(uPosX=0;uPosX<uImageWidth ;uPosX++)
		{
		sImage.GetRGB(uPosX,uPosY,ucRed,ucGreen,ucBlue);

		uGray = (int)ucRed*76 + (int)ucGreen*152 + (int)ucBlue*29;

		SetPixel(uPosX,uPosY,uGray>>8);
		}



return true;
}

//*****************************************************************************
//*
//*		ConvertToSingle
//*
//*****************************************************************************
//	Konvertiert ein Bild in ein 1-Bit-Schwarzweis Bild
//	sImage		: Ist das Bid das konvertiert werden soll.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::ConvertToSingle(const BitmapImage &sImage)
{
unsigned char	ucGreen;
unsigned char	ucBlue;
unsigned char	ucRed;
unsigned		uGray;
unsigned		uPosX;
unsigned		uPosY;


	if(!sImage.IsOk())return false;

	SetSize(1,sImage.Width(),sImage.Height(),BI_NOT_INIT);

	for(uPosY=0;uPosY<uImageHeight;uPosY++)
	for(uPosX=0;uPosX<uImageWidth ;uPosX++)
		{
		sImage.GetRGB(uPosX,uPosY,ucRed,ucGreen,ucBlue);

		uGray = (int)ucRed*76 + (int)ucGreen*152 + (int)ucBlue*29;

		SetPixel(uPosX,uPosY,(uGray>>15)&1);
		}


return true;
}


//*****************************************************************************
//*
//*		ConvertToAlpha
//*
//*****************************************************************************
//	Konvertiert ein 8-Bit-Bild in eine 32-Bit-Alpha-Maske.
//	Die Alpha-Maske kommt aus dem 8-Bit-Bild.
//	sImage		: Ist das Bild das konvertiert werden soll.
//	iMode		: Modus fr Konvertierung
//				  Bit0 : 0=Indizes verwenden  1=Farben verwenden
//				  Bit1 : 0=Normal  1=Alpha-Maske invertieren
//	uColor		: Ist die neue Hintergundfarbe
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::ConvertToAlpha(const BitmapImage &sImage,int iMode,COLORRGB uColor)
{
unsigned char  *pSource;
unsigned char  *pTarget;
unsigned		uCount;
unsigned		uIndex;


	if(!sImage.IsOk() || sImage.BitCount()!=8)
		{
		return false;
		}

	uColor = SwapRGB(uColor)&0x00FFFFFF;
	uCount = sImage.Width()*sImage.Height();
	SetSize(32,sImage.Width(),sImage.Height(),uColor);

	pSource = sImage.pImageMem;
	pTarget = pImageMem+3;


	switch(iMode&3)
		{
	case 0:													// Index / Normal

		while(uCount>0)
			{
			uCount--;
			pTarget[uCount*4] = pSource[uCount];
			}

		break;

	case 1:													// Index / Invers

		while(uCount>0)
			{
			uCount--;
			pTarget[uCount*4] = ~pSource[uCount];
			}

		break;

	case 2:													// Farben / Normal

		while(uCount>0)
			{
			uCount--;
			uIndex			  = pSource[uCount];
			pTarget[uCount*4] = sImage.pColorMap[uIndex].ucBlue;
			}

		break;

	case 3:													// Farben / Invers

		while(uCount>0)
			{
			uCount--;
			uIndex			  = pSource[uCount];
			pTarget[uCount*4] = ~sImage.pColorMap[uIndex].ucBlue;
			}

		break;
		}


return true;
}


//*****************************************************************************
//*
//*		Frame
//*
//*****************************************************************************
//	Zeichnet ein nicht ausgeflltes Rechteck
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Frame(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel)
{
unsigned char  *pMem;
int				iEndX;
int				iEndY;
int				iOk2;
int				iOk1;
int				i;


													// Koordinaten
	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;iSizeX=-iSizeX;}
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;iSizeY=-iSizeY;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iPosX >=(int)uImageWidth )return 0;			// Auser Bereich
	if(iPosY >=(int)uImageHeight)return 0;
	if(iEndX <=0)return 0;
	if(iEndY <=0)return 0;
	if(iSizeX<=0)return 0;							// Leere Box
	if(iSizeY<=0)return 0;


	iEndX--;
	iEndY--;

	if(iPosX<0)										// Prfe die linke Linie
		{
		iPosX = 0;
		iOk1  = 0;
		}
	else{
		iOk1  = 1;
		}

	if(iEndX>=(int)uImageWidth)						// Prfe die rechte Linie
		{
		iEndX = uImageWidth-1;
		iOk2  = 0;
		}
	else{
		iOk2  = 1;
		}


	if((unsigned)iPosY<uImageHeight)				// Obere Linie
		{
		pMem=ROW_PTR(iPosY);
		for(i=iPosX;i<=iEndX;i++)SetPixel_(pMem,i,iPixel);
		}
	else if(iPosY<0)
		{
		iPosY = 0;
		}

	if(iOk1 || iOk2)								// Senkrechte Linien
		{
		for(iPosY++;iPosY<iEndY;iPosY++)
			{
			if((unsigned)iPosY>=uImageHeight)break;
			pMem=ROW_PTR(iPosY);
			if(iOk1)SetPixel_(pMem,iPosX,iPixel);
			if(iOk2)SetPixel_(pMem,iEndX,iPixel);
			}
		}

	if((unsigned)iEndY<uImageHeight)				// Untere Linie
		{
		pMem=ROW_PTR(iEndY);
		for(i=iPosX;i<=iEndX;i++)SetPixel_(pMem,i,iPixel);
		}



return 1;
}

//*****************************************************************************
//*
//*		Frame
//*
//*****************************************************************************
//	Zeichnet ein nicht ausgeflltes Rechteck
//	iPosX /iPosY	: Ist die Position an der das Rechteck gezeichnet wird.
//	iSizeX/iSizeY	: Ist die Gre der Rechteckes in Pixel.
//					  Die Werte knnen auch kleiner als 0 werden, dann wird
//					  das Rechteck in die andere Richtung gezeichnet.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	pProc			: Ist die Zeichenfunktion
//						TEXT_SMOTH	: Mit Weichzeichner
//						TEXT_NORMAL	: Direkt setzen
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Frame(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFunction pProc)
{
int		iEndX;
int		iEndY;


													// Koordinaten
	if(iSizeX<0){iEndX=iPosX+1;iPosX+=iSizeX+1;iSizeX=-iSizeX;}
	else	    {iEndX=iPosX+  iSizeX;}
	if(iSizeY<0){iEndY=iPosY+1;iPosY+=iSizeY+1;iSizeY=-iSizeY;}
	else	    {iEndY=iPosY+  iSizeY;}

	if(iPosX >=(int)uImageWidth )return 0;			// Auser Bereich
	if(iPosY >=(int)uImageHeight)return 0;
	if(iEndX <=0)return 0;
	if(iEndY <=0)return 0;
	if(iSizeX<=0)return 0;							// Leere Box
	if(iSizeY<=0)return 0;


	iEndX--;
	iEndY--;

	Line(iPosX,iPosY,iPosX,iEndY,iPixel,pProc,0);
	Line(iPosX,iEndY,iEndX,iEndY,iPixel,pProc,0);
	Line(iEndX,iEndY,iEndX,iPosY,iPixel,pProc,0);
	Line(iEndX,iPosY,iPosX,iPosY,iPixel,pProc,0);



return 1;
}

//*****************************************************************************
//*
//*		CreateBitmap
//*
//*****************************************************************************
//	Erzeugt ein Windows Bitmap-Objekt
//	Ergibt ein HBITMAP Handle bzw. 0 bei einem Fehler
HBITMAP BitmapImage::CreateBitmap(HWND hWnd)
{
HDC			hDc;
HBITMAP		hBitmap;
int			iBits;
int			iLine;



	#if defined(_WIN32) || defined(_WIN64)

	if(!IsOk())return 0;



	hDc		= GetDC(hWnd);

	hBitmap	= CreateCompatibleBitmap(hDc,uImageWidth,uImageHeight);

	if(hBitmap==0)
		{
		ReleaseDC(hWnd,hDc);
		return 0;
		}

	iBits = GetDeviceCaps(hDc,BITSPIXEL);
	iLine = SetDIBits(hDc,hBitmap,0,uImageHeight,pImageData,pBitmapInfo,DIB_RGB_COLORS);

	ReleaseDC(hWnd,hDc);

	if(!iLine)
		{
		DeleteObject((HGDIOBJ)hBitmap);
		return 0;
		}


	return hBitmap;


	#else

	return 0;

	#endif
}


//*****************************************************************************
//*
//*		InsertBitmap
//*
//*****************************************************************************
//	Erzeugt ein Bild aus einem Bitmap-Objekt
//	Ergibt 1 wenn Bild erzeugt wurde bzw. 0 bei einem Fehler
bool BitmapImage::InsertBitmap(HWND hWnd,HBITMAP hBitmap)
{
#if defined(_WIN32) || defined(_WIN64)

BITMAPINFO *pInfo;
SIZE		sSize;
int			iColors;
int			iBits;
int			iLine;
HDC			hDc;
bool		bOk;



	ClearData();

	if(!hBitmap)return false;

	bOk		= true;
	hDc		= GetDC(hWnd);
	iBits	= GetDeviceCaps(hDc,BITSPIXEL);
	pInfo	= (BITMAPINFO*)new char[BMI_SIZE];


	pInfo->bmiHeader.biSize		  		= sizeof(BITMAPINFOHEADER);
	pInfo->bmiHeader.biWidth		  	= 0;
	pInfo->bmiHeader.biHeight	  		= 0;
	pInfo->bmiHeader.biPlanes	  		= 1;
	pInfo->bmiHeader.biBitCount	  		= 0;
	pInfo->bmiHeader.biCompression 		= BI_RGB;
	pInfo->bmiHeader.biSizeImage		= 0;
	pInfo->bmiHeader.biXPelsPerMeter	= 0;
	pInfo->bmiHeader.biYPelsPerMeter	= 0;

	iLine	 = GetDIBits(hDc,hBitmap,0,0,NULL,pInfo,DIB_RGB_COLORS);
	sSize.cx = pInfo->bmiHeader.biWidth;
	sSize.cy = pInfo->bmiHeader.biHeight;
	iBits    = pInfo->bmiHeader.biBitCount;iColors	=(iBits>8)? 0:1<<iBits;
			   pInfo->bmiHeader.biClrUsed			= iColors;
			   pInfo->bmiHeader.biClrImportant		= iColors;

	if(iBits==16 && pInfo->bmiHeader.biCompression==BI_BITFIELDS)
		{
		iBits=15;
		}

	if(!sSize.cx || !sSize.cy || !SetSize(iBits,sSize.cx,sSize.cy,BI_NOT_INIT))
		{
		ReleaseDC(hWnd,hDc);
		ClearData();
		return false;
		}

	iLine = GetDIBits(hDc,hBitmap,0,sSize.cy,pImageData,pInfo,DIB_RGB_COLORS);

	ReleaseDC(hWnd,hDc);

	if(!iLine)
		{
		ClearData();
		bOk=false;
		}

	delete pInfo;

	return bOk;

	#else

	ClearData();
	return 0;

	#endif
}

//*****************************************************************************
//*
//*		InsertBitmap
//*
//*****************************************************************************
//	Erzeugt ein Bild aus einem Bitmap-Speicherbereich
//	pInfo		: Zeiger auf Bitmap Infos
//	pData		: Zeiger auf die Bilddaten
//	pColors		: Zeiger auf Farben
//	Ergibt 1 wenn Bild erzeugt wurde bzw. 0 bei einem Fehler
bool BitmapImage::InsertBitmap(BITMAPINFOHEADER *pInfo,void *pData,void *pColors)
{
bool		bOk;
SIZE		sSize;
int			iColors;
int			iBits;
int			iNum;
int		   *pPtr;


	bOk=true;

	ClearData();

	if(!pInfo || !pData)return false;

	if(pInfo->biPlanes     !=1      )return false;
	if(pInfo->biCompression!= BI_RGB)return false;


	sSize.cx = pInfo->biWidth;
	sSize.cy = pInfo->biHeight;
	iBits    = pInfo->biBitCount;iColors=(iBits>8)? 0:1<<iBits;


	if(iBits==16 && pInfo->biCompression==BI_BITFIELDS)
		{
		iBits=15;
		}

	if(!sSize.cx || !sSize.cy || !SetSize(iBits,sSize.cx,sSize.cy,BI_NOT_INIT))
		{
		return false;
		}

	if(pInfo->biSizeImage<uRowWidth*uImageHeight)		// Falsche Bidgre
		{
		ClearData();
		return false;
		}


	memcpy(pImageData,pData,uRowWidth*uImageHeight);	// Pixel kopieren


	if(iBits<=8 && pColors)								// Farben einstellen
		{
		pPtr = (int*)pColors;

		for(iNum=0;iNum<iColors;iNum++)
			{
			SetColor(iNum,pPtr[iNum]);
			}
		}


return bOk;
}

//*****************************************************************************
//*
//*		InsertBitmap
//*
//*****************************************************************************
//	Erzeugt ein Bild aus einem Bitmap-Speicherbereich
//	pInfo:	Zeiger auf Bitmap Infos mit anschlieender Farbtabelle und Pixeldaten
//	Ergibt 1 wenn Bild erzeugt wurde bzw. 0 bei einem Fehler
bool BitmapImage::InsertBitmap(BITMAPINFOHEADER *pInfo)
{
void   *pTemp;
void   *pData;
int		iBits;
int		iColors;


	iBits   =  pInfo->biBitCount;
	iColors	= (iBits>8)? 0:1<<iBits;
	pTemp	= (void*)(((char*)pInfo)+sizeof(BITMAPINFOHEADER));
	pData   = (void*)(((char*)pTemp)+4*iColors);


return InsertBitmap(pInfo,pData,pTemp);
}

//*****************************************************************************
//*
//*		InsertBitmap
//*
//*****************************************************************************
//	Erzeugt ein Bild aus einer Bitmap-Resource
//	pResourceName	: Ist dername der Resource
//	Ergibt 1 wenn Bild erzeugt wurde bzw. 0 bei einem Fehler
bool BitmapImage::InsertBitmap(LPCTSTR pResourceName,HINSTANCE hInstance)
{
HBITMAP		hImage;
bool		bRet;


	if(!hInstance)
		{
		hInstance = (HINSTANCE)GetModuleHandle(NULL);
		}

		hImage = LoadBitmap(hInstance,pResourceName);
	if(!hImage)return false;

	bRet = InsertBitmap(0,hImage);

	DeleteObject(hImage);


return bRet;
}

//*****************************************************************************
//*
//*		Smoth
//*
//*****************************************************************************
//	Erzeugt in Bild mit Weichzeichner
//	sImage	: Ist das Quellbild
//	uMode	: Ist die Strke des Weichzeichners	(11-255, 11=maximal).
//			  Die Strken 15,31,63,127 und 255 knnen besonders
//			  schnell berechnet werden.
//	uBits	: Ist die Bitanzahl der Farben (15,16,24,oder 32)
//	Ergibt 1 wenn das Bild erzeugt werden konnte
bool BitmapImage::Smoth(const BitmapImage &sImage,unsigned uMode,unsigned uBits)
{
unsigned char 	r[9],g[9],b[9];
unsigned		uRed,uGreen,uBlue;
unsigned		uMul,uDiv  ,uShr;
int				iXpos,iYpos;
int				iXmax,iYmax;



	if(!sImage.IsOk())
		{
		if(IsOk())ClearData();
		return false;
		}

	iXmax = sImage.Width();
	iYmax = sImage.Height();

	if(!SetSize(uBits,iXmax,iYmax,BI_NOT_INIT))
		{
		return false;
		}

	uMode &= 0xFF;

	if(uMode<11)uMode=11;

	uDiv = uMode+1;
	uMul = uDiv-12;
	uShr = 0;

	iXmax--;
	iYmax--;


	     if(uDiv== 16)uShr=4;
	else if(uDiv== 32)uShr=5;
	else if(uDiv== 64)uShr=6;
	else if(uDiv==128)uShr=7;
	else if(uDiv==256)uShr=8;

	if(uShr)
	for(iYpos=0;iYpos<=iYmax;iYpos++)
	for(iXpos=0;iXpos<=iXmax;iXpos++)
		{
		sImage.GetRGB(iXpos,iYpos,r[0],g[0],b[0]);

		if(iYpos>0)
			{
			if(iXpos>    0)sImage.GetRGB(iXpos-1,iYpos-1,r[1],g[1],b[1]);
			else		                 {r[1]=r[0];g[1]=g[0];b[1]=b[0];}
			if(iXpos<iXmax)sImage.GetRGB(iXpos  ,iYpos-1,r[3],g[3],b[3]);
			else			             {r[3]=r[0];g[3]=g[0];b[3]=b[0];}
						   sImage.GetRGB(iXpos+1,iYpos-1,r[2],g[2],b[2]);
			}
		else{
			r[1]=r[0];g[1]=g[0];b[1]=b[0];
			r[2]=r[0];g[2]=g[0];b[2]=b[0];
			r[3]=r[0];g[3]=g[0];b[3]=b[0];
			}

		if(iYpos<iYmax)
			{
			if(iXpos>    0)sImage.GetRGB(iXpos-1,iYpos+1,r[7],g[7],b[7]);
			else			             {r[7]=r[0];g[7]=g[0];b[7]=b[0];}
			if(iXpos<iXmax)sImage.GetRGB(iXpos  ,iYpos+1,r[5],g[5],b[5]);
			else			             {r[5]=r[0];g[5]=g[0];b[5]=b[0];}
						   sImage.GetRGB(iXpos+1,iYpos+1,r[6],g[6],b[6]);
			}
		else{
			r[5]=r[0];g[5]=g[0];b[5]=b[0];
			r[6]=r[0];g[6]=g[0];b[6]=b[0];
			r[7]=r[0];g[7]=g[0];b[7]=b[0];
			}

		if(iXpos>    0)sImage.GetRGB(iXpos-1,iYpos,r[8],g[8],b[8]);
		else			           {r[8]=r[0];g[8]=g[0];b[8]=b[0];}
		if(iXpos<iXmax)sImage.GetRGB(iXpos  ,iYpos,r[4],g[4],b[4]);
		else			           {r[4]=r[0];g[4]=g[0];b[4]=b[0];}

		uRed     = r[0]*uMul+r[1]+r[3]+r[5]+r[7]+r[2]*2+r[4]*2+r[6]*2+r[8]*2;
		uGreen   = g[0]*uMul+g[1]+g[3]+g[5]+g[7]+g[2]*2+g[4]*2+g[6]*2+g[8]*2;
		uBlue    = b[0]*uMul+b[1]+b[3]+b[5]+b[7]+b[2]*2+b[4]*2+b[6]*2+b[8]*2;

		uRed   >>= uShr;
		uGreen >>= uShr;
		uBlue  >>= uShr;

		SetPixel(iXpos,iYpos,uBlue|(uGreen<<8)|(uRed<<16));
		}

	if(!uShr)
	for(iYpos=0;iYpos<=iYmax;iYpos++)
	for(iXpos=0;iXpos<=iXmax;iXpos++)
		{
		sImage.GetRGB(iXpos,iYpos,r[0],g[0],b[0]);

		if(iYpos>0)
			{
			if(iXpos>    0)sImage.GetRGB(iXpos-1,iYpos-1,r[1],g[1],b[1]);
			else			             {r[1]=r[0];g[1]=g[0];b[1]=b[0];}
			if(iXpos<iXmax)sImage.GetRGB(iXpos  ,iYpos-1,r[3],g[3],b[3]);
			else			             {r[3]=r[0];g[3]=g[0];b[3]=b[0];}
						   sImage.GetRGB(iXpos+1,iYpos-1,r[2],g[2],b[2]);
			}
		else{
			r[1]=r[0];g[1]=g[0];b[1]=b[0];
			r[2]=r[0];g[2]=g[0];b[2]=b[0];
			r[3]=r[0];g[3]=g[0];b[3]=b[0];
			}

		if(iYpos<iYmax)
			{
			if(iXpos>    0)sImage.GetRGB(iXpos-1,iYpos+1,r[7],g[7],b[7]);
			else			             {r[7]=r[0];g[7]=g[0];b[7]=b[0];}
			if(iXpos<iXmax)sImage.GetRGB(iXpos  ,iYpos+1,r[5],g[5],b[5]);
			else			             {r[5]=r[0];g[5]=g[0];b[5]=b[0];}
						   sImage.GetRGB(iXpos+1,iYpos+1,r[6],g[6],b[6]);
			}
		else{
			r[5]=r[0];g[5]=g[0];b[5]=b[0];
			r[6]=r[0];g[6]=g[0];b[6]=b[0];
			r[7]=r[0];g[7]=g[0];b[7]=b[0];
			}

		if(iXpos>    0)sImage.GetRGB(iXpos-1,iYpos,r[8],g[8],b[8]);
		else			           {r[8]=r[0];g[8]=g[0];b[8]=b[0];}
		if(iXpos<iXmax)sImage.GetRGB(iXpos  ,iYpos,r[4],g[4],b[4]);
		else			           {r[4]=r[0];g[4]=g[0];b[4]=b[0];}

		uRed    = r[0]*uMul+r[1]+r[3]+r[5]+r[7]+r[2]*2+r[4]*2+r[6]*2+r[8]*2;
		uGreen  = g[0]*uMul+g[1]+g[3]+g[5]+g[7]+g[2]*2+g[4]*2+g[6]*2+g[8]*2;
		uBlue   = b[0]*uMul+b[1]+b[3]+b[5]+b[7]+b[2]*2+b[4]*2+b[6]*2+b[8]*2;

		uRed   /= uDiv;
		uGreen /= uDiv;
		uBlue  /= uDiv;

		SetPixel(iXpos,iYpos,uBlue|(uGreen<<8)|(uRed<<16));
		}


return true;
}


//*****************************************************************************
//*
//*		SetLinePixelDotted
//*
//*****************************************************************************
//	Pixel-Funktion fr punktierte Linien
void FC BitmapImage::SetLinePixelDotted(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{

	if(pImage->uMaskDotted&1)
		{
		pImage->uMaskDotted>>=1;
		pImage->uMaskDotted|=0x80000000;
		return;
		}

	pImage->uMaskDotted>>=1;
	pImage->SetPixel(uXpos,uYpos,uColor);

}

//*****************************************************************************
//*
//*		SetLinePixelDashed
//*
//*****************************************************************************
//	Pixel-Funktion fr strichlierte Linien
void FC BitmapImage::SetLinePixelDashed(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{

	if(pImage->uMaskDashed&1)
		{
		pImage->uMaskDashed>>=1;
		pImage->uMaskDashed|=0x80000000;
		return;
		}

	pImage->uMaskDashed>>=1;
	pImage->SetPixel(uXpos,uYpos,uColor);

}

//*****************************************************************************
//*
//*		SetTextPixelNormal
//*
//*****************************************************************************
//	Pixel-Funktion fr Textausgabe
void FC BitmapImage::SetTextPixelNormal(BitmapImage *pImage,unsigned uPosX,unsigned uPosY,unsigned uColor)
{
unsigned char *pPtr;

	if(uPosX>=pImage->uImageWidth || uPosY>=pImage->uImageHeight)	// Koordinaten prfen
		{
		return;
		}

	pPtr  = ROW_PTR_C(pImage,uPosY);
	pImage->SetPixel_(pPtr,uPosX,uColor);
}

//*****************************************************************************
//*
//*		SetTextPixelSmoth
//*
//*****************************************************************************
//	Pixel-Funktion fr Textausgabe
void FC BitmapImage::SetTextPixelSmoth(BitmapImage *pImage,unsigned uPosX,unsigned uPosY,unsigned uColor)
{
int				i;
unsigned		uMul1,uMul2;
unsigned		cr,cg,cb;
unsigned char 	r,g,b;
static int 		iXadd[9]={-1, 0, 1,-1, 0, 1,-1, 0, 1};
static int 		iYadd[9]={-1,-1,-1, 0, 0, 0, 1, 1, 1};
static unsigned uMul [9]={ 1, 2, 1, 2,20, 2, 1, 2, 1};



	cb = (uColor    )&0xFF;
	cg = (uColor>> 8)&0xFF;
	cr = (uColor>>16)&0xFF;

	for(i=0;i<9;i++)
		{
		uMul1 = uMul[i];
		uMul2 = 32-uMul[i];

		pImage->GetRGB(uPosX+iXadd[i],uPosY+iYadd[i],r,g,b);

		uColor  =  (cb*uMul1+b*uMul2)>>5;
		uColor |= ((cg*uMul1+g*uMul2)>>5)<<8;
		uColor |= ((cr*uMul1+r*uMul2)>>5)<<16;

		pImage->SetPixel(uPosX+iXadd[i],uPosY+iYadd[i],uColor);
		}

}

//*****************************************************************************
//*
//*		SetTextPixelSmoth32
//*
//*****************************************************************************
//	Pixel-Funktion fr Textausgabe mit Alpha-Kanal
void FC BitmapImage::SetTextPixelSmoth32(BitmapImage *pImage,unsigned uPosX,unsigned uPosY,unsigned uColor)
{
int				i;
unsigned		uMul1,uMul2;
unsigned		cr,cg,cb,ca;
unsigned char 	r,g,b,a;
static int 		iXadd[9]={-1, 0, 1,-1, 0, 1,-1, 0, 1};
static int 		iYadd[9]={-1,-1,-1, 0, 0, 0, 1, 1, 1};
static unsigned uMul [9]={ 1, 2, 1, 2,20, 2, 1, 2, 1};



	cb = (uColor    )&0xFF;
	cg = (uColor>> 8)&0xFF;
	cr = (uColor>>16)&0xFF;
	ca = (uColor>>24)&0xFF;

	for(i=0;i<9;i++)
		{
		uMul1 = uMul[i];
		uMul2 = 32-uMul[i];

		pImage->GetRGB(uPosX+iXadd[i],uPosY+iYadd[i],r,g,b,a);

		uColor  =  (cb*uMul1+b*uMul2)>>5;
		uColor |= ((cg*uMul1+g*uMul2)>>5)<<8;
		uColor |= ((cr*uMul1+r*uMul2)>>5)<<16;
		uColor |= ((ca*uMul1+a*uMul2)>>5)<<24;

		pImage->SetPixel(uPosX+iXadd[i],uPosY+iYadd[i],uColor);
		}

}

//*****************************************************************************
//*
//*		TextPut
//*
//*****************************************************************************
//	Fgt ein Text-Bitmap ein
//	uXpos/uYpos	= Koordinaten fr das Bitmap
//	pMem		= Zeiger auf das Bitmap
//				  Byte 0 = Breite in Pixel
//				  Byte 1 = Hhe   in Pixel
//				  Byte 2 = Erste Zeile in Bitmap
void BitmapImage::TextPut(unsigned uXpos,unsigned uYpos,unsigned char *pMem)
{
int		iXsize;
int		iPosX;
int		iPosY;
int		iXmax;
int		iCol;


	if(!pMem)return;

	iPosY  =  pMem[1];
	iXmax  =  pMem[0];
	iXsize = (iXmax+7)>>3;
	pMem  +=  2;

	if(pSet0 && !pSet1)
		{
		for(iPosY--;iPosY>=0;iPosY--,pMem+=iXsize)
		for(iPosX=0;iPosX<iXmax;iPosX++)
			{
			iCol=pMem[iPosX>>3];
			if(!(iCol&(0x80>>(iPosX&7))))
				{
				pSet0(this,iPosX+uXpos,iPosY+uYpos,uTextColor0);
				}
			}

		return;
		}

	if(pSet0 && pSet1)
		{
		for(iPosY--;iPosY>=0;iPosY--,pMem+=iXsize)
		for(iPosX=0;iPosX<iXmax;iPosX++)
			{
			iCol=pMem[iPosX>>3];

			if(iCol&(0x80>>(iPosX&7)))
				{
				pSet1(this,iPosX+uXpos,iPosY+uYpos,uTextColor1);
				}
			else{
				pSet0(this,iPosX+uXpos,iPosY+uYpos,uTextColor0);
				}
			}

		return;
		}

	if(!pSet0 && pSet1)
		{
		for(iPosY--;iPosY>=0;iPosY--,pMem+=iXsize)
		for(iPosX=0;iPosX<iXmax;iPosX++)
			{
			iCol=pMem[iPosX>>3];
			if(iCol&(0x80>>(iPosX&7)))
				{
				pSet1(this,iPosX+uXpos,iPosY+uYpos,uTextColor1);
				}
			}

		return;
		}

}

//*****************************************************************************
//*
//*		TextDummy
//*
//*****************************************************************************
//	Zeichnet den Hintergund fr ein Text-Bitmap ein
//	uXpos/uYpos	= Koordinaten fr das Bitmap
//	pMem		= Zeiger auf das Bitmap
//				  Byte 0 = Breite in Pixel
//				  Byte 1 = Hhe   in Pixel
//				  Byte 2 = Erste Zeile in Bitmap
//	pSet		= Pixelfunktion
void BitmapImage::TextDummy(unsigned uXpos,unsigned uYpos,int iSizeX,int iSizeY,PixelFunction pSet)
{
int		iPosX;
int		iPosY;


	for(iPosY=iSizeY-1;iPosY>=0;iPosY--)
	for(iPosX=0;iPosX<iSizeX;iPosX++)
		{
		pSet(this,iPosX+uXpos,iPosY+uYpos,uTextColor1);
		}

}

//*****************************************************************************
//*
//*		Print
//*
//*****************************************************************************
//	Schreibt eine Text in das Bild
//	Der Font kann mit SetFont eingestellt werden.
//	uXpos	: X-Koordinate fr den Text
//	uYpos	: Y-Koordinate fr den Text	(mit BI_TETXSIZE wird die Breite berechnet)
//	pText	: Zeiger auf den Text
//	Erbibt die Breite des Textes in Pixel
int BitmapImage::Print(unsigned uXpos,unsigned uYpos,const char *pText)
{
PixelFunction	pOld;
const char     *pStr;
unsigned       *pList;
unsigned		uSize;
unsigned		uNext;
unsigned		uPos;
unsigned		uNum;
unsigned char	ucChar;



	if(!pActualFont)return 0;

	pList	 = (unsigned*)(pActualFont+uFontOff);
	uNum	 = 0;

	if(cTextAlignX || uYpos==BI_TETXSIZE)				// Text Ausrichtung berechnen
		{
		pStr  = pText;
		uSize = 0;

		if(*pStr)for(;;)
			{
			   ucChar=*pStr;
			if(ucChar<uFontMin)continue;
			if(ucChar>uFontMax)continue;

			ucChar = (unsigned char)(ucChar-uFontMin);
			uPos   = GET_DW(pList+ucChar);
			uSize += pActualFont[uPos];

			pStr++;
			if(!*pStr)break;

			uSize += iTextJump;
			}

		if(uYpos==BI_TETXSIZE)
			{
			return uSize;
			}

		if(cTextAlignX==1)uSize>>=1;

		uXpos-=uSize;
		}


	uYpos -= cTextAddY;									// Y-Ausrichtung


	if(iTextJump==0 || !pSet1)							// Buchstaben ohne Sprngen oder ohne Hintergrund
		{
		if(*pText)for(;;)
			{
			   ucChar=*pText;
			if(ucChar<uFontMin)continue;
			if(ucChar>uFontMax)continue;

			ucChar = (unsigned char)(ucChar-uFontMin);
			uPos   = GET_DW(pList+ucChar);

			TextPut(uXpos+uNum,uYpos,pActualFont+uPos);
			uNum += pActualFont[uPos];

			pText++;
			if(!*pText)break;

			uNum += iTextJump;
			}
		}
	else if(iTextJump<0)								// Buchstaben mit Sprung nach links
		{
		pOld	= pSet1;
		pSet1	= 0;
		uNext	= 0;

		if(*pText)for(;;)
			{
			   ucChar=*pText;
			if(ucChar<uFontMin)continue;
			if(ucChar>uFontMax)continue;

			ucChar = (unsigned char)(ucChar-uFontMin);
			uPos   = GET_DW(pList+ucChar);

			TextDummy(uXpos+uNum-uNext,uYpos,pActualFont[uPos]+uNext,pActualFont[uPos+1],pOld);
			TextPut  (uXpos+uNum,uYpos,pActualFont+uPos);
			uNum += pActualFont[uPos];

			pText++;
			if(!*pText)break;

			uNum += iTextJump;
			uNext = iTextJump;
			}

		pSet1	= pOld;
		}
	else if(iTextJump>0)								// Buchstaben mit Sprung nach rechts
		{
		uNext	= 0;

		if(*pText)for(;;)
			{
			   ucChar=*pText;
			if(ucChar<uFontMin)continue;
			if(ucChar>uFontMax)continue;

			ucChar = (unsigned char)(ucChar-uFontMin);
			uPos   = GET_DW(pList+ucChar);

			if(uNext)
				{
				TextDummy(uXpos+uNum-uNext,uYpos,uNext,pActualFont[uPos+1],pSet1);
				}

			TextPut(uXpos+uNum,uYpos,pActualFont+uPos);
			uNum += pActualFont[uPos];

			pText++;
			if(!*pText)break;

			uNum += iTextJump;
			uNext = iTextJump;
			}
		}


return uNum;
}


//*****************************************************************************
//*
//*		SetFont
//*
//*****************************************************************************
//	Stellt den aktuellen Font ein
//	pFont	: Zeiger auf den Font
//
//				Header-Format:
//
//					Offset	Gre	Funktion
//					[0]		 1		= Nummer des ersten Buchstabens
//					[1]		 1		= Nummer des letzten Buchstabens
//					[2] 	 4*n	= Offset der Buchstabendaten (n=[1]-[0]+1)
//					[2 +4*n] 4		= Optionales Flag-Feld (Wenn 0x55AA00FF)
//					[6 +4*n] 4		= Gre der Flag-Daten (inklusive 0x55AA00FF)
//					[10+4*n] 2		= Erste ID eines Flags
//					[12+4*n] 2		= Lnge eines Flags
//					[14+4*n] 2		= Daten eines Flags
//
//				Header-Format (erweitert):
//
//					Offset	Gre	Funktion
//					[0]		 1		= Nummer des ersten Buchstabens alt (immer 0)
//					[1]		 1		= Nummer des letzten Buchstabens alt (immer 0)
//					[2]		 2		= Tag immer "FN"
//					[4]		 1		= Schattierung (Bits = 1<<N)
//					[5]		 1		= Unbenutzt immer 0
//					[6]		 2		= Gre des optionalen Flag-Feld (bei Offset 16+4*n)
//					[8]		 2		= Nummer des ersten Buchstabens
//					[10]	 2		= Nummer des letzten Buchstabens
//					[12]	 4		= Unbenutzt immer 0
//					[16] 	 4*n	= Offset der Buchstabendaten (n=[10/11]-[8/9]+1)
//					[16+4*n] 4		= Optionales Flag-Feld (Wenn 0x55AA00FF)
//					[20+4*n] 4		= Gre der Flag-Daten (inklusive 0x55AA00FF)
//					[22+4*n] 2		= Erste ID eines Flags
//					[24+4*n] 2		= Lnge eines Flags
//					[26+4*n] 2		= Daten eines Flags
//
//				Buchstabendaten:
//
//					Offset	Gre	Funktion
//					[0]		 1		= Breite des Buchstabens in Pixel (x)
//					[1]		 1		= Hhe   des Buchstabens in Pixel (y)
//					[2]    (x+7)/8  = Erste Zeile des Buchstabens (unten zu sehen)
//
//				Flag-IDs:
//
//					ID		Gre	Funktion
//					0x0000			= Zeichenabstand des Fonts     (1 wenn nicht definiert)
//					0x0001			= Zeichenverschub bein Zeichen (0 wenn nicht definiert)
//
void BitmapImage::SetFont(unsigned char *pFont)
{
unsigned char   ucChar;
unsigned char  *pData;
unsigned       *pList;
unsigned		uOff;
unsigned		uMax;
unsigned		uMin;
unsigned		uLen;
unsigned		uPos;
unsigned		uId;




	if(!pFont)											// Zeiger prfen
		{
		pActualFont = 0;
		return;
		}

	if(GET_DW(pFont)==0x4E460000)						// Erweiterter Font
		{
		uFontMin	= GET_WORD(pFont+ 8);
		uFontMax	= GET_WORD(pFont+10);
		uFontBit	= pFont[4];
		uFontOff	= 16;
		}
	else{												// Normale Font
		uFontMin	= pFont[0];
		uFontMax	= pFont[1];
		uFontBit	= 0;
		uFontOff	= 2;
		}

	if(uFontMin>uFontMax)								// Enthlt der Font keine Zeichen
		{
		pActualFont = 0;
		return;
		}


	pData		= pFont+uFontOff+(uFontMax-uFontMin+1)*4;
	pActualFont = pFont;
	iTextShift	= 0;
	iTextSpace	= 1;
	iTextBase	= 0;
	uMax		= GET_DW(pData+4);


	if(GET_DW(pData)==0x55AA00FF && uMax<=4096)			// Flags einlesen
		{
		uOff = 8;

		while(uOff<uMax)
			{
			uId		= pData[uOff]+pData[uOff+1]*256;	uOff+=2;
			uLen	= pData[uOff]+pData[uOff+1]*256;	uOff+=2;

			switch(uId)
				{
			case 0x0000:	iTextShift = (char)pData[uOff];	break;
			case 0x0001:	iTextSpace = (char)pData[uOff];	break;
			case 0x0002:	iTextBase  = (char)pData[uOff];	break;
				}

			uOff += uLen;
			}
		}


	if(iTextHole==TEXT_AUTOSPACE)						// Automatischer Zeichenabstand
		{
		iTextJump	= iTextShift;
		}
	else{
		iTextJump	= iTextHole-iTextSpace+iTextShift;
		}


	if(cTextAlignY && pFont)							// Ausrichtung in Y-Richtung
		{
		if(cTextAlignY==3 && iTextBase)					// Auf Base-Line
			{
			cTextAddY	= -iTextBase;
			}
		else{
			uMin		= uFontMin;
			uMax		= uFontMax-uMin;
			ucChar		= (uMin<=' ' && uMax<=' ')? ' '-uMin:uMin;
			pList		= (unsigned*)(pFont+uFontOff);

			if(ucChar>uMax)ucChar=0;

			uPos		= GET_DW(pList+ucChar);
			cTextAddY	= pFont[uPos+1];

			if(cTextAlignY==1)cTextAddY>>=1;
			}

		}
	else{
		cTextAddY	= 0;
		}


}

//*****************************************************************************
//*
//*		SetSpacing
//*
//*****************************************************************************
//	Stellt den Leeraumzwischen den den Buchstaben ein.
//	iSpace		: Ist der neue Leeraum (TEXT_AUTOSPACE fr default Schriftabstand)
void BitmapImage::SetSpacing(int iSpace)
{

	iTextHole	= iSpace;

	if(iTextHole==TEXT_AUTOSPACE)
		{
		iTextJump	= iTextShift;
		}
	else{
		iTextJump	= iTextHole-iTextSpace+iTextShift;
		}

}

//*****************************************************************************
//*
//*		SetPixelFunction
//*
//*****************************************************************************
//	Einstellen der Pixel-Funktionen fr die Textausgabe
//	pProc	: Ist die benutzte Funktion
//					TEXT_NONE	: Keinen Pixes ausgeben
//					TEXT_SMOTH	: Mit Weichzeichner
//					TEXT_NORMAL	: Direkt setzen
//	uColor		: Ist die Pixelfarbe
//	iPixel		: Welche Pixel-Funktionen soll gesetzt werden (1=HG 0=VG)
void BitmapImage::SetPixelFunction(PixelFunction pProc,unsigned uColor,int iPixel)
{


	if(uImageBits<=8)
	if(pProc==SetTextPixelSmoth)
		{
		pProc=SetTextPixelNormal;
		}

	if(uImageBits==32)
	if(pProc==SetTextPixelSmoth)
		{
		pProc=SetTextPixelSmoth32;
		}

	if(iPixel)
		{
		pSet1		= pProc;
		uTextColor1 = uColor;
		}
	else{
		pSet0		= pProc;
		uTextColor0 = uColor;
		}


}

//*****************************************************************************
//*
//*		Fill
//*
//*****************************************************************************
//	Fllt einen Bereich des Bildes mit einer bestimmten Farbe
//	uXpos		: X-Koordinate fr den Fllpunkt
//	uYpos		: Y-Koordinate fr den Fllpunkt
//	uPixel		: Ist die Pixelfarbe bei Bildern mit mehr als 8 Bit
//	Ergibt true wenn der Bereich gefllt werden konnte
bool BitmapImage::Fill(unsigned uXpos,unsigned uYpos,unsigned uPixel)
{
#define 		AddPoint(x,y,m,l)	if(!l){l=1;pPoints[uNow]=(m)|((x)<<2)|((y)<<17);uNow++;}
unsigned	   *pPoints;
unsigned	   *pPtOld;
unsigned char  *pRowP;
unsigned char  *pRowM;
unsigned char  *pRowN;
unsigned		uStart;
unsigned		uModeX;
unsigned		uMode;
unsigned		uTempX;
unsigned		uTemp;
unsigned		uLastX;
unsigned		uLast;
unsigned		uFrom;
unsigned		uMax;
unsigned		uNow;


	if(uXpos>=uImageWidth )return false;
	if(uYpos>=uImageHeight)return false;


	uPixel &= uPixelMask;
	uStart	= GetPixel(uXpos,uYpos);
	pPoints = 0;
	uMax	= 0;
	uNow	= 0;

	if(uPixel==uStart)return true;

	   uMax	= uImageWidth*8;
	if(uMax<1024)uMax=1024;

		pPoints	= new unsigned[uMax];
	if(!pPoints)return false;




							uMode =0;
	if(uYpos>0             )uMode|=1;
	if(uYpos+2<uImageHeight)uMode|=2;

	uNow		= 1;
	pPoints[0]	= uMode|(uXpos<<2)|(uYpos<<17);




	while(uNow>0)											// Wurden alle Punkte abgearbeitet
		{
		uNow   -= 1;
		uMode	= pPoints[uNow];
		uXpos	= (uMode>> 2)&0x7FFF;
		uYpos	= (uMode>>17)&0x7FFF;

		pRowN	= ROW_PTR(uYpos);
		SetPixel_(pRowN,uXpos,uPixel);


		switch(uMode&3)
			{
		case 3:												// Oben und Unten scannen
				pRowM	= ROW_PTR(uYpos-1);
				pRowP	= ROW_PTR(uYpos+1);
				uModeX	= (uYpos+2<uImageHeight)? 3:1;
				uMode	= (uYpos>1)? 3:2;
				uFrom	=  uXpos;
				uLast	=  0;
				uLastX	=  0;

				if(GetPixel_(pRowM,uXpos)==uStart)
					{
					AddPoint(uXpos,uYpos-1,uMode,uLast);
					}

				if(GetPixel_(pRowP,uXpos)==uStart)
					{
					AddPoint(uXpos,uYpos+1,uModeX,uLastX);
					}

				uTempX	= uLastX;
				uTemp	= uLast;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);

					if(GetPixel_(pRowM,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}

					if(GetPixel_(pRowP,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}

				uLastX	= uTempX;
				uLast	= uTemp;

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);

					if(GetPixel_(pRowM,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}

					if(GetPixel_(pRowP,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}


				break;

		case 2:												// Oben scannen
				pRowP	= ROW_PTR(uYpos+1);
				uModeX	= (uYpos+2<uImageHeight)? 3:0;
				uFrom	=  uXpos;
				uLastX	=  0;

				if(GetPixel_(pRowP,uXpos)==uStart)
					{
					AddPoint(uXpos,uYpos+1,uModeX,uLastX);
					}

				uTempX	= uLastX;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);

					if(GetPixel_(pRowP,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}

				uLastX	= uTempX;

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);

					if(GetPixel_(pRowP,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}


				break;

		case 1:												// Unten scannen
				pRowM	= ROW_PTR(uYpos-1);
				uMode	= (uYpos>1)? 3:0;
				uFrom	=  uXpos;
				uLast	=  0;

				if(GetPixel_(pRowM,uXpos)==uStart)
					{
					AddPoint(uXpos,uYpos-1,uMode,uLast);
					}

				uTemp	= uLast;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);

					if(GetPixel_(pRowM,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}
					}

				uLast	= uTemp;

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);

					if(GetPixel_(pRowM,uXpos)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}
					}


		case 0:												// Einzeiliger Scann
				uFrom	=  uXpos;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);
					}

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(GetPixel_(pRowN,uXpos)!=uStart)break;
					   SetPixel_(pRowN,uXpos,uPixel);
					}

			}


		if(uNow+uImageWidth>=uMax)							// Punktspeicher vergrern
			{
			pPtOld	= pPoints;
			uMax   *= 2;

				pPoints	= new unsigned[uMax];
			if(!pPoints)
				{
				delete pPtOld;
				return false;
				}

			memcpy(pPoints,pPtOld,uNow*sizeof(*pPoints));
			delete pPtOld;
			}
		}



	delete pPoints;



return true;
}

//*****************************************************************************
//*
//*		Fill
//*
//*****************************************************************************
//	Fllt einen Bereich des Bildes mit einer bestimmten Farbe. Die Grenzfarben
//	und das Pixelzeichen werden dabei ber Callbacks erledigt.
//	uXpos		: X-Koordinate fr den Fllpunkt
//	uYpos		: Y-Koordinate fr den Fllpunkt
//	uPixel		: Ist die Pixelfarbe bei Bildern mit mehr als 8 Bit
//	pSet		: Ist die Funktion mit der ein Pixel gezeichnet wird
//	pGet		: Ist die Funktion mit der ein Pixel gelesen wird
//	uStart		: Ist die Farbe des Startpunktes.
//				  Bei 0xFFFFFFFF wird er automatisch ausgelesen.
//	Ergibt true wenn der Bereich gefllt werden konnte
bool BitmapImage::Fill(unsigned uXpos,unsigned uYpos,unsigned uPixel,PixelFillSet pSet,PixelFillGet pGet,unsigned uStart)
{
#define 		AddPoint(x,y,m,l)	if(!l){l=1;pPoints[uNow]=(m)|((x)<<2)|((y)<<17);uNow++;}
unsigned	   *pPoints;
unsigned	   *pPtOld;
unsigned char  *pRowP;
unsigned char  *pRowM;
unsigned char  *pRowN;
unsigned		uYposP;
unsigned		uYposM;
unsigned		uModeX;
unsigned		uMode;
unsigned		uTempX;
unsigned		uTemp;
unsigned		uLastX;
unsigned		uLast;
unsigned		uFrom;
unsigned		uMax;
unsigned		uNow;


	if(uXpos>=uImageWidth )return false;
	if(uYpos>=uImageHeight)return false;

	if(uStart==0xFFFFFFFF)									// Startpunkt auslesen
		{
		pRowN	= ROW_PTR(uYpos);
		uStart	= pGet(this,pRowN,uXpos,uYpos);
		}

	uPixel &= uPixelMask;
	pPoints = 0;
	uMax	= 0;
	uNow	= 0;

	if(uPixel==uStart)return true;

	   uMax	= uImageWidth*8;
	if(uMax<1024)uMax=1024;

		pPoints	= new unsigned[uMax];
	if(!pPoints)return false;




							uMode =0;
	if(uYpos>0             )uMode|=1;
	if(uYpos+2<uImageHeight)uMode|=2;

	uNow		= 1;
	pPoints[0]	= uMode|(uXpos<<2)|(uYpos<<17);




	while(uNow>0)											// Wurden alle Punkte abgearbeitet
		{
		uNow   -= 1;
		uMode	= pPoints[uNow];
		uXpos	= (uMode>> 2)&0x7FFF;
		uYpos	= (uMode>>17)&0x7FFF;

		pRowN	= ROW_PTR(uYpos);
		pSet(this,pRowN,uXpos,uYpos,uPixel);


		switch(uMode&3)
			{
		case 3:												// Oben und Unten scannen

				uYposM	= uYpos-1;
				uYposP	= uYpos+1;
				pRowM	= ROW_PTR(uYpos-1);
				pRowP	= ROW_PTR(uYpos+1);
				uModeX	= (uYpos+2<uImageHeight)? 3:1;
				uMode	= (uYpos>1)? 3:2;
				uFrom	=  uXpos;
				uLast	=  0;
				uLastX	=  0;

				if(pGet(this,pRowM,uXpos,uYposM)==uStart)
					{
					AddPoint(uXpos,uYpos-1,uMode,uLast);
					}

				if(pGet(this,pRowP,uXpos,uYposP)==uStart)
					{
					AddPoint(uXpos,uYpos+1,uModeX,uLastX);
					}

				uTempX	= uLastX;
				uTemp	= uLast;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);

					if(pGet(this,pRowM,uXpos,uYposM)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}

					if(pGet(this,pRowP,uXpos,uYposP)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}

				uLastX	= uTempX;
				uLast	= uTemp;

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);

					if(pGet(this,pRowM,uXpos,uYposM)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}

					if(pGet(this,pRowP,uXpos,uYposP)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}


				break;

		case 2:												// Oben scannen
				uYposP	= uYpos+1;
				pRowP	= ROW_PTR(uYpos+1);
				uModeX	= (uYpos+2<uImageHeight)? 3:0;
				uFrom	=  uXpos;
				uLastX	=  0;

				if(pGet(this,pRowP,uXpos,uYposP)==uStart)
					{
					AddPoint(uXpos,uYpos+1,uModeX,uLastX);
					}

				uTempX	= uLastX;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);

					if(pGet(this,pRowP,uXpos,uYposP)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}

				uLastX	= uTempX;

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);

					if(pGet(this,pRowP,uXpos,uYposP)==uStart)
						{
						AddPoint(uXpos,uYpos+1,uModeX,uLastX);
						}
					else{
						uLastX=0;
						}
					}


				break;

		case 1:												// Unten scannen
				uYposM	= uYpos-1;
				pRowM	= ROW_PTR(uYpos-1);
				uMode	= (uYpos>1)? 3:0;
				uFrom	=  uXpos;
				uLast	=  0;

				if(pGet(this,pRowM,uXpos,uYposM)==uStart)
					{
					AddPoint(uXpos,uYpos-1,uMode,uLast);
					}

				uTemp	= uLast;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);

					if(pGet(this,pRowM,uXpos,uYposM)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}
					}

				uLast	= uTemp;

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);

					if(pGet(this,pRowM,uXpos,uYposM)==uStart)
						{
						AddPoint(uXpos,uYpos-1,uMode,uLast);
						}
					else{
						uLast=0;
						}
					}


		case 0:												// Einzeiliger Scann
				uFrom	=  uXpos;

				for(uXpos++;uXpos<uImageWidth;uXpos++)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);
					}

				for(uXpos=uFrom-1;(int)uXpos>=0;uXpos--)
					{
					if(pGet(this,pRowN,uXpos,uYpos)!=uStart)break;
					   pSet(this,pRowN,uXpos,uYpos,uPixel);
					}

			}


		if(uNow+uImageWidth>=uMax)							// Punktspeicher vergrern
			{
			pPtOld	= pPoints;
			uMax   *= 2;

				pPoints	= new unsigned[uMax];
			if(!pPoints)
				{
				delete pPtOld;
				return false;
				}

			memcpy(pPoints,pPtOld,uNow*sizeof(*pPoints));
			delete pPtOld;
			}
		}



	delete pPoints;



return true;
}

//*****************************************************************************
//*
//*		GetFillPixel
//*
//*****************************************************************************
//	Holt einen Pixel fr die Fllfunktion
//	pImage		: Zeiger auf das Bild
//	pPtr		: Zeiger auf die Bildzeile
//	uPosX		: X-Koordinate
//	uPosY		: Y-Koordinate
//	Ergibt den Wert des Pixels
unsigned FC	BitmapImage::GetFillPixel(BitmapImage *pImage,unsigned char *pRow,unsigned uPosX,unsigned uPosY)
{
return  pImage->GetPixel_(pRow,uPosX);
}

//*****************************************************************************
//*
//*		Triangle
//*
//*****************************************************************************
//	Zeichnet ein Dreieck in das Bild.
//	pPoints		: Ist ein Zeiger auf die Eckpunkte des Dreiecks. (X1,Y1,X2...)
//	iPixel		: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Triangle(int *pPoints,int iPixel)
{
unsigned char  *pMem;
int				iFlag;
int				iMinX;
int				iMinY;
int				iMaxX;
int				iMaxY;
int				iMin;
int				iNum;
int				iLen;
int				i,j;




	iMin   = 0;												// Suche hchsten Punkt
	iMinY  = pPoints[1];
	iMaxY  = pPoints[1];

	if(iMinY>pPoints[3]){iMinY=pPoints[3];iMin=1;}
	if(iMaxY<pPoints[3]){iMaxY=pPoints[3];       }
	if(iMinY>pPoints[5]){iMinY=pPoints[5];iMin=2;}
	if(iMaxY<pPoints[5]){iMaxY=pPoints[5];       }


	if(iMinY>=(int)uImageHeight)return 0;
	if(iMaxY<                 0)return 0;


	iMinX  = pPoints[0];
	iMaxX  = pPoints[0];

	if(iMinX>pPoints[2]){iMinX=pPoints[2];}
	if(iMaxX<pPoints[2]){iMaxX=pPoints[2];}
	if(iMinX>pPoints[4]){iMinX=pPoints[4];}
	if(iMaxX<pPoints[4]){iMaxX=pPoints[4];}

	if(iMinX>=(int)uImageWidth )return 0;
	if(iMaxX<                 0)return 0;

//******************** Erste Linie initialisieren *****************************
int		iLaAddY =1,iLaAddX =1;
int		iLaAddY1=1,iLaAddX1=1;
int		iLaSizeY  ,iLaSizeX;
int		iLaPosY   ,iLaPosX;
int		iLaNumY   ,iLaNumX;



	iNum = (iMin+1)%3;

	iLaPosY	 = pPoints[iMin*2+1];
	iLaSizeY = pPoints[iNum*2+1]-iLaPosY;

	if(iLaSizeY<0)
		{
		iLaAddY  = -1;
		iLaSizeY = -iLaSizeY;
		}


	iLaPosX	 = pPoints[iMin*2];
	iLaSizeX = pPoints[iNum*2]-iLaPosX;

	if(iLaSizeX<0)
		{
		iLaAddX  = -1;
		iLaSizeX = -iLaSizeX;
		}

	iLaAddY1 = iLaAddY;
	iLaAddX1 = iLaAddX;

	if(iLaSizeY>iLaSizeX)
		{
		iLaAddX1 = 0;
		}
	else{
		i        = iLaSizeY;
		iLaSizeY = iLaSizeX;
		iLaSizeX = i;
		iLaAddY1 = 0;
		}


	iLaNumY = (iLaSizeY-iLaSizeX+1)>>1;
	iLaNumX = (iLaSizeY-iLaSizeX);
	iLaSizeY++;


//******************** Zweite Linie initialisieren *****************************
int		iLbAddY =1,iLbAddX =1;
int		iLbAddY1=1,iLbAddX1=1;
int		iLbSizeY  ,iLbSizeX;
int		iLbPosY   ,iLbPosX;
int		iLbNumY   ,iLbNumX;



	iNum = (iMin+2)%3;

	iLbPosY	 = pPoints[iMin*2+1];
	iLbSizeY = pPoints[iNum*2+1]-iLbPosY;

	if(iLbSizeY<0)
		{
		iLbAddY  = -1;
		iLbSizeY = -iLbSizeY;
		}


	iLbPosX	 = pPoints[iMin*2];
	iLbSizeX = pPoints[iNum*2]-iLbPosX;

	if(iLbSizeX<0)
		{
		iLbAddX  = -1;
		iLbSizeX = -iLbSizeX;
		}

	iLbAddY1 = iLbAddY;
	iLbAddX1 = iLbAddX;

	if(iLbSizeY>iLbSizeX)
		{
		iLbAddX1 = 0;
		}
	else{
		i        = iLbSizeY;
		iLbSizeY = iLbSizeX;
		iLbSizeX = i;
		iLbAddY1 = 0;
		}


	iLbNumY = (iLbSizeY-iLbSizeX+1)>>1;
	iLbNumX = (iLbSizeY-iLbSizeX);
	iLbSizeY++;


	iFlag	= 0;


//******************** Dreieck zeichnen ****************************************


	for(;;)
		{
		iMinX = iLaPosX;
		iMaxX = iLaPosX;


		while(iLaSizeY>0)									// Linie A abschreiten
			{
			iLaSizeY--;

			if(iMinX>iLaPosX)iMinX=iLaPosX;
			if(iMaxX<iLaPosX)iMaxX=iLaPosX;

			if(iLaNumY>0)
				{
				iLaNumY -= iLaSizeX;
				iLaPosX += iLaAddX1;
				iLaPosY += iLaAddY1;

				if(iLaAddY1)break;
				}
			else{
				iLaNumY += iLaNumX;
				iLaPosX += iLaAddX;
				iLaPosY += iLaAddY;

				if(iLaAddY)break;
				}
			}


		while(iLbSizeY>0)									// Linie B abschreiten
			{
			iLbSizeY--;

			if(iMinX>iLbPosX)iMinX=iLbPosX;
			if(iMaxX<iLbPosX)iMaxX=iLbPosX;

			if(iLbNumY>0)
				{
				iLbNumY -= iLbSizeX;
				iLbPosX += iLbAddX1;
				iLbPosY += iLbAddY1;

				if(iLbAddY1)break;
				}
			else{
				iLbNumY += iLbNumX;
				iLbPosX += iLbAddX;
				iLbPosY += iLbAddY;

				if(iLbAddY)break;
				}
			}


		//*********************************************************************


		if(iLaSizeY<=0 && iFlag==0)							// Linie A nachladen
			{
			iLaAddY =1,
			iLaAddX =1;
			iLaAddY1=1,
			iLaAddX1=1;

			iNum = (iMin+2)%3;
			iMin = (iMin+1)%3;

			iLaPosY	 = pPoints[iMin*2+1];
			iLaSizeY = pPoints[iNum*2+1]-iLaPosY;

			if(iLaSizeY<0)
				{
				iLaAddY  = -1;
				iLaSizeY = -iLaSizeY;
				}


			iLaPosX	 = pPoints[iMin*2];
			iLaSizeX = pPoints[iNum*2]-iLaPosX;

			if(iLaSizeX<0)
				{
				iLaAddX  = -1;
				iLaSizeX = -iLaSizeX;
				}

			iLaAddY1 = iLaAddY;
			iLaAddX1 = iLaAddX;

			if(iLaSizeY>iLaSizeX)
				{
				iLaAddX1 = 0;
				}
			else{
				i        = iLaSizeY;
				iLaSizeY = iLaSizeX;
				iLaSizeX = i;
				iLaAddY1 = 0;
				}


			iLaNumY = (iLaSizeY-iLaSizeX+1)>>1;
			iLaNumX = (iLaSizeY-iLaSizeX);
			iLaSizeY++;

			iFlag = 1;

			while(iLaSizeY>0)								// Linie A abschreiten
				{
				iLaSizeY--;

				if(iMinX>iLaPosX)iMinX=iLaPosX;
				if(iMaxX<iLaPosX)iMaxX=iLaPosX;

				if(iLaNumY>0)
					{
					iLaNumY -= iLaSizeX;
					iLaPosX += iLaAddX1;
					iLaPosY += iLaAddY1;

					if(iLaAddY1)break;
					}
				else{
					iLaNumY += iLaNumX;
					iLaPosX += iLaAddX;
					iLaPosY += iLaAddY;

					if(iLaAddY)break;
					}
				}
			}

		if(iLbSizeY<=0 && iFlag==0)							// Linie B nachladen
			{
			iLbAddY =1,
			iLbAddX =1;
			iLbAddY1=1,
			iLbAddX1=1;


			iNum = (iMin+1)%3;
			iMin = (iMin+2)%3;

			iLbPosY	 = pPoints[iMin*2+1];
			iLbSizeY = pPoints[iNum*2+1]-iLbPosY;

			if(iLbSizeY<0)
				{
				iLbAddY  = -1;
				iLbSizeY = -iLbSizeY;
				}


			iLbPosX	 = pPoints[iMin*2];
			iLbSizeX = pPoints[iNum*2]-iLbPosX;

			if(iLbSizeX<0)
				{
				iLbAddX  = -1;
				iLbSizeX = -iLbSizeX;
				}

			iLbAddY1 = iLbAddY;
			iLbAddX1 = iLbAddX;

			if(iLbSizeY>iLbSizeX)
				{
				iLbAddX1 = 0;
				}
			else{
				i        = iLbSizeY;
				iLbSizeY = iLbSizeX;
				iLbSizeX = i;
				iLbAddY1 = 0;
				}


			iLbNumY = (iLbSizeY-iLbSizeX+1)>>1;
			iLbNumX = (iLbSizeY-iLbSizeX);
			iLbSizeY++;

			iFlag = 1;

			while(iLbSizeY>0)								// Linie B abschreiten
				{
				iLbSizeY--;

				if(iMinX>iLbPosX)iMinX=iLbPosX;
				if(iMaxX<iLbPosX)iMaxX=iLbPosX;

				if(iLbNumY>0)
					{
					iLbNumY -= iLbSizeX;
					iLbPosX += iLbAddX1;
					iLbPosY += iLbAddY1;

					if(iLbAddY1)break;
					}
				else{
					iLbNumY += iLbNumX;
					iLbPosX += iLbAddX;
					iLbPosY += iLbAddY;

					if(iLbAddY)break;
					}
				}
			}


		//************ Zeile zeichnen *****************************************


		if(iMinY>=0 && iMaxX>=0 && iMinX<(int)uImageWidth)
			{
			if(iMinY>=(int)uImageHeight)break;

			pMem = ROW_PTR(iMinY);

			if(iMinX<                0)iMinX=0;
			if(iMaxX>=(int)uImageWidth)iMaxX=uImageWidth-1;


			switch(uBytesPerPixel)
					{
			case 1:	     if(uImageBits==8)j=(iPixel&0xFF)*0x01010101;
					else if(uImageBits==4)j=(iPixel&0x0F)*0x11111111;
					else if(uImageBits==2)j=(iPixel&0x03)*0x55555555;
					else if(uImageBits==1)j=(iPixel&0x01)? -1:0;
					else				  j=(iPixel&0xFF)*0x01010101;


					while(iMinX<=iMaxX && (iMinX&uColumMask))
						{
						SetPixel_(pMem,iMinX,iPixel);
						iMinX++;
						}

					iLen = (iMaxX-iMinX+1)>>uShiftMask;

					if(iLen>0)
						{
						memset(pMem+iMinX/uColumBit,j,iLen);
						iMinX += iLen<<uShiftMask;
						}

					while(iMinX<=iMaxX)
						{
						SetPixel_(pMem,iMinX,iPixel);
						iMinX++;
						}

					break;

			case 2:	if(uImageBits==15)	j=RGB_TO_C15(iPixel);
					else				j=RGB_TO_C16(iPixel);

					j    |= (j<<16);
					iLen  = iMaxX-iMinX;
					pMem += iMinX*2;

					if(iMinX&1)
						{
						*(short*)pMem = (short)j;
						pMem+=2;
						iLen--;
						}

					while(iLen>0)
						{
						SET_DW(pMem,j);
						iLen -= 2;
						pMem += 4;
						}

					if(iLen>=0)
						{
						*(short*)pMem = (short)j;
						}

					break;

			case 3:	if(uImageBits==12)
						{
						j	= RGB_TO_C12H(iPixel)|RGB_TO_C12L(iPixel);

						if(iMinX&1)
							{
							SetPixel_(pMem,iMinX,iPixel);
							iMinX++;
							}

						iLen  = iMaxX-iMinX+1;

						for(;iLen>0;iLen-=2)
							{
							RGB_TO_P24(j,pMem+iMaxX/2);
							iMinX+=2;
							}

						if(iMinX<=iMaxX)
							{
							SetPixel_(pMem,iMaxX,iPixel);
							}

						break;
						}

					j	  = RGB_TO_C24(iPixel);
					iLen  = iMaxX-iMinX;
					pMem += iMinX*3;

					for(iLen*=3;iLen>=0;iLen-=3)
						{
						RGB_TO_P24(j,pMem+iLen);
						}

					break;

			case 4:	iLen  = iMaxX-iMinX;
					pMem += iMinX*4;

					for(iLen*=4;iLen>=0;iLen-=4)RGB_TO_P32(iPixel,pMem+iLen);

					break;
					}
			}


		if(iFlag && iLaSizeY<=0 && iLbSizeY<=0)				// Ende erreicht ?
			{
			break;
			}

		iMinY++;
		}


return 1;
}


//*****************************************************************************
//*
//*		Triangle
//*
//*****************************************************************************
//	Zeichnet ein Dreieck in das Bild mittels Pixel-Callback-Funktion.
//	pPoints		: Ist ein Zeiger auf die Eckpunkte des Dreiecks. (X1,Y1,X2...)
//	iPixel		: Ist die Farbe bzw. der Farbindex fr das Rechteck.
//	pSet			: Ist die Funktion zum Fllen der Pixel
//	Ergibt TRUE wenn alles ok war, bzw. FALSE bei einem Fehler
bool BitmapImage::Triangle(int *pPoints,int iPixel,PixelFillSet pSet)
{
unsigned char  *pMem;
int				iFlag;
int				iMinX;
int				iMinY;
int				iMaxX;
int				iMaxY;
int				iMin;
int				iNum;
int				i;




	iMin   = 0;												// Suche hchsten Punkt
	iMinY  = pPoints[1];
	iMaxY  = pPoints[1];

	if(iMinY>pPoints[3]){iMinY=pPoints[3];iMin=1;}
	if(iMaxY<pPoints[3]){iMaxY=pPoints[3];       }
	if(iMinY>pPoints[5]){iMinY=pPoints[5];iMin=2;}
	if(iMaxY<pPoints[5]){iMaxY=pPoints[5];       }


	if(iMinY>=(int)uImageHeight)return 0;
	if(iMaxY<                 0)return 0;


	iMinX  = pPoints[0];
	iMaxX  = pPoints[0];

	if(iMinX>pPoints[2]){iMinX=pPoints[2];}
	if(iMaxX<pPoints[2]){iMaxX=pPoints[2];}
	if(iMinX>pPoints[4]){iMinX=pPoints[4];}
	if(iMaxX<pPoints[4]){iMaxX=pPoints[4];}

	if(iMinX>=(int)uImageWidth )return 0;
	if(iMaxX<                 0)return 0;

//******************** Erste Linie initialisieren *****************************
int		iLaAddY =1,iLaAddX =1;
int		iLaAddY1=1,iLaAddX1=1;
int		iLaSizeY  ,iLaSizeX;
int		iLaPosY   ,iLaPosX;
int		iLaNumY   ,iLaNumX;



	iNum = (iMin+1)%3;

	iLaPosY	 = pPoints[iMin*2+1];
	iLaSizeY = pPoints[iNum*2+1]-iLaPosY;

	if(iLaSizeY<0)
		{
		iLaAddY  = -1;
		iLaSizeY = -iLaSizeY;
		}


	iLaPosX	 = pPoints[iMin*2];
	iLaSizeX = pPoints[iNum*2]-iLaPosX;

	if(iLaSizeX<0)
		{
		iLaAddX  = -1;
		iLaSizeX = -iLaSizeX;
		}

	iLaAddY1 = iLaAddY;
	iLaAddX1 = iLaAddX;

	if(iLaSizeY>iLaSizeX)
		{
		iLaAddX1 = 0;
		}
	else{
		i        = iLaSizeY;
		iLaSizeY = iLaSizeX;
		iLaSizeX = i;
		iLaAddY1 = 0;
		}


	iLaNumY = (iLaSizeY-iLaSizeX+1)>>1;
	iLaNumX = (iLaSizeY-iLaSizeX);
	iLaSizeY++;


//******************** Zweite Linie initialisieren *****************************
int		iLbAddY =1,iLbAddX =1;
int		iLbAddY1=1,iLbAddX1=1;
int		iLbSizeY  ,iLbSizeX;
int		iLbPosY   ,iLbPosX;
int		iLbNumY   ,iLbNumX;



	iNum = (iMin+2)%3;

	iLbPosY	 = pPoints[iMin*2+1];
	iLbSizeY = pPoints[iNum*2+1]-iLbPosY;

	if(iLbSizeY<0)
		{
		iLbAddY  = -1;
		iLbSizeY = -iLbSizeY;
		}


	iLbPosX	 = pPoints[iMin*2];
	iLbSizeX = pPoints[iNum*2]-iLbPosX;

	if(iLbSizeX<0)
		{
		iLbAddX  = -1;
		iLbSizeX = -iLbSizeX;
		}

	iLbAddY1 = iLbAddY;
	iLbAddX1 = iLbAddX;

	if(iLbSizeY>iLbSizeX)
		{
		iLbAddX1 = 0;
		}
	else{
		i        = iLbSizeY;
		iLbSizeY = iLbSizeX;
		iLbSizeX = i;
		iLbAddY1 = 0;
		}


	iLbNumY = (iLbSizeY-iLbSizeX+1)>>1;
	iLbNumX = (iLbSizeY-iLbSizeX);
	iLbSizeY++;


	iFlag	= 0;


//******************** Dreieck zeichnen ****************************************


	for(;;)
		{
		iMinX = iLaPosX;
		iMaxX = iLaPosX;


		while(iLaSizeY>0)									// Linie A abschreiten
			{
			iLaSizeY--;

			if(iMinX>iLaPosX)iMinX=iLaPosX;
			if(iMaxX<iLaPosX)iMaxX=iLaPosX;

			if(iLaNumY>0)
				{
				iLaNumY -= iLaSizeX;
				iLaPosX += iLaAddX1;
				iLaPosY += iLaAddY1;

				if(iLaAddY1)break;
				}
			else{
				iLaNumY += iLaNumX;
				iLaPosX += iLaAddX;
				iLaPosY += iLaAddY;

				if(iLaAddY)break;
				}
			}


		while(iLbSizeY>0)									// Linie B abschreiten
			{
			iLbSizeY--;

			if(iMinX>iLbPosX)iMinX=iLbPosX;
			if(iMaxX<iLbPosX)iMaxX=iLbPosX;

			if(iLbNumY>0)
				{
				iLbNumY -= iLbSizeX;
				iLbPosX += iLbAddX1;
				iLbPosY += iLbAddY1;

				if(iLbAddY1)break;
				}
			else{
				iLbNumY += iLbNumX;
				iLbPosX += iLbAddX;
				iLbPosY += iLbAddY;

				if(iLbAddY)break;
				}
			}


		//*********************************************************************


		if(iLaSizeY<=0 && iFlag==0)							// Linie A nachladen
			{
			iLaAddY =1,
			iLaAddX =1;
			iLaAddY1=1,
			iLaAddX1=1;

			iNum = (iMin+2)%3;
			iMin = (iMin+1)%3;

			iLaPosY	 = pPoints[iMin*2+1];
			iLaSizeY = pPoints[iNum*2+1]-iLaPosY;

			if(iLaSizeY<0)
				{
				iLaAddY  = -1;
				iLaSizeY = -iLaSizeY;
				}


			iLaPosX	 = pPoints[iMin*2];
			iLaSizeX = pPoints[iNum*2]-iLaPosX;

			if(iLaSizeX<0)
				{
				iLaAddX  = -1;
				iLaSizeX = -iLaSizeX;
				}

			iLaAddY1 = iLaAddY;
			iLaAddX1 = iLaAddX;

			if(iLaSizeY>iLaSizeX)
				{
				iLaAddX1 = 0;
				}
			else{
				i        = iLaSizeY;
				iLaSizeY = iLaSizeX;
				iLaSizeX = i;
				iLaAddY1 = 0;
				}


			iLaNumY = (iLaSizeY-iLaSizeX+1)>>1;
			iLaNumX = (iLaSizeY-iLaSizeX);
			iLaSizeY++;

			iFlag = 1;

			while(iLaSizeY>0)								// Linie A abschreiten
				{
				iLaSizeY--;

				if(iMinX>iLaPosX)iMinX=iLaPosX;
				if(iMaxX<iLaPosX)iMaxX=iLaPosX;

				if(iLaNumY>0)
					{
					iLaNumY -= iLaSizeX;
					iLaPosX += iLaAddX1;
					iLaPosY += iLaAddY1;

					if(iLaAddY1)break;
					}
				else{
					iLaNumY += iLaNumX;
					iLaPosX += iLaAddX;
					iLaPosY += iLaAddY;

					if(iLaAddY)break;
					}
				}
			}

		if(iLbSizeY<=0 && iFlag==0)							// Linie B nachladen
			{
			iLbAddY =1,
			iLbAddX =1;
			iLbAddY1=1,
			iLbAddX1=1;


			iNum = (iMin+1)%3;
			iMin = (iMin+2)%3;

			iLbPosY	 = pPoints[iMin*2+1];
			iLbSizeY = pPoints[iNum*2+1]-iLbPosY;

			if(iLbSizeY<0)
				{
				iLbAddY  = -1;
				iLbSizeY = -iLbSizeY;
				}


			iLbPosX	 = pPoints[iMin*2];
			iLbSizeX = pPoints[iNum*2]-iLbPosX;

			if(iLbSizeX<0)
				{
				iLbAddX  = -1;
				iLbSizeX = -iLbSizeX;
				}

			iLbAddY1 = iLbAddY;
			iLbAddX1 = iLbAddX;

			if(iLbSizeY>iLbSizeX)
				{
				iLbAddX1 = 0;
				}
			else{
				i        = iLbSizeY;
				iLbSizeY = iLbSizeX;
				iLbSizeX = i;
				iLbAddY1 = 0;
				}


			iLbNumY = (iLbSizeY-iLbSizeX+1)>>1;
			iLbNumX = (iLbSizeY-iLbSizeX);
			iLbSizeY++;

			iFlag = 1;

			while(iLbSizeY>0)								// Linie B abschreiten
				{
				iLbSizeY--;

				if(iMinX>iLbPosX)iMinX=iLbPosX;
				if(iMaxX<iLbPosX)iMaxX=iLbPosX;

				if(iLbNumY>0)
					{
					iLbNumY -= iLbSizeX;
					iLbPosX += iLbAddX1;
					iLbPosY += iLbAddY1;

					if(iLbAddY1)break;
					}
				else{
					iLbNumY += iLbNumX;
					iLbPosX += iLbAddX;
					iLbPosY += iLbAddY;

					if(iLbAddY)break;
					}
				}
			}


		//************ Zeile zeichnen *****************************************


		if(iMinY>=0 && iMaxX>=0 && iMinX<(int)uImageWidth)
			{
			if(iMinY>=(int)uImageHeight)break;
			if(iMinX<                 0)iMinX=0;
			if(iMaxX>=(int)uImageWidth )iMaxX=uImageWidth-1;

			pMem = ROW_PTR(iMinY);

			while(iMinX<=iMaxX)
				{
				pSet(this,pMem,iMinX,iMinY,iPixel);
				iMinX++;
				}
			}


		if(iFlag && iLaSizeY<=0 && iLbSizeY<=0)				// Ende erreicht ?
			{
			break;
			}

		iMinY++;
		}


return 1;
}

//*****************************************************************************
//*
//*		Circle
//*
//*****************************************************************************
//	Zeichnet einen nicht gefllten Kreis oder ein Kreissegment
//	iPosX/Y			: Ist der Mittelpunkt des Kreises.
//	iSizeX/Y		: Ist der Radius des Kreises in Pixel.
//					  Ein negativer Wert spiegelt den Kreis um die X/Y-Achsen.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr den Kreis.
//	iAngelFrom		: Startwinkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iAngelFrom		: Endwinkel   (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iRoll			: Ist der Winkel um den der Kreis gedreht wird.
//	Ergibt 1 wenn erfolgreich.
bool BitmapImage::Circle(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,int iAngelFrom,int iAngelTo,int iRoll)
{
int			iAngel;
int			iDiff;
int			iSize;
int			iFlag;
int			iStep;
int			iCosR;
int			iSinR;
int			iOldX;
int			iOldY;
int			iNewX;
int			iNewY;
int			iValX;
int			iValY;
int			iVal;
int			iPos;
int			iAdd;


	iValX = (iSizeX<0)? -iSizeX:iSizeX;
	iValY = (iSizeY<0)? -iSizeY:iSizeY;

	iSize = (iValX>iValY)? iValX:iValY;
	iFlag = (iAngelFrom!=iAngelTo)? 1:0;


	if(iPosX+iSize<-1)return 0;
	if(iPosY+iSize<-1)return 0;
	if(iPosX-iSize>(int)uImageWidth )return 0;
	if(iPosY-iSize>(int)uImageHeight)return 0;


	iDiff = iAngelTo-iAngelFrom;

	if(iDiff>=0)											// In welche Richtung soll gezeichnet werden
			{ iDiff= iDiff&0x1FFFF;iAdd=128;iStep= 128; }
	else	{ iDiff=-iDiff&0x1FFFF;iAdd=128;iStep=-128; }



	if(!iDiff && iFlag)iDiff=0x20000;



	iAngelFrom &= 0x1FFFF;									// Die Winkel runden
	iAngelTo   &= 0x1FFFF;
	iRoll	   &= 0x1FFFF;
	iVal  		= 53121/4;

	if(iSize<=0)iSize=1;

	while(iVal>=iSize)										// Winkelschritte berechnen
		{
		iStep  *= 2;
		iAdd   *= 2;
		iVal   /= 4;
		}


	if(iAdd>0x4000)											// Maximal 45
		{
		iStep = (iStep<0)? -0x4000:0x4000;
		iAdd  = 0x4000;
		}



	if(iRoll && iValX!=iValY)								// Ist es eine gedrehte Ellipse
		{
		iCosR		= CosInt(iRoll)/0x10;
		iSinR		= SinInt(iRoll)/0x10;

		iValX		= (CosInt(iAngelFrom)*iSizeX)/0x1000;
		iValY		= (SinInt(iAngelFrom)*iSizeY)/0x1000;

		iOldX		= (iValX*iCosR-iValY*iSinR)/0x10000+iPosX;
		iOldY		= (iValY*iCosR+iValX*iSinR)/0x10000+iPosY;
		iAngel		= iAngelFrom+iStep;

		for(iPos=0;iPos<iDiff;iPos+=iAdd,iAngel+=iStep)
			{
			iValX	= (CosInt(iAngel)*iSizeX)/0x1000;
			iValY	= (SinInt(iAngel)*iSizeY)/0x1000;

			iNewX	= (iValX*iCosR-iValY*iSinR)/0x10000+iPosX;
			iNewY	= (iValY*iCosR+iValX*iSinR)/0x10000+iPosY;

			if(iNewX==iOldX && iNewY==iOldY)continue;

			Line(iOldX,iOldY,iNewX,iNewY,iPixel);

			iOldX	= iNewX;
			iOldY	= iNewY;
			}

		iValX		= (CosInt(iAngelTo)*iSizeX)/0x1000;
		iValY		= (SinInt(iAngelTo)*iSizeY)/0x1000;

		iNewX		= (iValX*iCosR-iValY*iSinR)/0x10000+iPosX;
		iNewY		= (iValY*iCosR+iValX*iSinR)/0x10000+iPosY;

		Line(iOldX,iOldY,iNewX,iNewY,iPixel);
		}
	else{
		iOldX		= (CosInt(iAngelFrom)*iSizeX)/0x10000+iPosX;
		iOldY		= (SinInt(iAngelFrom)*iSizeY)/0x10000+iPosY;
		iAngel		= iAngelFrom+iStep;

		for(iPos=0;iPos<iDiff;iPos+=iAdd,iAngel+=iStep)
			{
			iNewX	= (CosInt(iAngel)*iSizeX)/0x10000+iPosX;
			iNewY	= (SinInt(iAngel)*iSizeY)/0x10000+iPosY;

			if(iNewX==iOldX && iNewY==iOldY)continue;

			Line(iOldX,iOldY,iNewX,iNewY,iPixel);

			iOldX	= iNewX;
			iOldY	= iNewY;
			}

		iNewX		= (CosInt(iAngelTo)*iSizeX)/0x10000+iPosX;
		iNewY		= (SinInt(iAngelTo)*iSizeY)/0x10000+iPosY;

		Line(iOldX,iOldY,iNewX,iNewY,iPixel);
		}



return 1;
}


//*****************************************************************************
//*
//*		Circle
//*
//*****************************************************************************
//	Zeichnet einen nicht gefllten Kreis oder ein Kreissegment
//	iPosX/Y			: Ist der Mittelpunkt des Kreises.
//	iSizeX/Y		: Ist der Radius des Kreises in Pixel.
//					  Ein negativer Wert spiegelt den Kreis um die X/Y-Achsen.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr den Kreis.
//	pProc			: Ist die Zeichenfunktion
//						TEXT_SMOTH	: Mit Weichzeichner
//						TEXT_NORMAL	: Direkt setzen
//	iAngelFrom		: Startwinkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iAngelFrom		: Endwinkel   (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iRoll			: Ist der Winkel um den der Kreis gedreht wird.
//	iFull			: Auch den letzten Punkt zeichnen. Dieser Wert sollte
//					  Null sein wenn man verkettet Linien zeichnet.
//	Ergibt 1 wenn erfolgreich.
bool BitmapImage::Circle(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFunction pProc,int iAngelFrom,int iAngelTo,int iRoll,int iFull)
{
int			iAngel;
int			iDiff;
int			iSize;
int			iFlag;
int			iStep;
int			iCosR;
int			iSinR;
int			iOldX;
int			iOldY;
int			iNewX;
int			iNewY;
int			iValX;
int			iValY;
int			iVal;
int			iPos;
int			iAdd;


	iValX = (iSizeX<0)? -iSizeX:iSizeX;
	iValY = (iSizeY<0)? -iSizeY:iSizeY;

	iSize = (iValX>iValY)? iValX:iValY;
	iFlag = (iAngelFrom!=iAngelTo)? 1:0;


	if(iPosX+iSize<-1)return 0;
	if(iPosY+iSize<-1)return 0;
	if(iPosX-iSize>(int)uImageWidth )return 0;
	if(iPosY-iSize>(int)uImageHeight)return 0;


	iDiff = iAngelTo-iAngelFrom;

	if(iDiff>=0)											// In welche Richtung soll gezeichnet werden
			{ iDiff= iDiff&0x1FFFF;iAdd=128;iStep= 128; }
	else	{ iDiff=-iDiff&0x1FFFF;iAdd=128;iStep=-128; }



	if(!iDiff && iFlag)iDiff=0x20000;



	iAngelFrom &= 0x1FFFF;									// Die Winkel runden
	iAngelTo   &= 0x1FFFF;
	iRoll	   &= 0x1FFFF;
	iVal  		= 53121/4;

	if(iSize<=0)iSize=1;

	while(iVal>=iSize)										// Winkelschritte berechnen
		{
		iStep  *= 2;
		iAdd   *= 2;
		iVal   /= 4;
		}


	if(iAdd>0x4000)											// Maximal 45
		{
		iStep = (iStep<0)? -0x4000:0x4000;
		iAdd  = 0x4000;
		}


	if(uImageBits<=8)
	if(pProc==SetTextPixelSmoth)
		{
		pProc=SetTextPixelNormal;
		}

	if(uImageBits==32)
	if(pProc==SetTextPixelSmoth)
		{
		pProc=SetTextPixelSmoth32;
		}


	if(iRoll && iValX!=iValY)								// Ist es eine gedrehte Ellipse
		{
		iCosR		= CosInt(iRoll)/0x10;
		iSinR		= SinInt(iRoll)/0x10;

		iValX		= (CosInt(iAngelFrom)*iSizeX)/0x1000;
		iValY		= (SinInt(iAngelFrom)*iSizeY)/0x1000;

		iOldX		= (iValX*iCosR-iValY*iSinR)/0x10000+iPosX;
		iOldY		= (iValY*iCosR+iValX*iSinR)/0x10000+iPosY;
		iAngel		= iAngelFrom+iStep;

		for(iPos=0;iPos<iDiff;iPos+=iAdd,iAngel+=iStep)
			{
			iValX	= (CosInt(iAngel)*iSizeX)/0x1000;
			iValY	= (SinInt(iAngel)*iSizeY)/0x1000;

			iNewX	= (iValX*iCosR-iValY*iSinR)/0x10000+iPosX;
			iNewY	= (iValY*iCosR+iValX*iSinR)/0x10000+iPosY;

			if(iNewX==iOldX && iNewY==iOldY)continue;

			Line(iOldX,iOldY,iNewX,iNewY,iPixel,pProc,0);

			iOldX	= iNewX;
			iOldY	= iNewY;
			}

		iValX		= (CosInt(iAngelTo)*iSizeX)/0x1000;
		iValY		= (SinInt(iAngelTo)*iSizeY)/0x1000;

		iNewX		= (iValX*iCosR-iValY*iSinR)/0x10000+iPosX;
		iNewY		= (iValY*iCosR+iValX*iSinR)/0x10000+iPosY;

		Line(iOldX,iOldY,iNewX,iNewY,iPixel,pProc,iFull);
		}
	else{
		iOldX		= (CosInt(iAngelFrom)*iSizeX)/0x10000+iPosX;
		iOldY		= (SinInt(iAngelFrom)*iSizeY)/0x10000+iPosY;
		iAngel		= iAngelFrom+iStep;

		for(iPos=0;iPos<iDiff;iPos+=iAdd,iAngel+=iStep)
			{
			iNewX	= (CosInt(iAngel)*iSizeX)/0x10000+iPosX;
			iNewY	= (SinInt(iAngel)*iSizeY)/0x10000+iPosY;

			if(iNewX==iOldX && iNewY==iOldY)continue;

			Line(iOldX,iOldY,iNewX,iNewY,iPixel,pProc,0);

			iOldX	= iNewX;
			iOldY	= iNewY;
			}

		iNewX		= (CosInt(iAngelTo)*iSizeX)/0x10000+iPosX;
		iNewY		= (SinInt(iAngelTo)*iSizeY)/0x10000+iPosY;

		Line(iOldX,iOldY,iNewX,iNewY,iPixel,pProc,iFull);
		}



return 1;
}


//*****************************************************************************
//*
//*		CircleSmoth
//*
//*****************************************************************************
//	Zeichnet einen nicht gefllten Kreis oder ein Kreissegment
//	iPosX/Y			: Ist der Mittelpunkt des Kreises
//	iSizeX/Y		: Ist der Radius des Kreises in Pixel
//					  Ein negativer Wert spiegelt den Kreis um die X/Y-Achsen.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr den Kreis.
//	iAngelFrom		: Startwinkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iAngelTo		: Endwinkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iRoll			: Ist der Winkel um den der Kreis gedreht wird.
//	Ergibt 1 wenn erfolgreich.
bool BitmapImage::CircleSmoth(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,int iAngelFrom,int iAngelTo,int iRoll)
{
ColorMapEntry	sColPx;
ColorMapEntry	sColBg;
unsigned		uFact1;
unsigned		uFact2;
int				iAngel;
int				iSize;
int				iFlag;
int				iStep;
int				iCosR;
int				iSinR;
int				iOldX;
int				iOldY;
int				iNewX;
int				iNewY;
int				iValX;
int				iValY;
int				iDifX;
int				iDifY;
int				iAddX;
int				iAddY;
int				iVal;
int				iEnd;


	if(uImageBits<=8)
		{
		return Circle(iPosX,iPosY,iSizeX,iSizeY,iPixel,iAngelFrom,iAngelTo,iRoll);
		}

	iValX = (iSizeX<0)? -iSizeX:iSizeX;
	iValY = (iSizeY<0)? -iSizeY:iSizeY;

	iSize = (iValX>iValY)? iValX:iValY;
	iFlag = (iAngelFrom!=iAngelTo)? 1:0;


	if(iPosX+iSize<-1)return 0;
	if(iPosY+iSize<-1)return 0;
	if(iPosX-iSize>(int)uImageWidth )return 0;
	if(iPosY-iSize>(int)uImageHeight)return 0;

	if(iAngelFrom>iAngelTo)									// In die andere Richtung zeichnen
		{
		iAngel		= iAngelFrom;
		iAngelFrom	= iAngelTo;
		iAngelTo	= iAngel;
		}


	iAngelFrom &= 0x1FFFF;									// Die Winkel runden
	iAngelTo   &= 0x1FFFF;
	iRoll	   &= 0x1FFFF;


	if(iFlag && iAngelTo<=iAngelFrom)
		{
		iAngelTo += 0x20000;
		}


	iStep 		= 128;
	iVal  		= 53121/4;

	while(iVal>iSize)										// Winkelschritte berechnen
		{
		iStep  *= 2;
		iVal   /= 4;
		}

	if(iStep>0x4000)iStep=0x4000;							// Maximal 45



	iPosX	   *= 0x10000;
	iPosY	   *= 0x10000;

	iCosR		= CosInt(iRoll)/0x10;						// Drehparameter berechnen
	iSinR		= SinInt(iRoll)/0x10;

	iValX		= (CosInt(iAngelFrom)*iSizeX)/0x1000;
	iValY		= (SinInt(iAngelFrom)*iSizeY)/0x1000;

	iOldX		= (iValX*iCosR-iValY*iSinR)+iPosX;
	iOldY		= (iValY*iCosR+iValX*iSinR)+iPosY;



	iAngel		= iAngelFrom+iStep;
	sColPx.uRgb	= iPixel;

	for(iEnd=0;!iEnd;iAngel+=iStep)
		{
		if(iAngel>=iAngelTo)
			{
			iEnd   = 1;
			iAngel = iAngelTo;
			}

		iValX	= (CosInt(iAngel)*iSizeX)/0x1000;
		iValY	= (SinInt(iAngel)*iSizeY)/0x1000;

		iNewX	= (iValX*iCosR-iValY*iSinR)+iPosX;
		iNewY	= (iValY*iCosR+iValX*iSinR)+iPosY;

		iDifX	= iNewX/0x10000-iOldX/0x10000;
		iDifY	= iNewY/0x10000-iOldY/0x10000;

		if(!iDifX && !iDifY)continue;

		iAddX	= (iDifX<0)? -1:1;
		iAddY	= (iDifY<0)? -1:1;

		if(ValueFrom(iDifX)>ValueFrom(iDifY))
			{
			iValY	= iOldY-0x8000;
			iValX	= iOldX/0x10000;
			iDifY   =(iNewY-iOldY)/ValueFrom(iDifX);

			if(iEnd && iFlag && ((iAngelTo^iAngelFrom)&0x1FFFF))
				{
				iDifX += iAddX;
				}

			while(iDifX!=0)
				{
				uFact2			=  (iValY>>8)&0xFF;
				uFact1			=  256-uFact2;

				sColBg.uRgb		=  GetPixel(iValX,iValY/0x10000);
				sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
				sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
				sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

				SetPixel(iValX,iValY/0x10000,sColBg.uRgb);

				sColBg.uRgb		=  GetPixel(iValX,iValY/0x10000+1);
				sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact2)+(sColBg.ucRed  *uFact1))/256);
				sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact2)+(sColBg.ucBlue *uFact1))/256);
				sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact2)+(sColBg.ucGreen*uFact1))/256);

				SetPixel(iValX,iValY/0x10000+1,sColBg.uRgb);

				iValY += iDifY;
				iValX += iAddX;
				iDifX -= iAddX;
				}
			}
		else{
			iValX	= iOldX-0x8000;
			iValY	= iOldY/0x10000;
			iDifX	=(iNewX-iOldX)/ValueFrom(iDifY);

			if(iEnd && iFlag && ((iAngelTo^iAngelFrom)&0x1FFFF))
				{
				iDifY += iAddY;
				}

			while(iDifY!=0)
				{
				uFact2			=  (iValX>>8)&0xFF;
				uFact1			=  256-uFact2;

				sColBg.uRgb		=  GetPixel(iValX/0x10000,iValY);
				sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
				sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
				sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

				SetPixel(iValX/0x10000,iValY,sColBg.uRgb);

				sColBg.uRgb		=  GetPixel(iValX/0x10000+1,iValY);
				sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact2)+(sColBg.ucRed  *uFact1))/256);
				sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact2)+(sColBg.ucBlue *uFact1))/256);
				sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact2)+(sColBg.ucGreen*uFact1))/256);

				SetPixel(iValX/0x10000+1,iValY,sColBg.uRgb);

				iValX += iDifX;
				iValY += iAddY;
				iDifY -= iAddY;
				}
			}

		iOldX	= iNewX;
		iOldY	= iNewY;
		}



return 1;
}


//*****************************************************************************
//*
//*		Ellipsis
//*
//*****************************************************************************
//	Zeichnet einen gefllten Kreis oder eine Ellipse.
//	iPosX/Y			: Ist der Mittelpunkt/Eckpunkt des Kreises.
//	iSizeX/Y		: Ist der Radius/Durchmesser des Kreises in Pixel. Bei
//					  negativen Werten wird der Kreis um den Eckpunkt gespiegelt.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr den Kreis.
//					  Ein negativer Wert spiegelt den Kreis um die X/Y-Achsen.
//	iMode			: Bestimmt wie der Kreis gezeichnet werden soll
//						Bit0    = 0=Radius 1=Durchmesser
//						Bit2..3 = X-Koordinate 0=Mittelpunk 1=links 2=rechts
//						Bit4..5 = Y-Koordinate 0=Mittelpunk 1=oben  2=unten
//	Ergibt 1 wenn erfolgreich, bzw. 0 bei einem Fehler
bool BitmapImage::Ellipsis(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,int iMode)
{
unsigned 		uFact1;
unsigned 		uFact2;
unsigned		uSize;
unsigned		uNumX;
unsigned		uNumY;
unsigned		uSubY;
int				iValY;
int				iPosZ;
int				iAdd;
int				iNum;



	if(iMode&1)												// Durchmesser angegeben
		{
		uNumX   = ValueFrom(iSizeX);
		uNumY   = ValueFrom(iSizeY);

		if(uNumX==0)return 0;
		if(uNumY==0)return 0;

		iSizeX /= 2;
		iSizeY /= 2;
		}
	else{													// Radius angegeben
		uNumX   = ValueFrom(iSizeX)*2+1;
		uNumY   = ValueFrom(iSizeY)*2+1;
		}


	if(uImageBits<=8)iMode&=~2;


	switch((iMode>>2)&3)									// X-Koordinate	anpassen
		{
	case 0:	iPosX -= uNumX/2;							break;
	case 1:	if(iSizeX<0)iPosX-=uNumX-1;					break;
	case 2:	if(iSizeX>0)iPosX-=uNumX-1;					break;
	default:return 0;
		}

	switch((iMode>>4)&3)									// Y-Koordinate	anpassen
		{
	case 0:														break;
	case 1:	iPosY += (iSizeY>0)? (uNumY  )/2:-(int)(uNumY-1)/2;	break;
	case 2:	iPosY -= (iSizeY>0)? (uNumY-1)/2:-(int)(uNumY  )/2;	break;
	default:return 0;
		}


	if(iSizeX<0)iSizeX=-iSizeX;
	if(iSizeY<0)iSizeY=-iSizeY;


	if(uNumY&1)												// Gibt es eine ungerade Y-Mittellinie
		{
		Box(iPosX,iPosY,uNumX,1,iPixel);
		iPosZ	= iPosY;
		uSubY	= 0x0000;
		}
	else{
		iPosZ	= iPosY-1;
		uSubY	= 0x8000;
		}


	for(iValY=1;iValY<=iSizeY;iValY++)						// Reihen zeichnen
		{
		iNum	= (iValY*0x10000-uSubY)/uNumY;
		uFact1	= SIZE_ARRAY[iNum/0x100  ];
		uFact2	= SIZE_ARRAY[iNum/0x100+1];

		uSize	= uFact1*(256-(iNum&0xFF));
		uSize  += uFact2*(    (iNum&0xFF));
		uSize  /= 0x100;
		uSize  *= uNumX;
		uSize  += 0x3FFF;
		uSize  /= 0x8000;
		iAdd	= (uNumX-uSize)/2;

		Box(iPosX+iAdd,iPosY-iValY,uSize,1,iPixel);
		Box(iPosX+iAdd,iPosZ+iValY,uSize,1,iPixel);
		}


return 1;
}

//*****************************************************************************
//*
//*		Ellipsis
//*
//*****************************************************************************
//	Zeichnet einen gefllten Kreis oder eine Ellipse.
//	iPosX/Y			: Ist der Mittelpunkt/Eckpunkt des Kreises.
//	iSizeX/Y		: Ist der Radius/Durchmesser des Kreises in Pixel. Bei
//					  negativen Werten wird der Kreis um den Eckpunkt gespiegelt.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr den Kreis.
//					  Ein negativer Wert spiegelt den Kreis um die X/Y-Achsen.
//	pProc			: Callback zum Pixel zeichnen.
//	iMode			: Bestimmt wie der Kreis gezeichnet werden soll
//						Bit0    = 0=Radius 1=Durchmesser
//						Bit2..3 = X-Koordinate 0=Mittelpunk 1=links 2=rechts
//						Bit4..5 = Y-Koordinate 0=Mittelpunk 1=oben  2=unten
//	Ergibt 1 wenn erfolgreich, bzw. 0 bei einem Fehler
bool BitmapImage::Ellipsis(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,PixelFillSet pProc,int iMode)
{
unsigned 		uFact1;
unsigned 		uFact2;
unsigned		uSize;
unsigned		uNumX;
unsigned		uNumY;
unsigned		uSubY;
int				iValY;
int				iPosZ;
int				iAdd;
int				iNum;



	if(iMode&1)												// Durchmesser angegeben
		{
		uNumX   = ValueFrom(iSizeX);
		uNumY   = ValueFrom(iSizeY);

		if(uNumX==0)return 0;
		if(uNumY==0)return 0;

		iSizeX /= 2;
		iSizeY /= 2;
		}
	else{													// Radius angegeben
		uNumX   = ValueFrom(iSizeX)*2+1;
		uNumY   = ValueFrom(iSizeY)*2+1;
		}


	if(uImageBits<=8)iMode&=~2;


	switch((iMode>>2)&3)									// X-Koordinate	anpassen
		{
	case 0:	iPosX -= uNumX/2;							break;
	case 1:	if(iSizeX<0)iPosX-=uNumX-1;					break;
	case 2:	if(iSizeX>0)iPosX-=uNumX-1;					break;
	default:return 0;
		}

	switch((iMode>>4)&3)									// Y-Koordinate	anpassen
		{
	case 0:														break;
	case 1:	iPosY += (iSizeY>0)? (uNumY  )/2:-(int)(uNumY-1)/2;	break;
	case 2:	iPosY -= (iSizeY>0)? (uNumY-1)/2:-(int)(uNumY  )/2;	break;
	default:return 0;
		}


	if(iSizeX<0)iSizeX=-iSizeX;
	if(iSizeY<0)iSizeY=-iSizeY;


	if(uNumY&1)												// Gibt es eine ungerade Y-Mittellinie
		{
		Box(iPosX,iPosY,uNumX,1,iPixel,pProc);
		iPosZ	= iPosY;
		uSubY	= 0x0000;
		}
	else{
		iPosZ	= iPosY-1;
		uSubY	= 0x8000;
		}


	for(iValY=1;iValY<=iSizeY;iValY++)						// Reihen zeichnen
		{
		iNum	= (iValY*0x10000-uSubY)/uNumY;
		uFact1	= SIZE_ARRAY[iNum/0x100  ];
		uFact2	= SIZE_ARRAY[iNum/0x100+1];

		uSize	= uFact1*(256-(iNum&0xFF));
		uSize  += uFact2*(    (iNum&0xFF));
		uSize  /= 0x100;
		uSize  *= uNumX;
		uSize  += 0x3FFF;
		uSize  /= 0x8000;
		iAdd	= (uNumX-uSize)/2;

		Box(iPosX+iAdd,iPosY-iValY,uSize,1,iPixel,pProc);
		Box(iPosX+iAdd,iPosZ+iValY,uSize,1,iPixel,pProc);
		}


return 1;
}

//*****************************************************************************
//*
//*		EllipsisSmoth
//*
//*****************************************************************************
//	Zeichnet einen gefllten Kreis oder eine Ellipse mit Kantenglttung.
//	iPosX/Y			: Ist der Mittelpunkt/Eckpunkt des Kreises.
//	iSizeX/Y		: Ist der Radius/Durchmesser des Kreises in Pixel. Bei
//					  negativen Werten wird der Kreis um den Eckpunkt gespiegelt.
//	iPixel			: Ist die Farbe bzw. der Farbindex fr den Kreis.
//					  Ein negativer Wert spiegelt den Kreis um die X/Y-Achsen.
//	iMode			: Bestimmt wie der Kreis gezeichnet werden soll
//						Bit0    = 0=Radius 1=Durchmesser
//						Bit2..3 = X-Koordinate 0=Mittelpunk 1=links 2=rechts
//						Bit4..5 = Y-Koordinate 0=Mittelpunk 1=oben  2=unten
//	Ergibt 1 wenn erfolgreich, bzw. 0 bei einem Fehler
bool BitmapImage::EllipsisSmoth(int iPosX,int iPosY,int iSizeX,int iSizeY,int iPixel,int iMode)
{
ColorMapEntry	sColPx;
ColorMapEntry	sColBg;
unsigned 		uFactU;
unsigned 		uFactL;
unsigned 		uFact1;
unsigned 		uFact2;
unsigned 		uFact;
unsigned		uSize;
unsigned		uNext;
unsigned		uNumX;
unsigned		uNumY;
unsigned		uSubY;
unsigned		uAddF;
int				iValY;
int				iPosZ;
int				iSize;
int				iAddL;
int				iAdd;
int				iNum;



	if(iMode&1)												// Durchmesser angegeben
		{
		uNumX   = ValueFrom(iSizeX);
		uNumY   = ValueFrom(iSizeY);

		if(uNumX==0)return 0;
		if(uNumY==0)return 0;

		iSizeX /= 2;
		iSizeY /= 2;
		}
	else{													// Radius angegeben
		uNumX   = iSizeX*2+1;
		uNumY   = iSizeY*2+1;
		}


	if(uImageBits<=8)iMode&=~2;


	switch((iMode>>2)&3)									// X-Koordinate	anpassen
		{
	case 0:	iPosX -= uNumX/2;							break;
	case 1:	if(iSizeX<0)iPosX-=uNumX-1;					break;
	case 2:	if(iSizeX>0)iPosX-=uNumX-1;					break;
	default:return 0;
		}

	switch((iMode>>4)&3)									// Y-Koordinate	anpassen
		{
	case 0:														break;
	case 1:	iPosY += (iSizeY>0)? (uNumY  )/2:-(int)(uNumY-1)/2;	break;
	case 2:	iPosY -= (iSizeY>0)? (uNumY-1)/2:-(int)(uNumY  )/2;	break;
	default:return 0;
		}


	if(iSizeX<0)iSizeX=-iSizeX;
	if(iSizeY<0)iSizeY=-iSizeY;


	if(uNumY&1)												// Gibt es eine ungerade Y-Mittellinie
		{
		Box(iPosX,iPosY,uNumX,1,iPixel);
		iPosZ	= iPosY;
		uSubY	= 0x0000;
		}
	else{
		iPosZ	= iPosY-1;
		uSubY	= 0x8000;
		}


	iNum	= (1*0x10000-uSubY)/uNumY;
	uFact1	= SIZE_ARRAY[iNum/0x100  ];
	uFact2	= SIZE_ARRAY[iNum/0x100+1];

	uNext	= uFact1*(256-(iNum&0xFF));
	uNext  += uFact2*(    (iNum&0xFF));
	uNext  /= 0x100;
	uNext  *= uNumX;
	uNext  /= 0x80;

	sColPx.uRgb	= iPixel;

	for(iValY=1;iValY<=iSizeY;iValY++)						// Innere Reihen zeichnen
		{
		uSize = uNext;

		if(iValY==iSizeY)
			{
			uNext  /= 3;
			}
		else{
			iNum	= (iValY*0x10000-uSubY)/uNumY;
			uFact1	= SIZE_ARRAY[iNum/0x100  ];
			uFact2	= SIZE_ARRAY[iNum/0x100+1];

			uNext	= uFact1*(256-(iNum&0xFF));
			uNext  += uFact2*(    (iNum&0xFF));
			uNext  /= 0x100;
			uNext  *= uNumX;
			uNext  /= 0x80;
			}

		if(uNumX&1)
			{
			if(uSize&0x100)
				{
				uFact1 = (uSize&0xFF)/2;
				iSize  =  uSize/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			else{
				iSize  = uSize-0x100;
				uFact1 = (iSize&0x1FF)/2;
				iSize  = (int)(iSize)/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			}
		else{
			if(uSize&0x100)
				{
				uFact1 = (uSize&0x1FF)/2;
				iSize  = (int)(uSize-0x100)/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			else{
				uFact1 = (uSize&0xFF)/2;
				iSize  =  uSize/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			}

		if(uNext+0x200<uSize)break;							// Nur ein Pixel breiter

		Box(iPosX+iAdd,iPosY-iValY,iSize,1,iPixel);
		Box(iPosX+iAdd,iPosZ+iValY,iSize,1,iPixel);

		uFact2			=  256-uFact1;
		sColBg.uRgb		=  GetPixel(iPosX+iAdd-1,iPosY-iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iAdd-1,iPosY-iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iAdd+iSize,iPosY-iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iAdd+iSize,iPosY-iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iAdd-1,iPosZ+iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iAdd-1,iPosZ+iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iAdd+iSize,iPosZ+iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iAdd+iSize,iPosZ+iValY,sColBg.uRgb);
		}

	iValY  -= 1;
	uSubY  += 0x8000;
	iNum	= (iValY*0x10000-uSubY)/uNumY;
	uFact1	= SIZE_ARRAY[iNum/0x100  ];
	uFact2	= SIZE_ARRAY[iNum/0x100+1];

	uNext	= uFact1*(256-(iNum&0xFF));
	uNext  += uFact2*(    (iNum&0xFF));
	uNext  /= 0x100;
	uNext  *= uNumX;
	uNext  /= 0x80;

	if(uNumX&1)
		{
		if(uNext&0x100)
			{
			uFactU = (uNext&0xFF)/2;
			iSize  =  uNext/0x100;
			iAdd   = (uNumX-iSize)/2;
			}
		else{
			iSize  = uNext-0x100;
			uFactU = (iSize&0x1FF)/2;
			iSize  = (int)(iSize)/0x100;
			iAdd   = (uNumX-iSize)/2;
			}
		}
	else{
		if(uNext&0x100)
			{
			uFactU = (uNext&0x1FF)/2;
			iSize  = (int)(uNext-0x100)/0x100;
			iAdd   = (uNumX-iSize)/2;
			}
		else{
			uFactU = (uNext&0xFF)/2;
			iSize  =  uNext/0x100;
			iAdd   = (uNumX-iSize)/2;
			}
		}

	for(iValY++;iValY<=iSizeY;iValY++)						// uere Reihen zeichnen
		{
		iAddL	= iAdd;
		uSize	= uNext;
		uFactL	= uFactU;

		if(iValY==iSizeY)
			{
			uNext  /= 4;
			}
		else{
			iNum	= (iValY*0x10000-uSubY)/uNumY;
			uFact1	= SIZE_ARRAY[iNum/0x100  ];
			uFact2	= SIZE_ARRAY[iNum/0x100+1];

			uNext	= uFact1*(256-(iNum&0xFF));
			uNext  += uFact2*(    (iNum&0xFF));
			uNext  /= 0x100;
			uNext  *= uNumX;
			uNext  /= 0x80;
			}

		if(uNumX&1)
			{
			if(uNext&0x100)
				{
				uFactU = (uNext&0xFF)/2;
				iSize  =  uNext/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			else{
				iSize  = uNext-0x100;
				uFactU = (iSize&0x1FF)/2;
				iSize  = (int)(iSize)/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			}
		else{
			if(uNext&0x100)
				{
				uFactU = (uNext&0x1FF)/2;
				iSize  = (int)(uNext-0x100)/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			else{
				uFactU = (uNext&0xFF)/2;
				iSize  =  uNext/0x100;
				iAdd   = (uNumX-iSize)/2;
				}
			}

		Box(iPosX+iAdd,iPosY-iValY,iSize,1,iPixel);
		Box(iPosX+iAdd,iPosZ+iValY,iSize,1,iPixel);


		uFact2			=  (0x100-uFactU)/(iAdd-iAddL+1);
 		uFact1			=  256-uFact2;
		iNum			=  iAdd-1;

		sColBg.uRgb		=  GetPixel(iPosX+iNum,iPosY-iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iNum,iPosY-iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iAdd+iSize,iPosY-iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iAdd+iSize,iPosY-iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iNum,iPosZ+iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iNum,iPosZ+iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iAdd+iSize,iPosZ+iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iAdd+iSize,iPosZ+iValY,sColBg.uRgb);

		uAddF			=  0x80000000/(uSize-uNext-0x100);
		uFact			=  (uAddF*(256+128-uFactU))/0x100;
		iSize		   +=  1;
		iNum		   -=  1;

		while(iNum>=iAddL)
			{
			iSize		   += 2;
			uFact2			=  uFact/0x4000;
 			uFact1			=  256-uFact2;

			sColBg.uRgb		=  GetPixel(iPosX+iNum,iPosY-iValY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

			SetPixel(iPosX+iNum,iPosY-iValY,sColBg.uRgb);

			sColBg.uRgb		=  GetPixel(iPosX+iNum+iSize,iPosY-iValY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

			SetPixel(iPosX+iNum+iSize,iPosY-iValY,sColBg.uRgb);

			sColBg.uRgb		=  GetPixel(iPosX+iNum,iPosZ+iValY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

			SetPixel(iPosX+iNum,iPosZ+iValY,sColBg.uRgb);

			sColBg.uRgb		=  GetPixel(iPosX+iNum+iSize,iPosZ+iValY);
			sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
			sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
			sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

			SetPixel(iPosX+iNum+iSize,iPosZ+iValY,sColBg.uRgb);

			uFact		   += uAddF;
			iNum		   -= 1;
			}

		uFact1			=  uFactL/(iAdd-iAddL)/2;
 		uFact2			=  256-uFact1;
		iSize		   +=  2;

		sColBg.uRgb		=  GetPixel(iPosX+iNum,iPosY-iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iNum,iPosY-iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iNum+iSize,iPosY-iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iNum+iSize,iPosY-iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iNum,iPosZ+iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iNum,iPosZ+iValY,sColBg.uRgb);

		sColBg.uRgb		=  GetPixel(iPosX+iNum+iSize,iPosZ+iValY);
		sColBg.ucRed	=  (unsigned char)(((sColPx.ucRed  *uFact1)+(sColBg.ucRed  *uFact2))/256);
		sColBg.ucBlue	=  (unsigned char)(((sColPx.ucBlue *uFact1)+(sColBg.ucBlue *uFact2))/256);
		sColBg.ucGreen	=  (unsigned char)(((sColPx.ucGreen*uFact1)+(sColBg.ucGreen*uFact2))/256);

		SetPixel(iPosX+iNum+iSize,iPosZ+iValY,sColBg.uRgb);
		}



return 1;
}


//*****************************************************************************
//*
//*		GetPixelsPerMeter
//*
//*****************************************************************************
bool BitmapImage::GetPixelsPerMeter(int &iPerMeterX,int &iPerMeterY)
{

	if(!pBitmapInfo)
		{
		iPerMeterX = 0;
		iPerMeterY = 0;
		return false;
		}


	iPerMeterX = pBitmapInfo->bmiHeader.biXPelsPerMeter;
	iPerMeterY = pBitmapInfo->bmiHeader.biYPelsPerMeter;


return true;
}

//*****************************************************************************
//*
//*		SetPixelsPerMeter
//*
//*****************************************************************************
bool BitmapImage::SetPixelsPerMeter(int iPerMeterX,int iPerMeterY)
{

	if(!pBitmapInfo)
		{
		return false;
		}


	pBitmapInfo->bmiHeader.biXPelsPerMeter	= iPerMeterX;
	pBitmapInfo->bmiHeader.biYPelsPerMeter	= iPerMeterY;


return true;
}

//*****************************************************************************
//*
//*		Move
//*
//*****************************************************************************
//	Verschiebt einen Bildausschnitt an einen anderen Platz im Bild
//	iPosX/Y		: Ist eine Ecke des Bildausschnitts
//	iSizeX/Y	: Ist die Gre des Bildausschnitts (kann auch negativ sein)
//	iTargetX/Y	: Ist die neue Position des Bildausschnitts
//	Ergibt 1 wenn erfolgreich, bzw. 0 bei einem Fehler
bool BitmapImage::Move(int iPosX,int iPosY,int iSizeX,int iSizeY,int iTargetX,int iTargetY)
{
unsigned char  *pOff;
unsigned char  *pCpy;
int				iDif;
int				iOff;
int				iCpy;
int				iNum;


	if(iSizeX<=0)											// Prfe die Ausschnittsgre
		{
		if(iSizeX==0)return 0;

		iPosX  +=  iSizeX;
		iSizeX  = -iSizeX;
		}


	if(iSizeY<=0)
		{
		if(iSizeY==0)return 0;

		iPosY  +=  iSizeY;
		iSizeY  = -iSizeY;
		}


	if(iPosX==iTargetX && iPosY==iTargetY)					// Verschub zur gleichen Position
		{
		return 1;
		}



	if(iPosX<0)												// Prfe die Ausschnittsposition
		{
		   iSizeX+=iPosX;
		if(iSizeX<=0)return 0;
		iPosX   = 0;
		}


	if(iPosY<0)
		{
		   iSizeY+=iPosY;
		if(iSizeY<=0)return 0;
		iPosY   = 0;
		}


	if(iPosX+iSizeX>(int)uImageWidth)
		{
		if(iPosX>=(int)uImageWidth)return 0;
		iSizeX	= uImageWidth-iPosX;
		}


	if(iPosY+iSizeY>(int)uImageHeight)
		{
		if(iPosY>=(int)uImageHeight)return 0;
		iSizeY  = uImageHeight-iPosY;
		}


	if(iTargetX<0)											// Prfe die Zielposition
		{
		iPosX  -= iTargetX;
		iSizeX += iTargetX;

		if(iSizeX<=0)return 0;

		iTargetX = 0;
		}


	if(iTargetY<0)
		{
		iPosY  -= iTargetY;
		iSizeY += iTargetY;

		if(iSizeY<=0)return 0;

		iTargetY = 0;
		}


	   iDif	= iTargetX+iSizeX-uImageWidth;
	if(iDif>0)
		{
		if(iTargetX>=(int)uImageWidth)return 0;
		iSizeX -= iDif;

		if(iSizeX<=0)return 0;
		}


	   iDif	= iTargetY+iSizeY-uImageHeight;
	if(iDif>0)
		{
		if(iTargetY>=(int)uImageHeight)return 0;
		iSizeY -= iDif;

		if(iSizeY<=0)return 0;
		}




	iOff	= uImageBits*iPosX;
	iCpy	= uImageBits*iTargetX;
	iNum	= uImageBits*iSizeX;


	if((iOff&3) || (iCpy&3) ||  (iNum&3))					// Mssen einzelne Bits kopiert werden
		{
		BitmapImage		sImage;
		sImage.Get(*this,iPosX,iPosY,iSizeX,iSizeY);
		Put(sImage,iTargetX,iTargetY);
		}
	else{													// Kopieren mit memcpy
		pOff    = ROW_PTR(iPosY   )+iOff/8;
		pCpy    = ROW_PTR(iTargetY)+iCpy/8;
		iSizeY -= 1;
		iNum   /= 8;

		if(iTargetY>iPosY)
			{
			pOff  -= uRowWidth*iSizeY;
			pCpy  -= uRowWidth*iSizeY;

			while(iSizeY>=0)
				{
				memcpy(pCpy,pOff,iNum);
				pCpy   += uRowWidth;
				pOff   += uRowWidth;
				iSizeY -= 1;
				}
			}
		else if(iTargetY<iPosY || iPosX+iSizeX<=iTargetY || iTargetX+iSizeX<=iPosX)
			{
			while(iSizeY>=0)
				{
				memcpy(pCpy,pOff,iNum);
				pCpy   -= uRowWidth;
				pOff   -= uRowWidth;
				iSizeY -= 1;
				}
			}
		else{
			while(iSizeY>=0)
				{
				memmove(pCpy,pOff,iNum);
				pCpy   -= uRowWidth;
				pOff   -= uRowWidth;
				iSizeY -= 1;
				}
			}
		}




return 1;
}


//*****************************************************************************
//*
//*		Polygon
//*
//*****************************************************************************
//	Zeichnet ein Polygon
//	pPoints		: Zeiger auf die Punkte ([0]=X0 [1]=Y0 [2]=X1 ...)
//	iCount		: Ist die Anzahl der Punkte im Polygon
//	iPixel		: Ist die Farbe bzw. der Farbindex fr das Polygon.
//	Ergibt TRUE wenn ein Polygon gezeichnet wurde, bzw. FALSE wenn nicht.
bool BitmapImage::Polygon(int *pPoints,int iCount,int iPixel)
{
typedef	struct
	{
	char 	cMode;
	char 	cSwap;
	char 	cFlag;
	int		iLast;
	int		iNum;
	int		iOff;
	int		iDif;
	int		iMinY;
	int		iMaxY;
	int		iPosX;
	int		iEndX;
	}LineData;

#define 		MAX_POINTS	64

unsigned char  *pMem;
LineData		aLines[MAX_POINTS];
int				aDraw [MAX_POINTS];
char			cSwap;
char			cBase;
int				iStep;
int				iStop;
int				iDifX;
int				iDifY;
int				iMinY;
int				iMaxY;
int				iMinX;
int				iMaxX;
int				iFrom;
int				iLast;
int				iEnd;
int				iAdd;
int				iVal;
int				iNum;
int				iPos;



	if(iCount<3)											// Kein Polygon
		{
		if(iCount<=0)
			{
			return 0;
			}

		if(iCount==1)
			{
			if((unsigned)pPoints[0]>=uImageWidth )return 0;
			if((unsigned)pPoints[1]>=uImageHeight)return 0;
			SetPixel(pPoints[0],pPoints[1],iPixel);
			return 1;
			}

		return Line(pPoints[0],pPoints[1],pPoints[2],pPoints[3],iPixel);
		}
	else if(iCount>MAX_POINTS)
		{
		return 0;
		}



	if(pPoints[1]>pPoints[iCount*2-1])							// Erste Linie
		{
		aLines[0].iMinY	= pPoints[iCount*2-1];
		aLines[0].iMaxY	= pPoints[1];
		aLines[0].iPosX	= pPoints[iCount*2-2];
		aLines[0].iEndX	= pPoints[0];
		aLines[0].cSwap = 0;
		}
	else{
		aLines[0].iMinY	= pPoints[1];
		aLines[0].iMaxY	= pPoints[iCount*2-1];
		aLines[0].iPosX	= pPoints[0];
		aLines[0].iEndX	= pPoints[iCount*2-2];
		aLines[0].cSwap = 1;
		}

	aLines[0].cFlag = 1;


	if(aLines[0].iPosX>aLines[0].iEndX)
		{
		iMinX	= aLines[0].iEndX;
		iMaxX	= aLines[0].iPosX;
		}
	else{
		iMinX	= aLines[0].iPosX;
		iMaxX	= aLines[0].iEndX;
		}

	iMinY	= aLines[0].iMinY;
	iMaxY	= aLines[0].iMaxY;


	for(iPos=1;iPos<iCount;iPos++)								// Linien kopieren
		{
		if(pPoints[iPos*2+1]>pPoints[iPos*2-1])
			{
			aLines[iPos].iMinY	= pPoints[iPos*2-1];
			aLines[iPos].iMaxY	= pPoints[iPos*2+1];
			aLines[iPos].iPosX	= pPoints[iPos*2-2];
			aLines[iPos].iEndX	= pPoints[iPos*2  ];
			aLines[iPos].cSwap  = 0;
			}
		else{
			aLines[iPos].iMinY	= pPoints[iPos*2+1];
			aLines[iPos].iMaxY	= pPoints[iPos*2-1];
			aLines[iPos].iPosX	= pPoints[iPos*2  ];
			aLines[iPos].iEndX	= pPoints[iPos*2-2];
			aLines[iPos].cSwap  = 1;
			}

		aLines[iPos].cFlag = 1;

		if(iMinY>aLines[iPos].iMinY)iMinY=aLines[iPos].iMinY;
		if(iMaxY<aLines[iPos].iMaxY)iMaxY=aLines[iPos].iMaxY;
		if(iMinX>aLines[iPos].iPosX)iMinX=aLines[iPos].iPosX;
		if(iMaxX<aLines[iPos].iPosX)iMaxX=aLines[iPos].iPosX;
		if(iMinX>aLines[iPos].iEndX)iMinX=aLines[iPos].iEndX;
		if(iMaxX<aLines[iPos].iEndX)iMaxX=aLines[iPos].iEndX;
		}

	if(iMinX<0 && iMaxX<0)return 0;
	if(iMinY<0 && iMaxY<0)return 0;
	if(iMinX>=(int)uImageWidth  && iMaxX>=(int)uImageWidth )return 0;
	if(iMinY>=(int)uImageHeight && iMaxY>=(int)uImageHeight)return 0;

	if(iMinX==iMaxX || iMinY==iMaxY)							// Polygon auf einer Linie
		{
		return Line(iMinX,iMinY,iMaxX,iMaxY,iPixel);
		}


	for(cSwap=0,iPos=0;iPos<iCount;iPos++)						// Start-Swap ermitteln
		{
		if(aLines[iPos].iMaxY==aLines[iPos].iMinY)continue;
		cSwap = aLines[iPos].cSwap;
		break;
		}


	for(iPos=iCount-1;iPos>=0;iPos--)							// Liniendaten ermitteln
		{
		if(aLines[iPos].iMinY>=(int)uImageHeight)
			{
			aLines[iPos].cMode	= 6;							// Linie nicht sichtbar
			continue;
			}

		iDifY = aLines[iPos].iMaxY-aLines[iPos].iMinY;
		iDifX = aLines[iPos].iPosX-aLines[iPos].iEndX;

		if(iDifX<0)
			{
			iDifX				= -iDifX;
			aLines[iPos].cMode	= 1;
			}
		else{
			aLines[iPos].cMode	= 0;
			}

		if(iDifY==0)											// Waagrechte Linie
			{
			aLines[iPos].cMode |= 4;
			aLines[iPos].cSwap	= cSwap;
			continue;
			}

		cSwap = aLines[iPos].cSwap;

		if(iDifX>iDifY)
			{
			aLines[iPos].cMode |= 2;
			aLines[iPos].iDif	= iDifY;
			aLines[iPos].iOff	= iDifX-iDifY;
			aLines[iPos].iNum	=(iDifX-iDifY+1)/2;
			aDraw [iPos]        = iDifX;
			}
		else{
			aLines[iPos].iDif	= iDifX;
			aLines[iPos].iOff	= iDifY-iDifX;
			aLines[iPos].iNum	=(iDifY-iDifX+1)/2;
			aDraw [iPos]        = iDifY;
			}
		}


	if(iMaxY>=(int)uImageHeight)
		{
		iMaxY = uImageHeight-1;
		}

	if(iMinY<0)
		{
		for(iPos=0;iPos<iCount;iPos++)							// Suche Linien fr die aktuelle Zeile
			{
			if(aLines[iPos].iMinY>=0)
				{
				continue;
				}

			if(aLines[iPos].iMaxY<0)							// Linie ist nicht sichtbar
				{
				aLines[iPos].cMode = 6;
				continue;
				}


			aLines[iPos].cFlag = 0;								// Kein erster Punkt


			switch(aLines[iPos].cMode)
				{
			case 0:												// X-- DX<DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iDif;
					iVal				= aLines[iPos].iNum+iAdd;
					iAdd				= iVal/aDraw[iPos];
					aLines[iPos].iNum	= iVal%aDraw[iPos];

					if(aLines[iPos].iNum<=-aLines[iPos].iDif)
						{
						aLines[iPos].iNum += aDraw[iPos];
						iAdd -= 1;
						}

					aLines[iPos].iPosX += iAdd;
					aLines[iPos].iMinY  = 0;

					break;

			case 1:												// X++ DX<DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iDif;
					iVal				= aLines[iPos].iNum+iAdd;
					iAdd				= iVal/aDraw[iPos];
					aLines[iPos].iNum	= iVal%aDraw[iPos];

					if(aLines[iPos].iNum<=-aLines[iPos].iDif)
						{
						aLines[iPos].iNum += aDraw[iPos];
						iAdd -= 1;
						}

					aLines[iPos].iPosX -= iAdd;
					aLines[iPos].iMinY  = 0;

					break;

			case 2:												// X-- DX>DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iOff;
					iVal				= aLines[iPos].iNum-iAdd;
					iAdd				= iVal/aLines[iPos].iDif;
					aLines[iPos].iNum	= iVal%aLines[iPos].iDif;

					while(iAdd>0)
						{
						iVal = aLines[iPos].iNum+aLines[iPos].iDif;
						if(iVal>=aLines[iPos].iOff)break;
						aLines[iPos].iNum = iVal;
						iAdd -= 1;
						}

					aLines[iPos].iPosX += aLines[iPos].iMinY;
					aLines[iPos].iPosX -= iAdd;
					aLines[iPos].iMinY  = 0;

					break;

			case 3:												// X++ DX>DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iOff;
					iVal				= aLines[iPos].iNum-iAdd;
					iAdd				= iVal/aLines[iPos].iDif;
					aLines[iPos].iNum	= iVal%aLines[iPos].iDif;

					while(iAdd>0)
						{
						iVal = aLines[iPos].iNum+aLines[iPos].iDif;
						if(iVal>=aLines[iPos].iOff)break;
						aLines[iPos].iNum = iVal;
						iAdd -= 1;
						}

					aLines[iPos].iPosX -= aLines[iPos].iMinY;
					aLines[iPos].iPosX += iAdd;
					aLines[iPos].iMinY  = 0;

					break;
				}
			}

		iMinY = 0;
		}

	pMem = ROW_PTR(iMinY);

	for(;iMinY<=iMaxY;iMinY++,pMem-=uRowWidth)					// Zeilenweise abarbeiten
		{
		iLast = -2;
		cBase =  0;
		iNum  =  0;

		for(iPos=0;iPos<iCount;iPos++)							// Suche Linien fr die aktuelle Zeile
			{
			if(aLines[iPos].iMinY!=iMinY)continue;


			switch(aLines[iPos].cMode)
				{
			case 0:												// X-- DX<DY
					aDraw[iNum] = aLines[iPos].iPosX<<16;

					if(aLines[iPos].iNum>0)
						{
						aLines[iPos].iNum -= aLines[iPos].iDif;
						}
					else{
						aLines[iPos].iNum += aLines[iPos].iOff;
						aLines[iPos].iPosX--;
						}

					break;

			case 1:												// X++ DX<DY
					aDraw[iNum] = aLines[iPos].iPosX<<16;

					if(aLines[iPos].iNum>0)
						{
						aLines[iPos].iNum -= aLines[iPos].iDif;
						}
					else{
						aLines[iPos].iNum += aLines[iPos].iOff;
						aLines[iPos].iPosX++;
						}

					break;

			case 2:												// X-- DX>DY
					iFrom = aLines[iPos].iPosX;
					iAdd  = aLines[iPos].iNum/aLines[iPos].iDif;

					aLines[iPos].iNum  -= aLines[iPos].iDif*iAdd;
					aLines[iPos].iNum  += aLines[iPos].iOff;
					aLines[iPos].iPosX -= iAdd+1;

					iFrom-=iAdd;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			case 3:												// X++ DX>DY
					iFrom = aLines[iPos].iPosX;
					iAdd  = aLines[iPos].iNum/aLines[iPos].iDif;

					aLines[iPos].iNum  -= aLines[iPos].iDif*iAdd;
					aLines[iPos].iNum  += aLines[iPos].iOff;
					aLines[iPos].iPosX += iAdd+1;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			case 4:												// X-- DY=0
					iFrom = aLines[iPos].iEndX;
					iAdd  = aLines[iPos].iPosX-iFrom;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			case 5:												// X++ DY=0
					iFrom = aLines[iPos].iPosX;
					iAdd  = aLines[iPos].iEndX-iFrom;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			default:continue;
				}



			if(aLines[iPos].cFlag || aLines[iPos].iMaxY==iMinY)	// Erster oder letzter Punkt
				{
				iFrom = aDraw[iNum]>>16;
				iAdd  = aDraw[iNum]&0xFFFF;
				iEnd  = iFrom+iAdd;

				if(aLines[iPos].cMode==2)						// Ende korrigieren
					{
					if(iFrom<aLines[iPos].iEndX)
						{
						iFrom = aLines[iPos].iEndX;
						iAdd  = iEnd-iFrom;
						aDraw[iNum] = (iFrom<<16)|iAdd;
						}
					}
				else if(aLines[iPos].cMode==3)
					{
					if(iEnd>aLines[iPos].iEndX)
						{
						iEnd  = aLines[iPos].iEndX;
						iAdd  = iEnd-iFrom;
						aDraw[iNum] = (iFrom<<16)|iAdd;
						}
					}

				if(iLast+1==iPos && cSwap==aLines[iPos].cSwap)	// Kombinieren
					{
					if(iEnd <iStop)iEnd =iStop;
					if(iFrom>iStep)iFrom=iStep;
					iAdd        =  iEnd -iFrom;
					aDraw[iNum] = (iFrom<<16)|iAdd;
					iNum--;
					}

				cSwap = aLines[iPos].cSwap;
				iLast = iPos;
				iStep = iFrom;
				iStop = iEnd;
				}
			else{												// Schnittpunkt
				iLast = -2;
				}

			aLines[iPos].iMinY++;

			if(aLines[iPos].iMinY>aLines[iPos].iMaxY)			// Linie nicht mehr benutzen
				{
				aLines[iPos].iMinY = -1;
				aLines[iPos].cMode =  6;
				}

			if(iPos==0)cBase=1;
			iNum++;
			}

																// Erstes und letztes kompinieren
		if(cBase && iLast+1==iCount && iNum>=2 && cSwap==aLines[0].cSwap)
			{
			iFrom	 = aDraw[0]>>16;
			iAdd	 = aDraw[0]&0xFFFF;
			iEnd	 = iFrom+iAdd;

			if(iEnd <iStop)iEnd =iStop;
			if(iFrom>iStep)iFrom=iStep;

			iAdd	 =  iEnd -iFrom;
			aDraw[0] = (iFrom<<16)|iAdd;

			iNum--;
			}



		if(iNum==2)												// Nur zwei Punkte
			{
			if(aDraw[0]<aDraw[1])
				{
				iFrom = aDraw[0]>>16;
				iEnd  = aDraw[1]>>16;
				iEnd += aDraw[1]&0xFFFF;
				}
			else{
				iFrom = aDraw[1]>>16;
				iEnd  = aDraw[0]>>16;
				iEnd += aDraw[0]&0xFFFF;
				}

			if(iFrom<0)
				{
				if(iEnd<0)continue;
				iFrom = 0;
				}

			if(iEnd>=(int)uImageWidth)
				{
				if(iFrom>=(int)uImageWidth)
					{
					continue;
					}

				iEnd = uImageWidth-1;
				}

			while(iFrom<=iEnd)									// Einzelne Linie zeichnen
				{
				SetPixel_(pMem,iFrom,iPixel);
				iFrom++;
				}

			continue;
			}


		for(iPos=0;iPos<iNum;iPos++)							// Werte sortieren
			{
			iEnd = iPos;
			iVal = aDraw[iPos];

			while(iEnd>0 && aDraw[iEnd-1]>iVal)
				{
				aDraw[iEnd] = aDraw[iEnd-1];
				iEnd--;
				}

			aDraw[iEnd] = iVal;
			}

		for(iPos=0;iPos<iNum;iPos+=2)
			{
			iFrom = aDraw[iPos  ]>>16;
			iEnd  = aDraw[iPos+1]>>16;
			iEnd += aDraw[iPos+1]&0xFFFF;

			if(iFrom<0)
				{
				if(iEnd<0)continue;
				iFrom = 0;
				}

			if(iEnd>=(int)uImageWidth)
				{
				if(iFrom>=(int)uImageWidth)
					{
					break;
					}

				iEnd = uImageWidth-1;
				}

			while(iFrom<=iEnd)									// Einzelne Linie zeichnen
				{
				SetPixel_(pMem,iFrom,iPixel);
				iFrom++;
				}
			}
		}



return 1;
}


//*****************************************************************************
//*
//*		Polygon
//*
//*****************************************************************************
//	Zeichnet ein Polygon
//	pPoints		: Zeiger auf die Punkte ([0]=X0 [1]=Y0 [2]=X1 ...)
//	iCount		: Ist die Anzahl der Punkte im Polygon
//	iPixel		: Ist die Farbe bzw. der Farbindex fr das Polygon.
//	pSet		: Ist die Funktion zum Fllen der Pixel
//	Ergibt TRUE wenn ein Polygon gezeichnet wurde, bzw. FALSE wenn nicht.
bool BitmapImage::Polygon(int *pPoints,int iCount,int iPixel,PixelFillSet pSet)
{
typedef	struct
	{
	char 	cMode;
	char 	cSwap;
	char 	cFlag;
	int		iLast;
	int		iNum;
	int		iOff;
	int		iDif;
	int		iMinY;
	int		iMaxY;
	int		iPosX;
	int		iEndX;
	}LineData;

#define 		MAX_POINTS	64

unsigned char  *pMem;
LineData		aLines[MAX_POINTS];
int				aDraw [MAX_POINTS];
char			cSwap;
char			cBase;
int				iStep;
int				iStop;
int				iDifX;
int				iDifY;
int				iMinY;
int				iMaxY;
int				iMinX;
int				iMaxX;
int				iFrom;
int				iLast;
int				iEnd;
int				iAdd;
int				iVal;
int				iNum;
int				iPos;



	if(iCount<3)											// Kein Polygon
		{
		if(iCount<=0)
			{
			return 0;
			}

		if(iCount==1)
			{
			if((unsigned)pPoints[0]>=uImageWidth )return 0;
			if((unsigned)pPoints[1]>=uImageHeight)return 0;

			pMem = ROW_PTR(pPoints[1]);
			pSet(this,pMem,pPoints[0],pPoints[1],iPixel);

			return 1;
			}

		return Line(pPoints[0],pPoints[1],pPoints[2],pPoints[3],iPixel,pSet);
		}
	else if(iCount>64)
		{
		return 0;
		}



	if(pPoints[1]>pPoints[iCount*2-1])							// Erste Linie
		{
		aLines[0].iMinY	= pPoints[iCount*2-1];
		aLines[0].iMaxY	= pPoints[1];
		aLines[0].iPosX	= pPoints[iCount*2-2];
		aLines[0].iEndX	= pPoints[0];
		aLines[0].cSwap = 0;
		}
	else{
		aLines[0].iMinY	= pPoints[1];
		aLines[0].iMaxY	= pPoints[iCount*2-1];
		aLines[0].iPosX	= pPoints[0];
		aLines[0].iEndX	= pPoints[iCount*2-2];
		aLines[0].cSwap = 1;
		}

	aLines[0].cFlag = 1;


	if(aLines[0].iPosX>aLines[0].iEndX)
		{
		iMinX	= aLines[0].iEndX;
		iMaxX	= aLines[0].iPosX;
		}
	else{
		iMinX	= aLines[0].iPosX;
		iMaxX	= aLines[0].iEndX;
		}

	iMinY	= aLines[0].iMinY;
	iMaxY	= aLines[0].iMaxY;


	for(iPos=1;iPos<iCount;iPos++)								// Linien kopieren
		{
		if(pPoints[iPos*2+1]>pPoints[iPos*2-1])
			{
			aLines[iPos].iMinY	= pPoints[iPos*2-1];
			aLines[iPos].iMaxY	= pPoints[iPos*2+1];
			aLines[iPos].iPosX	= pPoints[iPos*2-2];
			aLines[iPos].iEndX	= pPoints[iPos*2  ];
			aLines[iPos].cSwap  = 0;
			}
		else{
			aLines[iPos].iMinY	= pPoints[iPos*2+1];
			aLines[iPos].iMaxY	= pPoints[iPos*2-1];
			aLines[iPos].iPosX	= pPoints[iPos*2  ];
			aLines[iPos].iEndX	= pPoints[iPos*2-2];
			aLines[iPos].cSwap  = 1;
			}

		aLines[iPos].cFlag = 1;

		if(iMinY>aLines[iPos].iMinY)iMinY=aLines[iPos].iMinY;
		if(iMaxY<aLines[iPos].iMaxY)iMaxY=aLines[iPos].iMaxY;
		if(iMinX>aLines[iPos].iPosX)iMinX=aLines[iPos].iPosX;
		if(iMaxX<aLines[iPos].iPosX)iMaxX=aLines[iPos].iPosX;
		if(iMinX>aLines[iPos].iEndX)iMinX=aLines[iPos].iEndX;
		if(iMaxX<aLines[iPos].iEndX)iMaxX=aLines[iPos].iEndX;
		}

	if(iMinX<0 && iMaxX<0)return 0;
	if(iMinY<0 && iMaxY<0)return 0;
	if(iMinX>=(int)uImageWidth  && iMaxX>=(int)uImageWidth )return 0;
	if(iMinY>=(int)uImageHeight && iMaxY>=(int)uImageHeight)return 0;

	if(iMinX==iMaxX || iMinY==iMaxY)							// Polygon auf einer Linie
		{
		return Line(iMinX,iMinY,iMaxX,iMaxY,iPixel);
		}


	for(cSwap=0,iPos=0;iPos<iCount;iPos++)						// Start-Swap ermitteln
		{
		if(aLines[iPos].iMaxY==aLines[iPos].iMinY)continue;
		cSwap = aLines[iPos].cSwap;
		break;
		}


	for(iPos=iCount-1;iPos>=0;iPos--)							// Liniendaten ermitteln
		{
		if(aLines[iPos].iMinY>=(int)uImageHeight)
			{
			aLines[iPos].cMode	= 6;							// Linie nicht sichtbar
			continue;
			}

		iDifY = aLines[iPos].iMaxY-aLines[iPos].iMinY;
		iDifX = aLines[iPos].iPosX-aLines[iPos].iEndX;

		if(iDifX<0)
			{
			iDifX				= -iDifX;
			aLines[iPos].cMode	= 1;
			}
		else{
			aLines[iPos].cMode	= 0;
			}

		if(iDifY==0)											// Waagrechte Linie
			{
			aLines[iPos].cMode |= 4;
			aLines[iPos].cSwap	= cSwap;
			continue;
			}

		cSwap = aLines[iPos].cSwap;

		if(iDifX>iDifY)
			{
			aLines[iPos].cMode |= 2;
			aLines[iPos].iDif	= iDifY;
			aLines[iPos].iOff	= iDifX-iDifY;
			aLines[iPos].iNum	=(iDifX-iDifY+1)/2;
			aDraw [iPos]        = iDifX;
			}
		else{
			aLines[iPos].iDif	= iDifX;
			aLines[iPos].iOff	= iDifY-iDifX;
			aLines[iPos].iNum	=(iDifY-iDifX+1)/2;
			aDraw [iPos]        = iDifY;
			}
		}


	if(iMaxY>=(int)uImageHeight)
		{
		iMaxY = uImageHeight-1;
		}

	if(iMinY<0)
		{
		for(iPos=0;iPos<iCount;iPos++)							// Suche Linien fr die aktuelle Zeile
			{
			if(aLines[iPos].iMinY>=0)
				{
				continue;
				}

			if(aLines[iPos].iMaxY<0)							// Linie ist nicht sichtbar
				{
				aLines[iPos].cMode = 6;
				continue;
				}


			aLines[iPos].cFlag = 0;								// Kein erster Punkt


			switch(aLines[iPos].cMode)
				{
			case 0:												// X-- DX<DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iDif;
					iVal				= aLines[iPos].iNum+iAdd;
					iAdd				= iVal/aDraw[iPos];
					aLines[iPos].iNum	= iVal%aDraw[iPos];

					if(aLines[iPos].iNum<=-aLines[iPos].iDif)
						{
						aLines[iPos].iNum += aDraw[iPos];
						iAdd -= 1;
						}

					aLines[iPos].iPosX += iAdd;
					aLines[iPos].iMinY  = 0;

					break;

			case 1:												// X++ DX<DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iDif;
					iVal				= aLines[iPos].iNum+iAdd;
					iAdd				= iVal/aDraw[iPos];
					aLines[iPos].iNum	= iVal%aDraw[iPos];

					if(aLines[iPos].iNum<=-aLines[iPos].iDif)
						{
						aLines[iPos].iNum += aDraw[iPos];
						iAdd -= 1;
						}

					aLines[iPos].iPosX -= iAdd;
					aLines[iPos].iMinY  = 0;

					break;

			case 2:												// X-- DX>DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iOff;
					iVal				= aLines[iPos].iNum-iAdd;
					iAdd				= iVal/aLines[iPos].iDif;
					aLines[iPos].iNum	= iVal%aLines[iPos].iDif;

					while(iAdd>0)
						{
						iVal = aLines[iPos].iNum+aLines[iPos].iDif;
						if(iVal>=aLines[iPos].iOff)break;
						aLines[iPos].iNum = iVal;
						iAdd -= 1;
						}

					aLines[iPos].iPosX += aLines[iPos].iMinY;
					aLines[iPos].iPosX -= iAdd;
					aLines[iPos].iMinY  = 0;

					break;

			case 3:												// X++ DX>DY
					iAdd    			= aLines[iPos].iMinY;
					iAdd			   *= aLines[iPos].iOff;
					iVal				= aLines[iPos].iNum-iAdd;
					iAdd				= iVal/aLines[iPos].iDif;
					aLines[iPos].iNum	= iVal%aLines[iPos].iDif;

					while(iAdd>0)
						{
						iVal = aLines[iPos].iNum+aLines[iPos].iDif;
						if(iVal>=aLines[iPos].iOff)break;
						aLines[iPos].iNum = iVal;
						iAdd -= 1;
						}

					aLines[iPos].iPosX -= aLines[iPos].iMinY;
					aLines[iPos].iPosX += iAdd;
					aLines[iPos].iMinY  = 0;

					break;
				}
			}

		iMinY = 0;
		}

	pMem = ROW_PTR(iMinY);

	for(;iMinY<=iMaxY;iMinY++,pMem-=uRowWidth)					// Zeilenweise abarbeiten
		{
		iLast = -2;
		cBase =  0;
		iNum  =  0;

		for(iPos=0;iPos<iCount;iPos++)							// Suche Linien fr die aktuelle Zeile
			{
			if(aLines[iPos].iMinY!=iMinY)continue;


			switch(aLines[iPos].cMode)
				{
			case 0:												// X-- DX<DY
					aDraw[iNum] = aLines[iPos].iPosX<<16;

					if(aLines[iPos].iNum>0)
						{
						aLines[iPos].iNum -= aLines[iPos].iDif;
						}
					else{
						aLines[iPos].iNum += aLines[iPos].iOff;
						aLines[iPos].iPosX--;
						}

					break;

			case 1:												// X++ DX<DY
					aDraw[iNum] = aLines[iPos].iPosX<<16;

					if(aLines[iPos].iNum>0)
						{
						aLines[iPos].iNum -= aLines[iPos].iDif;
						}
					else{
						aLines[iPos].iNum += aLines[iPos].iOff;
						aLines[iPos].iPosX++;
						}

					break;

			case 2:												// X-- DX>DY
					iFrom = aLines[iPos].iPosX;
					iAdd  = aLines[iPos].iNum/aLines[iPos].iDif;

					aLines[iPos].iNum  -= aLines[iPos].iDif*iAdd;
					aLines[iPos].iNum  += aLines[iPos].iOff;
					aLines[iPos].iPosX -= iAdd+1;

					iFrom-=iAdd;
					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			case 3:												// X++ DX>DY
					iFrom = aLines[iPos].iPosX;
					iAdd  = aLines[iPos].iNum/aLines[iPos].iDif;

					aLines[iPos].iNum  -= aLines[iPos].iDif*iAdd;
					aLines[iPos].iNum  += aLines[iPos].iOff;
					aLines[iPos].iPosX += iAdd+1;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			case 4:												// X-- DY=0
					iFrom = aLines[iPos].iEndX;
					iAdd  = aLines[iPos].iPosX-iFrom;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			case 5:												// X++ DY=0
					iFrom = aLines[iPos].iPosX;
					iAdd  = aLines[iPos].iEndX-iFrom;

					aDraw[iNum] = (iFrom<<16)|iAdd;

					break;

			default:continue;
				}



			if(aLines[iPos].cFlag || aLines[iPos].iMaxY==iMinY)	// Erster oder letzter Punkt
				{
				iFrom = aDraw[iNum]>>16;
				iAdd  = aDraw[iNum]&0xFFFF;
				iEnd  = iFrom+iAdd;

				if(aLines[iPos].cMode==2)						// Ende korrigieren
					{
					if(iFrom<aLines[iPos].iEndX)
						{
						iFrom = aLines[iPos].iEndX;
						iAdd  = iEnd-iFrom;
						aDraw[iNum] = (iFrom<<16)|iAdd;
						}
					}
				else if(aLines[iPos].cMode==3)
					{
					if(iEnd>aLines[iPos].iEndX)
						{
						iEnd  = aLines[iPos].iEndX;
						iAdd  = iEnd-iFrom;
						aDraw[iNum] = (iFrom<<16)|iAdd;
						}
					}

				if(iLast+1==iPos && cSwap==aLines[iPos].cSwap)	// Kombinieren
					{
					if(iEnd <iStop)iEnd =iStop;
					if(iFrom>iStep)iFrom=iStep;
					iAdd        =  iEnd -iFrom;
					aDraw[iNum] = (iFrom<<16)|iAdd;
					iNum--;
					}

				cSwap = aLines[iPos].cSwap;
				iLast = iPos;
				iStep = iFrom;
				iStop = iEnd;
				}
			else{												// Schnittpunkt
				iLast = -2;
				}

			aLines[iPos].iMinY++;

			if(aLines[iPos].iMinY>aLines[iPos].iMaxY)			// Linie nicht mehr benutzen
				{
				aLines[iPos].iMinY = -1;
				aLines[iPos].cMode =  6;
				}

			if(iPos==0)cBase=1;
			iNum++;
			}

																// Erstes und letztes kompinieren
		if(cBase && iLast+1==iCount && iNum>=2 && cSwap==aLines[0].cSwap)
			{
			iFrom	 = aDraw[0]>>16;
			iAdd	 = aDraw[0]&0xFFFF;
			iEnd	 = iFrom+iAdd;

			if(iEnd <iStop)iEnd =iStop;
			if(iFrom>iStep)iFrom=iStep;

			iAdd	 =  iEnd -iFrom;
			aDraw[0] = (iFrom<<16)|iAdd;

			iNum--;
			}



		if(iNum==2)												// Nur zwei Punkte
			{
			if(aDraw[0]<aDraw[1])
				{
				iFrom = aDraw[0]>>16;
				iEnd  = aDraw[1]>>16;
				iEnd += aDraw[1]&0xFFFF;
				}
			else{
				iFrom = aDraw[1]>>16;
				iEnd  = aDraw[0]>>16;
				iEnd += aDraw[0]&0xFFFF;
				}

			if(iFrom<0)
				{
				if(iEnd<0)continue;
				iFrom = 0;
				}

			if(iEnd>=(int)uImageWidth)
				{
				if(iFrom>=(int)uImageWidth)
					{
					continue;
					}

				iEnd = uImageWidth-1;
				}

			while(iFrom<=iEnd)									// Einzelne Linie zeichnen
				{
				pSet(this,pMem,iFrom,iMinY,iPixel);
				iFrom++;
				}

			continue;
			}


		for(iPos=0;iPos<iNum;iPos++)							// Werte sortieren
			{
			iEnd = iPos;
			iVal = aDraw[iPos];

			while(iEnd>0 && aDraw[iEnd-1]>iVal)
				{
				aDraw[iEnd] = aDraw[iEnd-1];
				iEnd--;
				}

			aDraw[iEnd] = iVal;
			}

		for(iPos=0;iPos<iNum;iPos+=2)
			{
			iFrom = aDraw[iPos  ]>>16;
			iEnd  = aDraw[iPos+1]>>16;
			iEnd += aDraw[iPos+1]&0xFFFF;

			if(iFrom<0)
				{
				if(iEnd<0)continue;
				iFrom = 0;
				}

			if(iEnd>=(int)uImageWidth)
				{
				if(iFrom>=(int)uImageWidth)
					{
					break;
					}

				iEnd = uImageWidth-1;
				}

			while(iFrom<=iEnd)									// Einzelne Linie zeichnen
				{
				pSet(this,pMem,iFrom,iMinY,iPixel);
				iFrom++;
				}
			}
		}



return 1;
}


//*****************************************************************************
//*
//*		Roll
//*
//*****************************************************************************
//	Rotiert ein Bild um einen Winkel
//	sSource		: Ist das Quellbild das Rotiert wird
//	iAngel		: Ist der Winkel (0=0 90=0x8000 180=0x10000 360=0x20000)
//	iMode		: Diverse Flags fr die Bilderstellung
//					Bit0		: Keine gleitenden Farben
//				  	Bit1		: Drehpunkt ist in 1/4 Schritten
//	iCenterX/Y	: Ist der Punkt um den das Bild rotiert wird.
//				  Hier wird auch der neue Drehpunkt gespeichert.
//	uColor		: Ist die Farbe fr Punkte auserhalb des Bildes
//	Ergibt TRUE wenn Bild erzeugt wurde.
bool BitmapImage::Roll(const BitmapImage &sSource,int iAngel,int iMode,int &iCenterX,int &iCenterY,unsigned uColor)
{
unsigned char  *pRowPtr;
unsigned char	ucAlpha;
unsigned char	ucColR;
unsigned char	ucColG;
unsigned char	ucColB;
unsigned char	ucColA;
unsigned char	ucDefR;
unsigned char	ucDefG;
unsigned char	ucDefB;
unsigned char	ucDefA;
unsigned		uFillR;
unsigned		uFillG;
unsigned		uFillB;
unsigned		uFillA;
unsigned		uFillD;
unsigned		uPixel;
unsigned		uBaseX;
unsigned		uBaseY;
unsigned		uCordX;
unsigned		uCordY;
unsigned		uFact1;
unsigned		uFact2;
unsigned		uFact3;
unsigned		uFact4;
unsigned		uValue;
int				iSizeX;
int				iSizeY;
int				iMinX;
int				iMinY;
int				iMaxX;
int				iMaxY;
int				iAddX;
int				iAddY;
int				iOffX;
int				iOffY;
int				iSetX;
int				iSetY;
int				iPosX;
int				iPosY;
int				iValX;
int				iValY;
int				iSin;
int				iCos;
int				iVal;



	uBaseX = sSource.Width ();
	uBaseY = sSource.Height();

	if(uBaseX>0x1000)return false;								// Prfe die Gre der Quelle
	if(uBaseY>0x1000)return false;

	if(iMode&2)													// Drehpunkt ist in 1/4 Schritten
		{
		iPosX = -iCenterX;
		iPosY = -iCenterY;
		}
	else{
		iPosX = -iCenterX*4;									// Linke untere Ecke in 1/4
		iPosY = -iCenterY*4;
		}

	iSin	= SinInt(-iAngel);
	iCos	= CosInt(-iAngel);

	iAddX   = iPosX-2;
	iAddY   = iPosY-2;
	iValX	= uBaseX*4+iAddX;									// Rechte obere Ecke in 1/4
	iValY 	= uBaseY*4+iAddY;

	iMinX	= (iCos*iAddX - iSin*iAddY)>>16;					// Linke untere Ecke drehen
	iMinY 	= (iSin*iAddX + iCos*iAddY)>>16;
	iMaxX	= (iCos*iValX - iSin*iValY)>>16;					// Rechte obere Ecke drehen
	iMaxY 	= (iSin*iValX + iCos*iValY)>>16;

	if(iMinX>iMaxX){iVal=iMinX;iMinX=iMaxX;iMaxX=iVal;}
	if(iMinY>iMaxY){iVal=iMinY;iMinY=iMaxY;iMaxY=iVal;}

	iOffX	= (iCos*iAddX - iSin*iValY)>>16;					// Linke obere Ecke drehen
	iOffY 	= (iSin*iAddX + iCos*iValY)>>16;

	if(iMinX>iOffX)iMinX=iOffX;
	if(iMinY>iOffY)iMinY=iOffY;
	if(iMaxX<iOffX)iMaxX=iOffX;
	if(iMaxY<iOffY)iMaxY=iOffY;

	iOffX	= (iCos*iValX - iSin*iAddY)>>16;					// Rechte untere Ecke drehen
	iOffY 	= (iSin*iValX + iCos*iAddY)>>16;

	if(iMinX>iOffX)iMinX=iOffX;
	if(iMinY>iOffY)iMinY=iOffY;
	if(iMaxX<iOffX)iMaxX=iOffX;
	if(iMaxY<iOffY)iMaxY=iOffY;

	iSizeX	= (iMaxX-iMinX+3)>>2;
	iSizeY	= (iMaxY-iMinY+3)>>2;

	if(iSizeX>0x2000)return false;								// Prfe die Gre neuen Bildes
	if(iSizeY>0x2000)return false;


	if(!SetSize(sSource.BitCount(),iSizeX,iSizeY,uColor))		// Neues Bild erzeugen
		{
		return false;
		}

	iSin	= SinInt(iAngel);
	iCos	= CosInt(iAngel);
	iSetX   = iMinX+2;
	iSetY   = iMinY+2;
	iAddX	= iCos*4;
	iAddY	= iSin*4;


	if(sSource.BitCount()<=8 || (iMode&1))
		{
		for(iOffY=0;iOffY<iSizeY;iOffY++,iSetY+=4)				// Zeilenweise erstellen
			{
			iValX	= iCos*iSetX - iSin*iSetY - (iPosX<<16);
			iValY	= iSin*iSetX + iCos*iSetY - (iPosY<<16);
			pRowPtr	= GetRow_(iOffY);

			for(iOffX=0;iOffX<iSizeX;iOffX++)
				{
				uCordX	= iValX>>18;
				uCordY	= iValY>>18;

				if(uCordX<uBaseX && uCordY<uBaseY)
						uPixel = sSource.GetPixel(uCordX,uCordY);
				else	uPixel = uColor;

				SetPixel(pRowPtr,iOffX,uPixel);

				iValX += iAddX;
				iValY += iAddY;
				}
			}
		}
	else{
		ucDefR	= (unsigned char)(uColor);
		ucDefG	= (unsigned char)(uColor>>8);
		ucDefB	= (unsigned char)(uColor>>16);
		ucDefA	= (unsigned char)(uColor>>24);
		uBaseY--;
		uBaseX--;

		if(sSource.HasAlpha())
			{
			ucAlpha = 0x00;
			}
		else{
			ucAlpha = 0xFF;
			}


		for(iOffY=0;iOffY<iSizeY;iOffY++,iSetY+=4)				// Zeilenweise erstellen
			{
			iValX	= iCos*iSetX - iSin*iSetY - (iPosX<<16);
			iValY	= iSin*iSetX + iCos*iSetY - (iPosY<<16);

			for(iOffX=0;iOffX<iSizeX;iOffX++)
				{
				uCordX	= iValX>>10;
				uCordY	= iValY>>10;
				uFact3	= (unsigned char)uCordX;
				uFact4	= (unsigned char)uCordY;
				uFact1	= 256-uFact3;
				uFact2	= 256-uFact4;
				uCordX /= 256;
				uCordY /= 256;

				if(uCordX<=uBaseX && uCordY<=uBaseY)
					{
					sSource.GetRGB(uCordX,uCordY,ucColR,ucColG,ucColB,ucColA);
					ucColA |= ucAlpha;
					uFillR	= ucColR;
					uFillG	= ucColG;
					uFillB	= ucColB;
					uFillA	= ucColA;
					}
				else{
					ucColR	= ucDefR;
					ucColG	= ucDefG;
					ucColB	= ucDefB;
					ucColA	= ucDefA;
					}

				if(ucColA)
					{
					uValue	= uFact1*uFact2;
					uFillR	= uValue*ucColR;
					uFillG	= uValue*ucColG;
					uFillB	= uValue*ucColB;
					uFillA	= uValue*ucColA;
					uFillD  = uValue;
					}
				else{
					uFillR  = 0;
					uFillG	= 0;
					uFillB	= 0;
					uFillA	= 0;
					uFillD	= 0;
					}

				if(uCordX<uBaseX && uCordY<=uBaseY)
					{
					sSource.GetRGB(uCordX+1,uCordY,ucColR,ucColG,ucColB,ucColA);
					ucColA |= ucAlpha;
					}
				else{
					ucColR	= ucDefR;
					ucColG	= ucDefG;
					ucColB	= ucDefB;
					ucColA	= ucDefA;
					}

				if(ucColA)
					{
					uValue	= uFact3*uFact2;
					uFillR += uValue*ucColR;
					uFillG += uValue*ucColG;
					uFillB += uValue*ucColB;
					uFillA += uValue*ucColA;
					uFillD += uValue;
					}

				if(uCordX<=uBaseX && uCordY<uBaseY)
					{
					sSource.GetRGB(uCordX,uCordY+1,ucColR,ucColG,ucColB,ucColA);
					ucColA |= ucAlpha;
					}
				else{
					ucColR	= ucDefR;
					ucColG	= ucDefG;
					ucColB	= ucDefB;
					ucColA	= ucDefA;
					}

				if(ucColA)
					{
					uValue	= uFact1*uFact4;
					uFillR += uValue*ucColR;
					uFillG += uValue*ucColG;
					uFillB += uValue*ucColB;
					uFillA += uValue*ucColA;
					uFillD += uValue;
					}

				if(uCordX<uBaseX && uCordY<uBaseY)
					{
					sSource.GetRGB(uCordX+1,uCordY+1,ucColR,ucColG,ucColB,ucColA);
					ucColA |= ucAlpha;
					}
				else{
					ucColR	= ucDefR;
					ucColG	= ucDefG;
					ucColB	= ucDefB;
					ucColA	= ucDefA;
					}

				if(ucColA)
					{
					uValue	= uFact3*uFact4;
					uFillR += uValue*ucColR;
					uFillG += uValue*ucColG;
					uFillB += uValue*ucColB;
					uFillA += uValue*ucColA;
					uFillD += uValue;
					}

				if(uFillD==0x10000)
					{
					SetRGB(iOffX,iOffY,uFillR>>16,uFillG>>16,uFillB>>16,uFillA>>16);
					}
				else if(uFillD!=0)
					{
					SetRGB(iOffX,iOffY,uFillR/uFillD,uFillG/uFillD,uFillB/uFillD,uFillA>>16);
					}
				else{
					SetRGB(iOffX,iOffY,ucDefR,ucDefG,ucDefB,0);
					}

				iValX += iAddX;
				iValY += iAddY;
				}
			}
		}

	if(iMode&2)													// Neuen Drehpunkt speichern
		{
		iCenterX = -iMinX-2;
		iCenterY = -iMinY-2;
		}
	else{
		iCenterX = -iMinX/4;
		iCenterY = -iMinY/4;
		}



return true;
}

//*****************************************************************************
//*
//*		HasAlpha
//*
//*****************************************************************************
//	Prft ob ein Bild eine Alpha-Maske hat (32 Bit und nicht alle Maske auf 0)
//	Ergibt TRUE wenn das Bild eine Alpha-Maske hat.
bool BitmapImage::HasAlpha() const
{
int		iPos;



	if(uImageBits!=32)return false;

	for(iPos=uImageSize-1;iPos>0;iPos-=4)
		{
		if(pImageData[iPos])return true;
		}



return false;
}

//*****************************************************************************
//*
//*		FillAlpha
//*
//*****************************************************************************
//	Fllt die gesamte Alpha-Maske eines 32-Bit-Bildes mit einem Wert auf.
//	ucAlpha		: Ist der Wert fr die Alpha-Maske
//	Ergibt true wenn die Alpha-Maske geschrieben wurde
bool BitmapImage::FillAlpha(unsigned char ucAlpha)
{
unsigned char  *pData;
int				iPos;


	if(uImageBits!=32)
		{
		return false;
		}

	pData	= pImageData;
	iPos	= uImageSize-1;

	for(;iPos>0;iPos-=4)
		{
		pData[iPos] = ucAlpha;
		}


return true;
}

//*****************************************************************************
//*
//*		HasAlphaEx
//*
//*****************************************************************************
//	Prft ob ein Bild eine Alpha-Maske hat bzw. alle Masken auf 255 sind
//	(32 Bit und nicht alle Maske auf 0)
//	Ergibt 	folgende Werte
//				0 : wenn es kein 32-Bit-Bild bzw. kein Palettenbild ist.
//				0 : wenn alle Masken auf 0 sind
//				1 : wenn alle Masken auf 255 sind
//				2 : wenn Masken unterschidlich sind
int BitmapImage::HasAlphaEx() const
{
unsigned char 	ucBase;
unsigned char  *pData;
int				iPos;


	if(uImageBits==32)
		{
		pData	= pImageData;
		iPos	= uImageSize-1;
		}
	else if(uImageBits<=8 && uImageBits>=1)
		{
		iPos	= uColorCount*4-1;
		pData	= (unsigned char*)pColorMap;
		}
	else{
		return 0;
		}

	ucBase	= pData[iPos];

	if(ucBase!=0x00 && ucBase!=0xFF)
		{
		return 2;
		}

	for(iPos-=4;iPos>0;iPos-=4)
		{
		if(pData[iPos]!=ucBase)return 2;
		}


return (ucBase)? 1:0;
}


//*****************************************************************************
//*
//*		Scroll
//*
//*****************************************************************************
//	Scrollt ein Bild
//	iShiftX		: Horizontaler Verschub  (-=nach links / +=nach rechts)
//	iShiftY		: Vertikaler Verschub (-=nach oben / +=nach unten)
//	iFill		: Fllfarbe fr die neunen leeren Bereiche (BI_NOT_INIT=keine Fllung)
void BitmapImage::Scroll(int iShiftX,int iShiftY,int iFill)
{
unsigned   *pSource;
unsigned   *pTarget;
unsigned	uValue;
int			iCount;
int			iLines;
int			iStart;
int			iSize;
int			iMode;
int			iAdd;



	if(iShiftY<0)										// Nach oben verschieben
		{
		   iLines = uImageHeight+iShiftY;
		if(iLines<=0 || iShiftX>=(int)uImageWidth || -iShiftX>=(int)uImageWidth)
			{
			if(iFill==BI_NOT_INIT)return;
			Box(0,0,uImageWidth,uImageHeight,iFill);
			return;
			}

		iMode	= 0;
		iAdd	= -(int)(uRowWidth/4);
		pTarget	= (unsigned*)GetRow(0);
		pSource	= pTarget-iShiftY*iAdd;
		}
	else if(iShiftY>0)									// Nach untern verschieben
		{
		   iLines = uImageHeight-iShiftY;
		if(iLines<=0 || iShiftX>=(int)uImageWidth || -iShiftX>=(int)uImageWidth)
			{
			if(iFill==BI_NOT_INIT)return;
			Box(0,0,uImageWidth,uImageHeight,iFill);
			return;
			}

		iMode	= 0;
		iAdd	= (uRowWidth/4);
		pTarget	= (unsigned*)GetRow(uImageHeight-1);
		pSource	= pTarget+iShiftY*iAdd;
		}
	else{												// Kein Y-Verschub
		if(iShiftX==0)return;

		if(iShiftX<0)
			{
			iMode  = 0;
			uValue = -iShiftX;
			}
		else{
			iMode  = 1;
			uValue = iShiftX;
			}

		if(uValue>=uImageWidth)
			{
			if(iFill==BI_NOT_INIT)return;
			Box(0,0,uImageWidth,uImageHeight,iFill);
			return;
			}

		iLines	= uImageHeight;
		iAdd	= -(int)(uRowWidth/4);
		pTarget	= (unsigned*)GetRow(0);
		pSource	= pTarget;
		}



	if(uImageBits==15)									// Bei 15-Bit werden 2 Byte kopiert
		{
		iStart	= -iShiftX   *16;
		iSize	= uImageWidth*16;
		}
	else{
		iStart	= -iShiftX*(int)uImageBits;
		iSize	= uImageWidth * uImageBits;
		}

	iCount	= uRowWidth/4;



	if(iStart&7)										// Verschub nicht auf Bytegrenze
		{
		if(iMode)
			{
			for(;iLines>0;iLines--)
				{
				CopyLineR(iStart,iCount,pSource,pTarget,iSize);

				pTarget	+= iAdd;
				pSource	+= iAdd;
				}
			}
		else{
			for(;iLines>0;iLines--)
				{
				CopyLineL(iStart,iCount,pSource,pTarget,iSize);

				pTarget	+= iAdd;
				pSource	+= iAdd;
				}
			}
		}
	else{												// Verschub ist auf Bytegrenze
		iStart /= 8;
		iSize   = (iSize+7)/8;

		if(iStart>0)
			{
			PTR_ADD(pSource,iStart);
			iCount  = iSize-iStart;
			}
		else{
			PTR_SUB(pTarget,iStart);
			iCount  = iSize+iStart;
			}

		if(iShiftY==0)
			{
			for(;iLines>0;iLines--)
				{
				memmove(pTarget,pSource,iCount);
				pTarget	+= iAdd;
				pSource	+= iAdd;
				}
			}
		else{
			for(;iLines>0;iLines--)
				{
				memcpy(pTarget,pSource,iCount);
				pTarget	+= iAdd;
				pSource	+= iAdd;
				}
			}
		}


	if(iFill==BI_NOT_INIT)return;


	if(iShiftY>0)
		{
		Box(0,0,uImageWidth,iShiftY,iFill);
		iLines = uImageWidth-iShiftY;
		iStart = iShiftY;
		}
	else if(iShiftY<0)
		{
		Box(0,uImageHeight+iShiftY,uImageWidth,-iShiftY,iFill);
		iLines = uImageWidth+iShiftY;
		iStart = 0;
		}
	else{
		iLines = uImageWidth;
		iStart = 0;
		}


	if(iShiftX>0)
		{
		Box(0,iStart,iShiftX,iLines,iFill);
		}
	else if(iShiftX<0)
		{
		Box(uImageWidth+iShiftX,iStart,-iShiftX,iLines,iFill);
		iStart = 0;
		}
	else{
		iStart = 0;
		}


}

//*****************************************************************************
//*
//*		ColorDiff
//*
//*****************************************************************************
//	Berechnet die Farbdifferenz  zwischen zwei Farbe (linear)
COLORRGB BitmapImage::ColorDiff(COLORRGB uColor1,COLORRGB uColor2)
{
int		iDiffR;
int		iDiffG;
int		iDiffB;


	iDiffR = (uColor1&0xFF)-(uColor2&0xFF);		uColor1>>=8;	uColor2>>=8;
	iDiffG = (uColor1&0xFF)-(uColor2&0xFF);		uColor1>>=8;	uColor2>>=8;
	iDiffB = (uColor1&0xFF)-(uColor2&0xFF);		uColor1>>=8;	uColor2>>=8;

	if(iDiffR<0)iDiffR=-iDiffR;
	if(iDiffG<0)iDiffG=-iDiffG;
	if(iDiffB<0)iDiffB=-iDiffB;


return iDiffR+iDiffG+iDiffB;
}


//*****************************************************************************
//*
//*		ColorDiff
//*
//*****************************************************************************
//	Berechnet die Farbdifferenz zwischen zwei Farbe (quartratisch)
COLORRGB BitmapImage::ColorDiff2(COLORRGB uColor1,COLORRGB uColor2)
{
int		iDiffR;
int		iDiffG;
int		iDiffB;


	iDiffR = (uColor1&0xFF)-(uColor2&0xFF);		uColor1>>=8;	uColor2>>=8;
	iDiffG = (uColor1&0xFF)-(uColor2&0xFF);		uColor1>>=8;	uColor2>>=8;
	iDiffB = (uColor1&0xFF)-(uColor2&0xFF);		uColor1>>=8;	uColor2>>=8;


return iDiffR*iDiffR+iDiffG*iDiffG+iDiffB*iDiffB;
}


//*****************************************************************************
//*
//*		DrawPixel1
//*
//*****************************************************************************
void FC BitmapImage::DrawPixel1(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
	pImage->SetPixel(uXpos,uYpos,uColor);
}

//*****************************************************************************
//*
//*		DrawPixel2
//*
//*****************************************************************************
void FC BitmapImage::DrawPixel2(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={0, 0, 1, 1};
const int	aDeltaY[]={0, 1, 0, 1};
unsigned	uPos;


	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uColor);
		}

}

//*****************************************************************************
//*
//*		DrawPixel3
//*
//*****************************************************************************
void FC BitmapImage::DrawPixel3(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={0, 0,-1, 0, 1};
const int	aDeltaY[]={0,-1, 0, 1, 0};
unsigned	uPos;


	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uColor);
		}

}

//*****************************************************************************
//*
//*		DrawPixel4
//*
//*****************************************************************************
void FC BitmapImage::DrawPixel4(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={0, 0,-1, 0, 1, 1, 0,-1,-1,-2,-2,-1};
const int	aDeltaY[]={0,-1, 0, 1, 0,-1,-2,-1,-2,-1, 0, 1};
unsigned	uPos;


	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uColor);
		}

}

//*****************************************************************************
//*
//*		DrawPixel5
//*
//*****************************************************************************
void FC BitmapImage::DrawPixel5(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={0, 0,-1, 0, 1,-1, 1,-1, 1,-2, 2, 0, 0};
const int	aDeltaY[]={0,-1, 0, 1, 0,-1,-1, 1, 1, 0, 0,-2, 2};
unsigned	uPos;


	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uColor);
		}

}


//*****************************************************************************
//*
//*		DrawPixelEx1
//*
//*****************************************************************************
void FC BitmapImage::DrawPixelEx1(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[4]={ 0,-1, 0, 1};
const int	aDeltaY[4]={-1, 0, 1, 0};
unsigned	uTemp;
unsigned	uAdd;
unsigned	uPos;


	pImage->SetPixel(uXpos,uYpos,uColor);

	uAdd = (uColor>>3)&0x1F1F1F;

	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		uTemp	= pImage->GetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos]);
		uTemp   = uTemp-((uTemp>>3)&0x1F1F1F)+uAdd;
				  pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uTemp);
		}


}

//*****************************************************************************
//*
//*		DrawPixelEx2
//*
//*****************************************************************************
void FC BitmapImage::DrawPixelEx2(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[4]={ 0,-1, 0, 1};
const int	aDeltaY[4]={-1, 0, 1, 0};
unsigned	uTemp;
unsigned	uAdd;
unsigned	uPos;


	pImage->SetPixel(uXpos,uYpos,uColor);

	uAdd = (uColor>>2)&0x3F3F3F;

	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		uTemp	= pImage->GetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos]);
		uTemp   = uTemp-((uTemp>>2)&0x3F3F3F)+uAdd;
				  pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uTemp);
		}


}

//*****************************************************************************
//*
//*		DrawPixelEx3
//*
//*****************************************************************************
void FC BitmapImage::DrawPixelEx3(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={-1,-1, 1, 1, 0,-2, 0, 2};
const int	aDeltaY[]={-1, 1, 1,-1,-2, 0, 2, 0};
const int	aSolidX[]={ 0,-1, 0, 1};
const int	aSolidY[]={-1, 0, 1, 0};
unsigned	uTemp;
unsigned	uAdd;
unsigned	uPos;


	pImage->SetPixel(uXpos,uYpos,uColor);

	uAdd = (uColor>>2)&0x3F3F3F;

	for(uPos=0;uPos<ENTRIES(aSolidX);uPos++)
		{
		pImage->SetPixel(uXpos+aSolidX[uPos],uYpos+aSolidY[uPos],uColor);
		}

	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		uTemp	= pImage->GetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos]);
		uTemp   = uTemp-((uTemp>>2)&0x3F3F3F)+uAdd;
				  pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uTemp);
		}

}

//*****************************************************************************
//*
//*		DrawPixelEx4
//*
//*****************************************************************************
void FC BitmapImage::DrawPixelEx4(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={-2,-2,-2,-1, 0, 1, 2, 2, 2, 1, 0,-1,};
const int	aDeltaY[]={-1, 0, 1, 2, 2, 2, 1, 0,-1,-2,-2,-2,};
const int	aSolidX[]={-1, 1, 1,-1, 0,-1, 0, 1};
const int	aSolidY[]={-1,-1, 1, 1,-1, 0, 1, 0};
unsigned	uTemp;
unsigned	uAdd;
unsigned	uPos;


	pImage->SetPixel(uXpos,uYpos,uColor);

	uAdd = (uColor>>2)&0x3F3F3F;

	for(uPos=0;uPos<ENTRIES(aSolidX);uPos++)
		{
		pImage->SetPixel(uXpos+aSolidX[uPos],uYpos+aSolidY[uPos],uColor);
		}

	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		uTemp	= pImage->GetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos]);
		uTemp   = uTemp-((uTemp>>2)&0x3F3F3F)+uAdd;
				  pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uTemp);
		}

}

//*****************************************************************************
//*
//*		DrawPixelEx5
//*
//*****************************************************************************
void FC BitmapImage::DrawPixelEx5(BitmapImage *pImage,unsigned uXpos,unsigned uYpos,unsigned uColor)
{
const int	aDeltaX[]={-2,-2,-2,-1, 0, 1, 2, 2, 2, 1, 0,-1,-3,  0,  3, 0};
const int	aDeltaY[]={-1, 0, 1, 2, 2, 2, 1, 0,-1,-2,-2,-2, 0, -3,  0, 3};
const int	aSolidX[]={-1, 1, 1,-1, 0,-1, 0, 1};
const int	aSolidY[]={-1,-1, 1, 1,-1, 0, 1, 0};
unsigned	uTemp;
unsigned	uAdd;
unsigned	uPos;


	pImage->SetPixel(uXpos,uYpos,uColor);

	uAdd = (uColor>>2)&0x3F3F3F;

	for(uPos=0;uPos<ENTRIES(aSolidX);uPos++)
		{
		pImage->SetPixel(uXpos+aSolidX[uPos],uYpos+aSolidY[uPos],uColor);
		}

	for(uPos=0;uPos<ENTRIES(aDeltaX);uPos++)
		{
		uTemp	= pImage->GetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos]);
		uTemp   = uTemp-((uTemp>>2)&0x3F3F3F)+uAdd;
				  pImage->SetPixel(uXpos+aDeltaX[uPos],uYpos+aDeltaY[uPos],uTemp);
		}

}

//*****************************************************************************
//*
//*		CompessColors
//*
//*****************************************************************************
//	Verschiebt alle bentigten Farben eines 8 Bit-Bildes an den Begin.
//	Ergibt TRUE wenn erfolgreich
bool BitmapImage::CompessColors()
{
unsigned char 	aSwap[256];
unsigned		aList[8];
unsigned		uFlag;
unsigned		uBits;
unsigned		uRest;
unsigned		uOff;
unsigned		uAdd;
unsigned		uPos;
unsigned		uEnd;
unsigned		uRgb;



	if(uImageBits!=8)return false;						// Nur 8-Bit-Bilder

	uFlag = 0;

	for(uPos=0;uPos<256;uPos++)
		{
		aSwap[uPos] = uPos;
		uRgb = pColorMap[uPos].uRgb;

		for(uOff=0;uOff<uPos;uOff++)					// Suche gleiche Frarben in der Palette
			{
			if(uRgb!=pColorMap[uOff].uRgb)continue;
			aSwap[uPos] = uOff;
			uFlag = 1;
			break;
			}
		}


	memset(aList,0,sizeof(aList));

	uAdd	= (0-uImageWidth)&3;
	uRest	= (uAdd)? uImageWidth:uImageSize+1;

	for(uPos=0;uPos<uImageSize;uPos++)					// Welche Farben werden benutzt
		{
		uOff = pImageData[uPos];
		uOff = aSwap[uOff];

		aList[uOff/32] |= 1<<(uOff&0x1F);

		   uRest--;
		if(uRest)continue;

		uRest = uImageWidth;

		if(uAdd>=3){uPos++;pImageData[uPos]=0;}
		if(uAdd>=2){uPos++;pImageData[uPos]=0;}
		if(uAdd>=1){uPos++;pImageData[uPos]=0;}
		}


	for(uOff=0;uOff<256;)								// Suche unbenutzte Farben
		{
		   uBits = aList[uOff/32];
		if(uBits==0xFFFFFFFF)
			{
			uOff+=32;
			continue;
			}

		uBits = ~uBits;

		for(;uBits!=0;uOff++,uBits>>=1)
			{
			if(!(uBits&1))continue;

			for(uEnd=255;uEnd>uOff;)					// Suche benutzte Farbe von hinten an
				{
				   uRest = aList[uEnd/32];
				if(uRest==0x00000000)
					{
					uEnd-=32;
					continue;
					}

				for(;uEnd>uOff && uRest!=0;uEnd--,uRest<<=1)
					{
					if(!(uRest&0x80000000))continue;

					pColorMap[uOff].uRgb = pColorMap[uEnd].uRgb;

					aList[uOff/32] |= 1<<(uOff&0x1F);
					aList[uEnd/32] ^= 1<<(uEnd&0x1F);
					aSwap[uEnd   ]  = uOff;
					uFlag = 1;
					break;
					}

				break;
				}
			}

		uOff +=  0x1F;
		uOff &= ~0x1F;
		}


	if(uFlag)											// Gibt es Farben zu tauschen
		{
		for(uPos=0;uPos<uImageSize;uPos++)
			{
			uOff = pImageData[uPos];
			pImageData[uPos] = aSwap[uOff];
			}
		}


return true;
}


//*****************************************************************************
//*
//*		PutAlphaArea
//*
//*****************************************************************************
//	Legt auf ein Bild mit einer Alpha-Maske auf eine Farbflche mit einer Farbe.
//	Das Bild muss im 32-Bit-Modus sein. Die Alpha-Maske wird auf 255 gesetzt.
//	Dort wo das Bild durchsichtig ist, wird die Farbflche sichtbar.
//	uColor		: Ist die Hintergrundfarbe fr die Flche ( BGR(r,g,b) )
//					Bits  0- 7 ist der Blauanteil
//					Bits  8-15 ist der Grnanteil
//					Bits 16-23 ist der Rotanteil
//	Ergibt TRUE wenn erfolgreich
bool BitmapImage::PutAlphaArea(unsigned uColor)
{
unsigned char  *pPixels;
unsigned		uColorR;
unsigned		uColorG;
unsigned		uColorB;
unsigned		uAlpha1;
unsigned		uAlpha2;
unsigned		uValue;
int				iCount;



	if(!IsOk() || uImageBits!=32)					// Nur 32-Bit-Bilder
		{
		return false;
		}

	pPixels = pImageMem;
	iCount  = uImageHeight*uImageWidth;
	uColorB	= (uColor    )&0xFF;
	uColorG	= (uColor>> 8)&0xFF;
	uColorR	= (uColor>>16)&0xFF;
	uColor |= 0xFF000000;


	for(;iCount>0;iCount--,pPixels+=4)
		{
		if(pPixels[3]==0xFF)						// Pixel total undurchsichtig
			{
			continue;
			}

		if(pPixels[3]==0x00)						// Pixel total durchsichtig
			{
			SET_DW(pPixels,uColor);
			continue;
			}

		uAlpha1	= pPixels[3]+1;
		uAlpha2	= 257-uAlpha1;

		uValue	= 0xFF000000;
		uValue |= (((unsigned)pPixels[0]*uAlpha1+uColorB*uAlpha2)>> 8);
		uValue |= (((unsigned)pPixels[1]*uAlpha1+uColorG*uAlpha2)    )&0x0000FF00;
		uValue |= (((unsigned)pPixels[2]*uAlpha1+uColorR*uAlpha2)<< 8)&0x00FF0000;

		SET_DW(pPixels,uValue);
		}


return TRUE;
}
